#include <bits/stdc++.h>

using namespace std;

template<typename t>
struct vec : vector<t> {
  using vector<t>::vector;
  void sort() {
    std::sort(vector<t>::begin(), vector<t>::end());
  }
  void sort(function<bool(t, t)> cmp) {
    std::sort(vector<t>::begin(), vector<t>::end(), cmp);
  }
};

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
  for (t &e : a) {
    in >> e;
  }
  return in;
}

template<typename t>
ostream &operator<<(ostream &out, vector<t> a) {
  for (t e : a) {
    out << e << ' ';
  }
  return out << '\n';
}

struct worker {
  int id;
  int l, m, r;
  worker() : id(-1), l(-1), m(-1), r(-1) {}
  worker(int id, int l, int m, int r) : id(id), l(l), m(m), r(r) {}
};

int f(int x) {
  return x & (x - 1);
}

int g(int x) {
  return (x | (x - 1)) + 1;
}

void solve() {
  int n, k;
  cin >> n >> k;
  vec<worker> w(k);
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    cin >> l >> m >> r;
    --l, --m, --r;
    w[i] = {i, l, m, r};
  }
  w.sort(
    [](worker a, worker b) {
      return a.r < b.r || (a.r == b.r && a.id < b.id);
    }
  );
  // for (int i = 0; i < k; ++i) {
  //   cout << w[i].id << ": " << w[i].l << ' ' << w[i].m << ' ' << w[i].r << '\n';
  // }
  // cout << '\n';
  vec<int> issbth(n + 1, false); // walid Rs
  function<int(int)> get = [&issbth](int i) {
    int s = 0;
    for (int j = i; j > 0; j = f(j)) {
      s += issbth[j];
    }
    return s;
  };
  function<void(int)> add = [&issbth](int i) {
    for (int j = i + 1; j < issbth.size(); j = g(j)) {
      ++ issbth[j];
    }
  };
  vec<pair<int, int>> st; // stack of walid ends(m, r); m r = < <
  st.emplace_back(-1, 0);
  function<bool(int)> check = [&st](int i) { // i = l
    int j = upper_bound(st.begin(), st.end(), i - 1, [](int i, pair<int, int> p) { return i < p.first; }) - st.begin() - 1;
    return j != st.size() && st[j].second >= i;
  };
  for (int i = 0; i < k; ++i) {
    if (check(w[i].l) || get(w[i].m) - get(w[i].l) > 0) {
      add(w[i].r);
      while (!st.empty() && st.back().first >= w[i].m) st.pop_back();
      st.emplace_back(w[i].m, w[i].r + 1);
    }
  }
  if (get(n) != get(n - 1)) {
    cout << "YES\n";
  } else {
    cout << "NO\n";
  }
}

int main() {
  int t;
  cin >> t;
  // t = 1;
  while (t--) {
    solve();
  }
}