#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

struct Node {
    int mn = INF, mx = -INF;

    static Node merge(Node a, Node b) {
        return { min(a.mn, b.mn), max(a.mx, b.mx) };
    }
};

struct SegTree {
    vector<Node> t;
    int h = 0;

    SegTree(int n) {
        while ((1 << h) < n)
            h += 1;
        t.resize(1 << (h + 1));
    }

    void upd(int v, int vl, int vr, int i, int val) {
        if (vl + 1 == vr) {
            t[v].mn = min(t[v].mn, val);
            t[v].mx = max(t[v].mx, val);
            return;
        }
        int vm = (vl + vr) / 2;
        if (i < vm)
            upd(2 * v, vl, vm, i, val);
        else
            upd(2 * v + 1, vm, vr, i, val);
        t[v] = Node::merge(t[2 * v], t[2 * v + 1]);
    }

    void upd(int i, int val) {
        upd(1, 0, (1 << h), i, val);
    }

    Node get(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l)
            return Node();
        if (l <= vl && vr <= r)
            return t[v];
        int vm = (vl + vr) / 2;
        return Node::merge(get(2 * v, vl, vm, l, r), get(2 * v + 1, vm, vr, l, r));
    }

    Node get(int l, int r) {
        return get(1, 0, (1 << h), l, r);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int>> ve(k);
    for (auto& [li, ri, mi] : ve) {
        cin >> li >> mi >> ri;
        --li, --ri, --mi;
    }
    sort(ve.begin(), ve.end(), [&](const auto& a, const auto& b) {
        const auto& [la, ra, ma] = a;
        const auto& [lb, rb, mb] = b;
        if (la != lb)
            return la < lb;
        return ra > rb;
        });
    vector<int> good(k);
    SegTree st(n);
    for (int i = 0; i < k; ++i) {
        auto [li, ri, mi] = ve[i];
        if (li == 0) {
            good[i] = 1;
            st.upd(mi, ri);
            continue;
        }
        Node nd1 = st.get(0, li);
        if (nd1.mx >= li - 1)
            good[i] = 1;
        Node nd2 = st.get(li, n);
        if (nd2.mn < mi)
            good[i] = 1;
        if (good[i]) {
            st.upd(mi, ri);
        }
        // for (int j = 0; j < i; ++j) {
        //     if (!good[j])
        //         continue;
        //     auto [lj, rj, mj] = ve[j];
        //     if (rj < li - 1)
        //         continue;
        //     if (li <= mj && mi <= rj)
        //         continue;
        //     good[i] = 1;
        //     break;
        // }
    }
    bool ans = false;
    for (int i = 0; i < k; ++i) {
        auto [li, ri, mi] = ve[i];
        if (ri == n - 1 && good[i])
            ans = true;
    }
    cout << (ans ? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}