#include <bits/stdc++.h>
#define int long long

using namespace std;

using ll = __int128_t;

const __int128_t INF = 1e36;

struct LinearFunction {
    ll k = 0, b = INF;

    ll operator()(ll x) {
        return k * x + b;
    }
};

struct LiChao {
    vector<int> xs;
    vector<LinearFunction> t;
    map<int, int> comp;
    int h = 0;

    LiChao(vector<int> inx) {
        xs = inx;
        sort(xs.begin(), xs.end());
        xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
        t.resize(xs.size());
        for (int i = 0; i < xs.size(); ++i)
            comp[xs[i]] = i;
    }

    ll get(int vl, int vr, int x) {
        int vm = (vl + vr) / 2;
        if (x == vm)
            return t[vm](xs[x]);
        if (x < vm)
            return min(t[vm](xs[x]), get(vl, vm - 1, x));
        return min(t[vm](xs[x]), get(vm + 1, vr, x));
    }

    ll get(int x) {
        return get(0, xs.size() - 1, comp[x]);
    }

    void upd(int vl, int vr, LinearFunction& f) {
        if (vl > vr)
            return;
        int vm = (vl + vr) / 2;
        bool updl = (f(xs[vl]) < t[vm](xs[vl]));
        bool updm = (f(xs[vm]) < t[vm](xs[vm]));
        if (updm)
            swap(t[vm], f);
        if (updl != updm)
            upd(vl, vm - 1, f);
        else
            upd(vm + 1, vr, f);
    }

    void upd(LinearFunction f) {
        upd(0, xs.size() - 1, f);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto& el : x)
        cin >> el;
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    vector<ll> rxans(n + 1);
    vector<ll> rsqsum(n + 1), rsum(n + 1);
    for (int i = n - 1;i >= 0; --i) {
        rsqsum[i] = (i == n - 1 ? (ll)0 : rsqsum[i + 1]) + (ll)x[i] * x[i];
        rsum[i] = (i == n - 1 ? (ll)0 : rsum[i + 1]) + (ll)x[i];
    }
    rxans[0] = rsqsum[0];
    for (int i = 1; i <= n; ++i) {
        ll sq = (i == n ? (ll)0 : rsqsum[i]);
        ll sm = (i == n ? (ll)0 : rsum[i]);
        ll curans = sq - (ll)2 * sm * x[i - 1] + ((ll)x[i - 1] * x[i - 1]) * (n - i);
        rxans[i] = curans;
    }
    int m;
    cin >> m;
    vector<int> ts(m);
    for (auto& el : ts)
        cin >> el;
    LiChao lc(ts);
    lc.upd({ 0, rxans[0] });
    for (int i = 1; i <= n; ++i) {
        lc.upd({ i, rxans[i] });
    }
    for (auto el : ts)
        cout << (int)lc.get(el) << '\n';
}