#include <bits/stdc++.h>
#define int long long

using namespace std;

using ll = __int128_t;

const __int128_t INF = 1e36;

struct LinearFunction {
    ll k = 0, b = INF;

    ll operator()(ll x) {
        return k * x + b;
    }
};

struct LiChao {
    vector<int> xs;
    vector<LinearFunction> t;
    map<int, int> comp;
    int h = 0;

    LiChao(vector<int> inx) {
        xs = inx;
        sort(xs.begin(), xs.end());
        xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
        t.resize(xs.size());
        for (int i = 0; i < xs.size(); ++i)
            comp[xs[i]] = i;
    }

    ll get(int vl, int vr, int x) {
        int vm = (vl + vr) / 2;
        if (x == vm)
            return t[vm](xs[x]);
        if (x < vm)
            return min(t[vm](xs[x]), get(vl, vm - 1, x));
        return min(t[vm](xs[x]), get(vm + 1, vr, x));
    }

    ll get(int x) {
        return get(0, xs.size() - 1, comp[x]);
    }

    void upd(int vl, int vr, LinearFunction& f) {
        if (vl > vr)
            return;
        int vm = (vl + vr) / 2;
        bool updl = (f(xs[vl]) < t[vm](xs[vl]));
        bool updm = (f(xs[vm]) < t[vm](xs[vm]));
        if (updm)
            swap(t[vm], f);
        if (updl != updm)
            upd(vl, vm - 1, f);
        else
            upd(vm + 1, vr, f);
    }

    void upd(LinearFunction f) {
        upd(0, xs.size() - 1, f);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto& el : x)
        cin >> el;
    sort(x.begin(), x.end());
    int mxx = *max_element(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<__int128_t> cntans(mxx + 1);
    __int128_t curans = 0;
    ll rsum = 0;
    for (auto el : x) {
        curans += (__int128_t)el * el;
        rsum += el;
    }
    cntans[0] = curans;
    int ptr = 0;
    for (int i = 1; i <= mxx; ++i) {
        ll prv = (ll)d * (i - 1);
        ll nw = (ll)d * i;
        curans -= (ll)(n - ptr) * prv * prv;
        curans += (ll)2 * rsum * prv;
        while (ptr < n && x[ptr] <= nw) {
            ll var1 = (ll)2 * x[ptr] * prv - prv * prv;
            ll var2 = (ll)2 * x[ptr] * nw - nw * nw;
            rsum -= x[ptr];
            curans -= max(var1, var2);
            ptr += 1;
        }
        curans += (ll)(n - ptr) * nw * nw;
        curans -= (ll)2 * rsum * nw;
        cntans[i] = curans;
    }
    vector<int> ts(m);
    for (auto& el : ts)
        cin >> el;
    LiChao lc(ts);
    for (int i = 0; i <= mxx; ++i)
        lc.upd({ i, cntans[i] });
    for (auto el : ts)
        cout << (int)lc.get(el) << '\n';
    // while (m--) {
//     int t;
//     cin >> t;
//     ll best = INF;
//     for (int i = 0; i <= mxx; ++i)
//         best = min(best, cntans[i] + (ll)i * t);
//     cout << (int)best << "\n";
// }
}