#include <bits/stdc++.h>
#define int long long

using namespace std;

using ll = __int128_t;

const __int128_t INF = 1e36;

struct LinearFunction {
    ll k = 0, b = INF;

    ll operator()(ll x) {
        return k * x + b;
    }
};

struct LiChao {
    vector<int> xs;
    vector<LinearFunction> t;
    map<int, int> comp;
    int h = 0;

    LiChao(vector<int> inx) {
        xs = inx;
        sort(xs.begin(), xs.end());
        xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
        t.resize(xs.size());
        for (int i = 0; i < xs.size(); ++i)
            comp[xs[i]] = i;
    }

    ll get(int vl, int vr, int x) {
        int vm = (vl + vr) / 2;
        if (x == vm)
            return t[vm](xs[x]);
        if (x < vm)
            return min(t[vm](xs[x]), get(vl, vm - 1, x));
        return min(t[vm](xs[x]), get(vm + 1, vr, x));
    }

    ll get(int x) {
        return get(0, xs.size() - 1, comp[x]);
    }

    void upd(int vl, int vr, LinearFunction& f) {
        if (vl > vr)
            return;
        int vm = (vl + vr) / 2;
        bool updl = (f(xs[vl]) < t[vm](xs[vl]));
        bool updm = (f(xs[vm]) < t[vm](xs[vm]));
        if (updm)
            swap(t[vm], f);
        if (updl != updm)
            upd(vl, vm - 1, f);
        else
            upd(vm + 1, vr, f);
    }

    void upd(LinearFunction f) {
        upd(0, xs.size() - 1, f);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto& el : x)
        cin >> el;
    sort(x.begin(), x.end());
    int mxx = *max_element(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    vector<int> rx, lx;
    for (auto el : x) {
        if (el > x0)
            rx.push_back(el);
        else
            lx.push_back(el);
    }
    int m;
    cin >> m;
    vector<__int128_t> rans(mxx + 1);
    __int128_t curans = 0;
    ll rsum = 0;
    for (auto el : rx) {
        curans += (__int128_t)(el - x0) * (el - x0);
        rsum += el;
    }
    rans[0] = curans;
    int ptr = 0;
    for (int i = 1; i <= mxx; ++i) {
        ll prv = x0 + (ll)d * (i - 1);
        ll nw = x0 + (ll)d * i;
        curans -= (ll)(rx.size() - ptr) * prv * prv;
        curans += (ll)2 * rsum * prv;
        while (ptr < rx.size() && rx[ptr] <= nw) {
            ll var1 = (ll)2 * rx[ptr] * prv - prv * prv;
            ll var2 = (ll)2 * rx[ptr] * nw - nw * nw;
            rsum -= rx[ptr];
            curans -= max(var1, var2);
            ptr += 1;
        }
        curans += (ll)(rx.size() - ptr) * nw * nw;
        curans -= (ll)2 * rsum * nw;
        rans[i] = curans;
    }

    vector<ll> lans(x0 + 1);
    curans = 0;
    ll lsum = 0;
    for (auto el : lx) {
        curans += (ll)(el - x0) * (el - x0);
        lsum += el;
    }
    lans[0] = curans;
    ptr = 0;
    for (int i = 1; i <= x0; ++i) {
        ll prv = x0 - (ll)d * (i - 1);
        ll nw = x0 - (ll)d * i;
        curans -= (ll)(lx.size() - ptr) * prv * prv;
        curans += (ll)2 * lsum * prv;
        while (ptr < lx.size() && nw <= lx[ptr]) {
            ll var1 = (ll)2 * lx[ptr] * prv - prv * prv;
            ll var2 = (ll)2 * lx[ptr] * nw - nw * nw;
            lsum -= lx[ptr];
            curans -= max(var1, var2);
            ptr += 1;
        }
        curans += (ll)(lx.size() - ptr) * nw * nw;
        curans -= (ll)2 * lsum * nw;
        lans[i] = curans;
    }

    vector<int> ts(m);
    for (auto& el : ts)
        cin >> el;
    LiChao lcl(ts), lcr(ts);
    for (int i = 0; i <= mxx; ++i) {
        lcr.upd({ i, rans[i] });
    }
    for (int i = 0; i <= x0; ++i)
        lcl.upd({ i, lans[i] });
    LiChao lcl2(ts), lcr2(ts);
    for (int i = 0; i <= mxx; ++i) {
        lcr2.upd({ 2 * i, rans[i] });
    }
    for (int i = 0; i <= x0; ++i)
        lcl2.upd({ 2 * i, lans[i] });
    for (auto el : ts) {
        int la = lcl2.get(el) + lcr.get(el);
        int ra = lcr2.get(el) + lcl.get(el);
        cout << min(la, ra) << '\n';
    }
}