#include <bits/stdc++.h>
#define int long long

using namespace std;

const int LOG = 21;

vector<vector<int>> g;
vector<int> depth;
vector<int> up[LOG];
vector<int> tin, tout;
int timer = 0;

void dfs(int v, int p) {
    up[0][v] = p;
    for (int l = 1; l < LOG; ++l)
        up[l][v] = up[l - 1][up[l - 1][v]];
    tin[v] = timer++;
    for (auto to : g[v]) {
        if (to != p) {
            depth[to] = depth[v] + 1;
            dfs(to, v);
        }
    }
    tout[v] = timer;
}

// bool is_up(int a, int b) {
//     return tin[a] <= tin[b] && tout[b] <= tout[a];
// }

// int lca(int a, int b) {
//     if (is_up(a, b))
//         return a;
//     if (is_up(b, a))
//         return b;
//     for (int l = LOG - 1; l >= 0; --l)
//         if (!is_up(up[l][a], b))
//             a = up[l][a];
//     return up[0][a];
// }

// int dist(int a, int b) {
//     int l = lca(a, b);
//     return depth[a] + depth[b] - 2 * depth[l];
// }

vector<vector<int>> cand;
int d;

void dfs2(int v, int p, int begv, int curd) {
    if (curd > d)
        return;
    if (depth[begv] % 2 != depth[v] % 2)
        cand[begv].push_back(v);
    for (auto to : g[v]) {
        if (to == p)
            continue;
        dfs2(to, v, begv, curd + 1);
    }
}

vector<int> mt;
vector<int> used;
int utimer = 1;

bool kuhn(int v) {
    if (used[v] == utimer)
        return false;
    used[v] = utimer;
    for (auto to : cand[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return true;
        }
    }
    for (auto to : cand[v]) {
        if (kuhn(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n >> d;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int l = 0; l < LOG; ++l)
        up[l].resize(n);
    depth.resize(n), tin.resize(n), tout.resize(n);
    dfs(0, 0);
    vector<int> evs, ods;
    for (int v = 0;v < n; ++v) {
        if (depth[v] % 2)
            ods.push_back(v);
        else
            evs.push_back(v);
    }
    cout << min(evs.size(), ods.size()) << '\n';
    for (int i = 0; i < min(evs.size(), ods.size()); ++i)
        cout << evs[i] + 1 << ' ' << ods[i] + 1 << '\n';
    // cand.resize(n);
    // used.resize(n);
    // for (auto el : evs) {
    //     dfs2(el, -1, el, 0);
    // }
    // mt.resize(n, -1);
    // for (auto el : evs) {
    //     utimer += 1;
    //     kuhn(el);
    // }
    // vector<pair<int, int>> ans;
    // for (auto el : ods) {
    //     if (mt[el] == -1)
    //         continue;
    //     ans.push_back({ mt[el], el });
    // }
    // cout << ans.size() << '\n';
    // for (auto [x, y] : ans)
    //     cout << x + 1 << ' ' << y + 1 << '\n';
}