#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 1e18;

template<class T> bool cmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct st {
    vector<int> t;
    int n;
    st(int n) : n(n), t(2 * n, inf) {}
    void upd(int i, int x) {
        if (t[i += n] < x)
            return;
        for (t[i] = x; i > 0; t[i >>= 1] = min(t[i], t[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = inf;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1)
                cmin(ans, t[l++]);
            if (~r & 1)
                cmin(ans, t[r--]);
        }
        return ans;
    }
};

constexpr int N = 5e5;

vector<int> gr[N], now, nw[N];
int used[N], mtc[N], timer = 0, dd[N];

void dfs(int v, int p, int d) {
    dd[v] = d;
    for (int u : gr[v])
        if (u != p)
            dfs(u, v, d + 1);
}

void dfs2(int v, int p, int c, int l) {
    if (c)
        now.push_back(v);
    if (l == 0)
        return;
    for (int u : gr[v])
        if (u != p)
            dfs2(u, v, c ^ 1, l - 1);
}

int d;

bool kuhn(int v) {
    if (used[v] == timer)
        return false;
    used[v] = timer;
    for (int u : nw[v])
        if (mtc[u] == -1) {
            mtc[u] = v;
            return true;
        }
    for (int u : nw[v])
        if (kuhn(mtc[u])) {
            mtc[u] = v;
            return true;
        }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int &i : x)
        cin >> i;
    int s, d, t;
    cin >> s >> d;
    auto calc = [&](int l) {
        __int128 res = (__int128)l * t;
        for (int i = 0; i < n; ++i)
            if (x[i] >= d * l)
                res += (__int128)(x[i] - d * l) * (x[i] - d * l);
            else {
                int mn = min(x[i] - (x[i] / d) * d, (x[i] / d + 1) * d - x[i]);
                res += (__int128)mn * mn;
            }
        return res;
    };
    int m;
    cin >> m;
    while (m--) {
        cin >> t;
        int l = 0, r = 1e9 / d + 228;
        while (r - l > 2) {
            int m1 = (r - l) / 3 + l, m2 = (r - l) / 3 * 2 + l;
            if (calc(m1) < calc(m2))
                r = m2;
            else
                l = m1;
        }
        cout << (int)min({calc(l), calc(l + 1), calc(r)}) << '\n';
    }
}

signed main() { // windows faster
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}