#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 1e9;

template<class T> bool cmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct st {
    vector<int> t;
    int n;
    st(int n) : n(n), t(2 * n, inf) {}
    void upd(int i, int x) {
        if (t[i += n] < x)
            return;
        for (t[i] = x; i > 0; t[i >>= 1] = min(t[i], t[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = inf;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1)
                cmin(ans, t[l++]);
            if (~r & 1)
                cmin(ans, t[r--]);
        }
        return ans;
    }
};

constexpr int N = 5e5;

vector<int> gr[N];
int used[N], mtc[N], timer = 0, dd[N];

void dfs(int v, int p, int d) {
    dd[v] = d;
    for (int u : gr[v])
        if (u != p)
            dfs(u, v, d + 1);
}

bool kuhn(int v) {
    if (used[v] == timer)
        return false;
    used[v] = timer;
    for (int u : gr[v])
        if (mtc[u] == -1) {
            mtc[u] = v;
            return true;
        }
    for (int u : gr[v])
        if (kuhn(mtc[u])) {
            mtc[u] = v;
            return true;
        }
    return false;
}

void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 1, u, v; i < n; ++i) {
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dfs(0, -1, 0);
    fill(mtc, mtc + N, -1);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (dd[i] % 2 == 0) {
            ++timer;
            if (kuhn(i))
                ++ans;
        }
    }
    cout << ans << '\n';
}

signed main() { // windows faster
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}