#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 1e9;

template<class T> bool cmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct st {
    vector<int> t;
    int n;
    st(int n) : n(n), t(2 * n, inf) {}
    void upd(int i, int x) {
        if (t[i += n] < x)
            return;
        for (t[i] = x; i > 0; t[i >>= 1] = min(t[i], t[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = inf;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1)
                cmin(ans, t[l++]);
            if (~r & 1)
                cmin(ans, t[r--]);
        }
        return ans;
    }
};

constexpr int N = 5e5;

vector<int> gr[N], now, nw[N];
int used[N], mtc[N], timer = 0, dd[N];

void dfs(int v, int p, int d) {
    dd[v] = d;
    for (int u : gr[v])
        if (u != p)
            dfs(u, v, d + 1);
}

void dfs2(int v, int p, int c, int l) {
    if (c)
        now.push_back(v);
    if (l == 0)
        return;
    for (int u : gr[v])
        if (u != p)
            dfs2(u, v, c ^ 1, l - 1);
}

int d;

bool kuhn(int v) {
    if (used[v] == timer)
        return false;
    used[v] = timer;
    for (int u : nw[v])
        if (mtc[u] == -1) {
            mtc[u] = v;
            return true;
        }
    for (int u : nw[v])
        if (kuhn(mtc[u])) {
            mtc[u] = v;
            return true;
        }
    return false;
}

void solve() {
    int n;
    cin >> n >> d;
    for (int i = 1, u, v; i < n; ++i) {
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dfs(0, -1, 0);
    if (d == n - 1) {
        set<int> a, b;
        for (int i = 0; i < n; ++i)
            if (dd[i] % 2)
                a.insert(i);
            else
                b.insert(i);
        cout << min(a.size(), b.size()) << '\n';
        while (a.size() && b.size()) {
            int u = *a.begin(), v = *b.begin();
            a.erase(u);
            b.erase(v);
            cout << u + 1 << ' ' << v + 1 << '\n';
        }
        return;
    }
    fill(mtc, mtc + N, -1);
    for (int i = 0; i < n; ++i) {
        if (dd[i] % 2 == 0) {
            now.clear();
            dfs2(i, -1, 0, d);
            nw[i] = now;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (dd[i] % 2 == 0) {
            ++timer;
            if (kuhn(i))
                ++ans;
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i)
        if (mtc[i] != -1)
            cout << mtc[i] + 1 << ' ' << i + 1 << '\n';
}

signed main() { // windows faster
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}