#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>

const int inf = 5e5 + 1;
struct lec {
	int l, x, r, ind;
};
bool cmp1(const lec& a, const lec& b) {
	return a.l < b.l;
}
bool cmp_x(const lec& a, const lec& b) {
	return a.x < b.x;
}
bool cmp_r(const lec& a, const lec& b) {
	return a.r < b.r;
}
bool operator<(const lec& a, const lec& b) {
	return a.r < b.r;
}
struct tree {
	int h;
	std::vector<int> d;
	void build(int n) {
		h = 1;
		while (h < n) {
			h <<= 1;
		}
		d.resize((h << 1) - 1, inf);
	}
	void merge(int i) {
		const int j = (i << 1) + 1;
		d[i] = std::min(d[j], d[j + 1]);
	}
	void make(int i, int qx) {
		i += h - 1;
		d[i] = qx;
		while (i > 0) {
			i = (i - 1) >> 1;
			merge(i);
		}
	}
	int get(int i, int tl, int tr, int ql, int qr) {
		if (ql <= tl && tr <= qr) {
			return d[i];
		}
		if (tl >= qr || tr <= ql) {
			return inf;
		}
		const int j = (i << 1) + 1, tm = (tl + tr) >> 1;
		return std::min(get(j, tl, tm, ql, qr), get(j + 1, tm, tr, ql, qr));
	}
};
int get_x(int i, std::vector<std::pair<int, int>>& a) {
	int l = -1, r = a.size();
	while (r - l > 1) {
		int m = (r + l) >> 1;
		if (a[m].first < i) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return r;
}
void solve() {
	int n, k;
	std::cin >> n >> k;
	int l = n, r = 1;
	std::vector<lec> a(k);
	std::vector<std::pair<int, int>> b(k), c(k);
	for (int i = 0; i < k; ++i) {
		std::cin >> a[i].l >> a[i].x >> a[i].r;
		a[i].ind = i;
		b[i] = { a[i].x, i };
		c[i] = { a[i].r, i };
		l = std::min(l, a[i].l);
		r = std::max(r, a[i].r);
	}
	if (l > 1 || r < n) {
		std::cout << "NO\n";
		return;
	}
	std::vector<bool> dp(k);
	std::vector<int> pos_x(k), pos_r(k);
	std::sort(b.begin(), b.end());
	for (int i = 0; i < k; ++i) {
		pos_x[b[i].second] = i;
	}
	std::sort(c.begin(), c.end());
	for (int i = 0; i < k; ++i) {
		pos_r[c[i].second] = i;
	}
	std::sort(a.begin(), a.end(), cmp1);
	std::set<std::pair<int, int>> p;
	tree tx, tr;
	tr.build(k);
	tx.build(k);
	for (lec& i : a) {
		while (p.size() > 0 && (*p.begin()).first < i.l - 1) {
			int j = (*p.begin()).second;
			tx.make(pos_x[j], inf);
			tr.make(pos_r[j], inf);
			p.erase(p.begin());
		}
		int p_x = get_x(i.l, b);
		int ans_x = tx.get(0, 0, tx.h, 0, p_x);
		int pl = get_x(i.l - 1, c);
		int pr = get_x(i.r - 1, c);
		int ans_r = tr.get(0 ,0, tr.h, pl, pr);
		dp[i.ind] = (std::min(ans_x, ans_r) < i.r) || (i.l == 1);
		if (dp[i.ind]) {
			if (i.r == n) {
				std::cout << "YES\n";
				return;
			}
			p.insert({ i.r, i.ind });
			tx.make(pos_x[i.ind], i.r);
			tr.make(pos_r[i.ind], i.r);
		}
	}
	std::cout << "NO\n";
}
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}