#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

__int128 d;
__int128 find(std::vector<__int128>& syf1, std::vector<__int128>& syf2, std::vector<__int128>& pref, std::vector<__int128>& a, __int128 pos, __int128 t) {
	pos *= d;
	int i = std::upper_bound(a.begin(), a.end(), pos) - a.begin();
	return pref[i] + syf2[i] - 2 * syf1[i] * pos + pos * pos * (syf1.size() - 1 - i) + pos / d * t;
}
__int128 bin(std::vector<__int128>& syf1, std::vector<__int128>& syf2, std::vector<__int128>& pref, std::vector<__int128>& a, __int128 t) {
	__int128 l = 0, r = a.back() / d + 2;
	while (r - l > 1) {
		const __int128 m = (r + l) >> 1;
		__int128 f1 = find(syf1, syf2, pref, a, m - 1, t);
		__int128 f2 = find(syf1, syf2, pref, a, m, t);
		if (f1 >= f2) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return find(syf1, syf2, pref, a, l, t);
}
void solve(std::vector<__int128>& a, std::vector<__int128>& t, std::vector<__int128>& ans, std::vector<__int128>& ans2, long long p) {
	const int n = a.size();
	if (n == 0) {
		return;
	}
	std::vector<__int128> pref(n + 1), syf1(n + 1), syf2(n + 1);
	for (int i = n - 1; i >= 0; --i) {
		syf1[i] = syf1[i + 1] + a[i];
		syf2[i] = syf2[i + 1] + a[i] * a[i];
	}
	for (int i = 0; i < n; ++i) {
		__int128 c = a[i] % d;
		if (c > (d >> 1)) {
			c = d - c;
		}
		pref[i + 1] = pref[i] + c * c;
	}
	p = pref[n];
	for (int i = 0; i < t.size(); ++i) {
		ans[i] = bin(syf1, syf2, pref, a, t[i]);
		ans2[i] = bin(syf1, syf2, pref, a, 2 * t[i]);
	}
}

int main() {
	int n;
	long long x;
	std::cin >> n;
	std::vector<__int128> a(n);
	for (int i = 0; i < n; ++i) {
		long long p;
		std::cin >> p;
		a[i] = p;
	}
	long long p;
	std::cin >> x >> p;
	d = p;
	std::vector<__int128> left, right;
	std::sort(a.begin(), a.end());
	int i = 0;
	while (i < n && a[i] < x) {
		left.push_back(x - a[i]);
		++i;
	}
	while (i < n) {
		right.push_back(a[i] - x);
		++i;
	}
	int m;
	std::cin >> m;
	std::vector<__int128> t(m);
	for (int i = 0; i < m; ++i) {
		std::cin >> p;
		t[i] = p;
	}
	std::vector<__int128> ans_l(m), ans_l2(m), ans_r(m), ans_r2(m);
	long long l1, r1;
	solve(right, t, ans_r, ans_r2, r1);
	solve(left, t, ans_l, ans_l2, l1);
	for (int i = 0; i < m; ++i) {
		long long ans = (long long)std::min(ans_l[i] + ans_r2[i], ans_l2[i] + ans_r[i]);
		ans = std::min(ans, (long long)ans_l[i] + r1);
		ans = std::min(ans, (long long)ans_r[i] + l1);
		std::cout << ans << '\n';
	}
}

