#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Fenwick {
    int n;
    vector<int> tr;

    Fenwick(int n) : n(n) {
        tr.resize(n);
    }

    void upd(int i, int x) {
        for (; i < n; i = (i | (i + 1))) tr[i] += x;
    }

    int get(int i) {
        int ans = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) ans += tr[i];
        return ans;
    }

    int get(int l, int r) {  // on segment
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> a(k, vector<int>(3));
    for (int i = 0; i < k; ++i) for (auto &e : a[i]) cin >> e;
    for (auto &e : a) for (auto &i : e) --i;
    sort(a.begin(), a.end());
    vector<vector<int>> kekr(n), kekl(n);
    for (int i = 0; i < k; ++i) {
        kekr[a[i][2]].push_back(i);
        kekl[a[i][0]].push_back(i);
    }
    vector<int> dp1(n + 1), dp2(n + 1);
    {
        dp1[0] = 1;
        Fenwick lol(n + 1);
        lol.upd(0, 1);
        for (int r = 1; r <= n; ++r) {
            for (auto e : kekr[r - 1]) {
                int l = a[e][0], m = a[e][1];
                if (lol.get(l, m)) {
                    dp1[r] = 1;
                    lol.upd(r, 1);
                    break;
                }
            }
        }
    }
    {
        dp2[n] = 1;
        Fenwick lol(n + 1);
        lol.upd(n, 1);
        for (int l = n - 1; l >= 0; --l) {
            for (auto e : kekl[l]) {
                int r = a[e][2], m = a[e][1];
                if (lol.get(m + 1, r + 1)) {
                    dp2[l] = 1;
                    lol.upd(l, 1);
                    break;
                }
            }
        }
    }
    vector<int> ps1(dp1.size() + 1);
    for (int i = 0; i < dp1.size(); ++i) ps1[i + 1] = ps1[i] + dp1[i];
    vector<int> ps2(dp2.size() + 1);
    for (int i = 0; i < dp2.size(); ++i) ps2[i + 1] = ps2[i] + dp2[i];
    
    for (auto e : a) {
        int l = e[0], r = e[1], m = e[2];
        if (ps1[l] != ps1[m + 1] && ps2[r + 1] != ps2[m]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}