
#include <bits/stdc++.h>

using namespace std;

// #define int long long

struct Fenwick {
    int n;
    vector<int> tr;

    Fenwick(int n) : n(n) {
        tr.resize(n);
    }

    void upd(int i, int x) {
        for (; i < n; i = (i | (i + 1))) tr[i] += x;
    }

    int get(int i) {
        int ans = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) ans += tr[i];
        return ans;
    }

    int get(int l, int r) {  // on segment
        return get(r) - get(l - 1);
    }
};

struct SegTree {
    int sz;
    vector<int> tr;

    SegTree(int n) {
        sz = (1 << ((int)log2(n))) * 2;
        tr.resize(2 * sz, 1e9);
    }

    void update(int v, int l, int r, int ind, int x) {
        if (l > ind || r <= ind) return;
        if (r - l == 1) {
            // cout << l << ' ' << r << ' ' << x << '\n';
            tr[v] = min(tr[v], x);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, ind, x);
        update(2 * v + 2, m, r, ind, x);
        tr[v] = min(tr[2 * v + 1], tr[2 * v + 2]);
    }

    void update(int ind, int x) {
        update(0, 0, sz, ind, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) return 1e9;
        if (l >= ql && r <= qr) return tr[v];
        int m = (l + r) / 2;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> a(k, vector<int>(3));
    for (int i = 0; i < k; ++i) for (auto &e : a[i]) cin >> e;
    for (auto &e : a) for (auto &i : e) --i;
    sort(a.begin(), a.end());
    vector<vector<int>> kekr(n), kekl(n);
    for (int i = 0; i < k; ++i) {
        kekr[a[i][2]].push_back(i);
        kekl[a[i][0]].push_back(i);
    }
    vector<int> dp(n + 1, n + 2);
    dp[0] = 0;
    set<int> curkek;
    sort(a.begin(), a.end(), [&](vector<int> a, vector<int> b) {
        return a[2] < b[2];
    });
    // set<int> ok;
    // ok.insert(-1);
    // ok.insert(n + 5);
    Fenwick lol2(n + 1);
    lol2.upd(0, 1);
    SegTree lol(n + 1);
    lol.update(0, -1);
    for (auto e : a) {
        int l = e[0], m = e[1], r = e[2];
        // cout << l << ' ' << m << ' ' << r << ' ' << lol.get(l, n + 1) << '\n';
        // cout << l << ' '<< m << ' ' << r << ' ' << *ok.lower_bound(l - 1) << ' ' << *ok.lower_bound(m + 1) << '\n';
        if (lol.get(l, n + 1) < l || lol2.get(l - 1, m - 1) != 0) {
            lol.update(r + 1, m);
            lol2.upd(r, 1);
            if (r == n - 1) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}