#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <set>

using namespace std;

vector<int> ord;

void dfs(int v, vector<vector<int>> &g, vector<bool> &been) {
    been[v] = true;
    for (auto u : g[v]) {
        if (!been[u]) {
            dfs(u, g, been);
        }
    }
    ord.push_back(v);
}

vector<int> t;

void add(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        t[v]++;
        return;
    }
    if (l >= qr || ql >= r) {
        return;
    }
    int m = (l + r) / 2;
    add(2 * v + 1, l, m, ql, qr);
    add(2 * v + 2, m, r, ql, qr);
}

int get(int v, int l, int r, int pos, int cnt) {
    cnt += t[v];
    if (r - l == 1) {
        return cnt;
    }
    int m = (l + r) / 2;
    if (m < pos) {
        return get(2 * v + 1, l, m, pos, cnt);
    } else {
        return get(2 * v + 2, m, r, pos, cnt);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int qw;
    cin >> qw;
    while (qw--) {
        int n, k;
        cin >> n >> k;
        vector<vector<int>> seg(k, vector<int>(3));
        for (int i = 0; i < k; ++i) {
            cin >> seg[i][0] >> seg[i][1] >> seg[i][2];
        }
        vector<vector<int>> g(k);
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < k; ++j) {
                if (seg[j][0] > seg[i][1] || seg[j][2] < seg[i][1]) {
                    g[i].push_back(j);
                }
            }
        }
        ord.clear();
        vector<bool> been(k, false);
        for (int i = 0; i < k; ++i) {
            if (!been[i]) {
                dfs(i, g, been);
            }
        }
        t.clear();
        t.resize(4 * k);
        bool fl = true;
        for (int i = 0; i < (int)ord.size(); ++i) {
            int v = ord[i];
            if (get(0, 0, n, seg[v][1], 0) != 0) {
                fl = false;
                break;
            } else {
                add(0, 0, n, seg[v][0], seg[v][2] + 1);
            }
        }
        if (fl && (int)ord.size() == k) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
    return 0;
}