#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <set>

using namespace std;

vector<int> ord;

void dfs(int v, vector<vector<int>> &seg, vector<bool> &been) {
    been[v] = true;
    int k = (int)seg.size();
    for (int j = 0; j < k; ++j) {
        if (seg[v][0] >= seg[j][1] && seg[j][1] <= seg[v][2]) {
            if (!been[j]) {
                dfs(j, seg, been);
            }
        }
    }
    ord.push_back(v);
}

struct node {
    int add = 0, mn = 0;
};

vector<node> t;

void calc(int v, int l, int r) {
    if (r - l != 1) {
        t[v].mn = min(t[2 * v + 1].mn + t[2 * v + 1].add, t[2 * v + 2].mn + t[2 * v + 2].add);
    }
}

void add(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        t[v].add++;
        return;
    }
    if (l >= qr || ql >= r) {
        return;
    }
    int m = (l + r) / 2;
    add(2 * v + 1, l, m, ql, qr);
    add(2 * v + 2, m, r, ql, qr);
    calc(v, l, r);
}

int get(int v, int l, int r, int pos, int cnt) {
    cnt += t[v].add;
    if (r - l == 1) {
        return cnt;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        return get(2 * v + 1, l, m, pos, cnt);
    } else {
        return get(2 * v + 2, m, r, pos, cnt);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int qw;
    cin >> qw;
    while (qw--) {
        int n, k;
        cin >> n >> k;
        vector<vector<int>> seg(k, vector<int>(3));
        for (int i = 0; i < k; ++i) {
            cin >> seg[i][0] >> seg[i][1] >> seg[i][2];
            seg[i][0]--;
            seg[i][1]--;
            seg[i][2]--;
        }
        ord.clear();
        vector<bool> been(k, false);
        for (int i = 0; i < k; ++i) {
            if (!been[i]) {
                dfs(i, seg, been);
            }
        }
        t.clear();
        t.resize(4 * n);
        bool fl = true;
        for (int i = 0; i < (int)ord.size(); ++i) {
            int v = ord[i];
            if (get(0, 0, n, seg[v][1], 0) != 0) {
                fl = false;
                break;
            } else {
                add(0, 0, n, seg[v][0], seg[v][2] + 1);
            }
        }
        if (fl && t[0].mn + t[0].add != 0) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
    return 0;
}