#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <set>

using namespace std;


bool ok = true;

void dfs(int v, vector<vector<int>> &seg, vector<int> &been) {
    been[v] = 1;
    int k = (int)seg.size();
    for (int j = 0; j < k; ++j) {
        if (j != v && seg[v][0] <= seg[j][1] && seg[j][1] <= seg[v][2]) {
            if (been[j] == -1) {
                dfs(j, seg, been);
            } else if (been[j] == 1) {
                ok = false;
                return;
            }
        }
    }
    been[v] = 0;
}

struct node {
    int psh = 0, mn = 0;
};

vector<node> t;

void upd(int v, int l, int r) {
    if (t[v].psh != 0) {
        t[v].mn += t[v].psh;
        if (r - l > 1) {
            t[2 * v + 1].psh += t[v].psh;
            t[2 * v + 2].psh += t[v].psh;
        }
        t[v].psh = 0;
    }
}


void add(int v, int l, int r, int ql, int qr, int x) {
    if (ql <= l && r <= qr) {
        t[v].psh += x;
        upd(v, l, r);
        return;
    }
    upd(v, l, r);
    if (l >= qr || ql >= r) {
        return;
    }
    int m = (l + r) / 2;
    add(2 * v + 1, l, m, ql, qr, x);
    add(2 * v + 2, m, r, ql, qr, x);
    t[v].mn = min(t[2 * v + 1].mn + t[2 * v + 1].psh, t[2 * v + 2].mn + t[2 * v + 2].psh);
}

int get(int v, int l, int r, int pos, int cnt) {
    upd(v, l, r);
    if (r - l == 1) {
        return t[v].mn;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        return get(2 * v + 1, l, m, pos, cnt);
    } else {
        return get(2 * v + 2, m, r, pos, cnt);
    }
}

int mn(int v, int l, int r, int ql, int qr) {
    upd(v, l, r);
    if (ql <= l && r <= qr) {
        return t[v].mn;
    }
    if (ql >= r || l >= qr) {
        return 1e9;
    }
    int m = (l + r) / 2;
    return min(mn(2 * v + 1, l, m, ql, qr), mn(2 * v + 2, m, r, ql, qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int qw;
    cin >> qw;
    while (qw--) {
        int n, k;
        cin >> n >> k;
        t.clear();
        t.resize(4 * n);
        vector<vector<int>> seg(k, vector<int>(3));
        for (int i = 0; i < k; ++i) {
            cin >> seg[i][0] >> seg[i][1] >> seg[i][2];
            seg[i][0]--;
            seg[i][1]--;
            seg[i][2]--;
            add(0, 0, n, seg[i][0], seg[i][2] + 1, 1);
        }
        vector<vector<int>> nw;
        for (int i = 0; i < k; ++i) {
            if (mn(0, 0, n, seg[i][0], seg[i][2]) >= 2) {
                add(0, 0, n, seg[i][0], seg[i][2] + 1, -1);
            } else {
                nw.push_back(seg[i]);
            }
        }
        seg = nw;
        k = (int)seg.size();
        ok = true;
        vector<int> been(k, -1);
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < k; ++j) {
                if (i != j) {
                    if (seg[i][0] <= seg[j][1] && seg[j][1] <= seg[i][2]) {
                        if (seg[j][0] <= seg[i][1] && seg[i][1] <= seg[j][2]) {
                            ok = false;
                            break;
                        }
                    }
                }
            }
        }
        if (!ok) {
            cout << "NO" << endl;
        } else {
            vector<pair<int, int>> a;
            for (int i = 0; i < k; ++i) {
                a.push_back({seg[i][0], seg[i][2]});
            }
            sort(a.begin(), a.end());
            int r = 0;
            bool fl = true;
            for (int i = 0; i < k; ++i) {
                if (a[i].first <= r) {
                    r = max(r, a[i].second + 1);
                } else {
                    fl = false;
                    break;
                }
            }
            if (fl && r == n) {
                cout << "YES" << endl;
            } else {
                cout << "NO" << endl;
            }
        }
    }
    return 0;
}