#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <cmath>
#include <set>
#define int long long
#define ll __int128

using namespace std;

void dfs(int v, int pr, vector<vector<int>> &g, vector<vector<int>> &dp, vector<int> &nxt) {
    dp[v][0] = 0;
    dp[v][1] = 0;
    for (auto u : g[v]) {
        if (u != pr) {
            if (dp[u][0] == -1) {
                dfs(u, v, g, dp, nxt);
            }
            dp[v][0] += max(dp[u][0], dp[u][1]);
        }
    }
    int cnt = dp[v][0];
    for (auto u : g[v]) {
        if (u != pr) {
            if (dp[u][0] >= dp[u][1]) {
                dp[v][1] = cnt + 1;
                nxt[v] = u;
            } else {
                cnt -= dp[u][1];
                cnt += dp[u][0] + 1;
                if (cnt > dp[v][1]) {
                    dp[v][1] = cnt;
                    nxt[v] = u;
                }
                cnt -= dp[u][0] + 1;
                cnt += dp[u][1];
            }
        }
    }
}

vector<pair<int, int>> ans;

void dfs2(int v, int pr, bool can, vector<vector<int>> &g, vector<vector<int>> &dp, vector<int> &nxt) {
    if (can) {
        if (dp[v][1] > dp[v][0] && nxt[v] != -1) {
            ans.push_back({v, nxt[v]});
            for (auto u : g[v]) {
                if (u != pr) {
                    if (u == nxt[v]) {
                        dfs2(u, v, false, g, dp, nxt);
                    } else {
                        dfs2(u, v, true, g, dp, nxt);
                    }
                }
            }
            return;
        }
    }
    for (auto u : g[v]) {
        if (u != pr) {
            dfs2(u, v, true, g, dp, nxt);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int d;
    cin >> d;
    vector<vector<int>> g(n);
    int u, v;
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> dp(n, vector<int>(2, -1));
    vector<int> nxt(n, -1);
    dfs(0, -1, g, dp, nxt);
    cout << max(dp[0][0], dp[0][1]) << endl;
    dfs2(0, -1, true, g, dp, nxt);
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << endl;
    }
    return 0;
}