#include <bits/stdc++.h>
using namespace std;
#define int long long
#pragma GCC optimize("O3,unroll-loops")

template<typename T>
istream& operator>>(istream& in, vector<T>& vec) {
    for (T& i : vec) in >> i;
    return in;
}

int gu(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 + d * mx >= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (x0 - d * mx <= x) rx = mx;
            else lx = mx + 1;
        }

        return x0 - d * lx;
    }
}

int gl(int x, int x0, int d) {
    int lx = 0, rx = 1e9;
    if (x > x0) {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 + d * mx > x) rx = mx - 1;
            else lx = mx;
        }

        return x0 + d * lx;
    } else {
        while (lx < rx) {
            int mx = rx - (rx - lx) / 2;
            if (x0 - d * mx < x) rx = mx - 1;
            else lx = mx;
        }

        return x0 - d * lx;
    }
}

#define iint __int128

void solve() {
    int n;
    cin >> n;
    vector<iint> a(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        a[i] = t;
    }
    sort(a.begin(), a.end());
    int x0, d;
    cin >> x0 >> d;
    for (iint& i : a) i -= x0;

    vector<iint> pos, neg;
    for (iint i : a) if (i < 0) neg.push_back(-i); else pos.push_back(i);
    reverse(neg.begin(), neg.end());

    vector<iint> sufpos(pos.size() + 1);
    vector<iint> sufsqpos(pos.size() + 1);

    vector<iint> sufneg(neg.size() + 1);
    vector<iint> sufsqneg(neg.size() + 1);

    for (int i = (int) pos.size() - 1; i >= 0; i--) {
        sufpos[i] = sufpos[i+1] + pos[i];
        sufsqpos[i] = sufsqpos[i + 1] + pos[i] * pos[i];
    }

    for (int i = (int) neg.size() - 1; i >= 0; i--) {
        sufneg[i] = sufneg[i+1] + neg[i];
        sufsqneg[i] = sufsqneg[i + 1] + neg[i] * neg[i];
    }

    vector<iint> prefpos(pos.size() + 1);
    for (int i = 1; i <= pos.size(); i++) {
        iint l = gu(pos[i-1], 0, d);
        iint r = gl(pos[i-1], 0, d);

        prefpos[i] = prefpos[i-1] + min((pos[i-1] - l) * (pos[i-1] - l), (pos[i-1] - r) * (pos[i-1] - r));
    }

    vector<iint> prefneg(neg.size() + 1);
    for (int i = 1; i <= neg.size(); i++) {
        iint l = gu(neg[i-1], 0, d);
        iint r = gl(neg[i-1], 0, d);

        prefneg[i] = prefneg[i-1] + min((neg[i-1] - l) * (neg[i-1] - l), (neg[i-1] - r) * (neg[i-1] - r));
    }

    auto f = [&](iint t, vector<iint>& a, vector<iint>& suf, vector<iint>& sufsq, vector<iint>& pref) {
        iint ans = 4e18;

        iint lx = 0, rx = 1e9 + 1;

        while (lx < rx) {
            iint lx1 = lx + (rx - lx) / 2;
            iint l1 = lx1 * d;
            iint rx1 = lx1 + 1;
            iint r1 = rx1 * d;

            iint ansl = 0;
            int pos = lower_bound(a.begin(), a.end(), l1) - a.begin();
            ansl += pref[pos];
            ansl += l1 * l1 * (a.size() - pos) - 2 * l1 * suf[pos] + sufsq[pos] + lx1 * t;

            iint ansr = 0;
            pos = lower_bound(a.begin(), a.end(), r1) - a.begin();
            ansr += pref[pos];
            ansr += r1 * r1 * (a.size() - pos) - 2 * r1 * suf[pos] + sufsq[pos] + rx1 * t;

            if (ansl > ansr) lx = lx1 + 1;
            else rx = lx1;
        }

        for (iint mx = lx; mx <= rx; mx++) {
            iint l1 = mx * d;
            iint ansl = 0;
            int pos = lower_bound(a.begin(), a.end(), l1) - a.begin();
            ansl += pref[pos];
            ansl += l1 * l1 * (a.size() - pos) - 2 * l1 * suf[pos] + sufsq[pos] + mx * t;
            ans = min(ans, ansl);
        }

        return ans;
    };

    iint e = 0, w = 0;
    for (iint i : neg) e += i * i;
    for (iint j : pos) w += j * j;

    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;

        iint negr = f(t, neg, sufneg, sufsqneg, prefneg);
        iint posr = f(t, pos, sufpos, sufsqpos, prefpos);

        iint ans = min({
            posr + e,
            negr + w,
            f(t * 2, pos, sufpos, sufsqpos, prefpos) + negr,
            f(t * 2, neg, sufneg, sufsqneg, prefneg) + posr});

        cout << (int) ans << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}