#include <bits/stdc++.h>
using namespace std;

struct segment_tree {
  int size;
  vector<int> tree;

  segment_tree(int n) {
    size = 1;
    while (size < n) {
      size *= 2;
    }
    tree.assign(size * 2, 0);
  }

  void update(int i, int value, int x, int lx, int rx) {
    if (rx - lx == 1) {
      tree[x] = value;
    } else {
      int mid = (lx + rx) / 2;
      if (i < mid) {
        update(i, value, x * 2, lx, mid);
      } else {
        update(i, value, x * 2 + 1, mid, rx);
      }
      tree[x] = max(tree[x * 2], tree[x * 2 + 1]);
    }
  }

  void update(int i, int value) {
    update(i, value, 1, 0, size);
  }

  int query(int l, int r, int x, int lx, int rx) {
    if (lx >= r || rx <= l) {
      return 0;
    } else if (lx >= l && rx <= r) {
      return tree[x];
    } else {
      int mid = (lx + rx) / 2;
      int left = query(l, r, x * 2, lx, mid);
      int right = query(l, r, x * 2 + 1, mid, rx);
      return max(left, right);
    }
  }

  int query(int l, int r) {
    return query(l, r, 1, 0, size);
  }
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int t;
  cin >> t;
  while (t--) {
    int n, k;
    cin >> n >> k;
    vector<int> L(k), M(k), R(k);
    for (int i = 0; i < k; i++) {
      cin >> L[i] >> M[i] >> R[i];
      --L[i], --M[i];
    }
    vector<int> ord(k);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int x, int y) {
      return L[x] < L[y];
    });
    vector<bool> dp(k); // dp[i] = whether it is possible to cover all guys before given segment
    segment_tree dsA(n + 1), dsB(n + 1);
    for (int i = 0; i < k; i++) {
      dp[ord[i]] = dsA.query(0, L[ord[i]]) >= L[ord[i]] || dsB.query(0, M[ord[i]] + 1) >= L[ord[i]];
      if (dp[ord[i]]) {
        dsA.update(M[ord[i]], R[ord[i]]);
        dsB.update(R[ord[i]], R[ord[i]]);
      }
    }
    bool answer = false;
    for (int i = 0; i < k; i++) {
      if (R[i] == n) {
        answer |= dp[i];
      }
    }
    cout << (answer ? "YES\n" : "NO\n");
  }
}
