#include <bits/stdc++.h>
using namespace std;

constexpr int MAX_N = 300000;
vector<int> graph[MAX_N];
vector<array<int, 2>> vert[MAX_N][2];

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, d;
  cin >> n >> d;
  vector<int> deg(n);
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    ++deg[u], ++deg[v];
    graph[u].push_back(v);
    graph[v].push_back(u);
  }
  queue<int> Q;
  for (int i = 0; i < n; i++) {
    if (graph[i].size() == 1) {
      Q.push(i);
    }
  }
  vector<bool> used(n);
  vector<array<int, 2>> matching;
  while (!Q.empty()) {
    int u = Q.front();
    Q.pop();
    used[u] = true;
    vert[u][0].push_back({0, u});
    sort(vert[u][0].begin(), vert[u][0].end());
    sort(vert[u][1].begin(), vert[u][1].end());
    array<vector<array<int, 2>>, 2> new_vert;
    int j = int(vert[u][1].size()) - 1;
    for (int i = int(vert[u][0].size()) - 1; i >= 0; i--) {
      while (j >= 0 && vert[u][0][i][0] + vert[u][1][j][0] > d) {
        if (vert[u][1][j][0] < d) {
          new_vert[0].push_back({vert[u][1][j][0] + 1, vert[u][1][j][1]});
        }
        --j;
      }
      if (j == -1 && vert[u][0][i][0] < d) {
        new_vert[1].push_back({vert[u][0][i][0] + 1, vert[u][0][i][1]});
      }
      if (j != -1) {
        matching.push_back({vert[u][0][i][1], vert[u][1][j][1]});
        --j;
      }
    }
    while (j >= 0) {
      if (vert[u][1][j][0] < d) {
        new_vert[0].push_back({vert[u][1][j][0] + 1, vert[u][1][j][1]});
      }
      --j;
    }
    vert[u][0] = {}, vert[u][1] = {};
    for (int v : graph[u]) {
      if (!used[v]) {
        --deg[v];
        if (deg[v] == 1) {
          Q.push(v);
        }
        vert[v][0] = new_vert[0];
        vert[v][1] = new_vert[1];
      }
    }
  }
  cout << matching.size() << "\n";
  for (auto [u, v] : matching) {
    cout << 1 + u << " " << 1 + v << "\n";
  }
}
