#include <bits/stdc++.h>
using namespace std;

constexpr int MAX_N = 300000;
vector<int> graph[MAX_N];

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, d;
  cin >> n >> d;
  vector<int> deg(n);
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    ++deg[u], ++deg[v];
    graph[u].push_back(v);
    graph[v].push_back(u);
  }
  queue<int> Q;
  for (int i = 0; i < n; i++) {
    if (graph[i].size() == 1) {
      Q.push(i);
    }
  }
  vector<bool> used(n), match(n);
  vector<array<int, 2>> matching;
  while (!Q.empty()) {
    int u = Q.front();
    Q.pop();
    used[u] = true;
    for (int v : graph[u]) {
      if (!used[v]) {
        if (--deg[v] == 1) {
          Q.push(v);
        }
        if (!match[u] && !match[v]) {
          matching.push_back({u, v});
          match[u] = match[v] = true;
        }
      }
    }
  }
  cout << matching.size() << "\n";
  for (auto [u, v] : matching) {
    cout << 1 + u << " " << 1 + v << "\n";
  }
}
