#include <bits/stdc++.h>
using namespace std;

constexpr int MAX_N = 300000;
vector<int> graph[MAX_N];

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, d;
  cin >> n >> d;
  vector<int> deg(n);
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    ++deg[u], ++deg[v];
    graph[u].push_back(v);
    graph[v].push_back(u);
  }
  vector<vector<int>> dist(n, vector<int>(n, n));
  for (int i = 0; i < n; i++) {
    dist[i][i] = 0;
    queue<int> Q;
    Q.push(i);
    while (!Q.empty()) {
      int u = Q.front();
      Q.pop();
      for (int v : graph[u]) {
        if (dist[i][v] == n) {
          dist[i][v] = dist[i][u] + 1;
          Q.push(v);
        }
      }
    }
  }
  vector<array<int, 2>> matching;
  int cnt0 = 0, cnt1 = 0;
  for (int i = 0; i < n; i++) {
    cnt0 += dist[0][i] % 2 == 0;
    cnt1 += dist[0][i] % 2 == 1;
  }
  int mod = cnt0 < cnt1 ? 1 : 0;
  for (int mask = 0; mask < (1 << n); mask++) {
    bool good = true;
    for (int i = 0; i < n; i++) {
      if (((mask >> i) & 1) && dist[0][i] % 2 != mod) {
        good = false;
      }
    }
    if (!good) {
      continue;
    }
    vector<int> ord, ord_m;
    for (int i = 0; i < n; i++) {
      if (dist[0][i] % 2 != mod) {
        ord_m.push_back(i);
      }
      if ((mask >> i) & 1) {
        ord.push_back(i);
      }
    }
    do {
      vector<array<int, 2>> cur;
      for (int i = 0; i < min(ord.size(), ord_m.size()); i++) {
        if (dist[ord[i]][ord_m[i]] > d || dist[0][ord[i]] % 2 == dist[0][ord_m[i]] % 2) {
          break;
        }
        cur.push_back({ord[i], ord_m[i]});
        if (cur.size() > matching.size()) {
          matching = cur;
        }
      }
    } while (next_permutation(ord_m.begin(), ord_m.end()));
  }
  cout << matching.size() << "\n";
  for (auto [x, y] : matching) {
    cout << 1 + x << " " << 1 + y << "\n";
  }
}
