#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using i128 = __int128_t;

struct worker {
    ll d;
    vector<ll> x, borders;
    vector<i128> pref, s0, s1, s2;

    worker(vector<ll> _x, ll _d) {
        x = _x;
        d = _d;
        sort(x.begin(), x.end());
        int n = x.size();
        s0.assign(n + 1, 0);
        s1.assign(n + 1, 0);
        s2.assign(n + 1, 0);
        pref.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            ll s = x[i] / d;
            if (abs(s * d - x[i]) < abs((s + 1) * d - x[i])) borders.push_back(s);
            else borders.push_back(s + 1);
            pref[i + 1] = pref[i] + (i128)(borders[i] * d - x[i]) * (borders[i] * d - x[i]);
        }
        // for (auto i : x) cout << i << ' ';
        // cout << endl;
        // for (auto i : borders) cout << i << ' ';
        // cout << endl;
        // cout << 111 << endl;
        for (int i = n - 1; i >= 0; --i) {
            s0[i] = s0[i + 1] + 1;
            s1[i] = s1[i + 1] + x[i];
            s2[i] = s2[i + 1] + (i128)x[i] * x[i];
        }
    }

    i128 get(ll s, ll t) {
        i128 pt = (i128)s * d;
        int k = upper_bound(borders.begin(), borders.end(), s) - borders.begin();
        i128 ret = (pref[k]) + (s0[k] * pt * pt - 2 * s1[k] * pt + s2[k]) + (i128)s * t;
        // cout << 222 << ' ' << s << ' ' << (ll)ret << ' ' << ' ' << (ll) pref[k] << ' ' << k << ' ' << (ll)s0[k] << ' ' << (ll)s1[k] << ' ' << (ll)s2[k] << ' ' << (ll)pt << ' ' << s * t << endl;
        return ret;
    }

    i128 get_min(ll t) {
        ll L = 0, R = borders.back();
        while (R - L > 3) {
            ll M1 = (2 * L + R) / 3;
            ll M2 = (L + 2 * R) / 2;
            if (get(M1, t) < get(M2, t)) R = M2;
            else L = M1;
        }
        // cout << L << ' ' << R << endl;
        i128 ret = 1e36;
        for (ll i = L; i <= R; ++i) ret = min(ret, get(i, t));
        // cout << (ll)ret << endl;
        return ret;
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    cin >> n;
    vector<ll> x(n);
    for (auto& i : x) cin >> i;
    ll x0, d;
    cin >> x0 >> d;
    for (auto& i : x) i -= x0;
    vector<ll> l0, g0;
    for (auto& i : x) if (i < 0) l0.push_back(-i); else g0.push_back(i);
    worker lwork(l0, d), gwork(g0, d);
    int q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        i128 ret = 1e36;
        for (int iter = 0; iter < 2; ++iter, swap(lwork, gwork)) {
            ret = min(ret, lwork.get_min(t) + gwork.get_min(2 * t));
        }
        string s;
        while (ret > 0) {
            s.push_back(ret % 10 + '0');
            ret /= 10;
        }
        reverse(s.begin(), s.end());
        if (s.empty()) s = "0";
        cout << s << '\n';
    }
}