#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using i128 = __int128_t;

struct worker {
    ll d;
    vector<ll> x, borders;
    vector<int> uniq;
    vector<i128> pref, s0, s1, s2;

    worker(vector<ll> _x, ll _d) {
        x = _x;
        d = _d;
        sort(x.begin(), x.end());
        int n = x.size();
        s0.assign(n + 1, 0);
        s1.assign(n + 1, 0);
        s2.assign(n + 1, 0);
        pref.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            ll s = x[i] / d;
            if (abs(s * d - x[i]) < abs((s + 1) * d - x[i])) borders.push_back(s);
            else borders.push_back(s + 1);
            pref[i + 1] = pref[i] + (i128)(borders[i] * d - x[i]) * (borders[i] * d - x[i]);
        }
        for (int i = n - 1; i >= 0; --i) {
            s0[i] = s0[i + 1] + 1;
            s1[i] = s1[i + 1] + x[i];
            s2[i] = s2[i + 1] + (i128)x[i] * x[i];
        }
        uniq.push_back(0);
        for (int i = 1; i < n; ++i) {
            if (borders[i] > borders[i - 1]) uniq.push_back(i);
        }
        uniq.push_back(n);
    }

    i128 get(ll s, ll t, int k) {
        i128 pt = (i128)s * d;
        i128 ret = (pref[k]) + (s0[k] * pt * pt - 2 * s1[k] * pt + s2[k]) + (i128)s * t;
        return ret;
    }

    i128 get_min(ll t) {
        if (x.empty()) return 0;
        int k;
        {
            int L = 0, R = uniq.size() - 1;
            while (L != R) {
                int M = (L + R) / 2 + 1;
                int k = uniq[M];
                ll lb = k == 0 ? 0 : borders[k - 1];
                if (get(lb + 1, t, k) - get(lb, t, k) <= 0) L = M;
                else R = M - 1;
            }
            k = uniq[L];
        }
        i128 L = k > 0 ? borders[k - 1] : 0, R = k < borders.size() ? borders[k] : (ll)2e9 / d;
        i128 c = s2[k] + pref[k];
        i128 b = s1[k] * d * (-2) + t;
        i128 a = s0[k] * d * d;
        if (a == 0) {
            return b * L + c;
        }
        i128 x0 = (-b) / (2 * a);
        x0 = max(x0, L);
        return min(a * x0 * x0 + b * x0 + c, a * (x0 + 1) * (x0 + 1) + b * (x0 + 1) + c);
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    cin >> n;
    vector<ll> x(n);
    for (auto& i : x) cin >> i;
    ll x0, d;
    cin >> x0 >> d;
    for (auto& i : x) i -= x0;
    vector<ll> l0, g0;
    for (auto& i : x) if (i < 0) l0.push_back(-i); else g0.push_back(i);
    worker lwork(l0, d), gwork(g0, d);
    int q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        i128 ret = min(lwork.get_min(t) + gwork.get_min(2 * t), gwork.get_min(t) + lwork.get_min(2 * t));
        string s;
        while (ret > 0) {
            s.push_back(ret % 10 + '0');
            ret /= 10;
        }
        reverse(s.begin(), s.end());
        if (s.empty()) s = "0";
        cout << s << '\n';
    }
}