#include<bits/stdc++.h>
using namespace std;

using ll = long long;
const int inf = 1e9;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, D;
    cin >> n >> D;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int sz = n * (D + 2) + 2;
    int st = sz - 2;
    int fi = sz - 1;
    struct edge {
        int to, cap;
    };
    vector<edge> e;
    vector<vector<int>> adj(sz);
    auto add_edge = [&](int u, int v, int cap) -> void {
        adj[u].push_back(e.size());
        e.emplace_back(v, cap);
        adj[v].push_back(e.size());
        e.emplace_back(u, 0);
    };
    for (int i = 0; i < n; ++i) {
        add_edge(st, i, 1);
    }
    for (int j = 0; j < D; ++j) {
        for (int i = 0; i < n; ++i) {
            for (auto k : g[i]) {
                add_edge(j * n + i, (j + 1) * n + k, inf);
            }
        }
    }
    for (int j = 1; j <= D; j += 2) {
        for (int i = 0; i < n; ++i) {
            add_edge(j * n + i, (D + 1) * n + i, inf);
        }
    }
    for (int i = 0; i < n; ++i) {
        add_edge((D + 1) * n + i, fi, 1);
    }
    vector<int> used(sz, 0);
    vector<int> ptr(sz, 0);
    int timer = 0;
    vector<int> dist(sz);
    queue<int> q;
    auto bfs = [&]() -> bool {
        fill(dist.begin(), dist.end(), -1);
        dist[st] = 0;
        q.push(st);
        while (q.size()) {
            int u = q.front();
            q.pop();
            for (auto id : adj[u]) {
                int to = e[id].to;
                if (e[id].cap > 0 && dist[to] == -1) {
                    dist[to] = dist[u] + 1;
                    q.push(to);
                }
            }
        }
        return dist[fi] != -1;
    };
    auto dfs = [&](auto dfs, int u, int flow) -> int {
        if (u == fi) return flow;
        used[u] = timer;
        while (ptr[u] < adj[u].size()) {
            int id = adj[u][ptr[u]];
            int to = e[id].to;
            if (used[to] == timer || dist[to] != dist[u] + 1 || e[id].cap == 0) {
                ++ptr[u];
                continue;
            }
            int d = dfs(dfs, to, min(flow, e[id].cap));
            if (d > 0) {
                e[id].cap -= d;
                e[id ^ 1].cap += d;
                return d;
            }
            ++ptr[u];
        }
        return 0;
    };
    int ans = 0;
    while (bfs()) {
        fill(ptr.begin(), ptr.end(), 0);
        while (true) {
            ++timer;
            int c = dfs(dfs, st, inf);
            if (c == 0) break;
            ans += c;
        }
    }
    cout << ans / 2 << "\n-1";
}