#include<bits/stdc++.h>
using namespace std;

using ll = long long;

struct DSU {
    vector<int> prv;

    DSU() = default;
    DSU(int n) : prv(n) {
        iota(prv.begin(), prv.end(), 0);
    }

    int get(int u) {
        if (u == -1) return u;
        if (u == prv[u]) return u;
        return prv[u] = get(prv[u]);
    }

    void del(int u) {
        prv[u] = u - 1;
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> cnt(n, vector<int>(d + 1));
    vector<int> depth(n);
    vector<bool> used(n);
    vector<int> par(n, -1);
    vector<int> tout(n);
    int timer = 0;
    auto dfs = [&](auto dfs, int u, int p) -> void {
        for (auto to : g[u]) {
            if (to != p) {
                par[to] = u;
                depth[to] = depth[u] + 1;
                dfs(dfs, to, u);
            }
        }
        tout[u] = timer++;
    };
    dfs(dfs, 0, -1);
    vector<pair<int, int>> ret;
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);
    sort(perm.begin(), perm.end(), [&](int i, int j) {
        return tout[i] < tout[j];
    });
    vector<vector<vector<int>>> verts(n, vector<vector<int>>(d + 1));
    vector<array<DSU, 2>> prv(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i, c = 0; c <= d && j != -1; j = par[j], c++) {
            verts[j][c].push_back(i);
        }
        prv[i][0] = prv[i][1] = DSU(d + 1);
        for (int j = 0; j <= d; ++j) {
            prv[i][~j & 1].del(j);
        }
    }
    for (auto i : perm) {
        if (used[i]) continue;
        pair<int, int> mx = {-1, -1};
        for (int j = i, c = 0; c <= d && j != -1; j = par[j], c++) {
            int eo = ~c & 1;
            int k = d - c;
            while (k >= 0) {
                k = prv[j][eo].get(k);
                if (k < 0) continue;
                while (verts[j][k].size() && used[verts[j][k].back()]) verts[j][k].pop_back();
                if (verts[j][k].empty()) {
                    prv[j][eo].del(k);
                } else {
                    int u = verts[j][k].back();
                    mx = max(mx, {depth[u], u});
                    break;
                }
                k--;
            }
        }
        if (mx.second != -1) {
            ret.emplace_back(i, mx.second);
            used[i] = used[mx.second] = true;
        }
    }
    cout << ret.size() << '\n';
    for (auto [x, y] : ret) cout << x + 1 << ' ' << y + 1 << '\n';
}