#include<bits/stdc++.h>
using namespace std;

using ll = long long;

const int D = 100;
const int N = 3e5;

struct DSU {
    int prv[D];

    DSU() {
        iota(prv, prv + D, 0);
    }

    int get(int u) {
        while (u != -1 && prv[u] != -1 && prv[u] != u) {
            u = prv[u] = prv[prv[u]];
        }
        if (u != -1) u = prv[u];
        return u;
    }

    void del(int u) {
        prv[u] = u - 1;
    }
} prv[N][2];
int n, d;
vector<int> g[N];
int depth[N], par[N], tin[N], timer = 0, lst[N], nxt[N], vert[N][D];
bool used[N];
void dfs(int u, int p) {
    nxt[u] = lst[depth[u]];
    lst[depth[u]] = u;
    tin[u] = timer++;
    for (int v = u, c = 0; c <= d && v != -1; v = par[v], c++) {
        vert[v][c] = u;
    }
    for (auto to : g[u]) {
        if (to != p) {
            par[to] = u;
            depth[to] = depth[u] + 1;
            dfs(to, u);
        }
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    par[0] = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= d; ++j) vert[i][j] = -1;
    }
    fill(lst, lst + n, -1);
    fill(nxt, nxt + n, -1);
    dfs(0, -1);
    vector<pair<int, int>> ret;
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);
    sort(perm.begin(), perm.end(), [&](int i, int j) {
        return depth[i] > depth[j];
    });
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= d; ++j) {
            prv[i][~j & 1].del(j);
        }
    }
    for (auto i : perm) {
        if (used[i]) continue;
        pair<int, int> mx = {-1, -1};
        for (int j = i, c = 0; c <= d && j != -1; j = par[j], c++) {
            int eo = ~c & 1;
            int k = d - c;
            while (k >= 0) {
                k = prv[j][eo].get(k);
                if (k < 0) continue;
                while (vert[j][k] != -1 && tin[vert[j][k]] >= tin[j] && used[vert[j][k]]) vert[j][k] = nxt[vert[j][k]];
                if (vert[j][k] != -1 && tin[vert[j][k]] >= tin[j]) {
                    int u = vert[j][k];
                    mx = max(mx, {depth[u], u});
                    break;
                } else {
                    prv[j][eo].del(k);
                }
                k--;
            }
        }
        if (mx.second != -1) {
            ret.emplace_back(i, mx.second);
            used[i] = used[mx.second] = true;
        }
    }
    cout << ret.size() << '\n';
    for (auto [x, y] : ret) cout << x + 1 << ' ' << y + 1 << '\n';
}