#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> adj(n);
    vector<bool> depth(n);
    auto dfs = [&](auto dfs, int u, int p) -> void {
        for (auto to : g[u]) {
            if (to != p) {
                depth[to] = !depth[u];
                dfs(dfs, to, u);
            }
        }
    };
    dfs(dfs, 0, -1);
    for (int i = 0; i < n; ++i) {
        if (depth[i]) continue;
        auto dfs2 = [&](auto dfs2, int u, int p, int dist) -> void {
            if (dist & 1) {
                adj[i].push_back(u);
            }
            if (dist < d) {
                for (auto to : g[u]) {
                    if (to != p) {
                        dfs2(dfs2, to, u, dist + 1);
                    }
                }
            }
        };
        dfs2(dfs2, i, -1, 0);
    }
    vector<int> mt(n, -1), used(n, 0);
    int timer = 0;
    auto try_kuhn = [&](auto try_kuhn, int u) -> bool {
        used[u] = timer;
        for (auto to : adj[u]) {
            if (mt[to] == -1) {
                mt[to] = u;
                return true;
            }
        }
        for (auto to : adj[u]) {
            if (used[mt[to]] != timer && try_kuhn(try_kuhn, mt[to])) {
                mt[to] = u;
                return true;
            }
        }
        return false;
    };
    for (int i = 0; i < n; ++i) {
        if (depth[i]) continue;
        timer++;
        try_kuhn(try_kuhn, i);
    }
    vector<pair<int, int>> ret;
    for (int i = 0; i < n; ++i) {
        if (mt[i] != -1) {
            ret.emplace_back(i, mt[i]);
        }
    }
    cout << ret.size() << '\n';
    for (auto [x, y] : ret) cout << x + 1 << ' ' << y + 1 << '\n';
}