#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ull unsigned ll
#define vll vector<ll>
#define fi(n) for (int i = 0; i < n; i++)
#define fj(n) for (int j = 0; j < n; j++)
#define all(v) v.begin(), v.end()

using namespace std;

struct dtree {
    vector<int> t;
    vector<int> p;
    int size;
    void assign(int n) {
        size = 1;
        while (size <= n) size*=2;
        t.assign(2*size-1, 0);
        p.assign(2*size-1, 0);
    }
    dtree(int n) {
        assign(n);
    }
    void push(int v, int lx, int rx) {
        if (p[v] == 0) return;
        if (lx < p[v]) {
            int rq = min(p[v], rx);
            t[v] += (1ll * (rq - 1) * rq - 1ll * (lx - 1) * lx) / 2;
            t[v] += (rx - rq) * p[v];
        } else {
            t[v] += (rx - lx) * p[v];
        }
        p[v] = 0;
        if (rx - lx == 1) return;
        p[2*v+1] = p[v];
        p[2*v+2] = p[v];
    }
    void add(int x, int v, int l, int r, int lx, int rx) {
        push(v, lx, rx);
        if (l <= lx && r >= rx) {
            p[v] += x;
            return;
        }
        if (l >= rx || r <= lx) return;
        int mid = (lx + rx) / 2;
        add(x, 2*v+1, l, r, lx, mid);
        add(x, 2*v+2, l, r, mid, rx);
    }
};

void solve() {
    int h, w; cin >> h >> w;
    vector<vector<int>> a(h, vector<int>(w, 0));
    fi(h) {
        fj(w) {
            char c; cin >> c;
            if (c == '1') a[i][j] = 1;
        }
    }
    vector<vector<unordered_map<int, int>>> dp(h, vector<unordered_map<int, int>>(w, unordered_map<int, int>()));
    int ans = 0;
    fi(h) {
        int horiz = 0;
        for (int j = w-1; j >= 0; j--) {
            if (a[i][j] == 0) {
                horiz = 0;
                continue;
            }
            dp[i][j][1] = 1;
            horiz++;
            int mx = 0;
            for (int k = 0; k <= horiz; k++) {
                if (i) {
                    mx = max(mx, dp[i-1][j][k]);
                    dp[i][j][k] = mx + min(k, horiz);
                } else {
                    dp[i][j][k] = min(k, horiz);
                }
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}