#include <bits/stdc++.h>

#define ll long long
#define ull unsigned ll
#define vll vector<ll>
#define fi(n) for (int i = 0; i < n; i++)
#define fj(n) for (int j = 0; j < n; j++)
#define all(v) v.begin(), v.end()

using namespace std;

vector<vector<int>> g;

struct ftree {
    vector<int> t;
    int n;

    void assign(int ns) {
        n = ns;
        t.assign(n+1, 0);
    }

    ftree(int n) : n(n) { assign(n); }

    void add(int i, int x) {
        for (; i <= n; i += i &-i) {
            t[i] += x;
        }
    }

    int sum(int i) {
        int ans = 0;
        for (; i > 0; i -= i& -i) {
            ans += t[i];
        }
        return ans;
    }
};

struct rab {
    int l, r, m;
    rab(int l = 0, int r = 0, int m = 0) : l(l), r(r), m(m) {};
};

vector<bool> used;

bool dfs(int v) {
    used[v] = true;
    bool flag = false;
    for (auto u : g[v]) {
        if (used[u]) return true;
        flag |= dfs(u);
    }
    return flag;
}

void solve() {
    int n, k; cin >> n >> k;
    vector<rab> a(k);
    ftree tr(n + 1);
    g.assign(k, vector<int>());
    fi(k) {
        auto &e = a[i];
        cin >> e.l >> e.m >> e.r;
        tr.add(e.l, 1);
        tr.add(e.r + 1, -1);
    }
    fi(k) {
        auto &e = a[i];
        fj(k) {
            if (i == j) continue;
            if (e.l <= a[j].m && e.r >= a[j].m) g[i].push_back(j);
        }
    }
    fi(k) {
        used.assign(k, false);
        if (dfs(i)) {
            cout << "NO\n";
            return;
        }
    }
    fi(n) {
        if (tr.sum(i+1) <= 0) {
            cout << "NO\n";
            return;
        }
    }
    for (auto &e : a) {
        tr.add(e.l, -1);
        tr.add(e.r + 1, 1);
        if (tr.sum(e.m) > 1) {
            cout << "NO\n";
            return;
        }
        tr.add(e.l, 1);
        tr.add(e.r + 1, -1);
    }
    cout << "YES\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}