#include <bits/stdc++.h>
using namespace std;


const int N = 4e6 + 1;

mt19937 rng(time(0));
struct Node {
    int f, s, t;
};

vector<Node> cur;

bool cmp (Node a, Node b) {
    return a.f > b.f;
}
int n, k;

bool check (vector<int>&p) {
    vector<int> used(n + 1);
    for (auto &x : p) {
        auto it = cur[x];
        int l = it.f, r = it.s, m = it.f;
        if (!used[m]) {
            for (int i = l; i <= r; ++i) {
                used[i] = 1;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) return false;
    }
    return true;

}

bool solve() {


    vector<int> p;
    for (int i = 0; i < k; ++i) p.push_back(i);
    if (check(p)) {
        return true;
    }
    while (next_permutation(p.begin(), p.end())) {
        if (check(p)) {
            return true;
        }
    }
    return false;

}


bool clever() {

    sort(cur.begin(), cur.end(), cmp);
    vector<pair<int, int>> help;
    vector<int> used(n + 1);
    for (auto &[l, r, m] : cur) {
        if (!used[l]) {
            used[l] = r;
        } else {
            used[l] = max(used[l], r);
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) continue;
        help.push_back({i, used[i]});
    }
    vector<int> dp (n + 2);
    dp[n + 1] = 1;
    for (auto &[l, r] : help) {
        for (int i = l; i <= r; ++i) {
            dp[i] = 1;
        }
    }
    bool fl = true;
    for (int i = 1; i <= n; ++i) {
        if (!dp[i]) return false;
    }
   return true;
}

signed main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    while (test) {

        cur.clear();
        n = rng() % 20 + 1;
        k = rng() % 8 + 1;
        for (int i = 0; i < k; ++i) {
            int l = rng() % n + 1;
            int r = -1;
            while (r < l) {
                r = rng() % n + 1;
            }
            int m = l;
            cur.push_back({l, r, m});
        }
        bool fl = clever(), fl2 = solve();
        if (fl != fl2) {
            cout << fl << ' ' << fl2 << '\n';
            cout << n << ' ' << k << '\n';
            for (auto &[l, r, m] : cur) {
                cout << l << ' ' << m << ' ' << r << '\n';
            }
            return 0;
        }
    }
}
// 6 8
// 6 6 6
// 6 6 6
// 5 5 6
// 3 3 6
// 2 2 2
// 2 2 3
// 2 2 6
// 1 1 3

