#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = (int) (1e7) + 52;

struct work {
    int l, m;

    work(const int l = 0, const int m = 0) : l(l), m(m) {
    }
};

vector<int> tree;

void update(int v, int tl, int tr, int q, int x) {
    if (tl + 1 == tr) {
        tree[v] = min(tree[v], x);;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (q < tm) {
        update(2 * v + 1, tl, tm, q, x);
    } else {
        update(2 * v + 2, tm, tr, q, x);
    }
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int tl, int tr, int ql, int qr) {
    if (qr <= tl || tr <= ql) {
        return inf;
    }
    if (ql <= tl && tr <= qr) {
        return tree[v];
    }
    int tm = (tl + tr) >> 1;
    return min(get(2 * v + 1, tl, tm, ql, qr), get(2 * v + 2, tm, tr, ql, qr));
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<work> > here(n + 1);
    while (k--) {
        int l, r, m;
        cin >> l >> m >> r;
        here[r].emplace_back(l, m);
    }
    vector<int> dp(n + 1, n + 1);
    tree.assign(4 * (n + 1), n + 1);
    dp[0] = 0;
    update(0, 0, n + 1, 0, 0);
    for (int r = 1; r <= n; r++) {
        for (auto &[l, m]: here[r]) {
            dp[r] = min(dp[r], max(m, get(0, 0, n + 1, l - 1, m)));
            if (get(0, 0, n + 1, l - 1, r) < l) {
                dp[r] = min(dp[r], m);
            }
        }
        update(0, 0, n + 1, r, dp[r]);
    }
    cout << (dp[n] <= n ? "YES\n" : "NO\n");
}

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
