#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<vector<int> > cg(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        cg[v].emplace_back(u);
        cg[u].emplace_back(v);
    }
    vector<vector<int> > g(n);
    vector<vector<int> > dst(n, vector<int>(n, n + 1));
    auto dfs = [&](auto &&self, int v, int s, int d) -> void {
        dst[s][v] = d;
        if (d <= k & v != s && (d & 1)) {
            g[v].emplace_back(s);
        }
        for (auto &u: cg[v]) {
            if (dst[s][u] >= n) {
                self(self, u, s, d + 1);
            }
        }
    };
    for (int v = 0; v < n; v++) {
        dfs(dfs, v, v, 0);
    }
    vector<int> color(n, -1);
    auto cdfs = [&](auto &&self, int v, int cur) -> void {
        color[v] = cur;
        for (auto &u: g[v]) {
            if (color[u] == -1) {
                self(self, u, cur ^ 1);
            }
        }
    };
    cdfs(cdfs, 0, 0);
    vector<int> used(n, -1), lp(n, -1);
    vector<vector<int> > fg(n);
    for (int v = 0; v < n; v++) {
        if (color[v] == 0) {
            for (auto &u: g[v]) {
                fg[v].emplace_back(u);
            }
        }
    }
    auto kuhn = [&](auto &&self, int v, int cur) -> bool {
        if (used[v] == cur) {
            return false;
        }
        used[v] = cur;
        for (auto &u: fg[v]) {
            if (lp[u] == -1) {
                lp[u] = v;
                return true;
            }
        }
        for (auto &u: fg[v]) {
            if (self(self, lp[u], cur)) {
                lp[u] = v;
                return true;
            }
        }
        return false;
    };
    int mt = 0;
    for (int v = 0; v < n; v++) {
        if (color[v] == 0) {
            mt += kuhn(kuhn, v, mt);
        }
    }
    vector<pair<int, int> > way;
    for (int v = 0; v < n; v++) {
        if (lp[v] != -1) {
            way.emplace_back(v, lp[v]);
        }
    }
    cout << (int) way.size() << '\n';
    for (auto &[v, u]: way) {
        cout << v + 1 << ' ' << u + 1 << '\n';
    }
    return 0;
}
