#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("unroll-loops", "O3")

const int INF = 1e9;

struct segTree {
    vector<int> t;
    int sz;
    void build(int n) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        t.assign(sz * 2, INF);
    }

    void update(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            if (t[v] > x)
                t[v] = x;
            return;
        }

        int mid = (l + r) / 2;
        if (ind < mid)
            update(v * 2 + 1, l, mid, ind, x);
        else
            update(v * 2 + 2, mid, r, ind, x);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void update(int ind, int x) {
        update(0, 0, sz, ind, x);
    }

    int get(int v, int l, int r, int lv, int rv) {
        if (lv >= r || l >= rv)
            return INF;
        if (l >= lv && r <= rv)
            return t[v];
        int mid = (l + r) / 2;
        return min(get(v * 2 + 1, l, mid, lv, rv), get(v * 2 + 2, mid, r, lv, rv));
    }

    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pair<int, int>, int>> vec(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        vec[i] = {{l, r}, m};
    }

    sort(vec.begin(), vec.end());
    segTree tree;
    tree.build(n + 1);
    tree.update(0, 0);

    for (int i = 0; i < k; i++) {
        int minL = tree.get(vec[i].first.first - 1, vec[i].second);
        int minR = tree.get(vec[i].second, vec[i].first.second + 1);
        if (minL != INF || minR < vec[i].first.first)
            tree.update(vec[i].first.second, vec[i].second);
    }

    if (tree.get(n, n + 1) == INF)
        cout << "NO\n";
    else
        cout << "YES\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}