#include <bits/stdc++.h>
using namespace std;
#define ll long long
#pragma GCC optimize("unroll-loops", "O3")

struct upd {
    ll res = 0, sum = 0, cnt = 0;
    ll add = 0, last = 0;

    void ins(ll x) {
        res += x * x;
        sum += x;
        cnt++;
    }

    void del(ll x) {
        res -= x * x;
        sum -= x;
        cnt--;
    }

    void move(ll d) {
        ll d_ = d;
        d -= last;
        last = d_;
        res += cnt * d * d - d * 2 * sum;
        sum -= d * cnt;
    }
};

ll findD(ll dist, ll d) {
    ll left = (dist / d + 1) * d - dist;
    ll right = dist - (dist / d) * d;
    right = min(right, left);
    return right * right;
}

vector<upd> calcFunc(vector<ll> &x, ll d) {
    ll cur = 0;
    upd u;
    for (ll i: x) {
        u.ins(i);
    }
    u.last = u.add = 0;
    vector<upd> res;
    for (ll i: x) {
        u.move(i);
        cur += findD(i, d);
        u.del(0);
        //cout << i << " " << u.res << " " << cur << "\n";
        u.add = cur;
        res.push_back(u);
    }
    return res;
}

ll getFunc(vector<ll> &x, vector<upd> &dp, ll k, ll d, ll t) {
    ll ind = upper_bound(x.begin(), x.end(), k * d) - x.begin() - 1;
    dp[ind].move(k * d);
    return dp[ind].res + dp[ind].add + k * t;
}

ll findMn(vector<ll> &x, vector<upd> &dp, ll t, ll d) {
    ll l = 0, r = (x.back() + d - 1) / d;
    while (r - l > 2) {
        ll m1 = (l * 2 + r) / 3;
        ll m2 = (l + r * 2) / 3;
        if (getFunc(x, dp, m1, d, t) <= getFunc(x, dp, m2, d, t))
            r = m2;
        else
            l = m1;
    }
    ll ans = 2e18;
    for (ll i = l; i <= r; i++)
        ans = min(ans, getFunc(x, dp, i, d, t));
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++)
        cin >> x[i];
    sort(x.begin(), x.end());
    ll x0, d;
    cin >> x0 >> d;
    vector<ll> xl, xr;
    xr.push_back(0);
    for (ll i: x) {
        if (i < x0)
            xl.push_back(x0 - i);
        if (i > x0)
            xr.push_back(i - x0);
    }
    xl.push_back(0);
    reverse(xl.begin(), xl.end());

    auto dpl = calcFunc(xl, d), dpr = calcFunc(xr, d);

    ll m; cin >> m;
    for (int i = 0; i < m; i++) {
        int t; cin >> t;
        ll ans = findMn(xl, dpl, t * 2, d) + findMn(xr, dpr, t, d);
        ans = min(ans, findMn(xl, dpl, t, d) + findMn(xr, dpr, t * 2, d));
        cout << ans << "\n";
    }
}