#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
using ll = long long;
using ld = long double;

#define int long long
const int maxn = 2e5 + 2;
const int inf = 1e9 + 1;

int h, w;

vector<vector<int>> a, nxt;

struct Node {
    ll mx, sum, add;
};

Node merge(Node a, Node b) {
    Node c;
    c.mx = max(a.mx, b.mx);
    c.sum = a.sum + b.sum;
    c.add = -1;
    return c;
}

Node tree[maxn * 4];

void push(int v, int l, int r) {
    if (tree[v].add == -1) {
        return;
    }
    if (l == r) {
        tree[v].mx = tree[v].add;
        tree[v].sum = tree[v].add;
        tree[v].add = -1;
        return;
    }
    int mid = (l + r) / 2;
    tree[v].mx = tree[v].add;
    tree[v].sum = tree[v].add * (r - l + 1);
    tree[2 * v].add = tree[v].add;
    tree[2 * v + 1].add = tree[v].add;
    tree[v].add = -1;
}

void build(int v, int l, int r, int j) {
    if (l == r) {
        tree[v] = {nxt[r][j], nxt[r][j], -1};
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v, l, mid, j);
    build(2 * v + 1, mid + 1, r, j);
    tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
}

ll get(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if (r < ql || qr < l) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[v].sum;
    }
    int mid = (l + r) / 2;
    return get(2 * v, l, mid, ql, qr) + get(2 * v + 1, mid + 1, r, ql, qr);
}

ll get_more(int v, int l, int r, int k) {
    push(v, l, r);
    if (l == r) {
        return r;
    }
    int mid = (l + r) / 2;
    push(2 * v, l, mid);
    push(2 * v + 1, mid + 1, r);
    if (tree[2 * v].mx > k) {
        return get_more(2 * v, l, mid, k);
    } else {
        return get_more(2 * v + 1, mid + 1, r, k);
    }
}

void update(int v, int l, int r, int ql, int qr, int k) {
    push(v, l, r);
    if (qr < l || r < ql) {
        return;
    }
    if (ql <= l && r <= qr) {
        tree[v].add = k;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(2 * v, l, mid, ql, qr, k);
    update(2 * v + 1, mid + 1, r, ql, qr, k);
    tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> h >> w;
    a.resize(h + 1);
    nxt.resize(h + 1);
    for (int i = 0; i < h + 1; i++) {
        a[i].resize(w + 1);
        nxt[i].resize(w + 1);
    }
    for (int i = 1; i < h + 1; i++) {
        string s; cin >> s;
        for (int j = 1; j < w + 1; j++) {
            a[i][j] = s[j - 1] - '0';
        }
    }
    for (int i = 1; i < h + 1; i++) {
        int cur = w + 1;
        for (int j = w; j > 0; j--) {
            if (a[i][j] == 1) {
                nxt[i][j] = cur - j;
            } else {
                cur = j;
            }
        }
    }
    ll res = 0;
    for (int j = 1; j < w + 1; j++) {
        //cout << j << " : \n";
        build(1, 1, h, j);
        //print();
        for (int i = 1; i < h + 1; i++) {
            //cout << i << " --> ";
            //print();
            if (nxt[i][j] >= nxt[i - 1][j]) {
                res = max(res, get(1, 1, h, 1, i));
                continue;
            }
            int border = get_more(1, 1, h, nxt[i][j]);
            update(1, 1, h, border, i, nxt[i][j]);
            res = max(res, get(1, 1, h, 1, i));
            //cout << i << " --> ";
            //print();
        }
    }
    cout << res << "\n";
}

/*
6 4
0011
1101
0111
1110
0111
0100
*/
