#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using i128 = __int128;

const int maxn = 5e5;
const ll INF = 1e18;

#define int ll

int st[4 * maxn];
int add[4 * maxn];

void build(int v, int l, int r) {
    add[v] = 0;
    if (l + 1 == r) {
        st[v] = 0;
        return;
    }
    int m = (r + l) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
}

void push(int v) {
    if (add[v] == 0) return;
    st[v * 2 + 1] += add[v];
    st[v * 2 + 2] += add[v];
    add[v * 2 + 1] += add[v];
    add[v * 2 + 2] += add[v];
    add[v] = 0;
}

void add_val(int v, int l, int r, int lq, int rq, int val) {
    if (rq <= l || r <= lq) return;
    if (lq <= l && r <= rq) {
        st[v] += val;
        add[v] += val;
        return;
    }
    push(v);
    int m = (r + l) / 2;
    add_val(v * 2 + 1, l, m, lq, rq, val);
    add_val(v * 2 + 2, m, r, lq, rq, val);
    st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
}

pair<int, int> get(int v, int l, int r) {
    if (l + 1 == r) return {st[v], l};
    push(v);
    int m = (r + l) / 2;
    if (st[v * 2 + 1] < st[v * 2 + 2]) return get(v * 2 + 1, l, m);
    return get(v * 2 + 2, m, r);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int> > v(k);
    vector<int> l(k), r(k), m(k);
    vector<bool> mark(n);
    map<int, int> mp;
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        r[i]--;
        mark[m[i]] = true;
        mp[m[i]] = i;
        v[i] = {l[i], r[i]};
    }
    build(0, 0, n);
    for (int i = 0; i < k; ++i) {
        add_val(0, 0, n, l[i], r[i] + 1, 1);
    }
    if (get(0, 0, n).first == 0) cout << "NO\n";
    else cout << "YES\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}
