#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using i128 = __int128;

const ll INF = 1e18;

#define int ll

vector<vector<int> > g;
vector<vector<int> > G;
vector<int> mt;
vector<int> color;
int d;

void get_G(int start, int v, int p, int dst) {
    if (dst > d) return;
    if (dst % 2 == 1) {
        G[start].push_back(v);
    }
    for (auto to: g[v]) {
        if (to == p) continue;
        get_G(start, to, v, dst + 1);
    }
}

void color_G(int v, int clr) {
    color[v] = clr;
    for (auto to: G[v]) {
        if (color[to] != -1) continue;
        color_G(to, 1 - clr);
    }
}

vector<bool> used;

bool dfs(int v) {
    used[v] = true;
    for (auto to: g[v]) {
        if (mt[to] == -1 || (!used[mt[to]] && dfs(mt[to]))) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    int n;
    cin >> n >> d;
    g.assign(n + 1, {});
    G.assign(n + 1, {});
    color.assign(n + 1, -1);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 1; i <= n; ++i) {
        get_G(i, i, -1, 0);
    }
    g.assign(n + 1, {});
    mt.assign(n + 1, -1);
    for (int i = 1; i <= n; ++i) {
        if (color[i] == -1) {
            color_G(i, 0);
        }
        if (color[i] == 0) {
            for (auto to: G[i]) {
                g[i].push_back(to);
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        used.assign(n + 1, {});
        dfs(i);
    }
    vector<pair<int, int> > ans;
    for (int i = 1; i <= n; ++i) {
        if (mt[i] != -1) ans.push_back({mt[i], i});
    }
    cout << ans.size() << "\n";
    for (auto [a, b]: ans) cout << a << " " << b << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
