#include<bits/stdc++.h>
using namespace std;
#define int long long
vector<vector<int> > g;
vector<vector<int> > up;
vector<int> d, tin, tout;
int timer = 0;

void dfs(int v, int p = 0) {
    d[v] = d[p] + 1;
    up[v][0] = p;
    tin[v] = timer++;
    for (int i = 1; i < 20; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto to: g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
    tout[v] = timer;
}

bool parent(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
    if (parent(a, b)) {
        return a;
    }
    if (parent(b, a)) {
        return b;
    }
    for (int i = 19; i >= 0; --i) {
        if (!parent(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return up[a][0];
}

int dist(int a, int b) {
    return d[a] + d[b] - 2 * d[lca(a, b)];
}

vector<int> used, mt;

bool kuhn(int v) {
    used[v] = 1;
    for (auto to: g[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return true;
        }
        if (!used[mt[to]] && kuhn(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, d1;
    cin >> n >> d1;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    d.resize(n);
    tin.resize(n);
    tout.resize(n);
    up.resize(n, vector<int>(20));
    dfs(0);
    g.clear();
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (dist(i, j) <= d1 && d[i] % 2 != d[j] % 2) {
                g[i].push_back(j);
            }
        }
    }
    int ans = 0;
    mt.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        if (d[i] % 2) {
            used.assign(n, 0);
            if (kuhn(i)) {
                ans++;
            }
        }
    }
    cout << ans << '\n' << -1;
}
