#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
const int INF = 2 * 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int h, w;
	cin >> h >> w;
	vector<vector<char>> a(h, vector<char>(w));
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			cin >> a[i][j];
		}
	}
	vector<vector<int>> mas(h, vector<int>(w, 0));
	for (int i = 0; i < h; ++i) {
		for (int j = w - 1; j >= 0; --j) {
			if (a[i][j] == '0') {
				mas[i][j] = 0;
			}
			else {
				mas[i][j] = 1;
				if (j != w - 1) mas[i][j] += mas[i][j + 1];
			}
		}
	}
	vector<vector<int>> up(h, vector<int>(w, -1));
	for (int j = 0; j < w; ++j) {
		vector<int> st;
		for (int i = h - 1; i >= 0; --i) {
			while (!st.empty() && mas[st.back()][j] > mas[i][j]) {
				up[st.back()][j] = i;
				st.pop_back();
			}
			st.push_back(i);
		}
	}
	vector<vector<int>> dp(h, vector<int>(w, 0));
	int ans = 0;
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			if (a[i][j] == '0') {
				dp[i][j] = 0;
			}
			else {
				if (up[i][j] == -1) {
					dp[i][j] = mas[i][j] * (i + 1);
				}
				else {
					dp[i][j] = dp[up[i][j]][j] + mas[i][j] * (i - up[i][j]);
				}
			}
			ans = max(ans, dp[i][j]);
		}
	}
	cout << ans;

	return 0;
}