#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;
using ii = long long; //__int128;
const ll INF = 2 * 1e18;

ii get_dist(ii x1, ii x2) {
	return (x1 - x2) * (x1 - x2);
}
ii get(ii x, ii x0, ii d) {
	ii k = (x - x0) / d;
	if (x < x0) k--;
	ii var1 = x0 + k * d;
	ii var2 = x0 + (k + 1) * d;
	//cout << "  " << x << " " << var1 << " " << var2 << "\n";
	return min(get_dist(x, var1), get_dist(x, var2));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	vector<ii> x(n);
	for (int i = 0; i < n; ++i) {
		ll x1; cin >> x1; x[i] = x1;
	}
	sort(x.begin(), x.end());
	ll x0_1, d_1;
	cin >> x0_1 >> d_1;
	ii x0 = x0_1, d = d_1;
	vector<ii> ind;
	ii cur = x0;
	while (true) {
		ind.push_back(cur);
		if (cur >= x[n - 1])
			break;
		cur += d;
	}
	vector<ii> suf2(n + 1, 0), suf1(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		suf1[i] = suf1[i + 1] + x[i];
		suf2[i] = suf2[i + 1] + x[i] * x[i];
	}
	vector<ii> best(n), pref(n);
	for (int i = 0; i < n; ++i) {
		best[i] = get(x[i], x0, d);
		pref[i] = best[i];
		if (i != 0) pref[i] += pref[i - 1];
	}
	vector<ll> dp(ind.size());
	for (int j = 0; j < ind.size(); ++j) {
		ll cur = 0;
		int curi = distance(x.begin(), upper_bound(x.begin(), x.end(), ind[j]));
		ll cnt = n - curi;
		cur += ind[j] * ind[j] * cnt + suf2[curi] - ind[j] * 2 * suf1[curi];
		if (curi > 0) cur += pref[curi - 1];
		dp[j] = cur;
	}

	int m;
	cin >> m;
	for (int _ = 0; _ < m; ++_) {
		ll t; cin >> t;
		ii ans = -1;
		for (int j = 0; j < ind.size(); ++j) {
			if (ans == -1) ans = t * (ii)j + dp[j];
			else ans = min(ans, t * (ii)j + dp[j]);
		}
		cout << "   " << (ll)(ans) << "\n";
	}

	return 0;
}