#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;
const int INF = 2 * 1e9;

vector<vector<int>> g;
vector<int> dp0, dp1;
vector<int> pred;

void dfs(int u, int p) {
	int sum_dp1 = 0;
	int min_val = INF, minv = -1;
	for (int v : g[u]) {
		if (v != p) {
			dfs(v, u);
			sum_dp1 += max(dp0[v], dp1[v]);
			if (max(dp0[v], dp1[v]) - dp0[v] < min_val) {
				min_val = min(min_val, max(dp0[v], dp1[v]) - dp0[v]);
				minv = v;
			}
		}
	}
	dp0[u] = sum_dp1;
	if (min_val != INF) {
		dp1[u] = sum_dp1 - min_val + 1;
		pred[u] = minv;
	}
}

void dfs2(int u, int p) {
	if (dp0[u] >= dp1[u]) {
		for (int v : g[u]) {
			if (v != p)
				dfs2(v, u);
		}
	}
	else {
		cout << u + 1 << " " << pred[u] + 1 << "\n";
		for (int v : g[u]) {
			if (v != p && v != pred[u]) {
				dfs2(v, u);
			}
			else if (v == pred[u]) {
				for (int v2 : g[v]) {
					if (v2 != u)
						dfs2(v2, v);
				}
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, d;
	cin >> n >> d;
	g.resize(n);
	for (int _ = 0; _ < n - 1; ++_) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dp0.resize(n, 0);
	dp1.resize(n, 0);
	pred.resize(n, -1);
	dfs(0, -1);
	cout << max(dp0[0], dp1[0]) << "\n";
	dfs2(0, -1);

	return 0;
}