#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;
const int INF = 2 * 1e9;

vector<vector<int>> g;
vector<int> h, par, tin, tout;
int curt = 0;

void dfs(int u, int p) {
	par[u] = p;
	tin[u] = curt; curt++;
	for (int v : g[u]) {
		if (v != p) {
			h[v] = h[u] + 1;
			dfs(v, u);
		}
	}
	tout[u] = curt; curt++;
}
bool getp(int p, int u) {
	return (tin[p] <= tin[u] && tout[p] >= tout[u]);
}
int get_dist(int u, int v) {
	if (getp(u, v)) {
		return h[u] - h[v];
	}
	int lca = u;
	while (!getp(lca, v))
		lca = par[lca];
	return h[u] + h[v] - 2 * h[lca];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, d;
	cin >> n >> d;
	g.resize(n);
	for (int _ = 0; _ < n - 1; ++_) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	h.resize(n, 0);
	par.resize(n, -1);
	tin.resize(n);
	tout.resize(n);
	dfs(0, -1);
	vector<int> mas0, mas1;
	for (int u = 0; u < n; ++u) {
		if (h[u] % 2 == 0) mas0.push_back(u);
		else mas1.push_back(u);
	}
	int cnt0 = mas0.size(), cnt1 = mas1.size();
	vector<vector<int>> dp(cnt0 + 1, vector<int>((1 << cnt1), 0));
	for (int i = 0; i < cnt0; ++i) {
		for (int mask = 0; mask < (1 << cnt1); ++mask) {
			dp[i + 1][mask] = max(dp[i + 1][mask], dp[i][mask]);
			for (int j = 0; j < cnt1; ++j) {
				if (!((mask >> j) & 1)) continue;
				if (get_dist(mas0[i], mas1[j]) <= d)
					dp[i + 1][mask] = max(dp[i + 1][mask], dp[i][mask ^ (1 << j)] + 1);
			}
		}
	}
	cout << dp[cnt0].back() << "\n";
	cout << -1;

	return 0;
}