#include <iostream>
#include <vector>

using namespace std;

int h, w;
vector<vector<bool> > table;
vector<vector<int> > max_right;

void solve() {
    cin >> h >> w;
    char c;
    table.resize(h);
    for (auto &row: table) {
        row.resize(w);
        for (_Bit_reference val: row) {
            cin >> c;
            val = c == '1';
        }
    }
    max_right.resize(h);
    for (int i = 0; i < h; ++i) {
        max_right[i].resize(w);
        for (int j = w - 1; j >= 0; --j) {
            if (!table[i][j]) max_right[i][j] = 0;
            else if (j + 1 < w) max_right[i][j] = max_right[i][j + 1] + 1;
            else max_right[i][j] = 1;
        }
    }
    int ans = 0;
    vector<pair<int, int> > st;
    for (int j = 0; j < w; ++j) {
        for (int i = 0; i < h; ++i) {
            if (!table[i][j] || (i && table[i - 1][j])) continue;
            st.clear();
            st.emplace_back(i - 1, 0);
            int cans = 0;
            for (int k = i; k < h && table[k][j]; ++k) {
                while (st.back().second > max_right[k][j]) {
                    cans -= st.back().second * (st.back().first - st[st.size() - 2].first);
                    st.pop_back();
                }
                st.emplace_back(k, max_right[k][j]);
                cans += st.back().second * (st.back().first - st[st.size() - 2].first);
                ans = std::max(ans, cans);
            }
        }
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
    cin >> t;
#endif
    while (t--) solve();
    return 0;
}
