#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

constexpr int maxn = 5e5 + 10;
int n, k;

struct Seg {
    int l, m, r;
};

Seg segs[maxn];

void solve() {
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        auto &[l,m,r] = segs[i];
        cin >> l >> m >> r, --l, --m, --r;
    }
    vector<int> order(k);
    iota(order.begin(), order.end(), 0);
    vector<bool> ok(n, false);
    do {
        fill(ok.begin(), ok.end(), false);
        for (int i = 0; i < k; ++i) {
            auto [l,m,r] = segs[order[i]];
            if (ok[m]) continue;
            for (int j = l; j <= r; ++j) ok[j] = true;
        }
        if (find(ok.begin(), ok.end(), false) == ok.end()) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(order.begin(), order.end()));
    cout << "NO\n";
    // for (int i = 0; i < k; ++i) {
    //     for (int j = i + 1; j < k; ++j) {
    //         if (std::max(segs[i].l, segs[j].l) <= std::min(segs[i].m, segs[j].m) &&
    //             std::max(segs[i].m, segs[j].m) <= std::min(segs[i].r, segs[j].r)) {
    //             cout << "NO\n";
    //             return;
    //         }
    //     }
    // }
    // cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    cin >> t;
    while (t--) solve();
    return 0;
}
