#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

constexpr int maxn = 5e5 + 10;
int n, k;

struct Seg {
    int l, m, r;
};

Seg segs[maxn];
vector<pair<int, bool> > acts;

void solve() {
    cin >> n >> k;
    acts.clear();
    for (int i = 0; i < k; ++i) {
        auto &[l,m,r] = segs[i];
        cin >> l >> m >> r, --l, --m, --r;
        acts.emplace_back(l, false);
        acts.emplace_back(r + 1, true);
    }
    sort(acts.begin(), acts.end());
    int cnt = 0;
    for (auto [pos,t]: acts) {
        if (cnt == 0 && pos) {
            cout << "NO\n";
            return;
        }
        if (t) --cnt;
        else ++cnt;
    }
    cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    cin >> t;
    while (t--) solve();
    return 0;
}
