#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

constexpr int maxn = 5e5 + 10;
int n, k;

struct Seg {
    int l, m, r;
};

Seg segs[maxn];
vector<pair<int, bool> > acts;

void solve() {
    cin >> n >> k;
    acts.clear();
    for (int i = 0; i < k; ++i) {
        auto &[l,m,r] = segs[i];
        cin >> l >> m >> r, --l, --m, --r;
        acts.emplace_back(l, false);
        acts.emplace_back(r + 1, true);
    }
    sort(acts.begin(), acts.end());
    int cnt = 0;
    for (auto [pos,t]: acts) {
        if (cnt == 0 && pos) {
            cout << "NO\n";
            return;
        }
        if (t) --cnt;
        else ++cnt;
    }
    vector<int> left, right;
    for (int i = 0; i < n; ++i) {
        auto [l,m,r] = segs[i];
        if (l == 0 && r == n - 1) {
            cout << "YES\n";
            return;
        }
        if (l == 0) left.push_back(i);
        else right.push_back(i);
    }
    sort(right.begin(), right.end(), [](Seg a, Seg b) { return a.l < b.l; });
    vector<int> lbs(right.size());
    vector<int> pfmax(right.size() + 1);
    pfmax[0] = -1;
    for (int i = 0; i < right.size(); ++i) pfmax[i + 1] = std::max(pfmax[i], segs[right[i]].m);
    for (int i = 0; i < right.size(); ++i) lbs[i] = segs[right[i]].l;
    for (auto _: left) {
        auto [l1,m1,r1] = segs[_];
        int p1 = lower_bound(lbs.begin(), lbs.end(), m1 + 1) - lbs.begin();
        int p2 = upper_bound(lbs.begin(), lbs.end(), r1 + 1) - lbs.begin();
        if (p1 < p2) {
            cout << "YES\n";
            return;
        }
        p1 = upper_bound(lbs.begin(), lbs.end(), m1 + 1) - lbs.begin();
        if (pfmax[p1] >= r1 + 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    cin >> t;
    while (t--) solve();
    return 0;
}
