#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <cstdint>

using namespace std;
using ll = long long;

constexpr ll maxn = 3e5 + 10;
ll n, x0, d;
ll targets[maxn];
ll nearest_k[maxn];
ll near_k_power[maxn];
__int128 nkp_pf[maxn];
__int128 sq_pf[maxn];
ll pf[maxn];

ll get_near_k(ll x) {
    ll v = (x - x0) / d, c = std::abs(x0 + v * d - x);
    if (std::abs(x0 + (v + 1) * d - x) < c) ++v;
    else if (std::abs(x0 + (v + 1) * d - x) == c) {
        if (std::abs(v + 1) < std::abs(v)) ++v;
    } else if (std::abs(x0 + (v - 1) * d - x) < c) --v;
    else if (std::abs(x0 + (v - 1) * d - x) == c) {
        if (std::abs(v - 1) < std::abs(v)) --v;
    }
    return v;
}

__int128 ans_for_pk(ll p, ll k) {
    return (x0 + __int128(k) * d - targets[0]) + __int128(std::abs(k)) * p;
}

ll ans_for_p(ll p) {
    ll l = 0, r = 1e9;
    while (r - l >= 3) {
        ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        auto a1 = ans_for_pk(p, m1);
        auto a2 = ans_for_pk(p, m2);
        if (a1 > a2) l = m1;
        else r = m2;
    }
    __int128 ans = ans_for_pk(p, l);
    for (ll i = l + 1; i <= r; ++i) ans = std::min(ans, ans_for_pk(p, i));
    return ans;
}

void solve() {
    cin >> n;
    for (ll i = 0; i < n; ++i) cin >> targets[i];
    sort(targets, targets + n);
    // ll target = targets[0];
    sq_pf[0] = 0;
    for (ll i = 0; i < n; ++i) sq_pf[i + 1] = sq_pf[i] + 1ll * targets[i] * targets[i];
    for (ll i = 0; i < n; ++i) pf[i + 1] = pf[i] + targets[i];
    cin >> x0 >> d;
    for (ll i = 0; i < n; ++i) nearest_k[i] = get_near_k(targets[i]);
    for (ll i = 0; i < n; ++i)
        near_k_power[i] = 1ll * (targets[i] - (x0 + nearest_k[i] * d))
                          * (targets[i] - (x0 + nearest_k[i] * d));
    for (ll i = 0; i < n; ++i) nkp_pf[i + 1] = nkp_pf[i] + near_k_power[i];
    ll m;
    cin >> m;
    for (ll _ = 0; _ < m; ++_) {
        ll p;
        cin >> p;
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    ll t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
    cin >> t;
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    while (t--) solve();
    return 0;
}
