// #pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

constexpr ll maxn = 5e5 + 10;

int n, d;
vector<int> g[maxn];
int dp[maxn][2];
int connected[maxn];
bool used[maxn];
vector<pair<int, int> > ans;

void dfs1(int v, int p = -1) {
    dp[v][0] = dp[v][1] = 0;
    for (auto u: g[v]) {
        if (p == u) continue;
        dfs1(u, v);
        dp[v][0] += dp[u][1];
    }
    dp[v][1] = dp[v][0];
    for (auto u: g[v]) {
        if (p == u) continue;
        if (dp[u][0] + 1 > dp[u][1]) {
            dp[v][1] += dp[u][0] + 1 - dp[u][1];
            connected[v] = u;
            break;
        }
    }
}

void dfs2(int v, int p = -1) {
    if (dp[v][1] > dp[v][0] && !used[v]) {
        ans.emplace_back(v, connected[v]);
        used[v] = used[connected[v]] = true;
    }
    for (auto u: g[v]) {
        if (p == u) continue;
        dfs2(u, v);
    }
}

void solve() {
    cin >> n >> d;
    for (int i = 1, u, v; i < n; ++i) {
        cin >> u >> v, --u, --v;
        g[u].push_back(v), g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) connected[i] = -1;
    dfs1(0);
    dfs2(0);
    cout << ans.size() << "\n";
    for (auto [v,u]: ans) cout << v + 1 << " " << u + 1 << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    ll t = 1;
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
    cin >> t;
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    while (t--) solve();
    return 0;
}
