#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
template<typename T>
using ve = vector<T>;
using vii = vector<pair<int, int>>;
const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

int reps = 1;

struct SegTree {
        int maxn;
        vii st;
        vi sp;

        SegTree() {}
        SegTree(int n) : maxn(n) {
                st.resize(4 * maxn);
                sp.resize(4 * maxn, -1);
        }

        void push(int v, int l, int r, int mid) {
                if (sp[v] == -1) return;
                st[2 * v + 1] = {(mid - l) * sp[v], sp[v]};
                st[2 * v + 2] = {(r - mid) * sp[v], sp[v]};
                sp[2 * v + 1] = sp[v];
                sp[2 * v + 2] = sp[v];
                sp[v] = -1;
        }

        void update(int ql, int qr, int x, int v, int l, int r) {
                if (qr <= l || r <= ql) return;
                if (ql <= l && r <= qr) {
                        st[v] = {(r - l) * x, x};
                        sp[v] = x;
                        return;
                }
                int mid = (r + l) / 2;
                push(v, l, r, mid);
                update(ql, qr, x ,2  * v + 1, l, mid);
                update(ql, qr, x, 2 * v + 2, mid, r);
                st[v] = {st[2 * v + 1].first + st[2 * v + 2].first, min(st[2 * v + 1].second, st[2 * v + 2].second)};
        }


        struct Var {
                int v, l, r;
                Var() {}
                Var(int a, int b, int c) : v(a), l(b), r(c) {}
        };
        ve<Var> path;

        void find(int ql, int qr, int v, int l, int r) {
                if (qr <= l || r <= ql) return;
                if (ql <= l && r <= qr) {
                        path.push_back(Var(v, l, r));
                        return;
                }
                int mid = (r + l) / 2;
                find(ql, qr, 2 * v + 1, l, mid);
                find(ql, qr, 2 * v + 2, mid, r);
        }

        int getl(int x, int ind) {
                path.clear();
                find(0, ind, 0, 0, maxn);
                reverse(all(path));
                for (const auto &el : path) {
                        if (st[el.v].second <= x) {
                                int l = el.l, r = el.r, v = el.v;
                                while (r - l > 1) {
                                        int mid = (r + l) / 2;
                                        if (st[2 * v + 2].second <= x) {
                                                l = mid;
                                                v = 2 * v + 2;
                                        } else {
                                                r = mid;
                                                v = 2 * v + 1;
                                        }
                                }
                                return l;
                        }
                }
                return -1;
        }
};

void solve() {
        int h, w; cin >> h >> w;
        ve<string> a(h);
        for (int i = 0; i < h; i++) {
                cin >> a[i];
        }
        ve<vii> segs(h);
        for (int i = 0; i < h; i++) {
                int l = 0;
                for (int r = 0; r < w; r++) {
                        if (a[i][r] == '0') {
                                if (r - l > 0) segs[i].emplace_back(l, r - 1); 
                                l = r + 1;
                        }
                }
                if (w - l > 0) segs[i].emplace_back(l, w - 1);
        }

        int ans = 0;
        for (int i = 0; i < w; i++) {
                // int l = 0;
                SegTree tree(h);
                // cout << i << ": ";
                for (int r = 0; r < h; r++) {
                        if (a[r][i] == '0') {
                                // l = r + 1;
                                ans = max(ans, tree.st[0].first);
                                tree.update(0, h, 0, 0, 0, h);
                        } else {
                                int tl = 0, tr = segs[r].size();
                                while (tr - tl > 1) {
                                        int mid = (tr + tl) / 2;
                                        if (segs[r][mid].first <= i) tl = mid;
                                        else tr = mid;
                                }
                                // cout << i << ' ' << r << ": " << segs[r][tl].first << ' '<< segs[r][tl].second << '\n';
                                ans = max(ans, tree.st[0].first);
                                int kr = segs[r][tl].second;
                                int ind = tree.getl(kr - i + 1, r);
                                // cout << "(" << ind << ' ' << kr - i + 1 << ") ";
                                tree.update(ind + 1, r + 1, kr - i + 1, 0, 0, h);
                        }
                        // cout << i << ' ' << r << ' ' << ans << '\n';
                }
                // cout << '\n';
                ans = max(ans, tree.st[0].first);
                // cout << i << ' ' << ans << '\n';
        }
        cout << ans << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL 
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                solve();
        }

        return 0;
}
