#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using vii = vector<pair<int, int>>;
template<typename T>
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

int reps = 1;

struct Var {
        int l, m, r;
};

struct FenwickTree {
        int maxn;
        vi ft;

        FenwickTree(int n) : maxn(n) {
                ft.resize(maxn);
        }

        void update(int i, int x) {
                for (; i < maxn; i |= (i + 1)) ft[i] += x;
        }

        int get(int ql, int qr) {
                return get(qr - 1) - get(ql - 1);
        }

        int get(int r) {
                int res = 0;
                for (; r >= 0; r = (r & (r + 1)) - 1) res += ft[r];
                return res;
        }
};

int getCoord(vi& nums, int x) {
        return lower_bound(all(nums), x) - nums.begin();
}

void solve() {
        int n, k; cin >> n >> k;
        ve<Var> a(k);
        for (int i = 0; i < k; i++) {
                cin >> a[i].l >> a[i].m >> a[i].r;
        }
        vi nums;
        for (int i = 0; i < k; i++) {
                nums.push_back(a[i].m);
                nums.push_back(a[i].r);
                // nums.push_back(a[i].l);
        }
        nums.push_back(0);
        sort(all(nums));
        nums.resize(unique(all(nums)) - nums.begin());
        int m = nums.size();
        ve<vi> els(m + 1);
        for (int i = 0; i < k; i++) {
                els[getCoord(nums, a[i].r)].push_back(i);
        }
        ve<vi> dp(m + 1, vi(m + 1));
        dp[0][0] = true;
        ve<vi> j_k(m + 1);
        j_k[0].push_back(0);
        for (int i = 1; i <= m; i++) {
                for (const auto ind : els[i]) {
                        int c1 = getCoord(nums, a[ind].m);
                        if (dp[i][c1]) continue;
                        j_k[i].push_back(c1);
                        // cout << i << ' ' << c1 << '\n';
                        // cout << j_k[1].size() << '\n';
                        for (int j = c1; j < i; j++) {
                                for (int ind2 = 0; ind2 < (int)j_k[j].size(); ind2++) {
                                        if (nums[j_k[j][ind2]] >= a[ind].l) break;
                                        dp[i][c1] |= dp[j][j_k[j][ind2]];
                                }
                                // for (int k = 0; k < a[ind].l; k++) {
                                //         dp[i][a[ind].m] |= dp[j][k];
                                // }
                        }
                        for (int j = getCoord(nums, a[ind].l - 1); j < c1; j++) {
                                // cout << i << ' ' << j << '\n';
                                for (int ind2 = 0; ind2 < (int)j_k[j].size(); ind2++) {
                                       dp[i][c1] |= dp[j][j_k[j][ind2]];
                                }
                        }
                }
        }
        // cout << dp[1][1] << '\n';
        // cerr << j_k[1].size() << '\n';
        // cout << j_k[1][0] << '\n';
        // for (auto el : nums) cout << el << ' ';
        // cout << '\n';
        if (nums[m - 1] != n) {
                cout << "NO\n";
                return;
        }
        bool f = false;
        for (int i = 0; i <= m; i++) {
                f |= dp[m - 1][i];
        }
        (f) ? cout << "YES\n" : cout << "NO\n";
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL 
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        #endif
        cin >> reps;

        for (int i = 1; i <= reps; i++) {
                solve();
        }

        return 0;
}
