#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#ifdef LOCAL:
#define deb(x) cout << #x << " = " << x << '\n';
#else:
#define deb(x) 52;
#endif
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> l(k), m(k), r(k);
    for (ll i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<ll> p(k);
    for (ll i = 0; i < k; ++i) {
        p[i] = i;
    }
    do {
        vector<bool> dp(n + 1);
        dp[0] = true;
        for (ll ii = 0; ii < k; ++ii) {
            ll i = p[ii];
            bool f = false;
            for (ll j = l[i] - 1; j < m[i]; ++j) {
                f = f || dp[j];
            }
            dp[r[i]] = dp[r[i]] || f;
        }
        if (dp[n]) {
            cout << "YES";
            return;
        }
        dp.assign(n + 2, false);
        dp[n + 1] = true;
        for (ll ii = 0; ii < k; ++ii) {
            ll i = p[ii];
            bool f = false;
            for (ll j = r[i] + 1; j > m[i]; --j) {
                f = f || dp[j];
            }
            dp[l[i]] = dp[l[i]] || f;
        }
        if (dp[1]) {
            cout << "YES";
            return;
        }
    } while (next_permutation(all(p)));
    cout << "NO";
}


ll n, k;
vector<ll> l, m, r;


bool smart() {
    vector<ll> p(k);
    for (ll i = 0; i < k; ++i) {
        p[i] = i;
    }
    do {
        vector<bool> dp(n + 1);
        dp[0] = true;
        for (ll ii = 0; ii < k; ++ii) {
            ll i = p[ii];
            bool f = false;
            for (ll j = l[i] - 1; j < m[i]; ++j) {
                f = f || dp[j];
            }
            dp[r[i]] = dp[r[i]] || f;
        }
        if (dp[n]) {
            return true;
        }
    } while (next_permutation(all(p)));
    return false;
}


bool stupid() {
    vector<ll> p(k);
    for (ll i = 0; i < k; ++i) {
        p[i] = i;
    }
    do {
        vector<bool> used(n + 1);
        for (ll i : p) {
            if (!used[m[i]]) {
                for (ll j = l[i]; j <= r[i]; ++j) {
                    used[j] = true;
                }
            }
        }
        bool f = true;
        for (ll i = 1; i <= n; ++i) {
            f = f && used[i];
        }
        if (f) {
            return true;
        }
    } while (next_permutation(all(p)));
    return false;
}


mt19937 gen(52);


void gen_test() {
    n = 7;
    k = 3;
    l.assign(k, 0);
    r.assign(k, 0);
    m.assign(k, 0);
    for (ll i = 0; i < k; ++i) {
        l[i] = gen() % n + 1;
        r[i] = gen() % n + 1;
        if (l[i] > r[i]) {
            swap(l[i], r[i]);
        }
        m[i] = l[i] + gen() % (r[i] - l[i] + 1);
    }
}


void stress() {
    while (true) {
        gen_test();
        ll sm = smart(), st = stupid();
        if (sm != st) {
            cout << n << ' ' << k << '\n';
            for (ll i = 0; i < k; ++i) {
                cout << l[i] << ' ' << m[i] << ' ' << r[i] << '\n';
            }
            cout << "-------\n";
            cout << "smart: " << sm;
            cout << "\nstupid: " << st;
            return;
        }
    }
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 1;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    //stress();
    //return 0;
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}