#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

typedef tree<pdd, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct STB {
    struct Node {
        dgt max, cnt_max, second_max;
        dgt sum;
        dgt p;
    };

    Node DEFAULT = {0, 0, -INF, 0, INF};

    vector<Node> tree;
    dgt size;

    STB(dgt n) {
        build(n);
    }

    void build(dgt n) {
        for (size = 1; size < n; size *= 2);
        tree.assign(2 * size - 1, DEFAULT);
    }

    void _push(dgt v, dgt l, dgt r) {
        if (l + 1 < r && tree[v].p != DEFAULT.p) {
            for (dgt i = 1; i <= 2; ++i) {
                if (tree[v].p >= tree[2 * v + i].max)
                    continue;
                tree[2 * v + i].sum -= (tree[2 * v + i].max - tree[v].p) * tree[2 * v + i].cnt_max;
                tree[2 * v + i].p = tree[v].p;
            }
            tree[v].p = DEFAULT.p;
        }
    }

    Node _merge(Node a, Node b) {
        Node res = DEFAULT;
        res.sum = a.sum + b.sum;
        if (a.max > b.max) {
            res.max = a.max;
            res.cnt_max = a.cnt_max;
            res.second_max = max(a.second_max, b.max);
        } else if (a.max < b.max) {
            res.max = b.max;
            res.cnt_max = b.cnt_max;
            res.second_max = max(b.second_max, a.max);
        } else {
            res.max = a.max;
            res.cnt_max = a.cnt_max + b.cnt_max;
            res.second_max = max(a.second_max, b.second_max);
        }
        return res;
    }

    void _minx(dgt v, dgt l, dgt r, dgt ql, dgt qr, dgt x) {
        if (qr <= l || ql >= r || x >= tree[v].max)
            return;
        if (ql <= l && qr >= r && x > tree[v].second_max) {
            tree[v].sum -= (tree[v].max - x) * tree[v].cnt_max;
            tree[v].max = x;
            tree[v].p = x;
            return;
        }
        dgt m = (l + r) / 2;
        _push(v, l, r);
        _minx(2 * v + 1, l, m, ql, qr, x);
        _minx(2 * v + 2, m, r, ql, qr, x);
        tree[v] = _merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void minx(dgt ql, dgt qr, dgt x) {
        return _minx(0, 0, size, ql, qr, x);
    }

    void _set(dgt v, dgt l, dgt r, dgt pos, dgt x) {
        if (l + 1 == r) {
            tree[v].second_max = DEFAULT.second_max;
            tree[v].max = tree[v].sum = x;
            tree[v].cnt_max = 1;
            return;
        }
        dgt m = (l + r) / 2;
        _push(v, l, r);
        if (pos < m)
            _set(2 * v + 1, l, m, pos, x);
        else
            _set(2 * v + 2, m, r, pos, x);
        tree[v] = _merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void set(dgt pos, dgt x) {
        return _set(0, 0, size, pos, x);
    }

    dgt sum() {
        return tree[0].sum;
    }
};

void solve() {
    dgt h, w;
    cin >> h >> w;
    vector<string> field(h);
    for (dgt i = 0; i < h; ++i)
        cin >> field[i];
    vector<vector<dgt>> cnt(h, vector<dgt>(w, 0));
    for (dgt i = 0; i < h; ++i) {
        for (dgt j = 0; j < w; ++j) {
            if (i == 0) {
                cnt[i][j] = (field[i][j] == '1');
            } else {
                if (field[i][j] == '0') {
                    cnt[i][j] = 0;
                } else {
                    cnt[i][j] = cnt[i - 1][j] + 1;
                }
            }
        }
    }
    STB sg(w);
    dgt ans = 0;
    for (dgt i = 0; i < h; ++i) {
        sg.build(w);
        for (dgt j = w - 1; j >= 0; --j) {
            sg.set(j, cnt[i][j]);
            sg.minx(0, w, cnt[i][j]);
            ans = max(ans, sg.sum());
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " =======================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===========================\n";
#endif
    }

    return 0;
}