// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

typedef tree<pdd, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<dgt>> g;
vector<dgt> dp0, dp1;
vector<dgt> f0, f1;
vector<pdd> res;

void dfs(dgt v, dgt pr = -1) {
    for (dgt u: g[v]) {
        if (u == pr)
            continue;
        dfs(u, v);
        if (dp0[v] < dp0[u]) {
            dp0[v] = dp0[u];
            f0[v] = u;
        }
        if (dp0[v] < dp1[u]) {
            dp0[v] = dp1[u];
            f0[v] = u;
        }
        if (dp1[v] < dp0[u]) {
            dp1[v] = dp0[u] + 1;
            f1[v] = u;
        }
    }
}

void dfs2(dgt v, bool flag, dgt pr = -1) {
    if (v == -1)
        return;
    if (dp0[v] >= dp1[v] || (!flag)) {
        dfs2(f0[v], true, v);
        for (dgt u: g[v]) {
            if (u == pr || u == f0[v])
                continue;
            dfs2(u, true, v);
        }
    } else {
        res.emplace_back(v, f1[v]);
        dfs2(f1[v], false, v);
        for (dgt u: g[v]) {
            if (u == pr || u == f1[v])
                continue;
            dfs2(u, true, v);
        }
    }
}

void solve() {
    dgt n, d;
    cin >> n >> d;
    g.clear();
    g.resize(n);
    for (dgt i = 1; i < n; ++i) {
        dgt u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp0.assign(n, 0);
    dp1.assign(n, 0);
    f0.assign(n, -1);
    f1.assign(n, -1);
    dfs(0);
    cout << max(dp0[0], dp1[0]) << '\n';
    res.clear();
    dfs2(0, true);
    for (auto [u, v]: res) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " =======================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===========================\n";
#endif
    }

    return 0;
}