#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

typedef tree<pdd, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<dgt>> g;
vector<dgt> h;
vector<dgt> mt;

void dfs(dgt v, dgt pr = -1) {
    for (dgt u: g[v]) {
        if (u == pr)
            continue;
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

vector<dgt> used;
dgt tmi;

bool dfs2(dgt v) {
    if (used[v] == tmi)
        return false;
    used[v] = tmi;
    for (dgt u: g[v]) {
        if (mt[u] == -1 || dfs2(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    dgt n, d;
    cin >> n >> d;
    g.clear();
    g.resize(n);
    for (dgt i = 1; i < n; ++i) {
        dgt u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    h.assign(n, 0);
    dfs(0);
    unordered_map<dgt, dgt> dist;
    unordered_set<dgt> st;

    vector<dgt> buf;
    for (dgt i = 0; i < n; ++i) {
        dist.clear();
        st.clear();
        buf.clear();
        dist[i] = 0;
        queue<dgt> qu;
        qu.push(i);
        while (qu.size()) {
            dgt v = qu.front();
            if (dist[v] >= d)
                break;
            qu.pop();
            for (dgt u: g[v]) {
                if (dist.count(u) == 0 || dist[u] > dist[v] + 1) {
                    dist[u] = dist[v] + 1;
                    if (dist[u] == 3) {
                        buf.push_back(u);
                    }
                    qu.push(u);
                }
            }
        }
        for (dgt u: buf)
            g[i].push_back(u);
    }
    mt.assign(n, -1);
    tmi = 0;
    used.assign(n, -1);
    for (dgt i = 0; i < n; ++i) {
        if ((h[i] & 1)) {
            tmi += dfs2(i);
        }
    }
    cout << tmi << '\n';
    for (dgt i = 0; i < n; ++i) {
        if (mt[i] == -1)
            continue;
        cout << i + 1 << ' ' << mt[i] + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " =======================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===========================\n";
#endif
    }

    return 0;
}