#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double

int h, w;

struct node {
    int val;
    int mn;
    int mx;
    int p;
};

struct tree {
    int n;
    vector<node> t;
    tree (int N) : n(N) {
        t.resize(4 * n, {0, 0});
    }
    node merge(node a, node b) {
        return {a.val + b.val, 0};
    }
    void push(int v, int l, int r) {
        if (t[v].p != 0 && r - l > 1) {
            int p = t[v].p;
            int m = (r + l)/2;
            t[2 * v + 1] = {p * (m - l), p};
            t[2 * v + 2] = {p * (r - m), p};
            t[v].p = 0;
        }
    }
    void upd(int v, int l, int r, int ql, int qr, int x) {
        if (ql <= l && r <= qr) {
            t[v] = {x * (r - l), min(x, t[v].p)};
            return;
        }
        if (r <= ql || qr <= l) {
            return;
        }
        push(v, l, r);
        int m = (r + l)/2;
        upd(2 * v + 1, l, m, ql, qr, x);
        upd(2 * v + 2, m, r, ql, qr, x);
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }
    node get_sum(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return t[v];
        }
        if (r <= ql || qr <= l) {
            return {0, 0};
        }
        push(v, l, r);
        int m = (r + l)/2;
        return (merge(get_sum(2 * v + 1, l, m, ql, qr), get_sum(2 * v + 2, m, r, ql, qr)));
    }
    node get_one(int v, int l, int r, int pos) {
        if (r - l == 1) {
            return t[v];
        }
        push(v, l, r);
        int m = (r + l)/2;
        if (pos < m) return get_one(2 * v + 1, l, m, pos);
        else return get_one(2 * v + 2, m, r, pos);
    }
};

vector<vector<char>> v;


void solve() {
    cin >> h >> w;
    v.resize(h, vector<char>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> v[i][j];
        }
    }

    vector<vector<int>> dp(h, vector<int>(w));

    for (int i = 0; i < h; ++i) {
        for (int j = w-1; j >= 0; --j) {
            if (v[i][j] == '1') {
                dp[i][j] = 1;
                if (j < w-1) dp[i][j] += dp[i][j+1];
            }
            //cout << dp[i][j] << ' ';
        }
        //cout << '\n';
    }

    int ans = 0;
    for (int j = 0; j < w; ++j) {
        tree t(h);
        for (int i = 0; i < h; ++i) {

            int l = -1, r = i, m;
            while (r - l > 1) {
                m = ((r + l)>>1);
                if (t.get_one(0, 0, h, m).val > dp[i][j]) r = m;
                else l = m;
            }

            t.upd(0, 0, h, r, i + 1, dp[i][j]);

            //cout << r << ' ' << i + 1 << ' ' << dp[i][j] << '\n';
            ans = max(ans, t.get_sum(0, 0, h, 0, i + 1).val);
        }
    }
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int ttt = 1;
    // cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
