#include <bits/stdc++.h>

using namespace std;
#define int long long

struct SegTree {
    vector<int> t;
    int sz = 1;

    SegTree(int n) {
        while (sz <= n) sz *= 2;
        t.resize(sz * 2, -(int) 1e18);
    }

    void update(int i, int val) {
        i += sz, t[i] = max(t[i], val), i /= 2;
        while (i > 0) {
            t[i] = max(t[i * 2], t[i * 2 + 1]);
            i /= 2;
        }
    }

    int get_max(int l, int r) {
        int res = -(int) 1e18;
        for (l += sz, r += sz; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1)
                res = max(res, t[l++]);
            if (r % 2 == 0)
                res = max(res, t[r--]);
        }
        return res;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<pair<int, int>, int> > seg(k);
    for (int i = 0; i < k; i++)
        cin >> seg[i].first.first >> seg[i].second >> seg[i].first.second;
    SegTree T(k), S(k);
    sort(seg.begin(), seg.end());
    int l[k], m[k], r[k];
    for (int i = 0; i < k; i++) {
        l[i] = seg[i].first.first - 1, r[i] = seg[i].first.second - 1;
        m[i] = seg[i].second - 1;
    }
    auto find1 = [&](int x) {
        int L = 0, R = k - 1;
        while (R - L > 1) {
            int mid = (L + R) / 2;
            if (l[mid] >= x)
                R = mid;
            else
                L = mid;
        }
        return (l[L] >= x ? L : (l[R] >= x ? R : -1));
    };
    auto find2 = [&](int x) {
        int L = 0, R = k - 1;
        while (R - L > 1) {
            int mid = (L + R) / 2;
            if (l[mid] <= x) L = mid;
            else R = mid;
        }
        return (l[R] <= x ? R : (l[L] <= x ? L : -1));
    };
    bool dp[k];
    for (int i = 0; i < k; i++) dp[i] = false;
    for (int i = k - 1; i >= 0; i--) {
        if (r[i] == n - 1)
            dp[i] = true;
        int a = find1(l[i] + 1), b = find2(r[i] + 1);
        if (a != -1 && b != -1 && a <= b) {
            if (T.get_max(a, b) > r[i])
                dp[i] = true;
        }
        a = find1(m[i] + 1), b = find2(r[i] + 1);
        if (a != -1 && b != -1 && a <= b) {
            if (S.get_max(a, b) > r[i])
                dp[i] = true;
        }
        if (dp[i])
            T.update(i, m[i]), S.update(i, r[i]);
    }
    for (int i = 0; i < k; i++) {
        if (l[i] == 0 && dp[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}