#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
using namespace std;

int n, k;

struct Node{
    Node* l;
    Node* r;
    int s;
};

Node* build(int lx, int rx) {
    Node* v = new Node();
    v->s = 0;
    if (rx - lx == 1) {
        return v;
    }
    int mid = (lx + rx) / 2;
    v->l = build(lx, mid);
    v->r = build(mid, rx);
    return v;
}

Node* upd(Node* v, int i, int lx, int rx) {
    Node* u = new Node();
    u->l = v->l;
    u->r = v->r;
    u->s = v->s;
    if (rx - lx == 1) {
        u->s++;
        return u;
    }
    int mid = (lx + rx) / 2;
    if (i < mid) u->l = upd(v->l, i, lx, mid);
    else u->r = upd(v->r, i, mid, rx);
    u->s = u->l->s + u->r->s;
    return u;
}

Node* upd(Node* v, int i) {
    return upd(v, i, 0, n + 1);
}

int get(Node* v, int l, int r, int lx, int rx) {
    if (l >= rx || lx >= r) return 0;
    if (l <= lx && rx <= r) return v->s;
    int mid = (lx + rx) / 2;
    return get(v->l, l, r, lx, mid) + get(v->r, l, r, mid, rx);
}

int get(Node* v, int l, int r) {
    return get(v, l, r, 0, n + 1);
}

struct Ft2{
    int sz;
    vector<int> t;

    void init() {
        t.assign(n + 1, 0);
    }

    void upd(int i) {
        for (; i <= n; i += (i&(-i))) {
            t[i]++;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i > 0; i -= (i&(-i))) {
            res += t[i];
        }
        return res;
    }
};

void solve() {
    cin >> n >> k;
    vector<array<int, 3>> a;
    a.push_back({0, 0, 0});
    for (int i = 0; i < k; i++) {
        int l, r, m;
        cin >> l >> m >> r;
        a.push_back({m, l, r});
    }
    sort(a.begin(), a.end());
    Ft2 f2;
    f2.init();
    vector<Node*> st(k + 1);
    st[0] = build(0, n + 1);
    for (int i = 1; i <= k; i++) {
        st[i] = st[i - 1];
        int m = a[i][0], l = a[i][1], r = a[i][2], flag = 0;
        if (l == 1) flag = 1;
        else if (f2.get(m - 1) - f2.get(l - 2) != 0) flag = 1;
        else {
            int lx = 0, rx = i;
            while (rx - lx > 1) {
                int mid = (lx + rx) / 2;
                if (a[mid][0] <= l - 1) lx = mid;
                else rx = mid;
            }
            if (get(st[lx], l - 1, r) != 0) flag = 1;
        }
        if (flag) {
            st[i] = upd(st[i], r);
            f2.upd(r);
        }
        if (r == n && flag) {
            cout << "YES";
            return;
        }
    }
    cout << "NO";
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
