#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
using namespace std;

struct Ft{
    int sz;
    vector<unordered_map<int, int>> t;

    void init(int n) {
        sz = n;
        t.assign(n + 1, {});
    }

    void upd(int i, int j) {
        for (int i2 = i; i2 <= sz; i2 += (i2&(-i2))) {
            for (int j2 = j; j2 <= sz; j2 += (j2&(-j2))) {
                t[i2][j2]++;
            }
        }
    }

    int get(int i, int j) {
        int res = 0;
        for (int i2 = i; i2 > 0; i2 -= (i2&(-i2))) {
            for (int j2 = j; j2 > 0; j2 -= (j2&(-j2))) {
                res += t[i2][j2];
            }
        }
        return res;
    }
};

struct Ft2{
    int sz;
    vector<int> t;

    void init(int n) {
        sz = n;
        t.assign(n + 1, 0);
    }

    void upd(int i) {
        for (; i <= sz; i += (i&(-i))) {
            t[i]++;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i > 0; i -= (i&(-i))) {
            res += t[i];
        }
        return res;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a;
    for (int i = 0; i < k; i++) {
        int l, r, m;
        cin >> l >> m >> r;
        a.push_back({m, l, r});
    }
    sort(a.begin(), a.end());
    vector<int> dp(k);
    Ft f1;
    Ft2 f2;
    f1.init(n);
    f2.init(n);
    for (int i = 0; i < k; i++) {
        int m = a[i][0], l = a[i][1], r = a[i][2], flag = 0;
        if (l == 1) flag = 1;

        if (f1.get(l - 1, r - 1) - f1.get(l - 1, l - 2) != 0) flag = 1;
        if (f2.get(m - 1) - f2.get(l - 2) != 0) flag = 1;

        if (flag) {
            f1.upd(m, r);
            f2.upd(r);
        }
        if (r == n && flag) {
            cout << "YES";
            return;
        }
    }
    cout << "NO";
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
