#include <bits/stdc++.h>

using namespace std;

vector<vector<bool>> a;
vector<vector<int>> otr;

#define ALL(x) x.begin(), x.end()

struct segmentTree
{
    vector<int> t;
    int sz = 0;
    segmentTree(int n)
    {
        sz = n;
        t.resize(n * 4, 0);
    }
    void change(int v, int l, int r, int pos, int x)
    {
        if (pos < l || pos >= r)
        {
            return;
        }
        if (r - l == 1 && pos == l)
        {
            t[v] = x;
            return;
        }
        int m = (l + r) / 2;
        change(v * 2, l, m, pos, x);
        change(v * 2 + 1, m, r, pos, x);
        t[v] = max(t[v * 2], t[v * 2 + 1]);

    }
    void change(int pos, int x)
    {
        change(1, 0, sz, pos, x);
    }

    int get(int v, int l, int r, int L, int R)
    {
        if (r <= L || R <= l)
        {
            return 0;
        }
        if (L <= l && r <= R)
        {
            return t[v];
        }
        int m = (l + r) / 2;
        return max(get(v * 2, l, m, L, R), get(v * 2 + 1, m, r, L, R));
    }
    int get(int l, int r)
    {
        return get(1, 0, sz, l, r);
    }
};

void solve()
{
    int h, w;
    cin >> h >> w;
    int ans = 0;
    a.resize(h, {});
    otr.resize(h, {});
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < w; j++)
        {
            char x;
            cin >> x;
            a[i].push_back(x == '1');
        }
    }
    for (int i = 0; i < h; i++)
    {
        int left = w - 1;
        bool ed = 0;
        otr[i].resize(w, 0);

        for (int j = w - 1; j >= 0; j--)
        {
            if (a[i][j] == 0)
            {
                ed = 0;
            }
            else
            {
                if (ed)
                {
                    otr[i][j] = left - j + 1;
                }
                else
                {
                    ed = 1;
                    left = j;
                    otr[i][j] = 1;
                }
            }
        }
    }
    for (int j = 0; j < w; j++)
    {
        vector<int> v;
        segmentTree st(w - j + 1);
        v.push_back(0);
        for (int i = 0; i < h; i++)
        {
            auto gh = st.get(0, otr[i][j] + 1);
            int now = v[gh] + (i - gh + 1) * otr[i][j];
            ans = max(ans, now);
            v.push_back(now);
            st.change(otr[i][j], i + 1);

        }
    }
    cout << ans;
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}