#include <bits/stdc++.h>

using namespace std;

vector<vector<bool>> a;
vector<vector<int>> otr;
vector<vector<int>> bliz;


#define ALL(x) x.begin(), x.end()

const int INF = 1e9 + 7;

struct segmentTree
{
    vector<int> t;
    int sz = 0;
    segmentTree(int n)
    {
        sz = n;
        t.resize(n * 4, INF);
    }
    void change(int v, int l, int r, int pos, int x)
    {
        if (pos < l || pos >= r)
        {
            return;
        }
        if (r - l == 1 && pos == l)
        {
            t[v] = min(x, t[v]);
            return;
        }
        int m = (l + r) / 2;
        change(v * 2, l, m, pos, x);
        change(v * 2 + 1, m, r, pos, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]);

    }
    void change(int pos, int x)
    {
        change(1, 0, sz, pos, x);
    }

    int get(int v, int l, int r, int L, int R)
    {
        if (r <= L || R <= l)
        {
            return INF;
        }
        if (L <= l && r <= R)
        {
            return t[v];
        }
        int m = (l + r) / 2;
        return min(get(v * 2, l, m, L, R), get(v * 2 + 1, m, r, L, R));
    }
    int get(int l, int r)
    {
        return get(1, 0, sz, l, r);
    }
};

struct Node
{
    int l, m, r;
    Node(int a, int b, int c)
    {
        l = a;
        m = b;
        r = c;
    }

};

bool cmp(Node a, Node b)
{
    if (a.l != b.l)
    {
        return a.l < b.l;
    }
    return a.r < b.r;
}

void solve()
{
    int n, k;
    cin >> n >> k;
    vector<Node> a;
    for (int i = 0; i < k; i++)
    {
        int l, m, r;
        cin >> l >> m >> r;
        a.emplace_back(l, m, r);
    }
    sort(ALL(a), cmp);
    segmentTree st(n + 1);
    st.change(0, 0);
    for (auto [l, m, r] : a)
    {
        if (st.get(l - 1, m) <= r)
        {
            st.change(r, m);
        }
        else if (st.get(l - 1, r + 1) < l)
        {
            st.change(r, m);
        }
    }
    if (st.get(n, n + 1) <= n)
    {
        cout << "YES\n";
    }
    else
    {
        cout << "NO\n";
    }
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}