#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,inline,unroll-loops")
#pragma GCC target("avx,avx2")
using namespace std;

vector<vector<bool>> a;
vector<vector<int>> otr;
vector<vector<int>> bliz;

//#define int long long
#define ALL(x) x.begin(), x.end()

const int INF = 1e9 + 7;

struct segmentTree
{
    vector<int> t;
    int sz = 0;
    segmentTree(int n)
    {
        sz = n;
        t.resize(n * 4, INF);
    }
    void change(int v, int l, int r, int pos, int x)
    {
        if (pos < l || pos >= r)
        {
            return;
        }
        if (r - l == 1 && pos == l)
        {
            t[v] = min(x, t[v]);
            return;
        }
        int m = (l + r) / 2;
        change(v * 2, l, m, pos, x);
        change(v * 2 + 1, m, r, pos, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]);

    }
    void change(int pos, int x)
    {
        change(1, 0, sz, pos, x);
    }

    int get(int v, int l, int r, int L, int R)
    {
        if (r <= L || R <= l)
        {
            return INF;
        }
        if (L <= l && r <= R)
        {
            return t[v];
        }
        int m = (l + r) / 2;
        return min(get(v * 2, l, m, L, R), get(v * 2 + 1, m, r, L, R));
    }
    int get(int l, int r)
    {
        return get(1, 0, sz, l, r);
    }
};

const int MAXN = 5e5 + 5;

int dp[MAXN][2];

int pp[MAXN];

vector<int> g[MAXN];

vector<int> g1[MAXN];

vector<int> c;
vector<int> c1;

void dfs1(int x, int p, int d = 0)
{
    if (d % 2 == 0)
    {
        c.push_back(x);
    }
    else
    {
        c1.push_back(x);
    }
    int sum = 0;
    int minD = 1;
    int soed = -1;
    for (auto i : g[x])
    {
        if (i == p)
        {
            continue;
        }
        dfs1(i, x, d + 1);
        sum += dp[i][1];
        if (dp[i][0] == dp[i][1])
        {
            minD = 0;
            soed = i;
        }
    }
    pp[x] = soed;
    dp[x][0] = sum;
    dp[x][1] = sum + 1 - minD;
}

int d;

void dfs(int x, int p, int deep, int ii)
{
    if (deep % 2 == 1 && deep <= d)
    {
        g1[ii].push_back(x);
    }
    if (deep >= d)
    {
        return;
    }
    for (auto i : g[x])
    {
        if (i == p)
        {
            continue;
        }
        dfs(i, x, deep + 1, ii);
    }
}

int used[MAXN];

int timer = 0;

int matched[MAXN];

bool kuhn(int x)
{
    if (used[x] == timer)
    {
        return false;
    }
    used[x] = timer;
    for (auto i : g1[x])
    {
        if (matched[i] == -1 || kuhn(matched[i]))
        {
            matched[i] = x;
            return true;
        }
    }
    return false;
}

void solve()
{
    int n;
    cin >> n;

    cin >> d;
    for (int i = 1; i < n; i++)
    {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs1(0, 0);
    for (int i = 0; i < n; i++)
    {
        dfs(i, i, 0, i);
    }
    fill(matched, matched + MAXN, -1);
    for (auto x : c)
    {
        for (auto i : g1[x])
        {
            if (matched[i] == -1)
            {
                matched[i] = x;
            }
        }
    }
    for (auto i : c)
    {
        if (used[i] == 0)
        {
            timer++;
            kuhn(i);
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < MAXN; i++)
    {
        if (matched[i] != -1)
        {
            ans.emplace_back(i, matched[i]);
        }
    }
    cout << ans.size() << '\n';
    for (auto [a, b] : ans)
    {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

int32_t main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}