#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <numeric>
#include <set>
#include <map>
#include <limits.h>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

ll stress(vector<vector<int>> a) {
	int n = a.size(), m = a[0].size();
	ll res = 0;
	for (auto& v : a) {
		for (int i = 0; i < m; i++) {
			ll cur = 0; int bef = INT_MAX;
			for (int j = i; j < m; j++) {
				bef = min(bef, v[j]);
				cur += bef;
			}
			res = max(cur, res);
		}
	}
	return res;
}

ll solve(vector<vector<int>> a) {
	ll res = 0;
	int n = a.size(), m = a[0].size();
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (a[i][j]) {
				a[i][j] += a[i - 1][j];
			}
		}
	}
	//return stress(a);
	for (int i = 0; i < n; i++) {
		ll cur_ans = 0;
		vector<pair<ll, ll>> stack; //{h, cnt}
		for (int x : a[i]) {
			ll cnt = 1;
			while (stack.size() && stack.back().first >= x) {
				cur_ans -= stack.back().first * stack.back().second;
				cnt += stack.back().second;
				stack.pop_back();
			}
			stack.push_back({ x, cnt });
			cur_ans += x * cnt;
			res = max(res, cur_ans);
		}
	}
	return res;
}

void rotate(vector<vector<int>>& a) {
	int n = a.size(), m = a[0].size();
	vector<vector<int>> b(m, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			b[j][i] = a[i][j];
		}
	}
	swap(a, b);
	for (auto& v : a) reverse(all(v));
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m; cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c; cin >> c;
			a[i][j] = c == '1';
		}
	}

	for (auto& v : a) reverse(all(v));
	cout << solve(a);

	return 0;
}