#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <numeric>
#include <set>
#include <map>
#include <array>
#include <limits.h>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

using seg = std::array<int, 3>;
bool in(seg& a, seg& b) {
	return a[1] >= b[0] && a[1] <= b[2];
}

bool bad(seg& a, seg& b) {
	return in(a, b) && in(b, a);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		int n, k; cin >> n >> k;
		vector<std::array<int, 3>> segs(k);
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < 3; j++) {
				cin >> segs[i][j];
				segs[i][j]--;
			}
		}

		segs.push_back( {-1, -1, -1} );
		segs.push_back({ n, n, n });
		sort(all(segs), [](std::array<int, 3> & l, std::array<int, 3> & r) {return l[1] < r[1]; });
		vector<bool> dp(k + 2);
		dp[0] = 1;
		k += 2;
		
		for (int i = 1; i < k; i++) {
			for (int j = i - 1; j < i; j++) {
				if (segs[j][2] >= segs[i][0] - 1 && !bad(segs[i], segs[j]) && dp[j] && segs[i][2] > segs[j][2]) {
					dp[i] = 1;
					break;
				}
			}
		}

		cout << (dp.back() ? "YES" : "NO") << '\n';
	}

	return 0;
}