#ifdef LOCAL
using int128 = long long;
#define I128MAX LLONG_MAX
#else
using int128 = __int128;
#define I128MAX LLONG_MAX;
#endif

#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <numeric>
#include <set>
#include <map>
#include <array>
#include <limits.h>

using namespace std;
using ll = int128;
using printable = long long;
#define all(a) (a).begin(), (a).end()

struct Node {
	vector<int> e;
	bool used = false;
};
vector<Node> graph;
vector<pair<int, int>> ans;

int dfs(int u, int bef) {
	if (bef != -1 && graph[u].e.size() == 1) return u;
	for (int to : graph[u].e) if (to != bef) {
		int x = dfs(to, u);
		if (x != -1 && !graph[u].used) {
			ans.push_back({ x, u });
			graph[u].used = 1;
		}
	}
	if (!graph[u].used) return u;
	return -1;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, d; cin >> n >> d;
	graph.assign(n, {});
	for (int i = 0; i < n - 1; i++) {
		int u, v; cin >> u >> v; u--; v--;
		graph[u].e.push_back(v);
		graph[v].e.push_back(u);
	}
	dfs(0, -1);
	cout << ans.size() << '\n';
	for (auto [x, y] : ans) {
		cout << x + 1 << ' ' << y + 1 << '\n';
	}

	return 0;
}