#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;


struct tree {
	int n;
	vector <int> T;
	
	tree(int n_) {
		n = n_;
		T.resize(4 * n, 0);
	}

	int get(int l, int r, int v, int lv, int rv) {
		if (l >= rv || r <= lv) {
			return 0;
		}
		if (l >= lv && r <= rv) {
			return T[v];
		}

		int m = (l + r) / 2;

		return get(l, m, v * 2 + 1, lv, rv) + get(m, r, v * 2 + 2, lv, rv);
	}

	bool get(int l, int r) {
		return get(0, n, 0, l, r) > 0;
	}

	void change(int l, int r, int v, int pos) {
		if (l > pos || r <= pos) {
			return;
		}
		if (r - l == 1) {
			T[v] = 1;
			return;
		}

		int m = (l + r) / 2;

		change(l, m, v * 2 + 1, pos);
		change(m, r, v * 2 + 2, pos);

		T[v] = T[v * 2 + 1] + T[v * 2 + 2];
	}

	void change(int pos) {
		change(0, n, 0, pos);
	}
};


struct Node {
	int l, r, m;

	//Node(int l, int r, int m) : l{ l }, r{ r }, m{ m }{}

	bool operator < (const Node& other) const {
		return m < other.m;
	}
};

void solve() {
	int n, k;
	cin >> n >> k;

	vector <Node> inp(k);
	for (int i = 0; i < k; i++) {
		cin >> inp[i].l >> inp[i].m >> inp[i].r;
	}

	sort(inp.begin(), inp.end());

	tree T(n + 1);
	T.change(0);

	for (int i = 0; i < k; i++) {
		if (T.get(inp[i].l - 1, inp[i].m)) {
			T.change(inp[i].r);
		}
	}

	cout << (T.get(n, n + 1) ? "YES" : "NO") << "\n";
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
