#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std;

#define int long long

vector <vector <int>> sp;
vector <int> Ans;
int cnt = 0;


void DFS(int v, int p) {
	if (sp[v].size() == 1) {
		if (Ans[p] == -1) {
			Ans[v] = p;
			Ans[p] = v;
			cnt++;
			return;
		}
	}

	for (auto t : sp[v]) {
		if (t != p) {
			DFS(t, v);

			if (Ans[t] == -1 && Ans[v] == -1) {
				Ans[t] = v;
				Ans[v] = t;
				cnt++;
			}
		}
	}
}


void solve() {
	int n, d;
	cin >> n >> d;

	sp.resize(n);
	Ans.resize(n, -1);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;

		sp[u - 1].push_back(v - 1);
		sp[v - 1].push_back(u - 1);
	}

	DFS(0, -1);

	cout << cnt << "\n";
	vector <int> used(n, 0);
	for (int i = 0; i < n; i++) {
		if (Ans[i] != -1 && !used[i]) {
			used[i] = 1, used[Ans[i]] = 1;

			cout << i + 1 << " " << Ans[i] + 1 << "\n";
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}
