#include <vector>
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std;

#define int long long

vector <vector <int>> sp;
vector <int> C;
vector <vector <int>> Ds;
vector <pair <int, int>> ans;
vector <int> Used;
int n, d;


void BFS() {
	queue <int> Q;
	Q.push(0);
	C[0] = 0;

	while (!Q.empty()) {
		int v = Q.front();
		Q.pop();
		for (auto t : sp[v]) {
			if (C[t] == -1) {
				C[t] = 1 - C[v];

				Q.push(t);
			}
		}
	}
}


void BFSv(int u) {
	vector <int> used(n, 0);
	queue <pair<int, int>> Q;
	Q.push({ u, 0 });
	used[u] = 1;

	while (!Q.empty()) {
		int v = Q.front().first, f = Q.front().second;
		Q.pop();

		for (auto t : sp[v]) {
			if (!used[t] && f < d) {
				Q.push({ t, f + 1 });
				used[t] = 1;

				if (C[t] != C[u]) {
					Ds[u].push_back(t);
				}
			}
		}
	}
}


void r(vector <pair<int, int>> &st) {
	if (st.size() > ans.size()) ans = st;
	if (n > 13 && ans.size() == (n / 2) - 1) return;
	if (ans.size() == (n / 2)) return;

	for (int i = 0; i < n; i++) {
		if (!Used[i]) {
			Used[i] = 1;

			for (auto t : Ds[i]) {
				if (!Used[t]) {
					Used[t] = 1;
					st.emplace_back(i + 1, t + 1);

					r(st);

					st.pop_back();
					Used[t] = 0;
				}
			}

			Used[i] = 0;
		}
	}
}


void solve() {
	cin >> n >> d;

	sp.resize(n);
	C.resize(n, -1);
	Ds.resize(n);
	Used.resize(n, 0);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;

		sp[u - 1].push_back(v - 1);
		sp[v - 1].push_back(u - 1);
	}

	BFS();


	for (int i = 0; i < n; i++) BFSv(i);

	vector <pair<int, int>> st;
	r(st);

	cout << ans.size() << "\n";
	for (auto t : ans) {
		cout << t.first << " " << t.second << "\n";
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}