#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define pomidor ios_base::sync_with_stdio(0);
#define pelmenyevich cin.tie(0);
#define ll long long

ll sqr(ll x) { return x * x; }

vector<ll> X;
vector<ll> xdr, xdl, rs, ls, pa, pb, pc, sa, sb, sc;

ll x0, d, fix;

ll calcr(int i, ll t) { return rs[i] + sa[i] * sqr(xdr[i]) + sb[i] * xdr[i] + sc[i] + t * ((xdr[i] - x0) / d); }
ll calcl(int i, ll t) { return ls[i] + pa[i] * sqr(xdl[i]) + pb[i] * xdl[i] + pc[i] + t * ((x0 - xdl[i]) / d); }

int findr(ll t) {
	int l = 0, r = xdr.size() - 1;
	ll vl = calcr(l, t), vr = calcr(r, t);
	while (r - l > 3) {
		int m = (l + r) >> 1;
		ll vm1 = calcr(m, t), vm2 = calcr(m + 1, t);
		if (vm1 > vm2) { l = m; vl = vm1; }
		else if (vm1 < vm2) { r = m + 1; vr = vm2; }
		else { l = m; r = m + 1; vl = vm1; vr = vm2; }
	}
	int b; ll vb;
	if (vl <= vr) { b = l; vb = vl; }
	else { b = r; vb = vr; }
	for (int i = l + 1; i < r; ++i) { ll vc = calcr(i, t); if (vc < vb) { b = i; vb = vc; } }
	return b;
}

int findl(ll t) {
	int l = 0, r = xdl.size() - 1;
	ll vl = calcl(l, t), vr = calcl(r, t);
	while (r - l > 3) {
		int m = (l + r) >> 1;
		ll vm1 = calcl(m, t), vm2 = calcl(m + 1, t);
		if (vm1 > vm2) { l = m; vl = vm1; }
		else if (vm1 < vm2) { r = m + 1; vr = vm2; }
		else { l = m; r = m + 1; vl = vm1; vr = vm2; }
	}
	int b; ll vb;
	if (vl <= vr) { b = l; vb = vl; }
	else { b = r; vb = vr; }
	for (int i = l + 1; i < r; ++i) { ll vc = calcl(i, t); if (vc < vb) { b = i; vb = vc; } }
	return b;
}

ll minr(ll t) {
	int ix = findr(t);
	// dx = 2ax + b + t
	// xmin = (-t - b) / 2a
	ll ans = calcr(ix, t);
	ll x;
	if (sa[ix]) {
		x = (-t - sb[ix]) / (2 * sa[ix]);
		if (x >= xdr[ix]) {
			x -= (x - x0) % d;
			ans = min(ans, rs[ix] + sa[ix] * sqr(x) + sb[ix] * x + sc[ix] + t * ((x - x0) / d));
			x += d;
			ans = min(ans, rs[ix] + sa[ix] * sqr(x) + sb[ix] * x + sc[ix] + t * ((x - x0) / d));
		}
	}
	if (ix > 0) {
		--ix;
		ans = min(ans, calcr(ix, t));
		if (sa[ix]) {
			x = (-t - sb[ix]) / (2 * sa[ix]);
			if (x > xdr[ix]) {
				x -= (x - x0) % d;
				ans = min(ans, rs[ix] + sa[ix] * sqr(x) + sb[ix] * x + sc[ix] + t * ((x - x0) / d));
				x += d;
				ans = min(ans, rs[ix] + sa[ix] * sqr(x) + sb[ix] * x + sc[ix] + t * ((x - x0) / d));
			}
		}
	}
	return ans;
}

ll minl(ll t) {
	int ix = findl(t);
	// dx = 2ax + b - t
	// xmin = (t - b) / 2a
	ll ans = calcl(ix, t);
	ll x;
	if (pa[ix]) {
		x = (t - pb[ix]) / (2 * pa[ix]);
		if (x > -d && x <= xdl[ix]) {
			x -= (x - x0 + fix) % d;
			ans = min(ans, ls[ix] + pa[ix] * sqr(x) + pb[ix] * x + pc[ix] + t * ((x0 - x) / d));
			x += d;
			ans = min(ans, ls[ix] + pa[ix] * sqr(x) + pb[ix] * x + pc[ix] + t * ((x0 - x) / d));
		}
	}
	if (ix > 0) {
		--ix;
		ans = min(ans, calcl(ix, t));
		if (pa[ix]) {
			x = (t - pb[ix]) / (2 * pa[ix]);
			if (x > 0 && x < xdl[ix]) {
				x -= (x - x0 + fix) % d;
				ans = min(ans, ls[ix] + pa[ix] * sqr(x) + pb[ix] * x + pc[ix] + t * ((x0 - x) / d));
				x += d;
				ans = min(ans, ls[ix] + pa[ix] * sqr(x) + pb[ix] * x + pc[ix] + t * ((x0 - x) / d));
			}
		}
	}
	return ans;
}

// Please work, I beg you!!! For the sake of pomidor pelmenyevich!!!

int32_t main()
{
	pomidor pelmenyevich;
	int n; cin >> n;
	int in;
	X.resize(n);
	for (int i = 0; i < n; ++i) { cin >> in; X[i] = in; }
	sort(X.begin(), X.end());
	cin >> in; x0 = in; cin >> in; d = in;
	xdr.push_back(x0); rs.push_back(0); sa.push_back(0); sb.push_back(0); sc.push_back(0);
	for (int i = 0; i < n; ++i) {
		if (X[i] <= x0) continue;
		ll x = X[i] + ((X[i] - x0) % d == 0 ? 0 : d - (X[i] - x0) % d);
		if (x != xdr.back()) { xdr.push_back(x); rs.push_back(rs.back()); sa.push_back(0); sb.push_back(0); sc.push_back(0); }
		rs.back() += min(sqr(x - X[i]), sqr(x - d - X[i]));
	}
	int ix = xdr.size() - 1;
	for (int i = n - 1; i >= 0 && X[i] > x0; --i) {
		while (X[i] <= xdr[ix]) { 
			--ix; sa[ix] = sa[ix + 1]; sb[ix] = sb[ix + 1]; sc[ix] = sc[ix + 1];
		}
		++sa[ix]; sb[ix] -= 2 * X[i]; sc[ix] += sqr(X[i]);
	}
	fix = 1'000'000'000ll + d - 1'000'000'000ll % d;
	xdl.push_back(x0); ls.push_back(0); pa.push_back(0); pb.push_back(0); pc.push_back(0);
	for (int i = n - 1; i >= 0; --i) {
		if (X[i] >= x0) continue;
		ll x = X[i] - (X[i] - x0 + fix) % d;
		if (x != xdl.back()) { xdl.push_back(x); ls.push_back(ls.back()); pa.push_back(0); pb.push_back(0); pc.push_back(0); }
		ls.back() += min(sqr(x - X[i]), sqr(x + d - X[i]));
	}
	ix = xdl.size() - 1;
	for (int i = 0; i < n && X[i] < x0; ++i) {
		while (X[i] >= xdl[ix]) { --ix; pa[ix] = pa[ix + 1]; pb[ix] = pb[ix + 1]; pc[ix] = pc[ix + 1]; }
		++pa[ix]; pb[ix] -= 2 * X[i]; pc[ix] += sqr(X[i]);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
	}

	int m; cin >> m;
	for (int prt = 0; prt < m; ++prt) {
		cin >> in;
		ll ti = in;
		ll zero = 0;
		if (ti == zero) { cout << ls.back() + rs.back() << '\n'; continue; }
		ll ans = min(minl(ti + ti) + minr(ti), minl(ti) + minr(ti + ti));
		cout << ans << '\n';
	}
}