#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define endl "\n"


const int INF = 1e18;

const int MAXN = 1000'000 + 1;


struct Side {
    vector<__int128> x;
    __int128 d;

    vector<__int128> cost;
    vector<__int128> xcnt;

    Side(vector<__int128> _x, __int128 _d) {
        x = _x;
        d = _d;
        cost.resize(MAXN);
        xcnt.resize(MAXN);
        sort(all(x));
        for (auto it: x) {
            xcnt[it]++;
        }
        __int128 xsqsum = 0;
        __int128 xsum = 0;
        __int128 xnum = 0;
        for (int i = MAXN - 1; i >= 0; i--) {
            xsqsum += xcnt[i] * i * i;
            xsum += xcnt[i] * i;
            xnum += xcnt[i];
            if (i % d == 0) {
                cost[i] = xsqsum - 2 * xsum * i + i * i * xnum;
            }
        }
        __int128 xadd = 0;
        for (int i = 0; i < MAXN; i++) {
            xadd += xcnt[i] * min(i % d, d - i % d) * min(i % d, d - i % d);
            if (i % d == 0) {
                cost[i] += xadd;
            }
        }
    }

    int get(__int128 t) {
        __int128 ans = INF;
        for (int i = 0; i < MAXN; i += d) {
            ans = min(ans, i / d * t + cost[i]);
        }
        return ans;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> a(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int x0, d;
    cin >> x0 >> d;

    vector<__int128> xs1;
    vector<__int128> xs2;

    for (int i = 0; i < n; i++) {
        a[i] -= x0;
        if (a[i] < 0) {
            xs1.push_back(-a[i]);
        } else if (a[i] > 0) {
            xs2.push_back(a[i]);
        }
    }

    Side lside(xs1, d);
    Side rside(xs2, d);

    int m;
    cin >> m;

    while (m--) {
        int t;
        cin >> t;
        int ans = min(lside.get(t) + rside.get(2 * t), lside.get(2 * t) + rside.get(t));
        cout << ans << endl;
    }
}
