#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define endl "\n"


const int INF = 1e18;

const int MAXN = 2000'001;

struct Line {
    __int128 k, b;

    Line(__int128 _k, __int128 _b) {
        k = _k;
        b = _b;
    }

    __int128 cross(Line &other) {
        return (b - other.b + other.k - k - 1) / (other.k - k);
    }

    __int128 get(__int128 x) {
        return k * x + b;
    }
};

struct ConvexHull {
    vector<Line> lines;
    vector<__int128> pts;

    ConvexHull() {
    }

    void add(Line l) {
        while (lines.size() && l.cross(lines.back()) <= pts.back()) {
            lines.pop_back();
            pts.pop_back();
        }
        if (lines.size() == 0) {
            pts.push_back(0);
            lines.push_back(l);
        } else {
            pts.push_back(l.cross(lines.back()));
            lines.push_back(l);
        }
    }

    int get(__int128 x) {
        return lines[upper_bound(all(pts), x) - pts.begin() - 1].get(x);
    }
};


struct Side {
    vector<__int128_t> x;
    __int128_t d;

    vector<__int128_t> cost;
    vector<__int128_t> xcnt;

    ConvexHull ch;

    Side(vector<__int128_t> _x, __int128_t _d) {
        x = _x;
        d = _d;
        cost.resize(MAXN, 0);
        xcnt.resize(MAXN, 0);
        for (auto it: x) {
            xcnt[it]++;
        }
        __int128_t xsqsum = 0;
        __int128_t xsum = 0;
        __int128_t xnum = 0;
        for (int i = MAXN - 1; i >= 0; i--) {
            xsqsum += xcnt[i] * i * i;
            xsum += xcnt[i] * i;
            xnum += xcnt[i];
            if (i % d == 0) {
                cost[i] = xsqsum - 2 * xsum * i + i * i * xnum;
            }
        }
        __int128_t xadd = 0;
        for (int i = 0; i < MAXN; i++) {
            xadd += xcnt[i] * min(i % d, d - i % d) * min(i % d, d - i % d);
            if (i % d == 0) {
                cost[i] += xadd;
            }
        }
        for (int i = MAXN - MAXN % d; i >= 0; i -= d) {
            ch.add({i / d, cost[i]});
        }
    }

    int get(__int128_t t) {
        return ch.get(t);
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> a(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int x0, d;
    cin >> x0 >> d;

    int zeroans = 0;

    for (auto it: a) {
        int c = abs(it % d - x0 % d);
        zeroans += min(c, d - c) * min(c, d - c);
    }

    vector<__int128_t> xs1;
    vector<__int128_t> xs2;

    for (int i = 0; i < n; i++) {
        a[i] -= x0;
        if (a[i] < 0) {
            xs1.push_back(-a[i]);
        } else if (a[i] > 0) {
            xs2.push_back(a[i]);
        }
    }

    Side lside(xs1, d);
    Side rside(xs2, d);

    int m;
    cin >> m;

    while (m--) {
        int t;
        cin >> t;
        if (t == 0) {
            cout << zeroans << endl;
            continue;
        }
        int ans = min(lside.get(t) + rside.get(2 * t), lside.get(2 * t) + rside.get(t));
        cout << ans << endl;
    }
}
