#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
struct SegmentTree {
	vector<ll>tree;
	vector<ll>mod;
	vector<ll>mx;
	ll n;
	SegmentTree(ll x) {
		n = x;
		tree.resize(4 * n);
		mx.resize(4 * n);
		mod.resize(4 * n);
		build(0, 0, n);
	}
	void build(ll v, ll l, ll r) {
		if (r - l == 1) {
			tree[v] = 0;
			mod[v] = -1;
			mx[v] = 0;
			return;
		}
		ll mid = (l + r) / 2;
		build(2 * v + 1, l, mid);
		build(2 * v + 2, mid, r);
		mod[v] = -1;
	}
	void push(ll v, ll l, ll r) {
		ll d = mod[v]; mod[v] = -1;
		ll mid = (l + r) / 2;
		tree[2 * v + 1] = (mid - l) * d;
		tree[2 * v + 2] = (r - mid) * d;
		mod[2 * v + 1] = mod[2 * v + 2] = d;
		mx[2 * v + 1] = mx[2 * v + 2] = d;
	}
	void merge(ll v) {
		tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
		mx[v] = max(mx[2 * v + 1], mx[2 * v + 2]);
		mod[v] = -1;
	}
	void change(ll v, ll l, ll r, ll lq, ll rq, ll d) {
		if (r <= lq || rq <= l)return;
		if (lq <= l && r <= rq) {
			tree[v] = d * (r - l);
			mod[v] = d; mx[v] = d;
			return;
		}
		if (mod[v] != -1)push(v, l, r);
		ll mid = (l + r) / 2;
		change(2 * v + 1, l, mid, lq, rq, d);
		change(2 * v + 2, mid, r, lq, rq, d);
		merge(v);
	}
	ll get(ll v, ll l, ll r, ll lq, ll rq) {
		if (r <= lq || rq <= l)return 0;
		if (lq <= l && r <= rq)return tree[v];
		if (mod[v] != -1)push(v, l, r);
		ll mid = (l + r) / 2;
		ll ans = get(2 * v + 1, l, mid, lq, rq);
		ans+=get(2 * v + 2, mid, r, lq, rq);
		return ans;
	}
	ll spusk(ll v, ll l, ll r, ll x) {
		if (mx[v] <= x)return n+1;
		if (r - l == 1)return l;
		ll mid = (l + r) / 2;
		if (mod[v] != -1)push(v, l, r);
		if (mx[2 * v + 1] > x)return spusk(2 * v + 1, l, mid, x);
		else spusk(2 * v + 2, mid, r, x);
	}
};
int main()
{
	ll w, h; cin >> w >> h;
	vector<vector<ll>>p(w, vector<ll>(h, 0));
	for (int i = 0; i < w; i++) {
		for (int j = 0; j < h; j++) {
			char x; cin >> x;
			p[i][j] = x - '0';
		}
	}
	vector<vector<ll>>cnt(w, vector<ll>(h, 0));
	for (int i = 0; i < w; i++) {
		ll res = 0;
		for (int j = h-1; j>=0; j--) {
			if (p[i][j] == 0)res = 0;
			else {
				res++;
				cnt[i][j] = res;
			}
		}
	}
	ll ans = 0;
	SegmentTree DO(w);
	for (int j = 0; j < h; j++) {
		ll ind = 0;
		for (int i = 0; i < w; i++) {
			if (p[i][j] == 0) {
				ind = 0; continue;
			}
			if (ind == 0)DO.change(0, 0, w, 0, w, 0);
			ll index = DO.spusk(0, 0, w, cnt[i][j]);
			index = min(index, ind);
			DO.change(0, 0, w, index, w, cnt[i][j]);
			ans = max(ans, DO.get(0, 0, w, 0, ind + 1));
			ind++;
		}
	}
	cout << ans;
}