#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
struct Node {
	ll mx, sm, d;
	Node(ll a = 0, ll b = 0, ll c = 0) {
		mx = a, sm = b, d = c;
	}
};
struct SegmentTree {
	vector<Node>tree;
	ll n;
	SegmentTree(ll x){
		n = x; tree.resize(4 * n);
		build(0, 0, n);
	}
	void build(ll v, ll l, ll r) {
		if (r - l==1) {
			tree[v] = Node(0, 0, -1);
			return;
		}
		ll mid = (l + r) / 2;
		build(2 * v + 1, l, mid);
		build(2 * v + 2, mid, r);
		tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
	}
	Node merge(Node &a, Node &b) {
		Node c(max(a.mx, b.mx), a.sm + b.sm, -1);
		return c;
	}
	ll get(ll v, ll l, ll r, ll lq, ll rq, ll mod) {
		if (mod != -1) {
			tree[v] = Node(mod, (r - l) * mod, mod);
		}
		if (r <= lq || rq <= l)return 0;
		if (lq <= l && r <= rq)return tree[v].sm;
		ll mid = (l + r) / 2;
		ll d = tree[v].d; tree[v].d = -1;
		ll ans = 0;
		ans += get(2 * v + 1, l, mid, lq, rq, d);
		ans += get(2 * v + 2, mid, r, lq, rq, d);
		return ans;
	}
	void change(ll v, ll l, ll r, ll lq, ll rq, ll d, ll mod) {
		if (mod != -1) {
			tree[v] = Node(mod, (r - l) * mod, mod);
		}
		if (r <= lq || rq <= l)return;
		if (lq <= l && r <= rq) {
			tree[v] = Node(d, (r - l) * d, d);
			return;
		}
		ll mid = (l + r) / 2;
		ll md = tree[v].d; tree[v].d = -1;
		change(2 * v + 1, l, mid, lq, rq, d, md);
		change(2 * v + 2, mid, r, lq, rq, d, md);
		tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
	}
	ll spusk(ll v, ll l, ll r, ll x, ll mod) {
		if (mod != -1) {
			tree[v] = Node(mod, (r - l) * mod, mod);
		}
		if (r - l == 1) {
			return l;
		}
		ll d = tree[v].d; tree[v].d = -1;
		ll mid = (l + r) / 2;
		if (tree[2*v+1].mx>x)return spusk(2 * v + 1, l, mid, x, d);
		return spusk(2 * v + 2, mid, r, x, d);
	}
};
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll w, h; cin >> w >> h;
	vector<vector<ll>>p(w, vector<ll>(h, 0));
	for (int i = 0; i < w; i++) {
		for (int j = 0; j < h; j++) {
			char x; cin >> x;
			p[i][j] = (ll)(x - '0');
		}
	}
	vector<vector<ll>>cnt(w, vector<ll>(h, 0));
	for (int i = 0; i < w; i++) {
		ll res = 0;
		for (int j = h-1; j>=0; j--) {
			if (p[i][j] == 0)res = 0;
			else {
				res++;
				cnt[i][j] = res;
			}
		}
	}
	ll ans = 0;
	SegmentTree DO(w);
	for (int j = 0; j < h; j++) {
		vector<ll>st;
		ll ind = 0;
		for (int i = 0; i < w; i++) {
			if (p[i][j] == 0) {
				ind = 0;
				continue;
			}
			if (ind == 0) {
				DO.change(0, 0, w, 0, w, 0, -1);
			}

			ll fb = DO.spusk(0, 0, w, cnt[i][j], -1);
			fb = min(fb, ind);
			DO.change(0, 0, w, fb, w, cnt[i][j], -1);

			ll res = DO.get(0,0,w,0,ind+1, -1);
			ans = max(ans, res);
			ind++;
		}
	}
	cout << ans;
}
/*11 10
0111000000
1110000000
1111100000
1111110000
1110000000
1111111110
1111111000
0111111100
0100000000
0111111111
0100000000*/