#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using bigint = long long;


const int inf = 1e9 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


template<typename T>
T dist(T a, T b) {
    return (a - b) * (a - b);
}


bigint abss(bigint a) {
    if (a < 0) {
        return -a;
    }
    return a;
}


template<typename T>
T distprev(T s, T t, T d) {
    T dist = abss(s - t);
    if (s < t) {
        return (dist / d * d);
    }
    return -(dist / d * d);
}


template<typename T>
T distnext(T s, T t, T d) {
    T dist = abss(s - t);
    if (s < t) {
        return ((dist + d - 1) / d * d);
    }
    return -((dist + d - 1) / d * d);
}


bigint func(bigint x0, const vector<bigint> &x, bigint d, bigint cnt, bigint t) {
    bigint stand;
    bigint res = 0;
    stand = x0 + cnt * d;
    res += cnt * t;
    for (int j = 0; j < int(x.size()); j++) {
        bigint pos1 = x0 + distprev(x0, bigint(x.at(j)), d), pos2 = x0 + distnext(x0, bigint(x.at(j)), d);
        if (pos1 > stand) {
            pos1 = stand;
        }
        if (pos2 > stand) {
            pos2 = stand;
        }
        res += min(dist(pos1, bigint(x.at(j))), dist(pos2, bigint(x.at(j))));
    }
    return res;
}


bigint getone(bigint x0, const vector<bigint> &x, bigint d, bigint t, int n) {
    bigint r = (abss(x0 - x.back()) + d - 1) / d + 1;
    bigint l = 0;
    while (l + 2 < r) {
        bigint m1 = l + (r - l) / 3;
        bigint m2 = l + (r - l) / 3 * 2;
        bigint f1 = func(x0, x, d, m1, t);
        bigint f2 = func(x0, x, d, m2, t);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    bigint f = func(x0, x, d, l, t);
    for (int i = l + 1; i <= r; i++) {
        bigint buf = func(x0, x, d, i, t);
        if (buf < f) {
            f = buf;
            l = i;
        }
    }
    return f;
}


ll solve(bigint x0, bigint d, const vector<bigint> &x, int n, bigint t) {
    return ll(getone(x0, x, d, t, n));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<bigint> x(n);
    for (int i = 0; i < n; i++) {
        ll num;
        cin >> num;
        x.at(i) = bigint(num);
    }
    sort(x.begin(), x.end());
    ll x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        ll t;
        cin >> t;
        cout << solve(x0, d, x, n, t) << '\n';
    }
    return 0;
}


/*5
1 2 3 4 5
0 1
1
10*/


/*4
30 239 57 179
0 7
1
10*/


/*3
4 0 7
2 3
1
2
*/
