#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using bigint = long long;


const bigint inf = 1e9 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


template<typename T>
T dist(T a, T b) {
    return (a - b) * (a - b);
}


bigint abss(bigint a) {
    if (a < 0) {
        return -a;
    }
    return a;
}


template<typename T>
T distprev(T s, T t, T d) {
    T dist = abss(s - t);
    if (s < t) {
        return (dist / d * d);
    }
    return -(dist / d * d);
}


template<typename T>
T distnext(T s, T t, T d) {
    T dist = abss(s - t);
    if (s < t) {
        return ((dist + d - 1) / d * d);
    }
    return -((dist + d - 1) / d * d);
}


/*istream & operator >>(istream &in, bigint &a) {
    ll num;
    in >> num;
    a = bigint(num);
    return in;
}*/


/*ostream & operator <<(ostream &os, bigint &a) {
    ll num;
    num = ll(a);
    os << num;
    return os;
}*/


bigint secfunc(bigint x0, const vector<bigint> &x, bigint d, bigint cnt, bigint t) {
    bigint stand;
    bigint res = 0;
    stand = x0 + cnt * d;
    res += cnt * t;
    for (int j = 1; j < int(x.size()); j++) {
        bigint pos1 = x0 + distprev(x0, bigint(x.at(j)), d), pos2 = x0 + distnext(x0, bigint(x.at(j)), d);
        if (pos1 > stand) {
            pos1 = stand;
        }
        if (pos2 > stand) {
            pos2 = stand;
        }
        res += min(dist(pos1, bigint(x.at(j))), dist(pos2, bigint(x.at(j))));
    }
    return res;
}


bigint Calc(bigint x0, const vector<bigint> &x, bigint d, bigint t) {
    if (int(x.size()) == 0) {
        return 0;
    }
    bigint r = (abss(x0 - x.back()) + d - 1) / d + 1;
    bigint l = 0;
    while (l + 2 < r) {
        bigint m1 = l + (r - l) / 3;
        bigint m2 = l + (r - l) / 3 * 2;
        bigint f1 = secfunc(x0, x, d, m1, t);
        bigint f2 = secfunc(x0, x, d, m2, t);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    bigint f = secfunc(x0, x, d, l, t);
    for (int i = l + 1; i <= r; i++) {
        bigint buf = secfunc(x0, x, d, i, t);
        if (buf < f) {
            f = buf;
            l = i;
        }
    }
    return f;
}


bigint func(bigint x0, const vector<bigint> &x, const vector<bigint> &px, const vector<bigint> &pref, const vector<bigint> &sumsuf, const vector<bigint> &sumkv, bigint d, bigint cnt, bigint t) {
    bigint stand;
    bigint res = 0;
    stand = x0 + cnt * d;
    res += cnt * t;
    auto it = upper_bound(x.begin(), x.end(), stand);
    int pos = int(it - x.begin());
    res += pref.at(pos - 1);
    bigint len = int(x.size()) - pos;
    res += len * stand * stand - bigint(2) * stand * sumsuf.at(pos) + sumkv.at(pos);
    return res + Calc(-stand, px, d, t);
}


bigint getone(bigint x0, const vector<bigint> &x, const vector<bigint> &px, const vector<bigint> &pref, const vector<bigint> &sumsuf, const vector<bigint> &sumkv, bigint d, bigint t, int n) {
    if (int(x.size()) == 0) {
        return Calc(-x0, px, d, t);
    }
    bigint r = (abss(x0 - x.back()) + d - 1) / d + 1;
    bigint l = 0;
    while (l + 2 < r) {
        bigint m1 = l + (r - l) / 3;
        bigint m2 = l + (r - l) / 3 * 2;
        bigint f1 = func(x0, x, px, pref, sumsuf, sumkv, d, m1, t);
        bigint f2 = func(x0, x, px, pref, sumsuf, sumkv, d, m2, t);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    bigint f = func(x0, x, px, pref, sumsuf, sumkv, d, l, t);
    for (int i = l + 1; i <= r; i++) {
        bigint buf = func(x0, x, px, pref, sumsuf, sumkv, d, i, t);
        if (buf < f) {
            f = buf;
            l = i;
        }
    }
    return f;
}


ll solve(bigint x0, bigint d, const vector<bigint> &x, const vector<bigint> &px, const vector<bigint> &pref, const vector<bigint> &sumsuf, const vector<bigint> &sumkv, int n, bigint t) {
    return ll(getone(x0, x, px, pref, sumsuf, sumkv, d, t, n));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<bigint> x, px, buf(n);
    for (int i = 0; i < n; i++) {
        ll num;
        cin >> num;
        buf.at(i) = bigint(num);
    }
    sort(buf.begin(), buf.end());
    x.push_back(-inf);
    px.push_back(-inf);
    bigint x0, d;
    cin >> x0 >> d;
    for (auto el : buf) {
        if (el >= x0) {
            x.push_back(el);
        } else {
            px.push_back(-el);
        }
    }
    vector<bigint> pref(int(x.size()), 0), sumsuf(int(x.size()) + 1, 0), sumkv(int(x.size()) + 1, 0);
    vector<bigint> prefp(int(px.size()), 0), sumsufp(int(px.size()) + 1, 0), sumkvp(int(px.size()) + 1, 0);
    for (int i = 1; i < int(x.size()); i++) {
        bigint pos1 = x0 + distprev(x0, bigint(x.at(i)), d), pos2 = x0 + distnext(x0, bigint(x.at(i)), d);
        pref.at(i) = pref.at(i - 1) + min(dist(pos1, bigint(x.at(i))), dist(pos2, bigint(x.at(i))));
    }
    for (int i = int(x.size()) - 1; i >= 1; i--) {
        sumsuf.at(i) = sumsuf.at(i + 1) + x.at(i);
        sumkv.at(i) = sumkv.at(i + 1) + x.at(i) * x.at(i);
    }

    for (int i = 1; i < int(px.size()); i++) {
        bigint pos1 = -x0 + distprev(-x0, bigint(px.at(i)), d), pos2 = -x0 + distnext(-x0, bigint(px.at(i)), d);
        prefp.at(i) = prefp.at(i - 1) + min(dist(pos1, bigint(px.at(i))), dist(pos2, bigint(px.at(i))));
    }
    for (int i = int(px.size()) - 1; i >= 1; i--) {
        sumsufp.at(i) = sumsufp.at(i + 1) + px.at(i);
        sumkvp.at(i) = sumkvp.at(i + 1) + px.at(i) * px.at(i);
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        bigint t;
        cin >> t;
        cout << min(solve(x0, d, x, px, pref, sumsuf, sumkv, n, t), solve(-x0, d, px, x, prefp, sumsufp, sumkvp, n, t)) << '\n';
    }
    return 0;
}


/*4
100 2 101 666
9 10
1
1
*/

/*3
4 0 7
2 3
1
1*/


/*5
1 2 3 4 5
0 1
1
10*/


/*4
30 239 57 179
0 7
1
10*/


/*3
4 0 7
2 3
1
2
*/
