#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using bigint = __int128;


const int inf = 1e9 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


template<typename T>
T dist(T a, T b) {
    return (a - b) * (a - b);
}


ll distprev(ll s, ll t, ll d) {
    ll dist = abs(s - t);
    if (s < t) {
        return (dist / d * d);
    }
    return -(dist / d * d);
}


ll distnext(ll s, ll t, ll d) {
    ll dist = abs(s - t);
    if (s < t) {
        return ((dist + d - 1) / d * d);
    }
    return -((dist + d - 1) / d * d);
}


ll func(ll x0, ll xto, ll d, ll cnt, ll t) {
    ll stand;
    ll res = 0;
    if (xto < x0) {
        stand = x0 - cnt * d;
    } else {
        stand = x0 + cnt * d;
    }
    res += cnt * t;
    res += dist(stand, xto);
    return res;
}


ll getone(bigint x0, bigint xto, bigint d, bigint t, int n) {
    bigint r = (abs(x0 - xto) + d - 1) / d;
    bigint l = 0;
    while (l + 2 < r) {
        bigint m1 = l + (r - l) / 3;
        bigint m2 = l + (r - l) / 3 * 2;
        bigint f1 = func(x0, xto, d, m1, t);
        bigint f2 = func(x0, xto, d, m2, t);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    bigint f = func(x0, xto, d, l, t);
    for (int i = l + 1; i <= r; i++) {
        bigint buf = func(x0, xto, d, i, t);
        if (buf < f) {
            f = buf;
            l = i;
        }
    }
    if (x0 < xto) {
        return ll(x0 + l * d);
    }
    return ll(x0 - l * d);
}


ll solve(ll x0, ll d, const vector<ll> &x, int n, ll t) {
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll xshoot = getone(x0, x.at(i), d, t, n);
        ans += dist(xshoot, x.at(i));
        ans += abs(x0 - xshoot) / d * t;
        x0 = xshoot;
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x.at(i);
    }
    sort(x.begin(), x.end());
    ll x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        ll t;
        cin >> t;
        cout << solve(x0, d, x, n, t) << '\n';
    }
    return 0;
}


/*3
4 0 7
2 3
1
2
*/
