#include <bits/stdc++.h>


using namespace std;


using ll = long long;
using bigint = __int128;


const int inf = 1e9 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


template<typename T>
T dist(T a, T b) {
    return (a - b) * (a - b);
}


bigint abss(bigint a) {
    if (a < 0) {
        return -a;
    }
    return a;
}


template<typename T>
T distprev(T s, T t, T d) {
    T dist = abs(s - t);
    if (s < t) {
        return (dist / d * d);
    }
    return -(dist / d * d);
}


template<typename T>
T distnext(T s, T t, T d) {
    T dist = abs(s - t);
    if (s < t) {
        return ((dist + d - 1) / d * d);
    }
    return -((dist + d - 1) / d * d);
}


bigint func(bigint x0, bigint xto, bigint d, bigint cnt, bigint t) {
    bigint stand;
    bigint res = 0;
    if (xto < x0) {
        stand = x0 - cnt * d;
    } else {
        stand = x0 + cnt * d;
    }
    res += cnt * t;
    res += dist(stand, xto);
    return res;
}


bigint getone(bigint x0, bigint xto, bigint d, bigint t, int n) {
    bigint r = (abss(x0 - xto) + d - 1) / d;
    bigint l = 0;
    while (l + 2 < r) {
        bigint m1 = l + (r - l) / 3;
        bigint m2 = l + (r - l) / 3 * 2;
        bigint f1 = func(x0, xto, d, m1, t);
        bigint f2 = func(x0, xto, d, m2, t);
        if (f1 < f2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    bigint f = func(x0, xto, d, l, t);
    for (int i = l + 1; i <= r; i++) {
        bigint buf = func(x0, xto, d, i, t);
        if (buf < f) {
            f = buf;
            l = i;
        }
    }
    if (x0 < xto) {
        return ll(x0 + l * d);
    }
    return ll(x0 - l * d);
}


ll solve(bigint x0, bigint d, const vector<ll> &x, int n, bigint t) {
    bigint ans = -1;
    for (int i = 0; i < n; i++) {
        bigint xshoot = getone(x0, x.at(i), d, t, n);
        bigint curr = 0;
        curr += abss(xshoot - x0) / d * t;
        for (int j = 0; j < n; j++) {
            bigint pos1 = x0 + distprev(x0, bigint(x.at(j)), d), pos2 = x0 + distnext(x0, bigint(x.at(j)), d);
            if (pos1 > xshoot) {
                pos1 = xshoot;
            }
            if (pos2 > xshoot) {
                pos2 = xshoot;
            }
            curr += min(dist(pos1, bigint(x.at(j))), dist(pos2, bigint(x.at(j))));
        }
        if (ans == -1) {
            ans = curr;
        }
        ans = min(ans, curr);
    }
    return ll(ans);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x.at(i);
    }
    sort(x.begin(), x.end());
    ll x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        ll t;
        cin >> t;
        cout << solve(x0, d, x, n, t) << '\n';
    }
    return 0;
}


/*4
30 239 57 179
0 7
1
10*/


/*3
4 0 7
2 3
1
2
*/
