#include <bits/stdc++.h>
using namespace std;
using pp = pair<int, int>;

vector<vector<int> > graph;
vector<int> tin, tout, p, depth;
int timer = 0;
const int inf = 1e9;

void dfs(int v, int prv, int d) {
    depth[v] = d;
    p[v] = prv;
    tin[v] = timer++;
    for (int to: graph[v]) {
        if (to == prv) {
            continue;
        }
        dfs(to, v, d + 1);
    }
    tout[v] = timer++;
}

bool is_anc(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int dist(int a, int b) {
    int ans = 0;
    while (!is_anc(a, b)) {
        ans++;
        a = p[a];
    }
    while (!is_anc(b, a)) {
        ans++;
        b = p[b];
    }
    ans += abs(depth[a] - depth[b]);
    return ans;
}

void solve() {
    int n, d;
    cin >> n >> d;
    graph.assign(n, {});
    tin.assign(n, 0);
    tout.assign(n, 0);
    p.assign(n, -1);
    depth.assign(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dfs(0, -1, 0);
    vector<vector<int> > dst(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dst[i][j] = dist(i, j);
        }
    }
    vector<bool> dp(1 << n);
    vector<pp> prv(1 << n, {-1, -1});
    dp[0] = true;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (!dp[mask]) {
            continue;
        }
        for (int a = 0; a < n; a++) {
            if ((mask >> a) & 1) {
                continue;
            }
            for (int b = a + 1; b < n; b++) {
                if ((mask >> b) & 1) {
                    continue;
                }
                if (dst[a][b] > d || dst[a][b] % 2 == 0) {
                    continue;
                }
                dp[mask | (1 << a) | (1 << b)] = true;
                prv[mask | (1 << a) | (1 << b)] = {a, b};
            }
        }
    }
    int best_mask = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (!dp[mask]) {
            continue;
        }
        if (__builtin_popcount(mask) > __builtin_popcount(best_mask)) {
            best_mask = mask;
        }
    }
    vector<pp> ans;
    while (best_mask > 0) {
        auto [a, b] = prv[best_mask];
        ans.emplace_back(a, b);
        best_mask ^= 1 << a;
        best_mask ^= 1 << b;
    }
    cout << ans.size() << '\n';
    for (auto [a, b]: ans) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
