#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

inline void solve() {
	int n, k;
	cin >> n >> k;
	vector<pii> a(k);
	vector<int> ms(k);
	vector<int> cnt0(n + 1);
	for (int i = 0; i < k; i++) {
		cin >> a[i].first >> ms[i] >> a[i].second;
		a[i].first--;
		ms[i]--;
		cnt0[a[i].first]++;
		cnt0[a[i].second]--;
	}
	for (int i = 0; i < n; i++)
		cnt0[i + 1] += cnt0[i];
	bool has0 = false;
	for (int i = 0; i < n; i++)
		if (cnt0[i] == 0)
			has0 = true;
	if (has0) {
		cout << "NO\n";
		return;
	}
	vector<vector<pii>> bucl(n + 1), bucr(n + 1);
	for (int i = 0; i < k; i++) {
		bucl[a[i].first].push_back({ a[i].second, ms[i] });
		bucr[a[i].second].push_back({ a[i].first, ms[i] });
	}
	vector<bool> pref_dp(n + 1), suf_dp(n + 1);
	pref_dp[0] = 1;
	for (int r = 0; r <= n; r++) {
		for (pii seg : bucr[r]) {
			int l = seg.first, m = seg.second;
			for (int from = l; from <= m; from++)
				if (pref_dp[from])
					pref_dp[r] = 1;
		}
	}
	if (pref_dp[n]) {
		cout << "YES\n";
		return;
	}
	suf_dp[n] = 1;
	for (int l = n; l >= 0; l--) {
		for (pii seg : bucl[l]) {
			int r = seg.first, m = seg.second;
			for (int from = m + 1; from <= r; from++)
				if (suf_dp[from])
					suf_dp[l] = 1;
		}
	}
	if (suf_dp[0]) {
		cout << "YES\n";
		return;
	}
	vector<vector<bool>> pref(n + 1, vector<bool>(n + 2));
	auto suf = pref;
	pref[0][0] = 1;
	for (int ri = 0; ri <= n; ri++) {
		for (pii seg : bucr[ri]) {
			int li = seg.first, mi = seg.second;
			for (int r = li; r < ri; r++)
				for (int m = -1; m < li; m++)
					if (pref[r][m + 1])
						pref[ri][mi + 1] = 1;
		}
	}
	suf[n][n + 1] = 1;
	for (int li = n; li >= 0; li--) {
		for (pii seg : bucl[li]) {
			int ri = seg.first, mi = seg.second;
			for (int l = li + 1; l <= ri; l++)
				for (int m = max(l, ri); m <= n + 1; m++)
					if (suf[l][m])
						suf[li][mi] = 1;
		}
	}
	for (int i = 0; i < k; i++) {
		int l = a[i].first, m = ms[i], r = a[i].second;
		for (int R = 0; R < k; R++)
			for (int L = 0; L < k; L++) {
				if (pref[a[R].second][ms[R] + 1] && suf[a[L].first][ms[L]])
					if (a[R].second <= m && a[R].second >= l)
						if (a[L].first > m && a[L].first <= r) 
							if (a[R].second <= a[L].first) {
								cout << "YES\n";
								return;
							}
			}
		for (int R = 0; R < k; R++)
			for (int L = 0; L < k; L++) {
				if (pref_dp[a[R].second] && suf_dp[a[L].first])
					if (a[R].second <= m && a[R].second >= l)
						if (a[L].first > m && a[L].first <= r) 
							if (a[R].second <= a[L].first) {
								cout << "YES\n";
								return;
							}
			}
	}
	cout << "NO\n";
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
	cin >> tt;
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}