#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

struct triple {
	int l, m, r;
};

inline void solve() {
	int n, k;
	cin >> n >> k;
	vector<triple> a(k);
	vector<int> cnt0(n + 1);
	for (int i = 0; i < k; i++) {
		cin >> a[i].l >> a[i].m >> a[i].r;
		a[i].l--;
		a[i].m--;
		cnt0[a[i].l]++;
		cnt0[a[i].r]--;
	}
	for (int i = 0; i < n; i++)
		cnt0[i + 1] += cnt0[i];
	bool has0 = false;
	for (int i = 0; i < n; i++)
		if (cnt0[i] == 0)
			has0 = true;
	if (has0) {
		cout << "NO\n";
		return;
	}
	sort(all(a), [](const auto& a, const auto& b) {
		return a.r < b.r;
	});
	vector<vector<bool>> dp(k, vector<bool>(k + 1));
	for (int i = 0; i < k; i++)
		if (a[i].l == 0)
			dp[i][k] = 1;
	for (int i = 1; i < k; i++) {
		int li = a[i].l, mi = a[i].m, ri = a[i].r;
		for (int j = 0; j < i; j++) {
			int lj = a[j].l, mj = a[j].m, rj = a[j].r;
			if (li > rj)
				continue;
			if (ri == rj)
				continue;
			if (li <= lj)
				continue;
			bool both = false;
			if (li <= mj && mj < ri)
				if (lj <= mi && mi < rj)
					both = true;
			if (both)
				continue;
			if (dp[j][k])
				dp[i][j] = 1;
			for (int p = 0; p < j; p++) {
				int lp = a[p].l, rp = a[p].r;
				if (rp >= li)
					continue;
				if (dp[j][p])
					dp[i][j] = 1;
			}
		}
	}
	for (int i = 0; i < k; i++)
		if (a[i].r == n) {
			for (int j = 0; j <= k; j++)
				if (dp[i][j]) {
					cout << "YES\n";
					return;
				}
		}
	cout << "NO\n";
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
	cin >> tt;
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}