#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

const ll inf = 3e18;

ll div_floor(ll a, ll b) {
	if (b < 0) {
		a = -a;
		b = -b;
	}
	if (a % b == 0 || a >= 0)
		return a / b;
	return a / b - 1;
}

i128 sq(i128 a) {
	return a * a;
}

inline void solve() {
	int n;
	cin >> n;
	vector<ll> x(n);
	for (int i = 0; i < n; i++)
		cin >> x[i];
	sort(all(x));
	ll x0, d;
	cin >> x0 >> d;
	int m;
	cin >> m;
	vector<i128> pref(n + 1);
	vector<i128> pref_sq(n + 1);
	for (int i = 0; i < n; i++) {
		pref[i + 1] = pref[i] + x[i];
		pref_sq[i + 1] = pref_sq[i] + x[i] * x[i];
	}
	vector<i128> opt(n);
	for (int i = 0; i < n; i++) {
		ll k = div_floor(x[i] - x0, d);
		opt[i] = inf;
		opt[i] = min(opt[i], sq(x[i] - x0 - k * d));
		opt[i] = min(opt[i], sq(x[i] - x0 - (k + 1) * d));
	}
	vector<i128> pref_opt(n + 1);
	for (int i = 0; i < n; i++)
		pref_opt[i + 1] = pref_opt[i] + opt[i];
	auto f = [&](i128 k, i128 t) -> i128 {
		int R = upper_bound(all(x), k * d) - x.begin();
		i128 res = t * k;
		res += pref_opt[R];
		res += pref_sq[n] - pref_sq[R];
		res += (i128)(1) * (n - R) * sq(k * d);
		res -= (i128)2 * (k * d) * (pref[n] - pref[R]);
		return res;
	};
	for (int i = 0; i < m; i++) {
		ll t;
		cin >> t;
		ll lo = -1, hi = x.back() / d + 1;
		while (hi - lo > 1) {
			ll mid = (lo + hi) / 2;
			ll a1 = f(mid, t);
			ll a2 = f(mid + 1, t);
			if (a1 >= a2)
				lo = mid;
			else
				hi = mid;
		}
		ll res = f(hi, t);
		cout << res << '\n';
	}
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}