#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

const int N = 3e5;
vector<int> g[N];
int dep[N];

void dfs(int v, int pr = -1) {
	for (int u : g[v])
		if (u != pr) {
			dep[u] = dep[v] + 1;
			dfs(u, v);
		}
}

inline void solve() {
	int n;
	cin >> n;
	int d;
	cin >> d;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(0);
	vector<int> c0, c1;
	for (int v = 0; v < n; v++) {
		if (dep[v] & 1)
			c1.push_back(v);
		else
			c0.push_back(v);
	}
	vector<pii> ans;
	while (!c0.empty() && !c1.empty()) {
		ans.push_back({ c0.back(), c1.back() });
		c0.pop_back();
		c1.pop_back();
	}
	cout << ans.size() << '\n';
	for (const pii& p : ans)
		cout << p.first + 1 << ' ' << p.second + 1 << '\n';
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}