#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()

const int lg = 9;
const int N = 200;
vector<int> t[N];
int dep[N];
int par[N];
int up[lg][N];

void norm(int v, int pr = -1) {
	if (pr > -1)
		t[v].erase(find(all(t[v]), pr));
	for (int u : t[v])
		norm(u, v);
}

void dfs1(int v) {
	for (int u : t[v]) {
		par[u] = v;
		dep[u] = dep[v] + 1;
		dfs1(u);
	}
}

int LCA(int v, int u) {
	if (dep[v] < dep[u])
		swap(v, u);
	for (int i = lg - 1; i > -1; i--)
		if (dep[up[i][v]] >= dep[u])
			v = up[i][v];
	if (v == u)
		return v;
	for (int i = lg - 1; i > -1; i--)
		if (up[i][v] != up[i][u])
			v = up[i][v], u = up[i][u];
	return par[v];
}

int dist(int v, int u) {
	return dep[v] + dep[u] - 2 * dep[LCA(v, u)];
}

vector<int> g[N];
int mt[N];
int used[N];
int timer = 1;

bool dfs(int v) {
	if (used[v] == timer)
		return false;
	for (int u : g[v])
		if (mt[u] == -1 || dfs(mt[u])) {
			mt[u] = v;
			return true;
		}
	return false;
}

inline void solve() {
	int n;
	cin >> n;
	int d;
	cin >> d;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		t[v].push_back(u);
		t[u].push_back(v);
	}
	norm(0);
	dfs1(0);
	for (int v = 0; v < n; v++)
		up[0][v] = par[v];
	for (int i = 1; i < lg; i++)
		for (int v = 0; v < n; v++)
			up[i][v] = up[i - 1][up[i - 1][v]];
	for (int v = 0; v < n; v++)
		if (dep[v] & 1)
			for (int u = 0; u < n; u++)
				if (!(dep[u] & 1))
					if (dist(v, u) <= d)
						g[v].push_back(u);
	fill(mt, mt + n, -1);
	for (int v = 0; v < n; v++)
		if (dep[v] & 1)
			if (dfs(v))
				timer++;
	vector<pii> ans;
	for (int v = 0; v < n; v++)
		if (!(dep[v] & 1))
			ans.push_back({ mt[v], v });
	cout << ans.size() << '\n';
	for (pii p : ans)
		cout << p.first + 1 << ' ' << p.second + 1 << '\n';
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << endl;
#endif
		solve();
	}
	return 0;
}