#include <bits/stdc++.h>

using i64 = long long;

void solve() {
    int n;
    std::cin >> n;
    int max_d;
    std::cin >> max_d;
    std::vector<std::vector<int>> adj(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        std::cin >> v >> u;
        v--, u--;
        adj[v].emplace_back(u);
        adj[u].emplace_back(v);
    }
    if (n <= 14) {
        std::vector<std::vector<int>> d(n, std::vector<int>(n, 1E9));
        for (int i = 0; i < n; i++) {
            for (int j : adj[i]) {
                d[i][j] = 1;
            }
        }
        for (int i = 0; i < n; i++) {
            d[i][i] = 0;
        }
        for (int k = 0; k < n; k++) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    d[i][j] = std::min(d[i][j], d[i][k] + d[k][j]);
                }
            }
        }
        std::vector<int> dp(1 << n);
        std::vector<std::vector<std::pair<int, int>>> ans(1 << n);
        for (int msk = 0; msk < (1 << n); msk++) {
            std::vector<int> bits;
            for (int i = 0; i < n; i++) {
                if (msk & (1 << i)) {
                    bits.emplace_back(i);
                }
            }
            for (int i : bits) {
                for (int j : bits) {
                    if (i == j) {
                        continue;
                    }
                    if (d[i][j] <= max_d && d[i][j] % 2 == 1) {
                        int pre = msk ^ (1 << i) ^ (1 << j);
                        if (dp[pre] + 1 > dp[msk]) {
                            dp[msk] = dp[pre] + 1;
                            ans[msk] = ans[pre];
                            ans[msk].emplace_back(i, j);
                        }
                    }
                }
            }
        }
        std::cout << dp[(1 << n) - 1] << "\n";
        for (auto [x, y] : ans[(1 << n) - 1]) {
            std::cout << x + 1 << " " << y + 1 << "\n";
        }
    } else if (max_d == 1) {
        std::vector<std::vector<int>> dp(n, std::vector<int>(2));
        auto dfs = [&](auto self, int v, int f) -> void {
            for (int u : adj[v]) {
                if (u == f) {
                    continue;
                }
                self(self, u, v);
                dp[v][0] += std::max(dp[u][1], dp[u][0]);
                dp[v][1] += std::max(dp[u][1], dp[u][0]);
            }
            int mx = -1;
            for (int u : adj[v]) {
                if (u == f) {
                    continue;
                }
                dp[v][1] -= std::max(dp[u][1], dp[u][0]);
                dp[v][1] += dp[u][0];
                mx = std::max(mx, dp[v][1] + 1);
                dp[v][1] -= dp[u][0];
                dp[v][1] += std::max(dp[u][1], dp[u][0]);
            }
            dp[v][1] = mx;
        };
        dfs(dfs, 0, 0);
        std::cout << std::max(dp[0][0], dp[0][1]) << "\n";
        std::cout << "-1\n";
    } else {
        std::vector<int> h(n);
        std::vector<std::vector<int>> ct(2);
        auto dfs = [&](auto self, int v, int f) -> void {
            h[v] = h[f] + 1;
            ct[h[v] % 2].emplace_back(v);
            for (int u : adj[v]) {
                if (u == f) {
                    continue;
                }
                self(self, u, v);
            }
        };
        dfs(dfs, 0, 0);
        int as = std::min((int) ct[0].size(), (int) ct[1].size());
        std::cout << as << "\n";
        for (int i = 0; i < as; i++) {
            std::cout << ct[0][i] + 1 << " " << ct[1][i] + 1 << "\n";
        }
    }
}

signed main() {
    // std::ios::sync_with_stdio(false);
    // std::cin.tie(nullptr);
    int t = 1;
    // std::cin >> t;
    while (t--) {
        solve();
    }
}