#include <bits/stdc++.h>

using namespace std;

struct Node {
    int upd = 0;
    int cnt = 0;
    int sum = 0;
};

struct ST {
    vector<Node> tree;

    void push(int v, int l, int r) {
        if (tree[v].upd != 0) {
            tree[v * 2 + 1].upd = 1;
            tree[v * 2 + 1].cnt = 0;
            tree[v * 2 + 2].upd = 1;
            tree[v * 2 + 2].cnt = 0;
            tree[v * 2 + 1].sum = 0;
            tree[v * 2 + 2].sum = 0;
            tree[v].upd = 0;
        }
    }

    void upd(int v, int l, int r, int ind, int x) {
        if (l + 1 == r) {
            tree[v].cnt += x;
            tree[v].sum += x * ind;
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        if (ind < m) {
            upd(v * 2 + 1, l, m, ind, x);
        } else {
            upd(v * 2 + 2, m, r, ind, x);
        }
        tree[v].cnt = tree[v * 2 + 1].cnt + tree[v * 2 + 2].cnt;
        tree[v].sum = tree[v * 2 + 1].sum + tree[v * 2 + 2].sum;
    }

    long long get_cnt(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tree[v].cnt;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        return get_cnt(v * 2 + 1, l, m, ql, qr) + get_cnt(v * 2 + 2, m, r, ql, qr);
    }

    long long get_sum(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tree[v].sum;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        return get_sum(v * 2 + 1, l, m, ql, qr) + get_sum(v * 2 + 2, m, r, ql, qr);
    }

    void upd_l_r(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            tree[v].cnt = 0;
            tree[v].upd = 1;
            tree[v].sum = 0;
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        upd_l_r(v * 2 + 1, l, m, ql, qr);
        upd_l_r(v * 2 + 2, m, r, ql, qr);
        tree[v].cnt = tree[v * 2 + 1].cnt + tree[v * 2 + 2].cnt;
        tree[v].sum = tree[v * 2 + 1].sum + tree[v * 2 + 2].sum;
    }
};


int main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> a(h, vector<int> (w, 0));
    string s;
    for (int i = 0; i < h; i++) {
        cin >> s;
        for (int j = 0; j < w; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    vector<vector<int>> maxi(h, vector<int> (w, 0));
    for (int i = h - 1; i >= 0; i--) {
        int cnt = 0;
        for (int j = w - 1; j >= 0; j--) {
            if (a[i][j] == 0) {
                cnt = 0;
            } else {
                cnt++;
                maxi[i][j] = cnt;
            }
        }
    }
    ST d;
    d.tree.resize(4 * (w + 1));
    long long ans = 0;
    for (int j = w - 1; j >= 0; j--) {
        int pred = 0;
        long long sum = 0;
        for (int i = 0; i < h; i++) {
            int cnt = d.get_cnt(0, 0, w + 1, maxi[i][j], w + 1);
            d.upd_l_r(0, 0, w + 1, maxi[i][j], w + 1);
            cnt++;
            d.upd(0, 0, w + 1, maxi[i][j], cnt);
            ans = max(ans, d.get_sum(0, 0, w + 1, 0, w + 1));
        }
        d.upd_l_r(0, 0, w + 1, 0, w + 1);
    }
    cout << ans;
    return 0;
}