#include <bits/stdc++.h>

using namespace std;

struct Node {
    int upd = 0;
    int cnt = 0;
    int sum = 0;
};

struct ST {
    vector<Node> tree;

    void push(int v, int l, int r) {
        if (tree[v].upd != 0) {
            tree[v * 2 + 1].upd = 1;
            tree[v * 2 + 1].cnt = 0;
            tree[v * 2 + 2].upd = 1;
            tree[v * 2 + 2].cnt = 0;
            tree[v * 2 + 1].sum = 0;
            tree[v * 2 + 2].sum = 0;
            tree[v].upd = 0;
        }
    }

    void upd(int v, int l, int r, int ind, int x) {
        if (l + 1 == r) {
            tree[v].cnt += x;
            tree[v].sum += x * ind;
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        if (ind < m) {
            upd(v * 2 + 1, l, m, ind, x);
        } else {
            upd(v * 2 + 2, m, r, ind, x);
        }
        tree[v].cnt = tree[v * 2 + 1].cnt + tree[v * 2 + 2].cnt;
        tree[v].sum = tree[v * 2 + 1].sum + tree[v * 2 + 2].sum;
    }

    long long get_cnt(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tree[v].cnt;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        return get_cnt(v * 2 + 1, l, m, ql, qr) + get_cnt(v * 2 + 2, m, r, ql, qr);
    }

    void upd_l_r(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            tree[v].cnt = 0;
            tree[v].upd = 1;
            tree[v].sum = 0;
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        upd_l_r(v * 2 + 1, l, m, ql, qr);
        upd_l_r(v * 2 + 2, m, r, ql, qr);
        tree[v].cnt = tree[v * 2 + 1].cnt + tree[v * 2 + 2].cnt;
        tree[v].sum = tree[v * 2 + 1].sum + tree[v * 2 + 2].sum;
    }
};


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    string s;
    for (int i = 0; i < h; i++) {
        cin >> a[i];
    }
    vector<vector<int>> maxi(h, vector<int> (w, 0));
    for (int i = h - 1; i >= 0; i--) {
        int cnt = 0;
        for (int j = w - 1; j >= 0; j--) {
            if (a[i][j] == '0') {
                cnt = 0;
            } else {
                cnt++;
                maxi[i][j] = cnt;
            }
        }
    }
    long long ans = 0;
    for (int j = w - 1; j >= 0; j--) {
        vector<pair<int, int>> pr;
        long long sum = 0;
        int cnt;
        for (int i = 0; i < h; i++) {
            cnt = 0;
            while ((int)pr.size() != 0 && pr.back().first >= maxi[i][j]) {
                sum -= pr.back().first * pr.back().second;
                cnt += pr.back().second;
                pr.pop_back();
            }
            cnt++;
            sum += maxi[i][j] * cnt;
            pr.push_back({maxi[i][j], cnt});
            ans = max(ans, sum);
        }
    }
    cout << ans;
    return 0;
}