#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

template<typename T>ostream &operator<<(ostream &s,vector<T> v) {
    for(auto j:v) {s<<j<<' ';}
    return s;
}

int tree[3000000];

void st(int v,int l,int r,int q) {
    debug(v)
    debug(l)
    debug(r)
    if(r<=q || l>q) {return;}
    if(r-l==1) {tree[v]=1;return;}
    int m=(r+l)/2;
    st(v*2+1,l,m,q);
    st(v*2+2,m,r,q);
    tree[v]=tree[v*2+1]+tree[v*2+2];
}

int gt(int v,int l,int r,int ql,int qr) {
    if(l>=qr || ql>=r) {return 0;}
    if(l>=ql && r<=qr) {return tree[v];}
    int m=(r+l)/2;
    return gt(v*2+1,l,m,ql,qr)+gt(v*2+2,m,r,ql,qr);
}

struct El {
    int l,m,r;
};

void solve() {
    int n,k;
    cin>>n>>k;
    for(int i=0;i<4*n;i++) {tree[i]=0;}
    st(0,0,n+1,0);
    vector<El> e(k);
    for(auto &[l,m,r]:e) { cin>>l>>m>>r;l--;m--;r--;}
    sort(e.begin(),e.end(),[](El a,El b){return a.r<b.r;});
    for(auto [l,m,r]:e) {
        debug(l)
        debug(m)
        debug(r)
        if(gt(0,0,n+1,l,m+1)>0) {st(0,0,n+1,r+1);debug(r)}
        debug(gt(0,0,n+1,l,m+1))
        //for(int i=0;i<4*n;i++) {cout<<tree[i]<<' ';}cout<<'\n';
    }
    if(gt(0,0,n+1,n,n+1)>0) {cout<<"YES\n";}
    else {cout<<"NO\n";}
}

int main() {
    cin.tie(0);cin.sync_with_stdio(0);
    int t=1;
    cin>>t;
    while(t--) {
        solve();
    }
    return 0;
}
