#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

template<typename T>ostream &operator<<(ostream &s,vector<T> v) {
    for(auto j:v) {s<<j<<' ';}
    return s;
}

//int tree[3000000];
const int INF=1e9;

struct Node {
    bool tp;
    int pv;
    int mn;
};

void push(vector<Node> &tree,int v) {
    if(!tree[v].tp) {return;}
    //int m=(r+l)/2;
    tree[v*2+1].tp=1;
    tree[v*2+1].mn=min(tree[v*2+1].mn,tree[v].pv);
    tree[v*2+1].pv=tree[v].pv;
    tree[v*2+2].tp=1;
    tree[v*2+2].mn=min(tree[v*2+2].mn,tree[v].mn);
    tree[v*2+2].pv=tree[v].pv;
    tree[v].tp=0;
}

Node operator+ (Node a,Node b) {
    return {0,INF,min(a.mn,b.mn)};
}

void st(vector<Node> &tree,int v,int l,int r,int ql,int qr,int qv) {
    if(l>=qr || ql>=r) {return;}
    if(l>=ql && r<=qr) {tree[v].mn=min(tree[v].mn,qv);tree[v].tp=1;tree[v].pv=qv;return;}
    push(tree,v);
    int m=(r+l)/2;
    st(tree,v*2+1,l,m,ql,qr,qv);
    st(tree,v*2+2,m,r,ql,qr,qv);
    tree[v]=tree[v*2+1]+tree[v*2+2];
}

int gt(vector<Node> &tree,int v,int l,int r,int ql,int qr) {
    if(l>=qr || ql>=r) {return INF;}
    if(l>=ql && r<=qr) {return tree[v].mn;}
    push(tree,v);
    int m=(r+l)/2;
    return min(gt(tree,v*2+1,l,m,ql,qr),gt(tree,v*2+2,m,r,ql,qr));
}

struct El {
    int l,m,r,ind;
};

void solve() {
    int n,k;
    cin>>n>>k;
    vector<Node> treef(4*n+4,{0,INF,INF}),treeb(4*n+4,{0,INF,INF});
    //for(int i=0;i<4*n;i++) {tree[i]=0;}
    //st(0,0,n+1,0);
    vector<El> e(k);
    int indn=0;
    for(auto &[l,m,r,ind]:e) { cin>>l>>m>>r;l--;m--;r--;ind=indn++;}
    //vector<El> el=e;
    //vector<El> er=e;
    sort(e.begin(),e.end(),[](El a,El b){return a.m<b.m;});
    //sort(el.begin(),el.end(),[](El a,El b){return a.l<b.l;});
    //sort(er.begin(),er.end(),[](El a,El b){return a.r<b.r;});
    for(auto [l,m,r,ind]:e) {
        debug(l)
        debug(m)
        debug(r)
        debug(ind)
        bool can=l==0;
        if(gt(treeb,0,0,n+1,l,l+1)<r) { can=1; }
        if(gt(treef,0,0,n+1,l-1,m)<l) {can=1;}
        if(can && r==n-1) {cout<<"YES\n";return;}
        if(can) {
            st(treeb,0,0,n+1,m+1,r+2,r);
            st(treef,0,0,n+1,r,r+1,l);
        }
        debug(can)
    }
    //if(gt(0,0,n+1,n,n+1)>0) {cout<<"YES\n";}
    cout<<"NO\n";
}

int main() {
    cin.tie(0);cin.sync_with_stdio(0);
    int t=1;
    cin>>t;
    while(t--) {
        solve();
    }
    return 0;
}
