#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
//#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;
typedef __int128 lll;

template<typename T>ostream &operator<<(ostream &s,vector<T> v) {
    for(auto j:v) {s<<j<<' ';}
    return s;
}

istream &operator>>(istream &s,__int128 &x) {
    ll _x;
    s>>_x;
    x=_x;
    return s;
}

ostream &operator<<(ostream &s,__int128 x) {
    s<<(ll)x;
    return s;
}

const ll INF=1e18;

lll x0,d,n,m;
vector<lll> x;
#ifdef LOCAL
const lll SZ=1000;
#else
const lll SZ=1000010;
#endif

inline lll mvres(lll t,lll l,lll r) {
    return min(l,r)*2*t+max(l,r)*t;
}

lll getres(lll t,lll l,lll r) {
    lll res=mvres(t,l,r);
    for(auto xn:x) {
        if(xn<x0-l*d) {res+=(x0-l*d-xn)*(x0-l*d-xn);}
        else if(xn>x0+r*d) {res+=(xn-(x0+r*d))*(xn-(x0+r*d));}
        else {lll o1=((xn-x0)%d+d)%d,o2=((x0-xn)%d+d)%d;res+=min(o1,o2)*min(o1,o2);}
    }
    return res;
}

void solve() {
    cin>>n;
    x.resize(n);
    for(auto &i:x) {cin>>i;}
    sort(x.begin(),x.end());
    cin>>x0>>d;
    cin>>m;
    vector<pair<lll,ll>> ts(m);
    {ll ind=0; for(auto &i:ts) {cin>>i.first;i.second=ind++;} }
    sort(ts.begin(),ts.end());
    vector<ll> ans(m);
    //int i=0,j=n;
    vector<lll> lr(SZ);
    vector<lll> rr(SZ);
    for(auto xn:x) {
        lll o1=((xn-x0)%d+d)%d,o2=((x0-xn)%d+d)%d;
        if(xn<x0) {lr.back()+=min(o1,o2)*min(o1,o2);}
        else {rr.back()+=min(o1,o2)*min(o1,o2);}
    }
    {
        lll trpd=0;
        lll cnt=0;
        int j=0;
        for(lll l=SZ-2;l>=0;l--) {
            debug(trpd)
            lr[l]=lr[l+1];
            lll pos=x0-l*d;
            trpd+=d*cnt;
            lr[l]+=trpd*d;
            trpd+=d*cnt;
            //debug(x[j])
            debug(pos)
            while(j<n && x[j]<pos) {
                lll xn=x[j];
                lll o1=((xn-x0)%d+d)%d,o2=((x0-xn)%d+d)%d;
                lr[l]-=min(o1,o2)*min(o1,o2);
                lr[l]+=(pos-xn)*(pos-xn);
                cnt++;
                trpd+=2*(pos-xn);
                j++;
            }
            debug(lr[l])
        }
    }
    debug(lr)
    {
        lll trpd=0;
        lll cnt=0;
        int j=n-1;
        for(lll r=SZ-2;r>=0;r--) {
            debug(trpd)
            rr[r]=rr[r+1];
            lll pos=x0+r*d;
            trpd+=d*cnt;
            rr[r]+=trpd*d;
            trpd+=d*cnt;
            //debug(x[j])
            debug(pos)
            while(j>=0 && x[j]>pos) {
                lll xn=x[j];
                lll o1=((xn-x0)%d+d)%d,o2=((x0-xn)%d+d)%d;
                rr[r]-=min(o1,o2)*min(o1,o2);
                rr[r]+=(xn-pos)*(xn-pos);
                cnt++;
                trpd+=2*(xn-pos);
                j--;
            }
            debug(rr[r])
        }
    }
    debug(rr)
    lll l=SZ-1,r=SZ-1;
    //for(int i=0;i<n;i++) {
    //    cout<<lr[i]<<' ';
    //}
    //return;
#define getres(t,l,r) (mvres(t,l,r)+lr[l]+rr[r])
    for(auto [t,ind]:ts) {
        //ll ans=INF;
        //for(ll l=0;l==0 || x0-l*d+d>=x[0];l++) {
        //    for(ll r=0;r==0 || x0+r*d-d<=x[n-1];r++) {
        //        ans=min(ans,getres(t,l,r));
        //    }
        //}
        bool go=1;
        lll lres=getres(t,l,r);
        while(go) {
            go=false;
            if(l>0) {
                lll nres=getres(t,l-1,r);
                if(nres<=lres) {lres=nres;go=true;l--;}
            }
            if(r>0) {
                lll nres=getres(t,l,r-1);
                if(nres<=lres) {lres=nres;go=true;r--;}
            }
            //if(l>0 && r>0) {
            //    lll nres=getres(t,l-1,r-1);
            //    if(nres<=lres) {lres=nres;go=true;r--;l--;}
            //}
        }
        debug(l)
        debug(r)
        for(int L=max(l-5,(lll)0);L<min(SZ,l+5);L++) {
            for(int R=max(r-5,(lll)0);R<min(SZ,r+5);R++) {
                lres=min(lres,getres(t,L,R));
            }
        }
        ans[(int)ind]=lres;
    }
    for(auto i:ans) {cout<<i<<'\n';}
}

signed main() {
    cin.tie(0);cin.sync_with_stdio(0);
    ll t=1;
    //cin>>t;
    while(t--) {
        solve();
    }
    return 0;
}
