#include <iostream>
#include <vector>
#include <algorithm>


int main() {
    int h, w;
    std::cin >> h >> w;
    std::vector< std::vector<char> > a(h, std::vector<char>(w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            std::cin >> a[i][j];
        }
    }

    std::vector< std::vector< std::pair<int, int> > > dp(h, std::vector< std::pair<int, int> >(w + 1));
    std::vector< std::vector<int> > height(h + 1, std::vector<int>(w + 1));
    for (int j = 0; j < w; j++) {
        for (int i = 0; i < h; i++) {
            if (a[i][j] == '0') {
                height[i][j] = 0;
            } else {
                if (i != 0)
                    height[i][j] = height[i - 1][j] + 1;
                else
                    height[i][j] = 1;
            }
        }
    }

    int answer = 0;
    for (int i = 0; i < h; i++) {
        for (int j = w - 1; j >= 0; j--) {
            if (a[i][j] == '0') {
                dp[i][j] = {0, 0};
            } else {
                int k = j;
                int add = 0;
                while (dp[i][k + 1].first > height[i][j]) {
                    add++;
                    k++;
                }

                dp[i][j] = {
                    height[i][j],
                    dp[i][k + 1].second + height[i][j] + add * height[i][j]
                };
                answer = std::max(answer, dp[i][j].second);
            }
        }
    }
    std::cout << answer;
}