#include <iostream>
#include <vector>
#include <algorithm>
#include <set>


std::vector< std::vector<int> > g;
std::vector< std::vector<int> > rg;
std::vector< std::pair< int, std::pair<int, int> > > events, workers;
std::vector<int> visited;
std::vector< std::pair<int, std::vector<int> > > cycles_;
std::vector< std::vector<int> > cycles;


void dfs(int v, int c) {
    visited[v] = c;
    for (auto u : g[v]) {
        if (visited[u] == c) {
            cycles_.push_back({u, {}});
        } else if (visited[u] == 0) {
            dfs(u, c);
        }
    }

    for (int i = 0; i < cycles_.size(); i++) {
        if (cycles_[i].first == -1) continue;

        cycles_[i].second.push_back(v);

        if (cycles_[i].first == v) {
            cycles_[i].first = -1;
            cycles.push_back(cycles_[i].second);
        }
    }
}


void solve() {
    int n, k, l, m, r;
    std::cin >> n >> k;

    g.clear();
    rg.clear();
    visited.clear();
    events.clear();
    workers.clear();
    cycles.clear();
    cycles_.clear();

    g.resize(k + 1);
    rg.resize(k + 1);
    visited.resize(k + 1, 0);

    for (int i = 0; i < k; i++) {
        std::cin >> l >> m >> r;
        events.push_back({l, {0, i}});
        events.push_back({m, {1, i}});
        events.push_back({r, {2, i}});
        workers.push_back({m, {l, r}});
    }
    std::sort(events.begin(), events.end());

    std::vector<int> cur;
    int last = 0;
    for (auto [t, p] : events) {
        auto [type, i] = p;

        if (type == 0) {
            cur.push_back(i);
        } else if (type == 1) {
            for (auto v : cur) {
                if (v == i) continue;
                rg[v].push_back(i);
                g[i].push_back(v);
            }
        } else {
            cur.erase(std::find(cur.begin(), cur.end(), i));

            if (last + 1 >= workers[i].second.first) {
                last = std::max(last, workers[i].second.second);
            }
        }
    }

    if (last != n) {
        std::cout << "NO\n";
        return;
    }

    int c = 1;
    for (int i = 0; i < k; i++) {
        if (visited[i]) continue;
        dfs(i, c);
        c++;
    }

    if (cycles.size() != 0) {
        std::cout << "NO\n";
        return;
    }

    std::cout << "YES\n";
}


int main() {
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
}