#include <iostream>
#include <vector>
#include <algorithm>
#include <set>


int main() {
    int h, w;
    std::cin >> h >> w;
    std::vector< std::vector<char> > a(h, std::vector<char>(w));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            std::cin >> a[i][j];
        }
    }

    std::vector< std::vector<int> > dp(h, std::vector<int>(w + 1));
    std::vector< std::vector<int> > height(h + 1, std::vector<int>(w + 1));
    for (int j = 0; j < w; j++) {
        for (int i = 0; i < h; i++) {
            if (a[i][j] == '0') {
                height[i][j] = 0;
            } else {
                if (i != 0)
                    height[i][j] = height[i - 1][j] + 1;
                else
                    height[i][j] = 1;
            }
        }
    }

    int answer = 0;
    for (int i = 0; i < h; i++) {
        std::vector< std::pair<int, int> > set;
        set.push_back({0, w});
        for (int j = w - 1; j >= 0; j--) {
            if (a[i][j] == '0') {
                dp[i][j] = 0;
                set.clear();
                set.push_back({0, j});
            } else {
                while (!set.empty() && (*(--set.end())).first > height[i][j]) {
                    set.pop_back();
                }
                int k = (*(--set.end())).second;

                dp[i][j] = dp[i][k] + height[i][j] + (k - j - 1) * height[i][j];
                answer = std::max(answer, dp[i][j]);
                set.push_back({height[i][j], j});
            }
        }
    }
    std::cout << answer;
}