#include <iostream>
#include <vector>
#include <algorithm>
#include <set>


std::vector< std::vector<int> > g;
std::vector< std::vector<int> > rg;
std::vector< std::pair< int, std::pair<int, int> > > events, workers;
std::vector<int> visited, tin(5e5 + 10), tout(5e5 + 10), depth(5e5 + 10);
std::vector< std::pair<int, std::vector<int> > > cycles;
int n, k, l, m, r;
int timer = 0;


/*void dfs(int v, int c, int d) {
    visited[v] = c;
    tin[v] = ++timer;
    depth[v] = d;
    tout[v] = 0;
    for (auto u : g[v]) {
        if (visited[u] == c && tout[u] == 0) {
            cycles.push_back({u, {v}});
            cycles[cycles.size() - 1].second.reserve(d - depth[u] + 1);
        } else if (visited[u] == 0) {
            dfs(u, c, d + 1);
        }
    }
    tout[v] = ++timer;

    for (int i = 0; i < cycles.size(); i++) {
        if (cycles[i].first == -1) continue;
        if (depth[cycles[i].second[cycles[i].second.size() - 1]] >= depth[v]) continue;

        cycles[i].second.push_back(v);

        if (cycles[i].first == v) {
            cycles[i].first = -1;
        }
    }
}*/

void dfs(int v, int c) {
    visited[v] = c;
    for (auto u : g[v]) {
        if (visited[u] == 0) {
            dfs(u, c);
        }
    }
}


void solve() {
    std::cin >> n >> k;

    g.clear();
    rg.clear();
    visited.clear();
    events.clear();
    workers.clear();
    cycles.clear();

    g.resize(n + 5);
    rg.resize(k + 1);
    visited.resize(n + 5, 0);

    bool cont = true;
    for (int i = 0; i < k; i++) {
        std::cin >> l >> m >> r;

        if (cont && l == 1 && r == n) {
            std::cout << "YES\n";
            cont = false;
        }

        g[l].push_back(r + 1);

        events.push_back({l, {0, i}});
        events.push_back({m, {1, i}});
        events.push_back({r, {2, i}});
        workers.push_back({m, {l, r}});
    }
    if (!cont) return;
    std::sort(events.begin(), events.end());

    dfs(1, 1);
    if (visited[n + 1]) {
        std::cout << "YES\n";
    } else {
        std::cout << "NO\n";
    }

    /*std::vector<int> cur;
    std::vector< std::vector<int> > req;
    int last = 0;
    for (auto [t, p] : events) {
        auto [type, i] = p;

        if (type == 0) {
            if (cur.size()) {
                req.push_back(cur);
            }
            cur.push_back(i);
        } else if (type == 1) {
            for (auto v : cur) {
                if (v == i) continue;
                rg[v].push_back(i);
                g[i].push_back(v);
            }
        } else {
            req.push_back(cur);
            cur.erase(std::find(cur.begin(), cur.end(), i));

            if (last + 1 >= workers[i].second.first) {
                last = std::max(last, workers[i].second.second);
            }
        }
    }

    if (last != n) {
        std::cout << "NO\n";
        return;
    }

    int c = 1;
    for (int i = 0; i < k; i++) {
        if (visited[i]) continue;
        dfs(i, c, 1);
        c++;
    }

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (workers[i].second.first != 1) {
                continue;
            }
            if (workers[j].second.second != n) {
                continue;
            }
            if (workers[i].second.second + 1 < workers[j].second.first) {
                continue;
            }
            if (workers[j].second.first <= workers[i].first && workers[i].first <= workers[j].second.second 
            && workers[i].second.first <= workers[j].first && workers[j].first <= workers[i].second.second) {
                continue;
            }
            std::cout << "YES\n";
            return;
        }
    }
    std::cout << "NO\n";
    return;

    if (cycles.size() != 0) {
        std::cout << "NO\n";
        return;
    }

    std::cout << "YES\n";*/
}


int main() {
    int t;
    std::cin >> t;

    while (t--) {
        solve();
    }
}