#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
 
 
std::vector< std::vector<int> > g;
std::vector< std::vector<int> > rg;
std::vector< std::pair< int, std::pair<int, int> > > events, workers;
std::vector<int> visited, tin(5e5 + 10), tout(5e5 + 10), depth(5e5 + 10);
std::vector< std::pair<int, std::vector<int> > > cycles;
int n, k, l, m, r;
int timer = 0;
 
 
void dfs(int v, int c, int d) {
    visited[v] = c;
    tin[v] = ++timer;
    depth[v] = d;
    tout[v] = 0;
    for (auto u : g[v]) {
        if (visited[u] == c && tout[u] == 0) {
            cycles.push_back({u, {v}});
            cycles[cycles.size() - 1].second.reserve(d - depth[u] + 1);
        } else if (visited[u] == 0) {
            dfs(u, c, d + 1);
        }
    }
    tout[v] = ++timer;
 
    for (int i = 0; i < cycles.size(); i++) {
        if (cycles[i].first == -1) continue;
        if (depth[cycles[i].second[cycles[i].second.size() - 1]] >= depth[v]) continue;
 
        cycles[i].second.push_back(v);
 
        if (cycles[i].first == v) {
            cycles[i].first = -1;
        }
    }
}


bool check(int c, std::vector<int> &deleted) {
    if (c == cycles.size()) {
        int last = 1;
        for (auto [t, p] : events) {
            auto [type, i] = p;

            if (std::find(deleted.begin(), deleted.end(), i) != deleted.end()) {
                continue;
            }
    
            if (last + 1 >= workers[i].second.first) {
                last = std::max(last, workers[i].second.second);
            }
        }
        return last == n;
    }

    bool res = false;
    for (auto v : cycles[c].second) {
        deleted.push_back(v);
        res = res || check(c + 1, deleted);
        deleted.pop_back();
    }
    return res;
}

 
void solve() {
    std::cin >> n >> k;
 
    g.clear();
    rg.clear();
    visited.clear();
    events.clear();
    workers.clear();
    cycles.clear();
 
    g.resize(k + 1);
    rg.resize(k + 1);
    visited.resize(k + 1, 0);
 
    for (int i = 0; i < k; i++) {
        std::cin >> l >> m >> r;
        events.push_back({l, {0, i}});
        events.push_back({m, {1, i}});
        events.push_back({r, {2, i}});
        workers.push_back({m, {l, r}});
    }
    std::sort(events.begin(), events.end());
 
    std::vector<int> cur;
    int last = 0;
    for (auto [t, p] : events) {
        auto [type, i] = p;
 
        if (type == 0) {
            cur.push_back(i);
        } else if (type == 1) {
            for (auto v : cur) {
                if (v == i) continue;
                rg[v].push_back(i);
                g[i].push_back(v);
            }
        } else {
            cur.erase(std::find(cur.begin(), cur.end(), i));
 
            if (last + 1 >= workers[i].second.first) {
                last = std::max(last, workers[i].second.second);
            }
        }
    }
 
    if (last != n) {
        std::cout << "NO\n";
        return;
    }
 
    int c = 1;
    for (int i = 0; i < k; i++) {
        if (visited[i]) continue;
        dfs(i, c, 1);
        c++;
    }
 
    std::vector<int> a;
    if (check(0, a)) {
        std::cout << "YES\n";
    } else {
        std::cout << "NO\n";
    }
}
 
 
int main() {
    int t;
    std::cin >> t;
 
    while (t--) {
        solve();
    }
}