#include <iostream>
#include <vector>
#include <algorithm>
#include <set>


std::vector< std::vector<int> > g;
std::vector< std::vector<int> > rg;
std::vector<int> visited;


bool dfs(int v, int c) {
    visited[v] = c;
    for (auto u : g[v]) {
        if (visited[u] == c) {
            return false;
        } else if (visited[u] == 0) {
            if (!dfs(u, c)) {
                return false;
            }
        }
    }
    return true;
}


void solve() {
    int n, k, l, m, r;
    std::cin >> n >> k;

    g.clear();
    rg.clear();
    visited.clear();

    g.resize(k + 1);
    rg.resize(k + 1);
    visited.resize(k + 1, 0);

    std::vector< std::pair< int, std::pair<int, int> > > events, workers;
    for (int i = 0; i < k; i++) {
        std::cin >> l >> m >> r;
        events.push_back({l, {0, i}});
        events.push_back({m, {1, i}});
        events.push_back({r, {2, i}});
        workers.push_back({m, {l, r}});
    }
    std::sort(events.begin(), events.end());

    std::set<int> cur;
    int last = 0;
    for (auto [t, p] : events) {
        auto [type, i] = p;

        if (type == 0) {
            cur.insert(i);
        } else if (type == 1) {
            for (auto v : cur) {
                if (v == i) continue;
                rg[v].push_back(i);
                g[i].push_back(v);
            }
        } else {
            cur.erase(i);

            if (last + 1 == workers[i].second.first) {
                last = workers[i].second.second;
            }
        }
    }

    if (last != n) {
        std::cout << "NO\n";
        return;
    }

    int c = 1;
    for (int i = 0; i < k; i++) {
        if (visited[i]) continue;
        if (!dfs(i, c)) {
            std::cout << "NO\n";
            return;
        }
        c++;
    }

    std::cout << "YES\n";
}


int main() {
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
}