#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
int n, d;
vector <vector <int>> gtree;
vector <int> used, glyb, pred;
void dfsbase(int v) {
    used[v] = 1;
    for (auto elem : gtree[v]) {
        if (!used[elem]) {
            glyb[elem] = glyb[v] + 1;
            pred[elem] = v;
            dfsbase(elem);
        }
    }
}
int dist(int v, int u) {
    int ans = 0;
    while (glyb[v] > glyb[u]) {
        v = pred[v]; ans++;
    }
    while (glyb[u] > glyb[v]) {
        u = pred[u]; ans++;
    }
    while (v != u) {
        v = pred[v]; u = pred[u];
        ans += 2;
    }
    return ans;
}
int n1, n2, version = 0;
vector <vector <int>> g;
vector <int> mt, used2;
bool try_kuhn(int v) {
    if (used2[v] == version) { return false; }
    used2[v] = version;
    for (auto elem : g[v]) {
        if (mt[elem] == -1 || try_kuhn(mt[elem])) {
            mt[elem] = v;
            return true;
        }
    }
    return false;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    cin >> n >> d; gtree.resize(n); used.resize(n); glyb.resize(n); pred.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u; cin >> v >> u; v--; u--;
        gtree[v].push_back(u); gtree[u].push_back(v);
    }
    dfsbase(0);
    vector <int> dolya1, dolya2;
    vector <int> index(n);
    for (int i = 0; i < n; i++) {
        if (glyb[i] % 2 == 0) {
            dolya1.push_back(i);
        } else {
            index[i] = dolya2.size();
            dolya2.push_back(i);
        }
    }
    n1 = dolya1.size(), n2 = dolya2.size();
    g.resize(n1); mt.assign(n2, -1); used2.resize(n1);
    for (int i=0; i<n1;i++) {
        int ver = dolya1[i];
        for (auto elem:gtree[ver]) {
            g[i].push_back(index[elem]);
        }
    }
    for (int i = 0; i < n1; i++) {
        version += 1;
        try_kuhn(i);
    }
    vector <int> ans1, ans2;
    for (int i = 0; i < n2; i++) {
        if (mt[i] != -1) {
            ans1.push_back(dolya1[mt[i]]+1);
            ans2.push_back(dolya2[i]+1);
        }
    }
    cout << ans1.size() << "\n";
    for (int i = 0; i < ans1.size(); i++) {
        cout << ans1[i] << " " << ans2[i] << "\n";
    }
    return 0;
}
