#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
//#define int long long
const int maxn = 4e6 + 10;
int seg_sz = 1, N;

struct Segtree{
    vector <int> t, clear, cnt;
    Segtree(){
        while (seg_sz <= maxn){
            seg_sz *= 2;
        }
        t.resize(2 * seg_sz - 1);
        clear.resize(2 * seg_sz - 1);
        cnt.resize(2 * seg_sz - 1);
    }
    void push(int v, int l, int r){
        if (clear[v] == 0){
            return;
        }
        if (clear[v]){
            clear[v] = 0;
            t[v] = 0;
            cnt[v] = 0;
            if (l + 1 != r){
                clear[2 * v + 1] = 1;
                t[2 * v + 1] = 0;
                t[2 * v + 2] = 0;
                cnt[2 * v + 1] = 0;
                cnt[2 * v + 2] = 0;
                clear[2 * v + 2] = 1;
            }
        }
    }
    int get(int ql, int qr, int v = 0, int l = 0, int r = N){
        push(v, l, r);
        if (ql <= l && r <= qr){
            return t[v];
        }
        if (qr <= l || r <= ql){
            return 0;
        }
        int m = (r + l) / 2;
        return get(ql, qr, 2 * v + 1, l, m) + get(ql, qr, 2 * v + 2, m, r);
    }
    int get_cnt(int ql, int qr, int v = 0, int l = 0, int r = N){
        push(v, l, r);
        if (ql <= l && r <= qr){
            return cnt[v];
        }
        if (qr <= l || r <= ql){
            return 0;
        }
        int m = (r + l) / 2;
        return get_cnt(ql, qr, 2 * v + 1, l, m) + get_cnt(ql, qr, 2 * v + 2, m, r);
    }
    void set(int pos, int cnts, int v = 0, int l = 0, int r = N){
        push(v, l, r);
        if (l + 1 == r){
            t[v] += pos * cnts;
            cnt[v] += cnts;
            return;
        }
        int m = (r + l) / 2;
        if (pos < m){
            set(pos, cnts, 2 * v + 1, l, m);
        }
        else{
            set(pos, cnts, 2 * v + 2, m, r);
        }
        t[v] = t[2 * v + 1] + t[2 * v + 2];
        cnt[v] = cnt[2 * v + 1] + cnt[2 * v + 2];
    }
    void update_clear(int ql, int qr, int v = 0, int l = 0, int r = N){
        push(v, l, r);
        if (ql <= l && r <= qr){
            clear[v] = 1;
            push(v, l, r);
            return;
        }
        if (qr <= l || r <= ql){
            return;
        }
        int m = (r + l) / 2;
        update_clear(ql, qr, 2 * v + 1, l, m);
        update_clear(ql, qr, 2 * v + 2, m, r);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
        cnt[v] = cnt[2 * v + 1] + cnt[2 * v + 2];
    }
};
using ordered_set = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin>>n>>m;
    N = maxn;
    vector <vector <char> > p(n, vector <char> (m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin>>p[i][j];
        }
    }
    vector <vector <int> > a(n, vector <int> (m, 0));
    for (int i = 0; i < n; i++){
        for (int j = m - 1; j >= 0; j--){
            if (p[i][j] == '1'){
                a[i][j]++;
                if (j < m - 1){
                    a[i][j] += a[i][j + 1];
                }
            }
        }
    }
    int ans = 0;
    Segtree tree;
    for (int j = 0; j < m; j++){
        int tek = 0;
        for (int i = 0; i < n; i++){
            tek = a[i][j];
            int cnt = tree.get_cnt(tek + 1, maxn);
            tree.update_clear(tek + 1, maxn);
            tree.set(tek, cnt + 1);
            ans = max(ans, tree.get(0, tek + 1));

        }
        tree.clear[0] = 1;
    }
    cout<<ans<<endl;


}