#include <iostream>
#include <vector>

using namespace std;

vector<pair<int, int>> stree;

void push(int i, int lc, int rc) {
    if (stree[i].second == -1) {
        return;
    }
    stree[2*i+1].second = stree[i].second;
    stree[2*i+2].second = stree[i].second;
    stree[i].first = stree[i].second*(rc-lc+1);
    stree[i].second = -1;
}

int get(int i, int lc, int rc, int l, int r) {
    if (rc < l || r < lc) {
        return 0;
    }
    push(i, lc, rc);
    if (l <= lc && rc <= r) {
        return stree[i].first;
    }
    int m = (lc+rc)/2;
    return get(2*i+1, lc, m, l, r)+get(2*i+2, m+1, rc, l, r);
}

void set(int i, int lc, int rc, int l, int r, int c) {
    if (rc < l || r < lc) {
        return;
    }
    push(i, lc, rc);
    if (l <= lc && rc <= r) {
        stree[i].second = c;
        push(i, lc, rc);
        return;
    }
    int m = (lc+rc)/2;
    set(2*i+1, lc, m, l, r, c);
    set(2*i+2, m+1, rc, l, r, c);
    stree[i].first = stree[2*i+1].first + stree[2*i+1].second;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        stree.assign(4*n, {0, 0});
        for (int i = 0; i < k; i++) {
            int l, m, r;
            cin >> l >> m >> r;
            set(0, 0, n-1, l, r, 1);
        }
        if (get(0, 0, n-1, 0, n-1) == n) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}