#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()
#define node int v, int l, int r
#define root 0, 0, n
#define lv 2 * v + 1
#define rv 2 * v + 2
#define LSon lv, l, m
#define RSon rv, m, r

const int INF = 1e9;

vector<int> t;

void update(node, int pos, int x) {
    if (r - l == 1) {
        t[v] = min(t[v], x);
        return;
    }
    int m = (l + r) / 2;
    if (pos < m)
        update(LSon, pos, x);
    else
        update(RSon, pos, x);
    t[v] = min(t[lv], t[rv]);
}

int query(node, int ql, int qr) {
    if (l >= qr || r <= ql) return INF;
    if (l >= ql && r <= qr) return t[v];
    int m = (l + r) / 2;
    return min(query(LSon, ql, qr), query(RSon, ql, qr));
}

struct seg {
    int l = 0, m = 0, r = 0;
    bool operator<(const seg &other) const {
        if (r == other.r)
            return l < other.l;
        return r < other.r;
//        return l < other.l;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    t.assign(4 * n, INF);
    vector<seg> segs(k);
    for (int i = 0; i < k; ++i) {
        cin >> segs[i].l >> segs[i].m >> segs[i].r;
        --segs[i].l;
        --segs[i].r;
        --segs[i].m;
    }
    sort(all(segs));
    for (auto [l, m, r] : segs) {
        if (l == 0) {
            //cout << "UPD " << l << " " << m << " " << r << endl;
            update(root, r, m);
            continue;
        }
        int val = query(root, l - 1, m);
        if (val != INF) {
            //cout << "UPD " << l << " " << m << " " << r << endl;
            update(root, r, m);
        } else {
            val = query(root, m, r);
            //cout << l << " " << r << " " << val << "\n";
            if (val < l) {
                //cout << "UPD " << l << " " << m << " " << r << endl;
                update(root, r, m);
            }
        }
//        for (auto el : t) {
//            cout << el << " ";
//        }
//        cout << endl;
    }
    if (query(root, n - 1, n) != INF) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
