#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

vector<vector<int>> g;
vector<int> mt, used, col;
int timer = 0;

void dfs(int v, int p, int c) {
    col[v] = c;
    used[v] = 1;
    for (auto to : g[v]) if (!used[to]) {
        dfs(to, v, 1 - c);
    }
}

bool kuhn(int v) {
    used[v] = timer;
    for (auto to : g[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return true;
        }
    }
    for (auto to : g[v]) if (used[mt[to]] != timer){
        if (kuhn(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

void subtask5(int n, int d) {
    vector<vector<int>> g1(n);
    vector<int> dist;
    for (int st = 0; st < n; ++st) {
        dist.assign(n, n);
        dist[st] = 0;
        queue<int> q;
        q.push(st);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            if (dist[v] >= d)
                continue;
            for (auto to : g[v]) if (dist[to] == n) {
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
        for (int to = 0; to < n; ++to) {
            if ((dist[to] & 1) && dist[to] <= d) {
                //cout << st << " " << to << endl;
                g1[st].push_back(to);
            }
        }
    }
    swap(g, g1);
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    subtask5(n, d);
    mt.resize(n, -1);
    col.resize(n);
    used.assign(n, 0);
    dfs(0, -1, 0);
    used.assign(n, -1);
    int ans = 0;
    if (d == n - 1) {
        vector<int> b, w;
        for (int i = 0; i < n; ++i) {
            if (col[i] == 0)
                b.push_back(i);
            else
                w.push_back(i);
        }
        cout << min(b.size(), w.size()) << "\n";
        while (!b.empty() && !w.empty()) {
            cout << b.back() + 1 << " " << w.back() + 1 << "\n";
            b.pop_back();
            w.pop_back();
        }
        return 0;
    }
    for (int i = 0; i < n; ++i) if (col[i]) {
        if (kuhn(i))
            ++ans;
        ++timer;
    }
    cout << ans << "\n";
    for (int i = 0; i < n; ++i) if (mt[i] != -1) {
        cout << i + 1 << " " << mt[i] + 1 << "\n";
    }
}
