#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

using ll = long long int;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl = vector <vl>;
using vb = vector <bool>;
using vvb = vector <vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

ll OK(ll x, vl& prefsum, vl& mas) {
	ll l = 0, r = mas.size();

	while (r - l > 1) {
		ll m = l + (r - l) / 2;

		if (mas[m] <= x) l = m;
		else r = m;
	}

	ll res = prefsum[l];
	for (int i = l + 1; i < mas.size(); i++) {
		res += (mas[i] - x) * (mas[i] - x);
	}

	return res;
}

ll binf(ll l, ll r, vl &mas, vl &prefsum, ll cost, ll d) {
	while (r - l > 1) {
		ll m1 = l + (r - l) / 3;
		ll m2 = r - (r - l) / 3;
		if (m1 == l) ++m1;
		if (m2 == r) --m2;


		ll cu1 = OK(m1 * d, prefsum, mas) + m1 * cost;
		ll cu2 = OK(m2 * d, prefsum, mas) + m2 * cost;

		if (cu1 > cu2) l = m1;
		else r = m2;
	}

	ll cu1 = OK(l * d, prefsum, mas) + l * cost;
	ll cu2 = OK(r * d, prefsum, mas) + r * cost;

	return min(cu1, cu2);
}

void solut() {
	ll n;

	cin >> n;

	vl mas(n);

	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}

	sort(mas.begin(), mas.end());

	ll x0, d;

	cin >> x0 >> d;

	vl prefsum(n);

	for (int i = 0; i < n; i++) {
		ll lastx = (mas[i] - x0) / d * d + x0;
		ll nextx = lastx + d;

		prefsum[i] = min((mas[i] - lastx) * (mas[i] - lastx), (nextx - mas[i]) * (nextx - mas[i]));
		if (i != 0) prefsum[i] += prefsum[i - 1];
	}

	vl sufsum(n);

	ll m;

	cin >> m;

	while (m--) {
		ll cost;

		cin >> cost;

		ll l = 0, r = 10000000;

		ll res = binf(l, r, mas, prefsum, cost, d);

		cout << res << "\n";
	}
}

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;

	while (t--) {
		solut();
	}
}
