#include <bits/stdc++.h>
using namespace std;
#define int long long

struct Line {
    int k, b;
    bool operator==(const Line &o) const {
        return o.k == k && o.b == b;
    }
    int count(int x) {
        return k * x + b;
    }
};
constexpr int INF = 1e18;
Line EMPTY = {0, INF};

struct Node {
    Line ln = EMPTY;
    int l = -1, r = -1;
};

struct LiChaoTree {
    vector<Node> t;
    LiChaoTree() {
        t.emplace_back();
    }
    void add(int v, int l, int r, Line ln) {
        int m = (l + r) / 2;
        if (ln.count(m) < t[v].ln.count(m)) {
            swap(ln, t[v].ln);
        }
        if (r - l == 1) {
            return;
        }
        if (ln.count(l) < t[v].ln.count(l)) {
            if (t[v].l == -1) {
                t[v].l = t.size();
                t.emplace_back();
            }
            add(t[v].l, l, m, ln);
        }
        if (ln.count(r) < t[v].ln.count(r)) {
            if (t[v].r == -1) {
                t[v].r = t.size();
                t.emplace_back();
            }
            add(t[v].r, m, r, ln);
        }
    }
    int get(int v, int l, int r, int x) {
        if (l >= r) {
            return INF;
        }
        int m = (l + r) / 2;
        int ans = t[v].ln.count(x);
        if (x < m) {
            if (t[v].l != -1) {
                ans = min(ans, get(t[v].l, l, m, x));
            }
        } else {
            if (t[v].r != -1) {
                ans = min(ans, get(t[v].r, m + 1, r, x));
            }
        }
        return ans;
    }
};

int norm_div(int n, int k) {
    if (n >= 0 || n % k == 0) {
        return n / k;
    }
    return n / k - 1;
}

signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    // map<int, vector<int>> aa;
    int x0, d;
    cin >> x0 >> d;
    // for (int i = 0; i < n; ++i) {
    //     int lf = norm_div(a[i], d) * d;
    //     int rt = norm_div(a[i], d) * d + d;

    // }
    // x0 == 0
    LiChaoTree lct;
    for (int i = 0; i - 2 * d < a.back(); i += d) {
        int dd = 0;
        for (int j = 0; j < n; ++j) {
            int lf = norm_div(a[j], d) * d;
            int rt = norm_div(a[j], d) * d + d;
            int dist = (i - a[j]) * (i - a[j]);
            if (rt <= i) {
                dist = min(dist, (rt - a[j]) * (rt - a[j]));
            }
            if (lf <= i) {
                dist = min(dist, (lf - a[j]) * (lf - a[j]));
            }
            dd += dist;
            if (dd >= INF) {
                dd = INF;
            }
        }
        // cout << i << " " << dd << "\n";
        lct.add(0, 0, 100000005, {i / d, dd});        
    }
    int qq;
    cin >> qq;
    for (int ii = 0; ii < qq; ++ii) {
        int xx;
        cin >> xx;
        cout << lct.get(0, 0, 100000005, xx) << "\n";
    }
}