#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> gr;
vector<int> dep;

void dfs(int u, int p, int d) {
    dep[u] = d;
    for (int v : gr[u]) {
        if (v != p) {
            dfs(v, u, d + 1);
        }
    } 
}

vector<vector<int>> dist;
void dfsCountDists(int u, int p, int d, int startU) {
    dist[startU][u] = d;
    for (int v : gr[u]) {
        if (v != p) {
            dfsCountDists(v, u, d + 1, startU);
        }
    }
}

vector<vector<int>> gr2;
vector<int> match;
vector<bool> used;
bool kuhn(int u) {
    if (used[u] || match[u] != -1) {
        return false;
    }
    used[u] = true;
    for (int v : gr2[u]) {
        if (match[v] == -1 || kuhn(match[v])) {
            match[v] = u;
            match[u] = v;
            return true;
        }
    }
    return false;
}

int main() {
    int n, d;
    cin >> n >> d;
    // n <= 200
    dep.resize(n);
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }
    dfs(0, -1, 0);
    dist.resize(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        dfsCountDists(i, -1, 0, i);
    }
    match.resize(n, -1);
    gr2.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (dist[i][j] <= d && dist[i][j] % 2 == 1) {
                gr2[i].push_back(j);
            }
        }
    }
    int ans = 0;
    while (true) {
        used.assign(n, false);
        bool changed = false;
        for (int i = 0; i < n; ++i) {
            if (dep[i] % 2 == 0 && kuhn(i)) {
                ans++;
                changed = true;
            }
        }
        if (!changed) {
            break;
        }
    }
    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        if (match[i] != -1 && i < match[i]) {
            cout << i + 1 << " " << match[i] + 1 << "\n";
        }
    }
}