#include <bits/stdc++.h>
 
#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif
 
using namespace std;
 
const int INF = 1e9 + 7;
 
template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}
 
struct Man {
    int l, m, r;
};

bool intersect(Man a, Man b) {
    return a.l <= b.m && b.m <= a.r && b.l <= a.m && a.m <= b.r;
}

void solve() {
    int n, k; cin >> n >> k;
 
    vector<Man> lst(k);
    for (int i = 0; i < k; i++) {
        cin >> lst[i].l >> lst[i].m >> lst[i].r;
        lst[i].l--, lst[i].m--, lst[i].r--;
    }

    vector<pair<int, int>> events;
    for (int i = 0; i < k; i++) {
        events.emplace_back(lst[i].l, 1);
        events.emplace_back(lst[i].r + 1, -1);
    }

    sort(all(events), [](pair<int, int> a, pair<int, int> b) {
        return a.first < b.first || (a.first == b.first && a.second > b.second);
    });
  
    int ans = 0, cur = 0, prev = events[0].first;
    for (auto &[x, delta] : events) {
        // cout << x << " " << delta << " | " << cur << endl;
        if (cur) {
            ans += x - prev;
        }
        cur += delta;
        prev = x;
    }
  
    // cout << ans << endl;
  
    if (ans < n) {
        cout << "NO" << endl;
    }
 
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (intersect(lst[i], lst[j])) {
                cout << "NO" << endl;
                return;
            }
        }
    }
 
    cout << "YES" << endl;
}
 
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
 
    int t; cin >> t;
    while (t--) solve();
}
