#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, set<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct Man {
    int l, m, r;
};

bool intersect(Man a, Man b) {
    return a.l <= b.m && b.m <= a.r && b.l <= a.m && a.m <= b.r;
}

bool in(int l, int m, int r) {
    return l <= m && m <= r;
}

void solve() {
    int n, k; cin >> n >> k;

    vector<Man> lst(k);
    for (int i = 0; i < k; i++) {
        cin >> lst[i].l >> lst[i].m >> lst[i].r;
        lst[i].l--, lst[i].m--, lst[i].r--;
    }

    for (int i = 0; i < k; i++) {
        // debug(i);
        int l = lst[i].l, r = lst[i].r;
        vector<int> used(k);
        used[i] = true;
        while (true) {
            int v = -1;
            for (int j = 0; j < k; j++) {
                if (used[j]) continue;
                if (in(l, lst[j].m, r)) continue;
                if (lst[j].l > r) continue;

                if (v == -1 || lst[j].r > lst[v].r) {
                    v = j;
                }
            }

            if (v != -1) {
                used[v] = true;
                l = min(l, lst[v].l);
                r = max(r, lst[v].r);
                continue;
            }

            for (int j = 0; j < k; j++) {
                if (used[j]) continue;
                if (in(l, lst[j].m, r)) continue;
                if (lst[j].r < l) continue;

                if (v == -1 || lst[j].l < lst[v].l) {
                    v = j;
                }
            }

            if (v != -1) {
                used[v] = true;
                l = min(l, lst[v].l);
                r = max(r, lst[v].r);
            } else {
                break;
            }
        }

        // cout << l << " " << r << endl;

        if (r - l == n - 1) {
            cout << "YES" << endl;
            return;
        }
    }

    cout << "NO" << endl;

    // vector<set<int>> g(k);
    // for (int i = 0; i < k; i++) {
    //     for (int j = i + 1; j < k; j++) {
    //         if (intersect(lst[i], lst[j])) {
    //             g[i].emplace(j);
    //             g[j].emplace(i);
    //         }
    //     }
    // }

    // for (int i = 0; i < k; i++) {
    //     cout << i << ": " << g[i] << endl;
    // }

    // for (int mask = 1; mask < (1 << k); mask++) {
    //     vector<int> inds;
    //     for (int i = 0; i < k; i++) {
    //         if ((mask >> i) & 1) {
    //             inds.emplace_back(i);
    //         }
    //     }

    //     bool ok = true;
    //     for (auto i : inds) {
    //         for (auto j : inds) {
    //             if (i == j) continue;
    //             if (!g[i].count(j)) {
    //                 ok = false;
    //                 break;
    //             }
    //         }
    //         if (!ok) break;
    //     }

    //     if (!ok) continue;

    //     debug(inds);

    //     vector<int> used(n);
    //     for (auto i : inds) {
    //         for (int j = lst[i].l; j <= lst[i].r; j++) {
    //             used[j] = true;
    //         }
    //     }

    //     // cout << used << endl;

    //     int ans = 0;
    //     for (int i = 0; i < n; i++) {
    //         ans += used[i];
    //     }

    //     if (ans == n) {
    //         cout << "YES" << endl;
    //         return;
    //     }
    // }

    // cout << "NO" << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while (t--) solve();
}
