#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, set<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct Man {
    int l, m, r;
};

bool intersect(Man a, Man b) {
    return a.l <= b.m && b.m <= a.r && b.l <= a.m && a.m <= b.r;
}

bool in(int l, int m, int r) {
    return l <= m && m <= r;
}

void solve() {
    int n, k; cin >> n >> k;

    map<int, int> dct;
    for (int i = 0; i < k; i++) {
        int l, m, r; cin >> l >> m >> r;

        if (dct.find(l) == dct.end()) {
            dct[l] = r;
        } else {
            dct[l] = max(r, dct[l]);
        }
    }

    vector<Man> lst;
    for (auto &[l, r] : dct) {
        lst.push_back(Man{l, l, r});
    }

    sort(all(lst), [](Man a, Man b) {
        return a.l > b.l;
    });

    int l = lst[0].l, r = lst[0].r;
    for (int i = 0; i < len(lst); i++) {
        if (r < lst[i].l) {
            cout << "NO" << endl;
            return;
        }
        l = min(l, lst[i].l);
        r = max(r, lst[i].r);
    }

    // cout << l << " " << r << endl;

    if (r - l == n - 1) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while (t--) solve();
}
