#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, set<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct Man {
    int l, m, r;
};

bool intersect(Man a, Man b) {
    return a.l <= b.m && b.m <= a.r && b.l <= a.m && a.m <= b.r;
}

bool in(int l, int m, int r) {
    return l <= m && m <= r;
}

void solve() {
    int n, k; cin >> n >> k;

    vector<Man> lst;
    for (int i = 0; i < k; i++) {
        int l, m, r; cin >> l >> m >> r;
        lst.push_back(Man{l, m, r});
    }

    vector<pair<int, int>> events;
    for (int i = 0; i < k; i++) {
        events.emplace_back(lst[i].l, 1);
        events.emplace_back(lst[i].r + 1, -1);
    }

    int ans = 0, cur = 0, prev = events[0].first;
    for (auto &[x, delta] : events) {
        if (cur) {
            ans += x - prev;
        }
        cur += delta;
        prev = x;
    }
    
    // cout << ans << endl;
    if (ans == n) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while (t--) solve();
}
