#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

int n, d;
vector<int> h, mt, used;
vector<vector<int>> g, g0;

void height(int v = 0, int p = -1) {
    for (auto u : g[v]) {
        if (u == p) continue;
        h[u] = h[v] + 1;
        height(u, v);
    }
}

void dfs(int f, int v, int p = -1, int l = 0) {
    if (l > d) return;
    if (h[v] % 2 == 1 && h[f] % 2 == 0) {
        g0[f].emplace_back(v);
    }

    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(f, u, v, l + 1);
    }
}

bool par(int v) {
    if (used[v]) return false;
    used[v] = true;

    for (auto u : g0[v]) {
        if (mt[u] == -1 || par(mt[u])) {
            mt[u] = v;
            return true;
        }
    }

    return false;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> d;

    g.resize(n);
    h.resize(n);
    g0.resize(n);
    mt.assign(n, -1);
    used.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }

    height();

    for (int v = 0; v < n; v++) {
        dfs(v, v);
        // cout << v << ": " << g0[v] << endl;
    }

    int cnt = 0;
    for (int i = 0; i < n; i++) {
        debug(i);
        used.assign(n, false);
        cnt += par(i);
    }

    debug(mt);

    cout << cnt << endl;
    for (int i = 0; i < n; i++) {
        if (mt[i] == -1) continue;
        cout << mt[i] + 1 << " " << i + 1 << endl;
    }
}
