#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC Optimize("O3, Ofast, unroll-loops")
#endif
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define int ll
#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
#define pii pair<int, int>

mt19937 rnd(time(0));

struct F {
    vector<int> t;
    F(int n) {
        t.assign(n, 0);
    }
    void upd(int i, int x) {
        for (; i < t.size(); i = (i|(i+1))) {
            t[i] = x;
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r&(r+1))-1) {
            ans = max(ans, t[r]);
        }
        return ans;
    }
};

struct seg {
    int l, m, r;
    seg(int l, int m, int r) : l(l), m(m), r(r) {}
};

void get(int n, vector<seg> S, F &f) {
    sort(all(S), [&](seg a, seg b) {
        return a.m < b.m;
    });
    for (auto &s : S) {
        if (f.get(s.l-1) >= s.l - 1) {
            f.upd(s.m, s.r);
        }
    }
}

bool stupid(int m, vector<seg> S) {
    int n = S.size();
    vector<int> p(n);
    iota(all(p), 0);
    do {
        vector<int> a(m, 0);
        for (int i = 0; i < n; ++i) {
            if (a[S[p[i]].m-1] == 0) {
                for (int j = S[p[i]].l - 1; j < S[p[i]].r; ++j) {
                    a[j] = 1;
                }
            }
        }
        if (count(all(a), 0) == 0) {
            return true;
        }
    } while (next_permutation(all(p)));
    return false;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        F l(n + 1), r(n + 1);
        vector<seg> s;
        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            s.pb(seg(a, b, c));
        }
        get(n, s, l);
        for (auto &x : s) {
            x.l = n - x.l + 1;
            x.m = n - x.m + 1;
            x.r = n - x.r + 1;
            swap(x.l, x.r);
        }
        get(n, s, r);
        bool ok = false;
        for (auto &sg : s) {
            // cout << sg.l << " : " << sg.r << endl;
            int left = r.get(sg.l - 1);
            int right = l.get(n - sg.r);
            // cout << left << ' ' << right << endl;
            if (left >= sg.l - 1 && left < sg.r && right >= n - sg.r && right <= n - sg.l) {
                ok = true;
                break;
            }
        }
        // assert(ok == stupid(n, s));
        if (ok) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
}