#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC Optimize("O3, Ofast, unroll-loops")
#endif
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
#define pii pair<int, int>

mt19937 rnd(time(0));

struct F {
    vector<int> t;
    F(int n) {
        t.assign(n, 0);
    }
    void upd(int i, int x) {
        for (; i < t.size(); i = (i|(i+1))) {
            t[i] = max(t[i], x);
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r&(r+1))-1) {
            ans = max(ans, t[r]);
        }
        return ans;
    }
};

struct seg {
    int l, m, r, ind;
    seg(int l, int m, int r, int ind) : l(l), m(m), r(r), ind(ind) {}
};

vector<bool> get(int m, vector<seg> S) {
    // F f(m + 1);
    int n = S.size();
    vector<bool> ok(n, false);
    sort(all(S), [&](seg a, seg b) {
        return mp(a.r, a.l) < mp(b.r, b.l);
    });
    for (auto &s : S) {
        if (s.l == 1) {
            ok[s.ind] = true;
        }
        for (auto &s2 : S) {
            if (ok[s2.ind]) {
                if (s2.m < s.l && s2.r >= s.l - 1 && s2.r <= s.r) {
                    ok[s.ind] = true;
                    break;
                }
                if (s.m > s2.r && s2.r >= s.l - 1 && s.l >= s2.l) {
                    ok[s.ind] = true;
                    break;
                }
            }
        }
    }
    return ok;
}

bool stupid(int m, vector<seg> S) {
    int n = S.size();
    vector<int> p(n);
    iota(all(p), 0);
    do {
        vector<int> a(m, 0);
        for (int i = 0; i < n; ++i) {
            if (a[S[p[i]].m-1] == 0) {
                for (int j = S[p[i]].l - 1; j < S[p[i]].r; ++j) {
                    a[j] = 1;
                }
            }
        }
        if (count(all(a), 0) == 0) {
            return true;
        }
    } while (next_permutation(all(p)));
    return false;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<seg> s;
        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            s.pb(seg(a, b, c, i));
        }
        vector<bool> ok1 = get(n, s);
        for (auto &x : s) {
            x.l = n - x.l + 1;
            x.m = n - x.m + 1;
            x.r = n - x.r + 1;
            swap(x.l, x.r);
        }
        vector<bool> ok2 = get(n, s);
        bool ok = false;
        for (int i = 0; i < m; ++i) {
            if (ok1[i] && ok2[i]) {
                ok = true;
                break;
            }
        }
        // assert(ok == stupid(n, s));
        if (ok) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
}