#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC Optimize("O3, Ofast, unroll-loops")
#endif
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define int ll
#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
#define pii pair<int, int>

mt19937 rnd(11);

struct F {
    vector<int> t;
    F(int n) {
        t.assign(n, 0);
    }
    void inc(int i, int x) {
        for (; i < t.size(); i = (i|(i+1))) {
            t[i] += x;
        }
    }
    int sum(int r) {
        int ans = 0;
        for (; r >= 0; r = (r&(r+1))-1) {
            ans += t[r];
        }
        return ans;
    }
};

struct seg {
    int l, m, r;
    seg(int l, int m, int r) : l(l), m(m), r(r) {}
};

void get(int n, vector<seg> S, F &f) {
    sort(all(S), [&](seg a, seg b) {
        return a.m < b.m;
    });
    f.inc(0, 1);
    for (auto &s : S) {
        if (f.sum(s.m-1) - f.sum(s.l-2) > 0) {
            f.inc(s.r, 1);
        }
    }
}

bool stupid(int m, vector<seg> S) {
    int n = S.size();
    vector<int> p(n);
    iota(all(p), 0);
    do {
        vector<int> a(m, 0);
        for (int i = 0; i < n; ++i) {
            if (a[S[p[i]].m-1] == 0) {
                for (int j = S[p[i]].l - 1; j < S[p[i]].r; ++j) {
                    a[j] = 1;
                }
            }
        }
        if (count(all(a), 0) == 0) {
            return true;
        }
    } while (next_permutation(all(p)));
    return false;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        // n = 50; m = 8;
        F l(n + 1), r(n + 1);
        vector<seg> s;
        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            // a = rnd() % n;
            // b = rnd() % n;
            // c = rnd() % n;
            // if (a > c) {
            //     swap(a, c);
            // }
            // if (a > b) {
            //     swap(a, b);
            // }
            // if (b > c) {
            //     swap(b, c);
            // }
            // ++a; ++b; ++c;
            s.pb(seg(a, b, c));
        }
        get(n, s, l);
        for (auto &x : s) {
            x.l = n - x.l + 1;
            x.m = n - x.m + 1;
            x.r = n - x.r + 1;
            swap(x.l, x.r);
        }
        get(n, s, r);
        bool ok = false;
        for (auto &sg : s) {
            // cout << r.sum(sg.m - 1) - r.sum(sg.l - 2) << ' ' << l.sum(n - sg.m) - l.sum(n - sg.r - 1) << endl;
            if (r.sum(sg.m - 1) - r.sum(sg.l - 2) > 0 && l.sum(n - sg.m) - l.sum(n - sg.r - 1) > 0) {
                ok = true;
                break;
            }
        }
        if (ok != stupid(n, s)) {
            assert(ok);
        }
        if (ok) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
}