#include <bits/stdc++.h>

struct Man
{
  int l, m, r;

  Man(int l, int m, int r) : l(l), r(r), m(m) {}
};

bool operator<(const Man &a, const Man &b)
{
  return b.l <= a.m && a.m <= b.r;
}

std::vector<int> tree;

void upd(int v, int l, int r, int ql, int qr)
{
  if (r <= ql || qr <= l)
    return;
  if (ql <= l && r <= qr) {
    tree[v] = 1;
    return;
  }
  int m = (l + r) / 2;
  upd(2 * v + 1, l, m, ql, qr);
  upd(2 * v + 2, m, r, ql, qr);
}

int get(int v, int l, int r, int i)
{
  if (tree[v] == 1)
    return 1;
  if (r - l == 1)
    return 0;
  int m = (l + r) / 2;
  if (i < m)
    return get(2 * v + 1, l, m, i);
  return get(2 * v + 2, m, r, i);
}

std::vector<std::vector<int>> g;
std::vector<int> topsort, used;

bool dfs(int v) {
  if (used[v] == 1)
    return false;
  if (used[v] == 2)
    return true;
  used[v] = 1;
  for (auto u : g[v]) {
    if (!dfs(u))
      return false;
  }
  topsort.push_back(v);
  used[v] = 2;
  return true;
}

void solve()
{
  int n, k;
  std::cin >> n >> k;
  std::vector<Man> man_s, man_p;
  bool fl = false;
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    std::cin >> l >> m >> r;
    l--, m--, r--;
    if (l == n && r == n - 1) {
      fl = true;
    }
    if (l == 0)
      man_p.emplace_back(l, m, r);
    else
      man_s.emplace_back(l, m, r);
  }
  if (fl) {
    std::cout << "YED\n";
    return;
  }
  for (size_t i = 0; i < man_p.size(); ++i) {
    for (size_t j = 0; j < man_s.size(); ++j) {
      if (man_p[i] < man_s[j] && man_s[j] < man_p[i])
        continue;
      if (man_p[i].r >= man_s[j].l - 1)  {
        std::cout << "YES\n";
        return;
      }
    }
  }
  std::cout << "NO\n";
  return;
}

int main()
{
  int t;
#ifdef LOCAL
  freopen("in/b.txt", "r", stdin);
  freopen("out/b.txt", "w", stdout);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  std::cin >> t;
  for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}