#include <bits/stdc++.h>

struct Man
{
  int l, m, r;

  Man(int l, int m, int r) : l(l), r(r), m(m) {}
};

bool operator<(const Man &a, const Man &b)
{
  return b.l <= a.m && a.m <= b.r;
}

void solve()
{
  int n, k;
  std::cin >> n >> k;
  std::vector<Man> man;
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    std::cin >> l >> m >> r;
    l--, m--, r--;
    man.emplace_back(l, m, r);
  }
  std::vector<std::vector<int>> dp(n + 1, std::vector<int>(n + 1));
  dp[0][0] = 1;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n - i; ++j) {
      if (!dp[i][j])
        continue;
      for (int t = 0; t < k; ++t) {
        if (i <= man[t].m && j <= n - man[t].m - 1) {
          bool fl_l = man[t].l <= i;
          bool fl_r = n - man[t].r - 1 <= j;
          if (fl_l && fl_r) {
            std::cout << "YES\n";
            return;
          }
          if (fl_l)
            dp[man[t].r + 1][j] = 1;
          if (fl_r)
            dp[i][n - man[t].l] = 1; 
        }
      }
    }
  }
  std::cout << "NO\n";
}

int main()
{
  int t;
#ifdef LOCAL
  freopen("in/b.txt", "r", stdin);
  freopen("out/b.txt", "w", stdout);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  std::cin >> t;
  for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}