#include <bits/stdc++.h>

struct Man
{
  int l, m, r;

  Man(int l, int m, int r) : l(l), r(r), m(m) {}
};

bool operator<(const Man &a, const Man &b)
{
  return b.l <= a.m && a.m <= b.r;
}

std::vector<int> tree;

void upd(int v, int l, int r, int ql, int qr)
{
  if (r <= ql || qr <= l)
    return;
  if (ql <= l && r <= qr) {
    tree[v] = 1;
    return;
  }
  int m = (l + r) / 2;
  upd(2 * v + 1, l, m, ql, qr);
  upd(2 * v + 2, m, r, ql, qr);
}

int get(int v, int l, int r, int i)
{
  if (tree[v] == 1)
    return 1;
  if (r - l == 1)
    return 0;
  int m = (l + r) / 2;
  if (i < m)
    return get(2 * v + 1, l, m, i);
  return get(2 * v + 2, m, r, i);
}

void solve()
{
  int n, k;
  std::cin >> n >> k;
  std::vector<Man> man;
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    std::cin >> l >> m >> r;
    l--, m--, r--;
    man.emplace_back(l, m, r);
  }
  std::vector<int> ans(k);
  for (int i = 0; i < k; ++i)
    ans[i] = i;
  std::vector<int> ans0 = ans;
  do {
    tree.assign(4 * n, 0);
    for (int i = 0; i < k; ++i) {
      int c = ans[i];
      if (get(0, 0, n, man[c].m))
        continue;
      upd(0, 0, n, man[c].l, man[c].r + 1);
    }
    bool fl = 1;
    for (int i = 0; i < n && fl; ++i) {
      if (!get(0, 0, n, i))
        fl = false;
    }
    if (fl) {
      std::cout << "YES\n";
      return;
    }
    std::next_permutation(ans.begin(), ans.end());
  } while (ans != ans0);
  std::cout << "NO\n";
}

int main()
{
  int t;
#ifdef LOCAL
  freopen("in/b.txt", "r", stdin);
  freopen("out/b.txt", "w", stdout);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  std::cin >> t;
  for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}