#include <bits/stdc++.h>

#define int long long

std::vector<std::vector<int>> g;
std::vector<int> p, jump, h, left, right;
std::vector<int> match;

void dfs(int v, int par, int dep)
{
  p[v] = par;
  h[v] = dep;
  if (dep % 2 == 0)
    left.push_back(v);
  else
    right.push_back(v);
  if (h[jump[par]] - h[par] == h[jump[jump[par]]] - h[jump[par]])
    jump[v] = jump[jump[par]];
  else
    jump[v] = par;
  for (auto u : g[v]) {
    if (u != par)
      dfs(u, v, dep + 1);
  }
}

std::vector<int> used;

int try_kuhn(int v, int c)
{
  if (used[v] == c)
    return 0;
  used[v] = c;
  for (auto u : right) {
    if (match[u] == -1) {
      match[u] = v;
      return 1;
    }
  }
  for (auto u : right) {
    if (try_kuhn(match[u], c)) {
      match[u] = v;
      return 1;
    }
  }
  return 0;
}

void solve()
{
  int n, d;
  std::cin >> n >> d;
  g.assign(n, std::vector<int>());
  for (int i = 0; i < n - 1; ++i) {
    int u, v;
    std::cin >> u >> v;
    u--, v--;
    g[u].push_back(v);
    g[v].push_back(u);
  }
  left.clear();
  p.assign(n, 0);
  h.assign(n, 0);
  jump.assign(n, 0);
  dfs(0, 0, 0);
  match.assign(n, -1);
  used.assign(n, 0);
  int res = 0;
  for (size_t i = 0; i < left.size(); ++i) {
    res += try_kuhn(left[i], res + 1);
  }
  std::cout << res << '\n';
  for (int i = 0; i < n; ++i) {
    if (match[i] != -1)
      std::cout << i + 1 << ' ' << match[i] + 1 << '\n';
  }
}

signed main()
{
  int t = 1;
#ifdef LOCAL
  freopen("in/d.txt", "r", stdin);
  freopen("out/d.txt", "w", stdout);
  std::cin >> t;
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}