#include <bits/stdc++.h>

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

const int N = 210;
const int LG = 20;

vector<int> g[N], gg[N];
int h[N], jmp[N][LG], par[N], tin[N], tout[N], timer = 0;

void dfs(int v, int p) {
    h[v] = (p == -1 ? 0 : h[p] + 1);
    for (int k = 0; k + 1 < LG; k++) {
        jmp[v][k + 1] = jmp[jmp[v][k]][k];
    }
    tin[v] = timer++;
    par[v] = p;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        jmp[u][0] = v;
        dfs(u, v);
    }
    tout[v] = timer;
}

bool isp(int p, int v) {
    return tin[p] <= tin[v] && tin[v] < tout[p];
}

int lca(int u, int v) {
    if (isp(u, v)) {
        return u;
    }
    if (isp(v, u)) {
        return v;
    }
    for (int k = LG - 1; k >= 0; k--) {
        if (!isp(jmp[u][k], v)) {
            u = jmp[u][k];
        }
    }
    return par[u];
}

int dist(int a, int b) {
    return h[a] + h[b] - 2 * h[lca(a, b)];
}

int mt[N];
bool used[N];

bool kuhn(int v) {
    if (used[v]) {
        return false;
    }
    used[v] = true;
    for (int u : gg[v]) {
        if (mt[u] == -1 || kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve_case() {
    int n, d; cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    jmp[1][0] = 1;
    dfs(1, -1);
    for (int a = 1; a <= n; a++) {
        for (int b = a + 1; b <= n; b++) {
            int dd = dist(a, b);
            if (dd % 2 && dd <= d) {
                int u = a, v = b;
                if (h[a] % 2) {
                    swap(u, v);
                }
                gg[u].push_back(v + n);
                gg[v + n].push_back(u);
            }
        }
    }
    memset(mt, -1, sizeof mt);
    for (int v = 1; v <= n; v++) {
        memset(used, false, sizeof used);
        kuhn(v);
    }
    vector<pair<int, int>> ans;
    for (int i = n + 1; i <= n + n; i++) {
        if (mt[i] != -1) {
            ans.push_back({mt[i], i - n});
        }
    }
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) {
        cout << a << ' ' << b << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve_case();
    }
}