#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9 + 228;

vector<vector<int>> tr;
vector<vector<int>> mn;
vector<pair<pair<int, int>, pair<int, int>>> a;

void mrg(int v) {
    int i = 0;
    int j = 0;
    int lst = inf;
    while (i < tr[2 * v + 1].size() && j < tr[2 * v + 2].size()) {
        if (tr[2 * v + 1][i] <= tr[2 * v + 2][j]) {
            tr[v].push_back(tr[2 * v + 1][i]);
            mn[v].push_back(min(lst, mn[2 * v + 1][i]));
            lst = mn[v].back();
            i++;
        } else {
            tr[v].push_back(tr[2 * v + 2][j]);
            mn[v].push_back(min(lst, mn[2 * v + 2][j]));
            lst = mn[v].back();
            j++;
        }
    }
    while (i < tr[2 * v + 1].size()) {
        tr[v].push_back(tr[2 * v + 1][i]);
        mn[v].push_back(min(lst, mn[2 * v + 1][i]));
        i++;
        lst = mn[v].back();
    }
    while (j < tr[2 * v + 2].size()) {
        tr[v].push_back(tr[2 * v + 2][j]);
        mn[v].push_back(min(lst, mn[2 * v + 2][j]));
        j++;
        lst = mn[v].back();
    }
}

void build(int v, int l, int r) {
    if (l == r - 1) {
        tr[v] = {a[l].second.second};
        mn[v] = {a[l].second.first};
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    mrg(v);
}

int ask(int v, int l, int r, int askl, int askr, int rm) {
    if (l >= askr || r <= askl) {
        return inf;
    }
    if (l >= askl && r <= askr) {
        int ll = -1, rr = tr[v].size();
        while (rr - ll > 1) {
            int mm = (ll + rr) / 2;
            if (tr[v][mm] < rm) {
                ll = mm;
            } else {
                rr = mm;
            }
        }
        if (ll != -1) {
            return mn[v][ll];
        }
        return inf;
    }
    int m = (r + l) / 2;
    return min(ask(2 * v + 1, l, m, askl, askr, rm), ask(2 * v + 2, m, r, askl, askr, rm));
}


void solve() {
    int n, k;
    cin >> n >> k;
    a.assign(k, {{}, {}});
    for (int i = 0; i < k; ++i) {
        cin >> a[i].second.first >> a[i].first.first >> a[i].second.second;
        a[i].second.first--;
        a[i].first.first--;
        a[i].second.second--;
        a[i].first.second = i;
    }
    sort(a.begin(), a.end());
    tr.assign(4 * k, {});
    mn.assign(4 * k, {});
    build(0, 0, k);
    vector<int> t(k);
    for (int i = 0; i < k; ++i) {
        int l = -1, r = i;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (a[m].first.first >= a[i].second.first) {
                r = m;
            } else {
                l = m;
            }
        }
        t[i] = min(a[i].second.first, ask(0, 0, k, r, i + 1, a[i].first.first));
    }
    vector<int> mr(k, -1);
    if (a[0].second.first == 0) {
        mr[0] = a[0].second.second;
    }
    for (int i = 1; i < k; ++i) {
        int l = -1, r = i;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (a[m].first.first < a[i].second.first) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l == -1) {
            if (t[i] == 0) {
                mr[i] = a[i].second.second;
            }
        } else if (mr[l] >= t[i] - 1) {
            mr[i] = max(mr[l], a[i].second.second);
        }
        mr[i] = max(mr[i], mr[i - 1]);
    }
    if (mr[k - 1] == n - 1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}