#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> gr, dt;
int dp = 0, d;

void dfs(int v, int st) {
    if (dp > d) {
        return;
    }
    dt[st][v] = dp++;
    for (auto to : gr[v]) {
        if (dt[st][to] == 0 && to != st) {
            dfs(to, st);
        }
    }
    dp--;
}

vector<vector<int>> ng;

void build() {
    int n = gr.size();
    for (int i = 0; i < n; ++i) {
        dfs(i, i);
    }
    ng.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dt[i][j] <= d && dt[i][j] % 2) {
                ng[i].push_back(j);
                ng[j].push_back(i);
            }
        }
    }
}

vector<int> used, p;

bool kuhn(int v, int timer) {
    used[v] = timer;
    for (auto to : ng[v]) {
        if ((p[to] == -1 || (used[p[to]] != timer && kuhn(p[to], timer)))) {
            p[to] = v;
            return true;
        }
    }
    return false;
}

void ans() {
    int tm = 0;
    int n = gr.size();
    used.resize(n);
    p.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        if (dt[0][i] % 2 == 0) {
            kuhn(i, ++tm);
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; ++i) {
        if (p[i] != -1) {
            ans.push_back({i, p[i]});
        }
    }
    cout << ans.size() << '\n';
    for (auto elem : ans) {
        cout << elem.first + 1 << ' ' << elem.second + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n >> d;
    gr.resize(n);
    dt.resize(n, vector<int> (n, 1e9));
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    build();
    ans();
}