#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
//#define int long long
int inf = 1e9;
#define all(a) a.begin(), a.end()
struct sgt {
    int n;
    vector<int> t;
    vector<int> p;
    void build(int v, int l, int r, vector<int> &a) {
        if (r-l == 1) {
            if (l < a.size()) {
                t[v] = a[l];
            }
            return;
        }
        int m = (l+r)/2;
        build(2*v+1, l , m, a);
        build(2*v+2, m, r, a);
        t[v] = t[2*v+1] + t[2*v+2];
    }

    sgt(vector<int> &a) {
        n = 1;
        while (n < a.size()) {
            n *= 2;
        }
        t.assign(2*n-1, 0);
        p.assign(2*n-1, -1);
        build(0, 0, n, a);
    }

    void apply(int v, int l, int r, int x) {
        t[v] = (r-l)*x;
        p[v] = x;
    }

    void push(int v, int l, int r) {
        if (p[v] == -1 || r-l == 1) {
            return;
        }
        int m = (l+r)/2;
        apply(2*v+1, l , m, p[v]);
        apply(2*v+2, m , r, p[v]);
        p[v] = -1;
    }

    void upd(int v, int l, int r, int lq, int rq, int x) {
        if (rq <= l || r <= lq) {
            return;
        }
        if (l >= lq && r <= rq) {
            apply(v, l, r, x);
            return;
        }
        push(v, l , r);
        int m = (l+r)/2;
        upd(2*v+1, l , m, lq, rq, x);
        upd(2*v+2, m, r, lq, rq, x);
        t[v] = t[2*v+1] + t[2*v+2];
;    }

    void upd(int lq, int rq, int x) {
        upd(0, 0, n, lq, rq, x);
    }

    int get(int v, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq) {
            return 0;
        }
        if (l >= lq && r <= rq) {
            return t[v];
        }
        push(v, l , r);
        int m = (l+r)/2;
        return get(2*v+1, l ,m, lq, rq) + get(2*v+2, m, r, lq, rq);
    }

    int get(int lq, int rq) {
        return get(0, 0, n, lq, rq);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    vector<vector<int>> v(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            if (s[j] == '1') {
                a[i][j] = 1;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) {
                v[i][j] = 1;
                if (i) {
                    v[i][j] = v[i-1][j]+1;
                }
            }
        }
    }
    if (n < m) {
        vector<vector<int>> b(m, vector<int> (n));
        for (int i = 0; i< m; ++i) {
            for (int j =0 ; j < n; ++j) {
                b[i][j] = a[n-j-1][m-i-1];
            }
        }
        swap(n, m);
        a = b;
    }
    int best = 0;
    vector<int> uwu(m, inf);
    for (int i = 0; i < n; ++i) {
        int k = inf;
        sgt tree(uwu);
        tree.upd(0, 1, v[i][0]);
        best =max(best, v[i][0]);
        for (int j = 1; j < m; ++j) {
            k = v[i][j];
            int l = -1, r = j, mid;
            while (r > l+1) {
                mid = (l+r)/2;
                if (tree.get(mid, mid+1) >= k) {
                    r = mid;
                }else {
                    l = mid;
                }
            }
            tree.upd(r, j+1, k);
            best = max(best, tree.get(0, j+1));
        }
    }
    cout << best;
    return 0;
}