#include <bits/stdc++.h>
using namespace std;

//#define int long long

struct SegTree {
    struct node {
        int val;
    };
    vector<node> d;
    int n;
    void make(int sz) {
        n = sz;
        d.resize(4 * n, {0});
    }
    void update(int v, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            if (d[v].val == 0) {
                d[v].val = val;
            } else {
                d[v].val = min(d[v].val, val);
            }
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, ql, qr, val);
        update(2 * v + 2, m, r, ql, qr, val);
        d[v].val = d[2 * v + 1].val + d[2 * v + 2].val;
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return d[v].val;
        }
        int m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

bool solve(int n, int k, vector<int> & l, vector<int> & m, vector<int> & r) {
    vector<vector<int>> sss(k);
    for (int i = 0; i < k; i++) {
        sss[i] = {l[i], m[i], r[i]};
    }
    sort(sss.begin(), sss.end());
    int mx_r;
    mx_r = 1;
    for (int i = 0; i < k; i++) {
        if (sss[i][0] > mx_r) {
            return false;
        } else {
            mx_r = max(mx_r, sss[i][2]);
        }
    }
    SegTree tree;
    tree.make(n + 1);
    tree.update(0, 0, n + 1, 0, 1, 1);
    for (int i = 0; i < k; i++) {
        int cur = tree.get(0, 0, n + 1, sss[i][0] - 1, sss[i][1]);
        if (cur != 0) {
            tree.update(0, 0, n + 1, sss[i][2], sss[i][2] + 1, sss[i][1]);
        } else {
            if (tree.get(0, 0, n + 1, sss[i][1], sss[i][2]) < sss[i][0]) {
                tree.update(0, 0, n + 1, sss[i][2], sss[i][2] + 1, sss[i][1]);
            }
        }
    }
    if (tree.get(0, 0, n + 1, n, n + 1) != 0) {
        return true;
    } else {
        return false;
    }
}

bool solve1(int n, int k, vector<int> & l, vector<int> & m, vector<int> & r) {
    vector<int> perm(k);
    for (int i = 0; i < k; i++) {
        perm[i] = i;
    }
    vector<int> nch(k);
    nch = perm;
    bool f = true;
    vector<bool> msk(n + 1);
    for (int i = 1; i <= n; i++) {
        msk[i] = true;
    }
    for (;;) {
        vector<bool> zzz(n + 1);
        if (nch == perm) {
            if (!f) {
                break;
            }
            f = false;
        }
        for (int i = 0; i < k; i++) {
            if (zzz[m[perm[i]]] == false) {
                for (int j = l[perm[i]]; j <= r[perm[i]]; j++) {
                    zzz[j] = true;
                }
            } else {
                break;
            }
        }
        if (zzz == msk) {
            return true;
        }
        next_permutation(perm.begin(), perm.end());
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<int> l(k), m(k), r(k);
        for (int i = 0; i < k; i++) {
            cin >> l[i] >> m[i] >> r[i];
        }
        if (solve1(n, k, l, m, r)) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
}