#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

// #pragma GCC optimize("unroll-loops")
// #define LOCAL

vector<vector<int>> g;
int n, d;
vector<pair<int, int>> best;
vector<int> dist;
vector<bool> odd;
void dfs(int v, int p=-1) {
    dist[v] = 1 + (p == -1 ? 0 : dist[p]);
    if (dist[v] % 2 == 1) {
        odd[v] = true;
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
    }
}
vector<pair<int, int>> cur;
vector<bool> used;
void dfs2(int v) {
    if (v == n) {
        if (sz(cur) > sz(best)) {
            best = cur;
        }
        return;
    }
    dfs2(v + 1);
    if (used[v]) {
        return;
    }
    queue<int> q;
    vector<bool> cused(n);
    vector<int> cdist(n);
    q.push(v);
    cused[v] = true;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (cdist[u] % 2 == 1 && !used[u]) {
            used[v] = used[u] = true;
            cur.emplace_back(v, u);
            dfs2(v + 1);
            used[v] = used[u] = false;
            cur.pop_back();
        }
        for (auto k : g[u]) {
            if (cused[k]) continue;
            cdist[k] = cdist[u] + 1;
            cused[k] = true;
            if (cdist[k] > d) continue;
            q.push(k);
        }
    }
}

void solve() {
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    odd.resize(n);
    used.resize(n);
    dist.resize(n);
    dfs(0);
    dfs2(0);
    cout << sz(best) << '\n';
    for (auto [u, v] : best) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}