#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;
}
void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}

struct seg {
    int l, r, m;
};

struct seg_tree {
    int n = 1;
    vector<int> mn;
    seg_tree(int nq) {
        while (n < nq) n *= 2;
        mn.resize(n * 2);
    }
    void change(int ind, int val) {
        change(1, 0, n, ind, val);
    }
    void change(int u, int l, int r, int ind, int val) {
        if (ind < l || r <= ind) return;
        if (r - l == 1) {
            mn[u] = val;
            return;
        }
        int mid = (l + r) / 2;
        change(u * 2, l, mid, ind, val);
        change(u * 2 + 1, mid, r, ind, val);
        mn[u] = min(mn[u * 2], mn[u * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }
    int get(int u, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq) return INF;
        if (lq <= l && r <= rq) return mn[u];
        int mid = (l + r) / 2;
        return min(get(u * 2, l, mid, lq, rq), get(u * 2 + 1, mid, r, lq, rq));
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<seg> v(k);
    for (int i = 0; i < k; i++) {
        cin >> v[i].l >> v[i].m >> v[i].r;
        v[i].l--; v[i].m--;
    }
    vector<vector<seg>> sg(n + 1);
    for (seg s : v) {
        sg[s.r].push_back(s);
    }
    seg_tree dp(n + 1);
    for (int i = 1; i <= n; i++) dp.change(i, n);
    dp.change(0, -1);

    for (int r = 1; r <= n; r++) {
        for (seg s : sg[r]) {
            if (dp.get(s.l, s.m + 1) < n) {
                dp.change(r, min(dp.get(r, r + 1), s.m));
            }
            if (dp.get(s.l, s.r) < s.l) {
                dp.change(r, min(dp.get(r, r + 1), s.m));
            }
        }
    }
    if (dp.get(n, n + 1) < n) cout << "YES\n";
    else cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1; cin >> tt;
    while (tt--) solve();
}