#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <algorithm>

using namespace std;
#define int long long
mt19937 rnd(42);

struct node {
	int li, ri, val, flag, flag2;
	node() {
		li = -1; ri = -1; val = 0; flag = 0; flag2 = 0;
	}
};

int max_node = 1;
vector<node> t(3000000);

void push(int now, int left, int right) {
	int mid = (left + right) / 2;
	if (t[now].flag2 == 1) {
		t[t[now].li].flag2 = 1;
		t[t[now].li].flag = 0;
		t[t[now].li].val = 0;
		t[t[now].ri].flag2 = 1;
		t[t[now].ri].flag = 0;
		t[t[now].ri].val = 0;
		t[now].flag2 = 0;
	}
	t[t[now].li].flag += t[now].flag;
	t[t[now].li].val += t[now].flag * (mid - left + 1);
	t[t[now].ri].flag += t[now].flag;
	t[t[now].ri].val += t[now].flag * (right - mid);
	t[now].flag = 0;
}

int cnt = 0;

void update(int now, int left, int right, int tleft, int tright, int val) {
	if (tleft > tright) return;
	if (tleft == left and tright == right) {
		t[now].val += val * (right - left + 1);
		t[now].flag += val;
		return;
	}
	int mid = (left + right) / 2;
	if (t[now].li == -1) t[now].li = max_node++;
	if (t[now].ri == -1) t[now].ri = max_node++;
	push(now, left, right);
	update(t[now].li, left, mid, tleft, min(tright, mid), val);
	update(t[now].ri, mid + 1, right, max(tleft, mid + 1), tright, val);
	t[now].val = t[t[now].li].val + t[t[now].ri].val;
}

void update2(int now, int left, int right, int tleft, int tright, int val) {
	if (tleft > tright) return;
	if (tleft == left and tright == right) {
		t[now].val = 0;
		t[now].flag2 = 1;
		t[now].flag = 0;
		return;
	}
	int mid = (left + right) / 2;
	if (t[now].li == -1) t[now].li = max_node++;
	if (t[now].ri == -1) t[now].ri = max_node++;
	push(now, left, right);
	update2(t[now].li, left, mid, tleft, min(tright, mid), val);
	update2(t[now].ri, mid + 1, right, max(tleft, mid + 1), tright, val);
	t[now].val = t[t[now].li].val + t[t[now].ri].val;
}

int sum(int now, int left, int right, int tleft, int tright) {
	if (tleft > tright) return 0;
	if (tleft == left and tright == right) {
		return t[now].val;
	}
	if (t[now].li == -1) t[now].li = max_node++;
	if (t[now].ri == -1) t[now].ri = max_node++;
	int mid = (left + right) / 2;
	push(now, left, right);
	return sum(t[now].li, left, mid, tleft, min(tright, mid)) +
		sum(t[now].ri, mid + 1, right, max(tleft, mid + 1), tright);
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	int n, m;
	cin >> n >> m;
	vector<string> l(n);
	for (int i = 0; i < n; i++) {
		l[i] = string(m, '0');
		for (int j = 0; j < m; j++) {
			if (rnd() % 2) l[i][j] = '1';
		}
		cin >> l[i];
	}
	vector<vector<int>> l2(n, vector<int>(m));
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (j != m - 1) l2[i][j] = l2[i][j + 1];
			if (l[i][j] == '1') l2[i][j]++;
			else l2[i][j] = 0;
		}
	}

	for (int j = 0; j < m; j++) {
		t[0].val = 0;
		t[0].flag = 0;
		t[0].flag2 = 1;
		for (int i = 0; i < n; i++) {
			cnt = 0;
			update2(0, 0, m, l2[i][j] + 1, m, 1);
			int u = sum(0, 0, m, 1, l2[i][j]);
			//cout << i << " " << j << " " << u << " ehhee\n";
			ans = max(ans, u + l2[i][j]);
			if (l2[i][j] != 0) update(0, 0, m, 1, l2[i][j], 1);
		}
	}


	
	cout << ans;

}

/*


6 4
0011
1101
0111
1110
0111
0100


*/