#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;
const i64 INF = 1e18;

const i64 S = 5e5 + 10;
vector <pair<i64, i64>> otr[S];
i64 pref[S], suf[S];
i64 n, k;

void addPref(i64 v) {
	for (i64 x = v; x <= n; x += x & (-x)) {
		pref[x] += 1;
	}
	return;
}

i64 getPref(i64 v) {
	i64 sum = 0;
	for (i64 x = v; x >= 1; x -= x & (-x)) {
		sum += pref[x];
	}
	return sum;
}

i64 itogPref(i64 l, i64 r) {
	return getPref(r) - getPref(l - 1);
}

void addSuf(i64 v) {
	for (i64 x = v; x <= n; x += x & (-x)) {
		suf[x] += 1;
	}
	return;
}

i64 getSuf(i64 v) {
	i64 sum = 0;
	for (i64 x = v; x >= 1; x -= x & (-x)) {
		sum += suf[x];
	}
	return sum;
}

i64 itogSuf(i64 l, i64 r) {
	return getSuf(r) - getSuf(l - 1);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 t; cin >> t;

	while (t--) {
		cin >> n >> k;
		for (i64 x = 1; x <= k; ++x) {
			i64 l, m, r; cin >> l >> m >> r;
			otr[m].push_back(mp(l, r));
		}
		for (i64 x = 1; x <= n; ++x) {
			for (auto y : otr[x]) {
				if (itogPref(y.first - 1, x - 1) || y.first == 1) {
					addPref(y.second);
				}
			}
		}
		for (i64 x = n; x >= 1; --x) {
			for (auto y : otr[x]) {
				if (itogSuf(x + 1, y.second + 1) || y.second == n) {
					addSuf(y.first);
				}
			}
		}
		if (itogPref(n, n) || itogSuf(1, 1)) cout << "YES" << endl;
		else cout << "NO" << endl;

		for (i64 x = 0; x < S; ++x) {
			otr[x].clear();
		}
		for (i64 x = 0; x < S; ++x) {
			pref[x] = 0, suf[x] = 0;
		}
	}
}