#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;
const i64 INF = 1e18;

const i64 S = 5e5 + 10;
vector <pair<i64, i64>> otr[S];
i64 pref[S], suf[S];
i64 n, k;

void addPref(i64 v) {
	for (i64 x = v; x <= n; x += x & (-x)) {
		pref[x] += 1;
	}
	return;
}

i64 getPref(i64 v) {
	i64 sum = 0;
	for (i64 x = v; x >= 1; x -= x & (-x)) {
		sum += pref[x];
	}
	return sum;
}

i64 itogPref(i64 l, i64 r) {
	return getPref(r) - getPref(l - 1);
}

void addSuf(i64 v) {
	for (i64 x = v; x <= n; x += x & (-x)) {
		suf[x] += 1;
	}
	return;
}

i64 getSuf(i64 v) {
	i64 sum = 0;
	for (i64 x = v; x >= 1; x -= x & (-x)) {
		sum += suf[x];
	}
	return sum;
}

i64 itogSuf(i64 l, i64 r) {
	return getSuf(r) - getSuf(l - 1);
}

vector <pair<pair<i64, i64>, i64>> d, d1, ch;
vector <pair<i64, i64>> ans, ans1;

void solve() {
	i64 l = INF, r = -INF;
	for (auto x : ch) {
		l = min(l, x.first.first);
		r = max(r, x.first.second);
		otr[x.second].push_back(x.first);
	}
	for (i64 x = l; x <= r; ++x) {
		for (auto y : otr[x]) {
			if (itogPref(y.first - 1, x - 1) || y.first == l) {
				addPref(y.second);
			}
		}
	}
	for (i64 x = r; x >= l; --x) {
		for (auto y : otr[x]) {
			if (itogSuf(x + 1, y.second + 1) || y.second == r) {
				addSuf(y.first);
			}
		}
	}

	if (itogPref(r, r) || itogSuf(l, l)) {
		ans.push_back(mp(l, r));
	}

	for (i64 x = l; x <= r; ++x) {
		pref[x] = 0;
		suf[x] = 0;
		otr[x].clear();
	}
	return;
}

bool cmp(pair<pair<i64, i64>, i64> a, pair<pair<i64, i64>, i64> b) {
	return a.first < b.first;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 t; cin >> t;

	while (t--) {
		cin >> n >> k;
		ch.clear();
		d.clear();
		d1.clear();
		ans.clear();
		ans1.clear();
		for (i64 x = 1; x <= k; ++x) {
			i64 l, m, r; cin >> l >> m >> r;
			d.push_back(mp(mp(l, r), m));
		}

		sort(d.begin(), d.end(), cmp);
		vector <pair<i64, i64>> itog;

		for (auto x : d) {
			if (d1.size() && d1.back().first.second >= x.first.first) {
				ch.push_back(x);
				d1.back().first.second = max(d1.back().first.second, x.first.second);
			}
			else {
				if (ch.size()) solve();
				ch.clear();
				ch.push_back(x);
				d1.push_back(x);
			}
		}

		if (ch.size()) solve();
		ch.clear();

		ans1.clear();

		sort(ans.begin(), ans.end());

		for (auto x : ans) {
			if (ans1.size() && ans1.back().second >= x.first - 1) {
				ans1.back().second = max(ans1.back().second, x.second);
			}
			else {
				ans1.push_back(x);
			}
		}

		if (ans1.size() == 1 && ans1[0].first == 1 && ans1[0].second == n) {
			cout << "YES" << endl;
		}
		else {
			cout << "NO" << endl;
		}
	}
}