#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;
const i64 INF = 1e18;

const i64 S = 5e5 + 10, K = 22;
i64 mx[S][K], mn[S][K], lg[S];

void recalc() {
	for (i64 y = 0; y < K; ++y) {
		if ((1 << y) < S) lg[(1 << y)] = y;
	}
	for (i64 x = 1; x < S; ++x) {
		if (lg[x] == 0) lg[x] = lg[x - 1];
	}
}

void build(i64 n) {
	for (i64 y = 1; y < K; ++y) {
		for (i64 x = 1; x < n; ++x) {
			mx[x][y] = max(mx[x][y - 1], mx[min(n, (i64(1) << (y - 1)))][y - 1]);
			mn[x][y] = max(mn[x][y - 1], mn[min(n, (i64(1) << (y - 1)))][y - 1]);
		}
		mx[n][y] = mx[n][0];
		mn[n][y] = mn[n][0];
	}
}

i64 getMx(i64 l, i64 r) {
	if (l == r) return mx[l][0];
	i64 k = lg[r - l + 1];
	return max(mx[l][k], mx[r - (1 << k) + 1][k]);
}

i64 getMn(i64 l, i64 r) {
	if (l == r) return mn[l][0];
	i64 k = lg[r - l + 1];
	return min(mn[l][k], mn[r - (1 << k) + 1][k]);
}

vector <pair<i64, i64>> d, d1;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 t; cin >> t;
	recalc();

	while (t--) {
		i64 n, k; cin >> n >> k;
		for (i64 x = 1; x <= n; ++x) {
			for (i64 y = 0; y < K; ++y) {
				mx[x][y] = -INF;
				mn[x][y] = INF;
			}
		}
		d.clear();
		d1.clear();
		bool fine = true;
		for (i64 x = 1; x <= k; ++x) {
			i64 l, m, r; cin >> l >> m >> r;
			d.push_back(mp(l, r));
			if (mx[m][0] != -INF) {
				fine = false;
			}
			else {
				mx[m][0] = r;
				mn[m][0] = l;
			}
		}
		if (fine) {
			build(n);
			for (i64 x = 1; x <= n; ++x) {
				if (mx[x][0] == -INF) continue;
				i64 l = mn[x][0], r = mx[x][0];
				if ((l < x && getMx(l, x - 1) >= x) || (r > x && getMn(x + 1, r) <= x)) {
					fine = false;
				}
			}
		}
		sort(d.begin(), d.end());
		for (auto x : d) {
			if (d1.size() && d1.back().second >= x.first - 1) {
				d1.back().second = x.second;
			}
			else {
				d1.push_back(x);
			}
		}
		if (fine && (d1.size() == 1 && d1[0].first == 1 && d1[0].second == n)) cout << "YES" << endl;
		else cout << "NO" << endl;
	}
}