// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define vc vector
#define all(v) v.begin(), v.end()
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
#define endl "\n"

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

bool solve();

int main()
{
    acceleration();

    ll t = 1;
    cin >> t;

    while (t--)
    {
        if (solve())
            cout << "YES";
        else
            cout << "NO";
        cout << endl;
    }
    return 0;
}

struct seg
{
    ll l, m, r;

    bool operator<(seg &s)
    {
        return r < s.r;
    }
};

struct fnw
{
    vc<ll> a;

    fnw(ll n)
    {
        a = vc<ll>(n, 0);
    }

    void set(ll pos)
    {
        a[pos] = 1;
    }

    bool get(ll lq, ll rq)
    {
        return accumulate(a.begin() + lq, a.begin() + rq + 1, 0ll);
    }
};

struct ev
{
    ll pos, d;

    bool operator<(ev r)
    {
        return pos < r.pos || pos == r.pos && d > r.d;
    }
};

bool solve()
{
    ll n, k;
    cin >> n >> k;

    vc<seg> a(k);
    vc<ev> events{};
    for (auto &[l, m, r] : a)
    {
        cin >> l >> m >> r;
        l--, r--, m--;

        events.push_back({l, 1});
        events.push_back({r, -1});
    }

    sort(all(events));
    ll cover = 0;
    for (auto [pos, d] : events)
    {
        cover += d;

        if (pos != 0 && pos != n - 1 && cover == 0)
            return false;
    }

    vc<ll> p(k);
    iota(all(p), 0ll);

    do
    {
        vc<bool> mark(n, false);

        for (ll i : p)
        {
            if (mark[a[i].m])
                continue;
            for (ll j = a[i].l; j <= a[i].r; ++j)
                mark[j] = true;
        }

        if (find(all(mark), false) == mark.end())
            return true;

    } while (next_permutation(all(p)));

    return false;
}

/*


2
5 2
3 4 5
1 3 3


5 3
1 2 4
2 4 5
3 3 3



YES
NO

*/