#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;


using ll = long long;
using pii = pair<int, int>;

struct SegmentTree {
    struct Node {
        int x = 0, push = 0;

        Node operator+(const Node &other) const {
            return {x + other.x, 0};
        }
    };
    vector<Node> tree;
    int n;

    SegmentTree(int sz) {
        n = sz;
        tree.resize(4 * n);
    }

    void apply(int v) {
        tree[v].x = 1;
        tree[v].push = 1;
    }

    void push(int v) {
        if (tree[v].push) {
            apply(2 * v + 1);
            apply(2 * v + 2);
            tree[v].push = 0;
        }
    }

    void upd(int v, int cl, int cr, int l, int r) {
        if (cl >= r || cr <= l) return;
        if (cl >= l && cr <= r) {
            apply(v);
            return;
        }
        push(v);
        int m = (cl + cr) / 2;
        upd(2 * v + 1, cl, m, l, r);
        upd(2 * v + 2, m, cr, l, r);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void upd(int l, int r) {
        upd(0, 0, n, l, r);
    }

    Node get(int v, int cl, int cr, int l, int r) {
        if (cl >= r || cr <= l) return {0, 0};
        if (cl >= l && cr <= r) return tree[v];
        int m = (cl + cr) / 2;
        push(v);
        return get(2 * v + 1, cl, m, l, r) + get(2 * v + 2, m, cr, l, r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r).x;
    }
};

struct Solution {
    int n, k;
    vector<vector<int>> g;
    vector<int> used, ts;

    struct Segment {
        int l, m, r;

        bool operator<(const Segment &other) const {
            return l < other.l;
        }
    };

    void dfs(int v) {
        used[v] = 1;
        for (auto u : g[v]) {
            if (!used[u]) dfs(u);
        }
        ts.push_back(v);
    }

    Solution() {
        cin >> n >> k;
        vector<Segment> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            --a[i].l; --a[i].r; --a[i].m;
        }
        vector<vector<int>> dp(n, vector<int> (n));
        for (int len = 1; len <= n; ++len) {
            for (int l = 0; l < n; ++l) {
                int r = l + len - 1;
                if (r >= n) break;
                for (auto [l1, m1, r1] : a) {
                    if (l1 < l || r1 > r) continue;
                    int h1 = 0, h2 = 0;
                    if (l1 == l) {
                        h1 = 1;
                    } else {
                        for (int m = l1 - 1; m < m1; ++m) {
                            if (dp[l][m]) {
                                h1 = 1;
                                break;
                            }
                        }
                    }
                    if (r1 == r) {
                        h2 = 1;
                    } else {
                        for (int m = m1 + 1; m <= r1 + 1; ++m) {
                            if (dp[m][r]) {
                                h2 = 1;
                                break;
                            }
                        }
                    }
                    if (h1 && h2) {
                        dp[l][r] = 1;
                        break;
                    }
                }
            }
        }
        if (dp[0][n - 1]) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t --> 0) {
        Solution sol{};
    }
}