#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;

struct SegmentTree {
    vector<int> tree;
    int n;

    SegmentTree(int sz) {
        n = sz;
        tree.resize(4 * n);
    }

    void upd(int v, int cl, int cr, int pos) {
        if (cr - cl == 1) {
            tree[v] = 1;
            return;
        }
        int m = (cl + cr) / 2;
        if (m > pos) {
            upd(2 * v + 1, cl, m, pos);
        } else {
            upd(2 * v + 2, m, cr, pos);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void upd(int pos) {
        upd(0, 0, n, pos);
    }

    int get(int v, int cl, int cr, int l, int r) {
        if (cl >= r || cr <= l) return 0;
        if (cl >= l && cr <= r) return tree[v];
        int m = (cl + cr) / 2;
        return get(2 * v + 1, cl, m, l, r) + get(2 * v + 2, m, cr, l, r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

struct Solution {
    int n, k;

    struct Segment {
        int l, m, r;
    };

    Solution() {
        cin >> n >> k;
        vector<Segment> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            --a[i].l; --a[i].r; --a[i].m;
        }
        bool h = false;
        sort(a.begin(), a.end(), [] (const Segment& lhs, const Segment &rhs) {
            return lhs.r > rhs.r;
        });
        SegmentTree dp(n + 1);
        dp.upd(n);
        for (auto [l, m, r] : a) {
            if (dp.get(m + 1, r + 2)) {
                dp.upd(l);
            }
        }
        if (dp.get(0, 1)) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t --> 0) {
        Solution sol{};
    }
}
