#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;

struct SegmentTree {
    vector<int> tree;
    int n;

    SegmentTree(int sz) {
        n = sz;
        tree.resize(4 * n);
    }

    void upd(int v, int cl, int cr, int pos) {
        if (cr - cl == 1) {
            tree[v] = 1;
            return;
        }
        int m = (cl + cr) / 2;
        if (m > pos) {
            upd(2 * v + 1, cl, m, pos);
        } else {
            upd(2 * v + 2, m, cr, pos);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void upd(int pos) {
        upd(0, 0, n, pos);
    }

    int get(int v, int cl, int cr, int l, int r) {
        if (cl >= r || cr <= l) return 0;
        if (cl >= l && cr <= r) return tree[v];
        int m = (cl + cr) / 2;
        return get(2 * v + 1, cl, m, l, r) + get(2 * v + 2, m, cr, l, r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

struct Solution {
    int n, k;

    struct Segment {
        int l, m, r;
    };

    Solution() {
        cin >> n >> k;
        vector<Segment> a(k);
        int max_1 = -1, min_n = n + 1;
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            --a[i].l; --a[i].r; --a[i].m;
            if (a[i].m == 0) {
                max_1 = max(max_1, a[i].r);
            } else {
                min_n = min(min_n, a[i].l);
            }
        }
        if (max_1 + 1 >= min_n) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t --> 0) {
        Solution sol{};
    }
}
