#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> g, dist;

vector<int> colors;

void dfs(int v, int p, int col) {
    colors[v] = col;
    for (auto u : g[v]) {
        if (p == u) continue;
        dfs(u, v, 1 - col);
    }
}

void dfs_dist(int v, int p, int d, int r) {
    dist[r][v] = d;
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs_dist(u, v, d + 1, r);
    }
}

vector<vector<int>> g2;
vector<int> mt1, mt2, used;
int timer = 0;

bool dfs_mt(int v) {
    used[v] = timer;
    for (auto u : g2[v]) {
        if (mt2[u] == -1) {
            mt2[u] = v;
            mt1[v] = u;
            return true;
        }
    }
    for (auto u : g2[v]) {
        if (used[mt2[u]] != timer && dfs_mt(mt2[u])) {
            mt2[u] = v;
            mt1[v] = u;
            return true;
        }
    }
    return false;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    dist.resize(n, vector<int> (n));
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    colors.resize(n);
    for (int i = 0; i < n; ++i) {
        dfs_dist(i, -1, 0, i);
    }
    dfs(0, -1, 0);
    g2.resize(n);
    mt1.resize(n, -1);
    mt2.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (colors[i] == colors[j] || dist[i][j] > d) continue;
            g2[i].push_back(j);
            g2[j].push_back(i);
        }
    }
    int ans = 0;
    used.resize(n);
    timer = 1;
    for (int i = 0; i < n; ++i) {
        if (colors[i] == 1) continue;
        if (used[i] != timer && dfs_mt(i)) {
            ++ans;
            ++timer;
        }
    }
    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        if (colors[i] == 1) continue;
        if (mt1[i] == -1) continue;
        cout << i + 1 << " " << mt1[i] + 1 << "\n";
    }
}
