// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int INF = 1e9 + 69;
const int MAXN = 3e5 + 1;
const int C = 179;
mt19937 rnd(179);

int link_to_left[MAXN];
bool is_in_pairing[MAXN];
vector<int> graph[MAXN];
int used[MAXN];
int funny[MAXN];
int cur_it = 0;
vector<vector<int>> tree;
int n, d;

bool dfs(int v) {
    if (used[v] == cur_it) {
        return false;
    }
    used[v] = cur_it;
    for (auto u : tree[v]) {
        if (link_to_left[u] == -1) {
            link_to_left[u] = v;
            is_in_pairing[v] = true;
            return true;
        }
    }
    return false;
}

vector<pair<int, int>> get_max_matching() {
    for (int i = 0; i < MAXN; i++) {
        used[i] = -1;
        is_in_pairing[i] = false;
        link_to_left[i] = -1;
    }
    cur_it = 0;
    vector<int> indexes = {};
    for (int i = 0; i < MAXN; i++) {
        indexes.push_back(i);
    }
    shuffle(all(indexes), rnd);
    for (int i = 0; i < MAXN; i++) {
        shuffle(all(graph[i]), rnd);
    }
    for (auto i : indexes) {
        if (!is_in_pairing[i]) {
            cur_it++;
            dfs(i);
        }
    }
    vector<pair<int, int>> ans = {};
    for (int i = 0; i < MAXN; i++) {
        if (link_to_left[i] != -1) {
            ans.push_back({link_to_left[i], i});
        }
    }
    return ans;
}

vector<int> depth;

void calc_depth(int v, int p) {
    for (auto u : tree[v]) {
        if (u != p) {
            depth[u] = depth[v] + 1;
            calc_depth(u, v);
        }
    }
}

int v_source = -1;

void dfs_get_graph(int v, int p, int cur_d) {
    if (cur_d > d) {
        return;
    }
    if (cur_d % 2) {
        graph[v_source].push_back(v);
    }
    for (auto u : tree[v]) {
        if (u != p) {
            dfs_get_graph(u, v, cur_d + 1);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int u, v;
    cin >> n >> d;
    tree.resize(n, {});
    depth.resize(n, -1);
    for (int i = 0; i < n - 1; i ++) {
        cin >> u >> v;
        u--;
        v--;
        tree[u].push_back(v);
        tree[v].push_back(u);
    }
    calc_depth(0, 0);
    vector<pair<int, int>> ans = get_max_matching();
    cout << ans.size() << endl;
    for (auto p : ans) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }
    return 0;
}
