// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int INF = 1e9 + 69;
const int MAXN = 3e5 + 1;
const int C = 179;
mt19937 rnd(179);

int link_to_left[MAXN];
bool is_in_pairing[MAXN];
vector<int> graph[MAXN];
int used[MAXN];
int funny[MAXN];
vector<int> tree[MAXN];
int depth[MAXN];
int cur_it = 0;
int n, d;

vector<int> all_v = {};
bool is_ans = false;

void dfs2(int v, int p, int v_source, int cur_d) {
    if (cur_d > d || is_ans) {
        return;
    }
    if (cur_d % 2 && (link_to_left[v] == -1)) {
        link_to_left[v] = v_source;
        is_in_pairing[v_source] = true;
        is_ans = true;
        return;
    }
    if (cur_d % 2) {
        all_v.push_back(v);
    }
    for (auto u : tree[v]) {
        if (u != p) {
            dfs2(u, v, v_source, cur_d + 1);
            if (is_ans) {
                return;
            }
        }
    }
}

bool dfs(int v) {
    if (used[v] == cur_it) {
        return false;
    }
    used[v] = cur_it;
    is_ans = false;
    all_v.clear();
    dfs2(v, v, v, 0);
    if (is_ans) {
        return true;
    }
    vector<int> cur_v = all_v;
    for (auto u : cur_v) {
        if (dfs(link_to_left[u])) {
            link_to_left[u] = v;
            is_in_pairing[v] = true;
            return true;
        }
    }
    return false;
}

vector<pair<int, int>> get_max_matching() {
    for (int i = 0; i < MAXN; i++) {
        used[i] = -1;
        is_in_pairing[i] = false;
        link_to_left[i] = -1;
    }
    cur_it = 0;
    vector<int> indexes = {};
    for (int i = 0; i < MAXN; i++) {
        if (depth[i] != -1 && depth[i] % 2 == 0) {
            indexes.push_back(i);
        }
    }
    shuffle(all(indexes), rnd);
    for (int i = 0; i < MAXN; i++) {
        shuffle(all(graph[i]), rnd);
    }
    for (auto i : indexes) {
        if (!is_in_pairing[i]) {
            cur_it++;
            dfs(i);
        }
    }
    vector<pair<int, int>> ans = {};
    for (int i = 0; i < MAXN; i++) {
        if (link_to_left[i] != -1) {
            ans.push_back({link_to_left[i], i});
        }
    }
    return ans;
}

void calc_depth(int v, int p) {
    for (auto u : tree[v]) {
        if (u != p) {
            depth[u] = depth[v] + 1;
            calc_depth(u, v);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int u, v;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i ++) {
        cin >> u >> v;
        u--;
        v--;
        tree[u].push_back(v);
        tree[v].push_back(u);
    }
    for (int i = 0; i < MAXN; i++) {
        depth[i] = -1;
    }
    calc_depth(0, 0);
    vector<pair<int, int>> ans = get_max_matching();
    cout << ans.size() << endl;
    for (auto p : ans) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }
    return 0;
}
