#include <bits/stdc++.h>
#define pb push_back
#define int long long
#define endl "\n"
using namespace std;
typedef pair<int, int> pii;
const int maxk = 1e4 + 10;
bool ok = 1;
vector<int> g[maxk];
int used[maxk];


struct node {
    int l, m, r, i;
};

class SegTree {
private:
    vector<bool> promise;
public:
    SegTree(int n):promise(4 * n, 0){}
    void pr(int v, int l, int r, int ql, int qr) {
        if (l == ql && r == qr) {
            promise[v] = 1;
            return;
        }
        int m = (l + r) / 2;
        if (ql < m) pr(2 * v, l, m, ql, min(qr, m));
        if (qr > m) pr(2 * v + 1, m, r, max(m, ql), qr);
    }
    int get_val(int v, int l, int r, int i) {
        if (r - l == 1) {
            return promise[v];
        }
        if (promise[v]) return promise[v];
        int m = (l + r) / 2;
        if (i < m) return get_val(2 * v, l, m, i);
        else return get_val(2 * v + 1, m, r, i);
    }
};


vector<node> a;
int mn, mx;
vector<int> now;
int inf = 1e9;
vector<int> dist(maxk, inf);


void dfs(int u) {
    now.pb(u);
    if (a[u].l < a[mn].l) mn = u;
    if (a[u].r > a[mx].r) mx = u;
    used[u] = 1;
    for (int v : g[u]) {
        if (!used[v]) dfs(v);
    }
}



pair<pii, pii> solve1(int i) {
    now.clear();
    mn = mx = i;
    dfs(i);
    dist[mn] = 0;
    queue<int> q;
    q.push(mn);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (int v : g[u]) {
            if (dist[v] > dist[u] + 1) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }
    int r = a[mn].r;
    for (int u : now) {
        if (dist[u] % 2 == 0) {
            r = max(r, a[u].r);
        }
    }
    pii ans1 = {a[mn].l, r};
    for (int u : now) dist[u] = inf;
    dist[mx] = 0;
    q.push(mx);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (int v : g[u]) {
            if (dist[v] > dist[u] + 1) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }
    int l = a[mx].l;
    for (int u : now) {
        if (dist[u] % 2 == 0) {
            l = min(l, a[u].l);
        }
    }
    pii ans2 = {l, a[mx].r};
    return {ans1, ans2};
}



void solve() {
    ok = 1;
    int n, k;
    cin >> n >> k;
    dist.assign(k, inf);
    a.clear();
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; m--; r--;
        a.pb({l, m, r, i});
    }
    for (int i = 0; i <= k; ++i) g[i].clear();
    vector<pii> events;
    for (auto [l, m, r, i] : a) {
        events.pb({l, 0});
        events.pb({r, 2});
    }
    for (int i = 0; i < n; ++i) {
        events.pb({i, 1});
    }
    sort(events.begin(), events.end());
    int cnt = 0;

    for (auto [x, t] : events) {
        if (t == 0) {
            cnt++;
        } else if (t == 1) {
            if (cnt == 0) ok = 0;
        } else {
            cnt--;
        }
    }
    if (!ok) {
        cout << "NO" << endl;
        return;
    }
    for (int i = 0; i < k; ++i) {
        for (int j = i + 1; j < k; ++j) {
            if (a[i].m >= a[j].l && a[i].m <= a[j].r && a[j].m >= a[i].l && a[j].m <= a[i].r) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }

    SegTree tree(n);
    fill(used, used + k, 0);
    vector<pair<pii, pii>> v;
    for (int i = 0; i < k; ++i) {
        if (!used[i]) {
            auto [ans1, ans2] = solve1(i);
            if (ans1.first > ans2.first) swap(ans1, ans2);
            if (ans1 != ans2) v.pb({ans1, ans2});
            else {
                tree.pr(1, 0, n, ans1.first, ans1.second + 1);
            }
        }

    }


    int first_bad = n;
    for (int i = 0; i < n; ++i) {
        if (tree.get_val(1, 0, n, i) == 0) {
            first_bad = i;
            break;
        }
    }
    if (first_bad == n) {
        cout << "YES" << endl;
        return;
    }

    sort(v.begin(), v.end());
    for (auto [o1, o2] : v) {
        if (first_bad >= o2.first) {
            tree.pr(1, 0, n, o2.first, o2.second + 1);
        } else {
            tree.pr(1, 0, n, o1.first, o1.second + 1);

        }
        while (first_bad < n && tree.get_val(1, 0, n, first_bad) == 1) first_bad++;
    }


    if (first_bad == n) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}