#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll pref_sum(vector<vector<ll>> &pref, ll x1, ll y1, ll x2, ll y2) {
    return pref[x2 + 1][y2 + 1] - pref[x1][y2 + 1] - pref[x2 + 1][y1] + pref[x1][y1];
}

bool check(vector<vector<ll>> &pref, ll i, ll x, ll y) {
    return pref_sum(pref, i, x, i, y) == y - x + 1;
}

void make_max(vector<vector<ll>> &a, ll n) {
    vector<vector<ll>> maxx(n, vector<ll> (n, 0));
    for (ll i = 0; i < n; ++i) {
        maxx[i][i] = a[i][i];
    }

    for (ll len = 2; len <= n; ++len) {
        for (ll i = 0; i + len - 1 < n; ++i) {
            ll j = i + len - 1;
            maxx[i][j] = max(a[i][j], maxx[i][j - 1]);
        }
    }
    swap(a, maxx);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll> (m, 0));
    for (ll i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (ll j = 0; j < m; ++j) {
            a[i][j] = s[j] - '0';
        }
    }

    if (m > n) {
        vector<vector<ll>> a1(m, vector<ll> (n, 0));
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < m; ++j) {
                a1[j][i] = a[i][m - 1 - j];
            }
        }
        swap(n, m);
        swap(a, a1);
    }

    vector<vector<ll>> pref(n + 1, vector<ll> (m + 1, 0));
    for (ll i = 1; i <= n; ++i) {
        for (ll j = 1; j <= m; ++j) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i - 1][j - 1];
        }
    }

    vector<vector<ll>> dp(m, vector<ll> (m, 0));
    ll ans = 0;
    for (ll i = 0; i < m; ++i) {
        for (ll j = i; j < m; ++j) {
            if (check(pref,  0, i, j)) {
                dp[i][j] = j - i + 1;
                ans = max(ans, dp[i][j]);
            }
        }
    }
    make_max(dp, m);

    for (ll line = 1; line < n; ++line) {
        vector<vector<ll>> dp1(m, vector<ll> (m, 0));
        for (ll i1 = 0; i1 < m; ++i1) {
            for (ll j1 = i1; j1 < m; ++j1) {
                if (check(pref, line, i1, j1)) {
                    dp1[i1][j1] = dp[i1][j1] + j1 - i1 + 1;
                    ans = max(ans, dp1[i1][j1]);
                }
            }
        }
        swap(dp, dp1);
        make_max(dp, m);
    }

    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll ttt_ = 1;
    // cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}