#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Seg {
    ll l, m, r;

    Seg() = default;

    Seg(ll l, ll m, ll r) : l(l), m(m), r(r) {};

    bool operator <(const Seg &a) const {
        return l < a.l || (l == a.l && r < a.r);
    }
};

bool get_ans_lr(vector<pair<ll, ll>> &l, vector<pair<ll, ll>> &r) {
    ll max_m = 0, i = 0, j = 0;
    while (i < l.size()) {
        if (j < r.size() && r[j].first <= l[i].first + 1) {
            max_m = max(max_m, r[j].second);
            ++j;
        } else {
            if (max_m > l[i].first) {
                return true;
            }
            ++i;
        }
    }
    return false;
}

bool dfs(ll v, vector<vector<ll>> &g, vector<bool> &used) {
    if (used[v]) {
        return false;
    }
    used[v] = true;
    for (ll to : g[v]) {
        if (!dfs(to, g, used)) {
            return false;
        }
    }
    return true;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<Seg> a(k);
    bool fl1 = true, fl2 = true;
    for (ll i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        if (a[i].l != a[i].m) {
            fl1 = false;
        }
        if (a[i].l > 0 && a[i].r < n - 1) {
            fl2 = false;
        }
    }

    if (fl1) {
        sort(a.begin(), a.end());
        ll maxx = 0;
        for (ll i = 0; i < k; ++i) {
            if (maxx < a[i].l) {
                cout << "NO\n";
                return;
            }
            maxx = max(maxx, a[i].r + 1);
        }
        if (maxx == n) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
        return;
    }

    if (fl2) {
        vector<pair<ll, ll>> l, r;
        for (ll i = 0; i < k; ++i) {
            if (a[i].l == 0) {
                l.emplace_back(a[i].r, a[i].m);
                if (a[i].r == n - 1) {
                    cout << "YES\n";
                    return;
                }
            } else {
                r.emplace_back(a[i].l, a[i].m);
            }
        }

        sort(l.begin(), l.end());
        sort(r.begin(), r.end());
        if (get_ans_lr(l, r)) {
            cout << "YES\n";
        } else {
            for (auto &i : l) {
                i.first = n - 1 - i.first;
                i.second = n - 1 - i.second;
            }
            for (auto &i : r) {
                i.first = n - 1 - i.first;
                i.second = n - 1 - i.second;
            }
            sort(l.begin(), l.end());
            sort(r.begin(), r.end());
            if (get_ans_lr(r, l)) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
        return;
    }

    vector<vector<ll>> g(k);
    for (ll i = 0; i < k; ++i) {
        for (ll j = 0; j < k; ++j) {
            if (i != j && a[i].l <= a[j].m && a[j].m <= a[i].r) {
                g[i].push_back(j);
            }
        }
    }
    vector<bool> used(k, false);
    for (ll i = 0; i < k; ++i) {
        if (!used[i] && !dfs(i, g, used)) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll ttt_ = 1;
    cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}