#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Seg {
    ll l, m, r;

    Seg() = default;

    Seg(ll l, ll m, ll r) : l(l), m(m), r(r) {};

    bool operator <(const Seg &a) const {
        return l < a.l || (l == a.l && r < a.r);
    }
};

bool dfs(ll v, vector<vector<ll>> &g, vector<ll> &used, ll time) {
    used[v] = time;
    for (ll to : g[v]) {
        if (used[to] == time) {
            return false;
        }
        if (used[to] == -1 && !dfs(to, g, used, time)) {
            return false;
        }
    }
    return true;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<Seg> a(k);
    bool fl1 = true, fl2 = true;
    for (ll i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        if (a[i].l != a[i].m) {
            fl1 = false;
        }
        if (a[i].l > 0 && a[i].r < n - 1) {
            fl2 = false;
        }
    }

    sort(a.begin(), a.end());
    ll maxx = 0;
    for (ll i = 0; i < k; ++i) {
        if (maxx < a[i].l) {
            cout << "NO\n";
            return;
        }
        maxx = max(maxx, a[i].r + 1);
    }
    if (maxx != n) {
        cout << "NO\n";
        return;
    }

    vector<vector<ll>> g(k);
    for (ll i = 0; i < k; ++i) {
        for (ll j = 0; j < k; ++j) {
            if (i != j && a[i].l <= a[j].m && a[j].m <= a[i].r) {
                g[i].push_back(j);
            }
        }
    }

    vector<ll> used(k, -1);
    ll time = 0;
    for (ll i = 0; i < k; ++i) {
        if (used[i] == -1 && !dfs(i, g, used, time++)) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll ttt_ = 1;
    cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}