#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Seg {
    ll l, m, r;

    Seg() = default;

    Seg(ll l, ll m, ll r) : l(l), m(m), r(r) {};

    bool operator <(const Seg &a) const {
        return l < a.l || (l == a.l && r < a.r);
    }
};

bool dfs(ll v, vector<vector<ll>> &g, vector<ll> &used, ll time) {
    used[v] = time;
    for (ll to : g[v]) {
        if (used[to] == time) {
            return false;
        }
        if (used[to] == -1 && !dfs(to, g, used, time)) {
            return false;
        }
    }
    return true;
}

bool check(ll n, ll k, vector<Seg> &a, vector<ll> &ord) {
    vector<bool> used(k, false);
    for (ll i = 0; i < k; ++i) {
        Seg x = a[ord[i]];
        bool venom = true;
        for (ll j = 0; j < i; ++j) {
            Seg y = a[ord[j]];
            if (y.l <= x.m && x.m <= y.r) {
                venom = false;
                break;
            }
        }
        if (venom) {
            used[ord[i]] = true;
        }
    }

    vector<Seg> b;
    for (ll i = 0; i < k; ++i) {
        if (used[i]) {
            b.push_back(a[i]);
        }
    }
    sort(b.begin(), b.end());
    ll maxx = 0;
    for (auto & i : b) {
        if (maxx < i.l) {
            return false;
        }
        maxx = max(maxx, i.r + 1);
    }
    if (maxx != n) {
        return false;
    }
    return true;
}

bool rec(ll n, ll k, vector<Seg> &a, vector<ll> &ord, ll done, vector<bool> &used) {
    if (done == k) {
        return check(n, k, a, ord);
    }

    for (ll i = 0; i < k; ++i) {
        if (!used[i]) {
            ord[done] = i;
            used[i] = true;
            if (rec(n, k, a, ord, done + 1, used)) {
                return true;
            }
            used[i] = false;
        }
    }
    return false;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<Seg> a(k);
    bool fl1 = true, fl2 = true;
    for (ll i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        if (a[i].l != a[i].m) {
            fl1 = false;
        }
        if (a[i].l > 0 && a[i].r < n - 1) {
            fl2 = false;
        }
    }

    vector<ll> ord(k, 0);
    vector<bool> used(k, false);
    if (rec(n, k, a, ord, 0, used)) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll ttt_ = 1;
    cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}