#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>

using namespace std;

// #define int long long

using ll = long long;
using pii = pair<int, int>;

const int inf = 1e9, max_n = 202;
vector<int> g[max_n];
vector<int> pg[max_n];
int d;
vector<int> h(max_n);

void add_edge(int a, int b) {
   // if (h[a] % 2 == 1) swap(a, b);
    pg[a].push_back(b);
   // cout << "E " << a + 1 << " " << b + 1 << endl;
}

void dfs(int v, int pr, int x, int anc) {
   // cout << "vx " <<  v << " " << x << endl;
    if (x % 2 == 1 && x <= d) {
        add_edge(anc, v);
    }
    for (int u : g[v]) {
        if (u != pr) {
            dfs(u, v, x + 1, anc);
        }
    }
}

void calc_h(int v, int pr) {
    if (pr == -1) h[v] = 0;
    for (int u : g[v]) {
        if (u != pr) {
            calc_h(u, v);
        }
    }
}

int bit(int a, int id) {
    return (a >> id) & 1;
}

void solve() {
    int n; cin >> n;
    cin >> d;
    for (int i = 0; i < n - 1; i++) {
        int v, u; cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    calc_h(0, -1);
    for (int i = 0; i < n; i++) {
        dfs(i, -1, 0, i);
    }
    int p = (1 << n);
    vector<pii> dp(p, {-1, -1});
    dp[0] = {-2, -2};
    int ires = 0;
    int msk = 0;
    for (int mask = 0; mask < p; mask++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            cnt += bit(mask, i);
        }
        if (dp[mask].first == -1) continue;
        for (int v = 0; v < n; v++) {
            for (int u : pg[v]) {
                if (!bit(mask, v) && !bit(mask, u)) {
                    dp[mask + (1 << v) + (1 << u)] = {v, u};
                }
            }
        }
        if (dp[mask].first != -1) {
            ires = max(ires, cnt);
            if (ires == cnt) {
                msk = mask;
            }
        }
    }
    cout << ires / 2 << endl;
    vector<pii> vres;
    while (msk > 0) {
        vres.emplace_back(dp[msk]);
        auto [x, y] = dp[msk];
        msk -= (1 << x);
        msk -= (1 << y);
    }
    for (auto [x, y] : vres) {
        cout << x+1 << " " << y+1 << endl;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
