#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define endl '\n'
#define ALL(v) v.begin(), v.end()

using namespace std;

template<typename T1, typename T2>
bool rmin(T1& a, const T2& b)
{
	if (b < a)
	{
		a = b;
		return true;
	}
	return false;
}
template<typename T1, typename T2>
bool rmax(T1& a, const T2& b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

#ifdef _DEBUG

typedef int64_t int128;

#else

typedef __int128 int128;

#endif // _DEBUG

struct Otr
{
	int l, m, r;
	friend bool operator<(const Otr& a, const Otr& b)
	{
		return a.l < b.l;
	}
};

constexpr uint32_t MAXN = 500;
bool dp[MAXN + 1][MAXN + 1];

void solve()
{
	int n, k;
	cin >> n >> k;
	vector<Otr> mas(k);
	for (int i = 0; i < k; i++)
	{
		cin >> mas[i].l >> mas[i].m >> mas[i].r;
		--mas[i].l;
	}
	sort(ALL(mas));

	for (int i = 0; i <= n; i++)
	{
		for (int j = 0; j <= n; j++)
		{
			dp[i][j] = false;
		}
	}
	dp[0][0] = true;
	for (int i = 0; i < k; i++)
	{
		for (int r = mas[i].l; r <= n; r++)
		{
			for (int m = 0; m <= r; m++)
			{
				if ((r <= mas[i].m - 1 or m <= mas[i].l) and dp[r][m])
				{
					dp[mas[i].r][mas[i].m] = true;
				}
			}
		}
	}

	bool ans = false;
	for (int m = 0; m <= n; m++)
	{
		if (dp[n][m])
		{
			ans = true;
		}
	}
	if (ans)
	{
		cout << "YES";
	}
	else
	{
		cout << "NO";
	}
}