#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define endl '\n'
#define ALL(v) v.begin(), v.end()

using namespace std;

template<typename T1, typename T2>
bool rmin(T1& a, const T2& b)
{
	if (b < a)
	{
		a = b;
		return true;
	}
	return false;
}
template<typename T1, typename T2>
bool rmax(T1& a, const T2& b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

#ifdef _DEBUG

typedef int64_t int128;

#else

typedef __int128 int128;

#endif // _DEBUG

struct Otr
{
	int l, m, r;
	friend bool operator<(const Otr& a, const Otr& b)
	{
		return a.l < b.l;
	}
};

int tree[1 << 20];
void set_v(int v, int l, int r, int ind, int val)
{
	if (l + 1 == r)
	{
		tree[v] = val;
		return;
	}
	int mid = (l + r) / 2;
	if (ind < mid)
	{
		set_v(v * 2 + 0, l, mid, ind, val);
	}
	else
	{
		set_v(v * 2 + 1, mid, r, ind, val);
	}
	tree[v] = min(tree[v * 2 + 0], tree[v * 2 + 1]);
	return;
}
int get(int v, int l, int r, int ql, int qr)
{
	if (r <= ql or qr <= l)
	{
		return 1'000'000;
	}
	if (ql <= l and r <= qr)
	{
		return tree[v];
	}
	int mid = (l + r) / 2;
	return min(get(v * 2 + 0, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
}

void solve()
{
	int n, k;
	cin >> n >> k;
	vector<Otr> mas(k);
	for (int i = 0; i < k; i++)
	{
		cin >> mas[i].l >> mas[i].m >> mas[i].r;
		--mas[i].l;
	}
	sort(ALL(mas));
	int sz = 1;
	while (sz < n + 1)
	{
		sz *= 2;
	}

	for (int i = 0; i <= n; i++)
	{
		set_v(1, 0, sz, i, n + 1);
	}
	set_v(1, 0, sz, 0, 0);
	for (int i = 0; i < k; i++)
	{
		if (get(1, 0, sz, mas[i].l, mas[i].m) < n + 1 or get(1, 0, sz, mas[i].m, n + 1) <= mas[i].l)
		{
			set_v(1, 0, sz, mas[i].r, min(mas[i].m, get(1, 0, sz, mas[i].r, mas[i].r + 1)));
		}
	}

	if (get(1, 0, sz, n, n + 1) < n + 1)
	{
		cout << "YES";
	}
	else
	{
		cout << "NO";
	}
}