#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
 
using namespace std;
 
template<typename T1, typename T2>
bool rmin(T1& a, const T2& b)
{
    if (b < a)
    {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool rmax(T1& a, const T2& b)
{
    if (a < b)
    {
        a = b;
        return true;
    }
    return false;
}
 
void solve();
 
int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
	cout << fixed << setprecision(0);
 
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++)
    {
        solve();
        cout << endl;
    }
}
 
#ifdef _DEBUG
 
typedef long double int128;
 
#else
 
typedef long double int128;
 
#endif // _DEBUG
 
int64_t sq(int x)
{
    return int64_t(x) * x;
}
 
constexpr uint32_t MAXN = 300'000;
int coor[MAXN], coor_l[MAXN + 1], coor_l_sz = 0, coor_r[MAXN + 1], coor_r_sz = 0, v_mn_d_l_sz = 0, v_mn_d_r_sz = 0, pref_sq_l_sz = 1, suf_sq_r_sz = 1, pref_l_sz = 1, pref_r_sz = 1;
pair<int, int128> v_mn_d_l[MAXN + 1], v_mn_d_r[MAXN + 1];
int128 pref_sq_l[MAXN + 2], suf_sq_r[MAXN + 2];
int64_t pref_l[MAXN +2], suf_r[MAXN + 2];
 
void solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> coor[i];
    }
    sort(coor, coor + n);
 
    int x0, d;
    cin >> x0 >> d;
    int shift = d - x0 % d;
    for (int i = 0; i < n; i++)
    {
        coor[i] += shift;
    }
    x0 += shift;
 
    coor_r[coor_r_sz++] = x0;
    for (int i = 0; i < n; i++)
    {
        if (coor[i] < x0)
        {
            coor_l[coor_l_sz++] = coor[i];
        }
        else if (coor[i] > x0)
        {
            coor_r[coor_r_sz++] = coor[i];
        }
    }
    coor_l[coor_l_sz++] = x0;
 
    map<int, int128> mn_d_l, mn_d_r;
    for (int i = 0; i < coor_l_sz; i++)
    {
        if (coor_l[i] % d == 0)
        {
            mn_d_l[coor_l[i]] += 0;
        }
        else
        {
            int l_pos = coor_l[i] / d * d, r_pos = (coor_l[i] / d + 1) * d;
            if (coor_l[i] - l_pos < r_pos - coor_l[i])
            {
                mn_d_l[l_pos] += sq(coor_l[i] - l_pos);
            }
            else
            {
                mn_d_l[r_pos] += sq(r_pos - coor_l[i]);
            }
        }
    }
    for (auto& x : mn_d_l)
    {
        v_mn_d_l[v_mn_d_l_sz++] = x;
    }
    for (int i = v_mn_d_l_sz - 2; i >= 0; i--)
    {
        v_mn_d_l[i].second += v_mn_d_l[i + 1].second;
    }
    for (int i = 0; i < coor_r_sz; i++)
    {
        if (coor_r[i] % d == 0)
        {
            mn_d_r[coor_r[i]] += 0;
        }
        else
        {
            int l_pos = coor_r[i] / d * d, r_pos = (coor_r[i] / d + 1) * d;
            if (coor_r[i] - l_pos <= r_pos - coor_r[i])
            {
                mn_d_r[l_pos] += sq(coor_r[i] - l_pos);
            }
            else
            {
                mn_d_r[r_pos] += sq(r_pos - coor_r[i]);
            }
        }
    }
    for (auto& x : mn_d_r)
    {
        v_mn_d_r[v_mn_d_r_sz++] = x;
    }
    for (int i = 1; i < v_mn_d_r_sz; i++)
    {
        v_mn_d_r[i].second += v_mn_d_r[i - 1].second;
    }
 
    for (int i = 0; i < coor_l_sz; i++)
    {
        pref_sq_l[i + 1] = pref_sq_l[i] + sq(coor_l[i]);
        pref_l[i + 1] = pref_l[i] + coor_l[i];
    }
    for (int i = coor_r_sz - 1; i >= 0; i--)
    {
        suf_sq_r[i] = suf_sq_r[i + 1] + sq(coor_r[i]);
        suf_r[i] = suf_r[i + 1] + coor_r[i];
    }
 
    int m;
    cin >> m;
    int start_r_l = (x0 - mn_d_l.begin()->first) / d + 1, start_r_r = (prev(mn_d_r.end())->first - x0) / d + 1;
    for (int i = 0; i < m; i++)
    {
        int t;
        cin >> t;
 
        auto check_l = [&](const int x) -> int128
        {
            int128 ans = lower_bound(v_mn_d_l, v_mn_d_l + v_mn_d_l_sz, x, [&](auto& a, auto& b) {return a.first < b; })->second;
            int r_ind = lower_bound(coor_l, coor_l + coor_l_sz, x - d / 2) - coor_l;
            ans += int128(r_ind) * sq(x) - int128(2) * x * pref_l[r_ind] + pref_sq_l[r_ind];
            return ans;
        };
        auto check_r = [&](const int x) -> int128
        {
            int128 ans = prev(upper_bound(v_mn_d_r, v_mn_d_r + v_mn_d_r_sz, x, [&](auto& a, auto& b) {return a < b.first; }))->second;
            int l_ind = upper_bound(coor_r, coor_r + coor_r_sz, x + d / 2) - coor_r;
            ans += int128(coor_r_sz - l_ind) * sq(x) - int128(2) * x * suf_r[l_ind] + suf_sq_r[l_ind];
            return ans;
        };
 
        auto check_1l = [&](const int cnt) -> int128
        {
            return int64_t(t) * cnt + check_l(x0 - cnt * d);
        };
        auto check_2l = [&](const int cnt) -> int128
        {
            return int64_t(2) * t * cnt + check_l(x0 - cnt * d);
        };
        auto check_1r = [&](const int cnt) -> int128
        {
            return int64_t(t) * cnt + check_r(x0 + cnt * d);
        };
        auto check_2r = [&](const int cnt) -> int128
        {
            return int64_t(2) * t * cnt + check_r(x0 + cnt * d);
        };
 
        int l, r;
        int128 ans_1l, ans_2l, ans_1r, ans_2r;
 
        l = 0;
        r = start_r_l;
        while (r - l > 2)
        {
            int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check_1l(m1) < check_1l(m2))
            {
                r = m2;
            }
            else
            {
                l = m1;
            }
        }
        ans_1l = min(check_1l(l), check_1l(l + 1));
 
        l = 0;
        r = start_r_l;
        while (r - l > 2)
        {
            int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check_2l(m1) < check_2l(m2))
            {
                r = m2;
            }
            else
            {
                l = m1;
            }
        }
        ans_2l = min(check_2l(l), check_2l(l + 1));
 
 
 
        l = 0;
        r = start_r_r;
        while (r - l > 2)
        {
            int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check_1r(m1) < check_1r(m2))
            {
                r = m2;
            }
            else
            {
                l = m1;
            }
        }
        ans_1r = min(check_1r(l), check_1r(l + 1));
 
        l = 0;
        r = start_r_r;
        while (r - l > 2)
        {
            int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            if (check_2r(m1) < check_2r(m2))
            {
                r = m2;
            }
            else
            {
                l = m1;
            }
        }
        ans_2r = min(check_2r(l), check_2r(l + 1));
 
        cout << min(ans_1l + ans_2r, ans_2l + ans_1r) << endl;
    }
}