#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define endl '\n'
#define ALL(v) v.begin(), v.end()

using namespace std;

template<typename T1, typename T2>
bool rmin(T1& a, const T2& b)
{
	if (b < a)
	{
		a = b;
		return true;
	}
	return false;
}
template<typename T1, typename T2>
bool rmax(T1& a, const T2& b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

#ifdef _DEBUG

typedef int64_t int128;

#else

typedef __int128 int128;

#endif // _DEBUG

int64_t sq(int x)
{
	return int64_t(x) * x;
}

void solve()
{
	int n;
	cin >> n;
	vector<int> coor(n);
	for (int i = 0; i < n; i++)
	{
		cin >> coor[i];
	}

	int x0, d;
	cin >> x0 >> d;
	int shift = d - x0 % d;
	for (int i = 0; i < n; i++)
	{
		coor[i] += shift;
	}
	x0 += shift;

	vector<int> coor_l, coor_r;
	coor_l.push_back(x0);
	coor_r.push_back(x0);
	for (int i = 0; i < n; i++)
	{
		if (coor[i] < x0)
		{
			coor_l.push_back(coor[i]);
		}
		else if (coor[i] > x0)
		{
			coor_r.push_back(coor[i]);
		}
	}
	map<int, int128> mn_d_l, mn_d_r;
	for (int i = 0; i < coor_l.size(); i++)
	{
		if (coor_l[i] % d == 0)
		{
			mn_d_l[coor_l[i]] += 0;
		}
		else
		{
			int l_pos = coor_l[i] / d * d, r_pos = (coor_l[i] / d + 1) * d;
			if (coor_l[i] - l_pos < r_pos - coor_l[i])
			{
				mn_d_l[l_pos] += sq(coor_l[i] - l_pos);
			}
			else
			{
				mn_d_l[r_pos] += sq(r_pos - coor_l[i]);
			}
		}
	}
	auto it = prev(mn_d_l.end());
	while (it != mn_d_l.begin())
	{
		prev(it)->second += it->second;
		--it;
	}
	for (int i = 0; i < coor_r.size(); i++)
	{
		if (coor_r[i] % d == 0)
		{
			mn_d_r[coor_r[i]] += 0;
		}
		else
		{
			int l_pos = coor_r[i] / d * d, r_pos = (coor_r[i] / d + 1) * d;
			if (coor_r[i] - l_pos <= r_pos - coor_r[i])
			{
				mn_d_r[l_pos] += sq(coor_r[i] - l_pos);
			}
			else
			{
				mn_d_r[r_pos] += sq(r_pos - coor_r[i]);
			}
		}
	}
	it = mn_d_r.begin();
	while (next(it) != mn_d_r.end())
	{
		next(it)->second += it->second;
		++it;
	}

	vector<int128> pref_sq_l(coor_l.size() + 1), pref_l(coor_l.size() + 1), suf_sq_r(coor_r.size() + 1), suf_r(coor_r.size() + 1);
	sort(ALL(coor_l));
	for (int i = 0; i < coor_l.size(); i++)
	{
		pref_sq_l[i + 1] = pref_sq_l[i] + sq(coor_l[i]);
		pref_l[i + 1] = pref_l[i] + coor_l[i];
	}
	sort(ALL(coor_r));
	for (int i = coor_r.size() - 1; i >= 0; i--)
	{
		suf_sq_r[i] = suf_sq_r[i + 1] + sq(coor_r[i]);
		suf_r[i] = suf_r[i + 1] + coor_r[i];
	}

	int m;
	cin >> m;
	for (int i = 0; i < m; i++)
	{
		int ct;
		cin >> ct;
		int128 t = ct;

		auto check_l = [&](const int x) -> int128
		{
			int128 ans = mn_d_l.lower_bound(x)->second;
			int r_ind = lower_bound(ALL(coor_l), x - d / 2) - coor_l.begin();
			ans += int128(r_ind) * sq(x) - int128(2) * x * pref_l[r_ind] + pref_sq_l[r_ind];
			return ans;
		};
		auto check_r = [&](const int x) -> int128
		{
			int128 ans = prev(mn_d_r.upper_bound(x))->second;
			int l_ind = upper_bound(ALL(coor_r), x + d / 2) - coor_r.begin();
			ans += int128(coor_r.size() - l_ind) * sq(x) - int128(2) * x * suf_r[l_ind] + suf_sq_r[l_ind];
			return ans;
		};

		auto check_1l = [&](const int cnt) -> int128
		{
			return t * cnt + check_l(x0 - cnt * d);
		};
		auto check_2l = [&](const int cnt) -> int128
		{
			return 2 * t * cnt + check_l(x0 - cnt * d);
		};
		auto check_1r = [&](const int cnt) -> int128
		{
			return t * cnt + check_r(x0 + cnt * d);
		};
		auto check_2r = [&](const int cnt) -> int128
		{
			return 2 * t * cnt + check_r(x0 + cnt * d);
		};

		int64_t l, r;
		int128 ans_1l, ans_2l, ans_1r, ans_2r;

		l = 0;
		r = (x0 - mn_d_l.begin()->first) / d + 1;
		while (r - l > 2)
		{
			int m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
			if (check_1l(m1) < check_1l(m2))
			{
				r = m2;
			}
			else
			{
				l = m1;
			}
		}
		ans_1l = min(check_1l(l), check_1l(l + 1));

		l = 0;
		r = (x0 - mn_d_l.begin()->first) / d + 1;
		while (r - l > 2)
		{
			int m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
			if (check_2l(m1) < check_2l(m2))
			{
				r = m2;
			}
			else
			{
				l = m1;
			}
		}
		ans_2l = min(check_2l(l), check_2l(l + 1));



		l = 0;
		r = (prev(mn_d_r.end())->first - x0) / d + 1;
		while (r - l > 2)
		{
			int m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
			if (check_1r(m1) < check_1r(m2))
			{
				r = m2;
			}
			else
			{
				l = m1;
			}
		}
		ans_1r = min(check_1r(l), check_1r(l + 1));

		l = 0;
		r = (prev(mn_d_r.end())->first - x0) / d + 1;
		while (r - l > 2)
		{
			int m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
			if (check_2r(m1) < check_2r(m2))
			{
				r = m2;
			}
			else
			{
				l = m1;
			}
		}
		ans_2r = min(check_2r(l), check_2r(l + 1));

		int64_t ans = min(ans_1l + ans_2r, ans_2l + ans_1r);
		cout << ans << endl;
	}
}