#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <numeric>
#include <unordered_map>

using namespace std;

using ll = long long;

ll get(vector<ll>& vec) {
	ll n = vec.size();
	vector<ll> id;
	vector<ll> left(n, -1);
	for (int i = 0; i < n; i++) {
		while (!id.empty() && vec[id.back()] >= vec[i]) id.pop_back();
		if (!id.empty()) left[i] = id.back();
		id.push_back(i);
	}
	vector<ll> dp(n);
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		dp[i] = (i - left[i]) * vec[i];
		if (left[i] != -1) dp[i] += dp[left[i]];
		ans = max(ans, dp[i]);
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int h, w; cin >> h >> w;
	vector<vector<ll>> vec(h, vector<ll>(w));
	for (int i = 0; i < h; i++) {
		string s; cin >> s;
		for (int j = 0; j < w; j++) {
			vec[i][j] = s[j] == '1';
		}
	}
	vector<ll> cnt(h);
	ll ans = 0;
	for (int i = w - 1; i >= 0; i--) {
		for (int j = 0; j < h; j++) {
			if (vec[j][i] == 0) cnt[j] = 0;
			else cnt[j]++;	
		}
		ans = max(ans, get(cnt));
	}
	cout << ans << endl;
}
