#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>

using namespace std;

using ll = long long;

long long d;

ll div1 = 100;

ll get(ll p, ll b) {
	if (b > p) return (b - p) * (b - p);
	ll prev = b % d;
	prev = min(prev, d - prev);
	return prev * prev;
}

ll get(vector<ll>& balls, ll t, vector<ll>& precalc) {
	if (balls.empty()) return 0;
	ll l = 0, r = balls.back() / d + 2;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		ll dd = precalc[m - 1] - precalc[m];
		if (dd >= t) l = m;
		else r = m;
	}
	return precalc[l] + l * t;
}

struct state {
	ll cnt = 0;
	ll minall = 0;
	ll id = 0;
	ll sum = 0;

	state(ll cnt, ll minall, ll id, ll sum) : cnt(cnt), minall(minall), id(id), sum(sum) {}
};

vector<state> statesl, statesr;

vector<ll> precalc(vector<ll>& balls, vector<state>& states) {
	sort(balls.begin(), balls.end());
	ll s0 = 0;
	for (auto p : balls) s0 += p * p;
	vector<ll> ans(1, s0);
	ll sum = 0;
	for (auto p : balls) sum += p;
	ll cnt = balls.size();
	ll minall = 0;
	ll id = 0;
	states.push_back(state(cnt, minall, id, sum));
	for (int i = 1; cnt > 0; i++) {
		while (id < balls.size() && balls[id] <= i * d) {
			s0 -= (balls[id] - minall) * (balls[id] - minall);
			cnt--;
			sum -= (balls[id] - minall);

			s0 += get(i * d, balls[id]);

			id++;
		}
		ll delta = (d * d) * cnt - 2 * d * sum;

		sum -= cnt * d;
		minall += d;

		s0 += delta;
		ans.push_back(s0);
		states.push_back(state(cnt, minall, id, sum));
	}
	ans.push_back(ans.back());
	states.push_back(states.back());
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	long long n; cin >> n;
	vector<long long> vec(n);
	for (int i = 0; i < n; i++) cin >> vec[i];
	long long x; cin >> x >> d;

	d *= div1;

	vector<ll> left, right;
	for (auto p : vec) {
		if (p > x) right.push_back(p - x);
		if (p < x) left.push_back(x - p);
	}

	sort(left.begin(), left.end());
	sort(right.begin(), right.end());

	auto precalcL = precalc(left, statesl), precalcR = precalc(right, statesr);

	long long m; cin >> m;
	while (m--) {
		long long t; cin >> t;
		ll l1 = get(left, t, precalcL);
		ll l2 = get(left, t * 2, precalcL);
		ll r1 = get(right, t, precalcR);
		ll r2 = get(right, t * 2, precalcR);
		ll ans = min(
			l2 + r1,
			r2 + l1
		);
		cout << (long long)ans << endl;
	}
}