#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>

using namespace std;

using ll = long long;

ll d;

ll get(ll p, ll b) {
	if (b > p) return (b - p) * (b - p);
	ll prev = b % d;
	prev = min(prev, d - prev);
	return prev * prev;
}

vector<pair<pair<ll, ll>, ll>> precalc(vector<ll> balls) {
	vector<ll> positions(1);
	for (auto p : balls) {
		ll prev = (p / d) * d;
		ll next = prev + d;
		positions.push_back(prev);
		positions.push_back(next);
	}
	ll mbal = 0;
	for (auto p : balls) mbal = max(mbal, p);
	ll c = 0;
	while (c <= mbal) {
		positions.push_back(c);
		c += d;
	}
	sort(positions.begin(), positions.end());
	sort(balls.begin(), balls.end());
	positions.erase(unique(positions.begin(), positions.end()), positions.end());
	vector<pair<pair<ll, ll>, ll>> ans;
	for (auto p : positions) {
		ll answ = 0;
		for (auto b : balls) answ += get(p, b);
		ll pansw = 0;
		for (auto b : balls) pansw += get(p - d, b);
		ll delta = pansw - answ;
		ans.push_back({ { p, answ }, delta });
	}
	return ans;
}

vector<vector<pair<pair<ll, ll>, ll>>> precalc(ll x0, vector<ll> vec) {
	vector<ll> left, right;
	for (auto p : vec) {
		if (p > x0) right.push_back(p - x0);
		if (p < x0) left.push_back(x0 - p);
	}
	auto c1 = precalc(left), c2 = precalc(right);
	return { c1, c2 };
}

pair<ll, ll> vecot(ll p, vector<ll>& balls) {
	ll answ = 0;
	for (auto b : balls) answ += get(p, b);
	ll pansw = 0;
	for (auto b : balls) pansw += get(p - d, b);
	ll delta = pansw - answ;
	return { answ, delta };
}

ll get(vector<ll>& balls, ll t) {
	ll l = 0, r = balls.back() / d + 2;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		auto dd = vecot(m * d, balls);
		ll delta = dd.second;
		if (delta >= t) l = m;
		else r = m;
	}
	auto dd = vecot(l * d, balls);
	return dd.first + l * t;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n; cin >> n;
	vector<ll> vec(n);
	for (int i = 0; i < n; i++) cin >> vec[i];
	ll x; cin >> x >> d;

	vector<ll> left, right;
	for (auto p : vec) {
		if (p > x) right.push_back(p - x);
		if (p < x) left.push_back(x - p);
	}
	
	ll m; cin >> m;
	while (m--) {	
		ll t; cin >> t;
		ll l1 = get(left, t);
		ll l2 = get(left, t * 2);
		ll r1 = get(right, t);
		ll r2 = get(right, t * 2);
		ll ans = min(
			l2 + r1,
			r2 + l1
		);
		cout << ans << endl;
	}
}
