#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>

using namespace std;

using ll = long long;

long long d;

vector<vector<ll>> graph;

vector<ll> color;

vector<ll> dp1, dp2;
vector<ll> from1;

void dfs(ll i, vector<ll>& dist) {
	for (auto p : graph[i]) {
		if (dist[p] != -1) continue;
		dist[p] = dist[i] + 1;
		dfs(p, dist);
	}
}

vector<ll> cpath;
vector<bool> term;
vector<ll> cntin;

bool kuhn(ll i, vector<ll>& used, vector<unordered_set<ll>>& g) {
	cpath.push_back(i);
	used[i] = true;
	for (auto p : g[i]) {
		if (!used[p]) {
			if (!kuhn(p, used, g)) {
				cpath.pop_back();
				return false;
			}
		}
	}
	if (term[i] && g[i].empty()) {
		for (int i = 0; i + 1 < cpath.size(); i++) {
			ll a = cpath[i];
			ll b = cpath[i + 1];
			g[a].erase(b);
			cntin[b]--;
			g[b].insert(a);
			cntin[a]++;
		}
		cpath.pop_back();
		return false;
	}
	cpath.pop_back();
	return true;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, d; cin >> n >> d;
	graph.resize(n);
	for (int i = 0; i < n - 1; i++) {
		ll a, b; cin >> a >> b; a--; b--;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}
	vector<vector<ll>> dist(n, vector<ll>(n, -1));
	for (int i = 0; i < n; i++) {
		dist[i][i] = 0;
		dfs(i, dist[i]);
	}
	vector<unordered_set<ll>> g(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (j != i && dist[i][j] <= d && dist[i][j] % 2) {
				if (dist[0][i] % 2) {
					g[i].insert(j);
				}
				else {
					g[j].insert(i);
				}
			}
		}
	}
	vector<ll> c1, c2;
	for (int i = 0; i < n; i++) {
		if (dist[0][i] % 2) c1.push_back(i);
		else c2.push_back(i);
	}
	term.resize(n);
	for (auto p : c2) term[p] = true;
	cntin.resize(n);
	for (auto p : c1) {
		for (auto e : g[p]) cntin[e]++;
	}

	for (int itr = 0; itr < n + 1; itr++) {
		vector<ll> used(n, false);
		for (auto c : c1) {
			if (used[c] || cntin[c] > 0) continue;
			kuhn(c, used, g);
		}
	}
	vector<pair<ll, ll>> answ;
	for (auto c : c2) {
		if (g[c].empty()) continue;
		answ.push_back({ c, *g[c].begin() });
	}
	cout << answ.size() << endl;
	for (auto p : answ) cout << p.first + 1 << " " << p.second + 1 << endl;
}