#include <bits/stdc++.h> 

using ll = long long;
using namespace std;

#define all(a) a.begin(), a.end()

const ll inf = 1e18;

void solve();
void prec();

int main() {
#ifdef LOCAL
    freopen("_INPUT.TXT", "r", stdin);
    freopen("_OUTPUT.TXT", "w", stdout);
    auto start = clock();
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    prec();
    ll t;
    cin >> t;
    while(t--) {
        solve();
    }
#ifdef LOCAL
    auto end = clock();
    cout << "\nXXXtimeXXX: " << fixed << setprecision(10) << (end - start) / 1000.0;
#endif
}

void prec() {

}

struct elem {
    ll l, m, r;
};

bool comp(elem &t1, elem& t2) {
    if(t1.m == t2.m) {
        return t1.r < t2.r;
    }
    return t1.m < t2.m;
}

vector<ll> tree;

void update(ll v, ll l, ll r, ll pos, ll val) {
    if(l == r - 1) {
        tree[v] = min(tree[v], val);
        return;
    }
    ll m = (l + r) / 2;
    if(m > pos) {
        update(2 * v + 1, l, m, pos, val);
    } else {
        update(2 * v + 2, m, r, pos, val);
    }
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if(l >= ql && r <= qr) {
        return tree[v];
    } else if(ql >= r || qr <= l) {
        return inf;
    }
    return min(get(2 * v + 1, l, (l + r) / 2, ql, qr), get(2 * v + 2, (l + r) / 2, r, ql, qr));
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<elem> segm(k);
    for(int i = 0; i < k; i++) {
        cin >> segm[i].l >> segm[i].m >> segm[i].r;
    }
    sort(all(segm), comp);
    tree.assign(4 * (n + 10), inf);
    for(int i = 0; i < k; i++) {
        if(segm[i].l == 1) {
            update(0, 0, n + 1, segm[i].r, segm[i].m);
        } else if(get(0, 0, n + 1, segm[i].l - 1, segm[i].m) != inf) {
            update(0, 0, n + 1, segm[i].r, segm[i].m);
        } else if(get(0, 0, n + 1, segm[i].m, segm[i].r) < segm[i].l) {
            update(0, 0, n + 1, segm[i].r, segm[i].m);
        }
    }
    if(get(0, 0, n + 1, n, n + 1) != inf) {
        cout << "YES" << "\n";
    } else {
        cout << "NO" << "\n";
    }
}