#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

vector<ll> p, sz, an;
ll SU = 0;

int pr(int x) {
	if(p[x] == -1) return x;
	return p[x] = pr(p[x]);
}

void obed(int a, int b) {
	a = pr(a);
	b = pr(b);
	if (a == b) return;
	if (sz[a] < sz[b]) swap(a, b);
	SU -= sz[a] * an[a] + sz[b] * an[b];
	an[a] = min(an[a], an[b]);
	sz[a] += sz[b];
	SU += sz[a] * an[a];
	p[b] = a;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	vector<vector<ll>> b(n, vector<ll>(m));
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++) {
			a[i][j] = s[j] - '0';
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j > -1; j--) {
			if (!a[i][j]) {
				b[i][j] = 0;
				continue;
			}
			if (j != m - 1) b[i][j] = b[i][j + 1];
			b[i][j]++;
		}
	}
	p.resize(n);
	sz.resize(n);
	an.resize(n);
	ll ans = 0;
	for (int j = 0; j < m; j++) {
		SU = 0;
		for (int i = 0; i < n; i++) {
			p[i] = -1;
			sz[i] = 1;
			an[i] = b[i][j];
		}
		vector<pair<int, int>> c;
		c.push_back({ 0, -1 });
		for (int i = 0; i < n; i++) {
			SU += b[i][j];
			while (c.back().first > b[i][j]) {
				obed(c.back().second, i);
				c.pop_back();
			}
			c.push_back({ b[i][j], i });
		    ans = max(ans, SU);
		}
	}
	cout << ans;
}