#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

struct DO_mi {
	vector<int> d;

	DO_mi(int n) : d(n * 4, 1e9) {};

	void upd(int v, int l, int r, int x, int y) {
		if (l + 1 == r) {
			d[v] = y;
			return;
		}
		int m = (l + r) / 2;
		if (x >= m) upd(v * 2 + 1, m, r, x, y);
		else upd(v * 2, l, m, x, y);
		d[v] = min(d[v * 2], d[v * 2 + 1]);
	}

	int ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return 1e9;
		int m = (l + r) / 2;
		return min(ans(v * 2, l, m, L, R), ans(v * 2 + 1, m, r, L, R));
	}
};

struct DO_ma {
	vector<int> d;

	DO_ma(int n) : d(n * 4, -1e9) {};

	void upd(int v, int l, int r, int x, int y) {
		if (l + 1 == r) {
			d[v] =max(d[v], y);
			return;
		}
		int m = (l + r) / 2;
		if (x >= m) upd(v * 2 + 1, m, r, x, y);
		else upd(v * 2, l, m, x, y);
		d[v] = max(d[v * 2], d[v * 2 + 1]);
	}

	int ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return -1e9;
		int m = (l + r) / 2;
		return max(ans(v * 2, l, m, L, R), ans(v * 2 + 1, m, r, L, R));
	}
};

struct tair {
	int a, b, c;
};

bool cmp(tair a, tair b) {
	return a.b < b.b;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int q;
	cin >> q;
	while (q--) {
		int n, m;
		cin >> n >> m;
		vector<tair> a(m);
		for (int i = 0; i < m; i++) {
			cin >> a[i].a >> a[i].b >> a[i].c;
			a[i].a--;
			a[i].b--;
			a[i].c--;
		}
		sort(a.begin(), a.end(), cmp);
		vector<int> ans(m+1);
		ans[m] = n;
		DO_ma dma(n);
		for (int i = m - 1; i > -1; i--) {
			ans[i] = ans[i + 1];
			int L = 0, R = m;
			while (R - L > 1) {
				int M = (L + R) / 2;
				if (a[M].b <= a[i].c) L = M;
				else R = M;
			}
			if (ans[R] <= a[i].c + 1) {
				ans[i] = min(ans[i], a[i].a);
				dma.upd(1, 0, n, a[i].a, a[i].c);
			}
			int X = dma.ans(1, 0, n, a[i].b + 1, a[i].c + 1);
			if (X > a[i].c) {
				ans[i] = min(ans[i], a[i].a);
				dma.upd(1, 0, n, a[i].a, a[i].c);
			}
		}
		if (ans[0] == 0) cout << "YES\n";
		else cout << "NO\n";
	}
}