#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

ll foo(vector<ll>& su1, vector<ll>& su2, vector<ll>& su3, ll f, ll R, vector<ll>& x, ll d, ll t) {
	int n = int(x.size());
	int LL = -1, RR = n;
	while (RR - LL > 1) {
		int MM = (LL + RR) / 2;
		if (x[MM] <= R) LL = MM;
		else RR = MM;
	}
	ll SU = su1[LL + 1];
	SU += su2[RR] + R * R * (n - RR) - 2 * R * su3[RR];
	SU += f * (R / d) * t;
	return SU;
}

ll ans(vector<ll>& x, ll f, ll d, ll t) {
	
	int n = int(x.size());
	vector<ll> su1(n+1);
	for (int i = 0; i < n; i++) {
		su1[i+1] = su1[i] + min((x[i] % d) * (x[i] & d), (d - (x[i] % d)) * (d - (x[i] % d)));
	}
	vector<ll> su2(n + 1);
	for (int i = n - 1; i > -1; i--) {
		su2[i] = su2[i + 1] + x[i] * x[i];
	}
	vector<ll> su3(n + 1);
	for (int i = n - 1; i > -1; i--) {
		su3[i] = su3[i + 1] + x[i];
	}
	ll L = 0, R = ((1e9) / d) + 1;
	while (R - L > 2) {
		ll M1 = L + (R - L) / 3, M2 = R - (R - L) / 3;
		ll an1 = foo(su1, su2, su3, f, M1 * d, x, d, t);
		ll an2 = foo(su1, su2, su3, f, M2 * d, x, d, t);
		if (an1 > an2) {
			L = M1;
		}
		else {
			R = M2;
		}
	}
	ll AN = foo(su1, su2, su3, f, ((L+R)/2) * d, x, d, t);
	AN = min(AN, foo(su1, su2, su3, f, R * d, x, d, t));
	AN = min(AN, foo(su1, su2, su3, f, L * d, x, d, t));
	return AN;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	vector<ll> x(n);
	for (int i = 0; i < n; i++) cin >> x[i];
	ll x0, d;
	cin >> x0 >> d;
	for (int i = 0; i < n; i++) x[i] -= x0;
	vector<ll> x1, x2;
	for (int i = 0; i < n; i++) {
		if (x[i] >= 0) x1.push_back(x[i]);
		else x2.push_back(-x[i]);
	}
	int m;
	cin >> m;
	sort(x1.begin(), x1.end());
	sort(x2.begin(), x2.end());
	while (m--) {
		ll t;
		cin >> t;
		ll ANS = ans(x1, 1, d, t) + ans(x2, 2, d, t);
		ANS = min(ANS, ans(x1, 2, d, t) + ans(x2, 1, d, t));
		//cout << ans(x1, 1, d, t) << ' ' << ans(x2, 2, d, t) << ' ' << ans(x1, 2, d, t) << ' ' << ans(x2, 1, d, t) << "\n";
		cout << ANS << "\n";
	}
}