#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;

#pragma GCC optymize("Ofast");


int F;

__int128 foo(vector<__int128>& su1, vector<__int128>& su2, vector<__int128>& su3, ll f, ll R, vector<ll>& x, ll d, __int128 t, unordered_map<ll, ll> & an) {
	__int128 n = int(x.size());

	ll LL = -1, RR = n;
	if (an.find(R) != an.end()) {
		
		LL = an[R];
		RR = LL + 1;
	}
	else {
		while (RR - LL > 1) {
			int MM = (LL + RR) / 2;
			if (x[MM] <= R) LL = MM;
			else RR = MM;
		}
		an[R] = LL;
	}
	__int128 SU = su1[LL + 1];
	SU += su2[RR] + R * R * (n - RR) - 2 * R * su3[RR];
	SU += f * (R / d) * t;
	return SU;
}

ll ans(vector<ll>& x, ll f, ll d, __int128 t, vector<__int128>& su1, vector<__int128>& su2, vector<__int128>& su3, unordered_map<ll, __int128>& an) {

	ll L = 0, R = ((1e9) / d) + 1;
	while (R - L > 2) {
		ll M1 = (L + R) / 2, M2 = (L + R) / 2 + 1;
		__int128 an1 = foo(su1, su2, su3, f, M1 * d, x, d, t, an);
		__int128 an2 = foo(su1, su2, su3, f, M2 * d, x, d, t, an);
		if (an1 > an2) {
			L = M1;
		}
		else {
			R = M2;
		}
	}
	__int128 AN = foo(su1, su2, su3, f, ((L + R) / 2) * d, x, d, t, an);
	AN = min(AN, foo(su1, su2, su3, f, R * d, x, d, t, an));
	AN = min(AN, foo(su1, su2, su3, f, L * d, x, d, t, an));
	return AN;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	vector<ll> x(n);
	for (int i = 0; i < n; i++) cin >> x[i];
	ll x0, d;
	cin >> x0 >> d;
	for (int i = 0; i < n; i++) x[i] -= x0;
	vector<ll> x1, x2;
	for (int i = 0; i < n; i++) {
		if (x[i] >= 0) x1.push_back(x[i]);
		else x2.push_back(-x[i]);
	}
	int m;
	cin >> m;
	sort(x1.begin(), x1.end());
	sort(x2.begin(), x2.end());

	int n1 = int(x1.size());
	vector<__int128> su11(n1 + 1);
	for (int i = 0; i < n1; i++) {
		su11[i + 1] = su11[i] + min((x1[i] % d) * (x1[i] % d), (d - (x1[i] % d)) * (d - (x1[i] % d)));
	}
	vector<__int128> su12(n1 + 1);
	for (int i = n1 - 1; i > -1; i--) {
		su12[i] = su12[i + 1] + x1[i] * x1[i];
	}
	vector<__int128> su13(n1 + 1);
	for (int i = n1 - 1; i > -1; i--) {
		su13[i] = su13[i + 1] + x1[i];
	}

	int n2 = int(x2.size());
	vector<__int128> su21(n2 + 1);
	for (int i = 0; i < n2; i++) {
		su21[i + 1] = su21[i] + min((x2[i] % d) * (x2[i] % d), (d - (x2[i] % d)) * (d - (x2[i] % d)));
	}
	vector<__int128> su22(n2 + 1);
	for (int i = n2 - 1; i > -1; i--) {
		su22[i] = su22[i + 1] + x2[i] * x2[i];
	}
	vector<__int128> su23(n2 + 1);
	for (int i = n2 - 1; i > -1; i--) {
		su23[i] = su23[i + 1] + x2[i];
	}

	unordered_map<ll, __int128> an1;
	unordered_map<ll, __int128> an2;

	while (m--) {
		ll t;
		cin >> t;
		__int128 T = t;
		if (t == 0) {
			cout << (ll)su11.back() + (ll)su21.back() << "\n";
			continue;
		}
		ll ANS = ans(x1, 1, d, T, su11, su12, su13, an1) + ans(x2, 2, d, T, su21, su22, su23, an2);
		ANS = min(ANS, ans(x1, 2, d, T, su11, su12, su13, an1) + ans(x2, 1, d, T, su21, su22, su23, an2));
		//cout << ans(x1, 1, d, T, su11, su12, su13, an1) << ' ' << ans(x2, 2, d, T, su21, su22, su23, an2) << ' '
		//	<< ans(x1, 2, d, T, su11, su12, su13, an1) << ' ' << ans(x2, 1, d, T, su21, su22, su23, an2) << "\n";
		cout << ANS << "\n";
	}
}