#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

using ll = long long;

int foo(int v, vector<vector<int>>& gr, vector<int>& us, vector<int>& p, int T, vector<int>& gus) {
	us[v] = T;
	for (int u : gr[v]) {
		if (p[u] == -1) {
			p[u] = v;
			return 1;
		}
		if (us[p[u]] == T) continue;
		if (foo(p[u], gr, us, p, T, gus)) {
			p[u] = v;
			return 1;
		}
	}
	return 0;
}

vector<int> kun(vector<vector<int>>& gr, int n) {
	vector<int> p(n*2, -1);
	vector<int> gus(n * 2);
	vector<int> us(n * 2);
	int T = 1;
	/*for (int i = n; i < n * 2; i++) {
		for (int u : gr[i]) {
			if (us[u] != T) {
				gus[u] = 1;
				us[u] = T;
				p[i] = u;
			}
		}
	}*/
	for (int i = 0; i < n; i++) {
		T++;
		if(!gus[i]) foo(i, gr, us, p, T, gus);
	}
	return p;
}

void dfs(int v, vector<vector<int>>& gr, vector<int>& us) {
	us[v] = 1;
	for (int u : gr[v]) if (!us[u]) dfs(u, gr, us);
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, d;
	cin >> n >> d;
	vector<vector<int>> gr(n*2);
	vector<vector<int>> dist(n, vector<int>(n, 1e9));
	for (int i = 0; i < n; i++) dist[i][i] = 0;
	for (int i = 0; i < n - 1; i++) {
		int A, B;
		cin >> A >> B;
		A--;
		B--;
		dist[A][B] = dist[B][A] = 1;
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (dist[i][j] % 2 == 1 && dist[i][j] <= d) {
				gr[i].push_back(j + n);
				gr[j + n].push_back(i);
			}
		}
	}
	vector<int> us(n * 2);
	dfs(0, gr, us);
	for (int i = 0; i < n * 2; i++) if (!us[i]) gr[i] = {};
	vector<int> p = kun(gr, n);
	set<pair<int, int>> ps;
	for (int i = n; i < n * 2; i++) if (p[i] != -1) ps.insert({ min(i - n, p[i]), max(i - n, p[i]) });
	cout << int(ps.size()) << "\n";
	for (pair<int, int> p : ps) cout << p.first+1 << ' ' << p.second+1 << "\n";

}