#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>

using namespace std;

using ll = long long;

int foo(int v, vector<vector<int>>& gr, vector<int>& us, vector<int>& p, int T) {
	us[v] = T;
	for (int u : gr[v]) {
		if (p[u] == -1) {
			p[u] = v;
			return 1;
		}
		if (us[p[u]] == T) continue;
		if (foo(p[u], gr, us, p, T)) {
			p[u] = v;
			return 1;
		}
	}
	return 0;
}

vector<int> kun(vector<vector<int>>& gr, int n) {
	vector<int> p(n * 2, -1);
	vector<int> gus(n * 2);
	vector<int> us(n * 2);
	int T = 1;
	for (int i = n; i < n * 2; i++) {
		for (int u : gr[i]) {
			if (us[u] != T) {
				gus[u] = 1;
				us[u] = T;
				p[i] = u;
				break;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		T++;
		if (!gus[i]) {
			foo(i, gr, us, p, T);
		}
	}
	return p;
}

void dfs(int v, vector<vector<int>>& gr, vector<int>& us) {
	us[v] = 1;
	for (int u : gr[v]) if (!us[u]) dfs(u, gr, us);
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, d;
	cin >> n >> d;
	vector<vector<int>> gr(n * 2);
	vector<vector<int>> GR(n);
	for (int i = 0; i < n - 1; i++) {
		int A, B;
		cin >> A >> B;
		A--;
		B--;
		GR[A].push_back(B);
		GR[B].push_back(A);
	}
	vector<int> dist(n, 1e9);
	for (int i = 0; i < n; i++) {
		deque<int> D;
		dist[i] = 0;
		D.push_back(i);
		vector<int> b;
		b.push_back(i);
		while (int(D.size())) {
			int v = D.front();
			D.pop_front();
			if (dist[v] == d) continue;
			for (int u : GR[v]) {
				if (dist[u] == 1e9) {
					dist[u] = dist[v] + 1;
					D.push_back(u);
					b.push_back(u);
				}
			}
		}
		for (int c : b) {
			if (dist[c] % 2) {
				gr[i].push_back(c + n);
				gr[c + n].push_back(i);
			}
			dist[c] = 1e9;
		}
	}
	vector<int> us(n * 2);
	dfs(0, gr, us);
	for (int i = 0; i < n * 2; i++) if (!us[i]) gr[i] = {};
	vector<int> p = kun(gr, n);
	set<pair<int, int>> ps;
	for (int i = n; i < n * 2; i++) if (p[i] != -1) ps.insert({ min(i - n, p[i]), max(i - n, p[i]) });
	cout << int(ps.size()) << "\n";
	for (pair<int, int> p : ps) cout << p.first + 1 << ' ' << p.second + 1 << "\n";

}