#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>

using namespace std;

using ll = long long;

vector<vector<int>> dp1, dp2;
int n, d;
int ans = 0;

void dfs(int v, vector<vector<int>>& gr, int p = -1) {
	for (int u : gr[v]) {
		if (u == p) continue;
		dfs(u, gr, v);
		for (int i = 0; i < d; i++) {
			dp1[v][i + 1] += dp2[u][i];
			dp2[v][i + 1] += dp1[u][i];
		}
	}
	dp2[v][0] = 1;
	for (int i = 0; i < d; i++) {
		for (int j = d-i; j > -1; j--) {
			if (!dp1[v][i]) break;
			if (!dp2[v][j]) continue;
			if (dp2[v][j] <= dp1[v][i]) {
				ans += dp2[v][j];
				dp1[v][i] -= dp2[v][j];
				dp2[v][j] = 0;
			}
			else {
				ans += dp1[v][i];
				dp2[v][j] -= dp1[v][i];
				dp1[v][i] = 0;
			}
		}
	}
	for (int i = 0; i < d; i++) {
		for (int j = d-i; j > -1; j--) {
			if (!dp2[v][i]) break;
			if (!dp1[v][j]) continue;
			if (dp1[v][j] <= dp2[v][i]) {
				ans += dp1[v][j];
				dp2[v][i] -= dp1[v][j];
				dp1[v][j] = 0;
			}
			else {
				ans += dp2[v][i];
				dp1[v][j] -= dp2[v][i];
				dp2[v][i] = 0;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cin >> n >> d;
	vector<vector<int>> gr(n);
	for (int i = 0; i < n-1; i++) {
		int A, B;
		cin >> A >> B;
		A--;
		B--;
		gr[A].push_back(B);
		gr[B].push_back(A);
	}
	dp1.resize(n, vector<int>(d + 1));
	dp2.resize(n, vector<int>(d + 1));
	dfs(0, gr);
	cout << ans << "\n-1";
}