#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

struct dsu {
    vector<int> p, h, r;
    int cnt;
    vector<pair<int&, int>> mem;
    dsu(int n) {
        p.assign(n, 0);
        r.assign(n, 0);
        iota(all(p), 0);
        iota(all(r), 0);
        h.assign(n, 1);
        cnt = n;
    }
    int find(int v) {
        return v == p[v] ? v : p[v] = find(p[v]);
    }
    void join(int v, int u) {
        v = find(v), u = find(u);
        if (v == u) {
            mem.emplace_back(cnt, cnt);
            mem.emplace_back(cnt, cnt);
            mem.emplace_back(cnt, cnt);
            mem.emplace_back(cnt, cnt);
            return;
        }
        if (h[v] < h[u]) swap(v, u);
        mem.emplace_back(p[u], p[u]);
        mem.emplace_back(r[v], r[v]);
        mem.emplace_back(h[v], h[v]);
        mem.emplace_back(cnt, cnt);
        --cnt;
        p[u] = v;
        r[v] = max(r[v], r[u]);
        h[v] += (h[u] == h[v]);
    }
    void rev() {
        mem.back().first = mem.back().second;
        mem.pop_back();
        mem.back().first = mem.back().second;
        mem.pop_back();
        mem.back().first = mem.back().second;
        mem.pop_back();
        mem.back().first = mem.back().second;
        mem.pop_back();
    }
};
void solve() {
    int n, k;
    cin >> n >> k;
    const int MAXK = 10;
    vector<bitset<MAXK>> g(k);
    vector<tuple<int, int, int>> a(k);
    for (auto &[l, m, r] : a) {
        cin >> l >> m >> r;
        --l, --m, --r;
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) continue;
            auto [l1, m1, r1] = a[i];
            auto [l2, m2, r2] = a[j];
            if (!(l1 <= m2 && m2 <= r1)) {
                g[i].set(j);
            }
            if (!(l2 <= m1 && m1 <= r2)) {
                g[j].set(i);
            }
        }
    }
    dsu d(n);
    bool good = false;
    auto dfs = [&](auto &&self, int v, bitset<MAXK> mask) ->void {
        if (good) {
            return;
        }
        int cnt = 0;
        for (int i = get<0>(a[v]); i < get<2>(a[v]);) {
            d.join(i, i + 1);
            i = d.r[d.find(i)];
            ++cnt;
        }
        if (d.cnt == 1) {
            good = true;
            return;
        }
        auto cur = g[v] & mask;
        for (int u = cur._Find_first(); u < MAXK; u = cur._Find_next(u)) {
            self(self, u, cur);
        }
        for (int i = 0; i < cnt; ++i) {
            d.rev();
        }
    };
    bitset<MAXK> msk;
    msk.set();
    for (int start = 0; start < k && !good; ++start) {
        dfs(dfs, start, msk);
    }
    if (good) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    // for (auto &[l1, m1, r1] : a) {
    //     for (auto &[l2, m2, r2] : a) {
    //
    //     }
    // }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}