#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

struct dsu {
    vector<int> p, h, r;
    int cnt;
    vector<pair<int&, int>> mem;
    dsu(int n) {
        p.assign(n, 0);
        r.assign(n, 0);
        iota(all(p), 0);
        iota(all(r), 0);
        h.assign(n, 1);
        cnt = n;
    }
    int find(int v) {
        return v == p[v] ? v : p[v] = find(p[v]);
    }
    void join(int v, int u) {
        v = find(v), u = find(u);
        if (v == u) {
            // mem.emplace_back(cnt, cnt);
            // mem.emplace_back(cnt, cnt);
            // mem.emplace_back(cnt, cnt);
            // mem.emplace_back(cnt, cnt);
            return;
        }
        if (h[v] < h[u]) swap(v, u);
        // mem.emplace_back(p[u], p[u]);
        // mem.emplace_back(r[v], r[v]);
        // mem.emplace_back(h[v], h[v]);
        // mem.emplace_back(cnt, cnt);
        --cnt;
        p[u] = v;
        r[v] = max(r[v], r[u]);
        h[v] += (h[u] == h[v]);
    }
    void rev() {
        for (int i = 0; i < 4; ++i) {
            mem.back().first = mem.back().second;
            mem.pop_back();
        }
    }
};

struct seg {
    int l, m, r;
};
void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> a(k);
    vector<int> pref(n, n), suf(n, -1);
    for (auto &[l, m, r] : a) {
        cin >> l >> m >> r;
        --l, --m, --r;
        if (l == 0 && r == n - 1) {
            cout << "YES\n";
            return;
        }
        if (l == 0) {
            pref[r] = min(pref[r], m);
        } else {
            suf[l] = max(suf[l], m);
        }
    }
    const int LOG = 20;
    vector<vector<int>> mn(LOG, vector<int>(n)), mx(LOG, vector<int>(n));
    mn[0] = pref;
    mx[0] = suf;
    for (int j = 1; j < LOG; ++j) {
        // cout << j << '\n';
        for (int i = 0; i + (1 << j) <= n; ++i) {
            mn[j][i] = min(mn[j - 1][i], mn[j - 1][i + (1 << (j - 1))]);
            mx[j][i] = max(mx[j - 1][i], mx[j - 1][i + (1 << (j - 1))]);
        }
    }
    auto gmn = [&](int l, int r) {
        if (l >= r) return n;
        int lg = __lg(r - l);
        return min(mn[lg][l], mn[lg][r - (1 << lg)]);
    };
    auto gmx = [&](int l, int r) {
        if (l >= r) {
            return -1ll;
        }
        int lg = __lg(r - l);
        return max(mx[lg][l], mx[lg][r - (1 << lg)]);
    };
    bool good = false;
    for (int i = 0; i < n; ++i) {
        if (pref[i] != n) {
            int res = gmx(pref[i] + 1, i + 1);
            if (res != -1) {
                good = true;
            }
        }
        if (suf[i] != -1) {
            int res = gmn(i, suf[i]);
            if (res != n) {
                good = true;
            }
        }
    }
    if (good) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}