
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()


struct dsu {
    vector<int>p, r;
    dsu(int n) {
        p.assign(n, 0);
        iota(all(p), 0);
        r.assign(n, 0);
        iota(all(r), 0);
    }
    int find(int v) {
        return v == p[v] ? v : p[v] = find(p[v]);
    }
    void join(int v, int u) {
        v = find(v), u = find(u);
        r[v] = max(r[v], r[u]);
        p[u] = v;
    }
};
struct seg {
    int l, m, r;
};
struct node {
    int x, p;
    node() :x(0), p(0) {}
};
vector<node> t;
void push(int v, int l, int r) {
    if (r - l > 1) {
        int m = (r + l) / 2;
        t[2 * v + 1].x +=  (m - l) * t[v].p;
        t[2 * v + 1].p += t[v].p;
        t[2 * v + 2].x +=  (r - m) * t[v].p;
        t[2 * v + 2].p += t[v].p;
    }
    t[v].p = 0;
}
void upd(int ql, int qr, int x, int v, int l, int r) {
    if (ql == l && qr == r) {
        t[v].x += (r - l) * x;
        t[v].p += x;
        return;
    }
    push(v, l, r);
    int m = (r + l) / 2;
    if (qr <= m) {
        upd(ql, qr, x, 2 * v + 1, l, m);
    } else if (ql >= m) {
        upd(ql, qr, x, 2 * v + 2, m, r);
    } else {
        upd(ql, m, x, 2 * v + 1, l, m);
        upd(m, qr, x, 2 * v + 2, m, r);
    }
}
int get(int ql, int qr, int v, int l, int r) {
    if (ql == l && qr == r) {
        return t[v].x;
    }
    push(v, l, r);
    int m = (r + l) / 2;
    if (qr <= m) {
        return get(ql, qr, 2 * v + 1, l, m);
    } else if (ql >= m) {
        return get(ql, qr, 2 * v + 2, m, r);
    } else {
        return get(ql, m, 2 * v + 1, l, m) + get(m, qr, 2 * v + 2, m, r);
    }
}
void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> a(k);
    vector<int> used(n);
    dsu d(n);
    t.assign(4 * n, node());
    for (auto &[l, m, r]: a) {
        cin >> l >> m >> r;
        --l, --m, --r;
        upd(l, r + 1, 1, 0, 0, n);
        used[m] = 1;
        for (int j = l; j < r;) {
            d.join(j, j + 1);
            used[j] = 1;
            used[j + 1] = 1;
            j = d.r[d.find(j)];
        }
    }
    int sum = 0;
    for (auto i : used) sum += i;
    if (sum != n) {
        cout << "NO\n";
        return;
    }
    int i = 0;
    used.assign(n, 0);
    for (; i < k; ++i) {
        bool bad = true;
        for (int ind = 0; ind < k; ++ind) {
            if (!used[ind]) {
                if (get(a[ind].l, a[ind].r + 1, 0, 0, n) == a[ind].r - a[ind].l + 1){
                    bad = false;
                    upd(a[ind].l, a[ind].r + 1,-1,  0, 0, n);
                    used[ind] = 1;
                    break;
                }
            }
        }
        if (bad) {
            break;
        }
    }
    if (i == k) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
// #ifdef LOCAL
//     freopen("in.txt", "r", stdin);
//     freopen("out.txt", "w", stdout);
// #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}