#ifdef LOCAL
# define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()

struct dsu {
    vector<int> p, h, r;
    int cnt;
    vector<pair<int&, int>> mem;
    dsu(int n) {
        p.assign(n, 0);
        r.assign(n, 0);
        iota(all(p), 0);
        iota(all(r), 0);
        h.assign(n, 1);
        cnt = n;
    }
    int find(int v) {
        return v == p[v] ? v : p[v] = find(p[v]);
    }
    void join(int v, int u) {
        v = find(v), u = find(u);
        if (v == u) {
            mem.emplace_back(cnt, cnt);
            mem.emplace_back(cnt, cnt);
            mem.emplace_back(cnt, cnt);
            mem.emplace_back(cnt, cnt);
            return;
        }
        if (h[v] < h[u]) swap(v, u);
        mem.emplace_back(p[u], p[u]);
        mem.emplace_back(r[v], r[v]);
        mem.emplace_back(h[v], h[v]);
        mem.emplace_back(cnt, cnt);
        --cnt;
        p[u] = v;
        r[v] = max(r[v], r[u]);
        h[v] += (h[u] == h[v]);
    }
    void rev() {
        for (int i = 0; i < 4; ++i) {
            mem.back().first = mem.back().second;
            mem.pop_back();
        }
    }
};

struct seg {
    int l, m, r;
};
void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> a(k);
    for (auto &[l, m, r] : a) {
        cin >> l >> m >> r;
        --l, --m, --r;
    }
    vector<int> best(n, -1);
    for (auto &[l, m, r] : a) {
        best[l] = max(best[l], r);
    }
    vector<int> dp(n + 1), suf(n + 2);
    dp[n] = suf[n] = 1;
    for (int i = n - 1; i>= 0; --i) {
        if (best[i] != -1) {
            int res = suf[i + 1] - suf[best[i] + 2];
            if (res) {
                dp[i] = 1;
                suf[i] = suf[i + 1] + 1;
            } else {
                suf[i] = suf[i + 1];
            }
        } else {
            suf[i] = suf[i + 1];
        }
    }
    if (dp[0]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}