// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}


struct Otr {
    int l, r, m;
};

struct node {
    int val = 1e9;
    node() {}
    node(int x) : val(x) {}
};
vector<node> t;
void update(int v, int l, int r, int id, int x) {
    if (l+1 == r) {
        t[v] = min(t[v].val, x);
        return;
    }
    int mid = (l+r) / 2;
    if (mid<=id) update(v*2+2, mid, r, id, x);
    else update(v*2+1, l, mid, id, x);
    t[v] = min(t[v*2+1].val, t[v*2+2].val);
}
int get(int v, int l, int r, int L, int R) {
    if (r<=L || R<=l) return 1e9;
    if (L<=l && r<=R) return t[v].val;
    int mid = (l+r) / 2;
    return min(get(v*2+1, l, mid, L, R), get(v*2+2, mid, r, L, R));
}


void solve() {
    int n, k;
    cin >> n >> k;
    vector<Otr> otrs(k);
    vector<int> cords{0, n-1};
    for (int i=0; i<k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; r--; m--;
        otrs[i] = {l, r, m};
        cords.push_back(l); cords.push_back(r); cords.push_back(m);
    }

    t.assign(n*4, node());
    sort(otrs.begin(), otrs.end(), [](Otr a, Otr b) {
        return a.l < b.l;
    });

    vector<int> dp(sz(cords), 1e9);
    for (int i=0; i<k; i++) {
        if (otrs[i].l == 0) update(0, 0, n, otrs[i].r, otrs[i].m);
        else {
            if (get(0, 0, n, otrs[i].l-1, otrs[i].m) != 1e9) {
                update(0, 0, n, otrs[i].r, otrs[i].m);
            }
            if (get(0, 0, n, otrs[i].l-1, otrs[i].r) < otrs[i].l) {
                update(0, 0, n, otrs[i].r, otrs[i].m);
            }
        }
    }

    if (get(0, 0, n, n-1, n) != 1e9) cout << "YES\n";
    else cout << "NO\n";
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int tt;
    cin >> tt;
    while (tt--) solve();


    // mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
    // auto gen = [&](int l, int r) {
    //     return rnd()%(r-l+1) + l;
    // };
    //
    // int n = 1e4, k = 1e4;
    // cout << 1 << '\n' << n << ' ' << k << '\n';
    // for (int i=0; i<k; i++) {
    //     int l=gen(1, n), r=gen(1, n);
    //     if (l>r) swap(l, r);
    //     cout << l << ' ' << gen(l, r) << ' ' << r << '\n';
    // }


    return 0;
}