#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
struct DSU {
    vector<int> p;
    vector<vector<int>> c;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        c.resize(n);
        for (int i = 0; i < n; i++) c[i] = {i};
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (c[a].size() > c[b].size()) swap(a, b);
        p[a] = b;
        for (auto el : c[a]) c[b].push_back(el);
        return true;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> srt = {0, 1, n};
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
    }

    sort(all(a), [&](const array<int, 3>& x, const array<int, 3>& y) {return tie(x[0], x[2]) < tie(y[0], y[2]);});

    vector<int> dp(k);
    bool ok = false;
    for (int i = 0; i < k; i++) {
        auto [l, m, r] = a[i];
        if (l == 1) {
            dp[i] = 1;
        } else {
            for (int j = 0; j < i; j++) {
                if (a[j][2] < a[i][0] - 1) continue;
                if (a[i][0] <= a[j][1] && a[j][1] <= a[i][2]) {
                    if (a[j][0] <= a[i][1] && a[i][1] <= a[j][2]) {
                        continue;
                    }
                }

                dp[i] = 1;
            }
        }

        if (dp[i] == 1 && r == n) ok = true;
    }

    cout << (ok ? "YES\n" : "NO\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}