#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9;

struct SegmentTree {
    int n;
    vector<int> tree;
    vector<int> lz;

    SegmentTree(int _n) : n(_n) {
        int SIZE = 1 << (__lg(n) + bool(__builtin_popcount(n) - 1));
        tree.assign(2 * SIZE, INF);
    }

    void update(int i, int val, int x, int l, int r) {
        if (l + 1 == r) {
            tree[x] = min(tree[x], val);
            return;
        }

        int m = (l + r) / 2;
        if (i < m) {
            update(i, val, 2 * x + 1, l, m);
        } else {
            update(i, val, 2 * x + 2, m, r);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }

    void update(int i, int val) {
        update(i, val, 0, 0, n);
    }

    int get(int lq, int rq, int x, int l, int r) {
        if (lq <= l && r <= rq) return tree[x];
        if (rq <= l || r <= lq) return INF;

        int m = (l + r) / 2;
        return min(get(lq, rq, 2 * x + 1, l, m), get(lq, rq, 2 * x + 2, m, r));
    }

    int get(int lq, int rq) {
        return get(lq, rq, 0, 0, n);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
    }

    sort(all(a), [&](const array<int, 3>& x, const array<int, 3>& y) {return tie(x[0], x[2]) < tie(y[0], y[2]);});

    SegmentTree l_need(n), m_need(n);

    vector<int> dp(k);
    bool ok = false;
    for (int i = 0; i < k; i++) {
        auto [l, m, r] = a[i];
        if (l == 1) {
            dp[i] = 1;
        } else {
            if (l > l_need.get(l - 1, r) || m > m_need.get(l - 1, r)) {
                dp[i] = 1;
            }
        }

        if (dp[i] && r == n) ok = true;

        if (dp[i]) {
            l_need.update(r, m);
            m_need.update(r, r);
        }
    }

    cout << (ok ? "YES\n" : "NO\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}