#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
struct DSU {
    vector<int> p;
    vector<vector<int>> c;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        c.resize(n);
        for (int i = 0; i < n; i++) c[i] = {i};
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (c[a].size() > c[b].size()) swap(a, b);
        p[a] = b;
        for (auto el : c[a]) c[b].push_back(el);
        return true;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> srt = {0, 1, n};
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
        srt.push_back(l - 1);
        srt.push_back(l);
        srt.push_back(r);
    }

    sort(all(srt));
    srt.resize(unique(all(srt)) - srt.begin());
    int CNT = srt.size();

    DSU dsu(k);
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (a[i][0] <= a[j][1] && a[j][1] <= a[i][2]) {
                if (a[j][0] <= a[i][1] && a[i][1] <= a[j][2]) {
                    dsu.unite(i, j);
                }
            }
        }
    }

    for (auto& [l, m, r] : a) {
        l = lower_bound(all(srt), l) - srt.begin();
        m = -1;
        r = lower_bound(all(srt), r) - srt.begin();
    }

    vector<array<int, 2>> dp(CNT, {0, 0});
    dp[0] = {1, 2};

    sort(all(a));
    for (int step = 0; step < CNT; step++) {
        for (int i = 0; i < k; i++) {
            auto [l, _, r] = a[i];
            int cid = dsu.get(i);

            if (dp[r][0] && dp[r][1]) continue;
            if (dp[r][0] == cid + 1 || dp[r][1] == cid + 1) continue;

            bool ok = false;
            for (int j = l - 1; j <= r; j++) {
                if (dp[j][0] && dp[j][0] != cid + 1) {
                    ok = true;
                    break;
                }
                if (dp[j][1] && dp[j][1] != cid + 1) {
                    ok = true;
                    break;
                }
            }

            if (ok) {
                if (dp[r][0] == 0) {
                    dp[r][0] = cid + 1;
                } else if (dp[r][1] == 0) {
                    dp[r][1] = cid + 1;
                }
            }
        }
    }

    cout << (dp.back()[0] || dp.back()[1] ? "YES\n" : "NO\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}
