#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
struct DSU {
    vector<int> p;
    vector<vector<int>> c;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        c.resize(n);
        for (int i = 0; i < n; i++) c[i] = {i};
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (c[a].size() > c[b].size()) swap(a, b);
        p[a] = b;
        for (auto el : c[a]) c[b].push_back(el);
        return true;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> srt = {0, 1, n};
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
        srt.push_back(l - 1);
        srt.push_back(l);
        srt.push_back(r);
    }

    sort(all(srt));
    srt.resize(unique(all(srt)) - srt.begin());
    int CNT = srt.size();

    DSU dsu(k);
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            if (a[i][0] <= a[j][1] && a[j][1] <= a[i][2]) {
                if (a[j][0] <= a[i][1] && a[i][1] <= a[j][2]) {
                    dsu.unite(i, j);
                }
            }
        }
    }

    for (auto& [l, m, r] : a) {
        l = lower_bound(all(srt), l) - srt.begin();
        m = -1;
        r = lower_bound(all(srt), r) - srt.begin();
    }

    vector<array<int, 3>> seg;
    for (int i = 0; i < k; i++) {
        if (dsu.get(i) != i) continue;

        sort(all(dsu.c[i]), [&](int x, int y) {return a[x] < a[y];});
        vector<int> st;
        for (auto el : dsu.c[i]) {
            if (!st.empty()) {
                if (a[st.back()][0] == a[el][0] && a[st.back()][2] <= a[el][2]) {
                    st.pop_back();
                }
            }

            bool ok = true;
            if (!st.empty() && a[st.back()][2] > a[el][2]) ok = false;
            if (ok) st.push_back(el);
        }
        dsu.c[i] = st;

        int lq = 1e9, rq = -1e9;
        for (auto id : dsu.c[i]) lq = min(lq, a[id][0]), rq = max(rq, a[id][2]);
        seg.push_back({lq, rq, i});
    }

    sort(all(seg));

    vector<int> dp(CNT, 0);
    dp[0] = 1;
    for (auto [_l, _r, cid] : seg) {
        vector<int> ok;
        for (auto id : dsu.c[cid]) {
            int l = a[id][0];
            int r = a[id][2];

            bool f = false;
            for (int i = l - 1; i <= r; i++) {
                if (dp[i]) {
                    f = true;
                    break;
                }
            }
            if (f) ok.push_back(r);
        }
        for (auto el : ok) dp[el] = 1;
    }

    cout << (dp.back() ? "YES\n" : "NO\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}