#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct Line {
    i128 k = 0, b = 4e18;
    i128 get(const i128& x) const {
        return k * x + b;
    }
};
struct node {
    int left = 0, right = 0;
    Line l;
};

vector<ld> points = {-1e18};
vector<Line> lines;

ld intersect(const Line& a, const Line& b) {
    return (ld)(b.b - a.b) / (a.k - b.k);
}

void add(const Line& cur) {
    while (lines.size() >= 2) {
        int k = lines.size();
        if (intersect(cur, lines[k - 2]) <= points.back()) {
            lines.pop_back();
            points.pop_back();
        } else {
            break;
        }
    }
    if (!lines.empty()) points.push_back(intersect(lines.back(), cur));
    lines.push_back(cur);
}

ll get(ll x) {
    int id = upper_bound(all(points), x) - points.begin() - 1;
    return lines[id].get(x);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    sort(all(x));

    ll start, d;
    cin >> start >> d;
    assert(start == 0);

    i128 sq_s = 0;
    i128 s = 0;
    for (int i = 0; i < n; i++) sq_s += x[i] * x[i], s += x[i];

    i128 now = 0;
    int cur = 0;

    vector<Line> aboba;
    for (ll pos = 0; pos < 1'000'111 + d; pos += d) {
        while (cur < n) {
            if (abs(x[cur] - (pos - d)) < abs(x[cur] - pos)) {
                sq_s -= x[cur] * x[cur];
                s -= x[cur];
                now += (x[cur] - (pos - d)) * (x[cur] - (pos - d));
                cur++;
            } else {
                break;
            }
        }

        i128 cost = now + sq_s - 2 * s * pos + (i128)(n - cur) * pos * pos;
        if (cost < LLONG_MAX) aboba.push_back({pos / d, cost});
    }

    sort(rall(aboba), [&](const Line& x, const Line& y) {return x.k < y.k;});
    for (auto l : aboba) add(l);

    // why...
    // for (ll pos = 0; pos < 1000; pos += d) {
    // ll ans = 0;
    // for (int i = 0; i < n; i++) {
    //     ll cur = 4e18;
    //     ll var = x[i] + (x[i] % d - start % d);
    //     for (int k = -2; k <= 2; k++) {
    //         ll curpos = var + k * d;
    //         curpos = max(curpos, 0LL);
    //         curpos = min(curpos, pos);
    //         cur = min(cur, (curpos - x[i]) * (curpos - x[i]));
    //     }
    //     ans += cur;
    // }
    //
    // update({pos / d, ans}, 0, 0, MAXA);
    // }

    int m;
    cin >> m;
    for (int query = 0; query < m; query++) {
        int t;
        cin >> t;
        cout << get(t) << '\n';
    }

    return 0;
}
