#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct Line {
    i128 k = 0, b = 4e18;
    i128 get(const i128& x) const {
        return k * x + b;
    }
};

const int MAXA = 1'000'111;
Line LC[1 << 21];

void update(Line cur, int x, int l, int r) {
    int m = (l + r) / 2;
    if (LC[x].get(m) > cur.get(m)) swap(cur, LC[x]);

    if (l != m && LC[x].get(l) > cur.get(l)) update(cur, 2 * x + 1, l, m);
    if (m != r && LC[x].get(r - 1) > cur.get(r - 1)) update(cur, 2 * x + 2, m, r);
}

i128 get(ll val, int x, int l, int r) {
    i128 res = LC[x].get(val);
    if (l + 1 == r) return res;
    int m = (l + r) / 2;
    if (val < m) res = min(res, get(val, 2 * x + 1, l, m));
    if (val > m) res = min(res, get(val, 2 * x + 2, m, r));
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    sort(all(x));

    ll start, d;
    cin >> start >> d;
    assert(start == 0);

    i128 sq_s = 0;
    i128 s = 0;
    for (int i = 0; i < n; i++) sq_s += x[i] * x[i], s += x[i];

    i128 now = 0;
    int cur = 0;
    for (int pos = 0; pos < MAXA + d; pos += d) {
        while (cur < n) {
            if (abs(x[cur] - (pos - d)) < abs(x[cur] - pos)) {
                sq_s -= x[cur] * x[cur];
                s -= x[cur];
                now += (x[cur] - (pos - d)) * (x[cur] - (pos - d));
                cur++;
            } else {
                break;
            }
        }

        i128 cost = now + sq_s - 2 * s * pos + (i128)(n - cur) * (n - cur) * pos * pos;
        update({pos / d, cost}, 0, 0, MAXA);
    }

    int m;
    cin >> m;
    for (int query = 0; query < m; query++) {
        ll t;
        cin >> t;
        cout << (ll)(get(t, 0, 0, MAXA)) << '\n';
    }

    return 0;
}
