#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9 + 10;

struct SegTree {
    vector<int> t;

    SegTree(int n) {
        t.resize(n * 4, inf);
    }

    void upd(int l, int r, int i, int idx, int x) {
        if (l + 1 == r) {
            t[i] = min(t[i], x);
            return;
        }
        int m = (l + r) / 2;
        if (idx < m) {
            upd(l, m, i * 2 + 1, idx, x);
        } else {
            upd(m, r, i * 2 + 2, idx, x);
        }
        t[i] = min(t[i * 2 + 1], t[i * 2 + 2]);
    }

    int gmin(int l, int r, int i, int ql, int qr) {
        if (l >= qr || ql >= r) return inf;
        if (ql <= l && r <= qr) {
            return t[i];
        }
        int m = (l + r) / 2;
        int r1 = gmin(l, m, i * 2 + 1, ql, qr);
        int r2 = gmin(m, r, i * 2 + 2, ql, qr);
        return min(r1, r2);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> line;
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        line.push_back({l, m, r});
    }
    sort(line.begin(), line.end());
    SegTree dp(n + 1);
    dp.upd(0, n + 1, 0, 0, 0);
    for (auto [l, m, r] : line) {
        int cm = dp.gmin(0, n + 1, 0, l - 1, m);
        if (cm != inf) {
            dp.upd(0, n + 1, 0, r, m);
        }
        cm = dp.gmin(0, n + 1, 0, m, r);
        if (cm < l) {
            dp.upd(0, n + 1, 0, r, m);
        }
    }
    if (dp.gmin(0, n + 1, 0, n, n + 1) == inf) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
