#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9 + 10;

vector<vector<int>> g;
vector<int> col;
vector<int> lg, rg;

void dfs(int u, int p) {
    if (col[u] == 0) {
        lg.push_back(u);
    } else {
        rg.push_back(u);
    }
    for (auto v : g[u]) {
        if (v == p) continue;
        col[v] = col[u] ^ 1;
        dfs(v, u);
    }
}

vector<int> used;
vector<int> mt;

int d;

bool kuhn(int u, int tm) {
    if (used[u] == tm) return false;
    used[u] = tm;
    deque<array<int, 3>> st;
    st.push_back({u, u, 0});
    while (!st.empty()) {
        auto [vn, p, len] = st.front();
        st.pop_front();
        if (len % 2) {
            if (mt[vn] == -1) {
                mt[vn] = u;
                return true;
            }
            if (kuhn(mt[vn], tm)) {
                mt[vn] = u;
                return true;
            }
        }
        if (len == d) continue;
        for (auto v : g[vn]) {
            if (v != p) {
                st.push_back({v, vn, len + 1});
            }
        }
    }
    return false;
}

void solve() {
    int n;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    col.resize(n);
    dfs(0, 0);
    mt19937 rnd(82);
    shuffle(lg.begin(), lg.end(), rnd);
    for (int i = 0; i < n; i++) {
        shuffle(g[i].begin(), g[i].end(), rnd);
    }
    used.resize(n, -1);
    mt.resize(n, -1);
    for (auto e : lg) {
        kuhn(e, e);
    }
    vector<array<int, 2>> ans;
    for (int i = 0; i < n; i++) {
        if (mt[i] != -1) {
            ans.push_back({i + 1, mt[i] + 1});
        }
    }
    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u << ' ' << v << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) solve();
}
