#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll h, w; cin >> h >> w;
    vector<vector<ll>> a(h, vector<ll>(w));
    for (int i = 0; i < h; i++) {
        string s; cin >> s;
        for (int j = 0; j < w; j++) {
            a[i][j] = (s[j] - '0');
        }
    }
    vector<vector<ll>> col(h, vector<ll>(w));
    for (int i = h - 1; i >= 0; i--) {
        for (int j = w - 1; j >= 0; j--) {
            if (j != w - 1) {
                col[i][j] = col[i][j + 1];
            }
            if (a[i][j] == 0) {
                col[i][j] = 0;
            } else {
                col[i][j]++;
            }
        }
    }
    vector<vector<pair<ll, ll>>> res(w);
    vector<ll> sum(w);
    ll ans = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (a[i][j] == 0) {
                sum[j] = 0;
                res[j].clear();
                continue;
            }
            ll now = col[i][j], c1 = 1;
            while (res[j].size() != 0) {
                if (res[j].back().first > now) {
                    c1 += res[j].back().second;
                    sum[j] -= (res[j].back().first - now) * res[j].back().second;
                    res[j].pop_back();
                } else {
                    break;
                }
            }
            res[j].push_back({now, c1});
            sum[j] += now;
            ans = max(ans, sum[j]);
        }
    }
    cout << ans;
    return 0;
}
