#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll cmp(vector<ll> v1, vector<ll> v2) {
    return v1 < v2;
}

void solve() {
    ll n, k; cin >> n >> k;
    vector<vector<ll>> v(k, vector<ll>(3));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < 3; j++) {
            cin >> v[i][j];
        }
    }
    sort(v.begin(), v.end(), cmp);
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1));
    for (int i = 0; i < k; i++) {
        ll l = v[i][0], m = v[i][1], r = v[i][2];
        for (int r_l = 0; r_l <= n; r_l++) {
            for (int m_l = 0; m_l <= n; m_l++) {
                if (dp[r_l][m_l] && r >= r_l && m > m_l && l <= r_l + 1 && (m > r_l || m_l < l)) dp[r][m] = 1;
            }
        }
        if (l == 1) dp[r][m] = 1;
    }
    ll ok = 0;
    for (int j1 = 0; j1 <= n; j1++) {
        for (int j2 = 0; j2 <= n; j2++) {
            if (dp[j1][j2] && j1 == n) ok = 1;
        }
    }
    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}