#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll cmp(vector<ll> v1, vector<ll> v2) {
    return v1 < v2;
}

vector<ll> tree;

void update(ll i, ll l, ll r, ll q, ll x) {
    if (q < l || q >= r) return;
    if (l == r - 1) {
        tree[i] = x;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * i + 1, l, m, q, x);
    update(2 * i + 2, m, r, q, x);
    tree[i] = min(tree[2 * i + 1], tree[2 * i + 2]);
}

ll get_min(ll i, ll l, ll r, ll ql, ll qr) {
    if (qr <= l || r <= ql) return inf;
    if (ql <= l && r <= qr) return tree[i];
    ll m = (l + r) / 2;
    return min(get_min(2 * i + 1, l, m, ql, qr), get_min(2 * i + 2, m, r, ql, qr));
}

void solve() {
    ll n, k; cin >> n >> k;
    tree.assign(4 * n, inf);
    vector<vector<ll>> v(k, vector<ll>(3));
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < 3; j++) {
            cin >> v[i][j];
        }
    }
    sort(v.begin(), v.end(), cmp);
    vector<ll> dp(n + 1, inf);
    set<ll> s;
    for (ll i = 0; i < k; i++) {
        ll l = v[i][0], m = v[i][1], r = v[i][2];
        ll ans = inf;
        // for (ll r_l = l - 1; r_l <= r; r_l++) {
        //     ll m_l = dp[r_l];
        //     if (m_l == inf) continue;
        //     if (m > r_l) ans = min(ans, m);
        // }
        auto it = s.lower_bound(l - 1);
        if (it != s.end() && (*it) <= r) ans = min(ans, m);
        ll mn = get_min(0, 0, n, l - 1, r + 1);
        if (mn < l) ans = min(ans, m);
        dp[r] = min(dp[r], ans);
        if (l == 1) dp[r] = min(dp[r], m);
        update(0, 0, n, r, dp[r]);
        if (dp[r] != inf) s.insert(r);
    }
    ll ok = (dp[n] != inf);
    if (ok) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}