#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef __int128 ll1;

const ll1 inf = 1e18;

ll n, x0, d;
ll t = 0;
map<pair<ll, ll>, ll1> mapa;
vector<ll> x1;

ll1 f(ll1 j1, ll1 j2) {
    ll1 l = x0 + j1 * d, r = x0 + j2 * d;
    ll1 ind = l;
    ll1 ans = min((-j1), j2) * t + (j2 - j1) * t;
    for (ll1 j = 0; j < n; j++) {
        ll1 res1 = (((x1[j] - x0) / d) * d) + x0 - d;
        if (res1 <= r) {
            ind = max(res1, l);
        } else {
            ind = r;
        }
        while (1) {
            ll1 next = min(r, ind + d);
            ll1 r1 = abs(ind - x1[j]);
            ll1 r2 = abs(next - x1[j]);
            if (r2 < r1) {
                ind = next;
            } else {
                break;
            }
        }
        ans += ll1(ind - x1[j]) * ll1(ind - x1[j]);
    }
    return ans;
}

ll1 f(ll1 x) {
    ll1 l = 0, r = ll(1e9);
    while (r - l > 2) {
        ll1 m1 = l + ll1(r - l) / 3;
        ll1 m2 = r - ll1(r - l) / 3;
        ll1 ans1 = f(x, m1), ans2 = f(x, m2);
        if (ans1 < ans2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    ll1 res = inf;
    for (ll1 j = l; j <= r; j++) res = min(res, f(x, j));
    return res;
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    x1.assign(n, 0);
    for (int i = 0; i < n; i++) cin >> x1[i];
    sort(x1.begin(), x1.end());
    cin >> x0 >> d;
    ll m; cin >> m;
    vector<ll> a(m);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < m; i++) {
        t = a[i];
        ll1 res = inf;
        ll1 l = -ll(1e9), r = 0;
        while (r - l > 2) {
            ll1 m1 = l + (r - l) / 3;
            ll1 m2 = r - (r - l) / 3;
            ll1 ans1 = f(m1), ans2 = f(m2);
            if (ans1 < ans2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        for (ll1 m1 = l; m1 <= r; m1++) {
            ll1 ans1 = f(m1);
            res = min(res, ans1);
        }
        cout << ll(res) << "\n";
    }
    return 0;
}
