#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef __int128 ll1;

const ll1 inf = 1e18;

ll n, x0, d;
ll t = 0;
vector<ll> x1;

ll1 abs1(ll1 x) {
    if (x < 0) return -x;
    return x;
}

pair<ll1, ll1> f(ll1 j1, ll1 j2) {
    ll1 l = x0 + j1 * d, r = x0 + j2 * d;
    ll1 ind = l, need = 0;
    ll1 ans = 0;
    need = min((-j1), j2) + (j2 - j1);
    for (ll1 j = 0; j < n; j++) {
        ll1 res1 = (((x1[j] - x0) / d) * d) + x0 - d;
        if (res1 <= r) {
            ind = max(res1, l);
        } else {
            ind = r;
        }
        while (1) {
            ll1 next = min(r, ind + d);
            ll1 r1 = abs1(ind - x1[j]);
            ll1 r2 = abs1(next - x1[j]);
            if (r2 < r1) {
                ind = next;
            } else {
                break;
            }
        }
        ans += ll1(ind - x1[j]) * ll1(ind - x1[j]);
    }
    return {need, ans};
}

vector<ll1> f(ll1 x) {
    ll1 l = 0, r = ll(1e6);
    vector<ll1> res = {inf, inf, inf};
    while (r - l > 1) {
        ll m = (l + r) / 2;
        pair<ll1, ll1> ans1 = f(x, m), ans2 = f(x, m + 1);
        ll res1 = ll1(ans1.first) * t + ans1.second;
        ll res2 = ll1(ans2.first) * t + ans2.second;
        if (res1 < res2) {
            r = m;
        } else {
            l = m;
        }
    }
    for (ll1 j = l; j <= r; j++) {
        pair<ll1, ll1> p = f(x, j);
        vector<ll1> now = {ll1(p.first * t + p.second), p.first, p.second};
        res = min(res, now);
    }
    return res;
}

vector<ll1> ans(ll now) {
    t = now;
    ll1 l = -ll(1e6), r = 0;
    while (r - l > 1) {
        ll1 m = (l + r) / 2;
        ll1 ans1 = f(m)[0], ans2 = f(m + 1)[0];
        if (ans1 < ans2) {
            r = m;
        } else {
            l = m;
        }
    }
    vector<ll1> v = {inf, inf, inf};
    for (ll1 m1 = l; m1 <= r; m1++) {
        vector<ll1> v1 = f(m1);
        v = min(v, v1);
    }
    return v;
}

vector<pair<ll, ll>> ind;
vector<ll> res;
vector<ll> a;

void solve(ll l, ll r) {
    if (l > r) return;
    vector<ll1> v1 = ans(ind[l].first), v2 = ans(ind[r].first);
    res[ind[l].second] = v1[0];
    res[ind[r].second] = v2[0];
    if (abs(l - r) <= 1) return;
    pair<ll, ll> p1 = {v1[1], v1[2]}, p2 = {v2[1], v2[2]};
    if (p1 == p2) {
        for (int j = l; j <= r; j++) {
            res[ind[j].second] = p1.first * a[ind[j].second] + p1.second;
        }
        return;
    }
    ll m = (l + r) / 2;
    solve(l, m);
    solve(m + 1, r);
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    x1.assign(n, 0);
    for (int i = 0; i < n; i++) cin >> x1[i];
    sort(x1.begin(), x1.end());
    cin >> x0 >> d;
    ll m; cin >> m;
    res.assign(m, 0);
    a.assign(m, 0);
    for (int i = 0; i < m; i++) cin >> a[i];
    for (int i = 0; i < m; i++) ind.push_back({a[i], i});
    sort(ind.begin(), ind.end());
    solve(0, m - 1);
    for (ll el : res) cout << el << "\n";
    return 0;
}
