#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll n, d;
vector<vector<ll> > g;
vector<ll> was;
vector<pair<ll, ll> > res;
vector<ll> ok;

void dfs(ll v) {
    was[v] = 1;
    vector<ll> now;
    for (ll to: g[v]) {
        if (was[to] == 0) {
            dfs(to);
            if (ok[to] == 0) {
                now.push_back(to);
            }
        }
    }
    if (now.size() != 0) {
        res.push_back({v, now.back()});;
        ok[v] = 1;
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> d;
    g.assign(n, {});
    was.assign(n, 0);
    res.clear();
    ok.assign(n, 0);
    for (int i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0);
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); i++) cout << res[i].first + 1 << " " << res[i].second + 1 << "\n";
    return 0;
}
