#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

mt19937 rnd(14);

typedef long long ll;

const ll inf = 1e18;

ll n, d;
vector<vector<ll> > g;
vector<ll> was;
vector<pair<ll, ll>> res;
vector<ll> ok;
vector<map<ll, vector<ll>>> res1;
vector<ll> h;

void dfs(ll v) {
    was[v] = 1;
    for (ll to: g[v]) {
        if (was[to] == 0) {
            h[to] = h[v] + 1;
            dfs(to);
            if (res1[to].size() > res1[v].size()) {
                swap(res1[v], res1[to]);
            }
            for (pair<ll, vector<ll>> el: res1[to]) {
                for (ll el1 : el.second) res1[v][el.first].push_back(el1);
            }
            res1[to].clear();
        }
    }
    ll ind1 = -1;
    for (pair<ll, vector<ll>> el : res1[v]) {
        if (el.second.size() == 0) continue;
        ll now1 = el.first;
        if (abs(h[v] - now1) > d) continue;
        if (abs(now1 - h[v]) % 2 == 0) continue;
        ind1 = max(ind1, el.first);
    }
    ll i1 = ll(res1[v][h[v] + 1].size()) - 1, i2 = ll(res1[v][h[v] + 2].size()) - 1;
    while (1) {
        if (res1[v][h[v] + 1].size() == 0 || res1[v][h[v] + 2].size() == 0) break;
        ll k1 = res1[v][h[v] + 1].back();
        res1[v][h[v] + 1].pop_back();
        ll k2 = res1[v][h[v] + 2].back();
        res1[v][h[v] + 2].pop_back();
        res.push_back({k1, k2});
    }
    if (ind1 != -1) {
        ll k1 = v, k2 = res1[v][ind1].back();
        res1[v][ind1].pop_back();
        res.push_back({k1, k2});
    } else {
        res1[v][h[v]].push_back(v);
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> d;
    g.assign(n, {});
    was.assign(n, 0);
    h.assign(n, 0);
    res.clear();
    res1.assign(n, {});
    ok.assign(n, 0);
    for (int i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    // for (int i = 0; i < 100000; i++) {
    //     was.assign(n, 0);
    //     h.assign(n, 0);
    //     res.clear();
    //     res1.assign(n, {});
    //     ok.assign(n, 0);
    //     dfs(rnd() % n);
    //
    // }
    dfs(0);
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); i++) cout << res[i].first + 1 << " " << res[i].second + 1 << "\n";
    return 0;
}
