#include <iostream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <iostream>
#include <vector>
#include <iostream>
#include <array>

using namespace std;

typedef long long ll;

const int N = 3e6 + 5;

ll get(int x1, int x2) {
    ll dx = abs(x1 - x2);
    return dx * dx;
}

__int128 add(int l, int r, ll pos, vector<__int128> &p_sum, vector<__int128> &p_sqr) {
    int len = r - l;
    return p_sqr[r] - p_sqr[l] - 2 * (p_sum[r] - p_sum[l]) * pos + __int128(len) * pos * pos;
}

array<__int128, N> dp;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> x(n);
    for (int &i : x) {
        cin >> i;
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    x0 += d;
    for (auto &i : x) {
        i += d;
        //cout << i << ' ';
    }
    //cout << endl;
    vector<__int128> p_sum(n + 1), p_sqr(n + 1);
    for (int i = 0; i < n; ++i) {
        p_sum[i + 1] = p_sum[i] + x[i];
        p_sqr[i + 1] = p_sqr[i] + ll(x[i]) * x[i];
    }

    dp[x0] = 0;
    for (int k = 1; x0 + k * d <= x.back() + d; ++k) {
        int t1 = x0 + (k - 1) * d, t2 = x0 + k * d;
        int L = lower_bound(x.begin(), x.end(), t1) - x.begin() - 1;
        int R = upper_bound(x.begin(), x.end(), t2) - x.begin();
        //cout << L << ' ' << R << ' ';
        if (R - L >= 2) {
            int l = L, r = R;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (get(x[m], t1) < get(x[m], t2)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            dp[t2] = dp[t1] + add(L + 1, r, t1, p_sum, p_sqr) + add(r, R, t2, p_sum, p_sqr);
        } else {
            dp[t2] = dp[t1];
        }
        //cout << t2 << ' ' << ll(dp[t2]) << '\n';
    }
    for (int k = 1; x0 - k * d >= 0; ++k) {
        int t1 = x0 - (k - 1) * d, t2 = x0 - k * d;
        int L = lower_bound(x.begin(), x.end(), t2) - x.begin() - 1;
        int R = upper_bound(x.begin(), x.end(), t1) - x.begin();
        if (R - L >= 2) {
            int l = L, r = R;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (get(x[m], t2) < get(x[m], t1)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            dp[t2] = dp[t1] + add(L + 1, r, t2, p_sum, p_sqr) + add(r, R, t1, p_sum, p_sqr);
        } else {
            dp[t2] = dp[t1];
        }
        //cout << L << ' ' << R << ' ' << t2 << ' ' << ll(dp[t2]) << '\n';
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        ll t;
        cin >> t;
        __int128 left = -1, right = -1, add_left = 0, add_right = 0;
        for (int k = 0; x0 + k * d <= x.back() + d; ++k) {
            int pos = x0 + k * d;
            int l = lower_bound(x.begin(), x.end(), pos) - x.begin();
            __int128 cur = dp[pos] + add(l, n, pos, p_sum, p_sqr);
            __int128 add_cur = __int128(k) * t;
            if (right == -1 || right + 2 * add_right > cur + 2 * add_cur) {
                right = cur;
                add_right = add_cur;
            }
        }
        for (int k = 0; x0 - k * d >= 0; ++k) {
            int pos = x0 - k * d;
            int r = upper_bound(x.begin(), x.end(), pos) - x.begin();
            __int128 cur = dp[pos] + add(0, r, pos, p_sum, p_sqr);
            __int128 add_cur = __int128(k) * t;
            if (left == -1 || left + 2 * add_left > cur + 2 * add_cur) {
                left = cur;
                add_left = add_cur;
            }
        }
        __int128 ans = min(add_left, add_right) * 2 + left + right + max(add_left, add_right);
        for (int k = 0; x0 + k * d <= x.back() + d; ++k) {
            int pos = x0 + k * d;
            int l = lower_bound(x.begin(), x.end(), pos) - x.begin();
            __int128 cur = dp[pos] + add(l, n, pos, p_sum, p_sqr);
            __int128 add_cur = __int128(k) * t;
            ans = min(ans, 2 * add_left + left + cur + add_cur);
        }
        for (int k = 0; x0 - k * d >= 0; ++k) {
            int pos = x0 - k * d;
            int r = upper_bound(x.begin(), x.end(), pos) - x.begin();
            __int128 cur = dp[pos] + add(0, r, pos, p_sum, p_sqr);
            __int128 add_cur = __int128(k) * t;
            ans = min(ans, 2 * add_right + right + cur + add_cur);
        }
        cout << ll(ans) << '\n';
    }
    return 0;
}
