#include <iostream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <iostream>
#include <vector>
#include <iostream>
#include <array>

using namespace std;

typedef long long ll;

const int N = 1e7 + 5;

ll get(int x1, int x2) {
    ll dx = abs(x1 - x2);
    return dx * dx;
}

__int128 add(int l, int r, __int128 pos, vector<__int128> &p_sum, vector<__int128> &p_sqr) {
    int len = r - l;
    return p_sqr[r] - p_sqr[l] - 2 * (p_sum[r] - p_sum[l]) * pos + __int128(len) * pos * pos;
}

array<__int128, N> dp;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> x(n);
    for (int &i : x) {
        cin >> i;
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    x0 += d;
    for (auto &i : x) {
        i += d;
        //cout << i << ' ';
    }
    //cout << endl;
    vector<__int128> p_sum(n + 1), p_sqr(n + 1);
    for (int i = 0; i < n; ++i) {
        p_sum[i + 1] = p_sum[i] + x[i];
        p_sqr[i + 1] = p_sqr[i] + ll(x[i]) * x[i];
    }

    dp[x0] = 0;
    for (int k = 1; x0 + k * d <= x.back() + d; ++k) {
        int t1 = x0 + (k - 1) * d, t2 = x0 + k * d;
        int L = lower_bound(x.begin(), x.end(), t1) - x.begin() - 1;
        int R = upper_bound(x.begin(), x.end(), t2) - x.begin();
        //cout << L << ' ' << R << ' ';
        if (R - L >= 2) {
            int l = L, r = R;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (get(x[m], t1) < get(x[m], t2)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            dp[t2] = dp[t1] + add(L + 1, r, t1, p_sum, p_sqr) + add(r, R, t2, p_sum, p_sqr);
        } else {
            dp[t2] = dp[t1];
        }
        //cout << t2 << ' ' << ll(dp[t2]) << '\n';
    }
    for (int k = 1; x0 - k * d >= 0; ++k) {
        int t1 = x0 - (k - 1) * d, t2 = x0 - k * d;
        int L = lower_bound(x.begin(), x.end(), t2) - x.begin() - 1;
        int R = upper_bound(x.begin(), x.end(), t1) - x.begin();
        if (R - L >= 2) {
            int l = L, r = R;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (get(x[m], t2) < get(x[m], t1)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            dp[t2] = dp[t1] + add(L + 1, r, t2, p_sum, p_sqr) + add(r, R, t1, p_sum, p_sqr);
        } else {
            dp[t2] = dp[t1];
        }
        //cout << L << ' ' << R << ' ' << t2 << ' ' << ll(dp[t2]) << '\n';
    }

    auto right1 = [&] (__int128 k, ll t) -> __int128 {
        __int128 pos = x0 + k * d;
        int l = lower_bound(x.begin(), x.end(), pos) - x.begin();
        __int128 cur = dp[pos] + add(l, n, pos, p_sum, p_sqr);
        __int128 add_cur = __int128(k) * t;
        return cur + add_cur;
    };

    auto right2 = [&] (__int128 k, ll t) -> __int128 {
        __int128 pos = x0 + k * d;
        int l = lower_bound(x.begin(), x.end(), pos) - x.begin();
        __int128 cur = dp[pos] + add(l, n, pos, p_sum, p_sqr);
        __int128 add_cur = __int128(k) * t;
        return cur + 2 * add_cur;
    };

    auto left1 = [&] (__int128 k, ll t) -> __int128 {
        __int128 pos = x0 - k * d;
        int r = upper_bound(x.begin(), x.end(), pos) - x.begin();
        __int128 cur = dp[pos] + add(0, r, pos, p_sum, p_sqr);
        __int128 add_cur = __int128(k) * t;
        return cur + add_cur;
    };

    auto left2 = [&] (__int128 k, ll t) -> __int128 {
        __int128 pos = x0 - k * d;
        int r = upper_bound(x.begin(), x.end(), pos) - x.begin();
        __int128 cur = dp[pos] + add(0, r, pos, p_sum, p_sqr);
        __int128 add_cur = __int128(k) * t;
        return cur + 2 * add_cur;
    };

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        ll t;
        cin >> t;
        __int128 l = - abs(x[0]) / d - 10, r = abs(x.back()) / d + 10;
        while (l + 2 < r) {
            __int128 m1 = (2 * l + r) / 3;
            __int128 m2 = (l + 2 * r) / 3;
            if (right1(m1, t) < right1(m2, t)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        __int128 ansright1 = l;
        for (int it = 0; it < 3; ++it) {
            if (right1(l + it, t) < right1(ansright1, t)) {
                ansright1 = l + it;
            }
        }

        l = - abs(x[0]) / d - 10, r = abs(x.back()) / d + 10;
        while (l + 2 < r) {
            __int128 m1 = (2 * l + r) / 3;
            __int128 m2 = (l + 2 * r) / 3;
            if (right2(m1, t) < right2(m2, t)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        __int128 ansright2 = l;
        for (__int128 k = l; k <= r; ++k) {
            if (right2(k, t) < right2(ansright2, t)) {
                ansright2 = k;
            }
        }

        l = - abs(x[0]) / d - 10, r = abs(x.back()) / d + 10;
        while (l + 2 < r) {
            __int128 m1 = (2 * l + r) / 3;
            __int128 m2 = (l + 2 * r) / 3;
            if (left1(m1, t) < left1(m2, t)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        __int128 ansleft1 = l;
        for (__int128 k = l; k <= r; ++k) {
            if (left1(k, t) < left1(ansleft1, t)) {
                ansleft1 = k;
            }
        }

        l = - abs(x[0]) / d - 10, r = abs(x.back()) / d + 10;
        while (l + 2 < r) {
            __int128 m1 = (2 * l + r) / 3;
            __int128 m2 = (l + 2 * r) / 3;
            if (left2(m1, t) < left2(m2, t)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        __int128 ansleft2 = l;
        for (__int128 k = l; k <= r; ++k) {
            if (left2(k, t) < left2(ansleft2, t)) {
                ansleft2 = k;
            }
        }

        cout << ll(min(right1(ansright1, t) + left2(ansleft2, t), right2(ansright2, t) + left1(ansleft1, t))) << '\n';
    }
    return 0;
}
