#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const int mxN = 5e5 + 10;

struct Segtree {
    int n;
    vector<ll> mx, sum, lazy;
    Segtree(int n) : n(n) {
        mx.resize(n * 4);
        sum.resize(n * 4);
        lazy.resize(n * 4, -INF);
    }

    void push(int v, int vl, int vr) {
        if (lazy[v] == -INF) return;
        mx[v] = lazy[v];
        sum[v] = lazy[v] * (vr - vl + 1);
        if (vl != vr) {
            lazy[v * 2 + 1] = lazy[v * 2 + 2] = lazy[v];
        }
        lazy[v] = -INF;
    }

    ll query_sum(int v, int vl, int vr, int l, int r) {
        push(v, vl, vr);
        if (r < vl || vr < l) return 0;
        if (l <= vl && vr <= r) return sum[v];
        int vm = (vl + vr) / 2;
        return query_sum(v * 2 + 1, vl, vm, l, r) + query_sum(v * 2 + 2, vm + 1, vr, l, r);
    }
    ll query_sum(int l, int r) { return query_sum(0, 0, n - 1, l, r); }

    int first_more(int v, int vl, int vr, int x) {
        push(v, vl, vr);
        if (vl == vr) return vl;
        int vm = (vl + vr) / 2;
        push(v * 2 + 1, vl, vm);
        if (mx[v * 2 + 1] > x) return first_more(v * 2 + 1, vl, vm, x);
        return first_more(v * 2 + 2, vm + 1, vr, x);
    }
    int first_more(int x) { return first_more(0, 0, n - 1, x); }

    void update(int v, int vl, int vr, int l, int r, int x) {
        push(v, vl, vr);
        if (r < vl || vr < l) return;
        if (l <= vl && vr <= r) {
            lazy[v] = x;
            push(v, vl, vr);
            return;
        }
        int vm = (vl + vr) / 2;
        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm + 1, vr, l, r, x);
        mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
        sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
    }
    void update(int l, int r, int x) { update(0, 0, n - 1, l, r, x); }
};

int used[mxN], ind[mxN];
vector<int> g[mxN], order;

void dfs(int v) {
    if (used[v]) return;
    used[v] = 1;
    for (int to : g[v]) dfs(to);
    ind[v] = -siz(order);
    order.push_back(v);
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < k; ++i) g[i].clear();
    fill(used, used + k, 0);
    order.clear();
    vector<vector<int>> seg(k);
    Segtree segt(n + 1);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        seg[i] = {l, m, r};
        segt.update(l, r, 1);
        for (int j = 0; j < i; ++j) {
            int l2 = seg[j][0], m2 = seg[j][1], r2 = seg[j][2];
            if (l <= m2 && m2 <= r) g[i].push_back(j);
            if (l2 <= m && m <= r2) g[j].push_back(i);
        }
    }
    int prov = (segt.query_sum(1, n) == n);
    for (int i = 0; i < k; ++i) {
        dfs(i);
    }
    for (int v = 0; v < k; ++v) {
        for (int to : g[v]) {
            if (ind[to] < ind[v]) prov = 0;
        }
    }
    cout << (prov ? "YES\n" : "NO\n");
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}