#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;

struct Segtree {
    int n;
    vector<ll> mx, sum, lazy;
    Segtree(int n) : n(n) {
        mx.resize(n * 4);
        sum.resize(n * 4);
        lazy.resize(n * 4, -INF);
    }

    void push(int v, int vl, int vr) {
        if (lazy[v] == -INF) return;
        mx[v] = lazy[v];
        sum[v] = lazy[v] * (vr - vl + 1);
        if (vl != vr) {
            lazy[v * 2 + 1] = lazy[v * 2 + 2] = lazy[v];
        }
        lazy[v] = -INF;
    }

    ll query_sum(int v, int vl, int vr, int l, int r) {
        push(v, vl, vr);
        if (r < vl || vr < l) return 0;
        if (l <= vl && vr <= r) return sum[v];
        int vm = (vl + vr) / 2;
        return query_sum(v * 2 + 1, vl, vm, l, r) + query_sum(v * 2 + 2, vm + 1, vr, l, r);
    }
    ll query_sum(int l, int r) { return query_sum(0, 0, n - 1, l, r); }

    int first_more(int v, int vl, int vr, int x) {
        push(v, vl, vr);
        if (vl == vr) return vl;
        int vm = (vl + vr) / 2;
        push(v * 2 + 1, vl, vm);
        if (mx[v * 2 + 1] > x) return first_more(v * 2 + 1, vl, vm, x);
        return first_more(v * 2 + 2, vm + 1, vr, x);
    }
    int first_more(int x) { return first_more(0, 0, n - 1, x); }

    void update(int v, int vl, int vr, int l, int r, int x) {
        push(v, vl, vr);
        if (r < vl || vr < l) return;
        if (l <= vl && vr <= r) {
            lazy[v] = x;
            push(v, vl, vr);
            return;
        }
        int vm = (vl + vr) / 2;
        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm + 1, vr, l, r, x);
        mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
        sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
    }
    void update(int l, int r, int x) { update(0, 0, n - 1, l, r, x); }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> seg(k);
    Segtree segt(n + 1);
    for (int i= 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        segt.update(l, r, 1);
    }
    cout << (segt.query_sum(1, n) == n ? "YES\n" : "NO\n");
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}