#include<bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int MAXN = 5e5 + 52;
vector<int> g1[MAXN];
vector<int> g2[MAXN];
int h[MAXN];
int p[MAXN];

void dfs(int v) {
    for (auto &u: g1[v]) {
        if (p[v] != u) {
            h[u] = h[v] + 1;
            p[u] = v;
            dfs(u);
        }
    }
}

int mt[MAXN];
int t = 2;
int used[MAXN];

bool kuhn(int v) {
    used[v] = t;
    for (auto &u: g2[v]) {
        if (mt[u] == -1) {
            mt[u] = v;
            return 1;
        }
    }
    for (auto &u: g2[v]) {
        if (used[mt[u]] != t && kuhn(mt[u])) {
            mt[u] = v;
            return 1;
        }
    }
    return 0;
}

vector<int> now;
mt19937 rnd(time(0));

void dfs(int v, int dist, int d) {
    used[v] = t;
    if (dist > d) return;
    if (dist % 2) now.push_back(v);
    for (auto &u: g1[v]) {
        if (used[u] != t) {
            dfs(u, dist + 1, d);
        }
    }
}

void solve() {
    fill(mt, mt + MAXN, -1);
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    dfs(0);
    p[0] = -1;
    for (int i = 0; i < n; i++) {
        dfs(i, 0, d);
        t++;
        for (auto &x: now) {
            g2[i].push_back(x);
        }
        now.clear();
    }
    vector<int> e;
    for (int i = 0; i < n; i++) {
        if (h[i] % 2) e.push_back(i);
    }
    shuffle(all(e), rnd);
    int ans = 0;
    for (auto &u: e) {
        if (kuhn(u)) {
            ans++;
            t++;
        }
    }
    cout << ans << "\n";
    for (int i = 0; i < n; i++) {
        if (mt[i] != -1) {
            cout << i + 1 << " " << mt[i] + 1 << "\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
