#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

mt19937 rng(228);

struct Fenwick {
    int n;
    vector<int> t;

    Fenwick() {}
    Fenwick(int _n) : n(_n) {
        t.resize(n + 1);
    }

    int get(int i) {
        int ans = 0;
        for (++i; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }

    void upd(int l, int r, int x) {
        add(l, x);
        add(r, -x);
    }
};

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<array<int, 3>> seg(k);
        for (auto &[l, m, r] : seg) {
            cin >> l >> m >> r;
            --l, --m, --r;
        }
        bool ok = false;
        for (int _ = 0; _ < 1e5; ++_) {
            shuffle(seg.begin(), seg.end(), rng);
            Fenwick tr(n);
            for (int i = 0; i < k; ++i) {
                auto [l, m, r] = seg[i];
                if (tr.get(m) == 0) {
                    tr.upd(l, r + 1, 1);
                }
            }
            bool ok = true;
            for (int i = 0; i < n; ++i) {
                if (tr.get(i) == 0) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                ok = true;
                break;
            }
        }
        if (ok) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}