#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

mt19937 rng(228);

struct Fenwick {
    int n;
    vector<int> t;

    Fenwick() {}
    Fenwick(int _n) : n(_n) {
        t.resize(n + 1);
    }

    int get(int i) {
        int ans = 0;
        for (++i; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }

    void upd(int l, int r, int x) {
        add(l, x);
        add(r, -x);
    }
};

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<array<int, 3>> seg(k);
        for (auto &[l, m, r] : seg) {
            cin >> l >> m >> r;
            --l, --m, --r;
        }
        bool ok = false;
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < k; ++j) {
                if (i != j) {
                    if (!(seg[i][0] <= seg[j][1] && seg[j][1] <= seg[i][2])) {
                        if (seg[i][0] <= seg[j][0] && seg[i][2] >= seg[j][0]) {
                            ok = true;
                            break;
                        }
                    }
                }
            }
            if (ok) {
                break;
            }
        }
        if (ok) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}