#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

bool comp(vector<int>& a, vector<int>& b) {
	return a[1] < b[1];
}

struct fencnt {
	vector<int>v;
	int n;
	fencnt(int x) {
		n = x;
		v.resize(n + 1);
	}
	void add(int x) {
		x++;
		for (; x <= n; x += x & (-x)) {
			v[x]++;
		}
	}
	int get(int l, int r) {
		r++;
		int ans = 0;
		for (; r > 0; r -= r & (-r)) {
			ans += v[r];
		}
		for (; l > 0; l -= l & (-l)) {
			ans -= v[l];
		}
		return ans;
	}
};

struct fenmin {
	vector<int>v;
	int n;
	fenmin(int x) {
		n = x;
		v.resize(n + 1,1e9);
	}
	void add(int x, int y) {
		x = n - x;
		for (; x <= n; x += x & (-x)) {
			v[x] = min(v[x], y);
		}
	}
	int get(int x) {
		int ans = 1e9;
		x = n - x;
		for (; x > 0; x -= x & (-x)) {
			ans = min(ans, v[x]);
		}
		return ans;
	}
};

int32_t main() {
	int t;
	cin >> t;
	for (; t > 0; --t) {
		int n, k;
		cin >> n >> k;
		vector<vector<int>>v(k, vector<int>(3));
		for (int i = 0; i < k; ++i)cin >> v[i][0] >> v[i][2] >> v[i][1];
		sort(v.begin(), v.end(), comp);
		vector<int>isok(k);
		fencnt  f1(k);
		fenmin  f2(k);
		for (int i = 0; i < k; ++i) {
			if (v[i][0] == 1) {
				isok[i] = 1;
				f1.add(i);
				f2.add(i, v[i][2]);
				continue;
			}
			
				int l = -1;
				int r = i;
				while (l + 1 < r) {
					int mid = (l + r) / 2;
					if (v[mid][1] < v[i][0] - 1) {
						l = mid;
					}
					else {
						r = mid;
					}
				}
				if (r != i) {
					if(f2.get(r)<v[i][0]){
						isok[i] = 1;
					}
					else {
						int l1 = r - 1;
						int r1 = i;
						while (l1 + 1 < r1) {
							int mid = (l1 + r1) / 2;
							if (v[mid][1] < v[i][2]) {
								l1 = mid;
							}
							else {
								r1 = mid;
							}
						}
						if (f1.get(r, l1) > 0) {
							isok[i] = 1;
						}
					}
				}
				if (isok[i] == 1) {
					f1.add(i);
					f2.add(i, v[i][2]);
				}
				
			
		}
		int ok = 0;
		for (int i = 0; i < k; ++i) {
			if (v[i][1] == n && isok[i]==1) {
				ok = 1;
			}
		}
		if (ok) {
			cout << "YES\n";
		}
		else {
			cout << "NO\n";
		}
	}
	return 0;
}