#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define ld long double

using namespace std;

struct line {
	int k, b, x0;
	line(){
		x0 = 1e9;
		k = 0;
		b = 0;
	}
	line(int x, int y) {
		k = x;
		b = y;
		x0 = 1e9;
	}
	int get(int x) {
		return x * k + b;
	}
};

int getper(line& a, line& b) {
	ld x1 = (b.b - a.b);
	x1 /= (a.k - b.k);
	int x = x1;
	if (x < x1) {
		x++;
	}
	return x;
}

struct kht {
	vector<line>v;
	int kon;
	kht(int n) {
		v.resize(n);
		kon = 0;
	}
	void add(line& lol) {
		while (kon > 0 && getper(v[kon-1], lol) >= v[kon-1].x0) {
			kon--;
		}
		if (kon > 0) {
			lol.x0 = getper(lol, v[kon-1]);
		}
		v[kon] = lol;
		kon++;
	}
	int get(int x) {
		if (kon == 0) {
			return 0;
		}
		int l = 0;
		int r = kon - 1;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (v[mid].x0 >= x) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		return min(v[l].get(x), v[r].get(x));
	}
};

int getget(int x, int d, int x0) {
	int opa = (x / d) * d + x0 % d;
	if (opa >= x) {
		opa -= d;
	}
	return min((x - opa) * (x - opa), (x - opa - d) * (x - opa - d));
}

void build(vector<int>& v, kht& lol,int n,int x0,int d) {
	if (n == 0) {
		return;
	}
	vector<int>pref(n);
	for (int i = 0; i < n; ++i) {
		if (i > 0) {
			pref[i] += pref[i - 1];
		}
		pref[i] += getget(v[i], d,x0);
	}
	vector<pair<int, int>>cnt(n);
	for (int i = n - 1; i >= 0; --i) {
		if (i < n - 1) {
			//cnt[i].first = cnt[i + 1].first;
			cnt[i].second = cnt[i + 1].second + (n - i - 1) * ((v[i + 1] - v[i]) * (v[i + 1] - v[i])) + 2 * (v[i + 1] - v[i]) * (cnt[i + 1].first);
			cnt[i].first = cnt[i + 1].first + (n - i - 1) * (v[i + 1] - v[i]);
		}
	}
	
		int j = 0;
		int opa = x0;
		int ccnt = 0;
		while (opa <= v[n - 1] + d) {
			while (j < n && v[j] <= opa) {
				ccnt = pref[j];
				j++;
			}
			int a = ccnt;
			if (j < n) {
				a += cnt[j].second + (n - j) * ((v[j] - opa) * (v[j] - opa)) + 2 * (v[j] - opa) * (cnt[j].first);

			}
			//ans = min(ans, a + (opa / d) * x);
			line x(opa / d, a);
			lol.add(x);
			opa += d;
		}
		
	
}

int32_t main() {
	int n;
	cin >> n;
	vector<int>v(n);
	for (int i = 0; i < n; ++i)cin >> v[i];
	int x0, d;
	cin >> x0 >> d;
	vector<int>left;
	vector<int>right;
	for (int i = 0; i < n; ++i) {
		if (v[i] > x0) {
			right.push_back(v[i]);
		}
		else if (v[i] < x0) {
			left.push_back(x0+x0-v[i]);
		}
	}

	sort(left.begin(), left.end());
	sort(right.begin(), right.end());
	kht k1(1e6+10);
	kht k2(1e6+10);
	build(left, k1, left.size(), x0, d);
	build(right, k2, right.size(), x0, d);
	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		int x;
		cin >> x;
		int ans = min(k1.get(x) + k2.get(x * 2), k1.get(x * 2) + k2.get(x));
		cout << ans << '\n';
	}
	return 0;
}