#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define vi vector<int>
#define pi pair<int, int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vb vector<bool>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define gb(a, b) (((a) >> (b)) & 1)

bool cont(int l, int m, int r) {
	return l <= m && m <= r;
}
vi used;
vvi graph;

struct snm {
	int n;
	vi par;
	vi sz;
	snm(int n = 0) : n(n) {
		par.assign(n, 1);
		sz.assign(n, 1);
		for (int i = 0; i < n; i++) par[i] = i;
	}
	int get(int x) {
		if (par[x] == x) return x;
		int y = get(par[x]);
		par[x] = y;
		return y;
	}
	void unite(int i, int j) {
		i = get(i);
		j = get(j);
		if (get(i) == get(j)) return;
		if (sz[i] > sz[j]) swap(i, j);
		par[i] = j;
		sz[j] += sz[i];
	}
};

vi par;
snm sm;
void dfs(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (!used[v]) {
			par[v] = u;
			dfs(v);
		}
		else if (used[v] == 1) {
			int x = u;
			while (x != v) {
				sm.unite(x, par[x]);
				x = par[x];
			}
		}
	}
	used[u] = 2;
}

vpi ls;
bool cmp(int a, int b) {
	return ls[a] < ls[b];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		vi l(k);
		vi m(k);
		vi r(k);
		for (int i = 0; i < k; i++) {
			cin >> l[i] >> m[i] >> r[i];
			l[i]--;
			m[i]--;
			r[i]--;
		}
		bool ok = 0;
		for (int tm = 0; tm < (1 << k); tm++) {
			vi tt(n);
			vi td(k);
			while (1) {
				int tx = -1;
				for (int i = 0; i < k; i++) {
					if (td[i]) continue;
					if (gb(tm, i) && !tt[m[i]]) {
						bool tok = 1;
						for (int j = 0; j < k; j++) {
							if (j == i) continue;
							if (!gb(tm, j)) continue;
							if (td[j]) continue;
							if (cont(l[i], m[j], r[i])) {
								tok = 0;
								break;
							}
						}
						if (tok) {
							tx = i;
							break;
						}
					}
				}
				if (tx == -1) break;
				for (int i = l[tx]; i <= r[tx]; i++) {
					tt[i] = 1;
				}
				td[tx] = 1;
			}
			if (tt == vi(n,1)) ok = 1;
		}

		if (ok) cout << "YES\n";
		else cout << "NO\n";
	}
}