#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define vi vector<int>
#define pi pair<int, int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vb vector<bool>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

#define cont(l, m, r) ((l) <= (m) && (m) <= r)

vi used;
vvi graph;

struct snm {
	int n;
	vi par;
	vi sz;
	snm(int n = 0) : n(n) {
		par.assign(n, 1);
		sz.assign(n, 1);
		for (int i = 0; i < n; i++) par[i] = i;
	}
	int get(int x) {
		if (par[x] == x) return x;
		int y = get(par[x]);
		par[x] = y;
		return y;
	}
	void unite(int i, int j) {
		i = get(i);
		j = get(j);
		if (get(i) == get(j)) return;
		if (sz[i] > sz[j]) swap(i, j);
		par[i] = j;
		sz[j] += sz[i];
	}
};

vi par;
snm sm;
void dfs(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (!used[v]) {
			par[v] = u;
			dfs(v);
		}
		else if (used[v] == 1) {
			int x = u;
			while (x != v) {
				sm.unite(x, par[x]);
				x = par[x];
			}
		}
	}
	used[u] = 2;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		vi l(k);
		vi m(k);
		vi r(k);
		for (int i = 0; i < k; i++) {
			cin >> l[i] >> m[i] >> r[i];
			l[i]--;
			m[i]--;
			r[i]--;
		}
		vb bad(k);
		graph.assign(k, vi());
		for (int i = 0; i < k; i++) {
			for (int j = i + 1; j < k; j++) {
				if (cont(l[i], m[j], r[i])) graph[j].push_back(i);
				if (cont(l[j], m[i], r[j])) graph[i].push_back(j);
			}
		}
		used.assign(k, 0);
		par.assign(k, -0);
		sm = snm(k);
		for (int i = 0; i < k; i++) {
			if (!used[i]) dfs(i);
		}
		bool ok = 1;
		vvi tvec(k);
		vector<set<int>> tt(n);
		for (int i = 0; i < k; i++) {
			tvec[sm.get(i)].push_back(i);
			for (int x = l[i]; x <= r[i]; x++) {
				tt[x].insert(sm.get(i));
			}
		}
		vi tok(n);
		for (int _ = 0; _ < n; _++) {
			int tx = -1;
			for (int i = 0; i < n; i++) {
				if (tok[i]) continue;
				if (tx == -1 || tt[i].size() < tt[tx].size()) tx = i;
			}
			if (tx == -1) break;
			if (tt[tx].size()) {
				tok[tx] = 1;
				int c = *tt[tx].begin();
				int tl, tr;
				for (int a : tvec[c]) {
					if (cont(l[a], tx, r[a])) {
						tl = l[a];
						tr = r[a];
					}
				}
				for (int i = 0; i < n; i++) tt[i].erase(c);
				for (int a = tl; a <= tr; a++) tok[a] = 1;
			}
			else {
				ok = 0;
				break;
			}
		}

		

		if (ok && tok == vi(n, 1)) cout << "YES\n";
		else cout << "NO\n";
	}
}