#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define vi vector<int>
#define pi pair<int, int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vb vector<bool>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define gb(a, b) (((a) >> (b)) & 1)

#define cont(l, m, r) ((l) <= (m) && (m) <= r)

vi used;
vvi graph;

struct snm {
	int n;
	vi par;
	vi sz;
	snm(int n = 0) : n(n) {
		par.assign(n, 1);
		sz.assign(n, 1);
		for (int i = 0; i < n; i++) par[i] = i;
	}
	int get(int x) {
		if (par[x] == x) return x;
		int y = get(par[x]);
		par[x] = y;
		return y;
	}
	void unite(int i, int j) {
		i = get(i);
		j = get(j);
		if (get(i) == get(j)) return;
		if (sz[i] > sz[j]) swap(i, j);
		par[i] = j;
		sz[j] += sz[i];
	}
};

vi par;
snm sm;
void dfs(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (!used[v]) {
			par[v] = u;
			dfs(v);
		}
		else if (used[v] == 1) {
			int x = u;
			while (x != v) {
				sm.unite(x, par[x]);
				x = par[x];
			}
		}
	}
	used[u] = 2;
}

vpi ls;
bool cmp(int a, int b) {
	return ls[a] < ls[b];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		vi l(k);
		vi m(k);
		vi r(k);
		for (int i = 0; i < k; i++) {
			cin >> l[i] >> m[i] >> r[i];
			l[i]--;
			m[i]--;
			r[i]--;
		}
		vb bad(k);
		graph.assign(k, vi());
		for (int i = 0; i < k; i++) {
			for (int j = i + 1; j < k; j++) {
				if (cont(l[i], m[j], r[i])) graph[j].push_back(i);
				if (cont(l[j], m[i], r[j])) graph[i].push_back(j);
			}
		}
		used.assign(k, 0);
		par.assign(k, -0);
		sm = snm(k);
		for (int i = 0; i < k; i++) {
			if (!used[i]) dfs(i);
		}
		bool ok = 1;
		vvi tvec(k);
		vi ord;
		ls.assign(k, { 2e9, -2e9 });
		for (int i = 0; i < k; i++) {
			tvec[sm.get(i)].push_back(i);
			ls[sm.get(i)].ff = min(ls[sm.get(i)].ff, l[i]);
			ls[sm.get(i)].ss = min(ls[sm.get(i)].ss, r[i]);
			ord.push_back(i);
		}
		
		vector<set<int>> dp(n + 1);
		dp[0].insert(0);
		for (int i = 0; i < n; i++) {
			for (int a : dp[i]) {
				for (int c = 0; c < k; c++) {
					if (gb(a, c)) continue;
					for (int b : tvec[c]) {
						if (l[b] <= (i)) dp[r[b] + 1].insert(a + (1 << c));
					}
				}
			}
		}

		if (ok && dp[n].size()) cout << "YES\n";
		else cout << "NO\n";
	}
}