#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3, unroll-loops, inline, fast-math, no-stack-protector")
//#pragma GCC terget("avx2")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
//#define int long long

const ll INF = 2e9 + 228;

mt19937 rnd(228 + 57 - 179 + 1337);

struct el {
    int l, m, r;
};

struct seg_tree{
    vector<int> t;
    vector<int> p;
    seg_tree(int n) {
        t.resize(8 * n);
        p.resize(8 * n);
    }
    void push(int v) {
        if (p[v]) {
            t[v] = p[v];
            p[v * 2] = p[v];
            p[v * 2 + 1] = p[v];
            p[v] = 0;
        }
    }
    int get(int v, int l, int r, int pos) {
        push(v);
        if (l + 1 == r) {
            return t[v];
        }
        int m = (l + r) / 2;
        if (pos < m) return get(v * 2, l, m, pos);
        else return get(v * 2 + 1, m, r, pos);
    }
    void upd(int v, int l, int r, int L, int R) {
        push(v);
        if (L <= l && r <= R) {
            p[v] = 1;
            push(v);
            return;
        }
        if (R <= l || r <= L) return;
        int m = (l + r) / 2;
        upd(v * 2, l, m, L, R);
        upd(v * 2 + 1, m, r, L, R);
    }
};

vector<vector<int>> g;
vector<int> used, ts;

void dfs(int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (!used[i]) dfs(i);
    }
    ts.push_back(v);
}

void solve() {
    int n, k;
    cin >> n >> k;
    g.resize(k);
    used.resize(k);
    vector<int> cnt(n);
    vector<el> w(k);
    for (int i = 0; i < k; ++i) {
        cin >> w[i].l >> w[i].m >> w[i].r;
        --w[i].l;
        --w[i].m;
        ++cnt[w[i].m];
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (w[j].l <= w[i].l && w[i].r <= w[j].r) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < k; ++i) {
        if (!used[i]) dfs(i);
    }
    reverse(ts.begin(), ts.end());
    seg_tree t(n);
    for (auto ind : ts) {
        if (t.get(1, 0, n, w[ind].m) == 0) {
            t.upd(1, 0, n, w[ind].l, w[ind].r);
        }
    }
    int good = 1;
    for (int i = 0; i < n; ++i) good &= t.get(1, 0, n, i);
    cout << (good? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
    return 0;
}