#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
struct Line {
    int k, b;

    int get(int x) {
        return k * x + b;
    }

};

inline int sign(int x) {
    if (x < 0) return -1;
    if (x == 0) return 0;
    if (x > 0) return 1;
}

inline int intersect(Line a, Line b) {
    int d1 = a.k - b.k;
    int d2 = b.b - a.b;
    if (sign(d1) * sign(d2) < 0) return 0;
    if (d1 <= 0 && d2 <= 0) d1 *= -1, d2 *= -1;
    swap(d1, d2);
    return (d1 + d2 - 1) / d2;

}

struct cht {
    vector<pair<int, Line>> vl;
    int get(int x) {
        int l = 0, r = vl.size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (vl[m].first <= x) l = m;
            else r = m;
        }
        return vl[l].second.get(x);
    }

    cht(vector<Line>& vec) {
        reverse(all(vec));
        for (auto l : vec) {
            while (!vl.empty() && l.get(vl.back().first) <= vl.back().second.get(vl.back().first)) {
                vl.pop_back();
            }
            if (vl.empty()) {
                vl.push_back({0, l});
            } else {
                vl.push_back({intersect(vl.back().second, l), l});
            }
        }
    }

};
int d;
pair<cht, cht> calc(vector<int> points) {
    vector<Line> v1, v2;
    sort(all(points));
    if (points.empty()) {
        v1 = {{0, 0}};
        v2 = v1;
    } else {
        int curx = 0;
        int sumpref = 0;
        int sumsx2 = 0;
        int sumsx = 0;
        for (auto& i : points) sumsx += i;
        for (auto& i : points) sumsx2 += i * i;
        int cp = 0;
        while (true) {
            while (cp < points.size() && points[cp] <= curx) {
                sumsx2 -= points[cp] * points[cp];
                sumsx -= points[cp];
                int mn = min(points[cp] % d, d - points[cp] % d);
                sumpref += mn * mn;
                cp++;
            }
            int sumsuff = sumsx2 - 2 * curx * sumsx + curx * curx * (points.size() - cp);
            v1.push_back({curx / d, sumpref + sumsuff});
            v2.push_back({(curx * 2) / d, sumpref + sumsuff});
            if (curx >= points.back()) break;
            curx += d;
        }
    }
    return pair<cht, cht>(cht(v1), cht(v2));
}

auto main() -> signed {
    fastio;
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto& i : x) cin >> i;
    int x0;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<int> t(m);
    for (auto& i : t) cin >> i;
    for (auto& i : x) i -= x0;
    vector<int> pos;
    vector<int> neg;
    for (auto& i : x) {
        if (i > 0) pos.push_back(i);
        else if (i < 0) neg.push_back(i);
    }
    for (auto& i : neg) i = -i;
    auto res1 = calc(pos);
    auto res2 = calc(neg);
    for (auto i : t) {
        int br = min(res1.first.get(i) + res2.second.get(i), res1.second.get(i) + res2.first.get(i));
        cout << br << '\n';
    }
}