#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define endl '\n'

struct seg {
    int l;
    int m;
    int r;
};

vector < int > tree;

void update(int v, int l, int r, int i, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        update(2 * v + 1, l, m, i, x);
    } else {
        update(2 * v + 2, m, r, i, x);
    }
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return -1;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}


void solve() {
    int n, k; cin >> n >> k;
    vector < int > l(n);
    vector < int > r(n);
    vector < int > m(n);
    vector < seg > a;
    for (int i = 0; i < k; i++) {
        int l1, m1, r1;
        cin >> l1 >> m1 >> r1; l1--; r1--; m1--;
        l[l1]++; r[r1]++; m[m1]++;
        a.push_back({l1, m1, r1});
    }
    sort(a.begin(), a.end(), [](const auto& a, const auto& b) {
        return a.m < b.m;
    });
    bool flag = true;
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt += l[i];
        if (cnt == 0) {
            flag = false;
        }
        cnt -= r[i];
    }
    if (!flag) {
        cout << "NO" << endl;
        return;
    }
    tree.resize(4 * n, -1);
    int mx = -1;
    for (int i = 0; i < k; i++) {
        int ql = a[i].l;
        int qr = a[i].m;
        int per = get(0, 0, n, ql, qr);
        if (per >= a[i].m) {
            flag = false;
        }
        update(0, 0, n, a[i].m, a[i].r);
    }
    if (!flag) {
        cout << "NO" << endl;
    } else {
        cout << "YES" << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}


/*
2
3 2
1 1 1
3 3 3
3 2
1 1 2
2 2 3

1
5 2
1 2 4
2 4 5
*/
