#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef int ll;
typedef long double ld;
typedef pair<int, int> pii;

struct SegTree {
	ll n;
	vector<ll> t;
	SegTree(ll& _n) {
		n = _n;
		t.resize(4 * n, 0);
	}
	void update(ll v) {
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
	ll get(ll v, ll l, ll r, ll al, ll ar) {
		if (l >= ar || r <= al) return 0;
		if (l >= al && r <= ar) return t[v];
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		return max(get(vl, l, m, al, ar), get(vr, m, r, al, ar));
	}
	void change(ll v, ll l, ll r, ll i, ll x) {
		if (r - l == 1) {
			t[v] = x;
			return;
		}
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		if (i < m) change(vl, l, m, i, x);
		else change(vr, m, r, i, x);
		update(v);
	}
};

struct Person {
	ll l, r, m;
};

bool cmp(Person x, Person y) {
	return x.m < y.m;
}

void solve() {
	ll n, k;
	cin >> n >> k;
	vector<Person> a(k);
	for (ll i = 0; i < k; i++) {
		cin >> a[i].l >> a[i].m >> a[i].r;
		--a[i].l;
		--a[i].m;
		--a[i].r;
	}
	sort(all(a), cmp);
	SegTree t(n);
	for (ll i = k - 1; i >= 0; i--) {
		if (a[i].r == n - 1) {
			t.change(1, 0, n, a[i].l, 1);
			continue;
		}
		if (t.get(1, 0, n, a[i].m + 1, a[i].r + 2) == 1) {
			t.change(1, 0, n, a[i].l, 1);
		}
	}
	SegTree t2(n);
	for (ll i = 0; i < k; i++) {
		if (a[i].l == 0) {
			t2.change(1, 0, n, a[i].r, 1);
			continue;
		}
		if (t2.get(1, 0, n, a[i].l - 1, a[i].m) == 1) {
			t2.change(1, 0, n, a[i].r, 1);
		}
	}
	if (t.get(1, 0, n, 0, 1) || t2.get(1, 0, n, n - 1, n)) cout << "YES\n";
	else cout << "NO\n";
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	cin >> t;
	while (t--) solve();
}