#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <stack>
#define int long long

using namespace std;
using ll = long long;

struct Staff {
	int l, m, r;
};

bool flag = false;

void dfs(int v, vector <vector <int>>& g, vector <int>& used) {
	if (flag) {
		return;
	}
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u] == 1) {
			flag = true;
			return;
		}
		else if (used[u] == 0) {
			dfs(u, g, used);
		}
	}
	used[v] = 2;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector <Staff> arr(k);
	for (int i = 0; i < k; i++) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
		arr[i].l--;
		arr[i].m--;
		arr[i].r--;
	}
	vector <vector <int>> g(k);
	for (int i = 0; i < k; i++) {
		for (int j = i + 1; j < k; j++) {
			if (arr[i].l <= arr[j].m && arr[j].m <= arr[i].r) {
				if (arr[j].l <= arr[i].m && arr[i].m <= arr[j].r) {
					cout << "NO\n";
					return;
				}
				else {
					g[j].push_back(i);
				}
			}
			else {
				if (arr[j].l <= arr[i].m && arr[i].m <= arr[j].r) {
					g[i].push_back(j);
				}
			}
		}
	}
	vector <int> used(k, 0);
	flag = false;
	for (int i = 0; i < k; i++) {
		if (!used[i]) {
			dfs(i, g, used);
		}
	}
	if (flag) {
		cout << "NO\n";
	}
	else {
		vector <int> brr(n + 1);
		for (int i = 0; i < k; i++) {
			brr[arr[i].l]++;
			brr[arr[i].r + 1]--;
		}
		int curr = 0;
		for (int i = 0; i < n; i++) {
			curr += brr[i];
			if (curr == 0) {
				cout << "NO\n";
				return;
			}
		}
		cout << "YES\n";
	}
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
