#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <stack>
#include <numeric>
#define int long long

using namespace std;
using ll = long long;

const int INF = 2e18;

struct Staff {
	int l, m, r;
};

void dfs(int v, vector <vector <int>>& g, vector <bool>& used) {
	used[v] = true;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u, g, used);
		}
	}
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector <Staff> arr(k);
	for (int i = 0; i < k; i++) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
		arr[i].l--;
		arr[i].m--;
		arr[i].r--;
	}
	vector <vector <int>> g(k);
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			if (i == j) {
				continue;
			}
			if (arr[j].m > arr[i].r && arr[j].l <= arr[i].r + 1) {
				g[i].push_back(j);
			}
		}
	}
	vector <bool> used(k);
	for (int i = 0; i < k; i++) {
		if (arr[i].l == 0 && !used[i]) {
			dfs(i, g, used);
		}
	}
	for (int i = 0; i < k; i++) {
		if (arr[i].r == n - 1 && used[i]) {
			cout << "YES\n";
			return;
		}
	}
	g.assign(k, {});
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			if (i == j) {
				continue;
			}
			if (arr[j].m < arr[i].l && arr[j].r + 1 >= arr[i].l) {
				g[i].push_back(j);
			}
		}
	}
	used.assign(k, false);
	for (int i = 0; i < k; i++) {
		if (arr[i].r == n - 1 && !used[i]) {
			dfs(i, g, used);
		}
	}
	for (int i = 0; i < k; i++) {
		if (arr[i].l == 0 && used[i]) {
			cout << "YES\n";
			return;
		}
	}
	cout << "NO\n";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
