#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct SegmentTree {
    vector<int> t;
    int sz = 1;
    void init(int n) {
        sz = 1 << __lg(n) + !!(n & (n - 1));
        t.assign(sz << 1, 1e9);
    }
    void rangeApply(int l, int r, int x) {
        l = max(l, 0);
        r = min(r, sz);
        for (l += sz, r += sz; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                t[l] = min(t[l], x);
                l += 1;
            }
            if (r & 1) {
                --r;
                t[r] = min(t[r], x);
            }
        }
    }
    int query(int x) {
        int ans = 1e9;
        for (x += sz; x > 0; x >>= 1) {
            ans = min(ans, t[x]);
        }
        return ans;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> s(k);
    for (int i = 0; i < k; ++i) {
        cin >> s[i][0] >> s[i][1] >> s[i][2];
        --s[i][0], --s[i][1], --s[i][2];
    }
    sort(s.begin(), s.end());
    vector<int> dp(k);
    bool yay = false;
    SegmentTree tree;
    tree.init(n);
    for (int i = 0; i < k; ++i) {
        auto [l, m, r] = s[i];
        if (l == 0) {
            dp[i] = 1;
        } else {
            if (tree.query(l) < m) {
                dp[i] = true;
            }
            if (!dp[i]) {
                continue;
            }
        }
        if (dp[i] && r == n - 1) {
            yay = true;
            break;
        }
        tree.rangeApply(m + 1, r + 2, -1);
        tree.rangeApply(0, m + 1, r);
        // for (int j = i + 1; j < k; ++j) {
        //     if (m < s[j][0]) {
        //         if (s[j][0] <= r + 1) {
        //             dp[j] = true;
        //         }
        //     } else {
        //         if (s[j][1] > r) {
        //             dp[j] = true;
        //         }
        //     }
        // }
    }
    if (yay) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}