#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i128 = __int128;

int d;

struct CHT {
    struct Line {
        ll k;
        i128 b;
        i128 eval(ll x) {
            return i128(k) * x + b;
        }
        long double inter(const Line &oth) {
            return (oth.b - b) / (long double)(k - oth.k);
        }
    };

    vector<Line> t;
    void insert(Line l) {
        if (!t.empty() && t.back().k == l.k) {
            if (t.back().b > l.b) {
                swap(t.back(), l);
            }
            return;
        }
        while (t.size() > 1 && l.inter(t.end()[-2]) <= t.back().inter(t.end()[-2])) {
            t.pop_back();
        }
        t.push_back(l);
    }
    i128 qry(ll x) {
        if (t.empty()) {
            return 9e18;
        }
        int lo = 0, hi = t.size() - 1;
        while (lo < hi) {
            int mid = lo + hi >> 1;
            if (t[mid].eval(x) <= t[mid + 1].eval(x)) {
                hi = mid;
            } else {
                lo = mid + 1;
            }
        }
        return t[lo].eval(x);
    }
};

struct Struct {
#define ll i128
    vector<int> x, nx, prv;
    vector<ll> suf;
    vector<i128> pref, suf_sq;
    vector<ll> val;
    int n;

    CHT cht;
    CHT cht2;
    vector<int> stk;


    void build(vector<int> xx, int x0) {
        for (int y : xx) {
            if (y >= x0) {
                x.push_back(y - x0);
            } else {
                x.push_back(x0 - y);
            }
        }
        sort(x.begin(), x.end());
        n = x.size();
        suf.assign(n + 1, 0);
        pref.assign(n + 1, 0);
        val.assign(n + 1, 0);
        nx.assign(n + 1, 0);
        suf_sq.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            int l = x[i] / d * d;
            int r = l + d;
            nx[i + 1] = r;
            if (x[i] - l > r - x[i]) {
                val[i] = (r - x[i]) * 1LL * (r - x[i]);
            } else {
                val[i] = (x[i] - l) * 1LL * (x[i] - l);
            }
            pref[i + 1] = pref[i] + val[i];
        }
        for (int i = n - 1; i >= 0; --i) {
            suf[i] = suf[i + 1] + x[i];
            suf_sq[i] = suf_sq[i + 1] + 1LL * x[i] * x[i];
        }
        for (int i = 0; i < n; ++i) {
            if (nx[i] <= x[i]) {
                ll tx = x[i] / d * d;
                ll now = i128(tx) / d;
                i128 b = suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx + pref[i];
                cht.insert(CHT::Line{now, b});
                tx = nx[i] / d * d;
                now = i128(tx) / d;
                b = suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx + pref[i];
                cht2.insert(CHT::Line{now, b});
                stk.push_back(i);
            }
        }
    }
    ll query(ll t) {
        i128 answer = min<i128>(9e18, pref[n] + i128(nx[n]) / d * t);
        answer = min(answer, cht.qry(t));
        answer = min(answer, cht2.qry(t));
        auto isNext = [&](int i) {
            int tx = x[i] / d * d;
            return t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d;
        };
        int lo = -1, hi = stk.size();
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (isNext(stk[mid])) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        auto f = [&](int i) {
            auto relax = [&](ll tx) {
                i128 now = pref[i] + i128(tx) / d * t;
                now += suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx;
                answer = min(answer, now);
            };
            ll lo = nx[i] / d, hi = x[i] / d;
            while (lo < hi) {
                ll mid = lo + hi >> 1;
                ll tx = mid * d;
                if (t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d) {
                    lo = mid + 1;
                } else {
                    hi = mid;
                }
            }
            relax(hi * d);
        };
        for (int u : {hi, hi + 1, hi + 2}) {
            if (u < stk.size()) {
                f(stk[u]);
            }
        }
        // for (int i = 0, T = 3; i < n; ++i) {
        //     if (nx[i] > x[i]) {
        //         continue;
        //     }
        //     // t >= 1LL * (n - i) * d * d + i128(2) * suf[i] * d - i128(2) * (tx + d) * (n - i) * d
        //     // tx + d >= (1LL * (n - i) * d * d + 2 * suf[i] * d + t + 2 * (n - i) * d - 1) / (2 * (n - i) * d))
        //     auto relax = [&](ll tx) {
        //         i128 now = pref[i] + i128(tx) / d * t;
        //         now += suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx;
        //         answer = min(answer, now);
        //     };
        //
        //     ll lo = nx[i] / d, hi = x[i] / d;
        //     if (isNext(i)) {
        //         continue;
        //         lo = hi;
        //     }
        //     while (lo < hi) {
        //         ll mid = lo + hi >> 1;
        //         ll tx = mid * d;
        //         if (t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d) {
        //             lo = mid + 1;
        //         } else {
        //             hi = mid;
        //         }
        //     }
        //     relax(hi * d);
        //     if (T-- <= 0) {
        //         break;
        //     }
        //     // ll tx = (1LL * (n - i) * d * d + i128(2) * suf[i] * d + t + 2LL * (n - i) * d - 1) / (2LL * (n - i) * d) - d;
        //     // relax(tx);
        //     // relax(tx + d);
        //     // relax(tx - d);
        //     // break;
        //     // for (int tx = nx[i]; tx <= x[i]; tx += d) {
        //     //     if (t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d) {
        //     //         continue;
        //     //     }
        //     //     i128 now = pref[i] + i128(tx) / d * t;
        //     //     now += suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx;
        //     //     answer = min(answer, now);
        //     // }
        // }
        return answer;
    }
#undef ll
};

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    int x0;
    cin >> x0 >> d;
    vector<int> l, r;
    for (int y : x) {
        if (y <= x0) {
            l.push_back(y);
        } else {
            r.push_back(y);
        }
    }
    Struct L, R;
    L.build(l, x0);
    R.build(r, x0);
    int q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        i128 answer = 9e18;
        answer = min(answer, L.query(t) + R.query(2 * t));
        answer = min(answer, L.query(2 * t) + R.query(t));
        cout << ll(answer) << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}