#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i128 = __int128;

int d;

struct Struct {
    vector<int> x, nx, prv;
    vector<ll> suf;
    vector<i128> pref, suf_sq;
    vector<ll> val;
    int n;

    void build(vector<int> xx, int x0) {
        for (int y : xx) {
            if (y >= x0) {
                x.push_back(y - x0);
            } else {
                x.push_back(x0 - y);
            }
        }
        sort(x.begin(), x.end());
        n = x.size();
        suf.assign(n + 1, 0);
        pref.assign(n + 1, 0);
        val.assign(n + 1, 0);
        nx.assign(n + 1, 0);
        suf_sq.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            int l = x[i] / d * d;
            int r = l + d;
            nx[i + 1] = r;
            if (x[i] - l > r - x[i]) {
                val[i] = (r - x[i]) * 1LL * (r - x[i]);
            } else {
                val[i] = (x[i] - l) * 1LL * (x[i] - l);
            }
            pref[i + 1] = pref[i] + val[i];
        }
        for (int i = n - 1; i >= 0; --i) {
            suf[i] = suf[i + 1] + x[i];
            suf_sq[i] = suf_sq[i + 1] + 1LL * x[i] * x[i];
        }
    }
    ll query(ll t) {
        i128 answer = min<i128>(9e18, pref[n] + i128(nx[n]) / d * t);
        auto isNext = [&](int i) {
            int tx = x[i] / d * d;
            return t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d;
        };
        int lo = -1, hi = n;
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (isNext(mid)) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        // vector<int>
        if (hi < n) {
            int i = hi;
            // t >= 1LL * (n - i) * d * d + i128(2) * suf[i] * d - i128(2) * (tx + d) * (n - i) * d
            // tx + d >= (1LL * (n - i) * d * d + 2 * suf[i] * d + t + 2 * (n - i) * d - 1) / (2 * (n - i) * d))
            auto relax = [&](ll tx) {
                i128 now = pref[i] + i128(tx) / d * t;
                now += suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx;
                answer = min(answer, now);
            };
            ll lo = nx[i] / d, hi = x[i] / d;
            while (lo < hi) {
                ll mid = lo + hi >> 1;
                ll tx = mid * d;
                if (t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d) {
                    lo = mid + 1;
                } else {
                    hi = mid;
                }
            }
            relax(hi * d);
            // ll tx = (1LL * (n - i) * d * d + i128(2) * suf[i] * d + t + 2LL * (n - i) * d - 1) / (2LL * (n - i) * d) - d;
            // relax(tx);
            // relax(tx + d);
            // relax(tx - d);
            // break;
            // for (int tx = nx[i]; tx <= x[i]; tx += d) {
            //     if (t < 1LL * (n - i) * d * d + i128(2) * (suf[i] - 1LL * (tx + d) * (n - i)) * d) {
            //         continue;
            //     }
            //     i128 now = pref[i] + i128(tx) / d * t;
            //     now += suf_sq[i] + (n - i) * i128(tx) * tx - 2 * suf[i] * tx;
            //     answer = min(answer, now);
            // }
        }
        return answer;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    int x0;
    cin >> x0 >> d;
    vector<int> l, r;
    for (int y : x) {
        if (y <= x0) {
            l.push_back(y);
        } else {
            r.push_back(y);
        }
    }
    Struct L, R;
    L.build(l, x0);
    R.build(r, x0);
    int q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        ll answer = 9e18;
        answer = min(answer, L.query(t) + R.query(2 * t));
        answer = min(answer, L.query(2 * t) + R.query(t));
        cout << answer << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}