#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, D;
    cin >> n >> D;
    vector<vector<int>> adj(n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    vector<int> fa(n, -1), depth(n), ord;
    auto dfs_init = [&](auto self, int v) -> void {
        ord.push_back(v);
        for (int to : adj[v]) {
            if (to == fa[v]) {
                continue;
            }
            adj[to].erase(find(adj[to].begin(), adj[to].end(), v));
            depth[to] = depth[v] + 1;
            fa[to] = v;
            self(self, to);
        }
    };
    dfs_init(dfs_init, 0);

    vector<int> used(n);
    vector<array<int, 2>> pairs;
    sort(ord.begin(), ord.end(), [&](int x, int y) {
        return depth[x] > depth[y];
    });
    vector<int> tmp(n);
    for (int x : ord) {
        if (used[x] || fa[x] == -1) {
            continue;
        }
        if (D == 1 && !used[fa[x]]) {
            used[fa[x]] = used[x] = true;
            pairs.push_back({x, fa[x]});
        } else if (D == 3 && fa[fa[x]] != -1) {
            int u = fa[fa[x]];
            if (tmp[u] < adj[u].size()) {
                int t = adj[u][tmp[u]++];
                used[x] = used[t] = true;
                pairs.push_back({x, t});
            } else {
                u = fa[u];
                if (u != -1 && !used[u]) {
                    used[x] = used[u] = true;
                    pairs.push_back({x, u});
                }
            }
        }
    }
    cout << pairs.size() << '\n';
    for (auto [x, y] : pairs) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}