#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, D;
    cin >> n >> D;
    vector<vector<int>> adj(n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    vector<int> fa(n, -1), depth(n), ord, tin(n), tout(n);
    int timer = 0;
    auto dfs_init = [&](auto self, int v) -> void {
        ord.push_back(v);
        tin[v] = timer++;
        for (int to : adj[v]) {
            if (to == fa[v]) {
                continue;
            }
            adj[to].erase(find(adj[to].begin(), adj[to].end(), v));
            depth[to] = depth[v] + 1;
            fa[to] = v;
            self(self, to);
        }
        tout[v] = timer;
    };
    dfs_init(dfs_init, 0);

    vector<int> used(n);
    vector<array<int, 2>> pairs;
    sort(ord.begin(), ord.end(), [&](int x, int y) {
        return depth[x] > depth[y];
    });
    vector<int> tmp(n);
    if (D == 1) {
        for (int x : ord) {
            if (used[x] || fa[x] == -1) {
                continue;
            }
            if (D == 1 && !used[fa[x]]) {
                used[fa[x]] = used[x] = true;
                pairs.push_back({x, fa[x]});
            } else if (D == 3 && fa[fa[x]] != -1) {
                int u = fa[fa[x]];
                if (fa[u] != -1 && !used[fa[u]]) {

                }
                if (tmp[u] < adj[u].size()) {
                    int t = adj[u][tmp[u]++];
                    used[x] = used[t] = true;
                    pairs.push_back({x, t});
                } else {
                    u = fa[u];
                    if (u != -1 && !used[u]) {
                        used[x] = used[u] = true;
                        pairs.push_back({x, u});
                    }
                }
            }
        }
        cout << pairs.size() << '\n';
        for (auto [x, y] : pairs) {
            cout << x + 1 << " " << y + 1 << '\n';
        }
        return;
    }
    for (int x : ord) {
        vector<int> kids[2];
        for (int y = 0; y < n; ++y) {
            if (!(tin[x] <= tin[y] && tout[x] >= tout[y])) {
                continue;
            }
            kids[depth[y] & 1].push_back(y);
        }
        for (int t = 0; t < 2; ++t) {
            sort(kids[t].begin(), kids[t].end(), [&](int u, int v) { return depth[u] > depth[v]; });
        }
        for (int i = 0; i < kids[0].size(); ++i) {
            if (used[kids[0][i]]) {
                continue;
            }
            for (int j = 0; j < kids[1].size(); ++j) {
                if (used[kids[1][j]]) {
                    continue;
                }
                int a = kids[0][i];
                int b = kids[1][j];
                int dist = depth[a] + depth[b] - 2 * depth[x];
                if (dist <= D) {
                    used[a] = used[b] = true;
                    pairs.push_back({a, b});
                    break;
                }
            }
        }
    }
    cout << pairs.size() << '\n';
    for (auto [x, y] : pairs) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}