#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, D;
    cin >> n >> D;
    vector<vector<int>> adj(n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    vector<int> fa(n, -1), depth(n), ord_, tin(n), tout(n);
    int timer = 0;
    auto dfs_init = [&](auto self, int v) -> void {
        ord_.push_back(v);
        tin[v] = timer++;
        for (int to : adj[v]) {
            if (to == fa[v]) {
                continue;
            }
            adj[to].erase(find(adj[to].begin(), adj[to].end(), v));
            depth[to] = depth[v] + 1;
            fa[to] = v;
            self(self, to);
        }
        tout[v] = timer;
    };
    dfs_init(dfs_init, 0);
    vector<int> used(n);
    vector<array<int, 2>> pairs;
    vector<int> ord = ord_;
    sort(ord_.begin(), ord_.end(), [&](int x, int y) {
        return depth[x] > depth[y];
    });
    vector<int> tmp(n);
    vector<set<int>> s(n);
    for (int i = 0; i < n; ++i) {
        s[depth[i]].insert(tin[i]);
    }
    auto match = [&](int a, int b) {
        used[a] = used[b] = true;
        pairs.push_back({a, b});
        s[depth[a]].erase(tin[a]);
        s[depth[b]].erase(tin[b]);
    };
    if (D == n - 1) {
        vector<int> o[2];
        for (int i = 0; i < n; ++i) {
            o[depth[i] & 1].push_back(i);
        }
        while (!o[0].empty() && !o[1].empty()) {
            match(o[0].back(), o[1].back());
            o[0].pop_back(), o[1].pop_back();
        }
    } else {
        for (int T = D; T >= 1; T -= 2) {
            for (int x : ord_) {
                for (int dx = 0; dx <= T; dx += 2) {
                    if (depth[x] + dx >= n || s[depth[x] + dx].empty()) {
                        continue;
                    }
                    int dy = T - dx;
                    if (depth[x] + dy >= n || s[depth[x] + dy].empty()) {
                        continue;
                    }
                    auto ix = s[depth[x] + dx].lower_bound(tin[x]);
                    auto iy = s[depth[x] + dy].lower_bound(tin[x]);
                    while (ix != s[depth[x] + dx].end() && iy != s[depth[x] + dy].end() & *ix < tout[x] && *iy < tout[x]) {
                        int a = ord[*ix];
                        int b = ord[*iy];
                        ++ix, ++iy;
                        match(a, b);
                    }
                }
            }
        }
    }
    cout << pairs.size() << '\n';
    for (auto [x, y] : pairs) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}