#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
vector<pair<int, int>> tree;
vector<int> null;
 
void push(int v, int l, int r) {
    if (l >= r) return;
    if (!null[v]) return;
    tree[v] = {0, 0};
    null[v] = 0;
    if (l + 1 < r) {
        null[2 * v + 1] = 1;
        null[2 * v + 2] = 1;
    }
}
 
void change(int v, int l, int r, int i, int x) {
    push(v, l, r);
    if ((l >= r) || (l > i) || (r <= i)) return;
    if (l + 1 == r) {
        tree[v].first += x;
        tree[v].second += x * l;
        return;
    }
    int m = (l + r) / 2;
    change(2 * v + 1, l, m, i, x);
    change(2 * v + 2, m, r, i, x);
    tree[v].first = tree[2 * v + 1].first + tree[2 * v + 2].first;
    tree[v].second = tree[2 * v + 1].second + tree[2 * v + 2].second;
}
 
pair<int, int> req(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if ((l >= r) || (l >= qr) || (r <= ql)) return {0, 0};
    if ((ql <= l) && (r <= qr)) {
        return tree[v];
    }
    int m = (l + r) / 2;
    pair<int, int> res;
    auto left = req(2 * v + 1, l, m, ql, qr);
    auto right = req(2 * v + 2, m, r, ql, qr);
    res.first = left.first + right.first;
    res.second = left.second + right.second;
    return res;
}
 
void zero(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if ((l >= r) || (l >= qr) || (r <= ql)) return;
    if ((ql <= l) && (r <= qr)) {
        null[v] = 1;
        return;
    }
    int m = (l + r) / 2;
    zero(2 * v + 1, l, m, ql, qr);
    zero(2 * v + 2, m, r, ql, qr);
    tree[v].first = tree[2 * v + 1].first + tree[2 * v + 2].first;
    tree[v].second = tree[2 * v + 1].second + tree[2 * v + 2].second;
}
 
int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    tree.resize(4 * (m + 1), {0, 0});
    null.resize(4 * (m + 1), 0);
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            a[i][j] = s[j] - '0';
        }
    }
    vector<vector<int>> pr(n, vector<int>(m, 0));
    pr[0][0] = a[0][0];
    for (int i = 1; i < n; ++i) {
        pr[i][0] = a[i][0] + pr[i - 1][0];
    }
    for (int j = 1; j < m; ++j) {
        pr[0][j] = a[0][j] + pr[0][j - 1];
    }
    vector<vector<int>> ones(n, vector<int>(m, 0));
    for (int i = n - 1; i > -1; --i) {
        int cur = 0;
        for (int j = m - 1; j > -1; --j) {
            cur += a[i][j];
            cur *= a[i][j];
            ones[i][j] = cur;
        }
    }
    int ans = 0;
    int N = (m + 1);
    for (int j = 0; j < m; ++j) {
        int c = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] == 0) {
                c = 0;
            }
            else {
                if (!c) {
                    c = 1;
                    zero(0, 0, N, 0, N);
                    change(0, 0, N, ones[i][j], 1);
                    ans = max(ans, ones[i][j]);
                    continue;
                }
                int sl = req(0, 0, N, ones[i][j] + 1, m + 1).first;
                zero(0, 0, N, ones[i][j] + 1, m + 1);
                change(0, 0, N, ones[i][j], 1 + sl);
                ans = max(ans, req(0, 0, N, 0, N).second);
            }
        }
    }
    cout << ans << "\n";
    return 0;
}