#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define forn(i, n) for(decltype(n) i= 0; i < n; i++)
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n;
    cin >> n;
    vector<ll> target(n);
    forn(i, n) cin >> target[i];
    sort(all(target));

    ll x0, d;
    cin >> x0 >> d;

    forn(i, n) target[i] -= x0;
    x0 = 0;

    vector<int> pts1, pts2;
    forn(i, n) {
        if (target[i] < 0) pts1.emplace_back(-target[i]);
        else pts2.emplace_back(target[i]);
    }

    int szl = pts1.size(), szr = pts2.size();
    vector<ll> pl(szl + 1), pr(szr + 1);
    vector<__int128> p2l(szr + 1), p2r(szr + 1);
    forn(i, szl) pl[i + 1] = pl[i] + pts1[i], p2l[i + 1] = p2l[i] + 1ll * pts1[i] * pts1[i];
    forn(i, szr) pr[i + 1] = pr[i] + pts2[i], p2r[i + 1] = p2r[i] + 1ll * pts2[i] * pts2[i];

    auto getr = [&](__int128 l, __int128 r, __int128 x1) -> __int128 {
        return (r - l + 1) * x1 * x1 - 2 * x1 * (pr[r + 1] - pr[l]) + p2r[r + 1] - p2r[l];
    };

    auto getl = [&](__int128 l, __int128 r, __int128 x1) -> __int128 {
        return (r - l + 1) * x1 * x1 - 2 * x1 * (pl[r + 1] - pl[l]) + p2l[r + 1] - p2l[l];
    };


    vector<ll> best_pl(szl), best_pr(szr);
    forn(i, szl) {
        best_pl[i] = (pts1[i] - x0) / d * d;
        if (abs(best_pl[i] - pts1[i]) > abs(best_pl[i] - d - pts1[i])) best_pl[i] -= d;
        if (abs(best_pl[i] - pts1[i]) > abs(best_pl[i] + d - pts1[i])) best_pl[i] += d;
    }
    forn(i, szr) {
        best_pr[i] = (pts2[i] - x0) / d * d;
        if (abs(best_pr[i] - pts2[i]) > abs(best_pr[i] - d - pts2[i])) best_pr[i] -= d;
        if (abs(best_pr[i] - pts2[i]) > abs(best_pr[i] + d - pts2[i])) best_pr[i] += d;
    }

    vector<__int128> pref_bestl(szl + 1), pref_bestr(szr + 1);
    forn(i, szl) pref_bestl[i + 1] = pref_bestl[i] + 1ll * (pts1[i] - best_pl[i]) * (pts1[i] - best_pl[i]);
    forn(i, szr) pref_bestr[i + 1] = pref_bestr[i] + 1ll * (pts2[i] - best_pr[i]) * (pts2[i] - best_pr[i]);

    int m;
    cin >> m;
    vector<pair<int, int> > q(m);
    forn(i, m) cin >> q[i].first, q[i].second = i;
    sort(rall(q));

    vector<ll> ans(m, LLONG_MAX);

    for (auto &[t, id]: q) {
        __int128 cur = 0;
        int tid;
        ll l, r;

        if (pts2.size()) {
            l = -1, r = 1e9;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                int tid1 = upper_bound(all(best_pr), mid * d) - best_pr.begin();
                int tid2 = upper_bound(all(best_pr), (mid + 1) * d) - best_pr.begin();
                if (t * mid + pref_bestr[tid1] + getr(tid1, n - 1, x0 + mid * d) > t * (mid + 1) + pref_bestr[tid2] +
                    getr(tid2, n - 1, x0 + (mid + 1) * d)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            tid = upper_bound(all(best_pr), x0 + r * d) - best_pr.begin();
            cur += t * r + pref_bestr[tid] + getr(tid, n - 1, x0 + r * d);
        }

        t *= 2;
        if (pts1.size()) {
            l = -1, r = 1e9;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                int tid1 = upper_bound(all(best_pl), mid * d) - best_pl.begin();
                int tid2 = upper_bound(all(best_pl), (mid + 1) * d) - best_pl.begin();
                if (t * mid + pref_bestl[tid1] + getl(tid1, n - 1, x0 + mid * d) > t * (mid + 1) + pref_bestl[tid2] +
                    getl(
                        tid2, n - 1, x0 + (mid + 1) * d)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            tid = upper_bound(all(best_pl), x0 + r * d) - best_pl.begin();
            cur += t * r + pref_bestl[tid] + getl(tid, n - 1, x0 + r * d);
        }

        ans[id] = min(ans[id], (ll) cur);

        t /= 2, cur = 0;
        if (pts1.size()) {
            l = -1, r = 1e9;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                int tid1 = upper_bound(all(best_pl), mid * d) - best_pl.begin();
                int tid2 = upper_bound(all(best_pl), (mid + 1) * d) - best_pl.begin();
                if (t * mid + pref_bestl[tid1] + getl(tid1, n - 1, x0 + mid * d) > t * (mid + 1) + pref_bestl[tid2] +
                    getl(
                        tid2, n - 1, x0 + (mid + 1) * d)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            tid = upper_bound(all(best_pl), x0 + r * d) - best_pl.begin();
            cur += t * r + pref_bestl[tid] + getl(tid, n - 1, x0 + r * d);
        }

        t *= 2;
        if (pts2.size()) {
            l = -1, r = 1e9;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                int tid1 = upper_bound(all(best_pr), mid * d) - best_pr.begin();
                int tid2 = upper_bound(all(best_pr), (mid + 1) * d) - best_pr.begin();
                if (t * mid + pref_bestr[tid1] + getr(tid1, n - 1, x0 + mid * d) > t * (mid + 1) + pref_bestr[tid2] +
                    getr(
                        tid2, n - 1, x0 + (mid + 1) * d)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            tid = upper_bound(all(best_pr), x0 + r * d) - best_pr.begin();
            cur += t * r + pref_bestr[tid] + getr(tid, n - 1, x0 + r * d);
        }

        ans[id] = min(ans[id], (ll) cur);
    }

    forn(i, m) cout << ans[i] << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:/work/IO/in.txt", "r", stdin);
    freopen("C:/work/IO/out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();
}
