#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			cin >> c;
			a[i][j] = c - '0';
		}
	}
	vector<vector<int>> cnt(n, vector<int>(m, 0));
	for (int i = 0; i < n; i++) {
		cnt[i][m - 1] = a[i][m - 1];
		for (int j = m - 2; j >= 0; j--) {
			if (a[i][j] == 1) {
				cnt[i][j] = cnt[i][j + 1] + 1;
			}
		}
	}
	vector<vector<pair<int, int>>> dp(n, vector<pair<int, int>>(m, { 0, 0 }));
	if (a[n - 1][m - 1] == 1) {
		dp[n - 1][m - 1] = { 1, 1 };
	}
	for (int j = 0; j < m; j++) {
		dp[n - 1][j] = { cnt[n - 1][j], cnt[n - 1][j] };
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (a[i][j] == 1) {
				dp[i][j] = { dp[i + 1][j].first + min(cnt[i][j], dp[i + 1][j].second), min(cnt[i][j], dp[i + 1][j].second) };
				if (dp[i][j].first <= cnt[i][j]) {
					dp[i][j] = { cnt[i][j], cnt[i][j] };
				}
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ans = max(ans, dp[i][j].first);
		}
	}
	cout << ans;
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}