#include <iostream>
#include <vector>
#include <algorithm>
#include <array>

using namespace std;
using ll = long long;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			cin >> c;
			a[i][j] = c - '0';
		}
	}
	vector<vector<int>> cnt(n + 1, vector<int>(m + 1, 0));
	for (int j = 0; j < m; j++) {
		cnt[0][j] = a[0][j];
	}
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (a[i][j] == 1) {
				cnt[i][j] = cnt[i - 1][j] + 1;
			}
		}
	}
	int ans = 0;
	vector<int> l(m);
	vector<int> dp(m + 1, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			l[j] = m;
			dp[j] = 0;
		}
		vector<int> s;
		for (int j = m - 1; j >= 0; j--) {
			while (s.size() > 0 && cnt[i][j] < cnt[i][s.back()]) {
				s.pop_back();
			}
			if (s.size() > 0) {
				l[j] = s.back();
			}
			s.push_back(j);
		}
		for (int j = m - 1; j >= 0; j--) {
			if (a[i][j] == 1) {
				dp[j] = dp[l[j]] + cnt[i][j] + (l[j] - j - 1) * cnt[i][l[j]];
				ans = max(ans, dp[j]);
			}
		}
	}
	cout << ans;
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}