#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <random>

using namespace std;
using ll = long long;

mt19937 rnd(425269);

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

int solve1(int n, int m, vector<vector<int>> a) {
	vector<vector<int>> cnt(n + 1, vector<int>(m + 1, 0));
	for (int j = 0; j < m; j++) {
		cnt[0][j] = a[0][j];
	}
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (a[i][j] == 1) {
				cnt[i][j] = cnt[i - 1][j] + 1;
			}
		}
	}
	int ans = 0;
	vector<int> l(m);
	vector<int> dp(m + 1, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			l[j] = m;
			dp[j] = 0;
		}
		vector<int> s;
		for (int j = m - 1; j >= 0; j--) {
			while (s.size() > 0 && cnt[i][j] < cnt[i][s.back()]) {
				s.pop_back();
			}
			if (s.size() > 0) {
				l[j] = s.back();
			}
			s.push_back(j);
		}

		for (int j = m - 1; j >= 0; j--) {
			if (a[i][j] == 1) {
				dp[j] = dp[l[j]] + (l[j] - j) * cnt[i][j];
				ans = max(ans, dp[j]);
			}
		}
	}
	return ans;
}

int solve2(int n, int m, vector<vector<int>> a) {
	vector<vector<vector<int>>> dp(n, vector<vector<int>>(m, vector<int>(n, 0)));
	for (int i = 0; i < n; i++) {
		int p = i;
		while (p >= 0 && a[p][m - 1] == 1) {
			dp[i][m - 1][p] = i - p + 1;
			p--;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = m - 2; j >= 0; j--) {
			int p = i;
			int mx = 0;
			while (p >= 0 && a[p][j] == 1) {
				mx = max(mx, dp[i][j + 1][p]);
				dp[i][j][p] = mx + i - p + 1;
				p--;
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int h = 0; h <= i; h++) {
				ans = max(ans, dp[i][j][h]);
			}
		}
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	cout << solve1(n, m, a);
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}