#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <random>

using namespace std;
using ll = long long;

mt19937 rnd(425269);

const int INF = 1e9 + 239;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 5e5 + 239;
vector<int> tree(MAXN * 4, INF);

void update(int v, int l, int r, int p, int val) {
	if (l == r) {
		tree[v] = val;
	}
	else {
		int m = (l + r) / 2;
		if (p <= m) {
			update(2 * v, l, m, p, val);
		}
		else {
			update(2 * v + 1, m + 1, r, p, val);
		}
		tree[v] = min(tree[2 * v], tree[2 * v + 1]);
	}
}

int get(int v, int l, int r, int lq, int rq) {
	if (lq == l && rq == r) {
		return tree[v];
	}
	if (lq > r || rq < l) {
		return INF;
	}
	int m = (l + r) / 2;
	return min(get(2 * v, l, m, lq, min(m, rq)), get(2 * v + 1, m + 1, r, max(m + 1, lq), rq));
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<array<int, 3>> a(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i][2] >> a[i][1] >> a[i][0];
	}
	sort(a.begin(), a.end());
	vector<bool> dp(n + 1, false);
	dp[0] = true;
	for (int i = 0; i < k; i++) {
		int r = a[i][0];
		int m = a[i][1];
		int l = a[i][2];
		if (dp[l - 1] || get(1, 0, n, l, r) < l || (l != m && get(1, 0, n, l, m - 1) != INF)) {
			update(1, 0, n, r, m);
			dp[r] = true;
		}
	}
	if (dp[n]) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
	for (int i = 0; i <= 4 * (n + 239); i++) {
		tree[i] = INF;
	}
}

int main() {
	fastw();
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}