#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <random>

using namespace std;
using ll = long long;

mt19937 rnd(425269);

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

bool solve2(int n, int k, vector<array<int, 3>> a) {
	vector<vector<int>> p(n + 1);
	for (int i = 0; i < k; i++) {
		p[a[i][2]].push_back(i);
	}
	vector<bool> dp(n + 1, false);
	dp[0] = true;
	for (int i = 1; i <= n; i++) {
		for (auto el : p[i]) {
			int l = a[el][0];
			int m = a[el][1];
			int r = a[el][2];
			for (int j = l - 1; j < m; j++) {
				if (dp[j]) {
					dp[r] = true;
				}
			}
		}
	}
	return dp[n];
}
bool solve1(int n, int k, vector<array<int, 3>> a) {
	vector<int> p(k);
	for (int i = 0; i < k; i++) {
		p[i] = i;
	}
	do {
		vector<int> ok(n + 1, false);
		for (int i = 0; i < k; i++) {
			int l = a[p[i]][0];
			int r = a[p[i]][1];
			int m = a[p[i]][2];
			if (!ok[m]) {
				for (int j = l; j <= r; j++) {
					ok[j] = true;
				}
			}
		}
		bool fl = true;
		for (int j = 1; j <= n; j++) {
			if (!ok[j]) {
				fl = false;
			}
		}
		if (fl) {
			return true;
		}
	} while (next_permutation(p.begin(), p.end()));
	return false;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<array<int, 3>> a(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i][0] >> a[i][1] >> a[i][2];
	}
	if (solve2(n, k, a)) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

int main() {
	fastw();
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}
