#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <random>

using namespace std;
using ll = long long;
#define int ll

mt19937 rnd(425269);

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 5e5 + 239;
vector<vector<int>> g(MAXN);
vector<pair<int, int>> ans;
vector<bool> used(MAXN);

void dfs(int v, int p) {
	for (int u : g[v]) {
		if (u != p) {
			dfs(u, v);
			if (!used[v] && !used[u]) {
				ans.push_back({ v, u });
				used[v] = true;
				used[u] = true;
			}
		}
	}
}

void solve() {
	int n;
	cin >> n;
	int d;
	cin >> d;
	for (int i = 1; i < n; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(1, 1);
	cout << ans.size() << '\n';
	for (auto el : ans) {
		cout << el.first << ' ' << el.second << '\n';
	}
}

signed main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}