#include <bits/stdc++.h>
//#define int long long
#define F first
#define S second
using namespace std;
const int lgN = 20;
int n, d;
vector<vector<int> > g;
vector<int> depth;
vector<int> jump[lgN];

void dfs(int v, int p) {
    jump[0][v] = p;
    for (int i = 1; i < lgN; ++i) {
        jump[i][v] = jump[i - 1][jump[i - 1][v]];
    }
    for (int i: g[v]) {
        if (i == p) {
            continue;
        }
        depth[i] = depth[v] + 1;
        dfs(i, v);
    }
}

int getlca(int v, int u) {
    if (depth[v] > depth[u]) {
        swap(v, u);
    }
    for (int i = lgN - 1; i >= 0; --i) {
        if (depth[jump[i][u]] >= depth[v]) {
            u = jump[i][u];
        }
    }
    if (v == u) {
        return v;
    }
    for (int i = lgN - 1; i >= 0; --i) {
        if (jump[i][v] != jump[i][u]) {
            v = jump[i][v];
            u = jump[i][u];
        }
    }
    return jump[0][v];
}

int getdist(int v, int u) {
    int lc = getlca(v, u);
    return depth[v] + depth[u] - 2 * depth[lc];
}

vector<vector<int> > nor;
vector<int> col;
bool e = 1;

void check(int v, int c) {
    if (!e) {
        return;
    }
    col[v] = c;
    for (int i: g[v]) {
        if (col[i] != 3 - c && col[i] != 0) {
            e = 0;
            break;
        }
        if (!col[i]) {
            check(i, 3 - c);
        }
    }
}

vector<vector<int> > toget;
vector<int> mt;
vector<bool> used;

bool try_kuhn(int v) {
    if (used[v]) {
        return 0;
    }
    used[v] = 1;
    for (int i: toget[v]) {
        if (mt[i] == -1 || try_kuhn(mt[i])) {
            mt[i] = v;
            return 1;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d;
    g.resize(n);
    depth.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < lgN; ++i) {
        jump[i].resize(n);
    }
    dfs(0, 0);
    nor.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int di = getdist(i, j);
            if (di <= d && di & 1) {
                nor[i].push_back(j);
                nor[j].push_back(i);
            }
        }
    }
    col.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!col[i]) {
            check(i, 1);
        }
    }
    toget.resize(n);
    for (int i = 0; i < n; ++i) {
        if (col[i] == 1) {
            continue;
        }
        for (int j: g[i]) {
            toget[i].push_back(j);
        }
    }
    mt.resize(n, -1);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        used.assign(n, 0);
        ans += try_kuhn(i);
    }
    cout << ans;
    return 0;
}
