#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

struct Fast {
    struct seg {
        ll l, m, r;

        seg() = default;

        seg(ll l, ll m, ll r) : l(l), m(m), r(r) {}
    };

    vector <ll> t;

    void update(ll v, ll l, ll r, ll p, ll d) {
        if (r - l < 2) {
            t[v] = min(t[v], d);
            return;
        }
        ll m = (l + r) / 2;
        if (p < m) {
            update(v * 2 + 1, l, m, p, d);
        } else {
            update(v * 2 + 2, m, r, p, d);
        }
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (r <= ql || qr <= l) {
            return mod;
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }
        ll m = (l + r) / 2;
        return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
    }

    void main() {
        ll n, k;
        cin >> k >> n;
        vector<seg> a(n);
        for (auto &[l, m, r]: a) {
            cin >> l >> m >> r;
            l--;
            m--;
            r--;
        }
        sort(a.begin(), a.end(), [&](auto f, auto s) {
            return tie(f.m, f.l, f.r) < tie(s.m, s.l, s.r);
        });
        vector<bool> d(n);
        t.resize(k * 4, mod);
        for (ll i = 0; i < n; i++) {
            if (a[i].l == 0) {
                d[i] = true;
                update(0, 0, k, a[i].r, a[i].m);
            }
        }
        for (ll i = 0; i < n; i++) {
            ll x = get(0, 0, k, max(0ll, a[i].l - 1), a[i].r + 1);
            if (x < a[i].l) {
                d[i] = true;
                update(0, 0, k, a[i].r, a[i].m);
                continue;
            }
            x = get(0, 0, k, max(0ll, a[i].l - 1), a[i].m);
            if (x < mod) {
                d[i] = true;
                update(0, 0, k, a[i].r, a[i].m);
            }
        }
        for (ll i = 0; i < n; i++) {
            if (a[i].r == k - 1 && d[i]) {
                cout << "YES";
                return;
            }
        }
        cout << "NO";
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll testC;
    cin >> testC;
    while (testC--) {
        Fast().main();
        cout << '\n';
    }
    return 0;
}