#include<bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int inf = 2e9;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}


template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << "\n";
    }
    return out;
}

struct segment_tree {
    int n;
    vector<int> tree;

    segment_tree(int n) : n(n) {
        tree.resize(4 * n, inf);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            tree[v] = val;
        } else {
            int m = (r + l) / 2;
            if (pos < m) {
                update(2 * v, l, m, pos, val);
            } else {
                update(2 * v + 1, m, r, pos, val);
            }
            tree[v] = min(tree[2 * v], tree[2 * v + 1]);
        }
    }

    int query(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) {
            return inf;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        int m = (r + l) / 2;
        return min(query(2 * v, l, m, ql, qr), query(2 * v + 1, m, r, ql, qr));
    }
};

struct segment {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> num_seg(n);
    vector<segment> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        num_seg[a[i].m].push_back(i);
    }
    vector<int> dp(n, inf);
    segment_tree st(n);

    for (int i = 0; i < n; ++i) {
        for (auto j : num_seg[i]) {
            if (a[j].l == 0) {
                dp[a[j].r] = min(dp[a[j].r], a[j].m);
                st.update(1, 0, n, a[j].r, min(dp[a[j].r], a[j].m));
            }
            if (st.query(1, 0, n, max(0ll, a[j].l - 1), a[j].m) < inf) {
                dp[a[j].r] = min(dp[a[j].r], a[j].m);
                st.update(1, 0, n, a[j].r, min(dp[a[j].r], a[j].m));
            }
            if (st.query(1, 0, n, a[j].m, a[j].r) < a[j].l) {
                dp[a[j].r] = min(dp[a[j].r], a[j].m);
                st.update(1, 0, n, a[j].r, min(dp[a[j].r], a[j].m));
            }


            // for (int p = max(0ll, a[j].l - 1); p < a[j].m; ++p) {
            //     if (dp[p] != inf) {
            //         dp[a[j].r] = min(dp[a[j].r], a[j].m);
            //         break;
            //     }
            // }
            // for (int p = a[j].m; p < a[j].r; ++p) {
            //     if (dp[p] != inf && dp[p] < a[j].l) {
            //         dp[a[j].r] = min(dp[a[j].r], a[j].m);
            //         break;
            //     }
            // }
            // if (a[j].l == 0) {
            //     dp[a[j].r] = min(dp[a[j].r], a[j].m);
            // }
        }
    }
    //cout << dp << "\n";
    cout << (dp[n - 1] != inf ? "YES" : "NO") << "\n";
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}