#include<bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int inf = 2e9;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}


template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << i << ": " << a[i] << "\n";
    }
    return out;
}

struct segment {
    int l, m, r;
};

bool can(segment a, segment b) {
    return a.r < b.m;
}

bool check(segment a, segment b) {
    return can(a, b) || can(b, a);
}

vector<vector<int>> g;

bool cycle;
vector<int> used;

void dfs(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (used[u] == 1) {
            cycle = true;
            return;
        }
        if (used[u] == 0) {
            dfs(u);
        }
    }
    used[v] = 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> num_seg(n);
    vector<segment> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        num_seg[a[i].m].push_back(i);
    }

    g = {};
    g.resize(k);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i != j && a[j].l <= a[i].m && a[i].m <= a[j].r) {
                g[i].push_back(j);
            }
        }
    }
    cycle = false;
    used.assign(n, 0);

    for (int v = 0; v < k; ++v) {
        if (!used[v]){dfs(v);}
    }

    cout << (cycle ? "NO" : "YES") << "\n";
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}