#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include<bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int INF = 9e18;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}


template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << "\n";
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    cin >> x;
    sort(all(x));

    vector<__int128> suf_sqr(n + 1), suf_2(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf_sqr[i] = suf_sqr[i + 1] + (__int128)x[i] * x[i];
        suf_2[i] = suf_2[i + 1] - 2 * x[i];
    }

    int x0, d;
    cin >> x0 >> d;


    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        auto calc = [&](int k) {
            int x_cur = k * d;
            auto pos = upper_bound(all(x), k * d) - x.begin();
            __int128 res = (__int128)(n - pos) * x_cur * x_cur + suf_2[pos] * x_cur + suf_sqr[pos];
            return res + k * t;
        };

        int l = 0, r = 1e9;
        while (r - l > 2) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (calc(m1) < calc(m2)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        //cout << l << " " << r << "\n";


        __int128 ans = (__int128)INF * INF;
        for (int i = l; i <= r; ++i) {
            ans = min(ans, calc(i));
        }
        cout << (int)ans << "\n";
    }

}

/*
3
4 0 7
0 1
7
0
1
2
3
4
23
25

3
4 0 7
2 3
1 1


3
7
10
12
13
32
33
4
30 239 57 179
0 7
5
1
10
15
100
100000
49
355
525
3378
93311
4
100 2 101 666
9 10
5
777
1
2
15
10
49597
91
159
1043
703
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}