#include<bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int inf = 2e9;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}


template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << i << ": " << a[i] << "\n";
    }
    return out;
}

struct segment {
    int l, m, r;
};

bool can(segment a, segment b) {
    return a.r < b.m;
}

bool check(segment a, segment b) {
    return can(a, b) || can(b, a);
}

vector<vector<int>> g;
vector<int> depth;

void dfs(int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            depth[u] = (depth[v] + 1) % 2;
            dfs(u, v);
        }
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs(0, -1);

    vector<int> d0, d1;
    for (int v = 0; v < n; ++v) {
        if (depth[v] % 2) {
            d1.push_back(v);
        } else {
            d0.push_back(v);
        }
    }

    cout << min(d0.size(), d1.size()) << "\n";
    for (int i = 0; i < min(d0.size(), d1.size()); ++i) {
        cout << d0[i] + 1 << " " << d1[i] + 1 << "\n";
    }
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}