//#define __GLIBCXX_DEBUG 1
#include<bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()

const int inf = 2e9;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (int i = 0; i < a.size(); ++i) {
        in >> a[i];
    }
    return in;
}


template<typename T>
ostream& operator << (ostream& out, vector<T> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << a[i] << " ";
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> a) {
    for (int i = 0; i < a.size(); ++i) {
        out << i << ": " << a[i] << "\n";
    }
    return out;
}

vector<vector<int>> g, g2;
vector<vector<int>> dist;
vector<int> depth;

void dfs1(int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            depth[u] = (depth[v] + 1) % 2;
            dfs1(u, v);
        }
    }
}

void dfs2(int v, int p, int start) {
    for (int u : g[v]) {
        if (u != p) {
            dist[start][u] = dist[start][v] + 1;
            dfs2(u, v, start);
        }
    }
}

vector<int> mt;
vector<bool> used;

bool try_kuhn(int v) {
    if (used[v]) {
        return false;
    }
    used[v] = true;

    for (int u : g2[v]) {
        if (mt[u] == -1 || try_kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    int n, d;
    cin >> n >> d;
    g.resize(n);
    g2.resize(n);
    depth.resize(n);
    dist.resize(n, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs1(0, -1);

    for (int i = 0; i < n; ++i) {
        dfs2(i, -1, i);
    }

    for (int v = 0; v < n; ++v) {
        if (depth[v] == 0) {
            for (int u = 0; u < n; ++u) {
                if (depth[u] == 1) {
                    if (dist[v][u] <= d) {
                        g2[v].push_back(u);
                    }
                }
            }
        }
    }

    mt.resize(n, -1);
    for (int v = 0; v < n; ++v) {
        if (depth[v] == 0) {
            used.assign(n, false);
            try_kuhn(v);
        }
    }

    int ans = 0;
    for (int i : mt) {
        if (i != -1) {
            ans++;
        }
    }

    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        if (mt[i] != -1) {
            cout << i + 1 << " " << mt[i] + 1 << "\n";
        }
    }

}

/*
8
7
1 2
2 3
3 4
3 5
1 6
6 7
3 8
3
2 7
6 3
4 1
11
3
1 2
2 3
3 4
3 5
3 6
3 7
1 8
8 9
8 10
8 11
4
3 7
11 8
10 2
1 6

*/

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}