#include "bits/stdc++.h"
using namespace std;
#define int int64_t
const int INF = 1e18;

struct Segtree {
    vector<int> tree;

    void init(int n) {
        tree.assign(2 * n - 1, INF);
    }

    void set(int x, int lx, int rx, int i, int v) {
        if (lx == rx) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) >> 1;
        if (i <= m) {
            set(x + 1, lx, m, i, v);
        } else {
            set(x + 2 * (m - lx + 1), m + 1, rx, i, v);
        }
        tree[x] = min(tree[x + 1], tree[x + 2 * (m - lx + 1)]);
    }

    int get(int x, int lx, int rx, int l, int r) {
        if (l > r) return INF;
        if (l == lx && r == rx) return tree[x];
        int m = (lx + rx) >> 1;
        int s1 = get(x + 1, lx, m, l, min(m, r));
        int s2 = get(x + 2 * (m - lx + 1), m + 1, rx, max(m + 1, l), r);
        return min(s1, s2);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3> > q(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        q[i] = {l, m, r};
    }
    Segtree seg;
    seg.init(n + 2);
    sort(q.begin(), q.end(), [](auto &l, auto &r) {
        if (l[1] != r[1]) return l[1] > r[1];
        return l[0] > r[0];
    });
    int N = n + 2;
    int last = INT_MAX;
    vector<int> occ(n + 2);
    for (auto [l, m, r]: q) {
        if (r < last && m < last) {
            last = m;
            occ[l]++;
            occ[r + 1]--;
        }
    }
    int now = 0;
    for (int i = 1; i <= n; ++i) {
        now += occ[i];
        if (now == 0) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main() {
#ifdef SEREGA
    freopen("/home/roi/work/CLionProject/input.txt", "r", stdin);
    freopen("/home/roi/work/CLionProject/output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
}
