#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;

struct line {
	int l, m, r;
	line() {}
};

struct event {
	int type, cord, ind;
	event() {}
	event(int type, int cord, int ind) : type(type), cord(cord), ind(ind) {}
};

bool comp(const event& v1, const event& v2) {
	if (v1.cord != v2.cord) return v1.cord < v2.cord;
	if (v1.type != v2.type) return v1.type < v2.type;
	return v1.ind < v2.ind;
}

inline void solve() {
	int n; cin >> n;
	int k; cin >> k;
	
	set<pair<int, pair<int, int>>> all_lines;
	for (int i = 0; i < k; i++) {
		int a, b, c; cin >> a >> b >> c;
		all_lines.insert(make_pair(a, make_pair(b, c)));
	}
	k = all_lines.size();
	vector<line> arr(k);
	int index = 0;
	for (auto x : all_lines) {
		arr[index].l = x.first;
		arr[index].m = x.second.first;
		arr[index].r = x.second.second;
		arr[index].l--;
		arr[index].m--;
		index++;
	}

	vector<event> evs;

	for (int i = 0; i < k; i++) {
		evs.emplace_back(event(0, arr[i].l, i));
		evs.emplace_back(event(1, arr[i].m, i));
		evs.emplace_back(event(2, arr[i].r, i));
	}
	sort(evs.begin(), evs.end(), comp);

	int cur_ind = 0;
	int val = 0;
	int m_val = 0;

	set<int> all;
	set<int> inds;
	for (int ind = 0; ind < n; ind++) {
		while (cur_ind != evs.size() && evs[cur_ind].cord == ind) {
			if (evs[cur_ind].type == 0) {
				val++;
				inds.insert(evs[cur_ind].ind);
			}
			else if (evs[cur_ind].type == 1) {
				m_val++;
			}
			else {
				m_val--;
				val--;
				inds.erase(evs[cur_ind].ind);
			}
			cur_ind++;
		}

		if (val == 0) {
			cout << "NO" << '\n';
			return;
		}

		if (val == 1) {
			all.insert(*inds.begin());
		}
	}

	evs.clear();

	for (auto i : all) {
		evs.emplace_back(event(0, arr[i].l, i));
		evs.emplace_back(event(1, arr[i].m, i));
		evs.emplace_back(event(2, arr[i].r, i));
	}
	sort(evs.begin(), evs.end(), comp);

	cur_ind = 0;
	val = 0;
	set<int> minds;
	for (int ind = 0; ind < n; ind++) {
		while (cur_ind != evs.size() && evs[cur_ind].cord == ind) {
			if (evs[cur_ind].type == 0) {
				val++;
				minds.clear();
			}
			else if (evs[cur_ind].type == 1) {
				minds.insert(evs[cur_ind].ind);
			}
			else {
				if (minds.count(evs[cur_ind].ind)) {
					minds.erase(evs[cur_ind].ind);
				}
				val--;
			}
			cur_ind++;
		}

		if (minds.size() > 1) {
			cout << "NO" << '\n';
			return;
		}
	}

	cout << "YES" << '\n';
	return;
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	///*
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	//*/

	int t; cin >> t;
	while (t--) solve();
}