#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;

struct seg_tree_max {
	vector<int> tree;
	seg_tree_max(int n) {
		tree.assign(4 * n, -1);
	}

	void upd(int v, int l, int r, int ind, int val) {
		if (r - l == 1) {
			tree[v] = max(tree[v], val);
			return;
		}

		int mid = (l + r) / 2;
		if (mid > ind) upd(v * 2 + 1, l, mid, ind, val);
		else upd(v * 2 + 2, mid, r, ind, val);
		tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
	}

	int ask(int v, int l, int r, int ql, int qr) {
		if (l >= qr || ql >= r) return -1;
		if (ql <= l && r <= qr) return tree[v];
		int mid = (l + r) / 2;
		return max(ask(v * 2 + 1, l, mid, ql, qr), ask(v * 2 + 2, mid, r, ql, qr));
	}
};

struct line {
	int l, m, r;
	line() {}
};


bool comp(const line& v1, const line& v2) {
	if (v1.r != v2.r) return v1.r < v2.r;
	if (v1.l != v2.l) return v1.l < v2.l;
	return v1.m < v2.m;
}

void solve() {
	int n; cin >> n;
	int k; cin >> k;
	vector<int> dp(n + 1, 1e9); // dp[r] = min(m) to get r. r = 1...n
	seg_tree_max ms(n + 1); // max r : dp[r] = m
	seg_tree_max dps(n + 1); // max dp[r]

	vector<line> arr(k);

	for (int i = 0; i < k; i++) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
		arr[i].l--; arr[i].m--;
	}

	sort(arr.begin(), arr.end(), comp);

	bool flag = false;

	for (int i = 0; i < k; i++) {
		//recount dp[r]
		if (arr[i].l == 0) flag = true;
		if (!flag) continue;

		if (arr[i].l == 0) {
			dp[arr[i].r] = arr[i].m;
			dps.upd(0, 0, n + 1, arr[i].r, dp[arr[i].r]);
			ms.upd(0, 0, n + 1, dp[arr[i].r], arr[i].r);
			continue;
		}

		//recount dp[r];

		if (dps.ask(0, 0, n + 1, arr[i].l, arr[i].m + 1) != -1) {
			dp[arr[i].r] = min(dp[arr[i].r], arr[i].m);
		}

		if (ms.ask(0, 0, n + 1, 0, arr[i].l) != -1) {
			dp[arr[i].r] = min(dp[arr[i].r], arr[i].m);
		}


		dps.upd(0, 0, n + 1, arr[i].r, dp[arr[i].r]);
		ms.upd(0, 0, n + 1, dp[arr[i].r], arr[i].r);
	}
	if (dp[n] == 1e9) {
		cout << "NO" << '\n';
	}
	else {
		cout << "YES" << '\n';
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	///*
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	//*/

	int t; cin >> t;
	while (t--) solve();
}