#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;

vector<vector<int>> g, dist;
vector<int> used;
vector<int> odd, even;
int root = 0;
void dfs(int v, int d = 0) {
	dist[root][v] = d;
	used[v] = 1;
	for (auto to : g[v]) {
		if (!used[to]) dfs(to, d + 1);
	}
}
int ans = 0;
vector<int> paired;
int n, d;
void rec(int v, int cnt = 0) {
	if (v == n) {
		ans = max(ans, cnt);
		return;
	}

	if (paired[v]) {
		rec(v + 1, cnt);
		return;
	}
	for (int i = 0; i < n; i++) {
		if (i == v) continue;
		if (paired[i]) continue;
		if (dist[v][i] % 2 == 0 || dist[v][i] > d) continue;
		paired[v] = i + 1;
		paired[i] = v + 1;
		rec(v + 1, cnt + 1);
		paired[v] = 0;
		paired[i] = 0;
	}
	rec(v + 1, cnt);
}

void get_ans(int v, int cnt = 0) {
	if (v == n && ans == cnt) {
		cout << ans << '\n';
		for (int i = 0; i < n; i++) {
			if (paired[i]) {
				cout << i + 1 << ' ' << paired[i] << '\n';
				paired[paired[i] - 1] = 0;
				paired[i] = 0;
			}
		}
		exit(0);
		return;
	}

	if (v == n) return;

	if (paired[v]) {
		get_ans(v + 1, cnt);
		return;
	}
	for (int i = 0; i < n; i++) {
		if (i == v) continue;
		if (paired[i]) continue;
		if (dist[v][i] % 2 == 0 || dist[v][i] > d) continue;
		paired[v] = i + 1;
		paired[i] = v + 1;
		get_ans(v + 1, cnt + 1);
		paired[v] = 0;
		paired[i] = 0;
	}
	get_ans(v + 1, cnt);
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	///*
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	//*/

	cin >> n;
	cin >> d;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b; cin >> a >> b;
		a--; b--;
		g[a].emplace_back(b);
		g[b].emplace_back(a);
	}
	dist.resize(n);
	for (int i = 0; i < n; i++) {
		root = i;
		used.assign(n, 0);
		dist[i].resize(n);
		dfs(root);
	}
	paired.assign(n, 0);
	rec(0);
	paired.assign(n, 0);
	get_ans(0);
}