#include <iostream>
#include <vector>
#include <algorithm>
#include<cmath>
#include<string>
#include<iomanip>

using namespace std;
int max(int &a, int &b) {
    if (a > b) {
        return a;
    }
    return b;
}
int cnt = 0;
struct person {
    int l, r, m;
    person() = default;
    person(int l_,int m_, int r_):l(l_), m(m_), r(r_){};
};

bool cmp(person &a, person &b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

bool Cover(vector<person> &a, int n) {
    sort(a.begin(), a.end(), cmp);
    int need = 1;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i].l <= need && a[i].r >= need) {
            need = a[i].r + 1;
        }
    }
    if (need <= n) {
        return 0;
    }
    return 1;
}

void dfs(int v, vector<int> &used, vector<vector<int>> &g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u, used, g);
        }
        else if (used[u] == 1) {
            cnt = 1;
        }
    }
    used[v] =2;
}

signed main() {
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        cnt = 0;
        int n, k;
        cin >> n >> k;
        vector<person> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        if (!Cover(a, n)) {
            cout << "NO\n";
        }
        else {
            vector<vector<int>> g(k);
            for (int i = 0; i < k; ++i) {
                for (int j = 0; j < k; ++j) {
                    if (i != j) {
                        if (a[i].m >= a[j].l && a[i].m <= a[j].r) {
                            g[i].push_back(j);
                        }
                    }
                }
            }
            vector<int> used(k, 0);
            for (int i = 0; i < k; ++i) {
                if (used[i] == 0) {
                    dfs(i, used, g);
                }
            }
            if (cnt == 1) {
                cout << "NO\n";
            }
            else {
                cout << "YES\n";
            }
        }
    }
}