#include <iostream>
#include <vector>
#include <algorithm>
#include<set>
#include<string>
#include<iomanip>

using namespace std;
long long max(long long &a, long long &b) {
    if (a > b) {
        return a;
    }
    return b;
}
long long cnt = 0;
struct person {
    long long l, r, m;
    person() = default;
    person(long long l_,long long m_, long long r_):l(l_), m(m_), r(r_){};
};

bool cmp(person &a, person &b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

bool Cover(vector<person> &a, long long n, vector<long long> &del) {
    long long need = 1;
    for (long long i = 0; i < a.size(); ++i) {
        if (a[i].l <= need && a[i].r >= need && del[i] == 0) {
            need = a[i].r + 1;
        }
    }
    if (need <= n) {
        return 0;
    }
    return 1;
}

void dfs(long long v, vector<long long> &used, vector<vector<long long>> &g, vector<long long> &path, vector<long long> &deleted) {
    used[v] = 1;
    long long cnt1 = cnt;
    if (cnt1 == 0) {
        path.push_back(v);
    }
    for (auto u : g[v]) {
        if (deleted[u] == 0) {
            if (used[u] == 0) {
                dfs(u, used, g, path, deleted);
            }
            else if (used[u] == 1) {
                cnt = 1;
                path.push_back(u);
            }
        }
    }
    if (cnt == 0) {
        path.pop_back();
    }
    used[v] =2;
}

vector<long long> CalcUniqu(vector<person> &a, vector<long long> &deleted, long long n) {
    vector<long long> uni(a.size(), 0);
    vector<pair<pair<long long, long long>, long long>> events;
    for (long long i = 0; i < a.size(); ++i) {
        if (deleted[i] == 0) {
            events.push_back({{a[i].l, -1}, i});
            events.push_back({{a[i].r, 1}, i});

        }
    }
    sort(events.begin(), events.end());
    long long now_ = 1;
    long long open = 0;
    long long cur = 0;
    for (long long i = 1; i <= n; ++i) {
        long long last = 0;
        long long count = 0;
        for (long long j = 0; j < a.size(); ++j) {
            if (deleted[j] == 0 && a[j].l <= i && a[j].r >= i) {
                count++;
                last = j;
            }
        }
        if (count == 1) {
            uni[last] = 1;
        }
    }
    return uni;
}

signed main() {
    long long t;
    cin >> t;
    for (long long _ = 0; _ < t; ++_) {
        cnt = 0;
        long long n, k;
        cin >> n >> k;
        vector<person> a(k);
        for (long long i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        sort(a.begin(), a.end(), cmp);
        vector<long long> deleted(k, 0);
        if (!Cover(a, n, deleted)) {
            cout << "NO\n";
        }
        else {
            vector<vector<long long>> g(k);
            for (long long i = 0; i < k; ++i) {
                for (long long j = 0; j < k; ++j) {
                    if (i != j) {
                        if (a[i].m >= a[j].l && a[i].m <= a[j].r) {
                            g[i].push_back(j);
                        }
                    }
                }
            }
            vector<long long> used(k, 0);
            vector<long long> uniqu;
            vector<long long> all_unique;
            cnt = 1;
            while (cnt == 1) {
                if (!Cover(a, n, deleted)) {
                    cout << "NO\n";
                    cnt = 2;
                }
                else {
                    cnt = 0;
                    uniqu = CalcUniqu(a, deleted, n);
                    used.assign(k, 0);
                    vector<long long> path;
                    for (long long i = 0; i < k; ++i) {
                        if (used[i] == 0 && deleted[i] == 0) {
                            dfs(i, used, g, path, deleted);
                        }
                        if (cnt == 1) {
                            break;
                        }
                    }
                    if (cnt == 0) {
                        break;
                    }
                    else {
                        long long v = path.back();
                        path.pop_back();
                        long long ind = v;
                        while (path.back() != v) {
                            if (g[ind].size() <=g[path.back()].size() && !uniqu[path.back()]) {
                                ind = path.back();
                            }
                            path.pop_back();
                        }
                        deleted[ind] = 1;
                        if (uniqu[ind] == 1) {
                            cout << "NO\n";
                            cnt = 2;
                        }
                    }
                }

            }
            if (cnt != 2 && !Cover(a, n, deleted)) {
                cout << "NO\n";
                cnt = 2;
            }
            if (cnt != 2) {
                cout << "YES\n";
            }
        }
    }
}