#include <iostream>
#include <vector>
#include <algorithm>
#include<set>
#include<string>
#include<iomanip>

using namespace std;
int max(int &a, int &b) {
    if (a > b) {
        return a;
    }
    return b;
}
int cnt = 0;
struct person {
    int l, r, m;
    person() = default;
    person(int l_,int m_, int r_):l(l_), m(m_), r(r_){};
};

bool cmp(person &a, person &b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

bool Cover(vector<person> &a, int n) {
    sort(a.begin(), a.end(), cmp);
    int need = 1;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i].l <= need && a[i].r >= need) {
            need = a[i].r + 1;
        }
    }
    if (need <= n) {
        return 0;
    }
    return 1;
}

void dfs(int v, vector<int> &used, vector<vector<int>> &g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u, used, g);
        }
        else if (used[u] == 1) {
            cnt = 1;
        }
    }
    used[v] =2;
}


void solve_d() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    vector<set<int>> g(n);
    vector<int> sz(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].insert(u);
        g[u].insert(v);
        sz[v]++;
        sz[u]++;
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        s.insert({sz[i], i});
    }
    vector<pair<int, int>> ans;
    vector<int> used(n);
    while (!s.empty()) {
        auto[siz, ind] = *s.begin();
        s.erase(s.begin());
        if (siz == 1 && siz == sz[ind]) {
            int u = *g[ind].begin();
            g[u].erase(ind);
            if (used[u] == 0) {
                ans.push_back({u, ind});
                sz[u]--;
            }
            for (auto p : g[u]) {
                g[p].erase(u);
                sz[p]--;
                if (sz[p] == 1) {
                    s.insert({sz[p], p});
                }
            }
            used[ind] = 1;
            used[u] = 1;
        }
    }
    cout << ans.size() << '\n';
    for (auto [v, u] : ans) {
        cout << v + 1 << ' ' << u + 1 << '\n';
    }
}

void solve_c() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        long long ans = 0;
        long long walk_for_left = 0;
        __int128 best_k = 2 * x[n - 1] * d - t[i];
        if (best_k < 0) {
            best_k = 0;
        }
        best_k /= d * d;
        if (best_k > 0) {
            walk_for_left += (best_k) * d;
        }
        for (int j = 0; j < n; ++j) {
            best_k = 2 * x[j] * d - t[i];
            if (best_k < 0) {
                best_k = 0;
            }
            best_k /= d * d;
            if (best_k > 0) {
                walk_for_left += min((x[j] - best_k * d) * (x[j] - best_k * d), (x[j] - best_k * d + d) * (x[j] - best_k * d + d));
            }
            else {
                walk_for_left += (x[j] - best_k * d) * (x[j] - best_k * d);
            }
        }
        cout << walk_for_left << '\n';
        //
        // best_k /= d * d;
        // if (best_k < 0) {
        //     best_k = 0;
        // }
        // if (x[0] < x0) {
        //     walk_for_left = best_k * t[i];
        // }
        // best_k = 2 * x[n - 1] - 2 * x0 * d - t[i];
        // best_k /= d * d;
        // if (best_k < 0) {
        //     best_k = 0;
        // }
        // if (x[n - 1] > x0) {
        //     walk_for_left += best_k * t[i];
        // }
        // for (int j = 0;j < n; ++j) {
        //     if (x[j] > x0) {
        //         best_k = 2 * x[j] - 2 * x0 * d - t[i];
        //         if (best_k < 0) {
        //             best_k = 0;
        //         }
        //         best_k /= d * d;
        //         ans += (x[j] - (x0 + best_k * d)) * (x[j] - (x0 + best_k * d));
        //     }
        //     else {
        //         best_k = 2 * x[j] + 2 * x0 * d - t[i];
        //         best_k /= d * d;
        //         if (best_k < 0) {
        //             best_k = 0;
        //         }
        //         ans += (x[j] - (x0 - best_k * d)) * (x[j] - (x0 - best_k * d));
        //     }
        // }
        // cout << ans + walk_for_left << '\n';
    }
}

signed main() {
    solve_c();
    return 0;
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        cnt = 0;
        int n, k;
        cin >> n >> k;
        vector<person> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        if (!Cover(a, n)) {
            cout << "NO\n";
        }
        else {
            vector<vector<int>> g(k);
            for (int i = 0; i < k; ++i) {
                for (int j = 0; j < k; ++j) {
                    if (i != j) {
                        if (a[i].m >= a[j].l && a[i].m <= a[j].r) {
                            g[i].push_back(j);
                        }
                    }
                }
            }
            vector<int> used(k, 0);
            vector<int> unique;
            for (int i = 0; i < k; ++i) {
                if (used[i] == 0) {
                    dfs(i, used, g);
                }
            }
            if (cnt == 1) {
                cout << "NO\n";
            }
            else {
                cout << "YES\n";
            }
        }
    }
}