#include <iostream>
#include <vector>
#include <algorithm>
#include<set>
#include<string>
#include<iomanip>

using namespace std;
long long max(long long &a, long long &b) {
    if (a > b) {
        return a;
    }
    return b;
}
long long cnt = 0;
struct person {
    long long l, r, m;
    person() = default;
    person(long long l_,long long m_, long long r_):l(l_), m(m_), r(r_){};
};

bool cmp(person &a, person &b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

bool Cover(vector<person> &a, long long n) {
    sort(a.begin(), a.end(), cmp);
    long long need = 1;
    for (long long i = 0; i < a.size(); ++i) {
        if (a[i].l <= need && a[i].r >= need) {
            need = a[i].r + 1;
        }
    }
    if (need <= n) {
        return 0;
    }
    return 1;
}

void dfs(long long v, vector<long long> &used, vector<vector<long long>> &g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u, used, g);
        }
        else if (used[u] == 1) {
            cnt = 1;
        }
    }
    used[v] =2;
}


void solve_d() {
    long long n;
    cin >> n;
    long long d;
    cin >> d;
    vector<set<long long>> g(n);
    vector<long long> sz(n);
    for (long long i = 0; i < n - 1; ++i) {
        long long v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].insert(u);
        g[u].insert(v);
        sz[v]++;
        sz[u]++;
    }
    set<pair<long long, long long>> s;
    for (long long i = 0; i < n; ++i) {
        s.insert({sz[i], i});
    }
    vector<pair<long long, long long>> ans;
    vector<long long> used(n);
    while (!s.empty()) {
        auto[siz, ind] = *s.begin();
        s.erase(s.begin());
        if (siz == 1 && siz == sz[ind]) {
            long long u = *g[ind].begin();
            g[u].erase(ind);
            if (used[u] == 0) {
                ans.push_back({u, ind});
                sz[u]--;
            }
            for (auto p : g[u]) {
                g[p].erase(u);
                sz[p]--;
                if (sz[p] == 1) {
                    s.insert({sz[p], p});
                }
            }
            used[ind] = 1;
            used[u] = 1;
        }
    }
    cout << ans.size() << '\n';
    for (auto [v, u] : ans) {
        cout << v + 1 << ' ' << u + 1 << '\n';
    }
}
long long all_k;
__int128 f(long long k, long long xi, long long x0, long long d, long long t, int cnt = 0) {
    if (k <= all_k) {
        return (xi - (x0 + k * d)) * (xi - (x0 + k * d));
    }
    return (xi - (x0 + k * d)) * (xi - (x0 + k * d)) + k * t;
}

long long find(long long xi, long long x0, long long d, long long t, long long cnt = 0) {
    long long L = 0;
    long long R = (xi / d) + 2;
    if (cnt == 0) {
        R = all_k;
    }
    while (R - L > 2) {
        long long M1 = R + 2 * L;
        M1 /= 3;
        long long M2 = R + R + L;
        M2 /= 3;
        if (f(M2, xi, x0, d, t, cnt) > f(M1, xi, x0, d, t, cnt)) {
            R = M2;
        }
        else {
            L = M1;
        }
    }
    if (f(L, xi, x0, d, t, cnt) > f(L + 1, xi, x0, d, t, cnt)) {
        L = L+1;
    }
    if (f(L, xi, x0, d, t, cnt) > f(R, xi, x0, d, t, cnt)) {
        L = R;
    }
    return L;
}

void solve_c() {
    long long n;
    cin >> n;
    vector<long long> x(n);
    for (long long i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    long long x0, d;
    cin >> x0 >> d;
    long long m;
    cin >> m;
    vector<long long> t(m);
    for (long long i = 0; i < m; ++i) {
        cin >> t[i];
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += ((abs(x[i] - x0)) % d) * ((abs(x[i] - x0)) % d);
    }
    cout << ans;
    return;
    for (long long i = 0; i < m; ++i) {
        long long walk_for_left = 0;
        long long walking = 0;
        long long best_k;
        int curr = 0;
        all_k = 0;
        for (long long j = n - 1; j >= 0; --j) {
            if (j == n - 1) {
                curr = 1;
            }
            best_k = find(x[j], x0, d, t[i],curr);
            all_k = max(best_k, all_k);
            walk_for_left += (x[j] - best_k * d) * (x[j] - best_k * d);
            walking = max(best_k, walking);
            curr = 0;
        }
        cout << walk_for_left + walking * t[i]<< '\n';
        //
        // best_k /= d * d;
        // if (best_k < 0) {
        //     best_k = 0;
        // }
        // if (x[0] < x0) {
        //     walk_for_left = best_k * t[i];
        // }
        // best_k = 2 * x[n - 1] - 2 * x0 * d - t[i];
        // best_k /= d * d;
        // if (best_k < 0) {
        //     best_k = 0;
        // }
        // if (x[n - 1] > x0) {
        //     walk_for_left += best_k * t[i];
        // }
        // for (long long j = 0;j < n; ++j) {
        //     if (x[j] > x0) {
        //         best_k = 2 * x[j] - 2 * x0 * d - t[i];
        //         if (best_k < 0) {
        //             best_k = 0;
        //         }
        //         best_k /= d * d;
        //         ans += (x[j] - (x0 + best_k * d)) * (x[j] - (x0 + best_k * d));
        //     }
        //     else {
        //         best_k = 2 * x[j] + 2 * x0 * d - t[i];
        //         best_k /= d * d;
        //         if (best_k < 0) {
        //             best_k = 0;
        //         }
        //         ans += (x[j] - (x0 - best_k * d)) * (x[j] - (x0 - best_k * d));
        //     }
        // }
        // cout << ans + walk_for_left << '\n';
    }
}

signed main() {
    solve_c();
    return 0;
    long long t;
    cin >> t;
    for (long long _ = 0; _ < t; ++_) {
        cnt = 0;
        long long n, k;
        cin >> n >> k;
        vector<person> a(k);
        for (long long i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        if (!Cover(a, n)) {
            cout << "NO\n";
        }
        else {
            vector<vector<long long>> g(k);
            for (long long i = 0; i < k; ++i) {
                for (long long j = 0; j < k; ++j) {
                    if (i != j) {
                        if (a[i].m >= a[j].l && a[i].m <= a[j].r) {
                            g[i].push_back(j);
                        }
                    }
                }
            }
            vector<long long> used(k, 0);
            vector<long long> unique;
            for (long long i = 0; i < k; ++i) {
                if (used[i] == 0) {
                    dfs(i, used, g);
                }
            }
            if (cnt == 1) {
                cout << "NO\n";
            }
            else {
                cout << "YES\n";
            }
        }
    }
}