#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct SegmentTree {
    vector<int> tree;
    int sz;

    SegmentTree(int _sz) {
        sz = _sz;
        tree.resize(4 * sz);
    }

    void update(int v, int tl, int tr, int pos, int val) {
        if (tl > pos || tr <= pos) {
            return;
        }
        if (tr - tl == 1) {
            tree[v] += val;
            return;
        }
        int tm = (tl + tr) / 2;
        update(v * 2 + 1, tl, tm, pos, val);
        update(v * 2 + 2, tm, tr, pos, val);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (tl >= r || tr <= l) {
            return 0;
        }
        if (tl >= l && tr <= r) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return get(v * 2 + 1, tl, tm, l, r) + get(v * 2 + 2, tm, tr, l, r);
    }

    void add(int pos) {
        update(0, 0, sz, pos, 1);
    }

    void del(int pos) {
        int val = get(0, 0, sz, pos, pos + 1);
        update(0, 0, sz, pos, -val);
    }

    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

struct border {
    int b, x;
    border(int _b, int _x) : b(_b), x(_x) {};

    bool operator<(const border& other) const {
        return x < other.x;
    }
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int h, w;
    cin >> h >> w;
    vector<vector<int>> arr(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < w; ++j) {
            arr[i][j] = (s[j] == '1');
        }
    }

    
    vector<int> cnt(w);
    int best = 0;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (arr[i][j] == 1) {
                ++cnt[j];
            } else {
                cnt[j] = 0;
            }
        }
        for (int j = 0; j < w; ++j) {
            int cur_cnt = 0, last = 1e9;
            for (int k = j; k < w; ++k) {
                cur_cnt += min(cnt[k], last);
                last = min(cnt[k], last);
                best = max(best, cur_cnt);
            }
        }
    }

    cout << best;

    return 0;
}