#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e9;

struct SegmentTree {
    vector<int> tree;
    int sz;
 
    SegmentTree(int _sz) {
        sz = _sz;
        tree.resize(4 * sz, INF);
    }
 
    void update(int v, int tl, int tr, int pos, int val) {
        if (tl > pos || tr <= pos) {
            return;
        }
        if (tr - tl == 1) {
            tree[v] = min(tree[v], val);
            return;
        }
        int tm = (tl + tr) / 2;
        update(v * 2 + 1, tl, tm, pos, val);
        update(v * 2 + 2, tm, tr, pos, val);
        tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
    }
 
    int get(int v, int tl, int tr, int l, int r) {
        if (tl >= r || tr <= l) {
            return INF;
        }
        if (tl >= l && tr <= r) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return min(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm, tr, l, r));
    }
 
    void update(int pos, int val) {
        update(0, 0, sz, pos, val);
    }
 
    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

struct segment {
    int l, r, m;
    segment(int _l, int _r, int _m) : l(_l), r(_r), m(_m) {}
    bool operator<(const segment& s) {
        return tie(r, l, m) < tie(s.r, s.l, s.m);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    
    for (int _ = 0; _ < t; ++_) {
        int n, k;
        cin >> n >> k;
        vector<segment> s;
        for (int i = 0; i < k; ++i) {
            int l, r, m;
            cin >> l >> m >> r;
            s.push_back(segment(l, r, m));
        }
        sort(s.begin(), s.end());

        SegmentTree tree(n + 1);
        bool check = true;
        for (int i = 0; i < k; ++i) {
            if (i > 0 && s[i].l > s[i - 1].r + 1) {
                continue;
            }
            int m1 = tree.get(max(0, s[i].l - 1), s[i].m),
                m2 = tree.get(s[i].m, s[i].r + 1);
            if (s[i].l == 1 || m1 < INF || m2 < s[i].l) {
                tree.update(s[i].r, s[i].m);
            }
        }
        if (tree.get(n, n + 1) < INF) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }

    return 0;
}