#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct line {
    ll k, b;
    line(ll _k,ll _b) : k(_k), b(_b) {};
    ll eval(ll x) {
        return 1LL * k * x + b;
    }
};

ld cross(line& l1, line& l2) {
    return 1.0 * (l1.b - l2.b) / (l2.k - l1.k);
}

ll get_min(vector<line>& cht, ll x) {
    if (cht.empty()) {
        return 0;
    }
    int l = 0, r = cht.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (cht[m].eval(x) <= cht[m - 1].eval(x)) {
            l = m;
        } else {
            r = m;
        }
    }
    return cht[l].eval(x);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n;
    cin >> n;
    vector<ll> x(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());

    ll x0, d;
    cin >> x0 >> d;

    ll m;
    cin >> m;
    vector<ll> t(m);
    for (ll i = 0; i < m; ++i) {
        cin >> t[i];
    }

    vector<line> cht1, cht2;
    vector<ll> optr1(m, 0), optr2(m, 0);
    if (x.back() >= x0) {
        ll r = (x.back() - x0) / d + 1;
        ll pos = lower_bound(x.begin(), x.end(), x0) - x.begin();
        ll cnt = 0, cur_sum = 0;
        ll b = 0;
        for (int i = pos; i < n; ++i) {
            ++cnt;
            cur_sum += x[i];
            b += (x[i] - x0) * (x[i] - x0);
        }
        cht1.push_back(line(0, b));
        cht2.push_back(line(0, b));
        for (int i = 1; i <= r; ++i) {
            while (pos < n && x[pos] < x0 + i * d && fabs(x[pos] - x0 - (i - 1) * d) < fabs(x[pos] - x0 - i * d)) {
                --cnt;
                cur_sum -= x[pos];
                ++pos;
            }
            b -= cnt * ((x0 + (i - 1) * d) * (x0 + (i - 1) * d)) + 2 * cur_sum * (x0 + i * d);
            b += cnt * ((x0 + i * d) * (x0 + i * d)) + 2 * cur_sum * (x0 + (i - 1) * d);

            line l1(i, b);
            while (cht1.size() > 1 && cross(cht1[cht1.size() - 1], l1) >= cross(cht1[cht1.size() - 2], l1)) {
                cht1.pop_back();
            }
            cht1.push_back(l1);
            
            line l2(2 * i, b);
            while (cht2.size() > 1 && cross(cht2[cht2.size() - 1], l2) >= cross(cht2[cht2.size() - 2], l2)) {
                cht2.pop_back();
            }
            cht2.push_back(l2);
        }

        for (int i = 0; i < m; ++i) {
            optr1[i] = get_min(cht1, t[i]);
            optr2[i] = get_min(cht2, t[i]);
        }
    }

    cht1.clear();
    cht2.clear();
    vector<ll> optl1(m, 0), optl2(m, 0);
    if (x[0] < x0) {
        ll r = (x0 - x[0]) / d + 1;
        ll pos = lower_bound(x.begin(), x.end(), x0) - x.begin() - 1;
        ll cnt = 0, cur_sum = 0;
        ll b = 0;
        for (int i = pos; i >= 0; --i) {
            ++cnt;
            cur_sum += x[i];
            b += (x[i] - x0) * (x[i] - x0);
        }
        cht1.push_back(line(0, b));
        cht2.push_back(line(0, b));
        for (int i = 1; i <= r; ++i) {
            while (pos >= 0 && x[pos] > x0 - i * d && fabs(x[pos] - x0 + (i - 1) * d) < fabs(x[pos] - x0 + i * d)) {
                --cnt;
                cur_sum -= x[pos];
                --pos;
            }
            b -= cnt * ((x0 - (i - 1) * d) * (x0 - (i - 1) * d)) + 2 * cur_sum * (x0 - i * d);
            b += cnt * ((x0 - i * d) * (x0 - i * d)) + 2 * cur_sum * (x0 - (i - 1) * d);

            line l1(i, b);
            while (cht1.size() > 1 && cross(cht1[cht1.size() - 1], l1) >= cross(cht1[cht1.size() - 2], l1)) {
                cht1.pop_back();
            }
            cht1.push_back(l1);
            
            line l2(2 * i, b);
            while (cht2.size() > 1 && cross(cht2[cht2.size() - 1], l2) >= cross(cht2[cht2.size() - 2], l2)) {
                cht2.pop_back();
            }
            cht2.push_back(l2);
        }

        for (int i = 0; i < m; ++i) {
            optl1[i] = get_min(cht1, t[i]);
            optl2[i] = get_min(cht2, t[i]);
        }
    }

    for (int i = 0; i < m; ++i) {
        ll val1 = optl1[i] + optr2[i],
            val2 = optl2[i] + optr1[i];
        cout << min(val1, val2) << '\n';
    }

    return 0;
}