#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>

using namespace std;

vector<int> mt;

bool dfs(int v, vector<vector<int>>&gr, vector<bool>&used, vector<int>&upd) {
    if (used[v]) {
        return false;
    }
    upd.push_back(v);
    used[v] = true;
    for (int u: gr[v]) {
        if (u != mt[v]) {
            if (mt[u] == -1 or dfs(mt[u], gr, used, upd)) {
                mt[v] = u;
                mt[u] = v;
                return true;
            }
        }
    }
    return false;
}

signed main() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    vector<vector<int>> ngr(n);
    for (int i = 0; i < n; i++) {
        queue<pair<int, int>> q;
        vector<vector<int>> dist(n, vector<int>(2, 1e9));
        dist[i][0] = 0;
        q.push({i, 0});
        while (!q.empty()){
            int v = q.front().first, ind = q.front().second;
            q.pop();
            if (dist[v][ind] != d) {
                for (int u: gr[v]) {
                    if (dist[u][1 - ind] == 1e9) {
                        dist[u][1 - ind] = dist[v][ind] + 1;
                        q.push({u, 1 - ind});
                    }
                }
            }
        }
        for (int j = 0; j < n; j++) {
            if (dist[j][1] != 1e9) {
                ngr[i].push_back(j);
            }
        }
    }
    mt.resize(n, -1);
    vector<bool> used(n, false);
    for (int i = 0; i < n; i++) {
        if (mt[i] == -1) {
            vector<int> upd;
            dfs(i, ngr, used, upd);
            for (int e: upd) {
                used[e] = false;
            }
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (mt[i] != -1 and mt[i] < i) {
            ans.push_back({mt[i], i});
        }
    }
    cout << ans.size() << '\n';
    for (auto e: ans) {
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }
}