#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void solution() {
	int n, k;
	cin >> n >> k;

	vector <vector <pair <int, int>>> pers(n);
	for (int i = 0; i < k; i++) {
		int l, m, r;
		cin >> l >> m >> r;
		l--; m--;
		pers[m].push_back({ l, r });
	}

	vector <vector <bool>> dp(n + 1, vector <bool>(n + 1));
	for (int i = 0; i <= n; i++) {
		dp[i][i] = 1;
	}
	for (int len = 1; len <= n; len++) {
		for (int l = 0; l + len <= n; l++) {
			int r = l + len;
			for (int m = l; m < r && !dp[l][r]; m++) {
				for (auto [pl, pr] : pers[m]) {
					
					pl = max(pl, l);
					pr = min(pr, r);
					dp[l][r] = dp[l][pl] && dp[pr][r];
					if (dp[l][r]) break;
				}
			}
		}
	}
	if (dp[0][n]) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solution();
		cout << '\n';
	}
}