#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

const int oo = 2e9;

struct Segment {
	int l, m, r;

	Segment() {}

	Segment(int a, int b, int c) {
		l = a;
		m = b;
		r = c;
	}
};

bool operator<(Segment a, Segment b) {
	return a.r < b.r;
}

//void insert(set <pair <int, int>>& st, int i, int x) {
//	auto prv = --st.lower_bound({ i + 1, -1 });
//	if (prv->second <= x) return;
//	while (1) {
//		auto nxt = st.lower_bound({i, -1});
//		if (nxt == st.end()) break;
//		if (nxt->second > x) {
//			st.erase(nxt);
//		}
//		else {
//			break;
//		}
//	}
//	st.insert({ i, x });
//}
//
//void get(int )

struct SegmentTree {
	vector <int> t;
	int n;

	SegmentTree() {}

	SegmentTree(int n) {
		this->n = n;
		t.resize(4 * n, +oo);
	}

	void set(int v, int l, int r, int pos, int x) {
		if (l + 1 == r) {
			t[v] = min(t[v], x);
			return;
		}
		int m = (l + r) / 2;
		if (pos < m) {
			set(v * 2 + 1, l, m, pos, x);
		}
		else {
			set(v * 2 + 2, m, r, pos, x);
		}
		t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
	}

	void set(int pos, int x) {
		set(0, 0, n, pos, x);
	}

	int get(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return +oo;
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) / 2;
		return min(
			get(v * 2 + 1, l, m, ql, qr),
			get(v * 2 + 2, m, r, ql, qr)
		);
	}

	int get(int ql, int qr) {
		return get(0, 0, n, ql, qr);
	}
};

void solution() {
	int n, k;
	cin >> n >> k;
	vector <Segment> segs;
	for (int i = 0; i < k; i++) {
		int l, m, r;
		cin >> l >> m >> r;
		l--; m--; r--;
		segs.push_back({ l, m, r });
	}
	sort(segs.begin(), segs.end());
	SegmentTree dero(n + 10);
	for (auto [l, m, r] : segs) {
		bool tr = 0;
		if (l == 0) {
			tr = 1;
		}
		else {
			int prv = dero.get(0, m);
			if (prv < +oo) {
				tr = 1;
			}
			int mr = dero.get(m, r + 1);
			if (mr < l) {
				tr = 1;
			}
		}

		if (tr) {
			dero.set(r, m);
		}
	}

	int prv = dero.get(n - 1, n + 1);
	if (prv < +oo) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solution();
		cout << '\n';
	}
}