#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

#define int long long

const int oo = 2e18;

int mod(int x, int d) {
	return (x % d + d) % d;
}

int lower(int x, int d) {
	return x - x % d;
}

int upper(int x, int d) {
	if (x % d == 0) return x;
	return x + (d - x % d);
}

int base_cost(int l, int m, int r) {
	if (r < m) {
		return m - l;
	}
	if (m < l) {
		return r - m;
	}
	return r - l + min(m - l, r - m);
}

int get_parabola(int a, int b, int c, int ql, int qr, int x) {
	if (x < ql || qr < x) return +oo;
	return a * x * x + b * x + c;
}

int solve_parabola(int a, int b, int c, int ql, int qr, int d) {
	if (a == 0) {
		if (b < 0) return ql;
		else return qr;
	}
	int mn = +oo;
	int mid = (-b) / (2 * a);
	for (int dd = -2; dd <= 2; dd++) {
		for (int xd = -2; xd <= 2; xd++) {
			mn = min(mn, get_parabola(a, b, c, ql, qr, lower(ql + xd, d) + dd * d));
			mn = min(mn, get_parabola(a, b, c, ql, qr, lower(qr + xd, d) + dd * d));
			mn = min(mn, get_parabola(a, b, c, ql, qr, lower(mid + xd, d) + dd * d));

			mn = min(mn, get_parabola(a, b, c, ql, qr, upper(ql + xd, d) + dd * d));
			mn = min(mn, get_parabola(a, b, c, ql, qr, upper(qr + xd, d) + dd * d));
			mn = min(mn, get_parabola(a, b, c, ql, qr, upper(mid + xd, d) + dd * d));
		}
	}

	return mn;
}

signed main() {
	int n;
	cin >> n;
	vector <int> ts(n);
	for (int i = 0; i < n; i++) {
		cin >> ts[i];
	}

	sort(ts.begin(), ts.end());

	int basex, d;
	cin >> basex >> d;
	for (int i = 0; i < n; i++) {
		ts[i] -= basex;
	}
	basex = 0;

	vector <int> suff1(n + 1);
	vector <int> suff2(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		suff1[i] = suff1[i + 1] + ts[i];
		suff2[i] = suff2[i + 1] + ts[i] * ts[i];
	}

	int q;
	cin >> q;
	while (q--) {
		int tcost;
		cin >> tcost;

		int pref2 = 0;
		int pref1 = 0;

		for (int l = 0; l < n; l++) {
			for (int r = l; r < n; r++) {
				int dl = lower(ts[l], d);
				int dr = upper(ts[r], d);
				int bcost = base_cost(dl, 0, dr);

				if (0 < l) {
					bcost += solve_parabola(l, -2 * pref1 - 1, dl, -oo, dl, d) + pref2;
				}
				if (r < n - 1) {
					bcost += solve_parabola(n - r - 1, -2 * suff1[r + 1] + 1, -dr, dr, +oo, d) + suff2[r + 1];
				}

				answer = min(answer, bcost);
			}

			pref1 += ts[l];
			pref2 += ts[l] * ts[l];
		}
	}
}