#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

#define int long long

const int oo = 2e18;

int mod(int x, int d) {
	return (x % d + d) % d;
}

int lower(int x, int d) {
	return x - mod(x, d);
}

int upper(int x, int d) {
	if (x % d == 0) return x;
	return x + (d - mod(x, d));
}

int sqer(int x) {
	return x * x;
}

const int MXD = 100;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector <int> ts(n);
	for (int i = 0; i < n; i++) {
		cin >> ts[i];
	}

	sort(ts.begin(), ts.end());

	int basex, d;
	cin >> basex >> d;
	for (int i = 0; i < n; i++) {
		ts[i] -= basex;
	}
	basex = 0;

	int q;
	cin >> q;
	while (q--) {
		int tcost;
		cin >> tcost;

		int answer = +oo;
		for (int l = -MXD * d; l <= MXD * d; l += d) {
			for (int r = l; r < MXD * d; r += d) {
				int curr = 0;
				if (0 < l) {
					curr = r / d * tcost;
				} else 
				if (r < 0) {
					curr = -l / d * tcost;
				}
				else {
					curr = (r - l + min(r, -l)) / d * tcost;
				}
				for (auto t : ts) {
					if (l <= t && t <= r) {
						curr += min(sqer(upper(t, d) - t), sqer(lower(t, d) - t));
						continue;
					}
					if (t < l) {
						curr += sqer(l - t);
					}
					if (r < t) {
						curr += sqer(r - t);
					}
				}
				answer = min(answer, curr);
			}
		}

		cout << answer << '\n';;
	}
}