#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

#define int long long

const int oo = 2e18;

int mod(int x, int d) {
	return (x % d + d) % d;
}

int lower(int x, int d) {
	return x - mod(x, d);
}

int upper(int x, int d) {
	if (x % d == 0) return x;
	return x + (d - mod(x, d));
}

int sqer(int x) {
	return x * x;
}

const int MXD = 100;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector <int> ts(n);
	for (int i = 0; i < n; i++) {
		cin >> ts[i];
	}

	sort(ts.begin(), ts.end());

	int basex, d;
	cin >> basex >> d;
	for (int i = 0; i < n; i++) {
		ts[i] -= basex;
	}
	basex = 0;

	int q;
	cin >> q;
	while (q--) {
		int tcost;
		cin >> tcost;

		int t = abs(ts[0]);

		int a = 1;
		int b = -2 * t + 1;
		int c = t * t;

		int opt = lower(-b / (2 * a), d);

		int answer = +oo;
		for (int dd = -5; dd <= 5; dd++) {
			int x = opt + dd * d;
			if (x < 0) continue;

			answer = min(answer, opt * opt * a + opt * b + c);
		}

		cout << answer << '\n';;
	}
}