#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n;
vector <vector <int>> g;

vector <int> dep(n);

void precalc(int v, int p) {
	for (auto u : g[v]) {
		if (u == p) continue;
		dep[u] = dep[v] + 1;
		precalc(u, v);
	}
}

vector <int> mate;
vector <int> used;
int T;

bool dfs(int v) {
	if (used[v] == T) return 0;
	used[v] = T;
	for (auto u : g[v]) {
		if (mate[u] == -1) {
			mate[u] = v;
			return 1;
		}
	}
	for (auto u : g[v]) {
		if (dfs(mate[u])) {
			mate[u] = v;
			return 1;
		}
	}
	return 0;
}

int main() {
	int d;
	cin >> n >> d;

	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	dep.resize(n);
	precalc(0, 0);

	mate.resize(n, -1);
	used.resize(n, -1);
	T = 0;

	for (int i = 0; i < n; i++) {
		if (dep[i] % 2) continue;
		T++;
		dfs(i);
	}

	vector <pair <int, int>> ans;

	for (int i = 0; i < n; i++) {
		if (mate[i] == -1) continue;
		ans.push_back({ mate[i], i });
	}
	cout << ans.size() << '\n';
	for (auto [a, b] : ans) {
		cout << min(a, b) + 1 << ' ' << max(a, b) + 1 << '\n';
	}
}