#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int oo = 1e18;

int n;
vector <vector <int>> g;

vector <int> dep(n);

void precalc(int v, int p) {
	for (auto u : g[v]) {
		if (u == p) continue;
		dep[u] = dep[v] + 1;
		precalc(u, v);
	}
}

vector <int> mate;
vector <int> used;
int T;

bool dfs(int v) {
	if (used[v] == T) return 0;
	used[v] = T;
	for (auto u : g[v]) {
		if (mate[u] == -1) {
			mate[u] = v;
			return 1;
		}
	}
	for (auto u : g[v]) {
		if (dfs(mate[u])) {
			mate[u] = v;
			return 1;
		}
	}
	return 0;
}

signed main() {
	int d;
	cin >> n >> d;

	g.resize(n);
	vector <vector <int>> dist(n, vector <int>(n, +oo));
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
		dist[a][b] = dist[b][a] = 1;
	}

	dep.resize(n);
	precalc(0, 0);
	
	for (int v = 0; v < n; v++) {
		auto vec = g[v];
		int m = vec.size();
		if (m <= 1) continue;
		for (int i = 0; i < m - 1; i++) {
			g[vec[i]].push_back(vec[i + 1]);
			g[vec[i + 1]].push_back(vec[i]);
		}
		g[vec.front()].push_back(vec.back());
		g[vec.back()].push_back(vec.front());
	}

	mate.resize(n, -1);
	used.resize(n, -1);
	T = 0;

	for (int i = 0; i < n; i++) {
		if (dep[i] % 2) continue;
		T++;
		dfs(i);
	}

	vector <pair <int, int>> ans;

	for (int i = 0; i < n; i++) {
		if (mate[i] == -1) continue;
		ans.push_back({ mate[i], i });
	}
	cout << ans.size() << '\n';
	for (auto [a, b] : ans) {
		cout << min(a, b) + 1 << ' ' << max(a, b) + 1 << '\n';
	}
}