#include<bits/stdc++.h>

using namespace std;


struct P {
    int l, m, r;

    bool operator<(P o) {
        return l < o.l;
    }
};

bool solve(int n, vector<P> a) {
    int k = a.size();

    sort(a.begin(), a.end(), [](P a, P b){return a.r > b.r;});
    int minl = n+1;

    for(int i = 0; i < k; i++){
        if (a[i].l > minl)
            continue;
        if (a[i].r < minl - 1) {
            return false;
        }
        minl = min(minl, a[i].l);
    }
    return minl == 1;
}

bool solve2(int n, vector<P> a) {
    int k = a.size();
    for (int i = 0; i < k; i++) {
        a[i].l--;
        a[i].m--;
        a[i].r--;
    }
    vector<int> p(k);
    for (int i = 0; i < k; i++) {
        p[i] = i;
    }
    do {
        vector<bool> used(n);
        for (int i = 0; i < k; i++) {
            if (used[a[p[i]].m])
                continue;
            else {
                for (int j = a[p[i]].l; j <= a[p[i]].r; j++)
                    used[j] = true;
            }
        }
        bool good = true;
        for (int i = 0; i < n; i++) {
            if (!used[i])
                good = false;
        }
        if (good) {
            return true;
        }
    } while (next_permutation(p.begin(), p.end()));
    return false;
}

void stress() {
    for (int i = 0; i < 1000000; i++) {
        int n = rand() % 5 + 1;
        int k = rand() % 4 + 1;
        vector<P> a(k);
        for (int i = 0; i < k; i++) {
            a[i].l = a[i].m = rand()%n + 1;
            a[i].r = rand()%n + 1;
            if (a[i].l > a[i].r) {
                swap(a[i].l, a[i].r);
                a[i].m = a[i].l;
            }
        }
        bool a1 = solve(n, a);
        bool a2 = solve2(n, a);
        if (a1 != a2) {
            cout << "Test " << i << " failed:\n";
            cout << n << ' ' << k << '\n';
            for (int i = 0; i < k; i++) {
                cout << a[i].l << ' ' << a[i].m << ' ' << a[i].r << '\n';
            }
            cout << "Right answer is " << a2;
            exit(0);
        }
    }
    cout << "All passed";
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    srand(2);
    stress();
#endif
    cin >> t;

    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<P> a(k);
        for (int i  = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        cout << (solve(n, a) ? "YES" : "NO");
        cout << '\n';
    }
}