#include<bits/stdc++.h>

using namespace std;


struct P {
    int l, m, r;

    bool operator<(P o) {
        return l < o.l;
    }
};

vector<vector<int>> g;

vector<int> used;

bool dfs(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (used[u] == 2) continue;
        if (used[u] == 1) return true;
        if (used[u] == 0) {
            if (dfs(u))
                return true;
        }
    }
    used[v] = 2;
    return false;
}

struct Event {
    int x;
    int type; // -1 0 1
    int i;

    bool operator<(Event e) {
        if (x == e.x)
            return type < e.type;
        return x < e.x;
    }
};

bool solve(int n, vector<P> a) {
    int k = a.size();
    vector<int> diff(n + 1);
    for (int i = 0; i < k; i++) {
        diff[a[i].l-1]++;
        diff[a[i].r]--;
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        cur += diff[i];
        if (cur == 0)
            return false;
    }
    sort(a.begin(), a.end());
    g = vector<vector<int>>(k);

    vector<Event> e;
    for (int i = 0; i < k; i++) {
        e.push_back({a[i].r+1, -1, i});
        e.push_back({a[i].l, 0, i});
        e.push_back({a[i].m, 1, i});
    }

    sort(e.begin(), e.end());
    set<int> over;
    for (int i = 0; i < e.size(); i++) {
        auto [x, type, id] = e[i];
        if (type == -1) {
            over.erase(id);
        }
        if (type == 0) {
            over.insert(id);
        }
        if (type == 1) {
            for (int j : over)
                if (j != id)
                    g[id].push_back(j);
        }
    }
    used = vector<int>(k);
    for (int i = 0; i < k; i++) {
        if (used[i] == 0)
            if (dfs(i))
                return false;
    }
    return true;
}

bool solve2(int n, vector<P> a) {
    int k = a.size();
    for (int i = 0; i < k; i++) {
        a[i].l--;
        a[i].m--;
        a[i].r--;
    }
    vector<int> p(k);
    for (int i = 0; i < k; i++) {
        p[i] = i;
    }
    do {
        vector<bool> used(n);
        for (int i = 0; i < k; i++) {
            if (used[a[p[i]].m])
                continue;
            else {
                for (int j = a[p[i]].l; j <= a[p[i]].r; j++)
                    used[j] = true;
            }
        }
        bool good = true;
        for (int i = 0; i < n; i++) {
            if (!used[i])
                good = false;
        }
        if (good) {
            return true;
        }
    } while (next_permutation(p.begin(), p.end()));
    return false;
}

bool solve7(int n, vector<P>a) {
    int k = a.size();
    vector<P> s;
    vector<P> e;
    for (int i = 0; i < k; i++) {
        if (a[i].l == 1 && a[i].r == n)
            return true;
        else if (a[i].l == 1)
            s.push_back(a[i]);
        else if (a[i].r == n)
            e.push_back(a[i]);
    }

    for (int i = 0; i < s.size(); i++) {
        for (int j = 0; j < e.size(); j++) {
            if (s[i].m >= e[j].l && e[j].m <= s[i].r) {
                continue;
            }
            if (s[i].r + 1 >= e[j].l)
                return true;
        }
    }
    return false;
}

void stress() {
    for (int i = 0; i < 1000000; i++) {
        int n = rand() % 5 + 1;
        int k = rand() % 4 + 1;
        vector<P> a(k);
        for (int i = 0; i < k; i++) {
            a[i].l = a[i].m = rand()%n + 1;
            a[i].r = rand()%n + 1;
            if (a[i].l > a[i].r) {
                swap(a[i].l, a[i].r);
                a[i].m = a[i].l;
            }
            if (rand() < RAND_MAX / 2) {
                a[i].l = 1;
            }
            else {
                a[i].r = n;
            }
        }
        bool a1 = solve7(n, a);
        bool a2 = solve2(n, a);
        if (a1 != a2) {
            cout << "Test " << i << " failed:\n";
            cout << n << ' ' << k << '\n';
            for (int i = 0; i < k; i++) {
                cout << a[i].l << ' ' << a[i].m << ' ' << a[i].r << '\n';
            }
            cout << "Right answer is " << a2;
            exit(0);
        }
    }
    cout << "All passed";
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    srand(2);
    stress();
#endif
    cin >> t;

    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<P> a(k);
        for (int i  = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        cout << (solve7(n, a) ? "YES" : "NO");
        cout << '\n';
    }
}