#include <iostream>
#include <ios>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>

using namespace std;

#define int long long

const int UNDO = -1;
const int HEIGHT = 2e5 + 2;
int tme = 0;

// struct segtree {
//     vector<int> t, la;
//     vector<vector<int>> lp;
    
//     segtree(int n) {
//         t.assign(n * 4, 0);
//         lp.resize(n * 4);
//         la.assign(n * 4, UNDO);
//     }

//     void push(int v, int l, int r) {
//         if (la[v] != UNDO) {
//             t[v] = (r - l) * la[v];
//             la[v * 2 + 1] = la[v * 2 + 2] = la[v];
//             la[v] = UNDO;
//         }
//         while (lp[v].back() > la[v]) {
//             t[v] += (r - l);
//             lp[v * 2 + 1].push_back(lp[v].back());
//             lp[v * 2 + 2].push_back(lp[v].back());
//         }
//         vector<int> buf;
//         swap(buf, lp[v]);
//     }

//     int plus(int v, int l, int r, int ql, int qr) {
//         push(v, l, r);
//         if (r <= ql || qr <= l)
//             return t[v];
//         if (ql <= l && r <= qr) {
//             lp[v] = 1;
//             return t[v] + (r - l);
//         }
//         int m = (l + r) / 2;
//         return t[v] = plus(v * 2 + 1, l, m, ql, qr) + plus(v * 2 + 2, m, r, ql, qr);
//     }

//     int asign(int v, int l, int r, int ql, int qr) {
//         push(v, l, r);
//         if (r <= ql || qr <= l)
//             return t[v];
//         if (ql <= l && r <= qr) {
//             la[v] = tme;
//             return 0;
//         }
//         int m = (l + r) / 2;
//         return t[v] = asign(v * 2 + 1, l, m, ql, qr) + asign(v * 2 + 2, m, r, ql, qr);
//     }

//     int get(int v, int l, int r, int ql, int qr) {
//         push(v, l, r);
//         if (r <= ql || qr <= l)
//             return 0;
//         if (ql <= l && r <= qr)
//             return t[v];
//         int m = (l + r) / 2;
//         return get(v * 2 + 1, l, m, ql, qr) + get(v * 2 + 2, m, r, ql, qr);
//     }
// };

signed main() {
    int n, m; cin >> n >> m;
    vector<string> ladder(n);
    for (auto &x: ladder) {
        cin >> x;
    }
    vector<vector<int>> h(n, vector<int> (m));
    for (int i = 0; i < m; i++) 
        h[0][i] = ladder[0][i] == '1';
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++) {
            h[i][j] = (h[i - 1][j] + 1) * (ladder[i][j] == '1');
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        set<int> curr;
        vector<int> cnt(HEIGHT, 0);
        int csum = 0;
        for (int j = m - 1; j >= 0; j--) {
            int cut = 1;
            while (!curr.empty() && *(--curr.end()) > h[i][j]) {
                csum -= cnt[*(--curr.end())] * (*(--curr.end()));
                cut += cnt[*(--curr.end())];
                cnt[*(--curr.end())] = 0;
                curr.erase(--curr.end());
            }
            csum += cut * h[i][j];
            cnt[h[i][j]] += cut;
            curr.insert(h[i][j]);
            ans = max(ans, csum);
        }
    }
    cout << ans << '\n';
    // int n; cin >> n;
    // segtree st(n);
    // while (true) {
    //     char t; cin >> t;
    //     if (t == 'p') {
    //         tme++;
    //         int ql, qr; cin >> ql >> qr;
    //         st.plus(0, 0, n, ql, ++qr);
    //     } if (t == 'a') {
    //         tme++;
    //         int ql, qr; cin >> ql >> qr;
    //         st.asign(0, 0, n, ql, ++qr);
    //     } if (t == 'g') {
    //         int ql, qr; cin >> ql >> qr;
    //         cout << st.get(0, 0, n, ql, ++qr) << '\n';
    //     }
    // }
}