#include <iostream>
#include <ios>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>

using namespace std;

vector<vector<int>> g;
vector<bool> used;
vector<int> mt;

bool kuhn(int v) {
    if (used[v])
        return false;
    used[v] = true;
    for (int x: g[v]) {
        if (mt[x] == -1 || kuhn(mt[x])) {
            mt[x] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    int n, d; cin >> n >> d;
    vector<vector<int>> mtr(n, vector<int> (n, 1e9));
    for (int i = 1; i < n; i++) {
        int a, b; cin >> a >> b;
        a--, b--;
        mtr[a][b] = mtr[b][a] = 1;
    }
    for (int k = 0; k < n; k++) {
        mtr[k][k] = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) 
                mtr[i][j] = min(mtr[i][j], mtr[i][k] + mtr[k][j]);
        }
    }

    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        for (int j = i + 1; j < n; j++) {
            if (mtr[i][j] % 2 && mtr[i][j] <= d)
                g[i].push_back(j);
        }
    }
    mt.assign(n, -1);
    for (int i = 0; i < n; i++) {
        used.assign(n, 0);
        kuhn(i);
    }
    vector<pair<int, int>> out;
    for (int i = 0; i < n; i++) {
        if (mt[i] != -1) 
            out.emplace_back(i + 1, mt[i] + 1);
    }
    cout << out.size() << '\n';
    for (auto &x: out)
        cout << x.first << ' ' << x.second << '\n';
}