#include <vector>
#include <iostream>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

#define ll long long
#define all(x) x.begin(),x.end()

struct duo {
	ll name;
	ll index;
};

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	ll n, m;
	cin >> n >> m;

	vector<vector<ll>> arr(n, vector<ll>(m));
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++) {
			if (s[j] == '1') {
				arr[i][j] = 1;
			}
			if (s[j] == '0') {
				arr[i][j] = 0;
			}
		}
	}

	for (int j = 0; j < m; j++) {
		ll start = 0;
		for (int i = 0; i < n; i++) {
			if (arr[i][j] == 1) {
				start++;
			}
			else {
				start = 0;
			}
			arr[i][j] = start;
		}
	}

	ll tot_ans = 0;
	vector<ll> dp;
	for (int i = 0; i < n; i++) {
		dp.assign(m,0);
		dp[m - 1] = arr[i][m - 1];
		deque<duo> deq;
		deq.push_front({ arr[i][m - 1],m - 1 });
		for (int j = m - 2; j >= 0; j--) {
			while (!deq.empty() && deq.front().name > arr[i][j]) {
				deq.pop_front();
			}
			if (arr[i][j] > arr[i][j + 1]) {
				dp[j] = dp[j + 1] + arr[i][j];
			}
			else {
				if (deq.empty()) {
					dp[j] = arr[i][j];
				}
				else {
					dp[j] = max(arr[i][j], dp[deq.front().index] + arr[i][j] * (deq.front().index - j -1) + arr[i][j]);
				}
			}

			deq.push_front({ arr[i][j],j });
			tot_ans = max(tot_ans, dp[j]);
		}
	}

	cout << tot_ans << '\n';
}

