#include <vector>
#include <iostream>
#include <map>
#include <algorithm>
#include <deque>
#include <random>
#include <chrono>
#include <unordered_map>

using namespace std;

#define ll long long
#define all(x) x.begin(),x.end()
#define REP(a) for(int i = 0 ; i < a ; i ++)

mt19937 rnd(time(0));

struct duo {
	ll used;
	ll not_used;
};

vector<vector<ll>> graph;

duo dfs(ll curr,ll last) {
	if (graph[curr].size() == 1) {
		return { 0,0 };
	}
	duo curr_max = { 0,0 };
	ll not_used = 0;
	ll used = 0;
	for (auto& to : graph[curr]) {
		if (to != last) {
			auto ans = dfs(to,curr);
			not_used += max(ans.used, ans.not_used);
			used += ans.not_used;
		}
	}
	return {used+1,not_used};
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	ll n,u,v;
	cin >> n;
	ll d;
	cin >> d;
	graph.resize(n);
	REP(n-1) {
		cin >> u >> v;
		graph[u - 1].push_back(v-1);
		graph[v - 1].push_back(u - 1);
	}
	auto tt = dfs(0,-1);
	cout << max(tt.used,tt.not_used+1) << '\n';
	cout << -1 << '\n';
}

