#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

struct node {
	int l, r, m;
	node() {}
	node(int l, int r, int m) : l(l), r(r), m(m) {}
	bool operator < (node b) {
		return l < b.l;
	}
};


vector<vector<int>> g;
vector<int> used;

bool dfs(int v) {
	if (used[v]) return 0;
	used[v] = 1;
	for (int u : g[v]) {
		if (!dfs(u)) return 0;
	}
	return 1;
}

void solve() {
	int n, k; cin >> n >> k;
	g.assign(k, {});
	used.assign(k, 0);

	vector<node> v(k);
	vector<int> col(n);
	for (int i = 0; i < k; ++i) {
		cin >> v[i].l >> v[i].m >> v[i].r;
		for (int j = v[i].l - 1; j < v[i].r; ++j) col[j]++;
	}
	for (int i = 0; i < n; ++i) {
		if (col[i] == 0) {
			cout << "NO\n";
			return;
		}
	}

	sort(all(v));

	bool f = 1;
	vector<int> in(k);
	

	for(int i = 0; i < k; ++i){
		for (int j = i + 1; j < k; ++j) {
			if (v[i].r < v[j].l) continue;
			int cnt = 0;
			if (v[j].l <= v[i].m) g[i].push_back(j), in[j]++;
			if (v[j].m <= v[i].r) g[j].push_back(i), in[i]++;
		}
	}

	for (int i = 0; i < k; ++i) {
		if (in[i] == 0 && !dfs(i)) {
			cout << "NO\n";
			return;
		}
	}
	for (int i = 0; i < k; ++i) {
		if (!used[i]) {
			cout << "NO\n";
			return;
		}
	}

	cout << "YES\n";
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t; cin >> t;
	while (t--) solve();

}