#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
#define all(a) (a).begin(), (a).end()
#define int long long

struct node {
	int l, r, m;
	node() {}
	node(int l, int r, int m) : l(l), r(r), m(m) {}
	bool operator < (node b) {
		return l < b.l;
	}
};


vector<vector<int>> g, gr;
vector<int> used;
vector<int> eul;

void dfs(int v) {
	if (used[v]) return;
	used[v] = 1;
	for (int u : g[v]) dfs(u);
	eul.push_back(v);
}

void dfs(int v, int c) {
	if (used[v]) return;
	used[v] = c;
	for (int u : g[v]) dfs(u, c);
}

void solve() {
	int n, k; cin >> n >> k;
	g.assign(k, {});
	gr.assign(k, {});
	used.assign(k, 0);

	vector<node> v(k);
	vector<int> col(n);
	for (int i = 0; i < k; ++i) {
		cin >> v[i].l >> v[i].m >> v[i].r;
		for (int j = v[i].l - 1; j < v[i].r; ++j) col[j]++;
	}
	for (int i = 0; i < n; ++i) {
		if (col[i] == 0) {
			cout << "NO\n";
			return;
		}
	}

	sort(all(v));
	
	for(int i = 0; i < k; ++i){
		for (int j = i + 1; j < k; ++j) {
			if (v[i].r < v[j].l) continue;
			int cnt = 0;
			if (v[j].l <= v[i].m) {
				g[i].push_back(j);
				gr[j].push_back(i);
			}

			if (v[j].m <= v[i].r) {
				g[j].push_back(i);
				gr[i].push_back(j);
			}
		}
	}
	used.assign(k, 0);
	for (int i = 0; i < k; ++i)
		dfs(i);

	used.assign(k, 0);
	int c = 0;
	for (int v : eul) {
		if (!used[v]) dfs(v, ++c);
	}
	if (c == k) cout << "YES\n";
	else cout << "NO\n";
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG

	int t; cin >> t;
	while (t--) solve();

}