#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct segtree {
    int n;
    vector<int> t;
    segtree() = default;
    segtree(int n_) {
        n = n_;
        t.assign(2 * n, -1);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = max(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = -1;
        while (l < r) {
            if (l & 1) ans = max(ans, t[l++]);
            if (r & 1) ans = max(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

struct segtree2 {
    int n;
    vector<int> t;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.assign(2 * n, 1e9);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = min(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = 1e9;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
        a[i][0]--; a[i][1]--; a[i][2]--;
    }

    vector<int> ord(k); iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) {
        return a[i][1] < a[j][1];
    });
    vector<int> dp_right(k, 0), dp_left(k, 0);
    segtree sg(n);
    for (int i = k - 1; i >= 0; i--) {
        if (a[ord[i]][2] == n - 1 || sg.get(0, a[ord[i]][2] + 2) > a[ord[i]][2]) {
            dp_right[i] = 1;
            sg.upd(a[ord[i]][0], a[ord[i]][1]);
        }
    }
    segtree2 sg2(n);
    for (int i = 0; i < k; i++) {
        if (a[ord[i]][0] == 0 || sg2.get(a[ord[i]][0] - 1, n) < a[ord[i]][0]) {
            dp_left[i] = 1;
            sg2.upd(a[ord[i]][2], a[ord[i]][1]);
        }
    }
    // for (int u : ord) cout << u << ' ';
    // cout << '\n';
    // for (int i = 0; i < k; i++) cout << dp_right[i] << ' ' << dp_left[i] << '\n';
    int ans = 0;
    for (int i = 0; i < k; i++) ans = max(ans, dp_right[i] * dp_left[i]);
    cout << (ans ? "YES\n" : "NO\n");
}

signed main() {
    int t = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}