#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct segtree {
    int n;
    vector<int> t;
    segtree() = default;
    segtree(int n_) {
        n = n_;
        t.assign(2 * n, -1);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = max(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = -1;
        while (l < r) {
            if (l & 1) ans = max(ans, t[l++]);
            if (r & 1) ans = max(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

struct segtree2 {
    int n;
    vector<int> t;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.assign(2 * n, 1e9);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = min(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = 1e9;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
        a[i][0]--; a[i][1]--; a[i][2]--;
    }
    vector<int> ord(k); iota(all(ord), 0);
    do {
        vector<int> used(n);
        int cnt = n;
        for (int i = 0; i < k; i++) {
            if (!used[a[ord[i]][1]]) {
                for (int j = a[ord[i]][0]; j <= a[ord[i]][2]; j++) {
                    if (!used[j]) {
                        cnt--; used[j] = 1;
                    }
                }
            }
            if (!cnt) {
                cout << "YES\n";
                return;
            }
        }
    } while(next_permutation(all(ord)));
    cout << "NO\n";
}

signed main() {
    int t = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}