#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct segtree {
    int n;
    vector<int> t;
    segtree() = default;
    segtree(int n_) {
        n = n_;
        t.assign(2 * n, -1);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = max(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = -1;
        while (l < r) {
            if (l & 1) ans = max(ans, t[l++]);
            if (r & 1) ans = max(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

struct segtree2 {
    int n;
    vector<int> t;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.assign(2 * n, 1e9);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = min(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = 1e9;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

void solve() {
    int n; cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    int x0, d; cin >> x0 >> d;

    int q;
    cin >> q;
    while (q--) {
        int t; cin >> t;
        auto f = [&](int l, int r) {
            ll per = (l + r + min(l, r)) * 1ll * t;
            for (int i = 0; i < n; i++) {
                if (x[i] < x0) {
                    int dd = (x0 - x[i] + d - 1) / d;
                    if (l >= dd) {
                        per += min((x[i] - (x0 - d * 1ll * dd)) * 1ll * (x[i] - (x0 - d * 1ll * dd)), 
                        (x[i] - (x0 - d * 1ll * (dd - 1))) * 1ll * (x[i] - (x0 - d * 1ll * (dd - 1))));
                    } else {
                        per += (x[i] - (x0 - d * 1ll * l)) * 1ll * (x[i] - (x0 - d * 1ll * l));
                    }
                } else {
                    int dd = (x[i] - x0 + d - 1) / d;
                    if (r >= dd) {
                        per += min((x[i] - (x0 + d * 1ll * dd)) * 1ll * (x[i] - (x0 + d * 1ll * dd)), 
                        (x[i] - (x0 + d * 1ll * (dd - 1))) * 1ll * (x[i] - (x0 + d * 1ll * (dd - 1))));
                    } else {
                        per += (x[i] - (x0 + d * 1ll * r)) * 1ll * (x[i] - (x0 + d * 1ll * r));
                    }
                }
            }
            return per;
        };  
        ll ans= 1e18;
        for (int l = 0; l <= 100; l++) {
            for (int r = 0; r <= 100; r++) ans = min(ans, f(l, r));
        }
        cout << ans << '\n';
    }
}

signed main() {
    int t = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> t;

    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    
    while (t--) {
        solve();
    }

    return 0;
}