#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct segtree {
    int n;
    vector<int> t;
    segtree() = default;
    segtree(int n_) {
        n = n_;
        t.assign(2 * n, -1);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = max(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = -1;
        while (l < r) {
            if (l & 1) ans = max(ans, t[l++]);
            if (r & 1) ans = max(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

struct segtree2 {
    int n;
    vector<int> t;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.assign(2 * n, 1e9);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = min(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = 1e9;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

__int128 smartdivide(__int128 x, __int128 y) {
    if (y == 0) return -1;
    return (x > 0 ? x / y : -((-x + y - 1) / y));
}

void solve() {
    int n; cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    ll x0, d; cin >> x0 >> d;

    vector<ll> big, low;
    for (int i = 0; i < n; i++) {
        if(x[i] >= x0) big.pb(x[i]);
        else low.pb(x[i]);
    }

    auto sq = [&](ll x) {
        return x * x;
    };

    sort(all(big)); sort(all(low));
    vector<ll> times(sz(big)), goodb(sz(big));
    for (int i = 0; i < sz(big); i++) {
        times[i] = (big[i] - x0 + d - 1) / d;
        goodb[i] = min(sq(big[i] - (x0 + d * times[i])), sq(big[i] - (x0 + d * (times[i] - 1))));
    }
    vector<ll> pref_good(sz(big) + 1);
    for(int i = 1; i <= sz(big); i++) pref_good[i] = pref_good[i - 1] + goodb[i - 1];
    vector<__int128> suff_sqb(sz(big) + 1), suff_smb(sz(big) + 1);
    for (int i = sz(big) -1; i >= 0; i--) {suff_smb[i] = suff_smb[i + 1] + big[i]; suff_sqb[i] = suff_sqb[i + 1] + big[i] * big[i]; }
    auto calc_big = [&](ll time, int goodpref) {
        __int128 ans = pref_good[goodpref] + suff_sqb[goodpref] + __int128((x0 + time * d) * (x0 + time * d)) * (sz(big) - goodpref) - (__int128)2 * (x0 + time * d) * suff_smb[goodpref];
        return ans;
    };
    vector<pair<__int128, __int128>> lol(sz(big));
    for (int i = 0; i < sz(big); i++) {
        lol[i].first = calc_big(times[i] - 1, i); lol[i].second = calc_big(times[i], i + 1);
    }

    //-----------------------------------
    reverse(all(low));
    for (int i = 0; i < sz(low); i++) low[i] = 2 * x0 - low[i];

    vector<ll> times_l(sz(low)), goodl(sz(low));
    for (int i = 0; i < sz(low); i++) {
        times_l[i] = (low[i] - x0 + d - 1) / d;
        goodl[i] = min(sq(low[i] - (x0 + d * times_l[i])), sq(low[i] - (x0 + d * (times_l[i] - 1))));
    }

    vector<ll> pref_good_l(sz(low) + 1);
    for(int i = 1; i <= sz(low); i++) pref_good_l[i] = pref_good_l[i - 1] + goodl[i - 1];
    vector<__int128> suff_sql(sz(low) + 1), suff_sml(sz(low) + 1);
    for (int i = sz(low) -1; i >= 0; i--) {suff_sml[i] = suff_sml[i + 1] + low[i]; suff_sql[i] = suff_sql[i + 1] + low[i] * low[i]; }

    auto calc_low = [&](ll time, int goodpref) {
        //cout << (ll)pref_good_l[goodpref] << ' ' << (ll)suff_sql[goodpref] << ' ' << (ll)__int128((x0 + time * d) * (x0 + time * d)) * (sz(low) - goodpref) << ' ' << ll((__int128)2 * (x0 + time * d) * suff_sml[goodpref]) << '\n';
        __int128 ans = pref_good_l[goodpref] + suff_sql[goodpref] + __int128((x0 + time * d) * (x0 + time * d)) * (sz(low) - goodpref) - (__int128)2 * (x0 + time * d) * suff_sml[goodpref];
        return ans;
    };
    vector<pair<__int128, __int128>> lol2(sz(low));
    for (int i = 0; i < sz(low); i++) {
        lol2[i].first = calc_low(times_l[i] - 1, i); lol2[i].second = calc_low(times_l[i], i + 1);
    }
    // if (sz(low) >= 1) {
    //     cout << ll(lol2[0].first) << ' ' << ll(lol2[0].second) << ' ' << times_l[0] << '\n';
    // }

    constexpr ll INF = 8e18;

    int q;
    cin >> q;
    while (q--) {
        ll t; cin >> t;
        __int128 bl1 = INF, bl2 = INF, br1 = INF, br2 = INF;
        {
            int L = -1, R = sz(big);
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (lol[M].second + times[M] * t <= lol[M].first + (times[M] - 1) * t) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ll smx = suff_smb[R];
            int N = sz(big) - R;
            // d * (d - 2 * pt + 2 * smx) >= t
            // -d * 2 * pt >= t - d * d - d * 2 * smx;
            // 2d * pt <= d * d + d * 2 * smx - t
            // pt <= (d * d + d * 2 * smx - t) / 2d
            __int128 lim_pt = min(__int128(L == sz(big) - 1 ? 8e18 : x0 + d * (times[R] - 1)), max(__int128(L >= 0 ? times[L] * d + x0 : 0ll), smartdivide((__int128(d * d) * N + __int128(d * 2) * smx - t), (2 * d * N))));
            ll take = x0 + ((lim_pt-x0) / d) * d;
            //cout << ll(lim_pt)<<' '<<ll(smartdivide((__int128(d * d) * N + __int128(d * 2) * smx - t), (2 * d * N)))<<' '<<ll(__int128(L >= 0 ? times[L] : 0ll))<<' '<<N<<' '<<smx<<' '<<ll((lim_pt / d))<< '\n';
            //if(t==1)cout << take << ' ' << (ll) lim_pt << endl;

            br1 = ((take - x0) / d) * t + pref_good[R] + suff_sqb[R] + __int128(take * take * (sz(big) - R)) - __int128(2 * take) * suff_smb[R];
        }
        {
            int L = -1, R = sz(big);
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (lol[M].second + times[M] * 2 * t <= lol[M].first + (times[M] - 1) * 2 * t) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ll smx = suff_smb[R];
            int N = sz(big) - R;
            //if (t == 2) cout << R << endl;
            // d * (d - 2 * pt + 2 * smx) >= t
            // -d * 2 * pt >= t - d * d - d * 2 * smx;
            // 2d * pt <= d * d + d * 2 * smx - t
            // pt <= (d * d + d * 2 * smx - t) / 2d
            __int128 lim_pt = min(__int128(L == sz(big) - 1 ? 8e18 : x0 + d * (times[R] - 1)), max(__int128(L >= 0 ? times[L] * d + x0 : 0ll), smartdivide((__int128(d * N) * d + __int128(d * 2) * smx - 2 * t), (2 * d * N))));
            ll take = x0 + ((lim_pt-x0)/ d) * d;
            //if (t==2) cout <<smx<<' '<< take << ' ' << times[L] << ' ' << ll(d + (d * d + __int128(d * 2) * smx - 2 * t) / (2 * d)) << '\n';

            br2 = ((take - x0) / d) * 2 * t + pref_good[R] + suff_sqb[R] + __int128(take * take * (sz(big) - R)) - __int128(2 * take) * suff_smb[R];
        }
        {
            int L = -1, R = sz(low);
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (lol2[M].second + times_l[M] * t <= lol2[M].first + (times_l[M] - 1) * t) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ll smx = suff_sml[R];
            int N = sz(low) - R;
            // d * (d - 2 * pt + 2 * smx) >= t
            // -d * 2 * pt >= t - d * d - d * 2 * smx;
            // 2d * pt <= d * d + d * 2 * smx - t
            // pt <= (d * d + d * 2 * smx - t) / 2d
            __int128 lim_pt = min(__int128(L == sz(low) - 1 ? 8e18 : x0 + d * (times_l[R] - 1)), max(__int128(L >= 0 ? times_l[L] * d + x0 : 0ll), smartdivide((__int128(d * N) * d + __int128(d * 2) * smx  - t), (2 * d * N))));
            ll take = x0 + ((lim_pt-x0)/ d) * d;
            //cout << take << ' ' << ll((__int128(d * N) * d + __int128(d * 2) * smx - t)) << ' ' << 2 * d << ' ' << ll((__int128(d * N) * d + __int128(d * 2) * smx - t) / (2 * d))<<'\n';
            //cout << L << ' ' << take << '\n';
            //if(t==1)cout << take << ' ' << (ll) lim_pt << endl;

            bl1 = ((take - x0) / d) * t + pref_good_l[R] + suff_sql[R] + __int128(take * take * (sz(low) - R)) - __int128(2 * take) * suff_sml[R];
        }
        {
            int L = -1, R = sz(low);
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (lol2[M].second + times_l[M] * 2 * t <= lol2[M].first + (times_l[M] - 1) * 2 * t) {
                    L = M;
                } else {
                    R = M;
                }
            }
            ll smx = suff_sml[R];
            int N = sz(low) - R;
            // d * (d - 2 * pt + 2 * smx) >= t
            // -d * 2 * pt >= t - d * d - d * 2 * smx;
            // 2d * pt <= d * d + d * 2 * smx - t
            // pt <= (d * d + d * 2 * smx - t) / 2d
            __int128 lim_pt = min(__int128(L == sz(low) - 1 ? 8e18 : x0 + d * (times_l[R] - 1)), max(__int128(L >= 0 ? times_l[L] * d + x0 : 0ll), smartdivide((__int128(d * N) * d + __int128(d * 2) * smx  - 2 * t), (2 * d * N))));
            ll take = x0 + ((lim_pt-x0)/ d) * d;
            //if(t==1)cout << take << ' ' << (ll) lim_pt << endl;

            bl2 = ((take - x0) / d) * 2 * t + pref_good_l[R] + suff_sql[R] + __int128(take * take * (sz(low) - R)) - __int128(2 * take) * suff_sml[R];
        }
        //cout << ll(bl1) << ' ' << ll(bl2) << '\n';
        cout << ll(min(br1 + bl2, br2 + bl1)) << '\n';
    }
}

signed main() {
    int t = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> t;

    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    
    while (t--) {
        solve();
    }

    return 0;
}