#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct segtree {
    int n;
    vector<int> t;
    segtree() = default;
    segtree(int n_) {
        n = n_;
        t.assign(2 * n, -1);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = max(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = -1;
        while (l < r) {
            if (l & 1) ans = max(ans, t[l++]);
            if (r & 1) ans = max(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

struct segtree2 {
    int n;
    vector<int> t;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.assign(2 * n, 1e9);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = min(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = 1e9;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

__int128 smartdivide(__int128 x, __int128 y) {
    if (y == 0) return -1;
    return (x > 0 ? x / y : -((-x + y - 1) / y));
}

void solve() {
    int n; cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    ll x0, d; cin >> x0 >> d;

    vector<ll> big, low;
    for (int i = 0; i < n; i++) {
        if(x[i] >= x0) big.pb(x[i]);
        else low.pb(x[i]);
    }

    auto sq = [&](ll x) {
        return x * x;
    };

    sort(all(big)); sort(all(low));
    vector<ll> times(sz(big)), goodb(sz(big));
    for (int i = 0; i < sz(big); i++) {
        times[i] = (big[i] - x0 + d - 1) / d;
        goodb[i] = min(sq(big[i] - (x0 + d * times[i])), sq(big[i] - (x0 + d * (times[i] - 1))));
    }
    vector<int> BIG(sz(big)), EQR(sz(big));
    for (int i = sz(big) - 1; i >= 0; i--) {
        BIG[i] = (i + 1 < sz(big) && times[i + 1] == times[i] ? BIG[i + 1] : sz(big) - i - 1);
    }
    vector<ll> pref_good(sz(big) + 1);
    for(int i = 1; i <= sz(big); i++) pref_good[i] = pref_good[i - 1] + goodb[i - 1];
    vector<__int128> suff_sqb(sz(big) + 1), suff_smb(sz(big) + 1);
    for (int i = sz(big) -1; i >= 0; i--) {suff_smb[i] = suff_smb[i + 1] + big[i]; suff_sqb[i] = suff_sqb[i + 1] + big[i] * big[i]; }
    auto calc_big = [&](ll time, int goodpref) {
    
        __int128 ans = pref_good[goodpref] + suff_sqb[goodpref] + __int128((x0 + time * d))* __int128((x0 + time * d)) * (sz(big) - goodpref) - (__int128)2 * __int128(x0 + time * d) * suff_smb[goodpref];
        return ans;
    };
    vector<pair<__int128, __int128>> lol(sz(big));
    for (int i = 0; i < sz(big); i++) {
        int j = i;
        while (j+1<sz(big)&&times[j+1]==times[i])j++;
        for (int I = i; I <= j; I++) {
            EQR[I] = j - i + 1;
            lol[I].first = calc_big(times[i] - 1, i); lol[I].second = calc_big(times[i], j + 1);
        }
        i=j;
        //lol[i].first = calc_big(times[i] - 1, i); lol[i].second = calc_big(times[i], i + 1);
    }

    //-----------------------------------
    reverse(all(low));
    for (int i = 0; i < sz(low); i++) low[i] = 2 * x0 - low[i];

    vector<ll> times_l(sz(low)), goodl(sz(low));
    for (int i = 0; i < sz(low); i++) {
        times_l[i] =  (low[i] - x0 + d - 1) / d;
        goodl[i] = min(sq(low[i] - (x0 + d * times_l[i])), sq(low[i] - (x0 + d * (times_l[i] - 1))));
    }
    vector<int> BIG_LOW(sz(low));
    for (int i = sz(low) - 1; i >= 0; i--) {
        BIG_LOW[i] = (i+1<sz(low)&&times_l[i+1]==times_l[i] ? BIG_LOW[i+1]:sz(low)-i-1);
    }

    vector<ll> pref_good_l(sz(low) + 1);
    for(int i = 1; i <= sz(low); i++) pref_good_l[i] = pref_good_l[i - 1] + goodl[i - 1];
    vector<__int128> suff_sql(sz(low) + 1), suff_sml(sz(low) + 1);
    for (int i = sz(low) -1; i >= 0; i--) {suff_sml[i] = suff_sml[i + 1] + low[i]; suff_sql[i] = suff_sql[i + 1] + low[i] * low[i]; }

    auto calc_low = [&](ll time, int goodpref) {
        __int128 ans = pref_good_l[goodpref] + suff_sql[goodpref] + __int128((x0 + time * d))* __int128((x0 + time * d)) * (sz(low) - goodpref) - (__int128)2 * __int128(x0 + time * d) * suff_sml[goodpref];
        return ans;
    };
    vector<int> EQL(sz(low));
    vector<pair<__int128, __int128>> lol2(sz(low));
    for (int i = 0; i < sz(low); i++) {
        int j = i;
        while (j+1<sz(low)&&times_l[j+1]==times_l[i]){
            j++;
        }
        for (int I=i;I<=j;I++){
            EQL[I] = j - i + 1;
            lol2[I].first = calc_low(times_l[i] - 1, i); lol2[I].second = calc_low(times_l[i], I + 1);
        }
        i=j;
    }
    //cout << (ll)lol2[0].first << ' ' << (ll)lol2[0].second << '\n';
    constexpr ll INF = 8e18;

    int q;
    cin >> q;
    while (q--) {
        ll t; cin >> t;
        __int128 bl1 = INF, bl2 = INF, br1 = INF, br2 = INF;
        auto calc_r = [&](int time, int coef) {
            __int128 proh = time * 1ll * coef * t;
            int L = -1, R = sz(big);
            while(R-L>1){
                int M=(L+R)/2;
                if(times[M] <= time) L=M;
                else R = M;
            }
            return proh +calc_big(time, R);
        };
        auto calc_l = [&](int time, int coef) {
            __int128 proh = time * 1ll * coef * t;
            int L = -1, R = sz(low);
            while(R-L>1){
                int M=(L+R)/2;
                if(times_l[M] <= time) L=M;
                else R = M;
            }
            return proh +calc_low(time, R);
        };
        {
            ll L = -1, R = sz(big);
            while(R-L>1){
                ll M=(L+R)/2;
                if (calc_big(times[M], sz(big) - BIG[M]) + times[M] * t <= calc_big(times[M] - 1, sz(big) - BIG[M] - EQR[M]) + (times[M] - 1) * t) L = M;
                else R = M;
            }
            ll newl = (L == -1 ? -1 : times[L] - 1), newr = (R == sz(big) ? 1e9 : times[R] - 1);
            int goodpref = (L == -1 ? 0 : sz(big) - BIG[L]);
            while (newr - newl > 1) {
                int newm = (newl + newr) / 2;
                if (calc_big(newm, goodpref) + newm * t >= calc_big(newm + 1, goodpref) + (newm + 1) * t) newl = newm;
                else newr = newm;
            }

            // ll L = -1, R = 1e9;
            // while (R - L > 1) {
            //     int M = (L +R) / 2;
            //     if(calc_r(M+1,1)<=calc_r(M,1))L=M;
            //     else R=M;
            // }
            br1=calc_r(newr, 1);
        }
        {
            ll L = -1, R = 1e9;
            while (R - L > 1) {
                int M = (L +R) / 2;
                if(calc_r(M+1,2)<=calc_r(M,2))L=M;
                else R=M;
            }
            br2=calc_r(R, 2);
        }
        {
            ll L = -1, R = 1e9;
            while (R - L > 1) {
                int M = (L +R) / 2;
                if(calc_l(M+1,1)<=calc_l(M,1))L=M;
                else R=M;
            }
            bl1=calc_l(R, 1);
        }
        {
            ll L = -1, R = 1e9;
            while (R - L > 1) {
                int M = (L +R) / 2;
                if(calc_l(M+1,2)<=calc_l(M,2))L=M;
                else R=M;
            }
            bl2=calc_l(R, 2);
        }
        cout << ll(min(br1 + bl2, br2 + bl1)) << '\n';
    }
}

signed main() {
    int t = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> t;

    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    
    while (t--) {
        solve();
    }

    return 0;
}