#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

struct segtree {
    int n;
    vector<int> t;
    segtree() = default;
    segtree(int n_) {
        n = n_;
        t.assign(2 * n, -1);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = max(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = -1;
        while (l < r) {
            if (l & 1) ans = max(ans, t[l++]);
            if (r & 1) ans = max(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

struct segtree2 {
    int n;
    vector<int> t;
    segtree2() = default;
    segtree2(int n_) {
        n = n_;
        t.assign(2 * n, 1e9);
    }  

    void upd(int pos, int val) {
        pos += n;
        while (pos) {
            t[pos] = min(t[pos], val);
            pos >>= 1;
        }
    }
    int get(int l, int r) {
        l += n; r += n;
        int ans = 1e9;
        while (l < r) {
            if (l & 1) ans = min(ans, t[l++]);
            if (r & 1) ans = min(ans, t[--r]);
            l >>= 1; r >>= 1;
        }
        return ans;
    }
};

__int128 smartdivide(__int128 x, __int128 y) {
    if (y == 0) return -1;
    return (x > 0 ? x / y : -((-x + y - 1) / y));
}

void solve() {
    int n, d; cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i= 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].pb(v); g[v].pb(u);
    }

    vector<int> h(n);
    vector<vector<int>> byp(2);
    auto dfs = [&](int v, int p, auto&&self) -> void {
        byp[h[v]%2].pb(v);
        for (int u :g[v]) {
            if (u != p) {
                h[u]=h[v]+1;self(u,v,self);
            }
        }
    };
    dfs(0, 0, dfs);
    cout << min(sz(byp[0]), sz(byp[1])) << '\n';
    for (int i = 0; i < min(sz(byp[0]), sz(byp[1])); i++) cout << byp[0][i] + 1 << ' ' << byp[1][i] + 1 << '\n';
}

signed main() {
    int t = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> t;

    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    
    while (t--) {
        solve();
    }

    return 0;
}