#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;


struct segtree {
    vector<int> t;
    vector<int> p;
    void Build(int v, int tl, int tr, vector<int>& a) {
        if (tl == tr) {
            t[v] = a[tl];
            p[v] = -1;
            return;
        }
        int mid = (tl + tr) / 2;
        Build(v * 2 + 1, tl, mid, a);
        Build(v * 2 + 2, mid + 1, tr, a);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    void push(int v, int tl, int tr) {
        if (v * 2 + 2 < t.size() && p[v] != -1) {
            int mid = (tl + tr) / 2;
            p[v * 2 + 1] = p[v];
            p[v * 2 + 2] = p[v];
            t[v * 2 + 1] = (mid - tl + 1) * p[v];
            t[v * 2 + 2] = (tr -mid) * p[v];
            p[v] = -1;
        }
    }
    int query(int v, int tl, int tr, int ql, int qr) {
        push(v, tl, tr);
        if (ql > qr) return 0;
        if (tl == ql && tr == qr) {
            return t[v];
        }
        int mid = (tl + tr) / 2;
        return query(v * 2 + 1, tl, mid, ql, min(qr, mid)) + query(v * 2 + 2, mid + 1, tr, max(ql,mid + 1), qr);
    }
    void upd(int v, int tl, int tr, int pos, int x) {
        push(v, tl, tr);
        if (tl == tr) {
            t[v] += x;
            return;
        }
        int mid = (tl + tr) / 2;
        if (pos <= mid) {
            upd(v * 2 + 1, tl, mid, pos, x);
        } else {
            upd(v * 2 + 2, mid + 1, tr, pos, x);
        }
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    void updo(int v, int tl, int tr, int ql, int qr) {
        push(v, tl, tr);
        if (ql > qr) {
            return;
        }
        if (tl == ql && tr == qr) {
            t[v] = 0;
            p[v] = 0;
            return;
        }
        int mid = (tl + tr) / 2;
        updo(v * 2 + 1, tl, mid, ql, min(qr, mid));
        updo(v * 2 + 2, mid + 1, tr, max(ql, mid + 1), qr);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    segtree(int a) {
        t.resize(4 * a);
        p.resize(4 * a, -1);
    }
};


int32_t main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> t(h, vector<int>(w));
    for (int i = 0;i < h; ++i) {
        string s;
        cin >> s;
        for (int j=  0;j < s.size(); ++j) {
            if (s[j] == '0') {
                t[i][j] = 0;
            } else {
                t[i][j] = 1;
            }
        }
    }
    vector<vector<int>> hs(h, vector<int>(w));
    for (int i = 0;i < h; ++i) {
        for (int j = 0;j < w; ++j) {
            hs[i][j] += t[i][j];
            if (t[i][j] && i > 0) {
                hs[i][j] += hs[i - 1][j];
            }
        }
    }
    int ans = 0;
    vector<vector<int>> anss(h, vector<int>(w));
    for (int i = 0;i < h; ++i) {
        vector<int> st;
        for (int j = w - 1;j > -1;--j) {
            while (st.size() && hs[i][j] <=hs[i][st.back()]) {
                st.pop_back();
            }
            if (st.size()) {
                anss[i][j] = anss[i][st.back()] + abs(j - st.back()) * hs[i][j];
            } else {
                anss[i][j] = (w - j) * hs[i][j];
            }
            st.push_back(j);
            ans = max(anss[i][j], ans);
        }
    }
    cout << ans << '\n';
}
