//#define __GLIBCXX_DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
#define ll __int128_t
#define int ll
constexpr  ll inf = 1e15;

struct segtree {
    vector<ll> t;
    void upd(ll v, ll tl, ll tr, ll pos, ll x) {
        if (tl == tr) {
            t[v] = min(t[v], x);
            return;
        }
        ll mid = (tl + tr) / 2;
        if (pos <= mid) {
            upd(v * 2 + 1, tl, mid, pos, x);
        } else {
            upd(v * 2 + 2, mid + 1, tr, pos, x);
        }
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
    ll query(ll v, ll tl, ll tr, ll ql, ll qr) {
        if (ql > qr) {
            return inf;
        }
        if (tl == ql && tr == qr) {
            return t[v];
        }
        ll mid = (tl + tr) / 2;
        return min(query(v *2 + 1, tl, mid, ql, min(qr, mid)), query(v * 2 + 2, mid + 1, tr, max(ql, mid + 1), qr));
    }
    segtree(ll a) {
        t.resize(4 * a, inf);
    }
};

ll bp(ll a, ll p) {
    if (p == 1) {
        return a;
    }
    ll b = bp(a, p/2);
    return b * b * (p%2?a:1);
}

struct line {
    ll k, b;
    line():k(0),b(inf){}
    line(ll _k, ll _b):k(_k), b(_b){}
    ll get(ll x) {
        return k * x + b;
    }
};

struct LC {
    ll tl, tr;
    LC* l, *r;
    line a;
    LC(ll _tl, ll _tr) {
        tl = _tl;
        tr = _tr;
        l = nullptr;
        r = nullptr;
        a=  line();
    }
    void upd(line b) {
        ll mid = (tl + tr) / 2;
        if (a.get(mid) > b.get(mid)) {
            swap(a, b);
        }
        bool ld = a.get(tl) <= b.get(tl), rd =a.get(tr) <= b.get(tr);
        if (ld && rd) {
            return;
        }
        if (ld) {
            if (!r) {
                r = new LC(mid + 1, tr);
            }
            r->upd(b);
        }
        if (rd) {
            if (!l) {
                l = new LC(tl, mid);
            }
            l->upd(b);
        }
    }
    ll query(ll x) {
        ll mid = (tl + tr) / 2;
        ll ans = a.get(x);
        if (x <= mid && l) {
            ans = min(ans, l->query(x));
        }
        if (x >= mid && r) {
            ans = min(ans, r->query(x));
        }
        return ans;
    }
};

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int64_t n;
    cin >> n;
    vector<ll> c(n);
    for (int i = 0;i < n; ++i) {
        int64_t b;
        cin >> b;
        c[i] = b;
    }
    sort(c.begin(), c.end());
    int64_t x0, d;
    cin >> x0 >> d;
    ll sumsq = 0, sum = 0, cnt = 0;
    LC* st = new LC(0, (ll)1e8);
    for (ll i = 1e6;i > -1;--i) {
        while (c.size() && c.back() >= i) {
            sumsq += c.back() * c.back();
            sum += c.back();
            ++cnt;
            c.pop_back();
        }
        st->upd(line(i, i * i * cnt - 2 * sum * i * sumsq));
    }
    int64_t m=  0;
    cin >> m;
    for (int i = 0;i < m; ++i) {
        int64_t t;
        cin >> t;
        cout << (int64_t)st->query((ll)t) << '\n';
    }
}