#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <array>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

void solve() {
	int h, w; cin >> h >> w;
	vector<vector<char>> T(h, vector<char>(w));
	for (int i = 0; i < h; i++) {
		string tmp; cin >> tmp;
		for (int j = 0; j < w; j++) {
			T[i][j] = tmp[j];
		}
	}
	if (h < w) {
		vector<vector<char>> tmp(w, vector<char>(h));
		for (int i = 0; i < w; i++) {
			for (int j = 0; j < h; j++) {
				tmp[i][j] = T[h - 1 - j][w - 1 - i];
			}
		}
		swap(tmp, T);
		swap(h, w);
	}
	vector<int> max_height(w, 0);
	for (int j = 0; j < w; j++) {
		while (max_height[j] < h && T[h - 1 - max_height[j]][j] == '1') {
			max_height[j]++;
		}
	}
	int ans = 0;
	vector<array<int, 3>> stack_max{ {-1, w, 0} };
	int cur_sum = 0;
	for (int l = w - 1; l >= 0; l--) {
		int cur_h = max_height[l];
		while (stack_max.back()[0] >= cur_h) {
			cur_sum -= stack_max.back()[2];
			stack_max.pop_back();
		}
		stack_max.push_back({cur_h, l, (stack_max.back()[1] - l) * cur_h });
		cur_sum += stack_max.back()[2];
		ans = max(ans, cur_sum);
	}
	for (int bottom = h - 2; bottom >= 0; bottom--) {
		for (int j = 0; j < w; j++) {
			if (max_height[j] > 0) {
				max_height[j]--;
			}
			else {
				while (max_height[j] < bottom + 1 && T[bottom - max_height[j]][j] == '1') {
					max_height[j]++;
				}
			}
		}
		cur_sum = 0;
		stack_max = { {-1, w, 0} };
		for (int l = w - 1; l >= 0; l--) {
			int cur_h = max_height[l];
			while (stack_max.back()[0] >= cur_h) {
				cur_sum -= stack_max.back()[2];
				stack_max.pop_back();
			}
			stack_max.push_back({ cur_h, l, (stack_max.back()[1] - l) * cur_h });
			cur_sum += stack_max.back()[2];
			ans = max(ans, cur_sum);
		}
	}
	cout << ans;
}


int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*
6 4
0011
1101
0111
1110
0111
0100
*/
/*
5 5
00100
01110
01110
01000
00000
*/