#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

const int MAXN = 800000;

int leftt[MAXN], rightt[MAXN], max_elem[MAXN], sum[MAXN], setted[MAXN];

void build(int v, int l, int r) {
	leftt[v] = l, rightt[v] = r;
	sum[v] = max_elem[v] = 0;
	setted[v] = -1;
	if (l + 1 != r) {
		int m = (l + r) / 2;
		build(2 * v + 1, l, m);
		build(2 * v + 2, m, r);
	}
}

void push(int v) {
	if (setted[v] == -1) {
		return;
	}
	setted[2 * v + 1] = max_elem[2 * v + 1] = setted[v];
	setted[2 * v + 2] = max_elem[2 * v + 2] = setted[v];
	sum[2 * v + 1] = (rightt[2 * v + 1] - leftt[2 * v + 1]) * setted[v];
	sum[2 * v + 2] = (rightt[2 * v + 2] - leftt[2 * v + 2]) * setted[v];
	setted[v] = -1;
}

void set_seg(int qleft, int qright, int val, int v = 0) {
	if (qleft <= leftt[v] && rightt[v] <= qright) {
		sum[v] = (rightt[v] - leftt[v]) * val;
		max_elem[v] = val;
		setted[v] = val;
		return;
	}
	if (qright <= leftt[v] || rightt[v] <= qleft) {
		return;
	}
	if (setted[v] != -1) {
		push(v);
	}
	set_seg(qleft, qright, val, 2 * v + 1);
	set_seg(qleft, qright, val, 2 * v + 2);
	max_elem[v] = max(max_elem[2 * v + 1], max_elem[2 * v + 2]);
	sum[v] = sum[2 * v + 1] + sum[2 * v + 2];
}


int rightmost_geq(int x, int v = 0) {
	if (max_elem[v] < x) {
		return -1;
	}
	if (leftt[v] + 1 == rightt[v]) {
		return leftt[v];
	}
	if (setted[v] != 0) {
		push(v);
	}
	if (max_elem[2 * v + 2] >= x) {
		return rightmost_geq(x, 2 * v + 2);
	}
	return rightmost_geq(x, 2 * v + 1);
}

int get_sum(int qleft, int qright, int v = 0) {
	if (qleft <= leftt[v] && rightt[v] <= qright) {
		return sum[v];
	}
	if (qright <= leftt[v] || rightt[v] <= qleft) {
		return 0;
	}
	if (setted[v] != -1) {
		push(v);
	}
	return get_sum(qleft, qright, 2 * v + 1) + get_sum(qleft, qright, 2 * v + 2);
}

void solve() {
	int h, w; cin >> h >> w;
	build(0, 0, w);
	vector<vector<char>> T(h, vector<char>(w));
	for (int i = 0; i < h; i++) {
		string tmp; cin >> tmp;
		for (int j = 0; j < w; j++) {
			T[i][j] = tmp[j];
		}
	}
	if (h < w) {
		vector<vector<char>> tmp(w, vector<char>(h));
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				tmp[i][j] = T[w - 1 - j][h - 1 - i];
			}
		}
		swap(tmp, T);
		swap(h, w);
	}
	vector<int> max_height(w, 0);
	for (int j = 0; j < w; j++) {
		while (max_height[j] < h && T[h - 1 - max_height[j]][j] == '1') {
			max_height[j]++;
		}
	}
	int ans = 0;
	for (int l = w - 1; l >= 0; l--) {
		int pos = rightmost_geq(max_height[l]);
		set_seg(l, max(l, pos) + 1, max_height[l]);
		ans = max(ans, get_sum(l, w));
	}
	for (int bottom = h - 2; bottom >= 0; bottom--) {
		for (int j = 0; j < w; j++) {
			if (max_height[j] > 0) {
				max_height[j]--;
			}
			else {
				while (max_height[j] < bottom + 1 && T[bottom - max_height[j]][j] == '1') {
					max_height[j]++;
				}
			}
		}
		set_seg(0, w, 0);
		for (int l = w - 1; l >= 0; l--) {
			int pos = rightmost_geq(max_height[l]);
			set_seg(l, max(l, pos) + 1, max_height[l]);
			ans = max(ans, get_sum(l, w));
		}
	}
	cout << ans;
}


int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*
6 4
0011
1101
0111
1110
0111
0100
*/
/*
5 5
00100
01110
01110
01000
00000
*/