#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <array>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

struct Segment {
	int l, m, r, id;
	Segment(int a = 0, int b = 0, int c = 0, int i = 0) : l(a), m(b), r(c), id(i) {}
	bool operator< (Segment other) {
		if (r != other.r) {
			return (r < other.r);
		}
		if (m != other.m) {
			return (m < other.m);
		}
		if (l != other.l) {
			return (l < other.l);
		}
		return (id < other.id);
	}
};

static const int INF = 1e9;

void solve() {
	int n, k; cin >> n >> k;
	vector<Segment> segs(k);
	for (auto& p : segs) {
		cin >> p.l >> p.m >> p.r;
	}
	sort(all(segs));
	vector<int> dp(n + 1, INF);
	dp[0] = 0;
	for (auto& s : segs) {
		if (dp[s.r] <= s.m) {
			continue;
		}
		for (int r_prev = s.l - 1; r_prev < s.m; r_prev++) {
			if (dp[r_prev] < INF) {
				dp[s.r] = s.m;
				break;
			}
		}
		if (dp[s.r] <= s.m) {
			continue;
		}
		for (int r_prev = s.m; r_prev <= s.r; r_prev++) {
			if (dp[r_prev] < s.l) {
				dp[s.r] = s.m;
				break;
			}
		}
	}
	if (dp[n] < INF) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}


int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
*/