#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <array>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x.size())

using lng = long long;

vector<vector<int>> g;
vector<vector<int>> colors_list;

void dfs_colors(int v, int p, int c) {
	colors_list[c].push_back(v);
	for (auto u : g[v]) {
		if (u != p) {
			dfs_colors(u, v, c ^ 1);
		}
	}
}

void solve() {
	int n, d; cin >> n >> d;
	g.assign(n, vector<int>(0));
	for (int i = 1; i < n; i++) {
		int x, y; cin >> x >> y; --x; --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	colors_list = { {}, {} };
	dfs_colors(0, -1, 0);
	cout << min(sz(colors_list[0]), sz(colors_list[1])) << '\n';
	for (int i = 0; i < min(sz(colors_list[0]), sz(colors_list[1])); i++) {
		cout << colors_list[0][i] + 1 << ' ' << colors_list[1][i] + 1 << '\n';
	}
}


int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*
3
4 0 7
2 3
7
0
1
2
3
4
23
25
*/