// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <csetjmp>
#include <cstdarg>
#include <cstddef>
#include <cstdlib>

#if __cplusplus >= 201103L
#include <cstdint>
#endif

// C++
// #include <bitset>
// #include <complex>
#include <algorithm>
#include <bitset>
#include <functional>
#include <iterator>
#include <limits>
#include <memory>
#include <new>
#include <numeric>
#include <typeinfo>
#include <utility>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <initializer_list>
#include <ratio>
#include <scoped_allocator>
#include <tuple>
#include <typeindex>
#include <type_traits>
#endif

#if __cplusplus >= 201402L
#endif

#if __cplusplus >= 201703L
#include <any>
// #include <execution>
#include <optional>
#include <variant>
#include <string_view>
#endif

#if __cplusplus >= 202002L
#include <bit>
#include <compare>
#include <concepts>
#include <numbers>
#include <ranges>
#include <span>
#include <source_location>
#include <version>
#endif

#if __cplusplus > 202002L
#include <expected>
#include <stdatomic.h>
#if __cpp_impl_coroutine
# include <coroutine>
#endif
#endif

#if _GLIBCXX_HOSTED
// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cwchar>
#include <cwctype>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#endif

// C++
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

#if __cplusplus >= 201402L
#include <shared_mutex>
#endif

#if __cplusplus >= 201703L
#include <any>
#include <charconv>
// #include <execution>
#include <filesystem>
#include <optional>
#include <memory_resource>
#include <variant>
#endif

#if __cplusplus >= 202002L
#include <barrier>
#include <bit>
#include <compare>
#include <concepts>
#include <latch>
#include <numbers>
#include <ranges>
#include <span>
#include <stop_token>
#include <semaphore>
#include <source_location>
#include <syncstream>
#include <version>
#endif

#if __cplusplus > 202002L
#include <expected>
#include <spanstream>
#if __has_include(<stacktrace>)
# include <stacktrace>
#endif
#include <stdatomic.h>
#include <stdfloat>
#endif

#endif // HOSTED
#include <iostream>
using namespace std;

typedef long double dl;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
#define all(x) x.begin(),x.end()
#define for0(i,n) for(ll i = 0; i < (n);i++)
#define fi first
#define se second
#define pub push_back
#define pob pop_back

template<typename T1, typename T2>
istream& operator >>(istream& in, pair<T1, T2>& a){
    in >> a.fi >> a.se;
    return in;
}

template<typename T1, typename T2>
ostream& operator <<(ostream& out, pair<T1, T2>& a){
    out << a.fi << " " << a.se;
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T>& a){
    for(T& ai : a) in >> ai;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T>& a){
    for(T& ai : a) out << ai << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<vector<T>>& a){
    for(vector<T>& row : a){
        for (T& ai : row){
            in >> ai;
        }
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<vector<T>>& a){
    for(vector<T>& row : a){
        for (T& ai : row){
            out << ai << " ";
        }
        out << endl;
    }
    return out;
}

int n, d;
vvi g;
vvi dp;
vector<bool> used;
vi p;
vi take;
vvi ans;

const int maxn = 15;
int up[maxn][30];
int T = 0;
int tin[maxn];
int tout[maxn];
int dist[maxn];

bool isa(int v, int u){
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

void dfs(int v){
    for(int k = 1; k < 30; k++){
        up[v][k] = up[up[v][k-1]][k-1];
    }
    bool isleaf = true;
    used[v] = true;
    int s = 0;
    tin[v] = T++;
    for(int u : g[v]){
        if (used[u]) continue;
        p[u] = v;
        up[u][0] = v;
        dist[u] = dist[v]+1;
        dfs(u);
        s += dp[u][1];
        isleaf = false;
    }
    if (isleaf){
        return;
    }
    dp[v][0] = s;
    dp[v][1] = s;
    take[v] = v;
    for(int u : g[v]){
        if (u == p[v]) continue;
        int val = s-dp[u][1]+dp[u][0]+1;
        if (val > dp[v][1]){
            take[v] = u;
            dp[v][1] = val;
        }
    }
    tout[v] = T++;
}

int lca(int v, int u){
    if (isa(v,u)) return v;
    if (isa(u,v)) return u;
    for(int k = 29; k >= 0; k--){
        if (!isa(up[v][k], u)) v = up[v][k];
    }
    return up[v][0];
}

int getd(int v, int u){
    return dist[v] + dist[u] - 2 * dist[lca(v,u)];
}

void dfs2(int v, int totake){
    //cout << v << totake << endl;
    if (totake == 1 && take[v] != -1 && v != take[v]){
        ans.pub({v+1,take[v]+1});
    }
    for(int u : g[v]){
        if (u == p[v]) continue;
        if (totake == 1 && u == take[v]){
            dfs2(u,0);
        }else{
            dfs2(u,1);
        }
    }
}

void solve(){
    int v, u;
    cin >> n >> d;
    g = vvi(n);
    take = vi(n,-1);
    ans.clear();
    for0(i,n-1){
        cin >> v >> u;
        v--; u--;
        g[v].pub(u);
        g[u].pub(v);
    }
    p = vi(n);
    dp = vvi(n, vi(2));
    used = vector<bool>(n);
    up[0][0] = 0;
    dist[0] = 0;
    dfs(0);

    
    vi a;
    for0(i,n) a.pub(i);
    for0(I,1e5){
        for0(i,100){
            swap(a[rand()%a.size()],a[rand()%a.size()]);
        }
        vvi newans;
        for(int k = 0; k+1 < n; k += 2){
            int curd = getd(a[k], a[k+1]);
            if (curd % 2 == 1 && curd <= d){
                newans.pub({a[k]+1, a[k+1]+1});
            }
        }
        if (newans.size() > ans.size()) ans = newans;
    }

    cout << ans.size() << endl << -1 << endl;
    //for(vi& ansi : ans) cout << ansi << endl;
}

signed main()
{
    srand(42);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

