#include <bits/stdc++.h>
using namespace std;
#define int long long

struct seg {
  int l, m, r;
};
int n, k;
const int N = 5e5 + 5;
int tree[N * 4];
void build(int x = 0, int lx = 0, int rx = n + 1) {
  if (rx - lx == 1) {
    tree[x] = -1;
    return;
  }
  int mx = (lx + rx) / 2;
  build(x * 2 + 1, lx, mx);
  build(x * 2 + 2, mx, rx);
  tree[x] = -1;
}

void update(int i, int v, int x = 0, int lx = 0, int rx = n + 1) {
  if (i < lx or rx <= i) return;
  if (rx - lx == 1) {
    tree[x] = min(tree[x], v);
    if (tree[x] == -1) tree[x] = v;
    return;
  }
  int mx = (lx + rx) / 2;
  update(i, v, x * 2 + 1, lx, mx);
  update(i, v, x * 2 + 2, mx, rx);
  tree[x] = min(tree[x * 2 + 1], tree[x * 2 + 2]);
  if (tree[x * 2 + 1] == -1)
    tree[x] = tree[x * 2 + 2];
  else if (tree[x * 2 + 2] == -1)
    tree[x] = tree[x * 2 + 1];
}

int get(int l, int r, int x = 0, int lx = 0, int rx = n + 1) {
  if (l <= lx and rx <= r) return tree[x];
  if (r <= lx or rx <= l) return -1;
  int mx = (lx + rx) / 2;
  int fv = get(l, r, x * 2 + 1, lx, mx),
      sv = get(l, r, x * 2 + 2, mx, rx);
  if (fv == -1) return sv;
  if (sv == -1) return fv;
  return min(fv, sv);
}

signed main() {
  // ios_base::sync_with_stdio(0);
  // cin.tie(0);
  int t;
  cin >> t;
  while (t--) {
    cin >> n >> k;
    build();
    vector <seg> a(k);
    for (int i = 0; i < k; i++) {
      cin >> a[i].l >> a[i].m >> a[i].r;
    }
    update(0, 0);
    sort(a.begin(), a.end(), [](seg a1, seg a2) { return a1.r < a2.r; });
    for (int i = 0; i < k; i++) {
      if (get(a[i].l - 1, a[i].m) != -1) {
        update(a[i].r, a[i].m);
      }
      if (get(a[i].m, a[i].r + 1) < a[i].l and get(a[i].m, a[i].r + 1) != -1) {
        update(a[i].r, a[i].m);
      }
    }
    if (get(n, n + 1) != -1)
      cout << "YES\n";
    else
      cout << "NO\n";
  }

  return 0;
}
