#include <iostream>
#include <algorithm>
#include <map>
#include <cmath>
#include <vector>

using namespace std;
using ll = long long;
using ll1 = long long;

ll cnt(ll i, ll r, ll l, vector<vector<ll>>& a, ll pr) {
	ll ans = 0;
	ll mx = pr - r;
	while (i >= 0 && a[i][l] + l - 1 >= r) {
		ll cur = a[i][l] + l - r;
		if (cur > mx) {
			cur = mx;
		}
		else
			mx = cur;
		ans += cur;
		i--;
	}
	return ans;
}

ll solve1() {
	ll h, w;
	cin >> h >> w;
	vector<vector<ll>> a(h, vector<ll>(w));
	for (ll i = 0; i < h; i++)
	{
		for (ll j = 0; j < w; j++)
		{
			char c;
			cin >> c;
			a[i][j] = (ll)(c - '0');
		}
	}
	for (ll i = h - 1; i >= 0; i--)
	{
		for (ll j = w - 1; j >= 0; j--)
		{
			if (a[i][j] == 0) {
				a[i][j] = 0;
				continue;
			}
			a[i][j] = 1;
			if (j + 1 < w)
				a[i][j] += a[i][j + 1];
		}
	}
	vector<vector<ll> > dp(h, vector<ll>(w, 0));
	ll ans = 0;
	for (ll i = 0; i < h; i++)
	{
		for (ll j = 0; j < w; j++)
		{
			dp[i][j] = a[i][j];
			if (a[i][j] == 0)
				continue;
			if (i - 1 >= 0) {
				if (a[i - 1][j] <= a[i][j])
					dp[i][j] += dp[i - 1][j];
				else {
					dp[i][j] += dp[i - 1][j];
					dp[i][j] -= cnt(i - 1, j + a[i][j], j, a, j + a[i - 1][j]);
				}
			}
			if (dp[i][j] > ans)
				ans = dp[i][j];
		}
	}
	cout << ans;
	return 0;
}

struct emp {
	ll l, m, r;
};

bool cmp(emp& a, emp& b) {
	if (a.l == b.l) {
		if (a.r == b.r)
			return a.m < b.m;
		return a.r> b.r;
	}
	return a.l < b.l;
}
vector<ll> tr2;
vector<bool> psh;

void pfh(ll v, ll l, ll r) {
	tr2[v] = r - l;
	if (r - l > 1) {
		psh[v * 2 + 1] = true;
		psh[v * 2 + 2] = true;
	}
}
void upd(ll v, ll l, ll r, ll ql, ll qr) {
	if (psh[v])
		pfh(v, l, r);
	if (ql >= r || qr <= l)
		return;
	if (ql <= l && qr >= r) {
		psh[v] = true;
		pfh(v, l, r);
		return;
	}
	ll m = (l + r) / 2;
	upd(v * 2 + 1, l, m, ql, qr);
	upd(v * 2 + 2, m, r, ql, qr);
	tr2[v] = tr2[v * 2 + 1] + tr2[v * 2 + 2];
}

void upd(ll v, ll l, ll r, ll q) {
	if (psh[v])
		pfh(v, l, r);
	if (r - l == 1) {
		tr2[v] = 1;
		return;
	}
	ll m = (l + r) / 2;
	if (q < m)
		upd(v * 2 + 1, l, m, q);
	else
		upd(v * 2 + 2, m, r, q);
	tr2[v] = tr2[v * 2 + 1] + tr2[v * 2 + 2];
}


ll get(ll v, ll l, ll r, ll q) {
	if (psh[v])
		pfh(v, l, r);
	if (r - l == 1) {
		return tr2[v];
	}
	ll m = (l + r) / 2;
	if (q < m)
		 return get(v * 2 + 1, l, m, q);
	else
		return get(v * 2 + 2, m, r, q);
}

bool ans = false;
vector<vector<ll>> g;
vector<bool> used;

void dfs(ll v, vector<emp> &a) {
	used[v] = true;
	for (auto u : g[v]) {
		if (!used[u])
			dfs(u, a);
	}
	if (get(0, 0, tr2.size()/4, a[v].m - 1) == 0)
		upd(0, 0, tr2.size() / 4, a[v].l - 1, a[v].r);
	
	
}

void solve2() {
	ll n, k;
	cin >> n >> k;
	vector<emp> a(k);
	for (ll i = 0; i < k; i++)
	{
		cin >> a[i].l >> a[i].m >> a[i].r;
	}
	tr2.assign(4 * n, 0);
	psh.assign(4 * n , 0);
	g.assign(k, vector<ll>(0));
	used.assign(k, false);
	sort(a.begin(), a.end(), cmp);
	ans = false;
	for (ll i = 0; i < k; i++)
	{
		for (ll j = i+1; j < k; j++)
		{
			if (a[i].l <= a[j].m && a[j].m <= a[i].r) {
				g[i].push_back(j);

			}
			if (a[j].l <= a[i].m && a[i].m <= a[j].r) {
				g[j].push_back(i);
			}
		}
	}
	for (ll i = 0; i < k; i++)
	{
		if (!used[i])
			dfs(i, a);
	}
	if (tr2[0] == n) {
		cout << "YES";
	}
	else
		cout << "NO";
	cout << "\n";
}

void solve3() {
	ll n;
	cin >> n;
	vector<ll> x(n);
	for (ll i = 0; i < n; i++) {
		cin >> x[i];
	}
	ll x0, d;
	cin >> x0 >> d;
	ll m;
	cin >> m;
	vector<ll> t(m);
	vector<ll> ans(m, LLONG_MAX);
	vector<ll1> mn(n);
	for (ll i = 0; i < m; i++) {
		cin >> t[i];
	}
	sort(x.begin(), x.end());
	ll1 sum = 0;
	for (ll k = 0; k == 0 || x0 + (k - 1) * d <= x[n - 1]; k++)
	{
		for (ll i = 0; i < n; i++)
		{
			sum -= mn[i];
			ll1 f1 = (ll1)(x0 + d * k - x[i]) * (ll1)(x0 + d * k - x[i]);
			if (k == 0)
				mn[i] = f1;
			else
				mn[i] = min(mn[i], f1);
			sum += mn[i];
		}

		for (ll i = 0; i < m; i++)
		{

			ll cur = k * t[i] + sum;
			if (k == 0)
				ans[i] = cur;
			else
				ans[i] = min(ans[i], cur);
		}
	}
	for (ll i = 0; i < m; i++)
	{
		cout << (ll)ans[i] << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	cin >> t;
	while (t--)
		solve2();
}
