#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;
using ll = long long;

ll cnt(ll i, ll r, ll l, vector<vector<ll>>& a, ll pr) {
	ll ans = 0;
	ll mx = pr - r;
	while (i >= 0 && a[i][l] + l - 1 >= r) {
		ll cur = a[i][l] + l - r;
		if (cur > mx) {
			cur = mx;
		}
		else
			mx = cur;
		ans += cur;
		i--;
	}
	return ans;
}

ll solve1() {
	ll h, w;
	cin >> h >> w;
	vector<vector<ll>> a(h, vector<ll>(w));
	for (ll i = 0; i < h; i++)
	{
		for (ll j = 0; j < w; j++)
		{
			char c;
			cin >> c;
			a[i][j] = (ll)(c - '0');
		}
	}
	for (ll i = h - 1; i >= 0; i--)
	{
		for (ll j = w - 1; j >= 0; j--)
		{
			if (a[i][j] == 0) {
				a[i][j] = 0;
				continue;
			}
			a[i][j] = 1;
			if (j + 1 < w)
				a[i][j] += a[i][j + 1];
		}
	}
	vector<vector<ll> > dp(h, vector<ll>(w, 0));
	ll ans = 0;
	for (ll i = 0; i < h; i++)
	{
		for (ll j = 0; j < w; j++)
		{
			dp[i][j] = a[i][j];
			if (a[i][j] == 0)
				continue;
			if (i - 1 >= 0) {
				if (a[i - 1][j] <= a[i][j])
					dp[i][j] += dp[i - 1][j];
				else {
					dp[i][j] += dp[i - 1][j];
					dp[i][j] -= cnt(i - 1, j + a[i][j], j, a, j + a[i - 1][j]);
				}
			}
			if (dp[i][j] > ans)
				ans = dp[i][j];
		}
	}
	cout << ans;
	return 0;
}

struct emp {
	ll l, m, r;
};

bool cmp(emp& a, emp& b) {
	if (a.m == b.m) {
		if (a.l == b.l)
			return a.r < b.r;
		return a.l < b.l;
	}
	return a.m < b.m;
}
vector<ll> tr2;
vector<bool> psh;

void pfh(ll v, ll l, ll r) {
	tr2[v] = r - l;
	if (r - l > 1) {
		psh[v * 2 + 1] = true;
		psh[v * 2 + 2] = true;
	}
}
void upd(ll v, ll l, ll r, ll ql, ll qr) {
	if (psh[v])
		pfh(v, l, r);
	if (ql >= r || qr <= l)
		return;
	if (ql <= l && qr >= r) {
		psh[v] = true;
		pfh(v, l, r);
		return;
	}
	ll m = (l + r) / 2;
	upd(v * 2 + 1, l, m, ql, qr);
	upd(v * 2 + 2, m, r, ql, qr);
	tr2[v] = tr2[v * 2 + 1] + tr2[v * 2 + 2];
}

bool ans = false;

void fun2(vector<emp>& a, ll id) {
	bool t = true;
	for (ll i = 1; i < psh.size(); i++) {
		if (!psh[i]) {
			t = false;
			break;
		}
	}
	if (t) {
		ans = true;
		return;
	}
	if (id == a.size())
		return;
	for (ll i = 0; i < a.size(); i++)
	{
		if (psh[a[i].m])
			continue;
		vector<bool> pr = psh;
		for (ll j = a[i].l; j < a[i].r + 1; j++)
		{
			psh[j] = true;
		}
		fun2(a, id + 1);
		psh = pr;
	}
}

void solve2() {
	ll n, k;
	cin >> n >> k;
	vector<emp> a(k);
	vector<bool> used(k, 0);
	for (ll i = 0; i < k; i++)
	{
		cin >> a[i].l >> a[i].m >> a[i].r;
	}
	sort(a.begin(), a.end(), cmp);
	ans = false;
	vector<bool> dp(n + 1, 0);
	dp[0] = true;
	for (ll i = 0; i < k; i++)
	{
		ll pos = false;
		for (ll j = max(0ll, a[i].l - 1); j < a[i].m; j++)
		{
			if (dp[j]) {
				pos = true;
				break;
			}
		}
		if (!pos) {
			continue;
		}
		dp[a[i].r] = true;
	}
	if (dp[n]) {
		cout << "YES";
	}
	else
		cout << "NO";
	cout << "\n";
}


void solve3() {
	ll n;
	cin >> n;
	vector<ll> x(n);
	for (ll i = 0; i < n; i++) {
		cin >> x[i];
	}
	ll x0, d;
	cin >> x0 >> d;
	ll m;
	cin >> m;
	vector<ll> t(m);
	for (ll i = 0; i < m; i++) {
		cin >> t[i];
	}
	sort(x.begin(), x.end());
	ll fb = lower_bound(x.begin(), x.end(), x0) - x.begin();
	for (ll i = 0; i < m; i++)
	{
		__int128 ans = 1e9;
		ll l = (x[0] - x0) / d - 1, r = (x[0] - x0 + d - 1) / d + 1;
		if (x[0] < x0)
			r = 0;
		else
			l = 0;
		while (l + 1 < r) {
			if (r - l < 3) {
				while (l < r) {

					__int128 f = abs(l) * t[i] + (__int128)(x0 + d * l - x[0]) * (__int128)(x0 + d * l - x[0]);
					ans = min(ans, f);
					l++;
				}
				break;
			}
			ll m1 = l + (r - l) / 3;
			ll m2 = r - (r - l) / 3;
			if (m2 < m1)
				swap(m1, m2);
			__int128 f1 = abs(m1) * t[i] + (__int128)(x0 + d * m1 - x[0]) * (__int128)(x0 + d * m1 - x[0]);
			__int128 f2 = abs(m2) * t[i] + (__int128)(x0 + d * m2 - x[0]) * (__int128)(x0 + d * m2 - x[0]);
			ans = min(ans, f1);
			ans = min(ans, f2);
			if (f1 <= f2) {
				r = m2;
			}
			if (f2 <= f1)
				l = m1;
		}
		ll ans1 = ans;
		cout << ans1 << " ";
	}


}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--)
		solve3();
}