#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()
#define rall(t) t.rbegin(), t.rend()

using namespace std;

const int N = 3e5 + 5;
const ll INF = 8e18;

ll a[N], n;
ll t[N * 4], psh[N * 4];
ll ans[N];

void build(int v = 0, int l = 0, int r = n - 1) {
    if (l == r) {
        t[v] = a[l];
        return;
    }
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    build(lt, l, m);
    build(rt, m + 1, r);
    t[v] = t[lt] + t[rt];
}

void push(int v, int l, int r) {
    if (psh[v] == 0)
        return;
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    t[lt] += psh[v] * (m - l + 1);
    t[rt] += psh[v] * (r - m);
    psh[lt] += psh[v];
    psh[rt] += psh[v];
    psh[v] = 0;
}

ll get(int ql, int qr, int v = 0, int l = 0, int r = n - 1) {
    if (r < ql || qr < l) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    push(v, l, r);
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    return get(ql, qr, lt, l, m) + get(ql, qr, rt, m + 1, r);
}

void update(int ql, int qr, ll x, int v = 0, int l = 0, int r = n - 1) {
    if (r < ql || qr < l) {
        return;
    }
    if (ql <= l && r <= qr) {
        t[v] += x * (r - l + 1);
        psh[v] += x;
        return;
    }
    push(v, l, r);
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    update(ql, qr, x, lt, l, m);
    update(ql, qr, x, rt, m + 1, r);
}

void solve() {
    int i, j, k, q;
    cin >> n;
    vector <int> xx(n);
    for (i = 0; i < n; i++) {
        cin >> xx[i];
    }
    ll x0, d;
    cin >> x0 >> d;
    sort(all(xx));
    __int128_t cur = 0;
    for (i = 0; i < n; i++) {
        xx[i] -= x0;
        a[i] = xx[i];
        cur += a[i] * a[i];
    }
    build();
    cin >> q;
    vector <pair<ll, int>> qq(q);
    for (i = 0; i < q; i++) {
        cin >> qq[i].first;
        qq[i].second = i;
        if (cur < INF)
            ans[i] = cur;
    }
    sort(rall(qq));
    map <ll, ll> bonus;
    for (i = 0; i < n; i++) {
        if (a[i] % d == 0)
            continue;
        if (a[i] < 0) {
            ll dl = d - abs(a[i]) % d;
            if (dl < abs(a[i]) % d)
                bonus[-(abs(a[i]) / d) - 1] += dl * dl - (abs(a[i]) % d) * (abs(a[i]) % d);
        }
        else {
            ll dl = d - a[i] % d;
            if (dl < a[i] % d)
                bonus[a[i] / d + 1] += dl * dl - (a[i] % d) * (a[i] % d);
        }
    }
    int l = lower_bound(all(xx), 0) - xx.begin() - 1;
    int r = lower_bound(all(xx), 0) - xx.begin();
    ll k1 = 0, k2 = 0;
    for (auto [y, ix]:qq) {
        ans[ix] = min(ans[ix], (ll)cur + (min(k1, k2) * 2 + max(k1, k2)) * y);
        while (r < n && a[r] < (k1 + 1) * d) {
            r ++;
        }
        while (l >= 0 && abs(a[l]) < (k2 + 1) * d) {
            l --;
        }
        ll delta1 = y * (k1 < k2 ? 2 : 1) + bonus[k1 + 1] - 2 * get(r, n - 1) * d + d * d * (n - r);
        ll delta2 = y * (k2 < k1 ? 2 : 1) + bonus[-k2 - 1] - 2 * get(0, l) * d + d * d * (l + 1);
        while (delta1 < 0 || delta2 < 0) {
            if (delta2 < 0) {
                k2 ++;
                update(0, l, -d);
                cur += delta2 - y * (k2 - 1 < k1 ? 2 : 1);
            }
            else {
                k1 ++;
                update(r, n - 1, -d);
                cur += delta1 - y * (k1 - 1 < k2 ? 2 : 1);
            }
            ans[ix] = min(ans[ix], (ll)cur + (min(k1, k2) * 2 + max(k1, k2)) * y);
            while (r < n && a[r] < (k1 + 1) * d) {
                r ++;
            }
            while (l >= 0 && abs(a[l]) < (k2 + 1) * d) {
                l --;
            }
            delta1 = y * (k1 < k2 ? 2 : 1) + bonus[k1 + 1] - 2 * get(r, n - 1) * d + d * d * (n - r);
            delta2 = y * (k2 < k1 ? 2 : 1) + bonus[-k2 - 1] - 2 * get(0, l) * d + d * d * (l + 1);
        }
    }
    for (i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }
}

main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
