#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;

// #define int ll


struct node {
    int mx;

    node() : mx(0) {}
    node(int mx) : mx(mx) {}
};

node operator+(node &a, node &b) {
    return node (max(a.mx, b.mx));
}

struct seg_tree {
    int sz;
    vector<node> t;

    seg_tree(int sz_) {
        sz = sz_;
        t.resize(4 * sz);
    }

    void upd(int ind) {
        upd(0, 0, sz, ind);
    }
    void upd(int v, int l, int r, int ind) {
        if (l + 1 == r) {
            t[v].mx = 1;
            return;
        }
        int m = (l + r) / 2;
        int l_u = 2 * v + 1, r_u = 2 * v + 2;
        if (ind < m) upd(l_u, l, m, ind);
        else upd(r_u, m, r, ind);
        t[v] = t[l_u] + t[r_u];
    }

    int get(int ql, int qr) {
        return get(0, 0, sz, ql, qr).mx;
    }
    node get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return node();
        if (ql <= l && r <= qr) return t[v];
        int m = (l + r) / 2;
        int l_u = 2 * v + 1, r_u = 2 * v + 2;
        node res_l = get(l_u, l, m, ql, qr);
        node res_r = get(r_u, m, r, ql, qr);
        return (res_l + res_r);
    }
};


struct l_m {
    int l, m;
};


void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<l_m>> a(n + 1);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        l--;
        a[r].push_back({l, m});
    }


    seg_tree st(n + 1);
    st.upd(0);
    for (int i = 1; i <= n; i++) {
        bool have = false;
        for (auto &j : a[i]) {
            if (st.get(j.l, j.m) == 1) {
                have = true;
                break;
            }
        }
        if (i == n) {
            if (have) {
                cout << "YES" << endl;
            } else {
                cout << "NO" << endl;
            }
        }
        if (have) {
            st.upd(i);
        }
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
