#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("popcnt,avx,avx2")

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pii = pair<int, int>;

// #define int ll


int n;
vector<vector<int>> g;

vector<int> bfs(int s) {
    vector<int> d(n, -1);
    d[s] = 0;
    deque<int> q;
    q.push_back(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto u : g[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                q.push_back(u);
            }
        }
    }
    return d;
}


int deg2(int deg) {
    return (1 << deg);
}
bool have(int mask, int deg) {
    return (mask & deg2(deg));
}


signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }


    vector<vector<int>> dist(n);
    for (int i = 0; i < n; i++) {
        dist[i] = bfs(i);
    }


    vector<bool> dp(deg2(n), false);
    vector<vector<pii>> par(deg2(n));
    dp[0] = true;
    vector<pii> ans;
    for (int mask = 0; mask < deg2(n); mask++) {
        if (!dp[mask]) continue;
        for (int a = 0; a < n; a++) {
            for (int b = 0; b < n; b++) {
                if (dist[a][b] <= d && dist[a][b] % 2 == 1 && !have(mask, a) && !have(mask, b)) {
                    int new_mask = mask + deg2(a) + deg2(b);
                    if (!dp[new_mask]) {
                        dp[new_mask] = true;
                        par[new_mask] = par[mask];
                        par[new_mask].push_back({a, b});
                        if (par[new_mask].size() > ans.size()) {
                            ans = par[new_mask];
                        }
                    }
                }
            }
        }
    }


    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b + 1 << "\n";
    }
}