#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>>a;

int dfs(int v, vector<bool>& used, vector<int>&dp, vector<int>&next_less, int col) {
	if (v == -1) return 0;
	if (used[v]) return dp[v];
	used[v] = 1;
	return dp[v] = dfs(next_less[v], used, dp, next_less, col) + a[v][col] * (v - next_less[v]);
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int h, w;
	cin >> h >> w;
	vector<vector<bool>>base(h, vector<bool>(w));
	a.resize(h, vector<int>(w));
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			char c;
			cin >> c;
			base[i][j] = (c == '1');
		}
	}
	for (int i = 0; i < h; ++i) {
		int cur = 0;
		for (int j = w - 1; j >= 0; --j) {
			if (base[i][j] == 0) cur = 0;
			cur += base[i][j];
			a[i][j] = cur;
		}
	}

	int res = 0;
	vector<int>st;
	vector<int>next_less(h + 1, -1);
	vector<bool>used(h);
	vector<int>dp(h);
	for (int col = 0; col < w; ++col) {
		st.clear();
		for (int i = h - 1; i >= 0; --i) {
			used[i] = dp[i] = 0;
			next_less[i] = -1;
			while (!st.empty() && a[i][col] < a[st.back()][col]) {
				next_less[st.back()] = i;
				st.pop_back();
			}
			st.push_back(i);
		}
		int start = h - 1;
		while (start > -1) {
			res = max(res, dfs(start, used, dp, next_less, col));
			while (start > -1 && used[start]) --start;
		}
	}
	cout << res << "\n";
}
