
#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;

vector<vector<int>>g;
vector<int>used;

bool dfs(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		if (used[u] == 1) return 1;
		if (used[u] == 2) continue;
		if (dfs(u)) return 1;
	}
	used[v] = 2;
	return 0;
}

void solve() {
	g.clear();
	used.clear();
	int n, k;
	cin >> n >> k;
	swap(n, k);
	vector<tuple<int, int, int>>a(n);
	vector<tuple<int, int, int>>events;
	for (int i = 0; i < n; ++i) {
		int l, m, r;
		cin >> l >> m >> r;
		--l; --m;
		a[i] = { m, l, r };
	}
	{
		sort(a.begin(), a.end());
		for (int i = 0; i < n; ++i) {
			auto [m, l, r] = a[i];
			events.push_back({ l, -1, i });
			events.push_back({ r, 1, i });
		}
		sort(events.begin(), events.end());
		int cur = 0;
		int mx = 0;
		vector<bool>bad(n);
		int L = -1;
		int ind = -1;
		for (auto [x, t, i] : events) {
			cur -= t;
			if (t == -1) {
				auto [m, l, r] = a[i];
				if (r <= mx) {
					bad[i] = 1;
				}
				else {
					if (L == l) bad[ind] = 1;
					L = l;
					ind = i;
					mx = r;
				}
			}
			if (cur == 0 && x < k) {
				cout << "NO\n";
				return;
			}
		}
		vector<tuple<int, int, int>>good;
		for (int i = 0; i < n; ++i) {
			if (bad[i]) continue;
			good.push_back(a[i]);
		}
		swap(good, a);
		n = a.size();
	}
	vector<int>p(n);
	for (int i = 0; i < n; ++i) p[i] = i;
	do {
		vector<bool>cleaned(k);
		for (int i : p) {
			auto [m, l, r] = a[i];
			if (cleaned[m]) continue;
			for (int j = l; j < r; ++j)cleaned[j] = 1;
		}
		bool ok = true;
		for (int i = 0; i < k; ++i) {
			if (!cleaned[i]) {
				ok = false;
				break;
			}
		}
		if (ok) {
			cout << "YES\n";
			return ;
		}
	} while (next_permutation(p.begin(), p.end()));
	cout << "NO\n";
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) solve();
}
