
#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;

vector<vector<int>>g;
vector<int>used;

bool dfs(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		if (used[u] == 1) return 1;
		if (used[u] == 2) continue;
		if (dfs(u)) return 1;
	}
	used[v] = 2;
	return 0;
}

bool cmp(tuple<int, int, int, int>a, tuple<int, int, int, int>b) {
	auto [x1, t1, i1, y1] = a;
	auto [x2, t2, i2, y2] = b;
	if (t1 != t2) return t1 < t2;
	if (x1 != x2) return x1 < x2;
	return y1 > y2;
	
}
void solve() {
	g.clear();
	used.clear();
	int n, k;
	cin >> n >> k;
	swap(n, k);
	vector<tuple<int, int, int>>a(n);
	vector<tuple<int, int, int, int>>events;
	for (int i = 0; i < n; ++i) {
		int l, m, r;
		cin >> l >> m >> r;
		--l; --m;
		a[i] = { m, l, r };
	}
	{
		sort(a.begin(), a.end());
		for (int i = 0; i < n; ++i) {
			auto [m, l, r] = a[i];
			events.push_back({ l, -1, i, r });
			events.push_back({ r, 1, i, r });
		}
		sort(events.begin(), events.end());
		int cur = 0;
		int mx = -1;
		vector<bool>bad(n);
		int L = -1;
		int ind = -1;
		for (auto [x, t, i, y] : events) {
			cur -= t;
			if (cur == 0 && x < k) {
				cout << "NO\n";
				return;
			}
		}
	}
	int pref = 0, suf = 0;
	for (auto [m, l, r] : a) {
		if (l == 0 && r == k) {
			cout << "YES\n";
			return;
		}
		if (m == 0)pref = max(pref, r - l);
		else if (m == k - 1)suf = max(suf, r - l);
	}
	if (pref + suf >= k) {
		cout << "YES\n";
		return;
	}
	else cout << "NO\n";
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) solve();
}
