#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;

vector<vector<int>>g;
vector<int>used;

bool dfs(int v) {
	used[v] = 1;
	for (int u : g[v]) {

		if (used[u] == 1) return 1;
		if (used[u] == 2) continue;
		if (dfs(u)) return 1;
	}
	used[v] = 2;
	return 0;
}

void solve() {
	g.clear();
	used.clear();
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>>a(k);
	vector<tuple<int, int, int>>events;
	for (int i = 0; i < k; ++i) {
		int l, m, r;
		cin >> l >> m >> r;
		--l; --m;
		a[i] = { m, l, r };
	}
	sort(a.begin(), a.end());

	{
		for (int i = 0; i < k; ++i) {
			auto [m, l, r] = a[i];
			events.push_back({ l, -1, i });
			events.push_back({ r, 1, i });
		}
		sort(events.begin(), events.end());
		int cur = 0;
		int mx = 0;
		for (auto [x, t, i] : events) {
			cur -= t;
			if (cur == 0 && x < k) {
				cout << "NO\n";
				return;
			}
		}
	}
	vector<bool>dp((1 << n));
	dp[0] = 1;
	for (int mask = 0; mask < n; ++mask) {
		if (!dp[mask]) continue;
		for (int i = 0; i < k; ++i) {
			auto [m, l, r] = a[i];
			if ((mask >> m) & 1) continue;
			int mask1 = mask;
			mask1 |= (((1 << r) - 1) - ((1 << l) - 1));
			dp[mask1] = 1;
		}
	}
	if (dp[(1 << n) - 1]) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}

}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) solve();
}