#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;

vector<vector<int>>g;
vector<int>used;

bool dfs(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		
		if (used[u] == 1) return 1;
		if (used[u] == 2) continue;
		if (dfs(u)) return 1;
	}
	used[v] = 2;
	return 0;
}

void solve() {
	g.clear();
	used.clear();
	int n, k;
	cin >> n >> k;
	swap(n, k);
	vector<tuple<int, int, int>>a(n);
	vector<tuple<int, int, int>>events;
	for (int i = 0; i < n; ++i) {
		int l, m, r;
		cin >> l >> m >> r;
		--l; --m;
		a[i] = { m, l, r };
	}
	for (int i = 0; i < n; ++i) {
		auto [m, l, r] = a[i];
		events.push_back({ l, -1, i });
		events.push_back({ r, 1, i });
	}
	sort(a.begin(), a.end());
	sort(events.begin(), events.end());
	int cur = 0;
	for (auto [x, t, i] : events) {
		cur -= t;
		if (cur == 0 && x < k) {
			cout << "NO\n";
			return;
		}
	}
	vector<int>ms(n);
	for (int i = 0; i < n; ++i) {
		ms[i] = get<0>(a[i]);
	}
	sort(ms.begin(), ms.end());
	vector<pair<int, int>>seg(n);
	for (int i = 0; i < n; ++i) {
		auto [m, l, r] = a[i];
		int l1 = lower_bound(ms.begin(), ms.end(), l) - ms.begin();
		int r1 = lower_bound(ms.begin(), ms.end(), r) - ms.begin();
		seg[i] = { l1, r1 };
	}
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = seg[i].first; j < seg[i].second; ++j) {
			if (j == i) continue;
			g[i].push_back(j);
		}
	}
	used.resize(n);
	for (int i = 0; i < n; ++i) {
		if (used[i]) continue;
		if (dfs(i)) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) solve();
}
