#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;
using ll = long long;

constexpr ll LINF = 1e18 + 7;
constexpr int INF = 1e9 + 7;

vector<vector<int>>g;
vector<vector<int>>dp;
vector<int>prv;

void dfs(int v, int pr) {
	cout << v << "\n";
	if (g[v].size() == 1 && pr != -1) {
		dp[v][0] = -INF;
		dp[v][1] = 0;
		return;
	}
	int mx = -INF;
	int ind = -1;
	for (int u : g[v]) {
		if (u == pr) continue;
		dfs(u, v);
		dp[v][1] += max(dp[u][1], dp[u][0]);
		dp[v][0] += max(dp[u][0], dp[u][1]);
		if (mx < dp[u][1] - max(dp[u][0], dp[u][1]) + 1) ind = u;
		mx = max(mx, dp[u][1] - max(dp[u][0], dp[u][1]) + 1);
	}
	dp[v][0] += mx;
	prv[v] = ind;
}
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n, d;
	cin >> n >> d;
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	prv.resize(n);
	dp.resize(n, vector<int>(2));
	dfs(0, -1);

	cout << max(dp[0][1], dp[0][0])<<"\n";

}
