#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>

using namespace std;
using ll = long long;

constexpr ll LINF = 1e18 + 7;
constexpr int INF = 1e9 + 7;

vector<vector<int>>g;
vector<vector<int>>dp;
vector<int>prv;
vector<int>h;

vector<int>euler;
vector<int>tin;
vector<int>tout;
vector<int>full_euler;
vector<int>full_tin;
vector<int>full_tout;

void dfs(int v, int pr) {
	h[v] = h[pr] + 1;
	tin[v] = euler.size();
	euler.push_back(v);
	full_tin[v] = full_euler.size();
	full_euler.push_back(v);
	for (int u : g[v]) {
		if (u == pr) continue;
		dfs(u, v);
		full_euler.push_back(v);
	}
}

void build_st(vector<int>& euler, vector<int>& tin, vector<vector<int>>& st) {
	int n = euler.size();
	st.resize(20, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		st[0][i] = euler[i];
	}
	for (int i = 1; i < 20; ++i) {
		for (int j = 0; j + (1 << i) <= n; ++j) {
			if (tin[st[i - 1][j]] < tin[st[i - 1][j + (1 << (i - 1))]]) {
				st[i][j] = st[i - 1][j];
			}
			else {
				st[i][j] = st[i - 1][j + (1 << (i - 1))];
			}
		}
	}
}

vector<int>lg;

int getlca(int l, int r, vector<int>& tin, vector<vector<int>>& st) {
	if (r < l) swap(l, r); ++r;
	if (tin[st[lg[r - l]][l]] < tin[st[lg[r - l]][r - (1 << lg[r - l])]]) return st[lg[r - l]][l];
	else return st[lg[r - l]][r - (1 << lg[r - l])];
}

vector<vector<int>>g1;

vector<int>color;
vector<int>match;
int dfs_color(int v, int col) {
	color[v] = col;
	for (int u : g1[v]) {
		if (color[u] != -1) {
			continue;
		}
		dfs_color(u, 1 - col);
	}
	return 0;
}

vector<int>used;
bool Kuhn(int v, int root) {
	if (used[v] == root) return false;
	used[v] = root;
	for (int u : g1[v]) {
		if (match[u] == -1) {
			match[u] = v;
			return true;
		}
	}
	for (int u : g1[v]) {
		if (Kuhn(match[u], root)) {
			match[u] = v;
			return true;
		}
	}
	return false;
}
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n, d;
	cin >> n >> d;
	lg.resize(4 * n);
	tin.resize(n);
	h.resize(n, -1);
	tout.resize(n);
	full_tin.resize(n);
	for (int i = 2; i < 4 * n; ++i) {
		lg[i] = lg[i / 2] + 1;
	}
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0, 0);
	vector<vector<int>>st;
	build_st(full_euler, tin, st);
	vector<vector<int>>dist(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int lca = getlca(full_tin[i], full_tin[j], tin, st);
			dist[i][j] = dist[j][i] = h[i] + h[j] - 2 * h[lca];
		}
	}
	
	vector<int>dp(1 << n, 0);
	vector<tuple<int, int, int>>pr(1<<n);
	dp[0] = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) continue;
			for (int j = i + 1; j < n; ++j) {
				if ((mask >> j) & 1) continue;
				int mask1 = mask + (1 << i) + (1 << j);
				if ((dist[i][j] & 1) && dist[i][j] <= d) {
					if (dp[mask1] < dp[mask] + 1) {
						dp[mask1] = dp[mask] + 1;
						pr[mask1] = { mask, i, j };
					}
				}
			}
		}
	}
	
	int i = (1<<n) - 1;
	vector<pair<int, int>>ans;
	while (i > 0) {
		auto [m1, u, v] = pr[i];
		ans.push_back({ u, v });
		i = m1;
	}
	cout << dp[(1 << n) - 1] << "\n";
	cout << "-1\n";
	return 0;
	ans.pop_back();
	for (auto [u, v] : ans) cout << u + 1 << ' ' << v + 1 << "\n";
}

