#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int inf = 1e11 + 7;
const int real_inf = 1e18 + 100;

const int maxn = 3e5 + 100;
vector<int> left_lower(maxn, -1);
vector<int> lst_all;
int n;
int start, d;

void make_lower() {
    for (int i = 0; i < n; i++) {
        int v = lst_all[i];
        int l = -inf, r = inf;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (start + d * mid <= v) {
                l = mid;
            } else {
                r = mid;
            }
        }
        left_lower[i] = l;
    }
}

int find_dist(int ind, int chang) {
    int q = abs(lst_all[ind] - start - chang * d);
    if (q > 1e9) {
        return real_inf;
    }
    return q * q;
}

int cost_dist;

int find_val(int chang) {
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (chang <= left_lower[i]) {
            ans += find_dist(i, chang);
        } else {
            ans += min(find_dist(i, left_lower[i]), find_dist(i, left_lower[i] + 1));
        }
        if (ans > real_inf) {
            return real_inf;
        }
    }
    return ans;
}


void sol() {
    cin >> cost_dist;
    int l = -1, r = 1e11 + 100;
    while (l + 10 < r) {
        int mid1 = l + (r - l) / 3;
        int mid2 = r - (r - l) / 3;
        int ans1 = mid1 * cost_dist + find_val(mid1);
        int ans2 = mid2 * cost_dist + find_val(mid2);
        if (ans1 <= ans2) {
            r = mid2;
        } else {
            l = mid1;
        }
    }
    int ans = real_inf;
    for (int i = l - 10; i <= l + 10; i++) {
        cout << i << endl;
        if (i >= 0) {
            //cout << i <<  " " << find_val(i) << " " << ans << '\n';
            ans = min(ans, i * cost_dist + find_val(i));
            //cout << ans << " " << i * cost_dist + find_val(i) << " " << i << endl;
        }
    }
    cout << ans << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(25);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int num;
        cin >> num;
        lst_all.push_back(num);
    }
    sort(lst_all.begin(), lst_all.end());
    cin >> start >> d;
    if (lst_all[0] < start) {
        swap(lst_all[0], start);
    }
    lst_all[0] -= start;
    start -= start;
    make_lower();
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
