#include <bits/stdc++.h>

// #pragma GCC optimize("O3")
// #pragma GCC target("bmi,bmi2,avx2,lzcnt,popcnt")

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("input.txt", "r", stdin);
#define ff first
#define sc second
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

using ll = long long;
using pii = pair<int, int>;

const ll LOL = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 genom(LOL); ll randint(ll l, ll r) { uniform_int_distribution<ll> asjfbjl(l, r); return asjfbjl(genom); }

struct seg {
    int32_t l, m, r;
};

struct fen_tree {
    int n;
    vector<int> t;
    fen_tree(int _n) {
        n = _n;
        t.resize(n + 1);
    }

    void upd(int k, int x) {
        ++k;
        for (; k <= n; k += k & -k)
            t[k] += x;
    }

    void upd(int l, int r, int x) {
        upd(l, x);
        upd(r + 1, -x);
    }

    int get(int x) {
        ++x;
        int res = 0;
        for (; x > 0; x -= x & -x)
            res += t[x];
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> a(k);
    for (auto &[l, m, r] : a) {
        cin >> l >> m >> r;
        --l; --r; --m;
    }

    sort(all(a), [](seg &x, seg &y){ return x.r > y.r; });

    fen_tree lm(n + 1), mr(n + 1);

    vector<bool> good(k);
    vector<int32_t> st;
    st.reserve(k);

    for (int i = 0; i < k; ++i) {
        if (a[i].r == n - 1) {
            good[i] = 1;

            lm.upd(a[i].l, a[i].m, 1);
            mr.upd(a[i].l, 1);

            continue;
        }

        while (!st.empty() && a[st.back()].r != a[i].r) {
            good[st.back()] = 1;

            lm.upd(a[st.back()].l, a[st.back()].m, 1);
            mr.upd(a[st.back()].l, 1);

            st.pop_back();
        }

        if (mr.get(a[i].m + 1, a[i].r + 1) || lm.get(a[i].r + 1)) {
            st.pb(i);
        }
    }
    while (!st.empty()) {
        good[st.back()] = 1;
        st.pop_back();
    }

    bool check = 0;
    for (int i = 0; i < k; ++i)
        if (a[i].l == 0 && good[i])
            check = 1;
    cout << (check ? "YES\n" : "NO\n");
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
