#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <tuple>
#include <set>

using namespace std;

vector<int> used;
vector<vector<int>> gr;
bool fl = true;

void dfs(int v) {
    used[v] = 1;
    for (auto u : gr[v]) {
        if (used[u] == 1) {
            fl = false;
            return;
        }
        if (used[u] == 0) {
            dfs(u);
        }
    }
    used[v] = 2;
}

bool check(vector<tuple<int, int, int>> &v) {
    vector<pair<int, int>> ev;
    for (auto [l, m, r] : v) {
        ev.push_back({l, -1});
        ev.push_back({r, 1});
    }
    sort(ev.begin(), ev.end());
    int pred = 0;
    int cnt = 0;
    for (auto [x, tp] : ev) {
        if (cnt == 0 && x - pred > 1) {
            return false;
        }
        cnt -= tp;
        if (cnt == 0) {
            pred = x;
        }
    }
    return true;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int>> v(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        v[i] = {l, m, r};
    }
    if (!check(v)) {
        cout << "NO" << '\n';
        return;
    }
    fl = true;
    gr.clear();
    gr.resize(n);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) {
                continue;
            }
            auto [l1, m1, r1] = v[i];
            auto [l2, m2, r2] = v[j];
            bool f1 = false, f2 = false;
            if (m2 >= l1 && m2 <= r1) {
                f2 = true;
            }
            if (m1 >= l2 && m1 <= r2) {
                f1 = true;
            }
            if (f2 && f1) {
                cout << "NO" << '\n';
                return;
            }
            if (f1) {
                gr[i].push_back(j);
            }
            if (f2) {
                gr[j].push_back(i);
            }
        }
    }
    used.clear();
    used.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    if (fl) {
        cout << "Yes" << '\n';
    } else {
        cout << "NO" << '\n';
    }
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }

    return 0; 
}