#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <tuple>
#include <set>
 
using namespace std;
 
vector<int> used;
vector<vector<int>> gr;
bool fl = true;
 
void dfs(int v) {
    used[v] = 1;
    for (auto u : gr[v]) {
        if (used[u] == 1) {
            fl = false;
            return;
        }
        if (used[u] == 0) {
            dfs(u);
        }
    }
    used[v] = 2;
}
 
bool check(vector<tuple<int, int, int>> &v) {
    vector<pair<int, int>> ev;
    for (auto [l, m, r] : v) {
        ev.push_back({l, -1});
        ev.push_back({r, 1});
    }
    sort(ev.begin(), ev.end());
    int pred = 0;
    int cnt = 0;
    for (auto [x, tp] : ev) {
        if (cnt == 0 && x - pred > 1) {
            return false;
        }
        cnt -= tp;
        if (cnt == 0) {
            pred = x;
        }
    }
    return true;
}

bool comp(tuple<int, int, int> a, tuple<int, int, int> b) {
    auto [t1, t2, a1] = a;
    auto [t3, t4, b1] = b;
    return a1 < b1;
}

bool fail(tuple<int, int, int> a, tuple<int, int, int> b) {
    auto [l1, m1, r1] = a;
    auto [l2, m2, r2] = b;
    bool f1 = false, f2 = false;
    if (m2 >= l1 && m2 <= r1) {
        f2 = true;
    }
    if (m1 >= l2 && m1 <= r2) {
        f1 = true;
    }
    if (f2 && f1) {
        return true;
    }
    return false;
}
 
void solve() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int>> v(k);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        v[i] = {l, m, r};
    }
    if (!check(v)) {
        cout << "NO" << '\n';
        return;
    }
    sort(v.begin(), v.end(), comp);
    vector<bool> dp(k, false);
    for (int i = 0; i < k; i++) {
        auto [l, m, r] = v[i];
        if (l == 1) {
            dp[i] = true;
            continue;
        }
        for (int j = 0; j < i; j++) {
            auto [l1, m1, r1] = v[j];
            if (l <= r1 + 1 && !fail(v[i], v[j]) && dp[j]) {
                dp[i] = true;
            }
        }
        if (dp[i] && r == n) {
            cout << "YES" << '\n';
            return;
        }
    }
    cout << "NO" << '\n';
}
 
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0; 
}