#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,tune=native")

using namespace std;

#define MAXN 200000
//#define int long long

int t[8*MAXN] = {};
int pset[8*MAXN] = {};
int push[8*MAXN] = {};

void build(int v, int vl, int vr)
{
    if (vr - vl == 1)
    {
        t[v] = 0;
        pset[v] = -1;
        push[v] = -1;
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v, vl, vm);
    build(2 * v + 1, vm, vr);
}

inline void pushv(int v, int vl, int vm, int vr)
{
    if (pset[v] != -1)
    {
        t[2 * v] = pset[v] * (vm - vl);
        t[2 * v + 1] = pset[v] * (vr - vm);
        pset[2 * v] = pset[v];
        pset[2 * v + 1] = pset[v];
        push[2 * v] = -1;
        push[2 * v + 1] = -1;
    }
    if (push[v] != -1)
    {
        #define PUSH(z, l) \
        if (pset[z] != -1) \
        { \
            t[z] += push[v] * (l); \
            pset[z] += push[v]; \
        } \
        else \
        { \
            t[z] += push[v] * (l); \
            if (push[z] == -1) \
            { \
                push[z] = push[v]; \
            } \
            else \
            { \
                push[z] += push[v]; \
            } \
        }
        PUSH(2 * v, vm - vl);
        PUSH(2 * v + 1, vr - vm);
    }
    push[v] = -1;
    pset[v] = -1;
}

void tclear(int v, int vl, int vr, int l, int r)
{
//    cout << "V=" << vl << ' ' << vr << ' ' << l << ' ' << r << '\n';
    if (l >= r)
    {
        return;
    }
    if (pset[v] == 0)
    {
        return;
    }
    if (vl == l && vr == r)
    {
        pset[v] = 0;
        push[v] = -1;
        t[v] = 0;
        return;
    }

    int vm = (vl + vr) / 2;

    pushv(v, vl, vm, vr);

    tclear(2 * v, vl, vm, l, min(r, vm));
    tclear(2 * v + 1, vm, vr, max(l, vm), r);

    t[v] = t[2 * v] + t[2 * v + 1];
//    assert(!(push[v] != -1 && pset[v] != -1));
}

void tadd(int v, int vl, int vr, int l, int r, int x)
{
//    cout << "V=" << vl << ' ' << vr << ' ' << l << ' ' << r << '\n';
    if (l >= r)
    {
        return;
    }
    if (vl == l && vr == r)
    {
//        cout << "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ " << pset[v] << ' ' << push[v] <<  "\n";
        if (pset[v] != -1)
        {
//            cout << "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ\n";
            pset[v] += x;
        }
        else
        {
//            cout << "VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV\n";
            if (push[v] == -1)
            {
                push[v] = x;
            }
            else
            {
                push[v] += x;
            }
        }
        t[v] += x * (vr - vl);
        return;
    }

    int vm = (vl + vr) / 2;

    pushv(v, vl, vm, vr);

    tadd(2 * v, vl, vm, l, min(r, vm), x);
    tadd(2 * v + 1, vm, vr, max(l, vm), r, x);

    t[v] = t[2 * v] + t[2 * v + 1];
//    assert(!(push[v] != -1 && pset[v] != -1));
}

int tget(int v, int vl, int vr, int l, int r)
{
    if (l >= r)
    {
        return 0;
    }
    if (pset[v] != -1)
    {
        return pset[v] * (r - l);
    }
    if (vl == l && vr == r)
    {
        return t[v];
    }

    int vm = (vl + vr) / 2;

//    cout << "V=" << v << ' ' << vl << ' ' << vr << '\n';
//    cout << t[v] << ' ' << t[2 * v] << ' ' << t[2 * v + 1] << '\n';
//    cout << push[v] << ' ' << push[2 * v] << ' ' << push[2 * v + 1] << '\n';
//    cout << pset[v] << ' ' << pset[2 * v] << ' ' << pset[2 * v + 1] << '\n';


    pushv(v, vl, vm, vr);

//    cout << "P=" << v << ' ' << vl << ' ' << vr << '\n';
//    cout << t[v] << ' ' << t[2 * v] << ' ' << t[2 * v + 1] << '\n';
//    cout << push[v] << ' ' << push[2 * v] << ' ' << push[2 * v + 1] << '\n';
//    cout << pset[v] << ' ' << pset[2 * v] << ' ' << pset[2 * v + 1] << '\n';

    int ans = 0;
    ans += tget(2 * v, vl, vm, l, min(r, vm));
    ans += tget(2 * v + 1, vm, vr, max(l, vm), r);
//    cout << "R=" << v << ' ' << vl << ' ' << vr << '\n';
//    cout << t[v] << ' ' << t[2 * v] << ' ' << t[2 * v + 1] << '\n';
//    cout << push[v] << ' ' << push[2 * v] << ' ' << push[2 * v + 1] << '\n';
//    cout << pset[v] << ' ' << pset[2 * v] << ' ' << pset[2 * v + 1] << '\n';
//    assert(t[v] == t[2 * v] + t[2 * v + 1]);
//    assert(!(push[v] != -1 && pset[v] != -1));

    return ans;
}

char *v[MAXN];
int *next_right[MAXN];
int w, h;

int add[MAXN];

int update(int y, int x)
{
//    cout << "Z\n";
    int ans = 0;

    int W = w + 10;

    pset[1] = 0;
    push[1] = 0;
    t[1] = 0;
//    tclear(1, 0, W, 0, W);

//    ++y;

    int max_length = 0;

    int cur = 0;
    int ad = 0;

    while (y < h && v[y][x] == '1')
    {
//        cout << "XY=" << x << ' ' << y << "Z\n";
//        cout << "GET[0]=" << tget(1, 0, W, 0, 1) << '\n';
//        cout << "GET[1]=" << tget(1, 0, W, 1, 2) << '\n';
//        cout << "GET[2]=" << tget(1, 0, W, 2, 3) << '\n';
        // find length
        int length = next_right[y][x] - x;
//        cout << "L=" << length << '\n';
        // clear right part
        if (length < max_length)
        {
            while (ad > 0)
            {
                ad--;
                tadd(1, 0, W, 1, add[ad] + 1, 1);
            }
            tclear(1, 0, W, length + 1, W);
            max_length = length;
            cur = tget(1, 0, W, 0, W);
        }
        // add new row
        add[ad++] = length;
        cur += length;
        // update answer
        ans = max(ans, cur);
//        cout << "GET[0]=" << tget(1, 0, W, 0, 1) << '\n';
//        cout << "GET[1]=" << tget(1, 0, W, 1, 2) << '\n';
//        cout << "GET[2]=" << tget(1, 0, W, 2, 3) << '\n';
//        cout << "A=" << ans << '\n';
        max_length = length;
        ++y;
    }



    return ans;
}

signed main()
{
    cin.tie(NULL);
    cin.sync_with_stdio(false);
    w = 2000;
    h = 2000;
    cin >> h >> w;


    build(1, 0, w + 10);

    for (int j = 0; j < h; ++j)
    {
        v[j] = (char *)malloc(w);
    }
    for (int j = 0; j < h; ++j)
    {
        next_right[j] = (int *)malloc(sizeof(int) * w);
    }

//    for (int i = 0; i < w; ++i)
//    {
//        for (int j = 0; j < h; ++j)
//        {
//            v[j][i] = (rand() % 2) + '0';
//        }
//    }

    for (int i = 0; i < h; ++i)
    {
        string s;
        cin >> s;
        memcpy(v[i], s.data(), w);
//        cout << v[i] << '\n';
    }


    for (int i = 0; i < h; ++i)
    {
        int next = w;
        for (int j = w - 1; j >= 0; --j)
        {
            if (v[i][j] == '0')
            {
                next = j;
            }
            next_right[i][j] = next;
        }
    }

//    cout << "V\n";

    int ans = 0;

    for (int j = 0; j < w; ++j)
    {
        ans = max(ans, update(0, j));
    }

    for (int i = 0; i + 1 < h; ++i)
    {
        for (int j = 0; j < w; ++j)
        {
            if (v[i][j] == '0')
            {
                ans = max(ans, update(i + 1, j));
            }
        }
    }

    cout << ans << '\n';
    return 0;
}
