#include <bits/stdc++.h>

using namespace std;

#define MAXN 200000
#define int long long

int t[8*MAXN];
int push[8*MAXN];

void build(int v, int vl, int vr)
{
    if (vr - vl == 1)
    {
        t[v] = 0;
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v, vl, vm);
    build(2 * v + 1, vm, vr);
}

void tclear(int v, int vl, int vr, int l, int r)
{
//    cout << "V=" << vl << ' ' << vr << ' ' << l << ' ' << r << '\n';
    if (l >= r)
    {
        return;
    }
    if (vl == l && vr == r)
    {
        push[v] = -1;
        t[v] = 0;
        return;
    }

    int vm = (vl + vr) / 2;

    if (push[v] == -1)
    {
        t[2 * v] = 0;
        t[2 * v + 1] = 0;
        push[2 * v] = -1;
        push[2 * v + 1] = -1;
        push[v] = 0;
    }
    else if (push[v] != 0)
    {
        t[2 * v] += push[v];
        t[2 * v + 1] += push[v];
        push[2 * v] += push[v];
        push[2 * v + 1] += push[v];
        push[v] = 0;
    }

    tclear(2 * v, vl, vm, l, min(r, vm));
    tclear(2 * v + 1, vm, vr, max(l, vm), r);

    t[v] = t[2 * v] + t[2 * v + 1];
}

void tadd(int v, int vl, int vr, int l, int r, int x)
{
    if (l >= r)
    {
        return;
    }
    if (vl == l && vr == r)
    {
        push[v] += x;
        t[v] += x * (vr - vl);
        return;
    }

    int vm = (vl + vr) / 2;

    if (push[v] == -1)
    {
        t[2 * v] = 0;
        t[2 * v + 1] = 0;
        push[2 * v] = -1;
        push[2 * v + 1] = -1;
        push[v] = 0;
    }
    else if (push[v] != 0)
    {
        t[2 * v] += push[v] * (vm - vl);
        t[2 * v + 1] += push[v] * (vr - vm);
        push[2 * v] += push[v];
        push[2 * v + 1] += push[v];
        push[v] = 0;
    }

    tadd(2 * v, vl, vm, l, min(r, vm), x);
    tadd(2 * v + 1, vm, vr, max(l, vm), r, x);

    t[v] = t[2 * v] + t[2 * v + 1];
}

int tget(int v, int vl, int vr, int l, int r)
{
    if (l >= r)
    {
        return 0;
    }
    if (vl == l && vr == r)
    {
        return t[v];
    }

    int vm = (vl + vr) / 2;

    if (push[v] == -1)
    {
        t[2 * v] = 0;
        t[2 * v + 1] = 0;
        push[2 * v] = -1;
        push[2 * v + 1] = -1;
        push[v] = 0;
    }
    else if (push[v] != 0)
    {
        t[2 * v] += push[v] * (vm - vl);
        t[2 * v + 1] += push[v] * (vr - vm);
        push[2 * v] += push[v];
        push[2 * v + 1] += push[v];
        push[v] = 0;
    }

    int ans = 0;
    ans += tget(2 * v, vl, vm, l, min(r, vm));
    ans += tget(2 * v + 1, vm, vr, max(l, vm), r);

    assert(t[v] == t[2 * v] + t[2 * v + 1]);

    return ans;
}

vector<string> v;
vector<vector<int>> next_right;
int w, h;

int update(int y, int x)
{
//    cout << "Z\n";
    int ans = 0;

    tclear(1, 0, w, 0, w);

    ++y;

    while (y < h && v[y][x] == '1')
    {
//        cout << "XY=" << x << ' ' << y << "Z\n";
        // find length
        int length = next_right[y][x] - x;
        // clear right part
        tclear(1, 0, w, length + 1, w);
        // add new row
        tadd(1, 0, w, 1, length + 1, 1);
        // update answer
        ans = max(ans, tget(1, 0, w, 0, w));
//        cout << "A=" << ans << '\n';
        ++y;
    }



    return ans;
}

signed main()
{
    cin.tie(NULL);
    cin.sync_with_stdio(false);
    cin >> h >> w;

    v.resize(h);
    next_right.resize(h, vector<int>(w, 0));

    for (int i = 0; i < h; ++i)
    {
        cin >> v[i];
    }

    for (int i = 0; i < h; ++i)
    {
        int next = w;
        for (int j = w - 1; j >= 0; --j)
        {
            if (v[i][j] == '0')
            {
                next = j;
            }
            next_right[i][j] = next;
        }
    }

    int ans = 0;

    for (int i = 0; i < h; ++i)
    {
        for (int j = 0; j < w; ++j)
        {
            if (v[i][j] == '0')
            {
                ans = max(ans, update(i, j));
            }
        }
    }

    cout << ans << '\n';
    return 0;
}
