#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif


#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, k;
vector<int> l, m, r;

void solve() {
    vector dp(n + 1, vector<bool>(n + 1));
    dp[0][0] = true;
    vector<int> order(k);
    iota(all(order), 0);
    sort(all(order), [](int i, int j){return l[i] < l[j];});
    for (int id : order) {
        for (int i = l[id] - 1; i <= r[id]; ++i) {
            for (int last = 0; last <= i; ++last) {
                if (last < l[id] && dp[i][last]) { dp[r[id]][m[id]] = true; }
                if (i < m[id] && dp[i][last]) { dp[r[id]][m[id]] = true; }
            }
        }
    }
    for (int last = 0; last <= n; ++last) {
        if (dp[n][last]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        cin >> n >> k;
        l.resize(k);
        m.resize(k);
        r.resize(k);
        for (int i = 0; i < k; ++i) {
            cin >> l[i] >> m[i] >> r[i];
        }
        solve();
    }
}