#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif


#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, k;
vector<int> l, m, r;

vector<int> fen;

void add(int i) {
    for (; i < fen.size(); i |= i + 1) {
        ++fen[i];
    }
}

int sum(int i) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) {
        res += fen[i];
    }
    return res;
}

void solve() {
    vector<int> order(k);
    iota(all(order), 0);
    sort(all(order), [](int i, int j){return l[i] > l[j];});
    fen.assign(n + 2, 0);
    add(n + 1);
    for (int i : order) {
        if (sum(r[i] + 1) - sum(l[i])) {
            add(l[i]);
        }
    }
    cout << (sum(1) ? "YES\n" : "NO\n");
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        cin >> n >> k;
        l.resize(k);
        m.resize(k);
        r.resize(k);
        for (int i = 0; i < k; ++i) {
            cin >> l[i] >> m[i] >> r[i];
        }
        solve();
    }
}