#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif


#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, d;
vector<vector<int>> g;

vector<vector<int>> gg;

void dfs(int v, int par, int h) {
    for (int u : g[v]) {
        if (u == par) { continue; }
        if (!h) { gg[v].push_back(u); }
        dfs(u, v, h ^ 1);
    }
}

bool kuhn(int v, int timer, vector<int> &mt, vector<int> &used) {
    if (used[v] == timer) { return false; }
    used[v] = timer;
    for (int u : gg[v]) {
        if (!mt[u] || kuhn(mt[u], timer, mt, used)) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    gg.resize(n + 1);
    dfs(1, 0, 0);
    vector<int> mt(n + 1), used(n + 1);
    int timer = 0, res = 0;
    for (int v = 1; v <= n; ++v) {
        res += kuhn(v, ++timer, mt, used);
    }
    cout << res << '\n';
    for (int u = 1; u <= n; ++u) {
        if (mt[u]) { cout << u << ' ' << mt[u] << '\n'; }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> d;
    g.resize(n + 1);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    solve();
}