#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif


#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, d;
vector<vector<int>> g;

vector<vector<int>> dist;

void dfs(int v, int par, int h, int root) {
    dist[root][v] = h;
    for (int u : g[v]) {
        if (u != par) {
            dfs(u, v, h + 1, root);
        }
    }
}

void solve() {
    dist.assign(n + 1, vector<int>(n + 1));
    for (int v = 1; v <= n; ++v) {
        dfs(v, 0, 0, v);
    }
    vector<int> dp(1 << n);
    for (int mask = 1; mask < dp.size(); ++mask) {
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                dp[mask] = max(dp[mask], dp[mask - (1 << i)]);
                for (int j = i + 1; j < n; ++j) {
                    if (mask & (1 << j)) {
                        if (dist[i + 1][j + 1] <= d && dist[i + 1][j + 1] % 2) {
                            dp[mask] = max(dp[mask], dp[mask - (1 << i) - (1 << j)] + 1);
                        }
                    }
                }
            }
        }
    }
    int res = dp.back();
    cout << res << '\n';
    int cur = (1 << n) - 1;
    while (res) {
        for (int i = 0; i < n; ++i) {
            if (cur & (1 << i)) {
                if (cur == dp[cur - (1 << i)]) {
                    cur -= 1 << i;
                    break;
                }
                bool go = true;
                for (int j = i + 1; j < n; ++j) {
                    if (cur & (1 << j)) {
                        if (dist[i + 1][j + 1] <= d && dist[i + 1][j + 1] % 2) {
                            if (res == dp[cur - (1 << i) - (1 << j)] + 1) {
                                cout << i + 1 << ' ' << j + 1 << endl;
                                cur -= (1 << i) + (1 << j);
                                res--, go = false;
                                break;
                            }
                        }
                    }
                }
                if (!go) { break; }
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> d;
    g.resize(n + 1);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    solve();
}