#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

struct chel {
    int l, m, r;
    bool operator==(chel a)
    {
        return l == a.l && r == a.r && m == a.m;
    }
};

bool chain(chel x, chel y)
{
    return (x.m >= y.l && x.m <= y.r && y.m >= x.l && y.m <= x.r);
}

bool inter(chel x, chel y)
{
    return (x.l <= y.r && x.l >= y.l) || (x.r <= y.r && x.r >= y.l) || (y.l <= x.r && y.l >= x.l) || (y.r <= x.r && y.r >= x.l);
}

struct SegTree {
    int offset;
    vector<int> t;
    SegTree() { }
    SegTree(int n)
    {
        offset = 1;
        while (offset < n)
            offset <<= 1;
        t.resize(offset << 1, 0);
    }

    void upd(int i, int x)
    {
        t[i += offset] += x;
        for (i >>= 1; i > 0; i >>= 1)
            t[i] = t[i << 1] + t[i << 1 | 1];
    }

    void upd(int l, int r, int x)
    {
        upd(l, x);
        upd(r, x);
    }

    int get(int i)
    {
        int res = 0;
        for (int l = offset, r = offset + i; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                res += t[l++];
            if (r & 1)
                res += t[--r];
        }
        return res;
    }
};

void solve()
{
    int n, k;
    cin >> n >> k;
    vector<chel> a(k);
    for (auto& i : a)
        cin >> i.l >> i.m >> i.r;
    for (int mask = 0; mask < (1 << k); mask++) {
        set<int> cur;
        for (int i = 1; i <= n; i++)
            cur.insert(i);
        vector<chel> nw;
        for (int i = 0; i < k; i++)
            if ((mask >> i) & 1)
                nw.push_back(a[i]);
        bool flag = false;
        for (int i = 0; i < nw.size() - 1; i++)
            for (int j = i + 1; j < nw.size(); j++)
                if (chain(nw[i], nw[j])) {
                    flag = true;
                    break;
                }
        if (flag) {
            continue;
        }
        for (auto i : nw)
            for (int j = i.l; j <= i.r; j++)
                cur.erase(j);
        if (cur.size() == 0) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    cin >> ttt;
    while (ttt--)
        solve();
}
