#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

struct chel {
    int l, m, r;
    bool operator==(chel a)
    {
        return l == a.l && r == a.r && m == a.m;
    }
};

bool chain(chel x, chel y)
{
    return (x.m >= y.l && x.m <= y.r && y.m >= x.l && y.m <= x.r);
}

bool inter(chel x, chel y)
{
    return (x.l <= y.r && x.l >= y.l) || (x.r <= y.r && x.r >= y.l) || (y.l <= x.r && y.l >= x.l) || (y.r <= x.r && y.r >= x.l);
}

struct SegTree {
    int offset;
    vector<int> t;
    SegTree() { }
    SegTree(int n)
    {
        offset = 1;
        while (offset < n)
            offset <<= 1;
        t.resize(offset << 1, 0);
    }

    void upd(int i, int x)
    {
        t[i += offset] += x;
        for (i >>= 1; i > 0; i >>= 1)
            t[i] = t[i << 1] + t[i << 1 | 1];
    }

    void upd(int l, int r, int x)
    {
        upd(l, x);
        upd(r, x);
    }

    int get(int i)
    {
        int res = 0;
        for (int l = offset, r = offset + i; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                res += t[l++];
            if (r & 1)
                res += t[--r];
        }
        return res;
    }
};

void solve()
{
    int n, k;
    cin >> n >> k;
    vector<chel> a(k);
    for (auto& i : a)
        cin >> i.l >> i.m >> i.r;
    sort(a.begin(), a.end(), [](auto x, auto y) {
        if (x.m == y.m) {
            if (x.r == y.r)
                return x.l < y.l;
            return x.r > y.r;
        }
        return x.m < y.m;
    });
    if (a[0].l != 1) {
        cout << "NO\n";
        return;
    }
    vector<chel> dp { k + 3, { INT32_MAX, INT32_MAX, INT32_MAX } };
    dp[0] = { INT32_MIN, INT32_MIN, INT32_MIN };
    chel pre { 0, 0, n + 1 };
    int len = 1;
    for (int i = 0; i < k; i++) {
        if (!inter(pre, a[i]))
            continue;
        int l = 0, r = k + 2, mid;
        while (r - l > 1) {
            mid = (r + l) >> 1;
            if (dp[mid] == chel { INT32_MAX, INT32_MAX, INT32_MAX } || chain(a[i], dp[mid]))
                r = mid;
            else
                l = mid;
        }
        len = max(len, r);
        dp[r] = a[i];
        pre = a[i];
    }
    if (dp[len].r != n) {
        cout << "NO\n";
        return;
    } else {
        cout << "YES\n";
    }
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    cin >> ttt;
    while (ttt--)
        solve();
}
