#include <bits/stdc++.h>

using namespace std;

#define int int64_t

namespace rng = std::ranges;

#define vl (v * 2 + 1)
#define vr (v * 2 + 2)
#define tm ((tl + tr) / 2)

struct SegTree {
    struct Node {
        int sum = 0;
        int to_push = -1;
    };
public:
    SegTree(int sz) : da(sz * 4, Node{}) {
    }

    static Node Merge(Node a, Node b) {
        return {
            a.sum + b.sum,
            -1
        };
    }

    void Set(int ql, int qr, int val) {
        Set(ql, qr, val, 0, 0, da.size() / 4);
    }

    int Get(int ql, int qr) {
        return Get(ql, qr, 0, 0, da.size() / 4);
    }

private:

    Node Set(int ql, int qr, int val, int v, int tl, int tr) {
        if (qr <= tl || tr <= ql) {
            return da[v];
        } else if (ql <= tl && tr <= qr) {
            return da[v] = {
                val * (tr - tl),
                val
            };
        } else {
            Push(v, tl, tr);
            return da[v] = Merge(Set(ql, qr, val, vl, tl, tm), Set(ql, qr, val, vr, tm, tr));
        }
    }

    int Get(int ql, int qr, int v, int tl, int tr) {
        if (qr <= tl || tr <= ql) {
            return 0;
        } else if (ql <= tl && tr <= qr) {
            return da[v].sum;
        } else {
            Push(v, tl, tr);
            return Get(ql, qr, vl, tl, tm) + Get(ql, qr, vr, tm, tr);
        }
    }

    void Push(int v, int tl, int tr) {
        if (da[v].to_push == -1) return;
        da[vl] = {
            da[v].to_push * (tm - tl),
            da[v].to_push
        };
        da[vr] = {
            da[v].to_push * (tr - tm),
            da[v].to_push
        };
        da[v].to_push = -1;
    }


    vector<Node> da;
};

int BinSearch(int l, int r, auto &&f) {
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (f(m)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}


signed main() {
    int h, w;
    cin >> h >> w;
    vector<vector<bool>> table(h, vector<bool>(w));
    for (auto &i : table) {
        for (auto j : i) {
            char z;
            cin >> z;
            j = (z == '1');
        }
    }
    vector<vector<int>> up_for(h, vector<int>(w));
    for (int c = 0; c < w; ++c) {
        up_for[0][c] = table[0][c];
    }
    for (int l = 1; l < h; ++l) {
        for (int c = 0; c < w; ++c) {
            up_for[l][c] = table[l][c] ? up_for[l - 1][c] + 1 : 0;
        }
    }
    int ans = 0;
    for (int line = 0; line < h; ++line) {
        vector<pair<int, int>> segs;
        bool active = false;
        for (int c = 0; c < w; ++c) {
            if (table[line][c] && active) {
                ++segs.back().second;
            } else if (table[line][c] && !active) {
                segs.emplace_back(c, c);
            }
            active = table[line][c];
        }
        for (auto [l, r] : segs) {
            SegTree st(r - l + 1);
            for (int i = r - l; i >= 0; --i) {
                int first_leq = i + 1 + BinSearch(0, r - l - i - 1, [&] (int ind) {
                    return st.Get(i + 1 + ind, i + 1 + ind + 1) > up_for[line][l + i];
                });
                st.Set(i, first_leq, up_for[line][l + i]);
                ans = max(ans, st.Get(0, r - l + 1));
            }
        }
    }
    cout << ans << endl;


    return 0;
}