#pragma GCC optimize("O3,unroll-loops")
#include <iostream>
#include <vector>
#include <cstddef>
#include <cstdint>
#include <algorithm>
#include <map>
#include <set>
#pragma GCC target("avx2")

using namespace std;

#define int int64_t


#define vl (v * 2 + 1)
#define vr (v * 2 + 2)
#define tm ((tl + tr) / 2)

struct SegTree {
    struct Node {
        int sum = 0;
        int to_push = -1;
    };
public:
    SegTree(int sz) : da(sz * 4, Node{}) {
    }

    static Node Merge(Node a, Node b) {
        return {
            a.sum + b.sum,
            -1
        };
    }

    void Set(int ql, int qr, int val) {
        Set(ql, qr, val, 0, 0, da.size() / 4);
    }

    int Get(int ql, int qr) {
        return Get(ql, qr, 0, 0, da.size() / 4);
    }

private:

    Node Set(int ql, int qr, int val, int v, int tl, int tr) {
        if (qr <= tl || tr <= ql) {
            return da[v];
        } else if (ql <= tl && tr <= qr) {
            return da[v] = {
                val * (tr - tl),
                val
            };
        } else {
            Push(v, tl, tr);
            return da[v] = Merge(Set(ql, qr, val, vl, tl, tm), Set(ql, qr, val, vr, tm, tr));
        }
    }

    int Get(int ql, int qr, int v, int tl, int tr) {
        if (qr <= tl || tr <= ql) {
            return 0;
        } else if (ql <= tl && tr <= qr) {
            return da[v].sum;
        } else {
            Push(v, tl, tr);
            return Get(ql, qr, vl, tl, tm) + Get(ql, qr, vr, tm, tr);
        }
    }

    void Push(int v, int tl, int tr) {
        if (da[v].to_push == -1) return;
        da[vl] = {
            da[v].to_push * (tm - tl),
            da[v].to_push
        };
        da[vr] = {
            da[v].to_push * (tr - tm),
            da[v].to_push
        };
        da[v].to_push = -1;
    }

    vector<Node> da;
};

template<typename T>
int BinSearch(T &&f) {
    int l = 0, r = 1;
    while (f(r)) {
        l = r;
        r *= 2;
    }
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (f(m)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

struct Worker {
    int l, m, r;
};

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<Worker> w(k);
        for (auto &[l, m, r] : w) {
            cin >> l >> m >> r;
        }
        vector<int> dp(n + 1, 1e14);
        dp[0] = -1e14;
        vector<vector<Worker>> think(n + 1);
        for (auto [l, m, r] : w) {
            think[r].emplace_back(l, m, r);
        }
        for (int i = 1; i <= n; ++i) {
            for (auto [l, m, r] : think[i]) {
                for (int j = l - 1; j < r; ++j) {
                    if (dp[j] < l || m > j && dp[j] < 1e10) {
                        dp[i] = min(dp[i], m);
                    }
                }
            }
        }
        cout << (dp[n] < n * 2 ? "YES" : "NO") << endl;
    }

    return 0;
}