#pragma GCC optimize("O3,unroll-loops")
#include <iostream>
#include <vector>
#include <cstddef>
#include <cstdint>
#include <algorithm>
#include <map>
#include <set>
#pragma GCC target("avx2")

using namespace std;

#define int int64_t


#define vl (v * 2 + 1)
#define vr (v * 2 + 2)
#define tm ((tl + tr) / 2)

struct SegTree {
    struct Node {
        int sum = 0;
        int to_push = -1;
    };
public:
    SegTree(int sz) : da(sz * 4, 1e14) {
    }

    void Set(int ind, int val) {
        Set(ind, val, 0, 0, da.size() / 4);
    }

    int Get(int ql, int qr) {
        return Get(ql, qr, 0, 0, da.size() / 4);
    }

private:

    int Set(int ind, int val, int v, int tl, int tr) {
        if (tl + 1 == tr && ind == tl) {
            return da[v] = min(da[v], val);
        } else if (ind < tl || tr <= ind) {
            return da[v];
        } else {
            return da[v] = min(Set(ind, val, vl, tl, tm), Set(ind, val, vr, tm, tr));
        }
    }

    int Get(int ql, int qr, int v, int tl, int tr) {
        if (qr <= tl || tr <= ql) {
            return 1e14;
        } else if (ql <= tl && tr <= qr) {
            return da[v];
        } else {
            return min(Get(ql, qr, vl, tl, tm), Get(ql, qr, vr, tm, tr));
        }
    }

    vector<int> da;
};

template<typename T>
int BinSearch(T &&f) {
    int l = 0, r = 1;
    while (f(r)) {
        l = r;
        r *= 2;
    }
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (f(m)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

struct Worker {
    int l, m, r;
};

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<Worker> w(k);
        for (auto &[l, m, r] : w) {
            cin >> l >> m >> r;
        }
        SegTree st(n + 1);
        st.Set(0, -1e14);
        vector<vector<Worker>> think(n + 1);
        for (auto [l, m, r] : w) {
            think[r].emplace_back(l, m, r);
        }
        for (int i = 1; i <= n; ++i) {
            for (auto [l, m, r] : think[i]) {
                if (st.Get(l - 1, m) < 1e10 || st.Get(m, r) < l) {
                    st.Set(i, m);
                }
            }
        }
        cout << (st.Get(n, n + 1) < n * 2 ? "YES" : "NO") << endl;
    }

    return 0;
}