// #pragma GCC optimize("O3,unroll-loops")
#include <iostream>
#include <vector>
#include <cstddef>
#include <cstdint>
#include <algorithm>
#include <map>
#include <set>
#include <array>
#include <numeric>
// #pragma GCC target("avx2")

using namespace std;

#define int int64_t

namespace rng = ranges;

#define vl (v * 2 + 1)
#define vr (v * 2 + 2)
#define tm ((tl + tr) / 2)

int Sq(int x) {
    return x * x;
}

signed main() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (auto &i : x) {
        cin >> i;
    }
    rng::sort(x);
    int x0, d;
    cin >> x0 >> d;
    int min_v = (x[0] - x0) / d - 1;
    int max_v = (x.back() - x0) / d + 1;
    vector<vector<vector<vector<int>>>> dp(max_v - min_v + 1, vector(max_v - min_v + 1, vector(n, vector<int>(n + 1, 1e14))));

    int base_pos = x0 + min_v * d;
    auto find_pr = [&] (int l_hod, int r_hod, int pos) {
        int ans = 1e14;
        for (int i = min_v; i <= max_v; ++i) {
            int i_c = i * d + base_pos;
            i_c = min(i_c, r_hod);
            i_c = max(i_c, l_hod);
            ans = min(ans, Sq(i_c - pos));
        }
        return ans;
    };
    for (int r_hod = 0; r_hod < dp.size(); ++r_hod) {
        for (int l_hod = 0; l_hod <= r_hod; ++l_hod) {
            for (int i = 0; i < n; ++i) {
                dp[l_hod][r_hod][i][i] = 0;
                dp[l_hod][r_hod][i][i + 1] = find_pr(l_hod * d + base_pos, r_hod * d + base_pos, x[i]);
            }
        }
    }
    for (int len_hod = 1; len_hod <= dp.size(); ++len_hod) {
        for (int l_hod = 0; l_hod + len_hod - 1 < dp.size(); ++l_hod) {
            int r_hod = l_hod + len_hod - 1;
            for (int len_k = 1; len_k <= n; ++len_k) {
                for (int l_k = 0; l_k + len_k - 1 < n; ++l_k) {
                    int r_k = l_k + len_k;
                    if (l_hod + 1 < dp.size()) {
                        dp[l_hod][r_hod][l_k][r_k] = min({
                            dp[l_hod][r_hod][l_k][r_k],
                            dp[l_hod + 1][r_hod][l_k][r_k]
                        });
                    }
                    if (r_hod > 0) {
                        dp[l_hod][r_hod][l_k][r_k] = min({
                            dp[l_hod][r_hod][l_k][r_k],
                            dp[l_hod][r_hod - 1][l_k][r_k]
                        });
                    }
                    if (l_k + 1 < n) {
                        dp[l_hod][r_hod][l_k][r_k] = min({
                            dp[l_hod][r_hod][l_k][r_k],
                            dp[l_hod][r_hod][l_k + 1][r_k] + find_pr(l_hod * d + base_pos, r_hod * d + base_pos, x[l_k])
                        });
                    }
                    {
                        dp[l_hod][r_hod][l_k][r_k] = min({
                            dp[l_hod][r_hod][l_k][r_k],
                            dp[l_hod][r_hod][l_k][r_k - 1] + find_pr(l_hod * d + base_pos, r_hod * d + base_pos, x[r_k - 1])
                        });
                    }
                }
            }
        }
    }
    vector<int> r_p(dp.size());
    for (int i = 0; i < r_p.size(); ++i) {
        r_p[i] = base_pos + i * d;
    }
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        int ans = 1e14;
        for (int rh = 0; rh < dp.size(); ++rh) {
            if (rh * d + base_pos < x0) continue;
            for (int lh = 0; lh <= rh; ++lh) {
                if (lh * d + base_pos > x0) continue;
                int dl = abs((x0 - base_pos) / d - lh);
                int dr = abs((x0 - base_pos) / d - rh);
                ans = min(ans, dp[lh][rh][0][n] + min(dl, dr) * t * 2 + max(dl, dr) * t);
            }
        }
        cout << ans << endl;
    }

    return 0;
}