#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
using namespace std;


int n, k;
vector<vector<int>> graph;
vector<int> used;


bool dfs(int v) {
    if (v == n + 1)
        return true;
    used[v] = true;
    for (int u : graph[v]) {
        if (u == n + 1 || !used[u]) {
            if (dfs(u))
                return true;
        }
    }
    return false;
}


void solve() {
    cin >> n >> k;
    used.clear();
    used.resize(n + 1, false);
    int l, m, r;
    graph.clear();
    graph.resize(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> l >> m >> r;
        graph[l].push_back(r + 1);
    }
    if (dfs(1))
        cout << "YES" << '\n';
    else
        cout << "NO" << '\n';
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
