#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
using namespace std;


__int128 s, d, inf = 2e9, INF = 4e18;
vector<__int128> v1, v2;
array<__int128, 300000> s1, s2, ds1, ds2, ps1, ps2;


__int128 g1(__int128 m, __int128 t) {
	__int128 mx = s - d * m, cnt = 0;
	__int128 i = lower_bound(v1.begin(), v1.end(), mx) - v1.begin();
	//cout << "1 i " << (long long)i << " || " << (long long)mx << '\n';
	if (i > 0 && i != v1.size()) {
        cnt = ds1[v1.size()] - ds1[i] + s1[i] - 2 * ps1[i] * mx + mx * mx * i;
	} else if (i == 0) {
        cnt = ds1[v1.size()];
	} else {
        cnt = s1[v1.size()] - 2 * ps1[v1.size()] * mx + mx * mx * v1.size();
	}
	//cout << (long long)cnt << '\n';
	return cnt + m * t;
}


long long f1(__int128 t) {
	__int128 l = 0, r = inf, m1, m2, res1, res2, res;
	for (int i = 0; i < 50; i++) {
		m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
		res1 = g1(m1, t), res2 = g1(m2, t);
		if (res1 > res2)
			l = m1;
		else
			r = m2;
	}
	res = g1((l + r) / 2, t);
	res = min(res, g1(l, t));
	res = min(res, g1(r, t));
	//cout << "chech f1 " << t << ' ' << s - d * ((l + r) / 2) << '\n';
	return min(INF, res);
}


__int128 g2(__int128 m, __int128 t) {
	__int128 mx = s + d * m, cnt = 0, d1, d2;
	__int128 i = lower_bound(v2.begin(), v2.end(), mx) - v2.begin();
	//cout << "2 i " << (long long)i << " || " << (long long)mx << '\n';
	if (i > 0 && i != v2.size()) {
        cnt = ds2[i] + s2[v2.size()] - s2[i] - (ps2[v2.size()] - ps2[i]) * mx * 2 + mx * mx * (v2.size() - i);
	} else if (i == 0) {
        cnt = s2[v2.size()] - 2 * mx * ps2[v2.size()] + mx * mx * v2.size();
	} else {
        cnt = ds2[v2.size()];
	}
	//cout << (long long)cnt << '\n';
	return cnt + m * t;
}


long long f2(__int128 t) {
	__int128 l = 0, r = inf, m1, m2, res1, res2, res;
	for (int i = 0; i < 50; i++) {
		m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
		res1 = g2(m1, t), res2 = g2(m2, t);
		if (res1 > res2)
			l = m1;
		else
			r = m2;
	}
	res = g2((l + r) / 2, t);
	res = min(res, g2(l, t));
	res = min(res, g2(r, t));
	//cout << "chech f2 " << t << ' ' << s + d * ((l + r) / 2) << '\n';
	return min(INF, res);
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
	int n, m;
	cin >> n;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++)
		cin >> v[i];
    long long ss, dd;
	cin >> ss >> dd;
	s = ss, d = dd;
	sort(v.begin(), v.end());
	for (int i = 0; i < n; i++) {
		if (v[i] >= s)
			v2.push_back(v[i]);
		else
			v1.push_back(v[i]);
	}
	s1[0] = 0;
	ds1[0] = 0;
	ps1[0] = 0;
	for (int i = 0; i < v1.size(); i++) {
        s1[i + 1] = s1[i] + v1[i] * v1[i];
        __int128 d1 = (s - v1[i]) % d, d2 = d - d1;
        ds1[i + 1] = ds1[i] + min(d1, d2) * min(d1, d2);
        ps1[i + 1] = ps1[i] + v1[i];
	}
	s2[0] = 0;
	ds2[0] = 0;
	ps2[0] = 0;
	for (int i = 0; i < v2.size(); i++) {
        s2[i + 1] = s2[i] + v2[i] * v2[i];
        __int128 d1 = (v2[i] - s) % d, d2 = d - d1;
        ds2[i + 1] = ds2[i] + min(d1, d2) * min(d1, d2);
        ps2[i + 1] = ps2[i] + v2[i];
	}
	long long t;
	cin >> m;
	for (int i = 0; i < m; i++) {
		cin >> t;
		cout << min(f1(t) + f2(2 * t), f1(2 * t) + f2(t)) << '\n';
	}
}
