#include <iostream>
#include <vector>
using namespace std;


int n, d;
vector<vector<int>> graph;
vector<pair<int, int>> ans;


bool dfs(int v, int f, int p, int len) {
	if (v == f)
		return len;
	int sum = 0;
	for (int u : graph[v]) {
		if (u == p)
			continue;
		sum += dfs(u, f, v, len + 1);
	}
	return sum;
}


vector<bool> used;
vector<int> x;


void gen(int id, int cnt) {
	if (id == n - n % 2) {
		if (cnt > ans.size()) {
			ans.clear();
			for (int i = 0; i < n; i += 2) {
				int res = dfs(x[i], x[i + 1], -1, 0);
				if (res % 2 == 1 && res <= d)
					ans.push_back({ x[i], x[i + 1] });
			}
		}
		return;
	}
	if (id % 2 == 0) {
		for (int i = 1; i <= n; i++) {
			if (!used[i]) {
				used[i] = true;
				x[id] = i;
				gen(id + 1, cnt);
				used[i] = false;
				return;
			}
		}
	}
	else {
		for (int i = 1; i <= n; i++) {
			if (!used[i]) {
				int b = 0;
				used[i] = true;
				int res = dfs(x[id - 1], i, -1, 0);
				if (res % 2 == 1 && res <= d)
					b = 1;
				x[id] = i;
				gen(id + 1, cnt + b);
				used[i] = false;
			}
		}
	}
}



int main() {
	int v, u;
	cin >> n >> d;
	graph.resize(n + 1);
	for (int i = 1; i < n; i++) {
		cin >> v >> u;
		graph[v].push_back(u);
		graph[u].push_back(v);
	}
	used.resize(n + 1, false);
	x.resize(n);
	gen(0, 0);
	cout << ans.size() << '\n';
	for (auto [a, b] : ans)
		cout << a << ' ' << b << '\n';
}
