#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

struct Min {
    ll val;

    Min() : val(INF) {}

    Min(ll _val) : val(_val) {}
};

Min operator+(Min a, Min b) {
    return {min(a.val, b.val)};
}

struct Sum {
    ll val;

    Sum() : val(INF) {}

    Sum(ll _val) : val(_val) {}
};

Sum operator+(Sum a, Sum b) {
    return {a.val + b.val};
}

class segtreeMin {
public:
    segtreeMin(ll N) {
        sz = 1;
        while (sz < N) {
            sz <<= 1;
        }
        n = sz * 2 - 1;
        tree.assign(n, Min());
    }

    ll get(ll l, ll r) {
        return get(0, l, r, 0, sz).val;
    }

    void set(ll i, ll x) {
        set(0, i, x, 0, sz);
    }
private:
    ll n, sz;
    vector<Min> tree;

    Min get(ll v, ll l, ll r, ll tl, ll tr) {
        if (l <= tl && tr <= r) {
            return tree[v];
        }
        if (tl >= r || tr <= l) {
            return Min();
        }
        ll tm = (tl + tr) / 2;
        return get(2 * v + 1, l, r, tl, tm) + get(2 * v + 2, l, r, tm, tr);
    }

    void set(ll v, ll i, ll x, ll tl, ll tr) {
        if (tr - tl == 1) {
            tree[v].val = min(x, tree[v].val);
            return;
        }
        ll tm = (tl + tr) / 2;
        if (i < tm) {
            set(2 * v + 1, i, x, tl, tm);
        } else {
            set(2 * v + 2, i, x, tm, tr);
        }
    }
};


bool cmp(tuple<ll, ll, ll> a, tuple<ll, ll, ll> b) {
    if (get<0>(a) == get<0>(b)) {
        return get<2>(a) < get<2>(b);
    }
}

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll T;
    cin >> T;
    while (T--) {
        ll n, k;
        cin >> n >> k;
        vector<ll> dpr(n + 1, 0);
        segtreeMin dpm(n + 1);
        vector<tuple<ll, ll, ll> > q(k);
        for (auto &[l, m, r]: q) {
            cin >> l >> m >> r;
            l--;
            m--;
            r--;
        }
        dpr[0] = 1;
        sort(q.begin(), q.end());
        for (ll x = 0; x < 1; ++x) {
            for (auto [l, m, r]: q) {
                ll sum = 0;
                for (ll j = l; j <= m; ++j) {
                    sum += dpr[j];
                }
                if (sum > 0) {
                    dpr[r + 1] = 1;
                    dpm.set(r + 1, m);
                }

                ll mn = dpm.get(m + 1, r + 1);
                if (mn < l) {
                    dpr[r + 1] = 1;
                    dpm.set(r + 1, m);
                }
            }
        }
        cout << (dpr[n] > 0 ? "YES" : "NO") << "\n";
    }

    return 0;
}
