#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <iomanip>
#include <cmath>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>

typedef long long ll;
using namespace std;

void ftl() {
	int ans = 0;
	for (int i = 0; i < 2100000000; ++i) {
		ans += i * i * cos(i);
	}
	cout << ans;
}

struct imp {
	int l, r, m;
	imp() {
		l = 0;
		r = 0;
		m = 0;
	}
	imp(int _l, int _m, int _r) {
		l = _l;
		m = _m;
		r = _r;
	}
};

bool flag = false;

void dfs(int v, vector<vector<bool>>& g, vector<int>& used) {
	used[v] = 1;
	for (int u = 0; u < g.size(); ++u) {
		if (g[v][u])
			if (used[u] == 1) {
				flag = true;
			} else if (used[u] == 0) {
				dfs(u, g, used);
			}
	}
	used[v] = 2;
}

vector<int> nums;

void dfsc(int v, vector<vector<bool>>& g, vector<int>& c, int col) {
	c[v] = col;
	nums.push_back(v);
	for (int i = 0; i < g.size(); ++i) {
		if (g[v][i]) {
			if (c[i] == -1) {
				dfsc(i, g, c, col);
			}
		}
	}
}

bool checkarr(int n, vector<imp>& arr) {
	vector<pair<int, int>> act;
	for (int i = 1; i <= n; ++i) {
		act.push_back({ i, 0 });
	}
	for (int i = 0; i < arr.size(); ++i) {
		act.push_back({ arr[i].l, -1 });
		act.push_back({ arr[i].r, 1 });
	}
	sort(act.begin(), act.end());
	int cnt = 0;
	for (pair<int, int> i : act) {
		if (i.second == -1) {
			cnt++;
		} else if (i.second == 1) {
			cnt--;
		} else {
			if (cnt < 0) ftl();
			if (cnt == 0) {
				return false;
			}
		}
	}
	return true;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<imp> arr(k);
	for (int i = 0; i < k; ++i) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
	}
	vector<vector<bool>> g(n, vector<bool>(n, false));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			if (i == j) continue;
			if (arr[i].l <= arr[j].m && arr[j].m <= arr[i].r) {
				g[i][j] = true;
			}
		}
	}
	vector<int> used(k, 0);
	for (int i = 0; i < k; ++i) {
		if (used[i] == 0) {
			dfs(i, g, used);
			if (flag) {
				break;
			}
		}
	}
	if (!flag) {
		vector<pair<int, int>> act;
		for (int i = 1; i <= n; ++i) {
			act.push_back({ i, 0 });
		}
		for (int i = 0; i < k; ++i) {
			act.push_back({ arr[i].l, -1 });
			act.push_back({ arr[i].r, 1 });
		}
		sort(act.begin(), act.end());
		int cnt = 0;
		for (pair<int, int> i : act) {
			if (i.second == -1) {
				cnt++;
			} else if (i.second == 1) {
				cnt--;
			} else {
				if (cnt < 0) ftl();
				if (cnt == 0) {
					cout << "NO";
					return;
				}
			}
		}
		cout << "YES";
		return;
	}

	for (int i = 0; i < (1 << k); ++i) {
		vector<int> pm;
		vector<imp> qwe;
		for (int j = 0; j < k; ++j) {
			if ((1 << j) & i) {
				qwe.push_back(arr[j]);
				pm.push_back(j);
			}
		}
		int _ = 1;
		for (int j = 1; j <= pm.size(); ++j) {
			_ *= j;
		}
		while (_--) {
			next_permutation(pm.begin(), pm.end());
			bool fl = true;
			for (int j = 0; j < pm.size() - 1; ++j) {
				if (arr[j + 1].m <= arr[j].r && arr[j + 1].m >= arr[j].l) {
					fl = false;
					break;
				}
			}
			if (fl) {
				if (checkarr(n, qwe)) {
					cout << "YES";
					return;
				} else {
					break;
				}
			}
		}
	}
	cout << "NO";
	/*
	set<int> ends;
	ends.insert(n - 1);
	map<int, vector<int>> all;
	for (int i = 0; i < n; ++i) {
		all[arr[i].r].push_back(arr[i].l);
	}
	for (int i = n - 1; i >= 0; --i) {
		if (ends.find(i) != ends.end()) {
			for (int j : all[i]) {

			}
		}
	}
	if (ends.find(0) != ends.end()) {
		cout << "YES";
	} else {
		cout << "NO";
	}*/
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
}
/*

11
4
2 4 10
3 6 8
1 3 5
7 9 11

*/