#include <iostream>
#include <vector>
#include <iomanip>
#include <cmath>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>

typedef long long ll;
using namespace std;

void ftl() {
	int ans = 0;
	for (int i = 0; i < 2100000000; ++i) {
		ans += i * i * cos(i);
	}
	cout << ans;
}

struct imp {
	int l, r, m;
	imp() {
		l = 0;
		r = 0;
		m = 0;
	}
	imp(int _l, int _m, int _r) {
		l = _l;
		m = _m;
		r = _r;
	}
};

bool flag = false;

void dfs(int v, vector<vector<int>>& g, vector<int>& used) {
	used[v] = 1;
	for (int u : g[v]) {
		if (used[u] == 1) {
			flag = true;
		} else if (used[u] == 0) {
			dfs(u, g, used);
		}
	}
	used[v] = 2;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<imp> arr(k);
	for (int i = 0; i < k; ++i) {
		cin >> arr[i].l >> arr[i].m >> arr[i].r;
	}
	vector<vector<int>> g(n);
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			if (i == j) continue;
			if (arr[i].l <= arr[j].m && arr[j].m <= arr[i].r) {
				g[i].push_back(j);
			}
		}
	}
	vector<int> used(k, 0);
	for (int i = 0; i < k; ++i) {
		if (used[i] == 0) {
			dfs(i, g, used);
			if (flag) {
				break;
			}
		}
	}
	if (!flag) {
		vector<pair<int, int>> act;
		for (int i = 1; i <= n; ++i) {
			act.push_back({ i, 0 });
		}
		for (int i = 0; i < k; ++i) {
			act.push_back({ arr[i].l, -1 });
			act.push_back({ arr[i].r, 1 });
		}
		sort(act.begin(), act.end());
		int cnt = 0;
		for (pair<int, int> i : act) {
			if (i.second == -1) {
				cnt++;
			} else if (i.second == 1) {
				cnt--;
			} else {
				if (cnt < 0) ftl();
				if (cnt == 0) {
					cout << "NO";
					return;
				}
			}
		}
		cout << "YES";
		return;
	}
	cout << "NO";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	cin >> _;
	while (_--) {
		flag = false;
		solve();
		cout << "\n";
	}
}
