#include <bits/stdc++.h>

using namespace std;

vector<bool> segTree;
vector<bool> mod;

void push(int v){
    if(!mod[v])return;
    segTree[v] = true;
    mod[v * 2 + 1] = true;
    mod[v * 2 + 2] = true;
    mod[v] = false;
}

bool get(int v){
    return mod[v] || segTree[v];
}

void setVal(int l1, int r1, int l, int r, int v){
    if(r1 <= l || r <= l1){
        return;
    }else if(l1 <= l && r <= r1){
        mod[v] = true;
        return;
    }
    int m = l + (r - l) / 2;
    push(v);
    setVal(l1, r1, l, m, v * 2 + 1);
    setVal(l1, r1, m, r, v * 2 + 2);
    segTree[v] = get(v * 2 + 1) || get(v * 2 + 2);
}

bool get(int l1, int r1, int l, int r, int v){
    if(r1 <= l || r <= l1){
        return false;
    }else if(l1 <= l && r <= r1){
        return get(v);
    }
    int m = l + (r - l) / 2;
    push(v);
    return get(l1, r1, l, m, v * 2 + 1) || get(l1, r1, m, r, v * 2 + 2);
}

vector<pair<int, int>> maxSegtree;
vector<pair<int, int>> maxMod;

pair<int, int> combine(pair<int, int> a, pair<int, int> b){
    if(a.first > b.first){
        return a;
    }else{
        return b;
    }
}

pair<int, int> getMax(int v){
    return combine(maxSegtree[v], maxMod[v]);
}

void pushMax(int v){
    if(maxMod[v].second == -1) return;
    maxMod[v * 2 + 1] = combine(maxMod[v * 2 + 1], maxMod[v]);
    maxMod[v * 2 + 2] = combine(maxMod[v * 2 + 2], maxMod[v]);
    maxSegtree[v] = combine(maxSegtree[v], maxMod[v]);
    maxMod[v] = {-1, -1};
}

pair<int, int> getMax(int ind, int l, int r, int v){
    if(r - l == 1){
        return getMax(v);
    }
    int m = l + (r - l) / 2;
    pushMax(v);
    if(ind < m){
        return getMax(ind, l, m, v * 2 + 1);
    }else{
        return getMax(ind, m, r, v * 2 + 2);
    }
}

void setMax(int l1, int r1, pair<int, int> val, int l, int r, int v){
    if(r1 <= l || r <= l1){
        return;
    }else if(l1 <= l && r <= r1){
        if(val > getMax(v)){
            maxMod[v] = val;
        }
        return;
    }
    int m = l + (r - l) / 2;
    pushMax(v);
    setMax(l1, r1, val, l, m, v * 2 + 1);
    setMax(l1, r1, val, m, r, v * 2 + 2);
    maxSegtree[v] = max(getMax(v * 2 + 1), getMax(v * 2 + 2));
}

struct worker{
    int l, m, r;
    bool operator<(worker oth){
        return r > oth.r;
    }
};

void solve(){
    int n, k;
    cin >> n >> k;

    vector<worker> arr(k);

    for(int i = 0; i < k; i++){
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        arr[i].l--;
        arr[i].m--;
    }

    sort(arr.begin(), arr.end());

    segTree.assign(n * 4, false);
    mod.assign(n * 4, false);

    maxSegtree.assign(n * 4, {-1, -1});
    maxMod.assign(n * 4, {-1, -1});

    for(int i = 0; i < k; i++){
        int res = (arr[i].r == n);
        if(!res){
            res = get(arr[i].m + 1, arr[i].r + 1, 0, n, 0);
            auto par = getMax(arr[i].m, 0, n, 0);
            res |= par.first >= arr[i].r && par.second > arr[i].l;
        }

        if(res){
            int l1 = arr[i].l;
            int r1 = arr[i].m;
            setVal(l1, l1 + 1, 0, n, 0);
            setMax(l1, r1, {arr[i].m, arr[i].l}, 0, n, 0);
        }
    }
    // for(int i = 0; i < n; i++){
    //     cout << get(i, i + 1, 0, n, 0);
    // }
    // cout << "\n";
    // for(int i = 0; i < n; i++){
    //     cout << getMax(i, 0, n, 0) << ' ';
    // }
    // cout << '\n';
    if(get(0, 1, 0, n, 0)){
        cout << "YES\n";
    }else{
        cout << "NO\n";
    }
}

int main(){
    #ifdef _LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    freopen("C:\\work\\output.txt", "w", stdout);
    #endif

    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}