#include <bits/stdc++.h>

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
            freopen("input.txt", "r", stdin);
            freopen("output.txt", "w", stdout);
    #endif

    int t;
    std::cin >> t;

    while (t--) solve();
}

class Tuple {
 public:
    int l, r, m;

    bool operator < (const Tuple& other) const {
        return r < other.r;
    }
};

class SegTree {
 private:
    std::vector <int> body;
 public:
    SegTree(int n) {
        body.resize(4 * n, INT_MAX);
    }

    inline void upd(int curV, int l, int r, int id, int val) {
        if (id < l || r <= id) return;

        if (l + 1 == r) {
            body[curV] = val;
            return;
        }

        int m = (l + r) / 2;
        upd(curV * 2 + 1, l, m, id, val);
        upd(curV * 2 + 2, m, r, id, val);

        body[curV] = std::min(body[curV * 2 + 2], body[curV * 2 + 1]);
    }

    inline int min(int curV, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return INT_MAX;

        if (ql <= l && r <= qr) return body[curV];

        int m = (l + r) / 2;
        return std::min(min(curV * 2 + 1, l, m, ql, qr), min(curV * 2 + 2, m, r, ql, qr));
    }
};

void solve() {
    int n, k;
    std::cin >> n >> k;

    std::vector <Tuple> tuples(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        std::cin >> l >> m >> r;

        --l; --m; --r;

        tuples[i] = {l, r, m};
    }

    std::sort(tuples.begin(), tuples.end());

    SegTree dp(n);

    for (auto [l, r, m] : tuples) {
        int curRes = dp.min(0, 0, n, r, r + 1);
        if (l == 0) {
            curRes = std::min(curRes, m);
        }
        // 1
        if (0 < m) {
            int minM = dp.min(0, 0, n, std::max(0, l - 1), m);
            if (minM != INT_MAX) curRes = std::min(curRes, m);
        }
        // 2
        if (0 < m) {
            int minM = dp.min(0, 0, n, std::max(0, l - 1), r);
            if (minM < l) curRes = std::min(curRes, m);
        }
        // relax
        dp.upd(0, 0, n, r, curRes);
    }

    int resoult = dp.min(0, 0, n, n - 1, n);
    if (resoult == INT_MAX) {
        std::cout << "NO" << '\n';
    } else {
        std::cout << "YES" << '\n';
    }
}

