#include <bits/stdc++.h>
#define int long long

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();
}

void solve() {
    int n;
    std::cin >> n;

    std::vector <int> xs(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> xs[i];
    }

    std::sort(xs.begin(), xs.end());

    int x0, d;
    std::cin >> x0 >> d;

    int m;
    std::cin >> m;

    std::vector <long long> minimum(n, 0);
    for (int i = 0; i < n; ++i) {
        xs[i] -= x0;
        xs[i] = abs(xs[i]);

        long long a = (xs[i] / d) * d;
        long long b = (xs[i] / d + 1) * d;

        long long min = std::min(abs(xs[i] - a), abs(xs[i] - b));
        minimum[i] = min * min;
    }

    std::vector <long long> prefMin(n, minimum[0]);
    for (int i = 1; i < n; ++i) {
        prefMin[i] = prefMin[i - 1] + minimum[i];
    }

    std::vector <long long> sq(n, 0), sum(n, 0), cnt(n, 0);
    for (int i = n - 1; 0 <= i; --i) {
        if (i < n - 1) {
            sq[i] += sq[i + 1];
            sum[i] += sum[i + 1];
            cnt[i] += cnt[i + 1];
        }

        sum[i] += xs[i];
        sq[i] += xs[i] * xs[i];
        cnt[i] += 1;
    }

    for (int i = 0; i < m; ++i) {
        int t;
        std::cin >> t;

        long long l = 0, r = 1'000'000;
        while (l + 1 < r) {
            long long mid1 = (l + r) / 2;
            long long mid2 = mid1 + 1;

            long long firstRes = mid1 * t;
            {
                long long fPos = mid1 * d;

                long long l1 = -1, r1 = n;
                while (l1 + 1 < r1) {
                    long long mid = (l1 + r1) / 2;

                    if (xs[mid] <= fPos) {
                        l1 = mid;
                    } else {
                        r1 = mid;
                    }
                }

                if (l1 > -1) firstRes += prefMin[l1];
                if (r1 < n) firstRes += fPos * fPos * cnt[r1] + sq[r1] - fPos * 2 * sum[r1];
            }
            long long secondRes = mid2 * t;
            {
                long long sPos = mid2 * d;

                long long l1 = -1, r1 = n;
                while (l1 + 1 < r1) {
                    long long mid = (l1 + r1) / 2;

                    if (xs[mid] <= sPos) {
                        l1 = mid;
                    } else {
                        r1 = mid;
                    }
                }

                if (l1 > -1) secondRes += prefMin[l1];
                if (r1 < n) secondRes += sPos * sPos * cnt[r1] + sq[r1] - sPos * 2 * sum[r1];
            }

            if (firstRes < secondRes) {
                r = mid1;
            } else {
                l = mid1;
            }
        }

        long long mid1 = l;
        long long mid2 = r;

        long long firstRes = mid1 * t;
        {
            long long fPos = mid1 * d;

            long long l1 = -1, r1 = n;
            while (l1 + 1 < r1) {
                long long mid = (l1 + r1) / 2;

                if (xs[mid] <= fPos) {
                    l1 = mid;
                } else {
                    r1 = mid;
                }
            }

            if (l1 > -1) firstRes += prefMin[l1];
            if (r1 < n) firstRes += fPos * fPos * cnt[r1] + sq[r1] - fPos * 2 * sum[r1];
        }
        long long secondRes = mid2 * t;
        {
            long long sPos = mid2 * d;

            long long l1 = -1, r1 = n;
            while (l1 + 1 < r1) {
                long long mid = (l1 + r1) / 2;

                if (xs[mid] <= sPos) {
                    l1 = mid;
                } else {
                    r1 = mid;
                }
            }

            if (l1 > -1) secondRes += prefMin[l1];
            if (r1 < n) secondRes += sPos * sPos * cnt[r1] + sq[r1] - sPos * 2 * sum[r1];
        }

        std::cout << std::min(firstRes, secondRes) << '\n';
    }
}