#include <bits/stdc++.h>
#define int long long

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
            freopen("input.txt", "r", stdin);
            freopen("output.txt", "w", stdout);
    #endif

    solve();
}

std::vector <std::vector <int>> edges;
std::vector <std::vector <int>> dist;
inline void calc(int curV, int prevV, int d, int s) {
    dist[s][curV] = d;

    for (auto nextV : edges[curV]) {
        if (nextV == prevV) return;

        calc(nextV, curV, d + 1, s);
    }
}

std::vector <int> red, blue;
inline void color(int curV, int prevV, int c) {
    if (c % 2 == 0) red.push_back(curV);
    if (c % 2 == 1) blue.push_back(curV);

    for (auto nextV : edges[curV]) {
        if (nextV == prevV) continue;

        color(nextV, curV, (c + 1) % 2);
    }
}

void solve() {
    int n;
    std::cin >> n;

    int d;
    std::cin >> d;

    edges.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        std::cin >> u >> v;

        --u; --v;

        edges[u].push_back(v);
        edges[v].push_back(u);
    }

    if (d == n - 1) {
        color(0, -1, 0);

        std::cout << std::min(red.size(), blue.size()) << '\n';
        for (int i = 0; i < std::min(red.size(), blue.size()); ++i) {
            std::cout << red[i] + 1 << ' ' << blue[i] + 1 << '\n';
        }
        return;
    }
    if (n <= 14) {
        dist.resize(n, std::vector <int> (n));
        for (int i = 0; i < n; ++i) {
            calc(i, -1, 0, i);
        }

        std::vector <std::pair <int, int>> parents(1 << n);

        int maxRes = 0;

        std::vector <int> cnt(1 << n, 0);
        for (int i = 0; i < (1 << n); ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = j + 1; k < n; ++k) {
                    if ((((i >> j) & 1) == 0) && (((i >> k) & 1) == 0)) {
                        if (dist[k][j] <= d && dist[k][j] % 2 == 1) {
                            if (cnt[i | (1 << k) | (1 << j)] < cnt[i] + 1) {
                                cnt[i | (1 << k) | (1 << j)] = cnt[i] + 1;
                                parents[i | (1 << k) | (1 << j)] = {j, k};
                            }
                        }
                    }
                }
            }
            if (cnt[maxRes] < cnt[i]) maxRes = i;
        }

        std::cout << cnt[maxRes] << '\n';
        int cur = maxRes;
        while (cur != 0) {
            auto [a, b] = parents[cur];
            std::cout << a + 1 << ' ' << b + 1 << '\n';
            cur ^= (1 << a);
            cur ^= (1 << b);
        }
    }
}
