#include <bits/stdc++.h>

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
            freopen("input.txt", "r", stdin);
            freopen("output.txt", "w", stdout);
    #endif

    solve();
}

std::vector <std::vector <int>> edges;
std::vector <std::vector <int>> dist;

inline void calc(int curV, int prevV, int d, int s) {
    dist[s][curV] = d;

    for (auto nextV : edges[curV]) {
        if (nextV == prevV) continue;

        calc(nextV, curV, d + 1, s);
    }
}

std::mt19937 rnd(time(nullptr));

void solve() {
    auto st = std::chrono::system_clock::now();

    int n;
    std::cin >> n;

    int d;
    std::cin >> d;

    edges.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        std::cin >> u >> v;

        --u; --v;

        edges[u].push_back(v);
        edges[v].push_back(u);
    }

    if (n <= 200) {
        dist.resize(n, std::vector <int> (n));
        for (int i = 0; i < n; ++i) {
            calc(i, -1, 0, i);
        }

        std::deque <std::pair <int, int>> res;
        std::deque <std::pair <int, int>> curRes;

        std::unordered_set <int> free;
        for (int i = 0; i < n; ++i) free.insert(i);

        while (std::chrono::system_clock::now() - st < std::chrono::milliseconds(1900)) {
            if (free.size() > 1 && abs(int(rnd())) % 100 < 90) {
                // add
                int step = abs(int(rnd())) % (int) free.size();
                auto it = free.begin();
                for (int i = 0; i < step; ++i) ++it;
                int cur = *it;
                int next = -1;
                for (auto i : free) {
                    if (dist[*it][i] <= d && dist[*it][i] % 2 == 1) {
                        next = i;
                        break;
                    }
                }
                if (next != -1) {
                    free.erase(cur);
                    free.erase(next);
                    curRes.push_back({cur, next});
                }
            } else {
                // erase
                if (!curRes.empty()) {
                    std::shuffle(curRes.begin(), curRes.end(), rnd);
                    free.insert(curRes.back().first);
                    free.insert(curRes.back().second);
                    curRes.pop_back();
                }
            }

            if ((int) res.size() < (int) curRes.size()) res = curRes;
        }

        std::cout << (int) res.size() << '\n';
        for (auto i : res) {
            std::cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    }
}