#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<ll> vis;
ll timer = 1;

void dfs(ll v, vector<vector<ll>> &g, vector<ll> &col) {
    for (auto &u :g[v]) {
        if (col[u]) continue;
        col[u] = 3 - col[v];
        dfs(u, g, col);
    }
}

vector<ll> bfs(ll s, vector<vector<ll>> &g, ll d) {
    vector<ll> res;
    queue<pair<ll, ll>> q;
    q.push({s, 0});
    vis[s] = timer;
    while (!q.empty()) {
        auto [v, w] = q.front();
        if (w % 2 == 1) res.push_back(v);
        q.pop();
        if (w + 1 > d) continue;
        for (auto &u : g[v]) {
            if (vis[u] == timer) continue;
            q.push({u, w + 1});
            vis[u] = timer;
        }
    }
    return res;
}

struct edge {
    ll to, f, c;
    edge(ll to, ll f, ll c) : to(to), f(f), c(c) {};
};

ll flow(ll m, ll v, vector<vector<ll>> &r, vector<edge> &edges, ll cf, vector<ll> &used) {
    if (v == m - 1) {
        return cf;
    }
    for (auto &u : r[v]) {
        if (used[edges[u].to] || edges[u].c - edges[u].f == 0) continue;
        used[edges[u].to] = 1;
        ll d = flow(m, edges[u].to, r, edges, min(cf, edges[u].c - edges[u].f), used);
        if (d > 0) {
            edges[u].f += d;
            edges[u ^ 1].f -= d;
            return d;
        }
    }
    return 0;
}

void solve() {
    ll n, d;
    cin >> n >> d;
    vector<vector<ll>> g(n, vector<ll> ());
    for (ll i = 0; i < n - 1; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<ll> col(n, 0);
    col[0] = 1;
    dfs(0, g, col);
    vector<pair<ll, ll>> res;
    vector<ll> one, two;
    for (ll i = 0; i < n; i++) {
        if (col[i] == 1) {
            one.push_back(i);
        } else {
            two.push_back(i);
        }
    }
    vis.assign(n, 0);
    vector<vector<ll>> go(n);
    for (ll i = 0; i < n; i++) {
        if (col[i] == 2) continue;
        go[i] = bfs(i, g, d);
        timer++;
    }
    ll m = n + 2;
    vector<edge> edges;
    vector<vector<ll>> r(m, vector<ll> ());
    for (ll i = 0; i < n; i++) {
        if (col[i] == 1) {
            r[0].push_back(edges.size());
            edges.push_back(edge(i + 1, 0, 1));
            r[i + 1].push_back(edges.size());
            edges.push_back(edge(0, 0, 0));
        } else {
            r[i + 1].push_back(edges.size());
            edges.push_back(edge(m - 1, 0, 1));
            r[m - 1].push_back(edges.size());
            edges.push_back(edge(i + 1, 0, 0));
        }
    }
    for (ll i = 0; i < n; i++) {
        if (col[i] == 2) continue;
        for (auto &j : go[i]) {
            r[i + 1].push_back(edges.size());
            edges.push_back(edge(j + 1, 0, 1));
            r[j + 1].push_back(edges.size());
            edges.push_back(edge(i + 1, 0, 0));
        }
    }
    ll ans = 0;
    vector<ll> used(m, 0);
    ll ds = flow(m, 0, r, edges, 1, used);
    while (ds > 0) {
        ans += ds;
        used.assign(m, 0);
        ds = flow(m, 0, r, edges, 1, used);
    }
    cout << ans << '\n' << -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
    // cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}