#include <iostream>
#include <bits/stdc++.h>
 
using namespace std;
 
using ll = long long;
using ld = long double;
 
vector<int> vis;
int timer = 1;
 
void dfs(int v, vector<vector<int>> &g, vector<int> &col) {
    for (auto &u :g[v]) {
        if (col[u]) continue;
        col[u] = 3 - col[v];
        dfs(u, g, col);
    }
}
 
vector<int> bfs(int s, vector<vector<int>> &g, int d) {
    vector<int> res;
    queue<pair<int, int>> q;
    q.push({s, 0});
    vis[s] = timer;
    while (!q.empty()) {
        auto [v, w] = q.front();
        if (w % 2 == 1) res.push_back(v);
        q.pop();
        if (w + 1 > d) continue;
        for (auto &u : g[v]) {
            if (vis[u] == timer) continue;
            q.push({u, w + 1});
            vis[u] = timer;
        }
    }
    return res;
}
 
struct edge {
    int to, f, c;
    edge(int to, int f, int c) : to(to), f(f), c(c) {};
};
 
vector<int> par;
 
int flow(int m, int v, vector<vector<int>> &r, vector<edge> &edges, int cf, vector<int> &used) {
    if (v == m - 1) {
        return cf;
    }
    for (auto &u : r[v]) {
        if (used[edges[u].to] || edges[u].c - edges[u].f == 0) continue;
        used[edges[u].to] = 1;
        int d = flow(m, edges[u].to, r, edges, min(cf, edges[u].c - edges[u].f), used);
        if (d > 0) {
            edges[u].f += d;
            edges[u ^ 1].f -= d;
            if (edges[u].c == 1) {
                par[v] = edges[u].to;
                par[edges[u].to] = v;
            } else {
                par[v] = -1;
                par[edges[u].to] = -1;
            }
            return d;
        }
    }
    return 0;
}
 
void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n, vector<int> ());
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<int> col(n, 0);
    col[0] = 1;
    dfs(0, g, col);
    vector<pair<int, int>> res;
    vector<int> one, two;
    for (int i = 0; i < n; i++) {
        if (col[i] == 1) {
            one.push_back(i);
        } else {
            two.push_back(i);
        }
    }
    vis.assign(n, 0);
    vector<vector<int>> go(n);
    for (int i = 0; i < n; i++) {
        if (col[i] == 2) continue;
        go[i] = bfs(i, g, d);
        timer++;
    }
    int m = n + 2;
    vector<edge> edges;
    vector<vector<int>> r(m, vector<int> ());
    for (int i = 0; i < n; i++) {
        if (col[i] == 1) {
            r[0].push_back(edges.size());
            edges.push_back(edge(i + 1, 0, 1));
            r[i + 1].push_back(edges.size());
            edges.push_back(edge(0, 0, 0));
        } else {
            r[i + 1].push_back(edges.size());
            edges.push_back(edge(m - 1, 0, 1));
            r[m - 1].push_back(edges.size());
            edges.push_back(edge(i + 1, 0, 0));
        }
    }
    for (int i = 0; i < n; i++) {
        if (col[i] == 2) continue;
        for (auto &j : go[i]) {
            r[i + 1].push_back(edges.size());
            edges.push_back(edge(j + 1, 0, 1));
            r[j + 1].push_back(edges.size());
            edges.push_back(edge(i + 1, 0, 0));
        }
    }
    int ans = 0;
    vector<int> used(m, 0);
    par.assign(m + 1, -1);
    int ds = flow(m, 0, r, edges, 1, used);
    while (ds > 0) {
        ans += ds;
        used.assign(m, 0);
        ds = flow(m, 0, r, edges, 1, used);
    }
    used.assign(m, 0);
    for (int i = 1; i <= n; i++) {
        if (used[i] || par[i] == -1 || par[i] == 0 || par[i] == n + 1) continue;
        res.push_back({i, par[i]});
        used[i] = 1;
        used[par[i]] = 1;
    }
    cout << res.size() << '\n';
    for (auto &[f, s] : res) cout << f << " " << s << '\n';
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t12 = 1;
    // cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}