#include <bits/stdc++.h>

using namespace std;

struct node {
    int sum, mx, push;
    node() : sum(0), mx(0), push(-1) {}
    node(int _v) : sum(_v), mx(_v), push(-1) {}
};

struct segtree {
    node merge(node l, node r) {
        node res;
        res.sum = l.sum + r.sum;
        res.mx = max(l.mx, r.mx);
        return res;
    }
    vector<node> t;
    int n;
    segtree(int _n) {
        n = _n;
        t.resize(4*n);
    }
    void push(int v, int tl, int tr) {
        if(v >= t.size()) {
            return;
        }
        if(t[v].push == -1) {
            return;
        }
        int tm = (tl + tr) / 2;
        apply(v*2, tl,tm,t[v].push);
        apply(v*2+1,tm+1, tr,t[v].push);
    }
    void apply(int v, int tl, int tr, int val) {
        t[v].sum = (tr - tl + 1) * val;
        t[v].mx = val;
        t[v].push = val;
    }
    void update(int v, int tl, int tr, int l, int r, int val) {
        if(l > r) {
            return;
        }
        if(l == tl && r == tr) {
            apply(v, tl, tr, val);
            return;
        }
        int tm = (tl + tr) / 2;
        push(v, tl, tr);
        update(v*2, tl, tm, l, min(r, tm),val);
        update(v*2+1, tm+1, tr, max(l, tm+1), r,val);
        t[v] = merge(t[v*2], t[v*2+1]);
    }
    node query(int v, int tl, int tr, int l, int r) {
        if(l > r) {
            return node();
        }
        if(l == tl && r == tr) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        push(v,tl, tr);
        return merge(query(v * 2, tl, tm, l, min(r, tm)), query(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
    }
};


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m;
    cin >> n >> m;
    vector<string> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> b(n, vector<int>(m));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            if(a[i][j] == '1') {
                b[i][j] = 1;
            }
        }
    }
    for(int i = 0; i < n; ++i) {
        for(int j = m-2; j >= 0; --j) {
            if(a[i][j] != '0') {
                b[i][j] += b[i][j+1];
            }
        }
    }    
    vector<int> val(n);
    int res = 0;
    for(int i = 0; i < m; ++i) {
        segtree val(n);
        int sum = 0;
        int curmx = 0;
        for(int j = 0; j < n; ++j) {         
            if(b[j][i] == 0) {
                val.update(1,0,n-1,0,i,0);
                continue;
            }
            if(b[j][i] < curmx) {
                res = max(res, sum);
                int l = -1, r = j - 1;
                while(r - l > 1) {
                    int middle = (l + r) / 2;
                    if(val.query(1, 0, n-1, middle, i).mx > b[j][i]) {
                        r = middle;
                    } else {
                        l = middle;
                    }
                }
                sum = sum - val.query(1,0,n-1,r,i).sum + b[j][i] * (i - r - 1);
                val.update(1,0,n-1,r,i,b[j][i]);
            }
            sum += b[j][i];
            val.update(1,0,n-1,j,j,b[j][i]);
            curmx = b[j][i];            
            res = max(res, sum);
        }
    }
    cout << res << '\n';
    return 0;
}