#include <bits/stdc++.h>
 
using namespace std;

#pragma GCC optimize("Ofast")

struct segtree {
    vector<int> t;
    int n;
    segtree(int _n) {
        n = _n;
        t.resize(4*n, 1e9);
    }
    int merge(int l, int r) {
        return min(l, r);
    }
    void update(int v, int tl, int tr, int pos, int val) {
        if(tl == tr) {
            t[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        if(pos <= tm) {
            update(v*2, tl, tm, pos, val);
        } else {
            update(v*2+1, tm+1, tr, pos, val);
        }
        t[v] = merge(t[v*2], t[v*2+1]);
    }
    int query(int v, int tl, int tr, int l, int r) {
        if(l > r) {
            return 1e9;
        }
        if(l == tl && r == tr) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        return merge(query(v * 2, tl, tm, l, min(r, tm)), query(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
    }
};


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while(tt--) {
        int n,k;
        cin >> n >> k;
        vector<vector<int>> a(k,vector<int>(3));
        for(int i = 0; i < k; ++i) {
            cin >> a[i][0] >> a[i][1] >> a[i][2];
            a[i][0]--;
            a[i][1]--;
            a[i][2]--;
        }
        segtree st(n);
        sort(a.begin(), a.end(), [&](auto l, auto r) {return l[2] < r[2];});
        for(int i = 0; i < k; ++i) {
            int l = a[i][0];
            int m = a[i][1];
            int r = a[i][2];
            if(l == 0) {                
                int x = st.query(1,0,n-1,r,r);    
                x = min(x, a[i][1]);
                st.update(1,0,n-1,r, x);
            }
            int mn1 = st.query(1,0,n-1,max(0, l-1),m-1);         
            int mn2 = st.query(1,0,n-1,m, r-1);
            int x = st.query(1,0,n-1,r,r);      
            if(mn1 != 1e9)  {
                x = min(x, max(mn1, m));
            }
            if(mn2 < l) {
                x = min(x, max(mn2, m));
            }
            st.update(1,0,n-1,r,x);
        }
        cout << ((st.query(1,0,n-1,n-1, n-1) != 1e9) ? "YES\n" : "NO\n");
    }
    return 0;
}