#include <bits/stdc++.h>
 
using namespace std;

struct segtree {
    vector<int> t;
    int n;
    segtree(int _n) {
        n = _n;
        t.resize(4*n);
    }
    int merge(int l, int r) {
        return min(l, r);
    }
    void update(int v, int tl, int tr, int pos, int val) {
        if(tl == tr) {
            t[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        if(pos <= tm) {
            update(v*2, tl, tm, pos, val);
        } else {
            update(v*2+1, tm+1, tr, pos, val);
        }
        t[v] = merge(t[v*2], t[v*2+1]);
    }
    int query(int v, int tl, int tr, int l, int r) {
        if(l > r) {
            return 1e9;
        }
        if(l == tl && r == tr) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        return merge(query(v * 2, tl, tm, l, min(r, tm)), query(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
    }
};


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while(tt--) {
        int n,k;
        cin >> n >> k;
        vector<vector<int>> a(k,vector<int>(3));
        for(int i = 0; i < k; ++i) {
            cin >> a[i][0] >> a[i][1] >> a[i][2];
            a[i][0]--;
            a[i][1]--;
            a[i][2]--;
        }
        segtree st(n);
        for(int i = 0; i < n; ++i) {
            st.update(1,0,n-1,i,1e9);
        }
        vector<int> dp(n, 1e9);
        sort(a.begin(),a.end(), [&](auto l, auto r) {return l[2] < r[2];});
        for(int i = 0; i < k; ++i) {
            int l = a[i][0];
            int m = a[i][1];
            int r = a[i][2];
            if(l == 0) {
                dp[r] = min(dp[r], a[i][1]);
                st.update(1,0,n-1,r, dp[r]);
            }
            int mn1 = st.query(1,0,n-1,max(0, l-1),m-1);            
            // for(int j = max(0, l-1); j < m; ++j) {
            //     mn1 = min(mn1, dp[j]);
            // }
            int mn2 = st.query(1,0,n-1,m, r-1);
            // for(int j = m; j < r; ++j) {
            //     mn2 = min(mn2, dp[j]);
            // }
            if(mn1 != 1e9) {
                dp[r] = min(dp[r], max(mn1, m));
            }
            if(mn2 < l  ) {
                dp[r] = min(dp[r], max(mn2, m));
            }
            st.update(1,0,n-1,r,dp[r]);
        }
        cout << ((dp[n-1] != 1e9) ? "YES\n" : "NO\n");
    }
    return 0;
}