#include <bits/stdc++.h>

using ll = long long;

#define pb push_back
#define int ll

const int INF = 1e18;

using namespace std;

int n, k;

vector<int>t;

void build (int v, int tl, int tr, vector<int>&a) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }

    int tm = (tl+tr)/2;
    build(2*v, tl, tm, a);
    build(2*v+1, tm+1, tr, a);
    t[v] = min(t[2*v], t[2*v+1]);
}

int get (int v, int tl, int tr, int l, int r) {
    if (l > r) {
        return INF;
    }
    if (l == tl and r == tr) {
        return t[v];
    }

    int tm = (tl+tr)/2;
    return min(get(2*v, tl, tm, l, min(r, tm)), get(2*v+1, tm+1, tr, max(l, tm+1), r));
}

int get(int l, int r) {
    return get(1, 0, n, l, r);
}

void update(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        t[v] = x;
        return;
    }
    int tm = (tl+tr)/2;
    if (pos <= tm) {
        update(2*v, tl, tm, pos, x);
    }
    else {
        update(2*v+1, tm+1, tr, pos, x);
    }
    t[v] = min(t[v*2], t[v*2+1]);
}

void update(int pos, int x) {
    update(1, 0, n, pos, x);
}

void solve() {
    cin >> n >> k;
    vector<vector<pair<int, int>>>rab(n);
    for (int i=0; i<k; i++) {
        int l, r, m;
        cin >> l >> m >> r;
        l--; m--; r--;
        rab[r].pb({l, m});
    }

    vector<int>dp(n+1, INF);
    dp[0] = -1;
    t.assign(4*n, 0);
    build(1, 0, n, dp);

    for (int r = 1; r <= n; r++) {
        for (auto [l, m]:rab[r-1]) {
            bool e = false;
            if (get(l, m) != INF) {
                e = true;
            }
            if (get(m+1, r) < l) {
                e = true;
            }
            if (e) {
                dp[r] = min(dp[r], m);
            }
            update(r, dp[r]);
        }
    }

    if (dp[n] != INF) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tt;
    cin >> tt;
    while(tt--) {
        solve();
    }
}