#include <bits/stdc++.h>

using ll = long long;

#define pb push_back
#define int ll

const int INF = 1e18;

using namespace std;

vector<vector<int>>g;
vector<vector<int>>gn;
vector<vector<int>>dist;

int st;
void dfs (int v, int p) {
    if (p == -1) {
        dist[st][v] = 0;
    }
    else {
        dist[st][v] = dist[st][p] + 1;
    }

    for (auto u:g[v]) {
        if (u == p) continue;
        dfs(u, v);
    }
}

vector<int>col;
void dfs_col (int v, int p) {
    if (p == -1) {
        col[v] = 1;
    }
    else {
        col[v] = 3-col[p];
    }
    for (auto u:g[v]) {
        if (col[u] == -1) {
            dfs_col(u, v);
        }
    }
}

int timer = 1;
vector<int>mt;
vector<int>used;
bool kuhn (int v) {
    if (used[v] == timer) {
        return false;
    }
    for (auto u:gn[v]) {
        if (mt[u] == -1 or kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i=0; i<n-1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
    }

    dist.resize(n, vector<int>(n, -1));
    for (int i=0; i<n; i++) {
        st = i;
        dfs(i, -1);
    }

    gn.resize(n);
    for (int i=0; i<n; i++) {
        for (int j=i+1; j<n; j++) {
            if (dist[i][j] % 2 == 1 and dist[i][j] <= d) {
                gn[i].pb(j);
            }
        }
    }

    col.resize(n, -1);
    dfs_col(0, -1);
    mt.resize(n, -1);
    used.resize(n, 0);
    for (int i=0; i<n; i++) {
        if (col[i] == 1) {
            kuhn(i);
            timer++;
        }
    }

    int ans = 0;
    for (int i=0; i<n; i++) {
        if (col[i] == 2 and mt[i] != -1) {
            ans++;
        }
    }
    cout << ans;
}