#include <bits/stdc++.h>
using namespace std;
constexpr int MAXN = 10'001;
vector<int> g[MAXN], order;
char used[MAXN];

void dfs(int u) {
    used[u] = 1;
    for (int v: g[u]) {
        if (!used[v]) {
            dfs(v);
        }
    }
    order.push_back(u);
}


bool check(int n, vector<tuple<int, int, int> > A) {
    vector<int> used(n + 1);
    for (auto [l, m, r]: A) {
        if (!used[m]) {
            for (int i = l; i <= r; i++) {
                used[i] = 1;
            }
        }
    }
    return count(used.begin(), used.end(), 1) == n;
}


bool cover(tuple<int, int, int> A, tuple<int, int, int> B) {
    auto [l1, m1, r1] = A;
    auto [l2, m2, r2] = B;
    return l1 <= m2 && m2 <= r1;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<tuple<int, int, int> > A(k);
    order.clear();
    for (int i = 0; i < k; i++) {
        g[i].clear();
        used[i] = 0;
        int l, m, r;
        cin >> l >> m >> r;
        A[i] = {l, m, r};
    }
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (cover(A[i], A[j])) {
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < k; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(order.begin(), order.end());
    vector<tuple<int, int, int> > R(k);
    for (int i = 0; i < k; i++) {
        R[i] = A[order[i]];
    }
    cout << (check(n, R) ? "YES" : "NO") << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
