#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
mt19937 rnd(42);
constexpr int MAXN = 151;
int t[MAXN * 4];
vector<array<int, 3> > good;

void build() {
    for (int i = 0; i < MAXN * 4; i++) t[i] = 0;
}

void upd(int v, int l, int r, int L, int R) {
    if (L <= l && r <= R) {
        t[v] = 1;
        return;
    }
    if (l > R || r < L) {
        return;
    }
    int m = (l + r) / 2;
    upd(v * 2 + 1, l, m, L, R);
    upd(v * 2 + 2, m + 1, r, L, R);
}

int get(int v, int l, int r, int POS) {
    if (t[v]) return 1;
    if (l == r) return 0;
    int m = (l + r) / 2;
    if (POS <= m) {
        return get(v * 2 + 1, l, m, POS);
    } else {
        return get(v * 2 + 2, m + 1, r, POS);
    }
}

bool cover(array<int, 3> A, array<int, 3> B) {
    auto [l1, m1, r1] = A;
    auto [l2, m2, r2] = B;
    return l1 <= m2 && m2 <= r1;
}

bool check(int n, vector<array<int, 3> > A) {
    build();
    for (auto [l, m, r]: good) {
        if (!get(0, 1, n, m)) {
            upd(0, 1, n, l, r);
        }
    }
    for (auto [l, m, r]: A) {
        if (!get(0, 1, n, m)) {
            upd(0, 1, n, l, r);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!get(0, 1, n, i)) {
            return false;
        }
    }
    return true;
}


void solve() {
    int n, k;
    cin >> n >> k;
    good.clear();

    vector<array<int, 3> > A(k), bad;
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        A[i] = {l, m, r};
    }
    for (int i = 0; i < k; i++) {
        bool f = true;
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (cover(A[i], A[j])) {
                f = false;
                break;
            }
        }
        if (f) {
            good.push_back(A[i]);
        } else {
            bad.push_back(A[i]);
        }
    }

    for (int i = 0; i < 10000; i++) {
        shuffle(bad.begin(), bad.end(), rnd);
        if (check(n, bad)) {
            cout << "YES\n";
            return;
        }
    }

    cout << "NO" << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
