#include <bits/stdc++.h>
using namespace std;
constexpr int MAXN = 5e5 + 1, K = 20;
vector<int> g[MAXN];
int p[MAXN], total = 0;
vector<int> vals[2];
int parent[MAXN], up[K][MAXN], depth[MAXN];

void dfs(int u, int prev = -1) {
    for (int v: g[u]) {
        if (v == prev) continue;
        parent[v] = up[0][v] = u;
        depth[v] = depth[u] + 1;
        dfs(v, u);
    }
    vals[depth[u] % 2].push_back(u);
}

int lca(int u, int v) {
    if (depth[v] > depth[u]) {
        swap(u, v);
    }
    for (int st = K - 1; st >= 0; st--) {
        if (depth[up[st][u]] >= depth[v]) {
            u = up[st][u];
        }
    }
    if (u == v) return u;
    for (int st = K - 1; st >= 0; st--) {
        if (up[st][u] != up[st][v]) {
            u = up[st][u];
            v = up[st][v];
        }
    }
    return parent[u];
}

int path(int u, int v) {
    return depth[u] + depth[v] - depth[lca(u, v)] * 2;
}

vector<int> g2[MAXN], mt(MAXN, -1);
int used[MAXN], timer = 1;

bool try_kuhn(int u) {
    if (used[u] == timer) {
        return false;
    }
    used[u] = timer;
    for (int v: g2[u]) {
        if (mt[v] == -1) {
            mt[v] = u;
            return true;
        }
    }
    for (int v: g2[u]) {
        if (mt[v] == -1 || try_kuhn(mt[v])) {
            mt[v] = u;
            return true;
        }
    }
    return false;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    parent[1] = up[0][1] = 1;

    int n, d;
    cin >> n >> d;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1);
    for (int st = 1; st < K; st++) {
        for (int u = 1; u <= n; u++) {
            up[st][u] = up[st - 1][up[st - 1][u]];
        }
    }
    for (int x: vals[0]) {
        for (int y: vals[1]) {
            if (path(x, y) <= d) {
                g2[x].push_back(y);
            }
        }
    }
    for (int x: vals[0]) {
        timer++;
        try_kuhn(x);
    }
    for (int x: vals[1]) {
        if (mt[x] != -1) {
            total++;
            p[x] = mt[x];
            p[mt[x]] = x;
        }
    }
    cout << total << "\n";
    for (int i = 1; i <= n; i++) {
        if (p[i] > i) {
            cout << i << " " << p[i] << "\n";
        }
    }
    return 0;
}
