#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
constexpr int MAXN = 5e5 + 1;
vector<int> g[MAXN];
int p[MAXN], total = 0;
vector<int> vals[2];
int parent[MAXN], depth[MAXN];

void dfs(int u, int prev = -1) {
    for (int v: g[u]) {
        if (v == prev) continue;
        depth[v] = depth[u] + 1;
        dfs(v, u);
    }
    vals[depth[u] % 2].push_back(u);
}

vector<int> g2[MAXN], mt(MAXN, -1);
int used[MAXN], timer = 1;

bool try_kuhn(int u) {
    if (used[u] == timer) {
        return false;
    }
    used[u] = timer;
    for (int v: g2[u]) {
        if (mt[v] == -1) {
            mt[v] = u;
            return true;
        }
    }
    for (int v: g2[u]) {
        if (mt[v] == -1 || try_kuhn(mt[v])) {
            mt[v] = u;
            return true;
        }
    }
    return false;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    parent[1] = 1;

    int n, d;
    cin >> n >> d;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1);
    vector<int> q, dist(n + 1);
    if (vals[1].size() < vals[0].size()) {
        swap(vals[0], vals[1]);
    }
    for (int x: vals[0]) {
        q.clear();
        q.push_back(x);
        dist.assign(n + 1, -1);
        dist[x] = 0;
        for (int qi = 0; qi < q.size(); qi++) {
            int u = q[qi];
            if (dist[u] % 2 == 1) {
                g2[x].push_back(u);
            }
            if (dist[u] + 1 > d) break;
            for (int v : g[u]) {
                if (dist[v] == -1) {
                    dist[v] = dist[u] + 1;
                    q.push_back(v);
                }

            }
        }
    }
    for (int x: vals[0]) {
        timer++;
        try_kuhn(x);
    }
    for (int x: vals[1]) {
        if (mt[x] != -1) {
            total++;
            p[x] = mt[x];
            p[mt[x]] = x;
        }
    }
    cout << total << "\n";
    for (int i = 1; i <= n; i++) {
        if (p[i] > i) {
            cout << i << " " << p[i] << "\n";
        }
    }
    return 0;
}
