#include <bits/stdc++.h>
using namespace std;

#define int long long

long long calc_something(long long t, int d) {
    long long x(t % d);
    if (x > d - x) {
        x = d - x;
    }
    return x * x;
}

using Quad = tuple<__int128, __int128, __int128>;

Quad operator +(Quad a, Quad b) {
    return {get<0>(a) + get<0>(b), get<1>(a) + get<1>(b), get<2>(a) + get<2>(b)};
}

Quad operator -(Quad a, Quad b) {
    return {get<0>(a) - get<0>(b), get<1>(a) - get<1>(b), get<2>(a) - get<2>(b)};
}

Quad gen_quad(long long d, long long t) { //(kd - t)^2
    return {d * d, -2 * d * t, t * t};
}

Quad gen_quad_2(long long d, long long t) {
    return {0, 0, calc_something(t, d)};
}

Quad gen_quad_3(long long v) {
    return {0, v, 0};
}

long long minimize(Quad a) {
    if (get<0>(a) == 0) {
        return 0;
    }
    if (get<1>(a) > 0) {
        return 0;
    }
    long long ans((-get<1>(a)) / get<0>(a));
    if (ans <= 0) {
        return 0;
    }
    return (ans + 1) / 2;
}

__int128 get(Quad a, __int128 b) {
    return b * b * get<0>(a) + b * get<1>(a) + get<2>(a); //b will probably be an int
}

vector<long long> calculate_one_dir(vector<pair<long long, int>>& speeds, vector<long long>& targets, long long d) {
    //targets are sorted, speeds are antisorted
    Quad orig_quad{0, 0, 0};
    for (auto i : targets) {
        orig_quad = orig_quad + gen_quad(d, i);
    }
    vector<long long> ans(speeds.size(), 0);
    if (targets.size() == 0) {
        return ans;
    }
    int next_target(-1);
    Quad next_quad;
    next_quad = orig_quad;
    do {
        next_target++;
        next_quad = next_quad - gen_quad(d, targets[next_target]) + gen_quad_2(d, targets[next_target]);
    } while ((next_target < targets.size() - 1) && (targets[next_target + 1] / d == targets[next_target] / d));
    int cur_target(-1);
    for (auto i : speeds) {
        while (true) {
            //cout << "!" << next_target << endl;
            Quad next_speed_quad;
            next_speed_quad = next_quad + gen_quad_3(i.first);
            Quad speed_quad;
            speed_quad = orig_quad + gen_quad_3(i.first);
            int min1(minimize(speed_quad));
            int min2(minimize(next_speed_quad));
            int limpos2((targets[next_target] + d - 1) / d);
            min2 = max(min2, limpos2);
            int limpos1(0);
            if (cur_target >= 0) {
                limpos1 = (targets[cur_target] + d - 1) / d;
            }
            min1 = max(min1, limpos1);
            __int128 get1;
            get1 = get(speed_quad, min1);
            __int128 get2;
            get2 = get(next_speed_quad, min2);
            //cout << (long long)get<0>(speed_quad) << " " << (long long)get<1>(speed_quad) << " " << (long long)get<2>(speed_quad) << endl;
            //cout << i.first << " " << next_target << " " << limpos1 << " " << limpos2 << " " << min1 << " " << min2 << " " << (long long)get1 << " " << (long long)get2 << endl;
            if ((get2 <= get1) && (next_target < targets.size() - 1)) {
                orig_quad = next_quad;
                cur_target = next_target;
                do {
                    next_target++;
                    next_quad = next_quad - gen_quad(d, targets[next_target]) + gen_quad_2(d, targets[next_target]);
                } while ((next_target < targets.size() - 1) && (targets[next_target + 1] / d == targets[next_target] / d));
            } else {
                //cout << "!" << i.first << " " << (long long)get1 << endl;
                ans[i.second] = get1;
                break;
            }
        }
    }
    return ans;
}

signed main() { //for x0 = 0
    int n, q, x0, d;
    cin >> n;
    vector<long long> targets{};
    for (int i = 0; i < n; i++) {
        cin >> q;
        targets.push_back(q);
    }
    cin >> x0 >> d;
    vector<long long> targets1{}, targets2{};
    for (int i = 0; i < n; i++) {
        if (targets[i] > x0) {
            targets1.push_back(targets[i] - x0);
        } else {
            targets2.push_back(x0 - targets[i]);
        }
    }
    sort(targets1.begin(), targets1.end());
    sort(targets2.begin(), targets2.end());
    int m;
    cin >> m;
    vector<pair<long long, int>> peple{};
    for (int i = 0; i < m; i++) {
        cin >> q;
        peple.push_back({q, i});
        peple.push_back({2 * q, m + i});
    }
    sort(peple.begin(), peple.end());
    reverse(peple.begin(), peple.end());
    vector<long long> answers1(calculate_one_dir(peple, targets1, d));
    vector<long long> answers2(calculate_one_dir(peple, targets2, d));
    for (int i = 0; i < m; i++) {
        cout << min(answers1[i] + answers2[m + i], answers1[m + i] + answers2[i]) << endl;
    }
}
