#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int h, w;
	cin >> h >> w;
	vector<vector<int>> v(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			char c;
			cin >> c;
			if (c == '1')
				v[i][j] = 1;
			//cin >> v[i][j];
		}
	}
	vector<vector<int>> maxlen(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		if (v[i].back() == 1)
			maxlen[i].back() = 1;
		for (int j = w - 2; j >= 0; j--) {
			if (v[i][j] == 0)
				continue;
			maxlen[i][j] = maxlen[i][j + 1] + 1;
		}
	}
	vector<vector<int>> nextlow(h, vector<int>(w, -1));
	for (int col = 0; col < w; col++) {
		stack<int> st;
		for (int i = h - 1; i >= 0; i--) {
			while (!st.empty() && maxlen[st.top()][col] > maxlen[i][col]) {
				int cur = st.top();
				st.pop();
				nextlow[cur][col] = i;
			}
			st.push(i);
		}
	}
	vector<vector<int>> dp(h, vector<int>(w, -1));
	int ans = 0;
	for (int col = 0; col < w; col++) {
		for (int i = 0; i < h; i++) {
			int cur = maxlen[i][col] * (i - nextlow[i][col]);
			dp[i][col] = cur;
			if (nextlow[i][col] != -1)
				dp[i][col] += dp[nextlow[i][col]][col];
			ans = max(ans, dp[i][col]);
		}
	}
	cout << ans;
}
