#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

struct one {
	int l, r, m;
	one() {}
	one(int l, int r, int m) {
		this->l = l;
		this->r = r;
		this->m = m;
	}
};

vector<vector<int>> g;
vector<int> used;
bool flag = 1;

void dfs(int v) {
	if (!flag)
		return;
	used[v] = 1;
	for (auto i : g[v]) {
		if (used[i] == 0)
			dfs(i);
		else if (used[i] == 1) {
			flag = 0;
			break;
		}
	}
	used[v] = 2;
}


int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		vector<one> v(k);
		vector<vector<bool>> dp(n, vector<bool>(n, 0));
		for (int i = 0; i < k; i++) {
			int l, m, r;
			cin >> l >> m >> r;
			l--; m--; r--;
			v[i] = one(l, r, m);
			dp[l][r] = 1;
		}
		for (int len = 1; len <= n; len++) {
			for (int l = 0; l + len - 1 < n; l++) {
				int r = l + len - 1;
				vector<int> goodl, goodr;
				for (int rb = l; rb <= r; rb++) {
					if (dp[l][rb])
						goodr.push_back(rb);
				}
				for (int lb = l; lb <= r; lb++) {
					if (dp[lb][r])
						goodl.push_back(lb);
				}
				for (auto i : v) {
					if (dp[l][r])
						break;
					if (!(l <= i.l && i.r <= r))
						continue;
					int rb = i.m - 1;
					int lb = i.m + 1;
					bool leftok = 0, rightok = 0;
					if (i.l == l)
						leftok = 1;
					if (i.r == r)
						rightok = 1;
					if (!goodr.empty()) {
						int L = 0, R = goodr.size() - 1;
						while (L != R) {
							int mid = (L + R + 1) >> 1;
							if (goodr[mid] <= rb)
								L = mid;
							else
								R = mid - 1;
						}
						if (goodr[L] <= rb && goodr[L] >= i.l - 1)
							leftok = 1;
					}
					if (!goodl.empty()) {
						int L = 0, R = goodl.size() - 1;
						while (L != R) {
							int mid = (L + R) >> 1;
							if (goodl[mid] >= lb)
								R = mid;
							else
								L = mid + 1;
						}
						if (goodl[L] >= lb && goodl[L] <= i.r + 1)
							rightok = 1;
					}
					if (leftok && rightok)
						dp[l][r] = 1;
				}
			}
		}
		if (dp[0][n - 1])
			cout << "YES\n";
		else
			cout << "NO\n";
	}
}
