#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

struct one {
	int l, r, m;
	one() {}
	one(int l, int r, int m) {
		this->l = l;
		this->r = r;
		this->m = m;
	}
};

vector<vector<int>> g;
vector<int> used;
bool flag = 1;

void dfs(int v) {
	if (!flag)
		return;
	used[v] = 1;
	for (auto i : g[v]) {
		if (used[i] == 0)
			dfs(i);
		else if (used[i] == 1) {
			flag = 0;
			break;
		}
	}
	used[v] = 2;
}

bool cmp(one& a, one& b) {
	if (a.l != b.l)
		return a.l > b.l;
	return a.r - a.l > b.r - b.l;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		vector<one> v(k);
		for (int i = 0; i < k; i++) {
			int l, m, r;
			cin >> l >> m >> r;
			l--; m--; r--;
			v[i] = one(l, r, m);
		}
		vector<int> inc(n, 0);
		vector<int> sub(n, 0);
		sort(v.begin(), v.end(), cmp);
		for (int i = 0; i < v.size(); i++) {
			if (i > 0 && v[i - 1].l == v[i].l)
				continue;
			inc[v[i].l]++;
			sub[v[i].r]++;
		}
		vector<int> cov(n, 0);
		int cur = 0;
		for (int i = 0; i < n; i++) {
			cur += inc[i];
			cov[i] = cur;
			cur -= sub[i];
		}
		bool ok = 1;
		for (auto i : cov) {
			if (i == 0)
				ok = 0;
		}
		if (ok)
			cout << "YES\n";
		else
			cout << "NO\n";
	}
}
