#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

vector<vector<int>> tree;
vector<int> depth;
vector<vector<int>> g;
vector<int> used, mp;
vector<vector<int>> dist;

void dfs(int v, int d) {
	depth[v] = d;
	for (auto i : tree[v]) {
		if (depth[i] == -1)
			dfs(i, d + 1);
	}
}

void dfsdist(int v, int d, int s) {
	dist[s][v] = d;
	for (auto i : tree[v]) {
		if (dist[s][i] == -1)
			dfsdist(i, d + 1, s);
	}
}

bool kuhn(int v,int cur) {
	if (used[v] == cur)
		return 0;
	used[v] = cur;
	for (auto i : g[v]) {
		if (mp[i] == -1) {
			mp[i] = v;
			return 1;
		}
	}
	for (auto i : g[v]) {
		if (kuhn(mp[i], cur)) {
			mp[i] = v;
			return 1;
		}
	}
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, d;
	cin >> n >> d;
	tree.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		tree[a].push_back(b);
		tree[b].push_back(a);
	}
	depth.assign(n, -1);
	dfs(0, 0);
	dist.assign(n, vector<int>(n, -1));
	for (int i = 0; i < n; i++) {
		dfsdist(i, 0, i);
	}
	used.assign(n, -1);
	mp.assign(n, -1);
	g.resize(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j || depth[i] % 2 == 1 || depth[i] % 2 == depth[j] % 2)
				continue;
			if (dist[i][j] <= d)
				g[i].push_back(j);
		}
	}
	int cur = 0;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (depth[i] % 2 == 0) {
			if (kuhn(i, cur)) {
				ans++;
				cur++;
			}
		}
	}
	cout << ans << '\n';
	for (int i = 0; i < n; i++) {
		if (mp[i] != -1) {
			cout << mp[i] + 1 << " " << i + 1 << '\n';
		}
	}
}
