#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

vector<vector<int>> tree;
vector<int> depth;
vector<vector<int>> g;
vector<int> used, mp;
vector<vector<int>> dist;
vector<int> fk;

void dfs(int v, int d) {
	depth[v] = d;
	for (auto i : tree[v]) {
		if (depth[i] == -1) {
			dfs(i, d + 1);
			if (fk[v] == -1)
				fk[v] = i;
		}
	}
}

void dfsdist(int v, int d, int s) {
	dist[s][v] = d;
	for (auto i : tree[v]) {
		if (dist[s][i] == -1)
			dfsdist(i, d + 1, s);
	}
}

bool kuhn(int v,int cur) {
	if (used[v] == cur)
		return 0;
	used[v] = cur;
	for (auto i : g[v]) {
		if (mp[i] == -1) {
			mp[i] = v;
			return 1;
		}
	}
	for (auto i : g[v]) {
		if (kuhn(mp[i], cur)) {
			mp[i] = v;
			return 1;
		}
	}
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, d;
	cin >> n >> d;
	tree.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		tree[a].push_back(b);
		tree[b].push_back(a);
	}
	depth.assign(n, -1);
	fk.assign(n, -1);
	dfs(0, 0);
	int z = 0, o = 0;
	for (int i = 0; i < n; i++) {
		if (depth[i] & 1) {
			if (fk[i] != -1)
				o++;
		}
		else {
			if (fk[i] != -1)
				z++;
		}
	}
	int r = 0;
	if (o > z)
		r = 1;
	cout << max(o, z) << '\n';
	for (int i = 0; i < n; i++) {
		if (depth[i] % 2 == r && fk[i] != -1)
			cout << i + 1 << " " << fk[i] + 1 << '\n';
	}
}
