#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#pragma GCC target("avx2")

using namespace std;
using ll = long long;

vector<vector<int>> tree;
vector<int> depth;

void dfs(int v, int d) {
	depth[v] = d;
	for (auto i : tree[v]) {
		if (depth[i] == -1) {
			dfs(i, d + 1);
		}
	}
}

vector<int> dp1, dp0;
vector<bool> used;
vector<pair<int, int>> outp;
vector<int> neighb;

void dfs_dp(int v) {
	used[v] = 1;
	bool tookz = 0;
	int idx = -1;
	int summax = 0;
	int kids = 0;
	int curn = -1;
	for (auto i : tree[v]) {
		if (used[i])
			continue;
		dfs_dp(i);
		summax += max(dp0[i], dp1[i]);
		if (dp0[i] >= dp1[i]) {
			tookz = 1;
			curn = i;
		}
		if (idx == -1 || dp0[i] - dp1[i] > dp0[idx] - dp1[idx])
			idx = i;
		kids++;
	}
	dp0[v] = summax;
	if (tookz == 0 && idx != -1) {
		summax += dp0[idx] - dp1[idx];
		curn = idx;
	}
	if (idx != -1 && kids > 0) {
		dp1[v] = summax + 1;
		neighb[v] = curn;
	}
}

vector<bool> added;

void prepans(int v) {
	used[v] = -1;
	if (neighb[v] != -1 && added[v] == 0) {
		outp.push_back({ v + 1, neighb[v] + 1 });
		added[v] = 1;
		added[neighb[v]] = 1;
	}
	for (auto i : tree[v]) {
		if (!used[i])
			prepans(i);
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, d;
	cin >> n >> d;
	tree.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		tree[a].push_back(b);
		tree[b].push_back(a);
	}
	depth.assign(n, -1);
	dfs(0, 0);
	dp0.assign(n, 0);
	dp1.assign(n, 0);
	used.assign(n, 0);
	neighb.assign(n, -1);
	dfs_dp(0);
	cout << max(dp0[0], dp1[0]) << '\n';
	used.assign(n, 0);
	added.assign(n, 0);
	prepans(0);
	for (auto i : outp)
		cout << i.first << " " << i.second << '\n';
}
