#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i128 = ll;

constexpr ll inf = 0x3f3f3f3f3f3f3f3f;

inline ll sq(ll x) {
    return x * x;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    ranges::sort(a);
    int x0, d;
    cin >> x0 >> d;
    vector<int> lft, rig;
    for (int i = 0; i < n; ++i) {
        if (a[i] < x0) lft.push_back(a[i]);
        else if (a[i] > x0) rig.push_back(a[i]);
    }
    ranges::reverse(lft);
    int lsz = (int) lft.size(), rsz = (int) rig.size();
    ll mn = x0;
    vector<ll> l_opt(lsz), r_opt(rsz), l_val(lsz), r_val(rsz);
    for (int i = 0; i < lsz; ++i) {
        ll cx = lft[i], dist = abs(cx - x0), t = dist / d;
        ll lx = x0 - t * d, rx = x0 - (t + 1) * d, opt;
        if (sq(cx - rx) < sq(cx - lx)) {
            opt = rx;
        } else {
            opt = lx;
        }
        mn = min(mn, opt);
        l_opt[i] = opt;
        l_val[i] = sq(cx - opt);
    }
    ll mx = x0;
    for (int i = 0; i < rsz; ++i) {
        ll cx = rig[i], dist = abs(cx - x0), t = dist / d;
        ll lx = x0 + t * d, rx = x0 + (t + 1) * d, opt;
        if (sq(cx - rx) < sq(cx - lx)) {
            opt = rx;
        } else {
            opt = lx;
        }
        mx = max(mx, opt);
        r_opt[i] = opt;
        r_val[i] = sq(cx - opt);
    }
    vector<ll> lpt, rpt;
    for (ll x = x0; x >= mn; x -= d) lpt.push_back(x);
    vector<i128> l_cost(lpt.size(), 0);
    {
        i128 sm1 = 0ll, sm2 = 0ll, sm_lazy = 0ll, cnt = (int) lft.size();
        for (auto cx : lft) {
            sm1 += cx;
            sm2 += sq(cx);
        }
        for (int i = 0, l = 0; i < (int) lpt.size(); ++i) {
            ll x = lpt[i];
            while (l < lsz && x <= l_opt[l]) {
                ll cx = lft[l];
                sm1 -= cx;
                sm2 -= sq(cx);
                sm_lazy += l_val[l];
                l++;
                cnt--;
            }
            l_cost[i] = sm_lazy + cnt * sq(x) - 2 * x * sm1 + sm2;
        }
    }
    for (ll x = x0; x <= mx; x += d) rpt.push_back(x);
    vector<ll> r_cost(rpt.size(), 0);
    {
        i128 sm1 = 0ll, sm2 = 0ll, sm_lazy = 0ll, cnt = (int) rig.size();
        for (auto cx : rig) {
            sm1 += cx;
            sm2 += sq(cx);
        }
        for (int i = 0, l = 0; i < (int) rpt.size(); ++i) {
            ll x = rpt[i];
            while (l < rsz && x >= r_opt[l]) {
                ll cx = rig[l];
                sm1 -= cx;
                sm2 -= sq(cx);
                sm_lazy += r_val[l];
                l++;
                cnt--;
            }
            r_cost[i] = sm_lazy + cnt * sq(x) - 2 * x * sm1 + sm2;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        i128 ff = inf, ss = inf;
        for (int i = 0; i < (int) lpt.size(); ++i) {
            ff = min(ff, l_cost[i] + t * abs(x0 - lpt[i]) / d);
        }
        for (int i = 0; i < (int) rpt.size(); ++i) {
            ss = min(ss, r_cost[i] + t * abs(x0 - rpt[i]) / d);
        }
        i128 ans = inf;
        for (int i = 0; i < (int) lpt.size(); ++i) {
            ans = min(ans, 2 * llabs(x0 - lpt[i]) / d * t + l_cost[i] + ss);
        }
        for (int i = 0; i < (int) rpt.size(); ++i) {
            ans = min(ans, 2 * llabs(x0 - rpt[i]) / d * t + r_cost[i] + ff);
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tst = 1;
    // cin >> tst;
    while (tst--) {
        solve();
    }
}