#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using i128 = ll;

constexpr ll inf = 0x3f3f3f3f3f3f3f3f;
const int maxN = 1e8 + 1e3;

inline ll sq(ll x) {
    return x * x;
}

struct line {
    i128 k = 0, b = inf;

    line() = default;
    line(i128 _k, i128 _b) : k(_k), b(_b) {}

    friend i128 eval(line l, ll x) {
        return l.k * x + l.b;
    }
};

struct lct {
    struct nd {
        nd* lc = nullptr;
        nd* rc = nullptr;
        line l = line();
    };

    nd* r;

    lct() {
        r = new nd();
    }

    void add(line l, nd* x, int lx, int rx) {
        bool dl = eval(l, lx) < eval(x->l, lx);
        int m = (lx + rx) >> 1;
        bool dm = eval(l, m) < eval(x->l, m);
        if (dm) swap(x->l ,l);
        if (lx + 1 == rx) return;
        if (dl == dm) {
            if (!x->rc) {
                x->rc = new nd();
                x->rc->l = l;
                return;
            }
            add(l, x->rc, m, rx);
        } else {
            if (!x->lc) {
                x->lc = new nd();
                x->lc->l = l;
                return;
            }
            add(l, x->lc, lx, m);
        }
    }

    void add(line l) {
        add(l, r, 0, maxN);
    }

    ll get(int pos, nd* x, int lx, int rx) {
        if (!x) return inf;
        int m = (lx + rx) >> 1;
        if (pos < m) {
            return min(eval(x->l, pos), get(pos, x->lc, lx, m));
        } else {
            return min(eval(x->l, pos), get(pos, x->rc, m, rx));
        }
    }

    ll get(int pos) {
        return get(pos, r, 0, maxN);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    ranges::sort(a);
    int x0, d;
    cin >> x0 >> d;
    vector<int> lft, rig;
    for (int i = 0; i < n; ++i) {
        if (a[i] < x0) lft.push_back(a[i]);
        else if (a[i] > x0) rig.push_back(a[i]);
    }
    ranges::reverse(lft);
    int lsz = (int) lft.size(), rsz = (int) rig.size();
    ll mn = x0;
    vector<ll> l_opt(lsz), r_opt(rsz), l_val(lsz), r_val(rsz);
    for (int i = 0; i < lsz; ++i) {
        ll cx = lft[i], dist = abs(cx - x0), t = dist / d;
        ll lx = x0 - t * d, rx = x0 - (t + 1) * d, opt;
        if (sq(cx - rx) < sq(cx - lx)) {
            opt = rx;
        } else {
            opt = lx;
        }
        mn = min(mn, opt);
        l_opt[i] = opt;
        l_val[i] = sq(cx - opt);
    }
    ll mx = x0;
    for (int i = 0; i < rsz; ++i) {
        ll cx = rig[i], dist = abs(cx - x0), t = dist / d;
        ll lx = x0 + t * d, rx = x0 + (t + 1) * d, opt;
        if (sq(cx - rx) < sq(cx - lx)) {
            opt = rx;
        } else {
            opt = lx;
        }
        mx = max(mx, opt);
        r_opt[i] = opt;
        r_val[i] = sq(cx - opt);
    }
    vector<ll> lpt, rpt;
    for (ll x = x0; x >= mn; x -= d) lpt.push_back(x);
    vector<i128> l_cost(lpt.size(), 0);
    lct l_one, l_two;
    {
        i128 sm1 = 0ll, sm2 = 0ll, sm_lazy = 0ll, cnt = (int) lft.size();
        for (auto cx : lft) {
            sm1 += cx;
            sm2 += sq(cx);
        }
        for (int i = 0, l = 0; i < (int) lpt.size(); ++i) {
            ll x = lpt[i];
            while (l < lsz && x <= l_opt[l]) {
                ll cx = lft[l];
                sm1 -= cx;
                sm2 -= sq(cx);
                sm_lazy += l_val[l];
                l++;
                cnt--;
            }
            l_cost[i] = sm_lazy + cnt * sq(x) - 2 * x * sm1 + sm2;
            ll dst = abs(lpt[i] - x0) / d;
            l_one.add(line(dst, l_cost[i]));
            l_two.add(line(2 * dst, l_cost[i]));
        }
    }
    for (ll x = x0; x <= mx; x += d) rpt.push_back(x);
    vector<ll> r_cost(rpt.size(), 0);
    lct r_one, r_two;
    {
        i128 sm1 = 0ll, sm2 = 0ll, sm_lazy = 0ll, cnt = (int) rig.size();
        for (auto cx : rig) {
            sm1 += cx;
            sm2 += sq(cx);
        }
        for (int i = 0, l = 0; i < (int) rpt.size(); ++i) {
            ll x = rpt[i];
            while (l < rsz && x >= r_opt[l]) {
                ll cx = rig[l];
                sm1 -= cx;
                sm2 -= sq(cx);
                sm_lazy += r_val[l];
                l++;
                cnt--;
            }
            ll dst = abs(rpt[i] - x0) / d;
            r_cost[i] = sm_lazy + cnt * sq(x) - 2 * x * sm1 + sm2;
            r_one.add(line(dst, r_cost[i]));
            r_two.add(line(2 * dst, r_cost[i]));
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        i128 ans = inf;
        ans = min(ans, l_two.get(t) + r_one.get(t));
        ans = min(ans, r_two.get(t) + l_one.get(t));
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tst = 1;
    // cin >> tst;
    while (tst--) {
        solve();
    }
}