#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19;

int mn[R * 2];

void change(int pos, int val) {
    pos += R;
    mn[pos] = val;
    for (pos /= 2; pos > 0; pos /= 2) {
        mn[pos] = min(mn[pos * 2], mn[pos * 2 + 1]);
    }
}

int get(int l, int r) {
    l += R;
    r += R;
    int ans = R;
    while (l < r) {
        if (l & 1) {
            ans = min(ans, mn[l++]);
        }
        if (r & 1) {
            ans = min(ans, mn[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i <= n; ++i) {
        change(i, R);
    }
    vector<int> l(k), m(k), r(k);
    vector<vector<int>> inds(n + 1);
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--, m[i]--;
        inds[r[i]].push_back(i);
    }
    change(0, -1);
    for (int i = 1; i <= n; ++i) {
        int dp_nw = R;
        for (auto ind : inds[i]) {
            int val1 = get(l[ind], m[ind] + 1), val2 = get(m[ind] + 1, i);
            if (val1 < R || val2 < l[ind]) {
                dp_nw = min(dp_nw, m[ind]);
            }
        }
        change(i, dp_nw);
    }
    if (get(n, n + 1) != R) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
