#include <bits/stdc++.h>

using namespace std;

struct SegmentTree {
    int R;
    vector<pair<int, int>> mx;

    SegmentTree() {}

    SegmentTree(vector<pair<int, int>> vals) {
        R = 1;
        while (R < (int)vals.size()) {
            R *= 2;
        }
        mx.resize(R * 2);
        for (int i = 0; i < (int)vals.size(); ++i) {
            mx[i + R] = vals[i];
        }
        for (int i = R - 1; i > 0; --i) {
            mx[i] = max(mx[i * 2], mx[i * 2 + 1]);
        }
    }

    void change(int pos, pair<int, int> val) {
        pos += R;
        mx[pos] = val;
        for (pos /= 2; pos > 0; pos /= 2) {
            mx[pos] = max(mx[pos * 2], mx[pos * 2 + 1]);
        }
    }

    pair<int, int> get(int l, int r) {
        l += R;
        r += R;
        pair<int, int> ans(-1, -1);
        while (l < r) {
            if (l & 1) {
                ans = max(ans, mx[l++]);
            }
            if (r & 1) {
                ans = max(ans, mx[--r]);
            }
            l >>= 1;
            r >>= 1;
        }
        return ans;
    }
};

constexpr int maxn = 5e5 + 5, lg = 19;

vector<int> g[maxn];

int depth[maxn];

int centr[lg][maxn], dd[lg][maxn];

int sz[maxn];

int c_used[maxn];

SegmentTree tree_odd[maxn], tree_even[maxn];

vector<pair<int, int>> vals_odd[maxn], vals_even[maxn];

void calc_sz(int v, int pr) {
    sz[v] = 1;
    for (auto u : g[v]) {
        if (u != pr && !c_used[u]) {
            calc_sz(u, v);
            sz[v] += sz[u];
        }
    }
}

int find_centr(int v, int pr, int sz_all) {
    for (auto u : g[v]) {
        if (u != pr && !c_used[u] && sz[u] * 2 > sz_all) {
            return find_centr(u, v, sz_all);
        }
    }
    return v;
}

void color(int v, int level) {
    if (depth[v] % 2 == 1) {
        vals_odd[centr[level][v]].emplace_back(dd[level][v], v);
    } else {
        vals_even[centr[level][v]].emplace_back(dd[level][v], v);
    }
    for (auto u : g[v]) {
        if (!c_used[u] && centr[level][u] == -1) {
            centr[level][u] = centr[level][v];
            dd[level][u] = dd[level][v] + 1;
            color(u, level);
        }
    }
}

void build_centr(int n) {
    for (int level = 0; level < lg; ++level) {
        for (int i = 0; i < n; ++i) {
            centr[level][i] = -1;
        }
        for (int i = 0; i < n; ++i) {
            if (!c_used[i] && centr[level][i] == -1) {
                calc_sz(i, -1);
                int centr_nw = find_centr(i, -1, sz[i]);
                c_used[centr_nw] = 1;
                centr[level][centr_nw] = centr_nw;
                color(centr_nw, level);
                sort(vals_odd[centr_nw].begin(), vals_odd[centr_nw].end());
                tree_odd[centr_nw] = SegmentTree(vector<pair<int, int>>(vals_odd[centr_nw].size(), make_pair(-1, -1)));
                sort(vals_even[centr_nw].begin(), vals_even[centr_nw].end());
                tree_even[centr_nw] = SegmentTree(vector<pair<int, int>>(vals_even[centr_nw].size(), make_pair(-1, -1)));
            }
        }
    }
}

vector<pair<int, int>> ans;

void dfs(int v, int pr) {
    for (auto u : g[v]) {
        if (u != pr) {
            depth[u] = depth[v] + 1;
            dfs(u, v);
        }
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, -1);
    build_centr(n);
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int u, int v) -> bool {
        return depth[u] > depth[v];
    });
    set<int> unused;
    for (auto v : ord) {
        pair<int, int> mx(-1, -1);
        for (int i = 0; i < lg; ++i) {
            if (centr[i][v] != -1) {
                if (depth[v] % 2 == 1) {
                    int pos = lower_bound(vals_even[centr[i][v]].begin(), vals_even[centr[i][v]].end(), make_pair(d - dd[i][v] + 1, 0)) - vals_even[centr[i][v]].begin();
                    mx = max(mx, tree_even[centr[i][v]].get(0, pos));
                } else {
                    int pos = lower_bound(vals_odd[centr[i][v]].begin(), vals_odd[centr[i][v]].end(), make_pair(d - dd[i][v] + 1, 0)) - vals_odd[centr[i][v]].begin();
                    mx = max(mx, tree_odd[centr[i][v]].get(0, pos));
                }
            }
        }
        if (mx.second == -1) {
            unused.insert(v);
            for (int i = 0; i < lg; ++i) {
                if (centr[i][v] != -1) {
                    if (depth[v] % 2 == 1) {
                        int pos = lower_bound(vals_odd[centr[i][v]].begin(), vals_odd[centr[i][v]].end(), make_pair(dd[i][v], v)) - vals_odd[centr[i][v]].begin();
                        tree_odd[centr[i][v]].change(pos, make_pair(depth[v], v));
                    } else {
                        int pos = lower_bound(vals_even[centr[i][v]].begin(), vals_even[centr[i][v]].end(), make_pair(dd[i][v], v)) - vals_even[centr[i][v]].begin();
                        tree_even[centr[i][v]].change(pos, make_pair(depth[v], v));
                    }
                }
            }
        } else {
            int u = mx.second;
            ans.emplace_back(v, u);
            for (int i = 0; i < lg; ++i) {
                if (centr[i][u] != -1) {
                    if (depth[u] % 2 == 1) {
                        int pos = lower_bound(vals_odd[centr[i][u]].begin(), vals_odd[centr[i][u]].end(), make_pair(dd[i][u], u)) - vals_odd[centr[i][u]].end();
                        tree_odd[centr[i][u]].change(pos, make_pair(-1, -1));
                    } else {
                        int pos = lower_bound(vals_even[centr[i][u]].begin(), vals_even[centr[i][u]].end(), make_pair(dd[i][u], u)) - vals_even[centr[i][u]].end();
                        tree_even[centr[i][u]].change(pos, make_pair(-1, -1));
                    }
                }
            }
            unused.erase(u);
        }
    }
    set<pair<int, int>> even, odd;
    for (auto v : unused) {
        if (depth[v] % 2 == 0) {
            even.emplace(depth[v], v);
        } else {
            odd.emplace(depth[v], v);
        }
    }
    while (!even.empty()) {
        auto [vl, v] = *even.rbegin();
        even.erase(*even.rbegin());
        auto it = odd.lower_bound(make_pair(d - vl + 1, 0));
        if (it != odd.begin()) {
            it--;
            ans.emplace_back(v, it->second);
            odd.erase(it);
        }
    }
    cout << ans.size() << '\n';
    cout << -1 << '\n';
    // for (auto [a, b] : ans) {
    //     cout << a + 1 << ' ' << b + 1 << '\n';
    // }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
