#include <iostream>
#include <vector>
#include <chrono>
#include <random>
#include <algorithm>

using namespace std;

mt19937 rng(time(0));

bool f(const vector <vector <int>>& seg, int lg, int rg) {
    //cout << "*" <<  lg << " " << rg << " " << seg.size() << "\n";
    if (lg > rg) {
        return true;
    }
    if (seg.size() == 0) {
        return false;
    }
    int k = seg.size();
    int minl = 1000000001, maxr = -1000000001;
    for (int i = 0; i < k; i++) {
        if (seg[i][0] < minl) {
            minl = seg[i][0];
        }
        if (seg[i][1] > maxr) {
            maxr = seg[i][1];
        }
    }
    if (minl > lg || maxr < rg) {
        return false;
    }
    //cout << "&" << seg.size() << "\n";
    for (int i = 0; i < k; i++) {
        int l = seg[i][0], r = seg[i][1], m = seg[i][2];
        vector <vector <int>> segleft, segright;
        for (int j = 0; j < k; j++) {
            if (seg[j][0] > l || seg[j][1] < r || seg[j][2] < l || seg[j][2] > r) {
                if (seg[j][2] < l) {
                segleft.push_back({seg[j][0], min(seg[j][1], l - 1), seg[j][2]});
        }   else {
                segright.push_back({max(seg[j][0], r + 1), seg[j][1], seg[j][2]});
        }
            }
        }
        if (f(segleft, lg, l - 1) && f(segright, r + 1, rg)) {
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qtest;
    cin >> qtest;
    for (int _ = 0; _ < qtest; _++) {
        int n, k;
        cin >> n >> k;
        vector <vector <int>> seg(k, vector <int> (3));
        for (int i = 0; i < k; i++) {
            cin >> seg[i][0] >> seg[i][2] >> seg[i][1]; //l, r, m
            seg[i][0]--;
            seg[i][1]--;
            seg[i][2]--;
        }
        shuffle(seg.begin(), seg.end(), rng);
        bool fl = f(seg, 0, n - 1);
        if (fl) {
            cout << "YES\n";
    }   else {
            cout << "NO\n";
    }
    }

}
