#include <iostream>
#include <vector>
#include <set>
#include <random>
#include <chrono>
#include <algorithm>


using namespace std;

mt19937 rng(time(0));

bool comp(pair<int, int> a, pair<int, int> b) {
    return a.first < b.first;
}

vector <bool> ban;
vector <vector <int>> seg;
vector <pair<int, int>> mas; //our segm
int n, k;

bool is_dot(int x) {
    bool fl = false;
    for (int i = 0; i < mas.size(); i++) {
        if (mas[i].first <= x && mas[i].second >= x) {
            fl = true;
            break;
        }
    }
    return fl;
}

int countspare() {
    sort(mas.begin(), mas.end(), comp);
    int last = 0;
    int s = 0;
    for (int i = 0; i < mas.size(); i++) {
        if (last < mas[i].first) {
            s += mas[i].first - last;
        }
        last = max(last, mas[i].second + 1);
    }
    s += n - last;
    return s;
}


bool dfs(int v) {
    int l = seg[v][0], r = seg[v][1], m = seg[v][2];
    if (is_dot(m)) {
        return false;
    }
    mas.push_back(make_pair(l, r));
    if (countspare() == 0) {
        return true;
    }
    //cout << countspare() << "*\n";
    ban[v] = true;
    vector <int> change;
    change.push_back(v);
    for (int i = 0; i < k; i++) {
        if (!ban[i]) {
            if (is_dot(seg[i][2])) {
                ban[i] = true;
            }
        }
    }
    for (int i = 0; i < k; i++) {
        if (!ban[i]) {
            if (dfs(i)) {
                return true;
            }
        }
    }
    for (int i = 0; i < change.size(); i++) {
        ban[change[i]] = false;
    }
    mas.erase(lower_bound(mas.begin(), mas.end(), make_pair(l, r)));
    return false;
}

int main() {
    int qtest;
    cin >> qtest;
    for (int _ = 0; _ < qtest; _++) {
        cin >> n >> k;
        seg.clear();
        seg.resize(k, vector <int> (3));
        for (int i = 0; i < k; i++) {
            cin >> seg[i][0] >> seg[i][2] >> seg[i][1]; //l, r, m
            seg[i][0]--;
            seg[i][1]--;
            seg[i][2]--;
        }
        ban.clear();
        ban.resize(k, 0);
        vector <int> nums(k);
        iota(nums.begin(), nums.end(), 0);
        shuffle(nums.begin(), nums.end(), rng);
        bool fl = false;
        for (int i = 0; i < k; i++) {
            if (dfs(nums[i])) {
                fl = true;
                break;
            }
        }
        if (fl) {
            cout << "YES\n";
    }   else {
            cout << "NO\n";
    }
    }

}
