// #ifdef LOCAL
// #define _GLIBCXX_DEBUG
// #endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()

struct fenwick {

	fenwick() {}
	fenwick(int n) : n(n) {
		v.resize(n);
	}

	void add(int r, int x) {
		for (; r < n; r = r | (r + 1)) v[r] += x;
	}

	int get(int r) {
		int s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) s += v[r];
		return s;
	}

	int get(int l, int r) {
		return get(r) - get(l - 1);
	}

	int n;
	vector<int> v;

};

struct mst {

	mst() {}
	mst(vector<int> a) : n(a.size()) {
		v.resize(n * 4);
		mn.resize(n * 4);
		build(a, 0, 0, n - 1);
	}

	void build(vector<int>& a, int pos, int tl, int tr) {
		if (tl == tr) {
			v[pos].push_back({a[tl], tl});
			mn[pos] = 1;
		} else {
			int m = (tl + tr) / 2;
			build(a, pos * 2 + 1, tl, m);
			build(a, pos * 2 + 2, m + 1, tr);
			merge(all(v[pos * 2 + 1]), all(v[pos * 2 + 2]), back_inserter(v[pos]));
			mn[pos] = v[pos].size();
		}
	}

	int get(int l, int r, int mx) {
		return get(l, r, mx, 0, 0, n - 1);
	}

	int get(int l, int r, int mx, int pos, int tl, int tr) {
		if (tr < l || r < tl) return 0;
		if (l <= tl && tr <= r) {
			if (mn[pos] < v[pos].size() && v[pos][mn[pos]].first < mx) return 1;
			return 0;
		}
		int m = (tl + tr) / 2;
		return get(l, r, mx, pos * 2 + 1, tl, m) + get(l, r, mx, pos * 2 + 2, m + 1, tr);
	}

	void add(int position, int x) {
		add(position, x, 0, 0, n - 1);
	}

	int add(int position, int x, int pos, int tl, int tr) {
		if (tl == tr) {
			mn[pos] = 0;
			return v[pos][0].first;
		} else {
			int m = (tl + tr) / 2, val;
			if (position <= m) val = add(position, x, pos * 2 + 1, tl, m);
			else val = add(position, x, pos * 2 + 2, m + 1, tr);
			int ps = lower_bound(all(v[pos]), make_pair(val, position)) - v[pos].begin();
			// cout << pos << " " << ps << " " << mn.size() << "\n";
			mn[pos] = min(mn[pos], ps);
			return val;
		}
	}


	int n;
	vector<vector<pair<int, int>>> v;
	vector<int> mn;

};

void solve() {
	int n, k;
	cin >> n >> k;
	vector<array<int, 3>> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i][0] >> v[i][1] >> v[i][2];
	}
	sort(all(v), [&](array<int, 3> a, array<int, 3> b) {
		return a[2] < b[2];
	});
	vector<int> r(k), m(k);
	for (int i = 0; i < k; i++) r[i] = v[i][2], m[i] = v[i][1];

	vector<int> dp(k);
	fenwick f(k);
	mst st(m);
	bool ans = false;
	for (int i = 0; i < k; i++) {
		if (v[i][0] == 1) dp[i] = 1;
		else {
			int l = lower_bound(all(r), v[i][0] - 1) - r.begin();
			int pos = lower_bound(all(r), v[i][1]) - r.begin();
			if (l <= min(i - 1, pos - 1) && f.get(l, min(i - 1, pos - 1)) > 0) dp[i] = 1;
			if (pos < i && st.get(pos, i - 1, v[i][0]) > 0) dp[i] = 1;
		}
		if (v[i][2] == n && dp[i]) {
			ans = true;
			break;
		}
		if (dp[i]) {
			f.add(i, 1);
			st.add(i, 1);
		}
	}

	if (ans) cout << "YES\n";
	else cout << "NO\n";
}

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int t = 1;
	cin >> t;
	while (t--) solve();
}