 #ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

int n, d;
vector<vector<int>> g, gp;
vector<int> c, ind, revl, revr;
int l = 0, r = 0;

void dfs_color(int v, int p) {
	if (c[v] == 0) {
		ind[v] = l++;
	} else {
		ind[v] = r++;
	}
	for (int to : g[v]) {
		if (to == p) continue;
		c[to] = 1 - c[v];
		dfs_color(to, v);
	}
}

void dfs_build(int v, int p, int st, int h) {
	if (c[v] != c[st]) {
		gp[ind[st]].push_back(ind[v]);
	}
	if (h == d) return;
	for (int to : g[v]) {
		if (to == p) continue;
		dfs_build(to, v, st, h + 1);
	}
}

vector<int> mt, used, prd;
int tmr = 0;

bool kuhn(int v) {
	if (used[v] == tmr) return false;
	used[v] = tmr;
	for (int to : gp[v]) {
		if (mt[to] == -1) {
			mt[to] = v;
			prd[v] = 1;
			return true;
		}
	}
	for (int to : gp[v]) {
		if (kuhn(mt[to])) {
			mt[to] = v;
			prd[v] = 1;
			return true;
		}
	}
	return false;
}

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	cin >> n >> d;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b; a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	c.resize(n);
	ind.resize(n);
	dfs_color(0, -1);

	revl.resize(l);
	revr.resize(r);
	for (int i = 0; i < n; i++) {
		if (c[i] == 0) revl[ind[i]] = i;
		else revr[ind[i]] = i;
	}

	gp.resize(l);
	for (int i = 0; i < n; i++) {
		if (c[i] == 0) dfs_build(i, -1, i, 0);
	}

	vector<int> ll, rr;
    for (int i = 0; i < n; i++) {
    	if (c[i] == 0) ll.push_back(i);
    	else rr.push_back(i);
    }

	mt.resize(r, -1);
	for (int i = 0; i < min(l, r); i++) {
		mt[i] = i;
	}
	// for (int x : mt) cout << x << " ";

	vector<pair<int, int>> ans;
	for (int i = 0; i < r; i++) {
		if (mt[i] != -1) {
			ans.emplace_back(revl[mt[i]], revr[i]);
		}
	}

	cout << ans.size() << "\n";
	for (auto [a, b] : ans) {
		cout << a + 1 << " " << b + 1 << "\n";
	}
}