 #ifdef LOCAL
 #define _GLIBCXX_DEBUG
 #endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

int n, d;
vector<vector<int>> g, gp;
vector<int> c, ind, revl, revr;
int l = 0, r = 0;

void dfs_color(int v, int p) {
	if (c[v] == 0) {
		ind[v] = l++;
	} else {
		ind[v] = r++;
	}
	for (int to : g[v]) {
		if (to == p) continue;
		c[to] = 1 - c[v];
		dfs_color(to, v);
	}
}

bool dfs_build(int v, int p, int st, int h) {
	if (c[v] != c[st]) {
		gp[ind[st]].push_back(ind[v]);
		if (gp[ind[st]].size() > 1) return false;
	}
	if (h == d) return true;
	for (int to : g[v]) {
		if (to == p) continue;
		if (!dfs_build(to, v, st, h + 1)) return false;
	}
	return true;
}

vector<int> mt, used, prd, cnt;
int tmr = 0;

bool kuhn(int v, int d) {
	if (++cnt[v] > 1 || d > 10) return false;
	if (used[v] == tmr) return false;
	used[v] = tmr;
	for (int to : gp[v]) {
		if (mt[to] == -1) {
			mt[to] = v;
			prd[v] = 1;
			return true;
		}
	}
	for (int to : gp[v]) {
		if (kuhn(mt[to], d + 1)) {
			mt[to] = v;
			prd[v] = 1;
			return true;
		}
	}
	return false;
}

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	cin >> n >> d;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b; a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	for (int i = 0; i < n; i++) {
		shuffle(all(g[i]), rnd);
	}

	c.resize(n);
	ind.resize(n);
	dfs_color(0, -1);

	revl.resize(l);
	revr.resize(r);
	for (int i = 0; i < n; i++) {
		if (c[i] == 0) revl[ind[i]] = i;
		else revr[ind[i]] = i;
	}

	gp.resize(l);
	for (int i = 0; i < n; i++) {
		if (c[i] == 0) dfs_build(i, -1, i, 0);
	}
	for (int i = 0; i < l; i++) {
		shuffle(all(gp[i]), rnd);
	}

	vector<int> ord(l);
	iota(all(ord), 0);
	shuffle(all(ord), rnd);

	mt.resize(r, -1);
	prd.resize(l);
	used.resize(l);
	cnt.resize(l);
	while (true) {
		bool is = false;
		for (int i : ord) {
			if (prd[i]) continue;
			tmr++;
			if (kuhn(i, 0)) is = true;
		}
		if (!is) break;
	}

	vector<pair<int, int>> ans;
	for (int i = 0; i < r; i++) {
		if (mt[i] != -1) {
			ans.emplace_back(revl[mt[i]], revr[i]);
		}
	}

	cout << ans.size() << "\n";
	for (auto [a, b] : ans) {
		cout << a + 1 << " " << b + 1 << "\n";
	}
}