// semenInRussia 2025
#include <algorithm>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

struct fenw {
  vector<int> t;
  int n;

  fenw(int _n) {
    n = _n;
    t.resize(n + 1);
  }

  void add(int j, int v) {
    ++j;
    for (; j <= n; j += j & -j) {
      t[j] += v;
    }
  }

  int sum(int j) {
    int s = 0;
    for (; j > 0; j -= j & -j) {
      s += t[j];
    }
    return s;
  }
};

struct trip {
  int len;
  int v;
  int c;
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m;
  cin >> n >> m;

  vector<string> t(n);

  for (auto &row : t) {
    cin >> row;
  }

  vector<vector<int>> len(n, vector<int>(m + 1, 0));

  for (int i = 0; i < n; i++) {
    for (int j = m - 1; j >= 0; j--) {
      if (t[i][j] == '1') {
        len[i][j] = len[i][j + 1] + 1;
      }
    }
  }

  int ans = 0;

  for (int j = 0; j < m; j++) {
    vector<trip> buf;
    for (int i = n - 1; i >= 0; i--) {
      int x = len[i][j];
      int suf = 0;
      int cnt = 0;
      while (!buf.empty() && buf.back().len >= x) {
        auto p = buf.back();
        buf.pop_back();
        p.v += cnt * p.len;
        suf = max(suf, p.v);
        cnt += p.c;
      }
      // dp[x] = x + suf;
      buf.push_back({x, x + suf, cnt + 1});
      ans = max(ans, x + suf);
    }

    int cnt = 0;
    while (!buf.empty()) {
      auto p = buf.back();
      buf.pop_back();
      p.v += cnt * p.len;
      ans = max(ans, p.v);
      cnt += p.c;
    }
  }

  cout << ans;
}