// semenInRussia 2025
// #pragma GCC optimize("O3,unroll-loops")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
// #pragma GCC target("avx2")
using namespace std;

struct fenw {
  int n;
  vector<int> t;

  fenw(int _n) {
    n = _n;
    t.resize(n + 1);
    fill(t.begin(), t.end(), 0);
  }

  void add(int j, int v) {
    ++j;
    for (; j <= n; j += j & -j) {
      t[j] += v;
    }
  }

  int sum(int r) {
    int s = 0;
    for (; r > 0; r -= r & -r) {
      s += t[r];
    }
    return s;
  }
};

struct node {
  int l;
  int r;
  int m;
};

bool operator<(node a, node b) {
  return a.r < b.r || (a.r == b.r && a.l > b.l);
}

void solve() {
  int n, k;
  cin >> n >> k;

  vector<node> a(k);

  for (auto &t : a) {
    cin >> t.l >> t.m >> t.r;
    --t.l;
    --t.m;
  }

  vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));

  for (auto t : a) {
    dp[t.l][t.r] = true;
  }

  for (int i = 0; i <= n; i++) {
    dp[i][i] = true;
  }

  for (int len = 2; len <= n; len++) {
    for (int l = 0; l + len <= n; l++) {
      int r = l + len;
      for (auto t : a) {
        if (!(l <= t.l && t.r <= r)) {
          continue;
        }

        bool lef = false;
        for (int j = t.l; j <= t.m; j++) {
          if (dp[l][j]) {
            lef = true;
          }
        }

        bool rig = false;
        for (int j = t.m + 1; j <= t.r; j++) {
          if (dp[j][r]) {
            rig = true;
          }
        }

        if (lef && rig) {
          // cerr << "we can " << l << ", " << r << "\n";
          dp[l][r] = true;
        }
      }
    }
  }

  bool ok = dp[0][n];
  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}