// semenInRussia 2025
// #pragma GCC optimize("O3,unroll-loops")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
// #pragma GCC target("avx2")
using namespace std;

struct fenw {
  int n;
  vector<int> t;

  fenw(int _n) {
    n = _n;
    t.resize(n + 1);
    fill(t.begin(), t.end(), 0);
  }

  void add(int j, int v) {
    ++j;
    for (; j <= n; j += j & -j) {
      t[j] += v;
    }
  }

  int sum(int r) {
    int s = 0;
    for (; r > 0; r -= r & -r) {
      s += t[r];
    }
    return s;
  }
};

struct node {
  int l;
  int r;
  int m;
};

bool operator<(node a, node b) {
  return a.r < b.r || (a.r == b.r && a.l > b.l);
}

void solve() {
  int n, k;
  cin >> n >> k;

  vector<node> a(k);

  for (auto &t : a) {
    cin >> t.l >> t.m >> t.r;
    --t.l;
    --t.m;
  }

  bool ok = true;

  for (int i = 0; i < k; i++) {
    for (int j = i + 1; j < k; j++) {
      auto s = a[i];
      auto t = a[j];
      if ((t.l <= s.m && s.m < t.r) && (s.l <= t.m && t.m < s.r)) {
        ok = false;
      }
    }
  }

  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}