// semenInRussia 2025
// #pragma GCC optimize("O3,unroll-loops")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
// #pragma GCC target("avx2")
using namespace std;

const int N = 1e5;
vector<int> g[N];

struct node {
  int l;
  int r;
  int m;
};

bool operator<(node a, node b) {
  return a.r < b.r || (a.r == b.r && a.l > b.l);
}

int used[N];

bool cycle(int x) {
  if (used[x] == 2) {
    return false;
  }

  used[x] = 1;

  for (int y : g[x]) {
    if (used[y] == 1) {
      return true;
    }
    if (used[y] == 0) {
      if (cycle(y)) {
        return true;
      }
    }
  }

  used[x] = 2;

  return false;
}

void solve() {
  int n, k;
  cin >> n >> k;

  vector<node> a(k);

  for (auto &t : a) {
    cin >> t.l >> t.m >> t.r;
    --t.l;
    --t.m;
  }

  for (int i = 0; i <= k; i++) {
    g[i].clear();
    used[i] = 0;
  }

  for (int i = 0; i < k; i++) {
    for (int j = i + 1; j < k; j++) {
      auto s = a[i];
      auto t = a[j];
      if (t.l <= s.m && s.m < t.r) {
        g[i].push_back(j);
      }

      if (s.l <= t.m && t.m < s.r) {
        g[j].push_back(i);
      }
    }
  }

  bool ok = true;

  for (int x = 0; x < k; x++) {
    if (cycle(x)) {
      ok = false;
    }
  }

  vector<int> ad(n + 1);

  for (int i = 0; i < k; i++) {
    ad[a[i].l]++;
    ad[a[i].r]--;
  }

  int pref = 0;
  for (int i = 0; i < n; i++) {
    pref += ad[i];
    if (pref <= 0) {
      ok = false;
    }
  }

  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}