// semenInRussia 2025
// #pragma GCC optimize("O3,unroll-loops")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
// #pragma GCC target("avx2")
using namespace std;

struct node {
  int l;
  int r;
  int m;
};

bool operator<(node a, node b) {
  return a.r < b.r || (a.r == b.r && a.l > b.l);
}

struct fenw {
  int n;
  vector<int> t;

  fenw(int _n) {
    n = _n;
    t.resize(n + 1);
  }

  void add(int j, int v) {
    ++j;
    for (; j <= n; j += j & -j) {
      t[j] += v;
    }
  }

  int sum(int r) {
    int s = 0;
    for (; r > 0; r -= r & -r) {
      s += t[r];
    }
    return s;
  }
};

void solve() {
  int n, k;
  cin >> n >> k;

  vector<node> a(k);

  for (auto &t : a) {
    cin >> t.l >> t.m >> t.r;
    --t.l;
    --t.m;
  }

  fenw f(n + 1);
  f.add(0, +1);

  sort(a.begin(), a.end());

  for (auto t : a) {
    int x = (f.sum(t.m + 1) - f.sum(t.l)) >= 1;
    if (x) {
      f.add(t.r, x);
    }
  }

  bool ok = f.sum(n + 1) - f.sum(n) >= 1;

  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}