// semenInRussia 2025
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
using namespace std;

struct fenw {
  int n;
  vector<int> t;

  fenw(int _n) {
    n = _n;
    t.resize(n + 1);
    fill(t.begin(), t.end(), 0);
  }

  void add(int j, int v) {
    ++j;
    for (; j <= n; j += j & -j) {
      t[j] += v;
    }
  }

  int sum(int r) {
    int s = 0;
    for (; r > 0; r -= r & -r) {
      s += t[r];
    }
    return s;
  }
};

void solve() {
  int n, k;
  cin >> n >> k;

  vector<int> l(k), r(k), m(k);

  for (int i = 0; i < k; i++) {
    cin >> l[i] >> m[i] >> r[i];
    --l[i];
    --m[i];
  }

  vector<int> p(k);
  for (int i = 0; i < k; i++) {
    p[i] = i;
  }

  bool ok = false;

  do {
    bool cur = true;
    fenw t(n + 1);
    for (int j : p) {
      bool was = t.sum(m[j] + 1) >= 1;
      if (!was) {
        t.add(l[j], +1);
        t.add(r[j], -1);
      }
    }
    for (int j = 0; j < n; j++) {
      bool was = t.sum(j + 1) >= 1;
      if (!was) {
        cur = false;
      }
    }
    ok = max(ok, cur);
  } while (next_permutation(p.begin(), p.end()));

  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}