// semenInRussia 2025
#pragma GCC optimize("O3,unroll-loops")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

struct node {
  int l;
  int r;
  int m;
};

bool operator<(node a, node b) {
  return a.r < b.r || (a.r == b.r && a.l > b.l);
}

void solve() {
  int n, k;
  cin >> n >> k;

  vector<node> a(k);
  for (auto &t : a) {
    cin >> t.l >> t.m >> t.r;
    --t.l;
    --t.m;
  }

  sort(a.begin(), a.end());

  vector<int> dp(n + 1);
  dp[0] = true;

  for (int i = 0; i < k; i++) {
    int l = a[i].l;
    int r = a[i].r;
    int m = a[i].m;
    for (int j = l; j < r; j++) {
      dp[r] |= dp[j] && (m >= j);
    }
  }

  bool ok = dp[n];

  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}