// semenInRussia 2025
#pragma GCC optimize("O3,unroll-loops")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

struct fenw {
  int n;
  vector<int> t;

  fenw(int _n) {
    n = _n;
    t.resize(n + 1);
    fill(t.begin(), t.end(), 0);
  }

  void add(int j, int v) {
    ++j;
    for (; j <= n; j += j & -j) {
      t[j] += v;
    }
  }

  int sum(int r) {
    int s = 0;
    for (; r > 0; r -= r & -r) {
      s += t[r];
    }
    return s;
  }
};

struct node {
  int l;
  int r;
  int m;
};

bool operator<(node a, node b) {
  return a.r < b.r || (a.r == b.r && a.l > b.l);
}

void solve() {
  int n, k;
  cin >> n >> k;

  vector<node> a(k);
  for (auto &t : a) {
    cin >> t.l >> t.m >> t.r;
    --t.l;
    --t.m;
  }

  sort(a.begin(), a.end());

  fenw t(n + 1);
  t.add(0, +1);

  for (int i = 0; i < k; i++) {
    int l = a[i].l;
    int r = a[i].r;
    int m = a[i].m;
    int x = (t.sum(m + 1) - t.sum(l)) >= 1;
    t.add(r, x);
  }

  bool ok = t.sum(n + 1) - t.sum(n) >= 1;
  ok = true;

  cout << (ok ? "YES" : "NO") << "\n";
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}