#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
 
struct tr {
    vector<int> t;
    vector<int> push;
    tr(int n = 0) {
        t.assign(4 * n, 0);
    }
    void add(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) {
            t[v] = 1;
            return;
        }
        if (l >= qr || r <= ql) {
            return;
        }
        int m = (r + l) / 2;
        add(2 * v, l, m, ql, qr);
        add(2 * v + 1, m, r, ql, qr);
        if (t[2 * v] == 1 && t[2 * v + 1] == 1) {
            t[v] = 1;
        }
    }
    int get(int v, int l, int r, int i) {
        if (t[v] == 1) {
            return 1;
        }
        int m = (r + l) / 2;
        if (i >= l && i < m) {
            return get(2 * v, l, m, i);
        }  else {
            return get(2 * v + 1, m, r, i);
        }
    }
};
 
const int maxn = 1e4;
vector<vector<int>> g(maxn, vector<int>(0));
vector<vector<int>> tg(maxn, vector<int>(0));
vector<int> color(maxn, -1);
vector<int> tout(0);
int cur = 0;

void dfs(int v) {
    color[v] = 0;
    for (auto u : g[v]) {
        if (color[u] == 0) continue;
        dfs(u);
    }
    tout.push_back(v);
}

int dfs1(int v) {
    color[v] = cur;
    int cnt = 1;
    for (int u : tg[v]) {
        if (color[u] == 0) {
            cnt += dfs1(u);
        }
    }
    return cnt;
}

void solve() {
    int n, k;
    cin >> n >> k;
    tr tree(n);
    vector<int> l(k), m(k), r(k);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        tree.add(1, 0, n, l[i], r[i]);
        for (int j = 0; j < i; j++) {
            if (l[j] <= m[i] && m[i] < r[j]) {
                g[i].push_back(j);
                tg[j].push_back(i);
            }
            if (l[i] <= m[j] && m[j] < r[i]) {
                g[j].push_back(i);
                tg[i].push_back(j);
            }
        }
    }
    if (tree.t[1] == 0) {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < k; i++) {
        if (color[i] == 0) continue;
        dfs(i);
    }
    reverse(tout.begin(), tout.end());
    for (int i : tout) {
        if (color[i] == 0) {
            cur++;
            int c = dfs1(i);
            if (c > 1) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
}
 
int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}