#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 1e4;
vector<vector<int>> g(maxn, vector<int>(0));
vector<vector<int>> tg(maxn, vector<int>(0));
vector<int> color(maxn, -1);
vector<int> tout(0);
int cur = 0;

void dfs(int v) {
    color[v] = 0;
    for (auto u : g[v]) {
        if (color[u] == 0) continue;
        dfs(u);
    }
    tout.push_back(v);
}

int dfs1(int v) {
    color[v] = cur;
    int cnt = 1;
    for (int u : tg[v]) {
        if (color[u] == 0) {
            cnt += dfs1(u);
        }
    }
    return cnt;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), m(k), r(k);
    vector<int> t(n + 1, 0);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        t[l[i]]++;
        t[r[i]]--;
        for (int j = 0; j < i; j++) {
            if (l[j] <= m[i] && m[i] < r[j]) {
                g[i].push_back(j);
                tg[j].push_back(i);
            }
            if (l[i] <= m[j] && m[j] < r[i]) {
                g[j].push_back(i);
                tg[i].push_back(j);
            }
        }
    }
    int balance = 0;
    for (int i = 0; i < n; i++) {
        balance += t[i];
        if (balance == 0) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < k; i++) {
        if (color[i] == 0) continue;
        dfs(i);
    }
    reverse(tout.begin(), tout.end());
    for (int i : tout) {
        if (color[i] == 0) {
            cur++;
            int c = dfs1(i);
            if (c > 1) {
                cout << "NO\n";
                return;
            }
        }
    }
    cout << "YES\n";
}
 
int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}