#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 5e5;

vector<int> tr(4 * maxn, 0);

void add(int v, int l, int r, int i) {
    if (r - l == 1) {
        tr[v]++;
        return;
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i);
    } else {
        add(2 * v + 1, m, r, i);
    }
    tr[v] = tr[2 * v] + tr[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
}


void solve() {
    int n, k;
    cin >> n >> k;
    tr.assign(4 * n, 0);
    vector<int> l(k), m(k), r(k);
    bool good = false;
    vector<vector<int>>have(n);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        r[i]--;
        if (l[i] == 0) {
            add(1, 0, n, r[i]);
            continue;
        }
        have[r[i]].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        for (int j : have[i]) {
            if (get(1, 0, n, l[j] - 1, m[j]) > 0) {
                add(1, 0, n, r[j]);
            }
        }
    }
    if (get(1, 0, n, n - 1, n) > 0) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}