#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 5e5;
const int inf = 1e9 + 239;
vector<int> tr(0);
vector<int> maxx(0);

void upd(int v, int l, int r, int i, int x) {
    if (r - l == 1) {
        maxx[v] = min(maxx[v], x);
        return;
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        upd(2 * v, l, m, i, x);
    } else {
        upd(2 * v + 1, m, r, i, x);
    }
    maxx[v] = min(maxx[2 * v], maxx[2 * v + 1]);
}

int getmax(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return maxx[v];
    }
    if (l >= qr || r <= ql) {
        return inf;
    }
    int m = (r + l) / 2;
    return min(getmax(2 * v, l, m, ql, qr), getmax(2 * v + 1, m, r, ql, qr));
}


void add(int v, int l, int r, int i) {
    if (r - l == 1) {
        tr[v]++;
        return;
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i);
    } else {
        add(2 * v + 1, m, r, i);
    }
    tr[v] = tr[2 * v] + tr[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
}


void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    tr.assign(4 * n, 0);
    maxx.assign(4 * n, inf);
    vector<int> l(k), m(k), r(k);
    vector<vector<int>>have(n);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        r[i]--;
        if (l[i] == 0) {
            add(1, 0, n, r[i]);
            upd(1, 0, n, r[i], m[i]);
            continue;
        }
        have[r[i]].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        for (int j : have[i]) {
            if (get(1, 0, n, l[j] - 1, m[j]) > 0) {
                add(1, 0, n, r[j]);
                upd(1, 0, n, r[j], m[j]);
            }
            if (getmax(1, 0, n, m[j], r[j]) < l[j]) {
                add(1, 0, n, r[j]);
                upd(1, 0, n, r[j], m[j]);
            }
        }
    }
    if (get(1, 0, n, n - 1, n) > 0) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}