#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct tr {
    vector<int> t;
    vector<int> push;
    tr(int n = 0) {
        t.assign(4 * n, 0);
    }
    void add(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) {
            t[v] = 1;
            return;
        }
        if (l >= qr || r <= ql) {
            return;
        }
        int m = (r + l) / 2;
        add(2 * v, l, m, ql, qr);
        add(2 * v + 1, m, r, ql, qr);
        if (t[2 * v] == 1 && t[2 * v + 1] == 1) {
            t[v] = 1;
        }
    }
    int get(int v, int l, int r, int i) {
        if (r - l == 1) {
            return t[v];
        }
        if (t[v] == 1) {
            return 1;
        }
        int m = (r + l) / 2;
        if (i >= l && i < m) {
            return get(2 * v, l, m, i);
        } else {
            return get(2 * v + 1, m, r, i);
        }
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), m(k), r(k);
    vector<int> p(k);
    int w = 1;
    for (int i = 0; i < k; i++) {
        w *= (i + 1);
        p[i] = i;
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
    }
    for (int _ = 0; _ < w; _++) {
        tr tree(n);
        for (int i : p) {
            if (tree.get(1, 0, n, m[i]) == 0) {
                tree.add(1, 0, n, l[i], r[i]);
            }
        }
        if (tree.t[1] == 1) {
            cout << "YES\n";
            return;
        }
        next_permutation(p.begin(), p.end());
    }
    
    cout << "NO\n";
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}