#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 5e5;
vector<int> tr(maxn * 4, -1);

void add(int v, int l, int r, int i, int x) {
    if (r - l == 1) {
        tr[v] = max(tr[v], x);
        return;
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i, x);
    } else {
        add(2 * v + 1, m, r, i, x);
    }
    tr[v] = max(tr[2 * v], tr[2 * v + 1]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return -1;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
}


void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), m(k), r(k);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        m[i]--;
        if (r[i] == n) {
            add(1, 0, n, l[i], m[i]);
        }
        if (l[i] == 0 && r[i] == n) {
            cout << "YES\n";
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (l[i] != 0) continue;
        if (get(1, 0, n, 0, r[i] + 1) >= r[i]) {
            cout << "YES\n";
            return;
        }
        if (get(1, 0, n, m[i] + 1, r[i] + 1) != -1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}