#include <bits/stdc++.h>
#define int long long

using namespace std;

struct SegTree{
    int n;
    vector<int> arr;
    vector<int> tree;
    vector<int> op;
    SegTree(int nn){
        n = nn;
        arr.resize(nn, 0);
        tree.resize(n * 3);
        op.resize(n * 3, -1);
    }

    void push(int v, int l, int r){
        if(r - l == 1 || op[v] == -1){
            op[v] = -1;
            return;
        }

        int mid = (l + r) / 2;
        if(op[v] == 0){
            tree[v * 2 + 1] = 0;
            op[v * 2 + 1] = 0;
            tree[v * 2 + 2] = 0;
            op[v * 2 + 2] = 0;
        }else{
            tree[v * 2 + 1] += (mid - l);
            op[v * 2 + 1] = 1;
            tree[v * 2 + 2] = (r - mid);
            op[v * 2 + 2] = 1;
        }
        op[v] = -1;
    }

    void upd(int v, int l, int r, int ql, int qr, int tp){
        if(ql == qr){
            return;
        }
        if(qr <= l || r <= ql){
            return;
        }

        push(v, l, r);
        if(ql <= l && r <= qr){
            if(tp == 1){
                tree[v] += (r - l);
                op[v] = 1;
            }else{
                tree[v] = 0;
                op[v] = 0;
            }
            return;
        }

        int mid = (l + r) / 2;
        upd(v * 2 + 1, l, mid, ql, qr, tp);
        upd(v * 2 + 2, mid, r, ql, qr, tp);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }
};

signed main(){
#ifdef rog
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int h, w;
    cin >> h >> w;

    vector<vector<char>> arr(h, vector<char>(w));

    for(int i = 0;i < h;i++){
        for(int j = 0;j < w;j++){
            cin >> arr[i][j];
        }
    }

    vector<vector<int>> mx(h, vector<int>(w));
    for(int j = 0;j < w;j++){
        int last = -1;
        for(int i = 0;i < h;i++){
            if(arr[i][j] == '0'){
                last = i;
            }
            mx[i][j] = i - last;
        }
    }

    vector<vector<int>> anses(h, vector<int>(w, 0));
    int ans = 0;
    for(int i = 0;i < h;i++){
        SegTree tr(w * h + 1);
        for(int j = w - 1;j > -1;j--){
            tr.upd(0, 0, tr.n, mx[i][j], tr.n, 0);
            tr.upd(0, 0, tr.n, 0, mx[i][j], 1);
            //cout << i << " " << j << endl;
            //cout << mx[i][j] << endl;
            //cout << tr.tree[0] << endl;
            ans = max(ans, tr.tree[0]);
        }
        //cout << endl;
    }

    cout << ans << endl;

    return 0;
}