#include <bits/stdc++.h>
#define int long long
  
using namespace std;

struct SegTree{
    int n;
    vector<int> tree;
    vector<int> op;
    SegTree(int nn){
        n = nn;
        tree.resize(n * 3, 0);
        op.resize(n * 3, 0);
    }

    void push(int v, int l, int r){
        if(r - l == 1 || op[v] == 0){
            op[v] = 0;
            return;
        }

        int mid = (l + r) / 2;
        tree[v * 2 + 1] = mid - l;
        tree[v * 2 + 2] = r - mid;
        op[v * 2 + 1] = 1;
        op[v * 2 + 2] = 1;
        op[v] = 0;
    }

    void upd(int v, int l, int r, int ql, int qr){
        if(qr <= l || r <= ql){
            return;
        }

        push(v, l, r);
        if(ql <= l && r <= qr){
            tree[v] = r - l;
            op[v] = 1;
            return;
        }

        int mid = (l + r) / 2;
        upd(v * 2 + 1, l, mid, ql, qr);
        upd(v * 2 + 2, mid, r, ql, qr);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    int get(int v, int l, int r, int p){
        if(p < l || r <= p){
            return 0;
        }
        push(v, l, r);
        if(r - l == 1){
            return tree[v];
        }

        int mid = (l + r) / 2;
        return get(v * 2 + 1, l, mid, p) + get(v * 2 + 2, mid, r, p);
    }
};
  
signed main(){
#ifdef rog
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
  
    int t;
    cin >> t;
    for(int h = 0;h < t;h++){
        int n, k;
        cin >> n >> k;
        vector<array<int, 3>> arr(k);
        for(int i = 0;i < k;i++){
            cin >> arr[i][0] >> arr[i][1] >> arr[i][2];
        }

        for(int i = 0;i < k;i++){
            for(int j = 0;j < k;j++){
                if(i == j){
                    continue;
                }

            }
        }

        vector<int> a(k);
        for(int i = 0;i < k;i++){
            a[i] = i;
        }

        string ans = "NO";
        do{
            SegTree tr(n);
            for(int i = 0;i < k;i++){
                if(tr.get(0, 0, tr.n, arr[a[i]][1] - 1) == 0){
                    tr.upd(0, 0, tr.n, arr[a[i]][0] - 1, arr[a[i]][2]);
                }
            }
            if(tr.tree[0] == n){
                ans = "YES";
                break;
            }
        }while(next_permutation(a.begin(), a.end()));

        cout << ans << endl;
    }
  
    return 0;
}