#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const int INF = 1e9+7;
struct SegmentTree
{
	struct Node
	{
		int mn = INF;
		Node() {}
		Node(int x) : mn(x) {}
	};
	vector<Node> tree;
	int n;
	Node F(Node l, Node r)
	{
		Node x;
		x.mn = min(l.mn, r.mn);
		return x;
	}
	void Build(int _n)
	{
		n = _n;
		tree.resize(4 * n);
	}
	void SetMin(int v, int l, int r, int i, int x)
	{
		if (r <= i || i < l) return;
		if (r - l == 1)
		{
			tree[v].mn = min(x, tree[v].mn);
			return;
		}
		int mid = (r + l) / 2;
		if (i < mid)
		{
			SetMin(2 * v + 1, l, mid, i, x);
		}
		else
		{
			SetMin(2 * v + 2, mid, r, i, x);
		}
		tree[v] = F(tree[2 * v + 1], tree[2 * v + 2]);
	}
	int Get(int v, int l, int r, int ql, int qr)
	{
		if (qr<=l||r<=ql) return INF;
		if (ql<=l&&r<=qr)
		{
			return tree[v].mn;
		}
		int mid = (r + l) / 2;
		return min(Get(2 * v + 1, l, mid, ql, qr), Get(2 * v + 2, mid, r, ql, qr));
	}
};

void solve() 
{
	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> a(k);
	for (int i = 0; i < k; i++)
	{
		int l, r, m;
		cin >> l >> m >> r;
		a[i] = { l - 1,r - 1,m - 1 };
	}
	sort(a.begin(), a.end());
	SegmentTree tree;
	tree.Build(n + 1);
	tree.SetMin(0, 0, n + 1, 0, -1);
	for (int i = 0; i < k; i++)
	{
		auto [l, r, m] = a[i];
		int lstm = tree.Get(0, 0, n + 1, l, m+1);
		if (lstm!=INF)
		{
			tree.SetMin(0, 0, n + 1, r + 1, m);
		}
		lstm = tree.Get(0, 0, n + 1, m+1, r+1);
		if (lstm < l)
		{
			tree.SetMin(0, 0, n + 1, r + 1, m);
		}
	}
	if (tree.Get(0,0,n+1,n,n+1) != INF)
	{
		cout << "YES\n";
	}
	else
	{
		cout << "NO\n";
	}
}
int main()
{
	int t;
	cin >> t;
	while (t--) solve();
}