#pragma GCC optimize("O3, unroll_loops")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
using lll = __int128;
const int INF = 1e9 + 7;
const ll LINF = 1e18+7;
struct SegmentTree
{
	struct Node
	{
		int mn = INF;
		Node() {}
		Node(int x) : mn(x) {}
	};
	vector<Node> tree;
	int n;
	Node F(Node l, Node r)
	{
		Node x;
		x.mn = min(l.mn, r.mn);
		return x;
	}
	void Build(int _n)
	{
		n = _n;
		tree.resize(4 * n);
	}
	void SetMin(int v, int l, int r, int i, int x)
	{
		if (r <= i || i < l) return;
		if (r - l == 1)
		{
			tree[v].mn = min(x, tree[v].mn);
			return;
		}
		int mid = (r + l) / 2;
		if (i < mid)
		{
			SetMin(2 * v + 1, l, mid, i, x);
		}
		else
		{
			SetMin(2 * v + 2, mid, r, i, x);
		}
		tree[v] = F(tree[2 * v + 1], tree[2 * v + 2]);
	}
	int Get(int v, int l, int r, int ql, int qr)
	{
		if (qr<=l||r<=ql) return INF;
		if (ql<=l&&r<=qr)
		{
			return tree[v].mn;
		}
		int mid = (r + l) / 2;
		return min(Get(2 * v + 1, l, mid, ql, qr), Get(2 * v + 2, mid, r, ql, qr));
	}
};

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<int> x(n);
	for (int i = 0; i < n; i++) cin >> x[i];
	sort(x.begin(), x.end());
	ll start, d;
	cin >> start >> d;
	vector<int> left, right;
	left.reserve(n); right.reserve(n);
	for (int i = 0; i < n; i++)
	{
		if (x[i] < start) left.push_back(start - x[i]);
		else if(x[i]>start) right.push_back(x[i] - start);
	}
	reverse(left.begin(), left.end());
	int dpsz = max(left.empty() ? 0 : left.back(), right.empty()?0:right.back()) / d + 1;
	vector<lll> dp1(dpsz+1), dp2(dpsz+1);
	{lll xsqrsum = 0, xsum = 0;
	for (int x : left)
	{
		xsqrsum += (ll)x * x;
		xsum += x;
	}
	dp1[0] = xsqrsum;
	lll countedsum = 0;
	int j = 0;
	int cnt = left.size();
	for (int i = 1; i <= dpsz; i++)
	{
		for (j; j < left.size() && i * d >= left[j]; j++)
		{
			xsqrsum -= (ll)left[j] * left[j];
			xsum -= (ll)left[j];
			cnt--;
			countedsum += min((i * d - left[j]) * (i * d - left[j]), ((i - 1) * d - left[j]) * ((i - 1) * d - left[j]));
		}
		dp1[i] = min(dp1[i-1], xsqrsum - 2 * xsum * i * d + i * d * i * d * cnt + countedsum);
	}}
	{lll xsqrsum = 0, xsum = 0;
	for (int x : right)
	{
		xsqrsum += (ll)x * x;
		xsum += x;
	}
	dp2[0] = xsqrsum;
	lll countedsum = 0;
	int j = 0;
	int cnt = right.size();
	for (int i = 1; i <= dpsz; i++)
	{
		for (j; j < right.size() && i * d >= right[j]; j++)
		{
			xsqrsum -= (ll)right[j] * right[j];
			xsum -= (ll)right[j];
			cnt--;
			countedsum += min((i * d - right[j]) * (i * d - right[j]), ((i - 1) * d - right[j]) * ((i - 1) * d - right[j]));
		}
		dp2[i] = min(dp2[i-1],xsqrsum - 2 * xsum * i * d + i * d * i * d*cnt + countedsum);
	}}
	int m;
	cin >> m;
	while (m--)
	{
		int t;
		cin >> t;
		ll ansl=LINF, ans2l=LINF, ansr=LINF, ans2r=LINF;
		{
			lll curt = t;
			ll l=0, r=dpsz;
			while (r - l > 2)
			{
				ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
				lll ans1 = dp1[m1] + m1 * curt, ans2 = dp1[m2] + m2 * curt;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (int j = l; j <= r; j++)
			{
				ansl = min(ansl, dp1[j] + j * curt);
			}
		}
		{
			lll curt = 2*t;
			ll l = 0, r = dpsz;
			while (r - l > 2)
			{
				ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
				lll ans1 = dp1[m1] + m1 * curt, ans2 = dp1[m2] + m2 * curt;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (int j = l; j <= r; j++)
			{
				ans2l = min(ans2l, dp1[j] + j * curt);
			}
		}
		{
			lll curt = t;
			ll l = 0, r = dpsz;
			while (r - l > 2)
			{
				ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
				lll ans1 = dp2[m1] + m1 * curt, ans2 = dp2[m2] + m2 * curt;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (int j = l; j <= r; j++)
			{
				ansr = min(ansr, dp2[j] + j * curt);
			}
		}
		{
			lll curt = 2*t;
			ll l = 0, r = dpsz ;
			while (r - l > 2)
			{
				ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
				lll ans1 = dp2[m1] + m1 * curt, ans2 = dp2[m2] + m2 * curt;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (int j = l; j <= r; j++)
			{
				ans2r = min(ans2r, dp2[j] + j * curt);
			}
		}
		cout << min((ll)(ansl + ans2r), (ll)(ans2l + ansr)) << '\n';
	}
}
// (x-xi)^2
// x^2-2*x*xi+xi^2