#pragma GCC optimize("Ofast, unroll-loops, fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
using lll =ll;// __int128;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
struct SegmentTree
{
	struct Node
	{
		int mn = INF;
		Node() {}
		Node(int x) : mn(x) {}
	};
	vector<Node> tree;
	int n;
	Node F(Node l, Node r)
	{
		Node x;
		x.mn = min(l.mn, r.mn);
		return x;
	}
	void Build(int _n)
	{
		n = _n;
		tree.resize(4 * n);
	}
	void SetMin(int v, int l, int r, int i, int x)
	{
		if (r <= i || i < l) return;
		if (r - l == 1)
		{
			tree[v].mn = min(x, tree[v].mn);
			return;
		}
		int mid = (r + l) / 2;
		if (i < mid)
		{
			SetMin(2 * v + 1, l, mid, i, x);
		}
		else
		{
			SetMin(2 * v + 2, mid, r, i, x);
		}
		tree[v] = F(tree[2 * v + 1], tree[2 * v + 2]);
	}
	int Get(int v, int l, int r, int ql, int qr)
	{
		if (qr <= l || r <= ql) return INF;
		if (ql <= l && r <= qr)
		{
			return tree[v].mn;
		}
		int mid = (r + l) / 2;
		return min(Get(2 * v + 1, l, mid, ql, qr), Get(2 * v + 2, mid, r, ql, qr));
	}
};

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector<int> x(n);
	for (int i = 0; i < n; i++) cin >> x[i];
	sort(x.begin(), x.end());
	ll start, d;
	cin >> start >> d;
	vector<int> left, right;
	left.reserve(n); right.reserve(n);
	for (int i = 0; i < n; i++)
	{
		if (x[i] < start) left.push_back(start - x[i]);
		else if (x[i] > start) right.push_back(x[i] - start);
	}
	reverse(left.begin(), left.end());
	struct node
	{
		lll sum;
		lll mul;
		lll cnt;
	};
	vector<node> dp1(left.size() + 1), dp2(right.size() + 1);
	vector<int> tl(left.size()), tr(right.size());
	{
		lll xsqrsum = 0, xsum = 0;
		for (int x : left)
		{
			xsqrsum += (ll)x * x;
			xsum += x;
		}
		lll countedsum = 0;
		int cnt = left.size();
		dp1[0] = { xsqrsum,-2 * xsum,cnt };
		for (int j = 0; j < left.size(); j++)
		{
			int i = left[j] / d + 1;
			xsqrsum -= (ll)left[j] * left[j];
			xsum -= (ll)left[j];
			cnt--;
			countedsum += min((i * d - left[j]) * (i * d - left[j]), ((i - 1) * d - left[j]) * ((i - 1) * d - left[j]));
			dp1[j + 1] = { xsqrsum + countedsum, -2 * xsum, cnt };
		}
		for (int j = 0; j < left.size(); j++)
		{
			ll i = left[j] / d + 1;
			ll l = 0, r = INF;
			while (r - l > 1)
			{
				ll m1 = (r + l) / 2;

				lll ans1 = dp1[j+1].sum + dp1[j + 1].mul * i * d + i * i * d * d * dp1[j + 1].cnt + m1 * i;
				int cj = j;
				if ((i - 1) * d < left[j]) cj--;
				lll ans2 = dp1[cj + 1].sum + dp1[cj + 1].mul * (i - 1) * d + (i - 1) * (i - 1) * d * d * dp1[cj + 1].cnt + m1 * (i - 1);
				if ((i - 1) * d < left[j]) cj++;
				if (j+1<left.size() && (i + 1) * d >= left[j+1]) cj++;

				lll ans3 = dp1[cj + 1].sum + dp1[cj + 1].mul * (i + 1) * d + (i + 1) * (i + 1) * d * d * dp1[cj + 1].cnt + m1 * (i+1);
				if (ans1 > ans2||ans1>ans3)
				{
					r = m1;
				}
				else
				{
					l = m1;
				}
			}
			tl[j] = -l;
		}
	}
	{
		lll xsqrsum = 0, xsum = 0;
		for (int x : right)
		{
			xsqrsum += (ll)x * x;
			xsum += x;
		}
		lll countedsum = 0;
		int cnt = right.size();
		dp2[0] = { xsqrsum,-2 * xsum,cnt };
		for (int j = 0; j < right.size(); j++)
		{
			int i = right[j] / d + 1;
			xsqrsum -= (ll)right[j] * right[j];
			xsum -= (ll)right[j];
			cnt--;
			countedsum += min((i * d - right[j]) * (i * d - right[j]), ((i - 1) * d - right[j]) * ((i - 1) * d - right[j]));
			dp2[j + 1] = { xsqrsum + countedsum, -2 * xsum, cnt };
		}
		for (int j = 0; j <right.size(); j++)
		{
			ll i = right[j] / d + 1;
			ll l = 0, r = INF;
			while (r - l > 1)
			{
				ll m1 = (r + l) / 2;

				lll ans1 = dp2[j + 1].sum + dp2[j + 1].mul * i * d + i * i * d * d * dp2[j + 1].cnt + m1 * i;
				int cj = j;
				if ((i - 1) * d < right[j]) cj--;
				lll ans2 = dp2[cj + 1].sum + dp2[cj + 1].mul * (i - 1) * d + (i - 1) * (i - 1) * d * d * dp2[cj + 1].cnt + m1 * (i - 1);
				if ((i - 1) * d < right[j]) cj++;
				if (j + 1 < right.size() && (i + 1) * d >= right[j + 1]) cj++;

				lll ans3 = dp2[cj + 1].sum + dp2[cj + 1].mul * (i + 1) * d + (i + 1) * (i + 1) * d * d * dp2[cj + 1].cnt + m1 * (i + 1);
				if (ans1 > ans2 || ans1>ans3)
				{
					r = m1;
				}
				else
				{
					l = m1;
				}
			}
			tr[j] = -l;
		}
	}
	int m;
	cin >> m;
	while (m--)
	{
		int t;
		cin >> t;
		lll ansl = LINF, ans2l = LINF, ansr = LINF, ans2r = LINF;
		{
			lll curt = t;
			int j = upper_bound(tl.begin(), tl.end(), -curt) - tl.begin();
			ll l = (j > 0 ? left[j - 1] / d + 1 : 0), r = (j<left.size()?left[j] / d:INF);

			while (r - l > 2)
			{
				ll m1 = (r + l) / 2, m2 = (r + l) / 2 + 1;

				lll ans1 = dp1[j].sum + dp1[j].mul * m1 * d + m1 * m1 * d * d * dp1[j].cnt + curt * m1;
				lll ans2 = dp1[j].sum + dp1[j].mul * m2 * d + m2 * m2 * d * d * dp1[j].cnt + curt * m2;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (ll i = l; i <= r; i++)
			{
				lll ans = dp1[j].sum + dp1[j].mul * i * d + i * i * d * d * dp1[j].cnt;
				ansl = min(ansl, ans + curt * l);
			}
		}
		{
			lll curt = 2 * t;
			int j = upper_bound(tl.begin(), tl.end(), -curt) - tl.begin();
			ll l = (j > 0 ? left[j - 1] / d + 1 : 0), r = (j < left.size() ? left[j] / d : INF);

			while (r - l > 2)
			{
				ll m1 = (r + l) / 2, m2 = (r + l) / 2 + 1;

				lll ans1 = dp1[j].sum + dp1[j].mul * m1 * d + m1 * m1 * d * d * dp1[j].cnt + curt * m1;
				lll ans2 = dp1[j].sum + dp1[j].mul * m2 * d + m2 * m2 * d * d * dp1[j].cnt + curt * m2;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (ll i = l; i <= r; i++)
			{
				
				lll ans = dp1[j].sum + dp1[j].mul * i * d + i * i * d * d * dp1[j].cnt;
				ans2l = min(ans2l, ans + curt * l);
			}
		}
		{
			lll curt = t;
			int j = upper_bound(tr.begin(), tr.end(), -curt) - tr.begin();
			ll l = (j > 0 ? right[j - 1] / d + 1 : 0), r = (j < right.size() ? right[j] / d : INF);

			while (r - l > 2)
			{
				ll m1 = (r + l) / 2, m2 = (r + l) / 2 + 1;

				lll ans1 = dp2[j].sum + dp2[j].mul * m1 * d + m1 * m1 * d * d * dp2[j].cnt + curt * m1;
				lll ans2 = dp2[j].sum + dp2[j].mul * m2 * d + m2 * m2 * d * d * dp2[j].cnt + curt * m2;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (ll i = l; i <= r; i++)
			{
				lll ans = dp2[j].sum + dp2[j].mul * i * d + i * i * d * d * dp2[j].cnt;
				ansr = min(ansr, ans + curt * l);
			}
		}
		{
			lll curt = 2 * t;
			int j = upper_bound(tr.begin(), tr.end(), -curt) - tr.begin();
			ll l = (j > 0 ? right[j - 1] / d + 1 : 0), r = (j < right.size() ? right[j] / d : INF);

			while (r - l > 2)
			{
				ll m1 = (r + l) / 2, m2 = (r + l) / 2 + 1;

				lll ans1 = dp2[j].sum + dp2[j].mul * m1 * d + m1 * m1 * d * d * dp2[j].cnt + curt * m1;
				lll ans2 = dp2[j].sum + dp2[j].mul * m2 * d + m2 * m2 * d * d * dp2[j].cnt + curt * m2;
				if (ans1 <= ans2)
				{
					r = m2;
				}
				else
				{
					l = m1;
				}
			}
			for (ll i = l; i <= r; i++)
			{
				lll ans = dp2[j].sum + dp2[j].mul * i * d + i * i * d * d * dp2[j].cnt;
				ans2r = min(ans2r, ans + curt * l);
			}
		}
		cout <<'\t'<< min((ll)(ansl + ans2r), (ll)(ans2l + ansr)) << '\n';
	}
}
// (x-xi)^2
// x^2-2*x*xi+xi^2