#pragma GCC optimize("O3, unroll_loops")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
using lll =__int128;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
struct SegmentTree
{
	struct Node
	{
		int mn = INF;
		Node() {}
		Node(int x) : mn(x) {}
	};
	vector<Node> tree;
	int n;
	Node F(Node l, Node r)
	{
		Node x;
		x.mn = min(l.mn, r.mn);
		return x;
	}
	void Build(int _n)
	{
		n = _n;
		tree.resize(4 * n);
	}
	void SetMin(int v, int l, int r, int i, int x)
	{
		if (r <= i || i < l) return;
		if (r - l == 1)
		{
			tree[v].mn = min(x, tree[v].mn);
			return;
		}
		int mid = (r + l) / 2;
		if (i < mid)
		{
			SetMin(2 * v + 1, l, mid, i, x);
		}
		else
		{
			SetMin(2 * v + 2, mid, r, i, x);
		}
		tree[v] = F(tree[2 * v + 1], tree[2 * v + 2]);
	}
	int Get(int v, int l, int r, int ql, int qr)
	{
		if (qr <= l || r <= ql) return INF;
		if (ql <= l && r <= qr)
		{
			return tree[v].mn;
		}
		int mid = (r + l) / 2;
		return min(Get(2 * v + 1, l, mid, ql, qr), Get(2 * v + 2, mid, r, ql, qr));
	}
};

vector<vector<int>> g;

pair<int, int> dfs(int v, int p)
{
	int zero = 0, one = 0;
	for (int u : g[v])
	{
		if (u == p) continue;
		auto [uz, uo] = dfs(u, v);
		zero += max(uz, uo);
		one = max(one, uo - max(uz, uo) + 1);
	}
	return { zero,zero + one };
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, d;
	cin >> n >> d;
	g.resize(n);
	for (int i = 0; i < n - 1; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	auto [uz, uo] = dfs(0,0);
	cout << max(uz, uo);
}
// (x-xi)^2
// x^2-2*x*xi+xi^2