#pragma GCC optimize("O3, unroll_loops")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
//using lll =__int128;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
struct SegmentTree
{
	struct Node
	{
		int mn = INF;
		Node() {}
		Node(int x) : mn(x) {}
	};
	vector<Node> tree;
	int n;
	Node F(Node l, Node r)
	{
		Node x;
		x.mn = min(l.mn, r.mn);
		return x;
	}
	void Build(int _n)
	{
		n = _n;
		tree.resize(4 * n);
	}
	void SetMin(int v, int l, int r, int i, int x)
	{
		if (r <= i || i < l) return;
		if (r - l == 1)
		{
			tree[v].mn = min(x, tree[v].mn);
			return;
		}
		int mid = (r + l) / 2;
		if (i < mid)
		{
			SetMin(2 * v + 1, l, mid, i, x);
		}
		else
		{
			SetMin(2 * v + 2, mid, r, i, x);
		}
		tree[v] = F(tree[2 * v + 1], tree[2 * v + 2]);
	}
	int Get(int v, int l, int r, int ql, int qr)
	{
		if (qr <= l || r <= ql) return INF;
		if (ql <= l && r <= qr)
		{
			return tree[v].mn;
		}
		int mid = (r + l) / 2;
		return min(Get(2 * v + 1, l, mid, ql, qr), Get(2 * v + 2, mid, r, ql, qr));
	}
};

vector<vector<int>> g, g1;
vector<int> match;
vector<int> used; int ep = 1;
bool kuhn(int v)
{
	if (used[v] == ep) return false;
	used[v] = ep;
	for (int u : g1[v])
	{
		if (match[u] == -1)
		{
			//match[v] = u;
			match[u] = v;
			return true;
		}
	}
	for (int u : g1[v])
	{
		if (kuhn(match[u]))
		{
			//match[v] = u;
			match[u] = v;
			return true;
		}
	}
	return false;
}
int n, d;
vector<int> distanc;
void dfs1(int v, int p, int dist)
{
	distanc[v] = dist;
	for (int u : g[v])
	{
		if (u == p) continue;
		dfs1(u, v, dist + 1);
	}
}
void dfs(int v, int p, int st, int dist)
{
	if (dist % 2 == 1)
	{
		g1[st].push_back(v);
	}
	if (dist==d) return;
	for (int u : g[v])
	{
		if (u == p) continue;
		dfs(u, v, st, dist + 1);
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d;
	g.resize(n);
	g1.resize(n);
	for (int i = 0; i < n - 1; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	
	distanc.resize(n);

	dfs1(0, 0, 0);
	if (d == n - 1)
	{
		set<int> z;
		for (int i = 0; i < n; i++)
		{
			if (distanc[i] % 2 == 0) z.insert(i);
		}
		vector<pair<int, int>> ans;
		for (int i = 0; i < n; i++)
		{
			if (distanc[i] % 2 == 1&&!z.empty())
			{
				ans.push_back({ i,*z.begin() });
				z.erase(z.begin());
			}
		}
		cout << ans.size() << '\n';
		for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
		return 0;
	}
	for (int i = 0; i < n; i++)
	{
		dfs(i, i, i, 0);
	}
	used.resize(n);
	match.resize(n, -1);
	for (int i = 0; i < n; i++)
	{
		if(distanc[i]%2==0) kuhn(i); ep++;
	}
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++)
	{
		if(match[i]!=-1) ans.push_back({ i,match[i] });
	}
	cout << ans.size() << '\n';
	for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
}
// (x-xi)^2
// x^2-2*x*xi+xi^2