#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

struct segment_tree {
	vector<ll> tree;
	ll size;
	segment_tree(ll n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 2, INF);
	}
	ll get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return INF;
		}
		ll mid = (l + r) / 2;
		return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
	}
	void set(ll v, ll x) {
		set(1, 0, size, v, x);
	}
	void set(ll v, ll l, ll r, ll x, ll y) {
		if (x < l || r <= x) {
			return;
		}
		if (r - l == 1) {
			tree[v] = y;
			return;
		}
		ll mid = (l + r) / 2;
		set(v * 2, l, mid, x, y);
		set(v * 2 + 1, mid, r, x, y);
		tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
	}
};

void solve() {
	ll n, k;
	cin >> n >> k;
	vector<tuple<ll, ll, ll>> segs(k);
	for (auto&[m, r, l] : segs) {
		cin >> l >> m >> r;
		l--;
	}
	sort(segs.begin(), segs.end());
	segment_tree st(n + 1);
	vector<ll> mmp(n + 1, INF);
	mmp[0] = 0;
	st.set(0, 0);
	for (auto[m, r, l] : segs) {
		if (mmp[r] < m) {
			continue;
		}
		if (st.get(l, m) < INF || st.get(m, r) <= l) {
			mmp[r] = m;
			st.set(r, m);
		}
	}
	cout << (mmp.back() == INF ? "NO" : "YES") << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
