#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<vector<ll>> dfs(ll v, ll p, ll d, vector<vector<ll>>& tree, vector<pair<ll, ll>>& ans) {
	vector<vector<ll>> nc(d);
	nc[0].push_back(v);
	for (auto i : tree[v]) {
		if (i != p) {
			vector<vector<ll>> ncs = dfs(i, v, d, tree, ans);
			while (!ncs[1].empty() && !ncs[2].empty()) {
				ans.emplace_back(ncs[1].back(), ncs[2].back());
				ncs[1].pop_back();
				ncs[2].pop_back();
			}
			for (auto i : ncs[0]) {
				nc[1].push_back(i);
			}
			for (auto i : ncs[1]) {
				nc[2].push_back(i);
			}
		}
	}
	return nc;
}

void solve() {
	ll n;
	cin >> n;
	ll d;
	cin >> d;
	vector<vector<ll>> to(n);
	for (ll i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		to[a].push_back(b);
		to[b].push_back(a);
	}
	if (d % 2 == 0) {
		d--;
	}
	vector<pair<ll, ll>> ans;
	auto nc = dfs(0, 0, 3, to, ans);
	while (!nc[1].empty() && !nc[2].empty()) {
		ans.emplace_back(nc[1].back(), nc[2].back());
		nc[1].pop_back();
		nc[2].pop_back();
	}
	while (!nc[1].empty() && !nc[0].empty()) {
		ans.emplace_back(nc[1].back(), nc[0].back());
		nc[1].pop_back();
		nc[0].pop_back();
	}
	cout << ans.size() << '\n';
	for (auto[a, b] : ans) {
		cout << a + 1 << ' ' << b + 1 << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
