#pragma GCC optimize("O3")

#include <bits/extc++.h>
  
using namespace std;
  
vector<vector<int>> g, t;
  
vector<int> ord, used, c;
  
void dfs1(int v) {
  used[v] = 1;
  for (int u : g[v]) {
    if (!used[u]) {
      dfs1(u);
    }
  }
  ord.push_back(v);
}
  
void dfs2(int v, int col) {
  c[v] = col;
  for (int u : t[v]) {
    if (c[u] == -1) {
      dfs2(u, col);
    }
  }
}

mt19937 rnd_(chrono::high_resolution_clock::now().time_since_epoch().count());
 
int rnd(int l, int r) {
  return l + (int)(rnd_() % (r - l + 1));
}
 
double RRR() {
  return (double)rnd(0, 1000000000) / (double)(1000000000);
}
 
struct sgt {
  vector<pair<int, int>> t;
  vector<int> lazy;
  void init(int n) {
    t.assign(n << 2, {0, 0});
    lazy.assign(n << 2, 0);
  }
  pair<int, int> pull(pair<int, int> a, pair<int, int> b) {
    if (a.first != b.first) {
      return min(a, b);
    }
    return {a.first, a.second + b.second};
  }
  void bld(int v, int tl, int tr) {
    if (tl + 1 == tr) {
      t[v] = {0, 1};
      return;
    }
    int tm = (tl + tr) >> 1;
    bld(2 * v + 1, tl, tm);
    bld(2 * v + 2, tm, tr);
    t[v] = pull(t[2 * v + 1], t[2 * v + 2]);
  }
  void push(int v, int tl, int tr) {
    if (lazy[v] == 0) {
      return;
    }
    t[v].first += lazy[v];
    if (tl + 1 < tr) {
      lazy[2 * v + 1] += lazy[v];
      lazy[2 * v + 2] += lazy[v];
    }
    lazy[v] = 0;
  }
  void upd(int v, int tl, int tr, int l, int r, int x) {
    push(v, tl, tr);
    if (tr <= l || r <= tl) {
      return;
    }
    if (l <= tl && tr <= r) {
      lazy[v] = x;
      push(v, tl, tr);
      return;
    }
    int tm = (tl + tr) >> 1;
    upd(2 * v + 1, tl, tm, l, r, x);
    upd(2 * v + 2, tm, tr, l, r, x);
    t[v] = pull(t[2 * v + 1], t[2 * v + 2]);
  }
  pair<int, int> get(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (tr <= l || r <= tl) {
      return {-1, 0};
    }
    if (l <= tl && tr <= r) {
      return t[v];
    }
    int tm = (tl + tr) >> 1;
    return pull(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
  };
};
 
int TTT;
 
void solve() {
  int n, k;
  cin >> n >> k;
  g.assign(k, {});
  t.assign(k, {});
  vector<int> l(k), m(k), r(k);
  vector<int> z(n + 1);
  for (int i = 0; i < k; i++) {
    cin >> l[i] >> m[i] >> r[i];
    l[i]--, m[i]--, r[i]--;
    z[l[i]]++;
    z[r[i] + 1]--;
  }
  for (int i = 1; i < n; i++) {
    z[i] += z[i - 1];
  }
  for (int i = 0; i < n; i++) {
    if (z[i] == 0) {
      cout << "NO\n";
      return;
    }
  }
  for (int v = 0; v < k; v++) {
    for (int u = 0; u < k; u++) {
      if (v == u) {
        // continue;
      }
      if (l[v] <= m[u] && m[u] <= r[v]) {
        g[u].push_back(v);
        t[v].push_back(u);
      }
    }
  }
  used.assign(k, 0);
  ord.clear();
  c.assign(k, -1);
  for (int v = 0; v < k; v++) {
    if (!used[v]) {
      dfs1(v);
    }
  }
  reverse(ord.begin(), ord.end());
  int col = 0;
  for (int v : ord) {
    if (c[v] == -1) {
      dfs2(v, col);
      col++;
    }
  }
  vector<vector<int>> h(col);
  for (int i = 0; i < k; i++) {
    h[c[i]].push_back(i);
  }
  vector<int> good;
  for (int i = 0; i < col; i++) {
    if (h[i].size() > 1) {
      good.push_back(i);
    }
  }
  sgt e;
  e.init(n);
  e.bld(0, 0, n);
  vector<int> w(col);
  for (int i = 0; i < col; i++) {
    w[i] = rnd(0, h[i].size() - 1);
    // cerr << "+++ " << l[h[i][w[i]]] +  1 << "  " << r[h[i][w[i]]] + 1 << '\n';
    e.upd(0, 0, n, l[h[i][w[i]]], r[h[i][w[i]]] + 1, 1);
  }
  // for (int i = 0; i < k; i++) {
    // cerr << c[i] << '\n';
  // }
  // cerr << '\n';
  auto f = [&]() -> int {
    auto pr = e.get(0, 0, n, 0, n);
    // cerr << "????? " << pr.first <<  ' ' << pr.second << '\n';
    if (pr.first == 0) {
      return pr.second;
    }
    return 0;
  };
  int ans = f();
  if (!good.empty()) {
    double T = 1;
 
    while ((double)clock() / (double)CLOCKS_PER_SEC <= 0.019) {
      T *= 0.99999;
      int i = good[rnd(0, good.size() - 1)];
      int d = rnd(0, h[i].size() - 1);
      int was = w[i];
      e.upd(0, 0, n, l[h[i][w[i]]], r[h[i][w[i]]] + 1, -1);
      e.upd(0, 0, n, l[h[i][d]], r[h[i][d]] + 1, 1);
      int now = f();
      if (now < ans || RRR() < exp((ans - now) / T)) {
        ans = now;
        w[i] = d;
      } else {
        e.upd(0, 0, n, l[h[i][w[i]]], r[h[i][w[i]]] + 1, 1);
        e.upd(0, 0, n, l[h[i][d]], r[h[i][d]] + 1, -1);
      }
      if (ans == 0) {
        break;
      }
    }
  }
  cout << (ans == 0 ? "YES\n" : "NO\n");
}
 
signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cin >> TTT;
  for (int i = 0; i < TTT; i++) {
    solve();
  }
  return 0;
}
/*
 
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
 
 **/