// #pragma GCC optimize("O3")
 
#include <bits/extc++.h>
 
using namespace std;

vector<vector<int>> g;
vector<int> num;

void f(int v, int tl, int tr) {
  if (tl + 1 == tr) {
    num[tl] = v;
    return;
  }
  int tm = (tl + tr) >> 1;
  f(2 * v + 1, tl, tm);
  f(2 * v + 2, tm, tr);
  g[v].push_back(2 * v + 1);
  g[v].push_back(2 * v + 2);
}

void link(int v, int tl, int tr, int l, int r, int T) {
  if (tr <= l || r <= tl) {
    return;
  }
  if (l <= tl && tr <= r) {
    g[num[T]].push_back(v);
    return;
  }
  int tm = (tl + tr) >> 1;
  link(2 * v + 1, tl, tm, l, r, T);
  link(2 * v + 2, tm, tr, l, r, T);
}

vector<int> ord, used, c;
vector<vector<int>> tg;

void dfs(int v) {
  used[v] = 1;
  for (int u : g[v]) {
    if (!used[u]) {
      dfs(u);
    }
  }
  ord.push_back(v);
}

void dfs2(int v, int col) {
  c[v] = col;
  for (int u : tg[v]) {
    if (c[u] == -1) {
      dfs2(u, col);
    }
  }
}

void solve() {
  int n, k;
  cin >> n >> k;
  g.assign(4 * k, {});
  ord.clear();
  used.assign(k << 2, 0);
  tg.assign(k << 2, {});
  num.assign(k, -1);
  c.assign(k << 2, -1);

  vector<int> l(k), m(k), r(k);
  for (int i = 0; i < k; i++) {
    cin >> l[i] >> m[i] >> r[i];
    l[i]--, m[i]--, r[i]--;
    assert(l[i] == 0 || r[i] == n - 1);
    if (r[i] - l[i] + 1 == n) {
      cout << "YES\n";
      return;
    }
  }
  vector<int> ord(k);
  for (int i = 0; i < k; i++) {
    ord[i] = i;
  }
  sort(ord.begin(), ord.end(), [&](int i, int j) {
    return m[i] < m[j];
  });
  {
    auto mm = m;
    auto ll = l;
    auto rr = r;
    for (int i = 0; i < k; i++) {
      l[i] = ll[ord[i]];
      m[i] = mm[ord[i]];
      r[i] = rr[ord[i]];
    }
  }
  f(0, 0, k);
  for (int i = 0; i < k; i++) {
    int ll = (int)(lower_bound(m.begin(), m.end(), l[i]) - m.begin());
    int rr = (int)(upper_bound(m.begin(), m.end(), r[i]) - m.begin());
    link(0, 0, n, ll, rr, i);
  }
  for (int v = 0; v < g.size(); v++) {
    for (int u : g[v]) {
      tg[u].push_back(v);
    }
  }
  for (int v = 0; v < k; v++) {
    if (!used[v]) {
      dfs(v);
    }
  }
  reverse(ord.begin(), ord.end());
  int col = 0;
  for (int v : ord) {
    if (c[v] == -1) {
      dfs2(v, col);
      col++;
    }
  }
  set<int> all;
  for (int v = 0; v < k; v++) {
    all.insert(c[num[v]]);
  }
  cout << (all.size() == k ? "YES" : "NO") << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}