#include <bits/stdc++.h>
 
using namespace std;
 
// #define int long long
 
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
 
using ll = long long;

const ll INF = 1e9;

template<typename T>
inline void chmin(T& a, T b) {
    if (b < a) {
        a = b;
    }
}

struct S{
    int n;
    vector<int> t, pu;
    S() {}
    S(int n) : n(n), t(4 * n, INF), pu(4 * n, INF) {}
    void push(int node, int l, int r) {
        if (pu[node] != INF) {
            chmin(t[node], pu[node]);
            if (l != r) {
                chmin(pu[2 * node], pu[node]);
                chmin(pu[2 * node + 1], pu[node]);
            }
            pu[node] = INF;
        }
    }
    void upd(int node, int l, int r, int ql, int qr, int val) {
        push(node, l, r);
        if (max(l, ql) > min(r, qr)) {
            return;
        }
        if (ql <= l && r <= qr) {
            pu[node] = val;
            push(node, l, r);
            return;
        }
        int m = (l + r) >> 1;
        upd(2 * node, l, m, ql, qr, val);
        upd(2 * node + 1, m + 1, r, ql, qr, val);
        t[node] = min(t[2 * node], t[2 * node + 1]);
    }
    void upd(int ql, int qr, int val) {
        upd(1, 0, n - 1, ql, qr, val);
    }
    int get(int node, int l, int r, int ql, int qr) {
        push(node, l, r);
        if (max(l, ql) > min(r, qr)) return INF;
        if (ql <= l && r <= qr) {
            return t[node];
        }
        int m = (l + r) >> 1;
        return min(get(2 * node, l, m, ql, qr), get(2 * node + 1, m + 1, r, ql, qr));
    }
    int get(int ql, int qr) {
        return get(1, 0, n - 1, ql, qr);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> a(k);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < 3; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    sort(all(a), [&](auto x, auto y) {
        return x[2] < y[2];
    });
    vector<bool> dp(k);
    S s1(n + 1);
    S s2(n + 1);
    for (int i = 0; i < k; ++i) {
        if (a[i][0] == 0) {
            dp[i] = 1;
        } else {
            if (s1.get(a[i][0], a[i][0]) < a[i][0] || s2.get(a[i][0], a[i][0]) < a[i][1]) {
                dp[i] = 1;
            }
        }
        if (dp[i]) {
            s1.upd(a[i][0] + 1, a[i][2] + 1, a[i][1]);
            s2.upd(a[i][0] + 1, a[i][2] + 1, a[i][2]);
        }
    }
    for (int i = 0; i < k; ++i) {
        if (dp[i] && a[i][2] == n - 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}
 
signed main() {
    #ifdef LOCALEGOR
    freopen("C:\\work\\INPUT.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    #endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}