#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct seg
{
	long long l, r, m;
};

struct segtree
{
	long long n;
	vector<int> t;

	segtree() {}

	segtree(int in)
	{
		n = in;
		t.resize(n * 4, -1);
	}

	void upd_elem(long long v, long long tl, long long tr, long long pos, int val)
	{
		if (tl == tr)
		{
			t[v] = max(t[v], val);
			return;
		}

		long long tm = (tl + tr) / 2;
		if (pos <= tm)
		{
			upd_elem(v * 2 + 1, tl, tm, pos, val);
		}
		else
		{
			upd_elem(v * 2 + 2, tm + 1, tr, pos, val);
		}
		t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
	}

	void upd(long long pos, long long val)
	{
		upd_elem(0, 0, n - 1, pos, val);
	}

	long long get_seg(long long v, long long tl, long long tr, long long l, long long r)
	{
		if (tr < l || r < tl)
		{
			return -1;
		}
		if (l <= tl && tr <= r)
		{
			return t[v];
		}

		long long tm = (tl + tr) / 2;
		return max(get_seg(v * 2 + 1, tl, tm, l, r), get_seg(v * 2 + 2, tm + 1, tr, l, r));
	}

	long long get(long long l, long long r)
	{
		return get_seg(0, 0, n - 1, l, r);
	}
};

void solve()
{
	long long n, k;
	cin >> n >> k;
	vector<seg> v(k);
	for (long long i = 0; i < k; i++)
	{
		cin >> v[i].l >> v[i].m >> v[i].r;
		v[i].l--;
		v[i].m--;
		v[i].r--;
	}
	sort(v.begin(), v.end(),
		[](seg& x, seg& y)
		{
			if (x.l == y.l)
			{
				return x.m < y.m;
			}
			return x.l < y.l;
		}
	);

	vector<bool> dp(k);
	segtree sgtr(n + 1), sgtm(n + 1);
	for (long long i = k - 1; i > -1; i--)
	{
		if (v[i].r == n - 1)
		{
			dp[i] = true;
			sgtr.upd(v[i].l, v[i].r);
			sgtm.upd(v[i].l, v[i].m);
			continue;
		}

		/*
		for (long long j = i + 1; j < k; j++)
		{
			if (v[i].r + 1 < v[j].l)
			{
				break;
			}
			if (v[j].r <= v[i].r)
			{
				continue;
			}
			if (!dp[j])
			{
				continue;
			}
			long long cnt = 0;
			if (v[j].l <= v[i].m && v[i].m <= v[j].r)
			{
				cnt++;
			}
			if (v[i].l <= v[j].m && v[j].m <= v[i].r)
			{
				cnt++;
			}
			if (cnt <= 1)
			{
				dp[i] = true;
				break;
			}
		}
		*/

		long long mxm = sgtm.get(v[i].l, v[i].m);
		if (v[i].r < mxm)
		{
			dp[i] = true;
		}
		if (!dp[i])
		{
			long long mxr = sgtr.get(v[i].m + 1, v[i].r + 1);
			if (v[i].r < mxr)
			{
				dp[i] = true;
			}
		}
		if (dp[i])
		{
			sgtr.upd(v[i].l, v[i].r);
			sgtm.upd(v[i].l, v[i].m);
		}
	}

	bool ans = false;
	for (long long i = 0; i < k; i++)
	{
		if (v[i].l == 0 && dp[i])
		{
			ans = true;
			break;
		}
	}
	cout << (ans ? "YES" : "NO") << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
