#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long divl(long long a, long long b)
{
	if (a >= 0)
	{
		return a / b;
	}
	return -((-a + b - 1) / b);
}

long long divr(long long a, long long b)
{
	if (a >= 0)
	{
		return (a + b - 1) / b;
	}
	return a / b;
}

void solve()
{
	long long n;
	cin >> n;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	long long s, d;
	cin >> s >> d;
	long long q;
	cin >> q;
	sort(v.begin(), v.end());
	vector<long long> best(n);

	auto get_thr = [&](long long a, long long b) -> long long
	{
		return (a - b) * (a - b);
	};

	vector<long long> upos = { s };
	for (long long i = 0; i < n; i++)
	{
		long long k = divl(v[i] - s, d);
		upos.push_back(s + k * d);
		best[i] = get_thr(s + k * d, v[i]);
		k = divr(v[i] - s, d);
		upos.push_back(s + k * d);
		best[i] = min(best[i], get_thr(s + k * d, v[i]));
	}
	for (long long i = -d; i <= 50 + d; i++)
	{
		upos.push_back(i);
	}
	sort(upos.begin(), upos.end());
	upos.erase(unique(upos.begin(), upos.end()), upos.end());

	vector<long long> pbest(n + 1);
	for (long long i = 0; i < n; i++)
	{
		pbest[i + 1] = pbest[i] + best[i];
	}
	long long sidx = lower_bound(upos.begin(), upos.end(), s) - upos.begin();
	while (q--)
	{
		long long t;
		cin >> t;
		long long ans = INF;
		for (long long left = sidx; left > -1; left--)
		{
			for (long long right = sidx; right < upos.size(); right++)
			{
				long long cur = 0;
				for (long long i = 0; i < n; i++)
				{
					if (v[i] <= upos[left])
					{
						cur += get_thr(v[i], upos[left]);
					}
					else if (upos[right] <= v[i])
					{
						cur += get_thr(upos[right], v[i]);
					}
					else
					{
						cur += best[i];
					}
					if (cur > ans)
					{
						break;
					}
				}
				if (cur > ans)
				{
					continue;
				}

				long long tol = (s - upos[left]) / d;
				long long tor = (upos[right] - s) / d;
				cur += (tol + tor) * t;
				cur += min(tol, tor) * t;
				ans = min(ans, cur);
			}
		}
		cout << ans << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
