#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));
 
const long long INF = 2e18, MOD = 1e9 + 7;
 
long long n, d;
vector<long long> g[500000];
vector<bool> col;
 
void dfs_col(long long v, long long p)
{
    for (auto& i : g[v])
    {
        if (i == p)
        {
            continue;
        }
 
        col[i] = (col[v] ^ 1);
        dfs_col(i, v);
    }
}
 
long long tmr = 0;
vector<long long> gr[500000];
vector<long long> used;
 
void dfs_edges(long long v, long long p, long long d, long long rt)
{
    if (col[v])
    {
        gr[rt].push_back(v);
    }
    if (!d)
    {
        return;
    }
    for (auto& i : g[v])
    {
        if (i == p)
        {
            continue;
        }
 
        dfs_edges(i, v, d - 1, rt);
    }
}
 
bool kuhn(long long v, vector<long long>& mt)
{
    if (used[v] == tmr)
    {
        return false;
    }
    used[v] = tmr;
    for (auto& i : gr[v])
    {
        if (mt[i] == -1 || kuhn(mt[i], mt))
        {
            mt[i] = v;
            return true;
        }
    }
    return false;
}
 
void solve()
{
    cin >> n >> d;
    for (long long i = 0; i < n - 1; i++)
    {
        long long a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    col.resize(n);
    dfs_col(0, -1);
 
    for (long long i = 0; i < n; i++)
    {
        if (col[i])
        {
            continue;
        }
 
        dfs_edges(i, -1, d, i);
    }
 
    used.resize(n, -1);
    vector<long long> mt(n, -1);
    for (long long i = 0; i < n; i++)
    {
        if (!gr[i].size())
        {
            continue;
        }
 
        kuhn(i, mt);
        tmr++;
    }
    vector<pair<long long, long long>> ans;
    for (long long i = 0; i < n; i++)
    {
        if (mt[i] != -1)
        {
            ans.push_back({ i, mt[i] });
        }
    }
    cout << ans.size() << "\n";
    for (auto& i : ans)
    {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
}
 
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
 
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
 
    return 0;
}
 
/*
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
*/
