//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long t, n, m;
vector<pair<long long, long long>> tree;

void update(long long v, long long l, long long r, long long nom, pair<long long, long long> p) {
	if (l > nom || r < nom)
		return;
	if (l == r) {
		tree[v] = p;
		return;
	}
	long long mid = (l + r) / 2;
	update(v * 2, l, mid, nom, p);
	update(v * 2 + 1, mid + 1, r, nom, p);
	tree[v].first = max(tree[v * 2].first, tree[v * 2 + 1].first);
	tree[v].second = max(tree[v * 2].second, tree[v * 2 + 1].second);
}

long long get1(long long v, long long l, long long r, long long x) {
	if (tree[v].first > x + 1)
		return -1;
	if (l == r)
		return l;
	long long mid = (l + r) / 2;
	if (tree[v * 2 + 1].first <= x + 1)
		return get1(v * 2 + 1, mid + 1, r, x);
	else
		return get1(v * 2, l, mid, x);
}

pair<long long, long long> get2(long long v, long long l, long long r, long long x) {
	if (l > x)
		return { -1, -1 };
	if (r <= x)
		return tree[v];
	long long mid = (l + r) / 2;
	pair<long long, long long> p1 = get2(v * 2, l, mid, x);
	pair<long long, long long> p2 = get2(v * 2 + 1, mid + 1, r, x);
	return { max(p1.first, p2.first), max(p1.second, p2.second) };
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> t;

	for (long long h = 0; h < t; ++h) {
		cin >> n >> m;

		tree.clear();
		tree.resize(4 * m, { -1, -1 });

		vector<pair<pair<long long, long long>, long long>> v1(m);
		vector<long long> dp(m, 0);

		for (long long i = 0; i < m; ++i) {
			cin >> v1[i].first.first >> v1[i].second >> v1[i].first.second;
			--v1[i].first.first;
			--v1[i].first.second;
			--v1[i].second;
		}

		sort(v1.begin(), v1.end());

		long long nom = m - 1;

		for (long long i = m - 1; i >= 0; --i) {
			if (v1[i].first.second == n - 1) {
				dp[i] = 1;
				update(1, 0, m - 1, nom, { v1[i].first.first, v1[i].second });
				--nom;
				continue;
			}

			long long x1 = get1(1, 0, m - 1, v1[i].first.second);
			if (x1 == -1)
				continue;
			pair<long long, long long> p = get2(1, 0, m - 1, x1);

			if (v1[i].second < p.first || v1[i].first.second < p.second) {
				dp[i] = 1;
				update(1, 0, m - 1, nom, { v1[i].first.first, v1[i].second });
				--nom;
				continue;
			}

			/*for (long long j = i + 1; j < m; ++j) {
				if (dp[j] == 1 && v1[j].first.first <= v1[i].first.second + 1) {
					if (v1[i].second < v1[j].first.first) {
						dp[i] = 1;
						break;
					}
					else {
						if (v1[j].second > v1[i].first.second) {
							dp[i] = 1;
							break;
						}
					}
				}
			}*/
		}

		long long x4 = 1;

		for (long long i = 0; i < m; ++i)
			if (v1[i].first.first == 0 && dp[i] == 1) {
				x4 = 0;
				break;
			}

		if (x4 == 1)
			cout << "NO\n";
		else
			cout << "YES\n";
	}

	return 0;
}
