//#pragma GCC optimaze('O3')
//#pragma GCC target('avx,avx2,fma')
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long n, d;
vector<vector<long long>> g, sp;
vector<long long> v1, v2, tin, eul, logg, used, mt, used2;

void dfs1(long long v, long long c, long long pr, long long h) {
	eul.push_back(h);
	tin[v] = (long long)eul.size() - 1;
	if (c == 0) {
		v1.push_back(v);
		used[v] = 1;
	}
	else
		v2.push_back(v);
	for (long long i = 0; i < (long long)g[v].size(); ++i)
		if (pr != g[v][i]) {
			dfs1(g[v][i], c ^ 1, v, h + 1);
			eul.push_back(h);
		}
}

void build() {
	for (long long i = 0; i < (long long)eul.size(); ++i)
		sp[0][i] = eul[i];
	for (long long k = 1; k < 22; ++k)
		for (long long i = 0; i < (long long)eul.size(); ++i)
			sp[k][i] = min(sp[k - 1][i], sp[k - 1][min(i + (1ll << (k - 1)), (long long)eul.size() - 1)]);
}

long long get(long long l, long long r) {
	if (r < l)
		swap(l, r);
	return min(sp[logg[r - l + 1]][l], sp[logg[r - l + 1]][r - (1 << logg[r - l + 1]) + 1]);
}

long long dist(long long l, long long r) {
	return eul[tin[l]] + eul[tin[r]] - 2 * get(tin[l], tin[r]);
}


bool dfs(long long v, long long c) {
	if (used2[v] == c)
		return false;
	used2[v] = c;
	for (long long i = 0; i < (long long)v2.size(); ++i) {
		if (dist(v2[i], v) > d)
			continue;
		if (mt[v2[i]] == -1) {
			mt[v2[i]] = v;
			return true;
		}
	}
	for (long long i = 0; i < (long long)v2.size(); ++i) {
		if (dist(v2[i], v) > d)
			continue;
		if (dfs(mt[v2[i]], c)) {
			mt[v2[i]] = v;
			return true;
		}
	}
	return false;
}


int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> d;

	g.resize(n);
	logg.resize(3 * n + 1, 0);
	for (long long i = 2; i <= 3 * n; ++i)
		logg[i] = logg[i / 2] + 1;
	tin.resize(n);
	used.resize(n, 0);
	used2.resize(n, -1);
	mt.resize(n, -1);

	for (long long i = 0; i < n - 1; ++i) {
		long long a, b;
		cin >> a >> b;
		--a;
		--b;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	dfs1(0, 0, 0, 0);
	sp.resize(22, vector<long long>((long long)eul.size()));
	build();

	for (long long i = 0; i < n; ++i) {
		if (used[i] == 0)
			continue;
		dfs(i, i);
	}

	vector<pair<long long, long long>> ans;

	for (long long i = 0; i < n; ++i)
		if (mt[i] != -1)
			ans.push_back({ mt[i] + 1, i + 1 });

	cout << ans.size() << '\n';
	for (long long i = 0; i < (long long)ans.size(); ++i)
		cout << ans[i].first << ' ' << ans[i].second << '\n';
	return 0;
}
