#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using ll = long long;
#define emp emplace_back
#define nl '\n'
#define pll pair<ll, ll>
#define ss second
#define ff first
#define pii pair<int, int>
#define m_p make_pair
#define all(x) x.begin(), x.end()

using namespace std;

const ll INF = 1e18;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

vector<ll> tree;

void update(ll v, ll lv, ll rv, ll i, ll x) {
    if (rv <= i || i < lv) {
        return;
    }
    if (lv + 1 == rv) {
        tree[v] = min(tree[v], x);
        return;
    }
    ll m = (lv + rv) / 2;
    update(2 * v + 1, lv, m, i, x);
    update(2 * v + 2, m, rv, i, x);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

ll get(ll v, ll lv, ll rv, ll l, ll r) {
    if (rv <= l || r <= lv) {
        return INF;
    }
    if (l <= lv && rv <= r) {
        return tree[v];
    }
    ll m = (lv + rv) / 2;
    return min(get(2 * v + 1, lv, m, l, r), get(2 * v + 2, m, rv, l, r));
}

void solve() {
    tree.clear();
    ll n, k;
    cin >> n >> k;
    vector<pll> a(k);
    vector<pll> p;
    for (ll i = 0; i < k; ++i) {
        ll l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, r};
        p.emp(m, i);
    }
    sort(all(p));
    tree.resize(4 * (n + 1), INF);
    update(0, 0, n + 1, 0, 0);
    for (ll i = 0; i < k; ++i) {
        auto [l, r] = a[p[i].ss];
        ll m = p[i].ff;
        ll g1 = get(0, 0, n + 1, l - 1, m);
        ll g2 = get(0, 0, n + 1, m, r + 1);
        if (g1 != INF || g2 < l) {
            update(0, 0, n + 1, r, m);
        }
    }
    if (get(0, 0, n + 1, n, n + 1) != INF) {
        cout << "YES";
    }
    else {
        cout << "NO";
    }
}

int main() {
#ifdef LOCAL
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    cin >> tpk;

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef LOCAL
    cout << clock() - time1 << " ms";
#endif
}