#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using ll = long long;
#define emp emplace_back
#define nl '\n'
#define pll pair<ll, ll>
#define ss second
#define ff first
#define pii pair<int, int>
#define m_p make_pair
#define all(x) x.begin(), x.end()

using namespace std;

const ll INF = 1e18;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

ll n;
vector<vector<ll>> g;
vector<vector<ll>> col;

void dfs(ll u, ll c, ll p = -1) {
    col[c].emp(u);
    for (auto v : g[u]) {
        if (v == p) {
            continue;
        }
        dfs(v, 1 - c, u);
    }
}

void solve() {
    cin >> n;
    ll d;
    cin >> d;
    g.resize(n);
    col.resize(2);
    vector<vector<ll>> dist(n, vector<ll> (n, INF));
    for (ll i = 0; i < n; ++i) {
        dist[i][i] = 0;
    }
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].emp(v);
        g[v].emp(u);
        dist[u][v] = 1;
        dist[v][u] = 1;
    }
    dfs(0, 0);
    for (ll k = 0; k < n; ++k) {
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < n; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    sort(all(col[0]));
    vector<pll> ans;
    do {
        sort(all(col[1]));
        do {
            vector<pll> cur;
            for (ll i = 0; i < min((ll)col[1].size(), (ll)col[0].size()); ++i) {
                if (dist[col[0][i]][col[1][i]] <= d) {
                    cur.emp(col[0][i], col[1][i]);
                }
            }
            if ((ll)cur.size() > (ll)ans.size()) {
                swap(cur, ans);
            }
        } while (next_permutation(all(col[1])));
    } while (next_permutation(all(col[0])));
    cout << (ll)ans.size() << nl;
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << nl;
    }
}

int main() {
#ifdef LOCAL
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef LOCAL
    cout << clock() - time1 << " ms";
#endif
}