#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

using ll = long long;
#define emp emplace_back
#define nl '\n'
#define pll pair<ll, ll>
#define ss second
#define ff first
#define pii pair<int, int>
#define m_p make_pair
#define all(x) x.begin(), x.end()

using namespace std;

const ll INF = 1e18;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

int n;
vector<vector<int>> g;
vector<vector<int>> col;
vector<int> mt, used;

void dfs(int u, int c, int p = -1) {
    col[c].emp(u);
    for (auto v : g[u]) {
        if (v == p) {
            continue;
        }
        dfs(v, 1 - c, u);
    }
}

bool calc(int u) {
    used[u] = 1;
    for (auto v : g[u]) {
        if (mt[v] == -1) {
            mt[v] = u;
            return true;
        }
    }
    for (auto v : g[u]) {
        if (!used[mt[v]] && calc(mt[v])) {
            mt[v] = u;
            return true;
        }
    }
    return false;
}

void solve() {
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    col.resize(2);
    mt.resize(n, -1);
    used.resize(n);
    vector<vector<int>> dist(n, vector<int> (n, 1e9));
    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
    }
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].emp(v);
        g[v].emp(u);
        dist[u][v] = 1;
        dist[v][u] = 1;
    }
    dfs(0, 0);
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    g.clear();
    g.resize(n);
    for (auto u : col[0]) {
        for (auto v : col[1]) {
            if (dist[u][v] <= d) {
                g[u].emp(v);
                g[v].emp(u);
            }
        }
    }
    for (auto u : col[0]) {
        used.assign(n, 0);
        calc(u);
    }
    vector<pll> ans;
    for (ll i = 0; i < n; ++i) {
        if (mt[i] == -1) continue;
        ll u = mt[i];
        ans.emp(u + 1, i + 1);
    }
    cout << (ll)ans.size() << nl;
    for (auto [x, y] : ans) {
        cout << x << ' ' << y << nl;
    }
}

int main() {
#ifdef LOCAL
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef LOCAL
    cout << clock() - time1 << " ms";
#endif
}