#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using ll = long long;
using ld = long double;
using namespace std;
int INF = 1e9;
void update(int v, int vl, int vr, int pos, int x, vector<int>&tree) {
    if (vl == vr -1) {
        tree[v] = min(x, tree[v]);
        return;
    }
    int vm = (vl + vr)/2;
    if (pos < vm) {
        update(v * 2, vl, vm, pos, x, tree);
    } else {
        update(v * 2 + 1, vm, vr, pos, x, tree);
    }
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}
int get(int v, int vl, int vr, int ql, int qr, vector<int>&tree) {
    if (vl == ql && vr == qr) {
        return tree[v];
    }
    int vm = (vl + vr)/2;
    if (qr <= vm) {
        return get(v * 2, vl, vm, ql, qr, tree);
    } else if (ql >= vm) {
        return get(v * 2 + 1, vm, vr, ql, qr, tree);
    } else {
        return min(get(v * 2, vl, vm, ql, vm, tree), get(v * 2 + 1, vm, vr, vm, qr, tree));
    }
}
int get_ans(int v, int vl, int vr, vector<int>&tree) {
    if (vl == vr -1) {
        return tree[v];
    }
    int vm = (vl + vr)/2;
    return get_ans(v * 2 + 1, vm, vr, tree);
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<vector<pair<int, int>>>seg(n+1);
        int l, r, m;
        for (int i = 0; i < k; i++) {
            cin >> l >> m >> r;
            seg[r].push_back({m, l});
        }
        vector<int>dp(4 * (n+1), INF);
        for (int i = 0; i <= n; i++) {
            for (const auto& [s, l_i] : seg[i]) {
                if (l_i == 1) {
                    update(1, 0, n + 1, i, s, dp);
                    continue;
                }
                bool ok = false;
                int q1 = get(1, 0, n+1, l_i - 1, s, dp);
                int q2 = get(1, 0, n+1, s, i + 1, dp);
                if (q1 != INF || q2 < l_i) {
                    update(1, 0, n + 1, i, s, dp);
                }
            }
        }
        if (get_ans(1, 0, n+1, dp) != INF) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}
