#include <bits/stdc++.h>

using namespace std;

struct SegmentTree {
    int sz;
    vector<int> tree;
    SegmentTree(int n): sz(n), tree(4*n, n) {}
    void add(int i, int x) {
        _add(0, 0, sz-1, i, x);
    }
    void _add(int v, int l, int r, int i, int x) {
        tree[v] = min(tree[v], x);
        if (l==r) return;
        int mid = (l+r)/2;
        if (i<=mid) _add(2*v+1, l, mid, i, x);
        else _add(2*v+2, mid+1, r, i, x);
    }
    int get(int l, int r) {
        return _get(0, 0, sz-1, l, r);
    }
    int _get(int v, int l, int r, int L, int R) {
        if (r<L || R<l) return sz;
        if (L<=l && r<=R) return tree[v];
        int mid = (l+r)/2;
        return min(_get(2*v+1, l, mid, L, R), _get(2*v+2, mid+1, r, L, R));
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> lst(n+1);
    for (int i = 0; i < k; ++i) {
        int l, m, r; cin >> l >> m >> r;
        lst[m].emplace_back(l, r);
    }
    SegmentTree tree(n+1);
    vector<int> dp(n+1);
    for (int i = 1; i <= n; ++i) {
        dp[i] = dp[i-1];
        for (auto [l, r] : lst[i]) {
            if (l==1) {
                tree.add(r, i);
                dp[i]=max(dp[i], r);
                continue;
            }
            bool ok = (tree.get(l-1, r-1)<l) || (tree.get(l-1, i-1)<i);
            if (ok) {
                tree.add(r, i);
                dp[i]=max(dp[i], r);
            }
        }
    }
    cout << (dp[n]==n?"YES":"NO") << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t; cin >> t;
    while (t--) solve();

    return 0;
}