#include <bits/stdc++.h>

using namespace std;

struct MergeSortTree {
    int sz;
    vector<vector<int>> tree;
    MergeSortTree(int n): sz(n), tree(4*n) {}
    void add(int i, int x) {
        _add(0, 0, sz, i, x);
    }
    void _add(int v, int l, int r, int i, int x) {
        if (r-l==1) {
            tree[v].emplace_back(x);
            return;
        }
        int mid = (l+r)/2;
        if (i<mid) _add(2*v+1, l, mid, i, x);
        else _add(2*v+2, mid, r, i, x);
    }
    void _build(int v) {
        tree[v].insert(tree[v].end(), tree[2*v+1].begin(), tree[2*v+1].end());
        tree[v].insert(tree[v].end(), tree[2*v+2].begin(), tree[2*v+2].end());
        sort(tree[v].begin(), tree[v].end());
    }
    void create(int i) {
        _create(0, 0, sz, i);
    }
    void _create(int v, int l, int r, int i) {
        if (r-l==1) {
            sort(tree[v].begin(), tree[v].end());
            return;
        }
        int mid = (l+r)/2;
        if (i<mid) _create(2*v+1, l, mid, i);
        else _create(2*v+2, mid, r, i);
        if (i==r-1) _build(v);
    }
    int get(int r, int x) {
        return _get(0, 0, sz, r, x);
    }
    int _count(int v, int x) {
        int L = -1, R = tree[v].size();
        while (R-L > 1) {
            int M = (L+R)/2;
            if (tree[v][M]<x) L = M;
            else R = M;
        }
        return R;
    }
    int _get(int v, int l, int r, int R, int x) {
        //cout << "_get(" << v << ", " << l << ", " << r << ", " << R << ", " << x << ")" << endl;
        if (r<=R+1) return _count(v, x);
        if (l>R) return 0;
        int mid = (l+r)/2;
        return _get(2*v+1, l, mid, R, x)+_get(2*v+2, mid, r, R, x);
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<pair<int, int>>> lst(n+1);
    for (int i = 0; i < k; ++i) {
        int l, m, r; cin >> l >> m >> r;
        lst[m].emplace_back(l, r);
    }
    MergeSortTree tree(n+1);
    vector<int> dp(n+1);
    for (int i = 1; i <= n; ++i) {
        tree.create(i-1);
        dp[i] = dp[i-1];
        for (auto [l, r] : lst[i]) {
            if (l==1) {
                tree.add(i, r);
                dp[i]=max(dp[i], r);
                continue;
            }
            //cout << "Here" << endl;
            int cnt1 = tree.get(l-1, r)-tree.get(l-1, i-1);
            //cout << "cnt1 = " << cnt1 << endl;
            int cnt2 = tree.get(i-1, i)-tree.get(i-1, l-1);
            //cout << "cnt2 = " << cnt1 << endl;
            if (cnt1 || cnt2) {
                tree.add(i, r);
                dp[i]=max(dp[i], r);
                break;
            }
        }
        //cout << i << ' ' << dp[i] << endl;
    }
    cout << (dp[n]==n?"YES":"NO") << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--) solve();


    return 0;
}