#include <bits/stdc++.h>

using namespace std;

struct Node {
    int64_t a, b, c, d;
    int64_t x;
    bool operator<(const Node& other) const {
        return x<other.x;
    }
};

struct Function {
    vector<Node> nodes;
    void add(int64_t a, int64_t b, int64_t c, int64_t d, int64_t x) {
        nodes.emplace_back(a, b, c, d, x);
    }
    void construct() {
        sort(nodes.begin(), nodes.end());
        int64_t carA = 0, carB = 0, carC = 0, carD = 0;
        for (int64_t i = 0; i < nodes.size(); ++i) {
            carD += nodes[i].d;
            nodes[i].d = carD-nodes[i].d;
        }
        for (int64_t i = nodes.size()-1; i >= 0; --i) {
            carA += nodes[i].a;
            carB += nodes[i].b;
            carC += nodes[i].c;
            nodes[i].a = carA;
            nodes[i].b = carB;
            nodes[i].c = carC;
        }
        nodes.emplace_back(0, 0, 0, carD, INT32_MAX);
    }
    int64_t get(int64_t x) {
        int64_t L = -1, R = nodes.size()-1;
        while (R-L > 1) {
            int64_t M = (L+R)/2;
            if (nodes[M].x<=x) L = M;
            else R = M;
        }
        return nodes[R].a*x*x+nodes[R].b*x+nodes[R].c+nodes[R].d;
    }
};

int64_t calc(Function& f, int64_t t) {
    int64_t L = 0, R = 1e9;
    while (R-L > 1) {
        int64_t M1 = (L+R)/2;
        int64_t M2 = M1+1;
        int64_t val1 = f.get(M1)+M1*t;
        int64_t val2 = f.get(M2)+M2*t;
        if (val1<=val2) R = M1;
        else L = M2;
    }
    return min(f.get(L)+L*t, f.get(R)+R*t);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int64_t n; cin >> n;
    vector<int64_t> x(n);
    for (int64_t i = 0; i < n; ++i) cin >> x[i];
    int64_t x0, d; cin >> x0 >> d;
    for (int64_t i = 0; i < n; ++i) x[i]-=x0;
    sort(x.begin(), x.end());
    Function f1, f2;
    for (auto xi : x) {
        if (xi<0) {
            xi = -xi;
            int64_t id = xi/d;
            int64_t dist = xi%d;
            if (dist>(d-dist)) {++id; dist = d-dist;}
            f1.add(d*d, -2*d*xi, xi*xi, dist*dist, id);
        } else {
            int64_t id = xi/d;
            int64_t dist = xi%d;
            if (dist>(d-dist)) {++id; dist = d-dist;}
            f2.add(d*d, -2*d*xi, xi*xi, dist*dist, id);
        }
    }
    f1.construct();
    f2.construct();
    int m; cin >> m;
    while (m--) {
        int64_t t; cin >> t;
        int64_t ans = min(calc(f1, t)+calc(f2, 2*t), calc(f1, 2*t)+calc(f2, t));
        cout << ans << '\n';
    }

    return 0;
}