#include <bits/stdc++.h>

using namespace std;

struct Node {
    int64_t a, b, c, d;
    int64_t x;
    bool operator<(const Node& other) const {
        return x<other.x;
    }
};

struct Function {
    vector<Node> nodes;
    void add(int64_t a, int64_t b, int64_t c, int64_t d, int64_t x) {
        nodes.emplace_back(a, b, c, d, x);
    }
    void construct() {
        sort(nodes.begin(), nodes.end());
        int64_t carA = 0, carB = 0, carC = 0, carD = 0;
        for (int64_t i = 0; i < nodes.size(); ++i) {
            carD += nodes[i].d;
            nodes[i].d = carD-nodes[i].d;
        }
        for (int64_t i = nodes.size()-1; i >= 0; --i) {
            carA += nodes[i].a;
            carB += nodes[i].b;
            carC += nodes[i].c;
            nodes[i].a = carA;
            nodes[i].b = carB;
            nodes[i].c = carC+nodes[i].d;
            nodes[i].d = 0;
        }
        nodes.emplace_back(0, 0, carD, 0, INT32_MAX);
    }
    int64_t get(int64_t x, int64_t t)  {
        if (x<0) return INT64_MAX;
        int64_t L = -1, R = nodes.size()-1;
        while (R-L > 1) {
            int64_t M = (L+R)/2;
            if (nodes[M].x<=x) L = M;
            else R = M;
        }
        return nodes[R].a*x*x+(nodes[R].b+t)*x+nodes[R].c;
    }
    int64_t calc(int64_t t) {
        if (nodes.size()==1) return 0;
        if (t==0) return nodes.back().c;
        int64_t v1 = min(nodes[0].c, nodes.back().c+t*nodes[nodes.size()-2].x);
        int64_t L = 0, R = nodes.size()-2;
        while (R-L > 1) {
            int64_t M = (L+R)/2;
            long double xm = -(long double)(nodes[M].b+t)/(2*nodes[M].a);
            if (xm>=nodes[M].x) L = M;
            else R = M;
        }
        long double xm = -(long double)(nodes[L].b+t)/(2*nodes[L].a);
        v1 = min(v1, get((int64_t)xm, t));
        v1 = min(v1, get((int64_t)(xm+1), t));
        v1 = min(v1, get((int64_t)(xm-1), t));
        xm = -(long double)(nodes[R].b+t)/(2*nodes[R].a);
        v1 = min(v1, get((int64_t)xm, t));
        v1 = min(v1, get((int64_t)(xm+1), t));
        v1 = min(v1, get((int64_t)(xm-1), t));
        v1 = min(v1, get(nodes[L].x, t));
        return v1;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int64_t n; cin >> n;
    vector<int64_t> x(n);
    for (int64_t i = 0; i < n; ++i) cin >> x[i];
    int64_t x0, d; cin >> x0 >> d;
    for (int64_t i = 0; i < n; ++i) x[i]-=x0;
    sort(x.begin(), x.end());
    Function f1, f2;
    for (auto xi : x) {
        if (xi<0) {
            xi = -xi;
            int64_t id = xi/d;
            int64_t dist = xi%d;
            if (dist>(d-dist)) {++id; dist = d-dist;}
            f1.add(d*d, -2*d*xi, xi*xi, dist*dist, id);
        } else {
            int64_t id = xi/d;
            int64_t dist = xi%d;
            if (dist>(d-dist)) {++id; dist = d-dist;}
            f2.add(d*d, -2*d*xi, xi*xi, dist*dist, id);
        }
    }
    f1.construct();
    f2.construct();
    int m; cin >> m;
    while (m--) {
        int64_t t; cin >> t;
        int64_t ans = min(f1.calc(t)+f2.calc(2*t), f1.calc(2*t)+f2.calc(t));
        cout << ans << '\n';
    }

    return 0;
}