#include <bits/stdc++.h>

using namespace std;

struct Node {
    int64_t a, b, c, d;
    int64_t x;
    bool operator<(const Node& other) const {
        return x<other.x;
    }
};

struct Function {
    vector<Node> nodes;
    void add(int64_t a, int64_t b, int64_t c, int64_t d, int64_t x) {
        nodes.emplace_back(a, b, c, d, x);
    }
    void construct() {
        sort(nodes.begin(), nodes.end());
        int64_t carA = 0, carB = 0, carC = 0, carD = 0;
        for (int64_t i = 0; i < nodes.size(); ++i) {
            carD += nodes[i].d;
            nodes[i].d = carD-nodes[i].d;
        }
        for (int64_t i = nodes.size()-1; i >= 0; --i) {
            carA += nodes[i].a;
            carB += nodes[i].b;
            carC += nodes[i].c;
            nodes[i].a = carA;
            nodes[i].b = carB;
            nodes[i].c = carC+nodes[i].d;
            nodes[i].d = 0;
        }
        nodes.emplace_back(0, 0, carD, 0, INT32_MAX);
        vector<Node> n; n.emplace_back(nodes[0]);
        for (int i = 1; i < nodes.size(); ++i) if (nodes[i].x>nodes[i-1].x) n.emplace_back(nodes[i]);
        nodes.swap(n);
    }
    int64_t get(int64_t x, int64_t t)  {
        if (x<0) return INT64_MAX;
        int64_t L = -1, R = nodes.size()-1;
        while (R-L > 1) {
            int64_t M = (L+R)/2;
            if (nodes[M].x<=x) L = M;
            else R = M;
        }
        return nodes[R].a*x*x+(nodes[R].b+t)*x+nodes[R].c;
    }
    int64_t calc(int64_t t) {
        if (nodes.size()==1) return 0;
        if (t==0) return nodes.back().c;
        int64_t v1 = min(nodes[0].c, nodes.back().c+t*nodes[nodes.size()-2].x);
        int64_t L = -1, R = nodes.size()-1;
        while (R-L > 1) {
            int64_t M = (L+R)/2;
            int64_t dy = 2*nodes[M].a*nodes[M].x+nodes[M].b+t;
            if (dy<0) L = M;
            else R = M;
        }
        int64_t id = R;
        L = 0, R = nodes[id].x;
        if (id>0) L = nodes[id-1].x;
        while (R-L > 1) {
            int64_t M1 = (L+R)/2;
            int64_t M2 = M1+1;
            int64_t val1 = nodes[id].a*M1*M1+(nodes[id].b+t)*M1+nodes[id].c;
            int64_t val2 = nodes[id].a*M2*M2+(nodes[id].b+t)*M2+nodes[id].c;
            if (val1<=val2) R = M1;
            else L = M2;
        }
        return min(v1, min(nodes[id].a*L*L+(nodes[id].b+t)*L+nodes[id].c,
                               nodes[id].a*R*R+(nodes[id].b+t)*R+nodes[id].c));
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int64_t n; cin >> n;
    vector<int64_t> x(n);
    for (int64_t i = 0; i < n; ++i) cin >> x[i];
    int64_t x0, d; cin >> x0 >> d;
    for (int64_t i = 0; i < n; ++i) x[i]-=x0;
    sort(x.begin(), x.end());
    Function f1, f2;
    for (auto xi : x) {
        if (xi<0) {
            xi = -xi;
            int64_t id = xi/d;
            int64_t dist = xi%d;
            if (dist>(d-dist)) {++id; dist = d-dist;}
            f1.add(d*d, -2*d*xi, xi*xi, dist*dist, id);
        } else {
            int64_t id = xi/d;
            int64_t dist = xi%d;
            if (dist>(d-dist)) {++id; dist = d-dist;}
            f2.add(d*d, -2*d*xi, xi*xi, dist*dist, id);
        }
    }
    f1.construct();
    f2.construct();
    int m; cin >> m;
    while (m--) {
        int64_t t; cin >> t;
        int64_t ans = min(f1.calc(t)+f2.calc(2*t), f1.calc(2*t)+f2.calc(t));
        cout << ans << '\n';
    }

    return 0;
}