#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

void dfs1(int p, int v, int d, vector<vector<int>>& tree, vector<bool>& used, vector<vector<int>>& graph) {
    used[v] = true;
    if (d%2==0) graph[p].emplace_back(v);
    if (d==0) return;
    for (auto u : tree[v]) {
        if (used[u]) continue;
        dfs1(p, u, d-1, tree, used, graph);
    }
}

void dfs2(int v, vector<vector<int>>& graph, vector<int>& col) {
    for (auto u : graph[v]) {
        if (col[u]==0) {
            col[u] = 3-col[v];
            dfs2(u, graph, col);
        }
    }
}

bool dfs3(int v, int fr, vector<int>& from, vector<vector<int>>& graph, vector<int>& used, int c) {
    used[v] = c;
    if (from[v] == -1) {
        from[v] = fr;
        return true;
    }
    for (auto u : graph[from[v]]) {
        if (u==v) continue;
        if (used[u]!=c && dfs3(u, from[v], from, graph, used, c)) {
            from[v] = fr;
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n; cin >> n;
    int d; cin >> d;
    vector<vector<int>> tree(n);
    for (int i = 0; i < n-1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        tree[u].emplace_back(v);
        tree[v].emplace_back(u);
    }
    vector<vector<int>> graph(n);
    vector<int> col(n);
    for (int i = 0; i < n; ++i) {
        if (col[i]==0) {
            col[i] = 1;
            dfs2(i, tree, col);
        }
    }
    for (int i = 0; i < n; ++i) --col[i];
    vector<int> cid(n);
    vector<int> arr1, arr2;
    int i1 = 0, i2 = 0;
    for (int i = 0; i < n; ++i) {
        if (col[i]==0) {cid[i]=i1++; arr1.emplace_back(i);}
        else {cid[i]=i2++; arr2.emplace_back(i);}
    }
    vector<vector<int>> bing(i1);
    for (int i = 0; i < n; ++i) {
        if (col[i]==0) {
            vector<bool> used(n, false);
            dfs1(i, i, d, tree, used, graph);
            for (auto j : graph[i]) bing[cid[i]].emplace_back(cid[j]);
        }
    }
    vector<int> from(i2, -1);
    vector<int> used(i2, -1); int c = 0;
    int ans = 0;
    for (int i = 0; i < i1; ++i) {
        for (auto u : bing[i]) {
            if (dfs3(u, i, from, bing, used, c)) {++ans; break;}
        }
        ++c;
    }
    cout << ans << '\n';
    for (int i = 0; i < i2; ++i) {
        if (from[i]==-1) continue;
        cout << arr1[from[i]]+1 << ' ' << arr2[i]+1 << '\n';
    }

    return 0;
}