#pragma GCC optimize("O3")
#pragma target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cout << setprecision(20) << fixed;

    int t = 1; cin >> t;
    while (t--) solve();
}

const int OPEN = 1, START = 0, CLOSE = -1;

struct Event {
    int tp, x, id;
    Event() {}
    Event(int tp, int x, int id) : tp(tp), x(x), id(id) {}
};

bool comp(Event a, Event b) {
    return a.x < b.x || (a.x == b.x && a.tp > b.tp);
}

struct Seg {
    int l, m, r;
    Seg() {}
};

vector<vector<int> > g;
vector<int> used, p, cycle;
int cycle1 = 0;

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            p[u] = v;
            dfs(u);
        } else if (used[u] == 1) {
            cycle1 = 1;
            int cur = v;
            while (cur != u) {
                cycle[cur] = 1;
                cur = p[cur];
            }
            cycle[u] = 1;
        }
    }
    used[v] = 2;
}

void dfs2(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs2(u);
        }
    }
}

void solve() {
    int n, k; cin >> n >> k;
    vector<Seg> seg(k);
    vector<int> cnt1(n + 2);
    for (int i = 0 ; i < k; i++) {
        cin >> seg[i].l >> seg[i].m >> seg[i].r;
        cnt1[seg[i].l]++;
        cnt1[seg[i].r + 1]--;
    }
    vector<int> pref1(n + 1);
    int cur_cnt = 0;
    for (int i = 1; i <= n; i++) {
        cur_cnt += cnt1[i];
        pref1[i] = pref1[i - 1];
        if (cur_cnt == 1) pref1[i]++;
    }

    vector<int> a;
    for (int i = 0; i < k; i++) {
        if (pref1[seg[i].r] - pref1[seg[i].l - 1] > 0) a.push_back(i);
    }

    vector<Event> e;
    for (int i = 0 ; i < a.size(); i++) {
        e.push_back(Event(OPEN, seg[a[i]].l, a[i]));
        e.push_back(Event(START, seg[a[i]].m, a[i]));
        e.push_back(Event(CLOSE, seg[a[i]].r, a[i]));
    }
    sort(all(e), comp);

    g.assign(k, vector<int> (0));

    set<int> cur;
    for (auto [tp, x, id] : e) {
        if (tp == OPEN) {
            cur.insert(id);
        }
        if (tp == CLOSE) cur.erase(id);
        if (tp == START) {
            for (auto i : cur) {
                if (seg[i].l < seg[id].l || (seg[i].l >= seg[id].l && seg[id].r < seg[i].r)) {
                    g[id].push_back(i);
                }
            }
        }
    }

    used.assign(k, 0);
    p.assign(k, 0);
    cycle.assign(k, 0);
    cycle1 = 0;
    for (int i = 0; i < k; i++) {
        if (!used[i]) dfs(i);
    }

    if (cycle1) {
        cout << "NO\n";
        return;
    }

    e.clear();
    for (int i = 0 ; i < k; i++) {
        e.push_back(Event(OPEN, seg[i].l, i));
        e.push_back(Event(START, seg[i].m, i));
        e.push_back(Event(CLOSE, seg[i].r, i));
    }

    sort(all(e), comp);
    g.assign(k, vector<int> (0));
    cur.clear();

    for (auto [tp, x, id] : e) {
        if (tp == OPEN) {
            cur.insert(id);
        }
        if (tp == CLOSE) {
            cur.erase(id);
            for (auto i : cur) {
                if (seg[i].m > seg[id].r || seg[id].m < seg[i].l) {
                    g[i].push_back(id);
                    g[id].push_back(i);
                }
            }
        }
    }

    used.assign(k, 0);
    for (int i = 0; i < k; i++) {
        if (seg[i].l == 1 && !used[i]) {
            dfs2(i);
        }
    }

    for (int i = 0; i < k; i++) {
        if (seg[i].r == n && used[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";

}

/*
1
 12 3
 1 5 9
 1 8 9
 7 8 12

 12 4
 1 4 5
 4 5 9
 4 8 9
 7 8 12

 7 3
 3 4 6
 1 3 4
 4 5 7
*/