#pragma GCC optimize("O3")
#pragma target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cout << setprecision(20) << fixed;

    int t = 1; cin >> t;
    while (t--) solve();
}

const int OPEN = 1, START = 0, CLOSE = -1;

struct Event {
    int tp, x, id;
    Event() {}
    Event(int tp, int x, int id) : tp(tp), x(x), id(id) {}
};

bool comp(Event a, Event b) {
    return a.x < b.x || (a.x == b.x && a.tp > b.tp);
}

struct Seg {
    int l, m, r;
    Seg() {}
};

vector<vector<int> > g;
vector<int> used;
int cycle = 0;

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) dfs(u);
        else if (used[u] == 1) {
            cycle = 1;
        }
    }
    used[v] = 2;
}

void solve() {
    int n, k; cin >> n >> k;
    vector<Seg> seg(k);
    vector<Event> e;
    for (int i = 0 ; i < k; i++) {
        cin >> seg[i].l >> seg[i].m >> seg[i].r;
        e.push_back(Event(OPEN, seg[i].l, i));
        e.push_back(Event(START, seg[i].m, i));
        e.push_back(Event(CLOSE, seg[i].r, i));
    }
    sort(all(e), comp);

    if (e[0].x != 1 || e.back().x != n) {
        cout << "NO\n";
        return;
    }

    g.assign(k, vector<int> (0));

    set<int> cur;
    for (auto [tp, x, id] : e) {
        if (tp == OPEN) cur.insert(id);
        if (tp == CLOSE) cur.erase(id);
        if (tp == START) {
            for (auto i : cur) {
                if (seg[i].l < seg[id].l || (seg[i].l >= seg[id].l && seg[id].r < seg[i].r)) {
                    g[id].push_back(i);
                }
            }
        }
    }

    used.assign(k, 0);
    cycle = 0;
    for (int i = 0; i < k; i++) {
        if (!used[i]) dfs(i);
    }

    if (cycle) cout << "NO\n";
    else cout << "YES\n";
}