#pragma GCC optimize("O3")
#pragma target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cout << setprecision(20) << fixed;

    int t = 1; cin >> t;
    while (t--) solve();
}

const int OPEN = 1, CLOSE = -1;

struct Event {
    int tp, x, id;
    Event() {}
    Event(int tp, int x, int id) : tp(tp), x(x), id(id) {}
};

bool comp(Event a, Event b) {
    return a.x < b.x || (a.x == b.x && a.tp > b.tp);
}

struct Seg {
    int l, m, r;
    Seg() {}
};

vector<vector<int> > g;
vector<int> used;

void dfs2(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs2(u);
        }
    }
}

void solve() {
    int n, k; cin >> n >> k;
    vector<Seg> seg(k);
    for (int i = 0 ; i < k; i++) {
        cin >> seg[i].l >> seg[i].m >> seg[i].r;
    }

    vector<Event> e;
    for (int i = 0 ; i < k; i++) {
        e.push_back(Event(OPEN, seg[i].l, i));
        e.push_back(Event(CLOSE, seg[i].r, i));
    }

    sort(all(e), comp);
    g.assign(k, vector<int> (0));
    set<int> cur;

    for (auto [tp, x, id] : e) {
        if (tp == OPEN) {
            cur.insert(id);
        }
        if (tp == CLOSE) {
            cur.erase(id);
            for (auto i : cur) {
                if (seg[id].l > seg[i].l) {
                    if (seg[i].m > seg[id].r || seg[id].m < seg[i].l) {
                        g[id].push_back(i);
                        g[i].push_back(id);
                    }
                }
            }
        }
    }

    used.assign(k, 0);
    for (int i = 0; i < k; i++) {
        if (seg[i].l == 1 && !used[i]) {
            dfs2(i);
        }
    }

    for (int i = 0; i < k; i++) {
        if (seg[i].r == n && used[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";

}

/*
4
 12 3
 1 5 9
 1 8 9
 7 8 12

 12 4
 1 4 5
 4 5 9
 4 8 9
 7 8 12

 7 3
 3 4 6
 1 3 4
 4 5 7

 18 6
 1 4 6
 3 4 7
 3 4 7
 3 14 15
 12 14 18
 12 17 18

 13 3
 1 2 4
 3 8 9
 9 11 13

*/