#include <bits/stdc++.h>

using namespace std;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
//
// using namespace __gnu_pbds;
//
// #define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define int long long

#define x first
#define y second

int inf = 1e9;

struct SegTree {
    vector<int> v;

    int merge(int a, int b) {
        return min(a, b);
    }

    void build2(int ind, int l, int r, vector<int>& v2) {
        if (l + 1 == r) {
            v[ind] = v2[l];
            return ;
        }
        int mid = (l + r) / 2;
        build2(2 * ind + 1, l, mid, v2);
        build2(2 * ind + 2, mid, r, v2);
        v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
    }

    void build(vector<int>& v2) {
        int n = v2.size();
        v.resize(4 * n);
        build2(0, 0, n, v2);
    }

    void update(int ind, int l, int r, int x, int zn) {
        if (l + 1 == r) {
            v[ind] = min(zn, v[ind]);
            return;
        }
        int mid = (l + r) / 2;
        if (x < mid) {
            update(2 * ind + 1, l, mid, x, zn);
        }else {
            update(2 * ind + 2, mid, r, x, zn);
        }
        v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
    }

    int getmin(int ind, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return v[ind];
        }
        if (r <= ql || qr <= l) {
            return inf;
        }
        int mid = (l + r) / 2;
        return merge(getmin(2 * ind + 1, l, mid, ql, qr),
            getmin(2 * ind + 2, mid, r, ql, qr));
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, pair<int, int>>> v(k);
    for (auto& i : v) {
        cin >> i.y.x >> i.x >> i.y.y;
    }
    SegTree t;
    vector<int> v2(n + 2, inf);
    v2[0] = 0;
    t.build(v2);
    sort(v.begin(), v.end());
    for (auto& i : v) {
        int h = t.getmin(0, 0, v2.size(), i.y.x - 1, i.y.y + 1);
        int h2 = t.getmin(0, 0, v2.size(), i.y.x - 1, i.x);
        if (h < i.y.x) {
            t.update(0, 0, v2.size(), i.y.y, i.x);
        }
        if (h2 < inf) {
            t.update(0, 0, v2.size(), i.y.y, i.x);
        }
    }
    int h = t.getmin(0, 0, v2.size(), n, n + 1);
    if (h < inf) {
        cout << "YES\n";
    }else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}