//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define int long long

using namespace std;
const int K = 20;
const int N = 30000;

vector<vector<int>> g;
vector<int> a, b;
vector<int> h;
int binup[K][N];

void dfs(int v, int t = 0, int p = -1) {
    if (t == 0) a.push_back(v);
    else b.push_back(v);
    for (int u : g[v]) {
        if (u != p) {
            binup[0][u] = v;
            h[u] = h[v] + 1;
            dfs(u, t ^ 1, v);
        }
    }
}

int go_on_k(int v, int k) {
    for (int i = 0; i < K; ++i) {
        if (k & (1 << i)) v = binup[i][v];
    }
    return v;
}

int get_lca(int v, int u) {
    v = go_on_k(v, max(0ll, h[v] - h[u]));
    u = go_on_k(u, max(0ll, h[u] - h[v]));
    if (v == u) return v;
    for (int i = K - 1; i >= 0; --i) {
        if (binup[i][v] != binup[i][u]) {
            v = binup[i][v];
            u = binup[i][u];
        }
    }
    return binup[0][v];
}

vector<int> neib;
bool kuhn(int v) {
    for (int u : g[v]) {
        if (neib[u] == -1) {
            neib[u] = v;
            return true;
        }
    }
    for (int u : g[v]) {
        if (kuhn(neib[u])) return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    int d;
    cin >> d;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    h.resize(n);
    dfs(0);
    for (int i = 0; i < K - 1; ++i) {
        for (int j = 0; j < n; ++j) {
            binup[i + 1][j] = binup[i][binup[i][j]];
        }
    }
    g.assign(n, {});
    for (int v : a) {
        for (int u : b) {
            int lca = get_lca(v, u);
            if (h[v] + h[u] - 2 * h[lca] <= d) {
                g[v].push_back(u);
            }
        }
    }
    neib.resize(n, -1);
    int cnt = 0;
    for (int v : a) {
        if (kuhn(v)) ++cnt;
    }
    cout << cnt << "\n";
    for (int i = 0; i < n; ++i) {
        if (neib[i] != -1) {
            cout << neib[i] + 1 << " " << i + 1 << "\n";
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
