#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct Person {
    int l, m, r;
};

const ll INF = 1e18;

ll near_left(ll x0, ll d, ll x) {
    if (x0 > x) {
        return x0 - d * ((x0 - x + d - 1) / d);
    } else {
        return x0 + d * ((x - x0) / d);
    }
}

ll near_right(ll x0, ll d, ll x) {
    if (x0 > x) {
        return x0 - d * ((x0 - x) / d);
    } else {
        return x0 + d * ((x - x0 + d - 1) / d);
    }
}


void solve() {
    int n;
    cin >> n;
    vector<ll> targets(n);
    for (auto &x : targets) {
        cin >> x;
    }
    ll x0, d;
    cin >> x0 >> d;

    int m;
    cin >> m;

    sort(targets.begin(), targets.end());

    map<ll, ll> ans;
    while (m--) {
        ll t;
        cin >> t;
        if (ans.find(t) != ans.end()) {
            cout << ans[t] << "\n";
            continue;
        }

        ll l1 = near_left(x0, d, 0);
        ll r1 = near_right(x0, d, max(targets[0], x0));

        ll res = LLONG_MAX;
        for (ll i = l1; i <= r1; i += d) {
            res = min(res, abs(i - x0) / d * t + (i - targets[0]) * (i - targets[0]));
        }
        ans[t] = res;
        cout << res << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}