#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> graph;
vector<vector<ll>> dist;

void dfs(ll v, ll start, ll p=-1) {
    for (auto x : graph[v]) {
        if (x == p) continue;
        dist[start][x] = dist[start][v] + 1;
        dfs(x, start, v);
    }
}

vector<pair<ll, ll>> best;
vector<pair<ll, ll>> now;
vector<bool> used;

ll n, d;
void brute(ll i) {
    if (now.size() > best.size()) {
        best = now;
    }
    if (i == n + 1) {
        return;
    }
    bool found = false;

    if (used[i]) {
        return brute(i + 1);
    }

    for (ll j = 1; j <= n; ++j) {
        if (i == j) continue;
        if (used[j]) continue;
        if (dist[i][j] % 2 == 1 && dist[i][j] <= d) {
            used[i] = true;
            used[j] = true;
            now.push_back({i, j});
            brute(i + 1);
            now.pop_back();
            used[i] = false;
            used[j] = false;
        }
    }
}

void solve() {
    cin >> n;
    cin >> d;
    used.resize(n + 1);
    dist.assign(n + 1, vector<ll>(n + 1));
    graph.resize(n + 1);
    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    for (ll i = 1; i <= n; ++i) {
        dist[i][i] = 0;
        dfs(i, i);
    }

    brute(1);

    cout << best.size() << "\n";
    for (auto x : best) {
        cout << x.first << " " << x.second << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}