#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset((x), 0, sizeof(x))
#define lolfill1(x, v) fill((x), (x) + sizeof(x) / sizeof(*(x)), v)
#define lolfill2(x, v) fill(*(x), *(x) + sizeof(x) / sizeof(**(x)), v)
#define lolfill3(x, v) fill(**(x), **(x) + sizeof(x) / sizeof(***(x)), v)
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}




#ifdef DEBUG
const int MAXN = 57, INF = 1e6;
#else
#define cerr if (0) cerr
const int MAXN = 5e5 + 10, INF = 1e9 + 228 * 1e4;
#endif


struct Seg {
    int l, m, r;
    bool in(int p) {
        return p >= l && p <= r;
    }
};
bool operator<(Seg s1, Seg s2) { return s1.r < s2.r; }
bool connect(Seg s1, Seg s2) {
    return !s2.in(s1.m) || !s1.in(s2.m);
}


struct StMin {
    int t[2 * MAXN];
    int n;
    void init(int n_) {
        n = n_;
        fill(t, t + 2 * n, INF);
    }
    void setmin(int i, int x) {
        for (i += n; i > 0; i >>= 1)
            smin(t[i], x);
    }
    int get(int l, int r) {
        int ans = INF;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                smin(ans, t[l]);
                l++;
            }
            if (r & 1) {
                r--;
                smin(ans, t[r]);
            }
        }
        return ans;
    }
} st_minm, st_minl;


signed one() {
    int n, k;
    cin >> n >> k;
    vector<Seg> segs(k);
    for (Seg &s : segs) {
        cin >> s.l >> s.m >> s.r;
    }
    sort(allv(segs));
    st_minm.init(n + 1);
    st_minl.init(n + 1);
    for (int i = 0; i < k; i++) {
        bool dpi = false;
        if (segs[i].l == 1) {
            dpi = true;
        } else {
            int minm = st_minm.get(segs[i].l - 1, segs[i].r + 1);
            int minl = st_minl.get(segs[i].l - 1, segs[i].m);
            dpi = (minm < segs[i].l || minl < segs[i].l);
        }
        if (dpi) {
            st_minm.setmin(segs[i].r, segs[i].m);
            st_minl.setmin(segs[i].r, segs[i].l);
        }
        if (dpi && segs[i].r == n) {
            cout << "YES\n";
            return 0;
        }
    }
    cout << "NO\n";
    return 0;
}


signed main() {
    int t;
    cin >> t;
    while (t--) {
        signed retcode = one();
        if (retcode) return retcode;
    }
    return 0;
}
