#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
#include <cassert>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset((x), 0, sizeof(x))
#define lolfill1(x, v) fill((x), (x) + sizeof(x) / sizeof(*(x)), v)
#define lolfill2(x, v) fill(*(x), *(x) + sizeof(x) / sizeof(**(x)), v)
#define lolfill3(x, v) fill(**(x), **(x) + sizeof(x) / sizeof(***(x)), v)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}




#ifdef DEBUG
const int MAXN = 0, INF = 1e6;
#else
#define cerr if (0) cerr
const int MAXN = 0, INF = 1e9 + 228 * 1e4;
#endif

inline ll sq(ll x) { return x * x; }
vector<__int128> pref1, pref2, pref_mn;
ll n;


__int128 sum_sq(ll x, ll l, ll r) {
    return (pref2[r] - pref2[l]) + (__int128)(r - l) * sq(x) - 2 * x * (pref1[r] - pref1[l]);
}

void precalc_half(vector<ll> &xs, ll d) {
    int n = sz(xs);
    if (!n) return;
    pref1.clear();
    pref2.clear();
    pref_mn.clear();
    pref1.resize(n + 1, 0);
    pref2.resize(n + 1, 0);
    ll maxx = *max_element(allv(xs));
    pref_mn.resize(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        pref1[i + 1] = pref1[i] + xs[i];
        pref2[i + 1] = pref2[i] + xs[i] * xs[i];
        pref_mn[i + 1] = pref_mn[i] + sq(min(xs[i] % d, d - xs[i] % d));
    }
}


ll one_half(vector<ll> xs, ll d, ll t) {
    int n = sz(xs);
    if (!n) return 0;
    __int128 ans = 5e18; ans *= ans;
    for (ll x = 0, i = 0; x <= xs.back() + d; x += d) {
        while (i < n && xs[i] < x)
            i++;
        smin(ans, pref_mn[i] + sum_sq(x, i, n) + (x / d) * t);
    }
    assert(ans < 9e18);
    return ans;
}


signed main() {
    int n;
    cin >> n;
    vector<ll> xs(n);
    for (ll &i : xs) cin >> i;
    sort(allv(xs));
    ll x0, d; cin >> x0 >> d;
    int m; cin >> m;
    vector<ll> ans1(m, 0), ans2(m, 0);
    vector<ll> ts(m);
    for (int i = 0; i < m; i++) {
        cin >> ts[i];
    }


    int im = lower_bound(allv(xs), x0) - xs.begin();
    vector<ll> xs1(xs.begin(), xs.begin() + im), xs2(xs.begin() + im, xs.end());
    reverse(allv(xs1));
    for (ll &xi : xs1)
        xi = x0 - xi;
    for (ll & xi : xs2)
        xi = xi - x0;

    precalc_half(xs1, d);
    for (int i = 0; i < m; i++) {
        ans1[i] += one_half(xs1, d, 2 * ts[i]);
        ans2[i] += one_half(xs1, d, ts[i]);
    }
    precalc_half(xs2, d);
    for (int i = 0; i < m; i++) {
        ans1[i] += one_half(xs2, d, ts[i]);
        ans2[i] += one_half(xs2, d, 2 * ts[i]);
        cout << min(ans1[i], ans2[i]) << '\n';
    }
    return 0;
}
