#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
#include <cassert>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset((x), 0, sizeof(x))
#define lolfill1(x, v) fill((x), (x) + sizeof(x) / sizeof(*(x)), v)
#define lolfill2(x, v) fill(*(x), *(x) + sizeof(x) / sizeof(**(x)), v)
#define lolfill3(x, v) fill(**(x), **(x) + sizeof(x) / sizeof(***(x)), v)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}




#ifdef DEBUG
const int MAXN = 0, INF = 1e6;
#else
#define cerr if (0) cerr
const int MAXN = 0, INF = 5e18 + 228 * 1e4;
#endif

inline ll sq(ll x) { return x * x; }
vector<__int128> pref1, pref2, pref_mn;
ll n;


__int128 sum_sq(ll x, ll l, ll r) {
    return (pref2[r] - pref2[l]) + (__int128)(r - l) * sq(x) - 2 * x * (pref1[r] - pref1[l]);
}

void precalc_half(vector<ll> &xs, ll d) {
    int n = sz(xs);
    if (!n) return;
    pref1.clear();
    pref2.clear();
    pref_mn.clear();
    pref1.resize(n + 1, 0);
    pref2.resize(n + 1, 0);
    ll maxx = *max_element(allv(xs));
    pref_mn.resize(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        pref1[i + 1] = pref1[i] + xs[i];
        pref2[i + 1] = pref2[i] + xs[i] * xs[i];
        pref_mn[i + 1] = pref_mn[i] + sq(min(xs[i] % d, d - xs[i] % d));
    }
}


struct Line {
     ll k;
     __int128 b;
     __int128 get(ll x) { return b + (__int128)k * x; }
};

__int128 div_floor(__int128 a, __int128 b) {
    if (b < 0)
        a = -a, b = -b;
    if (a < 0)
        return -((-a + b - 1) / b);
    else
        return (a) / b;
}


struct Cht {
    vector<ll> p;
    vector<Line> ls;
    void add(Line l0) {
        while (!ls.empty() && l0.get(p.back()) <= ls.back().get(p.back())) {
            ls.pop_back();
            p.pop_back();
        }
        ll inters;
        if (ls.empty())
            inters = INF;
        else
            inters = div_floor(l0.b - ls.back().b, ls.back().k - l0.k);
        p.push_back(inters);
        ls.push_back(l0);
    }
    __int128 get(ll x) {
        if (p.empty())
            return 0;
        int i = upper_bound(allv(p), x, greater<>()) - p.begin();
        i--;
        return ls[i].get(x);
    }
};


Cht one_half(vector<ll> xs, ll d) {
    int n = sz(xs);
    Cht cht;
    if (!n) return cht;
    for (ll x = 0, i = 0; x <= xs.back() + d; x += d) {
        while (i < n && xs[i] < x)
            i++;
        cht.add(Line{x / d, pref_mn[i] + sum_sq(x, i, n)});
    }
    return cht;
}


signed main() {
    int n;
    cin >> n;
    vector<ll> xs(n);
    for (ll &i : xs) cin >> i;
    sort(allv(xs));
    ll x0, d; cin >> x0 >> d;
    int m; cin >> m;

    int im = lower_bound(allv(xs), x0) - xs.begin();
    vector<ll> xs1(xs.begin(), xs.begin() + im), xs2(xs.begin() + im, xs.end());
    reverse(allv(xs1));
    for (ll &xi : xs1)
        xi = x0 - xi;
    for (ll & xi : xs2)
        xi = xi - x0;

    precalc_half(xs1, d);
    Cht cht1 = one_half(xs1, d);
    precalc_half(xs2, d);
    Cht cht2 = one_half(xs2, d);
    while (m--) {
        ll t; cin >> t;
        __int128 ans1 = cht1.get(2 * t) + cht2.get(t);
        __int128 ans2 = cht1.get(t) + cht2.get(2 * t);

        cout << (ll)min(ans1, ans2) << '\n';
    }
    return 0;
}
