#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <utility>
#include <algorithm>
#include <random>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset((x), 0, sizeof(x))
#define lolfill1(x, v) fill((x), (x) + sizeof(x) / sizeof(*(x)), v)
#define lolfill2(x, v) fill(*(x), *(x) + sizeof(x) / sizeof(**(x)), v)
#define lolfill3(x, v) fill(**(x), **(x) + sizeof(x) / sizeof(***(x)), v)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
void append_vec(vector<T> &a, vector<T> const& b) {
    a.resize(sz(a) + sz(b));
    copy(allv(b), a.end() - sz(b));
}



#ifdef DEBUG
const int MAXN = 57, INF = 1e6;
#else
#define cerr if (0) cerr
const int MAXN = 210, INF = 1e9 + 228 * 1e4;
#endif


vector<int> g[MAXN];
int d;
int dist[MAXN][MAXN];


void dfs(int v, int par, int cur_dist, int rt) {
    dist[rt][v] = cur_dist;
    for (int u : g[v]) {
        if (u == par) continue;
        dfs(u, v, cur_dist + 1, rt);
    }
}

vector<int> gpair[MAXN];
int mt[MAXN];
int used[MAXN];
int usedver = -1;
bool kuhn(int v) {
    used[v] = usedver;
    for (int u : gpair[v]) {
        if (mt[u] == v) continue;
        if (mt[u] == -1) {
            mt[u] = v;
            return true;
        }
        if (used[mt[u]] < usedver && kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}


signed main() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 1; i <= n; i++) {
        dfs(i, -1, 0, i);
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (j != i && dist[i][j] <= d && dist[i][j] % 2 == 1)
                gpair[i].push_back(j);
        }
    }
    lolfill1(mt, -1);
    for (int i = 1; i <= n; i++) {
        if (dist[1][i] % 2 == 1) continue;
        usedver++;
        kuhn(i);
    }
    vector<pii> ans;
    for (int i = 1; i <= n; i++) {
        if (mt[i] != -1) {
            ans.push_back({i, mt[i]});
        }
    }
    cout << sz(ans) << '\n';
    for (auto [u, v] : ans)
        cout << u << ' ' << v << '\n';
    return 0;
}
