#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-prtotector")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct Q {
    int l, m, r;
    int i;
};

bool cmp(Q a, Q b) {
    return (a.l < b.l);
}

bool ok(Q a, Q b) {
    int l = b.l;
    int r = a.r;
    return (a.r <= b.r && (b.m > r));
}

struct cmp_m {
    bool operator() (Q a, Q b) const {
        return (a.m < b.m || (a.m == b.m && a.i < b.i));
    }
};


struct cmp_r {
    bool operator() (Q a, Q b) const {
        return (a.r > b.r || (a.r == b.r && a.i < b.i));
    }
};

struct segtree {
    int sz;
    vector<int> tree;

    void init(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1, 0);
    }

    void add(int i, int v) {
        add(i, v, 0, 0, sz);
    }

    void add(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] += v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            add(i, v, 2 * x + 1, lx, m);
        }
        else {
            add(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int l, int r) {
        return get(l, r, 0, 0, sz);
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (rx <= l || lx >= r) {
            return 0;
        }
        if (l <= lx && r >= rx) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        return get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx);
    }
};



void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<Q> a(k);
        for (int i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            a[i].i = i;
        }
        sort(all(a), cmp);
        vector<int> dp(n + 1, 0);
        dp[0] = 1;
        vector<bool> can(k, false);
        segtree less_m;
        less_m.init(n + 1000);
        multiset<Q, cmp_m> tmp;
        multiset<Q, cmp_r> greater;
        less_m.add(0, 1);
        for (int i = 0; i < k; i++) {
            while (!tmp.empty() && tmp.begin()->m < a[i].l) {
                less_m.add(tmp.begin()->r, 1);
                greater.erase(greater.find(*tmp.begin()));
                tmp.erase(tmp.begin());
            }
            bool cur_can = (less_m.get(a[i].l - 1, a[i].r + 1));
            // int mx = a[i].r;
            // for (int j = 0; j < i; j++) {
            //     if (a[j].m >= a[i].l && can[j]) {
            //         mx = min(mx, a[j].r);
            //     }
            // }
            if (!greater.empty()) {
                cur_can |= (greater.begin()->r < a[i].m);
            }
            // cur_can |= (mx < a[i].m);
            // cout << i << ' ' << cur_can << '\n';
            can[i] = cur_can;
            if (cur_can) {
                tmp.insert(a[i]);
                greater.insert(a[i]);
                dp[a[i].r] = true;
            }
        }
        cout << (dp[n] ? "YES" : "NO") << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;

    solve();

    return 0;
}