#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back

const int INF = 1e18 + 7, MOD = 1e9 + 7, N = 5e5 + 100;

vector<int> tree(4 * N, INF);

void upd(int l, int r, int p, int x, int v = 0) {
    if (l == r) {
        tree[v] = min(x, tree[v]);
        return;
    }
    int m = (l + r) / 2;
    if (p <= m) {
        upd(l, m, p, x, 2 * v + 1);
    } else {
        upd(m + 1, r, p, x, 2 * v + 2);
    }
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int l, int r, int ql, int qr, int v = 0) {
    if (l <= ql && qr <= r) {
        return tree[v];
    }
    if (l > qr || r < ql) {
        return INF;
    }
    int m = (ql + qr) / 2;
    return min(get(l, r, ql, m, 2 * v + 1), get(l, r, m + 1, qr, 2 * v + 2));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        for (int i = 0; i < 4 * (n + 2); ++i) {
            tree[i] = INF;
        }
        vector<vector<int>> a;
        for (int i = 0; i < k; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            l--;
            r--;
            m--;
            a.pb({l, m, r});
        }
        sort(a.begin(), a.end());
        for (auto it : a) {
            int l = it[0], r = it[2], m = it[1];
            if (l == 0) {
                upd(0, n - 1, r, m);
                continue;
            }
            int u = get(l - 1, r, 0, n - 1);
            if (u < l) {
                upd(0, n - 1, r, max(u, m));
            }
            u = get(l - 1, m - 1, 0, n - 1);
            if (u != INF) {
                upd(0, n - 1, r, m);
            }
        }
        int v = get(n - 1, n - 1, 0, n - 1);
        if (v != INF) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}