#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

struct segtree {
    ll n;
    vector<ll> t;

    segtree() {}

    segtree(vector<ll>& a) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n - 1, a);
    }

    void build(ll v, ll tl, ll tr, vector<ll> & a) {
        if (tl == tr) {
            t[v] = a[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(2 * v +1, tl, tm, a);
        build(2 * v + 2, tm + 1, tr, a);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return INF;
        }
        ll tm = (tl + tr) / 2;
        return min(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
    }

    void upd(ll val, ll idx, ll v, ll tl, ll tr) {
        if (tl == tr && tl == idx) {
            t[v] = min(t[v], val);
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        ll tm = (tl + tr) / 2;
        upd(val, idx, 2 * v + 1, tl, tm);
        upd(val, idx, 2 * v + 2, tm + 1, tr);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get(ll l, ll r) {
        if (l > r) return INF;
        return get(0, 0, n - 1, l, r);
    }

    void upd(ll val, ll idx) {
        upd(val, idx, 0, 0, n - 1);
    }
};
void solve() {
    ll n, k; cin >> n >> k;
    vector<vector<ll>> a(k), b(k);
    for (int i = 0; i < k; i++) {
        ll l, m, r; cin >> l >> m >> r;
        a[i] = {l, m, r};
        b[i] = {r, -l, m};
    }
    sort(b.begin(), b.end());
    vector<ll> dp(n + 1, INF);
    dp[0] = -INF;
    segtree t(dp);
    for (int i = 0; i < k; i++) {
        ll l = -b[i][1], m = b[i][2], r = b[i][0];
        // for (int j = m - 1; j >= l - 1; j--) {
        //     if (dp[j] != INF) {
        //         dp[r] = min(dp[r], m);
        //     }
        // }
        if (t.get(l - 1, m - 1) != INF) {
            t.upd(m, r);
        }
        // for (int j = m; j <= r; j++) {
        //     if (dp[j] < l) {
        //         dp[r] = min(dp[r], m);
        //     }
        // }
        if (t.get(m, r) < l) {
            t.upd(m, r);
        }
    }
    if (t.get(n, n) != INF) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }

    return 0;
}
