#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int INF = 1e9;

struct segtree {
    int n;
    vector<int> t;

    segtree() {}

    segtree(vector<int>& a) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n - 1, a);
    }

    void build(int v, int tl, int tr, vector<int> & a) {
        if (tl == tr) {
            t[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(2 * v +1, tl, tm, a);
        build(2 * v + 2, tm + 1, tr, a);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return INF;
        }
        int tm = (tl + tr) / 2;
        return min(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
    }

    void upd(int val, int idx, int v, int tl, int tr) {
        if (tl == tr && tl == idx) {
            t[v] = min(t[v], val);
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        int tm = (tl + tr) / 2;
        upd(val, idx, 2 * v + 1, tl, tm);
        upd(val, idx, 2 * v + 2, tm + 1, tr);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    int get(int l, int r) {
        if (l > r) return INF;
        return get(0, 0, n - 1, l, r);
    }

    void upd(int val, int idx) {
        upd(val, idx, 0, 0, n - 1);
    }
};
void solve() {
    int n, k; cin >> n >> k;
    vector<vector<int>> a(k), b(k);
    for (int i = 0; i < k; i++) {
        int l, m, r; cin >> l >> m >> r;
        a[i] = {l, m, r};
        b[i] = {r, -l, m};
    }
    sort(b.begin(), b.end());
    vector<int> dp(n + 1, INF);
    dp[0] = -INF;
    segtree t(dp);
    for (int i = 0; i < k; i++) {
        int l = -b[i][1], m = b[i][2], r = b[i][0];
        if (t.get(l - 1, m - 1) != INF) {
            t.upd(m, r);
        }
        if (t.get(m, r) < l) {
            t.upd(m, r);
        }
    }
    if (t.get(n, n) != INF) {
        cout << "YES" << '\n';
    } else {
        cout << "NO" << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int tst; cin >> tst;
    while (tst--) {
        solve();
    }

    return 0;
}
