#include <bits/stdc++.h>
using namespace std;
typedef __int128 ll;

const ll N = 3e5 + 5;
const ll INF = 2e18;

struct segtree {
    ll n;
    vector<ll> t;

    segtree() {}

    segtree(vector<ll>& a) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n - 1, a);
    }

    void build(ll v, ll tl, ll tr, vector<ll> & a) {
        if (tl == tr) {
            t[v] = a[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(2 * v +1, tl, tm, a);
        build(2 * v + 2, tm + 1, tr, a);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (tr < l || r < tl) {
            return INF;
        }
        ll tm = (tl + tr) / 2;
        return min(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
    }

    void upd(ll val, ll idx, ll v, ll tl, ll tr) {
        if (tl == tr && tl == idx) {
            t[v] = min(t[v], val);
            return;
        }
        if (tr < idx || idx < tl) {
            return;
        }
        ll tm = (tl + tr) / 2;
        upd(val, idx, 2 * v + 1, tl, tm);
        upd(val, idx, 2 * v + 2, tm + 1, tr);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get(ll l, ll r) {
        if (l > r) return INF;
        return get(0, 0, n - 1, l, r);
    }

    void upd(ll val, ll idx) {
        upd(val, idx, 0, 0, n - 1);
    }
};

vector<ll> x;
ll pref[N], pref_sq[N];
ll good[N];
ll n, x0, d, q;

ll f(ll t, ll dst) {
    ll X = x0 + dst * d;
    // cout << (long long)X << '\n';
    ll i = lower_bound(x.begin(), x.end(), X) - x.begin() + 1;
    // cout << (long long)i << '\n';
    ll sum = pref[n] - pref[i - 1];
    ll sum_sq = pref_sq[n] - pref_sq[i - 1];
    return (n - (i - 1)) * X * X - 2 * X * sum + sum_sq + dst * t + good[i - 1];
}

void solve() {
    long long inpN; cin >> inpN;
    n = inpN;
    x.resize(n);
    for (int i = 0; i < n; i++) {
        long long inpX; cin >> inpX;
        x[i] = inpX;
    }
    sort(x.begin(), x.end());
    long long inpx0, inpd; cin >> inpx0 >> inpd;
    long long inpq; cin >> inpq;
    x0 = inpx0, d = inpd, q = inpq;

    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + x[i];
        pref_sq[i + 1] = pref_sq[i] + x[i] * x[i];

        ll rem = ((x[i] - x0) % d + d) % d;
        rem = min(rem, d - rem);
        good[i + 1] = good[i] + rem * rem;
        // cout << (long long)(rem * rem) << '\n';
    }
    for (ll i = n + 1; i < N; i++) {
        good[i] = good[i - 1];
    }

    // cout << (long long)f(1, 49) << '\n';
    // exit(0);
    while (q--) {
        long long inpt; cin >> inpt;
        ll t = inpt;

        ll lb = -1, rb = 1e9;
        while (rb - lb > 2) {
            ll mb1 = lb + (rb - lb) / 3;
            ll mb2 = rb - (rb - lb) / 3;
            ll f1 = f(t, mb1);
            ll f2 = f(t, mb2);
            if (f1 < f2) {
                rb = mb2;
            } else {
                lb = mb1;
            }
        }
        ll ans = INF;
        for (ll mb = max((ll)0, lb - 10); mb <= lb + 10; mb++) {
            ans = min(ans, f(t, mb));
        }
        cout << (long long)ans << '\n';
    }

}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }

    return 0;
}
