#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>

using namespace std;

#define int int64_t
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;
using ld = long double;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int((x).size())

int start, d;

int get_closest(int z) {
    ll closest = z / d * d;
    if (abs(z - closest) > abs(z - (closest + d))) {
        closest += d;
    }
    return closest;
}

struct line {
    ll k = 0, b = 1e18;
    ll calc(ll x) const {
        return k * x + b;
    }
};

struct LiChao : vector<line> {
    vector<ll> x;
    int n;
    LiChao(const vector<ll> &_x) {
        x = _x;
        n = sz(x);
        for (int m = 1; m < n || !(n = m); m <<= 1);
        resize(2 * n);
        while (sz(x) < n) x.push_back(0);
        sort(all(x));
    }

    void add(int p, int l, int r, line z) {
        line& v = at(p);
        if (v.k == z.k) {
            v.b = min(v.b, z.b);
            return;
        }
        int m = (l + r) / 2;
        if (z.calc(x[m]) < v.calc(x[m])) {
            std::swap(z, v);
        }
        if (r - l > 1) {
            if (z.k > v.k) {
                add(p * 2, l, m, z);
            }
            else {
                add(p * 2 + 1, m, r, z);
            }
        }
    }
    void add(line z) {
        add(1, 0, n, z);
    }

    ll get(ll q) {
        ll ans = INT64_MAX;
        int i = lower_bound(all(x), q) - x.begin();
        for (int p = i + n; p > 0; p >>= 1) ans = min(ans, at(p).calc(q));
        return ans;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    sort(all(x));
    cin >> start >> d;
    ll c = d - start % d;
    for (auto& z : x) z += c;
    start += c;
    assert(start % d == 0);
    int q;
    cin >> q;
    vector<pii> t(q);
    for (int i = 0; i < q; i++) {
        int z;
        cin >> z;
        t[i] = {z, i};
    }
    vector<ll> ans(q, INT64_MAX);
    ll SZ = max(start, *max_element(all(x))) + 2 * d + 1;
    SZ /= d;
    vector<ll> groups(n);
    vector<ll> pref_z(SZ + 1);
    vector<ll> pref_z2(SZ + 1);
    vector<ll> pref_amounts(SZ + 1);
    int zvzv = 0;
    for (int z : x) {
        int closest = get_closest(z);
        groups[zvzv] += (z - closest) * (z - closest);
        pref_z[closest / d + 1] += z;
        pref_z2[closest / d + 1] += z * z;
        pref_amounts[closest / d + 1]++;
        zvzv++;
    }
    start /= d;
    vector<ll> pref_groups(n + 1);
    for (int i = 1; i <= n; i++) {
        pref_groups[i] = pref_groups[i - 1] + groups[i - 1];
    }
    for (int i = 1; i <= SZ; i++) {
        pref_z[i] += pref_z[i - 1];
        pref_z2[i] += pref_z2[i - 1];
        pref_amounts[i] += pref_amounts[i - 1];
    }
    vector<ll> rights(SZ);
    vector<ll> lefts(SZ);
    for (int l = 0; l <= start; l++) {
        int xr = upper_bound(all(x), start * d + d / 2) - x.begin();
        int xl = lower_bound(all(x), l * d - d / 2) - x.begin();
        ll now_ans = 0;
        now_ans += pref_groups[xr] - pref_groups[xl];
        now_ans -= pref_z[l] * 2 * l * d;
        now_ans += pref_z2[l];
        now_ans += pref_amounts[l] * l * l * d * d;
        lefts[l] = now_ans;
    }
    for (int r = start; r < SZ; r++) {
        int xr = upper_bound(all(x), (r + 1) * d + d / 2) - x.begin();
        int xl = lower_bound(all(x), start * d - d / 2) - x.begin();
        ll now_ans = 0;
        now_ans += pref_groups[xr] - pref_groups[xl];
        now_ans -= (pref_z[SZ] - pref_z[r + 1]) * 2 * r * d;
        now_ans += (pref_z2[SZ] - pref_z2[r + 1]);
        now_ans += (pref_amounts[SZ] - pref_amounts[r + 1]) * r * r * d * d;
        rights[r] = now_ans;
    }

    auto check2 = [&](ll l, ll r, ll f) {
        return (min(start - l, r - start) + r - l) * f + lefts[l] + rights[r];
    };

    auto check = [&](ll l, ll f) {
        ll l_ans = INT64_MAX;
        int left_r = start, right_r = SZ - 1;
        while (right_r - left_r > 2) {
            int m1 = (left_r * 2 + right_r) / 3, m2 = (left_r + right_r * 2) / 3;
            if (check2(l, m1, f) < check2(l, m2, f)) {
                right_r = m2;
            }
            else {
                left_r = m1;
            }
        }
        for (int m = left_r; m <= right_r; m++) {
            l_ans = min(l_ans, check2(l, m, f));
        }
        return l_ans;
    };

    for (auto [f, i] : t) {
        int left_l = 0, right_l = start;
        while (right_l - left_l > 2) {
            int m1 = (left_l * 2 + right_l) / 3, m2 = (left_l + right_l * 2) / 3;
            if (check(m1, f) < check(m2, f)) {
                right_l = m2;
            }
            else {
                left_l = m1;
            }
        }
        for (int m = left_l; m <= right_l; m++) {
            ans[i] = min(ans[i], check(m, f));
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }
}