#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()

using namespace std;

const int INF= 1e9 + 1;
struct seg_tree{
    struct data{
        bool push= 0;
        int num= 0, sum= 0;
    };
    vector<data> tree;
    int n;

    seg_tree(int _n){
        n= _n;
        tree.resize(4*n);
    }

    void update(int v, int tl, int tr){
        tree[v].num= tree[2*v].num + tree[2*v + 1].num;
        tree[v].sum= tree[2*v].sum + tree[2*v + 1].sum;
    }

    void push(int v, int tl, int tr){
        bool psh= tree[v].push; 
        if(psh == 0) return;

        tree[v]= {0, 0, 0};
        if(tl + 1 == tr) return;

        tree[2*v].push= 1;
        tree[2*v + 1].push= 1;
    }

    void add_in(int v, int tl, int tr, int pos, int num){
        push(v, tl, tr);

        if(pos + 1 <= tl || tr <= pos) return;
        if(pos <= tl && tr <= pos + 1){
            tree[v].num+= num;
            tree[v].sum= tree[v].num * pos;
            return;
        }

        int tm= (tl + tr) / 2;
        add_in(2*v, tl, tm, pos, num);
        add_in(2*v + 1, tm, tr, pos, num);

        update(v, tl, tr);
    }

    void make_0_in(int v, int tl, int tr, int ql, int qr){
        push(v, tl, tr);

        if(qr <= tl || tr <= ql) return;
        if(ql <= tl && tr <= qr){
            tree[v].push= 1;
            push(v, tl, tr);
            return;
        }

        int tm= (tl + tr) / 2;
        make_0_in(2*v, tl, tm, ql, qr);
        make_0_in(2*v + 1, tm, tr, ql, qr);

        update(v, tl, tr);
    }

    pair<int, int> get_in(int v, int tl, int tr, int ql, int qr){
        push(v, tl, tr);
        if(qr <= tl || tr <= ql) return {0, 0};
        if(ql <= tl && tr <= qr) return {tree[v].num, tree[v].sum};

        int tm= (tl + tr) / 2;
        auto [lnum, lsum]= get_in(2*v, tl, tm, ql, qr);
        auto [rnum, rsum]= get_in(2*v + 1, tm, tr, ql, qr);

        return {lnum + rnum, lsum + rsum};
    }

    void add(int pos, int num){
        add_in(1, 0, n, pos, num);
    }
    void make_0(int ql, int qr){
        make_0_in(1, 0, n, ql, qr);
    }
    pair<int, int> get(int ql, int qr){
        return get_in(1, 0, n, ql, qr);
    }
};



int main(){
ios_base::sync_with_stdio(0);
cin.tie(0);
    int n, m; cin >> n >> m;

    vector<vector<char>> a(n, vector<char> (m, 0));
    for(int i= 0; i < n; i++){
        for(int j= 0; j < m; j++){
            cin >> a[i][j];
            a[i][j]-= '0';
        }
    }

    if(n > m){
        vector<vector<char>> arr(m, vector<char> (n, 0));
        for(int i= 0; i < n; i++){
            for(int j= 0; j < m; j++){
                arr[j][i]= a[n - 1 - i][m - 1 - j]; 
            }
        }
        
        a= arr;
        swap(n, m);
    }

    int sgn= 0;
    vector<vector<int>> dp(2, vector<int> (m, 0)), up(2, vector<int> (m, 0));

    seg_tree tree(n + 1);
    int ans= 0;
    for(int i= 0; i < n; i++){
        sgn^= 1;
        fill(all(dp[sgn]), 0);
        fill(all(up[sgn]), 0);
        tree.make_0(0, n + 1);

        for(int j= m - 1; j > -1; j--){
            if(a[i][j] == 0){
                up[sgn][j]= 0;
                dp[sgn][j]= 0;
            } else{
                up[sgn][j]= 1 + up[sgn ^ 1][j];
            }

            auto [up_num, up_sum]= tree.get(up[sgn][j] + 1, n + 1);
            tree.make_0(up[sgn][j] + 1, n + 1);
            tree.add(up[sgn][j], up_num + 1);

            dp[sgn][j]= tree.get(0, n + 1).second;
            ans= max(ans, dp[sgn][j]);
        }
    }

    cout << ans;
}