#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

struct segment {
    vector<ll> a, t;
    segment() {}
    segment(const vector<ll> a_) : a(a_) {
        t.resize(4 * a.size());
    }
    void build(ll v, ll l, ll r) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
    ll ask(ll v, ll l, ll r, ll askl, ll askr) {
        if (l >= askl && r <= askr) {
            return t[v];
        } else if (l >= askr || r <= askl) {
            return 0;
        }
        ll m = (l + r) / 2;
        ll t1 = ask(2 * v + 1, l, m, askl, askr);
        ll t2 = ask(2 * v + 2, m, r, askl, askr);
        return max(t1, t2);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll h, w;
    cin >> h >> w;

    vector<vector<ll>> a(h, vector<ll>(w));
    for (int i=0; i<h; ++i) {
        for (int j=0; j<w; ++j) {
            char c; cin >> c;
            a[i][j] = c - '0';
        }
    }

    vector<vector<ll>> dp(h, vector<ll>(w));
    vector<vector<ll>> dp1(h, vector<ll>(w));
    vector<vector<ll>> pref(h, vector<ll>(w));

    for (int j=0; j<w; ++j)
        dp[0][j] = a[0][j];

    for (int j=0; j<w; ++j)
        for (int i=1; i<h; ++i)
            dp[i][j] = (a[i][j]) ? dp[i-1][j] + 1 : 0;

    for (int i=0; i<h; ++i)
        dp1[i][w-1] = a[i][w-1];

    for (int j=w-2; j>=0; --j) {
        for (int i=0; i<h; ++i) {
            dp1[i][j] = (a[i][j]) ? dp1[i][j+1] + 1 : 0;
        }
    }

    for (int i=0; i<h; ++i)
        pref[i][0] = dp[i][0];
    for (int i=0; i<h; ++i)
        for (int j=1; j<w; ++j)
            pref[i][j] = pref[i][j-1] + dp[i][j];

    vector<segment> t;
    t.reserve(h);
    for (int i=0; i<h; ++i) {
        t.push_back(segment(dp[i]));
        t[i].build(0, 0, w);
    }

    ll res = 0;
    for (int i=0; i<h; ++i) {
        for (int j=0; j<w; ++j) {
            if (!a[i][j]) continue;
            ll curres = 0;
            segment tr = t[i];
            ll last = dp1[i][j];
            ll l = j+1, r = j+last;
            while (r - l > 1) {
                ll m = (l + r) / 2;
                ll cur = tr.ask(0, 0, w, j+1, m);
                if (cur >= dp[i][j]) {
                    l = m;
                } else {
                    r = m;
                }
            }
            if (l == w || (l == j+1 && dp[i][l] < dp[i][j])) l--;
            curres = (l - j + 1) * dp[i][j];
            curres += pref[i][j+last-1] - pref[i][l];
            res = max(res, curres);
        }
    }

    cout << res << '\n';

    return 0;
}
















