#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll dist(const ll x, const ll y) {
    return (x - y) * (x - y);
}

ll near(const ll x, const ll d) {
    const ll gg = x / d;
    ll mn = gg;
    if (dist(x, (gg + 1) * d) < dist(x, mn * d)) {
        mn = gg + 1;
    }
    if (dist(x, (gg - 1) * d) < dist(x, mn * d)) {
        mn = gg - 1;
    }
    return mn;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n;
    cin >> n;
    vector<ll> x(n);
    for (ll i = 0; i < n; i++) {
        cin >> x[i];
    }
    ll x0, d;
    cin >> x0 >> d;

    sort(x.begin(), x.end());
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        a[i] = near(x[i] - x0, d);
    }
    vector<ll> dst(n);
    for (ll i = 0; i < n; i++) {
        dst[i] = dist(x[i], x0 + a[i] * d);
    }
    vector<ll> dst_pref(n + 1);
    for (ll i = 1; i <= n; i++) {
        dst_pref[i] = dst_pref[i - 1] + dst[i - 1];
    }

    vector<ll> square(n);
    for (ll i = 0; i < n; i++) {
        square[i] = x[i] * x[i];
    }
    vector<ll> square_pref(n + 1);
    for (ll i = 1; i <= n; i++) {
        square_pref[i] = square_pref[i - 1] + square[i - 1];
    }
    vector<ll> square_suf(n + 1);
    for (ll i = n - 1; i >= 0; i--) {
        square_suf[i] = square_suf[i + 1] + square[i];
    }

    vector<ll> sum(n + 1);
    for (ll i = 1; i <= n; i++) {
        sum[i] = sum[i - 1] + x[i - 1];
    }

    auto foo1 = [&](const ll l, const ll r, ll t) {
        ll ind1 = lower_bound(a.begin(), a.end(), l) - a.begin();
        ll ind2 = upper_bound(a.begin(), a.end(), r) - a.begin();
        ll y1 = x0 + l * d;
        ll y2 = x0 + r * d;
        ll ans = dst_pref[ind2] - dst_pref[ind1];
        ans += y1 * y1 * ind1 + square_pref[ind1] - 2 * y1 * sum[ind1];
        ans += y2 * y2 * (n - ind2) + square_suf[ind2] - 2 * y2 * (sum[n] - sum[ind2]);
        ans += (min(abs(l), abs(r)) + r - l) * t;
        return ans;
    };

    auto foo = [&](const ll m, const ll t) {
        return min(foo1(0, m, t), foo1(-1, m - 2, t));
    };

    ll q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;

        ll l = 0, r = 1e9;
        while (r - l > 5) {
            const ll m1 = (2 * l + r) / 3;
            const ll m2 = (l + 2 * r) / 3;
            if (foo(m1, t) < foo(m2, t)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        ll ans = INT64_MAX;
        for (ll i = l; i <= r; i++) {
            ans = min(ans, foo(i, t));
        }
        cout << ans << '\n';
    }
}
