#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll> > g;
vector<ll> col;
vector<ll> p, tin, tout, deep;

ll timer = 0;

void dfs(const ll v, const ll p, ll c, ll d) {
    tin[v] = timer++;
    col[v] = c;
    deep[v] = d;
    for (const auto &to: g[v]) {
        if (to != p) {
            dfs(to, v, 1 - c, d + 1);
        }
    }
    tout[v] = timer;
}

bool is_parent(ll u, ll v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<ll> par;
vector<ll> used;

bool kun(ll v) {
    used[v] = timer;
    for (auto &to: g[v]) {
        if (used[to] != timer && par[to] == -1) {
            par[to] = v;
            return true;
        }
    }
    for (auto &to: g[v]) {
        if (used[to] != timer && kun(par[to])) {
            par[to] = v;
            return true;
        }
    }
    return false;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    ll d;
    cin >> d;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    col.assign(n, 0);
    p.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    deep.assign(n, 0);
    dfs(0, 0, 0, 0);
    vector<ll> a, b;
    for (ll i = 0; i < n; i++) {
        if (col[i] == 0) {
            a.push_back(i);
        } else {
            b.push_back(i);
        }
    }
    n = a.size();
    const ll m = b.size();
    g.assign(n, {});
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            ll x = a[i];
            while (!is_parent(x, b[j])) {
                x = p[x];
            }
            if (deep[a[i]] + deep[b[j]] - 2 * deep[x] <= d) {
                g[i].push_back(j);
            }
        }
    }
    par.assign(m, -1);
    used.assign(n, -1);
    ll timer = 0;
    for (ll i = 0; i < n; i++) {
        if (kun(i)) {
            timer++;
        }
    }
    vector<pair<ll, ll> > ans;
    for (ll i = 0; i < m; i++) {
        if (par[i] != -1) {
            ans.emplace_back(par[i], i);
        }
    }
    cout << ans.size() << '\n';
    for (auto &i: ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}
