#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll> > g;
vector<ll> col;
vector<ll> pred, tin, tout, deep;

ll timer = 0;

void dfs(const ll v, const ll p, ll c, ll d) {
    tin[v] = timer++;
    col[v] = c;
    deep[v] = d;
    pred[v] = p;

    for (const auto &to: g[v]) {
        if (to != p) {
            dfs(to, v, 1 - c, d + 1);
        }
    }
    tout[v] = timer;
}

bool is_parent(ll u, ll v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<ll> par;
vector<ll> used;

ll timer52 = 0;

bool kun(ll v) {
    used[v] = timer52;
    for (auto &to: g[v]) {
        if (par[to] == -1) {
            par[to] = v;
            return true;
        }
    }
    for (auto &to: g[v]) {
        if (used[par[to]] != timer52 && kun(par[to])) {
            par[to] = v;
            return true;
        }
    }
    return false;
}

ll lca(ll a, ll b) {
    if (is_parent(a, b)) {
        return a;
    }
    if (is_parent(b, a)) {
        return b;
    }
    ll x = a;
    while (!is_parent(x, b)) {
        x = pred[x];
    }
    return x;
}

ll dist(ll a, ll b) {
    ll l = lca(a, b);
    return deep[a] + deep[b] - 2 * deep[l];
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    ll d;
    cin >> d;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    col.assign(n, 0);
    pred.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    deep.assign(n, 0);
    dfs(0, 0, 0, 0);
    vector<ll> a, b;
    for (ll i = 0; i < n; i++) {
        if (col[i] == 0) {
            a.push_back(i);
        } else {
            b.push_back(i);
        }
    }
    n = a.size();
    const ll m = b.size();
    g.assign(n, {});
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (dist(a[i], b[j]) <= d) {
                g[i].push_back(j);
            }
        }
    }
    par.assign(m, -1);
    used.assign(n, -1);
    timer52 = 0;
    for (ll i = 0; i < n; i++) {
        if (kun(i)) {
            timer52++;
        }
    }
    vector<pair<ll, ll> > ans;
    for (ll i = 0; i < m; i++) {
        if (par[i] != -1) {
            ans.emplace_back(a[par[i]], b[i]);
        }
    }
    cout << ans.size() << '\n';
    for (auto &i: ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}
