#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//#define ordered_set tree<int, nullptr, less<int>, rb_tree_tag, tree_order_statistics_node_update>

using namespace std;

typedef int ll;

ll INF = 1e9 + 7;

struct seg_tree {

    vector<ll> d, t;

    ll build(ll v) {
        if (v * 2 >= d.size()) {
            return d[v];
        }
        d[v] = d[v * 2] + d[v * 2 + 1];
    }

    void push(ll v, ll vl, ll vr) {

        if (t[v] == 0) {
            return;
        }

        if (t[v] == -INF) {
            d[v] = 0;
            if (vr - vl > 1) {
                t[v * 2] = -INF;
                t[v * 2 + 1] = -INF;
            }
        } else {
            d[v] += t[v] * (vr - vl);
            if (vr - vl > 1) {
                if (t[v * 2] != -INF) {
                    t[v * 2] += t[v];
                } else {
                    push(v * 2, vl, (vl + vr) / 2);
                    t[v * 2] = t[v];
                }
                if (t[v * 2 + 1] != -INF) {
                    t[v * 2 + 1] += t[v];
                } else {
                    push(v * 2 + 1, (vl + vr) / 2, vr);
                    t[v * 2 + 1] = t[v];
                }            }
        }
        t[v] = 0;
    }

    ll get(ll v, ll vl, ll vr, ll l, ll r) {

        if (vr <= l || vl >= r) {
            return 0;
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return get(v * 2, vl, vm, l, r) + get(v * 2 + 1, vm, vr, l, r);
    }

    ll update(ll v, ll vl, ll vr, ll l, ll r, ll x) {

        push(v, vl, vr);
        if (vr <= l || vl >= r) {
            return d[v];
        }

        if (vl >= l && vr <= r) {
            t[v] = x;
            push(v, vl, vr);
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return d[v] = update(v * 2, vl, vm, l, r, x) + update(v * 2 + 1, vm, vr, l, r, x);
    }};

void solve() {

    ll h, w;
    cin >> h >> w;

    vector<vector<ll>> a(h, vector<ll> (w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            char x;
            cin >> x;
            a[i][j] = x - '0';
        }
    }

    ll c = 1;
    while (c < w) {
        c *= 2;
    }
    vector<ll> d(2 * c, 0), t(2 * c, 0);
    seg_tree st;
    st.d = d, st.t = t;

    vector<vector<ll>> r(h, vector<ll> (w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = w - 1; j >= 0; j--) {
            if (j + 1 < w && a[i][j + 1] == 1) {
                r[i][j] = r[i][j + 1];
            } else {
                r[i][j] = j;
            }
        }
    }

    ll mx = 0;
    for (int i = 0; i < w; i++) {

        st.update(1, 0, c, 0, w, -INF);

        for (int j = 0; j < h; j++) {

            if (a[j][i] == 0) {
                st.update(1, 0, c, 0, w, -INF);
                continue;
            }

            ll rb = r[j][i];
            st.update(1, 0, c, i, rb + 1, 1);
            st.update(1, 0, c, rb + 1, w, -INF);
            mx = max(mx, st.get(1, 0, c, 0, w));
        }
    }
    cout << mx;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}