#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

//#define ordered_set tree<int, nullptr, less<int>, rb_tree_tag, tree_order_statistics_node_update>

using namespace std;

//#pragma GCC optimize("O3")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,bmi,bmi2,mmx,fma,popcnt,lzcnt")

typedef int ll;

ll INF = 1e9 + 7;

struct seg_tree {

    vector<ll> d, t;

    ll build(ll v) {
        if (v * 2 >= d.size()) {
            return d[v];
        }
        return d[v] = build(v * 2) + build(v * 2 + 1);
    }

    void push(ll v, ll vl, ll vr) {

        if (t[v] == 0) {
            return;
        }

        if (t[v] == -INF) {
            d[v] = 0;
            if (vr - vl > 1) {
                t[v * 2] = -INF;
                t[v * 2 + 1] = -INF;
            }
        } else {
            d[v] += t[v] * (vr - vl);
            if (vr - vl > 1) {
                if (t[v * 2] != -INF) {
                    t[v * 2] += t[v];
                } else {
                    push(v * 2, vl, (vl + vr) / 2);
                    t[v * 2] = t[v];
                }
                if (t[v * 2 + 1] != -INF) {
                    t[v * 2 + 1] += t[v];
                } else {
                    push(v * 2 + 1, (vl + vr) / 2, vr);
                    t[v * 2 + 1] = t[v];
                }            }
        }
        t[v] = 0;
    }

    ll get(ll v, ll vl, ll vr, ll l, ll r) {

        if (vr <= l || vl >= r) {
            return 0;
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return get(v * 2, vl, vm, l, r) + get(v * 2 + 1, vm, vr, l, r);
    }

    ll update(ll v, ll vl, ll vr, ll l, ll r, ll x) {

        push(v, vl, vr);
        if (vr <= l || vl >= r) {
            return d[v];
        }

        if (vl >= l && vr <= r) {
            t[v] = x;
            push(v, vl, vr);
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return d[v] = update(v * 2, vl, vm, l, r, x) + update(v * 2 + 1, vm, vr, l, r, x);
    }};

void solve() {

    ll n, k;
    cin >> n >> k;

    seg_tree st;
    ll c = 1;
    while (c < n) {
        c *= 2;
    }
    st.d = vector<ll>(2 * c, 1), st.t = vector<ll>(2 * c, 0);
    st.build(1);

    vector<pair<ll, pair<ll, ll>>> a(k);
    unordered_set<ll> s;
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second.first >> a[i].second.second;
        st.update(1, 0, c, a[i].first - 1, a[i].second.second, -INF);
        s.insert(a[i].first);
    }
    if (st.get(1, 0, c, 0, c) != 0) {
        cout << "NO";
    } else {
        cout << "YES";
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}