#include <bits/stdc++.h>
using namespace std;

using ll = long long;
// #define int ll
int inf = 1e9;

int hs(string s) {
    int r = 0;
    for (auto i: s) {
        r = (r * 47 + i - 'a') % int(1e9 + 7);
    }
    return r;
}

mt19937 rnd(hs("zovzovzov"));

int rand(int l, int r) {
    return l + rnd() % (r - l + 1);
}

double randd() {
    int N = 1'000'000'000;
    return (double) rand(0, N) / N;
}

struct Wrk {
    int l;
    int m;
    int r;

    Wrk() {
    }

    Wrk(int a, int b, int c) {
        l = a;
        m = b;
        r = c;
    }
};

vector<int> used;
vector<Wrk> a;

struct segtree {
    int n;
    vector<int> st;

    segtree(int m) {
        n = m;
        st.resize(n * 4);
    }

    void set(int v, int l, int r, int i, int x) {
        if (l > i || r <= i)
            return;
        if (l + 1 == r) {
            st[v] = max(st[v], x);
            return;
        }
        set(v * 2 + 1, l, (l + r) / 2, i, x);
        set(v * 2 + 2, (l + r) / 2, r, i, x);
        st[v] = max(st[v * 2 + 1], st[v * 2 + 2]);
    }

    void set(int i, int x) {
        set(0, 0, n, i, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql)
            return 0;
        if (l >= ql && r <= qr)
            return st[v];
        return max(
            get(v * 2 + 1, l, (l + r) / 2, ql, qr),
            get(v * 2 + 2, (l + r) / 2, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

struct segtree2 {
    int n;
    vector<int> st;
    vector<int> op;

    segtree2(int m) {
        n = m;
        st.resize(n * 4, inf);
        op.resize(n * 4);
    }

    void push(int v, int l, int r) {
        if (!op[v])
            return;
        st[v] += op[v];
        if (r - l != 1) {
            op[v * 2 + 1] += op[v];
            op[v * 2 + 2] += op[v];
        }
        op[v] = 0;
    }


    void set(int v, int l, int r, int i, int x) {
        push(v, l, r);
        if (l > i || r <= i)
            return;
        if (l + 1 == r) {
            st[v] = min(st[v], x);
            return;
        }
        set(v * 2 + 1, l, (l + r) / 2, i, x);
        set(v * 2 + 2, (l + r) / 2, r, i, x);
        st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
    }

    void set(int i, int x) {
        set(0, 0, n, i, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (l >= qr || r <= ql)
            return inf;
        if (l >= ql && r <= qr)
            return st[v];
        return min(
            get(v * 2 + 1, l, (l + r) / 2, ql, qr),
            get(v * 2 + 2, (l + r) / 2, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    void add(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (l >= qr || r <= ql)
            return;
        if (l >= ql && r <= qr) {
            op[v] += x;
            push(v, l, r);
            return;
        }
        add(v * 2 + 1, l, (l + r) / 2, ql, qr, x);
        add(v * 2 + 2, (l + r) / 2, r, ql, qr, x);
        st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
    }

    void add(int l, int r, int x) {
        add(0, 0, n, l, r, x);
    }
};

segtree2 kek = 501;
int N;

int cnt(vector<Wrk> &a) {
    vector<pair<int, int> > tm;
    for (auto [l, m, r]: a) {
        if (kek.get(m, m + 1) == 0) {
            tm.emplace_back(l, r);
            kek.add(l, r + 1, 1);
        }
    }

    int res = 0;
    for (int i = 1; i < N; i++) {
        res += kek.get(i, i + 1) == 0;
    }
    for (auto [l, r]: tm) {
        kek.add(l, r + 1, -1);
    }
    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    N = n + 1;
    bool flag = false;
    a.resize(k);
    for (auto &[l, m, r]: a) {
        cin >> l >> m >> r;
    }
    for (int i = 1; i <= n; i++) {
        kek.set(i, 0);
    }
    int count = cnt(a);
    double temp = 1;
    double ub = 1.0 / 10000;
    while (temp > 0 && count > 0) {
        int i = rand(0, k - 1);
        int j = rand(0, k - 1);
        swap(a[i], a[j]);
        int c2 = cnt(a);
        if (c2 < count || exp(temp * (c2 - count)) < randd()) {
            count = c2;
        } else {
            swap(a[i], a[j]);
        }
        temp -= ub;
    }
    if (count == 0)
        cout << "YES\n";
    else
        cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
}
