#include <bits/stdc++.h>
using namespace std;

using ll = long long;
// #define int ll
int inf = 1e9;

int hs(string s) {
    int r = 0;
    for (auto i: s) {
        r = (r * 47 + i - 'a') % int(1e9 + 7);
    }
    return r;
}

mt19937 rnd(2281337);

int rand(int l, int r) {
    return l + rnd() % (r - l + 1);
}

double randd() {
    int N = 1'000'000'000;
    return (double) rand(0, N) / N;
}

struct Wrk {
    int l;
    int m;
    int r;

    Wrk() {
    }

    Wrk(int a, int b, int c) {
        l = a;
        m = b;
        r = c;
    }
};

vector<int> used;
vector<Wrk> a;

struct segtree {
    int n;
    vector<int> st;

    segtree(int m) {
        n = m;
        st.resize(n * 4);
    }

    void set(int v, int l, int r, int i, int x) {
        if (l > i || r <= i)
            return;
        if (l + 1 == r) {
            st[v] = max(st[v], x);
            return;
        }
        set(v * 2 + 1, l, (l + r) / 2, i, x);
        set(v * 2 + 2, (l + r) / 2, r, i, x);
        st[v] = max(st[v * 2 + 1], st[v * 2 + 2]);
    }

    void set(int i, int x) {
        set(0, 0, n, i, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql)
            return 0;
        if (l >= ql && r <= qr)
            return st[v];
        return max(
            get(v * 2 + 1, l, (l + r) / 2, ql, qr),
            get(v * 2 + 2, (l + r) / 2, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

struct segtree2 {
    int n;
    vector<int> st;
    vector<int> op;

    segtree2(int m) {
        n = m;
        st.resize(n * 4, inf);
        op.resize(n * 4);
    }

    void push(int v, int l, int r) {
        if (!op[v])
            return;
        st[v] += op[v];
        if (r - l != 1) {
            op[v * 2 + 1] += op[v];
            op[v * 2 + 2] += op[v];
        }
        op[v] = 0;
    }


    void set(int v, int l, int r, int i, int x) {
        push(v, l, r);
        if (l > i || r <= i)
            return;
        if (l + 1 == r) {
            st[v] = min(st[v], x);
            return;
        }
        set(v * 2 + 1, l, (l + r) / 2, i, x);
        set(v * 2 + 2, (l + r) / 2, r, i, x);
        st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
    }

    void set(int i, int x) {
        set(0, 0, n, i, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (l >= qr || r <= ql)
            return inf;
        if (l >= ql && r <= qr)
            return st[v];
        return min(
            get(v * 2 + 1, l, (l + r) / 2, ql, qr),
            get(v * 2 + 2, (l + r) / 2, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    void add(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (l >= qr || r <= ql)
            return;
        if (l >= ql && r <= qr) {
            op[v] += x;
            push(v, l, r);
            return;
        }
        add(v * 2 + 1, l, (l + r) / 2, ql, qr, x);
        add(v * 2 + 2, (l + r) / 2, r, ql, qr, x);
        st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
    }

    void add(int l, int r, int x) {
        add(0, 0, n, l, r, x);
    }
};

/***
 * конструктивы гавно
***/

struct Graph {
    int n;
    vector<vector<int> > g;
    vector<vector<int> > rg;
    vector<int> tsort;
    vector<int> used;
    vector<int> col;
    int tc = 1;

    Graph(int m) {
        n = m;
        g.resize(n + 1);
        used.resize(n + 1);
        col.resize(n + 1);
        rg.resize(n + 1);
    }

    void add_edge(int v, int u) {
        g[v].push_back(u);
        rg[u].push_back(v);
    }

    void tfs(int v) {
        used[v] = 1;
        for (auto u: g[v]) {
            if (!used[u])
                tfs(u);
        }
        tsort.push_back(v);
    }

    void clr(int v, int c) {
        col[v] = c;
        for (auto u: rg[v]) {
            if (!col[u])
                clr(u, c);
        }
    }

    void ts() {
        for (int i = 0; i < n; i++) {
            if (!used[i])
                tfs(i);
        }
        reverse(tsort.begin(), tsort.end());
        for (auto v: tsort) {
            if (!col[v]) {
                clr(v, tc++);
            }
        }
    }
};

void shuffle(vector<Wrk> &a) {
    int cnt = rand(0, a.size() * 2);
    for (int i = 0; i < cnt; i++) {
        int v = rand(1, a.size());
        int u = rand(1, a.size());
        swap(a[v - 1], a[u - 1]);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    Graph g = k;
    a.resize(k);
    vector<vector<pair<int, int> > > go(n + 1);
    for (auto &[l, m, r]: a) {
        cin >> l >> m >> r;
        go[r].emplace_back(l, m);
    }
    bool flag = false;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j)
                continue;
            if (a[i].l <= a[j].m && a[j].m <= a[i].r) {
                g.add_edge(j, i);
            }
        }
    }
    g.ts();
    vector<vector<Wrk> > cl(g.tc);
    for (int i = 0; i < k; i++) {
        cl[g.col[i]].push_back(a[i]);
    }
    for (int _ = 0; _ < 40000; _++) {
        segtree2 st = n + 1;
        st.add(1, n + 1, -inf);
        for (auto &i: cl) {
            for (auto [l, m, r]: i) {
                if (st.get(m, m + 1) == 0) {
                    st.add(l, r + 1, 1);
                }
            }
        }
        if (st.get(1, n + 1) != 0) {
            flag = true;
            break;
        }
        for (auto &i: cl) {
            shuffle(i);
        }
    }
    if (flag)
        cout << "YES\n";
    else
        cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
}
