#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

using namespace std;

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, m; cin >> n >> m;
    vector<vector<bool>> a(n, vector <bool> (m));
    for (auto &arr: a) for (int i = 0; i < m; ++i) {
        char c; cin >> c;
        arr[i] = (c == '1');
    }
    vector <vector<int>> up(n, vector <int> (m, 0));
    for (int j = 0; j < m; ++j) up[0][j] = a[0][j];
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) up[i][j] = 1 + up[i - 1][j];
        }
    }
    vector <vector<int>> neir(n, vector <int> (m, m));
    for (int i = 0; i < n; ++i) {
        set<pair<int, int>> S;
        S.emplace(1e9, m);
        for (int j = m - 1; j >= 0; --j) {
            auto it = S.lower_bound(make_pair(-up[i][j], 1e9));
            if (it->first == -up[i][j]) {
                S.erase(it);
            }
            auto [h, x] = *S.lower_bound(make_pair(-up[i][j], 1e9));
            neir[i][j] = x;
            S.emplace(-up[i][j], j);
        }
    }

    vector <vector<int>> dp(n, vector <int> (m + 1, 0));
    for (int i = 0; i < n; ++i) for (int j = m - 1; j >=0; --j) {
        if (!a[i][j]) continue;
        const int R = neir[i][j];
        int h = up[i][j];
        dp[i][j] = dp[i][R] + h * (R - j);
    }
    int max_s = 0;
    // for (auto arr: neir) {
    //     for (auto el: arr) cout << el << " ";
    //     cout << endl;
    // }
    for (auto &arr: dp) max_s = max(max_s, *max_element(arr.begin(), arr.end()));
    cout << max_s << "\n";
    return 0;
}
