#include <algorithm>
#include <array>
#include <cassert>
#include <functional>
#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>

using namespace std;

void dfs(const int v, vector <vector <int>> &gr, vector <bool> &used) {
  used[v] = true;
  for (auto u: gr[v]) if (!used[u]) dfs(u, gr, used);
}

void solve() {
    int n, k; cin >> n >> k;
    vector <pair<int, int>> lr(k);
    vector <int> m(k);
    for (int i = 0; i < k; ++i) {
        cin >> lr[i].first >> m[i] >> lr[i].second;
        --m[i];
        --lr[i].first;
    }
    vector <vector<int>> gr(n + 1);
    vector <bool> used(n + 1, false);
    for (auto [l, r]: lr) gr[l].push_back(r);
    for (int i = 0; i < k; ++i) for (int j = 0; j < k; ++j) {
        auto [L0, R0] = lr[i];
        auto [L1, R1] = lr[j];
        if (L0 < L1 && L1 <= R0)
            gr[L0].push_back(R1);
    }
    dfs(0, gr, used);
    cout << (used[n] ? "YES" : "NO") << "\n";
}

int main() {
    int T;
    for (cin >> T; T--; solve()) {}
    return 0;
}