//#pragma GCC optimize("Ofast","O3")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
const ll MAXN = 2e5;
const ll MOD = 1e9 + 7;
struct Node {
    ll val;
};
struct nodex {
    ll l,r,val;
};
mt19937 rnd(1);
Node tree[8*MAXN];
void update(ll v,ll vl,ll vr,ll i,ll val) {
    if (vl > i || vr <= i) {
        return;
    }
    if (vl + 1 == vr) {
        tree[v].val = val;
        return;
    }
    ll vm = (vl + vr) / 2;
    update(v*2,vl,vm,i,val);
    update(v*2+1,vm,vr,i,val);
    tree[v].val = min(tree[v*2].val,tree[v*2+1].val);
}
void build(ll v,ll vl,ll vr) {
    if (vl + 1 == vr) {
        tree[v].val = 0;
        return;
    }
    ll vm = (vl + vr) / 2;
    build(v*2,vl,vm);
    build(v*2+1,vm,vr);
    tree[v].val = 0;
}
nodex get(ll v,ll vl,ll vr,ll l,ll r,ll val) {
    if (vl >= r || l >= vr) {
        return {-1,-1,-1};
    }
    if (l <= vl && vr <= r) {
        if (tree[v].val <= val) {
            return {vl,vr,v};
        }
        return {-1,-1,-1};
    }
    ll vm = (vl + vr) / 2;
    nodex x1 = get(v*2,vl,vm,l,r,val);
    nodex x2 = get(v*2+1,vm,vr,l,r,val);
    if (x1.val == -1 && x2.val == -1) {
        return {-1,-1,-1};
    }
    else if (x1.val == -1) {
        return x2;
    }
    else if (x2.val == -1) {
        return x1;
    }
    else {
        if (x1.val < x2.val) {
            return x1;
        }
        return x2;
    }
}
ll getins(ll v,ll vl,ll vr,ll val) {
    if (vl + 1 == vr) {
        return vl;
    }
    ll vm = (vl + vr) / 2;
    if (tree[v*2].val <= val) {
        return getins(v*2,vl,vm,val);
    }
    else {
        return getins(v*2+1,vm,vr,val);
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, l, r;
    cin >> n >> m;
    char arr[n][m];
    ll pref[n][m+1];
    ll ans[n][m+1];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> arr[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m + 1; j++) {
            pref[i][j] = 0;
            ans[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0) {
                pref[i][j] = arr[i][j] - '0';
            } else {
                if (arr[i][j] == '0') {
                    pref[i][j] = 0;
                } else {
                    pref[i][j] = pref[i - 1][j] + 1;
                }
            }
        }
    }
    ll res = 0;
    for (int i = 0; i < n; i++) {
        build(1,0,m+1);
        for (int j = m - 1; j > -1; j--) {
            if (j == m-1) {
                ans[i][j] = pref[i][j];
            }
            else {
                if (pref[i][j] >= pref[i][j+1]) {
                    ans[i][j] = ans[i][j+1] + pref[i][j];
                }
                else {
                    nodex ind = get(1,0,m+1,j+1,m+1,pref[i][j]);
                    ll ind1 = getins(ind.val,ind.l,ind.r,pref[i][j]);
                    ans[i][j] = ans[i][ind1] + (ind1-j) * pref[i][j];
                }
            }
            update(1,0,m+1,j,pref[i][j]);
            res = max(res,ans[i][j]);
        }
    }
    cout << res << "\n";
}