#include <iostream>
#include <vector>
#include <algorithm>

#define int ll

using namespace std;
using ll = long long;

struct dude{
    int l, m, r;
};

istream & operator >> (istream &in, dude &x){
    return in >> x.l >> x.m >> x.r;
}

void solve_sorted(int n, int k){
    vector<int> delta(n + 1);
    while(k--){
        int l, r, m;
        cin >> l >> m >> r;
        l--;
        delta[l]++;
        delta[r]--;
    }
    int d = 0;
    for(int i = 0; i < n; i++){
        d += delta[i];
        if(d <= 0){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

void solve_square(int n, int k){
    vector<dude> a(k);
    for(auto &d : a){
        cin >> d;
        d.l--; d.m--;
    }
    a.push_back({-1, -1, 0});
    k++;
    sort(a.begin(), a.end(), [&](dude a, dude b){
        return a.l < b.l || (a.l == b.l && a.m < b.m);
    });
    vector<bool> dp(k);
    dp[0] = true;
    for(int i = 1; i < k; i++){
        for(int j = 0; j < i; j++){
            if(a[i].l <= a[j].r && (a[j].r <= a[i].m || a[j].m <= a[i].l)){
                dp[i] = dp[i] | dp[j];
            }
        }
    }
    for(int i = 1; i < k; i++){
        if(dp[i] && a[i].r == n){
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
    return;
}

void solve(){
    int n, k;
    cin >> n >> k;
    solve_square(n, k);
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // freopen("input.txt", "r", stdin);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}