#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#pragma GCC optimize("03")

#define int ll
  
using namespace std;
using ll = long long;
  
struct dude{
    int l, m, r, i;
};

bool operator<(dude a, dude b){
    return a.l < b.l;
}

istream & operator >> (istream &in, dude &x){
    return in >> x.l >> x.m >> x.r;
}
  
bool gen(int n, int k, vector<dude> &a, vector<bool> &used, vector<int> &cur){
    bool flag = true;
    for(int i = 0; i < k; i++){
        if(used[i] || cur[a[i].m] != 0){
            continue;
        }
        used[i] = true;
        for(int j = a[i].l; j < a[i].r; j++)
            cur[j]++;
        bool flag2 = gen(n, k, a, used, cur);
        if(flag2)
            return true;
        used[i] = false;
        for(int j = a[i].l; j < a[i].r; j++)
            cur[j]--;
    }
    if(flag){
        for(int i = 0; i < n; i++){
            if(cur[i] == 0){
                return false;
            }
        }
        return true;
    }
    return false;
}
  
void solve_perebor(int n, int k){
    vector<dude> a(k);
    for(auto &d : a){
        cin >> d;
        d.l--; d.m--;
    }
    vector<bool> used(k);
    vector<int> cur(n);
    if(gen(n, k, a, used, cur)){
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
 
void solve_square(int n, int k){
    vector<dude> a(k);
    for(int i = 0; i < k; i++){
        cin >> a[i];
        a[i].l--; a[i].m--;
    }
    a.push_back({-2, -2, 0});
    k++;
    sort(a.begin(), a.end(), [&](dude a, dude b){
        return a.l < b.l || (a.l == b.l && a.m < b.m);
    });
    for(int i = 0; i < k; i++)
        a[i].i = i;
    vector<bool> dp(k);
    dp[0] = true;
    set<dude> window;
    window.insert(a[0]);
    for(int i = 1; i < k && !window.empty(); i++){
        set<dude> new_window;
        for(auto &d : window){
            if(d.r >= a[i].l){
                new_window.insert(d);
            }
            if(a[i].l <= d.r && (d.r <= a[i].m || d.m < a[i].l)){
                dp[i] = dp[i] | dp[d.i];
            }
        }
        window = new_window;
    }
    for(int i = 1; i < k; i++){
        if(dp[i] && a[i].r == n){
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
    return;
}
  
void solve(){
    int n, k;
    cin >> n >> k;
    if(k <= 8){
        solve_perebor(n, k);
        return ;
    }
    solve_square(n, k);
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // freopen("input.txt", "r", stdin);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}