#include <iostream>
#include <vector>
#include <algorithm>

#define int ll

using namespace std;
using ll = long long;

struct dude{
    int l, m, r;
};

istream & operator >> (istream &in, dude &x){
    return in >> x.l >> x.m >> x.r;
}

void solve_sorted(int n, int k){
    vector<int> delta(n + 1);
    while(k--){
        int l, r, m;
        cin >> l >> m >> r;
        l--;
        delta[l]++;
        delta[r]--;
    }
    int d = 0;
    for(int i = 0; i < n; i++){
        d += delta[i];
        if(d <= 0){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

bool gen(int n, int k, vector<dude> &a, vector<bool> &used, vector<int> &cur){
    bool flag = true;
    for(int i = 0; i < k; i++){
        if(used[i] || cur[a[i].m] != 0){
            continue;
        }
        used[i] = true;
        for(int j = a[i].l; j < a[i].r; j++)
            cur[j]++;
        bool flag2 = gen(n, k, a, used, cur);
        if(flag2)
            return true;
        used[i] = false;
        for(int j = a[i].l; j < a[i].r; j++)
            cur[j]--;
    }
    if(flag){
        for(int i = 0; i < n; i++){
            if(cur[i] == 0){
                return false;
            }
        }
        return true;
    }
    return false;
}

void solve_perebor(int n, int k){
    vector<dude> a(k);
    for(auto &d : a){
        cin >> d;
        d.l--; d.m--;
    }
    vector<bool> used(k);
    vector<int> cur(n);
    if(gen(n, k, a, used, cur)){
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

void solve(){
    int n, k;
    cin >> n >> k;
    if(k > 8 && false){
        solve_sorted(n, k);
        return;
    }
    solve_perebor(n, k);
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // freopen("input.txt", "r", stdin);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}