#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;

void solve() {
	int h, w;
	cin >> h >> w;

	vector<vector<int>> a(h, vector<int>(w));
	for (int i = 0; i < h; ++i) {
		string input;
		cin >> input;
		for (int j = 0; j < w; ++j) {
			a[i][j] = input[j] - '0';
		}
	}

	int ans = 0;
	vector<int> mx_col(w);
	for (int i = 0; i < h; ++i) {
		for (int j = 0; j < w; ++j) {
			mx_col[j] = (a[i][j] != 0 ? mx_col[j] + 1 : 0);
		}
		
		vector<int> mxs(w + 1);
		vector<pair<int, int>> q = { {-INF, w} };
		for (int j = w - 1; j >= 0; --j) {
			while (mx_col[j] <= q.back().first)
				q.pop_back();

			mxs[j] = mx_col[j] * (q.back().second - j) + mxs[q.back().second];
			ans = max(ans, mxs[j]);

			q.push_back({ mx_col[j], j });
		}
	}

	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}
