#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

bool check(vector<bool>& a) {
	for (auto i : a)
		if (!i)
			return false;
	return true;
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<Node> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
	}

	vector<int> p(k);
	for (int i = 0; i < k; ++i)
		p[i] = i;

	vector<bool> b(n);
	for (int i = 0; i < k; ++i) {
		if (b[a[p[i]].m - 1] == true)
			continue;
		for (int j = a[p[i]].l - 1; j < a[p[i]].r; ++j) {
			b[j] = true;
		}

		if (check(b)) {
			cout << "YES\n";
			return;
		}
	}
	b.clear();
	while (next_permutation(all(p))) {
		vector<bool> b(n);
		for (int i = 0; i < k; ++i) {
			if (b[a[p[i]].m - 1] == true)
				continue;
			for (int j = a[p[i]].l - 1; j < a[p[i]].r; ++j) {
				b[j] = true;
			}

			if (check(b)) {
				cout << "YES\n";
				return;
			}
		}
	}
	cout << "NO\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
