#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

bool check(vector<bool>& a) {
	for (auto i : a)
		if (!i)
			return false;
	return true;
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<Node> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
	}

	sort(all(a), cmp);
	bool f = true;
	int max_r = 0;
	for (int i = 0; i < n; ++i) {
		if (max_r + 1 < a[i].l) {
			cout << "NO\n";
			return;
		}
		max_r = max(max_r, a[i].r);
	}
	if (max_r != n) {
		cout << "NO\n";
		return;
	}

	for (int i = 0; i < k; ++i) {
		for (int j = i + 1; j < k; ++i) {
			if ((a[j].l <= a[i].m and a[i].m <= a[j].r) and (a[i].l <= a[j].m and a[j].m <= a[i].r)) {
				cout << "NO\n";
				return;
			}
		}
	}
	
	cout << "YES\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}