#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e9;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<Node> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
	}

	sort(all(a), cmp);
	int mx_r = 0;
	for (int i = 0; i < k; ++i) {
		if (i == 0 or a[i].m != a[i - 1].m) {
			if (mx_r + 1 < a[i].m) {
				cout << "NO\n";
				return;
			}
			mx_r = max(mx_r, a[i].r);
		}
	}
	cout << "YES\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}
