#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int INF = 1e18;

struct Node {
	int l, m, r;
};

bool cmp(Node& a, Node& b) {
	return a.l < b.l or (a.l == b.l and a.r > b.r);
}

bool check(vector<bool>& a) {
	for (auto i : a)
		if (!i)
			return false;
	return true;
}

int f(int xi, int x0, int k, int d, int t) {
	int a = min((int)(xi - x0 - k * d), (int) 1e9);
	return a * a + abs(k * t);
}

void solve() {
	int n;
	cin >> n;

	vector<int> x(n);
	for (auto& xi : x)
		cin >> xi;

	int x0, d;
	cin >> x0 >> d;

	int m;
	cin >> m;

	for (int i = 0; i < m; ++i) {
		int t;
		cin >> t;

		int mn = INF;
		for (int xi : x) {
			int l = -1e9, r = 1e9;
			while (r - l > 2) {
				int m1 = (2 * l + r) / 3;
				int m2 = (l + 2 * r) / 3;

				__int128 a1 = (xi - x0 - m1 * d);
				__int128 a2 = (xi - x0 - m2 * d);
				
				if (a1 * a1 + abs(m1 * t) < a2 * a2 + abs(m2 * t)) {
					r = m2;
				}
				else {
					l = m1;
				}
			}

			for (int i = l - 2; i <= r + 2; ++i) {
				int a1 = (xi - x0 - i * d);
				mn = min(mn, a1 * a1 + abs(i * t));
			}
		}
		cout << mn << '\n';
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}
