#include "bits/stdc++.h"

using namespace std;
using ll = long long;

struct Segtree {
    int n;
    vector<int> t;

    Segtree(int n) : n(n) {
        t.resize(4 * n + 1, 1e9);
    }

    void update(int v, int l, int r, int i, int x) {
        if (r - l == 1) {
            t[v] = min(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) update(2 * v + 1, l, m, i, x);
        else update(2 * v + 2, m, r, i, x);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) return t[v];
        if (r <= ql || l >= qr) return 1e9;
        int m = (l + r) / 2;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

struct Segment {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<Segment> a(k);
    vector<int> comp = {0, n};
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        comp.push_back(a[i].l);
        comp.push_back(a[i].l - 1);
        comp.push_back(a[i].m);
        comp.push_back(a[i].r);
    }
    std::sort(comp.begin(), comp.end());
    comp.erase(std::unique(comp.begin(), comp.end()), comp.end());

    for (int i = 0; i < k; ++i) {
        a[i].l = lower_bound(comp.begin(), comp.end(), a[i].l) - comp.begin();
        a[i].m = lower_bound(comp.begin(), comp.end(), a[i].m) - comp.begin();
        a[i].r = lower_bound(comp.begin(), comp.end(), a[i].r) - comp.begin();
    }

    n = comp.size() - 1;

    std::sort(a.begin(), a.end(), [&](Segment L, Segment R) {
        if (L.r == R.r) {
            if (L.m == R.m) {
                return L.l < R.l;
            }
            return L.m < R.m;
        }
        return L.r < R.r;
    });

    vector<ll> dp(n + 1);
    Segtree first(n + 1);
    first.update(0, 0, n, 0, 0);
    dp[0] = true;
    for (int i = 0; i < k; ++i) {
        // front
        if (first.get(0, 0, n + 1, a[i].l - 1, a[i].m) <= a[i].m) {
            dp[a[i].r] = true;
            first.update(0, 0, n + 1, a[i].r, a[i].m);
        }

        // back
        if (first.get(0, 0, n + 1, a[i].l - 1, a[i].r + 1) < a[i].l) {
            dp[a[i].r] = true;
            first.update(0, 0, n + 1, a[i].r, a[i].m);
        }
    }

    if (dp[n]) {
        cout << "YES" << "\n";
        return;
    }
    cout << "NO" << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else

#endif

    ll t;
    cin >> t;

    while (t--) solve();
}