#include "bits/stdc++.h"

using namespace std;

int t[(int) 2e6 + 500];
int dp[(int) 5e5 + 500];

struct Segtree {
    int n;

    Segtree(int n) : n(n) {
        fill(begin(t), begin(t) + 4 * n + 1, 1e9);
    }

    void update(int v, int l, int r, int i, int x) {
        if (r - l == 1) {
            t[v] = min(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) update(2 * v + 1, l, m, i, x);
        else update(2 * v + 2, m, r, i, x);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) return t[v];
        if (r <= ql || l >= qr) return 1e9;
        int m = (l + r) / 2;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

struct Segment {
    int l, m, r;
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<Segment> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;

    }
    std::sort(a.begin(), a.end(), [&](Segment L, Segment R) {
        if (L.r == R.r) {
            if (L.m == R.m) {
                return L.l < R.l;
            }
            return L.m < R.m;
        }
        return L.r < R.r;
    });

    fill(begin(dp), begin(dp) + n + 1, 0);
    Segtree first(n + 1);
    first.update(0, 0, n + 1, 0, 0);
    dp[0] = true;
    for (int i = 0; i < k; ++i) {
        // front
        if (!dp[a[i].r]) {
            if (first.get(0, 0, n + 1, a[i].l - 1, a[i].m) <= a[i].m) {
                dp[a[i].r] = true;
                first.update(0, 0, n + 1, a[i].r, a[i].m);
            }
        }

        // back
        if (!dp[a[i].r]) {
            if (first.get(0, 0, n + 1, a[i].l - 1, a[i].r + 1) < a[i].l) {
            dp[a[i].r] = true;
            first.update(0, 0, n + 1, a[i].r, a[i].m);
        }
    }

    if (dp[n]) {
        cout << "YES" << "\n";
        return;
    }
    cout << "NO" << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else

#endif

    int t;
    cin >> t;

    while (t--) solve();
}