#include "bits/stdc++.h"

using namespace std;
using i128 = __int128;
using ll = __int128;

void solve() {
    int n, d;
    cin >> n >> d;

    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;

        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }

    vector<int> h(n);
    function<void(int,int)> dfs = [&](int v, int last) -> void {
        for (auto u: g[v]) {
            if (u == last) continue;
            h[u] = h[v] + 1;
            dfs(u, v);
        }
    };
    dfs(0, 0);

    vector<vector<int>> g2(n);
    function<void(int,int,int)> build = [&](int v, int last, int D) -> void {
        for (auto u: g[v]) {
            if (u == last) continue;
            if (h[v] % 2 == 0 && h[u] % 2 == 1) g2[v].push_back(u);
            if (D != d) build(u, v, D + 1);
        }
    };
    for (int i = 0; i < n; ++i) {
        build(i, i, 0);
    }

    vector<int> used(n, -1);
    vector<int> mate(n, -1);
    int ans = 0;
    function<int(int)> kuhn = [&](int v) {
        if (used[v] == ans) return false;
        used[v] = ans;
        for (auto u: g2[v]) {
            if (mate[u] == -1) {
                mate[u] = v;
                return true;
            }
        }
        for (auto u: g2[v]) {
            if (kuhn(mate[u])) {
                mate[u] = v;
                return true;
            }
        }
        return false;
    };

    for (int i = 0; i < n; ++i) {
        ans += kuhn(i);
    }

    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        if (mate[i] != -1){
            cout << i + 1 << " " << mate[i] + 1 << "\n";
        }
    }
//    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else

#endif

    int t = 1;

    while (t--) solve();
}