#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <cstdint>
#include <deque>

using namespace std;

#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define i64 int64_t
#define fi first
#define se second

void solve() {
    int n, m;
    cin >> n >> m;
    vvi g(n, vi(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            g[i][j] = c - '0';
        }
    }
    vvi len(n, vi(m));
    for (int i = 0; i < n; ++i) {
        if (g[i][m - 1] == 1) {
            len[i][m - 1] = 1;
        }
    }
    for (int j = m - 2; j >= 0; --j) {
        for (int i = 0; i < n; ++i) {
            if (g[i][j] == 0) {
                len[i][j] = 0;
            } else {
                len[i][j] = len[i][j + 1] + 1;
            }
        }
    }
    int ans = 0;
    for (int j = 0; j < m; ++j) {
        deque<pii> d;
        int cur = 0;
        for (int i = 0; i < n; ++i) {
            if (!g[i][j]) {
                d.clear();
                cur = 0;
            } else {
                int ln = 1;
                while (d.size() && d.back().fi >= len[i][j]) {
                    ln += d.back().se;
                    cur -= d.back().fi * d.back().se;
                    d.pop_back();
                }
                cur += ln * len[i][j];
                ans = max(ans, cur);
                d.push_back({len[i][j], ln});
            }
        }
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}