#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <cstdint>
#include <deque>
 
#include <functional>
 
using namespace std;
 
#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define i64 int64_t
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define vb vc<bool>
#define pb push_back
#define ld long double
 
void solve() {
    int n, d;
    cin >> n >> d;
    vvi g(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].pb(u);
        g[u].pb(v);
    }
    vb used(n);
    vi h(n);
    function<void(int)> dfs = [&](int v) {
        used[v] = 1;
        for (int u : g[v]) {
            if (!used[u]) {
                h[u] = h[v] + 1;
                dfs(u);
            }
        }
    };
    vvi dt(n, vi(n));
    for (int i = 0; i < n; ++i) {
        h.assign(n, 0);
        used.assign(n, 0);
        dfs(i);
        dt[i] = h;
    }
    vc<pii> ans;
    set<vb> st;
    function<void(vb&, vc<pii>&)> find = [&](vb &used, vc<pii> &cur) {
        if (st.count(used)) {
            return;
        }
        st.insert(used);
        if (cur.size() > ans.size()) {
            ans = cur;
        }
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if ((dt[i][j] & 1) && !used[i] && !used[j] && dt[i][j] <= d) {
                    cur.pb({i, j});
                    used[i] = used[j] = 1;
                    find(used, cur);
                    used[i] = used[j] = 0;
                    cur.pop_back();
                }
            }
        }
    };
    used.assign(n, 0);
    vc<pii> cur;
    find(used, cur);
    cout << ans.size() << '\n';
    for (pii el : ans) {
        cout << el.fi + 1 << " " << el.se + 1 << '\n';
    }
}
 
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}