#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct seg {
    int l, m, r;
};

struct segtree {
    vector<int> tree;
    int size;

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        }
        int m = (rx + lx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (rx <= l || r <= lx) {
            return 0;
        }
        int m = (rx + lx) / 2;
        return max(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<seg> s(k);
    for (auto [l, m, r]: s) cin >> l >> m >> r;
    vector<int> used(n + 1, 0);
    for (auto [l, m, r]: s) {
        used[l]++;
        if (r != n) {
            used[r + 1]--;
        }
    }
    for (int i = 1; i <= n; ++i) {
        used[i] += used[i - 1];
        if (used[i] < 1) {
            cout << "NO\n";
            return;
        }
    }
    vector<int> zl(n + 1);
    for (int i = 0; i < k; ++i) {
        zl[s[i].l] = max(zl[s[i].l], s[i].r);
    }
    segtree st;
    st.size = n + 1;
    st.tree.resize(4 * st.size);
    st.build(zl, 0, 0, st.size);
    while (!s.empty()) {
        vector<seg> next;
        for (int i = 0; i < (int)s.size(); ++i) {
            if (st.get(0, s[i].m, 0, 0, n + 1) <= s[i].m) {
                continue;
            }
            next.push_back(s[i]);
        }
        if (next.size() == s.size()) {
            cout << "NO\n";
            return;
        }
        s = next;
        next.clear();
    }
    cout << "YES\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
