#include <bits/stdc++.h>

using namespace std;

struct node {
    int l, m, r;
};

vector<int> tree, modif;

void change(int x, int l, int r, int ql, int qr, int val) {
    if (l == ql && r == qr) {
        tree[x] = val;
        modif[x] = val;
        return;
    }
    if (modif[x] != -2) {
        tree[2 * x + 1] = modif[x];
        tree[2 * x + 2] = modif[x];
        modif[2 * x + 1] = modif[x];
        modif[2 * x + 2] = modif[x];
        modif[x] = -2;
    }
    int m = (l + r) / 2;
    if (qr <= m) {
        change(2 * x + 1, l, m, ql, qr, val);
        return;
    }
    if (ql >= m) {
        change(2 * x + 2, m, r, ql, qr, val);
        return;
    }
    change(2 * x + 1, l, m, ql, m, val);
    change(2 * x + 2, m, r, m, qr, val);
}

int get(int x, int l, int r, int id) {
    if (r - l == 1) {
        return tree[x];
    }
    if (modif[x] != -2) {
        tree[2 * x + 1] = modif[x];
        tree[2 * x + 2] = modif[x];
        modif[2 * x + 1] = modif[x];
        modif[2 * x + 2] = modif[x];
        modif[x] = -2;
    }
    int m = (l + r) / 2;
    if (id < m) {
        return get(2 * x + 1, l, m, id);
    } else {
        return get(2 * x + 2, m, r, id);
    }
}

int n, k;
vector<node> g;
vector<int> change(vector<int>& v) {
    auto res = v;
    random_device rd;
    mt19937 rnd;
    uniform_int_distribution<> ind(0, k - 1);
    int id1 = ind(rd);
    int id2 = ind(rd);
    while (id1 == id2) {
        id1 = ind(rd);
    }
    swap(res[id1], res[id2]);
    return res;
}

int check(vector<int>& v) {
    int cnt = 0;
    vector<int> used(n + 1);
    tree.resize(n * 4 + 4);
    modif.resize(n * 4 + 4, -2);
    for (int i = 0; i < k; i++) {
        if (!get(0, 0, n, g[v[i]].m)) {
            change(0, 0, n, g[v[i]].l, g[v[i]].r + 1, 1);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!get(0, 0, n, i)) {
            cnt++;
        }
    }
    return cnt;
}

int sim() {
    double temp = 5;
    double cooling = 0.9995;
    vector<int> res(k);
    random_device rd;
    mt19937 rnd;
    for (int i = 0; i < k; i++) {
        res[i] = i;
    }
    shuffle(res.begin(), res.end(), rd);
    int cnt = check(res);
    while (cnt > 0 && temp > 0.01) {
        auto n_res = change(res);
        int n_cnt = check(n_res);
        int delt = n_cnt - cnt;
        if (n_cnt < cnt || uniform_real_distribution<> (0, 1.0)(rd) <= exp(-delt / temp)) {
            cnt = n_cnt;
            res = n_res;
        }
        temp *= cooling;
    }
    return cnt;
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> k;
        set<int> s;
        g.resize(k);
        for (int i = 0; i < k; i++) {
            cin >> g[i].l >> g[i].m >> g[i].r;
        }
        int res = sim();
        if (res > 0) {
            cout << "NO" << '\n';
        } else {
            cout << "YES" << '\n';
        }
    }
}
