#include <bits/stdc++.h>

using namespace std;

struct node {
    int l, m, r;
};

int n, k;
vector<node> g;
vector<int> change(vector<int>& v) {
    auto res = v;
    random_device rd;
    mt19937 rnd;
    uniform_int_distribution<> ind(0, k - 1);
    int id1 = ind(rnd);
    int id2 = ind(rnd);
    while (id1 == id2) {
        id1 = ind(rnd);
    }
    swap(res[id1], res[id2]);
    return res;
}

int check(vector<int>& v) {
    int cnt = 0;
    vector<int> used(n + 1);
    for (int i = 0; i < k; i++) {
        if (!used[g[v[i]].m]) {
            for (int j = g[v[i]].l; j <= g[v[i]].r; j++) {
                used[j] = 1;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            cnt++;
        }
    }
    return cnt;
}

int sim() {
    double temp = 5;
    double cooling = 0.9995;
    vector<int> res(k);
    random_device rd;
    mt19937 rnd;
    for (int i = 0; i < k; i++) {
        res[i] = i;
    }
    shuffle(res.begin(), res.end(), rnd);
    int cnt = check(res);
    while (cnt > 0 && temp > 0.0001) {
        auto n_res = change(res);
        int n_cnt = check(n_res);
        int delt = cnt - n_cnt;
        if (n_cnt < cnt || uniform_real_distribution<> (0, 1.0)(rnd) <= exp(-delt / temp)) {
            cnt = n_cnt;
            res = n_res;
        }
        temp *= cooling;
    }
    return cnt;
}

int main() {
    ios_base:: sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> k;
        set<int> s;
        g.resize(k);
        for (int i = 0; i < k; i++) {
            cin >> g[i].l >> g[i].m >> g[i].r;
        }
        int res = sim();
        if (res > 0) {
            cout << "NO" << '\n';
        } else {
            cout << "YES" << '\n';
        }
    }
}
