#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <iomanip>
#include <unordered_map>
using namespace std;
using ll = int;
const ll maxn = 200000;
ll t[4 * maxn];
ll p[4 * maxn];
void init() {
	for (auto& c : p) {
		c = -1;
	}
}
void apply(ll v, ll l, ll r, ll x) {
	p[v] = x;
	t[v] = x * (r - l);
}
void push(ll v, ll l, ll m, ll r) {
	if (p[v] == -1) {
		return;
	}
	apply(2 * v + 1, l, m, p[v]);
	apply(2 * v + 2, m, r, p[v]);
	p[v] = 0;
}
void upd(ll v, ll l, ll r, ll ql, ll qr, ll x) {
	if (l >= qr || r <= ql) {
		return;
	}
	if (l >= ql && r <= qr) {
		apply(v, l, r, x);
		return;
	}
	ll m = (l + r) / 2;
	push(v, l, m, r);
	upd(2 * v + 1, l, m, ql, qr, x);
	upd(2 * v + 2, m, r, ql, qr, x);
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}
ll get(ll v, ll l, ll r, ll ql, ll qr) {
	if (l >= qr || r <= ql) {
		return 0;
	}
	if (l >= ql && r <= qr) {
		return t[v];
	}
	ll m = (l + r) / 2;
	push(v, l, m, r);
	return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}
void solve() {
	ll n, m;
	init();
	cin >> n >> m;
	vector <vector <ll>> a(n, vector <ll>(m));
	for (ll i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (ll j = 0; j < m; ++j) {
			a[i][j] = s[j] - '0';
		}
	}
	vector <vector <ll>> r(n, vector <ll>(m));
	for (ll i = 0; i < n; ++i) {
		for (ll j = m - 1; j > -1; --j) {
			if (a[i][j] == 0) {
				continue;
			}
			if (j < m - 1 && a[i][j + 1] == 0) {
				r[i][j] = 1;
			}
			else if (j < m - 1) {
				r[i][j] = r[i][j + 1] + 1;
			}
			else {
				r[i][j] = m - j;
			}
			//cout << r[i][j] << ' ' << i << ' ' << j << "\n";
		}
	}
	ll ans = 0;
	ll sz = 0;
	for (ll j = 0; j < m; ++j) {
		vector <ll> s;
		if (sz > 0) {
			upd(0, 0, maxn, 0, sz, 0);
		}
		sz = 0;
		for (ll i = 0; i < n; ++i) {
			if (a[i][j] == 0) {
				if (sz > 0) {
					upd(0, 0, maxn, 0, sz, 0);
				}
				sz = 0;
			}
			else {
				ll l = -1, ri = sz;
				while (ri - l > 1) {
					ll mid = (l + ri) / 2;
					if (get(0, 0, maxn, mid, mid + 1) >= r[i][j]) {
						ri = mid;
					}
					else {
						l = mid;
					}
				}
				if (sz != ri) {
					upd(0, 0, maxn, ri, sz, r[i][j]);
				}
				upd(0, 0, maxn, sz, sz + 1, r[i][j]);
				sz++;
				ans = max(ans, get(0, 0, maxn, 0, sz));
			}
		}
	}
	cout << ans;
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}