#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <bitset>
#include <map>
#include <queue>
#include <iomanip>
#include <unordered_map>
using namespace std;
using ll = int;
const ll maxn = 300000;
vector <pair <ll, ll>> ans;
vector <ll> g[maxn];
ll p[maxn];
bool used[maxn];
ll lca[15][15];
ll timer = 0;
ll tin[maxn];
ll tout[maxn];
ll h[maxn];
void dfs(ll v, ll pr, vector <ll>& d) {
	tin[v] = timer++;
	for (auto to : g[v]) {
		if (to == pr) {
			continue;
		}
		d[to] = d[v] + 1;
		p[to] = v;
		h[to] = h[v] + 1;
		dfs(to, v, d);
	}
	tout[v] = timer;
}
void dfs1(ll v) {
	for (auto to : g[v]) {
		if (to == p[v]) {
			continue;
		}
		dfs1(to);
	}
	for (auto to : g[v]) {
		if (to == p[v]) {
			continue;
		}
		if (!used[to]) {
			ans.push_back({ v, to });
			used[v] = true;
			break;
		}
	}
}
bool anc(ll a, ll b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}
ll d;
ll n;
vector <ll> per;
bitset <14> used1;
void perebor(const ll& k, vector <ll>& x) {
	if (per.size() == k) {
		bool flag = true;
		for (ll i = 0; i < k; ++i) {
			if ((h[x[i]] + h[per[i]]) % 2 != 1 || (h[x[i]] + h[per[i]] - 2 * h[lca[x[i]][per[i]]]) > d) {
				flag = false;
			}
		}
		if (flag) {
			if (ans.size() > k) {
				return;
			}
			ans.clear();
			for (ll i = 0; i < k; ++i) {
				ans.push_back({ x[i], per[i] });
			}
		}
		return;
	}
	for (ll i = 0; i < n; ++i) {
		if (used1[i] == 0) {
			per.push_back(i);
			used1[i] = 1;
			perebor(k, x);
			used1[i] = 0;
			per.pop_back();
		}
	}
}
void solve() {
	cin >> n >> d;
	for (auto& c : p) {
		c = -1;
	}
	for (ll i = 0; i < n - 1; ++i) {
		ll x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	vector <ll> dist(n);
	dfs(0, -1, dist);
	if (d == 1) {
		dfs1(0);
		cout << ans.size() << "\n";
		for (auto c : ans) {
			cout << c.first + 1 << ' ' << c.second + 1 << "\n";
		}
		return;
	}
	if (d == n - 1) {
		vector <ll> a1;
		vector <ll> a0;
		for (ll i = 0; i < n; ++i) {
			if (dist[i] % 2 == 0) {
				a0.push_back(i);
			}
			else {
				a1.push_back(i);
			}
		}
		for (ll i = 0; i < min(a1.size(), a0.size()); ++i) {
			ans.push_back({ a1[i], a0[i] });
		}
		cout << ans.size() << "\n";
		for (auto c : ans) {
			cout << c.first + 1 << ' ' << c.second + 1 << "\n";
		}
		return;
	}
	if (n <= 14) {
		for (ll i = 0; i < n; ++i) {
			for (ll j = i + 1; j < n; ++j) {
				ll v = j;
				while (!anc(v, i)) {
					v = p[v];
				}
				lca[i][j] = v;
			}
		}
		for (ll mask = 1; mask < (1 << n); ++mask) {
			bitset <14> b(mask);
			if (b.count() > n / 2) {
				continue;
			}
			ll k = b.count();
			vector <ll> x;
			used1 = 0;
			for (ll i = 0; i < n; ++i) {
				if (b[i] == 1) {
					x.push_back(i);
					used1[i] = 1;
				}
			}
			perebor(k, x);
		}
		cout << ans.size() << "\n";
		for (auto c : ans) {
			cout << c.first + 1 << ' ' << c.second + 1 << "\n";
		}
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}
/*/
2
5 2
3 4 5
1 3 3
5 3
1 2 4
2 4 5
3 3 3
/*/