#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

vector<vector<int>> g;
vector<bool> used;
vector<int> topsort;
void dfs(int v) {
    used[v] = true;
    for (auto u: g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    topsort.push_back(v);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l, m, r;
    l.resize(k), m.resize(k), r.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<pair<int, int>> e;
    for (int i = 0; i < k; ++i) {
        e.push_back({m[i], i});
    }
    sort(e.begin(), e.end());
    g.assign(k, {});
    used.assign(k, false);
    topsort.clear();
    for (int i = 0; i < k; ++i) {
        int j = lower_bound(e.begin(), e.end(), make_pair(l[i], -1)) - e.begin();
        while (j < k && e[j].first <= r[i]) {
            if (e[j].second != i) {
                g[e[j].second].push_back(i);
            }
            ++j;
        }
    }
    for (int i = 0; i < k; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(topsort.begin(), topsort.end());
    vector<int> uc(k, false);
    for (auto v: topsort) {
        bool good = true;
        for (auto u: g[v]) {
            if (uc[u]) {
                good = false;
                break;
            }
        }
        uc[v] = good;
    }
    vector<int> diff(n + 1, 0);
    for (int i = 0; i < k; ++i) {
        if (uc[i]) {
            diff[l[i] - 1]++;
            diff[r[i]]--;
        }
    }
    for (int cur = 0, i = 0; i < n; ++i) {
        cur += diff[i];
        if (cur == 0) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}