#include <bits/extc++.h>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> col;
void dfs(int v, int p, int c) {
    col[v] = c;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v, 1 - c);
        }
    }
}

vector<int> mt, used; int usedt = 1;
bool kuhn(int v) {
    if (used[v] == usedt) {
        return false;
    }
    used[v] = usedt;
    for (auto u: g[v]) {
        if (mt[u] == -1 || kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    int n, k; cin >> n >> k;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u; cin >> v >> u;
        g[v - 1].push_back(u - 1);
        g[u - 1].push_back(v - 1);
    }
    col.assign(n, -1);
    dfs(0, -1, 1);
    mt.assign(n, -1);
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (col[i] == 1) {
            ++usedt;
            kuhn(i);
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; ++i) {
        if (col[i] == 0 && mt[i] != -1) {
            ans.push_back({i, mt[i]});
        }
    }
    cout << ans.size() << '\n';
    for (auto [v, u]: ans) {
        cout << v + 1 << ' ' << u + 1 << '\n';
    }
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}