#include <bits/stdc++.h>;

using namespace std;

using ll = long long;

struct Otr {
    ll l;
    ll m;
    ll r;
    ll ind;
};

bool comp_po_m(Otr x, Otr y) {
    return x.m < y.m;
}

bool comp_po_l(Otr x, Otr y) {
    if (x.l == y.l) {
        return x.r < y.r;
    } else {
        return x.l < y.l;
    }
}

ll n, k;

vector<Otr> otrs;

vector<Otr> otrs_sort_po_m;

vector<Otr> otrs_sort_po_l;

vector<vector<ll>> g;

vector<ll> m_na_prom(ll l, ll r) {
    ll lg = -1;
    ll rg = k;
    while (rg - lg > 1) {
        ll mid = (lg + rg) / 2;

        if (otrs_sort_po_m[mid].m < l) {
            lg = mid;
        } else {
            rg = mid;
        }
    }

    vector<ll> ans;
    for (ll i = rg; i < n && otrs_sort_po_m[i].m <= r; i++) {
        ans.push_back(otrs_sort_po_m[i].ind);
    }
    return ans;
}

vector<ll> tin;
vector<ll> tout;
ll timer;

vector<bool> used;


void dfs(ll now) {
    used[now] = true;
    tin[now] = timer++;

    for (ll to : g[now]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    tout[now] = timer++;
}

void solve() {
    cin >> n >> k;

    otrs.clear();
    otrs.resize(k);
    for (ll i = 0; i < k; i++) {
        cin >> otrs[i].l >> otrs[i].m >> otrs[i].r;
        otrs[i].l--; otrs[i].m--; otrs[i].r--;

        otrs[i].ind = i;
    }


    otrs_sort_po_m = otrs;
    sort(otrs_sort_po_m.begin(), otrs_sort_po_m.end(), comp_po_m);

    otrs_sort_po_l = otrs;
    sort(otrs_sort_po_l.begin(), otrs_sort_po_l.end(), comp_po_l);

    g.clear();
    g.resize(k);
    for (ll now = 0; now < k; now++) {
        for (ll to : m_na_prom(otrs[now].l, otrs[now].r)) {
            if (to != now) {
                g[now].push_back(to);
            }
        }
    }


    tin.clear();
    tin.resize(k);
    tout.clear();
    tout.resize(k);
    timer = 0;

    used.clear();
    used.resize(k, false);

    for (ll i = 0; i < k; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }

    bool ans = true;
    for (ll now = 0; now < k; now++) {
        for (ll to : g[now]) {
            if (tout[to] > tout[now]) {
                ans = false;
            }
        }
    }

    ll pred_l = n;
    for (ll i = k - 1; i >= 0; i--) {
        if (otrs_sort_po_l[i].l < pred_l) {
            if (otrs_sort_po_l[i].r >= pred_l - 1) {
                pred_l = otrs_sort_po_l[i].l;
            }
        }
    }

    if (pred_l != 0) {
        ans = false;
    }

    if (ans) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);


    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    cout << endl;
    return 0;
}
