#include <bits/stdc++.h>;

using namespace std;

using ll = long long;

ll n;
ll d;

vector<vector<ll>> g;

vector<ll> pred;
vector<vector<ll>> deti;

vector<bool> used;

void build_deti(ll now) {
    used[now] = true;
    for (ll to : g[now]) {
        if (!used[to]) {
            pred[to] = now;
            deti[now].push_back(to);
            build_deti(to);
        }
    }
}

vector<pair<ll, ll>> ans;

vector<vector<ll>> build_ans(ll now) {
    vector<vector<ll>> frees(d + 1);

    frees[0].push_back(now);

    for (ll to : deti[now]) {
        vector<vector<ll>> frees_now = build_ans(to);

        for (ll i = 0; i < d; i++) {
            for (ll now : frees_now[i]) {
                frees[i + 1].push_back(now);
            }
        }
    }

    for (ll i = d; i >= 0; i--) {
        for (ll j = d - i; j > i; j -= 2) {
            ll kol_now = min(frees[i].size(), frees[j].size());

            for (ll k = 0; k < kol_now; k++) {
                ans.push_back({frees[i].back(), frees[j].back()});
                frees[i].pop_back();
                frees[j].pop_back();
            }
        }
    }


    return frees;
}

void solve() {
    cin >> n;

    cin >> d;

    g.clear();
    g.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--; v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    pred.clear();
    pred.resize(n);
    pred[0] = -1;
    deti.clear();
    deti.resize(n);

    used.clear();
    used.resize(n, false);

    build_deti(0);


    ans.clear();

    build_ans(0);

    cout << ans.size() << '\n';
    for (pair<ll, ll> now : ans) {
        cout << now.first + 1 << ' ' << now.second + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);


    solve();
    cout << endl;
    return 0;
}
