#include <bits/stdc++.h>

using namespace std;


const int c = 1 << 3;

struct el {
    int val;
    int add;
};
void build(vector <int>& arr, vector <el>& t) {
    for (int i = 0; i < c; ++i) {
        t[i + c - 1].val = arr[i];
        t[i].add = -1;
    }
    for (int i = c - 2; i >= 0; --i) {
        t[i].val = t[2 * i + 1].val + t[2 * i + 2].val;
        t[i].add = -1;
    }
}

void apply (int x, int l, int r, vector <el>& t, int i) {
    if (x != -1) {
        t[i].add = x;
        t[i].val = x * (r - l);
    }
}

void push(int i, int l, int r, vector <el>& t) {
    int m = (r + l) / 2;
    apply(t[i].add, l, m, t, 2 * i + 1);
    apply(t[i].add, m, r, t, 2 * i + 2);
    t[i].add = -1;
}

void upd(int v, int x, int l, int r, int tl, int tr, vector <el>& t) {
    if (tl >= r || tr <= l) {
        return;
    }
    if (tl >= l && tr <= r) {
        apply(v, tl, tr, t, x);
        return;
    }
    push(x, tl, tr, t);
    int tm = (tl + tr) / 2;
    upd(v, 2 * x + 1, l, r, tl, tm, t);
    upd(v, 2 * x + 2, l, r, tm, tr, t);
    t[x].val = t[2 * x + 1].val + t[2 * x + 2].val;
}

int get(int x, int l, int r, int tl, int tr, vector <el>& t) {
    if (tl >= r || tr <= l) {
        return 0;
    }
    if (tl >= l && tr <= r) {
        return t[x].val;
    }
    push(x, tl, tr, t);
    int tm = (tl + tr) / 2;
    return get(2 * x + 1, l, r, tl, tm, t) + get(2 * x + 2, l, r, tm, tr, t);
}
int main()
{
    int h, w;
    cin >> h >> w;
    vector <vector <int>> v(h, vector <int> (w));
    for (int i = 0; i < h; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < w; ++j) {
            v[i][j] = int(s[j]) - 48;
        }
    }
    vector <vector <int>> up(h, vector <int> (w));
    for (int j = 0; j < w; ++j) {
        int r = h - 1;
        for (int i = h - 1; i >= 0; --i) {
            if (v[i][j] == 1) {
                while (r >= 0 && v[i][j] == v[r][j]) {
                    --r;
                }
                up[i][j] = i - r;
            } else {
                while (r >= 0 && v[r][j] == 0) {
                    --r;
                }
                up[i][j] = 0;
            }
        }
    }
    vector <vector <int>> bigger(h, vector <int> (w, w));
    for (int i = 0; i < h; ++i) {
        stack <int> s;
        s.push(0);
        for (int j = 1; j < w; ++j) {
            while (s.size() > 0 && up[i][s.top()] > up[i][j]) {
                bigger[i][s.top()] = j;
                s.pop();
            }
            s.push(j);
        }
    }
    int max_size = 0;
    for (int i = 0; i < h; ++i) {
        vector <int> arr(c, 0);
        for (int j = 0; j < w; ++j) {
            arr[j] = up[i][j];
        }
        vector <el> t(2 * c - 1, {0, -1});
        build(arr, t);
        for (int j = w - 1; j >= 0; --j) {
            upd(arr[j], 0, j, bigger[i][j], 0, c, t);
            max_size = max(max_size, t[0].val);
        }
    }
    cout << max_size;
    return 0;
}
