#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

struct query{
    ll l, m, r;
    query() {}
    query(ll l, ll m, ll r) : l(l), m(m), r(r) {}
};

const ll inf = 1e18;

vector<ll> tree;

ll ask(ll v, ll l, ll r, ll askl, ll askr){
    if (l >= askr || r <= askl){
        return inf;
    }
    if (l >= askl && r <= askr){
        return tree[v];
    }
    ll m = (l + r) / 2;
    return min(ask(2 * v + 1, l, m, askl, askr), ask(2 * v + 2, m, r, askl, askr));
}

void update(ll v, ll l, ll r, ll pos, ll x){
    if (l == r - 1){
        tree[v] = min(tree[v], x);
        return;
    }
    ll m = (l + r) / 2;
    if (pos < m){
        update(2 * v + 1, l, m, pos, x);
    }
    else {
        update(2 * v + 2, m, r, pos, x);
    }
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
};

bool operator <(const query& a, const query& b){
    return make_pair(a.l, a.r) < make_pair(b.l, b.r);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    ll t;
    cin >> t;
    while (t--){
        ll n, k;
        cin >> n >> k;
        vector<ll> dp(n + 1, inf);
        dp[0] = 0;
        tree = {};
        tree.resize(4 * (n + 1), inf);
        update(0, 0, n + 1, 0, 0);
        vector<query> a(k);
        for (int i = 0; i < k; ++i){
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        sort(a.begin(), a.end());
        for (int i = 0; i < k; ++i){
            ll z = ask(0, 0, n + 1, a[i].l - 1, a[i].m);
            if (z != inf){
                dp[a[i].r] = min(dp[a[i].r], a[i].m);
            }
            z = ask(0, 0, n + 1, a[i].m, a[i].r + 1);
            if (z != inf && a[i].l > z){
                dp[a[i].r] = min(dp[a[i].r], a[i].m);
            }
            update(0, 0, n + 1, a[i].r, dp[a[i].r]);
        }
        /*for (int i = 1; i < n + 1; ++i){
            for (int j = i - 1; j > -1; --j){
                for (int l = 0; l < k; ++l){
                    if (dp[j] != inf && (j < a[l].m || a[l].l > dp[j]) && a[l].l <= j + 1 && a[l].r == i){
                        dp[i] = min(dp[i], a[l].m);
                    }
                }
            }
        }*/
        if (dp[n] != inf){
            cout << "YES" << '\n';
        }
        else {
            cout << "NO" << '\n';
        }
    }
    return 0;
}
