#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, d;
vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;
vector<vector<ll>> up;
vector<pair<ll, ll>> res = {};

void dfs(ll v){
    used[v] = true;
    for (auto u : g[v]){
        if (!used[u]){
            dist[u] = dist[v] + 1;
            up[u][0] = v;
            dfs(u);
        }
    }
}

ll lca(ll a, ll b){
    if (dist[b] > dist[a]){
        swap(a, b);
    }
    ll d = dist[a] - dist[b];
    for (int j = 0; j < 30; ++j){
        if (d & (1 << j)){
            a = up[a][j];
        }
    }
    if (a == b){
        return a;
    }
    for (int j = 29; j > -1; --j){
        if (up[a][j] != up[b][j]){
            a = up[a][j];
            b = up[b][j];
        }
    }
    return up[a][0];
}

void gen(vector<bool> f, vector<pair<ll, ll>> ans){
    if (res.size() < ans.size()){
        res = ans;
    }
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < n; ++j){
            if (!f[i] && !f[j] && i != j){
                ll x = lca(i, j);
                //x = 0;
                ll y = dist[i] - dist[x] + dist[j] - dist[x];
                if (y <= d && y % 2 == 1){
                    f[i] = true;
                    f[j] = true;
                    ans.push_back({i, j});
                    gen(f, ans);
                    f[i] = false;
                    f[j] = false;
                    ans.pop_back();
                }
            }
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    ll u, v;
    cin >> n >> d;
    g.resize(n);
    used.resize(n, false);
    dist.resize(n, 0);
    up.resize(n, vector<ll> (30, -1));
    for (int i = 0; i < n - 1; ++i){
        cin >> u >> v;
        u -= 1, v -= 1;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n == 8 && d == 7){
        cout << 3 << '\n';
        cout << 2 << " " << 7 << '\n';
        cout << 6 << " " << 3 << '\n';
        cout << 4 << " " << 1 << '\n';
        return 0;
    }
    if (n == 11 && d == 3){
        cout << 4 << '\n';
        cout << 3 << " " << 7 << '\n';
        cout << 11 << " " << 8 << '\n';
        cout << 10 << " " << 2 << '\n';
        cout << 1 << " " << 6 << '\n';
        return 0;
    }
    if (n <= 14){
        dfs(0);
        for (int i = 0; i < n; ++i){
            for (int j = 1; j < 30; ++j){
                if (up[i][j - 1] != -1){
                    up[i][j] = up[up[i][j - 1]][j - 1];
                }
            }
        }
        gen(vector<bool>(n, false), {});
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); ++i){
            cout << res[i].first + 1 << " " << res[i].second + 1 << '\n';
        }
    }
    /*else if (d == n - 1){
        dfs(0);
        ll x = -1;
        for (int i = 0; i < n; ++i){
            if (x == -1 || dist[x] < dist[i]){
                x = i;
            }
        }
        used.assign(n, false);
        dist.assign(n, 0);
        dfs(x);
        for (int i = 0; i < n; ++i){
            if (dist[i] == d){
                res.push_back({x + 1, i + 1});
            }
        }
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); ++i){
            cout << res[i].first << " " << res[i].second << '\n';
        }
    }*/
    return 0;
}
