#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, d;
vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;
vector<vector<ll>> up;
vector<pair<ll, ll>> res = {};

void dfs(ll v){
    used[v] = true;
    for (auto u : g[v]){
        if (!used[u]){
            dist[u] = dist[v] + 1;
            up[u][0] = v;
            dfs(u);
        }
    }
}

ll lca(ll a, ll b){
    if (dist[b] > dist[a]){
        swap(a, b);
    }
    ll d = dist[a] - dist[b];
    for (int j = 0; j < 5; ++j){
        if (d & (1 << j)){
            a = up[a][j];
        }
    }
    if (a == b){
        return a;
    }
    for (int j = 4; j > -1; --j){
        if (up[a][j] != up[b][j]){
            a = up[a][j];
            b = up[b][j];
        }
    }
    return up[a][0];
}

void gen(vector<ll> b, vector<pair<ll, ll>> ans){
    if (res.size() < ans.size()){
        res = ans;
    }
    for (int i = 0; i < b.size(); ++i){
        for (int j = i + 1; j < b.size(); ++j){
            if (1 == 1){
                ll x = lca(b[i], b[j]);
                //ll x = 0;
                ll y = dist[b[i]] - dist[x] + dist[b[j]] - dist[x];
                if (y <= d && y % 2 == 1){
                    vector<ll> nb = {};
                    for (int k = 0; k < b.size(); ++k){
                        if (k != i && k != j){
                            nb.push_back(b[k]);
                        }
                    }
                    ans.push_back({b[i], b[j]});
                    gen(nb, ans);
                    ans.pop_back();
                }
            }
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    ll u, v;
    cin >> n >> d;
    g.resize(n);
    used.resize(n, false);
    dist.resize(n, 0);
    up.resize(n, vector<ll> (5, -1));
    for (int i = 0; i < n - 1; ++i){
        cin >> u >> v;
        u -= 1, v -= 1;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (n <= 14){
        dfs(0);
        for (int i = 0; i < n; ++i){
            for (int j = 1; j < 5; ++j){
                if (up[i][j - 1] != -1){
                    up[i][j] = up[up[i][j - 1]][j - 1];
                }
            }
        }
        vector<ll> b(n);
        iota(b.begin(), b.end(), 0);
        gen(b, {});
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); ++i){
            cout << res[i].first + 1 << " " << res[i].second + 1 << '\n';
        }
    }
    /*else if (d == n - 1){
        dfs(0);
        ll x = -1;
        for (int i = 0; i < n; ++i){
            if (x == -1 || dist[x] < dist[i]){
                x = i;
            }
        }
        used.assign(n, false);
        dist.assign(n, 0);
        dfs(x);
        for (int i = 0; i < n; ++i){
            if (dist[i] == d){
                res.push_back({x + 1, i + 1});
            }
        }
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); ++i){
            cout << res[i].first << " " << res[i].second << '\n';
        }
    }*/
    return 0;
}
