#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll long long

const ll maxn = 5 * 1e6;
pair<ll, ll> t[4 * maxn];
bool b1[4 * maxn];
ll b2[4 * maxn];
vector<ll> a1;

void build(ll v, ll l, ll r) {
    b1[v] = false;
    if (l == r - 1) {
        t[v] = {a1[l], a1[l]};
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v].first = min(t[2 * v + 1].first, t[2 * v + 2].first);
    t[v].second = t[2 * v + 1].second + t[2 * v + 2].second;
}

void push(ll v) {
    if (b1[v]) {
        b1[2 * v + 1] = true;
        b1[2 * v + 2] = true;
        b1[v] = false;
        b2[2 * v + 1] = b2[v];
        b2[2 * v + 2] = b2[v];
    }
}

void update(ll v, ll l, ll r, ll m) {
    if (b1[2 * v + 1]) {
        t[v].first = b2[2 * v + 1];
        t[v].second = b2[2 * v + 1] * (m - l);
    } else {
        t[v] = t[2 * v + 1];
    }
    if (b1[2 * v + 2]) {
        t[v].first = min(t[v].first, b2[2 * v + 2]);
        t[v].second += b2[2 * v + 2] * (r - m);
    } else {
        t[v].first = min(t[v].first, t[2 * v + 2].first);
        t[v].second += t[2 * v + 2].second;
    }
}

pair<ll, ll> f1(ll v, ll l, ll r, ll l1, ll r1) {
    if (l >= r1 || r <= l1) {
        return {1e18, 0};
    }
    if (l >= l1 && r <= r1) {
        if (b1[v]) {
            return {b2[v], b2[v] * (r - l)};
        }
        return t[v];
    }
    ll m = (l + r) / 2;
    push(v);
    pair<ll, ll> x1 = f1(2 * v + 1, l, m, l1, r1);
    pair<ll, ll> x2 = f1(2 * v + 2, m, r, l1, r1);
    update(v, l, r, m);
    pair<ll, ll> answer;
    answer.first = min(x1.first, x2.first);
    answer.second = x1.second + x2.second;
    return answer;
}

void f(ll v, ll l, ll r, ll l1, ll r1, ll x) {
    if (l >= r1 || r <= l1) {
        return;
    }
    if (l >= l1 && r <= r1) {
        b1[v] = true;
        b2[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    push(v);
    f(2 * v + 1, l, m, l1, r1, x);
    f(2 * v + 2, m, r, l1, r1, x);
    update(v, l, r, m);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (ll i = 0; i < h; i++) {
        cin >> a[i];
    }
    vector<vector<ll>> b(w, vector<ll>(h));
    for (ll i = 0; i < h; i++) {
        for (ll j = w - 1; j >= 0; j--) {
            if (a[i][j] == '0') {
                b[j][i] = 0;
            } else {
                if (j == w - 1) {
                    b[j][i] = 1;
                } else {
                    b[j][i] = b[j + 1][i] + 1;
                }
            }
        }
    }
    ll answer = 0;
    for (ll j = 0; j < w; j++) {
        a1 = b[j];
        build(0, 0, h);
        for (ll i = 0; i < h; i++) {
            ll l = -1;
            ll r = i;
            while (r - l > 1) {
                ll m = (l + r) / 2;
                if (f1(0, 0, h, m, i).first >= b[j][i]) {
                    r = m;
                } else {
                    l = m;
                }
            }
            if (r != i) {
                f(0, 0, h, r, i, b[j][i]);
            }
            answer = max(answer, f1(0, 0, h, 0, i + 1).second);
        }
    }
    cout << answer;
}