#include<iostream>
#include<algorithm>
#include<vector>

using namespace std;

#define ll long long

struct str {
    ll l, m, r;
    str() {}
    str(ll l, ll m, ll r) : l(l), m(m), r(r) {}
};

bool cmp(const str &str1, const str &str2) {
    return str1.r - str1.l > str2.r - str2.l;
}

const ll maxn = 6 * 1e5;
ll t[4 * maxn];
ll b[4 * maxn];

void build(ll v, ll l, ll r) {
    b[v] = 0;
    if (l == r - 1) {
        t[v] = 0;
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

void push(ll v) {
    b[2 * v + 1] += b[v];
    b[2 * v + 2] += b[v];
    b[v] = 0;
}

void update(ll v) {
    t[v] = min(t[2 * v + 1] + b[2 * v + 1], t[2 * v + 2] + b[2 * v + 2]);
}

void f(ll v, ll l, ll r, ll l1, ll r1, ll x) {
    if (l >= r1 || r <= l1) {
        return;
    }
    if (l >= l1 && r <= r1) {
        b[v] += x;
        return;
    }
    ll m = (l + r) / 2;
    push(v);
    f(2 * v + 1, l, m, l1, r1, x);
    f(2 * v + 2, m, r, l1, r1, x);
    update(v);
}

ll min1(ll v, ll l, ll r, ll l1, ll r1) {
    if (l >= r1 || r <= l1) {
        return 1e18;
    }
    if (l >= l1 && r <= r1) {
        return t[v] + b[v];
    }
    ll m = (l + r) / 2;
    push(v);
    ll answer = min(min1(2 * v + 1, l, m, l1, r1), min1(2 * v + 2, m, r, l1, r1));
    update(v);
    return answer;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        vector<str> a(k);
        for (ll i = 0; i < k; i++) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            a[i].l--;
            a[i].r--;
            a[i].m--;
        }
        sort(a.begin(), a.end(), cmp);
        ll f2 = 0;
        for (ll i = 0; i < k; i++) {
            build(0, 0, n);
            vector<str> a1;
            a1.push_back(a[i]);
            f(0, 0, n, a[i].l, a[i].r + 1, 1);
            for (ll j = i + 1; j < k; j++) {
                ll f1 = 0;
                for (auto elem : a1) {
                    pair<ll, ll> p1 = {max(elem.l, a[j].l), min(elem.r, a[j].r)};
                    if (p1.first > p1.second) {
                        continue;
                    } else {
                        if (elem.m >= p1.first && elem.m <= p1.second && a[j].m >= p1.first && a[j].m <= p1.second) {
                            f1 = 1;
                            break;
                        }
                    }
                }
                if (f1 == 0) {
                    a1.push_back(a[j]);
                    f(0, 0, n, a[j].l, a[j].r + 1, 1);
                }
            }
            if (min1(0, 0, n, 0, n) != 0) {
                f2 = 1;
                break;
            }
        }
        if (f2 != 0) {
            cout << "YES" << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}