#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll long long

vector<vector<ll>> gr;
vector<ll> d;
vector<vector<ll>> up;
vector<ll> tin;
vector<ll> tout;
ll t1 = 0;

void dfs(ll v, ll p, ll d1) {
    tin[v] = t1;
    t1++;
    d[v] = d1;
    up[v][0] = p;
    for (ll i = 1; i < 20; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto elem : gr[v]) {
        if (elem != p) {
            dfs(elem, v, d1 + 1);
        }
    }
    tout[v] = t1;
    t1++;
}

bool f(ll u, ll v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

ll lca(ll u, ll v) {
    if (f(u, v)) {
        return u;
    }
    if (f(v, u)) {
        return v;
    }
    for (ll i = 19; i >= 0; i--) {
        if (!f(up[u][i], v)) {
            u = up[u][i];
        }
    }
    return up[u][0];
}

ll dist(ll u, ll v) {
    ll l = lca(u, v);
    return d[u] + d[v] - 2 * d[l];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, d1;
    cin >> n >> d1;
    gr.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    tin.resize(n);
    tout.resize(n);
    d.resize(n);
    up.resize(n, vector<ll>(20));
    dfs(0, 0, 0);
    vector<ll> dp((1 << n));
    for (ll i = 0; i < (1 << n); i++) {
        for (ll i1 = 0; i1 < n; i1++) {
            for (ll j1 = 0; j1 < n; j1++) {
                if ((i & (1 << i1)) == 0 && (i & (1 << j1)) == 0) {
                    ll x = dist(i1, j1);
                    if (x <= d1 && x % 2 == 1) {
                        dp[(i | (1 << i1) | (1 << j1))] = max(dp[(i | (1 << i1) | (1 << j1))], dp[i] + 1);
                    }
                }
            }
        }
    }
    cout << *(max_element(dp.begin(), dp.end())) << '\n';
    cout << -1;
}