#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
using namespace std;
#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx2")

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<string> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	vector<vector<int>> nxt(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			if (v[i][j] == '1') {
				int k = j;
				while (k && v[i][k - 1] == '1') {
					k--;
				}
				for (int h = k; h <= j; h++) {
					nxt[i][h] = j;
				}
				j = k;
			}
		}
	}
	int ans = 0;
	auto f = [&](int mid) {
		int ans2 = 0;
		for (int j = 0; j < m; j++) {
			int r = -1, cur = 0;
			deque<pair<int, int>> st;
			for (int l = 0; l < n; l++) {
				if (v[l][j] == '0')continue;
				if (r < l) {
					st = { {nxt[l][j], 1} };
					cur = nxt[l][j] - j + 1;
					ans = max(ans, cur);
					ans2 = max(ans2, cur);
					r = l;
				}
				while (r - l + 1 < mid && r + 1 < n && v[r + 1][j] == '1') {
					int tp = 1;
					while (st.size() && st.back().first >= nxt[r + 1][j]) {
						cur -= (st.back().first - j + 1) * st.back().second;
						tp += st.back().second;
						st.pop_back();
					}
					st.push_back({ nxt[r + 1][j], tp });
					cur += (st.back().first - j + 1) * st.back().second;
					r++;
				}

				ans = max(ans, cur);
				ans2 = max(ans2, cur);

				if (st.front().second == 1) {
					cur -= st.front().first - j + 1;
					st.pop_front();
				}
				else {
					cur -= st.front().first - j + 1;
					st.front().second--;
				}
			}
		}
		return ans2;
	};
	int L = 0, R = n;
	while (L + 2 < R) {
		int lm = L + (R - L) / 3, rm = R - (R - L) / 3;

		if (f(lm) < f(rm)) {
			L = lm;
		}
		else {
			R = rm;
		}
	}
	f(L + 1);
	f(L + 2);
	f(L);
	cout << ans;
}