#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
#include <array>
#define all(v) v.begin(), v.end()
using namespace std;
const int nax = 5e5 + 5;
int dp[nax * 4];
void build(int v, int tl, int tr) {
	if (tl == tr) {
		if (tl == 0) {
			dp[v] = -1;
		}
		else {
			dp[v] = 1e9;
		}
	}
	else {
		int tm = (tl + tr) / 2;
		build(v * 2, tl, tm);
		build(v * 2 + 1, tm + 1, tr);
		dp[v] = min(dp[v * 2], dp[v * 2 + 1]);
	}
}
void update(int v, int tl, int tr, int pos, int x) {
	if (tl == tr) {
		dp[v] = min(dp[v], x);
	}
	else {
		int tm = (tl + tr) / 2;
		if (pos <= tm) {
			update(v * 2, tl, tm, pos, x);
		}
		else {
			update(v * 2 + 1, tm + 1, tr, pos, x);
		}
		dp[v] = min(dp[v * 2], dp[v * 2 + 1]);
	}
}
int query(int v, int tl, int tr, int l, int r) {
	if (l > r) {
		return 1e9;
	}
	if (tl == l && r == tr) {
		return dp[v];
	}
	else {
		int tm = (tl + tr) / 2;
		return min(query(v * 2, tl, tm, l, min(tm, r)), query(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
	}
}
int q(int v, int tl, int tr, int pos) {
	if (tl == tr) {
		return dp[v];
	}
	else {
		int tm = (tl + tr) / 2;
		if (pos <= tm) {
			return q(v * 2, tl, tm, pos);
		}
		else {
			return q(v * 2 + 1, tm + 1, tr, pos);
		}
	}
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<array<int,3>> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i][0] >> v[i][1] >> v[i][2];
	}
	sort(all(v), [&](array<int,3> a, array<int,3> b) {
		return a[2] < b[2];
		});
	build(1, 0, n);
	for (auto p : v) {
		int x = query(1, 0, n, p[0] - 1, p[1] - 1);
		int y = query(1, 0, n, p[0] - 1, n);
		if (x != 1e9 || p[0] >= y + 1) {
			update(1, 0, n, p[2], p[1]);
		}
	}
	if (q(1, 0, n, n) != 1e9) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}