#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
#include <array>
#define all(v) v.begin(), v.end()
#define int long long
#define ll long long
using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	sort(all(v));
	int x, d;
	cin >> x >> d;
	int m;
	cin >> m;

	vector<__int128> A, B;
	for (int i = 0; i < n; i++) {
		if (v[i] < x) {
			A.push_back(v[i]);
		}
		else {
			B.push_back(v[i]);
		}
	}
	vector<__int128> prefAa(A.size() + 1), prefAab(A.size() + 1), prefA(A.size() + 1), prefA2(A.size() + 1);
	for (int i = 0; i < A.size(); i++) {
		__int128 a = x - (x - A[i]) / d * d;
		__int128 b = x - ((x - A[i]) / d + 1) * d;
		prefAa[i + 1] = prefAa[i] + (A[i] - a) * (A[i] - a);
		prefAab[i + 1] = prefAab[i] + min((A[i] - a) * (A[i] - a), (A[i] - b) * (A[i] - b));
		prefA[i + 1] = prefA[i] + A[i];
		prefA2[i + 1] = prefA[i] + A[i] * A[i];
	}
	reverse(all(B));
	vector<__int128> prefBa(B.size() + 1), prefBab(B.size() + 1), prefB(B.size() + 1), prefB2(B.size() + 1);
	for (int i = 0; i < B.size(); i++) {
		__int128 a = x + abs(x - B[i]) / d * d;
		__int128 b = x + (abs(x - B[i]) / d + 1) * d;
		prefBa[i + 1] = prefBa[i] + (B[i] - a) * (B[i] - a);
		prefBab[i + 1] = prefBab[i] + min((B[i] - a) * (B[i] - a), (B[i] - b) * (B[i] - b));
		prefB[i + 1] = prefB[i] + B[i];
		prefB2[i + 1] = prefB[i] + B[i] * B[i];
	}

	auto f = [&](int L, int R, int t) {
		int tp = 0;
		int curr = A.size() - 1;
		int l = 0, r = curr;
		if (A.size()) {
			while (l < r) {
				int mid = (l + r) / 2;
				if ((x - A[mid]) / d + 1 <= L) {
					r = mid;
				}
				else {
					l = mid + 1;
				}
			}
			if (curr >= 0 && (x - A[l]) / d + 1 <= L) {
				tp += prefAab[curr + 1] - prefAab[l];
				curr = l - 1;
			}
			r = curr;
			l = 0;
			while (l < r) {
				int mid = (l + r) / 2;
				if ((x - A[mid]) / d <= L) {
					r = mid;
				}
				else {
					l = mid + 1;
				}
			}
			if (curr >= 0 && (x - A[l]) / d <= L) {
				tp += prefAa[curr + 1] - prefAa[l];
				curr = l - 1;
			}
			if (curr >= 0) {
				tp += prefA2[curr + 1];
				tp += (curr + 1) * (x - d * L) * (x - d * L);
				tp -= 2 * (x - d * L) * prefA[curr + 1];
			}
		}


		curr = B.size() - 1;
		l = 0, r = curr;
		if (B.size()) {
			while (l < r) {
				int mid = (l + r) / 2;
				if (abs(x - B[mid]) / d + 1 <= R) {
					r = mid;
				}
				else {
					l = mid + 1;
				}
			}
			if (curr >= 0 && abs(x - B[l]) / d + 1 <= R) {
				tp += prefBab[curr + 1] - prefBab[l];
				curr = l - 1;
			}
			r = curr;
			l = 0;
			while (l < r) {
				int mid = (l + r) / 2;
				if (abs(x - B[mid]) / d <= R) {
					r = mid;
				}
				else {
					l = mid + 1;
				}
			}
			if (curr >= 0 && abs(x - B[l]) / d <= R) {
				tp += prefBa[curr + 1] - prefBa[l];
				curr = l - 1;
			}
			if (curr >= 0) {
				tp += prefB2[curr + 1];
				tp += (curr + 1) * (x + d * R) * (x + d * R);
				tp -= 2 * (x + d * R) * prefB[curr + 1];
			}
		}

		return tp + t * L + t * R + t * min(L, R);
	};
	auto F = [&](int L, int t) {
		int l = 0, r = 1e9 / d + 100;
		while (l + 2 < r) {
			int lm = l + (r - l) / 3, rm = r - (r - l) / 3;
			if (f(L, lm, t) < f(L, rm, t)) {
				r = rm;
			}
			else {
				l = lm;
			}
		}
		return min({ f(L, l, t), f(L, l + 1, t), f(L, l + 2, t) });
	};
	for (int rep = 0; rep < m; rep++) {
		int t;
		cin >> t;
		int l = 0, r = 1e9 / d + 100;
		while (l + 2 < r) {
			int lm = l + (r - l) / 3, rm = r - (r - l) / 3;
			if (F(lm, t) < F(rm, t)) {
				r = rm;
			}
			else {
				l = lm;
			}
		}
		cout << min({ F(l, t), F(l + 1, t), F(l + 2, t) }) << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}
