#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
#include <array>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
using namespace std;
vector<set<int>> g;

void dfs(int s, int pred) {
	for (auto to : g[s]) {
		if (to != pred) {
			dfs(to, s);
		}
	}
}

void solve() {
	int n;
	cin >> n;
	g.resize(n);
	int d;
	cin >> d;
	vector<int> cnt(n);
	int s = 0;
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].insert(b);
		g[b].insert(a);
	}

	queue<int> q;
	for (int i = 0; i < n; i++) {
		if (g[i].size() == 1) {
			q.push(i);
		}
	}
	set<int> used;
	vector<pair<int,int>> ans;
	while (q.size()) {
		int s = q.front();
		q.pop();
		if (g[s].size() == 0)continue;
		int to = *g[s].begin();
		if (!used.count(to) && !used.count(s)) {
			ans.push_back({ s, to });
			used.insert(to);
			used.insert(s);
		}
		g[to].erase(s);
		if (g[to].size() <= 1) {
			q.push(to);
		}
	}
	cout << ans.size() << "\n";
	for (auto p : ans)cout << p.first + 1 << " " << p.second + 1 << "\n";



}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}