#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>
#include <array>
#include <set>
#include <queue>
#include <bitset>
#define all(v) v.begin(), v.end()
using namespace std;

vector<vector<int>> g;
vector<vector<int>> dist;
int S = 0;
void dfs(int s, int pred) {
	for (auto to : g[s]) {
		if (to != pred) {
			dist[S][to] = dist[S][s] + 1;
			dfs(to, s);
		}
	}
}

void solve() {
	int n;
	cin >> n;
	g.resize(n);
	int d;
	cin >> d;
	int s = 0;
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	dist.assign(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		S = i;
		dfs(i, -1);
	}
	vector<int> dp((1 << n), -1);
	dp[0] = 0;
	vector<pair<int, int>> pred((1 << n), { -1,-1 });
	for (int mask = 1; mask < (1 << n); mask++) {
		bitset<15> B(mask);
		for (int i = 0; i < 15; i++) {
			if (!B[i])continue;
			for (int j = 0; j < 15; j++) {
				if (!B[j] || i == j)continue;
				if (dist[i][j] % 2 && dist[i][j] <= d) {
					if (dp[mask] < dp[mask ^ (1 << i) ^ (1 << j)] + 1) {
						dp[mask] = dp[mask ^ (1 << i) ^ (1 << j)] + 1;
						pred[mask] = { i, j };
					}
				}
			}
		}
	}
	int ans = 0;
	for (int mask = 1; mask < (1 << n); mask++) {
		ans = max(ans, dp[mask]);
	}
	int cur = -1;
	for (int mask = 1; mask < (1 << n); mask++) {
		if (dp[mask] == ans) {
			cur = mask;
			break;
		}
	}
	vector<pair<int, int>> ANS;
	while (cur >= 0 && pred[cur] != make_pair(-1, -1)) {
		ANS.push_back(pred[cur]);
		cur = cur ^ (1 << pred[cur].first) ^ (1 << pred[cur].second);
	}
	cout << ANS.size() << "\n";
	for (auto p : ANS)cout << p.first + 1 << " " << p.second + 1 << "\n";

}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}