#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
using namespace std;

struct bebra {
    int l, m, r;
    bebra() = default;
    bebra(int l, int m, int r) : l(l), m(m), r(r) {}
};

bool cmpM(bebra i, bebra j) {
    return i.m < j.m;
}

bool cmpR(bebra i, bebra j) {
    return i.r < j.r;
}

bool connect(bebra i, bebra j) {
    int l = max(i.l, j.l);
    int r = min(i.r, j.r);
    if (l <= i.m && i.m <= r && l <= j.m && j.m <= r) {
        return false;
    }
    return true;
}

struct ST {

    struct node {
        int mx = 0;
    };

    vector<node> tr;

    ST(int n) {
        tr.resize(4*n, {});
    }

    void modify(int x, int l, int r, int ind, int val) {
        if (r < ind || ind < l) return;
        if (l == r) {
            tr[x].mx = max(tr[x].mx, val);
            return;
        }
        int mid = (l + r) >> 1;
        modify(2 * x + 1, l, mid, ind, val);
        modify(2 * x + 2, mid + 1, r, ind, val);
        tr[x].mx = max(tr[2 * x + 1].mx, tr[2 * x + 2].mx);
    }

    int get(int x, int l, int r, int ll, int rr) {
        if (r < ll || rr < l) return INT_MIN;
        if (ll <= l && r <= rr) return tr[x].mx;
        int mid = (l + r) >> 1;
        return max(get(2 * x + 1, l, mid, ll, rr), get(2 * x + 2, mid + 1, r, ll, rr));
    }
};


void solve() {
    int n, k;
    cin >> n >> k;
    vector<bebra> b(k);
    for (int i = 0; i < k; i++) {
        cin >> b[i].l >> b[i].m >> b[i].r;
    }
    sort(b.begin(), b.end(), cmpR);
    vector<int> dp(k, 0);
    for (int i = 0; i < k; i++) {
        if (b[i].l == 1) {
            dp[i] = 1;
        }
    }
    ST sg1(n + 1), sg2(n + 1);
    for (int i = 0; i < k; i++) {
        int mx1 = sg1.get(0, 1, n, 0, b[i].m - 1);
        int mx2 = sg2.get(0, 1, n, 0, b[i].l - 1);
        if (mx1 >= b[i].l) {
            dp[i] = 1;
        }
        if (mx2 >= b[i].l) {
            dp[i] = 1;
        }
        if (dp[i]) {
            sg1.modify(0, 1, n, b[i].r, b[i].r + 1);
            sg2.modify(0, 1, n, b[i].m, b[i].r + 1);
        }
    }
    for (int i = 0; i < k; i++) {
        if (dp[i] && b[i].r == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}