#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct bebra {
    int l, m, r;
    bebra() = default;
    bebra(int l, int m, int r) : l(l), m(m), r(r) {}
};

bool cmpM(bebra i, bebra j) {
    return i.m < j.m;
}


void solve() {
    int n, k;
    cin >> n >> k;
    vector<bebra> b(k);
    for (int i = 0; i < k; i++) {
        cin >> b[i].l >> b[i].m >> b[i].r;
    }
    sort(b.begin(), b.end(), cmpM);
    vector<int> dp(k);
    for (int i = 0; i < k; i++) {
        if (b[i].l == 1) {
            dp[i] = 1;
        }
    }
    for (int i = 0; i < k; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (dp[j] && b[i].l > b[j].m && b[j].r + 1 >= b[i].l && b[j].r <= b[i].r) {
                dp[i] = 1;
                break;
            }
        }
    }
    vector<int> dp2(k, 0);
    for (int i = 0; i < k; i++) {
        if (b[i].r == n) {
            dp2[i] = 1;
        }
    }
    for (int i = k - 1; i >= 0; i--) {
        for (int j = i + 1; j < k; j++) {
            if (dp2[j] && b[j].l - 1 <= b[i].r && b[i].r < b[j].m && b[i].l <= b[j].l) {
                dp2[i] = 1;
                break;
            }
        }
    }
    for (int i = 0; i < k; i++) {
        if (dp[i] && dp2[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}