#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct bebra {
    int l, m, r;
    bebra() = default;
    bebra(int l, int m, int r) : l(l), m(m), r(r) {}
};

bool cmpM(bebra i, bebra j) {
    return i.m < j.m;
}

bool connect(bebra i, bebra j) {
    int l = max(i.l, j.l);
    int r = min(i.r, j.r);
    if (l <= i.m && i.m <= r && l <= j.m && j.m <= r) {
        return false;
    }
    return true;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<bebra> b(k);
    for (int i = 0; i < k; i++) {
        cin >> b[i].l >> b[i].m >> b[i].r;
    }
    for (int mask = 0; mask < (1 << k); mask++) {
        if (mask == 3) {
            cout<<"";
        }
        vector<int> t;
        for (int i = 0; i < k; i++) {
            if ((mask >> i) & 1) {
                t.push_back(i);
            }
        }
        bool flag = true;
        for (int i = 0; i < t.size(); i++) {
            for (int j = i + 1; j < t.size(); j++) {
                if (!connect(b[t[i]], b[t[j]])) {
                    flag = false;
                }
            }
        }
        if (flag) {
            bool ch = true;
            for (int i = 1; i <= n; i++) {
                bool c = false;
                for (int j : t) {
                    if (b[j].l <= i && i <= b[j].r) {
                        c = true;
                    }
                }
                ch &= c;
            }
            if (ch) {
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}