#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct bebra {
    int l, m, r;
    bebra() = default;
    bebra(int l, int m, int r) : l(l), m(m), r(r) {}
};

bool cmpM(bebra i, bebra j) {
    return i.m < j.m;
}

bool cmpR(bebra i, bebra j) {
    return i.r < j.r;
}

bool connect(bebra i, bebra j) {
    int l = max(i.l, j.l);
    int r = min(i.r, j.r);
    if (l <= i.m && i.m <= r && l <= j.m && j.m <= r) {
        return false;
    }
    return true;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<bebra> b(k);
    for (int i = 0; i < k; i++) {
        cin >> b[i].l >> b[i].m >> b[i].r;
    }
    sort(b.begin(), b.end(), cmpR);
    vector<int> dp(k, 0);
    for (int i = 0; i < k; i++) {
        if (b[i].l == 1) {
            dp[i] = 1;
            break;
        }
    }
    for (int i = 0; i < k; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (b[j].r < b[i].m || b[j].m < b[i].l) {
                if (dp[j] && b[j].r + 1 >= b[i].l) {
                    dp[i] = 1;
                }
            }
        }
    }
    for (int i = 0; i < k; i++) {
        if (dp[i] && b[i].r == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}