#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <functional>
#include <numeric>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    int x0,d;
    cin >> x0 >> d;
    sort(x.begin(), x.end());
    assert(x0 == 0);
    vector<int> closel(n), closer(n);
    for (int i = 0; i < n; i++) {
        closel[i] = d * (x[i] / d);
        closer[i] = closel[i] + d;
    }
    int q;
    cin >> q;
    while (q--) {
        int c;
        cin >> c;
        function<int(int)> f = [&](int Do) {
            int res = 0;
            res += Do * c;
            for (int i = 0; i < n; i++) {
                int l = min(closel[i], d * Do);
                int r = min(closer[i], d * Do);
                int relax = power2(l - x[i]);
                relax = min(relax, power2(r-x[i]));
                res += relax;
            }
            return res;
        };
        int l = 0, r = 1e6 + 11;
        while (l + 3 < r) {
            int mid = (l + r) >> 1;
            if (f(mid) > f(mid+1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        int ans = 0;
        for (int Do = l; Do <= r; Do++) {
            int ff = f(Do);
            if (Do == l || ff < ans) {
                ans = ff;
            }
        }
        cout << ans << '\n';
    }
}