#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <functional>
#include <numeric>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n;
    cin >> n;
    assert(n == 1);
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
    }
    int x0,d;
    cin >> x0 >> d;
    sort(x.begin(), x.end());
    int q;
    cin >> q;
    while (q--) {
        int c;
        cin >> c;
        function<int(int)> f = [&](int Do) {
            int cord;
            if (x0 < x[0]) {
                cord = x0 + Do * d;
            } else {
                cord = x0 - Do * d;
            }
            return Do * c + power2(cord - x[0]);
        };
        int l = 0, r = abs(x0 - x[0]) / d + 1;
        while (l + 1 < r) {
            int mid = (l + r) >> 1;
            if (f(mid) < f(mid+1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        int ans = 0;
        for (int Do = l; Do <= r; Do++) {
            int ff = f(Do);
            if (Do == l || ff < ans) {
                ans = ff;
            }
        }
        cout << ans << '\n';
    }
}
/*
1
2
3
4
4
4
4
 */