#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <functional>
#include <numeric>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> dp(n, vector<int>(2));
    function<void(int, int)> dfs = [&](int v, int p) {
        int sum = 0;
        for (auto& to : g[v]) {
            if (to == p) continue;
            dfs(to, v);
            dp[v][0] += max(dp[to][0], dp[to][1]);
            sum += max(dp[to][0], dp[to][1]);
        }
        for (auto& to : g[v]) {
            if (to == p) continue;
            sum -= max(dp[to][0], dp[to][1]);
            dp[v][1] = max(dp[v][1], sum + 1 + dp[to][0]);
            sum += max(dp[to][0], dp[to][1]);
        }
    };
    dfs(0, 0);
    cout << max(dp[0][0], dp[0][1]) << '\n';
}
