#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <functional>
#include <numeric>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    assert(d == n - 1);
    vector<int> depth(n);
    function<void(int, int)> dfs = [&](int v, int p) {
        for (auto& to : g[v]) {
            if (to == p) continue;
            depth[to] = (depth[v] + 1) % 2;
            dfs(to, v);
        }
    };
    dfs(0, 0);
    vector<int> a, b;
    for (int i = 0; i < n; i++) {
        if (depth[i] == 0) {
            a.push_back(i);
        } else {
            b.push_back(i);
        }
    }
    cout << min(a.size(), b.size()) << '\n';
    while (!(a.empty() || b.empty())) {
        cout << a.back() + 1 << ' ' << b.back() + 1 << '\n';
        a.pop_back();
        b.pop_back();
    }
}
