#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <functional>
#include <map>
#include <numeric>
#include <set>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g2(n, vector<int>(n, INT_MAX));
    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }
    assert(n <= 14);
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                g2[i][j] = min(g2[i][j], g2[i][k] + g2[k][j]);
            }
        }
    }
    vector<int> used(n);
    vector<pair<int, int>> ans;
    vector<pair<int, int>> f;
    function<void()> gen = [&]() {
        if (ans.size() > f.size()) {
            f = ans;
        }
        for (int i = 0; i < n; i++) {
            if (used[i]) continue;
            for (int j = 0; j < n; j++) {
                if (used[j]) continue;
                if (g2[i][j] <= d && g2[i][j] % 2) {
                    ans.emplace_back(i, j);
                    used[i] = true;
                    used[j] = true;
                    gen();
                    ans.pop_back();
                    used[i] = false;
                    used[j] = false;
                }
            }
        }
    };
    gen();
    cout << f.size() << '\n';
    for (auto& [i,j] : f) {
        cout << i+1 << ' ' << j+1 << '\n';
    }
}
