#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <climits>
#include <functional>
#include <numeric>
#define int __int128
using namespace std;


istream& operator >> (istream& in, int& x) {
    long long xx;
    in >> xx;
    x = xx;
    return in;
}

ostream& operator << (ostream& out, int x) {
    out << (long long)x;
    return out;
}

int power2(int x) {
    return x*x;
}
#ifndef LOCAL
int abs(int x) {
    return x>0?x:-x;
}
#endif

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    vector<int> depth(n);
    vector<vector<int>> dist(n, vector<int>(n, INT_MAX));
    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        dist[u][v] = dist[v][u] = 1;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    vector<int> left, right;
    function<void(int, int, int)> dfs = [&](int v, int p, int c) {
        if (c) left.push_back(v);
        else right.push_back(v);
        for (auto& to : g[v]) {
            if (to == p) continue;
            depth[to] = depth[v] ^ 1;
            dfs(to, v, c^1);
        }
    };
    dfs(0, 0, 0);
    vector<vector<int>> g2(left.size());
    for (int i = 0; i < left.size(); i++) {
        int u = left[i];
        for (int j = 0; j < right.size(); j++) {
            int v = right[j];
            if (dist[u][v] <= d) {
                g2[i].push_back(j);
            }
        }
    }
    vector<int> mt(right.size(), -1);
    vector<int> used(left.size());
    function<bool(int)> try_kuhn = [&](int v) {
        used[v] = true;
        for (auto& to : g2[v]) {
            if (mt[to] == -1) {
                mt[to] = v;
                return true;
            }
        }
        for (auto& to : g2[v]) {
            if (!used[mt[to]] && try_kuhn(mt[to])) {
                mt[to] = v;
                return true;
            }
        }
        return false;
    };
    for (int i = 0; i < left.size(); i++) {
        used.assign(left.size(), false);
        try_kuhn(i);
    }
    cout << right.size()-count(mt.begin(),mt.end(),-1) << '\n';
    for (int i = 0; i < right.size(); i++) {
        if (mt[i] != -1)
            cout << left[mt[i]]+1 << ' ' << right[i]+1 << '\n';
    }
}