#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {

	int h, w;
	cin >> h >> w;

	vector<vector<char>> v(h, vector<char> (w));
	for(auto &x : v) {
		for(auto &y : x) {
			cin >> y;
			y -= '0';
		}
	}

	vector<pair<int, int>> tops;
	for(int i = 0; i < h; i++) {
		for(int j = 0; j < w; j++) {
			if(!v[i][j]) continue;
			if(i == 0 || !v[i - 1][j]) tops.push_back({i, j});
		}
	}

	vector<vector<int>> zeros(h, vector<int> (w, w));
	for(int i = 0; i < h; i++) {
		int p = 0;
		for(int j = 0; j < w; j++) {
			if(v[i][j] == 0) {
				for(int k = p; k <= j; k++)
					zeros[i][k] = j;
				p = j + 1;
			}
		}
	}

	int total = 0;
	for(auto [i, j] : tops) {
		int n = 1;
		while(i + n < h && v[i + n][j])
			n++;
		vector<int> sizes(n);
		for(int k = 0; k < n; k++)
			sizes[k] = zeros[i + k][j] - j;
		
		vector<int> prevSmaller(n, -1);
		stack<int> st;
		for(int k = n - 1; k >= 0; k--) {
			while(st.size() && sizes[st.top()] >= sizes[k]) {
				prevSmaller[st.top()] = k;
				st.pop();
			}
			st.push(k);
		}

		vector<int> ans(n);
		ans[0] = sizes[0];
		total = max(total, ans[0]);
		for(int k = 1; k < n; k++) {
			int curr = (prevSmaller[k] == -1) ? 0 : ans[prevSmaller[k]];
			curr += (k - prevSmaller[k]) * sizes[k];
			ans[k] = curr;
		}
		for(auto x : ans)
			total = max(total, x);
	}

	cout << total << endl;
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int t = 1;
	//cin >> t;

	while(t--) solve();
}
