#include <bits/stdc++.h>

#define int long long

using namespace std;

struct Dia {
	int l, m, r;
};

int treeSize;
vector<int> tree;

void setVal(int x, int lx, int rx, int p, int val) {
	if(rx - lx == 1) {
		tree[x] = val;
		return;
	}
	int mid = (lx + rx) / 2;
	if(p < mid) setVal(x * 2, lx, mid, p, val);
	else setVal(x * 2 + 1, mid, rx, p, val);
	tree[x] = tree[x * 2] + tree[x * 2 + 1];
}

int getSum(int x, int lx, int rx, int l, int r) {
	if(r <= lx || rx <= l) return 0;
	if(l <= lx && rx <= r) return tree[x];
	int mid = (lx + rx) / 2;
	return getSum(x * 2, lx, mid, l, r) + getSum(x * 2 + 1, mid, rx, l, r);
}

mt19937 rnd(time(0));

struct Node {
	Node *l;
	Node *r;
	int val;
	int ans;
	int minAns;
	int prio;
	Node(int ri, int mi) {
		l = nullptr;
		r = nullptr;
		val = mi;
		ans = ri;
		minAns = ri;
		prio = rnd();
	}
};

int getAns(Node *u) {
	if(u == nullptr) return 1e12;
	return u->minAns;
}

void update(Node *u) {
	if(u == nullptr) return;
	u->minAns = min({u->ans, getAns(u->l), getAns(u->r)});
}

Node *merge(Node *l, Node *r) {
	if(l == nullptr) return r;
	if(r == nullptr) return l;
	if(l->prio < r->prio) {
		auto u = merge(l, r->l);
		r->l = u;
		update(r);
		return r;
	} else {
		auto u = merge(l->r, r);
		l->r = u;
		update(l);
		return l;
	}
}

pair<Node*, Node*> split(Node *u, int val) {
	if(u == nullptr) return {u, u};
	if(u->val < val) {
		auto [l, r] = split(u->r, val);
		u->r = l;
		update(u);
		return {u, r};
	} else {
		auto [l, r] = split(u->l, val);
		u->l = r;
		update(u);
		return {l, u};
	}
}

Node *insert(Node *u, int mi, int ri) {
	auto [l, r] = split(u, mi);
	return merge(l, merge(new Node(mi, ri), r));
}

void solve() {

	int n, k;
	cin >> n >> k;

	vector<Dia> v(k);
	for(auto &x : v) {
		cin >> x.l >> x.m >> x.r;
		x.l--, x.m--, x.r--;
	}
	sort(v.begin(), v.end(), [](auto a, auto b) {
		return a.m < b.m;
	});

	treeSize = 1;
	while(treeSize <= n)
		treeSize *= 2;

	tree = vector<int> (treeSize * 2);
	setVal(1, 0, treeSize, 0, 1);

	Node *u = nullptr;

	for(auto x : v) {
		if(getSum(1, 0, treeSize, x.l, x.m + 1)) {
			u = insert(u, x.m, x.r);
			setVal(1, 0, treeSize, x.r + 1, 1);
			continue;
		}
		auto [r1, r23] = split(u, x.l - 1);
		auto [r2, r3] = split(r23, x.r + 1);
		if(getAns(r2) < x.l) {
			u = merge(r1, merge(r2, r3));
			u = insert(u, x.m, x.r);
			setVal(1, 0, treeSize, x.r + 1, 1);
		} else {
			u = merge(r1, merge(r2, r3));
		}
	}

	if(getSum(1, 0, treeSize, n, n + 1)) cout << "YES" << endl;
	else cout << "NO" << endl;
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int t = 1;
	cin >> t;

	while(t--) solve();
}
