#include <bits/stdc++.h>
#define int long long

const int MAXN = 4 * 1e5;
const int LOGN = 20;

int up[MAXN][LOGN];
int h[MAXN];

std ::vector<int> bfs(int start, std::vector<std::vector<int>> &g)
{
    std::vector<int> dist(g.size(), 1e18);
    dist[start] = 0;
    std::queue<int> q;
    q.push(start);

    while (!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int u : g[v])
        {
            if (dist[u] > dist[v] + 1)
            {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    return dist;
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n;
    std::cin >> n;
    int d;
    std::cin >> d;

    std::vector<std::vector<int>> g(n);

    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        std::cin >> a >> b;

        a--, b--;

        g[a].push_back(b);
        g[b].push_back(a);
    }

    std::vector<std ::vector<int>> dist(n, std::vector<int>(n));
    for (int i = 0; i < n; i++)
    {
        dist[i] = bfs(i, g);
    }
    std::vector<int> dp(1 << n);
    std::vector<int> prev((1 << n), 0);
    dp[0] = 1;
    int max = 0;
    int now = 0;
    for (int i = 0; i < (1 << n); i++)
    {
        if (dp[i] == 0)
        {
            continue;
        }
        if (__builtin_popcount(i) / 2 > max)
        {
            now = i;
            max = __builtin_popcount(i) / 2;
        }
        for (int j = 0; j < n; j++)
        {
            if ((i >> j) & 1)
                continue;
            for (int k = 0; k < n; k++)
            {
                if ((i >> k) & 1)
                    continue;
                if (k == j)
                {
                    continue;
                }
                int dt = dist[j][k];
                // std::cout << dt << std::endl;
                if (dt <= d && dt % 2 != 0)
                {
                    int x = i;
                    x |= (1 << j);
                    x |= (1 << k);
                    dp[x] = 1;
                    prev[x] = i;
                }
            }
        }
    }
    std::cout << max << std::endl;
    std::vector<std::pair<int, int>> ans;
    while (now != 0)
    {
        int x = now ^ prev[now];
        int first = -1;
        int second = -1;
        for (int j = 0; j < n; j++)

        {
            if ((x >> j) & 1)
            {
                if (first == -1)
                {
                    first = j;
                }
                else
                {
                    second = j;
                }
            }
        }

        ans.push_back({first + 1, second + 1});
        now = prev[now];
    }
    for (auto j : ans)
    {
        std::cout << j.first << ' ' << j.second << std::endl;
    }
}