#include <iostream>
#include <stack>

using namespace std;

int main() {
    int h, w; cin >> h >> w;
    int area[h][w], mxseg[h][w], nxt[h][w], dp[h][w];

    for (int i = 0; i < h; i++) {
        string s; cin >> s;
        for (int j = 0; j < w; j++) {
            area[i][j] = s[j] - '0';
            mxseg[i][j] = 0;
            nxt[i][j] = -1;
            dp[i][j] = 0;
        }
    }

    for (int i = 0; i < h; i++) {
        for (int j = w - 1; j >= 0; j--) {
            if (area[i][j] == 0) {
                continue;
            } else if (j == w - 1) {
                mxseg[i][j] = 1;
            } else {
                mxseg[i][j] = 1 + mxseg[i][j + 1];
            }
        }
    }

    for (int j = 0; j < w; j++) {
        stack<int> st;
        for (int i = h-1; i >= 0; i--) {
            while (!st.empty() && mxseg[st.top()][j] >= mxseg[i][j]) {
                nxt[st.top()][j] = i;
                st.pop();
            }
            st.push(i);
        }
    }

    int ans = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (nxt[i][j] == -1) {
                dp[i][j] = mxseg[i][j] * (i + 1);
            } else {
                dp[i][j] = mxseg[i][j] * (i - nxt[i][j]) + dp[nxt[i][j]][j];
            }
            ans = max(ans, dp[i][j]);
        }
    }

    cout << ans << '\n';
}