#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}


template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}
void Solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (auto &x : a) {
        for (auto &y : x) {
            char c;
            cin >> c;
            y = c - '0';
        }
    }
    //cout << "*" << endl;
    vector<vector<ll>> u(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
        u[i][m - 1] = a[i][m - 1];
        for (int j = m - 2; j >= 0; --j) {
            u[i][j] = (u[i - 1][j] + a[i][j]) * a[i][j];
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, 0));
    dp[0] = u[0];
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] && u[i][j] >= u[i - 1][j]) dp[i][j] = dp[i - 1][j] + u[i][j]; 
        }
    }
    ll mx = 0;
    for (auto &x : dp) mx = max(mx, *max_element(all(x)));
    cout << mx;
}
int main() {
    Solve();
}