#include <algorithm>
#include <iostream>
#include <vector>
 
using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
 
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
 
 
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
 
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}
void Solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (auto &x : a) {
        for (auto &y : x) {
            char c;
            cin >> c;
            y = c - '0';
        }
    }
    //cout << "*" << endl;
    vector<vector<ll>> u(n, vector<ll>(m));
    vector<vector<ll>> p(n, vector<ll>(m));
    u[0] = a[0];
    p[0][m - 1] = 0;
    for (int j = n - 2; j >= 0; --j) {
        if (a[0][j + 1]) p[0][j] = p[0][j + 1] + u[0][j + 1];
        else p[0][j] = 0;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) u[i][j] = (u[i - 1][j] + a[i][j]) * a[i][j];
        p[i][m - 1] = 0;
        for (int j = m - 2; j >= 0; --j) {
            if (a[i][j + 1]) p[i][j] = p[i][j + 1] + u[i][j + 1];
            else p[i][j] = 0;
        }
    }
    //cout << "**" << endl;
    vector<vector<ll>> dp(n, vector<ll>(m, 0));
    for (int i = 0; i < n; ++i) {
        dp[i][m - 1] = u[i][m - 1];
        for (int j = m - 2; j >= 0; --j) {
            if (!a[i][j]) {
                dp[i][j] = 0;
                continue;;
            }
            if (u[i][j] >= u[i][j + 1]) dp[i][j] = dp[i][j + 1] + u[i][j];
            else dp[i][j] = dp[i][j + 1] + u[i][j] - p[i - u[i][j]][j];
        }
    }
    //cout << "***" << endl;
    ll mx = 0;
    for (auto &x : dp) mx = max(mx, *max_element(all(x)));
    cout << mx;
}
int main() {
    Solve();
}