#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
  
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
  
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
  
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}
struct SegTree {
    vector<ll> t;
    void upd(ll v, ll lx, ll rx, ll i, ll x) {
        if (lx == rx - 1) {
            t[v] = x;
            return;
        }
        ll mid = lx + rx >> 1;
        if (i < mid) upd(v * 2, lx, mid, i, x);
        else upd(v * 2 + 1, mid, rx, i, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]); 
    }
    ll ans(ll v, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) return t[v];
        if (lx >= r || l >= rx) return 1e18;
        ll mid = lx + rx >> 1;
        return min(ans(v * 2, lx, mid, l, r), ans(v * 2 + 1, mid, rx, l, r));
    }

    SegTree (ll n) : t(4 * (n + 1), 1e18) {}
};

void Solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (auto &x : a) {
        for (auto &y : x) {
            char c;
            cin >> c;
            y = c - '0';
        }
    }
    //cout << "*" << endl;
    vector<vector<ll>> u(n, vector<ll>(m));
    u[0] = a[0];
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) u[i][j] = (u[i - 1][j] + a[i][j]) * a[i][j];
    }
    vector<vector<ll>> p(n, vector<ll>(m + 1, 0));
    for (int i = 0; i < n; ++i) {
        partial_sum(all(u[i]), p[i].begin() + 1);
    }
    vector<vector<ll>> fn(n, vector<ll>(m, 1e18));
    for (int i = 0; i < n; ++i) {
        if (!a[i][m - 1]) fn[i][m - 1] = m - 1;
        for (int j = m - 2; j >= 0; --j) {
            if (!a[i][j]) fn[i][j] = j;
            else fn[i][j] = fn[i][j + 1];
        }
    }
    vector<vector<ll>> d(n, vector<ll>(m, 0));
    vector<vector<ll>> dp(n, vector<ll>(m, 0));
    for (int i = 0; i < n; ++i) {
        d[i][m - 1] = dp[i][m - 1] = u[i][m - 1];
        for (int j = m - 2; j >= 0; --j) {
            if (!a[i][j]) continue;
            d[i][j] = d[i][j + 1] + u[i][j];
            if (u[i][j] >= u[i][j + 1]) dp[i][j] = dp[i][j + 1] + u[i][j];
            else dp[i][j] = d[i][j] - (p[i - u[i][j]][min(fn[i][j], m)] - p[i - u[i][j]][j + 1]);
        }
    }
    ll mx = 0;
    for (auto &x : dp) mx = max(mx, *max_element(all(x)));
    cout << mx;
}
int main() {
    Solve();
}