#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
#define ff first 
#define ss second
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
  
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
  
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}

struct SegTree {
    vector<ll> t;
    vector<ll> p;
    void upd(ll v, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) {
            ++t[v];
            ++p[v];
            return;
        }
        if (lx > r || l > rx) return;
        ll mid = lx + rx >> 1;
        upd(v * 2, lx, mid, l, r);
        upd(v * 2 + 1, mid + 1, rx, l, r);
        t[v] = min(t[v * 2], t[v * 2 + 1]) + p[v];
    }
    ll ans() {
        return t[1];
    }
    SegTree (ll n) : t(4 * n, 0), p(4 * n, 0) {}
};

void Solve() {
    ll n, k;
    cin >> n >> k;
    vector<pair<pair<ll, ll>, ll>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].ff.ff >> a[i].ss >> a[i].ff.ss; 
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j) continue;
            if (a[i].ss >= a[j].ff.ff && a[i].ss <= a[j].ff.ss && a[j].ss >= a[i].ff.ff && a[j].ss <= a[i].ff.ss) {
                cout << "NO\n";
                continue;
            }
        }
    }
    sort(all(a), [&](pair<pair<ll, ll>, ll> &x, pair<pair<ll, ll>, ll> &y) {
        if (x.ss >= y.ff.ff && x.ss <= y.ff.ss) return true;
        if (y.ss >= x.ff.ss && y.ss <= x.ff.ss) return false;
        return (x.ff < y.ff);
    });
    SegTree st(n);
    for (auto &x : a) {
        st.upd(1, 1, n, x.ff.ff, x.ff.ss);
    }
    if (!st.ans()) cout << "NO\n";
    else cout << "YES\n";
}
int main() {
    ll t;
    cin >> t;
    while (t--) Solve();
}