#include <algorithm>
#include <iostream>
#include <vector>
  
using namespace std;
#define all(x) (x).begin(), (x).end()
using ll = long long;
  
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &x : a) in >> x;
    return in;
}
  
  
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (T &x : a) out << x << ' ';
    return out;
}
  
template<typename T>
ostream &operator<<(ostream &out, vector<vector<T>> &a) {
    for (auto &x : a) out << x << '\n';
    return out;
}

vector<pair<ll, ll>> ans;
vector<bool> used;

void dfs(ll v, vector<vector<ll>> &g, ll p = -1) {
    for (ll u : g[v]) {
        if (u != p) {
            dfs(u, g, v);
            if (!used[v] && !used[u]) {
                used[v] = used[u] = 1;
                ans.push_back({u, v});
            }
        }
    }
}

void Solve() {
    ll n, d;
    cin >> n >> d;
    vector<vector<ll>> g(n + 1);
    for (ll u, v, i = 0; i < n - 1; ++i) {
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    used.resize(n + 1, 0);
    dfs(1, g);
    cout << ans.size() << '\n';
    for (auto &x : ans) cout << x.first << ' ' << x.second << '\n';
}
int main() {
  Solve();
}