#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace __gnu_pbds;
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi2,fma")

using ll = long long;
using i128 = __int128;

//#define int long long

const int inf = 1'000'000'000;

int get(int x, int d){
    if((x % d) * 2 <= d){
        return (x - x % d);
    }else{
        return ((x + d - 1) / d) * d;
    }
}

struct prefsum128{
    vector<i128> p;
    void init(vector<int> a){
        int n = a.size();
        p.resize(n + 1);
        for(int i = 0; i < n; i++){
            p[i + 1] = p[i] + ((ll)a[i]) * a[i];
        }
    }
    i128 get(int l, int r){
        return (p[r] - p[l]);
    }
};

struct prefsumll{
    vector<ll> p;
    void init(vector<int> a){
        int n = a.size();
        p.resize(n + 1);
        for(int i = 0; i < n; i++){
            p[i + 1] = p[i] + a[i];
        }
    }
    ll get(int l, int r){
        return (p[r] - p[l]);
    }
};

struct prefsumll2{
    vector<ll> p;
    void init(vector<ll> a){
        int n = a.size();
        p.resize(n + 1);
        for(int i = 0; i < n; i++){
            p[i + 1] = p[i] + a[i];
        }
    }
    ll get(int l, int r){
        return (p[r] - p[l]);
    }
};


istream& operator>> (istream& in, __int128 &a){
    long long z;
    in >> z;
    a = z;
    return in;
}

ostream& operator<< (ostream& out, __int128 a){
    cout << (long long)a;
    return out;
}


struct solver{
    vector<int> start, next;
    vector<int> a;
    prefsumll p;
    prefsumll2 best;
    prefsum128 pk;
    ll d;
    int n;
    solver(vector<int> a1, int d1){
        a = a1;
        d = d1;
        sort(a.begin(), a.end());
        n = a.size();
        p.init(a);
        pk.init(a);
        vector<ll> aa(n);
        for(int i = 0; i < n; i++){
            ll x = a[i] - get(a[i], d);
            aa[i] = x * x;
        }
        start.resize(n);
        next.resize(n);
        for(int i = 0; i < n; i++){
            start[i] = get(a[i], d);
        }
        for(int i = n - 1; i >= 0; i--){
            if(i == n - 1){
                next[i] = n;
            }else{
                if(start[i] != start[i + 1]){
                    next[i] = i + 1;
                }else{
                    next[i] = next[i + 1];
                }
            }
        }
        best.init(aa);
    }
    i128 getz(int ind, ll x){
        i128 ans = best.get(0, ind) - x * 2 * p.get(ind, n) + x * x * (n - ind) + pk.get(ind, n) ;
        return ans;
    }
    i128 getzz(ll x, ll v){
        int ind1 = upper_bound(a.begin(), a.end(), x) - a.begin();
        i128 ans1 = getz(ind1, x) + v * (x / d);
        return ans1;
    }
    gp_hash_table<int, int> g;
    i128 pr(int x, int v){
        if(g.find(x) == g.end()){
            g[x] = upper_bound(a.begin(), a.end(), x) - a.begin();
        }
        int ind1 = g[x];
        int ind2 = ind1;
        if((ind1 != n) && (start[ind1] <= x + d)){
            ind2 = next[ind1];
        }
        i128 ans1 = getz(ind1, x) + (ll)v * (x / d), ans2 = getz(ind2, x + d) + v * (x / d + 1);
        return (ans2 - ans1);
    }
    ll getans(ll v){
        if(a.empty()){
            return 0;
        }
        int l = -1, r = a.back() / d + 2;
        while(l + 1 != r){
            int m = (l + r) / 2;
            if(pr(m * d, v) < 0){
                l = m;
            }else{
                r = m;
            }
        }
        return getzz(r * d, v);
    }
};


void solve(){
    int n;
    cin >> n;
    vector<int> _(n);
    for(int i = 0; i < n; i++){
        cin >> _[i];
    }    
    int x0, d;
    cin >> x0 >> d;
    vector<int> a1, b1;
    for(auto i : _){
        if(i > x0){
            a1.push_back(i - x0);
        }else if(i < x0){
            b1.push_back(x0 - i);
        }
    }
    solver a(a1, d), b(b1, d);
    int q;
    cin >> q;
    while(q--){
        ll v;
        cin >> v;
        ll ans = min(a.getans(v) + b.getans(2 * v), a.getans(2 * v) + b.getans(v));
        cout << ans << endl;
    }
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}