#include <bits/stdc++.h>

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
using ll = long long;

struct point {
    ll l, m, r;
};

const ll N = 5e5 + 1;

class Wise_Tree {
    std::vector<ll> tree;

public:
    Wise_Tree() {
        tree.resize(N * 4);
    }

    void upd(ll i, ll x, ll v = 0, ll l = 0, ll r = N) {
        if (r <= i || i < l) return;
        if (r - l == 1) {
            tree[v] = x;
            return;
        }
        upd(i, x, v * 2 + 1, l, (l + r) >> 1), upd(i, x, v * 2 + 2, (l + r) >> 1, r);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    ll get(ll ql, ll qr, ll v = 0, ll l = 0, ll r = N) {
        if (r <= ql || qr <= l) return 0;
        if (ql <= l && r <= qr) return tree[v];
        return get(ql, qr, v * 2 + 1, l, (l + r) >> 1) + get(ql, qr, v * 2 + 2, (l + r) >> 1, r);
    }
};

void s1nmeee() {
    ll n, k;
    std::cin >> n >> k;
    std::vector<point> a(k);
    for (auto &[l, m, r]: a) std::cin >> l >> m >> r;
    std::sort(a.begin(), a.end(), [](point x, point y) {
       return x.r < y.r;
    });
    Wise_Tree tree;
    tree.upd(0, 1);
    for (auto [l, m, r]: a) {
        ll p = tree.get(l - 1, m);
        if (p == 0) continue;
        tree.upd(r, 1);
    }
    if (tree.get(n, n + 1) == 1) std::cout << "YES"; else std::cout << "NO";
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}