#include <bits/stdc++.h>
#define int long long
using namespace std;

struct SegTree {
    int n;
    vector<pair<int, int>> tree;
    vector<int> add;

    SegTree(int sz) {
        n = sz;
        tree.resize(n * 4, {0, 0});
        add.resize(n * 4, 0);
    }

    void push(int v) {
        if (add[v] == 1) {
            if (v * 2 + 1 < n * 4) {
                tree[v * 2] = {0, 0};
                add[v * 2] = 1;
                tree[v * 2 + 1] = {0, 0};
                add[v * 2 + 1] = 1;
            }
        }
        add[v] = 0;
    }

    void update(int v, int l, int r, int ql, int qr, pair<int, int> x) {
        if (qr <= l || r <= ql) return;
        if (ql <= l && r <= qr) {
            tree[v] = x;
            add[v] = 1;
            return;
        }
        int m = (l + r) / 2;
        push(v);
        update(v * 2, l, m, ql, qr, x);
        update(v * 2 + 1, m, r, ql, qr, x);
        tree[v].first = tree[v * 2].first + tree[v * 2 + 1].first;
        tree[v].second = tree[v * 2].second + tree[v * 2 + 1].second;
    }

    pair<int, int> get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return {0, 0};
        if (ql <= l && r <= qr) return tree[v];
        int m = (l + r) / 2;
        push(v);
        pair<int, int> ansl = get(v * 2, l, m, ql, qr), ansr = get(v * 2 + 1, m, r, ql, qr), ans;
        ans.first = ansl.first + ansr.first;
        ans.second = ansl.second + ansr.second;
        return ans;
    }
};

int solve1(int n, int m, vector<vector<char>> mx) {
    vector<vector<int>> hor(n, vector<int> (m)), vert(n, vector<int> (m)), dif(n, vector<int> (m));
    for (int j = 0; j < m; j++) {
        int h = 0;
        for (int i = 0; i < n; i++) {
            if (mx[i][j] == '1') h++;
            else h = 0;
            vert[i][j] = h;
        }
    }
    for (int i = 0; i < n; i++) {
        int l = 0;
        int r = m;
        for (int j = m - 1; j >= 0; j--) {
            if (mx[i][j] == '1') l++;
            else l = 0;
            hor[i][j] = l;
        }
    }
    for (int i = 0; i < n; i++) {
        SegTree t(n + 1);
        int sm = 0;
        int mn = n + 1;
        for (int j = m - 1; j >= 0; j--) {
            if (mx[i][j] == '0') {
                t.update(1, 0, n + 1, 0, n + 1, {0, 0});
                sm = 0;
                mn = n + 1;
            } else {
                if (vert[i][j] < mn) {
                    pair<int, int> l = t.get(1, 0, n + 1, vert[i][j], mn), r = t.get(1, 0, n + 1, mn, n + 1);
                    sm += l.first - l.second * vert[i][j] + r.second * (mn - vert[i][j]);
                    mn = vert[i][j];
                }
                pair<int, int> x = t.get(1, 0, n + 1, vert[i][j], vert[i][j] + 1);
                x.first += vert[i][j];
                x.second++;
                t.update(1, 0, n + 1, vert[i][j], vert[i][j] + 1, x);
                if (i == 3) {
                    cout << t.get(1, 0, n + 1, vert[i][j], vert[i][j] + 1).first << " AAAA" << endl;
                }
            }
            dif[i][j] = sm;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < m; j++) {
            vert[i][j] += vert[i][j - 1];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << dif[i][j] << ' ';
        }
        cout << endl;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int d = 0;
            if (j) d = vert[i][j - 1];
            if (!hor[i][j]) continue;
            ans = max(ans, vert[i][j + hor[i][j] - 1] - d - dif[i][j]);
            if (ans == 12) {
                cout << i << ' ' << j << endl;
            }
        }
    }
    return ans;
}

int solve2(int n, int m, vector<vector<char>> mx) {
    int ans = 0;
    vector<vector<int>> vert(n, vector<int> (m));
    for (int j = 0; j < m; j++) {
        int h = 0;
        for (int i = 0; i < n; i++) {
            if (mx[i][j] == '1') h++;
            else h = 0;
            vert[i][j] = h;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int lst = n, sm = 0;
            for (int k = j; k < m; k++) {
                sm += min(lst, vert[i][k]);
                lst = min(lst, vert[i][k]);
            }
            ans = max(ans, sm);
        }
    }
    return ans;
}

mt19937 rnd(179);
// TIP To <b>Run</b> code, press <shortcut actionId="Run"/> or
// click the <icon src="AllIcons.Actions.Execute"/> icon in the gutter.
signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> mx(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mx[i][j];
        }
    }
    cout << solve2(n, m, mx);
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.