#include <bits/stdc++.h>
#define int long long
using namespace std;

struct SegTree {
    int n;
    vector<int> tree;

    SegTree(int sz) {
        n = sz;
        tree.resize(n * 4, -1e9);
    }

    void update(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            tree[v] = x;
            return;
        }

        int m = (l + r) / 2;
        if (ind < m) {
            update(v * 2, l, m, ind, x);
        } else {
            update(v * 2 + 1, m, r, ind, x);
        }
        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return -1e9;
        if (ql <= l && r <= qr) return tree[v];
        int m = (l + r) / 2;
        return max(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
    }
};
// TIP To <b>Run</b> code, press <shortcut actionId="Run"/> or
// click the <icon src="AllIcons.Actions.Execute"/> icon in the gutter.
signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> mx(n, vector<char> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mx[i][j];
        }
    }
    vector<vector<int>> hor(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        int l = 0;
        int r = m;
        for (int j = m - 1; j >= 0; j--) {
            if (mx[i][j] == '1') l++;
            else l = 0;
            hor[i][j] = l;
        }
    }
    int ans = 0;
    vector<vector<int>> res(n, vector<int> (m));
    for (int j = 0; j < m; j++) {
        SegTree t(m + 1);
        int cur = 0;
        int lst = 0;
        int ind = -1;
        for (int i = 0; i < n; i++) {
            if (mx[i][j] == '0') {
                ans = max(ans, cur);
                cur = 0;
                ind = i;
                lst = 0;
            }
            else {
                if (hor[i][j] >= lst) {
                    cur += hor[i][j];
                } else {
                    int k = t.get(1, 0, n, 0, hor[i][j]);
                    if (k == -1e9 || k <= ind) {
                        cur = hor[i][j] * (i - ind);
                    } else {
                        cur = hor[i][j] * (i - k) + res[k][j];
                    }
                }
            }
            res[i][j] = cur;
            ans = max(ans, cur);
            lst = hor[i][j];
            t.update(1, 0, n, hor[i][j], i);
        }
    }
    cout << ans;
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.