#include <bits/stdc++.h>

using namespace std;

#define int long long

struct node {
    int l, r, m;
};

bool comp(node a, node b) {
    return a.l < b.l;
}

int inf = (int) 1000 * 1000 * 1000;

struct st { //get mx, max= in point
    vector <int> t;

    void build(int n) {
        t.resize(4 * n, -inf);
    }

    int get(int v, int l, int r, int ll, int rr) {
        if (ll > rr) {
            return -inf;
        }
        if (l == ll && r == rr)
        {
            return t[v];
        }
        int m = (l + r) / 2;
        return max(get(v * 2 + 1, l, m, ll, min(m, rr)), get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr));
    }

    void update(int v, int l, int r, int i, int x) {
        if (l == r)
        {
            t[v] = max(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            update(v * 2 + 1, l, m, i, x);
        }
        else {
            update(v * 2 + 2, m + 1, r, i, x);
        }
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int get(int l, int r) {
        return get(0, 0, t.size() / 4 - 1, l, r);
    }

    void update(int i, int x) {
        update(0, 0, t.size() / 4 - 1, i, x);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector <node> a(k);

    for (int i = 0; i < k; i ++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
    }

    sort(a.begin(), a.end(), comp);

    vector <bool> dp(k);

    st t;
    t.build(n + 1);

    set <int> s_l;

    if (a[k - 1].r == n) {
        dp[k - 1] = true;
        s_l.insert(a[k - 1].l);

        t.update(a[k - 1].l, a[k - 1].m);
    }
    else {
        dp[k - 1] = false;
    }

    //cout << a[0].r << " " << a[1].r << '\n';

    for (int i = k - 2; i >= 0; i --) {
        if (a[i].r == n) {
            dp[i] = true;
            s_l.insert(a[i].l);

            t.update(a[i].l, a[i].m);
        }
        else {
            if (s_l.lower_bound(a[i].m + 1) != s_l.end() && *s_l.lower_bound(a[i].m + 1) <= a[i].r + 1) {
                dp[i] = true;
                s_l.insert(a[i].l);

                t.update(a[i].l, a[i].m);
            }
            else {
                /*
                for (int j = i + 1; j < k; j ++) {
                    if (dp[j] && a[j].l > a[i].l && a[j].l <= a[i].r + 1) {
                        if (a[j].m > a[i].r) {
                            dp[i] = true;
                            s_l.insert(a[i].l);
                            break;
                        }
                    }
                }
                */

                int mx = t.get(a[i].l + 1, a[i].r + 1);
                if (mx > a[i].r) {
                    dp[i] = true;
                    s_l.insert(a[i].l);

                    t.update(a[i].l, a[i].m);
                }
            }
        }
    }

    for (int i = 0; i < k; i ++) {
        if (dp[i] && a[i].l == 1) {
            cout << "YES" << '\n';
            return;
        }
    }

    cout << "NO" << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    cin >> _;
    while (_ --) {
        solve();
    }
}