#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
using namespace std;
#define int long long

struct node {
    vector<int> sorted, maxpos;
};

node merge(const node &a, const node &b) {
    int n=a.sorted.size(), m=b.sorted.size();
    int i=0,j=0;
    node new_node;
    new_node.sorted.reserve(n+m);
    new_node.maxpos.reserve(n+m);
    while (i<n && j<m) {
        if (a.sorted[i]<b.sorted[j]) {
            new_node.sorted.push_back(a.sorted[i]);
            new_node.maxpos.push_back(max((new_node.maxpos.size()?new_node.maxpos.back():-1), a.maxpos[i]));
            ++i;
        }
        else {
            new_node.sorted.push_back(b.sorted[j]);
            new_node.maxpos.push_back(max((new_node.maxpos.size()?new_node.maxpos.back():-1), b.maxpos[j]));
            ++j;
        }
    }
    while (i<n) {
        new_node.sorted.push_back(a.sorted[i]);
        new_node.maxpos.push_back(max((new_node.maxpos.size()?new_node.maxpos.back():-1), a.maxpos[i]));
        ++i;
    }
    while (j<m) {
        new_node.sorted.push_back(b.sorted[j]);
        new_node.maxpos.push_back(max((new_node.maxpos.size()?new_node.maxpos.back():-1), b.maxpos[j]));
        ++j;
    }
    return new_node;
}

const int inf=1e18,MAXH=2e5+5;
int w,h;
vector<vector<int>> a;
vector<vector<int>> p;
static node t[MAXH];
int level;
void build(int u, int tl, int tr) {
    if (tr-tl == 1) {
        t[u].sorted={p[tl][level]};
        t[u].maxpos={tl};
        return;
    }
    int mid=(tl+tr)/2;
    build(2*u+1,tl,mid);
    build(2*u+2,mid,tr);
    t[u]=merge(t[2*u+1], t[2*u+2]);
}

int get_max(int l, int r, int x, int u, int tl, int tr) {
    if (tl>=r || tr<=l) return -inf;
    if (tl>=l && tr<=r) {
        int pos = upper_bound(t[u].sorted.begin(), t[u].sorted.end(), x) - t[u].sorted.begin();
        if (pos==0) {
            return 0LL;
        }
        pos--;
        return t[u].maxpos[pos];
    }
    int mid=(tl+tr)/2;
    return max(get_max(l,r,x,2*u+1,tl,mid), get_max(l,r,x,2*u+2,mid,tr));
}

void solve() {
    cin>>h>>w;
    a.assign(h, vector<int>(w,0));
    p.assign(h, vector<int>(w,0));
    for (int i=0;i<h;++i) {
        string s; cin>>s;
        for (int j=0;j<w;++j) {
            a[i][j]=s[j]-'0';
        }
    }
    for (int i=0;i<h;++i) {
        int last=0;
        for (int j=w-1;j>=0;--j) {
            if (a[i][j]) {
                p[i][j]=++last;
            }
            else {
                last=0;
            }
        }
    }
    int ans=0LL;
    for (int i=0;i<w;++i) {
        vector<int> cur(h);
        cur[0]=p[0][i];
        ans=max(ans,cur[0]);
        fill(t, t+4*h, node{{},{}});
        level=i;
        build(0,0,h);
        for (int j=1;j<h;++j) {
            int k=get_max(0,j,p[j][i],0,0,h);
            if (p[k][i]>p[j][i]) cur[j]=(j-k+1)*p[j][i];
            else cur[j]=cur[k]+(j-k)*p[j][i];
            ans=max(ans,cur[j]);
        }
    }
    cout<<ans<<'\n';
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}