#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct que {
    int l, m, r;
};

bool check(que a, que b) {
    return !(a.l <= b.m and b.m <= a.r);
}
const int inf = 1e9;

struct Tree {
    vector<int> tr;
    
    int get(int i, int l, int r, int ql, int qr) {
        if (ql <= l and r <= qr)
            return tr[i];
        if (ql >= r or l >= qr)
            return inf;
        int m = (l + r) / 2;
        return min(get(2 * i + 1, l, m, ql, qr), get(2 * i + 2, m, r, ql, qr));
    }

    void upd(int i, int l, int r, int qi, int x) {
        if (l + 1 == r)
            tr[i] = min(x, tr[i]);
        else {
            int m = (l + r) / 2;
            if (qi < m)
                upd(2 * i + 1, l, m, qi, x);
            else
                upd(2 * i + 2, m, r, qi, x);
            tr[i] = min(tr[2 * i + 1], tr[2 * i + 2]);
        }
    }
};

void solve() {
    int m, n;
    cin >> m >> n;
    vector<que> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].r--;
        a[i].m--;
    }
    sort(a.begin(), a.end(), [&] (que a, que b) {
        if (a.l == b.l) {
            if (a.r == b.r)
                return a.m < b.m;
            return a.r < b.r;
        }
        return a.l < b.l;
    });
    Tree dp;
    dp.tr.assign(4 * m, inf);
    
    for (int i = 0; i < n; i++) {
        if (a[i].l == 0) {
            dp.upd(0, 0, m, a[i].r, a[i].m);
        }
        else {
            if (dp.get(0, 0, m, a[i].l - 1, a[i].m) != inf) {
                dp.upd(0, 0, m, a[i].r, a[i].m);
            }
            if (dp.get(0, 0, m, a[i].m, a[i].r) < a[i].l)  {
                dp.upd(0, 0, m, a[i].r, a[i].m);
            }
        }
    }
    if (dp.get(0, 0, m, m - 1, m) != 1e9) {
        cout << "YES" << endl;
    }
    else {
        cout << "NO" << endl;
    }

}

signed main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}