#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()

struct seg {
    int l, m, r;
};

int optimal(int x, int x0, int d) {
    int t = 0;
    if (x > x0) {
        t = 1;
    }
    if (x < x0) {
        t = -1;
    }
    int x1 = (x - x0) / d * d + x0, x2 = (x - x0  + d * t) / d * d + x0;
    return min((x1 - x) * (x1 - x), (x2 - x) * (x2 - x));
}

__int128 left_f(__int128 mid, vector<int> arr, __int128 x0, __int128 d) {
    __int128 x = x0 - d * mid;
    __int128 ans = 0;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i] > x0) {
            continue;
        }
        if (arr[i] < x) {
            ans += (x - arr[i]) * (x - arr[i]);
        } else {
            ans += optimal(arr[i], x0, d);
        }
    }
    return ans;
}

__int128 right_f(__int128 mid, vector<int> arr, __int128 x0, __int128 d) {
    __int128 x = x0 + d * mid;
    __int128 ans = 0;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i] < x0) {
            continue;
        }
        if (arr[i] > x) {
            ans += (x - arr[i]) * (x - arr[i]);
        } else {
            ans += optimal(arr[i], x0, d);
        }
    }
    return ans;
}

__int128 search1(vector<int> arr, __int128 x0, __int128 t, __int128 d) {
    __int128 x = arr[0];
    __int128 l = 0, r = 1e9;
    while (l + 2 < r) {
        __int128 mid1 = (l + r) / 2;
        __int128 mid2 = (l + r) / 2 + 1;
        __int128 s1, s2;
        if (x < x0) {
            s1 = left_f(mid1, arr, x0, d) + mid1 * t;
            s2 = left_f(mid2, arr, x0, d) + mid2 * t;
        } else {
            s1 = right_f(mid1, arr, x0, d) + mid1 * t;
            s2 = right_f(mid2, arr, x0, d) + mid2 * t;
        }
        if (s1 < s2) {
            r = mid2;
        } else {
            l = mid1;
        }
    }
    __int128 s1, s2, s3;
    if (x < x0) {
        s1 = left_f(l, arr, x0, d) + l * t;
        s2 = left_f(l + 1, arr, x0, d) + (l + 1) * t;
        s3 = left_f(l + 2, arr, x0, d) + (l + 2) * t;
    } else {
        s1 = right_f(l, arr, x0, d) + l * t;
        s2 = right_f(l + 1, arr, x0, d) + (l + 1) * t;
        s3 = right_f(l + 2, arr, x0, d) + (l + 2) * t;
    }
    __int128 ans = min({s1, s2, s3});
    return ans;
}

__int128 search2(vector<int> arr, __int128 x0, __int128 t, __int128 d) {
    t *= 2;
    __int128 x = arr[0];
    __int128 l = 0, r = 1e9;
    while (l + 2 < r) {
        __int128 mid1 = (l + r) / 2;
        __int128 mid2 = (l + r) / 2 + 1;
        __int128 s1, s2;
        if (x < x0) {
            s1 = left_f(mid1, arr, x0, d) + mid1 * t;
            s2 = left_f(mid2, arr, x0, d) + mid2 * t;
        } else {
            s1 = right_f(mid1, arr, x0, d) + mid1 * t;
            s2 = right_f(mid2, arr, x0, d) + mid2 * t;
        }
        if (s1 < s2) {
            r = mid2;
        } else {
            l = mid1;
        }
    }
    __int128 s1, s2, s3;
    if (x < x0) {
        s1 = left_f(l, arr, x0, d) + l * t;
        s2 = left_f(l + 1, arr, x0, d) + (l + 1) * t;
        s3 = left_f(l + 2, arr, x0, d) + (l + 2) * t;
    } else {
        s1 = right_f(l, arr, x0, d) + l * t;
        s2 = right_f(l + 1, arr, x0, d) + (l + 1) * t;
        s3 = right_f(l + 2, arr, x0, d) + (l + 2) * t;
    }
    __int128 ans = min({s1, s2, s3});
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    sort(all(arr));
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        int t;
        cin >> t;
        __int128 a = search1(arr, x0, t, d), b = search2(arr, x0, t, d);
        swap(arr[0], arr[1]);
        a += search1(arr, x0, t, d), b += search2(arr, x0, t, d);
        int ans = min({a, b});
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
