#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>

using namespace std;
using ll=long long;
const ll inf = 1e15;

struct segtree {
	ll lb, rb;
	ll mn = inf;
	segtree* l = 0, *r = 0;
	segtree(ll lb, ll rb) :lb(lb), rb(rb) {
		if (lb < rb) {
			ll m = lb + (rb - lb) / 2;
			l = new segtree(lb, m);
			r = new segtree(m + 1, rb);
		}
	}
	void upd(ll lq, ll rq, ll val) {
		if (min(rb, rq) < max(lb, lq)) {
			return;
		}
		if (lb >= lq && rb <= rq) {
			mn = min(mn, val);
			return;
		}
		l->upd(lq, rq, val);
		r->upd(lq, rq, val);
		mn = min(l->mn, r->mn);
	}
	ll get(ll lq, ll rq) {
		if (min(rb, rq) < max(lb, lq)) {
			return inf;
		}
		if (lb >= lq && rb <= rq) {
			return mn;
		}
		return min(l->get(lq, rq), r->get(lq, rq));
	}
};


int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll T;
	cin >> T;
	for (int trtr = 1; trtr <= T; ++trtr) {
		ll n, k;
		cin >> n >> k;
		segtree dp(0, n + 1);
		vector<pair<pair<ll, ll>, ll>>v;
		for (int i = 1; i <= k; ++i) {
			ll l, r, m;
			cin >> l >> m >> r;
			v.push_back({ {l,r},m });
		}
		sort(v.begin(), v.end());
		dp.upd(0,0,0);
		for (int i = 0; i < v.size(); ++i) {
			ll fl = dp.get(v[i].first.first - 1, v[i].second -1 );
			/*for (int j = v[i].first.first-1; j < v[i].second; ++j) {
                if (dp[j] != inf) {
                    ++fl;
                }
            }*/
			if (fl != inf) {
				dp.upd(v[i].first.second, v[i].first.second, v[i].second);
			}
			fl = dp.get(v[i].second,v[i].first.second);
			/*for (int j = v[i].second; j <= v[i].first.second; ++j) {
				fl = min(fl, dp[j]);
			}*/
			if (fl < v[i].first.first) {
				dp.upd(v[i].first.second, v[i].first.second, v[i].second);
			}
		}
		if (dp.get(n,n) == inf) {
			cout << "NO" << "\n";
		}
		else {
			cout << "YES" << "\n";
		}
	}
}