


#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>
#include<set>

using namespace std;
using ll=long long;
const ll inf = 1e12;

struct segtree {
    ll lb, rb;
    ll mn = inf;
    segtree* l = 0, *r = 0;
    segtree(ll lb, ll rb) :lb(lb), rb(rb) {
        if (lb < rb) {
            ll m = lb + (rb - lb) / 2;
            l = new segtree(lb, m);
            r = new segtree(m + 1, rb);
        }
    }
    void upd(ll lq, ll rq, ll val) {
        if (min(rb, rq) < max(lb, lq)) {
            return;
        }
        if (lb >= lq && rb <= rq) {
            mn = min(mn, val);
            return;
        }
        l->upd(lq, rq, val);
        r->upd(lq, rq, val);
        mn = min(l->mn, r->mn);
    }
    ll get(ll lq, ll rq) {
        if (min(rb, rq) < max(lb, lq)) {
            return inf;
        }
        if (lb >= lq && rb <= rq) {
            return mn;
        }
        return min(l->get(lq, rq), r->get(lq, rq));
    }
};


ll x[300001];
ll lft[300001];
ll rgt[300001];
__int128 prefl[300001];
__int128 prefls[300001];
__int128 prefr[300001];
__int128 prefrs[300001];
ll pos = 0;
ll x0, d;
ll n;
ll getl(ll kol) {
    ll cord = pos - kol * d;
    ll l = 0, r = pos + 1;
    while (r - l > 1) {
        ll m = l + (r - l) / 2;
        if (x[pos - m] >= cord) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return l;
}
ll getr(ll kol) {
    ll cord = pos + kol * d;
    ll l = 0, r = n - pos + 1;
    while (r - l > 1) {
        ll m = l + (r - l) / 2;
        if (x[pos + m] <= cord) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return l;
}
int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> x[i];
    }
    sort(x + 1, x + n + 1);
    cin >> x0 >> d;
    if (x0 >= x[1]) {
        while (pos < n && x[pos + 1] <= x0) {
            ++pos;
        }
    }
    for (int i = 1; i <= pos; ++i) {
        ll f = x[pos - i + 1];
        ll k = f % d;
        __int128 r = min((k - x0 + inf * d) % d, (x0 - k + inf * d) % d);
        lft[i] = lft[i - 1] + r * r;
    }
    for (int i = 1; i <= pos; ++i) {
        prefl[i] = prefl[i - 1] + x[pos - i + 1];
        prefls[i] = prefls[i - 1] + x[pos - i + 1] * x[pos - i + 1];
    }
    for (int i = 1; i <= n-pos; ++i) {
        ll f = x[pos+i];
        ll k = f % d;
        __int128 r= min((k - x0 + inf * d) % d, (x0 - k + inf * d) % d);
        rgt[i] = rgt[i - 1] + r * r;
    }
    for (int i = 1; i <= n-pos; ++i) {
        prefr[i] = prefr[i - 1] + x[pos +i];
        prefrs[i] = prefrs[i - 1] + x[pos + i] * x[pos + i];
    }
    ll m;
    cin >> m;
    for (int i = 1; i <= m; ++i) {
        ll t;
        cin >> t;

        /*
        ll l1 = 0, r1 = x0 / d + 1;
        while (r1 - l1 > 2) {
            ll m2 = (l1 + 2 * r1) / 3;
            ll m1 = (2*l1 + r1) / 3;
            ll kol1 = getl(m1);
            ll kol2 = getl(m2);
            ll val1 = prefls[pos] - prefls[kol1] - 2 * (x0-m1*d) * (prefl[pos] - prefl[kol1]) + (pos - kol1) * (x0 - m1 * d) * (x0 - m1 * d) +t*m1+lft[kol1];
            ll val2 = prefls[pos] - prefls[kol2] - 2 * (x0 - m2 * d) * (prefl[pos] - prefl[kol2]) + (pos - kol2) * (x0 - m2 * d) * (x0 - m2 * d) +t*m2+lft[kol2];
            if (val1 <= val2) {
                r1 = m2;
            }
            else {
                l1 = m1;
            }
        }*/
        ll l2 = 0, r2 = abs(x[n] - pos) / d + 1;
        while (r2 - l2 > 2) {
            __int128 m2 = (l2 + 2 * r2) / 3;
            __int128 m1 = (2 * l2 + r2) / 3;
            ll kol1 = getr(m1);
            ll kol2 = getr(m2);
            __int128 s = (x0 + m1 * d);
            __int128 ss = (x0 + m2 * d);
            __int128 val1 = prefrs[n-pos] - prefrs[kol1] - 2 * (x0+ m1 * d) * (prefr[n-pos] - prefr[kol1]) + (n-pos - kol1) * s * s +t*m1+rgt[kol1];
            __int128 val2 = prefrs[n-pos] - prefrs[kol2] - 2 * (x0 + m2 * d) * (prefr[n-pos] - prefr[kol2]) + (n-pos - kol2) * ss * ss +t*m2+rgt[kol2];
            if (val1 <= val2) {
                r2 = m2;
            }
            else {
                l2 = m1;
            }
        }
        /*

        ll ans = 1e18;
        for (int j = 0; j <= x[pos] / d + 1; ++j) {
            for (int e = 0; e <= abs(x[n] - x[pos]) / d + 1; ++e) {
                ll kol1 = getl(j);
                ll val1 = prefls[pos] - prefls[kol1] - 2 * (x0 - j * d) * (prefl[pos] - prefl[kol1]) + (pos - kol1) * (x0 - j * d) * (x0 - j * d) + t * j + lft[kol1];
                ll kol3 = getr(e);
                ll val3 = prefrs[n - pos] - prefrs[kol3] - 2 * (x0 + e * d) * (prefr[n - pos] - prefr[kol3]) + (n - pos - kol3) * (x0 + e * d) * (x0 + e * d) + t * e + rgt[kol3];
                ans = min(val1 + val3 + min(j,e) * t, ans);
            }
        }

        ll ansl = 0;
        ll vall = inf;
        for (int j = l1; j <= r1; ++j) {
            ll kol1 = getl(j);
            ll val1 = prefls[pos] - prefls[kol1] - 2 * (x0 - j * d) * (prefl[pos] - prefl[kol1]) + (pos - kol1) * (x0 - j * d) * (x0 - j * d) + t * j + lft[kol1];
            if (val1 <= vall) {
                ansl = j;
                vall = val1;
            }
        }*/
        ll ansr = 0;
        __int128 valr = inf;

        for (ll j = l2; j <= r2; ++j) {
            ll kol3 = getr(j);
            __int128 s = (x0 + j * d);
            __int128 val3 = prefrs[n - pos] - prefrs[kol3] - 2 * (x0 + j * d) * (prefr[n - pos] - prefr[kol3]) + (n - pos - kol3) * s * s + t * j + rgt[kol3];
            if (val3 <= valr) {
                ansr = j;
                valr = val3;
            }
        }
        ll ans = valr;
        cout << ans<< "\n";
        //cout << ans << "\n";
    }
}
