#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>
#include<set>

using namespace std;
using ll=long long;
const ll inf = 1e15;

struct segtree {
	ll lb, rb;
	ll mn = inf;
	segtree* l = 0, *r = 0;
	segtree(ll lb, ll rb) :lb(lb), rb(rb) {
		if (lb < rb) {
			ll m = lb + (rb - lb) / 2;
			l = new segtree(lb, m);
			r = new segtree(m + 1, rb);
		}
	}
	void upd(ll lq, ll rq, ll val) {
		if (min(rb, rq) < max(lb, lq)) {
			return;
		}
		if (lb >= lq && rb <= rq) {
			mn = min(mn, val);
			return;
		}
		l->upd(lq, rq, val);
		r->upd(lq, rq, val);
		mn = min(l->mn, r->mn);
	}
	ll get(ll lq, ll rq) {
		if (min(rb, rq) < max(lb, lq)) {
			return inf;
		}
		if (lb >= lq && rb <= rq) {
			return mn;
		}
		return min(l->get(lq, rq), r->get(lq, rq));
	}
};


ll x[300001];
ll lft[300001];
ll rgt[300001];
ll prefl[300001];
ll prefls[300001];
ll prefr[300001];
ll prefrs[300001];
ll pos = 0;
ll x0, d;
ll n;
ll getl(ll kol) {
	ll cord = pos - kol * d;
	ll res = 0;
	while (res < pos && x[pos - res] >= cord) {
		++res;
	}
	return res;
}
ll getr(ll kol) {
	ll cord = pos + kol * d;
	ll res = 0;
	while (res < n - pos && x[pos + res + 1] <= cord) {
		++res;
	}
	return res;
}
int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> x[i];
	}
	sort(x + 1, x + n + 1);
	cin >> x0 >> d;
	if (x0 >= x[1]) {
		while (pos < n && x[pos + 1] <= x0) {
			++pos;
		}
	}
	for (int i = 1; i <= pos; ++i) {
		ll f = x[pos - i + 1];
		ll k = f % d;
		ll r = min((k - x0 + inf * d) % d, (x0 - k + inf * d) % d);
		lft[i] = lft[i - 1] + r * r;
	}
	for (int i = 1; i <= pos; ++i) {
		prefl[i] = prefl[i - 1] + x[pos - i + 1];
		prefls[i] = prefls[i - 1] + x[pos - i + 1] * x[pos - i + 1];
	}
	for (int i = 1; i <= n - pos; ++i) {
		ll f = x[pos + i];
		ll k = f % d;
		ll r = min((k - x0 + inf * d) % d, (x0 - k + inf * d) % d);
		rgt[i] = rgt[i - 1] + r * r;
	}
	for (int i = 1; i <= n - pos; ++i) {
		prefr[i] = prefr[i - 1] + x[pos + i];
		prefrs[i] = prefrs[i - 1] + x[pos + i] * x[pos + i];
	}
	ll m;
	cin >> m;
	for (int i = 1; i <= m; ++i) {
		ll t;
		cin >> t;
		if (x[1] == x0) {
			cout << 0 << "\n";
			continue;
		}
		if (x[1] > x0) {
			ll l2 = 0, r2 = abs(x[n]) / d + 1;
			while (r2 - l2 > 2) {
				ll m2 = (l2 + 2 * r2) / 3;
				ll m1 = (2 * l2 + r2) / 3;
				ll val1 = 0;
				ll val2 = 0;
				if (x0 + d * m1 >= x[1]) {
					val1 = m1 * t + rgt[1];
				}
				else {
					val1 = m1 * t + (x[1] - x0 - d * m1) * (x[1] - x0 - d * m1);
				}
				if (x0 + d * m2 >= x[1]) {
					val2 = m2 * t + rgt[1];
				}
				else {
					val2 = m2 * t + (x[1] - x0 - d * m2) * (x[1] - x0 - d * m2);
				}
				if (val1 <= val2) {
					r2 = m2;
				}
				else {
					l2 = m1;
				}
			}
			ll ansr = 0;
			ll valr = inf;

			for (int j = l2; j <= r2; ++j) {
				ll val3 = 0;
				if (x0 + d * j >= x[1]) {
					val3 = j * t + rgt[1];
				}
				else {
					val3 = j * t + (x[1] - x0 - d *j) * (x[1] - x0 - d * j);
				}
				if (val3 <= valr) {
					ansr = j;
					valr = val3;
				}
			}
			cout << valr << "\n";
		}
		else {
			ll l1 = 0, r1 = x0 / d + 1;
			while (r1 - l1 > 2) {
				ll m2 = (l1 + 2 * r1) / 3;
				ll m1 = (2 * l1 + r1) / 3;
				ll val1 = 0;
				ll val2 = 0;
				if (x0 - d * m1 <= x[1]) {
					val1 = m1 * t + lft[1];
				}
				else {
					val1 = m1 * t + (x[1] - x0 + d * m1) * (x[1] - x0 + d * m1);
				}
				if (x0 - d * m2 <= x[1]) {
					val2 = m2 * t + lft[1];
				}
				else {
					val2 = m2 * t + (x[1] - x0 + d * m2) * (x[1] - x0 + d * m2);
				}
				if (val1 <= val2) {
					r1 = m2;
				}
				else {
					l1 = m1;
				}
			}
			ll ansl = 0;
			ll vall = inf;
			for (int j = l1; j <= r1; ++j) {
				ll val1 = 0;
				if (x0 - d * j <= x[1]) {
					val1 = j * t + lft[1];
				}
				else {
					val1 = j * t + (x[1] - x0 + d * j) * (x[1] - x0 + d * j);
				}
				if (val1 <= vall) {
					ansl = j;
					vall = val1;
				}
			}
			cout << vall << "\n";
		}
		
	}
}