#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>

using namespace std;
using ll=long long;
const ll inf = 1e15;

struct segtree {
	ll lb, rb;
	ll mn = inf;
	segtree* l = 0, *r = 0;
	segtree(ll lb, ll rb) :lb(lb), rb(rb) {
		if (lb < rb) {
			ll m = lb + (rb - lb) / 2;
			l = new segtree(lb, m);
			r = new segtree(m + 1, rb);
		}
	}
	void upd(ll lq, ll rq, ll val) {
		if (min(rb, rq) < max(lb, lq)) {
			return;
		}
		if (lb >= lq && rb <= rq) {
			mn = min(mn, val);
			return;
		}
		l->upd(lq, rq, val);
		r->upd(lq, rq, val);
		mn = min(l->mn, r->mn);
	}
	ll get(ll lq, ll rq) {
		if (min(rb, rq) < max(lb, lq)) {
			return inf;
		}
		if (lb >= lq && rb <= rq) {
			return mn;
		}
		return min(l->get(lq, rq), r->get(lq, rq));
	}
};
ll n, d;

vector<vector<ll>>g(300001);
int h[300001];
void dfs1(int x, int p) {
	for (auto to : g[x]) {
		if (to != p) {
			h[to] = h[x] + 1;
			dfs1(to,x);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d;
	for (int i = 1; i < n; ++i) {
		ll u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	h[1] = 1;
	dfs1(1,1);
	vector<ll> c;
	vector<ll> nc;
	for (int i = 1; i <= n; ++i) {
		if (h[i] % 2 == 0) {
			c.push_back(i);
		}
		else {
			nc.push_back(i);
		}
	}
	cout << min(c.size(), nc.size()) << "\n";
	while (c.size() != 0 && nc.size() != 0) {
		cout << c.back() << " " << nc.back() << "\n";
		c.pop_back();
		nc.pop_back();
	}
}