#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>
#include<set>

using namespace std;
using ll=long long;
const ll inf = 1e15;

struct segtree {
	ll lb, rb;
	ll mn = inf;
	segtree* l = 0, *r = 0;
	segtree(ll lb, ll rb) :lb(lb), rb(rb) {
		if (lb < rb) {
			ll m = lb + (rb - lb) / 2;
			l = new segtree(lb, m);
			r = new segtree(m + 1, rb);
		}
	}
	void upd(ll lq, ll rq, ll val) {
		if (min(rb, rq) < max(lb, lq)) {
			return;
		}
		if (lb >= lq && rb <= rq) {
			mn = min(mn, val);
			return;
		}
		l->upd(lq, rq, val);
		r->upd(lq, rq, val);
		mn = min(l->mn, r->mn);
	}
	ll get(ll lq, ll rq) {
		if (min(rb, rq) < max(lb, lq)) {
			return inf;
		}
		if (lb >= lq && rb <= rq) {
			return mn;
		}
		return min(l->get(lq, rq), r->get(lq, rq));
	}
};
int n, d;

vector<vector<ll>>gg(300001);
vector<vector<ll>>g(300001);
int h[300001];
int used[300001];
int u[300001];
int p[300001];
int sss[300001];
ll f = 0;
ll t = 0;
void dfs1(int x, int len) {
	u[x] = t;
	if (len < d) {
		for (auto to : gg[x]) {
			if ((len % 2) == 0) {
				g[f].push_back(to);
				g[to].push_back(f);
				
			}
			if (u[to] != t) {
				dfs1(to, len + 1);
			}
		}
	}
}

bool dfs(int x) {
	used[x] = t;
	for (auto to : g[x]) {
		if (used[p[to]]!=t&&(p[to]==0|| dfs(p[to]))) {
			p[to] = x;
			p[x]=to;
			return true;
		}
	}
	return false;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d;
	for (int i = 1; i < n; ++i) {
		ll u, v;
		cin >> u >> v;
		gg[u].push_back(v);
		gg[v].push_back(u);
	}
	for (int i = 1; i <= n; ++i) {
		f = i;
		t = i;
		dfs1(i,0);
	}
	t = 0;
	for (int i = 1; i <= n; ++i) {
		t = i;
		if (p[i] == 0) {
			dfs(i);
		}
	}
	set<pair<ll, ll>> ans;
	for (int i = 1; i <= n; ++i) {
		if (p[i] != 0 ) {
			ans.insert({ min(p[i],i),max(p[i],i) });
		}
	}
	cout << ans.size() << "\n";
	for (auto i = ans.begin(); i != ans.end(); ++i) {
		cout << i->first << " " << i->second << "\n";
	}
}