// TaskD.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

using ll = long long;

const ll inf = 1e18 + 7;

vector<vector<int>> g;
vector<vector<int>> d;

void dfs(int v, int sv, int p = -1) {
	for (int u : g[v]) {
		if (u == p) {
			continue;
		}
		d[sv][u] = d[sv][v] + 1;
		dfs(u, sv, v);
	}
}

int n, mxd;
vector<int> a;

int confcnt() {
	int ans = 0;
	for (int i = 0; i < n / 2; i++) {
		int v = a[i];
		int u = a[n - i - 1];
		int dist = d[v][u];
		if (dist % 2 == 0 || dist > mxd) {
			ans++;
		}
	}
	return ans;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> mxd;
	d.resize(n, vector<int>(n));
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; i++) {
		dfs(i, i);
	}
	a.resize(n);
	for (int i = 0; i < n; i++) {
		a[i] = i;
	}
	double t = 1;
	double cool = 0.9999;
	int conf = confcnt();
	for (int i = 0; i < 10000; i++) {
		t *= cool;
		int p1 = rand() % n;
		int p2 = rand() % n;
		swap(a[p1], a[p2]);
		int nconf = confcnt();
		if (nconf < conf || exp((double)(-nconf + conf) / t) > (double)(rand() / RAND_MAX)) {
			conf = nconf;
		}
		else {
			swap(a[p1], a[p2]);
		}
	}
	cout << n / 2 - conf << '\n';
	for (int i = 0; i < n / 2; i++) {
		int v = a[i];
		int u = a[n - i - 1];
		int dist = d[v][u];
		if (dist % 2 == 1 && dist <= mxd) {
			cout << v + 1 << ' ' << u + 1 << '\n';
		}
	}
}
