#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second

const int INF = 1e9 + 7;

struct range {
    int l, m, r;
};

bool cmp_m(const range &a, const range &b) {
    return a.m < b.m;
}

struct stree {
    int n;
    vector<int> t;
    const int neutral = -INF;

    stree(int _n) {
        n = _n;
        t.resize(4 * n, neutral);
    }

    void set(int v, int l, int r, int ind, int val) {
        if (ind < l || r <= ind) return;
        // //cerr << '%' << l << ' ' << r << ' ' << ind << ' ' << val << endl;
        if (l + 1 == r) {
            t[v] = val;
            return;
        }
        int m = (l + r) / 2;
        set(2 * v + 1, l, m, ind, val);
        set(2 * v + 2, m, r, ind, val);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    void set(int ind, int val) {
        // //cerr << ind << ' ' << val << endl;
        set(0, 0, n, ind, val);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return neutral;
        if (ql <= l && r <= qr) return t[v];
        int m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    int get(int ql, int qr) {
        return get(0, 0, n, ql, qr);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<range> v(k);
    for (auto &[l, m, r] : v) {
        cin >> l >> m >> r;
        l--;
        m--;
        r;
    }

    sort(v.begin(), v.end(), cmp_m);
    reverse(v.begin(), v.end());

    stree st(n);
    bool cur;
    for (auto &[l, m, r] : v) {
        cur = false;
        //cerr << '#' << l << ' ' << m << ' ' << r << endl;
        if (st.get(l + 1, r + 1) >= r) {
            cur = true;
        }
        if (st.get(m + 1, r + 1) != st.neutral) {
            cur = true;
        }
        if (r == n) {
            cur = true;
        }
        if (cur) {
            st.set(l, max(st.get(l, l + 1), m));
        }
        //cerr;; for (int i = 0; i < n; i++) //cerr << st.get(i, i + 1) << ' '; //cerr << endl;
    }
    if (st.get(0, 1) != st.neutral) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int uwu = 1;
    cin >> uwu;
    while (uwu--) solve();
}
