// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

typedef long long ll;

#define ff first
#define ss second

const int INF = 1e9 + 7;

ll d;
vector<vector<ll>> v(2), p(2), xi(2), xi_sq(2), optim(2), cnt(2);

ll inner_eval(ll cost, bool t, int ind) {
    int sz = p[t].size();
    ll res = optim[t][ind];

    ll st = p[t][ind] * d;
    res += p[t][ind] * cost;

    //cerr << cost << ' ' << t << ' ' << ind << ' ' << res << endl;

    ll cur_xi = xi[t].back() - xi[t][ind];
    ll cur_xi_sq = xi_sq[t].back() - xi_sq[t][ind];
    ll cur_cnt = cnt[t].back() - cnt[t][ind];

    res += cur_xi_sq + st * st * cur_cnt - 2 * cur_xi * st;

    //cerr << cost << ' ' << t << ' ' << ind << ' ' << res << ' ' << st << endl;

    ll k = (cur_xi - st * cur_cnt) / d;
    if (k < 0) k = 0;
    ll cur_min;
    if (ind + 1 < sz && p[t][ind] + k + 1 >= p[t][ind + 1]) {
        k = p[t][ind + 1] - p[t][ind] - 1;
        cur_min = d * (k * k * d * cur_cnt + 2 * k * (st * cur_cnt - cur_xi)) + k * cost;
    } else {
        cur_min = d * (k * k * d * cur_cnt + 2 * k * (st * cur_cnt - cur_xi)) + k * cost;
        ll tmp = d * ((k + 1) * (k + 1) * d * cur_cnt + 2 * (k + 1) * (st * cur_cnt - cur_xi)) + (k + 1) * cost;
        if (tmp < cur_min) {
            cur_min = tmp;
            k++;
        }
    }
    // //cerr << cur_min << ' ' << cur_min * d << endl;
    res += cur_min;

    //cerr << cost << ' ' << t << ' ' << ind << ' ' << res << ' ' << k << endl;

    return res;
}

ll eval(ll cost, bool t) {
    int left = 0, right = (int)p[t].size() - 1, mid1, mid2;
    while (left + 2 < right) {
        mid1 = (2 * left + right) / 3;
        mid2 = (left + 2 * right) / 3;
        if (inner_eval(cost, t, mid1) < inner_eval(cost, t, mid2)) {
            right = mid2;
        } else {
            left = mid1;
        }
    }
    ll res = inner_eval(cost, t, left);
    for (int x = left + 1; x <= right; x++) res = min(res, inner_eval(cost, t, x));
    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> inp_v(n);
    for (auto &el : inp_v) cin >> el;
    ll tmp;
    cin >> tmp >> d;
    for (auto &el : inp_v) el -= tmp;
    inp_v.push_back(0);
    sort(inp_v.begin(), inp_v.end());
    n++;

    v[0] = vector<ll>(inp_v.begin(), find(inp_v.begin(), inp_v.end(), 0));
    v[1] = vector<ll>(find(inp_v.begin(), inp_v.end(), 0) + 1, inp_v.end());
    for (auto &el : v[0]) el = -el;
    reverse(v[0].begin(), v[0].end());

    /*for (auto &el : v) {
        for (auto &el1 : el) ////cerr << el1 << ' '; ////cerr << endl;
    }*/

    for (int t = 0; t < 2; t++) {
        p[t].resize(v[t].size() + 1, 0);
        for (int i = 1; i < p[t].size(); i++) p[t][i] = (v[t][i - 1] + d - 1) / d;
        p[t].push_back(p[t].back() + 1);
        p[t].erase(unique(p[t].begin(), p[t].end()), p[t].end());
    }

    int sz;
    for (int t = 0; t < 2; t++) {
        sz = p[t].size();
        xi[t].resize(sz, 0);
        xi_sq[t].resize(sz, 0);
        optim[t].resize(sz, 0);
        cnt[t].resize(sz, 0);
        for (int i = 1, j = 0; i < sz; i++) {
            xi[t][i] = xi[t][i - 1];
            xi_sq[t][i] = xi_sq[t][i - 1];
            optim[t][i] = optim[t][i - 1];
            cnt[t][i] = cnt[t][i - 1];
            while (j < v[t].size() && v[t][j] < p[t][i] * d) {
                xi[t][i] += v[t][j];
                xi_sq[t][i] += v[t][j] * v[t][j];
                tmp = min(v[t][j] % d, d - v[t][j] % d);
                optim[t][i] += tmp * tmp;
                cnt[t][i] += 1;
                j++;
            }
        }
    }
    /*for (int t = 0; t < 2; t++) {
        ////cerr << endl;
        for (auto &el : p[t]) ////cerr << el << ' '; ////cerr << endl;
        for (auto &el : xi[t]) ////cerr << el << ' '; ////cerr << endl;
        for (auto &el : xi_sq[t]) ////cerr << el << ' '; ////cerr << endl;
        for (auto &el : optim[t]) ////cerr << el << ' '; ////cerr << endl;
        for (auto &el : cnt[t]) ////cerr << el << ' '; ////cerr << endl;
        ////cerr << endl;
    }

    ////cerr << "DONE" << endl;*/

    int m;
    cin >> m;
    vector<pair<ll, int>> cost(m);
    for (int i = 0; i < m; i++) {
        cin >> cost[i].ff;
        cost[i].ss = i;
    }
    sort(cost.begin(), cost.end());

    // ////cerr << inner_eval(1, 1, 3) << endl;

    vector<ll> res(m, 4e18 + 7);
    for (auto &[cur, ind] : cost) {
        for (int t = 0; t < 2; t++) {
            res[ind] = min(res[ind], eval(2 * cur, t) + eval(cur, !t));
        }
    }
    for (auto &el : res) cout << el << '\n';
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
/*
4
30 239 57 179
0 7
1
100000
*/
