#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

typedef long long ll;

#define ff first
#define ss second

const int INF = 1e9 + 7;

vector<vector<int>> graph;
vector<int> dp0, dp1;

void dfs(int v, int p) {
    if (p != -1) graph[v].erase(find(graph[v].begin(), graph[v].end(), p));
    for (auto u : graph[v]) {
        dfs(u, v);
    }

    dp0[v] = 0;
    for (auto u : graph[v]) {
        dp0[v] += max(dp0[u], dp1[u]);
    }

    dp1[v] = -INF;
    int max_u = -1;
    for (auto u : graph[v]) {
        if (max_u == -1 || dp0[u] - max(dp0[u], dp1[u]) > dp0[max_u] - max(dp0[max_u], dp1[max_u])) {
            max_u = u;
        }
    }
    if (max_u != -1) {
        dp1[v] = dp0[v] + dp0[max_u] - max(dp0[max_u], dp1[max_u]) + 1;
    }
}

void get_res(int v, vector<pair<int, int>> &res) {
    if (dp1[v] >= dp0[v]) {
        int max_u = -1;
        for (auto u : graph[v]) {
            if (max_u == -1 || dp0[u] - max(dp0[u], dp1[u]) > dp0[max_u] - max(dp0[max_u], dp1[max_u])) {
                max_u = u;
            }
        }
        res.push_back({v, max_u});
        for (auto u : graph[v]) {
            if (u == max_u) continue;
            get_res(u, res);
        }
        for (auto u : graph[max_u]) {
            get_res(u, res);
        }
    } else {
        for (auto u : graph[v]) {
            get_res(u, res);
        }
    }
}

void solve() {
    int n, d;
    cin >> n >> d;
    graph.resize(n);
    int a, b;
    for (int i = 0; i < n - 1; i++) {
        cin >> a >> b; a--; b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    dp0.resize(n);
    dp1.resize(n);
    dfs(0, -1);
    vector<pair<int, int>> res;
    get_res(0, res);
    cout << res.size() << endl;
    for (auto &[a, b] : res) {
        cout << a + 1 << ' ' << b + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
