#include <bits/stdc++.h>
#define int long long

using namespace std;

istream& operator>>(istream& in, vector<auto>& v) {
    for (auto& el : v) {
        in >> el;
    }
    return in;
}

ostream& operator<<(ostream& out, vector<auto> v) {
    for (auto el : v) {
        out << el << " ";
    }
    out << "\n";
    return out;
}
ostream& operator<<(ostream& out, vector<vector<auto>> v) {
    for (auto el : v) {
        out << el;
    }
    out << "\n";
    return out;
}

struct Pref {
    vector<vector<int>> p;
    Pref(vector<string> v) {
        int n = v.size();
        int m = v[0].size();
        p = vector<vector<int>>(n + 1, vector<int> (m + 1));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                p[i + 1][j + 1] = (v[i][j] == '1') + p[i][j + 1] + p[i + 1][j] - p[i][j];
            }
        }
    }
    int get(int i1, int j1, int i2, int j2) {
        return p[i2][j2] - p[i1][j2] - p[i2][j1] + p[i1][j1];
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    for (auto& el : v) {
        cin >> el;
        reverse(el.begin(), el.end());
    }
    vector<vector<int>> a(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '1') {
                a[i][j] = 1;
            }
            else {
                continue;
            }
            if (j != 0) {
                a[i][j] += a[i][j - 1];
            }
        }
    }
    vector<vector<int>> b(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '1') {
                b[i][j] = 1;
            }
            else {
                continue;
            }
            if (i != 0) {
                b[i][j] += b[i - 1][j];
            }
        }
    }
//    cout << a << b;
    vector<vector<int>> dp(n, vector<int> (m));
    int ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '0') continue;
            dp[i][j] = 1;
            if (i != 0) {
                if (v[i - 1][j] == '0') {
                    dp[i][j] = a[i][j];
                    continue;
                }
                dp[i][j] += dp[i - 1][j];
            }
            if (j != 0) {
                if (v[i][j - 1] == '0') {
                    dp[i][j] = b[i][j];
                    continue;
                }
                dp[i][j] += dp[i][j - 1];
            }
            if (i != 0 && j != 0) {
                dp[i][j] -= dp[i - 1][j - 1];
            }
        }
    }
//    cout << v;
//    cout << dp;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
