#include <bits/stdc++.h>
#define int long long

using namespace std;

istream& operator>>(istream& in, vector<auto>& v) {
    for (auto& el : v) {
        in >> el;
    }
    return in;
}

ostream& operator<<(ostream& out, vector<auto> v) {
    for (auto el : v) {
        out << el << " ";
    }
    out << "\n";
    return out;
}

struct Segm {
    int l, m, r;
    friend istream& operator>>(istream& in, Segm& v) {
        return in >> v.l >> v.m >> v.r;
    }
    friend ostream& operator<<(ostream& in, Segm v) {
        return in << v.l << " " << v.m << " " << v.r << "\n";
    }
    bool operator<(Segm v) {
        return (pair<int, pair<int, int>>){l, (pair<int, int>){m, r}} < (pair<int, pair<int, int>>){v.l, (pair<int, int>){v.m, v.r}};
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<Segm> v(k);
    cin >> v;
//    cout << v;
    sort(v.begin(), v.end());
    const int INF = 1e9;
    set<pair<int, int>> mr, rm;
    for (int i = 0; i < k; i++) {
        if (v[i].l == 1) {
            mr.emplace(v[i].m, v[i].r);
            rm.emplace(v[i].r, v[i].m);
            continue;
        }
        while (!rm.empty() && rm.begin()->first + 1 < v[i].l) {
            mr.erase(*rm.begin());
            rm.erase(*rm.begin());
        }
//        cout << rm.size() << "\n";
        bool f = 0;
        for (auto [m, r] : mr) {
            if ((m < v[i].l || r < v[i].m) && v[i].l - 1 <= r) {
                f = 1;
                break;
            }
        }
        if (f) {
            mr.emplace(v[i].m, v[i].r);
            rm.emplace(v[i].r, v[i].m);
        }
    }
    for (auto [m, r] : mr) {
        if (r == n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

