#include <bits/stdc++.h>
#define int long long

using namespace std;

istream& operator>>(istream& in, vector<auto>& v) {
    for (auto& el : v) {
        in >> el;
    }
    return in;
}

ostream& operator<<(ostream& out, vector<auto> v) {
    for (auto el : v) {
        out << el << " ";
    }
    out << "\n";
    return out;
}

struct Segm {
    int l, m, r;
    friend istream& operator>>(istream& in, Segm& v) {
        return in >> v.l >> v.m >> v.r;
    }
    friend ostream& operator<<(ostream& in, Segm v) {
        return in << v.l << " " << v.m << " " << v.r << "\n";
    }
    bool operator<(Segm v) {
        return (pair<int, pair<int, int>>){l, (pair<int, int>){m, r}} < (pair<int, pair<int, int>>){v.l, (pair<int, int>){v.m, v.r}};
    }
};

const int INF = 1e9;
    int n;
struct SegmentTree {
    vector<int> t;
    SegmentTree(int n){
        t = vector<int>(n * 4, INF);
    }
    void update(int ind, int l, int r, int i, int val) {
        if (r <= i || i < l) {
            return;
        }
//        cout << l << " " << r << "\n";
        if (l + 1 == r) {
            t[ind] = min(t[ind], val);
            return;
        }
        int m = (l + r) / 2;
        update(2 * ind + 1, l, m, i, val);
        update(2 * ind + 2, m, r, i, val);
        t[ind] = min(t[ind * 2 + 1], t[ind * 2 + 2]);
    }
    int get(int ind, int l, int r, int L, int R) {
        if (L <= l && r <= R) {
            return t[ind];
        }
        if (R <= l || r <= L) {
            return INF;
        }
        int m = (l + r) / 2;
        return min(get(2 * ind + 1, l, m, L, R), get(2 * ind + 2, m, r, L, R));
    }
    void print(int i = 0, int l = 0, int r = n + 1) {
        cout << l << " " << r << ": " << t[i] << "\n";
        if (l + 1 == r) return;
        int m = (l + r) / 2;
        print(i * 2 + 1, l, m);
        print(i * 2 + 2, m, r);
    }
};

void solve() {
    int k;
    cin >> n >> k;
    vector<Segm> v(k);
    cin >> v;
//    cout << v;
    sort(v.begin(), v.end());
    SegmentTree t(n + 1);
    for (int i = 0; i < k; i++) {
        if (v[i].l == 1) {
            t.update(0, 0, n + 1, v[i].r, v[i].m);
            continue;
        }
//        t.print();
        if (t.get(0, 0, n + 1, v[i].l - 1, v[i].m) != INF ||
            t.get(0, 0, n + 1, v[i].l - 1, v[i].r + 1) < v[i].l) {
//            cout << v[i].m << "\n";
            t.update(0, 0, n + 1, v[i].r, v[i].m);
        }
    }
    if (t.get(0, 0, n + 1, n, n + 1) != INF) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

signed main()
{
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
