#include <bits/stdc++.h>
using namespace std;
const int inf = 1e9 + 7;
const int N = 5e5 + 3;
vector<pair<int, int>> v[N];
int dp[N];
int tree[4 * N];
void build(int v, int l, int r) {
    if (l == r) {
        tree[v] = inf;
        return ;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l,m);
    build(2 * v + 2, m + 1, r);
    tree[v] = inf;
}
int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (ql > r || l > qr) {
        return inf;
    }
    int m = (l + r) / 2;
    return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m + 1, r, ql, qr));
}
void update(int v, int l, int r, int pos, int x) {
    if (l == r) {
        tree[v] = min(tree[v], x);
        return;
    }
    int m = (l + r) / 2;
    if (pos <= m) {
        update(2 * v + 1, l,m, pos, x);
    } else {
        update(2 * v + 2, m + 1, r, pos, x);
    }
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}
void solve() {
    int n, k;
    cin >> n>> k;
    build(0, 0, n);
    fill(dp, dp + n + 1 , inf);
    for (int i = 0 ;i <= n; i++) {
        v[i].clear();
    }
    for (int i = 0 ;i < k; i++) {
        int l, m, r;
        cin >> l >> m>> r;
        if (l == 1) {
            update(0, 0, n, r, m);
        }
        v[r].push_back({l, m});
    }
    for (int r = 0; r <= n; r++) {
        for (auto [l, m] : v[r]) {
            bool f = false;
            int mn1 = get(0, 0, n, l - 1, m - 1);
            if (mn1 != inf) {
                update(0, 0, n, r, m);
            } else {
                if (m <= r - 1) {
                    int mn2 = get(0, 0, n, m, r - 1);
                    if (mn2 < l) {
                        update(0, 0, n, r, m);
                    }
                }
            }
            /*for (int t = l - 1; t < r; t++) {
                if (dp[t] == inf) {
                    continue;
                }

                if (t < m) {
                    f = true;
                } else {
                    if (dp[t] < l) {
                        f = true;
                    }
                }
            }
            if (f) {
                //cout << l << " " << m << " " << r << "\n";
                dp[r] = min(dp[r], m);
            }*/
        }
    }
    if (get(0, 0, n, n, n) == inf) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}