#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<cmath>
#include<deque>
#include<queue>
#include<time.h>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18, MOD = 1e9 + 7;
mt19937 mt(clock());

ll n, d, vers = 0;
vector <vector<ll>> g, ng;
vector <ll> lt, rt, u, nxt;

void dfs(ll v, ll h) {
	u[v] = 1;
	if (h & 1)
		lt.push_back(v);
	else
		rt.push_back(v);
	for (auto i : g[v]) {
		if (!u[i])
			dfs(i, h + 1);
	}
}

bool check(ll v) {
	if (u[v] == vers)
		return false;
	u[v] = vers;
	for (auto i : ng[v]) {
		if (nxt[i] == -1 || check(nxt[i])) {
			nxt[i] = v;
			return true;
		}
	}
	return false;
}

void solve() {
	cin >> n >> d;
	g.resize(n);
	u.resize(n, 0);
	for (ll i = 1; i < n; i++) {
		ll f, t;
		cin >> f >> t;
		f--;
		t--;
		g[f].push_back(t);
		g[t].push_back(f);
	}
	dfs(0, 0);
	vector <vector<ll>> dist(n, vector <ll>(n, -1));
	for (ll i = 0; i < n; i++) {
		dist[i][i] = 0;
		queue <ll> q;
		q.push(i);
		while (!q.empty()) {
			ll v = q.front();
			q.pop();
			for (auto j : g[v]) {
				if (dist[i][j] == -1) {
					dist[i][j] = dist[i][v] + 1;
					q.push(i);
				}
			}
		}
	}
	ng.resize(n);
	for (auto i : lt) {
		for (auto j : rt) {
			if (dist[i][j] <= d && dist[i][j] != -1) {
				ng[i].push_back(j);
				ng[j].push_back(i);
			}
		}
	}
	nxt.assign(n, -1);
	u.assign(n, -1);
	ll ans = 0; 
	shuffle(lt.begin(), lt.end(), mt);
	for (auto i : lt) {
		if (check(i))
			ans++;
		vers++;
	}
	cout << ans << '\n';
	for (auto i : rt) {
		if (nxt[i] == -1)
			continue;
		cout << i + 1 << ' ' << nxt[i] + 1 << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t12345 = 1;
	//cin >> t12345;
	while (t12345--) {
		solve();
		cout << '\n';
	}
	return 0;
}
