#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <vector <int>> g;
vector <int> color;
vector <int> f;
vector <int> s;
vector <int> dist;
vector <int> prv;
vector <int> dp1, dp0, dp, per;

void dfs(int v) {
    if (color[v] == 1) f.push_back(v);
    else s.push_back(v);
    for (int u : g[v]) {
        if (color[u] == 0) {
            color[u] = -color[v];
            prv[u] = v;
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
}

int distancion(int a, int b) {
    int ans = 0;
    while (a != b) {
        if (dist[a] > dist[b]) swap(a, b);
        b = prv[b];
        ans++;
    }
    return ans;
}

void dfs1(int v) {
    color[v] = 1;
    dp1[v] = 0;
    dp0[v] = 0;
    per[v] = -1;
    for (int u : g[v]) {
        if (color[u] == 1) continue;
        prv[u] = v;
        dfs1(u);
        dp1[v] += dp[u];
    }
    for (int u : g[v]) {
        if (u == prv[v]) continue;
        int k = dp1[v] - dp[u] + dp1[u] + 1;
        if (k > dp0[v]) {
            dp0[v] = k;
            per[v] = u;
        }
    }
    dp[v] = max(dp0[v], dp1[v]);
}

void dfs2(int v, int c) {
    color[v] = 2;
    for (int u : g[v]) {
        if (color[u] == 2) continue;
        if (u == per[v] && c == 1 && dp0[v] > dp1[v]) {
            cout << u + 1 << " " << v + 1 << "\n";
            dfs2(u, 0);
        } else {
            dfs2(u, 1);
        }
    }
}
int main()
{
//    freopen("input.txt", "r", stdin);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    prv.resize(n);
    dist.resize(n);
    color.resize(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b; a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (n <= 17) {
        color[0] = 1;
        prv[0] = -1;
        dfs(0);


        if (s.size() > f.size()) swap(s, f);

        int ans = 0;
        int ots;
        vector <int> x;
        for (int t = 0; t < 200'000; ++t) {
            next_permutation(f.begin(), f.end());
            int sum = 0;
            for (int i = 0; i < s.size(); ++i) {
                int k = distancion(s[i], f[i]);
                if (k <= d) {
                    sum++;
                }
            }
            if (sum > ans) {
                ans = sum;
                x = f;
            }
        }

        cout << ans << "\n";
        for (int i = 0; i < s.size(); ++i) {
            int k = distancion(s[i], x[i]);
            if (k <= d) {
                cout << s[i] + 1 << " " << x[i] + 1 << "\n";
            }
        }
    } else if (d == n - 1) {

        color[0] = 1;
        dfs(0);

        if (s.size() < f.size()) swap(s, f);

        cout << f.size() << "\n";
        for (int i = 0; i < f.size(); ++i) {
            cout << f[i] + 1 << " " << s[i] + 1 << "\n";
        }
    } else if (d == 1) {
        dp.resize(n);
        dp1.resize(n);
        per.resize(n);
        dp0.resize(n);
        prv.resize(n);
        prv[0] = -1;
        dfs1(0);
        cout << dp[0] << "\n";
        dfs2(0, 1);
    }
    return 0;
}


//        for (int k = 0; k + f.size() <= s.size(); ++k) {
//            int s = 0;
//            for (int i = 0; i < f.size(); ++i) {
//                if (distance(f[i], s[i + k]) <= d) {
//                    s++;
//                }
//            }
//            if (s > ans) {
//                x = f;
//                ots = k;
//
//            }
//        }
