#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

struct st {
    ll l, m, r;
};

bool operator<(st a, st b) {
    return a.l < b.l;
}

struct sg {
    vector<ll> tree;
    void change(ll v, ll vl, ll vr, ll pos, ll x) {
        if (vr - vl == 1) {
            tree[v] = x;
            return;
        }
        ll m = (vl + vr) / 2;
        if (pos < m) {
            change(2 * v, vl, m, pos, x);
        } else {
            change(2 * v + 1, m, vr, pos, x);
        }
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
    ll get(ll v, ll vl, ll vr, ll l, ll r) {
        if (vl >= r || vr <= l) {
            return 0;
        }
        if (vl >= l && vr <= r) {
            return tree[v];
        }
        ll m = (vl + vr) / 2;
        return get(2 * v, vl, m, l, r) + get(2 * v + 1, m, vr, l, r);
    }
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n, -1);
    vector<st> seg;
    for (int i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        l--, r--, m--;
        seg.push_back({l, m, r});
        a[l] = max(a[l], r);
    }
    sort(seg.begin(), seg.end());
    deque<pair<ll, ll>> can;
    sg t1;
    t1.tree.resize(4 * n);
    for (int i = 0; i < k; i++) {
        if (seg[i].l == 0) {
            can.emplace_back(seg[i].m, seg[i].r);
            t1.change(1, 0, n, seg[i].r, 1);
        } else {
            ll sm = t1.get(1, 0, n, seg[i].l - 1, min(seg[i].r, seg[i].m));
            if (sm > 0) {
                can.emplace_back(seg[i].m, seg[i].r);
                t1.change(1, 0, n, seg[i].r, 1);
            } else {
                for (auto [m, r] : can) {
                    if (seg[i].l - 1 <= r && r < seg[i].r && m < seg[i].l) {
                        can.emplace_back(seg[i].m, seg[i].r);
                        t1.change(1, 0, n, seg[i].r, 1);
                        break;
                    }
                }
            }
        }
        if (!empty(can) && can.back().second == n - 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}