#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

struct st {
    ll cnt, l, m, r;
};
bool operator<(st a, st b) {
    return a.cnt < b.cnt;
}

struct fenwick {
    vector<ll> t;
    void change(ll i, ll x) {
        for (; i < t.size(); i += i & -i) {
            t[i] = max(t[i], x);
        }
    }
    ll get(ll i) {
        ll ans = -INF;
        for (; i > 0; i -= i & -i) {
            ans = max(ans, t[i]);
        }
        return ans;
    }
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<st> seg;
    vector<ll> a(n);
    for (int i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        l--, m--, r--;
        a[m]++;
        if (a[m] > 1) {
            cout << "NO\n";
            return;
        }
        seg.push_back({0, l, m, r});
    }
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        sm += a[i];
        a[i] = sm;
    }
    vector<st> ans;
    for (auto [cnt, l, m, r] : seg) {
        ll s = a[r];
        if (l != 0) {
            s -= a[l - 1];
        }
        ans.push_back({s, l, m, r});
    }
    sort(ans.begin(), ans.end());
    fenwick t;
    t.t.resize(n + 1, -INF);
    for (auto [s, l, m, r] : ans) {
        ll val = t.get(m + 1);
        if (val >= m) {
            cout << "NO\n";
            return;
        }
        t.change(l + 1, r);
    }
    cout << "YES\n";
}