#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

using ll = long long;

inline ll di(ll a, ll b) {
    if (a > 0 && b > 0) return a/b;
    if (a < 0 && b < 0) return (-a)/(-b);
    if (a > 0 && b < 0) return di(-a, -b);
    if ((-a) % b == 0) return (-a)/b;
    return -((-a)/b+1);
}

struct ST {
    public:
    ST(int s) {
        size = s;
        d.resize(s);
        q.resize(4*s);
        build(0, 0, size);
    }
    int get(int k) {
        return get(0, 0, size, k);
    }
    void set(int l, int r, int x) {
        set(0, 0, size, l, r, x);
    }
    private:
    int get(int p, int l, int r, int k) {
        push(p, l, r);
        if (r - l <= 1) return d.at(l);
        else if (k < l || k >= r) throw new out_of_range("ST");
        else {
            int m = (l+r)/2;
            if (k < m) return get(2*p+1, l, m, k);
            else return get(2*p+2, m, r, k);
        }
    }
    void set(int p, int l, int r, int lq, int rq, int x) {
        push(p, l, r);
        if (lq <= l && rq >= r) {
            q.at(p) = x;
        } else if (rq <= l || lq >= r) {
            return;
        } else {
            int m = (l+r)/2;
            set(2*p+1, l, m, lq, rq, x);
            set(2*p+2, m, r, lq, rq, x);
        }
    }
    void push(int p, int l, int r) {
        if (q.at(p) != -1) {
            if (r - l > 1) {
                q.at(2*p+1) = q.at(p);
                q.at(2*p+2) = q.at(p);
            }
            d.at(l) = q.at(p);
            q.at(p) = -1;
        }
    }
    void build (int p, int l, int r) {
        if (r - l <= 1) {
            q.at(p) = -1;
            return;
        }
        int m = (l+r)/2;
        build(2*p+1, l, m);
        build(2*p+2, m, r);
        q.at(p) = -1;
    }
    vector<int> d;
    vector<int> q;
    int size;
};

vector<tuple<ll, ll, ll>> c;

int main() {
    cin.sync_with_stdio(false);
    cin.tie(0);
    int t; cin >> t;
    while (t--) {
        int n, k; cin >> n >> k;
        if (k > 8) assert(false); // Subtask 2, do not wait too long
        c.resize(k);
        for (auto &&[l, m, r]: c) cin >> l >> m >> r;
        sort(c.begin(), c.end());
        do {
            ST rooms(n);
            for (auto &&[l, m, r]: c) {
                if (rooms.get(m-1)) continue;
                rooms.set(l-1, r, 1);
            }
            bool ok = true;
            for (int i=0; i<n; ++i) ok &= rooms.get(i);
            if (ok) {
                cout << "YES" << endl;
                goto next;
            }
        } while(next_permutation(c.begin(), c.end()));
        cout << "NO" << endl;
        next:;
    }
}