#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using ld = long double;

vector<vi> binup, g, gg;
vi tin, tout, dep, used, mt;
const int LOGN = 20;
int timer = 0;
void dfs(int v, int p) {
    dep[v] = dep[p] + 1;
    tin[v] = timer++;
    binup[v][0] = p;

    for (int i = 1; i < LOGN; ++i) binup[v][i] = binup[binup[v][i - 1]][i - 1];

    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }

    tout[v] = timer++;
}

int isAnc(int u, int v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int getLca(int u, int v) {
    if (isAnc(u, v)) return u;
    if (isAnc(v, u)) return v;

    for (int i = LOGN - 1; i >= 0; --i) {
        if (!isAnc(binup[u][i], v)) u = binup[u][i];
    }

    return binup[u][0];
}

int dist(int u, int v) {
    int lca = getLca(u, v);
    return dep[u] + dep[v] - 2 * dep[lca];
}

int kuhn(int v) {
    if (used[v] == timer) return 0;

    used[v] = timer;

    for (int u : gg[v]) {
        if (mt[u] == -1) {
            mt[u] = v;
            return 1;
        }
    }

    for (int u : gg[v]) {
        if (kuhn(mt[u])) {
            mt[u] = v;
            return 1;
        }
    }

    return 0;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    int d;
    cin >> d;
    binup.assign(n, vi(LOGN));
    dep.resize(n);
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    gg.resize(n);
    used.resize(n);
    mt.assign(n, -1);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].pb(v);
        g[v].pb(u);
    }

    dfs(0, 0);

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int df = dist(i, j);
            if ((df % 2 == 1) && (df <= d)) {
                gg[i].pb(j);
                gg[j].pb(i);
            }
        }
    }

    int ans = 0;

    timer = 1;

    for (int i = 0; i < n; ++i) {
        if (dep[i] % 2 == 0) continue;
        if (kuhn(i)) ++ans;
        ++timer;
    }

    vector<pi> ps;
    for (int i = 0; i < n; ++i) {
        if (mt[i] == -1) continue;
        ps.pb({i + 1, mt[i] + 1});     
    }

    cout << ans << endl;
    for (auto [u, v] : ps) {
        cout << u << ' ' << v << endl;
    }
}