#include <iostream>
#include <algorithm>
#include <vector>
#include <climits>
 
using namespace std;
 
struct s {
    int l, m, r;
 
    bool operator<(const s& a) {
        return r < a.r;
    }
};

vector<int> treem(2'000'000, INT_MAX), treer(2'000'000, INT_MAX);

void update(int ind, int lx, int rx, int ix, int val, vector<int>& tree) {
    if (rx - lx == 1) {
        tree[ind] = val;
        return;
    }
    int mid = (lx + rx) / 2;
    if (ix < mid)
        update(ind * 2 + 1, lx, mid, ix, val, tree);
    else
        update(ind * 2 + 2, mid, rx, ix, val, tree);
    tree[ind] = min(tree[ind * 2 + 1], tree[ind * 2 + 2]);
}

int query(int ind, int lx, int rx, int l, int r, vector<int>& tree) {
    if (rx <= l || r <= lx)
        return INT_MAX;
    if (l <= lx && rx <= r)
        return tree[ind];
    int mid = (lx + rx) / 2;
    return min(query(ind * 2 + 1, lx, mid, l, r, tree), query(ind * 2 + 2, mid, rx, l, r, tree));
}
 
void solve() {
    int n, k; cin >> n >> k;
    s arr[k];
    for (int i = 0; i < k; ++i) {
        cin >> arr[i].l >> arr[i].m >> arr[i].r;
        --arr[i].l; --arr[i].m; --arr[i].r;
    }
    sort(arr, arr + k);

    bool ok[k] = {};
    for (int i = 0; i < k; ++i) {
        // cout << arr[i].l << ' ' << arr[i].m << ' ' << arr[i].r;
        if (arr[i].l == 0) {
            ok[i] = true;
            // cout << " OK";
        } else {
            int l = -1, r = i;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (arr[mid].r >= arr[i].l - 1)
                    r = mid;
                else
                    l = mid;
            }

            int ind = r;
            int m = query(0, 0, k, ind, i, treem);
            r = query(0, 0, k, ind, i, treer);
            // cout << " NEOK " << m << ' ' << r;
            if (arr[i].m > r || m < arr[i].l)
                ok[i] = true;
        }

        // cout << ' ' << ok[i];

        if (ok[i]) {
            if (arr[i].r == n - 1) {
                cout << "YES\n";
                return;
            }
            // cout << ' ' << arr[i].m << ' ' << arr[i].r;
            update(0, 0, k, i, arr[i].m, treem);
            update(0, 0, k, i, arr[i].r, treer);
        }
        // cout << endl;
    }

    cout << "NO\n";
}
 
int main() {
    cin.tie(0)->sync_with_stdio(0);
 
    int _; cin >> _;
    while (_--) {
        solve();
    }
 
    return 0;
}