#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
	for (T &elem: a) is >> elem;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
	for (T &elem: a) os << elem << ' ';
	return (os << '\n');
}

#define int long long

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;

      vector<string> a(n);
      for (int i = 0; i < n; ++i) cin >> a[i];

      vector<int> cnt(n);
      int res = 0;
      for (int j = m - 1; j >= 0; --j) {
            for (int i = 0; i < n; ++i) {
                  if (a[i][j] == '1') cnt[i]++;
                  else cnt[i] = 0;
            }

            vector<int> fl(n, -1);
            vector<int> st;
            st.push_back(0);
            for (int i = 1; i < n; ++i) {
                  while (!st.empty() and cnt[st.back()] >= cnt[i]) {
                        st.pop_back();
                  }
                  if (!st.empty()) fl[i] = st.back();
                  st.push_back(i);
            }

            vector<int> dp(n);
            for (int i = 0; i < n; ++i) {
                  dp[i] = (i - fl[i]) * cnt[i];
                  if (fl[i] >= 0) dp[i] += dp[fl[i]];
                  res = max(res, dp[i]);
            }

      }
      cout << res << '\n';
}

