#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for (T &elem: a) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (T &elem: a) os << elem << ' ';
      return (os << '\n');
}

#define int long long

struct seg {
      int l, m, r, id;

      friend bool operator<(seg a, seg b) {
            return a.id < b.id;
      }
};

struct Segtree {
      int size;
      vector<int> tree;

      Segtree(int n) {
            size =1 ;
            while (size < n) size *= 2;
            tree.resize(size * 2);
      }

      void set(int i, int v) {
            i += size;
            tree[i] = max(tree[i], v);
            for (i /= 2; i > 0; i /= 2) tree[i] = tree[i + i] + tree[i + i + 1];
      }

      int get(int l, int r) {
            l += size, r += size - 1;
            int res = 0;
            while (l <= r) {
                  if (l % 2) res += tree[l++];
                  if (r % 2 == 0) res += tree[r--];
                  l /= 2, r /= 2;
            }
            return res;
      }
};

void solve() {
      int n, k;
      cin >> n >> k;
      vector<seg> a(k);
      for (int i = 0; i < k; ++i) {
            auto &[l, m, r, id] = a[i];
            cin >> l >> m >> r, id = i;
      }
      std::sort(a.begin(), a.end());
      do {

            vector<int> used(n + 1);
            for (int i = 0; i < k; ++i) {
                  if (used[a[i].m]) continue;
                  for (int j = a[i].l; j <= a[i].r; ++j) {
                        used[j] = true;
                  }
            }

            bool flag = true;
            for (int i = 1; i <= n; ++i) flag &= used[i];
            if (flag) {
                  cout << "YES\n";
                  return ;
            }

      } while (next_permutation(a.begin(), a.end()));
      cout << "NO\n";
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int t;
      cin >> t;
      while (t--) solve();
}

