#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct Node {
    int mn, sum, push;
    int l, r;

    Node() {
        mn = 0;
        sum = 0;
        push = -1;
        l = -1;
        r = -1;
    }
};

vector<Node> t;

void push(int v) {
    if (t[v].push == -1)
        return;
    t[v * 2 + 1].mn = t[v].push;
    t[v * 2 + 2].mn = t[v].push;
    t[v * 2 + 1].sum = t[v].push * (t[v * 2 + 1].r - t[v * 2 + 1].l);
    t[v * 2 + 2].sum = t[v].push * (t[v * 2 + 2].r - t[v * 2 + 2].l);
    t[v * 2 + 1].push = t[v].push;
    t[v * 2 + 2].push = t[v].push;
    t[v].push = -1;
}

void init(int v, int l, int r) {
    t[v].l = l;
    t[v].r = r;
    if (l + 1 == r)
        return;

    int m = (l + r) / 2;
    init(v * 2 + 1, l, m);
    init(v * 2 + 2, m, r);
}

void Set(int v, int ql, int qr, int val) {
    if (qr <= t[v].l || t[v].r <= ql)
        return;
    if (ql <= t[v].l && t[v].r <= qr) {
        t[v].mn = val;
        t[v].sum = val * (t[v].r - t[v].l);
        t[v].push = val;
        return;
    }

    push(v);
    Set(v * 2 + 1, ql, qr, val);
    Set(v * 2 + 2, ql, qr, val);
    t[v].sum = t[v * 2 + 1].sum + t[v * 2 + 2].sum;
    t[v].mn = min(t[v * 2 + 1].mn, t[v * 2 + 2].mn);
}

int get_sum(int v, int ql, int qr) {
    if (qr <= t[v].l || t[v].r <= ql)
        return 0;
    if (ql <= t[v].l && t[v].r <= qr)
        return t[v].sum;

    push(v);
    int lc = get_sum(v * 2 + 1, ql, qr);
    int rc = get_sum(v * 2 + 2, ql, qr);
    return lc + rc;
}

int first_leq(int v, int ql, int qr, ll x) {
    if (qr <= t[v].l || t[v].r <= ql)
        return -1;
    if (t[v].mn > x)
        return -1;
    if (t[v].l + 1 == t[v].r)
        return t[v].l;

    push(v);
    int res = first_leq(v * 2 + 1, ql, qr, x);
    if (res == -1)
        res = first_leq(v * 2 + 2, ql, qr, x);
    return res;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int w, h;
    cin >> w >> h;

    vector<string> a(w);
    for (int i = 0; i < w; i++) {
        cin >> a[i];
    }
    reverse(a.begin(), a.end());

    vector<vector<int>> mxSeg(w, vector<int>(h, 0));
    for (int i = 0; i < w; i++) {
        mxSeg[i][h - 1] = a[i][h - 1] - '0';
        for (int j = h - 2; j >= 0; j--) {
            if (a[i][j] == '1')
                mxSeg[i][j] = mxSeg[i][j + 1] + 1;
        }
    }

    t.assign(w * 4, Node());
    init(0, 0, w);
    int ans = 0;
    for (int j = 0; j < h; j++) {
        Set(0, 0, w, 0);
        for (int i = w - 1; i >= 0; i--) {
            int r = first_leq(0, i + 1, w, mxSeg[i][j]);
            if (r == -1)
                r = w;
            Set(0, i, r, mxSeg[i][j]);
            ans = max(ans, get_sum(0, i, w));
        }
    }

    cout << ans << '\n';
}