// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <utility>
#include <bitset>
#include <queue>

using namespace std;
using ll =long long;
using ld = long double;

const int MAXN = (1 << 19), SIZE = 2 * MAXN - 1;
int st[SIZE], upd[SIZE];

void push(int v, int l, int r)
{
	st[v] = max(st[v], upd[v]);
	if (r - l != 1)
	{
		upd[2 * v + 1] = max(upd[2 * v + 1], upd[v]);
		upd[2 * v + 2] = max(upd[2 * v + 2], upd[v]);
	}
	upd[v] = -1;
}

int ql, qr, qt;
void update(int v, int l, int r)
{
	push(v, l, r);
	if (qr <= l || r <= ql)
		return;
	if (ql <= l && r <= qr)
	{
		upd[v] = max(upd[v], qt);
		push(v, l, r);
		return;
	}
	update(2 * v + 1, l, (l + r) >> 1);
	update(2 * v + 2, (l + r) >> 1, r);
	st[v] = max(st[2 * v + 1], st[2 * v + 2]);
}

void segment(int v, int l, int r)
{
	if (qr <= l || r <= ql)
		return;
	push(v, l, r);
	if (ql <= l && r <= qr)
	{
		qt = max(qt, st[v]);
		return;
	}
	segment(2 * v + 1, l, (l + r) >> 1);
	segment(2 * v + 2, (l + r) >> 1, r);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while (t--)
	{
		//memset(upd, -1, sizeof(upd));
		//memset(st, -1, sizeof(st));
		int n, k;
		cin >> n >> k;
		vector <tuple<int, int, int>> repair(k);
		for (auto& i : repair)
		{
			cin >> get<1>(i) >> get<0>(i) >> get<2>(i);
			get<1>(i)--;
			get<2>(i)--;
			get<0>(i)--;
		}
		int sz = 1;
		while (sz <= n)
			sz <<= 1;
		for (size_t i = 0; i < sz*2-1; i++)
		{
			st[i] = -1;
			upd[i] = -1;
		}
		sort(repair.begin(), repair.end());
		reverse(repair.begin(), repair.end());
		ql = n;
		qr = n + 1;
		qt = n;
		update(0, 0, sz);
		/*vector <int> dp(n + 1, -1);
		dp[n] = n;*/
		for (auto& i : repair)
		{
			int l = get<1>(i), r = get<2>(i), m = get<0>(i);
			int ans = -1;
			ql = m + 1;
			qr = r + 1;
			qt = -1;
			segment(0, 0, sz);
			ans = qt;
			/*for (int j = m + 1; j <= r; j++)
				ans = max(ans, dp[j]);*/
			int res = -1;
			if (ans > m)
			{
				res = l;
			}
			else
			{
				//res = min(l, dp[r + 1]);
				qt = -1;
				ql = r + 1;
				qr = r + 2;
				segment(0, 0, sz);
				res = min(l, qt);
			}
			/*for (int j = max(res, 0); j <= m; j++)
				dp[j] = max(dp[j], res);*/
			ql = max(res, 0);
			qr = m + 1;
			qt = res;
			update(0, 0, sz);
		}
		ql = 0;
		qr = 1;
		qt = -1;
		segment(0, 0, sz);
		if (qt == -1)
			cout << "NO";
		else
			cout << "YES";
		cout << '\n';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
