// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <utility>
#include <bitset>
#include <functional>
#include <queue>

using namespace std;
using ll =long long;
using ld = long double;
#ifdef _MSC_VER
#define __int128 ll
#endif
//using __int128 = ll;

ll cost(ll a)
{
	return a * a;
}

__int128 calc(__int128 a, __int128 b, __int128 x)
{
	return x * x * a + x * b;
}

// min(t*t*a+t*x*b+c*t+d*x+e)
__int128 solve_equation(ll a, ll b, ll c, ll d, ll e, ll x, ll ql, ll qr)
{
	ll base = e + d * x;
	b *= x;
	b += c;
	// now it is t*t*a+t*b+base
	__int128 cur = min(calc(a, b, ql), calc(a, b, qr));
	if (a != 0)
	{
		ll mid = -b / (2 * a);
		cur = min(cur, calc(a, b, min(qr, max(ql, mid))));
		cur = min(cur, calc(a, b, min(qr, max(ql, mid + 1))));
		cur = min(cur, calc(a, b, min(qr, max(ql, mid - 1))));
	}
	return cur + (__int128)base;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, d;
	cin >> n >> d;
	vector <vector <int>> g(n);
	for (size_t i = 1; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector <int> h(n);
	function<void(int, int)> dfs;
	dfs = [&](int v, int p)
	{
		for (auto& i : g[v])
		{
			if (i == p)
				continue;
			h[i] = h[v] + 1;
			dfs(i, v);
		}
	};
	dfs(0, 0);
	vector <int> x, y;
	for (size_t i = 0; i < n; i++)
	{
		if (h[i] % 2 == 0)
			x.push_back(i + 1);
		else
			y.push_back(i + 1);
	}
	vector <pair<int, int>> ans;
	while (!x.empty() && !y.empty())
	{
		ans.emplace_back(x.back(), y.back());
		x.pop_back();
		y.pop_back();
	}
	cout << ans.size() << '\n';
	for (auto& i : ans)
	{
		cout << i.first << ' ' << i.second << '\n';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
