// parsoch
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <cstring>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <utility>
#include <random>
#include <bitset>
#include <functional>
#include <queue>
#include <time.h>

using namespace std;
using ll =long long;
using ld = long double;
#ifdef _MSC_VER
#define __int128 ll
#endif
//using __int128 = ll;

ll cost(ll a)
{
	return a * a;
}

__int128 calc(__int128 a, __int128 b, __int128 x)
{
	return x * x * a + x * b;
}

// min(t*t*a+t*x*b+c*t+d*x+e)
__int128 solve_equation(ll a, ll b, ll c, ll d, ll e, ll x, ll ql, ll qr)
{
	ll base = e + d * x;
	b *= x;
	b += c;
	// now it is t*t*a+t*b+base
	__int128 cur = min(calc(a, b, ql), calc(a, b, qr));
	if (a != 0)
	{
		ll mid = -b / (2 * a);
		cur = min(cur, calc(a, b, min(qr, max(ql, mid))));
		cur = min(cur, calc(a, b, min(qr, max(ql, mid + 1))));
		cur = min(cur, calc(a, b, min(qr, max(ql, mid - 1))));
	}
	return cur + (__int128)base;
}

const int MAXN = 3e5 + 10;
vector <int> gr[MAXN];
int dp[MAXN][2];
bool used[MAXN];
int go[MAXN];

void dfs(int v, int p)
{
	go[v] = -1;
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 0;
	for (auto& i : gr[v])
	{
		if (i == p)
			continue;
		dfs(i, v);
		dp[v][1] += dp[i][0];
		dp[v][0] = max(dp[v][0], dp[i][1] - dp[i][0]);
		if (dp[v][0] == dp[i][1] - dp[i][0])
			go[v] = i;
	}
	dp[v][0] += dp[v][1];
	dp[v][1]++;
	dp[v][1] = max(dp[v][1], dp[v][0]);
}

vector <pair<int, int>> ans;
void restore(int v, int p, int k)
{
	if (k == 1)
	{
		if (dp[v][1] != dp[v][0])
		{
			ans.emplace_back(v + 1, p + 1);
			for (auto& i : gr[v])
			{
				if (i == p)
					continue;
				restore(i, v, 0);
			}
			return;
		}
	}
	for (auto& i : gr[v])
	{
		if (i == p)
			continue;
		if (i == go[v])
			restore(i, v, 1);
		else
			restore(i, v, 0);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, d;
	cin >> n >> d;
	for (size_t i = 1; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;
		gr[a].push_back(b);
		gr[b].push_back(a);
	}
	mt19937 rnd(time(NULL));
	for (size_t i = 0; i < n; i++)
	{
		shuffle(gr[i].begin(), gr[i].end(), rnd);
	}
	dfs(0, 0);
	restore(0, 0, 0);
	cout << dp[0][0] << '\n';
	for (auto& i : ans)
	{
		cout << i.first << ' ' << i.second << '\n';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
