#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ll INF = 1e18;

bool check(int l1, int m1, int r1, int l2, int m2, int r2) {
    return l1 <= m2 && m2 <= r1 && l2 <= m1 && m1 <= r2;
}

ll get(ll x, ll y) {
    return (x - y) * (x - y);
}

vector<int> getdist(int v, int d, int n, vector<vector<int>> &g) {
    vector<int> dist(n, -1);
    vector<int> g2;
    dist[v] = 0;
    deque<int> dq = {v};
    while (!dq.empty()) {
        int u = dq.front();
        if (dist[u] % 2 == 1 && dist[u] <= d) g2.push_back(u);
        dq.pop_front();
        for (auto to : g[u]) {
            if (dist[to] == -1) {
                dq.push_back(to);
                dist[to] = dist[u] + 1;
            }
        }
    }
    return dist;
}

vector<pair<int, int>> ans;

void gen(int st, int d, int n, vector<vector<int>> &g2, vector<bool> &used, vector<pair<int, int>> &nw) {
    if (st == n) {
        return;
    }
    if (ans.size() < nw.size()) ans = nw;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            for (auto j : g2[i]) {
                if (used[j] == 0) {
                    used[j] = 1;
                    nw.push_back({i, j});
                    gen(st + 2, d, n, g2, used, nw);
                    nw.pop_back();
                    used[j] = 0;
                }
            }
            used[i] = 0;
        }
    }
}


void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);

    for (int i = 0; i < n -1; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<vector<int>> g2(n);
    for (int i = 0; i < n; i++) {
        g2[i] = getdist(i, d, n, g);
    }
    vector<bool> used(n);
    vector<pair<int, int>> nw;
    gen(0, d, n, g2, used, nw);
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b + 1 << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
