#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ll INF = 1e18;

bool check(int l1, int m1, int r1, int l2, int m2, int r2) {
    return l1 <= m2 && m2 <= r1 && l2 <= m1 && m1 <= r2;
}

ll get(ll x, ll y) {
    return (x - y) * (x - y);
}

vector<pair<int, int>> getdist(int v, int d, int n, vector<vector<int>> &g) {
    vector<int> dist(n, -1);
    vector<pair<int, int>> g2;
    dist[v] = 0;
    deque<int> dq = {v};
    while (!dq.empty()) {
        int u = dq.front();
        if (dist[u] % 2 == 1 && dist[u] <= d) g2.push_back({u, v});
        dq.pop_front();
        for (auto to : g[u]) {
            if (dist[to] == -1) {
                dq.push_back(to);
                dist[to] = dist[u] + 1;
            }
        }
    }
    return g2;
}

void solve() {
    int n, d;
    cin >> n >> d;
    vector<vector<int>> g(n);
    vector<pair<int, int>> edges;
    for (int i = 0; i < n -1; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<vector<int>> g2(n);
    for (int i = 0; i < n; i++) {
        auto p = getdist(i, d, n, g);
        for (auto [a, b] : p) {
            edges.push_back({a, b});
        }
    }
    int all = (1 << n);
    vector<bool> dp(all);
    dp[0] = 1;
    vector<pair<int, int>> pr(all);
    for (int mask = 0; mask < all; mask++) {
        if (!dp[mask]) continue;
        for (auto [a, b] : edges) {
            if ((mask >> a) & 1 || (mask >> b) & 1) continue;
            dp[mask + (1 << a) + (1 << b)] = 1;
            pr[mask + (1 << a) + (1 << b)] = {a, b};
        }
    }
    pair<int, int> ans = {-1, -1};
    for (int i = 0; i < all; i++) {
        int cnt = __builtin_popcount(i);
        if (cnt > ans.first && dp[i]) {
            ans = {cnt, i};
        }
    }
    vector<pair<int, int>> ed;
    int nw = ans.second;
    while (nw > 0) {
        auto [a, b] = pr[nw];
        //cout << a << " " << b << " " << nw << endl;
        ed.push_back({a, b});
        nw -= (1 << a) + (1 << b);
    }
    cout << ed.size() << "\n";
    for (auto &[a, b] : ed) {
        cout << a + 1 << " " << b + 1 << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
