#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
const int INF = 1e9;

using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

struct seg_tree {
    vector<int> d;

    seg_tree(int n) {
        d.resize(4 * n, INF);
    }

    void update(int v, int l, int r, int ind, int val) {
        if (r - l == 1) {
            d[v] = min(d[v], val);
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) {
            update(2 * v + 1, l, m, ind, val);
        } else {
            update(2 * v + 2, m, r, ind, val);
        }
        d[v] = min(d[2 * v + 1], d[2 * v + 2]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return INF;
        if (ql <= l && r <= qr) return d[v];
        int m = (l + r) / 2;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<vector<int> > a(k, vector<int>(3));
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, r, m};
    }
    sort(a.begin(), a.end(), [&](vector<int> &x, vector<int> &y) {
        return x[1] < y[1];
    });
    vector<int> dp(n + 1, INF);
    seg_tree fir(n + 1);
    // fir - норм
    dp[0] = 0;
    fir.update(0, 0, n + 1, 0, 0);
    for (int i = 0; i < k; i++) {
        int l = a[i][0], r = a[i][1], m = a[i][2];
        int mx = fir.get(0, 0, n + 1, m, r);
        if (mx < l) {
            mx = max(mx, m);
            dp[r] = min({dp[r], mx});
        }
        mx = max(m, fir.get(0, 0, n + 1, l - 1, m));
        dp[r] = min({dp[r], mx});
        fir.update(0, 0, n + 1, r, dp[r]);
    }
    if (dp[n] != INF) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
