#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
#define int long long

using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

struct seg_tree {
    struct Node {
        int sum = 0, mod = -1;
    };

    vector<Node> d;

    seg_tree(int n) {
        d.resize(4 * n);
    }

    void push(int v, int l, int r) {
        if (d[v].mod == -1 || r - l == 1) return;
        int m = (l + r) / 2;
        d[2 * v + 1].sum = d[v].mod * (m - l);
        d[2 * v + 2].sum = d[v].mod * (r - m);
        d[2 * v + 1].mod = d[v].mod;
        d[2 * v + 2].mod = d[v].mod;
        d[v].mod = -1;
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || ql >= r) return 0;
        if (ql <= l && r <= qr) return d[v].sum;
        push(v, l, r);
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }

    void update(int v, int l, int r, int ql, int qr, int val) {
        if (ql >= r || l >= qr) return;
        if (ql <= l && r <= qr) {
            d[v].sum = (r - l) * val;
            d[v].mod = val;
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, ql, qr, val);
        update(2 * v + 2, m, r, ql, qr, val);
        d[v].sum = d[2 * v + 1].sum + d[2 * v + 2].sum;
    }
};

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), m(k), r(k);
    vector<vector<int> > a(k, vector<int>(3));
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
        l[i]--;
        r[i]--;
        m[i]--;
        a[i] = {m[i], l[i], r[i]};
    }
    sort(a.begin(), a.end(), [&](vector<int> &x, vector<int> &y) {
        int len1 = x[2] - x[1], len2 = y[2] - y[1];
        if (len1 == len2) {
            return x[2] < y[2];
        }
        return len1 < len2;
    });
    seg_tree st(n);
    for (int i = 0; i < k; i++) {
        int now = st.get(0, 0, n, a[i][0], a[i][0] + 1);
        if (now == 1) continue;
        st.update(0, 0, n, a[i][1], a[i][2] + 1, 1);
    }
    if (st.get(0, 0, n, 0, n) == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
