#include <bits/stdc++.h>
#define ll long long
#define ld long double
using namespace std;
ll get_cnt(ll i1, ll j1, ll i2, ll j2, vector<vector<ll> > &pref) {
    return pref[i2][j2] - (i1 > 0 ? pref[i1 - 1][j2] : 0ll) - (j1 > 0 ? pref[i2][j1 - 1] : 0ll) + (
               (i1 > 0 && j1 > 0) ? pref[i1 - 1][j1 - 1] : 0ll);
}

struct segment_tree {
    segment_tree(ll lb, ll rb): lb(lb), rb(rb) {
        if (lb != rb) {
            ll mid = (lb + rb) / 2;
            l = new segment_tree(lb, mid);
            r = new segment_tree(mid + 1, rb);
        }
    }

    void push() {
        if (l) {
            l->ass = ass;
        }
        if (r) {
            r->ass = ass;
        }
        if (ass != -1) {
            mx = ass;
            mn = ass;
            sm = ass * (rb - lb + 1);
            ass = -1;
        }
    }

    void set(ll lm, ll rm, ll x) {
        push();
        if (lb > rm || rb < lm) {
            return;
        }
        if (lb >= lm && rb <= rm) {
            ass = x;
            push();
            return;
        }
        l->set(lm, rm, x);
        r->set(lm, rm, x);
        mx = max(l->mx, r->mx);
        mn = min(l->mn, r->mn);
        sm = l->sm + r->sm;
    }

    void set_pos(ll lm, ll rm, ll x) {
        push();
        if (l) l->push();
        if (r) r->push();
        if (mx <= x) {
            return;
        }
        if (lb > rm || rb < lm) {
            return;
        }
        if (lb >= lm && rb <= rm) {
            if (mn > x) {
                ass = x;
                push();
                return;
            }
            if (r->mn > x) {
                l->ass = x;
                l->push();
                r->set_pos(lm, rm, x);
                mx = max(l->mx, r->mx);
                mn = min(l->mn, r->mn);
                sm = l->sm + r->sm;
                return;
            } else {
                l->set_pos(lm, rm, x);
                mx = max(l->mx, r->mx);
                mn = min(l->mn, r->mn);
                sm = l->sm + r->sm;
                return;
            }
        }
        l->set_pos(lm, rm, x);
        r->set_pos(lm, rm, x);
        mx = max(l->mx, r->mx);
        mn = min(l->mn, r->mn);
        sm = l->sm + r->sm;
    }

    ll get_sum(ll lm, ll rm) {
        push();
        if (lb > rm || rb < lm) {
            return 0;
        }
        if (lb >= lm && rb <= rm) {
            return sm;
        }
        return l->get_sum(lm, rm) + r->get_sum(lm, rm);
    }

    ll mx = 0, sm = 0, ass = -1, mn = 0;
    ll lb, rb;
    segment_tree *l = nullptr, *r = nullptr;
};

void solve() {
    ll h, w;
    cin >> h >> w;
    vector<string> f(h);
    vector<vector<ll> > len(h, vector<ll>(w));
    for (ll i = 0; i < h; ++i) {
        cin >> f[i];
    }
    vector<ll> pref(w);
    ll mx = 0;
    for (ll i = 0; i < h; ++i) {
        for (ll j = 0; j < w; ++j) {
            if (f[i][j] == '0') pref[j] = 0;
            else pref[j] += 1;
        }
        segment_tree seg(0, w - 1);
        ll sm = 0;
        ll rb = w - 1;
        for (ll j = w - 1; j >= 0; --j) {
            if (pref[j] == 0) {
                mx = max(mx, seg.get_sum(j, rb));
                sm = 0;
                rb = j - 1;
                continue;
            }
            seg.set(j, j, pref[j]);
            if (j < w - 1 && pref[j + 1] > pref[j]) {
                seg.set_pos(j + 1, rb, pref[j]);
            }
            mx = max(mx, seg.get_sum(j, rb));
        }
        mx = max(mx, seg.get_sum(0, rb));
        // for (ll j = 0; j < w; ++j) {
        //     ll mn = pref[j];
        //     ll sm = 0;
        //     for (ll z = j; z < w && pref[z] != 0; ++z) {
        //         mn = min(mn, pref[z]);
        //         sm += mn;
        //     }
        //     mx = max(mx, sm);
        // }
    }
    cout << mx;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
    // cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
