#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

struct SGT {
    struct Node {
        int mn = inf;
        int mod = -1;

        Node() {}
    };

    vector<Node> t;
    SGT(int n) : t(4 * n) {}

    void updateV(int v, int mod) {
        t[v].mn = mod;
        t[v].mod = mod;
    }

    void push(int v) {
        if (t[v].mod == -1) return;
        updateV(2 * v + 1, t[v].mod);
        updateV(2 * v + 2, t[v].mod);
        t[v].mod = -1;
    }

    void set(int v, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql) {
            return;
        } else if (ql <= l && r <= qr) {
            updateV(v, val);
            return;
        }
        push(v);
        int m = (l + r) / 2;
        set(2 * v + 1, l, m, ql, qr, val);
        set(2 * v + 2, m, r, ql, qr, val);
        t[v].mn = min(t[2 * v + 1].mn, t[2 * v + 2].mn);
    }

    int minSG(int v, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql) {
            return inf;
        } else if (ql <= l && r <= qr) {
            return t[v].mn;
        }
        push(v);
        int m = (l + r) / 2;
        set(2 * v + 1, l, m, ql, qr, val);
        set(2 * v + 2, m, r, ql, qr, val);
        t[v].mn = min(t[2 * v + 1].mn, t[2 * v + 2].mn);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> dp(n + 1);
    vector<int> nxt(n + 1, inf);
    vector<vector<vector<int>>> segs(n + 1);
    for (int i = 0, l, m, r; i < k; ++i) {
        cin >> l >> m >> r;
        segs[m].push_back({l, r});
    }

    dp[0] = 1;
    vector<vector<int>> curr;
    for (int i = 1; i <= n; ++i) {
        for (auto seg : segs[i]) {
            if (dp[seg[0] - 1] || nxt[seg[0] - 1] < i) {
                bool flag = 0;
                for (int pos = seg[0]; pos <= seg[1]; ++pos) {
                    if (i <= pos) dp[pos] = 1;
                    if (nxt[pos] < seg[1]) {
                        flag = 1;
                    } else if (nxt[pos] > seg[1] && flag == 1 && nxt[pos] != inf) {
                        throw exception();
                    }
                    nxt[pos] = min(nxt[pos], seg[1]);
                }
            }
        }
    }

    cout << (dp[n] == 1 ? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}