#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

struct SGTB {
    struct Node {
        int mn = inf;
        int mx = inf;
        int mod = -1;

        Node() {}
    };

    vector<Node> t;
    SGTB(int n) : t(4 * n) {}

    void updateV(int v, int mod) {
        t[v].mn = min(mod, t[v].mn);
        t[v].mx = mod;
        t[v].mod = mod;
    }

    void push(int v) {
        if (t[v].mod == -1) return;
        updateV(2 * v + 1, t[v].mod);
        updateV(2 * v + 2, t[v].mod);
        t[v].mod = -1;
    }

    void set(int v, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql || t[v].mx <= val) {
            return;
        } else if (ql <= l && r <= qr && t[v].mn >= val) {
            updateV(v, val);
            return;
        }
        push(v);
        int m = (l + r) / 2;
        set(2 * v + 1, l, m, ql, qr, val);
        set(2 * v + 2, m, r, ql, qr, val);
        t[v].mn = min(t[2 * v + 1].mn, t[2 * v + 2].mn);
        t[v].mx = max(t[2 * v + 1].mx, t[2 * v + 2].mx);
    }

    int minSG(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return inf;
        } else if (ql <= l && r <= qr) {
            return t[v].mn;
        }
        push(v);
        int m = (l + r) / 2;
        return min(minSG(2 * v + 1, l, m, ql, qr), minSG(2 * v + 2, m, r, ql, qr));;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> dp(n + 1);
    vector<vector<vector<int>>> segs(n + 1);
    for (int i = 0, l, m, r; i < k; ++i) {
        cin >> l >> m >> r;
        segs[m].push_back({l, r});
    }

    dp[0] = 1;
    SGTB tree(n + 1);
    SGTB tree1(n + 1);
    tree1.set(0, 0, n + 1, 0, 1, 1);
    vector<vector<int>> curr;
    for (int i = 1; i <= n; ++i) {
        for (auto seg : segs[i]) {
            if (tree1.minSG(0, 0, n + 1, seg[0] - 1, seg[0]) != inf || tree.minSG(0, 0, n + 1, seg[0], seg[0] + 1) < i) {
                tree.set(0, 0, n + 1, seg[0], seg[1] + 1, seg[1]);
                tree1.set(0, 0, n + 1, i, seg[1] + 1, 1);
            }
        }
    }

    cout << (tree1.minSG(0, 0, n + 1, n, n + 1) == 1 ? "YES" : "NO") << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}