#include <bits/stdc++.h>

using namespace std;


#define int long long
#define ld long double

struct node {
    int mn, mod, cnt;
};

vector<node> tree;

mt19937 rnd(time(0));


void build(int v,int tl,int tr) {
    if (tl == tr) {
        tree[v].cnt = 1;
    } else {
        int m = (tl + tr) / 2;
        build(v * 2, tl, m);
        build(v * 2 + 1, m + 1, tr);
        tree[v].cnt = tree[v * 2].cnt + tree[v * 2 + 1].cnt;
    }
}

void push(int v) {
    int x = tree[v].mod;
    tree[v].mod = 0;
    tree[v * 2].mn += x;
    tree[v * 2 + 1].mn += x;
    tree[v * 2].mod += x;
    tree[v * 2 + 1].mod += x;
    if (tree[v * 2].mn) {
        tree[v * 2].cnt = 0;
    }
    if (tree[v * 2 + 1].mn) {
        tree[v * 2 + 1].cnt = 0;
    }
}

void upd(int v,int tl,int tr,int l,int r) {
    if (tl > r | tr < l) {
        return;
    } else if (tl >= l && tr <= r) {
        tree[v].mn++;
        tree[v].mod++;
        if (tree[v].mn) {
            tree[v].cnt = 0;
        }
        return;
    }
    push(v);
    int m = (tl + tr) / 2;
    upd(v * 2, tl, m, l, r);
    upd(v * 2 + 1, m + 1, tr, l, r);
    tree[v].mn = min(tree[v * 2].mn, tree[v * 2 + 1].mn);
    tree[v].cnt = tree[v * 2].cnt + tree[v * 2 + 1].cnt;
}

int fnd(int v,int tl,int tr,int pos) {
    if (tl == tr) {
        return tree[v].mn;
    }
    push(v);
    int m = (tl + tr) / 2;
    if (pos <= m) {
        return fnd(v * 2, tl, m, pos);
    } else {
        return fnd(v * 2 + 1, m + 1, tr, pos);
    }
}

struct calls {
    int l, m, r;
};

bool cmp(calls a, calls b) {
    if (b.m < a.l || b.m > a.r) {
        return true;
    }
    return false;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        tree.clear();
        tree.resize(n * 4);
        vector<calls> a(k);
        vector<int> p(k);
        iota(p.begin(), p.end(), 0);
        build(1,0,n-1);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
            a[i].l--;
            a[i].m--;
            a[i].r--;
            if (!fnd(1, 0, n - 1, a[i].m)) {
                upd(1, 0, n - 1, a[i].l, a[i].r);
            }
        }
        ld temp = 1, colding = 0.999;
        int cur_cnt = tree[1].cnt;
        int q = 100;
        while (cur_cnt > 0 && q) {
            tree.clear();
            tree.resize(4 * n);
            build(1,0,n-1);
            q--;
            temp *= colding;
            int f = rnd() % k;
            int s = rnd() % k;
            while (s == f) {
                s = rnd() % k;
            }
            swap(p[f], p[s]);
            for (auto i: p) {
                if (!fnd(1, 0, n - 1, a[i].m)) {
                    upd(1, 0, n - 1, a[i].l, a[i].r);
                }
            }
            int new_cnt = tree[1].cnt;
            int delta = cur_cnt - new_cnt;
            if (new_cnt <= cur_cnt || (ld) (rnd() % 1000000000) / 1000000000 < exp(t / delta)) {
                cur_cnt = new_cnt;
            }
        }
        if (tree[1].mn) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    return 0;
}
