#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

typedef long long ll;

#define fi(from, to) for(int i = from; i <= to; i++)
#define fj(from, to) for(int j = from; j <= to; j++)

using namespace std;
int h, w;
vector <vector <int>> s;
vector <int> p;
vector <int> t;
vector <ll> t1;

int sz = 200'001;

void build(int u = 0, int l = 0, int r = sz) {
	if (l + 1 == r) {
		t[u] = p[l];
		return;
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	build(u1, l, mid);
	build(u2, mid, r);
	t[u] = t[u1] + t[u2];
}

ll get(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return t[u];
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	return get(ql, qr, u1, l, mid) + get(ql, qr, u2, mid, r);
}

ll get_sum(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return t1[u];
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	return get_sum(ql, qr, u1, l, mid) + get_sum(ql, qr, u2, mid, r);
}

void upd(int qi, int val, int u = 0, int l = 0, int r = sz) {
	if (qi < l || qi >= r) return;
	if (l + 1 == r) {
		t[u] = val;
		t1[u] = l * val;
		return;
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	upd(qi, val, u1, l, mid);
	upd(qi, val, u2, mid, r);
	t[u] = t[u1] + t[u2];
	t1[u] = t1[u1] + t1[u2];
}

int main() {
	cin >> h >> w;
	s.resize(h + 1, vector <int>(w + 1));
	fi(1, h) {
		string a;
		cin >> a;
		fj(1, w) {
			s[i][j] = a[j - 1] - '0';
		}
	}
	vector <vector <int>> dp(h + 1, vector <int>(w + 1));
	// vector <vector <pair <int, int>>> dp(h + 1, vector <pair <int, int>>(w + 1)); // ans, lenght
	fj(1, w) {
		fi(1, h) {
			if (s[i][j] == 1) {
				dp[i][j] = dp[i - 1][j] + 1;
			}
		}
	}
	ll ans = 0;
	p.resize(sz);
	t.resize(4 * sz + 10);
	t1.resize(4 * sz + 10);
	fi(1, h) {
		/*fj(1, w) {
			int sum = dp[i][j];
			int mx = dp[i][j];
			for (int j1 = j + 1; j1 <= w; j1++) {
				sum += min(mx, dp[i][j1]);
				mx = min(mx, dp[i][j1]);
			}
			ans = max(ans, sum);
		}*/
		ll sum = 0;
		for (int l = w, r = w; l > 0; l--) {
			sum += dp[i][l];
			int cnt = get(dp[i][l] + 1, sz);
			ll add = get_sum(dp[i][l] + 1, sz);
			sum -= add;
			sum += cnt * dp[i][l];
			p[dp[i][l]]++;
			upd(dp[i][l], p[dp[i][l]]);
			if (cnt) {
				while (r > l) {
					p[dp[i][r]]--;
					upd(dp[i][r], p[dp[i][r]]);
					p[dp[i][l]]++;
					r--;
				}
				upd(dp[i][l], p[dp[i][l]]);
			}
			ans = max(ans, sum);
		}
		p.resize(sz);
		t.resize(4 * sz + 10);
		t1.resize(4 * sz + 10);
	}
	cout << ans;
}