#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdio>

typedef long long ll;

#define fi(from, to) for(int i = from; i <= to; i++)
#define fj(from, to) for(int j = from; j <= to; j++)

using namespace std;
int h, w;
vector <vector <int>> s;
vector <int> p;
vector <ll> t;
vector <ll> t1;
vector <ll> add;

int sz = 200'001;

void build(int u = 0, int l = 0, int r = sz) {
	if (l + 1 == r) {
		t[u] = p[l];
		return;
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	build(u1, l, mid);
	build(u2, mid, r);
	t[u] = t[u1] + t[u2];
}

void push(int u, int l, int r) {
	if (add[u] == -1) {
		return;
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	t[u1] = 0;
	t1[u1] = 0;
	add[u1] = 0;
	t[u2] = 0;
	t1[u2] = 0;
	add[u2] = 0;
	add[u] = -1;
}

ll get(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return t[u];
	}
	push(u, l, r);
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	return get(ql, qr, u1, l, mid) + get(ql, qr, u2, mid, r);
}

ll get_sum(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return t1[u];
	}
	push(u, l, r);
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	return get_sum(ql, qr, u1, l, mid) + get_sum(ql, qr, u2, mid, r);
}

void upd(int qi, ll val, int u = 0, int l = 0, int r = sz) {
	if (qi < l || qi >= r) return;
	if (l + 1 == r) {
		t[u] += val;
		t1[u] = l * t[u];
		return;
	}
	push(u, l, r);
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	upd(qi, val, u1, l, mid);
	upd(qi, val, u2, mid, r);
	t[u] = t[u1] + t[u2];
	t1[u] = t1[u1] + t1[u2];
}

void upd1(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || ql >= r) return;
	if (ql <= l && r <= qr) {
		t[u] = 0;
		t1[u] = 0;
		add[u] = 0;
		return;
	}
	push(u, l, r);
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	upd1(ql, qr, u1, l, mid);
	upd1(ql, qr, u2, mid, r);
	t[u] = t[u1] + t[u2];
	t1[u] = t1[u1] + t1[u2];
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> h >> w;
	s.resize(h + 1, vector <int>(w + 1));
	fi(1, h) {
		string a;
		cin >> a;
		fj(1, w) {
			s[i][j] = a[j - 1] - '0';
		}
	}
	vector <vector <ll>> dp(h + 1, vector <ll>(w + 1));
	// vector <vector <pair <int, int>>> dp(h + 1, vector <pair <int, int>>(w + 1)); // ans, lenght
	fj(1, w) {
		fi(1, h) {
			if (s[i][j] == 1) {
				dp[i][j] = dp[i - 1][j] + 1;
			}
		}
	}
	ll ans = 0;
	p.resize(sz);
	t.resize(4 * sz + 10);
	t1.resize(4 * sz + 10);
	add.resize(4 * sz + 10, -1);
	fi(1, h) {
		/*fj(1, w) {
			int sum = dp[i][j];
			int mx = dp[i][j];
			for (int j1 = j + 1; j1 <= w; j1++) {
				sum += min(mx, dp[i][j1]);
				mx = min(mx, dp[i][j1]);
			}
			ans = max(ans, sum);
		}*/
		ll sum = 0;
		ll mn = 1e9 + 7;
		for (int l = w; l > 0; l--) {
			ll cnt = get(dp[i][l] + 1, sz);
			if (cnt) {
				upd1(dp[i][l] + 1, sz);
				upd(dp[i][l], cnt);
			}
			upd(dp[i][l], 1);
			sum = get_sum(1, sz);
			ans = max(ans, sum);
		}
		upd1(0, sz);
	}
	cout << ans;
}