#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<stack>
#include<deque>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<ctime>
#include<random>
#include<unordered_set>
#include<unordered_map>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

const int N = 3e5 + 2, inf = 1e4 + 100;
const ll llinf = 4e18 + 1000;
int n, n1 = 0, n2 = 0, q, d, xs[N];
ll a[N], b[N], sufa[N], sufb[N];
ll suf2a[N], suf2b[N], ansa[N], ansb[N];
ll geta_ind(int ind, ll t) {
	ll x = ind == 0 ? 0 : (a[ind - 1] + d - 1) / d;
	ll sum = x * t;
	x *= d;
	sum += ansa[ind];
	sum += x * x * (n1 - ind);
	sum += suf2a[ind];
	sum -= sufa[ind] * x * 2;
	return sum;
}
ll geta(int ind, ll x, ll t) {
	ll sum = x * t;
	x *= d;
	if (ind && a[ind - 1] >= x) --ind;
	sum += ansa[ind];
	sum += x * x * (n1 - ind);
	sum += suf2a[ind];
	sum -= sufa[ind] * x * 2;
	return sum;
}
ll getb_ind(int ind, ll t) {
	ll x = ind == 0 ? 0 : (b[ind - 1] + d - 1) / d;
	ll sum = x * t;
	x *= d;
	sum += ansb[ind];
	sum += x * x * (n2 - ind);
	sum += suf2b[ind];
	sum -= sufb[ind] * x * 2;
	return sum;
}
ll getb(int ind, ll x, ll t) {
	ll sum = x * t;
	x *= d;
	if (ind && b[ind - 1] >= x) --ind;
	sum += ansb[ind];
	sum += x * x * (n2 - ind);
	sum += suf2b[ind];
	sum -= sufb[ind] * x * 2;
	return sum;
}
ll get1(ll t) {
	int l = 0, r = n1 - 1;
	while (l < r) {
		int m = (l + r) / 2;
		if (geta_ind(m, t) <= geta_ind(m + 1, t)) r = m;
		else
			l = m + 1;
	}
	int ind = l;
	l = ind == 0 ? 0 : (a[ind - 1] + d - 1) / d, r = inf / d;
	while (l < r) {
		int m = (l + r) / 2;
		if (geta(ind, m, t) <= geta(ind, m + 1, t)) r = m;
		else
			l = m + 1;
	}
	return geta(ind, l, t);
}
ll get2(ll t) {
	int l = 0, r = n2 - 1;
	while (l < r) {
		int m = (l + r) / 2;
		if (getb_ind(m, t) <= getb_ind(m + 1, t)) r = m;
		else
			l = m + 1;
	}
	int ind = l;
	l = ind == 0 ? 0 : (b[ind - 1] + d - 1) / d, r = inf / d;
	while (l < r) {
		int m = (l + r) / 2;
		if (getb(ind, m, t) <= getb(ind, m + 1, t)) r = m;
		else
			l = m + 1;
	}
	return getb(ind, l, t);
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> xs[i];
	int x0;
	cin >> x0 >> d >> q;
	for (int i = 0; i < n; ++i) {
		xs[i] -= x0;
		if (xs[i] < 0) a[n1++] = -xs[i];
		else
			b[n2++] = xs[i];
	}
	sort(a, a + n1);
	sort(b, b + n2);
	for (int i = n1 - 1; i >= 0; --i) {
		sufa[i] = sufa[i + 1] + a[i];
		suf2a[i] = suf2a[i + 1] + a[i] * a[i];
	}
	for (int i = n2 - 1; i >= 0; --i) {
		sufb[i] = sufb[i + 1] + b[i];
		suf2b[i] = suf2b[i + 1] + b[i] * b[i];
	}
	for (int i = 0; i < n1; ++i) {
		ansa[i + 1] = ansa[i];
		ll dist = min(a[i] % d, d - a[i] % d);
		ansa[i + 1] += dist * dist;
	}
	for (int i = 0; i < n2; ++i) {
		ansb[i + 1] = ansb[i];
		ll dist = min(b[i] % d, d - b[i] % d);
		ansb[i + 1] += dist * dist;
	}
	while (q--) {
		ll t;
		cin >> t;
		ll ans = get1(t) + get2(t * 2);
		ans = min(ans, get1(t * 2) + get2(t));
		cout << ans << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}