#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<stack>
#include<deque>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<cstdio>
#include<bitset>
#include<ctime>
#include<random>
#include<unordered_set>
#include<unordered_map>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

mt19937 mt(time(0));
const int N = 3e5 + 2, inf = 1e9 + 100;
const ll llinf = 4e18 + 1000;
struct st {
	int ind, l, r;
};
int n, d, dist[N], tin[N], tout[N], p[N], pr[N], used[N], ind[N], timer = 0;
vector<int> nodes[N];
vector<int> g[N];
vector<st> seg[N];
void dfs(int v) {
	ind[timer] = v;
	tin[v] = timer++;
	nodes[dist[v]].push_back(tin[v]);
	for (auto to : g[v]) {
		if (to == p[v]) continue;
		p[to] = v;
		dist[to] = dist[v] + 1;
		dfs(to);
	}
	tout[v] = timer;
}
bool kuhn(int v) {
	if (used[v] == timer) return false;
	used[v] = timer;
	for (int it = 0; it < 100; ++it) {
		int i = mt() % seg[v].size();
		int to = seg[v][i].l + mt() % (seg[v][i].r - seg[v][i].l + 1);
		to = ind[nodes[seg[v][i].ind][to]];
		if (pr[to] == -1) {
			pr[to] = v;
			pr[v] = to;
			return true;
		}
	}
	for (int it = 0; it < 100; ++it) {
		int i = mt() % seg[v].size();
		int to = seg[v][i].l + mt() % (seg[v][i].r - seg[v][i].l + 1);
		to = ind[nodes[seg[v][i].ind][to]];
		if (kuhn(pr[to])) {
			pr[to] = v;
			pr[v] = to;
			return true;
		}
	}
	return false;
}

void solve() {
	cin >> n >> d;
	for (int i = 0; i + 1 < n; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	p[0] = -1;
	dfs(0);
	for (int v = 0; v < n; ++v) {
		int u = p[v];
		for (int h = dist[v] + 1; h <= dist[v] + d; h += 2) {
			if (lower_bound(all(nodes[h]), tin[v]) != nodes[h].end() && *lower_bound(all(nodes[h]), tin[v]) < tout[v]) {
				seg[v].push_back({ h, lower_bound(all(nodes[h]), tin[v]) - nodes[h].begin(), --lower_bound(all(nodes[h]), tout[v]) - nodes[h].begin() });
			}
		}
		for (int it = 1; u != -1 && it <= 3; ++it) {
			for (int h = dist[u]; h - dist[u] + it <= d; ++h) {
				if ((h - dist[u] + it) % 2 == 0) continue;
				if (lower_bound(all(nodes[h]), tin[u]) != nodes[h].end() && *lower_bound(all(nodes[h]), tin[u]) < tin[v])
					seg[v].push_back({ h, lower_bound(all(nodes[h]), tin[u]) - nodes[h].begin(), --lower_bound(all(nodes[h]), tin[v]) - nodes[h].begin() });
				if (lower_bound(all(nodes[h]), tout[v]) != nodes[h].end() && *lower_bound(all(nodes[h]), tout[v]) < tout[u])
					seg[v].push_back({ h, lower_bound(all(nodes[h]), tout[v]) - nodes[h].begin(), --lower_bound(all(nodes[h]), tout[u]) - nodes[h].begin() });
			}
			u = p[u];
		}
	}
	timer = 1;
	fill(pr, pr + n, -1);
	vector<int> per;
	for (int i = 0; i < n; ++i) {
		per.push_back(i);
		swap(per[i], per[mt() % (i + 1)]);
	}
	for (auto v : per) {
		if (dist[v] % 2 == 0) {
			if (kuhn(v)) ++timer;
		}
	}
	vector<pair<int, int>> ans;
	for (int v = 0; v < n; ++v) {
		if (dist[v] % 2 == 0 && pr[v] != -1) ans.push_back({ v, pr[v] });
	}
	cout << ans.size() << '\n';
	for (auto i : ans) cout << i.first + 1 << ' ' << i.second + 1 << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}