#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
#define all(a) a.begin(), a.end() 


constexpr int tag = 1e9;

struct nd{
    int mn, pmn;
    nd()
    {
        pmn = tag;
        mn = tag;
    }
};


void push(int v, vector<nd>&tree)
{
    tree[2 * v + 1].pmn = min(tree[2 * v + 1].pmn, tree[v].pmn);
    tree[2 * v + 2].pmn = min(tree[2 * v + 2].pmn, tree[v].pmn);
    tree[2 * v + 1].mn = min(tree[2 * v + 1].mn, tree[2 * v + 1].pmn);
    tree[2 * v + 2].mn = min(tree[2 * v + 2].mn, tree[2 * v + 2].pmn);
    return;
}

void upd(int v, int l, int r, int ql, int qr, int x, vector<nd>&tree)
{
    tree[v].mn = min(tree[v].mn, tree[v].pmn);
    if(ql >= r || qr <= l)
    {
        return;
    }
    if(ql <= l && r <= qr)
    {
        tree[v].pmn = min(tree[v].pmn, x);
        tree[v].mn = min(tree[v].mn, tree[v].pmn);
        return;
    }
    push(v, tree);
    int mid = (r + l)/2;
    upd(2 * v + 1, l, mid, ql, qr, x, tree);
    upd(2 * v + 2, mid, r, ql, qr, x, tree);
    tree[v].mn = min(tree[2 * v + 1].mn, tree[2 * v + 2].mn);
}

int gt(int v, int l, int r, int ql, int qr, int x, vector<nd>&tree)
{
    if(ql >= r || qr <= l)
    {
        return 1e9;
    }
    if(ql <= l && r <= qr)
    {
        tree[v].mn = min(tree[v].mn, tree[v].pmn);
        return tree[v].mn;
    }
    int resl, resr;
    push(v, tree);
    int mid = (r + l)/2;
    resl = gt(2 * v + 1, l, mid, ql, qr, x, tree);
    resr = gt(2 * v + 2, mid, r, ql, qr, x, tree);
    tree[v].mn = min(tree[2 * v + 1].mn, tree[2 * v + 2].mn);
    return min(resl, resr);
}
void solve()
{
    int n, k;
    cin >> n >> k;
    vector<vector<int>>st(k, vector<int>(3));
    for(int i = 0; i < k; i++)
    {
        cin >> st[i][1] >> st[i][0] >> st[i][2];
    }
    sort(all(st));
    vector<nd>pr(4 * n + 8);
    upd(0, 0, n + 2, 0, 1, 0, pr);
    vector<nd>suf(4 * n + 8);
    upd(0, 0, n + 2, n + 1, n + 2, -n - 1, suf);
    int l, r, res;
    int res2;
    for(int i = 0; i < k; i++)
    {
        l = st[i][1];
        r = st[i][2];
        res = gt(0, 0, n + 2, l - 1, l, 0, pr);
        res = max(res, r);
        res2 = gt(0, 0, n + 2, l, st[i][0], 0, pr);
        if(res2 < st[i][0])
        {
            res = min(res, r);
        }
        upd(0, 0, n + 2, st[i][0], r + 1, res, pr);
    }
    for(int i = k - 1; i > -1; i--)
    {
        l = st[i][1];
        r = st[i][2];
        res = gt(0, 0, n + 2, r + 1, r + 2, 0, suf);
        res = max(res, -l);
        res2 = gt(0, 0, n + 2, st[i][0] + 1, r + 1, 0, suf);
        if(-res2 > st[i][0])
        {
            res = min(-l, res);
        }
        upd(0, 0, n + 2, l, st[i][0] + 1, res, suf);
    }
    int res3;
    for(int i = 0; i < k; i++)
    {
        l = st[i][1];
        r = st[i][2];
        res = gt(0, 0, n + 2, l - 1, l, 0, pr);
        res3 = gt(0, 0, n + 2, l, st[i][0], 0, pr);
        if(res3 < st[i][0])
        {
            res = res3;
        }
        res2 = gt(0, 0, n + 2, r + 1, r + 2, 0, suf);
        res3 = gt(0, 0, n + 2, st[i][0] + 1, r + 1, 0, suf);
        if(-res3 > st[i][0])
        {
            res2 = res3;
        }
        if(res < st[i][0] && -res2 > st[i][0])
        {
            cout << "YES" << endl;
            return;
        }
    }
    cout << "NO" << endl;
}

int main()
{
    int t;
    cin >> t;
    while(t--)
    {
        solve();
    }
    return 0;
}