#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

struct Node {
	int sum = 0;
	int add = 0;
	int pusheq = -1;
};

void merge(int v, vector<Node>& tree) {
	tree[v].sum = tree[2 * v].sum + tree[2 * v + 1].sum;
}

void pushsum(int v, int l, int r, int x, vector<Node>& tree) {
	tree[v].sum += (r - l) * x;
	tree[v].add += x;
}

void pusheq(int v, int l, int r, int x, vector<Node>& tree) {
	tree[v].sum = (r - l) * x;
	tree[v].pusheq = x;
}

void push(int v, int l, int r, vector<Node>& tree) {
	if (r - l <= 1) {
		return;
	}
	int m = (l + r) / 2;
	pushsum(2 * v, l, m, tree[v].add, tree);
	pushsum(2 * v + 1, m, r, tree[v].add, tree);
	tree[v].add = 0;
	if (tree[v].pusheq != -1) {
		pusheq(2 * v, l, m, tree[v].pusheq, tree);
		pusheq(2 * v + 1, m, r, tree[v].pusheq, tree);
		tree[v].pusheq = -1;
	}
}

void addition(int v, int l, int r, int ql, int qr, int x, vector<Node>& tree) {
	if (qr <= l or ql >= r) {
		return;
	}
	if (ql <= l and r <= qr) {
		pushsum(v, l, r, x, tree);
		return;
	}
	int m = (l + r) / 2;
	push(v, l, r, tree);
	addition(2 * v, l, m, ql, qr, x, tree);
	addition(2 * v + 1, m, r, ql, qr, x, tree);
	merge(v, tree);
}

void setting(int v, int l, int r, int ql, int qr, int x, vector<Node>& tree) {
	if (qr <= l or ql >= r) {
		return;
	}
	if (ql <= l and r <= qr) {
		pusheq(v, l, r, x, tree);
		return;
	}
	int m = (l + r) / 2;
	push(v, l, r, tree);
	setting(2 * v, l, m, ql, qr, x, tree);
	setting(2 * v + 1, m, r, ql, qr, x, tree);
	merge(v, tree);
}

void solve() {
	int h, w;
	cin >> h >> w;
	vector<vector<int>> input(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			char c;
			cin >> c;
			input[h - i - 1][j] = (c - '0');
		}
	}
	vector<vector<int>> arr;
	if (w > h) {
		swap(h, w);
		arr.resize(h, vector<int>(w, 0));
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				arr[i][j] = input[j][i];
			}
		}
	}
	else {
		arr = input;
	}
	vector<vector<int>> sum(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		for (int j = w - 1; j > -1; j--) {
			if (arr[i][j] == 0) {
				sum[i][j] = 0;
			}
			else {
				if (j == w - 1) {
					sum[i][j] = 1;
					continue;
				}
				sum[i][j] = sum[i][j + 1] + 1;
			}
		}
	}
	int ans = 0;
	for (int j = 0; j < w; j++) {
		vector<int> cur;
		int maxi = 0;
		for (int i = h - 1; i > -1; i--) {
			cur.push_back(sum[i][j]);
			maxi = max(maxi, cur.back());
		}
		int power = 0;
		while ((1 << power) < (maxi + 1)) {
			power += 1;
		}
		int n = (1 << power);
		vector<Node> tree(2 * n);
		for (int ind = 1; ind <= h; ind++) {
			addition(1, 0, n, 1, cur[ind - 1] + 1, 1, tree);
			setting(1, 0, n, cur[ind - 1] + 1, n, 0, tree);
			ans = max(ans, tree[1].sum);
		}
	}
	cout << ans;
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	int i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
	return 0;
}