#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

struct Node {
	int sum = 0;
	int add = 0;
	int pusheq = -1;
};

Node tree[1 << 16];

void merge(int v) {
	tree[v].sum = tree[2 * v].sum + tree[2 * v + 1].sum;
}

void pushsum(int v, int l, int r, int x) {
	tree[v].sum += (r - l) * x;
	tree[v].add += x;
}

void pusheq(int v, int l, int r) {
	tree[v].sum = 0;
	tree[v].pusheq = 0;
	tree[v].add = 0;
}

void push(int v, int l, int r) {
	if (r - l <= 1) {
		return;
	}
	int m = (l + r) / 2;
	if (tree[v].pusheq != -1) {
		pusheq(2 * v, l, m);
		pusheq(2 * v + 1, m, r);
		tree[v].pusheq = -1;
	}
	pushsum(2 * v, l, m, tree[v].add);
	pushsum(2 * v + 1, m, r, tree[v].add);
	tree[v].add = 0;
}

void addition(int v, int l, int r, int ql, int qr, int x) {
	if (qr <= l || ql >= r) {
		return;
	}
	if (ql <= l && r <= qr) {
		pushsum(v, l, r, x);
		return;
	}
	int m = (l + r) / 2;
	push(v, l, r);
	addition(2 * v, l, m, ql, qr, x);
	addition(2 * v + 1, m, r, ql, qr, x);
	merge(v);
}

void setting(int v, int l, int r, int ql, int qr) {
	if (qr <= l || ql >= r) {
		return;
	}
	if (ql <= l && r <= qr) {
		pusheq(v, l, r);
		return;
	}
	int m = (l + r) / 2;
	push(v, l, r);
	setting(2 * v, l, m, ql, qr);
	setting(2 * v + 1, m, r, ql, qr);
	merge(v);
}

void solve() {
	int h, w;
	cin >> h >> w;
	vector<vector<int>> input(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			char c;
			cin >> c;
			input[h - i - 1][j] = (c - '0');
		}
	}
	vector<vector<int>> arr;
	if (w > h) {
		swap(h, w);
		arr.resize(h, vector<int>(w, 0));
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				arr[i][j] = input[j][i];
			}
		}
	}
	else {
		arr = input;
	}
	vector<vector<int>> sum(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		for (int j = w - 1; j > -1; j--) {
			if (arr[i][j] == 0) {
				sum[i][j] = 0;
			}
			else {
				if (j == w - 1) {
					sum[i][j] = 1;
					continue;
				}
				sum[i][j] = sum[i][j + 1] + 1;
			}
		}
	}
	int n = (1 << 15);
	int ans = 0;
	for (int j = 0; j < w; j++) {
		vector<int> cur;
		for (int i = h - 1; i > -1; i--) {
			cur.push_back(sum[i][j]);
		}
		setting(1, 0, n, 0, n);
		for (int ind = 1; ind <= h; ind++) {
			addition(1, 0, n, 1, cur[ind - 1] + 1, 1);
			setting(1, 0, n, cur[ind - 1] + 1, n);
			ans = max(ans, tree[1].sum);
		}
	}
	cout << ans;
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	int i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
	return 0;
}