#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

int res(int a, int b) {
	return (a - b) * (a - b);
}

int indl = 0;
int indr = 0;

void move_left(int pos, vector<int>& arr) {
	if (arr[indl] > pos) {
		while (indl > -1 and arr[indl] > pos) {
			indl -= 1;
		}
		indl += 1;
	}
	else {
		while (indl < (int)arr.size() and arr[indl] <= pos) {
			indl += 1;
		}
	}
}

void move_right(int pos, vector<int>& arr) {
	if (arr[indr] > pos) {
		while (indr > -1 and arr[indr] > pos) {
			indr -= 1;
		}
		indr += 1;
	}
	else {
		while (indr < (int)arr.size() and arr[indr] <= pos) {
			indr += 1;
		}
	}
}

int check(int m, int t, vector<int>& prefs, vector<int>& prefsquare, vector<int>& prefmins, vector<int>& arr, int d, int flag) {
	int pos = m * d;
	int ans = t * m;
	int n = arr.size();
	int ind = 0;
	if (flag) {
		move_right(pos, arr);
		ind = indr;
	}
	else {
		move_left(pos, arr);
		ind = indl;
	}
	ans += prefmins[ind];
	ans += (n - ind) * pos * pos;
	ans += prefsquare[n] - prefsquare[ind];
	ans -= 2 * pos * (prefs[n] - prefs[ind]);
	return ans;
}

int trinary_search(int l, int r, int t, vector<int>& prefs, vector<int>& prefsquare, vector<int>& prefmins, vector<int>& arr, int d) {
	while (r - l > 2) {
		int m1 = (2 * l + r) / 3;
		int m2 = (2 * r + l) / 3;
		int ans1 = check(m1, t, prefs, prefsquare, prefmins, arr, d, 0);
		int ans2 = check(m2, t, prefs, prefsquare, prefmins, arr, d, 1);
		if (ans1 > ans2) {
			l = m1;
		}
		else {
			r = m2;
		}
	}
	int m = (l + r) / 2;
	int ansl = check(l, t, prefs, prefsquare, prefmins, arr, d, 0);
	int ansm = check(m, t, prefs, prefsquare, prefmins, arr, d, 0);
	int ansr = check(r, t, prefs, prefsquare, prefmins, arr, d, 1);
	return min({ ansl, ansm, ansr });
}

void solve() {
	int n;
	cin >> n;
	vector<int> arr(n, 0);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	sort(arr.begin(), arr.end());
	int x0, d;
	cin >> x0 >> d;
	vector<int> mini(n, 0);
	for (int i = 0; i < n; i++) {
		mini[i] = min(res(arr[i], (arr[i] / d) * d), res(arr[i], ((arr[i] + d - 1) / d) * d));
	}
	vector<int> prefmins = { 0 };
	for (int i = 0; i < n; i++) {
		prefmins.push_back(prefmins.back() + mini[i]);
	}
	vector<int> prefs = { 0 };
	for (int i = 0; i < n; i++) {
		prefs.push_back(prefs.back() + arr[i]);
	}
	vector<int> prefsquare = { 0 };
	for (int i = 0; i < n; i++) {
		prefsquare.push_back(prefsquare.back() + arr[i] * arr[i]);
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int t;
		cin >> t;
		indl = 0;
		indr = n - 1;
		int ans = trinary_search(0, (arr.back() + d - 1) / d, t, prefs, prefsquare, prefmins, arr, d);
		cout << ans << '\n';
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	int i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
	return 0;
}