#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1000000000;
const ll INF2 = 9e18;
const ll MOD = 1000000007;

ll res(ll a, ll b) {
	return (a - b) * (a - b);
}

ll bin_search(ll l, ll r, ll pos, vector<ll>& arr) {
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if (arr[m] <= pos) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return r;
}

ll check(ll m, ll t, vector<ll>& prefs, vector<ll>& prefsquare, vector<ll>& prefmins, vector<ll>& arr, ll d) {
	ll pos = m * d;
	ll ans = t * m;
	ll n = arr.size();
	ll ind = bin_search(-1, n, pos, arr);
	ans += prefmins[ind];
	ans += (n - ind) * pos * pos;
	ans += prefsquare[n] - prefsquare[ind];
	ans -= 2 * pos * (prefs[n] - prefs[ind]);
	return ans;
}

ll trinary_search(ll l, ll r, ll t, vector<ll>& prefs, vector<ll>& prefsquare, vector<ll>& prefmins, vector<ll>& arr, ll d) {
	while (r - l > 2) {
		ll m1 = (2 * l + r) / 3;
		ll m2 = (2 * r + l) / 3;
		ll ans1 = check(m1, t, prefs, prefsquare, prefmins, arr, d);
		ll ans2 = check(m2, t, prefs, prefsquare, prefmins, arr, d);
		if (ans1 > ans2) {
			l = m1;
		}
		else {
			r = m2;
		}
	}
	ll m = (l + r) / 2;
	ll ansl = check(l, t, prefs, prefsquare, prefmins, arr, d);
	ll ansm = check(m, t, prefs, prefsquare, prefmins, arr, d);
	ll ansr = check(r, t, prefs, prefsquare, prefmins, arr, d);
	return min({ ansl, ansm, ansr });
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> arr(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	sort(arr.begin(), arr.end());
	ll x0, d;
	cin >> x0 >> d;
	vector<ll> mini(n, 0);
	for (ll i = 0; i < n; i++) {
		mini[i] = min(res(arr[i], (arr[i] / d) * d), res(arr[i], ((arr[i] + d - 1) / d) * d));
	}
	vector<ll> prefmins = { 0 };
	for (ll i = 0; i < n; i++) {
		prefmins.push_back(prefmins.back() + mini[i]);
	}
	ll m;
	cin >> m;
	for (ll i = 0; i < m; i++) {
		ll t;
		cin >> t;
		cout << prefmins[n] << '\n';
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	ll i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
	return 0;
}