#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;
using ll = long long;
#define all(x) x.begin(),x.end()
const int INF = 1e9 + 7;
vector<int> tr;
struct req
{
	int l, m, r;
	req(int l, int m, int r) :l(l), m(m), r(r) {}
};

bool cmp(const req& a, const req& b) {
	return a.r < b.r;
}
int n, k;
void build() {
	tr.assign(n * 2,INF);
	tr[n] = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		tr[i] = min(tr[i << 1], tr[(i << 1) | 1]);
	}
}
int get(int l, int r) {
	int res = INF;
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			res = min(tr[l++], res);
		}
		if (r & 1) {
			res = min(res, tr[--r]);
		}
	}
	return res;
}
void upd(int pos, int val) {
	pos += n;
	tr[pos] = min(tr[pos], val);
	pos >>= 1;
	for (; pos > 0; pos >>= 1) {
		tr[pos] = min(tr[pos << 1], tr[pos << 1 | 1]);
	}
}


void solve() {
	cin >> n >> k;
	++n;
	build();
	vector<req> a;
	for (int i = 0; i < k; i++)
	{
		int l, m, r;
		cin >> l >> m >> r;
		a.push_back(req(l, m, r));
	}
	sort(all(a), cmp);
	for (auto& i : a) {
		int val = get(i.l - 1, i.m);
		if (val < INF) {
			upd(i.r, i.m);
		}
		else {
			val = get(i.m, i.r);
			if (val < i.l)upd(i.r, i.m);
		}
	}
	if (tr[n * 2 - 1] < INF) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	int tt;
	cin >> tt;
	while (tt--)
	{
		solve();
		cout << '\n';
	}
}