def transpose(a):
    new_a = []
    for j in range(len(a[0])):
        to_add = []
        for i in range(len(a)):
            to_add.append(a[i][j])
        new_a.append(to_add)
    return new_a

def split_arr(a, splitter):
    chunks = []
    
    buffer = []
    for i in range(len(a)):
        if a[i] == splitter:
            if buffer != []:
                chunks.append(buffer)
                buffer = []
        else:
            buffer.append(a[i])
    
    if buffer != []:
        chunks.append(buffer)

    return chunks

def main():
    h, w = map(int, input().split())
    table = [list(map(int, list(input().strip()))) for _ in range(h)]
    
    # 1. PREFIX TABLE
    prefix = []
    for row in table:
        brow = list(reversed(row))
        to_add = [brow[0]] * w

        for i in range(1, w):
            if brow[i] == 0:
                to_add[i] = 0
            else:
                to_add[i] = to_add[i-1] + 1

        prefix.append(list(reversed(to_add)))
    
    # 2. ROTATE 90
    prefix = transpose(prefix)
    
    # 3. SOLUTION
    final_ans = 0
    for arr in prefix:
        chunks = split_arr(arr, 0)

        for chunk in chunks:
            if chunk == []:
                continue
            if len(chunk) == 1:
                final_ans = max(final_ans, chunk[0])
                continue

            #current = chunk[0]
            final_ans = max(final_ans, chunk[0])

            i = 1
            while i < len(chunk):
                #print(i, chunk, sum(chunk[:i]))
                final_ans = max(sum(chunk[:i]), final_ans)
                if chunk[i] < chunk[i-1]:
                    #current = current - chunk[i-1] + chunk[i]
                    chunk[i-1] = chunk[i]
                    if i > 1:
                        i -= 1
                else:
                    #current += chunk[i]
                    i += 1
                
                #print(i, chunk, sum(chunk[:i]))
                final_ans = max(sum(chunk[:i]), final_ans)
        
    print(final_ans)

main()
