import sys
input = sys.stdin.readline

def transpose(a):
    new_a = []
    for j in range(len(a[0])):
        to_add = []
        for i in range(len(a)):
            to_add.append(a[i][j])
        new_a.append(to_add)
    return new_a

def main():
    h, w = map(int, input().split())
    table = [list(map(int, list(input().strip()))) for _ in range(h)]
    
    # 1. PREFIX TABLE
    prefix = []
    for row in table:
        brow = list(reversed(row))
        to_add = [brow[0]] * w

        for i in range(1, w):
            if brow[i] == 0:
                to_add[i] = 0
            else:
                to_add[i] = to_add[i-1] + 1

        prefix.append(list(reversed(to_add)))
    
    # 2. ROTATE 90
    prefix = transpose(prefix)
    
    # 3. SOLUTION
    final_ans = -float("inf")
    for arr in prefix:
        # split(0)
        chunks = [list(map(int, chunk)) for chunk in map(list, "".join(map(str, arr)).split("0"))]
        #print(chunks)
        # for each
        for chunk in chunks:
            if chunk == []:
                continue
            if len(chunk) == 1:
                final_ans = max(final_ans, chunk[0])

            current = chunk[0]

            i = 1
            while i < len(chunk):
                if chunk[i] < chunk[i-1]:
                    current = current - chunk[i-1]
                    chunk[i-1] = chunk[i]
                    i -= 1
                else:
                    current += chunk[i]
                    i += 1
                
                final_ans = max(current, final_ans)
        
    print(final_ans)

main()
