#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <random>
#include <array>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
const ll INF = 1e18, MOD = 1e9 + 7;
const ld EPS = 1e-9;
struct Seg {
	vector<ll> t;
	ll sz;
	Seg(ll n) {
		sz = 1;
		while (sz < n) sz *= 2;
		t.resize(sz * 2, 0);
	}
	void upd(ll x, ll d) {
		t[sz + x] += d;
		for (ll v = (sz + x) / 2; v > 0; v /= 2) {
			t[v] = t[v * 2] + t[v * 2 + 1];
		}
	}
	ll get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
		if (r == -1) r = sz;
		if (lx <= l && r <= rx) return t[v];
		if (l >= rx || lx >= r) return 0;
		ll m = (l + r) / 2;
		return get(lx, rx, v * 2, l, m) + get(lx, rx, v * 2 + 1, m, r);
	}
};
void solve() {
	ll n, k;
	cin >> n >> k;
	vector<array<ll, 3>> v(k);
	for (ll i = 0; i < k; i++) cin >> v[i][0] >> v[i][1] >> v[i][2];
	vector<array<ll, 3>> can = { {0, 0, 0} };
	sort(all(v), [](array<ll, 3> a, array<ll, 3> b) {
		return a[0] < b[0];
		});
	Seg full = Seg(n + 1), small = Seg(n + 1);
	set<array<ll, 3>> big = { can[0] };
	full.upd(can[0][2], 1);
	bool ura = 0;
	for (array<ll, 3> p : v) {
		while (big.size() > 0 && (*big.begin())[0] < p[0]) {
			small.upd((*big.begin())[2], 1);
			big.erase(big.begin());
		}
		bool is = full.get(p[0] - 1, p[1]) || small.get(p[0] - 1, p[2]);
		/*for (array<ll, 3> q : can) {
			is |= (p[0] - 1 <= q[2] && q[2] < p[1]);
			is |= (p[0] - 1 <= q[2] && q[2] < p[2] && q[1] < p[0]);
		}*/
		if (is) {
			full.upd(p[2], 1);
			big.insert({ p[1], p[0], p[2] });
			if (p[2] == n) ura = 1;
		}
	}
	if (ura) cout << "YES\n";
	else cout << "NO\n";
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}