#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <random>
#include <array>
#include <iomanip>
#pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#ifdef _DEBUG
#define int128 ll
#else
#define int128 __int128
#endif
const ll INF = 1e18, MOD = 1e9 + 7;
const ld EPS = 1e-9;
ll n, x0, d, m[2];
vector<int128> a[2], opt[2], propt[2], pra[2], pra2[2];
ll u[2];
int128 smu[2], smu2[2];
int128 get(int128 x, ll k) {
	while (u[k] < m[k] && opt[k][u[k]] <= x) {
		smu[k] -= a[k][u[k]];
		smu2[k] -= a[k][u[k]] * a[k][u[k]];
		u[k]++;
	}
	return propt[k][u[k]] + x * x * d * d * (m[k] - u[k]) -
		2 * x * d * smu[k] + smu2[k];
}
struct Bp {
	ll k;
	int128 t;
	ll l, r, gde;
	Bp() {}
	Bp(ll k_, int128 t_, ll whose) {
		k = k_;
		t = t_;
		l = -1;
		gde = whose;
		if (m[k] > 0) r = opt[k].back() + 1;
		else r = 0;
	}
};
int128 bp(ll k, int128 t) {
	if (opt[k].size() == 0) return 0;
	ll l = -1, r = opt[k].back() + 1;
	while (l + 1 < r) {
		ll mid = (l + r) / 2;
		int128 resmid = get(mid, k) + mid * t;
		int128 resmidp = get(mid + 1, k) + (mid + 1) * t;
		if (resmid >= resmidp) l = mid;
		else r = mid;
	}
	return get(r, k) + r * t;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	vector<ll> x(n);
	for (ll i = 0; i < n; i++) {
		cin >> x[i];
	}
	cin >> x0 >> d;
	for (ll i = 0; i < n; i++) {
		if (x[i] >= x0) a[0].push_back(x[i] - x0);
		else a[1].push_back(x0 - x[i]);
	}
	for (ll k = 0; k < 2; k++) {
		m[k] = a[k].size();
		sort(all(a[k]));
		propt[k].resize(m[k] + 1, 0);
		pra[k].resize(m[k] + 1, 0);
		pra2[k].resize(m[k] + 1, 0);
		for (ll i = 0; i < m[k]; i++) {
			ll x = a[k][i];
			pra[k][i + 1] = pra[k][i] + x;
			pra2[k][i + 1] = pra2[k][i] + x * x;
			ll y0 = x / d * d, y1 = y0 + d;
			if (x - y0 <= y1 - x) {
				opt[k].push_back(y0 / d);
				propt[k][i + 1] = propt[k][i] + (y0 - x) * (y0 - x);
			}
			else {
				opt[k].push_back(y1 / d);
				propt[k][i + 1] = propt[k][i] + (y1 - x) * (y1 - x);
			}
		}
	}
	ll m;
	cin >> m;
	vector<ll> ts(m), ans0(m), ans1(m);
	vector<Bp> b;
	for (ll i = 0; i < m; i++) {
		cin >> ts[i];
		b.push_back(Bp(0, ts[i], i));
		b.push_back(Bp(1, ts[i] * 2, i));
		b.push_back(Bp(1, ts[i], i + m));
		b.push_back(Bp(0, ts[i] * 2, i + m));
	}
	stable_sort(all(b), [](Bp a, Bp b) {
		return a.t > b.t;
		});
	vector<int128> resmid(4 * m), resmidp(4 * m);
	vector<int128> ans(2 * m, 0);
	bool ok = 1;
	while (ok) {
		ok = 0;
		for (ll k = 0; k < 2; k++) {
			u[k] = 0;
			smu[k] = pra[k].back();
			smu2[k] = pra2[k].back();
		}
		for (ll i = 0; i < b.size(); i++) {
			Bp& p = b[i];
			if (p.l + 1 < p.r) {
				ok = 1;
				ll mid = (p.l + p.r) / 2;
				resmid[i] = get(mid, p.k) + p.t * mid;
			}
		}
		for (ll k = 0; k < 2; k++) {
			u[k] = 0;
			smu[k] = pra[k].back();
			smu2[k] = pra2[k].back();
		}
		for (ll i = 0; i < b.size(); i++) {
			Bp& p = b[i];
			if (p.l + 1 < p.r) {
				ok = 1;
				ll mid = (p.l + p.r) / 2;
				resmidp[i] = get(mid + 1, p.k) + p.t * (mid + 1);
				if (resmid[i] >= resmidp[i]) p.l = mid;
				else p.r = mid;
			}
		}
	}
	for (ll i = 0; i < b.size(); i++) {
		ans[b[i].gde] += get(b[i].r, b[i].k) + b[i].t * b[i].r;
	}
	for (ll i = 0; i < m; i++) {
		cout << (ll)min(ans[i], ans[i + m]) << "\n";
	}
	return 0;
}