#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <random>
#include <array>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#ifdef _DEBUG
#define int128 ll
#else
#define int128 __int128
#endif
const ll INF = 1e18, MOD = 1e9 + 7, N = 3e5 + 20;
const ld EPS = 1e-9;
ll n, d, c[N];
vector<ll> g[N];
void coloring(ll v, ll p) {
	for (ll u : g[v]) {
		if (u != p) {
			c[u] = 1 - c[v];
			coloring(u, v);
		}
	}
}
struct Flow {
	ll n, s, t;
	vector<ll> f;
	vector<ll> us; ll usnow;
	vector<vector<array<ll, 2>>> g;
	void addedge(ll u, ll v) {
		ll i = f.size();
		g[u].push_back({ v, i });
		f.push_back(0);
		i = f.size();
		g[v].push_back({ u, i });
		f.push_back(0);
	}
	Flow(vector<vector<ll>>& g_, ll s_, ll t_) {
		n = g_.size();
		us.resize(n, 0);
		g.resize(n);
		usnow = 0;
		s = s_, t = t_;
		for (ll v = 0; v < n; v++) {
			for (ll u : g_[v]) {
				addedge(v, u);
			}
		}
	}
	bool dfs(ll v) {
		us[v] = usnow;
		if (v == t) return 1;
		for (auto p : g[v]) {
			ll u = p[0], i = p[1];
			if (f[i] < ((i & 1) ^ 1) && us[u] < usnow) {
				if (dfs(u)) {
					f[i]++;
					f[i ^ 1]--;
					return 1;
				}
			}
		}
		return 0;
	}
	ll make() {
		ll ans = 0;
		usnow = 1;
		while (dfs(s)) {
			ans++;
			usnow++;
		}
		return ans;
	}
};
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> d;
	for (ll i = 0; i < n - 1; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	c[0] = 0;
	coloring(0, 0);
	ll cnt = 0;
	vector<ll> nn, pp;
	for (ll v = 0; v < n; v++) {
		cnt += (c[v] == 0);
		if (c[v] == 0) nn.push_back(v + 1);
		if (c[v] == 1) pp.push_back(v + 1);
	}
	ll m = (d + 1) / 2; // [0, m)
	vector<vector<ll>> gf(n * m + 2);
	ll s = gf.size() - 2, t = gf.size() - 1;
	for (ll v = 0; v < n; v++) {
		if (c[v] == 0) {
			gf[s].push_back(v * m + m - 1);
			for (ll x = 0; x < m; x++) {
				for (ll u : g[v]) {
					gf[v * m + x].push_back(u * m + x);
				}
			}
		}
		else {
			gf[v * m].push_back(t);
			for (ll x = 1; x < m; x++) {
				gf[v * m + x].push_back(v * m + x - 1);
				for (ll u : g[v]) {
					gf[v * m + x].push_back(u * m + x - 1);
				}
			}
		}
	}
	Flow f = Flow(gf, s, t);
	cout << f.make() << "\n-1\n";
	return 0;
}