#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void solve() {
    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (auto &e : a) {
        cin >> e;
        for (auto &c : e) {
            c -= '0';
        }
    }

    vector<vector<int>> nearest(h, vector<int>(w, w));
    for (int i = 0; i < h; ++i) {
        for (int j = w - 1; j >= 0; --j) {
            if (a[i][j] == 0) {
                nearest[i][j] = j;
            } else if (j != w - 1) {
                nearest[i][j] = nearest[i][j + 1];
            }
        }
    }

    int ans = 0, cur_ans = 0;
    for (int j = 0; j < w; ++j) {
        map<int, int> m;
        for (int i = 0; i < h; ++i) {
            if (a[i][j] == 0) {
                m.clear();
                cur_ans = 0;
                continue;
            }

            int cur = nearest[i][j] - j;
            cur_ans += cur;
            m[cur]++;
            auto it = prev(m.end());
            while (it->first > cur) {
                cur_ans -= it->second * (it->first - cur);
                m[cur] += prev(m.end())->second;
                m.erase(it);
                it = prev(m.end());
            }

            ans = max(ans, cur_ans);
        }
    }

    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}