#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

struct segment {
    int l, m, r;

    bool operator<(segment const &s) const {
        if (l != s.l) return l < s.l;
        return r < s.r;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<segment> segs(k);
    for (auto &e : segs) {
        cin >> e.l >> e.m >> e.r;
        e.l--;
        e.m--;
    }

    sort(all(segs));
    vector<vector<int>> dp(n, vector<int>(n + 1));
    for (int i = 0; i < k; ++i) {
        dp[segs[i].l][segs[i].r] = 1;
    }

    for (int step = 0; step < k; ++step) {
        for (int cur = 0; cur < k; ++cur) {
            for (int l1 = 0; l1 <= segs[cur].l; ++l1) {
                for (int r1 = max(l1 + 1, segs[cur].l); r1 <= n; ++r1) {
                    for (int l2 = r1; l2 <= segs[cur].r; ++l2) {
                        for (int r2 = l2 + 1; r2 <= n; ++r2) {
                            if (dp[l1][r1] and dp[l2][r2]) {
                                if (r1 <= segs[cur].m and segs[cur].m < l2) {
                                    dp[l1][r1] = 1;
                                }
                            }
                        }
                    }
                }
            }

            for (int l = 0; l < n; ++l) {
                for (int r = l + 1; r <= n; ++r) {
                    for (int m = l + 1; m < r; ++m) {
                        if (dp[l][m] and dp[m][r]) {
                            dp[l][r] = 1;
                            break;
                        }
                    }

                    if (not dp[l][r]) continue;

                    if (l <= segs[cur].m and segs[cur].m < r) continue;
                    if (r < segs[cur].l or segs[cur].r < l) continue;
                    dp[min(l, segs[cur].l)][max(r, segs[cur].r)] = 1;
                }
            }
        }
    }

    if (dp[0][n]) cout << "YES\n";
    else cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    solve();
}