#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <cmath>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

mt19937_64 rnd(42);

struct segment {
    int l, m, r;

    bool operator<(segment const &s) const {
        if (l != s.l) return l < s.l;
        return r < s.r;
    }
};

int n, k;
vector<segment> segs;

int cnt() {
    vector<bool> able(n);
    for (auto const &seg : segs) {
        if (able[seg.m]) continue;
        for (int j = seg.l; j < seg.r; ++j) {
            able[j] = true;
        }
    }
    return count(all(able), false);
}

void solve() {
    cin >> n >> k;
    segs.resize(k);
    for (auto &e : segs) {
        cin >> e.l >> e.m >> e.r;
        e.l--;
        e.m--;
    }

    shuffle(all(segs), rnd);

    int cur = cnt();
    double T = 100, d = 0.999;
    auto gen = uniform_int_distribution(0, k - 1);
    for (; T > 1e-2 and cur; T *= d) {
        int i = gen(rnd);
        int j = gen(rnd);
        swap(segs[i], segs[j]);
        int z = cnt();
        if (z < cur) {
            cur = z;
        } else if (rand() < exp(-(z - cur) / T) * RAND_MAX) {
            cur = z;
        } else {
            swap(segs[i], segs[j]);
        }
    }

    if (cnt()) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    solve();
}