// #pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <cmath>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

struct Segment {
    int l, m, r;

    bool operator<(Segment const &s) const {
        if (l != s.l) return l < s.l;
        if (r != s.r) return  r < s.r;
        return m < s.m;
    }
};

int n;
vector<vector<Segment>> a;
vector<int> t;

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res += t[r];
    }
    return res;
}

void add(int id, int d) {
    for (; id < n; id = id | (id + 1)) {
        t[id] += d;
    }
}

int get(int l, int r) {
    return get(r) - get(l);
}

void solve() {
    int k;
    cin >> n >> k;
    vector<Segment> segs(k);
    a.resize(n);
    t.assign(n, 0);
    for (auto &e : segs) {
        cin >> e.l >> e.m >> e.r;
        e.l--;
        e.m--;
        a[e.m].push_back(e);
        add(e.m, 1);
    }
    sort(all(segs));

    int cur = 0;
    for (int i = 0; i < k; ++i) {
        if (segs[i].l > cur) {
            cout << "NO\n";
            return;
        }
        cur = max(cur, segs[i].r);
    }
    if (cur != n) {
        cout << "NO\n";
        return;
    }

    for (int _ = 0; _ < k; ++_) {
        bool f = false;
        for (int i = 0; i < k and !f; ++i) {
            int t = get(segs[i].l - 1, segs[i].r - 1);
            if (t == 1) {
                add(segs[i].m, -1);
                f = true;
            }
        }
        if (!f) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    solve();
}