#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

struct segment {
    int l, m, r;

    bool operator<(segment const &s) const {
        if (l != s.l) return l < s.l;
        if (r != s.r) return  r < s.r;
        return m < s.m;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<segment> segs(k);
    for (auto &e : segs) {
        cin >> e.l >> e.m >> e.r;
        e.l--;
        e.m--;
    }

    sort(all(segs));

    do {
        vector<bool> able(n);
        for (int i = 0; i < k; ++i) {
            if (able[segs[i].m]) continue;
            for (int j = segs[i].l; j < segs[i].r; ++j) {
                able[j] = true;
            }
        }

        if (count(all(able), true) == n) {
            cout << "YES\n";
            return;
        }
    } while (next_permutation(all(segs)));

    cout << "NO\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
        solve();
}