#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <cmath>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

ll t;
ll x0, d;
vector<ll> x;

__int128 second_right(ll cur) {
    ll L = 0, R = 1e9, Md1, Md2;
    __int128 res1, res2;
    while (R - L > 2) {
        Md1 = L + (R - L) / 3;
        Md2 = R - (R - L) / 3;

        res1 = t * abs(Md1) + __int128(cur + Md1 * d - x[1]) * (cur + Md1 * d - x[1]);
        res2 = t * abs(Md2) + __int128(cur + Md2 * d - x[1]) * (cur + Md2 * d - x[1]);

        if (res1 < res2) R = Md2;
        else L = Md1;
    }

    return min({
        t * abs(L) + __int128(cur + L * d - x[1]) * (cur + L * d - x[1]),
        t * abs(R) + __int128(cur + R * d - x[1]) * (cur + R * d - x[1]),
        t * abs((L + R) / 2) + __int128(cur + (L + R) / 2 * d - x[1]) * (cur + (L + R) / 2 * d - x[1]),
    });
}

__int128 first_left() {
    ll L = 0, R = 1e9, Md1, Md2;
    __int128 res1, res2;
    while (R - L > 2) {
        Md1 = L + (R - L) / 3;
        Md2 = R - (R - L) / 3;

        res1 = second_right(x0 - d * Md1);
        res2 = second_right(x0 - d * Md2);

        if (res1 < res2) R = Md2;
        else L = Md1;
    }

    return min({
        second_right(x0 - d * L),
        second_right(x0 - d * R),
        second_right(x0 - d * (L + R) / 2),
    });
}

void solve() {
    int n;
    cin >> n;
    x.resize(n);
    for (auto &e : x) cin >> e;
    ll x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    while (m--) {
        cin >> t;
        __int128 res = first_left();
        swap(x[0], x[1]);
        x[0] *= -1;
        x[1] *= -1;
        x0 *= -1;

        res = min(res, first_left());
        cout << (ll) res << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}