// #pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <cmath>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void solve() {
    int n;
    cin >> n;
    vector<ll> x(n);
    for (ll &e : x) cin >> e;
    sort(all(x));

    vector<__int128> suf(n + 1), suf2(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf2[i] = suf2[i + 1] + x[i] * x[i];
        suf[i] = suf[i + 1] + x[i];
    }

    int a;
    cin >> a >> a;
    int q;
    cin >> q;
    ll t;
    while (q--) {
        cin >> t;
        ll L = 0, R = x.back(), Md1, Md2;
        __int128 res1, res2;
        while (R - L > 2) {
            Md1 = L + (R - L) / 3;
            Md2 = R - (R - L) / 3;

            auto it = upper_bound(all(x), Md1);
            __int128 k = it - x.begin();
            res1 = Md1 * t + k * Md1 * Md1 + suf2[k] - 2 * Md1 * suf[k];

            it = upper_bound(all(x), Md2);
            k = it - x.begin();
            res2 = Md2 * t + k * Md2 * Md2 + suf2[k] - 2 * Md2 * suf[k];

            if (res1 < res2) R = Md2;
            else L = Md1;
        }

        auto it = upper_bound(all(x), L);
        __int128 k = it - x.begin();
        __int128 res = L * t + k * L * L + suf2[k] - 2 * L * suf[k];
        L = (L + R) / 2;

        it = upper_bound(all(x), L);
        k = it - x.begin();
        res = min(L * t + k * L * L + suf2[k] - 2 * L * suf[k], res);

        L = R;
        it = upper_bound(all(x), L);
        k = it - x.begin();
        res = min(L * t + k * L * L + suf2[k] - 2 * L * suf[k], res);

        cout << (ll) res << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}