#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <cmath>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

int n, d;
vector<vector<int>> g;
vector<int> z, v;

void dfs(int id, int pr, bool f) {
    if (f) z.push_back(id);
    else v.push_back(id);
    for (int const &e : g[id]) {
        if (e != pr) {
            dfs(e, id, not f);
        }
    }
}

void solve() {
    cin >> n >> d;
    g.resize(n);
    int a, b;
    for (int i = 1; i < n; ++i) {
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }

    dfs(0, -1, true);
    cout << min(z.size(), v.size()) << '\n';

    for (int i = 0; i < z.size() and i < v.size(); ++i) {
        cout << z[i] + 1 << ' ' << v[i] + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}