// #pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <cmath>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

int n, d, ans = 0;
vector<vector<int>> g;
vector<vector<int>> dp;

void dfs(int id, int pr) {
    bool f = false;
    for (int const &e : g[id]) {
        if (e != pr) {
            dfs(e, id);
            if (dp[e][d - 1]) {
                f = true;
            }
        }
    }
    dp[id][0] = not f;
    ans += f;
    for (int const &e : g[id]) {
        if (e == pr) continue;

        for (int i = d - 1; i >= 0; --i) {
            for (int j = d - 1; j >= i; --j) {
                if (i + j >= d or (i + j) % 2 == 1) continue;
                int v = min(dp[e][i], dp[id][j]);
                ans += v;
                dp[e][i] -= v;
                dp[id][j] -= v;
            }
        }
        for (int i = 0; i + 1 < d; ++i) {
            dp[id][i + 1] += dp[e][i];
        }
    }
}

void solve() {
    int a, b;
    cin >> n >> d;
    g.resize(n);
    dp.resize(n, vector<int>(d));

    for (int i = 1; i < n; ++i) {
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }

    dfs(0, -1);
    cout << ans << "\n-1";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}