#include <bits/stdc++.h>


using namespace std;
// #define int long long

struct Node {
  int l, r, val;  
};

struct ST {
    vector<Node> st;

    void build(int v, int l, int r) {
        st[v] = {l, r, (int)1e9};
        if (r - l <= 1) {
            return;
        }
        build(2 * v, l, (l + r) / 2);
        build(2 * v + 1, (l + r) / 2, r);
    }

    ST(int n) {
        st.resize(4 * n);
        build(1, 0, n);
    }

    int get(int v, int l, int r) {
        if (l >= st[v].r || st[v].l >= r) {
            return 1e9;
        }
        if (l <= st[v].l && st[v].r <= r) {
            return st[v].val;
        }
        return min(get(2 * v, l, r), get(2 * v + 1, l, r));
    }

    void update(int v, int pos, int x) {
        if (st[v].r - st[v].l <= 1) {
            st[v].val = min(st[v].val, x);
            return;
        }
        if (pos < (st[v].l + st[v].r) / 2) {
            update(2 * v, pos, x);
        } else {
            update(2 * v + 1, pos, x);
        }
        st[v].val = min(st[2 * v].val, st[2 * v + 1].val);
    }
};

struct seg
{
    int l, m, r;
    bool operator<(seg a) {
        return tie(r, m, l) < tie(a.r, a.m, a.l);
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, k, l1, m1, r1;
        cin >> n >> k;
        vector<seg> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> l1 >> m1 >> r1;
            a[i] = {l1 - 1, m1 - 1, r1 - 1};
        }
        sort(a.begin(), a.end());
        ST t = ST(n);
        for (auto [l, m, r] : a) {
            t.update(1, r, max(t.get(1, max(l - 1, (int)0), m), m));
            int x = t.get(1, m, r + 1);
            if (x < l) {
                t.update(1, r, max(x, m));
            }
            if (l == 0) {
                t.update(1, r, m);
            }
        }
        if (t.get(1, n - 1, n) != (int)1e9) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
    
}