#include<bits/stdc++.h>

using namespace std;

const int MAX = 3e5;
vector<int> g[MAX];
int h[MAX];

void dfs(int v, int p) {
    h[v] = h[p] + 1;
    for (int to : g[v]) {
        if (to == p) continue;
        dfs(to, v);
    }
}

int used[MAX];
int pr[MAX];
vector<int> g2[MAX];
int timer = 0;

bool try_kuhn(int v) {
    if (used[v] == timer) return 0;
    used[v] = timer;
    for (int to : g[v]) {
        if (pr[to] == -1) {
            pr[to] = v;
            return 1;
        }
    }
    for (int to : g[v]) {
        if (try_kuhn(pr[to])) {
            pr[to] = v;
            return 1;
        }
    }
    return 0;
}

int dist(int v, int u, int n) {
    vector<int> d(n, 0);
    queue<int> q;
    vector<int> used2(n, 0);
    q.push(v);
    used2[v] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to : g[v]) {
            if (!used2[to]) {
                q.push(to);
                used2[to] = 1;
                d[to] = d[v] + 1;
            }
        }
    }
    return d[u];
}
signed main() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    h[0] = -1;
    dfs(0, 0);
    vector<int> cnt1, cnt2;
    for (int i = 0; i < n; ++i) {
        if (h[i] % 2) {
            cnt1.push_back(i);
        } else {
            cnt2.push_back(i);
        }
    }
    /*int ans = min((int)cnt1.size(), (int)cnt2.size());
    cout << ans << endl;
    for (int i = 0; i < ans; ++i) {
        cout << cnt1[i] + 1 << " " << cnt2[i] + 1 << endl;
    }*/
    /*for (int i = 0; i < (int)cnt1.size(); ++i) {
        for (int j = 0; j < (int)cnt2.size(); ++j) {
            int yy = dist(cnt1[i], cnt2[j], n);
            if (yy <= d) {
                g2[cnt1[i]].push_back(cnt2[j]);
            }
        }
    }*/
    fill(pr, pr + n, -1);
    int ans = 0;
    for (int x : cnt1) {
        timer++;
        ans += try_kuhn(x);
    }
    cout << ans << endl;
    for (int i = 0; i < n; ++i) {
        if (pr[i] != -1) {
            cout << i + 1 << " " << pr[i] + 1 << endl;
        }
    }
}
