#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

struct segment_tree {
    vector<int> st;
    size_t sz;
    segment_tree(int n) {
        sz = 1;
        while (sz < n) sz <<= 1;
        st.resize(2 * sz, 0);
    }
    void add(int i, int v) {
        i += sz;
        while (i) {
            st[i] += v;
            i >>= 1;
        }
    }
    int get(int l, int r) {
        l += sz; r += sz;
        int res = 0;
        while (l <= r) {
            if (l & 1) res += st[l++];
            if (~r & 1) res += st[r--];
            l >>= 1;
            r >>= 1;
        }
        return res;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), r(k), m(k);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<int> dp(n + 1);
    segment_tree st(n + 1);
    dp[n] = 1;
    st.add(n, 1);
    vector<vector<int>> ev(n + 1);
    for (int i = 0; i < k; i++) {
        ev[m[i]].push_back(i + 1);
        ev[l[i] - 1].push_back(-i - 1);
    }
    for (int i = 0; i <= n; i++) {
        sort(ev[i].begin(), ev[i].end());
    }
    int cnt = 0;
    for (int i = n; i > 0; i--) {
        for (int idx : ev[i]) {
            if (idx < 0) {
                idx *= -1;
                idx--;
                cnt -= st.get(m[idx], r[idx]);
            } else {
                idx--;
                cnt += st.get(m[idx], r[idx]);
            }
        }
        if (cnt) {
            dp[i - 1] = 1;
            st.add(i - 1, 1);
        }
    }
    if (dp[0]) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}