#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

struct segment_tree {
    vector<int> st;
    size_t sz;
    segment_tree(int n) {
        sz = 1;
        while (sz < n) sz <<= 1;
        st.resize(2 * sz, 0);
    }
    void add(int i, int v) {
        i += sz;
        while (i) {
            st[i] += v;
            i >>= 1;
        }
    }
    int get(int l, int r) {
        l += sz; r += sz;
        int res = 0;
        while (l <= r) {
            if (l & 1) res += st[l++];
            if (~r & 1) res += st[r--];
            l >>= 1;
            r >>= 1;
        }
        return res;
    }
};

struct segment_tree2 {
    vector<int> st;
    size_t sz;
    segment_tree2(int n) {
        sz = 1;
        while (sz < n) sz <<= 1;
        st.resize(2 * sz, 0);
    }
    int get(int i) {
        int res = 0;
        i += sz;
        while (i) {
            res += st[i];
            i >>= 1;
        }
        return res;
    }
    void add(int l, int r, int v) {
        l += sz; r += sz;
        while (l <= r) {
            if (l & 1) st[l++] += v;
            if (~r & 1) st[r--] += v;
            l >>= 1;
            r >>= 1;
        }
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(k), r(k), m(k);
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> m[i] >> r[i];
    }
    vector<int> dp(k + 1);
    segment_tree st(k + 1);
    segment_tree2 dp2(n + 1);
    dp2.add(n, n, 1);
    // dp[n] = 1;
    // st.add(n, 1);
    // vector<vector<int>> ev(n + 1);
    // for (int i = 0; i < k; i++) {
    //     ev[m[i]].push_back(i + 1);
    //     ev[l[i] - 1].push_back(-i - 1);
    // }
    // for (int i = 0; i <= n; i++) {
    //     sort(ev[i].begin(), ev[i].end());
    // }
    // int cnt = 0;
    // for (int i = n; i > 0; i--) {
    //     for (int idx : ev[i]) {
    //         if (idx < 0) {
    //             idx *= -1;
    //             idx--;
    //             cnt -= st.get(m[idx], r[idx]);
    //         } else {
    //             idx--;
    //             cnt += st.get(m[idx], r[idx]);
    //         }
    //     }
    //     if (cnt) {
    //         dp[i - 1] = 1;
    //         st.add(i - 1, 1);
    //     }
    // }
    l.push_back(n + 1);
    m.push_back(n + 1);
    r.push_back(n + 1);
    vector<int> ord(k + 1);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int a, int b) -> bool {
        return l[a] < l[b];
    });
    dp[k] = 1;
    st.add(k, 1);
    for (int idx = k - 1; idx >= 0; idx--) {
        int i = ord[idx];
        int lft;
        {
            int l1 = 0, r1 = k;
            while (l1 != r1) {
                int m1 = (r1 + l1) / 2;
                if (l[ord[m1]] > m[i]) {
                    r1 = m1;
                } else {
                    l1 = m1 + 1;
                }
            }
            lft = l1;
        }
        int rgt;
        {
            int l1 = 0, r1 = k;
            while (l1 != r1) {
                int m1 = (r1 + l1 + 1) / 2;
                if (l[ord[m1]] > r[i] + 1) {
                    r1 = m1 - 1;
                } else {
                    l1 = m1;
                }
            }
            rgt = l1;
        }
        dp[idx] = bool(st.get(lft, rgt) + dp2.get(r[i]));
        st.add(idx, dp[idx]);
        // dp2[l[i] - 1] = max(dp2[l[i] - 1], dp[idx]);
        if (dp[idx]) {
            dp2.add(l[i] - 1, m[i] - 1, 1);
        }
    }
    int ans = 0;
    for (int i = 0; i < k; i++) {
        if (dp[i] && l[ord[i]] == 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}