#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#ifndef LOCAL
  #pragma GCC target("avx2,fma")
#endif

using namespace std;

using ll = long long;

auto& setmax(auto& a, const auto& b) {
  return a = a > b ? a : b;
}

auto& setmin(auto& a, const auto& b) {
  return a = a < b ? a : b;
}

int isz(const auto& c) {
  return c.size();
}

const int inf = 1e9;

struct segtree {
  int n;
  pmr::vector<int> t;

  segtree(int _n) : n(_n), t(__bit_ceil(_n) * 2 - 1, inf) {}

  void set(int i, int v) {
    set(i, v, 0, 0, n);
  }

  void set(int i, int v, int x, int lx, int rx) {
    if (rx - lx == 1) {
      t[x] = v;
      return;
    }
    int m = (lx + rx) / 2;
    if (i < m) set(i, v, 2 * x + 1, lx, m);
    else set(i, v, 2 * x + 2, m, rx);
    t[x] = min(t[2 * x + 1], t[2 * x + 2]);
  }

  int get_first_smaller(int lq, int rq, int v) {
    return get_first_smaller(lq, rq, v, 0, 0, n).second;
  }

  pair<int, int> get_first_smaller(int lq, int rq, int v, int x, int lx, int rx) {
    if (rx <= lq || lx >= rq) return {inf, lq - 1};
    if (lq <= lx && rx <= rq && t[x] >= v) return {inf, lq - 1}; 
    if (rx - lx == 1) {
      return {t[x], lx};
    }
    int m = (lx + rx) / 2;
    auto right = get_first_smaller(lq, rq, v, 2 * x + 2, m, rx);
    if (right.first != inf) return right;
    return get_first_smaller(lq, rq, v, 2 * x + 1, lx, m);
  }
};

void solve() {
  int n, m;
  cin >> n >> m;
  pmr::vector a(n, pmr::vector<int>(m));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      char c;
      cin >> c;
      a[i][j] = c - '0';
    }
  }
  int ans = 0;
  pmr::vector val_cnt(n, pmr::vector<int>(m));
  pmr::vector dp(n, pmr::vector<int>(m));
  pmr::vector up(n, pmr::vector<int>(m));
  pmr::vector<segtree> sd(m, n);
  for (int j = m - 1; j >= 0; --j) {
    if (a[0][j]) {
      val_cnt[0][j] = (j == m - 1 ? 0 : val_cnt[0][j + 1]) + 1;
      dp[0][j] = val_cnt[0][j];
      setmax(ans, dp[0][j]);
      sd[j].set(0, val_cnt[0][j]);
      up[0][j] = 1;
    } else {
      sd[j].set(0, 0);
    }
  }
  for (int i = 1; i < n; ++i) {
    for (int j = m - 1; j >= 0; --j) {
      if (!a[i][j]) continue;
      val_cnt[i][j] = (j == m - 1 ? 0 : val_cnt[i][j + 1]) + 1;
      // int cur = val_cnt[i][j];
      // for (int i2 = i - 1; i2 >= 0; --i2) {
      //   setmin(cur, val_cnt[i2][j]);
      //   if (!cur) break;
      //   dp[i][j] += cur;
      // }
      int k = sd[j].get_first_smaller(i - up[i - 1][j], i, val_cnt[i][j]);
      dp[i][j] = val_cnt[i][j] * (i - k) + (k >= 0 ? dp[k][j] : 0);
      up[i][j] = i - k + (k >= 0 ? up[k][j] : 0);
      setmax(ans, dp[i][j]);
      sd[j].set(i, val_cnt[i][j]);
    }
  }
  cout << ans << '\n';
}

signed main() {
  pmr::monotonic_buffer_resource buf(8e8);
  pmr::set_default_resource(&buf);
  #ifdef LOCAL
    freopen("in.txt", "r", stdin);
  #endif
  cin.tie(0)->sync_with_stdio(0);
  solve();
}