#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#ifndef LOCAL
  #pragma GCC target("avx2,fma")
#endif
 
using namespace std;
 
using ll = long long;
 
auto& setmax(auto& a, const auto& b) {
  return a = a > b ? a : b;
}
 
auto& setmin(auto& a, const auto& b) {
  return a = a < b ? a : b;
}
 
int isz(const auto& c) {
  return c.size();
}
 
#define all(x) begin(x), end(x)
 
struct segtree {
  int n;
  vector<set<int>> t;

  segtree(int _n) : n(_n), t(_n * 4) {}

  void add(int lq, int rq, int v) {
    add(lq, rq, v, 0, 0, n);
  }

  void add(int lq, int rq, int v, int x, int lx, int rx) {
    if (rx <= lq || lx >= rq) return;
    if (lq <= lx && rx <= rq) {
      t[x].insert(v);
      return;
    }
    int m = (lx + rx) / 2;
    add(lq, rq, v, 2 * x + 1, lx, m);
    add(lq, rq, v, 2 * x + 2, m, rx);
  }

  bool check(int lq, int rq, int v) {
    return check(lq, rq, v, 0, 0, n);
  }

  bool check(int lq, int rq, int v, int x, int lx, int rx) {
    if (rx <= lq || lx >= rq) return false;
    if (lq <= lx && rx <= rq) {
      auto it = t[x].upper_bound(v);
      if (it != t[x].end()) return true;
      return false;
    }
    int m = (lx + rx) / 2;
    return check(lq, rq, v, 2 * x + 1, lx, m) || check(lq, rq, v, 2 * x + 2, m, rx);
  }
};

struct segtree2 {
  int n;
  vector<int> t;

  segtree2(int _n) : n(_n), t(_n * 4) {}

  void set(int i, int v) {
    set(i, v, 0, 0, n);
  }

  void set(int i, int v, int x, int lx, int rx) {
    if (rx - lx == 1) {
      t[x] = v;
      return;
    }
    int m = (lx + rx) / 2;
    if (i < m) set(i, v, 2 * x + 1, lx, m);
    else set(i, v, 2 * x + 1, m, rx);
    t[x] = t[2 * x + 1] || t[2 * x + 2];
  }

  bool get(int lq, int rq) {
    return get(lq, rq, 0, 0, n);
  }

  bool get(int lq, int rq, int x, int lx, int rx) {
    if (rx <= lq || lx >= rq) return 0;
    if (lq <= lx && rx <= rq) return t[x];
    int m = (lx + rx) / 2;
    return get(lq, rq, 2 * x + 1, lx, m) || get(lq, rq, 2 * x + 2, m, rx);
  }
};

struct man {
  int l, m, r;
};
 
void solve() {
  int n, k;
  cin >> n >> k;
  // vector<man> a(k);
  // for (auto& [l, m, r] : a) cin >> l >> m >> r;
  vector<vector<pair<int, int>>> b(n + 1);
  // for (auto [l, m, r] : a) {
    // b[l].push_back({m, r});
  // }
  for (int i = 0; i < k; ++i) {
    int l, m, r;
    cin >> l >> m >> r;
    b[l].emplace_back(m, r);
  }
  for (int i = 1; i <= n; ++i) {
    sort(all(b[i]));
  }
  segtree st(n + 10);
  segtree2 st2(n + 10);
  vector<char> dp(n + 2, 0);
  dp[n + 1] = 1;
  for (int i = n; i > 0; --i) {
    for (auto [m, r] : b[i]) {
      dp[i] |= st2.get(m + 1, r + 2);
      st2.set(i, dp[i]);
      dp[i] |= st.check(i + 1, r + 1, r);
      if (dp[i])
      st.add(i, r + 1, m);
    }
  }
  if (dp[1]) {
    cout << "YES\n";
    return;
  }
  cout << "NO\n";
}
 
signed main() {
  #ifdef LOCAL
    freopen("in.txt", "r", stdin);
  #endif
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  cin >> t;
  while (t --> 0) {
    solve();
  }
}