#pragma GCC optimize("O3")
#include <vector>
#pragma GCC target("avx", "avx2")
#include <iostream>
#include <climits>

using namespace std;

struct segTree{
    segTree(int l_, int r_) {
        l = l_;
        r = r_;
        mid = l + r >> 1;
        if (l == r) {
            //mx = 0;
            d = 0;
            return;
        }
        tl = new segTree(l, mid);
        tr = new segTree(mid + 1, r);
        d = 0;
        //mx = max(tl->mx, tr->mx);
    }
    void push() {
        if (l != r) {
            tl->d = max(d, tl->d);
            tr->d = max(d, tr->d);
        }
    }
    int get(int u) {
        if (u == l && u == r) {
            return d;
        }
        push();
        if (mid >= u) return tl->get(u);;
        return tr->get(u);
    }
    void upd(int l_, int r_, int x) {
        if (l_ <= l && r <= r_) {
            d = x;
            return;
        }
        if (r_ < l || r < l_) {
            return;
        }
        tl->upd(l_, r_, x);
        tr->upd(l_, r_, x);
        //mx = max(tl->mx, tr->mx);
        return;
    }
    // void clear() {
    //     c = 1;
    // }
    segTree *tl = nullptr, *tr = nullptr;
    int l, r, mid;
    int d = 0;
    //int mx = 0;
    // bool c;
};

struct fenvickTree{
    fenvickTree(int size) {
        sz = size + 1;
        t.resize(sz);
        for (int i = 1; i < size; ++i) {
            t[i] = 0;
        }
    }
    void upd(int u, int x) {
        while(u < sz) {
            t[u] += x;
            u += u & (-u);
        }
    }
    int get(int l, int r) {
        return uget(r) - uget(l - 1); 
    }
    int uget(int u) {
        int s = 0;
        while (u > 0) {
            s += t[u];
            u -= u & (-u);
        }
        return s;
    }
    void clear() {
        for (int i = 0; i < sz; ++i) {
            t[i] = 0;
        }
    }
    vector<int> t;
    int sz;
};

void print(segTree &tree) {
    for (int i = tree.l; i <= tree.r; ++i) {
        cout << tree.get(i) << ' ';
    }
    cout << '\n';
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<bool>> a(n + 1, vector<bool> (m + 1));
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; ++j) {
            a[i][j] = s[j - 1] - '0';
        }
    }
    vector<vector<int>> b(n + 1, vector<int> (m + 2, 0)), c(n + 1, vector<int> (m + 1, 0));
    for (int i = 1; i <= n; ++i) {
        for (int j = m; j > 0; --j) {
            if (a[i][j] == 0) continue;
            b[i][j] = b[i][j + 1] + 1;
        }
    }
    int ans = 0;
    segTree tree(1, m);
    for (int j = 1; j <= m; ++j) {
        //int mn = INT_MAX / 2;
        //cout << j << ": \n";
        // tree.clear();
        tree.upd(1, m, 0);
        int cnt = 0;
        for (int i = 1; i <= n; ++i) {
            if (a[i][j] == 0) {
                // tree.clear();
                tree.upd(1, m, 0);
                cnt = 0;
                continue;
            }
            ++cnt;
            int k = tree.get(b[i][j]);
            //cout << i << ' ' << j << ' ' << k << '\n';
            if (k == 0){
                c[i][j] = cnt * b[i][j];
            } else {
                c[i][j] = c[k][j] + (i - k) * b[i][j];
            }
            tree.upd(b[i][j], m, i);
            //print(tree);
            ans = max(ans, c[i][j]);
        }
    }
    // cout << '\n';
    // for (int i = 1; i <= n; ++i) {
    //     for (int j = 1; j <= m; ++j) {
    //         cout << c[i][j] << ' ';
    //     }
    //     cout << '\n';
    // }
    cout << ans << '\n';
}

int main() {
    cin.tie(0);
    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) solve();
}