#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

struct person {
    int l;
    int m;
    int r;

    person(int l_, int m_, int r_) {
        l = l_;
        m = m_;
        r = r_;
    }
};

vector<vector<int> > graph;
vector<int> colour;

int dfs(int v) {
    colour[v] = 1;
    int flag = 0;
    for (auto u: graph[v]) {
        if (colour[u] == 2)
            continue;

        if (colour[u] == 1)
            flag = 1;
        else
            flag = max(flag, dfs(u));
    }
    colour[v] = 2;
    return flag;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    for (int p = 0; p < t; ++p) {
        int n, k;
        cin >> n >> k;
        vector<person> v;

        vector<int> pref(n + 1);
        for (int i = 0; i < k; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            pref[l - 1]++;
            pref[r]--;
            v.push_back({l, m, r});
        }

        for (int i = 1; i < n; ++i)
            pref[i] += pref[i - 1];

        int flag = 0;
        for (int i = 0; i < n; ++i)
            if (pref[i] <= 0)
                flag = 1;

        if (flag) {
            cout << "NO" << endl;
            continue;
        }

        graph.clear();
        graph.resize(k);
        colour.clear();
        colour.assign(k, 0);

        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < k; ++j) {
                if (i == j)
                    continue;
                if (v[j].m >= v[i].l && v[j].m <= v[i].r)
                    graph[i].push_back(j);
            }
        }

        for (int i = 0; i < k; ++i) {
            if (!colour[i])
                flag = max(flag, dfs(i));
        }
        if (flag)
            cout << "NO" << endl;
        else
            cout << "YES" << endl;
    }
}
