// Created by rost on 27.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T>
T rnd(T l, T r) {
    return uniform_int_distribution<T>(l, r)(rng);
}

const int H = 20, MAX_N = 3e5;

int depth[MAX_N + 1];
vector<int> graph[MAX_N + 1];

int up[H][MAX_N];

void dfs(int v, int p) {
    depth[v] = depth[p] + 1;
    for (int i = 1; i < H; ++i) {
        if (up[i - 1][v] == 0)
            up[i][v] = 0;
        else
            up[i][v] = up[i - 1][up[i - 1][v]];
    }

    for (auto to: graph[v]) {
        if (to == p)
            continue;

        up[0][to] = v;
        dfs(to, v);
    }
}

int lca(int v, int u) {
    for (int i = H-1; i >= 0; --i) {
        if (up[i][v] != 0 && depth[up[i][v]] >= depth[u]) {
            v = up[i][v];
        }
    }

    for (int i = H-1; i >= 0; --i) {
        if (up[i][u] != 0 && depth[up[i][u]] >= depth[v]) {
            u = up[i][u];
        }
    }

    if (v == u)
        return v;

    for (int i = H-1; i >= 0; --i) {
        if (up[i][u] != up[i][v]) {
            u = up[i][u];
            v = up[i][v];
        }
    }
    return up[0][v];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#endif

    int n, d;
    cin >> n >> d;
    for (int i = 1; i < n; ++i) {
        int v, u;
        cin >> v >> u;

        graph[v].push_back(u);
        graph[u].push_back(v);
    }

    dfs(1, 0);

    int res = 0;
    int rMask = 0;

    vector<bool> dp((1 << n), 0);
    dp[0] = true;
    vector<int> prev((1 << n), 0);
    for (int mask = 0; mask < (1 << n); ++mask) {
        if (!dp[mask])
            continue;

        int c = 0;
        for (int i = 0; i < n; ++i) {
            if (mask & (1<<i))
                ++c;
        }
        if (c > res) {
            res = c;
            rMask = mask;
        }

        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if ((mask & (1 << i)) || (mask & (1 << j)) || dp[mask | (1 << j) | (1 << i)])
                    continue;

                int l = lca(i + 1, j + 1);
                if (depth[i + 1] + depth[j + 1] - 2 * depth[l] <= d && (depth[i + 1] + depth[j + 1] - 2 * depth[l]) % 2 == 1) {
                    dp[mask | (1 << j) | (1 << i)] = true;
                    prev[mask | (1 << j) | (1 << i)] = mask;
                }
            }
        }
    }

    cout << res / 2 << '\n';
    while (rMask) {
        int sMaks = rMask ^ prev[rMask];
        for (int i = 0; i < n; ++i) {
            if (sMaks & (1<<i)) {
                cout << i + 1 << ' ';
            }
        }
        cout << '\n';
        rMask = prev[rMask];
    }
}
