#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int INF = 1e9;

struct stb {
    struct Node {
        ll mx1 = 0, mx2 = -1, c1 = 0, c2 = 0, tag = INF;
        ll sum = 0;
        Node() {}
        Node(int x) {
            mx1 = x;
            c1 = 1;
            sum = x;
        }
    };

    vector <Node> t;

    void rel(int p, int l, int r) {
        int m = (l + r) / 2;
        t[p].sum = t[2 * p].sum + t[2 * p + 1].sum;
        t[p].c1 = 0; t[p].c2 = 0;
        map <ll, ll, greater<ll>> mp;
        mp[t[2 * p].mx1] += t[2 * p].c1;
        mp[t[2 * p].mx2] += t[2 * p].c2;
        mp[t[2 * p + 1].mx1] += t[2 * p + 1].c1;
        mp[t[2 * p + 1].mx2] += t[2 * p + 1].c2;
        t[p].mx1 = mp.begin()->first;
        t[p].c1 = mp.begin()->second;
        if (mp.size() < 2) {
            t[p].mx2 = -1;
            t[p].c2 = 0;
        } else {
            auto it = mp.begin();
            it++;
            t[p].mx2 = it->first;
            t[p].c2 = it->second;
        }
    }
    void push(int p) {
        if (t[p].tag == INF)
            return;
        if (t[2 * p].mx1 > t[p].tag) {
            t[2 * p].sum -= (t[2 * p].mx1 * t[2 * p].c1);
            t[2 * p].mx1 = t[p].tag;
            t[2 * p].sum += (t[2 * p].mx1 * t[2 * p].c1);
        }
        if (t[2 * p + 1].mx1 > t[p].tag) {
            t[2 * p + 1].sum -= (t[2 * p + 1].mx1 * t[2 * p + 1].c1);
            t[2 * p + 1].mx1 = t[p].tag;
            t[2 * p + 1].sum += (t[2 * p + 1].mx1 * t[2 * p + 1].c1);
        }
        t[2 * p + 1].tag = min(t[2 * p + 1].tag, t[p].tag);
        t[2 * p].tag = min(t[2 * p].tag, t[p].tag);
        t[p].tag = INF;
    }

    void upd(int p, int l, int r, int pos, int x) {
        if (r - l == 1) {
            t[p] = Node(x);
            return;
        }
        if (r - l > 1)
            push(p);
        int m = (l + r) / 2;
        if (pos < m)
            upd(2 * p, l, m, pos, x);
        else
            upd(2 * p + 1, m, r, pos, x);
        rel(p, l, r);
    }

    void setmin(int p, int l, int r, int lq, int rq, int tag) {
        if (rq <= l || r <= lq || t[p].mx1 <= tag)
            return;
        if (r - l > 1)
            push(p);
        if (lq <= l && rq >= r && t[p].mx1 > tag && t[p].mx2 < tag) {
            if (t[p].tag <= tag)
                throw "a";
            t[p].sum -= (t[p].mx1 * t[p].c1);
            t[p].mx1 = tag;
            t[p].sum += (t[p].mx1 * t[p].c1);
            return;
        }
        int m = (l + r) / 2;
        setmin(2 * p, l, m, lq, rq, tag);
        setmin(2 * p + 1, m, r, lq, rq, tag);
        rel(p, l, r);
    }

    void build(int p, int l, int r) {
        if (r - l == 1) {
            t[p] = Node(0);
            return;
        }
        int m = (l + r) / 2;
        build(2 * p, l, m);
        build(2 * p + 1, m, r);
        rel(p, l, r);
    }

    stb(int n) {
        t.resize(4 * n);
        build(1, 0, n);
    }
};

ll sqr(ll x) {
    return x * x;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n, vector <int> (m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            a[i][j] = s[j] - '0';
        }
    }
    vector <vector <ll>> r1(n, vector <ll> (m));
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == 1)
                cnt++;
            else
                cnt = 0;
            r1[i][j] = cnt;
        }
    }
    ll ans = 0;
    stb st(n);
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            st.setmin(1, 0, n, 0, i, r1[i][j]);
            st.upd(1, 0, n, i, r1[i][j]);
            ans = max(ans, st.t[1].sum);
        }
        st.build(1, 0, n);
    }
    cout << ans;
}