using ll = long long;
using namespace std;
#include <vector>
#include <iostream>
#include <algorithm>
#include <set>
vector <ll> tree;
ll n;
ll getM(ll qleft, ll qright, ll v = 1, ll left = 0, ll right = n) {
    if (qleft <= left && right <= qright) {
        return tree[v];
    } else if (right <= qleft || qright <= left) {
        return 0;
    } else {
        ll mid = (left + right) / 2;
        return max(getM(qleft, qright, 2 * v, left, mid), getM(qleft, qright, 2 * v + 1, mid, right));
    }
}
void upd(ll ind, ll x, ll v = 1, ll left = 0, ll right = n) {
    if (left + 1 == right) {
        tree[v] = x;
    } else {
        ll mid = (left + right) / 2;
        if (mid > ind) {
            upd(ind, x, 2 * v, left, mid);
        } else {
            upd(ind, x, 2 * v + 1, mid, right);
        }
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
}
struct event {
    ll l, m, r;
    event(ll _l, ll _m, ll _r) : l(_l), m(_m), r(_r) {}
};
bool comp(event a, event b) {
    return a.m < b.m || (a.m == b.m && a.r < b.r);
}
int main() {
    ll T;
    cin >> T;
    vector <event> a;
    set <ll> rs;
    while (T--) {
        ll k;
        cin >> n >> k;
        tree.resize(4 * n, 0);
        rs.insert(0);
        ll l, r, m;
        for (ll i = 0; i < k; ++i) {
            cin >> l >> m >> r;
            a.push_back({l, m, r});
        }
        sort(a.begin(), a.end(), comp);
        for (auto e : a) {
            if (getM(0, e.l - 1) >= (e.l - 1) || rs.lower_bound(e.l - 1) != rs.lower_bound(e.m)) {
                upd(e.m, e.r);
                rs.insert(e.r);
            }
        }
        bool ans = 0;
        for (ll i = 1; i <= n; ++i) {
            if (getM(i, i + 1) == n) {
                ans = 1;
            }
        }
        if (ans) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
        rs.clear();
        tree.clear();
        a.clear();
    }
}

