#include<iostream>
#include<vector>
#include<string>
#include<fstream>
#include<sstream>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>

#define ll long long
#define ld long double

using namespace std;

const int INF = 1e9 + 7;

struct seg {
    int l, r, m;
};

int solve(int cnt_test) {
    int n, K;
    cin >> n >> K;
    vector<seg> v(K);
    vector<int> pls(K);
    for (int i = 0; i < K; i++) {
        cin >> v[i].l >> v[i].m >> v[i].r;
        v[i].l--; v[i].m--;
        pls[i] = v[i].m;
    }
    sort(v.begin(), v.end(), [](seg a, seg b) {return a.m < b.m;});
    vector<vector<int>> dpl(n + 1, vector<int>(n + 1, -INF)), dpr(n + 1, vector<int>(n + 1, INF));
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            dpr[i][j] = -1;
            dpl[i][j] = n + 10;
        }
    }
    for (int len = 1; len <= n; len++) {
        int l = 0, r = 0;
        for (int i = 0; i + len <= n; i++) {
            int j = i + len;
            while (l < K && v[l].m < i) l++;
            while (r < K && v[r].m < j) r++;
            for (int k = l; k < r; k++) {
                if (dpr[i][v[k].l] <= v[k].r && dpl[v[k].r][j] >= v[k].l) {
                    dpr[i][j] = min({dpr[i][j], max(dpr[v[k].r][j], v[k].r)});
                    dpl[i][j] = max({dpl[i][j], min(dpl[i][v[k].l], v[k].l)});
                }
            }
        }
    }
    if (dpl[0][n] != -INF) cout << "YES\n";
    else cout << "NO\n";

    return 0;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int cnt = 0;
    while (!cin.eof()) {
        solve(cnt++);
    }
#else
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve(i);
    }
#endif
}