#include<iostream>
#include<vector>
#include<string>
#include<fstream>
#include<sstream>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>
 
#define ll long long
#define ld long double
 
using namespace std;
 
const int INF = 1e9 + 7;


struct seg {
    int l, r, m;
};

struct sp_table {
    int n = 0;
    vector<vector<int>> tb = {};
    vector<int> log = {};
    sp_table(int n1, vector<int> &v) {
        int n = n1;
        log.assign(n + 1, 0);
        for (int i = 2; i <= n; i++) {
            log[i] = log[i / 2] + 1;
        }
        tb.assign(log[n] + 1, vector<int>(n, -1));
        for (int i = 0; i < n; i++) {
            tb[0][i] = v[i];
        }
        for (int i = 1; i <= log[n]; i++) {
            for (int j = 0; j + (1 << i) <= n; i++) {
                tb[i][j] = max(tb[i - 1][j], tb[i - 1][j + (1 << (i - 1))]);
            }
        }
    }
    int get_max(int l, int r) {
        if (r - l <= 0) return -1;
        int len = log[r - l];
        return max(tb[len][l], tb[len][r - (1 << len)]);
    }
};

 
int solve(int cnt_test) {
    int n, K;
    cin >> n >> K;
    vector<seg> v(K);
    vector<int> rgt(K), pls(K);
    for (int i = 0; i < K; i++) {
        cin >> v[i].l >> v[i].m >> v[i].r;
        v[i].l--; v[i].m--;
    }
    sort(v.begin(), v.end(), [](seg a, seg b) {return a.m < b.m;});
    for (int i = 0; i < K; i++) {
        rgt[i] = v[i].r; pls[i] = v[i].m;
    }
    sp_table st(K, rgt);
    for (int i = 0; i < K; i++) {
        int ind = lower_bound(pls.begin(), pls.end(), v[i].l) - pls.begin();
        int k = st.get_max(ind, i);
        if (k > v[i].m) {
            cout << "NO\n";
            return 0;
        }
    }
    sort(v.begin(), v.end(), [](seg a, seg b) {return a.l < b.l;});
    int maxi = 0, c = 0;
    for (int i = 0; i < n; i++) {
        if (i > maxi) {
            cout << "NO\n";
            return 0;
        }
        while (c < K && v[c].l == i) {
            maxi = max(maxi, v[c].r - 1);
            c++;
        }
    }
    cout << "YES\n";

    return 0;
}
 
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int cnt = 0;
    while (!cin.eof()) {
        solve(cnt++);
    }
#else
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve(i);
    }
#endif
}