#include<iostream>
#include<vector>
#include<string>
#include<fstream>
#include<sstream>
#include<set>
#include<map>
#include<cmath>
#include<algorithm>

#define ll long long
#define ld long double
#define int long long

using namespace std;

const int INF = 1e9 + 7;
const ll INFL = (ll) 4e18 + 7;

vector<vector<int>> graph = {};
vector<pair<int, int>> dp = {};
vector<int> sec = {};

void dfs(int v, int p) {
    int add = -INF;
    int where = -1;
    for (int u : graph[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v].second += dp[u].first;
        int k = dp[u].second - dp[u].first;
        if (add < k) {
            add = k;
            where = u;
        }
    }
    if (dp[v].second < dp[v].second + add + 1) {
        dp[v].first = dp[v].second + add + 1;
        sec[v] = where;
    } else {
        dp[v].first = dp[v].second;
    }
}

void output(int v, int p, bool can) {
    if (can && sec[v] != -1) {
        cout << v + 1 << ' ' << sec[v] + 1 << '\n';
    }
    for (int u : graph[v]) {
        if (u == p) continue;
        if (can && u == sec[v]) output(u, v, false);
        else output(u, v, true);
    }
}

int solve(int cnt_test) {
    int n, d;
    cin >> n >> d;
    graph.assign(n, {});
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    dp.assign(n, {0, 0});
    sec.assign(n, -1);
    dfs(0, 0);
    cout << dp[0].first << '\n';
    output(0, 0, true);

    return 0;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int cnt = 0;
    while (!cin.eof()) {
        solve(cnt++);
    }
#else
    solve(0);
#endif
}