#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct cleaner {
    ll l, m, r;
};

bool comp(cleaner a, cleaner b) {
    if (a.l < b.l) {
        return true;
    }
    if (a.l == b.l && a.r < b.r) {
        return true;
    }
    return false;
}


vector<ll> tree, delay_operations;

// void build(ll l, ll r, ll ind, vector<ll> &a) {
//     if (l == r - 1) {
//         tree[ind] = a[l];
//         return;
//     }
//     build(l, (l + r) / 2, 2 * ind + 1, a);
//     build((l + r) / 2, r, 2 * ind + 2, a);
//     tree[ind] = tree[2 * ind + 1] + tree[2 * ind + 2];
// }

void push(ll l, ll r, ll ind) {
    if (l != r - 1) {
        delay_operations[2 * ind + 1] += delay_operations[ind];
        delay_operations[2 * ind + 2] += delay_operations[ind];
    }
    tree[ind] += (delay_operations[ind] * (r - l));
    delay_operations[ind] = 0;
}

ll get(ll l, ll r, ll ind, ll q_l, ll q_r) {
    push(l, r, ind);
    if (l >= q_r || r <= q_l) {
        return 0;
    }
    if (l >= q_l && r <= q_r) {
        return tree[ind];
    }

    ll f_value = get(l, (l + r) / 2, 2 * ind + 1, q_l, q_r);
    ll s_value = get((l + r) / 2, r, 2 * ind + 2, q_l, q_r);
    return f_value + s_value;
}

void update(ll l, ll r, ll ind, ll q_l, ll q_r, ll value) {
    push(l, r, ind);
    if (l >= q_r || r <= q_l) {
        return;
    }
    if (l >= q_l && r <= q_r) {
        delay_operations[ind] += value;
        return;
    }
    update(l, (l + r) / 2, 2 * ind + 1, q_l, q_r, value);
    update((l + r) / 2, r, 2 * ind + 2, q_l, q_r, value);
    ll f_value = tree[2 * ind + 1] + delay_operations[2 * ind + 1] * (r - l);
    ll s_value = tree[2 * ind + 2] + delay_operations[2 * ind + 2] * (r - l);
    tree[ind] = f_value + s_value;
}


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<cleaner> cleaners(k);
    for (ll i = 0; i < k; i++) {
        ll t1, t2, t3;
        cin >> t1 >> t2 >> t3;
        cleaners[i].l = t1;
        cleaners[i].m = t2;
        cleaners[i].r = t3;
    }

    sort(cleaners.rbegin(), cleaners.rend(), comp);

    vector<pair<ll, ll> > events;
    ll pr_l = -1;
    for (auto c: cleaners) {
        if (c.l != pr_l) {
            events.push_back({c.l, -1});
            events.push_back({c.r, 1});
        }
        pr_l = c.l;
    }
    sort(events.begin(), events.end());
    ll bal = 0;
    ll gap = 0;
    for (auto c : events) {
        // cout << c.first << ' ' << c.second << endl;
        if (bal == 0) {
            if (c.first - 1 != gap) {
                cout << "NO";
                return;
            }
        }
        bal += c.second;
        if (bal == 0) {
            gap = c.first;
        }
    }

    cout << "YES";
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    ll tt;
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}
