#include <bits/stdc++.h>
#define ll long long
#pragma GCC optimize("O3,unroll_loops")
#pragma GCC target("avx2")

using namespace std;

struct cleaner {
    ll l, m, r;
};

bool comp(cleaner a, cleaner b) {
    if (a.l < b.l) {
        return true;
    }
    if (a.l == b.l && a.r < b.r) {
        return true;
    }
    return false;
}


vector<ll> tree, delay_operations;

void push(ll l, ll r, ll ind) {
    if (l != r - 1 && delay_operations[ind] > 0) {
        delay_operations[2 * ind + 1] = 1;
        delay_operations[2 * ind + 2] = 1;
    }
    tree[ind] = max(tree[ind], delay_operations[ind] * (r - l));
    delay_operations[ind] = 0;
}

ll get(ll l, ll r, ll ind, ll q_l, ll q_r) {
    push(l, r, ind);
    if (l >= q_r || r <= q_l) {
        return 0;
    }
    if (l >= q_l && r <= q_r) {
        return tree[ind];
    }

    ll f_value = get(l, (l + r) / 2, 2 * ind + 1, q_l, q_r);
    ll s_value = get((l + r) / 2, r, 2 * ind + 2, q_l, q_r);
    return f_value + s_value;
}

void update(ll l, ll r, ll ind, ll q_l, ll q_r, ll value) {
    push(l, r, ind);
    if (l >= q_r || r <= q_l) {
        return;
    }
    if (l >= q_l && r <= q_r) {
        delay_operations[ind] = 1;
        return;
    }
    update(l, (l + r) / 2, 2 * ind + 1, q_l, q_r, value);
    update((l + r) / 2, r, 2 * ind + 2, q_l, q_r, value);

    ll f_value = max(tree[2 * ind + 1], delay_operations[2 * ind + 1] * ((l + r) / 2 - l));
    ll s_value = max(tree[2 * ind + 2], delay_operations[2 * ind + 2] * (r - (l + r) / 2));

    tree[ind] = f_value + s_value;
}


void solve() {
    ll n, k;
    cin >> n >> k;
    vector<cleaner> orig_cleaners(k);
    for (ll i = 0; i < k; i++) {
        ll t1, t2, t3;
        cin >> t1 >> t2 >> t3;
        orig_cleaners[i].l = t1 - 1;
        orig_cleaners[i].m = t2 - 1;
        orig_cleaners[i].r = t3 - 1;
    }

    vector<ll> order;
    for (ll i = 0; i < k; i++) {
        order.push_back(i);
    }

    do {
        bool flag = true;
        vector<cleaner> cleaners;
        for (ll i: order) {
            cleaners.push_back(orig_cleaners[i]);
        }

        tree.assign(4 * n, 0);
        delay_operations.assign(4 * n, 0);

        for (auto c: cleaners) {
            ll result = get(0, n, 0, c.m, c.m + 1);
            if (result == 0) {
                update(0, n, 0, c.l, c.r + 1, 1);
            }
        }

        if (get(0, n, 0, 0, n) != n) {
            flag = false;
        }

        if (flag) {
            cout << "YES";
            return;
        }
    } while (next_permutation(order.begin(), order.end()));

    bool flag = true;

    tree.assign(4 * n, 0);
    delay_operations.assign(4 * n, 0);

    for (auto c: orig_cleaners) {
        ll result = get(0, n, 0, c.m, c.m + 1);
        if (result == 0) {
            update(0, n, 0, c.l, c.r + 1, 1);
        }
    }

    if (get(0, n, 0, 0, n) != n) {
        flag = false;
    }

    if (flag) {
        cout << "YES";
        return;
    }

    cout << "NO";
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    ll tt;
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}
