#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
template<typename T>
void _print(T a) {cerr << a;}
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(vector<T> a) {cerr << "[";int f = 0;for (auto v : a) {if (f++)cerr << ", ";_print(v);}cerr << "]";}

#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n';
#else
#define debug(x)
#endif

struct segtree {
    vector<int> tree;
    int size;
    void init(int n) {
        size = 1;
        while (size < n)size *= 2;
        tree.assign(2 * size - 1, INT_MAX);
    }
    void set(int ind, int val) {
        set(ind, val, 0, 0, size);
    }
    void set(int ind, int val, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = val;
            return;
        }
        int m = (lx + rx) / 2;
        if (ind < m)set(ind, val, 2 * x + 1, lx, m);
        else set(ind, val, 2 * x + 2, m, rx);
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get(int l, int r, int val) {
        assert(tree[0] < val);
        return get(l, r, val, 0, 0, size);
    }
    int get(int l, int r, int val, int x, int lx, int rx) {
        if (rx <= l || r <= lx)return -1;
        if (rx - lx == 1)return lx;
        int m = (lx + rx) / 2;
        if (tree[2 * x + 2] < val) {
            int g = get(l, r, val, 2 * x + 2, m, rx);
            if (g != -1)return g;
        }
        return get(l, r, val, 2 * x + 1, lx, m);
    }
};

int main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);
    int n, m; cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        for (int j = 0; j < m; ++j)a[i][j] = s[j] - '0';
    }
    int maxi = 0;

    vector<int> ind(n);
    vector<vector<int>> row(m, vector<int> (n + 1));
    for (int i = 0; i < n; ++i) {
        int now = 0;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] == 1)now++;
            else now = 0;
            row[j][i + 1] = now;
        }
    }
    segtree sg;
    if ((ld)clock() / CLOCKS_PER_SEC >= 0.4)assert(false);
    for (int j = 0; j < m; ++j) {
        sg.init(n + 1);
        sg.set(0, -1);
        debug(sg.tree[0]);
        row[j][0] = -1;
        vector<int> dp(n + 1);
        dp[0] = 0;
        debug(j);
        debug(row[j]);
        for (int i = 1; i <= n; ++i) {
            int ans = sg.get(0, i, row[j][i]);
            int len = i - ans;
            dp[i] = len * row[j][i] + dp[ans];
            maxi = max(maxi, dp[i]);
            sg.set(i, row[j][i]);
        }
        debug(dp);
    }
    cout << maxi;
}