#include <bits/stdc++.h>
#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx,avx2,bmi,bmi2")
using namespace std;
using ll = long long;
template<typename T>
void _print(T a) {cerr << a;}
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(vector<T> a) {cerr << "[";int f = 0;for (auto v : a) {if (f++)cerr << ", ";_print(v);}cerr << "]";}

#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n';
#else
#define debug(x)
#endif

struct segtree {
    vector<int> tree;
    int size;
    void init(int n) {
        size = 1;
        while (size < n)size *= 2;
        tree.assign(2 * size - 1, INT_MAX);
    }
    void set(int ind, int val) {
        set(ind, val, 0, 0, size);
    }
    void set(int ind, int val, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = val;
            return;
        }
        int m = (lx + rx) / 2;
        if (ind < m)set(ind, val, 2 * x + 1, lx, m);
        else set(ind, val, 2 * x + 2, m, rx);
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get(int l, int r, int val) {
        assert(tree[0] < val);
        return get(l, r, val, 0, 0, size);
    }
    int get(int l, int r, int val, int x, int lx, int rx) {
        if (rx <= l || r <= lx)return -1;
        if (rx - lx == 1)return lx;
        int m = (lx + rx) / 2;
        if (tree[2 * x + 2] < val) {
            int g = get(l, r, val, 2 * x + 2, m, rx);
            if (g != -1)return g;
        }
        return get(l, r, val, 2 * x + 1, lx, m);
    }
};

int main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int n, m; cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        for (int j = 0; j < m; ++j)a[i][j] = s[j] - '0';
    }
    int maxi = 0;
    vector<vector<pair<int, int>>> ones(n);
    for (int i = 0; i < n; ++i)ones[i].emplace_back(0, 0);
    for (int i = 0; i < n; ++i) {
        int cnt = 0;
        int start = -1;
        for (int j = 0; j < m; ++j) {
            if (a[i][j]) {
                cnt++;
                if (cnt == 1)start = j;
            }
            else {
                if (start != -1)ones[i].emplace_back(start, cnt);
                cnt = 0;
                start = -1;
            }
        }
        if (start != -1)ones[i].emplace_back(start, cnt);
    }

    for (int i = 0; i < n; ++i) {
        debug(ones[i]);
    }
    vector<int> ind(n);
    segtree sg;
    for (int j = 0; j < m; ++j) {
        vector<int> row(n + 1);
        for (int i = 0; i < n; ++i) {
            while (ind[i] < (int)ones[i].size()) {
                int end = ones[i][ind[i]].first + ones[i][ind[i]].second - 1;
                if (end < j)ind[i]++;
                else {
                    if (ones[i][ind[i]].first <= j)row[i + 1] = end - j + 1;
                    break;
                }
            }
        }
        sg.init(n + 1);
        sg.set(0, -1);
        row[0] = -1;
        vector<int> dp(n + 1);
        dp[0] = 0;
        for (int i = 1; i <= n; ++i) {
            int ans = sg.get(0, i, row[i]);
            int len = i - ans;
            dp[i] = len * row[i] + dp[ans];
            maxi = max(maxi, dp[i]);
            sg.set(i, row[i]);
        }
    }
    cout << maxi;
}