#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using oset = tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Elem {
    int l, m, r;
    Elem (int l, int m, int r) : l(l), m(m), r(r) {}
};

bool solve(int n, int k, vector<Elem> els) {
    sort(els.begin(), els.end(), [&](Elem &a, Elem &b) {
        return a.m < b.m;
    });

    vector<set<int> > r(n + 2), l(n + 2);
    l[0].insert(-1);
    r[n + 1].insert(-1);
    for (int i = k - 1; i >= 0; --i) {
        if (els[i].r == n) {
            r[els[i].l].insert(i);
        } else {
            if (r[els[i].l].empty()) {
                for (int j = i + 1; j < k; ++j) {
                    if (els[j].m > els[i].r && els[j].l <= els[i].r + 1 && els[i].m < els[j].l && r[els[j].l].contains(j)) {
                        r[els[i].l].insert(i);
                    }
                }
            }
        }
    }

    for (int i = 0; i < k; ++i) {
        if (els[i].l == 1) {
            l[els[i].r].insert(i);
        } else {
            if (l[els[i].r].empty()) {
                for (int j = i - 1; j >= 0; --j) {
                    if (els[j].m < els[i].l && els[j].r >= els[i].l - 1 && els[i].m > els[j].r && l[els[j].r].contains(j)) {
                        l[els[i].r].insert(i);
                    }
                }
            }
        }
    }

    // return l[n] || r[1];

    for (int i = 0; i < k; ++i) {
        bool fll = false;
        bool flr = false;
        if (els[i].l == 1) {
            fll = true;
        } else {
            for (int j = els[i].l - 1; j < els[i].m; ++j) {
                if (!l[j].empty()) {
                    fll = true;
                    break;
                }
            }
        }

        if (els[i].r == n) {
            flr = true;
        } else {
            for (int j = els[i].m + 1; j <= els[i].r + 1; ++j) {
                if (!r[j].empty()) {
                    flr = true;
                    break;
                }
            }
        }

        if (fll && flr) {
            return true;
        }
    }

    return false;
}

bool solve2(int n, int k, vector<Elem> els) {
    sort(els.begin(), els.end(), [&](Elem &a, Elem &b) {
        return a.m < b.m;
    });

    vector<bool> r(n + 2), l(n + 2);
    l[0] = true;
    r[n + 1] = true;
    for (int i = k - 1; i >= 0; --i) {
        if (els[i].r == n) {
            r[els[i].l] = true;
        } else {
            if (!r[els[i].l]) {
                for (int j = els[i].m + 1; j <= els[i].r + 1; ++j) {
                    if (r[j]) {
                        r[els[i].l] = true;
                        break;
                    }
                }
            }
        }
    }

    for (int i = 0; i < k; ++i) {
        if (els[i].l == 1) {
            l[els[i].r] = true;
        } else {
            if (!l[els[i].r]) {
                for (int j = els[i].l - 1; j < els[i].m; ++j) {
                    if (l[j]) {
                        l[els[i].r] = true;
                        break;
                    }
                }
            }
        }
    }

    return l[n] || r[1];

    for (int i = 0; i < k; ++i) {
        bool fll = false;
        bool flr = false;
        if (els[i].l == 1) {
            fll = true;
        } else {
            for (int j = els[i].l - 1; j < els[i].m; ++j) {
                if (l[j]) {
                    fll = true;
                    break;
                }
            }
        }

        if (els[i].r == n) {
            flr = true;
        } else {
            for (int j = els[i].m + 1; j <= els[i].r + 1; ++j) {
                if (r[j]) {
                    flr = true;
                    break;
                }
            }
        }

        if (fll && flr) {
            return true;
        }
    }

    return false;
}

mt19937 rnd(2124);

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    // int n = 10;
    // while (true) {
    //     int k = rnd() % 3 + 1;
    //     vector<Elem> els;
    //     int l1 = 1;
    //     int r1 = rnd() % n + 1;
    //     int m1 = rnd() % (r1 - l1 + 1) + l1;
    //     els.emplace_back(l1, m1, r1);
    //     for (int i = 0; i < k - 1; ++i) {
    //         int l = rnd() % (n - 1) + 1;
    //         int r = rnd() % (n - l + 1) + l;
    //         int m = rnd() % (r - l + 1) + l;
    //         els.emplace_back(l, m, r);
    //     }
    //
    //     auto re1 = solve(n, k, els);
    //     auto re2 = solve2(n, k, els);
    //
    //     if (re1 != re2) {
    //         cout << re1 << ' ' << re2 << "\n";
    //         for (auto i : els) {
    //             cout << i.l << ' ' << i.m << ' ' << i.r << "\n";
    //         }
    //         break;
    //     }
    // }

    int tt = 1;
    cin >> tt;
    while (tt--) {
        int n, k;
        cin >> n >> k;

        vector<Elem> els;
        for (int i = 0; i < k; ++i) {
            int l, m, r;
            cin >> l >> m >> r;
            els.emplace_back(l, m, r);
        }
        if (solve(n, k, els)) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
}
