#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <bitset>
#include <cmath>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;

#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

int n, m;
vector<vector<int>> a, pref;

int bin(int line, int ql, int qr) {
    int l = ql, r = qr;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (pref[line][mid] - pref[line][ql] == mid - ql) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}

int f(int si, int sj, int ei) {
    if (a[ei][sj] != 1) return 0;
    int cur = 0, pr = m + 1;
    for (int line = ei; line >= si; line--) {
        int res = bin(line, sj, pr);
        cur += res - sj;
        pr = res + 1;
    }
    return cur;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    a = vector<vector<int>> (n, vector<int> (m));
    pref = vector<vector<int>> (n, vector<int> (m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
            pref[i][j + 1] = pref[i][j] + a[i][j];
        }
    }
    int ans = 0;
    for (int si = 0; si < n; si++) {
        for (int sj = 0; sj < m; sj++) {
            for (int ei = si; ei < n; ei++) {
                ans = max(ans, f(si, sj, ei));
            }
        }
    }
    cout << ans << '\n';
}