#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <bitset>
#include <cmath>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;

#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

int n, m;
vector<vector<int>> a, pref;
vector<vector<int>> pref2;

int bin(int line, int ql, int qr) {
    int l = ql, r = qr;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (pref[line][mid] - pref[line][ql] == mid - ql) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}

int calc(int i1, int j1, int i2, int j2) {
    return (pref2[i2 + 1][j2 + 1] - pref[i1][j2 + 1] - pref[i2 + 1][j1] + pref[i1][j1] - (i1 - i2 + 1) * (j1 - j2 + 1)) == 0;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    a = vector<vector<int>> (n, vector<int> (m));
    pref = vector<vector<int>> (n, vector<int> (m + 1));
    pref2 = vector<vector<int>> (n + 1, vector<int> (m + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
            pref[i][j + 1] = pref[i][j] + a[i][j];
            pref2[i + 1][j + 1] = pref2[i][j + 1] + pref2[i + 1][j] + a[i][j];
        }
    }
    int ans = 0;
    for (int sj = 0; sj < m; sj++) {
        vector<int> h(n);
        for (int i = 0; i < n; i++) {
            h[n - i - 1] = bin(i, sj, m + 1) - sj;
        }
        dbg(h);
        vector<vector<int>> dp(n, vector<int> (m + 1));
        dp[0][h[0]] = h[0];
        ans = max(ans, h[0]);
        for (int i = 1; i < n; i++) {
            int best = 0;
            for (int j = 0; j <= m; j++) {
                if (j > h[i]) break;
                best = max(best, dp[i - 1][j]);
                dp[i][j] = max(dp[i][j], best + j);
                ans = max(ans, dp[i][j]);
            }
        }
        dbg(dp);
    }
    cout << ans << '\n';
}