// GetmanovNikolai.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define ll long long
#define vec vector

using namespace std;

struct SegmentTree
{
	ll n;
	vec<ll> segtree;

	SegmentTree(ll n)
	{
		segtree.assign(4 * n, 0);
	}

	// RSQ
	void add(ll ind, ll v, ll left, ll right)
	{
		if (right < ind || left > ind)
			return;
		if (left == right)
		{
			segtree[v]++;
			return;
		}
		
		ll mid = (left + right) / 2;
		add(ind, v * 2, left, mid);
		add(ind, v * 2 + 1, mid + 1, right);
		segtree[v] = segtree[v * 2] + segtree[v * 2 + 1];
	}
	
	ll sum(ll ql, ll qr, ll v, ll left, ll right)
	{
		if (ql > right || qr < left)
			return 0;

 		if (ql <= left && right <= qr)
			return segtree[v];

		ll mid = (left + right) / 2;
		return sum(ql, qr, v * 2, left, mid) + sum(ql, qr, v * 2 + 1, mid + 1, right);
	}
};

ll getLeft(pair<ll, pair<ll, ll> > &a)
{
	return a.first;
}

ll getMid(pair<ll, pair<ll, ll> >& a)
{
	return a.second.first;
}

ll getRight(pair<ll, pair<ll, ll> >& a)
{
	return a.second.second;
}

int main()
{
	ll t;
	cin >> t;

	while (t--)
	{
		ll n, k;
		cin >> n >> k;

		vec<pair<ll, pair<ll, ll> > > workers(k);

		ll i;
		for (auto& w : workers)
		{
			ll l, m, r;
			cin >> l >> m >> r;

			w = { l, {m, r} };
		}

		sort(workers.begin(), workers.end());

		SegmentTree tr(n + 1);
		tr.add(0, 1, 0, n);

		for (auto& w : workers)
		{
			if (tr.sum(getLeft(w) - 1, getMid(w) - 1, 1, 0, n))
				tr.add(getRight(w), 1, 0, n);
		} 

		cout << (tr.sum(n, n, 1, 0, n) ? "YES\n" : "NO\n");
	}
}
