#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;
const ll INF = 1e18;
const ll MAXX = 100;
ll sign(ll x) {
    return (x > 0) - (x < 0);
}

struct Segtree {
    vector<ll> t;
    ll sz;

    ll get(ll x, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) {
            return t[x];
        }
        if (lx >= r || rx <= l) {
            return -INF;
        }
        ll md = (lx + rx) / 2;
        return max(get(2 * x + 1, lx, md, l, r), get(2 * x + 2, md, rx, l, r));
    }
    void edit(ll x, ll lx, ll rx, ll i, ll v) {
        if (rx - lx == 1) {
            t[x] = max(t[x], v);
            return;
        }
        ll md = (lx + rx) / 2;
        if (i < md) {
            edit(2 * x + 1, lx, md, i, v);
        } else {
            edit(2 * x + 2, md, rx, i, v);
        }
        t[x] = max(t[2 * x + 1], t[2 * x + 2]);
    }
};


void solve() {
    ll n, k;
    cin >> n >> k;
  
    vector<tup> sg(k);
    for (auto &[l, m, r] : sg) {
        cin >> l >> m >> r;
        --l; --m; --r;
    }
    sort(sg.begin(), sg.end());

    Segtree st1;
    Segtree st2;
    st1.t.assign(4 * n, -INF);
    st2.t.assign(4 * n, -INF);
  
    vector<ll> can(k, 0);
    for (ll i = 0; i < k; i++) {
        if (get<0>(sg[i]) == 0) {
            can[i] = 1;
            st1.edit(0, 0, n, get<2>(sg[i]), get<2>(sg[i]));
            st2.edit(0, 0, n, get<1>(sg[i]), get<2>(sg[i]));
            continue;
        }
  
        ll mx = -INF;
        mx = max(mx, st1.get(0, 0, n, 0, get<1>(sg[i])));
        mx = max(mx, st2.get(0, 0, n, 0, get<0>(sg[i])));
        can[i] = (mx >= get<0>(sg[i]) - 1);
        if (can[i]) {
            st1.edit(0, 0, n, get<2>(sg[i]), get<2>(sg[i]));
            st2.edit(0, 0, n, get<1>(sg[i]), get<2>(sg[i]));
        }
    }
  
    for (ll i = 0; i < k; i++) {
        if (get<2>(sg[i]) == n - 1 && can[i] == 1) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}


int main() {
    bool IS_MULTITEST = 1;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}