#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;
const ll INF = 1e18;


ll n, d;
vector<ll> col, mt, us;
vector<vector<ll>> dd;
vector<vector<ll>> g;


void dfs(ll v, ll p, ll cc) {
    col[v] = cc;
    for (auto &u : g[v]) {
        if (u != p) {
            dfs(u, v, cc + 1);
        }
    }
}

void get(ll v, ll p, ll cc) {
    dd.back()[v] = cc;
    for (auto &u : g[v]) {
        if (u != p) {
            get(u, v, cc + 1);
        }
    }
}

bool kuhn(ll v) {
    if (us[v]) return false;
    us[v] = 1;
    for (auto &u : g[v]) {
        if (mt[u] == -1 || kuhn(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    cin >> n >> d;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    col.assign(n, 0);
    dfs(0, -1, 0);

    vector<ll> c1, c2;
    for (ll i = 0; i < n; i++) {
        if (col[i] % 2) {
            c1.push_back(i);
        } else {
            c2.push_back(i);
        }
    }

    dd.clear();
    for (ll i = 0; i < n; i++) {
        dd.push_back(vector<ll> (n, 0));
        get(i, -1, 0);
    }

    ll sz1 = c1.size();
    ll sz2 = c2.size();
    g.assign(sz1, {});
    for (ll i = 0; i < sz1; i++) {
        for (ll j = 0; j < sz2; j++) {
            ll v = c1[i];
            ll u = c2[j];
            if (dd[v][u] <= d) {
                g[i].push_back(j);
            }
        }
    }

    ll cc = 0;
    mt.assign(sz2, -1);
    for (ll i = 0; i < sz1; i++) {
        us.assign(sz1, 0);
        if (kuhn(i)) {
            cc++;
        }
    }

    cout << cc << '\n';
    for (ll i = 0; i < sz2; i++) {
        if (mt[i] != -1) {
            cout << c1[mt[i]] + 1 << ' ' << c2[i] + 1 << '\n';
        }
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}