#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define szof(x) ((ll) x.size())

const int MAXN = 1e5 + 1;
vector<int> g[MAXN];
int cnt[MAXN];

void solve() {
    ll n, k;
    cin >> n >> k;

    fill(g, g + MAXN, vector<int>(0));
    fill(cnt, cnt + MAXN, 0);

    vector<tuple<ll, ll, ll>> a(k);
    vector<vector<int>> starts(n + 1);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = {l, m, r};
        for (int j = l; j <= m; ++j) {
            starts[j].push_back(i);
        }
    }
    vector<int> d(n + 2);
    for (auto [l, m, r] : a) {
        d[l]++, d[r + 1]--;
    }
    for (int i = 1; i <= n; ++i) {
        d[i] += d[i - 1];
        if (d[i] == 0) {
            return void(cout << "NO");
        }
    }
    vector<ll> dp(n + 2);
    dp[n + 1] = 1;
    for (int i = n; i >= 1; --i) {
        for (int j : starts[i]) {
            auto [l, m, r] = a[j];
            dp[i] |= dp[r + 1];
        }
    }
    cout << (dp[1] ? "YES" : "NO");
}

bool solve(ll n, ll k, vector<tuple<ll, ll, ll>> a) {
    fill(g, g + MAXN, vector<int>(0));
    fill(cnt, cnt + MAXN, 0);

    vector<vector<int>> starts(n + 1);
    for (int i = 0; i < k; ++i) {
        auto [l, m, r] = a[i];
        for (int j = l; j <= m; ++j) {
            starts[j].push_back(i);
        }
    }
    vector<int> d(n + 2);
    for (auto [l, m, r] : a) {
        d[l]++, d[r + 1]--;
    }
    for (int i = 1; i <= n; ++i) {
        d[i] += d[i - 1];
        if (d[i] == 0) {
            return false;
        }
    }
    vector<ll> dp(n + 2);
    dp[n + 1] = 1;
    for (int i = n; i >= 1; --i) {
        for (int j : starts[i]) {
            auto [l, m, r] = a[j];
            dp[i] |= dp[r + 1];
        }
    }
    return dp[1];
}

bool fool(ll n, ll k, vector<tuple<ll, ll, ll>> a) {
    fill(g, g + MAXN, vector<int>(0));
    fill(cnt, cnt + MAXN, 0);
    vector<int> d(n + 2);
    for (auto [l, m, r] : a) {
        d[l]++, d[r + 1]--;
    }
    for (int i = 1; i <= n; ++i) {
        d[i] += d[i - 1];
        if (d[i] == 0) {
            return false;
        }
    }

    for (int i = 0; i < k; ++i) {
        auto [l, m, r] = a[i];
        for (int j = 0; j < k; ++j) {
            if (j == i) {
                continue;
            }
            auto [l1, m1, r1] = a[j];
            if (l <= l1) {
                g[i].emplace_back(j);
            }
        }
    }
    vector<int> q;
    int head = 0;
    vector<int> used(k);
    for (int i = 0; i < k; ++i) {
        if (get<0>(a[i]) == 1) {
            q.push_back(i);
            used[i] = 1;
        }
    }
    while (head < szof(q)) {
        int v = q[head++];
        if (get<2>(a[v]) == n) {
            return true;
        }
        for (auto u : g[v]) {
            if (!used[u]) {
                used[u] = true;
                q.push_back(u);
            }
        }
    }
    return false;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}