#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <queue>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<bool>> tab(n + 2, vector<bool>(m + 2, 0));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			char c;
			cin >> c;
			tab[i][j] = (c == '1');
		}
	}

	vector<vector<int>> cnt(n + 2, vector<int>(m + 2, 0));
	vector<vector<int>> mx(n + 2, vector<int>(m + 2, 0));
	vector<vector<int>> pr(n + 2, vector<int>(m + 2, 0));
	vector<vector<int>> dp(n + 2, vector<int>(m + 2, 0));

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m + 1; j++)
			cnt[i][j] = int(tab[i][j]) + cnt[i - 1][j] + cnt[i][j - 1] - cnt[i - 1][j - 1];

		for (int j = m; j >= 1; j--) {
			if (!tab[i][j])
				mx[i][j] = 0;
			else
				mx[i][j] = mx[i][j + 1] + 1;
			pr[i][j] = pr[i - 1][j] + mx[i][j];
		}
	}

	int ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			int k = mx[i][j];
			dp[i][j] = dp[i - 1][j] + k;
			int l = 0, r = i;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (cnt[i - 1][j + k] + cnt[i - mid - 1][j - 1] - cnt[i - 1][j - 1] - cnt[i - mid - 1][j + k] == mid * k)
					l = mid;
				else
					r = mid;
			}

			dp[i][j] -= (pr[i][j + k] - pr[i - l - 1][j + k]);
			ans = max(ans, dp[i][j]);
		}
	}

	cout << ans;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);

	solve();
}
