#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <queue>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<bool>> tab(n + 2, vector<bool>(m + 2, 0));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			char c;
			cin >> c;
			tab[i][j] = (c == '1');
		}
	}

	vector<vector<int>> cnt(n + 2, vector<int>(m + 2, 0));
	vector<vector<int>> mx(n + 2, vector<int>(m + 2, 0));
	vector<vector<int>> dp(n + 2, vector<int>(m + 2, 0));
	vector<vector<int>> nxt(n + 2, vector<int>(m + 2, 0));

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m + 1; j++)
			cnt[i][j] = int(tab[i][j]) + cnt[i - 1][j] + cnt[i][j - 1] - cnt[i - 1][j - 1];

	}

	int k, l, r, mid;
	for (int j = m; j >= 1; j--) {
		for (int i = 1; i <= n; i++) {
			if (!tab[i][j])
				mx[i][j] = 0;
			else
				mx[i][j] = mx[i][j + 1] + 1;

			if (mx[i - 1][j] < mx[i][j]) {
				nxt[i][j] = i - 1;
				continue;
			}

			k = mx[i][j];
			l = i - nxt[i - 1][j]; r = i + 1;
			while (r - l > 1) {
				mid = (l + r) / 2;
				if (cnt[i][j + k - 1] + cnt[i - mid][j - 1] - cnt[i][j - 1] - cnt[i - mid][j + k - 1] == mid * k)
					l = i - nxt[i - mid + 1][j];
				else
					r = mid;
			}

			nxt[i][j] = i - l;
		}
	}

	int ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (!tab[i][j]) {
				dp[i][j] = 0;
				continue;
			}

			k = mx[i][j];

			dp[i][j] = dp[nxt[i][j]][j] + (i - nxt[i][j]) * k;
			ans = max(ans, dp[i][j]);
		}
	}

	cout << ans;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);

	solve();
}