#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <queue>
#include <set>
#include <map>

using namespace std;
using ll = long long;
const int SZ = 5e5 + 100;

int n, d;
vector<int> g[SZ];
vector<pair<int, int>> ans;
int rnk[SZ];

bool dfs(int v, int p = -1) {
	int w = -1;
	for (auto u : g[v]) {
		if (u == p)
			continue;
		rnk[u] = rnk[v] + 1;
		if (dfs(u, v))
			w = u;
	}
	if (w == -1)
		return 1;
	ans.push_back({ v, w });
	return 0;
}

void solve() {
	cin >> n >> d;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	rnk[1] = 0;
	dfs(1);

	vector<int> v1, v2;
	for (int i = 1; i <= n; i++) {
		if (rnk[i] % 2 == 1)
			v1.push_back(i);
		else
			v2.push_back(i);
	}

	if (d == n - 1) {
		cout << min(v1.size(), v2.size()) << endl;
		for (int i = 0; i < min(v1.size(), v2.size()); i++)
			cout << v1[i] << ' ' << v2[i] << endl;
	}
	else {
		cout << ans.size() << endl;
		for (auto p : ans)
			cout << p.first << ' ' << p.second << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);

	solve();
}