#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <unordered_map>

using namespace std;

struct people {
	int l, r, m;
	people() {
		l = 0;
		r = 0;
		m = 0;
	}
};

const int inf = 1e9;

vector <int> tree;

int get(int v, int l, int r, int xl, int xr) {
	if (l >= xl && r <= xr) {
		return tree[v];
	}
	if (r <= xl || l >= xr) {
		return inf;
	}
	int mid = (l + r) >> 1;
	return min(get((v << 1) + 1, l, mid, xl, xr), get((v << 1) + 2, mid, r, xl, xr));
}

void set(int v, int l, int r, int xl, int iz) {
	//cout << "SET " << l << ' ' << r << endl;
	if (l == xl && l == r - 1) {
		tree[v] = min(tree[v], iz);
	}
	else if (l > xl || r <= xl) {
		return;
	}
	else {
		int mid = (l + r) >> 1;
		set((v << 1) + 1, l, mid, xl, iz);
		set((v << 1) + 2, mid, r, xl, iz);
		tree[v] = min(tree[(v << 1) + 1], tree[(v << 1) + 2]);
	}
}

bool cmp(people& a, people& b) {
	return a.l < b.l;
}

istream& operator>> (istream& in, people& p) {
	in >> p.l >> p.m >> p.r;
	return in;
}

void f() {
	int n, k; cin >> n >> k;
	n++;
	vector<people> v(k);
	for (int i = 0; i < k; i++) {
		cin >> v[i];
	}
	tree.assign(n * 4, inf);
	set(0, 0, n, 0, 0);
	sort(v.begin(), v.end(), cmp);
	for (int i = 0; i < k; i++) {
		if (get(0, 0, n, v[i].l - 1, v[i].m) != inf) {
			set(0, 0, n, v[i].r, v[i].m);
		}
		else {
			int it = get(0, 0, n, v[i].m, v[i].r + 1);
			if (it < v[i].l) {
				set(0, 0, n, v[i].r, v[i].m);
			}
		}
	}
	if (get(0, 0, n, n - 1, n) != inf) {
		cout << "YES" << '\n';
	}
	else {
		cout << "NO" << '\n';
	}
}

int main()
{
	cin.tie(0);
	int t; cin >> t;
	for (int i = 0; i < t; i++) {
		f();
	}
}

