#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

const int maxn = 1 << 21;
int n;
int mn[maxn];

void upd(int v, int l, int r, int id, int x) {
	if (r - l == 1) {
		mn[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (id < m) {
		upd(2 * v, l, m, id, x);
	}
	else {
		upd(2 * v + 1, m, r, id, x);
	}
	mn[v] = min(mn[2 * v], mn[2 * v + 1]);
}

int get(int v, int l, int r, int tl, int tr) {
	if (l >= tr || tl >= r) return n + 1;
	if (l >= tl && r <= tr) return mn[v];
	int m = (l + r) / 2;
	return min(get(2 * v, l, m, tl, tr), get(2 * v + 1, m, r, tl, tr));
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		int k;
		cin >> n >> k;
		vector<vector<int>> v(k, vector<int> (3));
		vector<int> l(k), r(k), m(k);
		for (int i = 0; i < k; ++i) {
			cin >> v[i][1] >> v[i][2] >> v[i][0];
		}
		sort(v.begin(), v.end());
		for (int i = 0; i < k; ++i) {
			l[i] = v[i][1];
			r[i] = v[i][0];
			m[i] = v[i][2];
		}
		for (int i = 0; i < k; ++i) {
			if (l[i] == 1) {
				upd(1, 0 ,k, i, m[i]);
			}
			else {
				upd(1, 0, k, i, n + 1);
			}
		}

		for (int i = 0; i < k; ++i) {
			int i1 = lower_bound(r.begin(), r.end(), l[i] - 1) - r.begin();
			int i2 = upper_bound(r.begin(), r.end(), m[i]) - r.begin() - 1;
			if (get(1, 0, k, i1, i2 + 1) != n + 1) {
				upd(1, 0, k, i, m[i]);
			}
			else {
				upd(1, 0, k, i, max(m[i], get(1,0,k, i2, i)));
			}
		}
		bool fl = 0;
		for (int i = 0; i < k; ++i) {
			if (r[i] == n && get(1, 0, k, i, i + 1) != n + 1) {
				fl = 1;
				break;
			}
		}
		if (fl) {
			cout << "YES\n";
		}
		else {
			cout << "NO\n";
		}
	}

	return 0;
}
