#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef __int128 ldl;
#ifdef _DEBUG
typedef long long ll;
#else
typedef __int128 ll;
decltype(cin)& operator>>(decltype(cin)& in, ll& x) {
	long long f;
	in >> f;
	x = f;
	return in;
}

decltype(cout)& operator<<(decltype(cout)& out, ll x) {
	long long f = x;
	out << f;
	return out;
}
#endif

const int maxn = 3e5 + 1;
ll x[maxn], xl[maxn], xg[maxn], ssl[maxn], psl[maxn], pdl[maxn], pdg[maxn], ssg[maxn], psg[maxn];
ll x0, d, n, m, t, id, cl, cg;

ll f(ll x) {
	return min((x % d) * (x % d), (d - x % d) * (d - x % d));
}

ldl fl(ll cn) {
	ll id = upper_bound(xl, xl + cl, d * cn) - xl;
	return t * cn + pdl[id] + (ldl) (cn * d * cn * d) * (ldl) (cl - id) - 2 * cn * d * (ldl)(psl[cl] - psl[id]) + (ldl)ssl[cl] - ssl[id];
}

ldl fl1(ll cn) {
	return cn * t + fl(cn);
}

ldl fg(ll cn) {
	ll id = upper_bound(xg, xg + cg, d * cn) - xg;
	return (ldl) t * cn + pdg[id] + (ldl)(cn * d * cn * d) * (ldl)(cg - id) - 2 * cn * (ldl) d * (psg[cg] - psg[id]) + ssg[cg] - ssg[id];
}

ldl fg1(ldl cn, ldl ml1, ldl ml2) {
	return min(fl1(min(cn, ml2)) + fg(cn), fl(max(cn, ml1)) + fg(cn) + cn * t);
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> x[i];
	}
	cin >> x0 >> d >> m;
	for (int i = 0; i < n; ++i) {
		if (x[i] < x0) {
			xl[cl] = x0 - x[i];
			++cl;
		}
		else {
			xg[cg] = x[i] - x0;
			++cg;
		}
	}
	sort(xl, xl + cl);
	sort(xg, xg + cg);
	for (int i = 0; i < cl; ++i) {
		pdl[i + 1] = pdl[i] + f(xl[i]);
		ssl[i + 1] = ssl[i] + xl[i] * xl[i];
		psl[i + 1] = psl[i] + xl[i];
	}
	for (int i = 0; i < cg; ++i) {
		pdg[i + 1] = pdg[i] + f(xg[i]);
		ssg[i + 1] = ssg[i] + xg[i] * xg[i];
		psg[i + 1] = psg[i] + xg[i];
	}
	const long double phi = (-1 + sqrt(5)) / 2;
	while (m--) {
		cin >> t;
		ll lt = 0, rt = 1e9 / d + 1;
		if (cl != 0) {
			rt = xl[cl - 1] / d + 1;
		}
		else {
			rt = 0;
		}
		ll l1 = lt + (rt - lt) / (phi + 2), r1 = rt - (rt - lt) / (phi + 2);
		ll rsl = fl(l1), rsr = fl(r1);
		while (l1 < r1) {
			if (rsl > rsr) {
				lt = l1;
				rsl = rsr;
				l1 = r1;
				r1 = rt - (rt - lt) / (phi + 2);
				rsr = fl(r1);
			}
			else {
				rt = r1;
				r1 = l1;
				rsr = rsl;
				l1 = lt + (rt - lt) / (phi + 2);
				rsl = fl(l1);
			}
		}
		ll ml1 = lt, crs = fl(lt);
		for (ll xx = lt + 1; xx <= rt; ++xx) {
			ll cps;
			if (xx == l1) {
				cps = rsl;
			}
			else if (xx == r1) {
				cps = rsr;
			}
			else {
				cps = fl(xx);
			}
			if (cps < crs) {
				ml1 = xx;
				crs = cps;
			}
		}
		lt = 0, rt = 1e9 / d + 1;
		if (cl != 0) {
			rt = xl[cl - 1] / d + 1;
		}
		else {
			rt = 0;
		}
		l1 = lt + (rt - lt) / (phi + 2), r1 = rt - (rt - lt) / (phi + 2);
		rsl = fl1(l1), rsr = fl1(r1);
		while (l1 < r1) {
			if (rsl > rsr) {
				lt = l1;
				rsl = rsr;
				l1 = r1;
				r1 = rt - (rt - lt) / (phi + 2);
				rsr = fl1(r1);
			}
			else {
				rt = r1;
				r1 = l1;
				rsr = rsl;
				l1 = lt + (rt - lt) / (phi + 2);
				rsl = fl1(l1);
			}
		}
		ll ml2 = lt; crs = fl1(lt);
		for (ll xx = lt + 1; xx <= rt; ++xx) {
			ll cps;
			if (xx == l1) {
				cps = rsl;
			}
			else if (xx == r1) {
				cps = rsr;
			}
			else {
				cps = fl1(xx);
			}
			if (cps < crs) {
				ml2 = xx;
				crs = cps;
			}
		}
		lt = 0, rt = 1e9 / d + 1;
		if (cg != 0) {
			rt = xg[cg - 1] / d + 1;
		}
		else {
			rt = 0;
		}
		l1 = lt + (rt - lt) / (phi + 2), r1 = rt - (rt - lt) / (phi + 2);
		rsl = fg1(l1, ml1, ml2), rsr = fg1(r1, ml1, ml2);
		while (l1 < r1) {
			if (rsl > rsr) {
				lt = l1;
				rsl = rsr;
				l1 = r1;
				r1 = rt - (rt - lt) / (phi + 2);
				rsr = fg1(r1, ml1, ml2);
			}
			else {
				rt = r1;
				r1 = l1;
				rsr = rsl;
				l1 = lt + (rt - lt) / (phi + 2);
				rsl = fg1(l1, ml1, ml2);
			}
		}
		ll mnn = min(rsl, rsr);
		for (ll xx = lt; xx <= rt; ++xx) {
			if (xx == l1 || xx == r1) continue;
			mnn = min(mnn, fg1(xx, ml1, ml2));
		}
		cout << mnn << '\n';
	}

	return 0;
}
