#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

const int maxn = 3e5;
vector<int> g[maxn];
int ds[200][200], mt[200], us[200];
int n, d;
vector<int> a, b;
int ti = 1;

void dfs(int v, int f, int hg = 0, int p = -1) {
	ds[f][v] = hg;
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, f, hg + 1, v);
		}
	}
}

bool kuhn(int v) {
	if (us[v] == ti) return 0;
	us[v] = ti;
	for (int j = 0; j < b.size(); ++j) {
		if (ds[a[v]][b[j]] <= d && (mt[j] == -1 || kuhn(mt[j]))) {
			mt[j] = v;
			return 1;
		}
	}
	return 0;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	cin >> n >> d;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 0; i < n; ++i) {
		dfs(i, i);
	}
	for (int i = 0; i < n; ++i) {
		if (ds[0][i] % 2 == 0) {
			a.push_back(i);
		}
		else {
			b.push_back(i);
		}
	}
	fill(mt, mt + 200, -1);
	int cn = 0;
	for (int i = 0; i < a.size(); ++i) {
		cn += kuhn(i);
		++ti;
	}
	cout << cn << '\n';
	for (int i = 0; i < b.size(); ++i) {
		if (mt[i] != -1) {
			cout << b[i] + 1 << ' ' << a[mt[i]] + 1 << '\n';
		}
	}

	return 0;
}
