#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

const int maxn = 3e5;
vector<int> g[maxn];
vector<pair<int, int>> vc;
int d;

vector<vector<int>> dfs(int v, int p = -1) {
	vector<vector<int>> nw(d + 1);
	nw[0].push_back(v);
	for (auto u : g[v]) {
		if (u != p) {
			auto xt = dfs(u, v);
			for (int j = 0; j < d; ++j) {
				for (auto pt : xt[j]) {
					nw[j + 1].push_back(pt);
				}
			}
		}
	}
	for (int j = d; j >= 0; --j) {
		for (int k = d - j; k >= 0; k -= 2) {
			while (!nw[j].empty() && !nw[k].empty()) {
				vc.push_back({ nw[j].back(), nw[k].back() });
				nw[j].pop_back();
				nw[k].pop_back();
			}
		}
	}
	nw.pop_back();
	return nw;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n;
	cin >> n >> d;
	if (d % 2 == 0) --d;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0);
	cout << vc.size() << '\n' << -1;
	for (auto i : vc) {
		//cout << i.first + 1 << ' ' << i.second + 1 << '\n';
	}

	return 0;
}
