#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, d, logn = 20;
vector<int> c, tin, tout;
vector<vector<int>> g, up, sup;

int timer = 1;
void dfs(int v, int p, int col) {
    c[v] = col;
    tin[v] = timer++;
    up[0][v] = (p == -1 ? v : p);
    sup[0][v] = (p == -1 ? 0 : 1);
    for (int i = 1; i <= logn; ++i) {
        up[i][v] = up[i - 1][up[i - 1][v]];
        sup[i][v] = sup[i - 1][v] + sup[i - 1][up[i - 1][v]];
    }
    for (auto & u : g[v]) {
        if (u != p) {
            dfs(u, v, col^1);
        }
    }
    tout[v] = timer++;
}

bool anc(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int dist(int v, int u) {
    if (u == v) return 0;
    int ans = 0;
    for (int i = logn; i >= 0; --i) {
        if (!anc(up[i][v], u)) {
            ans += sup[i][v];
            v = up[i][v];
        }
    }
    for (int i = logn; i >= 0; --i) {
        if (!anc(up[i][u], v)) {
            ans += sup[i][u];
            u = up[i][u];
        }
    }
    if (anc(v, u)) return ans + 1;
    if (anc(u, v)) return ans + 1;
    return ans + 2;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> d;
    c.resize(n);
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    up.resize(logn + 1, vector<int>(n));
    sup.resize(logn + 1, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    dfs(0, -1, 0);
    vector<int> dp(1 << n), pr(1 << n);
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if ((mask & (1 << i)) != 0 && (mask & (1 << j)) != 0 && c[i] != c[j] && dist(i, j) <= d) {
                    int nmask = mask ^ (1 << i) ^ (1 << j);
                    if (dp[mask] < dp[nmask] + 1) {
                        dp[mask] = dp[nmask] + 1;
                        pr[mask] = nmask;
                    }
                }
            }
        }
    }
    int mask = 0;
    for (int i = 0; i < (1 << n); ++i) {
        if (dp[i] > dp[mask]) mask = i;
    }
    vector<pair<int, int>> ans;
    while (mask) {
        int r = mask ^ pr[mask];
        mask = pr[mask];
        vector<int> e;
        for (int i = 0; i < n; ++i) {
            if (r & (1 << i)) {
                e.push_back(i + 1);
            }
        }
        ans.push_back({e[0], e[1]});
    }
    cout << (int)ans.size() << "\n";
    for (auto & it : ans) {
        cout << it.first << " " << it.second << "\n";
    }
    return 0;
}
