#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int n, m;
vector<vector<bool>> field;
vector<vector<int>> len;

struct Node
{
    int cnt = 0, su = 0;
    Node operator+(const Node &other) const
    {
        return {cnt + other.cnt, su + other.su};
    }
};

struct Tree
{
    int sz;
    vector<Node> tree;
    vector<bool> delta;

    void push(int v, int l, int r)
    {
        if (!delta[v])
            return;
        tree[v] = {0, 0};
        if (l != r - 1)
        {
            delta[v * 2 + 1] = true;
            delta[v * 2 + 2] = true;
        }
        delta[v] = false;
    }

    void build(const int &_sz)
    {
        sz = _sz;
        tree.resize(sz * 4);
        delta.resize(sz * 4, 0);
    }

    void mod(int v, int l, int r, int i, int x)
    {
        push(v, l, r);
        if (l == r - 1)
        {
            assert(l == i);
            tree[v].cnt += x;
            tree[v].su += l * x;
            return;
        }
        int m = (l + r) / 2;
        if (i < m)
        {
            mod(v * 2 + 1, l, m, i, x);
        }
        else
        {
            mod(v * 2 + 2, m, r, i, x);
        }
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    void insert(const int &el, const int &cnt)
    {
        assert(el < sz);
        mod(0, 0, sz, el, cnt);
    }

    Node get(int v, int l, int r, int L, int R)
    {
        push(v, l, r);
        if (R <= l || r <= L)
            return {0, 0};
        if (L <= l && r <= R)
            return tree[v];
        int m = (l + r) / 2;
        return get(v * 2 + 1, l, m, L, R) + get(v * 2 + 2, m, r, L, R);
    }

    Node get(int L, int R)
    {
        return get(0, 0, sz, L, R);
    }

    void reset(int v, int l, int r, int L, int R)
    {
        push(v, l, r);
        if (R <= l || r <= L)
            return;
        if (L <= l && r <= R)
        {
            delta[v] = true;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        reset(v * 2 + 1, l, m, L, R);
        reset(v * 2 + 2, m, r, L, R);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    void reset(int L, int R)
    {
        reset(0, 0, sz, L, R);
    }
};

void solve()
{
    cin >> n >> m;

    field.resize(n, vector<bool>(m, false));
    len.resize(n, vector<int>(m, 0));

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char el;
            cin >> el;
            field[i][j] = el == '1';
        }
    }

    for (int j = 0; j < m; ++j)
    {
        if (field[0][j])
        {
            len[0][j] = 1;
        }
        for (int i = 1; i < n; ++i)
        {
            if (field[i][j])
            {
                len[i][j] = 1 + len[i - 1][j];
            }
            else
            {
                len[i][j] = 0;
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < n; ++i)
    {
        Tree tree;
        tree.build(n + 1);
        for (int j = m - 1; j >= 0; --j)
        {
            int x = len[i][j];
            auto greater = tree.get(x + 1, n + 1);
            tree.reset(x + 1, n + 1);
            tree.insert(x, greater.cnt + 1);

            auto total = tree.get(0, n + 1);
            ans = max(ans, total.su);
        }
    }

    cout << ans << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}