#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#else
// #pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

constexpr int MULT = 4000000;
int n, m;
bool field[MULT];
int len[MULT];

struct Node
{
    int cnt = 0, su = 0;
    Node operator+(const Node &other) const
    {
        return {cnt + other.cnt, su + other.su};
    }
};

constexpr int SZ = 4000010;
int sz;
Node tree[SZ];
bool delta[SZ];

void push(int v, int l, int r)
{
    if (!delta[v])
        return;
    tree[v] = {0, 0};
    if (l != r - 1)
    {
        delta[v * 2 + 1] = true;
        delta[v * 2 + 2] = true;
    }
    delta[v] = false;
}

void mod(int v, int l, int r, int i, int x)
{
    push(v, l, r);
    if (l == r - 1)
    {
        assert(l == i);
        tree[v].cnt += x;
        tree[v].su += i * x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m)
    {
        mod(v * 2 + 1, l, m, i, x);
        push(v * 2 + 2, m, r);
    }
    else
    {
        mod(v * 2 + 2, m, r, i, x);
        push(v * 2 + 1, l, m);
    }
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

void insert(const int &el, const int &cnt)
{
    assert(el < sz);
    assert(0 <= el);
    mod(0, 0, sz, el, cnt);
}

Node get(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R <= l || r <= L)
        return {0, 0};
    if (L <= l && r <= R)
    {
        auto res = tree[v];
        delta[v] = true;
        push(v, l, r);
        return res;
    }
    int m = (l + r) / 2;
    auto res = get(v * 2 + 1, l, m, L, R) + get(v * 2 + 2, m, r, L, R);
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    return res;
}

Node get(int L, int R)
{
    return get(0, 0, sz, L, R);
}

void reset(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R <= l || r <= L)
        return;
    if (L <= l && r <= R)
    {
        delta[v] = true;
        push(v, l, r);
        return;
    }
    int m = (l + r) / 2;
    reset(v * 2 + 1, l, m, L, R);
    reset(v * 2 + 2, m, r, L, R);
    tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

void reset(int L, int R)
{
    reset(0, 0, sz, L, R);
}

void solve()
{
    cin >> n >> m;

    bool sw = false;

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char el;
            cin >> el;
            field[i * m + j] = el == '1';
        }
    }

    int ans = 0;

    sz = n + 1;

    for (int i = 0; i < n; ++i)
    {
        delta[0] = true;
        for (int j = m - 1; j >= 0; --j)
        {
            if (i == 0)
            {
                len[j] = field[0 * m + j];
            }
            else
            {
                if (field[i * m + j])
                {
                    len[j] = len[j] + 1;
                }
                else
                {
                    len[j] = 0;
                }
            }
            int x = len[j];
            auto greater = get(x + 1, n + 1);
            insert(x, greater.cnt + 1);

            auto total = tree[0];
            ans = max(ans, total.su);
        }
    }

    cout << ans << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}