#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

constexpr int N = 500000;

int tree[N * 4]; // минимум
bool delta[N * 4];

void push(int v, int l, int r)
{
    if (!delta[v])
        return;
    tree[v] = INT_MAX;
    if (l != r - 1)
    {
        delta[v * 2 + 1] = true;
        delta[v * 2 + 2] = true;
    }
    delta[v] = false;
}

void mod(int v, int l, int r, int i, int x)
{
    push(v, l, r);
    if (l == r - 1)
    {
        tree[v] = min(tree[v], x);
        return;
    }
    int m = (l + r) / 2;
    if (i < m)
    {
        mod(v * 2 + 1, l, m, i, x);
        push(v * 2 + 2, m, r);
    }
    else
    {
        push(v * 2 + 1, l, m);
        mod(v * 2 + 2, m, r, i, x);
    }
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (R <= l || r <= L)
        return INT_MAX;
    if (L <= l && r <= R)
        return tree[v];
    int m = (l + r) / 2;
    return min(get(v * 2 + 1, l, m, L, R), get(v * 2 + 2, m, r, L, R));
}

struct Seg
{
    int l, r, m;

    tuple<int, int, int> gt() const
    {
        return make_tuple(m, l, r);
    }

    bool operator<(const Seg &other) const
    {
        return gt() < other.gt();
    }
};

void solve()
{
    delta[0] = true;

    int n, k;
    cin >> n >> k;
    vector<Seg> segs(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> segs[i].l >> segs[i].m >> segs[i].r;
    }
    sort(all(segs));

    // set<Seg> good;

    // good.insert({0, 0, 0});
    mod(0, 0, n + 1, 0, 0);

    bool ok = false;

    for (const auto seg : segs)
    {
        bool found = false;
        {
            // верхнее соединение
            // pr.r < seg.m
            // seg.l - 1 <= pr.r
            int res = get(0, 0, n + 1, seg.l - 1, seg.m);
            if (res != INT_MAX)
            {
                found = true;
            }
        }
        {
            // нижнее соединение
            // seg.m <= pr.r
            // pr.r < seg.r
            // pr.m < seg.l
            int res = get(0, 0, n + 1, seg.m, seg.r);
            if (res < seg.l)
            {
                found = true;
            }
        }
        // for (const auto &pr : good)
        // {
        //     if (pr.r < seg.m && pr.r >= seg.l - 1 && pr.r < seg.r)
        //     {
        //         // верхнее соединение
        //         found = true;
        //     }
        //     else if (seg.m - 1 < pr.r && pr.m < seg.l && pr.r < seg.r)
        //     {
        //         // нижнее соединение
        //         found = true;
        //     }

        //     if (found)
        //         break;
        // }

        if (found)
        {
            mod(0, 0, n + 1, seg.r, seg.m);
            // good.insert(seg);
            if (seg.r == n)
            {
                ok = true;
            }
        }
    }

    if (ok)
    {
        cout << "YES" << '\n';
    }
    else
    {
        cout << "NO" << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}