#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define i128 __int128
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;

using pii = pair<int, int>;

int read()
{
    ll el;
    cin >> el;
    return el;
}

vector<int> xall;

int ml;
vector<int> xl;
vector<int> xl_near;
vector<int> xl_val;
vector<i128> xl_sq; // сумма xl[i] * xl[i] на суффиксе
vector<int> xl_2x;  // сумма 2 * xr[i] на суффиксе

int mr;
vector<int> xr;
vector<int> xr_near;
vector<int> xr_val;
vector<i128> xr_sq;
vector<int> xr_2x;
int n, d, c;

int ab(int x)
{
    if (x < 0)
        return -1 * x;
    return x;
}

int nearest_left(int x) // возвращает ближайшую станцию
{
    int y = c - x;
    int delta = x - y;
    int k_less = y / d;
    int k_greater = (y + d - 1) / d;

    int p_less = c - k_less * d;
    int p_greater = c - k_greater * d;

    int dist_less = ab(x - p_less);
    int dist_greater = ab(x - p_greater);
    if (dist_less < dist_greater)
    {
        return p_less;
    }
    else
    {
        return p_greater;
    }
}

void build_left()
{
    ml = xl.size();
    if (ml == 0)
        return;
    sort(all(xl), std::greater<>());
    xl_near.resize(ml);
    xl_val.resize(ml);
    xl_sq.resize(ml);
    xl_2x.resize(ml);
    for (int i = 0; i < ml; ++i)
    {
        xl_near[i] = nearest_left(xl[i]);
        int dist = ab(xl_near[i] - xl[i]);
        xl_val[i] = dist * dist;
        if (i != 0)
            xl_val[i] += xl_val[i - 1];
    }
    xl_sq[ml - 1] = (i128)xl[ml - 1] * xl[ml - 1];
    xl_2x[ml - 1] = 2 * xl[ml - 1];
    for (int i = ml - 2; i >= 0; --i)
    {
        xl_sq[i] = (i128)xl[i] * xl[i] + xl_sq[i + 1];
        xl_2x[i] = 2 * xl[i] + xl_2x[i + 1];
    }
}

int get_left_val(int coord)
{
    if (coord <= xl_near[ml - 1])
    {
        // все элементы подходят
        return xl_val[ml - 1];
    }
    // ищем первый элемент, у которого оптимум левее coord
    int l = 0, r = ml - 1;
    while (l < r)
    {
        int m = (l + r) / 2;
        if (xl_near[m] < coord)
        {
            r = m;
        }
        else
        {
            l = m + 1;
        }
    }
    i128 res = 0;
    if (l > 0)
    {
        res += xl_val[l - 1];
    }
    int k = ml - l;
    i128 other = xl_sq[l] - (i128)xl_2x[l] * coord + (i128)coord * coord * k;
    res += other;
    return res;
}

int solve_left(int t)
{
    if (ml == 0)
        return 0;

    int count = (c - xl_near[ml - 1]) / d;
    int l = 0, r = count;
    while (l < r)
    {
        int m = (l + r) / 2;
        int m2 = m + 1;

        i128 val_m = get_left_val(c - m * d) + m * t;
        i128 val_m2 = get_left_val(c - m2 * d) + m2 * t;

        if (val_m2 <= val_m)
        {
            // делаем переход
            l = m + 1;
        }
        else
        {
            r = m;
        }
    }

    int ans = get_left_val(c - l * d) + l * t;
    return ans;
}

int nearest_right(int x)
{
    int y = x - c;
    int k_less = y / d;
    int k_greater = (y + d - 1) / d;

    int p_less = d * k_less + c;
    int p_greater = d * k_greater + c;

    int dist_less = ab(x - p_less);
    int dist_greater = ab(x - p_greater);
    if (dist_less <= dist_greater)
    {
        return p_less;
    }
    else
    {
        return p_greater;
    }
}

int get_right_val(int coord)
{
    if (xr_near[mr - 1] <= coord)
    {
        // все подходят
        return xr_val[mr - 1];
    }
    int l = 0, r = mr - 1;
    while (l < r)
    {
        int m = (l + r) / 2;
        if (coord < xr_near[m])
        {
            r = m;
        }
        else
        {
            l = m + 1;
        }
    }
    i128 res = 0;
    if (l > 0)
    {
        res += xr_val[l - 1];
    }
    assert(xr_near[l] > coord);
    int k = mr - l;
    i128 other = xr_sq[l] - (i128)xr_2x[l] * coord + (i128)coord * coord * k;
    res += other;
    return res;
}

void build_right()
{
    mr = xr.size();
    if (mr == 0)
        return;
    sort(all(xr));
    xr_near.resize(mr);
    xr_val.resize(mr);
    xr_sq.resize(mr);
    xr_2x.resize(mr);

    for (int i = 0; i < mr; ++i)
    {
        xr_near[i] = nearest_right(xr[i]);
        int dist = ab(xr[i] - xr_near[i]);
        xr_val[i] = dist * dist;
        if (i != 0)
            xr_val[i] += xr_val[i - 1];
    }

    xr_sq[mr - 1] = (i128)xr[mr - 1] * xr[mr - 1];
    xr_2x[mr - 1] = 2 * xr[mr - 1];

    for (int i = mr - 2; i >= 0; --i)
    {
        xr_sq[i] = (i128)xr[i] * xr[i] + xr_sq[i + 1];
        xr_2x[i] = 2 * xr[i] + xr_2x[i + 1];
    }
}

int solve_right(int t)
{
    if (mr == 0)
        return 0;

    int count = (xr_near[mr - 1] - c) / d;
    int l = 0, r = count;
    while (l < r)
    {
        int m = (l + r) / 2;
        int m2 = m + 1;

        i128 val_m = get_right_val(c + m * d) + m * t;
        i128 val_m2 = get_right_val(c + m2 * d) + m2 * t;

        if (val_m2 <= val_m)
        {
            l = m + 1;
        }
        else
        {
            r = m;
        }
    }
    int ans = get_right_val(c + l * d) + l * t;
    return ans;
}

void solve()
{
    n = read();
    xall.resize(n);
    for (int i = 0; i < n; ++i)
    {
        xall[i] = read();
    }

    c = read();
    d = read();
    for (const auto &el : xall)
    {
        if (el < c)
        {
            xl.push_back(el);
        }
        else if (c < el)
        {
            xr.push_back(el);
        }
    }

    build_left();
    build_right();

    int m;
    m = read();

    for (int tt = 0; tt < m; ++tt)
    {
        int t = read();
        i128 var1 = solve_left(t) + solve_right(2 * t);
        i128 var2 = solve_left(2 * t) + solve_right(t);
        i128 res = min(var1, var2);
        cout << (ll)res << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}