#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define int __int128
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;

using pii = pair<int, int>;

int read()
{
    ll el;
    cin >> el;
    return el;
}

vector<int> xall;

int ml;
vector<int> xl;
vector<int> xl_near;
vector<int> xl_sq; // сумма xl[i] * xl[i] на суффиксе
vector<int> xl_2x; // сумма 2 * xr[i] на суффиксе

int mr;
vector<int> xr;
vector<int> xr_near;
vector<int> xr_sq;
vector<int> xr_2x;
int n, d, c;

int ab(int x)
{
    if (x < 0)
        return -1 * x;
    return x;
}

int nearest_left(int x) // возвращает ближайшую станцию
{
    int y = c - x;
    int delta = x - y;
    int k_less = y / d;
    int k_greater = (y + d - 1) / d;

    int p_less = c - k_less * d;
    int p_greater = c - k_greater * d;

    int dist_less = ab(x - p_less);
    int dist_greater = ab(x - p_greater);
    if (dist_less < dist_greater)
    {
        return p_less;
    }
    else
    {
        return p_greater;
    }
}

void build_left()
{
    ml = xl.size();
    if (ml == 0)
        return;
    xl_near.resize(ml);
    xl_sq.resize(ml);
    xl_2x.resize(ml);
    for (int i = 0; i < ml; ++i)
    {
        xl_near[i] = nearest_left(xl[i]);
    }
    xl_sq[ml - 1] = xl[ml - 1] * xl[ml - 1];
    xl_2x[ml - 1] = 2 * xl[ml - 1];
    for (int i = ml - 2; i >= 0; --i)
    {
        xl_sq[i] = xl[i] * xl[i] + xl_sq[i + 1];
        xl_2x[i] = 2 * xl[i] + xl_2x[i + 1];
    }
}

int solve_left(int t)
{
    if (ml == 0)
        return 0;
    int p = 0;     // первый x, у котого оптимум дальше нас
    int coord = c; // наше положение
    int val = 0;   // сумма x, которые уже точно оптимальные
    int ans = -1;
    int moves = 0;
    while (p < ml)
    {
        while (p < ml && coord <= xl_near[p])
        {
            int dist = ab(xl[p] - xl_near[p]);
            val += dist * dist;
            ++p;
        }
        int current = val + moves * t; // значение в данное координате
        if (p < ml)
        {
            int k = ml - p;
            int others_su = xl_sq[p] - xl_2x[p] * coord + coord * coord * k;
            current += others_su;
        }
        if (ans == -1 || current < ans)
        {
            ans = current;
        }
        coord -= d;
        ++moves;
    }
    return ans;
}

int nearest_right(int x)
{
    int y = x - c;
    int k_less = y / d;
    int k_greater = (y + d - 1) / d;

    int p_less = d * k_less + c;
    int p_greater = d * k_greater + c;

    int dist_less = ab(x - p_less);
    int dist_greater = ab(x - p_greater);
    if (dist_less <= dist_greater)
    {
        return p_less;
    }
    else
    {
        return p_greater;
    }
}

void build_right()
{
    mr = xr.size();
    if (mr == 0)
        return;
    xr_near.resize(mr);
    xr_sq.resize(mr);
    xr_2x.resize(mr);

    for (int i = 0; i < mr; ++i)
    {
        xr_near[i] = nearest_right(xr[i]);
    }

    xr_sq[mr - 1] = xr[mr - 1] * xr[mr - 1];
    xr_2x[mr - 1] = 2 * xr[mr - 1];

    for (int i = mr - 2; i >= 0; --i)
    {
        xr_sq[i] = xr[i] * xr[i] + xr_sq[i + 1];
        xr_2x[i] = 2 * xr[i] + xr_2x[i + 1];
    }
}

int solve_right(int t)
{
    if (mr == 0)
        return 0;
    int p = 0; // первый x, оптимум которого находится правее нас
    int coord = c;
    int val = 0;
    int moves = 0;
    int ans = -1;

    while (p < mr)
    {
        while (p < mr && xr_near[p] <= coord)
        {
            int dist = ab(xr[p] - xr_near[p]);
            val += dist * dist;
            ++p;
        }
        int current = val + moves * t;
        if (p < mr)
        {
            int k = mr - p;
            int others = xr_sq[p] - xr_2x[p] * coord + (coord * coord) * k;
            current += others;
        }
        if (ans == -1 || current < ans)
        {
            ans = current;
        }
        coord += d;
        moves++;
    }
    return ans;
}

void solve()
{
    n = read();
    xall.resize(n);
    for (int i = 0; i < n; ++i)
    {
        xall[i] = read();
    }
    sort(all(xl), std::greater<>());
    sort(all(xr));

    c = read();
    d = read();
    for (const auto &el : xall)
    {
        if (el <= c)
        {
            xl.push_back(el);
        }
        else
        {
            xr.push_back(el);
        }
    }

    build_left();
    build_right();

    int m;
    m = read();

    for (int tt = 0; tt < m; ++tt)
    {
        int t = read();
        int var1 = solve_left(t) + solve_right(2 * t);
        int var2 = solve_left(2 * t) + solve_right(t);
        int res = min(var1, var2);
        cout << (ll)res << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}