#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define int __int128
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;

using pii = pair<int, int>;

int read()
{
    ll el;
    cin >> el;
    return el;
}

vector<int> xall;

int ml;
vector<int> xl;
vector<int> xl_near;
vector<int> xl_sq; // сумма xl[i] * xl[i] на суффиксе
vector<int> xl_2x; // сумма 2 * xr[i] на суффиксе

int mr;
vector<int> xr;
vector<int> xr_near;
vector<int> xr_sq;
vector<int> xr_2x;
int n, d, c;

int ab(int x)
{
    if (x < 0)
        return -1 * x;
    return x;
}

int nearest_left(int x) // возвращает ближайшую станцию
{
    int y = c - x;
    int delta = x - y;
    int k_less = y / d;
    int k_greater = (y + d - 1) / d;

    int p_less = c - k_less * d;
    int p_greater = c - k_greater * d;

    int dist_less = ab(x - p_less);
    int dist_greater = ab(x - p_greater);
    if (dist_less < dist_greater)
    {
        return p_less;
    }
    else
    {
        return p_greater;
    }
}

void build_left()
{
    ml = xl.size();
    if (ml == 0)
        return;
    sort(all(xl), std::greater<>());
    xl_near.resize(ml);
    xl_sq.resize(ml);
    xl_2x.resize(ml);
    for (int i = 0; i < ml; ++i)
    {
        xl_near[i] = nearest_left(xl[i]);
    }
    xl_sq[ml - 1] = xl[ml - 1] * xl[ml - 1];
    xl_2x[ml - 1] = 2 * xl[ml - 1];
    for (int i = ml - 2; i >= 0; --i)
    {
        xl_sq[i] = xl[i] * xl[i] + xl_sq[i + 1];
        xl_2x[i] = 2 * xl[i] + xl_2x[i + 1];
    }
}

int solve_left(int t)
{
    if (ml == 0)
        return 0;

    auto get_val = [&](int moves)
    {
        int res = moves * t;
        int coord = c - moves * d;
        int dist = ab(xl[0] - coord);
        res += dist * dist;
        return res;
    };

    int count = (c - xl_near[0]) / d;
    int l = 0, r = count;
    while (l < r)
    {
        int m = (l + r) / 2;
        int m2 = m + 1;

        int val_m = get_val(m);
        int val_m2 = get_val(m2);

        if (val_m2 < val_m)
        {
            // делаем переход
            l = m + 1;
        }
        else
        {
            r = m;
        }
    }

    int ans = get_val(l);
    return ans;
}

int nearest_right(int x)
{
    int y = x - c;
    int k_less = y / d;
    int k_greater = (y + d - 1) / d;

    int p_less = d * k_less + c;
    int p_greater = d * k_greater + c;

    int dist_less = ab(x - p_less);
    int dist_greater = ab(x - p_greater);
    if (dist_less <= dist_greater)
    {
        return p_less;
    }
    else
    {
        return p_greater;
    }
}

void build_right()
{
    mr = xr.size();
    if (mr == 0)
        return;
    sort(all(xr));
    xr_near.resize(mr);
    xr_sq.resize(mr);
    xr_2x.resize(mr);

    for (int i = 0; i < mr; ++i)
    {
        xr_near[i] = nearest_right(xr[i]);
    }

    xr_sq[mr - 1] = xr[mr - 1] * xr[mr - 1];
    xr_2x[mr - 1] = 2 * xr[mr - 1];

    for (int i = mr - 2; i >= 0; --i)
    {
        xr_sq[i] = xr[i] * xr[i] + xr_sq[i + 1];
        xr_2x[i] = 2 * xr[i] + xr_2x[i + 1];
    }
}

int solve_right(int t)
{
    if (mr == 0)
        return 0;

    auto get_val = [&](int moves)
    {
        int res = moves * t;
        int coord = c + moves * d;
        int dist = ab(xr[0] - coord);
        res += dist * dist;
        return res;
    };

    int count = (xr_near[0] - c) / d;
    int l = 0, r = count;
    while (l < r)
    {
        int m = (l + r) / 2;
        int m2 = m + 1;

        int val_m = get_val(m);
        int val_m2 = get_val(m2);

        if (val_m2 < val_m)
        {
            l = m + 1;
        }
        else
        {
            r = m;
        }
    }
    int ans = get_val(l);
    return ans;
}

void solve()
{
    n = read();
    xall.resize(n);
    for (int i = 0; i < n; ++i)
    {
        xall[i] = read();
    }

    c = read();
    d = read();
    for (const auto &el : xall)
    {
        if (el < c)
        {
            xl.push_back(el);
        }
        else if (c < el)
        {
            xr.push_back(el);
        }
    }

    build_left();
    build_right();

    int m;
    m = read();

    int res = 0;

    for (int i = 0; i < ml; ++i)
    {
        int dist = ab(xl[i] - xl_near[i]);
        res += dist * dist;
    }

    for (int i = 0; i < mr; ++i)
    {
        int dist = ab(xr[i] - xr_near[i]);
        res += dist * dist;
    }

    for (int tt = 0; tt < m; ++tt)
    {
        int t = read();
        // int var1 = solve_left(t) + solve_right(2 * t);
        // int var2 = solve_left(2 * t) + solve_right(t);
        // int res = min(var1, var2);
        cout << (ll)res << '\n';
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}