#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <experimental/random>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using str = string;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
}

struct seg_tree {
    int siz;
    vector<int> t;

    seg_tree(int sizee) {
        siz = sizee;
        t.resize(4 * siz + 5, INF);
    }

    void add(int v,int l,int r,int pos,int x) {
        if (r - l == 1) {
            t[v] = min(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (pos >= m) {
            add(2 * v + 1, m, r, pos, x);
        } else {
            add(2 * v, l, m, pos, x);
        }
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    void add(int pos,int x) {
        add(1, 0, siz, pos, x);
    }

    int get(int v,int l,int r,int ql,int qr) {
        if (l == ql && qr == r) {
            return t[v];
        }
        int qm = (ql + qr) / 2;
        if (r <= qm) {
            return get(2 * v, l, r, ql, qm);
        } else if (l >= qm) {
            return get(2 * v + 1, l, r, qm, qr);
        } else {
            return min(get(2 * v, l, qm, ql, qm), get(2 * v + 1, qm, r, qm, qr));
        }
    }

    int get(int l,int r) {
        return get(1, l, r, 0, siz);
    }
};

struct f {
    int l, m, r;
};

bool cmp(f &e1, f &e2) {
    return e1.r < e2.r;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<f> q(k);
    auto seg = seg_tree(n + 1);
    for (int i = 0; i < k; ++i) {
        cin >> q[i].l >> q[i].m >> q[i].r;
    }
    seg.add(0, 0);
    sort(q.begin(), q.end(), cmp);
    for (int i = 0; i < k; ++i) {
        int l = q[i].l;
        int m = q[i].m;
        int r = q[i].r;
        int ans = INF;
        if (m > l) {
            if (seg.get(l - 1, m) != INF) {
                ans = m;
            }
        }
        if (r > m) {
            if (seg.get(m, r) < l) {
                ans = m;
            }
        }
        seg.add(r, ans);
    }
    if (seg.get(n, n + 1) != INF) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
