#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;

const int INF = 1e9;
vector<vector<int>> g;
vector<pair<int, int>> ans;
deque<int> par;

void dfs(int u, int p)
{
    par.push_back(u);
    for (int v : g[u])
    {
        if (v == p)
            continue;
        dfs(v, u);
    }
    if(par.size() && par.back() == u)
        par.pop_back();
    if(par.size()){
        ans.push_back({par.back(), u});
        par.pop_back();
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    for (int i = 1; i < n; i++)
    {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1);
    cout << ans.size() << '\n';
    for (auto [a, b] : ans)
        cout << a + 1 << ' ' << b + 1 << '\n';
}