#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> tree1, tree2, ph;

void push(int n, int l, int r) {
    if (ph[n] == -1) return;

    tree1[n] = ph[n];
    tree2[n] = ph[n] * (r - l);

    if (r - l > 1) {
        ph[2 * n + 1] = ph[2 * n + 2] = ph[n];
    }

    ph[n] = -1;
}

void update(int n, int l, int r, int ql, int qr, int val) {
    push(n, l, r);

    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        ph[n] = val;
        push(n, l, r);
        return;
    }

    int m = (l + r) / 2;
    update(2 * n + 1, l, m, ql, qr, val);
    update(2 * n + 2, m, r, ql, qr, val);

    tree2[n] = tree2[2 * n + 1] + tree2[2 * n + 2];
    tree1[n] = max(tree1[2 * n + 1], tree1[2 * n + 2]);
}

int query(int n, int l, int r, int val) {
    push(n, l, r);

    if (r - l == 1) return l;

    int m = (l + r) / 2;
        if (tree1[2 * n + 1] < val) {
            return query(2 * n + 2, m, r, val);
        }

        return query(2 * n + 1, l, m, val);
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m; cin >> n >> m;

    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int ans = 0;

    vector<vector<int>> cnt(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] == '0') {
                cnt[i][j] = 0;
            } else {
                cnt[i][j] = 1;

                if (j < m - 1) {
                    cnt[i][j] += cnt[i][j + 1];
                }
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        tree1.assign(4 * n, 2e9);
        tree2.assign(4 * n, 0);
        ph.assign(4 * n, -1);

        for (int j = 0; j < n; ++j) {
            int x = query(0, 0, n, cnt[j][i]);

            x = min(x, j);
            if (x == -1) {
                x = j;
            }

            update(0, 0, n, x, j + 1, cnt[j][i]);

            ans = max(ans, tree2[0]);
        }
    }

    cout << ans;
}