#include <bits/stdc++.h>
#define int long long

using namespace std;

struct zxc {
    int l, m, r;
};

struct tr {
    vector<bool> tree;

    void init(int n) {
        tree.assign(4 * n, false);
    }

    bool query(int n, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return false;
        if (ql <= l && r <= qr) return tree[n];

        int m = (l + r) / 2;
        return query(2 * n + 1, l, m, ql, qr) | query(2 * n + 2, m, r, ql, qr);
    }

    void update(int n, int l, int r, int ql) {
        if (ql >= r || l > ql) return;
        if (r - l == 1) {
            tree[n] = true;
            return;
        }

        int m = (l + r) / 2;
        update(2 * n + 1, l, m, ql);
        update(2 * n + 2, m, r, ql);

        tree[n] = tree[2 * n + 1] | tree[2 * n + 2];
    }
};

void solve() {
    int n, k; cin >> n >> k;

    vector<zxc> a(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r; cin >> l >> r >> m;
        a[i] = {l, r, m};
    }

    a.push_back({0, 0, 0});

    sort(a.begin(), a.end(), [](zxc a, zxc b) {
        if (a.r == b.r) return a.l < b.l;

        return a.r < b.r;
    });

    vector<bool> dp(k + 1, false);
    dp[0] = true;

    tr tr1; tr1.init(n + 2);
    tr1.update(0, 0, n + 2, 0);

    for (int i = 1; i <= k; ++i) {
        dp[i] = tr1.query(0, 0, n + 2, a[i].l - 1, a[i].m);

        if (!dp[i]) {
            for (int j = 0; j < i; ++j) {
                if (a[i].l > a[j].r + 1 || !dp[j]) continue;

                bool f2 = true;
                if (a[i].l <= a[j].m && a[i].r >= a[j].m) f2 = false;

                if (f2) {
                    dp[i] = true;
                    break;
                }
            }
        }

        if (dp[i]) {
            if (a[i].r == n) {
                cout << "YES";
                return;
            }

            tr1.update(0, 0, n + 2, a[i].r);
        }
    }

    cout << "NO";
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt; cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
}