#include <bits/stdc++.h>

using namespace std;

const int B = 18;
int d;
vector<int> color;
vector<vector<int>> g;

void dfs_col(int idx, int col) {
    color[idx] = col;

    col = 2 - (col + 1) % 2;
    for (int to : g[idx]) {
        if (!color[to]) {
            dfs_col(to, col);
        }
    }
}

vector<int> dep, pr;

void dfs_dep(int idx) {
    for (int to : g[idx]) {
        if (dep[to] == -1) {
            pr[to] = idx;
            dep[to] = dep[idx] + 1;
            dfs_dep(to);
        }
    }
}

vector<vector<int>> up;

int lca(int x, int y) {
    if (dep[x] < dep[y]) swap(x, y);

    int i = B - 1;
    while (dep[x] != dep[y]) {
        if (dep[up[i][x]] >= dep[y]) {
            x = up[i][x];
        }

        --i;
    }

    if (x == y) return x;

    i = B - 1;
    while (pr[x] != pr[y]) {
        if (up[i][x] != up[i][y]) {
            x = up[i][x];
            y = up[i][y];
        }

        --i;
    }

    return pr[x];
}

bool dist(int x, int y) {
    int val = lca(x, y);

    val = dep[x] + dep[y] - 2 * dep[val];

    return val <= d;
}

vector<int> p, used, v1, v2;

int dfs(int idx, int col) {
    if (used[idx] == col) return 0;

    used[idx] = col;
    vector<int> can;
    for (int to : v2) {
        if (dist(to, idx)) {
            can.push_back(to);

            if (p[to] == -1) {
                p[to] = idx;
                return 1;
            }
        }
    }

    random_shuffle(can.begin(), can.end());
    for (int to : can) {
        if (dfs(p[to], col)) {
            p[to] = idx;
            return 1;
        }
    }

    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n >> d;

    color.assign(n + 1, 0), g.assign(n + 1, {});
    for (int i = 1; i < n; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs_col(1, 1);

    for (int i = 1; i <= n; ++i) {
        if (color[i] % 2) {
            v1.push_back(i);
        } else {
            v2.push_back(i);
        }
    }

    if (v1.size() > v2.size()) swap(v1, v2);

    dep.assign(n + 1, -1), pr.assign(n + 1, 0);
    dfs_dep(1);

    int mx = 1;
    for (int i = 2; i <= n; ++i) {
        if (dep[mx] < dep[i]) mx = i;
    }

    dep.assign(n + 1, -1);
    dfs_dep(mx);

    mx = 0;
    for (int i = 1; i <=  n; ++i) {
        if (dep[i] > mx) mx = dep[i];
    }

    dep.assign(n + 1, -1);
    dfs_dep(1);

    up.assign(B, vector<int>(n + 1, 0));
    up[0] = pr;

    for (int i = 1; i < B; ++i) {
        for (int j = 1; j <= n; ++j) {
            up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }

    if (d >= mx) {
        cout << min(v1.size(), v2.size()) << "\n";
        for (int i = 0; i < min(v1.size(), v2.size()); ++i) {
            cout << v1[i] << ' ' << v2[i] << "\n";
        }

        return 0;
    }

    random_shuffle(v1.begin(), v1.end());
    random_shuffle(v2.begin(), v2.end());

    p.assign(n + 1, -1), used.assign(n + 1, 0);

    int ans = 0;
    for (int i : v1) {
        ans += dfs(i, i);
    }

    cout << ans << "\n";
    for (int i = 1; i <= n; ++i) {
        if (p[i] != -1) {
            cout << p[i] << ' ' << i << "\n";
        }
    }
}