#include <bits/stdc++.h>

using namespace std;

int d;
vector<int> color;
vector<vector<int>> g;

void dfs_col(int idx, int col) {
    color[idx] = col;

    col = 2 - (col + 1) % 2;
    for (int to : g[idx]) {
        if (!color[to]) {
            dfs_col(to, col);
        }
    }
}

vector<int> p, used;
vector<vector<int>> vert;

int dfs(int idx, int col) {
    if (used[idx] == col) return 0;

    used[idx] = col;
    for (int to : vert[idx]) {
        if (p[to] == -1) {
            p[to] = idx;
            return 1;
        }
    }

    for (int to : vert[idx]) {
        if (dfs(p[to], col)) {
            p[to] = idx;
            return 1;
        }
    }

    return 0;
}

vector<int> dist;

void dfs_dist(int idx, int col) {
    used[idx] = col;

    if (dist[idx] % 2) {
        vert[col].push_back(idx);
    }

    if (dist[idx] >= d) return;

    for (int to : g[idx]) {
        if (used[to] != col) {
            dist[to] = dist[idx] + 1;
            dfs_dist(to, col);
        }
    }
}

vector<int> dep;

void dfs_dep(int idx) {
    for (int to : g[idx]) {
        if (dep[to] == -1) {
            dep[to] = dep[idx] + 1;
            dfs_dep(to);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n; cin >> n >> d;

    color.assign(n + 1, 0), g.assign(n + 1, {});
    for (int i = 1; i < n; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs_col(1, 1);

    vector<int> v1, v2;

    for (int i = 1; i <= n; ++i) {
        if (color[i] % 2) {
            v1.push_back(i);
        } else {
            v2.push_back(i);
        }
    }

    dep.assign(n + 1, -1);
    dfs_dep(1);

    int mx = 1;
    for (int i = 2; i <= n; ++i) {
        if (dep[mx] < dep[i]) mx = i;
    }

    dep.assign(n + 1, -1);
    dfs_dep(mx);

    mx = 0;
    for (int i = 1; i <=  n; ++i) {
        if (dep[i] > mx) mx = dep[i];
    }

    if (d >= mx) {
        cout << min(v1.size(), v2.size()) << "\n";
        for (int i = 0; i < min(v1.size(), v2.size()); ++i) {
            cout << v1[i] << ' ' << v2[i] << "\n";
        }

        return 0;
    }

    if (v1.size() > v2.size()) swap(v1, v2);

    p.assign(n + 1, -1), used.assign(n + 1, 0);
    vert.assign(n + 1, {});

    dist.assign(n + 1, 2e9);
    for (int idx : v1) {
        dist[idx] = 0;

        dfs_dist(idx, idx);
    }

    used.assign(n + 1, 0);

    int ans = 0;
    for (int i : v1) {
        ans += dfs(i, ans + 1);
    }

    cout << ans << "\n";
    for (int i = 1; i <= n; ++i) {
        if (p[i] != -1) {
            cout << p[i] << ' ' << i << "\n";
        }
    }
}