#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> color;
vector<vector<int>> g;

void dfs_col(int idx, int col) {
    color[idx] = col;

    col = 2 - (col + 1) % 2;
    for (int to : g[idx]) {
        if (!color[to]) {
            dfs_col(to, col);
        }
    }
}

vector<int> p, used;
vector<vector<int>> vert;

int dfs(int idx, int col) {
    if (used[idx] == col) return 0;

    used[idx] = col;
    for (int to : vert[idx]) {
        if (p[to] == -1) {
            p[to] = idx;
            return 1;
        }
    }

    for (int to : vert[idx]) {
        if (dfs(p[to], col)) {
            p[to] = idx;
            return 1;
        }
    }

    return 0;
}

vector<int> dist;

void dfs(int idx) {
    for (int to : g[idx]) {
        if (dist[to] == 2e9) {
            dist[to] = dist[idx] + 1;
            dfs(to);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, d; cin >> n >> d;

    color.assign(n + 1, 0), g.assign(n + 1, {});
    for (int i = 1; i < n; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs_col(1, 1);

    vector<int> v1, v2;

    for (int i = 1; i <= n; ++i) {
        if (color[i] % 2) {
            v1.push_back(i);
        } else {
            v2.push_back(i);
        }
    }

    if (d == n - 1) {
        cout << min(v1.size(), v2.size()) << "\n";
        for (int i = 0; i < min(v1.size(), v2.size()); ++i) {
            cout << v1[i] << ' ' << v2[i] << "\n";
        }

        return 0;
    }

    p.assign(n + 1, -1), used.assign(n + 1, 0);
    vert.assign(n + 1, {});

    for (int idx : v1) {
        dist.assign(n + 1, 2e9);
        dist[idx] = 0;

        dfs(idx);

        for (int i = 1; i <= n; ++i) {
            if (color[idx] != color[i] && dist[i] <= d) {
                vert[idx].push_back(i);
            }
        }
    }

    int ans = 0;
    for (int i : v1) {
        ans += dfs(i, i);
    }

    cout << ans << "\n";
    for (int i = 1; i <= n; ++i) {
        if (p[i] != -1) {
            cout << p[i] << ' ' << i << "\n";
        }
    }
}