#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

vector<vector<int>> g;
vector<int> used;
bool ok = true;

void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u] == 1) {
			ok = false;
		}
		if (used[u] == 0) {
			dfs(u);
		}
	}
	used[v] = 2;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int gh = 0; gh < t; gh++) {
		int n, k;
		cin >> n >> k;
		vector<tuple<int, int, int>> v(k);
		g.assign(k, {});
		ok = true;
		for (int i = 0; i < k; i++) {
			int l, m, r;
			cin >> l >> m >> r;
			v[i] = { l, m, r };
		}
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < k; j++) {
				if (i == j) {
					continue;
				}
				auto [l1, m1, r1] = v[i];
				auto [l2, m2, r2] = v[j];
				if (l2 <= m1 && m1 <= r2) {
					g[i].push_back(j);
				}
				if (l1 <= m2 && m2 <= r1) {
					g[j].push_back(i);
				}
			}
		}
		used.assign(k, 0);
		for (int i = 0; i < k; i++) {
			if (used[i] == 0) {
				dfs(i);
			}
		}
		if (!ok) {
			cout << "NO" << '\n';
			continue;
		}
		vector<pair<int, int>> e;
		for (auto [l, m, r] : v) {
			e.push_back({ l,r });
		}
		sort(e.begin(), e.end());
		int lastpl = 0;
		for (auto [l, r] : e) {
			if (l <= lastpl + 1) {
				lastpl = max(lastpl, r);
			}
			else {
				ok = false;
				break;
			}
		}
		if (!ok) {
			cout << "NO" << '\n';
		}
		else {
			cout << "YES" << '\n';
		}
	}
}