#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>

using namespace std;

vector<vector<int>> g;
vector<int> used;
bool ok = false;
vector<vector<int>> rg;
vector<int> topsort;
vector<vector<int>> comps;
vector<tuple<int, int, int>> v;

void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u] == 1) {
			ok = false;
		}
		if (used[u] == 0) {
			dfs(u);
		}
	}
	used[v] = 2;
}

void maketopsort(int v) {
	used[v] = 1;
	topsort.push_back(v);
	for (auto u : g[v]) {
		if (!used[u]) {
			maketopsort(u);
		}
	}
}

void makecomp(int v) {
	used[v] = comps.size() - 1;
	comps.back().push_back(v);
	for (auto u : rg[v]) {
		if (used[u] == -1) {
			makecomp(u);
		}
	}
}

int n;
vector<int> use;

void rec(int c) {
	if (ok) {
		return;
	}
	if (c == comps.size()) {
		vector<pair<int, int>> e = {};
		for (auto i : use) {
			auto [l, m, r] = v[i];
			e.push_back({ l,r });
		}
		bool okok = true;
		sort(e.begin(), e.end());
		int lastpl = 0;
		for (auto [l, r] : e) {
			if (l <= lastpl + 1) {
				lastpl = max(lastpl, r);
			}
			else {
				okok = false;
				break;
			}
		}
		if (lastpl == n && okok) {
			ok = true;
		}
	}
	else {
		for (auto nom : comps[c]) {
			if (ok) {
				return;
			}
			use.push_back(nom);
			rec(c + 1);
			use.pop_back();
			if (ok) {
				return;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int gh = 0; gh < t; gh++) {
		int k;
		cin >> n >> k;
		v.assign(k, {});
		g.assign(k, {});
		rg.assign(k, {});
		ok = false;
		topsort = {};
		comps = {};
		for (int i = 0; i < k; i++) {
			int l, m, r;
			cin >> l >> m >> r;
			v[i] = { l, m, r };
		}
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < k; j++) {
				if (i == j) {
					continue;
				}
				auto [l1, m1, r1] = v[i];
				auto [l2, m2, r2] = v[j];
				if (l2 <= m1 && m1 <= r2) {
					g[i].push_back(j);
					rg[j].push_back(i);
				}
				if (l1 <= m2 && m2 <= r1) {
					g[j].push_back(i);
					rg[i].push_back(j);
				}
			}
		}
		used.assign(k, 0);
		for (int i = 0; i < k; i++) {
			if (used[i] == 0) {
				maketopsort(i);
			}
		}
		reverse(topsort.begin(), topsort.end());
		used.assign(k, -1);
		for (auto v : topsort) {
			if (used[v] == -1) {
				comps.push_back({});
				makecomp(v);
			}
		}
		rec(0);
		if (!ok) {
			cout << "NO" << '\n';
		}
		else {
			cout << "YES" << '\n';
		}
	}
}