#pragma GCC optimize("O3,unroll-loops")
#include<bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout<<#x<<" = "<<x<<endl;
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

struct S {
    int l = 0, m = 0, r = 0;
    S(int l, int m, int r):  l(l), m(m), r(r) {
    }

    S() = default;
};

struct SegTree {
    int n;
    vector<int> t;

    int get(int i, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return n;
        if (ql <= l && r <= qr) return t[i];

        int mid = (l + r) / 2;
        return min(get(i * 2 + 1, l, mid, ql, qr), get(i * 2 + 2, mid, r, ql, qr));
    } 

    void set(int i, int l, int r, int q, int x) {
        if (q < l || r <= q) return;
        if (l + 1 == r) {
            t[i] = x;
            return;
        }

        int mid = (l + r) / 2;
        set(i * 2 + 1, l, mid, q, x);
        set(i * 2 + 2, mid, r, q, x);
        t[i] = min(t[i * 2 + 1], t[i * 2 + 2]);
    }

    SegTree(int n_): n(n_) {
        t.assign(n_ * 4 + 10, n);
    }

    void set(int i, int x) {
        set(0, 0, n, i, x);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<S> a(k);

    vector<vector<pair<int, int>>> v(n);

    vector<vector<pair<int, int>>> e(n + 1);

    for (int i = 0; i < k; ++i) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--; 

        v[a[i].m].push_back({a[i].l, a[i].r});
        e[a[i].r].push_back({a[i].l, a[i].m});
    }

    for (int i = 0; i < n; ++i) {
        sort(all(e[i]), [](pair<int, int> a, pair<int, int> b) {
            return a.second < b.second;
        });
    }

    vector<int> dp(n + 1, n);
    SegTree st(n + 1);
    st.set(0, -1);
    dp[0] = -1;

    for (int i = 0; i < n; ++i) {
        for (auto [l, m] : e[i + 1]) {
            int hl = st.get(l, m + 1);
            int hr = st.get(m + 1, i + 1);

            debug(hl << " " << hr);

            debug(m);

            if (hl < n || hr < l) {
                dp[i + 1] = m;
                st.set(i + 1, m);
                break;
            }
        }
    }

    $(
        for (int i : dp) {
            cout << int(i) << ' ';
        }
        cout << endl;
    )

    if (dp[n] < n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;

    for (int i = 0; i < t; ++i) {
        solve();
    }
}