#include <bits/stdc++.h>

using namespace std;

struct Segtree {
    vector<int> t;
    int st = 1;
    void init(int n) {
        while (st <= n) st <<= 1;
        t.resize(2 * st, n);
        t[st] = 0;
        for (int i = st - 1; i > 0; i--) t[i] = min(t[i * 2], t[i * 2 + 1]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr or ql >= r) return 1e9;
        if (l >= ql and r <= qr) return t[v];
        int m = (r + l) / 2;
        return min(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
    }

    void up(int v, int x) {
        v += st;
        t[v] = min(t[v], x);
        while (v > 0) {
            v /= 2;
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    int f(int l, int r) {
        return get(1, 0, st, l, r + 1);
    }
};

bool cmp(tuple<int, int, int> a, tuple<int, int, int> b) {
    return get<2>(a) < get<2>(b);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int abab = 0; abab < t; abab++) {
        int n, k;
        cin >> n >> k;
        vector<tuple<int, int, int>> a(k);
        for (int i = 0; i < k; i++) {
            int l, r, m;
            cin >> l >> m >> r;
            a[i] = {l, m, r};
        }
        sort(a.begin(), a.end(), cmp);
        Segtree tree;
        tree.init(n + 1);
        for (auto [l, m, r] : a) {
            if (tree.f(l - 1, m - 1) < n + 1) {
                tree.up(r, m);
            }
            if (tree.f(l - 1, n) < l) {
                tree.up(r, m);
            }
        }
        if (tree.f(n, n) == n + 1) cout << "NO" << '\n';
        else cout << "YES" << '\n';
    }
}