#include <bits/stdc++.h>
using namespace std;
using ll = long long;
# define ff first
# define ss second
# define all(a) (a).begin(), (a).end()
# define rall(a) (a).rbegin(), (a).rend()
# define pb push_back
using ld = long double;

const ll inf = 1e15;
const string YES = "YES\n";
const string NO = "NO\n";

struct Fenwick {
    ll n;
    vector<ll> t;

    Fenwick(ll n) {
        this->n = n;
        t.resize(n + 1);
    }

    ll f(ll x) {
        return x & -x;
    }

    void upd(ll pos, ll val) {
        for (; pos <= n; pos += f(pos)) t[pos] += val;
    }

    ll sum(ll pos) {
        ll ans = 0;
        for (; pos; pos -= f(pos)) ans += t[pos];
        return ans;
    }
    
    ll sum(ll l, ll r) {
        if (l <= 1) return sum(r);
        return sum(r) - sum(l - 1);
    }
};

void Solve() {
    ll n, k;
    cin >> n >> k;
    vector<vector<pair<ll, ll>>> a(n + 1);
    vector<ll> can(n + 1);
    vector<ll> can2(n + 1);
    Fenwick t(n), t2(n);
    vector<ll> pon(n + 1, true);
    vector<ll> pon2(n + 1, true);
    for (ll i = 0; i < k; ++i) {
        ll l, m, r;
        cin >> l >> m >> r;
        a[m].pb({l, r});
    }
    for (ll i = 1; i <= n; ++i) {
        for (auto &x : a[i]) {
            if (x.ff == 1 || can[x.ff - 1] || t.sum(x.ff, i - 1) > 0) {
                can[x.ss] = 1;
                if (i != x.ss) {
                    pon[x.ss] = false;
                    t.upd(x.ss, 1);
                    t.upd(i, -1);
                }
            }
        }
    }
     for (ll i = n; i > 0; --i) {
        for (auto &x : a[i]) {
            if (x.ss == n || can2[x.ss + 1] || t2.sum(i + 1, x.ss) > 0) {
                can2[x.ff] = 1;
                if (x.ff != i) {
                    pon[x.ff] = false;
                    t2.upd(i, -1);
                    t2.upd(x.ff, 1);
                }
            }
        }
    }   
    if (can[n] || can2[1]) {
        cout << YES;
        return;
    }
    for (ll i = 1; i < n; ++i) {
        if (can[i] && (can2[i + 1] || t2.sum(1, i))) {
            cout << YES;
            return;
        }
    }
    for (ll i = n; i >= 1; --i) {
        if (can2[i] && t.sum(i, n)) {
            cout << YES;
            return;
        }
    }
    cout << NO;
    return;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0); // для вайба
    ll tt = 1;
    cin >> tt;
    while (tt--) Solve();
    return 0;
}