#include <iostream>
#include <vector>
#include <deque>

using namespace std;

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int h, w;
	cin >> h >> w;
	vector<vector<char>> a(h, vector<char>(w));
	for (int i = 0; i < h; ++i)
	{
		for (int j = 0; j < w; ++j)
			cin >> a[i][j];
	}
	vector<ll> mins(h, -1);
	deque<pair<pair<ll, ll>, ll>> d;
	ll result = 0;
	for (int i = 0; i < w; ++i)
	{
		for (int j = 0; j < h; ++j)
		{
			if (mins[j] < i - 1)
				mins[j] = i - 1;
			while (mins[j] < w - 1 && a[j][mins[j] + 1] == '1')
			{
				++mins[j];
			}
		}
		d.clear();
		d.push_back({ { -2, -1 }, 0 });
		for (int j = 0; j < h; ++j)
		{
			while (!d.empty() && d.back().first.first >= mins[j])
			{
				d.pop_back();
			}
			d.push_back({ {mins[j], j}, d.back().second + (mins[j] - i + 1) * (j - d.back().first.second) });
			if (d.back().second > result)
				result = d.back().second;
		}
	}
	cout << result << '\n';
	return 0;
}
