#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> white, black;

void dfs(int me, int p, bool c)
{
	if (c)
		white.push_back(me);
	else
		black.push_back(me);
	for (int v : graph[me])
	{
		if (v == p)
			continue;
		dfs(v, me, !c);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	int d;
	cin >> d;
	graph.resize(n);
	for (int i = 0; i < n - 1; ++i)
	{
		int a, b;
		cin >> a >> b;
		graph[a - 1].push_back(b - 1);
		graph[b - 1].push_back(a - 1);
	}
	dfs(0, -1, true);
	cout << min(white.size(), black.size()) << '\n';
	for (int i = 0; i < min(white.size(), black.size()); ++i)
	{
		cout << white[i] + 1 << ' ' << black[i] + 1 << '\n';
	}
	return 0;
}
