#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<vector<int>> init_graph;
vector<int> white, black;
vector<pair<int, int>> dp;
vector<int> par;

void dfs_dp(int me, int p)
{
	dp[me].first = 0;
	bool boost = false;
	for (int v : init_graph[me])
	{
		if (v == p)
			continue;
		dfs_dp(v, me);
		dp[me].first += dp[v].second;
		if (dp[v].second == dp[v].first)
		{
			boost = true;
			par[me] = v;
		}
	}
	if (boost)
		dp[me].second = dp[me].first + 1;
	else
		dp[me].second = dp[me].first;
}

void dfs_out(int me, int p, bool skip = false)
{
	if (skip || dp[me].second == dp[me].first)
	{
		for (int v : init_graph[me])
		{
			if (v == p)
				continue;
			dfs_out(v, me);
		}
	}
	else
	{
		cout << me + 1 << ' ' << par[me] + 1 << '\n';
		for (int v : init_graph[me])
		{
			if (v == p)
				continue;
			dfs_out(v, me, v == par[me]);
		}
	}
}

void dfs(int me, int p, bool c)
{
	if (c)
		white.push_back(me);
	else
		black.push_back(me);
	for (int v : init_graph[me])
	{
		if (v == p)
			continue;
		dfs(v, me, !c);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	int d;
	cin >> d;
	dp.resize(n);
	par.resize(n);
	init_graph.resize(n);
	for (int i = 0; i < n - 1; ++i)
	{
		int a, b;
		cin >> a >> b;
		init_graph[a - 1].push_back(b - 1);
		init_graph[b - 1].push_back(a - 1);
	}
	dfs_dp(0, -1);
	cout << dp[0].second << '\n';
	dfs_out(0, -1);
	return 0;
	cout << min(white.size(), black.size()) << '\n';
	for (int i = 0; i < min(white.size(), black.size()); ++i)
	{
		cout << white[i] + 1 << ' ' << black[i] + 1 << '\n';
	}
	return 0;
}
