#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using dl = double long;
using ull = unsigned long long;

int inf = 1e9;

template <typename T>
void Debug(vector <T> &a) {
    for (auto el : a) cout << el << " ";
    cout << "\n";
}

template <typename T>
void Debug(vector <vector <T>> &a) {
    for (auto &b : a) Debug(b);
    cout << "\n";
}

struct vertex {
    int x, add;
    vertex() = default;
};

vector <vertex> t;

void apply(int v, int x) {
    t[v].x += x;
    t[v].add += x;
}

void push(int v) {
    apply(2 * v + 1, t[v].add);
    apply(2 * v + 2, t[v].add);
    t[v].add = 0;
}

void update(int v, int l, int r, int lq, int rq, int add) {
    if (r <= lq || rq <= l) return;
    if (lq <= l && r <= rq) {
        apply(v, add);
        return;
    }
    int m = (l + r) / 2;
    push(v);
    update(2 * v + 1, l, m, lq, rq, add);
    update(2 * v + 2, m, r, lq, rq, add);
    t[v].x = min(t[2 * v + 1].x, t[2 * v + 2].x);
}

int get(int v, int l, int r, int lq, int rq) {
    if (r <= lq || rq <= l) return inf;
    if (lq <= l && r <= rq) return t[v].x;
    int m = (l + r) / 2;
    push(v);
    return min(get(2 * v + 1, l, m, lq, rq), get(2 * v + 2, m, r, lq, rq));
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector <vector <int>> a(k, vector <int> (4));
    for (int i = 0; i < k; ++i) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
        a[i][3] = i;
        a[i][0]--;
        a[i][1]--;
    }
    vector <int> p(k);
    iota(p.begin(), p.end(), 0);
    bool flag = false;
    do {
        t.clear();
        t.resize(4 * n);
        for (auto i : p) {
            if (get(0, 0, n, a[i][1], a[i][1] + 1) == 0) {
                update(0, 0, n, a[i][0], a[i][2], 1);
            }
        }
        if (get(0, 0, n, 0, n) >= 1) {
            flag = true;
            break;
        }
    } while (next_permutation(p.begin(), p.end()));
    flag ? cout << "YES" : cout << "NO";
    cout << "\n";
}

int main() {
#ifdef WIN32
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}