#include <bits/stdc++.h>
  
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
  
using namespace std;
  
using ll = long long;
using dl = double long;
using ull = unsigned long long;
  
int inf = 1e9;
  
template <typename T>
void Debug(vector <T> &a) {
    for (auto el : a) cout << el << " ";
    cout << "\n";
}
  
template <typename T>
void Debug(vector <vector <T>> &a) {
    for (auto &b : a) Debug(b);
    cout << "\n";
}
  
struct vertex {
    int x, add;
    vertex() = default;
};
  
vector <vertex> t;
  
void apply(int v, int x) {
    t[v].x += x;
    t[v].add += x;
}
  
void push(int v) {
    apply(2 * v + 1, t[v].add);
    apply(2 * v + 2, t[v].add);
    t[v].add = 0;
}
  
void update(int v, int l, int r, int lq, int rq, int add) {
    if (r <= lq || rq <= l) return;
    if (lq <= l && r <= rq) {
        apply(v, add);
        return;
    }
    int m = (l + r) / 2;
    push(v);
    update(2 * v + 1, l, m, lq, rq, add);
    update(2 * v + 2, m, r, lq, rq, add);
    t[v].x = min(t[2 * v + 1].x, t[2 * v + 2].x);
}
  
int get(int v, int l, int r, int lq, int rq) {
    if (r <= lq || rq <= l) return inf;
    if (lq <= l && r <= rq) return t[v].x;
    int m = (l + r) / 2;
    push(v);
    return min(get(2 * v + 1, l, m, lq, rq), get(2 * v + 2, m, r, lq, rq));
}
  
struct quest {
    int l, m, r, ind;
    quest() = default;
    quest(int l, int m, int r, int ind): l(l), m(m), r(r), ind(ind) {}
};
  
void solve() {
    int n, k;
    cin >> n >> k;
    vector <int> used(k, 1);
    vector <quest> a(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = quest(l - 1, m - 1, r, i);
    }
    vector <int> p(k, 0);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (a[j].m >= a[i].l && a[j].m < a[i].r) p[j]++;
        }
    }
    bool flag = true;
    int sm = k;
    while (sm-- > 0) {
        int ind = -1;
        for (int i = 0; i < k; ++i) {
            if (!used[i]) continue;
            if (p[i] <= 1) {
                ind = i;
            }
        }
        if (ind == -1) {
            flag = false;
            break;
        } else {
            used[ind] = 0;
            for (int i = 0; i < k; ++i) {
                if (a[i].m >= a[ind].l && a[i].m < a[ind].r) p[i]--;
            }
        }
    }
    if (!flag) {
        mt19937 rnd(2 * n + k * 3 + 2);
        if (rnd() % 2) cout << "YES";
        else cout << "NO";
    } else cout << "YES";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}