#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using dl = double long;
using ull = unsigned long long;

int inf = 1e9;

template <typename T>
void Debug(vector <T> &a) {
    for (auto el : a) cout << el << " ";
    cout << "\n";
}

template <typename T>
void Debug(vector <vector <T>> &a) {
    for (auto &b : a) Debug(b);
    cout << "\n";
}

struct vertex {
    int x, add;
    vertex() = default;
};

vector <vertex> t;

void apply(int v, int x) {
    t[v].x += x;
    t[v].add += x;
}

void push(int v) {
    apply(2 * v + 1, t[v].add);
    apply(2 * v + 2, t[v].add);
    t[v].add = 0;
}

void update(int v, int l, int r, int lq, int rq, int add) {
    if (r <= lq || rq <= l) return;
    if (lq <= l && r <= rq) {
        apply(v, add);
        return;
    }
    int m = (l + r) / 2;
    push(v);
    update(2 * v + 1, l, m, lq, rq, add);
    update(2 * v + 2, m, r, lq, rq, add);
    t[v].x = min(t[2 * v + 1].x, t[2 * v + 2].x);
}

int get(int v, int l, int r, int lq, int rq) {
    if (r <= lq || rq <= l) return inf;
    if (lq <= l && r <= rq) return t[v].x;
    int m = (l + r) / 2;
    push(v);
    return min(get(2 * v + 1, l, m, lq, rq), get(2 * v + 2, m, r, lq, rq));
}

struct quest {
    int l, m, r, ind;
    quest() = default;
    quest(int l, int m, int r, int ind): l(l), m(m), r(r), ind(ind) {}
};

bool operator< (const quest a, const quest b) {
    return a.ind < b.ind;
}

void solve() {
    int n, k;
    cin >> n >> k;
    t.clear();
    t.resize(4 * n);
    vector <quest> a(k);
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        a[i] = quest(l - 1, m - 1, r, i);
    }
    for (int i = 0; i < k; ++i) {
        update(0, 0, n, a[i].l, a[i].r, 1);
    }
    bool flag = true;
    int sm = k;
    set <quest> st;
    for (int i = 0; i < k; ++i) st.insert(a[i]);
    while (st.size() > 0) {
        if (get(0, 0, n, 0, n) > 1) {
            flag = false;
            break;
        }
        quest del = quest(0, 0, 0, -1);
        for (auto i : st) {
            if (get(0, 0, n, i.m, i.m + 1) == 1) {
                del = i;
                break;
            }
        }
        if (del.ind != -1) {
            st.erase(del);
            update(0, 0, n, del.l, del.r, -1);
        } else {
            flag = false;
            break;
        }
    }
    flag ? cout << "YES" : cout << "NO";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}