// olymp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
struct seg_tree {
	std::vector<int> nodes;

	std::vector<int> lazy_add;
	std::vector<bool> lazy_set;
	int ext_size;

	seg_tree(int size) {
		ext_size = 1;
		while (ext_size < size)
		{
			ext_size *= 2;
		}
		nodes.assign(ext_size * 2, 0);
		lazy_add.assign(ext_size * 2, 0);
		lazy_set.assign(ext_size * 2, false);
	}
	void add_lazy(int node, int x, int size) {
		lazy_add[node] += x;
		nodes[node] += x * size;
	}
	void set_lazy(int node) {
		lazy_set[node] = true;
		lazy_add[node] = 0;
		nodes[node] = 0;
	}
	void push(int node, int size) {
		if (lazy_set[node]) {
			set_lazy(node * 2);
			set_lazy(node * 2 + 1);
			lazy_set[node] = false;
		}
		if (lazy_add[node]) {
			add_lazy(node * 2, lazy_add[node], size);
			add_lazy(node * 2+1, lazy_add[node], size);

			lazy_add[node] = 0;
		}
	}
	void set(int l, int r, int node, int nl, int nr) {
		if (r < nl || nr < l)
			return;
		if (l <= nl && nr <= r) {
			set_lazy(node);
			return;
		}
		push(node, nr-nl+1);
		int mid = (nl + nr) / 2;
		set(l, r, node * 2, nl, mid);
		set(l, r, node * 2 + 1, mid + 1, nr);
		nodes[node] = nodes[node * 2] + nodes[node * 2 + 1];

	}
	void add(int l, int r, int x, int node, int nl, int nr) {
		if (r < nl || nr < l)
			return;
		if (l <= nl && nr <= r)
			return add_lazy(node, x, nr-nl+1);
		push(node, nr - nl + 1);
		int mid = (nl + nr) / 2;
		add(l, r, x, node * 2, nl, mid);
		add(l, r, x, node * 2 + 1, mid + 1, nr);
		nodes[node] = nodes[node * 2] + nodes[node * 2 + 1];

	}
	int get(int l, int r, int node, int nl, int nr) {
		if (r < nl || nr < l)
			return 0;
		if (l <= nl && nr <= r)
			return nodes[node];
		push(node, nr - nl + 1);
		int mid = (nl + nr) / 2;
		return 
			get(l, r, node * 2, nl, mid) +
			get(l, r, node * 2 + 1, mid + 1, nr);

	}
};
using namespace std;
int32_t main()
{
	int h, w;
	cin >> h >> w;
	std::vector<std::vector<int>> arr(h, vector<int>(w));
	for (int i = 0; i < h; i++)
	{
		for (int j = w-1; j >= 0; j--)
		{
			char c;
			cin >> c;
			arr[i][j] = c == '1';
		}
	}

	if (w < h) {
		std::vector<std::vector<int>> arrt(w, vector<int>(h));
		for (int i = 0; i < w; i++)
			for (int j = 0; j < h; j++)
				arrt[i][j] = arr[j][i];
		swap(arrt, arr);
		swap(h, w);
	}
	auto hor_sum = arr;
	for (int i = 1; i < h; i++)
	{
		for (int j = 0; j < w; j++) {
			if (arr[i][j] == 0)
				continue;
			hor_sum[i][j] += hor_sum[i-1][j];
		}
	}
	int answer = 0;



	seg_tree in_row(h+1);
	for (int i = 0; i < h; i++)
	{
		int cur_height = i+1;
		int local_answer = 0;
		in_row.set(0, h, 1, 0, in_row.ext_size - 1);
		for (int j = 0; j < w; j++)
		{
			int real_height = hor_sum[i][j];
			local_answer += real_height;
			in_row.add(0, real_height-1, 1, 1, 0, in_row.ext_size - 1);
			if (cur_height > real_height) {
				local_answer -= in_row.get(real_height, h, 1, 0, in_row.ext_size - 1);
				in_row.set(real_height, h, 1, 0, in_row.ext_size - 1);
			}
			cur_height = real_height;
			answer = max(local_answer, answer);
		}

	}
	std::cout << answer << '\n';
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
