// olymp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

struct seg_tree {
	std::vector<bool> nodes;
	int ext_size;

	seg_tree(int size) {
		ext_size = 1;
		while (ext_size < size)
		{
			ext_size *= 2;
		}
		nodes.assign(ext_size * 2, false);
	}

	void set(int index) {
		index += ext_size;


		while (index) {
			nodes[index] = true;
			index /= 2;
		}

	}
	bool get(int l, int r) {


		l += ext_size;
		r += ext_size;

		while (l <= r) {

			if (l % 2 == 1) {
				if (nodes[l])
					return true;
				l++;
			}
			if (r % 2 == 0) {
				if (nodes[r])
					return true;
				r--;
			}
			l /= 2;
			r /= 2;

		}


		return false;
	}
};

struct employee {
	int l, m, r;
	bool operator<(employee other) const {
		return m < other.m;
	}


};
using namespace std;
void test() {
	int n, k;
	cin >> n >> k;
	seg_tree dp(n + 2);
	dp.set(0);

	std::vector<employee> arr(k);
	std::vector<int> scanline(n+2);
	for (auto& [l, m, r] : arr) {
		cin >> l >> m >> r;
		scanline[l]++;
		scanline[r + 1]--;
	}
	int t = 0;
	bool answer = true;
	for (int i = 1; i <= n; i++){
		t += scanline[i];
		if (t == 0)
			answer = false;
	}
	std::sort(arr.begin(), arr.end());
	
	for (int i = 0; i < k; i++)
		for (int j = 0; j < i; j++) {
			if (arr[i].l <= arr[j].m && arr[i].m <= arr[j].r)
				answer = false;
		}

	if (answer)
		cout << "YES\n";
	else
		cout << "NO\n";
}
int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		test();
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
