#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

// 10:30

struct FenwickTree {
	vector<int> tree;
	int n;
	void init(int _n) {
		n = _n;
		tree.assign(n, 0);
	}
	void inc(int i, int v) {
		for (int j = i; j < n; j |= j + 1) {
			tree[j] += v;
		}
	}
	int get(int i) {
		int ans = 0;
		for (int j = i; j >= 0; j = (j & (j + 1)) - 1) {
			ans += tree[j];
		}
		return ans;
	}
	void add(int l, int r, int x) {
		inc(l, x);
		if (r + 1 < n) {
			inc(r + 1, -x);
		}
	}
};

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> l(k), m(k), r(k);
	for (int i = 0; i < k; ++i) {
		cin >> l[i] >> m[i] >> r[i];
	}
	vector<int> ord(k);
	iota(ord.begin(), ord.end(), 0);
	do {
		FenwickTree ft;
		ft.init(n + 1);
		for (int i : ord) {
			if (ft.get(m[i]) == 0) {
				ft.add(l[i], r[i], 1);
			}
		}
		bool good = true;
		for (int i = 1; i <= n; ++i) {
			if (ft.get(i) == 0) {
				good = false;
				break;
			}
		}
		if (good) {
			cout << "YES\n";
			return;
		}
	} while (next_permutation(ord.begin(), ord.end()));
	cout << "NO\n";
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
