#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
 
using namespace std;
using ll = long long;
using ld = long double;

struct SegmentTree {
	vector<int> tree, lazy;
	int size;
	void init(int n) {
		size = 1;
		while (size < n) size *= 2;
		tree.assign(2 * size - 1, 0);
		lazy.assign(2 * size - 1, -1);
	}
	void push(int v, int l, int r) {
		if (lazy[v] == -1) return;
		tree[v] = lazy[v];
		if (l + 1 < r) {
			lazy[2 * v + 1] = lazy[v];
			lazy[2 * v + 2] = lazy[v];
		}
		lazy[v] = -1;
	}
	int max(int lx, int rx, int l, int r, int v) {
		push(v, l, r);
		if (rx <= l || r <= lx) return 0;
		if (lx <= l && r <= rx) return tree[v];
		int m = (l + r) >> 1;
		return std::max(max(lx, rx, l, m, 2 * v + 1), max(lx, rx, m, r, 2 * v + 2));
	}
	int max(int l, int r) {
		return max(l, r, 0, size, 0);
	}
	void update(int lx, int rx, int x, int l, int r, int v) {
		push(v, l, r);
		if (rx <= l || r <= lx) return;
		if (lx <= l && r <= rx) {
			lazy[v] = x;
			return push(v, l, r);
		}
		int m = (l + r) >> 1;
		update(lx, rx, x, l, m, 2 * v + 1);
		update(lx, rx, x, m, r, 2 * v + 2);
		tree[v] = std::max(tree[2 * v + 1], tree[2 * v + 2]);
	}
	void update(int l, int r, int x) {
		update(l, r, x, 0, size, 0);
	}
};

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> l(k), m(k), r(k);
	for (int i = 0; i < k; ++i) {
		cin >> l[i] >> m[i] >> r[i];
		--l[i]; --r[i]; --m[i];
	}
	vector<int> ord(k);
	iota(ord.begin(), ord.end(), 0);
	sort(ord.begin(), ord.end(), [&](int i, int j) -> bool {
		return l[i] > l[j] || (l[i] == l[j] && m[i] < m[j]);
	});
	vector<int> dp(k);
	for (int i = 0; i < k; ++i) {
		if (r[ord[i]] == n - 1) {
			dp[i] = 1;
		} else {
			for (int j = i - 1; j >= 0; --j) {
				if (dp[j]) {
					int lx = std::max(l[ord[i]], l[ord[j]]);
					int rx = std::min(r[ord[i]], r[ord[j]]);
					if (r[ord[i]] + 1 == l[ord[j]]) {
						dp[i] = 1;
						break;
					} else {
						if (lx <= rx) {
							if (!(lx <= m[ord[i]] && m[ord[i]] <= rx) || 
								!(lx <= m[ord[j]] && m[ord[j]] <= rx)) {
								dp[i] = 1;
								break;
							}
						}
					}
				}
			}
		}

		if (dp[i] && l[ord[i]] == 0) {
			cout << "YES\n";
			return;
		}
	}
	cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
 
    int tests;
    cin >> tests;
    while (tests--) {
    	solve();
    }
}
