#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
  
using namespace std;
using ll = long long;
using ld = long double;

#define int long long

const int inf = (int)1e9 + 5;

// 260

struct Line {
	int k, l;
	int get(int x) {
		return k * x + l;
	}
	Line() {
		k = 1, l = 0;
	}
	Line(int k, int l) : k(k), l(l) {
		if (l < 0) {
			l = -l;
			k = -k;
		}
	}
};

struct Rac {
	int a, b;
	Rac(int a, int b) : a(a), b(b) {}
	Rac() : a(0), b(1) {}
};

bool operator <(const Rac &a, const Rac &b) {
	return __int128(a.a) * b.b < __int128(a.b) * b.a;
}

Rac dot(const Line &a, const Line &b) {
	return Rac(b.l - a.l, a.k - b.k);
}

bool operator <(const pair<Rac, Line> &a, const pair<Rac, Line> &b) {
	return a.first < b.first;
}

// min
struct CHT {
	vector<pair<Rac, Line>> arr;
	void add(Line line) {
		if (arr.empty()) {
			arr.push_back(make_pair(Rac(-inf, 1), line));
			return;
		}
		if (arr.back().second.k == line.k) {
			return;
		}
		while ((int)arr.size() >= 2 && !(dot(line, arr[(int)arr.size() - 2].second) < dot(line, arr.back().second))) {
			arr.pop_back();
		}
		arr.push_back({dot(line, arr.back().second), line});
	}
	void build(vector<Line> lines) {
		sort(lines.begin(), lines.end(), [&](Line &a, Line &b) -> bool {
			if (a.k == b.k) {
				return a.l < b.l;
			}
			return a.k > b.k;
		});
		for (auto it : lines) {
			add(it);
		}
	}
	int get(int x) {
		if (arr.empty()) return (int)1e18;
		auto it = *lower_bound(arr.begin(), arr.end(), make_pair(Rac(x, 1), Line(1, 0)));
		return it.second.get(x);
	}
};

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
    	cin >> x[i];
    }
    int s_pos, d;
    cin >> s_pos >> d;
    for (int i = 0; i < n; ++i) {
    	x[i] -= s_pos;
    }
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; ++i) {
    	cin >> t[i];
    }

    vector<int> left, right;
    for (int i = 0; i < n; ++i) {
    	if (x[i] == 0) continue;
    	if (x[i] < 0) {
    		left.push_back(-x[i]);
    	} else {
    		right.push_back(x[i]);
    	}
    }

    if (left.empty() && right.empty()) {
    	for (int q = 0; q < m; ++q) {
    		cout << 0 << '\n';
    	}
    	return 0;
    }

    ll sum_l = 0, sum_r = 0;

    for (int i : left) {
    	sum_l += i * i;
    }

    for (int i : right) {
    	sum_r += i * i;
    }

    auto get = [&](int p) -> int {
    	if (p < 0) {
    		p = -p;
    	}
		ll temp = 1e18;
		int s = p;
        p = (p / d) * d;
        temp = std::min(temp, (s - p) * (s - p));
        p += d;
        temp = std::min(temp, (s - p) * (s - p));
        return temp;
	};

	sort(left.begin(), left.end());
	sort(right.begin(), right.end());

	if (right.empty()) {
		left.swap(right);
	}

	int k = (int)right.size();

	vector<int> sq_sum(k), sum(k);

	for (int i = k - 1; i >= 0; --i) {
		sq_sum[i] += right[i] * right[i];
		sum[i] += right[i];
		if (i + 1 < k) {
			sq_sum[i] += sq_sum[i + 1];
			sum[i] += sum[i + 1];
		}
	}

	vector<int> pref(k);

	for (int i = 0; i < k; ++i) {
		pref[i] = get(right[i]);
		if (i > 0) {
			pref[i] += pref[i - 1];
		}
	}

	vector<Line> lines;

	int lim = (int)1e6;
	if (lim % d) lim = (lim / d + 1) * d;

	int ptr = 0;

	for (int x = 0; x * d <= lim; x++) {
		ll sum_take = 0;
		while (ptr < (int)right.size() && right[ptr] <= x * d) ptr++;
		if (ptr > 0) {
			sum_take += pref[sum_take - 1];
		}
		sum_take += (k - ptr) * d * d * x * x;
		sum_take += sq_sum[ptr];
		sum_take -= 2 * d * x * sum[ptr];
		lines.push_back({Line(x, sum_take)});
	}

	CHT st;
	st.build(lines);

    for (int q = 0; q < m; ++q) {
    	cout << sum_l + st.get(t[q]) << '\n';
    }
}
