#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
 
using namespace std;
using ll = long long;
using ld = long double;
 
vector<pair<int, int>> solve(const vector<pair<int, int>> &edges, int n) {
    vector<vector<int>> g(n);
    for (auto &[u, v] : edges) {
        g[u].push_back(v);
    }
    vector<int> p(n, -1), used(n);
    int timer = 0;
    auto try_kuhn = [&](auto &&try_kuhn, int v) -> bool {
        if (used[v] == timer) return false;
        used[v] = timer;
        for (int to : g[v]) {
            if (p[to] == -1 || try_kuhn(try_kuhn, p[to])) {
                p[to] = v;
                return true;
            }
        }
        return false;
    };
    for (int i = 0; i < n; ++i) {
        timer++;
        try_kuhn(try_kuhn, i);
    }
    vector<pair<int, int>> res;
    for (int i = 0; i < n; ++i) {
        if (p[i] != -1) {
            res.emplace_back(i, p[i]);
        }
    }
    return res;
}
 
signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
 
    int n, d;
    cin >> n >> d;
    vector<int> clr(n);
    vector<vector<int>> g(n);
    for (int i = 0; i + 1 < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    auto dfs = [&](auto &&dfs, int v, int pr = -1) -> void {
        for (int to : g[v]) {
            if (to == pr) continue;
            clr[to] = clr[v] ^ 1;
            dfs(dfs, to, v);
        }
    };
    dfs(dfs, 0);
    vector<pair<int, int>> edges;
    int start;
    auto dfs2 = [&](auto &&dfs2, int v, int pr, int dist) -> void {
        if (dist % 2 == 1) {
            edges.emplace_back(start, v);
        }
        if (dist >= d) {
            return;
        }
        for (int to : g[v]) {
            if (to == pr) continue;
            dfs2(dfs2, to, v, dist + 1);
        }
    };
    for (int i = 0; i < n; ++i) {
        if (clr[i] == 0) {
            start = i;
            dfs2(dfs2, i, -1, 0);
        }
    }
    vector<pair<int, int>> res = solve(edges, n);
    cout << (int)res.size() << '\n';
    for (auto &[u, v] : res) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}
