#include <bits/stdc++.h>

using namespace std;

long long sq(int x) {
    return (long long) x * x;
}

struct ray {
    int n, d;
    vector <int> v;
    __int128 s = 0;
    vector <__int128> p, q;

    ray(int n, int d, vector <int> &u): n(n), d(d) {
        for (int x : u) v.push_back(x);
        sort(v.begin(), v.end());
        for (int x : v) s += sq(x);
        p.resize(1 + n); q.resize(1 + n);
        for (int i = 0; i < n; ++i) {
            q[i + 1] = v[i];
            p[i + 1] = sq(v[i]) - mins(i);
        }
        for (int i = 0; i < n; ++i) {
            q[i + 1] += q[i];
            p[i + 1] += p[i];
        }
    }

    long long mins(int k) {
        return min(sq(v[k] % d), sq(d - v[k] % d));
    }

    __int128 one(int k, int t) {
        int h = k * d;
        int i = upper_bound(v.begin(), v.end(), h) - v.begin() - 1;
        return k * t - p[i + 1] - 2 * (q[n] - q[i + 1]) * h + (__int128) (n - i - 1) * sq(h);
    }

    long long ans(int t) {
        int l = 0, r = v.back() / d + 1;
        while (r - l > 2) {
            int a = (l + l + r) / 3, b = (l + l + r) / 3;
            if (one(a, t) >= one(b, t)) l = a;
            else r = b;
        }
        return s + min(min(one(l, t), one(l + 1, t)), min(one(l + 2, t), (__int128) 0));
    }
};

int main() {
    ios::sync_with_stdio(false); cin.tie(nullptr);

    int n;
    cin >> n;

    vector <int> w(n), u, v;
    for (int i = 0; i < n; ++i) cin >> w[i];

    int s, d;
    cin >> s >> d;

    for (int x : w) {
        if (x >= s) v.push_back(x - s);
        else u.push_back(s - x);
    }
    ray x(u.size(), d, u), y(v.size(), d, v);

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        cout << min(x.ans(t) + y.ans(t * 2), x.ans(t * 2) + y.ans(t)) << '\n';
    }

    // cout << (int) y.s << ' ';
    // cout << (int) y.one(0, 4) << ' ' << (int) y.one(1, 4) << ' ' << (int) y.one(2, 4);

    return 0;
}
