#include<bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

struct segtree {
    struct node {
        int sum_1,sum_2, upd;
    };

    const node ZERO = {0, 0, 0};
    vector<node> t;
    int size;

    void apply(int v) {
        t[v].sum_1 = 0;
        t[v].sum_2 = 0;
        t[v].upd = 1;
    }

    void push(int v) {
        if (t[v].upd) {
            apply(v * 2 + 1);
            apply(v * 2 + 2);
        }
        t[v].upd = 0;
    }

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        t.assign(size * 2 - 1, ZERO);
    }

    node merge(node a, node b) {
        return {a.sum_1 + b.sum_1,a.sum_2 + b.sum_2 ,0};
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (tr <= l or tl >= r) {
            return 0;
        }
        if (tl >= l and tr <= r) {
            return t[v].sum_1;
        }
        push(v);
        int mid = (tl + tr) / 2;
        int res1 = get(v * 2 + 1, l, r, tl, mid);
        int res2 = get(v * 2 + 2, l, r, mid, tr);
        return res1 + res2;
    }

    int get(int l, int r) {
        return get(0, l, r, 0, size);
    }

    int get_res() {
        return t[0].sum_2;
    }


    void update2(int v, int ind, int x, int tl, int tr) {
        if (tr - tl == 1) {
            t[v].sum_2 += x*tl;
            t[v].sum_1+=x;
            return;
        }
        push(v);
        int mid = (tl + tr) / 2;
        if (ind < mid) {
            update2(v * 2 + 1, ind, x, tl, mid);
        } else {
            update2(v * 2 + 2, ind, x, mid, tr);
        }
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void update2(int ind, int x) {
        update2(0, ind, x, 0, size);
    }

    void update(int v, int l, int r, int tl, int tr) {
        if (tr <= l or tl >= r) {
            return;
        }
        if (tl >= l and tr <= r) {
            apply(v);
            return;
        }
        push(v);
        int mid = (tl + tr) / 2;
        update(v * 2 + 1, l, r, tl, mid);
        update(v * 2 + 2, l, r, mid, tr);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void update(int l, int r) {
        update(0, l, r, 0, size);
    }
};

void dany() {
    int n, m;
    cin >> n >> m;
    vector<vector<bool> > x(n, vector<bool>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            x[i][j] = c == '1';
        }
    }
    if (m < n) {
        vector<vector<bool> > x2(m, vector<bool>(n));
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                x2[i][j] = x[n - 1 - j][m - 1 - i];
            }
        }
        swap(x2, x);
        swap(n, m);
    }
    vector<vector<int> > a(n, vector<int>(m));
    int res = 0;
    for (int i = 0; i < m; i++) {
        int ans = 0;
        for (int j = 0; j < n; j++) {
            if (x[j][i]) {
                ans++;
            } else {
                ans = 0;
            }
            a[j][i] = ans;
            res = max(res, ans);
        }
    }
    for (int i = 0; i < n; i++) {
        segtree t;
        t.init(n + 1);
        for (int j = m - 1; j >= 0; j--) {
            int cnt = t.get(a[i][j] + 1, n + 1);
            if (cnt > 0) {
                t.update(a[i][j] + 1, n + 1);
            }
            t.update2(a[i][j], cnt + 1);
            res = max(res, t.get_res());
        }
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    dany();
    return 0;
}
