#include<bits/stdc++.h>

using namespace std;

struct segtree {
    struct node {
        int sum, upd;
    };

    const node ZERO = {0, 0};
    vector<node> t;
    int size;

    void apply(int v) {
        t[v].sum = 0;
        t[v].upd = 1;
    }

    void push(int v) {
        if (t[v].upd) {
            apply(v * 2 + 1);
            apply(v * 2 + 2);
        }
        t[v].upd = 0;
    }

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        t.assign(size * 2 - 1, ZERO);
    }

    node merge(node a, node b) {
        return {a.sum + b.sum, 0};
    }

    void build(int v, vector<int> &a, int tl, int tr) {
        if (tr - tl == 1) {
            if (tl < a.size()) {
                t[v] = {a[tl]};
            }
            return;
        }
        int mid = (tl + tr) / 2;
        build(v * 2 + 1, a, tl, mid);
        build(v * 2 + 2, a, mid, tr);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void build(vector<int> &a) {
        init(a.size());
        build(0, a, 0, size);
    }

    int get(int v, int ind, int tl, int tr) {
        if (tr - tl == 1) {
            return t[v].sum;
        }
        push(v);
        int mid = (tl + tr) / 2;
        if (ind < mid) {
            return get(v * 2 + 1, ind, tl, mid);
        }
        return get(v * 2 + 2, ind, mid, tr);
    }

    int get(int ind) {
        return get(0, ind, 0, size);
    }

    int get_res() {
        return t[0].sum;
    }

    void update(int v, int l, int r, int tl, int tr) {
        if (tr <= l or tl >= r) {
            return;
        }
        if (tl >= l and tr <= r) {
            apply(v);
            return;
        }
        push(v);
        int mid = (tl + tr) / 2;
        update(v * 2 + 1, l, r, tl, mid);
        update(v * 2 + 2, l, r,mid, tr);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void update(int l, int r) {
        update(0,l,r,0,size);
    }
};

void dany() {
    int n,k;
    cin>>n>>k;
    vector<int> one(n,1);
    segtree t;
    t.build(one);
    for (int i=0;i<k;i++) {
        int l, m, r;
        cin>>l>>r>>m;
        l--;
        m--;
        if (t.get(m)) {
            t.update(l, r);
        }
    }
    if (t.get_res()==0) {
        cout<<"YES\n";
    }
    else {
        cout<<"NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin>>t;
    while (t--) {
        dany();
    }
    return 0;
}
