#include<bits/stdc++.h>

using namespace std;

struct segtree {
    struct node {
        int sum,upd;
    };

    const node ZERO = {0, 0};
    vector<node> t;
    int size;

    void apply(int v) {
        t[v]={1,1};
    }

    void push(int v) {
        if (t[v].upd) {
            apply(v*2+1);
            apply(v*2+2);
        }
        t[v].upd=0;
    }

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        t.assign(size * 2 - 1, ZERO);
    }

    node merge(node a, node b) {
        return {a.sum + b.sum};
    }

    void build(int v, vector<int> &a, int tl, int tr) {
        if (tr - tl == 1) {
            if (tl < a.size()) {
                t[v] = {a[tl]};
            }
            return;
        }
        int mid = (tl + tr) / 2;
        build(v * 2 + 1, a, tl, mid);
        build(v * 2 + 2, a, mid, tr);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void build(vector<int> &a) {
        init(a.size());
        build(0, a, 0, size);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (tr <= l or tl >= r) {
            return 0;
        }
        if (tl >= l and tr <= r) {
            return t[v].sum;
        }
        push(v);
        int mid = (tl + tr) / 2;
        int res1 = get(v * 2 + 1, l, r, tl, mid);
        int res2 = get(v * 2 + 2, l, r, mid, tr);
        return res1 + res2;
    }

    int get(int l, int r) {
        return get(0, l, r, 0, size);
    }

    void update(int v, int l, int r, int tl, int tr) {
        if (tr <= l or tl >= r) {
            return;
        }
        if (tl >= l and tr <= r) {
            apply(v);
            return;
        }
        push(v);
        int mid = (tl + tr) / 2;
        update(v*2+1,l,r,tl,mid);
        update(v*2+2,l,r,mid, tr);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void update(int l, int r) {
        update(0, l, r, 0, size);
    }
};

struct anna {
    int l, r, m;
};

void dany() {
    int n, k;
    cin >> n >> k;
    vector<int> one(n, 1);
    vector<anna> a(k);
    vector<vector<pair<int, int> > > x(n);
    for (int i = 0; i < k; i++) {
        cin >> a[i].l >> a[i].m >> a[i].r;
        a[i].l--;
        a[i].m--;
        a[i].r--;
        x[a[i].l].push_back({a[i].m, a[i].r});
    }
    vector<bool> dp(n + 1);
    dp[n] = 1;
    segtree t,t2;
    t.init(n + 1);
    t2.init(n + 1);
    t.update(n, n+1);
    t2.update(n, n+1);
    sort(a.begin(), a.end(), [&](anna n1, anna n2) {
        return n1.m > n2.m;
    });
    for (auto j: a) {
        int m = j.m, r = j.r;
        if (t.get(r+1, r + 2) or t2.get(m+1,r+2)) {
            t.update(j.l, m + 1);
        }
        if (t2.get(m+1,r+2)) {
            t2.update(j.l, j.l+1);
        }
    }
    if (t.get(0,1)) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        dany();
    }
    return 0;
}

