#include <bits/stdc++.h>

using namespace std;
using ll = long long;

mt19937 G(13);

struct node {
    int sm;
    int val;
    int mn;
    node() : sm(0),val(0),mn(0){};
    node(int sm1,int val1,int mn1) : sm(sm1),val(val1),mn(mn1){};
};

unsigned int TREE_SIZE = 2000000;
node tree[2000000];

void build() {
    for (int i=0;i<TREE_SIZE;i++) {
        tree[i] = node();
    }
}

void push(int i,int l,int r) {
    if (r-l==1 || tree[i].val == 0) {
        return;
    }

    int v = tree[i].val;
    tree[i].val = 0;

    tree[i*2+1].val += v;
    tree[i*2+1].sm += v * (r-l);
    tree[i*2+1].mn += v;

    tree[i*2+2].val += v;
    tree[i*2+2].sm += v * (r-l);
    tree[i*2+2].mn += v;
}

void set_segment(int i,int l,int r,int q_l,int q_r,int v) {
    if (r<=q_l || q_r <= l) {
        return;
    }
    if (q_l <= l && r <= q_r) {
        tree[i].sm += v*(r-l);
        tree[i].val += v;
        tree[i].mn += v;
        return;
    }
    push(i,l,r);
    int m = (r+l)/2;
    set_segment(i*2+1,l,m,q_l,q_r,v);
    set_segment(i*2+2,m,r,q_l,q_r,v);

    tree[i].sm = tree[i*2+1].sm + tree[i*2+2].sm;
    tree[i].mn = min(tree[i*2+1].mn,tree[i*2+2].mn);
}

int get_min(int i,int l,int r,int q_l,int q_r) {
    if (r<=q_l || q_r <= l) {
        return 1;
    }
    if (q_l <= l && r <= q_r) {
        return tree[i].mn;
    }
    push(i,l,r);
    int m = (r+l)/2;
    int a1 = get_min(i*2+1,l,m,q_l,q_r);
    int a2 = get_min(i*2+2,m,r,q_l,q_r);
    return min(a1,a2);
}

struct chel {
    int l,r,m;
    chel() : l(0),r(0),m(0) {};
    chel(int l1,int r1,int m1) : l(l1),r(r1),m(m1) {};
};

bool cmp(chel &a,chel &b) {
    return a.l < b.l || a.l == b.l && a.r > b.r;
}

signed main() {
    int T;
    cin >> T;
    auto st = chrono::steady_clock::now();
    while (T--) {
        int n,k;
        cin >> n >> k;
        vector<chel> a;
        set<int> st;
        for (int i=0;i<k;i++) {
            int l,m,r;
            cin >> l >> m >> r;
            l--;
            r--;
            m--;
            st.insert(m);
            a.push_back(chel(l,r,m));
        }

        if (st.size()<k) {
            cout << "NO" << endl;
            continue;
        }

        sort(a.begin(), a.end(),cmp);
        reverse(a.begin(), a.end());
        
        st.clear();
        for (int i=0;i<k;i++) {
            auto [l,r,m] = a[i];
            if (get_min(0,0,n,l,l+1) == 0) {
                st.insert(i);
                set_segment(0,0,n,l,r+1,1);
            }
        }
        bool flag = false;
        if (get_min(0,0,n,0,n)>0) {
            flag = true;
        }
        for (auto i : st) {
            auto [l,r,m] = a[i];
            set_segment(0,0,n,l,r+1,-1);
        }
        if (flag) {
            cout << "YES" << endl;
        }else {
            cout << "NO" << endl;
        }
    }
}