#include <bits/stdc++.h>

using namespace std;

struct node {
    int l, r, m;
};

bool operator <(const node &u,const node &v) {
    if (u.l <= v.m && v.m <= u.r && v.l <= u.m && u.m <= v.r) {
        return (u.r - u.l) > (v.r - v.l);
    }
    if (u.l <= v.m && v.m <= u.r) {
        return 0;
    }
    return 1;
}

int maxn = 500005;
vector<int> tree(4 * maxn);
vector<int> add(4 * maxn);

void apl(int v, int x) {
    tree[v] = x;
    add[v] = x;
}

void push(int v) {
    if (add[v] == 0)
        return;
    apl(2 * v + 1, add[v]);
    apl(2 * v + 2, add[v]);
    add[v] = 0;
}

void upd(int v, int l, int r, int ql, int qr, int x) {
    if (qr <= l || r <= ql) {
        return;
    }
    if (ql <= l && r <= qr) {
        apl(v, x);
        return;
    }
    push(v);
    int mid = (l + r) / 2;
    upd(2 * v + 1, l, mid, ql, qr, x);
    upd(2 * v + 2, mid, r, ql, qr, x);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return 1;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    push(v);
    int mid = (l + r) / 2;
    return min(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (; t > 0; --t) {
        int n, k;
        cin >> n >> k;
        tree.clear();
        add.clear();
        tree.resize(4 * maxn);
        add.resize(4 * maxn);
        vector<node> a(k);
        for (int i = 0; i < k; ++i) {
            cin >> a[i].l >> a[i].m >> a[i].r;
        }
        sort(a.begin(), a.end());
        for (node it: a) {
            if (get(0, 0, n, it.m - 1, it.m) == 0) {
                upd(0, 0, n, it.l - 1, it.r, 1);
            }
        }
        if (tree[0] == 1) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
}
