#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC target("avx2,sse4")
#pragma GCC optimize("Ofast")
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

void solve() {
    int h, w;
    cin >> h >> w;
    vector<string> a(h);
    for (int i = 0; i < h; ++i) {
        cin >> a[i];
    }
    if (h > w) {
        vector<string> b(w, string(h, '0'));
        for (int i = 0; i < w; ++i) {
            for (int j = 0; j < h; ++j) {
                b[w - i - 1][h - j - 1] = a[j][i];
            }
        }
        swap(h, w);
        swap(a, b);
    }
    vector<vector<vector<int>>> dp(h, vector<vector<int>>(w, vector<int>(h)));
    int ans = 0;
    for (int i = h - 1; i >= 0; --i) {
        for (int j = w - 1; j >= 0; --j) {
            for (int k = i; k < h && a[k][j] == '1'; ++k) {
                dp[i][j][k] = max(i + 1 < h ? dp[i + 1][j][k] : 0, (j + 1 < w ? dp[i][j + 1][k] : 0) + (k - i)) + 1;
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
