#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

struct Seg {
    int l, m, r;
    bool operator<(Seg s) {
        return l < s.l;
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<Seg> a(k);
    for (auto& [l, m, r] : a) {
        cin >> l >> m >> r;
        --l, --m, --r;
    }
    sort(a.begin(), a.end());
    vector<int> dp(k, n);
    for (int i = 0; i < k; ++i) {
        auto [li, mi, ri] = a[i];
        if (li == 0) {
            dp[i] = -1;
        }
        for (int j = 0; j < i; ++j) {
            auto [lj, mj, rj] = a[j];
            if (li <= rj + 1 && dp[j] < li && (mj < li || rj < mi)) {
                dp[i] = min(dp[i], rj);
            }
        }
        if (ri == n - 1 && dp[i] != n) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
