#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;
using i128 = __int128;

#define szof(x) (int)x.size()

ll sq(ll a) {
    return a * a;
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i];
    }
    vector<int> nt(m);
    iota(nt.begin(), nt.end(), 0);
    sort(nt.begin(), nt.end(), [&t](int i, int j) { return t[i] > t[j]; });
    vector<ll> b(n + 1), sum(n + 1);
    vector<i128> sum2(n + 1);
    for (int i = 0; i < n; ++i) {
        b[i + 1] = b[i] + min(sq(x[i] - x[i] / d * d), sq(x[i] / d * d + d - x[i]));
    }
    for (int i = n - 1; i >= 0; --i) {
        sum[i] = sum[i + 1] + x[i];
        sum2[i] = sum2[i + 1] + sq(x[i]);
    }
    auto cost = [&](int k) -> i128 {
        int i = lower_bound(x.begin(), x.end(), d * k) - x.begin();
        return b[i] + (i128)sq(d * k) * (n - i) - (i128)2 * d * k * sum[i] + sum2[i];
    };
    vector<ll> ans(m);
    for (auto u : nt) {
        int l = -1, r = (x[n - 1] + d - 1) / d;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (cost(mid) + (ll)t[u] * mid > cost(mid + 1) + (ll)t[u] * (mid + 1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans[u] = cost(r) + (ll)t[u] * r;
    }
    for (auto el : ans) {
        cout << el << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
