#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;
using i128 = __int128;

#define szof(x) (int)x.size()

ll sq(ll a) {
    return a * a;
}

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    sort(x.begin(), x.end());
    int x0, d;
    cin >> x0 >> d;
    int m;
    cin >> m;
    vector<int> t(m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i];
    }
    vector<int> nt(m);
    iota(nt.begin(), nt.end(), 0);
    sort(nt.begin(), nt.end(), [&t](int i, int j) { return t[i] > t[j]; });
    vector<ll> ans(m);
    for (auto u : nt) {
        bool sw = false;
        if (x[0] < x0) {
            sw = true;
            swap(x[0], x0);
        }
        int l = -1, r = (x[0] - x0 + d - 1) / d;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if ((ll)t[u] * mid + sq(x0 + mid * d - x[0]) > (ll)t[u] * (mid + 1) + sq(x0 + (mid + 1) * d - x[0])) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans[u] = (ll)t[u] * r + sq(x0 + r * d - x[0]);
        if (sw) {
            swap(x[0], x0);
        }
    }
    for (auto el : ans) {
        cout << el << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
