#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

int n, d;
vector<vector<int>> gr;
vector<pair<int, int>> ans;
vector<bool> fr;

void dfs1(int v, int p) {
    fr[v] = true;
    for (auto u : gr[v]) {
        if (u != p) {
            dfs1(u, v);
            if (fr[v] && fr[u]) {
                ans.emplace_back(u, v);
                fr[v] = false;
            }
        }
    }
}

void solve() {
    cin >> n >> d;
    gr.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    fr.resize(n);
    dfs1(0, -1);
    cout << szof(ans) << "\n";
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
