#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

int n, d;
vector<vector<int>> gr;
vector<pair<int, int>> ans;
vector<int> h;

void dfs1(int v, int p) {
    for (auto u : gr[v]) {
        if (u != p) {
            h[u] = h[v] + 1;
            dfs1(u, v);
        }
    }
}

void solve() {
    cin >> n >> d;
    gr.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    h.resize(n);
    dfs1(0, -1);
    vector<int> r0;
    for (int i = 0; i < n; ++i) {
        if (h[i] % 2 == 0) {
            r0.push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (h[i] % 2 == 1 && !r0.empty()) {
            ans.emplace_back(i, r0.back());
            r0.pop_back();
        }
    }
    cout << szof(ans) << "\n";
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
