#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

int n, d;
vector<vector<int>> gr, dist, ngr;
vector<pair<int, int>> ans;
vector<int> col, mt, h;

void dfs1(int v, int p, int w) {
    for (auto u : gr[v]) {
        if (u != p) {
            dist[w][u] = dist[w][v] + 1;
            h[u] = h[v] + 1;
            dfs1(u, v, w);
        }
    }
}

bool dfs2(int v, int i) {
    col[v] = i;
    for (auto u : ngr[v]) {
        if (mt[u] == -1 || (col[mt[u]] != i && dfs2(mt[u], i))) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void solve() {
    cin >> n >> d;
    gr.resize(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dist.resize(n, vector<int>(n));
    h.resize(n);
    for (int i = 0; i < n; ++i) {
        h[i] = 0;
        dfs1(i, -1, i);
    }
    ngr.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dist[i][j] <= d && dist[i][j] % 2 == 1) {
                ngr[i].push_back(j);
                ngr[j].push_back(i);
            }
        }
    }
    col.resize(n, -1);
    mt.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        if (h[i] % 2 == 0) {
            dfs2(i, i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (mt[i] != -1) {
            ans.emplace_back(i, mt[i]);
        }
    }
    cout << szof(ans) << "\n";
    for (auto [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
