#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
using namespace std;

bool dfs(int v, int p, vector<vector<int>>& g, vector<bool>& used){
    used[v] = true;

    for (auto u: g[v]){
        if (u == p) continue;
        if (used[u]) return true;
        if (dfs(u, v, g, used)) return true;
    }

    return false;
}

int main(){
    int t;
    cin >> t;
    while (t--){
        int n, k;
        cin >> n >> k;
        vector<vector<int>> g(k);
        vector<int> l(k), m(k), r(k);
        for (int i = 0; i < k; i++){
            cin >> l[i] >> m[i] >> r[i];
        }

        unordered_set<int> st;

        for (int i = 0; i < k; i++){
            for (int j = 0; j < k; j++){
                if (i == j) continue;
                if (l[i] <= m[j] && m[j] <= r[i]){
                    g[i].push_back(j);
                    st.insert(j);
                }
            }
        }

        vector<bool> used(k);

        bool ans = true;

        for (int i = 0; i < k; i++){
            if (!st.count(i)){
                ans = dfs(i, -1, g, used);
                break;
            }
        }

        cout << (!ans ? "YES" : "NO") << endl;
    }
}