#include <vector>


#pragma GCC optimize ("O3,unroll-loops")
#pragma GCC target ("avx2")

#include <iostream>
#include <algorithm>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
#include <random>
#include <array>
using namespace std;

mt19937_64 rnd(1488);

const int MAX_N = 3500000;
int n;
vector<vector<int>> g(MAX_N);
vector<vector<int>> gg(MAX_N);
vector<int> mt(MAX_N, -1);
vector<int> used(MAX_N, 0);
vector<int> col(MAX_N);
int T = 1;


bool try_kuhn(int v){
    if (v < 0 || v >= n) return false;
    if (used[v] == T) return false;
    used[v] = T;

    for (auto u: g[v]){
        // if (used[u] == T) continue;
        if(mt[u] == -1){
            mt[u] = v;
            return true;
        }
    }

    for (auto u: g[v]){
        // if (used[u] == T) continue;
        if (mt[u] == v) continue;
        if (try_kuhn(mt[u])){
            mt[u] = v;
            return true;
        }
    }

    return false;
}

void dfs_col(int v, int p, int c){
    col[v] = c;
    for (auto u: g[v]){
        if (u == p) continue;
        dfs_col(u, v, 1 - c);
    }
}

void dfs_depth(int v, int p, int c, int fl){
    if (fl == 0){
        g[v].push_back(c);
        return;
    }

    for (auto u: gg[v]){
        if (u == p) continue;
        dfs_depth(u, v, c, fl - 1);
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    // g.resize(n);
    int d;
    cin >> d;
    for (int i = 0; i < n - 1; i++){
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs_col(0, -1, 0);

    vector<pair<int, int>> ans;

    
    array<vector<int>, 2> ar;
    for (int i = 0; i < n; i++){
        ar[col[i]].push_back(i);
    }

    for (int i = 0; i < ar[0].size() && i < ar[1].size(); i++){
        ans.push_back({ar[0][i], ar[1][i]});
    }
    
    cout << ans.size() << endl;
    for (auto k: ans){
        cout << k.first + 1 << ' ' << k.second + 1 << endl;
    }
}