#include <vector>


#pragma GCC optimize ("O3,unroll-loops")
#pragma GCC target ("avx2")

#include <iostream>
#include <algorithm>
#include <stack>
#include <string>
#include <set>
#include <unordered_set>
using namespace std;

const int MAX_N = 3500000;
int n;
vector<vector<int>> g(MAX_N);
vector<int> mt(MAX_N, -1);
vector<int> used(MAX_N);
vector<int> col(MAX_N);
int T = 1;


bool try_kuhn(int v){
    if (v < 0) return false;
    if (used[v] == T) return false;
    used[v] = T;

    for (auto u: g[v]){
        if (used[u] == T) continue;
        if(mt[u] == -1){
            mt[u] = v;
            return true;
        }
    }

    for (auto u: g[v]){
        if (used[u] == T) continue;
        if (mt[u] == v) continue;
        if (try_kuhn(mt[u])){
            mt[u] = v;
            return true;
        }
    }

    return false;
}

void dfs_col(int v, int p, int c){
    col[v] = c;
    for (auto u: g[v]){
        if (u == p) continue;
        dfs_col(u, v, !c);
    }
}

int main(){
    cin >> n;
    // g.resize(n);
    int d;
    cin >> d;
    for (int i = 0; i < n - 1; i++){
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs_col(0, -1, 0);

    for (int i = 0; i < n; i++){
        if (col[i] == 0){
            try_kuhn(i);
            T++;
        }
    }

    vector<pair<int, int>> ans;

    for (int i = 0; i < n; i++){
        if (col[i] == 1 && mt[i] != -1){
            ans.push_back({i, mt[i]});
        }
    }
    
    cout << ans.size() << endl;
    for (auto k: ans){
        cout << k.first + 1 << ' ' << k.second + 1 << endl;
    }
}