#include "iostream"
#include "stack"
#include "vector"
#include "numeric"
#include "algorithm"
#include "random"
using namespace std;
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")
vector<int> graph[300'000];
int por[300'000];
random_device rd;
mt19937 rnd(rd());
int matching[300'000];
int strange_dfs(int x, int p, int d) {
    if (!d) return (matching[x] == -1 ? x : -1);
    int res = 0;
    shuffle(graph[x].begin(), graph[x].end(), rnd);
    for (auto& i : graph[x]) {
        if (i == p) continue;
        res = strange_dfs(i, x, d - 1);
        if (res != -1) return res;
    }
    return -1;
}
void solve() {
    int n, d; cin >> n >> d;
    iota(por, por + n, 0);
    int l, r;
    for (int i = 1; i < n; i++) {
        cin >> l >> r; l--; r--;
        graph[l].push_back(r);
        graph[r].push_back(l);
    }
    int cnt = 400'000'000 / n / d;
    int ans;
    int best = 0;
    int maxcan = (d - 1) / 2 + 1;

    for (int i = 0; i < 30; i++) {
        shuffle(por, por + n, rnd);
        ans = 0;
        fill(matching, matching + n, -1);
        for (int dst = 1; dst <= d; dst += 2) {
            for (int j = 0, i = por[j]; j < n; j++, i = por[j]) {
                if (matching[i] == -1) {
                    matching[i] = strange_dfs(i, -1, 1 + (abs((int)rnd()) % maxcan) * 2);
                    if (matching[i] != -1) {
                        matching[matching[i]] = i;
                        ans++;
                    }
                }
            }
        }
        best = max(best, ans);
    }
    cout << best << "\n-1";
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}