#include <regex>

#include "iostream"
#include "stack"
#include "vector"
#include "numeric"
#include "algorithm"
#include "random"
using namespace std;
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")
constexpr int maxn = 300'000;
vector<int> graph[maxn];
int dp[2][maxn];
void fill_dfs(int x, int p) {
    if (graph[x].size() == 1 && p != -1) {
        dp[0][x] = 0;
        dp[1][x] = -maxn;
        return;
    }
    int cnt = 0;
    for (auto& i : graph[x]) {
        if (i == p) continue;
        fill_dfs(i, x);
        cnt += max(dp[0][i], dp[1][i]);
    }
    dp[0][x] = cnt;
    dp[1][x] = -maxn;
    for (auto& i : graph[x]) {
        if (i == p) continue;
        cnt -= max(dp[0][i], dp[1][i]);
        cnt += dp[0][i] + 1;
        dp[1][x] = max(dp[1][x], cnt);
        cnt -= dp[0][i] + 1;
        cnt += max(dp[0][i], dp[1][i]);
    }
}

void solve() {
    int n, d; cin >> n >> d;
    int l, r;
    for (int i = 1; i < n; i++) {
        cin >> l >> r; l--; r--;
        graph[l].push_back(r);
        graph[r].push_back(l);
    }
    fill_dfs(0, -1);
    cout << max(dp[0][0], dp[1][0]) << "\n-1";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}