#include "iostream"
#include "stack"
#include "vector"
#include "numeric"
#include "algorithm"
#include "random"
using namespace std;
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")
vector<int> graph[300'000];
int por[300'000];
random_device rd;
mt19937 rnd(rd());
int matching[300'000];
void rebuild(int x, int p) {
    shuffle(graph[x].begin(), graph[x].end(), rnd);
    for (auto& i : graph[x]) {
        if (i == p) continue;
        rebuild(i, x);
    }
}
int strange_dfs(int x, int p, int d) {
    if (!d) return (matching[x] == -1 ? x : -1);
    int res = 0;
    for (auto& i : graph[x]) {
        if (i == p) continue;
        res = strange_dfs(i, x, d - 1);
        if (res != -1) return res;
    }
    return -1;
}
void solve() {
    int n, d; cin >> n >> d;
    iota(por, por + n, 0);
    int l, r;
    for (int i = 1; i < n; i++) {
        cin >> l >> r; l--; r--;
        graph[l].push_back(r);
        graph[r].push_back(l);
    }
    int cnt = 1'000'000 / n;
    int best = 0;
    int maxcan = (d - 1) / 2 + 1;
    vector<pair<int, int>> pairs;
    vector<pair<int, int>> cur_pairs;
    for (int i = 0; i < cnt; i++) {
        shuffle(por, por + n, rnd);
        cur_pairs.clear();
        rebuild(0, -1);
        fill(matching, matching + n, -1);
        for (int dst = 1; dst <= 11; dst += 2) {
            for (int j = 0, i = por[j]; j < n; j++, i = por[j]) {
                if (matching[i] == -1) {
                    matching[i] = strange_dfs(i, -1, 1 + (abs((int)rnd()) % maxcan) * 2);
                    if (matching[i] != -1) {
                        cur_pairs.emplace_back(i, matching[i]);
                        matching[matching[i]] = i;
                    }
                }
            }
        }
        if (cur_pairs.size() > pairs.size()) pairs = cur_pairs;
    }
    cout << pairs.size() << "\n";
    for (auto& i : pairs) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}