#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

const int INF = 2e9;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mtx(n, vector<int>(m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char c;
            cin >> c;
            mtx[i][j] = c - '0';
        }
    }
    vector<vector<int>> dp(n, vector<int>(m, 0));
    vector<vector<int>> h(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i)
    {
        for (int j = m - 1; j >= 0; --j)
        {
            if (mtx[i][j] == 0)
            {
                h[i][j] = 0;
                continue;
            }
            if (i == 0)
            {
                h[i][j] = 1;
                continue;
            }
            h[i][j] = 1 + h[i - 1][j];
        }
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = m - 1; j >= 0; --j)
        {
            dp[i][j] = h[i][j];
            if (j == m - 1)
            {
                continue;
            }
            dp[i][j] += dp[i][j + 1];
            int mn = INF;
            for (int u = j + 1; u < m; ++u)
            {
                mn = min(mn, h[i][u]);
                if (mn > h[i][j])
                {
                    dp[i][j] -= (mn - h[i][j]);
                } else
                {
                    break;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = m - 1; j >= 0; --j)
        {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;

    return 0;
}
