#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct obj
{
    ll l, m, r;
};

bool operator<(obj x, obj y)
{
    //if (x.l != y.l) return x.l > y.l;
    return x.r > y.r;
}

vector<vector<int>> g;
vector<int> color;
bool f = 1;

void dfs(int v)
{
    color[v] = 1;
    for (int u : g[v])
    {
        if (!color[u])
        {
            dfs(u);
        }
        if (color[u] == 1)
        {
            f = 0;
        }
    }
    color[v] = 2;
}

void solve()
{
    int n, k;
    cin >> n >> k;
    vector<obj> a(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> a[i].l >> a[i].m >> a[i].r;
        --a[i].l;
        --a[i].m;
        --a[i].r;
    }
    sort(all(a));
    int lt = n;
    for (int i = 0; i < k; ++i)
    {
        if (a[i].r + 1 < lt)
        {
            cout << "NO\n";
            return;
        }
        lt = a[i].l;
    }
    if (lt != 0)
    {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < k; ++i)
    {
        if (a[i].l == 0 && a[i].r == n - 1)
        {
            cout << "YES\n";
            return;
        }
    }
    for (int i = 0; i < k; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            if (i == j) continue;
            if (a[i].l == 0 && a[j].r == n - 1 && a[i].r + 1 >= a[j].l)
            {
                if (a[i].l <= a[j].m && a[j].m <= a[i].l && a[j].l <= a[i].m && a[i].m <= a[j].r)
                {
                    continue;
                }
                cout << "YES\n";
                return;
            }
        }
    }
    cout << "NO\n";
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

