#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct obj
{
    ll l, m, r;
};

bool operator<(obj x, obj y)
{
    //if (x.l != y.l) return x.l > y.l;
    return x.r > y.r;
}

vector<vector<int>> g;
int n, k;
vector<obj> st;
vector<bool> forb;
set<int> used;
vector<obj> a;
bool ans;

void check(vector<obj> b)
{
    sort(all(b));
    int k1 = len(b);
    int lt = n;
    for (int i = 0; i < k1; ++i)
    {
        if (b[i].l >= lt) continue;
        if (b[i].r + 1 < lt)
        {
            return;
        }
        lt = b[i].l;
    }
    if (lt != 0) return;
    for (int i = 0; i < k1; ++i)
    {
        for (int j = 0; j < k1; ++j)
        {
            if (i == j) continue;
            int l = max(b[i].l, b[j].l);
            int r = min(b[i].r, b[j].r);
            bool cond1 = (l <= b[i].m && b[i].m <= r);
            bool cond2 = (l <= b[j].m && b[j].m <= r);
            if (cond1 && cond2)
            {
                return;
            }
        }
    }
    ans = 1;
}

void dfs(int v)
{
    used.insert(v);
    st.push_back(a[v]);
    vector<bool> fr(k, 1);
    for (int u : g[v])
    {
        fr[u] = 0;
    }
    vector<int> bck;
    for (int i = 0; i < k; ++i)
    {
        if (fr[i] && !forb[i])
        {
            forb[i] = 1;
        }
    }
    for (int u : g[v])
    {
        if (used.find(u) == used.end() && !forb[u])
        {
            dfs(u);
        }
    }
    check(st);
    for (int u : bck)
    {
        forb[u] = 0;
    }
    used.erase(v);
}

void solve()
{
    ans = 0;
    cin >> n >> k;
    a.assign(k, {0, 0, 0});
    for (int i = 0; i < k; ++i)
    {
        cin >> a[i].l >> a[i].m >> a[i].r;
        --a[i].l;
        --a[i].m;
        --a[i].r;
    }
    sort(all(a));
    int lt = n;
    for (int i = 0; i < k; ++i)
    {
        if (a[i].r + 1 < lt)
        {
            cout << "NO\n";
            return;
        }
        lt = a[i].l;
    }
    if (lt != 0)
    {
        cout << "NO\n";
        return;
    }
    g.assign(k, {});
    for (int i = 0; i < k; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            if (i == j) continue;
            int l = max(a[i].l, a[j].l);
            int r = min(a[i].r, a[j].r);
            bool cond1 = (l <= a[i].m && a[i].m <= r);
            bool cond2 = (l <= a[j].m && a[j].m <= r);
            /*if (cond1 && cond2)
            {
                cout << "NO\n";
                return;
            }*/
            if (!cond2)
            {
                g[i].push_back(j);
            }
            if (!cond1)
            {
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < k; ++i)
    {
        used.clear();
        forb.assign(k, 0);
        st.clear();
        dfs(i);
    }
    if (ans)
    {
        cout << "YES\n";
    } else
    {
        cout << "NO\n";
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

