#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;
using ld = long double;
using lll = __int128;

const ll INF = 4e18;

ll sq(ll x)
{
    return x * x;
}

ll dist(ll l, ll r, ll x)
{
    if (x < l)
    {
        return l;
    }
    if (x > r)
    {
        return r;
    }
    return x;
}

ll d;

lll f(ll t, ll k, ll x)
{
    return (lll)t * k + sq(x - (lll)k * d);
}

ll fih(ll x, ll t)
{
    ld kopt = (ld)(2 * x * d - t) / (2 * d * d);
    ll k1 = kopt;
    ll k2 = k1 + 1;
    ll k3 = k1 - 1;
    ll cur = min(f(t, k1, x), min(f(t, k2, x), f(t, k3, x)));
    return cur;
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> x[i];
    }
    ll x0;
    cin >> x0 >> d;
    for (int i = 0; i < n; ++i)
    {
        x[i] -= x0;
    }
    int m;
    cin >> m;
    vector<ll> t(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> t[i];
    }
    ll maxx = 0;
    for (int i = 0; i < n; ++i)
    {
        maxx = max(maxx, (abs(x[i]) / d + 1));
    }
    if (m == 1 && t[0] == 0)
    {
        ll ans = 0;
        for (int i = 0; i < n; ++i)
        {
            ll k = d * (x[i] / d);
            ans += min(sq(x[i] - k), min(sq(x[i] - k + d), sq(x[i] - k - d)));
        }
        cout << ans;
        return 0;
    }
    if (n == 1)
    {
        x[0] = abs(x[0]);
        for (int i = 0; i < m; ++i)
        {
            cout << fih(x[0], t[i]) << '\n';
        }
        return 0;
    }
    if (n == 2)
    {
        ll x1 = abs(x[0]);
        ll x2 = abs(x[1]);
        for (int i = 0; i < m; ++i)
        {
            ll s1 = fih(x1, t[i]) + sq(x2);
            ll s2 = fih(x2, t[i]) + sq(x1);
            ll s3 = fih(x1, 2 * t[i]) + fih(x2, t[i]);
            ll s4 = fih(x2, 2 * t[i]) + fih(x1, t[i]);
            cout << min(s1, min(s1, min(s3, s4))) << '\n';
        }
        return 0;
    }
    if (x0 == 0)
    {
        for (int i = 0; i < m; ++i)
        {
            ll ans = INF;
            ll l = -1, r = maxx + 1;
            while (r - l > 1)
            {
                ll mid = (l + r) / 2;
                ll cur = mid * t[i];
                for (int j = 0; j < n; ++j)
                {
                    ll l1 = x[j] / d;
                    ll r1 = l1 + 1;
                    if (x[j] < 0)
                    {
                        r1 = l1 - 1;
                    }
                    cur += min(sq(x[j] - dist(0, mid, r1) * d), sq(x[j] - dist(0, mid, l1) * d));
                }
                ll cur1 = (mid + 1) * t[i];
                for (int j = 0; j < n; ++j)
                {
                    ll l1 = x[j] / d;
                    ll r1 = l1 + 1;
                    if (x[j] < 0)
                    {
                        r1 = l1 - 1;
                    }
                    cur1 += min(sq(x[j] - dist(0, mid + 1, r1) * d), sq(x[j] - dist(0, mid + 1, l1) * d));
                }
                if (cur >= cur1)
                {
                    l = mid;
                } else
                {
                    r = mid;
                }
            }
            ll cur = l * t[i];
            for (int j = 0; j < n; ++j)
            {
                ll l1 = x[j] / d;
                ll r1 = l1 + 1;
                if (x[j] < 0)
                {
                    r1 = l1 - 1;
                }
                cur += min(sq(x[j] - dist(0, l, r1) * d), sq(x[j] - dist(0, l, l1) * d));
            }
            ll cur1 = (r) * t[i];
            for (int j = 0; j < n; ++j)
            {
                ll l1 = x[j] / d;
                ll r1 = l1 + 1;
                if (x[j] < 0)
                {
                    r1 = l1 - 1;
                }
                cur1 += min(sq(x[j] - dist(0, r, r1) * d), sq(x[j] - dist(0, r, l1) * d));
            }
            cout << min(cur, cur1) << '\n';
        }
        return 0;
    }
    for (int i = 0; i < m; ++i)
    {
        ll ans = INF;
        for (ll l = -maxx; l <= maxx; l += 1)
        {
            for (ll r = l; r <= maxx; r += 1)
            {
                ll cur = (abs(l) + abs(r) + min(abs(l), abs(r))) * t[i];
                for (int j = 0; j < n; ++j)
                {
                    /*ll l1 = x[j] / d;
                    ll r1 = l1 + 1;
                    if (x[j] < 0)
                    {
                        r1 = l1 - 1;
                    }
                    cur += min(sq(x[j] - dist(l, r, r1) * d), sq(x[j] - dist(l, r, l1) * d));*/
                    ll mn = INF;
                    for (ll u = l; u <= r; ++u)
                    {
                        mn = min(mn, sq(x[j] - u * d));
                    }
                    cur += mn;
                }
                ans = min(ans, cur);
            }
        }
        cout << ans << '\n';
    }

    return 0;
}

