#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

const ll INF = 1e18;
vector<vector<int>> g;
vector<int> col;
vector<int> dp0;
vector<int> dp1;
vector<int> way;
vector<bool> used;

void dfs(int v, int c)
{
    col[v] = c;
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
    }
}

void dfsdp(int v)
{
    used[v] = 1;
    dp0[v] = 0;
    dp1[v] = 0;
    way[v] = -1;
    vector<int> ch;
    int sum = 0;
    for (int u : g[v])
    {
        if (!used[u])
        {
            dfsdp(u);
            ch.push_back(u);
            dp0[v] += max(dp0[u], dp1[u]);
            sum += max(dp0[u], dp1[u]);
        }
    }
    for (int u : ch)
    {
        int cur = sum - max(dp0[u], dp1[u]) + dp0[u];
        if (dp1[v] < cur + 1)
        {
            dp1[v] = cur + 1;
            way[v] = u;
        }
    }
}

void build(int v, int c)
{
    used[v] = 1;
    if (c == 0 || way[v] == -1)
    {
        for (int u : g[v])
        {
            if (!used[u])
            {
                if (dp0[u] >= dp1[u])
                {
                    build(u, 0);
                } else
                {
                    build(u, 1);
                }
            }
        }
        return;
    } else
    {
        cout << v + 1 << ' ' << way[v] + 1 << '\n';
        build(way[v], 0);
        for (int u : g[v])
        {
            if (u == way[v]) continue;
            if (!used[u])
            {
                if (dp0[u] >= dp1[u])
                {
                    build(u, 0);
                } else
                {
                    build(u, 1);
                }
            }
        }
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    dp0.resize(n);
    dp1.resize(n);
    way.resize(n);
    col.resize(n, 0);
    for (int i = 0; i < n - 1; ++i)
    {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    if (d == 1)
    {
        used.assign(n, 0);
        dfsdp(0);
        int ans = max(dp0[0], dp1[0]);
        cout << ans << '\n';
        used.assign(n, 0);
        if (dp0[0] >= dp1[0])
        {
            build(0, 0);
        } else
        {
            build(0, 1);
        }
        return 0;
    }
    dfs(0, 1);
    int cnt1 = 0;
    for (int i = 0; i < n; ++i)
    {
        cnt1 += (col[i] == 1);
    }
    int cnt2 = n - cnt1;
    if (d == n - 1)
    {
        cout << min(cnt1, cnt2) << '\n';
        vector<int> v1;
        vector<int> v2;
        for (int i = 0; i < n; ++i)
        {
            if (col[i] == 1)
            {
                v1.push_back(i);
            } else
            {
                v2.push_back(i);
            }
        }
        for (int i = 0; i < min(cnt1, cnt2); ++i)
        {
            cout << v1[i] + 1 << ' ' << v2[i] + 1 << '\n';
        }
        return 0;
    }

    return 0;
}

