#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

const ll INF = 1e18;
vector<vector<int>> g;
vector<vector<int>> gmt;
vector<int> mt;
vector<int> usedmt;
int timer = 0;
vector<int> col;
vector<bool> used;
vector<int> h;
int n, d;
vector<int> vs;
vector<int> avs;

void dfs(int v, int c)
{
    col[v] = c;
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
    }
}

void dfsh(int v, int hs)
{
    if (hs > d) return;
    if (col[v] == 2)
    {
        vs.push_back(v);
    }
    avs.push_back(v);
    used[v] = 1;
    for (int u : g[v])
    {
        if (!used[u])
        {
            dfsh(u, hs + 1);
        }
    }
}

bool dfsmt(int v)
{
    if (usedmt[v] == timer) return 0;
    usedmt[v] = timer;
    for (int u : gmt[v])
    {
        if (mt[u] == -1)
        {
            mt[u] = v;
            return 1;
        }
    }
    for (int u : gmt[v])
    {
        if (dfsmt(mt[u]))
        {
            mt[u] = v;
            return 1;
        }
    }
    return 0;
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> d;
    g.resize(n);
    gmt.resize(n);
    h.resize(n);
    col.resize(n, 0);
    for (int i = 0; i < n - 1; ++i)
    {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, 1);
    used.assign(n, 0);
    h.assign(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (col[i] == 2) continue;
        vs.clear();
        avs.clear();
        dfsh(i, 0);
        for (int u : vs)
        {
            gmt[i].push_back(u);
        }
        for (int u : avs)
        {
            used[u] = 0;
        }
    }
    int mtcnt = 0;
    usedmt.assign(n, -1);
    mt.assign(n, -1);
    timer = 0;
    for (int i = 0; i < n; ++i)
    {
        if (dfsmt(i))
        {
            mtcnt += 1;
            timer += 1;
        }
    }
    cout << mtcnt << '\n';
    cout << -1;

    return 0;
}

