#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

vector<vector<int>> g;
vector<int> col;

void dfs(int v, int c)
{
    col[v] = c;
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, d;
    cin >> n >> d;
    g.resize(n);
    col.resize(n, 0);
    for (int i = 0; i < n - 1; ++i)
    {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, 1);
    int cnt1 = 0;
    for (int i = 0; i < n; ++i)
    {
        cnt1 += (col[i] == 1);
    }
    int cnt2 = n - cnt1;
    if (d == n - 1)
    {
        cout << min(cnt1, cnt2) << '\n';
        vector<int> v1;
        vector<int> v2;
        for (int i = 0; i < n; ++i)
        {
            if (col[i] == 1)
            {
                v1.push_back(i);
            } else
            {
                v2.push_back(i);
            }
        }
        for (int i = 0; i < min(cnt1, cnt2); ++i)
        {
            cout << v1[i] + 1 << ' ' << v2[i] + 1 << '\n';
        }
        return 0;
    }

    return 0;
}

