#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 1e9;

struct segtree {
    int n;
    vector<int> tree;

    int get(int v, int l, int r, int left, int right, int qval) {
        if (r <= left || right <= l) return inf;
        if (l + 1 == r) {
            if (tree[v] < qval) {
                return l;
            }
            return inf;
        }
        if (l == left && r == right) {
            int m = (l + r) / 2;
            if (tree[2 * v + 1] < qval) {
                return get(2 * v + 1, l, m, left, min(m, right), qval);
            } else {
                return get(2 * v + 2, m, r, max(m, left), right, qval);
            }
        }
        int m = (l + r) / 2;
        int lval = get(2 * v + 1, l, m, left, min(m, right), qval);
        if (lval != inf) return lval;
        return get(2 * v + 2, m, r, max(m, left), right, qval);
    }

    int get(int left, int right, int qval) {
        return get(0, 0, n, left, right, qval);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            tree[v] = min(tree[v], val);
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            update(2 * v + 1, l, m, pos, val);
        } else {
            update(2 * v + 2, m, r, pos, val);
        }
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void update(int pos, int val) {
        update(0, 0, n, pos, val);
    }

    segtree(int n) : n(n) {
        tree.resize(4 * n, inf);
    }
};

bool comp(array<int, 3> a, array<int, 3> b) {
    return a[2] < b[2];
}

bool intersect(array<int, 3> a, array<int, 3> b) {
    return b[0] <= a[1] && a[1] <= b[2] && a[0] <= b[1] && b[1] <= a[2];
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<array<int, 3>> seg(k);
    for (auto& [l, x, r] : seg) cin >> l >> x >> r;
    sort(seg.begin(), seg.end(), comp);
    vector<int> dp(k, inf);
    segtree dp1(n), dp2(n);
    for (int i = 0; i < k; i++) {
        auto [l, m, r] = seg[i];
        if (l == 1) {
            dp[i] = -1;
        }
        dp[i] = min(dp[i], dp1.get(l - 1, m, l));
        dp[i] = min(dp[i], dp2.get(l, n, l));
        // for (int j = 0; j < i; j++) {
        //     if (seg[i][0] <= seg[j][2] + 1 && seg[i][0] > dp[j] && seg[i][0] > seg[j][1]) {
        //         dp[i] = min(dp[i], seg[j][2]);
        //     }
        // }
        dp1.update(r, dp[i]);
        dp2.update(r, max(m, dp[i]));
    }
    // for (int i : dp) cout << i << " ";
    // cout << "\n";
    for (int i = 0; i < k; i++) {
        if (seg[i][2] == n && dp[i] < inf) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}