#pragma GCC optimize("O2,O3,unroll-loops")
#include <bits/stdc++.h>

using namespace std;

const int maxn = 3e5 + 123;

vector<int> adj[maxn];

vector<int> par_adj[maxn];

int n, maxd;

int start;

int col[maxn];

void coldfs(int v, int p, int c) {
    col[v] = c;
    for (int i : adj[v]) {
        if (i == p) continue;
        coldfs(i, v, 1 - c);
    }
}

void dfs(int v, int p, int d) {
    if (d > maxd) return;
    if (d % 2 == 1 && col[start]) {
        par_adj[start].push_back(v);
    }
    for (int i : adj[v]) {
        if (i == p) continue;
        dfs(i, v, d + 1);
    }
}

int mt[maxn], par[maxn], used[maxn];

bool dfs2(int v) {
    if (used[v]) return false;
    used[v] = 1;
    for (int i : par_adj[v]) {
        if (mt[i] == -1 || dfs2(mt[i])) {
            par[v] = i;
            mt[i] = v;
            return true;
        }
    }
    return false;
}

vector<pair<int, int>> solve() {
    fill(mt, mt + n, -1);
    fill(par, par + n, -1);
    bool found = true;
    while (found) {
        found = false;
        fill(used, used + n, 0);
        for (int j = 0; j < n; j++) {
            if (!used[j] && par[j] == -1) {
                found |= dfs2(j);
            }
        }
    }
    vector<pair<int, int>> pairs;
    for (int i = 0; i < n; i++) {
        if (mt[i] != -1) {
            pairs.push_back({i, mt[i]});
        }
    }
    return pairs;
}

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> maxd;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    coldfs(0, -1, 0);
    array<vector<int>, 2> cols;
    for (int i = 0; i < n; i++) {
        cols[col[i]].push_back(i);
    }
    cout << min(cols[0].size(), cols[1].size()) << "\n";
    while (cols[0].size() && cols[1].size()) {
        cout << cols[0].back() + 1 << " " << cols[1].back() + 1 << "\n";
        cols[0].pop_back();
        cols[1].pop_back();
    }
    return 0;
    for (int i = 0; i < n; i++) {
        start = i;
        dfs(i, -1, 0);
    }
    auto pairs = solve();
    cout << pairs.size() << "\n";
    for (auto [a, b] : pairs) {
        cout << a + 1 << " " << b + 1 << "\n";
    }
}