#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOC
#define debug(x) cerr << #x << " = " << x << '\n';
#else
#define debug(x)
#endif

struct T {
    int l, m, r;
};

bool operator<(T a, T b) {
    if (a.l != b.l) return a.l < b.l;
    if (a.r != b.r) return a.r < b.r;
    return a.m < b.m;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<T> A(k);
    int min_l = n + 1, max_r = -1;
    for (auto& i : A) {
        cin >> i.l >> i.m >> i.r;
        min_l = min(min_l, i.l);
        max_r = max(max_r, i.r);
    }
    if (min_l != 1 || max_r != n) {
        cout << "NO\n";
        return;
    }
    vector<vector<int>> graph(n);
    vector<vector<int>> rev_graph(n);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            if (A[j].l <= A[i].m && A[i].m <= A[j].r) {
                graph[j].push_back(i);
                rev_graph[i].push_back(j);
            }
        }
    }
    vector<int> cnt_child(n);
    queue<int> good;
    for (int i = 0; i < n; i++) {
        cnt_child[i] = graph[i].size();
        if (cnt_child[i] == 0) {
            good.push(i);
        }
    }
    int res = 0;
    while (!good.empty()) {
        int v = good.front();
        for (auto u : rev_graph[v]) {
            cnt_child[u]--;
            if (cnt_child[u] == 0) {
                good.push(u);
            }
        }
        good.pop();
        res++;
    }
    if (res == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
