#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOC
#define debug(x) cerr << #x << " = " << x << '\n';
#else
#define debug(x)
#endif

void bfs(int v, vector<int>& dst, vector<vector<int>>& graph) {
    queue<int> q;
    q.push(v);
    dst[v] = 0;
    while (!q.empty()) {
        int u = q.front();
        for (auto w : graph[u]) {
            if (dst[w] == -1) {
                dst[w] = dst[u] + 1;
                q.push(w);
            }
        }
        q.pop();
    }
}

vector<bool> used;
vector<int> match;
vector<vector<int>> graph2;

bool kune(int v) {
    if (used[v]) return false;
    used[v] = true;
    for (auto u : graph2[v]) {
        if (match[u] == -1 || kune(match[u])) {
            match[u] = v;
            return true;
        }
    }
    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d;
    cin >> n >> d;
    vector<vector<int>> graph(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    vector<vector<int>> dists(n, vector<int>(n, -1));
    for (int i = 0; i < n; i++) {
        bfs(i, dists[i], graph);
    }
    vector<int> first, second;
    for (int i = 0; i < n; i++) {
        if (dists[0][i] % 2 == 0) {
            first.push_back(i);
        } else {
            second.push_back(i);
        }
    }
    vector<int> firstb(n, -1), secondb(n, -1);
    for (int i = 0; i < (int)first.size(); i++) {
        firstb[first[i]] = i;
    }
    for (int i = 0; i < (int)second.size(); i++) {
        secondb[second[i]] = i;
    }
    graph2.assign(first.size(), {});
    for (auto i : first) {
        for (auto j : second) {
            if (i == j) continue;
            if (dists[i][j] > d) continue;
            graph2[firstb[i]].push_back(secondb[j]);
        }
    }
    match.assign(second.size(), -1);
    for (int i = 0; i < (int)first.size(); i++) {
        used.assign(first.size(), false);
        kune(i);
    }
    int ans = 0;
    for (auto i : match) {
        ans += i != -1;
    }
    cout << ans << '\n';
    for (int i = 0; i < (int)second.size(); i++) {
        if (match[i] == -1) continue;
        cout << second[i] + 1 << ' ' << first[match[i]] + 1 << '\n';
    }
}
