#include <bits/stdc++.h>
 
using namespace std;
 
using ll = long long;
using lll = __int128;

struct segtree{
    vector<ll> t;
    ll n;
    void build(vector<ll> &a, ll l, ll r, ll v) {
        if (r - l == 1) {
            t[v] = a[l];
        } else {
            ll m = (l + r) / 2;
            build(a, l, m, v * 2 + 1);
            build(a, m, r, v * 2 + 2);
            t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
        }
    }
    segtree(vector<ll> & a) {
        n = (ll)a.size();
        t.assign(n * 4, 0);
        build(a, 0, n, 0);
    }
    ll get(ll l, ll r, ll ql, ll qr, ll v) {
        if (l >= qr || r <= ql) {
            return 0;
        }
        if (ql <= l && qr >= r) {
            return t[v];
        }
        ll m = (l + r) / 2;
        return max(get(l, m, ql, qr, v * 2 + 1), get(m, r, ql, qr, v * 2 + 2));
    }
    ll get(ll l, ll r) {
        return get(0, n, l, r, 0);
    }
    void rep(ll l, ll r, ll v, ll a, ll x) {
        if (r - l == 1) {
            t[v] = x;
            return;
        }
        ll m = (l + r) / 2;
        if (a < m) {
            rep(l, m, v * 2 + 1, a, x);
        } else {
            rep(m, r, v * 2 + 2, a, x);
        }
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }
    void rep(ll a, ll x) {
        rep(0, n, 0, a, x);
    }
};
 
void solve() {
    ll n, k;
    cin >> n >> k;
    vector<pair<ll, ll>> m1;
    vector<pair<ll, ll>> m2;
    for (ll i = 0; i < k; i++) {
        ll l, m, r;
        cin >> l >> m >> r;
        if (m != l) {
            m1.push_back({l, m - 1});
        }
        if (m != r) {
            m2.push_back({m + 1, r});
        }
    }
    vector<ll> dp1(n + 1);
    vector<ll> dp2(n + 1);
    dp2[0] = 1;
    segtree st1(dp1);
    segtree st2(dp2);
    vector<pair<pair<ll, ll>, ll>> ve;
    for (auto [u, v] : m1) {
        ve.push_back({{u, v}, 1});
    }
    for (auto [u, v] : m2) {
        ve.push_back({{u, v}, 2});
    }
    sort(ve.begin(), ve.end());
    for (auto [x, y] : ve) {
        if (y == 1) {
            auto [u, v] = x;
            dp1[v] = max(dp1[v], max(st1.get(max(0ll, u - 2), v + 1), st2.get(u - 1, v + 1)));
            st1.rep(v, dp1[v]);
        } else {
            auto [u, v] = x;
            dp2[v] = max(dp2[v], max(st2.get(max(0ll, u - 2), v + 1), st1.get(max(0ll, u - 3), max(0ll, u - 2))));
            st2.rep(v, dp2[v]);
        }
    }
    if (dp1[n - 1] || dp2[n]) {
        cout << "YES" << endl;
        return;
    }
    dp1.assign(n + 1, 0);
    dp2.assign(n + 1, 0);
    dp2[0] = 1;
    st1.build(dp1);
    st2.build(dp2);
    for (auto [x, y] : ve) {
        if (y == 1) {
            auto [u, v] = x;
            dp1[v] = max(dp1[v], max(st1.get(max(0ll, u - 2), v + 1), st2.get(u - 1, v + 1)));
            st1.rep(v, dp1[v]);
        } else {
            auto [u, v] = x;
            dp2[v] = max(dp2[v], max(st2.get(max(0ll, u - 2), v + 1), st1.get(max(0ll, u - 3), max(0ll, u - 2))));
            st2.rep(v, dp2[v]);
        }
    }
    if (dp1[n - 1] || dp2[n]) {
        cout << "YES" << endl;
        return;
    } else {
        cout << "NO" << endl;
    }
}
 
signed main() {
    #ifdef zapvm
        freopen("in.txt", "r", stdin);
    #endif
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}