#include <bits/stdc++.h>

#ifndef DEBUG
#endif

using ll = long long;
using pll = std::pair<ll, ll>;

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct sgt {
    ll l, m, r;
};

struct Fenw {
    std::vector<ll> f;

    Fenw(ll sz) {
        f.clear();
        f.resize(sz + 1);
    }

    void upd(ll i, ll x) {
        ++i;
        while (i < f.size()) {
            f[i] += x;
            i += i & -i;
        }
    }

    void upd(ll l, ll r, ll x) {
        upd(l, x);
        if (r != f.size() - 1) {
            upd(r, -x);
        }
    }

    ll get(ll i) {
        ++i;
        ll ans = 0;
        while (i > 0) {
            ans += f[i];
            i -= i & -i;
        }
        return ans;
    }
};

bool cmp(sgt a, sgt b) {
    return a.m > b.m || (a.m == b.m && a.r > b.r);
}

void solve() {
    ll n, k;
    std::cin >> n >> k;
    std::vector<sgt> b(k);
    for (int i = 0; i < k; ++i) {
        std::cin >> b[i].l >> b[i].m >> b[i].r;
    }
    for (int msk = 0; msk < 1ll << k; ++msk) {
        std::vector<sgt> chs;
        for (int i = 0; i < k; ++i) {
            if ((msk >> i) & 1) {
                chs.push_back(b[i]);
            }
        }
        Fenw b(n + 1);
        bool flg = true;
        for (int i = 0; i < chs.size(); ++i) {
            for (int j = i + 1; j < chs.size(); ++j) {
                if (chs[i].l <= chs[j].m && chs[j].m <= chs[i].r && chs[j].l <= chs[i].m && chs[i].m <= chs[j].r) {
                    flg = false;
                }
            }
            b.upd(chs[i].l - 1, chs[i].r, 1);
        }
        for (int i = 0; i < n; ++i) {
            if (!b.get(i)) {
                flg = false;
                break;
            }
        }
        if (flg) {
            std::cout << "YES\n";
            return;
        }
    }
    std::cout << "NO\n";
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
