#include <bits/stdc++.h>

#ifndef DEBUG
#endif

using ll = long long;
using pll = std::pair<ll, ll>;

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct sgt {
    ll l, m, r;
};

struct Fenw {
    std::vector<ll> f;

    Fenw(ll sz) {
        f.clear();
        f.resize(sz + 1);
    }

    void upd(ll i, ll x) {
        ++i;
        while (i < f.size()) {
            f[i] += x;
            i += i & -i;
        }
    }

    void upd(ll l, ll r, ll x) {
        upd(l, x);
        if (r != f.size() - 1) {
            upd(r, -x);
        }
    }

    ll get(ll i) {
        ++i;
        ll ans = 0;
        while (i > 0) {
            ans += f[i];
            i -= i & -i;
        }
        return ans;
    }
};

bool cmp1(sgt a, sgt b) {
    if (a.l < b.l || (a.l == b.l && a.m < b.m) || (a.l == b.l && a.m == b.m && a.r > b.r)) {
        return true;
    }
    return false;
}

bool cmp(sgt a, sgt b) {
    if (a.m < b.l || a.m > b.r || b.m < a.l || b.m > a.r) {
        return true;
    }
    return false;
}

void solve() {
    ll n, k;
    std::cin >> n >> k;
    std::vector<sgt> b(k);
    for (int i = 0; i < k; ++i) {
        std::cin >> b[i].l >> b[i].m >> b[i].r;
    }
    std::sort(b.begin(), b.end(), cmp1);
    Fenw bb(n + 1);
    std::vector<ll> dp(k, -1e9);
    for (int l = 0; l < k; ++l) {
        if (b[l].l == 1) {
            dp[l] = b[l].r;
        }
        for (int j = l - 1; j >= 0; --j) {
            if (dp[j] != -1e9 && b[j].r >= b[l].l - 1 && cmp(b[j], b[l])) {
                dp[l] = b[l].r;
            }
        }
    }
    if (*std::max_element(dp.begin(), dp.end()) == n) {
        std::cout << "YES\n";
    }
    else {
        std::cout << "NO\n";
    }
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
