#include <bits/stdc++.h>

#ifndef DEBUG
#endif

using ll = long long;

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct sgt {
    ll l, m, r;
};

bool cmp(sgt a, sgt b) {
    if (a.l <= b.m && b.m < a.r) {
        return false;
    }
    return true;
}

struct Fenw {
    std::vector<ll> f;

    Fenw(ll sz) {
        f.resize(sz + 1);
    }

    void upd(ll i, ll x) {
        ++i;
        while (i < f.size()) {
            f[i] += x;
            i += i & -i;
        }
    }

    void upd(ll l, ll r, ll x) {
        upd(l, x);
        if (r != f.size() - 1) {
            upd(r, -x);
        }
    }

    ll get(ll i) {
        ++i;
        ll ans = 0;
        while (i > 0) {
            ans += f[i];
            i -= i & -i;
        }
        return ans;
    }
};

void solve() {
    ll n, k;
    std::cin >> n >> k;
    std::vector<sgt> b(k);
    for (int i = 0; i < k; ++i) {
        std::cin >> b[i].l >> b[i].m >> b[i].r;
        --b[i].l;
        --b[i].m;
    }
    std::sort(b.begin(), b.end(), cmp);
    Fenw d(n + 1);
    for (int i = 0; i < k; ++i) {
        if (!d.get(b[i].m)) {
            d.upd(b[i].l, b[i].r, 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!d.get(i)) {
            std::cout << "NO\n";
            return;
        }
    }
    std::cout << "YES\n";
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
