#include <bits/stdc++.h>

#ifndef DEBUG
#endif

using ll = long long;
using pll = std::pair<ll, ll>;

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct sgt {
    ll l, m, r;
};

struct Fenw {
    std::vector<ll> f;

    Fenw(ll sz) {
        f.clear();
        f.resize(sz + 1);
    }

    void upd(ll i, ll x) {
        ++i;
        while (i < f.size()) {
            f[i] += x;
            i += i & -i;
        }
    }

    void upd(ll l, ll r, ll x) {
        upd(l, x);
        if (r != f.size() - 1) {
            upd(r, -x);
        }
    }

    ll get(ll i) {
        ++i;
        ll ans = 0;
        while (i > 0) {
            ans += f[i];
            i -= i & -i;
        }
        return ans;
    }
};

bool cmp(sgt a, sgt b) {
    if (a.l <= b.m && b.m <= a.r && b.l <= a.m && a.m <= b.r) {
        return false;
    }
    return true;
}

void solve() {
    ll n, k;
    std::cin >> n >> k;
    std::vector<sgt> b(k);
    for (int i = 0; i < k; ++i) {
        std::cin >> b[i].l >> b[i].m >> b[i].r;
    }
    Fenw bb(n + 1);
    bool flg = false;
    for (int str = 0; str < k; ++str) {
        bb.upd(b[str].l - 1, b[str].r, 1);
        if (str != k - 1 && !cmp(b[str], b[str + 1])) {
            flg = true;
        }
    }
    for (int j = 0; j < n; ++j) {
        if (!bb.get(j)) {
            flg = true;
        }
    }
    if (!flg) {
        std::cout << "YES\n";
        return;
    }
    std::cout << "NO\n";
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}