#include <bits/stdc++.h>

#ifndef DEBUG
#pragma GCC optimize("O3")
#endif

using ll = int;

std::vector<std::vector<ll>> G1;
std::vector<ll> used, mt, clrr;
ll timer = 1;
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

bool dfs(ll v) {
    if (used[v] == timer) {
        return false;
    }
    used[v] = timer;
    for (auto u : G1[v]) {
        if (mt[u] == -1) {
            mt[u] = v;
            return true;
        }
    }
    for (auto u : G1[v]) {
        if (dfs(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

void clr(ll v, ll clrd = 1) {
    clrr[v] = clrd;
    for (auto u : G1[v]) {
        if (!clrr[u]) {
            clr(u, 3 - clrd);
        }
    }
}

void solve() {
    ll n;
    std::cin >> n;
    used.resize(n);
    clrr.resize(n);
    ll d;
    std::cin >> d;
    std::vector<std::vector<ll>> G(n);
    G1.resize(n);
    for (int i = 1; i < n; ++i) {
        ll v, u;
        std::cin >> v >> u;
        --v, --u;
        G[v].push_back(u);
        G[u].push_back(v);
    }
    std::vector<ll> dst(n, -1);
    for (int v = 0; v < n; ++v) {
        dst[v] = 0;
        std::deque<ll> q = {v};
        std::vector<ll> cc;
        while (!q.empty()) {
            ll u = q.front();
            cc.push_back(u);
            q.pop_front();
            if (dst[u] % 2) {
                G1[v].push_back(u);
            }
            if (dst[u] == d) {
                continue;
            }
            for (auto U : G[u]) {
                if (dst[U] == -1) {
                    dst[U] = dst[u] + 1;
                    q.push_back(U);
                }
            }
        }
        for (int i = 0; i < cc.size(); ++i) {
            dst[cc[i]] = -1;
        }
        std::shuffle(G1[v].begin(), G1[v].end(), rnd);
    }
    clrr.resize(n);
    clr(0, 1);
    mt.resize(n, -1);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (clrr[i] == 1 && dfs(i)) {
            ++ans;
            ++timer;
        }
    }
    std::cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        if (mt[i] == -1) {
            continue;
        }
        std::cout << i + 1 <<' '<< mt[i] + 1 << '\n';
    }
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
}
