#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll INF = 1e7;


vector<ll> func (vector<ll> x, ll x0, ll d) {
    if (x.empty()) {
        vector<ll> r (INF+d);
        return r;
    }
    ll n = x.size();
    for (int i = 0; i < x.size(); ++i) {
        x[i] -= x0;
    }
    x0 = 0;
    vector<ll> sq_suf(n), suf(n);
    for (int i = n - 1; i >= 0; --i) {
        sq_suf[i] = x[i] * x[i];
        suf[i] = x[i];
        if (i != n - 1) {
            sq_suf[i] += sq_suf[i + 1];
            suf[i] += suf[i + 1];
        }
    }
    vector<ll> nei(n);
    for (int i = 0; i < n; ++i) {
        ll k = (x[i]) % d;
        ll p = d - k;
        p = min(k, p);
        nei[i] += p * p;
        if (i != 0)
            nei[i] += nei[i - 1];
    }
    vector<ll> t (INF+d);
    ll cnt = 0;
    for (int i = 0; i < t.size(); i += d) {
        while (cnt < n && x[cnt] <= i)
            cnt++;
        if (cnt != 0)
            t[i] += nei[cnt-1];
        if (cnt != n) {
            t[i] += sq_suf[cnt] - 2*i*suf[cnt] + i*i *(n-cnt);
        }
    }
    vector<ll> p;
    for (int i = 0; i < INF+d; i += d) {
        p.push_back(t[i]);
    }
    return p;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    ll n, m;
    cin >> n;
    vector<ll> x(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    ll x0, d;
    cin >> x0 >> d;
    sort(x.begin(), x.end());
    vector<ll> a1, a2;
    for (int i = 0; i < n; ++i) {
        if (x[i] < x0)
            a1.push_back(x[i]);
        else
            a2.push_back(x[i]);
    }
    reverse(a1.begin(), a1.end());
    for (int i = 0; i < a1.size(); ++i) {
        a1[i] = 2*x0-a1[i];
    }
    vector<ll> r1 = func (a1, x0, d);
    vector<ll> r2 = func (a2, x0, d);
    cin >> m;
    vector<pair<ll, ll>> t (m);
    for (int i = 0; i < m; ++i) {
        cin >> t[i].first;
        t[i].second = i;
    }

    sort(t.begin(), t.end());

    vector<ll> ans (m);
    for (int i = 0; i < m; ++i) {
        ll s1 = 0;
        ll l = 0, r = r1.size();
        ll L = r1[l] + l * t[i].first * 2, R = 1e18;
        while (l+2 < r) {
            ll m1 = (r-l)/3+l;
            ll m2 = r-(r-l)/3;
            ll v1 = r1[m1] + m1 * t[i].first * 2;
            ll v2 = r1[m2] + m2 * t[i].first * 2;
            if (v1 < v2) {
                r = m2;
                R = v2;
            }
            else if (v2 < v1) {
                l = m1;
                L = v1;
            }
            else {
                l = m1;
                L = v1;
                r = m2;
                R = v2;
            }
        }
        ll M = (l+r)/2;
        M = r1[M] + M * t[i].first * 2;
        L = min(L, min(R, M));
        s1 += L;


        l = 0, r = r2.size();
        L = r2[l] + l * t[i].first, R = 1e18;
        while (l+2 < r) {
            ll m1 = (r-l)/3+l;
            ll m2 = r-(r-l)/3;
            ll v1 = r2[m1] + m1 * t[i].first;
            ll v2 = r2[m2] + m2 * t[i].first;
            if (v1 < v2) {
                r = m2;
                R = v2;
            }
            else if (v2 < v1) {
                l = m1;
                L = v1;
            }
            else {
                l = m1;
                L = v1;
                r = m2;
                R = v2;
            }
        }
        M = (l+r)/2;
        M = r2[M] + M * t[i].first;
        L = min(L, min(R, M));
        s1 += L;


        ll s2 = 0;
        l = 0, r = r2.size();
        L = r2[l] + l * t[i].first * 2, R = 1e18;
        while (l+2 < r) {
            ll m1 = (r-l)/3+l;
            ll m2 = r-(r-l)/3;
            ll v1 = r2[m1] + m1 * t[i].first * 2;
            ll v2 = r2[m2] + m2 * t[i].first * 2;
            if (v1 < v2) {
                r = m2;
                R = v2;
            }
            else if (v2 < v1) {
                l = m1;
                L = v1;
            }
            else {
                l = m1;
                L = v1;
                r = m2;
                R = v2;
            }
        }
        M = (l+r)/2;
        M = r2[M] + M * t[i].first * 2;
        L = min(L, min(R, M));
        s2 += L;




        l = 0, r = r2.size();
        L = r2[l] + l * t[i].first, R = 1e18;
        while (l+2 < r) {
            ll m1 = (r-l)/3+l;
            ll m2 = r-(r-l)/3;
            ll v1 = r1[m1] + m1 * t[i].first;
            ll v2 = r1[m2] + m2 * t[i].first;
            if (v1 < v2) {
                r = m2;
                R = v2;
            }
            else if (v2 < v1) {
                l = m1;
                L = v1;
            }
            else {
                l = m1;
                L = v1;
                r = m2;
                R = v2;
            }
        }
        M = (l+r)/2;
        M = r2[M] + M * t[i].first;
        L = min(L, min(R, M));
        s2 += L;
        ll res = min (s1, s2);
        ans[t[i].second] = res;
    }
    for (ll i : ans)
        cout << i << '\n';
}
