#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}


void solution() {
    int n, m;
    cin >> n >> m;

    vector<vector<bool>> a(n, vector<bool>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char x; cin >> x;
            a[i][j] = x - '0';
        }
    }

    vector<vector<int>> len(n, vector<int>(m));
    for (int j = m - 1; j >= 0; --j) {
        for (int i = 0; i < n; ++i) {
            if (j == m - 1) {
                len[i][j] = a[i][j];
            } else {
                if (a[i][j]) len[i][j] = len[i][j + 1] + 1;
            }
        }
    }

    int best = 0;
    for (int j = 0; j < m; ++j) {
        vector<int> st = {-1};
        vector<int> sm(n);
        for (int i = 0; i < n; ++i) {
            while (st.back() != -1 && len[st.back()][j] > len[i][j]) {
                st.pop_back();
            }
            int v = st.back();
            if (v == -1) {
                sm[i] = (i + 1) * len[i][j];
            } else {
                sm[i] = (i - v) * len[i][j] + sm[v];
            }
            best = max(best, sm[i]);
            st.push_back(i);
        }
    }

    cout << best << '\n';
}