#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
#include <queue>
using namespace std;
#define int long long
 
void solution();
 
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif
 
    int t;
    cin >> t;
    while (t--) {
        solution();
    }
}

struct se {
    int l, m, r;
};

void solution() {
    int n, k;
    cin >> n >> k;

    vector<se> lmr;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        lmr.push_back({l, m, r});
    }

    vector<vector<int>> gr(k);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            auto [l1, m1, r1] = lmr[i];
            auto [l2, m2, r2] = lmr[j];

            if (l2 <= l1 || r2 <= r1 || l2 > r1 + 1) continue;
            if (m2 <= r1 && l2 <= m1) continue;
            gr[i].push_back(j);
            gr[j].push_back(i);
        }
    }

    queue<int> q;
    vector<bool> used(k);
    for (int i = 0; i < k; ++i) {
        if (lmr[i].l == 1) {
            q.push(i);
            used[i] = true;
        }
    }

    while (!q.empty()) {
        int s = q.front();
        q.pop();
        
        for (auto v : gr[s]) {
            if (used[v]) continue;
            used[v] = true;
            q.push(v);
        }
    }

    for (int i = 0; i < k; ++i) {
        if (lmr[i].r == n && used[i]) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";
}