#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
#include <queue>
using namespace std;
#define int long long
 
void solution();
 
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif
 
    int t;
    cin >> t;
    while (t--) {
        solution();
    }
}

struct se {
    int l, m, r;
};

struct rmq {
    int n;
    vector<int> t;
    rmq(int _n) {
        n = _n;
        t.assign(n * 4, 1e9);
    }

    void update(int v, int vl, int vr, int l, int r, int x) {
        if (vl >= r || l >= vr) return;
        if (l <= vl && vr <= r) {
            t[v] = min(t[v], x);
            return;
        }
        int vm = (vl + vr) / 2;
        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm, vr, l, r, x);
    }

    int get(int v, int vl, int vr, int pos) {
        if (vl > pos || vr <= pos) return 1e9;
        if (vl + 1 == vr) return t[v];
        int vm = (vl + vr) / 2;
        return min(get(v * 2 + 1, vl, vm, pos), get(v * 2 + 2, vm, vr, pos));
    }
};

void solution() {
    int n, k;
    cin >> n >> k;

    vector<se> lmr;
    for (int i = 0; i < k; ++i) {
        int l, m, r;
        cin >> l >> m >> r;
        lmr.push_back({l, m, r});
    }


    sort(lmr.begin(), lmr.end(), [](se a, se b) {return a.r < b.r;});

    vector<int> cm, cr;
    cr.push_back(0);
    rmq t(k + 1);
    t.update(0, 0, n, 0, 1, 0);
    for (auto [l, m, r] : lmr) {
        int pos = lower_bound(cr.begin(), cr.end(), l - 1) - cr.begin();
        if (pos == cr.size()) continue;
        if (cr[pos] < m || t.get(0, 0, n, pos) < l) {
            cr.push_back(r);
            t.update(0, 0, n, 0, cr.size(), m);
        }
    }

    if (cr.back() == n) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}