#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
#include <queue>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

vector<bool> used;
vector<vector<int>> to;
vector<int> match;

bool kuhn(int s) {
    used[s] = true;
    for (auto v : to[s]) {
        if (match[v] == -1 || (!used[match[v]] && kuhn(match[v]))) {
            match[v] = s;
            return true;
        }
    }
    return false;
}

void solution() {
    int n;
    cin >> n;

    int d;
    cin >> d;

    vector<vector<int>> gr(n);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    vector<vector<int>> dist(n, vector<int>(n, -1));
    for (int i = 0; i < n; ++i) {
        queue<int> q;
        q.push(i);
        dist[i][i] = 0;
        while (!q.empty()) {
            int s = q.front();
            q.pop();
            for (auto v : gr[s]) {
                if (dist[i][v] != -1) continue;
                dist[i][v] = dist[i][s] + 1;
                q.push(v);
            }
        }
    }

    vector<int> col0, col1;

    

    queue<int> q;
    vector<int> col(n, -1);
    q.push(0);
    col[0] = 0;
    while (!q.empty()) {
        int s = q.front();
        q.pop();

        if (col[s] == 0) col0.push_back(s);
        else col1.push_back(s);

        for (auto v : gr[s]) {
            if (col[v] != -1) continue;
            col[v] = !col[s];
            q.push(v);
        }
    }

    to.resize(col0.size());
    for (int i = 0; i < col0.size(); ++i) {
        for (int j = 0; j < col1.size(); ++j) {
            if (dist[col0[i]][col1[j]] <= d) {
                to[i].push_back(j);
            }
        }
    }

    used.resize(col0.size());
    match.assign(col1.size(), -1);
    for (int i = 0; i < col0.size(); ++i) {
        used.assign(col0.size(), false);
        kuhn(i);
    }

    vector<pair<int, int>> res;
    for (int i = 0; i < col1.size(); ++i) {
        int j = match[i];
        if (j == -1) continue;
        res.emplace_back(col0[j], col1[i]);
    }

    cout << res.size() << '\n';
    for (auto [i, j] : res) {
        cout << i + 1 << ' ' << j + 1 << '\n';
    }
}