#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
#include <queue>
using namespace std;
#define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

vector<bool> used;
vector<vector<int>> to;
vector<int> match;

bool kuhn(int s) {
    used[s] = true;
    for (auto v : to[s]) {
        if (match[v] == -1 || (!used[match[v]] && kuhn(match[v]))) {
            match[v] = s;
            return true;
        }
    }
    return false;
}

void solution() {
    int n;
    cin >> n;

    int d;
    cin >> d;

    vector<vector<int>> gr(n);

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    vector<int> col0, col1;

    queue<int> q;
    vector<int> col(n, -1);
    q.push(0);
    col[0] = 0;
    while (!q.empty()) {
        int s = q.front();
        q.pop();

        if (col[s] == 0) col0.push_back(s);
        else col1.push_back(s);

        for (auto v : gr[s]) {
            if (col[v] != -1) continue;
            col[v] = !col[s];
            q.push(v);
        }
    }

    if (col0.size() > col1.size()) col0.swap(col1);
    
    cout << col0.size() << '\n';
    for (int i = 0; i < col0.size(); ++i) {
        cout << col0[i] + 1 << ' ' << col1[i] + 1 << '\n';
    }
}