#include <iostream>
#include <vector>
#include <cstdint>
#include <iomanip>
#include <algorithm>
#include <queue>
using namespace std;
#define int long long
  
void solution();
  
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif
  
    solution();
}
  
vector<vector<int>> gr;
vector<int> dp0, dp1;
vector<int> pr;
 
void dfs(int s, int p) {
    for (auto v : gr[s]) {
        if (v == p) continue;
        dfs(v, s);
        dp0[s] += dp1[v];
    }
 
    dp1[s] = dp0[s];
    pr[s] = s;
    for (auto v : gr[s]) {
        if (v == p) continue;
        int res = dp0[s] - dp1[v] + dp0[v] + 1;
        if (res > dp1[s]) {
            dp1[s] = res;
            pr[s] = v;
        }
    }
}

vector<pair<int, int>> ans;

void vost(int s, int p, bool flag) {
    if (!flag) {
        for (auto v : gr[s]) {
            if (v == p) continue;
            vost(v, s, true);
        }
        return;
    }

    if (pr[s] == s) {
        vost(s, p, false);
        return;
    }

    ans.emplace_back(s, pr[s]);
    for (auto v : gr[s]) {
        if (v == p) continue;
        if (v == pr[s]) vost(v, s, false);
        else vost(v, s, true);
    }
}
  
void solution() {
    int n;
    cin >> n;
 
    int d;
    cin >> d;
     
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
 
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
 
    dp0.resize(n);
    dp1.resize(n);
    pr.resize(n);
 
    dfs(0, -1);
    vost(0, -1, true);

    cout << ans.size() << '\n';
    for (auto [u, v] : ans) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}