#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct ST
{
    vector<int> vals;
    vector<int> tree;
    int layer_size;

    int f(int a, int b)
    {
        if (a == -1)
            return b;
        if (b == -1)
            return a;
        if (vals[a] > vals[b])
            return a;
        return b;
    }

    ST() {}
    ST(int n, vector<int> &vals, vector<int> &ord): vals(vals)
    {
        for (layer_size = 1; layer_size < n; layer_size *= 2) {}
        tree.resize(2 * layer_size, -1);

        for (int i = 0; i < ord.size(); i++)
            tree[ord[i] + layer_size] = i;
        
        for (int i = layer_size - 1; i >= 1; i--)
            tree[i] = f(tree[i * 2], tree[i * 2 + 1]);
    }

    int _ans(int l, int r, int tl, int tr, int v)
    {
        if (tl >= r || tr <= l)
            return -1;
        if (l <= tl && tr <= r)
            return tree[v];
        int tm = (tl + tr) / 2;
        return f(_ans(l, r, tl, tm, v * 2), _ans(l, r, tm, tr, v * 2 + 1));
    }

    int ans(int l, int r)
    {
        return _ans(l, r, 0, layer_size, 1);
    }

    void del(int i)
    {
        i += layer_size;
        tree[i] = -1;

        while (i /= 2)
            tree[i] = f(tree[i * 2], tree[i * 2 + 1]);
    }
};

vector<bool> used;
vector<int> l;
vector<int> m;
vector<int> r;
ST st_r;
ST st_m;

void dfs(int u)
{
    used[u] = true;
    st_r.del(l[u]);
    st_m.del(l[u]);
    bool ok = true;
    while (ok)
    {
        int v = st_r.ans(m[u] + 1, r[u] + 2);
        ok = false;
        if (v != -1 && r[v] > r[u])
        {
            dfs(v);
            ok = true;
        }
        v = st_m.ans(l[u] + 1, r[u] + 1);
        if (v != -1 && m[v] > r[u])
        {
            dfs(v);
            ok = true;
        }
    }
}

void solve()
{
    used.clear();
    l.clear();
    m.clear();
    r.clear();

    int n, k;
    cin >> n >> k;

    l.resize(k);
    m.resize(k);
    r.resize(k);
    used.resize(k);
    for (int i = 0; i < k; i++)
    {
        cin >> l[i] >> m[i] >> r[i];
        --l[i];
        --m[i];
        --r[i];
    }
    st_r = ST(n + 1, r, l);
    st_m = ST(n + 1, m, l);

    for (int i = 0; i < k; i++)
    {
        if (!used[i] && l[i] == 0)
        {
            dfs(i);
        }
    }

    for (int i = 0; i < k; i++)
    {
        if (used[i] && r[i] == n - 1)
            return void(cout << "YES\n");
    }
    cout << "NO\n";
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif

    while (t--)
        solve();
    return 0;
}