#include <iostream>
#include <vector>
#include <stack>
#include <set>
#pragma GCC optimize("Ofast")

using namespace std;

const int inf = 1e9;

typedef long long ll;

int u;
vector<int> used;
vector<int> ans;
vector<vector<int>> gr;

void dfs(int ind, int t) {
    used[ind] = t;
    for (auto i : gr[ind]) {
        if (used[i] == 0) {
            dfs(i, 3 - t);
        }
    }
}

bool dfs_par(int ind) {
    used[ind] = u;
    for (auto i : gr[ind]) {
        if (ans[i] == -1) {
            ans[i] = ind;
            return 1;
        }
    }
    for (auto i : gr[ind]) {
        if (used[ans[i]] != u && dfs_par(ans[i])) {
            ans[i] = ind;
            return 1;
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, d, u, v;
    cin >> n >> d;
    vector<int> a(n);
    gr.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> u >> v;
        u--, v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dfs(0, 1);
    ans.resize(n, -1);
    vector<int> t1;
    vector<int> t2;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            t1.push_back(i);
        } else {
            t2.push_back(i);
        }
    }
    used.clear();
    used.resize(n, 0);
    int cnt = 0;
    u = 1;
    for (int i = 0; i < t1.size(); i++) {
        int h = dfs_par(t1[i]);
        if (h) {
            cnt++;
            u++;
        }
    }
    cout << cnt << '\n';
    for (auto i : t2) {
        if (ans[i] != -1) {
            cout << i + 1 << " " << ans[i] + 1 << '\n';
        }
    }
    return 0;
}