#include <bits/stdc++.h>

using namespace std;

void dfs(int i, int p, int c, vector<int> &col, vector<vector<int>> &gr) {
    col[i] = c;
    for (auto &j : gr[i]) {
        if (j == p) continue;
        dfs(j, i, (c + 1) % 2, col, gr);
    }
}

vector<int> match;
int d;

bool dfs(int i, vector<int> &used, int cur_used, vector<vector<int>> &gr) {
    if (used[i] == cur_used) return false;
    used[i] = cur_used;
    vector<pair<pair<int, int>, int>> tgr;
    for (auto &j : gr[i]) {
        tgr.push_back({{j, -1}, 1});
    }
    while (tgr.size() > 0) {
        int j = tgr.back().first.first;
        int dist = tgr.back().second;
        int par = tgr.back().first.second;
        tgr.pop_back();
        if (match[j] == -1 || dfs(match[j], used, cur_used, gr)) {
            match[j] = i;
            return true;
        }
        if (dist == d) continue;
        for (auto &x : gr[j]) {
            if (x == par) continue;
            for (auto &y : gr[x]) {
                if (y == j) continue;
                tgr.push_back({{y, x}, dist + 2});
            }
        }
    }
    return false;
}

int main() {
    int n;
    cin >> n;
    cin >> d;
    vector<vector<int>> gr(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    for (auto &i : gr) {
        random_shuffle(i.begin(), i.end());
    }
    vector<int> col(n);
    dfs(0, -1, 0, col, gr);
    vector<int> c0, c1;
    for (int i = 0; i < n; i++) {
        if (col[i] == 1) {
            c1.push_back(i);
        } else {
            c0.push_back(i);
        }
    }
    if (c0.size() > c1.size()) swap(c1, c0);
    match.resize(n, -1);
    int cur_used = 1;
    vector<int> used(n);
    for (auto &i : c0) {
        dfs(i, used, cur_used, gr);
        cur_used++;
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (match[i] != -1) {
            ans.push_back({match[i], i});
        }
    }
    cout << ans.size() << endl;
    for (auto &i : ans) {
        cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
}