#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

ll f(vector<ll>& v) {
	map<ll, ll>mp;
	ll cur_sum = 0;
	ll best = 0;
	vector<ll>del;
	for (auto& el : v) {
		mp[el] = 1;
		cur_sum += el;
		auto it = mp.upper_bound(el);
		for (it; it != mp.end(); ++it) {
			ll val = it->first, cnt = it->second;
			cur_sum -= val * cnt;
			cur_sum += el * cnt;
			mp[el] += cnt;
			del.push_back(val);
		}
		while (!del.empty()) {
			mp.erase(del.back());
			del.pop_back();
		}
		best = max(best, cur_sum);
	}
	return best;
}

void solve() {
	ll h, w; cin >> h >> w;
	vector<vector<ll>>v(h, vector<ll>(w));
	for (ll i = 0; i < h; ++i) {
		for (ll j = 0; j < w; ++j) {
			char c; cin >> c;
			v[i][j] = (c - '0');
		}
	}
	vector<vector<ll>>mx(h, vector<ll>(w, 0));
	for (ll i = 0; i < h; ++i) {
		for (ll j = w - 1; j >= 0; --j) {
			if (v[i][j] == 0) mx[i][j] = 0;
			else mx[i][j] = (j == w - 1 ? 1 : mx[i][j + 1] + 1);
		}
	}
	ll ans = 0;
	for (ll b = 0; b < w; ++b) {
		vector<ll>x;
		for (ll j = 0; j < h; ++j) x.push_back(mx[j][b]);
		ans = max(ans, f(x));
	}
	cout << ans;
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
