#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

struct T {
	ll l, m, r, ind;
	T() {}
	T(ll l, ll m, ll r, ll ind) {
		this->l = l;
		this->m = m;
		this->r = r;
		this->ind = ind;
	}
};

vector<ll>tree;

void upd(ll lq, ll rq, ll u, ll l, ll r) {
	if (tree[u]) return;
	if (l == lq && r == rq) {
		tree[u] = 1;
		return;
	}
	ll m = (l + r) / 2;
	if (rq <= m) upd(lq, rq, u * 2 + 1, l, m);
	else if (lq > m) upd(lq, rq, u * 2 + 2, m + 1, r);
	else {
		upd(lq, m, u * 2 + 1, l, m);
		upd(m + 1, rq, u * 2 + 2, m + 1, r);
	}
}

ll fnd(ll ind, ll u, ll l, ll r) {
	if (tree[u]) return 1;
	if (l == r) return tree[u];
	ll m = (l + r) / 2;
	if (ind <= m) return fnd(ind, u * 2 + 1, l, m);
	return fnd(ind, u * 2 + 2, m + 1, r);
}


bool f(vector<T>& w, ll n) {
	tree.assign(4 * n, 0);
	for (auto& el : w) {
		ll l = el.l, m = el.m, r = el.r;
		if (fnd(m, 0, 0, n - 1)) continue;
		upd(l, r, 0, 0, n - 1);
	}
	for (ll i = 0; i < n; ++i) {
		if (!fnd(i, 0, 0, n - 1)) {
			return false;
		}
	}
	return true;
}

bool find_cycle(vector<vector<ll>>& g, vector<ll>& used, ll u) {
	used[u] = 1;
	for (auto& v : g[u]) {
		if (used[v] == 2) continue;
		if (used[v] == 1) return true;
		if (find_cycle(g, used, v)) return true;
	}
	used[u] = 2;
	return false;
}

void topsort(vector<vector<ll>>&g, vector<ll>& ts, ll u, vector<ll>used) {
	used[u] = 3;
	for (auto& v : g[u]) {
		if (used[v] == 3) continue;
		topsort(g, ts, v, used);
	}
	ts.push_back(u);
}

void solve() {
	ll n, k; cin >> n >> k;
	vector<T>w;
	for (ll i = 0; i < k; ++i) {
		ll l, m, r; cin >> l >> m >> r;
		l--; m--; r--;
		w.emplace_back(l, m, r, i);
	}
	vector<vector<ll>>g(k);
	for (ll i = 0; i < k; ++i) {
		for (ll j = i + 1; j < k; ++j) {
			if (w[i].m >= w[j].l && w[i].m <= w[j].r) {
				g[i].push_back(j);
			}
			if (w[j].m >= w[i].l && w[j].m <= w[i].r) {
				g[j].push_back(i);
			}
		}
	}
	vector<ll>used(k, 0);
	for (ll i = 0; i < k; ++i) {
		if (used[i]) continue;
		if (find_cycle(g, used, 0)) {
			cout << "NO";
			return;
		}
	}
	vector<ll>ts;
	for (ll i = 0; i < k; ++i) {
		if (used[i] == 3) continue;
		topsort(g, ts,
	vector<T>nw;
	for (ll i = 0; i < k; ++i) nw.push_back(w[ts[i]]);
	if (f(nw, n)) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}