#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

struct T {
	ll l, m, r, ind;
	T() {}
	T(ll l, ll m, ll r, ll ind) {
		this->l = l;
		this->m = m;
		this->r = r;
		this->ind = ind;
	}
};

bool cmp(const T& a, const T& b) {
	return a.l < b.l;
}

void solve() {
	ll n, k; cin >> n >> k;
	vector<T>w;
	for (ll i = 0; i < k; ++i) {
		ll l, m, r; cin >> l >> m >> r;
		l--; m--; r--;
		if (l == 0 && r == n - 1) {
			cout << "YES";
			return;
		}
		w.emplace_back(l, m, r, i);
	}
	sort(all(w), cmp);
	vector<ll>r;
	vector<ll>m;
	for (ll i = 0; i < k; ++i) {
		if (w[i].r == n - 1) {
			r.push_back(w[i].l);
			m.push_back(w[i].m);
		}
	}
	vector<ll>pref(r.size(), 0);
	if (r.size()) {
		pref[0] = m[0];
		for (ll i = 1; i < r.size(); ++i) pref[i] = max(m[i], pref[i - 1]);
		for (auto& i : w) {
			if (i.r == n - 1) continue;
			ll b = i.r;
			ll ind = upper_bound(all(r), b + 1) - r.begin() - 1;
			if (ind < 0 || ind >= pref.size()) continue;
			if (pref[ind] > b) {
				cout << "YES";
				return;
			}
		}
	}

	for (auto& i : w) {
		i.l = n - i.l - 1;
		i.r = n - i.r - 1;
		i.m = n - i.m - 1;
		swap(i.l, i.r);
	}

	sort(all(w), cmp);
	r.clear();
	m.clear();
	for (ll i = 0; i < k; ++i) {
		if (w[i].r == n - 1) {
			r.push_back(w[i].l);
			m.push_back(w[i].m);
		}
	}
	pref.resize(r.size());
	if (r.size()) {
		pref[0] = m[0];
		for (ll i = 1; i < r.size(); ++i) pref[i] = max(m[i], pref[i - 1]);
		for (auto& i : w) {
			if (i.r == n - 1) continue;
			ll b = i.r;
			ll ind = upper_bound(all(r), b + 1) - r.begin() - 1;
			if (ind < 0 || ind >= pref.size()) continue;
			if (pref[ind] > b) {
				cout << "YES";
				return;
			}
		}
	}
	cout << "NO";
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}