#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

struct T {
	ll l, m, r;
	T() {}
	T(ll l, ll m, ll r) {
		this->l = l;
		this->m = m;
		this->r = r;
	}
};

bool operator<(const T& a, const T& b) {
	return a.l > b.l;
}

vector<ll>tree;

void upd(ll lq, ll rq, ll u, ll l, ll r) {
	if (tree[u]) return;
	if (l == lq && r == rq) {
		tree[u] = 1;
		return;
	}
	ll m = (l + r) / 2;
	if (rq <= m) upd(lq, rq, u * 2 + 1, l, m);
	else if (lq > m) upd(lq, rq, u * 2 + 2, m + 1, r);
	else {
		upd(lq, m, u * 2 + 1, l, m);
		upd(m + 1, rq, u * 2 + 2, m + 1, r);
	}
}

ll fnd(ll ind, ll u, ll l, ll r) {
	if (tree[u]) return 1;
	if (l == r) return tree[u];
	ll m = (l + r) / 2;
	if (ind <= m) return fnd(ind, u * 2 + 1, l, m);
	else return fnd(ind, u * 2 + 2, m + 1, r);
}

void solve() {
	ll n, k; cin >> n >> k;
	tree.assign(n, 0);
	vector<T>w(k);
	for (auto& i : w) {
		ll l, m, r; cin >> l >> m >> r;
		i = T(l - 1, m - 1, r - 1);
	}
	sort(all(w));
	
	for (ll i = 0; i < n; ++i) {
		if (!fnd(i, 0, 0, n - 1)) {
			cout << "NO";
			return;
		}
	}
	cout << "YES";
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}
