#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = __int128;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll inf = 1e30;

__int128 read() {
    string s; cin >> s;
    ll f = 1, x = 0;
    for (auto c: s) {
        if (c == '-') f *= -1;
        else {
            x *= 10;
            x += c - '0';
        }
    }
    return x * f;
}

void print(__int128 x, bool z = true) {
    if (x < 0) {
        cout << '-';
        x *= -1;
    }
    if (x == 0) {
        if (z) cout << 0;
        return;
    }
    print(x / 10, false);
    cout << (int)(x % 10);
}

pii nst(ll x, ll d) {
    if (x >= 0) {
        return {x / d, (x + d - 1) / d};
    }
    return {-((-x + d - 1) / d), -(-x / d)};
}

ll abs(ll k) {
    if (k >= 0) return k;
    return -k;
}

ll dist(ll k, ll t, ll d, ll x) {
    return t * abs(k) + (k * d - x) * (k * d - x);
}


void solve() {
    ll n = read();
    vector<ll>x(n);
    for (auto& i : x) i = read();
    ll x0 = read(), d = read();
    for (auto &i : x) {
        i -= x0;
    }
    ll m = read();
    for (ll it = 1; it <= m; ++it){
        ll t = read();
        ll ans = inf;
        pii a = nst(x[0], d), b = nst(x[1], d);
        for (auto st : {a.first, a.second}) {
            for (auto fn : {b.first, b.second}) {
                ans = min({ans,
                    dist(st, t, d, x[0]) + t * abs(st) + dist(fn, t, d, x[1]),
                    dist(fn, t, d, x[1] +  t * abs(fn) + dist(st, t, d, x[0]))
                });
            }
        }
        print(ans);
        cout << '\n';
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t = 1;

    while (t--) {
        solve();
        cout << '\n';
    }
}