#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll k = 20;

vector<vector<ll>>g;
vector<ll>col;

void dfs(ll u = 0, ll pr = -1, ll cl = 0) {
	col[u] = cl;
	for (auto& v : g[u]) {
		if (v == pr) continue;
		dfs(v, u, 1 - cl);
	}
}



void solve() {
	ll n; cin >> n;
	ll d; cin >> d;
	g.resize(n);
	col.resize(n);
	for (ll i = 1; i < n; ++i) {
		ll u, v; cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs();
	vector<ll>b, g;
	for (ll i = 0; i < n; ++i) {
		if (col[i]) b.push_back(i);
		else g.push_back(i);
	}
	cout << min(b.size(), g.size()) << '\n';
	for (ll i = 0; i < min(b.size(), g.size()); ++i) {
		cout << b[i] + 1 << ' ' << g[i] + 1 << '\n';
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}