#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = __int128;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll inf = 1e30;

__int128 read() {
    string s; cin >> s;
    ll f = 1, x = 0;
    for (auto c: s) {
        if (c == '-') f *= -1;
        else {
            x *= 10;
            x += c - '0';
        }
    }
    return x * f;
}

void print(__int128 x, bool z = true) {
    if (x < 0) {
        cout << '-';
        x *= -1;
    }
    if (x == 0) {
        if (z) cout << 0;
        return;
    }
    print(x / 10, false);
    cout << (int)(x % 10);
}

pii nst(ll x, ll d) {
    if (x >= 0) {
        return {x / d, (x + d - 1) / d};
    }
    return {-((-x + d - 1) / d), -(-x / d)};
}

ll abs(ll k) {
    if (k >= 0) return k;
    return -k;
}

ll dist(ll k, ll t, ll d, ll x, ll st = 0) {
    return t * abs(st - k) + (k * d - x) * (k * d - x);
}

ll tern_search(ll st, ll x, ll d, ll t) {
    ll l = 0, r = (x - st + d - 1) / d;
    while (r - l > 2) {
        ll lm = l + (r - l) / 3, rm = r - (r - l) / 3;
        ll fa = dist(lm, t, d, x, st);
        ll fb = dist(rm, t, d, x, st);
        if (fa <= fb) r = rm;
        if (fa >= fb) l = lm;
    }
    ll ans = inf;
    for (ll k = l; k <= r; ++k) {
        ans = min(ans, dist(k, t, d, x, st));
    }
    return ans;
}

void solve() {
    ll n = read();
    vector<ll>x(n);
    for (auto& i : x) i = read();
    ll x0 = read(), d = read();
    for (auto &i : x) {
        i -= x0;
    }
    ll m = read();
    for (ll it = 1; it <= m; ++it){
        ll t = read();
        ll a = x[0], b = x[1];
        ll l = -(-x[0] + d - 1) / d, r = 0;
        while (r - l > 2) {
            ll lm = l + (r - l) / 3, rm = r - (r - l) / 3;
            ll fa = tern_search(lm, b, d, t) + dist(lm, t, d, a);
            ll fb = tern_search(rm, b, d, t) + dist(rm, t, d, a);
            if (fa <= fb) r = rm;
            if (fa >= fb) l = lm;
        }
        ll ans = inf;
        for (ll k = l; k <= r; ++k) {
            ans = min(ans, tern_search(k, b, d, t) + dist(k, t, d, a));
        }
        swap(a, b);
        a = -a; b = -b;

        l = -(-x[0] + d - 1) / d, r = 0;
        while (r - l > 2) {
            ll lm = l + (r - l) / 3, rm = r - (r - l) / 3;
            ll fa = tern_search(lm, b, d, t) + dist(lm, t, d, a);
            ll fb = tern_search(rm, b, d, t) + dist(rm, t, d, a);
            if (fa <= fb) r = rm;
            if (fa >= fb) l = lm;
        }
        for (ll k = l; k <= r; ++k) {
            ans = min(ans, tern_search(k, b, d, t) + dist(k, t, d, a));
        }
        print(ans);
        cout << '\n';
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t = 1;

    while (t--) {
        solve();
        cout << '\n';
    }
}