#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
using ll = __int128;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

__int128 read() {
    string s; cin >> s;
    ll f = 1, x = 0;
    for (auto c: s) {
        if (c == '-') f *= -1;
        else {
            x *= 10;
            x += c - '0';
        }
    }
    return x * f;
}

void print(__int128 x, bool z = true) {
    if (x < 0) {
        cout << '-';
        x *= -1;
    }
    if (x == 0) {
        if (z) cout << 0;
        return;
    }
    print(x / 10, false);
    cout << (int)(x % 10);
}

pii nst(ll x, ll x0, ll d) {
    if (x % d == x0 % d) return { x, x };
    if (x0 < x) {
        ll k = (x - x0) / d;
        return { x0 + k * d, x0 + (k + 1) * d };
    }
    ll k = (x0 - x) / d;
    return { x0 - (k + 1) * d, x0 - k * d };
}

void solve() {
    ll n = read();
    vector<ll>x(n);
    for (auto& i : x) i = read();
    sort(all(x));
    ll x0 = read(), d = read();
    ll m = read();
    ll t = read();
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        pii s = nst(x[i], x0, d);
        ll a = (s.first - x[i]) * (s.first - x[i]);
        ll b = (s.second - x[i]) * (s.second - x[i]);
        ans += min(a, b);
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t = 1;
#ifdef _DEBUG
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cin >> t;
#endif
    while (t--) {
        solve();
        cout << '\n';
    }
}