#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll k = 20;

vector<vector<ll>>g;
vector<ll>h;
vector<vector<ll>>pred;

void dfs(ll u = 0, ll pr = -1, ll ht = 0) {
	h[u] = ht;
	if (u == 0) {
		for (auto& i : pred[u]) i = 0;
	}
	else {
		pred[u][0] = pr;
		for (ll i = 1; i < k; ++i) {
			pred[u][i] = pred[pred[u][i - 1]][i - 1];
		}
	}
	for (auto& v : g[u]) {
		if (v == pr) continue;
		dfs(v, u, ht + 1);
	}
}

ll dist(ll u, ll v) {
	if (h[u] < h[v]) swap(u, v);
	ll hu = h[u], hv = h[v];
	for (ll i = k - 1; i >= 0; --i) {
		if (h[pred[u][i]] >= h[v]) u = pred[u][i];
	}
	if (u == v) return hv - hu;
	for (ll i = k - 1; i >= 0; --i) {
		if (pred[u][i] != pred[v][i]) {
			u = pred[u][i];
			v = pred[v][i];
		}
	}
	ll hl = h[pred[u][0]];
	return hl - hu + hl - hv;
}

void solve() {
	ll n; cin >> n;
	ll d; cin >> d;
	g.resize(n);
	h.resize(n);
	pred.assign(n, vector<ll>(k));
	for (ll i = 1; i < n; ++i) {
		ll u, v; cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs();
	cout << n / 2;
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}