#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll k = 20;

vector<vector<ll>>g;
vector<ll> dp0;
vector<pii> dp1;

void dfs(ll u = 0, ll pr = -1) {
	dp0[u] = 0;
	vector<ll>x;
	ll cur = 0;
	for (auto& v : g[u]) {
		if (v == pr) continue;
		dfs(v, u);
		dp0[u] += max(dp0[v], dp1[v].first);
		x.push_back(v);
		cur += max(dp0[v], dp1[v].first);
	}
	for (auto& v : x) {
		ll c = cur - max(dp0[v], dp1[v].first) + dp0[v];
		dp1[u] = max(dp1[u], { c + 1, v });
	}
}

void solve() {
	ll n; cin >> n;
	ll d; cin >> d;
	g.resize(n);
	dp0.resize(n);
	dp1.resize(n);
	for (ll i = 1; i < n; ++i) {
		ll u, v; cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs();
	cout << max(dp0[0], dp1[0].first);
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}