#include <iostream>
#include <vector>

using namespace std;

int main() {
    int h, w;
    cin >> h >> w;
    vector<string> table(h);
    for (int i = 0; i < h; i++) {
        cin >> table[i];
    }
    vector<vector<int>> heights(h, vector<int>(w, 0));
    for (int i = 0; i < w; i++) {
        if (table[0][i] == '1') {
            heights[0][i] = 1;
        }
    }
    for (int i = 0; i < w; i++) {
        for (int j = 1; j < h; j++) {
            if (table[j][i] == '1') {
                heights[j][i] = heights[j - 1][i] + 1;
            }
        }
    }
    vector<vector<int>> ans(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        vector<pair<int, int>> st;
        for (int j = w - 1; j >= 0; j--) {
            while (!st.empty() && st.back().first > heights[i][j]) {
                st.pop_back();
            }
            if (st.empty()) {
                ans[i][j] = heights[i][j] * (w - j);
            } else {
                ans[i][j] = heights[i][j] * (st.back().second - j) + ans[i][st.back().second];
            }
            st.emplace_back(heights[i][j], j);
        }
    }
    int res = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            res = max(res, ans[i][j]);
        }
    }
    cout << res << endl;
    return 0;
}