#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct person {
    int l, m, r;
};

int k;
vector<person> people;
vector<int> used;
vector<int> top_sort;
vector<vector<int>> g;

inline void dfs(int v) {
    used[v] = 1;
    for (int i : g[v]) {
        if (!used[i]) {
            dfs(i);
        }
    }
    top_sort.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n >> k;
        used.assign(k, 0);
        for (int i = 0; i < k; i++) {
            int l, m, r;
            cin >> l >> m >> r;
            people.emplace_back(l, m, r);
        }
        g.resize(k);
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                if (people[j].m <= people[i].r && people[j].m >= people[i].l) {
                    g[i].push_back(j);
                }
            }
        }
        int res = 1;
        for (int i = 0; i < k; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        vector<int> inds(k);
        for (int i = 0; i < k; i++) {
            inds[top_sort[i]] = i;
        }
        for (int i = 0; i < k; i++) {
            for (int j : g[i]) {
                if (inds[i] <= inds[j]) {
                    res = 0;
                }
            }
        }
        if (res) {
            cout << "YES" << endl;
        } else {
            cout << "NO" << endl;
        }
    }
    return 0;
}