#include <iostream>
#include <cassert>
#include <vector>
using namespace std;
#define line cout << "\n"
#define pii pair<int, int>
#define pb push_back
#define all(a) a.begin(), a.end()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(a) (int) a.size()
  
  
int max(int a, int b) {
    return (a > b ? a : b);
}
  
int min(int a, int b) {
    return (a < b ? a : b);
}
const int MAXN = 20;
const int LOG = 5;
vector<vector<int>> g(MAXN);
vector<int> dp(MAXN);
vector<vector<int>> up(MAXN, vector<int>(LOG));
vector<int> tin(MAXN), tout(MAXN);
int t = 1;

void dfs(int v, int p) {
    dp[v] = dp[p] + 1;
    tin[v] = t++;
    up[v][0] = p;
    for (int i = 1; i < LOG; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto &u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
    }
    tout[v] = t++;
}


bool check(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}


int get_lca(int a, int b) {
    if (check(a, b)) {
        return dp[a];
    }
    if (check(b, a)) {
        return dp[b];
    }
    for (int i = LOG - 1; i >= 0; i--) {
        if (!check(i, up[a][i])) {
            a = up[a][i];
        }
    }
    return dp[up[a][0]];
}
  
void solve() {
    int n, d;
    cin >> n >> d;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(b);
        g[b].pb(a);
    }
    vector<pii> ans((1 << n), {-1, -1});
    ans[0] = {0, 0};
    dfs(0, 0);
    int ans_cnt = 0, ans_mask = 0;
    for (int i = 0; i < (1 << n); i++) {
        if (ans[i].first == -1) {
            continue;
        }
        int calc = 0;
        for (int a = 0; a < n; a++) {
            if (i & (1 << a)) {
                calc++;
            }
        }
        if (ans_cnt < calc) {
            ans_cnt = calc;
            ans_mask = i;
        }
        for (int a = 0; a < n; a++) {
            for (int b = a + 1; b < n; b++) {
                if (i & (1 << a)) {
                    continue;
                }
                if (i & (1 << b)) {
                    continue;
                }
                int t = get_lca(a, b);
                if ((dp[a] + dp[b] - t * 2) <= d && (dp[a] + dp[b]) % 2 == 1) {
                    ans[i + (1 << a) + (1 << b)] = {a, b};
                }
            }
        }
    }
    cout << ans_cnt / 2; line;
    while (ans_mask) {
        int a = ans[ans_mask].first;
        int b = ans[ans_mask].second;
        cout << a + 1 << " " << b + 1; line;
        ans_mask -= (1 << a);
        ans_mask -= (1 << b);
    }
}
  
  
signed main() {
    fast;
 
 
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}