// D_1_1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#define not !
#define and &&
#define or ||
using namespace std;

vector<vector<int>> G;
vector<int> D, P, tin, tout;
vector<vector<int>> binup;
int t = 0, n = 0, d = 0;

void dfs(int v, int p) {
	t++;
	binup[v][0] = p;
	tin[v] = t;
	for (int i = 0; i < 20 and binup[v][i] != -1; i++) {
		binup[v][i + 1] = binup[binup[v][i]][i];
	}
	P[v] = p;
	if (p != -1)D[v] = D[p] + 1;
	for (auto& i : G[v]) {
		if (i == p)continue;
		dfs(i, v);
	}
	tout[v] = t;
}

bool is_upper(int v, int u) {
	if (v == -1)return 1;
	if (tin[v] <= tin[u] and tout[u] <= tout[v])return 1;
	return 0;
}

int lca(int u, int v) {
	if (is_upper(u, v))return u;
	for (int i = 19; i > -1; i--) {
		if (not is_upper(binup[u][i], v))u = binup[u][i];
	}
	return binup[u][0];
}

int dist(int u, int v) {
	return D[u] + D[v] - D[lca(u, v)] * 2;
}

vector<int> ps;
vector<int> used;

int it_ps(int v) {
	//cout << "!" << " " << v << endl;
	used[v] = 1;
	if ((D[v] & 1) == 0) {
		for (int i = 0; i < n; i++) {
			if (dist(i, v) <= d and D[i] % 2 == 1 and (used[i] == 0) and ps[i] != v) {
				if (ps[i] == -1) {
					ps[v] = i;
					ps[i] = v;
					return 1;
				}
				if (it_ps(i)) {
					ps[v] = i;
					ps[i] = v;
					return 1;
				}
			}
		}
	}
	else {
		if (not used[ps[v]])
			return it_ps(ps[v]);
		else return 0;
	}
	return 0;
}

int main()
{
	cin >> n >> d;
	G.assign(n, {});
	D.assign(n, 0);
	P.assign(n, 0);
	tin.assign(n, 0);
	tout.assign(n, 0);
	binup.assign(n, vector<int>(20, -1));
	ps.assign(n, -1);
	used.assign(n, 0);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		G[a].push_back(b);
		G[b].push_back(a);
	}
	dfs(0, -1);
	while (1) {
		used.assign(n, 0);
		int A = -1, N = 0;
		while (A < n - 1) {
			A += 1;
			if (D[A] % 2 == 1)continue;
			if (ps[A] != -1)continue;
			N = 1;
			break;
		}
		if (not N)break;
		if (not it_ps(A))break;
	}
	vector<pair<int, int>> PS;
	for (int i = 0; i < n; i++) {
		if (D[i] % 2 == 0) {
			int j = ps[i];
			if (j != -1) {
				PS.push_back({ i + 1, j + 1 });
			}
		}
	}
	cout << PS.size() << endl;
	for (auto& i : PS) {
		if (dist(i.first, i.second) > d)throw "RE";
		cout << i.first << " " << i.second << endl;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
