#include <bits/stdc++.h>
using namespace std;
#define int ll
typedef long long ll;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T> > &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const vector<pair<T1, T2> > &a) {
    for (const auto &i: a)out << i;
    return out;
}

using T = ll;

struct Line {
    T k, b;

    Line(T k = {}, T b = {}): k(k), b(b) {
    }

    T operator()(int x) const {
        return k * x + b;
    }
};

constexpr ll inf = 1e18 + 7;

struct LiChao {
    vector<Line> d;
    int n;
    map<int, int> mp;
    vector<int> x;

    LiChao() = default;

    explicit LiChao(vector<int> x) {
        vector<int> b = x;
        sort(b.begin(), b.end());
        b.resize(unique(b.begin(), b.end()) - b.begin());
        n = b.size();
        int t = 0;
        sort(x.begin(), x.end());
        for (int i: x) {
            if (i != b[t])t++;
            mp[i] = t;
        }
        this->x = b;
        d.resize(4 * n, {0, inf});
    }

    void update(Line l) {
        update(0, 0, n, l);
    }

    void update(int t, int tl, int tr, Line l) {
        const int tm = (tl + tr) / 2;
        if (l(x[tm]) < d[t](x[tm]))swap(d[t], l);
        if (l.k == d[t].k)return;
        if (tl + 1 == tr)return;
        if (l.k > d[t].k)update(2 * t + 1, tl, tm, l);
        else update(2 * t + 2, tm, tr, l);
    }

    T get(int x) {
        return get(0, 0, n, mp[x]);
    }

    T get(int t, int tl, int tr, int pos) {
        if (tl + 1 == tr)return d[t](x[pos]);
        int tm = (tl + tr) / 2;
        if (pos < tm)return min(d[t](x[pos]), get(2 * t + 1, tl, tm, pos));
        return min(d[t](x[pos]), get(2 * t + 2, tm, tr, pos));
    }
};

struct Test {
    int n{};
    vector<int> x;
    int x0{};
    int d{};
    int m{};
    vector<int> t;

    Test() {
        cin >> n;
        x.resize(n);
        cin >> x;
        cin >> x0 >> d >> m;
        t.resize(m);
        cin >> t;
        LiChao li_chao(t);
        ll x2 = 0;
        ll x1 = 0;
        ll add = 0;
        for (int i = 0; i < n; i++) {
            x1 += x[i];
            x2 += x[i] * x[i];
        }
        sort(x.begin(), x.end());
        int now_x = 0;
        for (ll k = 0; k*d <= x.back()+d; k++) {
            while (now_x!=n&&x[now_x] <= k * d) {
                ll k1 = k * d;
                ll xx = x[now_x];
                bool flag=false;
                if ((xx - k1) * (xx - k1) > (xx - k1 + d) * (xx - k1 + d)) {
                    k--;
                    flag=true;
                }
                x2 -= x[now_x] * x[now_x];
                x1 -= x[now_x];
                add += (x[now_x] - k * d) * (x[now_x] - k * d);
                k+=flag;
                now_x++;
            }
            ll k1 = k;
            ll b1 = x2 - 2 * k * d * x1 + k * d * k * d * (n - now_x) + add;
            //cerr << k1 << ' ' << b1 << '\n';
            li_chao.update({k1, b1});
        }
        /*
        for (int now_x = 0; now_x < n; now_x++) {
            while (x[now_x] > k * d) {
                ll k1 = k;
                ll b1 = x2 - 2 * k * d * x1 + k * d * k * d * (n - now_x) + add;
                cerr << k1 << ' ' << b1 << '\n';
                li_chao.update({k1, b1});
                k++;
            }
            x2 -= x[now_x] * x[now_x];
            x1 -= x[now_x];
            if ((x[now_x] - k * d) * (x[now_x] - k * d) < (x[now_x] - k * d - d) * (x[now_x] - k * d - d)) {
            }
            add += (x[now_x] - k * d) * (x[now_x] - k * d);
        }
        */
        for (auto q: t) {
            cout << li_chao.get(q) << '\n';
        }
    }
};

signed main() {
#ifdef Local
    freopen(".in", "r",stdin);
    freopen(".out", "w",stdout);
    auto start = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cout.precision(20);
    int t = 1;
    //cin>>t;
    while (t--) Test();
#ifdef Local
    cerr << setprecision(5) << 1e3 * (clock() - start) / CLOCKS_PER_SEC << "ms\n";
#endif
}
