#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T> > &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const vector<pair<T1, T2> > &a) {
    for (const auto &i: a)out << i;
    return out;
}


struct Test {
    int n;
    vector<vector<int> > g;
    vector<int> clr;
    vector<int> dp1;
    vector<int> dp2;
    vector<int> pref;

    void color_dfs(int v, int p, int c) {
        clr[v] = c;
        for (auto u: g[v]) {
            if (u == p)continue;
            color_dfs(u, v, 1 - c);
        }
    }

    void dfs(int v, int p = -1) {
        int mn = 2;
        int mn_u = 0;
        for (auto u: g[v]) {
            if (u == p)continue;
            dfs(u, v);
            dp1[v] += max(dp2[u], dp1[u]);
            dp2[v] += max(dp2[u], dp1[u]);
            if (max(dp2[u] - dp1[u], 0) < mn) {
                mn = max(0, dp2[u] - dp1[u]);
                mn_u = u;
            }
        }
        if (mn != 2) {
            pref[v] = mn_u;
            dp2[v] = dp2[v] - mn + 1;
        }
    }

    void ans(int v, int p, int used = 0) {
        //assert(v>=0);
        if (used) {
            for (auto u: g[v]) {
                if (u==p)continue;
                ans(u, v, 0);
            }
        } else {
            if (dp2[v] > dp1[v]) {
                for (auto u:g[v]) {
                    if (u==p || u==pref[v])continue;
                    ans(u,v,0);
                }
                cout<<v+1<<' '<<pref[v]+1<<'\n';
                ans(pref[v],v,1);
            }
        }
    }

    Test() {
        cin >> n;
        int d;
        cin >> d;
        g.resize(n);
        dp1.resize(n, 0);
        dp2.resize(n, 0);
        pref.resize(n,-1);
        for (int i = 0; i < n - 1; i++) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        clr.resize(n);
        color_dfs(0, -1, 0);
        dfs(0);
        cout << max(dp1[0], dp2[0]) << '\n';
        ans(0,-1,0);
    }
};

signed main() {
#ifdef Local
    freopen(".in", "r",stdin);
    freopen(".out", "w",stdout);
    auto start = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cout.precision(20);
    int t = 1;
    //cin >> t;
    while (t--) Test();
#ifdef Local
    cerr << setprecision(5) << 1e3 * (clock() - start) / CLOCKS_PER_SEC << "ms\n";
#endif
}
