#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>

using namespace std;

struct event {
	int l, m, r;
	event() = default;
};

bool operator<(event a, event b) {
	return a.r < b.r;
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<event> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
		--a[i].l;
		--a[i].m;
		--a[i].r;
	}

	sort(a.begin(), a.end());

	vector<bool> dp(n + 1, false);
	dp[0] = true;

	for (int i = 0; i < k; ++i) {
		bool fl = false;
		for (int j = a[i].l; j <= a[i].m; ++j) {
			fl = fl || dp[j];
		}
		if (fl) {
			dp[a[i].r + 1] = true;
		}
	}

	if (dp[n]) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
