#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <random>

using namespace std;

struct event {
	int l, m, r;
	event() = default;
};

bool operator<(event a, event b) {
	if (a.l != b.l) return a.l < b.l;
	if (a.m != b.m) return a.m < b.m;
	return a.l < b.l;
}

const int inf = 1e9;

const int sz = 1 << 20;
int tree[sz];

void init(int v, int l, int r) {
	tree[v] = inf;
	if (r - l == 1) return;
	int m = (l + r) / 2;

	init(v * 2, l, m);
	init(v * 2 + 1, m, r);
}

void upd(int v, int l, int r, int qi, int qx) {
	if (r - l == 1) {
		tree[v] = min(tree[v], qx);
		return;
	}
	int m = (l + r) / 2;
	if (qi < m) upd(v * 2, l, m, qi, qx);
	else upd(v * 2 + 1, m, r, qi, qx);

	tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

int mn(int v, int l, int r, int ql, int qr) {
	if (l >= qr || ql >= r) return inf;
	if (l >= ql && r <= qr) return tree[v];
	int m = (l + r) / 2;

	int r1 = mn(v * 2, l, m, ql, qr);
	int r2 = mn(v * 2 + 1, m, r, ql, qr);
	return min(r1, r2);
}

void solve() {
	int n, k;
	cin >> n >> k;

	vector<event> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].l >> a[i].m >> a[i].r;
		--a[i].l;
		--a[i].m;
		--a[i].r;
	}


	sort(a.begin(), a.end());
	init(1, 0, n + 1);
	upd(1, 0, n + 1, 0, 0);

	for (int i = 0; i < k; ++i) {
		if (mn(1, 0, n + 1, a[i].l, a[i].r + 1) <= a[i].l || mn(1, 0, n + 1, a[i].l, a[i].m + 1) < inf) {
			upd(1, 0, n + 1, a[i].r + 1, a[i].m + 1);
		}

	}

	if (mn(1, 0, n + 1, n, n + 1) < inf) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
