#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define len(v) (int)((v).size())

#define int ll

typedef long long ll;

const ll inf = 4e18 + 7;

ll s2(ll x) {
	return x * x;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> x(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i];
	}

	sort(x.begin(), x.end());

	int x0, d;
	cin >> x0 >> d;

	vector<int> best(n);

	for (int i = 0; i < n; ++i) {
		int l = 0, r = 1e9 + 5;

		while (r - l > 1) {
			int m = (l + r) / 2;

			ll xm = x0 + m * 1ll * d;

			if (xm <= x[i]) {
				l = m;
			}
			else {
				r = m;
			}
		}

		while (s2(x0 + l * 1ll * d - x[i]) > s2(x0 + (l + 1) * 1ll * d - x[i])) {
			++l;
		}
		best[i] = x0 + l * 1ll * d;
	}

	int q;
	cin >> q;

	vector<int> t(q);
	for (int i = 0; i < q; ++i) {
		cin >> t[i];
	}

	vector<int> l(q, 0), r(q, 1e9 + 7);

	set<pair<int, int>> que, nque;

	for (int i = 0; i < q; ++i) {
		nque.insert({l[i] + r[i], i});
	}

	auto calc = [&](ll xi) {
		ll ans = 0;

		for (int i = 0; i < n; ++i) {
			if (best[i] <= xi) {
				ans += s2(best[i] - x[i]);
			}
			else {
				ans += s2(xi - x[i]);
			}
		}

		return ans;
	};

	vector<ll> answers(q, inf);

	while (!nque.empty()) {
		swap(nque, que);


		ll xi = x0;
		ll ans0 = calc(xi);
		ll ans1 = calc(xi + d);

		while (!que.empty()) {
			int mi = que.begin()->first;
			int ind = que.begin()->second;
			que.erase(que.begin());

			if (x0 + mi * 1ll * d != xi) {
				xi = (x0 + mi * 1ll * d);

				ans0 = calc(xi);
				ans1 = calc(xi + d);
			}

			if (ans0 - ans1 <= t[ind]) {
				r[ind] = mi;
			}
			else {
				l[ind] = mi;
			}

			if (r[ind] - l[ind] == 1) {
				answers[ind] = min(calc(x0 + l[ind] * 1ll * d) + t[ind] * 1ll * l[ind], calc(x0 + r[ind] * 1ll * d) + t[ind] * 1ll * r[ind]);
			}
			else if (r[ind] - l[ind] < 1) {
				continue;
			}
			else {
				nque.insert({ (l[ind] + r[ind]) / 2, ind });
			}
		}
	}

	for (int i = 0; i < q; ++i){
		cout << answers[i] << '\n';
	}
}
