#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_map>

using namespace std;

#define len(v) (int)((v).size())


typedef long long lll;
typedef long long ll;
typedef long double ld;
//typedef long long lll;

#define int ll

const lll inf = 2e18 + 7;

lll s2(ll x) {
	return (lll)x * x;
}

ld s22(ll x) {
	return (ld)x * x;
}


vector<ll> solve(vector<int> x, vector<int> t, int x0, int d) {
	int n = len(x);
	vector<int> best(n);

	for (int i = 0; i < n; ++i) {
		int l = 0, r = 1e9 + 5;

		while (r - l > 1) {
			int m = (l + r) / 2;

			ll xm = x0 + m * 1ll * d;

			if (xm <= x[i]) {
				l = m;
			}
			else {
				r = m;
			}
		}

		while (abs(x0 + l * 1ll * d - x[i]) > abs(x0 + (l + 1) * 1ll * d - x[i])) {
			++l;
		}
		best[i] = x0 + l * 1ll * d;
	}

	int q = len(t);

	vector<signed> l(q, 0), r(q, 1e9 + 7);

	vector<pair<signed, signed>> que, nque;

	for (int i = 0; i < q; ++i) {
		nque.emplace_back(l[i] + r[i], i);
	}

	vector<ll> answers(q, inf);
	vector<pair<ll, ll>> ansq;
	{
		int li = 0;
		ll sx = 0;
		ld sx2 = 0;

		ld cf = 0;
		int cnt = n;

		for (int i = 0; i < n; ++i) {
			sx += x[i];
			sx2 += s22(x[i]);
		}

		auto calc1 = [&](int xi) {
			while (li < n && best[li] <= xi) {
				cf += s22(best[li] - x[li]);
				sx -= x[li];
				sx2 -= s22(x[li]);
				cnt -= 1;
				++li;
			}
			return (ld)xi * xi * cnt - 2 * (ld)xi * sx + sx2 + cf;
		};




		while (!nque.empty()) {
			swap(nque, que);

			nque.clear();
			sort(que.begin(), que.end());

			ll xi = x0;

			li = 0;
			sx = 0;
			sx2 = 0;
			cnt = n;
			cf = 0;
			for (int i = 0; i < n; ++i) {
				sx += x[i];
				sx2 += s2(x[i]);
			}

			lll ans0 = calc1(xi);
			lll ans1 = calc1(xi + d);

			for (int nw = 0; nw < len(que); ++nw) {
				int mi = que[nw].first;
				int ind = que[nw].second;

				if (x0 + mi * 1ll * d != xi) {
					xi = (x0 + mi * 1ll * d);

					ans0 = calc1(xi);
					ans1 = calc1(xi + d);
				}

				if (ans0 - ans1 <= t[ind]) {
					r[ind] = mi;
				}
				else {
					l[ind] = mi;
				}

				if (r[ind] - l[ind] == 1) {
					ansq.emplace_back(l[ind], ind);
					ansq.emplace_back(r[ind], ind);
				}
				else if (r[ind] - l[ind] < 1) {
					continue;
				}
				else {
					nque.emplace_back((l[ind] + r[ind]) / 2, ind);
				}
			}
		}
	}

	int li = 0;
	ll sx = 0;
	ll sx2 = 0;

	ll cf = 0;
	int cnt = n;
	for (int i = 0; i < n; ++i) {
		sx += x[i];
		sx2 += s2(x[i]);
	}

	auto calc2 = [&](int xi) {
		while (li < n && best[li] <= xi) {
			cf += s2(best[li] - x[li]);
			sx -= x[li];
			sx2 -= s2(x[li]);
			cnt -= 1;
			++li;
		}
		return (ll)xi * xi * cnt - 2 * (ll)xi * sx + sx2 + cf;
	};

	sort(ansq.begin(), ansq.end());

	ll xi = x0;
	for (int nw = 0; nw < len(ansq); ++nw) {
		int mi = ansq[nw].first;
		int ind = ansq[nw].second;

		if (x0 + mi * 1ll * d != xi) {
			xi = (x0 + mi * 1ll * d);
		}

		if (answers[ind] > calc2(xi) + mi * 1ll * t[ind]) {
			answers[ind] = calc2(xi) + mi * 1ll * t[ind];
		}
	}
	return answers;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> x(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i];
	}


	int x0, d;
	cin >> x0 >> d;

	long long q;
	cin >> q;

	vector<int> t(q);
	for (int i = 0; i < q; ++i) {
		cin >> t[i];
		t.push_back(2 * t[i]);
	}

	vector<int> x1, x2;
	for (int i = 0; i < n; ++i) {
		if (x[i] < x0) x1.push_back(2 * x0 - x[i]);
		else x2.push_back(x[i]);
	}

	sort(x1.begin(), x1.end());
	sort(x2.begin(), x2.end());

	vector<ll> ans1 = solve(x1, t, x0, d);
	vector<ll> ans2 = solve(x2, t, x0, d);

	for (int i = 0; i < q; ++i) {
		cout << (long long)min(ans1[i] + ans2[i + q], ans2[i] + ans1[i + q]) << '\n';
	}
}