#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_map>

using namespace std;

#define len(v) (int)((v).size())


typedef __int128 ll;

#define int ll

const ll inf = 4e18 + 7;

ll s2(ll x) {
	return x * x;
}

vector<ll> solve(vector<long long> x, vector<long long> t, long long x0, long long d) {
	ll n = len(x);
	vector<int> best(n);

	for (int i = 0; i < n; ++i) {
		int l = 0, r = 1e9 + 5;

		while (r - l > 1) {
			int m = (l + r) / 2;

			ll xm = x0 + m * 1ll * d;

			if (xm <= x[i]) {
				l = m;
			}
			else {
				r = m;
			}
		}

		while (s2(x0 + l * 1ll * d - x[i]) > s2(x0 + (l + 1) * 1ll * d - x[i])) {
			++l;
		}
		best[i] = x0 + l * 1ll * d;
	}
	
	int q = len(t);

	vector<int> l(q, 0), r(q, 1e9 + 7);

	set<pair<int, int>> que, nque;

	for (int i = 0; i < q; ++i) {
		nque.insert({ l[i] + r[i], i });
	}

	unordered_map<long long, ll> sv;

	auto calc = [&](ll xi) {
		if (sv.find(xi) != sv.end()) return sv[xi];

		ll ans = 0;

		for (int i = 0; i < n; ++i) {
			if (best[i] <= xi) {
				ans += s2(best[i] - x[i]);
			}
			else {
				ans += s2(xi - x[i]);
			}
		}

		return sv[xi] = ans;
	};

	vector<ll> answers(q, inf);

	while (!nque.empty()) {
		swap(nque, que);


		ll xi = x0;
		ll ans0 = calc(xi);
		ll ans1 = calc(xi + d);

		while (!que.empty()) {
			int mi = que.begin()->first;
			int ind = que.begin()->second;
			que.erase(que.begin());

			if (x0 + mi * 1ll * d != xi) {
				xi = (x0 + mi * 1ll * d);

				ans0 = calc(xi);
				ans1 = calc(xi + d);
			}

			if (ans0 - ans1 <= t[ind]) {
				r[ind] = mi;
			}
			else {
				l[ind] = mi;
			}

			if (r[ind] - l[ind] == 1) {
				answers[ind] = min(calc(x0 + l[ind] * 1ll * d) + t[ind] * 1ll * l[ind], calc(x0 + r[ind] * 1ll * d) + t[ind] * 1ll * r[ind]);
			}
			else if (r[ind] - l[ind] < 1) {
				continue;
			}
			else {
				nque.insert({ (l[ind] + r[ind]) / 2, ind });
			}
		}
	}

	return answers;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	long long n;
	cin >> n;

	vector<long long> x(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i];
	}


	long long x0, d;
	cin >> x0 >> d;

	long long q;
	cin >> q;
	
	vector<long long> t(q), t2(q);
	for (int i = 0; i < q; ++i) {
		cin >> t[i];
		t2[i] = 2 * t[i];
	}

	vector<long long> x1, x2;
	for (int i = 0; i < n; ++i) {
		if (x[i] < x0) x1.push_back(2 * x0 - x[i]);
		else x2.push_back(x[i]);
	}

	sort(x1.begin(), x1.end());
	sort(x2.begin(), x2.end());
	
	vector<ll> ans11 = solve(x1, t, x0, d);
	vector<ll> ans12 = solve(x1, t2, x0, d);

	vector<ll> ans21 = solve(x2, t, x0, d);
	vector<ll> ans22 = solve(x2, t2, x0, d);

	for (int i = 0; i < q; ++i) {
		cout << (long long)min(ans11[i] + ans22[i], ans12[i] + ans21[i]) << '\n';
	}
}
