#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <random>

using namespace std;

#define len(v) (int)((v).size())

const int inf = 1e9 + 7;

const int N = 5e5 + 7;
vector<int> g[N];

int c[N];

void dfsc(int v, int cv) {
	c[v] = cv;

	for (int u : g[v]) {
		if (c[u] == -1) {
			dfsc(u, 1 - cv);
		}
	}
}

int cr = 0;
int us[N];
int p[N];

bool dfs(int v) {
	if (us[v] == cr) return false;
	us[v] = cr;

	for (int u : g[v]) {
		if (p[u] == -1 || dfs(p[u])) {
			p[u] = v;
			return true;
		}
	}
	return false;
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, d;
	cin >> n >> d;

	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	for (int i = 0; i < n; ++i) {
		c[i] = -1;
		p[i] = -1;
	}
	dfsc(0, 0);

	vector<vector<int>> dg(n, vector<int>(n, inf));
	for (int i = 0; i < n; ++i) {
		for (int j : g[i]) dg[i][j] = 1;
	}

	for (int k = 0; k < n; ++k) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j){
				if (dg[i][j] > dg[i][k] + dg[k][j]) {
					dg[i][j] = dg[i][k] + dg[k][j];
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (dg[i][j] > 1 && dg[i][j] % 2 == 1 && dg[i][j] <= d) {
				g[i].push_back(j);
			}
		}
	}
	
	for (int i = 0; i < n; ++i) {
		if (c[i] == 0) {
			++cr;
			dfs(i);
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += (p[i] != -1);
	}
	cout << ans << '\n';
	for (int i = 0; i < n; ++i) {
		if (p[i] != -1) {
			cout << p[i] + 1 << ' ' << i + 1 << '\n';
		}
	}
}
