#include <bits/stdc++.h>

using namespace std;

const int maxn = 600005;

vector<pair<int,int>> segTree[4*maxn];
vector<int> cd[maxn];
vector<pair<int,int>> res;
vector<int> g[maxn];
bool fic[maxn];
int d;
int ans = 0;
int tin[maxn];
int tout[maxn];
int itin[maxn];
int times = 0;

void build(int l,int r,int indV,int j)
{
    if(l == r)
    {
        segTree[j][indV] = {!fic[itin[cd[j][l]]],l};
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1,j);
    build(m+1,r,indV*2+2,j);
    segTree[j][indV] = max(segTree[j][indV*2+1],segTree[j][indV*2+2]);
}

void modify(int i,int x,int l,int r,int indV,int j)
{
    if(l > i || r < i)
    {
        return ;
    }
    else if(l == r)
    {
        segTree[j][indV] = {x,l};
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1,j);
    modify(i,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = max(segTree[j][indV*2+1],segTree[j][indV*2+2]);
    return ;
}
pair<int,int> get(int lx,int rx,int l,int r,int indV,int j)
{
    if(l > rx || r < lx)
    {
        return {0,-1};
    }
    else if(l >= lx && r <= rx)
    {
        return segTree[j][indV];
    }
    int m = (l+r)/2;
    pair<int,int> sl = get(lx,rx,l,m,indV*2+1,j);
    pair<int,int> sr = get(lx,rx,m+1,r,indV*2+2,j);
    return max(sl,sr);
}

void dfs_d(int v,int p,int d)
{
    tin[v] = times++;
    cd[d].push_back(tin[v]);
    itin[tin[v]] = v;
    for(auto u:g[v])
    {
        if(u != p)
        {
            dfs_d(u,v,d+1);
        }
    }
    tout[v] = times;
    return ;
}

vector<int> dfs(int v,int p,int dd)
{
   // cout << v << endl;
    vector<int> dep(d+1,0);
    if(!fic[v])
        dep[0] = 1;
    for(auto u:g[v])
    {
        if(u != p)
        {
            vector<int> cd = dfs(u,v,dd+1);
            for(int j= 0 ;j < d;++j)
            {
                dep[j+1] += cd[j];
            }
        }
    }
    for(int i = 0;i < d+1;++i)
    {
        if(dep[i] != 0 && dep[d-i] != 0)
        {
            while(dep[i] != 0 && dep[d-i] != 0)
            {
                //cout << 1 << endl;
               // cout << v << ' ' << i << ' ' << d-i << endl;
                //cout << cd[i+dd][0] << ' ' << cd[i+dd][1] << ' ' << tin[v] << ' ' << tout[v] << endl;
                int lga = lower_bound(cd[i+dd].begin(),cd[i+dd].end(),tin[v])-cd[i+dd].begin();
                int rga = lower_bound(cd[i+dd].begin(),cd[i+dd].end(),tout[v])-cd[i+dd].begin()-1;
                int lgb = lower_bound(cd[d-i+dd].begin(),cd[d-i+dd].end(),tin[v])-cd[d-i+dd].begin();
                int rgb = lower_bound(cd[d-i+dd].begin(),cd[d-i+dd].end(),tout[v])-cd[d-i+dd].begin()-1;
                //cout << lga << ' ' << rga << ' ' << cd[i+dd].size() << ' ' << lgb << ' ' << rgb << ' ' << cd[d-i+dd].size() << endl;
                //cout << 2 << endl;
                pair<int,int> a = get(lga,rga,0,int(cd[i+dd].size())-1,0,i+dd);
                pair<int,int> b = get(lgb,rgb,0,int(cd[d-i+dd].size())-1,0,d-i+dd);
               // cout << 2 << endl;
               // cout << a.second << ' ' << b.second << endl;
                res.emplace_back(itin[cd[i+dd][a.second]],itin[cd[d-i+dd][b.second]]);
                dep[i] --;
                dep[d-i] -- ;
                ans++;
                //cout << 2 << endl;
                modify(a.second,0,0,int(cd[i+dd].size())-1,0,i+dd);
                modify(b.second,0,0,int(cd[d-i+dd].size())-1,0,d-i+dd);
               // cout << 2 << endl;
            }
        }
    }
    return dep;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    cin >> d;
    if(d%2 == 0)
    {
        d--;
    }

    for(int j =0;j < n-1;++j)
    {
        int u,v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(int i = 0;i <= d;++i)
    {
        fic[i+n] = 1;
    }
    for(int i = 0;i < d;++i)
    {
        g[i+n].push_back(i+n+1);
    }
    g[d+n].push_back(0);
   // cout << "!" << endl;
    dfs_d(n,0,0);
   // cout << "!" << endl;
    for(int i = 0;i <= n+d+1;++i)
    {
        if(cd[i].size() != 0)
        {
            segTree[i].resize(4*cd[i].size());
            build(0,cd[i].size()-1,0,i);
        }
    }
    //cout << "!" << endl;
    dfs(n,-1,0);
    cout << ans << "\n";
    for(int i =0;i < res.size();++i)
    {
        cout << res[i].first+1 << ' ' << res[i].second+1 << "\n";
    }
    return 0;
}