#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int h, w;
    cin >> h >> w;

    vector <vector <int>> t(h, vector <int> (w));

    char c;
    for (int i=0; i<h; i++) for (int j=0; j<w; j++)
    {
        cin >> c;
        t[i][j] = c-'0';
    }

    vector <vector <int>> up(h, vector <int> (w, 0));

    for (int i=0; i<h; i++)
    {
        for (int j=0; j<w; j++)
        {
            if (t[i][j])
            {
                if (i == 0) up[i][j] = 1;
                else up[i][j] = up[i-1][j]+1;
            }
        }
    }

    vector <vector <int>> next (h, vector <int> (w, -1));

    for (int i=0; i<h; i++)
    { 
        deque <int> mins (w);
        for (int j=0; j<w; j++)
        {
            while (mins.size() && up[i][mins[mins.size()-1]] > up[i][j])
            {
                next[i][mins[mins.size()-1]] = j;
                mins.pop_back();
            }
            mins.push_back(j);
        }
    }

    vector <vector <int>> dp(h, vector <int> (w));

    int ans=0;
    for (int i=0; i<h; i++)
    {
        for (int j=w-1; j>=0; j--)
        {
            if (next[i][j] == -1)
            {
                dp[i][j] = up[i][j] * (w-j);
            }
            else
            {
                dp[i][j] = dp[i][next[i][j]] + up[i][j] * (next[i][j]-j);
            }
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;

    // cin >> tests;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }
}