#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

struct P
{
    int l, m, r;
};

bool operator < (P a, P b)
{
    if (a.r > b.r) return false;
    if (a.r < b.r) return true;
    if (a.l < b.l) return true;
    if (a.m < b.m) return true;
    return false;
}

void solve()
{
    int n, k;
    cin >> n >> k;

    vector <P> v (k);

    int l, m, r;
    for (int i=0; i<k; i++)
    {
        cin >> l >> m >> r;
        l--; m--; r--;
        v[i].l = l; v[i].m = m; v[i].r = r;
    }

    sort(v.begin(), v.end());

    set <int> s;

    if (v[0].l)
    {
        cout << "NO";
        return;
    }

    s.insert(v[0].r);
    for (int i=1; i<k; i++)
    {
        l = v[i].l; m = v[i].m; r = v[i].r;
        int x = *s.lower_bound(l);
        if (x <= m) s.insert(r+1);
    }

    if (s.count(n)) cout << "YES";
    else cout << "NO";

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;

    cin >> tests;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }
}