#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <set>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;
 
struct P
{
    int l, m, r;
    int ind;
};
 
bool comp1 (P a, P b)
{
    if (a.r > b.r) return false;
    if (a.r < b.r) return true;
    if (a.l < b.l) return true;
    if (a.m < b.m) return true;
    return false;
}

bool comp2 (P a, P b)
{
    if (a.l < b.l) return false;
    if (a.l > b.l) return true;
    if (a.r > b.r) return true;
    if (a.m > b.m) return true;
    return false;
}
 
void solve()
{
    int n, k;
    cin >> n >> k;
 
    vector <P> v1 (k), v2 (k);
 
    int l, m, r;
    for (int i=0; i<k; i++)
    {
        cin >> l >> m >> r;
        l--; m--; r--;
        v1[i].l = l;
        v1[i].m = m;
        v1[i].r = r;
        v1[i].ind = i;
        v2[i].l = l;
        v2[i].m = m;
        v2[i].r = r;
        v2[i].ind = i;
    }
 
    sort(v1.begin(), v1.end(), comp1); 
    sort(v2.begin(), v2.end(), comp2);
 
    set <int> s1;
 
    s1.insert(0);
    for (int i=0; i<k; i++)
    {
        l = v1[i].l; m = v1[i].m; r = v1[i].r;
        auto it = s1.lower_bound(l);
        if (it == s1.end()) continue;
        int x = *it;
        if (x <= m) s1.insert(r+1);
    }

    set <int> s2;

    s2.insert(1-n);
    for (int i=0; i<k; i++)
    {
        l = v2[i].l; m = v2[i].m; r = v2[i].r;
        auto it = s2.lower_bound(-r);
        if (it == s2.end()) continue;
        int x = -(*it);
        if (x >= m)
        {
            s2.insert(-l+1);
            auto it1 = s1.lower_bound(l);
            if (it1 != s1.end() && (*it1) <= m)
            {
                cout << "YES";
                return;
            }
        }
    }

    for (int i=0; i<k; i++)
    {
        l = v1[i].l; m = v1[i].m; r = v1[i].r;
        auto it = s1.lower_bound(l);
        if (it == s1.end()) continue;
        int x = *it;
        if (x <= m)
        {
            s1.insert(r+1);
            auto it1 = s2.lower_bound(-r);
            if (it1 != s2.end() && (*it1) >= m)
            {
                cout << "YES";
                return;
            }
        }
    }

    cout << "NO";

    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    int tests = 1;
 
    cin >> tests;
 
    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }
}