#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <set>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;
 
struct P
{
    int l, m, r;
};

vector <vector <int>> g;

void solve()
{
    int n, k;
    cin >> n >> k;
 
    vector <P> v (k);
    g.assign(k, vector <int>());

    int l, m, r;
    for (int i=0; i<k; i++)
    {
        cin >> l >> m >> r;
        l--; m--; r--;
        v[i].l = l; v[i].m = m; v[i].r = r;
    }

    vector <int> used(k, 1);
    for (int i=0; i<k; i++)
    {
        for (int j=0; j<k; j++)
        {
            if (i == j) continue;
            if (v[i].l <= v[j].m && v[j].m <= v[i].r)
            {
                g[j].push_back(i);
                used[i] = 0;
            }
        }
    }

    deque <int> q;
    for (int i=0; i<k; i++)
    {
        if (used[i]) q.push_back(i);
    }

    while (!q.empty())
    {
        auto v = q.front();
        q.pop_front();
        for (auto u : g[v])
        {
            if (used[u])
            {
                cout << "NO"; return;
            }
            if (!used[u]) q.push_back(u);
            used[u] = 1;
        }
    }
    for (auto i : used) if (!i)
    {
        cout << "NO";
        return;
    }
    cout << "YES";

    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    int tests = 1;
 
    cin >> tests;
 
    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }
}