#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <set>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;

vector <vector <int>> g;
vector <int> c1, c2;
vector <int> used;

void dfs(int v, int c=1)
{
    if (c == 1) c1.push_back(v);
    if (c == 2) c2.push_back(v);
    used[v] = 1;
    for (auto u : g[v])
    {
        if (!used[u])
        {
            dfs(u, 3-c);
        }
    }
    return;
}

void solve()
{
    int n;
    cin >> n;
    int d;
    cin >> d;

    g.resize(n);
    used.assign(n, 0);

    int v, u;
    for (int i=0; i<n-1; i++)
    {
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    dfs(0);

    cout << min(c1.size(), c2.size()) << '\n';
    for (int i=0; i<min(c1.size(), c2.size()); i++)
    {
        cout << c1[i]+1 << ' ' << c2[i]+1 << '\n';
    }

    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    int tests = 1;
 
    cin >> tests;
 
    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }
}