#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
#define endl '\n'
#define cin(v) for (auto& el : v) { cin >> el;}
#define cout(v) for (auto& el : v) { cout << el << " ";} cout << "\n";

using namespace std;
using ll = long long;
const ll MOD1 = 1e9 + 7;

struct segtree {
    int n;
    vector<ll> tree, set_;

    segtree(int n_) {
        n = n_;
        tree.resize(2 * n);
        set_.resize(2 * n, -1);
    }

    void push(int v, int vl, int vr) {
        if (set_[v] == -1) {
            return;
        }
        tree[v] = set_[v] * (vr - vl);
        if (vl != vr - 1) {
            int vm = vl + (vr - vl) / 2;
            set_[v + 1] = set_[v];
            set_[v + 2 * (vm - vl)] = set_[v];
        }
        set_[v] = -1;
    }

    int query(int v, int vl, int vr, int ind) {
        push(v, vl, vr);
        if (vl > ind || vr <= ind) {
            return 1e9;
        }
        if (vl == vr - 1) {
            return tree[v];
        }
        int vm = vl + (vr - vl) / 2;
        int ans1 = query(v + 1, vl, vm, ind);
        int ans2 = query(v + 2 * (vm - vl), vm, vr, ind);
        return min(ans1, ans2);
    }

    int query(int ind) {
        return query(0, 0, n, ind);
    }

    void update(int v, int vl, int vr, int ql, int qr, int val) {
        push(v, vl, vr);
        if (vl >= qr || vr <= ql) {
            return;
        }
        if (ql <= vl && vr <= qr) {
            set_[v] = val;
            push(v, vl, vr);
            return;
        }
        int vm = vl + (vr - vl) / 2;
        update(v + 1, vl, vm, ql, qr, val);
        update(v + 2 * (vm - vl), vm, vr, ql, qr, val);
        tree[v] = min(tree[v + 1], tree[v + 2 * (vm - vl)]);
    }

    void update(int v, int vl, int vr) {
        update(0, 0, n, vl, vr, v);
    }
};

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> dp2(n + 1);
    vector<int> max_good(n + 1, -1);
    dp2.back() = 1;
    max_good[n] = n;
    vector<vector<pair<int, int>>> qs(n);
    for (int i = 0; i < k; i++) {
        int l, m, r;
        cin >> l >> m >> r;
        l--; r--;
        m--;
        qs[l].push_back({m, r});
    }
    segtree tr(n + 10);
    tr.update(n + 1, 0, n + 10);
    set<int> GOOD;
    GOOD.insert(n);
    for (int i = n - 1; i >= 0; i--) {
        for (auto p : qs[i]) {
            int m = p.first, r = p.second;
            bool good = 0;
            int ans = tr.query(r + 1);
            if (ans <= r + 1) {
                good = 1;
            }
            int v = *GOOD.lower_bound(m + 1);
            if (v <= r + 1) {
                good = 1;
            }
            if (good) {
                max_good[i] = max(max_good[i], m);
            }
        }
        dp2[i] = (max_good[i] != -1);
        if (dp2[i]) {
            GOOD.insert(i);
        }
        if (max_good[i] != -1) {
            tr.update(i, 0, max_good[i] + 1);
        }
    }
    if (dp2[0]) {
        cout << "YES\n";
    }else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}