#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
  for (t &e : a) {
    in >> e;
  }
  return in;
}

template<typename t>
ostream &operator<<(ostream &out, vector<t> a) {
  for (t e : a) {
    out << e << ' ';
  }
  return out << '\n';
}

template<typename t>
struct vec : vector<t> {
  using vector<t>::vector;
  void sort() {
    std::sort(vector<t>::begin(), vector<t>::end());
  }
  void sort(function<bool(t, t)> cmp) {
    std::sort(vector<t>::begin(), vector<t>::end(), cmp);
  }
  void iota(t x) {
    std::iota(vector<t>::begin(), vector<t>::end(), x);
  }
  bool nxtprm() {
    return next_permutation(vector<t>::begin(), vector<t>::end());
  }
};

int solve(vec<vec<int>> &a, vec<int> &prm, int r, int c) {
  int n = a.size(), m = a[0].size();
  if (r == n || c == m) {
    int ret = 0;
    for (int i = 0; i < prm.size(); ++i) {
      for (int j = 0; j < i; ++j) {
        ret += prm[i] < prm[j];
      }
    }
    return ret;
  }
  for (int i = r; i < n; ++i) {
    prm.push_back(a[i][c]);
  }
  int ret = solve(a, prm, r, c + 1);
  for (int i = r; i < n; ++i) {
    prm.pop_back();
  }
  for (int i = c; i < m; ++i) {
    prm.push_back(a[r][i]);
  }
  ret = min(ret, solve(a, prm, r + 1, c));
  for (int i = c; i < m; ++i) {
    prm.pop_back();
  }
  return ret;
}

int main() {
  int n, m;
  cin >> n >> m;
  vec<vec<int>> a(n, vec<int>(m));
  cin >> a;
  vec<int> prm;
  cout << solve(a, prm, 0, 0);
}
