#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
  for (t &e : a) {
    in >> e;
  }
  return in;
}

template<typename t>
ostream &operator<<(ostream &out, vector<t> a) {
  for (t e : a) {
    out << e << ' ';
  }
  return out << '\n';
}

template<typename t>
struct vec : vector<t> {
  using vector<t>::vector;
  void sort() {
    std::sort(vector<t>::begin(), vector<t>::end());
  }
  void sort(function<bool(t, t)> cmp) {
    std::sort(vector<t>::begin(), vector<t>::end(), cmp);
  }
  void iota(t x) {
    std::iota(vector<t>::begin(), vector<t>::end(), x);
  }
};

struct vec2 {
  int x, y;
  vec2() : x(0), y(0) {}
  vec2(int x, int y) : x(x), y(y) {}
  friend vec2 operator+(vec2 a, vec2 b) {
    return vec2(a.x + b.x, a.y + b.y);
  }
  friend vec2 &operator+=(vec2 &a, vec2 b) {
    return a=vec2(a.x + b.x, a.y + b.y);
  }
  friend vec2 operator-(vec2 a, vec2 b) {
    return vec2(a.x - b.x, a.y - b.y);
  }
  friend vec2 &operator-=(vec2 &a, vec2 b) {
    return a=vec2(a.x - b.x, a.y - b.y);
  }
  friend vec2 operator*(vec2 a, int k) {
    return vec2(a.x * k, a.y * k);
  }
  friend vec2 operator*(int k, vec2 a) {
    return vec2(k * a.x, k * a.y);
  }
  friend vec2 &operator*=(vec2 &a, int k) {
    return a = vec2(a.x * k, a.y * k);
  }
  friend int operator*(vec2 a, vec2 b) {
    return a.x * b.x + a.y * b.y;
  }
  friend int operator%(vec2 a, vec2 b) {
    return a.x * b.y - a.y * b.x;
  }

  friend istream &operator>>(istream &in, vec2 &v) {
    return in >> v.x >> v.y;
  }
  friend ostream &operator<<(ostream &out, vec2 v) {
    return out << v.x << ' ' << v.y << ' ';
  }
  ll len2() const {
    return x * x + y * y;
  }
};

ll r, rr;

bool cmp(vec2 a, vec2 b) {
  return (a.x / rr) < (b.x / rr) || ((a.x / rr) < (b.x / rr) && (a.y / rr) < (b.y / rr));
}

bool toofar(vec2 a, vec2 b) {
  return abs(a.x / rr - b.x / rr) > 2;
}

int main() {
  int n;
  cin >> n >> r;
  rr = (r + 1) / 2;
  vec<vec2> vs(n);
  cin >> vs;
  vec<vec<int>> g(n);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (i != j && (vs[i] - vs[j]).len2() <= r * r) {
        g[i].push_back(j);
        g[j].push_back(i);
      }
    }
  }
  vec<bool> par(n);
  vec<int> col(n);
  vec<bool> used(n);
  col.iota(0);
  vec<bool> ans(n);
  {
    function<bool(int)> dfs = [&g, &col, &par, &used, &dfs](int v) {
      if (used[v]) return false;
      used[v] = true;
      bool ret = false;
      for (int u : g[v]) {
        if (col[u] == col[v] && par[u] == par[v]) return true;
        par[u] = !par[v];
        col[u] = col[v];
        if (dfs(u)) ret = true;
      }
      return ret;
    };
    for (int i = 0; i < n; ++i) {
      ans[i] = dfs(i);
      ans[i] = ans[col[i]];
    }
  }
  for (int i = 0; i < n; ++i) {
    cout << (ans[i] ? 1 : 0);
  }







/*
  vs.sort(cmp);
  vec<vec<vec2>> vsr;
  for (vec2 &v : vs) {
    if (vsr.empty() || (vsr.back().back().x / rr != v.x / rr || vsr.back().back().y / rr != v.y / rr)) {
      vsr.push_back({});
    }
    vsr.back().push_back(v);
  }
  vec<int> col(vsr.size(), 0);
  col.iota(0);
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if (toofar(vsr[i][0], vsr[j][0])) break;
      for (vec2 vi : vsr[i]) {
        for (vec2 vj : vsr[j]) {
          if ((vi - vj).len2() <= r * r) {
            col[i] = col[i];
          }
        }
      }
    }
  }
  for (auto &vv : vsr) {
    for (auto &v : vv) {
      cout << v << '\n';
    } cout << '\n';
  }
*/
}
