#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename t>
istream &operator>>(istream &in, vector<t> &a) {
  for (t &e : a) {
    in >> e;
  }
  return in;
}

template<typename t>
ostream &operator<<(ostream &out, vector<t> a) {
  for (t e : a) {
    out << e << ' ';
  }
  return out << '\n';
}

template<typename t>
struct vec : vector<t> {
  using vector<t>::vector;
  void sort() {
    std::sort(vector<t>::begin(), vector<t>::end());
  }
  void sort(function<bool(t, t)> cmp) {
    std::sort(vector<t>::begin(), vector<t>::end(), cmp);
  }
  void iota(t x) {
    std::iota(vector<t>::begin(), vector<t>::end(), x);
  }
  bool nxtprm() {
    return next_permutation(vector<t>::begin(), vector<t>::end());
  }
};

struct sptb {
  int n;
  int L = 18;
  vec<vec<int>> st;
  vec<int> a;
  sptb(vec<int> a) : a(a), n(a.size()) {
    st.resize(L, vec<int>(n));
    for (int i = 0; i < n; ++i) {
      st[0][i] = i;
    }
    for (int l = 1; l < L; ++l) {
      for (int i = 0; i <= n - (1 << l); ++i) {
        st[l][i] = (a[st[l - 1][i]] < a[st[l - 1][i + (1 << (l - 1))]] ? st[l - 1][i] : st[l - 1][i + (1 << (l - 1))]);
      }
    }
  }
  int get(int l, int r) {
    int _l = __lg(r - l);
    return (a[st[_l][l]] < a[st[_l][r - (1 << _l)]] ? st[_l][l] : st[_l][r - (1 << _l)]);
  }
};

int main() {
  int n, q;
  cin >> n >> q;
  vec<int> a(n);
  cin >> a;
  vec<int> r(n);
  {
    vec<int> st(1, n);
    for (int i = n - 1; i >= 0; --i) {
      while (st.back() != n && a[i] > a[st.back()]) st.pop_back();
      r[i] = st.back();
      st.push_back(i);
    }
  }
  for (int qi = 0; qi < q; ++qi) {
    int k, i;
    cin >> k >> i;
    if (k == 1) {
      int mx = 0;
      for (int j = 0; j < n; ++j) {
        mx = max(mx, a[j]);
      }
      cout << mx << '\n';
      continue;
    }
    vec<bool> perm(n - 1);
    for (int j = 0; j < k - 1; ++j) {
      perm[n - 2 - j] = true;
    }
    vec<int> bb;
    do {
      vec<int> b;
      int mx = 0;
      for (int j = 0; j < n; ++j) {
        if (j != 0 && perm[j - 1]) {
          b.push_back(mx);
          mx = 0;
        }
        mx = max(mx, a[j]);
      }
      b.push_back(mx);
      if (bb.empty()) {
        bb=b;
      } else {
        for (int j = 0; j < b.size(); ++j) {
          if (b[j] < bb[j]) {
            bb = b;
            break;
          } else if (b[j] > bb[j]) {
            break;
          }
        }
      }
    } while (perm.nxtprm());
    cout << bb[i - 1] << '\n';
  }
}
