#include <bits/stdc++.h>

using namespace std;

struct Vector {
    int x, y;

    Vector operator-(const Vector& rhs) const {
        return { x - rhs.x, y - rhs.y };
    }

    int operator*(const Vector& rhs) const {
        return x * rhs.x + y * rhs.y;
    }

    int sqlen() const {
        return (*this) * (*this);
    }
};

using Point = Vector;

const int LOG = 21;

// vector<vector<int>> g;
// vector<int> used, comp, depth;
// // vector<int> up[LOG];
// // vector<int> tin, tout;
// // int timer = 1;

// void dfs(int v, int curd, int cc) {
//     if (used[v])
//         return;
//     // tin[v] = timer++;
//     used[v] = true;
//     comp[v] = cc;
//     depth[v] = curd;
//     // up[0][v] = p;
//     // for (int l = 1; l < LOG; ++l)
//         // up[l][v] = up[l - 1][up[l - 1][v]];
//     for (auto to : g[v])
//         dfs(to, curd + 1, cc);
//     // tout[v] = timer;
// }

// bool is_up(int a, int b) {
//     return tin[a] <= tin[b] && tout[b] <= tout[a];
// }

// int lca(int a, int b) {
//     if (is_up(a, b))
//         return a;
//     if (is_up(b, a))
//         return b;
//     for (int l = LOG - 1; l >= 0; --l)
//         if (!is_up(up[l][a], b))
//             a = up[l][a];
//     return up[0][a];
// }

struct DSU {
    vector<int> p, sz, bip;
    vector<int> bit;

    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0ll);
        sz.resize(n, 1);
        bip.resize(n, 1), bit.resize(n, 0);
    }

    pair<int, int> get(int v) {
        if (p[v] == v)
            return { v, 0ll };
        auto [pv, pb] = get(p[v]);
        bit[v] ^= pb;
        p[v] = pv;
        return { p[v], bit[v] };
    }

    void unite(int a, int b) {
        auto [pa, ba] = get(a);
        auto [pb, bb] = get(b);
        if (pa == pb) {
            bip[pa] &= (ba != bb);
            return;
        }
        a = pa, b = pb;
        if (sz[a] < sz[b]) {
            swap(a, b);
            swap(ba, bb);
        }
        sz[a] += sz[b];
        p[b] = a;
        bip[a] &= bip[b];
        bit[b] = (ba ^ bb ^ 1);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> pts(n);
    unordered_map<int, unordered_map<int, int>> haspt;
    int curid = 0;
    for (auto& [x, y] : pts) {
        cin >> x >> y;
        haspt[x][y] = curid++;
    }
    // g.resize(n);
    DSU dsu(n);
    for (int i = 0; i < n; ++i) {
        auto [myx, myy] = pts[i];
        for (int nx = myx - r; nx <= myx + r; ++nx) {
            for (int ny = myy; (myx - nx) * (myx - nx) + (myy - ny) * (myy - ny) <= r * r; ny++) {
                if (nx == myx && ny == myy)
                    continue;
                if (haspt[nx].count(ny)) {
                    int j = haspt[nx][ny];
                    if (j <= i)
                        continue;
                    // if (dsu.get(i) == dsu.get(j))
                //     continue;
                // g[i].push_back(j);
                // g[j].push_back(i);
                    dsu.unite(i, j);
                }
            }
            for (int ny = myy - 1; (myx - nx) * (myx - nx) + (myy - ny) * (myy - ny) <= r * r; ny--) {
                if (nx == myx && ny == myy)
                    continue;
                if (haspt[nx].count(ny)) {
                    int j = haspt[nx][ny];
                    if (j <= i)
                        continue;
                    // if (dsu.get(i) == dsu.get(j))
                    //     continue;
                    // g[i].push_back(j);
                    // g[j].push_back(i);
                    dsu.unite(i, j);
                }
            }
        }
        // for (int j = i + 1; j < n; ++j) {
        //     if (dsu.get(i) == dsu.get(j))
        //         continue;
        //     int tmp = (pts[i] - pts[j]).sqlen();
        //     if (tmp <= r * r) {
        //         g[i].push_back(j);
        //         g[j].push_back(i);
        //         dsu.unite(i, j);
        //     }
        // }
    }
    // used.resize(n), depth.resize(n);
    // // for (int l = 0; l < LOG; ++l)
    // //     up[l].assign(n, 0);
    // // tin.resize(n), tout.resize(n);
    // comp.resize(n);
    // int cc = 1;
    // for (int i = 0; i < n; ++i) {
    //     if (used[i] == 0) {
    //         dfs(i, 0, cc++);
    //     }
    // }
    // vector<int> goodc(cc + 1);
    // for (int i = 0; i < n; ++i) {
    //     if (goodc[comp[i]])
    //         continue;
    //     auto [myx, myy] = pts[i];
    //     for (int nx = myx - r; nx <= myx + r; ++nx) {
    //         for (int ny = myy; (myx - nx) * (myx - nx) + (myy - ny) * (myy - ny) <= r * r; ny++) {
    //             if (nx == myx && ny == myy)
    //                 continue;
    //             if (haspt.count({ nx, ny })) {
    //                 int j = haspt[{nx, ny}];
    //                 if (depth[i] % 2 == depth[j] % 2) {
    //                     goodc[comp[i]] = 1;
    //                     break;
    //                 }
    //             }
    //         }
    //         for (int ny = myy; (myx - nx) * (myx - nx) + (myy - ny) * (myy - ny) <= r * r; ny--) {
    //             if (nx == myx && ny == myy)
    //                 continue;
    //             if (haspt.count({ nx, ny })) {
    //                 int j = haspt[{nx, ny}];
    //                 if (depth[i] % 2 == depth[j] % 2) {
    //                     goodc[comp[i]] = 1;
    //                     break;
    //                 }
    //             }
    //         }
    //     }
    //     // for (int j = i + 1; j < n; ++j) {
    //     //     int tmp = (pts[i] - pts[j]).sqlen();
    //     //     if (tmp <= r * r) {
    //     //         if (depth[i] % 2 == depth[j] % 2) {
    //     //             goodc[comp[i]] = 1;
    //     //             break;
    //     //         }
    //     //     }
    //     // }
    // }
    for (int i = 0; i < n; ++i)
        cout << !dsu.bip[dsu.get(i).first];
}