#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Vector {
    int x, y;

    Vector operator-(const Vector& rhs) const {
        return { x - rhs.x, y - rhs.y };
    }

    int operator*(const Vector& rhs) const {
        return x * rhs.x + y * rhs.y;
    }

    int sqlen() const {
        return (*this) * (*this);
    }
};

using Point = Vector;

const int LOG = 21;

vector<vector<int>> g;
vector<int> used, comp, depth;
// vector<int> up[LOG];
// vector<int> tin, tout;
// int timer = 1;

void dfs(int v, int curd, int cc) {
    if (used[v])
        return;
    // tin[v] = timer++;
    used[v] = true;
    comp[v] = cc;
    depth[v] = curd;
    // up[0][v] = p;
    // for (int l = 1; l < LOG; ++l)
        // up[l][v] = up[l - 1][up[l - 1][v]];
    for (auto to : g[v])
        dfs(to, curd + 1, cc);
    // tout[v] = timer;
}

// bool is_up(int a, int b) {
//     return tin[a] <= tin[b] && tout[b] <= tout[a];
// }

// int lca(int a, int b) {
//     if (is_up(a, b))
//         return a;
//     if (is_up(b, a))
//         return b;
//     for (int l = LOG - 1; l >= 0; --l)
//         if (!is_up(up[l][a], b))
//             a = up[l][a];
//     return up[0][a];
// }

struct DSU {
    vector<int> p, sz;

    DSU(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0ll);
        sz.resize(n, 1);
    }

    int get(int v) {
        return (p[v] == v ? v : p[v] = get(p[v]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b)
            return;
        if (sz[a] < sz[b])
            swap(a, b);
        sz[a] += sz[b];
        p[b] = a;
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, r;
    cin >> n >> r;
    vector<Point> pts(n);
    map<pair<int, int>, int> haspt;
    int curid = 0;
    for (auto& [x, y] : pts) {
        cin >> x >> y;
        haspt[{x, y}] = curid++;
    }
    g.resize(n);
    DSU dsu(n);
    for (int i = 0; i < n; ++i) {
        auto [myx, myy] = pts[i];
        for (int nx = myx - 4; nx <= myx + 4; ++nx) {
            for (int ny = myy - (4 - abs(myx - nx)); ny <= myy + (4 - abs(myx - nx)); ++ny) {
                if (nx == myx && ny == myy)
                    continue;
                if (haspt.count({ nx, ny })) {
                    int j = haspt[{nx, ny}];
                    if (dsu.get(i) == dsu.get(j))
                        continue;
                    int tmp = (pts[i] - pts[j]).sqlen();
                    if (tmp <= r * r) {
                        g[i].push_back(j);
                        g[j].push_back(i);
                        dsu.unite(i, j);
                    }
                }
            }
        }
        // for (int j = i + 1; j < n; ++j) {
        //     if (dsu.get(i) == dsu.get(j))
        //         continue;
        //     int tmp = (pts[i] - pts[j]).sqlen();
        //     if (tmp <= r * r) {
        //         g[i].push_back(j);
        //         g[j].push_back(i);
        //         dsu.unite(i, j);
        //     }
        // }
    }
    used.resize(n), depth.resize(n);
    // for (int l = 0; l < LOG; ++l)
    //     up[l].assign(n, 0);
    // tin.resize(n), tout.resize(n);
    comp.resize(n);
    int cc = 1;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            dfs(i, 0, cc++);
        }
    }
    vector<int> goodc(cc + 1);
    for (int i = 0; i < n; ++i) {
        if (goodc[comp[i]])
            continue;
        auto [myx, myy] = pts[i];
        for (int nx = myx - 4; nx <= myx + 4; ++nx) {
            for (int ny = myy - (4 - abs(myx - nx)); ny <= myy + (4 - abs(myx - nx)); ++ny) {
                if (nx == myx && ny == myy)
                    continue;
                if (haspt.count({ nx, ny })) {
                    int j = haspt[{nx, ny}];
                    if (dsu.get(i) == dsu.get(j))
                        continue;
                    int tmp = (pts[i] - pts[j]).sqlen();
                    if (tmp <= r * r) {
                        if (depth[i] % 2 == depth[j] % 2) {
                            goodc[comp[i]] = 1;
                            break;
                        }
                    }
                }
            }
        }
        // for (int j = i + 1; j < n; ++j) {
        //     int tmp = (pts[i] - pts[j]).sqlen();
        //     if (tmp <= r * r) {
        //         if (depth[i] % 2 == depth[j] % 2) {
        //             goodc[comp[i]] = 1;
        //             break;
        //         }
        //     }
        // }
    }
    for (int i = 0; i < n; ++i)
        cout << goodc[comp[i]];
}