#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Fenwick {
    map<int, int> t;
    int _n;

    Fenwick(int n) {
        n += 1;
        _n = n;
    }

    int get(int i) {
        i += 1;
        int ans = 0;
        for (; i > 0; i -= (i & (-i)))
            ans += t[i];
        return ans;
    }

    int get(int l, int r) {
        if (l == 0)
            return get(r);
        return get(r) - get(l - 1);
    }

    void upd(int i, int val) {
        i += 1;
        for (; i < _n; i += (i & (-i)))
            t[i] += val;
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& r : a) {
        for (auto& el : r) {
            cin >> el;
            --el;
        }
    }
    vector<vector<int>> hordown(n, vector<int>(m));
    vector<vector<int>> verdown(n, vector<int>(m));
    // for (int diag = -m + 1; diag <= n - 1; ++diag) {
    //     Fenwick ft(n * m);
    //     for (int row = min(n - 1, m + diag - 1); row >= max(0ll, diag); --row) {
    //         int i = row;
    //         int j = i - diag;
    //         for (int i1 = i + 1; i1 < n; ++i1)
    //             ft.upd(a[i1][j], 1);
    //         for (int j1 = m - 1; j1 >= j; --j1) {
    //             hordown[i][j] += ft.get(a[i][j1]);
    //             ft.upd(a[i][j1], 1);
    //         }
    //         for (int i1 = i + 1; i1 < n; ++i1)
    //             ft.upd(a[i1][j], -1);
    //         for (int j1 = m - 1; j1 >= j; --j1) {
    //             ft.upd(a[i][j1], -1);
    //         }
    //         for (int j1 = j + 1; j1 < m; ++j1)
    //             ft.upd(a[i][j1], 1);
    //         for (int i1 = n - 1; i1 >= i; --i1) {
    //             verdown[i][j] += ft.get(a[i1][j]);
    //             ft.upd(a[i1][j], 1);
    //         }
    //     }
    // }
    for (int i = n - 1; i >= 0; --i) {
        int lasthui = 0;
        Fenwick ft(n * m);
        Fenwick hor(n * m);
        for (int j = m - 1; j >= 0; --j) {
            int myb = hor.get(a[i][j]) + ft.get(a[i][j]);
            for (int i1 = i + 1; i1 < n; ++i1)
                myb += (a[i1][j] < a[i][j]);
            int horhui = lasthui;
            for (int i1 = i + 1; i1 < n; ++i1)
                horhui += hor.get(a[i1][j], n * m - 1);
            lasthui = horhui + myb;
            hordown[i][j] = horhui + myb;
            verdown[i][j] = myb;
            for (int i1 = n - 1; i1 > i; --i1) {
                verdown[i][j] += hor.get(a[i1][j]) + ft.get(a[i1][j]);
                ft.upd(a[i1][j], 1);
            }
            hor.upd(a[i][j], 1);
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            // int var1 = dp[i + 1][j];
            // Fenwick ft(n * m);
            // for (int i1 = i + 1; i1 < n; ++i1) {
            //     for (int j1 = j; j1 < m; ++j1) {
            //         ft.upd(a[i1][j1], 1);
            //     }
            // }
            // for (int j1 = m - 1; j1 >= j; --j1) {
            //     var1 += ft.get(a[i][j1]);
            //     ft.upd(a[i][j1], 1);
            // }
            // int var2 = dp[i][j + 1];
            // ft = Fenwick(n * m);
            // for (int i1 = i; i1 < n; ++i1) {
            //     for (int j1 = j + 1; j1 < m; ++j1) {
            //         ft.upd(a[i1][j1], 1);
            //     }
            // }
            // for (int i1 = n - 1; i1 >= i; --i1) {
            //     var2 += ft.get(a[i1][j]);
            //     ft.upd(a[i1][j], 1);
            // }
            int var1 = dp[i + 1][j] + hordown[i][j];
            int var2 = dp[i][j + 1] + verdown[i][j];
            dp[i][j] = min(var1, var2);
        }
    }
    cout << dp[0][0];
}