#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

const int LOG = 2;

vector<vector<int>> up[LOG];

struct Node {
    int mn = INF, mnid = -1;

    static Node merge(Node a, Node b) {
        if (a.mn == b.mn) {
            if (a.mnid > b.mnid)
                return a;
            return b;
        }
        if (a.mn < b.mn)
            return a;
        return b;
    }
};

struct SegTree {
    vector<Node> t;
    int h = 0;

    SegTree(int n) {
        while ((1 << h) < n)
            h += 1;
        t.resize(1 << (h + 1));
        for (int i = 0; i < n; ++i)
            t[(1 << h) + i].mnid = i;
        for (int i = (1 << h) - 1; i > 0; --i)
            t[i] = Node::merge(t[2 * i], t[2 * i + 1]);
    }

    Node get(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l)
            return Node();
        if (l <= vl && vr <= r)
            return t[v];
        int vm = (vl + vr) / 2;
        return Node::merge(get(2 * v, vl, vm, l, r), get(2 * v + 1, vm, vr, l, r));
    }

    Node get(int l, int r) {
        return get(1, 0, (1 << h), l, r);
    }

    void upd(int v, int vl, int vr, int i, int val) {
        if (vl + 1 == vr) {
            t[v].mn = val;
            return;
        }
        int vm = (vl + vr) / 2;
        if (i < vm)
            upd(2 * v, vl, vm, i, val);
        else
            upd(2 * v + 1, vm, vr, i, val);
        t[v] = Node::merge(t[2 * v], t[2 * v + 1]);
    }

    void upd(int i, int val) {
        upd(1, 0, (1 << h), i, val);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto& el : a)
        cin >> el;
    vector<int> rclos(n);
    vector<int> st;
    for (int i = n - 1; i >= 0; --i) {
        while (st.size() && a[st.back()] < a[i])
            st.pop_back();
        rclos[i] = (st.empty() ? n : st.back());
        st.push_back(i);
    }
    int maxk = 3;
    vector<vector<int>> dp(n, vector<int>(maxk + 1, INF));
    vector<SegTree> sts(maxk + 1, SegTree(n));
    vector<vector<int>> to(n, vector<int>(maxk + 1, -1));
    int sufmx = 0;
    for (int i = n - 1; i >= 0; --i) {
        sufmx = max(sufmx, a[i]);
        for (int k = 1; k <= min(maxk, n - i); ++k) {
            if (k == 1) {
                dp[i][k] = sufmx;
                to[i][k] = -1;
            } else {
                // int best = INF;
                // int bestto = -1;
                // for (int i1 = i; i1 + 1 < n - k + 2; ++i1) {
                //     if (a[i1] > a[i])
                //         break;
                //     if (dp[i1 + 1][k - 1] < best) {
                //         best = dp[i1 + 1][k - 1];
                //         bestto = i1 + 1;
                //     }
                // }
                // dp[i][k] = a[i];
                // to[i][k] = bestto;
                auto [best, bestto] = sts[k - 1].get(i + 1, min(rclos[i], n - k + 1) + 1);
                dp[i][k] = best;
                to[i][k] = bestto;
            }
            sts[k].upd(i, dp[i][k]);
        }
    }
    up[0].resize(n, vector<int>(maxk + 1));
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j <= maxk; ++j) {
            up[0][i][j] = (to[i][j] == -1 ? i : to[i][j]);
        }
    }
    for (int l = 1; l < LOG; ++l) {
        up[l].resize(n, vector<int>(n + 1));
        for (int i = 0; i < n; ++i) {
            for (int j = (1 << (l - 1)); j <= maxk; ++j) {
                up[l][i][j] = up[l - 1][up[l - 1][i][j]][j - (1 << (l - 1))];
            }
        }
    }
    while (q--) {
        int k, id;
        cin >> k >> id;
        --id;
        int cur = 0, curk = k;
        int curid = 0;
        for (int l = LOG - 1; l >= 0; --l) {
            if (curid + (1 << l) <= id) {
                cur = up[l][cur][curk];
                curk -= (1 << l);
                curid += (1 << l);
            }
        }
        cout << dp[cur][curk] << '\n';
    }
}