#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/allocator.h>

// #pragma GCC target("bmi2")

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

constexpr int inf = 1e18;

struct f {
    vector<vector<int>> t;
    int n, m;
    f(int n, int m) : n(n), m(m), t(n + 1, vector<int>(m + 1, 0)) {}
    int get(int i, int j) {
        int x = 0;
        for (++i; i > 0; i -= i & -i)
            for (int k = j + 1; k > 0; k -= k & -k)
                x += t[i][k];
        return x;
    }
    void upd(int i, int j, int x) {
        for (++i; i <= n; i += i & -i)
            for (int k = j + 1; k <= m; k += k & -k)
                t[i][k] += x;
    }
};

// struct f {
//     vector<pair<int, int>> a;
//     f(int n, int m) {}
//     void upd(int i, int j, int x) {
//         a.push_back({i, j});
//     }
//     int get(int i, int j) {
//         int x = 0;
//         for (auto k : a)
//             if (k.first <= i && k.second <= j)
//                 ++x;
//         return x;
//     }
// };

int inv(vector<int> a) {
    tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> s;
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        ans += s.size() - s.order_of_key(a[i]);
        s.insert(a[i]);
    }
    return ans;
}

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c, 0));
    for (auto &i : a)
        for (int &j : i)
            cin >> j, --j;
    vector<pair<int, pair<int, int>>> v;
    for (int i = 0; i < r; ++i)
        for (int j = 0; j < c; ++j)
            v.push_back({a[i][j], {i, j}});
    sort(rall(v));
    vector<vector<unordered_map<int, int>>> calc(r, vector<unordered_map<int, int>>(c));
    f t(r, c);
    for (auto [x, p] : v) {
        auto [i, j] = p;
        for (int ki = -1; ki < i; ++ki)
            calc[i][j][(ki + 1) * max(r, c) + j] = t.get(ki, c - 1) + t.get(r - 1, j - 1) - t.get(ki, j - 1);
        for (int kj = -1; kj < j; ++kj)
            calc[i][j][i * max(r, c) + kj + 1] = t.get(i - 1, c - 1) + t.get(r - 1, kj) - t.get(i - 1, kj);
        t.upd(i, j, 1);
    }
    vector<vector<int>> dp(r + 1, vector<int>(c + 1, inf));
    dp[0][0] = 0;
    for (int i = 0; i < r; ++i)
        for (int j = 0; j < c; ++j) {
            int now = dp[i][j];
            vector<int> b;
            for (int k = j; k < c; ++k)
                now += calc[i][k][i * max(r, c) + j], b.push_back(a[i][k]);
            now += inv(b);
            dp[i + 1][j] = min(dp[i + 1][j], now);
            now = dp[i][j];
            b.clear();
            for (int k = i; k < r; ++k)
                now += calc[k][j][i * max(r, c) + j], b.push_back(a[k][j]);
            now += inv(b);
            dp[i][j + 1] = min(dp[i][j + 1], now);
        }
    int ans = inf;
    for (int i = 0; i <= r; ++i)
        ans = min(ans, dp[i][c]);
    for (int j = 0; j <= c; ++j)
        ans = min(ans, dp[r][j]);
    cout << ans << '\n';
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}