#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

long double e = 1e-7;
struct point {
	long long x, y;
};
bool operator<(const point& a, const point& b) {
	if (a.x == b.x) {
		return a.y < b.y;
	}
	return a.x < b.x;
}
point operator/(const point& a, long double x) {
	return {(long long)(a.x / x + e), (long long)(a.y / x + e)};
}
std::vector<bool> ans;
std::vector<short> used;
std::vector<std::vector<int>> g;
std::map<point, std::vector<int>> cnt;
std::vector<point> a;
long long r;
long double r2;
bool check(int i, int j) {
	const long long x1 = a[i].x - a[j].x;
	const long long y1 = a[i].y - a[j].y;
	return x1 * x1 + y1 * y1 <= r * r;
}
void make() {
	for (auto& b : cnt) {
		if (b.second.size() >= 3) {
			for (int i : b.second) {
				ans[i] = 1;
			}
			continue;
		}
		const point p = b.first;
		for (int i : b.second) {
			for (int dx = -2; dx < 3; ++dx) {
				for (int dy = -2; dy < 3; ++dy) {
					const point p2 = { p.x + dx, p.y + dy };
					if (cnt.find(p2) != cnt.end()) {
						for (int j : cnt[p2]) {
							if (i != j && check(i, j)) {
								g[i].push_back(j);
							}
						}
					}
				}
			}
		}
	}
}
bool dfs(int i, int cl) {
	if (ans[i] || (used[i] + cl == 1)) {
		ans[i] = 1;
		return 1;
	}
	used[i] = cl;
	cl ^= 1;
	for (int to : g[i]) {
		if (used[to] != cl) {
			if (dfs(to, cl)) {
				ans[i] = 1;
				return 1;
			}
		}
	}
	return 0;
}
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int n;
	std::cin >> n >> r;
	r2 = r / (long double)(std::sqrt(2));
	ans.resize(n);
	used.resize(n, -1);
	a.resize(n);
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> a[i].x >> a[i].y;
		cnt[a[i] / r2].push_back(i);
	}
	make();
	for (int i = 0; i < n; ++i) {
		if (g[i].size() >= 6) {
			ans[i] = 1;
			continue;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i] == -1 && ans[i] == 0) {
			dfs(i, 0);
		}
	}
	for (int i = 0; i < n; ++i) {
		std::cout << ans[i];
	}
}