#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

int n;
std::vector<int> a, next, pref, p;
struct table {
	int h;
	std::vector<int> lg;
	std::vector<std::vector<std::pair<int, int>>> d;
	void build() {
		int h = 0;
		while ((1 << h) < n) {
			++h;
		}
		d.resize(h);
		lg.resize(n + 1);
		lg[1] = 0;
		for (int i = 2; i <= n; ++i) {
			lg[i] = lg[i >> 1] + 1;
		}
		d[0].resize(n);
		for (int i = 0; i < n; ++i) {
			d[0][i] = { a[i], i };
		}
		for (int i = 1; i < h; ++i) {
			d[i].resize(n - (1 << i) + 1);
			for (int j = 0; j < d[i].size(); ++j) {
				d[i][j] = std::min(d[i - 1][j], d[i - 1][j + (1 << (i - 1))]);
			}
		}
	}
	int get(int l, int r) {
		int ln = lg[r - l];
		return std::min(d[ln][l], d[ln][r - (1 << ln)]).second;
	}
};
table t;
void req() {
	int j, k;
	std::cin >> k >> j;
	int i = 0;
	while (--j) {
		--k;
		i = t.get(i + 1, std::min(n - k, next[i]) + 1);
	}
	if (k - 1 != j) {
		std::cout << a[i] << '\n';
	}
	else {
		std::cout << pref[i] << '\n';
	}
}
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int q;
	std::cin >> n >> q;
	a.resize(n);
	next.resize(n, n);
	pref.resize(n + 1, 1);
	for (int i = 0; i < n; ++i) {
		std::cin >> a[i];
	}
	for (int i = n - 1; i >= 0; --i) {
		pref[i] = std::max(a[i], pref[i + 1]);
	}
	t.build();
	for (int i = 0; i < n; ++i) {
		while (p.size() > 0 && a[p.back()] < a[i]) {
			next[p.back()] = i;
			p.pop_back();
		}
		p.push_back(i);
	}
	while (q--) {
		req();
	}
}