#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<int> par;

int find(int v) {
	return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	if (u != v) {
		par[u] = v;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif


	int n;
	ll r;
	cin >> n >> r;
	int sz = (r + 1) / 2;
	par.resize(n * 2);
	for (int i = 0; i < n * 2; i++) {
		par[i] = i;
	}
	unordered_map<pair<int, int>, vector<int>> mem;
	vector<pair<ll, ll>> ps(n);
	for (int i = 0; i < n; i++) {
		cin >> ps[i].first >> ps[i].second;
		mem[{ps[i].first / sz, ps[i].second / sz}].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int x = ps[i].first / sz;
		int y = ps[i].second / sz;

		for (int x1 = x - 2; x1 <= x + 2; x1++) {
			for (int y1 = y - 2; y1 <= y + 2; y1++) {
				if (!mem.count({ x1, y1 })) continue;
				for (int w = 0; w < min(int(mem[{x1, y1}].size()), 5); w++) {
					int j = mem[{x1, y1}][w];
					if (i != j && (ps[i].first - ps[j].first) * (ps[i].first - ps[j].first) + (ps[i].second - ps[j].second) * (ps[i].second - ps[j].second) <= r * r) {
						unite(i, j + n);
						unite(i + n, j);
					}
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		cout << (find(i) == find(i + n));
	}
}
