#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<int> par;

int find(int v) {
	return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	if (u != v) {
		par[u] = v;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif


	int n;
	ll r;
	cin >> n >> r;
	int sz = (r + 1) / 2;
	par.resize(n * 2);
	for (int i = 0; i < n * 2; i++) {
		par[i] = i;
	}
	vector<ll> keys;
	vector<pair<ll, ll>> ps(n);
	for (int i = 0; i < n; i++) {
		cin >> ps[i].first >> ps[i].second;
		keys.push_back(ps[i].first / sz * 1e9 + ps[i].second / sz);
	}
	sort(all(keys));
	keys.erase(unique(all(keys)), keys.end());
	vector<vector<int>> mem(keys.size());
	for (int i = 0; i < n; i++) {
		ll key = ps[i].first / sz * 1e9 + ps[i].second / sz;
		int pos = lower_bound(all(keys), key) - keys.begin();
		mem[pos].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int x = ps[i].first / sz;
		int y = ps[i].second / sz;

		for (ll x1 = x - 2; x1 <= x + 2; x1++) {
			for (ll y1 = y - 2; y1 <= y + 2; y1++) {
				ll key = x1 * 1e9 + y1;
				int pos = lower_bound(all(keys), key) - keys.begin();
				if (pos >= keys.size() || keys[pos] != key) continue;
				for (int w = 0; w < min(int(mem[pos].size()), 5); w++) {
					int j = mem[pos][w];
					if (i != j && (ps[i].first - ps[j].first) * (ps[i].first - ps[j].first) + (ps[i].second - ps[j].second) * (ps[i].second - ps[j].second) <= r * r) {
						unite(i, j + n);
						unite(i + n, j);
					}
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		cout << (find(i) == find(i + n));
	}
}
