#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<vector<int>> g;
vector<bool> used;
vector<bool> ans;
vector<int> h, par;

void dfs(int v) {
	used[v] = 1;
	for (auto to : g[v]) {
		if (!used[to]) {
			h[to] = h[v] + 1;
			par[to] = v;
			dfs(to);
		}
		else {
			if (h[to] % 2 == h[v] % 2) {
				int v1 = v;
				while (!ans[v1]) {
					ans[v1] = 1;
					if (v1 == to) break;
					v1 = par[v1];
				}
			}
		}
	}
}

vector<int> pard;

int find(int v) {
	return pard[v] == v ? v : pard[v] = find(pard[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	par[u] = v;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif


	int n;
	ll r;
	cin >> n >> r;
	g.resize(n);
	used.resize(n);
	ans.resize(n);
	h.resize(n);
	par.resize(n);
	pard.resize(n);
	for (int i = 0; i < n; i++) {
		pard[i] = i;
	}
	vector<pair<ll, ll>> ps(n);
	for (int i = 0; i < n; i++) {
		cin >> ps[i].first >> ps[i].second;
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((ps[i].first - ps[j].first) * (ps[i].first - ps[j].first) + (ps[i].second - ps[j].second) * (ps[i].second - ps[j].second) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
				if (find(i) != find(j)) {
					unite(i, j);
				}
			}
		}
	}
	dfs(0);
	for (int i = 0; i < n; i++) {
		ans[find(i)] = ans[find(i)] ||  ans[i];
	}
	for (int i = 0; i < n; i++) {
		cout << ans[find(i)];
	}
}
