#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<int> par;

int find(int v) {
	return par[v] == v ? v : par[v] = find(par[v]);
}

void unite(int u, int v) {
	u = find(u);
	v = find(v);
	if (u != v) {
		par[u] = v;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif


	int n;
	ll r;
	cin >> n >> r;
	par.resize(n*2);
	for (int i = 0; i < n*2; i++) {
		par[i] = i;
	}
	vector<pair<ll, ll>> ps(n);
	for (int i = 0; i < n; i++) {
		cin >> ps[i].first >> ps[i].second;
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((ps[i].first - ps[j].first) * (ps[i].first - ps[j].first) + (ps[i].second - ps[j].second) * (ps[i].second - ps[j].second) <= r * r) {
				unite(i, j + n);
				unite(i + n, j);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		cout << (find(i) == find(i + n));
	}
}
