#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<int> t;

void add(int i, int val) {
	for (; i < t.size(); i += i & (~(i - 1))) {
		t[i] += val;
	}
}

int get(int i) {
	int s = 0;
	for (; i > 0; i -= i & (~(i - 1))) {
		s += t[i];
	}
	return s;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif

	int n, m;
	cin >> n >> m;
	t.resize(n * m + 1);
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector<vector<int>> dp(n + 1, vector<int>(m + 1, 1e9));
	vector<vector<int>> inv1(n, vector<int>(m)), inv2(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		int s = 0;
		for (int j = m - 1; j >= 0; j--) {
			s += get(a[i][j]);
			add(a[i][j], 1);
			inv1[i][j] = s;
		}
		for (int j = m - 1; j >= 0; j--) {
			add(a[i][j], -1);
		}
	}
	for (int j = 0; j < m; j++) {
		int s = 0;
		for (int i = n - 1; i >= 0; i--) {
			s += get(a[i][j]);
			add(a[i][j], 1);
			inv2[i][j] = s;
		}
		for (int i = n - 1; i >= 0; i--) {
			add(a[i][j], -1);
		}
	}
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int res = dp[i][j];
			res += inv1[i][j];
			for (int i1 = 0; i1 < n; i1++) {
				for (int j1 = 0; j1 < m; j1++) {
					if (i1 < i || j1 < j) {
						for (int k = j; k < m; k++) {
							res += a[i1][j1] > a[i][k];
						}
					}
				}
			}
			dp[i + 1][j] = min(dp[i + 1][j], res);

			res = dp[i][j];
			res += inv2[i][j];
			for (int i1 = 0; i1 < n; i1++) {
				for (int j1 = 0; j1 < m; j1++) {
					if (i1 < i || j1 < j) {
						for (int k = i; k < n; k++) {
							res += a[i1][j1] > a[k][j];
						}
					}
				}
			}
			dp[i][j+1] = min(dp[i][j+1], res);
		}
	}
	int ans = 1e9;
	for (int i = 0; i < n; i++) {
		ans = min(ans, dp[i][m]);
	}
	for (int i = 0; i < m; i++) {
		ans = min(ans, dp[n][i]);
	}
	cout << ans;
}
