#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
using ll = long long;
#define all(a) a.begin(), a.end()
using namespace std;

vector<int> t;

void add(int i, int val) {
	for (; i < t.size(); i += i & (~(i - 1))) {
		t[i] += val;
	}
}

int get(int i) {
	int s = 0;
	for (; i > 0; i -= i & (~(i - 1))) {
		s += t[i];
	}
	return s;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
#endif

	int n, m;
	cin >> n >> m;
	t.resize(n * m + 1);
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e18));
	vector<vector<ll>> inv1(n, vector<ll>(m)), inv2(n, vector<ll>(m)), inv3(n, vector<ll>(m)), inv31(n, vector<ll>(m)), inv32(n, vector<ll>(m)), inv4(n, vector<ll>(m));
	for (int i = 0; i < n; i++) {
		ll s = 0;
		for (int j = m - 1; j >= 0; j--) {
			s += get(a[i][j]);
			add(a[i][j], 1);
			inv1[i][j] = s;
		}
		for (int j = m - 1; j >= 0; j--) {
			add(a[i][j], -1);
		}
	}
	for (int j = 0; j < m; j++) {
		ll s = 0;
		for (int i = n - 1; i >= 0; i--) {
			s += get(a[i][j]);
			add(a[i][j], 1);
			inv2[i][j] = s;
		}
		for (int i = n - 1; i >= 0; i--) {
			add(a[i][j], -1);
		}
	}

	for (int i = 0; i < n; i++) {//up
		ll s = 0;
		for (int j = m - 1; j >= 0; j--) {
			s += i * m - get(a[i][j]);
			inv3[i][j] = s;
		}
		for (int j = 0; j < m; j++) {
			add(a[i][j], 1);
		}
	}
	fill(all(t), 0);
	for (int i = 0; i < n; i++) {//l
		for (int j = 0; j < m; j++) {
			inv31[i][j] = (n - i) * j - get(a[i][j]);

			for (int k = i; k < n; k++) {
				add(a[k][j], 1);
			}
		}
		fill(all(t), 0);
	}
	for (int i = 0; i < n; i++) {//r
		for (int j = m - 1; j >= 0; j--) {
			if (j < m - 1) {
				inv32[i][j] += inv32[i][j + 1];
			}
			for (int k = i; k < n; k++) {
				inv32[i][j] -= get(a[k][j]);
			}
			inv32[i][j] += inv31[i][j];

			add(a[i][j], 1);
		}
		fill(all(t), 0);
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ll s = 0;
			for (int i1 = n - 1; i1 >= i; i1--) {
				s += i * m + j * n - i * j - get(a[i1][j]);
			}
			inv4[i][j] = s;

			for (int k = i; k < n; k++) {
				add(a[k][j], 1);
			}
		}
		fill(all(t), 0);
		for (int k = 0; k <= i; k++) {
			for (int j = 0; j < m; j++) {
				add(a[k][j], 1);
			}
		}
	}
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ll res = dp[i][j];
			res += inv1[i][j];
			res += inv3[i][j] + inv32[i][j];
			dp[i + 1][j] = min(dp[i + 1][j], res);

			res = dp[i][j];
			res += inv2[i][j];
			res += inv4[i][j];
			dp[i][j + 1] = min(dp[i][j + 1], res);
		}
	}
	ll ans = 1e18;
	for (int i = 0; i < n; i++) {
		ans = min(ans, dp[i][m]);
	}
	for (int i = 0; i < m; i++) {
		ans = min(ans, dp[n][i]);
	}
	cout << ans;
}