#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef __int128 lll;

ll R;

struct point {
    ll x, y, idx;
};

vector<set<ll>> g;
vector<bool> answer;
vector<ll> col;
bool flag = false;

void dfs(ll v) {
    for (auto i : g[v]) {
        if (answer[i] || (col[i] == col[v])) {
            flag = true;
        }
        if (!col[i]) {
            col[i] = (col[v] % 2) + 1;
            dfs(i);
        }
    }
}

void dfs1(ll v) {
    for (auto i : g[v]) {
        if (!answer[i]) {
            answer[i] = true;
            dfs1(i);
        }
    }
}

void update_answer() {
    col.assign(g.size(), 0);
    for (ll i = 0; i < g.size(); ++i) {
        if (col[i] || answer[i]) continue;
        col[i] = 1;
        flag = false;
        dfs(i);
        if (flag) dfs1(i);
    }
}

bool check(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= R * R;
}

void add_from(map<ll, vector<point>> mp) {
    for (auto [q, a] : mp) {
        sort(a.begin(), a.end(), [](point a, point b) {
            return a.x + a.y < b.x + b.y;
        });
        ll l = 0, ri = 0;
        for (int i = 0; i < a.size(); ++i) {
            while (l < a.size() && a[l].x + a[l].y + ceil(1.5 * R) < a[i].x + a[i].y) ++l;
            while (ri < a.size() && a[ri].x + a[ri].y - ceil(1.5 * R) <= a[i].x + a[i].y) ++ri;
            for (ll j1 = l; j1 < ri; ++j1) {
                for (ll j2 = j1 + 1; j2 < ri; ++j2) {
                    if (check(a[j1], a[j2])) {
                        g[a[j1].idx].insert(a[j2].idx);
                        g[a[j2].idx].insert(a[j1].idx);
                    }
                }
            }
        }
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    R = r;
    g.assign(n, {});
    vector<point> arr(n);
    for (ll i = 0; i < n; ++i) cin >> arr[i].x >> arr[i].y;
    for (int i = 0; i < n; ++i) arr[i].idx = i;
    map<ll, vector<point>> mp;
    for (int i = 0; i < n; ++i) {
        mp[(arr[i].x - arr[i].y) / (2 * r)].push_back(arr[i]);
    }
    add_from(mp);
    mp.clear();
    for (int i = 0; i < n; ++i) {
        mp[(arr[i].x - arr[i].y + r) / (2 * r)].push_back(arr[i]);
    }
    add_from(mp);
    answer.assign(n, false);
    update_answer();
    for (ll i = 0; i < n; ++i) cout << (answer[i] ? 1 : 0);
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}