#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Fenwick {
    int n;
    vector<int> tr;

    Fenwick(int n) : n(n) {
        tr.resize(n);
    }

    void upd(int i, int x) {
        for (; i < n; i = (i | (i + 1))) tr[i] += x;
    }

    int get(int i) {
        int ans = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) ans += tr[i];
        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    for (auto &e : a) {
        for (auto &i : e) {
            --i;
        }
    }
    vector<vector<int>> x1(n, vector<int>(m)), x2(m, vector<int>(n)); // del row, del column
    Fenwick lol(n * m);
    for (int r = n - 1; r >= 0; --r) {
        int tans = 0, tans2 = 0;
        for (int c = m - 1; c >= 0; --c) {
            for (int i = r + 1; i < n; ++i) {
                // tans += lol.get(a[i][c]);
                tans2 += lol.get(n * m - 1) - lol.get(a[i][c]);
            }
            x1[r][c] = tans2;
            x2[c][r] = tans2;
            lol.upd(a[r][c], 1);

        }
        for (int c = 0; c < m; ++c) {
            lol.upd(a[r][c], -1);
        }
    }
    for (int c = m - 1; c >= 0; --c) {
        int tans = 0;
        for (int r = n - 1; r >= 0; --r) {
            for (int i = c + 1; i < m; ++i) {
                tans += lol.get(n * m - 1) - lol.get(a[r][i]);
            }
            // x1[r][c] = tans;
            x2[c][r] = tans;
            lol.upd(a[r][c], 1);
        }
        for (int r = 0; r < n; ++r) {
            lol.upd(a[r][c], -1);
        }
    }
    // for (auto e : x1) {
    //     for (auto i : e) {
    //         cout << i << ' ';
    //     }
    //     cout << '\n';
    // }
    // for (auto e : x2) {
    //     for (auto i : e) {
    //         cout << i << ' ';
    //     }
    //     cout << '\n';
    // }
    vector<vector<int>> dp(n + 1, vector<int>(m + 1, 1e17));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i > 0) {
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + x1[i][j]);
            }
            if (j > 0) {
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + x2[j][i]);
            }
        }
    }
    int anss = dp[n - 1][m - 1];
    for (int i = 0; i < m; ++i) anss = min(anss, dp[n - 1][i]);
    for (int i = 0; i < n; ++i) anss = min(anss, dp[i][m - 1]);
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            for (int k = i; k < n; ++k) lol.upd(a[k][j], 1);
            anss += lol.get(a[i][j]) - 1;
            // cout << i << ' ' << j << ' ' << lol.get(a[i][j]) << '\n';
        }
        for (int j = m - 1; j >= 0; --j) {
            for (int k = i; k < n; ++k) lol.upd(a[k][j], -1);
        }
    }
    // for (auto e : dp) {
    //     for (auto i : e) {
    //         cout << i << ' ';
    //     }
    //     cout << '\n';
    // }
    // cout << anss << '\n';
    // for (int i = 0; i < n; ++i) {
    //     for (int j = m - 1; j >= 0; --j) {
    //         anss += lol.get(a[i][j]);
    //         lol.upd(a[i][j], 1);
    //     }
    //     for (int j = 0; j < m; ++j) lol.upd(a[i][j], -1);
    // }
    // for (int j = 0; j < m; ++j) {
    //     for (int i = n - 1; i >= 0; --i) {
    //         anss += lol.get(a[i][j]);
    //         lol.upd(a[i][j], 1);
    //     }
    //     for (int i = 0; i < n; ++i) {
    //         lol.upd(a[i][j], -1);
    //     }
    // }
    cout << anss << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}