#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#define int long long

using namespace std;

int n, r;
vector<int> col;
vector<pair<int, int>> p;
map<pair<int, int>, int> d;
vector<vector<int>> g;

unordered_map<int, int> yes;

bool go(pair<int, int> &a, pair<int, int> &b) {
    int dx = a.first - b.first;
    int dy = a.second - b.second;
    return dx * dx + dy * dy <= r * r;
}

void dfs(int v, int c) {
    col[v] = c;
    for (auto i : g[v]) {
        if (col[i] == -1) {
            dfs(i, c);
        }
    }
}

vector<int> bincol;

void dfs1(int v, int C, int c) {
    bincol[v] = c;
    for (auto i : g[v]) {
        if (i != v) {
            if (bincol[i] == -1) {
                dfs1(i, C, 1 - c);
            } else if (bincol[i] == c) {
                yes[C] = 1;
            }
        }
    }
}

signed main() {
    cin >> n >> r;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
        d[p[i]] = i;
    }
    g.resize(n);
    for (int v = 0; v < n; ++v) {
        for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                if (d.find({p[v].first + dx, p[v].second + dy}) != d.end()) {
                    int i = d[{p[v].first + dx, p[v].second + dy}];
                    if (i != v && go(p[v], p[i])) {
                        g[i].push_back(v);
                    }
                }
            }
        }
    }
    col.resize(n, -1);
    int c = 0;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            dfs(i, c);
            c++;
        }
    }
    bincol.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        if (bincol[i] == -1) {
            dfs1(i, col[i], 0);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (yes.find(col[i]) != yes.end()) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    cout << endl;
    return 0;
}