#include <bits/stdc++.h>
using namespace std;
// #define int long long
#pragma GCC optimize("O3,unroll-loops")

const int maxn = 100005;

vector<int> g[maxn];

int col[maxn];
int vv = -1;

void dfs(int v, int cc = 1) {
    col[v] = cc;
    for (int u : g[v]) {
        if (vv != -1) return;
        if (col[u] == 0)
            dfs(u, (cc == 1) ? (2) : (1));
        else {
            if (col[u] == cc) {
                vv = u;
                return;
            }
        }
    }
}

bool used[maxn];

long long dist(pair<long long, long long>& a, pair<long long, long long>& b) {
    long long u = a.first - b.first;
    long long v = a.second - b.second;
    return u * u + v * v;
}

int pr[maxn];
bool ok[maxn];

int get(int v) {
    return pr[v] == v ? v : pr[v] = get(pr[v]);
}

int sz[maxn];
vector<int> vec[maxn];

void unite(int u, int v) {
    bool inv = false;
    if (col[u] == col[v]) {
        inv = true;
    }

    u = get(u);
    v = get(v);

    if (sz[u] > sz[v]) swap(u, v);

    if (inv) {
        for (int i : vec[u]) {
            col[i] = col[i] == 1 ? 2 : 1;
        }
    }

    pr[u] = v;
    sz[v] += sz[u];

    if (ok[u]) ok[v] = true;

    for (int i : vec[u])
        vec[v].push_back(i);
}

void solve() {
    long long n, r;
    cin >> n >> r;
    fill(sz, sz + n, 1ll);
    iota(pr, pr + n, 0ll);
    for (int i = 0; i < n; i++) vec[i].push_back(i);
    // r *= r;

    vector<pair<long long, long long>> pts(n);
    for (int i = 0; i < n; i++)
        cin >> pts[i].first >> pts[i].second;

    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0ll);
    sort(perm.begin(), perm.end(),  [&](int a, int b) {
        return pts[a].first < pts[b].first;
    });

    int pl = 0, pr = 0;
    set<pair<int, int>> st;

    fill(col, col + n, 1);

    for (int i = 0; i < n; i++) {
        while (pr < n && pts[perm[pr]].first <= pts[perm[i]].first + r) {
            st.insert({pts[perm[pr]].second, perm[pr]});
            pr++;
        }

        while (pl < n && pts[perm[pl]].first < pts[perm[i]].first - r) {
            st.erase({pts[perm[pl]].second, perm[pl]});
            pl++;
        }

        auto it = st.lower_bound({pts[perm[i]].second - r, -1});

        while (true) {
            if (it == st.end()) break;
            if (it->first > pts[perm[i]].second + r) break;

            if (it->second == perm[i]) {
                ++it;
                continue;
            }

            if (dist(pts[it->second], pts[perm[i]]) <= r * r) {
                if (get(it->second) == get(perm[i])) {
                    if (col[it->second] == col[perm[i]]) {
                        ok[get(it->second)] = true;
                    }
                } else {
                    unite(it->second, perm[i]);
                }
            }

            ++it;
        }
    }

    string ans(n, '0');

    for (int i = 0; i < n; i++) {
        if (ok[get(i)]) ans[i] = '1';
    }

    cout << ans;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}