#include <bits/stdc++.h>
using namespace std;

struct fenwick {
  int size;
  vector<int> tree;

  fenwick(int n) : size(n), tree(n + 1) {}

  void update(int i, int value) {
    for (++i; i <= size; i += i & -i) {
      tree[i] += value;
    }
  }

  int query(int r) {
    int answer = 0;
    for (; r > 0; r -= r & -r) {
      answer += tree[r];
    }
    return answer;
  }
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int r, c;
  cin >> r >> c;
  vector<int> a(c);
  for (int &x : a) {
    cin >> x;
    --x;
  }
  fenwick bit(c);
  long long answer = 0;
  for (int i = 0; i < c; i++) {
    answer += i - bit.query(a[i]);
    bit.update(a[i], 1);
  }
  cout << answer << "\n";
}
// I decided to farm easy subtasks in C
