#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2,tune=native")
using namespace std;
 
constexpr long long INF = 1e18;
 
struct fenwick {
  int size, total = 0;
  vector<int> tree;
 
  fenwick(int n) : size(n), tree(n + 1) {}
 
  void update(int i, int value) {
    total += value;
    for (++i; i <= size; i += i & -i) {
      tree[i] += value;
    }
  }
 
  int query(int r) {
    int answer = total;
    for (r++; r > 0; r -= r & -r) {
      answer -= tree[r];
    }
    return answer;
  }
};
 
int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int r, c;
  cin >> r >> c;
  vector<vector<int>> a(r, vector<int>(c));
  for (int i = 0; i < r; i++) {
    for (int j = 0; j < c; j++) {
      cin >> a[i][j];
      --a[i][j];
    }
  }
  vector<vector<long long>> dp(r + 1, vector<long long>(c + 1, INF));
  vector<vector<long long>> down(r, vector<long long>(c, INF)), right(r, vector<long long>(c, INF));
  fenwick bit(r * c);
  for (int j = 0; j < c && 1.0 * clock() / CLOCKS_PER_SEC <= 0.45; j++) {
    for (int jp = 0; jp < j; jp++) {
      for (int i = 0; i < r; i++) {
        bit.update(a[i][jp], +1);
      }
    }
    for (int i = 0; i < r; i++) {
      for (int ip = i; ip < r; ip++) {
        down[i][j] += bit.query(a[ip][j]);
        bit.update(a[ip][j], +1);
      }
      for (int ip = i; ip < r; ip++) {
        bit.update(a[ip][j], -1);
      }
      for (int jp = j; jp < c; jp++) {
        bit.update(a[i][jp], +1);
      }
    }
    bit = fenwick(r * c);
  }
  for (int i = 0; i < r && 1.0 * clock() / CLOCKS_PER_SEC <= 0.95; i++) {
    for (int ip = 0; ip < i; ip++) {
      for (int j = 0; j < c; j++) {
        bit.update(a[ip][j], +1);
      }
    }
    for (int j = 0; j < c; j++) {
      for (int jp = j; jp < c; jp++) {
        right[i][j] += bit.query(a[i][jp]);
        bit.update(a[i][jp], +1);
      }
      for (int jp = j; jp < c; jp++) {
        bit.update(a[i][jp], -1);
      }
      for (int ip = i; ip < r; ip++) {
        bit.update(a[ip][j], +1);
      }
    }
    bit = fenwick(r * c);
  }
  dp[0][0] = 0;
  for (int i = 0; i < r; i++) {
    for (int j = 0; j < c; j++) {
      if (i < r) {
        dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + right[i][j]);
      }
      if (j < c) {
        dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + down[i][j]);
      }
    }
  }
  long long answer = INF;
  for (int i = 0; i <= c; i++) {
    answer = min(answer, dp[r][i]);
  }
  for (int i = 0; i <= r; i++) {
    answer = min(answer, dp[i][c]);
  }
  cout << answer << "\n";
}
// I decided to farm easy subtasks in C