#include<bits/stdc++.h>
using namespace std;

using ll = long long;

const ll inf = 1e18;

struct fenwick {
    int n;
    vector<int> fenw;

    fenwick() = default;
    fenwick(int _n) {
        n = _n;
        fenw.assign(n, 0);
    }

    void upd(int k) {
        for (; k < n; k |= k + 1) fenw[k]++;
    }
    int get(int k) {
        int ret = 0;
        for (; k >= 0; k &= k + 1, k--) ret += fenw[k];
        return ret;
    }
};

template<typename T>
vector<vector<T>> transpose(vector<vector<T>> a) {
    int n = a.size(), m = a[0].size();
    vector<vector<T>> b(m, vector<T>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            b[j][i] = a[i][j];
        }
    }
    return b;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& i : a) {
        for (auto& j : i) cin >> j;
    }
    if (n < m) {
        swap(n, m);
        a = transpose(a);
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, inf)), vert, horiz;
    fenwick fenw(n * m + 1);
    horiz = vector<vector<ll>>(n, vector<ll>(m));
    for (int j = 0; j < m; ++j) {
        fill(fenw.fenw.begin(), fenw.fenw.end(), 0);
        for (int i = n - 1; i >= 0; --i) {
            for (int k = m - 1; k >= j; --k) {
                horiz[i][j] += fenw.get(a[i][k]);
                fenw.upd(a[i][k]);
            }
        }
    }
    fenwick fenw2(n * m + 1);
    vert = vector<vector<ll>>(n, vector<ll>(m));
    for (int j = 0; j < m; ++j) {
        fill(fenw.fenw.begin(), fenw.fenw.end(), 0);
        fill(fenw2.fenw.begin(), fenw2.fenw.end(), 0);
        ll sm = 0;
        for (int i = n - 1; i >= 0; --i) {
            for (int k = j + 1; k < m; ++k) {
                sm += (n - i - 1) - fenw2.get(a[i][k]);
                fenw.upd(a[i][k]);
            }
            sm += fenw.get(a[i][j]);
            sm += fenw2.get(a[i][j]);
            fenw2.upd(a[i][j]);
            vert[i][j] = sm;
        }
    }
    for (int i = 0; i <= n; ++i) dp[i][m] = 0;
    for (int i = 0; i <= m; ++i) dp[n][i] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dp[i][j] = min(dp[i][j + 1] + vert[i][j], dp[i + 1][j] + horiz[i][j]);
        }
    }
    for (int i = 0; i <= n; ++i) dp[i][m] = 0;
    for (int i = 0; i <= m; ++i) dp[n][i] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dp[i][j] = min(dp[i][j + 1] + vert[i][j], dp[i + 1][j] + horiz[i][j]);
        }
    }
    cout << dp[0][0] << '\n';
}