#include<bits/stdc++.h>
using namespace std;

using ll = long long;

const ll inf = 1e18;

struct fenwick {
    int n;
    vector<int> fenw;

    fenwick() = default;
    fenwick(int _n) {
        n = _n;
        fenw.assign(n, 0);
    }

    void upd(int k) {
        for (; k < n; k |= k + 1) fenw[k]++;
    }
    int get(int k) {
        int ret = 0;
        for (; k >= 0; k &= k + 1, k--) ret += fenw[k];
        return ret;
    }
};

template<typename T>
vector<vector<T>> transpose(vector<vector<T>> a) {
    int n = a.size(), m = a[0].size();
    vector<vector<T>> b(m, vector<T>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            b[j][i] = a[i][j];
        }
    }
    return b;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& i : a) {
        for (auto& j : i) cin >> j;
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, inf)), vert, horiz;
    fenwick fenw(n * m + 1);
    for (int iter = 0; iter < 2; ++iter, swap(n, m), a = transpose(a), swap(vert, horiz)) {
        horiz = vector<vector<ll>>(n, vector<ll>(m));
        for (int j = 0; j < m; ++j) {
            fill(fenw.fenw.begin(), fenw.fenw.end(), 0);
            for (int i = n - 1; i >= 0; --i) {
                for (int k = m - 1; k >= j; --k) {
                    horiz[i][j] += fenw.get(a[i][k]);
                    fenw.upd(a[i][k]);
                }
            }
        }
        // vector<vector<int>> vals(4 * m);
        // vector<fenwick> tr(4 * m);
        // auto build = [&](auto build, int u, int l, int r) -> void {
        //     if (l == r) {
        //         for (int i = 0; i < n; ++i) vals[u].push_back(a[i][l]);
        //         sort(vals[u].begin(), vals[u].end());
        //     } else {
        //         int m = (l + r) / 2;
        //         build(build, u << 1, l, m);
        //         build(build, u << 1 | 1, m + 1, r);
        //         merge(vals[u << 1].begin(), vals[u << 1].end(), vals[u << 1 | 1].begin(), vals[u << 1 | 1].end(), back_inserter(vals[u]));
        //     }
        //     tr[u] = fenwick(vals[u].size());
        // };
        // build(build, 1, 0, m - 1);
        // for (int i = n - 1; i >= 0; --i) {
        //     auto dc = [&](auto dc, int u, int l, int r) -> void {
        //         if (l == r) {
        //             int k = lower_bound(vals[u].begin(), vals[u].end(), a[i][l]) - vals[u].begin();
        //             vert[i][l] += tr[u].get(k);
        //         } else {
        //             int m = (l + r) / 2;
        //             ll sm = 0;
        //             for (int j = r; j > m; --j) {
        //                 int k = upper_bound(vals[u << 1 | 1].begin(), vals[u << 1 | 1].end(), a[i][j]) - vals[u << 1 | 1].begin();
        //                 sm += tr[u << 1 | 1].get(k);
        //             }
        //             dc(dc, u << 1 | 1, m + 1, r);
        //             dc(dc, u << 1, l, m);
        //             for (int j = m; j >= l; --j) {
        //                 int k = upper_bound(vals[u << 1 | 1].begin(), vals[u << 1 | 1].end(), a[i][j]) - vals[u << 1 | 1].begin();
        //                 sm += tr[u << 1 | 1].get(k);
        //                 vert[i][j] += sm;
        //             }
        //         }
        //         for (int j = l; j <= r; ++j) {
        //             int k = lower_bound(vals[u].begin(), vals[u].end(), a[i][j]) - vals[u].begin();
        //             tr[u].upd(k);
        //         }
        //     };
        //     dc(dc, 1, 0, m - 1);
        // }
        // for (auto& i : vert) {
        //     for (auto& j : i) cout << j << ' ';
        //     cout << endl;
        // }
    }
    vert = transpose(vert);
    for (int i = 0; i <= n; ++i) dp[i][m] = 0;
    for (int i = 0; i <= m; ++i) dp[n][i] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dp[i][j] = min(dp[i][j + 1] + vert[i][j], dp[i + 1][j] + horiz[i][j]);
        }
    }
    cout << dp[0][0] << '\n';
}