#include<bits/stdc++.h>
using ll = int;
using namespace std;
struct SegTree {
    vector<ll> t, add;
    ll sz;
    SegTree(ll n = 1) {
        sz = n;
        t.resize(4*sz);
        add.resize(4*sz);
    }
    void push(ll v, ll l, ll r) {
        t[v]+=add[v]*(r-l);
        if (l+1!=r) {
            add[2*v]+=add[v];
            add[2*v+1]+=add[v];
        }
        add[v]=0;
    }
    ll get(ll l, ll r) {
        if (l==r) {
            return 0;
        }
        return _get(1, 0, sz, l, r);
    }
    ll _get(ll v, ll tl, ll tr, ll l, ll r) {
        push(v, tl, tr);
        if (l<=tl&&tr<=r) {
            return t[v];
        }
        ll tm = (tr+tl)/2;
        if (r<=tm) {
            return _get(2*v, tl, tm, l, r);
        }
        if (l>=tm) {
            return _get(2*v+1, tm, tr, l, r);
        }
        return _get(2*v, tl,tm, l, tm)+_get(2*v+1, tm, tr, tm, r);
    }
    void update(ll l, ll r, ll val) {
        if (l==r) {
            return;
        }
        _update(1, 0, sz, l, r, val);
    }
    void _update(ll v, ll tl, ll tr,ll l, ll r, ll val) {
        push(v, tl, tr);
        if (r<=tl||tr<=l) {
            return;
        }
        if (l<=tl&&tr<=r) {
            add[v]+=val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l,r, val);
        _update(2*v+1, tm, tr, l,r, val);
        t[v]=t[2*v+1]+t[2*v];
    }
};
void solve() {
    ll n, m;
    cin>>n>>m;
    vector<vector<ll>> v(n, vector<ll>(m));
    for (int i = 0; i<n; i++) {
        for (int j = 0; j<m; j++) {
            cin>>v[i][j];
            v[i][j]--;
        }
    }
    vector<vector<ll>> dp(n+1, vector<ll> (m+1, 0));
    SegTree sg = n*m;
    for (int j = m-1; j>-1; j--) {
        sg = n*m;
        for (int i = n-1; i>-1; i--) {
            ll ans1 = 0;
            for (int j1 = m-1; j1>=j; j1--) {
                sg.update(v[i][j1], v[i][j1]+1, 1);
                ans1+=sg.get(0, v[i][j1]);
            }
            cout<<ans1<<"\n";
            ll ans2 = 0;
            for (int i1 = i; i1<n; i1++) {
                sg.update(v[i1][j], v[i1][j]+1, -1);
            }
            for (int i1 = n-1; i1>=i; i1--) {
                sg.update(v[i1][j], v[i1][j]+1, 1);
                ans2+=sg.get(0, v[i1][j]);
            }
            cout<<ans2<<"\n";
            dp[i][j]=min(dp[i+1][j]+ans1, dp[i][j+1]+ans2);
        }
    }
    // for (int i = 0; i<n; i++) {
    //     for (int j = 0; j<m; j++) {
    //         cout<<dp[i][j]<<" ";
    //     }
    //     cout<<"\n";
    // }
    cout<<dp[0][0]<<"\n";
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while (AnyaSamsonovaGoSex--)solve();
}