#pragma GCC optimize("O2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define int long long
const int INF = 1e12;
using namespace std;

struct segment_tree {
    vector<int> t;

    int get(int v, int l, int r, int lq, int rq) {
        if (lq >= r || l >= rq) {
            return 0;
        }
        if (lq <= l && r <= rq) {
            return t[v];
        }
        int m = (r + l) / 2;
        return get(2 * v, l, m, lq, rq) + get(2 * v + 1, m, r, lq, rq);
    }
    void upd(int v, int l, int r, int ind , int x) {
        if (r - l == 1) {
            t[v] += x;
            return;
        }
        int m = (r + l) / 2;
        if (ind < m) {
            upd(2 * v, l, m, ind, x);
        }
        else {
            upd(2 * v + 1, m, r, ind, x);
        }
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    int n;
    int get(int l, int r) {
        return get(1, 0, n, l, r + 1);
    }
    void upd(int ind ,int x) {
        upd(1, 0, n, ind, x);
    }

    void create(int nn) {
        n = nn;
        t.resize(n * 4 + 10, 0);
    }
};

signed main() {
    int r, c;
    cin >> r >> c;
    vector<int> ab(c);
    for (auto& i : ab)
        cin >> i;
    segment_tree st;
    st.create(r * c + 1);
    int ans = 0;
    for (auto i : ab) {

        ans += st.get(i, r * c);
        st.upd(i, 1);
    }

    cout << ans;
}