#pragma GCC optimize("O2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define int long long
const int INF = 1e12;
using namespace std;

struct segment_tree {
    vector<int> t;

    int get(int v, int l, int r, int lq, int rq) {
        if (lq >= r || l >= rq) {
            return 0;
        }
        if (lq <= l && r <= rq) {
            return t[v];
        }
        int m = (r + l) / 2;
        return get(2 * v, l, m, lq, rq) + get(2 * v + 1, m, r, lq, rq);
    }
    void upd(int v, int l, int r, int ind , int x) {
        if (r - l == 1) {
            t[v] += x;
            return;
        }
        int m = (r + l) / 2;
        if (ind < m) {
            upd(2 * v, l, m, ind, x);
        }
        else {
            upd(2 * v + 1, m, r, ind, x);
        }
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    int n;
    int get(int l, int r) {
        return get(1, 0, n, l, r + 1);
    }
    void upd(int ind ,int x) {
        upd(1, 0, n, ind, x);
    }

    void create(int nn) {
        n = nn;
        t.resize(n * 4 + 10, 0);
    }
};

signed main() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> ab(r, vector<int>(c));
    segment_tree st;
    st.create(r * c + 1);
    for (auto& i : ab) {
        for (auto& j : i)
            cin >> j;
    }

    vector<vector<int>> pod(r, vector<int>(c));

    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            pod[i][j] = st.get(ab[i][j], r * c);
            st.upd(ab[i][j], 1);
        }
    }

    vector<vector<int>> dp(r + 1, vector<int>(c + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            int cnt = 0;
            for (int w = j; w < c; w++) {
                cnt += pod[i][w];
            }
            dp[i + 1][j] = min(dp[i][j] + cnt, dp[i + 1][j]);
            cnt = 0;
            for (int w = i; w < r; w++) {
                cnt += pod[w][j];
            }
            dp[i][j + 1] = min(dp[i][j] + cnt, dp[i][j + 1]);
        }
    }

    int ans = INF;

    for (int i = 0; i < r; i++) {
        ans = min(ans, dp[i][c]);
    }
    for (int j = 0; j < c; j++) {
        ans = min(ans, dp[r][j]);
    }

    cout << ans;
}