#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = (ll) (7e18);

struct fenwick {
    int n;
    vector<int> f;

    fenwick(const int _n) {
        n = _n;
        f.resize(n + 1);
    }

    void update(int i) {
        for (i++; i <= n; i += i & -i) {
            f[i]++;
        }
    }

    void update1(int i) {
        for (i++; i <= n; i += i & -i) {
            f[i]--;
        }
    }

    int get(int i) {
        int cnt = 0;
        for (i++; i > 0; i -= i & -i) {
            cnt += f[i];
        }
        return cnt;
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    auto calc = [&](int i, int j, int x) -> int {
        int cnt = 0;
        for (int i1 = i; i1 < n; i1++) {
            for (int j1 = j; j1 < m; j1++) {
                cnt += (a[i1][j1] < x);
            }
        }
        return cnt;
    };
    vector<vector<ll> > dp(n, vector<ll>(m, inf));
    vector<vector<ll> > col(n, vector<ll>(m, 0));
    vector<vector<ll> > row(n, vector<ll>(m, 0));
    vector<vector<ll> > kek(n, vector<ll>(m, 0));
    vector<pair<int, pair<int, int> > > evr;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            evr.push_back({a[i][j], {i, j}});
        }
    }
    ranges::sort(evr);
    vector<fenwick> before(n, fenwick(m));
    for (int e = 0; e < n * m; e++) {
        auto [v, cr] = evr[e];
        auto [x, y] = cr;
        for (int i = x; i < n; i++) {
            kek[x][y] += before[i].get(m - 1) - before[i].get(y - 1);
        }
        before[x].update(y);
    }
    fenwick tree(n * m);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i + 1 < n) {
                col[i][j] = col[i + 1][j];
            }
            col[i][j] += kek[i][j];
            for (int i1 = i + 1; i1 < n; i1++) {
                tree.update(a[i1][j]);
            }
            for (int j1 = j + 1; j1 < m; j1++) {
                col[i][j] += tree.get(n * m - 1) - tree.get(a[i][j1] - 1);
            }
            for (int i1 = i + 1; i1 < n; i1++) {
                tree.update1(a[i1][j]);
            }
        }
    }
    for (int j = m - 1; j >= 0; j--) {
        for (int i = n - 1; i >= 0; i--) {
            if (j + 1 < m) {
                row[i][j] = row[i][j + 1];
            }
            row[i][j] += kek[i][j];
            for (int j1 = 0; j1 < m; j1++) {
                tree.update(a[i][j1]);
            }
            for (int i1 = 0; i1 < n; i1++) {
                row[i][j] += tree.get(a[i1][j]);
            }
            for (int j1 = 0; j1 < m; j1++) {
                tree.update1(a[i][j1]);
            }
        }
    }
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < m; j++) {
    //         cout << i << ' ' << j << ": " << col[i][j] << endl;
    //     }
    // }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            ll cand1 = (j + 1 < m ? dp[i][j + 1] : 0);
            // for (int i1 = i; i1 < n; i1++) {
            //     cand1 += calc(i, j + 1, a[i1][j]);
            //     for (int i2 = i1 + 1; i2 < n; i2++) {
            //         cand1 += (a[i2][j] < a[i1][j]);
            //     }
            // }
            cand1 += col[i][j];
            ll cand2 = (i + 1 < n ? dp[i + 1][j] : 0);
            // for (int j1 = j; j1 < m; j1++) {
            //     cand2 += calc(i + 1, j, a[i][j1]);
            //     for (int j2 = j1 + 1; j2 < m; j2++) {
            //         cand2 += (a[i][j2] < a[i][j1]);
            //     }
            // }
            cand2 += row[i][j];
            dp[i][j] = min(cand1, cand2);
        }
    }
    cout << dp[0][0] << '\n';
    return 0;
}
