#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct fenwick {
    int n;
    vector<int> f;

    fenwick(const int _n) {
        n = _n;
        f.resize(n + 1);
    }

    void update(int i) {
        for (i++; i <= n; i += i & -i) {
            f[i]++;
        }
    }

    int get(int i) {
        int cnt = 0;
        for (i++; i > 0; i -= i & -i) {
            cnt += f[i];
        }
        return cnt;
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x;
            cin >> x;
            x--;
            a.emplace_back(x);
        }
    }
    n = (int) a.size();
    fenwick tree(n);
    ll ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        ans += tree.get(a[i]);
        tree.update(a[i]);
    }
    cout << ans << '\n';
    return 0;
}
