#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct fenwick {
    int n;
    vector<int> f;

    fenwick(const int _n) {
        n = _n;
        f.resize(n + 1);
    }

    void update(int i) {
        for (i++; i <= n; i += i & -i) {
            f[i]++;
        }
    }

    int get(int i) {
        int cnt = 0;
        for (i++; i > 0; i -= i & -i) {
            cnt += f[i];
        }
        return cnt;
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > f(n, vector<int>(m));
    vector<int> a, b;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x;
            cin >> x;
            x--;
            f[i][j] = x;
            a.emplace_back(x);
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            b.emplace_back(f[i][j]);
        }
    }
    ll ans = 1ll * n * n; {
        n = (int) a.size();
        fenwick tree(n);
        ll ans1 = 0;
        for (int i = n - 1; i >= 0; i--) {
            ans1 += tree.get(a[i]);
            tree.update(a[i]);
        }
        ans = ans1;
    } {
        n = (int) a.size();
        fenwick tree(n);
        ll ans2 = 0;
        for (int i = n - 1; i >= 0; i--) {
            ans2 += tree.get(b[i]);
            tree.update(b[i]);
        }
        ans = min(ans, ans2);
    }
    cout << ans << '\n';
    return 0;
}
