#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = (ll) (7e18);

struct fenwick {
    int n;
    vector<int> f;

    fenwick(const int _n) {
        n = _n;
        f.resize(n + 1);
    }

    void update(int i) {
        for (i++; i <= n; i += i & -i) {
            f[i]++;
        }
    }

    int get(int i) {
        int cnt = 0;
        for (i++; i > 0; i -= i & -i) {
            cnt += f[i];
        }
        return cnt;
    }
};

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    auto calc = [&](int i, int j, int x) -> int {
        int cnt = 0;
        for (int i1 = i; i1 < n; i1++) {
            for (int j1 = j; j1 < m; j1++) {
                cnt += (a[i1][j1] < x);
            }
        }
        return cnt;
    };
    vector<vector<ll> > dp(n, vector<ll>(m, inf));
    vector<vector<ll> > down(n, vector<ll>(m, 0)), right(n, vector<ll>(m, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int i1 = i + 1; i1 < n; i1++) {
                down[i][j] += (a[i1][j] < a[i][j]);
            }
            for (int j1 = j + 1; j1 < m; j1++) {
                right[i][j] = (a[i][j1] < a[i][j]);
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            ll cand1 = (j + 1 < m ? dp[i][j + 1] : 0);
            for (int i1 = i; i1 < n; i1++) {
                cand1 += calc(i, j + 1, a[i1][j]);
                cand1 += down[i1][j];
            }
            ll cand2 = (i + 1 < n ? dp[i + 1][j] : 0);
            for (int j1 = j; j1 < m; j1++) {
                cand2 += calc(i + 1, j, a[i][j1]);
                cand2 += right[i][j1];
            }
            dp[i][j] = min(cand1, cand2);
        }
    }
    cout << dp[0][0] << '\n';
    return 0;
}
