#include <bits/stdc++.h>
using namespace std;

struct spTable {
    vector<vector<pair<int, int>>> t;
    vector<int> log;

    void build(vector<pair<int, int>> &a) {
        int n = a.size();
        log.assign(n + 1, 0);
        for (int i = 2; i <= n; i++)
            log[i] = log[i / 2] + 1;

        t.assign(log[n] + 1, vector<pair<int, int>> (n));
        t[0] = a;
        for (int lvl = 0; lvl < log[n]; lvl++) {
            for (int i = 0; i < n; i++) {
                t[lvl + 1][i] = t[lvl][i];
                if (i + (1 << lvl) < n)
                    t[lvl + 1][i] = min(t[lvl + 1][i], t[lvl][i + (1 << lvl)]);
            }
        }
    }

    pair<int, int> get(int l, int r) {
        int lvl = log[r - l + 1];
        return min(t[lvl][l], t[lvl][r - (1 << lvl) + 1]);
    }
};

int32_t main() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector<int> r(n, n);
    vector<int> suf(n + 1, 0);
    vector<int> st;
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = max(suf[i + 1], a[i]);
        while (!st.empty() && a[st.back()] < a[i])
            st.pop_back();
        if (!st.empty())
            r[i] = st.back();
        st.push_back(i);
    }
    // vector<vector<int>> bs(n);
    // for (int i = 0; i < n; i++) {
    //     int l = i;
    //     while (l < n) {
    //         bs[i].push_back(l);
    //         l = r[l];
    //     }
    // }
    vector<pair<int, int>> tmp(n);
    for (int i = 0; i < n; i++)
        tmp[i] = {a[i], i};

    spTable table;
    table.build(tmp);

    for (int i = 0; i < q; i++) {
        int k, ind;
        cin >> k >> ind;
        vector<int> p;
        int l = 0;
        for (;;) {
            if (k == 1) {
                p.push_back(suf[l]);
                break;
            }
            p.push_back(a[l]);
            auto [x, j] = table.get(l + 1, min(r[l], n));
            l = j;
            k--;
        }
        cout << p[ind - 1] << "\n";
    }
}