#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 1e5 + 7, lg = 25;

vector <int> v[N];
int d[N];
int used[N];
int ans[N];
int pr[N], sz[N];

struct pt {
    ll x, y;
};

ll dist(pt p1, pt p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

int get(int x) {
    if (x == pr[x]) {
        return x;
    }
    return pr[x] = get(pr[x]);
}

bool check(int x, int y) {
    x = get(x);
    y = get(y);
    return x == y;
}

void unite(int x, int y) {
    x = get(x);
    y = get(y);
    if (sz[x] > sz[y]) {
        sz[x] += sz[y];
        pr[y] = x;
    }
    else {
        sz[y] += sz[x];
        pr[x] = y;
    }
}

int t = 0;
int tin[N], tout[N];
int jump[N][lg];

void dfs(int x, int pr, int num) {
    used[x] = num;
    tin[x] = t++;
    jump[x][0] = pr;
    for (int i = 1; i < lg; i++) {
        jump[x][i] = jump[jump[x][i - 1]][i - 1];
    }
    for (auto u: v[x]) {
        if (u != pr) {
            d[u] = d[x] + 1;
            dfs(u, x, num);
        }
    }
    tout[x] = t++;
}

bool anc(int x, int y) {
    return tin[x] <= tin[y] && tout[x] >= tout[y];
}

int lca(int a, int b) {
    if (anc(a, b)) {
        return a;
    }
    if (anc(b, a)) {
        return b;
    }
    for (int i = lg - 1; i >= 0; i--) {
        int c = jump[a][i];
        if (anc(c, b)) {
            continue;
        }
        a = c;
    }
    return jump[a][0];
}

map <pair <int, int>, int> mp;

int main() {
    ll n, r;
    cin >> n >> r;
    vector <pt> vec;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        mp[{x, y}] = i + 1;
        vec.push_back({x, y});
    }
    for (int i = 0; i < n; i++) {
        pr[i] = i;
        sz[i] = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int x = vec[i].x - r; x <= vec[i].x + r; x++) {
            for (int y = vec[i].y - r; y <= vec[i].y + r; y++) {
                if (mp[{x, y}] == 0) {
                    continue;
                }
                int j = mp[{x, y}] - 1;
                if (i != j && dist(vec[i], vec[j]) <= r*r && !check(i, j)) {
                    v[i].push_back(j);
                    v[j].push_back(i);
                    unite(i, j);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i, i + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int x = vec[i].x - r; x <= vec[i].x + r; x++) {
            for (int y = vec[i].y - r; y <= vec[i].y + r; y++) {
                if (mp[{x, y}] == 0) {
                    continue;
                }
                int j = mp[{x, y}] - 1;
                if (i != j && used[i] == used[j] && ans[used[i]] == 0 && dist(vec[i], vec[j]) <= r*r) {
                    int c = lca(i, j);
                    int d1 = d[i] + d[j] - 2*d[c];
                    if (d1 % 2 == 0) {
                        ans[used[i]] = 1;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[used[i]];
    }
}
