#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 2e5 + 7, lg = 25;

vector <int> v[N];
vector <int> v1[N];
int d[N];
int used[N];
int ans[N];
int pr[N], sz[N];

struct pt {
    ll x, y;
};

ll dist(pt p1, pt p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

int get(int x) {
    if (x == pr[x]) {
        return x;
    }
    return pr[x] = get(pr[x]);
}

bool check(int x, int y) {
    x = get(x);
    y = get(y);
    return x == y;
}

void unite(int x, int y) {
    x = get(x);
    y = get(y);
    if (sz[x] > sz[y]) {
        sz[x] += sz[y];
        pr[y] = x;
    }
    else {
        sz[y] += sz[x];
        pr[x] = y;
    }
}

int t = 0;
int tin[N], tout[N];
int jump[N][lg];

void dfs(int x, int pr, int num) {
    used[x] = num;
    tin[x] = t++;
    jump[x][0] = pr;
    for (int i = 1; i < lg; i++) {
        jump[x][i] = jump[jump[x][i - 1]][i - 1];
    }
    for (auto u: v[x]) {
        if (u != pr) {
            d[u] = d[x] + 1;
            dfs(u, x, num);
        }
    }
    tout[x] = t++;
}

bool anc(int x, int y) {
    return tin[x] <= tin[y] && tout[x] >= tout[y];
}

int lca(int a, int b) {
    if (anc(a, b)) {
        return a;
    }
    if (anc(b, a)) {
        return b;
    }
    for (int i = lg - 1; i >= 0; i--) {
        int c = jump[a][i];
        if (anc(c, b)) {
            continue;
        }
        a = c;
    }
    return jump[a][0];
}

set <tuple <int, int, int>> st;
map <pair <int, int>, int> mp;

bool cmp(pt p1, pt p2) {
    return p1.x < p2.x;
}

int main() {
    ll n, r;
    cin >> n >> r;
    vector <pt> vec;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        mp[{x, y}] = i;
        vec.push_back({x, y});
    }
    sort(vec.begin(), vec.end(), cmp);
    for (int i = 0; i < n; i++) {
        st.insert({vec[i].x, vec[i].y, i});
    }
    st.insert({5e8 + 1, 5e8 + 1, 1});
    for (int i = 0; i < n; i++) {
        pr[i] = i;
        sz[i] = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int x1 = 0; x1 <= r; x1++) {
            for (int y1 = 0; (y1*y1 + x1*x1) <= r*r; y1++) {
                int x = vec[i].x + x1;
                int y = vec[i].y + y1;
                auto [X, Y, j] = *st.lower_bound({x, y, 0});
                if (X == x && Y == y) {
                    if (i != j) {
                        v1[i].push_back(j);
                    }
                    if (!check(i, j)) {
                        v[i].push_back(j);
                        v[j].push_back(i);
                        unite(i, j);
                        //cout << "! " << i << " " << j << endl;
                    }
                }
                y = vec[i].y - y1;
                auto [X1, Y1, j1] = *st.lower_bound({x, y, 0});
                if (X1 == x && Y1 == y) {
                    if (i != j1) {
                        v1[i].push_back(j1);
                    }
                    if (!check(i, j1)) {
                        v[i].push_back(j1);
                        v[j1].push_back(i);
                        unite(i, j1);
                        //cout << "! " << i << " " << j1 << endl;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, i, i + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[used[i]]) {
            continue;
        }
        for (auto j: v1[i]) {
            if (used[i] == used[j]) {
                int c = lca(i, j);
                int d1 = d[i] + d[j] - 2*d[c];
                if (d1 % 2 == 0) {
                    ans[used[i]] = 1;
                }
            }
            if (ans[used[i]]) {
                break;
            }
        }
    }
    vector <int> ans1(n, 0);
    for (int i = 0; i < n; i++) {
        ans1[mp[{vec[i].x, vec[i].y}]] = ans[used[i]];
    }
    for (int i = 0; i < n; i++) {
        cout << ans1[i];
    }
}
