#include <bits/stdc++.h>

using ll = long long;

const ll INF = 1e9;

using namespace std;

bool fl;

vector<vector<int>> g;
vector<bool> used, used1;
vector<int> h, ans;

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) {
            if (h[u] % 2 != (h[v] + 1) % 2) {
                fl = 1;
            }
            continue;
        }
        h[u] = h[v] + 1;
        dfs(u);
    }
}

void color(int v) {
    used1[v] = 1;
    ans[v] = 1;
    for (auto u : g[v]) {
        if (used1[u]) {
            continue;
        }
        color(u);
    }
}

struct Point {
    ll x, y;
};

ll dist(Point a, Point b) {
    return (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
}

bool operator<(Point a, Point b) {
    if (a.x == b.x){
        return a.y < b.y;
    }
    return a.x < b.x;
}

void solve() {
    ll n, r;
    cin >> n >> r;
    g.resize(n);
    h.assign(n, 0);
    used.assign(n, 0);
    used1.assign(n, 0);
    ans.assign(n, 0);
    vector<Point> v(n);
    unordered_map<ll, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> v[i].x >> v[i].y;
        mp[v[i].x * INF + v[i].y] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        Point p = v[i];
        for (int x = p.x - r; x <= p.x + r; x++) {
            for (int y = p.y - r; y <= p.y + r; y++) {
                if (x == p.x && y == p.y) {
                    continue;
                }
                if (dist({p.x, p.y}, {x, y}) > r * r) {
                    continue;
                }
                ll k = mp[x * INF + y];
                if (k == 0) {
                    continue;
                }
                g[k - 1].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            fl = 0;
            dfs(i);
            if (fl) {
                color(i);
            }
        }
        cout << ans[i];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    bool MULTITEST = 0;

    #ifdef egg 
        freopen("test.txt", "r", stdin);
        MULTITEST = 1;
    #endif

    if (MULTITEST) {
        cin >> t;
    }

    while (t--) {
        solve();
    }

    return 0;
}
