#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

vector<vector<int>> g;
vector<int> h, comp;
vector<bool> vis;
bool flag = false;

void dfs(int u, int p) {
	vis[u] = true;
	comp.push_back(u);
	for (int v : g[u]) {
		if (!vis[v]) {
			h[v] = h[u] + 1;
			dfs(v, u);
		}
		else {
			if (h[u] % 2 == h[v] % 2)
				flag = true;
		}
	}
}
ll get_dist(ll x1, ll y1, ll x2, ll y2) {
	return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; ll r;
	cin >> n >> r;
	vector<ll> x(n), y(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
	}
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (get_dist(x[i], y[i], x[j], y[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	h.resize(n, 0);
	vis.resize(n, false);
	vector<bool> ans(n, false);
	for (int i = 0; i < n; ++i) {
		if (!vis[i]) {
			comp.clear();
			flag = false;
			dfs(i, -1);
			if (flag) {
				for (int u : comp)
					ans[u] = true;
			}
		}
	}
	for (auto el : ans) cout << (int)el;

	return 0;
}