#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;
using ll = long long;

vector<vector<int>> g;
vector<int> h, comp;
vector<bool> vis;
bool flag = false;

void dfs(int u, int p) {
	vis[u] = true;
	comp.push_back(u);
	for (int v : g[u]) {
		if (!vis[v]) {
			h[v] = h[u] + 1;
			dfs(v, u);
		}
		else {
			if (h[u] % 2 == h[v] % 2)
				flag = true;
		}
	}
}
ll get_dist(ll x1, ll y1, ll x2, ll y2) {
	return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; ll r;
	cin >> n >> r;
	vector<ll> x(n), y(n);
	unordered_map<ll, vector<pair<ll, int>>> dict;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
		dict[y[i]].push_back({ x[i], i });
	}
	for (auto el : dict) {
		sort(dict[el.first].begin(), dict[el.first].end());
	}
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		for (ll y2 = y[i] - r; y2 <= y[i] + r; ++y2) {
			if (dict.find(y2) == dict.end()) continue;
			auto it = lower_bound(dict[y2].begin(), dict[y2].end(), pair<ll, int>{ x[i], -1 });
			auto it2 = it;
			while (it2 != dict[y2].end()) {
				int j = it2->second;
				if (get_dist(x[i], y[i], x[j], y[j]) > r * r) break;
				if (i != j) g[i].push_back(j);
				//cout << "   " << i + 1 << " " << j + 1 << "\n";
				it2 = next(it2);
			}
			if (it != dict[y2].begin()) {
				it2 = prev(it);
				while (true) {
					int j = it2->second;
					if (get_dist(x[i], y[i], x[j], y[j]) > r * r) break;
					if (i != j) g[i].push_back(j);
					if (it2 == dict[y2].begin()) break;
					it2 = prev(it2);
				}
			}
		}
	}
	h.resize(n, 0);
	vis.resize(n, false);
	vector<bool> ans(n, false);
	for (int i = 0; i < n; ++i) {
		if (!vis[i]) {
			comp.clear();
			flag = false;
			dfs(i, -1);
			if (flag) {
				for (int u : comp)
					ans[u] = true;
			}
		}
	}
	for (auto el : ans) cout << (int)el;

	return 0;
}