#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;
using ll = long long;

vector<int> h, comp;
int n; ll r;
vector<ll> x, y;

vector<bool> vis;
bool flag = false;
unordered_map<ll, vector<pair<ll, int>>> dict;
vector<ll> ally;

ll get_dist(ll x1, ll y1, ll x2, ll y2) {
	return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}
void dfs(int i, int p) {
	vis[i] = true;
	comp.push_back(i);
	auto ity0 = lower_bound(ally.begin(), ally.end(), y[i]);
	auto ity = ity0;
	while (ity != ally.end() && *ity <= y[i] + r) {
		ll y2 = *ity;
		ity = next(ity);
		if (dict.find(y2) == dict.end()) continue;
		auto it = lower_bound(dict[y2].begin(), dict[y2].end(), pair<ll, int>{ x[i], -1 });
		auto it2 = it;
		while (it2 != dict[y2].end()) {
			int j = it2->second;
			if (get_dist(x[i], y[i], x[j], y[j]) > r * r) break;
			if (i != j) {
				if (!vis[j]) {
					h[j] = h[i] + 1;
					dfs(j, i);
				}
				else if (vis[j] && h[i] % 2 == h[j] % 2) {
					flag = true;
				}
			}
			it2 = next(it2);
		}
		if (it != dict[y2].begin()) {
			it2 = prev(it);
			while (true) {
				int j = it2->second;
				if (get_dist(x[i], y[i], x[j], y[j]) > r * r) break;
				if (i != j) {
					if (!vis[j]) {
						h[j] = h[i] + 1;
						dfs(j, i);
					}
					else if (vis[j] && h[i] % 2 == h[j] % 2) {
						flag = true;
					}
				}
				if (it2 == dict[y2].begin()) break;
				it2 = prev(it2);
			}
		}
	}
	if (ity0 != ally.begin()) {
		ity = prev(ity0);
		while (*ity >= y[i] - r) {
			ll y2 = *ity;
			if (dict.find(y2) == dict.end()) continue;
			auto it = lower_bound(dict[y2].begin(), dict[y2].end(), pair<ll, int>{ x[i], -1 });
			auto it2 = it;
			while (it2 != dict[y2].end()) {
				int j = it2->second;
				if (get_dist(x[i], y[i], x[j], y[j]) > r * r) break;
				if (i != j) {
					if (!vis[j]) {
						h[j] = h[i] + 1;
						dfs(j, i);
					}
					else if (vis[j] && h[i] % 2 == h[j] % 2) {
						flag = true;
					}
				}
				it2 = next(it2);
			}
			if (it != dict[y2].begin()) {
				it2 = prev(it);
				while (true) {
					int j = it2->second;
					if (get_dist(x[i], y[i], x[j], y[j]) > r * r) break;
					if (i != j) {
						if (!vis[j]) {
							h[j] = h[i] + 1;
							dfs(j, i);
						}
						else if (vis[j] && h[i] % 2 == h[j] % 2) {
							flag = true;
						}
					}
					if (it2 == dict[y2].begin()) break;
					it2 = prev(it2);
				}
			}
			if (ity == ally.begin()) break;
			ity = prev(ity);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> r;
	x.resize(n); y.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
		ally.push_back(y[i]);
		dict[y[i]].push_back({ x[i], i });
	}
	sort(ally.begin(), ally.end());
	for (auto el : dict) {
		sort(dict[el.first].begin(), dict[el.first].end());
	}
	h.resize(n, 0);
	vis.resize(n, false);
	vector<bool> ans(n, false);
	for (int i = 0; i < n; ++i) {
		if (!vis[i]) {
			comp.clear();
			flag = false;
			dfs(i, -1);
			if (flag) {
				for (int u : comp)
					ans[u] = true;
			}
		}
	}
	for (auto el : ans) cout << (int)el;

	return 0;
}