#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#pragma gcc optimize("O3")
#pragma gcc optimize("unroll-loops", "inline")
#pragma gcc target("avx2")
using namespace std;
using ll = long long;
const int sz = 1e4;

struct fenvik {
	int size;
	int f[sz + 1];

	void init(int n) {
		size = n;
		for (int i = 0; i < n; ++i) f[i] = 0;
	}
	int getp(int r) {
		int s = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1)
			s += f[i];
		return s;
	}
	void upd(int pos, int val) {
		for (int i = pos; i < size; i = (i | (i + 1))) {
			f[i] += val;

		}
	}
	int get_sum(int l, int r) {
		int s = getp(r - 1);
		if (l != 0) s -= getp(l - 1);
		return s;
	}
};

int dp[sz][sz], a[sz][sz];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int r, c;
	cin >> r >> c;
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}

	fenvik tr1, tr_all;
	tr1.init(r * c + 1);
	tr_all.init(r * c + 1);

	tr_all.upd(a[r - 1][c - 1], 1);

	for (int i = r - 1; i >= 0; --i) {
		for (int j = c - 1; j >= 0; --j) {
			int cur = 0;
			for (int k = j; k < c; ++k) {
				cur += tr1.get_sum(a[i][k] + 1, r * c + 1);
				tr1.upd(a[i][k], 1);
				tr_all.upd(a[i][k], -1);
			}
			cur += dp[i + 1][j];
			for (int k = j; k < c; ++k) {
				cur += tr_all.get_sum(1, a[i][k]);
				tr1.upd(a[i][k], -1);
			}
			for (int k = j; k < c; ++k) {
				tr_all.upd(a[i][k], 1);
			}
			dp[i][j] = cur;

			cur = 0;
			for (int k = i; k < r; ++k) {
				cur += tr1.get_sum(a[k][j] + 1, r * c + 1);
				tr1.upd(a[k][j], 1);
				tr_all.upd(a[k][j], -1);
			}
			cur += dp[i][j + 1];
			for (int k = i; k < r; ++k) {
				cur += tr_all.get_sum(1, a[k][j]);
				tr1.upd(a[k][j], -1);
			}
			for (int k = i; k < r; ++k) {
				tr_all.upd(a[k][j], 1);
			}
			dp[i][j] = min(dp[i][j], cur);

			if (j != 0) {
				for (int k = i; k < r; ++k) {
					tr_all.upd(a[k][j - 1], 1);
				}
			}
			else {
				for (int k = i; k < r; ++k) {
					for (int z = j; z < c; ++z) {
						tr_all.upd(a[k][z], -1);
					}
				}
				if (i != 0) {
					for (int k = i - 1; k < r; ++k) {
						tr_all.upd(a[k][c - 1], 1);
					}
				}
			}
		}
	}
	cout << dp[0][0];

	return 0;
}