#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

constexpr int maxn = 1e5 + 10;

int n;
bool arr[maxn];
int prior_by_pos[maxn];
bool now_enabled[maxn];
int res_by_cnt[maxn];
bool single[maxn];

void solve() {
    int q;
    cin >> n >> q;
    char c;
    int work_cnt = 0;
    for (int i = 0; i < n; ++i) cin >> c, arr[i] = (c == '1');
    for (int i = 0; i < n; ++i) if (!arr[i]) ++work_cnt;
    for (int i = 0; i < n; ++i) {
        if (arr[i] && (!i || !arr[i - 1]) && (i + 1 == n || !arr[i + 1])) {
            if (i) ++prior_by_pos[i - 1];
            if (i + 1 < n) ++prior_by_pos[i + 1];
            single[i] = true;
        }
    }
    if (work_cnt == n) {
        for (int _ = 0; _ < q; ++_) {
            int k;
            cin >> k;
            if (k < 2) cout << 0 << "\n";
            else cout << k << "\n";
        }
        return;
    }
    set<pair<int, int> > pr_v;
    for (int i = 0; i < n; ++i) if (!arr[i]) pr_v.emplace(prior_by_pos[i], i);
    int now_res = 0;
    for (int i = 0; i < n; ++i) if (arr[i] && ((i && arr[i - 1]) || (i + 1 < n && arr[i + 1]))) ++now_res;
    res_by_cnt[0] = now_res;
    for (int i = 0; i < work_cnt; ++i) {
        int pos = pr_v.rbegin()->second;
        pr_v.erase(prev(pr_v.end()));
        prior_by_pos[pos] = -1;
        if (pos >= 1 && single[pos - 1] && !now_enabled[pos - 1]) now_enabled[pos - 1] = true;
        if (pos >= 2 && single[pos - 1] && prior_by_pos[pos - 2] != -1) {
            pr_v.erase(make_pair(prior_by_pos[pos - 2], pos - 2));
            --prior_by_pos[pos - 2];
            pr_v.emplace(prior_by_pos[pos - 2], pos - 2);
        }
        if (pos + 1 < n && single[pos + 1] && !now_enabled[pos + 1]) now_enabled[pos + 1] = true;
        if (pos + 2 < n && single[pos + 1] && prior_by_pos[pos + 2] != -1) {
            pr_v.erase(make_pair(prior_by_pos[pos + 2], pos + 2));
            --prior_by_pos[pos + 2];
            pr_v.emplace(prior_by_pos[pos + 2], pos + 2);
        }
        now_res = 0;
        for (int j = 0; j < n; ++j)
            if ((arr[j] || prior_by_pos[j] == -1)
                && ((j && (arr[j - 1] || prior_by_pos[j - 1] == -1)) ||
                    (j + 1 < n && (arr[j + 1] || prior_by_pos[j + 1] == -1))))
                ++now_res;
        // if ((pos >= 1 && (arr[pos - 1] || prior_by_pos[pos - 1] == -1)) ||
        //     (pos + 1 < n && (arr[pos + 1] || prior_by_pos[pos + 1] == -1)))
        //     ++now_res;
        res_by_cnt[i + 1] = now_res;
    }
    for (int _ = 0; _ < q; ++_) {
        int k;
        cin >> k;
        cout << res_by_cnt[k] << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    solve();
    return 0;
}
