#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

constexpr int maxn = 1e5 + 10;

int n;
bool arr[maxn];
int prior_by_pos[maxn];
bool now_enabled[maxn];
int res_by_cnt[maxn];
bool single[maxn];
bool is_neight_good[maxn];

struct El {
    int p1;
    bool p2;
    int pos;

    El(int p1, bool p2, int pos): p1(p1), p2(p2), pos(pos) {
    }

    bool operator<(const El &rhs) const {
        if (p1 != rhs.p1) return p1 < rhs.p1;
        if (p2 != rhs.p2) return p2 < rhs.p2;
        return pos < rhs.pos;
    }
};

void solve() {
    int q;
    cin >> n >> q;
    char c;
    int work_cnt = 0;
    for (int i = 0; i < n; ++i) cin >> c, arr[i] = (c == '1');
    for (int i = 0; i < n; ++i) if (!arr[i]) ++work_cnt;
    for (int i = 0; i < n; ++i) {
        if (arr[i] && (!i || !arr[i - 1]) && (i + 1 == n || !arr[i + 1])) {
            if (i) ++prior_by_pos[i - 1];
            if (i + 1 < n) ++prior_by_pos[i + 1];
            single[i] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!arr[i]) continue;
        if (i && !arr[i - 1]) is_neight_good[i - 1] = true;
        if (i + 1 < n && !arr[i + 1]) is_neight_good[i + 1] = true;
    }
    if (work_cnt == n) {
        for (int _ = 0; _ < q; ++_) {
            int k;
            cin >> k;
            if (k < 2) cout << 0 << "\n";
            else cout << k << "\n";
        }
        return;
    }
    set<El> pr_v;
    for (int i = 0; i < n; ++i) if (!arr[i]) pr_v.emplace(prior_by_pos[i], is_neight_good[i], i);
    int now_res = 0;
    for (int i = 0; i < n; ++i) if (arr[i] && ((i && arr[i - 1]) || (i + 1 < n && arr[i + 1]))) ++now_res;
    res_by_cnt[0] = now_res;
    for (int i = 0; i < work_cnt; ++i) {
        int pos = pr_v.rbegin()->pos;
        pr_v.erase(prev(pr_v.end()));
        prior_by_pos[pos] = -1;
        if (pos >= 1 && single[pos - 1] && !now_enabled[pos - 1]) now_enabled[pos - 1] = true, ++now_res;
        if (pos >= 2 && single[pos - 1] && prior_by_pos[pos - 2] != -1) {
            pr_v.erase(El(prior_by_pos[pos - 2], true, pos - 2));
            --prior_by_pos[pos - 2];
            pr_v.emplace(prior_by_pos[pos - 2], true, pos - 2);
        }
        if (pos + 1 < n && single[pos + 1] && !now_enabled[pos + 1]) now_enabled[pos + 1] = true, ++now_res;
        if (pos + 2 < n && single[pos + 1] && prior_by_pos[pos + 2] != -1) {
            pr_v.erase(El(prior_by_pos[pos + 2], true, pos + 2));
            --prior_by_pos[pos + 2];
            pr_v.emplace(prior_by_pos[pos + 2], true, pos + 2);
        }
        if (pos && !arr[pos - 1] && !is_neight_good[pos - 1] && prior_by_pos[pos - 1] != -1) {
            pr_v.erase(El(prior_by_pos[pos - 1], is_neight_good[pos - 1], pos - 1));
            is_neight_good[pos - 1] = true;
            pr_v.emplace(prior_by_pos[pos - 1], is_neight_good[pos - 1], pos - 1);
        }
        if (pos + 1 < n && !arr[pos + 1] && !is_neight_good[pos + 1] && prior_by_pos[pos + 1] != -1) {
            pr_v.erase(El(prior_by_pos[pos + 1], is_neight_good[pos + 1], pos + 1));
            is_neight_good[pos + 1] = true;
            pr_v.emplace(prior_by_pos[pos + 1], is_neight_good[pos + 1], pos + 1);
        }
        if ((pos >= 1 && (arr[pos - 1] || prior_by_pos[pos - 1] == -1)) ||
            (pos + 1 < n && (arr[pos + 1] || prior_by_pos[pos + 1] == -1)))
            ++now_res;
        res_by_cnt[i + 1] = now_res;
    }
    for (int _ = 0; _ < q; ++_) {
        int k;
        cin >> k;
        cout << res_by_cnt[k] << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    solve();
    return 0;
}
