#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;
using ll = long long;

int n, m;

vector<vector<int> > matrix;
vector<vector<ll> > dp;

void solve() {
    cin >> n >> m;
    matrix.resize(n, vector<int>(m));
    dp.resize(n, vector<ll>(m, 1e18));
    for (auto &row: matrix) for (auto &val: row) cin >> val;
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (i == n - 1 && j == m - 1) continue;
            ll cnt = 0;
            for (int j1 = j; j1 < m; ++j1)
                for (int j2 = j1 + 1; j2 < m; ++j2) if (matrix[i][j1] > matrix[i][j2]) ++cnt;
            for (int k = j; k < m; ++k)
                for (int i1 = i + 1; i1 < n; ++i1)
                    for (int j1 = j; j1 < m; ++j1)
                        if (matrix[i][k] > matrix[i1][j1]) ++cnt;
            if (i != n - 1) dp[i][j] = std::min(dp[i][j], dp[i + 1][j] + cnt);
            cnt = 0;
            for (int i1 = i; i1 < n; ++i1)
                for (int i2 = i1 + 1; i2 < n; ++i2) if (matrix[i1][j] > matrix[i2][j]) ++cnt;
            for (int k = i; k < n; ++k)
                for (int i1 = i; i1 < n; ++i1)
                    for (int j1 = j + 1; j1 < m; ++j1)
                        if (matrix[k][j] > matrix[i1][j1]) ++cnt;
            if (j != m - 1) dp[i][j] = std::min(dp[i][j], dp[i][j + 1] + cnt);
        }
    }
    cout << dp[0][0] << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    solve();
    return 0;
}
