#include <iostream>
#include <algorithm>
#include <functional>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

int n, m;

vector<vector<int> > matrix;
vector<vector<ll> > dp;
vector<vector<ll> > inv_cnt_row;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    cin >> n >> m;
    matrix.resize(n, vector<int>(m));
    inv_cnt_row.resize(n, vector<ll>(m, 0));
    dp.resize(n, vector<ll>(m, 1e18));
    for (auto &row: matrix) for (auto &val: row) cin >> val;
    for (int i = 0; i < n; ++i) {
        ordered_set<int> cvs;
        cvs.insert(matrix[i][m - 1]);
        inv_cnt_row[i][m - 1] = 0;
        for (int j = m - 2; j >= 0; --j) {
            inv_cnt_row[i][j] = inv_cnt_row[i][j + 1] + cvs.order_of_key(matrix[i][j]);
            cvs.insert(matrix[i][j]);
        }
    }
    ordered_set<int> top_nums, bottom_nums, jhs;
    ll top_bottom_inv_cnt = 0;
    dp[n - 1][m - 1] = 0;
    for (int j = m - 1; j >= 0; --j) {
        for (int i = n - 1; i >= 0; --i) {
            if (i == 0) {
                top_nums.insert(matrix[i][j]);
                top_bottom_inv_cnt += bottom_nums.order_of_key(matrix[i][j]);
            } else {
                bottom_nums.insert(matrix[i][j]);
                top_bottom_inv_cnt += top_nums.size() - top_nums.order_of_key(matrix[i][j]);
            }
            if (i == n - 1 && j == m - 1) continue;
            ll cnt = inv_cnt_row[i][j] + top_bottom_inv_cnt;
            // for (int k = j; k < m; ++k)
            // for (int i1 = i + 1; i1 < n; ++i1)
            // for (int j1 = j; j1 < m; ++j1)
            // if (matrix[i][k] > matrix[i1][j1]) ++cnt;
            if (i != n - 1) dp[i][j] = std::min(dp[i][j], dp[i + 1][j] + cnt);
            cnt = 0;
            for (int i1 = i; i1 < n; ++i1)
                for (int i2 = i1 + 1; i2 < n; ++i2) if (matrix[i1][j] > matrix[i2][j]) ++cnt;
            if (i == 0) {
                for (int k = i; k < n; ++k)
                    cnt += jhs.order_of_key(matrix[k][j]);
            } else cnt += bottom_nums.order_of_key(matrix[i][j]);
            // for (int i1 = i; i1 < n; ++i1)
            // for (int j1 = j + 1; j1 < m; ++j1)
            // if (matrix[k][j] > matrix[i1][j1]) ++cnt;
            if (j != m - 1) dp[i][j] = std::min(dp[i][j], dp[i][j + 1] + cnt);
        }
        jhs.insert(matrix[0][j]);
        jhs.insert(matrix[1][j]);
    }
    cout << dp[0][0] << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    solve();
    return 0;
}
