#include <iostream>
#include <algorithm>
#include <functional>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

int n, m;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

vector<vector<int> > matrix;
vector<vector<ll> > dp;

void solve() {
    cin >> n >> m;
    matrix.resize(n, vector<int>(m));
    dp.resize(n, vector<ll>(m, 1e18));
    for (auto &row: matrix) for (auto &val: row) cin >> val;
    ll ans = 0;
    ordered_set<int> vals;
    for (int i = 0; i < 1; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            ans += vals.order_of_key(matrix[i][j]);
            vals.insert(matrix[i][j]);
        }
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    solve();
    return 0;
}
