#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;
using ll = long long;

constexpr int maxn = 3e5, maxlogn = 21;

int n, q;
int arr[maxn];
int near_bg[maxn];

namespace ST {
    pair<int, int> tree[maxlogn][maxn];

    void init() {
        for (int i = 0; i < n; ++i) tree[0][i] = {arr[i], i};
        for (int k = 1; (1 << k) <= n; ++k)
            for (int i = 0; i + (1 << k) <= n; ++i)
                tree[k][i] = std::min(tree[k - 1][i], tree[k - 1][i + (1 << (k - 1))]);
    }

    pair<int, int> get_min(int a, int b) {
        int k = __lg(b - a);
        return std::min(tree[k][a], tree[k][b - (1 << k)]);
    }
}

void solve() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) cin >> arr[i];
    vector<int> sfm(n + 1);
    sfm[n] = 0;
    for (int i = n - 1; i >= 0; --i) sfm[i] = std::max(arr[i], sfm[i + 1]);
    ST::init();
    vector<pair<int, int> > st;
    st.emplace_back(n + 1, n);
    for (int i = n - 1; i >= 0; --i) {
        while (st.back().first < arr[i]) st.pop_back();
        near_bg[i] = st.back().second;
        st.emplace_back(arr[i], i);
    }
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        int cp = 0;
        for (int j = 0; j + 1 < i; ++j) {
            if (near_bg[cp] == cp + 1) ++cp;
            else {
                int pss = ST::get_min(cp, std::min(near_bg[cp], n - std::max(k - j - 2, 0))).second;
                cp = pss;
            }
        }
        if (k == i) cout << sfm[cp] << "\n";
        else cout << arr[cp] << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
#ifdef TEST
    freopen("input.txt", "r",stdin);
#endif
    solve();
    return 0;
}
