#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;

int reps = 1;

struct FenwickTree {
        int maxn;
        vi ft;

        FenwickTree() {}
        FenwickTree(int n) : maxn(n) {
                ft.resize(maxn);
        }

        void update(int i, int x) {
                for (; i < maxn; i |= (i + 1)) ft[i] += x;
        }

        int get(int ql, int qr) {
                return get(qr - 1) - get(ql - 1);
        }

        int get(int r) {
                int res = 0;
                for (; r >= 0; r = (r & (r + 1)) - 1) res += ft[r];
                return res;
        }
};

void solve() {
        int r, c; cin >> r >> c;
        ve<vi> a(r, vi(c));
        for (int i = 0; i < r; i++ ){
                for (int j =0 ; j < c; j++) cin >> a[i][j];
        }
        // FenwickTree fenw(r * c + 1);
        // for (int i = 0; i < r; i++) {
        //         for (int j = 0; j < c; j++) {
        //                 fenw.update(a[i][j], 1);
        //         }
        // }
        // FenwickTree fenwSuff(r * c + 1);
        // FenwickTree fenwPref(r * c + 1);
        FenwickTree fenw(r * c  + 1);
        // for (int i = 0 ;i  < r;i++) {
        //         for (int j = 0; j < c; j++) {
        //                 fenw.update(a[i][j], 1);
        //         }
        // }
        ve<ve<long long>> dp(r + 1, ve<long long>(c + 1));
        for (int i = r - 1; i >= 0; i--) {
                for (int j = c - 1; j >= 0; j--) {
                        for (int k = i; k < r; k++) {
                                // fenwPref.update(a[k][j], -1);
                                fenw.update(a[k][j], 1);
                        }
                        long long op1 = 0;
                        for (int k = j; k < c; k++) {
                                op1 += fenw.get(0, a[i][k]);
                                fenw.update(a[i][k], -1);
                        }
                        for (int k = j; k < c; k++) {
                                fenw.update(a[i][k], 1);
                        }
                        long long op2 = 0;
                        for (int k = i; k < r; k++) {
                                op2 += fenw.get(0, a[k][j]);
                                fenw.update(a[k][j], -1);
                        }
                        for (int k = i; k < r; k++) {
                                fenw.update(a[k][j], 1);
                        }
                        // cout << i << ' ' << j << ' ' << "(" << op1 << ' ' << op2 << ")\n";
                        dp[i][j] = min(op1 + dp[i + 1][j], op2 + dp[i][j + 1]);
                }
                for (int j = 0; j < c; j++) {
                        for (int k = i; k < r; k++) {
                                fenw.update(a[k][j], -1);
                        }
                }
        }
        // for (int i = 0; i < r; i++) {
        //         for (int j = 0; j < c; j++) {
        //                 cout << dp[i][j] << ' ';
        //         }
        //         cout << '\n';
        // }
        cout << dp[0][0] << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test ========\n\n";
                #endif
        }

        return 0;
}