#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;

int reps = 1;

struct FenwickTree {
        int maxn;
        vi ft;

        FenwickTree() {}
        FenwickTree(int n) : maxn(n) {
                ft.resize(maxn);
        }

        void update(int i, int x) {
                for (; i < maxn; i |= (i + 1)) ft[i] += x;
        }

        int get(int ql, int qr) {
                return get(qr - 1) - get(ql - 1);
        }

        int get(int r) {
                int res = 0;
                for (; r >= 0; r = (r & (r + 1)) - 1) res += ft[r];
                return res;
        }
};

void solve() {
        int r, c; cin >> r >> c;
        ve<vi> a(r, vi(c));
        for (int i = 0; i < r; i++ ){
                for (int j =0 ; j < c; j++) cin >> a[i][j];
        }
        // FenwickTree fenw(r * c + 1);
        // for (int i = 0; i < r; i++) {
        //         for (int j = 0; j < c; j++) {
        //                 fenw.update(a[i][j], 1);
        //         }
        // }
        int x = 0, y = 0;
        vi b;
        while (x != r && y != c) {
                int mx1 = 0;
                for (int i = x; i < r; i++) {
                        mx1 = max(mx1, a[i][y]);
                }
                int mx2 =0 ;
                for (int i = y; i < c; i++) {
                        mx2 = max(mx2, a[x][i]);
                }
                if (mx1 < mx2) {
                        for (int i = x; i < r; i++) b.push_back(a[i][y]);
                        y++;           
                } else {
                        for (int i = y; i < c; i++) b.push_back(a[x][i]);
                        x++;
                }
        }
        FenwickTree fenw(r * c + 1);
        for (auto el : b) fenw.update(el, 1);
        long long ans = 0;
        for (auto el : b) {
                ans += fenw.get(0, el);
                fenw.update(el, -1);
        }
        cout << ans << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test ========\n\n";
                #endif
        }

        return 0;
}