#include <bits/stdc++.h>
 
#define int long long
#define all(x) x.begin(), x.end()
 
using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFL = 1e18 + 1;
 
int reps = 1;
 
struct FenwickTree {
        int maxn;
        vi ft;
 
        FenwickTree() {}
        FenwickTree(int n) : maxn(n) {
                ft.resize(maxn);
        }
 
        void update(int i, int x) {
                for (; i < maxn; i |= (i + 1)) ft[i] += x;
        }
 
        int get(int ql, int qr) {
                return get(qr - 1) - get(ql - 1);
        }
 
        int get(int r) {
                int res = 0;
                for (; r >= 0; r = (r & (r + 1)) - 1) res += ft[r];
                return res;
        }
};
 
void solve() {
        int r, c; cin >> r >> c;
        ve<vi> a(r, vi(c));
        for (int i = 0; i < r; i++ ){
                for (int j =0 ; j < c; j++) cin >> a[i][j];
        }
        int ans = 0;
        FenwickTree fenw(r * c + 1);
        for (int i = 0; i < r; i++) {
                for (int j = 0; j < c; j++) {
                        fenw.update(a[i][j], 1);
                }
        }
        int x = 0, y = 0;
        while (x != r && y != c) {
                // cout << x << ' ' << y << '\n';
                long long op1 = 0;
                long long op2 = 0;
                for (int i = x; i < r; i++) {
                        // op1 += fenw.get(a[i][y] + 1, r * c + 1);
                        fenw.update(a[i][y], -1);
                }
                for (int i = x; i < r; i++) {
                        op1 += fenw.get(0, a[i][y]);
                        // fenw.update(a[i][y], -1);
                }
                for (int i = x; i < r; i++) {
                        // op1 += fenw.get(a[i][y] + 1, r * c + 1);
                        fenw.update(a[i][y], 1);
                }
                for (int j = y; j < c; j++) {
                        // op2 += fenw.get(a[x][j] + 1, r * c + 1);
                        fenw.update(a[x][j], -1);
                }
                for (int j = y; j < c; j++) {
                        op2 += fenw.get(0, a[x][j]);
                        // fenw.update(a[x][j], -1);
                }
                // cout << op1 << ' ' << op2 << '\n';
                if (op2 > op1) {
                        for (int j = y; j < c; j++) {
                                // op2 += fenw.get(a[x][j] + 1, r * c + 1);
                                fenw.update(a[x][j], 1);
                        }
                        for (int i = x; i < r; i++) {
                                ans += fenw.get(0, a[i][y]);
                                fenw.update(a[i][y], -1);
                        }
                        y++;
                } else {
                        for (int j = y; j < c; j++) {
                                fenw.update(a[x][j], 1);
                        }
                        for (int j = y; j < c; j++) {
                                ans += fenw.get(0, a[x][j]);
                                fenw.update(a[x][j], -1);
                        }
                        x++;                       
                }
        }
        cout << ans << '\n';
}
 
signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);
 
        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif
 
        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test ========\n\n";
                #endif
        }
 
        return 0;
}