#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()

using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
template<typename T> 
using ve = vector<T>;
const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;

int reps = 1;

struct FenwickTree {
        int maxn;
        vi ft;
 
        FenwickTree() {}
        FenwickTree(int n) : maxn(n) {
                ft.resize(maxn);
        }
 
        void update(int i, int x) {
                for (; i < maxn; i |= (i + 1)) ft[i] += x;
        }
 
        int get(int ql, int qr) {
                return get(qr - 1) - get(ql - 1);
        }
 
        int get(int r) {
                int res = 0;
                for (; r >= 0; r = (r & (r + 1)) - 1) res += ft[r];
                return res;
        }
};

void solve() {
        int r, c; cin >> r >> c;
        ve<vi> a(r, vi(c));
        for (int i = 0; i < r; i++ ){
                for (int j =0 ; j < c; j++) cin >> a[i][j];
        }
        long long ans = INFLL;
        for (int mask = 0; mask < (1 << (r + c)); mask++) {
                FenwickTree fenw(r * c + 1);
                for (int i = 0; i < r; i++) {
                        for (int j = 0; j < c; j++) {
                                fenw.update(a[i][j], 1);
                        }
                }
                int x = 0, y = 0;
                long long curans = 0;
                for (int i = 0; i < r + c; i++) {
                        if (x == r || y == c) break;
                        if (mask & (1 << i)) {
                                for (int j = x; j < r; j++) {
                                        curans += fenw.get(0, a[j][y]);
                                        fenw.update(a[j][y], -1);
                                }
                                y++;
                        } else {
                                for (int j = y; j < c; j++) {
                                        curans += fenw.get(0, a[x][j]);
                                        fenw.update(a[x][j], -1);
                                }
                                x++;
                        }
                }
                ans = min(ans, curans);
        }
        cout << ans << '\n';
}

signed main() {
        ios::sync_with_stdio(0);
        cin.tie(0);

        #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        cin >> reps;
        #endif

        for (int i = 1; i <= reps; i++) {
                #ifdef LOCAL
                cout << "======= Test #" << i << " ========\n";
                #endif
                solve();
                #ifdef LOCAL
                cout << "======= End Test =======\n\n";
                #endif
        }

        return 0;
}