#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


vector<bool> calc_graph(vector<vector<ll>> graph) {
    ll n = (ll)graph.size();
    vector<ll> used(n);
    vector<bool> bad(n);
    vector<bool> ans(n);
    auto dfs = [&](auto &dfs, ll v, ll col) -> void {
        used[v] = col;
        for (ll u : graph[v]) {
            if (!used[u]) {
                dfs(dfs, u, 3 - col);
            } else if (used[u] == col) {
                bad[v] = true;
            }
        }
    };
    used.assign(n, 0);
    auto dfs2 = [&](auto &dfs2, ll v) -> void {
        bad[v] = true;
        for (ll u : graph[v]) {
            if (!bad[u]) {
                dfs2(dfs2, u);
            }
        }
    };
    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(dfs, i, 1);
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (bad[i]) {
            dfs2(dfs2, i);
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (bad[i]) {
            ans[i] = true;
        }
    }
    return ans;
}


ull toll(ll x, ll y) {
    return x << 32 | y;
}


mt19937 gen(52);


void solve() {
    ll n, r;
    cin >> n >> r;
    vector<ll> x(n), y(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    auto kvadrat = [&](ll x) -> ll {
        return x * x;
    };
    auto check = [&](ll i, ll j) -> bool {
        ll d = kvadrat(x[i] - x[j]) + kvadrat(y[i] - y[j]);
        return d <= r * r;
    };
    unordered_map<ull, vector<ll>> mp;
    ll side = r / 2;
    for (ll i = 0; i < n; ++i) {
        mp[toll(x[i] / side, y[i] / side)].pb(i);
    }
    for (auto &p : mp) {
        shuffle(all(p.second), gen);
    }
    vector<bool> ans(n);
    vector<bool> alive(n, true);
    auto can_go = [&](ll a, ll b) -> bool {
        if (mp[b].size() >= 3) {
            return true;
        }
        for (ll i : mp[a]) {
            for (ll j : mp[b]) {
                if (check(i, j)) {
                    return true;
                }
            }
        }
        return false;
    };
    auto give_dir = [&](ull a) -> vector<ull> {
        ll x0 = a >> 32, y0 = a % (1ll << 32);
        vector<ull> res;
        for (ll i = -2; i <= 2; ++i) {
            for (ll j = -2; j <= 2; ++j) {
                if (i != 0 && j != 0) {
                    res.pb(toll((x0 + i * side) / side, (y0 + j * side) / side));
                }
            }
        }
        return res;
    };
    auto give_dir2 = [&](ull a) -> vector<ull> {
        ll x0 = a >> 32, y0 = a % (1ll << 32);
        vector<ull> res;
        for (ll i = -2; i <= 2; ++i) {
            for (ll j = -2; j <= 2; ++j) {
                if (i != 0 && j != 0) {
                    res.pb(toll((x0 + i * side) / side, (y0 + j * side) / side));
                }
            }
        }
        return res;
    };
    unordered_map<ull, bool> used;
    auto dfs1 = [&](auto &dfs1, ull v) -> void {
        for (ll i : mp[v]) {
            ans[i] = true;
            alive[i] = false;
        }
        used[v] = true;
        for (ll u : give_dir(v)) {
            if (!used[u] && can_go(v, u)) {
                dfs1(dfs1, u);
            }
        }
        mp[v].clear();
    };
    vector<ull> starts;
    for (auto &p : mp) {
        if ((ll)p.second.size() >= 3) {
            starts.pb(p.first);
        }
    }
    for (ull v : starts) {
        if (!used[v]) {
            dfs1(dfs1, v);
        }
    }
    vector<vector<ll>> graph(n);
    for (ll i = 0; i < n; ++i) {
        if (alive[i]) {
            vector<ull> dir = give_dir2(toll(x[i] / side, y[i] / side));
            for (ull v : dir) {
                for (ll j : mp[v]) {
                    if (check(i, j) && i != j) {
                        graph[i].pb(j);
                    }
                }
            }
        }
    }
    vector<bool> ans2 = calc_graph(graph);
    for (ll i = 0; i < n; ++i) {
        ans[i] = ans[i] || ans2[i];
    }
    for (ll i = 0; i < n; ++i) {
        cout << (ans[i] ? '1' : '0');
    }
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}