#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


string calc(vector<vector<ll>> graph) {
    ll n = (ll)graph.size();
    vector<ll> used(n);
    vector<bool> bad(n);
    string ans(n, '0');
    auto dfs = [&](auto &dfs, ll v, ll col) -> void {
        used[v] = col;
        for (ll u : graph[v]) {
            if (!used[u]) {
                dfs(dfs, u, 3 - col);
            } else if (used[u] == col) {
                bad[v] = true;
            }
        }
    };
    used.assign(n, 0);
    auto dfs2 = [&](auto &dfs2, ll v) -> void {
        bad[v] = true;
        for (ll u : graph[v]) {
            if (!bad[u]) {
                dfs2(dfs2, u);
            }
        }
    };
    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(dfs, i, 1);
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (bad[i]) {
            dfs2(dfs2, i);
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (bad[i]) {
            ans[i] = '1';
        }
    }
    return ans;
}


void solve1(vector<ll> x, vector<ll> y, ll r) {
    ll n = (ll)x.size();
    map<pair<ll, ll>, ll> mp;
    for (ll i = 0; i < n; ++i) {
        mp[{x[i], y[i]}] = i;
    }
    auto kvadrat = [&](ll x) -> ll {
        return x * x;
    };
    auto check = [&](ll i, ll j) -> bool {
        ll d = kvadrat(x[i] - x[j]) + kvadrat(y[i] - y[j]);
        return d <= r * r;
    };
    vector<vector<ll>> graph(n);
    ll K = r;
    for (ll i = 0; i < n; ++i) {
        for (ll x0 = x[i] - K; x0 <= x[i] + K; ++x0) {
            for (ll y0 = y[i] - K; y0 <= y[i] + K; ++y0) {
                if (mp.count({x0, y0})) {
                    ll j = mp[{x0, y0}];
                    if (j != i && check(i, j)) {
                        graph[i].pb(j);
                    }
                }
            }
        }
    }
    string ans = calc(graph);
    cout << ans;
}


void solve() {
    ll n, r;
    cin >> n >> r;
    vector<ll> x(n), y(n);
    for (ll i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    if (r <= 3) {
        solve1(x, y, r);
        return;
    }
    auto kvadrat = [&](ll x) -> ll {
        return x * x;
    };
    auto check = [&](ll i, ll j) -> bool {
        ll d = kvadrat(x[i] - x[j]) + kvadrat(y[i] - y[j]);
        return d <= r * r;
    };
    ll side = r / 2;
    map<pair<ll, ll>, vector<ll>> mp;
    for (ll i = 0; i < n; ++i) {
        mp[{x[i] / side, y[i] / side}].pb(i);
    }
    auto get_near = [&](ll x0, ll y0) -> vector<ll> {
        vector<ll> ans;
        for (ll i = -2; i <= 2; ++i) {
            for (ll j = -2; j <= 2; ++j) {
                ll x1 = x0 + i * side, y1 = y0 + j * side;
                if (mp.count({x1 / side, y1 / side})) {
                    ans.insert(ans.end(), all(mp[make_pair(x1 / side, y1 / side)]));
                }
            }
        }
        return ans;
    };
    vector<vector<ll>> graph(n);
    for (ll i = 0; i < n; ++i) {
        vector<ll> can = get_near(x[i], y[i]);
        for (ll j : can) {
            if (check(i, j) && i != j) {
                graph[i].pb(j);
            }
        }
    }
    string ans = calc(graph);
    cout << ans;
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}