#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


struct Fenwick {
    ll n;
    vector<ll> t;

    Fenwick(ll n) : n(n) {
        t.resize(n + 1);
    }

    void add(ll i, ll x) {
        ++i;
        while (i <= n) {
            t[i] += x;
            i += i & -i;
        }
    }

    ll sum(ll r) {
        ll ans = 0;
        while (r > 0) {
            ans += t[r];
        }
        r ^= r & -r;
    }

    ll sum(ll l, ll r) {
        // [l, r);
        return sum(r) - sum(l);
    }
};


vector<ll> calc_suf_inv(vector<ll> a) {
    ll n = (ll)a.size();
    vector<pair<ll, ll>> b;
    for (ll i = 0; i < n; ++i) {
        b.eb(a[i], i);
    }
    sort(all(b), [](pair<ll, ll> p, pair<ll, ll> q) {
        return p.first < q.first || (p.first == q.first && p.second < q.second);
    });
    vector<ll> x = a;
    sort(all(x));
    for (ll &i : a) {
        i = lower_bound(all(x), i) - x.begin();
    }
    Fenwick t(n);
    vector<ll> dp(n);
    for (pair<ll, ll> p : b) {
        ll i = p.second;
        dp[i] = 1 + t.sum(i + 1, n);
        t.add(i, dp[i]);
    }
    return dp;
}


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vector<ll> invs = calc_suf_inv(a[0]);
    invs.pb(0);
    ll ans = invs[0];
    Fenwick f1(m), f2(m);
    for (ll i = 0; i < m; ++i) {
        f2.add(i, 1);
    }
    ll cur = 0;
    ll pref_invs = 0;
    for (ll i = 0; i < n; ++i) {
        pref_invs += f1.sum(a[0][i], m);
        cur -= f1.sum(a[0][i], m);
        f1.add(a[0][i], 1);
        f2.add(a[0][i], -1);
        cur += f2.sum(0, a[0][i]);
        ans = min(ans, pref_invs + invs[i + 1] + cur);
    }
    cout << ans;
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}