#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


struct Fenwick {
    ll n;
    vector<ll> t;

    Fenwick(ll n = 0) : n(n) {
        t.resize(n + 1);
    }

    void add(ll i, ll x) {
        ++i;
        while (i <= n) {
            t[i] += x;
            i += i & -i;
        }
    }

    ll sum(ll r) {
        ll ans = 0;
        while (r > 0) {
            ans += t[r];
            r ^= r & -r;
        }
        return ans;
    }

    ll sum(ll l, ll r) {
        // [l, r);
        return sum(r) - sum(l);
    }
};


struct ST {
    vector<ll> a;   
    Fenwick f;

    ST(vector<ll> _a = {}) : a(_a) {
        sort(all(a));
        f = Fenwick((ll)a.size());
    }

    void insert(ll x) {
        f.add(lower_bound(all(a), x) - a.begin(), 1);
    }

    ll cnt_less(ll x) {
        return f.sum(lower_bound(all(a), x) - a.begin());
    }

    ll cnt_greater(ll x) {
        return f.sum(lower_bound(all(a), x) - a.begin() + 1, (ll)a.size());
    }
};


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<ST> cnts(n);
    for (ll i = 0; i < n; ++i) {
        cnts[i] = ST(a[i]);
    }
    auto cnt_less = [&](ll l1, ll r1, ll l2, ll r2, ll x) -> ll {
        ll ans = 0;
        for (ll i = l1; i < r1; ++i) {
            ans += cnts[i].cnt_less(x);
        }
        return ans;
    };
    auto cnt_inv = [&](ll l1, ll r1, ll l2, ll r2) -> ll {
        ll ans = 0;
        vector<pair<ll, ll>> b;
        vector<ll> aa;
        for (ll i = l1; i < r1; ++i) {
            for (ll j = l2; j < r2; ++j) {
                aa.pb(a[i][j]);
            }
        }
        for (ll i = 0; i < (ll)aa.size(); ++i) {
            b.eb(aa[i], i);
        }
        sort(all(b), [](pair<ll, ll> p1, pair<ll, ll> p2) {
            return p1.first > p2.first || (p1.first == p2.first && p1.second > p2.second);
        });
        Fenwick t((ll)aa.size());
        for (pair<ll, ll>p :b) {
            ll i = p.second;
            ll val = t.sum(i);
            ans += val;
            t.add(i, 1);
        }
        return ans;
    };
    vector<vector<ll>> dp(n, vector<ll>(m));
    for (ll j = m - 1; j >= 0; --j) {
        for (ll i = n - 1; i >= 0; --i) {
            cnts[i].insert(a[i][j]);
            if (i == n - 1) {
                dp[i][j] = cnt_inv(i, i + 1, j, m);
            } else if (j == m - 1) {
                dp[i][j] = cnt_inv(i, n, j, j + 1);
            } else {
                ll val = cnt_inv(i, i + 1, j, m);
                for (ll k = j; k < m; ++k) {
                    val += cnt_less(i + 1, n, j, m, a[i][k]);
                }
                val += dp[i + 1][j];
                dp[i][j] = val;
                val = cnt_inv(i, n, j, j + 1);
                for (ll k = i; k < n; ++k) {
                    val += cnt_less(i, n, j + 1, m, a[k][j]);
                }
                val += dp[i][j + 1];
                dp[i][j] = min(dp[i][j], val);
            }
        }
    }
    ll ans = dp[0][0];
    cout << ans;
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}