#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define eb emplace_back
#define all(vec) vec.begin(), vec.end()
#define deb(x) cout << #x << " = " << x << '\n';
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll MOD = 1e9 + 7;
const ll P = 73;
const ll INF = (ll)2e18 + 11;
const ll inf = 1e9 + 11;


struct SegTree {
    ll n;
    vector<ll> tree;

    SegTree(ll n) : n(n) {
        tree.resize(4 * n, INF);
    }

    void change(ll i, ll x, ll tl, ll tr, ll v) {
        if (tr - tl == 1) {
            tree[v] = x;
            return;
        }
        ll tm = (tr + tl) >> 1;
        if (i < tm) {
            change(i, x, tl, tm, v * 2 + 1);
        } else {
            change(i, x, tm, tr, v * 2 + 2);
        }
        tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    void change(ll i, ll x) {
        change(i, x, 0, n, 0);
    }

    ll get(ll l, ll r, ll tl, ll tr, ll v) {
        if (l >= tr || tl >= r) {
            return -1;
        }
        if (tr - tl == 1) {
            return tl;
        }
        ll tm = (tr + tl) >> 1;
        if (tree[v * 2 + 1] < tree[v * 2 + 2]) {
            ll m1 = get(l, r, tl, tm, v * 2 + 1);
            if (m1 == -1) {
                return get(l, r, tm, tr, v * 2 + 2);
            } else {
                return m1;
            }
        } else {
            ll m2 = get(l, r, tm, tr, v * 2 + 2);
            if (m2 == -1) {
                return get(l, r, tl, tm, v * 2 + 1);
            } else {
                return m2;
            }
        }
    }

    ll get(ll l, ll r) {
        return get(l, r, 0, n, 0);
    }
};


struct StupidST {
    ll n;
    vector<ll> a;

    StupidST(ll n) : n(n) {
        a.resize(n, INF);
    }

    void change(ll i, ll x) {
        a[i] = x;
    }

    ll get(ll l, ll r) {
        ll good = l;
        for (ll i = l; i < r; ++i) {
            if (a[i] < a[good]) {
                good = i;
            }
        }
        return good;
    }
};


vector<ll> calc_r_greater(vector<ll> a) {
    ll n = (ll)a.size();
    vector<ll> stk;
    vector<ll> r(n, n);
    for (ll i = n - 1; i >= 0; --i) {
        while (!stk.empty() && a[stk.back()] <= a[i]) {
            stk.pop_back();
        }
        if (!stk.empty()) {
            r[i] = stk.back();
        }
        stk.pb(i);
    }
    return r;
}


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> R = calc_r_greater(a);
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, INF));
    vector<StupidST> sg(n + 1, StupidST(n + 1));
    ll mx = -INF;
    for (ll i = n; i >= 1; --i) {
        mx = max(mx, a[i - 1]);
        dp[i][1] = mx;
        sg[1].change(i, mx);
    }
    vector<vector<ll>> to(n + 1, vector<ll>(n + 1, -1));
    for (ll i = n; i > 0; --i) {
        for (ll j = 2; j + i <= n + 1; ++j) {
            mx = a[i - 1];
            dp[i][j] = mx;
            sg[j].change(i, mx);
            ll best = sg[j - 1].get(i + 1, min(n + 1, R[i - 1] + 2));
            if (best == -1) {
                best = sg[j - 1].get(i + 1, min(n + 1, R[i - 1] + 2));
            }
            /*for (ll k = i + 1; k <= n; ++k) {
                if (mx > a[i - 1]) {
                    break;
                }
                if (dp[best][j - 1] > dp[k][j - 1]) {
                    best = k;
                }
                mx = max(mx, a[k - 1]);
            }*/
            to[i][j] = best;
         }
    }
    vector<vector<ll>> res(n + 1);
    for (ll i = 1; i <= n; ++i) {
        vector<ll> b;
        ll cur_i = 1, cur_j = i;
        while (cur_j > 0) {
            b.pb(dp[cur_i][cur_j]);
            cur_i = to[cur_i][cur_j];
            --cur_j;
        }
        res[i] = b;
    }
    while (q--) {
        ll k, i;
        cin >> k >> i;
        --i;
        cout << res[k][i] << '\n';
    }
}


int main() {
#ifdef LOCAL:
    freopen("C:/work/CLionProjects/untitled/input.txt", "r", stdin);
    freopen("C:/work/CLionProjects/untitled/output.txt", "w", stdout);
#endif
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}