#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

ll dist2(pdd a, pdd b) {
    pair<ll, ll> aa = a, bb = b;
    ll dx = abs(aa.first - bb.first);
    ll dy = abs(aa.second - bb.second);
    return dx * dx + dy * dy;
}

vector<vector<dgt>> g;
vector<signed char> color;
string ans;

bool dfs(dgt v, signed char c) {
    color[v] = c;
    for (dgt u: g[v]) {
        if (color[u] == color[v])
            return false;
        if (color[u] == -color[v])
            continue;
        if (!dfs(u, -c))
            return false;
    }
    return true;
}

void dfs2(dgt v) {
    ans[v] = '1';
    for (dgt u: g[v]) {
        if (ans[u] == '1')
            continue;
        dfs2(u);
    }
}

void solve() {
    dgt n;
    ll r;
    cin >> n >> r;
    ll r2 = r * r;
    vector<pdd> p(n);
    for (dgt i = 0; i < n; ++i)
        cin >> p[i].first >> p[i].second;
    g.assign(n, {});
    for (dgt i = 0; i < n; ++i) {
        for (dgt j = i + 1; j < n; ++j) {
            if (dist2(p[i], p[j]) <= r2) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    color.assign(n, 0);
    ans.assign(n, '0');
    for (dgt i = 0; i < n; ++i)
        if (color[i] == 0 && (!dfs(i, 1)))
            dfs2(i);
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " ===================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test =======================\n";
#endif
    }

    return 0;
}

// g++ -std=c++20 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
