// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

struct Fenwick {
    vector<dgt> t;

    Fenwick(dgt n) {
        build(n);
    }

    void build(dgt n) {
        t.assign(n + 1, 0);
    }

    dgt sum(dgt r) {
        dgt res = 0;
        for (; r > 0; r -= (r & -r))
            res += t[r];
        return res;
    }

    dgt sum(dgt l, dgt r) {
        return sum(r) - sum(l - 1);
    }

    void add(dgt pos, dgt x) {
        for (; pos < t.size(); pos += (pos & -pos))
            t[pos] += x;
    }
};

void solve() {
    dgt r, c;
    cin >> r >> c;
    vector<vector<dgt>> a(r, vector<dgt>(c));
    for (dgt i = 0; i < r; ++i)
        for (dgt j = 0; j < c; ++j)
            cin >> a[i][j];
    dgt n = r + c;
    dgt ans = INF;
    for (dgt mask = 0; mask < (1 << n); ++mask) {
        vector<dgt> arr;
        dgt i = 0, j = 0;
        for (dgt k = 0; k < n; ++k) {
            if (i == r || j == c)
                break;
            if (((mask >> k) & 1)) {
                for (dgt ind = j; ind < c; ++ind)
                    arr.push_back(a[i][ind]);
                ++i;
            } else {
                for (dgt ind = i; ind < r; ++ind)
                    arr.push_back(a[ind][j]);
                ++j;
            }
        }
        dgt cnt = 0;
        Fenwick fw(r * c);
        for (dgt ii = r * c - 1; ii >= 0; --ii) {
            cnt += fw.sum(arr[ii]);
            fw.add(arr[ii], 1);
        }
        ans = min(ans, cnt);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " ===================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test =======================\n";
#endif
    }

    return 0;
}

// g++ -std=c++20 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
