#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

#pragma GCC target("avx2,sse4.2,bmi,bmi2,popcnt,lzcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef ll dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

struct Fenwick {
    vector<dgt> t;

    Fenwick(dgt n) {
        build(n);
    }

    void build(dgt n) {
        t.assign(n + 1, 0);
    }

    dgt sum(dgt r) {
        dgt res = 0;
        for (; r > 0; r -= (r & -r))
            res += t[r];
        return res;
    }

    dgt sum(dgt l, dgt r) {
        return sum(r) - sum(l - 1);
    }

    void add(dgt pos, dgt x) {
        for (; pos < t.size(); pos += (pos & -pos))
            t[pos] += x;
    }
};

void solve() {
    dgt r, c;
    cin >> r >> c;
    vector<vector<dgt>> a(r, vector<dgt>(c));
    for (dgt i = 0; i < r; ++i)
        for (dgt j = 0; j < c; ++j)
            cin >> a[i][j];
    dgt ans = INFLL;
    vector<Fenwick> rows(r, r * c);
    for (dgt i = 0; i < r; ++i) {
        for (dgt j = 1; j < c; ++j) {
            rows[i].add(a[i][j], 1);
        }
    }
    Fenwick fw(r * c);
    dgt ir = 0, jc = 0;
    dgt ans = 0;
    while (ir < r && jc < c) {
        dgt invr = 0, invc = 0;
        for (dgt i = ir; i < r; ++i) {
            invc += rows[ir].sum(a[i][jc]);
            invr += rows[ir].sum(a[i][jc], r * c);
        }
        if (invr > invc) {
            for (dgt i = ir; i < r; ++i) {
                ans += fw.sum(a[i][jc], r * c);
                fw.add(a[i][jc], 1);
                if (jc + 1 < c)
                    rows[i].add(a[i][jc + 1], -1);
            }
            ++jc;
        } else {
            for (dgt j = jc; j < c; ++j) {
                ans += fw.sum(a[ir][j], r * c);
                fw.add(a[ir][j], 1);
            }
            ++ir;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " ===================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test =======================\n";
#endif
    }

    return 0;
}

// g++ -std=c++20 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
