// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef ll dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

struct Fenwick {
    vector<dgt> t;

    Fenwick(dgt n) {
        build(n);
    }

    void build(dgt n) {
        t.assign(n + 1, 0);
    }

    dgt sum(dgt r) {
        dgt res = 0;
        for (; r > 0; r -= (r & -r))
            res += t[r];
        return res;
    }

    dgt sum(dgt l, dgt r) {
        return sum(r) - sum(l - 1);
    }

    void add(dgt pos, dgt x) {
        for (; pos < t.size(); pos += (pos & -pos))
            t[pos] += x;
    }
};

void solve() {
    dgt r, c;
    cin >> r >> c;
    vector<vector<dgt>> a(r, vector<dgt>(c));
    for (dgt i = 0; i < r; ++i)
        for (dgt j = 0; j < c; ++j)
            cin >> a[i][j];
    dgt ans = INF;
    Fenwick fw(r * c);
    if (r == 1) {
        dgt cnt = 0;
        for (dgt ii = c - 1; ii >= 0; --ii) {
            cnt += fw.sum(a[0][ii]);
            fw.add(a[0][ii], 1);
        }
        ans = min(ans, cnt);
    } else {
        ans = 0;
        for (dgt j = r - 1; j >= 0; --j) {
            for (dgt i = c - 1; i >= 0; --i) {
                ans += fw.sum(a[j][i]);
                fw.add(a[j][i], 1);
            }
        }
        fw.build(r * c);
        for (dgt i = 0; i < c; ++i)
            fw.add(a[0][i], 1);
        dgt res = ans;
        for (dgt i = 0; i < c; ++i) {
            fw.add(a[0][i], -1);
            dgt cntl = fw.sum(a[1][i]);
            dgt cntg = (c - i - 1) - cntl;
            res -= cntg;
            res += cntl;
            ans = min(ans, res);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " ===================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test =======================\n";
#endif
    }

    return 0;
}

// g++ -std=c++20 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
