// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t i128;
typedef ll dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = ll(1e18) + 1;
const ld EPS = 1e-9;

struct Fenwick {
    vector<dgt> t;

    Fenwick(dgt n) {
        build(n);
    }

    void build(dgt n) {
        t.assign(n + 1, 0);
    }

    dgt sum(dgt r) {
        dgt res = 0;
        for (; r > 0; r -= (r & -r))
            res += t[r];
        return res;
    }

    dgt sum(dgt l, dgt r) {
        return sum(r) - sum(l - 1);
    }

    void add(dgt pos, dgt x) {
        for (; pos < t.size(); pos += (pos & -pos))
            t[pos] += x;
    }
};

void solve() {
    dgt r, c;
    cin >> r >> c;
    vector<vector<dgt>> a(r, vector<dgt>(c));
    for (dgt i = 0; i < r; ++i)
        for (dgt j = 0; j < c; ++j)
            cin >> a[i][j];
    vector<vector<dgt>> dp(r + 1, vector<dgt>(c + 1, INFLL));
    dp[0][0] = 0;
    // vector<dgt> arr;
    Fenwick fw(r * c);
    {
        fw.build(r * c);
        dgt res = 0;
        for (dgt i = 1; i <= r; ++i) {
            for (dgt j = 0; j < c; ++j) { 
                res += fw.sum(a[i - 1][j], r * c);
                fw.add(a[i - 1][j], 1);
            }
            dp[i][0] = res;
        }
    } {
        fw.build(r * c);
        dgt res = 0;
        for (dgt j = 1; j <= c; ++j) {
            for (dgt i = 0; i < r; ++i) {
                res += fw.sum(a[i][j - 1], r * c);
                fw.add(a[i][j - 1], 1);
            }
            dp[0][j] = res;
        }
    }
    for (dgt i = 1; i <= r; ++i) {
        fw.build(r * c);
        for (dgt i1 = 0; i1 < i - 1; ++i1) {
            for (dgt j1 = 0; j1 < c; ++j1) {
                fw.add(a[i1][j1], 1);
            }
        }
        for (dgt j = 1; j <= c; ++j) {
            if (j > 1) {
                for (dgt i1 = i - 1; i1 < r; ++i1) {
                    fw.add(a[i1][j - 2], 1);
                }
            }
            {
                for (dgt i1 = i - 1; i1 < r; ++i1) {
                    fw.add(a[i1][j - 1], 1);
                }
                // 
                dgt res = dp[i - 1][j];
                for (dgt j1 = j; j1 < c; ++j1) {
                    res += fw.sum(a[i - 1][j1], r * c);
                    fw.add(a[i - 1][j1], 1);
                }
                for (dgt j1 = j; j1 < c; ++j1) {
                    fw.add(a[i - 1][j1], -1);
                }
                dp[i][j] = min(dp[i][j], res);
                // 
                for (dgt i1 = i - 1; i1 < r; ++i1) {
                    fw.add(a[i1][j - 1], -1);
                }
            } {
                for (dgt j1 = j - 1; j1 < c; ++j1) {
                    fw.add(a[i - 1][j1], 1);
                }
                // 
                dgt res = dp[i][j - 1];
                for (dgt i1 = i; i1 < r; ++i1) {
                    res += fw.sum(a[i1][j - 1], r * c);
                    fw.add(a[i1][j - 1], 1);
                }
                for (dgt i1 = i; i1 < r; ++i1) {
                    fw.add(a[i1][j - 1], -1);
                }
                dp[i][j] = min(dp[i][j], res);
                // 
                for (dgt j1 = j - 1; j1 < c; ++j1) {
                    fw.add(a[i - 1][j1], -1);
                }
            }
        }
    }
    cout << dp[r][c] << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test #" << i << " ===================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test =======================\n";
#endif
    }

    return 0;
}

// g++ -std=c++20 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
