#include <bits/stdc++.h>

using ll = long long;
using namespace std;
#define int long long
class segment_tree {
    vector <pair <int, int>> tree;
    int n;
    pair <int, int> inf = {2e9, 2e9};
    pair <int, int> merge(pair <int, int> v1, pair <int, int> v2) {
        return min(v1, v2);
    }
    pair <int, int> get(int num, int l, int r, int low, int high) {
        if (l >= low && r <= high) {
            return tree[num];
        }
        int med = (l + r) / 2;
        pair <int, int> ans = inf;
        if (med > low) {
            ans = merge(ans, get(2 * num + 1, l, med, low, high));
        }
        if (med < high) {
            ans = merge(ans, get(2 * num + 2, med, r, low, high));
        }
        return ans;
    }
    void build(int num, int l, int r, vector <int> &val) {
        if (l == r - 1) {
            tree[num] = {val[l], l};
            return;
        }
        int med = (l + r) / 2;
        build(2 * num + 1, l, med, val);
        build(2 * num + 2, med, r, val);
        tree[num] = merge(tree[2 * num + 1], tree[2 * num + 2]);
    }
public:
    void init(int nn, vector <int> &val) {
        n = nn;
        tree.resize(4 * n);
        build(0, 0, n, val);
    }
    int get(int l, int r) {
        if (r <= l) {
            return 2e9;
        }
        return get(0, 0, n, l, r).second;
    }
};
void solve() {
    int n, q;
    cin >> n >> q;
    vector <int> val(n);
    for (int i = 0; i < n; ++i) {
        cin >> val[i];
    }
    segment_tree now;
    now.init(n, val);
    vector <int> next(n), suf(n + 1, 0);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], val[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        int ind = i + 1;
        while (ind != n && val[ind] < val[i]) {
            ind = next[ind];
        }
        next[i] = ind;
    }
    for (int i = 0; i < q; ++i) {
        int k, ind;
        cin >> k >> ind;
        --ind;
        int num = 0;
        while (ind > 0) {
            if (ind == 1 && k == 2) {
                num = min(n - 1, next[num]);
                ind = 0;
                k = 1;
                continue;
            }
            int cur = now.get(num + 1, min(n - (k - 2), next[num] + 1));
            num = cur;
            --ind;
            --k;
        }
        if (k == 1 && ind == 0) {
            cout << suf[num] << '\n';
        } else {
            cout << val[num] << '\n';
        }
    }
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    solve();
}
