#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

using namespace std;

typedef long long ll;

bool ans[100000];
int col[100000];
ll x[100000], y[100000], r, R;
vector <int> g[100000];

map <pair <ll, ll>, vector <int>> m;
set <pair <ll, ll>> cool;

void ldfs(int v) {
    const pair <ll, ll> cl = {x[v] *  2 / r, y[v] *  2 / r};
    pair <ll, ll> ngh[24];
    int ind = -1;
    for (int j = -2; j < 3; ++j)
        for (int k = -2; k < 3; ++k)
            if (j || k)
                ngh[++ind] = {cl.first + j, cl.second + k};
    for (auto ng : ngh) {
        if (!cool.contains(ng)) {
            for (auto u : m[ng])
                if ((x[v] - x[u]) * (x[v] - x[u]) + (y[v] - y[u]) * (y[v] - y[u]) <= R) {
                    cool.insert(ng);
                    ldfs(u);
                }
        }
    }
}

void dfs(int v, int c) {
    col[v] = c;
    for (int u : g[v]) {
        if (!col[u]) {
            dfs(u, 3 - c);
            if (ans[u])
                ans[v] = 1;
        } else if (col[u] == col[v] || ans[u])
            ans[v] = 1;
    }
}

void dfs2(int v) {
    col[v] = 1;
    for (int u : g[v]) {
        if (ans[v])
            ans[u] = 1;
        if (!col[u])
            dfs2(u);
    }
}

int main() {
    int n;
    cin >> n >> r;
    R = r * r;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        m[{x[i] * 2 / r, y[i] * 2 / r}].push_back(i);
        if (m[{x[i] * 2 / r, y[i] * 2 / r}].size() == 3)
            cool.insert({x[i] * 2 / r, y[i] * 2 / r});
    }
    for (int i = 0; i < n; ++i) {
        if (!cool.contains({x[i] * 2 / r, y[i] * 2 / r})) {
            pair <ll, ll> ngh[24];
            int ind = -1;
            for (int j = -2; j < 3; ++j)
                for (int k = -2; k < 3; ++k)
                    if (j || k)
                        ngh[++ind] = {x[i] * 2 / r + j, y[i] * 2 / r + k};
            for (auto ng : ngh) {
                if (m.contains(ng) && m[ng].size() > 2) {
                   for (int s : m[ng])
                        if ((x[i] - x[s]) * (x[i] - x[s]) + (y[i] - y[s]) * (y[i] - y[s]) <= R) {
                            cool.insert({x[i] * 2 / r, y[i] * 2 / r});
                            break;
                        }
                }
            }
        }
    }
    for (auto cl : cool)
        if (m[cl].size() < 3)
            for (int v : m[cl])
                ldfs(v);
    for (int i = 0; i < n; ++i) {
        pair <ll, ll> cl = {x[i] *  2 / r, y[i] *  2 / r};
        if (!cool.contains(cl)) {
            pair <ll, ll> ngh[25];
            int ind = -1;
            for (int j = -2; j < 3; ++j)
                for (int k = -2; k < 3; ++k)
                    ngh[++ind] = {cl.first + j, cl.second + k};
            for (auto ng : ngh) {
                if (!cool.contains(ng)) {
                    for (int s : m[ng])
                        if (s != i && (x[i] - x[s]) * (x[i] - x[s]) + (y[i] - y[s]) * (y[i] - y[s]) <= R) {
                            g[i].push_back(s);
                        }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i)
        if (!col[i])
            dfs(i, 1);
    for (int i = 0; i < n; ++i)
        col[i] = 0;
    for (int i = 0; i < n; ++i)
        if (!col[i])
            dfs2(i);
    for (auto p : cool)
        for (auto i : m[p])
            ans[i] = 1;
    for (int i = 0; i < n; ++i)
        cout << (int)ans[i];
    cout << endl;
}