#include <bits/stdc++.h>

using namespace std;

const int N = 600 * 600 + 1;

vector<long long> F;

void init2(int n) {
    F.resize(n + 1);
}

void update2(int i, long long val) {
    for (; i < F.size(); i += (i & (-i)))
        F[i] += val;
}

long long sum2(int r) {
    long long res = 0;
    for (; r > 0; r -= (r & (-r)))
        res += F[r];
    return res;
}

long long get_sum2(int l, int r) {
    if (l > r) return 0;
    return sum2(r) - sum2(l - 1);
}

vector<vector<long long> > F1;

void init1(int n, int m) {
    n++, m++;
    F1.resize(n, vector<long long>(m));
}

void update1(int i, int j, long long val) {
    i++, j++;
    for (; i < F1.size(); i += (i & (-i))) {
        int r = j;
        for (; j < F1[i].size(); j += (j & (-j)))
            F1[i][j] += val;
        j = r;
    }
}

long long sum1(int i, int j) {
    i++, j++;
    long long res = 0;
    for (; i > 0; i -= (i & (-i))) {
        int r = j;
        for (; j > 0; j -= (j & (-j)))
            res += F1[i][j];
        j = r;
    }
    return res;
}

long long get_sum1(int x1, int y1, int x2, int y2) {
    if (x1 > x2 || y1 > y2) return 0;
    return sum1(x2, y2) + sum1(x1 - 1, y1 - 1) - sum1(x2, y1 - 1) - sum1(x1 - 1, y2);
}

const int C = 600;
long long f[N], b[N / C + 1];

void updateD(int i, long long val) {
    while (i < N) {
        if (i % C == 0 && i + C < N) {
            b[i / C] += val;
            i += C;
        } else {
            f[i] += val;
            i++;
        }
    }
}

long long sumD(int r) {
    if (r < 0) return 0;
    return f[r] + b[r / C];
}

long long get_sumD(int l, int r) {
    return sumD(r) - sumD(l - 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int a[n][m];
    pair<int, int> pos[n * m + 1];
    long long v1[n][m], v2[n][m], cnt[n][m], invc[n][m], invr[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            pos[a[i][j]] = {i, j};
        }
    }
    init2(n * m + 1);
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            invc[i][j] = (j + 1 < m ? invc[i][j + 1] : 0) + get_sum2(0, a[i][j] - 1);
            update2(a[i][j], 1);
        }
        for (int j = 0; j < m; j++)
            update2(a[i][j], -1);
    }
    for (int j = 0; j < m; j++) {
        for (int i = n - 1; i >= 0; i--) {
            invr[i][j] = (i + 1 < n ? invr[i + 1][j] : 0) + get_sum2(0, a[i][j] - 1);
            update2(a[i][j], 1);
        }
        for (int i = 0; i < n; i++)
            update2(a[i][j], -1);
    }
    init1(n, m);
    for (int val = 1; val <= n * m; val++) {
        int i = pos[val].first, j = pos[val].second;
        cnt[i][j] = get_sum1(i + 1, j + 1, n - 1, m - 1);
        update1(i, j, 1);
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            v1[i][j] = (i + 1 < n ? v1[i + 1][j] : 0) + cnt[i][j];
            for (int k = i; k < n; k++)
                v1[i][j] += get_sumD(0, a[k][j] - 1);
            updateD(a[i][j], 1);
        }
        for (int j = 0; j < m; j++)
            updateD(a[i][j], -1);
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            v2[i][j] = (j + 1 < m ? v2[i][j + 1] : 0) + cnt[i][j];
            updateD(a[i][j], 1);
            for (int k = i + 1; k < n; k++)
                v2[i][j] += get_sumD(a[k][j] + 1, n * m);
        }
        for (int j = 0; j < m; j++)
            updateD(a[i][j], -1);
    }
    long long dp[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = (long long) 1e18;
        }
    }
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i + 1 < n)
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + v2[i][j] + invc[i][j]);
            if (j + 1 < m)
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + v1[i][j] + invr[i][j]);
        }
    }
    cout << dp[0][0];
    return 0;
}
