#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 600 * 600 + 10;

struct FenwickTree {
    vector<int> F;

    void init(int n) {
        F.resize(n + 1);
    }

    void update(int i, int val) {
        for (; i < F.size(); i += (i & (-i)))
            F[i] += val;
    }

    int sum(int r) {
        int res = 0;
        for (; r > 0; r -= (r & (-r)))
            res += F[r];
        return res;
    }

    int get_sum(int l, int r) {
        if (l > r) return 0;
        return sum(r) - sum(l - 1);
    }
} T;

struct FenwickTreeD {
    vector<vector<int> > F;

    void init(int n, int m) {
        n++, m++;
        F.resize(n, vector<int>(m));
    }

    void update(int i, int j, int val) {
        i++, j++;
        for (; i < F.size(); i += (i & (-i))) {
            int r = j;
            for (; j < F[i].size(); j += (j & (-j)))
                F[i][j] += val;
            j = r;
        }
    }

    int sum(int i, int j) {
        i++, j++;
        int res = 0;
        for (; i > 0; i -= (i & (-i))) {
            int r = j;
            for (; j > 0; j -= (j & (-j)))
                res += F[i][j];
            j = r;
        }
        return res;
    }

    int get_sum(int x1, int y1, int x2, int y2) {
        if (x1 > x2 || y1 > y2) return 0;
        return sum(x2, y2) + sum(x1 - 1, y1 - 1) - sum(x2, y1 - 1) - sum(x1 - 1, y2);
    }
} S;

const int C = 600;
int f[N], b[N / C + 1];

void updateD(int i, int val) {
    while (i < N) {
        if (i % C == 0 && i + C < N) {
            b[i / C] += val;
            i += C;
        } else {
            f[i] += val;
            i++;
        }
    }
}

int sumD(int r) {
    if (r < 0) return 0;
    return f[r] + b[r / C];
}

int get_sumD(int l, int r) {
    return sumD(r) - sumD(l - 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int a[n][m];
    pair<int, int> pos[n * m + 1];
    int v1[n][m], v2[n][m], cnt[n][m], invc[n][m], invr[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            pos[a[i][j]] = {i, j};
        }
    }
    T.init(n * m + 1);
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            invc[i][j] = (j + 1 < m ? invc[i][j + 1] : 0) + T.get_sum(0, a[i][j] - 1);
            T.update(a[i][j], 1);
        }
        for (int j = 0; j < m; j++)
            T.update(a[i][j], -1);
    }
    for (int j = 0; j < m; j++) {
        for (int i = n - 1; i >= 0; i--) {
            invr[i][j] = (i + 1 < n ? invr[i + 1][j] : 0) + T.get_sum(0, a[i][j] - 1);
            T.update(a[i][j], 1);
        }
        for (int i = 0; i < n; i++)
            T.update(a[i][j], -1);
    }
    S.init(n, m);
    for (int val = 1; val <= n * m; val++) {
        int i = pos[val].first, j = pos[val].second;
        cnt[i][j] = S.get_sum(i + 1, j + 1, n - 1, m - 1);
        S.update(i, j, 1);
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            v1[i][j] = (i + 1 < n ? v1[i + 1][j] : 0) + cnt[i][j];
            for (int k = i; k < n; k++)
                v1[i][j] += get_sumD(0, a[k][j] - 1);
            updateD(a[i][j], 1);
        }
        for (int j = 0; j < m; j++)
            updateD(a[i][j], -1);
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            v2[i][j] = (j + 1 < m ? v2[i][j + 1] : 0) + cnt[i][j];
            updateD(a[i][j], 1);
            for (int k = i + 1; k < n; k++)
                v2[i][j] += get_sumD(a[k][j] + 1, n * m);
        }
        for (int j = 0; j < m; j++)
            updateD(a[i][j], -1);
    }
    int dp[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = (int) 1e18;
        }
    }
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i + 1 < n)
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + v2[i][j] + invc[i][j]);
            if (j + 1 < m)
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + v1[i][j] + invr[i][j]);
        }
    }
    cout << dp[0][0];
    return 0;
}
