#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
#define int long long
using namespace std;

const int INF = 1e18;

int n, m;

struct Node{
    Node* l;
    Node* r;
    int s;
};

Node* build(int lx, int rx) {
    Node* u = new Node();
    u->s = 0;
    if (rx - lx == 1) {
        return u;
    }
    int mid = (lx + rx) / 2;
    u->l = build(lx, mid);
    u->r = build(mid, rx);
    return u;
}

Node* upd(Node* v, int i, int lx, int rx) {
    Node* u = new Node();
    u->l = v->l;
    u->r = v->r;
    u->s = v->s;
    if (rx - lx == 1) {
        u->s++;
        return u;
    }
    int mid = (lx + rx) / 2;
    if (i < mid) u->l = upd(v->l, i, lx, mid);
    else u->r = upd(v->r, i, mid, rx);
    u->s = u->l->s + u->r->s;
    return u;
}

Node* upd(Node *v, int i) {
    return upd(v, i, 0, n * m + 1);
}

int get(Node* v, int l, int r, int lx, int rx) {
    if (l >= rx || lx >= r) return 0;
    if (l <= lx && rx <= r) {
        return v->s;
    }
    int mid = (lx + rx) / 2;
    return get(v->l, l, r, lx, mid) + get(v->r, l, r, mid, rx);
}

int get(Node* v, int l, int r) {
    return get(v, l, r, 0, n * m + 1);
}

int get(Node* v) {
    return v->s;
}

void solve() {
    int ans = INF;
    cin >> n >> m;
    vector<vector<Node*>> st(n + 1, vector<Node*>(m + 1));
    vector<vector<int>> a(n + 1, vector<int>(m + 1)), dp(n + 2, vector<int>(m + 2, INF));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) cin >> a[i][j];
    }
    st[1][0] = build(0, n * m + 1);
    for (int j = 0; j <= m; j++) st[0][j] = st[1][0];
    for (int i = 2; i <= n; i++) st[i][0] = st[1][0];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            st[i][j] = st[i][j - 1];
            for (int i2 = 1; i2 <= i; i2++) {
                st[i][j] = upd(st[i][j], a[i2][j]);
            }
        }
    }
    dp[1][1] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            int res = dp[i][j];
            // del i;
            for (int j2 = j; j2 <= m; j2++) {
                res += get(st[n][j - 1], a[i][j2] + 1, n * m + 1) - get(st[i][j - 1], a[i][j2] + 1, n * m + 1);
                res += get(st[i][j2], a[i][j2] + 1, n * m + 1) - get(st[i - 1][j2], a[i][j2] + 1, n * m + 1);
                res += get(st[i - 1][m], a[i][j2] + 1, n * m + 1);
            }
            dp[i + 1][j] = min(dp[i + 1][j], res);

            res = dp[i][j];
            for (int i2 = i; i2 <= n; i2++) {
                res += get(st[n][j - 1], a[i2][j] + 1, n * m + 1) - get(st[i2][j - 1], a[i2][j] + 1, n * m + 1);
                res += get(st[i2][j], a[i2][j] + 1, n * m + 1) - get(st[i - 1][j], a[i2][j] + 1, n * m + 1);
                res += get(st[i - 1][m], a[i2][j] + 1, n * m + 1);
            }
            dp[i][j + 1] = min(dp[i][j + 1], res);
        }
    }
    for (int j = 1; j <= m; j++) ans = min(ans, dp[n + 1][j]);
    for (int i = 1; i <= n; i++) ans = min(ans, dp[i][m + 1]);
    cout << ans;
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    solve();
}
