#include <iostream>
#include <vector>
#include <random>
#include <array>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

using Point = std::array<ll, 2>;
const int A = 1e5 + 1;
mt19937 rnd(4054054);

ll sq(ll x) { return x * x; }

bool in(Point a, ll r, Point b) {
	return sq(a[0] - b[0]) + sq(a[1] - b[1]) <= r;
}

bool bad(Point a, ll r, Point A, Point B, Point C, Point D) {
	if (A[0] >= a[0] && A[1] >= a[1] && !in(a, r, A)) return true;
	if (B[0] >= a[0] && B[1] <= a[1] && !in(a, r, B)) return true;
	if (C[0] <= a[0] && C[1] <= a[1] && !in(a, r, C)) return true;
	if (D[0] <= a[0] && D[1] >= a[1] && !in(a, r, D)) return true;
	return false;
}

struct Quadro {
	struct Node {
		vector<Point> points;
		int l = -1, r = -1;
		ll mn[2]{}, mx[2]{};
	};
	vector<Node> tree;
	Quadro(vector<Point> points) {
		int n = points.size();
		tree.push_back({});
		tree[0].points = points;
		build(0);
	}
	void build(int u) {
		if (tree[u].points.size() == 1) {
			for (int i = 0; i < 2; i++) {
				tree[u].mn[i] = tree[u].points[0][i];
				tree[u].mx[i] = tree[u].points[0][i];
			}
			return;
		}
		int dim = rnd() % 2;
		sort(all(tree[u].points), [&](Point& l, Point& r) {return l[dim] < r[dim]; });
		int mid = tree[u].points.size() / 2;

		tree.push_back({ {tree[u].points.begin(), tree[u].points.begin() + mid} });
		tree[u].l = tree.size() - 1;
		tree.push_back({ {tree[u].points.begin() + mid, tree[u].points.end()} });
		tree[u].r = tree.size() - 1;

		build(tree[u].l); build(tree[u].r);
		for (int i = 0; i < 2; i++) {
			tree[u].mn[i] = min(tree[tree[u].l].mn[i], tree[tree[u].r].mn[i]);
			tree[u].mx[i] = max(tree[tree[u].l].mx[i], tree[tree[u].r].mx[i]);
		}
	}
	vector<Point> get(Point a, ll r, ll _r) {
		vector<Point> res;
		get(0, a, r, _r, res);
		return res;
	}
	void get(int u, Point a, ll r, ll _r, vector<Point>& res) {
		if (res.size() == ::A) return;
		if (u == -1) return;
		for (int i = 0; i < 2; i++) {
			if (tree[u].mn[i] > a[i] + _r) return;
			if (tree[u].mx[i] < a[i] - _r) return;
		}
		Point A = { tree[u].mn[0], tree[u].mn[1] },
			B = { tree[u].mn[0], tree[u].mx[1] },
			C = { tree[u].mx[0], tree[u].mx[1] },
			D = { tree[u].mx[0], tree[u].mn[1] };
		if (bad(a, r, A, B, C, D)) {
			return;
		}
		if (in(a, r, A) && in(a, r, B)
			&& in(a, r, C) && in(a, r, D)) {
			for (int i = 0; i < tree[u].points.size() && res.size() < ::A; i++) {
				res.push_back(tree[u].points[i]);
			}
		}
		else {
			if (tree[u].points.size() < 50) {
				for (int i = 0; i < tree[u].points.size() && res.size() < ::A; i++) {
					if (in(a, r, tree[u].points[i])) {
						res.push_back(tree[u].points[i]);
					}
				}
			}	
			else {
				get(tree[u].l, a, r, _r, res);
				get(tree[u].r, a, r, _r, res);
			}
		}
	}
};

struct Node {
	bool used1 = false;
	vector<int> e;
	int used = false;
	int h = 0;
	int ans = 0;
};
vector<Node> graph;

bool find_cycle(int u, int h, int bef) {
	if (graph[u].ans == 1) return true;
	if (graph[u].used) {
		if (graph[u].h >= h) return false;
		return (h - graph[u].h) % 2 == 1;
	}
	graph[u].h = h;
	graph[u].used = 1;
	for (int to : graph[u].e) if (to != bef) {
		if (find_cycle(to, h + 1, u)) return true;
	}
	return false;
}

void set_ans(int u, int ans) {
	if (graph[u].used == 2) return;
	graph[u].used = 2;
	graph[u].ans = ans;
	for (int to : graph[u].e) {
		set_ans(to, ans);
	}
}

int main() {

	int n; cin >> n;
	ll r, _r; cin >> r; _r = r; r *= r;
	vector<Point> points(n);
	for (int i = 0; i < n; i++) {
		cin >> points[i][0] >> points[i][1];
	}
	Quadro tree(points);
	graph.assign(n, {});
	map<Point, int> toi;
	for (int i = 0; i < n; i++) {
		toi[points[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		if (graph[i].used1) continue;
		vector<Point> ps = tree.get(points[i], r, _r);
		//vector<Point> ps;
		//for (int a = points[i][0] - _r; a <= points[i][0] + _r; a++) {
		//	for (int b = points[i][1] - _r; b <= points[i][1] + _r; b++) {
		//		if (in(points[i], r, { a, b }) && toi.count({ a, b })) {
		//			ps.push_back({ a, b });
		//		}
		//	}
		//}
		if (ps.size() >= 8) {
			for (auto p : ps) {
				graph[toi[p]].ans = 1;
				graph[toi[p]].used1 = true;
			}
		}
		else {
			for (auto p : ps) {
				if (p != points[i]) {
					graph[i].e.push_back(toi[p]);
					graph[toi[p]].e.push_back(i);
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		sort(all(graph[i].e));
		graph[i].e.erase(unique(all(graph[i].e)), graph[i].e.end());
	}

	for (int i = 0; i < n; i++) {
		int ans = find_cycle(i, 0, -1);
		set_ans(i, ans);
	}

	for (int i = 0; i < n; i++) {
		cout << graph[i].ans;
	}

	return 0;
}