#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <random>
#include <array>
#include <map>
#include <set>
#include <algorithm>
#include <limits.h>

using namespace std;
using ll = long long;
#define all(a) (a).begin(), (a).end()

vector<vector<ll>> getx(vector<vector<int>>& a) {
	int n = a.size(), m = a[0].size();
	vector<vector<ll>> res(n + 1, vector<ll>(m + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= m; j++) {
			for (int k = j; k < m; k++) {
				for (int i1 = 0; i1 < n; i1++) {
					for (int j1 = 0; j1 < m; j1++) {
						res[i][j] += a[i][k] < a[i1][j1] && (abs(j1) < j || abs(i1) < i);
					}
				}
				for (int w = j; w < k; w++) {
					res[i][j] += a[i][k] < a[i][w];
				}
			}
		}
	}
	return res;
}

template <typename T>
vector<vector<T>> transpose(vector<vector<T>>& a) {
	int n = a.size(), m = a[0].size();
	vector<vector<T>> res(m, vector<T>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			res[j][i] = a[i][j];
		}
	}
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m; cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	auto x = getx(a);
	auto ap = transpose(a);
	auto y = getx(ap);
	y = transpose(y);
	vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, LLONG_MAX / 2));
	dp[0][0] = 0;
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= m; j++) {
			if (i) dp[i][j] = dp[i - 1][j] + x[i - 1][j];
			if (j) dp[i][j] = min(dp[i][j], dp[i][j - 1] + y[i][j - 1]);
		}
	}
	cout << dp[n][m];

	return 0;
}