#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define int long long



struct Node {
	int x, y;
};

int get_dist(Node a, Node b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}


vector <vector <int>> sp;
vector <int> ans;
vector <int> used;
vector <int> C;
vector <int> st;
int c = 0;


void DFS(int v, int p) {
	st.push_back(v);
	C[v] = (1 - C[p]);
	used[v] = 1;

	for (auto t : sp[v]) {
		if (t == p) continue;
		if (!used[t]) {
			DFS(t, v);
		}
		else {
			if (C[v] == C[t] || ans[t]) {
				c = 1;
			}
		}
	}

}


signed main() {
	int n, r;
	cin >> n >> r;

	vector <Node> inp(n);
	sp.resize(n);
	ans.resize(n, 0);
	used.resize(n, 0);
	C.resize(n, 0);
	for (int i = 0; i < n; i++) cin >> inp[i].x >> inp[i].y;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			if (get_dist(inp[i], inp[j]) <= r * r) {
				sp[i].push_back(j);
			}
			if (sp[i].size() > 6) {
				ans[i] = 1;
				used[i] = 1;
				break;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			c = 0;
			st.clear();

			DFS(i, i);

			if (c) {
				for (auto t : st) {
					ans[t] = 1;
				}
			}
		}
	}

	for (auto t : ans) {
		cout << t;
	}
}
