#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define int long long



struct Node {
	int x, y, ind;

	bool operator <(const Node& other) const {
		if (x == other.x) return y < other.y;
		return x < other.x;
	}
};


struct Node2 {
	int x;
	vector <pair<int, int>> S;
};


int get_dist(Node a, Node b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}


vector <vector <int>> sp;
vector <int> ans;
vector <int> used;
vector <int> C;
vector <int> st;
int c = 0;


void DFS(int v, int p) {
	st.push_back(v);
	C[v] = (1 - C[p]);
	used[v] = 1;

	for (auto t : sp[v]) {
		if (t == p) continue;
		if (!used[t]) {
			DFS(t, v);
		}
		else {
			if (C[v] == C[t] || ans[t]) {
				c = 1;
			}
		}
	}

}


signed main() {
	int n, r;
	cin >> n >> r;

	vector <Node> inp(n);

	sp.resize(n);
	ans.resize(n, 0);
	used.resize(n, 0);
	C.resize(n, 0);
	for (int i = 0; i < n; i++) {
		cin >> inp[i].x >> inp[i].y;
		inp[i].ind = i;
	}

	vector <Node> inp_sorted = inp;
	sort(inp_sorted.begin(), inp_sorted.end());

	vector <Node2> S;
	for (int i = 0; i < n; i++) {
		S.emplace_back();
		S.back().x = inp[i].x;
		while (i < n - 1 && inp_sorted[i + 1].x == inp_sorted[i].x) {
			S.back().S.emplace_back(inp_sorted[i].y, inp_sorted[i].ind);
			i++;
		}
		S.back().S.emplace_back(inp_sorted[i].y, inp_sorted[i].ind);
	}

	for (int i = 0; i < n; i++) {
		int lb = -1, rb = 0;// (int)S.size();
		/*while (rb - lb > 1) {
			int mb = (lb + rb) / 2;

			if (S[mb].x < inp[i].x - r) {
				lb = mb;
			}
			else {
				rb = mb;
			}
		}*/

		while (rb < S.size()) {
			int lc = -1, rc = S[rb].S.size();
			while (rc - lc > 1) {
				int mc = (lc + rc) / 2;

				if (S[rb].S[mc].first < inp[i].y - r) {
					lc = mc;
				} 
				else {
					rc = mc;
				}
			}

			while (rc < S[rb].S.size() && S[rb].S[rc].first <= inp[i].y + r) {
				int ind = S[rb].S[rc].second;
				if (i == ind) {
					rc++;
					continue;
				}

				if (get_dist(inp[i], inp[ind]) <= r * r) {
					sp[i].push_back(ind);
				}

				rc++;

				if (sp[i].size() > 6) {
					used[i] = 1;
					ans[i] = 1;
					break;
				}
			}

			rb++;

			if (sp[i].size() > 6) {
				used[i] = 1;
				ans[i] = 1;
				break;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			c = 0;
			st.clear();

			DFS(i, i);

			if (c) {
				for (auto t : st) {
					ans[t] = 1;
				}
			}
		}
	}

	for (auto t : ans) {
		cout << t;
	}
}
