#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define int long long



struct tree {
	int n;
	vector <int> T;

	tree(int n_) {
		n = n_;
		T.resize(4 * n, 0);
	}

	int get(int l, int r, int v, int lv, int rv) {
		if (l >= rv || r <= lv) {
			return 0;
		}
		if (l >= lv && r <= rv) {
			return T[v];
		}

		int m = (l + r) / 2;

		return get(l, m, v * 2 + 1, lv, rv) + get(m, r, v * 2 + 2, lv, rv);
	}

	int get(int l, int r) {
		return get(0, n, 0, l, r);
	}

	void change(int l, int r, int v, int pos) {
		if (l > pos || r <= pos) {
			return;
		}
		if (r - l == 1) {
			T[v] = 1;
			return;
		}

		int m = (l + r) / 2;

		change(l, m, v * 2 + 1, pos);
		change(m, r, v * 2 + 2, pos);

		T[v] = T[v * 2 + 1] + T[v * 2 + 2];
	}

	void change(int pos) {
		change(0, n, 0, pos);
	}
};



signed main() {
	int r, c;
	cin >> r >> c;
	int n = r * c;

	vector <int> inp(n);
	for (int i = 0; i < n; i++) {
		cin >> inp[i];
	}

	tree T(n + 1);
	int ans = 0;

	for (int i = 0; i < n; i++) {
		ans += T.get(inp[i], n + 1);
		T.change(inp[i]);
	}

	cout << ans;
}
