#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e18;



struct tree {
	int n;
	vector <int> T;

	tree(int n_) {
		n = n_;
		T.resize(4 * n, 0);
	}

	int get(int l, int r, int v, int lv, int rv) {
		if (l >= rv || r <= lv) {
			return 0;
		}
		if (l >= lv && r <= rv) {
			return T[v];
		}

		int m = (l + r) / 2;

		return get(l, m, v * 2 + 1, lv, rv) + get(m, r, v * 2 + 2, lv, rv);
	}

	int get(int l, int r) {
		return get(0, n, 0, l, r);
	}

	void change(int l, int r, int v, int pos) {
		if (l > pos || r <= pos) {
			return;
		}
		if (r - l == 1) {
			T[v] = 1;
			return;
		}

		int m = (l + r) / 2;

		change(l, m, v * 2 + 1, pos);
		change(m, r, v * 2 + 2, pos);

		T[v] = T[v * 2 + 1] + T[v * 2 + 2];
	}

	void change(int pos) {
		change(0, n, 0, pos);
	}
};


int low_bd(vector <int>& A, int x) {
	int l = -1, r = (int)A.size();
	while (r - l > 1) {
		int m = (l + r) / 2;

		if (A[m] < x) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return r;
}


signed main() {
	int r, c;
	cin >> r >> c;

	vector <vector <int>> inp(r, vector <int> (c, 0));
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++) {
			cin >> inp[i][j];
		}
	}

	vector <vector <int>> Dp(r, vector <int>(c, INF));
	Dp[r - 1][c - 1] = 0;

	for (int i = r - 1; i >= 0; i--) {
		for (int j = c - 1; j >= 0; j--) {
			if (i == r - 1 && j == c - 1) continue;

			int s1 = 0, s2 = 0;
			if (i != r - 1) {
				vector <int> st;
				for (int k = j; k < c; k++) {
					for (auto t : st) {
						if (t > inp[i][k]) s1++;
					}
					st.emplace_back(inp[i][k]);
				}
				sort(st.begin(), st.end());
				st.emplace_back(INF);

				for (int i0 = i + 1; i0 < r; i0++) {
					for (int j0 = j; j0 < c; j0++) {
						s1 += (int)st.size() - 1 - low_bd(st, inp[i0][j0]);
					}
				}
			}
			else { s1 = INF; }

			if (j != c - 1) {
				vector <int> st;
				for (int k = i; k < r; k++) {
					for (auto t : st) {
						if (t > inp[k][j]) s2++;
					}
					st.emplace_back(inp[k][j]);
				}
				sort(st.begin(), st.end());
				st.emplace_back(INF);

				for (int i0 = i; i0 < r; i0++) {
					for (int j0 = j + 1; j0 < c; j0++) {
						s2 += (int)st.size() - 1 - low_bd(st, inp[i0][j0]);
					}
				}
			}
			else { s2 = INF; }

			Dp[i][j] = min((i + 1 == r ? 0 : Dp[i + 1][j]) + s1, (j + 1 == c ? 0 : Dp[i][j + 1]) + s2);
		}
	}

	cout << Dp[0][0];
}
