#include <bits/stdc++.h>


using namespace std;
#define ll long long
#define F first
#define S second

const ll enough = 7;

ll dist2(pair<pair<ll, ll>, ll> p1, pair<pair<ll, ll>, ll> p2) {
    return (p1.F.F - p2.F.F) * (p1.F.F - p2.F.F) + (p1.F.S - p2.F.S) * (p1.F.S - p2.F.S);
}

vector<pair<pair<ll, ll>, ll> > arr;
vector<bool> ans, used1;
vector<ll> clr;
vector<vector<ll> > g;

bool dfs(ll u, int c) {
    if (clr[u])
        return clr[u] != c;

    clr[u] = c;
    for (ll v: g[u])
        if (dfs(v, 3 - c))
            return 1;

    return 0;
}

void dfs0(ll u) {
    if (used1[u])
        return;

    used1[u] = 1;
    for (ll v: g[u])
        dfs0(v);
}

void dfs1(ll u) {
    if (used1[u])
        return;

    ans[arr[u].second] = 1;
    used1[u] = 1;
    for (ll v: g[u])
        dfs1(v);
}


struct mst {
    vector<vector<pair<pair<ll, ll>, ll> > > arr;
    ll sz;

    mst(vector<pair<pair<ll, ll>, ll> > &inp) {
        ll k = 1;
        while (k < inp.size())
            k *= 2;

        sz = k * 2;
        arr.resize(sz);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, r;
    cin >> n >> r;
    ll rr = r * r;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].F.F >> arr[i].F.S;
        arr[i].S = i;
    }

    sort(arr.begin(), arr.end());
    ans.resize(n);
    g.resize(n);
    used1.resize(n);
    clr.resize(n);

    map<pair<ll, ll>, ll> hh;
    for (int i = 0; i < n; ++i)
        hh[arr[i].F] = i;

    ll lg = 0, rg = 0;;
    for (ll i = 0; i < n; ++i) {
        while (rg < n && arr[rg].F.F <= arr[i].F.F + r)
            rg++;

        while (arr[lg].F.F + r < arr[i].F.F)
            lg++;

        vector<pair<ll, ll> > help;

        if (r < 4) {
            for (ll x = arr[i].F.F - r; x <= arr[i].F.F + r && help.size() < enough; ++x)
                for (ll y = arr[i].F.S - r; y <= arr[i].F.S + r && help.size() < enough; ++y) {
                    if (!hh.count({x, y}))
                        continue;

                    ll j = hh[{x, y}];
                    if (i == j)
                        continue;

                    ll h = dist2(arr[i], arr[j]);
                    if (h > rr)
                        continue;

                    help.emplace_back(h, j);
                }
        } else
            for (ll j = lg; j < rg && help.size() < enough; ++j) {
                if (i == j)
                    continue;

                if (arr[j].F.S < arr[i].F.S - r)
                    continue;

                if (arr[j].F.S > arr[i].F.S + r)
                    continue;

                ll h = dist2(arr[i], arr[j]);
                if (h > rr)
                    continue;

                help.emplace_back(h, j);
            }

        for (auto j: help) {
            g[i].emplace_back(j.second);
            g[j.second].emplace_back(i);
        }
    }

    for (int i = 0; i < n; ++i)
        if (!used1[i]) {
            if (dfs(i, 1))
                dfs1(i);
            else
                dfs0(i);
        }

    for (int i = 0; i < n; ++i)
        for (ll j: g[i]) {
            if (ans[arr[i].S])
                ans[arr[j].S] = 1;

            if (ans[arr[j].S])
                ans[arr[i].S] = 1;
        }

    for (int b: ans)
        cout << b;
}

/*
6 5
4 1
4 4
1 5
5 9
9 6
10 2

*/
/*
Даны точки
Проведены все ребра длинной до r
Нужно для каждой точки сказать есть ли в ее компоненте цикл нечетной длинны.

Стоит учесть что координаты маленькие.
Компонент не более 25e16 / (Pi * R^2)
Допустим можно перебирать компоненту.
Сколько времени нужно на проверку в какой компоненте точка.
Есть оболочка. Верх и низ. Пофиг, допустим (25e16 / (Pi * R^2)) * log.

Если R >= 2e5.
2e6 * log.

Теперь R < 2e5




*/
/*
9 подгруппа - около каждой точки очень мало других.
5 подгруппа - все на линии.
Храним прыжки в каждую сторону в ближайшую и через одну.


Маленькое r:
Для каждой точки перебираем все в квадрате r*r и проводим ребра.


Теперь мало соседних точек:
Как с маленьким r. Перебираем все точки в квадрате.

Так.
Допустим в круге r/2 >= 2 точек.
Тогда цикл найден.

Теперь обратное. Максимум одна.


Если у точки более 5 ребер, то она хорошая.
Т.е. для каждой точки имеет смысл хранить 5 ближайших вершин.

Осталось найти для каждой точки 5 ближайших и решить задачу на таком графе.
(может 6 или 7)

Найти сколько-то ближайших точек.

Допустим mst.
Найти точки входящие в квадрат.
Сколько имеет смысл находить?


Так.
Для каждой еще плохой точки находим все в квадрате r*r.
Смотрим какие в радиусе и проводим ребра.
Строим граф.


*/
/*

*/
