#include <bits/stdc++.h>


using namespace std;
#define ll long long
#define F first
#define S second

const ll enough = 200;

ll dist2(pair<pair<ll, ll>, ll> p1, pair<pair<ll, ll>, ll> p2) {
    return (p1.F.F - p2.F.F) * (p1.F.F - p2.F.F) + (p1.F.S - p2.F.S) * (p1.F.S - p2.F.S);
}

vector<bool> ans, used1;
vector<ll> clr;
vector<vector<ll> > g;

bool dfs(ll u, int c) {
    if (clr[u])
        return clr[u] != c;

    clr[u] = c;
    used1[u] = 1;
    for (ll v: g[u])
        if (dfs(v, 3 - c))
            return 1;

    return 0;
}

void dfs1(ll u) {
    if (ans[u])
        return;

    ans[u] = 1;
    used1[u] = 1;
    for (ll v: g[u])
        dfs1(v);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, r;
    cin >> n >> r;
    ll rr = r * r;
    vector<pair<pair<ll, ll>, ll> > arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].F.F >> arr[i].F.S;
        arr[i].S = i;
    }

    sort(arr.begin(), arr.end());
    ans.resize(n);
    g.resize(n);
    used1.resize(n);
    clr.resize(n);
    for (ll i = 0; i < n; ++i) {
        vector<pair<ll, ll> > help;
        for (ll j = 0; j < n; ++j) {
            if (i == j)
                continue;

            if (arr[j].F.F < arr[i].F.F - r)
                continue;

            if (arr[j].F.F > arr[i].F.F + r)
                continue;

            if (arr[j].F.S < arr[i].F.S - r)
                continue;

            if (arr[j].F.S > arr[i].F.S + r)
                continue;

            ll h = dist2(arr[i], arr[j]);
            if (h > rr)
                continue;

            help.emplace_back(h, j);
        }

        sort(help.begin(), help.end());
        for (int j = 0; j < min(enough, (ll) help.size()); ++j)
            g[i].emplace_back(help[j].second);
    }

    for (int i = 0; i < n; ++i)
        if (!used1[i] && dfs(i, 1))
            dfs1(i);

    for (int b: ans)
        cout << b;
}

/*
6 5
4 1
4 4
1 5
5 9
9 6
10 2

*/
/*
Даны точки
Проведены все ребра длинной до r
Нужно для каждой точки сказать есть ли в ее компоненте цикл нечетной длинны.

Стоит учесть что координаты маленькие.
Компонент не более 25e16 / (Pi * R^2)
Допустим можно перебирать компоненту.
Сколько времени нужно на проверку в какой компоненте точка.
Есть оболочка. Верх и низ. Пофиг, допустим (25e16 / (Pi * R^2)) * log.

Если R >= 2e5.
2e6 * log.

Теперь R < 2e5




*/
/*
9 подгруппа - около каждой точки очень мало других.
5 подгруппа - все на линии.
    Храним прыжки в каждую сторону в ближайшую и через одну.


Маленькое r:
  Для каждой точки перебираем все в квадрате r*r и проводим ребра.


Теперь мало соседних точек:
    Как с маленьким r. Перебираем все точки в квадрате.

Так.
Допустим в круге r/2 >= 2 точек.
Тогда цикл найден.

Теперь обратное. Максимум одна.


Если у точки более 5 ребер, то она хорошая.
Т.е. для каждой точки имеет смысл хранить 5 ближайших вершин.

Осталось найти для каждой точки 5 ближайших и решить задачу на таком графе.
(может 6 или 7)

Найти сколько-то ближайших точек.

Допустим mst.
Найти точки входящие в квадрат.
Сколько имеет смысл находить?


Так.
Для каждой еще плохой точки находим все в квадрате r*r.
Смотрим какие в радиусе и проводим ребра.
Строим граф.


*/
/*

*/
