#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define ahalai ios_base::sync_with_stdio(0);
#define mahalai cin.tie(0);
#define ll long long

const int LIM = 7;
const ll MAX_COORD = 500'000'000ll;

int n;
ll R, sqR;
vector<pair<ll, ll>> pts;

ll sqr(ll x) { return x * x; }

struct Node {
	Node* bl = nullptr;
	Node* tr = nullptr;
	int cnt = 0;
	ll l, r, t, b;
	vector<int> cont;
};

void make_children(Node* node) {
	if (node->bl != nullptr) return;
	node->bl = new Node;
	node->tr = new Node;
	node->bl->b = node->b;
	node->bl->l = node->l;
	node->bl->t = node->t;
	node->bl->r = node->r;
	node->tr->b = node->b;
	node->tr->l = node->l;
	node->tr->t = node->t;
	node->tr->r = node->r;
	if (node->r - node->l > node->t - node->b) {
		ll m = (node->l + node->r) >> 1ll;
		node->bl->r = m; node->tr->l = m + 1;
	}
	else {
		ll m = (node->b + node->t) >> 1ll;
		node->bl->t = m; node->tr->b = m + 1;
	}
}

void add_point(Node* node, int point) {
	if (pts[point].first < node->l || pts[point].first > node->r || pts[point].second < node->b || pts[point].second > node->t) return;
	++node->cnt;
	if (node->cont.size() < LIM) node->cont.push_back(point);
	if (node->b < node->t || node->l < node->r) {
		make_children(node);
		add_point(node->bl, point);
		add_point(node->tr, point);
	}
}

vector<int> get_ngh(Node* node, int p, int lim = LIM) {
	vector<int> res;
	if (node->cnt == 0 || lim == 0) return res;
	if (pts[p].first < node->l || pts[p].first > node->r || pts[p].second < node->b || pts[p].second > node->t)
	{
		if ((pts[p].first >= node->l && pts[p].first <= node->r ? 0 : min(sqr(pts[p].first - node->l), sqr(pts[p].first - node->r))) + (pts[p].second >= node->b && pts[p].second <= node->t ? 0 : min(sqr(pts[p].second - node->b), sqr(pts[p].second - node->t))) > sqR) return res;
	}
	else if (node->cnt == 1) return { p };
	if (max(sqr(pts[p].first - node->l), sqr(pts[p].first - node->r)) + max(sqr(pts[p].second - node->b), sqr(pts[p].second - node->t)) <= sqR) {
		for (int q : node->cont) {
			if (lim == 0) return res;
			res.push_back(q); --lim;
		}
		return res;
	}
	for (int q : get_ngh(node->bl, p, lim)) {
		if (lim == 0) return res;
		res.push_back(q); --lim;
	}
	for (int q : get_ngh(node->tr, p, lim)) {
		if (lim == 0) return res;
		res.push_back(q); --lim;
	}
	return res;
}

vector<vector<int>> g;
vector<bool> good;

vector<bool> used;

void make_good(int u) {
	if (used[u]) return;
	good[u] = true;
	used[u] = true;
	for (int v : g[u]) make_good(v);
}

vector<int> color;

bool try_paint(int u, int col = 0) {
	if (color[u] != -1) return false;
	color[u] = col;
	for (int v : g[u]) {
		if (try_paint(v, col ^ 1)) return true;
		if (color[v] == color[u]) { make_good(u); return true; }
	}
	return false;
}

int32_t main()
{
	ahalai mahalai;
	cin >> n >> R;
	sqR = sqr(R);
	Node* root = new Node;
	root->b = 0ll; root->l = 0ll; root->t = MAX_COORD; root->r = MAX_COORD;
	for (int i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		pts.push_back({ x, y });
		add_point(root, i);
	}
	good.assign(n, false);
	used.assign(n, false);
	g.assign(n, vector<int>());
	for (int i = 0; i < n; ++i) {
		vector<int> ngh = get_ngh(root, i);
		if (ngh.size() >= LIM) good[i] = true;
		else for (int v : ngh) {
			if (v == i) continue;
			g[v].push_back(i);
			//g[i].push_back(v);
		}
	}
	color.assign(n, -1);
	for (int u = 0; u < n; ++u) if (good[u]) make_good(u);
	for (int u = 0; u < n; ++u) if (!good[u]) try_paint(u);
	for (int u = 0; u < n; ++u) cout << (good[u] ? 1 : 0);
}
