#include <iostream>
#include <vector>
using namespace std;


struct Fenwick {
    int n, sz;
    vector<int> f;

    explicit Fenwick(int n1) {
        n = n1;
        sz = 0;
        f = vector<int>(n + 1, 0);
    }

    void add(int i) {
        for (; i <= n; i = (i | i - 1) + 1) f[i] ++;
        sz ++;
    }

    int get(int i) {
        int res = 0;
        for (; i > 0; i &= i - 1) res += f[i];
        return res;
    }

    void clear() {
        for (auto& i: f) i = 0;
        sz = 0;
    }
};


int main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& i: a) for (auto& j: i) cin >> j;
    vector<vector<long long>> dp(n + 1, vector<long long>(m + 1, 0));
    vector<vector<long long>> h(n + 1, vector<long long>(m + 1, 0)), v(n + 1, vector<long long>(m + 1, 0));
    Fenwick f0(n * m), f1(n * m);
    for (int i = n - 1; i >= 0; i --) {
        f0.clear(), f1.clear();
        for (int j = m - 1; j >= 0; j --) {
            for (int k = i; k < n; k ++) f0.add(a[k][j]);
            int x = f0.get(a[i][j]) - 1;
            h[i][j] = h[i][j + 1] + x;
            v[i][j] = v[i + 1][j] + x;
            // for (int k = i; k < n; k ++)
            //     for (int l = j; l < m; l ++)
            //         if (a[i][j] > a[k][l]) h[i][j] ++, v[i][j] ++;
            for (int k = i + 1; k < n; k ++) {
                x = f1.get(a[k][j]);
                v[i][j] += x;
                h[i][j] += f1.sz - x;
            }
            // for (int k = j + 1; k < m; k ++)
            //     for (int l = i + 1; l < n; l ++)
            //         if (a[i][k] > a[l][j]) h[i][j] ++;
            //         else v[i][j] ++;
            f1.add(a[i][j]);
        }
    }
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; i --)
        for (int j = m - 1; j >= 0; j --)
            dp[i][j] = min(h[i][j] + dp[i + 1][j], v[i][j] + dp[i][j + 1]);
    cout << dp[0][0] << "\n";
}
