#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

struct Segtree {
    int n;
    vector<int> tree;

    Segtree(int _n) {
        n = _n;
        tree.resize(4 * n + 10, 0);
    }

    void add(int v, int l, int r, int pos, int x) {
        if (l > pos || r <= pos) {
            return;
        }
        if (r - l == 1) {
            tree[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            add(2 * v + 1, l, m, pos, x);
        } else {
            add(2 * v + 2, m, r, pos, x);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) {
            return tree[v];
        }
        if (l >= qr || r <= ql) {
            return 0;
        }
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int> > a(n, vector<int>(m, 0));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }

    vector<int> stolb(m);

    Segtree st(2 * m);

    for (int i = m - 1; i >= 0; i--) {
        stolb[i] += st.get(0, 0, 2 * m, 0, a[0][i]);
        stolb[i] += st.get(0, 0, 2 * m, 0, a[1][i]);
        stolb[i] += (a[0][i] > a[1][i]);
        st.add(0, 0, 2 * m, a[0][i], 1);
        st.add(0, 0, 2 * m, a[1][i], 1);
    }

    vector<int> horiz(m);

    Segtree top(2 * m);
    Segtree bottom(2 * m);

    for (int i = m - 1; i >= 0; i--) {
        horiz[i] += top.get(0, 0, 2 * m, 0, a[0][i]);
        horiz[i] += bottom.get(0, 0, 2 * m, 0, a[0][i]);
        horiz[i] += top.get(0, 0, 2 * m, a[1][i], 2 * m);
        horiz[i] += bottom.get(0, 0, 2 * m, 0, a[1][i]);
        horiz[i] += (a[0][i] > a[1][i]);
        top.add(0, 0, 2 * m, a[0][i], 1);
        bottom.add(0, 0, 2 * m, a[1][i], 1);
    }

    int curr = 0;

    for (int i = 0; i < m; i++) {
        curr += horiz[i];
    }

    int ans = curr;

    for (int i = 0; i < m; i++) {
        curr -= horiz[i];
        curr += stolb[i];
        ans = min(ans, curr);
    }

    cout << ans << endl;
}
