#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

struct Segtree {
    int n;
    vector<pair<int, int> > tree;

    Segtree(int _n) {
        n = _n;
        tree.resize(4 * n + 10, {n + 5, n + 5});
    }

    void set(int v, int l, int r, int pos, pair<int, int> x) {
        if (l > pos || r <= pos) {
            return;
        }
        if (r - l == 1) {
            tree[v] = x;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            set(2 * v + 1, l, m, pos, x);
        } else {
            set(2 * v + 2, m, r, pos, x);
        }
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }

    pair<int, int> get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) {
            return tree[v];
        }
        if (l >= qr || r <= ql) {
            return {n + 5, n + 5};
        }
        int m = (l + r) / 2;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    vector<int> a(n, 0);

    Segtree tree(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        tree.set(0, 0, n, i, {a[i], i});
    }

    vector<int> sufmax(n);

    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            sufmax[i] = a[i];
        } else {
            sufmax[i] = max(sufmax[i + 1], a[i]);
        }
    }

    vector<int> lst(n);

    vector<pair<int, int> > st = {{a[n - 1], n - 1}};

    lst[n - 1] = n - 1;

    for (int i = n - 2; i >= 0; i--) {
        while (st.size() && st.back().ff < a[i]) {
            st.pop_back();
        }
        if (st.size() == 0) {
            lst[i] = n - 1;
        } else {
            lst[i] = st.back().ss - 1;
        }

        st.push_back({a[i], i});
    }

    vector<vector<int> > dt(n);

    vector<pair<int, int> > zprs;

    set<int> ks;

    while (q--) {
        int k, i;
        cin >> k >> i;
        zprs.push_back({k, i});
        ks.insert(k);
    }

    for (auto k: ks) {
        if (k == 1) {
            dt[k - 1] = {n};
            continue;
        }
        dt[k - 1] = {a[0]};
        int ind = 0;
        for (int i = 1; i < k; i++) {
            int l = ind + 1;
            int r = min(lst[ind] + 1, n - k + i);
            if (i != k - 1) {
                int bst = tree.get(0, 0, n, l, r + 1).ss;
                dt[k - 1].push_back(a[bst]);
                ind = bst;
            } else {
                int pos = lst[ind];

                if (pos == n - 1) {
                    dt[k - 1].push_back(a[n - 1]);
                } else {
                    dt[k - 1].push_back(sufmax[pos + 1]);
                }
            }
        }
    }

    for (auto [k, i]: zprs) {
        cout << dt[k - 1][i - 1] << endl;
    }
}
