#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("O3, Ofast")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

// #define int ll

using vi = vector<ll>;
using pii = pair<ll, ll>;
using vv = vector<vi>;
using vp = vector<pii>;
const int maxn = 2e6;

struct node {
    int sm = 0;
    int l = -1, r = -1;
};

node seg[maxn];
int sz = 0;


void make(int v) {
    if (seg[v].l == -1) {
        seg[v].l = sz++;;
    }
    if (seg[v].r == -1) {
        seg[v].r = sz++;;
    }
}

int get(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return seg[v].sm;
    }
    if (r <= tl || tr <= l) {
        return 0;
    }
    make(v);
    int tm = (tl + tr) / 2;
    return get(seg[v].l, tl, tm, l, r) + get(seg[v].r, tm, tr, l, r);
}

int upd(int v, int tl, int tr, int p) {
    if (tr - tl == 1) {
        int nw = sz++;
        seg[nw].sm = 1;
        return nw;
    }
    int tm = (tl + tr) / 2;
    make(v);
    if (p < tm) {
        int nw = sz++;

        seg[nw].l = upd(seg[v].l, tl, tm, p);
        seg[nw].r = seg[v].r;
        seg[nw].sm = seg[seg[nw].l].sm + seg[seg[nw].r].sm;
        return nw;
    } else {
        int nw = sz++;
        seg[nw].r = upd(seg[v].r, tm, tr, p);
        seg[nw].l = seg[v].l;
        seg[nw].sm = seg[seg[nw].l].sm + seg[seg[nw].r].sm;
        return nw;
    }
}

int copy_node(int v) {
    int nw = sz++;
    seg[nw].sm = seg[v].sm;
    seg[nw].l = seg[v].l;
    seg[nw].r = seg[v].r;
    return nw;
}

int f(int x) {
    return x & -x;
}

int get(vi &fen, int i) {
    int an = 0;
    for (; i >= 0; i -= f(i + 1)) {
        an += fen[i];
    }
    return an;
}

void upd(vi &fen, int i) {
    for (; i < fen.size(); i += f(i + 1)) {
        fen[i]++;
    }
}

ll cnt_inv(vi &a) {
    vi fen(a.size());
    vi b = a;
    sort(b.begin(), b.end());
    ll an = 0;
    for (int i = a.size() - 1; i >= 0; --i) {
        int p = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
        an += get(fen, p);
        upd(fen, p);
    }
    return an;
}

void solve() {
    int c, r;
    cin >> r >> c;
    int n = r * c;
    vv a(r, vi(c));
    vi b;
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            a[i][j]--;
            b.push_back(a[i][j]);
        }
    }
    ll inf = 1e18;
    vector<vector<int> > roots(r, vector<int>(c));
    roots[r - 1][c - 1] = sz++;
    roots[r - 1][c - 1] = upd(roots[r - 1][c - 1], 0, n, a[r - 1][c - 1]);
    vv dp(r, vi(c, inf));
    dp[r - 1][c - 1] = 0;
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            if (i == r - 1 && j == c - 1)continue;
            vi v1;
            ll p1 = 0, p2 = 0;
            if (i + 1 != r && j + 1 != c) {
                roots[i][j] = copy_node(roots[i + 1][j + 1]);
            } else {
                roots[i][j] = sz++;
            }
            for (int i1 = i; i1 < r; ++i1) {
                roots[i][j] = upd(roots[i][j], 0, n, a[i1][j]);
                if (j + 1 != c)p1 += get(roots[i][j + 1], 0, n, 0, a[i1][j]);
                v1.push_back(a[i1][j]);
            }
            vi v2;
            for (int j1 = j; j1 < c; ++j1) {
                roots[i][j] = upd(roots[i][j], 0, n, a[i][j1]);
                if (i + 1 != r)p2 += get(roots[i + 1][j], 0, n, 0, a[i][j1]);
                v2.push_back(a[i][j1]);
            }
            p1 += cnt_inv(v1);
            p2 += cnt_inv(v2);
            if (i + 1 != r) {
                dp[i][j] = min(dp[i + 1][j] + p2, dp[i][j]);
            } else {
                dp[i][j] = min(p2, dp[i][j]);
            }
            if (j + 1 != c) {
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + p1);
            } else {
                dp[i][j] = min(dp[i][j], p1);
            }
        }
    }
    cout << dp[0][0];
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int t_ = 1;
    // cin >> t_;
    while (t_--) {
        solve();
    }
}
