#include <bits/stdc++.h>


using namespace std;


using ll = long long;


struct Vector {
    ll x, y;
    Vector() {}
    Vector(ll _x, ll _y) : x(_x), y(_y) {}
    Vector(const Vector &p, const Vector &q) {
        x = q.x - p.x;
        y = q.y - p.y;
    }
};


istream & operator >>(istream &in, Vector &p) {
    in >> p.x >> p.y;
    return in;
}


ostream & operator <<(ostream &os, const Vector &p) {
    os << "{" << p.x << " " << p.y << "}\n";
    return os;
}


ll dist(const Vector &p, const Vector &q) {
    return (q.x - p.x) * (q.x - p.x) + (q.y - p.y) * (q.y - p.y);
}


bool bfs(const vector<Vector> &p, int v, vector<int> &used, int color, ll r, vector<int> &h) {
    bool res = 0;
    used.at(v) = color;
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (int i = 0; i < int(p.size()); i++) {
            if (i != v && dist(p.at(i), p.at(v)) <= r * r) {
                if (used.at(i) == color && abs(h.at(i) - h.at(v)) % 2 == 0) {
                    //cout << v << " " << i << " " << r << " " << dist(p.at(i), p.at(v)) << endl;
                    res = 1;
                }
                if (used.at(i) != color) {
                    h.at(i) = h.at(v) + 1;
                    used.at(i) = color;
                    q.push(i);
                }
            }
        }
    }
    return res;
}


void cover(int pos, vector<int> &res, const vector<pair<ll, int>> &x, ll r) {
    for (int i = pos - 1; i >= 0 && x.at(i + 1).first - x.at(i).first <= r; i--) {
        res.at(x.at(i).second) = 1;
    }
    for (int i = pos + 1; i < int(x.size()) && x.at(i).first - x.at(i - 1).first <= r; i++) {
        res.at(x.at(i).second) = 1;
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll r;
    int n;
    cin >> n >> r;
    vector<Vector> p(n);
    vector<pair<ll, int>> x(n);
    for (int i = 0; i < n; i++) {
        cin >> p.at(i);
        x.at(i).first = p.at(i).x;
        x.at(i).second = i;
    }
    sort(x.begin(), x.end());
    vector<int> res(n, -1);
    for (int i = 0; i < n; i++) {
        if (res.at(x.at(i).second) == -1) {
            auto it = upper_bound(x.begin(), x.end(), make_pair(x.at(i).first + r, -1));
            int pos = int(it - x.begin());
            int len = pos - i;
            int ans;
            if (len >= 2) {
                ans = 1;
                cover(i, res, x, r);
            } else {
                ans = 0;
                res.at(x.at(i).second) = ans;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << res.at(i);
    }
    return 0;
}


/*3 5
5 9
9 6
10 2*/
