#include <bits/stdc++.h>


using namespace std;


using ll = long long;


struct Vector {
    ll x, y;
    Vector() {}
    Vector(ll _x, ll _y) : x(_x), y(_y) {}
    Vector(const Vector &p, const Vector &q) {
        x = q.x - p.x;
        y = q.y - p.y;
    }
    bool operator <(const Vector &other) const {
        return x < other.x || (x == other.x && y < other.y);
    }
};


istream & operator >>(istream &in, Vector &p) {
    in >> p.x >> p.y;
    return in;
}


ostream & operator <<(ostream &os, const Vector &p) {
    os << "{" << p.x << " " << p.y << "}\n";
    return os;
}


ll dist(const Vector &p, const Vector &q) {
    return (q.x - p.x) * (q.x - p.x) + (q.y - p.y) * (q.y - p.y);
}


vector<int> calc(const Vector &p, ll r, map<Vector, int> &dict) {
    vector<int> res;
    for (ll x = p.x - r; x <= p.x + r; x++) {
        for (ll y = p.y - r; y <= p.y + r; y++) {
            Vector q = Vector(x, y);
            if (dist(q, p) <= r * r && dict.find(q) != dict.end()) {
                res.push_back(dict[q]);
            }
        }
    }
    return res;
}


bool bfs(const vector<pair<Vector, int>> &p, int v, vector<int> &used, int color, ll r, vector<int> &h, map<Vector, int> &dict) {
    bool res = 0;
    used.at(v) = color;
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        v = q.front();
        q.pop();
        auto go = calc(p.at(v).first, r, dict);
        for (int to : go) {
            if (to != v) {
                if (used.at(to) == color && abs(h.at(to) - h.at(v)) % 2 == 0) {
                    //cout << v << " " << i << " " << r << " " << dist(p.at(i), p.at(v)) << endl;
                    res = 1;
                }
                if (used.at(to) != color) {
                    h.at(to) = h.at(v) + 1;
                    used.at(to) = color;
                    q.push(to);
                }
            }
        }
    }
    return res;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll r;
    int n;
    cin >> n >> r;
    vector<pair<Vector, int>> p(n);
    map<Vector, int> dict;
    for (int i = 0; i < n; i++) {
        cin >> p.at(i).first;
        p.at(i).second = i;
        dict[p.at(i).first] = i;
    }
    int color = 0;
    vector<bool> good(1);
    vector<int> used(n, -1), h(n, 0);
    for (int i = 0; i < n; i++) {
        if (used.at(i) == -1) {
            good.at(color) = bfs(p, i, used, color, r, h, dict);
            color++;
            good.resize(color + 1, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << int(good.at(used.at(i)));
    }
    return 0;
}


/*3 5
0 0
1 0
2 0*/


/*3 5
5 9
9 6
10 2*/
