#include <bits/stdc++.h>


using namespace std;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


struct segTree {
    vector<int> T;
    segTree(int maxn, const vector<int> &a);
    void build(int v, int tl, int tr, const vector<int> &a);
    int get(int v, int tl, int tr, int ql, int qr);
};


segTree::segTree(int maxn, const vector<int> &a) {
    T.resize(maxn);
    build(0, 0, int(a.size()), a);
}


void segTree::build(int v, int tl, int tr, const vector<int> &a) {
    if (tl + 1 == tr) {
        T.at(v) = a.at(tl);
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm, a);
    build(v * 2 + 2, tm, tr, a);
    T.at(v) = min(T.at(v * 2 + 1), T.at(v * 2 + 2));
}


int segTree::get(int v, int tl, int tr, int ql, int qr) {
    if (ql == tl && tr == qr) {
        return T.at(v);
    }
    int tm = (tl + tr) / 2;
    if (qr <= tm) {
        return get(v * 2 + 1, tl, tm, ql, qr);
    } else if (ql >= tm) {
        return get(v * 2 + 2, tm, tr, ql, qr);
    }
    return min(get(v * 2 + 1, tl, tm, ql, tm), get(v * 2 + 2, tm, tr, tm, qr));
}


vector<int> minn(const vector<int> &a, const vector<int> &b) {
    if (int(a.size()) < int(b.size())) {
        return b;
    } else if (int(b.size()) < int(a.size())) {
        return a;
    }
    return min(a, b);
}


vector<int> upd(vector<int> a, int add) {
    a.push_back(add);
    return a;
}


int func(const vector<int> &a, int k, int pos, int n, const vector<int> &suf) {
    return min(a.at(pos), a.at(pos + 1));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a.at(i);
    }
    a.push_back(n + 1);
    //segTree T(4 * n, a);
    //vector<int> b2 = func(a, 2, n);
    vector<int> suf(n + 2, 0);
    for (int i = n; i >= 1; i--) {
        suf.at(i) = max(suf.at(i + 1), a.at(i));
    }
    for (int i = 0; i < q; i++) {
        int k, pos;
        cin >> k >> pos;
        cout << func(a, k, pos, n, suf) << '\n';
    }
    return 0;
}



/*3 5
0 0
1 0
2 0*/


/*3 5
5 9
9 6
10 2*/
