#include <bits/stdc++.h>


using namespace std;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


struct segTree {
    vector<int> T;
    segTree(int maxn, const vector<int> &a);
    void build(int v, int tl, int tr, const vector<int> &a);
    int get(int v, int tl, int tr, int ql, int qr);
};


segTree::segTree(int maxn, const vector<int> &a) {
    T.resize(maxn);
    build(0, 0, int(a.size()), a);
}


void segTree::build(int v, int tl, int tr, const vector<int> &a) {
    if (tl + 1 == tr) {
        T.at(v) = a.at(tl);
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm, a);
    build(v * 2 + 2, tm, tr, a);
    T.at(v) = max(T.at(v * 2 + 1), T.at(v * 2 + 2));
}


int segTree::get(int v, int tl, int tr, int ql, int qr) {
    if (ql == tl && tr == qr) {
        return T.at(v);
    }
    int tm = (tl + tr) / 2;
    if (qr <= tm) {
        return get(v * 2 + 1, tl, tm, ql, qr);
    } else if (ql >= tm) {
        return get(v * 2 + 2, tm, tr, ql, qr);
    }
    return max(get(v * 2 + 1, tl, tm, ql, tm), get(v * 2 + 2, tm, tr, tm, qr));
}


vector<int> minn(const vector<int> &a, const vector<int> &b) {
    if (int(a.size()) < int(b.size())) {
        return b;
    } else if (int(b.size()) < int(a.size())) {
        return a;
    }
    return min(a, b);
}


vector<int> upd(vector<int> a, int add) {
    a.push_back(add);
    return a;
}


int func(const vector<int> &a, int k, int pos, int n, segTree &T) {
    vector<vector<vector<int>>> dp(k + 1, vector<vector<int>>(n + 1, vector<int>(0)));
    vector<vector<int>> opt(k + 1, vector<int>(n + 2, 0));
    int mx = a.at(1);
    for (int j = 1; j <= n; j++) {
        mx = max(mx, a.at(j));
        dp.at(1).at(j).push_back(mx);
        opt.at(1).at(j) = 0;
    }
    for (int j = 1; j <= k; j++) {
        opt.at(j).at(n + 1) = n;
    }
    for (int i = 2; i <= k; i++) {
        for (int j = n; j >= i; j--) {
            int mx = T.get(0, 0, n + 1, min(opt.at(i).at(j + 1), j), j + 1);
            for (int prev = opt.at(i).at(j + 1); prev >= opt.at(i - 1).at(j); prev--) {
                dp.at(i).at(j) = minn(dp.at(i).at(j), upd(dp.at(i - 1).at(prev), mx));
                if (dp.at(i).at(j) == upd(dp.at(i - 1).at(prev), mx)) {
                    opt.at(i).at(j) = prev;
                }
                mx = max(mx, a.at(prev));
            }
        }
    }
    return dp.at(k).at(n).at(pos - 1);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a.at(i);
    }
    segTree T(4 * n + 4, a);
    for (int i = 0; i < q; i++) {
        int k, pos;
        cin >> k >> pos;
        cout << func(a, k, pos, n, T) << '\n';
    }
    return 0;
}


/*7 1
6 4 2 3 1 7 5
4 2*/


/*7 1
6 4 2 3 1 7 5
1 1
*/
