#include <bits/stdc++.h>


using namespace std;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


struct segTree {
    vector<int> T;
    segTree(int maxn, const vector<int> &a);
    void build(int v, int tl, int tr, const vector<int> &a);
    int get(int v, int tl, int tr, int ql, int qr);
};


segTree::segTree(int maxn, const vector<int> &a) {
    T.resize(maxn);
    build(0, 0, int(a.size()), a);
}


void segTree::build(int v, int tl, int tr, const vector<int> &a) {
    if (tl + 1 == tr) {
        T.at(v) = a.at(tl);
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm, a);
    build(v * 2 + 2, tm, tr, a);
    T.at(v) = min(T.at(v * 2 + 1), T.at(v * 2 + 2));
}


int segTree::get(int v, int tl, int tr, int ql, int qr) {
    if (ql == tl && tr == qr) {
        return T.at(v);
    }
    int tm = (tl + tr) / 2;
    if (qr <= tm) {
        return get(v * 2 + 1, tl, tm, ql, qr);
    } else if (ql >= tm) {
        return get(v * 2 + 2, tm, tr, ql, qr);
    }
    return min(get(v * 2 + 1, tl, tm, ql, tm), get(v * 2 + 2, tm, tr, tm, qr));
}


vector<int> minn(const vector<int> &a, const vector<int> &b) {
    if (int(a.size()) < int(b.size())) {
        return b;
    } else if (int(b.size()) < int(a.size())) {
        return a;
    }
    return min(a, b);
}


vector<int> upd(vector<int> a, int add) {
    a.push_back(add);
    return a;
}


vector<vector<vector<int>>> func(const vector<int> &a, int k, int n) {
    vector<vector<vector<int>>> dp(k + 1, vector<vector<int>>(n + 1, vector<int>(0)));
    vector<vector<bool>> cango(k + 1, vector<bool>(n + 1, 0));
    cango.at(0).at(0) = 1;
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= n; j++) {
            int mx = a.at(j);
            for (int prev = j - 1; prev >= 0; prev--) {
                if (cango.at(i - 1).at(prev)) {
                    dp.at(i).at(j) = minn(dp.at(i).at(j), upd(dp.at(i - 1).at(prev), mx));
                    cango.at(i).at(j) = 1;
                }
                mx = max(mx, a.at(prev));
            }
        }
    }
    return dp;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a.at(i);
    }

    //segTree T(4 * n, a);
    auto dp = func(a, n, n);
    for (int i = 0; i < q; i++) {
        int k, pos;
        cin >> k >> pos;
        cout << dp.at(k).at(n).at(pos - 1) << '\n';
    }
    return 0;
}


/*3 5
0 0
1 0
2 0*/


/*3 5
5 9
9 6
10 2*/
