#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
mt19937 rnd(157);

#define int long long
#define all(a) a.begin(), a.end()

struct segtree {
    vector<int> t;

    segtree (int n) {
        t.resize(4 * n, 0);
    }

    void update(int v, int l, int r, int pos) {
        if (r - l == 1) {
            t[v]++;
            return;
        }
        int m = (r + l) / 2;
        if (pos < m) {
            update(2 * v + 1, l, m, pos);
        } else {
            update(2 * v + 2, m, r, pos);
        }
        t[v]++;
    }

    int getsum(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) {
            return 0;
        }
        if (l >= ql && r <= qr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return getsum(2 * v + 1, l, m, ql, qr) + getsum(2 * v + 2, m, r, ql, qr);
    }
};

vector<int> cntinv(vector<int> a) {
    int n = a.size();
    segtree t(n);
    vector<int> ans(n + 1, 0);
    for (int i = n - 1; i >= 0; --i) {
        ans[i] = ans[i + 1] + t.getsum(0, 0, n, 0, a[i]);
        t.update(0, 0, n, a[i]);
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    auto ans1 = cntinv(a[0]);
    cout << ans1[0];
}