#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
mt19937 rnd(157);

#define int long long
#define all(a) a.begin(), a.end()

int INF = 1e9;

struct segtree {
    vector<int> t;

    segtree (int n) {
        t.resize(4 * n, 0);
    }

    void update(int v, int l, int r, int pos) {
        if (r - l == 1) {
            t[v]++;
            return;
        }
        int m = (r + l) / 2;
        if (pos < m) {
            update(2 * v + 1, l, m, pos);
        } else {
            update(2 * v + 2, m, r, pos);
        }
        t[v]++;
    }

    int getsum(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) {
            return 0;
        }
        if (l >= ql && r <= qr) {
            return t[v];
        }
        int m = (r + l) / 2;
        return getsum(2 * v + 1, l, m, ql, qr) + getsum(2 * v + 2, m, r, ql, qr);
    }
};

// vector<int> cntinv(vector<int> a) {
//     int n = a.size();
//     segtree t(n);
//     vector<int> ans(n + 1, 0);
//     for (int i = n - 1; i >= 0; --i) {
//         ans[i] = ans[i + 1] + t.getsum(0, 0, n, 0, a[i]);
//         t.update(0, 0, n, a[i]);
//     }
//     return ans;
// }

int cntinv(vector<int> a) {
    int n = a.size();
    segtree t(n);
    vector<int> b = a;
    sort(all(b));
    map<int, int> comp;
    for (int i = 0; i < n; i++) {
        comp[b[i]] = i;
    }
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        ans += t.getsum(0, 0, n, 0, comp[a[i]]);
        t.update(0, 0, n, comp[a[i]]);
    }
    return ans;
}



signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));

    vector<vector<int>> b(m, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            b[j][i] = a[i][j];
        }
    }
    // int ans1 = 0;
    //
    // for (int i = 0; i < n; i++) {
    //     ans1 += cntinv(a[i]);
    //
    // }
    // for (int i = 0; i < m; i++) {
    //     ans1 += cntinv(b[i]);
    // }

//    cout << ans1;
    vector<vector<int>> dp(n, vector<int> (m, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i > 0) {
                vector<int> b2;
                for (int i1 = i; i1 < n; i1++) {
                    for (int j1 = j; j1 < m; j1++) {
                        b2.push_back(a[i1][j1]);
                    }
                }
                vector<int> b3 = b2;
                for (int j1 = j; j1 < m; j1++) {
                    b2.push_back(a[i - 1][j1]);
                }
                sort(all(b2));
                map<int, int> comp;
                for (int i2 = 0; i2 < b2.size(); i2++) {
                    comp[b2[i2]] = i2;
                }
                segtree t(b2.size());
                for (int i2 = b3.size() - 1; i2 >= 0; --i2) {
                    t.update(0, 0, b2.size(), comp[b3[i2]]);
                }
                int cntinv1 = 0;
                for (int j1 = m - 1; j1 >= j; --j1) {
                    cntinv1 += t.getsum(0, 0, b2.size(), 0, comp[a[i - 1][j1]]);
                    t.update(0, 0, b2.size(), comp[a[i - 1][j1]]);
                }
                dp[i][j] = dp[i - 1][j] + cntinv1;
            }
            if (j > 0) {
                vector<int> b2;
                for (int i1 = i; i1 < n; i1++) {
                    for (int j1 = j; j1 < m; j1++) {
                        b2.push_back(a[i1][j1]);
                    }
                }
                vector<int> b3 = b2;
                for (int i1 = i; i1 < n; i1++) {
                    b2.push_back(a[i1][j - 1]);
                }
                sort(all(b2));
                map<int, int> comp;
                for (int i2 = 0; i2 < b2.size(); i2++) {
                    comp[b2[i2]] = i2;
                }
                segtree t(b2.size());
                for (int i2 = b3.size() - 1; i2 >= 0; --i2) {
                    t.update(0, 0, b2.size(), comp[b3[i2]]);
                }
                int cntinv1 = 0;
                for (int i1 = n - 1; i1 >= i; --i1) {
                    cntinv1 += t.getsum(0, 0, b2.size(), 0, comp[a[i1][j - 1]]);
                    t.update(0, 0, b2.size(), comp[a[i1][j - 1]]);
                }
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + cntinv1);
            }
        }
    }

    // for (auto el : dp) {
    //     for (auto el2 : el) {
    //         cout << el2 << " ";
    //     }
    //     cout << endl;
    // }
    cout << dp[n - 1][m - 1];
    // int ans2 = INF;
    // for (int i = 0; i < n; i++) {
    //     ans2 = min(ans2, dp[i][m - 1]);
    // }
    // for (int j = 0; j < m; j++) {
    //     ans2 = min(ans2, dp[n - 1][j]);
    // }
    // cout << ans2;
}