#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <vector>
#include <fstream>
#include <string>
#include <cmath>
#include <climits>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct pnt {
	ll x, y;

	pnt() {}

	pnt(ll x, ll y) : x(x), y(y) {}
};

ll dist(pnt a, pnt b) {
	ll x = a.x - b.x;
	ll y = a.y - b.y;
	return x * x + y * y;
}

const int N = 1e5;
int pr[N];
vector<int> cmp[N];
int col[N];
bool odd[N];

int get(int a) {
	return pr[a] == a ? a : get(pr[a]);
}

bool same(int a, int b) {
	a = get(a);
	b = get(b);
	return a == b;
}

void set_odd(int a) {
	a = get(a);
	odd[a] = 1;
}

bool get_odd(int a) {
	a = get(a);
	return odd[a];
}

bool unite(int a, int b) {
	bool same_col = col[a] == col[b];
	a = get(a);
	b = get(b);
	if (a == b)
		return false;
	if (cmp[a].size() < cmp[b].size())
		swap(a, b);
	if (odd[b])
		odd[a] = 1;
	pr[b] = a;
	if (same_col) {
		for (int u : cmp[b])
			col[u] = !col[u];
	}
	for (int u : cmp[b])
		cmp[a].push_back(u);
	cmp[b].clear();
	return true;
}

inline void solve() {
	int n;
	cin >> n;
	ll r;
	cin >> r;
	ll r2 = r * r;
	vector<pnt> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].x >> a[i].y;
	for (int i = 0; i < n; i++) {
		cmp[i].push_back(i);
		pr[i] = i;
	}
	vector<bool> ans(n);
	vector<int> ord(n);
	iota(all(ord), 0);
	sort(all(ord), [&](int i, int j) {
		return a[i].x < a[j].x;
		});
	for (int p = 0; p < n; p++) {
		int i = ord[p];
		if (p && a[ord[p - 1]].x >= a[i].x - r)
			unite(ord[p], ord[p - 1]);
		if (p > 1 && a[ord[p - 2]].x >= a[i].x - r)
			set_odd(i);
	}
	for (int i = 0; i < n; i++)
		cout << get_odd(i);
	cout << '\n';
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << '\n';
#endif
		solve();
	}
	return 0;
}