#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <vector>
#include <fstream>
#include <string>
#include <cmath>
#include <climits>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 3002;

struct query {
	int k, x, i;
};

inline void solve() {
	int n, queries;
	cin >> n >> queries;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	vector<query> q(queries);
	vector<vector<pii>> bucq(n + 1);
	for (int i = 0; i < queries; i++) {
		int k, x;
		cin >> k >> x;
		x--;
		q[i] = { k, x, i };
		bucq[k].push_back({ x, i });
	}
	vector<int> b(2);
	b[0] = a[0];
	b[1] = n;
	vector<int> suf_max(n);
	suf_max[n - 1] = a[n - 1];
	for (int i = n - 2; i > -1; i--)
		suf_max[i] = max(a[i], suf_max[i + 1]);
	for (int i = 1; i < n; i++) {
		if (i == n - 1 || a[i] > a[0])
			break;
		b[1] = min(b[1], suf_max[i + 1]);
	}
	vector<int> ans(queries);
	for (int i = 0; i < queries; i++) {
		ans[q[i].i] = b[q[i].x];
		cout << ans[i] << '\n';
	}
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << '\n';
#endif
		solve();
	}
	return 0;
}