#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <vector>
#include <fstream>
#include <string>
#include <cmath>
#include <climits>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#ifdef _DEBUG
using i128 = long long;
#else
using i128 = __int128;
#endif

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 3e5 + 2;

struct query {
	int k, x, i;
};

deque<int> dp[2][N];

inline void solve() {
	int n, queries;
	cin >> n >> queries;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	vector<query> q(queries);
	vector<vector<pii>> bucq(n + 1);
	vector<int> ans(queries);
	for (int i = 0; i < queries; i++) {
		int k, x;
		cin >> k >> x;
		x--;
		q[i] = { k, x, i };
		bucq[k].push_back({ x, i });
	}
	int mx = 0;
	for (int i = n - 1; i > -1; i--) {
		mx = max(mx, a[i]);
		dp[1][i].push_back(mx);
	}
	for (pii qi : bucq[1])
		ans[qi.second] = dp[1][0][qi.first];
	for (int k = 2; k <= n; k++) {
		for (int i = 0; i <= n; i++) {
			dp[0][i].clear();
			swap(dp[0][i], dp[1][i]);
		}
		vector<int> st, stdp;
		st.push_back(n - k + 1);
		stdp.push_back(n - k + 1);
		for (int i = n - k; i > -1; i--) {
			while (st.size() > 1 && a[st.back()] <= a[i])
				st.pop_back();
			int j = st.back() - 1;
			st.push_back(i);
			int lo = -1, hi = stdp.size();
			while (hi - lo > 1) {
				int mid = (lo + hi) / 2;
				if (stdp[mid] > j + 1)
					lo = mid;
				else
					hi = mid;
			}
			int ptr = hi;
			int from = stdp[ptr];
			dp[1][i] = dp[0][from];
			dp[1][i].push_front(a[i]);
			while (!stdp.empty() && dp[0][i] < dp[0][stdp.back()])
				stdp.pop_back();
			stdp.push_back(i);
		}
		for (pii qi : bucq[k])
			ans[qi.second] = dp[1][0][qi.first];
	}
	for (int i = 0; i < queries; i++)
		cout << ans[i] + 1 << '\n';
}

signed main() {
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << ":" << '\n';
#endif
		solve();
	}
	return 0;
}