#include <bits/extc++.h>

using i64 = long long;

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, r;
    std::cin >> n >> r;
    i64 rr = 1LL * r * r;
    std::vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        std::cin >> x[i] >> y[i];
    }
    auto dist = [&](int i, int j) {
        return 1LL * (x[i] - x[j]) * (x[i] - x[j]) + 1LL * (y[i] - y[j]) * (y[i] - y[j]);
    };
    bool ok = false;
    std::vector<int> vis;
    std::vector<int> col(n, -1);
    __gnu_pbds::gp_hash_table<i64, int> mp;
    const int N = 1E9;
    for (int i = 0; i < n; i++) {
        mp[1LL * x[i] * N + y[i]] = i;
    }
    std::vector<std::pair<int, int>> delta;
    for (int i = -r; i <= r; i++) {
        for (int j = -r; j <= r; j++) {
            if (1LL * i * i + 1LL * j * j <= rr) {
                delta.emplace_back(i, j);
            }
        }
    }
    auto dfs = [&](auto self, int v, int c) -> void {
        col[v] = c;
        vis.emplace_back(v);
        for (auto [dx, dy] : delta) {
            i64 h = 1LL * (x[v] + dx) * N + y[v] + dy;
            if (mp.find(h) == mp.end()) {
                continue;
            }
            int u = mp[h];
            if (dist(v, u) <= rr) {
                if (col[u] == -1) {
                    self(self, u, c ^ 1);
                }
                if (u != v && col[u] == col[v]) {
                    ok = true;
                }
            }
        }
    };
    std::vector<bool> ans(n, false);
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            ok = false;
            vis.clear();
            dfs(dfs, i, 0);
            if (ok) {
                for (int v : vis) {
                    ans[v] = true;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        std::cout << ans[i];
    }
    std::cout << "\n";
}