#include <bits/stdc++.h>

using i64 = long long;

struct Fenwick {
    int n;
    std::vector<int> t;
    Fenwick() {}
    Fenwick(int n) : n(n) {
        t.assign(n + 1, 0);
    }
    int query(int x) {
        int ans = 0;
        for (int i = x; i > 0; i -= i & -i) {
            ans += t[i];
        }
        return ans;
    }
    int query(int l, int r) {
        return query(r) - query(l - 1);
    }
    void modify(int x, int v) {
        for (int i = x; i <= n; i += i & -i) {
            t[i] += v;
        }
    }
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> a(n, std::vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cin >> a[i][j];
        }
    }
    if (n == 1) {
        i64 ans = 0;
        Fenwick fnw(n * m + 1);
        for (int i = 0; i < m; i++) {
            ans += fnw.query(a[0][i], n * m);
            fnw.modify(a[0][i], 1);
        }
        std::cout << ans << "\n";
        return 0;
    }
    std::vector<std::vector<i64>> row(n, std::vector<i64>(m)), col(m, std::vector<i64>(n));
    std::vector<int> ex(n * m + 1);
    for (int i = 0; i < n; i++) {
        ex.assign(n * m + 1, 0);
        row[i][m - 1] = 0;
        ex[a[i][m - 1]] = 1;
        for (int j = m - 2; j > -1; j--) {
            row[i][j] = row[i][j + 1] + std::accumulate(ex.begin(), ex.begin() + a[i][j], 0);
            ex[a[i][j]]++;
        }
    }
    for (int j = 0; j < m; j++) {
        ex.assign(n * m + 1, 0);
        col[j][n - 1] = 0;
        ex[a[n - 1][j]] = 1;
        for (int i = n - 2; i > -1; i--) {
            col[j][i] = col[j][i + 1] + std::accumulate(ex.begin(), ex.begin() + a[i][j], 0);
            ex[a[i][j]]++;
        }
    }
    std::vector<std::vector<i64>> dp(n + 1,std::vector<i64>(m + 1, 1E18));
    std::vector<std::vector<std::vector<int>>> pre(n + 1, std::vector<std::vector<int>>(m + 1, std::vector<int>(n * m + 1, 0)));
    dp[n][m] = 0;
    for (int x = n; x > 0; x--) {
        for (int y = m; y > 0; y--) {
            int rx = n - x + 1;
            int ry = m - y + 1;
            {
                i64 inv = row[rx - 1][ry - 1];
                for (int i = ry - 1; i < m; i++) {
                    inv += pre[x][y][n * m] - pre[x][y][a[rx - 1][i]];
                }
                if (dp[x][y] + inv < dp[x - 1][y]) {
                    dp[x - 1][y] = dp[x][y] + inv;
                    pre[x - 1][y] = pre[x][y];
                    ex.assign(n * m + 1, 0);
                    for (int i = ry - 1; i < m; i++) {
                        ex[a[rx - 1][i]]++;
                    }
                    for (int i = 0; i <= n * m; i++) {
                        if (i > 0) {
                            ex[i] += ex[i - 1];
                        }
                        pre[x - 1][y][i] += ex[i];
                    }
                }
            }
            {
                i64 inv = col[ry - 1][rx - 1];
                for (int i = rx - 1; i < n; i++) {
                    inv += pre[x][y][n * m] - pre[x][y][a[i][ry - 1]];
                }
                if (dp[x][y] + inv < dp[x][y - 1]) {
                    dp[x][y - 1] = dp[x][y] + inv;
                    pre[x][y - 1] = pre[x][y];
                    ex.assign(n * m + 1, 0);
                    for (int i = rx - 1; i < n; i++) {
                        ex[a[i][ry - 1]]++;
                    }
                    for (int i = 0; i <= n * m; i++) {
                        if (i > 0) {
                            ex[i] += ex[i - 1];
                        }
                        pre[x][y - 1][i] += ex[i];
                    }
                }
            }
        }
    }
    i64 ans = 1E18;
    for (int i = 0; i <= n; i++) {
        ans = std::min(ans, dp[i][0]);
    }
    for (int i = 0; i <= m; i++) {
        ans = std::min(ans, dp[0][i]);
    }
    std::cout << ans << "\n";
}