#include <bits/extc++.h>

using i64 = long long;

struct ST {
    int n;
    std::vector<std::vector<int>> t;
    ST() {}
    ST(std::vector<int> a) {
        n = (int) a.size();
        int lg = std::__lg(n) + 1;
        t.assign(lg, std::vector<int>(n));
        for (int i = 0; i < n; i++) {
            t[0][i] = a[i];
        }
        for (int x = 1; x < lg; x++) {
            for (int i = 0; i < n; i++) {
                t[x][i] = std::max(t[x - 1][i], t[x - 1][std::min(n - 1, i + (1 << (x - 1)))]);
            }
        }
    }
    int query(int l, int r) {
        int x = std::__lg(r - l + 1);
        return std::max(t[x][l], t[x][r - (1 << x) + 1]);
    }
};

struct ST2 {
    int n;
    std::vector<std::vector<std::pair<int, int>>> t;
    ST2() {}
    ST2(std::vector<int> a) {
        n = (int) a.size();
        int lg = std::__lg(n) + 1;
        t.assign(lg, std::vector<std::pair<int, int>>(n));
        for (int i = 0; i < n; i++) {
            t[0][i] = {a[i], i};
        }
        for (int x = 1; x < lg; x++) {
            for (int i = 0; i < n; i++) {
                t[x][i] = std::min(t[x - 1][i], t[x - 1][std::min(n - 1, i + (1 << (x - 1)))]);
            }
        }
    }
    int query(int l, int r) {
        int x = std::__lg(r - l + 1);
        return std::min(t[x][l], t[x][r - (1 << x) + 1]).second;
    }
};

std::vector<__gnu_pbds::gp_hash_table<int, int>> solve_smart(int n, std::vector<int> a, std::vector<int> dif) {
    std::vector<int> nxt(n, n + 1);
    ST st(a);
    ST2 st2(a);
    for (int i = 0; i < n; i++) {
        int low = i, high = n;
        while (high - low > 1) {
            int mid = (low + high) / 2;
            if (st.query(i + 1, mid) < a[i]) {
                low = mid;
            } else {
                high = mid;
            }
        }
        nxt[i] = high;
    }
    std::vector<__gnu_pbds::gp_hash_table<int, int>> ans(n + 1);
    for (int k : dif) {
        int l = 0;
        for (int cb = 0; cb < k; cb++) {
            int r = std::min(n + cb - k, nxt[l] - 1);
            if (cb == k - 1) {
                ans[k][cb] = st.query(l, n - 1);
                break;
            }
            if (cb == k - 2) {
                int pp = nxt[l];
                if (pp >= n) {
                    ans[k][cb] = a[l];
                    ans[k][cb + 1] = a[n - 1];
                } else {
                    ans[k][cb] = a[l];
                    ans[k][cb + 1] = st.query(pp, n - 1);
                }
                break;
            }
            int opt = st2.query(l + 1, r + 1);
            ans[k][cb] = a[l];
            l = opt;
        }
    }
    return ans;
}

std::vector<std::vector<int>> solve_stupid(int n, std::vector<int> a) {
    std::vector<std::vector<int>> ans(n + 1);
    for (int msk = 0; msk < (1 << (n - 1)); msk++) {
        std::vector<std::vector<int>> b = {{}};
        for (int i = 0; i < n; i++) {
            b.back().emplace_back(a[i]);
            if (msk & (1 << i)) {
                b.push_back({});
            }
        }
        std::vector<int> d;
        for (auto c : b) {
            int mx = *std::max_element(c.begin(), c.end());
            d.push_back(mx);
        }
        int k = (int) b.size();
        if (ans[k].empty() || d < ans[k]) {
            ans[k] = d;
        }
    }
    return ans;
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, q;
    std::cin >> n >> q;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    std::vector<int> nxt(n, n + 1);
    ST st(a);
    ST2 st2(a);
    for (int i = 0; i < n; i++) {
        int low = i, high = n;
        while (high - low > 1) {
            int mid = (low + high) / 2;
            if (st.query(i + 1, mid) < a[i]) {
                low = mid;
            } else {
                high = mid;
            }
        }
        nxt[i] = high;
    }
    for (int i = 0; i < q; i++) {
        int k, x;
        std::cin >> k >> x;
        x--;
        if (k == 1) {
            std::cout << n << "\n";
            continue;
        }
        if (x + 1 == k) {
            if (k % 2 == 0) {
                std::cout << a[x] << "\n";
            } else {
                std::cout << n / 2 + 1 << "\n";
            }
        } else {
            std::cout << a[x] << "\n";
        }
    }
}