#include <bits/stdc++.h>

using i64 = long long;

std::vector<std::vector<int>> solve_smart(int n, std::vector<int> a) {
    std::vector<int> nxt(n, n + 1);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[j] > a[i]) {
                nxt[i] = j;
                break;
            }
        }
    }
    std::vector<std::vector<int>> ans(n + 1, std::vector<int>(n));
    for (int k = 1; k <= n; k++) {
        int l = 0;
        for (int cb = 0; cb < k; cb++) {
            int r = std::min(n + cb - k, nxt[l] - 1);
            if (cb == k - 1) {
                ans[k][cb] = *std::max_element(a.begin() + l, a.end());
                break;
            }
            if (cb == k - 2) {
                std::set<int> L, R;
                L.insert(a[l]);
                for (int i = l + 1; i < n; i++) {
                    R.insert(a[i]);
                }
                std::pair<int, int> best = {a[l], *(--R.end())};
                for (int i = l + 2; i < n; i++) {
                    L.insert(a[i - 1]);
                    R.erase(a[i - 1]);
                    best = std::min(best, std::make_pair(*(--L.end()), *(--R.end())));
                }
                ans[k][cb] = best.first;
                ans[k][cb + 1] = best.second;
                break;
            }
            int opt = -1;
            for (int i = l + 1; i <= r + 1; i++) {
                if (opt == -1 || a[i] < a[opt]) {
                    opt = i;
                }
            }
            ans[k][cb] = a[l];
            l = opt;
        }
    }
    for (int i = 1; i <= n; i++) {
        ans[i].resize(i);
    }
    return ans;
}

std::vector<std::vector<int>> solve_stupid(int n, std::vector<int> a) {
    std::vector<std::vector<int>> ans(n + 1);
    for (int msk = 0; msk < (1 << (n - 1)); msk++) {
        std::vector<std::vector<int>> b = {{}};
        for (int i = 0; i < n; i++) {
            b.back().emplace_back(a[i]);
            if (msk & (1 << i)) {
                b.push_back({});
            }
        }
        std::vector<int> d;
        for (auto c : b) {
            int mx = *std::max_element(c.begin(), c.end());
            d.push_back(mx);
        }
        int k = (int) b.size();
        if (ans[k].empty() || d < ans[k]) {
            ans[k] = d;
        }
    }
    return ans;
}

std::mt19937 rng(1337);

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    // while (true) {
    //     int n = rng() % 10 + 1;
    //     std::vector<int> a(n);
    //     std::iota(a.begin(), a.end(), 1);
    //     std::shuffle(a.begin(), a.end(), rng);
    //     auto ans_smart = solve_smart(n, a);
    //     auto ans_stupid = solve_stupid(n, a);
    //     for (int k = 1; k <= n; k++) {
    //         for (int x = 0; x < k; x++) {
    //             if (ans_smart[k][x] != ans_stupid[k][x]) {
    //                 std::cout << n << "\n";
    //                 for (int i = 0; i < n; i++) {
    //                     std::cout << a[i] << " \n"[i == n - 1];
    //                 }
    //                 std::cout << k << " " << x << "\n";
    //                 std::cout << ans_smart[k][x] << " " << ans_stupid[k][x] << "\n";
    //                 return 0;
    //             }
    //         }
    //     }
    // }
    int n, q;
    std::cin >> n >> q;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    auto ans = solve_smart(n, a);
    for (int i = 0; i < q; i++) {
        int k, x;
        std::cin >> k >> x;
        x--;
        std::cout << ans[k][x] << "\n";
    }
}