#include <bits/stdc++.h>

using i64 = long long;

struct ST {
    int n;
    std::vector<std::vector<int>> t;
    ST() {}
    ST(std::vector<int> a) {
        n = (int) a.size();
        int lg = std::__lg(n) + 1;
        t.assign(lg, std::vector<int>(n));
        for (int i = 0; i < n; i++) {
            t[0][i] = a[i];
        }
        for (int x = 1; x < lg; x++) {
            for (int i = 0; i < n; i++) {
                t[x][i] = std::max(t[x - 1][i], t[x - 1][std::min(n - 1, i + (1 << (x - 1)))]);
            }
        }
    }
    int query(int l, int r) {
        int x = std::__lg(r - l + 1);
        return std::max(t[x][l], t[x][r - (1 << x) + 1]);
    }
};

std::vector<std::map<int, int>> solve_smart(int n, std::vector<int> a, std::vector<int> dif) {
    std::vector<int> nxt(n, n + 1);
    ST st(a);
    for (int i = 0; i < n; i++) {
        int low = i, high = n;
        while (high - low > 1) {
            int mid = (low + high) / 2;
            if (st.query(i + 1, mid) < a[i]) {
                low = mid;
            } else {
                high = mid;
            }
        }
        nxt[i] = high;
    }
    std::vector<std::map<int, int>> ans(n + 1);
    for (int k : dif) {
        int l = 0;
        for (int cb = 0; cb < k; cb++) {
            int r = std::min(n + cb - k, nxt[l] - 1);
            if (cb == k - 1) {
                ans[k][cb] = *std::max_element(a.begin() + l, a.end());
                break;
            }
            if (cb == k - 2) {
                std::set<int> L, R;
                L.insert(a[l]);
                for (int i = l + 1; i < n; i++) {
                    R.insert(a[i]);
                }
                std::pair<int, int> best = {a[l], *(--R.end())};
                for (int i = l + 2; i < n; i++) {
                    L.insert(a[i - 1]);
                    R.erase(a[i - 1]);
                    best = std::min(best, std::make_pair(*(--L.end()), *(--R.end())));
                }
                ans[k][cb] = best.first;
                ans[k][cb + 1] = best.second;
                break;
            }
            int opt = -1;
            for (int i = l + 1; i <= r + 1; i++) {
                if (opt == -1 || a[i] < a[opt]) {
                    opt = i;
                }
            }
            ans[k][cb] = a[l];
            l = opt;
        }
    }
    return ans;
}

std::mt19937 rng(1337);

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    // while (true) {
    //     int n = rng() % 10 + 1;
    //     std::vector<int> a(n);
    //     std::iota(a.begin(), a.end(), 1);
    //     std::shuffle(a.begin(), a.end(), rng);
    //     auto ans_smart = solve_smart(n, a);
    //     auto ans_stupid = solve_stupid(n, a);
    //     for (int k = 1; k <= n; k++) {
    //         for (int x = 0; x < k; x++) {
    //             if (ans_smart[k][x] != ans_stupid[k][x]) {
    //                 std::cout << n << "\n";
    //                 for (int i = 0; i < n; i++) {
    //                     std::cout << a[i] << " \n"[i == n - 1];
    //                 }
    //                 std::cout << k << " " << x << "\n";
    //                 std::cout << ans_smart[k][x] << " " << ans_stupid[k][x] << "\n";
    //                 return 0;
    //             }
    //         }
    //     }
    // }
    int n, q;
    std::cin >> n >> q;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    std::vector<int> dif;
    std::vector<std::pair<int, int>> qry(q);
    for (int i = 0; i < q; i++) {
        int k, x;
        std::cin >> k >> x;
        x--;
        dif.emplace_back(k);
        qry[i] = {k, x};
    }
    auto ans = solve_smart(n, a, dif);
    for (int i = 0; i < q; i++) {
        auto [k, x] = qry[i];
        std::cout << ans[k][x] << "\n";
    }
}