#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
//#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;
typedef long long ll;

template<typename T> ostream &operator<<(ostream &s,vector<T> v) {
    for(auto i:v) {s<<i<<' ';}
    return s;
}

struct Node {
    int l,r;
    vector<pair<int,int>> inds;
    int mi;
};

struct Pt {
    ll x,y,ind;
};

int tm;
vector<vector<int>> pn;
vector<Node> tree;
Node nw;

#ifdef LOCAL
const int X=100;
#else
const int X=1000000000;
#endif

void push(int v) {
    int mi=tree[v].mi;
    //debug(tree[v].l)
    //debug(tree[v].r)
    while(mi<tree[v].inds.size() && tree[v].inds[mi].first<tm) {mi++;}
    while(mi<tree[v].inds.size()) {tree[tree[v].l].inds.push_back(tree[v].inds[mi]);tree[tree[v].r].inds.push_back(tree[v].inds[mi]);mi++;}
    tree[v].mi=mi;
}


void add(int v,int l,int r,int ql,int qr,int qv,int lm) {
    //debug(v)
    //debug(l)
    //debug(r)
    if(l>=qr || ql>=r) {return;}
    if(l>=ql && r<=qr) {tree[v].inds.emplace_back(lm,qv);return;}
    if(tree[v].l==-1) {tree[v].l=tree.size();tree.push_back(nw);}
    if(tree[v].r==-1) {tree[v].r=tree.size();tree.push_back(nw);}
    push(v);
    int m=(r+l)/2;
    add(tree[v].l,l,m,ql,qr,qv,lm);
    add(tree[v].r,m,r,ql,qr,qv,lm);
}

void cntpn(int v,int l,int r,int qv,int qx) {
    //debug(v)
    //debug(l)
    //debug(r)
    if(l>qx || r<=qx) {return;}
    if(r-l==1) {
        while(tree[v].mi<tree[v].inds.size() && tree[v].inds[tree[v].mi].first<tm) {tree[v].mi++;}
        for(int i=tree[v].mi;i<tree[v].inds.size();i++) {
            pn[qv].push_back(tree[v].inds[i].second);
        }
        return;
    }
    if(tree[v].l==-1) {tree[v].l=tree.size();tree.push_back(nw);}
    if(tree[v].r==-1) {tree[v].r=tree.size();tree.push_back(nw);}
    push(v);
    int m=(r+l)/2;
    cntpn(tree[v].l,l,m,qv,qx);
    cntpn(tree[v].r,m,r,qv,qx);
}

void dfs(int v,vector<Pt> &pt,vector<int> &col,ll r,int mc) {
    for(auto u:pn[v]) {
        if(u==v || (pt[v].x-pt[u].x)*(pt[v].x-pt[u].x)+(pt[v].y-pt[u].y)*(pt[v].y-pt[u].y)>r*r) {continue;}
        if(mc==3) { if(col[u]==3) {continue;} col[u]=3;dfs(u,pt,col,r,3);continue;}
        if(col[u]==-1) {col[u]=3-mc;dfs(u,pt,col,r,3-mc);}
        if(col[u]==col[v] || col[u]==3) {col[v]=3;dfs(v,pt,col,r,3);return;}
    }
}

int main() {
    ll n,r;;
    nw.l=-1; nw.r=-1; nw.mi=0;
    tree.push_back(nw);
    cin>>n>>r;
    vector<Pt> pt(n);
    for(int i=0;i<n;i++) {
        cin>>pt[i].x>>pt[i].y;
        pt[i].ind=i;
    }
    sort(pt.begin(),pt.end(),[](Pt a,Pt b) {return a.x<b.x;});
    int j=0;
    pn.resize(n);
    for(int i=0;i<n;i++) {
        tm=pt[i].x;
        debug(pt[i].x)
        debug(pt[i].y)
        while(j<n && pt[j].x<=pt[i].x+r) {
            debug(pt[j].x)
            debug(pt[j].y)
            add(0,0,X,pt[j].y-r,pt[j].y+r+1,j,pt[j].x+r);
            j++;
        }
        cntpn(0,0,X,i,pt[i].y);
        debug(pn[i])
    }
    vector<int> col(n,-1);
    for(int i=0;i<n;i++) {
        if(col[i]==-1) {col[i]=1;dfs(i,pt,col,r,1);}
    }
    debug(col)
    string ans;
    ans.resize(n);
    for(int i=0;i<n;i++) {
        if(col[i]==3) ans[pt[i].ind]='1';
        else ans[pt[i].ind]='0';
    }
    cout<<ans;
    return 0;
}
