#ifdef LOCAL
#define debug(x) cerr<<"\e[38;5;1m"<<(#x)<<'\t'<<(x)<<"\e[0m"<<endl;
//#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;
typedef long long ll;

template<typename T> ostream &operator<<(ostream &s,vector<T> v) {
    for(auto i:v) {s<<i<<' ';}
    return s;
}

struct Node1 {
    int l,r;
    int cnt;
    int pv;
};

struct Node {
    int l,r;
    vector<pair<int,int>> inds;
    int mi;
};

struct Pt {
    ll x,y,ind;
};

int tm;
vector<vector<int>> pn;
vector<Node> tree;
vector<Node1> tree1;
Node nw;
Node1 nw1;

#ifdef LOCAL
const int X=100;
#else
const int X=1000000000;
#endif

void push1(int v) {
    tree1[tree1[v].l].cnt+=tree1[v].pv;
    tree1[tree1[v].l].pv+=tree1[v].pv;
    tree1[tree1[v].r].cnt+=tree1[v].pv;
    tree1[tree1[v].r].pv+=tree1[v].pv;
    tree1[v].pv=0;
}

void push(int v) {
    int mi=tree[v].mi;
    //debug(tree[v].l)
    //debug(tree[v].r)
    while(mi<tree[v].inds.size() && tree[v].inds[mi].first<tm) {mi++;}
    while(mi<tree[v].inds.size()) {tree[tree[v].l].inds.push_back(tree[v].inds[mi]);tree[tree[v].r].inds.push_back(tree[v].inds[mi]);mi++;}
    tree[v].mi=mi;
}


void add1(int v,int l,int r,int ql,int qr,int qv,int lm,int d) {
    if(l>=qr || ql>=r) {return;}
    if(l>=ql && r<=qr) {tree1[v].cnt+=d;tree1[v].pv+=d;return;}
    if(tree1[v].l==-1) {tree1[v].l=tree1.size();tree1.push_back(nw1);}
    if(tree1[v].r==-1) {tree1[v].r=tree1.size();tree1.push_back(nw1);}
    push1(v);
    int m=(r+l)/2;
    add1(tree1[v].l,l,m,ql,qr,qv,lm,d);
    add1(tree1[v].r,m,r,ql,qr,qv,lm,d);
}

void add(int v,int l,int r,int ql,int qr,int qv,int lm) {
    if(l>=qr || ql>=r) {return;}
    if(l>=ql && r<=qr) {tree[v].inds.emplace_back(lm,qv);return;}
    if(tree[v].l==-1) {tree[v].l=tree.size();tree.push_back(nw);}
    if(tree[v].r==-1) {tree[v].r=tree.size();tree.push_back(nw);}
    push(v);
    int m=(r+l)/2;
    add(tree[v].l,l,m,ql,qr,qv,lm);
    add(tree[v].r,m,r,ql,qr,qv,lm);
}

void cntpn(int v,int l,int r,int qv,int qx) {
    //debug(v)
    //debug(l)
    //debug(r)
    if(l>qx || r<=qx) {return;}
    if(r-l==1) {
        while(tree[v].mi<tree[v].inds.size() && tree[v].inds[tree[v].mi].first<tm) {tree[v].mi++;}
        for(int i=tree[v].mi;i<tree[v].inds.size();i++) {
            pn[qv].push_back(tree[v].inds[i].second);
        }
        return;
    }
    if(tree[v].l==-1) {tree[v].l=tree.size();tree.push_back(nw);}
    if(tree[v].r==-1) {tree[v].r=tree.size();tree.push_back(nw);}
    push(v);
    int m=(r+l)/2;
    cntpn(tree[v].l,l,m,qv,qx);
    cntpn(tree[v].r,m,r,qv,qx);
}

ll cntpn1(int v,int l,int r,int qv,int qx) {
    if(l>qx || r<=qx) {return 0;}
    if(r-l==1) {
        return tree1[v].cnt;
    }
    if(tree1[v].l==-1) {tree1[v].l=tree1.size();tree1.push_back(nw1);}
    if(tree1[v].r==-1) {tree1[v].r=tree1.size();tree1.push_back(nw1);}
    push1(v);
    int m=(r+l)/2;
    return cntpn1(tree1[v].l,l,m,qv,qx)+cntpn1(tree1[v].r,m,r,qv,qx);
}

void dfs(int v,vector<Pt> &pt,vector<int> &col,ll r,int mc) {
    for(auto u:pn[v]) {
        if(u==v || (pt[v].x-pt[u].x)*(pt[v].x-pt[u].x)+(pt[v].y-pt[u].y)*(pt[v].y-pt[u].y)>r*r) {continue;}
        if(mc==3) { if(col[u]==3) {continue;} col[u]=3;dfs(u,pt,col,r,3);continue;}
        if(col[u]==-1) {col[u]=3-mc;dfs(u,pt,col,r,3-mc);}
        if(col[u]==col[v] || col[u]==3) {col[v]=3;dfs(v,pt,col,r,3);return;}
    }
}

int main() {
    ll n,r;
    nw.l=-1; nw.r=-1; nw.mi=0;
    nw1.l=-1;nw1.r=-1;nw1.cnt=0;
    tree.push_back(nw);
    tree1.push_back(nw1);
    cin>>n>>r;
    vector<Pt> pt(n);
    for(int i=0;i<n;i++) {
        cin>>pt[i].x>>pt[i].y;
        pt[i].ind=i;
    }
    sort(pt.begin(),pt.end(),[](Pt a,Pt b) {return a.x<b.x;});
    //for(int i=0;i<n;i++) {
    //    cout<<pt[i].x<<' '<<pt[i].y<<'\n';
    //}
    int j=0,k=0;
    pn.resize(n);
    vector<int> skip(n);
    vector<int> sn(n);
    for(int i=0;i<n;i++) {
        tm=pt[i].x;
        while(j<n && pt[j].x<=pt[i].x+r/2) {
            add1(0,0,X,pt[j].y-r/2,pt[j].y+r/2+1,j,pt[j].x+r/2,1);
            j++;
        }
        while(k<n && pt[k].x<pt[i].x-r/2) {
            add1(0,0,X,pt[k].y-r/2,pt[k].y+r/2+1,k,pt[k].x+r/2,-1);
            k++;
        }
        debug(cntpn1(0,0,X,i,pt[i].y))
        if(cntpn1(0,0,X,i,pt[i].y)>=10) {
            skip[i]=1;
        }
    }
    debug(skip)
    for(auto &i:tree1) {i.cnt=0;i.pv=0;}
    j=0;k=0;
    for(int i=0;i<n;i++) {
        tm=pt[i].x;
        while(j<n && pt[j].x<=pt[i].x+r/2) {
            if(skip[j]) {add1(0,0,X,pt[j].y-r/2,pt[j].y+r/2+1,j,pt[j].x+r/2,1);debug(j)}
            j++;
        }
        while(k<n && pt[k].x<pt[i].x-r/2) {
            if(skip[k]) add1(0,0,X,pt[k].y-r/2,pt[k].y+r/2+1,k,pt[k].x+r/2,-1);
            k++;
        }
        debug(cntpn1(0,0,X,i,pt[i].y))
        if(cntpn1(0,0,X,i,pt[i].y)>0) {
            sn[i]=1;
        }
    }
    debug(sn)
    debug(tree.size())
    j=0;
    for(int i=0;i<n;i++) {
        if(skip[i]) {debug("******************")continue;}
        tm=pt[i].x;
        debug(pt[i].x)
        debug(pt[i].y)
        while(j<n && pt[j].x<=pt[i].x+r) {
            if(skip[j]) {debug("***********************************")j++;continue;}
            debug(pt[j].x)
            debug(pt[j].y)
            add(0,0,X,pt[j].y-r,pt[j].y+r+1,j,pt[j].x+r);
            j++;
        }
        cntpn(0,0,X,i,pt[i].y);
        debug(pn[i])
    }
    vector<int> col(n,-1);
    for(int i=0;i<n;i++) {
        if(sn[i] || skip[i]) {col[i]=3;}
    }
    for(int i=0;i<n;i++) {
        if(col[i]==-1) {col[i]=1;dfs(i,pt,col,r,1);}
    }
    debug(col)
    string ans;
    ans.resize(n);
    for(int i=0;i<n;i++) {
        if(col[i]==3 || skip[i] || sn[i]) ans[pt[i].ind]='1';
        else ans[pt[i].ind]='0';
    }
    cout<<ans;
    return 0;
}
