#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
typedef long long ll;


std::vector<ll> visited(1e5 + 10);
std::vector<ll> colors(1e5 + 10);
std::vector<ll> depth(1e5 + 10);
std::vector< std::pair<ll, ll> > a(1e5 + 10);
std::map< std::pair<ll, ll>, ll > points;
ll n, r;


void dfs(ll v, ll p, ll c) {
    visited[v] = c;
    depth[v] = depth[p] + 1;
    for (ll i = a[v].first - r; i <= a[v].first + r; i++) {
        for (ll j = a[v].second - r; j <= a[v].second + r; j++) {
            ll u = points[{i, j}];

            if (u == 0) continue;
            if (u == v) continue;
            if (u == p) continue;

            if ((a[v].first - a[u].first) * (a[v].first - a[u].first) + (a[v].second - a[u].second) * (a[v].second - a[u].second) > r) {
                continue;
            }

            if (visited[u]) {
                if ((depth[u] + depth[v]) % 2 == 0) {
                    colors[c] = 1;
                }

                continue;
            }

            dfs(u, v, c);
        }
    }
}


int main() {
    std::cin >> n >> r;
    r *= r;
    for (ll i = 1; i <= n; i++) {
       std::cin >> a[i].first >> a[i].second;
       points[a[i]] = i;
    }

    ll c = 1;
    for (ll i = 1; i <= n; i++) {
        if (visited[i]) continue;
        dfs(i, 0, c);
        c++;
    }

    for (ll i = 1; i <= n; i++) {
        std::cout << colors[visited[i]];
    }
}