#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
typedef long long ll;


std::vector<ll> visited(1e5 + 10);
std::vector<ll> colors(1e5 + 10);
std::vector<ll> depth(1e5 + 10);
ll n, r;


int main() {
    std::cin >> n >> r;
    std::vector< std::pair<ll, ll> > a(n + 1);

    std::set< std::pair<ll, std::pair<ll, ll>> > events;
    for (ll i = 1; i <= n; i++) {
       std::cin >> a[i].first >> a[i].second;
       events.insert({a[i].first - r, {-1, i}});
       events.insert({a[i].first, {0, i}});
       events.insert({a[i].first + r, {1, i}});
    }
    events.insert({(ll) 3e9, {-1, 0}});
    
    ll count = 0;
    std::vector<ll> last;
    ll color = 0;
    for (auto [x, p] : events) {
        auto [t, i] = p;
        if (t == -1) {
            if (count == 0) {
                for (auto v : last) {
                    colors[v] = color;
                }
                last.clear();
                color = 0;
            }
            count++;
        } else if (t == 0) {
            if (count >= 3) {
                color = 1;
            }
            last.push_back(i);
        } else if (t == 1) {
            count--;
        }
    }

    for (ll i = 1; i <= n; i++) {
        std::cout << colors[i];
    }
}