#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
typedef long long ll;


std::vector<ll> visited(1e5 + 10);
std::vector<ll> colors(1e5 + 10);
std::vector<ll> depth(1e5 + 10);
ll n, r;


struct Segtree {
    std::vector<int> t;

    Segtree(ll n) {
        t.resize(n * 4 + 10);
    }

    int get(int v, int l, int r, int lq, int rq) {
        if (r <= lq || rq <= l) {
            return 0;
        }

        if (lq <= l && r <= rq) {
            return t[v];
        }

        int mid = (l + r) / 2;
        return get(2 * v + 1, l, mid, lq, rq)
             + get(2 * v + 2, mid, r, lq, rq);
    }

    void update(int v, int l, int r, int i, int x) {
        if (r <= i || i + 1 <= l) {
            return;
        }

        if (l == i && r == i + 1) {
            t[v] += x;
            return;
        }

        int mid = (l + r) / 2;
        update(2 * v + 1, l, mid, i, x);
        update(2 * v + 2, mid, r, i, x);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
};


int main() {
    ll r, c;
    std::cin >> r >> c;
    std::vector< std::vector<ll> > a(r + 1, std::vector<ll>(c + 1));
    
    Segtree seg(r * c + 10);
    int answer = 0;
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++) {
            std::cin >> a[i][j];
            answer += seg.get(0, 0, r * c + 1, a[i][j] + 1, r * c + 1);
            seg.update(0, 0, r * c + 1, a[i][j], 1);
        }
    }
    std::cout << answer;
}