#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
typedef long long ll;


std::vector<ll> visited(1e5 + 10);
std::vector<ll> colors(1e5 + 10);
std::vector<ll> depth(1e5 + 10);
ll n, r;


struct Segtree {
    std::vector<ll> t;

    Segtree(ll n) {
        t.resize(n * 4 + 10);
    }

    ll get(ll v, ll l, ll r, ll lq, ll rq) {
        if (r <= lq || rq <= l) {
            return 0;
        }

        if (lq <= l && r <= rq) {
            return t[v];
        }

        ll mid = (l + r) / 2;
        return get(2 * v + 1, l, mid, lq, rq)
             + get(2 * v + 2, mid, r, lq, rq);
    }

    void update(ll v, ll l, ll r, ll i, ll x) {
        if (r <= i || i + 1 <= l) {
            return;
        }

        if (l == i && r == i + 1) {
            t[v] += x;
            return;
        }

        ll mid = (l + r) / 2;
        update(2 * v + 1, l, mid, i, x);
        update(2 * v + 2, mid, r, i, x);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
};


int main() {
    ll r, c;
    std::cin >> r >> c;
    std::vector< std::vector<ll> > a(r + 1, std::vector<ll>(c + 1));
    
    
    ll answer = 0;
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++) {
            std::cin >> a[i][j];
        }
    }
    
    ll ans = 1e9;
    for (int mask = 0; mask < (1 << 14); mask++) {
        ll s = 0;
        ll l = 0;

        Segtree seg(r * c + 10);

        ll answer = 0;
        for (int k = 0; k < 14; k++) {
            if (mask & (1 << k)) {
                if (s == c) {
                    continue;
                }

                for (ll i = l; i < r; i++) {
                    answer += seg.get(0, 0, r * c + 1, a[i][s] + 1, r * c + 1);
                    seg.update(0, 0, r * c + 1, a[i][s], 1);
                }
                s++;
            } else {
                if (l == r) {
                    continue;
                }

                for (ll j = s; j < c; j++) {
                    answer += seg.get(0, 0, r * c + 1, a[l][j] + 1, r * c + 1);
                    seg.update(0, 0, r * c + 1, a[l][j], 1);
                }
                l++;
            }
        }
        if (l == r || s == c) {
            ans = std::min(answer, ans);
        }
    }
    std::cout << ans;
}