#pragma GCC optimize("O3,unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#pragma GCC target("avx2")
typedef long long ll;


std::vector<ll> visited(1e5 + 10);
std::vector<ll> colors(1e5 + 10);
std::vector<ll> depth(1e5 + 10);
ll n, r;


struct Segtree {
    std::vector<ll> t;

    Segtree(ll n) {
        t.resize(n * 4 + 10);
    }

    ll get(ll v, ll l, ll r, ll lq, ll rq) {
        if (r <= lq || rq <= l) {
            return 0;
        }

        if (lq <= l && r <= rq) {
            return t[v];
        }

        ll mid = (l + r) / 2;
        return get(2 * v + 1, l, mid, lq, rq)
             + get(2 * v + 2, mid, r, lq, rq);
    }

    void update(ll v, ll l, ll r, ll i, ll x) {
        if (r <= i || i + 1 <= l) {
            return;
        }

        if (l == i && r == i + 1) {
            t[v] += x;
            return;
        }

        ll mid = (l + r) / 2;
        update(2 * v + 1, l, mid, i, x);
        update(2 * v + 2, mid, r, i, x);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
};


int main() {
    std::iostream::sync_with_stdio(0);
    std::cin.tie(0);
    
    ll r, c;
    std::cin >> r >> c;
    std::vector< std::vector<ll> > a(r + 1, std::vector<ll>(c + 1)), dp(r + 2, std::vector<ll>(c + 2));
    std::vector< std::vector<Segtree> > dps(r + 2, std::vector<Segtree>(c + 2, Segtree(r * c + 1)));

    for (ll i = 1; i <= r; i++) {
        for (ll j = 1; j <= c; j++) {
            std::cin >> a[i][j];
        }
    }
    
    for (ll i = 1; i <= r + 1; i++) {
        for (ll j = 1; j <= c + 1; j++) {
            if (i == j && i == 1) {
                continue;
            }

            Segtree t1(0), t2(0);
            ll at1 = 1e9;
            ll at2 = 1e9;

            if (i != 1) {
                t1 = dps[i - 1][j];
                at1 = dp[i - 1][j];
                for (ll jj = j; jj <= c; jj++) {
                    at1 += t1.get(0, 0, r * c + 1, a[i - 1][jj] + 1, r * c + 1);
                    t1.update(0, 0, r * c + 1, a[i - 1][jj], 1);
                }
            }

            if (j != 1) {
                t2 = dps[i][j - 1];
                at2 = dp[i][j - 1];
                for (ll ii = i; ii <= r; ii++) {
                    at2 += t2.get(0, 0, r * c + 1, a[ii][j - 1] + 1, r * c + 1);
                    t2.update(0, 0, r * c + 1, a[ii][j - 1], 1);
                }
            }

            if (at1 < at2) {
                dps[i][j] = t1;
                dp[i][j] = at1;
            } else {
                dps[i][j] = t2;
                dp[i][j] = at2;
            }
        }
    }

    std::cout << dp[r + 1][c + 1];
}