#pragma GCC optimize("O3,unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#pragma GCC target("avx2")


struct Segtree {
    std::vector< std::pair<int, int> > t;

    Segtree(std::vector< std::pair<int, int> > &a) {
        t.resize(a.size() * 4 + 10);
        build(0, 0, a.size(), a);
    }

    void build(int v, int l, int r, std::vector< std::pair<int, int> > &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }

        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        t[v] = std::min(t[2 * v + 1], t[2 * v + 2]);
    }

    std::pair<int, int> get(int v, int l, int r, int lq, int rq) {
        if (r <= lq || rq <= l) {
            return {1e9, -1};
        }

        if (lq <= l && r <= rq) {
            return t[v];
        }

        int mid = (l + r) / 2;
        return std::min(get(2 * v + 1, l, mid, lq, rq),
                        get(2 * v + 2, mid, r, lq, rq));
    }
};


int main() {
    std::iostream::sync_with_stdio(0);
    std::cin.tie(0);

    int n, q, count, k, i;
    std::cin >> n >> q;
    std::vector< std::pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i].first;
        a[i].second = i;
    }
    //Segtree seg(a);

    std::vector<int> sufmax(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        sufmax[i] = std::max(a[i].first, sufmax[i + 1]);
    }

    //std::map<int, std::map< int, std::vector<int> >> map;
    //std::vector<int> max_i(n + 1);
    int j = 0;
    //std::vector<int> answers(q);
    while (q--) {
        std::cin >> k >> i;
        
        if (k == 1) {
            std::cout << n << std::endl;
        } else if (k == i) {
            std::cout << sufmax[k] << std::endl;
        } else {
            std::cout << a[i].first << std::endl;
        }
    }

    /*std::vector<int> next(n);
    std::vector< std::pair<int, int> > stack;
    stack.push_back({1e9, n});
    for (int i = n - 1; i >= 0; i--) {
        while (a[i].first > stack.back().first) {
            stack.pop_back();
        }
        next[i] = stack.back().second;
        stack.push_back(a[i]);
    }

    for (auto [k, queries] : map) {
        int end = 0;
        for (int i = 1; i <= max_i[k]; i++) {
            if (k == i) {
                for (auto j : queries[i]) {
                    answers[j] = sufmax[end];
                }
                continue;
            }

            for (auto j : queries[i]) {
                answers[j] = a[end].first;
            }
            int ans1 = a[end].first;

            int l = std::min(next[end] - 1, n - (k - i) - 1);
            
            if (i != k - 1) {
                auto [ans, index] = seg.get(0, 0, n, end + 1, l + 2);
                end = index;
            } else {
                end = l + 1;
            }
        }
    }

    for (auto ans : answers) {
        std::cout << ans << '\n';
    }*/
}