#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>


struct Segtree1 {
    std::vector< std::pair<int, int> > t;

    Segtree1(std::vector< std::pair<int, int> > &a) {
        t.resize(a.size() * 4 + 10);
        build(0, 0, a.size(), a);
    }

    void build(int v, int l, int r, std::vector< std::pair<int, int> > &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }

        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        t[v] = std::min(t[2 * v + 1], t[2 * v + 2]);
    }

    std::pair<int, int> get(int v, int l, int r, int lq, int rq) {
        if (r <= lq || rq <= l) {
            return {1e9, -1};
        }

        if (lq <= l && r <= rq) {
            return t[v];
        }

        int mid = (l + r) / 2;
        return std::min(get(2 * v + 1, l, mid, lq, rq),
                        get(2 * v + 2, mid, r, lq, rq));
    }
};

struct Segtree2 {
    std::vector< std::pair<int, int> > t;

    Segtree2(std::vector< std::pair<int, int> > &a) {
        t.resize(a.size() * 4 + 10);
        build(0, 0, a.size(), a);
    }

    void build(int v, int l, int r, std::vector< std::pair<int, int> > &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }

        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        t[v] = std::max(t[2 * v + 1], t[2 * v + 2]);
    }

    std::pair<int, int> get(int v, int l, int r, int lq, int rq) {
        if (r <= lq || rq <= l) {
            return {-1e9, -1};
        }

        if (lq <= l && r <= rq) {
            return t[v];
        }

        int mid = (l + r) / 2;
        return std::max(get(2 * v + 1, l, mid, lq, rq),
                        get(2 * v + 2, mid, r, lq, rq));
    }
};


int main() {
    int n, q, count, k, i;
    std::cin >> n >> q;
    std::vector< std::pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i].first;
        a[i].second = i;
    }
    Segtree1 seg1(a);
    Segtree2 seg2(a);

    std::map<int, std::map< int, std::vector<int> >> map;
    int j = 0;
    std::vector<int> answers(q);
    while (q--) {
        std::cin >> k >> i;
        map[k][i].push_back(j);
        j++;
    }

    for (auto [k, queries] : map) {
        int end = 0;
        for (int i = 1; i <= k; i++) {
            if (k == i) {
                auto [ans, index] = seg2.get(0, 0, n, end, n);
                for (auto j : queries[i]) {
                    answers[j] = ans;
                }
                continue;
            }

            for (auto j : queries[i]) {
                answers[j] = a[end].first;
            }
            int ans1 = a[end].first;

            int l = end;
            int r = n - (k - i);
            while (r - l > 1) {
                int mid = (l + r) / 2;
                auto [ans, index] = seg2.get(0, 0, n, end, mid + 1);
                if (ans > ans1) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            
            if (i != k - 1) {
                auto [ans, index] = seg1.get(0, 0, n, end + 1, l + 2);
                end = index;
            } else {
                end = l + 1;
            }
        }
    }

    for (auto ans : answers) {
        std::cout << ans << '\n';
    }
}