#include <iostream>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
using namespace std;
//      
struct Segtree {
	int nn; vector <int> t;
	Segtree(int nnn) {
		nn = nnn; t.resize(4 * nn);
	}
	void update(int v, int l, int r, int pos, int delta) {
		if (l == r - 1) {t[v] += delta; return;}
		int med = (l + r) >> 1;
		if (pos < med) {update(2 * v + 1, l, med, pos, delta);}
		else {update(2 * v + 2, med, r, pos, delta);}
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
	void update(int pos, int delta) {
		update(0, 0, nn, pos, delta);
	}
	int get(int v, int l, int r, int ql, int qr) {
		if (ql <= l && r <= qr) {return t[v];}
		if (ql >= r || l >= qr) {return 0;}
		int med = (l + r) >> 1;
		return get(2 * v + 1, l, med, ql, qr) + get(2 * v + 2, med, r, ql, qr);
	}
	int get(int ql, int qr) {
		if (ql > qr) {
			return 0;
		}
		return get(0, 0, nn, ql, qr + 1);
	}
};
vector <long long> colinvsuf(vector <long long> spis) {
	int nn = spis.size();
	set <int> numbers;
	for (auto elem : spis) {
		numbers.insert(elem);
	}
	int ind = -1;
	map <int, int> mp;
	for (auto elem : numbers) {
		ind++; mp[elem] = ind;
	}
	for (int i = 0; i < nn; i++) {
		spis[i] = mp[spis[i]];
	}
	Segtree st(nn);
	long long tek = 0;
	vector <long long> ans(nn);
	for (int i = nn - 1; i >= 0; i--) {
		long long val = st.get(0, spis[i] - 1);
		tek += val; ans[i] = tek;
		st.update(spis[i], 1);
	}
	return ans;
}
long long n, m, inf = 1e17;
vector <vector<long long>> pole;
vector <vector<long long>> dp, colinvstr, colinvstolb;
long long getstr(int i, int j) {
	long long ans = 0;
	vector <long long> spis1, spis2;
	for (int ii = 0; ii < n; ii++) {
		for (int jj = 0; jj < m; jj++) {
			if (ii < i || jj < j) {
				spis1.push_back(pole[ii][jj]);
			}
			else if (ii == i) {
				spis2.push_back(pole[ii][jj]);
			}
		}
	}
	long long siz1 = spis1.size(), siz2 = spis2.size();
	vector <int> cntbigger(n * m);
	for (auto elem : spis1) {
		cntbigger[elem - 1]++;
	}
	for (int i = n * m - 2; i >= 0; i--) {
		cntbigger[i] += cntbigger[i + 1];
	}
	return ans;
}
long long getstolb(int i, int j) {
	long long ans = 0;
	vector <long long> spis1, spis2;
	for (int ii = 0; ii < n; ii++) {
		for (int jj = 0; jj < m; jj++) {
			if (ii < i || jj < j) {
				spis1.push_back(pole[ii][jj]);
			}else if (jj == j) {
				spis2.push_back(pole[ii][jj]);
			}
		}
	}
	long long siz1 = spis1.size(), siz2 = spis2.size();
	vector <int> cntbigger(n * m);
	for (auto elem : spis1) {
		cntbigger[elem - 1]++;
	}
	for (int i = n * m - 2; i >= 0; i--) {
		cntbigger[i] += cntbigger[i + 1];
	}
	return ans;
}
int main() {
	cin >> n >> m;
	pole.resize(n); colinvstr.resize(n); colinvstolb.resize(n);
	for (int i = 0; i < n; i++) {
		colinvstr[i].resize(m); colinvstolb.resize(n);
		pole[i].resize(m);
		for (int j = 0; j < m; j++) {
			cin >> pole[i][j];
		}
	}
	if (n == 1) {
		cout << colinvsuf(pole[0])[0];
	}
	return 0;
}