#include <iostream>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
using namespace std;
//      
struct Segtree {
	int nn; vector <int> t;
	Segtree(int nnn) {
		nn = nnn; t.resize(4 * nn);
	}
	void update(int v, int l, int r, int pos, int delta) {
		if (l == r - 1) {t[v] += delta; return;}
		int med = (l + r) >> 1;
		if (pos < med) {update(2 * v + 1, l, med, pos, delta);}
		else {update(2 * v + 2, med, r, pos, delta);}
		t[v] = t[2 * v + 1] + t[2 * v + 2];
	}
	void update(int pos, int delta) {
		update(0, 0, nn, pos, delta);
	}
	int get(int v, int l, int r, int ql, int qr) {
		if (ql <= l && r <= qr) {return t[v];}
		if (ql >= r || l >= qr) {return 0;}
		int med = (l + r) >> 1;
		return get(2 * v + 1, l, med, ql, qr) + get(2 * v + 2, med, r, ql, qr);
	}
	int get(int ql, int qr) {
		if (ql > qr) {
			return 0;
		}
		return get(0, 0, nn, ql, qr + 1);
	}
};
vector <long long> colinvsuf(vector <long long> spis) {
	int nn = spis.size();
	set <int> numbers;
	for (auto elem : spis) {
		numbers.insert(elem);
	}
	int ind = -1;
	map <int, int> mp;
	for (auto elem : numbers) {
		ind++; mp[elem] = ind;
	}
	for (int i = 0; i < nn; i++) {
		spis[i] = mp[spis[i]];
	}
	Segtree st(nn);
	long long tek = 0;
	vector <long long> ans(nn);
	for (int i = nn - 1; i >= 0; i--) {
		long long val = st.get(0, spis[i] - 1);
		tek += val; ans[i] = tek;
		st.update(spis[i], 1);
	}
	return ans;
}
long long n, m, inf = 1e17;
vector <vector<long long>> pole, getstr, getstolb;
vector <vector<long long>> dp, colinvstr, colinvstolb;
int main() {
	cin >> n >> m;
	pole.resize(n); colinvstr.resize(n); colinvstolb.resize(n); getstr.resize(n); getstolb.resize(n);
	for (int i = 0; i < n; i++) {
		colinvstr[i].resize(m); colinvstolb[i].resize(m);
		pole[i].resize(m); getstr[i].resize(m); getstolb[i].resize(m);
		for (int j = 0; j < m; j++) {
			cin >> pole[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		Segtree st(n * m + 1);
		for (int ii = 0; ii < n; ii++) {
			for (int jj = 0; jj < m; jj++) {
				if (ii < i || jj < m - 1) {
					st.update(pole[ii][jj], 1);
				}
			}
		}
		for (int j = m - 1; j >= 0; j--) {
			for (int jj = j; jj < m; jj++) {
				getstr[i][j] += st.get(pole[i][jj], n * m);
			}
			if (j != 0) {
				for (int ii = i; ii < n; ii++) {
					st.update(pole[ii][j - 1], -1);
				}
			}
		}
	}
	for (int j = 0; j < m; j++) {
		Segtree st(n * m + 1);
		for (int ii = 0; ii < n; ii++) {
			for (int jj = 0; jj < m; jj++) {
				if (ii < n - 1 || jj < j) {
					st.update(pole[ii][jj], 1);
				}
			}
		}
		for (int i = n - 1; i >= 0; i--) {
			for (int ii = i; ii< n; ii++){
				getstolb[i][j] += st.get(pole[ii][j], n * m);
			}
			if (i != 0) {
				for (int jj = j; jj < m; jj++) {
					st.update(pole[i - 1][jj], -1);
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		vector <long long> nums;
		for (int j = 0; j < m; j++) {
			nums.push_back(pole[i][j]);
		}
		vector <long long> res = colinvsuf(nums);
		for (int j = 0; j < m; j++) {
			colinvstr[i][j] = res[j];
		}
	}
	for (int j = 0; j < m; j++) {
		vector <long long> nums;
		for (int i = 0; i < n; i++) {
			nums.push_back(pole[i][j]);
		}
		vector <long long> res = colinvsuf(nums);
		for (int i = 0; i < n; i++) {
			colinvstolb[i][j] = res[i];
		}
	}
	dp.resize(n + 1);
	for (int i = 0; i < n + 1; i++) {
		dp[i].assign(m + 1, inf);
	}
	dp[0][0] = 0;
	for (int i = 0; i <=n; i++) {
		for (int j = 0; j <= m; j++) {
			if (i == 0 && j == 0) {continue;}
			if (i == n && j == m) { continue; }
			int ok1 = 1, ok2 = 1;
			if (i == 0 || j == m) { ok1 = 0; }
			if (j == 0 || i == n) {ok2 = 0;}
			if (ok1 == 1) {
				dp[i][j] = min(dp[i][j], dp[i - 1][j] + getstr[i - 1][j] + colinvstr[i - 1][j]);
			}
			if (ok2 == 1) {
				dp[i][j] = min(dp[i][j], dp[i][j - 1] + getstolb[i][j - 1] + colinvstolb[i][j - 1]);
			}
		}
	}
	long long ans = inf;
	for (int i = 0; i < n + 1; i++) {
		ans = min(ans, dp[i][m]);
	}
	for (int j = 0; j < m + 1; j++) {
		ans = min(ans, dp[n][j]);
	}
	cout << ans;
	return 0;
}