#include <iostream>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
using namespace std;
struct Segtree {
	int nn; vector <pair<int, int>> t;
	Segtree(vector <int> aa) {
		nn = aa.size(); t.resize(4 * nn);
		build(aa, 0, 0, nn);
	}
	void build(vector <int>& a, int v, int l, int r) {
		if (l == r - 1) { t[v].first = l; t[v].second = a[l]; return; }
		int med = (l + r) >> 1;
		build(a, 2 * v + 1, l, med);
		build(a, 2 * v + 2, med, r);
		if (t[2 * v + 1].second < t[2 * v + 2].second) { t[v] = t[2 * v + 1]; }
		else { t[v] = t[2 * v + 2]; }
	}
	pair<int, int> get(int v, int l, int r, int ql, int qr) {
		if (ql <= l && r <= qr) { return t[v]; }
		if (ql >= r || l >= qr) { return make_pair(1000000, 10000000); }
		int med = (l + r) >> 1;
		pair<int, int> res1 = get(2 * v + 1, l, med, ql, qr), res2 = get(2 * v + 2, med, r, ql, qr);
		if (res1.second < res2.second) { return res1; }
		else { return res2; }
	}
	pair<int, int> get(int ql, int qr) { return get(0, 0, nn, ql, qr + 1); }
};
int n, q;
vector <int> a;
vector <int> nextbigger;
vector <int> get(int k, Segtree& st) {
	vector <int> vals;
	int tekpos = 0;
	for (int knum = k; knum >= 2; knum--) {
		if (vals.size() == 3) { return vals; }
		int indlast = min(n - knum, nextbigger[tekpos] - 1);
		if (knum == 2) {
			vals.push_back(a[tekpos]);
			tekpos = indlast + 1;
		}
		else {
			int nexttekpos = st.get(tekpos + 1, indlast + 1).first;
			vals.push_back(a[tekpos]);
			tekpos = nexttekpos;
		}
	}
	int maxval = 0;
	for (int i = tekpos; i <= n - 1; i++) {
		maxval = max(maxval, a[i]);
	}
	vals.push_back(maxval);
	return vals;
}
int main() {
	cin >> n >> q; a.resize(n); nextbigger.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	} a.push_back(1e9 + 7);
	vector <int> stac; stac.push_back(n);
	for (int i = n - 1; i >= 0; i--) {
		while (a[stac.back()] <= a[i]) {
			stac.pop_back();
		}
		nextbigger[i] = stac.back();
		stac.push_back(i);
	}
	a.pop_back();
	Segtree st(a);
	while (q--) {
		int k, i; cin >> k >> i;
		vector <int> res = get(k, st);
		cout << res[i - 1] << "\n";
	}
	return 0;
}