#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <map>

using namespace std;

int n, r;
vector<int> used;
vector<int> d;
vector<bool> a;
vector<pair<int, int>> p;
map<pair<int, int>, vector<int>> comp;

bool check(pair<int, int> p1, pair<int, int> p2) {
    return 1ll*(p1.first - p2.first)*(p1.first - p2.first) + 1ll*(p1.second - p2.second)*(p1.second - p2.second) <= 1ll*r*r;
}

void dfs(int i, int c) {
    if (used[i] != -1) {
        return;
    }
    int x0 = p[i].first/(r/2), y0 = p[i].second/(r/2);
    for (auto j : comp[{x0, y0}]) {
        used[j] = c;
        if (j !=i) {
            d[j] = d[i]+1;
        }
    }
    if (comp[{x0, y0}].size() > 2) {
        a[c] = true;
        return;
    }
    for (int x = x0-2; x <= x0+2; x++) {
        for (int y = y0-2; y <= y0+2; y++) {
            if ((x == x0 && y == y0) || comp.find({x, y}) == comp.end()) {
                continue;
            }
            for (auto j : comp[{x, y}]) {
                if (check(p[i], p[j])) {
                    if (used[j] == -1) {
                        d[j] = d[i]+1;
                        dfs(j, c);
                    }
                    if (used[j] == c && abs(d[j] - d[i])%2 == 0) {
                        a[c] = true;
                    }
                    if (used[j] != -1 && a[used[j]]) {
                        a[c] = true;
                    }
                }
            }
        }
    }
}

vector<int> pr, sz;

int get(int i) {
    if (pr[i] == -1) {
        return i;
    }
    pr[i] = get(pr[i]);
    return get(pr[i]);
}

void merge(int i, int j) {
    if (sz[j] < sz[i]) {
        swap(i, j);
    }
    sz[j] += sz[i];
    pr[get(i)] = get(j);
}

int main () {
    cin >> n >> r;
    used.resize(n, -1);
    d.resize(n);
    a.resize(n);
    map<pair<int, int>, int> m;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        p.push_back({x, y});
        m[p[i]] = i;
    }
    sort(p.begin(), p.end());
    for (int i = 0; i < n; i++) {
        comp[{p[i].first/(r/2), p[i].second/(r/2)}].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        dfs(i, i);
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (a[used[i]]) {
            ans[m[p[i]]] = true;
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << '1';
        } else {
            cout << '0';
        }
    }
    cout << '\n';
    return 0;
}