#include <iostream>
#include <vector>

using namespace std;

vector<pair<int, int>> stree;
int n;

void push(int i, int lc, int rc) {
    if (stree[i].second == 0) {
        return;
    }
    if (lc != rc) {
        stree[2*i+1].second += stree[i].second;
        stree[2*i+2].second += stree[i].second;
    }
    stree[i].first += stree[i].second*(rc-lc+1);
    stree[i].second = 0;
}

int get(int i, int lc, int rc, int l, int r) {
    if (r < lc || rc < l) {
        return 0;
    }
    push(i, lc, rc);
    if (l <= lc && rc <= r) {
        return stree[i].first;
    }
    int m = (lc+rc)/2;
    return get(2*i+1, lc, m, l, r)+get(2*i+2, m+1, rc, l, r);
}

void set(int i, int lc, int rc, int l, int r, int c) {
    if (r < lc || rc < l) {
        return;
    }
    push(i, lc, rc);
    if (l <= lc && rc <= r) {
        stree[i].second += c;
        push(i, lc, rc);
        return;
    }
    int m = (lc+rc)/2;
    set(2*i+1, lc, m, l, r, c);
    set(2*i+2, m+1, rc, l, r, c);
    stree[i].first = stree[2*i+1].first+stree[2*i+2].first;
}

int get(int l, int r) {
    return get(0, 0, n-1, l, r);
}

void set(int l, int r, int c) {
    set(0, 0, n-1, l, r, c);
}

int main() {
    int r, c;
    cin >> r >> c;
    n = r*c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    // 1 - r
    long long ans = 1e18;
    for (long long mask = 0; mask < (1<<(r+c)); mask++) {
        int cnt = 0;
        for (long long i = 0; i < r+c; i++) {
            cnt += (mask>>i)&1ll;
        }
        if (cnt != r) {
            continue;
        }
        long long t = 0;
        vector<int> b;
        int cur = 0;
        for (int i = 0; i < r+c; i++) {
            if ((mask>>i)&1) {
                for (int j = cur; j < c; j++) {
                    b.push_back(a[i-cur][j]);
                }
            } else {
                for (int j = i-cur; j < r; j++) {
                    b.push_back(a[j][cur]);
                }
                cur++;
            }
        }
        stree.assign(4*r*c, {0, 0});
        for (int i = 0; i < n; i++) {
            t += i-get(b[i]-1, b[i]-1);
            set(b[i]-1, n-1, 1);
        }
        ans = min(ans, t);
    }
    cout << ans << endl;
    return 0;
}