#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

int n, r;
vector<int> par, sz;
vector<pii> pts;

int up(int v) {
    if (par[v] == v) return v;
    return par[v] = up(par[v]);
}

void unite(int u, int v) {
    u = up(u), v = up(v);
    if (u == v) return;
    if (sz[u] > sz[v]) swap(u, v);
    par[u] = v;
    sz[v] += sz[u];
}

unordered_map<int, set<pii>> mp[2];
vector<bool> used;

void dfs(int v, int col) {
    used[v] = true;
    auto [x, y] = pts[v];
    vector<tuple<int, int, int>> neighbors;
    for (int dx = -r; dx <= r; ++dx) if (mp[col ^ 1].find(x + dx) != mp[col ^ 1].end()) {
        set<pii> &se = mp[col ^ 1][x + dx];
        auto it = se.lower_bound({y, -1});
        for (auto cur = it; cur != se.end(); ++cur) {
            auto [y1, id] = (*cur);
            //cout << x << "  " << dx << " " << y1 << " " << id << endl;
            if (dx == 0 && y == y1) continue;
            ll dy = y - y1;
            if (dx * dx + dy * dy > r * r)
                break;
            neighbors.push_back({dx, y1, id});
        }
        if (it != se.begin()) {
            auto cur = it;
            --cur;
            for (; ; --cur) {
                if (cur == se.end()) {
                    if (cur == se.begin()) break;
                    continue;
                }
                auto [y1, id] = (*cur);
                //cout << x << "  " << dx << " " << y1 << " " << id << endl;
                if (dx == 0 && y == y1) {
                    if (cur == se.begin()) break;
                    continue;
                }
                ll dy = y - y1;
                if (dx * dx + dy * dy > r * r)
                    break;
                neighbors.push_back({dx, y1, id});
                if (cur == se.begin()) break;
            }
        }
    }
    for (auto [dx, y1, id] : neighbors) {
        mp[col ^ 1][x + dx].erase({y1, id});
        unite(v, id);
    }
    for (auto [dx, y1, id] : neighbors) if (!used[id]){
        dfs(id, 1 - col);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    par.resize(n + n);
    iota(all(par), 0);
    sz.resize(n + n, 1);
    pts.resize(n + n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].first >> pts[i].second;
        pts[i + n] = pts[i];
        mp[0][pts[i].first].insert({pts[i].second, i});
        mp[1][pts[i].first].insert({pts[i].second, i + n});
    }
    used.resize(n + n, false);
    for (int i = 0; i < n; ++i) if (!used[i]) {
        dfs(i, 0);
    }
    for (int i = 0; i < n; ++i) {
        if (up(i) == up(i + n)) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

