#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

int n, r;
vector<int> par, sz;
vector<pii> pts;

int up(int v) {
    if (par[v] == v) return v;
    return par[v] = up(par[v]);
}

void unite(int u, int v) {
    u = up(u), v = up(v);
    if (u == v) return;
    if (sz[u] > sz[v]) swap(u, v);
    par[u] = v;
    sz[v] += sz[u];
}

set<pii> mp[2];
vector<bool> used;

void dfs(int v, int col) {
    used[v] = true;
    auto [x, y] = pts[v];
    vector<pii> neighbors;
    auto it = mp[col ^ 1].lower_bound({x - r, -1});
    for (; it != mp[col ^ 1].end(); ++it) {
        auto [x1, id] = (*it);
        if (x1 <= x + r)
            neighbors.push_back({x1, id});
    }
    for (auto [x1, id] : neighbors) {
        mp[col ^ 1].erase({x1, id});
        unite(v, id);
    }
    for (auto [x1, id] : neighbors) if (!used[id]){
        dfs(id, 1 - col);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> r;
    par.resize(n + n);
    iota(all(par), 0);
    sz.resize(n + n, 1);
    pts.resize(n + n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].first >> pts[i].second;
        pts[i + n] = pts[i];
        mp[0].insert({pts[i].first, i});
        mp[1].insert({pts[i].first, i + n});
    }
    used.resize(n + n, false);
    for (int i = 0; i < n; ++i) if (!used[i]) {
        dfs(i, 0);
    }
    for (int i = 0; i < n; ++i) {
        if (up(i) == up(i + n)) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

