#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e18;

struct Node {
    ll sum = 0;
    ll l = -1, r = -1;
};

vector<Node> t;
vector<vector<ll>> roots;

ll newNode(ll x = -1) {
    if (x == -1) {
        t.emplace_back();
    } else {
        t.push_back(t[x]);
    }
    return t.size() - 1;
}

ll update(ll v, ll l, ll r, ll pos, ll x) {
    //cout << v << endl;
    ll nd = newNode(v);
    if (r - l == 1) {
        t[nd].sum += x;
        return nd;
    }
    ll m = (l + r) / 2;
    if (pos < m)
        t[nd].l = update((v == -1 ? -1 : t[v].l), l, m, pos, x);
    else
        t[nd].r = update((v == -1 ? -1 : t[v].r), m, r, pos, x);
    t[nd].sum = 0;
    if (t[nd].l != -1)
        t[nd].sum += t[t[nd].l].sum;
    if (t[nd].r != -1)
        t[nd].sum += t[t[nd].r].sum;
    return nd;
}

ll query(ll v, ll l, ll r, ll ql, ll qr) {
    if (v == -1) return 0;
    if (l >= qr || r <= ql) return 0;
    if (l >= ql && r <= qr) return t[v].sum;
    ll m = (l + r) / 2;
    return query(t[v].l, l, m, ql, qr) + query(t[v].r, m, r, ql, qr);
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    t.reserve(n * m * 25);
    ll r0 = newNode();
    roots.resize(n, vector<ll>(m));
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    for (ll i = n - 1; i >= 0; --i) {
        for (ll j = m - 1; j >= 0; --j) {
            if (n < m) {
                if (j == m - 1)
                    roots[i][j] = r0;
                else
                    roots[i][j] = roots[i][j + 1];
                for (ll ii = i; ii < n; ++ii) {
                    roots[i][j] = update(roots[i][j], 0, n * m, a[ii][j], 1);
                }
            } else {
                if (i == n - 1)
                    roots[i][j] = r0;
                else
                    roots[i][j] = roots[i + 1][j];
                for (ll jj = j; jj < m; ++jj) {
                    roots[i][j] = update(roots[i][j], 0, n * m, a[i][jj], 1);
                }
            }
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, INF));
    dp[n - 1][m - 1] = 0;
    for (ll i = n - 1; i >= 0; --i) {
        for (ll j = m - 1; j >= 0; --j) {
            if (i < n - 1) {
                ll x = dp[i + 1][j];
                for (ll jj = j; jj < m; ++jj) {
                    x += query(roots[i + 1][j], 0, n * m, 0, a[i][jj]);
                    x += query(roots[i][jj], 0, n * m, 0, a[i][jj]) - query(roots[i + 1][jj], 0, n * m, 0, a[i][jj]);
                }
                dp[i][j] = min(dp[i][j], x);
            }
            if (j < m - 1) {
                ll x = dp[i][j + 1];
                for (ll ii = i; ii < n; ++ii) {
                    x += query(roots[i][j + 1], 0, n * m, 0, a[ii][j]);
                    x += query(roots[ii][j], 0, n * m, 0, a[ii][j]) - query(roots[ii][j + 1], 0, n * m, 0, a[ii][j]);
                }
                dp[i][j] = min(dp[i][j], x);
            }
        }
    }
    cout << dp[0][0];
}

