#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <queue>

using namespace std;

using ll = long long;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl =vector<vl>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

struct Seg {
	struct thing {
		ll val;
	};
	vector <thing> tree;
	ll size = 1;

	Seg(ll _size) {
		while (size < _size) size *= 2;

		tree.assign(size * 2 - 1, { 0 });
	}

	void set(ll ind, ll val) {
		set(ind, val, 0, 0, size);
	}

	void set(ll ind, ll val, ll myind, ll l, ll r) {
		if (r - l == 1) {
			tree[myind].val = val;
			return;
		}

		ll m = l + (r - l) / 2;

		if (ind < m) set(ind, val, myind * 2 + 1, l, m);
		else set(ind, val, myind * 2 + 2, m, r);

		if (tree[myind * 2 + 1].val <= tree[myind * 2 + 2].val) {
			tree[myind] = tree[myind * 2 + 1];
		}
		else {
			tree[myind] = tree[myind * 2 + 2];
		}

		tree[myind].val = tree[myind * 2 + 1].val + tree[myind * 2 + 2].val;
	}

	ll get(ll l, ll r) {
		ll res = get(l, r, 0, 0, size);

		return res;
	}

	ll get(ll ql, ll qr, ll myind, ll l, ll r) {
		if (l >= ql && r <= qr) {
			return tree[myind].val;
		}
		else if (l >= qr || r <= ql) {
			return 0;
		}

		ll m = l + (r - l) / 2;

		ll cu1 = get(ql, qr, myind * 2 + 1, l, m);
		ll cu2 = get(ql, qr, myind * 2 + 2, m, r);

		return cu1 + cu2;
	}
};

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);

	ll n, m;

	cin >> n >> m;

	vvl mas(n, vl(m));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> mas[i][j];
		}
	}

	if (n == 1) {
		vl st = mas[0];

		Seg tree(m + 1);

		ll res = 0;
		for (int i = 0; i < m; i++) {
			res += tree.get(st[i], m + 1);
			tree.set(st[i], 1);
		}

		cout << res << "\n";
	}
}