#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <queue>

using namespace std;

using ll = long long;
using pl = pair<ll, ll>;
using dlle = long double;

using vl = vector<ll>;
using vvl =vector<vl>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vpl = vector<pl>;
using vvpl = vector<vpl>;

ll INF = 9e18;

struct Seg {
	struct thing {
		ll val, ind;
	};
	vector <thing> tree;
	vl mxtree;
	ll size = 1;

	Seg(ll _size) {
		while (size < _size) size *= 2;

		tree.assign(size * 2 - 1, {INF, -1});
		mxtree.assign(size * 2 - 1, -INF);
	}

	void set(ll ind, ll val) {
		set(ind, val, 0, 0, size);
	}

	void set(ll ind, ll val, ll myind, ll l, ll r) {
		if (r - l == 1) {
			tree[myind].ind = ind;
			tree[myind].val = val;
			mxtree[myind] = val;
			return;
		}

		ll m = l + (r - l) / 2;

		if (ind < m) set(ind, val, myind * 2 + 1, l, m);
		else set(ind, val, myind * 2 + 2, m, r);

		if (tree[myind * 2 + 1].val <= tree[myind * 2 + 2].val) {
			tree[myind] = tree[myind * 2 + 1];
		}
		else {
			tree[myind] = tree[myind * 2 + 2];
		}

		mxtree[myind] = max(mxtree[myind * 2 + 1], mxtree[myind * 2 + 2]);
	}

	ll getmin(ll l, ll r) {
		pl res = getmin(l, r, 0, 0, size);

		return res.second;
	}

	pl getmin(ll ql, ll qr, ll myind, ll l, ll r) {
		if (l >= ql && r <= qr) {
			return { tree[myind].val, tree[myind].ind };
		}
		else if (l >= qr || r <= ql) {
			return { INF, -1 };
		}

		ll m = l + (r - l) / 2;

		pl cu1 = getmin(ql, qr, myind * 2 + 1, l, m);
		pl cu2 = getmin(ql, qr, myind * 2 + 2, m, r);

		if (cu1.first <= cu2.first) return cu1;
		else return cu2;
	}

	ll rightk(ll k, ll l, ll r) {
		return rightk(k, l, r, 0, 0, size);
	}

	ll rightk(ll k, ll ql, ll qr, ll myind, ll l, ll r) {
		if (mxtree[myind] < k || l >= qr || r <= ql) return -1;
		if (r - l == 1) {
			return tree[myind].ind;
		}

		ll m = l + (r - l) / 2;

		ll cu1 = rightk(k, ql, qr, myind * 2 + 1, l, m);
		if (cu1 != -1) return cu1;
		ll cu2 = rightk(k, ql, qr, myind * 2 + 2, m, r);
		return cu2;
	}
};

int main() {
	cin.sync_with_stdio(false);
	cin.tie(0);

	ll n, q;

	cin >> n >> q;

	vl mas(n);

	for (int i = 0; i < n; i++) cin >> mas[i];

	struct thing {
		ll k, i, indzap;
	};

	vl resst(q);
	vector <thing> zap(q);

	for (int i = 0; i < q; i++) {
		cin >> zap[i].k >> zap[i].i;
		--zap[i].i;
		zap[i].indzap = i;
	}

	Seg tree(n);

	for (int i = 0; i < n; i++) {
		tree.set(i, mas[i]);
	}

	sort(zap.begin(), zap.end(), [](thing a, thing b) {
		return a.k < b.k;
	});

	vl st;
	for (int i = 0; i < q; i++) {
		if (i == 0 || zap[i].k != zap[i - 1].k) {
			st.clear();
			ll k = zap[i].k;

			if (k == 1) {
				ll a = 0;
				for (int i = 0; i < n; i++) {
					a = max(a, mas[i]);
				}

				st.push_back(a);
			}
			else {
				ll a = mas[0];
				st.push_back(a);
				ll l = 1;
				for (int i = 1; i < k - 1; i++) {
					ll r = tree.rightk(a, l, n - (k - i - 1));

					if (r == -1) {
						r = n - (k - i - 1);
					}
					else {
						++r;
					}

					ll indmn = tree.getmin(l, r);

					l = indmn + 1;
					a = mas[indmn];
					st.push_back(a);
				}

				ll lasta = a;
				bool flag = 1;
				a = 0;
				for (int j = l; j < n; j++) {
					if (mas[j] > a) {
						flag = 0;
					}
					if (j != n - 1 && flag) continue;

					a = max(a, mas[j]);
				}

				st.push_back(a);
			}
		}

		resst[zap[i].indzap] = st[zap[i].i];
	}

	for (auto now : resst) {
		cout << now << "\n";
	}
}
