#include <bits/stdc++.h>
using namespace std;

struct SegmentTree {
    vector<int> t;
    int SZ = 1, origN;
    vector<int> changedNodes;
    bool saveChanges = false;
    SegmentTree(int n, bool fastClearMode = false) {
        origN = n;
        saveChanges = fastClearMode;
        while (SZ < n) {
            SZ *= 2;
        }
        t.resize(2 * SZ);
    }
    void add(int i, int x) {
        int l = 0, r = SZ, v = 0;
        while (r - l > 1) {
            t[v] += x;
            if (saveChanges) {
                changedNodes.push_back(v);
            }
            int m = (l + r) / 2;
            if (i < m) {
                v = v * 2 + 1;
                r = m;
            } else {
                v = v * 2 + 2;
                l = m;
            }
        }
        if (saveChanges) {
            changedNodes.push_back(v);
        }
        t[v] += x;
    }
    int get(int l, int r) {
        if (l == 0) {
            return get(0, 0, SZ, r);
        }
        if (r >= origN) {
            return t[0] - get(0, 0, SZ, l);
        }
        return get(0, 0, SZ, r) - get(0, 0, SZ, l);
    }
    int get(int v, int l, int r, int i) {
        if (r <= i) {
            return t[v];
        } else if (l >= i) {
            return 0;
        } else {
            int m = (l + r) / 2;
            return get(v * 2 + 1, l, m, i) + get(v * 2 + 2, m, r, i);
        }
    }
    void clear() {
        if (saveChanges) {
            for (int v : changedNodes) {
                t[v] = 0;
            }
            changedNodes.clear();
        } else {
            t.assign(2 * SZ, 0);
            cerr << "Warning! Clearing not in fast clear mode.\n";
        }
    }
};

using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    SegmentTree tmp{n * m, true};
    ll cur = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cur += tmp.get(a[i][j], n * m);
            tmp.add(a[i][j], 1);
        }
    }
    if (n == 1) {
        cout << cur << "\n";
        return 0;
    }
    // n == 2
    ll ans = cur;
    SegmentTree cols{n * m}, ln1{n * m}, ln2{n * m};
    for (int j = 0; j < m; ++j) {
        ln1.add(a[0][j], 1);
        ln2.add(a[1][j], 1);
    }
    for (int j = 0; j < m; ++j) {
        ln1.add(a[0][j], -1);
        ln2.add(a[1][j], -1);
        cur -= ln1.get(0, a[0][j]);
        cur -= ln2.get(0, a[1][j]);
        cur -= ln2.get(0, a[0][j]);
        cur -= cols.get(a[0][j], n * m);
        cur -= cols.get(a[1][j], n * m);
        
        cur += ln1.get(a[0][j], n * m);
        ln1.add(a[0][j], 1);
        cur += ln2.get(a[1][j], n * m);
        ln2.add(a[1][j], 1);
        cur += ln1.get(0, a[0][j]);
        cur += ln2.get(0, a[0][j]);
        cur += ln1.get(0, a[1][j]);
        cur += ln2.get(0, a[1][j]);
        ans = min(ans, cur);
    }
    cout << ans << "\n";
}