#include <bits/stdc++.h>
using namespace std;

struct SparseTable {
    vector<vector<pair<int, int>>> sp;
    int N = 2, LG = 1;
    SparseTable(vector<pair<int, int>> &a) {
        while (N < (int) a.size()) {
            LG++;
            N *= 2;
        }
        a.resize(N, {-1, -1});
        sp.resize(LG + 1, vector<pair<int, int>>(N));
        for (int i = 0; i < LG; ++i) {
            for (int j = 0; j + (1 << (i + 1)) <= N; ++j) {
                sp[i + 1][j] = max(sp[i][j], sp[i][j + (1 << i)]);
            }
        }
    }
    pair<int, int> get(int l, int r) {
        int i = __lg(r - l);
        return max(sp[i][l], sp[i][r - (1 << i)]);
    }
};

int main() {
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    SparseTable st{a};
    map<int, vector<int>> memory;
    for (int tt = 0; tt < q; +tt) {
        int k, pos;
        cin >> k >> pos;
        pos--;
        if (memory.find(k) != memory.end()) {
            cout << memory[k][pos] << "\n";
            continue;
        }
        int i = 0;
        vector<int> res(k);
        for (int d = 0; d < k; ++d) {
            auto [ai, j] = st.get(i, n - k + d + 1);
            i = j;
            res[d] = ai;
        }
        memory[k] = res;
        cout << res[pos] << "\n";
    }
}