#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct Vec {
    ll x, y;

    Vec() {}
    Vec(ll x, ll y): x(x), y(y) {}

    ll sz() { return x * x + y * y; }

    Vec operator-(Vec v) { return Vec(x - v.x, y - v.y); }
};

ll n, r;
vector<ll> used;
vector<Vec> pnts;

void dfs(ll v, vector<ll> &lst) {
    lst.emplace_back(v);

    for (ll u = 0; u < n; u++) {
        if (v == u || (pnts[v] - pnts[u]).sz() > r * r || used[u]) continue;
        
        used[u] = 3 - used[v];
        dfs(u, lst);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> r;

    pnts.resize(n);
    used.resize(n);

    for (ll i = 0; i < n; i++) cin >> pnts[i].x >> pnts[i].y;

    vector<ll> ans(n);

    for (ll i = 0; i < n; i++) {
        if (used[i]) continue;

        used[i] = 1;
        vector<ll> lst;
        dfs(i, lst);

        bool ok = false;
        for (auto v : lst) {
            for (ll u = 0; u < n; u++) {
                if (v == u || (pnts[v] - pnts[u]).sz() > r * r) continue;
                if (used[v] == used[u]) {
                    ok = true;
                    break;
                }
            }
            if (ok) break;
        }

        if (ok) {
            for (auto v : lst) {
                ans[v] = true;
            }
        }
    }

    for (auto i : ans) cout << i;
    cout << endl;
}
