#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct Vec {
    ll x, y, id;

    Vec() {}
    Vec(ll x, ll y, ll id): x(x), y(y), id(id) {}

    ll sz() { return x * x + y * y; }

    Vec operator-(Vec v) { return Vec(x - v.x, y - v.y, -1); }
};

ll n, r;
vector<ll> used;
vector<Vec> pnts;

bool dfs(ll v, vector<ll> &lst) {
    lst.emplace_back(v);

    bool ok = false;
    for (ll u = 0; u < n; u++) {
        if (v == u || (pnts[v] - pnts[u]).sz() > r * r) continue;
        if (used[u]) {
            if (used[v] == used[u]) {
                ok = true;
            }
            continue;
        }
        
        used[u] = 3 - used[v];
        if (dfs(u, lst)) {
            ok = true;
        }
    }

    return ok;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> r;

    pnts.resize(n);
    used.resize(n);

    for (ll i = 0; i < n; i++) {
        cin >> pnts[i].x >> pnts[i].y;
        pnts[i].id = i;
    }

    vector<ll> ans(n), cmp(n);

    sort(all(pnts), [](Vec a, Vec b) {
        return a.x < b.x;
    });

    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (i && pnts[i].x - pnts[i - 1].x > r) cnt++;
        cmp[i] = cnt;
    }

    vector<ll> good(n);
    for (int i = 0; i + 2 < n; i++) {
        if (pnts[i + 2].x - pnts[i].x <= r) {
            good[cmp[i]] = true;
        }
    }

    for (int i = 0; i < n; i++) {
        ans[pnts[i].id] = good[cmp[i]];
    }

    debug(cmp);

    // for (ll i = 0; i < n; i++) {
    //     if (used[i]) continue;

    //     used[i] = 1;
    //     vector<ll> lst;
    //     bool ok = dfs(i, lst);

    //     if (ok) {
    //         for (auto v : lst) {
    //             ans[v] = true;
    //         }
    //     }
    // }

    for (auto i : ans) cout << i;
    cout << endl;
}
