#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const ll INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct Vec {
    ll x, y, id;

    Vec() {}
    Vec(ll x, ll y, ll id): x(x), y(y), id(id) {}

    ll sz() { return x * x + y * y; }

    Vec operator-(Vec v) { return Vec(x - v.x, y - v.y, -1); }
};

ll n, r;
vector<ll> used;
vector<Vec> pnts;
vector<vector<ll>> g;

bool dfs(ll v, vector<ll> &lst) {
    lst.emplace_back(v);

    bool ok = false;
    for (auto u : g[v]) {
        if (used[u]) {
            if (used[v] == used[u]) {
                ok = true;
            }
            continue;
        }

        used[u] = 3 - used[v];
        if (dfs(u, lst)) {
            ok = true;
        }
    }

    return ok;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> r;

    g.resize(n);
    pnts.resize(n);
    used.resize(n);

    for (ll i = 0; i < n; i++) {
        cin >> pnts[i].x >> pnts[i].y;
        pnts[i].id = i;
    }

    sort(all(pnts), [](Vec a, Vec b) {
        return a.x < b.x || (a.x == b.x && a.y < b.y);
    });

    map<ll, vector<pair<ll, ll>>> dct;
    for (auto &[x, y, id] : pnts) {
        dct[x].emplace_back(y, id);
    }

    vector<ll> ans(n);
    for (ll i = 0; i < n; i++) {
        for (ll x = pnts[i].x - r; x <= pnts[i].x + r; x++) {
            ll dx = abs(x - pnts[i].x), dy = sqrt(r * r - dx * dx);
            auto itl = lower_bound(all(dct[x]), make_pair(pnts[i].y - dy, 0ll));
            auto itr = upper_bound(all(dct[x]), make_pair(pnts[i].y + dy, INF));
            for (; itl != itr; itl++) {
                if (pnts[i].id == itl->second) continue;
                g[pnts[i].id].emplace_back(itl->second);
            }
        }
    }

    // for (ll i = 0; i < n; i++) {
    //     cout << i << ": " << g[i] << endl;
    // }

    for (ll i = 0; i < n; i++) {
        if (used[i]) continue;

        used[i] = 1;
        vector<ll> lst;
        bool ok = dfs(i, lst);

        if (ok) {
            for (auto v : lst) {
                ans[v] = true;
            }
        }
    }

    for (auto i : ans) cout << i;
    cout << endl;
}
