#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int r, c; cin >> r >> c;

    vector<vector<int>> lst(r, vector<int>(c));

    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> lst[i][j];
        }
    }

    vector<vector<int>> right(r, vector<int>(c)), down(r, vector<int>(c));
    
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            vector<int> cur;
            for (int k = j; k < c; k++) {
                cur.emplace_back(lst[i][k]);
            }

            for (int k = 0; k < len(cur); k++) {
                for (int p = k + 1; p < len(cur); p++) {
                    if (cur[k] > cur[p]) {
                        right[i][j]++;
                    }
                }
            }

            for (int k = i + 1; k < r; k++) {
                for (int p = j; p < c; p++) {
                    for (auto el : cur) {
                        if (el > lst[k][p]) {
                            right[i][j]++;
                        }
                    }
                }
            }
        }
    }

    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            vector<int> cur;
            for (int k = i; k < r; k++) {
                cur.emplace_back(lst[k][j]);
            }

            for (int k = 0; k < len(cur); k++) {
                for (int p = k + 1; p < len(cur); p++) {
                    if (cur[k] > cur[p]) {
                        down[i][j]++;
                    }
                }
            }

            for (int k = i; k < r; k++) {
                for (int p = j + 1; p < c; p++) {
                    for (auto el : cur) {
                        if (el > lst[k][p]) {
                            down[i][j]++;
                        }
                    }
                }
            }
        }
    }

    vector<vector<int>> dp(r, vector<int>(c, INF));
    dp[r - 1][c - 1] = 0;
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            if (i + 1 < r) {
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + right[i][j]);
            }
            if (j + 1 < c) {
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + down[i][j]);
            }
        }
    }

    cout << dp[0][0] << endl;
}
