#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const int INF = 1e9 + 7;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

struct SegTree {
    int h = 0;
    vector<int> tree;

    SegTree(int n) {
        while (1 << h < n) h++;
        tree.assign(1 << (h + 1), 0);
    }

    void update(int ind, int l, int r, int qi, int qx) {
        if (r - l == 1) {
            tree[ind] = qx;
            return;
        }

        int m = (l + r) / 2;
        if (qi < m) {
            update(ind * 2, l, m, qi, qx);
        } else {
            update(ind * 2 + 1, m, r, qi, qx);
        }

        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
    }

    void update(int qi, int qx) {
        update(1, 1, (1 << h) + 1, qi, qx);
    }

    int query(int ind, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) return tree[ind];
        if (qr <= l || r <= ql) return 0;

        int m = (l + r) / 2;
        return query(ind * 2, l, m, ql, qr) + query(ind * 2 + 1, m, r, ql, qr);
    }

    int query(int ql, int qr) {
        return query(1, 1, (1 << h) + 1, ql, qr);
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int r, c; cin >> r >> c;

    vector<vector<int>> lst(r, vector<int>(c));

    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> lst[i][j];
        }
    }

    vector<vector<int>> right(r, vector<int>(c)), down(r, vector<int>(c));

    for (int p = 0; p < c; p++) {
        SegTree tree(r * c);
        for (int i = r - 1; i >= 0; i--) {
            for (int j = c - 1; j >= p; j--) {
                right[i][p] += tree.query(1, lst[i][j]);
                tree.update(lst[i][j], 1);
            }
        }
    }

    for (int p = 0; p < r; p++) {
        SegTree tree(r * c);
        for (int j = c - 1; j >= 0; j--) {
            for (int i = r - 1; i >= p; i--) {
                down[p][j] += tree.query(1, lst[i][j]);
                tree.update(lst[i][j], 1);
            }
        }
    }

    vector<vector<int>> dp(r, vector<int>(c, INF));
    dp[r - 1][c - 1] = 0;
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            if (i + 1 < r) {
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + right[i][j]);
            }
            if (j + 1 < c) {
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + down[i][j]);
            }
        }
    }

    cout << dp[0][0] << endl;
}
