#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define len(x) ((int)(x.size()))
#define endl '\n'
#ifdef LOCAL
    #define debug(x) cout << (#x) << " = " << x << endl;
#else
    #define debug(x)
#endif

using namespace std;
using ll = long long;

const int INF = 1e9 + 7, MAXN = 160000 + 1;

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << " ";
    return out;
}

int f[MAXN];

void update(int i, int x) {
    for (; i < MAXN; i += i & -i) f[i] += x;
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= i & -i) res += f[i];
    return res;
}

int query(int ql, int qr) {
    return get(qr) - get(ql - 1);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int r, c; cin >> r >> c;

    vector<vector<int>> lst(r, vector<int>(c));

    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> lst[i][j];
        }
    }

    vector<vector<int>> right(r, vector<int>(c)), down(r, vector<int>(c));

    for (int p = 0; p < c; p++) {
        fill(f, f + MAXN, 0);
        for (int i = r - 1; i >= 0; i--) {
            for (int j = c - 1; j >= p; j--) {
                right[i][p] += query(1, lst[i][j]);
                update(lst[i][j], 1);
            }
        }
    }

    for (int p = 0; p < r; p++) {
        fill(f, f + MAXN, 0);
        for (int j = c - 1; j >= 0; j--) {
            for (int i = r - 1; i >= p; i--) {
                down[p][j] += query(1, lst[i][j]);
                update(lst[i][j], 1);
            }
        }
    }

    vector<vector<int>> dp(r, vector<int>(c, INF));
    dp[r - 1][c - 1] = 0;
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            if (i + 1 < r) {
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + right[i][j]);
            }
            if (j + 1 < c) {
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + down[i][j]);
            }
        }
    }

    cout << dp[0][0] << endl;
}
