#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(),v.end()

inline ll dist2(const pii &a, const pii &b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

const int maxn = 1e5 + 1;
int color[maxn];
bool can[maxn];
bool used[maxn];

mt19937 rnd(52525252);
vector<vector<int> > g;

inline void dfs(int v) {
    can[v] = 1;
    used[v] = 1;
    for (auto const elem: g[v]) {
        if (!used[elem]) {
            dfs(elem);
            can[elem] = 1;
        }
    }
}

inline bool dfs_col(int v, int col) {
    color[v] = col;
    bool ret = 1;
    for (auto const elem: g[v]) {
        if (color[elem] == -1) {
            ret &= dfs_col(elem, (col + 1) & 1);
            if (!ret) {
                return false;
            }
        } else if (color[elem] == col) {
            return false;
        }
    }
    return ret;
}

signed main() {
    for (int &elem: color)
        elem = -1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    g.resize(n);
    ll r2 = 1ll * r * r;
    vector<pair<pii, int> > a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    shuffle(all(a), rnd);
    for (auto i = 0; i < n; ++i) {
        for (auto j = i + 1; j < n; ++j) {
            if (dist2(a[i].first, a[j].first) <= r2) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (!dfs_col(i, 0)) {
                dfs(i);
            }
        }
    }
    vector<bool> ans(n);
    for (auto i = 0; i < n; ++i) {
        ans[a[i].second] = can[i];
    }
    for (int i=0; i<n; ++i) {
        if (ans[i])
            cout<<1;
        else
            cout<<0;
    }
    return 0;
}
