#pragma GCC optimize("O3,unroll-loops,Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(),v.end()


const int maxn = 1e5 + 1;

mt19937 rnd(52525252);
vector<vector<int> > g;
int color[maxn];
bool can[maxn];
bool used[maxn];

inline void dfs(int v) {
    can[v] = 1;
    used[v] = 1;
    for (auto const elem: g[v]) {
        if (!used[elem]) {
            dfs(elem);
            can[elem] = 1;
        }
    }
}

inline bool dfs_col(int v, int col) {
    color[v] = col;
    bool ret = 1;
    for (auto const elem: g[v]) {
        if (color[elem] == -1) {
            ret &= dfs_col(elem, (col + 1) & 1);
            if (!ret) {
                return false;
            }
        } else if (color[elem] == col) {
            return false;
        }
    }
    return ret;
}

inline ll dist2(const pii &a, const pii &b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

struct Hash {
    ll operator()(const pii&a) const {
        return (a.first<<31)+a.second;
    }
};


inline string wa(int n, int r, const vector<pii> &pp) {
    for (int &elem: color)
        elem = -1;
    for (auto &elem: can)
        elem = 0;
    for (auto &elem: used)
        elem = 0;
    g.clear();

    g.resize(n);
    ll r2 = 1ll * r * r;
    vector<pair<pii, int> > a(n);
    __gnu_pbds::gp_hash_table<pair<int, int>, int , Hash> mp;
    // unordered_map<pair<int, int>, int, Hash> mp;
    for (int i = 0; i < n; ++i) {
        a[i].first.first = pp[i].first;
        a[i].first.second = pp[i].second;
        mp[{a[i].first.first, a[i].first.second}] = i;
        a[i].second = i;
    }

    for (int it = 0; it < n; ++it) {
        ll top = (a[it].first.second - r);
        for (int x = a[it].first.first; x <= a[it].first.first + r; ++x) {
            int addx = x - a[it].first.first;
            while (dist2({x, top}, a[it].first) > r2)
                ++top;
            for (int y = a[it].first.second; y >= top; --y) {
                int addy = a[it].first.second - y;
                if (mp.find({x, y}) == mp.end()) {
                    if (mp[{x, y}] != it) {
                        g[it].push_back(mp[{x, y}]);
                    }
                }
                if (mp.find({x, y + addy * 2}) == mp.end()) {
                    if (mp[{x, y + addy * 2}] != it) {
                        g[it].push_back(mp[{x, y + addy * 2}]);
                    }
                }
                if (mp.find({x - addx * 2, y}) == mp.end()) {
                    if (mp[{x - addx * 2, y}] != it) {
                        g[it].push_back(mp[{x - addx * 2, y}]);
                    }
                }
                if (mp.find({x - addx * 2, y + addy * 2}) == mp.end()) {
                    if (mp[{x - addx * 2, y + addy * 2}] != it) {
                        g[it].push_back(mp[{x - addx * 2, y + addy * 2}]);
                    }
                }
            }
        }
    }


    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (!dfs_col(i, 0)) {
                dfs(i);
            }
        }
    }
    vector<bool> ans(n);
    for (auto i = 0; i < n; ++i) {
        ans[a[i].second] = can[i];
    }
    string ret;
    for (int i = 0; i < n; ++i) {
        if (ans[i])
            ret.push_back('1');
        else
            ret.push_back('0');
    }
    return ret;
}


inline string tl(int n, int r, const vector<pii> &pp) {
    for (int &elem: color)
        elem = -1;
    for (auto &elem: can)
        elem = 0;
    for (auto &elem: used)
        elem = 0;
    g.clear();

    g.resize(n);
    ll r2 = 1ll * r * r;
    vector<pair<pii, int> > a(n);
    for (int i = 0; i < n; ++i) {
        a[i].first.first = pp[i].first;
        a[i].first.second = pp[i].second;
        a[i].second = i;
    }
    shuffle(all(a), rnd);
    for (auto i = 0; i < n; ++i) {
        for (auto j = i + 1; j < n; ++j) {
            if (dist2(a[i].first, a[j].first) <= r2) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (!dfs_col(i, 0)) {
                dfs(i);
            }
        }
    }
    vector<bool> ans(n);
    for (auto i = 0; i < n; ++i) {
        ans[a[i].second] = can[i];
    }
    string ret;
    for (int i = 0; i < n; ++i) {
        if (ans[i])
            ret.push_back('1');
        else
            ret.push_back('0');
    }
    return ret;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    // string awa, atl;
    // vector<pii> pp;
    // int n = 4;
    // int r = 2;
    // while (awa == atl) {
    //     pp.clear();
    //     for (int i = 0; i < n; ++i) {
    //         int x = rnd() % (int) 10;
    //         int y = rnd() % (int) 10;
    //         if (1) {
    //             pp.push_back({x, y});
    //         } else {
    //             --i;
    //         }
    //     }
    //     // pp = {{5, 4}, {7, 6}, {3, 1}, {9, 9}};
    //     awa = wa(n, r, pp);
    //     atl = tl(n, r, pp);
    // }

    int n, r;
    cin>>n>>r;
    vector<pii> pp(n);
    for (auto &elem:pp)
        cin>>elem.first>>elem.second;
    cout<<wa(n,r,pp);
    return 0;
}
