#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(),v.end()


const int maxn = 1e5 + 1;
int color[maxn];
bool can[maxn];
bool used[maxn];

mt19937 rnd(52525252);
vector<vector<int> > g;

inline void dfs(int v) {
    can[v] = 1;
    used[v] = 1;
    for (auto const elem: g[v]) {
        if (!used[elem]) {
            dfs(elem);
            can[elem] = 1;
        }
    }
}

inline bool dfs_col(int v, int col) {
    color[v] = col;
    bool ret = 1;
    for (auto const elem: g[v]) {
        if (color[elem] == -1) {
            ret &= dfs_col(elem, (col + 1) & 1);
            if (!ret) {
                return false;
            }
        } else if (color[elem] == col) {
            return false;
        }
    }
    return ret;
}

inline ll dist2(const pii &a, const pii &b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

signed main() {
    for (int &elem: color)
        elem = -1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    g.resize(n);
    ll r2 = 1ll * r * r;
    vector<pair<pii, int> > a(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        mp[{a[i].first.first, a[i].first.second}] = i;
        a[i].second = i;
    }

    for (int it = 0; it < n; ++it) {
        ll top = (a[it].first.second + r);
        for (int x = a[it].first.first-r; x <= a[it].first.first; ++x) {
            while (dist2({x, top}, a[it].first) > r2)
                --top;
            for (int y = a[it].first.second; y >= a[it].first.second-top; --y) {
                if (mp.contains({x, y})) {
                    if (mp[{x, y}] != it) {
                        g[it].push_back(mp[{x, y}]);
                    }
                }
                if (mp.contains({x, y + r})) {
                    if (mp[{x, y + r}] != it) {
                        g[it].push_back(mp[{x, y + r}]);
                    }
                }
                if (mp.contains({x + r, y})) {
                    if (mp[{x + r, y}] != it) {
                        g[it].push_back(mp[{x + r, y}]);
                    }
                }
                if (mp.contains({x + r, y + r})) {
                    g[it].push_back(mp[{x + r, y + r}]);
                }
            }
        }
    }


    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (!dfs_col(i, 0)) {
                dfs(i);
            }
        }
    }
    vector<bool> ans(n);
    for (auto i = 0; i < n; ++i) {
        ans[a[i].second] = can[i];
    }
    for (int i = 0; i < n; ++i) {
        if (ans[i])
            cout << 1;
        else
            cout << 0;
    }
    return 0;
}
