#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#define int ll
#define endl "\n"
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct L {
    int x, y;
    int ind;
    L(int x, int y, int ind) : x(x), y(y), ind(ind) {}
};

const int D = 2;

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
#endif
    int n, r;
    cin >> n >> r;
    auto dist = [&](L a, L b) {
        return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
    };
    map<pii, vector<L>> s;
    int sz = (r + 1) / 2;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        s[mp(x / sz, y / sz)].emplace_back(x, y, i);
    }
    vector<int> isD(n, 1);
    vector<vector<int>> graph(n);
    for (auto &p : s) {
        for (int i = 1; i < p.s.size(); ++i) {
            graph[p.s[i].ind].pb(p.s[i-1].ind);
            graph[p.s[i-1].ind].pb(p.s[i].ind);
        }
        int x = p.f.f;
        int y = p.f.s;
        if (p.s.size() > 2) {
            isD[p.s[0].ind] = 0;
        }
        for (int dx = -D; dx <= D; ++dx) {
            for (int dy = -D; dy <= D; ++dy) {
                if (s.count(mp(x + dx, y + dy))) {
                    for (auto &l2 : s[mp(x + dx, y + dy)]) {
                        for (auto &l1 : p.s) {
                            if (dist(l1, l2)) {
                                graph[l1.ind].pb(l2.ind);
                                graph[l2.ind].pb(l1.ind);
                            }
                        }
                    }
                }
            }
        }
    }
    vector<int> color(n, -1), marked(n, 0);
    auto dfs = [&](int v, auto &&self) -> bool {
        if (isD[v] == 0) {
            return false;
        }
        for (auto &u : graph[v]) {
            if (u == v) {
                continue;
            }
            if (color[u] == -1) {
                color[u] = 1 - color[v];
                if (!self(u, self)) {
                    return false;
                }
            }
            if (color[u] + color[v] != 1) {
                return false;
            }
        }
        return true;
    };
    auto paint = [&](int v, auto &&self) -> void {
        marked[v] = true;
        isD[v] = false;
        for (auto &u : graph[v]) {
            if (!marked[u]) {
                self(u, self);
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) {
            color[i] = 0;
            if (!dfs(i, dfs)) {
                paint(i, paint);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << 1-isD[i];
    }
    cout << endl;
}