#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t lll;

struct Vector {
	int x, y;
};

ll len2(const Vector &a, const Vector &b) {
	return (a.x - b.x) * 1ll * (a.x - b.x) + (a.y - b.y) * 1ll * (a.y - b.y);
}

bool operator< (const Vector &a, const Vector &b) {
	return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

int n, r;

map<pair<int, int>, vector<int>> blocks;
vector<Vector> pts;

bool is_connected_pts(const Vector &a, const Vector &b) { return len2(a, b) <= r * 1ll * r; }
bool is_connected(const pair<int, int> &b1, const pair<int, int> &b2) {
	for (auto i : blocks[b1]) {
		for (auto j : blocks[b2]) {
			if (is_connected_pts(pts[i], pts[j])) return 1;
		}
	}
	return 0;
}

vector<int> res;

vector<vector<int>> g;
vector<int> dist;
vector<int> vs;

bool dfs(int v, int p) {
	dist[v] = (v == p ? 0 : dist[p] + 1);
	vs.emplace_back(v);
	bool ret = 0;
	for (auto u : g[v]) {
// 		if (u == p) continue;
		if (dist[u] != -1) {
			if (!((dist[u] ^ dist[v]) & 1)) ret = 1;
			continue;
		}
		ret |= dfs(u, v);
	}
	return ret;
}

void find_cycles() {
	dist.resize(n, -1);
	for (int v = 0; v < n; ++v) {
		if (res[v] || dist[v] != -1) continue;
		vs.clear();
		if (dfs(v, v)) {
			for (auto &it : vs) res[it] = 1;
		}
	}
}

signed main() {
	FastIO;
	cin >> n >> r;
	int bs = (int) floor((double) r / sqrt(2.0));
	pts.resize(n);
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		blocks[make_pair(x / bs, y / bs)].emplace_back(i);
		pts[i] = {x, y}; }
	for (auto &[k, v] : blocks) {
		sort(all(v)), [&](int i, int j){
			return pts[i] < pts[j];
		};
	}

	res.resize(n, 0);
	
	g.resize(n, vector<int>());

	for (auto &[v, inds] : blocks) {
		for (int ux = v.first - 2; ux <= v.first + 2; ++ux) {
			for (int uy = v.second - 2; uy <= v.second + 2; ++uy) {
				auto u = make_pair(ux, uy);
				if (u == v) continue;
				if (!blocks.count(u)) continue;
				for (auto &i : inds) {
					for (auto j : blocks[u]) {
						if (!is_connected_pts(pts[i], pts[j])) continue;
						g[i].emplace_back(j);
					}
				}
			}
		}
	}

// 	for (int v = 1; v < n; ++v) {
// 		for (int u = 0; u < v; ++u) {
// 			if (!is_connected_pts(pts[u], pts[v])) continue;
// 			g[u].emplace_back(v);
// 			g[v].emplace_back(u);
// 		}
// 	}
	find_cycles();

// 	cerr << "bs = " << bs << endl;
// 	cerr << "blocks: " << endl;
// 	for (auto &[v, inds] : blocks) { //cerr
// 		cerr << "{" << v.first << ", " << v.second << "}: ";
// 		for (auto &it : inds) cerr << it << ' ';
// 		cerr << endl;
// 	} //cerr

// 	for (int i = 0; i < n; ++i) { //cerr
// 		cerr << "g[" << i << "]: ";
// 		for (auto &it : g[i]) cerr << it << ' ';
// 		cerr << endl;
// 	} //cerr

	for (auto &it : res) cout << it;
	return 0;
}

