#include <bits/stdc++.h>

struct Point
{
  int x, y;

  Point(int x, int y) : x(x), y(y) {}
};

long long sqr_dist(const Point &a, const Point &b)
{
  long long x1 = a.x, x2 = b.x, y1 = a.y, y2 = b.y;
  return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

bool check(const Point &a, const Point & b, long long r)
{
  return sqr_dist(a, b) <= r * r;
}

std::vector<std::vector<int>> gr;
std::vector<int> used, is_g;

bool find(int i, int c)
{
  if (used[i]) {
    if (used[i] == c)
      return false;
    return true;
  }
  if (is_g[i])
    return true;
  used[i] = c;
  for (auto u : gr[i]) {
    if (find(u, 3 - c))
      return true;
  }
  return false;
}

void dfs(int v, int c) {
  if (used[v] == 3)
    return;
  used[v] = 3;
  is_g[v] = c;
  for (auto u : gr[v]) {
    dfs(u, c);
  }
}

int main()
{
  int n, r;
  std::cin >> n >> r;
  std::vector<Point> p;
  for (int i = 0; i < n; ++i) {
    int x, y;
    std::cin >> x >> y;
    p.emplace_back(x, y);
  }
  std::map<std::pair<int, int>, std::vector<int>> map;
  for (int i = 0; i < n; ++i) {
    map[{2 * p[i].x / r, 2 * p[i].y / r}].push_back(i);
  }
  is_g.assign(n, 0);
  for (auto it = map.begin(); it != map.end(); ++it) {
    if (it->second.size() >= 3) {
      for (auto i : it->second)
        is_g[i] = 1;
    }
  }
  gr.assign(n, std::vector<int>());
  for (int i = 0; i < n; ++i) {
    if (!is_g[i]) {
      int x = 2 * p[i].x / r, y = 2 * p[i].y / r;
      for (auto j : map[{x, y}]) {
        if (i != j) {
          gr[i].push_back(j);
        }
      }
      for (int dx = -2; dx <= 2; ++dx) {
        for (int dy = -2; dy <= 2; ++dy) {
          if ((dx == 0 && dy == 0) || !map.count({x + dx, y + dy}))
            continue;
          for (auto j : map[{x + dx, y + dy}]) {
            if (check(p[i], p[j], r))
              gr[i].push_back(j);
          }
        }
      }
    }
  }
  used.assign(n, 0);
  for (int i = 0; i < n; ++i) {
    if (!used[i]) {
      int c = find(i, 1);
      dfs(i, c);
    }
  }
  for (int i = 0; i < n; ++i) {
    if (is_g[i])
      std::cout << '1';
    else
      std::cout << '0';
  }
  std::cout << '\n';
  return 0;
}