//#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/list_update_policy.hpp>

#define int long long

constexpr int INF = 1e18;

typedef
__gnu_pbds::tree<
int,
__gnu_pbds::null_type,
std::greater<int>,
__gnu_pbds::rb_tree_tag,
__gnu_pbds::tree_order_statistics_node_update> tree;

void solve()
{
  int r, c;
  std::cin >> r >> c;
  std::vector<std::vector<int>> a(r, std::vector<int>(c));
  std::vector<std::pair<int, int>> ind(r * c + 1);
  for (int i = 0; i < r; ++i) {
    for (int j = 0; j < c; ++j) {
      std::cin >> a[i][j];
      ind[a[i][j]] = {i, j};
    }
  }
  std::vector<std::vector<std::vector<int>>> val_c(r, std::vector<std::vector<int>>(c, std::vector<int>(c)));
  std::vector<std::vector<std::vector<int>>> val_r(r, std::vector<std::vector<int>>(c, std::vector<int>(r)));
  // std::vector<std::vector<int>> val0_c(r, std::vector<int>(c, INF));
  // std::vector<std::vector<int>> val0_r(r, std::vector<int>(c, INF));
  std::vector<tree> c_tree(c), r_tree(r);
  for (int x = 1; x <= r * c; ++x) {
    auto [i, j] = ind[x];
    for (int j_s = c - 1; j_s >= 0; j_s--) {
      if (j_s != c - 1)
        val_c[i][j][j_s] = val_c[i][j][j_s + 1];
      val_c[i][j][j_s] += c_tree[j_s].order_of_key(i);
    }
    for (int i_s = r - 1; i_s >= 0; i_s--) {
      if (i_s != r - 1)
        val_r[i][j][i_s] = val_r[i][j][i_s + 1];
      val_r[i][j][i_s] += r_tree[i_s].order_of_key(j);
    }
    c_tree[j].insert(i);
    r_tree[i].insert(j);
  }
  std::vector<std::vector<int>> dp(r, std::vector<int>(c, INF));
  for (int i = r - 1; i >= 0; --i) {
    for (int j = c - 1; j >= 0; --j) {
      if (i == r - 1 && j == c - 1) {
        dp[i][j] = 0;
        continue;
      }
      int val1 = 0;
      for (int j_f = j; j_f < c; ++j_f) {
        val1 += val_c[i][j_f][j];
        val1 += val_r[i][j_f][i];
        if (i != r - 1)
          val1 -= val_r[i][j_f][i + 1];
      }
      int val2 = 0;
      for (int i_f = i; i_f < r; ++i_f) {
        val2 += val_r[i_f][j][i];
        val2 += val_c[i_f][j][j];
        if (j != c - 1)
          val2 -= val_c[i_f][j][j + 1];
      }
      if (i == r - 1)
        dp[i][j] = dp[i][j + 1] + val2;
      else if (j == c - 1)
        dp[i][j] = dp[i + 1][j] + val1;
      else
        dp[i][j] = std::min(dp[i + 1][j] + val1, dp[i][j + 1] + val2);
    }
  }
  std::cout << dp[0][0] << '\n';
}

signed main()
{
  int t = 1;
#ifdef LOCAL
  freopen("in/c.txt", "r", stdin);
  freopen("out/c.txt", "w", stdout);
  std::cin >> t;
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  for (int i_t = 0; i_t < t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case: " << i_t + 1 << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}