#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/list_update_policy.hpp>

constexpr int INF = 1e9;

typedef
__gnu_pbds::tree<
int,
__gnu_pbds::null_type,
std::less<int>,
__gnu_pbds::rb_tree_tag,
__gnu_pbds::tree_order_statistics_node_update> tree;

void solve()
{
  int r, c;
  std::cin >> r >> c;
  std::vector<std::vector<int>> a(r, std::vector<int>(c));
  for (int i = 0; i < r; ++i) {
    for (int j = 0; j < c; ++j)
      std::cin >> a[i][j];
  }
  std::vector<std::vector<int>> dp(r, std::vector<int>(c, INF));
  std::vector<tree> c_tree(c);
  for (int i = r - 1; i >= 0; --i) {
    for (int j = c - 1; j >= 0; --j) {
      if (i == r - 1 && j == c - 1) {
        dp[i][j] = 0;
        continue;
      }
      int val1 = 0;
      for (int j_f = j; j_f < c; ++j_f) {
        for (int j_s = j_f + 1; j_s < c; ++j_s)
          val1 += a[i][j_f] > a[i][j_s];
        for (int i_s = i + 1; i_s < r; ++i_s)
          val1 += a[i][j_f] > a[i_s][j];
        for (int j_s = j + 1; j_s < c; ++j_s) {
          val1 += c_tree[j_s].order_of_key(a[i][j_f]);
        }
      }
      int val2 = 0;
      for (int i_f = i; i_f < r; ++i_f) {
        for (int i_s = i_f + 1; i_s < r; ++i_s)
          val2 += a[i_f][j] > a[i_s][j];
        for (int j_s = j + 1; j_s < c; ++j_s)
          val2 += a[i_f][j] > a[i][j_s];
        for (int j_s = j + 1; j_s < c; ++j_s) {
          val2 += c_tree[j_s].order_of_key(a[i_f][j]);
        }
      }
      if (i == r - 1)
        dp[i][j] = dp[i][j + 1] + val2;
      else if (j == c - 1)
        dp[i][j] = dp[i + 1][j] + val1;
      else
        dp[i][j] = std::min(dp[i + 1][j] + val1, dp[i][j + 1] + val2);
      if (i != r - 1)
        c_tree[j].insert(a[i + 1][j]);
    }
  }
  std::cout << dp[0][0] << '\n';
}

int main()
{
  int t = 1;
#ifdef LOCAL
  freopen("in/c.txt", "r", stdin);
  freopen("out/c.txt", "w", stdout);
  std::cin >> t;
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  for (int i_t = 0; i_t < t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case: " << i_t + 1 << '\n';
#endif
    solve();
  }
  std::cout.flush();
  return 0;
}