#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

struct pt {
    int x, y;
};

int dist2(pt a, pt b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void solve_case() {
    int n, r; cin >> n >> r;
    vector<pt> p(n);
    map<pair<int, int>, vector<int>> mp;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        mp[{p[i].x / r, p[i].y / r}].push_back(i);
    }
    bool bipar = true;
    vector<int> col(n), comp;
    function<void(int, int)> dfs = [&](int v, int c) {
        col[v] = c;
        comp.push_back(v);
        int sx = p[v].x / r, sy = p[v].y / r;
        for (int dx = -1; dx <= 1; dx++) {
            for (int dy = -1; dy <= 1; dy++) {
                int tx = sx + dx, ty = sy + dy;
                for (int u : mp[{tx, ty}]) {
                    if (u == v || dist2(p[v], p[u]) > r * r) {
                        continue;
                    }
                    if (!col[u]) {
                        dfs(u, 3 - c);
                    } else if (col[u] != 3 - c) {
                        bipar = false;
                    }
                }
            }
        }
    };
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (!col[i]) {
            bipar = true;
            comp.clear();
            dfs(i, 1);
            for (int v : comp) {
                ans[v] = !bipar;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve_case();
    }
}