#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

struct Fenwick {
    int n;
    vector<int> a;
    Fenwick(int _n = 0) : n(_n), a(n) {}
    void add(int i, int x) {
        for (i++; i <= n; i += i & -i) {
            a[i - 1] += x;
        }
    }
    int sum(int i) {
        int res = 0;
        for (; i > 0; i -= i & -i) {
            res += a[i - 1];
        }
        return res;
    }
    int sum(int l, int r) {
        return sum(r) - sum(l);
    }
};

void solve_case() {
    int r, c; cin >> r >> c;
    vector a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    int res = 0;
    Fenwick fn(r * c);
    for (int j = 0; j < c; j++) {
        res += fn.sum(a[0][j] + 1, r * c);
        fn.add(a[0][j], 1);
        res += fn.sum(a[1][j] + 1, r * c);
        fn.add(a[1][j], 1);
    }
    int ans = res;
    Fenwick up(r * c), down(r * c);
    for (int j = c - 1; j >= 0; j--) {
        res -= fn.sum(a[1][j] + 1, r * c);
        fn.add(a[1][j], -1);
        res -= fn.sum(a[0][j] + 1, r * c);
        fn.add(a[1][j], -1);
        up.add(a[0][j], 1);
        down.add(a[1][j], 1);
        res += up.sum(a[0][j]);
        res += up.sum(a[1][j] + 1, r * c);
        res += down.sum(a[0][j]);
        res += down.sum(a[1][j]);
        ans = min(ans, res);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve_case();
    }
}