#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
using ll = long long;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2")
#pragma GCC optimize("unroll-loops")

struct SegTree {
    struct node {
        int val, mod;
    };
    vector<node> d;
    int n;
    void make(int sz) {
        d.resize(4 * sz);
        n = sz;
    }
    void push(int v, int l, int r) {
        if (d[v].mod == 0 || l + 1 == r) {
            return;
        }
        d[2 * v + 1].mod += d[v].mod;
        d[2 * v + 2].mod += d[v].mod;
        d[2 * v + 1].val += d[v].mod;
        d[2 * v + 2].val += d[v].mod;
        d[v].mod = 0;
    }
    void update(int v, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            d[v].val += val;
            //d[v].mod += val;
            return;
        }
        //push(v, l, r);
        update(2 * v + 1, l, (l + r) / 2, ql, qr, val);
        update(2 * v + 2, (l + r) / 2, r, ql, qr, val);
        d[v].val = d[2 * v + 1].val + d[2 * v + 2].val;
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return d[v].val;
        }
        //push(v, l, r);
        return get(2 * v + 1, l, (l + r) / 2, ql, qr) + get(2 * v + 2, (l + r) / 2, r, ql, qr);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    int row, col;
    row = 0;
    col = 0;
    ll ans = 0;
    vector<vector<int>> dp(n + 1, vector<int>(m + 1, 1ll * n * m * n * m));
    for (int i = 0; i <= n; i++) {
        dp[i][m] = 0;
    }
    for (int i = 0; i <= m; i++) {
        dp[n][i] = 0;
    }
    vector<vector<int>> inv_suf_r(n, vector<int>(m + 1, 0));
    for (int i = 0; i < n; i++) {
        ordered_set cur;
        for (int j = m - 1; j >= 0; j--) {
            inv_suf_r[i][j] = inv_suf_r[i][j + 1] + cur.order_of_key(a[i][j]);
            cur.insert(a[i][j]);
        }
    }
    vector<vector<int>> inv_suf_c(n + 1, vector<int>(m, 0));
    for (int j = 0; j < m; j++) {
        ordered_set cur;
        for (int i = n - 1; i >= 0; i--) {
            inv_suf_c[i][j] = inv_suf_c[i + 1][j] + cur.order_of_key(a[i][j]);
            cur.insert(a[i][j]);
        }
    }
    ordered_set sss;
    set<int> g;
    SegTree tree;
    tree.make(n * m + 1);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < tree.n; j++) {
            tree.d[i].val = 0;
            tree.d[i].mod = 0;
        }
        sss.clear();
        for (int j = m - 1; j >= 0; j--) {
            /*cout << "! ";
            for (auto u : g) {
                cout << u << " ";
            }
            cout << "\n";*/
            //dp[i][j] = dp[i + 1][j] + inv_suf + inv_pryamoug_suf;
            int inv_r = inv_suf_r[i][j];
            /*int inv_suf_r = 0;
            ordered_set f_r;
            for (int c = j; c < m; c++) {
                f_r.insert(a[i][c]);
            }
            for (int c = j; c < m; c++) {
                inv_suf_r += f_r.order_of_key(a[i][c]);
                f_r.erase(a[i][c]);
            }*/
            int inv_c = inv_suf_c[i][j];
            /*int inv_suf_c = 0;
            ordered_set f_c;
            for (int r = i; r < n; r++) {
                f_c.insert(a[r][j]);
            }
            for (int r = i; r < n; r++) {
                inv_suf_c += f_c.order_of_key(a[r][j]);
                f_c.erase(a[r][j]);
            }*/
            //ordered_set sss;
            int inv_podpr_r = 0, inv_podpr_c = 0;
            /*for (int r = i + 1; r < n; r++) {
                for (int c = j + 1; c < m; c++) {
                    sss.insert(a[r][c]);
                }
            }*/
            for (int c = j + 1; c < m; c++) {
                tree.update(0, 0, tree.n, a[i][c], a[i][c] + 1, 1);
            }
            for (int r = i; r < n; r++) {
                inv_podpr_c += tree.get(0, 0, tree.n, 0, a[r][j]);
            }
            for (int c = j + 1; c < m; c++) {
                tree.update(0, 0, tree.n, a[i][c], a[i][c] + 1, -1);
            }
            for (int r = i + 1; r < n; r++) {
                tree.update(0, 0, tree.n, a[r][j], a[r][j] + 1, 1);
            }
            for (int c = j; c < m; c++) {
                inv_podpr_r += tree.get(0, 0, tree.n, 0, a[i][c]);
            }
            /*for (int r = i + 1; r < n; r++) {
                sss.erase(a[r][j]);
            }*/
            dp[i][j] = min(dp[i + 1][j] + inv_r + inv_podpr_r, dp[i][j + 1] + inv_c + inv_podpr_c);
        }
    }
    cout << dp[0][0] << "\n";
}
