#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
using ll = long long;

/*#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2")
#pragma GCC optimize("unroll-loops")*/

struct SegTree {
    struct node {
        int val, mod;
    };

    vector<node> d;
    int n;

    void make(int sz) {
        d.resize(4 * sz);
        n = sz;
    }

    void push(int v, int l, int r) {
        if (d[v].mod == 0 || l + 1 == r) {
            return;
        }
        d[2 * v + 1].mod += d[v].mod;
        d[2 * v + 2].mod += d[v].mod;
        d[2 * v + 1].val += d[v].mod;
        d[2 * v + 2].val += d[v].mod;
        d[v].mod = 0;
    }

    void update(int v, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            d[v].val = val;
            //d[v].mod += val;
            return;
        }
        //push(v, l, r);
        update(2 * v + 1, l, (l + r) / 2, ql, qr, val);
        update(2 * v + 2, (l + r) / 2, r, ql, qr, val);
        d[v].val = d[2 * v + 1].val + d[2 * v + 2].val;
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return d[v].val;
        }
        //push(v, l, r);
        return get(2 * v + 1, l, (l + r) / 2, ql, qr) + get(2 * v + 2, (l + r) / 2, r, ql, qr);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    if (n > m) {
        swap(n, m);
        vector<vector<int>> a_c(n, vector<int>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a_c[i][j] = a[j][i];
            }
        }
        a = a_c;
    }
    int row, col;
    row = 0;
    col = 0;
    ll ans = 0;
    vector<vector<int> > dp(n + 1, vector<int>(m + 1, 1ll * n * m * n * m));
    for (int i = 0; i <= n; i++) {
        dp[i][m] = 0;
    }
    for (int i = 0; i <= m; i++) {
        dp[n][i] = 0;
    }
    SegTree t1;
    t1.make(n * m + 1);
    vector<vector<int> > inv_suf_r(n, vector<int>(m + 1, 0));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            inv_suf_r[i][j] = inv_suf_r[i][j + 1] + t1.get(0, 0, t1.n, 0, a[i][j]);
            t1.update(0, 0, t1.n, a[i][j], a[i][j] + 1, 1);
        }
        for (int j = m - 1; j >= 0; j--) {
            t1.update(0, 0, t1.n, a[i][j], a[i][j] + 1, 0);
        }
    }
    vector<vector<int> > inv_suf_c(n + 1, vector<int>(m, 0));
    SegTree t2;
    t2.make(n * m + 1);
    for (int j = 0; j < m; j++) {
        for (int i = n - 1; i >= 0; i--) {
            inv_suf_c[i][j] = inv_suf_c[i + 1][j] + t2.get(0, 0, t2.n, 0, a[i][j]);
            t2.update(0, 0, t2.n, a[i][j], a[i][j] + 1, 1);
        }
        for (int i = n - 1; i >= 0; i--) {
            t2.update(0, 0, t2.n, a[i][j], a[i][j] + 1, 0);
        }
    }
    set<int> g;
    SegTree tree;
    tree.make(n * m + 1);
    SegTree str;
    str.make(n * m + 1);
    for (int i = n - 1; i >= 0; i--) {
        for (auto &u: tree.d) {
            u = {0, 0};
        }
        for (auto &u: str.d) {
            u = {0, 0};
        }
        int predd = 0;
        for (int j = m - 1; j >= 0; j--) {
            //dp[i][j] = dp[i + 1][j] + inv_suf + inv_pryamoug_suf;
            int inv_r = inv_suf_r[i][j];
            int inv_c = inv_suf_c[i][j];
            int inv_podpr_r = predd, inv_podpr_c = 0;
            if (j + 1 < m) {
                str.update(0, 0, str.n, a[i][j + 1], a[i][j + 1] + 1, 1);
            }
            /*for (int c = j + 1; c < m; c++) {
                tree.update(0, 0, tree.n, a[i][c], a[i][c] + 1, 1);
            }*/
            int DODEP = 0;
            for (int r = i; r < n; r++) {
                inv_podpr_c += tree.get(0, 0, tree.n, 0, a[r][j]);
                if (i != r) {
                    DODEP += str.get(0, 0, str.n, 0, a[r][j]);
                } else {
                    inv_podpr_c += str.get(0, 0, str.n, 0, a[r][j]);
                }
            }
            inv_podpr_c += DODEP;
            /*for (int c = j + 1; c < m; c++) {
                tree.update(0, 0, tree.n, a[i][c], a[i][c] + 1, 0);
            }*/
            for (int r = i + 1; r < n; r++) {
                tree.update(0, 0, tree.n, a[r][j], a[r][j] + 1, 1);
            }
            inv_podpr_r += tree.get(0, 0, tree.n, 0, a[i][j]);
            /*for (int c = j; c < m; c++) {
                inv_podpr_r += tree.get(0, 0, tree.n, 0, a[i][c]);
            }*/
            inv_podpr_r += (m - j - 1) * (n - i - 1) - DODEP;
            dp[i][j] = min(dp[i + 1][j] + inv_r + inv_podpr_r, dp[i][j + 1] + inv_c + inv_podpr_c);
            predd = inv_podpr_r;
        }
    }
    cout << dp[0][0] << "\n";
}
