#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("Ofast")
#define LOCAL

struct segtree {
    vector<int> tree;
    int n;
    segtree(int _n) : n(_n), tree(4 * _n) {}
    void add(int v, int tl, int tr, int pos) {
        if (pos < tl || pos >= tr) return;
        if (tr - tl == 1) {
            tree[v] = 1;
            return;
        }
        int tm = (tl + tr) / 2;
        add(v * 2 + 1, tl, tm, pos);
        add(v * 2 + 2, tm, tr, pos);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }
    void add(int pos) {
        add(0, 0, n, pos);
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl) return 0;
        if (l <= tl && tr <= r) return tree[v];
        int tm = (tl + tr) / 2;
        return get(v * 2 + 1, tl, tm, l, r) + get(v * 2 + 2, tm, tr, l, r);
    }
    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};
void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> mtrx(r, vector<int>(c));
    for (auto &row : mtrx) {
        for (auto &el : row) {
            cin >> el;
            --el;
        }
    }
    ll ans = 1e9;
    for (int j = 0; j < (1 << (r + c)); ++j) {
        segtree tree(r * c);
        int curc = 0, curr = 0;
        ll cur = 0;
        for (int i = 0; i < r + c; ++i) {
            if ((j >> i) & 1) {
                for (int k = curc; k < c; ++k) {
                    cur += tree.get(mtrx[curr][k], r * c);
                    tree.add(mtrx[curr][k]);
                }
                curr++;
            } else {
                for (int k = curr; k < r; ++k) {
                    cur += tree.get(mtrx[k][curc], r * c);
                    tree.add(mtrx[k][curc]);
                }
                curc++;
            }
            if (curc == c || curr == r) break;
        }
        ans = min(ans, cur);
    }
    cout << ans;
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}