#include <bits/stdc++.h>
 
using ll = long long;
using namespace std;
 
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("Ofast")
// #define LOCAL
 
struct segtree {
    vector<int> tree;
    int n;
    void build(int v, int tl, int tr, const vector<int> &arr) {
        if (tr - tl == 1) {
            tree[v] = arr[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2 + 1, tl, tm, arr);
        build(v * 2 + 2, tm, tr, arr);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
    }
    segtree() {}
    segtree(const vector<int> &arr) : n(sz(arr)), tree(4 * sz(arr)) {
        build(0, 0, n, arr);
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl) return 0;
        if (l <= tl && tr <= r) return tree[v];
        int tm = (tl + tr) / 2;
        return max(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm, tr, l, r));
    }
    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};
void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> arr(n);
    for (auto &el : arr) cin >> el;
    segtree tree(arr);
    for (int i = 0; i < q; ++i) {
        int k, idx;
        cin >> k >> idx;
        --idx, --k;
        if (idx < k) {
            cout << arr[idx] << '\n';
        } else {
            cout << tree.get(idx, n) << '\n';
        }
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}