#include <bits/stdc++.h>

using ll = long long;
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("Ofast")
// #define LOCAL

struct segtree {
    vector<int> tree;
    int n;
    void build(int v, int tl, int tr, const vector<int> &arr) {
        if (tr - tl == 1) {
             tree[v] = arr[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2 + 1, tl, tm, arr);
        build(v * 2 + 2, tm, tr, arr);
        tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
    }
    segtree() {}
    segtree(const vector<int> &arr) : n(sz(arr)), tree(4 * sz(arr)) {
        build(0, 0, n, arr);
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (tr <= l || r <= tl) return 0;
        if (l <= tl && tr <= r) return tree[v];
        int tm = (tl + tr) / 2;
        return max(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm, tr, l, r));
    }
    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};
segtree tree;
vector<int> arr;
int n;
vector<int> best;
void find_ans(int rest, vector<int> &cur, int pos, vector<int> &best) {
    if (rest > n - pos) return;
    if (rest == 1) {
        cur.push_back(tree.get(pos, n));
        bool flag = false;
        for (int i = 0; i < sz(best); ++i) {
            if (cur[i] == best[i]) continue;
            flag = cur[i] < best[i];
            break;
        }
        if (flag) {
            best = cur;
        }
        cur.pop_back();
        return;
    }
    int mx = 0;
    for (int j = pos; j < n; ++j) {
        mx = max(mx, arr[j]);
        if (best[sz(cur)] < mx) continue;
        cur.push_back(mx);
        find_ans(rest - 1, cur, j + 1, best);
        cur.pop_back();
    }
}
void solve() {
    int q;
    cin >> n >> q;
    arr.resize(n);
    for (auto &el : arr) cin >> el;
    pair<int, int> mx = {1e9, 1e9};
    tree = segtree(arr);
    for (int j = 1; j < n; ++j) {
        pair<int, int> cur = make_pair(tree.get(0, j), tree.get(j, n));
        if (cur < mx) {
            mx = cur;
        }
    }
    vector<vector<int>> anses(n);
    for (int i = 0; i < n; ++i) {
        vector<int> best(i + 1, 1e9), cur;
        find_ans(i + 1, cur, 0, best);
        anses[i] = best;
    }
    for (int i = 0; i < q; ++i) {
        int k, idx;
        cin >> k >> idx;
        --idx;
        cout << anses[k - 1][idx] << '\n';
    }
}
int main() {
#ifdef LOCAL
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}