#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;


struct point {
    int x, y;
    point () {}
    point (int x, int y): x(x), y(y) {}
};

int dst2(point a, point b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return dx * dx + dy * dy;
}

pii srtd(pii p) {
    if (p.first > p.second) swap(p.first, p.second);
    return p;
}

int n, r, B, k;
vector<point> v;
vector<int> ind;
vector<bool> sup;
vector<point> pos;
vector<vector<int>> pts(k);
vector<point> neib;
vector<vector<int>> g;
vector<bool> used;
vector<int> clr;


void dfs(int u, int p) {
    used[u] = 1;
    if (p == -1) clr[u] = 0;
    else clr[u] = clr[p] ^ 1;
    if (p != -1 && sup[p]) sup[u] = 1;
    for (int v : g[u]) {
        if (used[v]) continue;
        dfs(v, u);
        if (sup[v]) sup[u] = 1;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    for (int i = -2; i <= 2; i++) {
        for (int j = -2; j <= 2; j++) {
            if (abs(i) + abs(j) > 0) neib.push_back(point(i, j));
        }
    }

    cin >> n >> r;
    int lb = 1, rb = r + 1;
    while (rb - lb > 1) {
        int mid = (lb + rb) / 2;
        if (2 * (mid - 1) * (mid - 1) <= r * r) lb = mid;
        else rb = mid;
    }
    B = lb;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].x >> v[i].y;
    }


    map<pii, vector<int>> mp;
    for (int i = 0; i < n; i++) {
        mp[{v[i].x / B, v[i].y / B}].push_back(i);
    }

    ind.resize(n);
    k = 0;
    for (auto b : mp) {
        if (b.second.size() == 1) {
            ind[b.second[0]] = k;
            sup.push_back(0);
            pos.push_back(v[b.second[0]]);
            k++;
        }
        if (b.second.size() == 2) {
            ind[b.second[0]] = k;
            ind[b.second[1]] = k + 1;
            pos.push_back(v[b.second[0]]);
            pos.push_back(v[b.second[1]]);
            sup.push_back(0);
            sup.push_back(0);
            k += 2;
        }
        if (b.second.size() > 2) {
            for (int i : b.second) ind[i] = k;
            sup.push_back(1);
            pos.push_back(point(b.first.first, b.first.second));
            k++;
        }
    }
    pts.resize(k);
    for (int i = 0; i < k; i++) {
        if (!sup[i]) continue;
        pts[i] = mp[{pos[i].x, pos[i].y}];
    }

    set<pii> edg;
    for (int u = 0; u < k; u++) {
        int xb, yb;
        if (sup[u]) continue;
        xb = pos[u].x / B, yb = pos[u].y / B;
        for (point d : neib) {
            pii pv = {xb + d.x, yb + d.y};
            if (!mp.count(pv)) continue;
            for (int i : mp[pv]) {
                if (dst2(v[i], pos[u]) <= r * r) {
                    edg.insert(srtd({ind[i], u}));
                }
            }
        }
    }

    g.resize(k);
    for (pii p : edg) {
        int u = p.first, v = p.second;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    clr.resize(n);
    used.assign(k, 0);
    for (int u = 0; u < k; u++) {
        if (used[u]) continue;
        dfs(u, -1);
    }
    for (int u = 0; u < k; u++) {
        for (int v : g[u]) {
            if (clr[u] == clr[v]) sup[u] = 1;
        }
    }
    used.assign(k, 0);
    for (int u = 0; u < k; u++) {
        if (used[u]) continue;
        dfs(u, -1);
    }
    vector<bool> ans(n, 0);
    for (int i = 0; i < n; i++) {
        if (sup[ind[i]]) cout << 1;
        else cout << 0;
    }
}

// TIP See CLion help at <a
// href="https://www.jetbrains.com/help/clion/">jetbrains.com/help/clion/</a>.
//  Also, you can try interactive lessons for CLion by selecting
//  'Help | Learn IDE Features' from the main menu.