#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const ll INF = 1e18;


struct point {
    int x, y;
    point () {}
    point (int x, int y): x(x), y(y) {}
};

int dst2(point a, point b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return dx * dx + dy * dy;
}

pii srtd(pii p) {
    if (p.first > p.second) swap(p.first, p.second);
    return p;
}

void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
void wr(vector<bool> a) {
    for (bool i : a) cout << i << ' ';
    cout << '\n';
}
void wr(vector<pii> a) {
    for (pii i : a) cout << "{" << i.first << ", " << i.second << "} ";
    cout << '\n';
}

struct seg_tree {
    int n = 1;
    vector<pii> mn;
    seg_tree (int nq, vector<int> v) {
        while (n <= nq) n *= 2;
        while (v.size() < n) v.push_back(INF);
        mn.resize(n * 2, {INF, -1});
        build(1, 0, n, v);
    }
    void build(int u, int l, int r, vector<int>& v) {
        if (r - l == 1) {
            mn[u] = {v[l], l};
            return;
        }
        int mid = (l + r) / 2;
        build(u * 2, l, mid, v);
        build(u * 2 + 1, mid, r, v);
        mn[u] = min(mn[u * 2], mn[u * 2 + 1]);
    }

    pii get(int l, int r) {
        return get(1, 0, n, l, r);
    }
    pii get(int u, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq) return {INF, -1};
        if (lq <= l && r <= rq) return mn[u];
        int mid = (l + r) / 2;
        return min(get(u * 2, l, mid, lq, rq), get(u * 2 + 1, mid, r, lq, rq));
    }
};


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (int &i : a) cin >> i;
    vector<pii> qr(q);
    for (int i = 0; i < q; i++) cin >> qr[i].first >> qr[i].second;

    set<int> buf;
    for (int i = 0; i < q; i++) buf.insert(qr[i].first);
    vector<int> ks;
    for (int i : buf) ks.push_back(i);
    int m = ks.size();

    seg_tree t(n, a);
    //wr(t.mn);
    vector<int> suf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = max(a[i], suf[i + 1]);
    }
    vector<int> r(n, n);
    vector<int> mxs;
    for (int i = n - 1; i >= 0; i--) {
        while (mxs.size() > 0 && a[mxs.back()] < a[i]) mxs.pop_back();
        if (mxs.size() > 0) r[i] = mxs.back();
        mxs.push_back(i);
    }

    //wr(suf);
    //wr(r);

    vector<vector<int>> res(n + 1);
    for (int _ = 0; _ < m; _++) {
        int k = ks[_];
        int cur = 0;
        int cnt = 1;
        while (cur < n) {
            if (k - cnt == 0) {
                res[k].push_back(suf[cur]);
                cur = n;
                break;
            }
            int nxt = t.get(cur + 1, min(r[cur], n - (k - cnt)) + 1).second;
            res[k].push_back(a[cur]);
            if (nxt == cur) {
                cur++;
            } else {
                cur = nxt;
            }
            cnt++;
        }
        //cout << "k:" << k << '\n';
        //wr(res[k]);
    }
    //for (int i = 1; i <= n; i++) wr(res[i]);
    for (pii i : qr) {
        cout << res[i.first][i.second - 1] << '\n';
    }
}