#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <algorithm>
#include <random>

using namespace std;
mt19937 rnd(42);
#define int long long

vector<int> p;
vector<int> sz;
vector<bool> can_jump;

void init(int n) {
	p = vector<int>(n);
	sz = vector<int>(n, 1);
	can_jump = vector<bool>(n);
	for (int i = 0; i < n; i++) p[i] = i;
}

int pred(int a) {
	if (a == p[a]) return a;
	p[a] = pred(p[a]);
	return p[a];
}

void un(int a, int b) {
	a = pred(a); b = pred(b);
	if (a == b) return;
	if (sz[a] > sz[b]) swap(a, b);
	p[a] = b;
	sz[b] += sz[a];
	can_jump[b] = can_jump[b] or can_jump[a];
}

struct point {
	int x, y;
};



int n, r;
vector<point> l;
vector<set<pair<int, int>>> l2;
vector<bool> color;

vector<vector<int>> closest;

int dist(int ind1, int ind2) {
	return (l[ind1].x - l[ind2].x) * (l[ind1].x - l[ind2].x) + (l[ind1].y - l[ind2].y) * (l[ind1].y - l[ind2].y);
}

void add(int i, int ind) {
	int u = 0;
	if (i & 1) u += l[ind].x;
	else u -= l[ind].x;
	if (i & 2) u += l[ind].y;
	else u -= l[ind].y;
	l2[i].insert({ u, ind });
}

void remove(int i, int ind) {
	int u = 0;
	if (i & 1) u += l[ind].x;
	else u -= l[ind].x;
	if (i & 2) u += l[ind].y;
	else u -= l[ind].y;
	l2[i].erase({ u, ind });
}

int cnt(int i, int ind) {
	int u = 0;
	if (i & 1) u += l[ind].x;
	else u -= l[ind].x;
	if (i & 2) u += l[ind].y;
	else u -= l[ind].y;
	return u;
}

set<pair<int, int>> s;

void bfs() {
	init(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			add(j, i);
		}
	}
	for (int i = 0; i < n; i++) {
		if (sz[i] != 1) continue;
		queue<int> q;
		q.push(i);
		bool jumped = false;
		vector<int> lol;
		lol.push_back(i);
		while (q.size() > 0) {
			int he = 0;
			int now = q.front();
			q.pop();
			auto j2 = s.lower_bound({l[now].x - r, -1});
			while (j2 != s.end()) {
				auto j = (*j2).second;
				if (l[j].x > l[now].x + r) {
					break;
				}
				else {
					if (pred(j) != pred(now)) {
						q.push(j);
						un(now, j);
						lol.push_back(j);
						color[j] = !color[now];
						//cout << now << " " << j.second << " ehhee\n";
					}
					else {
						if (now != j and color[now] == color[j]) {
							//cout << now << " " << j.second << " LOLOL\n";
							can_jump[pred(now)] = true;
							jumped = true;
						}
					}
				}
				j2++;
			}
			if (jumped) {
				for (int j : lol) {
					//s.erase({ l[j].x, j });
				}
				lol.clear();
			}
			//cout << he << "\n";
		}
		for (int j : lol) {
			//s.erase({ l[j].x, j });
		}
		lol.clear();
	}
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	n = 100000; r = 2;
	cin >> n >> r;
	l = vector<point>(n);
	color = vector<bool>(n);
	l2 = vector<set<pair<int, int>>>(4);
	closest = vector<vector<int>>(n);
	
	for (int i = 0; i < n; i++) {
		s.insert({ l[i].x, i });
	}
	for (int i = 0; i < n; i++) {
		l[i] = { i / 1000, i % 1000 };
		cin >> l[i].x >> l[i].y;
	}
	bfs();
	//for (int i : p) cout << i + 1 << " ";
	//cout << "\n";
	for (int i = 0; i < n; i++) {
		if (can_jump[pred(i)]) cout << "1";
		else cout << "0";
	}


}
/*

4 3
0 0
2 0
3 0
5 0

  
  :
   ,  0  
 1  

׸  ,    ,        8 
    
:    ,   ,     

      

     .  ?


*/