#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <algorithm>
#include <random>

using namespace std;
mt19937 rnd(42);
#define int long long

vector<int> p;
vector<int> sz;
vector<bool> can_jump;

void init(int n) {
	p = vector<int>(n);
	sz = vector<int>(n, 1);
	can_jump = vector<bool>(n);
	for (int i = 0; i < n; i++) p[i] = i;
}

int pred(int a) {
	if (a == p[a]) return a;
	p[a] = pred(p[a]);
	return p[a];
}

void un(int a, int b) {
	a = pred(a); b = pred(b);
	if (a == b) return;
	if (sz[a] > sz[b]) swap(a, b);
	p[a] = b;
	sz[b] += sz[a];
	can_jump[b] = can_jump[b] or can_jump[a];
}

struct point {
	int x, y;
};



int n, r;
vector<point> l;
vector<set<pair<int, int>>> l2;
vector<bool> color;

vector<vector<int>> closest;

int dist(int ind1, int ind2) {
	return (l[ind1].x - l[ind2].x) * (l[ind1].x - l[ind2].x) + (l[ind1].y - l[ind2].y) * (l[ind1].y - l[ind2].y);
}

void add(int i, int ind) {
	int u = 0;
	if (i & 1) u += l[ind].x;
	else u -= l[ind].x;
	if (i & 2) u += l[ind].y;
	else u -= l[ind].y;
	l2[i].insert({ u, ind });
}

void remove(int i, int ind) {
	int u = 0;
	if (i & 1) u += l[ind].x;
	else u -= l[ind].x;
	if (i & 2) u += l[ind].y;
	else u -= l[ind].y;
	l2[i].erase({ u, ind });
}

int cnt(int i, int ind) {
	int u = 0;
	if (i & 1) u += l[ind].x;
	else u -= l[ind].x;
	if (i & 2) u += l[ind].y;
	else u -= l[ind].y;
	return u;
}

set<pair<int, int>> s;
unordered_map<int, int> d;

void bfs() {
	init(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			add(j, i);
		}
	}
	for (int i = 0; i < n; i++) {
		if (sz[i] != 1) continue;
		queue<int> q;
		q.push(i);
		bool jumped = false;
		vector<int> lol;
		lol.push_back(i);
		while (q.size() > 0) {
			int he = 0;
			int now = q.front();
			q.pop();
			for (int x = max(0ll, l[now].x - r); x <= l[now].x + r; x++) {
				for (int y = max(0ll, l[now].y - r); y <= l[now].y + r; y++) {
					if ((x - l[now].x) * (x - l[now].x) + (y - l[now].y) * (y - l[now].y) <= r * r) {
						int j = d[x * (int)1e9 + y];
						if (j == 0) d.erase(x * (int)1e9 + y);
						//cout << d.size() << "\n";
						if (j) {
							j--;
							if (pred(j) != pred(now)) {
								q.push(j);
								un(now, j);
								//lol.push_back(j);
								color[j] = !color[now];
								//cout << now << " " << j.second << " ehhee\n";
							}
							else {
								if (now != j and color[now] == color[j]) {
									//cout << now << " " << j.second << " LOLOL\n";
									can_jump[pred(now)] = true;
									jumped = true;
								}
							}
						}
					}
					else continue;
				}
			}
			//cout << he << "\n";
		}
		for (int j : lol) {
			//s.erase({ l[j].x, j });
		}
		lol.clear();
	}
}

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);

	n = 100000; r = 2;
	cin >> n >> r;
	l = vector<point>(n);
	color = vector<bool>(n);
	l2 = vector<set<pair<int, int>>>(4);
	closest = vector<vector<int>>(n);


	for (int i = 0; i < n; i++) {
		l[i] = { i / 1000, i % 1000 };
		cin >> l[i].x >> l[i].y;
		d[l[i].x * (int)1e9 + l[i].y] = i + 1;
	}
	bfs();
	//for (int i : p) cout << i + 1 << " ";
	//cout << "\n";
	for (int i = 0; i < n; i++) {
		if (can_jump[pred(i)]) cout << "1";
		else cout << "0";
	}


}
/*

5 3
0 0
2 0
3 0
5 0
8 0

  
  :
   ,  0  
 1  

׸  ,    ,        8 
    
:    ,   ,     

      

     .  ?


*/