#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <cmath>
#include <math.h>

#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const ld eps = 1e-6;
const i64 INF = 1e9 + 5;

const i64 S = 1e5 + 10;

map <pair<int, int>, vector<i64>> sets;
map <pair<int, int>, bool> d;
pair <i64, i64> pos[S];

vector <pair<i64, i64>> moves;
bool ans[S];
i64 used[S];

vector <i64> gr[S];
i64 clr[S];

void dfsMake(i64 v) {
	used[v] = 1;
	ans[v] = true;
	for (auto x : gr[v]) {
		if (!used[x]) {
			dfsMake(x);
		}
	}
}

bool ok = false;
vector <i64> visit;

void pokras(i64 v, i64 color, i64 from) {
	used[v] = 1;
	visit.push_back(v);
	clr[v] = color;
	for (auto x : gr[v]) {
		if (x == from) continue;
		if (!used[x]) {
			pokras(x, (color == 1 ? 2 : 1), v);
		}
		else {
			if (clr[v] == clr[x]) ok = true;
		}
	}
}

i64 dist(i64 a, i64 b) {
	return (pos[a].first - pos[b].first) * (pos[a].first - pos[b].first)
		+ (pos[a].second - pos[b].second) * (pos[a].second - pos[b].second);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	for (auto x : { -2, -1, 0, 1, 2 }) {
		for (auto y : { -2, -1, 0, 1, 2 }) {
			moves.push_back(mp(x, y));
		}
	}

	i64 n, r; cin >> n >> r;

	i64 divis = (i64)floor((ld)r / sqrtl((ld)2 + eps));

	for (i64 x = 1; x <= n; ++x) {
		i64 posX, posY; cin >> posX >> posY;
		pos[x] = mp(posX, posY);
		i64 d = (posX + (INF * divis)) / divis - INF;
		i64 d1 = (posY + (INF * divis)) / divis - INF;
		sets[mp(d, d1)].push_back(x);
	}

	for (auto& x : sets) {
		if (x.second.size() >= 3) {
			d[x.first] = true;
			for (auto y : x.second) {
				ans[y] = true;
			}
			while (x.second.size() != 2) {
				x.second.pop_back();
			}
		}
	}

	for (auto x : sets) {
		for (auto from : x.second) {
			for (auto y : moves) {
				i64 toX = x.first.first + y.first, toY = x.first.second + y.second;
				for (auto to : sets[{toX, toY}]) {
					if (to < from && dist(from, to) <= r * r) {
						gr[from].push_back(to);
						gr[to].push_back(from);
					}
				}
			}
		}
	}

	for (i64 x = 1; x <= n; ++x) {
		if (!used[x] && ans[x]) {
			dfsMake(x);
		}
	}

	for (i64 x = 1; x <= n; ++x) {
		if (!used[x]) {
			visit.clear();
			ok = false;
			pokras(x, 1, x);
			if (ok) {
				for (auto y : visit) {
					ans[y] = true;
				}
			}
		}
	}

	for (i64 x = 1; x <= n; ++x) {
		if (ans[x]) cout << '1';
		else cout << '0';
	}
}