#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <cmath>
#include <math.h>

#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const ld eps = 1e-6;
const i64 INF = 1e9 + 5;

const i64 S = 2e6 + 10;
vector <i64> p[S], dp[S];
vector <i64> str[S], col[S];

i64 makeStr(i64 posX, i64 posY) {
	return str[posX].end() - lower_bound(str[posX].begin(), str[posX].end(), posY - 1);
}

i64 makeCol(i64 posX, i64 posY) {
	return col[posY].end() - lower_bound(col[posY].begin(), col[posY].end(), posX - 1);
}

const i64 K = 3e5;
i64 fenw[K];
i64 n, m;

void add(i64 v) {
	for (i64 x = v; x <= m; x += x & (-x)) {
		fenw[x] += 1;
	}
	return;
}

i64 prefSum(i64 v) {
	i64 sum = 0;
	for (i64 x = v; x >= 1; x -= x & (-x)) {
		sum += fenw[x];
	}
	return sum;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	cin >> n >> m;
	i64 alrAns = 0;

	for (i64 x = 1; x <= n; ++x) {
		p[x].resize(m + 1);
		dp[x].resize(m + 1);
		str[x].resize(m + 1);
		for (i64 y = 1; y <= m; ++y) {
			cin >> p[x][y];
		}
	}

	if (n == 1) {
		i64 answer = 0;
		for (i64 x = m; x >= 1; --x) {
			answer += prefSum(p[1][x]);
			add(p[1][x]);
		}
		cout << answer;
		exit(0);
	}

	str[0].resize(m + 1);

	for (i64 y = 0; y <= m; ++y) {
		col[y].resize(n + 1);
	}

	dp[0].resize(m + 1);

	i64 ex = 0;

	for (i64 x = 0; x <= n; ++x) {
		for (i64 y = 0; y <= m; ++y) {
			dp[x][y] = INF;
		}
	}

	dp[0][0] = 0;

	for (i64 x = 1; x <= n; ++x) {
		for (i64 y = 1; y <= m; ++y) {
			for (i64 x1 = 1; x1 <= n; ++x1) {
				for (i64 y1 = 1; y1 <= m; ++y1) {
					if (x1 >= x && y1 >= y) {
						if (p[x][y] > p[x1][y1]) {
							++alrAns;
						}
					}
					else if (x < x1 && y > y1) {
						if (p[x][y] > p[x1][y1]) {
							str[x][y1] += 1;
						}
					}
					else if (x > x1 && y < y1) {
						if (p[x][y] > p[x1][y1]) {
							col[y][x1] += 1;
						}
					}
				}
			}
		}
	}

	for (i64 x = n - 1; x >= 0; --x) {
		for (i64 y = m - 1; y >= 0; --y) {
			str[x][y] += str[x][y + 1];
			col[y][x] += col[y][x + 1];
		}
	}

	for (i64 x = 0; x <= n; ++x) {
		for (i64 y = 0; y <= m; ++y) {
			if ((x == n && y == m) || (x == 0 && y == 0)) continue;

			if (x >= 1 && y < m) {
				dp[x][y] = min(dp[x - 1][y] + str[x][y + 1], dp[x][y]);
			}
			if (y >= 1 && x < n) {
				dp[x][y] = min(dp[x][y - 1] + col[y][x + 1], dp[x][y]);
			}
		}
	}

	dp[n][m] = INF;

	i64 minAns = INF;

	for (i64 x = 0; x <= n; ++x) {
		minAns = min(minAns, dp[x][m]);
	}

	for (i64 y = 0; y <= m; ++y) {
		minAns = min(minAns, dp[n][y]);
	}

	cout << alrAns + minAns;
}