#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <cmath>
#include <math.h>

#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const ld eps = 1e-6;
const i64 INF = 1e9 + 5;

const i64 S = 2e4 + 10;
vector <i64> p[S], dp[S], down[S], righ[S];

vector <i64> fenw[S];
i64 n, m;

void add(i64 a, i64 b) {
	for (i64 x = a; x <= n; x += x & (-x)) {
		for (i64 y = b; y <= m; y += y & (-y)) {
			fenw[x][y] += 1;
		}
	}
}

i64 getPref(i64 a, i64 b) {
	i64 sum = 0;
	for (i64 x = a; x >= 1; x -= x & (-x)) {
		for (i64 y = b; y >= 1; y -= y & (-y)) {
			sum += fenw[x][y];
		}
	}
	return sum;
}

i64 getSum(i64 x, i64 y, i64 x1, i64 y1) {
	return getPref(x1, y1) - getPref(x - 1, y1) - getPref(x1, y - 1) + getPref(x - 1, y - 1);
}

pair <i64, i64> pos[S];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	cin >> n >> m;
	i64 alrAns = 0;

	for (i64 x = 1; x <= n; ++x) {
		p[x].resize(m + 1);
		dp[x].resize(m + 1);
		down[x].resize(m + 1);
		righ[x].resize(m + 1);
		for (i64 y = 1; y <= m; ++y) {
			cin >> p[x][y];
			pos[p[x][y]] = mp(x, y);
		}
		fenw[x].resize(m + 1);
	}

	righ[0].resize(m + 1);
	down[0].resize(m + 1);
	dp[0].resize(m + 1);

	i64 ex = 0;

	for (i64 x = 0; x <= n; ++x) {
		for (i64 y = 0; y <= m; ++y) {
			dp[x][y] = INF;
		}
	}

	dp[0][0] = 0;

	for (i64 x = 1; x <= n * m; ++x) {
		i64 posX = pos[x].first, posY = pos[x].second;
		alrAns += getSum(posX, posY, n, m);
		righ[posX][posY] = getSum(1, posY + 1, posX - 1, m);
		down[posX][posY] = getSum(posX + 1, 1, n, posY - 1);
		add(posX, posY);
	}

	/*for (i64 x = 1; x <= n; ++x) {
		for (i64 y = 1; y <= m; ++y) {
			for (i64 x1 = 1; x1 <= n; ++x1) {
				for (i64 y1 = 1; y1 <= m; ++y1) {
					if (x1 >= x && y1 >= y) {
						if (p[x][y] > p[x1][y1]) {
							++alrAns;
						}
					}
					else if (x < x1 && y > y1) {
						if (p[x][y] > p[x1][y1]) {
							str[x][y1] += 1;
						}
					}
					else if (x > x1 && y < y1) {
						if (p[x][y] > p[x1][y1]) {
							col[y][x1] += 1;
						}
					}
				}
			}
		}
	}
	*/

	for (i64 x = n - 1; x >= 0; --x) {
		for (i64 y = m - 1; y >= 0; --y) {
			down[x][y] += down[x][y + 1];
			righ[x][y] += righ[x + 1][y];
		}
	} 

	for (i64 x = 0; x <= n; ++x) {
		for (i64 y = 0; y <= m; ++y) {
			if ((x == n && y == m) || (x == 0 && y == 0)) continue;

			if (x >= 1 && y < m) {
				dp[x][y] = min(dp[x - 1][y] + righ[x][y + 1], dp[x][y]);
			}
			if (y >= 1 && x < n) {
				dp[x][y] = min(dp[x][y - 1] + down[x + 1][y], dp[x][y]);
			}
		}
	}

	dp[n][m] = INF;

	i64 minAns = INF;

	for (i64 x = 0; x <= n; ++x) {
		minAns = min(minAns, dp[x][m]);
	}

	for (i64 y = 0; y <= m; ++y) {
		minAns = min(minAns, dp[n][y]);
	}

	cout << alrAns + minAns;
}