#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <cmath>
#include <math.h>

#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const ld eps = 1e-6;
const i64 INF = 1e9 + 5;

const i64 S = 2e4 + 10;
vector <i64> p[S], dp[S];
vector <i64> str[S], col[S];

i64 makeStr(i64 posX, i64 posY) {
	return str[posX].end() - lower_bound(str[posX].begin(), str[posX].end(), posY - 1);
}

i64 makeCol(i64 posX, i64 posY) {
	return col[posY].end() - lower_bound(col[posY].begin(), col[posY].end(), posX - 1);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	i64 n, m; cin >> n >> m;
	i64 alrAns = 0;

	for (i64 x = 1; x <= n; ++x) {
		p[x].resize(m + 1);
		dp[x].resize(m + 1);
		str[x].resize(m + 1);
		for (i64 y = 1; y <= m; ++y) {
			cin >> p[x][y];
		}
	}

	for (i64 y = 1; y <= m; ++y) {
		col[y].resize(n + 1);
	}

	i64 sum = n + m, toMin = INF;
	for (i64 x = 0; x < (i64(1) << sum); ++x) {
		vector<i64> op;
		i64 s1 = 0, s2 = 0, itog = 0;
		i64 val = x;
		while (s1 < n && s2 < m) {
			if (val & 1) {
				for (i64 y = s2 + 1; y <= m; ++y) {
					for (i64 y1 = y + 1; y1 <= m; ++y1) {
						if (p[s1 + 1][y] > p[s1 + 1][y1]) ++itog;
					}
				}
				for (i64 x1 = 1; x1 <= n; ++x1) {
					for (i64 y1 = 1; y1 <= s2; ++y1) {
						for (i64 y = s2 + 1; y <= m; ++y) {
							if (p[x1][y1] > p[s1 + 1][y]) ++itog;
						}
					}
				}
				for (i64 x1 = 1; x1 <= s1; ++x1) {
					for (i64 y1 = 1; y1 <= m; ++y1) {
						if (x1 <= s1 && y1 <= s2) continue;
						for (i64 y = s2 + 1; y <= m; ++y) {
							if (p[x1][y1] > p[s1 + 1][y]) ++itog;
						}
					}
				}
				++s1;
			}
			else {
				for (i64 x = s1 + 1; x <= n; ++x) {
					for (i64 x1 = x; x1 <= n; ++x1) {
						if (p[x][s2 + 1] > p[x1][s2 + 1]) ++itog;
					}
				}
				for (i64 x1 = 1; x1 <= n; ++x1) {
					for (i64 y1 = 1; y1 <= s2; ++y1) {
						for (i64 x = s1 + 1; x<=n; ++x) {
							if (p[x1][y1] > p[x][s2 + 1]) ++itog;
						}
					}
				}
				for (i64 x1 = 1; x1 <= s1; ++x1) {
					for (i64 y1 = 1; y1 <= m; ++y1) {
						if (x1 <= s1 && y1 <= s2) continue;
						for (i64 x = s1 + 1; x <= n; ++x) {
							if (p[x1][y1] > p[x][s2 + 1]) ++itog;
						}
					}
				}
				++s2;
			}
			val = (val >> 1);
		}
		toMin = min(toMin, itog);
	} 

	dp[0].resize(m + 1);

	i64 ex = 0;

	for (i64 x = 1; x <= n; ++x) {
		for (i64 y = 1; y <= m; ++y) {
			dp[x][y] = INF;
			for (i64 x1 = 1; x1 <= n; ++x1) {
				for (i64 y1 = 1; y1 <= m; ++y1) {
					if (x1 >= x && y1 >= y) {
						if (p[x][y] > p[x1][y1]) {
							++alrAns;
						}
					}
					else if (x < x1 && y > y1) {
						if (p[x][y] > p[x1][y1]) {
							str[x][y1] = 1;
						}
					}
					else if (x > x1 && y < y1) {
						if (p[x][y] > p[x1][y1]) {
							col[y][x1] = 1;
						}
					}
				}
			}
		}
	}

	for (i64 x = n - 1; x >= 1; --x) {
		for (i64 y = m - 1; y >= 1; --y) {
			str[x][y] += str[x][y + 1];
			col[y][x] += col[y][x + 1];
		}
	}

	for (i64 x = 1; x <= n; ++x) {
		for (i64 y = 1; y <= m; ++y) {
			if (x == n && y == m) continue;

			if (x >= 1 && x < n) {
				dp[x][y] = min(dp[x - 1][y] + str[x][y], dp[x][y]);
			}
			if (y >= 1 && y < m) {
				dp[x][y] = min(dp[x][y - 1] + col[y][x], dp[x][y]);
			}
		}
	}

	dp[n][m] = INF;

	i64 minAns = INF;

	for (i64 x = 1; x <= n; ++x) {
		minAns = min(minAns, dp[x][m]);
	}

	for (i64 y = 1; y <= m; ++y) {
		minAns = min(minAns, dp[n][y]);
	}

	cout << toMin << endl;
	//cout << alrAns + minAns;
}