// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define vc vector
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
// #define endl "\n"

const ll inf = 1e15;
const ld eps = 1e-6;

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

void gen()
{
    random_device rd;
    ofstream cout("inp.txt");

    ll n = uniform_int_distribution<ll>(1, 10)(rd), q = 1;
    cout << n << " " << q << endl;

    vc<ll> p(n);
    iota(all(p), 0);

    shuffle(all(p), rd);

    vc<ll> s(n, 0);

    ll total = uniform_int_distribution<ll>(0, n - 1)(rd);
    for (ll i = 0; i < total; ++i)
        s[p[i]] = 1;

    copy(all(s), ostream_iterator<ll>(cout, ""));

    cout << endl;
    cout << 1;
}

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        // gen();
        solve();
        cout << endl;
    }

    return 0;
}

vc<ll> dumbsolve()
{
    ifstream cin("inp.txt");

    ll n, q;
    cin >> n >> q;

    string s;
    cin >> s;

    auto count = [&](string s)
    {
        ll cnt = 0;

        for (ll i = 0; i < n; ++i)
        {
            if (s[i] != '1')
                continue;

            if (i > 0 && s[i - 1] == '1' ||
                i + 1 < n && s[i + 1] == '1')
                cnt++;
        }

        return cnt;
    };

    vc<ll> answers{};

    while (q--)
    {
        ll k;
        cin >> k;

        ll best = 0;
        for (ll submask = 0; submask < (1 << n); submask++)
        {
            if (__popcount(submask) != k)
                continue;

            for (ll i = 0; i < n; ++i)
                if (s[i] == '1' && ((submask >> i) & 1))
                    continue;

            string t = s;

            for (ll i = 0; i < n; ++i)
                if ((submask >> i) & 1)
                    t[i] = '1';

            remax(best, count(t));
        }
        answers.push_back(best);
    }
    return answers;
}

void solve()
{
    // vc<ll> dumbans = dumbsolve();

    // copy(all(dumbans), ostream_iterator<ll>(cout, "\n"));

    // return;

    // ifstream cin("inp.txt");

    ll n, q;
    cin >> n >> q;

    string s;
    cin >> s;

    if (count(all(s), '1') == 0)
    {
        while (q--)
        {
            ll k;
            cin >> k;

            if (k <= 1)
                cout << 0 << endl;
            else
                cout << k << endl;
        }

        return;
    }

    ll ans = 0;

    for (ll i = 0; i + 2 <= n; ++i)
    {
        if (s.substr(i, 2) == "11")
        {
            ++ans;
            while (i + 1 < n && s[i + 1] == '1')
            {
                ++i;
                ++ans;
            }
        }
    }

    ll x = 0, y = 0;

    if (s.size() == 3 && s.substr(0, 3) == "101")
    {
        s[1] = '1';
        x++;
    }
    if (s.size() == 4 && s.substr(0, 4) == "0101")
    {
        s[2] = '1';
        x++;
    }
    if (s.size() >= 4 && s.substr(0, 4) == "1010")
    {
        s[1] = '1';
        x++;
    }

    reverse(all(s));

    if (s.size() == 3 && s.substr(0, 3) == "101")
    {
        s[1] = '1';
        x++;
    }
    if (s.size() == 4 && s.substr(0, 4) == "0101")
    {
        s[2] = '1';
        x++;
    }
    if (s.size() >= 4 && s.substr(0, 4) == "1010")
    {
        s[1] = '1';
        x++;
    }

    for (ll i = 0; i + 5 <= n; ++i)
    {
        if (s.substr(i, 5) == "01010")
        {
            x++;
            s[i + 2] = '1';

            // i += 4;
        }
    }

    if (s.size() >= 2 && s.substr(0, 2) == "10")
    {
        y++;
        s[1] = '1';
    }

    reverse(all(s));

    if (s.size() >= 2 && s.substr(0, 2) == "10")
    {
        y++;
        s[1] = '1';
    }

    for (ll i = 0; i + 3 <= n; ++i)
    {
        if (s.substr(i, 3) == "010")
        {
            y++;
            s[i] = '1';
        }
    }

    vc<ll> answers{};

    while (q--)
    {
        ll k;
        cin >> k;

        ll d = min(k, x);

        ll cur = d * 3;

        k -= d;

        d = min(k, y);

        cur += d * 2;

        k -= d;

        cur += ans;
        cur += k;

        // answers.push_back(cur);
        cout << cur << endl;
    }

    // if (answers != dumbans)
    // {

    //     copy(all(dumbans), ostream_iterator<ll>(cout, " "));
    //     cout << endl;
    //     copy(all(answers), ostream_iterator<ll>(cout, " "));

    //     exit(0);
    // }
}