// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define vc vector
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
// #define endl "\n"

const ll inf = 1e9;
const ld eps = 1e-6;

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
        cout << endl;
    }

    return 0;
}

struct DSU
{
    vc<ll> p, sz;

    DSU(ll n)
    {
        p = sz = vc<ll>(n);
        iota(all(p), 0);
        fill(all(sz), 1);
    }

    ll get(ll u)
    {
        return u == p[u] ? u : p[u] = get(p[u]);
    }

    void unite(ll u, ll v)
    {
        u = get(u), v = get(v);

        if (u == v)
            return;

        if (sz[u] < sz[v])
            swap(u, v);

        sz[u] += sz[v];
        p[v] = u;
    }
};

vc<vc<int>> g;
vc<ll> color;

bool isBipartite(ll u, ll curColor)
{
    color[u] = curColor;

    for (ll v : g[u])
    {
        if (color[v] == curColor)
            return true;

        if (color[v] == -1 && isBipartite(v, curColor ^ 1))
            return true;
    }
    return false;
}

void solve()
{
    ll n, r;
    cin >> n >> r;

    ll sqr = r * r;

    g.assign(n, {});

    vc<pll> a(n);

    vc<ll> allx{}, ally{};

    for (auto &[x, y] : a)
    {
        cin >> x >> y;
        allx.push_back(x);
        ally.push_back(y);
    }

    sort(all(allx));
    sort(all(ally));
    allx.erase(unique(all(allx)), allx.end());
    ally.erase(unique(all(ally)), ally.end());

    vc<vc<pll>> yByX(allx.size());
    for (ll id = 0; id < n; ++id)
    {
        auto [x, y] = a[id];
        yByX[lower_bound(all(allx), x) - allx.begin()].push_back({y, id});
    }

    for (ll i = 0; i < allx.size(); ++i)
        sort(all(yByX[i]));

    DSU dsu(n);

    for (ll u = 0; u < n; ++u)
    {
        auto [x, y] = a[u];

        ll mnx = lower_bound(all(allx), x - r) - allx.begin(),
           mxx = upper_bound(all(allx), x + r) - allx.begin();

        for (ll cx = mnx; cx < mxx; ++cx)
        {
            ll curx = allx[cx];
            ll sqdy = sqr - (x - curx) * (x - curx);

            ll dy = sqrtl(sqdy);

            for (auto it = lower_bound(all(yByX[cx]), pll{y - dy, -inf}); it != yByX[cx].end() && (*it).first <= y + dy; ++it)
            {
                ll v = (*it).second;
                if (v == u)
                    continue;
                g[u].push_back(v);
                dsu.unite(u, v);
                // g[v].push_back(u);
            }
        }
    }

    // for (ll u = 0; u < n; ++u)
    // {
    //     for (ll v = u + 1; v < n; ++v)
    //     {
    //         auto [x1, y1] = a[u];
    //         auto [x2, y2] = a[v];
    //         if ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= sqr)
    //         {
    //             g[u].push_back(v);
    //             g[v].push_back(u);
    //             dsu.unite(u, v);
    //         }
    //     }
    // }

    vc<bool> goodComp(n, false);
    vc<bool> visComp(n, false);
    color.assign(n, -1);

    for (ll u = 0; u < n; ++u)
    {
        if (visComp[dsu.get(u)] == false)
        {
            if (isBipartite(u, 0))
                goodComp[dsu.get(u)] = true;
            visComp[dsu.get(u)] = true;
        }

        if (goodComp[dsu.get(u)])
            cout << 1;
        else
            cout << 0;
    }
}