// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define vc vector
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
// #define endl "\n"

const ll inf = 1e15;
const ld eps = 1e-6;

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
        cout << endl;
    }

    return 0;
}

struct fnw
{
    vc<ll> a;

    vc<ll> val;
    vc<ll> list;

    fnw(ll n)
    {
        a.assign(n, 0);
        val.assign(n, 0);
    }

    void add(ll pos, ll d)
    {
        if (!val[pos])
        {
            list.push_back(pos);
            val[pos] += d;
        }
        for (ll i = pos; i < a.size(); i = (i | (i + 1)))
            a[i] += d;
    }

    ll sum(ll rq)
    {
        ll acc = 0;
        for (ll i = rq; i >= 0; i = (i & (i + 1)) - 1)
            acc += a[i];
        return acc;
    }

    ll sum(ll lq, ll rq)
    {
        return sum(rq) - sum(lq - 1);
    }

    void reset()
    {
        for (ll pos : list)
        {
            add(pos, -val[pos]);
            val[pos] = 0;
        }
        list.clear();
    }
};

struct counter
{
    ordered_set<ll> s;

    counter() {};

    void add(ll x)
    {
        s.insert(x);
    }
    ll getSmaller(ll x)
    {
        auto it = s.lower_bound(x);
        if (it == s.end())
            return s.size();
        return s.order_of_key(*it);
    }
    ll getBigger(ll x)
    {
        ll ans = s.size() - getSmaller(x);

        if (s.find(x) != s.end())
            ans--;

        return ans;
    }

    void reset()
    {
        s.clear();
    }
};

void solve()
{
    ll n, m;
    cin >> n >> m;

    vc<vc<ll>> a(n, vc<ll>(m));
    for (ll i = 0; i < n; ++i)
        for (ll j = 0; j < m; ++j)
        {
            cin >> a[i][j];
        }

    ll mxx = n * m - 1;
    vc<vc<ll>> dp(n, vc<ll>(m, inf));

    {
        counter cnt;
        for (ll i = n - 1, inv = 0; i >= 0; --i)
        {
            ll x = a[i][m - 1];

            inv += cnt.getSmaller(x);
            remin(dp[i][m - 1], inv);

            cnt.add(x);
        }
        cnt.reset();
    }

    {
        counter cnt;

        for (ll j = m - 1, inv = 0; j >= 0; --j)
        {
            ll x = a[n - 1][j];

            inv += cnt.getSmaller(x);
            remin(dp[n - 1][j], inv);

            cnt.add(x);
        }
        cnt.reset();
    }

    for (ll i = n - 1; i >= 0; --i)
    {
        for (ll j = m - 1; j >= 0; --j)
        {
            if (i == n - 1 && j == m - 1)
                continue;

            counter cornerCnt, rowCnt, colCnt;
            for (ll _i = i + 1; _i < n; ++_i)
                for (ll _j = j + 1; _j < m; ++_j)
                    cornerCnt.add(a[_i][_j]);
            for (ll _i = i + 1; _i < n; ++_i)
                colCnt.add(a[_i][j]);
            for (ll _j = j + 1; _j < m; ++_j)
                rowCnt.add(a[i][_j]);

            // remove top
            if (i + 1 < n)
            {
                counter cnt;
                ll inv = dp[i + 1][j];

                for (ll _j = j; _j < m; ++_j)
                {
                    ll x = a[i][_j];

                    inv += cnt.getBigger(x) + cornerCnt.getSmaller(x) + colCnt.getSmaller(x);

                    cnt.add(x);
                }
                remin(dp[i][j], inv);
            }

            // remove left
            if (j + 1 < m)
            {
                counter cnt;
                ll inv = dp[i][j + 1];

                for (ll _i = i; _i < n; ++_i)
                {
                    ll x = a[_i][j];

                    inv += cnt.getBigger(x) + cornerCnt.getSmaller(x) + rowCnt.getSmaller(x);

                    cnt.add(x);
                }
                remin(dp[i][j], inv);
            }
        }
    }

    cout << dp[0][0];
}