// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

template <class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define vc vector
#define remin(a, b) a = min(a, b)
#define remax(a, b) a = max(a, b)
// #define endl "\n"

const ll inf = 1e15;
const ld eps = 1e-6;

void acceleration()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

void solve();

int main()
{
    acceleration();

    ll t = 1;
    // cin >> t;

    while (t--)
    {
        solve();
        cout << endl;
    }

    return 0;
}

void solve()
{
    ll n, q;
    cin >> n >> q;

    vc<ll> a(n);
    for (ll &i : a)
    {
        cin >> i;
        i--;
    }

    vc<ll> sufmax = a;
    for (ll i = n - 2; i >= 0; --i)
        remax(sufmax[i], sufmax[i + 1]);

    vc<ll> idx(n);
    for (ll i = 0; i < n; ++i)
        idx[a[i]] = i;

    vc<ll> nextBigger(n);
    set<ll> vals{};
    for (ll v = n - 1; v >= 0; --v)
    {
        auto it = vals.lower_bound(idx[v]);

        if (it == vals.end())
            nextBigger[idx[v]] = n;
        else
            nextBigger[idx[v]] = *it;

        vals.insert(idx[v]);
    }

    auto getMinId = [&](ll l, ll r)
    {
        ll id = l;
        for (ll i = l + 1; i <= r; ++i)
        {
            if (a[i] < a[id])
                id = i;
        }
        return id;
    };

    vc<vc<ll>> mem(n + 1, vc<ll>{});

    while (q--)
    {
        ll k, pos;
        cin >> k >> pos;
        pos--;
        if (!mem[k].empty())
        {
            cout << mem[k][pos] + 1<< endl;
            continue;
        }

        ll l = 0;

        vc<ll> &curord = mem[k];

        for (ll id = 0; id < k; ++id)
        {
            if (id + 1 == k)
            {
                curord.push_back(sufmax[l]);
                break;
            }

            ll x = a[l];

            curord.push_back(x);

            ll r = nextBigger[l] - 1;
            remin(r, n - (k - id - 1) - 1);

            ll mnid = getMinId(l, r);

            if (mnid == l)
            {
                l += 1;
            }
            else
            {
                l = mnid;
            }
        }
        cout << curord[pos] + 1 << endl;
    }
}