#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;


struct Point {
    int x, y;

    Point(int x = 0, int y = 0) : x(x), y(y) {}

    Point operator-(const Point &other) const {
        return {x - other.x, y - other.y};
    }

    ll Len2() {
        return 1ll * x * x + 1ll * y * y;
    }
};

vector<vector<int>> g;
vector<int> col, comps, d;

void dfs(int v, int color, int comp) {
    comps[v] = comp;
    col[v] = color;
    for (auto u : g[v]) {
        if (col[u] == col[v]) {
            d[comp] = 1;
        }
        if (col[u] != -1) continue;
        dfs(u, 1 - color, comp);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    ll r;
    cin >> n >> r;
    r *= r;
    vector<Point> pts(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].x >> pts[i].y;
    }
    g.resize(n);
    col.resize(n, -1);
    comps.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((pts[i] - pts[j]).Len2() <= r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            d.emplace_back(0);
            ++cnt;
            dfs(i, 0, cnt - 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << d[comps[i]];
    }
}
