#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;


struct Point {
    int x, y;
    int id;

    Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    Point operator-(const Point &other) const {
        return {x - other.x, y - other.y};
    }

    ll Len2() {
        return 1ll * x * x + 1ll * y * y;
    }

    bool operator<(const Point &other) const {
        return x < other.x;
    }
};

vector<vector<int>> g;
vector<int> comps;
vector<short> col;
vector<bool> emp, d;

void dfs(int v, int color, int comp) {
    comps[v] = comp;
    col[v] = color;
    for (auto u : g[v]) {
        if (u == v) continue;
        if (emp[u] && col[u] != -1) continue;
        if (!emp[u] && col[u] == col[v]) {
            d[comp] = 1;
        }
        if (col[u] != -1) continue;
        if (emp[v]) {
            dfs(u, color, comp);
        } else {
            dfs(u, 1 - color, comp);
        }
    }
}


void build(int v, int cl, int cr) {
    if (cr - cl == 1) return;
    int m = (cl + cr) / 2;
    g[v].push_back(2 * v + 1);
    g[v].push_back(2 * v + 2);
    build(2 * v + 1, cl, m);
    build(2 * v + 2, m, cr);
}


int get_pos(int v, int cl, int cr, int pos) {
    if (cr - cl == 1) return v;
    int m = (cl + cr) / 2;
    if (m > pos) return get_pos(2 * v + 1, cl, m, pos);
    return get_pos(2 * v + 2, m, cr, pos);
}

void add(int v, int cl, int cr, int l, int r, int pos) {
    if (cl >= r || cr <= l) return;
    if (cl >= l && cr <= r) {
        g[pos].push_back(v);
        return;
    }
    int m = (cl + cr) / 2;
    add(2 * v + 1, cl, m, l, r, pos);
    add(2 * v + 2, m, cr, l, r, pos);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> pts(n);
    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].x >> pts[i].y;
        y[i] = pts[i].y;
        pts[i].id = i;
    }
    g.resize(4 * n);
    col.resize(4 * n, -1);
    comps.resize(4 * n);
    emp.resize(4 * n, 1);
    build(0, 0, n);
    sort(y.begin(), y.end());
    y.resize(unique(y.begin(), y.end()) - y.begin());
    unordered_map<int, int> mp_y;
    for (int i = 0; i < y.size(); ++i) {
        mp_y[y[i]] = i;
    }
    vector<vector<Point>> py(y.size());
    vector<vector<int>> py_id(y.size());
    for (int i = 0; i < n; ++i) {
        py[mp_y[pts[i].y]].push_back(pts[i]);
    }
    int cur = 0;
    vector<int> pos(n);
    for (int i = 0; i < y.size(); ++i) {
        sort(py[i].begin(), py[i].end());
        for (int j = 0; j < py[i].size(); ++j) {
            py_id[i].push_back(cur);
            ++cur;
            pos[py[i][j].id] = get_pos(0, 0, n, cur - 1);
            emp[pos[py[i][j].id]] = false;
        }
    }
    for (int i = 0; i < y.size(); ++i) {
        for (auto [x1, y1, id1] : py[i]) {
            for (int j = i; j < py.size(); ++j) {
                if (y[j] - y1 > r) break;
                ll k = r * r - 1ll * (y[j] - y1) * (y[j] - y1);
                ll left = x1 - (ll) sqrt(k);
                ll right = x1 + (ll) sqrt(k);
                if (left >= 1e9) continue;
                if (right >= 1e9) right = 1e9;
                int id = lower_bound(py[j].begin(), py[j].end(), Point(left, 0)) - py[j].begin();
                int id2 = upper_bound(py[j].begin(), py[j].end(), Point(right, 0)) - py[j].begin();
                int l = py_id[j].back() + 1, r = py_id[j].back() + 1;
                if (id != py_id[j].size()) l = py_id[j][id];
                if (id2 != py_id[j].size()) r = py_id[j][id2];
                add(0, 0, n, l, r, pos[id1]);
                if (id != 0 && (Point(x1, y1) - py[j][id - 1]).Len2() <= r * r) {
                    g[id1].push_back(pos[py[j][id - 1].id]);
                }
                if (id2 != (int) py[j].size() && (Point(x1, y1) - py[j][id2]).Len2() <= r * r) {
                    g[id1].push_back(pos[py[j][id2].id]);
                }
            }
            for (int j = i - 1; j >= 0; --j) {
                if (y1 - y[j]> r) break;
                ll k = r * r - 1ll * (y[j] - y1) * (y[j] - y1);
                ll left = x1 - (ll) sqrt(k);
                ll right = x1 + (ll) sqrt(k);
                if (left >= 1e9) continue;
                if (right >= 1e9) right = 1e9;
                int id = lower_bound(py[j].begin(), py[j].end(), Point(left, 0)) - py[j].begin();
                int id2 = upper_bound(py[j].begin(), py[j].end(), Point(right, 0)) - py[j].begin();
                int l = py_id[j].back() + 1, r = py_id[j].back() + 1;
                if (id != py_id[j].size()) l = py_id[j][id];
                if (id2 != py_id[j].size()) r = py_id[j][id2];
                add(0, 0, n, l, r, pos[id1]);
                if (id != 0 && (Point(x1, y1) - py[j][id - 1]).Len2() <= r * r) {
                    g[id1].push_back(pos[py[j][id - 1].id]);
                }
                if (id2 != (int) py[j].size() && (Point(x1, y1) - py[j][id2]).Len2() <= r * r) {
                    g[id1].push_back(pos[py[j][id2].id]);
                }
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (col[pos[i]] == -1) {
            d.emplace_back(0);
            ++cnt;
            dfs(pos[i], 0, cnt - 1);
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = d[comps[pos[i]]];
    }
    for (auto el : ans) cout << el;
}
