#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;


struct Point {
    ll x, y;
    int id;

    Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    Point operator-(const Point &other) const {
        return {x - other.x, y - other.y};
    }

    ll Len2() {
        return 1ll * x * x + 1ll * y * y;
    }

    bool operator<(const Point &other) const {
        return x < other.x;
    }
};

vector<vector<int>> g;
vector<int> col, comps, d;

void dfs(int v, int color, int comp) {
    comps[v] = comp;
    col[v] = color;
    for (auto u : g[v]) {
        if (u == v) continue;
        if (col[u] == col[v]) {
            d[comp] = 1;
        }
        if (col[u] != -1) continue;
        dfs(u, 1 - color, comp);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> pts(n);
    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].x >> pts[i].y;
        y[i] = pts[i].y;
        pts[i].id = i;
    }
    g.resize(n);
    col.resize(n, -1);
    comps.resize(n);
    sort(y.begin(), y.end());
    y.resize(unique(y.begin(), y.end()) - y.begin());
    unordered_map<int, int> mp_y;
    for (int i = 0; i < y.size(); ++i) {
        mp_y[y[i]] = i;
    }
    vector<vector<Point>> py(y.size());
    for (int i = 0; i < n; ++i) {
        py[mp_y[pts[i].y]].push_back(pts[i]);
    }
    for (int i = 0; i < y.size(); ++i) {
        sort(py[i].begin(), py[i].end());
    }
    for (int i = 0; i < py.size(); ++i) {
        for (auto [x1, y1, id1] : py[i]) {
            for (int j = i; j < py.size(); ++j) {
                if (y[j] - y1 > r) break;
                ll k = r * r - 1ll * (y[j] - y1) * (y[j] - y1);
                ll left = x1 - (ll) sqrt(k);
                ll right = x1 + (ll) sqrt(k);
                int id = lower_bound(py[j].begin(), py[j].end(), Point(left, 0)) - py[j].begin();
                for (int l = id; l < py[j].size() && py[j][l].x <= right; ++l) {
                    g[id1].push_back(py[j][l].id);
                    g[py[j][l].id].push_back(id1);
                }
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            d.emplace_back(0);
            ++cnt;
            dfs(i, 0, cnt - 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << d[comps[i]];
    }
}
