#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;


struct Point {
    int x, y;
    int id;

    Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    Point operator-(const Point &other) const {
        return {x - other.x, y - other.y};
    }

    ll Len2() {
        return 1ll * x * x + 1ll * y * y;
    }

    bool operator<(const Point &other) const {
        return x < other.x;
    }
};

vector<vector<int>> g;
vector<int> comps;
vector<short> col;
vector<bool> emp, d;

void dfs(int v, int color, int comp) {
    comps[v] = comp;
    col[v] = color;
    for (auto u : g[v]) {
        if (u == v) continue;
        if (emp[u] && col[u] != -1) continue;
        if (!emp[u] && col[u] == col[v]) {
            d[comp] = 1;
        }
        if (col[u] != -1) continue;
        if (emp[v]) {
            dfs(u, color, comp);
        } else {
            dfs(u, 1 - color, comp);
        }
    }
}


void build(int v, int cl, int cr) {
    if (cr - cl == 1) return;
    int m = (cl + cr) / 2;
    g[v].push_back(2 * v + 1);
    g[v].push_back(2 * v + 2);
    build(2 * v + 1, cl, m);
    build(2 * v + 2, m, cr);
}


int get_pos(int v, int cl, int cr, int pos) {
    if (cr - cl == 1) return v;
    int m = (cl + cr) / 2;
    if (m > pos) return get_pos(2 * v + 1, cl, m, pos);
    return get_pos(2 * v + 2, m, cr, pos);
}

void add(int v, int cl, int cr, int l, int r, int pos) {
    if (cl >= r || cr <= l) return;
    if (cl >= l && cr <= r) {
        g[pos].push_back(v);
        return;
    }
    int m = (cl + cr) / 2;
    add(2 * v + 1, cl, m, l, r, pos);
    add(2 * v + 2, m, cr, l, r, pos);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> pts(n);
    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].x >> pts[i].y;
        y[i] = pts[i].y;
        pts[i].id = i;
    }
    g.resize(4 * n);
    col.resize(4 * n, -1);
    comps.resize(4 * n);
    emp.resize(4 * n, 1);
    build(0, 0, n);
    sort(pts.begin(), pts.end());
    for (int i = 0; i < n; ++i) {
        pts[i].id = i;
    }
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[i] = get_pos(0, 0, n, i);
        emp[pos[i]] = false;
    }
    for (int i = 0; i < n; ++i) {
        int id = upper_bound(pts.begin(), pts.end(), Point(pts[i].x + r, 0)) - pts.begin();
        add(0, 0, n, i + 1, id, pos[i]);
        id = lower_bound(pts.begin(), pts.end(), Point(pts[i].x - r, 0)) - pts.begin();
        add(0, 0, n, id, i, pos[i]);
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (col[pos[i]] == -1) {
            d.emplace_back(0);
            ++cnt;
            dfs(pos[i], 0, cnt - 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << d[comps[pos[i]]];
    }
}
