#include <semaphore.h>
#include <bits/stdc++.h>

using namespace std;


using ll = long long;
using pii = pair<int, int>;

int n;
vector<int> a;
vector<vector<int>> ans;

void gen() {
    for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
        int cnt = 0;
        for (int i = 0; i < n - 1; ++i) {
            if (mask & (1 << i)) ++cnt;
        }
        vector<int> b(cnt + 1);
        int cur = 0, ptr = 0;
        for (int i = 0; i < n; ++i) {
            cur = max(cur, a[i]);
            if (i == n - 1 || mask & (1 << i)) {
                b[ptr] = cur;
                ++ptr;
                cur = 0;
            }
        }
        if (b < ans[cnt]) {
            ans[cnt] = b;
        }
    }
}

struct SegmentTree {
    struct Node {
        int mx;

        Node operator+(const Node &other) const {
            return {max(mx, other.mx)};
        }
    };
    vector<Node> tree;
    int n;

    void build(int v, int cl, int cr, vector<int> &a) {
        if (cr - cl == 1) {
            tree[v] = {a[cl]};
            return;
        }
        int m = (cl + cr) / 2;
        build(2 * v + 1, cl, m, a);
        build(2 * v + 2, m, cr, a);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    SegmentTree(vector<int> &a) {
        n = (int) a.size();
        tree.resize(4 * n);
        build(0, 0, n, a);
    }

    Node get(int v, int cl, int cr, int l, int r) {
        if (cl >= r || cr <= l) return {0};
        if (cl >= l && cr <= r) return tree[v];
        int m = (cl + cr) / 2;
        return get(2 * v + 1, cl, m, l, r) + get(2 * v + 2, m, cr, l, r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r).mx;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int q;
    cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> suf(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], a[i]);
    }
    while (q --> 0) {
        int k, i;
        cin >> k >> i;
        if (i != k) {
            cout << a[i - 1] << "\n";
        } else {
            if (k % 2 != 0 && k != 1) {
                cout << a.back() << "\n";
            } else {
                cout << suf[i - 1] << "\n";
            }
        }
    }
}
