// #define GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

long long dist(pair<int, int> p1, pair<int, int> p2) {
    return (1ll * (p1.first - p2.first) * (p1.first - p2.first) + 1ll *(p1.second - p2.second) * (p1.second - p2.second));
}

vector<vector<int>> graph;
vector<int> num_con;
vector<pair<bool, bool>> used;
vector<bool> is_ans_con;
int cur_con;

void dfs_con(int v) {
    num_con[v] = cur_con;
    for (auto u : graph[v]) {
        if (num_con[u] == -1) {
            dfs_con(u);
        }
    }
}

void dfs_ans(int v) {
    if (used[v].first && used[v].second) {
        is_ans_con[num_con[v]] = true;
    }
    for (auto u : graph[v]) {
        if (used[v].first && !used[u].second) {
            used[u].second = true;
            dfs_ans(u);
        }
        if (used[v].second && !used[u].first) {
            used[u].first = true;
            dfs_ans(u);
        }
    }
}

signed main()
{
    long long n, r;
    cin >> n >> r;
    r *= r;
    vector<pair<int, int>> a(n);
    map<pair<int, int>, int> ind_point;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        ind_point[a[i]] = i + 1;
    }
    graph.resize(n, {});
    used.resize(n, {false, false});
    num_con.resize(n, -1);
    cur_con = -1;
    is_ans_con.resize(n, false);
    for (int i = 0; i < n; i++) {
        for (int dif1 = -r; dif1 <= r; dif1++) {
            for (int dif2 = -r; dif2 <= r; dif2++) {
                pair<int, int> new_point = a[i];
                new_point.first += dif1;
                new_point.second += dif2;
                if ((dif1 || dif2) && (dist(a[i], new_point) <= r && ind_point[new_point])) {
                    graph[i].push_back(ind_point[new_point] - 1);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (num_con[i] == -1) {
            cur_con++;
            dfs_con(i);
            used[i].first = true;
            dfs_ans(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << is_ans_con[num_con[i]];
    }
    return 0;
}
