// #define GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

#define int long long

const int MAXN = 2e4 + 23;

// #pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

int fenwick[MAXN];

void upd(int ind, int x) {
    for (int i = ind; i < MAXN; i = (i | (i + 1))) {
        fenwick[i] += x;
    }
}

int get_pref(int ind) {
    int ans = 0;
    for (int i = ind; i >= 0; i = (i & (i + 1)) - 1) {
        ans += fenwick[i];
    }
    return ans;
}

int get(int l, int r) {
    return get_pref(r) - get_pref(l - 1);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int r, c;
    cin >> r >> c;
    signed a[r][c];
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    int inv_row[r][c];
    int inv_column[r][c];
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            int cur_inv = 0;
            for (int k = r - 1; k >= i; k--) {
                cur_inv += get_pref(a[k][j]);
                upd(a[k][j], 1);
            }
            inv_column[i][j] = cur_inv;
        }
        for (int j = c - 1; j >= 0; j--) {
            for (int k = i; k <= r - 1; k++) {
                upd(a[k][j], -1);
            }
        }
    }
    for (int j = c - 1; j >= 0; j--) {
        for (int i = r - 1; i >= 0; i--) {
            int cur_inv = 0;
            for (int k = c - 1; k >= j; k--) {
                cur_inv += get_pref(a[i][k]);
                upd(a[i][k], 1);
            }
            inv_row[i][j] = cur_inv;
        }
        for (int i = r - 1; i >= 0; i--) {
            for (int k = j; k <= c - 1; k++) {
                upd(a[i][k], -1);
            }
        }
    }
    int dp[r][c];
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            int prev_row = 0;
            if (j != c - 1) {
                prev_row = dp[i][j + 1];
            }
            dp[i][j] = prev_row + inv_column[i][j];
            int prev_column = 0;
            if (i != r - 1) {
                prev_column = dp[i + 1][j];
            }
            dp[i][j] = min(dp[i][j], prev_column + inv_row[i][j]);
        }
    }
    cout << dp[0][0];
    return 0;
}
