// #define GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int MAXN = 3e5 + 19;
// #define int long long

#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2")

int fenwick[MAXN];

void upd(int ind, int x) {
    for (int i = ind; i < MAXN; i = (i | (i + 1))) {
        fenwick[i] += x;
    }
}

int get_pref(int ind) {
    int ans = 0;
    for (int i = ind; i >= 0; i = (i & (i + 1)) - 1) {
        ans += fenwick[i];
    }
    return ans;
}

int get(int l, int r) {
    return get_pref(r) - get_pref(l - 1);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int r, c;
    cin >> r >> c;
    int a[r][c];
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    long long inv_row[r][c];
    long long inv_column[r][c];
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            inv_row[i][j] = 0;
            inv_column[i][j] = 0;
        }
    }
    if (r < c) {
        for (int i = r - 1; i >= 0; i--) {
            for (int j = c - 1; j >= 0; j--) {
                int cur_inv = 0;
                for (int k = r - 1; k >= i; k--) {
                    cur_inv += get_pref(a[k][j]);
                    upd(a[k][j], 1);
                }
                inv_column[i][j] = cur_inv;
            }
            for (int j = c - 1; j >= 0; j--) {
                for (int k = i; k <= r - 1; k++) {
                    upd(a[k][j], -1);
                }
            }
        }
    } else {
        for (int j = c - 1; j >= 0; j--) {
            for (int i = r - 1; i >= 0; i--) {
                upd(a[i][j], 1);
                for (int j2 = j; j2 >= 0; j2--) {
                    inv_column[i][j2] += get_pref(a[i][j2] - 1);
                }
            }
            for (int i = r - 1; i >= 0; i--) {
                upd(a[i][j], -1);
            }
        }
        for (int j = c - 1; j >= 0; j--) {
            for (int i = r - 2; i >= 0; i--) {
                inv_column[i][j] += inv_column[i + 1][j];
                upd(a[i + 1][j], 1);
                for (int j2 = j + 1; j2 < r; j2++) {
                    inv_column[i][j] += get(a[i][j2], MAXN - 1);
                }
            }
            for (int i = r - 2; i >= 0; i--) {
                upd(a[i + 1][j], -1);
            }
        }
    }
    if (c < r) {
        for (int j = c - 1; j >= 0; j--) {
            for (int i = r - 1; i >= 0; i--) {
                int cur_inv = 0;
                for (int k = c - 1; k >= j; k--) {
                    cur_inv += get_pref(a[i][k]);
                    upd(a[i][k], 1);
                }
                inv_row[i][j] = cur_inv;
            }
            for (int i = r - 1; i >= 0; i--) {
                for (int k = j; k <= c - 1; k++) {
                    upd(a[i][k], -1);
                }
            }
        }
    } else {
        for (int i = r - 1; i >= 0; i--) {
            for (int j = c - 1; j >= 0; j--) {
                upd(a[i][j], 1);
                for (int i2 = i; i2 >= 0; i2--) {
                    inv_row[i2][j] += get_pref(a[i2][j] - 1);
                }
            }
            for (int j = c - 1; j >= 0; j--) {
                upd(a[i][j], -1);
            }
        }
        for (int i = r - 1; i >= 0; i--) {
            for (int j = c - 2; j >= 0; j--) {
                inv_row[i][j] += inv_row[i][j + 1];
                upd(a[i][j + 1], 1);
                for (int i2 = i + 1; i2 < r; i2++) {
                    inv_row[i][j] += get(a[i2][j], MAXN - 1);
                }
            }
            for (int j = c - 2; j >= 0; j--) {
                upd(a[i][j + 1], -1);
            }
        }
    }
    long long dp[r][c];
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            long long prev_column = 0;
            if (j != c - 1) {
                prev_column = dp[i][j + 1];
            }
            dp[i][j] = prev_column + inv_column[i][j];
            long long prev_row = 0;
            if (i != r - 1) {
                prev_row = dp[i + 1][j];
            }
            dp[i][j] = min(dp[i][j], prev_row + inv_row[i][j]);
        }
    }
    cout << dp[0][0];
    return 0;
}
