// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int MAXN = 3e5 + 19;
const int INF = 1e9 + 69;
// #define int long long

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

pair<int, int> neutral_elem = {INF, INF};
pair<int, int> segment_tree[4 * MAXN + 1];

pair<int, int> get(int v, int vl, int vr, int l, int r) {
    if (l > vr || vl > r) {
        return neutral_elem;
    }
    if (l <= vl && vr <= r) {
        return segment_tree[v];
    }
    int m = (vl + vr) / 2;
    return min(get(2 * v, vl, m, l, r), get(2 * v + 1, m + 1, vr, l, r));
}

void upd(int v, int vl, int vr, int i, pair<int, int> x) {
    if (vl == vr) {
        segment_tree[v] = x;
        return;
    }
    int m = (vl + vr) / 2;
    if (i <= m) {
        upd(2 * v, vl, m, i, x);
    } else {
        upd(2 * v + 1, m + 1, vr, i, x);
    }
    segment_tree[v] = min(segment_tree[2 * v], segment_tree[2 * v + 1]);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, k, ind;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> next_bigger(n, n - 1);
    for (int i = 0; i < 4 * MAXN + 1; i++) {
        segment_tree[i] = neutral_elem;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        upd(1, 0, n - 1, i, {a[i], i});
    }
    vector<int> cur_stack = {};
    for (int i = n - 1; i >= 0; i--) {
        while (cur_stack.size() && a[cur_stack.back()] < a[i]) {
            cur_stack.pop_back();
        }
        if (cur_stack.size()) {
            next_bigger[i] = cur_stack.back();
        }
        cur_stack.push_back(i);
    }
    set<int> all_k;
    vector<pair<int, int>> queries;
    vector<int> suf_max(n, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf_max[i] = a[i];
        if (i != n - 1) {
            suf_max[i] = max(suf_max[i + 1], suf_max[i]);
        }
    }
    for (int i = 0; i < q; i++) {
        cin >> k >> ind;
        ind--;
        if (k != ind + 1) {
            cout << a[ind] + 1 << "\n";
        } else {
            if (ind % 2) {
                cout << suf_max[ind] + 1 << "\n";
            } else {
                cout << a[n - 1] + 1 << "\n";
            }
        }
    }
    return 0;
}
