// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

const int MAXN = 2e6 + 19;
const int INF = 1e9 + 69;
// #define int long long

#pragma GCC optimize("O3,unroll-loops")

pair<int, int> neutral_elem = {INF, INF};
vector<pair<int, int>> segment_tree;

pair<int, int> get(int v, int vl, int vr, int l, int r) {
    if (l > vr || vl > r) {
        return neutral_elem;
    }
    if (l <= vl && vr <= r) {
        return segment_tree[v];
    }
    int m = (vl + vr) / 2;
    return min(get(2 * v, vl, m, l, r), get(2 * v + 1, m + 1, vr, l, r));
}

void upd(int v, int vl, int vr, int i, pair<int, int> x) {
    if (vl == vr) {
        segment_tree[v] = x;
        return;
    }
    int m = (vl + vr) / 2;
    if (i <= m) {
        upd(2 * v, vl, m, i, x);
    } else {
        upd(2 * v + 1, m + 1, vr, i, x);
    }
    segment_tree[v] = min(segment_tree[2 * v], segment_tree[2 * v + 1]);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, k, ind;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> next_bigger(n, n - 1);
    segment_tree.resize(4 * n + 1, neutral_elem);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        upd(1, 0, n - 1, i, {a[i], i});
    }
    vector<int> cur_stack = {};
    for (int i = n - 1; i >= 0; i--) {
        while (cur_stack.size() && a[cur_stack.back()] < a[i]) {
            cur_stack.pop_back();
        }
        if (cur_stack.size()) {
            next_bigger[i] = cur_stack.back();
        }
        cur_stack.push_back(i);
    }
    set<int> all_k;
    vector<pair<int, int>> queries;
    for (int i = 0; i < q; i++) {
        cin >> k >> ind;
        ind--;
        queries.push_back({k, ind});
        all_k.insert(k);
    }
    map<pair<int, int>, int> ans_query;
    for (auto cur_k : all_k) {
        int ind_begin = 0;
        int cur_ind = 0;
        while (cur_ind != cur_k) {
            int cur_ind_min = get(1, 0, n - 1, ind_begin + 1, min(next_bigger[ind_begin], n - cur_k + cur_ind + 1)).second;
            if (cur_ind == cur_k - 2) {
                cur_ind_min = next_bigger[ind_begin];
            }
            if (cur_ind == cur_k - 1) {
                int cur_max = 0;
                for (int next_ind = ind_begin; next_ind < n; next_ind++) {
                    cur_max = max(cur_max, a[next_ind]);
                }
                ans_query[{cur_k, cur_ind}] = cur_max;
            } else {
                ans_query[{cur_k, cur_ind}] = a[ind_begin];
            }
            cur_ind++;
            ind_begin = cur_ind_min;
        }
    }
    for (int i = 0; i < q; i++) {
        cout << ans_query[queries[i]] + 1 << endl;
    }
    return 0;
}
