#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define endl "\n"
using namespace std;
typedef long long ll;
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2")

int get_inv(vector<int> &b) {
    int ans = 0;
    int n = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (b[j] > b[i]) ++ans;
        }
    }
    return ans;
}

void upd(int &x, int y) {
    if (x > y) x = y;
}


class SegTree {
private:
    vector<int> sm, promise;

    void upd(int v) {
        sm[v] = sm[2 * v] + sm[2 * v + 1];
    }
    void push(int v) {
        if (promise[v] == 0) return;
        sm[v] = 0;
        promise[2 * v] = promise[2 * v + 1] = 1;
        sm[2 * v] = sm[2 * v + 1] = 0;
        promise[v] = 0;
    }
public:
    SegTree(int n): sm(4 * n), promise(4 * n, 0){}

    void clear() {
        promise[1] = 1;
    }
    void change(int v, int l, int r, int i, int x) {
        if (r - l == 1) {
            sm[v] = x;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        if (i < m) change(2 * v, l, m, i, x);
        else change(2 * v + 1, m, r, i, x);
        upd(v);
    }

    int get_sum(int v, int l, int r, int ql, int qr) {
        assert(ql < qr);
        if (l == ql && r == qr) {
            return sm[v];
        }
        push(v);
        int m = (l + r) / 2;
        int ans = 0;
        if (ql < m) ans += get_sum(2 * v, l, m, ql, min(qr, m));
        if (qr > m) ans += get_sum(2 * v + 1, m, r, max(m, ql), qr);
        return ans;
    }

};



void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> v(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> v[i][j];
            v[i][j]--;
        }
    }
    int inf = 1e9;
    vector<vector<int>> dp(n + 1, vector<int> (m + 1, inf));

    dp[0][0] = 0;
    vector<int> cnt(n * m, 0);
    // vector<int> pr(n * m + 1, 0);
    // vector<int> cnt_b(n * m + 1, 0);
    // vector<vector<int>> inv1(n, vector<int> (m + 1, 0));
    // for (int i = 0; i < n; ++i) {
    //     for (int j = m - 1; j > -1; --j) {
    //         inv1[i][j] = inv1[i][j + 1];
    //         for (int j1 = j + 1; j1 < m; ++j1) {
    //             if (v[i][j1] < v[i][j]) ++inv1[i][j];
    //         }
    //     }
    // }
    vector<vector<int>> inv2(n + 1, vector<int> (m, 0));
    for (int j = 0; j < m; ++j) {
        for (int i = n - 1; i > -1; --i) {
            inv2[i][j] = inv2[i + 1][j];
            for (int i1 = i + 1; i1 < n; ++i1) {
                if (v[i1][j] < v[i][j]) inv2[i][j]++;
            }
        }
    }
    int mx = n * m;
    SegTree tree(n * m);
    SegTree os_tree(n * m);
    int res = 0;

    for (int a = 0; a < n; ++a) {
        // tree.build(1, 0, n * m);
        tree.clear();
        os_tree.clear();
        for (int i = 0; i < a; ++i) {
            for (int j = 0; j < m; ++j) {
                tree.change(1, 0, n * m, v[i][j], 1);
            }
        }
        res = 0;
        for (int j = m - 1; j > -1; --j) {
            res += os_tree.get_sum(1, 0, n * m, 0, v[a][j] + 1);
            os_tree.change(1, 0, n * m, v[a][j], 1);
            res += tree.get_sum(1, 0, mx, v[a][j], n * m);
        }


        for (int b = 0; b < m; ++b) {

            int res1 = inv2[a][b];
            for (int i = a; i < n; ++i) {
                // res1 += cnt_b[v[i][b]];
                res1 += tree.get_sum(1, 0, n * m, v[i][b], n * m);
            }
            upd(dp[a][b + 1], dp[a][b] + res1);
            // int res2 = inv1[a][b];
            int res2 = res;
            // for (int j = b; j < m; ++j) {
            //     // res2 += cnt_b[v[a][j]];
            //     res2 += tree.get_sum(1, 0, n * m, v[a][j], n * m);
            // }
            upd(dp[a + 1][b], dp[a][b] + res2);
            res -= tree.get_sum(1, 0, n * m, v[a][b], n * m);

            os_tree.change(1, 0, n * m, v[a][b], 0);
            res -= os_tree.get_sum(1, 0, n * m, 0, v[a][b] + 1);
            for (int i = a; i < n; ++i) {
                tree.change(1, 0, n * m, v[i][b], 1);
                res += os_tree.get_sum(1, 0, n * m, 0, v[i][b] + 1);
            }
        }
    }
    int ans = inf;
    for (int a = 0; a < n; ++a) {
        upd(ans, dp[a][m]);
    }
    for (int b = 0; b < m; ++b) {
        upd(ans, dp[n][b]);
    }
    cout << ans << endl;
}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    solve();
}