#include <bits/stdc++.h>

using namespace std;
using ll = long long;

bool dfs1(ll v, vector<vector<short int>> &g, vector<ll> &color, ll cur_c) {
    color[v] = cur_c;
    for (ll to : g[v]) {
        if (color[to] == -1) {
            if (dfs1(to, g, color, 1 - cur_c)) {
                return true;
            }
        } else if (color[to] == color[v]) {
            return true;
        }
    }
    return false;
}

void dfs2(ll v, vector<vector<short int>> &g, vector<bool> &used) {
    used[v] = true;
    for (ll to : g[v]) {
        if (!used[to]) {
            dfs2(to, g, used);
        }
    }
}

void solve1() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> c(n);
    for (ll i = 0; i < n; ++i) {
        cin >> c[i].first >> c[i].second;
    }

    vector<vector<short int>> g(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            if ((c[i].first - c[j].first) * (c[i].first - c[j].first) +
                (c[i].second - c[j].second) * (c[i].second - c[j].second) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    vector<bool> used(n, false);
    vector<ll> color(n, -1);
    for (ll i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (dfs1(i, g, color, 0)) {
                dfs2(i, g, used);
            }
        }
    }

    string s;
    for (ll i = 0; i < n; ++i) {
        if (used[i]) {
            s += '1';
        } else {
            s += '0';
        }
    }
    cout << s << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    ll ttt_ = 1;
    // cin >> ttt_;
    while (ttt_--) {
        solve1();
    }
}