#include <bits/stdc++.h>

using namespace std;
using ll = long long;

bool dfs1(ll v, vector<vector<short int>> &g, vector<ll> &color, ll cur_c) {
    color[v] = cur_c;
    for (ll to : g[v]) {
        if (color[to] == -1) {
            if (dfs1(to, g, color, 1 - cur_c)) {
                return true;
            }
        } else if (color[to] == color[v]) {
            return true;
        }
    }
    return false;
}

void dfs2(ll v, vector<vector<short int>> &g, vector<bool> &used) {
    used[v] = true;
    for (ll to : g[v]) {
        if (!used[to]) {
            dfs2(to, g, used);
        }
    }
}

void solve1() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> c(n);
    for (ll i = 0; i < n; ++i) {
        cin >> c[i].first >> c[i].second;
    }

    vector<vector<short int>> g(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            if ((c[i].first - c[j].first) * (c[i].first - c[j].first) +
                (c[i].second - c[j].second) * (c[i].second - c[j].second) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    vector<bool> used(n, false);
    vector<ll> color(n, -1);
    for (ll i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (dfs1(i, g, color, 0)) {
                dfs2(i, g, used);
            }
        }
    }

    string s;
    for (ll i = 0; i < n; ++i) {
        if (used[i]) {
            s += '1';
        } else {
            s += '0';
        }
    }
    cout << s << '\n';
}

bool check(ll x1, ll y1, ll x2, ll y2, ll r) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r;
}

void solve2() {
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> c(n);
    vector<ll> x;
    for (ll i = 0; i < n; ++i) {
        cin >> c[i].first >> c[i].second;
        x.push_back(c[i].first);
    }

    sort(x.begin(), x.end());
    x.resize(unique(x.begin(), x.end()) - x.begin());
    ll k = x.size();
    vector<vector<pair<ll, ll>>> pos(k);
    for (ll i = 0; i < n; ++i) {
        ll cur = lower_bound(x.begin(), x.end(), c[i].first) - x.begin();
        pos[cur].emplace_back(c[i].second, i);
    }
    for (ll i = 0; i < k; ++i) {
        sort(pos[i].begin(), pos[i].end());
    }

    vector<vector<short int>> g(n);
    for (ll ind = 0; ind < k; ++ind) {
        for (ll i = 0; i < pos[ind].size(); ++i) {
            for (ll j = i + 1; j < pos[ind].size(); ++j) {
                if (pos[ind][j].first - pos[ind][i].first <= r) {
                    g[pos[ind][i].second].push_back(pos[ind][j].second);
                    g[pos[ind][j].second].push_back(pos[ind][i].second);
                } else {
                    break;
                }
            }

            for (ll ind1 = ind + 1; ind1 < k && x[ind1] <= x[ind] + r; ++ind1) {
                pair<ll, ll> srch = {pos[ind][i].first, -1};
                ll cur = lower_bound(pos[ind1].begin(), pos[ind1].end(), srch) - pos[ind1].begin();
                for (ll j = cur; j < pos[ind1].size() && check(x[ind], pos[ind][i].first,
                    x[ind1], pos[ind1][j].first, r); ++j) {
                    g[pos[ind][i].second].push_back(pos[ind1][j].second);
                    g[pos[ind1][j].second].push_back(pos[ind][i].second);
                }
                for (ll j = cur - 1; j >= 0 && check(x[ind], pos[ind][i].first,
                    x[ind1], pos[ind1][j].first, r); --j) {
                    g[pos[ind][i].second].push_back(pos[ind1][j].second);
                    g[pos[ind1][j].second].push_back(pos[ind][i].second);
                }
            }
        }
    }

    vector<bool> used(n, false);
    vector<ll> color(n, -1);
    for (ll i = 0; i < n; ++i) {
        if (color[i] == -1) {
            if (dfs1(i, g, color, 0)) {
                dfs2(i, g, used);
            }
        }
    }

    string s;
    for (ll i = 0; i < n; ++i) {
        if (used[i]) {
            s += '1';
        } else {
            s += '0';
        }
    }
    cout << s << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    ll ttt_ = 1;
    // cin >> ttt_;
    while (ttt_--) {
        solve2();
    }
}