#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll get_sum(vector<ll> &t, ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return t[v];
    }
    ll m = (l + r) / 2;
    return get_sum(t, 2 * v + 1, l, m, ql, qr) + get_sum(t, 2 * v + 2, m, r, ql, qr);
}

void set_val(vector<ll> &t, ll v, ll l, ll r, ll qp, ll qx) {
    if (l > qp || r <= qp) {
        return;
    }
    if (r - l == 1) {
        t[v] = qx;
        return;
    }
    ll m = (l + r) / 2;
    set_val(t, 2 * v + 1, l, m, qp, qx);
    set_val(t, 2 * v + 2, m, r, qp, qx);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll> (c));
    for (ll i = 0; i < r; ++i) {
        for (ll j = 0; j < c; ++j) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }

    vector<vector<ll>> inv1(r, vector<ll> (c, 0)), inv2(r, vector<ll> (c, 0));
    vector<ll> t(4 * r * c, 0);
    for (ll i = r - 1; i >= 0; --i) {
        t.assign(4 * r * c, 0);
        for (ll j = c - 1; j >= 0; --j) {
            for (ll k = r - 1; k >= i; --k) {
                inv1[i][j] += get_sum(t, 0, 0, r * c, 0, a[k][j]);
                set_val(t, 0, 0, r * c, a[k][j], 1);
            }
        }
    }

    for (ll i = c - 1; i >= 0; --i) {
        t.assign(4 * r * c, 0);
        for (ll j = r - 1; j >= 0; --j) {
            for (ll k = c - 1; k >= i; --k) {
                inv2[j][i] += get_sum(t, 0, 0, r * c, 0, a[j][k]);
                set_val(t, 0, 0, r * c, a[j][k], 1);
            }
        }
    }

    vector<vector<ll>> dp(r + 1, vector<ll> (c + 1, 0));
    for (ll i = r - 1; i >= 0; --i) {
        for (ll j = c - 1; j >= 0; --j) {
            dp[i][j] = min(dp[i][j + 1] + inv1[i][j], dp[i + 1][j] + inv2[i][j]);
        }
    }
    cout << dp[0][0] << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    ll ttt_ = 1;
    // cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}