#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void build_sparse(ll n, vector<ll> &a, vector<ll> &lg, vector<vector<pair<ll, ll>>> &sparse, bool ven) {
    lg.resize(4 * n + 10);
    lg[1] = 0;
    for (ll i = 2; i < 4 * n + 10; ++i) {
        lg[i] = lg[i / 2] + 1;
    }

    sparse.resize(lg[2 * n + 2]);
    sparse[0].resize(n);
    for (ll i = 0; i < n; ++i) {
        sparse[0][i] = {a[i], i};
    }
    for (ll i = 1; i < lg[2 * n + 2]; ++i) {
        sparse[i].resize(max(0ll, n + 1 - (1 << i)));
        for (ll j = 0; j < n + 1 - (1 << i); ++j) {
            if (ven) {
                sparse[i][j] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
            } else {
                sparse[i][j] = max(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
            }
        }
    }
}

pair<ll, ll> get_min(vector<ll> &lg, vector<vector<pair<ll, ll>>> &sparse, ll l, ll r) {
    ll lglr = lg[r - l];
    return min(sparse[lglr][l], sparse[lglr][r - (1 << lglr)]);
}

pair<ll, ll> get_max(vector<ll> &lg, vector<vector<pair<ll, ll>>> &sparse, ll l, ll r) {
    ll lglr = lg[r - l];
    return max(sparse[lglr][l], sparse[lglr][r - (1 << lglr)]);
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<ll> lg;
    vector<vector<pair<ll, ll>>> sparse;
    build_sparse(n, a, lg, sparse, false);

    for (ll i = 0; i < q; ++i) {
        ll k, x;
        cin >> k >> x;
        if (k == x) {
            cout << get_max(lg, sparse, x - 1, n).first << '\n';
            continue;
        }
        cout << a[x - 1] << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    ll ttt_ = 1;
    // cin >> ttt_;
    while (ttt_--) {
        solve();
    }
}