#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>

using namespace std;

#define int long long
using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18 + 57, max_n = 1e5 + 5;

mt19937 rnd(57575757);

int gen(int l, int r) {
    return (rnd() % (r - l + 1)) + l;
}

int dist(pii a, pii b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

struct snm {
    vector<int> p, c, sz, ok;
    snm(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        c.resize(n, 0);
        ok.resize(n, 1);
        sz.resize(n, 1);
    }
    int get(int x) {
        if (p[x] == x) {
            return x;
        }
        return get(p[x]);
    }
    int get_c(int x) {
        if (x == p[x]) {
            return c[x];
        }
        return (c[x] ^ get_c(p[x]));
    }
    void unite(int a, int b) {
        int pa = get(a), pb = get(b);
        if (sz[pa] > sz[pb]) {
            swap(pa, pb);
            swap(a, b);
        }
        int ca = get_c(a), cb = get_c(b);
        if (ca == cb && pa == pb) {
            ok[pa] = 0;
            return;
        }
        if (pa == pb) {
            return;
        }
        if (ca == cb) {
            c[pa] ^= 1;
        }
        sz[pb] += sz[pa];
        p[pa] = pb;
    }
};

void solve() {
    int n, r; cin >> n >> r;
    vector<pii> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    snm s(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                if (dist(a[i], a[j]) <= r * r) {
                    s.unite(i, j);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!s.ok[s.get(i)]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
