#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18 + 57, max_n = 1e5 + 5;

mt19937 rnd(57575757);

int gen(int l, int r) {
    return (rnd() % (r - l + 1)) + l;
}

struct snm {
    vector<int> p, c, sz, ok;
    snm(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        c.resize(n, 0);
        ok.resize(n, 1);
        sz.resize(n, 1);
    }
    int get(int x) {
        if (p[x] == x) {
            return x;
        }
        return get(p[x]);
    }
    int get_c(int x) {
        if (x == p[x]) {
            return c[x];
        }
        return (c[x] ^ get_c(p[x]));
    }
    void unite(int a, int b) {
        int pa = get(a), pb = get(b);
        if (sz[pa] > sz[pb]) {
            swap(pa, pb);
            swap(a, b);
        }
        int ca = get_c(a), cb = get_c(b);
        if (ca == cb && pa == pb) {
            ok[pa] = 0;
            return;
        }
        if (pa == pb) {
            return;
        }
        if (ca == cb) {
            c[pa] ^= 1;
        }
        sz[pb] += sz[pa];
        p[pa] = pb;
    }
};

struct el {
    int x, y, id;
    explicit el(int x_ = 0, int y_ = 0, int id_ = 0) {
        x = x_, y = y_, id = id_;
    }
};

ll dist(el a, el b) {
    return 1ll * (a.x - b.x) * (a.x - b.x) + 1ll * (a.y - b.y) * (a.y - b.y);
}

bool comp(el l, el r) {
    return l.x < r.x;
}

const int c = 150;

ll hs(el a) {
    return 1ll * a.x * 1e9 + 1ll * a.y;
}

void solve() {
    ll n, r; cin >> n >> r;
    vector<el> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].id = i;
    }
// sort(a.begin(), a.end(), comp);
    snm s(n);
    gp_hash_table<ll, int> mp;
    for (auto e : a) {
        mp[hs(e)] = e.id + 1;
    }
    const int delt = 4;
    for (int i = 0; i < n; i++) {
        for (int dx = -delt; dx <= delt; dx++) {
            for (int dy = -delt; dy <= delt; dy++) {
                int j = mp[hs(el(a[i].x + dx, a[i].y + dy, -1))];
                if (j > 0 && i + 1 != j) {
                    j--;
                    if (dist(a[i], a[j]) <= r * r) {
                        s.unite(i, j);
                    }
                }
            }
        }
    }
    vector<int> vres(n, 0);
    for (int i = 0; i < n; i++) {
        if (!s.ok[s.get(i)]) {
            vres[a[i].id] = 1;
        }
    }
    for (int i : vres) {
        cout << i;
    }
}

/*
6 5
4 1
4 4
1 5
5 9
9 6
10 2
*/

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
