#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>

#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #define int long long
using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18 + 57, chs = 1e9;

mt19937 rnd(57575757);

int gen(int l, int r) {
    return (rnd() % (r - l + 1)) + l;
}

ll dist(pii a, pii b) {
    return  1ll * (a.first - b.first) * (a.first - b.first) + 1ll * (a.second - b.second) * (a.second - b.second);
}
const int max_n = 1e4 + 5;
bool mat[max_n][max_n];

void solve() {
    ll n, r; cin >> n >> r;
    vector<pii> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        mat[i][i] = 0;
        for (int j = i + 1; j < n; j++) {
            bool f = false;
            if (dist(a[i], a[j]) <= r * r) {
                f = true;
            }
            mat[i][j] = f;
            mat[j][i] = f;
        }
    }
    queue<int> q;
    vector<int> c(n, -1);
    vector<int> cs(n, 0);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (c[i] == -1) {
            q.push(i);
            c[i] = 0;
            cnt++;
            while (!q.empty()) {
                int v = q.front();
                cs[v] = cnt;
                q.pop();
                for (int u = 0; u < n; u++) {
                    if (c[u] == -1 && mat[v][u]) {
                        c[u] = 1 - c[v];
                        q.push(u);
                    }
                }
            }
        }
    }
    vector<int> res(n + 5, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (mat[i][j] && c[i] == c[j]) {
                res[cs[i]] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << res[cs[i]];
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
