#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>

using namespace std;

#define int long long
using ll = long long;
using pii = pair<int, int>;

const int inf = 1e18 + 57, max_n = 1e5 + 5;

mt19937 rnd(57575757);

int gen(int l, int r) {
    return (rnd() % (r - l + 1)) + l;
}

struct snm {
    vector<int> p, c, sz, ok;
    snm(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        c.resize(n, 0);
        ok.resize(n, 1);
        sz.resize(n, 1);
    }
    int get(int x) {
        if (p[x] == x) {
            return x;
        }
        return get(p[x]);
    }
    int get_c(int x) {
        if (x == p[x]) {
            return c[x];
        }
        return (c[x] ^ get_c(p[x]));
    }
    void unite(int a, int b) {
        int pa = get(a), pb = get(b);
        if (sz[pa] > sz[pb]) {
            swap(pa, pb);
            swap(a, b);
        }
        int ca = get_c(a), cb = get_c(b);
        if (ca == cb && pa == pb) {
            ok[pa] = 0;
            return;
        }
        if (pa == pb) {
            return;
        }
        if (ca == cb) {
            c[pa] ^= 1;
        }
        sz[pb] += sz[pa];
        p[pa] = pb;
    }
};

struct el {
    int x, y, id;
    explicit el(int x_ = 0, int y_ = 0, int id_ = 0) {
        x = x_, y = y_, id = id_;
    }
};

int dist(el a, el b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

bool comp(el l, el r) {
    return l.x < r.x;
}

const int c = 30;

void solve() {
    int n, r; cin >> n >> r;
    vector<el> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].id = i;
    }
    sort(a.begin(), a.end(), comp);
    snm s(n);
    for (int i = 0; i < n; i++) {
        for (int j = max(1ll * 0, i - c); j < min(n, i + c); j++) {
            if (i != j) {
                if (dist(a[i], a[j]) <= r * r) {
                    s.unite(i, j);
                }
            }
        }
    }
    vector<int> vres(n, 0);
    for (int i = 0; i < n; i++) {
        if (!s.ok[s.get(i)]) {
            vres[a[i].id] = 1;
        }
    }
    for (int i : vres) {
        cout << i;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
