#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <bitset>
#include <cmath>
#include <iomanip>
#include <stack>

using namespace std;

// #define int long long
using ll = long long;
using pii = pair<int, int>;

const ll inf = 1e18 + 57, max_n = 1e5 + 5;

mt19937 rnd(57575757);

int gen(int l, int r) {
    return (rnd() % (r - l + 1)) + l;
}

vector<int> ft;

void upd(int pos, int val) {
    pos++;
    for (int i = pos; i < ft.size(); i += (i & (-i))) {
        ft[i] += val;
    }
}

int f_get(int pos) {
    int res = 0;
    for (int i = pos; i > 0; i -= (i & (-i))) {
        res += ft[i];
    }
    return res;
}

int get(int l, int r) {
    return f_get(r) - f_get(l);
}

void solve() {
    int n, m; cin >> n >> m;
    int a[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    ll dp[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = inf;
        }
    }
    dp[n - 1][m - 1] = 0;
    ft.resize(n * m, 0);
    int loc_str[n][m];
    for (int i = 0; i < n; i++) {
        int res = 0;
        for (int j = m - 1; j >= 0; j--) {
            res += get(0, a[i][j]);
            upd(a[i][j], 1);
            loc_str[i][j] = res;
        }
        for (int j = m - 1; j >= 0; j--) {
            upd(a[i][j], -1);
        }
    }
    int loc_stolb[n][m];
    for (int j = 0; j < m; j++) {
        int res = 0;
        for (int i = n - 1; i >= 0; i--) {
            res += get(0, a[i][j]);
            upd(a[i][j], 1);
            loc_stolb[i][j] = res;
        }
        for (int i = n - 1; i >= 0; i--) {
            upd(a[i][j], -1);
        }
    }
    for (int i = 0; i < n; i++) {
        dp[i][m - 1] = loc_stolb[i][m - 1];
    }
    for (int j = 0; j < m; j++) {
        dp[n - 1][j] = loc_str[n - 1][j];
    }
    for (int i = n - 1; i >= 0; i--) {
        fill(ft.begin(), ft.end(), 0);
        for (int j = m - 1; j >= 0; j--) {
            //cout << "dp " << i + 1 << " " << j + 1 << " " << dp[i][j] << endl;
            for (int ni = i; ni < n; ni++) {
                upd(a[ni][j], 1);
            }
            if (j > 0) {
                int d1 = 0;
                for (int ni = i; ni < n; ni++) {
                    d1 += get(0, a[ni][j - 1]);
                }
               // cout << "next j " << i + 1 << " " << j + 1 << " " << d1 << endl;
                dp[i][j - 1] = min(dp[i][j - 1], dp[i][j] + d1 + loc_stolb[i][j - 1]);
            }
            if (i > 0) {
                int d1 = 0;
                for (int nj = j; nj < m; nj++) {
                    d1 += get(0, a[i - 1][nj]);
                }
               // cout << "next i " << i + 1 << " " << j + 1 << " " << d1 << endl;
                dp[i - 1][j] = min(dp[i - 1][j], dp[i][j] + d1 + loc_str[i - 1][j]);
            }
        }
    }
    cout << dp[0][0];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
