#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdint>
#include <unordered_map>
#define endl '\n'

using namespace std;

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

constexpr uint32_t MAXN = 100'000;

pair<int, int> pnt[MAXN];
vector<int> g[MAXN];

int64_t sq(int x)
{
	return int64_t(x) * x;
}

bool used_c[MAXN], col[MAXN];
int used_d[MAXN];

bool dfs(int v)
{
	for (int i = 0; i < g[v].size(); i++)
	{
		int nxt = g[v][i];
		if (!used_d[nxt])
		{
			used_d[nxt] = 3 - used_d[v];
			if (!dfs(nxt))
			{
				return false;
			}
		}
		else if (used_d[nxt] == used_d[v])
		{
			return false;
		}
	}
	return true;
}
void coloring(int v)
{
	used_c[v] = true;
	for (int i = 0; i < g[v].size(); i++)
	{
		int nxt = g[v][i];
		if (!used_c[nxt])
		{
			col[nxt] = col[v];
			coloring(nxt);
		}
	}
	return;
}

uint64_t pr_to_int(uint32_t x, uint32_t y)
{
	return uint64_t(x) << 32 | y;
}

void solve()
{
	int n, r;
	cin >> n >> r;
	int64_t r2 = sq(r);
	unordered_map<uint64_t, int> mp;
	for (int i = 0; i < n; i++)
	{
		cin >> pnt[i].first >> pnt[i].second;
		mp[pr_to_int(pnt[i].first, pnt[i].second)] = i;
	}
	for (int i = 0; i < n; i++)
	{
		for (int dx = 0; sq(dx) <= r2; dx++)
		{
			int64_t dx2 = sq(dx);
			for (int dy = dx == 0; sq(dy) <= r2 - dx2; dy++)
			{
				uint64_t pr_val = pr_to_int(pnt[i].first + dx, pnt[i].second + dy);
				if (mp.count(pr_val))
				{
					g[i].push_back(mp[pr_val]);
				}

				if (dy)
				{
					pr_val = pr_to_int(pnt[i].first + dx, pnt[i].second - dy);
					if (mp.count(pr_val))
					{
						g[i].push_back(mp[pr_val]);
					}

					if (dx)
					{
						pr_val = pr_to_int(pnt[i].first - dx, pnt[i].second - dy);
						if (mp.count(pr_val))
						{
							g[i].push_back(mp[pr_val]);
						}
					}
				}

				if (dx)
				{
					pr_val = pr_to_int(pnt[i].first - dx, pnt[i].second + dy);
					if (mp.count(pr_val))
					{
						g[i].push_back(mp[pr_val]);
					}
				}
			}
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (!used_c[i])
		{
			used_d[i] = 1;
			col[i] = !dfs(i);
			coloring(i);
		}
		cout << col[i];
	}

	return;
}