#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdint>
#include <unordered_map>
#define endl '\n'
#define ALL(v) v.begin(), v.end()

using namespace std;

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

constexpr uint32_t MAXN = 2'000'000;

int tree1[1 << 22], tree2[1 << 22];
void add1(int* tree, int v, int l, int r, int ind)
{
	++tree[v];
	if (l + 1 == r)
	{
		return;
	}
	int mid = (l + r) / 2;
	if (ind < mid)
	{
		add1(tree, v * 2 + 0, l, mid, ind);
	}
	else
	{
		add1(tree, v * 2 + 1, mid, r, ind);
	}
	return;
}
int get(int* tree, int v, int l, int r, int ql, int qr)
{
	if (qr <= l or r <= ql)
	{
		return 0;
	}
	if (ql <= l and r <= qr)
	{
		return tree[v];
	}
	int mid = (l + r) / 2;
	return get(tree, v * 2 + 0, l, mid, ql, qr) + get(tree, v * 2 + 1, mid, r, ql, qr);
}

void solve()
{
	int r, c;
	cin >> r >> c;
	vector<vector<int>> mas(r, vector<int>(c));
	for (int i = 0; i < r; i++)
	{
		for (int j = 0; j < c; j++)
		{
			cin >> mas[i][j];
			--mas[i][j];
		}
	}
	int N = r * c;
	int sz = 1;
	while (sz < N)
	{
		sz *= 2;
	}
	vector<vector<int64_t>> add_r(r, vector<int64_t>(c + 1)), add_c(r + 1, vector<int64_t>(c));
	for (int i = 0; i < r; i++)
	{
		fill(tree1, tree1 + 2 * sz, 0);
		fill(tree2, tree2 + 2 * sz, 0);
		for (int j = c - 1; j >= 0; j--)
		{
			add_r[i][j] = add_r[i][j + 1];
			for (int r_ind = i + 1; r_ind < r; r_ind++)
			{
				add_r[i][j] += get(tree2, 1, 0, sz, mas[r_ind][j] + 1, N);
				add1(tree1, 1, 0, sz, mas[r_ind][j]);
			}
			add_r[i][j] += get(tree2, 1, 0, sz, 0, mas[i][j]);
			add1(tree2, 1, 0, sz, mas[i][j]);
			add_r[i][j] += get(tree1, 1, 0, sz, 0, mas[i][j]);
		}
	}
	for (int j = 0; j < c; j++)
	{
		fill(tree1, tree1 + 2 * sz, 0);
		fill(tree2, tree2 + 2 * sz, 0);
		for (int i = r - 1; i >= 0; i--)
		{
			add_c[i][j] = add_c[i + 1][j];
			for (int c_ind = j + 1; c_ind < c; c_ind++)
			{
				add_c[i][j] += get(tree2, 1, 0, sz, mas[i][c_ind] + 1, N);
				add1(tree1, 1, 0, sz, mas[i][c_ind]);
			}
			add_c[i][j] += get(tree2, 1, 0, sz, 0, mas[i][j]);
			add1(tree2, 1, 0, sz, mas[i][j]);
			add_c[i][j] += get(tree1, 1, 0, sz, 0, mas[i][j]);
		}
	}

	vector<vector<int64_t>> dp(r + 1, vector<int64_t>(c + 1));
	for (int i = r - 1; i >= 0; i--)
	{
		for (int j = c - 1; j >= 0; j--)
		{
			dp[i][j] = min(dp[i + 1][j] + add_r[i][j], dp[i][j + 1] + add_c[i][j]);
		}
	}
	cout << dp[0][0];

	return;
}