#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdint>
#include <unordered_map>
#define endl '\n'
#define ALL(v) v.begin(), v.end()

using namespace std;

void solve();

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << endl;
	}
}

constexpr uint32_t MAXN = 2'000'000;

int tree[1 << 22];
void add1(int* tree, int v, int l, int r, int ind)
{
	++tree[v];
	if (l + 1 == r)
	{
		return;
	}
	int mid = (l + r) / 2;
	if (ind < mid)
	{
		add1(tree, v * 2 + 0, l, mid, ind);
	}
	else
	{
		add1(tree, v * 2 + 1, mid, r, ind);
	}
	return;
}
int get(int* tree, int v, int l, int r, int ql, int qr)
{
	if (qr <= l or r <= ql)
	{
		return 0;
	}
	if (ql <= l and r <= qr)
	{
		return tree[v];
	}
	int mid = (l + r) / 2;
	return get(tree, v * 2 + 0, l, mid, ql, qr) + get(tree, v * 2 + 1, mid, r, ql, qr);
}

void solve()
{
	int r, c;
	cin >> r >> c;
	vector<vector<int>> mas(r, vector<int>(c));
	for (int i = 0; i < r; i++)
	{
		for (int j = 0; j < c; j++)
		{
			cin >> mas[i][j];
			--mas[i][j];
		}
	}
	int N = r * c;
	int sz = 1;
	while (sz < N)
	{
		sz *= 2;
	}
	vector<vector<int64_t>> add_r1(r, vector<int64_t>(c + 1)), add_r2(r, vector<int64_t>(c + 1)), add_c1(r + 1, vector<int64_t>(c)), add_c2(r + 1, vector<int64_t>(c));
	for (int i = r - 1; i >= 0; i--)
	{
		fill(tree, tree + 2 * sz, 0);
		for (int j = c - 1; j >= 0; j--)
		{
			add_r1[i][j] = add_r1[i][j + 1] + get(tree, 1, 0, sz, 0, mas[i][j]);
			add1(tree, 1, 0, sz, mas[i][j]);
		}
	}
	for (int j = c - 1; j >= 0; j--)
	{
		fill(tree, tree + 2 * sz, 0);
		for (int i = r - 1; i >= 0; i--)
		{
			add_c1[i][j] = add_c1[i + 1][j] + get(tree, 1, 0, sz, 0, mas[i][j]);
			add1(tree, 1, 0, sz, mas[i][j]);
		}
	}

	for (int j = 0; j < c; j++)
	{
		vector<int> srt, prv;
		for (int i = r - 1; i >= 0; i--)
		{
			vector<int> nw(c - j);
			for (int col = j; col < c; col++)
			{
				nw[col - j] = mas[i][col];
			}
			sort(ALL(nw));

			int f = 0, s = 0;
			while (f < nw.size() and s < prv.size())
			{
				if (nw[f] < prv[s])
				{
					srt.push_back(nw[f]);
					++f;
					add_r2[i][j] += s;
				}
				else
				{
					srt.push_back(prv[s]);
					++s;
				}
			}
			while (f < nw.size())
			{
				srt.push_back(nw[f]);
				++f;
				add_r2[i][j] += s;
			}
			while (s < prv.size())
			{
				srt.push_back(prv[s]);
				++s;
			}

			swap(srt, prv);
			srt.clear();
		}
	}

	for (int i = 0; i < r; i++)
	{
		vector<int> srt, prv;
		for (int j = c - 1; j >= 0; j--)
		{
			vector<int> nw(r - i);
			for (int row = i; row < r; row++)
			{
				nw[row - i] = mas[row][j];
			}
			sort(ALL(nw));

			int f = 0, s = 0;
			while (f < nw.size() and s < prv.size())
			{
				if (nw[f] < prv[s])
				{
					srt.push_back(nw[f]);
					++f;
					add_c2[i][j] += s;
				}
				else
				{
					srt.push_back(prv[s]);
					++s;
				}
			}
			while (f < nw.size())
			{
				srt.push_back(nw[f]);
				++f;
				add_c2[i][j] += s;
			}
			while (s < prv.size())
			{
				srt.push_back(prv[s]);
				++s;
			}

			swap(srt, prv);
			srt.clear();
		}
	}

	vector<vector<int64_t>> dp(r + 1, vector<int64_t>(c + 1));
	for (int i = r - 1; i >= 0; i--)
	{
		for (int j = c - 1; j >= 0; j--)
		{
			dp[i][j] = min(dp[i + 1][j] + add_r1[i][j] + add_r2[i][j], dp[i][j + 1] + add_c1[i][j] + add_c2[i][j]);
		}
	}
	cout << dp[0][0];

	return;
}