#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

using ll = long long;

ll r;

bool check(pair<ll, ll> a, pair<ll, ll> b) {
	ll dx = a.first - b.first;
	ll dy = a.second - b.second;
	return dx * dx + dy * dy <= r * r;
}

vector<vector<int>> graph;

vector<ll> color;
vector<bool> ans;

void dfs(ll i) {
	for (auto p : graph[i]) {
		if (color[p] != -1) {
			if (color[p] == color[i]) ans[i] = true;
			continue;
		}
		color[p] = color[i] ^ 1;
		dfs(p);
	}
}

void dfs2(int i) {
	ans[i] = true;
	for (auto p : graph[i]) {
		if (ans[p]) continue;
		dfs2(p);
	}
}

int main()
{
	ll n; cin >> n >> r;
	vector<pair<ll, ll>> vec(n);
	for (int i = 0; i < n; i++) {
		ll x;
		cin >> x;
		vec[i] = { x, i };
		cin >> x;
	}
	vector<bool> can(n);
	sort(vec.begin(), vec.end());
	for (int i = 2; i < n; i++) {
		if (vec[i].first - vec[i - 2].first <= r) {
			can[i] = true;
		}
	}
	for (int i = 0; i < n; i++) {
		if (can[i]) {
			ll j = i;
			while (j > 0 && !can[j - 1] && vec[j].first - vec[j - 1].first <= r) {
				can[j - 1] = true;
				j--;
			}
		}
	}
	vector<bool> rans(n);
	for (int i = 0; i < n; i++) rans[vec[i].second] = can[i];
	for (auto p : rans) cout << (int)p << endl;
}
