#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

using ll = long long;

ll r;

bool check(pair<ll, ll> a, pair<ll, ll> b) {
	ll dx = a.first - b.first;
	ll dy = a.second - b.second;
	return dx * dx + dy * dy <= r * r;
}

vector<vector<ll>> graph;

vector<ll> color;
vector<bool> ans;

void dfs(ll i) {
	for (auto p : graph[i]) {
		if (color[p] != -1) {
			if (color[p] == color[i]) ans[i] = true;
			continue;
		}
		color[p] = color[i] ^ 1;
		dfs(p);
	}
}

void dfs2(int i) {
	ans[i] = true;
	for (auto p : graph[i]) {
		if (ans[p]) continue;
		dfs2(p);
	}
}

int main()
{
	ll n; cin >> n >> r;
	vector<pair<ll, ll>> vec(n);
	for (int i = 0; i < n; i++) cin >> vec[i].first >> vec[i].second;
	map<pair<ll, ll>, ll> mp;
	for (int i = 0; i < n; i++) mp[vec[i]] = i;
	sort(vec.begin(), vec.end());
	set<pair<ll, ll>> ms;
	graph.resize(n);
	ll id = 0;
	for (int i = 0; i < n; i++) {
		while (vec[i].first - vec[id].first > r) {
			ms.erase({ vec[id].second, id });
			id++;
		}
		auto iter = ms.lower_bound({ vec[i].second - r, -1 });
		while (iter != ms.end() && (*iter).first <= vec[i].second + r) {
			ll j = (*iter).second;
			if (check(vec[i], vec[j])) {
				graph[i].push_back(j);
				graph[j].push_back(i);
			}
			iter = next(iter);
			if (graph[i].size() > 300) break;
		}
		ms.insert({ vec[i].second, i });
	}
	color.resize(n, -1);
	ans.resize(n);
	for (int i = 0; i < n; i++) {
		if (color[i] != -1) continue;
		dfs(i);
	}
	vector<ll> ids;
	for (int i = 0; i < n; i++) if(ans[i]) {
		ids.push_back(i);
	}
	for (auto p : ids) dfs2(p);
	vector<bool> rans(n);
	for (int i = 0; i < n; i++) {
		rans[mp[vec[i]]] = ans[i];
	}
	for (auto p : rans) if (p == true) cout << 1; else cout << 0; cout << endl;
}
