#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

using ll = long long;

struct node {
	node* left = nullptr;
	node* right = nullptr;
	ll x = 0;

	node* clone() {
		node* nw = new node();
		nw->left = left;
		nw->right = right;
		nw->x = x;
		return nw;
	}

	node* get_left() {
		if (left == nullptr) left = new node();
		return left;
	}

	node* get_right() {
		if (right == nullptr) right = new node();
		return right;
	}

	void recalc() {
		x = get_left()->x + get_right()->x;
	}

	ll get(ll l, ll r, ll ql, ll qr) {
		if (l >= ql && r <= qr) return x;
		if (l >= qr || r <= ql) return 0;
		ll m = (l + r) / 2;
		return get_left()->get(l, m, ql, qr) + get_right()->get(m, r, ql, qr);
	}

	node* inc(ll l, ll r, ll id) {
		node* n = clone();
		if (r - l == 1) {
			n->x++;
			return n;
		}
		ll m = (l + r) / 2;
		if (id < m) n->left = n->get_left()->inc(l, m, id);
		else n->right = n->get_right()->inc(m, r, id);
		n->recalc();
		return n;
	}
};

ll MAXRC = 250010;

ll invCnt(vector<ll> vec) {
	node* st = new node();
	ll ans = 0;
	for (auto p : vec) {
		ans += st->get(0, MAXRC, p, 1e18);
		st = st->inc(0, MAXRC, p);
	}
	return ans;
}

int main() {
	ll r, c; cin >> r >> c;
	if (r == 1) {
		vector<ll> vec(c);
		for (int i = 0; i < c; i++) cin >> vec[i];
		cout << invCnt(vec) << endl;
		return 0;
	}
	MAXRC = 250010;
	vector<ll> vec1(c), vec2(c);
	for (int i = 0; i < c; i++) cin >> vec1[i];
	for (int i = 0; i < c; i++) cin >> vec2[i];

	vector<ll> vnL(1);
	node* st = new node();
	ll cur = 0;
	vector<node*> treesL(1, st);
	for (int i = 0; i < c; i++) {
		cur += st->get(0, MAXRC, vec1[i], 1e18);
		st = st->inc(0, MAXRC, vec1[i]);
		cur += st->get(0, MAXRC, vec2[i], 1e18);
		st = st->inc(0, MAXRC, vec2[i]);
		vnL.push_back(cur);
		treesL.push_back(st);
	}
	cur = 0;
	st = new node();
	node* st1 = new node();
	node* st2 = new node();
	vector<ll> vnR(1);
	vector<node*> treesR(1, st);
	for (int i = c - 1; i >= 0; i--) {
		cur += st->get(0, MAXRC, 0, vec1[i]);

		st = st->inc(0, MAXRC, vec1[i]);
		st = st->inc(0, MAXRC, vec2[i]);

		st1 = st1->inc(0, MAXRC, vec1[i]);

		cur += st1->get(0, MAXRC, vec2[i], 1e18);
		cur += st2->get(0, MAXRC, 0, vec2[i]);
		st2 = st2->inc(0, MAXRC, vec2[i]);

		vnR.push_back(cur);
		treesR.push_back(st);
	}

	ll ans = 1e18;
	cur = 0;
	for (int l = 0; l <= c; l++) {
		ll r = c - l;
		ll lans = vnL[l] + vnR[r] + cur;

		ans = min(ans, lans);
		
		if (ans < lans) break;

		if (l < c) {
			cur -= treesL[l]->get(0, MAXRC, vec1[l], 1e18);
			cur -= treesL[l]->get(0, MAXRC, vec2[l], 1e18);
			cur += treesR[r - 1]->get(0, MAXRC, 0, vec1[l]);
			cur += treesR[r - 1]->get(0, MAXRC, 0, vec2[l]);
		}
	}

	cout << ans << endl;
}