#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

using ll = long long;

vector<vector<int>> gr;
vector<int> us;

void dfs(int v, int C = 1) {
	us[v] = C;
	for (int u : gr[v]) {
		if (!us[u]) dfs(u, 3 - C);
	}
	for (int u : gr[v]) {
		if (us[u] != 3 - C) {
			us[v] = 10;
			break;
		}
	}
	if (us[v] == 10) {
		for (int u : gr[v]) {
			if (us[u] != 10) dfs(u, 3 - C);
		}
	}
}

ll foo(pair<ll, ll> a) {
	return a.first * 1e9 + a.second;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, r;
	cin >> n >> r;
	vector<pair<ll, ll>> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
	gr.resize(n);
	us.resize(n);
	unordered_map<ll, vector<int>> ma;
	for (int i = 0; i < n; i++) ma[foo({ a[i].first / r, a[i].second / r })].push_back(i);
	for (int i = 0; i < n; i++) {
		if (us[i]) continue;
		for (int Dx = -1; Dx < 2; Dx++) {
			for (int Dy = -1; Dy < 2; Dy++) {
				for (int j : ma[foo({ a[i].first / r + Dx, a[i].second / r + Dy })]) {
					if (i == j) continue;
					if ((a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second) <= r * r) {
						gr[i].push_back(j);
					}
				}
			}
		}
		if (int(gr[i].size()) > 6) {
			us[i] = 10;
		}
		if(us[i]==10) for (int u : gr[i]) us[u] = 10;
	}
	for (int i = 0; i < n; i++) {
		if (!us[i]) dfs(i);
	}
	for (int i = 0; i < n; i++) {
		if (us[i] == 10) cout << 1;
		else cout << 0;
	}
}