#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

using ll = long long;

#pragma GCC optimize("Ofast")

struct DO {
	vector<int> d;

	DO(int n) : d(n * 4) {};

	void upd(int v, int l, int r, int x, int y) {
		if (l + 1 == r) {
			d[v] += y;
			return;
		}
		int m = (l + r) / 2;
		if (x >= m) upd(v * 2 + 1, m, r, x, y);
		else upd(v * 2, l, m, x, y);
		d[v] = d[v * 2] + d[v * 2 + 1];
	}

	int ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return 0;
		int m = (l + r) / 2;
		return ans(v * 2, l, m, L, R) + ans(v * 2 + 1, m, r, L, R);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	vector<DO> d(n, DO(m*n+1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	ll N = n * m+1;
	vector<vector<ll>> dp(n + 1, vector<ll>(m + 1));
	vector<vector<ll>> pred1(n + 1, vector<ll>(m + 1));
	vector<vector<ll>> pred2(n + 1, vector<ll>(m + 1));
	for (int j = m - 1; j > -1; j--) {
		for (int i = n - 1; i > -1; i--) {

			pred1[i][j] = pred1[i][j+1];
			pred2[i][j] = pred2[i + 1][j];
			ll su = 0;
			for (int I = i + 1; I < n; I++) {
				su += d[i].ans(1, 0, N, 0, a[I][j]);
			}
			pred2[i][j] += su;
			pred1[i][j] += (n - i - 1) * (m - j - 1) - su;
		}
		for (int i = 0; i < n; i++) d[i].upd(1, 0, N, a[i][j], 1);
		for (int i = n - 1; i > -1; i--) {

			ll an1 = dp[i + 1][j] + pred1[i][j + 1];
			ll an2 = dp[i][j + 1] + pred2[i + 1][j];
			for (int I = i; I < n; I++) {
				ll x = d[I].ans(1, 0, N, 0, a[i][j]);
				an1 += x;
				an2 += x;
			}

			pred1[i][j] = an1 - dp[i + 1][j];
			pred2[i][j] = an2 - dp[i][j + 1];
			dp[i][j] = min(an1, an2);
		}
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << dp[i][j] << ' ';
		}
		cout << "\n";
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << pred1[i][j] << ' ';
		}
		cout << "\n";
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << pred2[i][j] << ' ';
		}
		cout << "\n";
	}*/
	cout << dp[0][0];
}