#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

using ll = long long;

#pragma GCC optimize("Ofast")

struct DO {
	vector<pair<int, int>> d;

	DO(int n) : d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = { a[l], l };
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = max(d[v * 2], d[v * 2 + 1]);
	}

	int ans(int v, int l, int r, int L, int R, pair<int, int> p) {
		if (d[v].first <= p.first) return -1;
		if (l >= R || r <= L) return -1;
		if (l + 1 == r) return l;
		int m = (l + r) / 2;
		int an = ans(v * 2, l, m, L, R, p);
		if (an != -1) return an;
		return ans(v * 2 + 1, m, r, L, R, p);
	}
};

struct DO_mi {
	vector<pair<int, int>> d;

	DO_mi(int n) : d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = { a[l], l };
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = min(d[v * 2], d[v * 2 + 1]);
	}

	pair<int, int> ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return { 1e9, -1 };
		int m = (l + r) / 2;
		return min(ans(v * 2, l, m, L, R), ans(v * 2 + 1, m, r, L, R));
	}
};

struct DO_ma {
	vector<pair<int, int>> d;

	DO_ma(int n) : d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = { a[l], l };
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = max(d[v * 2], d[v * 2 + 1]);
	}

	pair<int, int> ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return { -1e9, -1 };
		int m = (l + r) / 2;
		return max(ans(v * 2, l, m, L, R), ans(v * 2 + 1, m, r, L, R));
	}
};

struct DO_su {
	vector<int> d;

	DO_su(int n) :d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = a[l];
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = d[v * 2] + d[v * 2 + 1];
	}

	int ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return 0;
		int m = (l + r) / 2;
		return ans(v * 2, l, m, L, R) + ans(v * 2 + 1, m, r, L, R);
	}

};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	DO d(n);
	d.build(1, 0, n, a);
	DO_mi dmi(n);
	dmi.build(1, 0, n, a);
	DO_ma dma(n);
	dma.build(1, 0, n, a);

	vector<int> A(n);
	for (int i = 1; i < n; i++) if (a[i] > a[i - 1]) A[i] = 1;
	DO_su dsu(n);
	dsu.build(1, 0, n, A);

	int ma = 0;
	for (int c : a) ma = max(ma, c);
	while (q--) {
		int K, I;
		cin >> K >> I;
		if (K == 1) {
			cout << ma << "\n";
			continue;
		}
		int f = 0;
		if (I == K) {
			f = 1;
			I = K - 1;
		}
		int b = 0;
		int sz = 1;
		while (sz != I) {
			if (!A[b + 1]) {
				int p = d.ans(1, 0, n, b + 1, n - (K - sz), { a[b], -1 });
				if (p == -1) p = n - (K - sz);
				pair<int, int> x = dmi.ans(1, 0, n, b + 1, p + 1);
				b = x.second;
				sz++;
			}
			else {
				int L = b + 2, R = n;
				while (R - L > 1) {
					int M = (L + R) / 2;
					if (dsu.ans(1, 0, n, b + 1, M) == M - (b + 1)) L = M;
					else R = M;
				}
				L--;
				if (L - b + sz >= I) {
					b = b + I - sz;
					sz = I;
				}
				else {
					sz += L - b;
					b = L;
				}
			}
		}
		if (f) {
			cout << dma.ans(1, 0, n, b + 1, n).first << "\n";
		}
		else {
			cout << a[b] << "\n";
		}
	}
}