#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>

using namespace std;

using ll = long long;

#pragma GCC optimize("Ofast")

struct DO {
	vector<pair<int, int>> d;

	DO(int n) : d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = { a[l], l };
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = max(d[v * 2], d[v * 2 + 1]);
	}

	int ans(int v, int l, int r, int L, int R, pair<int, int> p) {
		if (d[v].first <= p.first) return -1;
		if (l >= R || r <= L) return -1;
		if (l + 1 == r) return l;
		int m = (l + r) / 2;
		int an = ans(v * 2, l, m, L, R, p);
		if (an != -1) return an;
		return ans(v * 2 + 1, m, r, L, R, p);
	}
};

struct DO_mi {
	vector<pair<int, int>> d;

	DO_mi(int n) : d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = { a[l], l };
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = min(d[v * 2], d[v * 2 + 1]);
	}

	pair<int, int> ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return { 1e9, -1 };
		int m = (l + r) / 2;
		return min(ans(v * 2, l, m, L, R), ans(v * 2 + 1, m, r, L, R));
	}
};

struct DO_ma {
	vector<pair<int, int>> d;

	DO_ma(int n) : d(n * 4) {};

	void build(int v, int l, int r, vector<int>& a) {
		if (l + 1 == r) {
			d[v] = { a[l], l };
			return;
		}
		int m = (l + r) / 2;
		build(v * 2, l, m, a);
		build(v * 2 + 1, m, r, a);
		d[v] = max(d[v * 2], d[v * 2 + 1]);
	}

	pair<int, int> ans(int v, int l, int r, int L, int R) {
		if (l >= L && r <= R) return d[v];
		if (l >= R || r <= L) return { -1e9, -1 };
		int m = (l + r) / 2;
		return max(ans(v * 2, l, m, L, R), ans(v * 2 + 1, m, r, L, R));
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	DO d(n);
	d.build(1, 0, n, a);
	DO_mi dmi(n);
	dmi.build(1, 0, n, a);
	DO_ma dma(n);
	dma.build(1, 0, n, a);
	int ma = 0;
	for (int c : a) ma = max(ma, c);
	vector<pair<int, int>> Q;
	set<int> se;
	for(int i=0;i<q;i++) {
		int K, I;
		cin >> K >> I;
		Q.push_back({ K, I - 1 });
		se.insert(K);
	}
	vector<vector<int>> maa(n+1);
	for (int K : se) {
		if (K == 1) {
			maa[K] = { dma.ans(1, 0, n, 0, n).second };
			continue;
		}
		vector<int> b;
		b.push_back(0);
		for (int i = 1; i < K; i++) {
			int p = d.ans(1, 0, n, b.back() + 1, n - (K - i), { a[b.back()], -1 });
			//int p = b.back() + 1;
			//for (; p < n - (K - i); p++) {
			//  if (a[p] > a[b.back()]) break;
			//}
			if (p == -1) p = n - (K - i);
			if (i == K - 1) {
				pair<int, int> C = dma.ans(1, 0, n, p, n);
				b.push_back(C.second);
				continue;
			}
			pair<int, int> x = dmi.ans(1, 0, n, b.back() + 1, p + 1);
			b.push_back(x.second);
		}
		maa[K] = b;
	}
	for (int i = 0; i < q; i++) {
		//cout << Q[i].first << ' ' << Q[i].second << ' ' << int(maa[Q[i].first].size()) << "\n";
		cout << a[maa[Q[i].first][Q[i].second]] << "\n";
	}
}