#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, greater<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

int n, m;
vector<vector<int>> a;

ll get_inv_row(int i, int j) {
    ordered_set T;
    ll ans = 0;
    for (int k = j; k < m; ++k) {
        ans += 1ll * T.order_of_key(a[i][k]);
        T.insert(a[i][k]);
    }
    return ans;
}

ll get_inv_col(int i, int j) {
    ordered_set T;
    ll ans = 0;
    for (int k = i; k < n; ++k) {
        ans += 1ll * T.order_of_key(a[k][j]);
        T.insert(a[k][j]);
    }
    return ans;
}

ll pupa_row(int i, int j) {
    ordered_set T;
    for (int k = j; k < m; ++k) {
        T.insert(a[i][k]);
    }
    ll ans = 0;
    for (int is = i + 1; is < n; ++is) {
        for (int js = j; js < m; ++js) {
            ans += 1ll * T.order_of_key(a[is][js]);
        }

    }
    // for (int k = j; k < m; ++k) {
    //     ans += less_then(i+1, j, a[i][k]);
    // }
    return ans;
}

ll pupa_col(int i, int j) {
    ordered_set T;
    for (int k = i; k < n; ++k) {
        T.insert(a[k][j]);
    }
    ll ans = 0;
    for (int is = i; is < n; ++is) {
        for (int js = j + 1; js < m; ++js) {
            ans += 1ll * T.order_of_key(a[is][js]);
        }
    }
    return ans;
}

void solve() {
    cin >> n >> m;

    a.resize(n, vector<int>(m));
    for (int i = 0; i< n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    vector<vector<ll>> dp(n, vector<ll>(m));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (i == n - 1 && j == m - 1) {
                dp[i][j] = 0;
                continue;
            }

            ll rw = get_inv_row(i, j) + (i + 1 < n? dp[i+1][j]: 0) + pupa_row(i, j);
            ll cl = get_inv_col(i, j) + (j + 1 < m? dp[i][j+1]: 0) + pupa_col(i,j);

            dp[i][j] = min(rw, cl);
        }
    }

    cout << dp[0][0] << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
