#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

struct segtree {
    int n;
    vector<int> t;

    segtree(vector<int> a) {
        n = len(a);
        t.resize(4*n);
        build(1, 0, n - 1, a);
    }

    void build(int v, int lx, int rx, vector<int> &a) {
        if (lx == rx) {
            t[v] = a[lx];
        } else {
            int mx = (lx + rx) / 2;
            build(v*2, lx, mx, a);
            build(v*2+1, mx+1, rx, a);
            t[v] = max(t[v*2], t[v*2+1]);
        }
    }

    int gm(int v, int lx, int rx, int l, int r) {
        if (l > rx || lx > r) return -INFi;
        if (l <= lx && rx <= r) return t[v];
        int mx = (lx + rx) / 2;
        return max(gm(v*2, lx, mx, l, r), gm(v*2+1, mx+1, rx, l, r));
    }

    int gm(int l, int r) {
        return gm(1, 0, n - 1, l, r);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        p[a[i]] = i;
    }

    segtree t(a);

    vector<vector<pair<int, int>>> quer(n+1);
    vector<int> ans(q);
    for (int i = 0; i < q; ++i) {
        int k, x;
        cin >> k >> x;
        --x;
        quer[k].emplace_back(x,i);
    }

    int k = 2;
    vector<int> b = {a[0]};
    for (int i = 0; i < n; ++i) {
        int j = p[i];
        if (i == a[0]) continue;
        if (t.gm(0, j - 1) == a[0] && t.gm(j, n - 1) == i) {
            b.push_back(i);
            break;
        }
    }

    for (auto [i, idx]: quer[2]) {
        ans[idx] = b[i];
    }

    for (auto x: ans) {
        cout << x + 1 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
