#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<int> p;
    vector<int> sz;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        sz.assign(n, 1);
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (sz[a] > sz[b]) swap(a, b);
        p[a] = b;
        sz[b] += sz[a];
        return true;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll r;
    cin >> n >> r;
    DSU dsu(2 * n);

    vector<array<ll, 2>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i][0] >> a[i][1];

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            ll dx = a[i][0] - a[j][0];
            ll dy = a[i][1] - a[j][1];
            if (dx * dx + dy * dy <= r * r) {
                dsu.unite(i + n, j);
                dsu.unite(i, j + n);
            }
        }
    }

    vector<int> ok(2 * n);
    for (int i = 0; i < n; i++) ok[dsu.get(i)] = (dsu.get(i) == dsu.get(i + n));

    for (int i = 0; i < n; i++) cout << ('1' ? ok[dsu.get(i)] : '0'); cout << '\n';

    return 0;
}
