#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<int> p;
    vector<int> sz;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        sz.assign(n, 1);
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (sz[a] > sz[b]) swap(a, b);
        p[a] = b;
        sz[b] += sz[a];
        return true;
    }
};

const ll MAXA = 1'000'000'000;

const int MAXSIZE = 10;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll r;
    cin >> n >> r;

    vector<array<ll, 2>> a(n);
    vector<ll> sq_id(n);

    gp_hash_table<ll, vector<int>> id;
    for (int i = 0; i < n; i++) {
        cin >> a[i][0] >> a[i][1];

        ll xid = a[i][0] / r;
        ll yid = a[i][1] / r;

        sq_id[i] = xid * MAXA + yid;
        id[sq_id[i]].push_back(i);
    }

    DSU dsu(2 * n);

    for (auto& [sq, vtx] : id) {
        int k = vtx.size();
        if (k > MAXSIZE) {
            for (int i = 0; i < k; i++) dsu.unite(vtx[0], vtx[i] + n), dsu.unite(vtx[i], vtx[0] + n);
        } else {
            for (int i = 0; i < k; i++) {
                for (int j = i + 1; j < k; j++) {
                    ll dx = a[vtx[i]][0] - a[vtx[j]][0];
                    ll dy = a[vtx[i]][1] - a[vtx[j]][1];
                    if (dx * dx + dy * dy <= r * r) {
                        dsu.unite(i, j + n);
                        dsu.unite(j, i + n);
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (id[sq_id[i]].size() > MAXSIZE) continue;

        for (int dx = -1; dx <= 1; dx++) {
            for (int dy = -1; dy <= 1; dy++) {
                if (dx == 0 && dy == 0) continue;

                int nxid = a[i][0] / r + dx;
                {
                    int nyid = a[i][1] / r + dy;
                    auto it = id.find(nxid * MAXA + nyid);
                    if (it != id.end()) {
                        for (auto el : it->second) {
                            ll dx = a[i][0] - a[el][0];
                            ll dy = a[i][1] - a[el][1];
                            if (dx * dx + dy * dy <= r * r) {
                                dsu.unite(i, el + n);
                                dsu.unite(el, i + n);
                            }
                        }
                    }
                }
                {
                    int nyid = a[i][1] / r - dy;
                    auto it = id.find(nxid * MAXA + nyid);
                    if (it != id.end()) {
                        for (auto el : it->second) {
                            ll dx = a[i][0] - a[el][0];
                            ll dy = a[i][1] - a[el][1];
                            if (dx * dx + dy * dy <= r * r) {
                                dsu.unite(i, el + n);
                                dsu.unite(el, i + n);
                            }
                        }
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (dsu.get(i) == dsu.get(i + n)) {
            cout << '1';
        } else {
            cout << '0';
        }
    }

    return 0;
}
