#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<int> p;
    vector<int> sz;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        sz.assign(n, 1);
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (sz[a] > sz[b]) swap(a, b);
        p[a] = b;
        sz[b] += sz[a];
        return true;
    }
};

const ll MAXA = 1'000'000'000;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll r;
    cin >> n >> r;

    vector<array<ll, 2>> a(n);

    gp_hash_table<ll, int> id;
    for (int i = 0; i < n; i++) {
        cin >> a[i][0] >> a[i][1];
        id[a[i][0] * MAXA + a[i][1]] = i;
    }

    DSU dsu(2 * n);
    for (int i = 0; i < n; i++) {
        for (int dx = -r; dx <= r; dx++) {
            for (int dy = 0; dx * dx + dy * dy <= r * r; dy++) {
                if (dx == 0 && dy == 0) continue;

                int nx = a[i][0] + dx;
                {
                    int ny = a[i][1] + dy;
                    auto it = id.find(nx * MAXA + ny);
                    if (it != id.end()) {
                        dsu.unite(i, (it->second) + n);
                        dsu.unite((it->second), i + n);
                    }
                }
                {
                    int ny = a[i][1] - dy;
                    auto it = id.find(nx * MAXA + ny);
                    if (it != id.end()) {
                        dsu.unite(i, (it->second) + n);
                        dsu.unite((it->second), i + n);
                    }
                }
            }
        }
    }

    vector<int> ok(2 * n);
    for (int i = 0; i < n; i++) ok[dsu.get(i)] = (dsu.get(i) == dsu.get(i + n));

    for (int i = 0; i < n; i++) cout << ('1' ? ok[dsu.get(i)] : '0'); cout << '\n';

    return 0;
}
