#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<int> p;
    vector<int> sz;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
        sz.assign(n, 1);
    }

    int get(int a) {
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (sz[a] > sz[b]) swap(a, b);
        p[a] = b;
        sz[b] += sz[a];
        return true;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll r;
    cin >> n >> r;

    vector<array<int, 2>> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i][0] >> a[i][1];
        a[i][1] = i;
    }
    sort(all(a));

    DSU dsu(2 * n);
    for (int i = 0; i + 1 < n; i++) {
        if (a[i + 1][0] - a[i][0] <= r) {
            dsu.unite(a[i][1], a[i + 1][1] + n);
            dsu.unite(a[i + 1][1], a[i][1] + n);
        }
    }
    for (int i = 0; i + 2 < n; i++) {
        if (a[i + 2][0] - a[i][0] <= r) {
            dsu.unite(a[i][1], a[i][1] + n);
        }
    }

    vector<int> ok(2 * n);
    for (int i = 0; i < n; i++) ok[dsu.get(i)] += (dsu.get(i) == dsu.get(i + n));

    for (int i = 0; i < n; i++) cout << ('1' ? ok[dsu.get(i)] : '0'); cout << '\n';

    return 0;
}
