#include <iostream>
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int MAXA = 1'000'250;
const ll INF = 1e18;

void inc(int pos, int d, int* f) {
    for (int i = pos; i < MAXA; i = (i | (i + 1))) f[i] += d;
}

int sum(int r, int* f) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) res += f[i];
    return res;
}

int inv[MAXA];

int table[MAXA];

int add[MAXA];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; i++) for (int j = 0; j < c; j++) cin >> a[i][j];

    vector<vector<ll>> row(r, vector<ll>(c)), col(r, vector<ll>(c));
    vector<vector<ll>> ans(r + 1, vector<ll>(c + 1, INF));

    for (int i = 0; i < r; i++) {
        // row
        {
            ll inv_c = 0;
            for (int j = 0; j < c; j++) {
                inv_c += j - sum(a[i][j], inv);
                inv_c += 1LL * i * c - sum(a[i][j], table);
                inc(a[i][j], 1, inv);
            }

            for (int j = 0; j < c; j++) {
                row[i][j] = inv_c;

                inc(a[i][j], -1, inv);
                inv_c -= sum(a[i][j], inv);
                inv_c -= 1LL * (r - i) * j - sum(a[i][j], add);
                inv_c -= 1LL * i * c - sum(a[i][j], table);

                for (int x = i; x < r; x++) {
                    inv_c += sum(a[x][j], inv);
                    inc(a[x][j], 1, add);
                }
            }

            for (int x = i; x < r; x++) {
                for (int y = 0; y < c; y++) {
                    inc(a[x][y], -1, add);
                }
            }
        }

        // col
        {
            int k = 0;
            for (int j = 0; j < c; j++) {
                ll cur = 0;

                for (int x = i; x < r; x++) {
                    cur += 1LL * i * c - sum(a[x][j], table);
                    cur += k - sum(a[x][j], add);
                    inc(a[x][j], 1, add);
                    k++;
                }

                col[i][j] = cur;
            }

            for (int x = i; x < r; x++) {
                for (int y = 0; y < c; y++) {
                    inc(a[x][y], -1, add);
                }
            }
        }


        for (int j = 0; j < c; j++) {
            inc(a[i][j], 1, table);
        }
    }

    // cout << "row\n";
    // for (int i = 0; i < r; i++) {
    //     for (int j = 0; j < c; j++) {
    //         cout << row[i][j] << " \n"[j + 1 == c];
    //     }
    // }
    // cout << "col\n";
    // for (int i = 0; i < r; i++) {
    //     for (int j = 0; j < c; j++) {
    //         cout << col[i][j] << " \n"[j + 1 == c];
    //     }
    // }

    ans[0][0] = 0;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            ans[i + 1][j] = min(ans[i + 1][j], ans[i][j] + row[i][j]);
            ans[i][j + 1] = min(ans[i][j + 1], ans[i][j] + col[i][j]);
        }
    }

    ll res = INF;
    for (int j = 0; j <= c; j++) res = min(res, ans[r][j]);
    for (int i = 0; i <= r; i++) res = min(res, ans[i][c]);
    cout << res << '\n';

    return 0;
}

/*
3 3
8 2 4
7 6 3
1 9 5
*/