#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int MAXA = 10'111;

void inc(int pos, int d, int* f) {
    for (int i = pos; i < MAXA; i = (i | (i + 1))) f[i] += d;
}

int sum(int r, int* f) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) res += f[i];
    return res;
}

int table[MAXA];
int inv[MAXA];

const ll INF = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; i++) for (int j = 0; j < c; j++) cin >> a[i][j];

    // vector<vector<ll>> row(r, vector<ll>(c)), col(r, vector<ll>(c));
    vector<vector<ll>> ans(r + 1, vector<ll>(c + 1, INF));

    ans[0][0] = 0;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            int other = 0;
            for (int x = 0; x < r; x++) {
                for (int y = 0; y < c; y++) {
                    if (x >= i && y >= j) break;
                    inc(a[x][y], 1, table);
                    other++;
                }
            }


            // row
            {
                ll delta = 0;
                for (int y = j; y < c; y++) {
                    delta += (y - j) - sum(a[i][y], inv);
                    inc(a[i][y], 1, inv);
                    delta += other - sum(a[i][y], table);
                }
                ans[i + 1][j] = min(ans[i + 1][j], ans[i][j] + delta);
                for (int y = j; y < c; y++) {
                    inc(a[i][y], -1, inv);
                }
            }

            // col
            {
                ll delta = 0;
                for (int x = i; x < r; x++) {
                    delta += (x - i) - sum(a[x][j], inv);
                    inc(a[x][j], 1, inv);
                    delta += other - sum(a[x][j], table);
                }
                ans[i][j + 1] = min(ans[i][j + 1], ans[i][j] + delta);
                for (int x = i; x < r; x++) {
                    inc(a[x][j], -1, inv);
                }
            }

            for (int x = 0; x < r; x++) {
                for (int y = 0; y < c; y++) {
                    if (x >= i && y >= j) break;
                    inc(a[x][y], -1, table);
                }
            }
        }
    }

    ll res = INF;
    for (int j = 0; j <= c; j++) res = min(res, ans[r][j]);
    for (int i = 0; i <= r; i++) res = min(res, ans[i][c]);
    cout << res << '\n';

    return 0;
}
