#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int INF = 1e9;

const int MAXN = 303030;
const int lg = 18;

array<int, 2> st[lg + 1][MAXN];

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, q;
	cin >> n >> q;
	vector<int> a(n + 2, INF);
	for (int i = 1; i <= n; i++) cin >> a[i], st[0][i] = {a[i], i};

	vector<int> suf(n + 2, 0);
	for (int i = n; i >= 1; i--) suf[i] = max(a[i], suf[i + 1]);

	for (int l = 0; (2 << l) <= n; l++) {
		for (int i = 1; i + (2 << l) - 1 <= n; i++) {
			st[l + 1][i] = min(st[l][i], st[l][i + (1 << l)]);
		}
	}

	auto get = [&](int l, int r) -> int {
		int t = __lg(r - l + 1);
		array<int, 2> res = min(st[t][l], st[t][r - (1 << t) + 1]);
		return res[1];
	};

	vector<int> nxt(n + 2);
    vector<int> st = {0};
	for (int i = 1; i <= n + 1; i++) {
		while (!st.empty()) {
			if (a[st.back()] < a[i]) {
				nxt[st.back()] = i;
				st.pop_back();
			} else {
				break;
			}
		}
		st.push_back(i);
	}

	vector<vector<int>> ans(n + 1, vector<int>(3 + 1));

	for (int k = 1; k <= n; k++) {
		int l = 0;
		int r = 0;
		for (int i = 1; i <= min(k, 3); i++) {
			if (i == k) {
				ans[k][i] = suf[r + 1];
			} else {
				int id = get(l + 1, r + 1);
				l = id;
				r = min(nxt[id] - 1, n - (k - i));
				ans[k][i] = a[id];
			}
		}
	}

	for (int query = 0; query < q; query++) {
		int k, i;
		cin >> k >> i;
		cout << ans[k][i] << '\n';
	}

	return 0;
}
