#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct FwTree {
    vector<int> t;

    FwTree(int n) {
        t.resize(n + 1);
    }

    void upd(int i, int x) {
        for (; i < (int)t.size(); i += (i & -i)) {
            t[i] += x;
        }
    }
    
    int gsum(int i) {
        int res = 0;
        for (; i >= 1; i -= (i & -i)) {
            res += t[i];
        }
        return res;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll>> gd(n, vector<ll> (m));
    vector<FwTree> td;
    for (int i = 0; i < m; i++) {
        td.push_back(FwTree(n * m));
    }
    ll ans = 0;
    for (int i = n - 1; i >= 0; i--) {
        // kek
        for (int j = m - 1; j >= 0; j--) {
            ll cur = 0;
            for (int k = j - 1; k >= 0; k--) {
                cur += td[k].gsum(a[i][j]);
                gd[i][k] += cur;
            }
        }
        for (int j = 0; j < m; j++) {
            td[j].upd(a[i][j], 1);
        }
        for (int j = 0; j < m; j++) {
            for (int k = j; k < m; k++) {
                ans += td[k].gsum(a[i][j] - 1);
            }
        }
    }
    vector<vector<ll>> gr(n, vector<ll> (m));
    vector<FwTree> tr;
    for (int i = 0; i < n; i++) {
        tr.push_back(FwTree(n * m));
    }
    for (int j = m - 1; j >= 0; j--) {
        for (int i = n - 1; i >= 0; i--) {
            ll cur = 0;
            for (int k = i - 1; k >= 0; k--) {
                cur += tr[k].gsum(a[i][j]);
                gr[k][j] += cur;
            }
        }
        for (int i = 0; i < n; i++) {
            tr[i].upd(a[i][j], 1);
        }
    }
    vector<vector<ll>> dp(n, vector<ll> (m, 1e18));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i < n - 1) {
                dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + gd[i][j]);
            }
            if (j < m - 1) {
                dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + gr[i][j]);
            }
        }
    }
    cout << ans + dp[n - 1][m - 1] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
