#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, q; cin >> n >> q;
    string s; cin >> s;
    map<ll, ll> mapa;
    ll col2 = 0, col = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') continue;
        col++;
        ll ok = 1;
        if (i != 0 && s[i - 1] == '1') ok = 0;
        if (i != n - 1 && s[i + 1] == '1') ok = 0;
        if (ok) {
            if (i != 0) mapa[i - 1]++;
            if (i != n - 1) mapa[i + 1]++;
        } else {
            col2++;
        }
    }
    set<pair<ll, ll>> s1;
    for (pair<ll, ll> el : mapa) s1.insert({el.second, -el.first});
    vector<ll> v(n + 1);
    ll now = 1;
    while (!s1.empty()) {
        pair<ll, ll> p = *s1.rbegin();
        s1.erase(s1.find(p));
        v[now] = p.first;
        now++;
        ll ind = -p.second;
        if (ind - 2 >= 0 && s1.find({mapa[ind - 2], ind - 2}) != s1.end()) {
            s1.erase(s1.find({mapa[ind - 2], ind - 2}));
            mapa[ind - 2]--;
            s1.insert({mapa[ind - 2], ind - 2});
        }
        if (ind + 2 < n && s1.find({mapa[ind + 2], ind + 2}) != s1.end()) {
            s1.erase(s1.find({mapa[ind + 2], ind + 2}));
            mapa[ind + 2]--;
            s1.insert({mapa[ind + 2], ind + 2});
        }
    }
    for (int i = 1; i <= n; i++) v[i] += v[i - 1];
    for (int i = 0; i < q; i++) {
        ll x; cin >> x;
        if (col == 0) {
            if (x >= 2) {
                cout << min(n, x) << "\n";
            } else {
                cout << 0 << "\n";
            }
            continue;
        } else if (col == 1) {
            if (x >= 1) {
                cout << min(n, x + col) << "\n";
            } else {
                cout << 0 << "\n";
            }
            continue;
        }
        ll ans = v[min(x, n)];
        ans += x;
        ans += col2;
        cout << min(n, ans) << "\n";
    }
    return 0;
}
