#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll n, r;
vector<vector<ll>> g;
vector<ll> was;
vector<ll> c;

void dfs(ll v) {
    was[v] = 1;
    for (ll to : g[v]) {
        if (was[to] == 0) {
            c[to] = (c[v] ^ 1);
            dfs(to);
        }
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    g.assign(n, {});
    was.assign(n, 0);
    c.assign(n, 0);
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].first >> v[i].second;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            ll res = (v[i].first - v[j].first) * (v[i].first - v[j].first) + (v[i].second - v[j].second) * (v[i].second - v[j].second);
            if (res <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        fill(was.begin(), was.end(), 0);
        fill(c.begin(), c.end(), 0);
        dfs(i);
        ll ok = 0;
        for (ll to : g[i]) {
            if (c[i] == c[to]) ok = 1;
        }
        cout << ok;
    }
    return 0;
}