#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll n, r;
vector<vector<ll>> g;
vector<ll> was;
vector<ll> c;
vector<ll> was1;
vector<ll> ok;

void dfs(ll v) {
    was[v] = 1;
    was1.push_back(v);
    for (ll to : g[v]) {
        if (was[to] == 0) {
            c[to] = (c[v] ^ 1);
            dfs(to);
        } else if (c[to] == c[v]) {
            ll col = 0;
            for (ll j = 0; j < was1.size(); j++) {
                ll el = was1[j];
                if (el == v || el == to) col++;
                if (col == 1 || el == v || el == to) ok[el] = 1;
                if (col == 2) break;
            }
        }
    }
    was1.pop_back();
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    g.assign(n, {});
    was.assign(n, 0);
    c.assign(n, 0);
    ok.assign(n, 0);
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].first >> v[i].second;
    sort(v.begin(), v.end());
    for (int i = 0; i < n; i++) {
        ll res = 0, ok = 0;
        if (i >= 2) {
            ll j = i - 2;
            res = ll(v[i].first - v[j].first) * ll(v[i].first - v[j].first) + ll(v[i].second - v[j].second) * ll(v[i].second - v[j].second);
            if (res <= r * r) ok = 1;
        }
        if (i + 2 < n) {
            ll j = i + 2;
            res = ll(v[i].first - v[j].first) * ll(v[i].first - v[j].first) + ll(v[i].second - v[j].second) * ll(v[i].second - v[j].second);
            if (res <= r * r) ok = 1;
        }
        if (i >= 1 && i + 1 < n) {
            res = ll(v[i - 1].first - v[i + 1].first) * ll(v[i - 1].first - v[i + 1].first) + ll(v[i - 1].second - v[i + 1].second) * ll(v[i - 1].second - v[i + 1].second);
            if (res <= r * r) ok = 1;
        }
        cout << ok;
    }
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < n; j++) {
    //         if (i == j) continue;
    //         ll res = ll(v[i].first - v[j].first) * ll(v[i].first - v[j].first) + ll(v[i].second - v[j].second) * ll(v[i].second - v[j].second);
    //         if (res <= r * r) {
    //             g[i].push_back(j);
    //         }
    //     }
    // }
    // for (int i = 0; i < n; i++) {
    //     fill(was.begin(), was.end(), 0);
    //     dfs(i);
    // }
    // for (ll el : ok) cout << el;
    return 0;
}