#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll n, r;
vector<vector<ll>> g;
vector<ll> was;
vector<ll> c;
vector<ll> was1;
vector<ll> ok;

void dfs(ll v) {
    was[v] = 1;
    was1.push_back(v);
    for (ll to : g[v]) {
        if (was[to] == 0) {
            c[to] = (c[v] ^ 1);
            dfs(to);
        } else if (c[to] == c[v]) {
            ll col = 0;
            for (int j = ll(was1.size()) - 1; j >= 0; j--) {
                col++;
                if (col > 30) break;
                ll el = was1[j];
                ok[el] = 1;
                if (el == to) break;
            }
        }
    }
    was1.pop_back();
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    g.assign(n, {});
    was.assign(n, 0);
    c.assign(n, 0);
    ok.assign(n, 0);
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].first >> v[i].second;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            ll res = ll(v[i].first - v[j].first) * ll(v[i].first - v[j].first) + ll(v[i].second - v[j].second) * ll(v[i].second - v[j].second);
            if (res <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        fill(was.begin(), was.end(), 0);
        dfs(i);
    }
    for (ll el : ok) cout << el;
    return 0;
}
