#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

ll n, r, ok1 = 0;
vector<vector<ll>> g;
vector<ll> was;
vector<ll> c;
vector<ll> was1;
vector<ll> ok;
vector<ll> h;
vector<ll> now;

void dfs(ll v) {
    was[v] = 1;
    now.push_back(v);
    for (ll to : g[v]) {
        if (was[to] == 0) {
            c[to] = (c[v] ^ 1);
            dfs(to);
        } else if (c[v] == c[to]) {
            ok1 = 1;
        }
    }
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> r;
    g.assign(n, {});
    was.assign(n, 0);
    c.assign(n, 0);
    h.assign(n, 0);
    ok.assign(n, 0);
    vector<pair<ll, ll>> v(n);
    map<pair<ll, ll>, ll> mapa;
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        mapa[v[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        for (int j1 = -r; j1 <= r; j1++) {
            for (int j2 = -r; j2 <= r; j2++) {
                ll x1 = v[i].first + j1, y1 = v[i].second + j2;
                if (j1 == 0 && j2 == 0) continue;
                if (mapa.find({x1, y1}) == mapa.end()) continue;
                ll res = (v[i].first - x1) * (v[i].first - x1) + (v[i].second - y1) * (v[i].second - y1);
                if (res <= r * r) {
                    g[i].push_back(mapa[{x1, y1}]);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (was[i] == 0) {
            ok1 = 0;
            now.clear();
            dfs(i);
            for (ll el : now) ok[el] = ok1;
        }
    }
    for (ll el : ok) cout << el;
    return 0;
}
