#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

vector<ll> tree;

void update(ll i, ll l, ll r, ll q, ll x) {
    if (q < l || q >= r) return;
    if (l == r - 1) {
        tree[i] = x;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * i + 1, l, m, q, x);
    update(2 * i + 2, m, r, q, x);
    tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

ll get_sum(ll i, ll l, ll r, ll ql, ll qr) {
    if (qr <= l || r <= ql) return 0;
    if (ql <= l && r <= qr) return tree[i];
    ll m = (l + r) / 2;
    return (get_sum(2 * i + 1, l, m, ql, qr) + get_sum(2 * i + 2, m, r, ql, qr));
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll r, c; cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1, inf));
    dp[0][0] = 0;
    tree.assign(4 * (r * c), 0);
    for (int i = 0; i <= r; i++) {
        vector<ll> was1 = tree;
        for (int j = 0; j <= c; j++) {
            vector<ll> was2 = tree;
            ll now1 = 0, now2 = 0;
            if (j != c) {
                for (int j1 = 0; j1 < r; j1++) {
                    if (get_sum(0, 0, r * c, a[j1][j], a[j1][j] + 1) == 1) continue;
                    update(0, 0, r * c, a[j1][j], 1);
                    now1 += get_sum(0, 0, r * c, a[j1][j] + 1, r * c);
                }
                tree = was2;
                dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + now1);
            }
            if (i != r) {
                for (int j1 = 0; j1 < c; j1++) {
                    if (get_sum(0, 0, r * c, a[i][j1], a[i][j1] + 1) == 1) continue;
                    update(0, 0, r * c, a[i][j1], 1);
                    now2 += get_sum(0, 0, r * c, a[i][j1] + 1, r * c);
                }
                tree = was2;
                dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + now2);
            }
            if (j != c) {
                for (int j1 = 0; j1 < r; j1++) update(0, 0, r * c, a[j1][j], 1);
            }
        }
        tree = was1;
        if (i != r) {
            for (int j1 = 0; j1 < c; j1++) {
                update(0, 0, r * c, a[i][j1], 1);
            }
        }
    }
    cout << dp[r][c];
    return 0;
}
