#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

vector<ll> tree;

void update(ll q, ll x) {
    q++;
    for (int i = q; i < tree.size(); i += (i & (-i))) tree[i] += x;

}

ll get(ll q) {
    ll sum = 0;
    q++;
    for (int i = q; i > 0; i -= (i & (-i))) sum += tree[i];
    return sum;
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll r, c; cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    tree.assign((r * c) + 2, 0);
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1, inf));
    dp[0][0] = 0;
    ll c1 = c;
    if (min(c, r) >= 200) c1 = 200;
    for (int i = 0; i <= r; i++) {
        vector<ll> was1 = tree;
        for (int j = 0; j <= min(i + c1, c); j++) {
            ll now1 = 0, now2 = 0;
            if (j != c && dp[i][j + 1] > dp[i][j]) {
                vector<ll> ind;
                for (int j1 = 0; j1 < r; j1++) {
                    if (get(a[j1][j]) - get(a[j1][j] - 1) == 1) continue;
                    update(a[j1][j], 1);
                    ind.push_back(a[j1][j]);
                    now1 += get(r * c) - get(a[j1][j]);
                }
                for (ll el : ind) update(el, -1);
                dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + now1);
            }
            if (i != r && dp[i + 1][j] > dp[i][j]) {
                vector<ll> ind;
                for (int j1 = 0; j1 < c; j1++) {
                    if (get(a[i][j1]) - get(a[i][j1] - 1) == 1) continue;
                    update(a[i][j1], 1);
                    ind.push_back(a[i][j1]);
                    now2 += get(r * c) - get(a[i][j1]);
                }
                for (ll el : ind) update(el, -1);
                dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + now2);
            }
            if (j != c) {
                for (int j1 = 0; j1 < r; j1++) {
                    if (get(a[j1][j]) - get(a[j1][j] - 1) == 0) update(a[j1][j], 1);
                }
            }
        }
        tree = was1;
        if (i != r) {
            for (int j1 = 0; j1 < c; j1++) {
                if (get(a[i][j1]) - get(a[i][j1] - 1) == 0) update(a[i][j1], 1);
            }
        }
    }
    cout << dp[r][c];
    return 0;
}
