#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;
using vl = vector<ll>;
using vc = vector<char>;
using vvi = vector<vi>;
using vvl = vector<vl>;
constexpr char nl = '\n';

struct segtree {
    int n;
    vi t;

    segtree(int _n) {
        n = _n;
        t.resize(4 * n);
    }

    void set(int v, int l, int r, int i, int x) {
        if (l + 1 == r) {
            t[v] = x;
            return;
        }
        int m = (l + r) / 2;
        if (i < m)
            set(v * 2 + 1, l, m, i, x);
        else
            set(v * 2 + 2, m, r, i, x);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return t[v];
        }
        if (qr <= l || r <= ql) {
            return 0;
        }
        int m = (l + r) / 2;
        return get(v * 2 + 1, l, m, ql, qr) + get(v * 2 + 2, m, r, ql, qr);
    }
};

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);

    int r, c;
    cin >> r >> c;
    int N = r * c;
    vvi a(r, vi(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vvl dp(r + 1, vl(c + 1, 1e15));
    dp[r][c - 1] = 0;
    segtree tr1(N);
    for (int i = r - 1; i >= 0; --i) {
        segtree trd(N), trr(N);
        for (int j = c - 1; j >= 0; --j) {
            ll ri = 0, di = 0, mr = 0, md = 0;
            for (int k = r - 1; k > i; --k) {
                trd.set(0, 0, N, a[k][j], 1);
            }

            for (int k = c - 1; k >= j; --k) {
                ri += tr1.get(0, 0, N, 0, a[i][k]);
                tr1.set(0, 0, N, a[i][k], 1);
                mr += trd.get(0, 0, N, 0, a[i][k]);
            }
            for (int k = c - 1; k >= j; --k) {
                tr1.set(0, 0, N, a[i][k], 0);
            }

            for (int k = r - 1; k >= i; --k) {
                di += tr1.get(0, 0, N, 0, a[k][j]);
                tr1.set(0, 0, N, a[k][j], 1);
                md += trr.get(0, 0, N, 0, a[k][j]);
            }
            for (int k = r - 1; k >= i; --k) {
                tr1.set(0, 0, N, a[k][j], 0);
            }

            for (int k = r - 1; k >= i; --k) {
                trr.set(0, 0, N, a[k][j], 1);
            }

            dp[i][j] = min(dp[i + 1][j] + mr + ri, dp[i][j + 1] + md + di);
        }
    }
    cout << dp[0][0];
}
