#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;
using vl = vector<ll>;
using vc = vector<char>;
using vvi = vector<vi>;
using vvl = vector<vl>;
constexpr char nl = '\n';
//
// struct segtree {
//     int n;
//     vi t;
//
//     segtree(int _n) {
//         n = _n;
//         t.resize(4 * n);
//     }
//
//     void set(int v, int l, int r, int i, int x) {
//         if (l + 1 == r) {
//             t[v] = x;
//             return;
//         }
//         int m = (l + r) / 2;
//         if (i < m)
//             set(v * 2 + 1, l, m, i, x);
//         else
//             set(v * 2 + 2, m, r, i, x);
//         t[v] = t[v * 2 + 1] + t[v * 2 + 2];
//     }
//
//     int get(int v, int l, int r, int ql, int qr) {
//         if (ql <= l && r <= qr) {
//             return t[v];
//         }
//         if (qr <= l || r <= ql) {
//             return 0;
//         }
//         int m = (l + r) / 2;
//         return get(v * 2 + 1, l, m, ql, qr) + get(v * 2 + 2, m, r, ql, qr);
//     }
// };


struct segtree {
    int n;
    vi t;

    segtree(int _n) {
        n = _n;
        t.resize(n + 1);
    }

    void set(int v, int l, int r, int i, int x) {
        ++i;
        for (; i < n; i += i & -i)
            t[i] += x;
    }

    int get(int v, int l, int r, int ql, int qr) {
        return gp(qr - 1) - gp(ql - 1);
    }

    int gp(int i) {
        ++i;
        int rs = 0;
        for (; i > 0; i -= i & -i)
            rs += t[i];
        return rs;
    }
};

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);

    int r, c;
    cin >> r >> c;
    int N = r * c;
    vvi a(r, vi(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vvl dp(r + 1, vl(c + 1, 1e15));
    vvl di(r + 1, vl(c + 1));
    vvl ri(r + 1, vl(c + 1));
    vvl mr(r + 1, vl(c + 1));
    vvl md(r + 1, vl(c + 1));
    dp[r][c - 1] = 0;
    segtree tr1(N);

    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            ri[i][j] = ri[i][j + 1] + tr1.get(0, 0, N, 0, a[i][j]);
            tr1.set(0, 0, N, a[i][j], 1);
        }
        for (int j = c - 1; j >= 0; --j) {
            tr1.set(0, 0, N, a[i][j], -1);
        }
    }
    for (int j = c - 1; j >= 0; --j) {
        for (int i = r - 1; i >= 0; --i) {
            di[i][j] = di[i + 1][j] + tr1.get(0, 0, N, 0, a[i][j]);
            tr1.set(0, 0, N, a[i][j], 1);
        }
        for (int i = r - 1; i >= 0; --i) {
            tr1.set(0, 0, N, a[i][j], -1);
        }
    }
    segtree trd(N), trr(N), trx(N);
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            // ll mr = 0, md = 0;
            for (int k = r - 1; k > i; --k) {
                trd.set(0, 0, N, a[k][j], 1);
                mr[i][j] += trx.get(0, 0, N, a[k][j], N);
            }
            mr[i][j] += mr[i][j + 1] + trd.get(0, 0, N, 0, a[i][j]);
            trx.set(0, 0, N, a[i][j], 1);

            for (int k = r - 1; k >= i; --k) {
                md[i][j] += trr.get(0, 0, N, 0, a[k][j]);
            }

            for (int k = r - 1; k >= i; --k) {
                trr.set(0, 0, N, a[k][j], 1);
            }

            dp[i][j] = min(dp[i + 1][j] + mr[i][j] + ri[i][j], dp[i][j + 1] + md[i][j] + di[i][j]);
        }
        for (int j = c - 1; j >= 0; --j) {
            for (int k = r - 1; k > i; --k) {
                trd.set(0, 0, N, a[k][j], -1);
            }
            trx.set(0, 0, N, a[i][j], -1);

            for (int k = r - 1; k >= i; --k) {
                trr.set(0, 0, N, a[k][j], -1);
            }
        }
    }
    cout << dp[0][0];
}
