#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef long long ll;

struct Point {
    ll x, y;

    Point(ll x = 0, ll y = 0) : x(x), y(y) {}
};

ll get_sqr_dist(const Point &a, const Point &b) {
    ll dx = a.x - b.x;
    ll dy = a.y - b.y;
    return dx * dx + dy * dy;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> pts(n);
    for (auto &[x, y] : pts) {
        cin >> x >> y;
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (get_sqr_dist(pts[i], pts[j]) <= r * r) {
                g[i].emplace_back(j);
                g[j].emplace_back(i);
                //cout << i << ' ' << j << '\n';
            }
        }
    }
    vector<int> col(n, -1);
    vector<int> vis;
    vis.reserve(n);
    auto dfs = [&] (auto &&self, int v, int c) -> bool {
        col[v] = c;
        bool find = false;
        vis.emplace_back(v);
        for (int u : g[v]) {
            if (col[u] == -1) {
                find |= self(self, u, c ^ 1);
            } else {
                find |= (col[u] == col[v]);
            }
        }
        return find;
    };
    vector<int> ans(n);
    for (int v = 0; v < n; ++v) {
        if (col[v] == -1) {
            bool find = dfs(dfs, v, 0);
            for (auto u : vis) {
                ans[u] = find;
            }
            vis.clear();
        }
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << '\n';
    return 0;
}
