#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef long long ll;

struct Point {
    ll x, y;

    Point(ll x = 0, ll y = 0) : x(x), y(y) {}
};

ll get_sqr_dist(const Point &a, const Point &b) {
    ll dx = a.x - b.x;
    ll dy = a.y - b.y;
    return dx * dx + dy * dy;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> pts(n);
    for (auto &[x, y] : pts) {
        cin >> x >> y;
    }
    vector<int> col(n, -1);
    auto dfs = [&] (auto &&self, int v, int c) -> bool {
        col[v] = c;
        bool find = false;
        for (int u = 0; u < n; ++u) {
            if (v == u || get_sqr_dist(pts[v], pts[u]) > r * r) {
                continue;
            }
            //cout << v << ' ' << u << endl;
            if (col[u] == -1) {
                find |= self(self, u, c ^ 1);
            } else {
                find |= (col[u] == col[v]);
            }
        }
        return find;
    };
    vector<int> f;
    for (int v = 0; v < n; ++v) {
        if (col[v] == -1) {
            bool find = dfs(dfs, v, 2 * (int) f.size());
            f.emplace_back(find);
            //cout << find << endl;
        }
    }
    for (int v = 0; v < n; ++v) {
        cout << f[col[v] / 2];
    }
    cout << '\n';
    return 0;
}
