#include <iostream>
#include <set>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;

const int INF = 1e9;

struct Point {
    ll x, y;

    Point(ll x = 0, ll y = 0) : x(x), y(y) {}
};

ll get_sqr_dist(const Point &a, const Point &b) {
    ll dx = a.x - b.x;
    ll dy = a.y - b.y;
    return dx * dx + dy * dy;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, r;
    cin >> n >> r;
    vector<Point> pts(n);
    gp_hash_table<ll, int> mp;
    for (int i = 0; i < n; ++i) {
        auto &[x, y] = pts[i];
        cin >> x >> y;
        mp[x * INF + y] = i;
    }
    vector<int> col(n, -1);
    vector<pair<int, int>> V = {make_pair(-r, -r / 2), make_pair(r / 2, r)};
    auto dfs = [&] (auto &&self, int v, int c) -> bool {
        col[v] = c;
        bool find = false;
        for (int mask = 0; mask < 4; ++mask) {
            for (int dx = V[mask & 1].first; dx <= V[mask & 1].second; ++dx) {
                for (int dy = V[((mask >> 1) & 1)].first; dy <= V[((mask >> 1) & 1)].second; ++dy) {
                    ll x = pts[v].x + dx, y = pts[v].y + dy;
                    //cout << dx << ' ' << dy << endl;
                    if (mp.find(x * INF + y) == mp.end()) {
                        continue;
                    }
                    int u = mp[x * INF + y];
                    if (v == u || get_sqr_dist(pts[v], pts[u]) > ll(r) * r) {
                        continue;
                    }
                    if (col[u] == -1) {
                        find |= self(self, u, c ^ 1);
                    } else {
                        find |= (col[u] == col[v]);
                    }
                }

            }
        }

        return find;
    };
    vector<int> f;
    for (int v = 0; v < n; ++v) {
        if (col[v] == -1) {
            bool find = dfs(dfs, v, 2 * (int) f.size());
            f.emplace_back(find);
            //cout << find << endl;
        }
    }
    for (int v = 0; v < n; ++v) {
        cout << f[col[v] / 2];
    }
    cout << '\n';
    return 0;
}
