#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef long long ll;

const ll INF = 1e18;

struct Fenwick {
    vector<int> f;

    Fenwick(int n) : f(n + 1) {}

    void add(int p, int x) {
        while (p < (int) f.size()) {
            f[p] += x;
            p += p & -p;
        }
    }

    int get(int p) {
        int ans = 0;
        while (p > 0) {
            ans += f[p];
            p -= p & -p;
        }
        return ans;
    }
};

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int> (c));
    for (auto &i : a) {
        for (int &j : i) {
            cin >> j;
        }
    }
    vector<vector<ll>> dp(2, vector<ll> (c + 1, INF));
    dp[0][0] = 0;
    vector<vector<Fenwick>> f(2, vector<Fenwick> (c + 1, r * c + 1));
    vector<vector<int>> s(2, vector<int> (c + 1));
    int q = 1, t = 0;
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            dp[q][j] = INF;
        }
        for (int j = 0; j < c; ++j) {
            {
                int x = 0;
                f[t][j + 1] = f[t][j];
                s[t][j + 1] = s[t][j];
                //cout << dp[i][j] << endl;
                for (int k = i; k < r; ++k) {
                    x += s[t][j + 1] - f[t][j + 1].get(a[k][j]);
                    //cout << i << ' ' << j << ' ' << k << ' ' << a[k][j] << ' ' << s[i][j + 1] - f[i][j + 1].get(a[k][j]) << ' ' << x << endl;
                    f[t][j + 1].add(a[k][j], 1);
                    s[t][j + 1]++;
                }
                dp[t][j + 1] = min(dp[t][j + 1], dp[t][j] + x);
            }
            {
                int x = 0;
                f[q][j] = f[t][j];
                s[q][j] = s[t][j];
                for (int k = j; k < c; ++k) {
                    x += s[q][j] - f[q][j].get(a[i][k]);
                    f[q][j].add(a[i][k], 1);
                    s[q][j]++;
                }
                dp[q][j] = min(dp[q][j], dp[t][j] + x);
            }
            //cout << endl;
        }
        swap(t, q);
    }
    /*for (auto &i : dp) {
        for (auto &j : i) {
            cout << j << ' ';
        }
        cout << '\n';
    }*/
    ll ans = min(dp[q][c], dp[t][c - 1]);
    cout << ans << '\n';
    return 0;
}
