#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef long long ll;

const ll INF = 1e18;

struct Fenwick {
    vector<int> f;

    Fenwick(int n) : f(n + 1) {}

    void add(int p, int x) {
        while (p < (int) f.size()) {
            f[p] += x;
            p += p & -p;
        }
    }

    int get(int p) {
        int ans = 0;
        while (p > 0) {
            ans += f[p];
            p -= p & -p;
        }
        return ans;
    }
};

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int> (c));
    for (auto &i : a) {
        for (int &j : i) {
            cin >> j;
        }
    }
    Fenwick f(r * c + 1);
    ll ans = 0;
    for (int i = 0; i < r; ++i) {
        for (int k = 0; k < c; ++k) {
            ans += k - f.get(a[i][k]);
            //cout << k - f.get(a[i][k]) << ' ';
            f.add(a[i][k], 1);
        }
    }
    cout << ans << '\n';
    return 0;
}
