#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

struct FenwTree {
    vector<int> tree;
    int n;

    FenwTree(int _n = 0) {
        n = _n;
        tree.resize(n + 1);
    }

    int F(int x) { return x & -x; }

    int get(int i) {
        int ans = 0;
        i++;
        for (; i > 0; i -= F(i)) ans += tree[i];
        return ans;
    }

    void upd(int i, int x) {
        i++;
        for (; i <= n; i += F(i)) tree[i] += x;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (auto &x: a) {
        for (auto &y: x) {
            cin >> y;
            y--;
        }
    }
    vector<vector<int> > ver(n, vector<int>(m));
    vector<vector<int> > gor(n, vector<int>(m));
    vector<FenwTree> tree(n, FenwTree(n * m));
    for (int j = m - 1; j >= 0; j--) {
        FenwTree now(n * m);
        int cur = 0;
        for (int i = n - 1; i >= 0; i--) {
            cur += now.get(a[i][j]);
            ver[i][j] = cur;
            now.upd(a[i][j], 1);
            for (int i1 = i; i1 < n; i1++)
                ver[i][j] += tree[i].get(a[i1][j]);
        }
        for (int i = n - 1; i >= 0; i--) {
            for (int i1 = i; i1 < n; i1++) {
                tree[i].upd(a[i1][j], 1);
            }
        }
    }
    tree.resize(m);
    fill(all(tree), FenwTree(n * m));
    for (int i = n - 1; i >= 0; i--) {
        FenwTree now(n * m);
        int cur = 0;
        for (int j = m - 1; j >= 0; j--) {
            cur += now.get(a[i][j]);
            gor[i][j] = cur;
            now.upd(a[i][j], 1);
            for (int j1 = j; j1 < m; j1++)
                gor[i][j] += tree[j].get(a[i][j1]);
        }
        for (int j = 0; j < m; j++) {
            for (int j1 = j; j1 < m; j1++) {
                tree[j].upd(a[i][j1], 1);
            }
        }
    }
    vector<vector<int> > dp(n, vector<int>(m, 1e18));
    dp[n - 1][m - 1] = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i < n - 1) {
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + gor[i][j]);
            }
            if (j < m - 1) {
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + ver[i][j]);
            }
        }
    }
    cout << dp[0][0];
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
