#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<vector<int>> g;
vector<bool> used;
vector<int> comp;
vector<bool> dp;
vector<bool> ans;
bool cycle = false;

void dfs1(int v, int p = -1) {
    if (cycle) {
        return;
    }
    used[v] = true;
    comp.push_back(v);
    for (auto u : g[v]) {
        if (!used[u]) {
            dp[u] = dp[v] ^ 1;
            dfs1(u, v);
        } else if (u != p) {
            if (dp[u] == dp[v]) {
                cycle = true;
                return;
            }
        }
    }
}

void dfs2(int v) {
    used[v] = true;
    ans[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs2(u);
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    ll r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
    }
    auto dist = [&](int i, int j) {
        return (a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second);
    };
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (dist(i, j) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    used.resize(n);
    dp.resize(n);
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comp.clear();
            cycle = false;
            dfs1(i);
            if (cycle) {
                for (auto j : comp) {
                    used[j] = false;
                }
                dfs2(i);
            }
        }
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << "\n";
    return 0;
}