#include <iostream>
#include <vector>
#include <map>
#include <cstdint>
#include <cmath>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<vector<int>> g;
vector<bool> used;
vector<int> comp;
vector<bool> dp;
vector<bool> ans;
bool cycle = false;

void dfs1(int v, int p = -1) {
    if (cycle) {
        return;
    }
    used[v] = true;
    comp.push_back(v);
    for (auto u : g[v]) {
        if (!used[u]) {
            dp[u] = dp[v] ^ 1;
            dfs1(u, v);
        } else if (u != p) {
            if (dp[u] == dp[v]) {
                cycle = true;
                return;
            }
        }
    }
}

void dfs2(int v) {
    used[v] = true;
    ans[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs2(u);
        }
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> a(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
        mp[{x, y}] = i;
    }
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int x = a[i].first;
        int y = a[i].second;
        for (int dx = -10; dx <= 10; ++dx) {
            ll pp = sqrtl(r * 1ll * r - dx * 1ll * dx);
            for (int dy = -pp; dy <= pp; ++dy) {
                int xx = x + dx, yy = y + dy;
                if ((x - xx) * 1ll * (x - xx) + (y - yy) * 1ll * (y - yy) <= r * 1ll * r) {
                    auto it = mp.find({xx, yy});
                    if (it != mp.end() && it->second != i) {
                        g[i].push_back(it->second);
                    }
                }
            }
        }
    }
    used.resize(n);
    dp.resize(n);
    ans.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comp.clear();
            cycle = false;
            dfs1(i);
            if (cycle) {
                for (auto j : comp) {
                    used[j] = false;
                }
                dfs2(i);
            }
        }
    }
    for (auto i : ans) {
        cout << i;
    }
    cout << "\n";
    return 0;
}