#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct Fenwick {
    int n;
    vector<int> t;

    Fenwick() {}
    Fenwick(int _n) : n(_n) {
        t.resize(n + 1);
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }
};

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    cin >> a;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            --a[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, infll));
    dp[0][0] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i - 1 >= 0) {
                Fenwick tr(n * m);
                for (int k = 0; k < i - 1; ++k) {
                    for (int l = 0; l < m; ++l) {
                        tr.add(a[k][l], 1);
                    }
                }
                for (int k = i - 1; k < n; ++k) {
                    for (int l = 0; l < j; ++l) {
                        tr.add(a[k][l], 1);
                    }
                }
                ll cur = 0;
                for (int k = j; k < m; ++k) {
                    cur += tr.get(a[i - 1][k] + 1, n * m);
                    tr.add(a[i - 1][k], 1);
                }
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + cur);
            }
            if (j - 1 >= 0) {
                Fenwick tr(n * m);
                for (int k = 0; k < i; ++k) {
                    for (int l = 0; l < m; ++l) {
                        tr.add(a[k][l], 1);
                    }
                }
                for (int k = i; k < n; ++k) {
                    for (int l = 0; l < j - 1; ++l) {
                        tr.add(a[k][l], 1);
                    }
                }
                ll cur = 0;
                for (int k = i; k < n; ++k) {
                    cur += tr.get(a[k][j - 1] + 1, n * m);
                    tr.add(a[k][j - 1], 1);
                }
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + cur);
            }
        }
    }
    ll ans = infll;
    for (int j = 0; j <= m; ++j) {
        ans = min(ans, dp[n][j]);
    }
    for (int i = 0; i <= n; ++i) {
        ans = min(ans, dp[i][m]);
    }
    cout << ans << "\n";
    return 0;
}