#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct Fenwick {
    int n;
    vector<int> t;

    Fenwick() {}
    Fenwick(int _n) : n(_n) {
        t.resize(n + 1);
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }
};

int32_t main() {
#ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    cin >> a;
    ll ans = infll;
    {
        vector<int> b;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                b.push_back(a[i][j]);
            }
        }
        for (auto &i : b) {
            --i;
        }
        Fenwick tr(b.size());
        ll cur = 0;
        for (int i = 0; i < n; ++i) {
            cur += tr.get(0, b[i]);
            tr.add(b[i], 1);
        }
        ans = min(ans, cur);
    }
    {
        vector<int> b;
        for (int j = 0; j < m; ++j) {
            for (int i = 0; i < n; ++i) {
                b.push_back(a[j][i]);
            }
        }
        for (auto &i : b) {
            --i;
        }
        Fenwick tr(b.size());
        ll cur = 0;
        for (int i = 0; i < n; ++i) {
            cur += tr.get(0, b[i]);
            tr.add(b[i], 1);
        }
        ans = min(ans, cur);
    }
    cout << ans << "\n";
    return 0;
}