#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#define int long long

struct fenwick {
    vector<int> t;

    fenwick(int n) {
        t.resize(n+1);
    }

    void upd(int k, int x) {
        for (; k < t.size(); k += (k & -k)) t[k] += x;
    }

    int get(int k) {
        int res = 0;
        for (; k > 0; k -= (k & -k)) res += t[k];
        return res;
    }
};

const int N = 200*200+1;

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m;
    cin>>n>>m;
    vector<vector<int> > a(n, vector<int>(m));
    for (auto &x:a) {
        for (auto &y:x) cin>>y;
    }
    vector<vector<int> > dp(n + 1, vector<int>(m+1, 1e18));
    vector<vector<bitset<N> > > vals(n, vector<bitset<N> >(m));
    dp[0][0] = 0;
    vals[0][0][a[0][0]] = 1;
    for (int i = 1; i < n; ++i) {
        vals[i][0] |= vals[i-1][0];
        vals[i][0][a[i][0]] = 1;
    }
    for (int j = 1; j < m; ++j) {
        vals[0][j] |= vals[0][j-1];
        vals[0][j][a[0][j]] = 1;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < m; ++j) {
            vals[i][j] = (vals[i][j-1] | vals[i-1][j]);
            vals[i][j][a[i][j]] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            {//del col
                bitset<N> gg;
                if (i - 1 >= 0) gg |= vals[i-1][m-1];
                if (j - 1 >= 0) gg |= vals[n-1][j-1];
                // if (i - 1 >= 0 && j - 1 >= 0) gg ^= vals[i-1][j-1];
                int op = 0;
                for (int w = i + 1; w <= n; ++w) {
                    for (int A = a[w-1][j] + 1; A <= n * m; ++A) {
                        op += gg[A];
                    }
                    gg[a[w-1][j]] = 1;
                }
                dp[i][j+1]=min(dp[i][j+1], dp[i][j] + op);
            }
            {//del row
                bitset<N> gg;
                if (i - 1 >= 0) gg |= vals[i-1][m-1];
                if (j - 1 >= 0) gg |= vals[n-1][j-1];
                // if (i - 1 >= 0 && j - 1 >= 0) gg ^= vals[i-1][j-1];
                int op = 0;
                for (int w = j + 1; w <= m; ++w) {
                    for (int A = a[i][w-1] + 1; A <= n * m; ++A) {
                        op += gg[A];
                    }
                    gg[a[i][w-1]] = 1;
                }
                dp[i+1][j]=min(dp[i+1][j], dp[i][j] + op);
            }
        }
    }
    int ans = 1e18;
    for (int i = 0; i <= n; ++i) {
        ans=min(ans,dp[i][m]);
    }
    for (int i = 0; i <= m; ++i) {
        ans=min(ans,dp[n][i]);
    }
    cout<<ans<<endl;
    return 0;
}