#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#define int long long

struct fenwick {
    vector<int> t;

    fenwick(int n) {
        t.resize(n+1);
    }

    void upd(int k, int x) {
        for (; k < t.size(); k += (k & -k)) t[k] += x;
    }

    int get(int k) {
        int res = 0;
        for (; k > 0; k -= (k & -k)) res += t[k];
        return res;
    }
};

const int N = 200*200+1;

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m;
    cin>>n>>m;
    vector<vector<int> > a(n, vector<int>(m));
    for (auto &x:a) {
        for (auto &y:x) cin>>y;
    }
    int ans = 0;
    fenwick t(n*m+1);
    for (auto &x:a[0]) {
        ans += t.get(n*m) - t.get(x+1);
        t.upd(x,1);
    }
    cout<<ans<<'\n';
    return 0;
}