#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#define int long long

struct fenwick {
    vector<int> t;

    fenwick(int n) {
        t.resize(n+1);
    }

    void upd(int k, int x) {
        for (; k < t.size(); k += (k & -k)) t[k] += x;
    }

    int get(int k) {
        int res = 0;
        for (; k > 0; k -= (k & -k)) res += t[k];
        return res;
    }
};

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m;
    cin>>n>>m;
    vector<vector<int> > a(n, vector<int>(m));
    for (auto &x:a) {
        for (auto &y:x) cin>>y;
    }
    if (n == 1) {
        fenwick t(2*n*m);
        int ans = 0;
        for (int i = m - 1; i >= 0; --i) {
            ans += t.get(a[0][i]);
            t.upd(a[0][i], 1);
        }
        cout<<ans<<endl;
        return 0;
    }
    return 1;
}