#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#define int long long

struct fenwick {
    vector<int> t;

    fenwick(int n) {
        t.resize(n+1);
    }

    void upd(int k, int x) {
        for (; k < t.size(); k += (k & -k)) t[k] += x;
    }

    int get(int k) {
        int res = 0;
        for (; k > 0; k -= (k & -k)) res += t[k];
        return res;
    }
};

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n, m;
    cin>>n>>m;
    vector<vector<int> > a(n, vector<int>(m));
    for (auto &x:a) {
        for (auto &y:x) cin>>y;
    }
    int ans = 1e18;
    int cur = 0;
    fenwick t(n*m+1);
    auto rec = [&](auto self, int i = 0, int j = 0) -> void {
        if (i == n || j == m) {
            ans = min(ans, cur);
            return;
        }
        if (i < n) {
            int op = 0;
            for (int w = j; w < m; ++w) {
                op += t.get(n*m) - t.get(a[i][w]-1);
                t.upd(a[i][w], 1);
            }
            cur += op;
            self(self,i+1,j);
            cur -= op;
            for (int w = j; w < m; ++w) {
                t.upd(a[i][w], -1);
            }
        }
        if (j < m) {
            int op = 0;
            for (int w = i; w < n; ++w) {
                op += t.get(n*m) - t.get(a[w][j]-1);
                t.upd(a[w][j], 1);
            }
            cur += op;
            self(self,i,j+1);
            cur -= op;
            for (int w = i; w < n; ++w) {
                t.upd(a[w][j], -1);
            }
        }
    };
    rec(rec);
    cout<<ans<<'\n';
    return 0;
}