#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

#define int long long
#define ll long long

using namespace std;


struct fen {
	vector<int>v;
	int n;
	fen(int x) {
		n = x;
		v.resize(n + 1);
	}
	void add(int x) {
		for (; x <= n; x += x & (-x)) {
			v[x]++;
		}
	}
	int get(int x) {
		int ans = 0;
		//x--;
		for (; x > 0; x -= x & (-x)) {
			ans -= v[x];
		}
		x = n;
		for (; x > 0; x -= x & (-x)) {
			ans += v[x];
		}
		return ans;
	}
};

mt19937 rnd(9483597);

int getum(vector<vector<int>>& v, int r, int c) {
	vector<vector<int>>cnt1(r, vector<int>(c));
	fen f(r * c + 1);
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cnt1[i][j] = f.get(v[i][j]);
			f.add(v[i][j]);

		}
	}
	vector<vector<int>>cnt2(r, vector<int>(c));
	fen f2(r * c + 1);
	for (int i = 0; i < c; ++i) {
		for (int j = 0; j < r; ++j) {
			cnt2[j][i] = f2.get(v[j][i]);
			f2.add(v[j][i]);

		}
	}
	vector<vector<vector<int>>>cnt3(r, vector<vector<int>>(c, vector<int>(c)));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			for (int o = 0; o < c; ++o) {
				if (o > 0) {
					cnt3[i][j][o] = cnt3[i][j][o - 1];
				}
				for (int op = i + 1; op < r; ++op) {
					if (v[op][o] > v[i][j]) {
						cnt3[i][j][o]++;
					}
				}
			}
		}
	}
	vector<vector<vector<int>>>cnt4(r, vector<vector<int>>(c, vector<int>(r)));
	for (int i = 0; i < c; ++i) {
		for (int j = 0; j < r; ++j) {
			for (int o = 0; o < r; ++o) {
				if (o > 0) {
					cnt4[j][i][o] = cnt4[j][i][o - 1];
				}
				for (int op = i + 1; op < c; ++op) {
					if (v[o][op] > v[j][i]) {
						cnt4[j][i][o]++;
					}
				}
			}
		}
	}
	vector<vector<int>>ans(r + 1, vector<int>(c + 1, 1e18));
	ans[0][0] = 0;
	for (int i = 0; i <= r; ++i) {
		for (int j = 0; j <= c; ++j) {
			if (i == 0 && j == 0) {
				continue;
			}
			if (i > 0) {
				int cnt = 0;
				for (int o = j; o < c; ++o) {
					cnt += cnt1[i - 1][o];
					if (j > 0) {
						cnt += cnt3[i - 1][o][j - 1];
					}
				}
				ans[i][j] = min(ans[i][j], cnt + ans[i - 1][j]);
			}
			if (j > 0) {
				int cnt = 0;
				for (int o = i; o < r; ++o) {
					cnt += cnt2[o][j - 1];
					if (i > 0) {
						cnt += cnt4[o][j - 1][i - 1];
					}
				}
				ans[i][j] = min(ans[i][j], cnt + ans[i][j - 1]);
			}
		}
	}
	return ans[r][c];
}


int gettup(vector<vector<int>>& v, int r, int c) {
	vector<vector<ll>>ans(r + 1, vector<ll>(c + 1, 1e18));
	ans[0][0] = 0;
	vector<vector<vector<int>>>lol(r + 1, vector<vector<int>>(c + 1));
	for (int i = 0; i <= r; ++i) {
		for (int j = 0; j <= c; ++j) {
			if (i == 0 && j == 0) {
				continue;
			}

			if (i > 0) {
				//lol[i][j] = lol[i - 1][j];
				//ans[i][j] = min(ans[i][j], ans[i - 1][j]);
				int cnt = 0;
				for (int o = j; o < c; ++o) {
					int l = -1;
					int r = lol[i - 1][j].size();
					while (l + 1 < r) {
						int m = (l + r) / 2;
						if (lol[i - 1][j][m] <= v[i - 1][o]) {
							l = m;
						}
						else {
							r = m;
						}
					}
					cnt += lol[i - 1][j].size() - r;
					for (int o1 = j; o1 < o; ++o1) {
						if (v[i - 1][o1] > v[i - 1][o]) {
							cnt++;
						}
					}
				}
				ans[i][j] = min(ans[i][j], cnt + ans[i - 1][j]);
			}
			if (j > 0) {
				//lol[i][j] = lol[i][j - 1];
				//ans[i][j] = min(ans[i][j], ans[i][j - 1]);
				int cnt = 0;
				for (int o = i; o < r; ++o) {
					int l = -1;
					int r = lol[i][j - 1].size();
					while (l + 1 < r) {
						int m = (l + r) / 2;
						if (lol[i][j - 1][m] <= v[o][j - 1]) {
							l = m;
						}
						else {
							r = m;
						}
					}
					cnt += lol[i][j - 1].size() - r;
					for (int o1 = i; o1 < o; ++o1) {
						if (v[o1][j - 1] > v[o][j - 1]) {
							cnt++;
						}
					}
				}
				ans[i][j] = min(ans[i][j], cnt + ans[i][j - 1]);
			}
			if (i > 0) {
				lol[i][j] = lol[i - 1][j];
				for (int o = j; o < c; ++o) {
					lol[i][j].push_back(v[i - 1][o]);
				}
			}
			else if (j > 0) {
				lol[i][j] = lol[i][j - 1];
				for (int o = i; o < r; ++o) {
					lol[i][j].push_back(v[o][j - 1]);
				}
			}
			sort(lol[i][j].begin(), lol[i][j].end());
		}
	}
	return ans[r][c];
}

int32_t main() {
	int r, c;
	cin >> r >> c;
	vector<vector<int>>v(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> v[i][j];
		}
	}
	cout << getum(v, r, c);
	return 0;
}