#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
using namespace std;
using i64 = int64_t;
struct DSU {
    vector<int> p, w;
    DSU(int n) {
        p.resize(n);
        w.assign(n, 1);
        iota(all(p), 0);
    }
    int get(int v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }

    void join(int v, int u) {
        v = get(v);
        u = get(u);
        if (v == u) return;
        if (w[v] > w[u]) {
            swap(v, u);
        }
        w[u] += w[v];
        p[v] = u;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    i64 n, r;
    cin >> n >> r;

    DSU dsu(2*n);

    map<pair<int, int>, int> verts;
    for (int i = 0; i < n; ++i) {
        i64 x, y;
        cin >> x >> y;
        for (i64 dx = -r; dx <= r; ++dx) {
            for (i64 dy = -r; dy <= r; ++dy) {
                if (dx*dx + dy*dy > r*r) continue;
                i64 nx = x + dx;
                i64 ny = y + dy;
                if (verts.contains({nx, ny})) {
                    int j = verts[{nx, ny}];
                    dsu.join(j, i + n);
                    dsu.join(i, j + n);
                }
            }
        }
        verts[{x, y}] = i;
    }

    for (int i = 0; i < n; ++i) {
        cout << (dsu.get(i) == dsu.get(i + n));
    }
    cout << "\n";
}
