#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
using namespace std;
using i64 = int64_t;
using u64 = uint64_t;
struct DSU {
    vector<int> p, w, tri;
    DSU(int n) {
        p.resize(n);
        w.assign(n, 1);
        tri.assign(n, 0);
        iota(all(p), 0);
    }
    int get(int v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }
    bool istri(int v) {
        return tri[get(v)];
    }
    void maketri(int v) {
        tri[get(v)] = 1;
    }
    void join(int v, int u) {
        v = get(v);
        u = get(u);
        if (v == u) return;
        if (w[v] > w[u]) {
            swap(v, u);
        }

        w[u] += w[v];
        p[v] = u;
        if (tri[v]) {
            maketri(v);
        }
    }
};

u64 remap(i64 x, i64 y) {
    const i64 MAXX = 5e8;
    if (x < 0 || y < 0 || x > MAXX || y > MAXX) return -1ULL;
    return (x << 32ULL) + y;
}

pair<int, int> unmap(u64 h) {
    return {h >> 32ULL, h & (-1U)};
}

void solve1(DSU& dsu, i64 n, i64 r) {
    unordered_map<u64, int> verts;
    for (int i = 0; i < n; ++i) {
        i64 x, y;
        cin >> x >> y;
        for (i64 dx = -r; dx <= r; ++dx) {
            for (i64 dy = -r; dy <= r; ++dy) {
                if (dx*dx + dy*dy > r*r) continue;
                i64 nx = x + dx;
                i64 ny = y + dy;

                if (verts.contains(remap(nx, ny))) {
                    int j = verts[remap(nx, ny)];
                    dsu.join(j, i + n);
                    dsu.join(i, j + n);
                }
            }
        }
        verts[remap(x, y)] = i;
    }
}

const vector<pair<int, int>> OFFSETS = {
    {0, 1},
    {0, -1},
    {-1, 0},
    {1, 0},
    {1, 1},
    {1, -1},
    {-1, 1},
    {-1, -1},
};

i64 dist2(i64 ax, i64 ay, i64 bx, i64 by) {
    return (ax - bx) * (ax - bx) + (ay - by) * (ay - by);
}

void solve2(DSU& dsu, i64 n, i64 r) {
    i64 mod = sqrtl(r);
    while ((mod-1) * (mod-1) + (mod-1) * (mod-1) > r * r) {
        mod--;
    }
    while (mod * mod + mod * mod <= r * r) {
        mod++;
    }
    vector<pair<i64, i64>> overts;
    unordered_map<u64, vector<int>> verts;
    unordered_map<u64, vector<int>> comps;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        int xi = x / mod;
        int yi = y / mod;
        u64 ind = remap(xi, yi);
        verts[ind].push_back(i);
        overts.emplace_back(x, y);
    }
    for (auto& [ind, ve] : verts) {
        if (ve.size() <= 2) {
            for (auto v : ve) {
                for (auto u : ve) {
                    if (v == u) continue;
                    dsu.join(v, u + n);
                }
            }
            for (auto v : ve) {
                comps[ind].push_back(dsu.get(v));
            }
            sort(all(comps[ind]));
            comps[ind].resize(unique(all(comps[ind])) - comps[ind].begin());
        } else {
            auto g = ve.front();
            for (auto v : ve) {
                dsu.join(g, v);
                dsu.join(g, v + n);
            }
            comps[ind] = { dsu.get(g) };
            dsu.maketri(g);
        }
    }
    for (auto& [ind, ce] : comps) {
        if (ce.size() == 1 && dsu.istri(ce[0])) continue;
        auto [xi, yi] = unmap(ind);
        for (auto [dx, dy] : OFFSETS) {
            int nxi = xi + dx;
            int nyi = yi + dy;
            u64 nind = remap(nxi, nyi);
            if (!verts.contains(nind)) continue;

            for (auto v : verts[ind]) {
                auto [vx, vy] = overts[v];
                for (auto u : verts[nind]) {
                    auto [ux, uy] = overts[u];
                    if (dist2(vx, vy, ux, uy) <= r * r) {
                        dsu.join(v, u + n);
                        dsu.join(u, v + n);
                    }
                }
                if (dsu.get(v) == dsu.get(v + n)) {
                    dsu.maketri(v);
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    i64 n, r;
    cin >> n >> r;

    DSU dsu(2*n);

    if (r <= 4) {
        solve1(dsu, n, r);
    } else {
        solve2(dsu, n, r);
    }

    for (int i = 0; i < n; ++i) {
        cout << (dsu.get(i) == dsu.get(i + n));
    }
    cout << "\n";
}

/*

6 5
4 1
4 4
1 5
5 9
9 6
10 2

 */