#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
using namespace std;
using i64 = int64_t;
using u64 = uint64_t;

vector<vector<int>> mat;
int R, C;
int lower(int x, int r, int c) {
    int a = 0;
    for (int i = r; i < R; ++i) {
        for (int j = c; j < C; ++j) {
            if (mat[i][j] < x) a++;
        }
    }
    return a;
}

struct Fenwick {
    vector<int> t;
    int n;
    Fenwick(int n): n(n) {
        t.resize(n + 1);
    }

    static int F(int i) {
        return i & -i;
    }

    void add(int i, int x) {
        i++;
        for (; i <= n; i += F(i))
            t[i] += x;
    }

    int sum(int r) {
        int s = 0;
        for (; r; r -= F(r))
            s += t[r];
        return s;
    }
    int sum(int l, int r) {
        return sum(r) - sum(l);
    }
};

i64 invers(vector<int> a) {
    i64 q = 0;
    vector<pair<int, int>> b;
    for (int i = 0; i < a.size(); ++i) {
        b.push_back({a[i], i});
    }
    sort(all(b));
    reverse(all(b));
    Fenwick tree(a.size());
    for (auto [v, i] : b) {
        q += tree.sum(i);
        tree.add(i, 1);
    }
    return q;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> R >> C;
    mat.resize(R, vector<int>(C));
    for (int i = 0; i < R; ++i) {
        for (int j = 0; j < C; ++j) {
            cin >> mat[i][j];
        }
    }
    cout << invers(mat[0]) << "\n";
}