#include <bits/stdc++.h>
#define all(v) v.begin(), v.end()
using namespace std;
using i64 = int64_t;
using u64 = uint64_t;

const int MAXLOG = 20;

template<typename T>
struct Sparse {
    array<vector<T>, MAXLOG> st;
    vector<int> log_2;
    int n;
    Sparse(vector<T> a) {
        n = a.size();
        st.fill(a);
        log_2.resize(n + 1);
        for (int i = 2; i <= n; ++i) {
            log_2[i] = log_2[i / 2] + 1;
        }
        for (int lvl = 1; lvl < MAXLOG; ++lvl) {
            for (int i = 0; i + (1 << lvl) <= n; ++i) {
                st[lvl][i] = min(st[lvl-1][i], st[lvl-1][i + (1 << lvl-1)]);
            }
        }
    }

    T get(int l, int r) {
        int k = log_2[r - l];
        return min(st[k][l], st[k][r - (1 << k)]);
    }
};

int n;
vector<int> a, ind, hide;
Sparse<pair<int, int>> st = {{}};
void solvek(int k, vector<int>& blocks, int s = 0) {
    if (blocks.size() >= 3) return;
    if (k == 1) {
        blocks.push_back(*max_element(a.begin() + s, a.end()));
        return;
    }
    if (k == 2) {
        int j = min(s + hide[s] + 1, n - 1);
        blocks.push_back(a[s]);
        solvek(k-1, blocks, j);
        return;
    }
    if (hide[s] == 0 || n - s == k) {
        blocks.push_back(a[s]);
        solvek(k-1, blocks, s + 1);
        return;
    }
    int sl = s + 1;
    int sr = + min(s + hide[s], n - k + 1) + 1;
    int j = st.get(sl, sr).second;
    blocks.push_back(a[s]);
    solvek(k - 1, blocks, j);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> n >> q;
    a.resize(n);
    ind.resize(n);
    hide.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        ind[a[i]] = i;
    }

    {
        vector<pair<int, int>> b;
        for (int i = 0; i < a.size(); ++i) {
            b.emplace_back(a[i], i);
        }
        st = {b};
    }
    {
        set<int> placed;
        for (int v = n-1; v >= 0; --v) {
            int i = ind[v];
            auto it = placed.lower_bound(i);
            if (it == placed.end()) {
                hide[i] = n - i - 1;
            } else {
                hide[i] = *it - i - 1;
            }
            placed.emplace(i);
        }
    }

    vector<pair<int, int>> que;
    vector<int> interk;
    for (int i = 0; i < q; ++i) {
        int k, j;
        cin >> k >> j;
        j--;
        que.emplace_back(k, j);
        interk.push_back(k);
    }

    sort(all(interk));
    interk.resize(unique(all(interk)) - interk.begin());
    vector<vector<int>> ans(n + 1);
    for (int k : interk) {
        solvek(k, ans[k]);
    }

    for (int i = 0; i < q; ++i) {
        auto [k, j] = que[i];
        cout << ans[k][j] + 1 << "\n";
    }
}

/*

7 4
6 4 2 3 1 7 5
7 4
1 1
4 2
5 3

 */