#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
#define int long long
int n, q, m, k;

void solve() {
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j= 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(m + 1,1e18));
    vector<vector<int>> inv0(n + 1, vector<int>(m + 1,0));
    vector<vector<int>> inv1(n + 1, vector<int>(m + 1,0));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; j--) {
            inv0[i][j] = inv0[i][j + 1];
            for (int ii = i + 1; ii < n; ii++) {
                for (int jj = j + 1; jj < m; jj++) 
                inv0[i][j] += (a[ii][j] < a[i][jj]);
            }
            for (int ii = i; ii < n; ii++) {
                for (int jj = j; jj < m; jj++) {
                    inv0[i][j] += (a[i][j] > a[ii][jj]);
                    inv1[i][j] += (a[i][j] > a[ii][jj]);
                }
            }
        }
    }    
    for (int j = m - 1; j >= 0; --j) {
        for (int i = n - 1; i >= 0; i--) {
            inv1[i][j] += inv1[i + 1][j];
            for (int jj = j + 1; jj < m; jj++) {
                for (int ii = i + 1; ii < n; ii++) 
                inv1[i][j] += (a[ii][j] > a[i][jj]);
            }
        }
    }

    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + inv0[i][j]);
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + inv1[i][j]);
        }
    }
    cout << min(dp[n][m - 1], dp[n - 1][m]) << endl;
}

//#define LOCAL
signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}