#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;
#define int long long
int n, q, m, k;

random_device rd;
mt19937 gen(239);
uniform_int_distribution<> ddddds(1, 1000000000);
int rnd() {return ddddds(gen);}
struct node{
    int x, y, col;
    node*L, *R;
node() {y = rnd(); col = 0;L = R = nullptr;}
node(int xx) {x = xx; y = rnd(); col = 1;L = R = nullptr;}
};
int getcol(node*x){
    if (!x) return 0;
    return x->col;
}
node* merge(node*L, node*R) {
    if (!L) return R;
    if (!R) return L;
    if (L->y >= R->y) {
        L->R = merge(L->R, R);
        L->col = 1 + getcol(L->L) + getcol(L->R);
        return L;
    } else {
        R->L = merge(L, R->L);
        R->col = 1 + getcol(R->L) + getcol(R->R);
        return R;
    }
}

pair<node*,node*> splitx(node*root, int x) {
    if (!root) return {nullptr, nullptr};
    if (root->x <= x) {
        auto b = splitx(root->R, x);
        root->R = b.first;
        root->col = 1 + getcol(root->L) + getcol(root->R);
        return {root, b.second};
    }
    else {
        auto b = splitx(root->L, x);
        root->L = b.second;
        root->col = 1 + getcol(root->L) + getcol(root->R);
        return {b.first, root};
    }
}

int leseq(node *root, int x) {
    if (!root) return 0;
    if (root->x < x) {
        return 1 + getcol(root->L) + leseq(root->R, x);
    } else {
        return leseq(root->L, x);
    }
}
int grteq(node *root, int x) {
    return getcol(root) - leseq(root, x);
}

node* insert(node*root, int x) {
    auto b = splitx(root, x);
    node*nw = new node(x);
    b.first = merge(b.first, nw);
    return merge(b.first, b.second);
}

void solve() {
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j= 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(m + 1,1e18));
    vector<vector<int>> inv0(n + 1, vector<int>(m + 1,0));
    vector<vector<int>> inv1(n + 1, vector<int>(m + 1,0));
    vector<node*> root0(n, nullptr), root1(m, nullptr);
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; j--) {

            
            inv0[i][j] += inv0[i][j + 1];
            inv1[i][j] += inv1[i + 1][j];
            int sum = 0;
            if (n - i <= m - j) {
                for (int ii = i + 1; ii < n; ii++) {
                    sum += grteq(root0[i], a[ii][j]);
                }
            } else {
                for (int jj = j + 1; jj < m; jj++) {
                    sum += leseq(root1[j], a[i][jj]);
                }
            }
            inv0[i][j] += sum;
            inv1[i][j] += (n - 1 - i) * (m - 1 - j) - sum;

            root0[i] = insert(root0[i], a[i][j]);
            root1[j] = insert(root1[j], a[i][j]);
            sum = 0;
            for (int ii = i; ii < n; ii++) {
                for (int jj = j; jj < m; jj++) {
                    sum += (a[i][j] > a[ii][jj]);
                }
            }
            inv0[i][j] += sum;
            inv1[i][j] += sum;
        }
    }

    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + inv0[i][j]);
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + inv1[i][j]);
        }
    }
    cout << min(dp[n][m - 1], dp[n - 1][m]) << endl;
}

//#define LOCAL
signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}