#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define pi pair<int, int>
#define ff first
#define vb vector<bool>
#define ss second

struct pt {
	int x, y;
	pt() {
		x = 0;
		y = 0;
	}
	pt(int x, int y) : x(x), y(y) {

	}
	int len2() {
		return x * x + y * y;
	}
	pt xinc() {
		x++;
		return *this;
	}
	pt yinc() {
		y++;
		return *this;
	}
	pt inc() {
		x++;
		y++;
		return *this;
	}
};

bool operator<(pt a, pt b) {
	if (a.x != b.x) return a.x < b.x;
	return a.y < b.y;
}

pt operator+(pt a, pt b) {
	return pt(a.x + b.x, a.y + b.y);
}
pt operator-(pt a, pt b) {
	return pt(a.x - b.x, a.y - b.y);
}

#define vpt vector<pt>

struct snm {
	int n;
	vi par;
	vi sz;
	snm(int n = 0) : n(n) {
		par.assign(n, 0);
		sz.assign(n, 1);
		for (int i = 0; i < n; i++) par[i] = i;
	}
	int get(int i) {
		if (par[i] == i) return i;
		int x = get(par[i]);
		par[i] = x;
		return x;
	}
	void unite(int i, int j) {
		i = get(i);
		j = get(j);
		if (i == j) return;
		if (sz[i] < sz[j]) swap(i, j);
		par[j] = i;
		sz[i] += sz[j];
	}
};

int n, rad;
vpt vec;

vvi graph;


vvi qtp;
vvi qtc;

snm sm(n);

bool cont(pt l, pt r, int i) {
	if (l.x <= vec[i].x && vec[i].x <= r.x) {
		if (l.y <= vec[i].y && vec[i].y <= r.y) {
			return 1;
		}
	}
	return 0;
}

void snmerge(pt l, pt r, int i, int v) {
	if (qtp[v].size() == 0) return;
	pt a = pt(l.x, r.y);
	pt b = pt(r.x, l.y);
	int dall = max(max((vec[i] - l).len2(), (vec[i] - r).len2()), max((vec[i] - a).len2(), (vec[i] - b).len2()));
	if (4 * dall <= rad * rad) {
		for (int a : qtp[v]) {
			//sm.unite(a, i);
		}
		return;
	}
	if (!cont(l, r, i)) {
		int d2 = min(min((vec[i] - l).len2(), (vec[i] - r).len2()), min((vec[i] - a).len2(), (vec[i] - b).len2()));
		if (l.x <= vec[i].x && vec[i].x <= r.x) {
			d2 = min(d2, abs(l.y - vec[i].y) * abs(l.y - vec[i].y));
			d2 = min(d2, abs(r.y - vec[i].y) * abs(r.y - vec[i].y));
		}
		if (l.y <= vec[i].y && vec[i].y <= r.y) {
			d2 = min(d2, abs(l.x - vec[i].x) * abs(l.x - vec[i].x));
			d2 = min(d2, abs(r.x - vec[i].x) * abs(r.x - vec[i].x));
		}
		if (4 * d2 > rad * rad) return;
	}

	pt m = r + l;
	m.x /= 2;
	m.y /= 2;

	pt mx = pt((l.x + r.x) / 2, l.y);
	pt my = pt(l.x, (l.y + r.y) / 2);

	pt rx = pt((l.x + r.x) / 2, r.y);
	pt ry = pt(r.x, (l.y + r.y) / 2);
	mx.xinc();
	my.yinc();
	if (qtc[v].size() == 0) {
		qtc[v].push_back(qtp.size());
		qtc[v].push_back(qtp.size() + 1);
		qtc[v].push_back(qtp.size() + 2);
		qtc[v].push_back(qtp.size() + 3);
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());


		for (int a : qtp[v]) {
			if (cont(l, m, a)) {
				qtp[qtc[v][0]].push_back(a);
			}
			else if (cont(mx, ry, a)) {
				qtp[qtc[v][1]].push_back(a);
			}
			else if (cont(my, rx, a)) {
				qtp[qtc[v][2]].push_back(a);
			}
			else {
				qtp[qtc[v][3]].push_back(a);
			}
		}
	}

	snmerge(l, m, i, qtc[v][0]);
	snmerge(mx, ry, i, qtc[v][1]);
	snmerge(my, rx, i, qtc[v][2]);
	snmerge(m.inc(), r, i, qtc[v][3]);
}

void getgraph(pt l, pt r, int i, int v) {
	if (qtp[v].size() == 0) return;
	pt a = pt(l.x, r.y);
	pt b = pt(r.x, l.y);
	int dall = max(max((vec[i] - l).len2(), (vec[i] - r).len2()), max((vec[i] - a).len2(), (vec[i] - b).len2()));
	if (4 * dall <= rad * rad) {
		//return;
	}
	if (dall <= rad * rad) {
		for (int a : qtp[v]) {
			if (1) {
				if (a != i) {
					graph[i].push_back(a);
				}
			}
		}
		return;
	}
	if (!cont(l, r, i)) {
		int d2 = min(min((vec[i] - l).len2(), (vec[i] - r).len2()), min((vec[i] - a).len2(), (vec[i] - b).len2()));
		if (l.x <= vec[i].x && vec[i].x <= r.x) {
			d2 = min(d2, abs(l.y - vec[i].y) * abs(l.y - vec[i].y));
			d2 = min(d2, abs(r.y - vec[i].y) * abs(r.y - vec[i].y));
		}
		if (l.y <= vec[i].y && vec[i].y <= r.y) {
			d2 = min(d2, abs(l.x - vec[i].x) * abs(l.x - vec[i].x));
			d2 = min(d2, abs(r.x - vec[i].x) * abs(r.x - vec[i].x));
		}
		if (d2 > rad * rad) return;
	}

	pt m = r + l;
	m.x /= 2;
	m.y /= 2;

	pt mx = pt((l.x + r.x) / 2, l.y);
	pt my = pt(l.x, (l.y + r.y) / 2);

	pt rx = pt((l.x + r.x) / 2, r.y);
	pt ry = pt(r.x, (l.y + r.y) / 2);
	mx.xinc();
	my.yinc();
	if (qtc[v].size() == 0) {
		qtc[v].push_back(qtp.size());
		qtc[v].push_back(qtp.size() + 1);
		qtc[v].push_back(qtp.size() + 2);
		qtc[v].push_back(qtp.size() + 3);
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());


		for (int a : qtp[v]) {
			if (cont(l, m, a)) {
				qtp[qtc[v][0]].push_back(a);
			}
			else if (cont(mx, ry, a)) {
				qtp[qtc[v][1]].push_back(a);
			}
			else if (cont(my, rx, a)) {
				qtp[qtc[v][2]].push_back(a);
			}
			else {
				qtp[qtc[v][3]].push_back(a);
			}
		}
	}

	getgraph(l, m, i, qtc[v][0]);
	getgraph(mx, ry, i, qtc[v][1]);
	getgraph(my, rx, i, qtc[v][2]);
	getgraph(m.inc(), r, i, qtc[v][3]);
}

bool ok = 0;
vb h;
vi used;
vi usedsnm;
vi abob;
void dfs(int u) {
	if (sm.sz[sm.get(u)] >= 3) {
		ok = 1;
	}
	abob.push_back(u);
	used[u] = 1;
	usedsnm[sm.get(u)] = 1;
	for (int v : graph[u]) {
		if (used[v] == 1) {
			if (h[v] == h[u]) {
				ok = 1;
			}
		}
		else if (!used[v]) {
			if (sm.sz[sm.get(v)] >= 2 && usedsnm[sm.get(v)] == 1) {
				ok = 1;
			}
			h[v] = !h[u];
			dfs(v);
		}
	}
}

vb tok;
void setok(int u) {
	used[u] = 1;
	tok[u] = 1;
	for (int v : graph[u]) {
		if (!used[v]) setok(v);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> rad;
	//if (n == 2) return 0;
	sm = snm(n);
	vec.assign(n, pt());
	graph.assign(n, vi());
	for (int i = 0; i < n; i++) {
		cin >> vec[i].x >> vec[i].y;
	}

	qtp.assign(1, vi(n, 0));
	qtc.push_back(vi());
	for (int i = 0; i < n; i++) {
		qtp[0][i] = i;
	}

	for (int i = 0; i < n; i++) {
		snmerge(pt(), pt(1e9, 1e9), i, 0);
	}
	for (int i = 0; i < n; i++) {
		getgraph(pt(), pt(1e9, 1e9), i, 0);
	}

	used.assign(n, 0);
	usedsnm.assign(n, 0);
	h.assign(n, 0);
	tok.assign(n, 0);
	for (int i = 0; i < n; i++) {
		if (!used[sm.get(i)]) {
			abob.clear();
			ok = 0;
			dfs(sm.get(i));
			if (ok) {
				for (int a : abob) tok[a] = 1;
			}
			for (int a : abob) {
				usedsnm[sm.get(a)] = 2;
				used[a] = 1;
			}
		}
	}
	used.assign(n, 0);
	vvi tgraph = graph;
	for (int i = 0; i < n; i++) {
		for (int j : tgraph[i]) {
			if (i != sm.get(i) || j != sm.get(j)) {
				graph[sm.get(i)].push_back(sm.get(j));
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (tok[i] || sm.sz[sm.get(i)] >= 3) {
			tok[sm.get(i)] = 1;
			if (!used[i]) setok(i);
		}
	}
	for (int i = 0; i < n; i++) {
		if (tok[i] || tok[sm.get(i)] || sm.sz[sm.get(i)] >= 3) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
}