#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define pi pair<int, int>
#define ff first
#define vb vector<bool>
#define ss second

struct pt {
	int x, y;
	pt() {
		x = 0;
		y = 0;
	}
	pt(int x, int y) : x(x), y(y) {

	}
	int len2() {
		return x * x + y * y;
	}
	pt xinc() {
		x++;
		return *this;
	}
	pt yinc() {
		y++;
		return *this;
	}
	pt inc() {
		x++;
		y++;
		return *this;
	}
};

bool operator<(pt a, pt b) {
	if (a.x != b.x) return a.x < b.x;
	return a.y < b.y;
}

pt operator+(pt a, pt b) {
	return pt(a.x + b.x, a.y + b.y);
}
pt operator-(pt a, pt b) {
	return pt(a.x - b.x, a.y - b.y);
}

#define vpt vector<pt>

int n, rad;
vpt vec;

vvi graph;
bool ok = 0;
vb h;
vb used;
vi abob;
void dfs(int u) {
	abob.push_back(u);
	used[u] = 1;
	for (int v : graph[u]) {
		if (used[v]) {
			if (h[v] == h[u]) {
				ok = 1;
			}
		}
		else {
			h[v] = !h[u];
			dfs(v);
		}
	}
}

vvi qtp;
vvi qtc;

bool cont(pt l, pt r, int i) {
	if (l.x <= vec[i].x && vec[i].x <= r.x) {
		if (l.y <= vec[i].y && vec[i].y <= r.y) {
			return 1;
		}
	}
	return 0;
}

void quadrotree(pt l, pt r, int i, int v) {
	if (qtp[v].size() == 0) return;
	pt a = pt(l.x, r.y);
	pt b = pt(r.x, l.y);
	if ((vec[i] - l).len2() <= rad * rad && (vec[i] - r).len2() <= rad * rad && (vec[i] - a).len2() <= rad * rad && (vec[i] - b).len2() <= rad * rad) {
		for (int a : qtp[v]) {
			if (a != i) graph[i].push_back(a);
		}
		return;
	}
	if (!cont(l, r, i)) {
		if ((vec[i] - l).len2() > rad * rad && (vec[i] - r).len2() > rad * rad && (vec[i] - a).len2() > rad * rad && (vec[i] - b).len2() > rad * rad) {
			return;
		}
	}

	pt m = r + l;
	m.x /= 2;
	m.y /= 2;

	pt mx = pt((l.x + r.x) / 2, l.y);
	pt my = pt(l.x,(l.y + r.y) / 2);

	pt rx = pt((l.x + r.x) / 2, r.y);
	pt ry = pt(r.x, (l.y + r.y) / 2);

	if (qtc[v].size() == 0) {
		qtc[v].push_back(qtp.size());
		qtc[v].push_back(qtp.size() + 1);
		qtc[v].push_back(qtp.size() + 2);
		qtc[v].push_back(qtp.size() + 3);
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtp.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());
		qtc.push_back(vi());


		for (int a : qtp[v]) {
			if (cont(l, m, a)) {
				qtp[qtc[v][0]].push_back(a);
			} else if (cont(mx, ry, a)) {
				qtp[qtc[v][1]].push_back(a);
			}
			else if (cont(my, rx, a)) {
				qtp[qtc[v][2]].push_back(a);
			}
			else {
				qtp[qtc[v][3]].push_back(a);
			}
		}
	}

	quadrotree(l, m, i, qtc[v][0]);
	quadrotree(mx.xinc(), ry, i, qtc[v][1]);
	quadrotree(my.yinc(), rx, i, qtc[v][2]);
	quadrotree(m.inc(), r, i, qtc[v][3]);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> rad;
	vec.assign(n, pt());
	graph.assign(n, vi());
	for (int i = 0; i < n; i++) {
		cin >> vec[i].x >> vec[i].y;
	}

	qtp.assign(1, vi(n, 0));
	qtc.push_back(vi());
	for (int i = 0; i < n; i++) {
		qtp[0][i] = i;
	}

	for (int i = 0; i < n; i++) {
		quadrotree(pt(), pt(10, 10), i, 0);
	}

	used.assign(n, 0);
	h.assign(n, 0);
	vb tok(n);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			abob.clear();
			ok = 0;
			dfs(i);
			if (ok) {
				for (int a : abob) tok[a] = 1;
			}
		}
	}
	for (int el : tok) cout << el;
}