#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct seg_tree{
    vector<int> t;
    seg_tree(int n) {
        t.resize(4 * n);
    }
    void upd(int v, int l, int r, int pos, int x) {
        if (l + 1 == r) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) upd(v * 2, l, m, pos, x);
        else upd(v * 2 + 1, m, r, pos, x);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get(int v, int l, int r, int L, int R) {
        if (L <= l && r <= R) return t[v];
        if (R <= l || r <= L) return 0;
        int m = (l + r) / 2;
        return get(v * 2, l, m, L, R) + get(v * 2 + 1, m, r, L, R);
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    ll ans = 0;
    int h = 0, w = 0, sz = r * c + 1;
    seg_tree t(r * c);
    while (h < r && w < c) {
        ll c1 = 0, c2 = 0;
        for (int i = w; i < c; ++i) {
            c1 += a[h][i] - 1 - t.get(1, 0, sz, 0, a[h][i]);
            t.upd(1, 0, sz, a[h][i], 1);
        }
        for (int i = w; i < c; ++i) {
            t.upd(1, 0, sz, a[h][i], -1);
        }
        for (int i = h; i < r; ++i) {
            c2 += a[i][w] - 1 - t.get(1, 0, sz, 0, a[i][w]);
            t.upd(1, 0, sz, a[i][w], 1);
        }
        for (int i = h; i < r; ++i) {
            t.upd(1, 0, sz, a[i][w], -1);
        }
        if (c1 < c2) {
            ans += c1;
            for (int i = w; i < c; ++i) {
                t.upd(1, 0, sz, a[h][i], 1);
            }
            ++h;
        } else {
            ans += c2;
            for (int i = h; i < r; ++i) {
                t.upd(1, 0, sz, a[i][w], 1);
            }
            ++w;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
}