#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
struct vect {
    int x, y;

    vect() {

    }

    vect(int x, int y) : x(x), y(y) {

    }

};

inline int getdist(const vect& a, const vect& b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector<vector<int>> g;
vector<int> cd;
vector<bool> good;

void spread(int v) {
    good[v] = true;
    cd[v] = 0;
    for (auto w : g[v]) {
        if (!good[w]) {
            spread(w);
        }
    }
}

void dfs1(int v, int curc) {
    cd[v] = curc;
    for (auto w : g[v]) {
        if (cd[w] == -1) {
            dfs1(w, curc ^ 1);
            if (good[v]) return;
        }
    }
    for (auto w : g[v]) {
        if (cd[w] == cd[v]) {
            spread(v);
            return;
        }
    }
}

signed main() {
    fastio;
    int n, r;
    cin >> n >> r;
    vector<vect> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i].x >> v[i].y, v[i].x *= 4, v[i].y *= 4;
    r *= 4;
    g.resize(n);
    good.resize(n);
    cd.resize(n, -1);
    // build
    int r2 = (r * r) / 2;
    map<pair<int, int>, vector<int>> squares;
    for (int i = 0; i < n; ++i) {
        int sqx = v[i].x / (r / 2);
        int sqy = v[i].y / (r / 2);
        squares[{sqx, sqy}].push_back(i);
    }

    for (auto [coord, pnts] : squares) {
        if (pnts.size() > 2) {
            for (auto ind : pnts) {
                good[ind] = true;
            }
        }
        for (int i = 1; i < pnts.size(); ++i) {
            int v = pnts[0], w = pnts[i];
            g[v].push_back(w);
            g[w].push_back(v);
        }
    }
    constexpr int K = 4;
    for (auto [coord, pnts] : squares) {
        if (pnts.size() > 2) continue;
        auto [cx, cy] = coord;
        for (int x = cx - K; x <= cx + K; ++x) {
            for (int y = cy - K; y <= cy + K; ++y) {
                if ((x == cx && y == cy) || squares.find({x, y}) == squares.end()) continue;
                const auto& vec = squares[{x, y}];
                for (auto ind1 : pnts) {
                    for (auto ind2 : vec) {
                        if (getdist(v[ind1], v[ind2]) <= r2) {
                            g[ind1].push_back(ind2);
                            g[ind2].push_back(ind1);
                        }
                    }
                }
            }
        }
    }
    // check
    for (int i = 0; i < n; ++i) {
        if (cd[i] == -1 && !good[i]) {
            dfs1(i, 0);
        } else if (good[i] && cd[i] == -1) {
            spread(i);
        }
    }
    // output
    for (int i = 0; i < n; ++i) {
        if (!good[i]) cout << "0";
        else cout << "1";
    }
}