#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int r;

struct point {
    int x;
    int y;
    int id;
};

long double len(point a) {
    return double(sqrt((ll)a.x * (ll)a.x + (ll)a.y * (ll)a.y));
}

const int MAXN = 100005;

vector < int > g[MAXN];

bool used[MAXN];

int col[MAXN];

bool cmp(point a, point b) {
    if ((ll)a.x * (ll)a.x + (ll)b.x * (ll)b.x < (ll)a.y * (ll)a.y + (ll)b.y * (ll)b.y) {
        return true;
    }
    return false;
}

bool good(point a, point b) {
    if ((ll)(a.x - b.x) * (ll)(a.x - b.x) + (ll)(a.y - b.y) * (ll)(a.y - b.y) <= (ll)(r) * (ll)(r)) {
        return true;
    } else {
        return false;
    }
}

string ans;

void dfs1(int v) {
    for (int to : g[v]) {
        if (col[to] == -1) {
            col[to] = 1 ^ col[v];
            dfs1(to);
        }
        if (col[v] == col[to]) {
            ans[v] = ans[to] = '1';
        }
    }
}

void dfs2(int v) {
    used[v] = true;
    for (int to : g[v]) {
        ans[to] = '1';
        if (!used[to]) {
            dfs2(to);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n >> r;
    vector < point > p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        p[i].id = i;
    }
    sort(p.begin(), p.end(), cmp);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (j == i) {
                continue;
            }
            if (len(p[i]) + r < len(p[j])) {
                break;
            }
            if (good(p[i], p[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        used[i] = false;
        ans += '0';
    }
    for (int i = 0; i < n; i++) {
        col[i] = -1;
    }
    for (int v = 0; v < n; v++) {
        if (col[v] == -1) {
            col[v] = 0;
            dfs1(v);
        }
    }
    for (int v = 0; v < n; v++) {
        if (!used[v] && ans[v] == '1') {
            dfs2(v);
        }
    }
    string otv = ans;
    for (int i = 0; i < n; i++) {
        int id = p[i].id;
        otv[id] = ans[i];
    }
    cout << otv << '\n';
}

/*
6 5
 4 1
 4 4
 1 5
 5 9
 9 6
 10 2

 3 1
 1 1
 1 2
 1 3
 */