#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#pragma GCC optimize("Ofast")
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef int ll;
typedef long double ld;
typedef pair<long long, long long> pii;

struct Stone {
	long long fi, se;
	ll in;
};

const ll SZ = 1e5;
Stone a[SZ];
vector<ll> g[SZ];
ll used[SZ];
ll ans[SZ] = {};
bool f;
vector<ll> p;

void dfs(ll v, ll c) {
	used[v] = c;
	p.push_back(v);
	for (auto u : g[v]) {
		if (!used[u]) dfs(u, 3 - c);
		else if (used[u] == used[v]) {
			f = true;
		}
	}
}

map<pii, ll> ma;

bool cmp(Stone x, Stone y) {
	return x.fi < y.fi;
}

inline void solve() {
	long long n;
	long long r;
	cin >> n >> r;
	long long rr = r * r;
	for (ll i = 0; i < n; i++) {
		cin >> a[i].fi >> a[i].se;
	}
	if (n == 2) {
		cout << "00\n";
		return;
	}
	if (n * r >= 1e7) {
		for (ll i = 0; i < n; i++) cout << 1;
		cout << '\n';
	}
	else if (n <= 10000) {
		sort(a, a + n, cmp);
		for (ll i = 0; i < n; i++) {
			for (ll j = i + 1; j < n; j++) {
				if (a[j].fi - a[i].fi > r) break;
				long long dx = (a[i].fi - a[j].fi) * (a[i].fi - a[j].fi);
				long long dy = (a[i].se - a[j].se) * (a[i].se - a[j].se);
				if (dx + dy <= rr) {
					g[a[i].in].push_back(a[j].in);
					g[a[j].in].push_back(a[i].in);
				}
			}
		}
		for (ll i = 0; i < n; i++) {
			if (used[i]) {
				cout << ans[i];
				continue;
			}
			f = false;
			dfs(i, 1);
			if (f) {
				cout << 1;
				for (auto i : p) ans[i] = 1;
				p = {};
			}
			else {
				cout << 0;
				for (auto i : p) ans[i] = 0;
				p = {};
			}
		}
	}
	else {
		for (ll i = 0; i < n; i++) {
			cin >> a[i].fi >> a[i].se;
			ma[{a[i].fi, a[i].se}] = i;
			long long x = a[i].fi;
			long long y = a[i].se;
			for (long long x1 = x - r; x1 <= x + r; x1++) {
				for (long long y1 = y; y1 <= y + r; y1++) {
					if (x1 == x && y1 == y) continue;
					long long dx = (x - x1) * (x - x1);
					long long dy = (y - y1) * (y - y1);
					if (dx + dy <= rr) {
						if (ma.find({ x1, y1 }) == ma.end()) continue;
						ll in = ma[{x1, y1}];
						g[i].push_back(in);
						g[in].push_back(i);
					}
					else break;
				}
				for (long long y1 = y - 1; y1 >= y - r; y1--) {
					if (x1 == x && y1 == y) continue;
					long long dx = (x - x1) * (x - x1);
					long long dy = (y - y1) * (y - y1);
					if (dx + dy <= rr) {
						if (ma.find({ x1, y1 }) == ma.end()) continue;
						ll in = ma[{x1, y1}];
						g[i].push_back(in);
						g[in].push_back(i);
					}
					else break;
				}
			}
		}
		for (ll i = 0; i < n; i++) {
			if (used[i]) {
				cout << ans[i];
				continue;
			}
			f = false;
			dfs(i, 1);
			if (f) {
				cout << 1;
				for (auto i : p) ans[i] = 1;
				p = {};
			}
			else {
				cout << 0;
				for (auto i : p) ans[i] = 0;
				p = {};
			}
		}
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}