#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#pragma GCC optimize("Ofast")
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll INF = 1e15;

struct SegTree {
	ll n;
	vector<ll> t;
	SegTree(ll _n) {
		n = _n;
		t.resize(4 * n);
	}
	ll get(ll v, ll l, ll r, ll al, ll ar) {
		if (l >= ar || r <= al) return 0;
		if (l >= al && r <= ar) return t[v];
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		return get(vl, l, m, al, ar) + get(vr, m, r, al, ar);
	}
	void change(ll v, ll l, ll r, ll i, ll x) {
		if (r - l == 1) {
			t[v] += x;
			return;
		}
		ll m = (l + r) / 2, vl = 2 * v, vr = vl + 1;
		if (i < m) change(vl, l, m, i, x);
		else change(vr, m, r, i, x);
		t[v] = t[vl] + t[vr];
	}
};

inline void solve() {
	ll r, c;
	cin >> r >> c;
	vector<vector<ll>> a(r, vector<ll>(c));
	for (ll i = 0; i < r; i++) {
		for (ll j = 0; j < c; j++) {
			cin >> a[i][j];
		}
	}
	SegTree t(c + 1);
	ll ans = 0;
	for (ll i = 0; i < c; i++) {
		ans += t.get(1, 0, c + 1, a[0][i], c + 1);
		t.change(1, 0, c + 1, a[0][i], 1);
	}
	cout << ans << '\n';
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}