#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#define int long long

using namespace std;
using ll = long long;
using ld = long double;

struct Pt {
	int x, y;
};

int sqDist(Pt a, Pt b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

bool flag = false;

void dfs(int v, vector <vector <int>>& g, vector <int>& used, vector <int>& ans, vector <int> &d, int curr) {
	used[v] = 1;
	d[v] = curr;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u, g, used, ans, d, curr + 1);
		}
		else if (used[u] == 1) {
			if ((d[v] - d[u]) % 2 == 0) {
				flag = true;
			}
		}
	}
	used[v] = 2;
}

void paint(int v, vector <vector <int>>& g, vector <bool>& used, vector <int>& ans) {
	ans[v] = 1;
	used[v] = true;
	for (auto u : g[v]) {
		if (!used[u]) {
			paint(u, g, used, ans);
		}
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, r;
	cin >> n >> r;
	vector <Pt> arr(n);
	map <pair<int, int>, int> mp;
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
		mp[{arr[i].x, arr[i].y}] = i;
	}
	vector <vector <int>> g(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (sqDist(arr[i], arr[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	vector <int> used(n, 0), ans(n, 0), d(n, 0);
	vector <bool> used2(n);
	stack <int> st;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			flag = false;
			dfs(i, g, used, ans, d, 0);
			if (flag) {
				paint(i, g, used2, ans);
			}
		}
	}
	for (auto el : ans) {
		cout << el;
	}
}
