#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#define int long long

using namespace std;
using ll = long long;
using ld = long double;

struct Pt {
	int x, y;
};

int sqDist(Pt a, Pt b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

bool flag = false;

void dfs(int v, vector <int>& used, vector <int>& ans, vector <int> &d, int curr, vector <Pt> &arr, int r) {
	if (flag) {
		return;
	}
	used[v] = 1;
	d[v] = curr;
	for (int u = 0; u < used.size(); u++) {
		if (v == u) {
			continue;
		}
		if (sqDist(arr[v], arr[u]) <= r * r) {
			if (!used[u]) {
				dfs(u, used, ans, d, curr + 1, arr, r);
			}
			else if (used[u] == 1) {
				if ((d[v] - d[u]) % 2 == 0) {
					flag = true;
					return;
				}
			}
		}
	}
	used[v] = 2;
}

void paint(int v, vector <bool>& used, vector <int>& ans, vector <Pt> &arr, int r) {
	ans[v] = 1;
	used[v] = true;
	for (int u = 0; u < used.size(); u++) {
		if (v == u) {
			continue;
		}
		if (sqDist(arr[v], arr[u]) <= r * r) {
			if (!used[u]) {
				paint(u, used, ans, arr, r);
			}
		}
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, r;
	cin >> n >> r;
	vector <Pt> arr(n);
	map <pair<int, int>, int> mp;
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
		mp[{arr[i].x, arr[i].y}] = i;
	}
	vector <int> used(n, 0), ans(n, 0), d(n, 0);
	vector <bool> used2(n);
	stack <int> st;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			flag = false;
			dfs(i, used, ans, d, 0, arr, r);
			if (flag) {
				paint(i, used2, ans, arr, r);
			}
		}
	}
	for (auto el : ans) {
		cout << el;
	}
}
