#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#define int long long

using namespace std;
using ll = long long;
using ld = long double;

struct Pt {
	int x, y;
};

int sqDist(Pt a, Pt b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

void dfs(int v, vector <vector <int>>& g, vector <int>& used, vector <int>& ans, stack <int> &st) {
	used[v] = 1;
	st.push(v);
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u, g, used, ans, st);
		}
		else if (used[u] == 1) {
			int cnt = 0;
			vector <int> tmp;
			while (st.top() != u) {
				cnt++;
				tmp.push_back(st.top());
				st.pop();
			}
			cnt++;
			tmp.push_back(u);
			if (cnt % 2 == 1) {
				for (auto el : tmp) {
					ans[el] = 1;
				}
			}
			while (!tmp.empty()) {
				st.push(tmp.back());
				tmp.pop_back();
			}
		}
	}
	used[v] = 2;
	st.pop();
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, r;
	cin >> n >> r;
	vector <Pt> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
	}
	vector <vector <int>> g(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (sqDist(arr[i], arr[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	vector <int> used(n), ans(n, 0);
	stack <int> st;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i, g, used, ans, st);
		}
	}
	for (int i = 0; i < n; i++) {
		if (!ans[i]) {
			for (auto u : g[i]) {
				if (ans[u]) {
					ans[i] = 1;
				}
			}
		}
	}
	for (auto el : ans) {
		cout << el;
	}
}
