#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#pragma GCC target("avx2")
using namespace std;
using ll = int;
using lll = uint64_t;

struct Point {
    ll x, y;

    int64_t dist(Point& a) {
        int64_t f = (a.x - x), s = (a.y - y);
        return f * f + s * s;
    }

    bool operator==(const Point &p) const {
        return x == p.x && y == p.y;
    }
    bool operator<(const Point &p) const {
        return x < p.x || (x == p.x && y < p.y);
    }
};


constexpr ll N = 1e5 + 1;

unordered_set<ll> g[N];

bool ans[N], used[N];

ll color[N];

void dfs(ll v, ll col) {
    used[v] = true;
    color[v] = col;
    for (auto &u : g[v]) {
        if (!used[u]) {
            dfs(u, (col + 1) % 2);
        } else {
            if (color[u] == color[v]) {
                ans[u] = 1;
            }
        }
    }
}

void dfs2(ll v) {
    used[v] = false;
    ans[v] = 1;
    for (auto &u : g[v]) {
        if (used[u]) {
            dfs2(u);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    int64_t r;
    cin >> n >> r;
    vector<Point> a(n);

    unordered_map<lll, ll> mp;

    ll tmp = 0;
    for (auto &u : a) {
        cin >> u.x >> u.y;
        mp[(static_cast<lll>(u.y) << 32) + static_cast<lll>(u.x)] = tmp++;
    }

    for (ll i = 0; i < n; ++i) {
        for (ll dx = -10; dx <= 10; ++dx) {
            for (ll dy = -10; dy <= 10; ++dy) {
                if (dx == dy && !dx) {
                    continue;
                }
                Point p{ a[i].x + dx, a[i].y + dy };
                ll h = ((lll)p.y << 32) + (lll)p.x;
                if (a[i].dist(p) <= r * r && mp.find(h) != mp.end()) {
                    g[i].insert(mp[h]);
                    g[mp[h]].insert(i);
                }
            }
        }
    }


    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 0);
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (used[i] && ans[i] == 1) {
            dfs2(i);
        }
    }

    for (ll i = 0; i < n; ++i) {
        cout << ans[i];
    }
}