#pragma GCC optimize("Ofast, unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2")
using namespace std;
using ll = int;

struct Point {
    ll x, y;
    int64_t dist(Point& a) {
        int64_t f = (a.x - x), s = (a.y - y);
        return f * f + s * s;
    }

    bool operator==(const Point &p) const {
        return x == p.x && y == p.y;
    }
    bool operator<(const Point &p) const {
        return x < p.x || (x == p.x && y < p.y);
    }

};

constexpr ll N = 1e5 + 1;

vector<ll> g[N];

bool ans[N], used[N];

ll color[N];

void dfs(ll v, ll col) {
    used[v] = true;
    color[v] = col;
    for (auto &u : g[v]) {
        if (!used[u]) {
            dfs(u, (col + 1) % 2);
        } else {
            if (color[u] == color[v]) {
                ans[u] = 1;
            }
        }
    }
}

void dfs2(ll v) {
    used[v] = false;
    ans[v] = 1;
    for (auto &u : g[v]) {
        if (used[u]) {
            dfs2(u);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    int64_t r;
    cin >> n >> r;
    vector<Point> a(n);

    map<Point, ll> mp;

    ll tmp = 0;
    for (auto &u : a) {
        cin >> u.x >> u.y;
        mp[u] = tmp++;
    }

    for (ll i = 0; i < n; ++i) {
        for (ll dx = -4; dx <= 4; ++dx) {
            for (ll dy = -4; dy <= 4; ++dy) {
                if (dx == dy && !dx) {
                    continue;
                }
                Point p{ a[i].x + dx, a[i].y + dy };
                if (a[i].dist(p) <= r * r && mp.contains(p)) {
                    g[i].push_back(mp[p]);
                }
            }
        }
    }


    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 0);
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (used[i] && ans[i] == 1) {
            dfs2(i);
        }
    }

    for (ll i = 0; i < n; ++i) {
        cout << ans[i];
    }
}