#include <bits/stdc++.h>
using namespace std;
using ll = int64_t;

struct Point {
    int64_t x, y;
    int64_t dist(Point& a) {
        return (a.x - x) * (a.x - x) + (a.y - y) * (a.y - y);
    }
};

constexpr ll N = 1e4 + 1;

vector<ll> g[N];

bool ans[N], used[N];

ll color[N];

void dfs(ll v, ll col) {
    used[v] = true;
    color[v] = col;
    for (auto &u : g[v]) {
        if (!used[u]) {
            dfs(u, (col + 1) % 2);
        } else {
            if (color[u] == color[v]) {
                ans[u] = 1;
            }
        }
    }
}

void dfs2(ll v) {
    used[v] = false;
    ans[v] = 1;
    for (auto &u : g[v]) {
        if (used[u]) {
            dfs2(u);
        }
    }
}

int main() {
    ll n;
    int64_t r;
    cin >> n >> r;
    vector<Point> a(n);
    for (auto &u : a) {
        cin >> u.x >> u.y;
    }


    for (ll i = 0; i < n; ++i) {
        vector<pair<ll, ll>> d;
        for (ll j = i + 1; j < n; ++j) {
            d.emplace_back(a[i].dist(a[j]), j);
        }
        sort(d.begin(), d.end());
        ll cnt = 0;
        for (auto &u : d) {
            if (cnt < 5 && u.first <= r * r) {
                ++cnt;
                g[i].push_back(u.second);
                g[u.second].push_back(i);
            }
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 0);
        }
    }

    for (ll i = 0; i < n; ++i) {
        if (used[i] && ans[i] == 1) {
            dfs2(i);
        }
    }

    for (ll i = 0; i < n; ++i) {
        cout << ans[i];
    }
}