#include <bits/stdc++.h>
using namespace std;
using ll = int64_t;

struct SegTree {
    vector<ll> t;
    SegTree(ll n) : t(n * 4, 0) {}
    void Upd(ll v, ll l, ll r, ll pos) {
        if (l + 1 == r) {
            t[v] = 1;
            return;
        }
        ll m = (l + r) / 2;
        if (pos < m) {
            Upd(v * 2 + 1, l, m, pos);
        } else {
            Upd(v * 2 + 2, m, r, pos);
        }
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
    ll Get(ll v, ll ql, ll qr, ll l, ll r) {
        if (l >= qr || r <= ql) {
            return 0;
        }
        if (l >= ql && r <= qr) {
            return t[v];
        }
        ll m = (l + r) / 2;
        return Get(v * 2 + 1, ql, qr, l, m) +
            Get(v * 2 + 2, ql, qr, m, r);
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll r, c;
    cin >> r >> c;
    vector<ll> a(c);
    for (auto &u : a) {
        cin >> u;
    }

    SegTree t(c + 1);

    ll ans = 0;

    for (auto &u : a) {
        ans += t.Get(0, u, c + 1, 0, c + 1);
        t.Upd(0, 0, c + 1, u);
    }

    cout << ans << endl;
}