#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Fenwick {
    vector<int> a;
    void init(int n) {
        a.assign(n + 1, 0);
    }
    void modify(int i, int x) {
        for (++i; i < a.size(); i += i & -i) {
            a[i] += x;
        }
    }
    int sum(int i) {
        int ans = 0;
        for (++i; i > 0; i -= i & -i) {
            ans += a[i];
        }
        return ans;
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    const int N = n * m;
    vector a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vector inv(n, vector<ll>(m)), oth(m, vector<ll>(n));
    {
        Fenwick fnw;
        fnw.init(N);
        for (int i = 0; i < n; ++i) {
            for (int j = m - 1; j >= 0; --j) {
                ll s = 0;
                for (int k = i + 1; k < n; ++k) {
                    s += fnw.sum(a[k][j]);
                }
                oth[j][i] = s;
                inv[i][j] = (m - j - 1) * 1LL * (n - i - 1) - s;
                fnw.modify(a[i][j], 1);
            }
            for (int j = 0; j < m; ++j) {
                fnw.modify(a[i][j], -1);
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        for (int i = n - 2; i >= 0; --i) {
            oth[j][i] += oth[j][i + 1];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = m - 2; j >= 0; --j) {
            inv[i][j] += inv[i][j + 1];
        }
    }
    {
        int x = 0, y = 0;
        ll answer = 0;
        vector<int> arr;
        while (x < n && y < m) {
            if (inv[x][y] < oth[y][x]) {
                for (int i = x; i < n; ++i) {
                    arr.push_back(a[i][y]);
                }
                y += 1;
            } else {
                for (int j = y; j < m; ++j) {
                    arr.push_back(a[x][j]);
                }
                x += 1;
            }
        }
        Fenwick fn;
        fn.init(N);
        reverse(arr.begin(), arr.end());
        for (int x : arr) {
            answer += fn.sum(x);
            fn.modify(x, 1);
        }
        cout << answer << '\n';
        return 0;
    }

    vector dp(n + 1, vector<ll>(m + 1, 3e18));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + inv[i][j]);
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + oth[j][i]);
        }
    }
    ll answer = 3e18;
    for (int i = 0; i < n; ++i) {
        answer = min(answer, dp[i][m]);
    }
    for (int j = 0; j < m; ++j) {
        answer = min(answer, dp[n][j]);
    }
    ll cnt_inv = 0;
    Fenwick fnw;
    fnw.init(N);
    for (int x = 0; x < n; ++x) {
        for (int j = 0; j < m; ++j) {
            fnw.modify(N - a[x][j] - 1, 1);
            for (int i = x; i < n; ++i) {
                cnt_inv += fnw.sum(N - a[i][j] - 1);
            }
            cnt_inv -= 1;
        }
        for (int j = 0; j < m; ++j) {
            fnw.modify(N - a[x][j] - 1, -1);
        }
    }
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < m; ++j) {
    //         cout << val[i][j] << " ";
    //     }
    //     cout << endl;
    // }
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < m; ++j) {
    //         for (int x = 0; x <= i; ++x) {
    //             for (int y = 0; y <= j; ++y) {
    //                 cnt_inv += a[i][j] < a[x][y];
    //             }
    //         }
    //     }
    // }
    cout << answer + cnt_inv << endl;

    return 0;
}