#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>


struct pt {
    int x, y;

    pt() {
        x = 0;
        y = 0;
    }

    pt(int _x, int _y) {
        x = _x;
        y = _y;
    }
};

ll sqrt_dist(pt a, pt b) {
    return ll(a.x - b.x) * ll(a.x - b.x) + ll(a.y - b.y) * ll(a.y - b.y);
}

vector<vector<int>> g;
vector<int> used;

vector<int> answer;

bool dfs(int v, int num) {
    used[v] = num;
    for (auto now : g[v]) {
        if (used[now] == num) return true;
        else if (used[now]) continue;
        int num2;
        if (num == 2) num2 = 1;
        if (num == 1) num2 = 2;
        if (dfs(now, num2)) return true;
    }
    return false;
}

void dfs2(int v, int z) {
    answer[v] = z;
    used[v] = 1;
    for (auto now : g[v]) {
        if (used[now]) continue;
        dfs2(now, z);
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    g.resize(n + 1);
    vector<pt> a(n + 1);
    answer.resize(n + 1);

    map<pii, int> mp;

    for (int i = 1; i <= n; i++) {
        cin >> a[i].x >> a[i].y;
        mp[{a[i].x, a[i].y}] = i;
    }
    pt dr;
    for (int i = 1; i <= n; i++) {
        for (int x = a[i].x - r; x <= a[i].x + r; x++) {
            for (int y = a[i].y - r; y <= a[i].y + r; y++) {
                if (x == a[i].x && y == a[i].y) continue;
                dr = pt(x, y);
                if (sqrt_dist(a[i], dr) > r * r) continue;
                if (mp.find({x, y}) != mp.end()) {
                    int num = mp[{x, y}];
                    g[i].push_back(num);
                    g[num].push_back(i);
                }
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        if (answer[i] != 0) continue;
        used.assign(n + 1, 0);
        if (dfs(i, 1)) {
            used.assign(n + 1, 0);
            dfs2(i, 1);
        } else {
            used.assign(n + 1, 0);
            dfs2(i, 2);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (answer[i] == 1) cout << 1;
        else cout << 0;
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
