#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#pragma gcc optimize("Ofast,unroll-loops,popcnt")
#pragma gcc target("avx2,avx,fma")
#endif


#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin,x.end()
#define rall(x) x.rbegin,x.rend()
#define ll long long
#define _ <<" "<<


void solve() {
    int n, delta = 2;
    ll r;
    cin >> n >> r;
    int bl = 0, br = r;
    while (br - bl > 1){
        ll mid = (bl + br) / 2;
        if (2ll * mid * mid <= r * r) bl = mid;
        else br = mid;
    }
    int K = br;

    vector<array<ll, 2> > pts(n);
    for (int i = 0; i < n; i++) for (int j = 0; j < 2; j += 1) cin >> pts[i][j];

    auto dist2 = [&](int v1, int v2) -> ll {
        return 1ll * (pts[v1][0] - pts[v2][0]) * (pts[v1][0] - pts[v2][0]) + 1ll * (pts[v1][1] - pts[v2][1]) * (
                   pts[v1][1] - pts[v2][1]);
    };

    auto hull = [&](vector<int> vp) -> vector<int> {
        return vp;
    };

    gp_hash_table<ll, vector<int> > mp;
    for (int i = 0; i < n; i++) {
        mp[((ll)(pts[i][0] / K) << 30) + pts[i][1] / K].emplace_back(i);
    }

    queue<ll > q;
    gp_hash_table<ll, int> used;
    vector<int> res(n);
    for (auto &[coords, vp]: mp) {
        if (vp.size() >= 3) {
            for (int v: vp) used[coords] = res[v] = 1, q.emplace(coords);
        }
    }

    auto dist_p = [&](int p0, vector<int> rc)-> ll {
        ll mnd = LLONG_MAX;
        for (int x : rc) mnd = min(mnd, dist2(p0, x));
        return mnd;
    };

    while (!q.empty()) {
        auto coords = q.front();
        int bx = coords >> 30, by = coords & ((1 << 30) - 1);
        q.pop();
        used[((ll)(bx) << 30) + by] = 1;
        for (int v: mp[((ll)(bx)) + by]) res[v] = 1;
        for (int dbx = -delta; dbx <= delta; dbx += 1) {
            for (int dby = -delta; dby <= delta; dby += 1) {
                int nbx = bx + dbx, nby = by + dby;
                if (mp.find(((ll)(nbx) << 30) + nby) == mp.end()) continue;
                if (used[((ll)(nbx) << 30) + nby]) continue;
                if (mp[((ll)(bx) << 30) + by].size() >= 3 && mp[((ll)(nbx) << 30) + nby].size() >= 3) continue;

                bool ok = false;
                if (mp[((ll)(bx) << 30) + by].size() >= 3) {
                    auto rc = hull(mp[((ll)(bx) << 30) + by]);
                    for (int p2: mp[((ll)(nbx) << 30) + nby]) {
                        if (dist_p(p2, rc) <= r * r) {
                            ok = true;
                            break;
                        }
                    }
                } else {
                    auto rc = hull(mp[((ll)(nbx) << 30) + nby]);
                    for (int p2: mp[((ll)(bx) << 30) + by]) {
                        if (dist_p(p2, rc) <= r * r) {
                            ok = true;
                            break;
                        }
                    }
                }

                if (ok) used[((ll)(nbx) << 30) + nby] = 1, q.emplace(nbx, nby);
            }
        }
    }


    bool ok = true;
    vector<int> tmp, color(n);

    auto f = [&](auto &&self, int v) -> void {
        tmp.emplace_back(v);
        int bx = pts[v][0] / K, by = pts[v][1] / K;
        for (int dbx = -delta; dbx <= delta; dbx += 1) {
            for (int dby = -delta; dby <= delta; dby += 1) {
                int nbx = bx + dbx, nby = by + dby;
                if (mp.find(((ll)(nbx) << 30) + nby) == mp.end()) continue;
                if (used[((ll)(nbx) << 30) + nby]) continue;
                for (int to: mp[((ll)(nbx) << 30) + nby]) {
                    if (dist2(v, to) > r * r || to == v) continue;
                    if (!color[to]) color[to] = 3 - color[v], self(self, to);
                    else if (color[to] == color[v]) ok = false;
                }
            }
        }
    };

    for (auto &[coords, vp]: mp) {
        if (!used[coords]) {
            tmp.clear();
            ok = true;
            if (!vp.empty() && !color[vp[0]]) color[vp[0]] = 1, f(f, vp[0]);
            if (!ok) {
                for (int v: tmp) res[v] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) cout << res[i];
    cout << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:/work/IO/in.txt", "r", stdin);
    freopen("C:/work/IO/out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();
}