#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#pragma gcc optimize("Ofast,unroll-loops,popcnt")
#pragma gcc target("avx2,avx,fma")
#endif


#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin,x.end()
#define rall(x) x.rbegin,x.rend()
#define ll long long
#define _ <<" "<<

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    int K = 3; //floorl((long double) (r) / sqrtl(2)) + 1;
    
    vector<array<int, 2> > pts(n);
    for (int i = 0; i < n; i++) for (int j = 0; j < 2; j += 1) cin >> pts[i][j];

    auto dist2 = [&](int v1, int v2) -> ll {
        return 1ll * (pts[v1][0] - pts[v2][0]) * (pts[v1][0] - pts[v2][0]) + 1ll * (pts[v1][1] - pts[v2][1]) * (
                   pts[v1][1] - pts[v2][1]);
    };

    auto hull = [&](vector<int> vp) -> vector<int> {
        if (vp.size() <= 3) return vp;
        int sz = vp.size();
        for (int i = 1; i < sz; i++) if (vp[i] < vp[0]) swap(vp[i], vp[0]);
        sort(vp.begin() + 1, vp.end(), [&](const auto &p1, const auto &p2) {
            ll x1 = pts[p1][0] - pts[vp[0]][0], y1 = pts[p1][1] - pts[vp[0]][1];
            ll x2 = pts[p2][0] - pts[vp[0]][0], y2 = pts[p2][1] - pts[vp[0]][1];
            if (x1 * y2 - x2 * y1 > 0) return true;
            if (x1 * y2 - x2 * y1 == 0 && x1 * x1 + y1 * y1 < x2 * x2 + y2 * y2) return true;
            return false;
        });

        vector<int> res = {vp[0]};
        for (int i = 1; i < sz; i++) {
            while (res.size() >= 2) {
                ll lx = pts[res.back()][0] - pts[res[res.size() - 2]][0];
                ll ly = pts[res.back()][1] - pts[res[res.size() - 2]][1];
                ll cx = pts[vp[i]][0] - pts[res.back()][0];
                ll cy = pts[vp[i]][1] - pts[res.back()][1];
                if (cx * ly - cy * lx > 0) res.pop_back();
                else break;
            }
            res.emplace_back(i);
        }

        return res;
    };

    map<pair<int, int>, vector<int> > mp;
    for (int i = 0; i < n; i++) mp[{pts[i][0] / K, pts[i][1] / K}].emplace_back(i);

    queue<pair<int, int> > q;
    map<pair<int, int>, int> used;
    vector<int> res(n);
    for (auto &[coords, vp]: mp) {
        if (vp.size() >= 3) {
            for (int v: vp) used[coords] = res[v] = 1, q.emplace(coords);
        }
    }

    auto dist_p = [&](int p0, vector<int> rc)-> ll {
        int p1 = 0;
        for (int k = __lg(rc.size()); k >= 0; k--) {
            int p2 = (p1 + (1 << k)) % rc.size(), p3 = ((p1 - (1 << k)) % rc.size() + rc.size()) % rc.size();
            if (dist2(p0, rc[p2]) < dist2(p0, rc[p1])) p1 = p2;
            if (dist2(p0, rc[p3]) < dist2(p0, rc[p1])) p1 = p3;
        }
        return dist2(p0, rc[p1]);
    };

    while (!q.empty()) {
        auto [bx, by] = q.front();
        q.pop();
        used[{bx, by}] = 1;
        for (int v: mp[{bx, by}]) res[v] = 1;
        for (int dbx = -1; dbx <= 1; dbx += 1) {
            for (int dby = -1; dby <= 1; dby += 1) {
                int nbx = bx + dbx, nby = by + dby;
                if (used[{nbx, nby}]) continue;
                if (mp[{bx, by}].size() >= 3 && mp[{nbx, nby}].size() >= 3) continue;

                bool ok = false;
                if (mp[{bx, by}].size() >= 3) {
                    auto rc = hull(mp[{bx, by}]);
                    for (int p2: mp[{nbx, nby}]) {
                        if (dist_p(p2, rc) <= r * r) {
                            ok = true;
                            break;
                        }
                    }
                } else {
                    auto rc = hull(mp[{nbx, nby}]);
                    for (int p2: mp[{bx, by}]) {
                        if (dist_p(p2, rc) <= r * r) {
                            ok = true;
                            break;
                        }
                    }
                }

                if (ok) used[{nbx, nby}] = 1, q.emplace(nbx, nby);
            }
        }
    }


    bool ok = true;
    vector<int> tmp, color(n);

    auto f = [&](auto &&self, int v) -> void {
        tmp.emplace_back(v);
        int bx = pts[v][0] / K, by = pts[v][1] / K;
        for (int dbx = -1; dbx <= 1; dbx += 1) {
            for (int dby = -1; dby <= 1; dby += 1) {
                int nbx = bx + dbx, nby = by + dby;
                if (used[{nbx, nby}]) continue;
                for (int to: mp[{nbx, nby}]) {
                    if (dist2(v, to) > r * r || to == v) continue;
                    if (!color[to]) color[to] = 3 - color[v], self(self, to);
                    else if (color[to] == color[v]) ok = false;
                }
            }
        }
    };

    for (auto &[coords, vp]: mp) {
        if (!used[coords]) {
            tmp.clear();
            ok = true;
            if (!vp.empty()) f(f, vp[0]);
            if (!ok) {
                for (int v: tmp) res[v] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) cout << res[i];
    cout << nl;
}

signed main() {
#ifdef LOCAL
    freopen("C:/work/IO/in.txt", "r", stdin);
    freopen("C:/work/IO/out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();
}
