#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using str = string;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 1e5 + 239;
vector<vector<int>> g(MAXN);
vector<int> used(MAXN, 0);
bool fl;

void dfs(int v) {
	for (int u : g[v]) {
		if (used[v] == used[u]) {
			fl = true;
		}
		if (used[u] == 0) {
			if (used[v] == 1) {
				used[u] = 2;
			}
			else {
				used[u] = 1;
			}
			dfs(u);
		}
	}
}

vector<int> ans(MAXN, -1);

void col(int v) {
	ans[v] = 1;
	for (int u : g[v]) {
		if (ans[u] == -1) {
			col(u);
		}
	}
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<pair<ll, ll>> x(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i].first;
		x[i].second = i;
		int y;
		cin >> y;
	}
	sort(x.begin(), x.end());
	vector<bool> ans(n, false);
	for (int i = 0; i < n; i++) {
		if (i + 2 < n && abs(x[i].first - x[i + 2].first) <= r) {
			ans[x[i].second] = true;
			ans[x[i + 1].second] = true;
			ans[x[i + 2].second] = true;
		}
		if (i > 0 && ans[x[i - 1].second] && abs(x[i].first - x[i - 1].first) <= r) {
			ans[x[i].second] = true;
		}
	}
	for (int i = 0; i < n; i++) {
		cout << ans[i];
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}

