#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using str = string;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 10000;
vector<vector<int>> g(MAXN);
vector<bool> pb(MAXN, false);
vector<bool> used(MAXN, false);
bool fl;

void dfs(int v) {
	pb[v] = true;
	for (int u : g[v]) {
		if (used[v] & used[u]) {
			fl = true;
		}
		if (!pb[u]) {
			if (used[v]) {
				used[u] = false;
			} else {
				used[u] = true;
			}
			dfs(u);
		}
	}
}

vector<bool> ans(MAXN);

void col(int v) {
	ans[v] = 1;
	for (int u : g[v]) {
		if (!ans[u]) {
			col(u);
		}
	}
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<ll> x(n);
	vector<ll> y(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!pb[i]) {
			fl = false;
			used[i] = true;
			dfs(i);
			if (fl) {
				col(i);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		cout << ans[i];
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}