#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using str = string;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 5e5 + 239;
vector<vector<int>> g(MAXN);
vector<int> used(MAXN, 0);
bool fl;

void dfs(int v) {
	for (int u : g[v]) {
		if (used[v] == used[u]) {
			fl = true;
		}
		if (used[u] == 0) {
			if (used[v] == 1) {
				used[u] = 2;
			}
			else {
				used[u] = 1;
			}
			dfs(u);
		}
	}
}

vector<int> ans(MAXN, -1);

void col(int v) {
	ans[v] = 1;
	for (int u : g[v]) {
		if (ans[u] == -1) {
			col(u);
		}
	}
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<ll> a(n);
	vector<ll> b(n);
	map<pair<ll, ll>, int> mp;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		mp[{ a[i], b[i] }] = i;
	}
	for (int i = 0; i < n; i++) {
		for (ll x = 0; x <= r; x++) {
			ll y = 0;
			while (x * x + y * y <= r * r) {
				if (x > 0 || y > 0) {
					if (mp.count({ a[i] + x, b[i] + y })) {
						int j = mp[{ a[i] + x, b[i] + y }];
						g[i].push_back(j);
						g[j].push_back(i);
					}
					if (mp.count({ a[i] + x, b[i] - y })) {
						int j = mp[{ a[i] + x, b[i] - y }];
						g[i].push_back(j);
						g[j].push_back(i);
					}
					if (mp.count({ a[i] - x, b[i] - y })) {
						int j = mp[{ a[i] - x, b[i] - y }];
						g[i].push_back(j);
						g[j].push_back(i);
					}
					if (mp.count({ a[i] - x, b[i] + y })) {
						int j = mp[{ a[i] - x, b[i] + y }];
						g[i].push_back(j);
						g[j].push_back(i);
					}
				}
				y++;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			fl = false;
			used[i] = 1;
			dfs(i);
			if (fl) {
				col(i);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (ans[i] == 1) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}