#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using str = string;

const int INF = 1e9 + 239;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector<vector<int>> dp(n, vector<int>(m, INF));
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (i != 0) {
				vector<int> now;
				for (int ii = 0; ii < n; ii++) {
					for (int jj = 0; jj < m; jj++) {
						if (ii < i - 1 || jj < j) {
							now.push_back(a[ii][jj]);
						}
					}
				}
				int ans = dp[i - 1][j];
				for (int u = j; u < m; u++) {
					for (auto el : now) {
						if (el > a[i - 1][u]) {
							ans++;
						}
					}
					now.push_back(a[i - 1][u]);
				}
				dp[i][j] = min(dp[i][j], ans);
			}
			if (j != 0) {
				vector<int> now;
				for (int ii = 0; ii < n; ii++) {
					for (int jj = 0; jj < m; jj++) {
						if (ii < i || jj < j - 1) {
							now.push_back(a[ii][jj]);
						}
					}
				}
				int ans = dp[i][j - 1];
				for (int u = i; u < n; u++) {
					for (auto el : now) {
						if (el > a[u][j - 1]) {
							ans++;
						}
					}
					now.push_back(a[u][j - 1]);
				}
				dp[i][j] = min(dp[i][j], ans);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (a[i][j] > a[n - 1][m - 1]) {
				dp[n - 1][m - 1]++;
			}
		}
	}
	cout << dp[n - 1][m - 1];
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}