#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using str = string;

const int INF = 1e9 + 239;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

const int MAXN = 3e5 + 239;
vector<int> tree(MAXN * 4, 0);

void update(int v, int l, int r, int p, int val) {
	if (l == r) {
		tree[v] = val;
	}
	else {
		int m = (l + r) / 2;
		if (p <= m) {
			update(2 * v, l, m, p, val);
		}
		else {
			update(2 * v + 1, m + 1, r, p, val);
		}
		tree[v] = tree[2 * v] + tree[2 * v + 1];
	}
}

int get(int v, int l, int r, int lq, int rq) {
	if (l == lq && r == rq) {
		return tree[v];
	}
	if (l > rq || r < lq) {
		return 0;
	}
	int m = (l + r) / 2;
	return get(2 * v, l, m, lq, min(m, rq)) + get(2 * v + 1, m + 1, r, max(m + 1, lq), rq);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	vector<vector<int>> dp(n, vector<int>(m, INF));
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int ii = 0; ii < n; ii++) {
			for (int jj = 0; jj < m; jj++) {
				if (i < ii) {
					update(1, 0, n * m, a[ii][jj], 1);
				}
				else {
					update(1, 0, n * m, a[ii][jj], 0);
				}
			}
		}
		for (int j = 0; j < m; j++) {
			if (i != 0) {
				int ans = dp[i - 1][j];
				for (int u = j; u < m; u++) {
					update(1, 0, n * m, a[i - 1][u], 0);
				}
				for (int u = j; u < m; u++) {
					ans += get(1, 0, n * m, a[i - 1][u], n * m);
					if (i == n - 1 && j == m - 1) {
					}
					update(1, 0, n * m, a[i - 1][u], 1);
				}
				dp[i][j] = min(dp[i][j], ans);
			}
			if (j != 0) {
				int ans = dp[i][j - 1];
				for (int u = i; u < n; u++) {
					update(1, 0, n * m, a[u][j - 1], 0);
				}
				for (int u = j; u < n; u++) {
					ans += get(1, 0, n * m, a[u][j - 1], n * m);
					update(1, 0, n * m, a[u][j - 1], 1);
				}
				dp[i][j] = min(dp[i][j], ans);
			}
			for (int ii = i; ii < n; ii++) {
				update(1, 0, n * m, a[ii][j], 1);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (a[i][j] > a[n - 1][m - 1]) {
				dp[n - 1][m - 1]++;
			}
		}
	}
	cout << dp[n - 1][m - 1];
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}