#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using lll = __int128;

const int mod = int(1e9) + 7;
const ll inf = ll(2e18) + 36;

vector <ll> p, sz, c;
vector <vector <ll>> t;
vector <ll> ans;

ll find(ll v) {
    return (v == p[v] ? v : p[v] = find(p[v]));
}

void unite(ll x, ll y) {
    ll u = find(x);
    ll v = find(y);
    if (u == v) {
        if (c[x] == c[y]) {
            ans[v] = 1;
        }
        return;
    }
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    sz[u] += sz[v];
    p[v] = u;
    ans[u] |= ans[v];
    bool fl = c[x] == c[y];
    for (auto& it : t[v]) {
        if (fl) {
            c[it] = 1 - c[it];
        }
        t[u].emplace_back(it);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, r;
    cin >> n >> r;
    vector<pair <ll, ll>> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    p.resize(n);
    iota(p.begin(), p.end(), 0);
    sz.resize(n, 1);
    ans.resize(n);
    c.resize(n);
    t.resize(n);
    unordered_map <ll, ll> mp;
    for (ll i = 0; i < n; i++) {
        mp[a[i].first * mod + a[i].second] = i;
        t[i].emplace_back(i);
    }
    for (ll i = 0; i < n; i++) {
        for (ll x = a[i].first; x <= a[i].first + r; x++) {
            for (ll y = a[i].second - r; y <= a[i].second + r; y++) {
                if (x == a[i].first && y == a[i].second) continue;
                if ((a[i].first - x) * (a[i].first - x) + (a[i].second - y) * (a[i].second - y) > r * r) continue;
                if (mp.count(x * mod + y)) {
                    unite(i, mp[x * mod + y]);
                }
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        cout << ans[find(i)];
    }
    return 0;
}