#include "bits/stdc++.h"
using namespace std;
#define int int64_t

vector<int> a;
int n, q;

struct SparseMin {
    vector<vector<pair<int, int> > > sp;

    void init(vector<int> &arr) {
        const int lgg = __lg(arr.size()) + 1;
        sp.assign(lgg, vector<pair<int, int> >(arr.size()));
        for (int i = 0; i < n; ++i) {
            sp[0][i] = {a[i], i};
        }
        for (int lg = 1; lg < lgg; ++lg) {
            for (int i = 0; i < n; ++i) {
                sp[lg][i] = sp[lg - 1][i];
                if (i + (1ll << (lg - 1)) < n) {
                    sp[lg][i] = min(sp[lg][i], sp[lg - 1][i + (1ll << (lg - 1))]);
                }
            }
        }
    }

    pair<int, int> get(int l, int r) {
        int lgg = __lg(r - l + 1);
        return min(sp[lgg][l], sp[lgg][r - (1ll << lgg) + 1]);
    }
};

struct SparseMax {
    vector<vector<pair<int, int> > > sp;

    void init(vector<int> &arr) {
        const int lgg = __lg(arr.size()) + 1;
        sp.assign(lgg, vector<pair<int, int> >(arr.size()));
        for (int i = 0; i < (int) arr.size(); ++i) {
            sp[0][i] = {a[i], i};
        }
        for (int lg = 1; lg < lgg; ++lg) {
            for (int i = 0; i < (int) arr.size(); ++i) {
                sp[lg][i] = sp[lg - 1][i];
                if (i + (1ll << (lg - 1)) < n) {
                    sp[lg][i] = max(sp[lg][i], sp[lg - 1][i + (1ll << (lg - 1))]);
                }
            }   
        }
    }

    pair<int, int> get(int l, int r) {
        int lgg = __lg(r - l + 1);
        return max(sp[lgg][l], sp[lgg][r - (1ll << lgg) + 1]);
    }
};

vector<int> nearestbigger;
SparseMin spmin;
SparseMax spmax;


vector<vector<int> > calced;

void getcalced(int k) {
    calced.emplace_back();
    calced.back().reserve(k);
    int left = k;
    for (int i = 0; i < n; ++i) {
        int now = a[i];
        if (left == 1) {
            calced.back().push_back(spmax.get(i, n - 1).first);
            left--;
            break;
        }
        int upto = nearestbigger[i];
        upto = min(upto, n - left + 1);
        auto [mn, index] = spmin.get(i + 1, upto);
        calced.back().push_back(now);
        i = index - 1;
        left--;
    }
}

void solve() {
    cin >> n >> q;
    a.assign(n + 1, {});
    a[n] = LLONG_MAX;
    nearestbigger.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    spmin.init(a);
    spmax.init(a);
    vector<int> st = {n};
    for (int i = n - 1; i >= 0; --i) {
        while (a[st.back()] <= a[i]) st.pop_back();
        nearestbigger[i] = st.back();
        st.push_back(i);
    }
    calced.emplace_back();
    for (int k = 1; k <= n; ++k) {
        getcalced(k);
    }
    for (int qq = 0; qq < q; ++qq) {
        int k, i;
        cin >> k >> i;
        cout << calced[k][i - 1] << '\n';
    }
}

signed main() {
#ifdef SEREGA
    freopen("/home/roi/work/proj/input.txt", "r", stdin);
    freopen("/home/roi/work/proj/output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}
