#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long, long> pll;
//#define endl '\n'
//#define int ll

vector<vector<int>> g;
vector<int> color, used, answer;

bool dfs1(int v, int clr = 1) {
	color[v] = clr;
	for (auto to : g[v]) {
		if (!color[to] && !dfs1(to, 3 - clr)) return false;
		else if (color[v] == color[to]) return false;
	}
	return true;
}

void dfs2(int v, int ans) {
	answer[v] = ans;
	used[v] = 1;
	for (auto to : g[v])
		if (!used[to]) dfs2(to, ans);
	return;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n; cin >> n;
	ll r; cin >> r;
	vector<pair<ll, ll>> arr(n);

	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
	}

	g.resize(n);
	used.resize(n, 0);
	color.resize(n, 0);
	answer.resize(n, 0);


	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ll pw1 = (arr[i].first - arr[j].first) * (arr[i].first - arr[j].first);
			ll pw2 = (arr[i].second - arr[j].second) * (arr[i].second - arr[j].second);

			if (pw1 + pw2 <= r * r) {
				g[i].emplace_back(j);
				g[j].emplace_back(i);
			}
		}
	}


	for (int v = 0; v < n; v++) {
		if (!color[v]) {
			bool cur = dfs1(v);
			if (cur) dfs2(v, 0);
			else dfs2(v, 1);
		}
	}

	for (auto res : answer) {
		cout << res;
	}
}