#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long, long> pll;
//#define endl '\n'
//#define int ll

vector<vector<int>> g;
vector<int> color, used, answer;

bool dfs1(int v, int clr = 1) {
	color[v] = clr;
	for (auto to : g[v]) {
		if (!color[to] && !dfs1(to, 3 - clr)) return false;
		else if (color[v] == color[to]) return false;
	}
	return true;
}

void dfs2(int v, int ans) {
	answer[v] = ans;
	used[v] = 1;
	for (auto to : g[v])
		if (!used[to]) dfs2(to, ans);
	return;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n; cin >> n;
	ll r; cin >> r;
	vector<pair<ll, ll>> arr(n);
	set<pair<ll, ll>> all;
	map<pair<int, int>, int> inds;
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
		inds[arr[i]] = i;
		all.insert(arr[i]);
	}

	g.resize(n);
	used.resize(n, 0);
	color.resize(n, 0);
	answer.resize(n, 0);


	for (int i = 0; i < n; i++) {
		ll x1 = arr[i].first;
		ll y1 = arr[i].second;
		for (ll x2 = x1 - r; x2 <= x1 + r; x2++) {
			for (ll y2 = y1 - r; y2 <= y1 + r; y2++) {
				if (all.count(make_pair(x2, y2))) {
					ll pw1 = (x2 - x1); pw1 *= pw1;
					ll pw2 = (y2 - y1); pw2 *= pw2;
					if (pw1 + pw2 <= r * r && pw1 + pw2) {
						g[i].emplace_back(inds[make_pair(x2, y2)]);
					}
				}
			}
		}
	}


	for (int v = 0; v < n; v++) {
		if (!used[v]) {
			bool cur = dfs1(v);
			if (cur) dfs2(v, 0);
			else dfs2(v, 1);
		}
	}

	for (int i = 0; i < n; i++) cout << answer[i];
}