#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long, long> pll;
//#define endl '\n'
#define int ll


struct seg_tree {
	vector<int> tree;
	seg_tree(int n) {
		tree.resize(4 * n);
	}

	void upd(int v, int l, int r, int ind) {
		if (r - l == 1) {
			tree[v] = 1;
			return;
		}

		int mid = (l + r) / 2;
 		if (mid > ind) upd(v * 2 + 1, l, mid, ind);
		else upd(v * 2 + 2, mid, r, ind);
		tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
	}

	ll get(int v, int l, int r, int ql, int qr) {
		if (l >= qr || ql >= r) return 0;
		if (ql <= l && r <= qr) return tree[v];
		int mid = (l + r) / 2;
		return get(v * 2 + 1, l, mid, ql, qr) + get(v * 2 + 2, mid, r, ql, qr);
	}
};

ll cnt_rev(vector<int> arr) {
	int n = arr.size();
	vector<int> sarr = arr;
	sort(sarr.begin(), sarr.end());
	vector<int> nrm_sarr = {};
	seg_tree tree(n);

	ll res = 0;
	for (int i = 0; i < n; i++) {
		res += tree.get(0, 0, n, arr[i], n);
		tree.upd(0, 0, n, arr[i]);
	}
	return res;
}

int n, m;
vector<vector<int>> arr;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	cin >> n;
	cin >> m;

	arr.resize(n, vector<int>(m));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> arr[i][j]; arr[i][j]--;
		}
	}

	vector<vector<int>> dp(n, vector<int>(m, 1e9));
	vector<seg_tree> trees(m, seg_tree(n * m));
	dp[n - 1][m - 1] = 0;

	vector<vector<int>> cur_stb(m);

	for (int y = n - 1; y >= 0; y--) {
		vector<int> cur_line = {};
		for (int x = m - 1; x >= 0; x--) {
			//recount dp[y][x]
			cur_line.emplace_back(arr[y][x]);
			cur_stb[x].emplace_back(arr[y][x]);
			trees[x].upd(0, 0, n * m, arr[y][x]);
			if (x == m - 1 && y == n - 1) continue;
			if (y != n - 1) {
				int cury = y;
				int res = dp[y + 1][x];
				for (int curx = x; curx < m; curx++) {
					int cur_val = arr[cury][curx];
					for (int i = x; i < m; i++) {
						res += trees[i].get(0, 0, n * m, 0, cur_val);
					}
				}
				int sz = m - x;
				int T = (sz * (sz - 1)) / 2;
				res -= cnt_rev(cur_line);
				dp[y][x] = min(dp[y][x], res);
			}

			if (x != m - 1) {
				int res = dp[y][x + 1];
				int curx = x;
				for (int cury = y; cury < n; cury++) {
					int cur_val = arr[cury][curx];
					for (int i = x + 1; i < m; i++) {
						res += trees[i].get(0, 0, n * m, 0, cur_val);
					}
				}

				dp[y][x] = min(dp[y][x], res + cnt_rev(cur_stb[x]));
			}
		}
	}

	cout << dp[0][0];
}