#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
typedef pair<long,long> pll;
//#define endl '\n'
//#define int ll

struct seg_tree {
    vector<int> tree;
    seg_tree(int n) {
        tree.resize(4 * n);
    }

    void upd(int v, int l, int r, int ind) {
        if (r - l == 1) {
            tree[v] = 1;
            return;
        }

        int mid = (l + r) / 2;
        if (mid > ind) upd(v * 2 + 1, l, mid, ind);
        else upd(v * 2 + 2, mid, r, ind);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    ll get(int v , int l, int r, int ql, int qr) {
        if (l >= qr || ql >= r) return 0;
        if (ql <= l && r <= qr) return tree[v];
        int mid = (l + r) / 2;
        return get(v * 2 + 1, l, mid, ql, qr) + get(v * 2 + 2, mid, r, ql, qr);
    }
};

ll cnt_rev(vector<int> arr) {
    int n = arr.size();
    vector<int> sarr = arr;
    sort(sarr.begin(), sarr.end());
    vector<int> nrm_sarr = {};
    seg_tree tree(n);

    ll res = 0;
    for (int i = 0 ; i < n ; i ++) {
        res += tree.get(0, 0, n, arr[i], n);
        tree.upd(0, 0, n, arr[i]);
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int n; cin >> n;
    int m; cin >> m;

    vector<vector<int>> arr(n, vector<int>(m));

    for (int i = 0 ; i < n ;  i++) {
        for (int j = 0 ; j < m ; j++) {
            cin >> arr[i][j]; arr[i][j]--;
        }
    }

    if (n == 1) {
        cout << cnt_rev(arr[0]);
    }
}