#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long, long> pll;
//#define endl '\n'
//#define int ll

struct seg_tree_max {
	vector<int> tree;
	seg_tree_max() {}
	seg_tree_max(int n) {
		tree.resize(4 * n);
	}

	void upd(int v, int l, int r, int ind, int val) {
		if (r - l == 1) {
			tree[v] = val;
			return;
		}
		int mid = (l + r) / 2;
		if (mid > ind) upd(v * 2 + 1, l, mid, ind, val);
		else upd(v * 2 + 2, mid, r, ind, val);
		tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
	}

	int get_ind(int v, int l, int r, int ql, int qr, int val) {
		if (l >= qr || ql >= r) return 1e9;
		if (ql <= l && r <= qr) {
			if (tree[v] <= val) return 1e9;
			if (r - l == 1) return l;
			int mid = (l + r) / 2;
			if (tree[v * 2 + 1] <= val) return get_ind(v * 2 + 2, mid, r, ql, qr, val);
			else return get_ind(v * 2 + 1, l, mid, ql, qr, val);
		}

		int mid = (l + r) / 2;
		int lft = get_ind(v * 2 + 1, l, mid, ql, qr, val);
		if (lft != 1e9) return lft;
		return  get_ind(v * 2 + 2, mid, r, ql, qr, val);
	}

	int get_max(int v, int l, int r, int ql, int qr) {
		if (l >= qr || ql >= r) return -1e9;
		if (ql <= l && r <= qr) return tree[v];

		int mid = (l + r) / 2;
		return max(get_max(v * 2 + 2, l, mid, ql, qr), get_max(v * 2 + 2, mid, r, ql, qr));
	}
};


struct seg_tree_min {
	vector<pair<int, int>> tree;
	seg_tree_min() {}
	seg_tree_min(int n) {
		tree.resize(4 * n);
	}

	void upd(int v, int l, int r, int ind, int val) {
		if (r - l == 1) {
			tree[v] = make_pair(val, l);
			return;
		}
		int mid = (l + r) / 2;
		if (mid > ind) upd(v * 2 + 1, l, mid, ind, val);
		else upd(v * 2 + 2, mid, r, ind, val);
		if (tree[v * 2 + 1].first <= tree[v * 2 + 2].first) tree[v] = tree[v * 2 + 1];
		else tree[v] = tree[v * 2 + 2];
	}

	pair<int, int> get_min(int v, int l, int r, int ql, int qr) {
		if (l >= qr || ql >= r) return make_pair(1e9, 1e9);
		if (ql <= l && r <= qr) return tree[v];

		int mid = (l + r) / 2;
		auto lft = get_min(v * 2 + 1, l, mid, ql, qr);
		auto rgh = get_min(v * 2 + 2, mid, r, ql, qr);

		if (lft.first <= rgh.first) return lft;
		else return rgh;
	}
};

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n; cin >> n;
	int q; cin >> q;
	vector<int> arr(n);
	seg_tree_max mxtree(n);
	seg_tree_min mntree(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		mxtree.upd(0, 0, n, i, arr[i]);
		mntree.upd(0, 0, n, i, arr[i]);
	}


	for (int i = 0; i < q; i++) {
		int k, b;
		cin >> k >> b;
		b--;
		int ind = 0;
		int bl = 0;

		if (k == n) {
			cout << arr[b] << '\n';
			continue;
		}

		if (k == 1) {
			cout << mxtree.get_max(0, 0, n, 0, n) << '\n';
			continue;
		}

		int ans = 1e9;

		while (bl != k) {
			if (bl == b) {
				if (bl == k - 1) {
					ans = mxtree.get_max(0, 0, n, ind, n);
				}
				else {
					ans = arr[ind];
				}
				break;
			}
			if (n - ind == k - bl) {
				ind++;
				bl++;
				continue;
			}

			int lf_max = mxtree.get_ind(0, 0, n, ind, n, arr[ind]);

			if (lf_max == ind + 1) {
				ind++;
				bl++;
				continue;
			}

			int left_blocks = k - bl - 1;

			auto pr = mntree.get_min(0, 0, n, ind + 1, min(lf_max, n - left_blocks + 1));

			ind = pr.second;
			bl++;
			continue;
		}

		cout << ans << '\n';
	}
}