#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;


struct point {
    ll x, y;
    int id;
    point(ll _x = 0, ll _y = 0, int _id = -1) : x(_x), y(_y), id(_id) {}
    bool operator<(const point& p) const {
        return id < p.id;
    }
};

const ll MAX_COORD = 5e8;
ll n, r, k, r2;
vector<bool> used, term, check_cycle;
vector<int> depth;
unordered_map<ll, set<point>> p_map;
vector<point> p_v;
vector<int> comp;

ll dist(point& p1, point& p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

void dfs_term(int v) {
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        v = q.front();
        q.pop();
        term[v] = 1;
        ll x = p_v[v].x / r, y = p_v[v].y / r;
        for (auto it = p_map[x * k + y].begin(); it != p_map[x * k + y].end();) {
            point p = *it;
            if (!term[p.id] && dist(p_v[v], p) <= r2) {
                int id = p.id;
                it = p_map[x * k + y].erase(it);
                q.push(id);
            } else {
                ++it;
            }
        }
        if (x != k - 1) {
            for (auto it = p_map[x * k + y + k].begin(); it != p_map[x * k + y + k].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y + k].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (x != 0) {
            for (auto it = p_map[x * k + y - k].begin(); it != p_map[x * k + y - k].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y - k].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (y != k - 1) {
            for (auto it = p_map[x * k + y + 1].begin(); it != p_map[x * k + y + 1].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y + 1].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (y != 0) {
            for (auto it = p_map[x * k + y - 1].begin(); it != p_map[x * k + y - 1].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y - 1].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (x != k - 1 && y != k - 1) {
            for (auto it = p_map[x * k + y + k + 1].begin(); it != p_map[x * k + y + k + 1].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y + k + 1].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (x != k - 1 && y != 0) {
            for (auto it = p_map[x * k + y + k - 1].begin(); it != p_map[x * k + y + k - 1].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y + k - 1].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (x != 0 && y != k - 1) {
            for (auto it = p_map[x * k + y - k + 1].begin(); it != p_map[x * k + y - k + 1].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y - k + 1].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
        if (x != 0 && y != 0) {
            for (auto it = p_map[x * k + y - k - 1].begin(); it != p_map[x * k + y - k - 1].end();) {
                point p = *it;
                if (!term[p.id] && dist(p_v[v], p) <= r2) {
                    int id = p.id;
                    it = p_map[x * k + y - k - 1].erase(it);
                    q.push(id);
                } else {
                    ++it;
                }
            }
        }
    }
}

void check_term(int v) {
    int cnt = 0;
    ll x = p_v[v].x / r, y = p_v[v].y / r;
    for (auto p : p_map[x * k + y]) {
        if (dist(p_v[v], p) <= r2) ++cnt;
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (y != k - 1) {
        for (auto p : p_map[x * k + y + k]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (x != 0) {
        for (auto p : p_map[x * k + y - k]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (y != k - 1) {
        for (auto p : p_map[x * k + y + 1]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (y != 0) {
        for (auto p : p_map[x * k + y - 1]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (x != k - 1 && y != k - 1) {
        for (auto p : p_map[x * k + y + k + 1]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (x != k - 1 && y != 0) {
        for (auto p : p_map[x * k + y + k - 1]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (x != 0 && y != k - 1) {
        for (auto p : p_map[x * k + y - k + 1]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
    if (x != 0 && y != 0) {
        for (auto p : p_map[x * k + y - k - 1]) {
            if (dist(p_v[v], p) <= r2) ++cnt;
        }
    }
    if (cnt >= 6) {
        p_map[x * k + y].erase(p_v[v]);
        dfs_term(v);
        return;
    }
}

void dfs_comp(int v, int c, int d) {
    comp[v] = c;
    depth[v] = d;
    ll x = p_v[v].x / r, y = p_v[v].y / r;
    for (auto p : p_map[x * k + y]) {
        if (!comp[p.id] && dist(p_v[v], p) <= r2) {
            dfs_comp(p.id, c, d + 1);
        } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
            check_cycle[c] = 1;
        }
    }
    if (x != k - 1) {
        for (auto p : p_map[x * k + y + k]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (x != 0) {
        for (auto p : p_map[x * k + y - k]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (y != k - 1) {
        for (auto p : p_map[x * k + y + 1]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (y != 0) {
        for (auto p : p_map[x * k + y - 1]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (x != k - 1 && y != k - 1) {
        for (auto p : p_map[x * k + y + k + 1]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (x != k - 1 && y != 0) {
        for (auto p : p_map[x * k + y + k - 1]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (x != 0 && y != k - 1) {
        for (auto p : p_map[x * k + y - k + 1]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
    if (x != 0 && y != 0) {
        for (auto p : p_map[x * k + y - k - 1]) {
            if (!comp[p.id] && dist(p_v[v], p) <= r2) {
                dfs_comp(p.id, c, d + 1);
            } else if (v != p.id && dist(p_v[v], p) <= r2 && ((depth[p.id] - d) & 1) == 0) {
                check_cycle[c] = 1;
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> r;
    k = MAX_COORD / r + 1;
    r2 = r * r;
    used.resize(n), term.resize(n);
    comp.resize(n), check_cycle.resize(n + 1), depth.resize(n);
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        p_map[x / r * k + y / r].insert(point(x, y, i));
        p_v.push_back(point(x, y, i));
    }

    for (int i = 0; i < n; ++i) {
        if (!term[i]) check_term(i);
    }

    int cur_comp = 1;
    for (int i = 0; i < n; ++i) {
        if (!term[i] && !comp[i]) {
            dfs_comp(i, cur_comp, 0);
            ++cur_comp;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (term[i] || check_cycle[comp[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }

    return 0;
}