#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;

struct FenwickTree {
    vector<vector<vector<int>>> tree;
    int r, c;

    FenwickTree(int _r, int _c) : r(_r), c(_c) {
        tree.resize(r + 1, vector<vector<int>>(c + 1));
    }

    void update(int x, int y, int val) {
        int _y = y;
        for (; x <= r; x += (x & -x)) {
            for (y = _y; y <= c; y += (y & -y)) {
                tree[x][y].push_back(val);
            }
        }
    }

    void sort_arrs() {
        for (int i = 0; i <= r; ++i) {
            for (int j = 0; j <= c; ++j) {
                sort(tree[i][j].begin(), tree[i][j].end());
            }
        }
    }

    int get(int x, int y, int val) {
        int _y = y, res = 0;
        for (; x > 0; x -= (x & -x)) {
            for (y = _y; y > 0; y -= (y & -y)) {
                res += lower_bound(tree[x][y].begin(), tree[x][y].end(), val) - tree[x][y].begin();
            }
        }
        return res;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll r, c;
    cin >> r >> c;
    ll _r = min(r, c), _c = max(r, c);

    vector<vector<ll>> arr(_r, vector<ll>(_c)), 
        dp(_r, vector<ll>(_c, INF)),
        version(_r, vector<ll>(_c, 0));
    if (r <= c) {
        for (ll i = 0; i < r; ++i) {
            for (ll j = 0; j < c; ++j) {
                cin >> arr[i][j];
            }
        }
    } else {
        for (ll i = 0; i < r; ++i) {
            for (ll j = 0; j < c; ++j) {
                cin >> arr[j][i];
            }
        }
    }
    r = _r, c = _c;

    FenwickTree ft(r, c);
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            ft.update(r - i, c - j, arr[i][j]);
        }
    }
    ft.sort_arrs();

    dp[r - 1][c - 1] = 0;
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            if (i != r - 1) {
                ordered_set s;
                ll cnt = 0;
                for (int k = j; k < c; ++k) {
                    cnt += s.size() - s.order_of_key(arr[i][k]);
                    s.insert(arr[i][k]);
                    cnt += ft.get(r - i - 1, c - j, arr[i][k]);
                }
                dp[i][j] = cnt + dp[i + 1][j];
            }
            if (j != c - 1) {
                ordered_set s;
                ll cnt = 0;
                for (int k = i; k < r; ++k) {
                    cnt += s.size() - s.order_of_key(arr[k][j]);
                    s.insert(arr[k][j]);
                    cnt += ft.get(r - i, c - j - 1, arr[k][j]);
                }
                dp[i][j] = min(dp[i][j], cnt + dp[i][j + 1]);
            }
        }
    }

    cout << dp[0][0];

    return 0;
}