#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct SparseTable {
    vector<int> arr;
    vector<vector<pair<int, int>>> table;
    int sz, lg_sz;

    SparseTable(vector<int> _arr) {
        arr = _arr;
        sz = arr.size();
        sz = arr.size();
        lg_sz = __lg(sz) + 1;
        table.resize(sz, vector<pair<int, int>>(lg_sz));
        build();
    }

    void build() {
        for (int i = sz - 1; i >= 0; --i) {
            table[i][0] = {arr[i], i};
            for (int j = 1; j < lg_sz; ++j) {
                table[i][j] = min(table[i][j - 1], table[min(sz - 1, i + (1 << (j - 1)))][j - 1]);
            }
        }
    }

    int get(int l, int r) {
        int lg_len = __lg(r - l);
        return min(table[l][lg_len], table[r - (1 << lg_len)][lg_len]).second;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }

    vector<int> st_max;
    vector<int> nearest(n);
    for (int i = 0; i < n; ++i) {
        while (!st_max.empty() && arr[i] > arr[st_max.back()]) {
            nearest[st_max.back()] = i;
            st_max.pop_back();
        }
        st_max.push_back(i);
    }
    while (!st_max.empty()) {
        nearest[st_max.back()] = n;
        st_max.pop_back();
    }

    vector<int> max_pref(n);
    int x = 0;
    for (int i = n - 1; i >= 0; --i) {
        x = max(x, arr[i]);
        max_pref[i] = x;
    }

    SparseTable st(arr);

    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        --i;
        vector<int> starts;
        int pos = 0;
        while (pos < n) {
            starts.push_back(pos);
            if (pos + 1 == nearest[pos]) {
                ++pos;
            } else {
                pos = min((int)(n - (k - starts.size())), st.get(pos + 1, nearest[pos]));
            }
        }
        cout << arr[starts[i]] << '\n';
    }

    return 0;
}