#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;

#define int long long

void dfs(int v, vector<vector<int>>&gr, vector<bool>&flag) {
    for (int u: gr[v]) {
        if (not flag[u]) {
            flag[u] = true;
            dfs(u, gr, flag);
        }
    }
}

bool dfs1(int v, vector<vector<int>>&gr, vector<int>&color) {
    for (int u: gr[v]) {
        if (color[u] == -1) {
            color[u] = 1 - color[v];
            if (dfs1(u, gr, color)) {
                return true;
            }
        }else if (color[u] == color[v]){
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> A(n);
    map<pair<int, int>, int> temp;
    for (int i = 0; i < n; i++) {
        cin >> A[i].first >> A[i].second;
        temp[A[i]] = i;
    }
    vector<vector<int>> gr(n);
    vector<bool> flag(n);
    for (int i = 0; i < n; i++) {
        for (int x = 0; x <= r; x++) {
            for (int y = 0; y * y + x * x <= r * r; y++) {
                if (not (x == 0 and y == 0)) {
                    if (temp.find({A[i].first + x, A[i].second + y}) != temp.end()) {
                        gr[i].push_back(temp[{A[i].first + x,  A[i].second + y}]);
                    }
                }
                if (x != 0) {
                    if (temp.find({A[i].first - x, A[i].second + y}) != temp.end()) {
                        gr[i].push_back(temp[{A[i].first - x,  A[i].second + y}]);
                    }
                }
                if (y != 0) {
                    if (temp.find({A[i].first + x, A[i].second - y}) != temp.end()) {
                        gr[i].push_back(temp[{A[i].first + x,  A[i].second - y}]);
                    }
                }
                if (x != 0 and y != 0) {
                    if (temp.find({A[i].first - x, A[i].second - y}) != temp.end()) {
                        gr[i].push_back(temp[{A[i].first - x,  A[i].second - y}]);
                    }
                }
            }
        }
    }
    vector<int> color(n, -1);
    for (int i = 0; i < n; i++) {
        if (flag[i]) {
            dfs(i, gr, flag);
        }
    }
    for (int i = 0; i < n; i++) {
        if (not flag[i] and color[i] == -1) {
            color[i] = 0;
            if (dfs1(i, gr, color)) {
                flag[i] = true;
                dfs(i, gr, flag);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (flag[i]) {
            cout << 1;
        }else {
            cout << 0;
        }
    }
}