#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

void dfs(int v, vector<vector<int>>&gr, vector<bool>&flag) {
    for (int u: gr[v]) {
        if (not flag[u]) {
            flag[u] = true;
            dfs(v, gr, flag);
        }
    }
}

bool dfs1(int v, vector<vector<int>>&gr, vector<int>&color) {
    for (int u: gr[v]) {
        if (color[u] == -1) {
            color[u] = 1 - color[v];
            if (dfs1(u, gr, color)) {
                return true;
            }
        }else if (color[u] == color[v]){
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> A(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i].first >> A[i].second;
    }
    vector<vector<int>> gr(n);
    vector<bool> flag(n);
    if (true) {
        for (int i = 0; i < n; i++) {
            if (gr[i].size() >= 6) {
                flag[i] = true;
            }else{
                for (int j = 0; j < n; j++) {
                    if (i != j) {
                        int x = A[i].first - A[j].first, y = A[i].second - A[j].second;
                        if (x * x + y * y <= r * r) {
                            gr[i].push_back(j);
                            gr[j].push_back(i);
                            if (gr[i].size() >= 6) {
                                flag[i] = true;
                                break;
                            }
                        }
                    }
                }
            }
        }
        vector<int> color(n, -1);
        for (int i = 0; i < n; i++) {
            if (flag[i]) {
                dfs(i, gr, flag);
            }
        }
        for (int i = 0; i < n; i++) {
            if (not flag[i] and color[i] == -1) {
                color[i] = 0;
                if (dfs1(i, gr, color)) {
                    flag[i] = true;
                    dfs(i, gr, flag);
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (flag[i]) {
                cout << 1;
            }else {
                cout << 0;
            }
        }
    }
}
