#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int oo = 1e18;

struct SegmentTree {
	vector <int> t;
	int n;

	SegmentTree(int n) {
		this->n = n;
		t.resize(4 * n);
	}

	void add(int v, int l, int r, int pos, int x) {
		t[v] += x;
		if (l + 1 == r) return;
		int m = (l + r) / 2;
		if (pos < m) {
			add(v * 2 + 1, l, m, pos, x);
		}
		else {
			add(v * 2 + 2, m, r, pos, x);
		}
	}

	void add(int pos, int x) {
		add(0, 0, n, pos, x);
	}

	int get(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return 0;
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) / 2;
		return
			get(v * 2 + 1, l, m, ql, qr) +
			get(v * 2 + 2, m, r, ql, qr);
	}

	int get(int ql, int qr) {
		return get(0, 0, n, ql, qr);
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	vector <vector <int>> a(n, vector <int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	if (n > m) {
		vector <vector <int>> b(m, vector <int>(n));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				b[j][i] = a[i][j];
			}
		}
		a = b;
		swap(n, m);
	}

	int answer = 0;
	SegmentTree dero(n);
	for (int i = 0; i < m; i++) {
		answer += dero.get(a[0][i], +oo);
		dero.add(a[0][i], 1);
	}

	cout << answer;
}