#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int oo = 1e18;

struct SegmentTree {
	vector <int> t;
	int n;

	SegmentTree(int n) {
		this->n = n;
		t.resize(4 * n);
	}

	void add(int v, int l, int r, int pos, int x) {
		t[v] += x;
		if (l + 1 == r) return;
		int m = (l + r) / 2;
		if (pos < m) {
			add(v * 2 + 1, l, m, pos, x);
		}
		else {
			add(v * 2 + 2, m, r, pos, x);
		}
	}

	void add(int pos, int x) {
		add(0, 0, n, pos, x);
	}

	int get(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return 0;
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) / 2;
		return
			get(v * 2 + 1, l, m, ql, qr) +
			get(v * 2 + 2, m, r, ql, qr);
	}

	int get(int ql, int qr) {
		return get(0, 0, n, ql, qr);
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	vector <vector <int>> a(n, vector <int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	/*if (n > m) {
		vector <vector <int>> b(m, vector <int>(n));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				b[j][i] = a[i][j];
			}
		}
		a = b;
		swap(n, m);
	}
*/
	vector <vector <int>> dp(n + 1, vector <int>(m + 1, +oo));
	dp[0][0] = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {

			

			{
				SegmentTree prvdero(n + 10);
				for (int ci = 0; ci < n; ci++) {
					for (int cj = 0; cj < m; cj++) {
						if (ci < i || cj < j) {
							prvdero.add(a[ci][cj], 1);
						}
					}
				}
				int curr = 0;
				for (int ci = i; ci < n; ci++) {
					curr += prvdero.get(a[ci][j], +oo);
					prvdero.add(a[ci][j], 1);
				}	
				dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + curr);
			}
			{
				SegmentTree prvdero(n + 10);
				for (int ci = 0; ci < n; ci++) {
					for (int cj = 0; cj < m; cj++) {
						if (ci < i || cj < j) {
							prvdero.add(a[ci][cj], 1);
						}
					}
				}
				int curr = 0;
				for (int cj = j; cj < m; cj++) {
					curr += prvdero.get(a[i][cj], +oo);
					prvdero.add(a[i][cj], 1);
				}
				dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + curr);
			}
		}
	}

	int answer = +oo;
	for (int i = 0; i <= n; i++) {
		answer = min(answer, dp[i][m]);
	}
	for (int j = 0; j <= m; j++) {
		answer = min(answer, dp[n][j]);
	}
	cout << answer;
}