#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool get_bit(int x, int d) {
	return x >> d & 1;
}

struct Query {
	int k, ti, ind;
};

bool operator<(Query a, Query b) {
	if (a.k == b.k) return a.ti < b.ti;
	return a.k > b.k;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector <vector <int>> ans(n + 1, vector <int>(n, n));
	
	for (int mask = 0; mask < (1 << n); mask++) {
		vector <int> curr;
		curr.push_back(a[0]);
		for (int i = 1; i < n; i++) {
			if (get_bit(mask, i)) {
				curr.back() = max(curr.back(), a[i]);
			}
			else {
				curr.push_back(a[i]);
			}
		}
		ans[curr.size()] = min(ans[curr.size()], curr);
	}

	for (int ind = 0; ind < q; ind++) {
		int k, ti;
		cin >> k >> ti;
		ti--;
		cout << ans[k][ti] << '\n';
	}
}