#include<bits/stdc++.h>

using namespace std;

bool edge(pair<long long, long long> a, pair<long long, long long> b, long long r) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second) <= r*r;
}

long long dist(pair<long long, long long> a, const pair<long long, long long> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}
const int maxn = 1e5 + 5;
vector<int> g[maxn];
int color[maxn];
bool bad[maxn];

bool cdfs(int v, int c = 1) {
    color[v] = c;
    for (int u : g[v]) {
        if (color[u] == c) {
            return false;
        }
        if (color[u] == 0) {
            if (cdfs(u, 3-c) == false)
                return false;
        }
    }
    return true;
}

void bfs(int i) {
    queue<int> q;
    q.push(i);
    while (q.size()) {
        int v = q.front();
        q.pop();
        if (bad[v])
            continue;
        bad[v] = true;
        for (int u : g[v]) {
            if (!bad[u])
                q.push(u);
        }
    }
}

struct Pen {
    long long x;
    long long y;
    long long i;

};

inline bool operator<(Pen a, Pen o) {
    return make_pair(a.x, a.y) < make_pair(o.x, o.y);
}

// void solve(long long n, long long r, vector<pair<long long, long long>> cord) {
//     fill(bad, bad + maxn, false);
//     fill(color, color + maxn, 0);
//     fill(g, g+maxn, vector<int>());
//     set<pair<int, int>, vector<Pen>> coord;
//     for (int i = 0; i < n; i++) {
//         auto [x, y] = cord[i];
//         //coord.insert({x, y, i});
//     }
//     for (auto v : coord) {
//         for (long long x = -r; x <= r; x++) {
//             for (long long y = -r; y <= r; y++) {
//                 if (coord.contains({v.x+x, v.y+y, 0})) {
//                     auto u = *coord.find({v.x +x, v.y+y, 0});
//                     if (v.i != u.i && edge(make_pair(v.x, v.y), make_pair(u.x, u.y), r)) {
//                         g[v.i].push_back(u.i);
//                     }
//                 }
//             }
//         }
//     }
//
//     for (int i = 0; i < n; i++) {
//         if (!bad[i] && color[i] == 0) {
//             if (cdfs(i) == false) {
//                 bfs(i);
//             }
//         }
//     }
//
//     for (int i = 0; i < n; i++) {
//         cout << (bad[i] ? "1" : "0");
//     }
// }

struct Event {
    int x;
    int type;
    int i;
};

void solve4(long long n, long long r, vector<pair<long long, long long>> cord) {
    vector<pair<int, int>> x(n);
    for (int i = 0; i < n; i++) {
        x[i] = {cord[i].first, i};
    }
    sort(x.begin(), x.end());
    int last = 0;
    vector<bool> bad(n);
    for (int i = 0; i < n-2; i++) {
        if (abs(x[i+2].first - x[i].first) <= r) {
            bad[x[i].second] = true;
            bad[x[i+1].second] = true;
            bad[x[i+2].second] = true;
            last = i + 2;
            while (last < n-1 && x[last+1].first - x[last].first <= r) {
                last++;
                bad[x[last].second] = true;
                i = last;
            }
        }
    }
    reverse(x.begin(), x.end());

    for (int i = 0; i < n-2; i++) {
        if (abs(x[i+2].first - x[i].first) <= r) {
            bad[x[i].second] = true;
            bad[x[i+1].second] = true;
            bad[x[i+2].second] = true;
            last = i + 2;
            while (last < n-1 && abs(x[last+1].first - x[last].first) <= r) {
                last++;
                bad[x[last].second] = true;
                i = last;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        cout << (bad[i] ? "1" : "0");
    }
}

void stress() {
    for (int _ = 0; _ < 100000; _++) {
        int n = rand() % 10 + 2;
        int r = rand() % 10 + 1;
        vector<pair<long long, long long>> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = {rand()%100, rand()%100};
        }
        solve4(n, r, a);
        cout << '\n';
    }
}

int main() {
    int t = 1;

#ifdef D
    cin >> t;
    //stress();
#endif
    while (t--) {
        long long n, r;
        cin >> n >> r;
        vector<pair<long long, long long>> a(n);
        for (int i = 0; i < n; i++) {
            long long x, y;
            cin >> x >> y;
            a[i] = {x, y};
        }
        solve4(n, r, a);
        cout << '\n';
    }
}