#include <stdint.h>
#include<bits/stdc++.h>

using namespace std;

bool edge(pair<long long, long long>& a, pair<long long, long long>& b, long long r) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second) <= r*r;
}

long long dist(pair<long long, long long>& a, pair<long long, long long>& b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}
const int maxn = 1e4 + 5;
vector<int> g[maxn];
int color[maxn];
bool bad[maxn];

bool cdfs(int v, int c = 1) {
    color[v] = c;
    for (int u : g[v]) {
        if (color[u] == c) {
            return false;
        }
        if (color[u] == 0) {
            if (cdfs(u, 3-c) == false)
                return false;
        }
    }
    return true;
}

void bfs(int i) {
    queue<int> q;
    q.push(i);
    while (q.size()) {
        int v = q.front();
        q.pop();
        if (bad[v])
            continue;
        bad[v] = true;
        for (int u : g[v]) {
            if (!bad[u])
                q.push(u);
        }
    }
}

void solve() {
    long long n, r;
    cin >> n >> r;

    vector<pair<long long, long long>> coord(n);
    for (int i = 0; i < n; i++) {
        cin >> coord[i].first >> coord[i].second;
    }
    queue<int> cand;
    for (int i = 0; i < n; i++) {
        int close = 0;
        for (int j = i + 1; j < n; j++) {
            if (edge(coord[i], coord[j], r)) {
                if (dist(coord[i], coord[j]) < r*r/4) {
                    close++;
                }
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
        if (close > 1)
            cand.push(i);
    }
    while (cand.size()) {
        bfs(cand.front());
        cand.pop();
    }
    for (int i = 0; i < n; i++) {
        if (!bad[i] && color[i] == 0) {
            if (cdfs(i) == false) {
                bfs(i);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        cout << (bad[i] ? "1" : "0");
    }
}

void stress() {

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    cin >> t;
#endif
    while (t--) {
        solve();
        cout << '\n';
    }
}