#include<bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> sparse;

void build(vector<pair<int, int>>& a) {
    sparse.clear();
    sparse.push_back(a);
    for (int i = 1; (1 << i) < a.size(); i++) {
        sparse.push_back({});
        for (int j = 0; j + (1 << i-1) < sparse[i-1].size(); j++) {
            sparse[i].push_back(min(sparse[i-1][j], sparse[i-1][j + (1<<i-1)]));
        }
    }
}

vector<int> lg;

pair<int, int> get(int l, int r) {
    int s = lg[r-l];
    return min(sparse[s][l], sparse[s][r - (1 << s)]);
}

vector<int> solve(int n, int q, vector<int> a, vector<pair<int, int>> r) {
    vector<int> right(n);
    vector<int> st = {n};
    for (int i = n-1; i > -1; i--) {
        while (st.size() > 1 && a[st.back()] < a[i])
            st.pop_back();
        right[i] = st.back();
        st.push_back(i);
    }

    vector<pair<int, int>> argmin(n);
    for (int i = 0; i < n; i++) {
        argmin[i] = {a[i], i};
    }
    build(argmin);
    lg = vector<int>(n + 1);
    for (int i = 2; i < n + 1; i++)
        lg[i] = lg[i/2] + 1;

    vector<int> suffmax(n+1);
    for (int i = n-1; i > -1; i--) {
        suffmax[i] = max(suffmax[i+1], a[i]);
    }
    vector<int> anss(q);
    for (int _ = 0; _ < q; _++) {
        auto [k, i] = r[_];

        int ans = 0;
        int l = 0;
        for (int it = 1; it <= i; it++) {
            if (it == k-1 && right[l] == n) {
                ans = a[l];
                l = n-1;
                continue;
            }
            if (it == k) {
                ans = suffmax[l];
                break;
            }
            int r = min(right[l], n - (k-it));
            int topmini = get(l+1, r+1).second;
            // if (a[r] < a[topmini]) {
            //     ans = r;
            //     l = r;
            // }
            {
                ans = a[l];
                l = topmini;
            }
        }
        anss[_] = ans;
    }
    return anss;
}

vector<int> solve2(int n, int q, vector<int> a, vector<pair<int, int>> r) {
    vector<int> right(n);
    vector<int> st = {n};
    for (int i = n-1; i > -1; i--) {
        while (st.size() > 1 && a[st.back()] < a[i])
            st.pop_back();
        right[i] = st.back();
        st.push_back(i);
    }

    vector<pair<int, int>> argmin(n);
    for (int i = 0; i < n; i++) {
        argmin[i] = {a[i], i};
    }
    build(argmin);
    lg = vector<int>(n + 1);
    for (int i = 2; i < n + 1; i++)
        lg[i] = lg[i/2] + 1;

    vector<int> suffmax(n+1);
    for (int i = n-1; i > -1; i--) {
        suffmax[i] = max(suffmax[i+1], a[i]);
    }
    vector<int> b = {n, n};
    int prefmax = 0;
    vector<int> anss(q);
    for (int i = 0; i < n-1; i++) {
        prefmax = max(prefmax, a[i]);
        b = min(b, {prefmax, suffmax[i+1]});
    }
    for (int _ = 0; _ < q; _++) {
        auto [k,i] = r[_];
        anss[_] = b[i-1];
    }
    return anss;
}

vector<int> solve4(int n, int q, vector<int> a, vector<pair<int, int>> r) {
    vector<int> right(n);
    vector<int> st = {n};
    for (int i = n-1; i > -1; i--) {
        while (st.size() > 1 && a[st.back()] < a[i])
            st.pop_back();
        right[i] = st.back();
        st.push_back(i);
    }

    vector<pair<int, int>> argmin(n);
    for (int i = 0; i < n; i++) {
        argmin[i] = {a[i], i};
    }
    build(argmin);
    lg = vector<int>(n + 1);
    for (int i = 2; i < n + 1; i++)
        lg[i] = lg[i/2] + 1;

    vector<int> suffmax(n+1);
    for (int i = n-1; i > -1; i--) {
        suffmax[i] = max(suffmax[i+1], a[i]);
    }
    vector<int> anss(q);
    for (int _ = 0; _ < q; _++) {
        auto[k,i] = r[_];
        if (i == k && k % 2 == 1 && k >= 3)
            anss[_] = a.back();
        else if (i == k)
            anss[_] = suffmax[i-1];
        else
            anss[_] = a[i-1];
    }
    return anss;
}

void stress() {
    for (int _ = 0; _ < 100000; _++) {
        int n = rand()%4 + 2;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = (i % 2 == 0 ? i/2+1 : n - i/2);
        }
        int q = rand()%10;
        vector<pair<int, int>> r(q);
        for (int i = 0; i < q; i++) {
            r[i].first = rand()%n +1;
            r[i].second = rand()%r[i].first + 1;
        }

        vector<int> a1 = solve(n, q, a, r);
        vector<int> a2 = solve4(n, q, a, r);
        if (a1 != a2) {
            cout << "TEST " << _ << " FAILED!\n";
            cout << n << ' ' << 2 << '\n';
            for (int i = 0; i < n; i++) {
                cout << a[i] << ' ';
            }
            cout << '\n';
            for (int i = 0; i < q; i++) {
                cout << r[i].first << ' ' << r[i].second << '\n';
            }
            cout << "Expected\n";
            for (int i = 0; i < q; i++) {
                cout << a1[i] << ' ';
            }
            cout << '\n';
            cout << "But get\n";
            for (int i = 0; i < q; i++) {
                cout << a2[i] << ' ';
            }

            exit(0);
        }
    }
    cout <<"ALL PASSED";
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;

#ifdef D
    cin >> t;
    stress();
#endif
    while (t--) {
        int n, q;
        cin >> n >> q;
        vector<int> a(n);
        for (int& i : a)
            cin >> i;
        vector<pair<int, int>> r(q);
        for (int i = 0; i < q; i++) {
            cin >> r[i].first >> r[i].second;
        }
        vector<int> ans = solve4(n, q, a , r);
        for (int i : ans)
            cout << i << '\n';
        cout << '\n';
    }
}