#include <bits/stdc++.h>

using namespace std;

struct dsu {
    int n;
    vector<int> par, sz;
    dsu(int n = 0) : n(n), par(n, -1), sz(n, 1) {}
    int get_par(int v) {
        if (par[v] == -1) return v;
        return par[v] = get_par(par[v]);
    }
    void unite(int v, int u) {
        v = get_par(v), u = get_par(u);
        if (v == u) return;
        if (sz[v] < sz[u]) swap(v, u);
        sz[v] += sz[u];
        par[u] = v;
    }
};

dsu d;

long long dist(pair<int, int> a, pair<int, int> b = {0, 0}) {
    long long dx = a.first - b.first;
    long long dy = a.second - b.second;
    return dx * dx + dy * dy;
}

vector<vector<int>> graph;
vector<int> color, ans;

bool dfs(int v, int col = 1) {
    color[v] = col;
    for (auto to : graph[v]) {
        if (color[to] == color[v]) {
            ans[d.get_par(v)] = 1;
            return true;
        }
        if (color[to] == 0 && dfs(to, 3 - col))
            return true;
    }
    return false;
}

int main() {
    int n;
    long long r;
    cin >> n >> r;
    r *= r;
    vector<pair<int, int>> vec(n);
    for (int i = 0; i < n; i++)
        cin >> vec[i].first >> vec[i].second;
    graph.resize(n);
    color.resize(n);
    d = dsu(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (dist(vec[i], vec[j]) <= r) {
                if (graph[i].size() < 10) graph[i].push_back(j);
                if (graph[j].size() < 10) graph[j].push_back(i);
                d.unite(i, j);
            }
        }
    }
    ans.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (graph[i].size() >= 6)
            ans[d.get_par(i)] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (ans[d.get_par(i)] == -1)
            ans[d.get_par(i)] = 0, dfs(i);
    }
    for (int i = 0; i < n; i++)
        cout << ans[d.get_par(i)];
    cout << '\n';
}