#include <bits/stdc++.h>

using namespace std;

struct dsu {
    int n;
    vector<int> par, sz;
    dsu(int n = 0) : n(n), par(n, -1), sz(n, 1) {}
    int get_par(int v) {
        if (par[v] == -1) return v;
        return par[v] = get_par(par[v]);
    }
    void unite(int v, int u) {
        v = get_par(v), u = get_par(u);
        if (v == u) return;
        if (sz[v] < sz[u]) swap(v, u);
        sz[v] += sz[u];
        par[u] = v;
    }
};

dsu d;

long long dist(pair<int, int> a, pair<int, int> b = {0, 0}) {
    long long dx = a.first - b.first;
    long long dy = a.second - b.second;
    return dx * dx + dy * dy;
}

vector<vector<int>> graph;
vector<int> color, ans;

bool dfs(int v, int col = 1) {
    color[v] = col;
    for (auto to : graph[v]) {
        if (color[to] == color[v]) {
            ans[d.get_par(v)] = 1;
            return true;
        }
        if (color[to] == 0 && dfs(to, 3 - col))
            return true;
    }
    return false;
}

int main() {
    int n;
    long long r, r2;
    cin >> n >> r;
    r2 = r * r;
    vector<pair<int, int>> vec(n);
    for (int i = 0; i < n; i++)
        cin >> vec[i].first >> vec[i].second;
    graph.resize(n);
    color.resize(n);
    map<pair<int, int>, vector<int>> mp;
    mt19937 rnd('pleeease');
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    d = dsu(n);
    const int c = 10;
    for (int att = 1; att <= 5; att++) {
        shuffle(order.begin(), order.end(), rnd);
        vector<pair<int, int>> take;
        for (auto cur : order) {
            int bx = vec[cur].first / r, by = vec[cur].second / r;
            bool flag = true;
            take = {{bx - 1, by - 1}, {bx - 1, by + 1}, {bx + 1, by - 1}, {bx + 1, by + 1}, {bx, by - 1}, {bx, by + 1}, {bx - 1, by}, {bx + 1, by}, {bx, by}};
            for (auto [xx, yy] : take) {
                if (!mp.contains({xx, yy})) continue;
                for (auto elem : mp[{xx, yy}]) {
                    if (elem == cur) continue;
                    if (dist(vec[cur], vec[elem]) <= r2) {
                        d.unite(cur, elem);
                        if (graph[cur].size() < c * att) {
                            graph[cur].push_back(elem);
                            graph[elem].push_back(cur);
                        }
                        if (graph[cur].size() == c * att) {
                            flag = false;
                            break;
                        }
                    }
                }
                if (!flag) break;
            }
            mp[{vec[cur].first / r, vec[cur].second / r}].push_back(cur);
        }
        mp.clear();
    }
    for (int i = 0; i < n; i++) {
        sort(graph[i].begin(), graph[i].end());
        graph[i].erase(unique(graph[i].begin(), graph[i].end()), graph[i].end());
    }
    ans.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (graph[i].size() >= 6)
            ans[d.get_par(i)] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (ans[d.get_par(i)] == -1)
            ans[d.get_par(i)] = 0, dfs(i);
    }
    for (int i = 0; i < n; i++)
        cout << ans[d.get_par(i)];
    cout << '\n';
}