#include <bits/stdc++.h>

using namespace std;

struct dsu {
    int n;
    vector<int> par, sz;
    dsu(int n = 0) : n(n), par(n, -1), sz(n, 1) {}
    int get_par(int v) {
        if (par[v] == -1) return v;
        return par[v] = get_par(par[v]);
    }
    void unite(int v, int u) {
        v = get_par(v), u = get_par(u);
        if (v == u) return;
        if (sz[v] < sz[u]) swap(v, u);
        sz[v] += sz[u];
        par[u] = v;
    }
};

dsu d;

long long dist(pair<int, int> a, pair<int, int> b = {0, 0}) {
    long long dx = a.first - b.first;
    long long dy = a.second - b.second;
    return dx * dx + dy * dy;
}

vector<vector<int>> graph;
vector<int> color, ans;

bool dfs(int v, int col = 1) {
    color[v] = col;
    for (auto to : graph[v]) {
        if (color[to] == color[v]) {
            ans[d.get_par(v)] = 1;
            return true;
        }
        if (color[to] == 0 && dfs(to, 3 - col))
            return true;
    }
    return false;
}

int main() {
    int n;
    long long r, r2;
    cin >> n >> r;
    r2 = r * r;
    vector<pair<int, int>> vec(n);
    for (int i = 0; i < n; i++)
        cin >> vec[i].first >> vec[i].second;
    graph.resize(n);
    color.resize(n);
    map<pair<int, int>, vector<int>> mp;
    for (int i = 0; i < n; i++) {
        mp[{vec[i].first / r, vec[i].second / r}].push_back(i);
    }
    mt19937 rnd(179);
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    shuffle(order.begin(), order.end(), rnd);
    d = dsu(n);
    const int c = 15;
    for (auto cur : order) {
        int bx = vec[cur].first / r, by = vec[cur].second / r;
        bool flag = true;
        for (int xx = bx - 1; xx <= bx + 1 && flag; xx++) {
            for (int yy = by - 1; yy <= by + 1 && flag; yy++) {
                for (auto elem : mp[{xx, yy}]) {
                    if (elem == cur) continue;
                    if (dist(vec[cur], vec[elem]) <= r2) {
                        d.unite(cur, elem);
                        if (graph[cur].size() < c) {
                            graph[cur].push_back(elem);
                            graph[elem].push_back(cur);
                        }
                        if (graph[cur].size() == c) {
                            flag = false;
                            break;
                        }
                    }
                }
            }
        }
    }
    ans.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (graph[i].size() >= 6)
            ans[d.get_par(i)] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (ans[d.get_par(i)] == -1)
            ans[d.get_par(i)] = 0, dfs(i);
    }
    for (int i = 0; i < n; i++)
        cout << ans[d.get_par(i)];
    cout << '\n';
}