#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
struct node {
    ll x, pr, sz;
    node *l, *r;
    node(ll x) : x(x), pr(rnd()), sz(1), l(nullptr), r(nullptr) {}
};
ll gsz(node* root) {
    if (!root) return 0;
    return root->sz;
}
void rec(node* root) {
    if (!root) return;
    root->sz = gsz(root->l) + 1 + gsz(root->r);
}
void split(node* root, node*& l, node*& r, ll x) {
    if (!root) l = r = nullptr;
    else if (root->x < x) split(root->r, root->r, r, x), l = root;
    else split(root->l, l, root->l, x), r = root;
    rec(root);
}
void merge(node*& root, node* l, node* r) {
    if (!l) root = r;
    else if (!r) root = l;
    else if (l -> pr < r -> pr) merge(l->r, l->r, r), root = l;
    else merge(r->l, l, r->l), root = r;
    rec(root);
}
void insert(node*& root, ll x) {
    node *t1 = nullptr, *t2 = nullptr;
    split(root, t1, t2, x);
    node *v = new node(x);
    merge(t1, t1, v);
    merge(root, t1, t2);
}
ll inv(vector<ll>& a, ll l, ll r) {
    if (r - l < 2) return 0;
    ll m = (l + r) / 2;
    ll ans = inv(a, l, m) + inv(a, m, r);
    vector<ll> b;
    ll i = l, j = m;
    while (i < m || j < r) {
        if (i < m && (j == r || a[i] < a[j])) b.push_back(a[i++]), ans += j - m;
        else b.push_back(a[j++]);
    }
    for (ll k = 0; k < r - l; ++k) a[l + k] = b[k];
    return ans;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m)), dp(n + 1, vector<ll>(m + 1, 0)), x(n, vector<ll>(m, 0)), y(n, vector<ll>(m, 0));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) cin >> a[i][j];
    }
    for (ll i = n - 1; i >= 0; --i) {
        node* root = nullptr;
        for (ll j = m - 1; j >= 0; --j) {
            for (ll k = n - 1; k >= i; --k) {
                node *t1 = nullptr, *t2 = nullptr;
                split(root, t1, t2, a[k][j]);
                x[i][j] += gsz(t1);
                merge(root, t1, t2);
                insert(root, a[k][j]);
            }
        }
    }
    for (ll j = m - 1; j >= 0; --j) {
        node *root = nullptr;
        for (ll i = n - 1; i >= 0; --i) {
            vector<ll> b;
            for (ll k = m - 1; k >= j; --k) {
                node *t1 = nullptr, *t2 = nullptr;
                split(root, t1, t2, a[i][k]);
                y[i][j] += gsz(t1);
                merge(root, t1, t2);
                insert(root, a[i][k]);
            }
        }
    }
    for (ll i = n - 1; i >= 0; --i) {
        for (ll j = m - 1; j >= 0; --j) dp[i][j] = min(x[i][j] + dp[i][j + 1], y[i][j] + dp[i + 1][j]);
    }
    cout << dp[0][0];
    cout << endl;
    return 0;
}