#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <ios>

using namespace std;

#define int long long

#define ff first 
#define ss second

vector<vector<int>> g;
vector<int> used; // 0 - no, -1/1 - clr, 2 - cycle
vector<bool> cycle;

void dfs(int v, int c) {
    used[v] = c;
    for (int x: g[v]) {
        if (!used[x])
            dfs(x, -c);
    }
}

void mark(int v) {
    cycle[v] = true;
    for (int x: g[v]) {
        if (!cycle[x])
            mark(x);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n, r; cin >> n >> r;
    g.resize(n);
    used.assign(n, 0);
    cycle.assign(n, false);
    vector<pair<int, int>> cord(n), ve;
    for (auto &x: cord)
        cin >> x.ff >> x.ss;
    for (int i = 0; i < n - 1; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((cord[i].ff - cord[j].ff) * (cord[i].ff - cord[j].ff) + (cord[i].ss - cord[j].ss) * (cord[i].ss - cord[j].ss) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
                ve.emplace_back(i, j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i, 1);
    }
    for (auto &x: ve) {
        if (used[x.ff] == used[x.ss])
            mark(x.ff);
    }
    for (bool x : cycle)
        cout << x;
}