#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <ios>
 
using namespace std;
 
#define ff first 
#define ss second
 
vector<vector<short>> g;
vector<short> used; // 0 - no, -1/1 - clr, 2 - cycle
 
void dfs(int v, int c) {
    used[v] = c;
    for (int x: g[v]) {
        if (!used[x])
            dfs(x, -c);
    }
    for (int x: g[v]) {
        if (used[x] == used[v] || used[x] == 2) 
            c = used[v] = 2;
    }
    for (int x: g[v]) {
        if (used[x] != 2 && c == 2)
            dfs(x, c == 2 ? 2 : -c);
    }
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
     
    int n, r; cin >> n >> r;
    g.resize(n);
    used.assign(n, 0);
    vector<pair<int, int>> cord(n);
    for (auto &x: cord)
        cin >> x.ff >> x.ss;
    for (int i = 0; i < n - 1; i++) {
        for (int j = i + 1; j < n; j++) {
            if ((long long)(cord[i].ff - cord[j].ff) * (cord[i].ff - cord[j].ff) + (long long)(cord[i].ss - cord[j].ss) * (cord[i].ss - cord[j].ss) <= (long long)r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i, 1);
    }
    for (int i = 0; i < n; i++) {
        cout << (used[i] == 2 ? 1 : 0);
    }
}