#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <ios>
#include <map>
  
using namespace std;
  
#define ff first 
#define ss second
  
vector<vector<int>> g;
vector<int> used; // 0 - no, -1/1 - clr, 2 - cycle
  
void dfs(int v, int c) {
    used[v] = c;
    for (int x: g[v]) {
        if (!used[x])
            dfs(x, -c);
    }
    for (int x: g[v]) {
        if (used[x] == used[v] || used[x] == 2) 
            c = used[v] = 2;
    }
    for (int x: g[v]) {
        if (used[x] != 2 && c == 2)
            dfs(x, c == 2 ? 2 : -c);
    }
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
      
    int n, r; cin >> n >> r;
    g.resize(n);
    used.assign(n, 0);
    vector<pair<int, int>> cord(n);
    map<pair<int, int>, int> check;
    for (int i = 0; i < n; i++) {
        cin >> cord[i].ff >> cord[i].ss;
        check[cord[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        for (int x = -r; x <= r; x++) {
            for (int y = -r; y <= r; y++) {
                if (y == 0 && x == 0)
                    continue;
                if ((long long)x * x + (long long)y * y <= (long long)r * r
                    && check[{cord[i].ff + x, cord[i].ss + y}]) {
                        g[i].push_back(check[{cord[i].ff + x,  cord[i].ss + y}] - 1);
                }
            }
        }
    }


    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i, 1);
    }
    for (int i = 0; i < n; i++) 
        cout << (used[i] == 2 ? 1 : 0);
}