#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <ios>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;

#define int long long

vector<int> vec;
int cnt;

void mrg(int l1, int r1, int l2, int r2) {
    vector<int> ans;
    int s1 = l1, s2 = l2;
    while (l1 <= r1 || l2 <= r2) {
        if (l1 <= r1 && (l2 > r2 || vec[l1] < vec[l2])) {
            cnt += l2 - s2;
            ans.push_back(vec[l1++]);
        } else {
            ans.push_back(vec[l2++]);
        }
    }
    for (int i = 0; i < ans.size(); i++)
        vec[s1 + i] = ans[i];
}

void merge_sort(int l, int r) {
    if (r == l)
        return;
    int m = (l + r) / 2;
    merge_sort(l, m);
    merge_sort(m + 1, r);
    mrg(l, m, m + 1, r);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    vector<vector<int>> mtr(n, vector<int> (m));
    for (auto &x: mtr) {
        for (auto &y: x)
            cin >> y;
    }
    int ans = 1e18;
    for (int mask = 0; mask < (1 << (n + m)); mask++) {
        vector<int> v2; 
        swap(v2, vec);
        vec.reserve(n * m);
        int x = 0, y = 0;
        for (int ind = 0; vec.size() < n * m; ind++) {
            if (mask & (1 << ind)) {
                for (int j = y; j < m; j++)
                    vec.push_back(mtr[x][j]);
                x++;
            } else {
                for (int i = x; i < n; i++) 
                    vec.push_back(mtr[i][y]);
                y++;
            }
        }
        cnt = 0;
        merge_sort(0, vec.size() - 1);
        ans = min(ans, cnt);
    }
    cout << ans << '\n';
}