#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <ios>

using namespace std;

vector<int> vec;
int cnt;

void mrg(int l1, int r1, int l2, int r2) {
    vector<int> ans;
    int s1 = l1, s2 = l2;
    while (l1 <= r1 || l2 <= r2) {
        if (l1 <= r1 && (l2 > r2 || vec[l1] < vec[l2])) {
            cnt += l2 - s2;
            ans.push_back(vec[l1++]);
        } else {
            ans.push_back(vec[l2++]);
        }
    }
    for (int i = 0; i < ans.size(); i++)
        vec[s1 + i] = ans[i];
}

void merge_sort(int l, int r) {
    if (r == l)
        return;
    int m = (l + r) / 2;
    merge_sort(l, m);
    merge_sort(m + 1, r);
    mrg(l, m, m + 1, r);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n, m; cin >> n >> m;
    vector<vector<int>> mtr(n, vector<int> (m));
    for (auto &x: mtr) {
        for (auto &y: x)
            cin >> y;
    }
    if (n < m) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                vec.push_back(mtr[i][j]);
            }
        }
    } else {
        for (int j = 0; j < m; j++) {
            for (int i = 0; i < n; i++) {
                vec.push_back(mtr[i][j]);
            }
        }
    }
    merge_sort(0, vec.size() - 1);
    cout << cnt << '\n';
}