#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <ios>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;

#define int long long

vector<int> vec;
int cnt;

void mrg(int l1, int r1, int l2, int r2) {
    vector<int> ans;
    int s1 = l1, s2 = l2;
    while (l1 <= r1 || l2 <= r2) {
        if (l1 <= r1 && (l2 > r2 || vec[l1] < vec[l2])) {
            cnt += l2 - s2;
            ans.push_back(vec[l1++]);
        } else {
            ans.push_back(vec[l2++]);
        }
    }
    for (int i = 0; i < ans.size(); i++)
        vec[s1 + i] = ans[i];
}

void merge_sort(int l, int r) {
    if (r == l)
        return;
    int m = (l + r) / 2;
    merge_sort(l, m);
    merge_sort(m + 1, r);
    mrg(l, m, m + 1, r);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    

    int n, m; cin >> n >> m;
    vector<vector<int>> mtr(n, vector<int> (m));
    for (auto &x: mtr) {
        for (auto &y: x)
            cin >> y;
    }
    vector<bool> mask(n + m, false);
    for (int i = 0; i < n; i++)
        mask[i] = true;
    for (int i = 0; i < n; i++) {
        int a = rand() % n;
        int b = rand() % n;
        swap(mask[a], mask[b]);
    }
    int ans = 1e18;
    long double t = 1;
    int iter = 0;
    for (int cc = 0;; cc++) {
        // cout << (long double)clock() / CLOCKS_PER_SEC << '\n';
        if (cc % 100 == 0 && (long double)clock() / CLOCKS_PER_SEC > 0.9) 
            break;
        int a = rand() % (n + m), b = rand() % (n + m);
        if (mask[a] == mask[b])
            continue;
        swap(mask[a], mask[b]);
        iter++;
        t *= 0.9999;
        vector<int> v2;
        swap(v2, vec);
        vec.reserve(n * m);
        int x = 0, y = 0;
        for (int ind = 0; x != n || y != m; ind++) {
            if (mask[ind]) {
                for (int j = y; j < m; j++)
                    vec.push_back(mtr[x][j]);
                x++;
            } else {
                for (int i = x; i < n; i++) 
                    vec.push_back(mtr[i][y]);
                y++;
            }
        }
        cnt = 0;
        merge_sort(0, vec.size() - 1);
        int new_ans = cnt;
        if (new_ans < ans || (long double)rand() / RAND_MAX < exp(ans - new_ans) * t) {
            ans = new_ans;
        } else {
            swap(mask[a], mask[b]);
        }
    }
    // cout << t << '\n'
    // cout << iter << '\n';
    cout << ans << '\n';
}