#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()
#define REP(x) for(int i = 0 ; i < x ; i ++)

struct duo {
	ll x;
	ll y;
};

long double dist(duo& a,duo& b){
	return pow((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y), 0.5);
}

vector<duo>arr;
vector<vector<ll>> graph;
vector<bool> used;

bool dfs(ll curr,ll dst,ll bgn) {
	bool tot_ans = 0;
	used[curr] = 1;
	for (auto to : graph[curr]) {
		if (to == bgn) {
			if (dst % 2 == 0) {
				return 1;
			}
		}
		if (!used[to]) {
			bool ans = dfs(to,dst+1,bgn);
			tot_ans |= ans;
		}
	}
	return tot_ans;
}


void solve(ll ind,ll n) {
	used.assign(n, 0);
	bool ans = dfs(ind,0,ind);
	cout << ans;
}

int main()
{
	ll n,r,x,y;
	cin >> n >> r;

	
	REP(n) {
		cin >> x >> y;
		arr.push_back({x,y});
	}

	graph.resize(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i != j) {
				if (dist(arr[i], arr[j]) <= r) {
					graph[i].push_back(j);
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		solve(i,n);
	}
}

