#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

#define ll int
#define all(a) a.begin(),a.end()
#define REP(x) for(int i = 0 ; i < x ; i ++)

struct duo {
	ll x;
	ll y;
};

ll dist(duo a,duo b){
	return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

vector<duo>arr;
vector<vector<ll>> graph;
vector<int> used;

bool dfs(ll curr,ll dst,ll bgn) {
	bool tot_ans = 0;
	used[curr] = 1;
	for (auto to : graph[curr]) {
		if (to == bgn) {
			if (dst % 2 == 0) {
				return 1;
			}
			//else { return 0; }
		}
		if (!used[to]) {
			bool ans = dfs(to,dst+1,bgn);
			tot_ans = tot_ans | ans;
		}
	}
	return tot_ans;
}


bool solve(ll ind,ll n) {
	used.assign(n, -1);
	ll curr = ind;
	deque<ll> deq;
	used[curr] = 0;
	deq.push_front(curr);
	while (!deq.empty()) {
		ll fr = deq.front();
		deq.pop_front();
		for (auto& to : graph[fr]) {
			if (used[to] == -1) {
				used[to] = (used[fr] + 1) % 2;
				deq.push_front(to);
			}
			else if (used[to] != (used[fr] + 1) % 2) {
				return 1;
			}
		}
	}
	return 0;
}

int main()
{
	ll n,r,x,y;
	cin >> n >> r;

	
	REP(n) {
		cin >> x >> y;
		arr.push_back({x,y});
	}

	graph.resize(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i != j) {
				if (dist(arr[i], arr[j]) <= r*r) {
					graph[i].push_back(j);
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		cout << solve(i,n);
	}
}

