#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

#define ll long long
#define all(a) a.begin(),a.end()
#define REP(x) for(int i = 0 ; i < x ; i ++)

struct duo {
	ll x;
	ll y;
};

ll dist(duo& a,duo& b){
	return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

vector<duo>arr;
vector<vector<int>> graph;
vector<int> used;

bool solve(int ind,int n) {
	used.assign(n, -1);
	int curr = ind;
	deque<int> deq;
	used[curr] = 0;
	deq.push_front(curr);
	while (!deq.empty()) {
		int fr = deq.front();
		deq.pop_front();
		for (auto& to : graph[fr]) {
			if (used[to] == -1) {
				used[to] = (used[fr] + 1) % 2;
				deq.push_front(to);
			}
			else if (used[to] != (used[fr] + 1) % 2) {
				return 1;
			}
		}
	}
	return 0;
}

int main()
{
	ll n,r,x,y;
	cin >> n >> r;

	
	REP(n) {
		cin >> x >> y;
		arr.push_back({x,y});
	}

	graph.resize(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i != j) {
				if (dist(arr[i], arr[j]) <= r*r) {
					graph[i].push_back(j);
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		cout << solve(i,n);
	}
}

