#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <random>
#include <set>

using namespace std;

mt19937 rnd(0);

#define all(a) (a).begin(), (a).end()
#define int long long

#pragma GCC optimize("Ofast, O3")
#pragma GCC target("avx2")

vector<vector<int>> g;
vector<int> t;
bool f = 0;
vector<int> good(2e5);


void dfs(int v, int c) {
	if (f) return;

	if (t[v] > c - 3) {
		if (t[v] == c) return;
		f = 1;
		good[c]++;
		return;
	}

	t[v] = c;

	for (int u : g[v])
		dfs(u, c ^ 1);

}

struct point {
	int x, y, i;
	point() {}
	bool operator < (point b) {
		return (x * x + y * y) <= (b.x * b.x + b.y * b.y);
	}
};

int dist(point a, point b) {
	int x = a.x - b.x;
	int y = a.y - b.y;
	return x * x + y * y;
}


void solve() {
	int n; cin >> n;
	g.resize(n);

	int r; cin >> r;
	vector<point> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i].x >> p[i].y;
		p[i].i = i;
	}

	sort(all(p));
	set<int> cur;
	for (int i = 0; i < 2000; ++i) cur.insert(rnd() % n);

	for (int i: cur) {
		for (int j = i + 1; j < n; ++j) {
			if (dist(p[i], p[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}

	t.assign(n, -1);

	int c = 1;
	for (int i = 0; i < n; ++i) {
		if (t[i] != -1) continue;
		f = 0;
		c += 5;
		dfs(i, c);
	}

	vector<int> ans(n);
	for (int i = 0; i < n; ++i) {
		if (good[t[i]] || good[t[i] ^ 1]) ans[p[i].i] = 1;
	}
	for (int el : ans) cout << el;
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // DEBUG
	int t = 1;
	while (t--) solve();
}