#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
 
#define pb push_back
#define sz(x) (int)(x).size()

const int MAXS = 2000010;

int T[MAXS], S;

void upd(int pos, int val) {
    for (; pos <= S; pos = pos | (pos + 1)) {
        T[pos] += val;
    }
}

int get(int pos) {
    int ans = 0;
    for (; pos > 0; pos = (pos & (pos + 1)) - 1) ans += T[pos];
    return ans;
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) cin >> a[i][j];
    }
    S = n * m;

    vector<vector<ll>> add_col(n, vector<ll>(m)), add_row(n, vector<ll>(m));
    auto rec_col = [&](int l, int r, auto&&self) -> void {
        if (l > r) return;
        if (l == r) {
            for (int j = m - 1; j >= 0; j--) {
                int cinv = get(a[l][j]);
                add_col[l][j] += cinv;
                upd(a[l][j], 1);
            }
            for (int j = m - 1; j >= 0; j--) {
                upd(a[l][j], -1);
            }
            return;
        }
        int mid = (l + r + 1) / 2;
        for (int j = m - 1; j >= 0; j--) {
            ll cur = 0;
            for (int i = r; i >= mid; i--) {
                cur += get(a[i][j]);
                upd(a[i][j], 1);
                if (i == mid) add_col[i][j] += cur;
            }
            for (int i = mid - 1; i >= l; i--) {
                cur += get(a[i][j]);
                add_col[i][j] += cur;
            }
        }
        for (int j = m - 1; j >= 0; j--) {
            for (int i = r; i >= mid; i--) upd(a[i][j], -1);
        }
        self(mid + 1, r, self); self(l, mid - 1, self);
    };
    auto rec_row = [&](int l, int r, auto&&self) -> void {
        if (l > r) return;
        if (l == r) {
            for (int i = n - 1; i >= 0; i--) {
                int cur = get(a[i][l]);
                add_row[i][l] += cur;
                upd(a[i][l], 1);
            }
            for (int i = n - 1; i >= 0; i--) upd(a[i][l], -1);
            return;
        }
        int mid = (l + r + 1) / 2;
        for (int i = n - 1; i >= 0; i--){
            ll cur = 0;
            for (int j = r; j >= mid; j--) {
                cur += get(a[i][j]);
                upd(a[i][j], 1);
                if (j == mid) add_row[i][j] += cur;
            }
            for (int j = mid - 1; j >= l; j--) {
                cur += get(a[i][j]);
                add_row[i][j] += cur;
            }
        }
        for (int i = n - 1; i >= 0; i--) {
            for (int j = r; j >= mid; j--) upd(a[i][j], -1);
        }
        self(l, mid - 1, self); self(mid + 1, r, self);
    };
    rec_col(0, n - 1, rec_col);
    rec_row(0, m - 1, rec_row);
    vector<vector<ll>> dp(n, vector<ll>(m));
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < m; j++) {
    //         cout << add_col[i][j] << ' ';
    //     }
    //     cout << '\n';
    // }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            dp[i][j] = min(add_col[i][j] + (j + 1 == m ? 0 : dp[i][j + 1]), add_row[i][j] + (i + 1 == n ? 0 : dp[i + 1][j]));
        }
    }

    cout << dp[0][0] << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL 
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else 
        cin.tie(0)->sync_with_stdio(false);
    #endif
    
    while (tt--) {
        solve();
    }

    return 0;
}