//#define __GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
#define ll int64_t
#define int ll
constexpr ll inf = 1e15;


struct segtree {
    vector<pair<ll,ll>> t;
    void Build(ll v, ll tl, ll tr, vector<ll>& a) {
        if (tl == tr) {
            t[v] = {a[tl], tl};
            return;
        }
        ll mid = (tl + tr) / 2;
        Build(v * 2 + 1, tl, mid, a);
        Build(v *2  +2, mid + 1, tr, a);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
    pair<ll,ll> query(ll v, ll tl, ll tr, ll ql, ll qr) {
        if (ql > qr) {
            return {inf, inf};
        }
        if (tl == ql && tr == qr) {
            return t[v];
        }
        ll mid = (tl + tr) / 2;
        return min(query(v * 2 + 1, tl, mid, ql, min(qr, mid)), query(v * 2 + 2, mid + 1, tr, max(ql, mid + 1), qr));
    }
    segtree(vector<ll>& a) {
        t.resize(4 * a.size());
        Build(0,0, a.size() - 1, a);
    }
};

unordered_map<ll, vector<ll>> ans;

void makeans(vector<ll>& a, vector<ll>& fb, ll k, ll n, vector<ll>& pm, segtree& segt, segtree& segp) {
    vector<ll> st;
    st.push_back(0);
    for (int cnt = 1;cnt < k; ++cnt) {
        ll mini = st.back() + 1;
        if (cnt < k - 1) {
            mini = segt.query(0,0, a.size() - 1, st.back() + 1, min(n - k + cnt, fb[st.back()])).second;
        } else {
            mini = segp.query(0,0, a.size() - 1,st.back() + 1, min(n - k + cnt, fb[st.back()])).second;
        }
        /*for (int i = st.back() + 1;i < n && i <= n - k + cnt && i <= fb[st.back()];++i) {
            if (a[i] < a[mini] && cnt < k - 1) {
                mini = i;
            }
            if (cnt == k - 1 && pm[i] < pm[mini]) {
                mini = i;
            }
        }*/
        st.push_back(mini);
    }
    st.push_back(n);
    ans[k] = st;
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0;i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> pm(n);
    for (int i = n - 1;i > -1; --i) {
        if (i + 1 < n) {
            pm[i] = max(pm[i + 1], a[i]);
        } else {
            pm[i] = a[i];
        }
    }
    vector<ll> st;
    vector<ll> fb(n);
    for (int i = n - 1;i > -1;--i) {
        while (st.size() && a[st.back()] < a[i]) {
            st.pop_back();
        }
        if (st.size()) {
            fb[i] = st.back();
        } else {
            fb[i] = n -1;
        }
        st.push_back(i);
    }
    segtree segt(a);
    segtree segp(pm);
    for (int _=0; _ < q; ++_) {
        ll k, i;
        cin >> k >> i;
        if (ans.find(k) == ans.end()) {
            makeans(a, fb, k, n, pm, segt, segp);
        }
        ll maxn = 0;
        if (i < k) {
            maxn = a[ans[k][i - 1]];
        } else {
            maxn = pm[ans[k][i - 1]];
        }
        cout << maxn << '\n';
    }
}