#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
constexpr ll LLINF = 1e18;
constexpr ll INF = 1e9;

#ifdef _DEBUG
#define debug(x) cerr << (#x) << " = " << (x) << '\n';
#else
#define debug(x) ;
#endif

mt19937 rnd(228);

struct Koch {
    ll x;
    ll y;
    Koch(ll x = 0, ll y = 0) : x(x), y(y) {;}
    constexpr ll operator- (const Koch& an) const {
        return (x - an.x) * (x - an.x) + (y - an.y) * (y - an.y);
    }
    constexpr bool operator== (const Koch& an) const {
        return x == an.x && y == an.y;
    }
    constexpr bool operator< (const Koch& an) const {
        if (x != an.x) return x < an.x;
        return y < an.y;
    }
    constexpr Koch operator/ (ll d) const { return {x / d, y / d}; }
};

istream& operator>> (istream& is, Koch& k) { return is >> k.x >> k.y; }
ostream& operator<< (ostream& os, Koch k) { return os << "( " << k.x << ", " << k.y << " )"; }
template<typename T>
ostream& operator<< (ostream& os, vector<T> arr) {
    os << "[ ";
    for (auto i : arr) os << i << ' ';
    return os << ']';
}

map<Koch, vector<ll>> sqs;
constexpr ll CHECK = 10;
vector<Koch> arr;
vector<vector<int>> gr;
vector<ll> fire;
bool were[100100];
bool odd[100100];
bool ans[100100];

bool odd_c(ll v, bool vodd = false) {
    were[v] = true;
    odd[v] = vodd;
    for (auto i : gr[v]) {
        if (!were[i]) if (odd_c(i, !vodd)) return true;
        if (were[i] && odd[i] == vodd) {
            fire.push_back(i);
            return true;
        }
    }
    return false;
}

void pozh(ll v) {
    were[v] = true;
    ans[v] = true;
    for (auto i : gr[v]) if (!ans[i]) pozh(i);
}

constexpr bool cmpx(const ll& a, const ll& b) {
    return arr[a] < arr[b];
}
bool cmpy(const ll a, const ll b) {
    if (arr[a].y != arr[b].y) return arr[a].y < arr[b].y;
    return arr[a].x < arr[b].x;
}
bool cmpxy(const ll a, const ll b) {
    if (arr[a].x + arr[a].y != arr[b].x + arr[b].y) return arr[a].x + arr[a].y < arr[b].x + arr[b].y;
    return arr[a].x < arr[b].x;
}
bool cmpyx(const ll a, const ll b) {
    if (arr[a].x - arr[a].y != arr[b].x - arr[b].y) return arr[a].x + arr[a].y < arr[b].x + arr[b].y;
    return arr[a].x < arr[b].x;
}

void solve() {
    ll qk, md, maxx = 0, maxy = 0, minx = LLINF, miny = LLINF, qe = 0, lils;
    cin >> qk >> md;
    lils = max<ll>(md / sqrtl(2), 1);
    debug(lils);
    if (qk == 2) {
        cout << "00\n";
        return;
    }
    arr.assign(qk, {0, 0});
    for (auto i = arr.begin(); i != arr.end(); ++i) {
        cin >> *i;
        sqs[*i / lils].push_back(i - arr.begin());
        maxx = max(maxx, i->x);
        maxy = max(maxy, i->y);
        minx = min(minx, i->x);
        miny = min(miny, i->y);
    }
    debug(arr);
    if ((maxx - minx) * (maxx - minx) + (maxy - miny) * (maxy - miny) <= md) {
        for (ll i = 0; i < qk; ++i) cout << '1';
        cout << '\n';
        return;
    }
    gr.assign(qk, {});
    for (auto &[i, t] : sqs) {
        //debug(i);
        //debug(t);
        if (t.size() >= 3) {
            for (auto v : t) if (v != t[0]) {
                gr[v].push_back(t[0]);
                gr[t[0]].push_back(v);
            }
            fire.push_back(t[0]);
            vector<ll> ext = t;
            t.clear();
            vector<ll> tocomp;
            sort(ext.begin(), ext.end(), cmpx);
            for (ll ind = 0; ind < min<ll>(ext.size(), CHECK); ++ind) {
                tocomp.push_back(ext[ind]);
                t.push_back(ext[ext.size() - 1 - ind]);
            }
            sort(ext.begin(), ext.end(), cmpxy);
            for (ll ind = 0; ind < min<ll>(ext.size(), CHECK); ++ind) {
                tocomp.push_back(ext[ind]);
                t.push_back(ext[ext.size() - 1 - ind]);
            }
            sort(ext.begin(), ext.end(), cmpy);
            for (ll ind = 0; ind < min<ll>(ext.size(), CHECK); ++ind) {
                tocomp.push_back(ext[ind]);
                t.push_back(ext[ext.size() - 1 - ind]);
            }
            sort(ext.begin(), ext.end(), cmpyx);
            for (ll ind = 0; ind < min<ll>(ext.size(), CHECK); ++ind) {
                tocomp.push_back(ext[ind]);
                t.push_back(ext[ext.size() - 1 - ind]);
                tocomp.push_back(ext[ext.size() - 1 - ind]);
                t.push_back(ext[ind]);
            }
            sort(tocomp.begin(), tocomp.end());
            tocomp.erase(unique(tocomp.begin(), tocomp.end()), tocomp.end());
            sort(t.begin(), t.end());
            t.erase(unique(t.begin(), t.end()), t.end());
            for (Koch an : { Koch(i.x - 1, i.y - 2),
                             Koch(i.x - 1, i.y - 1),
                             Koch(i.x - 2, i.y - 1),
                             Koch(i.x - 2, i.y),
                             Koch(i.x - 1, i.y),
                             Koch(i.x - 2, i.y + 1),
                             Koch(i.x - 1, i.y + 1),
                             Koch(i.x - 1, i.y + 2),
                             Koch(i.x, i.y + 1),
                             Koch(i.x, i.y + 2),
                             Koch(i.x - 2, i.y + 2),
                             Koch(i.x - 2, i.y - 2) }) {
                if (sqs.contains(an)) {
                    for (auto &i1 : sqs[an]) for (auto i2 : tocomp) if (arr[i1] - arr[i2] <= md) {
                        gr[i1].push_back(i2);
                        gr[i2].push_back(i1);
                        break;
                    }
                }
            }
            //set<ll> sx = set<ll>(t.begin(), t.end());
        }
        else {
            if (t.size() == 2) {
                gr[t[0]].push_back(t[1]);
                gr[t[1]].push_back(t[0]);
            }
            for (Koch an : { Koch(i.x - 1, i.y + 2),
                             Koch(i.x - 1, i.y + 1),
                             Koch(i.x - 2, i.y + 1),
                             Koch(i.x - 2, i.y),
                             Koch(i.x - 1, i.y),
                             Koch(i.x - 2, i.y - 1),
                             Koch(i.x - 1, i.y - 1),
                             Koch(i.x - 1, i.y - 2),
                             Koch(i.x, i.y - 1),
                             Koch(i.x, i.y - 2),
                             Koch(i.x - 2, i.y + 2),
                             Koch(i.x - 2, i.y - 2) }) {
                //debug(an);
                if (sqs.contains(an)) {
                    //debug(sqs[an]);
                    for (auto &i1 : sqs[an]) for (auto i2 : t) {
                        debug(i1);
                        debug(i2);
                        debug(arr[i1]);
                        debug(arr[i2]);
                        debug(arr[i1] - arr[i2]);
                        if (arr[i1] - arr[i2] <= md * md) {
                            gr[i1].push_back(i2);
                            gr[i2].push_back(i1);
                            break;
                        }
                    }
                }
            }
        }
    }
    debug(gr);
    for (ll i = 0; i < qk; ++i) for (auto &t : gr[i]) if (arr[i] - arr[t] > md * md) {
        debug(i);
        debug(t);
        debug(arr[i]);
        debug(arr[t]);
        debug(arr[i] - arr[t]);
        debug(md);
        exit(-35);
    }
    //if ((gr[0].size() != 0 || gr[1].size() != 0 || gr[2].size() != 0) && (gr[0].size() != 2 || gr[1].size() != 2 || gr[2].size() != 2)) exit(234);
    for (auto i : fire) if (!ans[i]) pozh(i);
    fire.clear();
    for (ll i = 0; i < qk; ++i) if (!were[i]) odd_c(i);
    for (auto i : fire) if (!ans[i]) pozh(i);
    //if ()

    for (ll i = 0; i < qk; ++i) {
        if (ans[i]) cout << '1';
        else cout << '0';
    }
    return;
    if (qk <= 10000 || md <= 10) {
        if (qk <= 10000) {
            gr.assign(qk, {});
            for (ll i = 0; i < qk; ++i) for (ll t = 0; t < i; ++t) if (arr[i] - arr[t] <= md * md && exp(-qe / 10000000) * INF > rnd() % INF) {
                gr[i].push_back(t);
                gr[t].push_back(i);
                ++qe;
            }
        }
        else {
            ;
        }
        for (ll i = 0; i < qk; ++i) if (!were[i]) odd_c(i);
        for (auto i : fire) if (!ans[i]) pozh(i);
    }
    else {
        ;
    }
    for (ll i = 0; i < qk; ++i) {
        if (ans[i]) cout << '1';
        else cout << '0';
    }
    cout << '\n';
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    ll t = 1;

    //cin >> t;

    for (ll i = 0; i < t; ++i) {
        solve();
    }

    return 0;
}