#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <unordered_map>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<lng>(x->size())

using lng = long long;

lng merge_sort(vector<int>& arr, int l, int r) {
	if (l + 1 == r) {
		return 0;
	}
	int m = (l + r) / 2;
	lng ans = merge_sort(arr, l, m) + merge_sort(arr, m, r);
	vector<int> tmp;
	int i = l, j = m;
	while (i < m && j < r) {
		if (arr[i] < arr[j]) {
			tmp.push_back(arr[i]);
			ans += static_cast<lng>(j - m);
			i++;
		}
		else {
			tmp.push_back(arr[j]);
			j++;
		}
	}
	while (i < m) {
		tmp.push_back(arr[i]);
		ans += static_cast<lng>(j - m);
		i++;
	}
	while (j < r) {
		tmp.push_back(arr[j]);
		j++;
	}
	for (int k = l; k < r; k++) {
		arr[k] = tmp[k - l];
	}
	return ans;
}

void solve() {
	int r, c; cin >> r >> c;
	vector<vector<int>> table(r, vector<int>(c));
	vector<int> rev_r(r * c), rev_c(r * c);
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++) {
			cin >> table[i][j];
			table[i][j]--;
			rev_r[table[i][j]] = i;
			rev_c[table[i][j]] = j;
		}
	}
	if (r == 1) {
		cout << merge_sort(table[0], 0, c);
		return;
	}
	int ans = 0;
	vector<vector<int>> row_cost(r, vector<int>(c + 1, 0));
	vector<vector<int>> column_cost(c, vector<int>(r + 1, 0));
	for (int x = 0; x < r * c; x++) {
		for (int y = 0; y < x; y++) {
			if (rev_c[y] >= rev_c[x] && rev_r[y] >= rev_r[x]) {
				ans++;
			}
			else if (rev_c[y] <= rev_c[x] && rev_r[y] <= rev_r[x]) {
				continue;
			}
			else if (rev_r[y] > rev_r[x] && rev_c[y] < rev_c[x]) {
				row_cost[rev_r[x]][rev_c[y]]++;
			}
			else if (rev_r[y] < rev_r[x] && rev_c[y] > rev_c[x]) {
				column_cost[rev_c[x]][rev_r[y]]++;
			}
		}
	}
	for (int i = 0; i < r; i++) {
		for (int j = c - 1; j >= 0; j--) {
			row_cost[i][j] += row_cost[i][j + 1];
		}
	}
	for (int i = 0; i < c; i++) {
		for (int j = r - 1; j >= 0; j--) {
			column_cost[i][j] += column_cost[i][j + 1];
		}
	}
	vector<vector<int>> dp(r + 1, vector<int>(c + 1, 1e9));
	dp[0][0] = 0;
	for (int i = 0; i <= r; i++) {
		for (int j = 0; j <= c; j++) {
			if (i < r) {
				dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + row_cost[i][j]);
			}
			if (j < c) {
				dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + column_cost[j][i]);
			}
		}
	}
	ans += dp[r][c];
	cout << ans;
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*
2 3
3 4 1
5 6 2
*/

/*
2 3
2 3 4
1 6 5
*/