#include <bits/stdc++.h>
 
using namespace std;
 
using ll = long long;
using ld = long double;
using vll = vector<ll>;
 
 
template<typename T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& el : a) {
        out << el << " ";
    }
    return out;
}
 
template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& el : a) {
        in >> el;
    }
    return in;
}
 
#define all(x) x.begin(), x.end()
 
const ll INF = 1e18;
 
vector<int> good;
// vector<vector<int>> g;
 
struct DSU {
    vll par;
    vll sz;
    int n;
 
    void makeSet(int v) {
        sz[v] = 1;
        par[v] = v;
    }
 
    void init() {
        for (int i = 0; i <= n; ++i) {
            makeSet(i);
        }
    }
 
    ll get(int v) {
        if (par[v] == v) {
            return v;
        }
        return par[v] = get(par[v]);
    }
 
    void unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        if (sz[a] > sz[b]) {
            swap(a, b);
        }
        par[a] = b;
        sz[b] += sz[a];
    }
 
    DSU(int n_) {
        n = n_;
        par.resize(n + 1);
        sz.resize(n + 1);
        init();
    }
};
 
 
ll dst = 0;
vector<int> col;
vector<int> used;
vector<int> vert;
bool dvudol = true;
ll n, r;
vector<pair<ll, ll>> arr;
 
bool ok (int i, int j) {
    return (ll) (arr[i].first - arr[j].first) * (arr[i].first - arr[j].first) + (arr[i].second - arr[j].second) * (arr[i].second - arr[j].second) <= r * r;
};

map<pair<int, int>, int> have;
map<int, pair<int, int>> cord;
 
void dfs(int v, int now) {
    used[v] = true;
    col[v] = now;
    vert.push_back(v);
    if (n <= 10000) {
        for (int to = 0; to < n; ++to) {
            if (to == v || !ok(v, to)) {
                continue;
            }
            if (col[v] != -1 && col[to] != -1 && col[v] == col[to]) {
                dvudol = false;
            }
            if (used[to]) {
                continue;
            }
            dfs(to, now ^ 1);
        }
    } else {
        auto [x, y] = cord[v];
        for (ll dx = -r; dx <= r; ++dx) {
            for (ll dy = -r; dy <= r; ++dy) {
                if (have.find({x + dx, y + dy}) != have.end()) {
                    int to = have[{x + dx, y + dy}];
                    if (to == v || !ok(v, to)) {
                        continue;
                    }
                    if (col[v] != -1 && col[to] != -1 && col[v] == col[to]) {
                        dvudol = false;
                    }
                    if (used[to]) {
                        continue;
                    }
                    dfs(to, now ^ 1);
                }
            }
        }
    }
}

 
void solve() {
    cin >> n >> r;
    // g.resize(n + 1);
    // O(n^2)
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        arr[i] = {x, y};
        have[{x, y}] = i;
        cord[i] = {x, y};
    }
 
    // DSU dsu(n + 1);
 
     
 
    // for (int i = 0; i < n; ++i) {
    //     for (int j = i + 1; j < n; ++j) {
    //         if (!ok(i, j)) {
    //             continue;
    //         }
    //         g[i].push_back(j);
    //         g[j].push_back(i);
    //         // cout << "add: " << i << " " << j << endl;
    //         // if (dsu.get(i) != dsu.get(j)) {
    //         //     dsu.unite(i, j);
    //         // } else {
    //         //     dfs(i);
    //         // }
    //     }
    // }
    col.resize(n, -1);
    used.resize(n, false);
    vll ans(n, 1);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dvudol = true;
            vert.clear();
            dfs(i, 0);
            if (dvudol) {
                for (auto v : vert) {
                    ans[v] = 0;
                }
            }
        }
    }
    for (auto v : ans) {
        cout << v;
    }
    cout << "\n";
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
 
    solve();
 
    return 0;
}