#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(v) (v).begin(), (v).end()
typedef pair<int, int> pii;
const int N = 2e5;
const int mod = 1e9 + 7;

int n, r;
int win[N];
int x[N];
int y[N];

int sqrdist(int i, int j)
{
	int dx = x[i] - x[j];
	int dy = y[i] - y[j];
	return dx*dx + dy*dy;
}
bool can(int i, int j)
{
	return sqrdist(i, j) <= r*r;
}

vector<int> gr[N];

int l = 0;

map<pii, vector<int>> grid;
set<pii> black;

int used[N];

void pushwins()
{
	queue<int> q;
	for (int i = 0; i < n; i++) if (win[i])
	{
	if (black.count(pii(x[i]/l, y[i]/l)))
			continue;
		q.push(i);
	}
	fill_n(used, n, 0);
	while (q.size())
	{
		int i = q.front(); q.pop();
		used[i] = 1;

		for (int dx = -2; dx <= 2; dx++)
			for (int dy = -2; dy <= 2; dy++) if (abs(dx) + abs(dy) != 4)
			{
				pii nc = pii((x[i]/l)+dx, (y[i]/l)+dy);
				if (!black.count(nc))
				{
					for (int j : grid[nc]) if (i != j && can(i, j) && !used[j])
					{
						win[j] = 1;
						q.push(j);
					}
				}
			}
	}
}

int color[N];
void dfs(int v, int p = -1)
{
	if (used[v])
		return;
	if (p == -1)
		color[v] = 0;
	else
		color[v] = 1-color[p];
	used[v] = 1;

	for (int u : gr[v])
		dfs(u, v);
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> r;
	l = r/sqrt(2);
	if (l == 0)
		l = 1;
	for (int i = 0; i < n; i++)
		cin >> x[i] >> y[i];
	for (int i = 0; i < n; i++)
		grid[pii(x[i]/l, y[i]/l)].push_back(i);

	for (auto &[p, val] : grid)
	{
		if (val.size() >= 3)
		{
			black.insert(p);
			for (int i : val)
			{
				win[i] = 1;
			}
		}
	}

	
	/// can get to black
	for (auto &[cord, ps] : grid) if (black.count(cord))
	{
		for (int i : ps)
		{
			for (int dx = -2; dx <= 2; dx++)
				for (int dy = -2; dy <= 2; dy++) if (!(dx==0 && dy==0)) if (abs(dx) + abs(dy) != 4)
				{
					pii nc = pii(cord.first+dx, cord.second+dy);
					if (!grid.count(nc))
						continue;
					if (!black.count(nc))
					{
						for (int j : grid[nc]) if (!win[j] && can(i, j))
							win[j] = 1;
					}
				}
			;
		}
	}

	cerr << "camed to blacks\n";

	pushwins();

	cerr << "pushed\n";

	/// now we have little graph
	for (int i = 0; i < n; i++) if (!win[i])
	{
		gr[i].reserve(75);
		for (int dx = -2; dx <= 2; dx++)
			for (int dy = -2; dy <= 2; dy++) if (abs(dx) + abs(dy) != 4)
			{
				pii nc = pii((x[i]/l) + dx, (y[i]/l) + dy);
				if (!grid.count(nc))
					continue;
				if (!black.count(nc))
				{
					if (!grid.count(nc))
						continue;
					for (int j : grid[nc]) if (can(i, j) && i != j)
					{
						gr[i].push_back(j);
					}
				}
			}
	}
	cerr << "gr\n";


	for (int i = 0; i < n; i++) if (!win[i])
		dfs(i);

	cerr << "dfsed\n";

	for (int i = 0; i < n; i++) if (!win[i])
	{
		for (int j : gr[i])
		{
			if (color[i] == color[j])
				win[i] = win[j] = 1;
		}
	}

	cerr << "winned\n";

	pushwins();


	for (int i = 0; i < n; i++)
		cout << win[i];
	cout << endl;
}

