#include <iostream>
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <csetjmp>
#include <cstdarg>
#include <cstddef>
#include <cstdlib>

#if __cplusplus >= 201103L
#include <cstdint>
#endif

// C++
// #include <bitset>
// #include <complex>
#include <algorithm>
#include <bitset>
#include <functional>
#include <iterator>
#include <limits>
#include <memory>
#include <new>
#include <numeric>
#include <typeinfo>
#include <utility>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <initializer_list>
#include <ratio>
#include <scoped_allocator>
#include <tuple>
#include <typeindex>
#include <type_traits>
#endif

#if __cplusplus >= 201402L
#endif

#if __cplusplus >= 201703L
#include <any>
// #include <execution>
#include <optional>
#include <variant>
#include <string_view>
#endif

#if __cplusplus >= 202002L
#include <bit>
#include <compare>
#include <concepts>
#include <numbers>
#include <ranges>
#include <span>
#include <source_location>
#include <version>
#endif

#if __cplusplus > 202002L
#include <expected>
#include <stdatomic.h>
#if __cpp_impl_coroutine
# include <coroutine>
#endif
#endif

#if _GLIBCXX_HOSTED
// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cwchar>
#include <cwctype>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#endif

// C++
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

#if __cplusplus >= 201402L
#include <shared_mutex>
#endif

#if __cplusplus >= 201703L
#include <any>
#include <charconv>
// #include <execution>
#include <filesystem>
#include <optional>
#include <memory_resource>
#include <variant>
#endif

#if __cplusplus >= 202002L
#include <barrier>
#include <bit>
#include <compare>
#include <concepts>
#include <latch>
#include <numbers>
#include <ranges>
#include <span>
#include <stop_token>
#include <semaphore>
#include <source_location>
#include <syncstream>
#include <version>
#endif

#if __cplusplus > 202002L
#include <expected>
#include <spanstream>
#if __has_include(<stacktrace>)
# include <stacktrace>
#endif
#include <stdatomic.h>
#include <stdfloat>
#endif

#endif // HOSTED
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;

#define all(x) x.begin(),x.end()
#define fi first
#define se second
#define pub push_back
#define pob pop_back
#define for0(i,n) for(ll i = 0; i < (n); i++)

template<typename T1, typename T2>
istream& operator >>(istream& in, pair<T1, T2>& a){
    in >> a.fi >> a.se;
    return in;
}

template<typename T1, typename T2>
ostream& operator <<(ostream& out, pair<T1, T2>& a){
    out << a.fi << " " << a.se;
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T>& a){
    for(T& ai : a) in >> ai;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T>& a){
    for(T& ai : a) out << ai << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<vector<T>>& a){
    for(vector<T>& row : a) {
        for(T& ai : row){
            in >> ai;
        }
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<vector<T>>& a){
    for(vector<T>& row : a) {
        for(T& ai : row){
            out << ai << " ";
        }
        out << endl;
    }
    return out;
}

int n, q;

void solve(){
    cin >> n >> q;
    string s;
    cin >> s;
    vi a(n);
    for0(i,n){
        a[i] = s[i] - '0';
    }

    vi blocks;
    int cur = 1;
    int cnt = 0;
    for(int i = 0; i < n; i++){
        if (a[i] == cur){
            cnt++;
        }else{
            blocks.pub(cnt);
            cur ^= 1;
            cnt = 1;
        }
    }
    blocks.pub(cnt);
    vi ans(n);
    vvi saprs;
    for(int i = (blocks[0] == 0 ? 2 : 0); i < blocks.size()-2;){
        if (blocks[i] == 1 && blocks[i+2] == 1){
            saprs.pub({blocks[i+1],i,i+2});
            i += 4;
        }else{
            i += 2;
        }
        
    }
    int curans = 0;
    for(int i = 0; i < blocks.size(); i += 2){
        if (blocks[i] >= 2) curans += blocks[i];
    }
    sort(all(saprs));
    ans[0] = curans;
    cout << ans[0];
    /*for(vi& sapr : saprs){
        ans[]
        cnt += sapr[0];
    }

    int q;
    cin >> q;


    vvi qs(q);
    for0(i,q){
        int qi;
        cin >> qi;
        qs[qi] = {qi, int(i)};
    }
    cin >> qs;
    sort(all(qs));
    vi ans(q);
    for(vi& qirow : qs){
        int qi = qirow[0];
        int curans;
        ans[qirow[1]] = curans;
    }
    cout << ans << endl;*/
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(42);
    solve();
    return 0;
}
