#include <bits/stdc++.h>
using namespace std;
#define int long long

const int N = 250005;
int tree[N * 4] = {0};
int rt, ct;

void build(int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (rx - lx == 1) {
        tree[x] = 0;
        return;
    }
    int mx = (lx + rx) / 2;
    build(x * 2 + 1, lx, mx);
    build(x * 2 + 2, mx, rx);
    tree[x] = tree[x * 2 + 1] + tree[x * 2 + 2];
}

void update(int v, int i, int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (i < lx or rx <= i) return;
    if (rx - lx == 1) {
        tree[x] += v;
        return;
    }
    int mx = (lx + rx) / 2;
    update(v, i, x * 2 + 1, lx, mx);
    update(v, i, x * 2 + 2, mx, rx);
    tree[x] = tree[x * 2 + 1] + tree[x * 2 + 2];
}

int get(int l, int r, int x = 0, int lx = 0, int rx = rt * ct + 1) {
    if (r <= lx or rx <= l) return 0;
    if (l <= lx and rx <= r) return tree[x];
    int mx = (lx + rx) / 2;
    return get(l, r, x * 2 + 1, lx, mx) + get(l, r, x * 2 + 2, mx, rx);
}

int check(vector<int> &a) {
    // for (int i = 0; i < rt * ct * 4; i++) tree[i] = 0;
    build();
    int ans = 0;
    for (int i = 0; i < a.size(); i++) {
        ans += get(a[i] + 1, rt * ct + 1);
        update(1, a[i]);
    }
    return ans;
}

int dfs(vector<vector<int>> &g, int i, int j, vector<int> &b) {
    int ans = 1e18;
    if (i == rt or j == ct) return check(b);
    for (int k = j; k < ct; k++) {
        b.push_back(g[i][k]);
    }
    ans = min(ans, dfs(g, i + 1, j, b));
    for (int k = j; k < ct; k++) {
        b.pop_back();
    }
    for (int k = i; k < rt; k++) {
        b.push_back(g[k][j]);
    }
    ans = min(ans, dfs(g, i, j + 1, b));
    for (int k = i; k < rt; k++) {
        b.pop_back();
    }

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> rt >> ct;
    if (rt == 1) {
        vector<int> a(ct);
        for (int i = 0; i < ct; i++) cin >> a[i];
        int ans = 0;
        for (int i = 0; i < ct; i++) {
            ans += get(a[i] + 1, N);
            update(1, a[i]);
        }
        cout << ans;
        return 0;
    } else {
        vector<vector<int>>a(rt, vector<int> (ct));
        for (int i = 0; i < rt; i++) {
            for (int j = 0; j < ct; j++)
                cin >> a[i][j];
        }
        vector<int> b;
        cout << dfs(a, 0, 0, b);
    }

    return 0;
}