#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <numeric>
#include <climits>

using namespace std;
using ll = long long;
void solve5() {
	ll n, q;
	cin >> n >> q;
	vector<bool> a(n + 1);
	vector<ll> p(n + 2, 0);
	vector<ll> s(n + 2, 0);
	ll cnth = 0;
	ll id = 1;
	bool lst = 0;
	for (ll i = 1; i <= n; i++)
	{
		char c;
		cin >> c;
		a[i] = (c == '1');
		if (a[i])
			p[i] = p[i - 1] + 1;
		else
			p[i] = 0;
	}
	for (ll i = 1; i <= n; i++)
	{
		while (i + 1 <= n && p[i + 1] > 1) {
			i++;
		}
		if (p[i] > 1) {
			cnth += p[i];
		}
		else {
			a[id] = (p[i] > 0);
			id++;
		}
	}
	for (ll i = n; i >= 1; i--)
	{
		if (a[i])
			s[i] = s[i + 1] + 1;
		else
			s[i] = 0;
	}
	ll ans = 0;
	for (ll i = n; i >= 1; i--)
	{
		if (a[i])
			continue;
		ll cnt = (ll)(p[i - 1] == 1) + ll(s[i + 1] == 1);
		if (p[i - 1] + s[i + 1] > 0)
			ans = max(ans, cnt);

	}
	while (q--) {
		ll k; cin >> k;
		cout << cnth + ans << "\n";
	}
}
struct pt {
	ll x, y;
};

ll dist(pt& a, pt& b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
vector<vector<bool>> d;
vector<bool> used;
vector<ll> ord;
vector<vector<ll>>g;

void dfs(ll v) {
	used[v] = 1;
	ord.push_back(v);
	for (auto u : g[v])
	{
		if (d[v][1])
			d[u][0] = d[v][1];
		if (d[v][0])
			d[u][1] = d[v][0];
		if (!used[u]) {
			dfs(u);
		}
	}
}
void solve6() {
	ll n, r;
	cin >> n >> r;
	vector<pt> a(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> a[i].x >> a[i].y;
	}
	g.resize(n);
	for (ll i = 0; i < n; i++)
	{
		for (ll j = i + 1; j < n; j++)
		{
			if (dist(a[i], a[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	d.resize(n, vector<bool>(2, false));
	used.resize(n, 0);
	ll c = 0;
	vector<bool> ans(n, 0);
	for (ll i = 0; i < n; i++)
	{
		if (!used[i]) {
			d[i][0] = true;
			ord.clear();
			ord.resize(0);
			dfs(i);
			ll f = false;
			for (ll ii = 0; ii < ord.size(); ii++)
			{
				if (d[ord[ii]][0] && d[ord[ii]][1]) {
					f = true;
					break;
				}
			}
			if (f) {
				for (ll ii = 0; ii < ord.size(); ii++)
				{
					ans[ord[ii]] = 1;
				}
			}
		}
	}
	for (ll i = 0; i < n; i++)
	{
		if (ans[i]) {
			cout << 1;
		}
		else
			cout << 0;
	}
}

ll ans;

vector<vector<ll>>a;
vector<ll> cur;
ll r, c;
void f(ll i1, ll j1) {
	if (i1 == r || j1 == c) {
		ll cnt = 0;
		for (ll i = 0; i < r * c; i++)
		{
			for (ll j = i + 1; j < r * c; j++)
			{
				if (cur[i] > cur[j])
					cnt++;
			}
		}
		ans = min(ans, cnt);
		return;
	}
	for (ll i = i1; i < r; i++)
	{
		cur.push_back(a[i][j1]);
	}
	f(i1, j1 + 1);
	for (ll i = i1; i < r; i++)
	{
		cur.pop_back();
	}
	for (ll i = j1; i < c; i++)
	{
		cur.push_back(a[i1][i]);
	}
	f(i1 + 1, j1);
	for (ll i = j1; i < c; i++)
	{
		cur.pop_back();
	}
}

void solve7() {
	cin >> r >> c;
	ans = LLONG_MAX;
	a.resize(r, vector<ll>(c));
	for (ll i = 0; i < r; i++)
	{
		for (ll j = 0; j < c; j++)
		{
			cin >> a[i][j];
		}
	}
	f(0, 0);
	cout << ans;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	solve5();
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
