#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;


struct node {
    int mx, mn, ind_mn;

    node() : mx(0), mn(1e9), ind_mn(-1) {}
    node(int x, int ind_mn) : mx(x), mn(x), ind_mn(ind_mn) {}
};

node operator+(node &a, node &b) {
    node res;
    if (a.mn < b.mn) {
        res.mn = a.mn;
        res.ind_mn = a.ind_mn;
    } else {
        res.mn = b.mn;
        res.ind_mn = b.ind_mn;
    }
    res.mx = max(a.mx, b.mx);
    return res;
}

struct seg_tree {
    int sz;
    vector<int> a;
    vector<node> t;

    seg_tree(vector<int> &arr) {
        sz = (int) arr.size();
        a = arr;
        t.resize(4 * sz);
        build(0, 0, sz);
    }

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = node(a[l], l);
            return;
        }
        int m = (l + r) / 2;
        int l_u = 2 * v + 1, r_u = 2 * v + 2;
        build(l_u, l, m);
        build(r_u, m, r);
        t[v] = t[l_u] + t[r_u];
    }

    node get(int ql, int qr) {
        return get(0, 0, sz, ql, qr);
    }
    node get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return node();
        if (ql <= l && r <= qr) return t[v];
        int m = (l + r) / 2;
        int l_u = 2 * v + 1, r_u = 2 * v + 2;
        node res_l = get(l_u, l, m, ql, qr);
        node res_r = get(r_u, m, r, ql, qr);
        return (res_l + res_r);
    }
};



signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);


    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto &i : a) cin >> i;


    seg_tree st(a);
    for (int _ = 0; _ < q; _++) {
        int k, ind;
        cin >> k >> ind;
        ind--;
        if (ind == k - 1) {
            cout << a.back() << "\n";
        } else {
            cout << a[ind] << "\n";
        }
    }
}
