#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e5 + 1;

ll dist(pair<ll, ll>a, pair<ll, ll>b) {
	return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}


vector<vector<int>>g;
int color[SZ];
bool good[SZ];
vector<int>used;
bool dfs_color(int v, int col) {
	color[v] = col;
	bool res = 0;
	used.emplace_back(v);
	for (int u : g[v]) {
		if (color[u] == col) {
			res = 1; continue;
		}
		if (color[u] == 1 - col) continue;
		if (dfs_color(u, 1 - col)) {
			res = 1;
		}
	}
	return res;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n; ll r;
	cin >> n >> r;
	vector<pair<ll, ll>>a(n);
	map<ll, vector<pair<ll, ll>>>Xy;
	for (int i = 0; i < n; ++i) {
		ll x, y;
		cin >> x >> y;
		a[i] = { x, y };
		Xy[x].push_back({ y, i });
	}
	for (auto& [x, b] : Xy) {
		sort(b.begin(), b.end());
	}
	g.resize(n);
	for (int fst = 0; fst < n; ++fst) {
		auto [x, y] = a[fst];
		for (int x1 = x - r; x1 <= x + r; ++x1) {
			if (Xy.find(x1) == Xy.end()) continue;
			int l = lower_bound(Xy[x1].begin(), Xy[x1].end(), make_pair(y - r, 1ll * (-1))) - Xy[x1].begin();
			for (int j = l; j < Xy[x1].size() && Xy[x1][j].first <= y + r; ++j) {
				int scd = Xy[x1][j].second;
				if (fst == scd) continue;
				if (dist(a[fst], a[scd]) <= r * r) {
					g[fst].push_back(scd);
				}
			}
		}
	}


	for (int i = 0; i < n; ++i) color[i] = -1;
	for (int i = 0; i < n; ++i) {
		if (color[i] == -1) {
			used.clear();
			if (dfs_color(i, 1)) {
				for (auto x : used) {
					good[x] = 1;
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << good[i];
	}
	
}
