#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;

struct Point {
	ll x, y;
	Point(ll x, ll y) :x(x), y(y) {}
	Point() {
		x = 0; y = 0;
	}
	ll dist(Point oth) {
		return (x - oth.x) * (x - oth.x) + (y - oth.y) * (y - oth.y);
	}

	bool operator<(Point oth) {
		return x < oth.x || x == oth.x && y < oth.y;
	}
};

vector<vector<int>>g;
vector<int>color;
vector<int>used;
bool dfs_color(int v, int col) {
	color[v] = col;
	bool res = 0;
	used.push_back(v);
	for (int u : g[v]) {
		if (color[u] == col) {
			res = 1; continue;
		}
		if (color[u] == 1 - col) continue;
		if (dfs_color(u, 1 - col)) {
			res = 1;
		}
	}
	return res;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n; ll r;
	cin >> n >> r;
	vector<Point>a(n);
	for (int i = 0; i < n; ++i) {
		ll x, y;
		cin >> x >> y;
		a[i] = Point(x, y);
	}
	
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (a[i].dist(a[j]) <= r * r) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	color.resize(n, -1);
	vector<int>good(n, 0);
	for (int i = 0; i < n; ++i) {
		if (color[i] == -1) {
			used.clear();
			if (dfs_color(i, 1)) {
				for (auto x : used) {
					good[x] = 1;
				}
			}
		}
	}
	for (auto x : good) {
		cout << x;
	}

}
