#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e4;

inline ll dist(pair<ll, ll>a, pair<ll, ll>b){
	return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

vector<vector<int>>g;
int color[SZ];
bool good[SZ];
vector<int>used;
bool dfs_color(int v, int col) {
	color[v] = col;
	bool res = 0;
	used.emplace_back(v);
	for (int u : g[v]) {
		if (color[u] == col) {
			res = 1; continue;
		}
		if (color[u] == 1 - col) continue;
		if (dfs_color(u, 1 - col)) {
			res = 1;
		}
	}
	return res;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n; ll r;
	cin >> n >> r;
	vector<pair<ll, ll>>a(n);
	for (int i = 0; i < n; ++i) {
		ll x, y;
		cin >> x >> y;
		a[i] = { x, y };
	}
	
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (dist(a[i], a[j]) <= r * r) {
				g[i].emplace_back(j);
				g[j].emplace_back(i);
			}
		}
	}
	for (int i = 0; i < n; ++i) color[i] = -1;
	for (int i = 0; i < n; ++i) {
		if (color[i] == -1) {
			used.clear();
			if (dfs_color(i, 1)) {
				for (auto x : used) {
					good[x] = 1;
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << good[i];
	}

}
