#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e4;

inline ll dist(pair<ll, ll>a, pair<ll, ll>b){
	return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

int color[SZ];
bool good[SZ];
vector<int>used;
vector<pair<pair<ll, ll>, int>>a;
int n; ll r;
bool dfs_color(int v, int col) {
	color[v] = col;
	bool res = 0;
	used.emplace_back(a[v].second);
	for (int u = 0; u < n; ++u) {
		if (u == v || dist(a[v].first, a[u].first) > r * r) continue;
		if (color[u] == col) {
			res = 1; continue;
		}
		if (color[u] == 1 - col) continue;
		if (dfs_color(u, 1 - col)) {
			res = 1;
		}
	}
	return res;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> r;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		ll x, y;
		cin >> x >> y;
		a[i].first = { x, y };
		a[i].second = i;
	}
	sort(a.begin(), a.end());
	vector<pair<int, int>>seg;
	for (int i = 0; i < n; ++i) {
		int L = i, R = n;
		while (R - L > 1) {
			int mid = (L + R) / 2;
			if (a[mid].first.first - a[i].first.first > r) R = mid;
			else L = mid;
		}
		if (L - i >= 2) {
			seg.push_back({ i, L });
		}
	}
	vector<pair<int, int>>ev;
	for (auto [x, y] : seg) {
		ev.push_back({ x, 1 });
		ev.push_back({ y + 1, -1 });
	}
	sort(ev.begin(), ev.end());
	int cur = 0;
	int ind = 0;
	for (int i = 0; i < n; ++i) {
		while (ind < ev.size() && ev[ind].first == i) {
			cur += ev[ind].second;
			++ind;
		}
		if (cur)good[a[i].second] = 1;
	}
	/*for (int i = 0; i < n; ++i) color[i] = -1;
	for (int i = 0; i < n; ++i) {
		if (color[i] == -1) {
			used.clear();
			if (dfs_color(i, 1)) {
				for (auto x : used) {
					good[x] = 1;
				}
			}
		}
	}
	*/
	for (int i = 0; i < n; ++i) {
		cout << good[i];
	}

}
