#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e5 + 1;
constexpr ll LINF = 1e18 + 7;

void add(int i, int x, vector<int>&fenv) {
	for (; i < fenv.size(); i += (i & (-i))) {
		fenv[i] += x;
	}
}

int getsum(int i, vector<int>&fenv){
	ll res = 0;
	for (; i > 0; i -= (i & (-i))) {
		res += fenv[i];
	}
	return res;
}


int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>>a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}
	if (r > c) {
		vector<vector<int>>b(c, vector<int>(r));
		for (int i = 0; i < r; ++i) {
			for (int j = 0; j < c; ++j) {
				b[j][i] = a[i][j];
			}
		}
		a = b;
		swap(r, c);
	}
	vector<vector<pair<ll, vector<vector<int>>>>>dp(r + 1, vector<pair<ll, vector<vector<int>>>>(c + 1, { LINF, {vector<int>(r * c + 1, 0)} }));
	dp[0][0] = { 0, {vector<int>(r * c + 1, 0)} };
	
	for (int i = 1; i <= r; ++i) {
		auto cnt = dp[i - 1][0].first;
		for (auto fenv : dp[i - 1][0].second) {
			for (int j = 0; j < c; ++j) {
				cnt += -getsum(r * c, fenv) + getsum(a[i - 1][j], fenv);
				add(a[i - 1][j], -1, fenv);
			}
			if (dp[i][0].first > cnt) {
				dp[i][0] = { cnt, {fenv} };
			}
			else if (dp[i][0].first == cnt) {
				dp[i][0].second.push_back(fenv);
			}
		}
	}
	for (int j = 1; j <= c; ++j) {
		auto cnt = dp[0][j - 1].first;
		for (auto fenv : dp[0][j - 1].second) {
			for (int i = 0; i < r; ++i) {
				cnt += -getsum(r * c, fenv) + getsum(a[i][j - 1], fenv);
				add(a[i][j - 1], -1, fenv);
			}
			if (dp[0][j].first > cnt) {
				dp[0][j] = { cnt, {fenv} };
			}
			else if (dp[0][j].first == cnt) {
				dp[0][j].second.push_back(fenv);
			}
		}
	}
	for (int row = 1; row <= r; ++row) {
		for (int col = 1; col <= c; ++col) {
			for (auto fenv : dp[row][col - 1].second) {
				auto cnt = dp[row][col - 1].first;
				for (int i = row - 1; i < r; ++i) {
					cnt += -getsum(r * c, fenv) + getsum(a[i][col - 1], fenv);
					add(a[i][col - 1], -1, fenv);
				}
				if (dp[row][col].first > cnt) {
					dp[row][col] = { cnt, {fenv} };
				}
				else if (dp[row][col].first == cnt) {
					dp[row][col].second.push_back(fenv);
				}
			}
			for (auto fenv1 : dp[row - 1][col].second) {
				auto cnt1 = dp[row - 1][col].first;
				for (int j = col; j < c; ++j) {
					cnt1 += -getsum(r * c, fenv1) + getsum(a[row - 1][j], fenv1);
					add(a[row - 1][j], -1, fenv1);
				}
				if (dp[row][col].first > cnt1) {
					dp[row][col] = { cnt1, {fenv1} };
				}
				else if (dp[row][col].first == cnt1) {
					dp[row][col].second.push_back(fenv1);
				}
			}
		}
	}
	ll mn = LINF;
	for (int i = 0; i < c; ++i) {
		mn = min(dp[r][i].first, mn);
	}
	for (int i = 0; i < r; ++i) {
		mn = min(dp[i][c].first, mn);
	}
	cout << mn << "\n";
}
