#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e4;

vector<int>fenv;

void add(int i, int x) {
	for (; i < fenv.size(); i += (i & (-i))) {
		fenv[i] += x;
	}
}

ll getsum(int i) {
	ll res = 0;
	for (; i > 0; i -= (i & (-i))) {
		res += fenv[i];
	}
	return res;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>>a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) cin >> a[i][j];
	}
	fenv.assign(r * c + 1, 0);
	int cur = 0;
	for (int j = c - 1; j >= 0; --j) {
		cur += getsum(a[0][j]);
		add(a[0][j], 1);
	}
	cout << cur << "\n";
}
