#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e5 + 1;

vector <int>fenv;
void add(int i, int x) {
	for (; i < fenv.size(); i += (i & (-i))) {
		fenv[i] += x;
	}
}

int getsum(int i){
	ll res = 0;
	for (; i > 0; i -= (i & (-i))) {
		res += fenv[i];
	}
	return res;
}


int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>>a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}
	if (r > c) {
		vector<vector<int>>b(c, vector<int>(r));
		for (int i = 0; i < r; ++i) {
			for (int j = 0; j < c; ++j) {
				b[j][i] = a[i][j];
			}
		}
		a = b;
		swap(r, c);
	}
	vector<int>b;
	int curi = 0, curj = 0;
	while (b.size() < r * c) {
		if (curi == r - 1) {
			for (int i = curj; i < c; ++i) {
				b.push_back(a[curi][i]);
			}
			++curi;
			continue;
		}
		if (curj == c - 1) {
			for (int i = curi; i < r; ++i) {
				b.push_back(a[i][curj]);
			}
			++curj;
			continue;
		}
		if (curj == c - 1 || a[curi][curj + 1] > a[curi + 1][curj]) {
			for (int i = curi; i < r; ++i) {
				b.push_back(a[i][curj]);
			}
			++curj;
		}
		else {
			for (int i = curj; i < c; ++i) {
				b.push_back(a[curi][i]);
			}
			++curi;
		}
	}
	fenv.assign(r * c + 1, 0);
	ll cur = 0;
	for (int i = b.size() - 1; i >= 0; --i) {
		cur += getsum(b[i]);
		add(b[i], 1);
	}
	cout << cur << "\n";
}
