#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
constexpr int SZ = 1e5 + 1;
constexpr ll LINF = 1e18 + 7;

void add(int i, int x, vector<int>&fenv) {
	for (; i < fenv.size(); i += (i & (-i))) {
		fenv[i] += x;
	}
}

int getsum(int i, vector<int>&fenv){
	ll res = 0;
	for (; i > 0; i -= (i & (-i))) {
		res += fenv[i];
	}
	return res;
}


int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>>a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}
	if (r > c) {
		vector<vector<int>>b(c, vector<int>(r));
		for (int i = 0; i < r; ++i) {
			for (int j = 0; j < c; ++j) {
				b[j][i] = a[i][j];
			}
		}
		a = b;
		swap(r, c);
	}
	vector<vector<pair<ll, vector<int>>>>dp(r + 1, vector<pair<ll, vector<int>>>(c + 1, { LINF, vector<int>(r * c + 1, 0) }));
	dp[0][0] = { 0, vector<int>(r * c + 1, 0) };
	
	for (int i = 1; i <= r; ++i) {
		auto [cnt, fenv] = dp[i - 1][0];
		for (int j = 0; j < c; ++j) {
			cnt += -getsum(r * c, fenv) + getsum(a[i - 1][j], fenv);
			add(a[i- 1][j], -1, fenv);
		}
		dp[i][0] = { cnt, fenv };
	}
	for (int j = 1; j <= c; ++j) {
		auto [cnt, fenv] = dp[0][j - 1];
		for (int i = 0; i < r; ++i) {
			cnt += - getsum(r * c, fenv) + getsum(a[i][j - 1], fenv);
			add(a[i][j - 1], -1, fenv);
		}
		dp[0][j] = { cnt, fenv };
	}
	for (int row = 1; row <= r; ++row) {
		for (int col = 1; col <= c; ++col) {
			auto [cnt, fenv] = dp[row][col - 1];
			for (int i = row - 1; i < r; ++i) {
				cnt += -getsum(r * c, fenv) + getsum(a[i][col - 1], fenv);
				add(a[i][col - 1], -1, fenv);
			}
			dp[row][col] = min(dp[row][col], { cnt, fenv });

			auto [cnt1, fenv1] = dp[row - 1][col];
			for (int j = col; j < c; ++j) {
				cnt1 += -getsum(r * c, fenv1) + getsum(a[row - 1][j], fenv1);
				add(a[row - 1][j], -1, fenv1);
			}
			dp[row][col] = min(dp[row][col], { cnt1, fenv1 });
		}
	}
	ll mn = LINF;
	for (int i = 0; i < c; ++i) {
		mn = min(dp[r][i].first, mn);
	}
	for (int i = 0; i < r; ++i) {
		mn = min(dp[i][c].first, mn);
	}
	cout << mn << "\n";
}
