#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using dd = double;

struct point {
    ll x, y;
};

int n, r;
vector <vector <int>> g;
vector <int> dist, ans;
set <int> in_s;

dd get_dist(point a, point b) {
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

int att = 0;

void bfs1(int s) {
    if (dist[s] != 2e9) {
        return;
    }
    queue <int> q;
    q.push(s);

    dist[s] = 0;

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto u : g[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }

            if ((dist[v] + dist[u]) % 2 == 0) {
                in_s.insert(u);
                in_s.insert(v);
            }
        }
    }
}

void bfs2() {
    dist.assign(n, 2e9);
    queue <int> q;

    for (auto v : in_s) {
        q.push(v);
        dist[v] = 0;
    }

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto u : g[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (dist[i] < 2e9) {
            ans[i] = 1;
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> r;
    g.resize(n);
    dist.assign(n, 2e9);
    ans.resize(n);
    vector <point> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (get_dist(a[i], a[j]) <= r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for (int v = 0; v < n; v++) {
        bfs1(v);
    }
    bfs2();

    for (auto i : ans) {
        cout << i;
    }

    cout << '\n';
}