#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define file_in freopen("input.txt", "r", stdin);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ff first
#define sc second
#define pb push_back
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;
using ordered_set = tree<int, null_type, greater<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto el : a) out << el << " "; return out; }

struct fen_tree {
    int n;
    vector<int> t;
    fen_tree(int _n) {
        n = _n;
        t.resize(n + 1);
    }

    void insert(int x) {
        if (x < 0)
            x += n + 1;
        for (; x <= n; x += x & -x)
            t[x] += 1;
    }

    void erase(int x) {
        if (x < 0)
            x += n + 1;
        for (; x <= n; x += x & -x)
            t[x] -= 1;
    }

    int order_of_key(int x) {
        if (x < 0)
            x += n + 1;
        int res = 0;
        for (; x > 0; x -= x & -x)
            res += t[x];
        return res;
    }
};

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));

    for (auto &el : a) for (auto &x : el) cin >> x;

    fen_tree prec(n * m + 5);

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ans += prec.order_of_key(-a[i][j]);
            prec.insert(-a[i][j]);
        }
    }

    int cur = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            prec.erase(-a[i][j]);
        }
    }

    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            cur += prec.order_of_key(-a[i][j]);
            prec.insert(-a[i][j]);
        }
    }

    ans = min(ans, cur);
    cout << ans << '\n';

    return 0;
}