#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x)
#endif
#define file_in freopen("input.txt", "r", stdin);
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ff first
#define sc second
#define pb push_back
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;
using ordered_set = tree<int, null_type, greater<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto el : a) out << el << " "; return out; }

struct sparse_table {
    int n;
    vector<vector<int>> t;
    vector<int> a;

    sparse_table(int _n, vector<int> &_a) {
        n = _n;
        a = _a;
        t.resize(__lg(n) + 1, vector<int>(n));
        iota(all(t[0]), 0);
        for (int k = 1; k < __lg(n) + 1; ++k) {
            for (int i = 0; i < n; ++i) {
                if (i + (1 << k) > n) break;
                t[k][i] = t[k - 1][i + (1 << (k - 1))];
                if (a[t[k - 1][i]] < a[t[k - 1][i + (1 << (k - 1))]])
                    t[k][i] = t[k - 1][i];
            }
        }
    }

    int get(int l, int r) {
        int k = __lg(r - l);
        if (a[t[k][l]] < a[t[k][r - (1 << k)]])
            return t[k][l];
        return t[k][r - (1 << k)];
    }
};

const int logn = 19;

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (auto &el : a) cin >> el;

    vector<int> mxsf(n);
    mxsf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i)
        mxsf[i] = max(mxsf[i + 1], a[i]);

    vector<int> right(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] < a[i]) {
            right[st.back()] = i;
            st.pop_back();
        }
        st.pb(i);
    }

    sparse_table spt(n, a);

    vector<vector<int>> binup(logn, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        int r = right[i];
        if (r != n) ++r;
        binup[0][i] = spt.get(i + 1, r);
    }
    binup[0][n - 1] = n - 1;
    for (int k = 1; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            binup[k][i] = binup[k - 1][binup[k - 1][i]];
        }
    }

    for (int _i = 0; _i < q; ++_i) {
        int k, i;
        cin >> k >> i;
        --i;

        int j = 0;
        int ind = 0;
        while (ind < i - 1) {
            debug(j)
            debug(ind)
            if (n - j == k - ind) {
                j += i - ind;
                ind = i;
                break;
            }
            for (int num = logn - 1; num >= 0; --num) {
                if (ind + (1 << num) <= i - 1 && n - binup[num][j] >= k - ind - (1 << num)) {
                    ind += (1 << num);
                    j = binup[num][j];
                }
            }
            if (ind != i - 1) {
                int r = right[j];
                if (r != n) ++r;
                r = min(r, n - k + ind + 2);
                int mn = spt.get(j + 1, r);
                j = mn;
                ++ind;
            }
        }

        for (; ind < i; ++ind) {
            // debug(j)
            // debug(ind)
            if (n - j == k - ind) {
                j += i - ind;
                break;
            }

            if (ind == k - 2) {
                j = right[j];
                if (j == n) --j;
            } else {
                int r = right[j];
                if (r != n) ++r;
                r = min(r, n - k + ind + 2);
                int mn = spt.get(j + 1, r);
                j = mn;
            }
        }
        cout << (i == k - 1 ? mxsf[j] : a[j]) << '\n';
    }

    return 0;
}
