#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<vector<int>> gr;
vector<int> cols;
vector<bool> fl;

long long dist(pair<long long, long long> a, pair<long long, long long> b) {
    auto [x1, y1] = a;
    auto [x2, y2] = b;
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

void dfs(int v, int col) {
    cols[v] = col;
    for (auto u : gr[v]) {
        if (cols[u] == -1) {
            dfs(u, col ^ 1);
        }
        if (cols[u] == col) {
            fl[v] = true;
        }
    }
}

void dfs2(int v) {
    fl[v] = true;
    for (auto u : gr[v]) {
        if (!fl[u]) {
            dfs2(u);
        }
    }
}

int main()
{
    long long n, r;
    cin >> n >> r;
    vector<pair<long long, long long>> v(n);
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        v[i] = {x, y};
    }
    cols.resize(n, -1);
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            if (dist(v[i], v[j]) <= r * r) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
    fl.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (cols[i] == -1) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (fl[i]) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << fl[i];
    }


    return 0;
}