#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> cols;
vector<bool> fl;

bool dist(pair<long long, long long> a, pair<long long, long long> b, long long r) {
    auto [x1, y1] = a;
    auto [x2, y2] = b;
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r;
}

vector<pair<long long, long long>> vc;
long long r;

void dfs(int v, int col) {
    cols[v] = col;
    for (int u = 0; u < vc.size(); u++) {
        if (u == v || !dist(vc[u], vc[v], r)) {
            continue;
        }
        if (cols[u] == -1) {
            dfs(u, col ^ 1);
        }
        if (cols[u] == col) {
            fl[v] = true;
        }
    }
}

void dfs2(int v) {
    fl[v] = true;
    for (int u = 0; u < vc.size(); u++) {
        if (u == v || !dist(vc[u], vc[v], r)) {
            continue;
        }
        if (!fl[u]) {
            dfs2(u);
        }
    }
}

int main()
{
    long long n;
    cin >> n >> r;
    vc.resize(n);
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        vc[i] = {x, y};
    }
    cols.resize(n, -1);
    fl.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (cols[i] == -1) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (fl[i]) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << fl[i];
    }


    return 0;
}