#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
 
using namespace std;
 
vector<int> cols;
vector<bool> fl;
 
bool dist(pair<long long, long long> a, pair<long long, long long> b, long long r) {
    auto [x1, y1] = a;
    auto [x2, y2] = b;
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r;
}
 
vector<pair<long long, long long>> vc;
long long r;
vector<pair<int, int>> dxy;
unordered_map<long long, int> mp;

long long hs(long long a, long long b) {
    return a * 1e9 + b;
}
 
void dfs(int v, int col) {
    cols[v] = col;
    auto [x, y] = vc[v];
    for (auto [dx, dy] : dxy) {
        int x2 = x + dx, y2 = y + dy;
        if (mp.find(hs(x2, y2)) != mp.end()) {
            int u = mp[hs(x2, y2)];
            if (cols[u] == -1) {
                dfs(u, col ^ 1);
            }
            if (cols[u] == col) {
                fl[v] = true;
            }
        }
    }
}



 
void dfs2(int v) {
    fl[v] = true;
    auto [x, y] = vc[v];
    for (auto [dx, dy] : dxy) {
        int x2 = x + dx, y2 = y + dy;
        if (mp.find(hs(x2, y2)) != mp.end()) {
            int u = mp[hs(x2, y2)];
            if (!fl[u]) {
                dfs2(u);
            }
        }
    }
}
 
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    long long n;
    cin >> n >> r;
    vc.resize(n);
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        vc[i] = {x, y};
        mp[hs(x, y)] = i;
    }

    for (int i = -r; i <= r; i++) {
        for (int j = -r; j <= r; j++) {
            if (i == 0 && j == 0) {
                continue;
            }
            if (i * i + j * j <= r * r) {
                dxy.push_back({i, j});
            }            
        }
    }

    cols.resize(n, -1);
    fl.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (cols[i] == -1) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (fl[i]) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << fl[i];
    }
 
    return 0;
}