#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
#include <cmath>
   
using namespace std;

map<pair<int, int>, vector<int>> mp;
vector<pair<int, int>> v;

vector<vector<int>> gr;
vector<int> cols;
vector<bool> fl;

bool dist(pair<long long, long long> a, pair<long long, long long> b, long long r) {
    auto [x1, y1] = a;
    auto [x2, y2] = b;
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r;
}

void dfs(int v, int col) {
    cols[v] = col;
    for (auto u : gr[v]) {
        if (cols[u] == -1) {
            dfs(u, col ^ 1);
        }
        if (cols[u] == col) {
            fl[v] = true;
        }
    }
}
 
void dfs2(int v) {
    fl[v] = true;
    for (auto u : gr[v]) {
        if (!fl[u]) {
            dfs2(u);
        }
    }
}

int main()
{
    long long n, r;
    cin >> n >> r;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        v[i] = {x, y};
    }

    long long p = sqrt(r * r / 2);

    for (int i = 0; i < n; i++) {
        auto [x, y] = v[i];
        mp[{x / p, y / p}].push_back(i);
    }

    cols.resize(n, -1);
    gr.resize(n);
    fl.resize(n, false);

    for (int i = 0; i < n; i++) {
        auto [x, y] = v[i];
        for (int dx = -2; dx <= 2; dx++) {
            for (int dy = -2; dy <= 2; dy++) {
                int x2 = x / p + dx, y2 = y / p + dy;
                for (auto id : mp[{x2, y2}]) {
                    if (dist(v[i], v[id], r) && i != id) {
                        gr[i].push_back(id);
                    }
                }
            }
        } 
    }


    for (int i = 0; i < n; i++) {
        if (cols[i] == -1) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        if (fl[i]) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << fl[i];
    }


    return 0;
}