#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
  
using namespace std;


struct fenw{
    vector<int> ft;
    fenw() {}
    fenw(int n) {
        ft.resize(n + 1, 0);
    }

    void addp(int l, int x) {
        for (int i = l; i < ft.size(); i += (i & (-i))) {
            ft[i] += x;
        }
    }

    int getp(int l) {
        int ans = 0;
        for (int i = l; i > 0; i -= (i & (-i))) {
            ans += ft[i];
        }
        return ans;
    }

    void add(int k) {
        addp(k + 1, 1);
    }

    int ask(int l, int r) {
        return getp(r) - getp(l);
    }
};


vector<vector<int>> v;

int sz;

vector<int> calc_inv_v(vector<int> v) {
    set<int> st;
    for (auto i : v) {
        st.insert(i);
    }
    map<int, int> mp;
    int it = 1;
    for (auto i : st) {
        mp[i] = it++;
    }

    for (int i = 0; i < v.size(); i++) {
        v[i] = mp[v[i]];
    }

    fenw tr(it + 1);
    int ans = 0;
    vector<int> res;
    for (int i = v.size() - 1; i >= 0; i--) {
        int x = v[i];
        ans += tr.ask(0, x);
        res.push_back(ans);
        tr.add(x);
    }
    reverse(res.begin(), res.end());
    return res;
}
  
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int r, c;
    cin >> r >> c;
    sz = r * c + 1;
    v.resize(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> v[i][j];
        }            
    }
    vector<vector<long long>> dp(r, vector<long long>(c));
    
    vector<vector<int>> invh(r, vector<int>(c));
    vector<vector<int>> invv(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        invh[i] = calc_inv_v(v[i]);
    }
    for (int i = 0; i < c; i++) {
        vector<int> cur;
        for (int j = 0; j < r; j++) {
            cur.push_back(v[j][i]);
        }
        vector<int> res = calc_inv_v(cur);
        for (int j = 0; j < r; j++) {
            invv[j][i] = res[j];
        }
    }

    vector<vector<pair<long long, long long>>> prc(r, vector<pair<long long, long long>>(c));
    for (int i = 0; i < r; i++) {
        fenw tr1(sz);
        fenw tr2(sz);
        long long ans1 = 0;
        for (int j = c - 1; j >= 0; j--) {
            int b = v[i][j];
            long long ans2 = 0;
            for (int k = i + 1; k < r; k++) {
                int x = v[k][j];
                ans1 += tr2.ask(x, sz);
            }
            
            for (int k = i; k < r; k++) {
                int x = v[k][j];
                ans2 += tr1.ask(0, x);
                ans2 += tr2.ask(0, x);
            }


            for (int k = i + 1; k < r; k++) {
                tr1.add(v[k][j]);
            }
            ans1 += tr1.ask(0, b);
            tr2.add(b);
            prc[i][j] = {ans1, ans2};
        }
    }

    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            if (i == r - 1) {
                dp[i][j] = invh[i][j];
                continue;
            }
            if (j == c - 1) {
                dp[i][j] = invv[i][j];
                continue;
            }
            long long s1 = invh[i][j], s2 = invv[i][j];
            s1 += prc[i][j].first;
            s2 += prc[i][j].second;
            dp[i][j] = min(dp[i + 1][j] + s1, dp[i][j + 1] + s2);
        }
    }
    cout << dp[0][0];
    return 0;
}