#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
  
using namespace std;


struct tree{
    vector<int> tr;

    tree() {}
    tree(int n) {
        tr.resize(n * 4, 0);
    }
    
    void add(int id, int l, int r, int k) {
        if (r - l == 1) {
            tr[id]++;
            return;
        }
        int mid = (l + r) / 2;
        if (k < mid) {
            add(id * 2 + 1, l, mid, k);
        } else {
            add(id * 2 + 2, mid, r, k);
        }
        tr[id] = tr[id * 2 + 1] + tr[id * 2 + 2];
    }

    int ask(int id, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return tr[id];
        }
        if (r <= ql || qr <= l) {
            return 0;
        }
        int mid = (l + r) / 2;
        return ask(id * 2 + 1, l, mid, ql, qr) + ask(id * 2 + 2, mid, r, ql, qr);
    }

    void clear(int id, int l, int r) {
        if (tr[id] == 0) {
            return;
        }
        if (r - l == 0) {
            tr[id]--;
            return;
        }
        int mid = (l + r) / 2;
        clear(id, l, mid);
        clear(id, mid, r);
        tr[id] = 0;
    }
};

vector<vector<int>> v;

int calc(int x, int l1, int l2, int r1, int r2) {
    int ans = 0;
    for (int i = l1; i <= l2; i++) {
        for (int j = r1; j <= r2; j++) {
            ans += (v[i][j] < x);
        }
    }
    return ans;
}

int sz;

int calc_inv(vector<int> &v) {
    tree tr(sz);
    long long ans = 0;
    for (int i = v.size() - 1; i >= 0; i--) {
        int x = v[i];
        ans += tr.ask(0, 0, sz, 0, x);
        tr.add(0, 0, sz, x);
    }
    return ans;
}
  
int main()
{
    int r, c;
    cin >> r >> c;
    sz = r * c + 1;
    v.resize(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> v[i][j];
        }
    }
    cout << calc_inv(v[0]) << endl;
    return 0;
    vector<vector<int>> dp(r, vector<int>(c));
    
    vector<vector<int>> invh(r, vector<int>(c));
    vector<vector<int>> invv(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        invh[i][c - 1] = 0;
        for (int j = c - 2; j >= 0; j--) {
            invh[i][j] = invh[i][j + 1] + calc(v[i][j], i, i, j, c - 1);
        }
    }
    for (int i = 0; i < c; i++) {
        invv[r - 1][i] = 0;
        for (int j = r - 2; j >= 0; j--) {
            invv[j][i] = invv[j + 1][i] + calc(v[j][i], j, r - 1, i, i);
        }
    }
     

    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            if (i == r - 1) {
                dp[i][j] = invh[i][j];
                continue;
            }
            if (j == c - 1) {
                dp[i][j] = invv[i][j];
                continue;
            }
            int s1 = invh[i][j], s2 = invv[i][j];
            for (int k = j; k < c; k++) {
                s1 += calc(v[i][k], i + 1, r - 1, j, c - 1);
            }
            for (int k = i; k < r; k++) {
                s2 += calc(v[k][j], i, r - 1, j + 1, c - 1);
            }
            dp[i][j] = min(dp[i + 1][j] + s1, dp[i][j + 1] + s2);
        }
    }
    cout << dp[0][0];
    return 0;
}