#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
 
using namespace std;

struct tree{
    vector<pair<int, int>> tr;
    vector<int> dat;

    void build(int id, int l, int r) {
        if (r - l == 1) {
            tr[id] = {dat[l], l};
            return;
        }
        int mid = (l + r) / 2;
        build(id * 2 + 1, l, mid);
        build(id * 2 + 2, mid, r);
        tr[id] = min(tr[id * 2 + 1], tr[id * 2 + 2]);
    }

    tree() {}

    tree(vector<int> &dat) : dat(dat) {
        tr.resize(dat.size() * 4);
        build(0, 0, dat.size());
    }

    pair<int, int> ask(int id, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return tr[id];
        }
        if (r <= ql || qr <= l) {
            return {1e8, -1};
        }
        int mid = (l + r) / 2;
        return min(ask(id * 2 + 1, l, mid, ql, qr), ask(id * 2 + 2, mid, r, ql, qr));
    }
};

tree tr;
vector<int> nxt;
vector<int> suf;

int solve(vector<int> &v, int k, int id) {
    int rm = k;
    int cur = 0;
    for (int i = 0; i < k - 1; i++) {
        if (id == i + 1) {
            return v[cur];
        }
        rm--;
        if (i == k - 2) {
            if (nxt[cur] != v.size()) {
                cur++;
            } else {
                return v[v.size() - 1];
            }
            continue;
        }
        int r = nxt[cur];
        auto [mn, id] = tr.ask(0, 0, v.size(), cur, min((int)v.size() - rm + 1, r));
        if (id == cur) {
            cur++;
        } else {
            cur = id;
        }
    }
    return suf[cur];
}
 
int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];                                                                                    
    }
    tr = tree(v);

    nxt.resize(n);
    stack<int> st;
    for (int i = n - 1; i >= 0; i--) {
        while (st.size() != 0 && v[st.top()] < v[i]) {
            st.pop();
        }
        if (st.size() == 0) {
            nxt[i] = n;
        } else {
            nxt[i] = st.top();
        }
        st.push(i);
    }

    suf.resize(n);
    suf[n - 1] = v[n - 1];
    for (int i = n - 2; i >= 0;i--) {
        suf[i] = max(suf[i + 1], v[i]);
    }

    for (int i = 0; i < q; i++) {
        int k, id;
        cin >> k >> id;
        cout << solve(v, k, id) << '\n';
    }
    return 0;
}