#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#pragma GCC optimize("Ofast")
#define int long long
#define INF 100000000000LL

int n, m;
vector<vector<int>> t;
vector<vector<int>> dp;

#define MAXN 2000000

int tt[4*MAXN] = {};
int push[4*MAXN] = {};

void update(int v)
{
    if (push[v])
    {
        tt[2 * v] = 0;
        tt[2 * v + 1] = 0;
        push[2 * v] = 1;
        push[2 * v + 1] = 1;
    }
    push[v] = 0;
}

void add(int v, int vl, int vr, int x)
{
    tt[v]++;
    if (vr - vl == 1)
    {
        return;
    }
    int vm = (vl + vr) / 2;

    update(v);

    if (x < vm)
    {
        add(2 * v, vl, vm, x);
    }
    else
    {
        add(2 * v + 1, vm, vr, x);
    }
}
void rem(int v, int vl, int vr, int x)
{
    tt[v]--;
    if (vr - vl == 1)
    {
        return;
    }
    int vm = (vl + vr) / 2;

    update(v);

    if (x < vm)
    {
        rem(2 * v, vl, vm, x);
    }
    else
    {
        rem(2 * v + 1, vm, vr, x);
    }
}

void cls()
{
    push[1] = 1;
}

int count_pref(int v, int vl, int vr, int l, int r)
{
    if (l >= r)
    {
        return 0;
    }
    if (vl == l && vr == r)
    {
        return tt[v];
    }
    int vm = (vl + vr) / 2;

    update(v);

    return count_pref(2 * v, vl, vm, l, min(r, vm)) +
           count_pref(2 * v + 1, vm, vr, max(l, vm), r);
}

int curr_a, curr_b;
void move_to(int a, int b)
{
    if (a == curr_a && b == curr_b)
    {
        return;
    }
    if (a == n || b == m)
    {
        cls();
    }
    else if (a != curr_a)
    {
        cls();
        for (int i = a; i < n; ++i)
        {
            for (int j = b; j < m; ++j)
            {
                add(1, 0, n*m, t[i][j]);
            }
        }
    }
    else
    {
        for (int i = a; i < n; ++i)
        {
            for (int j = curr_b; j < b; ++j)
            {
                rem(1, 0, n*m, t[i][j]);
            }
            for (int j = curr_b - 1; j >= b; --j)
            {
                add(1, 0, n*m, t[i][j]);
            }
        }
    }
    curr_a = a;
    curr_b = b;
}

int invs(vector<int> &v)
{
    if (v.size() == 1)
    {
        return 0;
    }
    if (v.size() < 10)
    {
        int res = 0;
        for (int i = 0; i < v.size(); ++i)
        {
            int x = i;
            while (x > 0 && v[x - 1] > v[x])
            {
                swap(v[x - 1], v[x]);
                --x;
                ++res;
            }
        }
        return res;
    }
    // split
    vector<int> a, b;
    int x = 0;
    for (; x < v.size() / 2; ++x)
    {
        a.push_back(v[x]);
    }
    for (; x < v.size(); ++x)
    {
        b.push_back(v[x]);
    }
    int res = 0;
    res += invs(a);
    res += invs(b);
    // merge
    for (int i = 0; i < a.size(); ++i)
    {
        res += lower_bound(b.begin(), b.end(), a[i]) - b.begin();
    }
    int ia = 0, ib = 0;
    x = 0;
    while (ia < a.size() && ib < b.size())
    {
        if (a[ia] < b[ib])
        {
            v[x++] = a[ia++];
        }
        else if (a[ia] > b[ib])
        {
            v[x++] = b[ib++];
        }
        else
        {
            v[x++] = a[ia++];
            v[x++] = b[ib++];
        }
    }
    for (;ia < a.size(); ++ia)
    {
        v[x++] = a[ia];
    }
    for (;ib < b.size(); ++ib)
    {
        v[x++] = b[ib];
    }
    return res;
}

int inv_A_a, inv_A_b, inv_A_res;
tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> inv_A_v;
int inv_A(int a, int b)
{
    if (inv_A_a == a && inv_A_b + 1 == b)
    {
//        vector<int> v(m - b);
//        int res = 0;
//        for (int i = b; i < m; ++i)
//        {
//            v[i - b] = t[a][i];
//        }
//        inv_A_res = invs(v);
        int res = inv_A_res;
        {
            inv_A_v.erase(t[a][inv_A_b]);
            res -= inv_A_v.order_of_key(t[a][inv_A_b]);
        }
        inv_A_res = res;
    }
    else
    {
        inv_A_v.clear();
        vector<int> v(m - b);
        int res = 0;
        for (int i = b; i < m; ++i)
        {
            inv_A_v.insert(t[a][i]);
            v[i - b] = t[a][i];
        }
        inv_A_res = invs(v);
    }
    inv_A_a = a;
    inv_A_b = b;
    return inv_A_res;
}

int inv_B(int a, int b)
{
    vector<int> v(n - a);
    int res = 0;
    for (int i = a; i < n; ++i)
    {
        v[i - a] = t[i][b];
//        for (int j = a; j < i; ++j)
//        {
//            res += (t[i][b] < t[j][b]);
//        }
    }
//    assert(res == invs(v));
//    return res;
    return invs(v);
}

int tA_res = 0, tA_a, tA_b;
tree<int, null_type, less<int>, rb_tree_tag,
 tree_order_statistics_node_update> tA_v;
int try_A(int a, int b)
{
    int res = 0;
    if (tA_a != a && tA_b + 1 != b)
    {
        move_to(a + 1, b);
        tA_v.clear();
        for (int i = b; i < m; ++i)
        {
            tA_v.insert(t[a][i]);
//            cout << "ADD: " << i << ' ' << count_pref(1, 0, n*m,0,t[a][i]) << '\n';
            res += count_pref(1, 0, n*m,0,t[a][i]);
        }
    }
    else
    {
        res = tA_res;
        int z = 0;
        tA_v.erase(t[a][tA_b]);
        for (int i = a + 1; i < n; ++i)
        {
            z += tA_v.size() - tA_v.order_of_key(t[i][tA_b]);
        }
        res -= count_pref(1, 0, n*m,0,t[a][tA_b]) + z;
//        cout << "REMOVE: " << tA_b << ' ' << count_pref(1, 0, n*m,0,t[a][tA_b]) + z << '\n';
        move_to(a + 1, b);
    }
    tA_a = a;
    tA_b = b;
    tA_res = res;
    return tA_res + inv_A(a, b);
}
int try_B(int a, int b)
{
    int res = 0;
    move_to(a, b + 1);
    for (int i = a; i < n; ++i)
    {
        res += count_pref(1, 0, n*m,0,t[i][b]);
    }
    res += inv_B(a, b);
    return res;
}

signed main()
{
//    vector<int> v = {1, 3, 2, 5, 4};
//    cout << invs(v) << '\n';
//    return 0;
//    cin.tie(NULL);
//    cin.sync_with_stdio(false);
//    n = 1; m = 300000;
    cin >> n >> m;
    curr_a = n;
    curr_b = m;
    inv_A_a = n;
    inv_A_b = m;
    tA_a = n;
    tA_b = m;
    t.resize(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
//            t[i][j] = rand();
            cin >> t[i][j];
        }
    }
    // compress
    {
        map<int, int> ma;
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < m; ++j)
            {
                ma[t[i][j]] = 0;
            }
        }
        int id = 0;
        for (auto &i : ma)
        {
            i.second = id++;
        }
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < m; ++j)
            {
                t[i][j] = ma[t[i][j]];
            }
        }
    }

    dp.resize(n + 1, vector<int>(m + 1, INF));

    dp[0][0] = 0;

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + try_B(i, j));
        }
        for (int j = 0; j < m; ++j)
        {
            if (i == n && j != 0)
            {
                continue;
            }
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + try_A(i, j));
        }
//        for (int j = 0; j < m; ++j)
//            cout << dp[i][j] << ' ';
//        cout << dp[i][m] << '\n';
    }
//    for (int i = 0; i <= m; ++i)
//    {
//        cout << dp[n][i] << ' ';
//    }
//    cout << '\n';

    int ans = INF;

    for (int i = 0; i <= n; ++i)
    {
        for (int j = 0; j <= m; ++j)
        {
            if (i == n || j == m)
            {
                ans = min(ans, dp[i][j]);
            }
        }
    }

    cout << ans << '\n';


    return 0;
}
