#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

struct Point {
    int x, y;

    constexpr Point() = default;

    ll dist(const Point &other) {
        return 1ll * (x - other.x) * (x - other.x) + 1ll * (y - other.y) * (y - other.y);
    }
};

int n, r;
vector<Point> a;

constexpr int N = 1e5;

int dfs_used[N];
bool used_id[N];
map<pair<int, int>, vector<int>> grid;

bool dfs(int i) {
    used_id[i] = true;
    const int xs = a[i].x / (r / 2), ys = a[i].y / (r / 2);
    for (int x = xs - 3; x <= xs + 3; ++x) {
        for (int y = ys - 3; y <= ys + 3; ++y) {
            if (!grid.contains({x, y})) { continue; }
            for (const int id : grid[{x, y}]) {
                if (i == id || a[i].dist(a[id]) > 1ll * r * r) {
                    continue;
                }
                if (dfs_used[id] == 0) {
                    dfs_used[id] = dfs_used[i] ^ 3;
                    if (dfs(id)) { return true; }
                } else if (dfs_used[id] == dfs_used[i]) {
                    return true;
                }
            }
        }
    }
    return false;
}

void solve() {
    if (r == 1) {
        for (int i = 0; i < n; ++i) {
            cout << '0';
        }
        cout << '\n';
        return;
    }
    for (int i = 0; i < n; ++i) {
        grid[{a[i].x / (r / 2), a[i].y / (r / 2)}].push_back(i);
    }
    vector<bool> res(n);
    set<pair<int, int>> used;
    queue<pair<int, int>> q;

    auto bfs = [&] {
        while (!q.empty()) {
            auto [xs, ys] = q.front();
            q.pop();
            for (const int id : grid[{xs, ys}]) {
                res[id] = used_id[id] = true;
                for (int x = xs - 3; x <= xs + 3; ++x) {
                    for (int y = ys - 3; y <= ys + 3; ++y) {
                        if (!grid.contains({x, y})) { continue; }
                        if (used.contains({x, y})) {
                            continue;
                        }
                        for (const int id2 : grid[{x, y}]) {
                            if (a[id].dist(a[id2]) <= 1ll * r * r) {
                                used.emplace(x, y);
                                q.emplace(x, y);
                                break;
                            }
                        }
                    }
                }
            }
        }
    };

    for (const auto &[key, val] : grid) {
        if (val.size() > 2) {
            used.insert(key);
            q.push(key);
        }
    }
    bfs();

    for (int i = 0; i < n; ++i) {
        if (used_id[i]) {
            continue;
        }
        dfs_used[i] = 1;
        if (dfs(i)) {
            used.emplace(a[i].x / (r / 2), a[i].y / (r / 2));
            q.emplace(a[i].x / (r / 2), a[i].y / (r / 2));
            bfs();
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << (res[i] ? '1' : '0');
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> r;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    solve();
}