#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, m;
vector<vector<int>> a;

vector<int> fen;

void add(int i) {
    for (; i < fen.size(); i |= i + 1) {
        ++fen[i];
    }
}

int sum(int i) {
    int res = 0;
    for (; i > 0; i = (i & (i + 1)) - 1) {
        res += fen[i];
    }
    return res;
}

void do_add(int rows, int cols) {
    fen.assign(n * m + 1, 0);
    for (int i = 0; i < rows; ++i) {
        for (int j = 0; j < m; ++j) {
            add(a[i][j]);
        }
    }
    for (int j = 0; j < cols; ++j) {
        for (int i = rows; i < n; ++i) {
            add(a[i][j]);
        }
    }
}

void solve() {
    vector dp(n + 1, vector(m + 1, INT_MAX));
    dp[0][0] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i) {
                int cur = dp[i - 1][j];
                do_add(i - 1, j);
                for (int k = j; k < m; ++k) {
                    cur += sum(n * m) - sum(a[i - 1][k]);
                    add(a[i - 1][k]);
                }
                dp[i][j] = min(dp[i][j], cur);
            }
            if (j) {
                int cur = dp[i][j - 1];
                do_add(i, j - 1);
                for (int k = i; k < n; ++k) {
                    cur += sum(n * m) - sum(a[k][j - 1]);
                    add(a[k][j - 1]);
                }
                dp[i][j] = min(dp[i][j], cur);
            }
        }
    }
    cout << dp[n][m] << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    a.assign(n, vector<int>(m));
    cin >> a;
    solve();
}