#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using LL = __int128_t;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T>
istream& operator >>(istream& in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

struct Req {
    int k, i;
    int id;

    constexpr Req() = default;
};

int n, q;
vector<int> p;
vector<Req> reqs;

constexpr int N = 3e5;
int st[__lg(N) + 1][N];

bool cmp(int i, int j) {
    return p[i] < p[j];
}

void build_sparse_table() {
    for (int i = 0; i < n; ++i) {
        st[0][i] = i;
    }
    for (int t = 1; t <= __lg(N); ++t) {
        for (int i = 0; i + (1 << t) <= n; ++i) {
            st[t][i] = min(st[t - 1][i], st[t - 1][i + (1 << (t - 1))], cmp);
        }
    }
}

int get_min(int l, int r) {
    const int t = __lg(r - l + 1);
    return max(st[t][l], st[t][r - (1 << t) + 1], cmp);
}

void solve() {
    build_sparse_table();
    vector nxt(n, n);
    {
        set<int> s;
        for (int i = 0; i < n; ++i) {
            while (!s.empty()) {
                int id = *s.begin();
                if (p[id] < p[i]) {
                    nxt[id] = i;
                    s.erase(id);
                    continue;
                }
                break;
            }
            s.insert(i);
        }
    }
    debug(nxt);
    sort(all(reqs), [](const Req &r1, const Req &r2){return r1.k < r2.k;});
    vector<int> res(q);
    int prv = -1;
    vector<int> b;

    for (const auto &[k, num, id] : reqs) {
        if (prv != k) {
            prv = k;
            b.clear();
            int cur = k;
            int l = 0, r = min(n - cur + 1, nxt[0] - 1);
            while (cur > 1) {
                b.push_back(p[l]);
                if (l == r) {
                    l++;
                } else {
                    l = get_min(l + 1, r);
                }
                r = min(n - --cur, nxt[l] - 1);
            }
            b.push_back(*max_element(p.begin() + l, p.end()));
        }
        res[id] = b[num];
    }
    cout << res << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> q;
    p.resize(n);
    cin >> p;
    reqs.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> reqs[i].k >> reqs[i].i;
        reqs[i].i--;
        reqs[i].id = i;
    }
    solve();
}