#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

struct SparseTable {
    vector<vector<pair<int, int>>> t;

    SparseTable() { }

    SparseTable(vector<pair<int, int>>& a)
    {
        int n = a.size();
        int L = __lg(n);
        t.resize(L + 1, vector<pair<int, int>>(n));
        for (int i = 0; i < n; i++)
            t[0][i] = a[i];
        for (int l = 1; l <= L; l++)
            for (int i = 0; i <= n - (1 << l); i++)
                t[l][i] = min(t[l - 1][i], t[l - 1][i + (1 << (l - 1))]);
    }

    pair<int, int> operator()(int l, int r)
    {
        int k = __lg(r - l);
        return min(t[k][l], t[k][r - (1 << k)]);
    }
};

void solve()
{
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].X;
        a[i].Y = i;
    }
    SparseTable st(a);
    while (q--) {
        int k, i;
        cin >> k >> i;
        vector<int> cur { -1 };
        for (int j = k - 1; j >= 0; j--)
            cur.push_back(st(cur.back() + 1, n - j).Y);
        cout << a[cur[i]].X << '\n';
    }
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
