#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define X first
#define Y second

int n;

struct SparseTable {
    vector<vector<pair<int, int>>> t;

    SparseTable() { }

    SparseTable(vector<int>& a)
    {
        int n = a.size();
        int L = __lg(n);
        t.resize(L + 1, vector<pair<int, int>>(n));
        for (int i = 0; i < n; i++)
            t[0][i] = { a[i], i };
        for (int l = 1; l <= L; l++)
            for (int i = 0; i <= n - (1 << l); i++)
                t[l][i] = min(t[l - 1][i], t[l - 1][i + (1 << (l - 1))]);
    }

    pair<int, int> operator()(int l, int r)
    {
        r = min(r, n);
        int k = __lg(r - l);
        return min(t[k][l], t[k][r - (1 << k)]);
    }
};

struct SparseTableMX {
    vector<vector<pair<int, int>>> t;

    SparseTableMX() { }

    SparseTableMX(vector<int>& a)
    {
        int n = a.size();
        int L = __lg(n);
        t.resize(L + 1, vector<pair<int, int>>(n));
        for (int i = 0; i < n; i++)
            t[0][i] = { a[i], i };
        for (int l = 1; l <= L; l++)
            for (int i = 0; i <= n - (1 << l); i++)
                t[l][i] = max(t[l - 1][i], t[l - 1][i + (1 << (l - 1))]);
    }

    pair<int, int> operator()(int l, int r)
    {
        r = min(r, n);
        int k = __lg(r - l);
        return max(t[k][l], t[k][r - (1 << k)]);
    }
};

void solve()
{
    int q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> b(n);
    vector<int> stk;
    for (int i = 0; i < n; i++) {
        while (stk.size() && a[stk.back()] < a[i]) {
            b[stk.back()] = i;
            stk.pop_back();
        }
        stk.push_back(i);
    }
    while (stk.size()) {
        b[stk.back()] = n;
        stk.pop_back();
    }
    SparseTable st(a);
    SparseTableMX stm(a);
    while (q--) {
        int k, id;
        cin >> k >> id;
        if (k == 1) {
            cout << n << '\n';
            continue;
        }
        if (id == 1) {
            cout << a[0] << '\n';
            continue;
        }
        vector<int> cur { 0 };
        for (int i = k - 1; i > 0; i--) {
            if (b[cur.back()] == cur.back() + 1)
                cur.push_back(cur.back() + 1);
            else {
                cur.push_back(st(cur.back() + 1, min(b[cur.back()] + 1, n - i)).Y);
            }
            if (cur.size() >= id + 2)
                break;
        }
        cur.push_back(n);
        cout << stm(cur[id - 1], cur[id]).X << '\n';
    }
}

signed main()
{
#ifdef LOCAL
    freopen("TEST", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int ttt = 1;
    // cin >> ttt;
    while (ttt--)
        solve();
}
