#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;

namespace rng = ranges;


int Sq(int x) {
    return x * x;
}

int DistSq(pair<int, int> a, pair<int, int> b) {
    return Sq(a.first - b.first) + Sq(a.second - b.second);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    int maxsh = r;
    r *= r;
    vector<pair<int, int>> xy(n);
    for (auto &[x, y] : xy) {
        cin >> x >> y;
    }
    vector<pair<pair<int, int>, int>> pi(n);
    for (int i = 0; i < n; ++i) {
        pi[i] = { xy[i], i };
    }
    rng::sort(pi);
    auto find = [&] (pair<int, int> p) -> optional<int> {
        auto it = rng::lower_bound(pi, pair{ p, (int)0 });
        if (it == pi.end() || it->first != p) {
            return nullopt;
        } else {
            return it->second;
        }
    };
    vector<vector<int>> g(n);
    for (int fr = 0; fr < n; ++fr) {
        for (int xj = xy[fr].first; xj <= xy[fr].first + maxsh; ++xj) {
            for (int yj = xy[fr].second; yj <= xy[fr].second + maxsh; ++yj) {
                if (DistSq(xy[fr], { xj, yj }) > r) break;
                if (auto oind = find({ xj, yj }); oind.has_value() && pair{ xj, yj } != xy[fr]) {
                    int j = *oind;
                    g[fr].push_back(j);
                    g[j].push_back(fr);
                }
            }
        }
    }
    vector<bool> used(n, false);
    vector<bool> ev_st(n);
    vector<bool> can(n, false);
    auto dfs = [&] (auto &&self, int fr, bool ev = true) -> void {
        if (used[fr]) {
            if (ev_st[fr] != ev) {
                can[fr] = true;
            }
            return;
        }
        used[fr] = true;
        ev_st[fr] = ev;
        for (int i : g[fr]) {
            self(self, i, !ev);
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(dfs, i);
        }
    }
    used.assign(n, false);
    auto dfs1 = [&] (auto &&self, int fr) -> void {
        if (used[fr]) {
            return;
        }
        used[fr] = true;
        can[fr] = true;
        for (int i : g[fr]) {
            self(self, i);
        }
    };
    for (int i = 0; i < n; ++i) {
        if (can[i]) {
            dfs1(dfs1, i);
        }
    }
    for (bool i : can) {
        cout << (i ? '1' : '0');
    }
    cout << endl;

    return 0;
}