#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
using namespace std;


array<int, 100000> col, ans;
array<vector<int>, 100000> graph;


bool dfs(int v, int c) {
	col[v] = c;
	bool flag = false;
	for (int u : graph[v]) {
		if (col[u] == -1)
			flag = flag || dfs(u, c ^ 1);
		if (col[u] == col[v])
			return true;
	}
	return flag;
}


void make(int v, int c) {
	ans[v] = c;
	for (int u : graph[v]) {
		if (ans[u] == -1)
			make(u, c);
	}
}


long long len(const pair<long long, long long>& a, const pair<long long, long long>& b) {
	return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, x, y;
	long long r;
	cin >> n >> r;
	vector<pair<long long, long long>> dots(n), tx(n), ty(n);
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		dots[i] = { x, y }, tx[i] = { x, i }, ty[i] = { y, i };
		col[i] = -1, ans[i] = -1;
	}
	sort(tx.begin(), tx.end());
	sort(ty.begin(), ty.end());
	int j = 0, v, u;
	for (int i = 0; i < n; i++) {
		while (j < n && tx[j].first - tx[i].first <= r)
			j++;
		for (int k = i + 1; k < j; k++) {
			v = tx[i].second, u = tx[k].second;
			if (len(dots[v], dots[u]) <= r * r) {
				graph[v].push_back(u);
				graph[u].push_back(v);
			}
		}
	}
	j = 0;
	for (int i = 0; i < n; i++) {
		while (j < n && ty[j].first - ty[i].first <= r)
			j++;
		for (int k = i + 1; k < j; k++) {
			v = ty[i].second, u = ty[k].second;
			if (len(dots[v], dots[u]) <= r * r) {
				graph[v].push_back(u);
				graph[u].push_back(v);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (ans[i] == -1) {
			if (dfs(i, 0))
				make(i, 1);
			else
				make(i, 0);
		}
		cout << ans[i];
	}
	cout << '\n';
}
