#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;


vector<int> col, ans;
vector<vector<int>> graph;


bool dfs(int v, int c) {
	col[v] = c;
	bool flag = false;
	for (int u : graph[v]) {
		if (col[u] == -1)
			flag = flag || dfs(u, c ^ 1);
		if (col[u] == col[v])
			return true;
	}
	return flag;
}


void make(int v, int c) {
	ans[v] = c;
	for (int u : graph[v]) {
		if (ans[u] == -1)
			make(u, c);
	}
}


long long len(pair<long long, long long> a, pair<long long, long long> b) {
	return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, x, y;
	long long r;
	cin >> n >> r;
	vector<pair<long long, long long>> dots(n);
	unordered_map<long long, vector<pair<long long, long long>>> ty;
	graph.resize(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		dots[i] = { x, y };
		ty[y].push_back({ x, i });
	}
	for (auto& [x, v] : ty)
		sort(v.begin(), v.end());
	for (int i = 0; i < n; i++) {
		x = dots[i].first, y = dots[i].second;
		for (int j = y - r; j <= y + r; j++) {
			if (ty.find(j) == ty.end())
				continue;
			pair<long long, long long> a = { x - r, 0ll }, b = { x + r + 1, 0ll };
			int lf = lower_bound(ty[j].begin(), ty[j].end(), a) - ty[j].begin();
			int rt = lower_bound(ty[j].begin(), ty[j].end(), b) - ty[j].begin();
			for (int k = lf; k < rt; k++) {
				int v = i, u = ty[j][k].second;
				if (len(dots[v], dots[u]) <= r * r && u != v) {
					//cout << "shiza " << v << ' ' << u << ' ' << len(dots[v], dots[u]) << '\n';
					graph[v].push_back(u);
					graph[u].push_back(v);
				}
			}

		}
	}
	col.resize(n + 1, -1);
	ans.resize(n + 1, -1);
	for (int i = 0; i < n; i++) {
		if (ans[i] == -1) {
			if (dfs(i, 0))
				make(i, 1);
			else
				make(i, 0);
		}
		cout << ans[i];
	}
	cout << '\n';
}
