#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
using namespace std;


int n;
long long r;
array<int, 100000> col, ans;
array<pair<long long, long long>, 100000> dots;


long long len(const pair<long long, long long>& a, const pair<long long, long long>& b) {
	return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}


bool dfs(int v, int c) {
	col[v] = c;
	bool flag = false;
	for (int u = 0; u < n; u++) {
		if (u == v || len(dots[u], dots[v]) > r * r)
			continue;
		if (col[u] == -1)
			flag = flag || dfs(u, c ^ 1);
		if (col[u] == col[v])
			return true;
	}
	return flag;
}


void make(int v, int c) {
	ans[v] = c;
	for (int u = 0; u < n; u++) {
		if (u == v || len(dots[u], dots[v]) > r * r)
			continue;
		if (ans[u] == -1)
			make(u, c);
	}
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int x, y;
	cin >> n >> r;
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		dots[i] = { x, y };
		col[i] = -1, ans[i] = -1;
	}
	for (int i = 0; i < n; i++) {
		if (ans[i] == -1) {
			if (dfs(i, 0))
				make(i, 1);
			else
				make(i, 0);
		}
		cout << ans[i];
	}
	cout << '\n';
}
