#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
using namespace std;


const int INF = 1e9, SZ = 2e6;
int n, m;
array<array<int, SZ>, SZ> mem, mat;
array<int, SZ> tree;


void upd(int id, int l, int r, int i, int x) {
	//cout << "upd " << ' ' << l << ' ' << r << " || " << i << ' ' << x << '\n';
	if (r - l == 1) {
		tree[id] += x;
		return;
	}
	int m = (l + r) / 2;
	if (i < m)
		upd(id * 2 + 1, l, m, i, x);
	else
		upd(id * 2 + 2, m, r, i, x);
	tree[id] = tree[id * 2 + 1] + tree[id * 2 + 2];
}


int get(int id, int l, int r, int ql, int qr) {
	//cout << "get " << id << ' ' << l << ' ' << r << " || " << ql << ' ' << qr << '\n';
	if (ql <= l && r <= qr)
		return tree[id];
	if (qr <= l || r <= ql)
		return 0;
	int m = (l + r) / 2;
	return get(id * 2 + 1, l, m, ql, qr) + get(id * 2 + 2, m, r, ql, qr);
}


int f(int x, int y) {
	//cout << x << ' ' << y << '\n';
	if (x == n || y == m)
		return 0;
	if (mem[x][y] != -1)
		return mem[x][y];
	int cnt, ans = INF;
	cnt = 0;
	for (int i = y; i < m; i++) {
		cnt += mat[x][i] - get(0, 0, n * m, 0, mat[x][i]);
		upd(0, 0, n * m, mat[x][i], 1);
	}
	ans = min(ans, cnt + f(x + 1, y));
	for (int i = y; i < m; i++)
		upd(0, 0, n * m, mat[x][i], -1);
	cnt = 0;
	for (int i = x; i < n; i++) {
		cnt += mat[i][y] - get(0, 0, n * m, 0, mat[i][y]);
		upd(0, 0, n * m, mat[i][y], 1);
	}
	ans = min(ans, cnt + f(x, y + 1));
	for (int i = x; i < n; i++)
		upd(0, 0, n * m, mat[i][y], -1);
	return mem[x][y] = ans;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> mat[i][j];
			mat[i][j]--, mem[i][j] = 0;
		}
	}
	if (n != 1) {
		cout << f(0, 0) << '\n';
		return 0;
	}
	int cnt = 0;
	for (int i = 0; i < m; i++) {
		cnt += get(0, 0, n * m, 0, mat[0][i]);
		upd(0, 0, n * m, mat[0][i], 1);
	}
	cout << cnt << '\n';
}
