#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


const long long INF = 1e9;
long long n, m;
vector<vector<long long>> mem, mat;
vector<long long> tree;


void upd(long long id, long long l, long long r, long long i, long long x) {
	//cout << "upd " << ' ' << l << ' ' << r << " || " << i << ' ' << x << '\n';
	if (r - l == 1) {
		tree[id] += x;
		return;
	}
	long long m = (l + r) / 2;
	if (i < m)
		upd(id * 2 + 1, l, m, i, x);
	else
		upd(id * 2 + 2, m, r, i, x);
	tree[id] = tree[id * 2 + 1] + tree[id * 2 + 2];
}


long long get(long long id, long long l, long long r, long long ql, long long qr) {
	//cout << "get " << id << ' ' << l << ' ' << r << " || " << ql << ' ' << qr << '\n';
	if (ql <= l && r <= qr)
		return tree[id];
	if (qr <= l || r <= ql)
		return 0;
	long long m = (l + r) / 2;
	return get(id * 2 + 1, l, m, ql, qr) + get(id * 2 + 2, m, r, ql, qr);
}


long long f(long long x, long long y) {
	//cout << x << ' ' << y << '\n';
	if (x == n || y == m)
		return 0;
	if (mem[x][y] != -1)
		return mem[x][y];
	long long cnt, ans = INF;
	cnt = 0;
	for (long long i = y; i < m; i++) {
		cnt += mat[x][i] - get(0, 0, n * m, 0, mat[x][i]);
		upd(0, 0, n * m, mat[x][i], 1);
	}
	ans = min(ans, cnt + f(x + 1, y));
	for (long long i = y; i < m; i++)
		upd(0, 0, n * m, mat[x][i], -1);
	cnt = 0;
	for (long long i = x; i < n; i++) {
		cnt += mat[i][y] - get(0, 0, n * m, 0, mat[i][y]);
		upd(0, 0, n * m, mat[i][y], 1);
	}
	ans = min(ans, cnt + f(x, y + 1));
	for (long long i = x; i < n; i++)
		upd(0, 0, n * m, mat[i][y], -1);
	return mem[x][y] = ans;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	mat.resize(n, vector<long long>(m));
	mem.resize(n, vector<long long>(m, -1));
	tree.resize(4 * n * m, 0);
	for (long long i = 0; i < n; i++) {
		for (long long j = 0; j < m; j++) {
			cin >> mat[i][j];
			mat[i][j]--;
		}
	}
	if (n != 1) {
		cout << f(0, 0) << '\n';
		return 0;
	}
	long long cnt = 0;
	for (long long i = 0; i < m; i++) {
		cnt += mat[0][i] - get(0, 0, n * m, 0, mat[0][i]);
		upd(0, 0, n * m, mat[0][i], 1);
	}
	cout << cnt << '\n';
}
