#include <iostream>
#include <vector>
using namespace std;


const int INF = 1e9;
vector<int> a, tree;


void build(int id, int l, int r) {
    if (r - l == 1) {
        tree[id] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(id * 2 + 1, l, m);
    build(id * 2 + 2, m, r);
    tree[id] = min(tree[id * 2 + 2], tree[id * 2 + 2]);
}


int get(int id, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr)
        return tree[id];
    if (qr <= l || r <= ql)
        return INF;
    int m = (l + r) / 2;
    return min(get(id * 2 + 1, l, m, ql, qr), get(id * 2 + 2, m, r, ql, qr));
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
	int n, q;
	cin >> n >> q;
	a.resize(n);
	tree.resize(4 * n, INF);
	for (int i = 0; i < n; i++)
		cin >> a[i];
    int x = a[1];
    if (a[0] != n && a[1] != n) {
        for (int i = 1; i < n; i++) {
            if (a[0] > x && a[i] < x)
                x = a[i];
        }
    }
    if (a[0] == n) {
        x = 0;
        for (int i = n - 1; i >= 0; i++) {
            if (a[i] == 1)
                break;
            x = max(x, a[i]);
        }
    }
    build(0, 0, n);
	int k, j;
	for (int i = 0; i < q; i++) {
		cin >> k >> j;
		if (a[0] == n) {
            if (j == 1)
                cout << n << '\n';
            if (j == 2)
                cout << 1 << '\n';
            if (j == 3)
                cout << x << '\n';
		}
		else if (a[1] == n) {
            if (j == 1)
                cout << a[0] << '\n';
            if (j == 2)
                cout << n << '\n';
            if (j == 3)
                cout << a[n - 1] << '\n';
		}
		else {
            if (j == 1)
                cout << a[0] << '\n';
            if (j == 2)
                cout << x << '\n';
            if (j == 3)
                cout << n << '\n';
		}
	}
}

