#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll

int n, r;

struct Point {
    int x, y;
};

int dist(Point p1, Point p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

bool reachable(Point p1, Point p2) {
    return dist(p1, p2) <= r * r;
}

vector<vector<int>> g;
vector<int> ans, st, used;

bool dfs(int v, int prev) {
    st.push_back(v);
    used[v] = 1;
    for (auto to : g[v]) {
        if (to == prev or used[to] == 2)
            continue;
        if (used[to] == 1) {
            int len = 0;
            while (st[st.size() - 1 - len] != to)
                len++;
            if (len % 2 == 0) {
                st.pop_back();
                used[v] = 2;
                return true;
            }
            continue;
        }
        if (dfs(to, v)) {
            st.pop_back();
            used[v] = 2;
            return true;
        }
    }
    st.pop_back();
    used[v] = 2;
    return false;
}

void mark_ans(int v, int cur_ans) {
    used[v] = 2;
    ans[v] = cur_ans;
    for (auto to : g[v]) {
        if (ans[to] == -1)
            mark_ans(to, cur_ans);
    } 
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >> n >> r;
    vector<Point> a(n);
    for (auto& i : a)
        cin >> i.x >> i.y;

    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j and reachable(a[i], a[j]))
                g[i].push_back(j);
        }
    }

    ans.assign(n, -1);
    used.assign(n, 0);
    for (int v = 0; v < n; v++) {
        if (ans[v] != -1)
            continue;
        if (dfs(v, -1))
            mark_ans(v, 1);
        else
            mark_ans(v, 0);
    }

    for (auto i : ans)
        cout << i;
}