#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
// #define int ll

int n, r;

struct Point {
    int x, y;
};

ll dist(Point p1, Point p2) {
    return ll(p1.x - p2.x) * ll(p1.x - p2.x) + ll(p1.y - p2.y) * ll(p1.y - p2.y);
}

vector<Point> a;
vector<int> ans, st, used;

bool reachable(int v, int to) {
    return dist(a[v], a[to]) <= (ll)r * (ll)r;
}

bool dfs(int v, int prev) {
    st.push_back(v);
    used[v] = 1;
    for (int to = 0; to < n; to++) {
        if (to == v or to == prev or !reachable(v, to) or used[to] == 2)
            continue;
        if (used[to] == 1) {
            int len = 0;
            while (st[st.size() - 1 - len] != to)
                len++;
            if (len % 2 == 0) {
                st.pop_back();
                used[v] = 2;
                return true;
            }
            continue;
        }
        if (dfs(to, v)) {
            st.pop_back();
            used[v] = 2;
            return true;
        }
    }
    st.pop_back();
    used[v] = 2;
    return false;
}

void mark_ans(int v, int cur_ans) {
    used[v] = 2;
    ans[v] = cur_ans;
    for (int to = 0; to < n; to++) {
        if (to == v or !reachable(v, to) or ans[to] != -1)
            continue;
        mark_ans(to, cur_ans);
    } 
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >> n >> r;
    a.resize(n);
    for (auto& i : a)
        cin >> i.x >> i.y;

    ans.assign(n, -1);
    used.assign(n, 0);
    for (int v = 0; v < n; v++) {
        if (ans[v] != -1)
            continue;
        if (dfs(v, -1))
            mark_ans(v, 1);
        else
            mark_ans(v, 0);
    }

    for (auto i : ans)
        cout << i;
}