#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>
using namespace std;
#define int long long

vector <int> tree;

void update(int v, int l, int r, int ind, int x) {
	tree[v] += x;
	if (r - l == 1) {
		return;
	}
	int m = (r + l) / 2;
	if (ind < m) {
		update(2 * v + 1, l, m, ind, x);
	}
	else {
		update(2 * v + 2, m, r, ind, x);
	}
}

int getsum(int v, int l, int r, int ql, int qr) {
	if (ql <= l && qr >= r) {
		return tree[v];
	}
	if (qr <= l || ql >= r) {
		return 0;
	}
	int m = (r + l) / 2;
	return getsum(2 * v + 1, l, m, ql, qr) + getsum(2 * v + 2, m, r, ql, qr);
}

signed main()
{
	int r, c;
	cin >> r >> c;
	vector <vector <int>> a(r, vector <int> (c));
	tree.resize(4 * r * c);
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++) {
			cin >> a[i][j];
			a[i][j]--;
			update(0, 0, r * c, a[i][j], 1);
		}
	}
	int ans = 0;
	int x = 0, y = 0;
	while (x + y < r + c - 2) {
		int gor = 0, ver = 0;
		for (int i = x; i < r; i++) {
			ver += getsum(0, 0, r * c, 0, a[i][y]);
			update(0, 0, r * c, a[i][y], -1);
		}
		for (int i = x; i < r; i++) {
			update(0, 0, r * c, a[i][y], 1);
		}
		for (int i = y; i < c; i++) {
			gor += getsum(0, 0, r * c, 0, a[x][i]);
			update(0, 0, r * c, a[x][i], -1);
		}
		for (int i = y; i < c; i++) {
			update(0, 0, r * c, a[x][i], 1);
		}
		if (gor < ver || (gor == ver && c - y >= r - x)) {
			ans += gor;
			for (int i = y; i < c; i++) {
				update(0, 0, r * c, a[x][i], -1);
			}
			x++;
		}
		else {
			ans += ver;
			for (int i = x; i < r; i++) {
				update(0, 0, r * c, a[i][y], -1);
			}
			y++;
		}
	}
	cout << ans;
}

