#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>
using namespace std;
#define int long long

vector <pair <int, int>> treemx, treemn;

void update(int v, int l, int r, int ind, int val) {
	if (r - l == 1) {
		treemn[v] = { val, l };
		treemx[v] = { val, l };
		return;
	}
	int m = (r + l) / 2;
	if (ind < m) {
		update(2 * v + 1, l, m, ind, val);
	}
	else {
		update(2 * v + 2, m, r, ind, val);
	}
	treemn[v] = min(treemn[2 * v + 1], treemn[2 * v + 2]);
	treemx[v] = max(treemx[2 * v + 1], treemx[2 * v + 2]);
}

int getmx(int v, int l, int r, int ql, int qr, int val) {
	if (treemx[v].first <= val || ql >= r || qr <= l) {
		return -1;
	}
	if (r - l == 1) {
		return l;
	}
	int m = (r + l) / 2;
	int ret = getmx(2 * v + 1, l, m, ql, qr, val);
	if (ret == -1) {
		return getmx(2 * v + 2, m, r, ql, qr, val);
	}
	else {
		return ret;
	}
}

pair <int, int> rgetmx(int v, int l, int r, int ql, int qr) {
	if (ql <= l && qr >= r) {
		return treemx[v];
	}
	if (qr <= l || ql >= r) {
		return { -1, -1 };
	}
	int m = (r + l) / 2;
	return max(rgetmx(2 * v + 1, l, m, ql, qr), rgetmx(2 * v + 2, m, r, ql, qr));
}

pair <int, int> getmn(int v, int l, int r, int ql, int qr) {
	if (ql <= l && qr >= r) {
		return treemn[v];
	}
	if (qr <= l || ql >= r) {
		return { 1e9, -1 };
	}
	int m = (r + l) / 2;
	return min(getmn(2 * v + 1, l, m, ql, qr), getmn(2 * v + 2, m, r, ql, qr));
}

signed main()
{
	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	treemn.resize(4 * n);
	treemx.resize(4 * n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		update(0, 0, n, i, a[i]);
	}
	for (int i = 0; i < q; i++) {
		int k, ind;
		cin >> k >> ind;
		int l = -1, last = 0;
		for (int j = 0; j < min(ind, k - 1); j++) {
			int r = n - k + j;
			for (int x = l + 1; x < n - k + j; x++) {
				if (a[x] > last) {
					r = x;
					break;
				}
			}
			auto to = getmn(0, 0, n, l + 1, r + 1);
			last = to.first;
			l = to.second;
		}
		if (ind == k) {
			last = rgetmx(0, 0, n, l + 1, n).first;
		}
		cout << last << '\n';
	}
}

