#include <bits/stdc++.h>
#define len(x) (int)x.size()
#define ll long long
#define all(x) x.begin(), x.end()
#define ld long double

using namespace std;

void print(vector<int> &a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<vector<int>> &a) {
    for (auto &x : a) print(x);
}

void print(vector<ll> &a) {
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<vector<ll>> &a) {
    for (auto &x : a) print(x);
}

//#define int ll

struct tree {

    int n;
    vector<int> t;

    tree(int n_) {
        n = n_;
        t.resize(4 * n);
    }

    void upd(int v, int vl, int vr, int ind) {
        if (ind < vl || vr <= ind) return;
        if (vl + 1 == vr) {
            t[v] = 1;
            return;
        }
        int mid = (vl + vr) / 2;
        upd(2 * v + 1, vl, mid, ind);
        upd(2 * v + 2, mid, vr, ind);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    void upd(int ind) {
        upd(0, 0, n, ind);
    }

    int get(int v, int vl, int vr, int ql, int qr) {
        if (qr <= vl || vr <= ql) return 0;
        if (ql <= vl && vr <= qr) return t[v];
        int mid = (vl + vr) / 2;
        return get(2 * v + 1, vl, mid, ql, qr) + get(2 * v + 2, mid, vr, ql, qr);
    }

    int get(int ind) {
        return get(0, 0, n, 0, ind);
    }

};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vector<vector<ll>> costup(n, vector<ll>(m));
    vector<vector<ll>> costl(n, vector<ll>(m));
    {
        vector<tree> curr(n, tree(n * m));
        for (int j = m - 1; j >= 0; --j) {
            for (int i = n - 1; i >= 0; --i) {
                if (j < m - 1) {
                    costup[i][j] = costup[i][j + 1];
                }
                for (int k = n - 1; k >= i; --k) {
                    costup[i][j] += curr[k].get(a[i][j]) + (a[i][j] > a[k][j]);
                }
                for (int k = n - 1; k > i; --k) {
                    costup[i][j] += curr[i].get(0, 0, n * m, a[k][j], n * m);
                }
            }
            for (int i = n - 1; i >= 0; --i) {
                curr[i].upd(a[i][j]);
            }
        }
        for (int i = 0; i < n; ++i) {
            tree cur(n * m);
            for (int j = m - 1; j >= 0; --j) {
                for (int k = n - 1; k >= i; --k) {
                    costl[i][j] += cur.get(a[k][j]);
                    cur.upd(a[k][j]);
                }
            }
        }
    }
     // print(costup);
    // print(costl);
    vector<vector<ll>> dist(n, vector<ll>(m, 1e18));
    dist[n - 1][m - 1] = 0;
    set<pair<ll, pair<int, int>>> st;
    st.insert({0, {n - 1, m - 1}});
    while (len(st)) {
        auto [d, xy] = *st.begin();
        st.erase(st.begin());
        auto [x, y] = xy;
        if (x > 0) {
            if (dist[x - 1][y] > d + costup[x - 1][y]) {
                st.erase({dist[x - 1][y], {x - 1, y}});
                dist[x - 1][y] = d + costup[x - 1][y];
                st.insert({dist[x - 1][y], {x - 1, y}});
            }
        }
        if (y > 0) {
            if (dist[x][y - 1] > d + costl[x][y - 1]) {
                st.erase({dist[x][y - 1], {x, y - 1}});
                dist[x][y - 1] = d + costl[x][y - 1];
                st.insert({dist[x][y - 1], {x, y - 1}});
            }
        }
    }
    cout << dist[0][0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}