#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

struct Node {
    ll val;

    Node() : val(0) {
    }

    Node(ll _val) : val(_val) {
    }
};

Node operator+(Node a, Node b) {
    return Node(a.val + b.val);
}

class segtree {
public:
    segtree(ll N) {
        sz = 1;
        while (sz < N) sz <<= 1;
        n = sz * 2 - 1;
        tree.assign(n, Node());
    }

    ll get(ll l, ll r) {
        return get(0, l, r, 0, sz).val;
    }

    void add(ll i, ll x) {
        add(0, i, x, 0, sz);
    }

private:
    vector<Node> tree;
    ll n;
    ll sz;

    Node get(ll v, ll l, ll r, ll tl, ll tr) {
        if (l <= tl && tr <= r) {
            return tree[v];
        }
        if (l >= tr || r <= tl) {
            return Node();
        }
        ll tm = (tl + tr) / 2;
        return get(2 * v + 1, l, r, tl, tm) + get(2 * v + 2, l, r, tm, tr);
    }

    void add(ll v, ll i, ll x, ll tl, ll tr) {
        if (tr - tl == 1) {
            tree[v].val = x;
            return;
        }
        ll tm = (tl + tr) / 2;
        if (i < tm) {
            add(2 * v + 1, i, x, tl, tm);
        } else {
            add(2 * v + 2, i, x, tm, tr);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }
};

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, m;
    cin >> n >> m;
    vector<vector<ll> > a(n, vector<ll>(m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    ll ans = INF;
    for (ll mask = 0; mask < (1 << (n + m - 1)); ++mask) {
        ll i = 0;
        ll j = 0;
        vector<ll> st;
        for (ll k = 0; k < n + m - 1; ++k) {
            if (j == m || i == n) continue;
            if (mask & (1 << k)) {
                for (ll jj = j; jj < m; ++jj) {
                    st.push_back(a[i][jj]);
                }
                i++;
            } else {
                for (ll ii = i; ii < n; ++ii) {
                    st.push_back(a[ii][j]);
                }
                j++;
            }
        }
        ll res = 0;
        for (ll i = 0; i < st.size(); ++i) {
            for (ll j = i + 1; j < st.size(); ++j) {
                if (st[i] > st[j]) {
                    res++;
                }
            }
        }
        ans = min(res, ans);
    }
    cout << ans;


    return 0;
}
