#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <string>

typedef long long ll;
using namespace std;

struct point {
	ll x, y;
	point() {
		x = 0;
		y = 0;
	}
	point(ll _x, ll _y) {
		x = _x;
		y = _y;
	}
};

ll r;

bool distcheck(point a, point b) {
	return (((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) <= r);
}

bool flag = false;

void dfs(int v, vector<vector<bool>>& g, vector<int>& used, int c) {
	used[v] = c;
	for (int i = 0; i < g.size(); ++i) {
		if (g[v][i]) {
			if (used[i] == c) {
				flag = true;
			} else if (used[i] == -1) {
				dfs(i, g, used, c ^ 1);
			}
		}
	}
}

void dfsc(int v, vector<vector<bool>>& g, vector<int>& c, int col) {
	c[v] = col;
	for (int i = 0; i < g.size(); ++i) {
		if (g[v][i]) {
			if (c[i] == -1) {
				dfsc(i, g, c, col);
			}
		}
	}
}

void solve() {
	int n;
	cin >> n >> r;
	vector<point> arr(n);
	bool all0 = true;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i].x >> arr[i].y;
		if (arr[i].y != 0) return;
	}
	vector<bool> ans(n, false);
	vector<pair<int, int>> srt(n);
	for (int i = 0; i < n; ++i) {
		srt[i] = { arr[i].x, i };
	}
	sort(srt.begin(), srt.end());

	vector<int> c(n, -1);
	int col = 0;
	c[srt[0].second] = 0;
	for (int i = 1; i < n; ++i) {
		if (srt[i].first - srt[i - 1].first <= r) {
			c[srt[i].second] = c[srt[i - 1].second];
		} else {
			c[srt[i].second] = ++col;
		}
	}

	vector<bool> cyc(col + 1, false);
	for (int i = 2; i < n; ++i) {
		if (srt[i].first - srt[i - 2].first <= r) {
			cyc[c[srt[i].second]] = true;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (cyc[c[i]]) {
			ans[i] = true;
		}
	}


	for (int i = 0; i < n; ++i) {
		if (ans[i]) {
			cout << 1;
		} else {
			cout << 0;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
}
/*

4 1
1010
0

*/