#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <random>

typedef long long ll;
using namespace std;

mt19937 gen(12944);

int fr(int a, int b) {
	return uniform_int_distribution<int>(a, b)(gen);
}

struct point {
	ll x, y;
	point() {
		x = 0;
		y = 0;
	}
	point(ll _x, ll _y) {
		x = _x;
		y = _y;
	}
};

ll r;

bool distcheck1(point a, point b) {
	return (((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) <= r);
}

bool distcheck(point& a, point& b) {
	return (((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) <= r);
}

bool flag = false;

void dfs(int v, vector<vector<int>>& g, vector<int>& used, int c) {
	used[v] = c;
	for (int i : g[v]) {
		if (used[i] == c) {
			flag = true;
		} else if (used[i] == -1) {
			dfs(i, g, used, c ^ 1);
		}
	}
}

void dfsc(int v, vector<vector<int>>& g, vector<int>& c, int col) {
	c[v] = col;
	for (int i : g[v]) {
		if (c[i] == -1) {
			dfsc(i, g, c, col);
		}
	}
}

bool compx(point& a, point& b) {
	if (a.x == b.x) return (a.y < b.y);
	return (a.x < b.x);
}

bool compy(point& a, point& b) {
	if (a.y == b.y) return (a.x < b.x);
	return (a.y < b.y);
}

void solve() {
	int n;
	cin >> n >> r;
	r *= r;
	vector<pair<int, int>> checker;
	for (int i = -10; i <= 10; ++i) {
		for (int j = -10; j <= 10; ++j) {
			if (distcheck1(point(), point(i, j)) && i != j) {
				checker.push_back({ i, j });
			}
		}
	}
	vector<point> arr(n);
	map<pair<int, int>, int> ind;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i].x >> arr[i].y;
		ind[{arr[i].x, arr[i].y}] = i;
	}
	vector<vector<int>> g(n);
	/*vector<point> arrx = arr;
	vector<point> arry = arr;
	sort(arrx.begin(), arrx.end(), compx);
	sort(arry.begin(), arry.end(), compy);
	vector<bool> ans(n, false);
	vector<int> indinx(n, -1);
	vector<int> indiny(n, -1);
	for (int i = 0; i < n; ++i) {
		indinx[i] = ind[make_pair(arrx[i].x, arrx[i].y)];
		indiny[i] = ind[make_pair(arry[i].x, arry[i].y)];
	}
	*/

	for (int i = 0; i < n; ++i) {
		for (pair<int, int> j : checker) {
			j.first += arr[i].x;
			j.second += arr[i].y;
			if (ind.find(j) != ind.end()) {
				g[i].push_back(ind[j]);
			}
		}
	}

	vector<int> used(n, -1);
	vector<bool> cyc(n, false);
	for (int i = 0; i < n; ++i) {
		if (used[i] == -1) {
			flag = false;
			dfs(i, g, used, 0);
			if (flag) {
				cyc[i] = true;
			}
		}
	}
	vector<int> c(n, -1);
	int col = 0;
	for (int i = 0; i < n; ++i) {
		if (c[i] == -1) {
			dfsc(i, g, c, col);
			col++;
		}
	}

	vector<bool> cyccol(col, false);
	for (int i = 0; i < n; ++i) {
		cyccol[c[i]] = cyccol[c[i]] || cyc[i];
	}

	for (int i = 0; i < n; ++i) {
		if (cyccol[c[i]]) {
			ans[i] = true;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (ans[i]) {
			cout << 1;
		} else {
			cout << 0;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
}
/*

4 1
1010
0

*/