#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <string>

typedef long long ll;
using namespace std;

struct point {
	ll x, y;
	point() {
		x = 0;
		y = 0;
	}
	point(ll _x, ll _y) {
		x = _x;
		y = _y;
	}
};

ll r;

bool distcheck(point a, point b) {
	return (((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) <= r);
}

bool flag = false;

void dfs(int v, vector<vector<bool>>& g, vector<int>& used, int c) {
	used[v] = c;
	for (int i = 0; i < g.size(); ++i) {
		if (g[v][i]) {
			if (used[i] == c) {
				flag = true;
			} else if (used[i] == -1) {
				dfs(i, g, used, c ^ 1);
			}
		}
	}
}

void dfsc(int v, vector<vector<bool>>& g, vector<int>& c, int col) {
	c[v] = col;
	for (int i = 0; i < g.size(); ++i) {
		if (g[v][i]) {
			if (c[i] == -1) {
				dfsc(i, g, c, col);
			}
		}
	}
}

void solve() {
	int n;
	cin >> n >> r;
	r *= r;
	vector<point> arr(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i].x >> arr[i].y;
	}
	vector<bool> ans(n, false);
	vector<vector<bool>> g(n, vector<bool>(n, false));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i != j && distcheck(arr[i], arr[j])) {
				g[i][j] = true;
			}
		}
	}

	vector<int> used(n, -1);
	vector<bool> cyc(n, false);
	for (int i = 0; i < n; ++i) {
		if (used[i] == -1) {
			flag = false;
			dfs(i, g, used, 0);
			if (flag) {
				cyc[i] = true;
			}
		}
	}
	vector<int> c(n, -1);
	int col = 0;
	for (int i = 0; i < n; ++i) {
		if (c[i] == -1) {
			dfsc(i, g, c, col);
			col++;
		}
	}

	vector<bool> cyccol(col, false);
	for (int i = 0; i < n; ++i) {
		cyccol[c[i]] = cyccol[c[i]] || cyc[i];
	}

	for (int i = 0; i < n; ++i) {
		if (cyccol[c[i]]) {
			ans[i] = true;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (ans[i]) {
			cout << 1;
		} else {
			cout << 0;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
}
/*

4 1
1010
0

*/