#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <string>
#include <random>

typedef long long ll;
using namespace std;

mt19937 gen(12945);

int fr(int a, int b) {
	return uniform_int_distribution<int>(a, b)(gen);
}

int ts;

void sett(int v, vector<int>& t, int l, int r, int ind) {
	if (ind > r || l > ind) {
		return;
	}
	if (l == r) {
		t[v]++;
		return;
	}
	sett(v * 2, t, l, (r + l) / 2, ind);
	sett(v * 2 + 1, t, (r + l) / 2 + 1, r, ind);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

void unsett(int v, vector<int>& t, int l, int r, int ind) {
	if (ind > r || l > ind) {
		return;
	}
	if (l == r) {
		t[v]--;
		return;
	}
	unsett(v * 2, t, l, (r + l) / 2, ind);
	unsett(v * 2 + 1, t, (r + l) / 2 + 1, r, ind);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

int gett(int v, vector<int>& t, int l, int r, int q, int w) {
	if (q <= l && r <= w) {
		return t[v];
	}
	if (q > r || w < l) return 0;
	return (gett(v * 2, t, l, (r + l) / 2, q, w) + gett(v * 2 + 1, t, (r + l) / 2 + 1, r, q, w));
}

ll f(vector<int>& arr, vector<int>& t) {
	ll ans = 0;
	for (int i = 0; i < arr.size(); ++i) {
		ans += gett(1, t, 0, ts, arr[i] + 1, ts);
		sett(1, t, 0, ts, arr[i]);
	}
	for (int i = 0; i < arr.size(); ++i) {
		unsett(1, t, 0, ts, arr[i]);
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	ts = n * m;
	vector<vector<int>> arr(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> arr[i][j];
			arr[i][j]--;
		}
	}
	vector<vector<ll>> dp(n, vector<ll>(m, 2100000000000000000));
	vector<vector<int>> st(m, vector<int>(ts * 4 + 4, 0));
	{
		for (int i = 1; i < m; ++i) {
			st[i] = st[i - 1];
			for (int j = 0; j < n; ++j) {
				sett(1, st[i], 0, ts, arr[j][i - 1]);
			}
		}
	}
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (i > 0) {
				vector<int> na;
				for (int q = j; q < m; ++q) {
					na.push_back(arr[i - 1][q]);
				}
				dp[i][j] = min(dp[i][j], dp[i - 1][j] + f(na, st[j]));
				for (int q = j; q < m; ++q) {
					sett(1, st[j], 0, ts, arr[i - 1][q]);
				}
			}
			if (j > 0) {
				vector<int> na;
				for (int q = i; q < n; ++q) {
					na.push_back(arr[q][j - 1]);
				}
				dp[i][j] = min(dp[i][j], dp[i][j - 1] + f(na, st[j - 1]));
			}
		}
	}
	vector<int> na = { arr[n - 1][m - 1] };
	cout << dp[n - 1][m - 1] + f(na, st[m - 1]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
}
/*

2 2
1 4
3 2

*/