#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int inf = 1e9;
struct SegTree {
    vector<ll>tree;
    void update(int i, int l, int r, int ind, ll add) {
        if (ind < l || ind >= r) return;
        if (l + 1 == r) {
            tree[i] += add; return;
        }
        update(2 * i + 1, l, (l + r) / 2, ind, add);
        update(2 * i + 2, (l + r) / 2, r, ind, add);
        tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
    }
    ll get(int i, int l, int r, int tl, int tr) {
        if (tl >= tr) return 0;
        if (l >= tl && r <= tr) return tree[i];
        if (l >= tr || r <= tl) return 0;
        return get(2 * i + 1, l, (l + r) / 2, tl, tr) + get(2 * i + 2, (l + r) / 2, r, tl, tr);
    }
};
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int r, c; cin >> r >> c;
    vector<vector<int>>a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j]; a[i][j]--;
        }
    }
    int n = r * c;
    SegTree t; t.tree.resize(4 * n);
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            t.update(0, 0, n, a[i][j], 1);
        }
    }
    vector<vector<ll>>pref(r, vector<ll>(c)); vector<vector<ll>>suf(r, vector<ll>(c));
    for (int i = r - 1; i >= 0; i--) {
        ll num = 0;
        for (int j = 0; j < c; j++) {
            t.update(0, 0, n, a[i][j], -1);
        }
        for (int j = c - 1; j >= 0; j--) {
            num += t.get(0, 0, n, a[i][j], n);
            pref[i][j] = num;
        }
    }
    for (int j = 0; j < c; j++) {
        t.tree.assign(4 * n, 0);
        for (int i = r - 1; i >= 0; i--) {
            for (int k = 0; k < j; k++) {
                t.update(0, 0, n, a[i][k], 1);
            }
            ll cur = 0;
            for (int k = c - 1; k >= j; k--) {
                cur += t.get(0, 0, n, a[i][k], n);
            }
            pref[i][j] += cur;
        }
    }
    t.tree.assign(4 * n, 0);
    for (int i = 0; i < c; i++) {
        int num = 0;
        for (int j = r - 1; j >= 0; j--) {
            num += t.get(0, 0, n, a[j][i], n);
            suf[j][i] = num;
        }
        for (int j = 0; j < r; j++) {
            t.update(0, 0, n, a[j][i], 1);
        }
    }
    for (int i = 0; i < r; i++) {
        t.tree.assign(4 * n, 0);
        for (int j = c - 1; j >= 0; j--) {
            for (int k = 0; k < i; k++) t.update(0, 0, n, a[k][j], 1);
            int num = 0;
            for (int k = r - 1; k >= i; k--) {
                num += t.get(0, 0, n, a[k][j], n);
            }
            suf[i][j] += num;
        }
    }
    vector<vector<int>>dp(r + 1, vector<int>(c + 1, inf)); dp[0][0] = 0;
    for (int sum = 1; sum < r + c; sum++) {
        for (int x = 0; x <= min(sum, r); x++) {
            int y = sum - x; if (y > c) continue;
            t.tree.assign(4 * n, 0);
            if (x == 0) {
                int ans = suf[x][y - 1];
                for (int j = 0; j < r; j++) {
                    ans += t.get(0, 0, n, a[j][y - 1], n);
                    t.update(0, 0, n, a[j][y - 1], 1);
                }
                dp[x][y] = min(dp[x][y], dp[x][y - 1] + ans);
            }else if (y == 0){
                int ans = pref[x - 1][y];
                for (int j = 0; j < c; j++) {
                    ans += t.get(0, 0, n, a[x - 1][j], n);
                    t.update(0, 0, n, a[x - 1][j], 1);
                }
                dp[x][y] = min(dp[x][y], dp[x - 1][y] + ans);
            }else {
                if (x != r) {
                    int ans = suf[x][y - 1];
                    for (int j = x; j < r; j++) {
                        ans += t.get(0, 0, n, a[j][y - 1], n);
                        t.update(0, 0, n, a[j][y - 1], 1);
                    }
                    dp[x][y] = min(dp[x][y], dp[x][y - 1] + ans);
                }
                if (y != c) {
                    t.tree.assign(4 * n, 0);
                    int ans = pref[x - 1][y];
                    for (int j = y; j < c; j++) {
                        ans += t.get(0, 0, n, a[x - 1][j], n);
                        t.update(0, 0, n, a[x - 1][j], 1);
                    }
                    dp[x][y] = min(dp[x][y], dp[x - 1][y] + ans);
                }
            }
        }
    }
    int ans = 1e9;
    for (int i = 0; i <= r; i++) {
        ans = min(ans, dp[i][c]);
    }
    for (int i = 0; i <= c; i++) {
        ans = min(ans, dp[r][i]);
    }
    cout << ans;
}