#include <bits/stdc++.h>
  
using namespace std;

#define int long long
  
vector<vector<int>> g;
  
struct point{
    int x, y;
};
  
vector<point> points;
  
bool comp(int a, int b){
    return points[a].x < points[b].x;
}
  
bool check(int a, int b, int r){
    long long dist = 1ll * (points[a].x - points[b].x) * (points[a].x - points[b].x)
    + 1ll * (points[a].y - points[b].y) * (points[a].y - points[b].y);
    return dist <= 1ll * r * r;
}
  
int n;
  
vector<int> snm;
vector<int> rnk;
vector<bool> good;
  
unordered_set<long long> edges;
  
bool is_present(int v, int u){
    if(v > u) swap(v, u);
    long long hash = v * n + u;
    return edges.find(hash) != edges.end();
}
  
void add(int v, int u){
    if(v > u) swap(v, u);
    long long hash = v * n + u;
    edges.insert(hash);
}
  
int get(int v){
    if(snm[v] == -1){
        return v;
    }
    snm[v] = get(snm[v]);
    return snm[v];
}
  
void connect(int v, int u){
    v = get(v);
    u = get(u);
    if(u == v) return;
    if(rnk[v] < rnk[u]) swap(v, u);
    if(rnk[v] == rnk[u]) rnk[v]++;
    snm[u] = v;
}
  
bool is_good(int v){
    v = get(v);
    return good[v];
}
void setgood(int v){
    v = get(v);
    good[v] = true;
}
  
vector<int> inds;
  
bool comp2(int a, int b){
    return points[a].y < points[b].y;
}
  
int D;
  
void conquire(int l, int r){
    if(r - l == 1){
        return;
    }
    int m = l + (r - l) / 2;
    conquire(l, m);
    conquire(m, r);
  
    vector<int> leftGran, rightGran;
  
    for(int i = l; i < m; i++){
        if(points[inds[i]].x + D >= points[inds[m]].x){
            leftGran.push_back(inds[i]);
        }
    }
    for(int i = m; i < r; i++){
        if(points[inds[i]].x - D <= points[inds[m]].x){
            rightGran.push_back(inds[i]);
        }
    }
    sort(leftGran.begin(), leftGran.end(), comp2);
    sort(rightGran.begin(), rightGran.end(), comp2);
    vector<int> st(leftGran.size() + rightGran.size());
    merge(leftGran.begin(), leftGran.end(),
    rightGran.begin(), rightGran.end(), st.begin(), comp2);
  
    int indl = 0, indr = 0;
    for(int i = 0; i < st.size(); i++){
        while(points[st[indl]].y + D < points[st[i]].y){
            indl++;
        }
        while(indr < st.size() && points[st[indr]].y - D <= points[st[i]].y){
            indr++;
        }
        if(!is_good(st[i]))
        for(int j = indl; j < indr; j++){
            if(i == j) continue;
            if(!check(st[i], st[j], D)) continue;
            if(is_present(st[i], st[j])) continue;
  
            add(st[i], st[j]);
              
            g[st[i]].push_back(st[j]);
            g[st[j]].push_back(st[i]);
            connect(st[i], st[j]);
            if(g[st[i]].size() >= 6){
                setgood(st[i]);
                break;
            }
        }
    }
      
}
  
vector<int> clr;
bool dfs(int v, int c){
    clr[v] = c;
    for(int u : g[v]){
        if(clr[u] == -1){
            if(dfs(u, 1 - c)) return true;
        }else{
            if(clr[u] == c) {
                return true;
            }
        }
    }
    return false;
}
  
void solve(){
    cin >> n >> D;
    points.resize(n);
  
    for(int i = 0; i < n; i++){
        cin >> points[i].x >> points[i].y;
    }
  
    inds.resize(n);
    iota(inds.begin(), inds.end(), 0);
  
    sort(inds.begin(), inds.end(), comp);
  
    snm.assign(n, -1);
    rnk.assign(n, 0);
    good.assign(n, false);
    g.assign(n, vector<int>());
  
    conquire(0, n);
  
    // for(auto a : good){
    //     cout << a;
    // }
    // cout << '\n';
  
    // for(auto a : snm){
    //     cout << a << ' ';
    // }
    // cout << '\n';
  
    clr.assign(n, -1);
    for(int i = 0; i < n; i++){
        if(clr[i] == -1){
            if(dfs(i, 0)){
                setgood(i);
            }
        }
    }
  
    for(int i = 0; i < n; i++){
        cout << is_good(i);
    }
    cout << '\n';
}
  
signed main(){
    #ifdef _LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    freopen("C:\\work\\output.txt", "w", stdout);
    #endif
    cin.tie(0);
    cout.sync_with_stdio(false);
  
    int t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}