#include <bits/stdc++.h>
 
using namespace std;

vector<pair<int, int>> segTree;

pair<int, int> combine(pair<int, int> a, pair<int, int> b){
    return {max(a.first, b.first), min(a.second, b.second)};
}

void build(int l, int r, int v, vector<int>& arr){
    if(r - l == 1){
        segTree[v] = {arr[l], arr[l]};
        return;
    }
    int m = l + (r - l) / 2;
    build(l, m, v * 2 + 1, arr);
    build(m, r, v * 2 + 2, arr);

    segTree[v] = combine(segTree[v * 2 + 1], segTree[v * 2 + 2]);
}

pair<int, int> get(int l1, int r1, int l, int r, int v){
    if(r1 <= l || r <= l1){
        return {0, 1e9};
    }else if(l1 <= l && r <= r1){
        return segTree[v];
    }
    int m = l + (r - l) / 2;
    return combine(get(l1, r1, l, m, v * 2 + 1), get(l1, r1, m, r, v * 2 + 2));
}
 
void solve(){
    int n, q;
    cin >> n >> q;
    vector<int> arr(n);
    vector<int> rearr(n);
    for(int i = 0; i < n; i++){
        cin >> arr[i];
        arr[i]--;
        rearr[arr[i]] = i;
    }
    vector<int> nxt(n);
    vector<int> st;
    for(int i = n - 1; i >= 0; i--){
        while(!st.empty() && arr[st.back()] < arr[i]){
            st.pop_back();
        }
        if(st.empty()){
            nxt[i] = n;
        }else{
            nxt[i] = st.back();
        }
        st.push_back(i);
    }

    segTree.resize(n * 4);

    build(0, n, 0, arr);

    vector<vector<int>> anses(n);

    for(int i = 0; i < n; i++){
        anses[i].resize(i + 1);
        anses[i][0] = 0;
        for(int j = 1; j < i; j++){
            int l = anses[i][j - 1];
            int r = min(nxt[l] + 1, n - i + j);
            l++;
            int val = get(l, r, 0, n, 0).second;
            int ind = rearr[val];
            anses[i][j] = ind;
        }
        {

            int l;
            if(i > 0)
                l = min(n - 1, nxt[anses[i][i - 1]]);
            else
                l = 0;
            int r = n;
            int val = get(l, r, 0, n, 0).first;
            int ind = rearr[val];
            anses[i][i] = ind;
        }
    }

    for(int i = 0; i < q; i++){
        int k, ind;
        cin >> k >> ind;
        k--; ind--;
        cout << arr[anses[k][ind]] + 1 << '\n';
    }
}
 
signed main(){
    #ifdef _LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    freopen("C:\\work\\output.txt", "w", stdout);
    #endif
    cin.tie(0);
    cout.sync_with_stdio(false);
 
    int t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}