#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll,ll>>

ll INF = 1e12;

struct fenwick_tree {
    vi f;
    ll n;

    fenwick_tree(ll _n) {
        n = _n;
        f.resize(n + 1);
    }

    void upd(ll pos, ll x) {
        for (ll i = pos; i <= n; i += i & -i) {
            f[i] += x;
        }
    }

    ll get(ll pos) {
        ll s = 0;
        for (ll i = pos; i > 0; i -= i & -i) {
            s += f[i];
        }
        return s;
    }

    ll sum(ll l, ll r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vii a(n, vi(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    ll sz = n + m;
    ll sz2 = n * m;
    ll mn = INF;
    fenwick_tree t(sz2);
    ll inv = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a[i][j] < sz2) {
                inv += t.sum(a[i][j] + 1, sz2);
            }
            t.upd(a[i][j], 1);
        }
    }
    mn = min(mn, inv);
    cout << mn;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
