#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define vip vector<pair<ll,ll>>

ll INF = 1e12;

struct fenwick_tree {
    vi f;
    ll n;

    fenwick_tree(ll _n) {
        n = _n;
        f.resize(n + 1);
    }

    void upd(ll pos, ll x) {
        for (ll i = pos; i <= n; i += i & -i) {
            f[i] += x;
        }
    }

    ll get(ll pos) {
        ll s = 0;
        for (ll i = pos; i > 0; i -= i & -i) {
            s += f[i];
        }
        return s;
    }

    ll sum(ll l, ll r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vii a(n, vi(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    ll sz = n + m;
    ll sz2 = n * m;
    ll mn = INF;
    fenwick_tree t(sz2);
    ll inv = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a[i][j] < sz2) {
                inv += t.sum(a[i][j] + 1, sz2);
            }
            t.upd(a[i][j], 1);
        }
    }
    mn = min(mn, inv);
    fenwick_tree t2(sz2);
    fenwick_tree t3(sz2);
    vi suf(m + 1);
    inv = 0;
    for (ll i = m - 1; i >= 0; i--) {
        if (a[0][i] > 1) {
            inv += t3.sum(1, a[0][i] - 1) + t2.sum(1, a[0][i] - 1);
        }
        if (a[1][i] < sz2) {
            inv += t2.sum(a[1][i] + 1, sz2);
        }
        if (a[1][i] > 1) {
            inv += t3.sum(1, a[1][i] - 1);
        }
        inv += a[0][i] > a[1][i];
        t2.upd(a[0][i], 1);
        t3.upd(a[1][i], 1);
        suf[i] = inv;
    }
    inv = 0;
    ll inv2 = 0;
    fenwick_tree t1(sz2);
    for (ll i = 0; i < m; i++) {
        if (a[0][i] < sz2) {
            inv += t1.sum(a[0][i] + 1, sz2);
        }
        t1.upd(a[0][i], 1);
        if (a[1][i] < sz2) {
            inv += t1.sum(a[1][i] + 1, sz2);
        }
        t1.upd(a[1][i], 1);
        t.upd(a[0][i], -1);
        t.upd(a[1][i], -1);
        if (a[0][i] > 1) {
            inv2 += t.sum(1, a[0][i] - 1);
        }
        if (a[1][i] > 1) {
            inv2 += t.sum(1, a[1][i] - 1);
        }
        mn = min(mn, inv + inv2 + suf[i + 1]);
    }
    cout << mn;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
