#include <bits/stdc++.h>

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();

    return 0;
}

class Elem {
 public:
    int id, cnt;

    bool operator < (const Elem& other) const {
        if (cnt == other.cnt) return id < other.id;
        return cnt > other.cnt;
    }
};

std::string s;

Elem calc(int id) {
    int n = (int) s.size();

    int cnt = 0;
    if (id == 1 && s[id - 1] == '1') {
        cnt += 1;
    } else if (id > 1 && s[id - 1] == '1' && s[id - 2] == '0') {
        cnt += 1;
    }

    if (id == n - 2 && s[n - 1] == '1') {
        cnt += 1;
    } else if (id < n - 2 && s[id + 1] == '1' && s[id + 2] == '0') {
        cnt += 1;
    }

    return {id, cnt};
}

void solve() {
    int n, q;
    std::cin >> n >> q;

    std::cin >> s;

    std::vector <int> res(n + 1, 0);
    std::set <Elem> elems;

    for (int i = 0; i < n; ++i) {
        if (s[i] != '1') {
            elems.insert(calc(i));
        }
    }

    for (int i = 0; i < n; ++i) {
        if (i && s[i] == s[i - 1] && s[i] == '1') {
            res[0] += 1;
        }

        if ((i == 0 || s[i - 1] == '0') && (s[i] == '1' && i + 1 < n && s[i + 1] == '1')) {
            res[0] += 1;
        }
    }

    int prevCnt = 0;
    while (!elems.empty()) {
        auto it = elems.begin();
        auto [id, cnt] = *it;

        elems.erase(it);

        res[prevCnt + 1] = res[prevCnt];
        if (cnt != 0) {
            res[prevCnt + 1] += 1 + cnt;
        } else {
            if ((id > 0 && s[id - 1] == '1') || (id + 1 < n && s[id + 1] == '1')) {
                res[prevCnt + 1] += 1;
            }
        }
        ++prevCnt;

        if (0 <= id - 2 && id - 2 < n && s[id - 2] == '0') {
            Elem cur = calc(id - 2);
            elems.erase(cur);
            s[id] = '1';
            cur = calc(id - 2);
            elems.insert(cur);
            s[id] = '0';
        }

        if (0 <= id - 1 && id - 1 < n && s[id - 1] == '0') {
            Elem cur = calc(id - 1);
            elems.erase(cur);
            s[id] = '1';
            cur = calc(id - 1);
            elems.insert(cur);
            s[id] = '0';
        }

        if (0 <= id - 1 && id - 1 < n && s[id - 1] == '0') {
            Elem cur = calc(id - 1);
            elems.erase(cur);
            s[id] = '1';
            cur = calc(id - 1);
            elems.insert(cur);
            s[id] = '0';
        }

        if (0 <= id + 1 && id + 1 < n && s[id + 1] == '0') {
            Elem cur = calc(id + 1);
            elems.erase(cur);
            s[id] = '1';
            cur = calc(id + 1);
            elems.insert(cur);
            s[id] = '0';
        }

        if (0 <= id + 2 && id + 2 < n && s[id + 2] == '0') {
            Elem cur = calc(id + 2);
            elems.erase(cur);
            s[id] = '1';
            cur = calc(id + 2);
            elems.insert(cur);
            s[id] = '0';
        }

        s[id] = '1';
    }

    for (int i = 0; i < q; ++i) {
        int k;
        std::cin >> k;

        std::cout << res[k] << '\n';
    }
}