#include <bits/stdc++.h>

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
            freopen("input.txt", "r", stdin);
            freopen("output.txt", "w", stdout);
    #endif

    solve();

    return 0;
}

class SegTree {
 private:
    std::vector <int> body;

 public:
    SegTree(int n) {
        body.resize(4 * n, 0);
    }

    inline void add(int curV, int l, int r, int id) {
        if (id < l || r <= id) return;

        if (l + 1 == r) {
            body[curV] = 1;
            return;
        }

        int m = (l + r) / 2;
        add(curV * 2 + 1, l, m, id);
        add(curV * 2 + 2, m, r, id);

        body[curV] = body[curV * 2 + 1] + body[curV * 2 + 2];
    }

    inline int get(int curV, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return 0;

        if (ql <= l && r <= qr) return body[curV];

        int m = (l + r) / 2;
        return get(curV * 2 + 1, l, m, ql, qr) + get(curV * 2 + 2, m, r, ql, qr);
    }
};

void solve() {
    int r, c;
    std::cin >> r >> c;

    std::vector <std::vector <int>> table(r, std::vector <int> (c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            std::cin >> table[i][j];
        }
    }

    long long res = INT_MAX;

    for (int i = 0; i < (1 << r + c); ++i) {
        int ri = 0, ci = 0;
        std::vector <int> b;
        for (int j = 0; j < r + c; ++j) {
            if ((i >> j) & 1) {
                for (int x = ri; x < r; ++x) {
                    b.push_back(table[x][ci]);
                }
                ++ci;
                if (ci == c) break;
            } else {
                for (int y = ci; y < c; ++y) {
                    b.push_back(table[ri][y]);
                }
                ++ri;
                if (ri == r) break;
            }
        }

        SegTree sys(r * c + 1);

        long long curRes = 0;
        for (auto i : b) {
            curRes += sys.get(0, 0, r * c + 1, i + 1, r * c + 1);
            sys.add(0, 0, r * c + 1, i);
        }

        res = std::min(res, curRes);
    }

    std::cout << res;
}
