#include <bits/stdc++.h>

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    solve();

    return 0;
}

class SegTree {
    class Elem {
     public:
        int min, max;
    };
 private:
    std::vector <Elem> body;

    inline void build(int curV, int l, int r, std::vector <int>& array) {
        if (l + 1 == r) {
            body[curV] = {array[l], array[l]};
            return;
        }

        int m = (l + r) / 2;
        build(curV * 2 + 1, l, m, array);
        build(curV * 2 + 2, m, r, array);

        auto [a, b] = body[curV * 2 + 1];
        auto [c, d] = body[curV * 2 + 2];

        body[curV] = {std::min(a, c), std::min(b, d)};
    }

 public:
    SegTree(std::vector <int>& array) {
        body.resize(4 * (int) array.size());
        build(0, 0, (int) array.size(), array);
    }

    inline Elem get(int curV, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return {INT_MAX, INT_MIN};

        if (ql <= l && r <= qr) return body[curV];

        int m = (l + r) / 2;
        auto [a, b] = get(curV * 2 + 1, l, m, ql, qr);
        auto [c, d] = get(curV * 2 + 2, m, r, ql, qr);

        return {std::min(a, c), std::min(b, d)};
    }
};

void solve() {
    int n, q;
    std::cin >> n >> q;

    std::vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }

    int f = 0;
    while (f + 1 < n - 1 && a[f + 1] <= a[0]) {
        ++f;
    }

    std::vector <int> res = {a[0]};
    int sec = 0;
    for (int i = f + 1; f < n; ++f) {
        sec = std::max(sec, a[i]);
    }
    res.push_back(sec);

    while (q--) {
        int k, i;
        std::cin >> k >> i;

        std::cout << res[i - 1] << '\n';
    }
}
