#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

vector<ll> build(ll n) {
    ll layers = ceil(log2(n));
    layers++;
    vector<ll> t(1 << layers, 0);
    return t;
}

void add(ll v, ll x, vector<ll> &t) {
    v += t.size() / 2;
    for (; v > 0; v >>= 1) {
        t[v] += x;
    }
}

ll get(ll l, ll r, vector<ll> &t) {
    ll res = 0;
    for (l += t.size() / 2, r += t.size() / 2; r > l; r >>= 1, l >>= 1) {
        if (l & 1) {
            res += t[l++];
        }
        if (r & 1) {
            res += t[--r]   ;
        }
    }
    return res;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll r, c;    
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll> (c));
    ll res1 = 0;
    ordered_set<ll> cur1;
    ll cursz = 0;
    for (auto &i : a) {
        for (auto &j : i) {
            cin >> j;
            res1 += 1LL * (cursz - cur1.order_of_key(j));
            cur1.insert(j);
            cursz++;
        }
    }
    if (r == 1) {
        cout << res1;
        return 0;
    }
    vector<ll> suf(c + 1, 0);
    vector<ll> up = build(r * c), down = build(r * c);
    for (ll i = c - 1; i >= 0; i--) {
        suf[i] = suf[i + 1];
        suf[i] += 1LL * get(0, a[0][i], up);
        suf[i] += 1LL * get(0, a[0][i], down);
        suf[i] += 1LL * get(0, a[1][i], down);
        suf[i] += (a[0][i] > a[1][i]);
        add(a[0][i] - 1, 1, up);
        add(a[1][i] - 1, 1, down);
    }
    up = build(r * c);
    down = build(r * c);
    for (auto &i : a) {
        for (auto &j : i) {
            add(j - 1, 1, down);
        }
    }
    ll res = 1LL * suf[0];
    add(a[0][0] - 1, -1, down);
    add(a[1][0] - 1, -1, down);
    ll tmp = 0;
    ll upsz = 0;
    ll pref = 0;
    for (ll i = 1; i <= c; i++) {
        pref += 1LL * (upsz - get(0, a[0][i - 1], up));
        add(a[0][i - 1] - 1, 1, down);
        upsz++;
        pref += 1LL * (upsz - get(0, a[1][i - 1], up));
        add(a[1][i - 1] - 1, 1, down);
        upsz++;
        tmp += get(0, a[0][i - 1], down) + get(0, a[1][i - 1], down);
        res = min(res, 1LL * (pref + suf[i] + tmp));
        if (i < c) {
            tmp -= (upsz - get(0, a[0][i], up)) + (upsz - get(0, a[1][i], up));
            add(a[0][i] - 1, -1, down);
            add(a[1][i] - 1, -1, down);
        }
    }
    cout << res;
}