#include <bits/stdc++.h>
 
using namespace std;
 
 
struct node {
    int mx, pos;
    node() : mx(0), pos(0) {}
    node(int m, int p) : mx(m), pos(p) {}
};
 
struct segtree {
    int n;
    node merge(node l, node r) {
        if(l.mx > r.mx) {
            return l;
        } else {
            return r;
        }
    }
    vector<node> t;
    segtree(int _n) {
        n = _n;
        t.resize(n*4);
    }
    void update(int v, int tl, int tr, int pos, int val) {
        if(tl == tr) {
            t[v] = node(val, tl);
            return;
        }
        int tm = (tl + tr) / 2;
        if(pos <= tm) {
            update(v*2,tl,tm,pos,val);
        } else {
            update(v*2+1,tm+1, tr,pos,val);
        }
        t[v] = merge(t[v*2], t[v*2+1]);
    }
    node query() {
        return t[1];
    }
};
 
int check(string &s, vector<int> &good, int i) {    
    int p = 0;
    if(s[i] == '0') {
        if((i != 0 && s[i-1] == '1') || (i != good.size() - 1 && s[i+1] == '1')) {
            p++;
            if(i != 0 && s[i - 1] == '1' && !good[i-1]) {
                p++;
            } 
            if(i != good.size() - 1 && s[i + 1] == '1' && !good[i + 1]) {
                p++;
            } 
        }
         
    }
    return p;
}
 
vector<int> solve(string& s) {
    int n = s.length();
    vector<int> good(n);
    vector<int> ans(n+1);
    int cur = 0;
    for(int i = 0; i < n; ++i) {
        if(s[i] == '1') {
            cur++;
        } else {
            if(cur >= 2) {
                for(int j = i - 1; j >= i-cur; --j) {
                    good[j] = 1;
                }
                ans[0] += cur;
            }
            cur = 0;
        }
    }
    vector<int> xx(n);
    segtree st(n);
    for(int i = 0; i < n; ++i) {
        xx[i] = check(s, good, i);
        st.update(1,0,n-1,i,xx[i]);
    }
    int pos = 0;
    for(int i = 1; i <= n; ++i) {
        ans[i] = ans[i-1];
        node qq = st.query();
        s[qq.pos] = '1';
        ans[i] += qq.mx;
        if(qq.mx != 0) {
            good[qq.pos] = 1;
            if(qq.pos != 0 && s[qq.pos - 1] == '1') {
                good[qq.pos - 1] = 1;
            }
            if(qq.pos != n-1 && s[qq.pos + 1] == '1') {
                good[qq.pos + 1] = 1;
            }
            for(int j = qq.pos-2; j <= qq.pos+2; ++j) {
                if(j >= 0 && j <= n-1) {
                    xx[j] = check(s,good,j);
                    st.update(1,0,n-1,j,xx[j]);
                }
            }
        }
    }
    return ans;
}
 
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<int> a(q);
    for(int i = 0; i < q; ++i) {
        cin >> a[i];
    }
    vector<int> ans = solve(s);
    for(int i = 0; i < q; ++i) {
        cout << ans[a[i]] << '\n';
    }
    return 0;
}