#include <bits/stdc++.h>
  
using namespace std;

 
struct node {
    int64_t sum;
    node() : sum(0) {}
    node(int64_t m) : sum(m) {}
};
 
struct segtree {
    int64_t n;
    node merge(node l, node r) {
        node res;
        res.sum = l.sum + r.sum;
        return res;
    }
    vector<node> t;
    segtree(int64_t _n) {
        n = _n;
        t.resize(n*4);
    }
    void update(int64_t v, int64_t tl, int64_t tr, int64_t pos, int64_t val) {
        if(tl == tr) {
            t[v].sum++;
            return;
        }
        int64_t tm = (tl + tr) / 2;
        if(pos <= tm) {
            update(v*2,tl,tm,pos,val);
        } else {
            update(v*2+1,tm+1, tr,pos,val);
        }
        t[v] = merge(t[v*2], t[v*2+1]);
    }
    node query(int64_t v, int64_t tl, int64_t tr, int64_t l, int64_t r) {
       if(l > r) {
            return node();
       }
       if(l == tl && r == tr) {
            return t[v];
       }
       int64_t tm = (tl + tr) / 2;
       return merge(query(v * 2, tl, tm, l, min(r, tm)), query(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int64_t r,c;
    cin >> r >> c;
    vector<vector<int64_t>> a(r,vector<int64_t> (c));
    for(int64_t i = 0; i < r; ++i) {
        for(int64_t j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    vector<int64_t> b;
    int posr = 0;
    int posc = 0;
    while(posr != r || posc != c) {
        if(a[posr][c-1] < a[r-1][posc]) {
            for(int i = posc; i < r; ++i) {
                b.push_back(a[posr][i]);
            }
            ++posr;
        } else {
            for(int i = posr; i < r; ++i) {
                b.push_back(a[i][posc]);
                posc++;
            }
        }
    }
    int64_t res = 0;
    segtree st(r*c+5);
    for(int64_t i = 0; i < c; ++i) {
        res += st.query(1,0,r*c+4, b[i] + 1, r*c+4).sum;
        st.update(1,0,r*c+4,b[i], 1);
    }
    cout << res << '\n';
    return 0;
}