#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define ff first
#define ss second

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

constexpr ll MAXN = 1e5 + 3;

vector<ll> g[MAXN];
ll col[MAXN], bad[MAXN];
pll p[MAXN];

bool dfs1(ll v, ll c) {
    col[v] = c;
    for (ll child : g[v]) {
        if (col[child] == c) {
            bad[v] = true;
            return false;
        }
        if (col[child] == 0) {
            if (!dfs1(child, 3 - c)) {
                return false;
            }
        }
    }
    return true;
}

void dfs2(ll v) {
    bad[v] = true;
    for (ll child : g[v]) {
        if (!bad[child]) {
            dfs2(child);
        }
    }
}

struct hashf {
    ll operator()(pll p) const {
        hash<ll> h;
        return h(p.ff) ^ h(p.ss);
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, r;
    cin >> n >> r;
    unordered_map<pll, ll, hashf> ind;
    for (ll i = 0; i < n; ++i) {
        cin >> p[i].ff >> p[i].ss;
        ind[p[i]] = i;
    }
    for (ll i = 0; i < n; ++i) {
        for (ll dx = -r; dx <= r; ++dx) {
            for (ll dy = 0; dy <= r; ++dy) {
                if (dx == 0 && dy == 0) {
                    continue;
                }
                if (dx * dx + dy * dy > r * r) {
                    continue;
                }
                if (ind.count(make_pair(p[i].ff + dx, p[i].ss + dy))) {
                    ll j = ind[make_pair(p[i].ff + dx, p[i].ss + dy)];
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (!col[i]) {
            dfs1(i, 1);
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (bad[i]) {
            dfs2(i);
        }
    }
    for (ll i = 0; i < n; ++i) {
        cout << (bad[i] ? 1 : 0);
    }
}
