#include <bits/stdc++.h>
using namespace std;
#define int long long
constexpr int MAXN = 1e5, k = 100;
vector<int> g[MAXN];
int used[MAXN], ans[MAXN], depth[MAXN];

bool has_cycle(int u) {
    used[u] = 1;
    for (int v: g[u]) {
        if (used[v] == 0) {
            depth[v] = depth[u] + 1;
            if (has_cycle(v)) {
                return true;
            }
        } else if (used[v] == 1) {
            if (abs(depth[u] - depth[v]) > 1 && abs(depth[u] - depth[v]) % 2 == 0) {
                return true;
            }
        }
    }
    used[u] = 2;
    return false;
}

void color(int u) {
    used[u] = 3;
    ans[u] = 1;
    for (int v: g[u]) {
        if (used[v] != 3) {
            color(v);
        }
    }
}

int dist(int x1, int y1, int x2, int y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, r;
    cin >> n >> r;
    vector<pair<int, int> > A(n);
    unordered_map<int, unordered_map<int, vector<int> > > D;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        A[i] = {x, y};
        D[x / r][y / r].push_back(i);
    }
    for (auto &[x, dd]: D) {
        for (auto &[y, b]: dd) {
            if (b.size() > k) {
                b.resize(k);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        auto [x1, y1] = A[i];
        for (int a = x1 / r - 1; a <= x1 / r + 1; a++) {
            for (int b = y1 / r - 1; b <= y1 / r + 1; b++) {
                for (int j: D[a][b]) {
                    auto [x2, y2] = A[j];
                    if (tie(x1, y1) == tie(x2, y2)) continue;
                    if (dist(x1, y1, x2, y2) <= r * r) {
                        g[i].emplace_back(j);
                        g[j].emplace_back(i);
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (has_cycle(i)) {
                color(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    return 0;
}
