#include <bits/stdc++.h>
using namespace std;

void add(vector<int>& tree, int n, int k) {
    for (; k <= n; k += k & -k) {
        tree[k]++;
    }
}

int get(vector<int>& tree, int n, int k) {
    int res(0);
    for (; k > 0; k -= k & -k) {
        res += tree[k];
    }
    return res;
}

int get2(vector<int>& sqdec1, vector<int>& sqdec2, int alpha, int x) {
    //cout << "?" << x << endl;
    //cout << sqdec2[x / alpha] + sqdec1[x] << endl;
    return sqdec2[x / alpha] + sqdec1[x];
}

void add2(vector<int>& sqdec1, vector<int>& sqdec2, int alpha, int x) {
    //cout << "!" << x << endl;
    int z(x / alpha);
    for (int i = 0; i < z; i++) {
        sqdec2[i]++;
    }
    for (int i = z * alpha; i < x; i++) {
        sqdec1[i]++;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int r, c, q;
    cin >> r >> c;
    vector<vector<int>> v(r, vector<int>(c, 0));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> q;
            v[i][j] = q;
        }
    }
    vector<vector<long long>> invr(r, vector<long long>(c, 0));
    vector<vector<long long>> invd(r, vector<long long>(c, 0));
    vector<int> tree(r * c + 1, 0);
    int alpha(2000);
    vector<int> sqdec1(r * c + 1, 0), sqdec2((r * c + 1) / alpha + 1, 0);
    for (int i = 0; i < r; i++) {
        for (int j = c - 1; j >= 0; j--) {
            for (int k = i + 1; k < r; k++) {
                invd[i][j] += get2(sqdec1, sqdec2, alpha, v[k][j]);
            }
            add2(sqdec1, sqdec2, alpha, v[i][j]);
        }
        //cout << "FLUSHED" << endl;
        for (int clr = 0; clr <= r * c; clr++) {
            sqdec1[clr] = 0;
        }
        for (int clr = 0; clr < sqdec2.size(); clr++) {
            sqdec2[clr] = 0;
        }
    }
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            invr[i][j] = (r - 1 - i) * (c - 1 - j) - invd[i][j];
        }
    }
    /*for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cout << invr[i][j] << "," << invd[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;*/
    for (int i = r - 1; i >= 1; i--) {
        for (int j = 0; j < c; j++) {
            invr[i - 1][j] += invr[i][j];
        }
    }
    for (int i = c - 1; i >= 1; i--) {
        for (int j = 0; j < r; j++) {
            invd[j][i - 1] += invd[j][i];
        }
    }
    /*for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cout << invr[i][j] << "," << invd[i][j] << " ";
        }
        cout << endl;
    }*/
    vector<vector<bool>> dbr(r + 1, vector<bool>(c + 1, false));
    vector<vector<long long>> cost(r + 1, vector<long long>(c + 1, 0)); //i really am making so many vectors
    for (int i = r - 1; i >= 0; i--) {
        dbr[i][c] = true;
    }
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            long long cr(cost[i][j + 1] + invr[i][j]);
            long long cd(cost[i + 1][j] + invd[i][j]);
            if (cd < cr) {
                cost[i][j] = cd;
                dbr[i][j] = true;
            } else {
                cost[i][j] = cr;
            }
        }
    }
    vector<int> a{};
    int x(0), y(0);
    while (x + y < r + c) {
        if (!dbr[x][y]) {
            for (int i = x; i < r; i++) {
                a.push_back(v[i][y]);
            }
            y++;
        } else {
            for (int i = y; i < c; i++) {
                a.push_back(v[x][i]);
            }
            x++;
        }
    }
    /*for (auto i : a) {
        cout << i << " ";
    }*/
    long long res(0);
    for (int i = 0; i < r * c; i++) {
        res += i - get(tree, r * c, a[i]);
        add(tree, r * c, a[i]);
    }
    cout << res << endl;
}
