#include <iostream>
#include<vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#pragma GCC target("avx2")

using namespace std;
typedef long long ll;

vector<int> mergev(vector<int>& v1, vector<int>& v2) {
	vector<int> ans;
	int p1 = 0, p2 = 0;
	while (p1 < v1.size() && p2 < v2.size()) {
		if (v1[p1] < v2[p2]) {
			ans.push_back(v1[p1]);
			p1++;
		}
		else {
			ans.push_back(v2[p2]);
			p2++;
		}
	}
	while (p1 < v1.size()) {
		ans.push_back(v1[p1]);
		p1++;
	}
	while (p2 < v2.size()) {
		ans.push_back(v2[p2]);
		p2++;
	}
	return ans;
}

pair<vector<int>, int> cntinv(vector<int>& v) {
	if (v.size() == 1)
		return {v, 0};
	int mid = (v.size() - 1) / 2;
	vector<int> lv, rv;
	for (int i = 0; i <= mid; i++)
		lv.push_back(v[i]);
	for (int i = mid + 1; i < v.size(); i++)
		rv.push_back(v[i]);
	auto lans = cntinv(lv), rans = cntinv(rv);
	swap(lv, lans.first);
	swap(rv, rans.first);
	int r = 0;
	int inc = 0;
	for (int i = 0; i < lv.size(); i++) {
		while (r < rv.size() && rv[r] < lv[i])
			r++;
		inc += r;
	}
	auto res = mergev(lv, rv);
	return { res, inc + lans.second + rans.second };
}

int incpair(vector<int>& lv, vector<int>& rv) {
	int inc = 0;
	int r = 0;
	for (int i = 0; i < lv.size(); i++) {
		while (r < rv.size() && rv[r] < lv[i])
			r++;
		inc += r;
	}
	return inc;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>> v(r, vector<int>(c));
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++)
			cin >> v[i][j];
	}
	cout << cntinv(v[0]).second;
	return 0;
	vector<vector<vector<int>>> sr(r, vector<vector<int>>(c)), sc(r, vector<vector<int>>(c));
	/*sr.back().back().push_back(v.back().back());
	sc.back().back().push_back(v.back().back());*/
	for (int i = r - 1; i >= 0; i--) {
		for (int j = c- 1; j >= 0; j--) {
			vector<int> cur = { v[i][j] };
			vector<int> sec = {};
			if (i + 1 < r)
				sec = sc[i + 1][j];
			sc[i][j] = mergev(sec, cur);
			sec = {};
			if (j + 1 < c)
				sec = sr[i][j + 1];
			sr[i][j] = mergev(sec, cur);
		}
	}
	vector<vector<int>> invr(r, vector<int>(c, 0)), invc(r, vector<int>(c, 0));
	for (int i = r - 1; i >= 0; i--) {
		for (int j = c - 1; j >= 0; j--) {
			if (i + 1 < r)
				invc[i][j] = invc[i + 1][j];
			for (auto h : sc[i][j]) {
				if (v[i][j] <= h)
					break;
				invc[i][j]++;
			}
			if (j + 1 < c)
				invr[i][j] = invr[i][j + 1];
			for (auto h : sr[i][j]) {
				if (v[i][j] <= h)
					break;
				invr[i][j]++;
			}
		}
	}
	/*cout << cntinv(v[0]).second;
	return 0;*/
	vector<vector<pair<vector<int>, int>>> dp(r, vector<pair<vector<int>, int>>(c, { {}, 0 }));
	dp.back().back() = { {v.back().back()}, 0 };
	for (int sum = r + c - 3; sum >= 0; sum--) {
		for (int i = r - 1; i >= 0; i--) {
			int j = sum - i;
			if (j < 0)
				continue;
			if (j >= c)
				break;
			int str = invr[i][j], stc = invc[i][j];
			int incr = 0, incc = 0;
			if (i + 1 < r) {
				incr += incpair(sr[i][j], dp[i + 1][j].first) + dp[i + 1][j].second;
			}
			if (j + 1 < c) {
				incc += incpair(sc[i][j], dp[i][j + 1].first) + dp[i][j + 1].second;
			}
			if (str + incr < stc + incc) {
				vector<int> sec = {};
				if (i + 1 < r)
					sec = dp[i + 1][j].first;
				dp[i][j].first = mergev(sr[i][j], sec);
				dp[i][j].second = str + incr;
			}
			else {
				vector<int> sec = {};
				if (j + 1 < c)
					sec = dp[i][j + 1].first;
				dp[i][j].first = mergev(sc[i][j], sec);
				dp[i][j].second = stc + incc;
			}
		}
	}
	cout << dp[0][0].second;
}