#include <iostream>
#include<vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <random>
#pragma GCC target("avx2")

using namespace std;
typedef long long ll;

vector<int> mergev(vector<int>& v1, vector<int>& v2) {
	vector<int> ans;
	int p1 = 0, p2 = 0;
	while (p1 < v1.size() && p2 < v2.size()) {
		if (v1[p1] < v2[p2]) {
			ans.push_back(v1[p1]);
			p1++;
		}
		else {
			ans.push_back(v2[p2]);
			p2++;
		}
	}
	while (p1 < v1.size()) {
		ans.push_back(v1[p1]);
		p1++;
	}
	while (p2 < v2.size()) {
		ans.push_back(v2[p2]);
		p2++;
	}
	return ans;
}

pair<vector<int>, int> cntinv(vector<int>& v) {
	if (v.size() == 1)
		return { v, 0 };
	int mid = (v.size() - 1) / 2;
	vector<int> lv, rv;
	for (int i = 0; i <= mid; i++)
		lv.push_back(v[i]);
	for (int i = mid + 1; i < v.size(); i++)
		rv.push_back(v[i]);
	auto lans = cntinv(lv), rans = cntinv(rv);
	swap(lv, lans.first);
	swap(rv, rans.first);
	int r = 0;
	int inc = 0;
	for (int i = 0; i < lv.size(); i++) {
		while (r < rv.size() && rv[r] < lv[i])
			r++;
		inc += r;
	}
	auto res = mergev(lv, rv);
	return { res, inc + lans.second + rans.second };
}

int stup(vector<int> v) {
	int n = v.size();
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (v[i] > v[j])
				ans++;
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	/*int n = 7;
	vector<int> v = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10,12, 11 };
	while (true) {
		random_shuffle(v.begin(), v.end());
		if (cntinv(v).second != stup(v)) {
			for (auto i : v)
				cout << i << " ";
			return 0;
		}
	}*/
	int r, c;
	cin >> r >> c;
	vector<int> v(c);
	for (int i = 0; i < c; i++)
		cin >> v[i];
	auto res = cntinv(v);
	cout << res.second;
}