#include <iostream>
#include<vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#pragma GCC target("avx2")

using namespace std;
typedef long long ll;

vector<int> mergev(vector<int>& v1, vector<int>& v2) {
	vector<int> ans;
	int p1 = 0, p2 = 0;
	while (p1 < v1.size() && p2 < v2.size()) {
		if (v1[p1] < v2[p2]) {
			ans.push_back(v1[p1]);
			p1++;
		}
		else {
			ans.push_back(v2[p2]);
			p2++;
		}
	}
	while (p1 < v1.size()) {
		ans.push_back(v1[p1]);
		p1++;
	}
	while (p2 < v2.size()) {
		ans.push_back(v2[p2]);
		p2++;
	}
	return ans;
}

pair<vector<int>, int> cntinv(vector<int>& v) {
	if (v.size() == 1)
		return {v, 0};
	int mid = (v.size() - 1) / 2;
	vector<int> lv, rv;
	for (int i = 0; i <= mid; i++)
		lv.push_back(v[i]);
	for (int i = mid + 1; i < v.size(); i++)
		rv.push_back(v[i]);
	auto lans = cntinv(lv), rans = cntinv(rv);
	swap(lv, lans.first);
	swap(rv, rans.first);
	int r = 0;
	int inc = 0;
	for (int i = 0; i < lv.size(); i++) {
		while (r < rv.size() && rv[r] < lv[i])
			r++;
		inc += r;
	}
	auto res = mergev(lv, rv);
	return { res, inc + lans.second + rans.second };
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>> v(r, vector<int>(c));
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++)
			cin >> v[i][j];
	}
	int ans = 1e9;
	for (int del = 1; del <= r + c; del++) {
		for (int mask = 0; mask < (1 << del); mask++) {
			int ri = 0, ci = 0;
			vector<int> cur;
			bool ok = 1;
			for (int j = 0; j < del; j++) {
				if (mask & (1 << j)) { // delete row
					if (ri >= r) {
						ok = 0;
						break;
					}
					for (int cc = ci; cc < c; cc++)
						cur.push_back(v[ri][cc]);
					ri++;
				}
				else {
					if (ci >= c) {
						ok = 0;
						break;
					}
					for (int rr = ri; rr < r; rr++)
						cur.push_back(v[rr][ci]);
					ci++;
				}
			}
			if (ok && ri == r && ci == c) {
				ans = min(ans, cntinv(cur).second);
			}
		}
	}
	cout << ans;
}