#include <iostream>
#include<vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#pragma GCC target("avx2")

using namespace std;
typedef long long ll;

vector<int> mergev(vector<int>& v1, vector<int>& v2) {
	vector<int> ans;
	int p1 = 0, p2 = 0;
	while (p1 < v1.size() && p2 < v2.size()) {
		if (v1[p1] < v2[p2]) {
			ans.push_back(v1[p1]);
			p1++;
		}
		else {
			ans.push_back(v2[p2]);
			p2++;
		}
	}
	while (p1 < v1.size()) {
		ans.push_back(v1[p1]);
		p1++;
	}
	while (p2 < v2.size()) {
		ans.push_back(v2[p2]);
		p2++;
	}
	return ans;
}

pair<vector<int>, int> cntinv(vector<int>& v) {
	if (v.size() == 1)
		return {v, 0};
	int mid = (v.size() - 1) / 2;
	vector<int> lv, rv;
	for (int i = 0; i <= mid; i++)
		lv.push_back(v[i]);
	for (int i = mid + 1; i < v.size(); i++)
		rv.push_back(v[i]);
	auto lans = cntinv(lv), rans = cntinv(rv);
	swap(lv, lans.first);
	swap(rv, rans.first);
	int r = 0;
	int inc = 0;
	for (int i = 0; i < lv.size(); i++) {
		while (r < rv.size() && rv[r] < lv[i])
			r++;
		inc += r;
	}
	auto res = mergev(lv, rv);
	return { res, inc + lans.second + rans.second };
}

int incpair(vector<int>& lv, vector<int>& rv) {
	int inc = 0;
	int r = 0;
	for (int i = 0; i < lv.size(); i++) {
		while (r < rv.size() && rv[r] < lv[i])
			r++;
		inc += r;
	}
	return inc;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int r, c;
	cin >> r >> c;
	vector<vector<int>> v(r, vector<int>(c));
	for (int i = 0; i < r; i++) {
		for (int j = 0; j < c; j++)
			cin >> v[i][j];
	}
	vector<vector<pair<vector<int>, int>>> dp(r, vector<pair<vector<int>, int>>(c, { {}, 0 }));
	dp.back().back() = { {v.back().back()}, 0 };
	for (int sum = r + c - 3; sum >= 0; sum--) {
		for (int i = r - 1; i >= 0; i--) {
			int j = sum - i;
			if (j < 0 || j >= c)
				continue;
			vector<int> curr, curc;
			for (int h = j; h < c; h++)
				curr.push_back(v[i][h]);
			for (int h = i; h < r; h++)
				curc.push_back(v[h][j]);
			int str = cntinv(curr).second, stc = cntinv(curc).second;
			sort(curr.begin(), curr.end());
			sort(curc.begin(), curc.end());
			
			int incr = 0, incc = 0;
			if (i + 1 < r) {
				incr += incpair(curr, dp[i + 1][j].first) + dp[i + 1][j].second;
			}
			if (j + 1 < c) {
				incc += incpair(curc, dp[i][j + 1].first) + dp[i][j + 1].second;
			}
			if (str + incr < stc + incc) {
				vector<int> sec = {};
				if (i + 1 < r)
					sec = dp[i + 1][j].first;
				dp[i][j].first = mergev(curr, sec);
				dp[i][j].second = str + incr;
			}
			else {
				vector<int> sec = {};
				if (j + 1 < c)
					sec = dp[i][j + 1].first;
				dp[i][j].first = mergev(curc, sec);
				dp[i][j].second = stc + incc;
			}
		}
	}
	cout << dp[0][0].second;
}