#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")

using namespace std;
typedef long long ll;

vector<vector<int>> g;
vector<int> col;
vector<int> vis;
bool flag = 0;

void dfs(int v, int c) {
	col[v] = c;
	vis.push_back(v);
	for (auto i : g[v]) {
		if (col[i] == c) {
			flag = 1;
		}
		if (col[i] == -1)
			dfs(i, 1 - c);
	}
}

bool cmp(vector<int>& a, vector<int>& b) { // returns 1 if a < b
	for (int i = 0; i < a.size(); i++) {
		if (a[i] != b[i])
			return a[i] < b[i];
	}
	return 0;
}

void pushf(vector<int>& v, int x) {
	vector<int> res;
	res.push_back(x);
	for (auto i : v)
		res.push_back(i);
	swap(res, v);
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	vector<vector<vector<int>>>dp(n, vector<vector<int>>(n + 1));
	dp[n - 1][1].push_back(v.back());
	for (int i = n - 2; i >= 0; i--) {
		for (int cnt = 1; cnt <= n - i; cnt++) {
			if (cnt == 1) {
				int maxi = 0;
				for (int h = i; h < n; h++)
					maxi = max(maxi, v[h]);
				dp[i][cnt].push_back(maxi);
				continue;
			}
			vector<int> cur;
			int maxi = 0;
			for (int h = i; h < n - 1; h++) {
				maxi = max(maxi, v[h]);
				vector<int> temp = dp[h + 1][cnt - 1];
				if (temp.empty())
					break;
				pushf(temp, maxi);
				if (cur.empty() || cmp(temp, cur))
					cur = temp;
			}
			dp[i][cnt] = cur;
		}
	}
	/*for (auto i : dp[0][7])
		cout << i << " ";
	cout << endl;*/
	while (q--) {
		int k, i;
		cin >> k >> i;
		i--;
		cout << dp[0][k][i] << '\n';
	}
}