#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll sq(ll x) {
    return x * x;
}

struct dsu {
    vector<int> pa, siz;

    dsu(int n) {
        pa.resize(n);
        iota(pa.begin(), pa.end(), 0);
        siz.resize(n, 1);
    }

    int get(int x) {
        return pa[x] = (x == pa[x] ? x : get(pa[x]));
    }

    bool uni(int x, int y) {
        x = get(x); y = get(y);
        if (x == y) return 0;
        if (siz[x] < siz[y]) swap(x, y);
        pa[y] = x;
        siz[x] += siz[y];
        return 1;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll r;
    cin >> n >> r;
    vector<array<ll, 2>> a(n);
    for (auto& [x, y] : a) cin >> x >> y;
    auto dst = [&](int i, int j) {
        return sq(a[i][0] - a[j][0]) + sq(a[i][1] - a[j][1]);
    };
    dsu dd(2 * n);
    auto add_edge = [&](int u, int v) {
        dd.uni(u + n, v);
        dd.uni(v + n, u);
    };
    r = sq(r);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (dst(i, j) <= r) {
                add_edge(i, j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << bool(dd.get(i) == dd.get(i + n));
    }
}