#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 0x3f3f3f3f;

template<>
struct std::hash<pair<ll, ll>> {
    ll operator()(const pair<ll, ll>& x) const {
        return 1ll * x.first * inf + x.second;
    }
};

struct BIT {
    vector<int> t;
    int sz;

    BIT(int n) : t(n + 1), sz(n) {}

    void upd(int i, int v) {
        for (++i; i <= sz; i += i & -i) t[i] += v;
    }

    int get(int r) {
        int res = 0;
        for (; r; r -= r & -r) res += t[r];
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& x : a) {
        for (auto& y : x) {
            cin >> y;
            --y;
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(m + 1, inf));
    dp[0][0] = 0;
    const int sz = n * m;
    for (int r = 0; r <= n; ++r) {
        for (int c = 0; c <= m; ++c) {
            if (r) {
                BIT tt(sz);
                for (int i = 0; i < r - 1; ++i) {
                    for (int j = 0; j < m; ++j) {
                        tt.upd(a[i][j], 1);
                    }
                }
                for (int i = 0; i < c; ++i) {
                    for (int j = r - 1; j < n; ++j) {
                        tt.upd(a[j][i], 1);
                    }
                }
                int ex = 0;
                for (int i = c; i < m; ++i) {
                    ex += tt.get(a[r - 1][i], sz);
                    tt.upd(a[r - 1][i], 1);
                }
                dp[r][c] = min(dp[r][c], dp[r - 1][c] + ex);
            }
            if (c) {
                BIT tt(sz);
                for (int i = 0; i < r; ++i) {
                    for (int j = 0; j < m; ++j) {
                        tt.upd(a[i][j], 1);
                    }
                }
                for (int i = 0; i < c - 1; ++i) {
                    for (int j = r; j < n; ++j) {
                        tt.upd(a[j][i], 1);
                    }
                }
                int ex = 0;
                for (int i = r; i < n; ++i) {
                    ex += tt.get(a[i][c - 1], sz);
                    tt.upd(a[i][c - 1], 1);
                }
                dp[r][c] = min(dp[r][c], dp[r][c - 1] + ex);
            }
        }
    }
    int ans = inf;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i == n || j == m) ans = min(ans, dp[i][j]);
        }
    }
    cout << ans;
}