#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 0x3f3f3f3f;

template<>
struct std::hash<pair<ll, ll>> {
    ll operator()(const pair<ll, ll>& x) const {
        return 1ll * x.first * inf + x.second;
    }
};

struct BIT {
    vector<int> t;
    int sz;

    BIT(int n) : t(n + 1), sz(n) {}

    void upd(int i, int v) {
        for (++i; i <= sz; i += i & -i) t[i] += v;
    }

    int get(int r) {
        int res = 0;
        for (; r; r -= r & -r) res += t[r];
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& x : a) {
        for (auto& y : x) {
            cin >> y;
            --y;
        }
    }
    cout << 0;  
}