#pragma GCC optimize("Ofast,fast-math,unroll-loops")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll infl = 0x3f3f3f3f3f3f3f3f;
    
bool ckmin(ll& a, ll b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

struct nd {
    nd* lc = nullptr;
    nd* rc = nullptr;

    ll inv = 0, sz = 0;
};

nd* rc(nd* x) {
    if (!x) return nullptr;
    return x->rc;
}

nd* lc(nd* x) {
    if (!x) return nullptr;
    return x->lc;
}

ll get_inv(nd* x) {
    if (!x) return 0ll;
    return x->inv;
}

ll get_sz(nd* x) {
    if (!x) return 0ll;
    return x->sz;
}

nd* mrg(nd* p, nd* q) {
    if (!p) return q;
    if (!q) return p;
    nd* r = new nd();
    r->lc = mrg(p->lc, q->lc);
    r->rc = mrg(p->rc, q->rc);
    r->inv = get_inv(p) + get_inv(q) + get_inv(r->lc) - get_inv(p->lc) - get_inv(q->lc) + get_inv(r->rc) - get_inv(p->rc) - get_inv(q->rc) + get_sz(p->rc) * get_sz(q->lc);
    r->sz = get_sz(r->lc) + get_sz(r->rc);
    // cout << get_sz(p) << ' ' << get_sz(q) << ' ' << get_sz(r) << endl;
    return r;
}

const int maxN = 1e4 + 1e3;

void upd(int i, nd* x, nd* pre, int lx = 0, int rx = maxN) {
    if (lx + 1 == rx) {
        x->sz = 1;
        x->inv = 0;
        return;
    }
    int m = (lx + rx) >> 1;
    if (i < m) {
        x->lc = new nd();
        x->rc = rc(pre);
        upd(i, x->lc, lc(pre), lx, m);
        x->inv = get_inv(pre) + get_inv(x->lc) - get_inv(lc(pre));
    } else {
        x->lc = lc(pre);
        x->rc = new nd();
        upd(i, x->rc, rc(pre), m, rx);
        x->inv = get_inv(pre) + get_inv(x->rc) - get_inv(rc(pre)) + get_sz(lc(pre));
    }
    x->sz = get_sz(x->lc) + get_sz(x->rc);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (auto& x : a) {
        for (auto& y : x) {
            cin >> y;
            --y;
        }
    }
    vector<vector<nd*>> col_rt(n + 1, vector<nd*>(m + 1)), row_rt(col_rt), rt(col_rt);
    for (int i = n; i >= 1; --i) {
        for (int j = m; j >= 1; --j) {
            col_rt[i][j] = new nd();
            row_rt[i][j] = new nd();
            int x = a[i - 1][j - 1];
            if (j < m) {
                upd(x, row_rt[i][j], row_rt[i][j + 1]);
            } else {
                upd(x, row_rt[i][j], nullptr);
            }
            if (i < n) {
                upd(x, col_rt[i][j], col_rt[i + 1][j]);
            } else {
                upd(x, col_rt[i][j], nullptr);
            }
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, infl));
    dp[0][0] = 0;
    for (int r = 0; r <= n; ++r) {
        for (int c = 0; c <= m; ++c) {
            rt[r][c] = new nd();
            if (r && c < m) {
                nd* x = mrg(rt[r - 1][c], row_rt[r][c + 1]);
                ll nw = get_inv(x);
                if (dp[r][c] > nw) {
                    dp[r][c] = nw;
                    rt[r][c] = x;
                }
            }
            if (c && r < n) {
                nd* x = mrg(rt[r][c - 1], col_rt[r + 1][c]);
                ll nw = get_inv(x);
                if (dp[r][c] > nw) {
                    dp[r][c] = nw;
                    rt[r][c] = x;
                }
            }
        }
    }
    ll ans = infl;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i == n || j == m) {
                ans = min(ans, dp[i][j]);
            }
        }
    }
    cout << ans;
}
