#include <bits/stdc++.h>

using namespace std;

struct DSU {
    int n;
    vector<int> sz, p;

    DSU(int _n) {
        n = _n;
        sz.assign(n, 1);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }

    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }

    void unite(int a, int b) {
        a = pr(a), b = pr(b);
        if (a == b) {
            return;
        }
        if (sz[b] > sz[a]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
    }
};

struct Vec {
    int x, y;

    Vec(int _x = 0, int _y = 0) {
        x = _x, y = _y;
    }

    long long operator*(Vec b) {
        return x * 1LL * b.x + y * 1LL * b.y;
    }

    long long operator%(Vec b) {
        return x * 1LL * b.y - y * 1LL * b.x;
    }

    Vec operator+(Vec b) {
        return Vec(x + b.x, y + b.y);
    }

    Vec operator-(Vec b) {
        return Vec(x - b.x, y - b.y);
    }
};

constexpr int maxn = 1e5 + 5;

vector<int> g[maxn];

int cmp[maxn], col[maxn];

int ans[maxn];

void dfs(int v) {
    for (auto u : g[v]) {
        if (!cmp[u]) {
            cmp[u] = cmp[v];
            col[u] = col[v] ^ 3;
            dfs(u);
        }
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<Vec> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    DSU d(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((a[i] - a[j]) * (a[i] - a[j]) <= r * 1LL * r) {
                if (d.pr(i) != d.pr(j)) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                    d.unite(i, j);
                }
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!cmp[i]) {
            cmp[i] = ++cnt;
            col[i] = 1;
            dfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (cmp[i] == cmp[j] && col[i] == col[j]) {
                if ((a[i] - a[j]) * (a[i] - a[j]) <= r * 1LL * r) {
                    ans[cmp[i]] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[cmp[i]];
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
