#include <bits/stdc++.h>

using namespace std;

constexpr long long INF = (long long)2e18 + 7;

struct Vec {
    int x, y;

    Vec(int _x = 0, int _y = 0) {
        x = _x, y = _y;
    }

    long long operator*(Vec b) {
        return x * 1LL * b.x + y * 1LL * b.y;
    }

    long long operator%(Vec b) {
        return x * 1LL * b.y - y * 1LL * b.x;
    }

    Vec operator+(Vec b) {
        return Vec(x + b.x, y + b.y);
    }

    Vec operator-(Vec b) {
        return Vec(x - b.x, y - b.y);
    }
};

vector<Vec> get_hull(vector<Vec> points) {
    if (points.empty()) {
        return points;
    }
    for (int i = 0; i < (int)points.size(); ++i) {
        if (points[i].x < points.back().x || (points[i].x == points.back().x && points[i].y < points.back().y)) {
            swap(points[i], points.back());
        }
    }
    Vec start = points.back();
    points.pop_back();
    sort(points.begin(), points.end(), [&](Vec a, Vec b) {
        if ((a - start) % (b - start) != 0) {
            return (a - start) % (b - start) < 0;
        }
        return (a - start) * (a - start) < (b - start) * (b - start);
    });
    vector<Vec> hull = {start};
    for (auto add : points) {
        while (hull.size() > 1 && (hull.back() - hull.rbegin()[1]) % (add - hull.back()) <= 0) {
            hull.pop_back();
        }
        hull.push_back(add);
    }
    return hull;
}

bool compare(Vec v1, Vec v2) {
    if (v1.x > 0 && v2.x < 0) {
        return true;
    }
    if (v1.x < 0 && v2.x > 0) {
        return false;
    }
    if (v1 % v2 == 0) {
        if (v1.y > 0) {
            return true;
        }
        return false;
    }
    return v1 % v2 > 0;
}

long long get_dist(vector<Vec> hull1, vector<Vec> hull2) {
    long long ans = INF;
    for (auto v1 : hull1) {
        for (auto v2 : hull2) {
            ans = min(ans, (v1 - v2) * (v1 - v2));
        }
    }
    return ans;
    for (int i = 0; i < (int)hull2.size(); ++i) {
        hull2[i].x *= -1;
        hull2[i].y *= -1;
    }
    reverse(hull2.begin(), hull2.end());
    int start2 = 0;
    for (int i = 0; i < (int)hull2.size(); ++i) {
        if (hull2[i].x < hull2[start2].x || (hull2[i].x == hull2[start2].x && hull2[i].y < hull2[start2].y)) {
            start2 = i;
        }
    }
    vector<Vec> _hull2;
    for (int i = start2; i < (int)hull2.size(); ++i) {
        _hull2.push_back(hull2[i]);
    }
    for (int i = 0; i < start2; ++i) {
        _hull2.push_back(hull2[i]);
    }
    hull2 = _hull2;
    int pos1 = 0, pos2 = 0;
    // long long ans = INF;
    for (int _ = 0; _ < (int)hull1.size() + (int)hull2.size(); ++_) {
        ans = min(ans, (hull1[pos1] - hull2[pos2]) * (hull1[pos1] - hull2[pos2]));
        Vec v1 = (hull1[(pos1 + 1) % (int)hull1.size()] - hull1[pos1]);
        Vec v2 = (hull2[(pos2 + 1) % (int)hull2.size()] - hull2[pos2]);
        if (compare(v1, v2)) {
            pos1++;
            pos1 %= (int)hull1.size();
        } else {
            pos2++;
            pos2 %= (int)hull2.size();
        }
    }
    return ans;
}

constexpr int maxn = 1e5 + 5;

vector<int> g[maxn];

int cmp[maxn], col[maxn];

int ans[maxn];

void dfs(int v) {
    for (auto u : g[v]) {
        if (!cmp[u]) {
            cmp[u] = cmp[v];
            col[u] = col[v] ^ 3;
            dfs(u);
        }
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    int d = sqrt(r * 1LL * r / 2);
    while (d * 2LL * d <= r * 1LL * r) {
        d++;
    }
    map<pair<int, int>, vector<int>> squares;
    map<pair<int, int>, vector<Vec>> hulls;
    vector<Vec> a(n);
    vector<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        squares[make_pair(a[i].x / d, a[i].y / d)].push_back(i);
        b.emplace_back(a[i].x / d, a[i].y / d);
    }
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (auto [xx, yy] : b) {
        vector<Vec> nw;
        for (auto ind : squares[make_pair(xx, yy)]) {
            nw.push_back(a[ind]);
        }
        hulls[make_pair(xx, yy)] = get_hull(nw);
    }
    for (auto [xx, yy] : b) {
        vector<int> inds_nw = squares[make_pair(xx, yy)];
        for (int i = 1; i < (int)inds_nw.size(); ++i) {
            g[inds_nw[0]].push_back(inds_nw[i]);
            g[inds_nw[i]].push_back(inds_nw[0]);
        }
        if ((int)inds_nw.size() > 2) {
            g[inds_nw[1]].push_back(inds_nw[2]);
            g[inds_nw[2]].push_back(inds_nw[1]);
        }
        for (int add_x = -2; add_x <= 2; ++add_x) {
            for (int add_y = 0; add_y <= 2; ++add_y) {
                if (add_x != 0 || add_y != 0) {
                    if (squares[make_pair(xx + add_x, yy + add_y)].empty()) {
                        continue;
                    }
                    if (inds_nw.size() < 3 && squares[make_pair(xx + add_x, yy + add_y)].size() < 3) {
                        for (auto ind1 : inds_nw) {
                            for (auto ind2 : squares[make_pair(xx + add_x, yy + add_y)]) {
                                if ((a[ind1] - a[ind2]) * (a[ind1] - a[ind2]) <= r * 1LL * r) {
                                    g[ind1].push_back(ind2);
                                    g[ind2].push_back(ind1);
                                }
                            }
                        }
                    } else {
                        if (get_dist(hulls[make_pair(xx, yy)], hulls[make_pair(xx + add_x, yy + add_y)]) <= r * 1LL * r) {
                            g[inds_nw[0]].push_back(squares[make_pair(xx + add_x, yy + add_y)][0]);
                            g[g[inds_nw[0]].back()].push_back(inds_nw[0]);
                        }
                    }
                }
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!cmp[i]) {
            cmp[i] = ++cnt;
            col[i] = 1;
            dfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (col[j] == col[i]) {
                ans[cmp[i]] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[cmp[i]];
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
