#include <bits/stdc++.h>

using namespace std;

struct Vec {
    int x, y;

    Vec(int _x = 0, int _y = 0) {
        x = _x, y = _y;
    }

    long long operator*(Vec b) {
        return x * 1LL * b.x + y * 1LL * b.y;
    }

    long long operator%(Vec b) {
        return x * 1LL * b.y - y * 1LL * b.x;
    }

    Vec operator+(Vec b) {
        return Vec(x + b.x, y + b.y);
    }

    Vec operator-(Vec b) {
        return Vec(x - b.x, y - b.y);
    }
};

constexpr int maxn = 1e5 + 5;

vector<int> g[maxn];

int cmp[maxn], col[maxn];

int ans[maxn];

void dfs(int v) {
    for (auto u : g[v]) {
        if (!cmp[u]) {
            cmp[u] = cmp[v];
            col[u] = col[v] ^ 3;
            dfs(u);
        }
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<Vec> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((a[i] - a[j]) * (a[i] - a[j]) <= r * 1LL * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!cmp[i]) {
            cmp[i] = ++cnt;
            col[i] = 1;
            dfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (col[j] == col[i]) {
                ans[cmp[i]] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[cmp[i]];
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
