#include <bits/stdc++.h>

using namespace std;

struct Vec {
    int x, y;

    Vec(int _x = 0, int _y = 0) {
        x = _x, y = _y;
    }

    long long operator*(Vec b) {
        return x * 1LL * b.x + y * 1LL * b.y;
    }

    long long operator%(Vec b) {
        return x * 1LL * b.y - y * 1LL * b.x;
    }

    Vec operator+(Vec b) {
        return Vec(x + b.x, y + b.y);
    }

    Vec operator-(Vec b) {
        return Vec(x - b.x, y - b.y);
    }
};

constexpr int maxn = 1e5 + 5;

vector<int> g[maxn];

int cmp[maxn], col[maxn];

int ans[maxn];

void dfs(int v) {
    for (auto u : g[v]) {
        if (!cmp[u]) {
            cmp[u] = cmp[v];
            col[u] = col[v] ^ 3;
            dfs(u);
        }
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    int d = sqrt(r * 1LL * r / 2);
    while (d * 2LL * d <= r * 1LL * r) {
        d++;
    }
    map<pair<int, int>, vector<int>> squares;
    vector<Vec> a(n);
    vector<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        squares[make_pair(a[i].x / d, a[i].y / d)].push_back(i);
        b.emplace_back(a[i].x / d, a[i].y / d);
    }
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (auto [xx, yy] : b) {
        vector<int> inds_nw = squares[make_pair(xx, yy)];
        for (int i = 1; i < (int)inds_nw.size(); ++i) {
            g[inds_nw[0]].push_back(inds_nw[i]);
            g[inds_nw[i]].push_back(inds_nw[0]);
        }
        if ((int)inds_nw.size() > 2) {
            g[inds_nw[1]].push_back(inds_nw[2]);
            g[inds_nw[2]].push_back(inds_nw[1]);
        }
        for (int add_x = -2; add_x <= 2; ++add_x) {
            for (int add_y = 0; add_y <= 2; ++add_y) {
                if (add_x != 0 || add_y != 0) {
                    for (auto ind1 : inds_nw) {
                        for (auto ind2 : squares[make_pair(xx + add_x, yy + add_y)]) {
                            if ((a[ind1] - a[ind2]) * (a[ind1] - a[ind2]) <= r * 1LL * r) {
                                g[ind1].push_back(ind2);
                                g[ind2].push_back(ind1);
                            }
                        }
                    }
                }
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!cmp[i]) {
            cmp[i] = ++cnt;
            col[i] = 1;
            dfs(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (col[j] == col[i]) {
                ans[cmp[i]] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[cmp[i]];
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
