#include <bits/stdc++.h>

using namespace std;

constexpr long long INF = (long long)2e18 + 7;

struct Fenwick2 {
    int r, c;
    vector<vector<int>> f;

    Fenwick2(int _r, int _c) {
        r = _r, c = _c;
        f.assign(r, vector<int>(c));
    }

    void add(int pos1, int pos2) {
        for (int i = pos1; i < r; i += i & -i) {
            for (int j = pos2; j < c; j += j & -j) {
                f[i][j]++;
            }
        }
    }

    int get(int pos1, int pos2) {
        int ans = 0;
        for (int i = pos1; i > 0; i -= i & -i) {
            for (int j = pos2; j > 0; j -= j & -j) {
                ans += f[i][j];
            }
        }
        return ans;
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    vector<pair<int, int>> ord;
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            ord.emplace_back(i, j);
        }
    }
    sort(ord.begin(), ord.end(), [&](pair<int, int> p1, pair<int, int> p2) -> bool {
        return a[p1.first][p1.second] < a[p2.first][p2.second];
    });
    Fenwick2 f(r + 1, c + 1);
    long long ans = 0;
    for (auto [i, j] : ord) {
        ans += f.get(r, c) - f.get(r, j) - f.get(i, c) + f.get(i, j);
        f.add(i + 1, j + 1);
    }
    vector<vector<long long>> dp(r, vector<long long>(c));
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            if (i == r - 1 && j == c - 1) {
                continue;
            }
            dp[i][j] = INF;
            if (i + 1 < r) {
                long long cnt_nw = 0;
                for (int j1 = j; j1 < c; ++j1) {
                    for (int i2 = i + 1; i2 < r; ++i2) {
                        for (int j2 = j; j2 < j1; ++j2) {
                            if (a[i][j1] > a[i2][j2]) {
                                cnt_nw++;
                            }
                        }
                    }
                }
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + cnt_nw);
            }
            if (j + 1 < c) {
                long long cnt_nw = 0;
                for (int i1 = i; i1 < r; ++i1) {
                    for (int i2 = i; i2 < i1; ++i2) {
                        for (int j2 = j + 1; j2 < c; ++j2) {
                            if (a[i1][j] > a[i2][j2]) {
                                cnt_nw++;
                            }
                        }
                    }
                }
                dp[i][j] = min(dp[i][j], dp[i][j + 1] + cnt_nw);
            }
        }
    }
    cout << dp[0][0] + ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
