#include <bits/stdc++.h>

using namespace std;

constexpr int R = 1 << 19;

int mx[R * 2], mn[R * 2];

void build() {
    for (int i = R - 1; i > 0; --i) {
        mx[i] = max(mx[i * 2], mx[i * 2 + 1]);
        mn[i] = min(mn[i * 2], mn[i * 2 + 1]);
    }
}

int get_mx(int l, int r) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans = max(ans, mx[l++]);
        }
        if (r & 1) {
            ans = max(ans, mx[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

int get_mn(int l, int r) {
    l += R;
    r += R;
    int ans = R;
    while (l < r) {
        if (l & 1) {
            ans = min(ans, mn[l++]);
        }
        if (r & 1) {
            ans = min(ans, mn[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), pos(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        mn[i + R] = mx[i + R] = a[i];
        pos[a[i]] = i;
    }
    build();
    vector<int> nxt(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] < a[i]) {
            nxt[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    vector<vector<int>> ans(n + 1);
    auto get_ans = [&](int k, int i) -> int {
        if (!ans[k].empty()) {
            return ans[k][i];
        }
        int pos_nw = 0;
        while ((int)ans[k].size() + 2 < k) {
            if (nxt[pos_nw] == pos_nw + 1) {
                ans[k].push_back(a[pos_nw]);
                pos_nw++;
            } else {
                int r = min(nxt[pos_nw], n - (k - (int)ans[k].size() - 1) + 1);
                int pos_nxt = pos[get_mn(pos_nw + 1, r)];
                ans[k].push_back(a[pos_nw]);
                pos_nw = pos_nxt;
            }
        }
        if (k > 1) {
            ans[k].push_back(pos_nw);
            pos_nw = nxt[pos_nw];
            if (pos_nw == n) {
                pos_nw--;
            }
        }
        ans[k].push_back(get_mx(pos_nw, n));
        return ans[k][i];
    };
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        cout << get_ans(k, i) + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
