#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

mt19937 gen(596);
const ll INF = 1e18;

struct segtree {
    ll n;
    vector<ll> tree;

    segtree() {}

    segtree(ll _n) {
        n = _n;
        tree.resize(4 * n);
    }

    void upd(int v, int tl, int tr, int i) {
        if (tl == tr) {
            tree[v] += 1;
            return;
        }
        int tm = (tl + tr) / 2;
        if (i <= tm) {
            upd(v * 2 + 1, tl, tm, i);
        }
        else {
            upd(v * 2 + 2, tm + 1, tr, i);
        }
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }

    ll get(int v, int tl, int tr, int ql, int qr) {
        if (tl > qr || tr < ql) {
            return 0;
        }
        if (ql <= tl && tr <= qr) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return get(v * 2 + 1, tl, tm, ql, qr) + get(v * 2 + 2, tm + 1, tr, ql, qr);
    }
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }
    int N = 3e5;
    segtree t(N);
    ll ans = 0;
    for (int i = 0; i < m; i++) {
        ans += t.get(0, 0, N - 1, a[i] + 1, N - 1);
        t.upd(0, 0, N - 1, a[i]);
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}