#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct V {
    ll x{}, y{};

    V() : x(), y() {}

    V(ll x, ll y) : x(x), y(y) {}
};

V operator-(V& p1, V& p2) {
    return {p1.x - p2.x, p1.y - p2.y};
}

ll operator%(V& p1, V& p2) {
    return (p1.x * p2.x + p1.y * p2.y);
}

ll len2(V a) {
    return a % a;
}

ll dist2(V& p1, V& p2) {
    return len2(p1 - p2);
}

void solve() {
    int n;
    ll r;

    cin >> n >> r;

    vector<V> p(n);
    vector<vector<int>> g(n);

    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;

        for (int j = 0; j < i; ++j) {
            if (dist2(p[j], p[i]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> used(n);
    bool f = false;
    auto dfs = [&](auto self, int v, int col)->void {
        used[v] = col;
        for (auto u : g[v]) {
            if (!used[u]) {
                self(self, u, 3 - col);
            }
            if (used[u] == col)
                f = true;
        }
    };

    vector<int> ans(n);
    auto dfs_ans = [&](auto self, int v)->void {
        ans[v] = 1;
        for (auto u : g[v]) {
            if (!ans[u])
                self(self, u);
        }
    };

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            f = false;
            dfs(dfs, i, 1);
            if (f) {
                dfs_ans(dfs_ans, i);
            }
        }
    }

    for (int i = 0; i < n; ++i)
        cout << ans[i];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
