#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(v) (v).begin(), (v).end()

struct fenwick {

	fenwick() {}
	fenwick(int n) : n(n) {
		v.resize(n);
	}

	void add(int r, int x) {
		sum += x;
		for (; r < n; r = r | (r + 1)) v[r] += x;
	}

	int pref(int r) { // <=
		if (r >= n - 1) return sum;
		int s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) s += v[r];
		return s;
	}

	int suff(int r) { // >=
		return sum - pref(r - 1);
	}

	int n;
	int sum = 0;
	vector<int> v;

};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			a[i][j]--;
		}
	}

	ll ans1 = 0;
	fenwick f(n * m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ans1 += f.suff(a[i][j]);
			f.add(a[i][j], 1);
		}
	}

	ll ans2 = 0;
	fenwick f2(n * m);
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			ans2 += f2.suff(a[i][j]);
			f2.add(a[i][j], 1);
		}
	}

	cout << min(ans1, ans2);
}

int32_t main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();
}