#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
//#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(v) (v).begin(), (v).end()

struct fenwick {

	fenwick() {}
	fenwick(int n) : n(n) {
		v.resize(n);
	}

	void add(int r, int x) {
		sum += x;
		for (; r < n; r = r | (r + 1)) v[r] += x;
	}

	int pref(int r) { // <=
		if (r >= n - 1) return sum;
		int s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) s += v[r];
		return s;
	}

	int suff(int r) { // >=
		return sum - pref(r - 1);
	}

	int n;
	int sum = 0;
	vector<int> v;

};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			a[i][j]--;
		}
	}

	vector<vector<ll>> h(n, vector<ll>(m)), v(n, vector<ll>(m));
	for (int i = 0; i < n; i++) {
		vector<int> ys;
		for (int j = 0; j < m; j++) {
			ys.push_back(a[i][j]);
		}
		sort(all(ys));
		ys.resize(unique(all(ys)) - ys.begin());
		fenwick f(ys.size());
		for (int j = m - 1; j >= 0; j--) {
			int pos = lower_bound(all(ys), a[i][j]) - ys.begin();
			h[i][j] = (j + 1 < m ? h[i][j + 1] : 0) + f.pref(pos);
			f.add(pos, 1);
		}
	}

	for (int j = 0; j < m; j++) {
		vector<int> ys;
		for (int i = 0; i < n; i++) {
			ys.push_back(a[i][j]);
		}
		sort(all(ys));
		ys.resize(unique(all(ys)) - ys.begin());
		fenwick f(ys.size());
		for (int i = n - 1; i >= 0; i--) {
			int pos = lower_bound(all(ys), a[i][j]) - ys.begin();
			v[i][j] = (i + 1 < n ? v[i + 1][j] : 0) + f.pref(pos);
			f.add(pos, 1);
		}
	}

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << h[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	//
	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << v[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }

	vector<vector<ll>> dp(n, vector<ll>(m, 1e18));
	for (int i = n - 1; i >= 0; i--) {
		fenwick f(n * m);

		vector<int> ys;
		for (int j = 0; j < m; j++) {
			ys.push_back(a[i][j]);
		}
		sort(all(ys));
		ys.resize(unique(all(ys)) - ys.begin());
		fenwick fr(ys.size());

		ll a2 = 0; // row
		for (int j = m - 1; j >= 0; j--) {
			int pos = lower_bound(all(ys), a[i][j]) - ys.begin();
			fr.add(pos, 1);

			ll a1 = 0; // column
			for (int i1 = i; i1 < n; i1++) {
				a1 += f.pref(a[i1][j]);
				if (i1 > i) {
					a2 += fr.suff(lower_bound(all(ys), a[i1][j]) - ys.begin());
				}
			}
			a2 += f.pref(a[i][j]) - fr.pref(pos) + 1;

			dp[i][j] = min(dp[i][j], (j + 1 < m ? dp[i][j + 1] : 0) + a1 + v[i][j]);
			dp[i][j] = min(dp[i][j], (i + 1 < n ? dp[i + 1][j] : 0) + a2 + h[i][j]);

			for (int i1 = i; i1 < n; i1++) {
				f.add(a[i1][j], 1);
			}
		}
	}

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << dp[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }

	cout << dp[0][0];
}

int32_t main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();
}