#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(v) (v).begin(), (v).end()

vector<int> solve(int n, int q, vector<int> a, vector<pair<int, int>> qr) {
	int lg_n = __lg(n) + 1;
	vector<vector<int>> sp(lg_n, vector<int>(n));
	iota(all(sp[0]), 0);
	for (int l = 1; l < lg_n; l++) {
		for (int i = 0; i + (1 << l) - 1 < n; i++) {
			if (a[sp[l - 1][i]] < a[sp[l - 1][i + (1 << (l - 1))]]) {
				sp[l][i] = sp[l - 1][i];
			} else {
				sp[l][i] = sp[l - 1][i + (1 << (l - 1))];
			}
		}
	}

	auto get = [&](int l, int r) {
		int g = __lg(r - l + 1);
		if (a[sp[g][l]] < a[sp[g][r - (1 << g) + 1]]) return sp[g][l];
		else return sp[g][r - (1 << g) + 1];
	};

	vector<vector<int>> sp_mx(lg_n, vector<int>(n));
	sp_mx[0] = a;
	for (int l = 1; l < lg_n; l++) {
		for (int i = 0; i + (1 << l) - 1 < n; i++) {
			sp_mx[l][i] = max(sp_mx[l - 1][i], sp_mx[l - 1][i + (1 << (l - 1))]);
		}
	}

	auto get_mx = [&](int l, int r) {
		int g = __lg(r - l + 1);
		return max(sp_mx[g][l], sp_mx[g][r - (1 << g) + 1]);
	};

	vector<int> rg(n);
	{
		vector<int> st;
		for (int i = n - 1; i >= 0; i--) {
			while (!st.empty() && a[st.back()] < a[i]) st.pop_back();
			if (st.empty()) rg[i] = n;
			else rg[i] = st.back();
			st.push_back(i);
		}
	}

	vector<vector<int>> mem(n + 1);
	auto calc = [&](int k, int i) {
		if (mem[k].empty()) {
			int nk = k, pos = 0;
			while (pos < n) {
				if (nk == n - pos) {
					break;
				}

				int nx;
				if (nk >= 3) {
					int rb = min(rg[pos] - 1, n - nk);
					if (rb == pos) nx = pos + 1;
					else nx = get(pos + 1, min(n - 1, rb + 1));
				} else if (nk == 2) {
					nx = min(rg[pos], n - 1);
				} else {
					nx = n;
				}

				mem[k].push_back(get_mx(pos, nx - 1));
				pos = nx;
				nk--;
			}
		}
		if (i < mem[k].size()) return mem[k][i];
		else return a[n - (k - i)];
	};

	vector<int> ans(q);
	for (int id = 0; id < q; id++) {
		auto [k, i] = qr[id];
		ans[id] = calc(k, i - 1);
	}
	return ans;
}

vector<int> stupid(int n, int q, vector<int> a, vector<pair<int, int>> qr) {
	vector<vector<int>> res(n + 1);
	for (int mask = 1; mask < (1 << n); mask += 2) {
		int mx;
		vector<int> t;
		for (int i = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				if (i != 0) t.push_back(mx);
				mx = a[i];
			}
			else mx = max(mx, a[i]);
		}
		t.push_back(mx);
		if (res[t.size()].empty()) res[t.size()] = t;
		else res[t.size()] = min(res[t.size()], t);
	}

	vector<int> ans(q);
	for (int id = 0; id < q; id++) {
		auto [k, i] = qr[id];
		ans[id] = res[k][i - 1];
	}
	return ans;
}

vector<int> solve2(int n, int q, vector<int> a, vector<pair<int, int>> qr) {
	vector<int> suff(n);
	for (int i = n - 1; i >= 0; i--) {
		suff[i] = a[i];
		if (i + 1 < n) suff[i] = max(suff[i], suff[i + 1]);
	}

	vector<int> ans(q);
	for (int id = 0; id < q; id++) {
		auto [x, y] = qr[id];
		if (y + 1 < x) ans[id] = a[y - 1];
		else if (y < x) {
			ans[id] = a[y - 1];
		} else {
			if (y >= 2) {
				if ((y - 2) % 2 == 0) ans[id] = suff[y - 1];
				else ans[id] = a[n - 1];
			} else {
				ans[id] = suff[y - 1];
			}
		}
	}
	return ans;
}

vector<int> solve3(int n, int q, vector<int> a, vector<pair<int, int>> qr) {
	int lg_n = __lg(n) + 1;
	vector<vector<int>> sp(lg_n, vector<int>(n));
	iota(all(sp[0]), 0);
	for (int l = 1; l < lg_n; l++) {
		for (int i = 0; i + (1 << l) - 1 < n; i++) {
			if (a[sp[l - 1][i]] < a[sp[l - 1][i + (1 << (l - 1))]]) {
				sp[l][i] = sp[l - 1][i];
			} else {
				sp[l][i] = sp[l - 1][i + (1 << (l - 1))];
			}
		}
	}

	auto get = [&](int l, int r) {
		int g = __lg(r - l + 1);
		if (a[sp[g][l]] < a[sp[g][r - (1 << g) + 1]]) return sp[g][l];
		else return sp[g][r - (1 << g) + 1];
	};

	vector<vector<int>> sp_mx(lg_n, vector<int>(n));
	sp_mx[0] = a;
	for (int l = 1; l < lg_n; l++) {
		for (int i = 0; i + (1 << l) - 1 < n; i++) {
			sp_mx[l][i] = max(sp_mx[l - 1][i], sp_mx[l - 1][i + (1 << (l - 1))]);
		}
	}

	auto get_mx = [&](int l, int r) {
		int g = __lg(r - l + 1);
		return max(sp_mx[g][l], sp_mx[g][r - (1 << g) + 1]);
	};

	vector<int> rg(n);
	{
		vector<int> st;
		for (int i = n - 1; i >= 0; i--) {
			while (!st.empty() && a[st.back()] < a[i]) st.pop_back();
			if (st.empty()) rg[i] = n;
			else rg[i] = st.back();
			st.push_back(i);
		}
	}

	vector<int> des(n, n - 1);
	for (int i = n - 2; i >= 0; i--) {
		if (a[i] > a[i + 1]) des[i] = i;
		else des[i] = des[i + 1];
	}

	auto calc = [&](int k, int i) -> int {
		int nk = k, pos = 0, ps = 0, cnt = 0;
		while (pos < n) {
			int jp = max(0, min({nk - 4, ps - i, des[pos] - pos}));
			pos += jp;
			nk -= jp;
			ps += jp;

			int nx;
			if (nk >= 3) {
				int rb = min(rg[pos] - 1, n - nk);
				if (rb == pos) nx = pos + 1;
				else nx = get(pos + 1, min(n - 1, rb + 1));
			} else if (nk == 2) {
				nx = min(rg[pos], n - 1);
			} else {
				nx = n;
			}

			if (ps == i) return get_mx(pos, nx - 1);

			pos = nx;
			nk--;
			ps++;
			assert(++cnt <= 50);
		}
		assert(false);
	};

	vector<int> ans(q);
	for (int id = 0; id < q; id++) {
		auto [k, i] = qr[id];
		ans[id] = calc(k, i - 1);
	}
	return ans;
}


// vector<int> solve3(int n, int q, vector<int> a, vector<pair<int, int>> qr) {
// 	vector<vector<int>> v;
// 	for (int i = 0; i < n; i++) {
// 		if (i > 0 && v.back().back() > a[i]) v.back().push_back(a[i]);
// 		else {
// 			v.emplace_back();
// 			v.back().push_back(a[i]);
// 		}
// 	}
//
// 	vector<int> ss;
// 	for (int i = 0; i < v.size(); i++) ss.push_back(v[i].size());
// 	for (int i = (int)v.size() - 2; i >= 0; i--) ss[i] += ss[i + 1];
//
// 	vector<int> ans(q);
//
// 	for (int id = 0; id < q; id++) {
// 		auto [k, i] = qr[id]; i--;
//
// 		vector<int> t;
// 		int j = 0;
// 		while (j + 1 < v.size()) {
// 			if (v[j].size() == 1) {
// 				if (k > 1)
// 			}
// 			t.push_back(v[j][0]);
// 			t.push_back(v[j].back());
// 			j++;
// 		}
//
// 	}
// 	return ans;
// }

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int32_t main() {
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	for (int& x : a) cin >> x;
	vector<pair<int, int>> qr(q);
	for (auto& [a, b] : qr) cin >> a >> b;

	auto res = solve3(n, q, a, qr);
	for (int x : res) cout << x << " ";
	//
	// while (true) {
	// 	int n = 1 + rnd() % 5, q = 1 + rnd() % 5;
	// 	vector<int> a(n);
	// 	for (int i = 0; i < n; i++) {
	// 		if (i % 2 == 0) a[i] = i / 2 + 1;
	// 		else a[i] = n - i / 2;
	// 	}
	// 	// iota(all(a), 1);
	// 	// shuffle(all(a), rnd);
	// 	vector<pair<int, int>> qr(q);
	// 	for (auto& [a, b] : qr) {
	// 		a = 1 + rnd() % n;
	// 		b = 1 + rnd() % a;
	// 	}
	//
	// 	auto res = solve(n, q, a, qr);
	// 	auto ans = stupid(n, q, a, qr);
	//
	// 	if (ans != res) {
	// 		cout << n << " " << q << "\n";
	// 		for (int x : a) cout << x << " ";
	// 		cout << "\n";
	// 		for (auto [a, b] : qr) cout << a << " " << b << "\n";
	// 		cout << "\n";
	// 	}
	// }
}

// 5 5
// 1 5 2 4 3
// 4 1
// 4 4
// 2 2
// 5 5
// 1 1