#pragma GCC optimize("Ofast","unroll-loops")
#include <iostream>
#include <vector>
using namespace std;
const int inf = 1e18, N = 601;
int a[N][N], inva[N][N], invb[N][N], ans1[N][N], ans2[N][N], dp[N][N];

struct segtree {
    int siz;
    vector<int> tree;

    void init(int n) {
        siz = 1;
        while (siz < n) {
            siz *= 2;
        }
        tree.assign(2 * siz, 0);
    }

    void upd(int i) {
        int v = i + siz;
        while (v) {
            tree[v]++;
            v >>= 1;
        }
    }

    int get_ans(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l)return 0;
        if (ql <= l && r <= qr)return tree[v];
        int mid = (l + r) / 2;
        return get_ans(2 * v, l, mid, ql, qr) + get_ans(2 * v + 1, mid, r, ql, qr);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    segtree st;
    for (int i = 0; i < n; ++i) {
        st.init(n * m + 1);
        for (int j = m - 1; j >= 0; --j) {
            inva[i][j] = inva[i][j + 1] + st.get_ans(1, 0, st.siz, 0, a[i][j]);
            st.upd(a[i][j]);
        }
    }
    for (int j = 0; j < m; ++j) {
        st.init(n * m + 1);
        for (int i = n - 1; i >= 0; --i) {
            invb[i][j] = invb[i + 1][j] + st.get_ans(1, 0, st.siz, 0, a[i][j]);
            st.upd(a[i][j]);
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        st.init(n * m + 1);
        for (int j = m - 1; j >= 0; --j) {
            for (int i1 = i; i1 < n; ++i1) {
                ans1[i][j] += st.get_ans(1, 0, st.siz, 0, a[i1][j]);
            }
            for (int i1 = i; i1 < n; ++i1) {
                st.upd(a[i1][j]);
            }
        }
    }
    for (int j = m - 1; j >= 0; --j) {
        st.init(n * m + 1);
        for (int i = n - 1; i >= 0; --i) {
            for (int j1 = j; j1 < m; ++j1) {
                ans2[i][j] += st.get_ans(1, 0, st.siz, 0, a[i][j1]);
            }
            for (int j1 = j; j1 < m; ++j1) {
                st.upd(a[i][j1]);
            }
        }
    }
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < m + 1; ++j) {
            dp[i][j] = inf;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i < n) {
                dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + inva[i][j] + ans2[i][j]);
            }
            if (j < m) {
                dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + invb[i][j] + ans1[i][j]);
            }
        }
    }
    cout << dp[n][m];
    return 0;
}
