#include <bits/stdc++.h>
#define int long long
using namespace std;
const int inf = 1e18;

struct segtree {
    int siz;
    vector<int> tree;

    void init(int n) {
        siz = 1;
        while (siz < n) {
            siz *= 2;
        }
        tree.assign(2 * siz - 1, 0);
    }

    void upd(int v, int l, int r, int i) {
        if (r - l == 1) {
            tree[v]++;
            return;
        }
        int mid = (l + r) / 2;
        if (i < mid) {
            upd(2 * v + 1, l, mid, i);
        } else {
            upd(2 * v + 2, mid, r, i);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    int get_ans(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l)return 0;
        if (ql <= l && r <= qr)return tree[v];
        int mid = (l + r) / 2;
        return get_ans(2 * v + 1, l, mid, ql, qr) + get_ans(2 * v + 2, mid, r, ql, qr);
    }
};

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<int> > dp(n + 1, vector<int>(m + 1, inf));
    dp[0][0] = 0;
    segtree st;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i < n) {
                vector<int> z;
                for (int j1 = j; j1 < m; ++j1) {
                    z.push_back(a[i][j1]);
                }
                int cn = 0;
                for (int i1 = 0; i1 < z.size(); ++i1) {
                    for (int i2 = i1 + 1; i2 < z.size(); ++i2) {
                        if (z[i1] > z[i2])cn++;
                    }
                }
                st.init(n * m + 1);
                for (int i1 = i + 1; i1 < n; ++i1) {
                    for (int j1 = j; j1 < m; ++j1) {
                        st.upd(0, 0, st.siz, a[i1][j1]);
                    }
                }
                for (int i1 = 0; i1 < z.size(); ++i1) {
                    cn += st.get_ans(0, 0, st.siz, 0, z[i1]);
                }
                dp[i + 1][j] = min(dp[i + 1][j], cn + dp[i][j]);
            }
            if (j < m) {
                vector<int> z;
                for (int i1 = i; i1 < n; ++i1) {
                    z.push_back(a[i1][j]);
                }
                int cn = 0;
                for (int i1 = 0; i1 < z.size(); ++i1) {
                    for (int i2 = i1 + 1; i2 < z.size(); ++i2) {
                        if (z[i1] > z[i2])cn++;
                    }
                }
                st.init(n * m + 1);
                for (int i1 = i; i1 < n; ++i1) {
                    for (int j1 = j + 1; j1 < m; ++j1) {
                        st.upd(0, 0, st.siz, a[i1][j1]);
                    }
                }
                for (int i1 = 0; i1 < z.size(); ++i1) {
                    cn += st.get_ans(0, 0, st.siz, 0, z[i1]);
                }
                dp[i][j + 1] = min(dp[i][j + 1], cn + dp[i][j]);
            }
        }
    }
    cout << dp[n][m];
    return 0;
}
