#pragma GCC optimize("Ofast","unroll-loops");
#include <bits/stdc++.h>
using namespace std;
const int inf = 1e18;

struct segtree {
    int siz;
    vector<int> tree;

    inline void init(int n) {
        siz = 1;
        while (siz < n) {
            siz *= 2;
        }
        tree.assign(2 * siz - 1, 0);
    }

    inline void upd(int v, int l, int r, int i) {
        if (r - l == 1) {
            tree[v]++;
            return;
        }
        int mid = (l + r) / 2;
        if (i < mid) {
            upd(2 * v + 1, l, mid, i);
        } else {
            upd(2 * v + 2, mid, r, i);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    inline int get_ans(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l)return 0;
        if (ql <= l && r <= qr)return tree[v];
        int mid = (l + r) / 2;
        return get_ans(2 * v + 1, l, mid, ql, qr) + get_ans(2 * v + 2, mid, r, ql, qr);
    }
};

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<int> > inva(n + 1, vector<int>(m + 1, 0));
    segtree st;
    for (int i = 0; i < n; ++i) {
        st.init(n * m + 1);
        for (int j = m - 1; j >= 0; --j) {
            inva[i][j] = inva[i][j + 1] + st.get_ans(0, 0, st.siz, 0, a[i][j]);
            st.upd(0, 0, st.siz, a[i][j]);
        }
    }
    vector<vector<int> > invb(n + 1, vector<int>(m + 1, 0));
    for (int j = 0; j < m; ++j) {
        st.init(n * m + 1);
        for (int i = n - 1; i >= 0; --i) {
            invb[i][j] = invb[i + 1][j] + st.get_ans(0, 0, st.siz, 0, a[i][j]);
            st.upd(0, 0, st.siz, a[i][j]);
        }
    }
    vector<vector<int> > ans1(n + 1, vector<int>(m + 1, 0)), ans2(n + 1, vector<int>(m + 1, 0));
    for (int i = n - 1; i >= 0; --i) {
        st.init(n * m + 1);
        for (int j = m - 1; j >= 0; --j) {
            for (int i1 = i; i1 < n; ++i1) {
                ans1[i][j] += st.get_ans(0, 0, st.siz, 0, a[i1][j]);
            }
            for (int i1 = i; i1 < n; ++i1) {
                st.upd(0, 0, st.siz, a[i1][j]);
            }
        }
    }
    for (int j = m - 1; j >= 0; --j) {
        st.init(n * m + 1);
        for (int i = n - 1; i >= 0; --i) {
            for (int j1 = j; j1 < m; ++j1) {
                ans2[i][j] += st.get_ans(0, 0, st.siz, 0, a[i][j1]);
            }
            for (int j1 = j; j1 < m; ++j1) {
                st.upd(0, 0, st.siz, a[i][j1]);
            }
        }
    }
    vector<vector<int> > dp(n + 1, vector<int>(m + 1, inf));
    dp[0][0] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i < n) {
                dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + inva[i][j] + ans2[i][j]);
            }
            if (j < m) {
                dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + invb[i][j] + ans1[i][j]);
            }
        }
    }
    cout << dp[n][m];
    return 0;
}