// semenInRussia 2025
#include <algorithm>
#include <cassert>
#include <iostream>
#include <queue>
#include <set>
#include <vector>
using namespace std;

struct dot {
  int x;
  int y;
};

const int N = 5e5;
dot p[N];

using ll = long long;

ll dist(dot a, dot b) {
  ll r = a.x - b.x;
  ll p = a.y - b.y;
  return r * r + p * p;
}

vector<int> g[N];
int h[N];
bool used[N];

bool cycle(int x, int fa = -1) {
  h[x] = fa == -1 ? 0 : h[fa] + 1;
  used[x] = true;
  for (int y : g[x]) {
    if (y == fa) {
      continue;
    }
    if (used[y] && abs(h[x] - h[y]) % 2 == 0) {
      return true;
    }
    if (!used[y]) {
      if (cycle(y, x)) {
        return true;
      }
    }
  }
  return false;
}

bool used2[N];

int main() {
  int n;
  ll r;
  cin >> n >> r;

  for (int i = 0; i < n; i++) {
    cin >> p[i].x >> p[i].y;
  }

  r *= r;

  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      if (dist(p[i], p[j]) <= r) {
        g[i].push_back(j);
        g[j].push_back(i);
      }
    }
  }

  for (int x = 0; x < n; x++) {
    if (used[x] || used2[x]) {
      continue;
    }

    if (cycle(x)) {
      // cerr << "cycle " << x << "\n";
      used2[x] = true;
      queue<int> q;
      q.push(x);
      while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int y : g[x]) {
          if (!used2[y]) {
            used2[y] = true;
            q.push(y);
          }
        }
      }
    }
  }

  for (int i = 0; i < n; i++) {
    cout << used2[i];
  }
}