// semenInRussia 2025
#pragma GCC optimize("O3")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <queue>
#include <set>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

struct dot {
  int x;
  int y;
};

bool operator<(dot a, dot b) { return a.x < b.x || (a.x == b.x && a.y < b.y); }

const int N = 1e4 + 10;
dot p[N];
bool used2[N];

using ll = long long;

ll dist(dot a, dot b) {
  ll r = a.x - b.x;
  ll p = a.y - b.y;
  return r * r + p * p;
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n;
  ll r;
  cin >> n >> r;

  int rr = r;

  for (int i = 0; i < n; i++) {
    cin >> p[i].x >> p[i].y;
  }

  for (int i = 1; i < n; i++) {
    assert(p[i].y == p[i - 1].y);
  }

  sort(p, p + n);

  r *= r;

  for (int i = 1; i + 1 < n; i++) {
    if (used2[i]) {
      continue;
    }
    used2[i] = true;
    if (dist(p[i - 1], p[i + 1]) <= r) {
      for (int j = i + 1; j < n && !used2[j]; j++) {
        if (dist(p[j - 1], p[j]) <= r) {
          used2[j] = true;
        } else {
          break;
        }
      }
      for (int j = i - 1; j >= n && !used2[j]; j--) {
        if (dist(p[j + 1], p[j]) <= r) {
          used2[j] = true;
        } else {
          break;
        }
      }
    }
  }

  for (int i = 0; i < n; i++) {
    cout << used2[i];
  }
}