// semenInRussia 2025
#pragma GCC optimize("O3")
#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>
#pragma GCC target("avx2")
using namespace std;

struct dot {
  int x;
  int y;
};

bool operator<(dot a, dot b) {
  return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

const int N = 5e5;
dot p[N];

using ll = long long;

ll dist(dot a, dot b) {
  ll r = a.x - b.x;
  ll p = a.y - b.y;
  return r * r + p * p;
}

vector<int> g[N];
int h[N];
bool used[N];

bool cycle(int x, int fa = -1) {
  h[x] = fa == -1 ? 0 : h[fa] + 1;
  used[x] = true;
  for (int y : g[x]) {
    if (y == fa) {
      continue;
    }
    if (used[y] && abs(h[x] - h[y]) % 2 == 0) {
      return true;
    }
    if (!used[y]) {
      if (cycle(y, x)) {
        return true;
      }
    }
  }
  return false;
}

bool used2[N];

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n;
  ll r;
  cin >> n >> r;

  int rr = r;

  map<dot, int> mp;

  for (int i = 0; i < n; i++) {
    cin >> p[i].x >> p[i].y;
    mp[p[i]] = i;
  }

  for (int i = 0; i < n; i++) {
    int x = p[i].x;
    int y = p[i].y;
    for (int x1 = x - r; x1 <= x + r; x1++) {
      for (int y1 = y - r; y1 <= y + r; y1++) {
        dot l = {x1, y1};
        if (dist(l, p[i]) <= 1ll * r * r && mp.count(l)) {
          int y = mp[l];
          if (i != y) {
            g[i].push_back(y);
          }
        }
      }
    }
  }

  r *= r;

  for (int x = 0; x < n; x++) {
    if (used[x] || used2[x]) {
      continue;
    }

    if (cycle(x)) {
      // cerr << "cycle " << x << "\n";
      used2[x] = true;
      queue<int> q;
      q.push(x);
      while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int y : g[x]) {
          if (!used2[y]) {
            used2[y] = true;
            q.push(y);
          }
        }
      }
    }
  }

  for (int i = 0; i < n; i++) {
    cout << used2[i];
  }
}