// semenInRussia 2025
#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

struct fenw {
  int n;
  vector<int> t;
  vector<int> buf, used;
  int sz = 0;

  fenw(int _n) {
    n = _n;

    t.resize(n + 1);
    used.resize(n + 1);
  }

  void add(int j, int v) {
    ++j;
    sz += v;
    for (; j <= n; j += j & -j) {
      t[j] += v;
      if (!used[j]) {
        buf.push_back(j);
        used[j] = true;
      }
    }
  }

  void clear() {
    for (int j : buf) {
      used[j] = false;
      t[j] = 0;
    }
    sz = 0;
    buf.clear();
  }

  int sum(int r) {
    int s = 0;
    for (; r > 0; r -= r & -r) {
      s += t[r];
    }
    return s;
  }
};

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<vector<int>> a(n, vector<int>(m, 0));

  for (auto &row : a) {
    for (auto &el : row) {
      cin >> el;
    }
  }

  using ll = long long;
  const ll inf = 1e18 + 100;
  vector<vector<ll>> dp(n, vector<ll>(m, inf));

  dp[n - 1][m - 1] = 0;

  fenw suf(n * m + 1);
  fenw suf2(n * m + 1);

  for (int i = n - 1; i >= 0; i--) {
    ll inv = 0;
    suf.clear();
    suf2.clear();
    for (int j = m - 1; j >= 0; j--) {
      for (int i2 = i + 1; i2 < n; i2++) {
        inv += suf2.sz - suf2.sum(a[i2][j]);
        suf.add(a[i2][j], +1);
      }

      inv += suf2.sum(a[i][j]);
      inv += suf.sum(a[i][j]);

      suf2.add(a[i][j], +1);

      ll cur = inv;
      if (i + 1 < n) {
        cur += dp[i + 1][j];
      }
      dp[i][j] = min(dp[i][j], cur);
    }

    suf.clear();
    for (int j = m - 1; j >= 0; j--) {
      ll inv = 0;
      suf2.clear();
      for (int i2 = i; i2 < n; i2++) {
        inv += suf2.sz - suf2.sum(a[i2][j]);
        inv += suf.sum(a[i2][j]);
        suf2.add(a[i2][j], +1);
      }

      for (int i2 = i; i2 < n; i2++) {
        suf.add(a[i2][j], +1);
      }

      ll cur = inv;
      if (j + 1 < m) {
        cur += dp[i][j + 1];
      }
      dp[i][j] = min(dp[i][j], cur);
    }
  }

  cout << dp[0][0];
}