#include <vector>
#include <iostream>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
using namespace std;

using ll = long long;
using ld = long double;

const int maxn = 1e5;
const ll inf = 6e8;
vector<ll> x(maxn);
vector<ll> y(maxn);

vector<vector<int>> g(maxn, vector<int>(0));
vector<int> color(maxn, 0);
vector<int> d(maxn, 0);

int cur = 1;

ll dist2(ll x1, ll y1, ll x2, ll y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

ld dist(ll x1, ll y1, ll x2, ll y2) {
    return sqrt((ld)(x1 - x2) * (x1 - x2) + (ld)(y1 - y2) * (y1 - y2));
}



void dfs(int v, int& cyc) {
    color[v] = cur;
    for (int u : g[v]) {
        if (color[u] == cur) {
            if (d[u] % 2 == d[v] % 2) {
                cyc = 1;
            }
            continue;
        }
        d[u] = d[v] + 1;
        dfs(u, cyc);
    }
}

ll h(ll x, ll y) {
    return x * inf + y;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll r;
    cin >> n >> r;
    ll r2 = r * r;
    unordered_map<int, vector<pair<int, int>>> t;
    set<int> set_y;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
        set_y.insert(y[i]);
        t[y[i]].push_back({x[i], i});
    }
    for (auto yy : set_y) {
        sort(t[yy].begin(), t[yy].end());
    }
    for (int i = 0; i < n; i++) {
        auto it = set_y.lower_bound(y[i] - r);
        while (*it <= x[i] + r) {
            int yy = *it;
            int le = -1, ri = t[yy].size();
            while (ri - le > 1) {
                int m = (le + ri) / 2;
                if (t[yy][m].first >= x[i] - r) {
                    ri = m;
                } else {
                    le = m;
                }
            }
            for (int j = ri; j < t[yy].size() && t[yy][j].first <= x[i] + r; j++) {
                if (dist2(x[i], y[i], t[yy][j].first, yy) <= r2) {
                    if (t[yy][j].second == i) continue;
                    g[i].push_back(t[yy][j].second);
                }
            }
            it++;
            if (it == set_y.end()) break;
        }
    }
    vector<int> ans(1, 0);
    for (int i = 0; i < n; i++) {
        if (color[i] == 0) {
            int cyc = 0;
            dfs(i, cyc);
            ans.push_back(cyc);
            cur++;
        }
        
    }
    for (int i = 0; i < n; i++) {
        cout << ans[color[i]];
    }
}

