#include <vector>
#include <iostream>
#include <cmath>
#pragma GCC optimize("O3,unroll-loops")
using namespace std;
 
using ll = long long;

 
const int maxn = 1e4;
vector<ll> x(maxn);
vector<ll> y(maxn);
 
vector<vector<int>> g(maxn, vector<int>(0));
vector<int> color(maxn, 0);
vector<int> d(maxn, 0);
 
int cur = 1;
 
ll dist2(ll x1, ll y1, ll x2, ll y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}
 
void dfs(int v, int& cyc) {
    color[v] = cur;
    for (int u : g[v]) {
        if (color[u] == cur) {
            if (d[u] % 2 == d[v] % 2) {
                cyc = 1;
            }
            continue;
        }
        d[u] = d[v] + 1;
        dfs(u, cyc);
    }
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll r;
    cin >> n >> r;
    ll r2 = r * r;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
        for (int j = 0; j < i; j++) {
            if (dist2(x[i], y[i], x[j], y[j]) <= r2) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> ans(1, 0);
    for (int i = 0; i < n; i++) {
        if (color[i] == 0) {
            int cyc = 0;
            dfs(i, cyc);
            ans.push_back(cyc);
            cur++;
        }
         
    }
    for (int i = 0; i < n; i++) {
        cout << ans[color[i]];
    }
}