#include <vector>
#include <iostream>
#include <cmath>
#include <map>
#include <unordered_map>
using namespace std;

using ll = long long;
using ld = long double;

const int maxn = 1e5;
vector<ll> x(maxn);
vector<ll> y(maxn);

vector<vector<int>> g(maxn, vector<int>(0));
vector<int> color(maxn, 0);
vector<int> d(maxn, 0);

int cur = 1;

ll dist2(ll x1, ll y1, ll x2, ll y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

ld dist(ll x1, ll y1, ll x2, ll y2) {
    return sqrt((ld)(x1 - x2) * (x1 - x2) + (ld)(y1 - y2) * (y1 - y2));
}



void dfs(int v, int& cyc) {
    color[v] = cur;
    for (int u : g[v]) {
        if (color[u] == cur) {
            if (d[u] % 2 == d[v] % 2) {
                cyc = 1;
            }
            continue;
        }
        d[u] = d[v] + 1;
        dfs(u, cyc);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll r;
    cin >> n >> r;
    ll r2 = r * r;
    unordered_map<int, unordered_map<int, int>> t;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
        t[x[i]][y[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        for (ll xx = x[i] - r; xx <= x[i] + r; xx++) {
            for (ll yy = y[i]; dist2(x[i], y[i], xx, yy) <= r2; yy++) {
                if (xx == x[i] && yy == y[i]) continue;
                int j = t[xx][yy] - 1;
                if (j != -1) {
                    g[i].push_back(j);
                }
            }
            for (ll yy = y[i] - 1; dist2(x[i], y[i], xx, yy) <= r2; yy--) {
                int j = t[xx][yy] - 1;
                if (j != -1) {
                    g[i].push_back(j);
                }
            }
        }
    }
    vector<int> ans(1, 0);
    for (int i = 0; i < n; i++) {
        if (color[i] == 0) {
            int cyc = 0;
            dfs(i, cyc);
            ans.push_back(cyc);
            cur++;
        }
        
    }
    for (int i = 0; i < n; i++) {
        cout << ans[color[i]];
    }
}

