#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

const ll inf = 1e16 + 239;

void add(int v, int l, int r, int i, vector<int>& tr) {
    if (r - l == 1) {
        tr[v]++;
        return;        
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i, tr);
    } else {
        add(2 * v + 1, m, r, i, tr);
    }
    tr[v] = tr[2 * v] + tr[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr, vector<int>& tr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr, tr) + get(2 * v + 1, m, r, ql, qr, tr);
}

ll get_ans(vector<int>& b) {
    ll ans = 0;
    int n = b.size();
    vector<int> tr(4 * n, 0);
    for (int i = 0; i < n; i++) {
        ans += get(1, 0, n, b[i] + 1, n, tr);
        add(1, 0, n, b[i], tr);
    }
    return ans;
}

int main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> t(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> t[i][j];
            t[i][j]--;
        }
    }
    ll ans = inf;
    for (int mask = 0; mask < (1 << (h + w)); mask++) {
        vector<int> b(0);
        int u = 0, l = 0;
        for (int i = 0; i < h + w && u < h && l < w; i++) {
            if ((mask >> i) & 1) {
                for (int j = l; j < w; j++) {
                    b.push_back(t[u][j]);
                }
                u++;
            } else {
                for (int j = u; j < h; j++) {
                    b.push_back(t[j][l]);
                }
                l++;
            }
        }
        ans = min(ans, get_ans(b));
    }
    cout << ans;
}