#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

const ll inf = 1e16 + 239;

int min(int a, int b) {
    if (a < b) return a;
    return b;
}
/*
void add(int v, int l, int r, int i, vector<int>& tr) {
    if (r - l == 1) {
        tr[v]++;
        return;        
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i, tr);
    } else {
        add(2 * v + 1, m, r, i, tr);
    }
    tr[v] = tr[2 * v] + tr[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr, vector<int>& tr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr, tr) + get(2 * v + 1, m, r, ql, qr, tr);
}

*/
int getf(int x, vector<int>& fw) {
    int ans = 0;
    for (; x > 0; x -= x & (-x)) {
        ans += fw[x];
    }
    return ans;
}

void updf(int x, int maxx, vector<int>& fw) {
    for (; x < maxx; x += (x & (-x))) {
        fw[x]++;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<int>> t(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> t[i][j];
            t[i][j] = h * w - t[i][j] + 1;
        }
    }
    if (w > h) {
        vector<vector<int>> tt(w, vector<int>(h, 0));
        for (int j = 0; j < w; j++) {
            for (int i = 0; i < h; i++) {
                tt[j][i] = t[i][j];
            }
        }
        swap(h, w);
        swap(t, tt);
    }
    vector<ll> dp_pr(w + 1, inf);
    vector<ll> dp_cur(w + 1, inf);
    /*
    vector<vector<int>> pr(w + 1, vector<int>(4 * h * w, 0));
    vector<vector<int>> cur(w + 1, vector<int>(4 * h * w, 0));
    */
    vector<vector<int>> pr(w + 1, vector<int>(h * w + 1, 0));
    vector<vector<int>> cur(w + 1, vector<int>(h * w + 1, 0));
    dp_cur[0] = 0;
    ll ans = inf;
    for (int i = 0; i <= h; i++) {
        for (int j = 0; j <= w; j++) {
            ll up = inf, left = inf;
            if (i > 0) {
                cur[j] = pr[j];
                up = dp_pr[j];
                for (int x = j; x < w; x++) {
                    up += getf(t[i - 1][x], cur[j]);
                    updf(t[i - 1][x], h * w + 1, cur[j]);
                    //up += get(1, 0, h * w, t[i - 1][x], h * w, cur[j]);
                    //add(1, 0, h * w, t[i - 1][x], cur[j]);
                }
                dp_cur[j] = up;
            }
            if (j > 0) {
                vector<int> tr_l = cur[j - 1];
                left = dp_cur[j - 1];
                for (int y = i; y < h; y++) {
                    left += getf(t[y][j - 1], tr_l);
                    updf(t[y][j - 1], h * w + 1, tr_l);
                    //left += get(1, 0, h * w, t[y][j - 1], h * w, tr_l);
                    //add(1, 0, h * w, t[y][j - 1], tr_l);
                }
                if (dp_cur[j] > left) {
                    dp_cur[j] = left;
                    swap(tr_l, cur[j]);
                }
            }
            if (i == h || j == w) {
                ans = min(ans, dp_cur[j]);
            }
        }
        swap(pr, cur);
        swap(dp_cur, dp_pr);
        dp_cur.assign(w + 1, inf);
        //cur.assign(w + 1, vector<int>(4 * h * w, 0));
        cur.assign(w + 1, vector<int>(h * w + 1, 0));
    }
    cout << ans;
}