#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

const ll inf = 1e16 + 239;

int min(int a, int b) {
    if (a < b) return a;
    return b;
}

void add(int v, int l, int r, int i, vector<int>& tr) {
    if (r - l == 1) {
        tr[v]++;
        return;        
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i, tr);
    } else {
        add(2 * v + 1, m, r, i, tr);
    }
    tr[v] = tr[2 * v] + tr[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr, vector<int>& tr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr, tr) + get(2 * v + 1, m, r, ql, qr, tr);
}

ll get_ans(vector<int>& b) {
    ll ans = 0;
    int n = b.size();
    vector<int> tr(4 * n, 0);
    for (int i = 0; i < n; i++) {
        ans += get(1, 0, n, b[i] + 1, n, tr);
        add(1, 0, n, b[i], tr);
    }
    return ans;
}

int main() {
    int h, w;
    cin >> h >> w;
    vector<vector<int>> t(h, vector<int>(w, 0));
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> t[i][j];
            t[i][j]--;
        }
    }
    vector<vector<ll>> dp(h + 1, vector<ll>(w + 1, inf));
    vector<vector<vector<int>>> tr(h + 1, vector<vector<int>>(w + 1, vector<int>(4 * h * w, 0)));
    dp[0][0] = 0;
    ll ans = inf;
    for (int i = 0; i <= h; i++) {
        for (int j = 0; j <= w; j++) {
            ll up = inf, left = inf;
            if (i > 0) {
                tr[i][j] = tr[i - 1][j];
                up = dp[i - 1][j];
                for (int x = j; x < w; x++) {
                    up += get(1, 0, h * w, t[i - 1][x], h * w, tr[i][j]);
                    add(1, 0, h * w, t[i - 1][x], tr[i][j]);
                }
                dp[i][j] = up;
            }
            if (j > 0) {
                vector<int> tr_l = tr[i][j - 1];
                left = dp[i][j - 1];
                for (int y = i; y < h; y++) {
                    left += get(1, 0, h * w, t[y][j - 1], h * w, tr_l);
                    add(1, 0, h * w, t[y][j - 1], tr_l);
                }
                if (dp[i][j] > left) {
                    dp[i][j] = left;
                    swap(tr_l, tr[i][j]);
                }
            }
            if (i == h || j == w) {
                ans = min(ans, dp[i][j]);
            }
        }
    }
    cout << ans;
}