#include <iostream>
#include <vector>
using namespace std;

pair<int, int> get(int l, int r, vector<vector<pair<int, int>>>& st) {
    int p = __lg(r - l);
    return min(st[p][l], st[p][r - (1 << p)]);
}

int getmax(int l, int r, vector<vector<int>>& st) {
    int p = __lg(r - l);
    return max(st[p][l], st[p][r - (1 << p)]);
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    int maxp = __lg(n) + 1;
    vector<vector<pair<int, int>>> st(maxp, vector<pair<int, int>>(n));
    vector<vector<int>> maxx(maxp, vector<int>(n));
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st[0][i] = {a[i], i};
        maxx[0][i] = a[i];
    }
    for (int p = 1; p < maxp; p++) {
        for (int i = 0; i + (1 << p) <= n; i++) {
            st[p][i] = min(st[p - 1][i], st[p - 1][i + (1 << (p - 1))]);
            maxx[p][i] = max(maxx[p - 1][i], maxx[p - 1][i + (1 << (p - 1))]);
        }
    }
    vector<int> right(n, 0);
    right[n - 1] = n;
    for (int i = n - 1; i >= 0; i--) {
        int l = i, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (getmax(i, m + 1, maxx) > a[i]) {
                r = m;
            } else {
                l = m;
            }
        }
        right[i] = r;

    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        int l = 0;
        for (int j = 0; j < i; j++) {
            int left = k - j - 1;
            int r = min(right[l], n - left) + 1;
            auto res = get(l + 1, min(n, r), st);
            l = res.second;
        }
        int ans = a[l];
        if (k - 1 == i) {
            ans = getmax(l, n, maxx);
        }
        cout << ans << '\n';
    }
    
}