#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ldb long double

#pragma GCC("O2")

ll const inf = 1e9 + 3;

#define ve vector
#define pb push_back


void merge(ve<ll> &a, ll l, ll m, ll r, long long &ans) {
    ll res[r - l];
    ll tl = l;
    ll tm = m;
    ll cnt = 0;
    while (tl < m && tm < r) {
        if (a[tl] > a[tm]) {
            res[cnt++] = a[tm];
            tm++;
        } else {
            ans += tm - m;
            res[cnt++] = a[tl];
            tl++;
        }
    }
    while (tl < m) {
        ans += tm - m;
        res[cnt++] = a[tl];
        tl++;
    }
    while (tm < r) {
        res[cnt++] = a[tm];
        tm++;
    }
    for (ll x = l; x < r; x++) {
        a[x] = res[x - l];
    }
}

void merge_sort(ve<ll> &a, ll l, ll r, long long &ans) {
    if (r - l == 1) {
        return;
    }
    ll m = (l + r) / 2;
    merge_sort(a, l, m, ans);
    merge_sort(a, m, r, ans);
    merge(a, l, m, r, ans);
}

ve<ll> merge_dif(ve<ll> &a, ve<ll> &b, long long &ans) {
    ll l = 0;
    ll r = 0;
    ve<ll> res(0);
    res.reserve(a.size() + b.size());
    while (l < a.size() && r < b.size()) {
        if (a[l] > b[r]) {
            res.pb(b[r]);
            r++;
        } else {
            ans += r;
            res.pb(a[l]);
            l++;
        }
    }
    while (l < a.size()) {
        res.pb(a[l]);
        l++;
        ans += r;
    }
    while (r < b.size()) {
        res.pb(b[r]);
        r++;
    }
    return res;
}

bool comp(ve<ll> &a, ve<ll> &b) {
    for (ll i = 0; i < a.size(); i++) {
        if (a[i] < b[i])
            return true;
        if (a[i] > b[i])
            return false;
    }
    return true;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    ll q;
    cin >> n >> q;
    ll a[n];
    ll i, j;
    for (i = 0; i < n; i++) {
        cin >> a[i];
    }
    ve<ve<ll> > to_comp(n + 1);
    for (i = 0; i < n + 1; i++) {
        to_comp[i].assign(i, inf);
    }
    for (ll mask = 0; mask < (1 << n); mask++) {
        ve<ll> nw_ve(0);
        ll cnt = 0;
        for (i = 0; i < n; i++) {
            cnt += (mask & 1 << i) > 0;
        }
        ll br[n];
        for (i = 0; i < n; i++) {
            br[i] = (mask & 1 << i) > 0;
        }
        if (mask & 1 << 0) {
            ll mx_cur = a[0];
            for (i = 1; i < n; i++) {
                if (br[i]) {
                    nw_ve.pb(mx_cur);
                    mx_cur = a[i];
                } else {
                    mx_cur = max(mx_cur, a[i]);
                }
            }
            nw_ve.pb(mx_cur);
            if (!comp(to_comp[cnt], nw_ve)) {
                to_comp[cnt] = nw_ve;
            }
        }
    }
    while (q--) {
        ll k, x;
        cin >> k >> x;
        x--;
        cout << to_comp[k][x] << '\n';
    }
}
