#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using point = pair<int, int>;

ull dist(point a, point b)
{
	ull x = abs(a.first - b.first), y = abs(a.second - b.second);
	return x * x + y * y;
}
vector<int> p, sz;
vector<int> dd;
vector<bool> ans;
int pr(int v)
{
	if (p[v] == v) return v;
	return p[v] = pr(p[v]);
}
void merge(int v, int u)
{
	int sv = v, su = u;
	v = pr(v);
	u = pr(u);
	if (v == u)
	{
		//if((dd[sv]+dd[su])%2==0)ans[v] = true;
		return;
	}
	if (sz[v] < sz[u]) swap(v, u);
	p[u] = v;
	sz[v] += sz[u];
}
vector<int> used;
vector<vector<bool>> g;
int n;
bool dfs(int v)
{
	for (int u = 0; u < n; u++)
	{
		if (!g[v][u]) continue;
		if (used[u] == -1)
		{
			used[u] = used[v] + 1;
			if (dfs(u)) return true;
		}
		else
		{
			if ((used[v] - used[u] + 1) % 2 == 1)
			{
				return true;
			}
		}
	}
	return false;
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	 ll r;
	cin >> n >> r;
	vector<pair<point,int>> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first.first >> a[i].first.second;
		a[i].second = i;
	}
	sort(a.begin(), a.end());
	p.resize(n); sz.resize(n, 1); ans.resize(n); dd.resize(n);  g.resize(n,vector<bool>(n,false));
	for (int i = 0; i < n; i++) p[i] = i;
	for (int i = 0; i < n; i++)
	{
		for (int j = i+1; j < n; j++)
		{
			if (dist(a[i].first, a[j].first) <= r * r)
			{
				g[i][j] = true;
				g[j][i] = true;
				merge(i, j);
			}
		}
	}
	vector<bool> b(n);
	used.resize(n, -1);
	for (int i = 0; i < n; i++)
	{
		if (p[i] == i)
		{
			used[i] = 0;
			ans[i] = dfs(i);
		}
	}
	for (int i = 0; i < n; i++)
	{
		b[a[i].second] = ans[pr(i)];
	}
	for (int i = 0; i < n; i++)
	{
		cout << b[i];
	}
}