#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using point = pair<ll, ll>;

ull dist(point a, point b)
{
	ull x = abs(a.first - b.first), y = abs(a.second - b.second);
	return x * x + y * y;
}
vector<int> p, sz;
vector<int> dd;
vector<bool> ans;
int pr(int v)
{
	if (p[v] == v) return v;
	return p[v] = pr(p[v]);
}
void merge(int v, int u)
{
	int sv = v, su = u;
	v = pr(v);
	u = pr(u);
	if (v == u)
	{
		if((dd[sv]+dd[su])%2==0)ans[v] = true;
		return;
	}
	if (sz[v] < sz[u]) swap(v, u);
	p[u] = v;
	sz[v] += sz[u];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n; ll r;
	cin >> n >> r;
	vector<pair<point,int>> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first.first >> a[i].first.second;
		a[i].second = i;
	}
	sort(a.begin(), a.end());
	p.resize(n); sz.resize(n, 1); ans.resize(n); dd.resize(n);
	for (int i = 0; i < n; i++) p[i] = i;
	set<point> s;
	int l = 0;
	for (int i = 0; i < n; i++)
	{
		while (l < i && a[l].first.first < a[i].first.first - r)
		{
			s.erase({ a[l].first.second,l });
			l++;
		}
		{
			auto it = s.lower_bound({ a[i].first.second - r,-1 });
			while (it != s.end() && (*it).first <= a[i].first.second + r)
			{
				int ind = (*it).second;
				if (dist(a[i].first, a[ind].first) <= r * r)
				{
					dd[i] = min(dd[i], dd[ind] + 1);
					//merge(i, ind);
				}
				it++;
			}
		}
		{
			auto it = s.lower_bound({ a[i].first.second - r,-1 });
			while (it != s.end() && (*it).first <= a[i].first.second + r)
			{
				int ind = (*it).second;
				if (dist(a[i].first, a[ind].first) <= r * r)
				{
					merge(i, ind);
				}
				it++;
			}
		}
		s.insert({ a[i].first.second,i });
	}
	vector<bool> b(n);
	for (int i = 0; i < n; i++)
	{
		b[a[i].second] = ans[pr(i)];
	}
	for (int i = 0; i < n; i++)
	{
		cout << b[i];
	}
}