#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include<map>
#include <set>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using point = pair<int, int>;
const ll LINF = 1e18 + 7;

ull dist(point a, point b)
{
	ull x = abs(a.first - b.first), y = abs(a.second - b.second);
	return x * x + y * y;
}
vector<int> p, sz;
vector<int> dd;
vector<bool> ans;
int pr(int v)
{
	if (p[v] == v) return v;
	return p[v] = pr(p[v]);
}
void merge(int v, int u)
{
	int sv = v, su = u;
	v = pr(v);
	u = pr(u);
	if (v == u)
	{
		//if((dd[sv]+dd[su])%2==0)ans[v] = true;
		return;
	}
	if (sz[v] < sz[u]) swap(v, u);
	p[u] = v;
	sz[v] += sz[u];
}
vector<int> used;
vector<vector<int>> g;
bool dfs(int v)
{
	for (int u : g[v])
	{
		if (used[u] == -1)
		{
			used[u] = used[v] + 1;
			if (dfs(u)) return true;
		}
		else
		{
			if ((used[v] - used[u] + 1) % 2 == 1)
			{
				return true;
			}
		}
	}
	return false;
}

struct fenvik
{
	vector<ll> a;
	int n;
	fenvik(int _n) : n(_n)
	{
		a.resize(n + 1);
	}
	void add(int i, int x)
	{
		for (i; i <= n; i += i & -i)
		{
			a[i] += x;
		}
	}
	ll get(int i)
	{
		ll ans = 0;
		for (i; i > 0; i -= i & -i)
		{
			ans += a[i];
		}
		return ans;
	}
};


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++) cin >> a[i][j];
	}
	vector<vector<ll>> row(n, vector<ll>(m)), col(n, vector<ll>(m));
	fenvik fen(n*m);
	for (int i = 0; i < n; i++)
	{
		for (int j = m-1; j >= 0; j--)
		{
			row[i][j] = fen.get(a[i][j]-1);
			fen.add(a[i][j], 1);
			if (j + 1 < m) row[i][j] += row[i][j + 1];
		}
		for (int j = m - 1; j >= 0; j--)
		{
			fen.add(a[i][j], -1);
		}
	}
	for (int j = 0; j < m; j++)
	{
		for (int i = n-1; i >=0 ; i--)
		{
			col[i][j] = fen.get(a[i][j] - 1);
			fen.add(a[i][j], 1);
			if (i + 1 < n) col[i][j] += col[i+1][j];
		}
		for (int i = n - 1; i >= 0; i--)
		{
			fen.add(a[i][j], -1);
		}
	}
	vector<vector<ll>> dp(n, vector<ll>(m,LINF));
	for (int x = 0; x < n; x++)
	{
		for (int y = 0; y < m; y++)
		{
			fen.add(a[x][y], 1);
		}
	}
	dp[0][0] = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			ll sum = 0;
			for (int y = j; y < m; y++)
			{
				fen.add(a[i][y], -1);
			}
			for (int y = j; y < m; y++)
			{
				sum += fen.get(a[i][y]);
			}
			for (int y = j; y < m; y++)
			{
				fen.add(a[i][y], 1);
			}
			if(i+1<n) dp[i + 1][j] = min(dp[i + 1][j], sum + row[i][j] + dp[i][j]);
			
			for (int x = i; x < n; x++)
			{
				fen.add(a[x][j], -1);
			}
			sum = 0;
			for (int x = i; x < n; x++)
			{
				sum += fen.get(a[x][j]);
			}
			if (j + 1 < m) dp[i][j+1] = min(dp[i][j+1], sum + col[i][j] + dp[i][j]);
		}
		for (int j = 0; j < m; j++)
		{
			for (int x = i; x < n; x++)
			{
				fen.add(a[x][j], +1);
			}
		}
		for (int y = 0; y < m; y++)
		{
			fen.add(a[i][y], -1);
		}
	}
	cout << dp[n-1][m-1] << '\n';
}