#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

struct sparse_table {
	vector<vector<pair<ll, ll>>> arr;
	vector<ll> m2, p2;
	sparse_table(vector<ll> a) {
		m2.push_back(0);
		p2.push_back(1);
		for (ll i = 1; i <= a.size(); i++) {
			m2.push_back(m2.back());
			if (p2[m2.back()] * 2 == i) {
				m2.back()++;
				p2.push_back(p2.back() * 2);
			}
		}
		arr.resize(p2.size(), vector<pair<ll, ll>>(a.size()));
		for (ll i = 0; i < a.size(); i++) {
			arr[0][i] = make_pair(a[i], i);
		}
		for (ll i = 1; i < p2.size(); i++) {
			for (ll j = 0; j + p2[i] <= a.size(); j++) {
				arr[i][j] = min(arr[i - 1][j], arr[i - 1][j + p2[i - 1]]);
			}
		}
	}
	ll get(ll l, ll r) {
		ll lp = m2[r - l];
		return min(arr[lp][l], arr[lp][r - p2[lp]]).second;
	}
};

void solve() {
	ll n, q;
	cin >> n >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	sparse_table st(arr);
	vector<ll> nb(n, 0);
	vector<pair<ll, ll>> now;
	now.emplace_back(INF, n);
	for (ll i = n - 1; i >= 0; i--) {
		while (now.back().first < arr[i]) {
			now.pop_back();
		}
		nb[i] = now.back().second;
		now.emplace_back(arr[i], i);
	}
	for (ll _ = 0; _ < q; _++) {
		ll k, i;
		cin >> k >> i;
		i--;
		cout << arr[i] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
