#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MCOLONE = 2;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll square(ll x) {
	return x * x;
}

void dfs(ll v, vector<bool>& good, vector<vector<ll>>& to) {
	good[v] = true;
	for (auto i : to[v]) {
		if (!good[i]) {
			dfs(i, good, to);
		}
	}
}

bool dfs2(ll v, vector<ll>& c, vector<vector<ll>>& to) {
	for (auto i : to[v]) {
		if (c[i] == -1) {
			c[i] = 1 - c[v];
			if (dfs2(i, c, to)) {
				return true;
			}
		}
		if (c[i] == c[v]) {
			return true;
		}
	}
	return false;
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<pair<ll, ll>> all(n);
	for (auto&[x, y] : all) {
		cin >> x >> y;
	}
	map<pair<ll, ll>, vector<ll>> as;
	ll ss = (r + 1) / 2;
	for (ll i = 0; i < n; i++) {
		as[make_pair(all[i].first / ss, all[i].second / ss)].push_back(i);
	}
	vector<vector<int>> to(n);
	vector<bool> good(n, false);
	for (ll i = 0; i < n; i++) {
		ll xs = all[i].first / ss, ys = all[i].second / ss;
		if (as[make_pair(xs, ys)].size() > MCOLONE) {
			good[i] = true;
		}
		for (ll ax = -2; ax <= 2; ax++) {
			for (ll ay = -2; ay <= 2; ay++) {
				if (as[make_pair(xs + ax, ys + ay)].size() <= MCOLONE) {
					for (auto j : as[make_pair(xs + ax, ys + ay)]) {
						if (j == i) {
							continue;
						}
						if (square(all[j].first - all[i].first) + square(all[j].second - all[i].second) <= r * r) {
							to[i].push_back(j);
							to[j].push_back(i);
						}
					}
				}
			}
		}
	}
	for (ll i = 0; i < n; i++) {
		if (good[i]) {
			dfs(i, good, to);
		}
	}
	vector<ll> c(n, -1);
	for (ll i = 0; i < n; i++) {
		if (!good[i]) {
			if (c[i] == -1) {
				c[i] = 0;
				if (dfs2(i, c, to)) {
					dfs(i, good, to);
				}
			}
		}
	}
	for (auto i : good) {
		cout << i;
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
