#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;

typedef long long ll;

const ll K = 1400, INF = 1'000'000'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

struct BIT {
	vector<ll> tree;
	BIT(ll n) {
		tree.resize(n + 1, 0);
	}
	ll get(ll x) {
		ll ans = 0;
		for (; x > 0; x -= x & -x) {
			ans += tree[x];
		}
		return ans;
	}
	void add(ll x, ll y) {
		x++;
		for (; x < tree.size(); x += x & -x) {
			tree[x] += y;
		}
	}
};

struct SQRTS1 {
	vector<ll> arr;
	vector<ll> sb;
	SQRTS1(ll n) {
		arr.resize(n, 0);
		sb.resize(n / K + 1, 0);
	}
	void add(ll x, ll y) {
		arr[x] += y;
		sb[x / K] += y;
	}
	ll get(ll x) {
		ll ans = 0;
		ll nl = 0;
		while (nl + K < x) {
			ans += sb[nl / K];
			nl += K;
		}
		for (ll i = nl; i < x; i++) {
			ans += arr[i];
		}
		return ans;
	}
};

struct SQRTG1 {
	vector<ll> arr;
	vector<ll> sb;
	SQRTG1(ll n) {
		arr.resize(n + 1, 0);
		sb.resize(n / K + 2, 0);
	}
	void add(ll x, ll y) {
		for (ll i = x / K + 1; i < sb.size(); i++) {
			sb[i] += y;
		}
		for (ll i = x + 1; i < arr.size() && i % K != 0; i++) {
			arr[i] += y;
		}
	}
	ll get(ll x) {
		return arr[x] + sb[x / K];
	}
};

void solve() {
	ll r, c;
	cin >> r >> c;
	vector<vector<ll>> arr(r, vector<ll>(c));
	vector<pair<ll, ll>> pos(r * c);
	for (ll i = 0; i < r; i++) {
		for (ll j = 0; j < c; j++) {
			cin >> arr[i][j];
			arr[i][j]--;
		}
		reverse(arr[i].begin(), arr[i].end());
		for (ll j = 0; j < c; j++) {
			pos[arr[i][j]] = make_pair(i, j);
		}
	}
	vector<vector<ll>> acol(r, vector<ll>(c, 0));
	vector<vector<vector<ll>>> precalc(r, vector<vector<ll>>(c));
	for (ll i = 0; i < r * c; i += K) {
		vector<pair<ll, ll>> lst;
		vector<vector<ll>> col(r + 1, vector<ll>(c + 1));
		for (ll a = 1; a <= r; a++) {
			for (ll b = 1; b <= c; b++) {
				col[a][b] = col[a - 1][b] + col[a][b - 1] - col[a - 1][b - 1] + acol[a - 1][b - 1];
			}
		}
		for (ll j = i; j < i + K && j < r * c; j++) {
			auto[x, y] = pos[j];
			acol[x][y]++;
			ll ncol = col[r][y + 1];
			vector<ll> add(x + 1, 0);
			for (auto[nx, ny] : lst) {
				if (ny <= y) {
					if (nx <= x) {
						add[nx]++;
					} else {
						ncol++;
					}
				}
			}
			precalc[x][y].resize(x + 1);
			ll startc = (r - x) * (y + 1);
			for (ll j = x; j >= 0; j--) {
				ncol += add[j];
				if (arr[j][y] <	arr[x][y]) {
					ncol--;
				}
				precalc[x][y][j] = (ncol - col[j][y + 1]);
				startc += y;
			}
			lst.push_back(pos[j]);
		}
	}
	vector<ll> dp(c + 1, INF);
	dp.back() = 0;
	for (ll i = 0; i < r; i++) {
		for (ll nc = c; nc > 0; nc--) {
			ll nans = dp[nc];
			for (ll k = i; k < r; k++) {
				nans += precalc[k][nc - 1][i];
			}
			assign_min(dp[nc - 1], nans);
		}
		SQRTS1 bd(r * c);
		SQRTG1 bu(r * c);
		ll lsum = 0;
		for (ll nc = 0; nc < c; nc++) {
			for (ll k = i + 1; k < r; k++) {
				lsum += nc - bu.get(arr[k][nc]);
				bd.add(arr[k][nc], 1);
			}
			lsum += bd.get(arr[i][nc]) + bu.get(arr[i][nc]);
			bu.add(arr[i][nc], 1);
			dp[nc + 1] += lsum;
		}
	}
	ll ans = INF;
	for (auto i : dp) {
		assign_min(ans, i);
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
