#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 1'000'000'000, K = 300;
const ll KO = K + 2;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

struct sparse_table {
	vector<vector<pair<ll, ll>>> arr;
	vector<ll> m2, p2;
	sparse_table(vector<ll> a = vector<ll>(0, 0)) {
		m2.push_back(0);
		p2.push_back(1);
		for (ll i = 1; i <= a.size(); i++) {
			m2.push_back(m2.back());
			if (p2[m2.back()] * 2 == i) {
				m2.back()++;
				p2.push_back(p2.back() * 2);
			}
		}
		arr.resize(p2.size(), vector<pair<ll, ll>>(a.size()));
		for (ll i = 0; i < a.size(); i++) {
			arr[0][i] = make_pair(a[i], i);
		}
		for (ll i = 1; i < p2.size(); i++) {
			for (ll j = 0; j + p2[i] <= a.size(); j++) {
				arr[i][j] = min(arr[i - 1][j], arr[i - 1][j + p2[i - 1]]);
			}
		}
	}
	ll get(ll l, ll r) {
		ll lp = m2[r - l];
		return min(arr[lp][l], arr[lp][r - p2[lp]]).second;
	}
};

sparse_table st;
vector<ll> nb;
ll n;

pair<ll, ll> gj(ll i, ll k) {
	if (i == n - 1 || n - k + 1 <= i) {
		return make_pair(i, 0);
	}
	return make_pair(st.get(i + 1, min(nb[i], n - k + 1) + 1), 1);
}

struct block {
	vector<ll> arr;
	ll stind;
	ll mk;
	vector<vector<pair<ll, ll>>> jmp;
	vector<vector<pair<ll, ll>>> bmka;
	vector<vector<ll>> bmkmk;
	block(vector<ll> a, ll cp) {
		stind = cp;
		arr = a;
		ll ost = n - arr.size() - stind;
		mk = ost + 2;
		vector<pair<ll, ll>> njmp(arr.size());
		for (ll i = 0; i < arr.size(); i++) {
			njmp[i] = gj(i + stind, mk);
		}
		jmp.push_back(njmp);
		for (ll nowk = mk + 1; nowk <= mk + arr.size(); nowk++) {
			for (ll i = 0; i < arr.size(); i++) {
				auto[to, c] = gj(i + stind, nowk);
				njmp[i] = make_pair(njmp[to - stind].first, njmp[to - stind].second + c);
			}
			jmp.push_back(njmp);
		}
		bmka.resize(arr.size());
		bmkmk.resize(arr.size());
		for (ll i = arr.size() - 1; i >= 0; i--) {
			ll l = -1, r = n;
			while (r - l > 1) {
				ll mid = (l + r) / 2;
				if (gj(i + stind, mid).first >= stind + arr.size()) {
					l = mid;
				} else {
					r = mid;
				}
			}
			bmka[i] = bmka[gj(i + stind, mk).first - stind];
			bmkmk[i] = bmkmk[gj(i + stind, mk).first - stind];
			for (auto&c : bmkmk[i]) {
				c++;
			}
			for (auto&[_, c] : bmka[i]) {
				c++;
			}
			while (!bmkmk[i].empty() && bmkmk[i].back() <= l) {
				bmkmk[i].pop_back();
				bmka[i].pop_back();
			}
			bmkmk[i].push_back(l);
			bmka[i].emplace_back(i + stind, 0);
		}
	}
	pair<ll, ll> getjmp1(ll i, ll k) {
		if (i >= stind + arr.size() || k < mk) {
			return make_pair(i, 0);
		}
		return jmp[k - mk][i - stind];
	}
	pair<ll, ll> getjmp2(ll i, ll k) {
		if (i >= stind + arr.size() || k >= mk) {
			return make_pair(i, 0);
		}
		while (bmkmk[i - stind].back() < k) {
			bmkmk[i - stind].pop_back();
			bmka[i - stind].pop_back();
		}
		return bmka[i - stind].back();
	}
};

void solve() {
	ll q;
	cin >> n >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	st = sparse_table(arr);
	nb.resize(n, 0);
	vector<pair<ll, ll>> now;
	now.emplace_back(INF, n);
	vector<ll> sm(n + 1, 0);
	for (ll i = n - 1; i >= 0; i--) {
		sm[i] = max(sm[i + 1], arr[i]);
		while (now.back().first < arr[i]) {
			now.pop_back();
		}
		nb[i] = now.back().second;
		now.emplace_back(arr[i], i);
	}
	vector<pair<vector<ll>, ll>> pb;
	vector<ll> nbl;
	ll cp = 0;
	for (auto i : arr) {
		nbl.push_back(i);
		if (nbl.size() == K || i == arr.back()) {
			pb.emplace_back(nbl, cp);
			cp += nbl.size();
			nbl.clear();
		}
	}
	vector<ll> nk(q), ni(q), nnow(q, 0);
	vector<ll> good;
	for (ll j = 0; j < q; j++) {
		ll k, i;
		cin >> k >> i;
		nk[j] = k;
		ni[j] = i;
		if (i > KO) {
			good.push_back(j);
		}
	}
	for (ll nb = 0; !good.empty() && nb < pb.size(); nb++) {
		vector<ll> ngood;
		block nowb(pb[nb].first, pb[nb].second);
		vector<vector<ll>> ak(n + 1);
		for (auto j : good) {
			auto[nnnow, cj] = nowb.getjmp1(nnow[j], nk[j]);
			ni[j] -= cj;
			nk[j] -= cj;
			nnow[j] = nnnow;
			ak[nk[j]].push_back(j);
		}
		good.clear();
		for (ll i = 0; i <= n; i++) {
			for (auto j : ak[i]) {
				good.push_back(j);
			}
		}
		for (auto j : good) {
			auto[nnnow, cj] = nowb.getjmp2(nnow[j], nk[j]);
			ni[j] -= cj;
			nk[j] -= cj;
			nnow[j] = nnnow;
		}
		for (auto j : good) {
			auto[nnnow, cj] = gj(nnow[j], nk[j]);
			ni[j] -= cj;
			nk[j] -= cj;
			nnow[j] = nnnow;
			if (ni[j] > KO) {
				ngood.push_back(j);
			}
		}
		good = ngood;
	}
	for (ll j = 0; j < q; j++) {
		ll k = nk[j];
		ll i = ni[j];
		if (k == 1) {
			cout << n << '\n';
			continue;
		}
		ll now = nnow[j];
		ll ans = 0;
		while (true) {
			if (i == 1) {
				ans = arr[now];
				break;
			}
			if (i == 2 && k == 2) {
				ans = sm[nb[now] - 1];
				break;
			}
			now = st.get(now + 1, min(nb[now], n - k + 1) + 1);
			k--;
			i--;
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
