#pragma GCC optimize("O3")

#include <bits/extc++.h>

using namespace std;

constexpr int INF = 1e9;

struct node {
    int lv = -1;
    int rv = -1;
    int s = 0;
};

vector<node> t;

int new_node() {
    t.emplace_back();
    return (int)t.size() - 1;
}

int bld(int tl, int tr) {
    int v = new_node();
    if (tl + 1 == tr) {
        return v;
    }
    int tm = (tl + tr) >> 1;
    t[v].lv = bld(tl, tm);
    t[v].rv = bld(tm, tr);
    return v;
}

int upd(int v, int tl, int tr, int i, int x) {
    int v2 = new_node();
    if (tl + 1 == tr) {
        t[v2].s = t[v].s + x;
        return v2;
    }
    int tm = (tl + tr) >> 1;
    if (i < tm) {
        int u = upd(t[v].lv, tl, tm, i, x);
        t[v2].lv = u;
        t[v2].rv = t[v].rv;
        t[v2].s = t[t[v2].lv].s + t[t[v2].rv].s;
        return v2;
    } else {
        int u = upd(t[v].rv, tm, tr, i, x);
        t[v2].rv = u;
        t[v2].lv = t[v].lv;
        t[v2].s = t[t[v2].lv].s + t[t[v2].rv].s;
        return v2;
    }
}

int get(int v, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl) {
        return 0;
    }
    if (l <= tl && tr <= r) {
        return t[v].s;
    }
    int tm = (tl + tr) >> 1;
    return get(t[v].lv, tl, tm, l, r) + get(t[v].rv, tm, tr, l, r);
}

void print(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        if (t[v].s > 0) {
            cerr << tr << ' ';
        }
        return;
    }
    int tm = (tl + tr) >> 1;
    print(t[v].lv, tl, tm);
    print(t[v].rv, tm, tr);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j], a[i][j]--;
        }
    }
    vector R(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = m - 2; j >= 0; j--) {
            R[i][j] = R[i][j + 1];
            for (int jj = j + 1; jj < m; jj++) {
                if (a[i][jj] < a[i][j]) {
                    R[i][j]++;
                }
            }
        }
    }
    vector D(n, vector<int>(m));
    for (int j = 0; j < m; j++) {
        for (int i = n - 2; i >= 0; i--) {
            D[i][j] = D[i + 1][j];
            for (int ii = i + 1; ii < n; ii++) {
                if (a[ii][j] < a[i][j]) {
                    D[i][j]++;
                }
            }
        }
    }
    vector V(n, vector<int>(m));
    V[n - 1][m - 1] = bld(0, n * m);
    V[n - 1][m - 1] = upd(V[n - 1][m - 1], 0, n * m, a[n - 1][m - 1], 1);
    for (int j = m - 1; j >= 0; j--) {
        for (int i = n - 1; i >= 0; i--) {
            if (i == n - 1 && j == m - 1) {
                continue;
            }
            if (i + 1 < n) {
                V[i][j] = V[i + 1][j];
                for (int jj = j; jj < m; jj++) {
                    V[i][j] = upd(V[i][j], 0, n * m, a[i][jj], 1);
                }
            } else {
                V[i][j] = V[i][j + 1];
                for (int ii = i; ii < n; ii++) {
                    V[i][j] = upd(V[i][j], 0, n * m, a[ii][j], 1);
                }
            }
        }
    }
    // for (int i = 0; i < n; i++) {
        // for (int j = 0; j < m; j++) {
            // print(V[i][j], 0, n * m);
            // cerr << '\n';
            // cerr << D[i][j] << ' ';
        // }
        // cerr << '\n';
    // }
    vector dp(n, vector<int>(m, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i + 1 < n) {
                int val = dp[i][j] + R[i][j];
                for (int jj = j; jj < m; jj++) {
                    int x = a[i][jj];
                    int ALL = n * m - 1 - x;
                    val += ALL - get(V[i][j], 0, n * m, x + 1, n * m);
                }
                // if (i + 1 == n - 1 && j == m - 1) {
                //     cerr << "??? " << val << '\n';
                // }
                dp[i + 1][j] = min(dp[i + 1][j], val);
            }
            if (j + 1 < m) {
                int val = dp[i][j] + D[i][j];
                for (int ii = i; ii < n; ii++) {
                    int x = a[ii][j];
                    int ALL = n * m - 1 - x;
                    val += ALL - get(V[i][j], 0, n * m, x + 1, n * m);
                }
                // if (i == n - 1 && j + 1 == m - 1) {
                //     cerr << "??? " << val << '\n';
                // }
                dp[i][j + 1] = min(dp[i][j + 1], val);
            }
        }
    }
    // for (int i = 0; i < n; i++) {
        // for (int j = 0; j < m; j++) {
            // cerr << dp[i][j] << " \n"[j == m - 1];
        // }
    // }
    // cerr << "!!!!!!!! " << get(n - 1, m - 1, a[n - 1][m - 1]) << '\n';
    cout << dp[n - 1][m - 1] + n * m - 1 - a[n - 1][m - 1] << '\n';
    return 0;
}
