#include <bits/stdc++.h>

using namespace std;

// #define int long long

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()

using ll = long long;

const ll INF = 1e18;

template <typename T> void chmin(T &a, T b) {
    if (a > b) {
        a = b;
    }
}

struct F {
    int n;
    vector<int> t;
    F() {}
    F(int n) : n(n), t(n) {}
    void add(int i, int x) {
        while (i < n) {
            t[i] += x;
            i |= i + 1;
        }
    }
    int get(int i) {
        int r = 0;
        while (~i) {
            r += t[i];
            i &= i + 1;
            --i;
        }
        return r;
    }
    int get(int l, int r) { return get(r) - get(l - 1); }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vector<vector<int>> plus_i(n, vector<int>(m));
    vector<vector<int>> plus_j(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = j; k < m; ++k) {
                for (int ni = 0; ni < n; ++ni) {
                    for (int nj = 0; nj < j; ++nj) {
                        plus_i[i][j] += (a[i][k] < a[ni][nj]);
                    }
                }
                for (int ni = 0; ni < i; ++ni) {
                    for (int nj = j; nj < m; ++nj) {
                        plus_i[i][j] += (a[i][k] < a[ni][nj]);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = i; k < n; ++k) {
                for (int ni = 0; ni < n; ++ni) {
                    for (int nj = 0; nj < j; ++nj) {
                        plus_j[i][j] += (a[k][j] < a[ni][nj]);
                    }
                }
                for (int ni = 0; ni < i; ++ni) {
                    for (int nj = j; nj < m; ++nj) {
                        plus_j[i][j] += (a[k][j] < a[ni][nj]);
                    }
                }
            }
        }
    }
    int dt = 0;
    F f(n * m);
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; ~j; --j) {
            dt += f.get(0, a[i][j] - 1);
            f.add(a[i][j], 1);
        }
        for (int j = m - 1; ~j; --j) {
            f.add(a[i][j], -1);
        }
    }
    for (int j = 0; j < m; ++j) {
        for (int i = n - 1; ~i; --i) {
            dt += f.get(0, a[i][j] - 1);
            f.add(a[i][j], 1);
        }
        for (int i = n - 1; ~i; --i) {
            f.add(a[i][j], -1);
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            chmin(dp[i + 1][j], dp[i][j] + plus_i[i][j]);
            chmin(dp[i][j + 1], dp[i][j] + plus_j[i][j]);
        }
    }
    ll ans = INF;
    for (int i = 0; i < n; ++i) chmin(ans, dp[i][m]);
    for (int j = 0; j < m; ++j) chmin(ans, dp[n][j]);
    cout << ans + dt << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("C:\\work\\INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}