#include <bits/stdc++.h>

using namespace std;

// #define int long long

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()

using ll = long long;

const ll INF = 1e18;    

template <typename T> inline void chmin(T &a, T b) {
    if (a > b) {
        a = b;
    }
}

struct F {
    int n;
    vector<int> t;
    F() {}
    F(int n) : n(n), t(n) {}
    void add(int i, int x) {
        while (i < n) {
            t[i] += x;
            i |= i + 1;
        }
    }
    int get(int i) {
        int r = 0;
        while (~i) {
            r += t[i];
            i &= i + 1;
            --i;
        }
        return r;
    }
    int get(int l, int r) { return get(r) - get(l - 1); }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            --a[i][j];
        }
    }
    vector<vector<ll>> plus_i(n, vector<ll>(m));
    vector<vector<ll>> plus_j(n, vector<ll>(m));
    F f(n * m);
    F g(n * m);
    ll inv = 0;
    auto add_f = [&](int x) {
        inv += g.get(x + 1, g.n - 1);
        f.add(x, 1);
    };
    auto del_f = [&](int x) {
        inv -= g.get(x + 1, g.n - 1);
        f.add(x, -1);
    };
    auto add_g = [&](int x) {
        inv += f.get(0, x - 1);
        g.add(x, 1);
    };
    auto del_g = [&](int x) {
        inv -= f.get(0, x - 1);
        g.add(x, -1);
    };
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            add_f(a[i][j]);
        }
        for (int j = 0; j < m; ++j) {
            plus_i[i][j] = inv;
            del_f(a[i][j]);
            for (int k = i; k < n; ++k) {
                add_g(a[k][j]);
            }
        }
        for (int k = i + 1; k < n; ++k) {
            for (int j = 0; j < m; ++j) {
                del_g(a[k][j]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            del_g(a[i][j]);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = i; k < n; ++k) {
                add_f(a[k][j]);
            }
            plus_j[i][j] = inv;
            for (int k = i; k < n; ++k) {
                del_f(a[k][j]);
                add_g(a[k][j]);
            }
        }
        for (int k = i + 1; k < n; ++k) {
            for (int j = 0; j < m; ++j) {
                del_g(a[k][j]);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        ll dt = 0;

        for (int j = m - 1; ~j; --j) {
            dt += f.get(0, a[i][j] - 1);
            f.add(a[i][j], 1);
            plus_i[i][j] += dt;
        }
        for (int j = m - 1; ~j; --j) {
            f.add(a[i][j], -1);
        }
    }
    for (int j = 0; j < m; ++j) {
        ll dt = 0;
        for (int i = n - 1; ~i; --i) {
            dt += f.get(0, a[i][j] - 1);
            f.add(a[i][j], 1);
            plus_j[i][j] += dt;
        }
        for (int i = n - 1; ~i; --i) {
            f.add(a[i][j], -1);
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            chmin(dp[i + 1][j], dp[i][j] + plus_i[i][j]);
            chmin(dp[i][j + 1], dp[i][j] + plus_j[i][j]);
        }
    }
    ll ans = INF;
    for (int i = 0; i < n; ++i)
        chmin(ans, dp[i][m]);
    for (int j = 0; j < m; ++j)
        chmin(ans, dp[n][j]);
    cout << ans << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("C:\\work\\INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}