#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
 
#define int long long
 
using namespace std;

vector<vector<int>> g;
vector<pair<int, int>> a;

int sq_dist(pair<int, int> v, pair<int, int> u) {
    int dx = v.first - u.first;
    int dy = v.second - u.second;
    return dx * dx + dy * dy;
}

vector<bool> used;
vector<bool> is_good;
vector<int> color;

bool dfs(int v, int c, int p) {
    color[v] = c;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        if (color[u] == c) {
            return true;
        }
        if (color[u] == -1) {
            bool z = dfs(u, c ^ 1, v);
            if (z) {
                return true;
            }
        }
    }
    return false;
}

void paint(int v, bool flag) {
    is_good[v] = flag;
    used[v] = true;
    for (int u : g[v]) {
        if (used[u]) {
            continue;
        }
        paint(u, flag);
    }
}

void solve() {
    int n, r;
    cin >> n >> r;
    g.resize(n);
    used.resize(n);
    color.resize(n, -1);
    is_good.resize(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y});
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            if (sq_dist(a[i], a[j]) <= r * r) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            bool flag = dfs(i, 0, -1);
            paint(i, flag);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << is_good[i];
    }
    cout << "\n";
}
 
signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}