// #pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
 
#define int long long
 
using namespace std;

struct seg_tree {
    int n;
    vector<int> tree;

    seg_tree() {}

    seg_tree(int n) {
        tree.resize(4 * n);
        this->n = n;
    }

    void update(int v, int l, int r, int ind, int x) {
        if (l + 1 == r) {
            tree[v] = x;
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) {
            update(2 * v + 1, l, m, ind, x);
        } else {
            update(2 * v + 2, m, r, ind, x);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void update(int ind, int x) {
        update(0, 0, n, ind, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        } else if (qr <= l || r <= ql) {
            return 0;
        }
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) +
        get(2 * v + 2, m, r, ql, qr);
    }

    int get(int ql, int qr) {
        if (ql >= qr) {
            return 0;
        }
        return get(0, 0, n, ql, qr);
    }

    int get(int x) {
        if (x <= 0) {
            return 0;
        }
        return get(0, 0, n, 0, x);
    }

    vector<int> debug() {
        vector<int> z;
        for (int i = 0; i < n; i++) {
            z.push_back(get(i, i + 1));
        }
        return z;
    }
};

const int INF = (int)1e17 + 7;

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> t(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> t[i][j];
        }
    }
    vector<vector<int>> dp(r + 1, vector<int>(c + 1, INF));
    for (int i = 0; i <= r; i++) {
        dp[i][c] = 0;
    }
    for (int i = 0; i <= c; i++) {
        dp[r][c] = 0;
    }
    vector<seg_tree> trees(c, seg_tree(r * c + 2));
    for (int i = r - 1; i >= 0; i--) {
        seg_tree from_tree = seg_tree(r * c + 2);
        for (int j = c - 1; j >= 0; j--) {
            int cur_res = 0;
            for (int k = c - 1; k >= j; k--) {
                int x = t[i][k];
                cur_res += trees[j].get(x);
                trees[j].update(x, 1);
            }
            dp[i][j] = min(dp[i][j], cur_res + dp[i + 1][j]);
            cur_res = 0;
            for (int k = r - 1; k >= i; k--) {
                int x = t[k][j];
                cur_res += from_tree.get(x);
                from_tree.update(x, 1);
            }
            dp[i][j] = min(dp[i][j], cur_res + dp[i][j + 1]);
            vector<int> v = trees[j].debug();
        }
    }
    cout << dp[0][0] << "\n";
}
 
signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}