#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
 
#define int long long
 
using namespace std;

struct seg_tree {
    int n;
    int tree[4 * (100 * 100 + 3)] = {};

    seg_tree() {}

    seg_tree(int n) {
        this->n = n;
    }

    void update(int v, int l, int r, int ind, int x) {
        if (l + 1 == r) {
            tree[v] = x;
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) {
            update(2 * v + 1, l, m, ind, x);
        } else {
            update(2 * v + 2, m, r, ind, x);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void update(int ind, int x) {
        update(0, 0, n, ind, x);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        } else if (qr <= l || r <= ql) {
            return 0;
        }
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) +
        get(2 * v + 2, m, r, ql, qr);
    }

    int get(int ql, int qr) {
        if (ql >= qr) {
            return 0;
        }
        return get(0, 0, n, ql, qr);
    }

    int get(int x) {
        if (x >= n) {
            return 0;
        }
        return get(0, 0, n, x + 1, n);
    }
};

const int INF = (int)1e17 + 7;
int t[103][103] = {};
int dp[103][103] = {};
seg_tree trees[103];

void solve() {
    int r, c;
    cin >> r >> c;
    vector<int> a(c);
    for (int &i : a) {
        cin >> i;
    }
    seg_tree tree(r * c + 2);
    int res = 0;
    for (int i = 0; i < c; i++) {
        res += tree.get(a[i]);
        tree.update(a[i], 1);
    }
    cout << res << "\n";
}
 
signed main() {
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}