#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(69);

const int INF = 1e9, MOD = 1e9 + 7;

struct point
{
	long long x = 0, y = 0;

	point() {}

	point(long long x, long long y):
		x(x), y(y) {}

	bool operator < (const point& o) const
	{
		if (x == o.x)
		{
			return y < o.y;
		}
		return x < o.x;
	}
};

long long dist(point& a, point& b)
{
	long long x = a.x - b.x, y = a.y - b.y;
	return x * x + y * y;
}

long long C = -1;

vector<vector<int>> g;

bool dfs(int v, int c, vector<int>& col)
{
	col[v] = c;
	for (auto& i : g[v])
	{
		if (col[i] == (c ^ 1))
		{
			continue;
		}
		if (col[i] == c)
		{
			return false;
		}

		if (!dfs(i, c ^ 1, col))
		{
			return false;
		}
	}
	return true;
};

void dfs_ans(int v, vector<int>& ans)
{
	ans[v] = 1;
	for (auto& i : g[v])
	{
		if (ans[i])
		{
			continue;
		}

		dfs_ans(i, ans);
	}
}

void small_r(long long n, long long r, vector<point>& v)
{
	vector<point> ch;
	for (long long dx = 0; dx <= r; dx++)
	{
		for (long long dy = (dx == 0 ? 1 : -r); dy <= r; dy++)
		{
			point q(dx, dy), emp(0, 0);
			if (dist(q, emp) <= r * r)
			{
				ch.push_back(q);
			}
		}
	}

	auto encode = [&](point& p) -> long long
	{
		return p.x * 1000000000ll + p.y;
	};

	unordered_map<long long, long long> mp;
	for (long long i = 0; i < n; i++)
	{
		mp[encode(v[i])] = i;
	}
	g.resize(n);
	for (long long i = 0; i < n; i++)
	{
		for (auto& j : ch)
		{
			point tmp(v[i].x + j.x, v[i].y + j.y);
			long long etmp = encode(tmp);
			if (mp.find(etmp) != mp.end())
			{
				long long to = mp[etmp];
				g[i].push_back(to);
				g[to].push_back(i);
			}
		}
	}

	vector<int> col(n, -1);
	vector<int> good;
	for (int i = 0; i < n; i++)
	{
		if (col[i] != -1)
		{
			continue;
		}

		if (!dfs(i, 0, col))
		{
			good.push_back(i);
		}
	}
	vector<int> ans(n);
	for (auto& i : good)
	{
		dfs_ans(i, ans);
	}
	for (auto& i : ans)
	{
		cout << i;
	}
	cout << "\n";
}

void solve()
{
	long long n, r;
	vector<point> v;
	cin >> n >> r;
	v.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].x >> v[i].y;
	}
	if (r <= 10)
	{
		small_r(n, r, v);
		return;
	}
	return;

	C = (long long)((double)r / sqrt(2));
	map<pair<long long, long long>, vector<long long>> mp;
	for (long long i = 0; i < n; i++)
	{
		mp[{v[i].x / C, v[i].y / C}].push_back(i);
	}

}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();
	
	return 0;
}

/*

























*/
