#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 1e9, MOD = 1e9 + 7;

struct point
{
	int x = 0, y = 0;

	point() {}
};

int dist(point& a, point& b)
{
	int x = a.x - b.x, y = a.y - b.y;
	return x * x + y * y;
}

vector<vector<int>> g;

bool dfs(int v, int c, vector<int>& col)
{
	col[v] = c;
	for (auto& i : g[v])
	{
		if (col[i] == (c ^ 1))
		{
			continue;
		}
		if (col[i] == c)
		{
			return false;
		}

		if (!dfs(i, c ^ 1, col))
		{
			return false;
		}
	}
	return true;
};

void dfs_ans(int v, vector<int>& ans)
{
	ans[v] = 1;
	for (auto& i : g[v])
	{
		if (ans[i])
		{
			continue;
		}

		dfs_ans(i, ans);
	}
}

void solve()
{
	int n, r;
	vector<point> v;
	cin >> n >> r;
	v.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].x >> v[i].y;
	}

	g.resize(n);
	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			if (dist(v[i], v[j]) <= r * r)
			{
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}

	vector<int> col(n, -1);
	vector<int> good;
	for (int i = 0; i < n; i++)
	{
		if (col[i] != -1)
		{
			continue;
		}

		if (!dfs(i, 0, col))
		{
			good.push_back(i);
		}
	}
	vector<int> ans(n);
	for (auto& i : good)
	{
		dfs_ans(i, ans);
	}
	for (auto& i : ans)
	{
		cout << i;
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();
	
	return 0;
}

/*

























*/
