#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(69);

const int INF = 1e9, MOD = 1e9 + 7;

vector<long long> gen(vector<int>& v, long long k, long long idx)
{
	if (k == 1)
	{
		return { *max_element(v.begin() + idx, v.end()) };
	}

	vector<long long> res = { v[idx] };
	while ((long long)res.size() + 1 < k)
	{
		long long bord = idx + 1;
		while (bord < v.size() && v[bord] < v[idx])
		{
			bord++;
		}
		bord--;

		long long best = idx + 1;
		for (long long i = idx + 1; i <= bord + 1; i++)
		{
			long long rest = v.size() - i;
			if ((long long)res.size() + rest < k)
			{
				break;
			}

			if (v[i] < v[best])
			{
				best = i;
			}
		}
		idx = best;
		res.push_back(v[idx]);
	}
	idx++;
	res.push_back({ *max_element(v.begin() + idx, v.end()) });
	return res;
}

void solve()
{
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
		v[i]--;
	}
	vector<vector<pair<long long, long long>>> qr(n + 1);
	for (long long i = 0; i < q; i++)
	{
		long long k, idx;
		cin >> k >> idx;
		idx--;
		qr[k].push_back({ idx, i });
	}
	vector<long long> ans(q);
	for (long long k = 0; k < qr.size(); k++)
	{
		if (!qr[k].size())
		{
			continue;
		}

		vector<long long> b = gen(v, k, 0);
		for (auto& [idx, qid] : qr[k])
		{
			ans[qid] = b[idx] + 1;
		}
	}
	for (auto& i : ans)
	{
		cout << i << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
