#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(69);

const int INF = 1e9, MOD = 1e9 + 7;

struct segtree
{
	long long n;
	vector<int> t, a;

	segtree() {}

	segtree(vector<int>& v)
	{
		n = v.size();
		t.resize(n * 4);
		a = v;
		build(0, 0, n - 1);
	}

	int ch(int x, int y)
	{
		if (a[x] < a[y])
		{
			return x;
		}
		return y;
	}

	void build(int v, int tl, int tr)
	{
		if (tl == tr)
		{
			t[v] = tl;
			return;
		}

		int tm = (tl + tr) / 2;
		build(v * 2 + 1, tl, tm);
		build(v * 2 + 2, tm + 1, tr);
		t[v] = ch(t[v * 2 + 1], t[v * 2 + 2]);
	}

	int get(int v, int tl, int tr, int l, int r)
	{
		if (tr < l || r < tl)
		{
			return l;
		}
		if (l <= tl && tr <= r)
		{
			return t[v];
		}

		int tm = (tl + tr) / 2;
		return ch(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm + 1, tr, l, r));
	}

	int get(int l, int r)
	{
		return get(0, 0, n - 1, l, r);
	}
};

segtree sgt;
vector<int> sufmx;
vector<int> gtr;

vector<long long> gen(vector<int>& v, long long k, long long idx)
{
	if (k == 1)
	{
		return { sufmx[0] };
	}

	vector<long long> res = { v[idx] };
	while ((long long)res.size() + 1 < k)
	{
		long long bord = gtr[idx];
		long long qqq = res.size() + v.size() - k;
		bord = min(bord, qqq);
		long long best = sgt.get(idx + 1, bord);
		idx = best;
		res.push_back(v[idx]);
	}
	long long bord = gtr[idx] - 1;
	if (gtr[idx] == v.size())
	{
		res.push_back(v.back());
	}
	else
	{
		res.push_back(sufmx[bord + 1]);
	}
	return res;
}

void solve()
{
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
		v[i]--;
	}
	sgt = segtree(v);
	sufmx.resize(n + 1);
	for (int i = n - 1; i > -1; i--)
	{
		sufmx[i] = max(sufmx[i + 1], v[i]);
	}
	vector<int> st;
	gtr.resize(n, n);
	for (int i = n - 1; i > -1; i--)
	{
		while (st.size() && v[st.back()] <= v[i])
		{
			st.pop_back();
		}
		if (st.size())
		{
			gtr[i] = st.back();
		}
		st.push_back(i);
	}
	vector<vector<pair<long long, long long>>> qr(n + 1);
	for (long long i = 0; i < q; i++)
	{
		long long k, idx;
		cin >> k >> idx;
		idx--;
		qr[k].push_back({ idx, i });
	}
	vector<long long> ans(q);
	for (long long k = 0; k < qr.size(); k++)
	{
		if (!qr[k].size())
		{
			continue;
		}

		vector<long long> b = gen(v, k, 0);
		for (auto& [idx, qid] : qr[k])
		{
			ans[qid] = b[idx] + 1;
		}
	}
	for (auto& i : ans)
	{
		cout << i << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
