#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <unordered_map>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
ll n, r;
struct point {
    ll x, y;

    point() {
    }

    point(ll x, ll y): x(x), y(y) {
    }
};

ll dist(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector<vector<ll> > g;
vector<ll>comps;
vector<bool> color;
vector<bool> ok;
vector<bool> used;
void dfs_(ll v, ll comp) {
    comps[v] = comp;
    used[v] = true;
    for (ll u : g[v]) {
        if (!used[u]) {
            dfs_(u, comp);
        }
    }
}
void dfs(ll v, ll comp) {
    used[v] = true;
    for (ll u : g[v]) {
        if (!used[u]) {
            color[u] = !color[v];
            dfs(u, comp);
        } else if (used[u] == 1) {
            if (color[u] == color[v]) {
                ok[comp] = true;
                return;
            }
        }
    }
}
unordered_map<ll, unordered_map<ll, vector<pair<point, ll>>>>mp;
void add_edge(ll x1, ll y1, ll x2, ll y2) {
    for (const auto& p1: mp[x1][y1]) {
        for (const auto & p2 : mp[x2][y2]) {
            if (p1.second != p2.second && dist(p1.first, p2.first) <= r * r) {
                g[p1.second].push_back(p2.second);
                g[p2.second].push_back(p1.second);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> r;
    vector<point> ps(n);
    g.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
        mp[ps[i].x/(2 * r)][ps[i].y/(2 * r)].push_back({ps[i], i});
    }
    for (const auto& cur1 : mp) {
        for (const auto& cur2 : cur1.second){
            ll cord_x = cur1.first, cord_y = cur2.first;
            add_edge(cord_x, cord_y, cord_x, cord_y);
            add_edge(cord_x, cord_x, cord_x + 1, cord_y);
            add_edge(cord_x, cord_x, cord_x, cord_y + 1);
            add_edge(cord_x, cord_x, cord_x + 1, cord_y + 1);
            add_edge(cord_x, cord_x, cord_x - 1, cord_y);
            add_edge(cord_x, cord_y, cord_x, cord_y - 1);
            add_edge(cord_x, cord_y, cord_x - 1, cord_y - 1);
            add_edge(cord_x, cord_y, cord_x + 1, cord_y - 1);
            add_edge(cord_x, cord_y, cord_x - 1, cord_y + 1);
        }
    }
    used.resize(n), ok.resize(n), color.resize(n), comps.resize(n);
    ll cmp = 0;
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_(i, cmp);
            cmp++;
        }
    }
    used.assign(n, false);
    for (ll i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, comps[i]);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ok[comps[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    return 0;
}
