#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <random>
 
using namespace std;
using ll = long long;
using ld = long double;

struct point {
    ll x, y;
 
    point() {
    }
 
    point(ll x, ll y): x(x), y(y) {
    }
};
 
ll dist(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
 
vector<vector<ll> > g;
vector<ll>comps;
vector<bool> color;
vector<bool> ok;
vector<bool> used;
void dfs_(ll v, ll comp) {
    comps[v] = comp;
    used[v] = true;
    for (const ll& u : g[v]) {
        if (!used[u]) {
            dfs_(u, comp);
        }
    }
}
void dfs(ll v, ll comp) {
    used[v] = true;
    for (const ll& u : g[v]) {
        if (!used[u]) {
            color[u] = !color[v];
            dfs(u, comp);
        } else if (used[u] == 1) {
            if (color[u] == color[v]) {
                ok[comp] = true;
                return;
            }
        }
    }
}
 
ll main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<point> ps(n);
    g.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            if (dist(ps[i], ps[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    used.resize(n), ok.resize(n), color.resize(n), comps.resize(n);
    ll cmp = 0;
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_(i, cmp);
            cmp++;
        }
    }
    used.assign(n, false);
    for (ll i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, comps[i]);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ok[comps[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    return 0;
}