#pragma GCC optimize("O3, unroint-loops")
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <random>
 
using namespace std;
using ll = long long;
using ld = long double;

struct point {
    int x, y;
 
    point() {
    }
 
    point(int x, int y): x(x), y(y) {
    }
};
 
ll dist(point a, point b) {
    return ll(a.x - b.x) * ll(a.x - b.x) + ll(a.y - b.y) * ll(a.y - b.y);
}
 
vector<vector<int> > g;
vector<int>comps;
vector<bool> color;
vector<bool> ok;
vector<bool> used;
void dfs_(int v, int comp) {
    comps[v] = comp;
    used[v] = true;
    for (const int& u : g[v]) {
        if (!used[u]) {
            dfs_(u, comp);
        }
    }
}
void dfs(int v, int comp) {
    used[v] = true;
    for (const int& u : g[v]) {
        if (!used[u]) {
            color[u] = !color[v];
            dfs(u, comp);
        } else if (used[u] == 1) {
            if (color[u] == color[v]) {
                ok[comp] = true;
                return;
            }
        }
    }
}
vector<point> ps;
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll n, r;
    cin >> n >> r;
    ps.resize(n);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (dist(ps[i], ps[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    used.resize(n), ok.resize(n), color.resize(n), comps.resize(n);
    int cmp = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_(i, cmp);
            cmp++;
        }
    }
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, comps[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (ok[comps[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    return 0;
}