#pragma GCC optimize("Ofast, unroll-loops")
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <random>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;
ll n, r;

struct point {
    int x, y;

    point() {
    }

    point(int x, int y): x(x), y(y) {
    }
};

ll dist(point a, point b) {
    return ll(a.x - b.x) * ll(a.x - b.x) + ll(a.y - b.y) * ll(a.y - b.y);
}

vector<vector<int> > g;
vector<int> comps;
vector<bool> color;
vector<bool> ok;
vector<bool> used;

void dfs_(int v, int comp) {
    comps[v] = comp;
    used[v] = true;
    for (const int &u: g[v]) {
        if (!used[u]) {
            dfs_(u, comp);
        }
    }
}

void dfs(int v, int comp) {
    used[v] = true;
    for (const int &u: g[v]) {
        if (!used[u]) {
            color[u] = !color[v];
            dfs(u, comp);
        } else if (used[u] == 1) {
            if (color[u] == color[v]) {
                ok[comp] = true;
                return;
            }
        }
    }
}

vector<point> ps;
unordered_map<int, unordered_map<int, vector<int> > > mp;

void add_edge(const int& x1, const int& y1, const int& x2, const int& y2) {
    for (const int &p1: mp[x1][y1]) {
        for (const int &p2: mp[x2][y2]) {
            if (p1 != p2 && dist(ps[p1], ps[p2]) <= r * r) {
                g[p1].push_back(p2);
                g[p2].push_back(p1);
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> r;
    ps.resize(n);
    g.resize(n);
    vector<pair<int, int> > all;
    for (int i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
        mp[ps[i].x / r][ps[i].y / r].push_back(i);
        all.push_back({ps[i].x / r, ps[i].y / r});
    }
    sort(all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());
    for (const pair<int, int> &cur: all) {
        int cord_x = cur.first, cord_y = cur.second;
        add_edge(cord_x, cord_y, cord_x, cord_y);
        add_edge(cord_x, cord_y, cord_x + 1, cord_y);
        add_edge(cord_x, cord_y, cord_x, cord_y + 1);
        add_edge(cord_x, cord_y, cord_x + 1, cord_y + 1);
        if (cord_x > 0) {
            add_edge(cord_x, cord_y, cord_x - 1, cord_y + 1);
        }
    }
    used.resize(n), ok.resize(n), color.resize(n), comps.resize(n);
    int cmp = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_(i, cmp);
            cmp++;
        }
    }
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, comps[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (ok[comps[i]]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    return 0;
}
