//#pragma GCC optimize("O3, unroll-loops")

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

struct point {
    ll x, y;

    point() {
    }

    point(ll x, ll y): x(x), y(y) {
    }
};

ll dist(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

vector<vector<ll> > g;
vector<ll> len;
vector<bool> ok;
vector<ll> used;

void dfs(ll v) {
    used[v] = 1;
    for (ll u: g[v]) {
        if (used[u] == 0) {
            len[u] = len[v] + 1;
            if (ok[v])ok[u] = 1;
            dfs(u);
        } else if (used[u] == 1) {
            if ((len[u] - len[v]) % 2 == 0) {
                ok[v] = true;
            }
        }
    }
    used[v] = 2;
}
void dfs2(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (ok[v]) ok[u] = true;
        if (used[u]==0) {
            dfs2(u);
        }
        if (ok[u]) ok[v] = true;
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<point> ps(n);
    g.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            if (dist(ps[i], ps[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    used.resize(n), ok.resize(n), len.resize(n);
    for (ll i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs2(i);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ok[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
    return 0;
}
