#include <bits/stdc++.h>

using namespace std;
/*
struct Lst {
    vector<pair<int, int>> v;
    bool sorted = false;
    Lst() {}
    void add(int x, int id) {
        v.emplace_back(x, id);
    }
    void init() {
        if (!sorted) {
            sort(v.begin(), v.end());
            sorted = true;
        }
    }
    int binFind(int r) {
        init();
        int L = -1, R = v.size();
        while (R-L > 1) {
            int M = (L+R)/2;
            if (v[M].first<=r) L = M;
            else R = M;
        }
        return R;
    }
    int count(int l, int r) {
        return binFind(r)-binFind(l-1);
    }
    void get(int l, int r, vector<int>& lst) {
        int lo = binFind(l), hi = binFind(r);
        for (int i = lo; i < hi; ++i) lst.emplace_back(v[i].second);
    }
};

int INF = 500000000;
struct SegmentTree {
    vector<Lst> tree;
    vector<int> lc, rc;
    SegmentTree(): tree(1), lc(1, -1), rc(1, -1) {}
    int nnode() {
        int v = tree.size();
        tree.emplace_back();
        lc.emplace_back(-1);
        rc.emplace_back(-1);
        return v;
    }
    void add(int x, int y, int id) {
        _add(0, 0, INF, x, y, id);
    }
    void _add(int v, int l, int r, int x, int y, int id) {
        tree[v].add(y, id);
        if (l==r) return;
        int mid = (l+r)/2;
        if (x<=mid) {
            if (lc[v]==-1) lc[v] = nnode();
            _add(lc[v], l, mid, x, y, id);
        } else {
            if (rc[v]==-1) rc[v] = nnode();
            _add(rc[v], mid+1, r, x, y, id);
        }
    }
    int count(int xl, int xr, int yl, int yr) {
        return _count(0, 0, INF, xl, xr, yl, yr);
    }
    int _count(int v, int l, int r, int xl, int xr, int yl, int yr) {
        if (v==-1 || r<xl || xr<l) return 0;
        if (xl<=l && r<=xr) return tree[v].count(yl, yr);
        int mid = (l+r)/2;
        return _count(lc[v], l, mid,   xl, xr, yl, yr)+
               _count(rc[v], mid+1, r, xl, xr, yl, yr);
    }
    void get(int xl, int xr, int yl, int yr, vector<int>& lst) {
        _get(0, 0, INF, xl, xr, yl, yr, lst);
    }
    void _get(int v, int l, int r, int xl, int xr, int yl, int yr, vector<int>& lst) {
        if (v==-1 || r<xl || xr<l) return;
        if (xl<=l && r<=xr) {
            tree[v].get(yl, yr, lst);
            return;
        }
        int mid = (l+r)/2;
        _get(lc[v], l, mid,   xl, xr, yl, yr, lst);
        _get(rc[v], mid+1, r, xl, xr, yl, yr, lst);
    }
};
*/
void fillok(int v, vector<vector<int>>& graph, vector<int>& gr) {
    gr[v] = 1;
    for (auto u : graph[v]) {
        if (!gr[u]) fillok(u, graph, gr);
    }
}

bool dfs(int v, int pr, vector<vector<int>>& graph, vector<int>& col) {
    col[v]=1;
    for (auto u : graph[v]) {
        if (u==pr) continue;
        if (col[u]==1) return true;
        if (col[u]==0 && dfs(u, v, graph, col)) return true;
    }
    col[v]=2;
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n; cin >> n;
    int64_t r; cin >> r;
    //SegmentTree tree;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
        //tree.add(p[i].first, p[i].second, i);
    }
    vector<int> gr(n, 0);
    /*for (int i = 0; i < n; ++i) {
        int d = r/2, x = p[i].first, y = p[i].second;
        if (tree.count(x, x+d, y, y+d)>=3) gr[i] = true;
        if (tree.count(x-d, x, y, y+d)>=3) gr[i] = true;
        if (tree.count(x, x+d, y-d, y)>=3) gr[i] = true;
        if (tree.count(x-d, x, y-d, y)>=3) gr[i] = true;
    }*/
    vector<vector<int>> graph(n);
    for (int i = 0; i < n; ++i) {
        if (gr[i]) continue;
        //vector<int> vs;
        //int x = p[i].first, y = p[i].second;
        //tree.get(x-r, x+r, y-r, y+r, vs);
        for (int j = 0; j < n; ++j) {
            if (!gr[j] && j<=i) continue;
            int64_t dx = p[i].first-p[j].first;
            int64_t dy = p[i].second-p[j].second;
            if (dx*dx+dy*dy<=r*r) {
                graph[i].emplace_back(j);
                graph[j].emplace_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (gr[i]) fillok(i, graph, gr);
    }
    vector<int> col(n, 0);
    for (int i = 0; i < n; ++i) {
        if (gr[i] || col[i]) continue;
        if (dfs(i, -1, graph, col)) fillok(i, graph, gr);
    }
    for (int i = 0; i < n; ++i) cout << gr[i];
    cout << '\n';

    return 0;
}