#include <bits/stdc++.h>

using namespace std;

struct MergeSortTree {
    vector<vector<int>> tree;
    vector<vector<int>> cl, cr;
    int sz;
    MergeSortTree(vector<int>& a): sz(a.size()) {
        tree.resize(sz*4);
        cl.resize(sz*4);
        cr.resize(sz*4);
        build(0, 0, sz-1, a);
    }
    void construct(int v) {
        int lc = 2*v+1, rc = 2*v+2;
        int i = 0, j = 0;
        tree[v].reserve(tree[lc].size()+tree[rc].size());
        cl[v].reserve(tree[lc].size()+tree[rc].size());
        cr[v].reserve(tree[lc].size()+tree[rc].size());
        while (i<tree[lc].size() && j<tree[rc].size()) {
            if (tree[lc][i]<tree[rc][j]) {
                tree[v].emplace_back(tree[lc][i]); ++i;
            } else {
                tree[v].emplace_back(tree[rc][j]); ++j;
            }
            cl[v].emplace_back(i-1);
            cr[v].emplace_back(j-1);
        }
        while (i<tree[lc].size()) {
            tree[v].emplace_back(tree[lc][i]); ++i;
            cl[v].emplace_back(i-1);
            cr[v].emplace_back(j-1);
        }
        while (j<tree[rc].size()) {
            tree[v].emplace_back(tree[rc][j]); ++j;
            cl[v].emplace_back(i-1);
            cr[v].emplace_back(j-1);
        }
    }
    void build(int v, int l, int r, vector<int>& a) {
        if (l==r) {
            tree[v] = {a[l]};
            return;
        }
        int mid = (l+r)/2;
        build(2*v+1, l, mid, a);
        build(2*v+2, mid+1, r, a);
        construct(v);
    }
    int get(int l, int r, int x) {
        int L = -1, R = tree[0].size();
        while (R-L > 1) {
            int M = (L+R)/2;
            if (tree[0][M]<x) L = M;
            else R = M;
        }
        return _get(0, 0, sz-1, l, r, L);
    }
    int _get(int v, int l, int r, int L, int R, int id) {
        if (id==-1 || r<L || R<l) return 0;
        if (L<=l && r<=R) return id+1;
        int mid = (l+r)/2;
        return _get(2*v+1, l,   mid, L, R, cl[v][id])+
               _get(2*v+2, mid+1, r, L, R, cr[v][id]);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int r, c; cin >> r >> c;
    bool sw = false;
    if (r>c) {swap(r, c); sw = true;}
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            if (sw) cin >> a[j][i];
            else cin >> a[i][j];
        }
    }
    vector<MergeSortTree> trees;
    for (int i = 0; i < r; ++i) trees.emplace_back(a[i]);
    vector<vector<int64_t>> cnt(r+1, vector<int64_t>(c+1));
    for (int i = r-1; i>=0; --i) {
        for (int j = c-1; j>=0; --j) {
            cnt[i][j] = cnt[i+1][j]+cnt[j][i+1]-cnt[i+1][j+1];
            for (int x = i; x<r; ++x) {
                cnt[i][j] += trees[x].get(j, c-1, a[i][j]);
            }
        }
    }
    vector<vector<int64_t>> dp(r+1, vector<int64_t>(c+1));
    for (int i = r-1; i>=0; --i) {
        for (int j = c-1; j>=0; --j) {
            int64_t inv1 = 0;
            for (int x = i+1; x<r; ++x) inv1 += trees[i].get(j+1, c-1, a[x][j]);
            int64_t inv2 = int64_t(r-i-1)*(c-j-1)-inv1;
            dp[i][j] = min(dp[i][j+1]+inv1, dp[i+1][j]+inv2);
        }
    }
    cout << dp[0][0]+cnt[0][0] << '\n';

    return 0;
}