#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using ll = long long;

const int MAX_NODES = 1e5;

ll sqr(ll x) {
    return x * x;
}

ll r, r_sqr;

bool are_near(int x, int y, int x1, int y1) {
    return sqr(x - x1) + sqr(y - y1) <= r_sqr;
}

int comp_color[MAX_NODES], color[MAX_NODES];
int xs[MAX_NODES], ys[MAX_NODES];
int n;

void dfs(int v, int comp_col, bool col) {
    comp_color[v] = comp_col;
    color[v] = col;
    for (int x = 0; x < n; ++x) {
        if (x == v) continue;
        if (!are_near(xs[v], ys[v], xs[x], ys[x])) continue;
        if (comp_color[x] != -1) {
            if (color[x] == col) {
                color[v] = -2;
            }
        } else {
            dfs(x, comp_col, !col);
        }
    }
}

void solve() {
    cin >> n >> r;
    r_sqr = r * r;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        xs[i] = x;
        ys[i] = y;
    }
    memset(comp_color, -1, sizeof(color[0]) * n);
    int components_cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (comp_color[i] == -1) {
            dfs(i, components_cnt++, false);
        }
    }
    vector<vector<int>> component_vertices(components_cnt);
    vector<bool> is_bad_comp(components_cnt);
    for (int i = 0; i < n; ++i) {
        if (comp_color[i] != -1) {
            component_vertices[comp_color[i]].push_back(i);
            if (color[i] == -2)
                is_bad_comp[comp_color[i]] = true;
        }
    }
    string ans(n, '0');
    for (int i = 0; i < components_cnt; ++i) {
        if (is_bad_comp[i]) {
            for (int j : component_vertices[i]) {
                if (j < n) {
                    ans[j] = '1';
                }
            }
        }
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}