#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using ll = long long;

#define all(x) (x).begin(), (x).end()

const int MAX_N = 2e3;

vector<int> grid[MAX_N];
vector<ll> dp[MAX_N];

int n, m;

ll count(int i1, int j1, vector<int> &values) {
    ll res = 0;
    for (int i = 0; i < (int) values.size(); ++i) {
        for (int j = i + 1; j < (int) values.size(); ++j) {
            res += values[i] > values[j];
        }
    }
    sort(all(values));
    for (int i = i1; i < n; ++i) {
        for (int j = j1; j < m; ++j) {
            res += values.end() - upper_bound(all(values), grid[i][j]);
        }
    }
    return res;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        grid[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> grid[i][j];
        }
        dp[i].resize(m + 1);
    }
    dp[n].resize(m + 1);
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            vector<int> vec1(grid[i].begin() + j, grid[i].begin() + m);
            vector<int> vec2;
            for (int i1 = i; i1 < n; ++i1) {
                vec2.push_back(grid[i1][j]);
            }
            dp[i][j] = min(dp[i + 1][j] + count(i + 1, j, vec1), dp[i][j + 1] + count(i, j + 1, vec2));
        }
    }
    cout << dp[0][0] << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}
