#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif

using ll = long long;

const int LOG_N = 19;
const int MAX_N = 1 << LOG_N;

int arr[MAX_N];

int unite(int a, int b) {
    return arr[a] < arr[b] ? a : b;
}

struct SparseTable {
    int table[LOG_N][MAX_N];

    void init(int n) {
        for (int i = 0; i < n; ++i) {
            table[0][i] = i;
        }
        for (int lvl = 0; lvl < LOG_N - 1; ++lvl) {
            for (int i = 0; i < n - (1 << lvl); ++i) {
                table[lvl + 1][i] = unite(table[lvl][i], table[lvl][i + (1 << lvl)]);
            }
        }
    }

    int get(int l, int r) {
        int lvl = __lg(r - l + 1);
        return unite(table[lvl][l], table[lvl][r - (1 << lvl) + 1]);
    }
};

int next_gr[MAX_N], suff_max[MAX_N];
int n, q;
SparseTable table;

void solve() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    table.init(n);
    for (int i = n - 1; i >= 0; --i) {
        suff_max[i] = max(suff_max[i + 1], arr[i]);
    }
    next_gr[n - 1] = n;
    for (int i = n - 2; i >= 0; --i) {
        next_gr[i] = i + 1;
        while (next_gr[i] != n && arr[next_gr[i]] <= arr[i]) {
            next_gr[i] = next_gr[next_gr[i]];
        }
    }
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        --ind;
        int x = 0;
        for (int i = 0; i < ind; ++i) {
            if (i < k - 1) {
                int l = x + 1;
                int r = min(n - k + i + 1, next_gr[x]);
                assert(l <= r);
                x = table.get(l, r);
            } else {
                x = next_gr[x] >= n ? n - 1 : next_gr[x];
            }
        }
        if (ind == k - 1) {
            cout << suff_max[x] << "\n";
        } else {
            cout << arr[x] << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}
