#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <cmath>

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define for1(i, n) for (ll i = 1; i <= n; ++i)
#define all(v) v.begin(), v.end()
using ll = long long;
using pll = pair <ll, ll>;
using vll = vector <ll>;
using vpll = vector <pll>;
using vvll = vector <vll>;

const ll N = 250000;

class tree {
public:
	ll n;
	ll tr[2 * N + 1];

	void update(ll p) {
		p += n;
		tr[p] = 1; p >>= 1;
		while (p > 0) {
			tr[p] = tr[p << 1] + tr[p << 1 | 1];
			p >>= 1;
		}
	}
	ll sum(ll l, ll r) {
		ll res = 0;
		l += n; r += n;
		while (l < r) {
			if (l & 1)
				res += tr[l++];
			if (r & 1)
				res += tr[--r];
			l >>= 1; r >>= 1;
		}
		return res;
	}
	void cl() {
		for0(i, 2 * N + 1)
			tr[i] = 0;
	}
};

ll r, c, ans = 1e18;
ll v[N + 1], ansv[N + 1];
vvll mat;
tree tr;

ll f(ll k) {
	ll sw = 0;
	for (ll i = k; i >= 1; --i) {
		sw += tr.sum(0, v[i]);
		tr.update(v[i] - 1);
	}
	tr.cl();
	return sw;
}

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	cin >> r >> c;
	mat.resize(r + 1, vll(c + 1)); tr.n = c;
	for1(i, r) {
		for1(j, c)
			cin >> mat[i][j];
	}
	for1(i, r) {
		for1(j, c)
			v[i * c + j] = mat[i][j];
	}
	ans = min(ans, f(r * c));
	for1(j, c) {
		for1(i, r)
			v[j * c + i] = mat[i][j];
	}
	ans = min(ans, f(r * c));
	cout << ans << "\n";
}