#include <bits/stdc++.h>

using namespace std;

using ll = int;

const ll N = 3e5 + 5;

ll n, q;

ll a[N];
ll pos[N];

struct st {
    vector<ll> tree;

    st() {
        tree.assign(n * 4 + 20, n + 1);
    }

    void build1(ll v, ll tl, ll tr) {
        if (tl == tr) {
            if (tl != 0 && tl != n + 1)
            tree[v] = a[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build1(v * 2, tl, tm);
        build1(v * 2 + 1, tm + 1, tr);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }

    void build2(ll v, ll tl, ll tr) {
        if (tl == tr) {
            if (tl != 0 && tl != n + 1)
            tree[v] = pos[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build2(v * 2, tl, tm);
        build2(v * 2 + 1, tm + 1, tr);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }

    void put(ll v, ll tl, ll tr, ll k, ll x) {
        if (tl > k || tr < k) {
            return;
        }
        if (tl == tr) {
            tree[v] = x;
            return;
        }
        ll tm = (tl + tr) / 2;
        put(v * 2, tl, tm, k, x);
        put(v * 2 + 1, tm + 1, tr, k, x);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }

    void put(ll k, ll x) {
        put(1, 0, n + 1, k, x);
    }

    ll get(ll v, ll tl, ll tr, ll l, ll r) {
        if (tl > r || tr < l) {
            return n + 1;
        }
        if (tl >= l && tr <= r) {
            return tree[v];
        }
        ll tm = (tl + tr) / 2;
        return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
    }

    ll get(ll l, ll r) {
        return get(1, 0, n + 1, l, r);
    }
};

ll suf_mx[N];
unordered_map<ll, vector<ll> > qp;

void solve() {
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    for (int i = n; i >= 1; --i) {
        suf_mx[i] = max(suf_mx[i + 1], a[i]);
    }

    for (int i = 0; i < q; ++i) {
        ll k, ind;
        cin >> k >> ind;
        if (ind != k) {
            cout << a[ind] << '\n';
        } else {
            if (ind % 2 == 0) {
                cout << a[ind] << '\n';
            } else {
                cout << a[n] << '\n';
            }
        }
        /*
        ll kd = k;
        if (!qp.count(kd)) {
            st tr1, tr2;
            tr1.build1(1, 0, n + 1);
            tr2.build2(1, 0, n + 1);

            for (int j = 1; j <= n; ++j) {
                tr1.put(j, a[j]);
                tr2.put(a[j], j);
            }

            ll t = 1;
            vector<ll> e;
            while (k > 0) {
                ll b;
                if (k == 1) {
                    b = suf_mx[t];
                } else if (k == 2) {
                    b = a[t];
                    ll new_t = min(n, tr2.get(a[t] + 1, n + 1));
                    t = new_t;
                } else {
                    b = a[t];
                    ll new_t = min(n - k + 2, tr2.get(a[t] + 1, n + 1));
                    ll mn = tr1.get(t + 1, new_t);
                    new_t = pos[mn];
                    while (t < new_t) {
                        tr1.put(t, n + 1);
                        tr2.put(a[t], n + 1);
                        t++;
                    }
                }
                k--;
                e.push_back(b);
            }
            qp[kd] = e;
        }
        cout << qp[kd][ind - 1] << '\n';
        */
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}

/*
7 7
1 7 2 6 3 5 4
7 4
3 3
5 3
3 1
5 4
7 1
2 1
6
4
2
1
6
1
1
 */