#pragma GCC optimize("O3")
#pragma target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cout << setprecision(20) << fixed;
    int t = 1; //cin >> t;
    while (t--) solve();
}

struct Tree {
    int n;
    vector<int> f;

    Tree(int n) : n(n) {
        f.resize(n);
    }

    void update(int pos, int val) {
        while (pos < n) {
            f[pos] += val;
            pos |= (pos + 1);
        }
    }

    int get(int pos) {
        int ans = 0;
        while (pos >= 0) {
            ans += f[pos];
            pos &= (pos + 1);
            pos--;
        }
        return ans;
    }
    int get(int l, int r) {
        ll ans = get(r);
        if (l > 0) ans -= get(l -1);
        return ans;
    }
};

const ll INF = 1e18;

void solve() {
    int n, m; cin >> n >> m;
    ll mx = n * m;
    vector<vector<int> > a(n + 1, vector<int> (m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }


    if (n == 1) {
        Tree f(mx + 1);
        ll ans = 0;
        for (int j = 1; j <= m; j++) {
            ans += f.get(a[1][j], mx);
            f.update(a[1][j], 1);
        }
        cout << ans;
        return;
    }


    vector<vector<ll> > dp(n + 1, vector<ll> (m + 1, INF));
    dp[0][0] = 0;
    Tree f(mx + 1);
    for (int i = 0; i <= n; i++) {
        if (i > 1)
            for (int j = 1; j <= m; j++) f.update(a[i - 1][j], 1);

        for (int j = 0; j <= m; j++) {
            if (j > 1) {
                for (int i1 = i + 1; i1 <= n; i1++) f.update(a[i1][j - 1], 1);
                f.update(a[i][j - 1], 1);
            }

            if (j > 0) {
                for (int j1 = j; j1 <= m; j1++) f.update(a[i][j1], 1);
                ll res = 0;
                for (int i1 = i + 1; i1 <= n; i1++) {
                    res += f.get(a[i1][j], mx);
                    f.update(a[i1][j], 1);
                }
                dp[i][j] = dp[i][j - 1] + res;
                for (int j1 = j; j1 <= m; j1++) f.update(a[i][j1], -1);
                for (int i1 = i + 1; i1 <= n; i1++) f.update(a[i1][j], -1);
            }

            if (i > 0) {
                for (int i1 = i; i1 <= n; i1++) f.update(a[i1][j], 1);

                ll res = 0;
                for (int j1 = j + 1; j1 <= m; j1++) {
                    res += f.get(a[i][j1], mx);
                    f.update(a[i][j1], 1);
                }
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + res);

                for (int i1 = i; i1 <= n; i1++) f.update(a[i1][j], -1);
                for (int j1 = j + 1; j1 <= m; j1++) f.update(a[i][j1], -1);
            }
        }

        for (int i1 = i; i1 <= n; i1++) {
            for (int j1 = 0; j1 < m; j1++) {
                f.update(a[i1][j1], -1);
            }
        }

    }
    cout << dp[n][m];
}