#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;
long long r;
struct point {
    long long x, y;
    int num;
};
bool dist(int x1, int y1, int x2, int y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) <= r * r;
}
vector<int> used;
vector<bool> color;
vector<int> h;
set<pair<int, int>> st;
map<pair<int, int>, int> mp;
vector<pair<int, int>> g;
int t = 0;
void dfs(int v, int pr) {
    if (v != pr) {
        h[v] = h[pr] + 1;
    }
    used[v] = t;
    int x = g[v].first;
    int y = g[v].second;
    for (int i = x - r; i < x + r + 1; ++i) {
        for (int j = y - r; j < y + r + 1; ++j) {
            if (i == x && j == y) {
                continue;
            }
            if (dist(i, j, x, y) == 1 && st.count({i, j}) == 1) {
                int u = mp[{i, j}];
                if (used[u] == t) {
                    if (abs(h[u] - h[v]) % 2 == 0) {
                        color[t] = 1;
                    }
                } else {
                    dfs(u, v);
                }
            }
        }
    }
}
int main() {
    int n;
    cin >> n >> r;
    h.resize(n, 0);
    used.resize(n, 0);
    color.resize(n + 1, 0);
    g.resize(n, {0, 0});
    int x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        st.insert({x, y});
        mp[{x, y}] = i;
        g[i] = {x, y};
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            t += 1;
            dfs(i, i);
        }
    }
    string ans = "";
    for (int i = 0; i < n; ++i) {
        if (color[used[i]] == 1) {
            ans += '1';
        } else {
            ans += '0';
        }
    }
    cout << ans;
    return 0;
}
