#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

struct segtree {
    int sz;
    vector<int> tree;

    void init(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1, 0);
    }

    void add(int i, int v) {
        add(i, v, 0, 0, sz);
    }

    void add(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] += v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            add(i, v, 2 * x + 1, lx, m);
        }
        else {
            add(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int l, int r) {
        return get(l, r, 0, 0, sz);
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (rx <= l || lx >= r) {
            return 0;
        }
        if (l <= lx && r >= rx) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        return get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx);
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> dp(r + 1, vector<int>(c + 1, 1e18));
    vector<vector<segtree>> tr(r + 1, vector<segtree>(c + 1));
    tr[0][0].init(r * c + 1000);
    dp[0][0] = 0;
    for (int i = 0; i <= r; i++) {
        for (int j = 0; j <= c; j++) {
            if (i == 0 && j == 0 || i == r && j == c) continue;
            segtree tr1, tr2;
            if (i) {
                // check i - 1, j
                int ans = dp[i - 1][j];
                int add = 0;
                for (int k = j; k < c; k++) {
                    int cur_el = a[i - 1][k];
                    add += tr[i - 1][j].get(cur_el, r * c + 1);
                    tr[i - 1][j].add(cur_el, 1);
                    // cur.push_back(cur_el);
                }
                if (dp[i][j] > ans + add) {
                    dp[i][j] = min(dp[i][j], ans + add);
                    tr[i][j] = tr[i - 1][j];
                }
                for (int k = j; k < c; k++) {
                    int cur_el = a[i - 1][k];
                    tr[i - 1][j].add(cur_el, -1);
                    // cur.push_back(cur_el);
                }
            }
            if (j) {
                // check i, j - 1
                int ans = dp[i][j - 1];
                int add = 0;
                for (int k = i; k < r; k++) {
                    int cur_el = a[k][j - 1];
                    add += tr[i][j - 1].get(cur_el, r * c + 1);
                    tr[i][j - 1].add(cur_el, 1);
                }
                if (dp[i][j] > ans + add) {
                    dp[i][j] = min(dp[i][j], ans + add);
                    tr[i][j] = tr[i][j - 1];
                }
                for (int k = i; k < r; k++) {
                    int cur_el = a[k][j - 1];
                    tr[i][j - 1].add(cur_el, -1);
                }
            }
        }
    }
    cout << min(min(dp[r][0], dp[0][c]), min(dp[r - 1][c], dp[r][c - 1])) << '\n';
 }

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;

    solve();

    return 0;
}