// #pragma GCC optimize("O3, Ofast")
#include <bits/stdc++.h>
#define int long long
#define all(x) (x).begin(), (x).end()
#define pi pair<int, int>
#define f first
#define s second

using namespace std;

struct fenwtree {
    int sz;
    vector<int> t;

    void init(int n) {
        sz = n;
        t.assign(n + 1, 0);
    }

    void add(int i, int v) {
        for (; i <= sz; i += i & (-i)) {
            t[i] += v;
        }
    }

    int sum(int r) {
        int res = 0;
        for (; r > 0; r -= r & (-r)) {
            res += t[r];
        }
        return res;
    }

    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    vector<vector<int>> invsl(n, vector<int>(m + 1)), invsr(n + 1, vector<int>(m)),
    suml(n, vector<int>(m + 1)), sumr(n + 1, vector<int>(m + 1));
    for (int i = 0; i < n; ++i) {
        vector<int> crd = a[i];
        sort(all(crd));
        fenwtree fw;
        fw.init(m);
        for (int j = m - 1; j >= 0; --j) {
            int lb = lower_bound(all(crd), a[i][j]) - crd.begin() + 1;
            invsl[i][j] = invsl[i][j + 1] + fw.sum(1, lb);
            suml[i][j] = suml[i][j + 1] + a[i][j];
            fw.add(lb, 1);
        }
    }
    fenwtree ff;
    ff.init(n * m);
    fenwtree fs;
    fs.init(n * m);
    vector<int> prec(m + 1);
    for (int i = m - 1; i >= 0; --i) {
        prec[i] += fs.sum(a[0][i], n * m);
        ff.add(a[0][i], 1);
        prec[i] += ff.sum(1, a[1][i]);
        prec[i] += prec[i + 1];
        fs.add(a[1][i], 1);
    }
    int res = 1e18;
    fenwtree fw;
    fw.init(n * m);
    int cur = 0;
    for (int j = 0; j < m; ++j) {
        int c = invsl[0][j] + invsl[1][j];
        int p = (m - j) * (m - j - 1) / 2;
        c += n * m * (m - j) - suml[1][j] - p;
        c += n * m * (m - j) - suml[0][j] - p - prec[j];
        res = min(res, cur + c);
        cur += fw.sum(a[0][j], n * m);
        fw.add(a[0][j], 1);
        cur += fw.sum(a[1][j], n * m);
        fw.add(a[1][j], 1);
    }
    res = min(res, cur);
    cout << res << "\n";
}
