#pragma GCC optimize("O3, Ofast")
#include <bits/stdc++.h>
#pragma GCC optimize("avx")
#define int long long
#define all(x) (x).begin(), (x).end()
#define pi pair<int, int>
#define f first
#define s second

using namespace std;

struct fenwtree {
    int sz;
    vector<int> t;

    void init(int n) {
        sz = n;
        t.assign(n + 1, 0);
    }

    void add(int i, int v) {
        for (; i <= sz; i += i & (-i)) {
            t[i] += v;
        }
    }

    int sum(int r) {
        int res = 0;
        for (; r > 0; r -= r & (-r)) {
            res += t[r];
        }
        return res;
    }

    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> invsl(n, vector<int>(m + 1)), invsr(n + 1, vector<int>(m)),
    suml(n, vector<int>(m + 1)), sumr(n + 1, vector<int>(m + 1));
    for (int i = 0; i < n; ++i) {
        vector<int> crd = a[i];
        sort(all(crd));
        fenwtree fw;
        fw.init(m);
        for (int j = m - 1; j >= 0; --j) {
            int lb = lower_bound(all(crd), a[i][j]) - crd.begin() + 1;
            invsl[i][j] = invsl[i][j + 1] + fw.sum(1, lb);
            suml[i][j] = suml[i][j + 1] + a[i][j];
            fw.add(lb, 1);
        }
    }
    for (int j = 0; j < m; ++j) {
        vector<int> crd(n);
        for (int i = 0; i < n; ++i) {
            crd[i] = a[i][j];
        }
        sort(all(crd));
        fenwtree fw;
        fw.init(n);
        for (int i = n - 1; i >= 0; --i) {
            int lb = lower_bound(all(crd), a[i][j]) - crd.begin() + 1;
            invsr[i][j] = invsr[i + 1][j] + fw.sum(1, lb);
            sumr[i][j] = sumr[i + 1][j] + a[i][j];
            fw.add(lb, 1);
        }
    }
    vector<vector<int>> vall(n, vector<int>(m)), valr(n, vector<int>(m));
    vector<int> crd;
    fenwtree fw;

    fenwtree ff;

    for (int i = n - 1; i >= 1; --i) {
        fw.init(n * m);
        ff.init(n * m);
        int cur = 0;
        for (int j = m - 1; j >= 0; --j) {
            for (int k = i; k < n; ++k) {
                cur += ff.sum(1, a[k][j]);
                fw.add(a[k][j], 1);
            }
            cur += fw.sum(a[i - 1][j], n * m);
            ff.add(a[i - 1][j], 1);
            int p = (m - j) * (m - j - 1) / 2;
            vall[i][j] = n * m * (m - j) - suml[i - 1][j] - cur - p;
        }
    }

    for (int i = n - 1; i >= 0; --i) {
        fw.init(n * m);
        for (int j = m - 1; j >= 1; --j) {
            for (int k = i; k < n; ++k) {
                fw.add(a[k][j], 1);
            }
            int cur = 0;
            for (int k = i; k < n; ++k) {
                cur += fw.sum(a[k][j - 1], n * m);
            }
            int p = (n - i) * (n - i - 1) / 2;
            valr[i][j] = n * m * (n - i) - sumr[i][j - 1] - cur - p;
        }
    }
    vector<vector<int>> dp(n, vector<int>(m, 1e18));
    dp[0][0] = 0;
    int res = 1e18;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i > 0) {
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + invsl[i - 1][j] + vall[i][j]);
            }
            if (j > 0) {
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + invsr[i][j - 1] + valr[i][j]);
            }
            if (i == n - 1) {
                int p = (m - j) * (m - j - 1) / 2;
                res = min(res, dp[i][j] + n * m * (m - j) - suml[i][j] - p + invsl[i][j]);
            }
            if (j == m - 1) {
                int p = (n - i) * (n - i - 1) / 2;
                res = min(res, dp[i][j] + n * m * (n - i) - sumr[i][j] - p + invsr[i][j]);
            }
        }
    }
    cout << res << "\n";
}
