#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 1e5 + 1;
const ll INF = 1e18;


void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<ll>> a(n + 1, vector<ll> (m + 1, INF));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    vector<vector<vector<ll>>> cnt(n + 1, vector<vector<ll>> (m + 1, vector<ll> (n * m)));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            for (int x = 0; x < n * m; x++) {
                cnt[i][j][x] = cnt[i + 1][j][x] + cnt[i][j + 1][x] - cnt[i + 1][j + 1][x] + (a[i][j] <= x);
            }
        }
    }

    vector<vector<vector<ll>>> pref(n + 1, vector<vector<ll>> (m + 1, vector<ll> (m + 1)));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            for (int k = m - 1; k >= 0; k--) {
                pref[i][j][k] = cnt[i + 1][k][a[i][j]];
            }
        }
    }

    vector<vector<vector<ll>>> suf(n + 1, vector<vector<ll>> (m + 1, vector<ll> (n + 1)));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            for (int k = n - 1; k >= 0; k--) {
                suf[i][j][k] = cnt[k][j + 1][a[i][j]];
            }
        }
    }

    vector<vector<ll>> row(n + 1, vector<ll> (m + 1));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            ll plus = 0;
            for (int k = j + 1; k < m; k++) {
                plus += (a[i][j] > a[i][k]);
            }
            row[i][j] = row[i][j + 1] + plus;
        }
    }

    vector<vector<ll>> col(n + 1, vector<ll> (m + 1));
    for (int j = m - 1; j >= 0; j--) {
        for (int i = n - 1; i >= 0; i--) {
            ll plus = 0;
            for (int k = i + 1; k < n; k++) {
                plus += (a[i][j] > a[k][j]);
            }
            col[i][j] = col[i + 1][j] + plus;
        }
    }

    vector<vector<ll>> dp(n + 1, vector<ll> (m + 1));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            dp[i][j] = INF;

            ll val1 = 0;
            for (int k = j; k < m; k++) {
                val1 += pref[i][k][j];
            }
            dp[i][j] = min(dp[i][j], dp[i + 1][j] + val1 + row[i][j]);

            ll val2 = 0;
            for (int k = i; k < n; k++) {
                val2 += suf[k][j][i];
            }
            dp[i][j] = min(dp[i][j], dp[i][j + 1] + val2 + col[i][j]);
        }
    }
    cout << dp[0][0] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();

    return 0;
}
