#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 1e5 + 1;
const ll INF = 1e18;

struct fenwick {
    ll n;
    vector<ll> t;

    fenwick() {}

    fenwick(ll _n) {
        n = _n;
        t.resize(n);
    }

    ll pref(ll r) {
        ll ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans += t[r];
        }
        return ans;
    }

    void upd(ll val, ll i) {
        for (; i < n; i = (i | (i + 1))) {
            t[i] += val;
        }
    }

    ll get(ll l, ll r) {
        return pref(r) - pref(l - 1);
    }
};

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll> a(m);
    for (int i = 0; i < m; i++) cin >> a[i], a[i]--;
    fenwick t(m);
    ll ans = 0;
    for (int i = m - 1; i >= 0; i--) {
        ans += t.get(0, a[i] - 1);
        t.upd(1, a[i]);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    solve();

    return 0;
}
