#ifdef  LOCAL
#define GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl;
#else
#pragma GCC optimize("O3")
#define debug(x)
#endif

#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

vector<vector<int>> g;

struct Point {
    ll x, y, i;
    ll lenSqr() const {
        return x * x + y * y;
    }
    Point operator-(const Point b) const {
        return {x - b.x, y - b.y};
    }
};

vector<int> components;
vector<bool> with_cycle;
vector<int> color;
int t = 1;
void dfs(int v, bool c) {
    components[v] = t;
    color[v] = c;
    for (int u : g[v]) {
        if (color[u] == -1) {
            dfs(u, !c);
        }
        else if (color[u] == color[v]) {
            with_cycle[t] = true;
        }
    }
}

mt19937_64 rnd(56767543);

bool xcmp(const Point &a, const Point &b) {
    if (a.x != b.x)
    return a.x < b.x;
    return a.y < b.y;
}

bool ycmp(const Point &a, const Point &b) {
    if (a.y != b.y)
        return a.y < b.y;
    return a.x < b.x;
}

struct ytruck {
    bool operator()(const Point &a, const Point &b) const {
        if (a.y != b.y)
            return a.y < b.y;
        return a.x < b.x;
    }

};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    ll r;
    cin >> n >> r;
    g.resize(n);
    vector<Point> points(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].x >> points[i].y;
        points[i].i = i;
    }
    sort(all(points), xcmp);
    set<Point, ytruck> s;
    int j = 0;
    for (Point p : points) {
        while (j < n && points[j].x < p.x - r) {
            s.erase(points[j]);
            j++;
        }
        auto it = s.lower_bound(Point(p.y - r, -1e9));
        while (it != s.end() && it->y <= p.y + r && g[p.i].size() < 6) {
            Point q = *it;
            if ((p - q).lenSqr() <= r * r) {
                g[p.i].push_back(q.i);
                g[q.i].push_back(p.i);
            }
            ++it;
        }
        s.insert(p);
    }
    components.resize(n, -1);
    with_cycle.resize(2 * n + 100);
    color.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (components[i] == -1) {
            dfs(i, 0);
            t += 2;
        }
    }
    vector<bool> ans(n);
    for (int i = 0; i < n; i++) {
        if (with_cycle[components[i]]) {
            ans[i] = 1;
        }
        else {
            ans[i] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        if (g[i].size() >= 50) assert(ans[i]);
        cout << ans[i];
    }
}