#ifdef  LOCAL
#define GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl;
#else
#pragma GCC optimize("O3")
#define debug(x)
#endif

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

vector<vector<int>> grid;
int n, m;

int inv_in_row(int i, int start, int x) {
    int ans = 0;
    for (int j = start; j <= m; j++) {
        if (grid[i][j] < x) ans++;
    }
    return ans;
}

int inv_in_col(int j, int start, int x) {
    int ans = 0;
    for (int i = start; i <= n; i++) {
        if (grid[i][j] < x) ans++;
    }
    return ans;
}

struct query {
    int to_i, to_j, x;
    bool type_to;
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    grid.resize(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> grid[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e18));
    vector<vector<ll>> pref_col(n + 1, vector<ll>(m + 1));
    vector<vector<ll>> pref_row(n + 1, vector<ll>(m + 1));
    vector add_col = pref_col;
    vector add_row = pref_row;
    vector<vector<vector<query>>> row_queries(n + 1, vector<vector<query>>(m + 1));
    vector<vector<vector<query>>> col_queries(n + 1, vector<vector<query>>(m + 1));
    for (int i = n; i >= 1; i--) {
        for (int j = m; j >= 1; j--) {
            row_queries[i - 1][j].push_back({i - 1, j, grid[i - 1][j], 0});
            for (int s = j + 1; s <= m; s++) {
                col_queries[i][s].push_back({i - 1, j, grid[i - 1][j], 0});
            }
            for (int k = j; k <= m; k++) {
                col_queries[i][j].push_back({i - 1, j, grid[i - 1][k], 0});
            }
            // ll ans1 = 0;
            // ans1 += inv_in_row(i - 1, j, grid[i - 1][j]);
            // for (int s = j + 1; s <= m; s++) {
            //     ans1 += inv_in_col(s, i, grid[i - 1][j]);
            // }
            // for (int k = j; k <= m; k++) {
            //     ans1 += inv_in_col(j, i, grid[i - 1][k]);
            // }
            // add_row[i - 1][j] = ans1;
            col_queries[i][j - 1].push_back({i, j - 1, grid[i][j - 1], 1});
            // ll ans2 = 0;
            // ans2 += inv_in_col(j - 1, i, grid[i][j - 1]);
            for (int s = i + 1; s <= n; s++) {
                row_queries[s][j].push_back({i, j - 1, grid[i][j - 1], 1});
                // ans2 += inv_in_row(s, j, grid[i][j - 1]);
            }
            for (int k = i; k <= n; k++) {
                row_queries[i][j].push_back({i, j - 1, grid[k][j - 1], 1});
                // ans2 += inv_in_row(i, j, grid[k][j - 1]);
            }
            // add_col[i][j - 1] = ans2;
        }
    }
    for (int i = 0; i <= n; i++) {
        ordered_set s;
        for (int j = m; j >= 0; j--) {
            s.insert(grid[i][j]);
            for (query q : row_queries[i][j]) {
                if (q.type_to == 0)
                    add_row[q.to_i][q.to_j] += s.order_of_key(q.x);
                else
                    add_col[q.to_i][q.to_j] += s.order_of_key(q.x);
            }
        }
    }
    for (int j = 0; j <= m; j++) {
        for (int i = n; i >= 0; i--) {
            for (query q : col_queries[i][j]) {
                if (q.type_to == 0)
                    add_row[q.to_i][q.to_j] += inv_in_col(j, i, q.x);
                else
                    add_col[q.to_i][q.to_j] += inv_in_col(j, i, q.x);
            }
        }
    }
    for (int i = n; i >= 1; i--) {
        for (int j = m; j >= 1; j--) {
            ll ans1 = add_row[i - 1][j];
            if (j < m) ans1 += pref_row[i - 1][j + 1];
            pref_row[i - 1][j] = ans1;
            ll ans2 = add_col[i][j - 1];
            if (i < n) ans2 += pref_col[i + 1][j - 1];
            pref_col[i][j - 1] = ans2;
        }
    }
    dp[0][0] = 0;
    dp[0][1] = 0;
    dp[1][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            ll ans1 = dp[i - 1][j] + pref_row[i - 1][j];
            ll ans2 = dp[i][j - 1] + pref_col[i][j - 1];
            dp[i][j] = min(ans1, ans2);
        }
    }
    cout << dp[n][m] << '\n';
}