#ifdef  LOCAL
#define GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl;
#else
#pragma GCC optimize("O3")
#define debug(x)
#endif

#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

vector<vector<int>> grid;
int n, m;

int inv_in_row(int i, int start, int x) {
    int ans = 0;
    for (int j = start; j <= m; j++) {
        if (grid[i][j] < x) ans++;
    }
    return ans;
}

int inv_in_col(int j, int start, int x) {
    int ans = 0;
    for (int i = start; i <= n; i++) {
        if (grid[i][j] < x) ans++;
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    grid.resize(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> grid[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e18));
    vector<vector<ll>> pref_col(n + 1, vector<ll>(m + 1));
    vector<vector<ll>> pref_row(n + 1, vector<ll>(m + 1));
    for (int i = n; i >= 1; i--) {
        for (int j = m; j >= 1; j--) {
            ll ans1 = 0;
            if (j < m) ans1 = pref_row[i - 1][j + 1];
            ans1 += inv_in_row(i - 1, j, grid[i - 1][j]);
            for (int s = j + 1; s <= m; s++) {
                ans1 += inv_in_col(s, i, grid[i - 1][j]);
            }
            for (int k = j; k <= m; k++) {
                ans1 += inv_in_col(j, i, grid[i - 1][k]);
            }
            // ll ans1 = 0;
            // for (int k = j; k <= m; k++) {
            //     ans1 += inv_in_row(i - 1, k, grid[i - 1][k]);
            //     for (int s = j; s <= m; s++) {
            //         ans1 += inv_in_col(s, i, grid[i - 1][k]);
            //     }
            // }
            pref_row[i - 1][j] = ans1;
            ll ans2 = 0;
            for (int k = i; k <= n; k++) {
                ans2 += inv_in_col(j - 1, k, grid[k][j - 1]);
                for (int s = i; s <= n; s++) {
                    ans2 += inv_in_row(s, j, grid[k][j - 1]);
                }
            }
            pref_col[i][j - 1] = ans2;
        }
    }
    dp[0][0] = 0;
    dp[0][1] = 0;
    dp[1][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            ll ans1 = dp[i - 1][j] + pref_row[i - 1][j];
            ll ans2 = dp[i][j - 1] + pref_col[i][j - 1];
            dp[i][j] = min(ans1, ans2);
        }
    }
    cout << dp[n][m] << '\n';
}