#ifdef  LOCAL
#define GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl;
#else
#pragma GCC optimize("O3")
#define debug(x)
#endif

#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

struct SegmentTree : vector<vector<int>> {
    int n;
    SegmentTree(vector<int> _x) {
        n = sz(_x);
        for (int m = 1; m < n || !(n = m); m <<= 1);
        while (sz(_x) < n) _x.push_back(1e9);
        resize(2 * n);
        for (int i = 0; i < n; i++) {
            at(i + n) = {_x[i]};
        }
        for (int i = n - 1; i > 0; i--) {
            std::merge(all(at(i * 2)), all(at(i * 2 + 1)), back_inserter(at(i)));
        }
    }

    int get(int p, int l, int r, int ql, int qr, int x) {
        if (ql <= l && r <= qr) {
            return lower_bound(all(at(p)), x) - at(p).begin();
        }
        if (qr <= l || r <= ql) {
            return 0;
        }
        int m = (l + r) / 2;
        return get(p * 2, l, m, ql, qr, x) + get(p * 2 + 1, m, r, ql, qr, x);
    }

    int get(int ql, int qr, int x) {
        return get(1, 0, n, ql, qr, x);
    }
};

vector<vector<int>> grid;
vector<SegmentTree> row_trees, col_trees;
int n, m;

int inv_in_row(int i, int start, int x) {
    return row_trees[i].get(start, m + 1, x);
}

int inv_in_col(int j, int start, int x) {
    return col_trees[j].get(start, n + 1, x);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    grid.resize(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> grid[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e18));
    vector<vector<ll>> pref_col(n + 1, vector<ll>(m + 1));
    vector<vector<ll>> pref_row(n + 1, vector<ll>(m + 1));
    for (int i = 0; i <= n; i++) {
        row_trees.push_back(SegmentTree(grid[i]));
    }
    for (int j = 0; j <= m; j++) {
        vector<int> col;
        for (int i = 0; i <= n; i++) {
            col.push_back(grid[i][j]);
        }
        col_trees.push_back(SegmentTree(col));
    }
    for (int i = n; i >= 1; i--) {
        for (int j = m; j >= 1; j--) {
            ll ans1 = 0;
            if (j < m) ans1 = pref_row[i - 1][j + 1];
            ans1 += inv_in_row(i - 1, j, grid[i - 1][j]);
            for (int s = j + 1; s <= m; s++) {
                ans1 += inv_in_col(s, i, grid[i - 1][j]);
            }
            for (int k = j; k <= m; k++) {
                ans1 += inv_in_col(j, i, grid[i - 1][k]);
            }
            pref_row[i - 1][j] = ans1;
            ll ans2 = 0;
            if (i < n) ans2 = pref_col[i + 1][j - 1];
            ans2 += inv_in_col(j - 1, i, grid[i][j - 1]);
            for (int s = i + 1; s <= n; s++) {
                ans2 += inv_in_row(s, j, grid[i][j - 1]);
            }
            for (int k = i; k <= n; k++) {
                ans2 += inv_in_row(i, j, grid[k][j - 1]);
            }
            pref_col[i][j - 1] = ans2;
        }
    }
    dp[0][0] = 0;
    dp[0][1] = 0;
    dp[1][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            ll ans1 = dp[i - 1][j] + pref_row[i - 1][j];
            ll ans2 = dp[i][j - 1] + pref_col[i][j - 1];
            dp[i][j] = min(ans1, ans2);
        }
    }
    cout << dp[n][m] << '\n';
}