#include <bits/stdc++.h>

#include <random>

using namespace std;
#define ll long long
vector<vector<ll> > s;

vector<vector<ll> > tree;
vector<ll> qw;

void build(ll v,ll vl,ll vr) {
    if (vr - vl == 1) {
        tree[v].push_back(qw[vl]);
        return;
    }
    ll mid = (vr + vl) / 2;
    build(v * 2, vl, mid);
    build(v * 2 + 1, mid, vr);
    tree[v].resize(tree[v * 2].size() + tree[v * 2 + 1].size());
    merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), tree[v].begin());
}

ll sum(ll v,ll vl,ll vr,ll l,ll r,ll x) {
    if (l >= vr || vl >= r) {
        return 0;
    }
    if (l <= vl && r >= vr) {
        return upper_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin();
    }
    ll mid = (vr + vl) / 2;
    return sum(v * 2, vl, mid, l, r, x) + sum(v * 2 + 1, mid, vr, l, r, x);
}


ll col_inv(vector<ll> &z) {
    qw = z;
    ll n = (ll) z.size();
    tree.assign(4 * n, {});
    build(1, 0, n);
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        ans += sum(1, 0, n, i + 1, n, qw[i]);
    }
    return ans;
}


ll mn = 1e18;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll r, c;
    cin >> r >> c;
    s.resize(r, vector<ll>(c));
    for (ll i = 0; i < r; i++) {
        for (ll j = 0; j < c; j++) {
            cin >> s[i][j];
        }
    }
    vector<ll> pr;
    for (ll i = 0; i < r; i++) {
        pr.push_back(0);
    }
    for (ll i = 0; i < c; i++) {
        pr.push_back(1);
    }
    for (ll mask = 0; mask < 1000; mask++) {
        ll v1 = 0;
        ll v2 = 0;
        vector<ll> z;
        for (ll i = 0; i < pr.size(); i++) {
            if (pr[i] != 0) {
                for (ll j = v2; j < c; j++) {
                    z.push_back(s[v1][j]);
                }
                v1++;
                if (v1 == r) {
                    break;
                }
            } else {
                for (ll j = v1; j < r; j++) {
                    z.push_back(s[j][v2]);
                }
                v2++;
                if (v2 == c) {
                    break;
                }
            }
        }
        mn = min(mn, col_inv(z));
        shuffle(pr.begin(), pr.end(), std::mt19937(std::random_device()()));
    }
    cout << mn;
}