#include<bits/stdc++.h>
using namespace std;
using ll = long long;

struct Point {
    ll x, y;

    Point() {
    }

    Point(int x1, int y1) {
        x = x1, y = y1;
    }
};

struct Vector {
    ll x, y;

    Vector() {
    }

    Vector(Point a, Point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    ll len() {
        return x * x + y * y;
    }
};

const int N = 1e5 + 1;

struct Fast {
    vector<int> g[N];
    int col[N] = {0};
    bool used[N] = {0};
    bool ok = 0;
    vector<int> t, ans;

    void dfs(int v, int c) {
        used[v] = 1;
        t.push_back(v);
        col[v] = c;
        for (auto u: g[v]) {
            if (used[u] && col[u] == col[v])
                ok = 1;
            if (!used[u])
                dfs(u, 3 - c);
        }
    }


    void solve() {
        ll n, r;
        cin >> n >> r;
        vector<Point> p(n);
        for (auto &[x, y]: p) cin >> x >> y;
        map<pair<int, int>, vector<int> > mp;
        for (int i = 0; i < n; i++) {
            int x = p[i].x / r;
            int y = p[i].y / r;
            mp[{x, y}].push_back(i);
        }
        g.resize(n);
        col.resize(n);
        used.resize(n);
        for (int i = 0; i < n; i++) {
            int x = p[i].x / r;
            int y = p[i].y / r;
            vector<int> inds;
            for (int dx = -1; dx <= 1; dx++) {
                for (int dy = -1; dy <= 1; dy++) {
                    if (mp.contains({x + dx, y + dy}))
                        for (auto j: mp[{x + dx, y + dy}]) {
                            if (i != j && Vector(p[i], p[j]).len() <= r * r) {
                                g[i].push_back(j);
                            }
                        }
                }
            }
        }
        ans.resize(n);
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                t.clear();
                ok = 0;
                dfs(i, 1);
                for (auto x: t)
                    ans[x] = ok;
            }
        }
        for (auto i: ans) cout << i;
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    // cin >> __;
    while (__--) {
        auto s1 = Fast();
        s1.solve();
        cout << '\n';
    }
}
