#include<bits/stdc++.h>
using namespace std;
using ll = long long;

struct Point {
    ll x, y;

    Point() {
    }

    Point(int x1, int y1) {
        x = x1, y = y1;
    }
};

struct Vector {
    ll x, y;

    Vector() {
    }

    Vector(Point a, Point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    ll len() {
        return x * x + y * y;
    }
};

const int N = 1e5 + 1;

struct Fast {
    vector<int> pr, sz, col, good;

    pair<int, int> find(int x, int xr) {
        xr ^= col[x];
        if (x == pr[x]) return {x, xr};
        return find(pr[x], xr);
    }

    void add(int u, int v) {
        auto [u1, cu] = find(u, 0);
        auto [v1,cv] = find(v, 0);
        v = v1;
        u = u1;
        if (u == v) {
            if (cu == cv)
                good[v] = 1;
            return;
        }
        if (sz[u] > sz[v]) {
            swap(u, v);
            swap(cu, cv);
        }
        pr[u] = v;
        sz[v] += sz[u];
        if (cu == cv) col[u] ^= 1;
        good[v] = max(good[u], good[v]);
    }

    void solve() {
        ll n, r;
        cin >> n >> r;
        vector<Point> p(n);
        for (auto &[x, y]: p) cin >> x >> y;
        map<pair<int, int>, vector<int> > mp;
        for (int i = 0; i < n; i++) {
            int x = p[i].x / r;
            int y = p[i].y / r;
            mp[{x, y}].push_back(i);
        }
        pr.resize(n);
        sz.resize(n, 1);
        col.resize(n);
        good.resize(n);
        iota(pr.begin(), pr.end(), 0);
        for (int i = 0; i < n; i++) {
            int x = p[i].x / r;
            int y = p[i].y / r;
            for (int dx = -1; dx <= 1; dx++) {
                for (int dy = -1; dy <= 1; dy++) {
                    if (mp.contains({x + dx, y + dy}))
                        for (auto j: mp[{x + dx, y + dy}]) {
                            if (i != j && Vector(p[i], p[j]).len() <= r * r) {
                                add(i, j);
                            }
                        }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            cout << good[find(i, 0).first];
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    // cin >> __;
    while (__--) {
        auto s1 = Fast();
        s1.solve();
        cout << '\n';
    }
}