#include <bits/stdc++.h>
#define int long long

using namespace std;

struct dot{
    int x, y;
    int ind;

    bool operator<(dot d) const{
        if(x == d.x) return y < d.y;
        return x < d.x;
    }

    dot operator-(dot d){ return {x - d.x, y - d.y}; }
    dot operator+(dot d){ return {x + d.x, y + d.y}; }

    __int128 len2(){ return __int128(x)*x + __int128(y)*y; }
};

vector<dot> step;

signed main(){
ios_base::sync_with_stdio(0);
cin.tie(0);
    for(int dx= -2; dx <= 2; dx++)
        for(int dy= -2; dy <= 2; dy++)
            step.push_back({dx, dy});

    int n, r; cin >> n >> r;

    vector<vector<int>> g(n);
    map<pair<int, int>, int> used;

    vector<int> ans(n, 0);
    vector<dot> hull(n);

    for(auto &d: hull) cin >> d.x >> d.y;
    for(int i= 0; i < n; i++){
        hull[i].ind= i;
        hull[i].x+= 5e8;
        hull[i].y+= 5e8;
    }

    map<dot, vector<dot>> table;
    for(auto d: hull){
        table[{d.x / (r/2), d.y / (r/2)}].push_back(d);

        if(d.x % (r/2) == 0) table[{d.x / (r/2) - 1, d.y / (r/2)}].push_back(d);
        if(d.y % (r/2) == 0) table[{d.x / (r/2), d.y / (r/2) - 1}].push_back(d);
        if(d.y % (r/2) == 0 && d.x % (r/2) == 0) table[{d.x / (r/2) - 1, d.y / (r/2) - 1}].push_back(d);
    }

    for(auto [h, v]: table){
        if(v.size() >= 3){
            for(auto d: v) ans[d.ind]= 1;
        } else{
            for(auto d: v){
                for(auto s: step){
                    for(auto d_next: table[{h.x + s.x, h.y + s.y}]){
                        if(used[{d.ind, d_next.ind}]++ != 0) continue;
                        if(used[{d_next.ind, d.ind}]++ != 0) continue;

                        if((d - d_next).len2() <= __int128(r)*r ){
                            g[d.ind].push_back(d_next.ind);
                            g[d_next.ind].push_back(d.ind);
                        }
                    }
                }
            }
        }
    }

    vector<int> mark(n, 0);
    function<void(int)> make_1= [&](int u){
        ans[u]= 1;
        mark[u]= 3;

        for(auto v: g[u]){
            if(mark[v] == 3) continue;
            make_1(v);
        }
    };

    function<bool(int)> check= [&](int u){
        bool flag= 1;
        for(auto v: g[u]){
            if(mark[v]){
                if(ans[v] == 1 || mark[v] == mark[u]) flag= 0;
                continue;
            }

            mark[v]= 3 - mark[u];
            flag&= check(v);
        }

        return flag;
    };

    for(int u= 0; u < n; u++){
        if(!mark[u]){
            mark[u]= 1;
            if(!check(u)) make_1(u);
        }
    }

    for(int i= 0; i < n; i++)
        cout << ans[i];
}
