#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;
typedef long long ll;

struct point {
    ll x, y;
    point() {}
    point(ll x, ll y) : x(x), y(y) {}
};

ll r;
vector<ll> can;
vector<point> points;

ll dist(const point& a, const point& b) { return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y); }

void dfs(ll v, ll color, unordered_map<ll, ll> visited) {
    if (visited[v] && color == 1) can[v] = 1;
    if (visited[v]) return;
    visited[v] = 1;
    for (int i=0; i<points.size(); ++i) {
        if (i == v) continue;
        if (dist(points[v], points[i]) > r * r) continue;
        dfs(i, (color + 1) % 2, visited);
    }
}

int main() {
    ll n;
    cin >> n >> r;
    points.reserve(n);
    can.resize(n);

    for (int i=0; i<n; ++i) {
        ll x, y;
        cin >> x >> y;
        points.push_back(point(x, y));
    }

    unordered_map<ll, ll> a;
    for (int i=0; i<n; ++i)
        dfs(i, 0, a);

    for (int i=0; i<n; ++i)
        cout << can[i] << ' ';

    return 0;
}