#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;
typedef long long ll;

struct point {
    ll x, y;
    point() {}
    point(ll x, ll y) : x(x), y(y) {}
};

ll r;
vector<ll> can;
vector<point> points;
vector<ll> used, depth;
vector<vector<ll>> gr;

ll dist(const point& a, const point& b) { return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y); }

void dfs(ll v, ll goal, ll d, ll color) {
    used[v] = goal;
    depth[v] = d;

    for (int u : gr[v]) {
        ll di = dist(points[v], points[u]);
        if (di <= r * r && used[u] == goal && (depth[u] + color) % 2 == 0) {
            can[goal] = 1;
            return;
        }
        if (di > r * r || used[u] == goal) continue;
        dfs(u, goal, d+1, (color+1)%2);
    }
}

int main() {
    ll n;
    cin >> n >> r;
    points.reserve(n);
    can.resize(n);
    used.resize(n);
    depth.resize(n);
    gr.resize(n, vector<ll>());

    for (int i=0; i<n; ++i) {
        ll x, y;
        cin >> x >> y;
        points.push_back(point(x, y));
    }

    for (int i=0; i<n; ++i) {
        for (int j=i+1; j<n; ++j) {
            if (dist(points[i], points[j]) > r * r) continue;
            gr[i].push_back(j);
            gr[j].push_back(i);
        }
    }

    for (int i=0; i<n; ++i) {
        dfs(i, i, 0, 0);
    }

    for (int i=0; i<n; ++i)
        cout << can[i];

    return 0;
}