#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> p;

const ll maxn = 1e5 + 5;

ll r;
ll can[maxn], used[maxn], depth[maxn];
pair<ll, ll> points[maxn];
vector<ll> gr[maxn];

ll dist(const p& a, const p& b) { return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second); }

void dfs(ll v, ll goal, ll d, ll color) {
    used[v] = goal + 1;
    depth[v] = d;

    for (int u : gr[v]) {
        ll di = dist(points[v], points[u]);
        if (di <= r * r && used[u] == goal + 1 && (depth[u] + color) % 2 == 0) {
            can[goal] = 1;
            return;
        }
        if (di > r * r || used[u] == goal + 1) continue;
        dfs(u, goal, d+1, (color+1)%2);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n >> r;

    for (int i=0; i<n; ++i) {
        ll x, y;
        cin >> x >> y;
        points[i] = {x, y};
    }

    for (int i=0; i<n; ++i) {
        for (int j=i+1; j<n; ++j) {
            if (dist(points[i], points[j]) > r * r) continue;
            gr[i].push_back(j);
            gr[j].push_back(i);
        }
    }

    for (int i=0; i<n; ++i)
        dfs(i, i, 0, 0);

    for (int i=0; i<n; ++i)
        cout << can[i];

    return 0;
}