#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> merge(vector<ll> &a, vector<ll> &b) {
    vector<ll> res(a.size() + b.size());
    merge(a.begin(), a.end(), b.begin(), b.end(), res.begin());
    return res;
}

struct SegmentTree {
    vector<vector<ll> > tree;
    vector<ll> arr;
    ll n;

    SegmentTree(vector<ll> &a) : arr(a) {
        n = a.size();
        tree.assign(4 * n, {});
        build(0, 0, n);
    }

    void build(ll v, ll l, ll r) {
        if (l == r - 1) {
            tree[v] = {arr[l]};
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr, ll x) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return lower_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin();
        }
        ll m = (l + r) / 2;
        ll aa1 = get(2 * v + 1, l, m, ql, qr, x);
        ll aa2 = get(2 * v + 2, m, r, ql, qr, x);
        return aa1 + aa2;
    }

    ll get(ll ql, ll qr, ll x) {
        return get(0, 0, n, ql, qr, x);
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, m;
    cin >> n >> m;
    vector<ll> a(m);
    for (ll i = 0; i < m; i++) {
        cin >> a[i];
    }
    SegmentTree tree(a);
    ll ans = 0;
    for (ll i = 0; i < m; i++) {
        ans += tree.get(i, m, a[i]);
    }
    cout << ans;
}
