#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

pair<vector<ll>, ll> merge_sort(const vector<ll> &a) {
    if (a.size() == 1) {
        return {a, 0};
    }
    ll n = static_cast<ll>(a.size());
    vector<ll> a1, a2;
    for (ll i = 0; i < n; i++) {
        if (i >= n / 2) {
            a2.push_back(a[i]);
        } else {
            a1.push_back(a[i]);
        }
    }
    auto res1 = merge_sort(a1);
    auto res2 = merge_sort(a2);
    ll ans = res1.second + res2.second;
    a1 = res1.first;
    a2 = res2.first;
    ll i = 0, j = 0;
    vector<ll> res;
    while (i < a1.size() && j < a2.size()) {
        if (a1[i] < a2[j]) {
            res.push_back(a1[i]);
            ans += j;
            i++;
        } else {
            res.push_back(a2[j]);
            j++;
        }
    }
    while (i < a1.size()) {
        res.push_back(a1[i]);
        ans += j;
        i++;
    }
    while (j < a2.size()) {
        res.push_back(a2[j]);
        j++;
    }
    return {res, ans};
}

vector<ll> merge(vector<ll> &a, vector<ll> &b) {
    vector<ll> res(a.size() + b.size());
    merge(a.begin(), a.end(), b.begin(), b.end(), res.begin());
    return res;
}

struct SegmentTree {
    vector<vector<ll> > tree;
    vector<ll> arr;
    ll n;

    SegmentTree() = default;

    SegmentTree(vector<ll> &a) : arr(a) {
        n = a.size();
        tree.assign(4 * n, {});
        build(0, 0, n);
    }

    void build(ll v, ll l, ll r) {
        if (l == r - 1) {
            tree[v] = {arr[l]};
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr, ll x) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return lower_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin();
        }
        ll m = (l + r) / 2;
        ll aa1 = get(2 * v + 1, l, m, ql, qr, x);
        ll aa2 = get(2 * v + 2, m, r, ql, qr, x);
        return aa1 + aa2;
    }

    ll get(ll ql, ll qr, ll x) {
        return get(0, 0, n, ql, qr, x);
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, m;
    cin >> n >> m;
    vector<vector<ll> > a(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<SegmentTree> rows(n);
    for (ll i = 0; i < n; i++) {
        rows[i] = SegmentTree(a[i]);
    }
    vector<SegmentTree> columns(m);
    for (ll j = 0; j < m; j++) {
        vector<ll> gg;
        for (ll i = 0; i < n; i++) {
            gg.push_back(a[i][j]);
        }
        columns[j] = SegmentTree(gg);
    }
    vector<vector<ll> > dp(n, vector<ll>(m,INT64_MAX));
    dp[n - 1][m - 1] = 0;
    for (ll i = n - 2; i >= 0; i--) {
        dp[i][m - 1] = dp[i + 1][m - 1] + columns[m - 1].get(i, n, a[i][m - 1]);
    }
    for (ll j = m - 2; j >= 0; j--) {
        dp[n - 1][j] = dp[n - 1][j + 1] + rows[n - 1].get(j, m, a[n - 1][j]);
    }
    for (ll i = n - 2; i >= 0; i--) {
        for (ll j = m - 2; j >= 0; j--) {
            {
                vector<ll> rr;
                for (ll y = j; y < m; y++) {
                    rr.push_back(a[i][y]);
                }
                vector<ll> gg;
                for (ll x = i + 1; x < n; x++) {
                    for (ll y = j; y < m; y++) {
                        gg.push_back(a[x][y]);
                    }
                }
                ll suk = merge_sort(rr).second;
                sort(rr.begin(), rr.end());
                sort(gg.begin(), gg.end());
                vector<ll> aaa;
                for (auto &i: rr) {
                    aaa.push_back(i);
                }
                for (auto &i: gg) {
                    aaa.push_back(i);
                }
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + merge_sort(aaa).second + suk);
            } {
                vector<ll> rr;
                for (ll x = i; x < n; x++) {
                    rr.push_back(a[x][j]);
                }
                vector<ll> gg;
                for (ll x = i; x < n; x++) {
                    for (ll y = j + 1; y < m; y++) {
                        gg.push_back(a[x][y]);
                    }
                }
                ll suk = merge_sort(rr).second;
                sort(rr.begin(), rr.end());
                sort(gg.begin(), gg.end());
                vector<ll> aaa;
                for (auto &i: rr) {
                    aaa.push_back(i);
                }
                for (auto &i: gg) {
                    aaa.push_back(i);
                }
                dp[i][j] = min(dp[i][j], dp[i + 1][j] + merge_sort(aaa).second + suk);
            }
        }
    }
    cout << dp[0][0];
}
