#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct SparseTable {
    vector<vector<ll> > mn;
    vector<ll> lg;
    ll n;

    explicit SparseTable(const vector<ll> &a) {
        n = static_cast<ll>(a.size());
        ll k = 0;
        while ((1 << k) <= n) {
            k++;
        }
        mn.assign(k, vector<ll>(n));
        for (ll i = 0; i < n; i++) {
            mn[0][i] = a[i];
        }
        for (ll i = 1; i < k; i++) {
            for (ll j = 0; j + (1 << i) <= n; j++) {
                mn[i][j] = min(mn[i - 1][j], mn[i - 1][j + (1 << (i - 1))]);
            }
        }
        lg.assign(n + 1, 0);
        for (ll i = 2; i <= n; i++) {
            lg[i] = lg[i / 2] + 1;
        }
    }

    ll get(const ll l, const ll r) const {
        ll x = lg[r - l];
        return min(mn[x][l], mn[x][r - (1 << x)]);
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<pair<ll, ll> > queries(q);
    vector<ll> k;
    for (ll i = 0; i < q; i++) {
        cin >> queries[i].first >> queries[i].second;
        queries[i].second--;
        k.push_back(queries[i].first);
    }
    sort(k.begin(), k.end());
    k.resize(unique(k.begin(), k.end()) - k.begin());

    vector<ll> pos(n, 0);
    for (ll i = 0; i < n; i++) {
        pos[a[i]] = i;
    }

    vector<ll> nxt(n, n);
    vector<pair<ll, ll> > stt;
    for (ll i = n - 1; i >= 0; i--) {
        while (!stt.empty() && stt.back().first < a[i]) {
            stt.pop_back();
        }
        if (!stt.empty()) {
            nxt[i] = stt.back().second;
        }
        stt.emplace_back(a[i], i);
    }

    vector<ll> suf(n + 1, 0);
    for (ll i = n - 1; i >= 0; i--) {
        suf[i] = max(suf[i + 1], a[i]);
    }

    vector<vector<ll> > ans(k.size());
    const SparseTable st(a);
    for (ll i = 0; i < k.size(); i++) {
        ans[i].assign(k[i], 0);
        ll s = 0;
        for (ll j = 0; j < k[i] - 1; j++) {
            ans[i][j] = a[s];
            const ll mn = st.get(s + 1, min(n - (k[i] - j - 2), nxt[s] + 1));
            s = pos[mn];
        }
        ans[i][k[i] - 1] = suf[s];
    }

    vector<ll> gg(n + 1);
    for (ll i = 0; i < k.size(); i++) {
        gg[k[i]] = i;
    }
    for (auto &i: queries) {
        cout << ans[gg[i.first]][i.second] + 1 << '\n';
    }
}
