#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct SparseTable {
    vector<vector<ll> > mx;
    vector<ll> lg;
    ll n;

    explicit SparseTable(const vector<ll> &a) {
        n = static_cast<ll>(a.size());
        ll k = 0;
        while ((1 << k) <= n) {
            k++;
        }
        mx.assign(k, vector<ll>(n));
        for (ll i = 0; i < n; i++) {
            mx[0][i] = a[i];
        }
        for (ll i = 1; i < k; i++) {
            for (ll j = 0; j + (1 << i) <= n; j++) {
                mx[i][j] = max(mx[i - 1][j], mx[i - 1][j + (1 << (i - 1))]);
            }
        }
        lg.assign(n + 1, 0);
        for (ll i = 2; i <= n; i++) {
            lg[i] = lg[i / 2] + 1;
        }
    }

    ll get(const ll l, const ll r) const {
        ll x = lg[r - l];
        return max(mx[x][l], mx[x][r - (1 << x)]);
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    vector<ll> suf(n + 1, 0);
    for (ll i = n - 1; i >= 0; i--) {
        suf[i] = max(suf[i + 1], a[i]);
    }

    while (q--) {
        ll k, i;
        cin >> k >> i;
        i--;
        if (i < k - 1) {
            cout << a[i] + 1 << '\n';
            continue;
        }
        if (k % 2 == 0) {
            cout << suf[i] + 1 << '\n';
        } else {
            cout << a[n - 1] + 1 << '\n';
        }
    }
}
