#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct SparseTable {
    vector<vector<ll> > mn;
    vector<ll> lg;
    ll n;

    explicit SparseTable(const vector<ll> &a) {
        n = static_cast<ll>(a.size());
        ll k = 0;
        while ((1 << k) <= n) {
            k++;
        }
        mn.assign(k, vector<ll>(n));
        for (ll i = 0; i < n; i++) {
            mn[0][i] = a[i];
        }
        for (ll i = 1; i < k; i++) {
            for (ll j = 0; j + (1 << i) <= n; j++) {
                mn[i][j] = min(mn[i - 1][j], mn[i - 1][j + (1 << (i - 1))]);
            }
        }
        lg.assign(n + 1, 0);
        for (ll i = 2; i <= n; i++) {
            lg[i] = lg[i / 2] + 1;
        }
    }

    ll get(const ll l, const ll r) const {
        ll x = lg[r - l];
        return min(mn[x][l], mn[x][r - (1 << x)]);
    }
};

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r",stdin);
    freopen("output.txt", "w",stdout);
#endif
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<pair<ll, ll> > queries(q);
    vector<ll> k;
    for (ll i = 0; i < q; i++) {
        cin >> queries[i].first >> queries[i].second;
        queries[i].second--;
        k.push_back(queries[i].first);
    }
    sort(k.begin(), k.end());
    k.resize(unique(k.begin(), k.end()) - k.begin());

    vector<ll> pos(n, 0);
    for (ll i = 0; i < n; i++) {
        pos[a[i]] = i;
    }

    vector<vector<ll> > aye;
    aye.push_back({a[0]});
    for (ll i = 1; i < n; i++) {
        if (a[i - 1] > a[i]) {
            aye.emplace_back();
        }
        aye.back().push_back(a[i]);
    }
    vector<ll> group(n);
    for (auto &i: aye) {
        for (auto &j: i) {
            group[pos[j]] = pos[i.back()];
        }
    }

    vector<ll> nxt(n, n);
    vector<pair<ll, ll> > stt;
    for (ll i = n - 1; i >= 0; i--) {
        while (!stt.empty() && stt.back().first < a[i]) {
            stt.pop_back();
        }
        if (!stt.empty()) {
            nxt[i] = stt.back().second;
        }
        stt.emplace_back(a[i], i);
    }

    vector<ll> suf(n + 1, n - 1);
    for (ll i = n - 1; i >= 0; i--) {
        if (a[i] > a[suf[i + 1]]) {
            suf[i] = i;
        } else {
            suf[i] = suf[i + 1];
        }
    }

    vector<vector<pair<ll, ll> > > ans(k.size());
    const SparseTable st(a);
    for (ll i = 0; i < k.size(); i++) {
        ll s = 0;
        ll j = 0;
        while (j < k[i] - 1) {
            ans[i].emplace_back(j, s);
            if (j == k[i] - 2) {
                if (nxt[s] == n) {
                    s = n - 1;
                } else {
                    s = nxt[s];
                }
                j++;
                continue;
            }
            if (group[s] < s) {
                const ll s1 = min(group[s], s + k[i] - 2 - j);
                j += s1 - s;
                s = s1;
                continue;
            }
            const ll mn = st.get(s + 1, min(n - (k[i] - j - 2), nxt[s] + 1));
            s = pos[mn];
            j++;
        }
        ans[i].emplace_back(k[i] - 1, suf[s]);
    }

    vector<ll> gg(n + 1);
    for (ll i = 0; i < k.size(); i++) {
        gg[k[i]] = i;
    }
    vector<vector<ll> > vv(k.size());
    for (ll i = 0; i < k.size(); i++) {
        for (auto &j: ans[i]) {
            vv[i].push_back(j.first);
        }
    }
    for (auto &i: queries) {
        const ll kk = gg[i.first];
        ll ii = i.second;
        const ll ind = upper_bound(vv[kk].begin(), vv[kk].end(), ii) - vv[kk].begin() - 1;
        cout << a[ans[kk][ind].second + ii - ans[kk][ind].first] + 1 << '\n';
    }
}
