#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
using namespace std;
using ll = long long;
struct point {
	ll x, y, ind;
	point() :x(0), y(0), ind(-1) {}
	point(int x, int y) :x(x), y(y),ind(-1) {}
	point(int x, int y,int i) :x(x), y(y), ind(i) {}

};
point operator+(point a, point b) {
	return point(a.x + b.x, a.y + b.y);
}
point operator-(point a, point b) {
	return point(a.x - b.x, a.y - b.y);
}
ll operator*(point a, point b) {
	return a.x * b.x + a.y + b.y;
}
ll operator%(point a, point b) {
	return a.x * b.y - b.x * a.y;
}
ll dst(point a, point b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
bool cmp_dt(point a, point b) {
	return a.y < b.y or a.y == b.y && a.ind < b.ind;
}

vector<vector<int>>g;
vector<int>used, cl;
bool dfs(int v,int tm, int col) {
	used[v] = tm;
	cl[v] = col;
	bool ans = false;
	for (auto u : g[v]) {
		ans |= (col == cl[u]);
		if (used[u]>=0)continue;
		ans|=dfs(u, tm, col ^ 1);
	}
	return ans;
}
int main()
{
	cin.tie(0)->sync_with_stdio(0);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ll n, r; cin >> n >> r;
	g.resize(n);

	vector<point>dots(n);
	vector<ll>xs;

	for (int i = 0; i < n; ++i) {
		int x, y; cin >> x >> y;
		dots[i] = point(x, y, i);
		xs.push_back(x);
	}
	sort(xs.begin(), xs.end());
	xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
	vector<vector<point>>dt(xs.size());
	for (auto c : dots) {
		dt[lower_bound(xs.begin(), xs.end(), c.x) - xs.begin()].push_back(c);
	}
	for (int i = 0; i < xs.size(); ++i) {
		sort(dt[i].begin(), dt[i].end(),cmp_dt);
	}

	/*for (auto c : dt) {
		for (auto z : c)cout << z.x << "_" << z.y << "_"<<z.ind<<" "; 
		cout << "\n";
	}*/


	for (int xs_i = 0; xs_i < xs.size(); ++xs_i) {
		for(auto cur_dot:dt[xs_i]){
			for (int xs_i2 = xs_i; xs_i2 >= 0; --xs_i2) {
				if (abs(cur_dot.x - xs[xs_i2]) > r)break;
				for (auto n_dot : dt[xs_i2]) {
					if (n_dot.ind == cur_dot.ind)continue;
					if (dst(cur_dot, n_dot) <= (ll)r * r) {
						g[cur_dot.ind].push_back(n_dot.ind);
					}
				}
			}
			for (int xs_i2 = xs_i+1; xs_i2 < xs.size(); ++xs_i2) {
				if (abs(cur_dot.x - xs[xs_i2]) > r)break;
				for (auto n_dot : dt[xs_i2]) {
					if (n_dot.ind == cur_dot.ind)continue;
					if (dst(cur_dot, n_dot) <= (ll)r * r) {
						g[cur_dot.ind].push_back(n_dot.ind);
					}
				}
			}
		}
	}
	/*for (int i = 0; i < n; ++i) {
		cout << i << ": ";
		for (auto c : g[i])cout << c << " "; cout << "\n";
	}*/
	used.resize(n, -1);
	cl.resize(n, -1);
	vector<int>tm_sts;
	for (int v = 0; v < n; ++v) {
		if (used[v] >= 0)continue;
		if (dfs(v, tm_sts.size(),1))tm_sts.push_back(1);
		else tm_sts.push_back(0);
	}
	for (int v = 0; v < n; ++v) {
		cout << tm_sts[used[v]];
	}
	cout << "\n";
}

