#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second

const int MOD = 1e9 + 7;
const ll INF = 1e18 + 7;
const int N = 3e5 + 10;
const int MAXN = 2e7;

struct Node {
    ll val;
    int L, R;

    Node(ll x = 0) {
        val = x, L = R = -1;
    }
};

int n, m, sz;
vector<vector<int>> a, roots;
vector<vector<ll>> dp;

int tmr = 1;
Node pts[MAXN];

ll val(int r) { if (r == -1) return 0; return pts[r].val; }

int newNode(ll val = 0) {
    pts[tmr] = Node(val);
    return tmr++;
}

int copied(int tind) {
    if (tind == -1) return newNode();
    pts[tmr] = pts[tind];
    return tmr++;
}

void pull(int tind) {
    pts[tind].val = val(pts[tind].L) + val(pts[tind].R);
}

int upd(int tind, int l, int r, int qind, int x) {
    if (tind == -1) tind = newNode();
    if (r - l == 1) return newNode(pts[tind].val + x);
    int m = (r + l) >> 1;
    int ans = copied(tind);
    if (qind < m) {
        if (pts[ans].L == -1) pts[ans].L = newNode();
        pts[ans].L = upd(pts[ans].L, l, m, qind, x);
    }
    else {
        if (pts[ans].R == -1) pts[ans].R = newNode();
        pts[ans].R = upd(pts[ans].R, m, r, qind, x);
    }
    pull(ans);
    return ans;
}

ll get(int tind, int l, int r, int ql, int qr) {
    if (tind == -1) return 0;
    if (ql <= l && r <= qr) return pts[tind].val;
    if (ql >= r || l >= qr) return 0;
    int m = (r + l) >> 1;
    return get(pts[tind].L, l, m, ql, qr) + get(pts[tind].R, m, r, ql, qr);
}

void solve() {
    int n, m; cin >> n >> m;
    sz = n * m + 1;
    a.resize(n + 1, vector<int> (m + 1));
    dp.resize(n + 2, vector<ll> (m + 2, INF));
    roots.resize(n + 2, vector<int> (m + 2, -1));
    for(int i = 1; i <= n; ++i) for (int j = 1; j <= m; ++j) cin >> a[i][j];

    for (int j = 2; j <= m; ++j) {
        roots[0][j] = roots[0][j - 1];
        for (int i = 1; i <= n; ++i) roots[0][j] = upd(roots[0][j], 1, sz, a[i][j - 1], 1);
    }
    for (int i = 2; i <= n; ++i) {
        roots[i][0] = roots[i - 1][0];
        for (int j = 1; j <= m; ++j) roots[i][0] = upd(roots[i][0], 1, sz, a[i - 1][j], 1);
    }

    dp[1][1] = 0;
    for (int i = 1; i <= n + 1; ++i) {
        for (int j = 1; j <= m + 1; ++j) {
            roots[i][j] = roots[i - 1][j - 1];
            if (i > 1 && j > 1) roots[i][j] = upd(roots[i][j], 1, sz, a[i - 1][j - 1], 1);
            //dp[i - 1][j]
            if (i - 1 >= 1 && j <= m) {
                ll cur = 0;
                for (int j1 = j; j1 <= m; ++j1) {
                    cur += get(roots[i][j], 1, sz, a[i - 1][j1], sz);
                    roots[i][j] = upd(roots[i][j], 1, sz, a[i - 1][j1], 1);
                }

                dp[i][j] = min(dp[i][j], dp[i - 1][j] + cur);

                for (int j1 = j; j1 <= m; ++j1) roots[i][j] = upd(roots[i][j], 1, sz, a[i - 1][j1], -1);
            }

            //dp[i][j - 1]
            if (j - 1 >= 1 && i <= n) {
                ll cur = 0;
                for (int i1 = i; i1 <= n; ++i1) {
                    cur += get(roots[i][j], 1, sz, a[i1][j - 1], sz);
                    roots[i][j] = upd(roots[i][j], 1, sz, a[i1][j - 1], 1);
                }

                dp[i][j] = min(dp[i][j], dp[i][j - 1] + cur);

                for (int i1 = i; i1 <= n; ++i1) roots[i][j] = upd(roots[i][j], 1, sz, a[i1][j - 1], -1);
            }
            if (i > 1) for (int j1 = j; j1 <= m; ++j1) roots[i][j] = upd(roots[i][j], 1, sz, a[i - 1][j1], 1);
            if (j > 1) for (int i1 = i; i1 <= n; ++i1) roots[i][j] = upd(roots[i][j], 1, sz, a[i1][j - 1], 1);
        }
    }

    ll ans = INF;
    for (int i = 1; i <= n; ++i) ans = min(ans, dp[i][m + 1]);
    for (int j = 1; j <= m; ++j) ans = min(ans, dp[n + 1][j]);
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}