#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;

ll INF = 1e9 + 7;

struct seg_tree {

    vector<pair<ll, ll>> d;
    vector<ll> t;

    pair<ll, ll> build(ll v) {
        if (v * 2 >= d.size()) {
            return d[v];
        }
        return d[v] = min(build(v * 2), build(v * 2 + 1));
    }

    void push(ll v, ll vl, ll vr) {

        if (t[v] == -INF) {
            return;
        }

        d[v].first = t[v];
        if (vr - vl > 1) {
            t[v * 2] = t[v];
            t[v * 2 + 1] = t[v];
        }
        t[v] = -INF;
    }
    
    pair<ll, ll> get(ll v, ll vl, ll vr, ll l, ll r) {

        if (vl >= r || vr <= l) {
            return {INF, INF};
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return min(get(v * 2, vl, vm, l, r), get(v * 2 + 1, vm, vr, l, r));
    }

    pair<ll, ll> get(ll l, ll r) {
        return get(1, 0, d.size() / 2, l, r);
    }

    pair<ll, ll> update(ll v, ll vl, ll vr, ll l, ll r, ll x) {

        if (vl >= r || vr <= l) {
            return d[v];
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            t[v] = x;
            push(v, vl, vr);
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return d[v] = min(update(v * 2, vl, vm, l, r, x), update(v * 2 + 1, vm, vr, l, r, x));
    }

    void update(ll ind, ll x) {
        update(1, 0, d.size() / 2, ind, ind + 1, x);
    }
};
 
void solve() {
 
    ll n, r;
    cin >> n >> r;
    r *= r;

    ll c = 1;
    while (c < n) {
        c *= 2;
    }
    auto st1 = seg_tree();
    st1.d = vector<pair<ll, ll>>(2 * c, {INF, INF});
    st1.t = vector<ll>(2 * c, -INF);

    auto st2 = seg_tree();
    st2.d = vector<pair<ll, ll>>(2 * c, {INF, INF});
    st2.t = vector<ll>(2 * c, -INF);

    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) {
        ll x;
        cin >> a[i].first >> x;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    unordered_map<ll, ll> mp;
    for (int i = 0; i < n; i++) {
        mp[a[i].second] = i;
        st1.d[i + c] = {a[i].first, i};
        st2.d[i + c] = {a[i].first, i};
    }
    st1.build(1);
    st2.build(1);

    queue<pair<ll, ll>> q;
    vector<vector<ll>> d(n, vector<ll>(2, 0));

    for (int cur = 0; cur < n; cur++) {
        if (d[cur][0] == 0 && d[cur][1] == 0) {
            q.push({cur, 0});
            d[cur][0] = 1;
            st1.update(cur, INF);
        }

        while (!q.empty()) {

            ll v = q.front().first;
            ll c = q.front().second;
            q.pop();

            ll lb = 0, rb = 0;
            {
                ll l = v, R = n;
                while (R - l > 1) {
                    ll m = (l + R) / 2;

                    ll dst = (a[m].first - a[v].first) * (a[m].first - a[v].first);

                    if (dst > r) {
                        R = m;
                    } else {
                        l = m;
                    }
                }
                rb = l;
            }
            {
                ll l = -1, R = v;
                while (R - l > 1) {
                    ll m = (l + R) / 2;

                    ll dst = (a[m].first - a[v].first) * (a[m].first - a[v].first);

                    if (dst > r) {
                        l = m;
                    } else {
                        R = m;
                    }
                }
                lb = R;
            }

            pair<ll, ll> p;
            while (c == 1 && (p = st1.get(lb, v)).first != INF ||
                c == 0 && (p = st2.get(lb, v)).first != INF) {
 
                d[p.second][!c] = 1;
                q.emplace(p.second, !c);

                if (c == 1) {
                    st1.update(p.second, INF);
                } else {
                    st2.update(p.second, INF);
                }
            }

            while (c == 1 && (p = st1.get(v + 1, rb + 1)).first != INF ||
                c == 0 && (p = st2.get(v + 1, rb + 1)).first != INF) {

                d[p.second][!c] = 1;
                q.emplace(p.second, !c);

                if (c == 1) {
                    st1.update(p.second, INF);
                } else {
                    st2.update(p.second, INF);
                }
            }
        }
    }
 
    for (int i = 0; i < n; i++) {
        if (d[mp[i]][0] == 1 && d[mp[i]][1] == 1) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}
 
int main() {
 
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
 
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
 
    return 0;
}