#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll INF = 1e9 + 7;

struct seg_tree {

    vector<pair<ll, ll>> d;
    vector<ll> t;

    pair<ll, ll> build(ll v) {
        if (v * 2 >= d.size()) {
            return d[v];
        }
        return d[v] = min(build(v * 2), build(v * 2 + 1));
    }

    void push(ll v, ll vl, ll vr) {

        if (t[v] == -INF) {
            return;
        }

        d[v].first = t[v];
        if (vr - vl > 1) {
            t[v * 2] = t[v];
            t[v * 2 + 1] = t[v];
        }
        t[v] = -INF;
    }

    pair<ll, ll> get(ll v, ll vl, ll vr, ll l, ll r) {

        if (vl >= r || vr <= l) {
            return {INF, INF};
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return min(get(v * 2, vl, vm, l, r), get(v * 2 + 1, vm, vr, l, r));
    }

    pair<ll, ll> get(ll l, ll r) {
        return get(1, 0, d.size() / 2, l, r);
    }

    pair<ll, ll> update(ll v, ll vl, ll vr, ll l, ll r, ll x) {

        if (vl >= r || vr <= l) {
            return d[v];
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            t[v] = x;
            push(v, vl, vr);
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return d[v] = min(update(v * 2, vl, vm, l, r, x), update(v * 2 + 1, vm, vr, l, r, x));
    }

    void update(ll ind, ll x) {
        update(1, 0, d.size() / 2, ind, ind + 1, x);
    }
};

struct seg_tree_mx {

    vector<pair<ll, ll>> d;
    vector<ll> t;

    pair<ll, ll> build(ll v) {
        if (v * 2 >= d.size()) {
            return d[v];
        }
        return d[v] = max(build(v * 2), build(v * 2 + 1));
    }

    void push(ll v, ll vl, ll vr) {

        if (t[v] == -INF) {
            return;
        }

        d[v].first = t[v];
        if (vr - vl > 1) {
            t[v * 2] = t[v];
            t[v * 2 + 1] = t[v];
        }
        t[v] = -INF;
    }

    pair<ll, ll> get(ll v, ll vl, ll vr, ll l, ll r) {

        if (vl >= r || vr <= l) {
            return {-INF, -INF};
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return max(get(v * 2, vl, vm, l, r), get(v * 2 + 1, vm, vr, l, r));
    }

    pair<ll, ll> get(ll l, ll r) {
        return get(1, 0, d.size() / 2, l, r);
    }

    pair<ll, ll> update(ll v, ll vl, ll vr, ll l, ll r, ll x) {

        if (vl >= r || vr <= l) {
            return d[v];
        }

        push(v, vl, vr);
        if (vl >= l && vr <= r) {
            t[v] = x;
            push(v, vl, vr);
            return d[v];
        }

        ll vm = (vl + vr) / 2;
        return d[v] = max(update(v * 2, vl, vm, l, r, x), update(v * 2 + 1, vm, vr, l, r, x));
    }

    void update(ll ind, ll x) {
        update(1, 0, d.size() / 2, ind, ind + 1, x);
    }
};

void solve() {

    ll n, q;
    cin >> n >> q;
    unordered_map<ll, vector<ll>> mp;

    ll c = 1;
    while (c <= n) {
        c *= 2;
    }
    auto s = seg_tree_mx();
    s.d = vector<pair<ll, ll>>(2 * c, {-INF, -INF});
    s.t = vector<ll> (2 * c, -INF);

    auto smn = seg_tree();
    smn.d = vector<pair<ll, ll>>(2 * c, {INF, INF});
    smn.t = vector<ll> (2 * c, -INF);

    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s.d[i + c] = {a[i], i};
        smn.d[i + c] = {a[i], i};
    }
    s.build(1);
    smn.build(1);

    while (q--) {
        ll k, g, p = 0;
        cin >> k >> g;

        if (mp[k].empty()) {
            ll cnt = n - k;
            vector<ll> ans(k);

            for (int i = 0; i < k - 1; i++) {

                ll l = p, r = min(n, p + cnt + 1);
                while (r - l > 1) {
                    ll m = (l + r) / 2;

                    if (s.get(p, m + 1).first <= a[p]) {
                        l = m;
                    } else {
                        r = m;
                    }
                }

                ll ind = smn.get(p + 1, min(n, l + 2)).second - 1;
                cnt -= ind - p;
                ans[i] = a[p];
                p = ind + 1;
            }
            ans[k - 1] = s.get(p, n).first;
            mp[k] = ans;
        }
        cout << mp[k][g - 1] << "\n";
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}