#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll

int inf = 1e15;

struct segtree {
    int n;
    vector<int> st;
    vector<int> mx;

    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            st[v] = a[l];
            mx[v] = a[l];
            return;
        }
        build(v * 2 + 1, l, (l + r) / 2, a);
        build(v * 2 + 2, (l + r) / 2, r, a);
        st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
        mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
    }

    segtree(vector<int> &a) {
        n = a.size();
        st.resize(n * 4);
        mx.resize(n * 4);
        build(0, 0, n, a);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql)
            return inf;
        if (l >= ql && r <= qr)
            return st[v];
        return min(
            get(v * 2 + 1, l, (l + r) / 2, ql, qr),
            get(v * 2 + 2, (l + r) / 2, r, ql, qr));
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    int gm(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql)
            return 0;
        if (l >= ql && r <= qr)
            return mx[v];
        return max(
            gm(v * 2 + 1, l, (l + r) / 2, ql, qr),
            gm(v * 2 + 2, (l + r) / 2, r, ql, qr));
    }

    int gm(int l, int r) {
        return gm(0, 0, n, l, r);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n + 2);
    vector<int> pos(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    segtree st = a;
    map<int, map<int, int> > ans;
    vector<int> rb(n + 1);
    vector<int> tmp;
    for (int i = n; i >= 1; i--) {
        while (!tmp.empty() && a[tmp.back()] < a[i])
            tmp.pop_back();
        if (!tmp.empty())
            rb[i] = tmp.back();
        else
            rb[i] = n;
        tmp.push_back(i);
    }
    vector<pair<int, int> > qr;
    vector<int> tk;
    for (int z = 0, k, i; z < q; z++) {
        cin >> k >> i;
        qr.emplace_back(k, i);
        tk.emplace_back(k);
    }
    sort(tk.begin(), tk.end());
    tk.resize(unique(tk.begin(), tk.end()) - tk.begin());
    // for (auto k : tk) {
    //     int nxt = a[1];
    //     for (int z = 1; z <= k; z++) {
    //         if (z == k) {
    //             ans[k][z] = st.gm(pos[nxt], n + 1);
    //             continue;
    //         }
    //         ans[k][z] = nxt;
    //         int r = min(n + 1 - (k - z - 1), rb[pos[nxt]] + 1);
    //         nxt = st.get(pos[nxt] + 1, r);
    //     }
    // }
    for (auto [k, i]: qr) {
        if (i == k) {
            cout << st.gm(i, n + 1) << "\n";
        }
        else {
            cout << a[i] << "\n";
        }
        // cout << ans[k][i] << "\n";
    }
}


/*
for (int k = 1; k <= n; k++) {
        int z = 1;
        int ls = a[1];
        for (int i = 1; i <= n; i++) {
            if (z != k && a[i] > ls) {
                ans[k][z] = ls;
                z++;
                ls = a[i];
                continue;
            }
            ls = max(ls, a[i]);
            if (n - i == k - z) {
                ans[k][z] = ls;
                z++;
                ls = a[i + 1];
            }
        }
    }
 */
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    solve();
}
