#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

typedef long long int lint;
typedef long double ld;

struct Vector2d {
    lint x, y;
    Vector2d(int x = 0, int y = 0): x(x), y(y) {}
    Vector2d operator+(const Vector2d other) const {
        return Vector2d(x + other.x, y + other.y);
    }
    Vector2d operator-(const Vector2d other) const {
        return Vector2d(x - other.x, y - other.y);
    }
    lint mod() const {
        return x * x + y * y;
    }
    friend istream& operator>>(istream &in, Vector2d &v);
    friend ostream& operator<<(ostream &out, const Vector2d v);
};
typedef Vector2d v2d;

istream& operator>>(istream &in, Vector2d &v) {
    in >> v.x >> v.y;
    return in;
}

ostream& operator<<(ostream &out, const Vector2d v) {
    out << "(" << v.x << ", " << v.y << ")";
    return out;
}


vector <vector <int>> gr;
vector <int> clr;
vector <int> used;
vector <int> add;

void resize(const size_t n) {
    gr.resize(n);
    clr.resize(n, 0);
    used.resize(n, 0);
}



bool dfs(const int v) {
    bool res = false;
    used[v] = true;
    add.push_back(v);
    for (const auto u: gr[v]) {
        if (clr[u] == 0) {
            clr[u] = 3 - clr[v];
            res = dfs(u) || res;
        }
        else if (clr[u] == clr[v]) {
            res = true;
        }
    }
    return res;
}

int main() {
    int n; cin >> n;
    lint r; cin >> r;
    const lint r2 = r * r;
    vector <v2d> a(n);
    for (auto &el: a) cin >> el;
    resize(n);
    for (int i = 0; i < n; ++i) for (int j = i + 1; j < n; ++j) {
        if ((a[i] - a[j]).mod() <= r2) {
            gr[i].push_back(j);
            gr[j].push_back(i);
        }
    }
    // for (int i = 0; i < n; ++i) {
    //     cout << i << "\t"; for (auto u: gr[i]) cout << u << " ";
    //     cout << endl;
    // }
    vector <bool> ans(n, 0);
    for (int i = 0; i < n; ++i) if (!used[i]) {
        add.clear();
        clr[i] = 1;
        bool y = dfs(i);
        if (y) for (auto u: add) ans[u] = true;
    }
    for (int i = 0; i < n; ++i) cout << ans[i];
    return 0;
}