#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

typedef long long int lint;

vector <int> b;

pair<lint, vector <int>> inv(int i, int len) {
    if (len == 1) {
        return make_pair(0ll, (vector <int>) {b[i]});
    }
    auto [I1, L] = inv(i, len / 2);
    auto [I2, R] = inv(i + len / 2, len - len / 2);
    lint Im = 0;
    vector <int> res(L.size() + R.size());
    int x = 0, y = 0;
    while (x < L.size() || y < R.size()) {
        if (x == L.size()) {
            res[x + y] = R[y];
            ++y;
        }
        else if (y == R.size()) {
            res[x + y] = L[x];
            ++x;
        }
        else if (L[x] <= R[y]) {
            res[x + y] = L[x];
            ++x;
        }
        else {
            res[x + y] = R[y];
            Im += (L.size() - x);
            ++y;
        }
    }
    // cout << i << " " << len << endl;
    // for (auto el: res) cout << el << " ";
    // cout << endl << " " << I1 + I2 + Im;
    // cout << endl << endl;
    return {I1 + I2 + Im, res};
}


int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, m; cin >> n >> m;
    vector <vector <int>> a(n, vector <int> (m));
    for (auto &arr: a) for (auto &el: arr) cin >> el;
    if (n == 1) {
        b = a[0];
        auto [cnt, sorted] = inv(0, m);
        cout << cnt << "\n";
    }
    else {
        assert(n == 2);
        lint res = 0;
        lint best_res = 0;
        int best_k = 0;
        vector <int> sa0 = a[0];
        for (int k = 1; k <= m; ++k) {
            for (int i = k; i < m; ++i) {
                res += a[0][i] > a[1][k - 1];
                res -= a[0][i] < a[1][k - 1];
            }
            if (res > best_res) {
                best_k = k;
                best_res = res;
            }
        }
        {
            int k = best_k;
            b.clear();
            for (int j = 0; j < k; ++j) {
                b.push_back(a[0][j]);
                b.push_back(a[1][j]);
            }
            b.insert(b.end(), a[0].begin() + k, a[0].end());
            b.insert(b.end(), a[1].begin() + k, a[1].end());
            res = inv(0, b.size()).first;
        }
        cout << res << "\n";
    }
    return 0;
}