#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

typedef long long int lint;

vector <int> b;

pair<lint, vector <int>> inv(int i, int len) {
    if (len == 1) {
        return make_pair(0ll, (vector <int>) {b[i]});
    }
    auto [I1, L] = inv(i, len / 2);
    auto [I2, R] = inv(i + len / 2, len - len / 2);
    lint Im = 0;
    vector <int> res(L.size() + R.size());
    int x = 0, y = 0;
    while (x < L.size() || y < R.size()) {
        if (x == L.size()) {
            res[x + y] = R[y];
            ++y;
        }
        else if (y == R.size()) {
            res[x + y] = L[x];
            ++x;
        }
        else if (L[x] <= R[y]) {
            res[x + y] = L[x];
            ++x;
        }
        else {
            res[x + y] = R[y];
            Im += (L.size() - x);
            ++y;
        }
    }
    // cout << i << " " << len << endl;
    // for (auto el: res) cout << el << " ";
    // cout << endl << " " << I1 + I2 + Im;
    // cout << endl << endl;
    return {I1 + I2 + Im, res};
}

lint rec(vector <vector <int>> &a) {
    if (a.size() == 1 || a[0].empty()) {
        // copy(a[0].begin(), a[0].end(), b.end());
        for (int i = a[0].size() - 1; i >= 0; --i) {
            b.push_back(a[0][i]);
        }
        lint res = inv(0, b.size()).first;
        for (int i = a[0].size() - 1; i >= 0; --i) {
            b.pop_back();
        }
        return res;
    }
    else {
        lint res = 0;
        vector <int> a0 = a.back();
        // copy(a[0].begin(), a[0].end(), b.end());
        // b.insert(b.end(), a0.begin(), a0.end());
        for (int i = a0.size() - 1; i >= 0; --i) {
            b.push_back(a0[i]);
        }
        a.pop_back();
        res = rec(a);
        a.push_back(a0);
        for (int i = 0; i < a0.size(); ++i) b.pop_back();

        vector <int> a00(a.size());
        for (int i = a.size() - 1; i >= 0; --i) {
            a00[a.size() - 1 - i] = a[i].back();
            a[i].pop_back();
        }
        b.insert(b.end(), a00.begin(), a00.end());
        res = min(res, rec(a));

        for (int i = 0; i < a.size(); ++i) a[i].push_back(a00[a.size() - 1 - i]);

        // cout << endl;
        // for (auto arr: a) {
        //     for (auto el: arr) cout << el << " ";
        //     cout << endl;
        // } cout << res << endl;


        return res;
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n, m; cin >> n >> m;
    vector <vector <int>> a(n, vector <int> (m));
    for (int i = n - 1; i >= 0; --i) for (int j = m - 1; j >= 0; --j) cin >> a[i][j];
    cout << rec(a) << "\n";
    return 0;
}