#include <iostream>
#include <string> 
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>


using namespace std;
using ll = long long;

struct point{
    ll x, y;
    point(): x(0), y(0){}
    point(ll x, ll y): x(x), y(y){}
};

ll dist2(point a, point b){
    return (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
}

void solve(){
    ll n, r;
    cin >> n >> r;
    vector<point> a(n);
    for(auto &[x, y] : a)
        cin >> x >> y;
    vector<vector<bool>> used(2, vector<bool>(n));
    deque<pair<int, int>> q;
    q.push_back({0, 0});
    used[0][0] = true;
    while(!q.empty()){
        auto [c, i] = q.front();
        q.pop_front();
        for(int j = 0; j < n; j++){
            if(i == j || dist2(a[i], a[j]) > r * r || used[!c][j]){
                continue;
            }
            used[!c][j] = true;
            q.push_back({!c, j});
        }
    }
    for(int i = 0; i < n; i++){
        char c = '0' + (used[0][i] && used[1][i]);
        cout << c ;
    }
    cout << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}