#include <iostream>
#include <string> 
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>


using namespace std;
using ll = long long;

struct point{
    ll x, y;
    point(): x(0), y(0){}
    point(ll x, ll y): x(x), y(y){}
};

ll dist2(point a, point b){
    return (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
}


void dfs(vector<int> &comp,  vector<point> &a, vector<int> &color, vector<bool> &good, int i, int c, int clr, int n, ll r){
    comp[i] = c;
    color[i] = clr;
    for(int j = 0; j < n; j++){
        if(i == j || dist2(a[i], a[j]) > r * r)
            continue;
        if(color[j] == 3 - clr)
            continue;
        if(color[j] == clr){
            good[comp[i]] = true;
            continue;
        } 
        dfs(comp, a, color, good, j, c, 3 - clr, n, r);

    }
}

void solve(){
    ll n, r;
    cin >> n >> r;
    vector<point> a(n);
    for(auto &[x, y] : a)
        cin >> x >> y;
    vector<int> comp(n);
    vector<int> color(n);
    vector<bool> good(n + 1);
    int c = 1;
    for(int i = 0; i < n; i++){
        if(!comp[i]){
            dfs(comp, a, color, good, i, c, 1, n, r);
            c++;
        }
    }
    for(int i = 0; i < n; i++){
        char c = '0' + (good[comp[i]]);
        cout << c ;
    }
    cout << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}