#include <iostream>
#include <string> 
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
 
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;
using ll = long long;
 
vector<int> cur;

struct MergeSortTree{
    int n;
    vector<vector<int>> t;
    MergeSortTree(vector<int> &a){
        n = a.size();
        t.resize(4 * n);
        build(a, 0, 0, n);
    }
    void build(vector<int> &a, int v, int l, int r){
        if(r - l == 1){
            t[v] = {a[l]};
            return;
        }
        int mid = (l + r) / 2;
        build(a, v * 2 + 1, l, mid);
        build(a, v * 2 + 2, mid, r);
        t[v].resize(t[v * 2 + 1].size() + t[v * 2 + 2].size());
        merge(all(t[v * 2 + 1]), all(t[v * 2 + 2]), t[v].begin());
    }
    int get(int v, int l, int r, int ql, int qr, int x){
        if(qr <= l || r <= ql){
            return 0;
        }
        if(ql <= l && r <= qr){
            return upper_bound(all(t[v]), x) - t[v].begin();
        }
        int mid = (l + r) / 2;
        return get(v * 2 + 1, l, mid, ql, qr, x) + get(v * 2 + 2, mid, r, ql, qr, x);
    }
    int get(int ql, int qr, int x){
        return get(0, 0, n, ql, qr, x);
    }
};
 
ll invs(vector<int> &a){
    if(a.empty()){
        return 1e9;
    }
    MergeSortTree mst(a);
    ll res = 0;
    for(int i = 1; i < a.size(); i++){
        res += i - mst.get(0, i, a[i]);
    }
    return res;
}
 
vector<vector<int>> a;
int n, m;
ll ans = 1e9;
 
vector<vector<vector<int>>> opt;

ll gen(int shr, int shc){
    if(!opt[shr][shc].empty())
        return 0;
    vector<int> nopt1, nopt2;
    if(shr < n - 1){
        gen(shr + 1, shc);
        for(int j = shc; j < m; j++)
            nopt1.push_back(a[shr][j]);
        for(auto &x : opt[shr + 1][shc])
            nopt1.push_back(x);
    } else {
        for(int j = shc; j < m; j++)
            nopt1.push_back(a[shr][j]);
    }
    if(shc < m - 1){
        gen(shr, shc + 1);
        for(int i = shr; i < n; i++)
            nopt2.push_back(a[i][shc]);
        for(auto &x : opt[shr][shc + 1])
            nopt2.push_back(x);
    } else {
        for(int i = shr; i < n; i++)
            nopt2.push_back(a[i][shc]);
    }
    ll inv1 = invs(nopt1), inv2 = invs(nopt2);
    if(inv1 <= inv2){
        opt[shr][shc] = nopt1;
        return inv1;
    }
    opt[shr][shc] = nopt2;
    return inv2;
}

void solve(){
    cin >> n >> m;
    a.resize(n, vector<int>(m));
    opt.resize(n, vector<vector<int>>(m));
    for(auto &x : a)
          for(auto &y : x)
            cin >> y;
    // if(n == 1){
    //     for(int i = 0; i < m; i++){
    //         cur.push_back(a[0][i]);
    //     }
    //     ans = invs(cur);
    //     cout << ans << endl;
    //     return;
    // }
    ans = gen(0, 0);
    cout << ans << endl;
}
 
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}