#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct Point {
	int x, y;
};

vector<vector<int>> g;

vector<int> used;
bool dfs(int v, int p, int col) {
	used[v] = col;

	for (auto u : g[v]) {
		if (u != p) {
			if (used[u] == 3 or (used[u] != 0 and used[u] != 3 - col))
				return true;
			if (used[u] == 0)
				return dfs(u, v, 3 - col);
		}
	}

	return false;
}

void solve() {
	int n, r;
	cin >> n >> r;
	vector<Point> p(n);

	for (int i = 0; i < n; ++i) {
		cin >> p[i].x >> p[i].y;
	}

	g.resize(n + 1);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if ((p[i].x - p[j].x) * (p[i].x - p[j].x) + (p[i].y - p[j].y) * (p[i].y - p[j].y) <= r * r) {
				g[i + 1].push_back(j + 1);
				g[j + 1].push_back(i + 1);
			}
		}
	}

	used.resize(n + 1);
	vector<bool> ans(n + 1);
	for (int i = 1; i < n  + 1; ++i) {
		for (int i = 1; i < n + 1; ++i) {
			if (used[i] != 3)
				used[i] = 0;
		}
		if (dfs(i, i, 1))
			ans[i] = true;
	}

	for (int i = 1; i < n + 1; ++i) {
		if (ans[i])
			cout << '1';
		else
			cout << '0';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}