#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
#define int long long

struct Point {
	int x, y;
};

vector<vector<int>> g;

vector<int> ans;
vector<int> used;
bool f = true;
void dfs(int v, int col) {
	used[v] = col;

	for (auto u : g[v]) {
		if (!f)
			return;

		if (used[u] == 0)
			dfs(u, 3 - col);
		else if (used[u] != 3 - col) {
			f = false;
			return;
		}
	}
}

void paint(int v, int f) {
	ans[v] = f;

	for (auto u : g[v]) {
		if (ans[u] == 0)
			paint(u, f);
	}
}

void solve() {
	int n, r;
	cin >> n >> r;
	vector<Point> p(n);

	for (int i = 0; i < n; ++i) {
		cin >> p[i].x >> p[i].y;
	}

	g.resize(n + 1);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if ((p[i].x - p[j].x) * (p[i].x - p[j].x) + (p[i].y - p[j].y) * (p[i].y - p[j].y) <= r * r) {
				g[i + 1].push_back(j + 1);
				g[j + 1].push_back(i + 1);
			}
		}
	}

	used.resize(n + 1);
	ans.resize(n + 1);
	for (int i = 1; i < n + 1; ++i) {
		if (ans[i] == 0) {
			f = true;
			dfs(i, 1);
			if (f) {
				paint(i, 1);
			}
			else {
				paint(i, 2);
			}
		}
	}

	for (int i = 1; i < n + 1; ++i) {
		if (ans[i] == 1)
			cout << '0';
		else
			cout << '1';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}