#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;

vector<int> a;
vector<vector<int>> tree;
int ans = 0;
void build_tree(int i, int l, int r) {
	if (r == l + 1) {
		tree[i].push_back(a[l]);
		return;
	}
	int m = (l + r) / 2;
	build_tree(i * 2 + 1, l, m);
	build_tree(i * 2 + 2, m, r);

	int t = 0, j = 0;
	while (t != tree[i * 2 + 1].size() or j != tree[i * 2 + 2].size()) {
		if (t == tree[i * 2 + 1].size()) {
			tree[i].push_back(tree[i * 2 + 2][j++]);
			continue;
		}
		if (j == tree[i * 2 + 2].size()) {
			tree[i].push_back(tree[i * 2 + 1][t++]);
			continue;
		}
		
		if (tree[i * 2 + 1][t] < tree[i * 2 + 2][j])
			tree[i].push_back(tree[i * 2 + 1][t++]);
		else {
			ans += (tree[i * 2 + 1].size() - t);
			tree[i].push_back(tree[i * 2 + 2][j++]);
		}
	}
}

void solve() {
	int r, c;
	cin >> r >> c;
	a.resize(c);
	for (auto& ai : a) {
		cin >> ai;
	}
	tree.resize(4 * c);
	build_tree(0, 0, c);
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return 0;
}