#include "bits/stdc++.h"

using namespace std;
using ll = long long;


struct HashPair {
    ll operator()(pair<ll, ll> a) const {
        return (a.first << 30) + a.second;
    }
};


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, r;
    cin >> n >> r;

    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    const int R = 10;
    unordered_map<pair<int, int>, vector<int>, HashPair> block;
    for (int i = 0; i < n; ++i) {
        block[{a[i].first / R, a[i].second / R}].push_back(i);
    }

    vector<int> comp(n, -1);
    int good = 0;
    vector<int> can(n);
    vector<int> col(n);
    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1) continue;
        deque<int> q = {i};
        col[i] = 1;
        comp[i] = i;
        bool flag = false;

        function<void(int)> dfs = [&](int v) {
            for (int block_i = a[v].first / R - 1; block_i <= a[v].first / R + 1; ++block_i) {
                for (int block_j = a[v].second / R - 1; block_j <= a[v].second / R + 1; ++block_j) {
                    for (auto u: block[{block_i, block_j}]) {
                        ll dist = (a[u].first - a[v].first) * (a[u].first - a[v].first) +
                                  (a[u].second - a[v].second) * (a[u].second - a[v].second);
                        if (dist > r * r) continue;

                        if (u == v) continue;
                        if (comp[u] != -1) {
                            flag |= col[u] == col[v];
                            continue;
                        }


                        col[u] = 3 - col[v];
                        comp[u] = comp[v];
                        dfs(u);
                    }
                }
            }
        };
        dfs(i);

        if (flag) {
            for (int j = 0; j < n; ++j) {
                if (comp[j] == comp[i]) can[j] = flag;
            }
        }
    }


    for (int i = 0; i < n; ++i) {
        cout << can[i];
    }
}

