#include "bits/stdc++.h"

using namespace std;
using ll = long long;

struct Node {
    int x, pos;

    Node(int x = 1e9, int pos = -1) : x(x), pos(pos) {}

    friend Node operator+(Node L, Node R) {
        Node res;
        if (res.x > L.x) {
            res.x = L.x;
            res.pos = L.pos;
        }
        if (res.x > R.x) {
            res.x = R.x;
            res.pos = R.pos;
        }
        return res;
    }
};

struct Segtree {
    int n;
    vector<Node> t;

    Segtree(int n, vector<Node> a) : n(n) {
        t.resize(4 * n + 1);
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, vector<Node> &a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    Node get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return t[v];
        if (l >= qr || r <= ql) return Node();
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> prefmax(n + 1);
    prefmax[n] = -1e9;
    for (int i = n - 1; i >= 0; --i) {
        prefmax[i] = max(prefmax[i + 1], a[i]);
    }

    vector<int> nearest(n, n);
    vector<int> que = {n - 1};
    for (int i = n - 1; i >= 0; --i) {
        while (!que.empty() && a[que.back()] <= a[i]) {
            que.pop_back();
        }
        if (!que.empty()) nearest[i] = que.back();
        que.push_back(i);
    }

    auto solvek2 = [&](vector<int> b) {
        int m = b.size();
        vector<int> prefmax(m + 1);
        prefmax[m] = -1e9;
        for (int i = m - 1; i >= 0; --i) {
            prefmax[i] = max(prefmax[i + 1], b[i]);
        }

        vector<int> best = {(int) 1e9, (int) 1e9};
        int mx = 0;
        for (int i = 0; i < m - 1; ++i) {
            mx = max(mx, b[i]);
            best = min(best, {mx, prefmax[i + 1]});
        }
        return best;
    };

    vector<Node> tmp(n);
    for (int i = 0; i < n; ++i) {
        tmp[i].x = a[i];
        tmp[i].pos = i;
    }

    Segtree tree(n, tmp);

    vector<vector<ll>> ans(n + 1);
    ans[1] = {n};

//    for (int i = 1; i <= n; ++i) {
//        for (auto v: ans[i]) cout << v << " ";
//        cout << "\n";
//    }
    while (q--) {
        int k, i;
        cin >> k >> i;

        if (ans[k].empty()) {
            ll pref = 0;
            ll kused = 0;
            while (pref < n) {
                if (pref + (k - kused) == n) {
                    break;
                }
                ll mx = min<ll>(nearest[pref], n - (k - kused - 1));
                if (kused == k - 2) {
                    vector<int> b(a.begin() + pref, a.end());
                    vector<int> an = solvek2(b);
                    ans[k].push_back(an[0]);
                    ans[k].push_back(an[1]);
                    kused += 2;
                    pref = n;
                } else {
                    int minpos = tree.get(0, 0, n, pref + 1, mx + 1).pos;

                    ans[k].push_back(a[pref]);
                    pref = minpos;
                    kused++;
                }
            }
        }

        if (ans[k].size() >= i) {
            cout << ans[k][i - 1] << "\n";
        } else {
            cout << a[n - (k - i) - 1] << "\n";
        }
    }
}

