#include "bits/stdc++.h"

using namespace std;
using ll = long long;

struct Node {
    int x, pos;

    Node(int x = 1e9, int pos = -1) : x(x), pos(pos) {}

    friend Node operator+(Node L, Node R) {
        Node res;
        if (res.x > L.x) {
            res.x = L.x;
            res.pos = L.pos;
        }
        if (res.x > R.x) {
            res.x = R.x;
            res.pos = R.pos;
        }
        return res;
    }
};

struct Segtree {
    int n;
    vector<Node> t;

    Segtree(int n, vector<Node> a) : n(n) {
        t.resize(4 * n + 1);
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, vector<Node> &a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    Node get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return t[v];
        if (l >= qr || r <= ql) return Node();
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

struct Res {
    int rs, ind, cnt;
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> prefmax(n + 1);
    prefmax[n] = -1e9;
    for (int i = n - 1; i >= 0; --i) {
        prefmax[i] = max(prefmax[i + 1], a[i]);
    }

    vector<int> nearest(n, n);
    vector<int> que = {n - 1};
    for (int i = n - 1; i >= 0; --i) {
        while (!que.empty() && a[que.back()] <= a[i]) {
            que.pop_back();
        }
        if (!que.empty()) nearest[i] = que.back();
        que.push_back(i);
    }
    vector<int> nearest_row(n, 0);
    nearest_row[n - 1] = 1;
    for (int i = n - 2; i >= 0; --i) {
        if (nearest[i] == i + 1) {
            nearest_row[i] = nearest_row[i + 1] + 1;
        } else {
            nearest_row[i] = 0;
        }
    }

    auto solvek2 = [&](vector<int> b) {
        int m = b.size();
        vector<int> prefmax(m + 1);
        prefmax[m] = -1e9;
        for (int i = m - 1; i >= 0; --i) {
            prefmax[i] = max(prefmax[i + 1], b[i]);
        }

        vector<int> best = {(int) 1e9, (int) 1e9};
        int mx = 0;
        for (int i = 0; i < m - 1; ++i) {
            mx = max(mx, b[i]);
            best = min(best, {mx, prefmax[i + 1]});
        }
        return best;
    };

    vector<Node> tmp(n);
    for (int i = 0; i < n; ++i) {
        tmp[i].x = a[i];
        tmp[i].pos = i;
    }

    Segtree tree(n, tmp);

    vector<vector<Res>> ans(n + 1);

//    for (int i = 1; i <= n; ++i) {
//        for (auto v: ans[i]) cout << v << " ";
//        cout << "\n";
//    }
    while (q--) {
        int k, i;
        cin >> k >> i;

        if (k == 1) {
            cout << n << "\n";
            continue;
        }

        if (ans[k].empty()) {
            ll pref = 0;
            ll kused = 0;
            while (pref < n) {
                if (pref + (k - kused) == n) {
                    break;
                }
                ll mx = min<ll>(nearest[pref], n - (k - kused - 1));
                if (nearest_row[pref] == 0) {
                    int minpos = tree.get(0, 0, n, pref + 1, mx + 1).pos;

                    if (ans[k].empty()) {
                        ans[k].push_back({a[pref], 0, 1});
                    } else {
                        ans[k].push_back({a[pref], 0, ans[k].back().cnt + 1});
                    }
                    pref = minpos;
                    kused++;

                } else {
                    if (ans[k].empty()) {
                        ans[k].push_back({-1, (int) pref, nearest_row[pref]});
                    } else {
                        ans[k].push_back({-1, (int) pref, ans[k].back().cnt + nearest_row[pref]});
                    }
                    kused += nearest_row[pref];
                    pref = pref + nearest_row[pref];
                }
            }
        }

        if (!ans[k].empty() && ans[k].back().cnt >= i) {
            int l = -1, r = ans[k].size();
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (ans[k][mid].cnt >= i) {
                    r = mid;
                } else {
                    l = mid;
                }
            }

            if (ans[k][r].rs == -1) {
                if (r == 0) {
                    cout << a[ans[k][r].ind + (i - 1)] << "\n";
                } else {
                    cout << a[ans[k][r].ind + (i - ans[k][r - 1].cnt + 1)] << "\n";
                }
            } else {
                cout << ans[k][r].rs << "\n";
            }
        } else {
            cout << a[n - (k - i) - 1] << "\n";
        }
    }
}