#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>

#include <functional>

// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")

using namespace std;

#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>

void solve() {
    i64 n, r;
    cin >> n >> r;
    vc<pair<i64, i64>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].fi >> p[i].se;
    }

    function<i64(int, int)> dist = [&](int i, int j) {
        return (p[i].fi - p[j].fi) * (p[i].fi - p[j].fi) + (p[i].se - p[j].se) * (p[i].se - p[j].se);
    };

    vvi g(n);
    for (int v = 0; v < n; ++v) {
        for (int u = v + 1; u < n; ++u) {
            if (dist(v, u) <= r * r) {
                g[v].pb(u);
                g[u].pb(v);
            }
        }
    }
    vvi g2(n);
    for (int v = 0; v < n; ++v) {
        for (int u : g[v]) {
            int l = 0, r = 0;
            vi nw;
            while (l < g2[v].size() && r < g[u].size()) {
                if (g2[v][l] == g[u][r]) {
                    nw.pb(g2[v][l]);
                    ++l; ++r;
                } else if (g2[v][l] < g[u][r]) {
                    nw.pb(g2[v][l]);
                    ++l;
                } else {
                    nw.pb(g[u][r]);
                    ++r;
                }
            }
            while (l < g2[v].size()) {
                nw.pb(g2[v][l++]);
            }
            while (r < g[u].size()) {
                nw.pb(g[u][r++]);
            }
            g2[v] = nw;
        }
    }

    vi used(n);
    int id = 0;

    vb nice(n);

    bool ret = 0;

    function<void(int)> dfs = [&](int v) {
        used[v] = id;
        if (nice[v]) {
            ret = 1;
            return;
        }
        for (int u : g2[v]) {
            if (used[u] < id) {
                dfs(u);
            }
            if (ret) return;
        }
    };

    function<void(int)> dfs2 = [&](int v) {
        used[v] = id;
        for (int u : g[v]) {
            if (used[u] < id) {
                dfs(u);
            }
        }
    };

    vi ans(n);
    vvi can(n);



    for (int v = 0; v < n; ++v) {
        ++id;
        dfs2(v);
        bool is = 0;
        for (int u = 0; u < n; ++u) {
            if (used[u] == id && ans[u]) {
                is = 1;
                break;
            }
        }
        if (is) {
            ans[v] = 1;
            cout << 1;
            continue;
        }
        ++id;
        nice.assign(n, 0);
        ret = 0;
        for (int u : g[v]) {
            nice[u] = 1;
        }
        dfs(v);
        for (int u : g[v]) {
            if (used[u] == id) {
                is = 1;
                break;
            }
        }
        ans[v] = is;
        cout << is;
    }

}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}