#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>
#include <bitset>
 
#include <functional>
 
// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
 
using namespace std;
 
#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>
 
void solve() {
    i64 n, r;
    cin >> n >> r;
    vc<pair<i64, i64>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].fi >> p[i].se;
    }
 
    function<i64(int, int)> dist = [&](int i, int j) {
        return (p[i].fi - p[j].fi) * (p[i].fi - p[j].fi) + (p[i].se - p[j].se) * (p[i].se - p[j].se);
    };
 
    vvi g(n);
    vc<bitset<10000>> gg(n);
    for (int v = 0; v < n; ++v) {
        for (int u = v + 1; u < n; ++u) {
            if (dist(v, u) <= r * r) {
                g[v].pb(u);
                g[u].pb(v);
                gg[v][u] = 1;
                gg[u][v] = 1;
            }
        }
    }
    vc<bitset<10000>> g2(n);
    
    for (int v = 0; v < n; ++v) {
        for (int u : g[v]) {
            g2[v] |= gg[u];
        }
    }
 
    vi used(n);
    int id = 1;
 
    bool ret = 0;
 
    function<void(int)> dfs = [&](int v) {
        used[v] = id;
        for (int u : g[v]) {
            if (used[u] == id) {
                ret = 1;
            }
        }
        for (int u = 0; u < n; ++u) {
            if (g2[v][u] && used[u] < id) {
                dfs(u);
            }
        }
        used[v] = id + 1;
    };
 

    vi ans;
 
    for (int v = 0; v < n; ++v) {
        ret = 0;
        if (!used[v]) {
            dfs(v);
            ans.pb(ret);
            id += 2;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[used[i] / 2 - 1];
    }
 
}
 
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}