#include <iostream>
#include <vector>
#include <cstdint>
#include <cassert>
#include <cstring>
#include <string>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <set>
  
#include <functional>
  
// #pragma GCC optimize("O3,fast-math,unroll-loops")
// #pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
  
using namespace std;
  
#define vc vector
#define vi vector<int>
#define i64 int64_t
#define pb push_back
#define fi first
#define se second
#define vvi vector<vi>
#define vb vector<bool>
  
void solve() {
    i64 n, r;
    cin >> n >> r;
    vc<pair<i64, i64>> p(n);
    set<pair<pair<i64, i64>, int>> st;
    for (int i = 0; i < n; ++i) {
        cin >> p[i].fi >> p[i].se;
        st.insert({p[i], i});
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            assert(p[i] != p[j]);
        }
    }
  
    function<i64(int, int)> dist = [&](int i, int j) {
        return (p[i].fi - p[j].fi) * (p[i].fi - p[j].fi) + (p[i].se - p[j].se) * (p[i].se - p[j].se);
    };
  
    vvi g(n);
    for (int v = 0; v < n; ++v) {
        for (int d1 = -5; d1 <= 5; ++d1) {
            for (int d2 = -5; d2 <= 5; ++d2) {
                if (d1 * d1 + d2 * d2 > r * r || d1 * d1 + d2 * d2 == 0) continue;
                pair<i64, i64> nw = {p[v].fi + d1, p[v].se + d2};
                auto it = st.lower_bound({nw, -1});
                if (it != st.end() && (*it).fi == nw) {
                    g[v].pb((*it).se);
                }
            }
        }
    }
 
    vvi g2(n);
 
    vi used2(n);
    int id2 = 0;
    int vv;
 
    function<void(int, int)> calc = [&](int v, int dist) {
        used2[v] = id2;
        if (!dist) {
            g2[vv].pb(v);
            return;
        }
        for (int u : g[v]) {
            if (used2[u] < id2) {
                calc(u, dist - 1);
            }
        }
    };
 
    for (int i = 0; i < n; ++i) {
        vv = i;
        ++id2;
        calc(vv, 2);
    }
  
    vi used(n);
    int id = 1;
  
    bool ret = 0;
  
    function<void(int)> dfs = [&](int v) {
        used[v] = id;
        for (int u : g[v]) {
            if (used[u] == id) {
                ret = 1;
            }
        }
        for (int u : g2[v]) {
            if (used[u] < id) {
                dfs(u);
            }
        }
        used[v] = id + 1;
    };
  
 
    vi ans;
  
    for (int v = 0; v < n; ++v) {
        ret = 0;
        if (!used[v]) {
            dfs(v);
            ans.pb(ret);
            id += 2;
        }
    }
 
    for (int i = 0; i < n; ++i) {
        cout << ans[used[i] / 2 - 1];
    }
  
}
  
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}