#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops")
#endif

using namespace std;

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()

int n, r;
unordered_map<int,int> a;
vector<int> cycles;
vector<int> to;
vector<int> st;
vector<int> used;
vector<int> pos;

bool check(pair<int,int> p1, pair<int,int> p2) {
    auto [x1,y1] = p1;
    auto [x2,y2] = p2;
    ll dist = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
    return dist <= r * r;
}

pair <int,int> to_p(int x) {
    int f = x << 32 >> 32;
    int s = x >> 32;
    return {f,s};
}

int to_i(pair <int,int> x) {
    return (x.first << 32) + x.second;
}

bool f = false;

void dfs(int v, pair<int,int> p) {
    pos[v] = st.size();
    st.push_back(v);
    used[v] = 1;
    auto [x,y] = p;
    for (int dx = -r; dx <= r; dx++) {
        for (int dy = -r; dy <= r; dy++) {
            int u = a[to_i({x + dx, y + dy})] - 1;
            if (u != -1) {
                if (f) {
                    pos[v] = -1;
                    return;
                }
                if (check({x, y}, {x + dx, y + dy}) && v != u) {
                    if (used[u] && pos[u] != -1 && abs(pos[u] - pos[v]) % 2 == 0) {
                        for (int i: st)
                            cycles[i] = 1;
                        f = true;
                        return;
                    }
                    if (used[u] && cycles[u] != 1) {
                        for (int i: st)
                            cycles[i] = 2;
                    }
                    if (!used[u]) {
                        dfs(u, {x + dx, y + dy});
                    }
                }
            }
        }
    }
    st.pop_back();
    pos[v] = -1;
}

void dfs2(int v, pair<int,int> p) {
    used[v] = 1;
    cycles[v] = 1;
    auto [x,y] = p;
    for (int dx = -r; dx <= r; dx++) {
        for (int dy = -r; dy <= r; dy++) {
            int u = a[to_i({x + dx, y + dy})] - 1;
            if (u != -1) {
                if (check(p, {x + dx, y + dy}) && v != u && !used[u]) {
                    dfs2(u, {x + dx, y + dy});
                }
            }
        }
    }
}

int32_t main() {
#ifndef LOCAL
    cin.tie(nullptr),ios_base::sync_with_stdio(false);
#endif
    cin >> n >> r;
    cycles.resize(n);
    to.resize(n);
    used.resize(n);
    pos.resize(n, -1);
    vector<pair<int,int> > g(n);
    for (int i = 1; i <= n; i++) {
        int x, y;
        cin >> x >> y;
        a[to_i({x, y})] = i;
        g[i - 1] = {x, y};
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            st.clear();
            f = false;
            dfs(i, g[i]);
        }
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (cycles[i] == 1)
                dfs2(i, g[i]);
        }
    }
    for (int i = 0; i < n; i++)
        cout << cycles[i] % 2;
    return 0;
}
