#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops")
#endif

using namespace std;

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()

int n, r;
vector<pair<int,int>> a;
vector <int> cycles;
vector <int> to;
vector <int> st;
vector <int> used;
vector <int> pos;

bool check(int v, int u) {
    auto [x1,y1] = a[v];
    auto [x2,y2] = a[u];
    ll dist = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
    return dist <= r * r;
}

bool f = false;

void dfs(int v) {
    pos[v] = st.size();
    st.push_back(v);
    used[v] = 1;
    for (int u = 0; u < n; u++) {
        if (f)
            return;
        if (check(v,u) && v != u) {
            if (used[u] && abs(pos[u] - pos[v]) % 2 == 0) {
                for (int i : st)
                    cycles[i] = 1;
                f = true;
                return;
            }
            if (used[u] && cycles[u] != 1) {
                for (int i : st)
                    cycles[i] = 2;
            }
            if (!used[u]) {
                dfs(u);
            }
        }
    }
    st.pop_back();
    pos[v] = 0;
}

void dfs2(int v) {
    used[v] = 1;
    cycles[v] = 1;
    for (int u = 0; u < n; u++) {
        if (check(v,u) && v != u && !used[u]) {
            dfs2(u);
        }
    }
}

int32_t main() {
#ifndef LOCAL
    cin.tie(nullptr),ios_base::sync_with_stdio(false);
#endif
    cin >> n >> r;
    a.resize(n);
    cycles.resize(n);
    to.resize(n);
    used.resize(n);
    pos.resize(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            st.clear();
            f = false;
            dfs(i);
        }
    }
    used.assign(n,0);
    for (int i = 0; i < n; i++) {
        if (cycles[i] == 1) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; i++)
        cout << cycles[i] % 2;
    return 0;
}
