#include <bits/extc++.h>

#include <random>

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops")
#endif

using namespace std;

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()

int r, c;
vector<vector<int> > a;
vector<int> b;
vector<vector<int> > used(r, vector<int>(c));

int cnt(vector<int> &order) {
    b.clear();
    used.assign(r, vector<int>(c, 0));
    int pr = 0, pc = 0;
    for (int tp: order) {
        if (tp == 0) {
            for (int j = 0; j < c; j++) {
                if (!used[pr][j]) {
                    b.push_back(a[pr][j]);
                    used[pr][j] = 1;
                }
            }
            pr++;
        } else {
            for (int i = 0; i < r; i++) {
                if (!used[i][pc]) {
                    b.push_back(a[i][pc]);
                    used[i][pc] = 1;
                }
            }
            pc++;
        }
    }
    int cnt = 0;
    for (int i = 0; i < b.size(); i++) {
        for (int j = 0; j < i; j++)
            if (b[j] > b[i])
                cnt++;
    }
    return cnt;
}

mt19937 rnd(1);

int randint(int l, int r) {
    return rnd() % (r - l + 1) + l;
}

ld get_rand() {
    return (double)rand() / RAND_MAX;
}

tuple<vector<int>, vector<int>, vector<int> > get_new(vector<int> order, vector<int> pos0, vector<int> pos1) {
    int i = randint(0, pos0.size() - 1);
    int j = randint(0, pos1.size() - 1);
    swap(order[pos0[i]], order[pos1[j]]);
    swap(pos0[i], pos1[j]);
    return {order,pos0,pos1};
}

int32_t main() {
#ifndef LOCAL
    cin.tie(nullptr),ios_base::sync_with_stdio(false);
#endif
    srand(1);
    cin >> r >> c;
    a.resize(r, vector<int>(c));
    for (int i = 0; i < r; i++)
        for (int j = 0; j < c; j++)
            cin >> a[i][j];
    vector<int> order;
    vector<int> pos0, pos1;
    for (int i = 0; i < r; i++) order.push_back(0);
    for (int i = 0; i < c; i++) order.push_back(1);
    shuffle(all(order), mt19937(1));
    for (int i = 0; i < order.size(); i++) {
        if (order[i])
            pos1.push_back(i);
        else
            pos0.push_back(i);
    }
    int cur = cnt(order);
    ld temp = 1000;
    ld cooling = 0.995;
    for (int it = 0; it < 10000; it++) {
        auto [new_order,new_pos0,new_pos1] = get_new(order,pos0,pos1);
        int new_cur = cnt(new_order);
        int delta = cur - new_cur;
        if (delta > 0 || exp(-delta / temp) < get_rand()) {
            order = new_order;
            pos0 = new_pos0;
            pos1 = new_pos1;
            cur = new_cur;
        }
        temp *= cooling;
    }
    cout << cur;
    return 0;
}
