#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

struct segtree {
    vector<int> tree;
    int size;

    void init(int n) {
        size = n;
        tree.resize(4 * n, 0);
    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        }
        int m = (rx + lx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int ind, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }
        int m = (rx + lx) / 2;
        if (ind < m) {
            set(ind, 2 * x + 1, lx, m);
        } else {
            set(ind, 2 * x + 2, m, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (rx <= l || r <= lx) {
            return 0;
        }
        int m = (rx + lx) / 2;
        return get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx);
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    vector<int> a(c);
    for (int i = 0; i < c; ++i) {
        cin >> a[i];
        a[i]--;
    }
    segtree st;
    st.init(c);
    int ans = 0;
    for (int i = 0; i < c; ++i) {
        ans += st.get(a[i] + 1, c, 0, 0, c);
        st.set(a[i], 0, 0, c);
    }
    cout << ans << '\n';
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
