#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct segtree {
    vector<int> tree;
    int size;

    void init(int n) {
        size = n;
        tree.assign(4 * n, 0);
    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        }
        int m = (rx + lx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int ind, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }
        int m = (rx + lx) / 2;
        if (ind < m) {
            set(ind, 2 * x + 1, lx, m);
        } else {
            set(ind, 2 * x + 2, m, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (rx <= l || r <= lx) {
            return 0;
        }
        int m = (rx + lx) / 2;
        return get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx);
    }
};


void solve() {
    int r, c;
    cin >> r >> c;
    vector a(r, vector<int>(c, 0));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    int ans = INF;
    for (int mask = 0; mask < 1 << ((r + c)); ++mask) {
        int cnt = 0;
        for (int j = 0; j < r + c; ++j) {
            cnt += ((mask >> j) & 1);
        }
        if (cnt != r) {
            continue;
        }
        segtree st;
        st.init(r * c);
        int cur = 0;
        int si = 0, sj = 0;
        for (int j = 0; j < r + c; ++j) {
            if (((mask >> j) & 1)) {
                for (int x = sj; x < c; ++x) {
                    cur += st.get(a[si][x], c * r, 0, 0, r * c);
                    st.set(a[si][x], 0, 0, r * c);
                }
                si++;
            } else {
                for (int x = si; x < r; ++x) {
                    cur += st.get(a[x][sj], r * c, 0, 0, r * c);
                    st.set(a[x][sj], 0, 0, r * c);
                }
                sj++;
            }
        }
        ans = min(ans, cur);
    }
    cout << ans << '\n';
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
