#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const int INF = 1e9;

struct segtree {
    vector<int> tree;
    int size;

    void init(int n) {
        size = n;
        tree.assign(4 * n, 0);
    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        }
        int m = (rx + lx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int ind, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }
        int m = (rx + lx) / 2;
        if (ind < m) {
            set(ind, 2 * x + 1, lx, m);
        } else {
            set(ind, 2 * x + 2, m, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (rx <= l || r <= lx) {
            return 0;
        }
        int m = (rx + lx) / 2;
        return get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx);
    }
};


void solve() {
    int r, c;
    cin >> r >> c;
    vector a(r, vector<int>(c, 0));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    segtree st;
    st.init(r * c);
    int si = 0;
    int sj = 0;
    int ans = 0;
    while (si < r && sj < c) {
        int curr = 0, curc = 0;
        for (int i = sj; i < c; ++i) {
            curr += st.get(a[si][i], r * c, 0, 0, r * c) + (a[si][i] - st.get(0, a[si][i], 0, 0, r * c));
        }
        for (int i = si; i < r; ++i) {
            curc += st.get(a[i][sj], r * c, 0, 0, r * c) + (a[i][sj] - st.get(0, a[si][i], 0, 0, r * c));
        }
        if (curr > curc) {
            for (int i = si; i < r; ++i) {
                ans += st.get(a[i][sj], r * c, 0, 0, r * c);
                st.set(a[i][sj], 0, 0, r * c);
            }
            sj++;
        } else {
            for (int i = sj; i < c; ++i) {
                ans += st.get(a[si][i], r * c, 0, 0, r * c);
                st.set(a[si][i], 0, 0, r * c);
            }
            si++;
        }
    }
    cout << ans << '\n';
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
