#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
const ll INF = 1e18;

struct segtree {
    vector<int> tree;
    int size;

    void init(int n) {
        size = n;
        tree.assign(4 * n, 0);
    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        }
        int m = (rx + lx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int ind, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }
        int m = (rx + lx) / 2;
        if (ind < m) {
            set(ind, 2 * x + 1, lx, m);
        } else {
            set(ind, 2 * x + 2, m, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (rx <= l || r <= lx) {
            return 0;
        }
        int m = (rx + lx) / 2;
        return get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx);
    }
};

ll r, c;

void solve() {
    vector<int> a(c);
    for (int i = 0; i < c; ++i) {
        cin >> a[i];
        a[i]--;
    }
    segtree st;
    st.init(c);
    ll ans = 0;
    for (int i = 0; i < c; ++i) {
        ans += st.get(a[i] + 1, c, 0, 0, c);
        st.set(a[i], 0, 0, c);
    }
    cout << ans << '\n';
}

void solve1() {
    vector a(2, vector<int>(c + 1, 0));
    for (int i = 1; i <= c; ++i) {
        cin >> a[0][i];
        a[0][i]--;
    }
    for (int i = 1; i <= c; ++i) {
        cin >> a[1][i];
        a[1][i]--;
    }
    vector<ll> answer(c + 1, 0);
    segtree st;
    st.init(r * c);
    for (int i = 1; i <= c; ++i) {
        answer[i] = answer[i - 1];
        answer[i] += r * c - 1 - st.get(0, a[1][i], 0, 0, r * c);
        st.set(a[1][i], 0, 0, r * c);
        answer[i] += r * c - 1 - st.get(0, a[0][i], 0, 0, r * c);
    }
    st.init(r * c);
    segtree st1;
    st1.init(r * c);
    ll cur = 0;
    for (int i = c; i > 0; --i) {
        cur += st1.get(0, a[1][i], 0, 0, r * c);
        st.set(a[1][i], 0, 0, r * c);
        st1.set(a[1][i], 0, 0, r * c);
        cur += st.get(0, a[0][i], 0, 0, r * c);
        st.set(a[0][i], 0, 0, r * c);
        answer[i - 1] += cur;
    }
    ll ans = INF;
    for (int i = 0; i <= c; ++i) {
        ans = min(ans, answer[i]);
    }
    cout << ans << '\n';
}

int main() {
    int t = 1;
    //cin >> t;
    cin >> r >> c;
    while (t--) {
        if (r == 1) {
            solve();
        } else {
            solve1();
        }
    }
}
