#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define sz(x) (int) x.size()
#define all(x) x.begin(), x.end()
#define int long long

const int N = 2e5;

struct sg {
    vector<int> d;

    sg() {}

    sg(int n) {
        d.resize(5 * n, 0);
    }

    void build(int v, int l, int r) {
        d[v] = 0;
        if (l == r) {
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
    }

    void update(int v, int l, int r, int pos, int zn) {
        d[v] += zn;
        if (l == r) {
            return;
        }
        int m = (l + r) / 2;
        if (pos > m) {
            update(2 * v + 1, m + 1, r, pos, zn);
        } else {
            update(2 * v, l, m, pos, zn);
        }
    }

    int find_ans(int v, int l, int r, int x, int y) {
        if (l > y || x > r) {
            return 0;
        }
        if (l >= x && r <= y) {
            return d[v];
        }
        int m = (l + r) / 2;
        return find_ans(2 * v, l, m, x, y) + find_ans(2 * v + 1, m + 1, r, x, y);
    }
};

int n, m;
vector<vector<int>> a;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    a.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int r = n * m + 1;
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    sg dr(n * m + 10), dc(n * m + 10);
    for (int i = n - 1; i >= 0; --i) {
        dr.build(1, 0, r);
        dc.build(1, 0, r);
        for (int k = i + 1; k < n; ++k) {
            dc.update(1, 0, r, a[k][m - 1], 1);
        }
        for (int j = m - 1; j >= 0; --j) {
            int val = 0;
            for (int k = n - 1; k >= i; --k) {
                val += dr.find_ans(1, 0, r, 0, a[k][j] - 1);
                dr.update(1, 0, r, a[k][j], 1);
            }
            dp[i][j] = dp[i][j + 1] + val;
            for (int k = i; k < n; ++k) {
                val -= dr.find_ans(1, 0, r, 0, a[k][j] - 1);
                dr.update(1, 0, r, a[k][j], -1);
            }
            val = 0;
            for (int k = m - 1; k >= j; --k) {
                val += dc.find_ans(1, 0, r, 0, a[i][k] - 1);
                dc.update(1, 0, r, a[i][k], 1);
            }
            dp[i][j] = min(dp[i][j], dp[i + 1][j] + val);
            for (int k = j; k < m; ++k) {
                val -= dc.find_ans(1, 0, r, 0, a[i][k] - 1);
                dc.update(1, 0, r, a[i][k], -1);
            }
            if (j != 0) {
                for (int k = i + 1; k < n; ++k) {
                    dc.update(1, 0, r, a[k][j - 1], 1);
                }
            }
            for (int k = i; k < n; ++k) {
                dr.update(1, 0, r, a[k][j], 1);
            }
        }
    }
    cout << dp[0][0];
    return 0;
}