#pragma GCC("O3")
#include <bits/stdc++.h>
#define int long long
const int INF = INT_MAX;
using namespace std;

struct segmentTree {
    vector<int> a;
    vector<int> t;
    segmentTree (const vector<int> &data) {
        a = data;
        t.resize(4 * a.size());
        build(0, 0, a.size());
    }
    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
    void change(int v, int l, int r, int pos) {
        if (l + 1 == r) {
            t[v] = 1;
            return;
        }

        int m = (r + l) / 2;
        if (pos < m) change(2 * v + 1, l, m, pos);
        else change(2 * v + 2, m, r, pos);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
    void change(int pos) {
        return change(0, 0, a.size(), pos);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (r <= ql || l >= qr) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }

        int m = (r + l) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
    int get(int ql, int qr) {
        return get(0, 0, a.size(), ql, qr);
    }
};


void solve() {
    int r, n;
    cin >> r >> n;
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    vector<int> b(n, 0);
    segmentTree t(b);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        t.change(a[i] - 1);
        ans += t.get(a[i], n);
        // cout << ans << '\n';
        // for (auto el : t.t) {
        //     cout << el << ' ';
        // }
    }

    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    while (t--) {
        solve();
    }
}
