#include <bits/extc++.h>
#define int long long

using namespace std;

const int inf = 1e18;
const int lm = 22;

struct segtree {
    vector<pair<int, int>> mn;
    int n;

    segtree(int _n, vector<int> &a) {
        n = _n;
        mn.resize(4 * n, {inf, -1});
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            mn[v] = {a[l], l};
        } else {
            int m = (l + r) / 2;
            build(2 * v + 1, l, m, a);
            build(2 * v + 2, m, r, a);
            mn[v] = min(mn[2 * v + 1], mn[2 * v + 2]);
        }
    }

    pair<int, int> query(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return mn[v];
        } else if (qr <= l || r <= ql) {
            return {inf, -1};
        } else {
            int m = (l + r) / 2;
            return min(query(2 * v + 1, l, m, ql, qr), query(2 * v + 2, m, r, ql, qr));
        }
    }

    pair<int, int> query(int l, int r) {
        return query(0, 0, n, l, r);
    }
};

void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    vector<int> gr(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> mr(n, n);
    vector<pair<int, int>> st = {{inf, n}};
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] < a[i + 1]) {
            gr[i] = gr[i + 1] + 1;
        }
        while (st.back().first <= a[i]) {
            st.pop_back();
        }
        mr[i] = st.back().second;
        st.push_back({a[i], i});
    }
    vector<int> mxs(n, inf); mxs[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        mxs[i] = max(a[i], mxs[i + 1]);
    }
    segtree t(n, a);
    vector<int> nxt(n, n);
    for (int dc = 0; dc < n - 2; ++dc) {
        int cur = dc;
        if (a[cur] < a[cur + 1]) {
            ++cur;
        } else { 
            int r = min(mr[cur], n - 1);
            auto [mn, j] = t.query(cur + 1, r);
            cur = j;
        }
        nxt[dc] = cur;
    }
    vector<vector<int>> up(n, vector<int>(lm, n));
    for (int i = 0; i < n; ++i) {
        up[i][0] = nxt[i];
    }
    for (int l = 1; l < lm; ++l) {
        for (int i = 0; i < n; ++i) {
            if (up[i][l - 1] != n) {
                up[i][l] = up[up[i][l - 1]][l - 1];
            }
        }
    }
    auto la = [&](int i, int k) {
        for (int j = 0; j < lm; ++j) {
            if ((k >> j) & 1) {
                i = up[i][j];
            }
        }
        return i;
    };
    for (int qi = 0; qi < q; ++qi) {
        int k, i; cin >> k >> i;
        if (i <= 5) {
            int cur = 0; --i; int ans = a[0];
            while (i >= 0) {
                if (k == 1) {
                    ans = mxs[cur];
                    break;
                } else {
                    if (gr[cur] >= 3 && i >= 2) {
                        int y = min(gr[cur], i);
                        k -= y;
                        i -= y;
                        cur += y;
                        ans = a[cur - 1];
                        continue;
                    }
                    if (a[cur] < a[cur + 1] || n - cur == k) {
                        ans = a[cur];
                        ++cur;
                        --k, --i;
                        continue;
                    }
                    if (k == 2) {
                        ans = a[cur];
                        cur = min(mr[cur], n - 1);
                        --i, --k;
                        continue;
                    }
                    int r = min(mr[cur], n - k + 2);
                    auto [mn, j] = t.query(cur + 1, r);
                    ans = a[cur];
                    cur = j;
                    --k, --i;
                }
            }
            cout << ans << '\n';
        } else {
            --i;
            int l = 0, r = i - 3;
            while (r - l > 1) {
                int m = (l + r) / 2;
                int j = la(0, m);
                if (j != n && n - j >= (k - m)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            i -= l;
            int cur = la(0, l);
            int ans = a[cur];
            k -= l;

            while (i >= 0) {
                if (k == 1) {
                    ans = mxs[cur];
                    break;
                } else {
                    if (gr[cur] >= 3 && i >= 2) {
                        int y = min(gr[cur], i);
                        k -= y;
                        i -= y;
                        cur += y;
                        ans = a[cur - 1];
                        continue;
                    }
                    if (a[cur] < a[cur + 1] || n - cur == k) {
                        ans = a[cur];
                        ++cur;
                        --k, --i;
                        continue;
                    }
                    if (k == 2) {
                        ans = a[cur];
                        cur = min(mr[cur], n - 1);
                        --i, --k;
                        continue;
                    }
                    int r = min(mr[cur], n - k + 2);
                    auto [mn, j] = t.query(cur + 1, r);
                    ans = a[cur];
                    cur = j;
                    --k, --i;
                }
            }
            cout << ans << '\n';
        }
    }
}

signed main(void) {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0), cout.tie(0);
    solve();
}