#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct Point {
    ll x, y;
};

ll n, r;
vector<Point> points;

vector<vector<ll>> g;


vector<ll> color;

vector<ll> used_now;

bool find_cicl(ll now) {
    used_now.push_back(now);

    bool ans_now = false;

    for (ll to : g[now]) {
        if (color[to] == -1) {
            color[to] = 1 - color[now];
            if (find_cicl(to)) {
                ans_now = true;
            }
        } else {
            if (color[to] == color[now]) {
                ans_now = true;
            }
        }
    }

    return ans_now;
}

vector<bool> is_cicl;

void solve() {
    cin >> n >> r;

    map<pair<ll, ll>, ll> which_point;

    points.clear();
    points.resize(n);
    for (ll now = 0; now < n; now++) {
        cin >> points[now].x >> points[now].y;

        which_point[{points[now].x, points[now].y}] = now;
    }

    g.clear();
    g.resize(n);
    for (ll now = 0; now < n; now++) {
        for (ll x = points[now].x - r; x <= points[now].x + r; x++) {
            for (ll y = points[now].y - r; y <= points[now].y + r; y++) {
                if (x != points[now].x || y != points[now].y) {
                    if ((x - points[now].x) * (x - points[now].x) + (y - points[now].y) * (y - points[now].y) <= r * r) {
                        if (which_point.count({x, y})) {
                            g[now].push_back(which_point[{x, y}]);
                        }
                    }
                }
            }
        }
    }


    color.clear();
    color.resize(n, -1);

    is_cicl.clear();
    is_cicl.resize(n, false);
    for (ll i = 0; i < n; i++) {
        if (color[i] == -1) {
            used_now.clear();

            color[i] = 0;
            if (find_cicl(i)) {
                for (ll now : used_now) {
                    is_cicl[now] = true;
                }
            }
        }
    }

    for (ll i = 0; i < n; i++) {
        if (is_cicl[i]) {
            cout << "1";
        } else {
            cout << "0";
        }
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);


    solve();
    cout << endl;
    return 0;
}
