#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct Segment_tree {
    struct Node {
        ll mi;
        ll ind_mi;

        ll ma;
        ll ind_ma;

        ll l, r;
    };

    ll n;
    vector<ll> a;
    vector<Node> nodes;
    ll root;

    void pull(ll now) {
        if (nodes[nodes[now].l].mi < nodes[nodes[now].r].mi) {
            nodes[now].mi = nodes[nodes[now].l].mi;
            nodes[now].ind_mi = nodes[nodes[now].l].ind_mi;
        } else {
            nodes[now].mi = nodes[nodes[now].r].mi;
            nodes[now].ind_mi = nodes[nodes[now].r].ind_mi;
        }

        if (nodes[nodes[now].l].ma > nodes[nodes[now].r].ma) {
            nodes[now].ma = nodes[nodes[now].l].ma;
            nodes[now].ind_ma = nodes[nodes[now].l].ind_ma;
        } else {
            nodes[now].ma = nodes[nodes[now].r].ma;
            nodes[now].ind_ma = nodes[nodes[now].r].ind_ma;
        }
    }

    ll build(ll l, ll r) {
        ll now = nodes.size();
        nodes.push_back({});

        if (l == r - 1) {
            nodes[now].mi = a[l];
            nodes[now].ind_mi = l;
            nodes[now].ma = a[l];
            nodes[now].ind_ma = l;
        } else {
            ll mid = (l + r) / 2;

            nodes[now].l = build(l, mid);
            nodes[now].r = build(mid, r);

            pull(now);
        }

        return now;
    }

    Segment_tree(ll n_, vector<ll> a_) {
        n = n_;
        a = a_;

        root = build(0, n);
    }

    pair<ll, ll> get_mi(ll now, ll l, ll r, ll ql, ll qr) {
        if (qr <= l || r <= ql) {
            return {n + 1, -1};
        }

        if (ql <= l && r <= qr) {
            return {nodes[now].mi, nodes[now].ind_mi};
        }

        ll mid = (l + r) / 2;

        auto [mi_1, ind_mi_1] = get_mi(nodes[now].l, l, mid, ql, qr);
        auto [mi_2, ind_mi_2] = get_mi(nodes[now].r, mid, r, ql, qr);

        if (mi_1 < mi_2) {
            return {mi_1, ind_mi_1};
        } else {
            return {mi_2, ind_mi_2};
        }
    }

    pair<ll, ll> get_mi(ll ql, ll qr) {
        return get_mi(root, 0, n, ql, qr);
    }


    pair<ll, ll> get_ma(ll now, ll l, ll r, ll ql, ll qr) {
        if (qr <= l || r <= ql) {
            return {0, -1};
        }

        if (ql <= l && r <= qr) {
            return {nodes[now].ma, nodes[now].ind_ma};
        }

        ll mid = (l + r) / 2;

        auto [ma_1, ind_ma_1] = get_ma(nodes[now].l, l, mid, ql, qr);
        auto [ma_2, ind_ma_2] = get_ma(nodes[now].r, mid, r, ql, qr);

        if (ma_1 > ma_2) {
            return {ma_1, ind_ma_1};
        } else {
            return {ma_2, ind_ma_2};
        }
    }

    pair<ll, ll> get_ma(ll ql, ll qr) {
        return get_ma(root, 0, n, ql, qr);
    }
};

ll n, q;
vector<ll> a;

vector<ll> near_bigger_right;
Segment_tree seg_tree = Segment_tree(1, {1});

map<ll, vector<ll>> ans;

void calc_ans(ll k) {
    vector<ll> ans_now(k);
    if (k == 1) {
        ans_now[0] = seg_tree.get_ma(0, n).first;
    } else {
        ll now = 0;
        for (ll i = 0; i < k - 2; i++) {
            ans_now[i] = a[now];

            auto [mi, next] = seg_tree.get_mi(now + 1, min(near_bigger_right[now], n - 1 - (k - i - 1 - 1)) + 1);

            now = next;
        }

        ans_now[k - 2] = a[now];
        ans_now[k - 1] = seg_tree.get_ma(near_bigger_right[now], n).first;
    }

    ans[k] = ans_now;
}

void get_ans(ll k, ll ind) {
    if (!ans.count(k)) {
        calc_ans(k);
    }

    cout << ans[k][ind] + 1 << '\n';
}

void solve() {
    cin >> n >> q;

    a.clear();
    a.resize(n);
    for (ll& now : a) {
        cin >> now;
        now--;
    }

    near_bigger_right.clear();
    near_bigger_right.resize(n);
    vector<pair<ll, ll>> st;
    st.push_back({n, n - 1});
    for (ll i = n - 1; i >= 0; i--) {
        while (st.back().first < a[i]) {
            st.pop_back();
        }

        near_bigger_right[i] = st.back().second;

        st.push_back({a[i], i});
    }


    seg_tree = Segment_tree(n, a);

    for (ll t = 0; t < q; t++) {
        ll k, ind;
        cin >> k >> ind;
        ind--;

        get_ans(k, ind);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);


    solve();
    cout << endl;
    return 0;
}
