#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>

using namespace std;

#define ll long long

vector<pair<set<ll>, ll>> gr;
vector<bool> used;
vector<bool> used1;

void dfs(ll v) {
    used1[v] = true;
    used[v] = true;
    for (auto elem : gr[v].first) {
        if (!used1[elem]) {
            dfs(elem);
        }
    }
}

bool cmp(const ll &ind1, const ll &ind2) {
    return gr[ind1].first.size() < gr[ind2].first.size();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    map<ll, vector<pair<ll, ll>>> m1;
    vector<ll> c;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        m1[a[i].first].push_back({a[i].second, i});
        c.push_back(a[i].first);
    }
    for (auto elem : m1) {
        sort(m1[elem.first].begin(), m1[elem.first].end());
    }
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());
    gr.resize(n);
    for (ll i = 0; i < n; i++) {
        gr[i].second = i;
        ll ind1 = lower_bound(c.begin(), c.end(), a[i].first) - c.begin();
        for (ll j = ind1; j < c.size(); j++) {
            if ((a[i].first - c[j]) * (a[i].first - c[j]) > r * r) {
                break;
            }
            ll x1 = r * r - (a[i].first - c[j]) * (a[i].first - c[j]);
            ll y1 = sqrt(x1);
            while (y1 * y1 > x1) {
                y1--;
            }
            while ((y1 + 1) * (y1 + 1) <= x1) {
                y1++;
            }
            ll l1 = -1;
            ll r1 = m1[c[j]].size() - 1;
            while (r1 - l1 > 1) {
                ll m = (l1 + r1) / 2;
                if (m1[c[j]][m].first - a[i].second >= -y1) {
                    r1 = m;
                } else {
                    l1 = m;
                }
            }
            for (ll j1 = r1; j1 < m1[c[j]].size(); j1++) {
                pair<ll, ll> elem = m1[c[j]][j1];
                ll x = (a[i].first - a[elem.second].first) * (a[i].first - a[elem.second].first) + (a[i].second - a[elem.second].second) * (a[i].second - a[elem.second].second);
                if (x <= r * r) {
                    gr[i].first.insert(elem.second);
                    gr[elem.second].first.insert(i);
                } else {
                    break;
                }
            }
        }
    }
    used.resize(n);
    vector<ll> ind(n);
    for (ll i = 0; i < n; i++) {
        ind[i] = i;
    }
    sort(ind.begin(), ind.end(), cmp);
    vector<set<ll>> gr2(n);
    for (ll i = 0; i < n; i++) {
        for (auto elem : gr[i].first) {
            if (ind[i] < ind[elem]) {
                gr2[i].insert(elem);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        ll v1 = ind[i];
        for (auto v2 : gr2[v1]) {
            for (auto elem : gr2[v2]) {
                if (gr2[v1].find(elem) != gr2[v1].end()) {
                    used[v1] = true;
                    used[v2] = true;
                    used[elem] = true;
                    break;
                }
            }
        }
    }
    used1.resize(n);
    for (ll i = 0; i < n; i++) {
        if (used[i] && !used1[i]) {
            dfs(i);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            cout << 0;
        } else {
            cout << 1;
        }
    }
}