#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

using namespace std;

#define ll long long

vector<pair<set<ll>, ll>> gr;
vector<bool> used;
vector<bool> used1;

void dfs(ll v) {
    used1[v] = true;
    used[v] = true;
    for (auto elem : gr[v].first) {
        if (!used1[elem]) {
            dfs(elem);
        }
    }
}

bool cmp(const ll &ind1, const ll &ind2) {
    return gr[ind1].first.size() < gr[ind2].first.size();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    gr.resize(n);
    for (ll i = 0; i < n; i++) {
        gr[i].second = i;
        for (ll j = i + 1; j < n; j++) {
            ll x = (a[i].first - a[j].first) * (a[i].first - a[j].first) + (a[i].second - a[j].second) * (a[i].second - a[j].second);
            if (x <= r * r) {
                gr[i].first.insert(j);
                gr[j].first.insert(i);
            }
        }
    }
    used.resize(n);
    vector<ll> ind(n);
    for (ll i = 0; i < n; i++) {
        ind[i] = i;
    }
    sort(ind.begin(), ind.end(), cmp);
    vector<set<ll>> gr2(n);
    for (ll i = 0; i < n; i++) {
        for (auto elem : gr[i].first) {
            if (ind[i] < ind[elem]) {
                gr2[i].insert(elem);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        ll v1 = ind[i];
        for (ll j = i + 1; j < n; j++) {
            ll v2 = ind[j];
            for (auto elem : gr2[v2]) {
                if (gr2[v1].find(elem) != gr2[v1].end()) {
                    used[v1] = true;
                    used[v2] = true;
                    used[elem] = true;
                }
            }
        }
    }
    used1.resize(n);
    for (ll i = 0; i < n; i++) {
        if (used[i] && !used1[i]) {
            dfs(i);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            cout << 0;
        } else {
            cout << 1;
        }
    }
}