#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>

using namespace std;

#define ll long long

vector<pair<set<ll>, ll>> gr;
vector<bool> used;
vector<bool> used1;

void dfs(ll v) {
    used1[v] = true;
    used[v] = true;
    for (auto elem : gr[v].first) {
        if (!used1[elem]) {
            dfs(elem);
        }
    }
}

bool cmp(const ll &ind1, const ll &ind2) {
    return gr[ind1].first.size() < gr[ind2].first.size();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> a(n);
    map<pair<ll, ll>, ll> m1;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        m1[a[i]] = i;
    }
    gr.resize(n);
    for (ll i = 0; i < n; i++) {
        gr[i].second = i;
        for (ll j = -r; j <= r; j++) {
            for (ll j1 = -r; j1 <= r; j1++) {
                ll x1 = a[i].first + j;
                ll y1 = a[i].second + j1;
                ll x = (x1 - a[i].first) * (x1 - a[i].first) + (y1 - a[i].second) * (y1 - a[i].second);
                if (m1.find({x1, y1}) != m1.end() && x <= r * r && (j != 0 || j1 != 0)) {
                    gr[i].first.insert(m1[{x1, y1}]);
                    gr[m1[{x1, y1}]].first.insert(i);
                }
            }
        }
    }
    used.resize(n);
    vector<ll> ind(n);
    for (ll i = 0; i < n; i++) {
        ind[i] = i;
    }
    sort(ind.begin(), ind.end(), cmp);
    vector<set<ll>> gr2(n);
    for (ll i = 0; i < n; i++) {
        for (auto elem : gr[i].first) {
            if (ind[i] < ind[elem]) {
                gr2[i].insert(elem);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        ll v1 = ind[i];
        ll f1 = 0;
        for (auto v2 : gr2[v1]) {
            for (auto elem : gr2[v2]) {
                if (gr2[v1].find(elem) != gr2[v1].end()) {
                    used[v1] = true;
                    used[v2] = true;
                    used[elem] = true;
                    f1 = 1;
                    break;
                }
            }
            if (f1 == 1) {
                break;
            }
        }
    }
    used1.resize(n);
    for (ll i = 0; i < n; i++) {
        if (used[i] && !used1[i]) {
            dfs(i);
        }
    }
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            cout << 0;
        } else {
            cout << 1;
        }
    }
}