#include<iostream>
#include<algorithm>
#include<stack>
#include<vector>

using namespace std;

#define ll long long

const ll maxn = 5 * 1e5;
const ll maxl = 20;
pair<ll, ll> sparse[maxl][maxn];
pair<ll, ll> sparse1[maxl][maxn];
ll log1[maxn];

pair<ll, ll> max1(ll l, ll r) {
    ll l1 = log1[r - l + 1];
    return max(sparse[l1][l], sparse[l1][r - (1 << l1) + 1]);
}

pair<ll, ll> min1(ll l, ll r) {
    ll l1 = log1[r - l + 1];
    return min(sparse1[l1][l], sparse1[l1][r - (1 << l1) + 1]);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    log1[0] = -1;
    for (ll i = 1; i < maxn; i++) {
        log1[i] = log1[i / 2] + 1;
    }
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> ind1(n, n);
    stack<pair<ll, ll>> s1;
    for (ll i = n - 1; i >= 0; i--) {
        if (s1.empty()) {
            s1.push({a[i], i});
        } else {
            while (!s1.empty() && s1.top().first <= a[i]) {
                s1.pop();
            }
            if (!s1.empty()) {
                ind1[i] = s1.top().second;
            }
            s1.push({a[i], i});
        }
    }
    for (ll i = 0; i < n; i++) {
        sparse[0][i] = {a[i], i};
    }
    for (ll l = 1; (1 << l) <= n; l++) {
        for (ll i = 0; i + (1 << l) - 1 < n; i++) {
            sparse[l][i] = max(sparse[l - 1][i], sparse[l - 1][i + (1 << (l - 1))]);
        }
    }
    for (ll i = 0; i < n; i++) {
        sparse1[0][i] = {a[i], i};
    }
    for (ll l = 1; (1 << l) <= n; l++) {
        for (ll i = 0; i + (1 << l) - 1 < n; i++) {
            sparse1[l][i] = min(sparse1[l - 1][i], sparse1[l - 1][i + (1 << (l - 1))]);
        }
    }
    vector<vector<ll>> c1(n);
    for (ll i = 0; i < n; i++) {
        vector<ll> c2;
        ll ind = 0;
        for (ll j = 0; j <= i; j++) {
            if (i == j) {
                c2.push_back(max1(ind, n - 1).first);
                break;
            } else {
                ll ind2 = ind1[ind] - 1;
                ind2 = min(ind2, n - (i - j));
                if (ind2 <= ind) {
                    c2.push_back(a[ind]);
                    ind++;
                    continue;
                }
                pair<ll, ll> p1 = min1(ind + 1, ind2);
                c2.push_back(a[ind]);
                ind = p1.second;
            }
        }
        c1[i] = c2;
    }
    while (q--) {
        ll k, ind;
        cin >> k >> ind;
        k--;
        ind--;
        cout << c1[k][ind] << '\n';
    }
}