#include <iostream>
#include<vector>
#include<string>
#include <set>
#include <array>
//define int long long
#define ll long long
using namespace std;
#pragma GCC optimize("unroll-loops, O3")
#pragma GCC target("avx2")
const int nax = 2e6 + 5;
struct node {
	node* l = NULL, * r = NULL;
	int val = 0;
	node() {}
	node(node* v) {
		l = v->l;
		r = v->r;
		val = v->val;
	}
};
int val(node* v) {
	if (v)return v->val;
	else return 0;
}
void build(node* v, int tl, int tr, int pos, int x) {
	if (tl == tr) {
		
	}
	else {
		int tm = (tl + tr) / 2;
		v->l = new node();
		v->r = new node();
		build(v->l, tl, tm, pos, x);
		build(v->r, tm + 1, tr, pos, x);
	}
}
node* update(node* V, int tl, int tr, int pos, int x) {
	node* v = new node(V);
	if (tl == tr) {
		v->val += x;
	}
	else {
		int tm = (tl + tr) / 2;
		if (pos <= tm) {
			v->l = update(v->l, tl, tm, pos, x);
		}
		else {
			v->r = update(v->r, tm + 1, tr, pos, x);
		}
		v->val = val(v->l) + val(v->r);
	}
	return v;
}
int query(node* v, int tl, int tr, int l, int r) {
	if (l > r) {
		return 0;
	}
	if (tl == l && tr == r) {
		return v->val;
	}
	else {
		int tm = (tl + tr) / 2;
		return query(v->l, tl, tm, l, min(tm, r)) + query(v->r, tm + 1, tr, max(tm + 1, l), r);
	}
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> v(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> v[i][j];
		}
	}
	vector<vector<node*>> tr(n + 1, vector<node*>(m + 1, new node()));
	build(tr[n][m - 1], 0, nax - 1, 0, nax - 1);
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			cout << i << " " << j << " ";
			tr[i][j] = update(tr[i + 1][j], 0, nax - 1, v[i][j], 1);
			cout << query(tr[i][j], 0, nax - 1, 0, nax - 1) << "\n";
		}
	}
	vector<vector<ll>> dp(n + 1, vector<ll>(m + 1));
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			ll res1 = 0;
			for (int k = j; k < m; k++) {
				res1 += query(tr[i + 1][j], 0, nax - 1, v[i][k] + 1, nax - 1);
			}
			ll res2 = 0;
			for (int k = i; k < n; k++) {
				res1 += query(tr[i][j + 1], 0, nax - 1, v[k][j] + 1, nax - 1);
			}
			dp[i][j] = min(dp[i + 1][j] + res1, dp[i][j + 1] + res2);
		}
	}
	cout << dp[0][0];
}