#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <map>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, r;
    cin >> n >> r;
    vector<point> p(n);
    vector<int> X(n), Y(n);
    map<pair<int, int>, int> cnt;
    map<pair<int, int>, vector<int>> ls;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        X[i] = p[i].x/r;
        Y[i] = p[i].y/r;
        cnt[{X[i], Y[i]}]++;
        ls[{X[i], Y[i]}].push_back(i);
    }
    vector<bool> srazy_naxuy(n, false);
    for (int i = 0; i < n; i++) {
        if (cnt[{X[i], Y[i]}] > 20) {
            srazy_naxuy[i] = true;
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        if (!srazy_naxuy[i]) {
            for (int a = -3; a <= 3; a++) {
                for (int b = -3; b <= 3; b++) {
                    int x = X[i] + a;
                    int y = Y[i] + b;
                    for (auto& ind : ls[{x,y}]) {
                        if (ind != i) {
                            auto[xx,yy] = p[ind];
                            if (power2(xx-p[i].x)+power2(yy-p[i].y) <= power2(r)) {
                                g[i].push_back(ind);
                                g[ind].push_back(i);
                            }
                        }
                    }
                }
            }
        }
    }
    vector<bool> t = srazy_naxuy;
    for (int i = 0; i < n; i++) {
        if (t[i] == 1) continue;
        map<int, int> color;
        function<void(int)> dfs = [&](int v) {
            if (t[v]) t[i] = 1;
            for (auto& to : g[v]) {
                if (!color.contains(to)) {
                    color[to] = !color[v];
                    dfs(to);
                } else {
                    if (color[to] == color[v]) {
                        t[i] = 1;
                    }
                }
            }
        };
        color[i]=0;
        dfs(i);
        function<void(int)> dfs2 = [&](int v) {
          for (auto& to : g[v]) {
              if (t[to] == 0) {
                  t[to] = 1;
                  dfs2(to);
              }
          }
        };
        if (t[i] == 1)
            dfs2(i);
    }
    for (int i = 0; i < n; i++) {
        cout << t[i];
    }
}