#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, r;
    cin >> n >> r;
    vector<vector<int>> g(n);
    vector<point> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (power2(p[i].x-p[j].x) + power2(p[i].y-p[j].y) <= power2(r)) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        vector<int> color(n, -1);
        bool ch = true;
        function<void(int)> dfs = [&](int v) {
            for (auto& to : g[v]) {
                if (color[to] == -1) {
                    color[to] = color[v] ^ 1;
                    dfs(to);
                } else {
                    if (color[to] == color[v]) {
                        ch = false;
                    }
                }
            }
        };
        color[i] = 0;
        dfs(i);
        cout << !ch;
    }
    cout << '\n';
}