#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <assert.h>
#include <map>
#include <functional>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, r;
    cin >> n >> r;
    assert(r<=2);
    vector<vector<int>> g(n);
    vector<point> p(n);
    map<pair<int, int>, int> ind;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        ind[{p[i].x,p[i].y}]=i;
    }
    for (int i = 0; i < n; i++) {
        const int D=2;
        for (int x = p[i].x-D; x <= p[i].x+D; x++) {
            for (int y = p[i].y-D; y <= p[i].y+D; y++) {
                if (ind.contains({x,y}) && power2(x-p[i].x)+power2(y-p[i].y) <= power2(r)) {
                    if (ind[{x,y}]!=i) {
                        g[i].push_back(ind[{x,y}]);
                        g[ind[{x,y}]].push_back(i);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        set<int> s(g[i].begin(),g[i].end());
        g[i]=vector<int>(s.begin(),s.end());
        assert(g[i].size()<=20);
    }
    vector<int> used(n);
    vector<int> ans(n);
    vector<int> color(n, -1);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        bool ch = true;
        function<void(int)> dfs = [&](int v) {
            for (auto& to : g[v]) {
                if (color[to] == -1) {
                    color[to] = color[v] ^ 1;
                    dfs(to);
                } else {
                    if (color[to] == color[v]) {
                        ch = false;
                    }
                }
            }
        };
        color[i]=0;
        dfs(i);
        ans[i]=!ch;
        function<void(int)> dfs2 = [&](int v) {
            used[v] = true;
            ans[v] = ans[i];
            for (auto& to : g[v]) {
                if (!used[to]) {
                    dfs2(to);
                }
            }
        };
        dfs2(i);
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << '\n';
}