#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <assert.h>
#include <map>
#include <functional>
#define mp make_pair

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

long long power2(long long x) {
    return x * x;
}

bool cmpX(point i, point j) {
    return i.x < j.x;
}

long long F(pair<long long, long long> p) {
    return p.first * 1e9 + p.second;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, r;
    cin >> n >> r;
    assert(r<=5);
    vector<vector<int>> g(n);
    vector<point> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    sort(p.begin(), p.end(), cmpX);
    const int D = 5;
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (abs(p[j].x-p[i].x)>D) break;
            if (power2(p[i].x-p[j].x)+power2(p[i].y-p[j].y) <= power2(r)) {
                g[i].push_back(j);
            }
        }
        for (int j = i + 1; j < n; j++) {
            if (abs(p[j].x-p[i].x)>D)break;
            if (power2(p[i].x-p[j].x)+power2(p[i].y-p[j].y) <= power2(r)) {
                g[i].push_back(j);
            }
        }
    }
    vector<int> used(n);
    vector<int> ans(n);
    vector<int> color(n, -1);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        bool ch = true;
        function<void(int)> dfs = [&](int v) {
            for (auto& to : g[v]) {
                if (color[to] == -1) {
                    color[to] = color[v] ^ 1;
                    dfs(to);
                } else {
                    if (color[to] == color[v]) {
                        ch = false;
                    }
                }
            }
        };
        color[i]=0;
        dfs(i);
        ans[i]=!ch;
        function<void(int)> dfs2 = [&](int v) {
            used[v] = true;
            ans[v] = ans[i];
            for (auto& to : g[v]) {
                if (!used[to]) {
                    dfs2(to);
                }
            }
        };
        dfs2(i);
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i];
    }
    cout << '\n';
}