#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <map>
#include <climits>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}


struct fenwick {
    vector<int> t;
    int n;
    fenwick(int n) : n(n) {
        t.resize(n);
    }
    void modify(int i, int val) {
        while (i < n) {
            t[i] += val;
            i += i&-i;
        }
    }
    int get(int i) {
        int res=0;
        while (i) {
            res += t[i];
            i -= i&-i;
        }
        return res;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    int ans = LLONG_MAX;
    vector<int> pot = {0,(1 << (n+m))-1};
    const int MAX = n*m+11;
    for (int mask : pot) {
        vector<int> b;
        int ptr1 = 0, ptr2 = 0;
        for (int i = 0; i < n+m; i++) {
            if (ptr1 == n || ptr2 == m) continue;
            if ((mask >> i) & 1) {
                for (int j = ptr2; j < m; j++) b.push_back(a[ptr1][j]);
                ptr1++;
            } else {
                for (int j = ptr1; j < n; j++) b.push_back(a[j][ptr2]);
                ptr2++;
            }
        }
        int inv = 0;
        fenwick f(MAX);
        int last=0;
        for (int x : b) {
            inv += (last++)-f.get(x);
            f.modify(x,1);
        }
        ans=min(ans,inv);
    }
    cout << ans << '\n';
}