#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <map>
#include <climits>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(m + 1,LLONG_MAX));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            {
                vector<int> b;
                for (int k = j; k < m; k++) b.push_back(a[i][k]);
                int add = 0;
                for (int z = 0; z < b.size(); z++) {
                    for (int zz = z - 1; zz >= 0; zz--) {
                        if (b[z] < b[zz]) add++;
                    }
                }
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < m; y++) {
                        if (x < i || y < j) {
                            for (auto& z : b) {
                                if (z < a[x][y]) {
                                    add++;
                                }
                            }
                        }
                    }
                }
                dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + add);
            }
            {
                vector<int> b;
                for (int k = i; k < n; k++) b.push_back(a[k][j]);
                int add = 0;
                for (int z = 0; z < b.size(); z++) {
                    for (int zz = z - 1; zz >= 0; zz--) {
                        if (b[z] < b[zz]) add++;
                    }
                }
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < m; y++) {
                        if (x < i || y < j) {
                            for (auto& z : b) {
                                if (z < a[x][y]) {
                                    add++;
                                }
                            }
                        }
                    }
                }
                dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + add);
            }
        }
    }
    int ans = LLONG_MAX;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            if (i == n || j == m) {
                ans = min(ans, dp[i][j]);
            }
        }
    }
    cout << ans << '\n';
}