#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <map>
#include <climits>
#include <assert.h>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

struct fenwick {
    vector<int> t;
    int n;
    fenwick(int n) : n(n) {
        t.resize(n);
    }
    void modify(int i, int val) {
        while (i < n) {
            t[i] += val;
            i += i&-i;
        }
    }
    int get(int i) {
        int res=0;
        while (i) {
            res += t[i];
            i -= i&-i;
        }
        return res;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    assert(n==1);
    const int MAX = n*m+11;
    fenwick f(MAX);
    int ans = 0;
    for (int i = 0; i < m; i++) {
        int x = a[0][i];
        ans += i-f.get(x);
        f.modify(x,1);
    }
    cout << ans << '\n';
}