#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <map>
#include <climits>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

struct fenwick {
    unordered_map<int, int> t;
    int n;
    fenwick(int n) : n(n) {
    }
    void modify(int i, int val) {
        while (i < n) {
            t[i] += val;
            i += i&-i;
        }
    }
    int get(int i) {
        int res=0;
        while (i) {
            res += t[i];
            i -= i&-i;
        }
        return res;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> gr(n);
    vector<int> st;
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && a[st.back()] < a[i]) st.pop_back();
        gr[i] = (st.empty() ? n - 1 : st.back() - 1);
        st.push_back(i);
    }
    while (q--) {
        int k,i;
        cin >> k >> i;
        i--;
        vector<int> b;
        int ptr = 0;
        for (int j = 0; j < k; j++) {
            int g = min(gr[ptr], n-(k-j));
            if (j == k - 1) {
                g = n-1;
            }
            int mx = 0;
            for (int z = ptr; z <= g; z++) mx=max(mx,a[z]);
            b.push_back(mx);
            if (ptr + 1 + 1 <= g + 2) {
                auto mn = min_element(a.begin() + ptr + 1, a.begin() + g + 2);
                ptr = (mn-a.begin());
            } else {
                ptr++;
            }
        }
        cout << b[i] << '\n';
    }
}