#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <map>
#include <assert.h>
#include <climits>
#define int long long

using namespace std;

struct point {
    int x, y;
    point() = default;
    point(int x, int y) : x(x), y(y) {}
};

int power2(int x) {
    return x * x;
}

struct fenwick {
    unordered_map<int, int> t;
    int n;
    fenwick(int n) : n(n) {
    }
    void modify(int i, int val) {
        while (i < n) {
            t[i] += val;
            i += i&-i;
        }
    }
    int get(int i) {
        int res=0;
        while (i) {
            res += t[i];
            i -= i&-i;
        }
        return res;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input", "r", stdin);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> b(2, n);
    vector<int> suf(n);
    suf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = max(a[i], suf[i + 1]);
    }
    int mx = 0;
    for (int i = 0; i + 1 < n; i++) {
        mx = max(mx, a[i]);
        vector<int> res(2);
        res[0] = mx;
        res[1] = suf[i+1];
        b = min(b, res);
    }/*
    vector<vector<int>> ans(n+1, vector<int>(n,n));
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> b(n,0);
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) b[i] = 1;
        }
        if (b[0] != 1) continue;
        vector<int> res;
        int c = __builtin_popcount(mask);
        int mx = 0;
        for (int i = 0; i < n; i++) {
            if (i > 0 && b[i] == 1) {
                res.push_back(mx);
                mx = a[i];
            } else {
                mx = max(mx, a[i]);
            }
        }
        res.push_back(mx);
        ans[c] = min(ans[c], res);
    }*/
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        assert(k==2);
        cout << b[i] << '\n';
    }
}