#include <bits/stdc++.h>

using namespace std;
#define int long long

struct point {
    int x;
    int y;
    int ind;

    bool operator< (point p2) {
        if (x * x + y * y == p2.x * p2.x + p2.y * p2.y)
            return ind < p2.ind;
        return x * x + y * y < p2.x * p2.x + p2.y * p2.y;
    }

    long double operator- (point p2) {
        return sqrtl(x * x + y * y) - sqrtl(p2.x * p2.x + p2.y * p2.y);
    }

    int operator* (point p2) {
        return (x - p2.x) * (x - p2.x) + (y - p2.y) * (y - p2.y);
    }
};

int flag = 0;
void dfs(int v, vector<vector<int>> &gr, vector<int> &used) {
    if (used[v] == -1)
        used[v] = 0;
    for (int u: gr[v]) {
        if (used[u] == -1) {
            used[u] = (used[v] + 1) % 2;
            dfs(u, gr, used);
        } else if (used[u] == used[v])
            flag = 1;
    }
}

void solve() {
    int n, rad;
    cin >> n >> rad;
    vector<point> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
        p[i].ind = i;
    }
    sort(p.begin(), p.end());

    vector<vector<int>> gr(n);
    vector<int> ans(n, 0);
    int last = -1;
    for (int i = 0; i < n; ++i) {
        int l = -1, r = i;
        while (r - l > 1) {
            int mid = (r + l) / 2, lol = p[i] - p[mid];
            if (lol > rad)
                l = mid;
            else
                r = mid;
        }
        if (i - r > 1 || (i - r == 1 && ans[i - 1])) {
            for (int j = max(last + 1, r); j <= i; ++j)
                ans[j] = 1;
            last = i;
        }
    }
    for (int i = 0; i < n; ++i) {
        int l = -1, r = i;
        while (r - l > 1) {
            int mid = (r + l) / 2, lol = p[i] - p[mid];
            if (lol > rad)
                l = mid;
            else
                r = mid;
        }
        if (i - r == 1 && ans[i]) {
            ans[i - 1] = 1;
        }
    }
    /*
    for (int i = 0; i < n; ++i) {
        vector<int> used(n, -1);
        flag = 0;
        dfs(i, gr, used);
        ans[p[i].ind] = flag;
    }
    */
    for (int x: ans)
        cout << x;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
        cout << '\n';
    }
}
