#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll maxn = 1e5+5;
const ll INF = 3e18;

vector<vector<ll>> ans(maxn);

struct SegTree {
    vector<ll>t;
    ll n;

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (l >= qr || r <= ql) {
            return INF;
        }
        if (l >= ql && r <= qr) {
            return t[v];
        }
        ll m = (l + r)/2;
        return min(get(v*2+1, l,m, ql, qr), get(v*2+2, m, r, ql, qr));
    }

    void build(ll v, ll l, ll r, vector<ll>&a) {
        if (r - l == 1){
            t[v] = a[l];
            return;
        }
        ll m = (l + r)/2;
        build(v*2+1, l, m, a);
        build(v*2+2, m, r,a);
        t[v] = min(t[v*2+1], t[v*2+2]);
    }

    SegTree(vector<ll>& a) : n(a.size()) {
        t.resize(n*4);
        build(0, 0, n, a);
    }
};

void calc(ll k, vector<ll>&nx, vector<ll>&suf, vector<ll>&a, vector<ll>&ind, SegTree& st) {
    vector<ll> res;
    res.push_back(a[0]);
    ll cur = 1;
    for (int i = 2; i <= k; ++i) {
        if (i == k) {
            res.push_back(suf[min(nx[cur-1], (ll)a.size()-1)]);
        } else {
            res.push_back(st.get(0, 0,a.size(), cur, min(nx[cur-1]+1, (ll)a.size() - (k-i))));
            cur = ind[res.back()]+1;
        }
    }
    ans[k-1] = res;
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    vector<ll>ind(n+1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ind[a[i]] = i;
    }
    SegTree segt(a);
    vector<ll> suf(n);
    vector<ll> nx(n);
    vector<pair<ll,ll>> st;
    st.push_back({n+1, n});
    nx[n-1] = n;
    st.push_back({a[n-1], n-1});
    suf[n-1] = a[n-1];
    for (int i = n-2; i >=0; --i) {
        suf[i] = max(suf[i+1], a[i]);
        while (st.back().first <= a[i]) {
            st.pop_back();

        }
        nx[i] = st.back().second;
        st.push_back({a[i], i});
    }
    for (int i = 0; i < q; ++i) {
        ll k, c;
        cin >> k >> c;
        if (ans[k-1].size() != 0) {
            cout << ans[k-1][c-1] << '\n';
        } else if (k == 1) {
            cout << n << '\n';
        } else if (k == n) {
            cout << a[c-1] << '\n';
        } else {
            calc(k, nx, suf, a, ind, segt);
            cout << ans[k-1][c-1] << '\n';
        }
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("C:\\work\\CLionProjects\\untitled\\in.txt", "r", stdin);
    // freopen("C:\\work\\CLionProjects\\untitled\\out.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--){}
    solve();
    cout << '\n';

}

