#include <bits/stdc++.h>

#define int __int128
#define MOD 1000000007

using namespace std;

vector<bool> used;
vector<vector<int>> g;
vector<int> color;

bool dfsColor(int i, vector<int> &st) {
	used[i] = 1;
	st.push_back(i);
	bool ok = true;
	for(auto x : g[i]) {
		if(color[x] == color[i]) ok = 0;
		if(used[x]) continue;
		color[x] = 1 - color[i];
		if(dfsColor(x, st)) ok = 0;
	}
	return !ok;
}

void dfs(int i, vector<int> &st) {
	used[i] = 1;
	st.push_back(i);
	for(auto x : g[i]) {
		if(!used[x])
			dfs(x, st);
	}
}

vector<bool> slowSolve(int n, int r, vector<pair<int, int>> v) {
	g = vector<vector<int>> (n);
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) {
			if(i == j) continue;
			int dx = v[i].first - v[j].first;
			int dy = v[i].second - v[j].second;
			if(dx * dx + dy * dy <= r * r) g[i].push_back(j);
		}
	}

	vector<bool> ans(n);
	used = vector<bool> (n);
	color = vector<int> (n, -1);
	for(int i = 0; i < n; i++) {
		if(used[i]) continue;
		vector<int> curr;
		color[i] = 0;
		//cout << i << endl;
		if(dfsColor(i, curr)) {
			for(auto x : curr)
				ans[x] = 1;
		}
	}

	return ans;
}

vector<bool> solveFor(int n, int r, vector<pair<int, int>> v) {
	r *= 2;
	for(auto &x : v) {
		x.first *= 2;
		x.second *= 2;
	}
	vector<bool> ans(n);
	map<int, vector<int>> sq;
	for(int i = 0; i < n; i++) {
		int x = v[i].first / (r / 2);
		int y = v[i].second / (r / 2);
		sq[x * MOD + y].push_back(i);
	}

	vector<int> toErase;
	for(auto x : sq) {
		if(x.second.size() > 2) toErase.push_back(x.first);
	}
	for(auto x : toErase) {
		for(auto y : sq[x])
			ans[y] = 1;
		sq[x].clear();
	}

	g = vector<vector<int>> (n);
	for(int i = 0; i < n; i++) {
		int x = v[i].first / (r / 2);
		int y = v[i].second / (r / 2);
		for(int a = -2; a <= 2; a++) {
			for(int b = -2; b <= 2; b++) {
				int currX = x + a;
				int currY = y + b;
				for(auto x : sq[currX * MOD + currY]) {
					if(i != x && (v[i].first - v[x].first) * (v[i].first - v[x].first) + (v[i].second - v[x].second) * (v[i].second - v[x].second) <= r * r) {
						g[i].push_back(x);
						g[x].push_back(i);
						//cout << i << " " << x << endl;
					}
				}
			}
		}
	}

	used = vector<bool> (n);
	color = vector<int> (n, -1);
	for(int i = 0; i < n; i++) {
		if(!ans[i]) continue;
		vector<int> curr;
		dfs(i, curr);
		for(auto x : curr)
			ans[x] = 1;
	}
	for(int i = 0; i < n; i++) {
		if(ans[i] || used[i]) continue;
		vector<int> curr;
		color[i] = 0;
		//cout << i << endl;
		if(dfsColor(i, curr)) {
			for(auto x : curr)
				ans[x] = 1;
		}
	}

	return ans;
}

void solve() {
	long long nt, rt;
	cin >> nt >> rt;
	int n = nt, r = rt;

	vector<pair<long long, long long>> vt(n);
	vector<pair<int, int>> v(n);
	for(auto &x : vt) {
		cin >> x.first >> x.second;
	}
	for(int i = 0; i < n; i++) {
		v[i] = vt[i];
	}

	vector<bool> ans = solveFor(n, r, v);
	for(auto x : ans)
		cout << x;
	cout << endl;
}

void stress() {
	int n = 5;
	int r = 3;
	set<pair<int, int>> s;
	while(s.size() < n) {
		int x = abs(rand()) % 10;
		int y = abs(rand()) % 10ll;
		s.insert({x, y});
	}
	vector<pair<int, int>> v;
	for(auto x : s)
		v.push_back(x);
	vector<bool> fast = solveFor(n, r, v);
	vector<bool> slow = slowSolve(n, r, v);
	if(fast != slow) {
		cout << (long long)n << " " << (long long)r << endl;
		for(auto x : v)
			cout << (long long)x.first << " " << (long long)x.second << endl;
		for(auto x : fast)
			cout << x;
		cout << endl;
		for(auto x : slow)
			cout << x;
		cout << endl;
	}
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int t = 1;
	//cin >> t;

	while(t--) solve();
}
