#include <bits/stdc++.h>

#define int __int128
#define MOD 2000000007

using namespace std;

vector<bool> used;
vector<vector<int>> g;
vector<int> color;

bool dfsColor(int i, vector<int> &st) {
	used[i] = 1;
	st.push_back(i);
	for(auto x : g[i]) {
		if(color[x] == color[i]) return 1;
		if(used[x]) continue;
		color[x] = 1 - color[i];
		if(dfsColor(x, st)) return 1;
	}
	return 0;
}

void dfs(int i, vector<int> &st) {
	used[i] = 1;
	st.push_back(i);
	for(auto x : g[i]) {
		if(!used[x])
			dfs(x, st);
	}
}

void solve() {

	long long nt, rt;
	cin >> nt >> rt;
	int n = nt, r = rt;
	r *= 2;

	vector<pair<long long, long long>> vt(n);
	vector<pair<int, int>> v(n);
	for(auto &x : vt) {
		cin >> x.first >> x.second;
		x.first *= 2;
		x.second *= 2;
	}
	for(int i = 0; i < n; i++) {
		v[i] = vt[i];
	}

	vector<bool> ans(n);
	map<int, vector<int>> sq;
	for(int i = 0; i < n; i++) {
		int x = v[i].first / (r / 2);
		int y = v[i].second / (r / 2);
		sq[x * MOD + y].push_back(i);
	}

	vector<int> toErase;
	for(auto x : sq) {
		if(x.second.size() > 2) toErase.push_back(x.first);
	}
	for(auto x : toErase) {
		for(auto y : sq[x])
			ans[y] = 1;
		sq.erase(x);
	}

	g = vector<vector<int>> (n);
	for(int i = 0; i < n; i++) {
		int x = v[i].first / (r / 2);
		int y = v[i].second / (r / 2);
		for(int a = -3; a <= 3; a++) {
			for(int b = -3; b <= 3; b++) {
				int currX = x + a;
				int currY = y + b;
				for(auto x : sq[currX * MOD + currY]) {
					if(i != x && (v[i].first - v[x].first) * (v[i].first - v[x].first) + (v[i].second - v[x].second) * (v[i].second - v[x].second) <= r * r) {
						g[i].push_back(x);
						//cout << i << " " << x << endl;
					}
				}
			}
		}
	}

	used = vector<bool> (n);
	color = vector<int> (n, -1);
	for(int i = 0; i < n; i++) {
		if(!ans[i] || used[i]) continue;
		vector<int> curr;
		dfs(i, curr);
		for(auto x : curr)
			ans[x] = 1;
	}
	for(int i = 0; i < n; i++) {
		if(ans[i] || used[i]) continue;
		vector<int> curr;
		color[i] = 0;
		//cout << i << endl;
		if(dfsColor(i, curr)) {
			for(auto x : curr)
				ans[x] = 1;
		}
	}

	for(auto x : ans)
		cout << x;
	cout << endl;
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int t = 1;
	//cin >> t;

	while(t--) solve();
}
