#include <bits/stdc++.h>

#define int long long
#define MOD 1000000007

using namespace std;

int n;
int logn;
vector<vector<int>> sp;
vector<int> v;
vector<int> ks;

int getMin(int l, int r) {
	int len = r - l;
	int k = ks[len];
	if(v[sp[k][l]] < v[sp[k][r - (1 << k)]])
		return sp[k][l];
	return sp[k][r - (1 << k)];
}

void solve() {
	
	int q;
	cin >> n >> q;

	v = vector<int> (n);
	for(auto &x : v)
		cin >> x;

	logn = 1;
	while((1 << logn) < n)
		logn++;

	sp = vector<vector<int>> (logn, vector<int> (n));
	for(int i = 0; i < n; i++)
		sp[0][i] = i;

	for(int j = 1; j < logn; j++) {
		for(int i = 0; i < n; i++) {
			int curr = sp[j - 1][i];
			int next = (i + (1 << (j - 1)) < n) ? sp[j - 1][i + (1 << (j - 1))] : -1;
			sp[j][i] = curr;
			if(next != -1 && v[next] < v[curr])
				sp[j][i] = next;
		}
	}

	ks = vector<int> (n + 1);
	ks[0] = 0;
	for(int i = 1; i <= n; i++) {
		ks[i] = ks[i - 1];
		if((1 << (ks[i] + 1)) < i)
			ks[i]++;
	}

	vector<int> nextBigger(n, n);
	{
		stack<int> st;
		for(int i = 0; i < n; i++) {
			while(st.size() && v[st.top()] < v[i]) {
				nextBigger[st.top()] = i;
				st.pop();
			}
			st.push(i);
		}
	}

	vector<int> maxSuf(n);
	maxSuf.back() = v.back();
	for(int i = n - 2; i >= 0; i--) {
		maxSuf[i] = max(v[i], maxSuf[i + 1]);
	}

	vector<pair<int, int>> qs;
	map<int, int> req;
	while(q--) {
		int k, i;
		cin >> k >> i;
		req[k] = max(req[k], i);
		qs.push_back({k, i});
	}

	v.push_back(n * 2);
	vector<vector<int>> ans(n + 1);
	for(auto k : req) {
		int p = 0;
		bool skip = false;
		for(int i = 0; (i < k.first - 1) && (ans[k.first].size() < k.second); i++) {
			if(n - p == k.first - i) {
				skip = true;
				break;
			}
			int next = nextBigger[p];
			int curr = getMin(p + 1, min((n + 1) - (k.first - i - 1), min(next + 1, n)));
			ans[k.first].push_back(v[p]);
			if(i == k.first - 2) {
				if(next >= n - 1) p = n - 1;
				else p = next;
			} else p = curr;
		}
		if(!skip) ans[k.first].push_back(maxSuf[p]);
	}

	for(auto x : qs) {
		if(ans[x.first].size() >= x.second) {
			cout << ans[x.first][x.second - 1] << endl;
		} else {
			cout << v[n - 1 - (x.first - x.second)] << endl;
		}
	}
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int t = 1;
	//cin >> t;

	while(t--) solve();
}
