#include <bits/stdc++.h>
#define int long long

struct Point
{
    int x, y;
    int ind;

    Point(int x, int y, int ind) : x(x), y(y), ind(ind) {};
    Point() = default;

    int dist(Point b)
    {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
};

const int MAXN = 1e5 + 1;
int up[MAXN];
int h[MAXN];
bool ans[MAXN];

void dfs(int v, std::vector<std::vector<std::pair<int, int>>> &g, std::vector<bool> &used, int pred = -1, int height = 0)
{
    h[v] = height;
    used[v] = true;
    up[v] = 1e18;

    for (auto u : g[v])
    {
        if (u.second != pred)
        {
            if (used[u.first])
            {
                if (h[v] % 2 == h[u.first] % 2)
                {
                    up[v] = std::min(up[v], h[u.first]);
                }
            }
            else
            {
                dfs(u.first, g, used, u.second, height + 1);
                up[v] = std::min(up[v], up[u.first]);
            }
        }
    }
    if (up[v] <= h[v])
    {
        ans[v] = true;
    }
    else
    {
        ans[v] = false;
    }
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, r;
    std::cin >> n >> r;

    std::vector<Point> all(n);
    for (int i = 0; i < n; i++)
    {
        std::cin >> all[i].x >> all[i].y;
        all[i].ind = i;
    }

    std::sort(all.begin(), all.end(), [&](Point a, Point b)
              { return a.x < b.x; });
    std::vector<std::vector<std::pair<int, int>>> g(n);
    int ty = 0;
    for (int i = 0; i < n; i++)
    {
        int now = i + 1;
        while (now < n && all[i].dist(all[now]) <= r * r)
        {
            // std::cout << i << ' ' << now << std::endl;
            g[all[i].ind].push_back({all[now].ind, ty});
            g[all[now].ind].push_back({all[i].ind, ty});
            ty++;
            now++;
        }
    }

    std::vector<bool> used(n, false);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            dfs(i, g, used);
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (ans[i])
        {
            std::cout << 1;
        }
        else
        {
            std::cout << 0;
        }
    }
}