#pragma GCC optmize("O3")
#include <bits/stdc++.h>
// #define int long long

struct Point
{
    long long x, y;
    int ind;

    Point(int x, int y, int ind) : x(x), y(y), ind(ind) {};
    Point() = default;

    long long dist(Point b)
    {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
};

const int MAXN = 1e5 + 1;
int h[MAXN];
bool ans[MAXN];
bool was = false;

std::vector<int> tmp;

void dfs(int v, std::vector<std::vector<std::pair<int, int>>> &g, std::vector<bool> &used, int pred = -1, int height = 0)
{

    tmp.push_back(v);
    used[v] = true;
    h[v] = height;
    for (auto u : g[v])
    {
        if (u.second == pred)
        {
            continue;
        }
        if (!used[u.first])
        {
            dfs(u.first, g, used, u.second, height + 1);
        }
        else
        {
            if (h[v] % 2 == h[u.first] % 2)
            {
                was = true;
            }
        }
    }
}

int first_less(std::vector<Point> &a, int left, int right, int delta)
{
    int l = left, r = right + 1;
    while (l + 1 < r)
    {
        int mid = (l + r) / 2;
        if (a[mid].y <= delta)
        {
            l = mid;
        }
        else
        {
            r = mid;
        }
    }
    return l;
}

int last_more(std::vector<Point> &a, int left, int right, int delta)
{
    int l = left - 1, r = right;
    while (l + 1 < r)
    {
        int mid = (l + r) / 2;
        if (a[mid].y >= delta)
        {
            r = mid;
        }
        else
        {
            l = mid;
        }
    }
    return r;
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n;
    long long r2;
    std::cin >> n >> r2;

    std::vector<Point> all(n);
    for (int i = 0; i < n; i++)
    {
        std::cin >> all[i].x >> all[i].y;
        all[i].ind = i;
    }

    std::sort(all.begin(), all.end(), [&](Point a, Point b)
              { return std::make_pair(a.x, a.y) < std::make_pair(b.x, b.y); });
    std::vector<std::vector<std::pair<int, int>>> g(n);
    int prev = -1;
    std::vector<int> start;
    std::vector<int> end;
    int ty = 0;
    for (int i = 0; i < n; i++)
    {
        if (all[i].x == prev)
        {
            continue;
        }
        prev = all[i].x;
        int j = i;
        while (j < n && all[j].x == prev)
        {
            int now = j + 1;
            while (now < n && (all[j].x - all[now].x) * (all[j].x - all[now].x) == 0 && now <= j + 2)
            {
                if (all[j].dist(all[now]) <= r2 * r2)
                {
                    // std::cout << i << ' ' << now << std::endl;
                    g[all[j].ind].push_back({all[now].ind, ty});
                    g[all[now].ind].push_back({all[j].ind, ty});
                    ty++;
                }
                now++;
            }

            int k = (int)start.size() - 1;

            // int k = start.size() - 1;
            while (k >= 0)
            {
                long long delta = (prev - all[start[k]].x);
                delta *= delta;
                delta = r2 * r2 - delta;
                if (delta < 0)
                {
                    break;
                }
                int a = all[j].y;

                long long tmp = sqrtl(delta);
                int less = a - tmp;
                if (tmp * tmp < delta)
                {

                    tmp++;
                }
                int more = a + tmp;
                // std::cout << less << ' ' << more << ' ' << delta << ' ' << prev << ' ' << all[start[k]].x << ' ' << r2 << std::endl;

                int right = last_more(all, start[k], end[k], more);
                int left = first_less(all, start[k], end[k], less);
                // std::cout << left << ' ' << right << ' ' << all[start[k]].x << ' ' << all[j].ind << std::endl;

                for (int th = left; th <= right; th++)
                {
                    if (all[j].dist(all[th]) <= r2 * r2)
                    {
                        // std::cout << all[j].ind << ' ' << all[th].ind << std::endl;
                        g[all[j].ind].push_back({all[th].ind, ty});
                        g[all[th].ind].push_back({all[j].ind, ty});
                        ty++;
                    }
                }
                k--;
            }

            j++;
        }

        end.push_back(j - 1);

        start.push_back(i);
    }

    std::vector<bool> used(n, false);
    for (int i = 0; i < n; i++)
    {
        ans[i] = false;
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            tmp.clear();
            was = false;
            dfs(i, g, used);
            if (was)
            {
                for (int j : tmp)
                {
                    ans[j] = true;
                }
            }
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (ans[i])
        {
            std::cout << 1;
        }
        else
        {
            std::cout << 0;
        }
    }
}