#pragma GCC optmize("O3")
#include <bits/stdc++.h>
#define int long long

struct Point
{
    int x, y;
    int ind;

    Point(int x, int y, int ind) : x(x), y(y), ind(ind) {};
    Point() = default;

    int dist(Point b)
    {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
};

const int MAXN = 1e5 + 1;
int up[MAXN];
int h[MAXN];
bool ans[MAXN];
bool was = false;

std::vector<int> tmp;

void dfs(int v, std::vector<std::vector<std::pair<int, int>>> &g, std::vector<bool> &used, int pred = -1, int height = 0)
{

    tmp.push_back(v);
    used[v] = true;
    h[v] = height;
    for (auto u : g[v])
    {
        if (u.second == pred)
        {
            continue;
        }
        if (!used[u.first])
        {
            dfs(u.first, g, used, u.second, height + 1);
        }
        else
        {
            if (h[v] % 2 == h[u.first] % 2)
            {
                was = true;
            }
        }
    }
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, r;
    std::cin >> n >> r;

    std::vector<Point> all(n);
    for (int i = 0; i < n; i++)
    {
        std::cin >> all[i].x >> all[i].y;
        all[i].ind = i;
    }

    std::sort(all.begin(), all.end(), [&](Point a, Point b)
              { return a.x < b.x; });
    std::vector<std::vector<std::pair<int, int>>> g(n);
    int ty = 0;

    for (int i = 0; i < n; i++)
    {
        int now = 0;
        int cnt = 0;

        // while (now < n && all[now].x == all[i].x)
        while (now < n && (all[i].x - all[now].x) * (all[i].x - all[now].x) <= r * r && cnt <= n / 100)
        {
            if (all[i].dist(all[now]) <= r * r)
            {
                // std::cout << i << ' ' << now << std::endl;
                g[all[i].ind].push_back({all[now].ind, ty});
                g[all[now].ind].push_back({all[i].ind, ty});
                ty++;
            }
            cnt++;
            now++;
        }
    }

    std::vector<bool> used(n, false);
    for (int i = 0; i < n; i++)
    {
        ans[i] = false;
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            tmp.clear();
            was = false;
            dfs(i, g, used);
            if (was)
            {
                for (int j : tmp)
                {
                    ans[j] = true;
                }
            }
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (ans[i])
        {
            std::cout << 1;
        }
        else
        {
            std::cout << 0;
        }
    }
}