#include <bits/stdc++.h>
#define int long long

const int MAXK = 200;

struct Fenwick
{
    int n;
    std::vector<int> t;

    Fenwick(int n) : n(n)
    {
        t.resize(n + 1);
    }

    void upd(int i, int x)
    {
        i++;
        for (; i <= n; i += (i & (-i)))
        {
            t[i] += x;
        }
    }
    int sum(int i)
    {
        i++;
        int ans = 0;
        for (; i > 0; i -= (i & (-i)))
        {
            ans += t[i];
        }
        return ans;
    }
    int sum(int r, int l)
    {
        return sum(r) - sum(l - 1);
    }
};

int Check(std::vector<int> &a, int r, int c)
{
    Fenwick t(r * c);
    int ans = 0;
    for (int i = 0; i < a.size(); i++)
    {
        ans += t.sum(a[i] + 1, r * c);
        t.upd(a[i], 1);
    }
    return ans;
}

signed
main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;

    std::vector<std ::vector<int>> a(n, std ::vector<int>(m));

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            std::cin >> a[i][j];
            a[i][j]--;
        }
    }

    if (n == 1)
    {
        std::cout << Check(a[0], n, m);
        return 0;
    }
}