#include <bits/stdc++.h>
#define int long long

const int MAXK = 200;

struct SegTree
{
    int n;
    std::vector<int> t;

    SegTree(int n) : n(n)
    {
        t.resize(4 * n);
    }

    void upd(int i, int l, int r, int pos, int x)
    {
        if (l == r - 1)
        {
            t[i] += x;
            return;
        }
        int mid = (l + r) / 2;
        if (pos >= mid)
        {
            upd(2 * i + 2, mid, r, pos, x);
        }
        else
        {
            upd(2 * i + 1, l, mid, pos, x);
        }
        t[i] = t[2 * i + 1] + t[2 * i + 2];
    }

    int query(int i, int l, int r, int ql, int qr)
    {
        if (l >= ql && r <= qr)
        {
            return t[i];
        }
        if (l >= qr || ql >= r)
        {
            return 0;
        }
        int mid = (l + r) / 2;
        return query(2 * i + 1, l, mid, ql, qr) + query(2 * i + 2, mid, r, ql, qr);
    }
};

int Check(std::vector<int> &a, int r, int c)
{
    SegTree t(r * c);
    int ans = 0;
    for (int i = 0; i < a.size(); i++)
    {
        ans += t.query(0, 0, r * c, a[i] + 1, r * c);
        // std::cout << i << ' ' << t.sum(a[i] + 1, r * c - 1) << std::endl;
        t.upd(0, 0, r * c, a[i], 1);
    }
    return ans;
}

signed
main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;

    std::vector<std ::vector<int>> a(n, std ::vector<int>(m));

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            std::cin >> a[i][j];
            a[i][j]--;
        }
    }

    if (n == 1)
    {
        std::cout << Check(a[0], n, m);
        return 0;
    }

    int tmp = n + m;
    int min = 1e18;
    for (int i = 0; i < (1 << tmp); i++)
    {
        int cur_up = 0;
        int cur_down = 0;

        std::vector<int> now;
        bool good = true;
        for (int j = 0; j < tmp; j++)
        {
            if ((i >> j) & 1)
            {
                if (cur_down == n)
                {
                    break;
                }
                for (int k = cur_up; k < m; k++)
                {
                    now.push_back(a[cur_down][k]);
                }
                cur_down++;
            }
            else
            {
                if (cur_up == m)
                {
                    break;
                }
                for (int k = cur_down; k < n; k++)
                {
                    now.push_back(a[k][cur_up]);
                }
                cur_up++;
            }
        }

        min = std::min(min, Check(now, n, m));
    }
    std::cout << min;
}