#define __GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <map>
#include <queue>

using ll = long long;
using namespace std;

#define pii pair<int, int>
#define mkp make_pair
#define int long long

const int inf = 1e16 + 1337;
vector<pii> a;
vector<vector<int>> g;
int r;

bool chk(int i, int j) {
    if (i == j) return 0;
    ll dist = 1ll * (a[i].first - a[j].first) * (a[i].first - a[j].first) + 1ll * (a[j].second - a[i].second) * (a[j].second - a[i].second);
    ll sq = 1ll * r * r;
    if (dist <= sq) return 1;
    else return 0;
};



int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n >> r;
	g.resize(n);
	a.resize(n);
	for(int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
	map<pii, int> mp;
	for(int i = 0; i < n; i++) mp[a[i]] = i;
	for(int i = 0; i < n; i++) {
		for(int x = a[i].first - r; x <= a[i].first + r; x++) {
			for(int y = a[i].second - r; y <= a[i].second + r; y++) {
				if(mp.find(mkp(x, y)) != mp.end()) {
					int j = mp[mkp(x, y)];
					if(i != j && chk(i, j)) g[i].push_back(j);
				}
			}
		}
	}
	// for(int i = 0; i < n; i++) {
	// 	for(int j : g[i]) {
	// 		cout << j + 1 << ' ';
	// 	}
	// 	cout << endl;
	// }
	vector<int> dist(n, inf);
	queue<int> qu;
	for(int i = 0; i < n; i++) {
		for(int j : g[i]) {
			for(int k : g[j]) {
				if(i != j && i != k && j != k && chk(i, j) && chk(i, k) && chk(j, k)) {
					qu.push(i);
					dist[i] = 0;
				}
			}
		}
	}
	while(!qu.empty()) {
		int v = qu.front();
		qu.pop();
		for(int u : g[v]) {
			if(dist[u] == inf) {
				dist[u] = 0;
				qu.push(u);
			}
		}
	}
	for(int i = 0; i < n; i++) {
		if(dist[i] == inf) cout << 0;
		else cout << 1;
	}

}