#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <map>

using ll = long long;
using namespace std;

#define pii pair<int, int>
#define mkp make_pair

vector<vector<int>> g;
vector<pii> a;
int r;
vector<int> used1, used2;

bool chk(int i, int j) {
	if (i == j) return 0;
	ll dist = 1ll * (a[i].first - a[j].first) * (a[i].first - a[j].first) + 1ll * (a[j].second - a[i].second) * (a[j].second - a[i].second);
	ll sq = 1ll * r * r;
	if (dist <= sq) return 1;
	else return 0;
};
bool ans = 0;

void dfs(int v, int st, int col, int base) {
	if (col) used1[v] = base;
	if (!col) used2[v] = base;
	if (ans == 1) return;
	if (col && chk(st, v)) {
		ans = 1;
		return;
	}
	for (int u : g[v]) {
		if (ans) return;
		if (col) {
			if (used2[u] != base) dfs(u, st, !col, base);
		}
		else {
			if (used1[u] != base) dfs(u, st, !col, base);
		}
		if (ans) return;
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n;
	cin >> r;
	used1.resize(n);
	used2.resize(n);
	a.resize(n);
    map<pii, int> mp;
	for (int i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
        mp[a[i]] = i;
	}
	auto chk = [&](int i, int j) {
		ll dist = 1ll * (a[i].first - a[j].first) * (a[i].first - a[j].first) + 1ll * (a[j].second - a[i].second) * (a[j].second - a[i].second);
		ll sq = 1ll * r * r;
		if (dist <= sq) return 1;
		else return 0;
	};
	g.resize(n);
	for (int i = 0; i < n; i++) {
		for(int x1 = a[i].first - r; x1 <= a[i].first + r; x1++) {
            for(int x2 = a[i].second - r; x2 <= a[i].second + r; x2++) {
                if(mp.find(mkp(x1, x2)) != mp.end()) {
                    int j = mp[mkp(x1, x2)];
                    if(chk(i, j) && i != j) {
                        g[i].push_back(j);
                    }
                }
            }
        }
	}
	for (int v = 0; v < n; v++) {
		ans = 0;
		dfs(v, v, 1, v + 1);
		cout << ans;
	}

}