#define __GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <map>
#include <queue>

using ll = long long;
using namespace std;

#define pii pair<int, int>
#define mkp make_pair

struct SegTree {
    vector<int> t;
    void upd(int v, int l, int r, int i) {
        if(l > i || r <= i) return;
        if(l + 1 >= r) {
            t[v]++;
            return;
        }
        int m = l + r >> 1;
        upd(v << 1, l, m, i);
        upd(v << 1 | 1, m, r, i);
        t[v] = t[v << 1] + t[v << 1 | 1];
    }
    int get(int v, int l, int r, int ql, int qr) {
        if(l >= qr || r <= ql) return 0;
        if(l >= ql && r <= qr) return t[v];
        int m = l + r >> 1;
        return get(v << 1, l, m, ql, qr) + get(v << 1 | 1, m, r, ql, qr);
    }
};


int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<int> v(n * m);
    for(int i = 0; i < n * m; i++) cin >> v[i];
    SegTree st;
    st.t.resize((n * m + 5) * 4);
    ll inv  = 0;
    for(int i = 0; i < n * m; i++) {
        st.upd(1, 0, n * m + 1, v[i]);
        inv += st.get(1, 0, n * m + 1, v[i] + 1, n * m + 1);
    }
    cout << inv << endl;

}