#define __GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <map>
#include <queue>

using ll = long long;
using namespace std;

#define pii pair<int, int>
#define mkp make_pair

const ll inf = 1e16 + 1337;

struct SegTree {
    vector<int> t;
    void upd(int v, int l, int r, int i) {
        if(l > i || r <= i) return;
        if(l + 1 >= r) {
            t[v]++;
            return;
        }
        int m = l + r >> 1;
        upd(v << 1, l, m, i);
        upd(v << 1 | 1, m, r, i);
        t[v] = t[v << 1] + t[v << 1 | 1];
    }
    int get(int v, int l, int r, int ql, int qr) {
        if(l >= qr || r <= ql) return 0;
        if(l >= ql && r <= qr) return t[v];
        int m = l + r >> 1;
        return get(v << 1, l, m, ql, qr) + get(v << 1 | 1, m, r, ql, qr);
    }
};


int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    ll ans = inf;
    for(int mask = 0; mask < (1 << (n + m)); mask++) {
       // if(__builtin_popcount(mask) != n) continue;
        SegTree st;
        st.t.resize(4 * (n * m + 5));
        int i = 0, j = 0;
        vector<int> v;

        bool flg = 1;
        for(int k = 0; k < (n + m); k++) {
            //cout << i << ' ' << j << endl;
            if(mask & (1 << k)) {
                for(int l = j; l < m; l++) {
                    if(i == n) {
                        flg = 0;
                        break;
                    }
                    v.push_back(a[i][l]);
                }
                i++;
            } else {
                for(int l = i; l < n; l++) {
                    if(j == m) {
                        flg = 0;
                        break;
                    }
                    v.push_back(a[l][j]);
                }
                j++;
            }
            if(!flg) break;
        }
        if(v.size() < n * m) continue;
        //for(int i = 0;i < v.size(); i++) cout << v[i] << ' ';
       // cout << endl;
        ll inv = 0;
        for(int i = 0; i < v.size(); i++) {
            st.upd(1, 0, n * m + 1, v[i]);
            inv += st.get(1, 0, n * m + 1, v[i] + 1, n * m + 1);
        }
        ans = min(ans, inv);
    }
    cout << ans << endl;

}