#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int h, w; cin >> h >> w;
    vector<vector<int>> a(h, vector<int>(w));
    for (auto &line : a) for (auto &i : line) cin >> i;

    vector<vector<int>> dp(h, vector<int>(w, h * w * h * w));
    vector<vector<vector<int>>> sorted(h, vector<vector<int>>(w)), sorted_line(h, vector<vector<int>>(w)), sorted_vert(h, vector<vector<int>>(w));
    
    for (int y = 0; y < h; y++) {
        for (int x = 0; x < w; x++) {
            for (int ny = y; ny < h; ny++) {
                for (int nx = x; nx < w; nx++) {
                    sorted[y][x].push_back(a[ny][nx]);
                }
            }
            sort(sorted[y][x].begin(), sorted[y][x].end());

            for (int ny = y; ny < h; ny++) {
                sorted_vert[y][x].push_back(a[ny][x]);
            }
            sort(sorted_vert[y][x].begin(), sorted_vert[y][x].end());

            for (int nx = x; nx < w; nx++) {
                sorted_line[y][x].push_back(a[y][nx]);
            }
            sort(sorted_line[y][x].begin(), sorted_vert[y][x].end());
        }
    }

    dp.back().back() = 0;
    for (int y = h - 1; y >= 0; y--) {
        for (int x = w - 1; x >= 0; x--) {
            int t1 = 0, t2 = 0;
            if (y < h - 1) {
                vector<int> &a = sorted_line[y][x], &b = sorted[y + 1][x];
                int i = 0, j = 0;
                while (i < a.size() && j < b.size()) {
                    if (a[i] > b[j]) {
                        t1 += i;
                        j++;
                    } else {
                        i++;
                    }
                }
                dp[y][x] = min(dp[y][x], dp[y + 1][x] + t1);
            }
            if (x < w - 1) {
                vector<int> &a = sorted_vert[y][x], &b = sorted[y][x + 1];
                int i = 0, j = 0;
                while (i < a.size() && j < b.size()) {
                    if (a[i] > b[j]) {
                        t1 += i;
                        j++;
                    } else {
                        i++;
                    }
                }
                dp[y][x] = min(dp[y][x], dp[y][x + 1] + t2);
            }
        }
    }
    cout << dp[h][w] << '\n';
}