#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define ff first 
#define ss second
 
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
 
template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
   for (T &x : a) in >> x;
   return in;
}
 
template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
   for (T &x : a) out << x << ' ';
   return out;
}

struct SegTree {
   vector<ll> t;
   SegTree (ll n) : t(4 * n, 0) {}
   SegTree() {}
   void add(ll v, ll lx, ll rx, ll x) {
      if (lx == rx) {
         ++t[v];
         return;
      }
      ll mid = lx + rx >> 1;
      if (x <= mid) add(v * 2, lx, mid, x);
      else add(v * 2 + 1, mid + 1, rx, x);
      t[v] = t[v * 2] + t[v * 2 + 1];
   }
   void del(ll v, ll lx, ll rx, ll x) {
      if (lx == rx) {
         --t[v];
         return;
      }
      ll mid = lx + rx >> 1;
      if (x <= mid) del(v * 2, lx, mid, x);
      else del(v * 2 + 1, mid + 1, rx, x);
      t[v] = t[v * 2] + t[v * 2 + 1];
   }
   ll ans(ll v, ll lx, ll rx, ll l, ll r) {
      if (lx >= l && rx <= r) return t[v];
      if (l > rx || lx > r) return 0;
      ll mid = lx + rx >> 1;
      return ans(v * 2, lx, mid, l, r) + ans(v * 2 + 1, mid + 1, rx, l, r);
   }
   ll count(ll v, ll lx, ll rx, ll x) {
      if (lx == rx) return t[v];
      ll mid = lx + rx >> 1;
      if (x <= mid) return count(v * 2, lx, mid, x);
      else return count(v * 2 + 1, mid + 1, rx, x);
   }
};

ll r, c;
vector<vector<ll>> a;
SegTree st;
ll ans = 1e18;
ll z = 0;

void add_row(ll &lx, ll &ly) {
   for (int i = lx; i < c; ++i) {
      z += st.ans(1, 1, r * c, a[ly][i], r * c);
      st.add(1, 1, r * c, a[ly][i]);
   }
   ++ly;
}

void del_row(ll &lx, ll &ly) {
   --ly;
   for (int i = c - 1; i >= lx; --i) {
      st.del(1, 1, r * c, a[ly][i]);
      z -= st.ans(1, 1, r * c, a[ly][i], r * c);
   }
}

void add_col(ll &lx, ll &ly) {
   for (int i = ly; i < r; ++i) {
      z += st.ans(1, 1, r * c, a[i][lx], r * c);
      st.add(1, 1, r * c, a[i][lx]);
   }
   ++lx;
}

void del_col(ll &lx, ll &ly) {
   --lx;
   for (int i = r - 1; i >= ly; --i) {
      st.del(1, 1, r * c, a[i][lx]);
      z -= st.ans(1, 1, r * c, a[i][lx], r * c);
   }
}

void gen(ll lx = 0, ll ly = 0) {
   //cout << lx << ' ' << ly << ' ';
   if (lx == c || ly == r) {
      ans = z;
      return;
   }
   //cout << 1 << endl;
   add_row(lx, ly);
   if (z >= ans) goto DelRow;
   gen(lx, ly);
   DelRow: del_row(lx, ly);
   //cout << 2 << endl;
   add_col(lx, ly);
   if (z >= ans) goto DelCol;
   gen(lx, ly);
   DelCol: del_col(lx, ly);
}

void Solve() {
   cin >> r >> c;
   a = vector<vector<ll>>(r, vector<ll>(c));
   cin >> a;
   st = SegTree(r * c);
   gen();
   cout << ans;
}
 
 
int main() {
   Solve();
}