#include <bits/stdc++.h>

using namespace std;

#ifndef lisie_bimbi
#define endl '\n'
#endif

using ll = long long;

const ll inf = 1'000'000'000'000'000'000;


const int N = 2'000'000;

struct fenwick{
    vector<int> d;
    vector<int> op;
    int n;
    void update(int ind, int z){
        ind++;
        for(int i = ind; i <= n; i += (i & (-i))){
            d[i] += z;
            op.push_back(i);
        }
    }
    int get(int l, int r){
        int ans = 0;
        for(int i = r; i > 0; i -= (i & (-i))){
            ans += d[i];
        }
        for(int i = l; i > 0; i -= (i & (-i))){
            ans -= d[i];
        }
        return ans;
    }
    void otkat(){
        for(auto i : op){
            d[i] = 0;
        }
        op.clear();
    }
    void init(int n1){
        op.clear();
        n = n1;
        d.clear();
        d.resize(n + 1);
    }
};

struct lox{
    fenwick a;
    fenwick b;
    ll ans = 0;
    void init(){
        a.init(N);
        b.init(N);
        ans = 0;
    }
    void adda(int x){
        ans += b.get(0, x);
        a.update(x, 1);
    }
    void addb(int x){
        ans += a.get(x, N);
        b.update(x, 1);
    }
    void erasea(int x){
        ans -= b.get(0, x);
        a.update(x, -1);
    }
    void eraseb(int x){
        ans -= a.get(x, N);
        b.update(x, -1);
    }
    ll get(){
        return ans;
    }
    void otkat(){
        ans = 0;
        a.otkat();
        b.otkat();
    }
};

struct lox2{
    ll ans = 0;
    fenwick f;
    void init(){
        f.init(N);
        ans = 0;
    }
    void add(int x){
        ans += f.get(x, N);
        f.update(x, 1);
    }
    ll get(){
        return ans;
    }
    void otkat(){
        ans = 0;
        f.otkat();
    }
};

lox l;
lox2 l2;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(min(n, m), vector<int>(max(n, m)));
    bool f = (n > m);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(f){
                cin >> a[j][i];
                a[j][i]--;
            }else{
                cin >> a[i][j];
                a[i][j]--;
            }
        }
    }
    if(n > m){
        swap(n, m);
    }
    vector<vector<ll>> g(n, vector<ll>(m)), v(n, vector<ll>(m));
    l.init();
    l2.init();
    for(int i = 0; i < n; i++){
        l.otkat();
        l2.otkat();
        for(int i2 = i; i2 < n; i2++){
            l.adda(a[i2][m - 1]);
        }
        for(int j = m - 1; j > 0; j--){
            l2.otkat();
            for(int i2 = i; i2 < n; i2++){
                l.erasea(a[i2][j]);
                l.addb(a[i2][j]);
                l.adda(a[i2][j - 1]);
                l2.add(a[i2][j - 1]);
            }
            g[i][j] = l.get() + l2.get();
        }
    }
    for(int i = 1; i < n; i++){
        l.otkat();
        l2.otkat();
        for(int j = m - 1; j >= 0; j--){
            l.adda(a[i - 1][j]);
            l2.add(a[i - 1][j]);
            for(int i2 = i; i2 < n; i2++){
                l.addb(a[i2][j]);
            }
            v[i][j] = l.get() + ((ll)(m - j) * ((m - j) - 1) / 2 - l2.get());
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, inf));
    dp[0][0] = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if((i == 0) && (j == 0)){
                continue;
            }
            if(i > 0){
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + v[i][j]);
            }
            if(j > 0){
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + g[i][j]);
            }
        }
    }
    cout << dp[n - 1][m - 1] << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}