#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi2,fma")

#ifndef lisie_bimbi
#define endl '\n'
#endif

using ll = long long;

const ll inf = 1'000'000'000'000'000'000;

#ifndef lisie_bimbi
const int N = 2'000'001;
#else
const int N = 20;
#endif

struct fenwick{
    int d[N];
    vector<int> op;
    int n;
    void update(int ind, int z){
        ind++;
        for(int i = ind; i <= n; i += (i & (-i))){
            d[i] += z;
            op.push_back(i);
        }
    }
    int get(int l, int r){
        int ans = 0;
        for(int i = r; i > 0; i -= (i & (-i))){
            ans += d[i];
        }
        for(int i = l; i > 0; i -= (i & (-i))){
            ans -= d[i];
        }
        return ans;
    }
    void otkat(){
        for(auto i : op){
            d[i] = 0;
        }
        op.clear();
    }
    void init(int n1){
        op.clear();
        n = n1;
    }
};

struct fenwick2d{
    vector<vector<int>> d;
    int n, m;
    void update(int x, int y, int z){
        x++;y++;
        for(int i = x; i <= n; i += (i & (-i))){
            for(int j = y; j <= m; j += (j & (-j))){
                d[i][i] += z;
            }
        }
    }
    int get(int x, int y){
        int ans = 0;
        for(int i = x; i > 0; i -= (i & (-i))){
            for(int j = y; j > 0; j -= (j & (-j))){
                ans += d[i][j];
            }
        }
        return ans;
    }
    void init(int n1, int m1){
        n = n1;
        m = m1;
        d.resize(n + 1, vector<int>(m + 1));
    }
};


fenwick f;
fenwick2d f2;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(min(n, m), vector<int>(max(n, m)));
    bool ff = (n > m);
    vector<tuple<int, int, int>> zz;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(ff){
                cin >> a[j][i];
                a[j][i]--;
                zz.emplace_back(a[j][i], j, i);
            }else{
                cin >> a[i][j];
                a[i][j]--;
                zz.emplace_back(a[i][j], i, j);
            }
        }
    }
    if(n > m){
        swap(n, m);
    }
    f.init(N);
    f2.init(n, m);
    sort(zz.begin(), zz.end());
    vector<vector<int>> lox(n, vector<int>(m));
    for(auto [zzz, x, y] : zz){
        lox[x][y] = f2.get(n - 1 - x, m - 1 - y);
        f2.update(n - 1 - x, m - 1 - y, 1);
    }
    vector<vector<int>> right(n, vector<int>(m)), down(n, vector<int>(m));
    for(int i = 0; i < n; i++){
        f.otkat();
        for(int j = m - 1; j >= 0; j--){
            right[i][j] = f.get(0, a[i][j]);
            f.update(a[i][j], 1);
        }
    }
    for(int j = 0; j < m; j++){
        f.otkat();
        for(int i = n - 1; i >= 0; i--){
            down[i][j] = f.get(0, a[i][j]);
            f.update(a[i][j], 1);
        }
    }
    vector<vector<ll>> g(n, vector<ll>(m)), v(n, vector<ll>(m));
    for(int i = n - 1; i >= 0; i--){
        f.otkat();
        for(int j = m - 1; j >= 0; j--){
            if(i + 1 < n){
                if(j + 1 < m){
                    v[i][j] += v[i][j + 1];
                }
                v[i][j] += lox[i][j];
                v[i][j] += right[i][j];
                v[i][j] += down[i][j];
                for(int i1 = i + 1; i1 < n ; i1++){
                    v[i][j] += f.get(a[i1][j], N);
                }
            }
            if(j > 0){
                if(i + 1 < n){
                    g[i][j] += g[i + 1][j];
                }
                g[i][j] += lox[i][j];
                g[i][j] += right[i][j];
                g[i][j] += down[i][j];
                for(int i1 = i + 1; i1 < n ; i1++){
                    g[i][j] += f.get(0, a[i1][j]);
                }
            }
            f.update(a[i][j], 1);
        }
    }
    /*
    for(auto i : lox){
        for(auto j : i){
            cout << j << " ";
        }
        cout << endl;
    }
    cout << endl;
    for(auto i : v){
        for(auto j : i){
            cout << j << " ";
        }
        cout << endl;
    }
    cout << endl;
    for(auto i : g){
        for(auto j : i){
            cout << j << " ";
        }
        cout << endl;
    }
    cout << endl;
    */
    vector<vector<ll>> dp(n, vector<ll>(m, inf));
    dp[0][0] = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if((i == 0) && (j == 0)){
                continue;
            }
            if(i > 0){
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + v[i - 1][j]);
            }
            if(j > 0){
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + g[i][j - 1]);
            }
        }
    }
    cout << dp[n - 1][m - 1] << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}