#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

struct SegTree {
    int n;
    vector<int> tree;

    SegTree(int sz) {
        n = sz;
        tree.resize(n * 4, 0);
    }

    void update(int v, int l, int r, int ind, int x) {
        if (r - l == 1) {
            tree[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) {
            update(v * 2, l, m, ind, x);
        } else {
            update(v * 2 + 1, m, r, ind, x);
        }
        tree[v] = tree[v * 2] + tree[v * 2 + 1];
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return 0;
        if (ql <= l && r <= qr) return tree[v];
        int m = (l + r) / 2;
        return get(v * 2, l, m, ql, qr) + get(v * 2 + 1, m, r, ql, qr);
    }
};

int inv(vector<int> & a) {
    int n = a.size();
    SegTree t(n + 1);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans += t.get(1, 0, n + 1, a[i] + 1, n + 1);
        t.update(1, 0, n, a[i], 1);
    }
    return ans;
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mx(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mx[i][j];
        }
    }
    if (n == 1) {
        cout << inv(mx[0]);
    } else {
        int ans = 1e18;
        for (int i = 0; i < (1 << (n + m)); i++) {
            int h = 0, v = 0;
            vector<int> a;
            for (int j = 0; j < n + m; j++) {
                if (h == n || v == m) break;
                if (i & (1 << j)) {
                    for (int k = v; k < m; k++) {
                        a.push_back(mx[h][k]);
                    }
                    h++;
                } else {
                    for (int k = h; k < n; k++) {
                        a.push_back(mx[k][v]);
                    }
                    v++;
                }
            }
            ans = min(ans, inv(a));
        }
        cout << ans;
    }
}