#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

struct SegTree {
    int n;
    vector<int> tree;

    SegTree(int sz) {
        n = sz;
        tree.resize(n * 4);
    }

    void build(int v, int l, int r, vector<int> & a) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2 , l, m, a);
        build(v * 2 + 1, m, r, a);
        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) return -1e9;
        if (ql <= l && r <= qr) return tree[v];
        int m = (l + r) / 2;
        return max(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
    }
};

vector<int> a;
vector<vector<int>> vx;

void gen(vector<int> & mx, int i, int k) {
    if (i == a.size()) {
        vx.push_back(mx);
        return;
    }
    if (a.size() - i >= k) {
        int xb = mx.back();
        mx.back() = max(mx.back(), a[i]);
        gen(mx, i + 1, k);
        mx.back() = xb;
    }
    if (k > 1 && i != 0) {
        mx.push_back(a[i]);
        gen(mx, i + 1, k - 1);
        mx.pop_back();
    }
}

signed main() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    for (auto & el : a) {
        cin >> el;
    }
    bool f = true;
    for (int i = 0; i < n; i += 2) {
        if (a[i] != i / 2 + 1) f = false;
    }
    for (int i = 1; i < n; i += 2) {
        if (a[i] != n - i / 2) f = false;
    }
    if (f) {
        SegTree t(n);
        t.build(1, 0, n, a);
        while (q--) {
            int k, i;
            cin >> k >> i;
            if (k == 1) {
                cout << a[1];
            } else if (i == k) {
                if (k % 2 == 0) {
                    cout << t.get(1, 0, n, i - 1, n);
                } else {
                    cout << a.back();
                }
            } else {
                cout << a[i - 1];
            }
            cout << "\n";
        }
        return 0;
    }
    SegTree t(n);
    t.build(1, 0, n, a);
    array<int, 2> ans2 = {(int) 1e9, (int) 1e9};
    for (int i = 0; i < n - 1; i++) {
        array<int, 2> cur = {t.get(1, 0, n, 0, i + 1), t.get(1, 0, n, i + 1, n)};
        if (cur < ans2) ans2 = cur;
    }
    array<int, 3> ans3{(int) 1e9, (int) 1e9, (int) 1e9};
    int mx = n;
    for (int i = 1; i < n; i++) {
        if (a[i] > a[0]) {
            mx = i;
            break;
        }
    }
    for (int i = 2; i < n; i++) {
        array<int, 3> cur = {t.get(1, 0, n, 0, min(mx, i - 1)), t.get(1, 0, n, min(mx, i - 1), i), t.get(1, 0, n, i, n)};
        if (cur < ans3) ans3 = cur;
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        if (k == 1) {
            cout << t.get(1, 0, n, 0, n);
        } else if (k == 2) {
            cout << ans2[i - 1];
        } else if (k == 3) {
            cout << ans3[i - 1];
        } else {
            vector<int> mx{0};
            vx = {};
            gen(mx, 0, k);
            cout << (*min_element(all(vx)))[i - 1];
        }
        cout << "\n";
    }
}