#include <bits/stdc++.h>

using namespace std;

//#pragma optimize("O3,avx,avx2,bmi,bmi2,unroll-loops")

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000;

struct st {
    vector <int> t;

    void build(int n) {
        t.resize(4 * n, 0);
    }

    int get(int v, int l, int r, int ll, int rr) {
        if (ll > rr) {
            return 0;
        }
        if (l == ll && r == rr) {
            return t[v];
        }
        int m = (l + r) / 2;
        return get(v * 2 + 1, l, m, ll, min(m, rr)) + get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int i, int x) {
        if (l == r) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            update(v * 2 + 1, l, m, i, x);
        }
        else {
            update(v * 2 + 2, m + 1, r, i, x);
        }
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void update(int i, int x) {
        update(0, 0, t.size() / 4 - 1, i, x);
    }

    int get(int l, int r) {
        return get(0, 0, t.size() / 4 - 1, l, r);
    }
};

void solve2(int n, int m) {
    vector <int> a(m);
    int cnt = 0;
    for (int i = 0; i < m; i ++) {
        cin >> a[i];
    }

    st t;
    t.build(m + 1);

    for (int i = m - 1; i >= 0; i --) {
        cnt += t.get(0, a[i] - 1);
        t.update(a[i], 1);
    }

    cout << cnt << '\n';
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        solve2(n, m);
        return;
    }
    vector <vector <int>> a(n, vector <int> (m));
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> a[i][j];
        }
    }

    st t1, t2;
    t1.build(n * m + 1);
    t2.build(n * m + 1);

    vector <int> dp(m, 0);
    for (int i = m - 1; i >= 0; i --) {
        if (i + 1 < m) {
            dp[i] = dp[i + 1];
        }
        dp[i] += t2.get(0, a[1][i] - 1);
        t2.update(a[1][i], 1);
        dp[i] += t1.get(0, a[0][i] - 1);
        dp[i] += t2.get(0, a[0][i] - 1);
        t1.update(a[0][i], 1);
    }

    vector <int> dp2(m, 0);
    st t3;
    t3.build(n * m + 1);
    for (int i = 1; i <= n * m; i ++) {
        t3.update(i, 1);
    }

    for (int i = 0; i < m; i ++) {
        t3.update(a[0][i], -1);
        if (i != 0) {
            dp2[i] = dp2[i - 1];
        }
        dp2[i] += t3.get(0, a[0][i] - 1);
        t3.update(a[1][i], -1);
        dp2[i] += t3.get(0, a[1][i] - 1);
    }

    int ans = min(dp[0], dp2[m - 1]);

    for (int i = 1; i < m; i ++) {
        ans = min(ans, dp2[i - 1] + dp[i]);
    }
    cout << ans << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}