#include <bits/stdc++.h>

using namespace std;

//#pragma optimize("O3,avx,avx2,bmi,bmi2,unroll-loops")

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000;

struct st {
    vector <int> t;

    void build(int n) {
        t.resize(4 * n, 0);
    }

    int get(int v, int l, int r, int ll, int rr) {
        if (ll > rr) {
            return 0;
        }
        if (l == ll && r == rr) {
            return t[v];
        }
        int m = (l + r) / 2;
        return get(v * 2 + 1, l, m, ll, min(m, rr)) + get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int i, int x) {
        if (l == r) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            update(v * 2 + 1, l, m, i, x);
        }
        else {
            update(v * 2 + 2, m + 1, r, i, x);
        }
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void update(int i, int x) {
        update(0, 0, t.size() / 4 - 1, i, x);
    }

    int get(int l, int r) {
        return get(0, 0, t.size() / 4 - 1, l, r);
    }
};

int solve2(vector <int> a, st &t) {
    int m = a.size();

    int cnt = 0;

    for (int i = m - 1; i >= 0; i --) {
        cnt += t.get(0, a[i] - 1);
        t.update(a[i], 1);
    }

    for (int i = m - 1; i >= 0; i --) {
        t.update(a[i], -1);
    }

    return cnt;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n, vector <int> (m));
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> a[i][j];
        }
    }

    st t;
    t.build(n * m + 1);

    int ans = 0;

    for (int i = 0; i < min(n, m); i ++) {
        vector <int> b1;
        for (int j = i; j < m; j ++) {
            b1.push_back(a[i][j]);
        }
        for (int j = i + 1; j < n; j ++) {
            b1.push_back(a[j][i]);
        }
        int cnt1 = solve2(b1, t);

        vector <int> b2;
        for (int j = i; j < n; j ++) {
            b2.push_back(a[j][i]);
        }
        for (int j = i + 1; j < m; j ++) {
            b2.push_back(a[i][j]);
        }
        int cnt2 = solve2(b2, t);

        ans += min(cnt1, cnt2);
    }

    cout << ans << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}