#include <bits/stdc++.h>

using namespace std;

#pragma optimize("O3,avx,avx2,bmi,bmi2,unroll-loops")

//#define int long long

int inf = (int)1000 * 1000 * 1000;

struct st {
    int t[4 * (200 * 200) + 1];
    int n;

    void build(int nn) {
        int n = nn;
        for (int i = 0; i < 4 * n; i ++) {
            t[i] = 0;
        }
    }

    int get(int v, int l, int r, int ll, int rr) {
        if (ll > rr) {
            return 0;
        }
        if (l == ll && r == rr) {
            return t[v];
        }
        int m = (l + r) / 2;
        return get(v * 2 + 1, l, m, ll, min(m, rr)) + get(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
    }

    void update(int v, int l, int r, int i, int x) {
        if (l == r) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            update(v * 2 + 1, l, m, i, x);
        }
        else {
            update(v * 2 + 2, m + 1, r, i, x);
        }
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void update(int i, int x) {
        update(0, 0, n - 1, i, x);
    }

    int get(int l, int r) {
        return get(0, 0, n - 1, l, r);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    int a[n][m];
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> a[i][j];
        }
    }

    int dp[n][m];
    dp[n - 1][m - 1] = 0;
    for (int i = n - 2; i >= 0; i --) {
        dp[i][m - 1] = dp[i + 1][m - 1];
        for (int j = i + 1; j < n; j ++) {
            if (a[i][m - 1] > a[j][m - 1]) {
                dp[i][m - 1] ++;
            }
        }
    }
    for (int i = m - 2; i >= 0; i --) {
        dp[n - 1][i] = dp[n - 1][i + 1];
        for (int j = i + 1; j < m; j ++) {
            if (a[n - 1][i] > a[n - 1][j]) {
                dp[n - 1][i] ++;
            }
        }
    }

    int ans1[n][m];
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            ans1[i][j] = 0;
        }
    }

    for (int i = n - 2; i >= 0; i --) {
        st t;
        t.build(n * m + 1);

        for (int j = i; j <= n - 1; j ++) {
            t.update(a[j][m - 1], 1);
        }

        for (int j = m - 2; j >= 0; j --) {
            int cnt = 0;
            for (int k = n - 1; k >= i; k --) {
                cnt += t.get(0, a[k][j] - 1);

                t.update(a[k][j], 1);
            }
            ans1[i][j] = cnt;
        }
    }


    int ans2[n][m];
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            ans2[i][j] = 0;
        }
    }

    for (int i = m - 2; i >= 0; i --) {
        st t;
        t.build(n * m + 1);

        for (int j = i; j <= m - 1; j ++) {
            t.update(a[n - 1][j], 1);
        }

        for (int j = n - 2; j >= 0; j --) {
            int cnt = 0;
            for (int k = m - 1; k >= i; k --) {
                cnt += t.get(0, a[j][k] - 1);
                t.update(a[j][k], 1);
            }
            ans2[j][i] = cnt;
        }
    }

    for (int i = n - 2; i >= 0; i --) {
        for (int j = m - 2; j >= 0; j --) {
            dp[i][j] = min(dp[i][j + 1] + ans1[i][j], dp[i + 1][j] + ans2[i][j]);
        }
    }

    cout << dp[0][0] << '\n';
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}