#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN=1e5+5;
int ans[MAXN];

struct dsu {
    vector<int> p,rank;
    vector<char> good;
    void build(int n) {
        p.assign(n,0);
        rank.assign(n,1);
        good.assign(n,false);
        for (int i=0;i<n;++i) {
            p[i]=i;
            if (ans[i]) good[i]=true;
        }
    }
    int find(int x) {
        int r=x;
        while (p[r]!=r) r=p[r];
        int i=x;
        while (p[i]!=r) {
            int j=p[i];
            p[i]=r;
            i=j;
        }
        return r;
    }
    void unite(int x, int y) {
        x=find(x);
        y=find(y);
        if (x==y) return;
        if (rank[x]>rank[y]) {
            p[y]=x;
            rank[x]+=rank[y];
            good[x]=good[x]||good[y];
        }
        else {
            p[x]=y;
            rank[y]+=rank[x];
            good[y]=good[x]||good[y];
        }
    }
    bool is_good(int x) {
        return good[find(x)];
    }
};

struct dot {
    int x,y;
};

long long dist(const dot &a, const dot &b) {
    return (a.x-b.x)*1LL*(a.x-b.x)+(a.y-b.y)*1LL*(a.y-b.y);
}

int n,r;
dot dots[MAXN];
vector<int> g[MAXN];
vector<int> visited;
char used[MAXN];

void dfs(int v) {
    used[v]=true;
    visited.push_back(v);
    for (auto u : g[v]) {
        if (used[u]) {
            vector<int> cycle;
            for (int i=visited.size()-1;i>=0;--i) {
                if (visited[i]!=u) cycle.push_back(visited[i]);
                else {
                    cycle.push_back(u);
                    break;
                }
            }
            if (cycle.size()%2==1 && cycle.size()>1) {
                for (auto vert : cycle) ans[vert]=1;
            }
            continue;
        }
        dfs(u);
    }
    visited.pop_back();
}

multiset<pair<int,int>> st;
map<pair<int,int>,int> mp;
void solve() {
    cin>>n>>r;
    fill(ans, ans+n, 0);
    fill(used, used+n, false);
    for (int i=0;i<n;++i) cin>>dots[i].x>>dots[i].y, st.insert({dots[i].x,dots[i].y}), mp[{dots[i].x,dots[i].y}]=i;
    for (int i=0;i<n;++i) {
        for (int dx=-r;dx<=r;++dx) {
            for (int dy=-r;dy<=r;++dy) {
                if (st.find({dots[i].x+dx, dots[i].y+dy}) != st.end()) {
                    int idx=mp[{dots[i].x+dx, dots[i].y+dy}];
                    if (idx == i) continue;
                    if (dist(dots[i],dots[idx])<=r*1LL*r) {
                        g[i].push_back(idx);
                    }
                }
            }
        }
    }
    for (int i=0;i<n;++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    dsu D; D.build(n);
    for (int i=0;i<n;++i) {
        for (auto j:g[i]) {
            D.unite(i,j);
        }
    }
    for (int i=0;i<n;++i) {
        if (D.is_good(i)) {
            cout<<"1";
        }
        else {
            cout<<"0";
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}