#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN=1e5+5;
int ans[MAXN];

struct dsu {
    vector<int> p,rank;
    vector<char> good;
    void build(int n) {
        p.assign(n,0);
        rank.assign(n,1);
        good.assign(n,false);
        for (int i=0;i<n;++i) {
            p[i]=i;
            if (ans[i]) good[i]=true;
        }
    }
    int find(int x) {
        int r=x;
        while (p[r]!=r) r=p[r];
        int i=x;
        while (p[i]!=r) {
            int j=p[i];
            p[i]=r;
            i=j;
        }
        return r;
    }
    void unite(int x, int y) {
        x=find(x);
        y=find(y);
        if (x==y) return;
        if (rank[x]>rank[y]) {
            p[y]=x;
            rank[x]+=rank[y];
            good[x]=good[x]||good[y];
        }
        else {
            p[x]=y;
            rank[y]+=rank[x];
            good[y]=good[x]||good[y];
        }
    }
    bool is_good(int x) {
        return good[find(x)];
    }
};

struct dot {
    int x,y;
};

int dist(const dot &a, const dot &b) {
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

int n,r;
dot dots[MAXN];
vector<int> g[MAXN];
vector<int> visited;
char used[MAXN];

void dfs(int v) {
    used[v]=true;
    visited.push_back(v);
    for (auto u : g[v]) {
        if (used[u]) {
            vector<int> cycle;
            for (int i=visited.size()-1;i>=0;--i) {
                if (visited[i]!=u) cycle.push_back(visited[i]);
                else {
                    cycle.push_back(u);
                    break;
                }
            }
            if (cycle.size()%2==1 && cycle.size()>1) {
                for (auto vert : cycle) ans[vert]=1;
            }
            continue;
        }
        dfs(u);
    }
    visited.pop_back();
}

void solve() {
    cin>>n>>r;
    fill(ans, ans+n, 0);
    fill(used, used+n, false);
    for (int i=0;i<n;++i) cin>>dots[i].x>>dots[i].y;
    for (int i=0;i<n;++i) {
        for (int j=i+1;j<n;++j) {
            if (dist(dots[i],dots[j])<=r*r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    // int edg; cin>>edg;
    // while (edg--) {
    //     int u,v; cin>>u>>v; u--; v--;
    //     g[u].push_back(v);
    //     g[v].push_back(u);
    // }
    for (int i=0;i<n;++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    dsu D; D.build(n);
    for (int i=0;i<n;++i) {
        for (auto j:g[i]) {
            D.unite(i,j);
        }
    }
    for (int i=0;i<n;++i) {
        if (D.is_good(i)) {
            cout<<"1";
        }
        else {
            cout<<"0";
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}