// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#include <bits/stdc++.h>
using namespace std;
// #define int long long

vector<int> merge(const vector<int> &a, const vector<int> &b) {
    int n=a.size(), m=b.size();
    int i=0,j=0;
    vector<int> res;
    while (i<n && j <m) {
        if (a[i]<b[j]) res.push_back(a[i++]);
        else res.push_back(b[j++]);
    }
    while (i<n) {
        res.push_back(a[i++]);
    }
    while (j<m) {
        res.push_back(b[j++]);
    }
    return res;
}

int anmerge(vector<int> &a, int l, int m, int r) {
    int i=l,j=m;
    vector<int> res;
    int ret=0;
    while (i<m && j<r) {
        if (a[i]<=a[j]) res.push_back(a[i++]);
        else res.push_back(a[j++]), ret+=(m-i);
    }
    while (i<m) {
        res.push_back(a[i++]);
    }
    while (j<r) {
        res.push_back(a[j++]);
    }
    a=res;
    return ret;
}

int merge_sort(vector<int> &arr, int l, int r) {
    if (r-l == 1) return 0;
    if (r-l == 2) {
        int ret=0;
        if (arr[l]>arr[r-1]) swap(arr[l],arr[r-1]), ret++;
        return ret;
    }
    int mid=(l+r)/2;
    int ret=merge_sort(arr, l, mid) + merge_sort(arr, mid, r) + anmerge(arr, l, mid, r);
    return ret;
}

const int inf=1e18;
int r,c;
vector<vector<int>> a;

void solve() {
    cin>>r>>c;
    a.assign(r, vector<int>(c,0));
    for (int i=0;i<r;++i) {
        for (int j=0;j<c;++j) {
            cin>>a[i][j];
        }
    }
    vector<vector<int>> dp(r, vector<int>(c, inf));
    vector<vector<vector<int>>> state(r, vector<vector<int>>(c, vector<int>()));
    dp[0][0]=0;
    int ans=inf;
    for (int i=0;i<r;++i) {
        for (int j=0;j<c;++j) {
            if (j==c-1) {
                vector<int> new_state;
                for (int k=i;k<r;++k) {
                    new_state.push_back(a[k][j]);
                }
                int cnt=merge_sort(new_state, 0,new_state.size());
                for (int val : new_state) {
                    int pos = upper_bound(state[i][j].begin(), state[i][j].end(), val) - state[i][j].begin();
                    cnt+=pos;
                }
                ans=min(ans, dp[i][j] + cnt);
            }
            if (j+1<c) {
                vector<int> new_state;
                for (int k=i;k<r;++k) {
                    new_state.push_back(a[k][j]);
                }
                int cnt=merge_sort(new_state, 0,new_state.size());
                state[i][j+1]=merge(state[i][j], new_state);
                for (int val : new_state) {
                    int pos = upper_bound(state[i][j].begin(), state[i][j].end(), val) - state[i][j].begin();
                    cnt+=pos;
                }
                dp[i][j+1]=min(dp[i][j+1], dp[i][j] + cnt);
            }
            if (i==r-1) {
                vector<int> new_state;
                for (int k=j;k<c;++k) {
                    new_state.push_back(a[i][k]);
                }
                int cnt=merge_sort(new_state, 0,new_state.size());
                for (int val : new_state) {
                    int pos = upper_bound(state[i][j].begin(), state[i][j].end(), val) - state[i][j].begin();
                    cnt+=pos;
                }
                ans=min(ans, dp[i][j] + cnt);
            }
            if (i+1<r) {
                vector<int> new_state;
                for (int k=j;k<c;++k) {
                    new_state.push_back(a[i][k]);
                }
                int cnt=merge_sort(new_state, 0,new_state.size());
                state[i+1][j]=merge(state[i][j], new_state);
                for (int val : new_state) {
                    int pos = upper_bound(state[i][j].begin(), state[i][j].end(), val) - state[i][j].begin();
                    cnt+=pos;
                }
                dp[i+1][j]=min(dp[i+1][j], dp[i][j] + cnt);
            }
        }
    }
    cout<<ans<<'\n';
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}