#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

using pii = pair<int, int>;
const int INF = 1e12;


struct Tree {
    vector<int> tree;
    int sz = 1;

    Tree(int n) {
        while (sz < n) sz *= 2;
        tree.resize(2 * sz - 1);
    }

    void upd(int x, int tl, int tr, int i, int add) {
        tree[x] += add;
        if (tl + 1 == tr) {
            return;
        }
        int m = (tl + tr) / 2;
        if (i < m) {
            upd(2 * x + 1, tl, m, i, add);
        } else {
            upd(2 * x + 2, m, tr, i, add);
        }
    }

    void upd(int i, int add) {
        upd(0, 0, sz, i, add);
    }

    int sum(int x, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) {
            return tree[x];
        } if (l >= tr || tl >= r) {
            return 0;
        }
        int m = (tl + tr) / 2;
        return sum(2 * x + 1, tl, m, l, r) + sum(2 * x + 2, m, tr, l, r);
    }

    int sum(int l, int r) {
        return sum(0, 0, sz, l, r);
    }

};



void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    if (n == 1) {
        Tree tree(m);
        int ans = 0;
        for (int i = 0; i < m; i++) {
            ans += tree.sum(a[0][i], m);
            tree.upd(a[0][i] - 1, 1);
        }
        cout << ans;
        return;
    }
    // Tree tree1(n * m), tree2(m * n), tree3(m * n);

    // int ans1 = 0, ans2 = 0;
    // for (int i = 0; i < 2 * m; i++) {
    //     ans1 += tree1.sum(a[i / m][i % m], n * m);
    //     if (i < m)
    //         tree1.upd(a[i / m][i % m], 1);
    // }
    // for (int i = 0; i < m; i++) {
    //     ans2 += tree2.sum(a[1][i], n * m);
    //     tree2.upd(a[1][i], 1);
    // }
    // int ans = INF, curr_ans = 0;
    // for (int i = 0; i < m; i++) {
    //     ans = min(ans, curr_ans + ans1 + ans2);
    //     for (int j = 0; j < 2; j++) {
    //         curr_ans += tree3.sum(a[j][i], n * m);
    //         tree3.upd(a[j][i], 1);
    //     }
    //     ans1 -= tree1.sum(0, a[0][i]);
    //     tree1.upd(a[0][i], -1);
    //     ans2 -= tree2.sum(0, a[1][i]);
    //     tree2.upd(a[1][i], -1);
    // }
    // cout << ans;
    int ans = 0;
    Tree tree(n * m);
    for (int i = 0; i < n * m; i++) {
        ans += tree.sum(a[i / m][i % m], n * m);
        tree.upd(a[i / m][i % m], 1);
    }
    tree.tree.assign(2 * tree.sz - 1, 0);
    for (int i = 1; i < m; i++) {
        tree.upd(a[0][i], 1);
    }
    int res = ans;
    for (int i = 0; i < m - 1; i++) {
        ans += -tree.sum(a[1][i], n * m) + tree.sum(0, a[1][i]);
        res = min(res, ans);
    }
    cout << res;

}

signed main() {
    cin.tie(0);
    cout.tie(0);
    // ios_base::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}