#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

using pii = pair<int, int>;
const int INF = 1e12;


struct Tree {
    vector<pii> minn;
    vector<pii> maxx;
    int sz = 1;

    void build(int x, int tl, int tr, vector<int> &a) {
        if (tl + 1 == tr) {
            if (tl < a.size()) {
                minn[x] = maxx[x] = {a[tl], tl};
            } else {
                minn[x] = {INF, a.size()};
                maxx[x] = {-INF, a.size()};
            }
            return;
        }
        int m = (tl + tr) / 2;
        build(2 * x + 1, tl, m, a);
        build(2 * x + 2, m, tr, a);
        minn[x] = min(minn[2 * x + 1], minn[2 * x + 2]);
        maxx[x] = max(maxx[2 * x + 1], maxx[2 * x + 2]);
    }

    Tree(int n, vector<int> &a) {
        while (sz < n) sz *= 2;
        maxx.assign(2 * sz - 1, {-INF, n});
        minn.assign(2 * sz - 1, {INF, n});
        build(0, 0, sz, a);
    }

    pii uni1(pii a, pii b) {
        if (a.first > b.first)
            return a;
        return b;
    }

    pii get_min_(int x, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) {
            return minn[x];
        } if (l >= tr || tl >= r) {
            return {INF, x};
        }
        int m = (tl + tr) / 2;
        return min(get_min_(2 * x + 1, tl, m, l, r), get_min_(2 * x + 2, m, tr, l, r));
    }

    pii getmin(int l, int r) {
        return get_min_(0, 0, sz, l, r);
    }

    pii get_max_(int x, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) {
            return maxx[x];
        } if (l >= tr || tl >= r) {
            return {-INF, x};
        }
        int m = (tl + tr) / 2;
        return max(get_max_(2 * x + 1, tl, m, l, r), get_max_(2 * x + 2, m, tr, l, r));
    }

    pii getmax(int l, int r) {
        return get_max_(0, 0, sz, l, r);
    }
};


void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    Tree tree(n, a);
    pii res = {INF, INF};
    for (int i = 1; i < n; i++) {
        int i1 = tree.getmax(0, i).first;
        int i2 = tree.getmax(i, n).first;
        res = min(res, {i1, i2});
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        if (i == 1) {
            cout << res.first << '\n';
        } else {
            cout << res.second << "\n";
        }
    }

}

signed main() {
    cin.tie(0);
    cout.tie(0);
    // ios_base::sync_with_stdio(false);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}