#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

struct point {
    ll x = 0, y = 0;

    point() = default;

    point(ll x_, ll y_) : x(x_), y(y_) {
    }

    point operator -() const {
        return {-x, -y};
    }

    point operator +(const point &p) const {
        return {x + p.x, y + p.y};
    }

    ll operator *(const point &p) const {
        return x * p.x + y * p.y;
    }

    ll operator %(const point &p) const {
        return x * p.y - y * p.x;
    }
};

ll dist2(point p1, point p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

ll r;
vector<point> p;
unordered_map<ll, int> st;
// bool operator < (const)

int dfs(const vector<vector<int>> & gr, vector<pair<int, int>> & used, int cur, int start, int col) {
    used[cur] = {col, start};

    int a = 0;
    for (auto v : gr[cur]) {
        if (used[v].first == 0) {
            a += dfs(gr, used, v, start, col ^ 1);
        } else if (used[v].first == col) {
            a += 1;
        }
    }
    return a > 0;
}

void solve() {
    int n;
    cin >> n >> r;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
    }

    vector<vector<int> > gr(n);
    int C = 0;

    if (r < C) {
        for (int i = 0; i < n; ++i) {
            for (ll x = min(0ll, p[i].x - r); x <= p[i].x + r; ++x) {
                for (ll y = min(0ll, p[i].y - r); y <= p[i].y + r; ++y) {
                    if (x == p[i].x && y == p[i].y) continue;
                    if (dist2({x, y}, p[i]) > r * r) continue;
                    int idx = st[10e9 * x + y];
                    if (idx > 0) gr[i].push_back(idx - 1);
                }
            }
        }
    }
    else {
        for (int i = 0; i < n - 1; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (dist2(p[i], p[j]) <= r * r) {
                    gr[i].push_back(j);
                    gr[j].push_back(i);
                }
            }
        }
    }
    vector<int> ans(n);
    vector<pair<int, int>> used(n);

    for (int i = 0; i < n; ++i) {
        if (used[i].first == 0) {
            ans[i] = dfs(gr, used, i, i, 3);
            cout << ans[i];
        } else {
            cout << ans[used[i].second];
        }
    }
}
