#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}


int r, c;
int buff[2200000];

ll merge(vector<int> & a, int l, int m, int r) {
    int i = 0;
    int j = 0;
    ll cnt = 0;

    while (i + l < m && j + m < r) {
        if (a[i + l] <= a[j + m]) {
            buff[i + j] = a[i + l];
            ++i;
            cnt += j;
        } else {
            buff[i + j] = a[j + m];
            ++j;
        }
    }
    while (i + l < m) {
        buff[i + j] = a[i + l];
        ++i;
        cnt += j;
    }
    while (j + m < r) {
        buff[i + j] = a[j + m];
        ++j;
    }
    for (int idx = 0; idx < r - l; ++idx) {
        a[l + idx] = buff[idx];
        buff[idx] = 0;
    }
    return cnt;
}

ll merge_sort(vector<int> & a, int l, int r) {
    if (r - l == 1) {
        return 0;
    }
    if (r - l == 2) {
        int inv = 0;
        if (a[l] > a[l + 1]) {
            swap(a[l], a[l + 1]);
            inv = 1;
        }
        return inv;
    }
    int m = (l + r) / 2;
    ll inv1 = merge_sort(a, l, m);
    ll inv2 = merge_sort(a, m, r);
    return inv1 + inv2 + merge(a, l, m, r);
}

void solve() {
    cin >> r >> c;
    vector<vector<int> > a(r, vector<int>(c));

    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    if (r + c <= 14) {
        vector<int> t(r * c);
        ll ans = 1e9;
        for (int x = 0; x < 1 << r + c; ++x) {
            int idx = 0;
            int idx_r = 0;
            int idx_c = 0;
            int y = x;
            bool fail = false;
            for (int b = 0; b < r + c; ++b) {
                if (y & 1) {
                    if (idx_c >= c) fail = true;
                    for (int i = idx_r; i < r; ++i) {
                        t[idx++] = a[i][idx_c];
                    }
                    ++idx_c;
                } else {
                    if (idx_r >= r) fail = true;
                    for (int j = idx_c; j < c; ++j) {
                        t[idx++] = a[idx_r][j];
                    }
                    ++idx_r;
                }
                if (idx >= r * c) break;
                y >>= 1;
                if (fail) break;
            }
            if (fail) continue;
            vector<int> t_copy = t;
            ll inv = merge_sort(t, 0, r * c);
            ans = min(ans, inv);
        }
        cout << ans;
    } else if (r == 1) {
        vector<int> t(c);
        for (int i = 0; i < c; ++i) {
            t[i] = a[0][i];
        }
        cout << merge_sort(t, 0, c);
    } else if (r * c <= 10000) {
        vector<vector<ll>> ver_inv(r, vector<ll>(c));
        vector<vector<ll>> gor_inv(r, vector<ll>(c));

        for (int j = 0; j < c; ++j) {
            for (int i = 0; i < r - 1; ++i) {

                vector<int> t(r - i);
                for (int idx = i; idx < r; ++idx) {
                    t[idx - i] = a[idx][j];
                }
                ver_inv[i][j] = merge_sort(t, 0, r - i);
            }
        }

        for (int i = 0; i < r; ++i) {
            for (int j = 0; j < c - 1; ++j) {
                vector<int> t(c - j);
                for (int idx = j; idx < c; ++idx) {
                    t[idx - j] = a[i][idx];
                }
                gor_inv[i][j] = merge_sort(t, 0, c - j);
            }
        }
        vector<vector<ll>> sum_ver(r, vector<ll>(c));
        vector<vector<ll>> sum_gor(r, vector<ll>(c));
        for (int j = 0; j < c; ++j) {
            vector<int> t(r * (c - j));
            for (int i = 1; i < r; ++i) {
                for (int idx = 0; idx < r; ++idx) {
                    for (int jdx = j; jdx < c; ++jdx) {
                        t[idx * (c - j) + jdx - j] = a[idx][jdx];
                    }
                }
                merge_sort(t, 0, i * (c - j));
                merge_sort(t, i * (c - j), r * (c - j));
                sum_ver[i - 1][j] = merge(t, 0, i * (c - j), r * (c - j));
            }
        }
        for (int i = 0; i < r; ++i) {
            vector<int> t(c * (r - i));
            for (int j = 1; j < c; ++j) {
                for (int jdx = 0; jdx < c; ++jdx) {
                    for (int idx = i; idx < r; ++idx) {
                        t[jdx * (r - i) + idx - i] = a[idx][jdx];
                    }
                }
                merge_sort(t, 0, j * (r - i));
                merge_sort(t, j * (r - i), c * (r - i));
                sum_gor[i][j - 1] = merge(t, 0, j * (r - i), c * (r - i));
            }
        }
        vector<vector<ll>> dp(r, vector<ll>(c, 1e18));
        dp[0][0] = 0;
        for (int i = 0; i < r; ++i) {
            for (int j = 0; j < c; ++j) {
                if (i < r - 1) {
                    dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + ver_inv[i][j] + sum_ver[i][j]);
                }
                if (j < c - 1) {
                    dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + gor_inv[i][j] + sum_gor[i][j]);
                }
            }
        }
        cout << dp[r - 1][c - 1];
    }
}
