#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

struct SegTree{
	int size;
	vl tree;
	SegTree(int n,vl nums){
		size = 1;
		while(size < n)size *= 2;
		tree.assign(size * 2, 0);
		for(int i = 0;i < n;i++){
			tree[i+size-1] = nums[i];
		}
		init(0);
	}
	void init(int x){
		if(x >= size - 1)return;
		init(x*2+1);
		init(x*2+2);
		tree[x] = max(tree[x*2+1],tree[x*2+2]);
	}
	int get(int l,int r,int x,int lx,int rx){
		if(lx >= r || rx <= l)return 0;
		if(lx >= l && rx <= r)return tree[x];
		int m = lx + (rx - lx) / 2;
		return max(get(l,r,x*2+1,lx,m),get(l,r,x*2+2,m,rx));
	}
	int get(int l,int r){
		return get(l,r,0,0,size);
	}
};

void solve(){
	int n,q;
	cin>>n>>q;
	vl nums(n,0);
	for(auto &i:nums)cin>>i;
	SegTree tree(n,nums);

	while(q--){
		int k,x;
		cin>>k>>x;
		if(k == x)cout<<tree.get(x - 1, n)<<"\n";
		else cout<<nums[x-1]<<"\n";
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0),cout.tie(0);

	/*freopen("in.txt","r",stdin);
	freopen("out.txt","w",stdout);/* */

	solve();

	return 0;
}