// TaskB.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>

using namespace std;

using ll = long long;
using ld = long double;

struct Point {
	ll x, y;
	Point() {}
	Point(ll xx, ll xy) : x(xx), y(xy) {}
	Point operator-(Point p) {
		return { x - p.x, y - p.y };
	}
	ll sqrlen() {
		return x * x + y * y;
	}
};

ll n, r;

vector<Point> ps;

bool cross(int v, int u) {
	ll d = (ps[v] - ps[u]).sqrlen();
	return (d <= r * r);
}

vector<vector<int>> ost;
vector<vector<int>> pos;
vector<int> used;
vector<vector<int>> dp;

vector<pair<ll, ll>> mp;

void dfs(int v, int cur = 0) {
	used[v] = 1;
	if (dp[v][cur] == 1) {
		return;
	}
	dp[v][cur] = 1;
	int p = pos[cur][v];
	int val = ost[cur].back();
	pos[cur][val] = p;
	swap(ost[cur][p], ost[cur].back());
	ost[cur].pop_back();
	pos[cur][v] = -1;
	int cx = ps[v].x;
	int cy = ps[v].y;
	for (ll x = cx - r; x <= cx + r; x++) {
		for (ll y = cy - r; y <= cy + r; y++) {
			auto val = lower_bound(mp.begin(), mp.end(), make_pair((ll)x * (ll)1e9 + y, -1ll));
			if (val == mp.end() || val->first != x * 1e9 + y) {
				continue;
			}
			int i = val->second;
			if (pos[cur ^ 1][i] != -1 && cross(v, i) && i != v) {
				dfs(i, cur ^ 1);
			}

		}
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> r;
	ps.resize(n);
	for (int i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		ps[i] = { x, y };
		mp.push_back({ x * 1e9 + y, i });
	}
	sort(mp.begin(), mp.end());
	pos.resize(2, vector<int>(n));
	ost.resize(2, vector<int>(n));
	for (int i = 0; i < n; i++) {
		ost[0][i] = i;
		pos[0][i] = i;
		ost[1][i] = i;
		pos[1][i] = i;
	}
	used.resize(n);
	dp.resize(n, vector<int>(2));
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			dfs(i);
		}
	}
	for (int i = 0; i < n; i++) {
		if (dp[i][0] == dp[i][1] && dp[i][0] == 1) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
	cout << '\n';
}
