// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

vector<vector<int>> graph;
vector<int> used;

bool dfs_is_bipart(int v, int c) {
    used[v] = c;
    bool flag = true;
    for (auto u : graph[v]) {
        if (used[u] == -1) {
            auto cur_flag = dfs_is_bipart(u, !c);
            flag = (flag && cur_flag);
        } else if (used[u] == used[v]) {
            flag = false;
        }
    }
    return flag;
}

void dfs_color(int v, int c) {
    used[v] = c;
    for (auto u : graph[v]) {
        if (used[u] != c) dfs_color(u, c);
    }
}

struct point {
    ll x, y;
    int ind;
};

bool is_close(const point &a, const point &b, ll r) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}

void solve() {
    int n;
    ll r;
    cin >> n >> r;
    vector<point> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        p[i].ind = i;
    }

    ll d = ceil(sqrt(ld(r * r) / 2));
    // cerr << d << endl;
    if (2 * (d - 1) * (d - 1) > r * r) {
        while (true) {
            cerr << "D TOO LARGE" << endl;
        }
    }

    map<pair<ll, ll>, vector<int>> blocks;
    for (auto &[x, y, ind] : p) {
        blocks[{x / d, y / d}].push_back(ind);
    }

    graph.resize(n);
    int cur_block_ind;
    for (auto &[cur_point, v] : blocks) {
        auto &[bx, by] = cur_point;
        if (v.size() >= 3) {
            graph[v[0]].push_back(v[1]);
            graph[v[1]].push_back(v[0]);
            graph[v[0]].push_back(v[2]);
            graph[v[2]].push_back(v[0]);
            graph[v[1]].push_back(v[2]);
            graph[v[2]].push_back(v[1]);
            for (int i = 3; i < v.size(); i++) {
                graph[v[i]].push_back(v[0]);
                graph[v[0]].push_back(v[i]);
            }
        }
        for (int nx = bx - 2; nx <= bx + 2; nx++) {
            for (int ny = by - 2; ny <= by + 2; ny++) {
                if (blocks.find(pair<ll, ll>{nx, ny}) != blocks.end()) {
                    if (blocks[{nx, ny}].size() >= 3) continue;
                    for (auto &ind : blocks[{nx, ny}]) {
                        for (auto &ind1 : v) {
                            if (is_close(p[ind], p[ind1], r)) {
                                graph[ind].push_back(ind1);
                                graph[ind1].push_back(ind);
                            }
                        }
                    }
                }
            }
        }
    }

    int run_cnt = 0;
    for (int i = 0; i < n; i++) {
        run_cnt = 0;
        for (int j = 0; j < graph[i].size(); j++) {
            if (graph[i][j] == i) {
                swap(graph[i][j], graph[i][run_cnt]);
                run_cnt++;
            }
        }
        graph[i].erase(graph[i].begin(), graph[i].begin() + run_cnt);
    }

    // for (int i = 0; i < n; i++) { cerr << i << ": "; for (auto &el : graph[i]) { cerr << el << ' '; } cerr << endl; }

    used.resize(n, -1);
    for (int i = 0; i < n; i++) {
        if (used[i] == -1) {
            dfs_color(i, 2 + !dfs_is_bipart(i, 0));
        }
    }
    for (auto &el : used) cout << el - 2;
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
/*
0 5

*/
