// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

struct fenwick {
    int r, c;
    vector<vector<int>> t;

    fenwick(int _r, int _c) {
        r = _r;
        c = _c;
        t.resize(r + 1, vector<int>(c + 1, 0));
    }

    int get(int x, int y) {
        int res = 0;
        for (int i = x; i > 0; i = (i & (i - 1))) {
            for (int j = y; j > 0; j = (j & (j - 1))) {
                res += t[i][j];
            }
        }
        return res;
    }

    int get(int x1, int y1, int x2, int y2) {
        return get(x2, y2) - get(x2, y1) - get(x1, y2) + get(x1, y1);
    }

    void add(int x, int y, int val) {
        x++;
        y++;
        for (int i = x; i <= r; i += i - (i & (i - 1))) {
            for (int j = y; j <= c; j += j - (j & (j - 1))) {
                // cerr << i << ' ' << j << ' ' << endl;
                t[i][j] += val;
            }
        }
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> v(r, vector<int>(c));
    for (auto &el : v) {
        for (auto &el1 : el) {
            cin >> el1;
            el1--;
        }
    }

    vector<pair<int, int>> pos(r * c);
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            pos[v[i][j]] = {i, j};
        }
    }

    ll res = 0;
    fenwick fw(r, c);
    vector<vector<vector<int>>> row_data(r, vector<vector<int>>(c));
    for (int val = r * c - 1; val >= 0; val--) {
        auto &[x, y] = pos[val];
        res += fw.get(0, 0, x + 1, y + 1);
        row_data[x][y].resize(x);
        for (int i = 0; i < x; i++) {
            row_data[x][y][i] = fw.get(i, y + 1, i + 1, c);
        }
        fw.add(x, y, 1);
    }

    // cerr << "DONE" << ' ' << res << endl;

    vector<vector<ll>> dp(r, vector<ll>(c));
    ll cur_val;
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            cur_val = 0;
            for (int t = i + 1; t < r; t++) {
                cur_val += row_data[t][j][i];
            }
            dp[i][j] = min((i + 1 < r ? dp[i + 1][j] : 0) + cur_val, (j + 1 < c ? dp[i][j + 1] : 0) + ll(r - i - 1) * ll(c - j - 1) - cur_val);
        }
    }
    // for (auto &el : dp) { for (auto &el1 : el) cerr << el1 << ' ' ; cerr << endl; }
    res += dp[0][0];
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
/*
0 5

*/
