// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define int ll

struct fenwick {
    int r, c;
    vector<vector<int>> t;

    fenwick(int _r, int _c) {
        r = _r;
        c = _c;
        t.resize(r + 1, vector<int>(c + 1, 0));
    }

    int get(int x, int y) {
        int res = 0;
        for (int i = x; i > 0; i = (i & (i - 1))) {
            for (int j = y; j > 0; j = (j & (j - 1))) {
                res += t[i][j];
            }
        }
        return res;
    }

    int get(int x1, int y1, int x2, int y2) {
        return get(x2, y2) - get(x2, y1) - get(x1, y2) + get(x1, y1);
    }

    void add(int x, int y, int val) {
        x++;
        y++;
        for (int i = x; i <= r; i += i - (i & (i - 1))) {
            for (int j = y; j <= c; j += j - (j & (j - 1))) {
                // cerr << i << ' ' << j << ' ' << endl;
                t[i][j] += val;
            }
        }
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    vector<vector<int>> v(r, vector<int>(c));
    for (auto &el : v) {
        for (auto &el1 : el) {
            cin >> el1;
            el1--;
        }
    }

    vector<pair<int, int>> pos(r * c);
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            pos[v[i][j]] = {i, j};
        }
    }

    ll res = 0;
    fenwick fw(r, c);
    vector<vector<vector<int>>> row_data(r, vector<vector<int>>(c));
    for (int val = r * c - 1; val >= 0; val--) {
        auto &[x, y] = pos[val];
        res += fw.get(0, 0, x + 1, y + 1);
        // cerr << 'p';
        row_data[x][y].resize(x + 1);
        // cerr << 'g';
        for (int i = 0; i < row_data[x][y].size(); i++) {
            row_data[x][y][i] = fw.get(i, y + 1, x, c);
        }
        // cerr << 'k';
        fw.add(x, y, 1);
        // cerr << 't';
        // for (int a = 0; a < r; a++) { for (int b = 0; b < c; b++) {cerr << fw.get(a, b, a + 1, b + 1) << ' '; } cerr << endl; } cerr << endl;
    }

    // cerr << "DONE" << ' ' << res << endl;

    vector<vector<ll>> corner_data(r + 1, vector<ll>(c + 1));
    for (int x = 0; x < r; x++) {
        for (int y = 0; y < c; y++) {
            for (int i = 0; i < x; i++) {
                corner_data[i][y] += row_data[x][y][i] - row_data[x][y][i + 1];
            }
        }
    }
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            corner_data[i][j] += corner_data[i + 1][j] + corner_data[i][j + 1] - corner_data[i + 1][j + 1];
        }
    }

    // cerr << "DONE" << ' ' << res << endl;

    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1));
    ll A, B, C, D, ABCD, AC, BC;
    for (int i = r - 1; i >= 0; i--) {
        for (int j = c - 1; j >= 0; j--) {
            ABCD = corner_data[i][j];
            D = corner_data[i + 1][j + 1];
            AC = 0;
            for (int t = i + 1; t < r; t++) {
                AC += row_data[t][j][i];
            }
            B = ABCD - AC - D;
            A = 0;
            for (int t = i + 1; t < r; t++) {
                A += row_data[t][j][i + 1];
            }
            C = AC - A;
            BC = B + C;
            // cerr << A << ' ' << B << ' ' << c << ' ' << D << endl;
            dp[i][j] = min(dp[i][j + 1] + ll(c - j - 1) * (r - i - 1) * (r - i) / 2 - AC, dp[i + 1][j] + BC);
        }
    }
    // for (auto &el : dp) { for (auto &el1 : el) cerr << el1 << ' ' ; cerr << endl; }
    res += dp[0][0];
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
/*
3 3
2 1 5
8 6 3
9 4 7


*/
