// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

const int LOG = 20;

struct sparse_table {
    int n;
    array<vector<pair<int, int>>, LOG> t_min;
    array<vector<pair<int, int>>, LOG> t_max;
    vector<int> logs;

    sparse_table(int _n, const vector<int> &v) {
        n = _n;
        for (auto &el : t_min) el.resize(n);
        for (auto &el : t_max) el.resize(n);
        for (int i = 0; i < n; i++) {
            t_min[0][i] = t_max[0][i] = {v[i], i};
        }
        for (int p = 1; p < LOG; p++) {
            for (int i = 0; i + (1 << p) <= n; i++) {
                t_min[p][i] = min(t_min[p - 1][i], t_min[p - 1][i + (1 << (p - 1))]);
                t_max[p][i] = max(t_max[p - 1][i], t_max[p - 1][i + (1 << (p - 1))]);
            }
        }

        logs.resize(n + 1, -1);
        for (int i = 1; i < logs.size(); i++) {
            logs[i] = logs[i - 1] + !(i & (i - 1));
        }
    }

    pair<int, int> get_min(int l, int r) {
        return min(t_min[logs[r - l]][l], t_min[logs[r - l]][r - (1 << logs[r - l])]);
    }

    pair<int, int> get_max(int l, int r) {
        return max(t_max[logs[r - l]][l], t_max[logs[r - l]][r - (1 << logs[r - l])]);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (auto &el : v) {
        cin >> el;
        el--;
    }

    map<int, vector<pair<int, int>>> reqs;
    int inp_k, inp_ind;
    for (int i = 0; i < q; i++) {
        cin >> inp_k >> inp_ind;
        inp_ind--;
        reqs[inp_k].push_back({inp_ind, i});
    }

    //cerr << 'a';
    sparse_table st(n, v);
    //cerr << 'a';

    vector<int> nb(n, n);
    vector<int> tmp_st;
    for (int i = 0; i < n; i++) {
        while (!tmp_st.empty() && v[tmp_st.back()] < v[i]) {
            nb[tmp_st.back()] = i;
            tmp_st.pop_back();
        }
        tmp_st.push_back(i);
    }

    vector<int> res(q);
    vector<int> bounds;
    for (auto &[k, cur_reqs] : reqs) {
        bounds.resize(k + 1);
        if (k == 1) {
            bounds[0] = 0;
            bounds[1] = n;
        } else {
            bounds[0] = 0;
            for (int i = 1; i < k - 1; i++) {
                // cerr << min(nb[bounds[i - 1]], n - (k - i)) << endl;
                bounds[i] = max(st.get_min(bounds[i - 1], min(nb[bounds[i - 1]], n - (k - i)) + 1).ss, bounds[i - 1] + 1);
            }
            bounds[k - 1] = min(nb[bounds[k - 2]], n - 1);
            bounds[k] = n;
        }
        for (auto [cur_ind, cur_i] : cur_reqs) {
            //cerr << 'a';
            res[cur_i] = st.get_max(bounds[cur_ind], bounds[cur_ind + 1]).ff;
            //cerr << 'a';
        }
    }
    for (auto &el : res) cout << el + 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
/*
4 3
4 1 3 2
3 1
3 2
3 3
*/
