// #define _GLIBCXX_DEBUG

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target("avx2")

using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

const int LOG = 20;

struct sparse_table {
    int n;
    array<vector<pair<int, int>>, LOG> t_min;
    array<vector<pair<int, int>>, LOG> t_max;
    vector<int> logs;

    sparse_table(int _n, const vector<int> &v) {
        n = _n;
        for (auto &el : t_min) el.resize(n);
        for (auto &el : t_max) el.resize(n);
        for (int i = 0; i < n; i++) {
            t_min[0][i] = t_max[0][i] = {v[i], i};
        }
        for (int p = 1; p < LOG; p++) {
            for (int i = 0; i + (1 << p) <= n; i++) {
                t_min[p][i] = min(t_min[p - 1][i], t_min[p - 1][i + (1 << (p - 1))]);
                t_max[p][i] = max(t_max[p - 1][i], t_max[p - 1][i + (1 << (p - 1))]);
            }
        }

        logs.resize(n + 1, -1);
        for (int i = 1; i < logs.size(); i++) {
            logs[i] = logs[i - 1] + !(i & (i - 1));
        }
    }

    pair<int, int> get_min(int l, int r) {
        return min(t_min[logs[r - l]][l], t_min[logs[r - l]][r - (1 << logs[r - l])]);
    }

    pair<int, int> get_max(int l, int r) {
        return max(t_max[logs[r - l]][l], t_max[logs[r - l]][r - (1 << logs[r - l])]);
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (auto &el : v) {
        cin >> el;
    }

    sparse_table st(n, v);

    int k, ind;
    for (int i = 0; i < q; i++) {
        cin >> k >> ind;
        if (ind < k) {
            cout << v[ind - 1] << '\n';
        } else {
            cout << st.get_max(k - 1, n).ff << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int uwu = 1;
    // cin >> uwu;
    while (uwu--) solve();
}
/*
4 5
15 6 14 11 3
1 19 4 9 8
20 5 10 17 12
2 13 16 7 18

75
*/
