#include <bits/stdc++.h>
#define int long long
using namespace std;

ostream& operator<<(ostream& out, vector<int> v) {
    for (auto el : v) {
        out << el << " ";
    }
    return out << "\n";
}


int r, n;
struct Pos {
    int x, y, i = 0;
    Pos() {}
    Pos(int x, int y) : x(x), y(y) {}
    Pos(int x, int y, int i) : x(x), y(y), i(i) {}
    friend istream& operator>>(istream& in, Pos& p) {
        return in >> p.x >> p.y;
    }
    friend ostream& operator<<(ostream& out, Pos p) {
        return out << p.x << "_" << p.y;
    }
    bool to(Pos p) {
        return ((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y)) <= r * r;
    }
};

vector<vector<int>> g;
vector<int> used;
void dfs(int v, int c) {
    used[v] = c;
    for (auto u : g[v]) {
        if (used[u] == c) {
            used[v] = 3;
        }
        if (used[u] == 0) {
            dfs(u, c ^ 3);
        }
    }
}
void dfs2(int v) {
    used[v] = 3;
    for (auto u : g[v]) {
        if (used[u] != 3) {
            dfs2(u);
        }
    }
}

void solve() {
    cin >> n >> r;
    int d = r + 1;
    vector<Pos> v(n);
    unordered_map<int, unordered_map<int, vector<Pos>>> p;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        v[i] = Pos(x, y, i);
        p[x / d][y / d].emplace_back(x, y, i);
    }
    g = vector<vector<int>>(n);
    for (auto [x, y, i] : v) {
        for (int px = x / d - 1; px <= x / d + 1; px++) {
            for (int py = y / d - 1; py <= y / d + 1; py++) {
                int cnt = 0;
                for (auto t : p[px][py]) {
                    if (i != t.i && v[i].to(t)) {
                        g[i].push_back(t.i);
                        g[t.i].push_back(i);
                        cnt++;
                    }
                    if (cnt >= 3) {
                        break;
                    }
                }
            }
        }
    }
    used = vector<int>(n);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, 1);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 3) {
            dfs2(i);
        }
    }
//    cout << used;
    for (auto el : used) {
        cout << (el == 3);
    }
    cout << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
7 4
1010101
0
1
2
3

*/
