#include <bits/stdc++.h>
#define int long long
using namespace std;

ostream& operator<<(ostream& out, vector<int> v) {
    for (auto el : v) {
        out << el << " ";
    }
    return out << "\n";
}
ostream& operator<<(ostream& out, vector<vector<int>> v) {
    for (auto el : v) {
        out << el;
    }
    return out << "\n";
}

struct SQdec {
    int BLOCK = 100;
    vector<int> a, b;
    int n;
    SQdec(vector<int>& v, int BLOCK) : BLOCK(BLOCK){
        a = v;
        b = v;
        n = v.size();
        for (int i = 0; i * BLOCK < n; i++) {
            int l = i * BLOCK;
            int r = min(l + BLOCK, n);
            sort(b.begin() + l, b.begin() + r);
        }
    }
    int mn(int l, int r, int x) {
        int lb = l / BLOCK;
        int rb = r / BLOCK;
        int res = 0;
        if (lb == rb) {
            for (int i = l; i < r; i++) {
                res += a[i] < x;
            }
            return res;
        }
        for (int i = l; i < lb * BLOCK + BLOCK; i++) {
            res += a[i] < x;
        }
        for (int i = rb * BLOCK; i < r; i++) {
            res += a[i] < x;
        }
        for (int i = lb + 1; i < rb; i++) {
            int ql = -1;
            int qr = BLOCK;
            while (ql + 1 < qr) {
                int qm = (ql + qr) / 2;
                if (b[qm + i * BLOCK] < x) {
                    ql = qm;
                }
                else {
                    qr = qm;
                }
            }
            res += qr;
        }
        return res;
    }
    int mx(int l, int r, int x) {
        return r - l - mn(l, r, x);
    }
};

int n, m;
vector<vector<int>> v, dp;
vector<SQdec> sq;
vector<SQdec> sq2;

const int INF = 1e15;

int f1(int i, int j) { // 
    int res = 0;
    for (int a = 0; a <= j; a++) {
        res += sq[i].mx(a + 1, j + 1, v[i][a]);
    }
    for (int a = 0; a <= j; a++) {
        for (int i2 = 0; i2 < i; i2++) {
            res += sq[i2].mn(0, j + 1, v[i][a]);
        }
    }

    if (i != 0) {
        res += dp[i - 1][j];
    }
    return res;
}

int f2(int i, int j) { // 
    vector<int> p(i + 1);
    for (int i2 = 0; i2 <= i; i2++) {
        p[i2] = v[i2][j];
    }
    SQdec sq2(p, 10);
    int res = 0;
    for (int a = 0; a <= i; a++) {
        res += sq2.mx(a + 1, i + 1, p[a]);
    }

    for (int b = 0; b <= i; b++) {
        for (int i2 = 0; i2 <= i; i2++) {
            res += sq[i2].mn(0, j, v[b][j]);
        }
    }

    if (j != 0) {
        res += dp[i][j - 1];
    }
    return res;
}


void rev() {
    if (n <= m) return;
    vector<vector<int>> v2(m, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            v2[j][i] = v[i][j];
        }
    }
    swap(n, m);
    swap(v2, v);
}

void solve() {
    cin >> n >> m;
    v = vector<vector<int>>(n, vector<int>(m));
    for (auto& mas : v) {
        for (auto& el : mas) {
            cin >> el;
        }
        reverse(mas.begin(), mas.end());
    }
    reverse(v.begin(), v.end());
    rev();
    for (int i = 0; i < n; i++) {
        sq.emplace_back(v[i], 50);
    }
    dp = vector<vector<int>>(n, vector<int>(m, INF));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 && j == 0) {
                dp[i][j] = 0;
                continue;
            }
            int res = INF;
            res = min(res, f1(i, j));
            res = min(res, f2(i, j));
            dp[i][j] = res;
        }
    }
//    cout << dp;
    cout << dp[n - 1][m - 1] << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
7 4
1010101
0
1
2
3

*/
