#include <bits/stdc++.h>
#define int long long
using namespace std;

ostream& operator<<(ostream& out, vector<int> v) {
    for (auto el : v) {
        out << el << " ";
    }
    return out << "\n";
}
ostream& operator<<(ostream& out, vector<vector<int>> v) {
    for (auto el : v) {
        out << el;
    }
    return out << "\n";
}

struct SparceTable {
    vector<vector<int>> st;
    vector<vector<int>> ind;
    vector<int> lg2;

    SparceTable(vector<int> v) {
        int n = v.size();
        lg2 = vector<int>(2 * n);
        for (int i = 2; i < 2 * n; i++) {
            lg2[i] = lg2[i / 2] + 1;
        }
        int k = lg2[n] + 1;
        st = ind = vector<vector<int>>(k, vector<int>(n));
        for (int i = 0; i < n; i++) {
            st[0][i] = v[i];
            ind[0][i] = i;
        }
        for (int i = 1; i < k; i++) {
            for (int j = 0; j + (1<<(i-1)) < n; j++) {
                if (st[i - 1][j] < st[i - 1][j + (1<<(i-1))]) {
                    st[i][j] = st[i - 1][j];
                    ind[i][j] = ind[i - 1][j];
                }
                else {
                    st[i][j] = st[i - 1][j + (1<<(i-1))];
                    ind[i][j] = ind[i - 1][j + (1<<(i-1))];
                }
            }
        }
//        cout << ind << st;
    }
    int get(int l, int r) const{
        if (l >= r) {
            return l;
        }
        int d = r - l;
        int k = lg2[d];
        if (st[k][l] < st[k][r - (1<<(k))]) {
            return ind[k][l];
        }
        else {
            return ind[k][r - (1<<(k))];
        }
    }
};

int n, q;
int f(int i, const vector<int>& a, const SparceTable& rst) {
    int l = i;
    int r = n + 1;
    while (l + 1 < r) {
//        cout << l << "_" << r << "\n";
        int m = (l + r) / 2;
        if (a[rst.get(i, m)] <= a[i]) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return l;
}

void solve() {
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    SparceTable st(a);
    for (int i = 0; i < n; i++) {
        a[i] = -a[i];
    }
    SparceTable rst(a);
    for (int i = 0; i < n; i++) {
        a[i] = -a[i];
    }
    while (q--) {
//        cout << "--------------\n";
//        cout << a;
        int ind, k;
        cin >> k >> ind;
        ind--;
        if (ind + 1 == k) {
            if (ind % 2 == 0 && ind >= 2) {
                cout << a[n - 1] << "\n";
            }
            else {
                cout << a[rst.get(ind, n)] << "\n";
            }
        }
        else {
            cout << a[ind] << "\n";
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
7 5
6 4 2 3 1 7 5
7 4
1 1
4 2
5 3
2 2

6 6
1 6 2 5 3 4
1 1
2 1
2 2
3 1
3 2
3 3
*/
