#include <bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

// #define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
const int N = 2e6;
int nm;

inline constexpr int hole(int x) {
    return x + (1 << 10);
}

struct fen {
    int f[hole(N) + 1];

    fen() {
        for (int i = 0; i <= hole(N); ++i) {
            f[i] = 0;
        }
    }

    void add(int x, int y) {
        for (; x <= nm; x += x & -x) {
            f[hole(x)] += y;
        }
    }

    int sum(int x) {
        int ans = 0;
        for (; x > 0; x -= x & -x) {
            ans += f[hole(x)];
        }
        return ans;
    }

    int sum(int x, int y) {
        return sum(y) - sum(x - 1);
    }

    int add(int x) {
        int ans = sum(x + 1, nm);
        add(x, 1);
        return ans;
    }

    int del(int x) {
        int ans = sum(x - 1);
        add(x, -1);
        return ans;
    }

    int gadd(int x) {
        return sum(x + 1, nm);
    }

    int gadd1(int x) {
        return sum(x - 1);
    }

    void easy_add(int x) {
        add(x, 1);
    }

    void easy_del(int x) {
        add(x, -1);
    }

    void clear() {
        for (int i = 0; i <= hole(nm); ++i) {
            f[i] = 0;
        }
    }
};


vector<int> a[N];
vector<ll> dp[N + 1], dp1[N + 1], dp2[N + 1];
int n, m;
fen f, f1;

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        a[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    nm = n * m;
    for (int i = 0; i <= n + 1; ++i) {
        dp[i].resize(m + 2, (ll) nm * nm);
        dp1[i].resize(m + 2);
        dp2[i].resize(m + 2);
    }
    for (int i = 0; i < n; ++i) {
        if (i != 0) {
            for (int j = 0; j < m; ++j) {
                f.easy_add(a[i - 1][j]);
            }
        }
        ll ans = 0;
        for (int j = 0; j < m; ++j) {
            ans += f.gadd(a[i][j]);
            ans += f1.add(a[i][j]);
        }
        dp1[i + 1][1] = ans;
        for (int j = 1; j < m; ++j) {
            ans -= f.gadd(a[i][j - 1]);
            ans -= f1.del(a[i][j - 1]);
            for (int k = i; k < n; ++k) {
                f.easy_add(a[k][j - 1]);
                ans += f1.gadd1(a[k][j - 1]);
            }
            dp1[i + 1][j + 1] = ans;
        }
        for (int j = 1; j < m; ++j) {
            for (int k = i; k < n; ++k) {
                f.easy_del(a[k][j - 1]);
            }
        }
        f1.easy_del(a[i][m - 1]);
    }
    f.clear();
    for (int i = 0; i < n; ++i) {
        if (i != 0) {
            for (int j = 0; j < m; ++j) {
                f.easy_add(a[i - 1][j]);
            }
        }
        for (int j = 0; j < m; ++j) {
            ll ans = 0;
            for (int k = i; k < n; ++k) {
                ans += f.add(a[k][j]);
            }
            dp2[i + 1][j + 1] = ans;
        }
        for (int j = 0; j < m; ++j) {
            for (int k = i; k < n; ++k) {
                f.easy_del(a[k][j]);
            }
        }
    }
    dp[1][1] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (!(i == 0 && j == 0)) {
                dp[i + 1][j + 1] = min(dp[i][j + 1] + dp1[i][j + 1], dp[i + 1][j] + dp2[i + 1][j]);
            }
        }
    }
    cout << dp[n + 1][m + 1];
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
