#include <bits/stdc++.h>
using namespace std;
const int N = 250000 + 3;
using ll = long long;
const ll inf = 1e18 + 7;
int tree[4 * N];
int nl[4 * N], nr[4 * N];
int cur = 1;
void build(int v, int l, int r) {
    if (l== r) {
        return;
    }
    int m = (l + r) / 2;
    nl[v] = cur;
    cur++;
    nr[v] = cur;
    cur++;
    build(nl[v], l, m);
    build(nr[v], m + 1, r);
}
void update(int v, int l, int r, int pos, int t) {
    if (l == r) {
        tree[v]+=t;
        return;
    }
    int m = (l + r) / 2;
    if (pos <= m) {
        update(nl[v], l, m, pos,t);
    } else {
        update(nr[v], m + 1, r, pos,t);
    }
    tree[v] = tree[nl[v]] + tree[nr[v]];
}
int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (ql > r || l > qr) {
        return 0;
    }
    int m = (l + r) / 2;
    return get(nl[v], l, m, ql, qr) + get( nr[v], m + 1, r, ql, qr);
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    vector<vector<int>> root(n, vector<int> (m));

    vector<vector<ll>> dp(n + 1, vector<ll> (m + 1, inf));
    for (int i = 0 ;i < n; i++) {
        for (int j = 0 ;j < m; j++) {
            cin >> a[i][j];
        }
    }
    build(0, 0, N - 1);
    dp[0][0] = 0;
    for (int ci = 0; ci < n; ci++) {
        for (int cj =0; cj < m; cj++) {
            //cout << ci << " " << cj << "\n";
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m;j++) {
                    if (i < ci || j < cj) {
                        update(0, 0, N - 1, a[i][j], 1);
                    }
                }
            }
            ll c = 0;
            for (int j = cj; j < m; j++) {
                c += get(0, 0, N - 1, a[ci][j], N - 1);
                update(0, 0, N - 1, a[ci][j], 1);
            }
            for (int j = cj; j < m; j++) {
                update(0, 0, N - 1, a[ci][j], - 1);
            }
            dp[ci + 1][cj] = min(dp[ci + 1][cj], dp[ci][cj] + c);
            c = 0;
            for (int i = ci; i < n; i++) {
                c += get(0, 0, N - 1, a[i][cj], N - 1);
                update(0, 0, N - 1, a[i][cj], 1);
            }
            for (int i = ci; i < n; i++) {
                update(0, 0, N - 1, a[i][cj], -1);
            }
            dp[ci][cj + 1] = min(dp[ci][cj + 1], dp[ci][cj] + c);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m;j++) {
                    if (i < ci || j < cj) {
                        update(0, 0, N - 1, a[i][j], -1);
                    }
                }
            }
        }
    }
    /*for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            cout << dp[i][j] << " ";
        }
        cout << "\n";
    }*/
    ll ans = inf;
    for (int i = 0 ;i <= n; i++) {
        ans = min(ans, dp[i][m]);
    }
    for (int j = 0; j <= m; j++) {
        ans = min(ans, dp[n][j]);
    }
    cout << ans;

}