#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<cmath>
#include<deque>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18, MOD = 1e9 + 7;
#define fst first
#define snd second

struct SparseTable {
	vector <ll> lgs, pw, _a;
	vector <vector<ll>> st;
	SparseTable() {
	}
	SparseTable(vector <ll> a) {
		ll n = (ll)a.size();
		_a = a;
		pw.resize(31, 1);
		for (ll i = 1; i < 31; i++) {
			pw[i] = pw[i - 1] * 2;
		}
		lgs.resize(n + 1, 0);
		for (ll i = 2; i <= n; i++) {
			lgs[i] = lgs[i / 2] + 1;
		}
		st.resize(lgs[n] + 1, vector <ll>(n));
		for (ll i = 0; i < n; i++)
			st[0][i] = i;
		for (ll k = 1; k <= lgs[n]; k++) {
			for (ll i = 0; i + pw[k] <= n; i++) {
				if (a[st[k - 1][i]] < a[st[k - 1][i + pw[k - 1]]])
					st[k][i] = st[k - 1][i];
				else
					st[k][i] = st[k - 1][i + pw[k - 1]];
			}
		}
	}
	ll get(ll l, ll r) {
		if (_a[st[lgs[r - l]][l]] < _a[st[lgs[r - l]][r - pw[lgs[r - l]]]])
			return st[lgs[r - l]][l];
		else
			return st[lgs[r - l]][r - pw[lgs[r - l]]];
	}
};

ll n, q;
vector <ll> a, nxt;
SparseTable tmp;

void func(vector <ll>& b, ll k) {
	b.resize(k);
	ll st = 0, i = 0;
	while (true) {
		if (st == k - 1) {
			b[st] = *max_element(a.begin() + i, a.end());
			break;
		}
		b[st] = a[i];
		if (st == k - 2) {
			i = nxt[i];
			if (i == n)
				i--;
			st++;
			continue;
		}
		ll j = i + 1, mn = i + 1;
		while (n - j - 1 >= k - st - 2 && a[j] < a[i]) {
			if (a[mn] > a[j])
				mn = j;
			j++;
		}
		i = mn;
		st++;
	}
}

struct Query {
	ll k, i, ind;
	Query() {
	}
	Query(ll _k, ll _i, ll _ind) {
		k = _k;
		i = _i;
		ind = _ind;
	}
};

void solve() {
	cin >> n >> q;
	a.resize(n);
	nxt.resize(n, n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	tmp = SparseTable(a);

	deque <ll> mx;
	for (ll i = n - 1; i >= 0; i--) {
		while (!mx.empty() && a[mx.back()] < a[i])
			mx.pop_back();
		if (!mx.empty())
			nxt[i] = mx.back();
		mx.push_back(i);
	}
	vector <vector<ll>> b(n);
	for (ll k = 1; k <= n; k++)
		func(b[k - 1], k);

	vector <Query> qs(q);
	for (ll ind = 0; ind < q; ind++) {
		ll k, i;
		cin >> k >> i;
		k--;
		i--;
		if (b[k].empty())
			func(b[k], k + 1);
		cout << b[k][i] << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t12345 = 1;
	//cin >> t12345;
	while (t12345--) {
		solve();
		cout << '\n';
	}
	return 0;
}
