#include <iostream>
#include <vector>
#include <set>

using namespace std;


long long sqr(long long a) {
    return a * a;
}
long long dist2(pair <long long, long long> a, pair <long long, long long> b) {
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

vector <vector <int>> g;
vector <int> color;
vector <int> used;
vector <int> can;
vector <pair <long long, long long>> p;
long long R;
void dfs1(int v, int cnt) {
    for (int u = 0; u < p.size(); ++u) {
        if (u != v && dist2(p[v], p[u]) <= R) {
            if (used[u] == -1) {
                used[u] = cnt;
                color[u] = -color[v];
                dfs1(u, cnt);
            } else if (color[u] == color[v]) {
                can[cnt] = 1;
            }
        }
    }
}

void dfs2(int v, int cnt) {
    for (int u : g[v]) {
        if (used[u] == -1) {
            used[u] = cnt;
            color[u] = -color[v];
            dfs2(u, cnt);
        } else if (color[u] == color[v]) {
            can[cnt] = 1;
        }
    }
}


int main()
{
   // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    long long r;
    cin >> n >> r;
    R = r * r;
    g.resize(n);
    p.resize(n);
    set <pair <pair <long long, long long>, int>> s;
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    if (n <= 10000) {
        int cnt = 0;
        used.resize(n, -1);
        color.resize(n, 0);
        for (int i = 0; i < n; ++i) {
            if (used[i] == -1) {
                color[i] = 1;
                used[i] = cnt;
                can.push_back(0);
                dfs1(i, cnt);
                cnt++;
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            s.emplace(p[i], i);
        }
        int cnt = 0;
        g.resize(n);
        color.resize(n, 0);
        used.resize(n, -1);

        for (int i = 0; i < n; ++i) {
            for (int x = -r; x <= r; ++x) {
                for (int y = -r; y <= r; ++y) {
                    if (x == 0 && y == 0) continue;
                    pair <long long, long long> pp = make_pair(p[i].first + x, p[i].second + y);
                    auto it = s.lower_bound(make_pair(make_pair(pp.first, pp.second), 0));
                    if (it != s.end()) {
                        pair <pair <long long, long long>, int> t = *it;
                        if (t.first == pp && dist2(t.first, p[i]) <= R) {
                            g[i].push_back(t.second);
                            g[t.second].push_back(i);
                        }
                    }
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (used[i] == -1) {
                color[i] = 1;
                used[i] = cnt;
                can.push_back(0);
                dfs2(i, cnt);
                cnt++;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << (can[used[i]]);
    }
    return 0;
}
