#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

struct pn {
    ll x, y, id;
};

bool check(pn fir, pn sec, ll r) {
    return (fir.x - sec.x) * (fir.x - sec.x) + (fir.y - sec.y) * (fir.y - sec.y) <= r * r;
}

bool prov(vector<vector<ll> > &g, ll st) {
    vector<vector<ll> > dp(g.size(), vector<ll>(2));
    dp[st][0] = 1;
    queue<pair<ll, ll> > bfs;
    bfs.emplace(st, 0);
    while (!empty(bfs)) {
        ll v = bfs.front().first;
        ll f = (bfs.front().second + 1) % 2;
        bfs.pop();
        for (auto u: g[v]) {
            if (!dp[u][f]) {
                dp[u][f] = 1;
                bfs.emplace(u, f);
            }
        }
    }
    for (int i = 0; i < g.size(); i++) {
        if (i != st && dp[i][0]) {
            for (auto u: g[i]) {
                if (u == st) {
                    return true;
                }
            }
        }
    }
    return false;
}


void solve() {
    ll n, r;
    cin >> n >> r;
    map<pair<ll, ll>, vector<pn> > t;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        t[{x / max(1ll, (r / 2)), y / max(1ll, (r / 2))}].push_back({x, y, i});
    }
    vector<ll> ans(n);
    ll tt = 100;
    for (auto [cord, p]: t) {
        if (p.size() > 2) {
            for (auto ed : p) {
                ans[ed.id] = 1;
            }
            continue;
        }
        ll i = cord.first;
        ll j = cord.second;
        vector<pn> x;
        for (auto pn: p) {
            x.push_back(pn);
        }
        bool flag = false;
        for (ll f1 = -tt; f1 <= tt; f1++) {
            for (ll f2 = -tt; f2 <= tt; f2++) {
                ll a = i + f1;
                ll b = j + f2;
                if (f1 == 0 && f2 == 0) {
                    continue;
                }
                if (t.find({a, b}) == t.end()) {
                    continue;
                }
                for (auto p2: t[{a, b}]) {
                    x.push_back(p2);
                }
                if (t[{a, b}].size() > 2) {
                    for (auto p1 : p) {
                        for (auto p2 : t[{a, b}]) {
                            if (check(p1, p2, r)) {
                                flag = true;
                                break;
                            }
                        }
                    }
                }
            }
        }
        if (flag) {
            if (p.size() > 2) {
                for (auto ed : p) {
                    ans[ed.id] = 1;
                }
                continue;
            }
        }
        vector<vector<ll> > g(x.size());
        for (int fir = 0; fir < x.size(); fir++) {
            for (int sec = fir + 1; sec < x.size(); sec++) {
                if (check(x[fir], x[sec], r)) {
                    g[fir].push_back(sec);
                    g[sec].push_back(fir);
                }
            }
        }
        for (int pn = 0; pn < p.size(); pn++) {
            if (prov(g, pn)) {
                ans[p[pn].id] = 1;
            }
        }
    }
    for (auto i: ans) {
        cout << i;
    }
}
