#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

struct pn {
    ll x, y, id;
};

bool check(pn fir, pn sec, ll r) {
    return (fir.x - sec.x) * (fir.x - sec.x) + (fir.y - sec.y) * (fir.y - sec.y) <= r * r;
}

bool fl = true;
vector<ll> used;
vector<ll> cll;
vector<ll> ver;
void dfs(vector<vector<ll>>& g, ll v, ll color) {
    cll[v] = color;
    ver.push_back(v);
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(g, u, (color + 1) % 2);
            continue;
        }
        if (cll[u] == cll[v]) {
            fl = false;
        }
    }
}

void solve() {
    ll n, r;
    cin >> n >> r;
    map<pair<ll, ll>, vector<pn> > t;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        t[{x / max(1ll, (r / 2)), y / max(1ll, (r / 2))}].push_back({x, y, i});
    }

    vector<ll> ans(n);
    ll tt = 2;
    set<pair<ll, ll> > good;
    queue<pair<ll, ll> > bfs;
    for (auto [cord, p]: t) {
        if (p.size() > 2) {
            for (auto ed: p) {
                ans[ed.id] = 1;
            }
            good.insert(cord);
            bfs.push(cord);
        }
    }

    while (!empty(bfs)) {
        ll i = bfs.front().first, j = bfs.front().second;
        bfs.pop();
        for (ll f1 = -tt; f1 <= tt; f1++) {
            for (ll f2 = -tt; f2 <= tt; f2++) {
                ll a = i + f1;
                ll b = j + f2;
                if (good.find({a, b}) != good.end()) {
                    continue;
                }
                if (f1 == 0 && f2 == 0) {
                    continue;
                }
                if (t.find({a, b}) == t.end()) {
                    continue;
                }
                bool flag = false;
                for (auto p1 : t[{i, j}]) {
                    for (auto p2: t[{a, b}]) {
                        if (check(p1, p2, r)) {
                            flag = true;
                            break;
                        }
                    }
                }
                if (flag) {
                    good.insert({a, b});
                    bfs.emplace(a, b);
                    for (auto p : t[{a, b}]) {
                        ans[p.id] = 1;
                    }
                }
            }
        }
    }

    vector<vector<ll> > g(n);
    for (auto [cord, p]: t) {
        if (good.find(cord) != good.end()) {
            continue;
        }
        for (auto p1 : p) {
            for (auto p2 : p) {
                if (p1.id == p2.id) {
                    continue;
                }
                g[p1.id].push_back(p2.id);
                g[p2.id].push_back(p1.id);
            }
        }
        ll i = cord.first;
        ll j = cord.second;
        for (ll f1 = -tt; f1 <= tt; f1++) {
            for (ll f2 = -tt; f2 <= tt; f2++) {
                ll a = i + f1;
                ll b = j + f2;
                if (f1 == 0 && f2 == 0) {
                    continue;
                }
                if (t.find({a, b}) == t.end() || good.find({a, b}) != good.end()) {
                    continue;
                }
                for (auto p1: p) {
                    for (auto p2: t[{a, b}]) {
                        if (check(p1, p2, r)) {
                            g[p1.id].push_back(p2.id);
                            g[p2.id].push_back(p1.id);
                        }
                    }
                }
            }
        }
    }
    used.resize(n);
    cll.resize(n);
    for (int i = 0; i < n; i++) {
        if (!used[i] && !ans[i]) {
            fl  = true;
            ver.clear();
            dfs(g, i, 0);
            if (!fl) {
                for (auto v : ver) {
                    ans[v] = 1;
                }
            }
        }
    }
    for (auto i: ans) {
        cout << i;
    }
}