#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

vector<vector<ll>> a;
ll n, m;
ll ans = INF;

vector<ll> b;

struct fenwick {
    vector<ll> c;

    void change(ll i, ll x) {
        for (; i < c.size(); i += i & -i) {
            c[i] += x;
        }
    }
    ll get(ll i) {
        ll ans = 0;
        for (; i > 0; i -= i & -i) {
            ans += c[i];
        }
        return ans;
    }
};

ll calc() {
    ll ans = 0;
    fenwick hv;
    hv.c.resize(n * m + 2);
    for (int i = (int)b.size() - 1; i >= 0; i--) {
        ans += hv.get(b[i]);
        hv.change(b[i] + 1, 1);
    }
    return ans;
}

void rec(ll i, ll j) {
    ll r = calc();
    if (r > ans) {
        return;
    }
    if (i == n || j == m) {
        ans = min(ans, r);
        return;
    }
    if (i != n) {
        for (int k = j; k < m; k++) {
            b.push_back(a[i][k]);
        }
        rec(i + 1, j);
        for (int k = j; k < m; k++) {
            b.pop_back();
        }
    }
    if (j != m) {
        for (int k = i; k < n; k++) {
            b.push_back(a[k][j]);
        }
        rec(i, j + 1);
        for (int k = i; k < n; k++) {
            b.pop_back();
        }
    }
}

void solve() {
    cin >> n >> m;
    a.resize(n, vector<ll>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    rec(0, 0);
    cout << ans;
}