#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

struct fenwick {
    vector<ll> c;

    void change(ll i, ll x) {
        for (; i < c.size(); i += i & -i) {
            c[i] += x;
        }
    }
    ll get(ll i) {
        ll ans = 0;
        for (; i > 0; i -= i & -i) {
            ans += c[i];
        }
        return ans;
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(m, INF));
    dp[0][0] = 0;
    fenwick hv;
    hv.c.resize(n * m + 2);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 && j == 0) {
                continue;
            }
            vector<ll> pref(n * m + 2);
            for (int k = 0; k < i; k++) {
                for (int t = 0; t < m; t++) {
                    pref[a[k][t] + 1] = 1;
                }
            }
            for (int k = i; k < n; k++) {
                for (int t = 0; t < j; t++) {
                    pref[a[k][t] + 1] = 1;
                }
            }
            if (i - 1 >= 0) {
                ll col = 0;
                for (int k = j; k < m; k++) {
                    pref[a[i - 1][k] + 1] = 0;
                }
                vector<ll> s = pref;
                for (int k = 1; k <= n * m + 1; k++) {
                    s[k] += s[k - 1];
                }
                for (int k = j; k < m; k++) {
                    col += hv.get(n * m + 1) - hv.get(a[i - 1][k] + 1);
                    col += s[n * m + 1] - s[a[i - 1][k] + 1];
                    hv.change(a[i - 1][k] + 1, 1);
                }
                for (int k = j; k < m; k++) {
                    hv.change(a[i - 1][k] + 1, -1);
                    pref[a[i - 1][k] + 1] = 1;
                }
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + col);
            }
            if (j - 1 >= 0) {
                for (int k = i; k < n; k++) {
                    pref[a[k][j - 1] + 1] = 0;
                }
                vector<ll> s = pref;
                for (int k = 1; k <= n * m + 1; k++) {
                    s[k] += s[k - 1];
                }
                ll col = 0;
                for (int k = i; k < n; k++) {
                    col += hv.get(n * m + 1) - hv.get(a[k][j - 1] + 1);
                    col += s[n * m + 1] - s[a[k][j - 1] + 1];
                    hv.change(a[k][j - 1] + 1, 1);
                }
                for (int k = i; k < n; k++) {
                    hv.change(a[k][j - 1] + 1, -1);
                    pref[a[k][j - 1] + 1] = 1;
                }
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + col);
            }
        }
    }
    cout << dp[n - 1][m - 1] + n * m - a[n - 1][m - 1];
}