#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll q = 1;
    while (q--) {
        solve();
    }
}

struct fenwick {
    vector<ll> c;

    void change(ll i, ll x) {
        for (; i < c.size(); i += i & -i) {
            c[i] += x;
        }
    }
    ll get(ll i) {
        ll ans = 0;
        for (; i > 0; i -= i & -i) {
            ans += c[i];
        }
        return ans;
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    if (n == 1) {
        fenwick c;
        c.c.resize(n * m + 2);
        ll ans = 0;
        for (int i = 0; i < m; i++) {
            ans += c.get(n * m + 1) - c.get(a[0][i] + 1);
            c.change(a[0][i] + 1, 1);
        }
        cout << ans;
        return;
    }
    fenwick f1, f2;
    f1.c.resize(n * m + 2);
    f2.c.resize(n * m + 2);
    vector<ll> suf(m + 1);
    for (int i = m - 1; i >= 0; i--) {
        suf[i] = suf[i + 1];
        if (a[0][i] > a[1][i]) {
            suf[i]++;
        }
        suf[i] += f1.get(a[0][i]);
        suf[i] += f2.get(a[0][i]);
        suf[i] += f1.get(n * m + 1) - f1.get(a[1][i] + 1);
        suf[i] += f2.get(a[1][i]);
        f1.change(a[0][i] + 1, 1);
        f2.change(a[1][i] + 1, 1);
    }
    vector<ll> pref(m + 1);
    fenwick f;
    f.c.resize(n * m + 2);
    for (int i = 1; i <= m; i++) {
        pref[i] = pref[i - 1];

        pref[i] += f.get(n * m + 1) - f.get(a[0][i - 1] + 1);
        f.change(a[0][i - 1] + 1, 1);

        pref[i] += f.get(n * m + 1) - f.get(a[1][i - 1] + 1);
        f.change(a[1][i - 1] + 1, 1);
    }

    fenwick t1, t2;
    t1.c.resize(n * m + 2);
    t2.c.resize(n * m + 2);
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < m; j++) {
            t2.change(a[i][j] + 1, 1);
        }
    }
    ll ans = INF;
    ll cnt = 0;
    for (int i = 0; i <= m; i++) {
        ans = min(ans, pref[i] + cnt + suf[i]);

        if (i != m) {
            cnt -= t1.get(n * m + 1) - t1.get(a[0][i] + 1);
            t2.change(a[0][i] + 1, -1);
            cnt += t2.get(a[0][i]);
            t1.change(a[0][i] + 1, 1);

            cnt -= t1.get(n * m + 1) - t1.get(a[1][i] + 1);
            t2.change(a[1][i] + 1, -1);
            cnt += t2.get(a[1][i]);
            t1.change(a[1][i] + 1, 1);
        }
    }
    cout << ans;
}