#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Tree {
    int n;
    vector<int> tree;
    vector<int> tree2;
    vector<int> ind;
    int inf = 1e10;
    Tree(int n_, vector<int> &a) {
        n = n_;
        tree.assign(4 * n, 0);
        tree2.assign(4 * n, inf);
        ind.assign(4 * n, inf);
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            tree[v] = a[l];
            tree2[v] = a[l];
            ind[v] = l;
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
        if (tree2[2 * v + 1] < tree2[2 * v + 2]) {
            ind[v] = ind[2 * v + 1];
        }
        else {
            ind[v] = ind[2 * v + 2];
        }
        tree2[v] = min(tree2[2 * v + 1], tree2[2 * v + 2]);

    }

    int get(int v, int l, int r, int lq, int rq) {
        if (lq <= l && r <= rq) return tree[v];
        if (r <= lq || rq <= l) return 0;
        int mid = (l + r) / 2;
        return max(get(2 * v + 1, l, mid, lq, rq), get(2 * v + 2, mid, r, lq, rq));
    }

    pair<int, int> get2(int v, int l, int r, int lq, int rq) {
        if (lq <= l && r <= rq) return {tree2[v], ind[v]};
        if (r <= lq || rq <= l) return {inf, inf};
        int mid = (l + r) / 2;
        pair<int, int> t1 = get2(2 * v + 1, l, mid, lq, rq);
        pair<int, int> t2 = get2(2 * v + 2, mid, r, lq, rq);
        if (t1.first < t2.first) return t1;
        return t2;
    }
};

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i];

    Tree tree(n, v);
    for (int _ = 0; _ < q; ++_) {
        int k, i;
        cin >> k >> i;
        int j = 1;
        int ans;
        if (k != 1) {
            ans = v[0];
        }
        else {
            ans = n;
        }
        int ind = 0;
        while (j < i) {
            int l = ind, r = n - (k - j);
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (tree.get(0, 0, n, ind, mid + 1) > ans) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            if (l != ind) {
                pair<int, int> t = tree.get2(0, 0, n, ind + 1, l + 1);
                if (t.first < v[r]) {
                    ans = t.first;
                    ind = t.second;
                }
                else {
                    ans = v[r];
                    ind = r;
                }
            }
            else {
                ans = v[ind + 1];
                ind++;
            }
            ++j;
        }
        cout << ans << '\n';
    }
    return 0;
}