#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

using ll = long long;

template<>
struct std::hash<pair<ll, ll>> {
    size_t operator()(const pair<ll, ll> &x) const {
        return x.first + 31*x.second;
    }
};

vector<pair<ll, ll>> generate_offsets(ll r) {
    vector<pair<ll, ll>> o;
    o.push_back({r, 0});
    o.push_back({-r, 0});
    ll x = r;
    ll y = 0;
    while (y < r) {
        y += 1;
        while (x*x+y*y > r*r) x--;
        for (int yy=0; yy<=y; ++yy) {
            o.push_back({x, yy});
            o.push_back({-x, yy});
            o.push_back({x, -yy});
            o.push_back({-x, -yy});
        }
    }
    return o;
}

int main() {
    cin.sync_with_stdio(false); cin.tie(0);
    ll n, r;
    cin >> n >> r;
    vector<pair<ll, ll>> points(n);
    for (auto &&[x, y]: points) cin >> x >> y;
    bool ST5 = true;
    for (auto &&[x, y]: points) ST5 = ST5 && (y == 0);
    if (ST5) {
        vector<ll> xp;
        for (auto &&[x, y]: points) xp.push_back(x);
        vector<ll> xs(xp.begin(), xp.end());
        sort(xs.begin(), xs.end());
        unordered_set<ll> cool;
        for (int i=1; i+1<n; ++i) {
            if (cool.count(xs[i])) continue;
            if (xs[i+1]-xs[i-1] <= r) {
                cool.insert(xs[i+1]);
                int j = i;
                while (j >= 0 && xs[j+1]-xs[j] <= r && !cool.count(xs[j])) {
                    cool.insert(xs[j]);
                    j--;
                }
                j = i+2;
                while (j < n && xs[j] - xs[j-1] <= r && !cool.count(xs[j])) {
                    cool.insert(xs[j]);
                    j++;
                }
            }
        }
        for (auto &&i: xp) cout << cool.count(i);
        cout << endl;
        return 0;
    }
    vector<vector<ll>> g(n, vector<ll>());
    if (r <= 5) {
        unordered_map<pair<ll, ll>, ll> pts;
        for (int i=0; i<n; ++i) {
            pts[points[i]] = i;
        }
        vector o = generate_offsets(r);
        for (int i=0; i<n; ++i) {
            auto [x1, y1] = points[i];
            for (auto [dx, dy]: o) {
                if (pts.count({x1+dx, y1+dy})) {
                    ll j = pts[{x1+dx, y1+dy}];
                    if (i == j) continue;
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }
    } else {
        for (int i=0; i<n; ++i) {
            for (int j=i+1; j<n; ++j) {
                auto [x1, y1] = points[i];
                auto [x2, y2] = points[j];
                if ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) <= r*r) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }
    }
    vector<ll> h(n, -1);
    vector<ll> cc(n, -1);
    vector<bool> cchol(n, false);
    ll ccn = 0;
    for (int i=0; i<n; ++i) {
        if (cc[i] != -1) continue;
        cc[i] = ++ccn;
        h[i] = 0;
        vector<ll> q;
        q.push_back(i);
        while(!q.empty()) {
            ll v = q.back();
            q.pop_back();
            for (auto u: g[v]) {
                if (h[u] == -1) {
                    h[u] = h[v]+1;
                    cc[u] = cc[v];
                    q.push_back(u);
                } else if ((h[u]+h[v])%2==0) {
                    cchol[cc[u]] = true;
                }
            }
        }
    }
    for (int i=0; i<n; ++i) {
        cout << cchol[cc[i]];
        cout.flush();
    }
    cout << endl;
}