#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

const int INF = 1e18;

struct SegTree {

    int sz;
    vi t;

    SegTree(int sz) : sz(sz) {
        t.resize(4 * sz);
    }

    void add(int v, int vl, int vr, int p, int x) {
        if (vl > p || vr < p) return;
        else if (vl == vr) {
            t[v] += x;
        } else {
            int mid = (vl + vr) / 2;
            add(v * 2, vl, mid, p, x);
            add(v * 2 + 1, mid + 1, vr, p, x);
            t[v] = t[v * 2] + t[v * 2 + 1];
        }
    }

    int get(int v, int vl, int vr, int l, int r) {
        if (vl > r || vr < l) return 0;
        else if (l <= vl && vr <= r) return t[v];
        else {
            int mid = (vl + vr) / 2;
            return get(v * 2, vl, mid, l, r) + get(v * 2 + 1, mid + 1, vr, l, r);
        }
    }

    void add(int p, int x) {
        add(1, 0, sz - 1, p, x);
    }

    int get(int l, int r) {
        return get(1, 0, sz - 1, l, r);
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vi> a(n, vi(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    vector<vi> dp(n + 1, vi(m + 1, INF));

    dp[0][0] = 0;

    vi row(n), col(m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = j + 1; k < m; ++k) {
                if (a[i][j] > a[i][k]) ++row[i];
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                if (a[j][i] > a[k][i]) ++col[i];
            }
        }
    }

    vi b1, b2;
    b1.reserve(n * m);
    b2.reserve(n * m);
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i == 0 && j == 0) continue;

            b1.clear();
            b2.clear();

            for (int x = 0; x < n; ++x) {
                for (int y = 0; y < m; ++y) {
                    if (x < i - 1 || y < j) b1.pb(a[x][y]);
                    // else break;
                }
            }

            for (int x = 0; x < n; ++x) {
                for (int y = 0; y < m; ++y) {
                    if (x < i || y < j - 1) b2.pb(a[x][y]);
                    // else break;
                }
            }

            int opt1 = INF;
            int opt2 = INF;

            if (i != 0) {
                opt1 = dp[i - 1][j];
                for (int el : b1) {
                    for (int y = j; y < m; ++y) {
                        if (a[i - 1][y] < el) {
                            ++opt1;
                        }
                    }
                }

                opt1 += row[i - 1];
            }

            if (j != 0) {
                opt2 = dp[i][j - 1];

                for (int el : b2) {
                    for (int x = i; x < n; ++x) {
                        if (a[x][j - 1] < el) {
                            ++opt2;
                        }
                    }
                }

                opt2 += col[j - 1];

                // for (int el : b2) cout << el << ' ';
                // cout << endl;

                // if (i == 0 && j == 1) cout << "q " << opt2 << endl;
            }

            dp[i][j] = min(opt1, opt2);
        }
    }

    int ans = INF;

    // cout << dp[0][1] << endl;

    for (int i = 0; i <= m; ++i) ans = min(ans, dp[n][i]);
    for (int i = 0; i <= n; ++i) ans = min(ans, dp[i][m]);

    cout << ans;
}