#include <iostream>
#include <vector>
#include <set>
 
using namespace std;
typedef long long ll;

bool adj[10'000][10'000] = {};
int used[100'000] = {};
bool dp[100'000][2];
bool ans[100'000] = {};
int n;
 
void dfs(int at, int col) {
    used[at] = col;
    for (int to = 0; to < n; ++to) {
        if (!adj[at][to])
            continue;

        if (!used[to]) {
            dp[to][0] = dp[at][1];
            dp[to][1] = dp[at][0];
            dfs(to, col);
        }
        dp[at][0] |= dp[to][1];
        dp[at][1] |= dp[to][0];
    }
}
 
int main() {
    ll R; cin >> n >> R;
    ll R2 = R * R;
    ll x[n], y[n];
    for (int i = 0; i < n; ++i)
        cin >> x[i] >> y[i];
 
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= R2) {
                adj[i][j] = adj[j][i] = true;
            }
        }
    }

    set<int> cols;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dp[i][0] = true;
            dp[i][1] = false;
            dfs(i, i + 1);
            if (dp[i][0] && dp[i][1])
                cols.insert(i + 1);
        }
        if (cols.count(used[i]))
            ans[i] = true;
    }
 
    for (int i = 0; i < n; ++i)
        cout << ans[i];
 
    return 0;
}
