#include <iostream>
#include <vector>
#include <set>
#include <map>
  
using namespace std;
typedef long long ll;

vector<int> graph[100'000];
int used[100'000] = {};
bool dp[100'000][2];
bool ans[100'000] = {};
int n;
  
void dfs(int at, int col) {
    used[at] = col;
    for (int to : graph[at]) {
        if (!used[to]) {
            dp[to][0] = dp[at][1];
            dp[to][1] = dp[at][0];
            dfs(to, col);
        }
        dp[at][0] |= dp[to][1];
        dp[at][1] |= dp[to][0];
    }
}
  
int main() {
    ll R; cin >> n >> R;
    ll xs[n], ys[n];
    map<ll, map<ll, ll>> arr;
    for (int i = 0; i < n; ++i) {
        cin >> xs[i] >> ys[i];
        arr[ys[i]][xs[i]] = i;
    }

    for (int i = 0; i < n; ++i) {
        for (ll y = ys[i] - R; y <= ys[i] + R; ++y) {
            for (ll x = xs[i] - R; x <= xs[i] + R; ++x) {
                if ((xs[i] - x) * (xs[i] - x) + (ys[i] - y) * (ys[i] - y) <= R * R && arr[y].count(x) && arr[y][x] != i)  {
                    graph[i].push_back(arr[y][x]);
                }
            }
        }
    
        // cout << i << ":\n";
        // for (int j : graph[i])
        //     cout << j << ' ';
        // cout << endl;
    }
 
    bool cols[n + 1] = {};
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dp[i][0] = true;
            dp[i][1] = false;
            dfs(i, i + 1);
            if (dp[i][0] && dp[i][1])
                cols[i + 1] = true;
        }
        if (cols[used[i]])
            ans[i] = true;
    }
  
    for (int i = 0; i < n; ++i)
        cout << ans[i];
  
    return 0;
}
