#include <iostream>
#include <vector>
#include <set>
#include <map>

#pragma GCC optimize("unroll-loops,Ofast")
#pragma GCC target("avx2")
#pragma ivdep
  
using namespace std;
typedef long long ll;

vector<int> graph[100'000];
int used[100'000] = {};
bool dp[100'000][2];
bool ans[100'000] = {};
int n;
ll R, xs[100'000], ys[100'000];
  
void dfs(int at, int col) {
    used[at] = col;
    for (int to : graph[at])  {
        if (!used[to]) {
            dp[to][0] = dp[at][1];
            dp[to][1] = dp[at][0];
            dfs(to, col);
        }
        dp[at][0] |= dp[to][1];
        dp[at][1] |= dp[to][0];
    }
}
  
int main() {
    cin >> n >> R;
    map<ll, map<ll, int>> arr;
    for (int i = 0; i < n; ++i) {
        cin >> xs[i] >> ys[i];
        arr[ys[i]][xs[i]] = i;
    }

    for (int at = 0; at < n; ++at) {
        for (auto y = arr.lower_bound(ys[at] - R);
         y != arr.end() && y->first <= ys[at] + R;
         ++y) {
 
            ll Y = y->first;
            for (auto x = arr[Y].lower_bound(xs[at] - R);
                x != arr[Y].end() && x->first <= xs[at] + R;
                ++x) {
        
                ll X = x->first;
                int to = x->second;
                if ((xs[at] - X) * (xs[at] - X) + (ys[at] - Y) * (ys[at] - Y) <= R * R && to != at)
                    graph[at].push_back(to);
            }
        }
    }
 
    bool cols[n + 1] = {};
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dp[i][0] = true;
            dp[i][1] = false;
            dfs(i, i + 1);
            if (dp[i][0] && dp[i][1])
                cols[i + 1] = true;
        }
        if (cols[used[i]])
            ans[i] = true;
    }
  
    for (int i = 0; i < n; ++i)
        cout << ans[i];
  
    return 0;
}
