#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

vector<int> graph[100'000];
bool used[100'000] = {};
bool dp[100'000][2];

void dfs(int at) {
    used[at] = true;
    for (int to : graph[at]) {
        if (!used[to]) {
            dp[to][0] = dp[at][1];
            dp[to][1] = dp[at][0];
            dfs(to);
        }
        dp[at][0] |= dp[to][1];
        dp[at][1] |= dp[to][0];
    }

    for (int to : graph[at]) {
        dp[to][0] |= dp[at][1];
        dp[to][1] |= dp[at][0];
    }
}

int main() {
    ll n, R; cin >> n >> R;
    ll R2 = R * R;
    ll x[n], y[n];
    for (int i = 0; i < n; ++i)
        cin >> x[i] >> y[i];

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= R2) {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dp[i][0] = true;
            dp[i][1] = false;
            dfs(i);
        }
        cout << (dp[i][0] && dp[i][1]);
    }

    return 0;
}
