#include <iostream>
#include <climits>
#include <vector>

using namespace std;

int tree[1'000'000] = {};

void update(int ind, int lx, int rx, int ix) {
    ++tree[ind];
    if (rx - lx > 1) {
        int mid = (lx + rx) / 2;
        if (ix < mid)
            update(ind * 2 + 1, lx, mid, ix);
        else
            update(ind * 2 + 2, mid, rx, ix);
    }
}

int query(int ind, int lx, int rx, int l, int r) {
    if (rx <= l || r <= lx)
        return 0;
    if (l <= lx && rx <= r)
        return tree[ind];
    int mid = (lx + rx) / 2;
    return query(ind * 2 + 1, lx, mid, l, r) + query(ind * 2 + 2, mid, rx, l, r);
}

int main() {
    int h, n; cin >> h >> n;
    int arr[n];
    for (int i = 0; i < n; ++i)
        cin >> arr[i], --arr[i];

    long long ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += query(0, 0, n, arr[i], n);
        update(0, 0, n, arr[i]);
    }
    cout << ans;
    
    return 0;
}
