#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for (T &elem: a) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (T &elem: a) os << elem << ' ';
      return (os << '\n');
}

template<typename Node>
struct Segtree {
      int size;
      vector<Node> tree;

      Segtree(int n) {
            size =1 ;
            while (size < n) size <<= 1;
            tree.resize(size << 1);
      }

      Segtree(vector<int> &a) : Segtree(a.size()) {
            for (int i = 0; i < a.size(); ++i) tree[i + size] = {a[i], i};
            for (int i = size - 1; i > 0; --i) tree[i] = tree[i << 1] + tree[i << 1 | 1];
      }

      void set(int i, int v) {
            tree[i += size].apply(v);
            for (i >>= 1; i > 0; i >>= 1) tree[i] = tree[i << 1] + tree[i << 1 | 1];
      }

      Node get(int l, int r) {
            Node res;
            for (l += size, r += size - 1; l <= r; l >>= 1, r >>= 1) {
                  if (l & 1) res = res + l;
                  if (r & 1 ^ 1) res = r + res;
            }

            return res;
      }
};

struct Node {
      int val, id;

      Node(int val = 0, int id = -1) : val(val), id(id) {}

      friend Node operator+(Node &a, Node &b) {
            if (a.val < b.val) return b;
            return a;
      }

      void apply(int v) {
            val += v;
      }
};

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;
      string s;
      cin >> s;
      int now = 0;
      int cnt1 = 0;
      vector<int> p(n + 2);
      for (int i = 0; i < n; ++i) {
            if (s[i] == '0') continue;
            now++;
            bool flag = false;
            if (i and s[i - 1] == '1') flag = true;
            if (i + 1 < n and s[i + 1] == '1') flag = true;
            if (!flag) p[i] = 1, now--;
      }
      auto t = p;
      int r = 0;
      for (int i = 0; i < n; ++i) {
            if (i and i + 1 < n and p[i - 1] and p[i + 1]) {
                  p[i - 1] = 0;
                  p[i + 1] = 0;
                  r++;
            }
      }

      int cnt = r;
      int ost = std::accumulate(p.begin(), p.end(), 0ll);
      int cntt = std::count(s.begin(), s.end(), '1');
      while (m--) {
            int k;
            cin >> k;
            if (cntt == 0 and k == 1) {
                  cout << 0 << endl;
                  continue;
            }
            if (k <= cnt) {
                  cout << now + k * 3 << endl;
            } else if (k - cnt <= ost) {
                  cout << 2 * (k - cnt) + cnt * 3 + now << endl;
            } else {
                  cout << min(n, (2 * ost + cnt * 3 + now + (k - ost - cnt))) << endl;
            }
      }
}


