#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for (T &elem: a) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (T &elem: a) os << elem << ' ';
      return (os << '\n');
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, r;
      cin >> n >> r;

      map<pair<int, int>, vector<int>> kv;
      vector<pair<int, int>> a(n);
      for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            a[i] = {x, y};
            kv[{x / r, y / r}].push_back(i);
      }


      auto dist = [&](int i, int j) {
            return 1ll * (a[i].first - a[j].first) * (a[i].first - a[j].first) +
                   1ll * (a[i].second - a[j].second) * (a[i].second - a[j].second);
      };

      vector<int> color(n, -1);
      vector<int> f;
      function<void(int)> dfs = [&](int u) {
            auto nowx = a[u].first / r, nowy = a[u].second / r;
            for (int dx = -1; dx <= 1; ++dx) {
                  for (int dy = -1; dy <= 1; ++dy) {
                        for (auto v: kv[{nowx + dx, nowy + dy}]) {
                              if (v == u) continue;
                              if (dist(v, u) <= 1ll * r * r) {
                                    if (color[v] == color[u]) {
                                          f.push_back(u);
                                    } else if (color[v] == -1) {
                                          color[v] = !color[u];
                                          dfs(v);
                                    }
                              }
                        }
                  }
            }
      };

      for (int i = 0; i < n; ++i) {
            if (color[i] == -1) {
                  color[i] = 0;
                  dfs(i);
            }
      }

      vector<int> res(n);
      vector<int> used(n);
      function<void(int)> dfs2 = [&](int u) {
            res[u] = 1;
            used[u] = 1;
            auto nowx = a[u].first / r, nowy = a[u].second / r;
            for (int dx = -1; dx <= 1; ++dx) {
                  for (int dy = -1; dy <= 1; ++dy) {
                        for (auto v: kv[{nowx + dx, nowy + dy}]) {
                              if (v == u) continue;
                              if (dist(v, u) <= 1ll * r * r and !used[v]) {
                                    dfs2(v);
                              }
                        }
                  }
            }
      };
      for (auto v: f) {
            if (!used[v]) dfs2(v);
      }
      for (int i = 0; i < n; ++i) cout << res[i];
}

