#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for (T &elem: a) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (T &elem: a) os << elem << ' ';
      return (os << '\n');
}

#define int long long

template<typename Node>
struct Segtree {
      int size;
      vector<Node> tree;

      Segtree(int n) {
            size =1 ;
            while (size < n) size <<= 1;
            tree.resize(size << 1);
      }

      Segtree(vector<int> &a) : Segtree(a.size()) {
            for (int i = 0; i < a.size(); ++i) tree[i + size] = {a[i], i};
            for (int i = size - 1; i > 0; --i) tree[i] = tree[i << 1] + tree[i << 1 | 1];
      }

      void set(int i, int v) {
            tree[i += size].apply(v);
            for (i >>= 1; i > 0; i >>= 1) tree[i] = tree[i << 1] + tree[i << 1 | 1];
      }

      Node get(int l, int r) {
            Node resl, resr;
            for (l += size, r += size - 1; l <= r; l >>= 1, r >>= 1) {
                  if (l & 1) resl = resl + tree[l++];
                  if (r & 1 ^ 1) resr = tree[r--] + resr;
            }

            return resl + resr;
      }
};
struct Node {
      int val;

      Node(int val = 0) : val(val) {}

      friend Node operator+(Node &a, Node &b) {
            return a.val + b.val;
      }

      void apply(int v) {
            val += v;
      }
};


signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;
      vector a(n, vector<int> (m));
      cin >> a;

      for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) a[i][j]--;

      vector cntl(n + 1, vector<int> (m + 1)), cnts(n +1, vector<int>(m + 1));
      Segtree<Node> st(m * n);
      for (int i = 0; i < n; ++i) {
            for (int j = m - 1; j >= 0; --j) {
                  if (j + 1 < m) cntl[i][j] = cntl[i][j + 1];
                  cntl[i][j] += st.get(0, a[i][j]).val;
                  st.set(a[i][j], 1);
            }
            for (int j = m - 1; j >= 0; --j) {
                  st.set(a[i][j], -1);
            }
      }

      cout << cntl[0][0] << endl;
//      for (int j = 0; j < m; ++j) {
//            for (int i = n - 1; i >= 0; --i) {
//                  if (i + 1 < n) cnts[i][j] = cnts[i + 1][j];
//                  cnts[i][j] += st.get(0, a[i][j]).val;
//                  st.set(a[i][j], 1);
//            }
//            for (int i = 0; i < n; ++i) {
//                  st.set(a[i][j], -1);
//            }
//      }
//
//      auto invl = [&](int i, int j) {
//            vector<int> cnt(n * m);
//            for (int i1 = i + 1; i1 < n; ++i1) {
//                  for (int j1 = j; j1 < m; ++j1) {
//                        cnt[a[i1][j1]]++;
//                  }
//            }
//
//            vector<int> p(n *m + 1);
//            for (int i1 = 0; i1 < cnt.size(); ++i1) {
//                  p[i1 + 1] = p[i1] + cnt[i1];
//            }
//            int res = 0;
//            for (int j1 = j; j1 < m; ++j1) {
//                  res += p[a[i][j1]];
//            }
//            return res;
//      };
//
//      auto invs = [&](int i, int j) {
//            vector<int> cnt(n * m);
//            for (int i1 = i; i1 < n; ++i1) {
//                  for (int j1 = j + 1; j1 < m; ++j1) {
//                        cnt[a[i1][j1]]++;
//                  }
//            }
//            vector<int> p(n *m + 1);
//            for (int i1 = 0; i1 < cnt.size(); ++i1) {
//                  p[i1 + 1] = p[i1] + cnt[i1];
//            }
//            int res = 0;
//            for (int i1 = i; i1 < n; ++i1) {
//                  res += p[a[i1][j]];
//            }
//            return res;
//      };
//
//      vector dp(n + 1, vector<int>(m + 1, 1e18));
//      dp[n - 1][m - 1] = 0;
//      for (int i = n - 1; i >= 0; --i) {
//            for (int j = m - 1; j >= 0; --j) {
//                  if (i) {
//                        dp[i - 1][j] = min(dp[i - 1][j], dp[i][j] + cntl[i - 1][j] + invl(i - 1, j));
//                  }
//                  if (j) {
//                        dp[i][j - 1] = min(dp[i][j - 1], dp[i][j] + cnts[i][j - 1] + invs(i, j - 1));
//                  }
//            }
//      }
////      cout << dp;
//      cout << dp[0][0];
}

