#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for (T &elem: a) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (T &elem: a) os << elem << ' ';
      return (os << '\n');
}
template<typename Node>
struct Segtree {
      int size;
      vector<Node> tree;

      Segtree(int n) {
            size =1 ;
            while (size < n) size <<= 1;
            tree.resize(size << 1);
      }

      Segtree(vector<int> &a) : Segtree(a.size()) {
            for (int i = 0; i < a.size(); ++i) tree[i + size] = {a[i], i};
            for (int i = size - 1; i > 0; --i) tree[i] = tree[i << 1] + tree[i << 1 | 1];
      }

      void set(int i, int v) {
            tree[i += size].apply(v);
            for (i >>= 1; i > 0; i >>= 1) tree[i] = tree[i << 1] + tree[i << 1 | 1];
      }

      Node get(int l, int r) {
            Node resl, resr;
            for (l += size, r += size - 1; l <= r; l >>= 1, r >>= 1) {
                  if (l & 1) resl = resl + tree[l++];
                  if (r & 1 ^ 1) resr = tree[r--] + resr;
            }

            return resl + resr;
      }
};

struct Node {
      int val, id;

      Node(int val = 1e9, int id = -1) : val(val), id(id) {}

      friend Node operator+(Node &a, Node &b) {
            if (a.val > b.val) return b;
            return a;
      }

      void apply(int v) {
            val = v;
      }
};
signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, q;
      cin >> n >> q;

      vector<int> a(n);
      cin >> a;

      vector<pair<int, int>> qs(q);
      vector<int> ks;
      for (int i = 0; i < q; ++i) {
            cin >> qs[i].first >> qs[i].second;
            ks.push_back(qs[i].first);
      }
      std::sort(ks.begin(), ks.end());
      ks.erase(std::unique(ks.begin(), ks.end()), ks.end());

      Segtree<Node> st(a);
      vector<vector<int>> fork;
      vector<int> s = {n - 1};
      vector<int> r(n, n);
      for (int i = n - 2; i >= 0; --i) {
            while (!s.empty() and a[s.back()] < a[i]) s.pop_back();
            if (!s.empty()) r[i] = s.back();
            s.push_back(i);
      }
      vector<int> mxs(n);
      for (int i = n- 1; i >= 0; --i) {
            if (i + 1 < n) mxs[i] = mxs[i + 1];
            mxs[i] = max(mxs[i], a[i]);
      }
      Segtree<Node> sts(mxs);
      for (int k: ks) {
            vector<int> now;
            int j = 0;
            for (int i = 0; i < min(k, 4); ++i) {
                  if (i == k - 1) {
                        now.push_back(mxs[j]);
                        break;
                  }
                  now.push_back(a[j]);
                  int rg = n - k + i + 2;
                  rg = min(rg, r[j]);
                  if (rg == j + 1) {
                        j++;
                        continue;
                  }
                  if (i == k - 2) {
                        Node t = sts.get(j + 1, rg);
                        j = t.id;
                        continue;
                  }
                  Node t = st.get(j + 1, rg);
                  j = t.id;
            }

            fork.push_back(now);
      }

      for (auto [k, i]: qs) {
            k = lower_bound(ks.begin(), ks.end(), k) - ks.begin();
            cout << fork[k][i - 1] << '\n';
      }
}

