#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct Point {
    ll x, y;

    Point() {
        x = 0;
        y = 0;
    }

    ll sqr_dist(Point P) {
        return (x - P.x) * (x - P.x) + (y - P.y) * (y - P.y);
    }
};

vector<vector<int>> g;
vector<int> col;

bool dfs(int v) {
    for (int u : g[v]) {
        if (col[u] == -1) {
            col[u] = (col[v] + 1) % 2;
            if (dfs(u))
                return true;
        } else if (col[u] == col[v]) {
            return true;
        }
    }

    return false;
}

vector<bool> used;

void mark(int v) {
    used[v] = true;

    for (int u : g[v]) {
        if (!used[u])
            mark(u);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    ll r;
    cin >> n >> r;

    vector<Point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }

    g.assign(n, {});
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[i].sqr_dist(a[j]) <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    col.assign(n, -1);
    used.assign(n, false);
    for (int v = 0; v < n; v++) {
        if (col[v] == -1) {
            col[v] = 0;
            if (dfs(v))
                mark(v);
        }
    }

    for (int i = 0; i < n; i++) {
        if (used[i])
            cout << 1;
        else
            cout << 0;
    }
    cout << '\n';
}