#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct Point {
    ll x, y, ind;

    Point() {
        x = 0;
        y = 0;
        ind = -1;
    }

    ll sqr_dist(Point P) {
        return (x - P.x) * (x - P.x) + (y - P.y) * (y - P.y);
    }
};

vector<vector<int>> g;
vector<int> col;

bool dfs(int v) {
    for (int u : g[v]) {
        if (col[u] == -1) {
            col[u] = (col[v] + 1) % 2;
            if (dfs(u))
                return true;
        } else if (col[u] == col[v]) {
            return true;
        }
    }

    return false;
}

vector<bool> used;

void mark(int v) {
    used[v] = true;

    for (int u : g[v]) {
        if (!used[u])
            mark(u);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    ll r;
    cin >> n >> r;

    vector<Point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].ind = i;
    }

    map<int, map<int, vector<Point>>> ars;
    for (int i = 0; i < n; i++) {
        ars[a[i].x / r][a[i].y / r].push_back(a[i]);
    }

    g.assign(n, {});
    for (int i = 0; i < n; i++) {
        for (int i1 = -1; i1 <= 1; i1++) {
            for (int j1 = -1; j1 <= 1; j1++) {
                for (auto P : ars[a[i].x / r + i1][a[i].y / r + j1]) {
                    if (P.ind != i && a[i].sqr_dist(P) <= r * r) {
                        g[i].push_back(P.ind);
                    }
                }
            }
        }
    }

    col.assign(n, -1);
    used.assign(n, false);
    for (int v = 0; v < n; v++) {
        if (col[v] == -1) {
            col[v] = 0;
            if (dfs(v))
                mark(v);
        }
    }

    for (int i = 0; i < n; i++) {
        if (used[i])
            cout << 1;
        else
            cout << 0;
    }
    cout << '\n';
}