#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct Point {
    ll x, y, ind;

    Point() {
        x = 0;
        y = 0;
        ind = -1;
    }

    ll sqr_dist(Point P) {
        return (x - P.x) * (x - P.x) + (y - P.y) * (y - P.y);
    }
};

vector<int> col;
map<int, map<int, vector<Point>>> ars;
vector<Point> a;
ll r;

bool dfs(int v) {
    for (int i1 = -1; i1 <= 1; i1++) {
        for (int j1 = -1; j1 <= 1; j1++) {
            for (auto P : ars[a[v].x / r + i1][a[v].y / r + j1]) {
                if (P.ind != v && a[v].sqr_dist(P) <= r * r) {
                    int u = P.ind;
                    if (col[u] == -1) {
                        col[u] = (col[v] + 1) % 2;
                        if (dfs(u))
                            return true;
                    } else if (col[u] == col[v]) {
                        return true;
                    }
                }
            }
        }
    }
    return false;
}

vector<bool> used;

void mark(int v) {
    used[v] = true;
    for (int i1 = -1; i1 <= 1; i1++) {
        for (int j1 = -1; j1 <= 1; j1++) {
            for (auto P : ars[a[v].x / r + i1][a[v].y / r + j1]) {
                if (P.ind != v && a[v].sqr_dist(P) <= r * r) {
                    int u = P.ind;
                    if (!used[u])
                        mark(u);
                }
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n >> r;

    a.assign(n, Point());
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].ind = i;
    }

    for (int i = 0; i < n; i++) {
        ars[a[i].x / r][a[i].y / r].push_back(a[i]);
    }

    col.assign(n, -1);
    used.assign(n, false);
    for (int v = 0; v < n; v++) {
        if (col[v] == -1) {
            col[v] = 0;
            if (dfs(v))
                mark(v);
        }
    }

    for (int i = 0; i < n; i++) {
        if (used[i])
            cout << 1;
        else
            cout << 0;
    }
    cout << '\n';
}