#include <bits/stdc++.h>
using namespace std;

using ll = long long;

struct Node {
    int cnt, l, r;

    Node() {
        cnt = 0;
        l = -1;
        r = -1;
    }
};

vector<Node> t;

void build(int v, int l, int r) {
    t[v].l = l;
    t[v].r = r;
    if (l + 1 == r)
        return;

    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
}

void upd(int v, int pos) {
    if (pos < t[v].l || t[v].r <= pos)
        return;
    if (t[v].l + 1 == t[v].r) {
        t[v].cnt = 1;
        return;
    }

    upd(v * 2 + 1, pos);
    upd(v * 2 + 2, pos);
    t[v].cnt = t[v * 2 + 1].cnt + t[v * 2 + 2].cnt;
}

int get_sum(int v, int ql, int qr) {
    if (qr <= t[v].l || t[v].r <= ql)
        return 0;
    if (ql <= t[v].l && t[v].r <= qr)
        return t[v].cnt;

    int lc = get_sum(v * 2 + 1, ql, qr);
    int rc = get_sum(v * 2 + 2, ql ,qr);
    return lc + rc;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n + 1, vector<int>(m + 1, 0));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }

    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 2e18));
    dp[0][0] = 0;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            if (i > 0) {
                ll cur = dp[i - 1][j];
                t.assign(n * m * 4, Node());
                build(0, 0, n * m);
                for (int i1 = 1; i1 < i; i1++) {
                    for (int j1 = 1; j1 <= m; j1++) {
                        upd(0, a[i1][j1]);
                    }
                }
                for (int i1 = i; i1 <= n; i1++) {
                    for (int j1 = 1; j1 <= j; j1++) {
                        upd(0, a[i1][j1]);
                    }
                }
                for (int j1 = j + 1; j1 <= m; j1++) {
                    cur += get_sum(0, a[i][j1], n * m);
                    upd(0, a[i][j1]);
                }
                dp[i][j] = min(dp[i][j], cur);
            }
            if (j > 0) {
                ll cur = dp[i][j - 1];
                t.assign(n * m * 4, Node());
                build(0, 0, n * m);
                for (int i1 = 1; i1 <= n; i1++) {
                    for (int j1 = 1; j1 < j; j1++) {
                        upd(0, a[i1][j1]);
                    }
                }
                for (int i1 = 1; i1 <= i; i1++) {
                    for (int j1 = j; j1 <= m; j1++) {
                        upd(0, a[i1][j1]);
                    }
                }
                for (int i1 = i + 1; i1 <= n; i1++) {
                    cur += get_sum(0, a[i1][j], n * m);
                    upd(0, a[i1][j]);
                }
                dp[i][j] = min(dp[i][j], cur);
            }
        }
    }

    ll ans = 2e18;
    for (int i = 0; i <= m; i++) {
        ans = min(ans, dp[n][i]);
    }
    for (int i = 0; i <= n; i++) {
        ans = min(ans, dp[i][m]);
    }

    cout << ans << '\n';
}