#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int maxn = 1e4;
int color[maxn];
bool good[maxn];
int p[maxn], s[maxn];

int get(int x)
{
    if (p[x] == x) {
        return x;
    }
    return get(p[x]);
}

int geth(int x)
{
    if (p[x] == x) {
        return 0;
    }
    return geth(p[x]) ^ color[x];
}

void merge(int a, int b)
{
    if (get(a) == get(b)) {
        if (geth(a) == geth(b)) {
            good[get(a)] = 1;
        }
        return;
    }
    bool f = geth(a) == geth(b);
    a = get(a);
    b = get(b);
    if (s[a] < s[b]) {
        swap(a, b);
    }
    p[b] = a;
    color[b] ^= f;
    s[a] += s[b];
    good[a] = good[a] || good[b];
}

ll sqr(ll x)
{
    return x * x;
}

bool check(pair<ll, ll> a, pair<ll, ll> b, ll r)
{
    return sqr(a.first - b.first) + sqr(a.second - b.second) <= r;
}

void solve()
{
    int n;
    ll r;
    cin >> n >> r;
    r *= r;
    vector<pair<ll, ll>> point;
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        point.emplace_back(x, y);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (check(point[i], point[j], r)) {
                merge(i, j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (good[get(i)]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

signed main()
{
    iota(p, p + maxn, 0);
    fill(s, s + maxn, 1);
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
#endif
    solve();
}