#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int maxn = 1e5;
int color[maxn];
bool good[maxn];
int p[maxn], s[maxn];
vector<int> g[maxn];
bool usd[maxn];

int get(int x)
{
    if (p[x] == x) {
        return x;
    }
    p[x] = get(p[x]);
    return p[x];
}

void merge(int a, int b)
{
    a = get(a);
    b = get(b);
    if (a == b) {
        return;
    }
    if (s[a] < s[b]) {
        swap(a, b);
    }
    p[b] = a;
    s[a] += s[b];
    good[a] = good[a] || good[b];
}

ll sqr(ll x)
{
    return x * x;
}

bool check(pair<ll, ll> a, pair<ll, ll> b, ll r)
{
    return sqr(a.first - b.first) + sqr(a.second - b.second) <= r;
}

bool dfs(int v)
{
    usd[v] = true;
    for (int i : g[v]) {
        if (color[i] == color[v]) {
            return true;
        }
        if (!color[i]) {
            color[i] = color[v] ^ 3;
            if (dfs(i)) {
                return true;
            }
        }
    }
    return false;
}

void sup(vector<pair<ll, ll>>& point, ll dx, ll dy, int i)
{
    auto p = make_pair(point[i].first + dx, point[i].second + dy);
    auto it = lower_bound(point.begin(), point.end(), p);
    if (it != point.end() && *it == p) {
        int ind = it - point.begin();
        g[ind].push_back(i);
        g[i].push_back(ind);
        merge(ind, i);
    }
}

void solve()
{
    int n;
    ll r;
    cin >> n >> r;
    r *= r;
    vector<pair<ll, ll>> point;
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        point.emplace_back(x, y);
    }
    sort(point.begin(), point.end());
    for (int i = 0; i < n; ++i) {
        for (ll dx = 0; sqr(dx) <= r; ++dx) {
            for (ll dy = 0; sqr(dx) + sqr(dy) <= r; ++dy) {
                if (!dx && !dy) {
                    continue;
                }
                sup(point, dx, dy, i);
                sup(point, dx, -dy, i);
            }
        }
        // for (int j = 0; j < i; ++j) {
        //     if (check(point[i], point[j], r)) {
        //         merge(i, j);
        //         g[i].push_back(j);
        //         g[j].push_back(i);
        //     }
        // }
    }
    for (int i = 0; i < n; ++i) {
        if (!usd[i]) {
            color[i] = 1;
            if (dfs(i)) {
                good[get(i)] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (good[get(i)]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
}

signed main()
{
    iota(p, p + maxn, 0);
    fill(s, s + maxn, 1);
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
#endif
    solve();
}