#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(x) (x).begin(), (x).end()

const int maxn = 3e5;
int a[maxn];
int nxt[maxn];
pair<int, int> tree[maxn << 2];

void build(int v, int l, int r)
{
    if (l + 1 == r) {
        tree[v] = { a[l], l };
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v + 1, l, mid);
    build(2 * v + 2, mid, r);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

pair<int, int> get(int v, int l, int r, int ql, int qr)
{
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (qr <= l || r <= ql) {
        return { 1e9, 1e9 };
    }
    int mid = (l + r) / 2;
    return min(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
}

int get(int l, int r, int n)
{
    return get(0, 0, n, l, r + 1).second;
}

void solve()
{
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = n - 1; i >= 0; --i) {
        nxt[i] = i + 1;
        while (nxt[i] < n && a[nxt[i]] <= a[i]) {
            nxt[i] = nxt[nxt[i]];
        }
    }
    vector<int> mx(n);
    mx[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        mx[i] = max(mx[i + 1], a[i]);
    }
    vector<vector<pair<int, int>>> qws(n + 1);
    vector<int> ans(q);
    for (int ind = 0; ind < q; ++ind) {
        int k, i;
        cin >> k >> i;
        --i;
        qws[k].emplace_back(i, ind);
    }
    build(0, 0, n);
    for (int k = 1; k <= n; ++k) {
        sort(all(qws[k]));
        int cur = 0;
        int j = 0;
        for (auto [i, ind] : qws[k]) {
            for (; j < i; ++j) {
                int r = min(nxt[cur], n - k + j + 1);
                if (j + 2 != k)
                    cur = get(cur + 1, r, n);
                else
                    cur = r;
            }
            if (i + 1 == k) {
                ans[ind] = mx[cur];
            } else {
                ans[ind] = a[cur];
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << '\n';
    }
}

signed main()
{
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
#endif
    solve();
}