#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <bitset>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

const int SIZE = (1 << 29);

struct segtree
{
	segtree* l, * r;
	vector <pair<int, int>> dblhit;
}*root;

const int MAXN = 1e5 + 10;
ll pt[MAXN][2], r;
set<int> gr[MAXN];
int cur_point;

typedef bool (*CALLBACK_PROC)(int);

bool callback(int x)
{
	if (x != cur_point && (pt[x][0] - pt[cur_point][0]) * (pt[x][0] - pt[cur_point][0]) + (pt[x][1] - pt[cur_point][1]) * (pt[x][1] - pt[cur_point][1]) <= r * r)
	{
		gr[cur_point].insert(x);
		gr[x].insert(cur_point);
	}
	return (gr[cur_point].size() < 15);
}

void build(segtree* v)
{
	if (!v)
		return;
	v->dblhit.shrink_to_fit();
	sort(v->dblhit.begin(), v->dblhit.end());
	build(v->l);
	build(v->r);
}

int x, y, id;
void push(segtree*& v, int l, int r)
{
	if (x < l || x >= r)
		return;
	if (!v)
		v = new segtree();
	v->dblhit.emplace_back(y, id);
	if (r - l > 1)
	{
		push(v->l, l, (l + r) >> 1);
		push(v->r, (l + r) >> 1, r);
	}
}

int xr, yr;
void search(segtree* v, int l, int r)
{
	if (!v)
		return;
	if (xr <= l || r <= x)
		return;
	if (x <= l && r <= xr)
	{
		auto it = lower_bound(v->dblhit.begin(), v->dblhit.end(), make_pair(y, -1));
		while (it != v->dblhit.end() && it->first < yr)
		{
			if (!callback(it->second))
				return;
			it++;
		}
		return;
	}
	search(v->l, l, (l + r) >> 1);
	search(v->r, (l + r) >> 1, r);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n >> r;
	for (size_t i = 0; i < n; i++)
	{
		cin >> pt[i][0] >> pt[i][1];
		x = pt[i][0];
		y = pt[i][1];
		id = i;
		push(root, 0, SIZE);
	}
	build(root);
	for (size_t i = 0; i < n; i++)
	{
		cur_point = i;
		x = 0;
		xr = SIZE;
		y = 0;
		yr = SIZE;
		search(root, 0, SIZE);
	}
	/*vector <pair<ll, ll>> lst(n);
	for (auto& i : lst)
	{
		cin >> i.first >> i.second;
	}
	vector <set<int>> g(n);
	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < n; j++)
		{
			if (i == j)
				continue;
			if ((lst[i].first - lst[j].first) * (lst[i].first - lst[j].first) + (lst[i].second - lst[j].second) * (lst[i].second - lst[j].second) <= r * r)
			{
				g[i].insert(j);
				g[j].insert(i);
				if (g[i].size() > 15)
					break;
			}
		}
	}*/
	vector <bool> ans(n);
	vector <int> c(n), have;
	for (size_t i = 0; i < n; i++)
	{
		if (c[i] == 0)
		{
			have.clear();
			bool err = false;
			c[i] = 1;
			vector <int> dfs;
			dfs.push_back(i);
			while (!dfs.empty())
			{
				int v = dfs.back();
				dfs.pop_back();
				have.push_back(v);
				for (auto& i : gr[v])
				{
					if (c[i] == 0)
					{
						c[i] = 3 - c[v];
						dfs.push_back(i);
					}
					if (c[i] == c[v])
						err = true;
				}
			}
			if (err)
			{
				for (auto& i : have)
				{
					ans[i] = true;
				}
			}
		}
	}
	for (size_t i = 0; i < n; i++)
	{
		cout << ans[i];
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
