#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <utility>
#include <bitset>
#include <map>
#include <set>
#include <array>
#include <math.h>
using namespace std;
using ll = long long;
using ld = long double;

const int SIZE = (1 << 29);

struct segtree
{
	segtree* l, * r;
	vector <pair<int, int>> dblhit;
}*root;

const int MAXN = 1e5 + 10, K = 20;
ll pt[MAXN][2], r;

vector <int> gr[MAXN];
int cur_point, bad_points = 0;

typedef bool (*CALLBACK_PROC)(int);

bool callback(int x)
{
	if (gr[cur_point].size() >= K)
		return false;
	if (x != cur_point && (pt[x][0] - pt[cur_point][0]) * (pt[x][0] - pt[cur_point][0]) + (pt[x][1] - pt[cur_point][1]) * (pt[x][1] - pt[cur_point][1]) <= r * r)
	{
		gr[cur_point].push_back(x);
		gr[x].push_back(cur_point);
		//insert_vector(gr[cur_point], x);
		//insert_vector(gr[x], cur_point);
	}
	/*else
	{
		bad_points++;
		if (bad_points > 30 * MAXN)
			exit(-1);
	}*/
	return (gr[cur_point].size() < K);
}

void build(segtree* v)
{
	if (!v)
		return;
	v->dblhit.shrink_to_fit();
	sort(v->dblhit.begin(), v->dblhit.end());
	build(v->l);
	build(v->r);
}

int x, y, id;
void push(segtree*& v, int l, int r)
{
	if (x < l || x >= r)
		return;
	if (!v)
		v = new segtree();
	v->dblhit.emplace_back(y, id);
	if (r - l > 1)
	{
		push(v->l, l, (l + r) >> 1);
		push(v->r, (l + r) >> 1, r);
	}
}

int xr, yr;
void search(segtree* v, int l, int r)
{
	if (!v)
		return;
	if (gr[cur_point].size() >= K)
		return;
	if (xr <= l || r <= x)
		return;
	if (x <= l && r <= xr)
	{
		auto it = lower_bound(v->dblhit.begin(), v->dblhit.end(), make_pair(y, (int)-1));
		while (it != v->dblhit.end() && it->first < yr)
		{
			if (!callback(it->second))
				return;
			it++;
		}
		return;
	}
	search(v->l, l, (l + r) >> 1);
	search(v->r, (l + r) >> 1, r);
}

char c[MAXN], ans[MAXN];
bool err;

void fill(int v, char c)
{
	if (ans[v] != 0)
		return;
	ans[v] = c;
	for (auto& i : gr[v])
	{
		fill(i, c);
	}
}

void paint(int v, char p)
{
	c[v] = p;
	for (auto& i : gr[v])
	{
		if (c[i] == 0)
			paint(i, 3 - p);
		if (c[i] == p)
			err = true;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n >> r;
	for (size_t i = 0; i < n; i++)
	{
		cin >> pt[i][0] >> pt[i][1];
		//pt[i][1] = 0;
		//pt[i][0] = rand();
		x = pt[i][0];
		y = pt[i][1];
		id = i;
		push(root, 0, SIZE);
	}
	build(root);
	for (size_t i = 0; i < n; i++)
	{
		cur_point = i;
		// first search through main square
		x = pt[i][0] - r;
		xr = pt[i][0] + r + 1;
		y = pt[i][1] - r;
		yr = pt[i][1] + r + 1;

		/*for (size_t j = 0; j < n; j++)
		{
			if (x <= pt[j][0] && pt[j][0] < xr && y <= pt[j][1] && pt[j][1] < yr)
			{
				callback(j);
			}
		}*/
		search(root, 0, SIZE);
		/*ll r2 = ((ld)r / sqrtl(2) + 2.0);
		x = pt[i][0] - r2;
		xr = pt[i][0] + r2;
		y = pt[i][0] - r2;
		yr = pt[i][0] + r2;
		ll r3 = max(1ll, r - r2) + 1;
		search(root, 0, SIZE);
		ll a = x, b = y, c = xr, d = yr;
		if (gr[i].size() < 15)
		{
			x = a;
			xr = c;
			y = b - r3;
			yr = b;
			search(root, 0, SIZE);
		}
		if (gr[i].size() < 15)
		{
			x = a;
			xr = c;
			y = d;
			yr = d + r3;
			search(root, 0, SIZE);
		}
		if (gr[i].size() < 15)
		{
			x = a - r3;
			xr = a;
			y = b;
			yr = d;
			search(root, 0, SIZE);
		}
		if (gr[i].size() < 15)
		{
			x = c;
			xr = c + r3;
			y = b;
			yr = d;
			search(root, 0, SIZE);
		}*/
		/*x = 0;
		xr = SIZE;
		y = 0;
		yr = SIZE;
		search(root, 0, SIZE);*/
	}
	/*vector <pair<ll, ll>> lst(n);
	for (auto& i : lst)
	{
		cin >> i.first >> i.second;
	}
	vector <set<int>> g(n);
	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < n; j++)
		{
			if (i == j)
				continue;
			if ((lst[i].first - lst[j].first) * (lst[i].first - lst[j].first) + (lst[i].second - lst[j].second) * (lst[i].second - lst[j].second) <= r * r)
			{
				g[i].insert(j);
				g[j].insert(i);
				if (g[i].size() > 15)
					break;
			}
		}
	}*/
	//vector <bool> ans(n);
	//vector <int> c(n), have;
	for (size_t i = 0; i < n; i++)
	{
		if (c[i] == 0)
		{
			err = false;
			paint(i, 1);
			if (err)
				fill(i, '1');
			else
				fill(i, '0');
		}
	}
#ifdef _DEBUG
	cout << bad_points << '\n';
#endif
	ans[n] = 0;
	puts(ans);
	/*for (size_t i = 0; i < n; i++)
	{
		cout << ans[i];
	}*/
#ifdef _DEBUG
	system("pause");
#endif // _DEBUG

	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
