//
// Created by roi on 29.03.2025.
//
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <bitset>
#include <map>
#include <set>
#ifndef _DEBUG
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#endif

using namespace std;
#ifndef _DEBUG
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
#endif

#ifndef _DEBUG
template <typename T, typename C = less<T>>
using ordered_set=tree<T, null_type, C, rb_tree_tag, tree_order_statistics_node_update>;
#else
template <typename T>
struct ordered_set :public set<T>
{
	int order_of_key(int x)
	{
		int c = 0;
		for (auto& i : (*this))
		{
			if (i >= x)
				break;
			c++;
		}
		return c;
	}
};
#endif


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int r, c;
	cin >> r >> c;
	vector <vector <int>> a(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		for (int j = 0; j < c; ++j) {
			cin >> a[i][j];
		}
	}
	vector t(r, vector<pair<int, int>>(c));
	for (int i = 0; i < r; ++i) {
		ordered_set<int> os;
		for (int j = c - 1; j >= 0; --j) {
			t[i][j].second += os.order_of_key(a[i][j]);
			os.insert((a[i][j]));
		}
	}
	for (int i = 0; i < c; ++i) {
		ordered_set<int> os;
		for (int j = r - 1; j >= 0; --j) {
			t[j][i].first += os.order_of_key(a[j][i]);
			os.insert(a[j][i]);
		}
	}
	ordered_set<int>os2;

	for (int i = r - 2; i >= 0; i--)
	{
		for (int j = c - 1; j >= 0; j--)
		{
			if (j < c - 1)
				t[i][j].second += t[i][j + 1].second;
			vector <int> q;
			for (int s = r - 1; s > i; s--)
			{
				q.push_back(a[s][j]);
				os2.insert(a[s][j]);
			}
			t[i][j].second += os2.order_of_key(a[i][j]);
			sort(q.begin(), q.end());
			for (int s = c - 1; s > j; s--)
			{
				t[i][j].second += lower_bound(q.begin(), q.end(), a[i][s]) - q.begin();
			}
		}
		os2.clear();
	}
	for (int j = c - 2; j >= 0; --j) {
		t[r - 1][j].second += t[r - 1][j + 1].second;
	}
	os2.clear();
	for (int j = c - 2; j >= 0; j--)
	{
		for (int i = r - 1; i >= 0; i--)
		{
			if (i < r - 1)
				t[i][j].first += t[i + 1][j].first;
			vector <int> q;
			for (int s = c - 1; s > j; s--)
			{
				q.push_back(a[i][s]);
				os2.insert(a[i][s]);
			}
			t[i][j].first += os2.order_of_key(a[i][j]);
			sort(q.begin(), q.end());
			for (int s = r - 1; s > i; s--)
			{
				t[i][j].first += lower_bound(q.begin(), q.end(), a[s][j]) - q.begin();
			}
		}
		os2.clear();
	}
	for (int i = r - 2; i >= 0; --i) {
		t[i][c - 1].first += t[i + 1][c - 1].first;
	}
	vector dp(r, vector<int>(c));
	for (int i = 0; i < r; ++i) {
		dp[i][c - 1] = t[i][c - 1].first;
	}
	for (int i = 0; i < c; ++i) {
		dp[r - 1][i] = t[r - 1][i].second;
	}
	for (int i = r - 2; i >= 0; --i) {
		for (int j = c - 2; j >= 0; --j) {
			dp[i][j] = min(dp[i + 1][j] + t[i][j].second, dp[i][j + 1] + t[i][j].first);
		}
	}
	cout << dp[0][0] << '\n';
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started:
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
