#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <bitset>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

const int MAXN = 3e5 + 10, LOGN = 19;
int n, a[MAXN], b[MAXN], sp[LOGN][MAXN][2], pre[MAXN];

inline void add(int* a, const int* b, const int* c)
{
	a[0] = min(b[0], c[0]);
	a[1] = max(b[1], c[1]);
}

inline void reset(int* a)
{
	a[0] = 1e9;
	a[1] = -1;
}

inline void sparse_get(int ql, int qr, int* a)
{
	reset(a);
	int sz = pre[qr - ql];
	add(a, sp[sz][ql], sp[sz][qr - (1 << sz)]);
	/*reset(a);
	for (size_t i = ql; i < qr; i++)
	{
		add(a, a, sp[0][i]);
	}*/
}

inline void sparse_build(int n)
{
	for (size_t i = 0; i < MAXN; i++)
	{
		reset(sp[0][i]);
	}
	for (size_t i = 0; i < n; i++)
	{
		sp[0][i][0] = a[i];
		sp[0][i][1] = a[i];
	}
	for (size_t i = 1; i < LOGN; i++)
	{
		for (int j = 0; j < MAXN - (1 << i); j++)
		{
			add(sp[i][j], sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);
		}
	}
	pre[0] = 0;
	pre[1] = 0;
	for (size_t i = 2; i < MAXN; i++)
	{
		pre[i] = pre[i >> 1] + 1;
	}
}

inline int request(int k, int id)
{
	id--;
	int c = 0;
	while (id)
	{
		//if (n - c == k)
		//{
		//	cout << a[c + id] + 1 << '\n';
		//	c = -1;
		//	break;
		//}
		k--;
		int fl = c, fr = n - k + 1;
		while (fr - fl > 1)
		{
			int fm = (fl + fr) >> 1;
			int t[2];
			sparse_get(c, fm, t);
			if (t[1] > a[c])
				fr = fm;
			else
				fl = fm;
		}
		if (k == 1)
		{
			c = fr - 1;
		}
		else
		{
			int t[2];
			sparse_get(c + 1, fr, t);
			c = b[t[0]];
		}
		id--;
	}
		if (k == 1)
		{
			int t[2];
			sparse_get(c, n, t);
			return t[1];
		}
		return a[c];
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int q;
	cin >> n >> q;
	for (size_t i = 0; i < n; i++)
	{
		cin >> a[i];
		a[i]--;
		b[a[i]] = i;
	}
	sparse_build(n);
	for (size_t i = 0; i < q; i++)
	{
		int k, id;
		cin >> k >> id;
		cout << request(k, id) + 1 << '\n';
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
