#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("unroll-loops")
using namespace std;
using ll = long long;

using pll = pair<ll, ll>;
constexpr int NMAX = 1e5 + 3;
int n;

__gnu_pbds::gp_hash_table<ll, vector<int> > grid;
int comp[NMAX];
char dist[2][NMAX];
ll x[NMAX], y[NMAX];
int nxC = 0;
vector<int> cur;
ll r2, r;

constexpr ll HZ = 1e9 + 3;

inline ll dist2(const int i, const int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
}

void dfs(const int v, const int d, const bool ok) {
    cur.push_back(v);
    dist[d][v] = 1;
    ll cell;
    for (int dx = -1; dx <= 1; ++dx) {
        for (int dy = -1; dy <= 1; ++dy) {
            cell = HZ * (x[v] / r + dx) + (y[v] / r + dy);
            if (grid.find(cell) == grid.end()) {
                continue;
            }
            for (const int i: grid[cell]) {
                if ((i == v || dist2(i, v) > r2) || dist[1 - d][i] || (ok && (dist[1][i] || dist[0][i]))) {
                    continue;
                }
                comp[i] = comp[v];
                dfs(i, 1 - d, ok);
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];

    r2 = r * r;
    fill(comp, comp + n, -1);
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            dist[i][j] = 0;
        }
    }
    cur.reserve(n);

    ll cell;
    for (int i = 0; i < n; ++i) {
        cell = HZ * (x[i] / r) + (y[i] / r);
        grid[cell].push_back(i);
    }

    char ans[n];
    fill(ans, ans + n, '0');
    bool ok;

    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1) {
            continue;
        }
        cur.clear();
        comp[i] = nxC++;
        dfs(i, 0, false);
        ok = false;
        for (int j: cur) {
            if (dist[0][j] && dist[1][j]) {
                ok = true;
                break;
            }
        }
        if (ok) {
            for (int j: cur) {
                ans[j] = '1';
            }
        }
    }

    for (int i = 0; i < n; ++i) cout << ans[i];
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
