#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
using namespace __gnu_pbds;

using pll = pair<ll, ll>;
gp_hash_table<ll, vector<int>> grid;
vector<int> comp;
vector<vector<int>> dist;
vector<ll> x, y;
int nxC = 0;
vector<int> cur;
ll r2, r;

const ll A1MAX = 1e9 + 3;

inline ll dist2(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
}

void dfs(int v, int d) {
    cur.push_back(v);
    dist[d][v] = 1;
    ll cell;
    for (int dx = -1, dy; dx <= 1; ++dx) {
        for (dy = -1; dy <= 1; ++dy) {
            cell = A1MAX * (x[v] / r + dx) + y[v] / r + dy;
            for (int i : grid[cell]) {
                if (i == v || dist2(i, v) > r2) {
                    continue;
                }

                comp[i] = comp[v];
                if (!dist[1 - d][i]) {
                    dfs(i, 1 - d);
                }
            }
        }
    }

}


void solve() {
    int n;
    cin >> n >> r;
    x.resize(n), y.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }

    r2 = r * r;
    comp.assign(n, -1);
    dist.assign(2, vector<int>(n, 0));
    ll cell;
    for (int i = 0; i < n; ++i) {
        cell = A1MAX * (x[i] / r) +  y[i] / r;
        grid[cell].push_back(i);
    }

    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        if (comp[i] == -1) {
            cur.clear();
            comp[i] = nxC++;
            dfs(i, 0);
            bool ok = false;
            for (int j : cur) {
                ok |= dist[0][j] && dist[1][j];
            }
            if (ok) {
                for (int j : cur) {
                    ans[j] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}