#include <bits/stdc++.h>
using namespace std;
using ll = long long;

using pll = pair<ll, ll>;
const int NMAX = 1e5 + 3;
int n;
map<ll, vector<int>> grid;
int comp[NMAX];
int dist[2][NMAX];
vector<ll> x, y;
int nxC = 0;
vector<int> cur;
ll r2, r;

const ll HZ = 1e9 + 3;

inline ll dist2(int i, int j) {
    return (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
}

void dfs(int v, int d) {
    cur.push_back(v);
    dist[d][v] = 1;
    for (int dx = -1; dx <= 1; ++dx) {
        for (int dy = -1; dy <= 1; ++dy) {
            ll cell = HZ * (x[v] / r + dx) + (y[v] / r + dy);
            for (int i: grid[cell]) {
                if (i == v || dist2(i, v) > r2) {
                    continue;
                }

                comp[i] = comp[v];
                if (!dist[1 - d][i]) {
                    dfs(i, 1 - d);
                }
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    x.resize(n), y.resize(n);
    for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];

    r2 = r * r;
    fill(comp, comp + n, -1);
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            dist[i][j] = 0;
        }
    }

    ll cell;
    for (int i = 0; i < n; ++i) {
        cell = HZ * (x[i] / r) +  (y[i] / r);
        grid[cell].push_back(i);
    }

    char ans[n];
    fill(ans, ans + n, '0');
    bool ok;

    for (int i = 0; i < n; ++i) {
        if (comp[i] != -1) {
            continue;
        }
        cur.clear();
        comp[i] = nxC++;
        dfs(i, 0);
        ok = false;
        for (int j: cur) ok |= dist[0][j] && dist[1][j];

        if (ok) {
            for (int j: cur) {
                ans[j] = '1';
            }
        }
    }

    for (int i = 0; i < n; ++i) cout << ans[i];
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
