#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("unroll-loops")
using namespace std;
using ll = long long;

using pll = pair<ll, ll>;

struct SGT2 {
    vector<vector<int> > t;

    SGT2() : t() {
    }

    SGT2(int n, const vector<int> &a) : t(n * 4) {
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, const vector<int> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        const int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a), build(2 * v + 2, mid, r, a);
        merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(),
              back_inserter(t[v]));
    }

    int cnt(int v, int l, int r, int ql, int qr, int x) {
        if (r <= ql || qr <= l) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return lower_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
        }
        int mid = (l + r) / 2;
        return cnt(2 * v + 1, l, mid, ql, qr, x) + cnt(2 * v + 2, mid, r, ql, qr, x);
    }
};

struct SGT {
    vector<int> t;

    SGT(int n) : t(n * 4) {
    }

    void add(int v, int l, int r, int i, int x) {
        if (l > i || r <= i) {
            return;
        }
        if (l + 1 == r) {
            t[v] += x;
            return;
        }
        int mid = (l + r) / 2;
        add(2 * v + 1, l, mid, i, x), add(2 * v + 2, mid, r, i, x);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int sum(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }
        int mid = (l + r) / 2;
        return sum(2 * v + 1, l, mid, ql, qr) + sum(2 * v + 2, mid, r, ql, qr);
    }
};

void solve() {
    int r, c;
    cin >> r >> c;
    const int rc = r * c;
    vector<vector<int> > a(r, vector<int>(c));
    vector<vector<int> > tra(c, vector<int>(r));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
            --a[i][j];
            tra[j][i] = a[i][j];
        }
    }

    vector<SGT2> row(c), col(r);
    for (int i = 0; i < r; ++i) {
        col[i] = SGT2(c, a[i]);
    }
    for (int i = 0; i < c; ++i) {
        row[i] = SGT2(r, tra[i]);
    }


    vector<vector<ll> > dp(r + 1, vector<ll>(c + 1));
    ll tmp1, tmp2;
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            dp[i][j] = 0;
            for (int k = i; k < r; ++k) {
                dp[i][j] += row[k].cnt(0, 0, c, j, c, a[i][j]);
            }
            tmp1 = dp[i + 1][j];
            tmp2 = dp[i][j + 1];
            for (int k = j + 1; k < c; ++k) {
                for (int l = i + 1; l < r; ++l) {
                    tmp1 += col[l].cnt(0, 0, c, j, c, a[i][k]);
                }
            }
            for (int k = j + 1; k < c; ++k) {
                for (int l = k + 1; l < c; ++l) {
                    tmp1 += a[i][k] > a[i][l];
                }
            }
            for (int k = i + 1; k < r; ++k) {
                for (int l = i; l < r; ++l) {
                    tmp2 += col[l].cnt(0, 0, c, j + 1, c, a[k][j]);
                }
            }
            for (int k = i + 1; k < r; ++k) {
                for (int l = k + 1; l < r; ++l) {
                    tmp2 += a[k][j] > a[l][j];
                }
            }
            dp[i][j] += min(tmp1, tmp2);
        }
    }
    cout << dp[0][0] << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
