#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int MAXN = 2e5 + 100;

int d[MAXN];

void update(int x, int y) {
    for (; x < MAXN; x += (x & -x)) {
        d[x] += y;
    }
}

int get(int x) {
    int ans = 0;
    for (; x > 0; x -= (x & -x)) {
        ans += d[x];
    }
    return ans;
}

ll check(vector<int> &a, int n) {
    fill(d, d + MAXN, 0);
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans += i - get(a[i]);
        update(a[i], 1);
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> mat(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mat[i][j];
        }
    }
    vector<vector<int>> dp(n, vector<int>(m, (int)1e9));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 && j == 0) continue;
            if (i - 1 >= 0) {
                int ans = dp[i - 1][j];
                for (int k = j; k < m; k++) {
                    ans += k - j - get(mat[i - 1][k]);
                    update(mat[i - 1][k], 1);
                }
                for (int k = i; k < n; k++) {
                    for (int l = j; l < m; l++) {
                        ans += m - j - get(mat[k][l]);
                    }
                }
                for (int k = j; k < m; k++) {
                    update(mat[i - 1][k], -1);
                }
                dp[i][j] = min(dp[i][j], ans);
            }
            if (j - 1 >= 0) {
                int ans = dp[i][j - 1];
                for (int k = i; k < n; k++) {
                    ans += k - i - get(mat[k][j - 1]);
                    update(mat[k][j - 1], 1);
                }
                for (int k = i; k < n; k++) {
                    for (int l = j; l < m; l++) {
                        ans += n - i - get(mat[k][l]);
                    }
                }
                for (int k = i; k < n; k++) {
                    update(mat[k][j - 1], -1);
                }
                dp[i][j] = min(dp[i][j], ans);
            }
        }
    }
    cout << dp[n - 1][m - 1];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
}