#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int long long
const int INF = 1e18;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

struct seg_tree {
    vector<int> d;

    seg_tree(int n) {
        d.resize(4 * n);
    }

    void update(int v, int l, int r, int ind, int val) {
        if (r - l == 1) {
            d[v] = val;
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) {
            update(2 * v + 1, l, m, ind, val);
        } else {
            update(2 * v + 2, m, r, ind, val);
        }
        d[v] = d[2 * v + 1] + d[2 * v + 2];
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return 0;
        if (ql <= l && r <= qr) return d[v];
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

int get_inv(vector<int> &a) {
    int n = a.size();
    int ans = 0;
    seg_tree st(n);
    for (int i = 1; i < n; i++) {
        ans += st.get(0, 0, n, a[i] + 1, n);
        st.update(0, 0, n, a[i], 1);
    }
    return ans;
}

void solve1() {
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    if (n == 1) {
        cout << get_inv(a[1]);
        return;
    }
    vector<vector<int> > dp(n + 1, vector<int>(m + 1, INF));
    dp[0][0] = 0;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            if (i == 0 && j == 0) continue;
            int fir = INF, sec = INF;
            if (i != 0) {
                fir = dp[i - 1][j];
            }
            if (j != 0) {
                sec = dp[i][j - 1];
            }
            vector<int> f, s;
            if (i != 0) {
                for (int k = j + 1; k <= m; k++) {
                    f.push_back(a[i][k]);
                    for (int x = 1; x < i; x++) {
                        for (int y = 1; y <= m; y++) {
                            if (a[i][k] < a[x][y]) {
                                fir++;
                            }
                        }
                    }
                    for (int x = i; x <= n; x++) {
                        for (int y = 1; y <= j; y++) {
                            if (a[i][k] < a[x][y]) {
                                fir++;
                            }
                        }
                    }
                }
                for (int x = 0; x < f.size(); x++) {
                    for (int y = 0; y < x; y++) {
                        if (f[x] < f[y]) {
                            fir++;
                        }
                    }
                }
            }
            dp[i][j] = fir;
            if (j != 0) {
                for (int k = i + 1; k <= n; k++) {
                    s.push_back(a[k][j]);
                    for (int x = 1; x <= i; x++) {
                        for (int y = 1; y <= m; y++) {
                            if (a[k][j] < a[x][y]) {
                                sec++;
                            }
                        }
                    }
                    for (int x = i + 1; x <= n; x++) {
                        for (int y = 1; y < j; y++) {
                            if (a[k][j] < a[x][y]) {
                                sec++;
                            }
                        }
                    }
                }
                for (int x = 0; x < s.size(); x++) {
                    for (int y = 0; y < x; y++) {
                        if (s[x] < s[y]) {
                            sec++;
                        }
                    }
                }
            }
            dp[i][j] = min(dp[i][j], sec);
        }
    }
    int ans = INF;
    for (int i = 0; i <= n; i++) {
        ans = min(ans, dp[i][m]);
    }
    for (int i = 0; i <= m; i++) {
        ans = min(ans, dp[n][i]);
    }
    cout << ans;
}
