#include <bits/stdc++.h>
#define ll int
#define ld long double
using namespace std;
vector<vector<ll> > graph;
vector<ll> used;
vector<bool> isRev;
ld getDist(pair<ll,ll> &a, pair<ll,ll> &b) {
    ld d = sqrt(
        (ld) (abs(a.first - b.first) * abs(a.first - b.first)
              +
              abs(a.second - b.second) * abs(a.second - b.second)));
    return d;
}

void dfs(ll v, ll c = 1) {
    used[v] = c;
    for (auto u: graph[v]) {
        if (used[u] == c) {
            isRev[u] = true;
            isRev[v] = true;
        }
        if (used[u] == 0 && !isRev[u]) {
            dfs(u, (c == 2 ? 1ll : (c + 1)));
        }
    }
}

void dfs2(ll v) {
    used[v] = true;
    isRev[v] = true;
    for (auto u: graph[v]) {
        if (!used[u]) dfs2(u);
    }
}

void solve() {
    ll n;
    ld r;
    cin >> n >> r;
    vector<pair<ll,ll> > pos(n);
    for (ll i = 0; i < n; ++i) {
        cin >> pos[i].first >> pos[i].second;
    }
    graph.resize(n);
    isRev.resize(n);
    used.resize(n);
    for (ll i = 0; i < n; ++i) {
        for (ll y = i + 1; y < n; ++y) {
            if (getDist(pos[i], pos[y]) <= r) {
                graph[i].push_back(y);
                graph[y].push_back(i);
            }
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (used[i] == 0) dfs(i);
    }
    used.assign(n, false);
    for (ll i = 0; i < n; ++i) {
        if (!used[i] && isRev[i]) dfs2(i);
    }
    for (ll i = 0; i < n; ++i) {
        cout << (isRev[i] ? 1 : 0);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    ll t = 1;
    // cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
