#include <bits/stdc++.h>
#define ll long long
#define ld long double
using namespace std;

struct segment_tree {
    segment_tree(ll lb, ll rb): lb(lb), rb(rb) {
        if (lb != rb) {
            ll mid = (lb + rb) / 2;
            l = new segment_tree(lb, mid);
            r = new segment_tree(mid + 1, rb);
        }
    }

    void set(ll pos, ll x) {
        if (lb == rb) {
            sm = x;
            return;
        }
        ll mid = (lb + rb) / 2;
        if (pos <= mid) {
            l->set(pos, x);
        } else {
            r->set(pos, x);
        }
        sm = l->sm + r->sm;
    }

    ll get_sum(ll lm, ll rm) {
        if (lb > rm || rb < lm) {
            return 0;
        }
        if (lb >= lm && rb <= rm) {
            return sm;
        }
        return l->get_sum(lm, rm) + r->get_sum(lm, rm);
    }

    ll sm = 0;
    ll lb, rb;
    segment_tree *l = nullptr, *r = nullptr;
};

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll> > a(r, vector<ll>(c));
    for (ll i = 0; i < r; ++i) {
        for (ll j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    ll i = 0, j = 0;
    vector<ll> b;
    segment_tree seg(0, r * c);
    for (ll z = 1; z <= r * c; ++z) seg.set(z, 1);
    while (i != r - 1 && j != c - 1) {
        ll c1 = 0, c2 = 0;
        for (ll i1 = i; i1 < r; ++i1) {
            seg.set(a[i1][j], 0);
        }
        for (ll i1 = r - 1; i1 >= i; --i1) {
            for (ll j1 = j + 1; j1 < c; ++j1) {
                seg.set(a[i1][j1], 0);
            }
            c1 += seg.get_sum(0, a[i1][j]);
        }
        for (ll i1 = i; i1 < r; ++i1) {
            for (ll j1 = j; j1 < c; ++j1) {
                seg.set(a[i1][j1], 1);
            }
        }
        for (ll j1 = j; j1 < c; ++j1) {
            seg.set(a[i][j1], 0);
        }
        for (ll j1 = c - 1; j1 >= j; --j1) {
            for (ll i1 = i + 1; i1 < r; ++i1) {
                seg.set(a[i1][j1], 0);
            }
            c2 += seg.get_sum(0, a[i][j1]);
        }
        for (ll i1 = i; i1 < r; ++i1) {
            for (ll j1 = j; j1 < c; ++j1) {
                seg.set(a[i1][j1], 1);
            }
        }
        if (c1 > c2) {
            for (ll j1 = j; j1 < c; ++j1) {
                b.push_back(a[i][j1]);
                seg.set(a[i][j1], 0);
            }
            ++i;
        } else {
            for (ll i1 = i; i1 < r; ++i1) {
                b.push_back(a[i1][j]);
                seg.set(a[i1][j], 0);
            }
            ++j;
        }
    }
    if (i == r - 1) {
        while (j < c) {
            b.push_back(a[i][j++]);
        }
    }
    if (j == c - 1) {
        while (i < r) {
            b.push_back(a[i++][j]);
        }
    }
    seg = segment_tree(0, r * c);
    ll ans = 0;
    for (ll i = b.size() - 1; i >= 0; --i) {
        ans += seg.get_sum(0, b[i]);
        seg.set(b[i], 1);
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    ll t = 1;
    // cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
