#include <bits/stdc++.h>
#define ll long long
#define ld long double
using namespace std;

struct segment_tree {
    segment_tree(ll lb, ll rb): lb(lb), rb(rb) {
        if (lb != rb) {
            ll mid = (lb + rb) / 2;
            l = new segment_tree(lb, mid);
            r = new segment_tree(mid + 1, rb);
        }
    }

    void set(ll pos, ll x) {
        if (lb == rb) {
            sm = x;
            return;
        }
        ll mid = (lb + rb) / 2;
        if (pos <= mid) {
            l->set(pos, x);
        } else {
            r->set(pos, x);
        }
        sm = l->sm + r->sm;
    }

    ll get_sum(ll lm, ll rm) {
        if (lb > rm || rb < lm) {
            return 0;
        }
        if (lb >= lm && rb <= rm) {
            return sm;
        }
        return l->get_sum(lm, rm) + r->get_sum(lm, rm);
    }

    ll sm = 0;
    ll lb, rb;
    segment_tree *l = nullptr, *r = nullptr;
};

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll> > a(r, vector<ll>(c));
    for (ll i = 0; i < r; ++i) {
        for (ll j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll> > inv1(r, vector<ll>(c)), inv2(c, vector<ll>(r));
    vector<ll> b;
    vector<vector<ll> > dp(r, vector<ll>(c));
    for (ll j = c - 1; j >= 0; --j) {
        segment_tree seg(0, r * c);
        for (ll i = r - 1; i >= 0; --i) {
            for (ll j1 = j + 1; j1 < c; ++j1) {
                seg.set(a[i][j1], 1);
            }
            for (ll i1 = r - 1; i1 >= i; --i1) {
                inv2[j][i] += seg.get_sum(0, a[i1][j]);
                seg.set(a[i1][j], 1);
            }
            for (ll i1 = r - 1; i1 >= i; --i1) {
                seg.set(a[i1][j], 0);
            }
        }
    }
    for (ll i = r - 1; i >= 0; --i) {
        segment_tree seg(0, r * c);
        for (ll j = c - 1; j >= 0; --j) {
            for (ll i1 = i + 1; i1 < r; ++i1) {
                seg.set(a[i1][j], 1);
            }
            for (ll j1 = c - 1; j1 >= j; --j1) {
                inv1[i][j] += seg.get_sum(0, a[i][j1]);
                seg.set(a[i][j1], 1);
            }
            for (ll j1 = c - 1; j1 >= j; --j1) {
                seg.set(a[i][j1], 0);
            }
        }
    }
    for (ll i = 1; i < r; ++i) {
        dp[i][0] = dp[i - 1][0] + inv1[i - 1][0];
    }
    for (ll j = 1; j < c; ++j) {
        dp[0][j] = dp[0][j - 1] + inv2[j - 1][0];
    }
    for (ll i = 1; i < r; ++i) {
        for (ll j = 1; j < c; ++j) {
            dp[i][j] = min(dp[i][j - 1] + inv2[j - 1][i], dp[i - 1][j] + inv1[i - 1][j]);
        }
    }
    cout << dp[r - 1][c - 1];
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    ll t = 1;
    // cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
