#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define x first
#define y second

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using pll = pair<ll, ll>;

struct BIT {
    vector<ll> f;

    BIT(int n) : f(n + 1) {}

    void add(int i, ll val) {
        for (; i < f.size(); i += (i & (-i))) {
            f[i] += val;
        }
    }

    ll prefSum(int i) {
        ll res = 0;
        for (; i > 0; i -= (i & (-i))) {
            res += f[i];
        }
        return res;
    }

    ll sum(int l, int r) {
        return prefSum(r) - prefSum(l - 1);
    }
};

void solve() {
    int r, c;
    cin >> r >> c;

    BIT f(r * c);
    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    BIT st(r * c);
    BIT st1(r * c);
    int add, mx = r * c;
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1));
    for (int i = r - 1; i >= 0; --i) {
        for (int j = 0; j <= r * c; ++j) {
            st.f[j] = 0;
            st1.f[j] = 0;
        }
        ll v = 0, h = 0;
        for (int j = c - 1; j >= 0; --j) {
            v = 0;
            for (int i1 = r - 1; i1 > i; --i1) {
                v += st.sum(1, a[i1][j]);
                h += st1.sum(a[i1][j], mx);
                st.add(a[i1][j], 1);
            }
            add = st.sum(1, a[i][j]);
            h += add;
            v += add;
            st.add(a[i][j], 1);
            st1.add(a[i][j], 1);
            dp[i][j] = min(dp[i][j + 1] + v, dp[i + 1][j] + h);
        }
    }

    cout << dp[0][0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}