#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define x first
#define y second

#define all(a) a.begin(),a.end()

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using pll = pair<ll, ll>;

ll r, c;
ll ans = 1e9;
vector<ll> b;
vector<vector<ll>> a;
ordered_set<ll> st;
void perebor(int i, int j) {
    if (i == r || j == c) {
        st.clear();
        ll res = 0;
        for (int pos = r * c - 1; pos >= 0; --pos) {
            res += st.order_of_key(b[pos]);
            st.insert(b[pos]);
        }
        ans = min(ans, res);
        return;
    }
    for (int i1 = i; i1 < r; ++i1) {
        b.push_back(a[i1][j]);
    }
    perebor(i, j + 1);
    for (int i1 = i; i1 < r; ++i1) {
        b.pop_back();
    }
    for (int j1 = j; j1 < c; ++j1) {
        b.push_back(a[i][j1]);
    }
    perebor(i + 1, j);
    for (int j1 = j; j1 < c; ++j1) {
        b.pop_back();
    }
}

ll solve1() {
    ans = 1e9;
    b.clear();
    perebor(0, 0);

    return ans;
}

ll solve2(ll r, ll c, vector<vector<ll>> a) {
    ordered_set<ll> st;
    ll add;
    vector<vector<ll>> dp(r + 1, vector<ll>(c + 1));
    for (int i = r - 1; i >= 0; --i) {
        st.clear();
        ll v = 0, h = 0;
        for (int j = c - 1; j >= 0; --j) {
            v = 0;
            for (int i1 = r - 1; i1 > i; --i1) {
                v += st.order_of_key(a[i1][j]);
                st.insert(a[i1][j]);
            }
            add = st.order_of_key(a[i][j]);
            h += add;
            v += add;
            st.insert(a[i][j]);
            dp[i][j] = min(dp[i][j + 1] + v, dp[i + 1][j] + h);
        }
    }

    return dp[0][0];
}

mt19937 rnd(time(0));
void gen() {
    ll test = 100000;
    while (test--) {
        r = rnd() % 3;
        c = rnd() % 3;
        vector<ll> p(r * c);
        iota(all(p), 1);
        a.assign(r, vector<ll>(c, 0));

        random_shuffle(all(p));

        int ind = 0;
        for (int i = 0; i < r; ++i) {
            for (int j = 0; j < c; ++j) {
                a[i][j] = p[ind++];
            }
        }

        if (solve1() != solve2(r, c, a)) {
            cout << r << ' ' << c << '\n';
            for (int i = 0; i < r; ++i) {
                for (int j = 0; j < c; ++j) {
                    cout << a[i][j] << ' ';
                }
                cout << '\n';
            }
            cout << solve1() << '\n';
            cout << solve2(r, c, a) << '\n';
            return;
        }

        cout << "OK " << test << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        gen();
    }
}