#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <chrono>
#include <random>
#include <deque>

typedef long long ll;

#define fi(from, to) for(int i = from; i <= to; i++)

using namespace std;
const int INF = 1'000'000'000 + 7;
int n, q;
vector <int> t;
vector <int> t_min;
vector <int> b;
int sz;

vector <int> f_r;

void build(int u = 0, int l = 0, int r = sz) {
	if (l + 1 == r) {
		t[u] = l;
		t_min[u] = l;
		return;
	}
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	build(u1, l, mid);
	build(u2, mid, r);
	if (b[t[u1]] > b[t[u2]]) {
		t[u] = t[u1];
		t_min[u] = t_min[u2];
	}
	else {
		t[u] = t[u2];
		t_min[u] = t_min[u1];
	}
}

int get_max(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || r <= ql) return n + 1;
	if (ql <= l && r <= qr) return t[u];
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	int ind1 = get_max(ql, qr, u1, l, mid);
	int ind2 = get_max(ql, qr, u2, mid, r);
	if (b[ind1] > b[ind2]) return ind1;
	else return ind2;
}

int get_min(int ql, int qr, int u = 0, int l = 0, int r = sz) {
	if (qr <= l || r <= ql) return n;
	if (ql <= l && r <= qr) return t_min[u];
	int mid = (l + r) / 2, u1 = 2 * u + 1, u2 = 2 * u + 2;
	int ind1 = get_min(ql, qr, u1, l, mid);
	int ind2 = get_min(ql, qr, u2, mid, r);
	if (b[ind1] < b[ind2]) return ind1;
	else return ind2;
}

map <int, vector <pair <int, int>>> answs;

vector <pair <int, int>> f(int k) {
	vector <int> opts;
	for (int i = 0; k; ) {
		int ind1 = min(f_r[i], n - k + 2);
		int ind_mn = get_min(i + 1, ind1);
        ind_mn = min(ind_mn, ind1);
		if (k == 1) ind_mn = n;
		opts.push_back(ind_mn - i);
		i = ind_mn;
		k--;
	}
	vector <pair <int, int>> res;
	int st = 0;
	fi(0, opts.size() - 1) {
		res.emplace_back(st, st + opts[i]);
		st += opts[i];
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> q;
	b = vector <int>(n);
	fi(0, n - 1) {
		cin >> b[i];
	}
	sz = n;
	t = vector <int>(4 * sz + 10);
	t_min = vector <int>(4 * sz + 10);
	build();
	b.push_back(INF);
	b.push_back(-INF);
	f_r = vector <int>(n);
	deque <int> s = { n };
	for (int i = n - 1; i >= 0; i--) {
		while (b[i] > b[s.front()]) {
			s.pop_front();
		}
		if (b[i] < b[s.front()]) {
			f_r[i] = s.front();
			s.push_front(i);
		}
	}
	fi(0, q - 1) {
		int k, ind;
		cin >> k >> ind; ind--;
		if (answs.find(k) == answs.end())
			answs[k] = f(k);
		auto lr = answs[k][ind];
		int l = lr.first, r = lr.second;
		cout << b[get_max(l, r)] << "\n";
	}
}