#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<bitset>
#include<iomanip>
#include<random>
#include<ctime>
#include<unordered_map>
#include<unordered_set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("03")
#pragma GCC target("avx,avx2")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

mt19937 mt(time(0));
const int N = 2e6 + 2, inf = 1e9 + 100;
const ll llinf = 1e18 + 100;
struct fenwick {
	int n;
	vector<int> t, upds;
	fenwick(int _n) {
		n = _n;
		t.resize(n + 1);
	}
	void add(int i) {
		upds.push_back(i);
		for (++i; i <= n; i += (i & -i)) t[i]++;
	}
	void clear() {
		for (auto i : upds) {
			for (++i; i <= n; i += (i & -i)) t[i] -= 1;
		}
		upds.clear();
	}
	int get(int i) {
		int s = 0;
		for (++i; i; i -= (i & -i)) s += t[i];
		return s;
	}
};
int n, m, posx[N], posy[N];
vector<vector<int>> a;
vector<vector<ll>> dp, cost;

void solve() {
	cin >> n >> m;
	a.resize(n, vector<int>(m));
	for (auto& i : a) {
		for (auto& j : i) cin >> j, --j;
	}
	ll sum = 0;
	fenwick t(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			posx[a[i][j]] = i;
			posy[a[i][j]] = j;
		}
	}
	for (int x = n * m - 1; x >= 0; --x) {
		sum += t.get(posx[x] - 1);
		t.add(posx[x]);
	}
	t = fenwick(n * m);
	cost.resize(n, vector<ll>(m));
	dp.resize(n + 1, vector<ll>(m + 1, llinf));
	for (int i = 0; i < n; ++i) {
		for (int j = m - 1; j >= 0; --j) {
			sum += t.get(a[i][j]);
			t.add(a[i][j]);
		}
		t.clear();
		for (int j = m - 1; j >= 0; --j) {
			ll cnt = 0, all = 1ll * (n - i - 1) * (m - j - 1);
			for (int i1 = i + 1; i1 < n; ++i1) {
				cnt += t.get(a[i1][j]);
			}
			cost[i][j] = -all + cnt * 2;
			t.add(a[i][j]);
		}
		t.clear();
	}
	dp[0][0] = sum;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			dp[i + 1][j] = min(dp[i + 1][j], dp[i][j]);
			dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + cost[i][j]);
		}
	}
	ll ans = llinf;
	for (int i = 0; i <= n; ++i) ans = min(ans, dp[i][m]);
	for (int j = 0; j <= m; ++j) ans = min(ans, dp[n][j]);
	cout << ans;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << endl;
	}
	return 0;
}