#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

const ll INF = 1000000000;

bool check(pair<int, int>& a, pair<int, int>& b, int r) {
	if ((ll)r * r >= (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second)) {
		return true;
	}
	return false;
}

bool dfs(int v, vector<int>& used, vector<vector<int>>& graph, int col) {
	used[v] = col;
	bool flag = true;
	for (auto to : graph[v]) {
		if (used[to] == col) {
			flag = false;
		}
		if (used[to] == 0) {
			flag = flag && dfs(to, used, graph, -col);
		}
	}
	return flag;
}

void solve() {
	int n, r;
	cin >> n >> r;
	vector<pair<int, int>> coords(n);
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		coords[i] = { x, y };
	}
	vector<vector<int>> graph(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (check(coords[i], coords[j], r)) {
				graph[i].push_back(j);
				graph[j].push_back(i);
			}
		}
	}
	vector<int> used(n, 0);
	set<int> st;
	int col = 1;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			if (!dfs(i, used, graph, col)) {
				st.insert(col);
			}
			col += 1;
		}
	}
	for (int i = 0; i < n; i++) {
		if (st.find(abs(used[i])) != st.end()) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	precalc();
	int i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
}