#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

const ll INF = 1000000000;

bool check(pair<ll, ll>& a, pair<ll, ll>& b, ll r) {
	if ((ll)r * r >= (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second)) {
		return true;
	}
	return false;
}

vector<int> used;
vector<int> used2;
vector<int> ans;
vector<vector<int>> graph;

bool dfs(int v, int col) {
	used[v] = col;
	for (auto to : graph[v]) {
		if (used[to] == col) {
			return false;
		}
		if (used[to] == 0) {
			if (!dfs(to, -col)) {
				return false;
			}
		}
	}
	return true;
}

void gfs(int v) {
	used2[v] = 1;
	ans[v] = 1;
	for (auto to : graph[v]) {
		if (used2[to] == 0) {
			gfs(to);
		}
	}
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<pair<ll, ll>> coords(n);
	for (ll i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		coords[i] = { x, y };
	}
	graph.resize(n);
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			if (check(coords[i], coords[j], r)) {
				graph[i].push_back(j);
				graph[j].push_back(i);
			}
		}
	}
	used.resize(n, 0);
	used2.resize(n, 0);
	ans.resize(n, 0);
	int col = 1;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			if (!dfs(i, col)) {
				gfs(i);
			}
			col += 1;
		}
	}
	for (auto it : ans) {
		cout << it;
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	ll i = 0;
	while (t-- > 0) {
		solve();
		i += 1;
	}
}