#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

const ll INF = 1000000000;

bool check(pair<ll, ll>& a, pair<ll, ll>& b, ll r) {
	if ((ll)r * r >= (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second)) {
		return true;
	}
	return false;
}

bool dfs(ll v, vector<ll>& used, vector<vector<ll>>& graph, ll col) {
	used[v] = col;
	bool flag = true;
	for (auto to : graph[v]) {
		if (used[to] == col) {
			flag = false;
		}
		if (used[to] == 0) {
			flag = flag && dfs(to, used, graph, -col);
		}
	}
	return flag;
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<pair<ll, ll>> coords(n);
	for (ll i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		coords[i] = { x, y };
	}
	vector<vector<ll>> graph(n);
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			if (check(coords[i], coords[j], r)) {
				graph[i].push_back(j);
				graph[j].push_back(i);
			}
		}
	}
	vector<ll> used(n, 0);
	set<ll> st;
	ll col = 1;
	for (ll i = 0; i < n; i++) {
		if (used[i] == 0) {
			if (!dfs(i, used, graph, col)) {
				st.insert(col);
			}
			col += 1;
		}
	}
	for (ll i = 0; i < n; i++) {
		if (st.find(abs(used[i])) != st.end()) {
			cout << 1;
		}
		else {
			cout << 0;
		}
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	ll i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
}