#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

const ll INF = 1000000000;

bool check(pair<ll, ll>& a, pair<ll, ll>& b, ll r) {
	if ((ll)r * r >= (ll)(a.first - b.first) * (a.first - b.first) + (ll)(a.second - b.second) * (a.second - b.second)) {
		return true;
	}
	return false;
}

bool dfs(ll v, vector<ll>& used, vector<vector<ll>>& graph, ll col) {
	used[v] = col;
	for (auto to : graph[v]) {
		if (used[to] == col) {
			return false;
		}
		if (used[to] == 0) {
			if (!dfs(to, used, graph, -col)) {
				return false;
			}
		}
	}
	return true;
}

void gfs(ll v, vector<ll>& used, vector<vector<ll>>& graph, vector<ll>& ans) {
	used[v] = 1;
	ans[v] = 1;
	for (auto to : graph[v]) {
		if (used[to] == 0) {
			gfs(to, used, graph, ans);
		}
	}
}

struct Coord {
	int first;
	int second;
	int ind;
};

bool comp(Coord a, Coord b) {
	if (a.first < b.first) {
		return true;
	}
	return false;
}

void solve() {
	ll n, r;
	cin >> n >> r;
	vector<Coord> coords(n);
	for (ll i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		coords[i] = { x, y, i };
	}
	sort(coords.begin(), coords.end(), comp);
	vector<vector<ll>> graph(n);
	for (ll i = 0; i < n; i++) {
		for (ll j = max(0ll, i - 2); j <= min(n - 1, i + 2); j++) {
			if (i == j) {
				continue;
			}
			if (abs(coords[i].first - coords[j].first) <= r) {
				graph[i].push_back(j);
				graph[j].push_back(i);
			}
		}
	}
	vector<ll> used(n, 0);
	vector<ll> used2(n, 0);
	vector<ll> ans(n, 0);
	int col = 1;
	for (ll i = 0; i < n; i++) {
		if (used[i] == 0) {
			if (!dfs(i, used, graph, col)) {
				gfs(i, used2, graph, ans);
			}
			col += 1;
		}
	}
	vector<int> output(n, 0);
	for (int i = 0; i < n; i++) {
		output[coords[i].ind] = ans[i];
	}
	for (auto it : output) {
		cout << it;
	}
}

void precalc() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll t = 1;
	//cin >> t;
	precalc();
	ll i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
}