#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;
using ll = long long;

const int INF = 1000000000;

void precalc() {
	
}

pair<int, int> get(int l, int r, vector<int>& log2n, vector<vector<pair<int, int>>>& sparse) {
	int sz = log2n[r - l + 1];
	return min(sparse[sz][l], sparse[sz][r - (1 << sz) + 1]);
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> arr(n, 0);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	int power = 0;
	while ((1 << power) <= n) {
		power += 1;
	}
	vector<vector<pair<int, int>>> sparse(power + 1, vector<pair<int, int>>(n, { 0, 0 }));
	for (int i = 0; i < n; i++) {
		sparse[0][i] = { arr[i], i };
	}
	for (int k = 1; k <= power; k++) {
		for (int i = 0; i < (n - (1 << k) + 1); i++) {
			sparse[k][i] = min(sparse[k - 1][i], sparse[k - 1][i + (1 << (k - 1))]);
		}
	}
	vector<int> right_big(n, 0);
	vector<int> stac;
	for (int i = n - 1; i > -1; i--) {
		while (!stac.empty() and arr[i] > arr[stac.back()]) {
			stac.pop_back();
		}
		if (stac.empty()) {
			right_big[i] = n;
			stac.push_back(i);
		}
		else {
			right_big[i] = stac.back();
			stac.push_back(i);
		}
	}
	vector<int> log2n(n, 0);
	log2n[0] = -1;
	for (int i = 2; i < n; i++) {
		log2n[i] = log2n[i / 2] + 1;
	}
	vector<int> maxpref(n, 0);
	maxpref[n - 1] = arr[n - 1];
	for (int i = n - 2; i > -1; i--) {
		maxpref[i] = max(maxpref[i + 1], arr[i]);
	}
	map<pair<int, int>, int> mp;
	for (int i = 0; i < q; i++) {
		int k, ind;
		cin >> k >> ind;
		if (mp.find({ k, ind }) != mp.end()) {
			cout << mp[{k, ind}] << '\n';
		}
		else {
			int curind = 0;
			vector<int> b;
			for (int j = 0; j < k - 1; j++) {
				int maxind = min(n - (k - j) + 1, right_big[curind]);
				pair<int, int> mini = get(curind + 1, maxind, log2n, sparse);
				b.push_back(arr[curind]);
				curind = mini.second;
			}
			b.push_back(maxpref[curind]);
			mp[{k, ind}] = b[ind - 1];
			cout << b[ind - 1] << '\n';
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	precalc();
	int i = 0;
	while (t --> 0) {
		solve();
		i += 1;
	}
}