from math import sqrt
from collections import deque, defaultdict

import sys
input = sys.stdin.readline

def able_to_move(x, y, x2, y2, r):
    ax = abs(x-x2)
    ay = abs(y-y2)
    
    distance = sqrt(ay*ay + ax*ax)
    
    return distance <= r

def bfs(graph, start):
    visited = set()
    colors = dict()

    colors[start] = 1
    visited.add(start)

    q = deque()
    for u in graph[start]:
        q.appendleft((u, -1, True))

    while q:
        v, color, offset = q.pop()
        if v not in visited or offset:
            if v in visited and offset:
                if color != colors[v]:
                    return visited, False
            else:
                colors[v] = color
                visited.add(v)

                for u in graph[v]:
                    q.appendleft((u, -color, True))
    
    return visited, True

def main():
    n, r = map(int, input().split())
    #points = dict()
    points = []
    for i in range(1, n+1):
        #points[i] = tuple(map(int, input().split()))
        x, y = map(int, input().split())
        points.append((i, x, y))

    # ЭТА ЧАСТЬ УЖАСНАЯ
    # ЕЁ ТРОГАЕМ
    # как будто хочется здесь сканлайн???

    # строим граф
    points.sort(key=lambda x: x[1]) # by x
    g = defaultdict(set)
    for i in range(n):
        i1, x1, y1 = points[i]
        
        # to the right
        for j in range(i+1, n):
            if i == j:
                continue
            i2, x2, y2 = points[j]
            ability = able_to_move(x1, y1, x2, y2, r)
            if ability:
                g[i1].add(i2)
                g[i2].add(i1)
            else:
                break
        
        # to the left
        for j in reversed(range(i)):
            if i == j:
                continue
            i2, x2, y2 = points[j]
            ability = able_to_move(x1, y1, x2, y2, r)
            if ability:
                g[i1].add(i2)
                g[i2].add(i1)
            else:
                break
    #print(points)
    #print(g)
    """
    for p1 in range(1, n+1):
        x, y = points[p1]
        for p2 in range(1, n+1)[p1:]:
            if p1 == p2:
                continue
            x2, y2 = points[p2]
            ability = able_to_move(x, y, x2, y2, r)
            if ability:
                g[p1].add(p2)
                g[p2].add(p1)
    """
    
    # ВОТ ЭТА ЧАСТЬ ОТЛИЧНАЯ
    # ЕЁ НЕ ТРОГАЕМ
    # чек каждую компоненту на 2-colorability
    # если точка в компоненте, которая True, то 1, иначе 0
    # чек каждую точку, если мы уже знаем о компоненте, то скип
    Gvisited = dict()
    for v in g:
        if v not in Gvisited:
            comp, colorability = bfs(g, v)
            for u in comp:
                Gvisited[u] = colorability

    ans = []
    for p in range(1, n+1):
        if p not in Gvisited:
            ans.append("0")
        elif Gvisited[p] == False:
            ans.append("1")
        else:
            ans.append("0")
    
    print("".join(ans))

main()