#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <array>
#include <cmath>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
ll n, r;
struct P {
	ll x, y;
};
vector<P> f;
bool ok(P a, P b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}
const ll N = 1e5 + 20;
map<pair<ll, ll>, vector<ll>> mp;
set<ll> g[N];
ll c[N]{}, bad[N]{};
void dfs(ll v) {
	if (g[v].size() >= 6) bad[v] = 1;
	for (ll u : g[v]) {
		if (c[u] == 0) {
			c[u] = 3 - c[v];
			dfs(u);
		}
		else if (c[u] + c[v] != 3) {
			bad[v] = 1;
		}
	}
}
void okr(ll v) {
	bad[v] = 1;
	for (ll u : g[v]) {
		if (bad[u] == 0) {
			okr(u);
		}
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> r;
	f.resize(n);
	ll br = ceil(r / pow(2, 0.5));
	for (ll i = 0; i < n; i++) {
		cin >> f[i].x >> f[i].y;
		mp[{f[i].x / br, f[i].y / br}].push_back(i);
	}
	for (auto p : mp) {
		ll x = p.first.first, y = p.first.second;
		for (ll v : p.second) {
			for (ll dx : {0, 1, -1, 2, -2}) {
				for (ll dy : {0, 1, -1, 2, -2}) {
					if (abs(dx) + abs(dy) >= 4) continue;
					if (g[v].size() >= 6) break;
					auto it = mp.find({ x + dx, y + dy });
					if (it != mp.end()) {
						for (ll u : it->second) {
							if (u != v && ok(f[u], f[v])) {
								g[v].insert(u);
								g[u].insert(v);
								if (g[v].size() >= 6) break;
							}
						}
					}
				}
			}
		}
	}
	for (ll v = 0; v < n; v++) {
		if (c[v] == 0) {
			c[v] = 1;
			dfs(v);
		}
	}
	for (ll v = 0; v < n; v++) {
		if (bad[v] == 1) {
			okr(v);
		}
	}
	for (ll v = 0; v < n; v++) cout << bad[v];
	cout << "\n";
	return 0;
}