#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <array>
#include <cmath>
#include <queue>

using namespace std;
typedef int ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
vector<vector<ll>> a;
const long long INF = 1e18;
const ll N = 2.5e5 + 1;
ll fen[2][N];
void upd(ll* fen, ll i, ll d) {
	for (ll j = i; j < N; j += j & -j) {
		fen[j] += d;
	}
}
ll get(ll* fen, ll i) {
	ll res = 0;
	for (ll j = i; j > 0; j -= j & -j) {
		res += fen[j];
	}
	return res;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll r, c;
	cin >> r >> c;
	if (r > c) {
		swap(r, c);
		a.resize(r, vector<ll>(c, 0));
		for (ll j = 0; j < c; j++) {
			for (ll i = 0; i < r; i++) {
				cin >> a[i][j];
			}
		}
	}
	else {
		a.resize(r, vector<ll>(c, 0));
		for (ll i = 0; i < r; i++) {
			for (ll j = 0; j < c; j++) {
				cin >> a[i][j];
			}
		}
	}
	vector<vector<long long>> peri(r, vector<long long>(c, 0));
	vector<vector<long long>> perj(r, vector<long long>(c, 0));
	for (ll i = r - 1; i >= 0; i--) {
		long long resi = 0;
		ll cnt[2]{};
		for (ll j = c - 1; j >= 0; j--) {
			long long resj = 0;
			for (ll k = r - 1; k > i; k--) {
				resj += get(fen[0], a[k][j]);
				resi += cnt[1] - get(fen[1], a[k][j]);
				upd(fen[0], a[k][j], 1); cnt[0]++;
			}
			resj += get(fen[0], a[i][j]);
			resi += get(fen[0], a[i][j]);
			perj[i][j] = resj;
			peri[i][j] = resi;
			upd(fen[0], a[i][j], 1); cnt[0]++;
			upd(fen[1], a[i][j], 1); cnt[1]++;
		}
		for (ll j = 0; j < c; j++) {
			for (ll k = i; k < r; k++) {
				upd(fen[0], a[k][j], -1);
			}
			upd(fen[1], a[i][j], -1);
		}
	}
	vector<vector<long long>> dp(r + 1, vector<long long>(c + 1, INF));
	dp[0][0] = 0;
	for (ll i = 0; i < r; i++) {
		for (ll j = 0; j < c; j++) {
			dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + peri[i][j]);
			dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + perj[i][j]);
		}
	}
	long long ans = INF;
	for (ll i = 0; i < r; i++) ans = min(ans, dp[i][c]);
	for (ll j = 0; j < c; j++) ans = min(ans, dp[r][j]);
	cout << ans << "\n";
	return 0;
}