#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <random>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

template <typename T>
struct Point {
    T x = 0, y = 0;

    Point() = default;

    Point(T const &x, T const &y) : x(x), y(y) {}

    Point operator+(Point const &p) const {
        return {x + p.x, y + p.y};
    }

    Point operator-(Point const &p) const {
        return {x - p.x, y - p.y};
    }

    T operator*(Point const &p) const {
        return x * p.x + y * p.y;
    }

    T operator%(Point const &p) const {
        return x * p.y - p.x * y;
    }

    T len2() const {
        return x * x + y * y;
    }

    ld len() const {
        return sqrtl(len2());
    }

    Point ort() const {
        return {-y, x};
    }
};

int n;
ll r;
bool f;
vector<Point<ll>> p;
vector<vector<int>> g;
vector<int> ans, color;
vector<int> stack;

void dfs(int id) {
    stack.push_back(id);

    for (int i = 0; i < n; ++i) {
        if (i == id) continue;
        if ((p[i] - p[id]).len2() <= r * r) {
            if (color[i]) {
                if (color[i] == color[id]) {
                    f = true;
                }
            } else {
                color[i] = 3 - color[id];
                dfs(i);
            }
        }
    }
}

void solve() {
    cin >> n >> r;
    p.resize(n);
    for (auto &e : p) cin >> e.x >> e.y;
    g.resize(n);
    ans.resize(n, -1);
    color.resize(n);

    for (int i = 0; i < n; ++i) {
        if (color[i]) continue;
        stack.clear();
        f = false;
        color[i] = 1;
        dfs(i);
        for (int const &e : stack) {
            ans[e] = f;
        }
    }

    for (int const &e : ans) cout << e;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}