// #pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int r, c;
    cin >> r >> c;

    vector<vector<int>> a(r, vector<int>(c));
    for (auto &z : a) for (auto &v : z) {
        cin >> v;
        v--;
    }

    vector<vector<int>> hor(r, vector<int>(c));
    vector<vector<int>> vert(r, vector<int>(c));

    for (int i = 0; i < r; ++i) {
        oset<int> q;
        q.insert(a[i][c - 1]);
        for (int j = c - 2; j >= 0; --j) {
            hor[i][j] = hor[i][j + 1] + q.order_of_key(a[i][j]);
            q.insert(a[i][j]);
        }
    }
    for (int j = 0; j < c; ++j) {
        oset<int> q;
        q.insert(a[r - 1][j]);
        for (int i = r - 2; i >= 0; --i) {
            vert[i][j] = vert[i + 1][j] + q.order_of_key(a[i][j]);
            q.insert(a[i][j]);
        }
    }

    vector<vector<oset<int>>> qs(r + 1, vector<oset<int>>(c + 1));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            for (int i1 = i; i1 < r; ++i1) {
                for (int j1 = j; j1 < c; ++j1) {
                    qs[i][j].insert(a[i1][j1]);
                }
            }
        }
    }

    vector<vector<int>> dp(r + 1, vector<int>(c + 1));
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            int z = dp[i + 1][j] + hor[i][j];
            int v = dp[i][j + 1] + vert[i][j];

            for (int k = j; k < c; ++k) {
                z += qs[i + 1][j].order_of_key(a[i][k]);
            }

            for (int k = i; k < r; ++k) {
                v += qs[i][j + 1].order_of_key(a[k][j]);
            }

            dp[i][j] = min(z, v);
        }
    }

    cout << dp[0][0];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}