// #pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int r, c;
    cin >> r >> c;

    vector<vector<int>> a(r, vector<int>(c));
    for (auto &z : a) for (auto &v : z) {
        cin >> v;
        v--;
    }

    vector<vector<int>> hor(r, vector<int>(c));
    vector<vector<int>> vert(r, vector<int>(c));
    vector<vector<oset<int>>> hor_qs(r + 1, vector<oset<int>>(c + 1));
    vector<vector<oset<int>>> vert_qs(r + 1, vector<oset<int>>(c + 1));

    for (int i = 0; i < r; ++i) {
        hor_qs[i][c - 1].insert(a[i][c - 1]);

        for (int j = c - 2; j >= 0; --j) {
            hor_qs[i][j] = hor_qs[i][j + 1];
            hor[i][j] = hor[i][j + 1] + hor_qs[i][j].order_of_key(a[i][j]);
            hor_qs[i][j].insert(a[i][j]);
        }
    }
    for (int j = 0; j < c; ++j) {
        vert_qs[r - 1][j].insert(a[r - 1][j]);

        for (int i = r - 2; i >= 0; --i) {
            vert_qs[i][j] = vert_qs[i + 1][j];
            vert[i][j] = vert[i + 1][j] + vert_qs[i][j].order_of_key(a[i][j]);
            vert_qs[i][j].insert(a[i][j]);
        }
    }

    vector<vector<int>> dp(r + 1, vector<int>(c + 1));
    for (int i = r - 1; i >= 0; --i) {
        for (int j = c - 1; j >= 0; --j) {
            int z = dp[i + 1][j] + hor[i][j];
            int v = dp[i][j + 1] + vert[i][j];

            for (int k = j; k < c; ++k) {
                for (int i1 = i + 1; i1 < r; ++i1) {
                    z += hor_qs[i1][j].order_of_key(a[i][k]);
                }
            }

            for (int k = i; k < r; ++k) {
                for (int j1 = j + 1; j1 < c; ++j1) {
                    v += vert_qs[i][j1].order_of_key(a[k][j]);
                }
            }

            dp[i][j] = min(z, v);
        }
    }

    cout << dp[0][0];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}