// #pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int r, c;
    cin >> r >> c;
    if (r == 2) {
        vector<vector<int>> a(r, vector<int>(c));
        for (auto &z : a) for (auto &v : z) cin >> v;
        vector<vector<int>> dp(2, vector<int>(c + 1));
        oset<int> q;
        q.insert(a[1][c - 1]);
        for (int i = c - 2; i >= 0; --i) {
            dp[1][i] = dp[1][i + 1] + q.order_of_key(a[1][i]);
            q.insert(a[1][i]);
        }

        oset<int> up;
        oset<int> down, right;
        ll kostyl = 0;
        ll rev = 0;
        for (int i = c - 1; i >= 0; --i) {
            rev += up.order_of_key(a[0][i]);

            up.insert(a[0][i]);
            down.insert(a[1][i]);

            kostyl += down.order_of_key(a[0][i]);
            kostyl += up.size() - up.order_of_key(a[1][i]);
            kostyl -= a[0][i] > a[1][i];

            int z = dp[0][i + 1];
            z += right.order_of_key(a[0][i]);
            z += right.order_of_key(a[1][i]);
            z += a[0][i] > a[1][i];

            int v = dp[1][i] + rev + kostyl;
            dp[0][i] = min(z, v);

            right.insert(a[0][i]);
            right.insert(a[1][i]);
        }
        cout << dp[0][0];
    } else {
        int x;
        ll ans = 0;
        oset<int> q;
        for (int i = 0; i < c; ++i) {
            cin >> x;
            ans += q.size() - q.order_of_key(x);
            q.insert(x);
        }
        cout << ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}