// #pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, q;
    cin >> n >> q;
    int k = n;
    vector<int> a(n);
    for (auto &e : a) cin >> e;

    vector<vector<vector<int>>> dp(k, vector<vector<int>>(n, vector<int>(1, 1e9)));
    dp[0][0] = {a[0]};
    for (int i = 1; i < n; ++i) {
        dp[0][i] = {min(dp[0][i - 1][0], a[i])};
    }

    for (int i = 1; i < k; ++i) {
        for (int j = i; j < n; ++j) {
            int mx = a[j];
            for (int pr = j - 1; pr >= i - 1; --pr) {
                auto kostyl = dp[i - 1][pr];
                kostyl.push_back(mx);
                dp[i][j] = min(dp[i][j], kostyl);

                mx = max(mx, a[pr]);
            }
        }
    }

    int z, v;
    while (q--) {
        cin >> z >> v;
        cout << dp[z - 1][n - 1][v - 1] << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}