// #pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int &e : a) cin >> e;
    vector<int> pr(n), suf(n);
    pr[0] = a[0];
    suf[n - 1] = a[n - 1];
    for (int i = 1; i < n; ++i) {
        pr[i] = max(pr[i - 1], a[i]);
        suf[n - i - 1] = max(suf[n - i], a[n - i - 1]);
    }
    pii ans{1e9, 1e9};
    for (int i = 1; i < n; ++i) {
        ans = min(ans, pii{pr[i - 1], suf[i]});
    }
    int z, v;
    while (q--) {
        cin >> z >> v;
        v--;
        if (v == 0) cout << ans.first << '\n';
        else cout << ans.second << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}