#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

using vec = pair<int, int>;

vec operator+(const vec &a, const vec &b) {
	return {a.x + b.x, a.y + b.y};
}

vec operator-(const vec &a, const vec &b) {
	return {a.x - b.x, a.y - b.y};
}

ll norm(const vec &a) {
	return 1ll * a.x * a.x + 1ll * a.y * a.y;
}

ll dot_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.x + 1ll * a.y * b.y;
}

ll cross_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

void solve() {
	int n;
	int r;
	cin >> n >> r;
	vector<vec> a(n);
	map<vec, int> idx;
	for (int i = 0; i < n; i++) {
		cin >> a[i].x >> a[i].y;
		idx[a[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		a.emplace_back(a[i].x + r + 1, -a[i].y - 1);
	}
	sort(a.begin(), a.end());
	set<vec> stw, stb;
	vector<vector<int>> g(n);
	for (vec v : a) {
		if (v.y < 0) {
			v.y = -v.y - 1;
			v.x -= r + 1;
			stw.erase({v.y, v.x});
			stb.erase({v.y, v.x});
			continue;
		}
		if (stb.empty() && stw.empty()) {
			stw.emplace(v.y, v.x);
			continue;
		}
		int bl = 0, wh = 0;
		if (!stw.empty()) {
			auto ptr = stw.lower_bound({v.y, -1});
			if (ptr != stw.end()) {
				vec o = *ptr;
				swap(o.x, o.y);
				if (norm(o - v) <= 1ll * r * r) {
					bl = 1;
					g[idx[o]].push_back(idx[v]);
					g[idx[v]].push_back(idx[o]);
				}
			}
			if (ptr != stw.begin()) {
				ptr--;
				vec o = *ptr;
				swap(o.x, o.y);
				if (norm(o - v) <= 1ll * r * r) {
					bl = 1;
					g[idx[o]].push_back(idx[v]);
					g[idx[v]].push_back(idx[o]);
				}
			}
		}
		if (!stb.empty()) {
			auto ptr = stb.lower_bound({v.y, -1});
			if (ptr != stb.end()) {
				vec o = *ptr;
				swap(o.x, o.y);
				if (norm(o - v) <= 1ll * r * r) {
					wh = 1;
					g[idx[o]].push_back(idx[v]);
					g[idx[v]].push_back(idx[o]);
				}
			}
			if (ptr != stb.begin()) {
				ptr--;
				vec o = *ptr;
				swap(o.x, o.y);
				if (norm(o - v) <= 1ll * r * r) {
					wh = 1;
					g[idx[o]].push_back(idx[v]);
					g[idx[v]].push_back(idx[o]);
				}
			}
		}
		if (wh) {
			vector<vec> er;
			{
				auto ptr = stw.lower_bound({v.y, -1});
				while (ptr != stw.end()) {
					vec o = *ptr;
					swap(o.x, o.y);
					ptr++;
					vec v2 = v + make_pair(0, r);
					if (dot_prod(v2 - o, v - o) >= dot_prod(v2 - v, o - v)) {
						er.push_back(o);
					} else {
						// break;
					}
				}
			}
			{
				auto ptr = stw.lower_bound({v.y, -1});
				while (ptr != stw.begin()) {
					ptr--;
					vec o = *ptr;
					swap(o.x, o.y);
					vec v2 = v - make_pair(0, r);
					if (dot_prod(v2 - o, v - o) >= dot_prod(v2 - v, o - v)) {
						er.push_back(o);
					} else {
						// break;
					}
				}
			}
			for (vec o : er) {
				swap(o.x, o.y);
				stw.erase(o);
			}
			stw.emplace(v.y, v.x);
		}
		if (bl) {
			vector<vec> er;
			{
				auto ptr = stb.lower_bound({v.y, -1});
				while (ptr != stb.end()) {
					vec o = *ptr;
					swap(o.x, o.y);
					ptr++;
					vec v2 = v + make_pair(0, r);
					if (dot_prod(v2 - o, v - o) >= dot_prod(v2 - v, o - v)) {
						er.push_back(o);
					} else {
						// break;
					}
				}
			}
			{
				auto ptr = stb.lower_bound({v.y, -1});
				while (ptr != stb.begin()) {
					ptr--;
					vec o = *ptr;
					swap(o.x, o.y);
					vec v2 = v - make_pair(0, r);
					if (dot_prod(v2 - o, v - o) >= dot_prod(v2 - v, o - v)) {
						er.push_back(o);
					} else {
						// break;
					}
				}
			}
			for (vec o : er) {
				swap(o.x, o.y);
				stb.erase(o);
			}
			stb.emplace(v.y, v.x);
		}
	}
	string ans(n, '0');
	vector<int> used(n, 0);
	auto paint {[&](auto paint, int s, int c) -> void {
		used[s] = c;
		for (int i : g[s]) {
			if (!used[i]) {
				paint(paint, i, 3 - c);
			} else {
				if (used[i] == used[s]) {
					ans[s] = '1';
				}
			}
		}
	}};
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			paint(paint, i, 1);
		}
	}
	fill(used.begin(), used.end(), 0);
	auto dfs {[&](auto dfs, int s) -> void {
		ans[s] = '1';
		used[s] = 1;
		for (int i : g[s]) {
			if (!used[i]) {
				dfs(dfs, i);
			}
		}
	}};
	for (int i = 0; i < n; i++) {
		if (!used[i] && ans[i] == '1') {
			dfs(dfs, i);
		}
	}
	cout << ans << '\n';
}