#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

using vec = pair<int, int>;

vec operator+(const vec &a, const vec &b) {
	return {a.x + b.x, a.y + b.y};
}

vec operator-(const vec &a, const vec &b) {
	return {a.x - b.x, a.y - b.y};
}

ll norm(const vec &a) {
	return 1ll * a.x * a.x + 1ll * a.y * a.y;
}

ll dot_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.x + 1ll * a.y * b.y;
}

ll cross_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

void solve() {
	int n;
	int r;
	cin >> n >> r;
	vector<vec> a(n);
	map<vec, int> idx;
	for (int i = 0; i < n; i++) {
		cin >> a[i].x >> a[i].y;
		idx[a[i]] = i;
	}
	vector<vector<int>> g(n);
	for (int i = 0; i < n; i++) {
		for (int dx = -r; dx <= r; dx++) {
			for (int dy = -r; dy <= r; dy++) {
				vec d = {dx, dy};
				if (norm(d) <= 1ll * r * r && norm(d) != 0) {
					if (idx.find(d + a[i]) != idx.end()) {
						g[i].push_back(idx[d + a[i]]);
					}
				}
			}
		}
	}
	string ans(n, '0');
	vector<int> used(n, 0);
	auto paint {[&](auto paint, int s, int c) -> void {
		used[s] = c;
		for (int i : g[s]) {
			if (!used[i]) {
				paint(paint, i, 3 - c);
			} else {
				if (used[i] == used[s]) {
					ans[s] = '1';
				}
			}
		}
	}};
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			paint(paint, i, 1);
		}
	}
	fill(used.begin(), used.end(), 0);
	auto dfs {[&](auto dfs, int s) -> void {
		ans[s] = '1';
		used[s] = 1;
		for (int i : g[s]) {
			if (!used[i]) {
				dfs(dfs, i);
			}
		}
	}};
	for (int i = 0; i < n; i++) {
		if (!used[i] && ans[i] == '1') {
			dfs(dfs, i);
		}
	}
	cout << ans << '\n';
}