#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

using vec = pair<int, int>;

vec operator+(const vec &a, const vec &b) {
	return {a.x + b.x, a.y + b.y};
}

vec operator-(const vec &a, const vec &b) {
	return {a.x - b.x, a.y - b.y};
}

ll norm(const vec &a) {
	return 1ll * a.x * a.x + 1ll * a.y * a.y;
}

ll dot_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.x + 1ll * a.y * b.y;
}

ll cross_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

struct DSU {
	vector<int> p;
	vector<int> change;
	DSU(int n) {
		p.resize(n, -1);
		change.resize(n, 0);
	}
	int get_par(int x) {
		return p[x] < 0 ? x : get_par(p[x]);
	}
	int get_col(int x) {
		return p[x] < 0 ? 0 : (change[x] ^ get_col(p[x]));
	}
	bool merge(int x, int y) {
		int cx = get_col(x);
		int cy = get_col(y);
		x = get_par(x);
		y = get_par(y);
		if (x == y) return false;
		if (p[x] > p[y]) swap(x, y);
		if (p[x] == p[y]) p[x]--;
		p[y] = x;
		if (cx == cy) {
			change[y] = 1;
		}
		return true;
	}
};

void solve() {
	int n;
	int r;
	cin >> n >> r;
	vector<vec> a(n);
	map<vec, int> idx;
	for (int i = 0; i < n; i++) {
		cin >> a[i].x >> a[i].y;
		idx[a[i]] = i;
	}
	string ans(n, '0');
	vector<vector<int>> g(n);
	DSU dsu(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (norm(a[i] - a[j]) <= 1ll * r * r) {
				if (dsu.merge(i, j)) {
					g[i].push_back(j);
					g[j].push_back(i);
				} else {
					if (dsu.get_col(i) == dsu.get_col(j) && ans[i] == '0' && ans[j] == '0') {
						g[i].push_back(j);
						g[j].push_back(i);
						ans[i] = '1';
						ans[j] = '1';
					}
				}
			}
		}
	}
	vector<int> used(n, 0);
	auto paint {[&](auto paint, int s, int c) -> void {
		used[s] = c;
		for (int i : g[s]) {
			if (!used[i]) {
				paint(paint, i, 3 - c);
			} else {
				if (used[i] == used[s]) {
					ans[s] = '1';
				}
			}
		}
	}};
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			paint(paint, i, 1);
		}
	}
	fill(used.begin(), used.end(), 0);
	auto dfs {[&](auto dfs, int s) -> void {
		ans[s] = '1';
		used[s] = 1;
		for (int i : g[s]) {
			if (!used[i]) {
				dfs(dfs, i);
			}
		}
	}};
	for (int i = 0; i < n; i++) {
		if (!used[i] && ans[i] == '1') {
			dfs(dfs, i);
		}
	}
	cout << ans << '\n';
}