#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

struct segment_tree {
	vector<int> st;
	size_t sz;
	segment_tree(int n) {
		sz = 1;
		while (sz < n) sz <<= 1;
		st.resize(2 * sz, 0);
	}
	void add(int i, int v) {
		i += sz;
		while (i) {
			st[i] += v;
			i >>= 1;
		}
	}
	int get(int l, int r) {
		l += sz; r += sz;
		int res = 0;
		while (l <= r) {
			if (l & 1) res += st[l++];
			if (~r & 1) res += st[r--];
			l >>= 1;
			r >>= 1;
		}
		return res;
	}
};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}
	ll base = 0;
	for (int i = 0; i < n; i++) {
		segment_tree st(n * m);
		for (int j = m - 1; j >= 0; j--) {
			for (int l = n - 1; l >= i; l--) {
				st.add(a[l][j], 1);
			}
			base += st.get(0, a[i][j] - 1);
		}
	}
	vector<vector<ll>> dp1(n, vector<ll>(m, 0));
	vector<vector<ll>> go1(n, vector<ll>(m, 0));
	vector<vector<ll>> go2(n, vector<ll>(m, 0));
	for (int i = 0; i < n; i++) {
		segment_tree st(n * m);
		for (int j = m - 1; j >= 0; j--) {
			for (int l = n - 1; l > i; l--) {
				dp1[i][j] += st.get(0, a[l][j] - 1);
			}
			st.add(a[i][j], 1);
			if (j + 1 < m) {
				go1[i][j] = go1[i][j + 1];
			}
			go1[i][j] += (m - j - 1) * (n - i - 1) - dp1[i][j];
		}
	}
	for (int j = 0; j < m; j++) {
		for (int i = n - 1; i >= 0; i--) {
			if (i + 1 < n) {
				go2[i][j] = go2[i + 1][j];
			}
			go2[i][j] += dp1[i][j];
		}
	}
	vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 0));
	for (int i = n - 1; i >= 0; i--) {
		for (int j = n - 1; j >= 0; j--) {
			dp[i][j] = min(dp[i + 1][j] + go1[i][j], dp[i][j + 1] + go2[i][j]);
		}
	}
	cout << dp[0][0] << '\n';
}