#pragma GCC optimize("O3")
#include <vector>
#pragma GCC target("avx", "avx2")
#include <iostream>
#include <random>
#include <ctime>

using namespace std;

mt19937 rnd(time(0));

template<typename T>
void print(T x) {
    cout << x;
}

template<typename T>
void print(vector<T> v) {
    for (T x : v) {
        print(x);
        cout << ' ';
    }
    cout << '\n';
}

struct point{
    long long x, y;
    point(){}
    point(long long x, long long y) : x{x}, y{y} {}
    long long dist(point &p) {
        return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
    }
};
vector<vector<int>> g;
vector<int> term;
vector<int> clr;
vector<bool> used;

int dfs(int v, int c = 1) {
    clr[v] = c;
    for (int to : g[v]) {
        if (clr[to]) {
            if (clr[to] == clr[v]) {
                term[v] = 1;
                break;
            }
            continue;
        }
        if (dfs(to, 3 - c)) return 1;
    }
    return term[v];
}

void dfs2(int v) {
    used[v] = 1;
    for (int to : g[v]) {
        term[v] = max(term[v], term[to]);
        if (used[to]) continue;
        dfs2(to);
        term[v] = max(term[v], term[to]);
    }
}

void solveB() {
    int n;
    long long r;
    cin >> n >> r;
    r *= r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (a[i].dist(a[j]) > r) continue;
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }
    //print(g);
    clr.resize(n);
    term.resize(n);
    used.resize(n);
    // for (int i = 0; i < n; ++i) {
    //     term[i] = 0;
    //     if (g[i].size() > 5) {
    //         term[i] = 1;
    //         continue;
    //     }
    //     for (int j = 0; j < g[i].size() && !term[i]; ++j) {
    //         for (int k = 0; k < j; ++k) {
    //             if (a[g[i][j]].dist(a[g[i][j]]) <= r) {
    //                 term[i] = 1;
    //                 break;
    //             }
    //         }
    //     }
    // }
    for (int i = 0; i < n; ++i) {
        clr[i] = 0;
        term[i] = 0;
        used[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (clr[i]) continue;
        dfs(i);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        dfs2(i);
    }
    for (int i = 0; i < n; ++i) {
        cout << term[i];
    }
    cout << '\n';
}

int main() {
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) solveB();
}