#pragma GCC optimize("O3")
#include <vector>
#pragma GCC target("avx", "avx2")
#include <iostream>
#include <random>
#include <ctime>
 
using namespace std;
 
mt19937 rnd(time(0));
 
template<typename T>
void print(T x) {
    cout << x;
}
 
template<typename T>
void print(vector<T> v) {
    for (T x : v) {
        print(x);
        cout << ' ';
    }
    cout << '\n';
}
 
struct point{
    long long x, y;
    point(){}
    point(long long x, long long y) : x{x}, y{y} {}
    long long dist(point &p) {
        return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
    }
};

vector<vector<int>> g;
vector<int> clr, term, used;

int dfs1(int u, int c = 1) {
    clr[u] = c;
    for (int to : g[u]) {
        if (clr[to]) {
            if (term[to]) {
                return 1;
            }
            if (clr[to] == clr[u]) {
                term[u] = 1;
                return 1;
            }
            continue;
        }
        if (dfs1(to, 3 - c)) {
            return 1;
        }
    }
    return 0;
}

void dfs2(int u) {
    used[u] = 1;
    term[u] = 1;
    for (int to : g[u]) {
        if (used[to]) continue;
        dfs2(to);
    }
    return;
}
 
void solveB() {
    int n;
    long long r;
    cin >> n >> r;
    r *= r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    g.resize(n);
    used.resize(n);
    clr.resize(n);
    term.resize(n);
    for (int i = 0; i < n; ++i) {
        used[i] = clr[i] = term[i] = 0;
        for (int j = 0; j < i; ++j) {
            if (a[i].dist(a[j]) > r) continue;
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (clr[i]) continue;
        dfs1(i);
    }
    for (int i = 0; i < n; ++i) {
        if (!term[i] || used[i]) continue;
        dfs2(i);
    }
    for (int i = 0; i < n; ++i) {
        cout << term[i];
    }
    cout << '\n';
}
 
int main() {
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) solveB();
}