#pragma GCC optimize("O3")
#include <vector>
#pragma GCC target("avx", "avx2")
#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
 
using namespace std;
 
mt19937 rnd(time(0));
 
template<typename T>
void print(T x) {
    cout << x;
}
 
template<typename T>
void print(vector<T> v) {
    for (T x : v) {
        print(x);
        cout << ' ';
    }
    cout << '\n';
}
 
struct point{
    int x, y;
    point(){}
    point(int x, int y) : x{x}, y{y} {}
    long long dist(point &p) {
        return (long long)(x - p.x) * (long long)(x - p.x) + (long long)(y - p.y) * (long long)(y - p.y);
    }
};

vector<vector<int>> g;
vector<char> clr;
vector<bool> term, used;

int dfs1(int u, int c = 1) {
    clr[u] = c;
    for (int to : g[u]) {
        if (clr[to]) {
            if (term[to]) {
                return 1;
            }
            if (clr[to] == clr[u]) {
                term[u] = 1;
                return 1;
            }
            continue;
        }
        if (dfs1(to, 3 - c)) {
            return 1;
        }
    }
    return 0;
}

void dfs2(int u) {
    used[u] = 1;
    term[u] = 1;
    for (int to : g[u]) {
        if (used[to]) continue;
        dfs2(to);
    }
    return;
}
 
void solveB() {
    int n;
    long long r;
    cin >> n >> r;
    r *= r;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    n = min(10000, n);
    //shuffle(a.begin(), a.end(), rnd);
    g.resize(n);
    used.resize(n);
    clr.resize(n);
    term.resize(n);
    for (int i = 0; i < n; ++i) {
        used[i] = clr[i] = term[i] = 0;
        for (int j = 0; j < i; ++j) {
            if (a[i].dist(a[j]) > r) continue;
            g[i].push_back(j);
            g[j].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (clr[i]) continue;
        dfs1(i);
    }
    for (int i = 0; i < n; ++i) {
        if (!term[i] || used[i]) continue;
        dfs2(i);
    }
    for (int i = 0; i < n; ++i) {
        cout << term[i];
    }
    cout << '\n';
}

struct fenvickTree{
    fenvickTree(int size) {
        sz = size + 1;
        tree.resize(sz);
        for (int i = 1; i <= sz; ++i) {
            tree[i] = 0;
        }
    }
    void upd(int u) {
        while (u < sz) {
            ++tree[u];
            u += u & (-u);
        }
    }
    int get(int l, int r) {
        return getr(r) - getr(l - 1);
    }
    int getr(int r) {
        int ret = 0;
        while (r > 0) {
            ret += tree[r];
            r -= r & (-r);
        }
        return ret;
    }
    vector<int> tree;
    int sz;
};

void solveC() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m)), dp(n + 1, vector<int> (m + 1, 0));
    vector<vector<int>> rp(n + 1, vector<int> (m + 1)), cp(n + 1, vector<int> (m + 1)), inv(n + 1, vector<int> (m + 1, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
        cp[i][m] = 0;
    }
    for (int j = 0; j < m; ++j) {
        rp[n][j] = 0;
    }
    for (int j = m - 1; j >= 0; --j) {
        fenvickTree tree(n * m);
        for (int i = n - 1; i >= 0; --i) {
            tree.upd(a[i][j]);
            cp[i][j] = tree.get(1, a[i][j] - 1) + cp[i + 1][j];
        }
    }
    vector<fenvickTree> r (n, fenvickTree(n * m));
    for (int j = m - 1; j >= 0; --j) {
        for (int i = n - 1; i >= 0; --i) {
            r[i].upd(a[i][j]);
            rp[i][j] = r[i].get(1, a[i][j] - 1) + rp[i][j + 1];
            for (int k = n - 1; k >= i; --k) {
                inv[i][j] += r[k].get(1, a[i][j] - 1);
            }
            //inv[i][j] += inv[i + 1][j] + inv[i][j + 1] - inv[i + 1][j + 1];
        }
    }
    //print(inv);
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            int c_ = 0, r_ = 0;
            for (int k = n - 1; k >= i; --k) {
                c_ += inv[k][j];
            }
            for (int k = m - 1; k >= j; --k) {
                r_ += inv[i][k];
            }
            dp[i][j] = min(dp[i][j + 1] + c_, dp[i + 1][j] + r_);
        }
    }
    //print(dp);
    cout << dp[0][0] << '\n';
}
 
int main() {
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) solveC();
}