#pragma GCC optimize("O3")
#include <vector>
#pragma GCC target("avx", "avx2")
#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
 
using namespace std;
 
mt19937 rnd(time(0));
 
template<typename T>
void print(T x) {
    cout << x;
}
 
template<typename T>
void print(vector<T> v) {
    for (T x : v) {
        print(x);
        cout << ' ';
    }
    cout << '\n';
}
 
struct point{
    int x, y;
    point(){}
    point(int x, int y) : x{x}, y{y} {}
    long long dist(point &p) {
        return (long long)(x - p.x) * (long long)(x - p.x) + (long long)(y - p.y) * (long long)(y - p.y);
    }
};

// vector<int> g[10000];
// char clr[10000];
// bool term[10000], used[10000];

// int dfs1(int u, int c = 1) {
//     clr[u] = c;
//     for (int to : g[u]) {
//         if (clr[to]) {
//             if (term[to]) {
//                 return 1;
//             }
//             if (clr[to] == clr[u]) {
//                 term[u] = 1;
//                 return 1;
//             }
//             continue;
//         }
//         if (dfs1(to, 3 - c)) {
//             return 1;
//         }
//     }
//     return 0;
// }

// void dfs2(int u) {
//     used[u] = 1;
//     term[u] = 1;
//     for (int to : g[u]) {
//         if (used[to]) continue;
//         dfs2(to);
//     }
//     return;
// }
 
void solveB() {
    int n, r;
    cin >> n >> r;
    vector<int> x(n);
    int z;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> z;
    }
    sort(x.begin(), x.end());
    int i = 0, j = 0, l = 0;
    vector<int> clr(n, 0);
    int c = 0;
    while (j < n) {
        while (x[l] + r >= x[j]) {
            if (j - l > 1) c = 1;
            ++j;
        }
        l = j;
        if (x[j] - x[j - 1] > r) {
            for (int k = i; k < j; ++k) clr[k] = c;
            c = 0;
            i = j;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << clr[i];
    }
    cout << '\n';
}

struct fenvickTree{
    fenvickTree(int size) {
        sz = size + 1;
        tree.resize(sz);
        for (int i = 1; i <= sz; ++i) {
            tree[i] = 0;
        }
    }
    void upd(int u) {
        while (u < sz) {
            ++tree[u];
            u += u & (-u);
        }
    }
    int get(int l, int r) {
        return getr(r) - getr(l - 1);
    }
    int getr(int r) {
        int ret = 0;
        while (r > 0) {
            ret += tree[r];
            r -= r & (-r);
        }
        return ret;
    }
    vector<int> tree;
    int sz;
};

void solveC() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m)), dp(n + 1, vector<int> (m + 1, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        fenvickTree tree(n * m);
        for (int j = m - 1; j >= 0; --j) {
            tree.upd(a[i][j]);
            int inv = 0;
            for (int k = m - 1; k >= j; --k) {
                inv += tree.get(1, a[i][k] - 1);
            }
            if (dp[i + 1][j] + inv < dp[i][j + 1] + (n - i) * (m - j) - inv) {
                dp[i][j] = 1;
            }
        }
    }
    vector<int> ans;
    int x = 0, y = 0;
    while (x < n - 1 && y < m - 1) {
        if (dp[y][x]) {
            for (int i = x; i < m; ++i) {
                ans.push_back(a[y][i]);
            }
            ++y;
        }
        else {
            for (int i = y; i < n; ++i) {
                ans.push_back(a[i][x]);
            }
            ++x;
        }
    }
    if (x == m - 1) {
        for (int i = y; i < n; ++i) {
            ans.push_back(a[i][x]);
        }
    } else {
        for (int i = x; i < m; ++i) {
            ans.push_back(a[y][i]);
        }
    }
    print(dp);
    print(ans);
}

void solveD() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n +1);
    vector<int> mxp(n + 2, 0);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for (int i = n; i >= 1; --i) {
        mxp[i] = max(a[i], mxp[i + 1]);
    }
    for (int i = 0; i < q; ++i) {
        int k, id;
        cin >> k >> id;
        if (id == k) {
            cout << mxp[k] << '\n';
        } else {
            cout << a[id] << '\n';
        }
    }
}
 
int main() {
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) solveD();
}