#include <bits/stdc++.h>

using ld = long double;
using ll = long long;
using namespace std;

template<class T>
struct point {
    T x;
    T y;

    point() {
        x = 0;
        y = 0;
    }

    point(T x_, T y_) {
        x = x_;
        y = y_;
    }

    point(T x1, T y1, T x2, T y2) {
        x = x2 - x1;
        y - y2 - y1;
    }

    point(point a, point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    point operator+(const point &other) const {
        return {x + other.x, y + other.y};
    }

    point operator-(const point &other) const {
        return {x - other.x, y - other.y};
    }

    point operator*(const T &k) const {
        return {x * k, y * k};
    }

    T operator*(const point &other) const {
        return {x * other.x + y * other.y};
    }

    T operator%(const point &other) const {
        return {x * other.y - y * other.x};
    }

    T len() {
        return x * x + y * y;
    }

    ld lensqr() {
        return sqrt(len());
    }
};

using pointll = point<ll>;
using pointld = point<ld>;

vector<vector<int> > graph;
vector<int> colour;

int dfs(int v, int c, vector<int> &now) {
    now.push_back(v);
    colour[v] = c;
    int flag = 0;
    for (auto u: graph[v]) {
        if (!colour[u])
            flag = max(flag, dfs(u, 3 - c, now));
        else if (colour[u] == colour[v])
            flag = 1;
    }
    return flag;
}

const ld eps = 1e-7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, r;
    cin >> n >> r;

    graph.resize(n);
    colour.assign(n, 0);

    map<pair<int, int>, int> m;
    set<pair<int, int>> s;

    vector<pointll> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
        m[{points[i].x, points[i].y}] = i + 1;
        s.insert({points[i].x, points[i].y});
    }

    for (int i = 0; i < n; ++i) {
        for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                int now_x = points[i].x + dx, now_y = points[i].y + dy;
                if (s.count({now_x, now_y})) {
                    int k = m[{now_x, now_y}] - 1;
                    if (sqrt(dx * dx + dy * dy) - eps <= r && k != i)
                        graph[i].push_back(k);
                }
            }
        }
    }

    vector<int> ans(n, 0);

    for (int i = 0; i < n; ++i) {
        if (!colour[i]) {
            vector<int> now;
            if (dfs(i, 1, now))
                for (auto &x: now)
                    ans[x] = 1;
        }
    }

    for (auto &x: ans)
        cout << x;
}
