#include <bits/stdc++.h>

using ld = long double;
using ll = long long;
using namespace std;

template<class T>
struct point {
    T x;
    T y;

    point() {
        x = 0;
        y = 0;
    }

    point(T x_, T y_) {
        x = x_;
        y = y_;
    }

    point(T x1, T y1, T x2, T y2) {
        x = x2 - x1;
        y - y2 - y1;
    }

    point(point a, point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    point operator+(const point &other) const {
        return {x + other.x, y + other.y};
    }

    point operator-(const point &other) const {
        return {x - other.x, y - other.y};
    }

    point operator*(const T &k) const {
        return {x * k, y * k};
    }

    T operator*(const point &other) const {
        return {x * other.x + y * other.y};
    }

    T operator%(const point &other) const {
        return {x * other.y - y * other.x};
    }

    T len() {
        return x * x + y * y;
    }

    ld lensqr() {
        return sqrt(len());
    }
};

using pointll = point<ll>;
using pointld = point<ld>;

vector<vector<int> > graph;
vector<int> colour;

int dfs(int v, int c, vector<int> &now) {
    now.push_back(v);
    colour[v] = c;
    int flag = 0;
    for (auto u: graph[v]) {
        if (!colour[u])
            flag = max(flag, dfs(u, 3 - c, now));
        else if (colour[u] == colour[v])
            flag = 1;
    }
    return flag;
}

const ld eps = 1e-7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, r;
    cin >> n >> r;

    vector<int> coords(n);
    map<int, int> m; //coord -> ind

    for (int i = 0; i < n; ++i) {
        cin >> coords[i];
        int y;
        cin >> y;
        m[coords[i]] = i;
    }

    sort(coords.begin(), coords.end());

    vector<vector<int> > groups;
    int ind = 0;
    groups.emplace_back();
    for (int i = 0; i < n - 1; ++i) {
        groups[ind].push_back(coords[i]);
        if (coords[i + 1] - coords[i] > r) {
            ++ind;
            groups.emplace_back();
        }
    }
    groups[ind].push_back(coords[n - 1]);

    vector<int> ans(n);

    for (auto &x: groups) {
        int flag = 0;
        int l = x.size();
        for (int i = 0; i < l - 2; ++i)
            if (x[i + 2] - x[i] <= r) {
                flag = 1;
                break;
            }

        if (flag) {
            for (auto &y: x)
                ans[m[y]] = 1;
        }
    }

    for (auto x: ans)
        cout << x;
}
