#include <bits/stdc++.h>

using ld = long double;
using ll = long long;
using namespace std;

struct segtree {
    int size;
    vector<int> tree;

    segtree(int n) {
        size = 1;
        while (size < n)
            size *= 2;
        tree.assign(2 * size, 0);
    }

    int get(int x, int lx, int rx, int l, int r) {
        if (lx >= l && rx <= r)
            return tree[x];

        if (lx >= r || rx <= l)
            return 0;

        int m = (lx + rx) / 2;
        return get(2 * x, lx, m, l, r) + get(2 * x + 1, m, rx, l, r);
    }

    void change(int x, int lx, int rx, int ind, int val) {
        if (lx + 1 == rx) {
            tree[x] = val;
            return;
        }

        int m = (lx + rx) / 2;
        if (ind < m)
            change(2 * x, lx, m, ind, val);
        else
            change(2 * x + 1, m, rx, ind, val);
        tree[x] = tree[2 * x] + tree[2 * x + 1];
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;

    segtree seg(n * m);

    ll ans = 0;
    for (int i = 0; i < n * m; ++i) {
        int x;
        cin >> x;
        ans += seg.get(1, 0, seg.size, x, n * m);
        seg.change(1, 0, seg.size, x - 1, 1);
    }
    cout << ans;
}
