// Created by rost on 29.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

struct R {
    int x, y;
    //    int i;
    R() : x(0), y(0) {
    }

    R(int _x, int _y) : x(_x), y(_y) {
    }
};

bool operator<(const R &a, const R &b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.y < b.y;
}

inline ll dist2(const R &a, const R &b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return 1ll * dx * dx + 1ll * dy * dy;
}

const int MAX_N = 1e5;
int res[MAX_N];
vector<int> graph[MAX_N + 1];

int d[MAX_N + 1];

bool dfs(int v, int p) {
    for (auto to: graph[v]) {
        if (to == p)
            continue;

        if (d[to] != 0) {
            if (d[to] % 2 == d[v] % 2)
                return true;
        } else {
            d[to] = d[v] + 1;
            if (dfs(to, v))
                return true;
        }
    }
    return false;
}

void dfs2(int v) {
    res[v - 1] = 1;

    for (auto to: graph[v]) {
        if (res[to - 1])
            continue;

        dfs2(to);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, r;
    cin >> n >> r;
    // vector<R> pt(n);
    map<R, int> pt;
    for (int i = 0; i < n; ++i) {
        R PT;
        cin >> PT.x >> PT.y;
        pt[PT] = i + 1;
        //        pt[i].i = i;
    }

    for (auto [PT, i]: pt) {
        for (int dx = -r; dx <= r; ++dx) {
            for (int dy = -r; dy <= r; ++dy) {
                if (dx == 0 && dy == 0)
                    continue;
                if (1ll * dx * dx + 1ll * dy * dy <= 1ll * r * r) {
                    R to(PT.x + dx, PT.y + dy);
                    if (pt.find(to) != pt.end())
                        graph[i].push_back(pt[to]);
                }
            }
        }
    }

    // d.resize(n);
    // res.resize(n);
    for (int i = 1; i <= n; ++i) {
        if (d[i] != 0)
            continue;

        d[i] = 1;
        if (dfs(i, -1)) {
            dfs2(i);
        }
    }

    for (int i = 0; i < n; ++i)
        cout << res[i];
    cout << '\n';
}
