// Created by rost on 29.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

struct R {
    int x, y;
    //    int i;
    R() : x(0), y(0) {
    }

    R(int _x, int _y) : x(_x), y(_y) {
    }

    bool operator==(const R &o) const {
        return x == o.x && y == o.y;
    }
};

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int MAX_INT = ~(1 << 31);

struct h {
    const int fixedRandom = uniform_int_distribution<int>(0, MAX_INT)(rng);
    //    const int fixedRandom = 32483034;

    ll operator()(const R &p) const {
        return 1ll * (p.x ^ fixedRandom) * 13 + 1ll * p.y * fixedRandom;
    }
};

inline ll dist2(const R &a, const R &b) {
    int dx = a.x - b.x;
    int dy = a.y - b.y;
    return 1ll * dx * dx + 1ll * dy * dy;
}

const int MAX_N = 1e5;

int n, r;
int res[MAX_N];
R pt[MAX_N];

gp_hash_table<R, int, h> pt2;
// vector<int> graph[MAX_N];

int d[MAX_N + 1];

bool dfs(int v, int p) {
    for (int dx = -r; dx <= r; ++dx) {
        for (int dy = -r; dy <= r; ++dy) {
            if (dx == 0 && dy == 0)
                continue;

            if (1ll * dx * dx + 1ll * dy * dy <= 1ll * r * r) {
                R to(pt[v - 1].x + dx, pt[v - 1].y + dy);
                if (p != -1 && to == pt[p - 1])
                    continue;

                if (pt2.find(to) != pt2.end()) {
                    int toi = pt2[to];

                    if (d[toi] != 0) {
                        if (d[toi] % 2 == d[v] % 2)
                            return true;
                    } else {
                        d[toi] = d[v] + 1;
                        if (dfs(toi, v))
                            return true;
                    }
                }
            }
        }
    }
    return false;
}

void dfs2(int v) {
    res[v - 1] = 1;

    for (int dx = -r; dx <= r; ++dx) {
        for (int dy = -r; dy <= r; ++dy) {
            if (dx == 0 && dy == 0)
                continue;

            if (1ll * dx * dx + 1ll * dy * dy <= 1ll * r * r) {
                R to(pt[v - 1].x + dx, pt[v - 1].y + dy);

                if (pt2.find(to) != pt2.end()) {
                    int toi = pt2[to];

                    if (res[toi - 1])
                        continue;

                    dfs2(toi);
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        cin >> pt[i].x >> pt[i].y;
        pt2[pt[i]] = i + 1;
    }

    for (int i = 1; i <= n; ++i) {
        if (d[i] != 0)
            continue;

        d[i] = 1;
        if (dfs(i, -1)) {
            dfs2(i);
        }
    }

    for (int i = 0; i < n; ++i)
        cout << res[i];
    cout << '\n';
}
