// Created by rost on 29.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;

class Segtree {
private:
    struct Vertex {
        int sum;

        Vertex() : sum(0) {
        }

        Vertex(int _sum) : sum(_sum) {
        }
    };

    Vertex merge(const Vertex &a, const Vertex &b) {
        return {a.sum + b.sum};
    }

    const int N;
    vector<Vertex> tree;

    void tree_upd(int v, int tl, int tr, int qp) {
        if (tl + 1 == tr) {
            tree[v].sum = 1;
            return;
        }

        int tm = (tl + tr) / 2;
        if (qp < tm) {
            tree_upd(2 * v + 1, tl, tm, qp);
        } else {
            tree_upd(2 * v + 2, tm, tr, qp);
        }
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    Vertex tree_get(int v, int tl, int tr, int ql, int qr) {
        if (qr <= tl || tr <= ql) return {};
        if (ql <= tl && tr <= qr) return tree[v];

        int tm = (tl + tr) / 2;
        return merge(tree_get(2 * v + 1, tl, tm, ql, qr),
                     tree_get(2 * v + 2, tm, tr, ql, qr));
    }

public:
    Segtree(int n) : N(n), tree(4 * N) {
    }

    void upd(int pos) {
        tree_upd(0, 0, N, pos);
    }

    int get(int l, int r) {
        return tree_get(0, 0, N, l, r).sum;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int r, c;
    cin >> r >> c;
    vector<vector<int> > a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    ll res = INF;
    for (int mask = 0; mask < (1 << (r + c - 1)); ++mask) {
        // cerr << '\n' << mask << " ";
        ll cnt = 0;
        Segtree st(r * c + 1);

        int colD = 0, rowD = 0;
        for (int i = 0; i < (r + c - 1); ++i) {
            if (mask & (1 << i)) {
                for (int j = rowD; j < r; ++j) {
                    // cerr << a[j][colD] << ' ';
                    cnt += st.get(a[j][colD], r * c + 1);
                    st.upd(a[j][colD]);
                }
                ++colD;
                if (colD == c)
                    break;
            } else {
                for (int j = colD; j < c; ++j) {
                    // cerr << a[rowD][j] << ' ';
                    cnt += st.get(a[rowD][j], r * c + 1);
                    st.upd(a[rowD][j]);
                }
                ++rowD;
                if (rowD == r)
                    break;
            }
        }
        // cerr << cnt;
        res = min(re    s, cnt);
    }
    cout << res << '\n';
}
