#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector <int> g[100'001];

ll dist2(pair <ll, ll> a, pair <ll, ll> b) {
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

bitset <100'001> cycle;
bitset <100'001> color;
bitset <100'001> used;
bool has_cycle = false;

vector <int> path;
void dfs(int v, int c) {
    used[v] = 1;
    path.push_back(v);
    color[v] = c;
    for (auto u : g[v])
        if (color[u] == color[v]) {
            has_cycle = true;
        } else if (!used[u]) {
            dfs(u, c & 1);
        }
}

const int inf = 1e9;
int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    ll n, r;
    cin >> n >> r;
    map <pair <int, int>, vector <int>> mp;
    pair <int, int> o = {inf, inf};
    vector <pair <int, int>> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
        o.first = min(o.first, x);
        o.second = min(o.second, x);
    }
    for (auto &[x, y] : a) {
        x -= o.first;
        y -= o.second;
    }

    for (int i = 0; i < n; i++) {
        mp[{a[i].first / r, a[i].second / r}].push_back(i);
    }


    vector <int> diff = {1, -1, 0};
    for (int i = 0; i < n; i++) {
        int x = a[i].first / r, y = a[i].second / r;
        for (int dx : diff) {
            for (int dy : diff) {
                if (!mp.contains({x + dx, y + dy})) continue;
                for (auto& j : mp[{x + dx, y + dy}]) {
                    if (dist2(a[i], a[j]) <= r * r && j != i) {
                        g[i].push_back(j);
                    }
                } //
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            has_cycle = false;
            path.clear();
            dfs(i, 1);
            for (auto v : path)
                cycle[v] = has_cycle;
        }
    }
    for (int i = 0; i < n; i++)
        if (cycle[i])
            cout << 1;
        else
            cout << 0;
}