#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct segtree {
    vector <int> t;

    void upd(int p, int l, int r, int pos) {
        if (r - l == 1) {
            t[p]++;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m)
            upd(2 * p, l, m, pos);
        else
            upd(2 * p + 1, m, r, pos);
        t[p] = t[2 * p] + t[2 * p + 1];
    }

    int get(int p, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq)
            return 0;
        if (lq <= l && r <= rq)
            return t[p];
        int m = (l + r) / 2;
        return get(2 * p, l, m, lq, rq) + get(2 * p + 1, m, r, lq, rq);
    }
};


int r, c;
int calc(vector <vector <int>>& a, vector <int>& p) {
    vector <int> b;
    vector <vector <bool>> used(r, vector <bool> (c));
    int k = 0, l = 0;
    for (auto t : p) {
        if (t == 0) {
            for (int j = 0; j < c; j++)
                if (!used[k][j]) {
                    b.push_back(a[k][j]);
                    used[k][j] = true;
                }
            k++;
        } else {
            for (int j = 0; j < r; j++)
                if (!used[j][l]) {
                    b.push_back(a[j][l]);
                    used[j][l] = true;
                }
            l++;
        }
    }
    segtree st;
    st.t.resize(4 * r * c);
    int ans = 0;
    for (int i = b.size() - 1; i >= 0; i--) {
        ans += st.get(1, 0, r * c, 0, b[i]);
        st.upd(1, 0, r * c, b[i]);
    }
    return ans;
}
mt19937 rnd(52);
ll gen() {
    uniform_int_distribution<int> d;
    return d(rnd);
}


int main() {
    cin >> r >> c;
    vector <vector <int>> a(r, vector <int> (c));
    for (auto &v : a)
        for (auto &e : v) {
            cin >> e;
            e--;
        }
    vector <int> p;
    for (int i = 0; i < r; i++)
        p.push_back(0);
    for (int i = 0; i < c; i++)
        p.push_back(1);
    long double t = 3, rate = 0.99999;
    random_shuffle(p.begin(), p.end());
    int best = calc(a, p);
    int ans = calc(a, p);
    vector <int> rows, lines;
    for (int i = 0; i < p.size(); i++)
        if (p[i])
            rows.push_back(i);
        else
            lines.push_back(i);
    for (int iter = 0; iter < 100000; iter++) {
        int i = rand() % rows.size();
        int j = rand() % lines.size();
        auto d = p;
        swap(d[lines[j]], d[rows[i]]);
        int nans = calc(a, d);
        if (nans < ans || ((long double)rand() / RAND_MAX) < exp((long double)(ans - nans) / t)) {
            ans = nans;
            best = min(best, nans);
            swap(rows[i], lines[j]);
            p = d;
        }
        t *= rate;
    }
    cout << best;
}