#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct Fenwick {
    vector <int> t;

    int f(int x) {
        return x & (x - 1);
    }
    int g(int x) {
        return x | (x - 1);
    }

    int sum(int x) {
        ll ans = 0;
        for (int i = x; i > 0; i = f(x) - 1)
            ans += t[i];
        return ans;
    }

    void upd(int x) {
        ll ans = 0;
        for (int i = x; i <= t.size(); i = g(i) + 1)
            t[i]++;
    }
};



int r, c;
int calc(vector <vector <int>>& a, vector <int>& p) {
    vector <int> b;
    vector <vector <bool>> used(r, vector <bool> (c));
    int k = 0, l = 0;
    for (auto t : p) {
        if (t == 0) {
            for (int j = 0; j < c; j++)
                if (!used[k][j]) {
                    b.push_back(a[k][j]);
                    used[k][j] = true;
                }
            k++;
        } else {
            for (int j = 0; j < r; j++)
                if (!used[j][l]) {
                    b.push_back(a[j][l]);
                    used[j][l] = true;
                }
            l++;
        }
    }
    Fenwick st;
    st.t.resize(r * c + 1);
    int ans = 0;
    for (int i = b.size() - 1; i >= 0; i--) {
        ans += st.sum(b[i]);
        st.upd(b[i]);
    }
    return ans;
}
mt19937 rnd(52);
ll gen() {
    uniform_int_distribution<int> d;
    return d(rnd);
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> r >> c;
    vector <vector <int>> a(r, vector <int> (c));
    for (auto &v : a)
        for (auto &e : v) {
            cin >> e;
            e--;
        }
    vector <int> p;
    for (int i = 0; i < r; i++)
        p.push_back(0);
    for (int i = 0; i < c; i++)
        p.push_back(1);
    long double t = 1000, rate = 0.99999;
    random_shuffle(p.begin(), p.end());
    int best = calc(a, p);
    int ans = calc(a, p);
    vector <int> rows, lines;
    for (int i = 0; i < p.size(); i++)
        if (p[i])
            rows.push_back(i);
        else
            lines.push_back(i);
    for (int iter = 0; iter < 65000; iter++) {
        int i = rand() % rows.size();
        int j = rand() % lines.size();
        auto d = p;
        swap(d[lines[j]], d[rows[i]]);
        int nans = calc(a, d);
        if (nans < ans || ((long double)rand() / RAND_MAX) < exp((long double)(ans - nans) / t)) {
            ans = nans;
            best = min(best, nans);
            swap(rows[i], lines[j]);
            p = d;
        }
        t *= rate;
    }
    cout << best;
}