#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct segtree {
    vector <int> t;

    void upd(int p, int l, int r, int pos) {
        if (r - l == 1) {
            t[p]++;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m)
            upd(2 * p, l, m, pos);
        else
            upd(2 * p + 1, m, r, pos);
        t[p] = t[2 * p] + t[2 * p + 1];
    }

    int get(int p, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq)
            return 0;
        if (lq <= l && r <= rq)
            return t[p];
        int m = (l + r) / 2;
        return get(2 * p, l, m, lq, rq) + get(2 * p + 1, m, r, lq, rq);
    }
};

const int inf = 1e9;

int main() {
    int n, q;
    cin >> n >> q;
    vector <int> a(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    vector <int> p(n + 2), s(n + 2);
    for (int i = 1; i <= n; i++)
        p[i] = max(p[i - 1], a[i]);
    for (int i = n; i > 0; i--)
        s[i] = max(s[i + 1], a[i]);

    vector <int> r(n + 1);
    vector <int> st = {0};
    a[0] = inf;
    for (int i = n; i > 0; i--) {
        while (a[st.back()] < a[i])
            st.pop_back();
        r[i] = st.back();
    }

    vector <int> ans = {inf, inf, inf};
    for (int i = 1; i <= n - 2; i++) {
        vector <int> nans;
        nans.push_back(p[i]);
        nans.push_back(a[i + 1]);
        if (r[i + 1] == 0) {
            nans.push_back(a[n]);
        } else {
            nans.push_back(s[r[i + 1]]);
        }
        ans = min(nans, ans);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        i--;
        cout << ans[i] << '\n';
    }
}