using ll= long long;
using namespace std;
#include <vector>
#include <random>
#include <iostream>
mt19937 rnd(179);
struct node {
    ll x, y;
    ll sz;
    node *left, *right;
    node(ll val) : x(val), y(rnd()), sz(1), left(nullptr), right(nullptr) {}
};
ll get_size(node *root) {
    if (!root)
        return 0;
    return root->sz;
}
void upd(node *root) {
    if (!root)
        return;
    root->sz = 1 + get_size(root->left) + get_size(root->right);
}
node* merge(node* root1, node* root2) {
    if (!root1)
        return root2;
    if (!root2)
        return root1;
    if (root1->y > root2->y) {
        root1->right = merge(root1->right, root2);
        upd(root1);
        return root1;
    } else {
        root2->left = merge(root1, root2->left);
        upd(root2);
        return root2;
    }
}
pair <node*, node*> split(node* root, ll val) {
    if (!root)
        return {nullptr, nullptr};
    if (root->x > val) {
        auto [root1, root2] = split(root->left, val);
        root->left = root2;
        upd(root);
        return {root1, root};
    } else {
        auto [root1, root2] = split(root->right, val);
        root->right = root1;
        upd(root);
        return {root, root2};
    }
}
pair <node*, ll> insert(node* root, ll x) {
    auto [root1, root3] = split(root, x);
    ll res = get_size(root1);
    node* root2 = new node(x);
    return {merge(root1, merge(root2, root3)), res};
}
int main() {
    ll n, m;
    cin >> n >> m;
    vector <vector <ll>> a(n, vector <ll> (m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector <vector <ll>> r(n, vector <ll> (m, 0)), c(n, vector <ll> (m, 0));
    node *root = nullptr;
    for (ll i = 0; i < n; ++i) {
        root = nullptr;
        for (ll j = m - 1; j >= 0; --j) {
            for (ll k = n - 1; k >= i; --k) {
                auto p = insert(root, a[k][j]);
                root = p.first;
                c[i][j] += p.second;
            }
        }
    }
    for (ll j = 0; j < m; ++j) {
        root = nullptr;
        for (ll i = n - 1; i >= 0; --i) {
            for (ll k = m - 1; k >= j; --k) {
                auto p = insert(root, a[i][k]);
                root = p.first;
                r[i][j] += p.second;
            }
        }
    }
    vector <vector <ll>> dp(n + 1, vector <ll> (m + 1, 0));
    for (ll i = 0; i < n + 1; ++i) {
        for (ll j = 0; j < m + 1; ++j) {
            if ((i == 0 && j == 0) || (i == n) && (j == m))
                continue;
            if (i == 0 || j == m) {
                dp[i][j] = dp[i][j - 1] + c[i][j - 1];
            } else if (j == 0 || i == n) {
                dp[i][j] = dp[i - 1][j] + r[i - 1][j];
            } else {
                dp[i][j] = min(dp[i][j - 1] + c[i][j - 1], dp[i - 1][j] + r[i - 1][j]);
            }
        }
    }
    ll ans = (n * m) * (n * m);
    for (ll i = 0; i < n; ++i) {
        ans = min(ans, dp[i][m]);
    }
    for (ll i = 0; i < m; ++i) {
        ans = min(ans, dp[n][i]);
    }
    cout << ans;
}

