#include<iostream>
//#include<bits/stdc++.h>
#include<fstream>
#include<string>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<random>
#include<iomanip>

using namespace std;

#define ll long long

const int INF = 1e9 + 7;


vector<vector<int>> graph = {};
vector<bool> good = {}, used = {}, col = {}; 
vector<int> comp = {};


struct pnt {
    int x, y, num;
    pnt(int x1 = 0, int y1 = 0, int num1 = 0) {
        x = x1;
        y = y1;
        num = num1;
    }
};


ll dist(pnt p1, pnt p2) {
    ll dx = p1.x - p2.x;
    ll dy = p1.y - p2.y;
    return dx*dx + dy*dy;
}

bool dfs(int v) {
    used[v] = true;
    comp.push_back(v);
    bool ret = false;
    for (int u : graph[v]) {
        if (good[u]) {
            ret = true; continue;
        }
        if (used[u] && col[u] == col[v]) {
            ret = true; 
        } else if (!used[u]) {
            col[u] = !col[v];
            if (dfs(u)) ret = true;
        }
    }
    return ret;
}

int solve(int cnt_test) {
    int n;
    ll r;
    cin >> n >> r;
    map<pair<int, int>, vector<int>> m = {};
    set<pair<int, int>> s = {};
    vector<pnt> v(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        v[i] = pnt(x, y, i);
        m[{x / r, y / r}].push_back(i);
        s.insert({x / r, y / r});
    }

    for (pair<int, int> p : s) {
        random_shuffle(m[p].begin(), m[p].end());
    }

    good.assign(n, false);
    graph.assign(n, {});

    for (int i = 0; i < n; i++) {
        for (int j = -1; j <= 1; j++) {
            for (int k = -1; k <= 1; k++) {
                pair<int, int> p = {v[i].x / r + j, v[i].y / r + k};
                if (m.find(p) == m.end()) continue;
                vector<int> &qd = m[p];
                for (int l : qd) {
                    if (l == i) continue;
                    if (dist(v[l], v[i]) <= r * r) {
                        graph[i].push_back(l);
                        if (graph[i].size() >= 6) {
                            good[i] = true;
                            break;
                        }
                    }
                }
                if (good[i]) break;
            }
            if (good[i]) break;
        }
    }
    used.assign(n, false);
    col.assign(n, false);
    for (int i = 0; i < n; i++) {
        comp = {};
        if (!used[i] && dfs(i)) {
            for (int j : comp) {
                good[j] = true;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (good[i]) cout << '1';
        else cout << '0';
    }

    return 0;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int cnt = 0;
    while(!cin.eof()) {
        solve(cnt++);
    }
#else
    solve(0);
#endif
}