#include<iostream>
//#include<bits/stdc++.h>
#include<fstream>
#include<string>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<random>
#include<iomanip>

using namespace std;

#define ll long long

const int INF = 1e9 + 7;

vector<vector<int>> v = {};

struct Node {
    Node *l = nullptr, *r = nullptr;
    int k = 0;
};


struct seg_tree {
    int n = 0;
    vector<Node*> rts = {new Node()};
    seg_tree(int n1) {
        n = n1;
    }
    Node* update(int x, Node *v, int l, int r) {
        if (r == -1) r = n;
        if (r <= x || l > x) return nullptr;
        Node* ret = new Node();
        ret->k = v->k + 1;
        if (r - l == 1) return ret;
        int m = (l + r) / 2;
        if (v->l == nullptr) v->l = new Node();
        if (v->r == nullptr) v->r = new Node();
        if (x < m) {
            ret->r = v->r;
            ret->l = update(x, v->l, l, m);
        } else {
            ret->l = v->l;
            ret->r = update(x, v->r, m, r);
        }
        return ret;
    }
    void update(int x, int num) {
        rts.push_back(update(x, rts[num], 0, n));
    }
    void update(int x, Node* r) {
        rts.push_back(update(x, r, 0, n));
    }

    int get_sum(int L, int R, Node *v, int l = 0, int r = -1) {
        if (r == -1) r = n;
        if (r <= L || l >= R) return 0;
        if (l >= L && r <= R) return v->k;
        int m = (l + r) / 2;
        if (v->l == nullptr) v->l = new Node();
        if (v->r == nullptr) v->r = new Node();
        return get_sum(L, R, v->l, l, m) + get_sum(L, R, v->r, m, r);
    }
    int get_sum(int l, int r, int num) {
        return get_sum(l, r, rts[num], 0, n);
    }
};


int solve(int cnt_test) {
    int n, m;
    cin >> n >> m;
    v.assign(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
            v[i][j]--;
        }
    }
    seg_tree st(n * m);
    vector<vector<Node*>> st_dp(n + 1, vector<Node*>(m + 1, st.rts[0]));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            Node* r = st_dp[i][j + 1];
            for (int k = i; k < n; k++) {
                st.update(v[k][j], r);
                r = st.rts.back();
            }
            st_dp[i][j] = r;
        }
    }
    vector<seg_tree> st_A(n, seg_tree(n * m));
    for (int i = 0; i < n; i++) {
        for (int j = m - 1; j >= 0; j--) {
            st_A[i].update(v[i][j], m - j - 1);
        }
    }

    vector<vector<int>> inv_r(n + 1, vector<int>(m + 1, 0));
    for (int i = 0; i < n; i++) {
        seg_tree st_inv(n * m);
        for (int j = m - 1; j >= 0; j--) {
            inv_r[i][j] = inv_r[i][j + 1] + st_inv.get_sum(0, v[i][j], m - 1 - j);
            st_inv.update(v[i][j], m - 1 - j);
        }
    }
    vector<vector<int>> inv_d(n + 1, vector<int>(m + 1, 0));
    for (int j = 0; j < m; j++) {
        seg_tree st_inv(n * m);
        for (int i = n - 1; i >= 0; i--) {
            inv_d[i][j] = inv_d[i + 1][j] + st_inv.get_sum(0, v[i][j], n - 1 - i);
            st_inv.update(v[i][j], n - 1 - i);
        }
    }
    

    vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));
    vector<vector<int>> right(n + 1, vector<int>(m + 1, 0));
    vector<vector<int>> down(n + 1, vector<int>(m + 1, 0));
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            right[i][j] = right[i + 1][j];
            right[i][j] += st.get_sum(0, v[i][j], st_dp[i][j + 1]);
            /*for (int k = i; k < n; k++) {
                for (int l = j + 1; l < m; l++) {
                    right[i][j] += (v[i][j] > v[k][l]);
                }
            }*/
            down[i][j] = down[i][j + 1];
            down[i][j] += st.get_sum(0, v[i][j], st_dp[i + 1][j]);
            /*for (int k = i + 1; k < n; k++) {
                for (int l = j; l < m; l++) {
                    down[i][j] += (v[i][j] > v[k][l]);
                }
            }*/
            int A = 0;
            /*for (int k = i + 1; k < n; k++) {
                for (int l = j + 1; l < m; l++) {
                    A += (v[k][j] > v[i][l]);
                }
            }*/
            for (int k = i + 1; k < n; k++) {
                A += st_A[i].get_sum(0, v[k][j], m - j - 1);
            }
            right[i][j] += A;
            down[i][j] += (n - i - 1) * (m - j - 1) - A;
            int inv1 = 0, inv2 = 0;
            /*for (int k = i; k < n; k++) {
                for (int l = k + 1; l < n; l++) {
                    inv1 += (v[k][j] > v[l][j]);
                }
            }
            for (int k = j; k < m; k++) {
                for (int l = k + 1; l < m; l++) {
                    inv2 += (v[i][k] > v[i][l]);
                }
            }*/
           inv1 = inv_d[i][j]; inv2 = inv_r[i][j];
            dp[i][j] = min(dp[i + 1][j] + down[i][j] + inv2, dp[i][j + 1] + right[i][j] + inv1);
        }
    }
    cout << dp[0][0] << '\n';


    return 0;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int cnt = 0;
    while(!cin.eof()) {
        solve(cnt++);
    }
#else
    solve(0);
#endif
}