#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, r;
vector<vector<ll> > graph;
vector<ll> visited, time_in;

vector<ll> cur_comp;

bool dfs(ll cur, ll cur_time) {
    visited[cur] = 1;
    time_in[cur] = cur_time % 2;
    cur_comp.push_back(cur);

    bool result = false;

    for (ll i: graph[cur]) {
        if (visited[i] == 0) {
            if (dfs(i, cur_time + 1)) {
                result = true;
            }
        }
        if (visited[i] == 1) {
            if ((cur_time + 1 - time_in[i]) % 2 == 1) {
                result = true;
            }
        }
    }

    visited[cur] = 2;
    return result;
}

void solve() {
    cin >> n >> r;
    vector<pair<ll, ll> > cords;
    unordered_map<pair<ll, ll>, ll> cords2idx;
    for (ll i = 0; i < n; i++) {
        ll t1, t2;
        cin >> t1 >> t2;
        cords.push_back({t1, t2});
        cords2idx[{t1, t2}] = i;
    }

    graph.assign(n, {});
    for (ll i = 0; i < n; i++) {
        auto cur_cords = cords[i];
        for (ll shift_x = -r; shift_x <= r; shift_x++) {
            for (ll shift_y = -r; shift_y <= r; shift_y++) {
                ll new_cords_x = shift_x + cur_cords.first;
                ll new_cords_y = shift_y + cur_cords.second;

                __int128 dist_1 = shift_x;
                dist_1 *= dist_1;
                __int128 dist_2 = shift_y;
                dist_2 *= dist_2;
                __int128 dist_3 = dist_1 + dist_2;
                __int128 dist_4 = r;
                dist_4 *= dist_4;

                if (dist_3 == 0) {
                    continue;
                }

                if (dist_3 > dist_4) {
                    continue;
                }

                if (cords2idx.find({cur_cords.first + shift_x, cur_cords.second + shift_y}) != cords2idx.end()) {
                    graph[i].push_back(cords2idx[{cur_cords.first + shift_x, cur_cords.second + shift_y}]);
                }
            }
        }
    }


    visited.assign(n, 0);
    time_in.assign(n, 0);
    vector<ll> ans(n, 0);
    for (ll i = 0; i < n; i++) {
        if (visited[i] == 0) {
            cur_comp.clear();
            if (dfs(i, 0)) {
                for (ll q: cur_comp) {
                    ans[q] = 1;
                }
            }
        }
    }

    for (auto c: ans) {
        cout << c;
    }
}


signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    ll tt;
    cin >> tt;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt = 1;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
}
