#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;


ll n, r;
vector<vector<int> > graph;
vector<ll> visited, time_in;

vector<ll> cur_comp;

bool dfs(ll cur, ll cur_time) {
    visited[cur] = 1;
    time_in[cur] = cur_time % 2;
    cur_comp.push_back(cur);

    bool result = false;

    for (ll i: graph[cur]) {
        if (visited[i] == 0) {
            if (dfs(i, cur_time + 1)) {
                result = true;
            }
        }
        if (visited[i] == 1) {
            if ((cur_time + 1 - time_in[i]) % 2 == 1) {
                result = true;
            }
        }
    }

    visited[cur] = 2;
    return result;
}

void solve() {
    cin >> n >> r;
    vector<pair<ll, ll> > cords;
    unordered_map<string, ll> cords2idx;
    for (ll i = 0; i < n; i++) {
        ll t1, t2;
        cin >> t1 >> t2;
        cords.push_back({t1, t2});
        cords2idx[to_string(t1) + " " + to_string(t2)] = i;
    }

    graph.assign(n, {});
    for (ll i = 0; i < n; i++) {
        auto cur_cords = cords[i];
        for (ll shift_x = -r; shift_x <= r; shift_x++) {
            ll pos_shift_y = r * r - shift_x * shift_x;
            pos_shift_y = (ll) sqrt(pos_shift_y);

            for (ll shift_y = -pos_shift_y; shift_y <= pos_shift_y; shift_y++) {
                if (shift_x == 0 && shift_y == 0) continue;
                string map_key = to_string(cur_cords.first + shift_x) + " " + to_string(cur_cords.second + shift_y);
                if (cords2idx.find(map_key) != cords2idx.end()) {
                    graph[i].push_back(cords2idx[map_key]);
                }
            }
        }
    }


    visited.assign(n, 0);
    time_in.assign(n, 0);
    vector<ll> ans(n, 0);
    for (ll i = 0; i < n; i++) {
        if (visited[i] == 0) {
            cur_comp.clear();
            if (dfs(i, 0)) {
                for (ll q: cur_comp) {
                    ans[q] = 1;
                }
            }
        }
    }

    for (auto c: ans) {
        cout << c;
    }
}


signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    ll tt;
    cin >> tt;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt = 1;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
}
