#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
template<typename T, typename K>
void _print(pair<T, K> a) {cerr << "{" << a.first << ", " << a.second << "}";}
template<typename T>
void _print(T a) {cerr << a;}
template<typename T>
void _print(vector<T> a) {
    cerr << "[";
    int f = 0;
    for (auto v : a) {
        if (f++)cerr << ", ";
        _print(v);
    }
    cerr << "]";
}
#ifdef LOCAL
#define debug(x) cerr << (#x) << ": "; _print(x); cerr << '\n'
#else
#define debug(x)
#endif

struct ftree {
    vector<int> tree;
    int n;
    void init(int nn) {
        tree.assign(nn, 0);
        n = nn;
    }
    void inc(int i, int val) {
        for (; i < n; i = (i | (i + 1))) {
            tree[i] += val;
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans += tree[r];
        }
        return ans;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n * m);
    for (auto &v : a)cin >> v;
    ll sum = 0;
    ftree f;
    f.init(m + 1);
    for (int i = 0; i < m; ++i) {
        sum += f.get(a[i] + 1, m);
        f.inc(a[i], 1);
    }
    cout << sum;
}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    solve();
}