#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <random>
#include <cmath>
#include <cassert>
#include <algorithm>

using namespace std;
#define int long long
using ll = long long;
using ld = long double;

#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

vector<pair<int, int>> pts;
int n, r;
vector<vector<int>> g;
vector<int> used;

bool can(int a, int b) {
    ld c1 = pts[a].first - pts[b].first, c2 = pts[a].second - pts[b].second;
    return hypot(c1, c2) <= (ld) r;
}
int comp = 1;

void dfs(int v) {
    used[v] = comp;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> r;
    pts = vector<pair<int, int>> (n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].first >> pts[i].second;
    }
    g = vector<vector<int>> (n * 2);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (!can(i, j)) continue;
            g[i].push_back(j + n);
            g[j + n].push_back(i);
            g[i + n].push_back(j);
            g[j].push_back(i + n);
        }
    }
    used = vector<int> (n * 2);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            comp++;
        }
    }
    for (int i = 0; i < n; i++) {
        int ans = (used[i] == used[i + n]);
        cout << ans;
    }
}