#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <random>
#include <cmath>
#include <cassert>
#include <algorithm>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;

#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

vector<pair<int, int>> pts;
int n, r;
int used[20001];
int g[20001][20001];

bool can(int a, int b) {
    ld c1 = pts[a].first - pts[b].first, c2 = pts[a].second - pts[b].second;
    return hypot(c1, c2) <= (ld) r;
}
int comp = 1;

void dfs(int v) {
    dbg(v, comp);
    used[v] = comp;
    for (int u = 0; u < n * 2; u++) {
        if (!used[u] && g[v][u] || g[u][v]) {
            dfs(u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> r;
    pts = vector<pair<int, int>> (n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].first >> pts[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            g[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        used[i] = 0;
        for (int j = i + 1; j < n; j++) {
            if (can(i, j)) {
                g[i][j + n] = 1;
                g[i + n][j] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            comp++;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << (used[i] == used[i + n] ? "1" : "0");
    }
    dbg(clock() * 1000 / CLOCKS_PER_SEC);

}