#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <random>
#include <cmath>
#include <cassert>
#include <algorithm>
 
using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
 
#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...)
#endif

vector<int> a;
vector<pair<int, int>> tree;
int n, q;
const int INF = 1e9;

void build(int v = 1, int l = 0, int r = n) {
    if (r - l == 1) {
        tree[v] = {a[l], l};
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

pair<int, int> get(int ql, int qr, int v = 1, int l = 0, int r = n) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return {-INF, INF};
    }
    int mid = (l + r) / 2;
    pair<int, int> left = get(ql, qr, v * 2, l, mid);
    pair<int, int> right = get(ql, qr, v * 2 + 1, mid, r);
    return max(left, right);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> q;
    a = vector<int> (n);
    tree = vector<pair<int, int>> (n * 4);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build();
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        if (ind == 1) {
            cout << a[0] << '\n';
        } else {
            int l = 1, r = n - 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (get(0, mid).first <= a[0]) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            cout << get(l, n).first << '\n';
        }
    }
}