#include<bits/stdc++.h>

using namespace std;

using ll = long long;
ll INF = 1e14;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

struct SegmentTree {
    vector<ll> t;
    vector<ll> a;

    SegmentTree(ll n) {
        t.resize(2 * n);
    }

    void build(ll v, ll l, ll r) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        ll m = (r + l) / 2;
        build(lv(v), l, m);
        build(rv(v), m, r);
        t[v] = max(t[lv(v)], t[rv(v)]);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql >= r || qr <= l) return 0;
        if (ql <= l && r <= qr) return t[v];
        ll m = (r + l) / 2;
        return get(lv(v), l, m, ql, qr) + get(rv(v), m, r, ql, qr);
    }

    void update(ll v, ll l, ll r, ll i, ll x) {
        if (r - l == 1) {
            t[v] += x;
            return;
        }
        ll m = (r + l) / 2;
        if (i < m) {
            update(lv(v), l, m, i, x);
        } else {
            update(rv(v), m, r, i, x);
        }
        t[v] = t[lv(v)] + t[rv(v)];
    }
};

void viperr() {
    ll r, c;
    cin >> r >> c;
    vector<ll> a;
    for (ll i = 0; i < c; i++) {
        ll d;
        cin >> d;
        a.push_back(d);
    }
    ll ans = 0;
    ll n = a.size();
    SegmentTree tree(n);
    for (ll i = 0; i < n; i++) {
        ans += tree.get(0, 0, n, a[i], n);
        tree.update(0, 0, n, a[i] - 1, 1);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll ttt1 = 1;
    while (ttt1--) {
        viperr();
        cout << '\n';
    }
    return 0;
}
