#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct seg {
    ll N;
    vector<ll> t;
    void create(ll n) {
        N = 1LL << (ll)ceil(log2(n));
        t.resize(2 * N);
    }
    ll get(ll l, ll r, ll lb, ll rb, ll ind) {
        if (lb > r || rb < l) return 0;
        if (lb >=l && rb <= r) return t[ind];
        ll mid = (lb + rb) >> 1;
        return get(l, r, lb, mid, ind * 2 + 1) + get(l, r, mid + 1, rb, ind * 2 + 2);
    }
    void se(ll pos, ll lb, ll rb, ll ind) {
        if (lb > pos || rb < pos) return;
        if (lb == rb) {
            t[ind] = 1;
            return;
        }
        ll mid = (lb + rb) >> 1;
        se(pos, lb, mid, ind * 2 + 1);
        se(pos, mid + 1, rb, ind * 2 + 2);
        t[ind] = t[ind * 2 + 1] + t[ind * 2 + 2];
    }
};

//mt19937 mt(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937 mt(1234);
uniform_real_distribution<ld> dr(0.0, 1.0);
ld ran() {
    return dr(mt);
}
vector<vector<ll>> v;
ll r,c;
ll n;

ll getval(vector<ll> &p) {
    vector<ll> b(n);
    ll ind = 0;
    ll ti = 0, tj = 0;
    for (ll i = 0; i < p.size(); ++i) {
        if (p[i] == 1) {
            for (ll j = tj; j < c; ++j) {
                b[ind++]=v[ti][j];
            }
            ++ti;
            if (ind >= n) break;
        }
        else {
            for (ll j = ti; j < r; ++j) {
                b[ind++] = v[j][tj];
            }
            ++tj;
            if (ind >= n) break;
        }
    }
    ll cnt = 0;
    seg st;
    st.create(n + 1);
    for (ll i = 0; i < b.size(); ++i) {
        cnt += st.get(b[i] + 1, st.N - 1, 0, st.N - 1, 0);
        st.se(b[i], 0, st.N - 1, 0);
    }
    return cnt;
}

vector<ll> simulate() {
    ld t = 10000;
    ld finish = 1e-3;
    ld kf = 0.995;
    uniform_int_distribution<int> dist(0, r + c - 1);
    vector<ll> p(r + c);
    for (ll i = 0; i < r; ++i)
        p[i] = 1;
    shuffle(p.begin(), p.end(), mt);
    ll ans = getval(p);
    ll coun = 0;
    while (true) {
        ++coun;
        if (coun >= 1000) {
            coun = 0;
            if (clock() >= 900) {
                return p;
            }
        }
        ll pos1 = -1, pos2 = -1;
        while (pos1 == -1 || p[pos1] == 0) {
            pos1 = dist(mt);
        }
        while (pos2 == -1 || p[pos2] == 1) {
            pos2 = dist(mt);
        }
        swap(p[pos1], p[pos2]);
        ll nans = getval(p);
        ll delta = nans - ans;
        if (delta < 0 || ran() < exp(-delta / t)) {
            ans = nans;
        } else {
            swap(p[pos1], p[pos2]);
        }
         t *= kf;
    }
    return p;
}

void solve() {
    cin>>r>>c;
    n = r * c;
    v.resize(r, vector<ll>(c));
    for (ll i = 0; i < r; ++i) {
        for (ll j = 0 ; j < c; ++j) {
            cin>>v[i][j];
        }
    }
    vector<ll> ans = simulate();
    cout << getval(ans) << endl;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
    return 0;
}