#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define vll vector<ll>
#define all(x) x.begin(), x.end()
#define speed ios::sync_with_stdio(false), cin.tie(nullptr);
#define pb push_back
#define ff first
#define ss second

const ll maxN = 1e5 + 1;
vll g[maxN];
pair<ll, ll> it[maxN];
bool marked[maxN];
ll colored[maxN];

// colors - 1, 2
void dfs1(ll curr, ll color, bool& found) {
    colored[curr] = color;

    for (auto next : g[curr]) {
        if (colored[next] != 0) {
            if (colored[next] == color) {
                found = true;
                return;
            }
            continue;
        }

        dfs1(next, (color + 1) % 2, found);
    }
}

void dfs2(ll curr, vector<bool>& visited) {
    visited[curr] = true;
    marked[curr] = true;
    for (auto next : g[curr]) {
        if (!visited[next]) {
            dfs2(next, visited);
        }
    }
}

void draw(ll curr, ll n) {
    vector<bool> visited(n, false);

    dfs2(curr, visited);
}

int main() {

    speed

    ll n, r; cin >> n >> r;

    map<ll, unordered_map<ll, ll>> meet;

    for (int i = 1; i <= n; i++) {
        cin >> it[i].ff >> it[i].ss;
        meet[it[i].ff][it[i].ss] = i;
    }


    if (r <= 10) {
        for (int i = 1; i <= n; i++) {
            for (int dx = -2; dx <= 2; dx++) {
                for (int dy = -2; dy <= 2; dy++) {
                    if ((dx * dx + dy * dy) > r * r) {
                        continue;
                    }
                    if (!meet.count(it[i].ff - dx)) {
                        continue;
                    }
                    ll ind = meet[it[i].ff - dx][it[i].ss - dy];
                    if (ind != 0 && ind != i) {
                        g[i].pb(ind);
                    }
                }
            }
        }
    } else {
        for (int i = 1; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                ll dist = (it[i].ff - it[j].ff) * (it[i].ff - it[j].ff) + (it[i].ss - it[j].ss) * (it[i].ss - it[j].ss);

                if (dist <= r * r) {
                    g[i].pb(j);
                    g[j].pb(i);
                }
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        bool found = false;
        if (colored[i] == 0) {
            dfs1(i, 0, found);
        }
        if (found) {
            draw(i, n);
        }
    }

    for (int i = 1; i <= n; i++) {
        if (marked[i]) cout << '1';
        else cout << '0';
    }

    return 0;
}