#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define vll vector<ll>
#define all(x) x.begin(), x.end()
#define speed ios::sync_with_stdio(false), cin.tie(nullptr);
#define pb push_back
#define ff first
#define ss second

const ll maxN = 1e5 + 1;

vll g[maxN];


// colors - 1, 2
void dfs1(ll curr, vll& colored, ll color, bool& found) {
    colored[curr] = color;

    for (auto next : g[curr]) {
        if (colored[next] != -1) {
            if (colored[next] == color) {
                found = true;
                return;
            }
            continue;
        }

        dfs1(next, colored, (color + 1) % 2, found);
    }
}

void dfs2(ll curr, vector<bool>& visited, vector<bool>& marked) {
    visited[curr] = true;
    marked[curr] = true;
    for (auto next : g[curr]) {
        if (!visited[next]) {
            dfs2(next, visited, marked);
        }
    }
}

void draw(vector<bool>& marked, vector<bool>& visited, ll curr, ll n) {
    dfs2(curr, visited, marked);
}

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    return a.ff < b.ff;
}

int main() {

    unordered_map<ll, ll> count;

    speed

    ll n, r, cz = 0; cin >> n >> r;

    vector<pair<ll, ll>> it(n + 1);
    vector<bool> marked(n + 1, false);
    vll colored(n + 1, -1);
    vector<bool> visited(n, false);

    for (int i = 1; i <= n; i++) {
        cin >> it[i].ff >> it[i].ss;
        count[it[i].ff | (it[i].ss << 31)] = i;
        if (it[i].ss == 0) cz++;
    }

    if (cz == n) {
        vector<pair<ll, ll>> cords = {{-1e10, 0}};
        for (int i = 1; i <= n; i++) {
            cords.pb({it[i].ff, i});
        }

        sort(all(cords), cmp);

        vector<bool> goods(n + 1, false);

        ll lp = 1, rp = 1;
        queue<ll> q;


        for (int i = 1; i <= n; i++) {
            if (rp < i) rp = i;
            while (cords[i].ff - cords[lp].ff > r) lp++;
            while (rp + 1 <= n && cords[rp + 1].ff - cords[i].ff <= r) rp++;

            ll has = rp - lp;

            if (i - lp >= 2 or rp - i >= 2 or (i > 1 && i < n && (cords[i + 1].ff - cords[i - 1].ff <= r))) {
                goods[i] = true;
                q.push(i);
            }
        }

        while (!q.empty()) {
            ll curr = q.front();
            q.pop();

            if (curr > 1 && cords[curr].ff - cords[curr - 1].ff <= r && !goods[curr - 1]) {
                goods[curr - 1] = true;
                q.push(curr - 1);
            }
            if (curr < n && cords[curr + 1].ff - cords[curr].ff <= r && !goods[curr + 1]) {
                goods[curr + 1] = true;
                q.push(curr + 1);
            }
        }

        for (int i = 1; i <= n; i++) {
            if (goods[i]) cout << "1";
            else cout << "0";
        }
        return 0;
    }

    if (n <= 1000) {
        for (int i = 1; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                ll dist = (it[i].ff - it[j].ff) * (it[i].ff - it[j].ff) + (it[i].ss - it[j].ss) * (it[i].ss - it[j].ss);

                if (dist <= r * r) {
                    g[i].pb(j);
                    g[j].pb(i);
                }
            }
        }
    } else {
        for (int i = 1; i <= n; i++) {
            for (int dx = -10; dx <= 10; dx++) {
                for (int dy = -10; dy <= 10; dy++) {
                    if (dx * dx + dy * dy > r * r) {
                        continue;
                    }

                    ll x = it[i].ff - dx, y = it[i].ss - dy;

                    if (x < 0 || y < 0) continue;

                    ll ind = count[x | (y << 31)];
                    if (ind != 0 && ind != i) {
                        g[i].pb(ind);
                    }
                }
            }
        }
    }


    for (int i = 1; i <= n; i++) {
        bool found = false;
        if (colored[i] == -1) {
            dfs1(i, colored, 0, found);
        }
        if (found) {
            draw(marked, visited, i, n);
        }
    }

    for (int i = 1; i <= n; i++) {
        if (marked[i]) cout << '1';
        else cout << '0';
    }

    return 0;
}