#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define vll vector<ll>
#define all(x) x.begin(), x.end()
#define speed ios::sync_with_stdio(false), cin.tie(nullptr);
#define pb push_back
#define ff first
#define ss second

const ll maxN = 1e5 + 1;

struct segtree {
    ll size; vll tree;

    void init(ll n) {
        size = 1;
        while (size < n) size *= 2;

        tree.assign(2 * size - 1, 0);
    }

    void up(int x) {
        tree[x] = tree[x * 2 + 1] + tree[x * 2 + 2];
    }

    void set(int x, int lx, int rx, int i) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }

        int md = (rx + lx) / 2;

        if (i < md) {
            set(x * 2 + 1, lx, md, i);
        } else {
            set(x * 2 + 2, md, rx, i);
        }

        up(x);
    }

    void set(int i) {
        set(0, 0, size, i);
    }

    ll count(int x, int lx, int rx, int l, int r) {
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        if (rx <= l || lx >= r) {
            return 0;
        }

        int md = (rx + lx) / 2;

        ll ans = 0;

        ans += count(x * 2 + 1, lx, md, l, r);
        ans += count(x * 2 + 2, md, rx, l, r);

        return ans;
    }

    ll count(int l, int r) {
        return count(0, 0, size, l, r);
    }
};

ll countInv(vll a) {
    segtree tree;
    ll ans = 0;

    tree.init(a.size() + 10);

    for (int i = 0; i < a.size(); i++) {
        ans += tree.count(a[i] + 1, a.size() + 3);
        tree.set(a[i]);
    }

    return ans;
}

ll ans = 1e15;

void minimize(vll cb, vector<vll>& mt) {
    if (mt.size() == 0) {
        ans = min(ans, countInv(cb));
        return;
    }

    vector<vll> c1, c2;
    vll cb1, cb2;

    for (auto x : mt) {
        c1.pb(x);
        c2.pb(x);
    }
    for (auto x : cb) {
        cb1.pb(x);
        cb2.pb(x);
    }

    for (auto x : c1[0]) {
        cb1.pb(x);
    }
    c1.erase(c1.begin());

    minimize(cb1, c1);

    for (int i = 0; i < mt.size(); i++) {
        cb2.pb(c2[i][0]);
        c2[i].erase(c2[i].begin());
    }

    if (c2[0].size() == 0) {
        c2 = {};
    }

    minimize(cb2, c2);
}

int main() {


    speed

    ll r, c; cin >> r >> c;

    vector<vll> mt(r, vll(c));
    for (auto &x : mt) for (auto &z : x) cin >> z;

    if (r == 1) {
        cout << countInv(mt[0]);
        return 0;
    }

    minimize({}, mt);

    cout << ans;

    return 0;
}