// g.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <deque>
#include <list>

using namespace std;

#define ll long long
#define vec vector

vec<list<ll> > gr(1e5 + 1);
vec<ll> partOfNonBipartite(1e5 + 1, 0);
vec<ll> color(1e5 + 1);

bool dfs(ll v, ll prevColor = 2)
{
	if (color[v]) return true;
	color[v] = !((prevColor - 1ll)) + 1ll;
	ll twosAreThere = 0, onesAreThere = 0;
	bool downResult = true;
	for (auto& e : gr[v])
	{
		if (color[e] == 2)
			twosAreThere += 1;
		if (color[e] == 1)
			onesAreThere += 1;
		downResult &= dfs(e, color[v]);
	}


	return !(twosAreThere && onesAreThere) && downResult;
}

vec<ll> color1(1e5 + 1);
void callNonBipartite(ll v)
{
	if (color1[v]) return;

	color1[v] = 1;
	for (auto& e : gr[v])
		callNonBipartite(e);
}

struct Point
{
	ll x, y;

	ll sqrDistance(Point& second)
	{
		return pow((x - second.x), 2) + pow((y - second.y), 2);
	}
};

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, r;
	cin >> n >> r;

	ll i, j;
	vec<Point> points(n + 1);
	for (i = 1; i <= n; i++)
		cin >> points[i].x >> points[i].y;

	// n <= 1e4
	for (i = 1; i <= n; i++)
		for (j = i + 1; j <= n; j++)
		{
			if (points[i].sqrDistance(points[j]) <= r * r)
			{
				gr[i].push_back(j);
				gr[j].push_back(i);
			}
		}

	for (i = 1; i <= n; i++)
	{
		if (color[i] == 0)
		{
			bool res = dfs(i);
			if (!res) callNonBipartite(i);
		}
	}

	for (i = 1; i <= n; i++)
		cout << color1[i];
}