#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
using namespace std;
vector<int> parent;
vector<int> rang;
vector<bool> goodloop;
vector<int> used;
struct node {
    int x,y,num;
};
void make_m(int v) {
    parent[v] = v;
    rang[v] = 1;
}
int find_m(int v) {
    return parent[v] == v ? v : parent[v] = find_m(parent[v]);
}
void merge_m(int x, int y) {
    x = find_m(x);
    y = find_m(y);
    if (x != y) {
        if (rang[x]<rang[y]) {
            swap(x,y);
        }
        parent[y] = x;
        if (goodloop[y])goodloop[x] = true;
        if (rang[x] == rang[y]) {
            rang[x]++;
        }
    }
}
void dfs(int v, vector<node> & a,int c,ll &r) {
    used[v] = c;
    for (int i = 0;i<a.size();i++) {
        if (a[i].num==v)continue;
        if ((a[i].x-a[v].x) * (a[i].x-a[v].x) + (a[i].y - a[v].y) * (a[i].y - a[v].y) <= r*r) {
            if (used[a[i].num] == -1) {
                merge_m(a[i].num, v);
                dfs(a[i].num, a, c+1, r);
            }
            else {
                if ((used[v] - used[a[i].num])%2 == 0)goodloop[find_m(v)] = true;
            }
        }
    }
}
bool cmp(node a, node b) {
    if (a.x*a.x + a.y*a.y < b.x  * b.x + b.y*b.y)return true;
    return false;
}
bool cmp2(node a, node b) {
    if (a.num > b.num)return false;
    return true;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin>>n>>m;
    vector<vector<int>> a(n,vector<int>(m));
    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) {
            cin>>a[i][j];
        }
    }
    vector<vector<ll>> dp(n,vector<ll>(m));
    vector<vector<ll>> dp1(n,vector<ll>(m));
    vector<vector<ll>> dp2(n,vector<ll>(m));
    dp[n-1][m-1] = 0;
    dp1[n-1][m-1] = 0;
    dp2[n-1][m-1] = 0;

    for (int i = m-2;i>=0;i--) {
        dp1[n-1][i] = dp1[n-1][i+1];
        for (int j = i+1;j<m;j++) {
            if (a[n-1][i] > a[n-1][j])dp1[n-1][i]++;
        }
        dp[n-1][i] = dp1[n-1][i];
    }
    for (int i = n-2;i>=0;i--) {
        dp2[i][m-1] = dp2[i+1][m-1];
        for (int j = i+1;j<n;j++) {
            if (a[i][m-1] > a[j][m-1])dp2[i][m-1]++;
        }
        dp[i][m-1] = dp2[i][m-1];
    }
    for (int i = n-2;i>=0;i--) {
        for (int j = m-2;j>=0;j--) {
            dp1[i][j] = dp1[i+1][j];
            for (int k = i; k<n;k++) {
                for (int u = j+1;u<m;u++) {
                    if (a[k][j] > a[i][u])dp1[i][j]++;
                }
            }
            for (int k = i+1;k<n;k++) {
                for (int u = j;u<m;u++) {
                    if (a[i][j] > a[k][u])dp1[i][j]++;
                }
            }
        }
    }
    for (int i = n-2;i>=0;i--) {
        for (int j = m-2;j>=0;j--) {
            dp2[i][j] = dp2[i][j+1];
            for (int k = i+1; k<n;k++) {
                for (int u = j;u<m;u++) {
                    if (a[i][u] > a[k][j])dp2[i][j]++;
                }
            }
            for (int k = i;k<n;k++) {
                for (int u = j+1;u<m;u++) {
                    if (a[i][j] > a[k][u])dp2[i][j]++;
                }
            }
        }
    }
    for (int i=n-2;i>=0;i--) {
        for (int j = m-2;j>=0;j--) {
            dp[i][j] = min(dp[i][j+1]+dp1[i][j] - dp[i+1][j+1], dp[i+1][j] + dp2[i][j]);
        }
    }
    cout<<dp[0][0];
}