#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
const ll MAXC = 1e9;

int n, r;
vector<pii> a;
vector<int> col;
unordered_map<ll, int> mp;
vector<vector<int>> g;

ll hsh(int x, int y) {
    return (1ll * MAXC * x + y);
}

ll sq(int x) {
    return (1ll * x * x);
}
bool good(int i, int j) {
    return (sq(a[i].first - a[j].first) + sq(a[i].second - a[j].second) <= sq(r));
}


void dfs(int i, int cc) {
    col[i] = cc;
    int w_id = (i - (i >= n) * n);
    for (int dx = -r; dx <= r; dx++) {
        for (int dy = 0; dy * dy + dx * dx <= r * r; dy++) {
            auto it = mp.find(hsh(a[w_id].first + dx, a[w_id].second + dy));
            if (it != mp.end() && it->second != w_id) {
                int nj = (it->second + (i < n) * n);
                if (col[nj] == -1) {
                    dfs(nj, cc);
                }
            } 
        }
        for (int dy = 0; dy * dy + dx * dx <= r * r; dy--) {
            auto it = mp.find(hsh(a[w_id].first + dx, a[w_id].second + dy));
            if (it != mp.end() && it->second != w_id) {
                int nj = (it->second + (i < n) * n);
                if (col[nj] == -1) {
                    dfs(nj, cc);
                }
            }
        }
    }
    /*for (int j = 0; j < n; j++) {
        if (j == w_id) continue;
        int nj = (j + (i < n) * n);
        if (good(w_id, j) && col[nj] == -1) {
            dfs(nj, cc);
        }
    }*/
}


void solve() {
    cin >> n >> r;
    a.assign(n, {});
    for (auto &el : a) {
        cin >> el.first >> el.second;
    }
    for (int i = 0; i < n; i++) {
        mp[hsh(a[i].first, a[i].second)] = i;
    }
    int cc = 0;
    col.assign(2 * n, -1);
    for (int i = 0; i < 2 * n; i++) {
        if (col[i] == -1) {
            dfs(i, cc++);
        }
    }

    for (int i = 0; i < n; i++) {
        cout << (col[i] == col[i + n] ? '1' : '0');
    }
    cout << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
