#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
const ll MAXC = 1e9;
const ll INF = 1e18;

struct Segtree {
    vector<ll> t;

    ll get(ll x, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) {
            return t[x];
        }
        if (lx >= r || rx <= l) {
            return 0;
        }
        ll md = (lx + rx) / 2;
        return (get(2 * x + 1, lx, md, l, r) + get(2 * x + 2, md, rx, l, r));
    }
    void edit(ll x, ll lx, ll rx, ll i, ll v) {
        if (rx - lx == 1) {
            t[x] += v;
            return;
        }
        ll md = (lx + rx) / 2;
        if (i < md) {
            edit(2 * x + 1, lx, md, i, v);
        } else {
            edit(2 * x + 2, md, rx, i, v);
        }
        t[x] = t[2 * x + 1] + t[2 * x + 2];
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll> (m));
    for (auto &el : a) {
        for (auto &x : el) {
            cin >> x;
            --x;
        }
    }



    Segtree st;
    st.t.assign(4 * n * m, 0);
    vector<vector<ll>> fxi(n + 1, vector<ll> (m + 1));
    for (ll i = 0; i < n; i++) {
        for (ll j = m - 1; j >= 0; j--) {
            for (ll nj = j + 1; nj < m; nj++) {
                fxi[i][j] += (a[i][j] > a[i][nj]);
            }
            fxi[i][j] += fxi[i][j + 1];
        }
    }

    vector<vector<ll>> fxj(n + 1, vector<ll> (m + 1));
    for (ll j = 0; j < m; j++) {
        for (ll i = n - 1; i >= 0; i--) {
            for (ll ni = i + 1; ni < n; ni++) {
                fxj[i][j] += (a[i][j] > a[ni][j]);
            }
            fxj[i][j] += fxj[i + 1][j];
        }
    }



    vector<vector<ll>> dp(n + 1, vector<ll> (m + 1, INF));
    dp[0][0] = 0;
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= m; j++) {
            if (i == 0 && j == 0) continue;

            if (i) {
                vector<ll> us(n * m);
                for (ll ni = 0; ni < n; ni++) {
                    for (ll nj = 0; nj < m; nj++) {
                        if (ni < i - 1 || nj < j) {
                            us[a[ni][nj]] = 1;
                        }
                    }
                }
                for (ll x = n * m - 2; x >= 0; x--) {
                    us[x] += us[x + 1];
                }

                ll cn = 0;
                for (ll nj = j; nj < m; nj++) {
                    ll el = a[i - 1][nj];
                    if (el < n * m - 1) {
                        cn += us[el + 1];
                    }
                }

                dp[i][j] = min(dp[i][j], dp[i - 1][j] + cn + fxi[i - 1][j]);
            }
            if (j) {
                vector<ll> us(n * m);
                for (ll ni = 0; ni < n; ni++) {
                    for (ll nj = 0; nj < m; nj++) {
                        if (ni < i || nj < j - 1) {
                            us[a[ni][nj]] = 1;
                        }
                    }
                }
                for (ll x = n * m - 2; x >= 0; x--) {
                    us[x] += us[x + 1];
                }

                ll cn = 0;
                for (ll ni = i; ni < n; ni++) {
                    ll el = a[ni][j - 1];
                    if (el < n * m - 1) {
                        cn += us[el + 1];
                    }
                }

                dp[i][j] = min(dp[i][j], dp[i][j - 1] + cn + fxj[i][j - 1]);
            }
        }
    }

    ll mn = INF;
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= m; j++) {
            if (j == m || i == n) {
                mn = min(mn, dp[i][j]);
            }
        }
    }
    cout << mn << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
