#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
const ll MAXC = 1e9;
const ll INF = 1e18;

struct Segtree {
    vector<ll> t;

    ll get(ll x, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) {
            return t[x];
        }
        if (lx >= r || rx <= l) {
            return 0;
        }
        ll md = (lx + rx) / 2;
        return (get(2 * x + 1, lx, md, l, r) + get(2 * x + 2, md, rx, l, r));
    }
    void edit(ll x, ll lx, ll rx, ll i, ll v) {
        if (rx - lx == 1) {
            t[x] += v;
            return;
        }
        ll md = (lx + rx) / 2;
        if (i < md) {
            edit(2 * x + 1, lx, md, i, v);
        } else {
            edit(2 * x + 2, md, rx, i, v);
        }
        t[x] = t[2 * x + 1] + t[2 * x + 2];
    }
};

ll n, m;
ll get(vector<ll> a) {
    ll s = 0;
    Segtree st;
    st.t.assign(4 * n * m, 0);
    for (ll i = 0; i < (ll)a.size(); i++) {
        s += st.get(0, 0, n * m, a[i] + 1, n * m);
        st.edit(0, 0, n * m, a[i], 1);
    }
    return s;
}


void solve() {
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll> (m));
    for (auto &el : a) {
        for (auto &x : el) {
            cin >> x;
            --x;
        }
    }

    vector<ll> v1, v2;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            v1.push_back(a[i][j]);
        }
    }
    ll mn = get(v1);
    if (n == 1) {
        cout << mn << '\n';
        return;
    }

    Segtree st1, st2;
    st1.t.assign(4 * n * m, 0);
    st2.t.assign(4 * n * m, 0);

    vector<ll> pi1(m);
    for (ll j = 0; j < m; j++) {
        for (ll i = 0; i < n; i++) {
            pi1[j] += st1.get(0, 0, n * m, a[i][j] + 1, n * m);
            st1.edit(0, 0, n * m, a[i][j], 1);
        }
        if (j) {
            pi1[j] += pi1[j - 1];
        }
    }

    vector<ll> su1(m + 1);
    st1.t.assign(4 * n * m, 0);
    for (ll j = m - 1; j >= 0; j--) {
        su1[j] += su1[j + 1];
        su1[j] += st1.get(0, 0, n * m, 0, a[0][j]);
        st1.edit(0, 0, n * m, a[0][j], 1);
        su1[j] += st2.get(0, 0, n * m, 0, a[1][j]);
        st2.edit(0, 0, n * m, a[1][j], 1);

        su1[j] += st2.get(0, 0, n * m, 0, a[0][j]);
        su1[j] += st1.get(0, 0, n * m, a[1][j] + 1, n * m);
        su1[j] -= (a[0][j] > a[1][j]);
    }

    st1.t.assign(4 * n * m, 0);
    st2.t.assign(4 * n * m, 0);
    for (ll i = 0; i < n * m; i++) {
        st2.edit(0, 0, n * m, i, 1);
    }

    ll inv = 0;
    for (ll j = 0; j < m; j++) {
        ll cr = pi1[j] + su1[j + 1];
        for (ll i = 0; i < n; i++) {
            inv -= st1.get(0, 0, n * m, a[i][j] + 1, n * m);
            st1.edit(0, 0, n * m, a[i][j], 1);
            st2.edit(0, 0, n * m, a[i][j], -1);
            inv += st2.get(0, 0, n * m, 0, a[i][j]);
        }
        mn = min(mn, cr + inv);
    }
    cout << mn << '\n';
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
