#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;
using tup = tuple<ll, ll, ll>;
const ll MAXC = 1e9;
const ll INF = 1e18;


struct Segtree {
    vector<ll> t;
 
    ll get(ll x, ll lx, ll rx, ll l, ll r) {
        if (lx >= l && rx <= r) {
            return t[x];
        }
        if (lx >= r || rx <= l) {
            return INF;
        }
        ll md = (lx + rx) / 2;
        return min(get(2 * x + 1, lx, md, l, r), get(2 * x + 2, md, rx, l, r));
    }
    void edit(ll x, ll lx, ll rx, ll i, ll v) {
        if (rx - lx == 1) {
            t[x] = v;
            return;
        }
        ll md = (lx + rx) / 2;
        if (i < md) {
            edit(2 * x + 1, lx, md, i, v);
        } else {
            edit(2 * x + 2, md, rx, i, v);
        }
        t[x] = min(t[2 * x + 1], t[2 * x + 2]);
    }
};



void solve() {
    ll n, q;
    cin >> n >> q;
    ll mx = 0;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
        mx = max(mx, el);
    }

    auto ps = a;
    for (ll i = n - 2; i >= 0; i--) {
        ps[i] = max(ps[i], ps[i + 1]);
    }

    vector<ll> st;
    vector<ll> cl(n, n);
    for (ll i = 0; i < n; i++) {
        while (!st.empty() && a[st.back()] < a[i]) {
            cl[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }

    Segtree w;
    w.t.assign(4 * n, INF);
    for (ll i = 0; i < n - 1; i++) {
        w.edit(0, 0, n, i, ps[i + 1]);
    }

    vector<pii> rs(n, {INF, INF});
    for (ll i = n - 2; i >= 1; i--) {
        rs[i] = {a[i], w.get(0, 0, n, i, min(n - 1, cl[i]))};
        /*for (ll lb = i; lb < min(n - 1, cl[i]); lb++) {
            rs[i] = min(rs[i], {a[i], ps[lb + 1]});
        }*/
    }

    tup d = {INF, INF, INF};
    for (ll lb = 0; lb < min(n - 2, cl[0]); lb++) {
        d = min(d, {a[0], rs[lb + 1].first, rs[lb + 1].second});
    }

    while (q--) {
        ll k, i;
        cin >> k >> i;
        if (i == 1) {
            cout << get<0>(d) << '\n';
        } else if (i == 2) {
            cout << get<1>(d) << '\n';
        } else {
            cout << get<2>(d) << '\n';
        }
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
    #ifdef flam3
        cout << "Time: " << (clock() / (ld)CLOCKS_PER_SEC) << '\n';
    #endif
}
