#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
struct Vector {
    T x, y;

    Vector(T x = 0, T y = 0) : x(x), y(y) {}

    Vector<T> operator-(Vector<T> b) {
        return Vector<T>(x - b.x, y - b.y);
    }

    T len2() {
        return x * x + y * y;
    }

    bool operator<(Vector<ll> b) const {
        return x < b.x || (x == b.x && y < b.y);
    }
};

const int MAXN = 1e5 + 1;
vector<int> g[MAXN];
int col[MAXN];
bool found[MAXN];

int dfs(int v, int c) {
    col[v] = c;
    for (auto u : g[v]) {
        if (col[u] == c) {
            return v;
        }
        if (col[u] == -1) {
            int x = dfs(u, c ^ 1);
            if (x != -1) {
                return x;
            }
        }
    }
    return -1;
}

void paint(int v) {
    found[v] = 1;
    for (auto u : g[v]) {
        if (!found[u]) {
            paint(u);
        }
    }
}

vector<pair<ll, ll>> a;
int ok[MAXN];
ll r, n;

void make_ok(int i) {
    ok[i] = 1;
    if (i > 0 && a[i].first - a[i - 1].first <= r && !ok[i - 1]) {
        make_ok(i - 1);
    }
    if (i < n - 1 && a[i + 1].first - a[i].first <= r && !ok[i + 1]) {
        make_ok(i + 1);
    }
}

void solve() {
    cin >> n >> r;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        int y;
        cin >> a[i].first >> y;
        a[i].second = i;
    }
    sort(a.begin(), a.end());
    int l = 0;
    for (int i = 0; i < n; ++i) {
        if (ok[i]) {
            continue;
        }
        int nxt = lower_bound(a.begin(), a.end(), make_pair(a[i].first + r + 1, 0ll)) - a.begin();
        int cnt = nxt - i;
        if (cnt >= 3) {
            make_ok(i);
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[a[i].second] = ok[i];
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

