#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
struct Vector {
    T x, y;

    Vector(T x = 0, T y = 0) : x(x), y(y) {}

    Vector<T> operator-(Vector<T> b) {
        return Vector<T>(x - b.x, y - b.y);
    }

    T len2() {
        return x * x + y * y;
    }

    bool operator<(Vector<ll> b) const {
        return x < b.x || (x == b.x && y < b.y);
    }
};

const ll MAXN = 1e5 + 1;
vector<ll> g[MAXN];
ll col[MAXN];
bool found[MAXN];

ll dfs(ll v, ll c) {
    col[v] = c;
    for (auto u : g[v]) {
        if (col[u] == c) {
            return v;
        }
        if (col[u] == -1) {
            ll x = dfs(u, c ^ 1);
            if (x != -1) {
                return x;
            }
        }
    }
    return -1;
}

void paint(ll v) {
    found[v] = 1;
    for (auto u : g[v]) {
        if (!found[u]) {
            paint(u);
        }
    }
}

void solve() {
    fill(col, col + MAXN, -1);
    ll n, r;
    cin >> n >> r;
    vector<pair<Vector<ll>, ll>> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].first.x >> a[i].first.y;
        a[i].second = i;
    }
    sort(a.begin(), a.end(), [](pair<Vector<ll>, ll> a, pair<Vector<ll>, ll> b) {
        return a.first.len2() < b.first.len2();
    });
    map<Vector<ll>, ll> s;
    for (ll i = 0; i < n; ++i) {
        s[a[i].first] = i;
    }
    for (ll i = 0; i < n; ++i) {
        ll x = a[i].first.x, y = a[i].first.y;
        for (ll x1 = x - 10; x1 <= x + 10; ++x1) {
            for (ll y1 = y - 10; y1 <= y + 10; ++y1) {
                if ((a[i].first - Vector<ll>(x1, y1)).len2() <= r * r) {
                    auto it = s.find({x1, y1});
                    if (it != s.end()) {
                        g[i].push_back(it->second);
                        g[it->second].push_back(i);
                    }
                }

            }
        }
    }
    // for (ll i = 0; i < n; ++i) {
    //     for (ll j = i + 1; j < min((ll) n, i + 5000); ++j) {
    //         if ((a[i].first - a[j].first).len2() <= r * r) {
    //             g[i].push_back(j);
    //             g[j].push_back(i);
    //         }
    //     }
    // }
    for (ll i = 0; i < n; ++i) {
        if (col[i] == -1) {
            ll x = dfs(i, 0);
            if (x != -1) {
                paint(x);
            }
        }
    }
    vector<ll> ans(n);
    for (ll i = 0; i < n; ++i) {
        ans[a[i].second] = found[i];
    }
    for (ll i = 0; i < n; ++i) {
        cout << ans[i];
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

