#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
struct Vector {
    T x, y;

    Vector(T x = 0, T y = 0) : x(x), y(y) {}

    Vector<T> operator-(Vector<T> b) {
        return Vector<T>(x - b.x, y - b.y);
    }

    T len2() {
        return x * x + y * y;
    }
};

const int MAXN = 1e4 + 1;
vector<int> g[MAXN];
int col[MAXN];
bool found[MAXN];

int dfs(int v, int c) {
    col[v] = c;
    for (auto u : g[v]) {
        if (col[u] == c) {
            return v;
        }
        if (col[u] == -1) {
            int x = dfs(u, c ^ 1);
            if (x != -1) {
                return x;
            }
        }
    }
    return -1;
}

void paint(int v) {
    found[v] = 1;
    for (auto u : g[v]) {
        if (!found[u]) {
            paint(u);
        }
    }
}

void solve() {
    fill(col, col + MAXN, -1);
    ll n, r;
    cin >> n >> r;
    vector<pair<Vector<ll>, ll>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.x >> a[i].first.y;
        a[i].second = i;
    }
    sort(a.begin(), a.end(), [](pair<Vector<ll>, ll> a, pair<Vector<ll>, ll> b) {
        return a.first.len2() < b.first.len2();
    });
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < min((int) n, i + 300); ++j) {
            if ((a[i].first - a[j].first).len2() <= r * r) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (col[i] == -1) {
            int x = dfs(i, 0);
            if (x != -1) {
                paint(x);
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[a[i].second] = found[i];
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i];
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

