#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 250000 + 10;
ll fen[MAXN];

void update(int i, ll x) {
    for (; i < MAXN; i += i & -i) {
        fen[i] += x;
    }
}

ll get(int i) {
    ll ans = 0;
    for (; i > 0; i -= i & -i) {
        ans += fen[i];
    }
    return ans;
}

ll get(ll l, ll r) {
    return get(r) - get(l - 1);
}

void solve() {
    ll r, c;
    cin >> r >> c;
    vector<vector<ll>> a(r, vector<ll>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    ll num = r * c;
    ll ans = LLONG_MAX;
    for (int mask = 0; mask < (1 << (r + c)); ++mask) {
        fill(fen, fen + num + 1, 0);
        ll now = 0;
        int row = 0, col = 0;
        for (int i = 0; i < r + c; ++i) {
            if (mask & (1 << i)) {
                for (int j = col; j < c; ++j) {
                    update(a[row][j], 1);
                    now += get(a[row][j] + 1, num);
                }
                row++;
            } else {
                for (int j = row; j < r; ++j) {
                    update(a[j][col], 1);
                    now += get(a[j][col] + 1, num);
                }
                col++;
            }
            if (row >= r || col >= c) {
                break;
            }
        }
        ans = min(ans, now);
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

