#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 250000 + 10;
ll fen[MAXN];

void update(int i, ll x) {
    for (; i < MAXN; i += i & -i) {
        fen[i] += x;
    }
}

ll get(int i) {
    ll ans = 0;
    for (; i > 0; i -= i & -i) {
        ans += fen[i];
    }
    return ans;
}

ll get(ll l, ll r) {
    return get(r) - get(l - 1);
}

void solve() {
    ll r, c;
    cin >> r >> c;
    if (r == 1) {
        vector<ll> a(c);
        for (int i = 0; i < c; ++i) {
            cin >> a[i];
        }
        ll ans = 0;
        for (int i = 0; i < c; ++i) {
            update(a[i], 1);
            ans += get(a[i] + 1, MAXN - 1);
        }
        cout << ans;
        return;
    }
    vector<vector<ll>> a(r, vector<ll>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }
    ll num = r * c;
    ll ans = 0;
    fill(fen, fen + num + 1, 0);
    for (int j = 0; j < c; ++j) {
        ans += get(a[0][j] + 1, num);
        ans += get(a[1][j] + 1, num);
        update(a[0][j], 1);
        update(a[1][j], 1);
    }
    fill(fen, fen + num + 1, 0);
    for (int i = c - 1; i > 0; --i) {
        update(a[0][i], 1);
        int cnt = c - i;
        int now = get(a[1][i - 1], num);
        ans += min(cnt, cnt - now);
    }
    for (int i = 0; i < c; ++i) {
        ans += a[0][i] > a[1][i];
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

