#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
//
// using namespace __gnu_pbds;
//
// template<class T>
// using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct SegTree {
    vector<pair<int, int>> tree;
    int n;

    SegTree() {}

    SegTree(int n, vector<int> a) : n(n), tree(4 * n + 1) {
        build(1, 0, n, a);
    }

    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            tree[v] = {a[l], l};
        } else {
            int m = (r + l) / 2;
            build(v << 1, l, m, a);
            build(v << 1 | 1, m, r, a);
            tree[v] = min(tree[v << 1], tree[v << 1 | 1]);
        }
    }

    pair<int, int> get(int v, int l, int r, int lq, int rq) {
        if (l >= rq || lq >= r) {
            return {n + 1, n + 1};
        }
        if (lq <= l && r <= rq) {
            return tree[v];
        }
        int m = (r + l) / 2;
        return min(get(v << 1, l, m, lq, rq), get(v << 1 | 1, m, r, lq, rq));
    }
};

SegTree tree;
vector<int> rt, suf;

vector<int> solve(int n, int k, vector<int> &a) {
#ifdef LOCAL
    tree = SegTree(n, a);
    rt.resize(n + 1, -1);
    suf.resize(n + 1);

    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(a[i], suf[i + 1]);
    }

    vector<pair<int, int>> st = {{n + 1, -1}};
    for (int i = 0; i < n; ++i) {
        while (a[i] > st.back().first) {
            rt[st.back().second] = i;
            st.pop_back();
        }
        st.emplace_back(a[i], i);
    }
#endif
    vector<int> b;
    int num = 1;
    for (int i = 0; i < n;) {
        if (num == k) {
            b.push_back(suf[i]);
            break;
        }
        if (num == k - 1) {
            int id = rt[i];
            // for (int j = i; j < n; ++j) {
            //     if (a[j] > a[i]) {
            //         id = j;
            //         break;
            //     }
            // }
            b.push_back(a[i]);
            if (id == -1) {
                id = n -1;
            }
            // int mx = 0;
            // for (int j = id; j < n; ++j) {
            //     mx = max(mx, a[j]);
            // }
            b.push_back(suf[id]);
            break;
        }
        int now = a[i];
        // int mn = n + 1, id = -1;
        // for (int j = i; j + k - num <= n; ++j) {
        //     if (a[j] > a[i]) {
        //         break;
        //     }
        //     if (a[j] < mn) {
        //         mn = a[j];
        //         id = j;
        //     }
        // }
        auto [mn, id] = tree.get(1, 0, n, i, min(n + num - k + 1, (rt[i] == -1 ? n : rt[i])));
        b.push_back(a[i]);
        if (id != i) {
            b.push_back(a[id]);
            num += 2;
        } else {
            num += 1;
        }
        i = id + 1;
    }
    return b;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    tree = SegTree(n, a);
    rt.resize(n + 1, -1);
    suf.resize(n + 1);

    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(a[i], suf[i + 1]);
    }
    
    vector<pair<int, int>> st = {{n + 1, -1}};
    for (int i = 0; i < n; ++i) {
        while (a[i] > st.back().first) {
            rt[st.back().second] = i;
            st.pop_back();
        }
        st.emplace_back(a[i], i);
    }

    vector<ll> ks;
    vector<pair<ll, ll>> qs(q);
    for (int i = 0; i < q; ++i) {
        ll k, m;
        cin >> k >> m;
        qs[i] = {k, m};
        ks.push_back(k);
    }
    sort(ks.begin(), ks.end());
    ks.resize(unique(ks.begin(), ks.end()) - ks.begin());

    vector<vector<int>> ans(n + 1);
    for (int i = 0; i < szof(ks); ++i) {
        ans[ks[i]] = solve(n, ks[i], a);
    }
    for (int i = 0; i < q; ++i) {
        auto [k, j] = qs[i];
        cout << ans[k][j - 1] << '\n';
    }
}

vector<int> my_solve(int n, int k, vector<int> a) {
    vector<int> suf(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(a[i], suf[i + 1]);
    }
    vector<int> ans;
    for (int j = 1; j <= k; ++j) {
        if (k % 2 == 0 || k == 1) {
            if (j < k) {
                ans.push_back(a[j - 1]);
            } else {
                ans.push_back(suf[k - 1]);
            }
        } else {
            if (j == k) {
                ans.push_back(a[n - 1]);
            } else {
                ans.push_back(a[j - 1]);
            }
        }
    }
    return ans;
}

void my_solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> suf(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(a[i], suf[i + 1]);
    }
    for (int i = 0; i < q; ++i) {
        int k, j;
        cin >> k >> j;
        if (k % 2 == 0 || k == 1) {
            if (j < k) {
                cout << a[j - 1] << '\n';
            } else {
                cout << suf[k - 1] << '\n';
            }
        } else {
            if (j == k) {
                cout << a[n - 1] << '\n';
            } else {
                cout << a[j - 1] << '\n';
            }
        }
    }
}

void stress() {
    mt19937 rnd(123);
    int test = 1;
    while (true) {
        int n = rnd() % 10 + 1;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                a[i] = i / 2 + 1;
            } else {
                a[i] = n - i / 2;
            }
        }
        for (int k = 1; k <= n; ++k) {
            auto need = solve(n, k, a);
            auto my = my_solve(n, k, a);
            if (need != my) {
                cout << "TEST " << test << " FAILED:\n" << n << " " << k << '\n';
                for (int i = 0; i < n; ++i) {
                    cout << a[i] << ' ';
                }
                cout << "\nNEED:\n";
                for (auto i : need) {
                    cout << i << ' ';
                }
                cout << "\nMY:\n";
                for (auto i : my) {
                    cout << i << ' ';
                }
                return;
            }
        }
        test++;
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    string s;
    getline(cin, s);
    if (s == "stress") {
        stress();
        return 0;
    }
#endif

    int times = 1;
    // cin >> times;
    while (times--) {
        my_solve(), cout << '\n';
    }
}

