#pragma GCC optimize("trapv")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define szof(x) ((ll) x.size())

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template<class T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

vector<int> solve(int n, int k, vector<int> &a) {
    vector<int> b;
    int num = 1;
    for (int i = 0; i < n;) {
        if (num == k) {
            int mx = 0;
            for (int j = i; j < n; ++j) {
                mx = max(mx, a[j]);
            }
            b.push_back(mx);
            break;
        }
        if (num == k - 1) {
            int id = -1;
            for (int j = i; j < n; ++j) {
                if (a[j] > a[i]) {
                    id = j;
                    break;
                }
            }
            b.push_back(a[i]);
            if (id == -1) {
                id = n -1;
            }
            int mx = 0;
            for (int j = id; j < n; ++j) {
                mx = max(mx, a[j]);
            }
            b.push_back(mx);
            break;
        }
        int now = a[i];
        int mn = n + 1, id = -1;
        for (int j = i; j + k - num <= n; ++j) {
            if (a[j] > a[i]) {
                break;
            }
            if (a[j] < mn) {
                mn = a[j];
                id = j;
            }
        }
        b.push_back(a[i]);
        if (id != i) {
            b.push_back(a[id]);
            num += 2;
        } else {
            num += 1;
        }
        i = id + 1;
    }
    return b;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> ks;
    vector<pair<ll, ll>> qs(q);
    for (int i = 0; i < q; ++i) {
        ll k, m;
        cin >> k >> m;
        qs[i] = {k, m};
        ks.push_back(k);
    }
    sort(ks.begin(), ks.end());
    ks.resize(unique(ks.begin(), ks.end()) - ks.begin());

    vector<vector<int>> ans(n + 1);
    for (int i = 0; i < szof(ks); ++i) {
        ans[ks[i]] = solve(n, ks[i], a);
    }
    for (int i = 0; i < q; ++i) {
        auto [k, j] = qs[i];
        cout << ans[k][j - 1] << '\n';
    }
}

vector<int> solve(int n, vector<int> a) {
    int id = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i] > a[0]) {
            id = i;
            break;
        }
    }
    if (id == -1) {
        id = n - 1;
    }
    int mx2 = 0;
    for (int i = id; i < n; ++i) {
        mx2 = max(mx2, a[i]);
    }
    return {a[0], mx2};
}

void stress() {
    mt19937 rnd(123);
    int test = 1;
    while (true) {
        int n = rnd() % 10 + 1;
        vector<int> a(n);
        iota(a.begin(), a.end(), 1);
        shuffle(a.begin(), a.end(), rnd);
        auto need = solve(n, a);
        auto my = solve(n, 2, a);
        if (need != my) {
            cout << "TEST " << test << " FAILED:\n" << n << "\n";
            for (int i = 0; i < n; ++i) {
                cout << a[i] << ' ';
            }
            cout << "\nNEED:\n" << need[0] << ' ' << need[1] << "\nMY:\n" << my[0] << ' ' << my[1];
            return;
        }
        test++;
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    string s;
    getline(cin, s);
    if (s == "stress") {
        stress();
        return 0;
    }
#endif

    int times = 1;
    // cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
}

