#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3274927942);
const int SZ = 1e5 + 1;

int col[SZ];
vector<int> g[SZ];

void col1(int v) {
	col[v] = -1;
	for (auto u : g[v])
		if (col[u] != -1)
			col1(u);
}

void dfs(int v) {
	if (col[v] == 0)
		col[v] = 1;
	for (auto u : g[v]) {
		if (col[u] == 0) {
			col[u] = 3 - col[v];
			dfs(u);
		}
		if (col[u] == -1) {
			if (col[v] != -1)
				col1(v);
			return;
		}
		if (col[u] == col[v]) {
			if (col[v] != -1)
				col1(v);
			return;
		}
	}
}

void solve() {
	int n;
	ld r;
	cin >> n >> r;
	vector<ll> x(n), y(n);
	for (int i = 0; i < n; i++) {
		col[i] = 0;
		cin >> x[i] >> y[i];
	}

	map<pair<int, int>, int> mp;
	vector<vector<int>> vec;
	vec.emplace_back();
	map<pair<int, int>, int> mp2;
	for (int i = 0; i < n; i++) {
		if (mp[{x[i] / r, y[i] / r}] == 0) {
			mp[{x[i] / r, y[i] / r}] = vec.size();
			vec.push_back({ i });
		}
		else {
			vec[mp[{x[i] / r, y[i] / r}]].push_back(i);
		}

		if (r > 1)
			mp2[{x[i] / (r / 2), y[i] / (r / 2)}]++;
	}

	vector<int> vec2;
	for (int i = 0; i < n; i++) {
		pair<int, int> p;
		int cnt = 0, ind;
		if (r > 1 && mp2[{ x[i] / (r / 2), y[i] / (r / 2) }] >= 3) {
			col[i] = -1;
			continue;
		}
		p = {x[i] / r, y[i] / r};

		ind = mp[{p.first - 1, p.second - 1}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first - 1, p.second}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first - 1, p.second + 1}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first, p.second - 1}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first, p.second}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first, p.second + 1}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first + 1, p.second - 1}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first + 1, p.second}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}
		ind = mp[{p.first + 1, p.second + 1}];
		{
			for (auto j : vec[ind]) {
				if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) <= r * r) {
					vec2.push_back(j);
					if (vec2.size() > 8)
						break;
				}
			}
		}

		if (vec2.size() > 8)
			col[i] = -1;
		else {
			for (auto j : vec2)
				if (i != j)
					g[i].push_back(j);
		}
		vec2.clear();
	}

	for (int i = 0; i < n; i++) {
		if (col[i] == 0)
			dfs(i);
	}

	for (int i = 0; i < n; i++)
		cout << (col[i] == -1 ? '1' : '0');
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}
