#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3274927942);
const int SZ = 3e5 + 1;

int n, m; // n <= m
void add(int i, vector<int>& fenv) {
	while (i <= n * m) {
		fenv[i]++;
		i = (i | (i - 1)) + 1;
	}
}

int get_sum(int i, vector<int>& fenv) {
	int ans = 0;
	while (i > 0) {
		ans += fenv[i];
		i = i & (i - 1);
	}
	return ans;
}

void solve() {
	cin >> n >> m;
	vector<vector<int>> a(n + 1, vector<int>(m + 1, 0));
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			cin >> a[i][j];

	vector<vector<int>> fenv(n + 1, vector<int>(n * m + 1, 0));
	vector<vector<vector<int>>> cnt1(n + 2, vector<vector<int>>(m + 2, vector<int>(n + 2, 0)));
	vector<vector<vector<int>>> cnt2(n + 2, vector<vector<int>>(m + 2, vector<int>(n + 2, 0)));
	for (int j = 1; j <= m; j++) {
		for (int i = 1; i <= n; i++) {
			for (int k = 1; k <= n; k++)
				cnt1[i][j][k] = j - 1 - get_sum(a[i][j], fenv[k]);
			for (int k = n; k >= 0; k--)
				cnt1[i][j][k] += cnt1[i][j][k + 1];
		}
		for (int i = 1; i <= n; i++)
			add(a[i][j], fenv[i]);
	}

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			for (int k = 1; k <= n; k++) {
				cnt2[i][j][k] = m - get_sum(a[i][j], fenv[k]);
				cnt2[i][j][k] += cnt2[i][j][k - 1];
			}
		}
	}


	vector<vector<int>> dp(n + 1, vector<int>(m + 1, n * m + 1));
	dp[0][0] = 0;
	//for (int i = 0; i <= n; i++)
	//	dp[i][0] = 0;
	//for (int i = 0; i <= m; i++)
	//	dp[0][i] = 0;

	//for (int i = 1; i <= n; i++) {
	//	int sum = 0;
	//	for (int j = 1; j <= m; j++)
	//		sum += cnt2[i][j][i - 1] + cnt1[i][j][i] - cnt1[i][j][i + 1];
	//	dp[i][0] = sum + dp[i - 1][0];
	//}
	//for (int j = 1; j <= m; j++) {
	//	int sum = 0;
	//	for (int i = 1; i <= n; i++) {
	//		sum += cnt1[i][j][1];
	//		for (int k = 1; k < i; k++)
	//			if (a[i][j] < a[k][j])
	//				sum++;
	//	}
	//	dp[0][j] = sum + dp[0][j - 1];
	//}

	//vector<int> sum3(m + 1, 0);
	//for (int i = 1; i <= n; i++) {
	//	for (int j = 1; j <= m; j++) {
	//		for (int k = 1; k < i; k++)
	//			if (a[k][j] > a[i][j])
	//				sum3[j]++;
	//	}
	//}

	//for (int i = 1; i <= n; i++) {
	//	int sum2 = 0, sum = 0;
	//	for (int j = 1; j <= m; j++)
	//		sum2 += cnt2[i][j][i - 1] + cnt1[i][j][i] - cnt1[i][j][i + 1];
	//	for (int j = 1; j <= m; j++) {
	//		sum2 -= (cnt1[i][j][i] + cnt2[i][j][i - 1]);
	//		for (int k = i + 1; k <= n; k++) {
	//			sum2 += m - j - ((cnt2[k][j][i] - cnt2[k][j][i - 1]) - (cnt1[k][j][i] - cnt1[k][j][i + 1]));
	//			if (a[i][j] > a[k][j])
	//				sum2 += 1;
	//		}

	//		sum = 0;
	//		for (int k = i + 1; k <= n; k++) {
	//			sum += cnt2[k][j][i];
	//			sum += cnt1[k][j][i + 1];
	//			if (a[i][j] > a[k][j])
	//				sum3[j]--;
	//		}
	//		sum += sum3[j];

	//		dp[i][j] = min(dp[i][j], dp[i][j - 1] + sum);
	//		dp[i][j] = min(dp[i][j], dp[i - 1][j] + sum2);
	//	}
	//}

	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= m; j++) {
			int sum1 = 0, sum2 = 0;

			if (i < n) {
				for (int k = i + 1; k <= n; k++) {
					for (int x = 1; x <= i; x++)
						for (int y = 1; y <= m; y++)
							if (a[x][y] > a[k][j + 1])
								sum1++;
				}
				for (int k = i + 1; k <= n; k++) {
					for (int x = i + 1; x <= n; x++)
						for (int y = 1; y <= j; y++)
							if (a[x][y] > a[k][j + 1])
								sum1++;
				}
				for (int x = i + 1; x <= n; x++)
					for (int y = x + 1; y <= n; y++)
						if (a[x][j + 1] > a[y][j + 1])
							sum1++;
				dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + sum2);
			}
			if (j < m) {
				for (int k = j + 1; k <= m; k++) {
					for (int x = 1; x <= i; x++)
						for (int y = 1; y <= m; y++)
							if (a[x][y] > a[i + 1][k])
								sum2++;
				}
				for (int k = j + 1; k <= m; k++) {
					for (int x = i + 1; x <= n; x++)
						for (int y = 1; y <= j; y++)
							if (a[x][y] > a[i + 1][k])
								sum2++;
				}

				for (int x = j + 1; x <= m; x++)
					for (int y = x + 1; y <= m; y++)
						if (a[i + 1][x] > a[i + 1][y])
							sum2++;
				dp[i][j + 1] = min(dp[i][j + 1], dp[i][j] + sum1);
			}
		}
	}

	int answer = n * m + 1;
	for (int i = 0; i <= n; i++)
		answer = min(answer, dp[i][m]);
	for (int i = 0; i <= m; i++)
		answer = min(answer, dp[n][i]);
	cout << answer;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}
