#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3274927942);
const int SZ = 3e5 + 1;

struct quest {
	int k, i, ind;
	quest(int k = 0, int i = 0, int ind = 0) : k(k), i(i), ind(ind) {}
};

vector<vector<pair<int, int>>> spt(20);
int best_st[SZ];
void build(int n, const vector<int>& a) {
	for (int i = 0; i < 20; i++)
		spt[i].assign(n, { 0, 0 });
	best_st[0] = best_st[1] = 0;
	for (int i = 2; i <= n; i++) {
		best_st[i] = best_st[i - 1] + 1;
		if ((1 << best_st[i]) > i)
			best_st[i]--;
	}
	for (int i = 0; i < n; i++)
		spt[0][i] = { a[i], i };
	for (int k = 0; k < 19; k++) {
		for (int i = 0; i < n; i++) {
			if (i + (1 << k) >= n)
				spt[k + 1][i] = spt[k][i];
			else
				spt[k + 1][i] = min(spt[k][i], spt[k][i + (1 << k)]);
		}
	}
}

int get_min_ind(int l, int r) { // [l; r)
	return min(spt[best_st[r - l]][l], spt[best_st[r - l]][r - (1 << best_st[r - l])]).second;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	vector<int> nxt(n, n);
	vector<int> mx(n + 1, 0);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	build(n, a);
	vector<pair<int, int>> vec = { {n + 1, n} };
	for (int i = n - 1; i >= 0; i--) {
		mx[i] = max(mx[i + 1], a[i]);
		while (vec.back().first <= a[i])
			vec.pop_back();
		nxt[i] = vec.back().second;
		vec.push_back({ a[i], i });
	}
	
	vector<quest> qu(m);
	vector<int> answer(m, -1);
	for (int i = 0; i < m; i++) {
		cin >> qu[i].k >> qu[i].i;
		qu[i].ind = i;
	}
	sort(qu.begin(), qu.end(), [](quest a, quest b) {
		if (a.k == b.k)
			return a.i < b.i;
		return a.k < b.k;
	});

	int k = 0, i = 0, pos = 0, ans, gr;
	for (auto q : qu) {
		if (k != q.k) {
			k = q.k;
			i = 1;
			pos = 0;
		}
		for (; i <= q.i; i++) {
			if (i == k) {
				ans = mx[pos];
				pos = n;
				continue;
			}
			gr = min(n - (k - i), nxt[pos]);
			ans = a[pos];
			if (i + 1 == k)
				pos = gr;
			else
				pos = max(get_min_ind(pos, gr + 1), pos + 1);
		}

		answer[q.ind] = ans;
	}

	for (auto x : answer)
		cout << x << '\n';
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}
