#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

unsigned long long r, rq;
int n;

struct point {
	unsigned long long x, y;
	point() {
		x = 0;
		y = 0;
	}
	pair <unsigned long long, unsigned long long> pos() {
		pair<unsigned long long, unsigned long long> ans;
		ans.first = x / r;
		ans.second = y / r;
		ans.first++;
		ans.second++;
		return ans;
	}
	bool go(point next) {
		unsigned long long it_x = x, it_y = y;
		if (it_x < next.x) {
			swap(it_x, next.x);
		}
		if (it_y < next.y) {
			swap(it_y, next.y);
		}
		it_x = it_x - next.x;
		it_y = it_y - next.y;
		unsigned long long len = it_x * it_x + it_y * it_y;
		return len <= rq;
	}
};

istream& operator>> (istream& in, point& a) {
	in >> a.x >> a.y;
	return in;
}

map <pair<unsigned long long, unsigned long long>, vector<int>> mp;
vector<point> points;
vector<bool> ans;
vector<int>numbers;
vector<int> color;

bool dfs(int p, int col) {
	numbers.push_back(p);
	color[p] = col;
	pair<unsigned long long, unsigned long long> it_pos = points[p].pos();
	if (mp[it_pos].size() >= 5) {
		color[p] = 4;
		return true;
	}
	for (int q = 0; q < 9; q++) {
		if (mp.find(it_pos) != mp.end()) {
			for (auto i : mp[it_pos]) {
				if (color[i] == 0 && points[p].go(points[i])) {
					if (dfs(i, 3 - col)) {
						color[p] = 4;
						return true;
					}
				}
				else if (points[p].go(points[i]) && ans[i]) {
					color[p] = 4;
					return true;
				}
				else if (i != p && points[p].go(points[i]) && color[i] ==  col) {
					color[p] = 4;
					return true;
				}
			}
		}
		if (q == 0) {
			it_pos.first--;
			it_pos.second--;
		}
		else if (q <= 2) {
			it_pos.first++;
		}
		else if (q <= 4) {
			it_pos.second++;
		}
		else if (q <= 6) {
			it_pos.first--;
		}
		else {
			it_pos.second--;
		}
	}
	color[p] = 4;
	return false;
}

int main()
{
	cin.tie(0);
	ios::sync_with_stdio(false);
	cin >> n >> r;
	rq = r * r;
	points.assign(n, point());
	ans.assign(n, false);
	color.assign(n, 0);
	for (int i = 0; i < n; i++) {
		cin >> points[i];
		mp[points[i].pos()].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		if (color[i] == 0) {
			if (dfs(i, 1)) {
				for (auto i : numbers) {
					ans[i] = true;
				}
			}
			numbers.clear();
		}
	}
	for (auto i : ans) {
		cout << i;
	}
}