#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <stack>

using namespace std;

struct node {
	node* left;
	node* right;
	int val;

	node (){
		left = NULL;
		right = NULL;
		val = 0;
	}

	node(bool m) {
		left = NULL;
		right = NULL;
		if (m) {
			val = 1;
		}
		else {
			val = 0;
		}
	}

	node(node* left, node* right) {
		this->left = left;
		this->right = right;
		val = left->val + right->val;
	}

	node(int l, int r) {
		val = 0;
		if (l == r - 1) {
			left = NULL;
			right = NULL;
		}
		else {
			int mid = (l + r) >> 1;
			left = new node(l, mid);
			right = new node(mid, r);
		}
	}

	node* set(int l, int r, int xl) {
		if (l == r - 1 && l == xl) {
			return new node(true);
		}
		if (l > xl || r <= xl) {
			return this;
		}
		int mid = (l + r) >> 1;
		return new node(left->set(l, mid, xl), right->set(mid, r, xl));
	}
	int get(int l, int r, int xl, int xr) {
		if (l >= xl && r <= xr) {
			return val;
		}
		if(l >= xr || r <= xl) {
			return 0;
		}
		int mid = (l + r) >> 1;
		return left->get(l, mid, xl, xr) + right->get(mid, r, xl, xr);
	}
};

vector <vector <node*>> mat;
vector <vector <long long>> dp;
vector < vector<int>> ci;

int main()
{
	cin.tie(0);
	ios::sync_with_stdio(false);
	int r, c; cin >> r >> c;
	ci.assign(r, vector<int>(c));
	dp.assign(r, vector<long long>(c, 0));
	mat.assign(r, vector<node*>(c, NULL));
	for (int i = 0; i < r; i++) {
		for (int q = 0; q < c; q++) {
			cin >> ci[i][q];
		}
	}
	mat[r - 1][c - 1] = new node(0, r * c);
	mat[r - 1][c - 1] = mat[r - 1][c - 1]->set(0, r * c, ci[r - 1][c - 1]);
	for (int i = r - 2; i >= 0; i--) {
		mat[i][c - 1] = mat[i + 1][c - 1];
		dp[i][c - 1] = dp[i + 1][c - 1] + mat[i][c - 1]->get(0, r * c, 0, ci[i][c - 1]);
		mat[i][c - 1] = mat[i][c - 1]->set(0, r * c, ci[i][c - 1]);
	}
	for (int i = c - 2; i >= 0; i--) {
		mat[r - 1][i] = mat[r - 1][i + 1];
		dp[r - 1][i] = dp[r - 1][i + 1] += mat[r - 1][i]->get(0, r * c, 0, ci[r - 1][i]);
		mat[r - 1][i] = mat[r - 1][i]->set(0, r * c, ci[r - 1][i]);
		//cout << mat[r - 1][i]->val;
	}/*
	for (auto i : dp) {
		for (auto j : i) {
			cout << j << ' ';
		}
	}*/
	cout << dp[0][0];
}