#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <stack>

using namespace std;
const int inf = 1e9;
vector<int> a;
vector<pair<int,int>> tree;
void build(int v, int l, int r) {
	if (l == r - 1) {
		tree[v] = { a[l], l };
		return;
	}
	int mid = (l + r) >> 1;
	build((v << 1) + 1, l, mid);
	build((v << 1) + 2, mid, r);
	tree[v] = min(tree[(v << 1) + 1], tree[(v << 1) + 2]);
}

pair<int, int> get(int v, int l, int r, int xl, int xr) {
	if (l >= xl && r <= xr) {
		return tree[v];
	}
	else if (l >= xr || r <= xl) {
		return { inf, inf };
	}
	else {
		int mid = (l + r) >> 1;
		return min(get((v << 1) + 1, l, mid, xl, xr), get((v << 1) + 2, mid, r, xl, xr));
	}
}

int main()
{
	cin.tie(0);
	ios::sync_with_stdio(false);
	int n, k, q, ci; cin >> n >> q;
	a.assign(n, 0);
	tree.assign(4 * n, { 0, 0 });
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector <int> next_max(n, n);
	build(0, 0, n);
	stack<pair<int, int>> st;
	for (int i = n - 1; i >= 0; i--) {
		while (st.size() != 0 && st.top().first < a[i]) {
			st.pop();
		}
		if (st.size() != 0) {
			next_max[i] = st.top().second;
		}
		st.push({ a[i], i });
	}
	map<int, vector<int>> mp;
	for (int i = 0; i < q; i++) {
		cin >> k >> ci;
		if (mp.find(k) == mp.end()) {
			vector<int> ans;
			if (k != 1) {
				ans.push_back(a[0]);
				int it = 0, cnt = k - 1;
				while (cnt > 1) {
					cnt--;
					if (next_max[it] == it + 1) {
						it = it + 1;
					}
					else {
						it = get(0, 0, n, it + 1, min(next_max[it], n - cnt)).second;
					}
					ans.push_back(a[it]);
				}
				int last = 0;
				for (int r = n - 1; r > it; r--) {
					last = max(last, a[r]);
				}
				ans.push_back(last);
			}
			else {
				int it = 0;
				for (int r = 0; r < n; r++) {
					it = max(it, a[r]);
				}
				ans.push_back(it);
			}
			mp[k] = ans;
		}
     	cout << mp[k][ci - 1] << '\n';
	}
}