#include <iostream>
#include <vector>
#include <map>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_map>
#include <queue>

using namespace std;
typedef long long ll;

const int maxn = 2e6;

int f1[maxn + 1], f2[maxn + 1];

void upd1(int v, int vl) {
	for (; v <= maxn; v += (v & -v)) {
		f1[v] += vl;
	}
}

int get1(int v) {
	int r = 0;
	for (; v > 0; v -= (v & -v)) {
		r += f1[v];
	}
	return r;
}


void upd2(int v, int vl) {
	for (; v <= maxn; v += (v & -v)) {
		f2[v] += vl;
	}
}

int get2(int v) {
	int r = 0;
	for (; v > 0; v -= (v & -v)) {
		r += f2[v];
	}
	return r;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}
	vector<vector<ll>> c1(n, vector<ll>(m)), c2(n, vector<ll>(m));
	for (ll j = 0; j < m; ++j) {
		ll cr = 0;
		for (ll i = 0; i < n; ++i) {
			cr += j * n - get1(a[i][j]);
			cr += i - get2(a[i][j]);
			upd2(a[i][j], 1);
		}
		c1[0][j] = cr;
		for (ll i = 1; i < n; ++i) {
			cr -= j * n + (i - 1) * (m - j) - get1(a[i - 1][j]);
			upd2(a[i - 1][j], -1);
			cr -= get2(a[i - 1][j]);
			for (int k = j; k < m; ++k) {
				upd1(a[i - 1][k], 1);
				cr += get2(a[i - 1][k]);
			}
			c1[i][j] = cr;
		}
		upd2(a[n - 1][j], -1);
		for (int i = 0; i < n - 1; ++i) {
			for (int k = j + 1; k < m; ++k) {
				upd1(a[i][k], -1);
			}
		}
		upd1(a[n - 1][j], 1);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			upd1(a[i][j], -1);
		}
	}
	for (ll i = 0; i < n; ++i) {
		ll cr = 0;
		for (ll j = 0; j < m; ++j) {
			cr += i * m - get1(a[i][j]);
			cr += j - get2(a[i][j]);
			upd2(a[i][j], 1);
		}
		c2[i][0] = cr;
		for (ll j = 1; j < m; ++j) {
			cr -= i * m + (j - 1) * (n - i) - get1(a[i][j - 1]);
			upd2(a[i][j - 1], -1);
			cr -= get2(a[i][j - 1]);
			for (int k = i; k < n; ++k) {
				upd1(a[k][j - 1], 1);
				cr += get2(a[k][j - 1]);
			}
			c2[i][j] = cr;
		}
		upd2(a[i][m - 1], -1);
		for (int j = 0; j < m - 1; ++j) {
			for (int k = i + 1; k < n; ++k) {
				upd1(a[k][j], -1);
			}
		}
		upd1(a[i][m - 1], 1);
	}

	vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, 1e15));
	dp[0][0] = 0;
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= m; ++j) {
			if (i == 0 && j == 0) continue;
			if (i == n && j == m) continue;
			if (i > 0 && j != m) {
				dp[i][j] = dp[i - 1][j] + c2[i - 1][j];
			}
			if (j > 0 && i != n) {
				dp[i][j] = min(dp[i][j], dp[i][j - 1] + c1[i][j - 1]);
			}
		}
	}

	ll rs = 1e15;
	for (int i = 0; i < n; ++i) {
		rs = min(rs, dp[i][m]);
	}
	for (int i = 0; i < m; ++i) {
		rs = min(rs, dp[n][i]);
	}
	cout << rs;

	return 0;
}
