#include <iostream>
#include <vector>
#include <map>
#include <cmath>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_map>
#include <queue>

using namespace std;
typedef long long ll;

const int maxn = 2e6;

int f1[maxn + 1], f2[maxn + 1];

void upd1(int v, int vl) {
	for (; v <= maxn; v += (v & -v)) {
		f1[v] += vl;
	}
}

int get1(int v) {
	int r = 0;
	for (; v > 0; v -= (v & -v)) {
		r += f1[v];
	}
	return r;
}


void upd2(int v, int vl) {
	for (; v <= maxn; v += (v & -v)) {
		f2[v] += vl;
	}
}

int get2(int v) {
	int r = 0;
	for (; v > 0; v -= (v & -v)) {
		r += f2[v];
	}
	return r;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}

	vector<ll> rs(m + 1);
	ll cr = 0;
	for (int i = 0; i < n * m; ++i) {
		upd2(i + 1, 1);
	}
	for (int i = 0; i < m; ++i) {
		cr += 2 * i - get1(a[0][i]);
		upd1(a[0][i], 1);
		cr += 2 * i + 1 - get1(a[1][i]);
		upd1(a[1][i], 1);
		upd2(a[0][i], -1);
		upd2(a[1][i], -1);
		cr += get2(a[0][i]);
		cr += get2(a[1][i]);
		rs[i + 1] = cr;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			upd1(a[i][j], -1);
		}
	}
	cr = 0;
	for (int i = m - 1; i >= 0; --i) {
		cr += get1(a[0][i]);
		cr += get2(a[0][i]);
		cr += a[0][i] > a[1][i];
		cr += get2(a[1][i]);
		cr += (m - i - 1) - get1(a[1][i]);
		upd1(a[0][i], 1);
		upd2(a[1][i], 1);
		rs[i] += cr;
	}
	cout << *min_element(rs.begin(), rs.end());

	return 0;
}
