#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n;
ll r, sz;
vector<int> good, used;
vector<vector<int>> g;

struct PT {
    ll x, y;
    PT() {}
    PT(ll _x, ll _y) { x = _x; y = _y; }
};

ll dist(PT a, PT b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

inline bool dfs(int v, int col) {
    if (good[v]) return true;
    used[v] = col;
    for (auto & u : g[v]) {
        if (used[u] == col) {
            return true;
        } else if (used[u] == 0 && dfs(u, -col)) {
            return true;
        }
    }
    return false;
}

inline void dfs2(int v) {
    good[v] = 1;
    used[v] = 100;
    for (auto & u : g[v]) {
        if (used[u] != 100) {
            dfs2(u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> r;
    vector<PT> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].x >> arr[i].y;
    }
    g.resize(n);
    good.resize(n);
    used.resize(n);
    sz = max(1ll, r);
    ll r2 = r * r;
    map<pair<int, int>, int> is;
    map<pair<int, int>, vector<int>> bl;
    for (int i = 0; i < n; ++i) {
        is[{arr[i].x / sz, arr[i].y / sz}] = 1;
        bl[{arr[i].x / sz, arr[i].y / sz}].push_back(i);
    }
    for (auto & it : bl) {
        auto [x, y] = it.first;
        auto & pt = it.second;
        if ((int)pt.size() >= 3) {
            for (auto & it : pt) {
                good[it] = 1;
            }
        } else {
            for (int i = 0; i < (int)pt.size(); ++i) {
                for (int j = 0; j < (int)pt.size(); ++j) {
                    if (i == j) continue;
                    g[pt[i]].push_back(pt[j]);
                    g[pt[j]].push_back(pt[i]);
                }
            }
            for (int dx = -1; dx <= 1; ++dx) {
                for (int dy = -1; dy <= 1; ++dy) {
                    if (dx == 0 && dy == 0) continue;
                    int nx = x + dx, ny = y + dy;
                    if (!is[{nx, ny}]) continue;
                    auto & npt = bl[{nx, ny}];
                    if (npt.size() >= 3) {
                        bool ok = 0;
                        for (int i = 0; i < (int)pt.size(); ++i) {
                            for (int j = 0; j < (int)npt.size(); ++j) {
                                if (dist(arr[pt[i]], arr[npt[j]]) <= r2) {
                                    ok = 1;
                                    break;
                                }
                            }
                        }
                        if (ok) {
                            for (auto & it : pt) {
                                good[it] = 1;
                            }
                        }
                    } else {
                        for (int i = 0; i < (int)pt.size(); ++i) {
                            for (int j = 0; j < (int)npt.size(); ++j) {
                                if (dist(arr[pt[i]], arr[npt[j]]) <= r2) {
                                    g[pt[i]].push_back(npt[j]);
                                    //      
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && dfs(i, 1)) {
            dfs2(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << good[i];
    }
    return 0;
}
