#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// TODO:
// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

mt19937 rnd(998244353);

struct Point
{
    int x, y;
};

struct Tree
{
    int sz;
    // coord -> id
    vector<vector<pii>> tree;

    void build(int v, int l, int r, const vector<vector<pii>> &arr)
    {
        if (l == r - 1)
        {
            tree[v] = arr[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m, arr);
        build(v * 2 + 2, m, r, arr);
        tree[v].resize(tree[v * 2 + 1].size() + tree[v * 2 + 2].size());
        merge(all(tree[v * 2 + 1]), all(tree[v * 2 + 2]), tree[v].begin());
    }

    void build(const vector<vector<pii>> &arr)
    {
        sz = arr.size();
        int k = 1;
        while (k < sz * 2)
        {
            k *= 2;
        }
        tree.resize(k + 1);
        build(0, 0, sz, arr);
    }

    void get(int v, int l, int r, int L, int R, int a, int b, vector<int> &res)
    {
        if (R <= l || r <= L)
            return;
        if (L <= l && r <= R)
        {
            auto it = lower_bound(all(tree[v]), make_pair(a, 0));
            while (it != tree[v].end())
            {
                if (it->first > b)
                    break;
                res.push_back(it->second);
                ++it;
            }
            return;
        }
        int m = (l + r) / 2;
        get(v * 2 + 1, l, m, L, R, a, b, res);
        get(v * 2 + 2, m, r, L, R, a, b, res);
    }

    void get(int L, int R, int a, int b, vector<int> &res)
    {
        get(0, 0, sz, L, R, a, b, res);
    }
};

void solve()
{
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> arr(n);
    vector<int> unzip;
    map<int, int> zip;
    vector<bool> used0(n);
    vector<bool> used1(n);
    vector<bool> ans(n);

    auto adj = [&](const int &a, const int &b) -> bool
    {
        ll x1 = unzip[arr[a].x];
        ll x2 = unzip[arr[b].x];
        ll dx = abs(x1 - x2);
        ll dy = abs(arr[a].y - arr[b].y);
        return dx * dx + dy * dy <= r * r;
    };

    unzip.reserve(n);

    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i].x >> arr[i].y;
        unzip.push_back(arr[i].x);
    }

    sort(all(unzip));
    unzip.resize(unique(all(unzip)) - unzip.begin());

    for (int i = 0; i < unzip.size(); ++i)
        zip[unzip[i]] = i;

    vector<vector<pii>> cols(unzip.size());

    for (int i = 0; i < n; ++i)
    {
        arr[i].x = zip[arr[i].x];
        cols[arr[i].x].push_back({arr[i].y, i});
    }

    for (int i = 0; i < unzip.size(); ++i)
    {
        sort(all(cols[i]));
    }

    Tree t0, t1;

    t0.build(cols);
    t1.build(cols);

    vector<int> per(n);
    iota(per.begin(), per.end(), 0);

    shuffle(all(per), rnd);

    for (int i = 0; i < n; ++i)
    {
        if (used0[i] && used1[i])
        {
            cout << 1;
        }
        else
        {
            cout << 0;
        }
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}