#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif
#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

struct Point
{
    int x, y;
};

int n;

vector<bool> solve_g(const vector<vector<int>> &g)
{
    vector<bool> used0(n, false);
    vector<bool> used1(n, false);

    queue<pii> q;

    for (int i = 0; i < n; ++i)
    {
        if (used0[i] || used1[i])
            continue;
        used0[i] = true;
        q.push({0, i});

        while (!q.empty())
        {
            const auto &[type, v] = q.front();
            q.pop();
            if (type == 0)
            {
                for (const auto &u : g[v])
                {
                    if (u == v || used1[u])
                        continue;
                    used1[u] = true;
                    q.push({1, u});
                }
            }
            else
            {
                for (const auto &u : g[v])
                {
                    if (u == v || used0[u])
                        continue;
                    used0[u] = true;
                    q.push({0, u});
                }
            }
        }
    }

    vector<bool> res(n);
    for (int i = 0; i < n; ++i)
    {
        res[i] = used0[i] && used1[i];
    }

    return res;
}

void solve()
{
    int r;
    cin >> n >> r;
    vector<Point> arr(n);
    unordered_map<int, unordered_map<int, int>> ma;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i].x >> arr[i].y;
        ma[arr[i].x][arr[i].y] = i;
    }

    for (int i = 0; i < n; ++i)
    {
        // TODO:
        for (int a = arr[i].x; a <= arr[i].x + r; ++a)
        {
            for (int b = arr[i].y - r; b <= arr[i].y + r; ++b)
            {
                int dx = abs(a - arr[i].x);
                int dy = abs(b - arr[i].y);
                int sq = dx * dx + dy * dy;
                if (sq > r * r)
                    continue;
                if (!ma.count(a) || !ma[a].count(b))
                    continue;
                int j = ma[a][b];
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    auto res = solve_g(g);

    for (int i = 0; i < n; ++i)
    {
        cout << res[i];
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}