#ifdef ROMALOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

// TODO:
// #define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

mt19937 rnd(998244353);

struct Point
{
    int x, y;
};

struct Tree
{
    int sz;
    // coord -> id
    vector<set<pii>> tree;

    void build(const int &_sz)
    {
        sz = _sz;
        tree.resize(sz * 4);
    }

    void insert(int v, int l, int r, int i, int x, int id)
    {
        tree[v].insert({x, id});
        if (l == r - 1)
        {
            assert(l == i);
            return;
        }
        int m = (l + r) / 2;
        if (i < m)
        {
            insert(v * 2 + 1, l, m, i, x, id);
        }
        else
        {
            insert(v * 2 + 2, m, r, i, x, id);
        }
    }

    void insert(int i, int x, int id)
    {
        insert(0, 0, sz, i, x, id);
    }

    void erase(int v, int l, int r, int i, int x, int id)
    {
        // TODO:
        assert(tree[v].count({x, id}));
        tree[v].erase(tree[v].find({x, id}));
        if (l == r - 1)
        {
            assert(l == i);
            return;
        }
        int m = (l + r) / 2;
        if (i < m)
        {
            erase(v * 2 + 1, l, m, i, x, id);
        }
        else
        {
            erase(v * 2 + 2, m, r, i, x, id);
        }
    }

    void erase(int i, int x, int id)
    {
        erase(0, 0, sz, i, x, id);
    }

    void get(int v, int l, int r, int L, int R, int a, int b, vector<int> &res)
    {
        if (R <= l || r <= L)
            return;
        if (L <= l && r <= R)
        {
            auto it = tree[v].lower_bound({a, 0});
            while (it != tree[v].end())
            {
                if (it->first > b)
                    break;
                res.push_back(it->second);
                ++it;
            }
            return;
        }
        int m = (l + r) / 2;
        get(v * 2 + 1, l, m, L, R, a, b, res);
        get(v * 2 + 2, m, r, L, R, a, b, res);
    }

    void get(int L, int R, int a, int b, vector<int> &res)
    {
        get(0, 0, sz, L, R, a, b, res);
    }
};

void solve()
{
    int n;
    ll r;
    cin >> n >> r;
    vector<Point> arr(n);
    vector<int> unzip;
    unordered_map<int, int> zip;
    vector<bool> used0(n);
    vector<bool> used1(n);
    vector<bool> ans(n);

    auto adj = [&](const int &a, const int &b) -> bool
    {
        ll x1 = unzip[arr[a].x];
        ll x2 = unzip[arr[b].x];
        ll dx = abs(x1 - x2);
        ll dy = abs(arr[a].y - arr[b].y);
        return dx * dx + dy * dy <= r * r;
    };

    // unzip.reserve(n * 3);

    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i].x >> arr[i].y;
        unzip.push_back(arr[i].x);
        unzip.push_back(arr[i].x - r);
        unzip.push_back(arr[i].x + r);
    }

    sort(all(unzip));
    unzip.resize(unique(all(unzip)) - unzip.begin());

    for (int i = 0; i < unzip.size(); ++i)
        zip[unzip[i]] = i;

    Tree t0, t1;
    t0.build(unzip.size());
    t1.build(unzip.size());

    for (int i = 0; i < n; ++i)
    {
        arr[i].x = zip[arr[i].x];
        t0.insert(arr[i].x, arr[i].y, i);
        t1.insert(arr[i].x, arr[i].y, i);
    }

    vector<int> per(n);
    iota(per.begin(), per.end(), 0);

    shuffle(all(per), rnd);

    for (const auto &root : per)
    {
        if (used0[root] || used1[root])
            continue;

        queue<pair<int, int>> q;
        q.push({0, root});
        t0.erase(arr[root].x, arr[root].y, root);

        while (!q.empty())
        {
            const auto [type, v] = q.front();
            q.pop();

            vector<int> g;
            int X = unzip[arr[v].x];
            int L = zip[X - r];
            int R = zip[X + r];
            int a = arr[v].y - r;
            int b = arr[v].y + r;

            if (type == 0)
            {
                used0[v] = true;
                t1.get(L, R + 1, a, b, g);

                for (const auto &u : g)
                {
                    if (!adj(v, u) || v == u)
                        continue;
                    // cout << v << " " << u << endl;
                    t1.erase(arr[u].x, arr[u].y, u);
                    q.push({1, u});
                }
            }
            else
            {
                used1[v] = true;
                t0.get(L, R + 1, a, b, g);

                for (const auto &u : g)
                {
                    if (!adj(v, u) || v == u)
                        continue;
                    // cout << v << " " << u << endl;
                    t0.erase(arr[u].x, arr[u].y, u);
                    q.push({0, u});
                }
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        if (used0[i] && used1[i])
        {
            cout << 1;
        }
        else
        {
            cout << 0;
        }
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}