#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

struct Point
{
    int x, y;
};

ll dist(const Point &a, const Point &b)
{
    return ((a.x - b.x) * (a.x - b.x)) + ((a.y - b.y) * (a.y - b.y));
}

vector<vector<int>> g;
vector<int> used;
int f;

void dfs(int u, int color){
    used[u] = color;
    for(auto v : g[u])
        if(!used[v])
            dfs(v, 2 - ((color + 1) % 2));
        else if(used[v] == color)
            f = 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, r;
    cin >> n >> r;
    vector<Point> points(n);
    g.resize(n);
    for (Point &i : points)
        cin >> i.x >> i.y;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if(i == j)
                continue;
            if (dist(points[i], points[j]) <= 1ll * r * r)
                g[i].push_back(j);
        }
    }
    vector<int> ans(n);
    for(int i = 0; i < n; i++){
        used.assign(n, 0);
        f = 0;
        dfs(i, 1);
        ans[i] = f;
    }
    for(int i : ans) cout << i;
    return 0;
}