#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

struct Point
{
    int x, y;
};

ll dist(const Point &a, const Point &b)
{
    return (1ll * (a.x - b.x) * (a.x - b.x)) + (1ll * (a.y - b.y) * (a.y - b.y));
}

vector<vector<int>> g;
vector<int> used, ans, used1;
int f;

void dfs(int u, int color)
{
    used[u] = color;
    for (int v : g[u])
    {
        if (f)
            break;
        if (!used[v])
            dfs(v, 2 - ((color + 1) % 2));
        else if (used[v] == color)
            f = 1;
    }
}

void dfs1(int u, int color)
{
    used1[u] = 1;
    ans[u] = color;
    for (int v : g[u])
        if (!used1[v])
            dfs1(v, color);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, r;
    cin >> n >> r;
    vector<Point> a(n);
    g.resize(n);
    map<pair<int, int>, int> mp;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].x >> a[i].y;
        mp[{a[i].x, a[i].y}] = i + 1;
    }
    for (int i = 0; i < n; i++)
    {
        auto [x, y] = a[i];
        for (int dx = -2; dx < 3; dx++)
        {
            for (int dy = -2; dy < 3; dy++)
            {
                if ((dx == 0 && dy == 0) || (dx * dx + dy * dy > r * r))
                    continue;
                int nowi = mp[{x + dx, y + dy}];
                if (nowi)
                    g[i].push_back(nowi - 1);
            }
        }
    }
    ans.resize(n);
    used.resize(n);
    used1.resize(n);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            f = 0;
            dfs(i, 1);
            dfs1(i, f);
        }
    }
    for (int i : ans)
        cout << i;
    return 0;
}