#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

struct Point
{
    int x, y;
};

ll dist(const Point &a, const Point &b)
{
    return (1ll * (a.x - b.x) * (a.x - b.x)) + (1ll * (a.y - b.y) * (a.y - b.y));
}

vector<vector<int>> g;
vector<int> used, ans, used1;
int f;

void dfs(int u, int color)
{
    used[u] = color;
    for (int v : g[u])
    {
        if (f)
            break;
        if (!used[v])
            dfs(v, 2 - ((color + 1) % 2));
        else if (used[v] == color)
            f = 1;
    }
}

void dfs1(int u, int color)
{
    used1[u] = 1;
    ans[u] = color;
    for (int v : g[u])
        if (!used1[v])
            dfs1(v, color);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, r;
    cin >> n >> r;
    vector<Point> a(n);
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].x >> a[i].y;
        v[i] = {a[i].x, i};
    }
    if (n == 2)
    {
        cout << "00";
        return 0;
    }
    sort(v.begin(), v.end());
    vector<int> ans(n);
    for (int i = 2; i < n; i++)
    {
        auto [x1, i1] = v[i - 2];
        auto [x2, i2] = v[i - 1];
        auto [x3, i3] = v[i];
        if (x3 - x1 <= r)
        {
            ans[i1] = ans[i2] = ans[i3] = 1;
            while (i + 1 < n)
            {
                if (v[i + 1].first - v[i].first <= r)
                {
                    ans[v[i + 1].second] = 1;
                    i++;
                }
                else
                    break;
            }
        }
    }
    for(int i : ans) cout << i;
    return 0;
}