#include <iostream>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef short int si;

struct Point
{
    int x, y;
};

ll dist(const Point &a, const Point &b)
{
    return (1ll * (a.x - b.x) * (a.x - b.x)) + (1ll * (a.y - b.y) * (a.y - b.y));
}

vector<vector<si>> g;
vector<si> used, ans;
int f;

void dfs(int u, int color)
{
    used[u] = color;
    for (int v : g[u])
    {
        if (ans[v])
            f = 1;
        if (f)
            break;
        if (!used[v])
            dfs(v, 2 - ((color + 1) % 2));
        else if (used[v] == color)
            f = 1;
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for(int & i : a)
        cin >> i;
    vector<int> pref(n), suf(n);
    int l = 1e9, r = 1e9;
    pref[0] = a[0];
    suf[n - 1] = a[n - 1];
    for(int i = 1; i < n; i++)
        pref[i] = max(pref[i - 1], a[i]);
    for (int i = n - 2; i >= 0; i--)
        suf[i] = max(suf[i + 1], a[i]);
    for(int i = 1; i < n; i++){
        int _l = pref[i - 1], _r = suf[i - 1];
        if(_l <= l){
            l = _l;
            r = _r;
        }
        else if(l == _l && _r < r){
            l = _l;
            r = _r;
        }  
    }
    while(q--){
        int k, i;
        cin >> k >> i;
        if(i == 1)
            cout << l << '\n';
        else
            cout << r << '\n';
    }
    return 0;
}