#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll int

using namespace std;
using namespace __gnu_pbds;

struct point {
    int x, y;

    ll dist(point other) {
        return pow(x - other.x, 2) + pow(y - other.y, 2);
    }
};

const int N = 1e5;

bool flag;
int color[N];
vector<int> g[N], all;
point a[N];

void dfs(int v, int col) {
    color[v] = col;
    all.push_back(v);

    col = (col + 1) % 2;
    col = 2 - col;

    for (int u: g[v]) {
        if (color[u] == col) continue;

        if (!color[u]) {
            dfs(u, col);
        } else {
            flag = true;
        }
    }
}

int lb(ll x, ll y, ll val, vector<pair<int, int>> &a, bool flag) {
    int l = 0, r = a.size(), m;

    if (!flag) {
        --l, --r;
    }

    while (r - l > 1) {
        m = (l + r) / 2;

        int d = a[m].first - y;
        if (flag) {
            if (d < 0 || (d <= val && d * d + x * x <= val * val)) {
                l = m;
            } else {
                r = m;
            }
        } else {
            if (d > 0 || (-d <= val && d * d + x * x <= val * val)) {
                r = m;
            } else {
                l = m;
            }
        }
    }

    if (!flag) return r;

    return l;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n;
    ll r;
    cin >> n >> r;

    gp_hash_table<int, vector<pair<int, int>>> mp;

    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        mp[x].emplace_back(y, i);

        a[i] = {x, y};
    }

    for (auto& [tmp, arr] : mp) {
        sort(arr.begin(), arr.end());
    }

    for (int i = 0; i < n; ++i) {
        for (int x = 0; x <= r; ++x) {
            if (mp[a[i].x + x].empty()) continue;

            int ql = lb(x, a[i].y, r, mp[a[i].x + x], false);
            int qr = lb(x, a[i].y, r, mp[a[i].x + x], true);

            for (int j = max(0, ql); j <= min((int)mp[a[i].x + x].size() - 1, qr); ++j) {
                if (!x && mp[a[i].x + x][j].second == i || a[i].dist(a[mp[a[i].x + x][j].second]) > r * r) continue;

                g[i].push_back(mp[a[i].x + x][j].second);
                g[mp[a[i].x + x][j].second].push_back(i);
            }
        }
    }

    string ans(n, '0');

    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }

    random_shuffle(p.begin(), p.end());

    for (int i : p) {
        if (!color[i]) {
            flag = false;

            all.clear();
            dfs(i, 1);

            if (flag) {
                for (int j: all) {
                    ans[j] = '1';
                }
            }
        }
    }

    cout << ans;
}