#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct seg_tr {
    vector<int> tr;

    void init(int n) {
        tr.assign(n + 1, 0);
    }

    int query(int l) {
        int ans = 0;

        for (int i = l; i > 0; i -= i & -i) {
            ans += tr[i];
        }

        return ans;
    }

    void update(int l) {
        for (int i = l; i < tr.size(); i += i & -i) {
            tr[i]++;
        }
    }

    int query(int l, int r) {
        return query(r) - query(l - 1);
    }
};

int c, r;
vector<pair<int, int>> tmp_arr;
vector<int> arr1;
 
ll cnt(vector<int>&cur) {
    for (int i = 0; i < cur.size(); ++i) {
        tmp_arr.push_back({cur[i], i});
    }
 
    sort(tmp_arr.begin(), tmp_arr.end());
 
    arr1.resize(cur.size());
    for (int i = 0; i < cur.size(); ++i) {
        arr1[tmp_arr[i].second] = i + 1;
    }
 
    seg_tr tr;
    tr.init(arr1.size() + 1);
    ll ans = 0;
 
    for (int el : arr1) {
        ans += tr.query(el + 1, arr1.size());
        tr.update(el);
    }
 
    arr1.clear();
    tmp_arr.clear();
 
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> r >> c;

    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    if (min(c, r) == 1) {
        vector<int> cur;
        for (int i = 0; i < max(r, c); ++i) {
            if (c == 1) {
                cur.push_back(a[i][0]);
            } else {
                cur.push_back(a[0][i]);
            }
        }

        cout << cnt(cur);
        return 0;
    }

    vector<vector<ll>> val(r + 1, vector<ll>(c + 1, LLONG_MAX));

    val[0][0] = 0;
    for (int i = 0; i < r; ++i) {
        ordered_set st;

        for (int x = i; x < r; ++x) {
            for (int y = 0; y < c; ++y) {
                st.insert(a[x][y]);
            }
        }

        for (int j = 0; j < c; ++j) {
            if (val[i][j] == LLONG_MAX) continue;

            ll cur = val[i][j];

            for (int y = j; y < c; ++y) {
                cur += a[i][y] - (st.size() - st.order_of_key(a[i][y]));
                st.erase(a[i][y]);
            }

            val[i + 1][j] = min(cur, val[i + 1][j]);

            for (int y = j; y < c; ++y) {
                st.insert(a[i][y]);
            }

            cur = val[i][j];
            for (int x = i; x < r; ++x) {
                cur += a[x][j] - (st.size() - st.order_of_key(a[x][j]));
                st.erase(a[x][j]);
            }

            val[i][j + 1] = min(cur, val[i][j + 1]);

            for (int x = i; x < r; ++x) {
                st.erase(a[x][j]);
            }
        }
    }

    ll ans = LLONG_MAX;
    for (int i = 0; i < max(r, c); ++i) {
        if (i < c) {
            ans = min(ans, val[r][i]);
        }

        if (i < r) {
            ans = min(ans, val[i][c]);
        }
    }

    cout << ans;
}