#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct seg_tr {
    vector<int> tr;

    void init(int n) {
        tr.assign(n + 1, 0);
    }

    int query(int l) {
        int ans = 0;

        for (int i = l; i > 0; i -= i & -i) {
            ans += tr[i];
        }

        return ans;
    }

    void update(int l, int val = 1) {
        for (int i = l; i < tr.size(); i += i & -i) {
            tr[i] += val;
        }
    }

    int query(int l, int r) {
        return query(r) - query(l - 1);
    }
};

int c, r;
vector<pair<int, int>> tmp_arr;
vector<int> arr1;

ll cnt(vector<int>&cur) {
    for (int i = 0; i < cur.size(); ++i) {
        tmp_arr.push_back({cur[i], i});
    }

    sort(tmp_arr.begin(), tmp_arr.end());

    arr1.resize(cur.size());
    for (int i = 0; i < cur.size(); ++i) {
        arr1[tmp_arr[i].second] = i + 1;
    }

    seg_tr tr;
    tr.init(arr1.size() + 1);
    ll ans = 0;

    for (int el : arr1) {
        ans += tr.query(el + 1, arr1.size());
        tr.update(el);
    }

    arr1.clear();
    tmp_arr.clear();

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> r >> c;

    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    if (min(c, r) == 1) {
        vector<int> cur;
        for (int i = 0; i < max(r, c); ++i) {
            if (c == 1) {
                cur.push_back(a[i][0]);
            } else {
                cur.push_back(a[0][i]);
            }
        }

        cout << cnt(cur);
        return 0;
    }


    seg_tr st; st.init(r * c + 1);

    ll ans = 0;
    int i = 0, j = 0;
    while (i + 1 < r && j + 1 < c) {
        if (a[i][c - 1] < a[r - 1][j]) {
            for (int y = j; y < c; ++y) {
                st.update(a[i][y]);
                ans += a[i][y] - st.query(1, a[i][y]);
            }

            ++i;
        } else {
            for (int x = i; x < r; ++x) {
                st.update(a[x][j]);
                ans += a[x][j] - st.query(1, a[x][j]);
            }

            ++j;
        }
    }

    if (i + 1 == r) {
        for (int y = j; y < c; ++y) {
            st.update(a[i][y]);
            ans += a[i][y] - st.query(1, a[i][y]);
        }
    } else {
        for (int x = i; x < r; ++x) {
            st.update(a[x][j]);
            ans += a[x][j] - st.query(1, a[x][j]);
        }
    }

    cout << ans;
}