#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct seg_tree {
    vector<int> tree;

    void init(int n) {
        tree.assign(n + 1, 0);
    }

    int query(int l) {
        int ans = 0;

        for (int i = l; i > 0; i -= i & -i) {
            ans += tree[i];
        }

        return ans;
    }

    void update(int l) {
        for (int i = l; i < tree.size(); i += i & -i) {
            tree[i]++;
        }
    }

    int query(int l, int r) {
        return query(r) - query(l - 1);
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int r, c; cin >> r >> c;

    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    if (min(c, r) == 1) {
        seg_tree tree;

        vector<int> cur;
        for (int i = 0; i < max(r, c); ++i) {
            if (c == 1) {
                cur.push_back(a[i][0]);
            } else {
                cur.push_back(a[0][i]);
            }
        }

        tree.init(c * r + 1);
        ll ans = 0;

        for (int el : cur) {
            ans += tree.query(el + 1, c * r);
            tree.update(el);
        }

        cout << ans;
        return 0;
    }

    int ans = 2e9;
    for (int mask = 0; mask < (1 << (r + c)); ++mask) {
        int i = 0, j = 0, tmp = mask;

        vector<int> cur;
        while (i != r && j != c) {
            if (tmp % 2) {
                for (int x = i; x < r; ++x) {
                    cur.push_back(a[x][j]);
                }

                ++j;
            } else {
                for (int x = j; x < c; ++x) {
                    cur.push_back(a[i][x]);
                }

                ++i;
            }

            tmp /= 2;
        }

        int cnt = 0;
        for (i = 0; i < cur.size(); ++i) {
            for (j = 0; j < i; ++j) {
                if (cur[j] > cur[i]) {
                    ++cnt;
                }
            }
        }

        ans = min(ans, cnt);
    }

    cout << ans;
}