#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct seg_tree {
    vector<int> tree;

    void init(int n) {
        tree.assign(n + 1, 0);
    }

    int query(int l) {
        int ans = 0;

        for (int i = l; i > 0; i -= i & -i) {
            ans += tree[i];
        }

        return ans;
    }

    void update(int l) {
        for (int i = l; i < tree.size(); i += i & -i) {
            tree[i]++;
        }
    }

    int query(int l, int r) {
        return query(r) - query(l - 1);
    }
};

int c, r;
ll cnt(vector<int>&cur) {
    seg_tree tree;
    tree.init(c * r + 1);
    ll ans = 0;

    for (int el : cur) {
        ans += tree.query(el + 1, c * r);
        tree.update(el);
    }

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> r >> c;

    vector<vector<int>> a(r, vector<int>(c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> a[i][j];
        }
    }

    if (min(c, r) == 1) {
        vector<int> cur;
        for (int i = 0; i < max(r, c); ++i) {
            if (c == 1) {
                cur.push_back(a[i][0]);
            } else {
                cur.push_back(a[0][i]);
            }
        }

        cout << cnt(cur);
        return 0;
    }

    int i = 0, j = 0;

    vector<int> cur;
    while (i != r && j != c) {
        if (j + 1 == c || (i + 1 != r && a[i + 1][j] > a[i][j + 1])) {
            for (int x = i; x < r; ++x) {
                cur.push_back(a[x][j]);
            }

            ++j;
        } else {
            for (int x = j; x < c; ++x) {
                cur.push_back(a[i][x]);
            }

            ++i;
        }
    }

    cout << cnt(cur);
}