#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

bool check(vector<int> &a, vector<int> &b) {
    for (int i = 0; i < min(a.size(), b.size()); ++i) {
        if (a[i] != b[i]) return a[i] < b[i];
    }

    return a.size() < b.size();
}

struct find_max{
    vector<int> a, tree;

    void init(int n, int l, int r) {
        if (r - l == 1) {
            tree[n] = a[l];
            return;
        }

        int m = (l + r) / 2;
        init(2 * n + 1, l,m);
        init(2 * n + 2, m, r);
        tree[n] = max(tree[2 * n + 1], tree[2 * n + 2]);
    }

    void init(vector<int> arr) {
        swap(arr, a);
        tree.resize(4 * a.size());
        init(0, 0, a.size());
    }

    int query(int n, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return 0;
        if (ql <= l && r <= qr) return tree[n];

        int m = (l + r) / 2;
        return max(query(2 * n + 1, l, m, ql, qr), query(2 * n + 2, m, r, ql, qr));
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, q; cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    find_max spt;
    spt.init(a);

    vector<vector<pair<int, int>>> qry(n + 1);
    for (int i = 0; i < q; ++i) {
        int k, j; cin >> k >> j;
        qry[k].emplace_back(j - 1, i);
    }

    vector<int> ans(q);
    for (int k = 1; k <= n; ++k) {
        if (qry[k].empty()) continue;

        vector<int> cur = {a[0]};

        int sz = 1;
        for (int i = 1; i < n; ++i) {
            int val = cur[sz - 1];

            vector<int> best = cur; best.push_back(a[i]);
            for (int j = sz - 1; j >= 1; --j) {
                if (j + n - i < k) break;

                val = max(cur[j - 1], val);

                cur.pop_back();
                --sz;

                cur[sz - 1] = val;

                cur.push_back(a[i]);
                if (check(cur, best)) {
                    best = cur;
                }

                cur.pop_back();
            }

            cur = best;
            sz = cur.size();

            if (sz > k) {
                cur.pop_back();
                cur.back() = max(cur.back(), a[i]);
                --sz;
            }
        }

        for (auto [i, j] : qry[k]) {
            ans[j] = cur[i];
        }
    }

    for (auto el : ans) cout << el << "\n";
}