#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

bool check(vector<int> &a, vector<int> &b) {
    for (int i = 0; i < min(a.size(), b.size()); ++i) {
        if (a[i] != b[i]) return a[i] < b[i];
    }

    return a.size() < b.size();
}

struct find_max{
    vector<int> a, tree;

    void init(int n, int l, int r) {
        if (r - l == 1) {
            tree[n] = a[l];
            return;
        }

        int m = (l + r) / 2;
        init(2 * n + 1, l,m);
        init(2 * n + 2, m, r);
        tree[n] = max(tree[2 * n + 1], tree[2 * n + 2]);
    }

    void init(vector<int> arr) {
        swap(arr, a);
        tree.resize(4 * a.size());
        init(0, 0, a.size());
    }

    int query(int n, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return 0;
        if (ql <= l && r <= qr) return tree[n];

        int m = (l + r) / 2;
        return max(query(2 * n + 1, l, m, ql, qr), query(2 * n + 2, m, r, ql, qr));
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, q; cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    find_max spt;
    spt.init(a);

    vector<vector<pair<int, int>>> qry(n + 1);
    for (int i = 0; i < q; ++i) {
        int k, j; cin >> k >> j;
        qry[k].emplace_back(j - 1, i);
    }

    vector<int> ans(q);
    for (int k = 1; k <= n; ++k) {
        if (qry[k].empty()) continue;

        for (auto [i, j] : qry[k]) {
            if (k == 1) {
                ans[j] = n;
                continue;
            }

            if (i < k - 2) {
                ans[j] = a[i];
            } else if (a[k - 2] < a[k - 1]) {
                if (i == k - 2) {
                    ans[j] = a[i];
                } else {
                    ans[j] = spt.query(0, 0, n, i, n);
                }
            } else {
                if (i == k - 2) {
                    ans[j] = spt.query(0, 0, n, i, n - 1);
                } else {
                    ans[j] = a[n - 1];
                }
            }
        }
    }

    for (auto el : ans) cout << el << "\n";
}