#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

bool check(vector<int> &a, vector<int> &b) {
    for (int i = 0; i < min(a.size(), b.size()); ++i) {
        if (a[i] != b[i]) return a[i] < b[i];
    }

    return a.size() < b.size();
}

struct find_max{
    vector<int> a, tree;

    void init(int n, int l, int r) {
        if (r - l == 1) {
            tree[n] = a[l];
            return;
        }

        int m = (l + r) / 2;
        init(2 * n + 1, l,m);
        init(2 * n + 2, m, r);
        tree[n] = max(tree[2 * n + 1], tree[2 * n + 2]);
    }

    void init(vector<int> arr) {
        swap(arr, a);
        tree.resize(4 * a.size());
        init(0, 0, a.size());
    }

    int query(int n, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return 0;
        if (ql <= l && r <= qr) return tree[n];

        int m = (l + r) / 2;
        return max(query(2 * n + 1, l, m, ql, qr), query(2 * n + 2, m, r, ql, qr));
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, q; cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    find_max spt;
    spt.init(a);

    vector<vector<pair<int, int>>> qry(n + 1);
    for (int i = 0; i < q; ++i) {
        int k, j; cin >> k >> j;
        qry[k].emplace_back(j - 1, i);
    }

    vector<int> ans(q);
    for (int k = 1; k <= n; ++k) {
        if (qry[k].empty()) continue;

        sort(qry[k].begin(), qry[k].end());

        if (k == 2) {
            vector<int> best = {n, n};

            for (int i = 0; i < n - 1; ++i) {
                vector<int> cur;
                cur.push_back(spt.query(0, 0, n, 0, i + 1));
                cur.push_back(spt.query(0, 0, n, i + 1, n));

                if (check(cur, best)) {
                    swap(cur, best);
                }
            }

            for (auto [i, j] : qry[k]) {
                ans[j] = best[i];
            }

            continue;
        }

        vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(k + 1));
        vector<vector<bool>> can(n + 1, vector<bool>(k + 1, false));

        can[0][0] = true;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < k; ++j) {
                if (!can[i][j]) continue;

                int val = 0;
                for (int i1 = i; i1 < n; ++i1) {
                    val = max(val, a[i1]);

                    dp[i][j].push_back(val);
                    if (!can[i1 + 1][j + 1] || check(dp[i][j], dp[i1 + 1][j + 1])) {
                        can[i1 + 1][j + 1] = true;
                        dp[i1 + 1][j + 1] = dp[i][j];
                    }

                    dp[i][j].pop_back();
                }
            }
        }

        for (auto [i, j] : qry[k]) {
            ans[j] = dp[n][k][i];
        }
    }

    for (auto el : ans) cout << el << "\n";
}