#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct point {
	int x, y;
	point(int x = 0, int y = 0) {
		this->x = x;
		this->y = y;
	}
};

long long r2;

long long dist2(point a, point b) {
	return (long long)(a.x - b.x) * (a.x - b.x) + (long long)(a.y - b.y) * (a.y - b.y);
}

bool conect(point a, point b) {
	return (dist2(a, b) <= r2);
}

vector<vector<int>> g;
vector<int> comp;
vector<bool> tipcomp;
int cnt = 0;

void build(int v) {
	comp[v] = cnt;
	for (auto u : g[v]) {
		if (comp[u] == -1) {
			build(u);
		}
	}
}

vector<int> high;
int hi = 1;

bool check(int v) {
	high[v] = hi;
	bool ans = false;
	for (auto u : g[v]) {
		if (high[u] == 0) {
			hi++;
			ans |= check(u);
			hi--;
		}
		else if (high[u] % 2 == high[v] % 2) {
			ans = true;
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, r;
	cin >> n >> r;
	r2 = (long long)r * r;
	vector<point> v(n);
	g.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].x >> v[i].y;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) {
				continue;
			}
			if (conect(v[i], v[j])) {
				g[i].push_back(j);
			}
		}
	}
	v = {};
	comp.resize(n, -1);
	for (int i = 0; i < n; i++) {
		if (comp[i] == -1) {
			build(i);
			cnt++;
		}
	}
	high.resize(n, 0);
	tipcomp.resize(cnt);
	for (int i = 0; i < n; i++) {
		if (high[i] == 0) {
			hi = 1;
			tipcomp[comp[i]] = check(i);
		}
	}
	for (int i = 0; i < n; i++) {
		cout << tipcomp[comp[i]];
	}
}