#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct point {
	int x, y;
	point(int x = 0, int y = 0) {
		this->x = x;
		this->y = y;
	}
};

long long r2;

long long dist2(point a, point b) {
	return (long long)(a.x - b.x) * (a.x - b.x) + (long long)(a.y - b.y) * (a.y - b.y);
}

bool conect(point a, point b) {
	return (dist2(a, b) <= r2);
}

bool cmp(pair<point, long long> a, pair<point, long long> b) {
	return (a.first.x < b.first.x);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, r;
	cin >> n >> r;
	r2 = (long long)r * r;
	vector<pair<point, long long>> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].first.x >> v[i].first.y;
		v[i].second = i;
	}
	sort(v.begin(), v.end(), cmp);
	vector<bool> cool(n);
	vector<bool> get_cool(n);
	for (long long i = 0; i + 2 < n; i++) {
		if (conect(v[i].first, v[i + 1].first) && conect(v[i].first, v[i + 2].first)) {
			cool[i] = true;
			cool[i + 1] = true;
			cool[i + 2] = true;
			get_cool[i] = true;
			get_cool[i + 1] = true;
			get_cool[i + 2] = true;
		}
	}
	for (long long i = 1; i < n; i++) {
		if (get_cool[i - 1] && conect(v[i].first, v[i - 1].first)) {
			get_cool[i] = true;
		}
	}
	for (long long i = n - 2; i >= 0; i--) {
		if (get_cool[i + 1] && conect(v[i].first, v[i + 1].first)) {
			get_cool[i] = true;
		}
	}
	vector<bool> ans(n);
	for (long long i = 0; i < n; i++) {
		ans[v[i].second] = get_cool[i];
	}
	for (auto ch : ans) {
		cout << ch;
	}
}