#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector<long long> tree;

void add(long long i, long long l, long long r, long long qi) {
	if (r <= qi || qi < l) {
		return;
	}
	if (l + 1 == r) {
		tree[i]++;
		return;
	}
	long long mid = (l + r) / 2;
	add(2 * i + 1, l, mid, qi);
	add(2 * i + 2, mid, r, qi);
	tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

long long get_sum(long long i, long long l, long long r, long long ql, long long qr) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree[i];
	}
	long long mid = (l + r) / 2;
	return get_sum(2 * i + 1, l, mid, ql, qr) + get_sum(2 * i + 2, mid, r, ql, qr);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long r, c;
	cin >> r >> c;
	long long n = c;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++) {
		cin >> v[i];
		v[i]--;
	}
	tree.resize(4 * n);
	long long ans = 0;
	for (long long i = 0; i < n; i++) {
		ans += get_sum(0, 0, n, v[i] + 1, n);
		add(0, 0, n, v[i]);
	}
	cout << ans;
}