#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector<long long> tree;

void add(long long i, long long l, long long r, long long qi) {
	if (r <= qi || qi < l) {
		return;
	}
	if (l + 1 == r) {
		tree[i]++;
		return;
	}
	long long mid = (l + r) / 2;
	add(2 * i + 1, l, mid, qi);
	add(2 * i + 2, mid, r, qi);
	tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

long long get_sum(long long i, long long l, long long r, long long ql, long long qr) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree[i];
	}
	long long mid = (l + r) / 2;
	return get_sum(2 * i + 1, l, mid, ql, qr) + get_sum(2 * i + 2, mid, r, ql, qr);
}

vector<vector<long long>> mst;
vector<long long> v;

void merge(long long i) {
	mst[i] = {};
	long long p1 = 0, p2 = 0;
	long long s1 = mst[2 * i + 1].size(), s2 = mst[2 * i + 2].size();
	while (p1 < s1 && p2 < s2) {
		if (mst[2 * i + 1][p1] < mst[2 * i + 2][p2]) {
			mst[i].push_back(mst[2 * i + 1][p1]);
			p1++;
		}
		else {
			mst[i].push_back(mst[2 * i + 2][p2]);
			p2++;
		}
	}
	while (p1 < s1) {
		mst[i].push_back(mst[2 * i + 1][p1]);
		p1++;
	}
	while (p2 < s2) {
		mst[i].push_back(mst[2 * i + 2][p2]);
		p2++;
	}
}

void build(long long i, long long l, long long r) {
	if (l + 1 == r) {
		mst[i] = { v[l] };
		return;
	}
	long long mid = (l + r) / 2;
	build(2 * i + 1, l, mid);
	build(2 * i + 2, mid, r);
	merge(i);
}

long long sumo(long long i, long long l, long long r, long long ql, long long qr, long long qx) {
	if (ql <= l && r <= qr) {
		long long muchless = lower_bound(mst[i].begin(), mst[i].end(), qx) - mst[i].begin();
		return muchless - (mst[i].size() - muchless);
	}
	if (r <= ql || qr <= l) {
		return 0;
	}
	long long mid = (l + r) / 2;
	return sumo(2 * i + 1, l, mid, ql, qr, qx) + sumo(2 * i + 2, mid, r, ql, qr, qx);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long r, c;
	cin >> r >> c;
	if (r == 1) {
		long long n = c;
		v.resize(n);
		for (long long i = 0; i < n; i++) {
			cin >> v[i];
			v[i]--;
		}
		tree.resize(4 * n);
		long long ans = 0;
		for (long long i = 0; i < n; i++) {
			ans += get_sum(0, 0, n, v[i] + 1, n);
			add(0, 0, n, v[i]);
		}
		cout << ans;
	}
	else {
		long long n = c;
		v.resize(2 * n);
		for (long long i = 0; i < 2 * n; i++) {
			cin >> v[i];
			v[i]--;
		}
		tree.resize(8 * n);
		long long ans = 0;
		for (long long i = 0; i < 2 * n; i++) {
			ans += get_sum(0, 0, 2 * n, v[i] + 1, 2 * n);
			add(0, 0, 2 * n, v[i]);
		}
		long long minim = ans;
		mst.resize(4 * n);
		build(0, 0, n);
		for (long long i = n; i < 2 * n; i++) {
			ans += sumo(0, 0, n, i - n + 1, n, v[i]);
			minim = min(minim, ans);
		}
		cout << minim;
	}
}