#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector<long long> tree;

void add(long long i, long long l, long long r, long long qi) {
	if (r <= qi || qi < l) {
		return;
	}
	if (l + 1 == r) {
		tree[i]++;
		return;
	}
	long long mid = (l + r) / 2;
	add(2 * i + 1, l, mid, qi);
	add(2 * i + 2, mid, r, qi);
	tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
}

long long get_sum(long long i, long long l, long long r, long long ql, long long qr) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree[i];
	}
	long long mid = (l + r) / 2;
	return get_sum(2 * i + 1, l, mid, ql, qr) + get_sum(2 * i + 2, mid, r, ql, qr);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long r, c;
	cin >> r >> c;
	vector<vector<long long>> t(r, vector<long long>(c));
	for (long long i = 0; i < r; i++) {
		for (long long j = 0; j < c; j++) {
			cin >> t[i][j];
		}
	}
	vector<long long> v;
	long long i = 0, j = 0;
	while (i < r && j < c) {
		long long muchless = 0;
		for (long long ii = i + 1; ii < r; ii++) {
			muchless += (lower_bound(t[i].begin() + j + 1, t[i].end(), t[ii][j])) - (t[i].begin() + j + 1);
		}
		long long muchmore = (c - j - 1) * (r - i - 1) - muchless;
		if (muchless < muchmore) {
			for (long long ii = i; ii < r; ii++) {
				v.push_back(t[ii][j]);
			}
			j++;
		}
		else {
			for (long long jj = j; jj < c; jj++) {
				v.push_back(t[i][jj]);
			}
			i++;
		}
	}
	tree.resize(v.size() * 4 + 4);
	long long ans = 0;
	long long n = v.size();
	for (long long i = 0; i < n; i++) {
		ans += get_sum(0, 0, n + 1, v[i] + 1, n + 1);
		add(0, 0, n + 1, v[i]);
	}
	cout << ans;
}