#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <unordered_map>

using namespace std;

long long n;
vector<long long> v;
vector<long long> morer;
vector<pair<long long, long long>> tree;

pair<long long, long long> merge(pair<long long, long long> a, pair<long long, long long> b) {
	if (a.first < b.first) {
		return a;
	}
	else {
		return b;
	}
}

void build(long long i, long long l, long long r) {
	if (l + 1 == r) {
		tree[i] = { v[l], l };
	}
	else {
		long long mid = (l + r) / 2;
		build(2 * i + 1, l, mid);
		build(2 * i + 2, mid, r);
		tree[i] = merge(tree[2 * i + 1], tree[2 * i + 2]);
	}
}

pair<long long, long long> get_min(long long i, long long l, long long r, long long ql, long long qr) {
	if (ql <= l && r <= qr) {
		return tree[i];
	}
	if (r <= ql || qr <= l) {
		return { 1e18, -1 };
	}
	long long mid = (l + r) / 2;
	return merge(get_min(2 * i + 1, l, mid, ql, qr), get_min(2 * i + 2, mid, r, ql, qr));
}

long long min_pos(long long l, long long r) {//[l,r];
	auto [min, pos] = get_min(0, 0, n, l, r + 1);
	return pos;
}

vector<long long> noms(long long k) {
	if (k == 1) {
		long long maxi = 0;
		for (long long i = 0; i < n; i++) {
			maxi = max(maxi, v[i]);
		}
		return { maxi };
	}
	vector<long long> ans;
	ans.push_back({ v[0] });
	long long i = 0;
	long long need = k - 1;
	while (need > 0) {
		if (need == 1) {
			long long maxi = v[n - 1];
			for (long long ii = morer[i]; ii < n; ii++) {
				maxi = max(maxi, v[ii]);
			}
			ans.push_back(maxi);
			need--;
			continue;
		}
		long long pos = min_pos(i + 1, min(n - need, morer[i]));
		ans.push_back(v[pos]);
		i = pos;
		need--;
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	long long q;
	cin >> n >> q;
	v.resize(n);
	for (long long i = 0; i < n; i++) {
		cin >> v[i];
	}
	tree.resize(4 * n);
	build(0, 0, n);
	morer.resize(n);
	stack<pair<long long, long long>> st;
	st.push({ 1e18, n });
	for (long long i = n - 1; i >= 0; i--) {
		while (st.top().first < v[i]) {
			st.pop();
		}
		morer[i] = st.top().second;
		st.push({ v[i],i });
	}
	vector<long long> nono = {};
	unordered_map<long long, vector<long long>> pr;
	for (long long gh = 0; gh < q; gh++) {
		long long k, i;
		cin >> k >> i;
		i--;
		if (pr[k] == nono){
			pr[k] = noms(k);
		}
		cout << pr[k][i] << '\n';
	}
}