#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout << #x << " = " << x << endl
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

using ll = long long;

struct Point {
    int id = 0;
    int x = 0, y = 0;
    Point(int id_, int x_, int y_): id(id_), x(x_), y(y_) {
    }

    bool dist(Point o, int r) {
        bool f = (ll)(o.x - x)*(o.x - x) + (ll)(o.y - y)*(o.y - y) <= (ll)r * r;
        return f;
    }

    bool operator< (Point o) {
        return y < o.y;
    }

    bool operator< (int o) {
        return y < o;
    }
    Point() = default;
};

bool operator<(int a, Point b) {
    return a < b.y;
}

struct DSU {
    int n;
    vector<int> p;
    vector<int> h;
    DSU(int n_): n(n_) {
        p.assign(n, -1);
        h.assign(n, 0);
    }

    int get(int v) {
       if (p[v] == -1) return v;
       return p[v] = get(p[v]);
    }

    void unite(int a, int b) {
        a = get(a);
        b = get(b);

        if (a == b) {
            return;
        }

        h[a] = h[a] || h[b];
        p[b] = a;
    }
};

bool dfs(int v, vector<vector<int>>& g, vector<bool>& used, vector<int>& cl, bool c) {
    debug(v);
    cl[v] = c;
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            if (dfs(u, g, used, cl, !c)) return 1;
        } else if (cl[u] == c) {
            debug(v << " " << u);
            return 1;
        }
    }

    return 0;
}

void solve() {
    int n, d;
    cin >> n >> d;
    vector<Point> ps(n);

    vector<int> x;
    for (int i = 0; i < n; ++i) {
        cin >> ps[i].x >> ps[i].y;
        ps[i].id = i;
        x.push_back(ps[i].x);
    }

    sort(all(x));

    x.resize(unique(all(x)) - x.begin());

    vector<vector<Point>> pp(x.size());

    unordered_map<int, int> mp;

    for (int i = 0; i < x.size(); ++i) {
        mp[x[i]] = i;
    }

    for (auto& i : pp) {
        sort(all(i));
    }
    for (int i = 0; i < n; ++i) {
        pp[mp[ps[i].x]].push_back(ps[i]);
    }

    vector<vector<int>> g(n);

    DSU ds(n);
    for (int i = 0; i < n; ++i) {
        Point p = ps[i];

        int l = lower_bound(all(x), p.x - d) - x.begin(); 
        int r = upper_bound(all(x), p.x + d) - x.begin();
        for (int xi = l; xi < r; ++xi) {
            int cx = x[xi];

            int ly = lower_bound(all(pp[xi]), p.y - d) - pp[xi].begin();
            int ry = upper_bound(all(pp[xi]), p.y + d) - pp[xi].begin();

            for (int yi = ly; yi < ry; ++yi) {
                Point o = pp[xi][yi];
                if (o.x == p.x && o.y == p.y) continue;
                if (p.dist(o, d)) {
                    g[i].push_back(o.id);
                    ds.unite(i, o.id);
                }
            }
        }
    }

    vector<bool> used(n, 0);
    vector<int> cl(n, -1);

    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        if (dfs(i, g, used, cl, 0)) {
            ds.h[ds.get(i)] = 1;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << (int)ds.h[ds.get(i)];
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    $(cin >> t;)

    for (int i = 0; i < t; ++i) {
        solve();
        $(cout << endl;)
    } 
}

