#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout << #x << " = " << x << endl
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

using ll = long long;

struct Point {
    int x = 0, y = 0;
    Point(int x_, int y_): x(x_), y(y_) {
    }

    bool dist(Point o, int r) {
        bool f = (ll)(o.x - x)*(o.x - x) + (ll)(o.y - y)*(o.y - y) <= (ll)r * r;
        return f;
    }

    bool operator< (Point o) {
        return y < o.y;
    }

    bool operator< (int o) {
        return y < o;
    }
    Point() = default;
};

bool operator<(int a, Point b) {
    return a < b.y;
}

struct DSU {
    int n;
    vector<int> p;
    vector<int> h;
    DSU(int n_): n(n_) {
        p.assign(n, -1);
        h.assign(n, 0);
    }

    int get(int v) {
       if (p[v] == -1) return v;
       return p[v] = get(p[v]);
    }

    void unite(int a, int b) {
        a = get(a);
        b = get(b);

        if (a == b) {
            return;
        }

        h[a] = h[a] || h[b];
        p[b] = a;
    }
};

bool dfs(int v, vector<vector<int>>& g, vector<bool>& used, vector<int>& cl, bool c) {
    debug(v);
    cl[v] = c;
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            if (dfs(u, g, used, cl, !c)) return 1;
        } else if (cl[u] == c) {
            debug(v << " " << u);
            return 1;
        }
    }

    return 0;
}

const int INF = 1e9;

void solve() {
    int n, d;
    cin >> n >> d;
    vector<Point> ps(n);

    vector<int> x;
    for (int i = 0; i < n; ++i) {
        cin >> ps[i].x >> ps[i].y;
        x.push_back(ps[i].x);
    }

    sort(all(x));

    x.resize(unique(all(x)) - x.begin());

    vector<vector<pair<int, int>>> pp(x.size());

    for (int i = 0; i < n; ++i) {
        pp[lower_bound(all(x), ps[i].x) - x.begin()].push_back({ps[i].y, i});
    }
    for (auto& i : pp) {
        sort(all(i));
    }

    vector<vector<int>> g(n);

    DSU ds(n);
    for (int i = 0; i < n; ++i) {
        Point p = ps[i];

        int l = lower_bound(all(x), p.x - d) - x.begin(); 
        int r = upper_bound(all(x), p.x + d) - x.begin();
        // int l = 0;
        // int r = x.size();
        for (int xi = l; xi < r; ++xi) {
            int cx = x[xi];

            int ly = lower_bound(all(pp[xi]), pair<int, int> {p.y - d, 0}) - pp[xi].begin();
            int ry = upper_bound(all(pp[xi]), pair<int, int> {p.y + d, INF}) - pp[xi].begin();

            // int ly = 0;
            // int ry = pp[xi].size();

            for (int yi = ly; yi < ry; ++yi) {
                auto [y, id] = pp[xi][yi];
                if (cx == p.x && y == p.y) continue;
                if (p.dist(Point(cx, y), d)) {
                    g[i].push_back(id);
                    ds.unite(i, id);
                }
            }
        }
    }

    vector<bool> used(n, 0);
    vector<int> cl(n, -1);

    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        if (dfs(i, g, used, cl, 0)) {
            ds.h[ds.get(i)] = 1;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << (int)ds.h[ds.get(i)];
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    $(cin >> t;)

    for (int i = 0; i < t; ++i) {
        solve();
        $(cout << endl;)
    } 
}

