#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout << #x << " = " << x << endl
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

using ll = long long;

struct Point {
    int id = 0;
    int x = 0, y = 0;
    Point(int id_, int x_, int y_): id(id_), x(x_), y(y_) {

    }
};

struct SegTree {
    vector<int> t;

    void add(int i, int l, int r, int q) {
        if (q < l || r <= q) return;
        if (l + 1 == r) {
            t[i] = 1;
            return;
        }

        int mid = (l + r) / 2;
        add(i * 2 + 1, l, mid, q);
        add(i * 2 + 2, mid, r, q);
        t[i] = t[i * 2 + 1] + t[i * 2 + 2];
    }

    int get(int i, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return 0;
        if (ql <= l && r <= qr) return t[i];
        int mid = (l + r) / 2;
        return get(i * 2 + 1, l, mid, ql, qr) + get(i * 2 + 2, mid, r, ql, qr);
    }

    int n;

    SegTree(int n_): n(n_) {
        t.assign(n * 4 + 10, 0);
    }

    void add(int q) {
        add(0, 0, n, q);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

const int INF = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> t(n, vector<int> (m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> t[i][j];
            t[i][j]--;
        }
    }

    int u = n * m;
    vector<vector<int>> cd(n, vector<int>(m, 0));
    vector<vector<int>> cr(n, vector<int>(m, 0));
    vector<vector<int>> dp(n, vector<int>(m, INF));
    dp[0][0] = 0;
    vector<vector<int>> h(n, vector<int>(m, 0));
    vector<vector<bool>> dir(n, vector<bool>(m, 0));

    vector<vector<int>> ir(n, vector<int>(m, 0));
    vector<vector<int>> id(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        SegTree st(u);
        for (int j = m - 1; j >= 0; --j) {            
            for (int c = i; c < n; ++c) {
                st.add(t[c][j]);
            }
            if (i > 0) {
                cd[i - 1][j] = st.get(0, t[i - 1][j]);
            }
            if (j > 0) {
                cr[i][j - 1] = st.get(0, t[i][j - 1]);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        SegTree st(u);
        for (int j = m - 1; j >= 0; --j) {
            for (int c = i + 1; c < n; ++c) {
                h[i][j] += st.get(t[c][j], u);
            }
            st.add(t[i][j]);
        }
    }

    
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            ir[i][j] = (i < n - 1 ? ir[i + 1][j] : 0) + (n - i - 1) * (m - j - 1) - h[i][j] + cr[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            id[i][j] = (j < m - 1 ? id[i][j + 1] : 0) + h[i][j] + cd[i][j];
        }
    }
    
    $(for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ir[i][j] << ' ';
        }
        cout << endl;
    }
cout << endl;)

    $(for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << cr[i][j] << ' ';
        }
        cout << endl;
    } cout << endl;)
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i > 0) {
                int vr = dp[i - 1][j] + id[i - 1][j];
                if (dp[i][j] > vr) {
                    dp[i][j] = vr;
                    dir[i][j] = 1;
                }
            }
            if (j > 0) {
                int vr = dp[i][j - 1] + id[i][j - 1];
                if (dp[i][j] > vr) {
                    dp[i][j] = vr;
                    dir[i][j] = 0;
                }
            }
        }
    }

    $(for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << dp[i][j] << ' ';
        }
        cout << endl;
    })

    int i = n - 1;
    int j = m - 1;  
    vector<int> p(1, t[n - 1][m - 1]);
    while (i >= 0 && j >= 0) {
        if (dir[i][j]) {
            i--;
            if (i >= 0) {
                for (int c = m - 1; c >= j; c--) {
                    p.push_back(t[i][c]);
                }
            }
        } else {
            j--;
            if (j >= 0) {
                for (int c = n - 1; c >= i; c--) {
                    p.push_back(t[c][j]);
                }
            }
        }
    }

    reverse(all(p));
    SegTree st(u);
    int cnt = 0;
    for (int i = 0; i < u; ++i) {
        cnt += st.get(p[i], u);
        st.add(p[i]);
    }
    cout << cnt << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    $(cin >> t;)

    for (int i = 0; i < t; ++i) {
        solve();
        $(cout << endl;)
    } 
}

