#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx,avx2")

using namespace std;

#define all(x) (x).begin(),(x).end()

#ifdef DBG
#define debug(x) cout << #x << " = " << x << endl
#define $(x) {x}
#else
#define debug(x)
#define $(x)
#endif

using ll = long long;

struct SegTree {
    vector<pair<int, int>> t;
    pair<int, int> get(int i, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return {INF, INF};
        if (ql <= l && r <= qr) return t[i];
        int mid = (l + r) / 2;
        return max(get(i * 2 + 1, l, mid, ql, qr), get(i * 2 + 2, mid, r, ql, qr));
    }

    int n;

    void build(int i, int l, int r, vector<int>& v) {
        if (l + 1 == r) {
            t[i] = {v[l], l};
            return;
        }

        int mid = (l + r) / 2;
        build(i * 2 + 1, l, mid, v);
        build(i * 2 + 2, mid, r, v);

        t[i] = max(t[i * 2 + 1], t[i * 2 + 2]);
    }

    SegTree(int n_, vector<int> v): n(n_) {
        t.assign(n * 4 + 10, {0, 0});
        build(0, 0, n, v);
    }

    pair<int, int> get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

const int INF = 1e9;


SegTree st;
vector<int> v;
int n;

int fnd(int s, int k, int i) {
    int pmxi = n;
    int mxi = st.get(s, n).second;
    while (mxi > k) {
        pmxi = mxi;
        int mxi = st.get(s, mxi).second;
    }
}

void solve() {
    int q;
    cin >> n >> q;
    
    v.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    st = SegTree(n, v);

    for (int qq = 0; qq < q; ++qq) {
        int k, i;
        cin >> k >> i;

        // cout << fnd(s, k, i - 1) << '\n';
        if (i == 1) {
            cout << v[0] << '\n';
        } else {
            if (st.get(0, n).first == v[0]) {
                cout << v[n - 1] << '\n';
            } else {
                cout << st.get(0, n).first << '\n';
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    $(cin >> t;)

    for (int i = 0; i < t; ++i) {
        solve();
        $(cout << endl;)
    } 
}

