#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
vector<vector<int>> gr;
vector<int> used;
vector<bool> ans;


bool dfs(int v, int col) {
    used[v] = col;
    for (auto u : gr[v]) {
        if (used[u] == used[v]) {return true;}
        if (used[u]) continue;
        if (dfs(u, 3 - col)) return true;
    }
    return false;
}



void dfs2(int v) {
    used[v] = 3;
    ans[v] = true;
    for (auto u : gr[v]) {
        if (used[u] == 3) continue;
        dfs2(u);
    }
}


int main() {

    int n;
    long long r;
    cin >> n >> r;
    gr.resize(n);
    vector<pair<long long, long long>> points(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (pow(points[i].first - points[j].first, 2) + pow(points[i].second - points[j].second, 2) <= r * r) {
                gr[i].push_back(j);
            }
        }
    }
    used.assign(n, 0);
    ans.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        if (dfs(i, 1)) {
            dfs2(i);
        }
    }
    for (auto i : ans) cout << i;


    return 0;
}