#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2,avx")
using namespace std;
using ll = long long;

struct Poll {
    ll x, y;
    ll i;
    ll t_end = 0;
    Poll() = default;
    Poll(ll x, ll y, ll i): x(x), y(y), i(i) {

    }
    Poll(ll x, ll y, ll i, ll t_end): x(x), y(y), i(i), t_end(t_end) {

    }
    ll dist(Poll b) const {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
    bool operator<(Poll b) const {
        if (y == b.y) {
            return x < b.x;
        }
        return y < b.y;
    }
};

vector<pair<vector<ll>, vector<ll>>> cmp;
vector<vector<ll>> g;

vector<ll> us;
vector<ll> bd;

void dfsc(ll v, ll c) {
    if (us[v]) return;
    if (c) cmp.back().second.push_back(v);
    else cmp.back().first.push_back(v);
    us[v] = 1;
    for (auto i : g[v]) dfsc(i, 1 - c);
}

bool check(vector<Poll> p, ll r) {
    set<Poll> st;
    for (auto i : p) {
        if (i.t_end) {
            i.x -= r;
            st.erase(i);
            auto x = st.upper_bound(i);
            if (x != st.end() && x != st.begin()) {
                auto y = prev(x);
                if (x->dist(*y) <= r * r) {
                    return 1;
                }
            }
        } else {
            auto x = st.upper_bound(i);
            if (x != st.end()) {
                if (x->dist(i) <= r * r) {
                    return 1;
                }
            }
            if (x != st.begin()) {
                x--;
                if (x->dist(i) <= r * r) {
                    return 1;
                }
            }
            st.insert(i);
        }
    }
    return 0;
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    ll r;
    ll n;
    cin >> n >> r;
    vector<Poll> p, rp;
    vector<pair<ll, ll>> crd(n);
    for (ll i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        crd[i] = {x, y};
        p.push_back(Poll(x, y, i));
        p.push_back(Poll(x + r, y, i, 1));
    }
    sort(p.begin(), p.end(), [](Poll a, Poll b){return a.x < b.x || a.x == b.x && a.t_end < b.t_end;});
    g.resize(n);

    set<Poll> st;
    for (auto i : p) {
        if (i.t_end) {
            i.x -= r;
            st.erase(i);
            auto x = st.upper_bound(i);
            if (x != st.begin() && x != st.end()) {
                auto y = prev(x);
                if (x->dist(*y) <= r * r) {
                    g[x->i].push_back(y->i);
                    g[y->i].push_back(x->i);
                }
            }
        } else {
            auto x = st.upper_bound(i);
            if (x != st.end()) {
                if (x->dist(i) <= r * r) {
                    g[x->i].push_back(i.i);
                    g[i.i].push_back(x->i);
                }
            }
            if (x != st.begin()) {
                x--;
                if (x->dist(i) <= r * r) {
                    g[x->i].push_back(i.i);
                    g[i.i].push_back(x->i);
                }
            }
            st.insert(i);
        }
    }

    us.assign(n, 0);
    bd.assign(n, 0);

    for (ll i = 0; i < n; i++) {
        if (!us[i]) {
            cmp.push_back(pair<vector<ll>, vector<ll>>{vector<ll>(0), vector<ll>(0)});
            dfsc(i, 0);
        }
    }
    for (auto [a, b] : cmp) {
        vector<Poll> pa, pb;
        for (auto i : a) {
            pa.emplace_back(crd[i].first, crd[i].second, i);
            pa.emplace_back(crd[i].first + r, crd[i].second, i, 1);
        }
        for (auto i : b) {
            pb.emplace_back(crd[i].first, crd[i].second, i);
            pb.emplace_back(crd[i].first + r, crd[i].second, i, 1);
        }
        sort(pa.begin(), pa.end(), [](Poll a, Poll b){return a.x < b.x || a.x == b.x && a.t_end < b.t_end;});
        sort(pb.begin(), pb.end(), [](Poll a, Poll b){return a.x < b.x || a.x == b.x && a.t_end < b.t_end;});
        ll bdd = check(pa, r) || check(pb, r);
        if (bdd) {
            for (auto i : a) {
                bd[i] = 1;
            }
            for (auto i : b) {
                bd[i] = 1;
            }
        }
    }
    for (auto& i : bd) cout << i;
}