#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("avx2,avx")
using namespace std;
using ll = long long;

struct Point {
    ll x, y;
    int i;
    int t_end = 0;
    Point() = default;
    Point(ll x, ll y, int i): x(x), y(y), i(i) {

    }
    Point(ll x, ll y, int i, int t_end): x(x), y(y), i(i), t_end(t_end) {

    }
    ll dist(Point b) const {
        return (x - b.x) * (x - b.x) + (y - b.y) * (y - b.y);
    }
    bool operator<(Point b) const {
        if (y == b.y) {
            return x < b.x;
        }
        return y < b.y;
    }
};
vector<vector<int>> g;

vector<int> us;
vector<int> bd;

void dfs(int v, int c) {
    if (us[v] == 1 - c) {
        bd[v] = 1;
        return;
    }
    if (us[v] != -1) return;
    us[v] = c;
    for (auto i : g[v]) dfs(i, 1 - c);
}
void dfsb(int v) {
    if (us[v]) {
        return;
    }
    us[v] = 1;
    bd[v] = 1;
    for (auto i : g[v]) dfsb(i);
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    ll r;
    int n;
    cin >> n >> r;
    vector<Point> p, rp;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        p.push_back(Point(x, y, i));
        p.push_back(Point(x + r, y, i, 1));
        rp.push_back(Point(x, y, i));
        rp.push_back(Point(x - r, y, i, 1));
    }
    sort(p.begin(), p.end(), [](Point a, Point b){return a.x < b.x;});
    sort(rp.begin(), rp.end(), [](Point a, Point b){return a.x > b.x;});
    g.resize(n);

    set<Point> st;
    for (auto i : p) {
        if (i.t_end) {
            auto x = st.upper_bound(i);
            Point t;
            bool f = 0;
            if (x != st.end()) {
                t = *x;
                f = 1;
            }
            st.erase(i);
            if (f) {
                x = st.lower_bound(t);
                if (x != st.begin()) {
                    auto y = prev(x);
                    if (x->dist(*y) <= r * r) {
                        g[x->i].push_back(y->i);
                        g[y->i].push_back(x->i);
                    }
                }
            }
        } else {
            auto x = st.lower_bound(i);
            auto y = x;
            if (x != st.end()) {
                if (x->dist(i) <= r * r) {
                    g[x->i].push_back(i.i);
                    g[i.i].push_back(x->i);
                }
            }
            if (x != st.begin()) {
                x--;
                if (x->dist(i) <= r * r) {
                    g[x->i].push_back(i.i);
                    g[i.i].push_back(x->i);
                }
                if (y != st.end()) {
                    if (x->dist(*y) <= r * r) {
                        g[x->i].push_back(y->i);
                        g[y->i].push_back(x->i);
                    }
                }
            }
            st.insert(i);
        }
    }

    for (auto i : rp) {
        if (i.t_end) {
            auto x = st.upper_bound(i);
            Point t;
            bool f = 0;
            if (x != st.end()) {
                t = *x;
                f = 1;
            }
            st.erase(i);
            if (f) {
                x = st.lower_bound(t);
                if (x != st.begin()) {
                    auto y = prev(x);
                    if (x->dist(*y) <= r * r) {
                        g[x->i].push_back(y->i);
                        g[y->i].push_back(x->i);
                    }
                }
            }
        } else {
            auto x = st.lower_bound(i);
            auto y = x;
            if (x != st.end()) {
                if (x->dist(i) <= r * r) {
                    g[x->i].push_back(i.i);
                    g[i.i].push_back(x->i);
                }
            }
            if (x != st.begin()) {
                x--;
                if (x->dist(i) <= r * r) {
                    g[x->i].push_back(i.i);
                    g[i.i].push_back(x->i);
                }
                if (y != st.end()) {
                    if (x->dist(*y) <= r * r) {
                        g[x->i].push_back(y->i);
                        g[y->i].push_back(x->i);
                    }
                }
            }
            st.insert(i);
        }
    }

    us.assign(n, -1);
    bd.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (us[i] == -1) dfs(i, 0);
    }
    us.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (bd[i]) dfsb(i);
    }
    for (auto& i : bd) cout << i;
}