#include <bits/stdc++.h>

using namespace std;
using ll = long long;
struct Tree {
    Tree() = default;
    ll n;
    vector<int> nd;
    vector<int> psh;
    Tree(ll n): n(n) {
        nd.assign(4 * n, 0);
        psh.assign(4 * n, 0);
    }
    void clear() {
        psh[0] = 1;
        nd[0] = 0;
    }
    void push(int v) {
        if (psh[v]) {
            nd[v * 2 + 1] = 0;
            nd[v * 2 + 2] = 0;
            psh[v * 2 + 1] = 1;
            psh[v * 2 + 2] = 1;
            psh[v] = 0;
        }
    }
    ll get(int v, int l, int r, int L, int R) {
        if (r <= L || R <= l) return 0;
        if (L <= l && r <= R) {
            return nd[v];
        }
        push(v);
        return get(v * 2 + 1, l, (l + r) / 2, L, R) + get(v * 2 + 2, (l + r) / 2, r, L, R);
    }
    ll get(int l, int r) {
        return get(0, 0, n, l, r);
    }
    void add(int v, int l, int r, int L) {
        if (r <= L || L < l) return;
        if (l + 1 == r) {
            nd[v] = 1;
            return;
        }
        push(v);
        add(v * 2 + 1, l, (l + r) / 2, L);
        add(v * 2 + 2, (l + r) / 2, r, L);
        nd[v] = nd[v * 2 + 1] + nd[v * 2 + 2];
    }
    void add(int a) {
        add(0, 0, n, a);
    }
};

int main() {
    int n, m;
    cin >> n >> m;
    int k = n * m;
    vector<vector<int>> v(n, vector<int>(m));
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for (auto& i : v) for (auto& j : i) cin >> j;
    for (auto& i : v) for (auto& j : i) j--;
    dp[0][0] = 0;
    Tree t(k);
    for (int i = 1; i <= n; i++) {
        ll s = 0;
        for (int j = 0; j < m; j++) {
            s += t.get(v[i - 1][j], k);
            t.add(v[i - 1][j]);
        }
        dp[i][0] = dp[i - 1][0] + s;
    }
    t.clear();
    for (int j = 1; j <= m; j++) {
        ll s = 0;
        for (int i = 0; i < n; i++) {
            s += t.get(v[i][j - 1], k);
            t.add(v[i][j - 1]);
        }
        dp[0][j] = dp[0][j - 1] + s;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
           // cout << i << " " << j << endl;
            t.clear();
            for (int di = 0; di < n; di++) {
                for (int dj = 0; dj < m; dj++) {
                    if (di >= i - 1 && dj >= j) break; 
                    t.add(v[di][dj]);
                }
            }
            ll s1 = 0;
            for (int dj = j; dj < m; dj++) {
                //for (int i = 0; i < 6; i++) cout << t.get(i, i + 1) << " ";
                s1 += t.get(v[i - 1][dj], k);
                t.add(v[i - 1][dj]);
            }
            t.clear();
            for (int di = 0; di < n; di++) {
                for (int dj = 0; dj < m; dj++) {
                    if (di >= i && dj >= j - 1) break; 
                    t.add(v[di][dj]);
                }
            }
            ll s2 = 0;
            for (int di = i; di < n; di++) {
                s2 += t.get(v[di][j - 1], k);
                t.add(v[di][j - 1]);
            }
            //cout << "- " << s1 << " " << s2 << endl;
            dp[i][j] = min(dp[i - 1][j] + s1, dp[i][j - 1] + s2);
        }
    }
    cout << dp[n][m];
}