#include <bits/stdc++.h>
using namespace std;
using ll = long long;
# define ff first
# define ss second
# define all(a) (a).begin(), (a).end()
# define rall(a) (a).rbegin(), (a).rend()
# define pb push_back
using ld = long double;

const ll inf = 1e15;

struct Fenwick {
    ll n;
    vector<ll> t;

    Fenwick(ll n) {
        this->n = n;
        t.resize(n + 1);
    }

    ll f(ll x) {
        return x & -x;
    }

    void upd(ll pos) {
        for (; pos <= n; pos += f(pos)) t[pos]++;
    }

    ll sum(ll pos) {
        ll ans = 0;
        for (; pos; pos -= f(pos)) ans += t[pos];
        return ans;
    }
};

void Solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (auto &x : a) {
        for (auto &y : x) cin >> y;
    }
    ll ans = inf;
    for (ll mask = 0; mask < (1 << n + m); ++mask) {
        ll ii = 0, jj = 0;
        vector<ll> z;
        Fenwick t(n * m);
        while (ii < n && jj < m) {
            if (mask & (1 << ii + jj)) {
                for (ll q = jj; q < m; ++q) z.pb(a[ii][q]);
                ii++;
            } else {
                for (ll q = ii; q < n; ++q) z.pb(a[q][jj]);
                jj++;
            }
        }
        ll ans1 = 0;
        for (ll ind = 0; ind < n * m; ++ind) {
            ans1 += t.sum(n * m) - t.sum(z[ind]);
            t.upd(z[ind]);
        }
        ans = min(ans, ans1);
    }
    cout << ans << '\n';
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0); // для вайба
    ll tt = 1;
    // cin >> tt;
    while (tt--) Solve();
    return 0;
}