#include <bits/stdc++.h>
using namespace std;
using ll = long long;
# define ff first
# define ss second
# define all(a) (a).begin(), (a).end()
# define rall(a) (a).rbegin(), (a).rend()
# define pb push_back
using ld = long double;

const ll inf = 1e15;

struct SegTree {
    vector<ll> a;
    vector<ll> t;

    SegTree(ll n, vector<ll> &z) {
        t.resize(n * 4);
        a = z;
        build(1, 0, n);
    }

    void build(ll v, ll l, ll r) {
        if (l == r - 1) {
            t[v] = l;
            return;
        }
        ll mid = l + r >> 1;
        build(v * 2, l, mid);
        build(v * 2 + 1, mid, r);
        t[v] = (a[t[v * 2]] < a[t[v * 2 + 1]] ? t[v * 2] : t[v * 2 + 1]);
        return;
    }
    
    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (l >= qr || ql >= r) return ql;
        if (ql <= l && r <= qr) return t[v];
        ll mid = l + r >> 1;
        ll x = get(v * 2, l, mid, ql, qr);
        ll y = get(v * 2 + 1, mid, r, ql, qr);
        return (a[x] < a[y] ? x : y);
    }
};

void Solve() {
     ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &x : a) cin >> x;
    SegTree t(n, a);
    stack<ll> st;
    vector<ll> suff(n + 1);
    for (ll i = n - 1; i >= 0; --i) suff[i] = max(suff[i + 1], a[i]);
    vector<ll> r(n);
    for (ll i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.top()] <= a[i]) st.pop();
        if (!st.size()) {
            r[i] = n;
        } else {
            r[i] = st.top() + 1;
        }
        st.push(i);
    }
    map<ll, vector<ll>> zov;
    while (q--) {
        ll k, p;
        cin >> k >> p;
        p--;
        if (k == 1) {
            cout << suff[0] << '\n';
            continue;
        }
        if (k == n) {
            cout << a[p] << '\n';
            continue;
        }
        if (zov[k] != vector<ll>()) {
            cout << zov[k][p] << '\n';
            continue;
        }
        vector<ll> z;
        z.pb(0);
        ll lst = 1;
        for (ll qq = 1; qq < k - 1; ++qq) {
            ll mn = t.get(1, 0, n, lst, min(n - (k - qq - 1), r[lst - 1]));
            lst = mn + 1;
            z.pb(mn);
        }
        ll mx = suff[r[lst - 1] - 1];
        z.pb(mx);
        cout << z[p] << '\n';
        zov[k] = z;
    }
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0); // для вайба
    ll tt = 1;
    // cin >> tt;
    while (tt--) Solve();
    return 0;
}