// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <set>
#include <cstdint>
#include <cassert>
using namespace std;
std::vector<pair<int, int>> points;
std::map<pair<int, int>, std::vector<int>> quad;
std::map<pair<int, int>, int> in_node;
std::vector<bool> colors;
int d;
int r;

pair<int, int> get_quad(pair<int, int> point) {
	return { point.first / d, point.second / d };
}
long long sqr_dist(pair<int, int> a, pair<int, int> b) {
	return (1LL * a.first - b.first) * (1LL * a.first - 1LL * b.first) + (1LL * a.second - 1LL * b.second) * (1LL * a.second - 1LL * b.second);
}
struct node {
	int size = 0;
	bool has_triangle = false;
	std::set<pair<int, int>> quadrants;
	void trianglize() {
		has_triangle = true;
	}
	void recolor_all() {
		for (auto q : quadrants) {
			for (auto i : quad[q])
				colors[i] = !colors[i];
		}
	}
	int get_intersection_type(pair<int, int> point) {
		auto q = get_quad(point);
		int result = 0;
		for (int dx = -2; dx <= 2; dx++) {

			for (int dy = -2; dy <= 2; dy++) {
				auto tq = q;
				tq.first += dx;
				tq.second += dy;
				if (quadrants.count(tq)) {
					for (auto i : quad[tq]) {
						if (sqr_dist(points[i], point) <= (1LL * r * r)) {
							if (has_triangle)
								return 3;
							result |= (int)colors[i] + 1;
						}
					}
				}
			}
		}
		return result;
	}
};
std::vector<node> nodes;
int32_t main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int n;
	std::cin >> n >> r;
	points.resize(n);
	colors.assign(n, false);
	d = (r + 1) / 2;
	int free_node_id = 0;
	for (int i = 0; i < n; i++) {
		cin >> points[i].first >> points[i].second;
		pair<int, int> q = { points[i].first / d, points[i].second / d };
		if (!quad.count(q)) {
			in_node[q] = free_node_id++;
			nodes.emplace_back();
			nodes.back().quadrants.insert(q);
		}
		else if (!nodes[in_node[q]].has_triangle) {
			int res = nodes[in_node[q]].get_intersection_type(points[i]);
			if (res == 3)
				nodes[in_node[q]].trianglize();
			if (res != 0)
				colors[i] = !(res-1);
		}
		quad[q].push_back(i);
		
		nodes[in_node[q]].size++;
	}
	auto try_to_merge = [](int a_id, int b_id) {
		if (a_id == b_id)
			return false;
		if (nodes[a_id].size < nodes[b_id].size)
			swap(a_id, b_id);
		bool need_recolor = false;
		bool notneed_recolor = false;
		int all_result = 0;
		for (auto q : nodes[b_id].quadrants){
			for (auto i : quad[q]) {
				int result = nodes[a_id].get_intersection_type(points[i]);
				if (result == 0)
					continue;
				else if (result == 3)
					all_result = 3;
				else if (result-1 == (int)colors[i]) {
					need_recolor = true;
					all_result |= 2;
				}
				else
				{
					all_result |= 1;
				}
			}
		}
		if (all_result == 3)
			nodes[a_id].trianglize();
		else if (all_result == 0)
			return false;
		else if (need_recolor)
			nodes[b_id].recolor_all();
		nodes[a_id].size += nodes[b_id].size;
		for (auto q : nodes[b_id].quadrants) {
			in_node[q] = a_id;
			nodes[a_id].quadrants.insert(q);

		}
		nodes[b_id].size = 0;
		nodes[b_id].has_triangle = false;
		return true;
	};
	for (int i = 0; i < n; i++) {
		auto q = get_quad(points[i]);
		for (int dx = -2; dx <= 2; dx++) {

			for (int dy = -2; dy <= 2; dy++) {
				auto tq = q;
				tq.first += dx;
				tq.second += dy;
				if (!quad.count(tq))
					continue;
				try_to_merge(in_node[q], in_node[tq]);
			}
		}
	}
	std::string answer(n, '0');

	for (int i = 0; i < nodes.size(); i++) {
		if (!nodes[i].has_triangle)
			continue;
		for (auto q : nodes[i].quadrants) {
			for (auto p : quad[q]) {
				answer[p] = '1';
			}
		}
	}
	std::cout << answer << '\n';
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
