// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <set>
#include <cstdint>
#include <cassert>
#include <random>
#include <unordered_set>
using namespace std;
struct seg_tree {
	std::vector<int> nodes;
	int ext_size;
	seg_tree(int size) {
		ext_size = 1;
		while (ext_size < size) {
			ext_size *= 2;
		}
		nodes.assign(ext_size * 2, 0);
	}
	void inc(int index) {
		index += ext_size;
		while (index) {
			nodes[index]++;
			index /= 2;
		}
	}
	int get(int l, int r) {
		l += ext_size;
		r += ext_size;
		int result = 0;
		while (l <= r) {
			if (l % 2 == 1) {
				result += nodes[l];
				l++;
			}
			else {
				result += nodes[r];
				r--;
			}
			l /= 2;
			r /= 2;
		}
		return result;
	}
};
int32_t main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int r, c;
	cin >> r >> c;
	std::vector<vector<int>> arr(r, vector(c, 0));
	std::vector<vector<long long>> dp(r, vector(c, (long long)1e15));
	for (auto& row : arr)
		for (auto& e : row) {
			cin >> e;
			e--;
		}
	seg_tree tree(1);
	auto build_seg = [&tree, &arr, r, c](int y, int x) {
		tree = seg_tree(r * c);
		for (int i = y; i < r; i++) {
			for (int j = x; j < c; j++) {
				tree.inc(arr[i][j]);
			}
		}
	};
	for (int i = r - 1; i >= 0; i--) {
		for (int j = c - 1; j >= 0; j--) {
			if (i == r - 1 && j == c - 1) {
				dp[i][j] = 0;
				continue;
			}
			if (i != r - 1) {
				build_seg(i + 1, j);
				long long local_ans = dp[i + 1][j];
				for (int k = c - 1; k >= j; k--) {
					local_ans += tree.get(0, arr[i][k]);
					tree.inc(arr[i][k]);
				}
				dp[i][j] = local_ans;
			}
			if (j != c - 1) {

				build_seg(i, j+1);
				long long local_ans = dp[i][j + 1];
				for (int k = r - 1; k >= i; k--) {
					local_ans += tree.get(0, arr[i][k]);
					tree.inc(arr[k][j]);
				}
				dp[i][j] = min(dp[i][j], local_ans);
			}
		}
	}
	cout << dp[0][0] << '\n';
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
