#pragma GCC optimize("O3,unroll-loops,no-stack-protector")

#include <bits/stdc++.h>

#pragma GCC target("avx,avx2,bmi,bmi2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,fma,popcnt,lzcnt,tune=native")

using namespace std;

long long sqdist(pair<long long, long long> a, pair<long long, long long> b) {
    long long dx = a.first - b.first;
    long long dy = a.second - b.second;
    return dx * dx + dy * dy;
}

struct hashh {
    size_t operator()(pair<long long, long long> x) const {
        return x.first * 738947802 + x.second;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n, r;
    cin >> n >> r;
    long long r2 = (r + 1) / 2;
    vector<pair<long long, long long>> pts(n);
    for(int i = 0; i < n; i++) cin >> pts[i].first >> pts[i].second;
    unordered_map<pair<long long, long long>, vector<int>, hashh> ptssq;
    for(int i = 0; i < n; i++) {
        auto [x, y] = pts[i];
        ptssq[{x / r2, y / r2}].push_back(i);
    }
    queue<pair<long long, long long>> qq;
    unordered_set<pair<long long, long long>, hashh> cycblk;
    int colcnt = 0;
    for(int i = 0; i < n; i++) {
        auto [xsq, ysq] = pts[i];
        xsq /= r2;
        ysq /= r2;
        if(cycblk.count({xsq, ysq})) continue;
        if(ptssq[{xsq, ysq}].size() >= 3) {
            cycblk.insert({xsq, ysq});
        }
    }
    for(auto [ck, ptsc] : ptssq) {
        if(ptsc.size() >= 3) continue;
        if(cycblk.count(ck)) continue;
        bool fl = false;
        for(auto pti : ptsc) {
            auto pt = pts[pti];
            auto [xsq, ysq] = pt;
            xsq /= r2;
            ysq /= r2;
            for(int dx1 = -2; dx1 <= 2; dx1++) {
                for(int dy1 = -2; dy1 <= 2; dy1++) {
                    for(int dx2 = -2; dx2 <= 2; dx2++) {
                        for(int dy2 = -2; dy2 <= 2; dy2++) {
                            long long xt1 = xsq + dx1, yt1 = ysq + dy1;
                            long long xt2 = xsq + dx2, yt2 = ysq + dy2;
                            auto it1 = ptssq.find({xt1, yt1});
                            auto it2 = ptssq.find({xt2, yt2});
                            if(it1 == ptssq.end()) continue;
                            if(it2 == ptssq.end()) continue;
                            if(it1->second.size() >= 3) continue;
                            if(it2->second.size() >= 3) continue;
                            for(auto pt1 : it1->second) {
                                for(auto pt2 : it2->second) {
                                    if(pt1 == pti || pt2 == pti || pt1 == pt2) continue;
                                    if(sqdist(pts[pt1], pts[pt2]) > r * r) continue;
                                    if(sqdist(pt, pts[pt2]) > r * r) continue;
                                    if(sqdist(pts[pt1], pt) > r * r) continue;
                                    cycblk.insert(ck);
                                    cycblk.insert({xt1, yt1});
                                    cycblk.insert({xt2, yt2});
                                    fl = true;
                                    break;
                                    // cout << ">>> " << ck.first << ' ' << ck.second << '\n';
                                    // cout << pti + 1 << ' ' << pt1 + 1 << ' ' << pt2 + 1 << '\n';
                                }
                                if(fl) break;
                            }
                            if(fl) break;
                        }
                        if(fl) break;
                    }
                    if(fl) break;
                }
                if(fl) break;
            }
            if(fl) break;
        }
    }
    for(auto t : cycblk) qq.push(t);
    while(qq.size()) {
        auto [xsq, ysq] = qq.front();
        qq.pop();
        auto cpts = ptssq[{xsq, ysq}];
        for(int dx = -2; dx <= 2; dx++) {
            for(int dy = -2; dy <= 2; dy++) {
                long long xt = xsq + dx, yt = ysq + dy;
                if(cycblk.count({xt, yt})) continue;
                auto it = ptssq.find({xt, yt});
                if(it == ptssq.end()) continue;
                if(it->second.size() >= 3) continue;
                bool fl = false;
                for(auto p1 : cpts) {
                    for(auto p2 : it->second) {
                        if(sqdist(pts[p1], pts[p2]) <= r * r) {
                            fl = true;
                            break;
                        }
                    }
                }
                if(fl) {
                    cycblk.insert({xt, yt});
                    qq.push({xt, yt});
                }
            }
        }
    }
    for(int i = 0; i < n; i++) {
        auto [xsq, ysq] = pts[i];
        xsq /= r2;
        ysq /= r2;
        if(cycblk.count({xsq, ysq})) cout << "1";
        else cout << "0";
    }
    cout << '\n';
}
