#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")

#include <bits/stdc++.h>

#pragma GCC target("avx,avx2,bmi,bmi2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,fma,popcnt,lzcnt,tune=native")

using namespace std;

long long sqdist(pair<long long, long long> a, pair<long long, long long> b) {
    long long dx = a.first - b.first;
    long long dy = a.second - b.second;
    return dx * dx + dy * dy;
}

struct hashh {
    size_t operator()(pair<long long, long long> x) const {
        return x.first * 738947802 + x.second;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n, r;
    cin >> n >> r;

    long long r2 = (r + 1) / 2;
    vector<pair<long long, long long>> pts(n);
    for(int i = 0; i < n; i++) cin >> pts[i].first >> pts[i].second;
    unordered_map<pair<long long, long long>, vector<int>, hashh> ptssq;
    for(int i = 0; i < n; i++) {
        auto [x, y] = pts[i];
        ptssq[{x / r2, y / r2}].push_back(i);
    }
    queue<pair<long long, long long>> qq;
    unordered_set<pair<long long, long long>, hashh> cycblk;
    int colcnt = 0;
    for(int i = 0; i < n; i++) {
        auto [xsq, ysq] = pts[i];
        xsq /= r2;
        ysq /= r2;
        if(cycblk.count({xsq, ysq})) continue;
        if(ptssq[{xsq, ysq}].size() >= 3) {
            cycblk.insert({xsq, ysq});
        }
    }

    {
        queue<int> qq;
        vector<int> oddcyc(n);
        vector<int> dist(n, -1);
        vector<int> col(n, -1);
        int colcnt = 0;
        for(int i = 0; i < n; i++) {
            auto [xsq, ysq] = pts[i];
            xsq /= r2;
            ysq /= r2;
            if(ptssq[{xsq, ysq}].size() >= 3) continue;
            if(col[i] != -1) continue;
            col[i] = colcnt;
            dist[i] = 0;
            qq.push(i);
            bool flOddCyc = false;
            while(qq.size()) {
                int v = qq.front();
                qq.pop();
                long long xsq = pts[v].first / r2;
                long long ysq = pts[v].second / r2;
                for(int dx = -2; dx <= 2; dx++) {
                    for(int dy = -2; dy <= 2; dy++) {
                        auto it = ptssq.find({xsq + dx, ysq + dy});
                        if(it == ptssq.end()) continue;
                        if(it->second.size() >= 3) continue;
                        for(auto t : it->second) {
                            if(t == v) continue;
                            if(sqdist(pts[v], pts[t]) > r * r) continue;
                            if(col[t] != -1) {
                                if(((dist[t] + dist[v] + 1) & 1)) {
                                    flOddCyc = true;
                                    continue;
                                }
                            } else {
                                col[t] = col[v];
                                dist[t] = dist[v] + 1;
                                qq.push(t);
                            }
                        }
                    }
                }
            }
            oddcyc[colcnt] = flOddCyc;
            colcnt++;
        }
        for(int i = 0; i < n; i++) {
            if(!oddcyc[col[i]]) continue;
            auto [xsq, ysq] = pts[i];
            xsq /= r2;
            ysq /= r2;
            cycblk.insert({xsq, ysq});
        }
    }

    for(auto t : cycblk) qq.push(t);
    while(qq.size()) {
        auto [xsq, ysq] = qq.front();
        qq.pop();
        auto cpts = ptssq[{xsq, ysq}];
        for(int dx = -2; dx <= 2; dx++) {
            for(int dy = -2; dy <= 2; dy++) {
                long long xt = xsq + dx, yt = ysq + dy;
                if(cycblk.count({xt, yt})) continue;
                auto it = ptssq.find({xt, yt});
                if(it == ptssq.end()) continue;
                if(it->second.size() >= 3) continue;
                bool fl = false;
                for(auto p1 : cpts) {
                    for(auto p2 : it->second) {
                        if(sqdist(pts[p1], pts[p2]) <= r * r) {
                            fl = true;
                            break;
                        }
                    }
                }
                if(fl) {
                    cycblk.insert({xt, yt});
                    qq.push({xt, yt});
                }
            }
        }
    }
    for(int i = 0; i < n; i++) {
        auto [xsq, ysq] = pts[i];
        xsq /= r2;
        ysq /= r2;
        if(cycblk.count({xsq, ysq})) cout << "1";
        else cout << "0";
    }
    cout << '\n';
}
