#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>

#pragma GCC target("avx,avx2,bmi,bmi2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,fma,popcnt,lzcnt,tune=native")

using namespace std;

int n, m;
vector<vector<int>> mtx;

vector<int> tree;

void upd(int i, int x) {
    while(i < tree.size()) {
        tree[i] += x;
        i = i | (i + 1);
    }
}

int pref(int i) {
    int ans = 0;
    while(i >= 0) {
        ans += tree[i];
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

void solven1() {
    long long ans = 0;
    for(int i = m - 1; i >= 0; i--) {
        ans += pref(mtx[0][i]);
        upd(mtx[0][i], 1);
    }
    cout << ans << '\n';
}

int main() {
    cin >> n >> m;
    mtx.resize(n, vector<int>(m));
    for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) cin >> mtx[i][j];

    if(n > m) {
        vector<vector<int>> mtx2(m, vector<int>(n));
        swap(n, m);
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++) {
                mtx2[i][j] = mtx[j][i];
            }
        }
        mtx = mtx2;
    }

    tree.resize(n * m + 1);
    if(n == 1) {
        solven1();
        return 0;
    }

    vector<vector<long long>> dp(n + 1, vector<long long>(m + 1));
    vector<vector<vector<int>>> els(n + 1, vector<vector<int>>(m + 1));
    for(int i = n - 1; i >= 0; i--) {
        for(int j = m - 1; j >= 0; j--) {
            vector<int> ca;
            for(int t = i; t < n; t++) ca.push_back(mtx[t][j]);
            for(int t = j + 1; t < m; t++) ca.push_back(mtx[i][t]);
            sort(ca.begin(), ca.end());
            merge(els[i + 1][j + 1].begin(), els[i + 1][j + 1].end(), ca.begin(), ca.end(), back_inserter(els[i][j]));
        }
    }

    vector<vector<long long>> invRow(n, vector<long long>(m));
    vector<vector<long long>> invCol(n, vector<long long>(m));
    for(int i = 0; i < n; i++) {
        // tree.assign(n * m + 1, 0);
        long long cinv = 0;
        for(int j = m - 1; j >= 0; j--) {
            cinv += pref(mtx[i][j]);
            invRow[i][j] = cinv;
            upd(mtx[i][j], 1);
        }
        for(int j = m - 1; j >= 0; j--) {
            upd(mtx[i][j], -1);
        }
    }
    for(int j = 0; j < m; j++) {
        // tree.assign(n * m + 1, 0);
        long long cinv = 0;
        for(int i = n - 1; i >= 0; i--) {
            cinv += pref(mtx[i][j]);
            invCol[i][j] = cinv;
            upd(mtx[i][j], 1);
        }
        for(int i = n - 1; i >= 0; i--) {
            upd(mtx[i][j], -1);
        }
    }

    // cout << "=================\n";
    // for(auto i : invRow) {
    //     for(auto j : i) cout << j << ' ';
    //     cout << '\n';
    // }
    // cout << "=================\n";
    // for(auto i : invCol) {
    //     for(auto j : i) cout << j << ' ';
    //     cout << '\n';
    // }
    // cout << "=================\n";

    for(int i = n - 1; i >= 0; i--) {
        for(int j = m - 1; j >= 0; j--) {
            long long costDelRow = dp[i + 1][j] + invRow[i][j];
            vector<int> elss;
            for(int a = j; a < m; a++) elss.push_back(mtx[i][a]);
            int curLess = 0;
            sort(elss.begin(), elss.end());
            for(auto x : elss) {
                while(curLess < els[i + 1][j].size() && els[i + 1][j][curLess] < x) curLess++;
                costDelRow += curLess;
            }

            long long costDelCol = dp[i][j + 1] + invCol[i][j];
            for(int a = i; a < n; a++) {
                costDelCol += lower_bound(els[i][j + 1].begin(), els[i][j + 1].end(), mtx[a][j]) - els[i][j + 1].begin();
            }

            dp[i][j] = min(costDelCol, costDelRow);
        }
    }
    cout << dp[0][0] << '\n';
}
