#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
 
using namespace std;
using ll = long long;
using ld = long double;
 
struct DSU {
    vector<int> r, p;
    void init(int n) {
        r.assign(n, 0);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }
    int find(int u) {
        if (p[u] ^ u) p[u] = find(p[u]);
        return p[u];
    }
    void merge(int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return;
        if (r[u] > r[v]) swap(u, v);
        if (r[u] == r[v]) r[v]++;
        p[u] = v;
    }
    vector<vector<int>> get() {
        vector<vector<int>> res((int)r.size());
        for (int i = 0; i < (int)res.size(); ++i) {
            res[find(i)].push_back(i);
        }
        return res;
    }
};
 
void solve(vector<pair<int, int>> edges, int n) {
    vector<vector<int>> g(n);
    vector<int> used(n, -1);
    vector<int> bad(n);
 
    DSU st;
    st.init(n);
 
    for (auto &[u, v] : edges) {
        if (u == v) continue;
        g[u].push_back(v);
        g[v].push_back(u);
        st.merge(u, v);
    }
 
    auto dfs = [&](auto &&dfs, int v) -> void {
        for (int to : g[v]) {
            if (used[to] == -1) {
                used[to] = 1 - used[v];
                dfs(dfs, to);
            } else if (used[to] != 1 - used[v]) {
                bad[v] = 1;
            }
        }
    };
 
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            used[i] = 0;
            dfs(dfs, i);
        }
    }
 
    vector<int> ans(n);
 
    vector<vector<int>> comps = st.get();
    for (auto it : comps) {
        bool is_bad = false;
        for (int v : it) {
            if (bad[v]) {
                is_bad = true;
                break;
            }
        }
        if (is_bad) {
            for (int v : it) {
                ans[v] = 1;
            }
        }
    }
 
    for (int i = 0; i < n; ++i) {
    	cout << ans[i];
    }
}
 
signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
 
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].first >> points[i].second;
    }
    vector<pair<int, int>> edges;
 
    auto get_sq_dist = [&](pair<int, int> a, pair<int, int> b) -> ll {
        ll x = a.first - b.first;
        ll y = a.second - b.second;
        return x * x + y * y;
    };
 
    set<pair<int, int>> st;
    vector<int> ord(n);
 
    for (int i = 0; i < n; ++i) {
    	for (int j = i + 1; j < n; ++j) {
    		if (get_sq_dist(points[i], points[j]) <= r * 1ll * r) {
    			edges.push_back({i, j});
    		}
    	}
    }
 
    solve(edges, n);
}
