#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
 
using namespace std;
using ll = long long;
using ld = long double;
 
struct DSU {
    vector<int> r, p;
    void init(int n) {
        r.assign(n, 0);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
    }
    int find(int u) {
        if (p[u] ^ u) p[u] = find(p[u]);
        return p[u];
    }
    void merge(int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return;
        if (r[u] > r[v]) swap(u, v);
        if (r[u] == r[v]) r[v]++;
        p[u] = v;
    }
    vector<vector<int>> get() {
        vector<vector<int>> res((int)r.size());
        for (int i = 0; i < (int)res.size(); ++i) {
            res[find(i)].push_back(i);
        }
        return res;
    }
};

const int N = (int)1e4 + 5;

pair<int, int> points[N];
int used[N], bad[N];
vector<int> comps[N];
int ans[N];
int cc = 0;

inline ll get_sq_dist(const pair<int, int> &a, const pair<int, int> &b) {
	ll x = a.first - b.first;
    ll y = a.second - b.second;
    return x * x + y * y;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
 
    int n, r;
    cin >> n >> r;
    for (int i = 0; i < n; ++i) {
        cin >> points[i].first >> points[i].second;
    }

    for (int i = 0; i < n; ++i) {
    	used[i] = -1;
    }
 
    auto dfs = [&](auto &&dfs, int v) -> void {
    	comps[cc].push_back(v);
        for (int to = 0; to < n; ++to) {
        	if (to == v) continue;
        	if (get_sq_dist(points[v], points[to]) > r * 1ll * r) continue;
            if (used[to] == -1) {
                used[to] = 1 - used[v];
                dfs(dfs, to);
            } else if (used[to] != 1 - used[v]) {
                bad[v] = 1;
            }
        }
    };
 
    for (int i = 0; i < n; ++i) {
        if (used[i] == -1) {
            used[i] = 0;
            dfs(dfs, i);
            cc++;
        }
    }

    for (int i = 0; i < cc; ++i) {
    	auto it = comps[i];
        bool is_bad = false;
        for (int v : it) {
            if (bad[v]) {
                is_bad = true;
                break;
            }
        }
        if (is_bad) {
            for (int v : it) {
                ans[v] = 1;
            }
        }
    }
 
    for (int i = 0; i < n; ++i) {
    	cout << ans[i];
    }
}
