#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

struct DSU {
	vector<int> r, p, val, is_bad, add;
	void init(int n) {
		r.assign(n, 0);
		p.resize(n);
		val.assign(n, 0);
		is_bad.assign(n, 0);
		add.assign(n, 0);
		iota(p.begin(), p.end(), 0);
	}
	int find(int u) {
		if (p[u] ^ u) return find(p[u]);
		return p[u];
	}
	int get_val(int u) {
		int res = val[u] ^ add[u];
		while (p[u] ^ u) {
			u = p[u];
			res ^= add[u];
		}
		return res;
	}
	void merge(int u, int v) {
		int x = u, y = v;
		u = find(u);
		v = find(v);
		if (u == v) {
			if (get_val(x) == get_val(y)) {
				is_bad[u] = 1;
			}
			return;
		}
		if (r[u] > r[v]) swap(u, v);
		if (r[u] == r[v]) r[v]++;
		p[u] = v;

		if (val[u] == val[v]) {
			add[u] ^= 1;
		}

		if (is_bad[u]) {
			is_bad[v] = 1;
		}
	}
	void final() {
		for (int i = 0; i < (int)r.size(); ++i) {
			if (is_bad[find(i)]) {
				cout << 1;
			} else {
				cout << 0;
			}
		}
	}
};

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int n, r;
	cin >> n >> r;
	vector<pair<int, int>> points(n);
	for (int i = 0; i < n; ++i) {
		cin >> points[i].first >> points[i].second;
	}
	vector<pair<int, int>> edges;

	auto get_sq_dist = [&](pair<int, int> a, pair<int, int> b) -> ll {
		ll x = a.first - b.first;
		ll y = a.second - b.second;
		return x * x + y * y;
	};

	set<pair<int, int>> st;
	vector<int> ord(n);

	auto get_extremum1 = [&](int l1, int r1, int l2, int r2) -> vector<int> {
		vector<int> res;

		auto it = st.lower_bound({r1, -1});

		for (int i = 0; i < 500; ++i) {
			if (it != st.end() && points[ord[it->second]].second <= r2) {
				res.push_back(ord[it->second]);
				it++;
			} else {
				break;
			}
		}

		sort(res.begin(), res.end());
		res.erase(unique(res.begin(), res.end()), res.end());
		
		if (!res.empty() && res.front() == -1) {
			reverse(res.begin(), res.end());
			res.pop_back();
			reverse(res.begin(), res.end());
		}

		return res;
	};

	auto get_extremum2 = [&](int l1, int r1, int l2, int r2) -> vector<int> {
		vector<int> res;

		auto it = st.lower_bound({l1, -1});

		for (int i = 0; i < 500; ++i) {
			if (it != st.end() && points[ord[it->second]].first <= l2) {
				res.push_back(ord[it->second]);
				it++;
			} else {
				break;
			}
		}

		sort(res.begin(), res.end());
		res.erase(unique(res.begin(), res.end()), res.end());
		
		if (!res.empty() && res.front() == -1) {
			reverse(res.begin(), res.end());
			res.pop_back();
			reverse(res.begin(), res.end());
		}

		return res;
	};





	iota(ord.begin(), ord.end(), 0);
	sort(ord.begin(), ord.end(), [&](int i, int j) -> bool {
		return points[i].first < points[j].first;
	});

	DSU ft;
	ft.init(n);

	int ptr = 0;
	int c = 0;

	auto add = [&](int u, int v) -> void {
		ft.merge(u, v);
	};

	for (int i : ord) {
		while (ptr < c && points[ord[c]].first - points[ord[ptr]].first > r) {
			st.erase({points[ord[ptr]].second, ptr});
			ptr++;
		}
		auto point = points[i];
		int x = point.first, y = point.second;
		for (auto it : get_extremum1(x - r, y - r, x, y)) {
			if (get_sq_dist(points[it], points[i]) <= r * 1ll * r) {
				add(i, it);
			}
		}
		for (auto it : get_extremum1(x - r, y, x, y + r)) {
			if (get_sq_dist(points[it], points[i]) <= r * 1ll * r) {
				add(i, it);
			}
		}
		st.insert({points[ord[c]].second, c});
		c++;
	}

	sort(ord.begin(), ord.end(), [&](int i, int j) -> bool {
		return points[i].second < points[j].second;
	});

	ptr = c = 0;
	st.clear();

	for (int i : ord) {
		while (ptr < c && points[ord[c]].second - points[ord[ptr]].second > r) {
			st.erase({points[ord[ptr]].first, ptr});
			ptr++;
		}
		auto point = points[i];
		int x = point.first, y = point.second;
		for (auto it : get_extremum2(x - r, y - r, x, y)) {
			if (get_sq_dist(points[it], points[i]) <= r * 1ll * r) {
				add(i, it);
			}
		}
		for (auto it : get_extremum2(x - r, y, x, y + r)) {
			if (get_sq_dist(points[it], points[i]) <= r * 1ll * r) {
				add(i, it);
			}
		}
		st.insert({points[ord[c]].first, c});
		c++;
	}

	ft.final();
}
