#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
  
using namespace std;
using ll = long long;
using ld = long double;

struct FenwickTree {
	vector<int> tree;
	int n;
	void init(int _n) {
		n = _n;
		tree.assign(n, 0);
	}
	void inc(int i, int v) {
		for (int j = i; j < n; j |= j + 1) {
			tree[j] += v;
		}
	}
	ll get(int i) {
		ll ans = 0;
		for (int j = i; j >= 0; j = (j & (j + 1)) - 1) {
			ans += tree[j];
		}
		return ans;
	}
};

vector<ll> calc_inversion(vector<int> arr) {
	vector<int> p = arr;
	sort(p.begin(), p.end());
	p.erase(unique(p.begin(), p.end()), p.end());
	vector<ll> ans((int)arr.size());
	FenwickTree ft;
	ft.init((int)p.size());
	for (int &i : arr) {
		i = lower_bound(p.begin(), p.end(), i) - p.begin();
	}
	for (int i = (int)arr.size() - 1; i >= 0; --i) {
		if (i + 1 < (int)arr.size()) {
			ans[i] = ans[i + 1];
		}
		ans[i] += ft.get(arr[i] - 1);
		ft.inc(arr[i], 1);
	}
	return ans;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
  
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
    	for (int j = 0; j < m; ++j) {
    		cin >> arr[i][j]; --arr[i][j];
    	}
    }
    vector<vector<ll>> dp_left(n, vector<ll>(m));
    vector<vector<ll>> dp_right(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
    	dp_left[i] = calc_inversion(arr[i]);
    }
    for (int i = 0; i < m; ++i) {
    	vector<int> temp(n);
    	for (int j = 0; j < n; ++j) {
    		temp[j] = arr[j][i];
    	}
    	auto it = calc_inversion(temp);
    	for (int j = 0; j < n; ++j) {
    		dp_right[j][i] = it[j];
    	}
    }

    if (n == 1) {
    	cout << dp_left[0][0];
    	return 0;
    }

    if (m == 1) {
    	cout << dp_right[0][0];
    	return 0;
    }

    vector<vector<vector<int>>> precalc(n, vector<vector<int>>(m, vector<int>(n * m)));
    for (int i = n - 1; i >= 0; --i) {
    	for (int j = m - 1; j >= 0; --j) {
    		for (int x = 0; x < n * m; ++x) {
    			if (i + 1 < n) {
    				precalc[i][j][x] += precalc[i + 1][j][x];
    			}
    			if (j + 1 < m) {
    				precalc[i][j][x] += precalc[i][j + 1][x];
    			}
    			if (i + 1 < n && j + 1 < m) {
    				precalc[i][j][x] -= precalc[i + 1][j + 1][x];
    			}
    			if (arr[i][j] < x) {
    				precalc[i][j][x]++;
    			}
    		}
    	}
    }
    vector<vector<int>> dp(n, vector<int>(m));
    for (int i = n - 1; i >= 0; --i) {
    	for (int j = m - 1; j >= 0; --j) {
    		if (i == n - 1 && j == m - 1) {
    			dp[i][j] = 0;
    			continue;
    		}
    		int min_val = (int)1e9 + 5;
    		
    		if (i + 1 < n) {
    			int sum = dp[i + 1][j] + dp_left[i][j];
    			for (int k = j; k < m; ++k) {
    				sum += precalc[i + 1][j][arr[i][k]];
    			}
    			min_val = std::min(min_val, sum);
    		}

    		if (j + 1 < m) {
    			int sum = dp[i][j + 1] + dp_right[i][j];
    			for (int k = i; k < n; ++k) {
    				sum += precalc[i][j + 1][arr[k][j]];
    			}
    			min_val = std::min(min_val, sum);
    		}

    		dp[i][j] = min_val;
    	}
    }
    cout << dp[0][0];
}
