#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
  
using namespace std;
using ll = long long;
using ld = long double;

#define int long long

struct FenwickTree {
	vector<ll> tree;
	int n;
	ll added;
	void init(int _n) {
		n = _n;
		added = 0;
		tree.assign(n, 0);
	}
	void inc(int i, int v) {
		for (int j = i; j < n; j |= j + 1) {
			tree[j] += v;
		}
		added += v;
	}
	ll get(int i) {
		ll ans = 0;
		for (int j = i; j >= 0; j = (j & (j + 1)) - 1) {
			ans += tree[j];
		}
		return ans;
	}
	ll get2(int i) {
		return added - get(i);
	}
};

vector<ll> calc_inversion(vector<int> arr) {
	vector<int> p = arr;
	sort(p.begin(), p.end());
	p.erase(unique(p.begin(), p.end()), p.end());
	vector<ll> ans((int)arr.size());
	FenwickTree ft;
	ft.init((int)p.size());
	for (int &i : arr) {
		i = lower_bound(p.begin(), p.end(), i) - p.begin();
	}
	for (int i = (int)arr.size() - 1; i >= 0; --i) {
		if (i + 1 < (int)arr.size()) {
			ans[i] = ans[i + 1];
		}
		ans[i] += ft.get(arr[i] - 1);
		ft.inc(arr[i], 1);
	}
	return ans;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
  
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
    	for (int j = 0; j < m; ++j) {
    		cin >> arr[i][j]; --arr[i][j];
    	}
    }
    if (n > m) {
    	vector<vector<int>> temp_arr(m, vector<int>(n));
    	for (int i = 0; i < n; ++i) {
    		for (int j = 0; j < m; ++j) {
    			temp_arr[j][i] = arr[i][j];
    		}
    	}
    	temp_arr.swap(arr);
    	swap(n, m);
    }
    vector<vector<ll>> dp_left(n, vector<ll>(m));
    vector<vector<ll>> dp_right(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
    	dp_left[i] = calc_inversion(arr[i]);
    }
    for (int i = 0; i < m; ++i) {
    	vector<int> temp(n);
    	for (int j = 0; j < n; ++j) {
    		temp[j] = arr[j][i];
    	}
    	auto it = calc_inversion(temp);
    	for (int j = 0; j < n; ++j) {
    		dp_right[j][i] = it[j];
    	}
    }

    if (n == 1) {
    	cout << dp_left[0][0];
    	return 0;
    }

    if (m == 1) {
    	cout << dp_right[0][0];
    	return 0;
    }

    vector<vector<ll>> dp_inv_left(n, vector<ll>(m));
    vector<FenwickTree> ft_inv_left(n);

    for (int i = 0; i < n; ++i) {
    	ft_inv_left[i].init(n * m);
    }

    for (int j = m - 1; j >= 0; --j) {
    	if (j == m - 1) {
    		for (int i = n - 1; i >= 0; --i) {
    			for (int k = i + 1; k < n; ++k) {
    				if (arr[i][j] < arr[k][j]) {
    					dp_inv_left[i][j]++;
    				}
    			}
    			ft_inv_left[i].inc(arr[i][j], 1);
    		}
    		continue;
    	}
    	for (int i = n - 1; i >= 0; --i) {
    		dp_inv_left[i][j] = dp_inv_left[i][j + 1];
    		for (int k = i + 1; k < n; ++k) {
    			dp_inv_left[i][j] += ft_inv_left[i].get2(arr[k][j]);
    		}
    	}
    	for (int i = 0; i < n; ++i) {
    		ft_inv_left[i].inc(arr[i][j], 1);
    	}
    	for (int i = n - 1; i >= 0; --i) {
    		for (int j = i + 1; j < n; ++j) {
    			dp_inv_left[i][j] += ft_inv_left[j].get(arr[i][j]);
    		}
    	}
    }

    vector<vector<ll>> dp_inv_right(n, vector<ll>(m));
    vector<FenwickTree> ft_inv_right(n);

    for (int i = 0; i < n; ++i) {
    	ft_inv_right[i].init(n * m);
    }

    for (int j = m - 1; j >= 0; --j) {
    	if (j == m - 1) {
    		for (int i = 0; i < n; ++i) {
    			dp_inv_right[i][j] = 0;
    		}
    	} else {
	    	for (int i = n - 1; i >= 0; --i) {
	    		for (int k = i; k < n; ++k) {
	    			dp_inv_right[i][j] += ft_inv_right[i].get(arr[k][j]);
	    		}
	    	}
	    }
    	for (int i = n - 1; i >= 0; --i) {
    		for (int k = i; k < n; ++k) {
    			ft_inv_right[i].inc(arr[k][j], 1);
    		}
    	}
    }

    vector<vector<ll>> dp(n, vector<ll>(m));
    for (int i = n - 1; i >= 0; --i) {
    	for (int j = m - 1; j >= 0; --j) {
    		if (i == n - 1 && j == m - 1) {
    			dp[i][j] = 0;
    			continue;
    		}
    		ll min_val = (ll)1e18 + 5;
    		
    		if (i + 1 < n) {
    			ll sum = dp[i + 1][j] + dp_left[i][j] + dp_inv_left[i][j];
    			min_val = std::min(min_val, sum);
    		}

    		if (j + 1 < m) {
    			ll sum = dp[i][j + 1] + dp_right[i][j] + dp_inv_right[i][j];
    			min_val = std::min(min_val, sum);
    		}

    		dp[i][j] = min_val;
    	}
    }
    cout << dp[0][0];
}
