#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
   
using namespace std;
using ll = long long;
using ld = long double;

const int inf = (int)1e9 + 5;

template<typename T>
struct SparseTableMin {
	vector<vector<T>> sparse;
	vector<int> logs;
	void build(const vector<T> &arr) {
		int n = (int)arr.size();
		logs.assign(n + 1, 0);
		for (int i = 2; i <= n; ++i) {
			logs[i] = logs[i >> 1] + 1;
		}
		sparse.resize(logs[n] + 1, vector<T>(n));
		sparse[0] = arr;
		for (int k = 0; k + 1 <= logs[n]; ++k) {
			for (int i = 0; i + (1 << k) < n; ++i) {
				sparse[k + 1][i] = std::min(sparse[k][i], sparse[k][i + (1 << k)]);
			}
		}
	}
	T min(int l, int r) {
		int sz = logs[r - l];
		return std::min(sparse[sz][l], sparse[sz][r - (1 << sz) + 1]);
	}
};

template<typename T>
struct SparseTableMax {
	vector<vector<T>> sparse;
	vector<int> logs;
	void build(const vector<T> &arr) {
		int n = (int)arr.size();
		logs.assign(n + 1, 0);
		for (int i = 2; i <= n; ++i) {
			logs[i] = logs[i >> 1] + 1;
		}
		sparse.resize(logs[n] + 1, vector<T>(n));
		sparse[0] = arr;
		for (int k = 0; k + 1 <= logs[n]; ++k) {
			for (int i = 0; i + (1 << k) < n; ++i) {
				sparse[k + 1][i] = std::max(sparse[k][i], sparse[k][i + (1 << k)]);
			}
		}
	}
	T max(int l, int r) {
		int sz = logs[r - l];
		return std::max(sparse[sz][l], sparse[sz][r - (1 << sz) + 1]);
	}
};
 
signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
   
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
    	cin >> a[i];
    	a[i]--;
    }
    vector<int> nxt_bigger(n);
    vector<pair<int, int>> st_b;
    for (int i = n - 1; i >= 0; --i) {
    	while (!st_b.empty() && st_b.back().first <= a[i]) {
    		st_b.pop_back();
    	}
    	if (!st_b.empty()) {
    		nxt_bigger[i] = st_b.back().second;
    	} else {
    		nxt_bigger[i] = n;
    	}
    	st_b.emplace_back(a[i], i);
    }

    SparseTableMin<pair<int, int>> st_min;
    SparseTableMax<pair<int, int>> st_max;
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; ++i) {
    	b[i] = make_pair(a[i], i);
    }
    st_min.build(b);
    st_max.build(b);

    vector<vector<int>> dp(n + 1);

    vector<pair<int, int>> calced(n + 1);
    vector<int> calced_res(n + 1);
    for (int i = 1; i <= n; ++i) {
    	calced[i] = {0, 0};
    }

    auto push = [&](int blocks) -> void {
    	int pos = calced[blocks].second;
    	int placed = calced[blocks].first;
    	calced[blocks].first++;

    	if (placed + 1 == blocks) {
			calced_res[blocks] = st_max.max(pos, n - 1).first;
			calced[blocks].second = pos;
			return;
		}
		if (placed + 2 == blocks) {
			calced_res[blocks] = a[pos];
			pos = std::min(nxt_bigger[pos], n - 1);
			calced[blocks].second = pos;
			return;
		}
		int lim = n - 1;
		lim = std::min(lim, nxt_bigger[pos]);
		lim = std::min(lim, n - (blocks - (placed + 1)));
		int nxt_pos = st_min.min(pos + 1, lim).second;
		calced_res[blocks] = a[pos];
		pos = nxt_pos;

		calced[blocks].second = pos;
    };

    vector<int> ans(q);
    vector<vector<pair<int, int>>> queries(n + 1);

    for (int t = 0; t < q; ++t) {
    	int k, i;
    	cin >> k >> i;
    	queries[k].emplace_back(i, t);
    }

    for (int i = 1; i <= n; ++i) {
    	sort(queries[i].begin(), queries[i].end());
    	for (auto &[place, pos] : queries[i]) {
    		while (calced[i].first < place) {
    			push(i);
    		}
    		ans[pos] = calced_res[i];
    	}
    }

    for (int i = 0; i < q; ++i) {
    	cout << ans[i] + 1 << '\n';
    }
}
