#include <bits/stdc++.h>

using namespace std;

struct fenwick {
    int n;
    vector <long long> w;

    fenwick(int n): n(n) {
        w.resize(1 + n);
    }

    long long get(int k) {
        long long s = 0;
        for (k; k; k -= k & -k) s += w[k];
        return s;
    }

    long long get(int a, int b) {
        return get(b) - get(a);
    }

    void add(int k, int x) {
        for (k; k <= n; k += k & -k) w[k] += x;
    }
};

struct df {
    int n;
    fenwick a, b;
    long long s = 0;

    df(int n): n(n), a(n), b(n) {}

    void ladd(int x) {
        s += b.get(x, n);
        a.add(x, 1);
    }
    void radd(int x) {
        s += a.get(x);
        b.add(x, 1);
    }

    void ldel(int x) {
        a.add(x, -1);
        s -= b.get(x, n);
    }
    void rdel(int x) {
        b.add(x, -1);
        s -= a.get(x);
    }

    long long get() {
        return s;
    }
};

int main() {
    int r, c;
    cin >> r >> c;

    vector <vector <int>> t(r, vector <int> (c));
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> t[i][j];
        }
    }

    fenwick f(r * c);
    /*
    vector <vector <long long>> g(r, vector <long long> (c));
    for (int i = 0; i < r; ++i) {
        for (int j = c - 1; j >= 0; --j) {
            g[i][j] = f.get(t[i][j]);
            if (j + 1 < c) g[i][j] += g[i][j + 1];
            f.add(t[i][j], 1);
        }
        for (int j = c - 1; j >= 0; --j) {
            f.add(t[i][j], -1);
            g[i][j] = (long long) (c - j) * (c - 1 - j) / 2 - g[i][j];
        }
    }
    vector <vector <long long>> h(r, vector <long long> (c));
    for (int j = 0; j < c; ++j) {
        for (int i = r - 1; i >= 0; --i) {
            h[i][j] = f.get(t[i][j]);
            if (i + 1 < r) h[i][j] += h[i + 1][j];
            f.add(t[i][j], 1);
        }
        for (int i = r - 1; i >= 0; --i) {
            f.add(t[i][j], -1);
            h[i][j] = (long long) (r - i) * (r - 1 - i) / 2 - h[i][j];
        }
    }

    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cout << h[i][j] << ' ';
        }
        cout << '\n';
    }
    */

    vector <bool> q;
    int x = 0, y = 0;
    df d(r * c);
    for (int i = 1; i < r; ++i) d.ladd(t[i][y]);
    for (int j = 1; j < c; ++j) d.radd(t[x][j]);
    while (x + 1 < r && y + 1 < c) {
        long long z = d.get();
        // cout << "z=" << z << '\n';
        q.push_back(z <= (long long) (r - 1 - x) * (c - 1 - y) - z);
        // cout << s << ' ' << w << ' ' << z << endl;
        if (q.back()) {
            for (int j = y + 1; j < c; ++j) d.rdel(t[x][j]);
            d.ldel(t[++x][y]);
            for (int j = y + 1; j < c; ++j) d.radd(t[x][j]);
        } else {
            for (int i = x + 1; i < r; ++i) d.ldel(t[i][y]);
            d.rdel(t[x][++y]);
            for (int i = x + 1; i < r; ++i) d.ladd(t[i][y]);
        }

        // for (int e : d.a.w) cout << e; cout << endl;
    }
    while (x + 1 < r) q.push_back(true), ++x;
    while (y + 1 < c) q.push_back(false), ++y;

    long long s = 0;
    x = 0, y = 0;
    for (bool b : q) {
            // cout << b;
        if (b) {
            for (int j = y; j < c; ++j) {
                s += f.get(t[x][j]);
                f.add(t[x][j], 1);
            }
            ++x;
        } else {
            for (int i = x; i < r; ++i) {
                s += f.get(t[i][y]);
                f.add(t[i][y], 1);
            }
            ++y;
        }
    }
    s += f.get(t[r - 1][c - 1]);
    // cout << endl;

    long long w = r * c;
    cout << w * (w - 1) / 2 - s;

    return 0;
}
