#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#define ll long long
#define ld long double

using namespace std;

struct segtree {
    struct node {
        int sum;
    };

    const node ZERO = {0};
    vector<node> t;
    int size;

    node merge(node a, node b) {
        return {a.sum + b.sum};
    }

    void init(int n) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        t.assign(size * 2 - 1, ZERO);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (tr <= l or tl >= r) {
            return 0;
        }
        if (tl >= l and tr <= r) {
            return t[v].sum;
        }
        int mid = (tl + tr) / 2;
        int res1 = get(v * 2 + 1, l, r, tl, mid);
        int res2 = get(v * 2 + 2, l, r, mid, tr);
        return res1 + res2;
    }

    int get(int l, int r) {
        if (l==r) {
            return 0;
        }
        return get(0, l, r, 0, size);
    }

    void update(int v, int ind, int x, int tl, int tr) {
        if (tr - tl == 1) {
            t[v] = {x};
            return;
        }
        int mid = (tl + tr) / 2;
        if (ind < mid) {
            update(v * 2 + 1, ind, x, tl, mid);
        } else {
            update(v * 2 + 2, ind, x, mid, tr);
        }
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    void update(int ind, int x) {
        update(0, ind, x, 0, size);
    }
};

int n, m;
vector<vector<int> > a;

void dany() {
    cin >> n >> m;
    a.resize(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }
    }
    if (n==1 and m==1) {
        cout<<0;
        return;
    }
    if (n==1) {
        ll ANS=0;
        segtree t;
        t.init(n*m);
        for (int j = m - 1; j >= 0; j--) {
            ANS+=t.get(0,a[0][j]);
            t.update(a[0][j],1);
        }
        cout<<ANS;
        return;
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1));
    vector<vector<ll> > str(n, vector<ll>(m)), stl(n, vector<ll>(m));
    vector<vector<ll> > kof1(n, vector<ll>(m)), kof2(n, vector<ll>(m));
    vector<segtree> t1(m), t2(n);
    for (int i = 0; i < m; i++) {
        t1[i].init(n * m);
        for (int i1=0;i1<n;i1++) {
            for (int j=0;j<i;j++) {
                t1[i].update(a[i1][j],1);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        t2[i].init(n * m);
        for (int i1=0;i1<i;i1++) {
            for (int j=0;j<m;j++) {
                t2[i].update(a[i1][j],1);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        segtree t;
        t.init(n*m);
        ll ANS=0;
        for (int j = m - 1; j >= 0; j--) {
            ANS+=t.get(0,a[i][j]);
            t.update(a[i][j],1);
            str[i][j]=ANS;
            ll ans = 0;
            for (int u = j; u < m; u++) {
                ans += t1[j].get(a[i][u] + 1, n * m);
            }
            kof1[i][j]=ans;
            for (int u = j; u < m; u++) {
                t1[j].update(a[i][u], 1);
            }
        }
    }
    for (int i = 0; i < m; i++) {
        segtree t;
        t.init(n*m);
        ll ANS=0;
        for (int j = n - 1; j >= 0; j--) {
            ANS+=t.get(0,a[j][i]);
            t.update(a[j][i],1);
            stl[j][i]=ANS;
            ll ans = 0;
            for (int u = j; u < n; u++) {
                ans += t2[j].get(a[u][i] + 1, n * m);
            }
            kof2[j][i]=ans;
            for (int u = j; u < n; u++) {
                t2[j].update(a[u][i], 1);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        dp[i][0] = dp[i - 1][0] + str[i - 1][0] + kof1[i - 1][0];
    }
    for (int i = 1; i <= m; i++) {
        dp[0][i] = dp[0][i - 1] + stl[0][i - 1] + kof2[0][i - 1];
    }
    ll res = LLONG_MAX;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (i == n) {
                if (j == m) {
                    break;
                }
                res = min(res, dp[i - 1][j] + str[i - 1][j] + kof1[i - 1][j]);
                continue;
            }
            if (j == m) {
                res = min(res, dp[i][j - 1] + stl[i][j - 1] + kof2[i][j - 1]);
                continue;
            }
            dp[i][j] = min(dp[i - 1][j] + str[i - 1][j] + kof1[i - 1][j],
                           dp[i][j - 1] + stl[i][j - 1] + kof2[i][j - 1]);
        }
    }
    cout << res;
}

signed main() {
    dany();
    return 0;
}
