#include <iostream>
#include <vector>
#include <queue>

struct point
{
    long long x;
    long long y;
};

struct state
{
    bool c;
    int p;
};

int main()
{
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n;
    long long r;
    std::cin >> n >> r;
    if (n < 3) {std::cout << '0'*n; return 0;}
    std::vector<point> v(n);
    for (int i = 0; i < n; i++)
        std::cin >> v[i].x >> v[i].y;
    std::vector<std::vector<bool> > g(n, std::vector<bool>(n));
    for (int i = 0; i < n; i++)
        for  (int j = i; j < n; j++)
            if (i == j)
                g[i][j] = 0;
            else
                g[i][j] = g[j][i] = ((v[i].x-v[j].x)*(v[i].x-v[j].x) + (v[i].y-v[j].y)*(v[i].y-v[j].y) <= r*r);
    std::queue<state> q;
    std::vector<bool> w(n, 0);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
            if (g[i][j] && w[j])
            {
                w[i] = 1;
                continue;
            }
        state s; s.p = i; s.c = 0;
        std::vector<state> seen;
        q.push(s);
        while (!q.empty())
        {
            state f; f.c = q.front().c; f.p = q.front().p;
            q.pop();
            if (f.p == i && f.c == 1)
            {
                w[i] = 1;
                break;
            }
            bool z = 1;
            for (int j = 0; j < seen.size(); j++)
                if (f.c == seen[j].c && f.p == seen[j].p)
                    z = 0;
            if (!z)
                continue;
            for (int j = 0; j < n; j++)
                if (g[f.p][j])
                {
                    state nw; nw.p = j; nw.c = !f.c;
                    q.push(nw);
                    seen.push_back(f);
                }
        }
    }
    for (int i = 0; i < n; i++)
        std::cout << w[i];
}