#include <iostream>
#include <vector>
#include <queue>

struct point
{
    long long x;
    long long y;
};

struct state
{
    bool c;
    int p;
};

long long r;

bool can(point a, point b)
{
    return ((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y) <= r*r);
}

int main()
{
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n;
    std::cin >> n >> r;
    if (n < 3) {for (; n > 0; n--) std::cout << '0'; return 0;}
    std::vector<point> v(n);
    for (int i = 0; i < n; i++)
        std::cin >> v[i].x >> v[i].y;
    std::queue<state> q;
    std::vector<bool> w(n, 0);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
            if (can(v[i], v[j]))
            {
                if (w[j])
                {
                    w[i] = 1;
                    continue;
                }
            }
        state s; s.p = i; s.c = 0;
        std::vector<state> seen;
        q.push(s);
        while (!q.empty())
        {
            state f; f.c = q.front().c; f.p = q.front().p;
            q.pop();
            if (f.p == i && f.c == 1)
            {
                w[i] = 1;
                break;
            }
            bool l = 1;
            for (int j = 0; j < seen.size(); j++)
                if (f.c == seen[j].c && f.p == seen[j].p)
                    l = 0;
            if (!l)
                continue;
            for (int j = 0; j < n; j++)
                if (f.p != j && can(v[f.p], v[j]))
                {
                    state nw; nw.p = j; nw.c = !f.c;
                    q.push(nw);
                    seen.push_back(f);
                }
        }
    }
    for (int i = 0; i < n; i++)
        std::cout << w[i];
}