#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else

#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>

using namespace std;

using ll = long long;
using i128 = __int128;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

const ll INF = 2e18;

vector<vector<int>> gr;
vector<int> comp, sz, ch;

void dfs1(int v, int c) {
    for (auto u : gr[v]) {
        if (comp[u] != c) {
            comp[u] = c;
            ++sz[c];
            ch[u] = ch[v] ^ 1;
            dfs1(u, c);
        }
    }
}

ll dist(pair<int, int> p1, pair<int, int> p2) {
    auto [x1, y1] = p1;
    auto [x2, y2] = p2;
    return (ll)(x1 - x2) * (x1 - x2) + (ll)(y1 - y2) * (y1 - y2);
}

ll calc(vector<pair<int, int>> p) {
    int n = szof(p);
    if (n < 2) {
        return INF;
    }
    int midx = p[n / 2].first;
    ll d = min(calc(vector(p.begin(), p.begin() + n / 2)), calc(vector(p.begin() + n / 2, p.end())));
    sort(p.begin(), p.end(), [](pair<int, int> p1, pair<int, int> p2) { return p1.second < p2.second; });
    ll res = d;
    vector<pair<int, int>> cand;
    for (int i = 0; i < n; ++i) {
        if ((ll)(p[i].first - midx) * (p[i].first - midx) < d) {
            while (!cand.empty() && (ll)(p[i].second - cand.back().second) * (p[i].second - cand.back().second) >= d) {
                cand.pop_back();
            }
            for (auto q : cand) {
                res = min(res, dist(q, p[i]));
            }
            cand.push_back(p[i]);
        }
    }
    return res;
}

void solve() {
    int n, r;
    cin >> n >> r;
    vector<pair<int, int>> p(n);
    for (auto& [x, y] : p) {
        cin >> x >> y;
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&p](int i, int j) { return p[i] < p[j]; });
    gr.resize(n);
    comp.resize(n);
    iota(comp.begin(), comp.end(), 0);
    sz.resize(n, 1);
    ch.resize(n);
    set<pair<int, int>> s;
    for (int i = 0, j = 0; i < n; ++i) {
        while (p[ord[j]].first + r < p[ord[i]].first || j + 1 < i) {
            s.erase({p[ord[j]].second, ord[j]});
            ++j;
        }
        auto itl = s.lower_bound({p[ord[i]].second - r, 0});
        auto itr = s.lower_bound({p[ord[i]].second + r + 1, 0});
        while (itl != itr) {
            int u = itl->second, v = ord[i];
            if (dist(p[u], p[v]) <= (ll)r * r && comp[u] != comp[v]) {
                gr[u].push_back(v);
                gr[v].push_back(u);
                if (sz[comp[u]] > sz[comp[v]]) {
                    swap(u, v);
                }
                dfs1(v, comp[v]);
            }
            ++itl;
        }
        s.emplace(p[ord[i]].second, ord[i]);
    }
    vector<vector<vector<pair<int, int>>>> g(n, vector<vector<pair<int, int>>>(2));
    for (auto i : ord) {
        g[comp[i]][ch[i]].push_back(p[i]);
    }
    vector<bool> gc(n);
    for (int i = 0; i < n; ++i) {
        gc[i] = calc(g[i][0]) <= (ll)r * r || calc(g[i][1]) <= (ll)r * r;
    }
    for (int i = 0; i < n; ++i) {
        cout << (gc[comp[i]] ? "1" : "0");
    }
    cout << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
