#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else

#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using i128 = __int128;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<int> b, ft(n * m + 1);
    for (int i = 1; i <= n * m; ++i) {
        ft[i] = i & -i;
    }
    for (int i = 0, j = 0; i < n && j < m;) {
        ll invi = 0;
        for (int k = j; k < m; ++k) {
            for (int g = a[i][k]; g <= n * m; g += g & -g) {
                --ft[g];
            }
        }
        for (int k = j; k < m; ++k) {
            for (int g = a[i][k]; g > 0; g -= g & -g) {
                invi += ft[g];
            }
        }
        for (int k = j; k < m; ++k) {
            for (int g = a[i][k]; g <= n * m; g += g & -g) {
                ++ft[g];
            }
        }
        ll invj = 0;
        for (int k = i; k < n; ++k) {
            for (int g = a[k][j]; g <= n * m; g += g & -g) {
                --ft[g];
            }
        }
        for (int k = i; k < n; ++k) {
            for (int g = a[k][j]; g > 0; g -= g & -g) {
                invj += ft[g];
            }
        }
        for (int k = i; k < n; ++k) {
            for (int g = a[k][j]; g <= n * m; g += g & -g) {
                ++ft[g];
            }
        }
        if (invi < invj) {
            for (int k = j; k < m; ++k) {
                b.push_back(a[i][k]);
                for (int g = a[i][k]; g <= n * m; g += g & -g) {
                    --ft[g];
                }
            }
            ++i;
        } else {
            for (int k = i; k < n; ++k) {
                b.push_back(a[k][j]);
                for (int g = a[k][j]; g <= n * m; g += g & -g) {
                    --ft[g];
                }
            }
            ++j;
        }
    }
    ll ans = 0;
    for (int i = 0; i < n * m; ++i) {
        ans += i;
        for (int j = b[i]; j > 0; j -= j & -j) {
            ans -= ft[j];
        }
        for (int j = b[i]; j <= n * m; j += j & -j) {
            ++ft[j];
        }
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
