#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else

#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using i128 = __int128;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1));
    vector<int> ft1(n * m + 1), ft2(n * m + 1);
    for (int i = n - 1; i >= 0; --i) {
        ll addi = 0;
        for (int j = m - 1; j >= 0; --j) {
            ll addj = 0;
            for (int k = a[i][j]; k > 0; k -= k & -k) {
                addi += ft1[k];
            }
            for (int k = a[i][j]; k <= n * m; k += k & -k) {
                ++ft2[k];
            }
            for (int k = n - 1; k >= i; --k) {
                for (int g = a[k][j]; g > 0; g -= g & -g) {
                    addj += ft1[g];
                }
                for (int g = a[k][j]; g <= n * m; g += g & -g) {
                    ++ft1[g];
                }
                if (k != i) {
                    addi += m - j;
                    for (int g = a[k][j]; g > 0; g -= g & -g) {
                        addi -= ft2[g];
                    }
                }
            }
            dp[i][j] = min(addi + dp[i + 1][j], addj + dp[i][j + 1]);
        }
        for (int j = m - 1; j >= 0; --j) {
            for (int k = a[i][j]; k <= n * m; k += k & -k) {
                --ft2[k];
            }
            for (int k = n - 1; k >= i; --k) {
                for (int g = a[k][j]; g <= n * m; g += g & -g) {
                    --ft1[g];
                }
            }
        }
    }
    cout << dp[0][0] << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
