#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
// #pragma GCC optimize("Ofast,unroll-loops")
#endif // LOCAL

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

using ll = long long;
using i128 = __int128;
using ui = unsigned int;
using ull = unsigned long long;

#define szof(x) (int)x.size()

int msb(ui n) {
    return 31 - countl_zero((ui)n);
}

int n, q;
vector<int> a, bolr, bi;
vector<vector<int>> spr;

int mmin(int i, int j) {
    if (a[i] < a[j]) {
        return i;
    }
    return j;
}

void calc(int k, int l, int r) {
    if (k == r - l - 1) {
        for (int i = l + 1; i < r; ++i) {
            bi.push_back(i);
        }
        return;
    }
    if (k == 0) {
        return;
    }
    int m = min(bolr[l], r);
    int lvl = msb(m - l);
    int i = mmin(spr[lvl][l], spr[lvl][m - (1 << lvl)]);
    if (i == l) {
        bi.push_back(m);
        calc(k - 1, m, r);
        return;
    }
    if (r - i < k) {
        for (int j = i + 1; j < r; ++j) {
            bi.push_back(j);
        }
        calc(k - (r - i) + 1, l, i);
        return;
    }
    if (m - i < k) {
        for (int j = i; j < m; ++j) {
            bi.push_back(j);
        }
        bi.push_back(m);
        calc(k - (m - i) - 1, m, r);
        return;
    }
    bi.push_back(i);
    if (k > 1) {
        bi.push_back(i + 1);
        calc(k - 2, i + 1, m);
    }
}

void solve() {
    cin >> n >> q;
    a.resize(n + 1, n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    bolr.resize(n);
    vector<int> st;
    st.push_back(n);
    for (int i = n - 1; i >= 0; --i) {
        while (a[i] > a[st.back()]) {
            st.pop_back();
        }
        bolr[i] = st.back();
        st.push_back(i);
    }
    spr.resize(msb(n) + 1);
    spr[0].resize(n);
    iota(spr[0].begin(), spr[0].end(), 0);
    for (int lvl = 1; (1 << lvl) <= n; ++lvl) {
        spr[lvl].resize(n - (1 << lvl) + 1);
        for (int i = 0; i + (1 << lvl) <= n; ++i) {
            spr[lvl][i] = mmin(spr[lvl - 1][i], spr[lvl - 1][i + (1 << (lvl - 1))]);
        }
    }
    vector<vector<pair<int, int>>> que(n + 1);
    for (int j = 0; j < q; ++j) {
        int k, i;
        cin >> k >> i;
        que[k].emplace_back(i, j);
    }
    vector<int> ans(q);
    for (int k = 1; k <= n; ++k) {
        if (!que[k].empty()) {
            bi.clear();
            bi.push_back(0);
            calc(k - 1, 0, n);
            sort(bi.begin(), bi.end());
            bi.emplace_back(n);
            vector<int> cost(k);
            for (int i = 0, j = -1; i < n; ++i) {
                if (i == bi[j + 1]) {
                    ++j;
                }
                cost[j] = max(cost[j], a[i]);
            }
            for (auto [i, j] : que[k]) {
                ans[j] = cost[i - 1];
            }
        }
    }
    for (auto el : ans) {
        cout << el + 1 << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif // LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
