#include <vector>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <string>
#include <array>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;


struct point{
    long long x, y;
};

long long dist(point p1, point p2){
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

const int MAX_N = 100000;
array<point, MAX_N> p;
array<vector<int>, MAX_N> g;
array<signed char, MAX_N> col;
array<signed char, MAX_N> ANS;

int n;
long long r;

bool dfs_col(int v, int c){
    if (col[v] != -1){
        return col[v] == c;
    }

    col[v] = c;
    for (auto u: g[v]){
        if (!dfs_col(u, !c)){
            return false;
        }
    }
    return true;
}

void dfs_ans(int v, vector<bool>& used, int ans){
    used[v] = true;
    ANS[v] = ans;
    for (auto u: g[v]){
        if (used[u]) continue;
        dfs_ans(u, used, ans);
    }
}


int main(){
    fill(ANS.begin(), ANS.end(), -1);
    fill(col.begin(), col.end(), -1);


    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> n >> r;
    int rr = r / sqrt(2);
    // cout << rr << endl;
    r *= r;

    for (int i = 0; i < n; i++){
        cin >> p[i].x >> p[i].y;
    }

    map<int, map<int, vector<int>>> mp;

    vector<pair<int, int>> buckets;
    queue<pair<int, int>> overf;

    for (int i = 0; i < n; i++){
        mp[p[i].x / rr][p[i].y / rr].push_back(i);
        // cout << "fds " << p[i].x / rr << ' ' << p[i].y / rr << endl;
        if (mp[p[i].x / rr][p[i].y / rr].size() == 1) buckets.push_back({p[i].x / rr, p[i].y / rr});
    }

    set<pair<int, int>> is_bad;

    for (auto k: buckets){
        if (mp[k.first][k.second].size() >= 3){
            overf.push(k);
            is_bad.insert(k);
        }
    }


    while (!overf.empty()){
        int si = overf.front().first, sj = overf.front().second;
        overf.pop();

        for (auto p1: mp[si][sj]){
            ANS[p1] = 1;
            for (int i = si  - 2; i <= si + 2; i++){
                for (int j = sj - 2; j <= sj + 2; j++){
                    if (i == si && j == sj) continue;
                    if (is_bad.count(make_pair(i, j))) continue;
                    
                    if (mp[i][j].size() >= 3) continue;

                    for (auto p2: mp[i][j]){
                        if (dist(p[p1], p[p2]) <= r){
                            overf.push({i, j});
                            is_bad.insert({i, j});
                            break;
                        }
                    }
                }
            }
        }

        mp[si][sj].clear();
    }

    vector<int> ost;
    for (auto b: buckets){
        for (auto p1: mp[b.first][b.second]){
            ost.push_back(p1);
        }
    }
    int m = ost.size();


    for (auto b: buckets){
        int si = b.first, sj = b.second;
        for (auto p1: mp[si][sj]){
            for (int i = si  - 2; i <= si + 2; i++){
                for (int j = sj - 2; j <= sj + 2; j++){

                    for (auto p2: mp[i][j]){
                        if (p1 == p2) continue;
                        if (dist(p[p1], p[p2]) <= r){
                            g[p1].push_back(p2);
                        }
                    }
                }
            }
        }
    }
 
    for (auto i: ost){
        if (ANS[i] != -1) continue;
        vector<bool> used(n);
        dfs_ans(i, used, !dfs_col(i, 0));
    }


    for (int i = 0; i < n; i++){
        cout << int(ANS[i]);
    }
    cout << endl;

    // for (auto k: ost){
    //     cout << k << ' ';
    // }cout << endl;

    // for (auto k: buckets){
    //     cout << k.first << ' ' << k.second << endl;
    // }cout << endl;
}