#include <iostream>
#include <vector>
#include <string>
#include <array>
#include <algorithm>
using namespace std;

struct point{
    long long x, y;
};

long long dist(point p1, point p2){
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

const int MAX_N = 10000;
vector<point> p(MAX_N);
vector<vector<int>> g(MAX_N);
vector<int> col(MAX_N, -1);
vector<int> ANS(MAX_N, -1);

int n;
long long r;

bool dfs_col(int v, int c){
    if (col[v] != -1){
        return col[v] == c;
    }

    col[v] = c;
    for (auto u: g[v]){
        if (!dfs_col(u, !c)){
            return false;
        }
    }
    return true;
}

void dfs_ans(int v, vector<bool>& used, int ans){
    used[v] = true;
    ANS[v] = ans;
    for (auto u: g[v]){
        if (used[u]) continue;
        dfs_ans(u, used, ans);
    }
}


int main(){
    cin >> n >> r;
    r *= r;

    for (int i = 0; i < n; i++){
        cin >> p[i].x >> p[i].y;
    }

    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            if (dist(p[i], p[j]) <= r){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    for (int i = 0; i < n; i++){
        if (ANS[i] != -1) continue;
        vector<bool> used(n);
        dfs_ans(i, used, !dfs_col(i, 0));
    }

    for (int i = 0; i < n; i++){
        cout << ANS[i];
    }
    cout << endl;
}