#include <vector>
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2")
#include <iostream>
#include <string>
#include <array>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;
 
 
 
long long dist(pair<long long, long long> p1, pair<long long, long long> p2){
    return (p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second);
}
 
const int MAX_N = 100000;
vector<pair<long long, long long>> p(MAX_N);
vector<vector<int>> g(MAX_N);
vector<short> col(MAX_N, -1);
vector<short> ANS(MAX_N, -1);
 
int n;
long long r;
 
bool dfs_col(int v, int c){
    if (col[v] != -1){
        return col[v] == c;
    }
 
    col[v] = c;
    for (auto u: g[v]){
        if (!dfs_col(u, !c)){
            return false;
        }
    }
    return true;
}
 
void dfs_ans(int v, vector<bool>& used, int ans){
    used[v] = true;
    ANS[v] = ans;
    for (auto u: g[v]){
        if (used[u]) continue;
        dfs_ans(u, used, ans);
    }
}
 
 
int main(){
    fill(ANS.begin(), ANS.end(), -1);
    fill(col.begin(), col.end(), -1);
 
 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
 
    cin >> n >> r;
    int rr = r / sqrt(2);
    // cout << rr << endl;
    r *= r;
 
    for (int i = 0; i < n; i++){
        cin >> p[i].first >> p[i].second;
    }
 
    // map<int, map<int, vector<int>>> mp;
    map<pair<int, int>, vector<int>> mp;

    vector<pair<int, int>> buckets;
    queue<pair<int, int>> overf;
 
    for (int i = 0; i < n; i++){
        mp[{p[i].first / rr, p[i].second / rr}].push_back(i);
        // cout << "fds " << p[i].first / rr << ' ' << p[i].second / rr << endl;
        if (mp[{p[i].first / rr, p[i].second / rr}].size() == 1) buckets.push_back({p[i].first / rr, p[i].second / rr});
    }
 
    set<pair<int, int>> is_bad;
 
    for (auto k: buckets){
        if (mp[{k.first, k.second}].size() >= 3){
            overf.push(k);
            is_bad.insert(k);
        }
    }
 
 
    while (!overf.empty()){
        int si = overf.front().first, sj = overf.front().second;
        overf.pop();
 
        for (auto p1: mp[{si, sj}]){
            ANS[p1] = 1;
            for (int i = si  - 2; i <= si + 2; i++){
                for (int j = sj - 2; j <= sj + 2; j++){
                    if (i == si && j == sj) continue;
                    if (is_bad.count(make_pair(i, j))) continue;
                     
                    if (mp[{i, j}].size() >= 3) continue;
 
                    for (auto p2: mp[{i, j}]){
                        if (dist(p[p1], p[p2]) <= r){
                            overf.push({i, j});
                            is_bad.insert({i, j});
                            break;
                        }
                    }
                }
            }
        }
 
        mp[{si, sj}].clear();
    }
 
    vector<int> ost;
    ost.reserve(n);
    for (auto b: buckets){
        for (auto p1: mp[{b.first, b.second}]){
            ost.push_back(p1);
        }
    }
    int m = ost.size();
 
 
    for (auto b: buckets){
        int si = b.first, sj = b.second;
        for (auto p1: mp[b]){
            for (int i = si  - 2; i <= si + 2; i++){
                for (int j = sj - 2; j <= sj + 2; j++){
 
                    for (auto p2: mp[{i, j}]){
                        if (p1 == p2) continue;
                        if (dist(p[p1], p[p2]) <= r){
                            g[p1].push_back(p2);
                        }
                    }
                }
            }
        }
    }
    
    vector<bool> used(n);
    for (auto i: ost){
        if (ANS[i] != -1) continue;
        dfs_ans(i, used, !dfs_col(i, 0));
    }
 
 
    for (int i = 0; i < n; i++){
        cout << int(ANS[i]);
    }
    cout << endl;
 
    // for (auto k: ost){
    //     cout << k << ' ';
    // }cout << endl;
 
    // for (auto k: buckets){
    //     cout << k.first << ' ' << k.second << endl;
    // }cout << endl;
}