#include <iostream>
#include <vector>
#include <string>
#include <array>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <queue>
using namespace std;

struct point{
    long long x, y;
};

long long dist(point p1, point p2){
    return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y);
}

const int MAX_N = 100000;
vector<point> p(MAX_N);
vector<vector<int>> g(MAX_N);
vector<short> col(MAX_N, -1);
vector<short> ANS(MAX_N, -1);

int n;
long long r;

bool dfs_col(int v, int c){
    if (col[v] != -1){
        return col[v] == c;
    }

    col[v] = c;
    for (auto u: g[v]){
        if (!dfs_col(u, !c)){
            return false;
        }
    }
    return true;
}

void dfs_ans(int v, vector<bool>& used, int ans){
    used[v] = true;
    ANS[v] = ans;
    for (auto u: g[v]){
        if (used[u]) continue;
        dfs_ans(u, used, ans);
    }
}


int main(){
    cin >> n >> r;
    long long rr = r / sqrt(2);
    // cout << rr << endl;
    r *= r;

    for (int i = 0; i < n; i++){
        cin >> p[i].x >> p[i].y;
    }

    unordered_map<long long, unordered_map<long long, vector<int>>> mp;

    vector<pair<long long, long long>> buckets;
    queue<pair<long long, long long>> overf;

    for (int i = 0; i < n; i++){
        mp[p[i].x / rr][p[i].y / rr].push_back(i);
        // cout << "fds " << p[i].x / rr << ' ' << p[i].y / rr << endl;
        if (mp[p[i].x / rr][p[i].y / rr].size() == 1) buckets.push_back({p[i].x / rr, p[i].y / rr});
    }

    for (auto k: buckets){
        if (mp[k.first][k.second].size() >= 3){
            overf.push(k);
        }
    }

    while (!overf.empty()){
        long long si = overf.front().first, sj = overf.front().second;
        overf.pop();

        for (auto p1: mp[si][sj]){
            ANS[p1] = 1;
            for (int i = si  - 2; i <= si + 2; i++){
                for (int j = sj - 2; j <= sj + 2; j++){
                    if (i == si && j == sj) continue;
                    
                    if (mp[i][j].size() >= 3) continue;

                    for (auto p2: mp[i][j]){
                        if (dist(p[p1], p[p2]) <= r){
                            overf.push({i, j});
                            break;
                        }
                    }
                }
            }
        }

        mp[si][sj].clear();
    }

    vector<int> ost;
    for (auto b: buckets){
        for (auto p1: mp[b.first][b.second]){
            ost.push_back(p1);
        }
    }
    int m = ost.size();


    for (int i = 0; i < m; i++){
        for (int j = i + 1; j < m; j++){
            if (dist(p[ost[i]], p[ost[j]]) <= r){
                g[ost[i]].push_back(ost[j]);
                g[ost[j]].push_back(ost[i]);
            }
        }
    }
 
    for (auto i: ost){
        if (ANS[i] != -1) continue;
        vector<bool> used(n);
        dfs_ans(i, used, !dfs_col(i, 0));
    }


    for (int i = 0; i < n; i++){
        cout << ANS[i];
    }
    cout << endl;

    // for (auto k: ost){
    //     cout << k << ' ';
    // }cout << endl;

    // for (auto k: buckets){
    //     cout << k.first << ' ' << k.second << endl;
    // }cout << endl;
}