#include <vector>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <string>
#include <array>
#include <algorithm>
#include <unordered_map>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;

const long long INF = 1e18;

struct Fenwik{
    vector<int> f;

    long long inv = 0;

    // Fenwik(int n): f(n + 1){};

    int lower(int x){
        int ans = 0;
        for (int i = x - 1; i >= 0; i = (i & (i + 1)) - 1){
            ans += f[i];
        }
        return ans;
    }

    void insert(int x){
        for (int i = x; i <= f.size(); i |= i + 1){
            f[i]++;
        }

        inv += lower(x);
    }

    void resize(int n){
        f.resize(n + 1);
    }
};


int main(){
    // Fenwik ff;
    // ff.resize(10);
    // ff.insert(2);
    // ff.insert(6);
    // cout << ff.lower(7) << endl;
    // return 0;

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> w(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> w[i][j];
        }
    }

    vector<vector<int>> inv_r(n, vector<int>(m));
    vector<Fenwik> f(m);
    for (auto& k: f) k.resize(n * m);
    for (int i = n - 1; i >= 0; i--){
        for (int j = m - 1; j >= 0; j--){
            for (int k = j; k >= 0; k--){
                f[k].insert(w[i][j]);
                inv_r[i][k] += f[k].lower(w[i][j]);
                // cout << "df " << i << ' ' << j << ' ' << k << ' ' << f[k].lower(w[i][j]) << endl;
            }
        }
    }

    vector<vector<int>> inv_d(n, vector<int>(m));
    vector<Fenwik> f1(n);
    for (auto& k: f1) k.resize(n * m);
    for (int j = m - 1; j >= 0; j--){
        for (int i = n - 1; i >= 0; i--){
            for (int k = i; k >= 0; k--){
                f1[k].insert(w[i][j]);
                inv_d[k][j] += f1[k].lower(w[i][j]);
            }
        }
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1));

    for (int i = n - 1; i >= 0; i--){
        for (int j = m - 1; j >= 0; j--){
            dp[i][j] = min(dp[i + 1][j] + inv_r[i][j], dp[i][j + 1] + inv_d[i][j]);
        }
    }

    cout << dp[0][0] << endl;

    // for (auto k: inv_r){
    //     for (auto kk: k){
    //         cout << kk << ' ';
    //     }
    //     cout << endl;
    // }
}