#include "iostream"
#include "queue"
#include "vector"
#include "unordered_map"
using namespace std;
//#define int long long
constexpr int maxn = 100'000;
vector<int> graph[maxn];
int color[maxn]{};
int curcol = 1;
void colorisation(int x) {
    if (color[x]) return;
    color[x] = curcol;
    for (auto& i : graph[x]) {
        colorisation(i);
    }
}
bool can;
char used_color[maxn];
int used[maxn]{};
void dfs_can(int x, int len) {
    if (used[x]) {
        if (used[x] % 2 != len % 2) {
            can = true;
        }
        return;
    }
    used[x] = len;
    for (auto& i : graph[x]) {
        dfs_can(i, len + 1);
        if (can) return;
    }
}
vector<pair<long long, long long>> pairs;
inline long long d(long long x) { return x * x; }
unordered_map<int, unordered_map<int, vector<int>>> card;
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n; cin >> n;
    long long dr;
    int r; cin >> r; dr = d(r);
    pairs.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> pairs[i].first >> pairs[i].second;
        card[pairs[i].first / r][pairs[i].second / r].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        for (int dx = -1; dx <= 1; dx++) {
            for (int dy = -1; dy <= 1; dy++) {
                for (auto& j : card[pairs[i].first / r + dx][pairs[i].second / r + dy]) {
                    if (j <= i) continue;
                    if (d(pairs[i].first - pairs[j].first) + d(pairs[i].second - pairs[j].second) <= dr) {
                        graph[i].push_back(j);
                        graph[j].push_back(i);
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!color[i]) {
            colorisation(i);
            curcol++;
        }
    }
    fill(used_color, used_color + curcol, -1);
    for (int i = 0; i < n; i++) {
        if (used_color[color[i]] == -1) {
            can = false;
            dfs_can(i, 1);
            used_color[color[i]] = can;
        }
        cout << (int)used_color[color[i]];
    }
}