#include "iostream"
#include "queue"
#include "vector"
#include "algorithm"
using namespace std;
//#define int long long
#define all(arr) arr.begin(), arr.end()
constexpr int maxn = 100'000;
vector<int> graph[maxn];
vector<int> color;
int curcol = 1;
void colorisation(int x) {
    if (color[x]) return;
    color[x] = curcol;
    for (auto& i : graph[x]) {
        colorisation(i);
    }
}
bool can;
vector<char> used_color;
vector<int> used;
void dfs_can(int x, int len) {
    if (used[x]) {
        if (used[x] % 2 != len % 2) {
            can = true;
        }
        return;
    }
    used[x] = len;
    for (auto& i : graph[x]) {
        dfs_can(i, len + 1);
        if (can) return;
    }
}
inline long long d(long long x) { return x * x; }
struct point {
    long long x;
    long long y;
    int ind;
};
vector<point> pairs;
auto cmp = [](const point& p1, const point& p2) { return p1.x < p2.x; };
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n; cin >> n;
    used.resize(n,0);
    long long dr;
    int r; cin >> r; dr = d(r);
    pairs.resize(n);
    color.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> pairs[i].x >> pairs[i].y;
        pairs[i].ind = i;
    }
    sort(all(pairs), cmp);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (pairs[j].x - pairs[i].x > r) break;
            if (d(pairs[i].x - pairs[j].x) + d(pairs[i].y - pairs[j].y) <= dr) {
                graph[pairs[i].ind].push_back(pairs[j].ind);
                graph[pairs[j].ind].push_back(pairs[i].ind);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!color[i]) {
            colorisation(i);
            curcol++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!color[i]) {
            colorisation(i);
            curcol++;
        }
    }
    used_color.resize(curcol, -1);
    for (int i = 0; i < n; i++) {
        if (used_color[color[i]] == -1) {
            can = false;
            dfs_can(i, 1);
            used_color[color[i]] = can;
        }
        cout << (int)used_color[color[i]];
    }
}