#include "iostream"
#include "queue"
#include "vector"
#include "stack"
using namespace std;
//#define int long long
constexpr int maxn = 300'000;
constexpr int maxlog = 19;
int _lg[maxn + 1];
typedef pair<int, int> pi;
pi sparse[maxlog][maxn]{};
vector<int> arr;
vector<int> next_bigger;
void build_sparse(int n) {
    for (int i = 0; i < n; i++) sparse[0][i] = {arr[i], i};
    for (int i = 1; i <= _lg[n]; i++) {
        for (int j = 0; j <= n - (1 << i); j++) {
            sparse[i][j] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
        }
    }
}
inline pi get_mn(int l, int r) {
    int curlog = _lg[r - l];
    return min(sparse[curlog][l], sparse[curlog][r - (1 << curlog)]);
}
vector<vector<int>> ans;
vector<int> suff_max;
void build(int k, int n) {
    if (k == 1) {
        ans[k - 1].push_back(n);
        return;
    }
    ans[k - 1].push_back(arr[0]);
    int end = min(n - (k - 2), (next_bigger[0] == n ? n : next_bigger[0] + 1));
    int start = 1;
    pi res;
    for (int i = k - 2; i > 0; i--) {
        res = get_mn(start, end);
        ans[k - 1].push_back(res.first);
        //if (ans[k - 1].size() >= 3) break;
        start = res.second + 1;
        end = min(n - i + 1, (next_bigger[res.second] == n ? n : next_bigger[res.second] + 1));
    }
    ans[k-1].push_back((end == n ? arr[n - 1] : suff_max[start]));
}
signed main() {
    _lg[0] = -1;
    for (int i = 1; i <= maxn; i++) _lg[i] = 1 + _lg[i >> 1];
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q; cin >> n >> q;
    arr.resize(n);
    for (int i = 0; i < n; i++) cin >> arr[i];
    next_bigger.resize(n, n);
    suff_max.resize(n);
    suff_max[n - 1] = arr[n - 1];
    for (int i = n - 2; i >= 0; i--) suff_max[i] = max(suff_max[i + 1], arr[i]);
    stack<int> st;
    for (int i = n - 1; i >= 0; i--) {
        while (st.size() && arr[i] > arr[st.top()]) st.pop();
        if (st.size()) next_bigger[i] = st.top();
        st.push(i);
    }
    build_sparse(n);
    ans.resize(n, vector<int>(0));
    int k, i;
    while (q--) {
        cin >> k >> i;
        /*if (ans[k - 1].empty()) {
            build(k, n);
        }*/
        if (k != i) {
            cout << arr[i - 1];
        } else {
            if (k <= 2) {
                cout << n;
            } else {
                cout << arr[n - 1];
            }
        }
        //cout << ans[k - 1][i - 1];
        cout << '\n';
    }
}