#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct pt
{
    ll x, y;
};

pt operator-(pt x, pt y)
{
    return {x.x - y.x, x.y - y.y};
}

ll len2(pt x)
{
    return x.x * x.x + x.y * x.y;
}

vector<int> dsu;
vector<int> sz;

void init(int n)
{
    dsu.assign(n, 0);
    sz.assign(n, 1);
    for (int i = 0; i < n; ++i)
    {
        dsu[i] = i;
    }
}

int get_set(int v)
{
    if (v == dsu[v]) return v;
    dsu[v] = get_set(dsu[v]);
    return dsu[v];
}

void merge(int v, int u)
{
    v = get_set(v);
    u = get_set(u);
    if (v == u) return;
    if (sz[v] < sz[u]) swap(v, u);
    sz[v] += sz[u];
    dsu[u] = v;
}

vector<vector<int>> g;
bool ch = 0;
vector<int> col;
vector<int> vs;

void dfs(int v, int c)
{
    col[v] = c;
    vs.push_back(v);
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
        if (col[u] == col[v])
        {
            ch = 1;
        }
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    ll n, r;
    cin >> n >> r;
    g.resize(n);
    col.resize(n);
    vector<pt> a(n);
    bool ch5 = 1;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].x >> a[i].y;
        if (a[i].y != 0) ch5 = 0;
    }
    if (ch5)
    {
        vector<pair<ll, int>> b;
        for (int i = 0; i < n; ++i)
        {
            auto p = a[i];
            b.push_back({p.x, i});
        }
        sort(all(b));
        vector<int> pls(n);
        for (int i = 0; i < n; ++i)
        {
            pls[b[i].second] = i;
        }
        for (int i = 0; i < n; ++i)
        {
            int pl = pls[i];
            if (pl >= 2 && b[pl].first - b[pl - 2].first <= r)
            {
                cout << 1;
                continue;
            }
            if (pl + 2 < n && b[pl + 2].first - b[pl].first <= r)
            {
                cout << 1;
                continue;
            }
            cout << 0;
        }
        return 0;
    }
    //init(n);
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            if (len2(a[i] - a[j]) <= r * r)
            {
                g[i].push_back(j);
                g[j].push_back(i);
                //merge(i, j);
            }
        }
    }
    vector<int> ans(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (!col[i])
        {
            ch = 0;
            dfs(i, 1);
            if (ch)
            {
                for (int v : vs)
                {
                    ans[v] = 1;
                }
            }
            vs.clear();
        }
    }
    for (int i = 0; i < n; ++i)
    {
        cout << ans[i];
    }

    return 0;
}

