#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct pt
{
    ll x, y;
};

pt operator-(pt x, pt y)
{
    return {x.x - y.x, x.y - y.y};
}

ll len2(pt x)
{
    return x.x * x.x + x.y * x.y;
}

vector<int> dsu;
vector<int> sz;

void init(int n)
{
    dsu.assign(n, 0);
    sz.assign(n, 1);
    for (int i = 0; i < n; ++i)
    {
        dsu[i] = i;
    }
}

int get_set(int v)
{
    if (v == dsu[v]) return v;
    dsu[v] = get_set(dsu[v]);
    return dsu[v];
}

void merge(int v, int u)
{
    v = get_set(v);
    u = get_set(u);
    if (v == u) return;
    if (sz[v] < sz[u]) swap(v, u);
    sz[v] += sz[u];
    dsu[u] = v;
}

vector<vector<int>> g;
bool ch = 0;
vector<int> col;
vector<int> vs;
const ll Mod = 5e8 + 1;

void dfs(int v, int c)
{
    col[v] = c;
    vs.push_back(v);
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
        if (col[u] == col[v])
        {
            ch = 1;
        }
    }
}

unordered_map<ll, int> mp;

ll f(ll x, ll y)
{
    return x * Mod + y;
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    ll n, r;
    cin >> n >> r;
    g.resize(n);
    col.resize(n);
    vector<pt> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].x >> a[i].y;
        mp[f(a[i].x, a[i].y)] = i;
    }
    //init(n);
    for (ll dx = -r; dx <= r; ++dx)
    {
        ll k = sqrt(r * r - dx * dx);
        for (ll dy = -k; dy <= k; ++dy)
        {
            if (dx == 0 && dy == 0) continue;
            if (dx * dx + dy * dy > r * r) continue;
            for (int i = 0; i < n; ++i)
            {
                if (mp.find(f(a[i].x + dx, a[i].y + dy)) != mp.end())
                {
                    int j = mp[f(a[i].x + dx, a[i].y + dy)];
                    if (i > j) continue;
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }
    }
    vector<int> ans(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (!col[i])
        {
            ch = 0;
            dfs(i, 1);
            if (ch)
            {
                for (int v : vs)
                {
                    ans[v] = 1;
                }
            }
            vs.clear();
        }
    }
    for (int i = 0; i < n; ++i)
    {
        cout << ans[i];
    }

    return 0;
}
