#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
//#pragma GCC optimize("Ofast,unroll-loops")

using namespace std;
using ll = long long;

struct pt
{
    ll x, y;
};

pt operator-(pt x, pt y)
{
    return {x.x - y.x, x.y - y.y};
}

ll len2(pt x)
{
    return x.x * x.x + x.y * x.y;
}

vector<vector<int>> g;
bool ch = 0;
vector<int> col;
vector<int> vs;
const ll Mod = 5e8 + 1;

void dfs(int v, int c)
{
    col[v] = c;
    vs.push_back(v);
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
        if (col[u] == col[v])
        {
            ch = 1;
        }
    }
}

map<int, vector<pair<ll, int>>> mp;
vector<pt> a;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    ll n, r;
    cin >> n >> r;
    g.resize(n);
    col.resize(n);
    a.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].x >> a[i].y;
        mp[a[i].x].push_back({a[i].y, i});
    }
    for (auto p : mp)
    {
        sort(all(mp[p.first]));
    }
    //init(n);
    for (ll dx = 0; dx <= r; ++dx)
    {

        ll k = sqrt(r * r - dx * dx);
        k += 2;
        /*for (ll dy = -k; dy <= k; ++dy)
        {
            if (dx == 0 && dy == 0) continue;
            if (dx * dx + dy * dy > r * r) continue;
            for (int i = 0; i < n; ++i)
            {
                if (mp.find(f(a[i].x + dx, a[i].y + dy)) != mp.end())
                {
                    int j = mp[f(a[i].x + dx, a[i].y + dy)];
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }*/
        for (int i = 0; i < n; ++i)
        {
            auto itl = lower_bound(all(mp[a[i].x + dx]), (pair<ll, int>){a[i].y - k, -1});
            auto itr = upper_bound(all(mp[a[i].x + dx]), (pair<ll, int>){a[i].y + k, -1});
            for (auto it = itl; it != itr; ++it)
            {
                int j = it->second;
                if (i == j || len2(a[i] - a[j]) > r * r) continue;
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector<int> ans(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (!col[i])
        {
            ch = 0;
            dfs(i, 1);
            if (ch)
            {
                for (int v : vs)
                {
                    ans[v] = 1;
                }
            }
            vs.clear();
        }
    }
    for (int i = 0; i < n; ++i)
    {
        cout << ans[i];
    }

    return 0;
}
