#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

struct pt
{
    ll x, y;
};

pt operator-(pt x, pt y)
{
    return {x.x - y.x, x.y - y.y};
}

ll len2(pt x)
{
    return x.x * x.x + x.y * x.y;
}

vector<int> dsu;
vector<int> sz;

void init(int n)
{
    dsu.assign(n, 0);
    sz.assign(n, 1);
    for (int i = 0; i < n; ++i)
    {
        dsu[i] = i;
    }
}

int get_set(int v)
{
    if (v == dsu[v]) return v;
    dsu[v] = get_set(dsu[v]);
    return dsu[v];
}

void merge(int v, int u)
{
    v = get_set(v);
    u = get_set(u);
    if (v == u) return;
    if (sz[v] < sz[u]) swap(v, u);
    sz[v] += sz[u];
    dsu[u] = v;
}

vector<vector<int>> g;
bool ch = 0;
vector<int> col;

void dfs(int v, int c)
{
    col[v] = c;
    for (int u : g[v])
    {
        if (!col[u])
        {
            dfs(u, 3 - c);
        }
        if (col[u] == col[v])
        {
            ch = 1;
        }
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    ll n, r;
    cin >> n >> r;
    g.resize(n);
    col.resize(n);
    vector<pt> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i].x >> a[i].y;
    }
    //init(n);
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            if (len2(a[i] - a[j]) <= r * r)
            {
                g[i].push_back(j);
                g[j].push_back(i);
                //merge(i, j);
            }
        }
    }
    dfs(0, 1);
    for (int i = 0; i < n; ++i)
    {
        //if (get_set(0) != get_set(i))
        if (col[i] == 0)
        {
            cout << 0;
            continue;
        }
        if (ch || col[i] != col[0])
        {
            cout << 1;
            continue;
        }
        cout << 0;
    }

    return 0;
}

