#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

int n, m;
vector<vector<int>> mtx;
const ll INF = 1e18;
ll ans = INF;

struct Seg_tree
{
    vector<int> tree;
    int n;
    Seg_tree(int _n)
    {
        n = _n;
        tree.resize(4 * n, 0);
    }
    void update(int v, int l, int r, int pos)
    {
        if (l > pos || r <= pos) return;
        if (r - l == 1)
        {
            tree[v] += 1;
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, pos);
        update(2 * v + 2, m, r, pos);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }
    int get_sum(int v, int l, int r, int ql, int qr)
    {
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr) return tree[v];
        int m = (l + r) / 2;
        return get_sum(2 * v + 1, l, m, ql, qr) + get_sum(2 * v + 2, m, r, ql, qr);
    }
};

void make(int cnt, int n1, int m1, vector<int> &b)
{
    if (cnt == 0)
    {
        //for (int x : b) cout << x << ' ';
        //cout << '\n';
        int k = n * m;
        Seg_tree tree(k + 1);
        ll cur = 0;
        for (int i = 0; i < k; ++i)
        {
            cur += tree.get_sum(0, 0, k + 1, b[i] + 1, k + 1);
            tree.update(0, 0, k + 1, b[i]);
        }
        //cout << cur << '\n';
        ans = min(ans, cur);
        return;
    }
    for (int i = m - m1; i < m; ++i)
    {
        b.push_back(mtx[n - n1][i]);
    }
    make(cnt - m1, n1 - 1, m1, b);
    for (int i = m - m1; i < m; ++i)
    {
        b.pop_back();
    }
    for (int i = n - n1; i < n; ++i)
    {
        b.push_back(mtx[i][m - m1]);
    }
    make(cnt - n1, n1, m1 - 1, b);
    for (int i = n - n1; i < n; ++i)
    {
        b.pop_back();
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> m;
    mtx.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cin >> mtx[i][j];
        }
    }
    vector<int> b;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            b.push_back(mtx[i][j]);
        }
    }
    int k = n * m;
    Seg_tree tree(k + 1);
    ll cur = 0;
    for (int i = 0; i < k; ++i)
    {
        cur += tree.get_sum(0, 0, k + 1, b[i] + 1, k + 1);
        tree.update(0, 0, k + 1, b[i]);
    }
    cout << cur;
    //vector<int> b;
    //make(n * m, n, m, b);
    //cout << ans;

    return 0;
}

