#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

using namespace std;
using ll = long long;

int n, m;
vector<vector<int>> mtx;
const ll INF = 1e18;
ll ans = INF;

struct Seg_tree
{
    vector<int> tree;
    int n;
    Seg_tree(int _n)
    {
        n = _n;
        tree.resize(4 * n, 0);
    }
    void update(int v, int l, int r, int pos)
    {
        if (l > pos || r <= pos) return;
        if (r - l == 1)
        {
            tree[v] += 1;
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, pos);
        update(2 * v + 2, m, r, pos);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }
    int get_sum(int v, int l, int r, int ql, int qr)
    {
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr) return tree[v];
        int m = (l + r) / 2;
        return get_sum(2 * v + 1, l, m, ql, qr) + get_sum(2 * v + 2, m, r, ql, qr);
    }
};

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> m;
    mtx.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cin >> mtx[i][j];
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, INF));
    dp[1][1] = 0;
    for (int i = 2; i <= n; ++i)
    {
        dp[i][1] = dp[i - 1][1];
        for (int j = n - (i - 1); j < n; ++j)
        {
            if (mtx[n - i][m - 1] > mtx[j][m - 1])
            {
                dp[i][1] += 1;
            }
        }
    }
    for (int j = 2; j <= m; ++j)
    {
        dp[1][j] = dp[1][j - 1];
        for (int i = m - (j - 1); i < m; ++i)
        {
            if (mtx[n - 1][m - j] > mtx[n - 1][j])
            {
                dp[1][j] += 1;
            }
        }
    }
    cout << dp[n][m];

    return 0;
}
