#pragma GCC optimize("O2,O3,unroll-loops")
#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, r;

bool inter(array<int, 2> a, array<int, 2> b) {
    int dx = a[0] - b[0], dy = a[1] - b[1];
    return dx * dx + dy * dy <= r * r;
}

const int maxn = 1e5 + 123;

vector<int> adj[maxn];

int col[maxn], used[maxn];

bool odd = false;

vector<int> cur;

void dfs(int v, int c) {
    used[v] = true;
    cur.push_back(v);
    col[v] = c;
    for (int i : adj[v]) {
        if (col[i] == col[v]) {
            odd = true;
        }
        if (col[i] == -1) {
            dfs(i, 1 - c);
        }
    }
}

signed main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> r;
    vector<array<int, 2>> pts(n);
    for (auto& [x, y] : pts) cin >> x >> y;
    unordered_map<int, unordered_map<int, int>> idx;
    for (int i = 0; i < n; i++) {
        auto [x, y] = pts[i];
        idx[x][y] = i;
    }
    for (int i = 0; i < n; i++) {
        auto [x, y] = pts[i];
        if (i > 0 && inter(pts[i], pts[0])) {
            adj[i].push_back(0);
            adj[0].push_back(i);
        }
        for (int dx = 0; dx <= r; dx++) {
            for (int dy = -r; dy <= r; dy++) {
                if (dx * dx + dy * dy > r * r) continue;
                int j = idx[x + dx][y + dy];
                if (j > 0 && inter(pts[i], pts[j]) && i != j) {
                    adj[i].push_back(j);
                    adj[j].push_back(i);
                }
            }
        }
    }
    fill(col, col + n, -1);
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        cur.clear();
        odd = false;
        dfs(i, 0);
        for (int i : cur) {
            ans[i] = odd;
        }
    }
    for (int i : ans) cout << i;
    cout << "\n";
}