#include <bits/stdc++.h>
#define int long long

using namespace std;

const int maxn = 100 + 5, maxm = 1e4 + 5;

int mat[maxn][maxm];

int n, m;

vector<int> tree[maxn][maxm * 4];

void merge(vector<int>& a, vector<int>& b, vector<int>& c) {
    int ita = 0, itb = 0;
    while (ita < a.size() && itb < b.size()) {
        if (a[ita] < b[itb]) {
            c.push_back(a[ita++]);
        } else {
            c.push_back(b[itb++]);
        }
    }
    while (ita < a.size()) {
        c.push_back(a[ita++]);
    }
    while (itb < b.size()) {
        c.push_back(b[itb++]);
    }
}

void build(int row, int v, int l, int r) {
    if (l + 1 == r) {
        tree[row][v] = {mat[row][l]};
        return;
    }
    int m = (l + r) / 2;
    build(row, 2 * v + 1, l, m);
    build(row, 2 * v + 2, m, r);
    merge(tree[row][2 * v + 1], tree[row][2 * v + 2], tree[row][v]);
}

int get(int row, int v, int l, int r, int left, int right, int q) {
    if (r <= left || right <= l) return 0;
    if (l == left && r == right) {
        return upper_bound(tree[row][v].begin(), tree[row][v].end(), q) - tree[row][v].begin();
    }
    int m = (l + r) / 2;
    int lres = get(row, 2 * v + 1, l, m, left, min(m, right), q);
    int rres = get(row, 2 * v + 2, m, r, max(m, left), right, q);
    return lres + rres;
}

int getless(int row, int left, int right, int q) {
    return get(row, 0, 0, m, left, right, q);
}

int getmore(int row, int left, int right, int q) {
    return right - left - get(row, 0, 0, m, left, right, q);
}

int row_inv[maxn][maxm];
int col_inv[maxn][maxm];
int dp[maxn][maxm];

signed main() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mat[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        build(i, 0, 0, m);
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            dp[i][j] = 1e15;
            row_inv[i][j] = 0;
            if (j + 1 < m) {
                row_inv[i][j] = row_inv[i][j + 1];
            }
            for (int k = i; k < n; k++) {
                row_inv[i][j] += getless(k, j + 1, m, mat[i][j]);
            }
            for (int k = i + 1; k < n; k++) {
                row_inv[i][j] += getmore(i, j + 1, m, mat[k][j]);
            }
            if (i + 1 < n) {
                dp[i][j] = row_inv[i][j] + dp[i + 1][j];
            } else {
                dp[i][j] = row_inv[i][j];
            }
            col_inv[i][j] = 0;
            if (i + 1 < n) {
                col_inv[i][j] = col_inv[i + 1][j];
            }
            for (int k = i; k < n; k++) {
                col_inv[i][j] += getless(k, j + 1, m, mat[i][j]);
            }
            for (int k = i + 1; k < n; k++) {
                col_inv[i][j] += getless(i, j + 1, m, mat[k][j]);
            }
            if (j + 1 < m) {
                dp[i][j] = min(dp[i][j], col_inv[i][j] + dp[i][j + 1]);
            } else {
                dp[i][j] = min(dp[i][j], col_inv[i][j]);
            }
        }
    }
    cout << dp[0][0] << "\n";
}