#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOC
#define debug(x) cerr << #x << " = " << x << '\n';
#else
#define debug(x)
#endif

ll dist(pair<int, int> a, pair<int, int> b) {
    return 1ll * (a.first - b.first) * (a.first - b.first) +
           1ll * (a.second - b.second) * (a.second - b.second);
}

bool dfs(int v, vector<vector<int>>& graph, vector<int>& clr, int c) {
    clr[v] = c;
    bool res = true;
    for (auto u : graph[v]) {
        if (clr[u] == clr[v]) {
            res = false;
            continue;
        }
        if (clr[u] == -1) {
            res &= dfs(u, graph, clr, 1 - c);
        }
    }
    return res;
}

void dfs2(int v, vector<vector<int>>& graph, vector<int>& ans, bool f) {
    ans[v] = f;
    for (auto u : graph[v]) {
        if (ans[u] == -1) dfs2(u, graph, ans, f);
    }
}

ll conv(pair<int, int> a) {
    return a.first * 2000000000ll + a.second;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, r;
    cin >> n >> r;
    if (n == 2) {
        cout << "00\n";
        return 0;
    }
    vector<pair<int, int>> A(n);
    for (auto& i : A) {
        cin >> i.first >> i.second;
    }
    unordered_map<ll, int> mp;
    for (int i = 0; i < (int)A.size(); i++) {
        mp[conv(A[i])] = i;
    }
    vector<vector<int>> graph(n);
    for (int i = 0; i < n; i++) {
        for (int x = A[i].first - r; x <= A[i].first + r; x++) {
            for (int y = A[i].second; dist(A[i], {x, y}) <= 1ll * r * r; y++) {
                auto it = mp.find(conv({x, y}));
                if (it != mp.end()) {
                    int j = (*it).second;
                    if (A[i].second == A[j].second && j <= i) continue;
                    graph[i].push_back(j);
                    graph[j].push_back(i);
                }
            }
        }
    }
    vector<int> clr(n, -1);
    vector<int> ans(n, -1);
    for (int i = 0; i < n; i++) {
        if (clr[i] == -1) {
            bool res = dfs(i, graph, clr, 0);
            dfs2(i, graph, ans, res);
        }
    }
    for (auto i : ans) {
        cout << 1 - i;
    }
    cout << '\n';
}