#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOC
#define debug(x) cerr << #x << " = " << x << '\n';
#else
#define debug(x)
#endif

struct SegTree {
    int n;
    vector<int> tree;
    SegTree(int n) : n(n) {
        tree.assign(4 * n, 0);
    }
    void update(int v, int l, int r, int ind) {
        if (l + 1 == r) {
            tree[v]++;
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) update(2 * v + 1, l, m, ind);
        else update(2 * v + 2, m, r, ind);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            debug(v);
            return tree[v];
        }
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int one, n;
    cin >> one >> n;
    vector<int> A(n);
    for (auto& i : A) cin >> i;
    set<int> st;
    for (auto i : A) st.insert(i);
    int i = 0;
    map<int, int> mp;
    for (auto j : st) {
        mp[j] = i;
        i++;
    }
    for (auto& i : A) {
        i = mp[i];
    }
    SegTree tree(n);
    ll ans = 0;
    tree.update(0, 0, n, A[0]);
    for (int i = 1; i < n; i++) {
        ans += tree.get(0, 0, n, A[i], n);
        tree.update(0, 0, n, A[i]);
    }
    cout << ans << '\n';
}