#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>;

using ll = long long;
using pll = std::pair<long long, long long>;

long long r, dx, dy;
std::vector<pll> a;
std::vector<std::vector<ll> > G;

bool check(pll x, pll y) {
    dx = x.first - y.first;
    dy = x.second - y.second;
    dx *= dx;
    dy *= dy;
    if (dx + dy <= r * r) {
        return true;
    }
    return false;
}

std::vector<ll> cmptnum;
std::vector<ll> used;


void dfs(ll v, ll cmp) {
    used[v] = 1;
    cmptnum[v] = cmp;
    for (auto u: G[v]) {
        if (!used[u]) {
            dfs(u, cmp);
        }
    }
}

void solve() {
    ll n;
    std::cin >> n >> r;
    G.resize(2 * n);
    a.resize(n);
    used.resize(2 * n);
    cmptnum.resize(2 * n);
    std::unordered_map<ll, std::unordered_map<ll, ll>> cc;
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i].first >> a[i].second;
        cc[a[i].first][a[i].second] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int jx = a[i].first - 10; jx <= a[i].first + 10; ++jx) {
            for (int jy = a[i].second - 10; jy <= a[i].second + 10; ++jy) {
                if (cc.contains(jx) && cc[jx].contains(jy)) {
                    ll j = cc[jx][jy];
                    if (j != i && check(a[i], a[j])) {
                        G[2 * i + 1].push_back(2 * j);
                        G[2 * i].push_back(2 * j + 1);
                        G[2 * j].push_back(2 * i + 1);
                        G[2 * j + 1].push_back(2 * i);
                    }
                }
            }
        }
    }
    ll cntt = 0;
    for (int i = 0; i < 2 * n; ++i) {
        if (!used[i]) {
            dfs(i, cntt++);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (cmptnum[2 * i] == cmptnum[2 * i + 1]) {
            std::cout << 1;
        } else {
            std::cout << 0;
        }
    }
}

int main() {
#ifdef DEBUG
    std::freopen("input.txt", "r", stdin);
#endif
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    ll tt = 1;
    // std::cin >> tt;
    while (tt--) {
        solve();
    }
}