#include<bits/stdc++.h>

#define ll long long

#define debug(x) cerr << (#x) << '=' << x << '\n';

using namespace std;

struct point {
    ll x;
    ll y;
};

vector<point> p;
vector<vector<ll>> s;
map<pair<ll, ll>, ll> mp;
vector<bool> vg;
vector<bool> ug;
vector<ll> used;
ll sqr;

ll get_dist(point p1, point p2) {
    ll c1 = p1.x - p2.x;
    ll c2 = p1.y - p2.y;
    return c1 * c1 + c2 * c2;
}

void dfs_1(ll v, ll x, ll y) {
    used[v] = 1;
    ll c1 = 0, c2 = 0;
    for (ll i = -2; i <= 2; i++) {
        for (ll j = -2; j <= 2; j++) {
            if ((i == 0) && (j == 0)) continue;
            c1 = x + i;
            c2 = y + j;
            c1 = mp[{c1, c2}];
            if (vg[c1]) continue;
            for (auto u: s[c1]) {
                if (used[u] != 0) continue;
                if (get_dist(p[u], p[v]) > sqr) continue;
                dfs_1(u, x + i, y + j);
            }
        }
    }
}

ll get_p(ll a) {
    if ((a % 2) == 1) return a - 1;
    return a + 1;
}

void dfs_2(ll v, ll x, ll y, ll cur_used) {
    used[v] = cur_used;
    ll c1 = 0, c2 = 0;
    for (ll i = -2; i <= 2; i++) {
        for (ll j = -2; j <= 2; j++) {
            c1 = x + i;
            c2 = y + j;
            c1 = mp[{c1, c2}];
            if (vg[c1]) continue;
            for (auto u: s[c1]) {
                if (v == u) continue;
                if (get_dist(p[u], p[v]) > sqr) continue;
                if (used[u] == cur_used) {
                    ug[cur_used] = true;
                    ug[get_p(cur_used)] = true;
                }
                if (used[u] != 0) continue;
                dfs_2(u, x + i, y + j, get_p(cur_used));
            }
        }
    }
}

ll get_sz(ll a) {
    double b = a;
    b /= sqrt(2);
    if ((int)b == 0) b = 1;
    return b;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, r;
    cin >> n >> r;
    ll sz = get_sz(r);
    p.resize(n);
    s.clear();
    s.push_back({});
    ll c1 = 0, c2 = 0, c3 = 0;
    for (ll i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        c1 = p[i].x / sz;
        c2 = p[i].y / sz;
        if (mp[{c1, c2}] == 0) {
            c3 = (ll)s.size();
            mp[{c1, c2}] = c3;
            s.push_back({i});
        } else {
            s[mp[{c1, c2}]].push_back(i);
        }
    }
    ll sqn = (ll)s.size();
    vg.resize(sqn, false);
    for (ll i = 0; i < sqn; i++) {
        if (s[i].size() > 2) vg[i] = true;
    }
    ug.resize(n * 2 + 2, false);
    used.resize(n, 0);
    ug[1] = true;
    sqr = r * r;
    for (ll i = 0; i < sqn; i++) {
        if (!vg[i]) continue;
        for (auto u: s[i]) {
            c1 = p[u].x / sz;
            c2 = p[u].y / sz;
            dfs_1(u, c1, c2);
        }
    }
    ll cur_used = 1;
    for (ll i = 0; i < sqn; i++) {
        if (vg[i]) continue;
        for (auto u: s[i]) {
            if (used[u] != 0) continue;
            c1 = p[u].x / sz;
            c2 = p[u].y / sz;
            dfs_2(u, c1, c2, cur_used * 2);
            cur_used += 1;
        }
    }
    for (ll i = 0; i < n; i++) {
        if (ug[used[i]]) cout << 1;
        else cout << 0;
    }
    cout << '\n';
    return 0;
}