#include <bits/stdc++.h>
using namespace std;
#define ll long long

const ll INF = 1e18;
struct node {
    ll v, i;
};


struct segtree {
    vector<node> tree;
    ll size;

    void init (ll n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(size * 2-1, {INF, 0});
    }

    node combine (node a, node b) {
        if (a.v < b.v)
            return a;
        else
            return b;
    }

    void change (ll i, ll val, ll x, ll lx, ll rx) {
        if (rx-lx == 1) {
            tree[x] = {val, lx};
            return;
        }
        ll m = (lx+rx)/2;
        if (i < m)
            change (i, val, 2*x+1, lx, m);
        else
            change (i, val, 2*x+2, m, rx);
        tree[x] = combine(tree[2*x+1], tree[2*x+2]);
    }

    void change (ll i, ll val) {
        change (i, val, 0, 0, size);
    }

    node fm () {
        return tree[0];
    }
};

int main () {
    ios_base::sync_with_stdio(0), cin.tie(0);
    ll n, q;
    cin >> n >> q;
    if (n == 1) {
        for (int i = 0; i < q; ++i) {
            cout << "0\n";
        }
        exit(0);
    }
    vector<ll> v (n);
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        if (c == '1')
            v[i] = 1;
        else
            v[i] = 0;
    }
    vector<ll> ans (n+1);
    ll cnt = 0;
    ll last = 0;
    vector<ll> t;
    ll res = 0;
    ll C = 0;
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += v[i];
        if (last == 1)
            cnt++;
        if (v[i] == 1 && (i == 0 || v[i-1] == 0) && (i == n-1 || v[i+1] == 0)) {
            C++;
            if (last == 1)
                t.push_back(cnt-1);
            cnt = 0;
            last = 1;
        }
        else if (v[i] == 1) {
            t.push_back(INF);
            res++;
            last = 0;
            cnt = 0;
        }
    }
    ll m = t.size();
    segtree st;
    st.init(m);
    for (int i = 0; i < t.size(); ++i) {
        st.change(i, t[i]);
    }
    ans[0] = res;
    for (int i = 1; i < n+1; ++i) {
        node a = st.fm();
        if (a.v == INF) {
            if (C != 0) {
                res++;
                C--;
            }
            res ++;
            ans[i] = min(res, n);
            continue;
        }
        a.v --;
        if (a.v == 0) {
            C -= 2;
            res += 3;
            st.change(a.i, INF);
            t[a.i] = INF;
            if (a.i != 0) {
                t[a.i-1] = INF;
                st.change(a.i-1, INF);
            }
            if (a.i+1 != t.size()) {
                t[a.i+1] = INF;
                st.change(a.i+1, INF);
            }
        }
        else {
            C--;
            res += 2;
            st.change(a.i, INF);
            t[a.i] = INF;
            if (a.i+1 != t.size()) {
                t[a.i+1] = INF;
                st.change(a.i+1, INF);
            }
        }
        ans[i] = min(res, n);
    }
    if (sum == 0 && n != 1) {
        for (int i = 2; i < n+1; ++i) {
            ans[i] = i;
        }
        ans[0] = 0;
        ans[1] = 0;
    }
    for (int i = 0; i < q; ++i) {
        ll k;
        cin >> k;
        cout << ans[k] << '\n';
    }
}