#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <unordered_map>
#include <set>
#include <queue>
using namespace std;
// #define int long long

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

// int p(int x, int y) {
//     return x * 1e9 + y;
// }

bool check(pair<int, int> &a, pair<int, int> &b, int &r) {
    return 1ll * (a.first - b.first) * (a.first - b.first) + 1ll * (a.second - b.second) * (a.second - b.second) <= 1ll * r * r;
}

void solution() {
    int n, r;
    cin >> n >> r;

    vector<pair<int, int>> xy(n);

    for (auto &[x, y] : xy) {
        cin >> x >> y;
    }

    int b = r / 2 + 1;

    map<pair<int, int>, vector<int>> mp;
    set<pair<int, int>> st;

    for (int i = 0; i < n; ++i) {
        auto [x, y] = xy[i];
        mp[{x / b, y / b}].push_back(i);   
        st.emplace(x / b, y / b);
    }

    vector<bool> ans(n);
    vector<vector<int>> gr(n);
    
    for (auto [xb, yb] : st) {
        auto vb = mp[{xb, yb}];
        if (vb.size() > 2) {
            for (auto i : vb) {
                ans[i] = true;
            }
            continue;
        }
        for (auto v : vb) {
            for (int dx = -2; dx <= 2; ++dx) {
                for (int dy = -2; dy <= 2; ++dy) {
                    if (mp.find({xb + dx, yb + dy}) == mp.end()) continue;
                    for (auto i : mp[{xb + dx, yb + dy}]) {
                        if (i != v && check(xy[i], xy[v], r)) {
                            gr[i].push_back(v);
                        }
                    }
                }
            }
        }
    }

    vector<int> col(n, -1);
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (col[i] != -1 || ans[i]) continue;
        q.emplace(i);
        col[i] = 0;
        bool was = false;
        while (!q.empty()) {
            int s = q.front();
            q.pop();
            for (auto v : gr[s]) {
                if (col[v] == -1) {
                    col[v] = !col[s];
                    q.emplace(v);
                } else if (col[v] == col[s] && !was) {
                    ans[s] = true;
                    was = true;
                }
            }
        }
    }

    vector<bool> used(n);
    for (int i = 0; i < n; ++i) {
        if (used[i] || !ans[i]) continue;
        q.emplace(i);
        used[i] = true;
        while (!q.empty()) {
            int s = q.front();
            q.pop();
            for (auto v : gr[s]) {
                if (used[v]) continue;
                used[v] = true;
                ans[v] = true;
                q.emplace(v);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (ans[i]) cout << 1;
        else cout << 0;
    }
    cout << '\n';
}