#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <unordered_map>
#include <set>
#include <queue>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define oset tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>

void solution();

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("res", "w", stdout);
#endif

    solution();
}

void solution() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    vector<vector<int>> rcnt(n, vector<int>(m));
    vector<vector<int>> dcnt(n, vector<int>(m));

    for (int h = 0; h <= n; ++h) {
        oset st;
        for (int j = m; j >= 0; --j) {
            for (int i = n - 1; i >= n - h; --i) {
                if (j < m) st.insert(a[i][j]);
            }
            if (j > 0 && h > 0) {
                oset r;
                int sm = 0;
                for (int i1 = n - 1; i1 >= n - h; --i1) {
                    sm += st.order_of_key(a[i1][j - 1]);
                    sm += r.order_of_key(a[i1][j - 1]);
                    r.insert(a[i1][j - 1]);
                }
                rcnt[n - h][j - 1] = sm;
            }
            if (h < n && j < m) {
                oset d;
                int sm = 0;
                for (int j1 = m - 1; j1 >= j; --j1) {
                    sm += st.order_of_key(a[n - h - 1][j1]);
                    sm += d.order_of_key(a[n - h - 1][j1]);
                    d.insert(a[n - h - 1][j1]);
                }
                dcnt[n - h - 1][j] = sm;
            }
        }
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            int res1 = dp[i + 1][j] + dcnt[i][j];
            int res2 = dp[i][j + 1] + rcnt[i][j];
            dp[i][j] = min(res1, res2);
        }
    }

    // cout << "    ";
    // for (int j = 0; j <= m; ++j) {
    //     cout << j << ' ';
    // }
    // cout << '\n';
    // for (int i = 0; i <= n; ++i) {
    //     cout << i << " - ";
    //     for (int j = 0; j <= m; ++j) {
    //         cout << dp[i][j] << ' ';
    //     }
    //     cout << '\n';
    // }

    cout << dp[0][0] << '\n';
}