#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//--//
#define int long long
//--//
#pragma GCC optimize("O3")
//--//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//--//

struct segtree {
    int size = 1;
    vector<int> tree;

    void init(int n) {
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int mx = (lx + rx) / 2;
        if (i < mx) {
            set(i, v, 2 * x + 1, lx, mx);
        } else {
            set(i, v, 2 * x + 2, mx, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }

    int get_sum(int l, int r, int x, int lx, int rx) {
        if (r <= lx || rx <= l) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int mx = (lx + rx) / 2;
        int s1 = get_sum(l, r, 2 * x + 1, lx, mx);
        int s2 = get_sum(l, r, 2 * x + 2, mx, rx);
        return s1 + s2;
    }

    int get_sum(int l, int r) {
        return get_sum(l, r, 0, 0, size);
    }
};


signed main() {
    fast;
    int r, c;
    cin >> r >> c;
    vector<int> row1(c), row2(c);
    for (int i = 0; i < c; ++i) {
        cin >> row1[i];
    }
    for (int i = 0; i < c; ++i) {
        cin >> row2[i];
    }
    int min_inv[2][c + 1];
    int row_inv[c + 1];
    for (int i = 0; i < 2; ++i) {
        min_inv[i][c] = row_inv[c] = 0;
    }
    segtree st1; segtree st2;
    st1.init(2 * c + 1);
    st2.init(2 * c + 1);
    for (int j = c - 1; j > -1; --j) {
        int a11 = st1.get_sum(0, row1[j]);
        int a12 = st2.get_sum(0, row1[j]);
        int a21 = st1.get_sum(0, row2[j]);
        int a22 = st2.get_sum(0, row2[j]);

        int additional = 0;
        if (row1[j] > row2[j]) additional = 1;

        min_inv[1][j] = a22 + min_inv[1][j + 1];

        min_inv[0][j] = additional + a11 + a12 + a21 + a22 + min_inv[1][j + 1]; //deleting the column

        int row_option = additional + a11 + a12 + (c - j - 1 - a21) + a22 + row_inv[j + 1]; //deleting the row

        if (min_inv[0][j] > row_option) {
            min_inv[0][j] = row_option;
        }

        row_inv[j] = row_option;

        st1.set(row1[j], 1);
        st2.set(row2[j], 1);
    }
    /*for (int i = r - 1; i > -1; --i) {
        for (int j = c - 1; j > -1; --j) {
            int add_row = 0;
            for (int x = j; x < c; ++x) {
                for (int y = x + 1; y < c; ++y) {
                    if (table[i][x] > table[i][y]) ++add_row;
                }
                for (int z = i + 1; z < r; ++z) {
                    for (int t = j; t < c; ++t) {
                        if (table[i][x] > table[z][t]) ++add_row;
                    }
                }
            }
            int hypot_row = add_row + min_inv[i + 1][j];

            int add_col = 0;
            for (int x = i; x < r; ++x) {
                for (int y = x + 1; y < r; ++y) {
                    if (table[x][j] > table[y][j]) ++add_col;
                }
                for (int z = i; z < r; ++z) {
                    for (int t = j + 1; t < c; ++t) {
                        if (table[x][j] > table[z][t]) ++add_col;
                    }
                }
            }
            int hypot_col = add_col + min_inv[i][j + 1];

            if (hypot_row < hypot_col) {
                min_inv[i][j] = hypot_row;
            } else {
                min_inv[i][j] = hypot_col;
            }
        }
    }*/
    cout << min_inv[0][0] << "\n";
    return 0;
}
