#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//--//
//#define int long long
//--//
#pragma GCC optimize("O3")
//--//
#define pii pair<int, int>
#define ft first
#define sd second
#define fast \
    ios_base::sync_with_stdio(0); \
    cin.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(20)
//--//
typedef __int128 lll;
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//--//

struct segtree {
    int size = 1;
    vector<int> tree;

    void init(int n) {
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int mx = (lx + rx) / 2;
        if (i < mx) {
            set(i, v, 2 * x + 1, lx, mx);
        } else {
            set(i, v, 2 * x + 2, mx, rx);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }

    int get_sum(int l, int r, int x, int lx, int rx) {
        if (r <= lx || rx <= l) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int mx = (lx + rx) / 2;
        int s1 = get_sum(l, r, 2 * x + 1, lx, mx);
        int s2 = get_sum(l, r, 2 * x + 2, mx, rx);
        return s1 + s2;
    }

    int get_sum(int x) {
        return get_sum(0, x, 0, 0, size);
    }
};


signed main() {
    fast;
    int r, c;
    cin >> r >> c;
    int table[r][c];
    for (int i = 0; i < r; ++i) {
        for (int j = 0; j < c; ++j) {
            cin >> table[i][j];
        }
    }
    ll min_inv[r + 1][c + 1];
    ll row_inv[r + 1][c + 1];
    ll col_inv[r + 1][c + 1];
    for (int i = 0; i <= r; ++i) {
        min_inv[i][c] = row_inv[i][c] = col_inv[i][c] = 0LL;
    }
    for (int j = 0; j <= c; ++j) {
        min_inv[r][j] = row_inv[r][j] = col_inv[r][j] = 0LL;
    }
    vector<segtree> for_rows(r);
    vector<segtree> for_columns(c);
    vector<segtree> edges(r);
    for (int i = 0; i < r; ++i) {
        for_rows[i].init(r * c + 1);
        edges[i].init(r * c + 1);
    }
    for (int j = 0; j < c; ++j) {
        for_columns[j].init(r * c + 1);
    }
    for (int sum = r + c - 2; sum > -1; --sum) {
        for (int i = r - 1; i > -1; --i) {
            int j = sum - i;
            if (j < 0 || j >= c) continue;
            //first let's try the row delete
            ll row_inversions = (ll)for_rows[i].get_sum(table[i][j]) + row_inv[i][j + 1];
            row_inv[i][j] = row_inversions;
            ll bottom_inversions = 0;
            if (i < r - 1) {
                for (int x = j; x < c; ++x) {
                    bottom_inversions += (ll)edges[i + 1].get_sum(table[i][x]);
                }
            }
            ll total_row = row_inversions + bottom_inversions + min_inv[i + 1][j];

            ll column_inversions = (ll)for_columns[j].get_sum(table[i][j]) + col_inv[i + 1][j];
            col_inv[i][j] = column_inversions;
            ll right_inversions = 0;
            for (int y = i; y < r; ++y) {
                right_inversions += (ll)edges[i].get_sum(table[y][j]);
            }
            ll total_column = column_inversions + right_inversions + min_inv[i][j + 1];

            if (total_column > total_row) {
                min_inv[i][j] = total_row;
            } else {
                min_inv[i][j] = total_column;
            }
        }
        for (int i = r - 1; i > -1; --i) {
            int j = sum - i;
            if (j < 0 || j >= c) continue;
            for (int y = i; y < r; ++y) {
                edges[i].set(table[y][j], 1);
            }
            for_rows[i].set(table[i][j], 1);
            for_columns[j].set(table[i][j], 1);
        }
    }
    cout << min_inv[0][0] << "\n";
    return 0;
}
