#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<int>> g;
vector<int> color;

void dfs(int u, int clr)
{
    color[u] = clr;
    for (int v : g[u])
    {
        if (color[v] == -1)
            dfs(v, clr);
    }
}

vector<int> mark;
bool check(int u, int clr = 0)
{
    mark[u] = clr;
    for (int v : g[u])
    {
        if (mark[v] == -1)
        {
            if (check(v, clr ^ 1))
                return true;
        }
        if (mark[v] == clr)
            return true;
    }
    return false;
}

void solve()
{
    int n, r;
    cin >> n >> r;

    vector<array<int, 2>> points(n);
    g.resize(n);

    for (int i = 0; i < n; i++)
    {
        cin >> points[i][0] >> points[i][1];
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            auto [x1, y1] = points[i];
            auto [x2, y2] = points[j];

            ll dist = 1ll * (x1 - x2) * (x1 - x2) + 1ll * (y1 - y2) * (y1 - y2);
            if (dist <= 1ll * r * r)
            {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    color.resize(n, -1);
    int clr = 0;
    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            dfs(i, clr++);
        }
    }

    vector<bool> ok(clr);
    vector<bool> used(clr);
    mark.resize(n, -1);
    for (int i = 0; i < n; i++)
    {
        if (!used[color[i]])
        {
            used[color[i]] = true;
            ok[color[i]] = check(i);
        }
    }

    for (int i = 0; i < n; i++)
        cout << ok[color[i]];
    cout << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}