#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<int>> g;
vector<int> color;

void dfs(int u, int clr)
{
    color[u] = clr;
    for (int v : g[u])
    {
        if (color[v] == -1)
            dfs(v, clr);
    }
}

vector<int> mark;
bool check(int u, int clr = 0)
{
    mark[u] = clr;
    for (int v : g[u])
    {
        if (mark[v] == -1)
        {
            if (check(v, clr ^ 1))
                return true;
        }
        if (mark[v] == clr)
            return true;
    }
    return false;
}

void solve()
{
    int n, r;
    cin >> n >> r;

    set<array<int, 3>> points;
    g.resize(n);

    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;

        points.insert({x, y, i});
    }

    for (auto [x0, y0, i] : points)
    {
        for (int x = x0 - r; x <= x0 + r; x++)
        {
            for (int y = y0 - r; y <= y0 + r; y++)
            {
                if (x0 == x && y0 == y)
                    continue;
                ll dist = 1ll * (x - x0) * (x - x0) + 1ll * (y - y0) * (y - y0);
                if (dist > 1ll * r * r)
                    continue;
                auto it = points.lower_bound({x, y, INT_MIN});
                if (it != points.end())
                {
                    auto [x1, y1, j] = *it;
                    if (x1 == x && y1 == y)
                        g[i].push_back(j);
                }
            }
        }
    }

    color.resize(n, -1);
    int clr = 0;
    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            dfs(i, clr++);
        }
    }

    vector<bool> ok(clr);
    vector<bool> used(clr);
    mark.resize(n, -1);
    for (int i = 0; i < n; i++)
    {
        if (!used[color[i]])
        {
            used[color[i]] = true;
            ok[color[i]] = check(i);
        }
    }

    for (int i = 0; i < n; i++)
        cout << ok[color[i]];
    cout << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}