#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<int> color;
set<array<int, 3>> points;
vector<array<int, 2>> cs;
int r;

void dfs(int u, int clr)
{
    color[u] = clr;

    auto [x0, y0] = cs[u];
    for (int x = x0 - r; x <= x0 + r; x++)
    {
        for (int y = y0 - r; y <= y0 + r; y++)
        {
            if (x0 == x && y0 == y)
                continue;
            ll dist = 1ll * (x - x0) * (x - x0) + 1ll * (y - y0) * (y - y0);
            if (dist > 1ll * r * r)
                continue;
            auto it = points.lower_bound({x, y, INT_MIN});
            if (it != points.end())
            {
                auto [x1, y1, v] = *it;
                if (x1 == x && y1 == y && color[v] == -1)
                    dfs(v, clr);
            }
        }
    }
}

vector<int> mark;
bool check(int u, int clr = 0)
{
    mark[u] = clr;

    auto [x0, y0] = cs[u];
    for (int x = x0 - r; x <= x0 + r; x++)
    {
        for (int y = y0 - r; y <= y0 + r; y++)
        {
            if (x0 == x && y0 == y)
                continue;
            ll dist = 1ll * (x - x0) * (x - x0) + 1ll * (y - y0) * (y - y0);
            if (dist > 1ll * r * r)
                continue;
            auto it = points.lower_bound({x, y, INT_MIN});
            if (it != points.end())
            {
                auto [x1, y1, v] = *it;
                if (x1 == x && y1 == y)
                {
                    if (mark[v] == -1)
                    {
                        if (check(v, clr ^ 1))
                            return true;
                    }
                    else if (mark[v] == clr)
                    {
                        return true;
                    }
                }
            }
        }
    }
    return false;
}

void solve()
{
    int n;
    cin >> n >> r;
    cs.resize(n);

    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        cs[i] = {x, y};
        points.insert({x, y, i});
    }

    color.resize(n, -1);
    int clr = 0;
    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            dfs(i, clr++);
        }
    }

    vector<bool> ok(clr);
    vector<bool> used(clr);
    mark.resize(n, -1);
    for (int i = 0; i < n; i++)
    {
        if (!used[color[i]])
        {
            used[color[i]] = true;
            ok[color[i]] = check(i);
        }
    }

    for (int i = 0; i < n; i++)
        cout << ok[color[i]];
    cout << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}