#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct BIT
{
    vector<int> t;
    BIT(int n): t(n + 1) {}

    int sum(int r)
    {
        int ans = 0;
        while (r > 0)
        {
            ans += t[r];
            r -= r & -r;
        }
        return ans;
    }

    void upd(int i, int x)
    {
        ++i;
        while (i < t.size())
        {
            t[i] += x;
            i += i & -i;
        }
    }
};

void solve()
{
    int r, c;
    cin >> r >> c;

    vector a(r, vector<int>(c));
    for (int i = 0; i < r; i++)
    {
        for (int j = 0; j < c; j++)
        {
            cin >> a[i][j];
            --a[i][j];
        }
    }

    vector dp(r + 1, vector<ll>(c + 1));
    for (int i = r - 1; i >= 0; i--)
    {
        BIT cnt(r * c);
        for (int j = c - 1; j >= 0; j--)
        {
            for (int k = i; k < r; k++)
                cnt.upd(a[k][j], 1);
            
            ll inv1 = dp[i + 1][j];
            for (int k = j; k < c; k++)
            {
                inv1 += cnt.sum(a[i][k]);
                cnt.upd(a[i][k], -1);
            }
            for (int k = j; k < c; k++)
                cnt.upd(a[i][k], 1);

            ll inv2 = dp[i][j + 1];
            for (int k = i; k < r; k++)
            {
                inv2 += cnt.sum(a[k][j]);
                cnt.upd(a[k][j], -1);
            }
            for (int k = i; k < r; k++)
                cnt.upd(a[k][j], 1);
            
            dp[i][j] = min(inv1, inv2);
        }
    }

    cout << dp[0][0] << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}