#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct BIT
{
    vector<int> t;
    BIT(int n): t(n + 1) {}

    int sum(int r)
    {
        int ans = 0;
        while (r > 0)
        {
            ans += t[r];
            r -= r & -r;
        }
        return ans;
    }

    int sum(int l, int r)
    {
        return sum(r) - sum(l);
    }

    void upd(int i, int x)
    {
        ++i;
        while (i < t.size())
        {
            t[i] += x;
            i += i & -i;
        }
    }
};

void solve()
{
    int r, c;
    cin >> r >> c;

    vector a(r, vector<int>(c));
    for (int i = 0; i < r; i++)
    {
        for (int j = 0; j < c; j++)
        {
            cin >> a[i][j];
            --a[i][j];
        }
    }

    BIT bit(c);
    ll ans = 0;
    for (int i : a[0])
    {
        bit.upd(i, 1);
        ans += bit.sum(i + 1, c);
    }
    cout << ans << '\n';
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}