#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#pragma GCC target("avx2")

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int L = 20;
struct ST
{
    vector<int> dp[L];
    vector<int> a;
    ST(vector<int> &a): a(a)
    {
        int n = a.size();
        for (int i = 0; i < L; i++)
            dp[i].resize(n);
        for (int i = 0; i < n; i++)
            dp[0][i] = i;
        
        for (int i = 1; i < L; i++)
        {
            for (int j = 0; j + (1 << i) <= n; j++)
            {
                int i1 = dp[i - 1][j];
                int i2 = dp[i - 1][j + (1 << (i - 1))];

                if (a[i1] < a[i2])
                    dp[i][j] = i1;
                else
                    dp[i][j] = i2;
            }
        }
    }

    int ans(int l, int r)
    {
        int len = r - l;
        int lg = __lg(len);
        
        int i1 = dp[lg][l];
        int i2 = dp[lg][r - (1 << lg)];

        if (a[i1] < a[i2])
            return i1;
        return i2;
    }
};

void solve()
{
    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    
    vector<int> gr_r(n, n);
    vector<int> stack;

    for (int i = 0; i < n; i++)
    {
        while (!stack.empty() && a[i] > a[stack.back()])
        {
            gr_r[stack.back()] = i;
            stack.pop_back();
        }
        stack.push_back(i);
    }

    ST st(a);

    vector<int> suf(n);
    suf[n - 1] = n - 1;
    for (int i = n - 2; i >= 0; i--)
    {
        if (a[i] > a[suf[i + 1]])
            suf[i] = i;
        else
            suf[i] = suf[i + 1];
    }

    for (int it = 0; it < q; it++)
    {
        int k, i;
        cin >> k >> i;

        int cur = 0;
        for (int t = 0; t < i - 1; t++)
        {

            int r = gr_r[cur];
            int nxt = r == cur + 1 ? -1 : st.ans(cur + 1, min(r, n - k + 2));
            if (k == 2 && r == n)
            {
                cur = n - 1;
                --k;
                continue;
            }
            if (nxt == -1)
                cur = r;
            else
                cur = nxt;
            --k;
        }
        if (k == 1)
            cur = suf[cur];

        cout << a[cur] << '\n';
    }
}

int main()
{
    int t;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("C:/work/in.txt", "r", stdin);
    freopen("C:/work/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}