#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
using namespace std;

typedef long long ll;
//#define int long long

struct pnt {
    ll x, y;
    pnt(ll x1, ll y1) {
        x = x1;
        y = y1;
    }
};

bool dist(pnt p1, pnt p2, ll r) {
    if ((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y) <= r * r) {
        return true;
    }
    return false;
}

const int maxn = 10000;
vector<pnt> l{};
int h = 1;
bool f;
int vis[maxn];
bool ans[maxn];
vector<vector<int>> gr;

void dfs(int ind, int pr) {
    if (f) {
        return;
    }
    vis[ind] = 2 * h + 1 - pr;
    for (auto i : gr[ind]) {
        if (vis[i] == vis[ind]) {
            f = 1;
            return;
        } else if (vis[i] != pr) {
            dfs(i, vis[ind]);
        }
    }
}

void basic_dfs(int ind) {
    ans[ind] = 1;
    for (auto i : gr[ind]) {
        if (!ans[i]) {
            basic_dfs(i);
        }
    }
}

signed main() {
	ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    ll r;
    cin >> n >> r;
    l.resize(n, pnt(0, 0));
    vector<pair<pair<ll, ll>, int>> q(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i].x >> l[i].y;
        q[i] = {{l[i].x, l[i].y}, i};
    }
    sort(q.begin(), q.end());
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = l[i].x - r; j <= l[i].x + r; j++) {
            for (int k = l[i].y - r; k <= l[i].y + r; k++) {
                if (!dist(l[i], {j, k}, r)) {
                    continue;
                }
                int lg = 0, rg = q.size(), mid;
                while (rg - lg > 1) {
                    mid = (lg + rg) / 2;
                    if (q[mid].first.first < j) {
                        lg = mid;
                    } else if (q[mid].first.first == j && q[mid].first.second <= k) {
                        lg = mid;
                    } else {
                        rg = mid;
                    }
                }
                if (!(j == l[i].x && k == l[i].y) && q[lg].first.first == j && q[lg].first.second ==  k) {
                    gr[i].emplace_back(q[lg].second);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        f = 0;
        if (vis[i] == 0) {
            dfs(i, 1);
            if (f) {
                basic_dfs(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << 1;
        } else {
            cout << 0;
        }
    }
	return 0;
}