#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Point{
    int x, y;
    Point() {}
    Point(int x, int y) : x(x), y(y) {}
    Point(Point a, Point b) : x(b.x - a.x), y(b.y - a.y) {}
    long long len_sq() {
        return x * x + y * y;
    }
};

bool operator<(Point a, Point b) {
    return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

bool cmp(pair<Point, int> a, pair<Point, int> b) {
    return a.first.y < b.first.y;
}

int rad;
vector<vector<int>> ans;

void dfs(int i, vector<int> &c, vector<vector<int>> &gr, int col) {
    if (c[i] != -1) return;
    c[i] = col;
    for (auto &j : gr[i]) {
        dfs(j, c, gr, col);
    }
}

vector<int> lans(vector<pair<Point, int>> v, bool f) {
    if (v.size() == 0) return vector<int> (0);
    int ml = v[0].second;
    for (auto &i : v) ml = min(ml, i.second);
    int n = v.size();
    if (v[0].first.x == v[n - 1].first.x) {
        vector<int> cmp(n, 0);
        int cur_cmp = 0;
        for (int i = 1; i < n; i++) {
            if (Point(v[i - 1].first, v[i].first).len_sq() > rad * rad) {
                cur_cmp++;
            } else {
                if (f) {
                    ans[v[i - 1].second].push_back(v[i].second);
                    ans[v[i].second].push_back(v[i - 1].second);
                }
            }
            cmp[i] = cur_cmp;
        }
        return cmp;
    }
    vector<pair<Point, int>> v1, v2;
    int x = v[n / 2].first.x;
    if (v[n - 1].first.x == x) x--;
    for (auto &i : v) {
        if (i.first.x <= x) {
            v1.push_back(i);
        } else {
            v2.push_back(i);
        }
    }
    vector<int> ans1 = lans(v1, f);
    int mx1 = ans1[0];
    for (auto &i : ans1) mx1 = max(mx1, i); 
    vector<int> tmp = lans(v2, f);
    for (auto &i : tmp) ans1.push_back(i + mx1 + 1);
    for (auto &i : ans1) mx1 = max(mx1, i); 
    mx1++;
    sort(v1.begin(), v1.end(), cmp);
    sort(v2.begin(), v2.end(), cmp);
    vector<deque<pair<Point, int>>> cmp(mx1);
    set<int> cur_comps;
    int l = 0;
    int r = 0;
    vector<vector<int>> cmps(mx1);
    for (auto &i : v2) {
        while (r < v1.size() && v1[r].first.y <= i.first.y + rad) {
            cmp[ans1[v1[r].second - ml]].push_back(v1[r]);
            cur_comps.insert(ans1[v1[r].second - ml]);
            r++;
        }
        while (l < v1.size() && v1[l].first.y < i.first.y - rad) {
            cmp[ans1[v1[l].second - ml]].pop_front();
            if (cmp[ans1[v1[l].second - ml]].size() == 0) cur_comps.erase(ans1[v1[r].second - ml]);
            l++;
        }
        for (auto &tmp1 : cur_comps) {
            for (auto &j : cmp[tmp1]) {
                if (Point(i.first, j.first).len_sq() <= rad * rad) {
                    cmps[ans1[i.second - ml]].push_back(ans1[j.second - ml]);
                    cmps[ans1[j.second - ml]].push_back(ans1[i.second - ml]);
                    if (f) {
                        ans[i.second].push_back(j.second);
                        ans[j.second].push_back(i.second);
                    }
                    break;
                }
            }
        }
    }
    vector<int> ans_cmp(mx1, -1);
    int cur_comp = 0;
    for (int i = 0; i < mx1; i++) {
        if (ans_cmp[i] != -1) continue;
        dfs(i, ans_cmp, cmps, cur_comp);
        cur_comp++;
    }
    for (auto &i : ans1) {
        i = ans_cmp[i];
    }
    return ans1;
}

bool dfs2(int i, vector<int> &c, int col) {
    if (c[i] != -1 && c[i] == col) return true;
    if (c[i] != -1 && c[i] != col) return false;
    c[i] = col;
    for (auto &j : ans[i]) {
        if (!dfs2(j, c, (col + 1) % 2)) return false;
    }
    return true;
}

vector<int> color;

bool ans_cmp(vector<int> p, vector<Point> &all) {
    if (!dfs2(p[0], color, 0)) return true;
    vector<pair<Point, int>> v1, v2;
    for (int i = 0; i < p.size(); i++) {
        if (color[p[i]] == 0) {
            v1.push_back({all[p[i]], p[i]});
        } else {
            v2.push_back({all[p[i]], p[i]});
        }
    }
    vector<int> ans1 = lans(v1, false), ans2 = lans(v2, false);
    int mx1 = 0;
    for (auto &i : ans1) mx1 = max(mx1, i);
    int mx2 = 0;
    for (auto &i : ans2) mx2 = max(mx2, i);
    if (mx1 < ((int)ans1.size() - 1)) return true;
    if (mx2 < ((int)ans2.size() - 1)) return true;
    return false;
}

main() {
    int n;
    cin >> n >> rad;
    ans.resize(n);
    color.resize(n, -1);
    vector<Point> v(n);
    vector<pair<Point, int>> v1;
    for (int i = 0; i < n; i++) {
        cin >> v[i].y >> v[i].x;
        v1.push_back({v[i], i});
    }
    sort(v.begin(), v.end());
    sort(v1.begin(), v1.end());
    vector<pair<Point, int>> v2;
    vector<int> per(n);
    for (int i = 0; i < n; i++) {
        per[v1[i].second] = i;
        v2.push_back({v1[i].first, i});
    }
    vector<int> cmp = lans(v2, true);
    int mx = cmp[0];
    for (auto &i : cmp) mx = max(mx, i);
    mx++;
    vector<vector<int>> lans(mx);
    vector<bool> f_ans(n, false);
    for (int i = 0; i < n; i++) {
        lans[cmp[i]].push_back(i);
    }
    for (int i = 0; i < mx; i++) {
        if (ans_cmp(lans[i], v)) {
            for (auto &j : lans[i]) {
                f_ans[j] = true;
            }
        }
    }
    for (int j = 0; j < n; j++) {
        cout << f_ans[per[j]];
    }
    cout << endl;
}