#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

ll r;

bool f(pii a, pii b) {
	ll dist = (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
	return dist <= r * r;
}


bool dfs(vector<vector<ll>>& g, ll u, vector<ll>& col) {
	for (auto v : g[u]) {
		if (col[v] == 0) {
			col[v] = 3 - col[u];
			if (dfs(g, v, col)) {
				return true;
			}
		}
		if (col[v] == col[u]) {
			return true;
		}
	}
	return false;
}

void solve() {
	ll n; cin >> n >> r;
	vector<pii>v(n);
	for (auto& i : v) cin >> i.first >> i.second;
	vector<vector<ll>>g(n);
	for (ll i = 0; i < n; ++i) {
		for (ll j = i + 1; j < n; ++j) {
			if (f(v[i], v[j])) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	vector<ll>col(n, 0);
	for (ll i = 0; i < n; ++i) {
		for (auto& i : col) i = 0;
		col[i] = 1;
		if (dfs(g, i, col)) cout << 1;
		else cout << 0;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
