#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

struct P {
	ll x, y, num;
	P(ll x = 0, ll y = 0, ll num = -1) {
		this->x = x;
		this->y = y;
		this->num = num;
	}
};

bool f(P a, P b) {
	ll dist = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return dist <= r * r;
}

bool ok = false;



void dfs(vector<vector<ll>>& g, ll u, vector<ll>& col) {
	for (auto v : g[u]) {
		if (col[v] == 0) {
			col[v] = 3 - col[u];
			dfs(g, v, col);
		}
		if (col[v] == col[u]) {
			ok = true;
		}
	}
}

void solve() {
	ll n; cin >> n >> r;
	vector<P>v(n);
	for (ll i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		v[i] = P(x, y, i);
	}
	sort(all(v), [](const P& a, const P& b) { return a.x < b.x;  });
	vector<bool>c(n, false);
	for (ll i = 0; i < n - 2; ++i) {
		if (c[i]) continue;
		if (f(v[i], v[i + 2])) {
			c[i] = c[i + 1] = c[i + 2] = true;
			ll l = i;
			while (l > 0 && f(v[l], v[l - 1])) {
				l--;
				c[l] = true;
			}
			ll r = i + 2;
			while (r < n - 1 && f(v[r], v[r + 1])) {
				r++;
				c[r] = true;
			}
		}
	}
	vector<bool>ans(n, false);
	for (ll i = 0; i < n; ++i) {
		ans[v[i].num] = c[i];
	}
	for (ll i = 0; i < n; ++i) cout << ans[i];
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
