#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

struct P {
	ll x, y, num;
	P(ll x = 0, ll y = 0, ll num = -1) {
		this->x = x;
		this->y = y;
		this->num = num;
	}
};

bool f(P a, P b) {
	ll dist = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return dist <= r * r;
}


bool ok = false;
vector<ll>comp;
vector<bool>comp_ok;

void dfs(vector<vector<ll>>& g, ll u, vector<ll>& col) {
	for (auto v : g[u]) {
		if (col[v] == 0) {
			comp[v] = comp[u];
			col[v] = 3 - col[u];
			dfs(g, v, col);
		}
		if (col[v] == col[u]) {
			ok = true;
		}
	}
}

void solve() {
	ll n; cin >> n >> r;
	comp.assign(n, -1);
	comp_ok.clear();
	vector<P>v(n);
	map<pii, P>mp;
	for (ll i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		v[i] = P(x, y, i);
		mp[{x, y}] = v[i];
	}
	vector<vector<ll>>g(n);
	for (ll i = 0; i < n; ++i) {
		for (ll x = v[i].x - r; x <= v[i].x + r; ++x) {
			for (ll y = v[i].y - r; y <= v[i].y + r; ++y) {
				if (x == v[i].x && y == v[i].y) continue;
				if (mp.find(make_pair(x, y)) != mp.end()) {
					P cur = mp[{x, y}];
					if (f(v[i], cur)) {
						g[i].push_back(cur.num);
						g[cur.num].push_back(i);
					}
				}
			}
		}
	}
	ll cnt = 0;
	vector<ll>col(n, 0);
	for (ll i = 0; i < n; ++i) {
		if (col[i] == 0) {
			col[i] = 1;
			comp[i] = cnt++;
			ok = false;
			dfs(g, i, col);
			comp_ok.push_back(ok);
		}
		if (comp_ok[comp[i]]) cout << 1;
		else cout << 0;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
