#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

const ll INF = 1e9;

struct P {
	ll x, y, num;
	P(ll x = 0, ll y = 0, ll num = -1) {
		this->x = x;
		this->y = y;
		this->num = num;
	}
};

bool f(P a, P b) {
	ll dist = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return dist <= r * r;
}


bool ok = false;
vector<ll>comp;
vector<bool>comp_ok;

void dfs(vector<P>& g, ll u, vector<ll>& col) {
	for (ll v = 0; v < g.size(); ++v) {
		if (!f(g[u], g[v])) continue;
		if (u == v) continue;
		if (col[v] == 0) {
			comp[v] = comp[u];
			col[v] = 3 - col[u];
			dfs(g, v, col);
		}
		if (col[v] == col[u]) {
			ok = true;
		}
	}
}

void solve() {
	ll n; cin >> n >> r;
	comp.assign(n, -1);
	comp_ok.clear();
	vector<P>v(n);
	for (ll i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		v[i] = P(x, y, i);
	}
	
	ll cnt = 0;
	vector<ll>col(n, 0);
	for (ll i = 0; i < n; ++i) {
		if (col[i] == 0) {
			col[i] = 1;
			comp[i] = cnt++;
			ok = false;
			dfs(v, i, col);
			comp_ok.push_back(ok);
		}
		if (comp_ok[comp[i]]) cout << 1;
		else cout << 0;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
