#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast,unroll-loops")

ll r;

const ll INF = 1e9;

struct P {
	ll x, y, num;
	P(ll x = 0, ll y = 0, ll num = -1) {
		this->x = x;
		this->y = y;
		this->num = num;
	}
};

bool f(P a, P b) {
	ll dist = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return dist <= r * r;
}


bool ok = false;
vector<ll>comp;
vector<bool>comp_ok;

void dfs(vector<vector<int>>& g, ll u, vector<short>& col) {
	for (auto v : g[u]) {
		if (col[v] == 0) {
			comp[v] = comp[u];
			col[v] = 3 - col[u];
			dfs(g, v, col);
		}
		if (col[v] == col[u]) {
			ok = true;
		}
	}
}

void solve() {
	ll n; cin >> n >> r;
	comp.assign(n, -1);
	comp_ok.clear();
	vector<P>v(n);
	unordered_map<ll, P>mp;
	for (ll i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		v[i] = P(x, y, i);
		mp[x * INF + y] = v[i];
	}
	vector<vector<int>>g(n);
	if (r * r < n) {
		for (ll i = 0; i < n; ++i) {
			for (ll x = v[i].x - r; x <= v[i].x + r; ++x) {
				for (ll y = v[i].y - r; y <= v[i].y + r; ++y) {
					if (x == v[i].x && y == v[i].y) continue;
					if (mp.find(x * INF + y) != mp.end()) {
						P cur = mp[x * INF + y];
						if (f(v[i], cur)) {
							g[i].push_back(cur.num);
							g[cur.num].push_back(i);
						}
					}
				}
			}
		}
	}
	else {
		for (ll i = 0; i < n; ++i) {
			for (ll j = i + 1; j < n; ++j) {
				if (f(v[i], v[j])) {
					g[i].push_back(j);
					g[j].push_back(i);
				}
			}
		}
	}
	ll cnt = 0;
	vector<short>col(n, 0);
	for (ll i = 0; i < n; ++i) {
		if (col[i] == 0) {
			col[i] = 1;
			comp[i] = cnt++;
			ok = false;
			dfs(g, i, col);
			comp_ok.push_back(ok);
		}
		if (comp_ok[comp[i]]) cout << 1;
		else cout << 0;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}