#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

const ll INF = 1e9;

struct P {
	ll x, y, num;
	P(ll x = 0, ll y = 0, ll num = -1) {
		this->x = x;
		this->y = y;
		this->num = num;
	}
};

bool f(P a, P b) {
	ll dist = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return dist <= r * r;
}


bool ok = false;
vector<ll>comp;
vector<bool>comp_ok;

void dfs(vector<vector<int>>& g, ll u, vector<short>& col) {
	for (auto v : g[u]) {
		if (col[v] == 0) {
			comp[v] = comp[u];
			col[v] = 3 - col[u];
			dfs(g, v, col);
		}
		if (col[v] == col[u]) {
			ok = true;
		}
	}
}

bool cmpx(const P& a, const P& b) {
	return a.x < b.x;
}
bool cmpy(const P& a, const P& b) {
	return a.y < b.y;
}

void solve() {
	ll n; cin >> n >> r;
	comp.assign(n, -1);
	comp_ok.clear();
	vector<P>v(n);
	map<ll, vector<P>>mpx, mpy;
	for (ll i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		v[i] = P(x, y, i);
		mpx[x].push_back(v[i]);
		mpy[y].push_back(v[i]);
	}

	for (auto& i : mpx) sort(all(i.second), cmpy);
	for (auto& i : mpy) sort(all(i.second), cmpx);
	
	vector<vector<int>>g(n);

	for (ll i = 0; i < n; ++i) {
		auto it = mpx.lower_bound(v[i].x - r);
		for (it; it != mpx.end() && it->first <= v[i].x + r; ++it) {
			ll _l = -1, _r = it->second.size() - 1;
			while (_r - _l > 1) {
				ll mid = (_l + _r) / 2;
				if (it->second[mid].y >= v[i].y - r) _r = mid;
				else _l = mid;
			}
			ll ind = _r;
			for (ind; ind < it->second.size() && it->second[ind].y <= v[i].y + r; ++ind) {
				if (v[i].num == it->second[ind].num) continue;
				if (f(v[i], it->second[ind])) {
					g[v[i].num].push_back(it->second[ind].num);
				}
			}
		}
	}

	ll cnt = 0;
	vector<short>col(n, 0);
	for (ll i = 0; i < n; ++i) {
		if (col[i] == 0) {
			col[i] = 1;
			comp[i] = cnt++;
			ok = false;
			dfs(g, i, col);
			comp_ok.push_back(ok);
		}
		if (comp_ok[comp[i]]) cout << 1;
		else cout << 0;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}