#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

const ll INF = 1e9;

struct P {
	ll x, y, num;
	P(ll x = 0, ll y = 0, ll num = -1) {
		this->x = x;
		this->y = y;
		this->num = num;
	}
};

bool f(P a, P b) {
	ll dist = (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
	return dist <= r * r;
}


vector<bool>ok;

void dfs(vector<vector<ll>>& g, ll u, vector<ll>& col) {
	if (ok[u]) return;
	for (auto v : g[u]) {
		if (col[v] == 0) {
			col[v] = 3 - col[u];
			dfs(g, v, col);
			if (ok[v]) {
				ok[u] = true;
				return;
			}
		}
		if (col[v] == col[u]) {
			ok[v] = ok[u] = true;
			return;
		}
	}
}

void solve() {
	ll n; cin >> n >> r;
	ok.assign(n, false);
	vector<P>v(n);
	unordered_map<ll, P>mp;
	for (ll i = 0; i < n; ++i) {
		ll x, y; cin >> x >> y;
		v[i] = P(x, y, i);
		mp[x * INF + y] = v[i];
	}
	vector<vector<ll>>g(n);
	for (ll i = 0; i < n; ++i) {
		for (ll j = i + 1; j < n; ++j) {
			if (f(v[i], v[j])) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	ll cnt = 0;
	vector<ll>col(n, 0);
	for (ll i = 0; i < n; ++i) {
		if (col[i] == 0) col[i] = 1;
		dfs(g, i, col);
		if (ok[i]) cout << 1;
		else cout << 0;
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
