#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll INF = 1e9;

ll inv(vector<ll>& a) {
	ll ans = 0;
	for (ll i = 0; i < a.size(); ++i) {
		for (ll j = i + 1; j < a.size(); ++j) {
			if (a[j] < a[i]) ans++;
		}
	}
	return ans;
}

void solve() {
	ll r, c; cin >> r >> c;
	vector<vector<ll>>v(r, vector<ll>(c));
	for (auto& i : v) for (auto& j : i) cin >> j;

	ll ans = INF;

	for (ll mask = 0; mask < (1 << (r + c)); ++mask) {
		ll rp = 0, cp = 0;
		ll rcnt = 0, ccnt = 0;
		for (ll i = 0; i < r + c; ++i) {
			if ((mask >> i) & 1) rcnt++;
			else ccnt++;
		}
		if (rcnt > r || ccnt > c) continue;
		vector<ll>b;
		for (ll i = 0; i < (r + c); ++i) {
			if ((mask >> i) & 1) {
				for (ll j = cp; j < c; ++j) b.push_back(v[rp][j]);
				rp++;
			}
			else {
				for (ll j = rp; j < r; ++j) b.push_back(v[j][cp]);
				cp++;
			}
		}
		ans = min(ans, inv(b));
	}
	cout << ans;

}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
