#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll INF = 1e9;


void solve() {
	ll r, c; cin >> r >> c;
	vector<vector<ll>>v(r, vector<ll>(c));
	for (auto& i : v) for (auto& j : i) cin >> j;
	
	vector<vector<ll>>dp(r, vector<ll>(c, 0));
	dp[r - 1][c - 1] = 0;
	for (ll i = r - 2; i >= 0; --i) {
		for (ll j = i + 1; j < r; ++j) {
			if (v[j][c - 1] < v[i][c - 1]) {
				dp[i][c - 1]++;
			}
		}
	}
	for (ll j = c - 2; j >= 0; --j) {
		for (ll i = j + 1; i < c; ++i) {
			if (v[r - 1][i] < v[r - 1][j]) {
				dp[r - 1][j]++;
			}
		}
	}
	for (ll i = r - 2; i >= 0; --i) {
		for (ll j = c - 2; j >= 0; --j) {
			ll v1 = dp[i + 1][j];
			for (ll j1 = j; j1 < c; ++j1) {
				for (ll x = i + 1; x < r; ++x) {
					for (ll y = j; y < c; ++y) {
						if (v[x][y] < v[i][j1]) v1++;
					}
				}
			}

			ll v2 = dp[i][j + 1];
			for (ll i1 = i; i1 < r; ++i1) {
				for (ll x = i; x < r; ++x) {
					for (ll y = j + 1; y < c; ++y) {
						if (v[x][y] < v[i1][j]) v2++;
					}
				}
			}

			dp[i][j] = min(v1, v2);

		}
	}
	cout << dp[0][0] * 2;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
