#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

const ll INF = 1e9;

mt19937 rng(84996);

ll inv(vector<ll>& a) {
	ll ans = 0;
	for (ll i = 0; i < a.size(); ++i) {
		for (ll j = i + 1; j < a.size(); ++j) {
			if (a[j] < a[i]) ans++;
		}
	}
	return ans;
}

ll stupid(vector<vector<ll>>& v) {
	ll r = v.size(), c = v[0].size();
	ll ans = INF;

	for (ll mask = 0; mask < (1 << (r + c)); ++mask) {
		ll rp = 0, cp = 0;
		ll rcnt = 0, ccnt = 0;
		for (ll i = 0; i < r + c; ++i) {
			if ((mask >> i) & 1) rcnt++;
			else ccnt++;
		}
		if (rcnt > r || ccnt > c) continue;
		vector<ll>b;
		for (ll i = 0; i < (r + c); ++i) {
			if ((mask >> i) & 1) {
				for (ll j = cp; j < c; ++j) b.push_back(v[rp][j]);
				rp++;
			}
			else {
				for (ll j = rp; j < r; ++j) b.push_back(v[j][cp]);
				cp++;
			}
		}
		ans = min(ans, inv(b));
	}
	return ans;
}

ll smart(vector<vector<ll>>& v) {
	ll r = v.size(), c = v[0].size();
	vector<vector<ll>>dp(r, vector<ll>(c, 0));
	
	for (ll i = r - 2; i >= 0; --i) {
		for (ll j = c - 2; j >= 0; --j) {


			ll v1 = dp[i + 1][j];

			for (ll j1 = j; j1 < c; ++j1) {
				for (ll x = i + 1; x < r; ++x) {
					for (ll y = j; y < j1; ++y) {
						if (v[x][y] < v[i][j1]) v1++;
					}
				}
			}


			ll v2 = dp[i][j + 1];

			for (ll i1 = i; i1 < r; ++i1) {
				for (ll x = i; x < i1; ++x) {
					for (ll y = j + 1; y < c; ++y) {
						if (v[x][y] < v[i1][j]) v2++;
					}
				}
			}

			dp[i][j] = min(v1, v2);

		}
	}

	return dp[0][0];
}

void solve() {
	/*ll n = 10, r = 5, c = 2;
	vector<ll>v;
	for (ll i = 0; i < n; ++i) v.push_back(i);
	while (true) {
		shuffle(all(v), rng);
		for (auto& i : v) cout << i << ' '; cout << '\n';
		vector<vector<ll>>g(r, vector<ll>(c));
		for (ll i = 0; i < r; ++i) {
			for (ll j = 0; j < c; ++j) {
				g[i][j] = v[i * c + j];
				cout << g[i][j] << ' ';
			}
			cout << '\n';
		}
		cout << '!';
		if (stupid(g) != smart(g)) {
			for (auto& i : g) {
				for (auto& j : i) cout << j << ' ';
				cout << '\n';
			}
			break;
		}
	}*/
	ll r, c; cin >> r >> c;
	vector<vector<ll>>v(r, vector<ll>(c));
	for (auto& i : v) for (auto& j : i) cin >> j;
	cout << smart(v);
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}
