#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

const ll INF = 1e9;

vector<ll>tree;

void upd(ll ind, ll u, ll l, ll r) {
	if (l == r) {
		tree[u]++;
		return;
	}
	ll m = (l + r) / 2;
	if (ind <= m) upd(ind, u * 2 + 1, l, m);
	else upd(ind, u * 2 + 2, m + 1, r);
	tree[u] = tree[u * 2 + 1] + tree[u * 2 + 2];
}

ll sum(ll lq, ll rq, ll u, ll l, ll r) {
	if (lq > rq) return 0;
	if (l == lq && r == rq) {
		return tree[u];
	}
	ll m = (l + r) / 2;
	if (rq <= m) return sum(lq, rq, u * 2 + 1, l, m);
	if (lq > m) return sum(lq, rq, u * 2 + 2, m + 1, r);
	return sum(lq, m, u * 2 + 1, l, m) + sum(m + 1, rq, u * 2 + 2, m + 1, r);
}

void solve() {
	ll r, c; cin >> r >> c;
	vector<ll>v(c);
	for (auto& i : v) cin >> i;
	tree.assign(4 * c, 0);
	ll ans = 0;
	for (auto& i : v) {
		i--;
		upd(i, 0, 0, c - 1);
		ans += sum(i + 1, c - 1, 0, 0, c - 1);
	}
	cout << ans;
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}