#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()

ll r;

const ll INF = 1e9;

vector<ll>tree;

void build(vector<ll>& v, ll u, ll l, ll r) {
	if (l == r) {
		tree[u] = v[l];
		return;
	}
	ll m = (l + r) / 2;
	build(v, u * 2 + 1, l, m);
	build(v, u * 2 + 2, m + 1, r);
	tree[u] = max(tree[u * 2 + 1], tree[u * 2 + 2]);
}

ll fnd(ll lq, ll rq, ll u, ll l, ll r) {
	if (lq > rq) return 0;
	if (lq == l && rq == r) {
		return tree[u];
	}
	ll m = (l + r) / 2;
	if (rq <= m) return fnd(lq, rq, u * 2 + 1, l, m);
	if (lq > m) return fnd(lq, rq, u * 2 + 2, m + 1, r);
	return max(fnd(lq, m, u * 2 + 1, l, m), fnd(m + 1, rq, u * 2 + 2, m + 1, r));
}


void solve() {
	ll n, q; cin >> n >> q;
	tree.resize(4 * n);
	vector<ll>v(n);
	for (auto& i : v) cin >> i;
	build(v, 0, 0, n - 1);
	ll bd = 0;
	while (bd < n && v[bd] <= v[0]) bd++;
	ll a = v[0];
	ll b = INF;
	ll c = INF;
	for (ll i = 1; i < n - 1; ++i) {
		if (i >= bd) {
			ll l = fnd(bd, i, 0, 0, n - 1);
			ll r = fnd(i + 1, n - 1, 0, 0, n - 1);
			if (l < b) {
				b = l;
				c = r;
			}
			else if (l == b) {
				c = min(c, r);
			}
		}
		else {
			ll l = v[i], r = fnd(i + 1, n - 1, 0, 0, n - 1);
			if (l < b) {
				b = l;
				c = r;
			}
			else if (l == b) {
				c = min(c, r);
			}
		}
	}
	while (q--) {
		ll k, i; cin >> k >> i;
		if (i == 1) cout << a;
		if (i == 2) cout << b;
		if (i == 3) cout << c;
		cout << '\n';
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	ll t = 1;
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	cin >> t;
#endif
	while (t--) {
		solve();
		cout << '\n';
	}
}