#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#include <map>
// #pragma GCC optimize("Ofast,unroll-loop")
#define int long long

using namespace std;

random_device rd;
mt19937 rnd(rd());

int r;
vector<int> ans, color, used1;
vector<vector<int>> g;
map<pair<int, int>, vector<int>> grid;

struct point {
    int x, y;
};

inline bool check(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}

inline int dfs(int v, int p = -1, int col = -1) {
    int res = 0;
    if (ans[v]) {
        return 1;
    }
    if (col == -1) {
        color[v] = 1;
    } else if (col == 1) {
        color[v] = 2;
    } else {
        color[v] = 1;
    }
    for (int u : g[v]) {
        if (!color[u]) {
            res |= dfs(u, v, color[v]);
        } else if (color[u] && u != p && color[u] == color[v]) {
            return 1;
        }
    }
    return res;
}

inline void dfs1(int v) {
    used1[v] = 1;
    ans[v] = 1;
    for (int u : g[v]) {
        if (!used1[u]) {
            dfs1(u);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n >> r;
    vector<point> points;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        points.emplace_back(x, y);
    }
    if (r == 1) {
        for (int i = 0; i < n; i++) {
            grid[{points[i].x / r, points[i].y / r}].push_back(i);
        }
        for (auto it : grid) {
            shuffle(grid[it.first].begin(), grid[it.first].end(), rnd);
        }
        ans.resize(n, 0);
        g.resize(n);
        for (int i = 0; i < n; i++) {
            if (g[i].size() >= 6) {
                ans[i] = 1;
            }
            for (int dx = -1; dx <= 1; dx++) {
                for (int dy = -1;dy <= 1; dy++) {
                    auto it = grid.find({points[i].x / r + dx, points[i].y / r + dy});
                    for (auto ind : (*it).second) {
                        if (ind > i && check(points[i], points[ind])) {
                            if (ans[i]) {
                                ans[ind] = 1;
                            } else {
                                g[i].push_back(ind);
                                g[ind].push_back(i);
                            }
                            if (g[i].size() >= 6) {
                                ans[i] = 1;
                            }
                        }
                    }
                }
            }
        }
        color.resize(n, 0);
        for (int i = 0; i < n; i++) {
            if (!ans[i] & !color[i]) {
                ans[i] = dfs(i);
            }
        }
        used1.resize(n, 0);
        for (int i = 0; i < n; i++) {
            if (color[i] && ans[i]) {
                dfs1(i);
            }
        }
        string s;
        for (int i = 0; i < n; i++) {
            if (ans[i]) {
                s.push_back('1');
            } else {
                s.push_back('0');
            }
        }
        cout << s << endl;
        return 0;
    }
    int new_r = (r + 1) / 2;
    for (int i = 0; i < n; i++) {
        grid[{points[i].x / new_r, points[i].y / new_r}].push_back(i);
    }
    ans.resize(n, 0);
    g.resize(n);
    for (auto it : grid) {
        if (it.second.size() >= 3) {
            for (auto ind : it.second) {
                ans[ind] = 1;
            }
        }
        shuffle(grid[it.first].begin(), grid[it.first].end(), rnd);
    }
    for (auto it : grid) {
        if (it.second.size() < 3) {
            for (auto ind : it.second) {
                if (g[ind].size() >= 6) {
                    ans[ind] = 1;
                }
                for (int dx = -2; dx <= 2; dx++) {
                    for (int dy = -2; dy <= 2; dy++) {
                        auto it1 = grid.find({points[ind].x / new_r + dx, points[ind].y / new_r + dy});
                        for (auto i : (*it1).second) {
                            if (i != ind && check(points[i], points[ind])) {
                                if (ans[ind]) {
                                    ans[i] = 1;
                                } else {
                                    g[i].push_back(ind);
                                }
                                if (g[ind].size() >= 6) {
                                    ans[ind] = 1;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    color.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (!ans[i] & !color[i]) {
            ans[i] = dfs(i);
        }
    }
    used1.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (color[i] && ans[i]) {
            dfs1(i);
        }
    }
    string s;
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            s.push_back('1');
        } else {
            s.push_back('0');
        }
    }
    cout << s << endl;
    return 0;
}