#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#define int long long

using namespace std;

random_device rd;
mt19937 rnd(rd());

int r;
vector<int> ans, color, used1;
vector<vector<int>> g;

struct point {
    int x, y;
};

bool check(point a, point b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) <= r * r;
}

int dfs(int v, int p = -1, int col = -1) {
    int res = 0;
    if (ans[v]) {
        return 1;
    }
    if (col == -1) {
        color[v] = 1;
    } else if (col == 1) {
        color[v] = 2;
    } else {
        color[v] = 1;
    }
    for (int u : g[v]) {
        if (!color[u]) {
            res |= dfs(u, v, color[v]);
        } else if (color[u] && u != p && color[u] == color[v]) {
            return 1;
        }
    }
    return res;
}

void dfs1(int v) {
    used1[v] = 1;
    ans[v] = 1;
    for (int u : g[v]) {
        if (!used1[u]) {
            dfs1(u);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n >> r;
    vector<point> points;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        points.emplace_back(x, y);
    }
    ans.resize(n, 0);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        if (g[i].size() >= 10) {
            ans[i] = 1;
        }
        for (int j = i + 1; j < n; j++) {
            if (check(points[i], points[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    color.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (!ans[i] & !color[i]) {
            ans[i] = dfs(i);
        }
    }
    used1.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (color[i] && ans[i]) {
            dfs1(i);
        }
    }
    string s;
    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            s.push_back('1');
        } else {
            s.push_back('0');
        }
    }
    cout << s << endl;
    return 0;
}