#include <iostream>
#include <vector>
#define int long long
#include <map>

using namespace std;

int n;
vector<int> tree;

int get(int v, int l, int r, int l1, int r1) {
    if (r <= l1 || r1 <=l) {
        return 0;
    }
    if (l1 <= l && r <= r1) {
        return tree[v];
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, l1, r1) + get(2 * v + 1, m, r, l1, r1);
}

void update(int v, int l, int r, int ind, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = (r + l) / 2;
    if (ind >= m) {
        update(2 * v + 1, m, r, ind, x);
    } else {
        update(2 * v, l, m, ind, x);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}


int invers(vector<int> a) {
    tree.clear();
    tree.resize(4 * n);
    int invs = 0;
    for (int i = n - 1; i >= 0; i--) {
        invs += get(1, 0, n, 0, a[i]);
        update(1, 0, n, a[i], 1);
    }
    return invs;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int r, c;
    cin >> r >> c;
    n = r * c;
    vector<vector<int>> table(r, vector<int>(c));
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            cin >> table[i][j];
        }
    }
    int minn = 1e10;
    int curr = 0, curc = 0;
    for (int i = 0; i < (1 << (r + c)); i++) {
        vector<int> aboba;
        for (int j = 0; j < r + c; j++) {
            if (curc == c || curr == r) {
                break;
            }
            if (((i >> j) & 1) == 0) {
                for (int x = curc; x < c; x++) {
                    aboba.push_back(table[curr][x]);
                }
                curr++;
            } else {
                for (int x = curr; x < r; x++) {
                    aboba.push_back(table[x][curc]);
                }
                curc++;
            }
        }
        minn = min(minn, invers(aboba));
    }
    cout << minn << endl;
    return 0;
}