#include <iostream>
#include <vector>
#include <map>

using namespace std;

struct query {
    int k, ind;
};

vector<pair<int, int>> tree;
vector<int> a;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = {a[l], l};
        return;
    }
    int m = (r + l) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    tree[v] = min(tree[2 * v], tree[2 * v + 1]);
}

pair<int, int> get(int v, int l, int r, int l1, int r1) {
    if (r <= l1 || r1 <= l) {
        return {1e7, 0};
    }
    if (l1 <= l && r <= r1) {
        return tree[v];
    }
    int m = (r + l) / 2;
    return min(get(2 * v, l, m, l1, r1), get(2 * v + 1, m, r, l1, r1));
}

int main() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    tree.resize(4 * n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build(1, 0, n);
    vector<int> nex(n);
    nex[n - 1] = n;
    vector<int> st;
    for (int i = n - 2; i >= 0; i--) {
        while (!st.empty() && a[st.back()] < a[i]) {
            st.pop_back();
        }
        if (st.empty()) {
            nex[i] = n;
        } else {
            nex[i] = st.back();
        }
        st.push_back(i);
    }
    vector<int> suf_max(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf_max[i] = max(suf_max[i + 1], a[i]);
    }
    vector<query> queries;
    while (q--) {
        int k, ind;
        cin >> k >> ind;
        queries.emplace_back(k, ind);
    }
    vector<vector<int>> big_table(n + 1);
    for (auto q1 : queries) {
        int i = q1.k;
        if (!big_table[i].empty()) {
            continue;
        }
        if (i == 1) {
            big_table[1].push_back(n);
            continue;
        }
        int l = 0;
        int cur_minn = 0;
        int cnt = 1;
        big_table[i].push_back(a[0]);
        while (true) {
            if (cnt == i - 1) {
                int minn = 1e6;
                if (l + 1 == nex[l]) {
                    big_table[i].push_back(suf_max[l + 1]);
                    break;
                }
                for (int x = l + 1; x < nex[l]; x++) {
                    minn = min(minn, suf_max[x]);
                }
                big_table[i].push_back(minn);
                break;
            }
            int bord = min(nex[i], n - i + cnt);
            auto minn = get(1, 0, n, l + 1, bord + 1);
            l = minn.second;
            cnt++;
        }
    }
    for (auto q1 : queries) {
        cout << big_table[q1.k][q1.ind - 1] << endl;
    }
    return 0;
}