#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
#define line cout << "\n"
#define sz(a) (int) a.size()
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
typedef long long ll;

const int MAXN = 3e5 + 10;
const int LOG = 19;

vector<vector<pii>> mi(MAXN, vector<pii>(LOG));
vector<vector<int>> ma(MAXN, vector<int>(LOG));


pii get_min(int l, int r) {
    int lg = log2(r - l + 1);
    return min(mi[l][lg], mi[r - (1 << lg) + 1][lg]);
}


int get_ma(int l, int r) {
    int lg = log2(r - l + 1);
    return max(ma[l][lg], ma[r - (1 << lg) + 1][lg]);
}

signed main() {
    fast;

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
 
 
 
    int n, q;
    cin >> n >> q;
    vector<int> suf_mi(n + 1);
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    for (int i = 0; i < n; i++) {
        mi[i][0] = {arr[i], i};
        ma[i][0] = arr[i];
    }
    for (int i = 1; i < LOG; i++) {
        for (int j = 0; j < n; j++) {
            if (j + (1 << i) < n) {
                mi[j][i] = min(mi[j][i - 1], mi[j + (1 << (i - 1))][i - 1]);
                ma[j][i] = max(ma[j][i - 1], ma[j + (1 << (i - 1))][i - 1]);
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        suf_mi[i] = max(suf_mi[i + 1], arr[i]);
    }
    vector<vector<int>> ans(n + 1);
    ans[1] = {suf_mi[0]};
    for (int k = 2; k <= n; k++) {
        int i = 0;
        int ost = k;
        while (ost > 2) {
            if (sz(ans[k]) > 3) {
                break;
            }
            ans[k].pb(arr[i]);
            int pos = i + 1;
            ost--;
            int tl = i, tr = n - ost + 1;
            while (tl + 1 < tr) {
                int mid = (tl + tr) / 2;
                if (get_ma(i, mid) == arr[i]) {
                    tl = mid;
                } else {
                    tr = mid;
                }
            }
            if (tl == i) {
                pos = i + 1;
            } else {
                pos = get_min(i, tl).second;
            }
            i = pos;
        }
        if (ost > 2) {
            continue;
        }
        pii res = {1e9, 1e9};
        int ma = 0;
        for (int j = i; j < n - 1; j++) {
            ma = max(ma, arr[j]);
            res = min(res, {ma, suf_mi[j + 1]});
        }
        ans[k].pb(res.first);
        ans[k].pb(res.second);
    }
    while (q--) {
        int k, i;
        cin >> k >> i;
        cout << ans[k][i - 1]; line;
    }
    return 0;
}