#include <bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
template<typename T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T> > &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const vector<pair<T1, T2> > &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

struct segment_tree {
    vector<ordered_set<int> > d;
    int n;

    segment_tree() = default;

    segment_tree(const vector<int> &a) {
        n = a.size();
        d.resize(4 * n);
        build(0, 0, n, a);
    }

    void build(int t, int tl, int tr, const vector<int> &a) {
        for (int i = tl; i < tr; i++)d[t].insert(a[i]);
        if (tl + 1 == tr)return;
        int tm = (tl + tr) / 2;
        build(2 * t + 1, tl, tm, a);
        build(2 * t + 2, tm, tr, a);
    }

    int get(int ql, int qr, int x) {
        return get(0, 0, n, ql, qr, x);
    }

    int get(int t, int tl, int tr, int ql, int qr, int x) {
        if (ql >= tr || qr <= tl)return 0;
        if (ql <= tl && tr <= qr) {
            return d[t].order_of_key(x);
        }
        int tm = (tl + tr) / 2;
        return get(2 * t + 1, tl, tm, ql, qr, x) + get(2 * t + 2, tm, tr, ql, qr, x);
    }
};


struct Test {
    int n, m;
    vector<vector<int> > a;
    vector<segment_tree> st;

    Test() {
        cin >> n >> m;
        a.resize(n, vector<int>(m, 0));
        cin >> a;
        st.resize(n);
        for (int i = 0; i < n; i++)st[i] = a[i];

        vector<vector<ll> > inv_r(n, vector<ll>(m + 1));
        vector<vector<ll>>inv_c(m,vector<ll>(n+1));
        for (int i = 0; i < n; i++) {
            ordered_set<int> s;
            for (int j = m - 1; j >= 0; j--) {
                inv_r[i][j]=inv_r[i][j+1]+s.order_of_key(a[i][j]);
                s.insert(a[i][j]);
            }
        }
        for (int j = 0; j < m; j++) {
            ordered_set<int> s;
            for (int i = n - 1; i >= 0; i--) {
                inv_c[j][i]=inv_c[j][i+1]+s.order_of_key(a[i][j]);
                s.insert(a[i][j]);
            }
        }
        vector<vector<ll> > dp(n + 1, vector<ll>(m + 1, 0));
        for (int c = m - 1; c >= 0; c--) {
            for (int r = n - 1; r >= 0; r--) {
                ll res1 = dp[r + 1][c]+inv_r[r][c];
                for (int j = c; j < m; j++) {
                    for (int i = r + 1; i < n; i++) {
                        res1 += st[i].get(c, m, a[r][j]);
                    }
                }
                ll res2 = dp[r][c + 1]+inv_c[c][r];
                for (int i = r; i < n; i++) {
                    for (int j = r; j < n; j++) {
                        int t= st[j].get(c+1, m, a[i][c]);
                        res2+=t;
                    }
                }
                dp[r][c] = min(res1, res2);
            }
        }
        cout << dp[0][0];
    }
};


signed main() {
#ifdef Local
    freopen(".in", "r",stdin);
    freopen(".out", "w",stdout);
    auto start = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--) {
        Test();
    }
#ifdef Local
    cerr << setprecision(5) << 1e3 * (clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
}
