#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T> > &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const vector<pair<T1, T2> > &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

namespace Min {
    struct Data {
        int v;
        int ind;

        Data(const vector<int> &a, int ind): Data(a[ind], ind) {
        }

        Data(int v = {}, int ind = {}): v(v), ind(ind) {
        }

        Data operator +(const Data &other) const {
            if (v < other.v)return *this;
            return other;
        }
    };

    struct SparseTable {
        vector<vector<Data> > up;
        int n;
        int k;
        vector<int> lg;

        Data get(int l, int r) const {
            int t = lg[r - l];
            Data res = up[t][l] + up[t][r - (1 << t)];
            return res;
        }

        SparseTable() = default;

        explicit SparseTable(const vector<int> &a): n(a.size()) {
            lg.resize(n + 1);
            int now = 1;
            int res = 0;
            for (int i = 0; i <= n; i++) {
                if (now * 2 == i) {
                    now *= 2;
                    res++;
                }
                lg[i] = res;
            }
            k = lg[n] + 1;
            up.resize(k, vector<Data>(n));
            for (int i = 0; i < n; i++) {
                up[0][i] = Data(a[i], i);
            }
            for (int x = 0; x < k - 1; x++) {
                for (int i = 0; i < n; i++) {
                    if (i + (1 << x) < n)up[x + 1][i] = up[x][i] + up[x][(1 << x) + i];
                    else up[x + 1][i] = up[x][i];
                }
            }
        }
    };
}

namespace Max {
    struct Data {
        int v;
        int ind;

        Data(const vector<int> &a, int ind): Data(a[ind], ind) {
        }

        Data(int v = {}, int ind = {}): v(v), ind(ind) {
        }

        Data operator +(const Data &other) const {
            if (v > other.v)return *this;
            return other;
        }
    };

    struct SparseTable {
        vector<vector<Data> > up;
        int n;
        int k;
        vector<int> lg;

        Data get(int l, int r) const {
            int t = lg[r - l];
            Data res = up[t][l] + up[t][r - (1 << t)];
            return res;
        }

        SparseTable() = default;

        explicit SparseTable(const vector<int> &a): n(a.size()) {
            lg.resize(n + 1);
            int now = 1;
            int res = 0;
            for (int i = 0; i <= n; i++) {
                if (now * 2 == i) {
                    now *= 2;
                    res++;
                }
                lg[i] = res;
            }
            k = lg[n] + 1;
            up.resize(k, vector<Data>(n));
            for (int i = 0; i < n; i++) {
                up[0][i] = Data(a[i], i);
            }
            for (int x = 0; x < k - 1; x++) {
                for (int i = 0; i < n; i++) {
                    if (i + (1 << x) < n)up[x + 1][i] = up[x][i] + up[x][(1 << x) + i];
                    else up[x + 1][i] = up[x][i];
                }
            }
        }
    };
}

struct Test {
    int n, q;
    vector<int> a;
    vector<pair<int, int> > queries;
    vector<int> next;
    Min::SparseTable st;
    Max::SparseTable mx_st;
    unordered_map<int, vector<int> > mp;

    int get(int k, int now) {
        int r = min(n - k + 1, next[now]) + 1;
        now++;
        if (k != 2) {
            return st.get(now, r).ind;
        }
        return r - 1;
    }

    int ans(int k, int ind) {
        if (mp.find(k)==mp.end())ans2(k);
        return mp[k][ind-1];
    }

    void ans2(int k) {
        int now = 0;
        mp[k].reserve(k);
        int k2 = k;
        while (k > 1) {
            mp[k2].push_back(a[now]);
            now = get(k, now);
            k--;
        }
        mp[k2].push_back(mx_st.get(now, n).v);
    }

    Test() {
        cin >> n >> q;
        a.resize(n);
        cin >> a;
        queries.resize(q);
        cin >> queries;
        a.push_back(n + 1);
        next.resize(n);
        stack<int> mx;
        mx.push(n);
        for (int i = n - 1; i >= 0; i--) {
            while (a[mx.top()] < a[i]) {
                mx.pop();
            }
            next[i] = mx.top();
            mx.push(i);
        }
        a.pop_back();
        st = Min::SparseTable(a);
        mx_st = Max::SparseTable(a);
        for (auto [k,ind]: queries) {
            cout << ans(k, ind) << '\n';
        }
    }
};


signed main() {
#ifdef Local
    freopen(".in", "r",stdin);
    freopen(".out", "w",stdout);
    auto start = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--) {
        Test();
    }
#ifdef Local
    cerr << setprecision(5) << 1e3 * (clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
}
