#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define len(v) (int)((v).size())

typedef long long ll;

vector<vector<int>> g;
vector<int> h;
vector<int> ans;

bool dfs(int v, int hv) {
	h[v] = hv;
	for (int u : g[v]) {
		if (h[u] == -1) {
			if (dfs(u, hv + 1)) return true;
		}
		else {
			if ((h[u] - h[v]) % 2 == 0) {
				return true;
			}
		}
	}
	return false;
}

void fill(int v, int vl) {
	ans[v] = vl;
	for (int u : g[v]) {
		if (ans[u] == -1) fill(u, vl);
	}
}

int main(){
	int n, r;
	cin >> n >> r;

	int r2 = r / 2;
	
	map<pair<int, int>, set<int>> b;
	
	vector<pair<int, int>> a(n), ar(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
		ar[i].first = a[i].first / r2;
		ar[i].second = a[i].second / r2;
		b[ar[i]].insert(i);
	}

	auto check = [&](int i, int j) {
		return (i != j) && (a[i].first - a[j].first) * 1ll * (a[i].first - a[j].first) +
			(a[i].second - a[j].second) * 1ll * (a[i].second - a[j].second) <= r * 1ll * r;
	};

	
	queue<int> upd;
	for (pair<pair<int, int>, set<int>> c : b) {
		if (len(c.second) >= 3) {
			for (int i : c.second) {
				upd.push(i);
			}
			b.erase(c.first);
		}
	}
	
	g.resize(n);
	h.resize(n, -1);
	ans.resize(n, -1);

	for (int i = 0; i < n; ++i) {
		for (int di = -2; di <= 2; ++di) {
			for (int dj = -2; dj <= 2; ++dj) {
				if (b.find({ di + ar[i].first, dj + ar[i].second }) != b.end()) {
					for (int j : b[{ di + ar[i].first, dj + ar[i].second }]) {
						if (check(i, j)) {
							g[i].push_back(j);
						}
					}
				}
			}
		}
	}

	while (!upd.empty()) {
		int v = upd.front();
		upd.pop();
		fill(v, 1);
	}

	for (int i = 0; i < n; ++i) {
		if (ans[i] == -1) {
			bool res = dfs(i, 0);
			fill(i, res);
		}
	}

	for (int i = 0; i < n; ++i) {
		cout << (int)ans[i];
	}
	cout << '\n';
}
