#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <random>

using namespace std;

#define len(v) (int)((v).size())

typedef long long ll;


const int SZ = 1 << 20;

int af[SZ];
int bf[SZ];

int merge(int l, int m, int r) {
	int i = l, j = m;
	int res = 0;
	while (i < m && j < r) {
		if (af[i] < af[j]) {
			bf[i + j - m] = af[i];
			++i;
		}
		else {
			res += (int)(m - i);
			bf[i + j - m] = af[j];
			++j;
		}
	}
	while (i < m) {
		bf[i + j - m] = af[i];
		++i;
	}
	while (j < r) {
		bf[i + j - m] = af[j];
		++j;
	}
	for (int k = l; k < r; ++k) {
		af[k] = bf[k];
	}
	return res;
}

int merge_sort(int l, int r) {
	if (r - l == 1) {
		return 0;
	}

	int m = (l + r) / 2;
	int res = 0;
	res += merge_sort(l, m);
	res += merge_sort(m, r);
	res += merge(l, m, r);
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}

	vector<vector<int>> dp(n, vector<int>(m, n * 1ll * m * n * m));
	dp[n - 1][m - 1] = 0;

	vector<vector<vector<int>>> dd(n, vector<vector<int>>(m));

	for (int i = n - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			for (int j2 = j; j2 < m; ++j2) {
				dd[i][j].push_back(a[i][j2]);
			}
			sort(dd[i][j].begin(), dd[i][j].end());
		}
	}

	vector<vector<vector<int>>> ee(n, vector<vector<int>>(m));
	
	for (int j = m - 1; j >= 0; --j) {
		for (int i = n - 1; i >= 0; --i) {
			for (int i2 = i; i2 < n; ++i2) {
				ee[i][j].push_back(a[i2][j]);
			}
			sort(ee[i][j].begin(), ee[i][j].end());
		}
	}

	for (int i = n - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			if (i > 0) {
				int cr = 0;
				int cf = 0;
				for (int j2 = j; j2 < m; ++j2) {
					af[cr++] = a[i - 1][j2];
					for (int i2 = i; i2 < n; ++i2) {
						cf += lower_bound(dd[i2][j].begin(), dd[i2][j].end(), a[i - 1][j2]) - dd[i2][j].begin();
					}
				}
				cf += merge_sort(0, cr);

				dp[i - 1][j] = min(dp[i - 1][j], cf + dp[i][j]);
			}
			if (j > 0) {
				int cr = 0;
				int cf = 0;
				for (int i2 = i; i2 < n; ++i2) {
					af[cr++] = a[i2][j - 1];
					for (int j2 = j; j2 < m; ++j2) {
						cf += lower_bound(ee[i][j2].begin(), ee[i][j2].end(), a[i2][j - 1]) - ee[i][j2].begin();
					}
				}
				cf += merge_sort(0, cr);

				dp[i][j - 1] = min(dp[i][j - 1], cf + dp[i][j]);
			}
		}
	}

	cout << dp[0][0] << '\n';
}
