#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define len(v) (int)((v).size())

typedef long long ll;

const int sz = 1 << 20;

int af[sz];
int bf[sz];

ll merge(int l, int m, int r) {
	int i = l, j = m;
	ll res = 0;
	while (i < m && j < r) {
		if (af[i] < af[j]) {
			bf[i + j - m] = af[i];
			++i;
		}
		else {
			res += (ll)(m - i);
			bf[i + j - m] = af[j];
			++j;
		}
	}
	while (i < m) {
		bf[i + j - m] = af[i];
		++i;
	}
	while (j < r) {
		bf[i + j - m] = af[j];
		++j;
	}
	for (int k = l; k < r; ++k) {
		af[k] = bf[k];
	}
	return res;
}

ll merge_sort(int l, int r) {
	if (r - l == 1) {
		return 0;
	}

	int m = (l + r) / 2;
	ll res = 0;
	res += merge_sort(l, m);
	res += merge_sort(m, r);
	res += merge(l, m, r);
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	for (int i = 0; i < sz; ++i) {
		af[i] = bf[i] = 0;
	}


	int n, m;
	cin >> n >> m;

	vector<vector<int>> a(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a[i][j];
		}
	}

	vector<vector<ll>> dp(n, vector<ll>(m, n * 1ll * m * n * m));
	dp[n - 1][m - 1] = 0;

	for (int i = n - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			if (i > 0) {
				int cr = 0;
				for (int j2 = j; j2 < m; ++j2) {
					af[cr++] = a[i - 1][j2];
				}
				int cl = cr;
				for (int i2 = i; i2 < n; ++i2) {
					for (int j2 = j; j2 < m; ++j2) {
						af[cr++] = a[i2][j2];
					}
				}
				merge_sort(cl, cr);
				dp[i - 1][j] = min(dp[i - 1][j], merge_sort(0, cr) + dp[i][j]);
			}
			if (j > 0) {
				int cr = 0;
				for (int i2 = i; i2 < n; ++i2) {
					af[cr++] = a[i2][j - 1];
				}
				int cl = cr;
				for (int i2 = i; i2 < n; ++i2) {
					for (int j2 = j; j2 < m; ++j2) {
						af[cr++] = a[i2][j2];
					}
				}
				merge_sort(cl, cr);
				dp[i][j - 1] = min(dp[i][j - 1], merge_sort(0, cr) + dp[i][j]);
			}
		}
	}

	cout << dp[0][0] << '\n';
}
