#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

#define len(v) (int)((v).size())

typedef long long ll;

const int LGN = 19;
const int N = 1 << LGN;

pair<int, int> dp[LGN][N];
int lg[N];

pair<int, int> get(int l, int r) {
	int lgn = lg[(r - l + 1)];
	return min(dp[lgn][l], dp[lgn][r - (1 << lgn) + 1]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, q;
	cin >> n >> q;

	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	lg[0] = -1;
	for (int i = 0; i < n; ++i) {
		dp[0][i] = { a[i], i };
	}
	for (int i = 1; i < n; ++i) {
		lg[i] = lg[i / 2] + 1;
	}
	for (int j = 1; j < LGN; ++j) {
		for (int i = 0; i < n; ++i) {
			dp[j][i] = min(dp[j - 1][i], dp[j - 1][(i + (1 << (j - 1))) % n]);
		}
	}

	stack<int> st;
	vector<int> rb(n, n);
	for (int i = n - 1; i >= 0; --i) {
		while (!st.empty() && a[st.top()] < a[i]) st.pop();
		if (!st.empty()) rb[i] = st.top();
		st.push(i);
	}

	vector<int> suf(n + 1, 0);
	for (int i = n - 1; i >= 0; --i) {
		suf[i] = max(suf[i + 1], a[i]);
	}
	map<int, vector<int>> ans;

	
	for (int i = 0; i < q; ++i) {
		int k, ind;
		cin >> k >> ind;

		if (ans.find(k) == ans.end()) {
			int i = 0;
			ans[k].resize(k + 1);
			for (int mv = 1; mv < k; ++mv) {
				if (k - mv == n - i - 1 || a[i + 1] > a[i]) {
					ans[k][mv] = a[i];
					i = i + 1;
				}
				else {
					pair<int, int> res = get(i, min(min(rb[i], n - (k - mv)), n - 1));
					ans[k][mv] = a[i];
					i = max(res.second, i + 1);
				}
			}
			ans[k][k] = suf[i];
		}

		cout << ans[k][ind] << '\n';
	}
}
