#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

#define len(v) (int)((v).size())

typedef long long ll;

const int LGN = 19;
const int N = 1 << LGN;

pair<int, int> dp[LGN][N];
int lg[N];

pair<int, int> get(int l, int r) {
	int lgn = lg[(r - l + 1)];
	return min(dp[lgn][l], dp[lgn][r - (1 << lgn) + 1]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, q;
	cin >> n >> q;

	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	lg[0] = -1;
	for (int i = 0; i < n; ++i) {
		dp[0][i] = { a[i], i };
	}
	for (int i = 1; i < n; ++i) {
		lg[i] = lg[i / 2] + 1;
	}
	for (int j = 1; j < LGN; ++j) {
		for (int i = 0; i < n; ++i) {
			dp[j][i] = min(dp[j - 1][i], dp[j - 1][i + (1 << (j - 1))]);
		}
	}

	stack<int> st;
	vector<int> rb(n, n);
	for (int i = n - 1; i >= 0; --i) {
		while (!st.empty() && a[st.top()] < a[i]) st.pop();
		if (!st.empty()) rb[i] = st.top();
		st.push(i);
	}

	vector<vector<int>> ans(n, vector<int>(n));
	for (int k = 1; k <= n; ++k) {
		int i = 0;

		for (int mv = 1; mv < k; ++mv) {
			pair<int, int> res = get(i, min(rb[i] - 1, n - (k - mv) - 1));
			ans[k - 1][mv - 1] = a[i];
			i = res.second + 1;
		}
		for (int j = i; j < n; ++j) {
			ans[k - 1][k - 1] = max(ans[k - 1][k - 1], a[j]);
		}
	}
	
	for (int i = 0; i < q; ++i) {
		int k, ind;
		cin >> k >> ind;

		cout << ans[k - 1][ind - 1] << '\n';
	}
}
