#include <bits/stdc++.h>

using namespace std;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
    }
}

const int INF = 1e9;

int n, m;

struct SegTree {
    int n;
    vector<int> t;

    SegTree(int n) {
        this->n = n;
        this->t.resize(4 * n);
    }

    void change(int v, int tl, int tr, int ind) {
        if (tr - tl == 1) {
            t[v]++;
            return;
        }
        int tm = (tl + tr) / 2;
        if (ind < tm) {
            change(v * 2, tl, tm, ind);
        } else {
            change(v * 2 + 1, tm, tr, ind);
        }
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    int get_sm(int v, int tl, int tr, int l, int r) {
        if (r <= tl || tr <= l) {
            return 0;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        return get_sm(v * 2, tl, tm, l, r) + get_sm(v * 2 + 1, tm, tr, l, r);
    }
};

void solve() {
    cin >> n >> m;
    vector<vector<int> > arr(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> arr[i][j];
            arr[i][j]--;
        }
    }
    int k = n * m;
    vector<vector<int> > dp(n + 1, vector<int>(m + 1, INF));
    vector<vector<SegTree> > d(n + 1, vector<SegTree>(m + 1, (k)));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i < 0 || i >= n || j < 0 || j >= m) {
                continue;
            }
            int sm1 = INF, sm2 = INF;
            if (i != n) {
                sm1 = dp[i][j];
                d[i + 1][j] = d[i][j];
                for (int t = j; t < m; t++) {
                    sm1 += d[i + 1][j].get_sm(1, 0, k, arr[i][t], k);
                    d[i + 1][j].change(1, 0, k, arr[i][t]);
                }
                dp[i + 1][j] = min(dp[i + 1][j], sm1);
            }
            if (j != m) {
                sm2 = dp[i][j];
                d[i][j + 1] = d[i][j];
                for (int t = i; t < n; t++) {
                    sm2 += d[i][j + 1].get_sm(1, 0, k, arr[t][j], k);
                    d[i][j + 1].change(1, 0, k, arr[t][j]);
                }
                dp[i][j + 1] = min(dp[i][j + 1], sm2);
            }
        }
    }
    int ans = INF;
    for (int i = 0; i <= n; i++) {
        ans = min(ans, dp[i][m]);
    }
    for (int j = 0; j <= m; j++) {
        ans = min(ans, dp[n][j]);
    }
    cout << ans;
}
