#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
    }
}

const int INF = 1e18;

struct segtree {
    int n;
    vector<int> t;

    segtree(int n) {
        this->n = n;
        this->t.resize(4 * n, -INF);
    }

    void build(int v, int tl, int tr, vector<int> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int get_mx(int v, int tl, int tr, int l, int r) {
        if (r <= tl || tr <= l) {
            return -INF;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        return max(get_mx(v * 2, tl, tm, l, r), get_mx(v * 2 + 1, tm, tr, l, r));
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> arr(n);

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    segtree tree(n);
    tree.build(1, 0, n, arr);
    vector<int> ans = {INF, INF, INF};
    int mx = -INF;
    int l = 1, r = 2;
    for (int i = 0; i < n - 2; i++) {
        mx = max(mx, arr[i]);
        l = max(l, i + 1);
        r = max(r, l + 1);
        while (r + 1 < n) {
            if (arr[r] <= arr[l]) {
                r++;
            } else {
                break;
            }
        }
        int mx1 = tree.get_mx(1, 0, n, l, r), mx2 = tree.get_mx(1, 0, n, r, n);
        vector<int> ans1 = {mx, mx1, mx2};
        ans = min(ans, ans1);
    }

    while (q--) {
        int k, ind;
        cin >> k >> ind;
        ind--;
        if (k == 3) {
            cout << ans[ind] << "\n";
        }
    }
}
