#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

const int maxn = 100005;

pair<int,int> segTree[maxn];
set<int> el[maxn];

void build(int l,int r,int indV)
{
    if(l == r)
    {
        segTree[indV] = {0,l};
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1);
    build(m+1,r,indV*2+2);
    segTree[indV] = {0,r};
}

void modify(int i,int x,int l,int r,int indV)
{
    if(l > i || r < i)
    {
        return ;
    }
    else if(l == r)
    {
        segTree[indV] = {x,l};
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1);
    modify(i,x,m+1,r,indV*2+2);
    segTree[indV] = max(segTree[indV*2+1],segTree[indV*2+2]);
    return ;
}
pair<int,int> get(int lx,int rx,int l,int r,int indV)
{
    if(l > rx || r < lx)
    {
        return {0,-1};
    }
    else if(l >= lx && r <= rx)
    {
        return segTree[indV];
    }
    int m = (l+r)/2;
    pair<int,int> sl = get(lx,rx,l,m,indV*2+1);
    pair<int,int> sr = get(lx,rx,m+1,r,indV*2+2);
    return max(sl,sr);
}
void add(int x,int y,int n)
{
    el[y].insert(x);
    int u = *(--el[y].end());
    modify(y,u,0ll,n-1,0ll);
}
void del(int x,int y,int n)
{
    el[y].erase(x);
    int u = (el[y].size() == 0 ? 0 : *(--el[y].end()));
    modify(y,u,0ll,n-1,0ll);
}

vector<int> g[maxn];
int vis[maxn];
int col[maxn];
bool good[maxn];
vector<int> comp;
map<pair<int,int>,int> ff;
bool yes = 0;

void dfs(int v,int c)
{
    //cout << v << ' ' << c << endl;
    col[v] = c;
    vis[v] = 1;
    if(good[v])
    {
       // cout << "!" << endl;
        yes = 1;
    }
    comp.push_back(v);
    for(auto u:g[v])
    {
        if(!vis[u])
        {
            dfs(u,c ^ 1);
        }
        else if(c == col[u])
        {   
            //cout << u << ' ' << v << endl;
            yes = 1;
        }
    }
    return ;
}

struct ev
{
    ev(bool _type,int _x,int _i){type = _type;x = _x;i = _i;};
    ev(){};
    bool type;
    int x;
    int i;
    bool operator < (const ev & oth){return (x != oth.x ? x < oth.x : type < oth.type);};
};

int get_seg(int xr,int yr,int r,int xp,int yp)
{
    if(ll(xr-xp)*(xr-xp) + ll(yr-yp)*(yr-yp) <= ll(r)*r)
    {
        return 0;
    }
    else if(xp >= xr && yp >= yr)
    {
        if(xr-yr >= xp-yp)
        {
            return 1;
        }
        else
            return 2;
    }
    else if(xp >= xr && yp < yr)
    {
        if(xr+yr >= xp+yp)
        {
            return 3;
        }
        else
            return 4;
    }
    else if(xp < xr && yp >= yr)
    {
        if(xr+yr >= xp+yp)
        {
            return 5;
        }
        else
            return 6;
    }
    else
    {
        if(xr-yr >= xp-yp)
        {
            return 7;
        }
        else
            return 8;
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,r;
    cin >> n >> r;
    vector<pair<int,int>> yy;
    int x[n],y[n];
    for(int i = 0;i < n;++i)
    {
        cin >> x[i] >> y[i];
        x[i]++;
        yy.push_back({y[i],i});
        ff[{x[i],y[i]}] = i;
    }
    vector<ev> sc;
    sort(yy.begin(),yy.end());
    for(int i = 0;i < n;++i)
    {
        y[yy[i].second] = i;
    }
    for(int i = 0;i < n;++i)
    {
        sc.push_back(ev(0,x[i],i));
        sc.push_back(ev(1,x[i] + r,i));
    }
    sort(sc.begin(),sc.end());
    for(int q = 0;q < sc.size();++q)
    {
        int i = sc[q].i;
        if(sc[q].type == 0)
        {
            add(x[i],y[i],n);
        }
        else
        {
            vector<vector<pair<int,int>>> seg(9);
            int c_in = 0;
            int oy = yy[y[i]].first;
            int yl = lower_bound(yy.begin(),yy.end(),make_pair(oy-r,0ll))-yy.begin();
            int yr = lower_bound(yy.begin(),yy.end(),make_pair(oy+r,n+1))-yy.begin()-1;
            while(true)
            {
               // cout << "!" << endl;
                pair<int,int> ct = get(yl,yr,0,n-1,0);
             //   cout << ct.first << ' ' << ct.second << endl;
                if(ct.first < max(1ll,x[i]-r))
                {
                    break;
                }
                else
                {
                    int xp = ct.first;
                    int yp = yy[ct.second].first;
                    del(ct.first,ct.second,n);
                    int tseg = get_seg(x[i],oy,r,xp,yp);
                    if(tseg == 0)
                    {
                        c_in++;
                        if(c_in == 7)
                        {
                          //  cout << "!" << endl;
                            good[i] = true;
                            break;
                        }
                    }
                    seg[tseg].push_back({xp,ct.second});
                }
            }
            for(int j = 0;j < seg.size();++j)
            {
                if(seg[j].size() >= 3 && j != 0)
                {
                    //cout << i << ' ' << j << "!" << endl;
                    for(int l = 0;l < seg[j].size();++l)
                    {
                       // cout << seg[j][l].first << ' ' << yy[seg[j][l].second].first << endl; 
                        good[ff[{seg[j][l].first,yy[seg[j][l].second].first}]] = 1;
                    }
                }
                else
                {
                    for(int l = 0;l < seg[j].size();++l)
                    {
                        add(seg[j][l].first,seg[j][l].second,n);
                    }
                    if(j == 0)
                    {
                        for(int l = 0;l < seg[j].size();++l)
                        {
                            int ind = ff[{seg[j][l].first,yy[seg[j][l].second].first}];
                          //  cout << i << ' ' << ind << ' ' << endl;
                            if(i != ind)
                            {
                                g[i].push_back(ind);
                                g[ind].push_back(i);

                            }
                        }
                    }
                }
            }
        }
    }
    vector<bool> ans(n,0);
    for(int j = 0;j < n;++j)
    {
        if(!vis[j])
        {
            comp.clear();
            yes = 0;
            dfs(j,0);
           // cout << yes << endl;
            if(yes)
            {
                for(auto c:comp)
                {
                    ans[c] = 1;
                }
            }
        }
    }
    for(int i = 0;i < ans.size();++i)
    {
        cout << ans[i];
    }
    return 0;
}