#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
}

#define ints __int16
#define endl '\n'
const int N = 1e4 + 10, MOD = 1e9 + 7, INF = 2e9;

struct seg_tree {
    int t[4*N];
    void update(int v,int l,int r,int pos,int val) {
        if (l==r) {
            t[v]+=val;
            return;
        }
        int m=(l+r)/2;
        if (pos<=m) {
            update(v*2,l,m,pos,val);
        }else {
            update(v*2+1,m+1,r,pos,val);
        }
        t[v]=t[v*2]+t[v*2+1];
    }
    int get(int v,int l,int r,int tl,int tr) {
        if (l>=tl && r<=tr){
            return t[v];
        }
        if (l>tr || r<tl) {
            return 0;
        }
        int m=(l+r)/2;
        int lv=get(v*2,l,m,tl,tr);
        int rv=get(v*2+1,m+1,r,tl,tr);
        return lv+rv;
    }
};

seg_tree t;

int inv(vector<int> &b,int br) {
    int n=b.size(),ans=0;
    for (int i=0;i<n;i++) {
        t.update(1,0,br,b[i],1);
        ans+=t.get(1,0,br,b[i]+1,br);
    }
    for (int i=0;i<n;i++) {
        t.update(1,0,br,b[i],-1);
    }
    return ans;
}


void solve() {
    int n,m;
    cin>>n>>m;
    vector<vector<int>> a(n+1,vector<int>(m+1,0));
    vector<vector<vector<ints>>> val(n+1,vector<vector<ints>>(m+1,vector<ints>(n*m+2,0)));
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) {
            cin>>a[i][j];
        }
    }
    for (int i=0;i<=n;i++) {
        for (int j=0;j<=m;j++) {
            for (int ki=1;ki<=i;ki++) {
                for (int kj=1;kj<=m;kj++) {
                    val[i][j][a[ki][kj]]=1;
                }
            }
            for (int kj=1;kj<=j;kj++) {
                for (int ki=1;ki<=n;ki++) {
                    val[i][j][a[ki][kj]]=1;
                }
            }
            for (int k=n*m;k>=0;k--) {
                val[i][j][k]+=val[i][j][k+1];
            }
        }
    }

    vector<vector<int>> dp(n+1,vector<int>(m+1,INF));
    dp[0][0]=0;
    int br=n*m+1;
    for (int i=1;i<=n;i++) {
        dp[i][0]=dp[i-1][0];
        int sum=0;
        for (int j=1;j<=m;j++) {
            sum+=val[i-1][0][a[i][j]];
        }
        dp[i][0]+=sum;
        dp[i][0]+=inv(a[i],br);
    }
    for (int j=1;j<=m;j++) {
        dp[0][j]=dp[0][j-1];
        int sum=0;
        vector<int> b;
        for (int i=1;i<=n;i++) {
            sum+=val[0][j-1][a[i][j]];
            b.push_back(a[i][j]);
        }
        dp[0][j]+=sum;
        dp[0][j]+=inv(b,br);
    }

    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) {
            int f=dp[i-1][j];
            int sum=0;
            vector<int> b;
            for (int k=j+1;k<=m;k++) {
                sum+=val[i-1][j][a[i][k]];
                b.push_back(a[i][k]);
            }
            f+=sum;
            f+=inv(b,br);
            int s=dp[i][j-1];
            sum=0;
            b.clear();
            for (int k=i+1;k<=n;k++) {
                sum+=val[i][j-1][a[k][j]];
                b.push_back(a[k][j]);
            }
            s+=sum;
            s+=inv(b,br);
            dp[i][j]=min(f,s);
        }
    }
    int ans=INF;
    for (int i=0;i<n;i++) {
        ans=min(ans,dp[i][m]);
    }
    for (int j=0;j<m;j++) {
        ans=min(ans,dp[n][j]);
    }
    cout<<ans<<endl;
}
