#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
 
using namespace std;
 
#define int long long
 
const int INF = 1e18 + 123;
 
int n, r, a;
map <pair <int, int>, vector <int>> m;
vector <pair <int, int>> p;
vector <int> color;
vector <int> ans;
 
void dfs(int v, int col=1, bool f=false)
{
    if (f) ans[v] = 1;
    color[v] = col;
    auto [x, y] = p[v];
 
    if (!ans[v])
    {
        for (int i=max(x/a-2, 0LL); i<=(x/a+2); i++)
        {
            for (int j=max(y/a-2, 0LL); j<=(y/a+2); j++)
            {
                if (m.count({i, j}))
                {
                    if (ans[v] && m[{i, j}].size() >= 3) continue;
                    for (auto ind : m[{i, j}])
                    {
                        if (v == ind) continue;
                        auto [x0, y0] = p[ind];
                        if ((x-x0)*(x-x0)+(y-y0)*(y-y0) <= r*r)
                        {
                            if (m[{i, j}].size() >= 3)
                            {
                                ans[v] = 1;
                                break;
                            }
                            if (!color[ind] && !ans[ind])
                            {
                                dfs(ind, 3-col, ans[v]);
                                if (ans[ind]) ans[v] = 1;
                            }
                            else if (ans[ind]) ans[v] = 1;
                            else if (color[ind] == col) ans[v] = 1;
                        }
                    }
                }
            }
        }
    }

    if (!ans[v]) return;

    for (int i=max(x/a-2, 0LL); i<=(x/a+2); i++)
    {
        for (int j=max(y/a-2, 0LL); j<=(y/a+2); j++)
        {
            if (m.count({i, j}))
            {
                if (m.size() >= 3) continue;
                for (auto ind : m[{i, j}])
                {
                    if (v == ind) continue;
                    auto [x0, y0] = p[ind];
                    if (color[ind] < 4 && (x-x0)*(x-x0)+(y-y0)*(y-y0) <= r*r)
                    {
                        dfs(ind, 4, ans[v]);
                    }
                }
            }
        }
    }
 
    return;
}
 
void solve()
{
    cin >> n >> r;
    a = max((int)floor((double)r/(sqrt(2))), 1LL);

    p.clear();
    m.clear();
    int x, y;
    vector <int> v;
    for (int i=0; i<n; i++)
    {
        cin >> x >> y;
        p.push_back({x, y});
        if (!m.count({x/a, y/a})) m[{x/a, y/a}] = v;
        m[{x/a, y/a}].push_back(i);
    }
    color.assign(n, 0);
    ans.assign(n, 0);
 
    for (auto [sq, points] : m)
    {
        if (points.size() >= 3)
        {
            for (auto i : points) ans[i] = 1;
        }
    }
 
    for (auto [sq, points] : m)
    {
        if (points.size() < 3)
        {
            for (auto i : points)
            {
                if (!color[i]) dfs(i);
            }
        }
    }
 
    for (auto i : ans) cout << i;
 
    return;
}
 
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
 
    int t = 1;
 
    // cin >> t;
 
    for (int i=0; i<t; i++)
    {
        solve();
        cout << endl;
    }
 
    return 0;
}