#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

vector <vector <int>> a;
vector <int> tree;

void upd(int i, int l, int r, int d, int u, int x, int y)
{
    if (x < l || x >= r || y < d || y >= u) return;
    tree[i]++;
    if (r - l == 1 && u - d == 1) return;
    int mid1 = (l + r) / 2;
    int mid2 = (d + u) / 2;
    upd(i*4+1, l, mid1, d, mid2, x, y);
    upd(i*4+2, mid1, r, d, mid2, x, y);
    upd(i*4+3, l, mid1, mid2, u, x, y);
    upd(i*4+4, mid1, r, mid2, u, x, y);
    return;
}

int get(int i, int l, int r, int d, int u, int ql, int qr, int qd, int qu)
{
    if (qr <= l || ql >= r || qu <= d || qd >= u) return 0;
    if (ql <= l && qr >= r && qd <= d && qu >= u) return tree[i];
    int mid1 = (l + r) / 2;
    int mid2 = (d + u) / 2;
    int aa = get(i*4+1, l, mid1, d, mid2, ql, qr, qd, qu);
    int bb = get(i*4+2, mid1, r, d, mid2, ql, qr, qd, qu);
    int cc = get(i*4+3, l, mid1, mid2, u, ql, qr, qd, qu);
    int dd = get(i*4+4, mid1, r, mid2, u, ql, qr, qd, qu);
    return aa+bb+cc+dd;
}

void solve()
{
    int r, c;
    cin >> r >> c;

    a.assign(r, vector <int> (c));
    tree.assign(4*r*c, 0);

    vector <pair <int, int>> pos(r*c);
    vector <vector <int>> cbi(r, vector <int> (c)), crci(r, vector <int> (c)), ccri(r, vector <int> (c));
    vector <vector <int>> cri(r, vector <int> (c)), cci(r, vector <int> (c));
    vector <vector <int>> cic(r, vector <int> (c)), cir(r, vector <int> (c));

    for (int i=0; i<r; i++)
    {
        for (int j=0; j<c; j++)
        {
            cin >> a[i][j]; a[i][j]--;
            pos[a[i][j]] = {i, j};
        }
    }

    for (int ind=0; ind<r*c; ind++)
    {
        auto [i, j] = pos[ind];
        cbi[i][j] = get(0, 0, r, 0, c, i, r, j, c);
        for (int l=i-1; l>=0; l--)
        {
            crci[l][j] += c-j-1-get(0, 0, r, 0, c, l, l+1, j+1, c);
            cci[l][j] += get(0, 0, r, 0, c, l, r, j+1, c);
        }
        for (int l=j-1; l>=0; l--)
        {
            cri[i][l] += get(0, 0, r, 0, c, i+1, r, l, c);
        }
        cri[i][j] += get(0, 0, r, 0, c, i+1, r, j, c);
        cci[i][j] += get(0, 0, r, 0, c, i, r, j+1, c);
        upd(0, 0, r, 0, c, i, j);
    }
    
    for (int i=r-1; i>=0; i--)
    {
        for (int j=c-1; j>=0; j--)
        {
            ccri[i][j] = (r-i-1)*(c-j-1) - crci[i][j];
        }
    }

    // for (auto i : cbi)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    // for (auto i : crci)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    // for (auto i : ccri)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    // for (auto i : cci)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    // for (auto i : cri)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    for (int i=r-1; i>=0; i--)
    {
        for (int j=c-1; j>=0; j--)
        {
            if (i == r-1 || j == c-1)
            {
                int x = cbi[i][j];
                if (i < r-1) x += cbi[i+1][j];
                if (j < c-1) x += cbi[i][j+1];
                cic[i][j] = x;
                cir[i][j] = x;
            }
            else
            {
                cic[i][j] = min(cic[i][j+1], cir[i][j+1]) + cci[i+1][j] + ccri[i][j] + cbi[i][j];
                cir[i][j] = min(cic[i+1][j], cir[i+1][j]) + cri[i][j+1] + crci[i][j] + cbi[i][j]; 
            }
        }
    }

    // for (auto i : cic)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    // for (auto i : cir)
    // {
    //     for (auto j : i) cerr << j << ' ';
    //     cerr << endl;
    // }

    cout << min(cic[0][0], cir[0][0]);

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;

    // cin >> t;

    for (int i=0; i<t; i++)
    {
        solve();
    }

    return 0;
}